+
/**
 * 
 * CanvasXpress 36.2 - JavaScript Canvas Library
 * 
 * Copyright (c) 2009-2021 - license@canvasxpress.org
 * 
 * Redistributions of the source code must retain this copyright
 * notice and the following disclaimer.
 *  
 * CanvasXpress is released as open source for personal and
 * educational use with dual licensing for comercial purposes.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * Please see a copy of the GNU General Public License at
 * http://www.gnu.org/licenses.
 * 
 * Commercial use may be granted to the extent that this source
 * code does NOT become part of any other Open Source or
 * Commercially licensed development library or toolkit without
 * explicit permission from CanvasXpress.
 * 
 */
/**
 * 
 * canvas.text.js
 * @projectDescription An cross-browser implementation of the HTML5 <canvas> text methods 
 * @author Fabien M�nager 
 * @version $Revision: 1.4 $ 
 * @license MIT License <http://www.opensource.org/licenses/mit-license.php> 
 * 
 * Known issues: 
 * - The 'light' font weight is not supported, neither is the 'oblique' font style. 
 * - Optimize the different hacks (for Opera9) 
 * 
 ****
 *
 * ngraph
 * 
 * The MIT License (MIT)
 *
 * Copyright (c) 2014-2019 Andrei Kashcha
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 ****
 * 
 * sprintf() for JavaScript v.0.4
 *
 * Copyright (c) 2007 Alexandru Marasteanu <http://alexei.417.ro/>
 * Thanks to David Baird (unit test and patch).
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 *
 ***
 * 
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 *
 ****
 *
 * canvas_wrapper.js
 * Canvas doesn't support getCoords() which I really need....
 * So I made a wrapper, code mostly taken from excanvas.js by Google - http://code.google.com/p/explorercanvas/
 * alias some functions to make (compiled) code shorter
 *
 ****
 *
 * conrec.js
 * Copyright (c) 2010, Jason Davies.
 *
 * All rights reserved.  This code is based on Bradley White's Java version,
 * which is in turn based on Nicholas Yue's C++ version, which in turn is based
 * on Paul D. Bourke's original Fortran version.  See below for the respective
 * copyright notices.
 *
 * See http://paulbourke.net/papers/conrec for the original
 * paper by Paul D. Bourke.
 *
 * The vector conversion code is based on http://apptree.net/conrec.htm by
 * Graham Cox.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the <organization> nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ****
 *
 * conrec.js
 * Copyright (c) 1996-1997 Nicholas Yue
 *
 * This software is copyrighted by Nicholas Yue. This code is based on Paul D.
 * Bourke's CONREC.F routine.
 *
 * The authors hereby grant permission to use, copy, and distribute this
 * software and its documentation for any purpose, provided that existing
 * copyright notices are retained in all copies and that this notice is
 * included verbatim in any distributions. Additionally, the authors grant
 * permission to modify this software and its documentation for any purpose,
 * provided that such modifications are not distributed without the explicit
 * consent of the authors and that existing copyright notices are retained in
 * all copies. Some of the algorithms implemented by this software are
 * patented, observe all applicable patent law.
 *
 * IN NO EVENT SHALL THE AUTHORS OR DISTRIBUTORS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF,
 * EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE IS
 * PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE NO
 * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS.
 * 
 **** 
 *
 * jLouvain.js
 * Author: Corneliu S. (github.com/upphiminn)
 * This is a javascript implementation of the Louvain
 * community detection algorithm (http://arxiv.org/abs/0803.0476)
 * Based on https://bitbucket.org/taynaud/python-louvain/overview
 * 
 ****
 * 
 * science.js
 * Copyright (c) 2011, Jason Davies
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 *
 * The name Jason Davies may not be used to endorse or promote products
 * derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL JASON DAVIES BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 ****
 *
 * Apache-Style Software License for ColorBrewer software and ColorBrewer Color
 * Schemes
 * 
 * Copyright (c) 2002 Cynthia Brewer, Mark Harrower, and The Pennsylvania State
 * University.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions as source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 * 
 * 2. The end-user documentation included with the redistribution, if any, must
 * include the following acknowledgment: "This product includes color
 * specifications and designs developed by Cynthia Brewer
 * (http://colorbrewer.org/)." Alternately, this acknowledgment may appear in the
 * software itself, if and wherever such third-party acknowledgments normally
 * appear.
 * 
 * 4. The name "ColorBrewer" must not be used to endorse or promote products
 * derived from this software without prior written permission. For written
 * permission, please contact Cynthia Brewer at cbrewer@psu.edu.
 * 
 * 5. Products derived from this software may not be called "ColorBrewer", nor
 * may "ColorBrewer" appear in their name, without prior written permission of
 * Cynthia Brewer.
 *
 ****
 * 
 * FileSaver.js
 * Copyright © 2015 [Eli Grey][1].
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is furnished
 * to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 **** 
 * 
 * canvas-toBlob.js
 * Copyright © 2011 Eli Grey and Devin Samarin.
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is furnished
 * to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 ****
 *
 * Blob.js
 * Copyright © 2014 Eli Grey.
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is furnished
 * to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 ****
 *
 * jstat.js
 * Copyright (c) 2013 jStat
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 ****
 *
 * numeric.js
 * Numeric Javascript
 * Copyright (C) 2011 by Sébastien Loisel
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 ****
 *
 * Sankey.js
 * Copyright (c) 2012, Michael Bostock
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * * The name Michael Bostock may not be used to endorse or promote products
 *   derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL MICHAEL BOSTOCK BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ****
 *
 * canvas2svg
 * The MIT License (MIT)
 *
 * Copyright (c) 2014 Gliffy Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
+(function(b, a) {
    if (typeof exports === "object" && typeof module !== "undefined") {
        a(exports)
    } else {
        if (typeof define === "function" && define.amd) {
            define(["exports"], a)
        } else {
            (a((b.CanvasXpress = b.CanvasXpress || {})))
        }
    }
}(this, (function(b) {
    var c, a;
    if (this) {
        c = this.window;
        a = this.document
    }
    CanvasXpress = function(j, f, e, o, d, k, g, n, m, i) {
        var h = this;
        var l = function() {
            h.init(j, f, e, o, d, k, g, n, m, i)
        };
        if ((e && e.fonts) || (j && j.config && j.config.fonts)) {
            if (e && e.fonts) {
                CanvasXpress.loadFonts(e.fonts, l)
            } else {
                CanvasXpress.loadFonts(j.config.fonts, l)
            }
        } else {
            if ((e && e.fontsExternal) || (j && j.config && j.config.fontsExternal)) {
                if (e && e.fontsExternal) {
                    CanvasXpress.loadFontsExternal(e.fontsExternal, l)
                } else {
                    CanvasXpress.loadFontsExternal(j.config.fontsExternal, l)
                }
            } else {
                this.init(j, f, e, o, d, k, g, n, m, i)
            }
        }
    }
})));
CanvasXpress.instances = [];
CanvasXpress.config = [];
CanvasXpress.transitions = {};
CanvasXpress.cacheImages = {};
CanvasXpress.cacheImagesReady = false;
CanvasXpress.cachePatterns = {};
CanvasXpress.cacheText = {};
CanvasXpress.fonts = {
    Arial: true,
    Courier: true,
    Verdana: true
};
CanvasXpress.loadFonts = function(d, c) {
    if (d && d.length) {
        var b = false;
        for (var a = 0; a < d.length; a++) {
            if (!CanvasXpress.fonts.hasOwnProperty(d[a])) {
                b = true;
                break
            }
        }
        WebFontConfig = {
            google: {
                families: d
            },
            timeout: 2000
        };
        if (c) {
            WebFontConfig.active = c
        }(function(h) {
            if (window.navigator.onLine && b) {
                var e = h.createElement("script");
                var g = h.scripts[0];
                e.src = "https://ajax.googleapis.com/ajax/libs/webfont/1.6.26/webfont.js";
                e.async = true;
                g.parentNode.insertBefore(e, g);
                for (var f = 0; f < d.length; f++) {
                    CanvasXpress.fonts[d[f]] = true
                }
            } else {
                c()
            }
        })(document)
    }
};
CanvasXpress.loadFontsExternal = function(c, b) {
    if (c && c.length) {
        var a = false;
        if (!CanvasXpress.fonts.hasOwnProperty(c[0].name)) {
            a = true
        }(function(f) {
            if (window.navigator.onLine && a) {
                var e = new XMLHttpRequest();
                e.addEventListener("readystatechange", function(g) {
                    if (e.readyState == 2 && e.status == 200) {} else {
                        if (e.readyState == 3) {} else {
                            if (e.readyState == 4) {
                                var d = new FontFace(c[0].name, e.response);
                                document.fonts.add(d);
                                CanvasXpress.fonts[c[0].name] = true;
                                b()
                            }
                        }
                    }
                });
                e.responseType = "arraybuffer";
                e.open("get", c[0].url);
                e.send()
            } else {
                b()
            }
        })(document)
    }
};
CanvasXpress.selector = {
    vars: {},
    smps: {},
    meta: {},
    comp: {},
    nodes: {},
    edges: {},
    mixed: {},
    selections: 0,
    graphType: false
};
CanvasXpress.stack = {};
CanvasXpress.current = false;
CanvasXpress.chain = {};
CanvasXpress.resizing = false;
CanvasXpress.registered = "C87F08D7818236136543148783BB44E";
CanvasXpress.system = {};
CanvasXpress.ready = false;
CanvasXpress.factory = {
    version: 36.2,
    buildDate: "09-23-2021",
    client: "",
    siteSrc: false,
    valid: undefined,
    href: window.location.href
};
CanvasXpress.factory.services = "https://www.canvasxpress.org/cgi-bin/services.pl";
CanvasXpress.onReady = function() {
    var f = [];
    var a = false;
    var d = false;
    var c = function() {
        if (!a) {
            console.log("canvasXpress JS ready");
            a = true;
            for (var g = 0; g < f.length; g++) {
                f[g].fn.call(window, f[g].ctx)
            }
            f = [];
            CanvasXpress.system.isHTMLWidgets = typeof HTMLWidgets != "undefined";
            CanvasXpress.system.isShiny = typeof window.Shiny !== "undefined" && !!window.Shiny.outputBindings;
            CanvasXpress.system.isRViewer = /\bviewer_pane=1\b/.test(window.location);
            CanvasXpress.system.isRConsole = CanvasXpress.system.isHTMLWidgets && !CanvasXpress.system.isShiny && !CanvasXpress.system.isRViewer;
            CanvasXpress.system.isjQuery = typeof $ === "function";
            CanvasXpress.system.isReveal = typeof Reveal != "undefined";
            CanvasXpress.system.isZoom = typeof zoom != "undefined";
            CanvasXpress.factory.valid = typeof window.cX == "string" ? window.cX : undefined
        }
    };
    var b = function() {
        if (window.document.readyState === "complete") {
            c()
        }
    };
    var e = function() {
        c()
    };
    window.onReady = function(h, g) {
        if (a) {
            setTimeout(function() {
                h(g)
            }, 1);
            return
        } else {
            f.push({
                fn: h,
                ctx: g
            })
        }
        if (window.document.readyState === "complete") {
            setTimeout(c, 1)
        } else {
            if (!d) {
                if (window.document.addEventListener) {
                    window.document.addEventListener("DOMContentLoaded", c, false);
                    window.addEventListener("load", e, false)
                } else {
                    window.document.attachEvent("onreadystatechange", b);
                    window.attachEvent("onload", e)
                }
                d = true
            }
        }
    };
    return true
}();
CanvasXpress.loadScripts = function() {
    var i = 0;
    return function(files, callback, scope) {
        var head = window.document.getElementsByTagName("head")[0];
        var loadScript = function(s, c) {
            var t = s.type;
            if (t.match(/javascript/i)) {
                s.onreadystatechange = function() {
                    if (s.readyState === "loaded" || s.readyState === "complete") {
                        s.onreadystatechange = null;
                        c()
                    }
                };
                s.onload = function() {
                    c()
                };
                head.appendChild(s)
            } else {
                head.appendChild(s);
                c()
            }
        };
        var count = function() {
            if (i === files.length) {
                i = 0;
                if (callback) {
                    if (typeof(callback) == "function") {
                        callback.call(scope)
                    } else {
                        if (typeof(callback) == "string") {
                            eval("var fn = " + callback);
                            fn()
                        }
                    }
                }
            } else {
                CanvasXpress.loadScripts(files, callback, scope)
            }
        };
        i++;
        loadScript(files[i - 1], count)
    }
}();
CanvasXpress.transferDatasetAttributes = function(e, a, f) {
    var d = JSON.parse(JSON.stringify(e.dataset));
    for (var c in d) {
        if (d.hasOwnProperty(c)) {
            if (f) {
                a[c.replace(/^data-/, "")] = d[c]
            } else {
                var b = "data-" + c.replace(/([a-zA-Z])(?=[A-Z])/g, "$1-").toLowerCase();
                a.setAttribute(b, d[c])
            }
        }
    }
};
CanvasXpress.initCanvas = function() {
    var e = window.document.getElementsByTagName("canvas");
    for (var d = 0; d < e.length; d++) {
        var g = e[d];
        if (g.className == "CanvasXpress" && g.id) {
            var f = false;
            var a = {};
            var b = CanvasXpress.getObject(g.id);
            if (g.hasAttribute("data-src") && !b) {
                f = g.getAttribute("data-src");
                CanvasXpress.transferDatasetAttributes(g, a, true);
                if (Object.keys(a).length) {
                    new CanvasXpress(g.id, f, a)
                } else {
                    new CanvasXpress(g.id, f)
                }
            }
        }
    }
};
CanvasXpress.initImage = function() {
    var a = window.document.getElementsByTagName("img");
    for (var c = 0; c < a.length; c++) {
        var g = a[c];
        if (g.className == "CanvasXpress" && g.id) {
            var f = CanvasXpress.getObject(g.id);
            var d = g.parentNode;
            if (!f) {
                var e = g.src;
                var h = g.id;
                var b = window.document.createElement("canvas");
                b.width = g.clientWidth;
                b.height = g.clientHeight;
                CanvasXpress.transferDatasetAttributes(g, b);
                d.removeChild(g);
                b.id = h;
                d.appendChild(b);
                new CanvasXpress(h, e)
            }
        }
    }
};
CanvasXpress.initTable = function() {
    var c = window.document.getElementsByTagName("table");
    for (var b = 0; b < c.length; b++) {
        var e = c[b];
        if (e.className == "CanvasXpress" && e.id) {
            var g = CanvasXpress.getObject(e.id);
            var d = e.parentNode;
            if (!g) {
                var f = e.id;
                var a = window.document.createElement("canvas");
                a.id = "temp-table-id-" + e.id;
                a.width = e.hasAttribute("data-width") ? e.getAttribute("data-width") : 500;
                a.height = e.hasAttribute("data-height") ? e.getAttribute("data-height") : 500;
                CanvasXpress.transferDatasetAttributes(e, a);
                d.appendChild(a);
                new CanvasXpress({
                    data: f,
                    renderTo: f
                })
            }
        }
    }
};
CanvasXpress.getObject = function(f, b) {
    if (f) {
        while (CanvasXpress.chain.hasOwnProperty(f)) {
            f = CanvasXpress.chain[f]
        }
        for (var a = 0; a < CanvasXpress.instances.length; a++) {
            if (CanvasXpress.instances[a].target == f) {
                return CanvasXpress.instances[a]
            }
        }
    } else {
        if (b) {
            var d = window.document.getElementById(f);
            if (!d) {
                var e = window.document.createElement("canvas");
                e.id = f;
                e.width = 100;
                e.height = 100;
                window.document.body.appendChild(e);
                d = new CanvasXpress({
                    renderTo: f,
                    hidden: true
                })
            }
            return d
        } else {
            if (CanvasXpress.instances.length) {
                return CanvasXpress.instances[0]
            }
        }
    }
};
CanvasXpress.json = function(b, c) {
    var a = new FileReader();
    a.onload = function() {
        try {
            c(JSON.parse(a.result))
        } catch (d) {
            alert("Oooops! Not a valid callback")
        }
    };
    a.readAsText(b)
};
CanvasXpress.csv = function(b, c) {
    var a = new FileReader();
    a.onload = function() {
        try {
            var o = JSON.parse(a.result);
            var d = /\r\n|\r|\n/g;
            var h = o.split(d);
            var j = 0;
            var n = 0;
            if (o.match(/,/g)) {
                j = o.match(/,/g).length
            }
            if (o.match(/\t/g)) {
                n = o.match(/\t/g).length
            }
            var g = j > n ? "," : "\t";
            for (var k = 0; k < h.length; k++) {
                if (h[k].match(/^#/)) {
                    h.splice(k, 1);
                    k--;
                    continue
                }
                var l = h[k].split(g);
                for (var p = l.length - 1; p >= 0; p--) {
                    if (l[p].replace(/"\s+$/, '"').charAt(l[p].length - 1) == '"') {
                        var q = l[p].replace(/^\s+"/, '"');
                        if (q.length > 1 && q.charAt(0) == '"') {
                            l[p] = l[p].replace(/^\s*"|"\s*$/g, "").replace(/""/g, '"')
                        } else {
                            if (p) {
                                l.splice(p - 1, 2, [l[p - 1], l[p]].join(g))
                            } else {
                                l = l.shift().split(g).concat(l)
                            }
                        }
                    } else {
                        l[p].replace(/""/g, '"')
                    }
                }
                if (l.length == 1 && l[0] == "") {
                    h.splice(k, 1);
                    k--;
                    continue
                }
                h[k] = l
            }
            c(h)
        } catch (m) {
            alert("Oooops! Not a valid callback")
        }
    };
    a.readAsText(b)
};
CanvasXpress.$ = function(b, a) {
    return CanvasXpress.getObject(b, a)
};
CanvasXpress.destroy = function(b, a) {
    if (CanvasXpress.instances.length > 0) {
        CanvasXpress.instances[0].destroy(b, a)
    }
};
CanvasXpress.prototype.init = function(f, c, b, j, a, g, d, i, h, e) {
    if (!f) {
        return
    } else {
        if (typeof(f) == "object" && f.renderTo) {
            c = f.tracks ? {
                tracks: f.tracks
            } : f.nodes ? {
                nodes: f.nodes
            } : f.venn ? {
                venn: f.venn
            } : f.data ? f.data : false;
            b = f.config || false;
            if (f.version) {
                b.createVersion = f.version
            }
            if (f.factory) {
                b.createFactory = f.factory
            }
            j = f.events || false;
            a = f.info ? f.info.replace(/'/g, "'").replace(/"/g, "'") : false;
            g = f.afterRender || false;
            d = f.hidden || false;
            i = f.callback || false;
            h = f.uploadFile || false;
            e = f.noValidate ? f.noValidate : b && b.noValidate ? b.noValidate : false;
            f = f.renderTo
        }
    }
    this.setInit = function() {
        this.target = f;
        this.events = j;
        this.info = a;
        this.userId = 1;
        this.url = {};
        this.meta = {
            ids: {},
            time: {
                start: new Date().getTime(),
                elapsed: null,
                end: null,
                draw: [],
                render: []
            },
            data: false,
            canvas: {},
            config: {
                user: b,
                orig: {},
                vals: {},
                remote: false
            },
            vals: {},
            render: {
                objects: [],
                groups: {},
                types: {},
                order: [],
                map: {},
                origin: [],
                transition: false
            },
            events: {},
            state: {
                save: 0,
                clip: false,
                translate: [0, 0],
                rotate: [0],
                scale: [1, 1],
                last: {
                    translate: [0, 0],
                    rotate: [0],
                    scale: [1, 1]
                }
            },
            stack: [],
            def: {},
            dom: {}
        }
    };
    this.validateParameters = function() {
        this.validateData();
        this.validateConfig();
        this.validateEvents();
        this.validateInfo();
        this.validateAfterRender()
    };
    this.validateData = function() {
        this.dataURL = false;
        this.dataString = false;
        if (typeof(c) == "string") {
            var m = window.document.getElementById(c);
            if (m && m.tagName.toLowerCase() == "table" && m.className == "CanvasXpress" && m.id) {
                var n = c;
                c = this.parseHTMLTable(m, true);
                b = c.config;
                c = c.data;
                m.parentNode.removeChild(m);
                var k = window.document.getElementById("temp-table-id-" + n);
                if (k) {
                    k.id = n
                } else {
                    alert("Dude! What did you do?")
                }
            } else {
                var m = this.isValidString(c);
                switch (m.type) {
                    case "URL":
                        this.dataURL = c;
                        c = false;
                        break;
                    case "XML":
                        this.dataString = m.data;
                        c = false;
                        break;
                    case "JSON":
                        c = m.data;
                        break;
                    case "DELIM":
                        c = m.data.data;
                        if (!b) {
                            b = m.data.config
                        }
                        break;
                    default:
                        alert("Not a valid data string\n");
                        break
                }
            }
        } else {
            if (typeof(c) == "function") {
                try {
                    c = c.call(this)
                } catch (l) {
                    alert("Not a valid Data object:\n" + l)
                }
            } else {
                if (!e) {
                    try {
                        this.stringifyJSON(c)
                    } catch (l) {
                        alert("Data object malformed:\n" + l)
                    }
                }
            }
        }
    };
    this.validateConfig = function() {
        if (b) {
            if (typeof(b) == "function") {
                try {
                    b = b.call(this)
                } catch (l) {
                    alert("Not a valid Data object:\n" + l)
                }
            } else {
                if (!e) {
                    try {
                        this.stringifyJSON(b)
                    } catch (l) {
                        alert("Config object malformed:\n" + l)
                    }
                }
            }
            this.topoJSONURL = false;
            if (b.topoJSON && typeof(b.topoJSON) == "string") {
                var k = this.isValidString(b.topoJSON);
                switch (k.type) {
                    case "URL":
                        this.topoJSONURL = b.topoJSON;
                        break
                }
            }
        }
    };
    this.validateEvents = function() {};
    this.validateInfo = function() {
        if (!a) {
            a = ""
        }
    };
    this.validateAfterRender = function() {
        if (g) {
            try {
                this.stringifyJSON(g)
            } catch (k) {
                alert("AfterRender object malformed:\n" + k)
            }
        }
    };
    this.isOneTimeFunctionInConfig = function(k) {
        if (!k) {
            k = this
        }
        if (k.transposeData) {
            return true
        }
        if (k.transformData) {
            return true
        }
        if (k.asSampleFactors && k.asSampleFactors.length) {
            return true
        }
        if (k.asVariableFactors && k.asVariableFactors.length) {
            return true
        }
        if (k.stringSampleFactors && k.stringSampleFactors.length) {
            return true
        }
        if (k.stringVariableFactors && k.stringVariableFactors.length) {
            return true
        }
        if (k.histogramData) {
            return true
        }
        if (k.ridgeBy) {
            return true
        }
        if (k.sortData && k.sortData.length) {
            return true
        }
        return false
    };
    this.getAfterRender = function(k) {
        var m = [];
        if (k.histogramData || k.ridgeBy) {
            if (k.histogramData === true && k.colorBy) {
                m.unshift(["createHistogram", [], {}])
            } else {
                m.unshift(["createHistogram", [k.ridgeBy || k.histogramData || k.colorBy], {}])
            }
        }
        if (k.stringVariableFactors && k.stringVariableFactors.length) {
            for (var l = 0; l < k.stringVariableFactors.length; l++) {
                m.unshift(["switchNumericToString", [k.stringVariableFactors[l]], {}])
            }
        }
        if (k.stringSampleFactors && k.stringSampleFactors.length) {
            for (var l = 0; l < k.stringSampleFactors.length; l++) {
                m.unshift(["switchNumericToString", [k.stringSampleFactors[l], true], {}])
            }
        }
        if (k.asVariableFactors && k.asVariableFactors.length) {
            for (var l = 0; l < k.asVariableFactors.length; l++) {
                m.unshift(["switchVarToAnnotation", [k.asVariableFactors[l]], {}])
            }
        }
        if (k.asSampleFactors && k.asSampleFactors.length) {
            for (var l = 0; l < k.asSampleFactors.length; l++) {
                m.unshift(["switchSmpToAnnotation", [k.asSampleFactors[l]], {}])
            }
        }
        if (k.transposeData) {
            m.unshift(["transpose", [false, true], {}])
        }
        if (k.transformData) {
            m.unshift(["transform", [k.transformData, k.transformAxis, false, true], {}])
        }
        if (k.sortData && k.sortData.length) {
            for (var l = 0; l < k.sortData.length; l++) {
                m.push(["modifySort", [k.sortData[l][0], k.sortData[l][1], k.sortData[l][2], false, l == this.sortData.length - 1 ? true : false], {}])
            }
        }
        return m
    };
    this.afterRender = function(y) {
        if (!y) {
            y = []
        }
        var C = this.meta.time.start;
        var z = this.graphType == "Scatter2D" && this.scatterType == "visium";
        if (this.histogramData || this.ridgeBy) {
            if (this.histogramData === true) {
                y.push(["createHistogram", [], {}, C, true])
            } else {
                y.push(["createHistogram", [this.ridgeBy || this.histogramData], {}, C, true])
            }
            this.histogramData = false;
            delete(CanvasXpress.stack[this.target].config.histogramData)
        }
        if (this.stringVariableFactors.length) {
            for (var p = 0; p < this.stringVariableFactors.length; p++) {
                y.unshift(["switchNumericToString", [this.stringVariableFactors[p], false], {}, C, true])
            }
            this.stringVariableFactors = [];
            this.layoutRestore = false
        }
        if (this.stringSampleFactors.length) {
            for (var p = 0; p < this.stringSampleFactors.length; p++) {
                y.unshift(["switchNumericToString", [this.stringSampleFactors[p], true], {}, C, true])
            }
            this.stringSampleFactors = [];
            this.layoutRestore = false
        }
        if (this.asVariableFactors.length) {
            for (var p = 0; p < this.asVariableFactors.length; p++) {
                y.unshift(["switchVarToAnnotation", [this.asVariableFactors[p], false], {}, C, true])
            }
            this.asVariableFactors = [];
            this.layoutRestore = false
        }
        if (this.asSampleFactors.length) {
            for (var p = 0; p < this.asSampleFactors.length; p++) {
                y.unshift(["switchSmpToAnnotation", [this.asSampleFactors[p], false], {}, C, true])
            }
            this.asSampleFactors = [];
            this.layoutRestore = false
        }
        if (this.transposeData) {
            y.unshift(["transpose", [false, this.sortData.length || this.selectedDataPoints.length], {}, C, true]);
            this.transposeData = false;
            delete(CanvasXpress.stack[this.target].config.transposeData)
        }
        if (this.sortData) {
            for (var p = 0; p < this.sortData.length; p++) {
                y.push(["modifySort", [this.sortData[p][0], this.sortData[p][1], this.sortData[p][2], false, p == this.sortData.length - 1 ? true : false], {}, C, true])
            }
            this.sortData = [];
            delete(CanvasXpress.stack[this.target].config.sortData)
        }
        if (this.selectedDataPoints.length) {
            var x = false;
            for (var p = 0; p < this.selectedDataPoints.length; p++) {
                var o = this.getVariableIndices(this.selectedDataPoints[p]);
                if (o >= 0) {
                    this.addRemoveToSelected([o, this.xAxisIndices[0], this.yAxisIndices[0]]);
                    x = true
                }
            }
            if (x) {
                y.unshift(["broadcastDraw", [{
                    func: "afterRender"
                }], {}, C, true])
            }
        }
        var r = y.length - 1;
        var l = false;
        for (var p = 0; p < y.length; p++) {
            var n = y[p];
            var u = n.shift();
            if (u) {
                var k = n.length > 0 ? n.shift() : [];
                var w = n.length > 0 ? n.shift() : {};
                var B = n.length > 0 ? n.shift() : C;
                var q = n.length > 0 ? n.shift() : false;
                if (this.showFunctionNamesAfterRender) {
                    this.flashInfoSpan(20, 20, u)
                }
                var m = y[p + 1] && y[p + 1][0] && y[p + 1][0].match(/drag/i) ? true : false;
                this.skipRender = u == "createDOE" || u == "createHistogram" || u.match(/segregate/) || m ? false : !this.showTransition && p < r ? true : this.view == "table" ? true : false;
                this.skipRender = u.match(/switch/) && p < r ? true : false;
                for (var s in w) {
                    this[s] = w[s]
                }
                if (u.match(/switch/) && z && p == r) {
                    l = true
                }
                this[u].apply(this, k);
                if (u == "moveCanvas") {
                    CanvasXpress.stack[this.target].afterRender.push([u, k])
                }
                if (q) {
                    var A = CanvasXpress.stack[this.target].afterRender.length - 1;
                    CanvasXpress.stack[this.target].afterRender[A][4] = true
                }
                if (l) {
                    this.masterReset()
                }
            }
        }
        if (this.view == "table") {
            this.view = "canvas";
            this.clickView()
        } else {
            if (this.view == "layout") {
                this.view = "canvas";
                this.clickLayout(false, false, "none")
            }
        }
        this.triggerDataLoaded("afterRender")
    };
    this.setURL = function() {
        if (window.location.search != "") {
            var m = location.search.substring(1).split("&");
            for (var l = 0; l < m.length; l++) {
                var k = m[l].split("=");
                if (!k[0]) {
                    continue
                }
                if (k[0].match(/^cX/)) {
                    this.url[k[0]] = k[1] || true
                } else {
                    this.url[k[0]] = k[1] == "false" ? false : k[1] == "true" ? true : k[1]
                }
            }
        }
    };
    this.createThumbnailBase64 = function() {
        if (this.url.hasOwnProperty("cXprint") || this.printThumbnail) {
            this.printThumbnail = false;
            var l = this.url.cXprint !== true && this.url.cXprint !== "true" ? this.url.cXprint : this.saveFilename ? this.saveFilename : this.target + ".png";
            var k = this;
            var m = function(n, o) {
                k.saveAs(n, o);
                setTimeout(function() {
                    window.close()
                }, 4000)
            };
            k.print(false, l, m)
        } else {
            if (this.url.hasOwnProperty("cXprintBase64") || this.cacheBase64) {
                this.cacheBase64 = false;
                var m = function() {
                    return
                };
                if (CanvasXpress.$(this.target)) {
                    this.print(false, false, m)
                }
            }
        }
    };
    this.logConsole = function(k) {
        if (this.verbose) {
            console.log(this.target, this.prettyJSON(k))
        }
    };
    this.triggerDataLoaded = function(n, l) {
        var m = this;
        var k = function() {
            var o = l || m;
            o.logConsole("canvasXpress data ready - " + n);
            o.createThumbnailBase64();
            CanvasXpress.ready = true
        };
        if (CanvasXpress.cacheImagesReady) {
            if (n == "afterRender") {
                if (!this.isAnimation && !this.isTransitionOn && !this.dataURL && !this.dataString && !h && !this.isUpdateRemoteData && !d) {
                    k()
                }
            } else {
                if (this.graphType == "Network") {
                    if (!this.isAnimation && !this.isUpdateRemoteData) {
                        k()
                    }
                } else {
                    if (!this.isTransitionOn) {
                        k()
                    }
                }
            }
        }
    };
    this.saveFirstState = function() {
        CanvasXpress.stack[this.target].state.push(this.getConfigState())
    };
    this.continueInitialization = function() {
        var k = CanvasXpress.stack[this.target];
        var l = this.isOneTimeFunctionInConfig();
        this.initializeGraph(false, false, false, false, false, false, l);
        if (!this.dataURL) {
            this.afterRender(k.afterRenderInit)
        }
        this.getDataFromURLOrString(this.target, k.config, k.events, k.info);
        this.saveFirstState();
        CanvasXpress.current = this.target;
        this.meta.time.end = new Date().getTime();
        this.meta.time.elapsed = this.meta.time.end - this.meta.time.start;
        this.hideMask()
    };
    this.pauseInitialization = function() {
        if (!this.lazyLoad || (!this.loaded && this.isInViewport(this.meta.canvas.ctx.canvas))) {
            this.continueInitialization()
        }
    };
    this.initializeProcessing = function() {
        var k = this;
        k.initializeBrowser();
        k.inititalizeConfig(b);
        k.initializeViewport(d);
        k.validateUserColors();
        k.initializeApi();
        k.initializeDimensions();
        k.initializeData(c);
        k.initializeLayout();
        k.initializeDataFilters();
        k.initializeEvents();
        k.initializeRemote();
        k.initStack(c, b, j, a, g);
        k.initTransitions();
        k.pauseInitialization()
    };
    this.initialize = function() {
        CanvasXpress.instances.push(this);
        this.setInit();
        this.setURL();
        this.initDOM();
        this.initSVG();
        this.initInterface();
        this.initSave();
        this.validateParameters();
        this.initConfig();
        this.initDate();
        this.initViewport();
        this.initPrimitives();
        this.initUtils();
        this.initNumeric();
        this.initjLouvain();
        this.initMathUtils();
        this.initLegendUtils();
        this.initFilterUtils();
        this.initClusterUtils();
        this.initSortUtils();
        this.initExample();
        this.initDataUtils();
        this.initRandom();
        this.initData();
        this.initValidity();
        this.initLayout();
        this.initEvents();
        this.initTooltip();
        this.initTooltipMouse();
        this.initTooltipDiv();
        this.initToolbar();
        this.initMenus();
        this.initLinks();
        this.initConfigurator();
        this.initDataFilter();
        this.initDataTable();
        this.initCodeInfo();
        this.initBin();
        this.initDataExplorer();
        this.initAnimation();
        this.initRemote();
        this.initAxes();
        this.initGraph();
        this.initializeProcessing()
    };
    this.initialize()
};
CanvasXpress.png = "data:image/png;base64,R0lGODlhAQABAID/AMDAwAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==";
CanvasXpress.letters = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];
CanvasXpress.dates = {
    Sun: 1,
    Mon: 2,
    Tue: 3,
    Wed: 4,
    Thu: 5,
    Fri: 6,
    Sat: 7,
    Sunday: 1,
    Monday: 2,
    Tuesday: 3,
    Wednesday: 4,
    Thursday: 5,
    Friday: 6,
    Saturday: 7,
    Jan: "01",
    Feb: "02",
    Mar: "03",
    Apr: "04",
    May: "05",
    Jun: "06",
    Jul: "07",
    Aug: "08",
    Sep: "09",
    Oct: "10",
    Nov: "11",
    Dec: "12",
    January: "01",
    February: "02",
    March: "03",
    April: "04",
    May: "05",
    June: "06",
    July: "07",
    August: "08",
    September: "09",
    October: "10",
    November: "11",
    December: "12"
};
CanvasXpress.countries = {
    AFG: ["Afghanistan", "Asia", "South Asia", "AF", 33.939, 67.709],
    ALA: ["Aland Islands", "Europe", "North Europe", "AX", 48.464, -122.706],
    ALB: ["Albania", "Europe", "South Europe", "AL", 41.153, 20.168],
    DZA: ["Algeria", "Africa", "North Africa", "DZ", 28.033, 1.659],
    ASM: ["American Samoa", "Oceania", "Polynesia", "AS", -14.271, -170.133],
    AND: ["Andorra", "Europe", "South Europe", "AD", 42.546, 1.601],
    AGO: ["Angola", "Africa", "Middle Africa", "AO", -11.203, 17.873],
    AIA: ["Anguilla", "America", "Caribbean", "AI", 18.22, -63.069],
    ATA: ["Antarctica", "", "", "AQ", -75.251, -0.072],
    ATG: ["Antigua and Barbuda", "America", "Caribbean", "AG", 17.06, -61.797],
    ARG: ["Argentina", "America", "South America", "AR", -38.417, -63.617],
    ARM: ["Armenia", "Asia", "West Asia", "AM", 40.069, 45.038],
    ABW: ["Aruba", "America", "Caribbean", "AW", 12.521, -69.969],
    AUS: ["Australia", "Oceania", "Australia and New Zealand", "AU", -25.275, 133.775],
    AUT: ["Austria", "Europe", "West Europe", "AT", 47.516, 14.55],
    AZE: ["Azerbaijan", "Asia", "West Asia", "AZ", 40.143, 47.576],
    BHS: ["Bahamas", "America", "Caribbean", "BS", 25.034, -77.397],
    BHR: ["Bahrain", "Asia", "West Asia", "BH", 25.93, 50.637],
    BGD: ["Bangladesh", "Asia", "South Asia", "BD", 23.684, 90.356],
    BRB: ["Barbados", "America", "Caribbean", "BB", 13.193, -59.544],
    BLR: ["Belarus", "Europe", "East Europe", "BY", 53.709, 27.953],
    BEL: ["Belgium", "Europe", "West Europe", "BE", 50.503, 4.469],
    BLZ: ["Belize", "America", "Central America", "BZ", 17.189, -88.498],
    BEN: ["Benin", "Africa", "West Africa", "BJ", 9.307, 2.315],
    BMU: ["Bermuda", "America", "North America", "BM", 32.321, -64.758],
    BTN: ["Bhutan", "Asia", "South Asia", "BT", 27.514, 90.433],
    BOL: ["Bolivia", "America", "South America", "BO", -16.291, -63.589],
    BES: ["Bonaire", "America", "Caribbean", "BQ", 12.201, -68.262],
    BIH: ["Bosnia and Herzegovina", "Europe", "South Europe", "BA", 43.915, 17.679],
    BWA: ["Botswana", "Africa", "South Africa", "BW", -22.329, 24.684],
    BVT: ["Bouvet Island", "", "", "BV", -54.424, 3.413],
    BRA: ["Brazil", "America", "South America", "BR", -14.236, -51.926],
    IOT: ["British Indian Ocean Territory", "", "", "IO", -6.344, 71.876],
    BRN: ["Brunei Darussalam", "Asia", "South-East Asia", "BN", 4.535, 114.727],
    BGR: ["Bulgaria", "Europe", "East Europe", "BG", 42.733, 25.485],
    BFA: ["Burkina Faso", "Africa", "West Africa", "BF", 12.238, -1.562],
    BDI: ["Burundi", "Africa", "East Africa", "BI", -3.374, 29.918],
    KHM: ["Cambodia", "Asia", "South-East Asia", "KH", 12.565, 104.99],
    CMR: ["Cameroon", "Africa", "Middle Africa", "CM", 7.369, 12.354],
    CAN: ["Canada", "America", "North America", "CA", 56.13, -106.347],
    CPV: ["Cabo Verde", "Africa", "West Africa", "CV", 16.002, -24.014],
    CYM: ["Cayman Islands", "America", "Caribbean", "KY", 19.513, -80.567],
    CAF: ["Central African Republic", "Africa", "Middle Africa", "CF", 6.611, 20.939],
    TCD: ["Chad", "Africa", "Middle Africa", "TD", 15.454, 18.732],
    CHL: ["Chile", "America", "South America", "CL", -35.676, -71.543],
    CHN: ["China", "Asia", "East Asia", "CN", 35.861, 104.195],
    CXR: ["Christmas Island", "", "", "CX", -10.448, 105.69],
    CCK: ["Cocos (Keeling) Islands", "", "", "CC", -12.165, 96.87],
    COL: ["Colombia", "America", "South America", "CO", 4.57, -74.298],
    COM: ["Comoros", "Africa", "East Africa", "KM", -11.876, 43.872],
    COG: ["Congo", "Africa", "Middle Africa", "CG", -0.229, 15.827],
    COD: ["Congo (Democratic Republic of the)", "Africa", "Middle Africa", "CD", -4.039, 21.758],
    COK: ["Cook Islands", "Oceania", "Polynesia", "CK", -21.237, -159.778],
    CRI: ["Costa Rica", "America", "Central America", "CR", 9.748, -83.754],
    CIV: ["Cote d'Ivoire", "Africa", "West Africa", "CI", 7.539, -5.548],
    HRV: ["Croatia", "Europe", "South Europe", "HR", 45.1, 15.2],
    CUB: ["Cuba", "America", "Caribbean", "CU", 21.521, -77.782],
    CUW: ["Cura�ao", "America", "Caribbean", "CW", 12.169, -68.99],
    CYP: ["Cyprus", "Asia", "West Asia", "CY", 35.126, 33.429],
    CZE: ["Czech Republic", "Europe", "East Europe", "CZ", 49.817, 15.472],
    DNK: ["Denmark", "Europe", "North Europe", "DK", 56.263, 9.501],
    DJI: ["Djibouti", "Africa", "East Africa", "DJ", 11.825, 42.59],
    DMA: ["Dominica", "America", "Caribbean", "DM", 15.414, -61.371],
    DOM: ["Dominican Republic", "America", "Caribbean", "DO", 18.735, -70.163],
    ECU: ["Ecuador", "America", "South America", "EC", -1.832, -78.184],
    EGY: ["Egypt", "Africa", "North Africa", "EG", 26.82, 30.802],
    SLV: ["El Salvador", "America", "Central America", "SV", 13.794, -88.897],
    GNQ: ["Equatorial Guinea", "Africa", "Middle Africa", "GQ", 1.65, 10.267],
    ERI: ["Eritrea", "Africa", "East Africa", "ER", 15.179, 39.782],
    EST: ["Estonia", "Europe", "North Europe", "EE", 58.595, 25.013],
    ETH: ["Ethiopia", "Africa", "East Africa", "ET", 9.145, 40.489],
    FLK: ["Falkland Islands", "America", "South America", "FK", -51.797, -59.524],
    FRO: ["Faroe Islands", "Europe", "North Europe", "FO", 61.892, -6.912],
    FJI: ["Fiji", "Oceania", "Melanesia", "FJ", -16.579, 179.414],
    FIN: ["Finland", "Europe", "North Europe", "FI", 61.924, 25.748],
    FRA: ["France", "Europe", "West Europe", "FR", 46.227, 2.213],
    GUF: ["French Guiana", "America", "South America", "GF", 3.933, -53.126],
    PYF: ["French Polynesia", "Oceania", "Polynesia", "PF", -17.68, -149.407],
    ATF: ["French Southern Territories", "", "", "TF", -49.281, 69.348],
    GAB: ["Gabon", "Africa", "Middle Africa", "GA", -0.804, 11.609],
    GMB: ["Gambia", "Africa", "West Africa", "GM", 13.443, -15.311],
    GEO: ["Georgia", "Asia", "West Asia", "GE", 42.315, 43.356],
    DEU: ["Germany", "Europe", "West Europe", "DE", 51.165, 10.451],
    GHA: ["Ghana", "Africa", "West Africa", "GH", 7.946, -1.024],
    GIB: ["Gibraltar", "Europe", "South Europe", "GI", 36.137, -5.346],
    GRC: ["Greece", "Europe", "South Europe", "GR", 39.074, 21.824],
    GRE: ["Greece", "Europe", "South Europe", "EL", 39.074, 21.824],
    GRL: ["Greenland", "America", "North America", "GL", 71.706, -42.605],
    GRD: ["Grenada", "America", "Caribbean", "GD", 12.262, -61.605],
    GLP: ["Guadeloupe", "America", "Caribbean", "GP", 16.995, -62.068],
    GUM: ["Guam", "Oceania", "Micronesia", "GU", 13.444, 144.793],
    GTM: ["Guatemala", "America", "Central America", "GT", 15.783, -90.231],
    GGY: ["Guernsey", "Europe", "North Europe", "GG", 49.465, -2.586],
    GIN: ["Guinea", "Africa", "West Africa", "GN", 9.945, -9.697],
    GNB: ["Guinea-Bissau", "Africa", "West Africa", "GW", 11.803, -15.181],
    GUY: ["Guyana", "America", "South America", "GY", 4.86, -58.931],
    HTI: ["Haiti", "America", "Caribbean", "HT", 18.971, -72.286],
    HMD: ["Heard Island and McDonald Islands", "", "", "HM", -53.082, 73.504],
    VAT: ["Holy See", "Europe", "South Europe", "VA", 41.902, 12.453],
    HND: ["Honduras", "America", "Central America", "HN", 15.199, -86.242],
    HKG: ["Hong Kong", "Asia", "East Asia", "HK", 22.396, 114.109],
    HUN: ["Hungary", "Europe", "East Europe", "HU", 47.162, 19.503],
    ISL: ["Iceland", "Europe", "North Europe", "IS", 64.963, -19.021],
    IND: ["India", "Asia", "South Asia", "IN", 20.593, 78.962],
    IDN: ["Indonesia", "Asia", "South-East Asia", "ID", -0.79, 113.921],
    IRN: ["Iran", "Asia", "South Asia", "IR", 32.427, 53.688],
    IRQ: ["Iraq", "Asia", "West Asia", "IQ", 33.223, 43.679],
    IRL: ["Ireland", "Europe", "North Europe", "IE", 53.412, -8.244],
    IMN: ["Isle of Man", "Europe", "North Europe", "IM", 54.236, -4.549],
    ISR: ["Israel", "Asia", "West Asia", "IL", 31.046, 34.851],
    ITA: ["Italy", "Europe", "South Europe", "IT", 41.871, 12.567],
    JAM: ["Jamaica", "America", "Caribbean", "JM", 18.109, -77.298],
    JPN: ["Japan", "Asia", "East Asia", "JP", 36.204, 138.252],
    JEY: ["Jersey", "Europe", "North Europe", "JE", 49.214, -2.132],
    JOR: ["Jordan", "Asia", "West Asia", "JO", 30.585, 36.238],
    KAZ: ["Kazakhstan", "Asia", "Central Asia", "KZ", 48.019, 66.923],
    KEN: ["Kenya", "Africa", "East Africa", "KE", -0.024, 37.906],
    KIR: ["Kiribati", "Oceania", "Micronesia", "KI", -3.371, -168.735],
    PRK: ["Korea (Democratic People's Republic of)", "Asia", "East Asia", "KP", 40.339, 127.51],
    KOR: ["Korea (Republic of)", "Asia", "East Asia", "KR", 35.907, 127.766],
    XKX: ["Kosovo", "Europe", "South Europe", "XK", 42.602, 20.902],
    KWT: ["Kuwait", "Asia", "West Asia", "KW", 29.311, 47.481],
    KGZ: ["Kyrgyzstan", "Asia", "Central Asia", "KG", 41.204, 74.766],
    LAO: ["Lao People's Democratic Republic", "Asia", "South-East Asia", "LA", 19.856, 102.495],
    LVA: ["Latvia", "Europe", "North Europe", "LV", 56.879, 24.603],
    LBN: ["Lebanon", "Asia", "West Asia", "LB", 33.854, 35.862],
    LSO: ["Lesotho", "Africa", "South Africa", "LS", -29.61, 28.233],
    LBR: ["Liberia", "Africa", "West Africa", "LR", 6.428, -9.43],
    LBY: ["Libya", "Africa", "North Africa", "LY", 26.335, 17.228],
    LIE: ["Liechtenstein", "Europe", "West Europe", "LI", 47.166, 9.555],
    LTU: ["Lithuania", "Europe", "North Europe", "LT", 55.169, 23.881],
    LUX: ["Luxembourg", "Europe", "West Europe", "LU", 49.815, 6.129],
    MAC: ["Macao", "Asia", "East Asia", "MO", 22.198, 113.543],
    MKD: ["Macedonia", "Europe", "South Europe", "MK", 41.608, 21.745],
    MDG: ["Madagascar", "Africa", "East Africa", "MG", -18.767, 46.869],
    MWI: ["Malawi", "Africa", "East Africa", "MW", -13.255, 34.301],
    MYS: ["Malaysia", "Asia", "South-East Asia", "MY", 4.21, 101.975],
    MDV: ["Maldives", "Asia", "South Asia", "MV", 3.202, 73.22],
    MLI: ["Mali", "Africa", "West Africa", "ML", 17.57, -3.997],
    MLT: ["Malta", "Europe", "South Europe", "MT", 35.937, 14.375],
    MHL: ["Marshall Islands", "Oceania", "Micronesia", "MH", 7.131, 171.184],
    MTQ: ["Martinique", "America", "Caribbean", "MQ", 14.641, -61.025],
    MRT: ["Mauritania", "Africa", "West Africa", "MR", 21.007, -10.941],
    MUS: ["Mauritius", "Africa", "East Africa", "MU", -20.349, 57.552],
    MYT: ["Mayotte", "Africa", "East Africa", "YT", -12.828, 45.166],
    MEX: ["Mexico", "America", "Central America", "MX", 23.634, -102.553],
    FSM: ["Micronesia", "Oceania", "Micronesia", "FM", 7.425, 150.55],
    MDA: ["Moldova", "Europe", "East Europe", "MD", 47.411, 28.369],
    MCO: ["Monaco", "Europe", "West Europe", "MC", 43.75, 7.412],
    MNG: ["Mongolia", "Asia", "East Asia", "MN", 46.862, 103.846],
    MNE: ["Montenegro", "Europe", "South Europe", "ME", 42.708, 19.374],
    MSR: ["Montserrat", "America", "Caribbean", "MS", 16.742, -62.188],
    MAR: ["Morocco", "Africa", "North Africa", "MA", 31.791, -7.093],
    MOZ: ["Mozambique", "Africa", "East Africa", "MZ", -18.666, 35.529],
    MMR: ["Myanmar", "Asia", "South-East Asia", "MM", 21.913, 95.956],
    NAM: ["Namibia", "Africa", "South Africa", "NA", -22.958, 18.49],
    NRU: ["Nauru", "Oceania", "Micronesia", "NR", -0.523, 166.931],
    NPL: ["Nepal", "Asia", "South Asia", "NP", 28.394, 84.124],
    NLD: ["Netherlands", "Europe", "West Europe", "NL", 52.132, 5.291],
    ANT: ["Netherlands Antilles", "", "", "AN", 12.226, -69.061],
    NCL: ["New Caledonia", "Oceania", "Melanesia", "NC", -20.905, 165.618],
    NZL: ["New Zealand", "Oceania", "Australia and New Zealand", "NZ", -40.901, 174.885],
    NIC: ["Nicaragua", "America", "Central America", "NI", 12.865, -85.208],
    NER: ["Niger", "Africa", "West Africa", "NE", 17.607, 8.081],
    NGA: ["Nigeria", "Africa", "West Africa", "NG", 9.081, 8.675],
    NIU: ["Niue", "Oceania", "Polynesia", "NU", -19.055, -169.868],
    NFK: ["Norfolk Island", "Oceania", "Australia and New Zealand", "NF", -29.041, 167.954],
    MNP: ["West Mariana Islands", "Oceania", "Micronesia", "MP", 17.33, 145.384],
    NOR: ["Norway", "Europe", "North Europe", "NO", 60.472, 8.468],
    OMN: ["Oman", "Asia", "West Asia", "OM", 21.512, 55.923],
    PAK: ["Pakistan", "Asia", "South Asia", "PK", 30.375, 69.345],
    PLW: ["Palau", "Oceania", "Micronesia", "PW", 7.514, 134.582],
    PSE: ["Palestine", "Asia", "West Asia", "PS", 31.952, 35.233],
    PAN: ["Panama", "America", "Central America", "PA", 8.537, -80.783],
    PNG: ["Papua New Guinea", "Oceania", "Melanesia", "PG", -6.315, 143.955],
    PRY: ["Paraguay", "America", "South America", "PY", -23.443, -58.444],
    PER: ["Peru", "America", "South America", "PE", -9.19, -75.016],
    PHL: ["Philippines", "Asia", "South-East Asia", "PH", 12.879, 121.774],
    PCN: ["Pitcairn", "Oceania", "Polynesia", "PN", -24.704, -127.44],
    POL: ["Poland", "Europe", "East Europe", "PL", 51.919, 19.145],
    PRT: ["Portugal", "Europe", "South Europe", "PT", 39.399, -8.225],
    PRI: ["Puerto Rico", "America", "Caribbean", "PR", 18.22, -66.591],
    QAT: ["Qatar", "Asia", "West Asia", "QA", 25.354, 51.183],
    REU: ["R�union", "Africa", "East Africa", "RE", -21.116, 55.536],
    ROU: ["Romania", "Europe", "East Europe", "RO", 45.943, 24.966],
    RUS: ["Russian Federation", "Europe", "East Europe", "RU", 61.524, 105.318],
    RWA: ["Rwanda", "Africa", "East Africa", "RW", -1.941, 29.873],
    BLM: ["Saint Barthelemy", "America", "Caribbean", "BL", 17.899, -62.833],
    SHN: ["Saint Helena", "Africa", "West Africa", "SH", -24.144, -10.031],
    KNA: ["Saint Kitts and Nevis", "America", "Caribbean", "KN", 17.357, -62.783],
    LCA: ["Saint Lucia", "America", "Caribbean", "LC", 13.909, -60.979],
    MAF: ["Saint Martin", "America", "Caribbean", "MF", 18.075, -63.06],
    SPM: ["Saint Pierre and Miquelon", "America", "North America", "PM", 46.941, -56.272],
    VCT: ["Saint Vincent and the Grenadines", "America", "Caribbean", "VC", 12.984, -61.288],
    WSM: ["Samoa", "Oceania", "Polynesia", "WS", -13.76, -172.105],
    SMR: ["San Marino", "Europe", "South Europe", "SM", 43.942, 12.457],
    STP: ["Sao Tome and Principe", "Africa", "Middle Africa", "ST", 0.186, 6.613],
    SAU: ["Saudi Arabia", "Asia", "West Asia", "SA", 23.885, 45.079],
    SEN: ["Senegal", "Africa", "West Africa", "SN", 14.497, -14.453],
    SRB: ["Serbia", "Europe", "South Europe", "RS", 44.016, 21.005],
    SYC: ["Seychelles", "Africa", "East Africa", "SC", -4.68, 55.491],
    SLE: ["Sierra Leone", "Africa", "West Africa", "SL", 8.46, -11.78],
    SGP: ["Singapore", "Asia", "South-East Asia", "SG", 1.352, 103.819],
    SXM: ["Sint Maarten", "America", "Caribbean", "SX", 18.042, -63.054],
    SVK: ["Slovakia", "Europe", "East Europe", "SK", 48.669, 19.699],
    SVN: ["Slovenia", "Europe", "South Europe", "SI", 46.151, 14.995],
    SLB: ["Solomon Islands", "Oceania", "Melanesia", "SB", -9.646, 160.156],
    SOM: ["Somalia", "Africa", "East Africa", "SO", 5.152, 46.199],
    ZAF: ["South Africa", "Africa", "South Africa", "ZA", -30.56, 22.937],
    SGS: ["South Georgia and the South Sandwich Islands", "", "", "GS", -54.43, -36.588],
    SSD: ["South Sudan", "Africa", "East Africa", "SS", 4.859, 31.571],
    ESP: ["Spain", "Europe", "South Europe", "ES", 40.463, -3.75],
    LKA: ["Sri Lanka", "Asia", "South Asia", "LK", 7.873, 80.771],
    SDN: ["Sudan", "Africa", "North Africa", "SD", 12.862, 30.217],
    SUR: ["Suriname", "America", "South America", "SR", 3.919, -56.028],
    SJM: ["Svalbard and Jan Mayen", "Europe", "North Europe", "SJ", 77.553, 23.67],
    SWZ: ["Swaziland", "Africa", "South Africa", "SZ", -26.523, 31.465],
    SWE: ["Sweden", "Europe", "North Europe", "SE", 60.128, 18.643],
    CHE: ["Switzerland", "Europe", "West Europe", "CH", 46.818, 8.227],
    SYR: ["Syrian Arab Republic", "Asia", "West Asia", "SY", 34.802, 38.996],
    TWN: ["Taiwan", "Asia", "East Asia", "TW", 23.697, 120.96],
    TJK: ["Tajikistan", "Asia", "Central Asia", "TJ", 38.861, 71.276],
    TZA: ["Tanzania", "Africa", "East Africa", "TZ", -6.37, 34.888],
    THA: ["Thailand", "Asia", "South-East Asia", "TH", 15.87, 100.992],
    TLS: ["Timor-Leste", "Asia", "South-East Asia", "TL", -8.875, 125.727],
    TGO: ["Togo", "Africa", "West Africa", "TG", 8.619, 0.824],
    TKL: ["Tokelau", "Oceania", "Polynesia", "TK", -8.968, -171.856],
    TON: ["Tonga", "Oceania", "Polynesia", "TO", -21.179, -175.199],
    TTO: ["Trinidad and Tobago", "America", "Caribbean", "TT", 10.691, -61.223],
    TUN: ["Tunisia", "Africa", "North Africa", "TN", 33.886, 9.537],
    TUR: ["Turkey", "Asia", "West Asia", "TR", 38.963, 35.243],
    TKM: ["Turkmenistan", "Asia", "Central Asia", "TM", 38.969, 59.556],
    TCA: ["Turks and Caicos Islands", "America", "Caribbean", "TC", 21.694, -71.798],
    TUV: ["Tuvalu", "Oceania", "Polynesia", "TV", -7.11, 177.649],
    UGA: ["Uganda", "Africa", "East Africa", "UG", 1.373, 32.29],
    UKR: ["Ukraine", "Europe", "East Europe", "UA", 48.379, 31.165],
    ARE: ["United Arab Emirates", "Asia", "West Asia", "AE", 23.424, 53.847],
    GBR: ["United Kingdom of Great Britain and Northern Ireland", "Europe", "North Europe", "GB", 55.378, -3.436],
    UKM: ["United Kingdom of Great Britain and Northern Ireland", "Europe", "North Europe", "UK", 55.378, -3.436],
    USA: ["United States of America", "America", "North America", "US", 37.09, -95.713],
    UMI: ["United States Minor Outlying Islands", "", "", "UM", -0.374, -159.996],
    URY: ["Uruguay", "America", "South America", "UY", -32.523, -55.766],
    UZB: ["Uzbekistan", "Asia", "Central Asia", "UZ", 41.377, 64.585],
    VUT: ["Vanuatu", "Oceania", "Melanesia", "VU", -15.377, 166.959],
    VEN: ["Venezuela", "America", "South America", "VE", 6.423, -66.59],
    VNM: ["Vietnam", "Asia", "South-East Asia", "VN", 14.058, 108.277],
    VGB: ["Virgin Islands (British)", "America", "Caribbean", "VG", 18.42, -64.64],
    VIR: ["Virgin Islands (U.S.)", "America", "Caribbean", "VI", 18.335, -64.897],
    WLF: ["Wallis and Futuna", "Oceania", "Polynesia", "WF", -13.769, -177.157],
    ESH: ["Western Sahara", "Africa", "North Africa", "EH", 24.215, -12.886],
    XXX: ["Unespecified Nationality", "", "", "XX", ],
    YEM: ["Yemen", "Asia", "West Asia", "YE", 15.552, 48.516],
    ZMB: ["Zambia", "Africa", "East Africa", "ZM", -13.134, 27.849],
    ZWE: ["Zimbabwe", "Africa", "East Africa", "ZW", -19.016, 29.154]
};
CanvasXpress.usa = {
    AK: ["Alaska", 63.588753, -154.493062],
    AL: ["Alabama", 32.318231, -86.902298],
    AR: ["Arkansas", 35.20105, -91.831833],
    AZ: ["Arizona", 34.048928, -111.093731],
    CA: ["California", 36.778261, -119.417932],
    CO: ["Colorado", 39.550051, -105.782067],
    CT: ["Connecticut", 41.603221, -73.087749],
    DC: ["District of Columbia", 38.905985, -77.033418],
    DE: ["Delaware", 38.910832, -75.52767],
    FL: ["Florida", 27.664827, -81.515754],
    GA: ["Georgia", 32.157435, -82.907123],
    HI: ["Hawaii", 19.898682, -155.665857],
    IA: ["Iowa", 41.878003, -93.097702],
    ID: ["Idaho", 44.068202, -114.742041],
    IL: ["Illinois", 40.633125, -89.398528],
    IN: ["Indiana", 40.551217, -85.602364],
    KS: ["Kansas", 39.011902, -98.484246],
    KY: ["Kentucky", 37.839333, -84.270018],
    LA: ["Louisiana", 31.244823, -92.145024],
    MA: ["Massachusetts", 42.407211, -71.382437],
    MD: ["Maryland", 39.045755, -76.641271],
    ME: ["Maine", 45.253783, -69.445469],
    MI: ["Michigan", 44.314844, -85.602364],
    MN: ["Minnesota", 46.729553, -94.6859],
    MO: ["Missouri", 37.964253, -91.831833],
    MS: ["Mississippi", 32.354668, -89.398528],
    MT: ["Montana", 46.879682, -110.362566],
    NC: ["North Carolina", 35.759573, -79.0193],
    ND: ["NorthDakota", 47.551493, -101.002012],
    NE: ["Nebraska", 41.492537, -99.901813],
    NH: ["New Hampshire", 43.193852, -71.572395],
    NJ: ["New Jersey", 40.058324, -74.405661],
    NM: ["New Mexico", 34.97273, -105.032363],
    NV: ["Nevada", 38.80261, -116.419389],
    NY: ["New York", 43.299428, -74.217933],
    OH: ["Ohio", 40.417287, -82.907123],
    OK: ["Oklahoma", 35.007752, -97.092877],
    OR: ["Oregon", 43.804133, -120.554201],
    PA: ["Pennsylvania", 41.203322, -77.194525],
    PR: ["Puerto Rico", 18.220833, -66.590149],
    RI: ["Rhode Island", 41.580095, -71.477429],
    SC: ["South Carolina", 33.836081, -81.163725],
    SD: ["South Dakota", 43.969515, -99.901813],
    TN: ["Tennessee", 35.517491, -86.580447],
    TX: ["Texas", 31.968599, -99.901813],
    UT: ["Utah", 39.32098, -111.093731],
    VA: ["Virginia", 37.431573, -78.656894],
    VT: ["Vermont", 44.558803, -72.577841],
    WA: ["Washington", 47.751074, -120.740139],
    WI: ["Wisconsin", 43.78444, -88.787868],
    WV: ["West Virginia", 38.597626, -80.454903],
    WY: ["Wyoming", 43.075968, -107.290284]
};
CanvasXpress.maps = {
    Africa: "/data/africa.geo.json",
    Argentina: "/data/argentina.geo.json",
    Asia: "/data/asia.geo.json",
    Belgium: "/data/belgium.geo.json",
    China: "/data/china.geo.json",
    Colombia: "/data/colombia.geo.json",
    Countries: "/data/countries.geo.json",
    Europe: "/data/europe.geo.json",
    France: "/data/france.geo.json",
    India: "/data/india.geo.json",
    Italy: "/data/italy.geo.json",
    NorthAmerica: "/data/north-america.geo.json",
    Oceania: "/data/oceania.geo.json",
    SouthAmerica: "/data/south-america.geo.json",
    Spain: "/data/spain.geo.json",
    UnitedKingdom: "/data/united-kindom.geo.json",
    USA: "/data/USA.geo.json",
    USACounties: "/data/usa-counties.json",
    USADistricts: "/data/usa-districts.json",
    USAStates: "/data/usa-states.json",
    WorldContinents: "/data/world-continents-geo.json",
    World: "/data/world.geo.json"
};
CanvasXpress.chromosomes = {
    hg19: {
        columns: ["start", "end", "name", "stain"],
        order: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, "X", "Y"],
        data: {
            1: [
                [0, 2300000, "p36.33", "gneg"],
                [2300000, 5400000, "p36.32", "gpos25"],
                [5400000, 7200000, "p36.31", "gneg"],
                [7200000, 9200000, "p36.23", "gpos25"],
                [9200000, 12700000, "p36.22", "gneg"],
                [12700000, 16200000, "p36.21", "gpos50"],
                [16200000, 20400000, "p36.13", "gneg"],
                [20400000, 23900000, "p36.12", "gpos25"],
                [23900000, 28000000, "p36.11", "gneg"],
                [28000000, 30200000, "p35.3", "gpos25"],
                [30200000, 32400000, "p35.2", "gneg"],
                [32400000, 34600000, "p35.1", "gpos25"],
                [34600000, 40100000, "p34.3", "gneg"],
                [40100000, 44100000, "p34.2", "gpos25"],
                [44100000, 46800000, "p34.1", "gneg"],
                [46800000, 50700000, "p33", "gpos75"],
                [50700000, 56100000, "p32.3", "gneg"],
                [56100000, 59000000, "p32.2", "gpos50"],
                [59000000, 61300000, "p32.1", "gneg"],
                [61300000, 68900000, "p31.3", "gpos50"],
                [68900000, 69700000, "p31.2", "gneg"],
                [69700000, 84900000, "p31.1", "gpos100"],
                [84900000, 88400000, "p22.3", "gneg"],
                [88400000, 92000000, "p22.2", "gpos75"],
                [92000000, 94700000, "p22.1", "gneg"],
                [94700000, 99700000, "p21.3", "gpos75"],
                [99700000, 102200000, "p21.2", "gneg"],
                [102200000, 107200000, "p21.1", "gpos100"],
                [107200000, 111800000, "p13.3", "gneg"],
                [111800000, 116100000, "p13.2", "gpos50"],
                [116100000, 117800000, "p13.1", "gneg"],
                [117800000, 120600000, "p12", "gpos50"],
                [120600000, 121500000, "p11.2", "gneg"],
                [121500000, 125000000, "p11.1", "acen"],
                [125000000, 128900000, "q11", "acen"],
                [128900000, 142600000, "q12", "gvar"],
                [142600000, 147000000, "q21.1", "gneg"],
                [147000000, 150300000, "q21.2", "gpos50"],
                [150300000, 155000000, "q21.3", "gneg"],
                [155000000, 156500000, "q22", "gpos50"],
                [156500000, 159100000, "q23.1", "gneg"],
                [159100000, 160500000, "q23.2", "gpos50"],
                [160500000, 165500000, "q23.3", "gneg"],
                [165500000, 167200000, "q24.1", "gpos50"],
                [167200000, 170900000, "q24.2", "gneg"],
                [170900000, 172900000, "q24.3", "gpos75"],
                [172900000, 176000000, "q25.1", "gneg"],
                [176000000, 180300000, "q25.2", "gpos50"],
                [180300000, 185800000, "q25.3", "gneg"],
                [185800000, 190800000, "q31.1", "gpos100"],
                [190800000, 193800000, "q31.2", "gneg"],
                [193800000, 198700000, "q31.3", "gpos100"],
                [198700000, 207200000, "q32.1", "gneg"],
                [207200000, 211500000, "q32.2", "gpos25"],
                [211500000, 214500000, "q32.3", "gneg"],
                [214500000, 224100000, "q41", "gpos100"],
                [224100000, 224600000, "q42.11", "gneg"],
                [224600000, 227000000, "q42.12", "gpos25"],
                [227000000, 230700000, "q42.13", "gneg"],
                [230700000, 234700000, "q42.2", "gpos50"],
                [234700000, 236600000, "q42.3", "gneg"],
                [236600000, 243700000, "q43", "gpos75"],
                [243700000, 249250621, "q44", "gneg"]
            ],
            2: [
                [0, 4400000, "p25.3", "gneg"],
                [4400000, 7100000, "p25.2", "gpos50"],
                [7100000, 12200000, "p25.1", "gneg"],
                [12200000, 16700000, "p24.3", "gpos75"],
                [16700000, 19200000, "p24.2", "gneg"],
                [19200000, 24000000, "p24.1", "gpos75"],
                [24000000, 27900000, "p23.3", "gneg"],
                [27900000, 30000000, "p23.2", "gpos25"],
                [30000000, 32100000, "p23.1", "gneg"],
                [32100000, 36600000, "p22.3", "gpos75"],
                [36600000, 38600000, "p22.2", "gneg"],
                [38600000, 41800000, "p22.1", "gpos50"],
                [41800000, 47800000, "p21", "gneg"],
                [47800000, 52900000, "p16.3", "gpos100"],
                [52900000, 55000000, "p16.2", "gneg"],
                [55000000, 61300000, "p16.1", "gpos100"],
                [61300000, 64100000, "p15", "gneg"],
                [64100000, 68600000, "p14", "gpos50"],
                [68600000, 71500000, "p13.3", "gneg"],
                [71500000, 73500000, "p13.2", "gpos50"],
                [73500000, 75000000, "p13.1", "gneg"],
                [75000000, 83300000, "p12", "gpos100"],
                [83300000, 90500000, "p11.2", "gneg"],
                [90500000, 93300000, "p11.1", "acen"],
                [93300000, 96800000, "q11.1", "acen"],
                [96800000, 102700000, "q11.2", "gneg"],
                [102700000, 106000000, "q12.1", "gpos50"],
                [106000000, 107500000, "q12.2", "gneg"],
                [107500000, 110200000, "q12.3", "gpos25"],
                [110200000, 114400000, "q13", "gneg"],
                [114400000, 118800000, "q14.1", "gpos50"],
                [118800000, 122400000, "q14.2", "gneg"],
                [122400000, 129900000, "q14.3", "gpos50"],
                [129900000, 132500000, "q21.1", "gneg"],
                [132500000, 135100000, "q21.2", "gpos25"],
                [135100000, 136800000, "q21.3", "gneg"],
                [136800000, 142200000, "q22.1", "gpos100"],
                [142200000, 144100000, "q22.2", "gneg"],
                [144100000, 148700000, "q22.3", "gpos100"],
                [148700000, 149900000, "q23.1", "gneg"],
                [149900000, 150500000, "q23.2", "gpos25"],
                [150500000, 154900000, "q23.3", "gneg"],
                [154900000, 159800000, "q24.1", "gpos75"],
                [159800000, 163700000, "q24.2", "gneg"],
                [163700000, 169700000, "q24.3", "gpos75"],
                [169700000, 178000000, "q31.1", "gneg"],
                [178000000, 180600000, "q31.2", "gpos50"],
                [180600000, 183000000, "q31.3", "gneg"],
                [183000000, 189400000, "q32.1", "gpos75"],
                [189400000, 191900000, "q32.2", "gneg"],
                [191900000, 197400000, "q32.3", "gpos75"],
                [197400000, 203300000, "q33.1", "gneg"],
                [203300000, 204900000, "q33.2", "gpos50"],
                [204900000, 209000000, "q33.3", "gneg"],
                [209000000, 215300000, "q34", "gpos100"],
                [215300000, 221500000, "q35", "gneg"],
                [221500000, 225200000, "q36.1", "gpos75"],
                [225200000, 226100000, "q36.2", "gneg"],
                [226100000, 231000000, "q36.3", "gpos100"],
                [231000000, 235600000, "q37.1", "gneg"],
                [235600000, 237300000, "q37.2", "gpos50"],
                [237300000, 243199373, "q37.3", "gneg"]
            ],
            3: [
                [0, 2800000, "p26.3", "gpos50"],
                [2800000, 4000000, "p26.2", "gneg"],
                [4000000, 8700000, "p26.1", "gpos50"],
                [8700000, 11800000, "p25.3", "gneg"],
                [11800000, 13300000, "p25.2", "gpos25"],
                [13300000, 16400000, "p25.1", "gneg"],
                [16400000, 23900000, "p24.3", "gpos100"],
                [23900000, 26400000, "p24.2", "gneg"],
                [26400000, 30900000, "p24.1", "gpos75"],
                [30900000, 32100000, "p23", "gneg"],
                [32100000, 36500000, "p22.3", "gpos50"],
                [36500000, 39400000, "p22.2", "gneg"],
                [39400000, 43700000, "p22.1", "gpos75"],
                [43700000, 44100000, "p21.33", "gneg"],
                [44100000, 44200000, "p21.32", "gpos50"],
                [44200000, 50600000, "p21.31", "gneg"],
                [50600000, 52300000, "p21.2", "gpos25"],
                [52300000, 54400000, "p21.1", "gneg"],
                [54400000, 58600000, "p14.3", "gpos50"],
                [58600000, 63700000, "p14.2", "gneg"],
                [63700000, 69800000, "p14.1", "gpos50"],
                [69800000, 74200000, "p13", "gneg"],
                [74200000, 79800000, "p12.3", "gpos75"],
                [79800000, 83500000, "p12.2", "gneg"],
                [83500000, 87200000, "p12.1", "gpos75"],
                [87200000, 87900000, "p11.2", "gneg"],
                [87900000, 91000000, "p11.1", "acen"],
                [91000000, 93900000, "q11.1", "acen"],
                [93900000, 98300000, "q11.2", "gvar"],
                [98300000, 100000000, "q12.1", "gneg"],
                [100000000, 100900000, "q12.2", "gpos25"],
                [100900000, 102800000, "q12.3", "gneg"],
                [102800000, 106200000, "q13.11", "gpos75"],
                [106200000, 107900000, "q13.12", "gneg"],
                [107900000, 111300000, "q13.13", "gpos50"],
                [111300000, 113500000, "q13.2", "gneg"],
                [113500000, 117300000, "q13.31", "gpos75"],
                [117300000, 119000000, "q13.32", "gneg"],
                [119000000, 121900000, "q13.33", "gpos75"],
                [121900000, 123800000, "q21.1", "gneg"],
                [123800000, 125800000, "q21.2", "gpos25"],
                [125800000, 129200000, "q21.3", "gneg"],
                [129200000, 133700000, "q22.1", "gpos25"],
                [133700000, 135700000, "q22.2", "gneg"],
                [135700000, 138700000, "q22.3", "gpos25"],
                [138700000, 142800000, "q23", "gneg"],
                [142800000, 148900000, "q24", "gpos100"],
                [148900000, 152100000, "q25.1", "gneg"],
                [152100000, 155000000, "q25.2", "gpos50"],
                [155000000, 157000000, "q25.31", "gneg"],
                [157000000, 159000000, "q25.32", "gpos50"],
                [159000000, 160700000, "q25.33", "gneg"],
                [160700000, 167600000, "q26.1", "gpos100"],
                [167600000, 170900000, "q26.2", "gneg"],
                [170900000, 175700000, "q26.31", "gpos75"],
                [175700000, 179000000, "q26.32", "gneg"],
                [179000000, 182700000, "q26.33", "gpos75"],
                [182700000, 184500000, "q27.1", "gneg"],
                [184500000, 186000000, "q27.2", "gpos25"],
                [186000000, 187900000, "q27.3", "gneg"],
                [187900000, 192300000, "q28", "gpos75"],
                [192300000, 198022430, "q29", "gneg"]
            ],
            4: [
                [0, 4500000, "p16.3", "gneg"],
                [4500000, 6000000, "p16.2", "gpos25"],
                [6000000, 11300000, "p16.1", "gneg"],
                [11300000, 15200000, "p15.33", "gpos50"],
                [15200000, 17800000, "p15.32", "gneg"],
                [17800000, 21300000, "p15.31", "gpos75"],
                [21300000, 27700000, "p15.2", "gneg"],
                [27700000, 35800000, "p15.1", "gpos100"],
                [35800000, 41200000, "p14", "gneg"],
                [41200000, 44600000, "p13", "gpos50"],
                [44600000, 48200000, "p12", "gneg"],
                [48200000, 50400000, "p11", "acen"],
                [50400000, 52700000, "q11", "acen"],
                [52700000, 59500000, "q12", "gneg"],
                [59500000, 66600000, "q13.1", "gpos100"],
                [66600000, 70500000, "q13.2", "gneg"],
                [70500000, 76300000, "q13.3", "gpos75"],
                [76300000, 78900000, "q21.1", "gneg"],
                [78900000, 82400000, "q21.21", "gpos50"],
                [82400000, 84100000, "q21.22", "gneg"],
                [84100000, 86900000, "q21.23", "gpos25"],
                [86900000, 88000000, "q21.3", "gneg"],
                [88000000, 93700000, "q22.1", "gpos75"],
                [93700000, 95100000, "q22.2", "gneg"],
                [95100000, 98800000, "q22.3", "gpos75"],
                [98800000, 101100000, "q23", "gneg"],
                [101100000, 107700000, "q24", "gpos50"],
                [107700000, 114100000, "q25", "gneg"],
                [114100000, 120800000, "q26", "gpos75"],
                [120800000, 123800000, "q27", "gneg"],
                [123800000, 128800000, "q28.1", "gpos50"],
                [128800000, 131100000, "q28.2", "gneg"],
                [131100000, 139500000, "q28.3", "gpos100"],
                [139500000, 141500000, "q31.1", "gneg"],
                [141500000, 146800000, "q31.21", "gpos25"],
                [146800000, 148500000, "q31.22", "gneg"],
                [148500000, 151100000, "q31.23", "gpos25"],
                [151100000, 155600000, "q31.3", "gneg"],
                [155600000, 161800000, "q32.1", "gpos100"],
                [161800000, 164500000, "q32.2", "gneg"],
                [164500000, 170100000, "q32.3", "gpos100"],
                [170100000, 171900000, "q33", "gneg"],
                [171900000, 176300000, "q34.1", "gpos75"],
                [176300000, 177500000, "q34.2", "gneg"],
                [177500000, 183200000, "q34.3", "gpos100"],
                [183200000, 187100000, "q35.1", "gneg"],
                [187100000, 191154276, "q35.2", "gpos25"]
            ],
            5: [
                [0, 4500000, "p15.33", "gneg"],
                [4500000, 6300000, "p15.32", "gpos25"],
                [6300000, 9800000, "p15.31", "gneg"],
                [9800000, 15000000, "p15.2", "gpos50"],
                [15000000, 18400000, "p15.1", "gneg"],
                [18400000, 23300000, "p14.3", "gpos100"],
                [23300000, 24600000, "p14.2", "gneg"],
                [24600000, 28900000, "p14.1", "gpos100"],
                [28900000, 33800000, "p13.3", "gneg"],
                [33800000, 38400000, "p13.2", "gpos25"],
                [38400000, 42500000, "p13.1", "gneg"],
                [42500000, 46100000, "p12", "gpos50"],
                [46100000, 48400000, "p11", "acen"],
                [48400000, 50700000, "q11.1", "acen"],
                [50700000, 58900000, "q11.2", "gneg"],
                [58900000, 62900000, "q12.1", "gpos75"],
                [62900000, 63200000, "q12.2", "gneg"],
                [63200000, 66700000, "q12.3", "gpos75"],
                [66700000, 68400000, "q13.1", "gneg"],
                [68400000, 73300000, "q13.2", "gpos50"],
                [73300000, 76900000, "q13.3", "gneg"],
                [76900000, 81400000, "q14.1", "gpos50"],
                [81400000, 82800000, "q14.2", "gneg"],
                [82800000, 92300000, "q14.3", "gpos100"],
                [92300000, 98200000, "q15", "gneg"],
                [98200000, 102800000, "q21.1", "gpos100"],
                [102800000, 104500000, "q21.2", "gneg"],
                [104500000, 109600000, "q21.3", "gpos100"],
                [109600000, 111500000, "q22.1", "gneg"],
                [111500000, 113100000, "q22.2", "gpos50"],
                [113100000, 115200000, "q22.3", "gneg"],
                [115200000, 121400000, "q23.1", "gpos100"],
                [121400000, 127300000, "q23.2", "gneg"],
                [127300000, 130600000, "q23.3", "gpos100"],
                [130600000, 136200000, "q31.1", "gneg"],
                [136200000, 139500000, "q31.2", "gpos25"],
                [139500000, 144500000, "q31.3", "gneg"],
                [144500000, 149800000, "q32", "gpos75"],
                [149800000, 152700000, "q33.1", "gneg"],
                [152700000, 155700000, "q33.2", "gpos50"],
                [155700000, 159900000, "q33.3", "gneg"],
                [159900000, 168500000, "q34", "gpos100"],
                [168500000, 172800000, "q35.1", "gneg"],
                [172800000, 176600000, "q35.2", "gpos25"],
                [176600000, 180915260, "q35.3", "gneg"]
            ],
            6: [
                [0, 2300000, "p25.3", "gneg"],
                [2300000, 4200000, "p25.2", "gpos25"],
                [4200000, 7100000, "p25.1", "gneg"],
                [7100000, 10600000, "p24.3", "gpos50"],
                [10600000, 11600000, "p24.2", "gneg"],
                [11600000, 13400000, "p24.1", "gpos25"],
                [13400000, 15200000, "p23", "gneg"],
                [15200000, 25200000, "p22.3", "gpos75"],
                [25200000, 27000000, "p22.2", "gneg"],
                [27000000, 30400000, "p22.1", "gpos50"],
                [30400000, 32100000, "p21.33", "gneg"],
                [32100000, 33500000, "p21.32", "gpos25"],
                [33500000, 36600000, "p21.31", "gneg"],
                [36600000, 40500000, "p21.2", "gpos25"],
                [40500000, 46200000, "p21.1", "gneg"],
                [46200000, 51800000, "p12.3", "gpos100"],
                [51800000, 52900000, "p12.2", "gneg"],
                [52900000, 57000000, "p12.1", "gpos100"],
                [57000000, 58700000, "p11.2", "gneg"],
                [58700000, 61000000, "p11.1", "acen"],
                [61000000, 63300000, "q11.1", "acen"],
                [63300000, 63400000, "q11.2", "gneg"],
                [63400000, 70000000, "q12", "gpos100"],
                [70000000, 75900000, "q13", "gneg"],
                [75900000, 83900000, "q14.1", "gpos50"],
                [83900000, 84900000, "q14.2", "gneg"],
                [84900000, 88000000, "q14.3", "gpos50"],
                [88000000, 93100000, "q15", "gneg"],
                [93100000, 99500000, "q16.1", "gpos100"],
                [99500000, 100600000, "q16.2", "gneg"],
                [100600000, 105500000, "q16.3", "gpos100"],
                [105500000, 114600000, "q21", "gneg"],
                [114600000, 118300000, "q22.1", "gpos75"],
                [118300000, 118500000, "q22.2", "gneg"],
                [118500000, 126100000, "q22.31", "gpos100"],
                [126100000, 127100000, "q22.32", "gneg"],
                [127100000, 130300000, "q22.33", "gpos75"],
                [130300000, 131200000, "q23.1", "gneg"],
                [131200000, 135200000, "q23.2", "gpos50"],
                [135200000, 139000000, "q23.3", "gneg"],
                [139000000, 142800000, "q24.1", "gpos75"],
                [142800000, 145600000, "q24.2", "gneg"],
                [145600000, 149000000, "q24.3", "gpos75"],
                [149000000, 152500000, "q25.1", "gneg"],
                [152500000, 155500000, "q25.2", "gpos50"],
                [155500000, 161000000, "q25.3", "gneg"],
                [161000000, 164500000, "q26", "gpos50"],
                [164500000, 171115067, "q27", "gneg"]
            ],
            7: [
                [0, 2800000, "p22.3", "gneg"],
                [2800000, 4500000, "p22.2", "gpos25"],
                [4500000, 7300000, "p22.1", "gneg"],
                [7300000, 13800000, "p21.3", "gpos100"],
                [13800000, 16500000, "p21.2", "gneg"],
                [16500000, 20900000, "p21.1", "gpos100"],
                [20900000, 25500000, "p15.3", "gneg"],
                [25500000, 28000000, "p15.2", "gpos50"],
                [28000000, 28800000, "p15.1", "gneg"],
                [28800000, 35000000, "p14.3", "gpos75"],
                [35000000, 37200000, "p14.2", "gneg"],
                [37200000, 43300000, "p14.1", "gpos75"],
                [43300000, 45400000, "p13", "gneg"],
                [45400000, 49000000, "p12.3", "gpos75"],
                [49000000, 50500000, "p12.2", "gneg"],
                [50500000, 54000000, "p12.1", "gpos75"],
                [54000000, 58000000, "p11.2", "gneg"],
                [58000000, 59900000, "p11.1", "acen"],
                [59900000, 61700000, "q11.1", "acen"],
                [61700000, 67000000, "q11.21", "gneg"],
                [67000000, 72200000, "q11.22", "gpos50"],
                [72200000, 77500000, "q11.23", "gneg"],
                [77500000, 86400000, "q21.11", "gpos100"],
                [86400000, 88200000, "q21.12", "gneg"],
                [88200000, 91100000, "q21.13", "gpos75"],
                [91100000, 92800000, "q21.2", "gneg"],
                [92800000, 98000000, "q21.3", "gpos75"],
                [98000000, 103800000, "q22.1", "gneg"],
                [103800000, 104500000, "q22.2", "gpos50"],
                [104500000, 107400000, "q22.3", "gneg"],
                [107400000, 114600000, "q31.1", "gpos75"],
                [114600000, 117400000, "q31.2", "gneg"],
                [117400000, 121100000, "q31.31", "gpos75"],
                [121100000, 123800000, "q31.32", "gneg"],
                [123800000, 127100000, "q31.33", "gpos75"],
                [127100000, 129200000, "q32.1", "gneg"],
                [129200000, 130400000, "q32.2", "gpos25"],
                [130400000, 132600000, "q32.3", "gneg"],
                [132600000, 138200000, "q33", "gpos50"],
                [138200000, 143100000, "q34", "gneg"],
                [143100000, 147900000, "q35", "gpos75"],
                [147900000, 152600000, "q36.1", "gneg"],
                [152600000, 155100000, "q36.2", "gpos25"],
                [155100000, 159138663, "q36.3", "gneg"]
            ],
            8: [
                [0, 2200000, "p23.3", "gneg"],
                [2200000, 6200000, "p23.2", "gpos75"],
                [6200000, 12700000, "p23.1", "gneg"],
                [12700000, 19000000, "p22", "gpos100"],
                [19000000, 23300000, "p21.3", "gneg"],
                [23300000, 27400000, "p21.2", "gpos50"],
                [27400000, 28800000, "p21.1", "gneg"],
                [28800000, 36500000, "p12", "gpos75"],
                [36500000, 38300000, "p11.23", "gneg"],
                [38300000, 39700000, "p11.22", "gpos25"],
                [39700000, 43100000, "p11.21", "gneg"],
                [43100000, 45600000, "p11.1", "acen"],
                [45600000, 48100000, "q11.1", "acen"],
                [48100000, 52200000, "q11.21", "gneg"],
                [52200000, 52600000, "q11.22", "gpos75"],
                [52600000, 55500000, "q11.23", "gneg"],
                [55500000, 61600000, "q12.1", "gpos50"],
                [61600000, 62200000, "q12.2", "gneg"],
                [62200000, 66000000, "q12.3", "gpos50"],
                [66000000, 68000000, "q13.1", "gneg"],
                [68000000, 70500000, "q13.2", "gpos50"],
                [70500000, 73900000, "q13.3", "gneg"],
                [73900000, 78300000, "q21.11", "gpos100"],
                [78300000, 80100000, "q21.12", "gneg"],
                [80100000, 84600000, "q21.13", "gpos75"],
                [84600000, 86900000, "q21.2", "gneg"],
                [86900000, 93300000, "q21.3", "gpos100"],
                [93300000, 99000000, "q22.1", "gneg"],
                [99000000, 101600000, "q22.2", "gpos25"],
                [101600000, 106200000, "q22.3", "gneg"],
                [106200000, 110500000, "q23.1", "gpos75"],
                [110500000, 112100000, "q23.2", "gneg"],
                [112100000, 117700000, "q23.3", "gpos100"],
                [117700000, 119200000, "q24.11", "gneg"],
                [119200000, 122500000, "q24.12", "gpos50"],
                [122500000, 127300000, "q24.13", "gneg"],
                [127300000, 131500000, "q24.21", "gpos50"],
                [131500000, 136400000, "q24.22", "gneg"],
                [136400000, 139900000, "q24.23", "gpos75"],
                [139900000, 146364022, "q24.3", "gneg"]
            ],
            9: [
                [0, 2200000, "p24.3", "gneg"],
                [2200000, 4600000, "p24.2", "gpos25"],
                [4600000, 9000000, "p24.1", "gneg"],
                [9000000, 14200000, "p23", "gpos75"],
                [14200000, 16600000, "p22.3", "gneg"],
                [16600000, 18500000, "p22.2", "gpos25"],
                [18500000, 19900000, "p22.1", "gneg"],
                [19900000, 25600000, "p21.3", "gpos100"],
                [25600000, 28000000, "p21.2", "gneg"],
                [28000000, 33200000, "p21.1", "gpos100"],
                [33200000, 36300000, "p13.3", "gneg"],
                [36300000, 38400000, "p13.2", "gpos25"],
                [38400000, 41000000, "p13.1", "gneg"],
                [41000000, 43600000, "p12", "gpos50"],
                [43600000, 47300000, "p11.2", "gneg"],
                [47300000, 49000000, "p11.1", "acen"],
                [49000000, 50700000, "q11", "acen"],
                [50700000, 65900000, "q12", "gvar"],
                [65900000, 68700000, "q13", "gneg"],
                [68700000, 72200000, "q21.11", "gpos25"],
                [72200000, 74000000, "q21.12", "gneg"],
                [74000000, 79200000, "q21.13", "gpos50"],
                [79200000, 81100000, "q21.2", "gneg"],
                [81100000, 84100000, "q21.31", "gpos50"],
                [84100000, 86900000, "q21.32", "gneg"],
                [86900000, 90400000, "q21.33", "gpos50"],
                [90400000, 91800000, "q22.1", "gneg"],
                [91800000, 93900000, "q22.2", "gpos25"],
                [93900000, 96600000, "q22.31", "gneg"],
                [96600000, 99300000, "q22.32", "gpos25"],
                [99300000, 102600000, "q22.33", "gneg"],
                [102600000, 108200000, "q31.1", "gpos100"],
                [108200000, 111300000, "q31.2", "gneg"],
                [111300000, 114900000, "q31.3", "gpos25"],
                [114900000, 117700000, "q32", "gneg"],
                [117700000, 122500000, "q33.1", "gpos75"],
                [122500000, 125800000, "q33.2", "gneg"],
                [125800000, 130300000, "q33.3", "gpos25"],
                [130300000, 133500000, "q34.11", "gneg"],
                [133500000, 134000000, "q34.12", "gpos25"],
                [134000000, 135900000, "q34.13", "gneg"],
                [135900000, 137400000, "q34.2", "gpos25"],
                [137400000, 141213431, "q34.3", "gneg"]
            ],
            10: [
                [0, 3000000, "p15.3", "gneg"],
                [3000000, 3800000, "p15.2", "gpos25"],
                [3800000, 6600000, "p15.1", "gneg"],
                [6600000, 12200000, "p14", "gpos75"],
                [12200000, 17300000, "p13", "gneg"],
                [17300000, 18600000, "p12.33", "gpos75"],
                [18600000, 18700000, "p12.32", "gneg"],
                [18700000, 22600000, "p12.31", "gpos75"],
                [22600000, 24600000, "p12.2", "gneg"],
                [24600000, 29600000, "p12.1", "gpos50"],
                [29600000, 31300000, "p11.23", "gneg"],
                [31300000, 34400000, "p11.22", "gpos25"],
                [34400000, 38000000, "p11.21", "gneg"],
                [38000000, 40200000, "p11.1", "acen"],
                [40200000, 42300000, "q11.1", "acen"],
                [42300000, 46100000, "q11.21", "gneg"],
                [46100000, 49900000, "q11.22", "gpos25"],
                [49900000, 52900000, "q11.23", "gneg"],
                [52900000, 61200000, "q21.1", "gpos100"],
                [61200000, 64500000, "q21.2", "gneg"],
                [64500000, 70600000, "q21.3", "gpos100"],
                [70600000, 74900000, "q22.1", "gneg"],
                [74900000, 77700000, "q22.2", "gpos50"],
                [77700000, 82000000, "q22.3", "gneg"],
                [82000000, 87900000, "q23.1", "gpos100"],
                [87900000, 89500000, "q23.2", "gneg"],
                [89500000, 92900000, "q23.31", "gpos75"],
                [92900000, 94100000, "q23.32", "gneg"],
                [94100000, 97000000, "q23.33", "gpos50"],
                [97000000, 99300000, "q24.1", "gneg"],
                [99300000, 101900000, "q24.2", "gpos50"],
                [101900000, 103000000, "q24.31", "gneg"],
                [103000000, 104900000, "q24.32", "gpos25"],
                [104900000, 105800000, "q24.33", "gneg"],
                [105800000, 111900000, "q25.1", "gpos100"],
                [111900000, 114900000, "q25.2", "gneg"],
                [114900000, 119100000, "q25.3", "gpos75"],
                [119100000, 121700000, "q26.11", "gneg"],
                [121700000, 123100000, "q26.12", "gpos50"],
                [123100000, 127500000, "q26.13", "gneg"],
                [127500000, 130600000, "q26.2", "gpos50"],
                [130600000, 135534747, "q26.3", "gneg"]
            ],
            11: [
                [0, 2800000, "p15.5", "gneg"],
                [2800000, 10700000, "p15.4", "gpos50"],
                [10700000, 12700000, "p15.3", "gneg"],
                [12700000, 16200000, "p15.2", "gpos50"],
                [16200000, 21700000, "p15.1", "gneg"],
                [21700000, 26100000, "p14.3", "gpos100"],
                [26100000, 27200000, "p14.2", "gneg"],
                [27200000, 31000000, "p14.1", "gpos75"],
                [31000000, 36400000, "p13", "gneg"],
                [36400000, 43500000, "p12", "gpos100"],
                [43500000, 48800000, "p11.2", "gneg"],
                [48800000, 51600000, "p11.12", "gpos75"],
                [51600000, 53700000, "p11.11", "acen"],
                [53700000, 55700000, "q11", "acen"],
                [55700000, 59900000, "q12.1", "gpos75"],
                [59900000, 61700000, "q12.2", "gneg"],
                [61700000, 63400000, "q12.3", "gpos25"],
                [63400000, 65900000, "q13.1", "gneg"],
                [65900000, 68400000, "q13.2", "gpos25"],
                [68400000, 70400000, "q13.3", "gneg"],
                [70400000, 75200000, "q13.4", "gpos50"],
                [75200000, 77100000, "q13.5", "gneg"],
                [77100000, 85600000, "q14.1", "gpos100"],
                [85600000, 88300000, "q14.2", "gneg"],
                [88300000, 92800000, "q14.3", "gpos100"],
                [92800000, 97200000, "q21", "gneg"],
                [97200000, 102100000, "q22.1", "gpos100"],
                [102100000, 102900000, "q22.2", "gneg"],
                [102900000, 110400000, "q22.3", "gpos100"],
                [110400000, 112500000, "q23.1", "gneg"],
                [112500000, 114500000, "q23.2", "gpos50"],
                [114500000, 121200000, "q23.3", "gneg"],
                [121200000, 123900000, "q24.1", "gpos50"],
                [123900000, 127800000, "q24.2", "gneg"],
                [127800000, 130800000, "q24.3", "gpos50"],
                [130800000, 135006516, "q25", "gneg"]
            ],
            12: [
                [0, 3300000, "p13.33", "gneg"],
                [3300000, 5400000, "p13.32", "gpos25"],
                [5400000, 10100000, "p13.31", "gneg"],
                [10100000, 12800000, "p13.2", "gpos75"],
                [12800000, 14800000, "p13.1", "gneg"],
                [14800000, 20000000, "p12.3", "gpos100"],
                [20000000, 21300000, "p12.2", "gneg"],
                [21300000, 26500000, "p12.1", "gpos100"],
                [26500000, 27800000, "p11.23", "gneg"],
                [27800000, 30700000, "p11.22", "gpos50"],
                [30700000, 33300000, "p11.21", "gneg"],
                [33300000, 35800000, "p11.1", "acen"],
                [35800000, 38200000, "q11", "acen"],
                [38200000, 46400000, "q12", "gpos100"],
                [46400000, 49100000, "q13.11", "gneg"],
                [49100000, 51500000, "q13.12", "gpos25"],
                [51500000, 54900000, "q13.13", "gneg"],
                [54900000, 56600000, "q13.2", "gpos25"],
                [56600000, 58100000, "q13.3", "gneg"],
                [58100000, 63100000, "q14.1", "gpos75"],
                [63100000, 65100000, "q14.2", "gneg"],
                [65100000, 67700000, "q14.3", "gpos50"],
                [67700000, 71500000, "q15", "gneg"],
                [71500000, 75700000, "q21.1", "gpos75"],
                [75700000, 80300000, "q21.2", "gneg"],
                [80300000, 86700000, "q21.31", "gpos100"],
                [86700000, 89000000, "q21.32", "gneg"],
                [89000000, 92600000, "q21.33", "gpos100"],
                [92600000, 96200000, "q22", "gneg"],
                [96200000, 101600000, "q23.1", "gpos75"],
                [101600000, 103800000, "q23.2", "gneg"],
                [103800000, 109000000, "q23.3", "gpos50"],
                [109000000, 111700000, "q24.11", "gneg"],
                [111700000, 112300000, "q24.12", "gpos25"],
                [112300000, 114300000, "q24.13", "gneg"],
                [114300000, 116800000, "q24.21", "gpos50"],
                [116800000, 118100000, "q24.22", "gneg"],
                [118100000, 120700000, "q24.23", "gpos50"],
                [120700000, 125900000, "q24.31", "gneg"],
                [125900000, 129300000, "q24.32", "gpos50"],
                [129300000, 133851895, "q24.33", "gneg"]
            ],
            13: [
                [0, 4500000, "p13", "gvar"],
                [4500000, 10000000, "p12", "stalk"],
                [10000000, 16300000, "p11.2", "gvar"],
                [16300000, 17900000, "p11.1", "acen"],
                [17900000, 19500000, "q11", "acen"],
                [19500000, 23300000, "q12.11", "gneg"],
                [23300000, 25500000, "q12.12", "gpos25"],
                [25500000, 27800000, "q12.13", "gneg"],
                [27800000, 28900000, "q12.2", "gpos25"],
                [28900000, 32200000, "q12.3", "gneg"],
                [32200000, 34000000, "q13.1", "gpos50"],
                [34000000, 35500000, "q13.2", "gneg"],
                [35500000, 40100000, "q13.3", "gpos75"],
                [40100000, 45200000, "q14.11", "gneg"],
                [45200000, 45800000, "q14.12", "gpos25"],
                [45800000, 47300000, "q14.13", "gneg"],
                [47300000, 50900000, "q14.2", "gpos50"],
                [50900000, 55300000, "q14.3", "gneg"],
                [55300000, 59600000, "q21.1", "gpos100"],
                [59600000, 62300000, "q21.2", "gneg"],
                [62300000, 65700000, "q21.31", "gpos75"],
                [65700000, 68600000, "q21.32", "gneg"],
                [68600000, 73300000, "q21.33", "gpos100"],
                [73300000, 75400000, "q22.1", "gneg"],
                [75400000, 77200000, "q22.2", "gpos50"],
                [77200000, 79000000, "q22.3", "gneg"],
                [79000000, 87700000, "q31.1", "gpos100"],
                [87700000, 90000000, "q31.2", "gneg"],
                [90000000, 95000000, "q31.3", "gpos100"],
                [95000000, 98200000, "q32.1", "gneg"],
                [98200000, 99300000, "q32.2", "gpos25"],
                [99300000, 101700000, "q32.3", "gneg"],
                [101700000, 104800000, "q33.1", "gpos100"],
                [104800000, 107000000, "q33.2", "gneg"],
                [107000000, 110300000, "q33.3", "gpos100"],
                [110300000, 115169878, "q34", "gneg"]
            ],
            14: [
                [0, 3700000, "p13", "gvar"],
                [3700000, 8100000, "p12", "stalk"],
                [8100000, 16100000, "p11.2", "gvar"],
                [16100000, 17600000, "p11.1", "acen"],
                [17600000, 19100000, "q11.1", "acen"],
                [19100000, 24600000, "q11.2", "gneg"],
                [24600000, 33300000, "q12", "gpos100"],
                [33300000, 35300000, "q13.1", "gneg"],
                [35300000, 36600000, "q13.2", "gpos50"],
                [36600000, 37800000, "q13.3", "gneg"],
                [37800000, 43500000, "q21.1", "gpos100"],
                [43500000, 47200000, "q21.2", "gneg"],
                [47200000, 50900000, "q21.3", "gpos100"],
                [50900000, 54100000, "q22.1", "gneg"],
                [54100000, 55500000, "q22.2", "gpos25"],
                [55500000, 58100000, "q22.3", "gneg"],
                [58100000, 62100000, "q23.1", "gpos75"],
                [62100000, 64800000, "q23.2", "gneg"],
                [64800000, 67900000, "q23.3", "gpos50"],
                [67900000, 70200000, "q24.1", "gneg"],
                [70200000, 73800000, "q24.2", "gpos50"],
                [73800000, 79300000, "q24.3", "gneg"],
                [79300000, 83600000, "q31.1", "gpos100"],
                [83600000, 84900000, "q31.2", "gneg"],
                [84900000, 89800000, "q31.3", "gpos100"],
                [89800000, 91900000, "q32.11", "gneg"],
                [91900000, 94700000, "q32.12", "gpos25"],
                [94700000, 96300000, "q32.13", "gneg"],
                [96300000, 101400000, "q32.2", "gpos50"],
                [101400000, 103200000, "q32.31", "gneg"],
                [103200000, 104000000, "q32.32", "gpos50"],
                [104000000, 107349540, "q32.33", "gneg"]
            ],
            15: [
                [0, 3900000, "p13", "gvar"],
                [3900000, 8700000, "p12", "stalk"],
                [8700000, 15800000, "p11.2", "gvar"],
                [15800000, 19000000, "p11.1", "acen"],
                [19000000, 20700000, "q11.1", "acen"],
                [20700000, 25700000, "q11.2", "gneg"],
                [25700000, 28100000, "q12", "gpos50"],
                [28100000, 30300000, "q13.1", "gneg"],
                [30300000, 31200000, "q13.2", "gpos50"],
                [31200000, 33600000, "q13.3", "gneg"],
                [33600000, 40100000, "q14", "gpos75"],
                [40100000, 42800000, "q15.1", "gneg"],
                [42800000, 43600000, "q15.2", "gpos25"],
                [43600000, 44800000, "q15.3", "gneg"],
                [44800000, 49500000, "q21.1", "gpos75"],
                [49500000, 52900000, "q21.2", "gneg"],
                [52900000, 59100000, "q21.3", "gpos75"],
                [59100000, 59300000, "q22.1", "gneg"],
                [59300000, 63700000, "q22.2", "gpos25"],
                [63700000, 67200000, "q22.31", "gneg"],
                [67200000, 67300000, "q22.32", "gpos25"],
                [67300000, 67500000, "q22.33", "gneg"],
                [67500000, 72700000, "q23", "gpos25"],
                [72700000, 75200000, "q24.1", "gneg"],
                [75200000, 76600000, "q24.2", "gpos25"],
                [76600000, 78300000, "q24.3", "gneg"],
                [78300000, 81700000, "q25.1", "gpos50"],
                [81700000, 85200000, "q25.2", "gneg"],
                [85200000, 89100000, "q25.3", "gpos50"],
                [89100000, 94300000, "q26.1", "gneg"],
                [94300000, 98500000, "q26.2", "gpos50"],
                [98500000, 102531392, "q26.3", "gneg"]
            ],
            16: [
                [0, 7900000, "p13.3", "gneg"],
                [7900000, 10500000, "p13.2", "gpos50"],
                [10500000, 12600000, "p13.13", "gneg"],
                [12600000, 14800000, "p13.12", "gpos50"],
                [14800000, 16800000, "p13.11", "gneg"],
                [16800000, 21200000, "p12.3", "gpos50"],
                [21200000, 24200000, "p12.2", "gneg"],
                [24200000, 28100000, "p12.1", "gpos50"],
                [28100000, 34600000, "p11.2", "gneg"],
                [34600000, 36600000, "p11.1", "acen"],
                [36600000, 38600000, "q11.1", "acen"],
                [38600000, 47000000, "q11.2", "gvar"],
                [47000000, 52600000, "q12.1", "gneg"],
                [52600000, 56700000, "q12.2", "gpos50"],
                [56700000, 57400000, "q13", "gneg"],
                [57400000, 66700000, "q21", "gpos100"],
                [66700000, 70800000, "q22.1", "gneg"],
                [70800000, 72900000, "q22.2", "gpos50"],
                [72900000, 74100000, "q22.3", "gneg"],
                [74100000, 79200000, "q23.1", "gpos75"],
                [79200000, 81700000, "q23.2", "gneg"],
                [81700000, 84200000, "q23.3", "gpos50"],
                [84200000, 87100000, "q24.1", "gneg"],
                [87100000, 88700000, "q24.2", "gpos25"],
                [88700000, 90354753, "q24.3", "gneg"]
            ],
            17: [
                [0, 3300000, "p13.3", "gneg"],
                [3300000, 6500000, "p13.2", "gpos50"],
                [6500000, 10700000, "p13.1", "gneg"],
                [10700000, 16000000, "p12", "gpos75"],
                [16000000, 22200000, "p11.2", "gneg"],
                [22200000, 24000000, "p11.1", "acen"],
                [24000000, 25800000, "q11.1", "acen"],
                [25800000, 31800000, "q11.2", "gneg"],
                [31800000, 38100000, "q12", "gpos50"],
                [38100000, 38400000, "q21.1", "gneg"],
                [38400000, 40900000, "q21.2", "gpos25"],
                [40900000, 44900000, "q21.31", "gneg"],
                [44900000, 47400000, "q21.32", "gpos25"],
                [47400000, 50200000, "q21.33", "gneg"],
                [50200000, 57600000, "q22", "gpos75"],
                [57600000, 58300000, "q23.1", "gneg"],
                [58300000, 61100000, "q23.2", "gpos75"],
                [61100000, 62600000, "q23.3", "gneg"],
                [62600000, 64200000, "q24.1", "gpos50"],
                [64200000, 67100000, "q24.2", "gneg"],
                [67100000, 70900000, "q24.3", "gpos75"],
                [70900000, 74800000, "q25.1", "gneg"],
                [74800000, 75300000, "q25.2", "gpos25"],
                [75300000, 81195210, "q25.3", "gneg"]
            ],
            18: [
                [0, 2900000, "p11.32", "gneg"],
                [2900000, 7100000, "p11.31", "gpos50"],
                [7100000, 8500000, "p11.23", "gneg"],
                [8500000, 10900000, "p11.22", "gpos25"],
                [10900000, 15400000, "p11.21", "gneg"],
                [15400000, 17200000, "p11.1", "acen"],
                [17200000, 19000000, "q11.1", "acen"],
                [19000000, 25000000, "q11.2", "gneg"],
                [25000000, 32700000, "q12.1", "gpos100"],
                [32700000, 37200000, "q12.2", "gneg"],
                [37200000, 43500000, "q12.3", "gpos75"],
                [43500000, 48200000, "q21.1", "gneg"],
                [48200000, 53800000, "q21.2", "gpos75"],
                [53800000, 56200000, "q21.31", "gneg"],
                [56200000, 59000000, "q21.32", "gpos50"],
                [59000000, 61600000, "q21.33", "gneg"],
                [61600000, 66800000, "q22.1", "gpos100"],
                [66800000, 68700000, "q22.2", "gneg"],
                [68700000, 73100000, "q22.3", "gpos25"],
                [73100000, 78077248, "q23", "gneg"]
            ],
            19: [
                [0, 6900000, "p13.3", "gneg"],
                [6900000, 13900000, "p13.2", "gpos25"],
                [13900000, 14000000, "p13.13", "gneg"],
                [14000000, 16300000, "p13.12", "gpos25"],
                [16300000, 20000000, "p13.11", "gneg"],
                [20000000, 24400000, "p12", "gvar"],
                [24400000, 26500000, "p11", "acen"],
                [26500000, 28600000, "q11", "acen"],
                [28600000, 32400000, "q12", "gvar"],
                [32400000, 35500000, "q13.11", "gneg"],
                [35500000, 38300000, "q13.12", "gpos25"],
                [38300000, 38700000, "q13.13", "gneg"],
                [38700000, 43400000, "q13.2", "gpos25"],
                [43400000, 45200000, "q13.31", "gneg"],
                [45200000, 48000000, "q13.32", "gpos25"],
                [48000000, 51400000, "q13.33", "gneg"],
                [51400000, 53600000, "q13.41", "gpos25"],
                [53600000, 56300000, "q13.42", "gneg"],
                [56300000, 59128983, "q13.43", "gpos25"]
            ],
            20: [
                [0, 5100000, "p13", "gneg"],
                [5100000, 9200000, "p12.3", "gpos75"],
                [9200000, 12100000, "p12.2", "gneg"],
                [12100000, 17900000, "p12.1", "gpos75"],
                [17900000, 21300000, "p11.23", "gneg"],
                [21300000, 22300000, "p11.22", "gpos25"],
                [22300000, 25600000, "p11.21", "gneg"],
                [25600000, 27500000, "p11.1", "acen"],
                [27500000, 29400000, "q11.1", "acen"],
                [29400000, 32100000, "q11.21", "gneg"],
                [32100000, 34400000, "q11.22", "gpos25"],
                [34400000, 37600000, "q11.23", "gneg"],
                [37600000, 41700000, "q12", "gpos75"],
                [41700000, 42100000, "q13.11", "gneg"],
                [42100000, 46400000, "q13.12", "gpos25"],
                [46400000, 49800000, "q13.13", "gneg"],
                [49800000, 55000000, "q13.2", "gpos75"],
                [55000000, 56500000, "q13.31", "gneg"],
                [56500000, 58400000, "q13.32", "gpos50"],
                [58400000, 63025520, "q13.33", "gneg"]
            ],
            21: [
                [0, 2800000, "p13", "gvar"],
                [2800000, 6800000, "p12", "stalk"],
                [6800000, 10900000, "p11.2", "gvar"],
                [10900000, 13200000, "p11.1", "acen"],
                [13200000, 14300000, "q11.1", "acen"],
                [14300000, 16400000, "q11.2", "gneg"],
                [16400000, 24000000, "q21.1", "gpos100"],
                [24000000, 26800000, "q21.2", "gneg"],
                [26800000, 31500000, "q21.3", "gpos75"],
                [31500000, 35800000, "q22.11", "gneg"],
                [35800000, 37800000, "q22.12", "gpos50"],
                [37800000, 39700000, "q22.13", "gneg"],
                [39700000, 42600000, "q22.2", "gpos50"],
                [42600000, 48129895, "q22.3", "gneg"]
            ],
            22: [
                [0, 3800000, "p13", "gvar"],
                [3800000, 8300000, "p12", "stalk"],
                [8300000, 12200000, "p11.2", "gvar"],
                [12200000, 14700000, "p11.1", "acen"],
                [14700000, 17900000, "q11.1", "acen"],
                [17900000, 22200000, "q11.21", "gneg"],
                [22200000, 23500000, "q11.22", "gpos25"],
                [23500000, 25900000, "q11.23", "gneg"],
                [25900000, 29600000, "q12.1", "gpos50"],
                [29600000, 32200000, "q12.2", "gneg"],
                [32200000, 37600000, "q12.3", "gpos50"],
                [37600000, 41000000, "q13.1", "gneg"],
                [41000000, 44200000, "q13.2", "gpos50"],
                [44200000, 48400000, "q13.31", "gneg"],
                [48400000, 49400000, "q13.32", "gpos50"],
                [49400000, 51304566, "q13.33", "gneg"]
            ],
            X: [
                [0, 4300000, "p22.33", "gneg"],
                [4300000, 6000000, "p22.32", "gpos50"],
                [6000000, 9500000, "p22.31", "gneg"],
                [9500000, 17100000, "p22.2", "gpos50"],
                [17100000, 19300000, "p22.13", "gneg"],
                [19300000, 21900000, "p22.12", "gpos50"],
                [21900000, 24900000, "p22.11", "gneg"],
                [24900000, 29300000, "p21.3", "gpos100"],
                [29300000, 31500000, "p21.2", "gneg"],
                [31500000, 37600000, "p21.1", "gpos100"],
                [37600000, 42400000, "p11.4", "gneg"],
                [42400000, 46400000, "p11.3", "gpos75"],
                [46400000, 49800000, "p11.23", "gneg"],
                [49800000, 54800000, "p11.22", "gpos25"],
                [54800000, 58100000, "p11.21", "gneg"],
                [58100000, 60600000, "p11.1", "acen"],
                [60600000, 63000000, "q11.1", "acen"],
                [63000000, 64600000, "q11.2", "gneg"],
                [64600000, 67800000, "q12", "gpos50"],
                [67800000, 71800000, "q13.1", "gneg"],
                [71800000, 73900000, "q13.2", "gpos50"],
                [73900000, 76000000, "q13.3", "gneg"],
                [76000000, 84600000, "q21.1", "gpos100"],
                [84600000, 86200000, "q21.2", "gneg"],
                [86200000, 91800000, "q21.31", "gpos100"],
                [91800000, 93500000, "q21.32", "gneg"],
                [93500000, 98300000, "q21.33", "gpos75"],
                [98300000, 102600000, "q22.1", "gneg"],
                [102600000, 103700000, "q22.2", "gpos50"],
                [103700000, 108700000, "q22.3", "gneg"],
                [108700000, 116500000, "q23", "gpos75"],
                [116500000, 120900000, "q24", "gneg"],
                [120900000, 128700000, "q25", "gpos100"],
                [128700000, 130400000, "q26.1", "gneg"],
                [130400000, 133600000, "q26.2", "gpos25"],
                [133600000, 138000000, "q26.3", "gneg"],
                [138000000, 140300000, "q27.1", "gpos75"],
                [140300000, 142100000, "q27.2", "gneg"],
                [142100000, 147100000, "q27.3", "gpos100"],
                [147100000, 155270560, "q28", "gneg"]
            ],
            Y: [
                [0, 2500000, "p11.32", "gneg"],
                [2500000, 3000000, "p11.31", "gpos50"],
                [3000000, 11600000, "p11.2", "gneg"],
                [11600000, 12500000, "p11.1", "acen"],
                [12500000, 13400000, "q11.1", "acen"],
                [13400000, 15100000, "q11.21", "gneg"],
                [15100000, 19800000, "q11.221", "gpos50"],
                [19800000, 22100000, "q11.222", "gneg"],
                [22100000, 26200000, "q11.223", "gpos50"],
                [26200000, 28800000, "q11.23", "gneg"],
                [28800000, 59373566, "q12", "gvar"]
            ]
        }
    },
    hg38: {
        columns: ["start", "end", "name", "stain"],
        order: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, "X", "Y"],
        data: {
            1: [
                [0, 2300000, "p36.33", "gneg"],
                [2300000, 5300000, "p36.32", "gpos25"],
                [5300000, 7100000, "p36.31", "gneg"],
                [7100000, 9100000, "p36.23", "gpos25"],
                [9100000, 12500000, "p36.22", "gneg"],
                [12500000, 15900000, "p36.21", "gpos50"],
                [15900000, 20100000, "p36.13", "gneg"],
                [20100000, 23600000, "p36.12", "gpos25"],
                [23600000, 27600000, "p36.11", "gneg"],
                [27600000, 29900000, "p35.3", "gpos25"],
                [29900000, 32300000, "p35.2", "gneg"],
                [32300000, 34300000, "p35.1", "gpos25"],
                [34300000, 39600000, "p34.3", "gneg"],
                [39600000, 43700000, "p34.2", "gpos25"],
                [43700000, 46300000, "p34.1", "gneg"],
                [46300000, 50200000, "p33", "gpos75"],
                [50200000, 55600000, "p32.3", "gneg"],
                [55600000, 58500000, "p32.2", "gpos50"],
                [58500000, 60800000, "p32.1", "gneg"],
                [60800000, 68500000, "p31.3", "gpos50"],
                [68500000, 69300000, "p31.2", "gneg"],
                [69300000, 84400000, "p31.1", "gpos100"],
                [84400000, 87900000, "p22.3", "gneg"],
                [87900000, 91500000, "p22.2", "gpos75"],
                [91500000, 94300000, "p22.1", "gneg"],
                [94300000, 99300000, "p21.3", "gpos75"],
                [99300000, 101800000, "p21.2", "gneg"],
                [101800000, 106700000, "p21.1", "gpos100"],
                [106700000, 111200000, "p13.3", "gneg"],
                [111200000, 115500000, "p13.2", "gpos50"],
                [115500000, 117200000, "p13.1", "gneg"],
                [117200000, 120400000, "p12", "gpos50"],
                [120400000, 121700000, "p11.2", "gneg"],
                [121700000, 123400000, "p11.1", "acen"],
                [123400000, 125100000, "q11", "acen"],
                [125100000, 143200000, "q12", "gvar"],
                [143200000, 147500000, "q21.1", "gneg"],
                [147500000, 150600000, "q21.2", "gpos50"],
                [150600000, 155100000, "q21.3", "gneg"],
                [155100000, 156600000, "q22", "gpos50"],
                [156600000, 159100000, "q23.1", "gneg"],
                [159100000, 160500000, "q23.2", "gpos50"],
                [160500000, 165500000, "q23.3", "gneg"],
                [165500000, 167200000, "q24.1", "gpos50"],
                [167200000, 170900000, "q24.2", "gneg"],
                [170900000, 173000000, "q24.3", "gpos75"],
                [173000000, 176100000, "q25.1", "gneg"],
                [176100000, 180300000, "q25.2", "gpos50"],
                [180300000, 185800000, "q25.3", "gneg"],
                [185800000, 190800000, "q31.1", "gpos100"],
                [190800000, 193800000, "q31.2", "gneg"],
                [193800000, 198700000, "q31.3", "gpos100"],
                [198700000, 207100000, "q32.1", "gneg"],
                [207100000, 211300000, "q32.2", "gpos25"],
                [211300000, 214400000, "q32.3", "gneg"],
                [214400000, 223900000, "q41", "gpos100"],
                [223900000, 224400000, "q42.11", "gneg"],
                [224400000, 226800000, "q42.12", "gpos25"],
                [226800000, 230500000, "q42.13", "gneg"],
                [230500000, 234600000, "q42.2", "gpos50"],
                [234600000, 236400000, "q42.3", "gneg"],
                [236400000, 243500000, "q43", "gpos75"],
                [243500000, 248956422, "q44", "gneg"]
            ],
            2: [
                [0, 4400000, "p25.3", "gneg"],
                [4400000, 6900000, "p25.2", "gpos50"],
                [6900000, 12000000, "p25.1", "gneg"],
                [12000000, 16500000, "p24.3", "gpos75"],
                [16500000, 19000000, "p24.2", "gneg"],
                [19000000, 23800000, "p24.1", "gpos75"],
                [23800000, 27700000, "p23.3", "gneg"],
                [27700000, 29800000, "p23.2", "gpos25"],
                [29800000, 31800000, "p23.1", "gneg"],
                [31800000, 36300000, "p22.3", "gpos75"],
                [36300000, 38300000, "p22.2", "gneg"],
                [38300000, 41500000, "p22.1", "gpos50"],
                [41500000, 47500000, "p21", "gneg"],
                [47500000, 52600000, "p16.3", "gpos100"],
                [52600000, 54700000, "p16.2", "gneg"],
                [54700000, 61000000, "p16.1", "gpos100"],
                [61000000, 63900000, "p15", "gneg"],
                [63900000, 68400000, "p14", "gpos50"],
                [68400000, 71300000, "p13.3", "gneg"],
                [71300000, 73300000, "p13.2", "gpos50"],
                [73300000, 74800000, "p13.1", "gneg"],
                [74800000, 83100000, "p12", "gpos100"],
                [83100000, 91800000, "p11.2", "gneg"],
                [91800000, 93900000, "p11.1", "acen"],
                [93900000, 96000000, "q11.1", "acen"],
                [96000000, 102100000, "q11.2", "gneg"],
                [102100000, 105300000, "q12.1", "gpos50"],
                [105300000, 106700000, "q12.2", "gneg"],
                [106700000, 108700000, "q12.3", "gpos25"],
                [108700000, 112200000, "q13", "gneg"],
                [112200000, 118100000, "q14.1", "gpos50"],
                [118100000, 121600000, "q14.2", "gneg"],
                [121600000, 129100000, "q14.3", "gpos50"],
                [129100000, 131700000, "q21.1", "gneg"],
                [131700000, 134300000, "q21.2", "gpos25"],
                [134300000, 136100000, "q21.3", "gneg"],
                [136100000, 141500000, "q22.1", "gpos100"],
                [141500000, 143400000, "q22.2", "gneg"],
                [143400000, 147900000, "q22.3", "gpos100"],
                [147900000, 149000000, "q23.1", "gneg"],
                [149000000, 149600000, "q23.2", "gpos25"],
                [149600000, 154000000, "q23.3", "gneg"],
                [154000000, 158900000, "q24.1", "gpos75"],
                [158900000, 162900000, "q24.2", "gneg"],
                [162900000, 168900000, "q24.3", "gpos75"],
                [168900000, 177100000, "q31.1", "gneg"],
                [177100000, 179700000, "q31.2", "gpos50"],
                [179700000, 182100000, "q31.3", "gneg"],
                [182100000, 188500000, "q32.1", "gpos75"],
                [188500000, 191100000, "q32.2", "gneg"],
                [191100000, 196600000, "q32.3", "gpos75"],
                [196600000, 202500000, "q33.1", "gneg"],
                [202500000, 204100000, "q33.2", "gpos50"],
                [204100000, 208200000, "q33.3", "gneg"],
                [208200000, 214500000, "q34", "gpos100"],
                [214500000, 220700000, "q35", "gneg"],
                [220700000, 224300000, "q36.1", "gpos75"],
                [224300000, 225200000, "q36.2", "gneg"],
                [225200000, 230100000, "q36.3", "gpos100"],
                [230100000, 234700000, "q37.1", "gneg"],
                [234700000, 236400000, "q37.2", "gpos50"],
                [236400000, 242193529, "q37.3", "gneg"]
            ],
            3: [
                [0, 2800000, "p26.3", "gpos50"],
                [2800000, 4000000, "p26.2", "gneg"],
                [4000000, 8100000, "p26.1", "gpos50"],
                [8100000, 11600000, "p25.3", "gneg"],
                [11600000, 13200000, "p25.2", "gpos25"],
                [13200000, 16300000, "p25.1", "gneg"],
                [16300000, 23800000, "p24.3", "gpos100"],
                [23800000, 26300000, "p24.2", "gneg"],
                [26300000, 30800000, "p24.1", "gpos75"],
                [30800000, 32000000, "p23", "gneg"],
                [32000000, 36400000, "p22.3", "gpos50"],
                [36400000, 39300000, "p22.2", "gneg"],
                [39300000, 43600000, "p22.1", "gpos75"],
                [43600000, 44100000, "p21.33", "gneg"],
                [44100000, 44200000, "p21.32", "gpos50"],
                [44200000, 50600000, "p21.31", "gneg"],
                [50600000, 52300000, "p21.2", "gpos25"],
                [52300000, 54400000, "p21.1", "gneg"],
                [54400000, 58600000, "p14.3", "gpos50"],
                [58600000, 63800000, "p14.2", "gneg"],
                [63800000, 69700000, "p14.1", "gpos50"],
                [69700000, 74100000, "p13", "gneg"],
                [74100000, 79800000, "p12.3", "gpos75"],
                [79800000, 83500000, "p12.2", "gneg"],
                [83500000, 87100000, "p12.1", "gpos75"],
                [87100000, 87800000, "p11.2", "gneg"],
                [87800000, 90900000, "p11.1", "acen"],
                [90900000, 94000000, "q11.1", "acen"],
                [94000000, 98600000, "q11.2", "gvar"],
                [98600000, 100300000, "q12.1", "gneg"],
                [100300000, 101200000, "q12.2", "gpos25"],
                [101200000, 103100000, "q12.3", "gneg"],
                [103100000, 106500000, "q13.11", "gpos75"],
                [106500000, 108200000, "q13.12", "gneg"],
                [108200000, 111600000, "q13.13", "gpos50"],
                [111600000, 113700000, "q13.2", "gneg"],
                [113700000, 117600000, "q13.31", "gpos75"],
                [117600000, 119300000, "q13.32", "gneg"],
                [119300000, 122200000, "q13.33", "gpos75"],
                [122200000, 124100000, "q21.1", "gneg"],
                [124100000, 126100000, "q21.2", "gpos25"],
                [126100000, 129500000, "q21.3", "gneg"],
                [129500000, 134000000, "q22.1", "gpos25"],
                [134000000, 136000000, "q22.2", "gneg"],
                [136000000, 139000000, "q22.3", "gpos25"],
                [139000000, 143100000, "q23", "gneg"],
                [143100000, 149200000, "q24", "gpos100"],
                [149200000, 152300000, "q25.1", "gneg"],
                [152300000, 155300000, "q25.2", "gpos50"],
                [155300000, 157300000, "q25.31", "gneg"],
                [157300000, 159300000, "q25.32", "gpos50"],
                [159300000, 161000000, "q25.33", "gneg"],
                [161000000, 167900000, "q26.1", "gpos100"],
                [167900000, 171200000, "q26.2", "gneg"],
                [171200000, 176000000, "q26.31", "gpos75"],
                [176000000, 179300000, "q26.32", "gneg"],
                [179300000, 183000000, "q26.33", "gpos75"],
                [183000000, 184800000, "q27.1", "gneg"],
                [184800000, 186300000, "q27.2", "gpos25"],
                [186300000, 188200000, "q27.3", "gneg"],
                [188200000, 192600000, "q28", "gpos75"],
                [192600000, 198295559, "q29", "gneg"]
            ],
            4: [
                [0, 4500000, "p16.3", "gneg"],
                [4500000, 6000000, "p16.2", "gpos25"],
                [6000000, 11300000, "p16.1", "gneg"],
                [11300000, 15000000, "p15.33", "gpos50"],
                [15000000, 17700000, "p15.32", "gneg"],
                [17700000, 21300000, "p15.31", "gpos75"],
                [21300000, 27700000, "p15.2", "gneg"],
                [27700000, 35800000, "p15.1", "gpos100"],
                [35800000, 41200000, "p14", "gneg"],
                [41200000, 44600000, "p13", "gpos50"],
                [44600000, 48200000, "p12", "gneg"],
                [48200000, 50000000, "p11", "acen"],
                [50000000, 51800000, "q11", "acen"],
                [51800000, 58500000, "q12", "gneg"],
                [58500000, 65500000, "q13.1", "gpos100"],
                [65500000, 69400000, "q13.2", "gneg"],
                [69400000, 75300000, "q13.3", "gpos75"],
                [75300000, 78000000, "q21.1", "gneg"],
                [78000000, 81500000, "q21.21", "gpos50"],
                [81500000, 83200000, "q21.22", "gneg"],
                [83200000, 86000000, "q21.23", "gpos25"],
                [86000000, 87100000, "q21.3", "gneg"],
                [87100000, 92800000, "q22.1", "gpos75"],
                [92800000, 94200000, "q22.2", "gneg"],
                [94200000, 97900000, "q22.3", "gpos75"],
                [97900000, 100100000, "q23", "gneg"],
                [100100000, 106700000, "q24", "gpos50"],
                [106700000, 113200000, "q25", "gneg"],
                [113200000, 119900000, "q26", "gpos75"],
                [119900000, 122800000, "q27", "gneg"],
                [122800000, 127900000, "q28.1", "gpos50"],
                [127900000, 130100000, "q28.2", "gneg"],
                [130100000, 138500000, "q28.3", "gpos100"],
                [138500000, 140600000, "q31.1", "gneg"],
                [140600000, 145900000, "q31.21", "gpos25"],
                [145900000, 147500000, "q31.22", "gneg"],
                [147500000, 150200000, "q31.23", "gpos25"],
                [150200000, 154600000, "q31.3", "gneg"],
                [154600000, 160800000, "q32.1", "gpos100"],
                [160800000, 163600000, "q32.2", "gneg"],
                [163600000, 169200000, "q32.3", "gpos100"],
                [169200000, 171000000, "q33", "gneg"],
                [171000000, 175400000, "q34.1", "gpos75"],
                [175400000, 176600000, "q34.2", "gneg"],
                [176600000, 182300000, "q34.3", "gpos100"],
                [182300000, 186200000, "q35.1", "gneg"],
                [186200000, 190214555, "q35.2", "gpos25"]
            ],
            5: [
                [0, 4400000, "p15.33", "gneg"],
                [4400000, 6300000, "p15.32", "gpos25"],
                [6300000, 9900000, "p15.31", "gneg"],
                [9900000, 15000000, "p15.2", "gpos50"],
                [15000000, 18400000, "p15.1", "gneg"],
                [18400000, 23300000, "p14.3", "gpos100"],
                [23300000, 24600000, "p14.2", "gneg"],
                [24600000, 28900000, "p14.1", "gpos100"],
                [28900000, 33800000, "p13.3", "gneg"],
                [33800000, 38400000, "p13.2", "gpos25"],
                [38400000, 42500000, "p13.1", "gneg"],
                [42500000, 46100000, "p12", "gpos50"],
                [46100000, 48800000, "p11", "acen"],
                [48800000, 51400000, "q11.1", "acen"],
                [51400000, 59600000, "q11.2", "gneg"],
                [59600000, 63600000, "q12.1", "gpos75"],
                [63600000, 63900000, "q12.2", "gneg"],
                [63900000, 67400000, "q12.3", "gpos75"],
                [67400000, 69100000, "q13.1", "gneg"],
                [69100000, 74000000, "q13.2", "gpos50"],
                [74000000, 77600000, "q13.3", "gneg"],
                [77600000, 82100000, "q14.1", "gpos50"],
                [82100000, 83500000, "q14.2", "gneg"],
                [83500000, 93000000, "q14.3", "gpos100"],
                [93000000, 98900000, "q15", "gneg"],
                [98900000, 103400000, "q21.1", "gpos100"],
                [103400000, 105100000, "q21.2", "gneg"],
                [105100000, 110200000, "q21.3", "gpos100"],
                [110200000, 112200000, "q22.1", "gneg"],
                [112200000, 113800000, "q22.2", "gpos50"],
                [113800000, 115900000, "q22.3", "gneg"],
                [115900000, 122100000, "q23.1", "gpos100"],
                [122100000, 127900000, "q23.2", "gneg"],
                [127900000, 131200000, "q23.3", "gpos100"],
                [131200000, 136900000, "q31.1", "gneg"],
                [136900000, 140100000, "q31.2", "gpos25"],
                [140100000, 145100000, "q31.3", "gneg"],
                [145100000, 150400000, "q32", "gpos75"],
                [150400000, 153300000, "q33.1", "gneg"],
                [153300000, 156300000, "q33.2", "gpos50"],
                [156300000, 160500000, "q33.3", "gneg"],
                [160500000, 169000000, "q34", "gpos100"],
                [169000000, 173300000, "q35.1", "gneg"],
                [173300000, 177100000, "q35.2", "gpos25"],
                [177100000, 181538259, "q35.3", "gneg"]
            ],
            6: [
                [0, 2300000, "p25.3", "gneg"],
                [2300000, 4200000, "p25.2", "gpos25"],
                [4200000, 7100000, "p25.1", "gneg"],
                [7100000, 10600000, "p24.3", "gpos50"],
                [10600000, 11600000, "p24.2", "gneg"],
                [11600000, 13400000, "p24.1", "gpos25"],
                [13400000, 15200000, "p23", "gneg"],
                [15200000, 25200000, "p22.3", "gpos75"],
                [25200000, 27100000, "p22.2", "gneg"],
                [27100000, 30500000, "p22.1", "gpos50"],
                [30500000, 32100000, "p21.33", "gneg"],
                [32100000, 33500000, "p21.32", "gpos25"],
                [33500000, 36600000, "p21.31", "gneg"],
                [36600000, 40500000, "p21.2", "gpos25"],
                [40500000, 46200000, "p21.1", "gneg"],
                [46200000, 51800000, "p12.3", "gpos100"],
                [51800000, 53000000, "p12.2", "gneg"],
                [53000000, 57200000, "p12.1", "gpos100"],
                [57200000, 58500000, "p11.2", "gneg"],
                [58500000, 59800000, "p11.1", "acen"],
                [59800000, 62600000, "q11.1", "acen"],
                [62600000, 62700000, "q11.2", "gneg"],
                [62700000, 69200000, "q12", "gpos100"],
                [69200000, 75200000, "q13", "gneg"],
                [75200000, 83200000, "q14.1", "gpos50"],
                [83200000, 84200000, "q14.2", "gneg"],
                [84200000, 87300000, "q14.3", "gpos50"],
                [87300000, 92500000, "q15", "gneg"],
                [92500000, 98900000, "q16.1", "gpos100"],
                [98900000, 100000000, "q16.2", "gneg"],
                [100000000, 105000000, "q16.3", "gpos100"],
                [105000000, 114200000, "q21", "gneg"],
                [114200000, 117900000, "q22.1", "gpos75"],
                [117900000, 118100000, "q22.2", "gneg"],
                [118100000, 125800000, "q22.31", "gpos100"],
                [125800000, 126800000, "q22.32", "gneg"],
                [126800000, 130000000, "q22.33", "gpos75"],
                [130000000, 130900000, "q23.1", "gneg"],
                [130900000, 134700000, "q23.2", "gpos50"],
                [134700000, 138300000, "q23.3", "gneg"],
                [138300000, 142200000, "q24.1", "gpos75"],
                [142200000, 145100000, "q24.2", "gneg"],
                [145100000, 148500000, "q24.3", "gpos75"],
                [148500000, 152100000, "q25.1", "gneg"],
                [152100000, 155200000, "q25.2", "gpos50"],
                [155200000, 160600000, "q25.3", "gneg"],
                [160600000, 164100000, "q26", "gpos50"],
                [164100000, 170805979, "q27", "gneg"]
            ],
            7: [
                [0, 2800000, "p22.3", "gneg"],
                [2800000, 4500000, "p22.2", "gpos25"],
                [4500000, 7200000, "p22.1", "gneg"],
                [7200000, 13700000, "p21.3", "gpos100"],
                [13700000, 16500000, "p21.2", "gneg"],
                [16500000, 20900000, "p21.1", "gpos100"],
                [20900000, 25500000, "p15.3", "gneg"],
                [25500000, 27900000, "p15.2", "gpos50"],
                [27900000, 28800000, "p15.1", "gneg"],
                [28800000, 34900000, "p14.3", "gpos75"],
                [34900000, 37100000, "p14.2", "gneg"],
                [37100000, 43300000, "p14.1", "gpos75"],
                [43300000, 45400000, "p13", "gneg"],
                [45400000, 49000000, "p12.3", "gpos75"],
                [49000000, 50500000, "p12.2", "gneg"],
                [50500000, 53900000, "p12.1", "gpos75"],
                [53900000, 58100000, "p11.2", "gneg"],
                [58100000, 60100000, "p11.1", "acen"],
                [60100000, 62100000, "q11.1", "acen"],
                [62100000, 67500000, "q11.21", "gneg"],
                [67500000, 72700000, "q11.22", "gpos50"],
                [72700000, 77900000, "q11.23", "gneg"],
                [77900000, 86700000, "q21.11", "gpos100"],
                [86700000, 88500000, "q21.12", "gneg"],
                [88500000, 91500000, "q21.13", "gpos75"],
                [91500000, 93300000, "q21.2", "gneg"],
                [93300000, 98400000, "q21.3", "gpos75"],
                [98400000, 104200000, "q22.1", "gneg"],
                [104200000, 104900000, "q22.2", "gpos50"],
                [104900000, 107800000, "q22.3", "gneg"],
                [107800000, 115000000, "q31.1", "gpos75"],
                [115000000, 117700000, "q31.2", "gneg"],
                [117700000, 121400000, "q31.31", "gpos75"],
                [121400000, 124100000, "q31.32", "gneg"],
                [124100000, 127500000, "q31.33", "gpos75"],
                [127500000, 129600000, "q32.1", "gneg"],
                [129600000, 130800000, "q32.2", "gpos25"],
                [130800000, 132900000, "q32.3", "gneg"],
                [132900000, 138500000, "q33", "gpos50"],
                [138500000, 143400000, "q34", "gneg"],
                [143400000, 148200000, "q35", "gpos75"],
                [148200000, 152800000, "q36.1", "gneg"],
                [152800000, 155200000, "q36.2", "gpos25"],
                [155200000, 159345973, "q36.3", "gneg"]
            ],
            8: [
                [0, 2300000, "p23.3", "gneg"],
                [2300000, 6300000, "p23.2", "gpos75"],
                [6300000, 12800000, "p23.1", "gneg"],
                [12800000, 19200000, "p22", "gpos100"],
                [19200000, 23500000, "p21.3", "gneg"],
                [23500000, 27500000, "p21.2", "gpos50"],
                [27500000, 29000000, "p21.1", "gneg"],
                [29000000, 36700000, "p12", "gpos75"],
                [36700000, 38500000, "p11.23", "gneg"],
                [38500000, 39900000, "p11.22", "gpos25"],
                [39900000, 43200000, "p11.21", "gneg"],
                [43200000, 45200000, "p11.1", "acen"],
                [45200000, 47200000, "q11.1", "acen"],
                [47200000, 51300000, "q11.21", "gneg"],
                [51300000, 51700000, "q11.22", "gpos75"],
                [51700000, 54600000, "q11.23", "gneg"],
                [54600000, 60600000, "q12.1", "gpos50"],
                [60600000, 61300000, "q12.2", "gneg"],
                [61300000, 65100000, "q12.3", "gpos50"],
                [65100000, 67100000, "q13.1", "gneg"],
                [67100000, 69600000, "q13.2", "gpos50"],
                [69600000, 72000000, "q13.3", "gneg"],
                [72000000, 74600000, "q21.11", "gpos100"],
                [74600000, 74700000, "q21.12", "gneg"],
                [74700000, 83500000, "q21.13", "gpos75"],
                [83500000, 85900000, "q21.2", "gneg"],
                [85900000, 92300000, "q21.3", "gpos100"],
                [92300000, 97900000, "q22.1", "gneg"],
                [97900000, 100500000, "q22.2", "gpos25"],
                [100500000, 105100000, "q22.3", "gneg"],
                [105100000, 109500000, "q23.1", "gpos75"],
                [109500000, 111100000, "q23.2", "gneg"],
                [111100000, 116700000, "q23.3", "gpos100"],
                [116700000, 118300000, "q24.11", "gneg"],
                [118300000, 121500000, "q24.12", "gpos50"],
                [121500000, 126300000, "q24.13", "gneg"],
                [126300000, 130400000, "q24.21", "gpos50"],
                [130400000, 135400000, "q24.22", "gneg"],
                [135400000, 138900000, "q24.23", "gpos75"],
                [138900000, 145138636, "q24.3", "gneg"]
            ],
            9: [
                [0, 2200000, "p24.3", "gneg"],
                [2200000, 4600000, "p24.2", "gpos25"],
                [4600000, 9000000, "p24.1", "gneg"],
                [9000000, 14200000, "p23", "gpos75"],
                [14200000, 16600000, "p22.3", "gneg"],
                [16600000, 18500000, "p22.2", "gpos25"],
                [18500000, 19900000, "p22.1", "gneg"],
                [19900000, 25600000, "p21.3", "gpos100"],
                [25600000, 28000000, "p21.2", "gneg"],
                [28000000, 33200000, "p21.1", "gpos100"],
                [33200000, 36300000, "p13.3", "gneg"],
                [36300000, 37900000, "p13.2", "gpos25"],
                [37900000, 39000000, "p13.1", "gneg"],
                [39000000, 40000000, "p12", "gpos50"],
                [40000000, 42200000, "p11.2", "gneg"],
                [42200000, 43000000, "p11.1", "acen"],
                [43000000, 45500000, "q11", "acen"],
                [45500000, 61500000, "q12", "gvar"],
                [61500000, 65000000, "q13", "gneg"],
                [65000000, 69300000, "q21.11", "gpos25"],
                [69300000, 71300000, "q21.12", "gneg"],
                [71300000, 76600000, "q21.13", "gpos50"],
                [76600000, 78500000, "q21.2", "gneg"],
                [78500000, 81500000, "q21.31", "gpos50"],
                [81500000, 84300000, "q21.32", "gneg"],
                [84300000, 87800000, "q21.33", "gpos50"],
                [87800000, 89200000, "q22.1", "gneg"],
                [89200000, 91200000, "q22.2", "gpos25"],
                [91200000, 93900000, "q22.31", "gneg"],
                [93900000, 96500000, "q22.32", "gpos25"],
                [96500000, 99800000, "q22.33", "gneg"],
                [99800000, 105400000, "q31.1", "gpos100"],
                [105400000, 108500000, "q31.2", "gneg"],
                [108500000, 112100000, "q31.3", "gpos25"],
                [112100000, 114900000, "q32", "gneg"],
                [114900000, 119800000, "q33.1", "gpos75"],
                [119800000, 123100000, "q33.2", "gneg"],
                [123100000, 127500000, "q33.3", "gpos25"],
                [127500000, 130600000, "q34.11", "gneg"],
                [130600000, 131100000, "q34.12", "gpos25"],
                [131100000, 133100000, "q34.13", "gneg"],
                [133100000, 134500000, "q34.2", "gpos25"],
                [134500000, 138394717, "q34.3", "gneg"]
            ],
            10: [
                [0, 3000000, "p15.3", "gneg"],
                [3000000, 3800000, "p15.2", "gpos25"],
                [3800000, 6600000, "p15.1", "gneg"],
                [6600000, 12200000, "p14", "gpos75"],
                [12200000, 17300000, "p13", "gneg"],
                [17300000, 18300000, "p12.33", "gpos75"],
                [18300000, 18400000, "p12.32", "gneg"],
                [18400000, 22300000, "p12.31", "gpos75"],
                [22300000, 24300000, "p12.2", "gneg"],
                [24300000, 29300000, "p12.1", "gpos50"],
                [29300000, 31100000, "p11.23", "gneg"],
                [31100000, 34200000, "p11.22", "gpos25"],
                [34200000, 38000000, "p11.21", "gneg"],
                [38000000, 39800000, "p11.1", "acen"],
                [39800000, 41600000, "q11.1", "acen"],
                [41600000, 45500000, "q11.21", "gneg"],
                [45500000, 48600000, "q11.22", "gpos25"],
                [48600000, 51100000, "q11.23", "gneg"],
                [51100000, 59400000, "q21.1", "gpos100"],
                [59400000, 62800000, "q21.2", "gneg"],
                [62800000, 68800000, "q21.3", "gpos100"],
                [68800000, 73100000, "q22.1", "gneg"],
                [73100000, 75900000, "q22.2", "gpos50"],
                [75900000, 80300000, "q22.3", "gneg"],
                [80300000, 86100000, "q23.1", "gpos100"],
                [86100000, 87700000, "q23.2", "gneg"],
                [87700000, 91100000, "q23.31", "gpos75"],
                [91100000, 92300000, "q23.32", "gneg"],
                [92300000, 95300000, "q23.33", "gpos50"],
                [95300000, 97500000, "q24.1", "gneg"],
                [97500000, 100100000, "q24.2", "gpos50"],
                [100100000, 101200000, "q24.31", "gneg"],
                [101200000, 103100000, "q24.32", "gpos25"],
                [103100000, 104000000, "q24.33", "gneg"],
                [104000000, 110100000, "q25.1", "gpos100"],
                [110100000, 113100000, "q25.2", "gneg"],
                [113100000, 117300000, "q25.3", "gpos75"],
                [117300000, 119900000, "q26.11", "gneg"],
                [119900000, 121400000, "q26.12", "gpos50"],
                [121400000, 125700000, "q26.13", "gneg"],
                [125700000, 128800000, "q26.2", "gpos50"],
                [128800000, 133797422, "q26.3", "gneg"]
            ],
            11: [
                [0, 2800000, "p15.5", "gneg"],
                [2800000, 11700000, "p15.4", "gpos50"],
                [11700000, 13800000, "p15.3", "gneg"],
                [13800000, 16900000, "p15.2", "gpos50"],
                [16900000, 22000000, "p15.1", "gneg"],
                [22000000, 26200000, "p14.3", "gpos100"],
                [26200000, 27200000, "p14.2", "gneg"],
                [27200000, 31000000, "p14.1", "gpos75"],
                [31000000, 36400000, "p13", "gneg"],
                [36400000, 43400000, "p12", "gpos100"],
                [43400000, 48800000, "p11.2", "gneg"],
                [48800000, 51000000, "p11.12", "gpos75"],
                [51000000, 53400000, "p11.11", "acen"],
                [53400000, 55800000, "q11", "acen"],
                [55800000, 60100000, "q12.1", "gpos75"],
                [60100000, 61900000, "q12.2", "gneg"],
                [61900000, 63600000, "q12.3", "gpos25"],
                [63600000, 66100000, "q13.1", "gneg"],
                [66100000, 68700000, "q13.2", "gpos25"],
                [68700000, 70500000, "q13.3", "gneg"],
                [70500000, 75500000, "q13.4", "gpos50"],
                [75500000, 77400000, "q13.5", "gneg"],
                [77400000, 85900000, "q14.1", "gpos100"],
                [85900000, 88600000, "q14.2", "gneg"],
                [88600000, 93000000, "q14.3", "gpos100"],
                [93000000, 97400000, "q21", "gneg"],
                [97400000, 102300000, "q22.1", "gpos100"],
                [102300000, 103000000, "q22.2", "gneg"],
                [103000000, 110600000, "q22.3", "gpos100"],
                [110600000, 112700000, "q23.1", "gneg"],
                [112700000, 114600000, "q23.2", "gpos50"],
                [114600000, 121300000, "q23.3", "gneg"],
                [121300000, 124000000, "q24.1", "gpos50"],
                [124000000, 127900000, "q24.2", "gneg"],
                [127900000, 130900000, "q24.3", "gpos50"],
                [130900000, 135086622, "q25", "gneg"]
            ],
            12: [
                [0, 3200000, "p13.33", "gneg"],
                [3200000, 5300000, "p13.32", "gpos25"],
                [5300000, 10000000, "p13.31", "gneg"],
                [10000000, 12600000, "p13.2", "gpos75"],
                [12600000, 14600000, "p13.1", "gneg"],
                [14600000, 19800000, "p12.3", "gpos100"],
                [19800000, 21100000, "p12.2", "gneg"],
                [21100000, 26300000, "p12.1", "gpos100"],
                [26300000, 27600000, "p11.23", "gneg"],
                [27600000, 30500000, "p11.22", "gpos50"],
                [30500000, 33200000, "p11.21", "gneg"],
                [33200000, 35500000, "p11.1", "acen"],
                [35500000, 37800000, "q11", "acen"],
                [37800000, 46000000, "q12", "gpos100"],
                [46000000, 48700000, "q13.11", "gneg"],
                [48700000, 51100000, "q13.12", "gpos25"],
                [51100000, 54500000, "q13.13", "gneg"],
                [54500000, 56200000, "q13.2", "gpos25"],
                [56200000, 57700000, "q13.3", "gneg"],
                [57700000, 62700000, "q14.1", "gpos75"],
                [62700000, 64700000, "q14.2", "gneg"],
                [64700000, 67300000, "q14.3", "gpos50"],
                [67300000, 71100000, "q15", "gneg"],
                [71100000, 75300000, "q21.1", "gpos75"],
                [75300000, 79900000, "q21.2", "gneg"],
                [79900000, 86300000, "q21.31", "gpos100"],
                [86300000, 88600000, "q21.32", "gneg"],
                [88600000, 92200000, "q21.33", "gpos100"],
                [92200000, 95800000, "q22", "gneg"],
                [95800000, 101200000, "q23.1", "gpos75"],
                [101200000, 103500000, "q23.2", "gneg"],
                [103500000, 108600000, "q23.3", "gpos50"],
                [108600000, 111300000, "q24.11", "gneg"],
                [111300000, 111900000, "q24.12", "gpos25"],
                [111900000, 113900000, "q24.13", "gneg"],
                [113900000, 116400000, "q24.21", "gpos50"],
                [116400000, 117700000, "q24.22", "gneg"],
                [117700000, 120300000, "q24.23", "gpos50"],
                [120300000, 125400000, "q24.31", "gneg"],
                [125400000, 128700000, "q24.32", "gpos50"],
                [128700000, 133275309, "q24.33", "gneg"]
            ],
            13: [
                [0, 4600000, "p13", "gvar"],
                [4600000, 10100000, "p12", "stalk"],
                [10100000, 16500000, "p11.2", "gvar"],
                [16500000, 17700000, "p11.1", "acen"],
                [17700000, 18900000, "q11", "acen"],
                [18900000, 22600000, "q12.11", "gneg"],
                [22600000, 24900000, "q12.12", "gpos25"],
                [24900000, 27200000, "q12.13", "gneg"],
                [27200000, 28300000, "q12.2", "gpos25"],
                [28300000, 31600000, "q12.3", "gneg"],
                [31600000, 33400000, "q13.1", "gpos50"],
                [33400000, 34900000, "q13.2", "gneg"],
                [34900000, 39500000, "q13.3", "gpos75"],
                [39500000, 44600000, "q14.11", "gneg"],
                [44600000, 45200000, "q14.12", "gpos25"],
                [45200000, 46700000, "q14.13", "gneg"],
                [46700000, 50300000, "q14.2", "gpos50"],
                [50300000, 54700000, "q14.3", "gneg"],
                [54700000, 59000000, "q21.1", "gpos100"],
                [59000000, 61800000, "q21.2", "gneg"],
                [61800000, 65200000, "q21.31", "gpos75"],
                [65200000, 68100000, "q21.32", "gneg"],
                [68100000, 72800000, "q21.33", "gpos100"],
                [72800000, 74900000, "q22.1", "gneg"],
                [74900000, 76700000, "q22.2", "gpos50"],
                [76700000, 78500000, "q22.3", "gneg"],
                [78500000, 87100000, "q31.1", "gpos100"],
                [87100000, 89400000, "q31.2", "gneg"],
                [89400000, 94400000, "q31.3", "gpos100"],
                [94400000, 97500000, "q32.1", "gneg"],
                [97500000, 98700000, "q32.2", "gpos25"],
                [98700000, 101100000, "q32.3", "gneg"],
                [101100000, 104200000, "q33.1", "gpos100"],
                [104200000, 106400000, "q33.2", "gneg"],
                [106400000, 109600000, "q33.3", "gpos100"],
                [109600000, 114364328, "q34", "gneg"]
            ],
            14: [
                [0, 3600000, "p13", "gvar"],
                [3600000, 8000000, "p12", "stalk"],
                [8000000, 16100000, "p11.2", "gvar"],
                [16100000, 17200000, "p11.1", "acen"],
                [17200000, 18200000, "q11.1", "acen"],
                [18200000, 24100000, "q11.2", "gneg"],
                [24100000, 32900000, "q12", "gpos100"],
                [32900000, 34800000, "q13.1", "gneg"],
                [34800000, 36100000, "q13.2", "gpos50"],
                [36100000, 37400000, "q13.3", "gneg"],
                [37400000, 43000000, "q21.1", "gpos100"],
                [43000000, 46700000, "q21.2", "gneg"],
                [46700000, 50400000, "q21.3", "gpos100"],
                [50400000, 53600000, "q22.1", "gneg"],
                [53600000, 55000000, "q22.2", "gpos25"],
                [55000000, 57600000, "q22.3", "gneg"],
                [57600000, 61600000, "q23.1", "gpos75"],
                [61600000, 64300000, "q23.2", "gneg"],
                [64300000, 67400000, "q23.3", "gpos50"],
                [67400000, 69800000, "q24.1", "gneg"],
                [69800000, 73300000, "q24.2", "gpos50"],
                [73300000, 78800000, "q24.3", "gneg"],
                [78800000, 83100000, "q31.1", "gpos100"],
                [83100000, 84400000, "q31.2", "gneg"],
                [84400000, 89300000, "q31.3", "gpos100"],
                [89300000, 91400000, "q32.11", "gneg"],
                [91400000, 94200000, "q32.12", "gpos25"],
                [94200000, 95800000, "q32.13", "gneg"],
                [95800000, 100900000, "q32.2", "gpos50"],
                [100900000, 102700000, "q32.31", "gneg"],
                [102700000, 103500000, "q32.32", "gpos50"],
                [103500000, 107043718, "q32.33", "gneg"]
            ],
            15: [
                [0, 4200000, "p13", "gvar"],
                [4200000, 9700000, "p12", "stalk"],
                [9700000, 17500000, "p11.2", "gvar"],
                [17500000, 19000000, "p11.1", "acen"],
                [19000000, 20500000, "q11.1", "acen"],
                [20500000, 25500000, "q11.2", "gneg"],
                [25500000, 27800000, "q12", "gpos50"],
                [27800000, 30000000, "q13.1", "gneg"],
                [30000000, 30900000, "q13.2", "gpos50"],
                [30900000, 33400000, "q13.3", "gneg"],
                [33400000, 39800000, "q14", "gpos75"],
                [39800000, 42500000, "q15.1", "gneg"],
                [42500000, 43300000, "q15.2", "gpos25"],
                [43300000, 44500000, "q15.3", "gneg"],
                [44500000, 49200000, "q21.1", "gpos75"],
                [49200000, 52600000, "q21.2", "gneg"],
                [52600000, 58800000, "q21.3", "gpos75"],
                [58800000, 59000000, "q22.1", "gneg"],
                [59000000, 63400000, "q22.2", "gpos25"],
                [63400000, 66900000, "q22.31", "gneg"],
                [66900000, 67000000, "q22.32", "gpos25"],
                [67000000, 67200000, "q22.33", "gneg"],
                [67200000, 72400000, "q23", "gpos25"],
                [72400000, 74900000, "q24.1", "gneg"],
                [74900000, 76300000, "q24.2", "gpos25"],
                [76300000, 78000000, "q24.3", "gneg"],
                [78000000, 81400000, "q25.1", "gpos50"],
                [81400000, 84700000, "q25.2", "gneg"],
                [84700000, 88500000, "q25.3", "gpos50"],
                [88500000, 93800000, "q26.1", "gneg"],
                [93800000, 98000000, "q26.2", "gpos50"],
                [98000000, 101991189, "q26.3", "gneg"]
            ],
            16: [
                [0, 7800000, "p13.3", "gneg"],
                [7800000, 10400000, "p13.2", "gpos50"],
                [10400000, 12500000, "p13.13", "gneg"],
                [12500000, 14700000, "p13.12", "gpos50"],
                [14700000, 16700000, "p13.11", "gneg"],
                [16700000, 21200000, "p12.3", "gpos50"],
                [21200000, 24200000, "p12.2", "gneg"],
                [24200000, 28500000, "p12.1", "gpos50"],
                [28500000, 35300000, "p11.2", "gneg"],
                [35300000, 36800000, "p11.1", "acen"],
                [36800000, 38400000, "q11.1", "acen"],
                [38400000, 47000000, "q11.2", "gvar"],
                [47000000, 52600000, "q12.1", "gneg"],
                [52600000, 56000000, "q12.2", "gpos50"],
                [56000000, 57300000, "q13", "gneg"],
                [57300000, 66600000, "q21", "gpos100"],
                [66600000, 70800000, "q22.1", "gneg"],
                [70800000, 72800000, "q22.2", "gpos50"],
                [72800000, 74100000, "q22.3", "gneg"],
                [74100000, 79200000, "q23.1", "gpos75"],
                [79200000, 81600000, "q23.2", "gneg"],
                [81600000, 84100000, "q23.3", "gpos50"],
                [84100000, 87000000, "q24.1", "gneg"],
                [87000000, 88700000, "q24.2", "gpos25"],
                [88700000, 90338345, "q24.3", "gneg"]
            ],
            17: [
                [0, 3400000, "p13.3", "gneg"],
                [3400000, 6500000, "p13.2", "gpos50"],
                [6500000, 10800000, "p13.1", "gneg"],
                [10800000, 16100000, "p12", "gpos75"],
                [16100000, 22700000, "p11.2", "gneg"],
                [22700000, 25100000, "p11.1", "acen"],
                [25100000, 27400000, "q11.1", "acen"],
                [27400000, 33500000, "q11.2", "gneg"],
                [33500000, 39800000, "q12", "gpos50"],
                [39800000, 40200000, "q21.1", "gneg"],
                [40200000, 42800000, "q21.2", "gpos25"],
                [42800000, 46800000, "q21.31", "gneg"],
                [46800000, 49300000, "q21.32", "gpos25"],
                [49300000, 52100000, "q21.33", "gneg"],
                [52100000, 59500000, "q22", "gpos75"],
                [59500000, 60200000, "q23.1", "gneg"],
                [60200000, 63100000, "q23.2", "gpos75"],
                [63100000, 64600000, "q23.3", "gneg"],
                [64600000, 66200000, "q24.1", "gpos50"],
                [66200000, 69100000, "q24.2", "gneg"],
                [69100000, 72900000, "q24.3", "gpos75"],
                [72900000, 76800000, "q25.1", "gneg"],
                [76800000, 77200000, "q25.2", "gpos25"],
                [77200000, 83257441, "q25.3", "gneg"]
            ],
            18: [
                [0, 2900000, "p11.32", "gneg"],
                [2900000, 7200000, "p11.31", "gpos50"],
                [7200000, 8500000, "p11.23", "gneg"],
                [8500000, 10900000, "p11.22", "gpos25"],
                [10900000, 15400000, "p11.21", "gneg"],
                [15400000, 18500000, "p11.1", "acen"],
                [18500000, 21500000, "q11.1", "acen"],
                [21500000, 27500000, "q11.2", "gneg"],
                [27500000, 35100000, "q12.1", "gpos100"],
                [35100000, 39500000, "q12.2", "gneg"],
                [39500000, 45900000, "q12.3", "gpos75"],
                [45900000, 50700000, "q21.1", "gneg"],
                [50700000, 56200000, "q21.2", "gpos75"],
                [56200000, 58600000, "q21.31", "gneg"],
                [58600000, 61300000, "q21.32", "gpos50"],
                [61300000, 63900000, "q21.33", "gneg"],
                [63900000, 69100000, "q22.1", "gpos100"],
                [69100000, 71000000, "q22.2", "gneg"],
                [71000000, 75400000, "q22.3", "gpos25"],
                [75400000, 80373285, "q23", "gneg"]
            ],
            19: [
                [0, 6900000, "p13.3", "gneg"],
                [6900000, 12600000, "p13.2", "gpos25"],
                [12600000, 13800000, "p13.13", "gneg"],
                [13800000, 16100000, "p13.12", "gpos25"],
                [16100000, 19900000, "p13.11", "gneg"],
                [19900000, 24200000, "p12", "gvar"],
                [24200000, 26200000, "p11", "acen"],
                [26200000, 28100000, "q11", "acen"],
                [28100000, 31900000, "q12", "gvar"],
                [31900000, 35100000, "q13.11", "gneg"],
                [35100000, 37800000, "q13.12", "gpos25"],
                [37800000, 38200000, "q13.13", "gneg"],
                [38200000, 42900000, "q13.2", "gpos25"],
                [42900000, 44700000, "q13.31", "gneg"],
                [44700000, 47500000, "q13.32", "gpos25"],
                [47500000, 50900000, "q13.33", "gneg"],
                [50900000, 53100000, "q13.41", "gpos25"],
                [53100000, 55800000, "q13.42", "gneg"],
                [55800000, 58617616, "q13.43", "gpos25"]
            ],
            20: [
                [0, 5100000, "p13", "gneg"],
                [5100000, 9200000, "p12.3", "gpos75"],
                [9200000, 12000000, "p12.2", "gneg"],
                [12000000, 17900000, "p12.1", "gpos75"],
                [17900000, 21300000, "p11.23", "gneg"],
                [21300000, 22300000, "p11.22", "gpos25"],
                [22300000, 25700000, "p11.21", "gneg"],
                [25700000, 28100000, "p11.1", "acen"],
                [28100000, 30400000, "q11.1", "acen"],
                [30400000, 33500000, "q11.21", "gneg"],
                [33500000, 35800000, "q11.22", "gpos25"],
                [35800000, 39000000, "q11.23", "gneg"],
                [39000000, 43100000, "q12", "gpos75"],
                [43100000, 43500000, "q13.11", "gneg"],
                [43500000, 47800000, "q13.12", "gpos25"],
                [47800000, 51200000, "q13.13", "gneg"],
                [51200000, 56400000, "q13.2", "gpos75"],
                [56400000, 57800000, "q13.31", "gneg"],
                [57800000, 59700000, "q13.32", "gpos50"],
                [59700000, 64444167, "q13.33", "gneg"]
            ],
            21: [
                [0, 3100000, "p13", "gvar"],
                [3100000, 7000000, "p12", "stalk"],
                [7000000, 10900000, "p11.2", "gvar"],
                [10900000, 12000000, "p11.1", "acen"],
                [12000000, 13000000, "q11.1", "acen"],
                [13000000, 15000000, "q11.2", "gneg"],
                [15000000, 22600000, "q21.1", "gpos100"],
                [22600000, 25500000, "q21.2", "gneg"],
                [25500000, 30200000, "q21.3", "gpos75"],
                [30200000, 34400000, "q22.11", "gneg"],
                [34400000, 36400000, "q22.12", "gpos50"],
                [36400000, 38300000, "q22.13", "gneg"],
                [38300000, 41200000, "q22.2", "gpos50"],
                [41200000, 46709983, "q22.3", "gneg"]
            ],
            22: [
                [0, 4300000, "p13", "gvar"],
                [4300000, 9400000, "p12", "stalk"],
                [9400000, 13700000, "p11.2", "gvar"],
                [13700000, 15000000, "p11.1", "acen"],
                [15000000, 17400000, "q11.1", "acen"],
                [17400000, 21700000, "q11.21", "gneg"],
                [21700000, 23100000, "q11.22", "gpos25"],
                [23100000, 25500000, "q11.23", "gneg"],
                [25500000, 29200000, "q12.1", "gpos50"],
                [29200000, 31800000, "q12.2", "gneg"],
                [31800000, 37200000, "q12.3", "gpos50"],
                [37200000, 40600000, "q13.1", "gneg"],
                [40600000, 43800000, "q13.2", "gpos50"],
                [43800000, 48100000, "q13.31", "gneg"],
                [48100000, 49100000, "q13.32", "gpos50"],
                [49100000, 50818468, "q13.33", "gneg"]
            ],
            X: [
                [0, 4400000, "p22.33", "gneg"],
                [4400000, 6100000, "p22.32", "gpos50"],
                [6100000, 9600000, "p22.31", "gneg"],
                [9600000, 17400000, "p22.2", "gpos50"],
                [17400000, 19200000, "p22.13", "gneg"],
                [19200000, 21900000, "p22.12", "gpos50"],
                [21900000, 24900000, "p22.11", "gneg"],
                [24900000, 29300000, "p21.3", "gpos100"],
                [29300000, 31500000, "p21.2", "gneg"],
                [31500000, 37800000, "p21.1", "gpos100"],
                [37800000, 42500000, "p11.4", "gneg"],
                [42500000, 47600000, "p11.3", "gpos75"],
                [47600000, 50100000, "p11.23", "gneg"],
                [50100000, 54800000, "p11.22", "gpos25"],
                [54800000, 58100000, "p11.21", "gneg"],
                [58100000, 61000000, "p11.1", "acen"],
                [61000000, 63800000, "q11.1", "acen"],
                [63800000, 65400000, "q11.2", "gneg"],
                [65400000, 68500000, "q12", "gpos50"],
                [68500000, 73000000, "q13.1", "gneg"],
                [73000000, 74700000, "q13.2", "gpos50"],
                [74700000, 76800000, "q13.3", "gneg"],
                [76800000, 85400000, "q21.1", "gpos100"],
                [85400000, 87000000, "q21.2", "gneg"],
                [87000000, 92700000, "q21.31", "gpos100"],
                [92700000, 94300000, "q21.32", "gneg"],
                [94300000, 99100000, "q21.33", "gpos75"],
                [99100000, 103300000, "q22.1", "gneg"],
                [103300000, 104500000, "q22.2", "gpos50"],
                [104500000, 109400000, "q22.3", "gneg"],
                [109400000, 117400000, "q23", "gpos75"],
                [117400000, 121800000, "q24", "gneg"],
                [121800000, 129500000, "q25", "gpos100"],
                [129500000, 131300000, "q26.1", "gneg"],
                [131300000, 134500000, "q26.2", "gpos25"],
                [134500000, 138900000, "q26.3", "gneg"],
                [138900000, 141200000, "q27.1", "gpos75"],
                [141200000, 143000000, "q27.2", "gneg"],
                [143000000, 148000000, "q27.3", "gpos100"],
                [148000000, 156040895, "q28", "gneg"]
            ],
            Y: [
                [0, 300000, "p11.32", "gneg"],
                [300000, 600000, "p11.31", "gpos50"],
                [600000, 10300000, "p11.2", "gneg"],
                [10300000, 10400000, "p11.1", "acen"],
                [10400000, 10600000, "q11.1", "acen"],
                [10600000, 12400000, "q11.21", "gneg"],
                [12400000, 17100000, "q11.221", "gpos50"],
                [17100000, 19600000, "q11.222", "gneg"],
                [19600000, 23800000, "q11.223", "gpos50"],
                [23800000, 26600000, "q11.23", "gneg"],
                [26600000, 57227415, "q12", "gvar"]
            ]
        }
    }
};
CanvasXpress.graphTypes = {
    Area: ["Area"],
    AreaLine: ["AreaLine"],
    Bar: ["Bar"],
    BarLine: ["BarLine"],
    Boxplot: ["Boxplot"],
    Fish: ["Fish"],
    Gantt: ["Gantt"],
    Circular: ["Circular"],
    Correlation: ["Correlation"],
    DotLine: ["DotLine"],
    Dotplot: ["Dotplot"],
    Genome: ["Genome"],
    Heatmap: ["Heatmap"],
    Line: ["Line"],
    Map: ["Map"],
    Meter: ["Meter"],
    Network: ["Network"],
    ParallelCoordinates: ["ParallelCoordinates"],
    Pie: ["Pie"],
    Sankey: ["Sankey"],
    Scatter2D: ["Scatter2D"],
    ScatterBubble2D: ["ScatterBubble2D"],
    Scatter3D: ["Scatter3D"],
    Stacked: ["Stacked"],
    StackedLine: ["StackedLine"],
    StackedPercent: ["StackedPercent"],
    StackedPercentLine: ["StackedPercentLine"],
    TagCloud: ["TagCloud"],
    Tree: ["Tree"],
    Treemap: ["Treemap"],
    Venn: ["Venn"],
    DotGraphs: ["Boxplot", "DotLine", "Dotplot"],
    LineGraphs: ["AreaLine", "BarLine", "DotLine", "Line", "ParallelCoordinates", "StackedLine", "StackedPercentLine"],
    ScatterGraphs: ["Scatter2D", "ScatterBubble2D", "Scatter3D"],
    StackedGraphs: ["Stacked", "StackedLine", "StackedPercent", "StackedPercentLine"],
    OneDPlots: ["Area", "AreaLine", "Bar", "BarLine", "Boxplot", "Gantt", "Meter", "DotLine", "Dotplot", "Heatmap", "Line", "ParallelCoordinates", "Sankey", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "TagCloud", "Tree", "Treemap"],
    OneDGraphs: ["Area", "AreaLine", "Bar", "BarLine", "Boxplot", "Gantt", "Meter", "DotLine", "Dotplot", "Heatmap", "Line", "ParallelCoordinates", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine"],
    OneTwoThreeeDGraphs: ["Area", "AreaLine", "Bar", "BarLine", "Boxplot", "Fish", "Gantt", "Meter", "Circular", "DotLine", "Dotplot", "Heatmap", "Line", "ParallelCoordinates", "Pie", "Scatter2D", "ScatterBubble2D", "Scatter3D", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "Treemap"],
    AllGraphs: ["Area", "AreaLine", "Bar", "BarLine", "Boxplot", "Gantt", "Fish", "Meter", "Circular", "Correlation", "DotLine", "Dotplot", "Genome", "Heatmap", "Line", "Map", "Network", "ParallelCoordinates", "Pie", "Sankey", "Scatter2D", "ScatterBubble2D", "Scatter3D", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "TagCloud", "Tree", "Treemap", "Venn"],
    AGraphs: ["Area", "AreaLine", "Bar", "BarLine", "Boxplot", "Gantt", "Fish", "Meter", "Circular", "Correlation", "DotLine", "Dotplot", "Heatmap", "Line", "Map", "ParallelCoordinates", "Sankey", "Scatter2D", "ScatterBubble2D", "Scatter3D", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "TagCloud", "Tree", "Treemap"],
    AttGraphs: ["Bar", "BarLine", "Boxplot", "Dotplot", "Treemap", "Heatmap", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "ParallelCoordinates", "Line", "Sankey", "Tree", "TagCloud", "Gantt"],
    NoneDGraphs: ["Fish", "Genome", "Map", "Network", "Sankey", "TagCloud", "Tree", "Treemap", "Venn"],
    NonSegregatable: ["Fish", "Genome", "Map", "Network", "Sankey", "TagCloud", "Tree", "Treemap", "Venn", "Circular", "Gantt", "Meter"]
};
CanvasXpress.colorNames = {
    aliceblue: "f0f8ff",
    antiquewhite1: "ffefdb",
    antiquewhite2: "eedfcc",
    antiquewhite3: "cdc0b0",
    antiquewhite4: "8b8378",
    antiquewhite: "faebd7",
    aqua: "00ffff",
    aquamarine1: "7fffd4",
    aquamarine2: "76eec6",
    aquamarine4: "458b74",
    aquamarine: "7fffd4",
    azure1: "f0ffff",
    azure2: "e0eeee",
    azure3: "c1cdcd",
    azure4: "838b8b",
    azure: "f0ffff",
    beige: "f5f5dc",
    bisque1: "ffe4c4",
    bisque2: "eed5b7",
    bisque3: "cdb79e",
    bisque4: "8b7d6b",
    bisque: "ffe4c4",
    black: "000000",
    blanchedalmond: "ffebcd",
    blue: "0000ff",
    blue1: "0000ff",
    blue2: "0000ee",
    blue3: "1874cd",
    blue4: "00008b",
    blueviolet: "8a2be2",
    brown1: "ff4040",
    brown2: "ee3b3b",
    brown3: "cd3333",
    brown4: "8b2323",
    brown: "a52a2a",
    burlywood1: "ffd39b",
    burlywood2: "eec591",
    burlywood3: "cdaa7d",
    burlywood4: "8b7355",
    burlywood: "deb887",
    cadetblue1: "98f5ff",
    cadetblue2: "8ee5ee",
    cadetblue3: "7ac5cd",
    cadetblue4: "53868b",
    cadetblue: "5f9ea0",
    chartreuse1: "7fff00",
    chartreuse2: "76ee00",
    chartreuse3: "66cd00",
    chartreuse4: "458b00",
    chartreuse: "7fff00",
    chocolate1: "ff7f24",
    chocolate2: "ee7621",
    chocolate3: "cd661d",
    chocolate: "d2691e",
    coral1: "ff7256",
    coral2: "ee6a50",
    coral3: "cd5b45",
    coral4: "8b3e2f",
    coral: "ff7f50",
    cornflowerblue: "6495ed",
    cornsilk1: "fff8dc",
    cornsilk2: "eee8cd",
    cornsilk3: "cdc8b1",
    cornsilk4: "8b8878",
    cornsilk: "fff8dc",
    crimson: "dc143c",
    cyan: "00ffff",
    cyan1: "00ffff",
    cyan2: "00eeee",
    cyan3: "00cdcd",
    cyan4: "008b8b",
    darkblue: "00008b",
    darkcyan: "008b8b",
    darkgoldenrod1: "ffb90f",
    darkgoldenrod2: "eead0e",
    darkgoldenrod3: "cd950c",
    darkgoldenrod4: "8b6508",
    darkgoldenrod4: "8b6508",
    darkgoldenrod: "b8860b",
    darkgray: "a9a9a9",
    darkgreen: "006400",
    darkgrey: "a9a9a9",
    darkkhaki: "bdb76b",
    darkmagenta: "8b008b",
    darkolivegreen1: "caff70",
    darkolivegreen2: "bcee68",
    darkolivegreen3: "a2cd5a",
    darkolivegreen4: "6e8b3d",
    darkolivegreen: "556b2f",
    darkorange1: "ff7f00",
    darkorange2: "ee7600",
    darkorange3: "cd6600",
    darkorange4: "8b4500",
    darkorange: "ff8c00",
    darkorchid1: "bf3eff",
    darkorchid2: "b23aee",
    darkorchid3: "9a32cd",
    darkorchid4: "68228b",
    darkorchid: "9932cc",
    darkred: "8b0000",
    darksalmon: "e9967a",
    darkseagreen1: "c1ffc1",
    darkseagreen2: "b4eeb4",
    darkseagreen3: "9bcd9b",
    darkseagreen4: "698b69",
    darkseagreen: "8fbc8f",
    darkslateblue: "483d8b",
    darkslategray1: "97ffff",
    darkslategray2: "8deeee",
    darkslategray: "2f4f4f",
    darkslategray3: "79cdcd",
    darkslategray4: "528b8b",
    darkslategrey: "2f4f4f",
    darkturquoise: "00ced1",
    darkviolet: "9400d3",
    deeppink1: "ff1493",
    deeppink2: "ee1289",
    deeppink3: "cd1076",
    deeppink4: "8b0a50",
    deeppink: "ff1493",
    deepskyblue: "00bfff",
    deepskyblue1: "00bfff",
    deepskyblue2: "00b2ee",
    deepskyblue3: "009acd",
    deepskyblue4: "00688b",
    dimgray: "696969",
    dimgrey: "696969",
    dodgerblue1: "1e90ff",
    dodgerblue: "1e90ff",
    dodgerblue2: "1c86ee",
    dodgerblue3: "1874cd",
    dodgerblue4: "104e8b",
    firebrick1: "ff3030",
    firebrick2: "ee2c2c",
    firebrick3: "cd2626",
    firebrick4: "8b1a1a",
    firebrick: "b22222",
    floralwhite: "fffaf0",
    forestgreen: "228b22",
    fuchsia: "ff00ff",
    gainsboro: "dcdcdc",
    ghostwhite: "f8f8ff",
    gold1: "ffd700",
    gold2: "eec900",
    gold3: "cdad00",
    gold4: "8b7500",
    goldenrod1: "ffc125",
    goldenrod2: "eeb422",
    goldenrod3: "cd9b1d",
    goldenrod4: "8b6914",
    goldenrod: "daa520",
    goldenrod: "daa520",
    gold: "ffd700",
    gray10: "1a1a1a",
    gray1: "030303",
    gray11: "1c1c1c",
    gray12: "1f1f1f",
    gray13: "212121",
    gray14: "242424",
    gray15: "262626",
    gray16: "292929",
    gray17: "2b2b2b",
    gray18: "2e2e2e",
    gray19: "303030",
    gray20: "333333",
    gray2: "050505",
    gray21: "363636",
    gray22: "383838",
    gray23: "3b3b3b",
    gray24: "3d3d3d",
    gray25: "404040",
    gray26: "424242",
    gray27: "454545",
    gray28: "474747",
    gray29: "4a4a4a",
    gray30: "4d4d4d",
    gray3: "080808",
    gray31: "4f4f4f",
    gray32: "525252",
    gray33: "545454",
    gray34: "575757",
    gray35: "595959",
    gray36: "5c5c5c",
    gray37: "5e5e5e",
    gray38: "616161",
    gray39: "636363",
    gray40: "666666",
    gray4: "0a0a0a",
    gray41: "696969",
    gray42: "6b6b6b",
    gray43: "6e6e6e",
    gray44: "707070",
    gray45: "737373",
    gray46: "757575",
    gray47: "787878",
    gray48: "7a7a7a",
    gray49: "7d7d7d",
    gray50: "7f7f7f",
    gray5: "0d0d0d",
    gray51: "828282",
    gray52: "858585",
    gray53: "878787",
    gray54: "8a8a8a",
    gray55: "8c8c8c",
    gray56: "8f8f8f",
    gray57: "919191",
    gray58: "949494",
    gray59: "969696",
    gray60: "999999",
    gray6: "0f0f0f",
    gray61: "9c9c9c",
    gray62: "9e9e9e",
    gray63: "a1a1a1",
    gray64: "a3a3a3",
    gray65: "a6a6a6",
    gray66: "a8a8a8",
    gray67: "ababab",
    gray68: "adadad",
    gray69: "b0b0b0",
    gray70: "b3b3b3",
    gray7: "121212",
    gray71: "b5b5b5",
    gray72: "b8b8b8",
    gray73: "bababa",
    gray74: "bdbdbd",
    gray75: "bfbfbf",
    gray76: "c2c2c2",
    gray77: "c4c4c4",
    gray78: "c7c7c7",
    gray79: "c9c9c9",
    gray: "808080",
    gray80: "cccccc",
    gray8: "141414",
    gray81: "cfcfcf",
    gray82: "d1d1d1",
    gray83: "d4d4d4",
    gray84: "d6d6d6",
    gray85: "d9d9d9",
    gray86: "dbdbdb",
    gray87: "dedede",
    gray88: "e0e0e0",
    gray89: "e3e3e3",
    gray90: "e5e5e5",
    gray9: "171717",
    gray91: "e8e8e8",
    gray92: "ebebeb",
    gray93: "ededed",
    gray94: "f0f0f0",
    gray95: "f2f2f2",
    gray97: "f7f7f7",
    gray98: "fafafa",
    gray99: "fcfcfc",
    gray: "bebebe",
    green: "008000",
    green1: "00ff00",
    green2: "00ee00",
    green3: "00cd00",
    green4: "008b00",
    greenyellow: "adff2f",
    grey: "808080",
    honeydew1: "f0fff0",
    honeydew2: "e0eee0",
    honeydew3: "c1cdc1",
    honeydew4: "838b83",
    honeydew: "f0fff0",
    hotpink1: "ff6eb4",
    hotpink2: "ee6aa7",
    hotpink3: "cd6090",
    hotpink4: "8b3a62",
    hotpink: "ff69b4",
    indianred1: "ff6a6a",
    indianred2: "ee6363",
    indianred3: "cd5555",
    indianred4: "8b3a3a",
    indianred: "cd5c5c",
    indigo: "4b0082",
    ivory1: "fffff0",
    ivory2: "eeeee0",
    ivory3: "cdcdc1",
    ivory4: "8b8b83",
    ivory: "fffff0",
    khaki1: "fff68f",
    khaki2: "eee685",
    khaki3: "cdc673",
    khaki4: "8b864e",
    khaki: "f0e68c",
    lavenderblush1: "fff0f5",
    lavenderblush2: "eee0e5",
    lavenderblush3: "cdc1c5",
    lavenderblush4: "8b8386",
    lavenderblush: "fff0f5",
    lavender: "e6e6fa",
    lawngreen: "7cfc00",
    lemonchiffon1: "fffacd",
    lemonchiffon2: "eee9bf",
    lemonchiffon3: "cdc9a5",
    lemonchiffon4: "8b8970",
    lemonchiffon: "fffacd",
    lightblue1: "bfefff",
    lightblue2: "b2dfee",
    lightblue3: "9ac0cd",
    lightblue4: "68838b",
    lightblue: "add8e6",
    lightcoral: "f08080",
    lightcyan1: "e0ffff",
    lightcyan2: "d1eeee",
    lightcyan3: "b4cdcd",
    lightcyan4: "7a8b8b",
    lightcyan: "e0ffff",
    light: "eedd82",
    lightgoldenrod1: "ffec8b",
    lightgoldenrod2: "eedc82",
    lightgoldenrod3: "cdbe70",
    lightgoldenrod4: "8b814c",
    lightgoldenrodyellow: "fafad2",
    lightgray: "d3d3d3",
    lightgreen: "90ee90",
    lightgrey: "d3d3d3",
    lightpink1: "ffaeb9",
    lightpink2: "eea2ad",
    lightpink3: "cd8c95",
    lightpink4: "8b5f65",
    lightpink: "ffb6c1",
    lightsalmon1: "ffa07a",
    lightsalmon2: "ee9572",
    lightsalmon3: "cd8162",
    lightsalmon4: "8b5742",
    lightsalmon: "ffa07a",
    lightseagreen: "20b2aa",
    lightskyblue1: "b0e2ff",
    lightskyblue2: "a4d3ee",
    lightskyblue3: "8db6cd",
    lightskyblue4: "607b8b",
    lightskyblue: "87cefa",
    lightslateblue: "8470ff",
    lightslategray: "778899",
    lightslategrey: "778899",
    lightsteelblue1: "cae1ff",
    lightsteelblue2: "bcd2ee",
    lightsteelblue3: "a2b5cd",
    lightsteelblue4: "6e7b8b",
    lightsteelblue: "b0c4de",
    lightyellow1: "ffffe0",
    lightyellow2: "eeeed1",
    lightyellow3: "cdcdb4",
    lightyellow4: "8b8b7a",
    lightyellow: "ffffe0",
    lime: "00ff00",
    limegreen: "32cd32",
    linen: "faf0e6",
    magenta2: "ee00ee",
    magenta3: "cd00cd",
    magenta4: "8b008b",
    magenta: "ff00ff",
    maroon1: "ff34b3",
    maroon2: "ee30a7",
    maroon3: "cd2990",
    maroon4: "8b1c62",
    maroon: "800000",
    maroon: "b03060",
    medium: "66cdaa",
    mediumaquamarine: "66cdaa",
    mediumblue: "0000cd",
    mediumorchid1: "e066ff",
    mediumorchid2: "d15fee",
    mediumorchid3: "b452cd",
    mediumorchid4: "7a378b",
    mediumorchid: "ba55d3",
    mediumpurple1: "ab82ff",
    mediumpurple2: "9f79ee",
    mediumpurple3: "8968cd",
    mediumpurple4: "5d478b",
    mediumpurple: "9370db",
    mediumseagreen: "3cb371",
    mediumslateblue: "7b68ee",
    mediumspringgreen: "00fa9a",
    mediumturquoise: "48d1cc",
    mediumvioletred: "c71585",
    midnightblue: "191970",
    mintcream: "f5fffa",
    mistyrose1: "ffe4e1",
    mistyrose2: "eed5d2",
    mistyrose3: "cdb7b5",
    mistyrose4: "8b7d7b",
    mistyrose: "ffe4e1",
    moccasin: "ffe4b5",
    navajowhite1: "ffdead",
    navajowhite2: "eecfa1",
    navajowhite3: "cdb38b",
    navajowhite4: "8b795e",
    navajowhite: "ffdead",
    navy: "000080",
    navyblue: "000080",
    oldlace: "fdf5e6",
    olive: "808000",
    olivedrab1: "c0ff3e",
    olivedrab2: "b3ee3a",
    olivedrab4: "698b22",
    olivedrab: "6b8e23",
    orange1: "ffa500",
    orange2: "ee9a00",
    orange3: "cd8500",
    orange4: "8b5a00",
    orange: "ffa500",
    orangered1: "ff4500",
    orangered2: "ee4000",
    orangered3: "cd3700",
    orangered4: "8b2500",
    orangered: "ff4500",
    orchid1: "ff83fa",
    orchid2: "ee7ae9",
    orchid3: "cd69c9",
    orchid4: "8b4789",
    orchid: "da70d6",
    pale: "db7093",
    palegoldenrod: "eee8aa",
    palegreen1: "9aff9a",
    palegreen2: "90ee90",
    palegreen3: "7ccd7c",
    palegreen4: "548b54",
    palegreen: "98fb98",
    paleturquoise1: "bbffff",
    paleturquoise2: "aeeeee",
    paleturquoise3: "96cdcd",
    paleturquoise4: "668b8b",
    paleturquoise: "afeeee",
    palevioletred1: "ff82ab",
    palevioletred2: "ee799f",
    palevioletred3: "cd6889",
    palevioletred4: "8b475d",
    palevioletred: "db7093",
    papayawhip: "ffefd5",
    peachpuff1: "ffdab9",
    peachpuff2: "eecbad",
    peachpuff3: "cdaf95",
    peachpuff4: "8b7765",
    peachpuff: "ffdab9",
    peru: "cd853f",
    pink1: "ffb5c5",
    pink2: "eea9b8",
    pink3: "cd919e",
    pink4: "8b636c",
    pink: "ffc0cb",
    plum1: "ffbbff",
    plum2: "eeaeee",
    plum3: "cd96cd",
    plum4: "8b668b",
    plum: "dda0dd",
    powderblue: "b0e0e6",
    purple1: "9b30ff",
    purple2: "912cee",
    purple3: "7d26cd",
    purple4: "551a8b",
    purple: "800080",
    purple: "a020f0",
    rebeccapurple: "663399",
    red1: "ff0000",
    red2: "ee0000",
    red3: "cd0000",
    red4: "8b0000",
    red: "ff0000",
    rosybrown1: "ffc1c1",
    rosybrown2: "eeb4b4",
    rosybrown3: "cd9b9b",
    rosybrown4: "8b6969",
    rosybrown: "bc8f8f",
    royalblue1: "4876ff",
    royalblue2: "436eee",
    royalblue3: "3a5fcd",
    royalblue: "4169e1",
    royalblue4: "27408b",
    saddlebrown: "8b4513",
    salmon1: "ff8c69",
    salmon2: "ee8262",
    salmon3: "cd7054",
    salmon4: "8b4c39",
    salmon: "fa8072",
    sandybrown: "f4a460",
    seagreen1: "54ff9f",
    seagreen2: "4eee94",
    seagreen: "2e8b57",
    seagreen3: "43cd80",
    seagreen4: "2e8b57",
    seashell1: "fff5ee",
    seashell2: "eee5de",
    seashell3: "cdc5bf",
    seashell4: "8b8682",
    seashell: "fff5ee",
    sienna1: "ff8247",
    sienna2: "ee7942",
    sienna3: "cd6839",
    sienna4: "8b4726",
    sienna: "a0522d",
    silver: "c0c0c0",
    skyblue1: "87ceff",
    skyblue2: "7ec0ee",
    skyblue3: "6ca6cd",
    skyblue4: "4a708b",
    skyblue: "87ceeb",
    slateblue1: "836fff",
    slateblue2: "7a67ee",
    slateblue3: "6959cd",
    slateblue4: "473c8b",
    slateblue: "6a5acd",
    slategray1: "c6e2ff",
    slategray2: "b9d3ee",
    slategray3: "9fb6cd",
    slategray4: "6c7b8b",
    slategray: "708090",
    slategrey: "708090",
    snow1: "fffafa",
    snow2: "eee9e9",
    snow3: "cdc9c9",
    snow4: "8b8989",
    snow: "fffafa",
    springgreen: "00ff7f",
    springgreen1: "00ff7f",
    springgreen2: "00ee76",
    springgreen3: "00cd66",
    springgreen4: "008b45",
    steelblue1: "63b8ff",
    steelblue2: "5cacee",
    steelblue3: "4f94cd",
    steelblue4: "36648b",
    steelblue: "4682b4",
    tan1: "ffa54f",
    tan2: "ee9a49",
    tan3: "cd853f",
    tan4: "8b5a2b",
    tan: "d2b48c",
    teal: "008080",
    thistle1: "ffe1ff",
    thistle2: "eed2ee",
    thistle3: "cdb5cd",
    thistle4: "8b7b8b",
    thistle: "d8bfd8",
    tomato1: "ff6347",
    tomato2: "ee5c42",
    tomato3: "cd4f39",
    tomato4: "8b3626",
    tomato: "ff6347",
    turquoise1: "00f5ff",
    turquoise2: "00e5ee",
    turquoise3: "00c5cd",
    turquoise4: "00868b",
    turquoise: "40e0d0",
    violet: "ee82ee",
    violetred1: "ff3e96",
    violetred2: "ee3a8c",
    violetred3: "cd3278",
    violetred4: "8b2252",
    violetred: "d02090",
    wheat1: "ffe7ba",
    wheat2: "eed8ae",
    wheat3: "cdba96",
    wheat4: "8b7e66",
    wheat: "f5deb3",
    white: "ffffff",
    whitesmoke: "f5f5f5",
    yellow1: "ffff00",
    yellow2: "eeee00",
    yellow3: "cdcd00",
    yellow4: "8b8b00",
    yellow: "ffff00",
    yellowgreen: "9acd32"
};
CanvasXpress.setColorSchemes = function() {
    CanvasXpress.colorSchemes = {
        YlGn: {
            3: "f7fcb9addd8e31a354",
            4: "ffffccc2e69978c679238443",
            5: "ffffccc2e69978c67931a354006837",
            6: "ffffccd9f0a3addd8e78c67931a354006837",
            7: "ffffccd9f0a3addd8e78c67941ab5d238443005a32",
            8: "ffffe5f7fcb9d9f0a3addd8e78c67941ab5d238443005a32",
            9: "ffffe5f7fcb9d9f0a3addd8e78c67941ab5d238443006837004529"
        },
        YlGnBu: {
            3: "edf8b17fcdbb2c7fb8",
            4: "ffffcca1dab441b6c4225ea8",
            5: "ffffcca1dab441b6c42c7fb8253494",
            6: "ffffccc7e9b47fcdbb41b6c42c7fb8253494",
            7: "ffffccc7e9b47fcdbb41b6c41d91c0225ea80c2c84",
            8: "ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea80c2c84",
            9: "ffffd9edf8b1c7e9b47fcdbb41b6c41d91c0225ea8253494081d58"
        },
        GnBu: {
            3: "e0f3dba8ddb543a2ca",
            4: "f0f9e8bae4bc7bccc42b8cbe",
            5: "f0f9e8bae4bc7bccc443a2ca0868ac",
            6: "f0f9e8ccebc5a8ddb57bccc443a2ca0868ac",
            7: "f0f9e8ccebc5a8ddb57bccc44eb3d32b8cbe08589e",
            8: "f7fcf0e0f3dbccebc5a8ddb57bccc44eb3d32b8cbe08589e",
            9: "f7fcf0e0f3dbccebc5a8ddb57bccc44eb3d32b8cbe0868ac084081"
        },
        BuGn: {
            3: "e5f5f999d8c92ca25f",
            4: "edf8fbb2e2e266c2a4238b45",
            5: "edf8fbb2e2e266c2a42ca25f006d2c",
            6: "edf8fbccece699d8c966c2a42ca25f006d2c",
            7: "edf8fbccece699d8c966c2a441ae76238b45005824",
            8: "f7fcfde5f5f9ccece699d8c966c2a441ae76238b45005824",
            9: "f7fcfde5f5f9ccece699d8c966c2a441ae76238b45006d2c00441b"
        },
        PuBuGn: {
            3: "ece2f0a6bddb1c9099",
            4: "f6eff7bdc9e167a9cf02818a",
            5: "f6eff7bdc9e167a9cf1c9099016c59",
            6: "f6eff7d0d1e6a6bddb67a9cf1c9099016c59",
            7: "f6eff7d0d1e6a6bddb67a9cf3690c002818a016450",
            8: "fff7fbece2f0d0d1e6a6bddb67a9cf3690c002818a016450",
            9: "fff7fbece2f0d0d1e6a6bddb67a9cf3690c002818a016c59014636"
        },
        PuBu: {
            3: "ece7f2a6bddb2b8cbe",
            4: "f1eef6bdc9e174a9cf0570b0",
            5: "f1eef6bdc9e174a9cf2b8cbe045a8d",
            6: "f1eef6d0d1e6a6bddb74a9cf2b8cbe045a8d",
            7: "f1eef6d0d1e6a6bddb74a9cf3690c00570b0034e7b",
            8: "fff7fbece7f2d0d1e6a6bddb74a9cf3690c00570b0034e7b",
            9: "fff7fbece7f2d0d1e6a6bddb74a9cf3690c00570b0045a8d023858"
        },
        BuPu: {
            3: "e0ecf49ebcda8856a7",
            4: "edf8fbb3cde38c96c688419d",
            5: "edf8fbb3cde38c96c68856a7810f7c",
            6: "edf8fbbfd3e69ebcda8c96c68856a7810f7c",
            7: "edf8fbbfd3e69ebcda8c96c68c6bb188419d6e016b",
            8: "f7fcfde0ecf4bfd3e69ebcda8c96c68c6bb188419d6e016b",
            9: "f7fcfde0ecf4bfd3e69ebcda8c96c68c6bb188419d810f7c4d004b"
        },
        RdPu: {
            3: "fde0ddfa9fb5c51b8a",
            4: "feebe2fbb4b9f768a1ae017e",
            5: "feebe2fbb4b9f768a1c51b8a7a0177",
            6: "feebe2fcc5c0fa9fb5f768a1c51b8a7a0177",
            7: "feebe2fcc5c0fa9fb5f768a1dd3497ae017e7a0177",
            8: "fff7f3fde0ddfcc5c0fa9fb5f768a1dd3497ae017e7a0177",
            9: "fff7f3fde0ddfcc5c0fa9fb5f768a1dd3497ae017e7a017749006a"
        },
        PuRd: {
            3: "e7e1efc994c7dd1c77",
            4: "f1eef6d7b5d8df65b0ce1256",
            5: "f1eef6d7b5d8df65b0dd1c77980043",
            6: "f1eef6d4b9dac994c7df65b0dd1c77980043",
            7: "f1eef6d4b9dac994c7df65b0e7298ace125691003f",
            8: "f7f4f9e7e1efd4b9dac994c7df65b0e7298ace125691003f",
            9: "f7f4f9e7e1efd4b9dac994c7df65b0e7298ace125698004367001f"
        },
        OrRd: {
            3: "fee8c8fdbb84e34a33",
            4: "fef0d9fdcc8afc8d59d7301f",
            5: "fef0d9fdcc8afc8d59e34a33b30000",
            6: "fef0d9fdd49efdbb84fc8d59e34a33b30000",
            7: "fef0d9fdd49efdbb84fc8d59ef6548d7301f990000",
            8: "fff7ecfee8c8fdd49efdbb84fc8d59ef6548d7301f990000",
            9: "fff7ecfee8c8fdd49efdbb84fc8d59ef6548d7301fb300007f0000"
        },
        YlOrRd: {
            3: "ffeda0feb24cf03b20",
            4: "ffffb2fecc5cfd8d3ce31a1c",
            5: "ffffb2fecc5cfd8d3cf03b20bd0026",
            6: "ffffb2fed976feb24cfd8d3cf03b20bd0026",
            7: "ffffb2fed976feb24cfd8d3cfc4e2ae31a1cb10026",
            8: "ffffccffeda0fed976feb24cfd8d3cfc4e2ae31a1cb10026",
            9: "ffffccffeda0fed976feb24cfd8d3cfc4e2ae31a1cbd0026800026"
        },
        YlOrBr: {
            3: "fff7bcfec44fd95f0e",
            4: "ffffd4fed98efe9929cc4c02",
            5: "ffffd4fed98efe9929d95f0e993404",
            6: "ffffd4fee391fec44ffe9929d95f0e993404",
            7: "ffffd4fee391fec44ffe9929ec7014cc4c028c2d04",
            8: "ffffe5fff7bcfee391fec44ffe9929ec7014cc4c028c2d04",
            9: "ffffe5fff7bcfee391fec44ffe9929ec7014cc4c02993404662506"
        },
        Purples: {
            3: "efedf5bcbddc756bb1",
            4: "f2f0f7cbc9e29e9ac86a51a3",
            5: "f2f0f7cbc9e29e9ac8756bb154278f",
            6: "f2f0f7dadaebbcbddc9e9ac8756bb154278f",
            7: "f2f0f7dadaebbcbddc9e9ac8807dba6a51a34a1486",
            8: "fcfbfdefedf5dadaebbcbddc9e9ac8807dba6a51a34a1486",
            9: "fcfbfdefedf5dadaebbcbddc9e9ac8807dba6a51a354278f3f007d"
        },
        Blues: {
            3: "deebf79ecae13182bd",
            4: "eff3ffbdd7e76baed62171b5",
            5: "eff3ffbdd7e76baed63182bd08519c",
            6: "eff3ffc6dbef9ecae16baed63182bd08519c",
            7: "eff3ffc6dbef9ecae16baed64292c62171b5084594",
            8: "f7fbffdeebf7c6dbef9ecae16baed64292c62171b5084594",
            9: "f7fbffdeebf7c6dbef9ecae16baed64292c62171b508519c08306b"
        },
        Greens: {
            3: "e5f5e0a1d99b31a354",
            4: "edf8e9bae4b374c476238b45",
            5: "edf8e9bae4b374c47631a354006d2c",
            6: "edf8e9c7e9c0a1d99b74c47631a354006d2c",
            7: "edf8e9c7e9c0a1d99b74c47641ab5d238b45005a32",
            8: "f7fcf5e5f5e0c7e9c0a1d99b74c47641ab5d238b45005a32",
            9: "f7fcf5e5f5e0c7e9c0a1d99b74c47641ab5d238b45006d2c00441b"
        },
        Oranges: {
            3: "fee6cefdae6be6550d",
            4: "feeddefdbe85fd8d3cd94701",
            5: "feeddefdbe85fd8d3ce6550da63603",
            6: "feeddefdd0a2fdae6bfd8d3ce6550da63603",
            7: "feeddefdd0a2fdae6bfd8d3cf16913d948018c2d04",
            8: "fff5ebfee6cefdd0a2fdae6bfd8d3cf16913d948018c2d04",
            9: "fff5ebfee6cefdd0a2fdae6bfd8d3cf16913d94801a636037f2704"
        },
        Reds: {
            3: "fee0d2fc9272de2d26",
            4: "fee5d9fcae91fb6a4acb181d",
            5: "fee5d9fcae91fb6a4ade2d26a50f15",
            6: "fee5d9fcbba1fc9272fb6a4ade2d26a50f15",
            7: "fee5d9fcbba1fc9272fb6a4aef3b2ccb181d99000d",
            8: "fff5f0fee0d2fcbba1fc9272fb6a4aef3b2ccb181d99000d",
            9: "fff5f0fee0d2fcbba1fc9272fb6a4aef3b2ccb181da50f1567000d"
        },
        Greys: {
            3: "f0f0f0bdbdbd636363",
            4: "f7f7f7cccccc969696525252",
            5: "f7f7f7cccccc969696636363252525",
            6: "f7f7f7d9d9d9bdbdbd969696636363252525",
            7: "f7f7f7d9d9d9bdbdbd969696737373525252252525",
            8: "fffffff0f0f0d9d9d9bdbdbd969696737373525252252525",
            9: "fffffff0f0f0d9d9d9bdbdbd969696737373525252252525000000"
        },
        PuOr: {
            3: "f1a340f7f7f7998ec3",
            4: "e66101fdb863b2abd25e3c99",
            5: "e66101fdb863f7f7f7b2abd25e3c99",
            6: "b35806f1a340fee0b6d8daeb998ec3542788",
            7: "b35806f1a340fee0b6f7f7f7d8daeb998ec3542788",
            8: "b35806e08214fdb863fee0b6d8daebb2abd28073ac542788",
            9: "b35806e08214fdb863fee0b6f7f7f7d8daebb2abd28073ac542788",
            10: "7f3b08b35806e08214fdb863fee0b6d8daebb2abd28073ac5427882d004b",
            11: "7f3b08b35806e08214fdb863fee0b6f7f7f7d8daebb2abd28073ac5427882d004b"
        },
        BrBG: {
            3: "d8b365f5f5f55ab4ac",
            4: "a6611adfc27d80cdc1018571",
            5: "a6611adfc27df5f5f580cdc1018571",
            6: "8c510ad8b365f6e8c3c7eae55ab4ac01665e",
            7: "8c510ad8b365f6e8c3f5f5f5c7eae55ab4ac01665e",
            8: "8c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e",
            9: "8c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e",
            10: "5430058c510abf812ddfc27df6e8c3c7eae580cdc135978f01665e003c30",
            11: "5430058c510abf812ddfc27df6e8c3f5f5f5c7eae580cdc135978f01665e003c30"
        },
        PRGn: {
            3: "af8dc3f7f7f77fbf7b",
            4: "7b3294c2a5cfa6dba0008837",
            5: "7b3294c2a5cff7f7f7a6dba0008837",
            6: "762a83af8dc3e7d4e8d9f0d37fbf7b1b7837",
            7: "762a83af8dc3e7d4e8f7f7f7d9f0d37fbf7b1b7837",
            8: "762a839970abc2a5cfe7d4e8d9f0d3a6dba05aae611b7837",
            9: "762a839970abc2a5cfe7d4e8f7f7f7d9f0d3a6dba05aae611b7837",
            10: "40004b762a839970abc2a5cfe7d4e8d9f0d3a6dba05aae611b783700441b",
            11: "40004b762a839970abc2a5cfe7d4e8f7f7f7d9f0d3a6dba05aae611b783700441b"
        },
        PiYG: {
            3: "e9a3c9f7f7f7a1d76a",
            4: "d01c8bf1b6dab8e1864dac26",
            5: "d01c8bf1b6daf7f7f7b8e1864dac26",
            6: "c51b7de9a3c9fde0efe6f5d0a1d76a4d9221",
            7: "c51b7de9a3c9fde0eff7f7f7e6f5d0a1d76a4d9221",
            8: "c51b7dde77aef1b6dafde0efe6f5d0b8e1867fbc414d9221",
            9: "c51b7dde77aef1b6dafde0eff7f7f7e6f5d0b8e1867fbc414d9221",
            10: "8e0152c51b7dde77aef1b6dafde0efe6f5d0b8e1867fbc414d9221276419",
            11: "8e0152c51b7dde77aef1b6dafde0eff7f7f7e6f5d0b8e1867fbc414d9221276419"
        },
        RdBu: {
            3: "ef8a62f7f7f767a9cf",
            4: "ca0020f4a58292c5de0571b0",
            5: "ca0020f4a582f7f7f792c5de0571b0",
            6: "b2182bef8a62fddbc7d1e5f067a9cf2166ac",
            7: "b2182bef8a62fddbc7f7f7f7d1e5f067a9cf2166ac",
            8: "b2182bd6604df4a582fddbc7d1e5f092c5de4393c32166ac",
            9: "b2182bd6604df4a582fddbc7f7f7f7d1e5f092c5de4393c32166ac",
            10: "67001fb2182bd6604df4a582fddbc7d1e5f092c5de4393c32166ac053061",
            11: "67001fb2182bd6604df4a582fddbc7f7f7f7d1e5f092c5de4393c32166ac053061"
        },
        RdGy: {
            3: "ef8a62ffffff999999",
            4: "ca0020f4a582bababa404040",
            5: "ca0020f4a582ffffffbababa404040",
            6: "b2182bef8a62fddbc7e0e0e09999994d4d4d",
            7: "b2182bef8a62fddbc7ffffffe0e0e09999994d4d4d",
            8: "b2182bd6604df4a582fddbc7e0e0e0bababa8787874d4d4d",
            9: "b2182bd6604df4a582fddbc7ffffffe0e0e0bababa8787874d4d4d",
            10: "67001fb2182bd6604df4a582fddbc7e0e0e0bababa8787874d4d4d1a1a1a",
            11: "67001fb2182bd6604df4a582fddbc7ffffffe0e0e0bababa8787874d4d4d1a1a1a"
        },
        RdYlBu: {
            3: "fc8d59ffffbf91bfdb",
            4: "d7191cfdae61abd9e92c7bb6",
            5: "d7191cfdae61ffffbfabd9e92c7bb6",
            6: "d73027fc8d59fee090e0f3f891bfdb4575b4",
            7: "d73027fc8d59fee090ffffbfe0f3f891bfdb4575b4",
            8: "d73027f46d43fdae61fee090e0f3f8abd9e974add14575b4",
            9: "d73027f46d43fdae61fee090ffffbfe0f3f8abd9e974add14575b4",
            10: "a50026d73027f46d43fdae61fee090e0f3f8abd9e974add14575b4313695",
            11: "a50026d73027f46d43fdae61fee090ffffbfe0f3f8abd9e974add14575b4313695"
        },
        Spectral: {
            3: "fc8d59ffffbf99d594",
            4: "d7191cfdae61abdda42b83ba",
            5: "d7191cfdae61ffffbfabdda42b83ba",
            6: "d53e4ffc8d59fee08be6f59899d5943288bd",
            7: "d53e4ffc8d59fee08bffffbfe6f59899d5943288bd",
            8: "d53e4ff46d43fdae61fee08be6f598abdda466c2a53288bd",
            9: "d53e4ff46d43fdae61fee08bffffbfe6f598abdda466c2a53288bd",
            10: "9e0142d53e4ff46d43fdae61fee08be6f598abdda466c2a53288bd5e4fa2",
            11: "9e0142d53e4ff46d43fdae61fee08bffffbfe6f598abdda466c2a53288bd5e4fa2"
        },
        RdYlGn: {
            3: "fc8d59ffffbf91cf60",
            4: "d7191cfdae61a6d96a1a9641",
            5: "d7191cfdae61ffffbfa6d96a1a9641",
            6: "d73027fc8d59fee08bd9ef8b91cf601a9850",
            7: "d73027fc8d59fee08bffffbfd9ef8b91cf601a9850",
            8: "d73027f46d43fdae61fee08bd9ef8ba6d96a66bd631a9850",
            9: "d73027f46d43fdae61fee08bffffbfd9ef8ba6d96a66bd631a9850",
            10: "a50026d73027f46d43fdae61fee08bd9ef8ba6d96a66bd631a9850006837",
            11: "a50026d73027f46d43fdae61fee08bffffbfd9ef8ba6d96a66bd631a9850006837"
        },
        Accent: {
            3: "7fc97fbeaed4fdc086",
            4: "7fc97fbeaed4fdc086ffff99",
            5: "7fc97fbeaed4fdc086ffff99386cb0",
            6: "7fc97fbeaed4fdc086ffff99386cb0f0027f",
            7: "7fc97fbeaed4fdc086ffff99386cb0f0027fbf5b17",
            8: "7fc97fbeaed4fdc086ffff99386cb0f0027fbf5b17666666"
        },
        Dark2: {
            3: "1b9e77d95f027570b3",
            4: "1b9e77d95f027570b3e7298a",
            5: "1b9e77d95f027570b3e7298a66a61e",
            6: "1b9e77d95f027570b3e7298a66a61ee6ab02",
            7: "1b9e77d95f027570b3e7298a66a61ee6ab02a6761d",
            8: "1b9e77d95f027570b3e7298a66a61ee6ab02a6761d666666"
        },
        Paired: {
            3: "a6cee31f78b4b2df8a",
            4: "a6cee31f78b4b2df8a33a02c",
            5: "a6cee31f78b4b2df8a33a02cfb9a99",
            6: "a6cee31f78b4b2df8a33a02cfb9a99e31a1c",
            7: "a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6f",
            8: "a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6fff7f00",
            9: "a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6fff7f00cab2d6",
            10: "a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6fff7f00cab2d66a3d9a",
            11: "a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6fff7f00cab2d66a3d9affff99",
            12: "a6cee31f78b4b2df8a33a02cfb9a99e31a1cfdbf6fff7f00cab2d66a3d9affff99b15928"
        },
        Pastel1: {
            3: "fbb4aeb3cde3ccebc5",
            4: "fbb4aeb3cde3ccebc5decbe4",
            5: "fbb4aeb3cde3ccebc5decbe4fed9a6",
            6: "fbb4aeb3cde3ccebc5decbe4fed9a6ffffcc",
            7: "fbb4aeb3cde3ccebc5decbe4fed9a6ffffcce5d8bd",
            8: "fbb4aeb3cde3ccebc5decbe4fed9a6ffffcce5d8bdfddaec",
            9: "fbb4aeb3cde3ccebc5decbe4fed9a6ffffcce5d8bdfddaecf2f2f2"
        },
        Pastel2: {
            3: "b3e2cdfdcdaccbd5e8",
            4: "b3e2cdfdcdaccbd5e8f4cae4",
            5: "b3e2cdfdcdaccbd5e8f4cae4e6f5c9",
            6: "b3e2cdfdcdaccbd5e8f4cae4e6f5c9fff2ae",
            7: "b3e2cdfdcdaccbd5e8f4cae4e6f5c9fff2aef1e2cc",
            8: "b3e2cdfdcdaccbd5e8f4cae4e6f5c9fff2aef1e2cccccccc"
        },
        Set1: {
            3: "e41a1c377eb84daf4a",
            4: "e41a1c377eb84daf4a984ea3",
            5: "e41a1c377eb84daf4a984ea3ff7f00",
            6: "e41a1c377eb84daf4a984ea3ff7f00ffff33",
            7: "e41a1c377eb84daf4a984ea3ff7f00ffff33a65628",
            8: "e41a1c377eb84daf4a984ea3ff7f00ffff33a65628f781bf",
            9: "e41a1c377eb84daf4a984ea3ff7f00ffff33a65628f781bf999999"
        },
        Set2: {
            3: "66c2a5fc8d628da0cb",
            4: "66c2a5fc8d628da0cbe78ac3",
            5: "66c2a5fc8d628da0cbe78ac3a6d854",
            6: "66c2a5fc8d628da0cbe78ac3a6d854ffd92f",
            7: "66c2a5fc8d628da0cbe78ac3a6d854ffd92fe5c494",
            8: "66c2a5fc8d628da0cbe78ac3a6d854ffd92fe5c494b3b3b3"
        },
        Set3: {
            3: "8dd3c7ffffb3bebada",
            4: "8dd3c7ffffb3bebadafb8072",
            5: "8dd3c7ffffb3bebadafb807280b1d3",
            6: "8dd3c7ffffb3bebadafb807280b1d3fdb462",
            7: "8dd3c7ffffb3bebadafb807280b1d3fdb462b3de69",
            8: "8dd3c7ffffb3bebadafb807280b1d3fdb462b3de69fccde5",
            9: "8dd3c7ffffb3bebadafb807280b1d3fdb462b3de69fccde5d9d9d9",
            10: "8dd3c7ffffb3bebadafb807280b1d3fdb462b3de69fccde5d9d9d9bc80bd",
            11: "8dd3c7ffffb3bebadafb807280b1d3fdb462b3de69fccde5d9d9d9bc80bdccebc5",
            12: "8dd3c7ffffb3bebadafb807280b1d3fdb462b3de69fccde5d9d9d9bc80bdccebc5ffed6f"
        },
        Default: {
            20: "fe296c487eb6a7ce31f8cc03ff8c02699696b7784483acd0c2e076fadc5aff549fffaf549ab8b7d2a6833d699b87ac22cda908d02158d07300567676",
            36: "ff00000000ff00ff00ffff0000ffffff00ff993300000080808000ff6600008080660066ff99cc666699333300ffcc99ccffff9999ffff80803366ff339966ffcc0000ccffd020909933660066cc99cc00ff990033cccccc99ff800000333399008000ffffcc99ccff800080"
        },
        Basic: {
            24: "0000ffff004dffbf0074ff00a400ffff7400ffff0000ffffff0000ffd3003d00ff00ff00ff00ffff9200d3ff000090ff6d00ffff4900ffe80000ff92ff0090ffaa00aaff00004dff"
        },
        Light: {
            24: "6565ffff6593ffd865abff65c865ffffab65ffff6565ffffff6565ffe5658965ff65ff65ff65ffffbd65e5ff6565bcffa765ffff9165fff16565ffbdff65bcffcc65ccff656593ff"
        },
        Favorite: {
            1: "ff0000",
            2: "ff000000ffff",
            3: "ff000000ff000000ff",
            4: "ff000080ff0000ffff8000ff",
            5: "ff0000bfff0000ff800040ffff00ff",
            6: "ff0000ffff0000ff0000ffff0000ffff00ff",
            8: "ff0000ffbf0080ff0000ff4000ffff0040ff8000ffff00bf",
            10: "ff0000ff8000ffff0080ff0000ff0000ff8000ffff0080ff0000ff8000ff",
            12: "ff0000ff8000ffff0080ff0000ff0000ff8000ffff0080ff0000ff8000ffff00ffff0080",
            24: "ff0000ff4000ff8000ffbf00ffff00bfff0080ff0040ff0000ff0000ff4000ff8000ffbf00ffff00bfff0080ff0040ff0000ff4000ff8000ffbf00ffff00ffff00bfff0080ff0040"
        },
        Pastel: {
            24: "b5b5ffffb5cbffedb5d7ffb5e5b5ffffd7b5ffffb5b5ffffffb5b5fff2b5c7b5ffb5ffb5ffb5ffffdfb5f2ffb5b5dfffd5b5ffffcab5fff8b5b5ffdfffb5dfffe6b5e6ffb5b5cbff"
        },
        Balanced: {
            20: "fe296c487eb6a7ce31f8cc03ff8c02699696b7784483acd0c2e076fadc5aff549fffaf549ab8b7d2a6833d699b87ac22cda908d02158d07300567676"
        },
        Rpalette: {
            8: "000000ff000000cd000000ff00ffffff00ffffff00bebebe"
        },
        RlatticeBackground: {
            7: "ffe5ccccffccccffffcce6ffffccffffccccffffcc"
        },
        RlatticeShingle: {
            7: "ff7f0000ff0000ffff0080ffff00ffff0000ffff00"
        },
        RlatticeLine: {
            7: "0080ffff00ff006400ff0000ffa50000ff00a52a2a"
        },
        RlatticePolygon: {
            7: "ccffffffccffccffccffe5cccce6ffffffccffcccc"
        },
        Bootstrap: {
            1: "337ab7",
            2: "337ab7d9534f",
            3: "337ab75cb85cd9534f",
            4: "337ab75cb85cf0ad4ed9534f",
            5: "337ab75cb85c5bc0def0ad4ed9534f",
            6: "337ab75cb85c9370db5bc0def0ad4ed9534f",
            7: "337ab75cb85cd9534ff0ad4e5bc0de84fe83ff9976",
            8: "337ab75cb85cd9534ff0ad4e5bc0de84fe83ff9976c86727"
        },
        ColorSpectrum: {
            1: ""
        },
        White: {
            1: "ffffff"
        },
        Black: {
            1: "000000"
        },
        NPG: {
            10: "e64b354dbbd500a0873c5488f39b7f8491b491d1c2dc00007e6148b09c85"
        },
        AAAS: {
            10: "3b4992ee0000008b45631879008280bb00215f559ba200568081801b1919"
        },
        NEJM: {
            8: "bc3c290072b5e1872720854e7876b16f99adffdc91ee4c97"
        },
        Lancet: {
            9: "00468bed000042b5400099b4925e9ffdaf91ad002aadb6b61b1919"
        },
        Jama: {
            7: "374e55df8f4400a1d5b2474579af976a659980796b"
        },
        JCO: {
            10: "0073c2efc000868686cd534c7aa6dc003c678f77003b3b3ba730304a6990"
        },
        Economist: {
            12: "6794a7014d6476c0c101a2d97ad2f600887dadadad7bd3f67c260bee8f7176c0c1a18376"
        },
        EconomistBG: {
            5: "d5e4ebc3d6dfed111aebebebc9c9c9"
        },
        Excel: {
            7: "ff00ffffff0000ffff8000808000000080800000ff"
        },
        Excel2: {
            7: "993366ffffccccffff660066ff80800066ccccccff"
        },
        Excel3: {
            10: "365e9698333477973d5d437c36869fd1702f8197c5c47f80acc4849887b0"
        },
        GGPlot: {
            1: "f8766d",
            2: "f8766d00bfc4",
            3: "f8766d00ba38619cff",
            4: "f8766d7cae0000bfc4c77cff",
            5: "f8766da3a50000bf7d00b0f6e76bf3",
            6: "f8766db79f0000ba3800bfc4619cfff564e3",
            7: "f8766dc49a0053b40000c09400b6eba58afffb61d7",
            8: "f8766dcd96007cae0000be6700bfc400a9ffc77cffff61cc",
            9: "f8766dd3920093aa0000ba3800c19f00b9e3619cffdb72fbff61c3",
            10: "f8766dd89000a3a50039b60000bf7d00bfc400b0f69590ffe76bf3ff62bc",
            11: "f8766ddb8e00aea20064b20000bd5c00c1a700bade00a6ffb385ffef67ebff63b6",
            12: "f8766dde8c00b79f007cae0000ba3800c08b00bfc400b4f0619cffc77cfff564e3ff64b0",
            13: "f8766de18a00be9c008cab0024b70000be7000c1ab00bbda00acfc8b93ffd575fef962ddff65ac",
            14: "f8766de38900c49a0099a80053b40000bc5600c09400bfc400b6eb06a4ffa58affdf70f8fb61d7ff66a8",
            15: "f8766de58700c99800a3a5006bb10000ba3800bf7d00c0af00bcd800b0f6619cffb983ffe76bf3fd61d1ff67a4",
            16: "f8766de68613cd9600aba3007cae000cb70200be6700c19a00bfc400b8e700a9ff8494ffc77cffed68edff61ccff68a1",
            17: "f8766de7851ed09400b2a10089ac0045b50000bc5100c08700c0b200bcd600b3f229a3ff9c8dffd277fff166e8ff61c7ff689e",
            18: "f8766de88526d39200b79f0093aa005eb30000ba3800bf7400c19f00bfc400b9e300adfa619cffae87ffdb72fbf564e3ff61c3ff699c"
        },
        Solarized: {
            1: "b58900",
            2: "b58900859900",
            3: "b58900c671c4859900",
            4: "b58900dc322f268bd2859900",
            5: "b58900dc322f6c71c4268bd2859900",
            6: "b58900cb4b16d336826c71c42aa198859900",
            7: "b58900cb4b16dc322f6c71c4268bd22aa198859900",
            8: "b58900cb4b16dc322fd336826c71c4268bd22aa198859900"
        },
        SolarizedBase: {
            7: "002b36073642586e7583949693a1a1eee8d5fdf6e3",
            8: "002b36073642586e75657b8383949693a1a1eee8d5fdf6e3"
        },
        PaulTol: {
            1: "4477aa",
            2: "4477aacc6677",
            3: "4477aaddcc77cc6677",
            4: "4477aa117733ddcc77cc6677",
            5: "4477aa88ccee117733ddcc77cc6677",
            6: "4477aa88ccee117733ddcc77cc6677aa4499",
            7: "33228888ccee44aa99117733ddcc77cc6677aa4499",
            8: "33228888ccee44aa99117733999933ddcc77cc6677aa4499",
            9: "33228888ccee44aa99117733999933ddcc77cc6677882255aa4499",
            10: "33228888ccee44aa99117733999933ddcc77661100cc6677882255aa4499",
            11: "3322886699cc88ccee44aa99117733999933ddcc77661100cc6677882255aa4499",
            12: "3322886699cc88ccee44aa99117733999933ddcc77661100cc6677aa4466882255aa4499"
        },
        ColorBlind: {
            8: "000000e69f0056b4e9009e73f0e4420072b2d55e00cc79a7"
        },
        Tableau: {
            20: "1f77b4aec7e8ff7f0effbb782ca02c98df8ad62728ff98969467bdc5b0d58c564bc49c94e377c2f7b6d27f7f7fc7c7c7bcbd22dbdb8d17becf9edae5",
            10: "1f77b4ff7f0e2ca02cd627289467bd8c564be377c27f7f7fbcbd2217becf"
        },
        TableauMedium: {
            10: "729eceff9e4a67bf5ced665dad8bc9a8786eed97caa2a2a2cdcc5d6dccda"
        },
        TableauLight: {
            10: "aec7e8ffbb7898df8aff9896c5b0d5c49c94f7b6d2c7c7c7dbdb8d9edae5"
        },
        TableauGrey: {
            5: "60636aa5acaf4144518f8782cfcfcf"
        },
        TableauColorBlind: {
            10: "006ba4ff800eababab5959595f9ed1c85200898989a2c8ecffbc79cfcfcf"
        },
        TableauTrafficLight: {
            9: "b10318dba13a309343d82526ffc15669b764f26c64ffdd719fcd99"
        },
        TableauPurpleGrey: {
            12: "7b66d2a699e8dc5fbdffc0da5f5a41b4b19b995688d898baab6ad5d098ee8b7c6edbd4c5"
        },
        TableauBlueRed: {
            12: "2c69b0b5c8e2f02720ffb6b0ac613ce9c39b6ba3d6b5dffdac8763ddc9b4bd0a36f4737a"
        },
        TableauGreenOrange: {
            12: "32a251acd98dff7f0fffb9773cb7cc98d9e4b85a0dffd94a39737c86b4a982853bccc94d"
        },
        TableauCyclic: {
            20: "1f83b41696ac18a18829a03c54a33882a93fadb828d8bd35ffbd4cffb022ff9c0eff810ee75727d23e4ec94d8cc04aa7b446b39658b18061b46f63bb"
        },
        TableauPairSequential: {
            32: "bccfb49c0824bccfb409622ab4d4da26456ef0c2947b3014c3c3c31e1e1ee5e5e5ffb2b6e5e5e5b7e6a7e5e5e5c4d8f3e5e5e5ffcc9ef5cac7bd1100dbe8b43c8200f3e0c2bb5137feffd941b7c4f7e4c6bb5137efedf5807dbaf0f0f0737373"
        },
        TableauTripleDiverging: {
            48: "9c0824cacaca26456e9c0824cacaca09622a9c0824ffffff09622a9c0824cacaca1e1e1e9c0824ffffff1e1e1e09622acacaca26456e7b3014cacaca26456e7b3014ffffff26456effb2b6e5e5e5b7e6a7ffb2b6ffffffb7e6a7ffb2b6ffffffc6c6c6ffcc9ee5e5e5c4d8f3ffcc9effffffc4d8f3e0ad30e4e4e27492aaeda389cde1d35c8b70529985dbcf47c26b51"
        },
        WallStreetJournal: {
            4: "efefefe9f3ead4dee7f8f2e4"
        },
        WallStreetJournal2: {
            4: "d3ba68d5695d5d8ca865a479"
        },
        WallStreetJournalRedGreen: {
            2: "088158ba2f2a"
        },
        WallStreetJournalBlackGreen: {
            4: "00000059595959a77f008856"
        },
        WallStreetJournalDemRep: {
            3: "006a8eb1283aa8a6a7"
        },
        WallStreetJournal3: {
            6: "c72e29016392be9c2e098154fb832d000000"
        },
        Stata: {
            15: "1a476f90353b55752fe37e006e8e84c10534938dd2cac27ea0522d7b92a82d6d669c8847bfa19cffd200d9e6eb"
        },
        Stata2: {
            15: "ffff0000ff000080ffff00ffff7f00ff0000add8e6ffe47400ff80c0dcc0ff45000000ffff00806e8e84a0522d"
        },
        Stata3: {
            15: "006000ff45001a476f90353b6e8e84a0522dff7f00ff00ff00ffffff000000ff009c8847800080c0dcc0add8e6"
        },
        StataMono: {
            15: "606060a0a0a0808080404040000000e0e0e0202020707070909090b0b0b0d0d0d0f0f0f0303030c0c0c0505050"
        },
        BlackAndWhite: {
            3: "f0f0f0bdbdbd636363",
            4: "f7f7f7cccccc969696525252",
            5: "f7f7f7cccccc969696636363252525",
            6: "f7f7f7d9d9d9bdbdbd969696636363252525",
            7: "f7f7f7d9d9d9bdbdbd969696737373525252252525",
            8: "fffffff0f0f0d9d9d9bdbdbd969696737373525252252525",
            9: "fffffff0f0f0d9d9d9bdbdbd969696737373525252252525000000"
        },
        CanvasXpress: {
            1: "4575b4",
            2: "d730274575b4",
            3: "d7191cfdae612c7bb6",
            4: "d7191cfdae61abd9e92c7bb6",
            5: "d7191cfdae61ffffbfabd9e92c7bb6",
            6: "d73027fc8d59fee090e0f3f891bfdb4575b4",
            7: "d73027fc8d59fee090ffffbfe0f3f891bfdb4575b4",
            8: "d73027f46d43fdae61fee090e0f3f8abd9e974add14575b4",
            9: "d73027f46d43fdae61fee090ffffbfe0f3f8abd9e974add14575b4",
            10: "a50026d73027f46d43fdae61fee090e0f3f8abd9e974add14575b4313695",
            11: "a50026d73027f46d43fdae61fee090ffffbfe0f3f8abd9e974add14575b4313695"
        },
        CanvasXpressTraditional: {
            1: "f2000d",
            2: "f2000d000df2",
            3: "f2000d000df20df200",
            4: "f2000d000df20df200f2f20d",
            5: "f2000d000df20df200f2f20df20df2",
            6: "f2000d000df20df200f2f20df20df20df2f2",
            7: "f2000d000df20df200f2f20df20df20df2f2f2f2f2",
            8: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd3",
            9: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fe",
            10: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b",
            11: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d0016",
            12: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d001600165d",
            13: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d001600165d165d00",
            14: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d001600165d165d00080808",
            15: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d001600165d165d00080808fed38b",
            16: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d001600165d165d00080808fed38bd38bfe",
            17: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d001600165d165d00080808fed38bd38bfe8bfed3",
            18: "f2000d000df20df200f2f20df20df20df2f2f2f2f2fe8bd38bd3fed3fe8b5d001600165d165d00080808fed38bd38bfe8bfed3404040"
        },
        Matlab: {
            7: "0072bdd95319edb1207e2f8e77ac304dbeeea2142f"
        },
        Parula: {
            10: "352a870f5cdd127dd8079ccf15b1b459bd8ca5be6be1b952fcce2ef9fb0e"
        },
        Viridis: {
            3: "44015421908cfde725",
            4: "44015431688e35b779fde725",
            5: "4401543b528b21908c5dc863fde725",
            6: "4401544144872a788e22a8847ad151fde725",
            7: "440154443a8331688e21908c35b7798fd744fde725",
            8: "44015446337e365c8d277f8e1fa1874ac16d9fda3afde725",
            9: "440154472d7b3b528b2c728e21908c27ad815dc863aadc32fde725",
            10: "4401544828783e4a8931688e26828e1f9e8935b7796dcd59b4de2cfde725",
            11: "44015448257641448735608d2a788e21908c22a88443bf717ad151bbdf27fde725",
            12: "440154482173433e8538598c2d708e25858e1e9b8a2bb07f51c56a85d54ac2df23fde725"
        },
        Magma: {
            3: "000004b63679fcfdbf",
            4: "000004721f81f1605dfcfdbf",
            5: "00000451127cb63679fb8861fcfdbf",
            6: "0000043b0f708c2981de4968fe9f6dfcfdbf",
            7: "0000042d1160721f81b63679f1605dfeaf77fcfdbf",
            8: "0000042311515f187f982d80d3436ef8765cfeba80fcfdbf",
            9: "0000041d114751127c822681b63679e65164fb8861fec287fcfdbf",
            10: "000004180f3e451077721f819f2f7fcd4071f1605dfd9567fec98dfcfdbf",
            11: "000004150e373b0f70641a808c2981b63679de4968f76f5cfe9f6dfece91fcfdbf",
            12: "000004120d323310685a167e7d2482a3307ec83e73e95562f97c5dfea873fed395fcfdbf"
        },
        Plasma: {
            3: "0d0887cc4678f0f921",
            4: "0d08879c179eed7953f0f921",
            5: "0d08877e03a8cc4678f89441f0f921",
            6: "0d08876a00a8b12a90e16462fca636f0f921",
            7: "0d08875d01a69c179ecc4678ed7953fdb32ff0f921",
            8: "0d08875402a38b0aa5b93289db5c68f48849febc2af0f921",
            9: "0d08874c02a17e03a8a92395cc4678e56b5df89441fdc328f0f921",
            10: "0d088747039f7301a89c179ebd3786d8576bed7953fa9e3bfdc926f0f921",
            11: "0d088742049e6a00a8900da4b12a90cc4678e16462f1844bfca636fcce25f0f921",
            12: "0d08873e049c6300a78707a6a62098c03a83d5546ee76f5af58c46fdad32fcd225f0f921"
        },
        Inferno: {
            3: "000004bb3754fcffa4",
            4: "000004781c6ded6925fcffa4",
            5: "00000456106ebb3754f98c0afcffa4",
            6: "000004420a68932667dd513afca50afcffa4",
            7: "000004330a5f781c6dbb3754ed6925fcb519fcffa4",
            8: "000004280b5465156e9f2a63d44842f57d15fac127fcffa4",
            9: "000004210c4a56106e89226abb3754e35932f98c0af9c932fcffa4",
            10: "0000041b0c424b0c6b781c6da52c60cf4446ed6925fb9a06f7d03cfcffa4",
            11: "000004170c3a420a686b186e932667bb3754dd513af3771afca50af6d645fcffa4",
            12: "000004140b353a096360136e85216ba92e5ecb4149e65d2ff78311fcad12f5db4bfcffa4"
        },
        Cividis: {
            3: "00204d7c7b78ffea46",
            4: "00204d575c6da69d75ffea46",
            5: "00204d414d6b7c7b78bcaf6fffea46",
            6: "00204d31446b666970958f78cbba69ffea46",
            7: "00204d233e6c575c6d7c7b78a69d75d3c164ffea46",
            8: "00204d16396d4b546c6c6e728e8a79b3a772dbc761ffea46",
            9: "00204d05366e414d6b61646f7c7b789b9477bcaf6fe0cb5effea46",
            10: "00204d00336f39486b575c6d7071738a8779a69d75c4b56ce4cf5bffea46",
            11: "00204d00326f31446b4e576c6669707c7b78958f78b0a473cbba69e7d159ffea46",
            12: "00204d00306f2a406c48526b5e626e7273748784799e9677b6a971d0be67ead357ffea46"
        },
        Rainbow: {
            3: "ff000000ff000000ff",
            4: "ff000080ff0000ffff8000ff",
            5: "ff0000ccff0000ff660066ffcc00ff",
            6: "ff0000ffff0000ff0000ffff0000ffff00ff",
            7: "ff0000ffdb0049ff0000ff920092ff4900ffff00db",
            8: "ff0000ffbf0080ff0000ff4000ffff0040ff8000ffff00bf",
            9: "ff0000ffaa00aaff0000ff0000ffaa00aaff0000ffaa00ffff00aa",
            10: "ff0000ff9900ccff0033ff0000ff6600ffff0066ff3300ffcc00ffff0099",
            11: "ff0000ff8b00e8ff005dff0000ff2e00ffb900b9ff002eff5d00ffe800ffff008b",
            12: "ff0000ff8000ffff0080ff0000ff0000ff8000ffff0080ff0000ff8000ffff00ffff0080"
        },
        Heat: {
            3: "ff0000ff8000ffff00",
            4: "ff0000ff8000ffff00ffff80",
            5: "ff0000ff5500ffaa00ffff00ffff80",
            6: "ff0000ff4000ff8000ffbf00ffff00ffff80",
            7: "ff0000ff3300ff6600ff9900ffcc00ffff00ffff80",
            8: "ff0000ff3300ff6600ff9900ffcc00ffff00ffff40ffffbf",
            9: "ff0000ff2a00ff5500ff8000ffaa00ffd500ffff00ffff40ffffbf",
            10: "ff0000ff2400ff4900ff6d00ff9200ffb600ffdb00ffff00ffff40ffffbf",
            11: "ff0000ff2000ff4000ff6000ff8000ff9f00ffbf00ffdf00ffff00ffff40ffffbf",
            12: "ff0000ff2000ff4000ff6000ff8000ff9f00ffbf00ffdf00ffff00ffff2affff80ffffd5"
        },
        LastAirBenderFire: {
            8: "ecb100a100007E605EFF45009948234B4C4E572530000000"
        },
        LastAirBenderAir: {
            7: "ff9933C24841FFFF338B5B4587AFD1EEB05ADBC5A0"
        },
        LastAirBenderEarth: {
            9: "015E05B1A8667A5C1264674225351C4C7022C7C45ED2CFABFEFED8"
        },
        LastAirBenderWater: {
            8: "0047ab1DB4D3A2CAEDAFB5B8120976fffafa174D79949BBC"
        },
        SpongeBob: {
            11: "C86925FDF56CC4433F989B46FC95765D57AFB2CE31FF2027000000B1D6C5AB8323"
        },
        Simpsons: {
            10: "fed90f424f46d1b271FB4122ABC67D0363C37A491E000000FC020946732E"
        },
        RickyAndMorty: {
            9: "01B4C697ce4cFFF874BEE5FDF675DA44281d3a4767F8D3ACE64358"
        },
        ParksAndRecreation: {
            10: "bdbdbda51209ffdb58ec70147A491EC24841005502f7fcb969983ab5651d"
        },
        KimPossible: {
            12: "FF8C0002466370D42389160402001F9CF6F7FFCE455D734DFEC3BB662C9Cfff9f5000000"
        },
        GravityFalls: {
            14: "417BA1ff1493ffff2e3456348b0000ff670093C0D58b45139248A71c88594747478fbc8fd2b48c000000"
        },
        GameOfThronesStark: {
            9: "cadde17B906F174D79fffafa898989D4CDB1708090120976000000"
        },
        GameOfThronesStannis: {
            7: "FF0000ff8d1aFFD700b20000cc6600FFFF66000000"
        },
        GameOfThronesLannister: {
            6: "89080AC5AA73FEDF25C248418B5B45000000"
        },
        GameOfThronesTyrell: {
            9: "068105F7DC27808000AB681BF9FE768DA08071749798FB983CB371"
        },
        GameOfThronesTargaryen: {
            5: "AC1F25272727ff993382878896804b"
        },
        GameOfThronesMartell: {
            8: "ff8000cc6600b81b1873110ff8fc23fafd7b4c2600a57642"
        },
        GameOfThronesTully: {
            6: "212250AE432FE4EDCA8B5B454682B4000000"
        },
        GameOfThronesGreyjoy: {
            6: "000000708090D4CDB1DCDCDCF7DC27808080"
        },
        GameOfThronesManderly: {
            7: "40e0d080808000ff00282828015202195953FFFFFF"
        },
        GameOfThronesArryn: {
            7: "007fff7fbfff0019334c4cffffefb2a89797FFFFFF"
        },
        Brooklyn99Regular: {
            10: "e7298a72bcd4e41a1cFCF40E49f149f16913525252F9FEFF000E33000000"
        },
        Brooklyn99Dark: {
            9: "6CA9C33A3533000E33800000CBCFD2175E78DAA520174D79000000"
        }
    };
    for (var c in CanvasXpress.colorSchemes) {
        for (var d in CanvasXpress.colorSchemes[c]) {
            var b = CanvasXpress.colorSchemes[c][d].match(/.{6}/g);
            CanvasXpress.colorSchemes[c][d] = b ? b.map(function(a) {
                return "#" + a
            }) : []
        }
    }
}();
CanvasXpress.ambiguityCodes = {
    "-": ["-"],
    A: ["A"],
    C: ["C"],
    G: ["G"],
    T: ["T"],
    M: ["A", "C"],
    R: ["A", "G"],
    W: ["A", "T"],
    S: ["C", "G"],
    Y: ["C", "T"],
    K: ["G", "T"],
    V: ["A", "C", "G"],
    H: ["A", "C", "T"],
    D: ["A", "G", "T"],
    B: ["C", "G", "T"],
    N: ["A", "C", "G", "T"],
    X: ["A", "C", "G", "T"]
};
CanvasXpress.codon = {
    TTT: ["F", "Phe", "Phenylalanine"],
    TCT: ["S", "Ser", "Serine"],
    TAT: ["Y", "Tyr", "Tyrosine"],
    TGT: ["C", "Cys", "Cysteine"],
    TTC: ["F", "Phe", "Phenylalanine"],
    TCC: ["S", "Ser", "Serine"],
    TAC: ["Y", "Tyr", "Tyrosine"],
    TGC: ["C", "Cys", "Cysteine"],
    TTA: ["L", "Leu", "Leucine"],
    TCA: ["S", "Ser", "Serine"],
    TAA: ["*", "Stop", "Ochre"],
    TGA: ["*", "Stop", "Opal"],
    TTG: ["L", "Leu", "Leucine"],
    TCG: ["S", "Ser", "Serine"],
    TAG: ["*", "Stop", "Amber"],
    TGG: ["W", "Trp", "Tryptophan"],
    CTT: ["L", "Leu", "Leucine"],
    CCT: ["P", "Pro", "Proline"],
    CAT: ["H", "His", "Histidine"],
    CGT: ["R", "Arg", "Arginine"],
    CTC: ["L", "Leu", "Leucine"],
    CCC: ["P", "Pro", "Proline"],
    CAC: ["H", "His", "Histidine"],
    CGC: ["R", "Arg", "Arginine"],
    CTA: ["L", "Leu", "Leucine"],
    CCA: ["P", "Pro", "Proline"],
    CAA: ["Q", "Gln", "Glutamine"],
    CGA: ["R", "Arg", "Arginine"],
    CTG: ["L", "Leu", "Leucine"],
    CCG: ["P", "Pro", "Proline"],
    CAG: ["Q", "Gln", "Glutamine"],
    CGG: ["R", "Arg", "Arginine"],
    ATT: ["I", "Ile", "Isoleucine"],
    ACT: ["T", "Thr", "Threonine"],
    AAT: ["N", "Asn", "Asparagine"],
    AGT: ["S", "Ser", "Serine"],
    ATC: ["I", "Ile", "Isoleucine"],
    ACC: ["T", "Thr", "Threonine"],
    AAC: ["N", "Asn", "Asparagine"],
    AGC: ["S", "Ser", "Serine"],
    ATA: ["I", "Ile", "Isoleucine"],
    ACA: ["T", "Thr", "Threonine"],
    AAA: ["K", "Lys", "Lysine"],
    AGA: ["R", "Arg", "Arginine"],
    ATG: ["M", "Met", "Methionine"],
    ACG: ["T", "Thr", "Threonine"],
    AAG: ["K", "Lys", "Lysine"],
    AGG: ["R", "Arg", "Arginine"],
    GTT: ["V", "Val", "Valine"],
    GCT: ["A", "Ala", "Alanine"],
    GAT: ["D", "Asp", "Aspartic acid"],
    GGT: ["G", "Gly", "Glycine"],
    GTC: ["V", "Val", "Valine"],
    GCC: ["A", "Ala", "Alanine"],
    GAC: ["D", "Asp", "Aspartic acid"],
    GGC: ["G", "Gly", "Glycine"],
    GTA: ["V", "Val", "Valine"],
    GCA: ["A", "Ala", "Alanine"],
    GAA: ["E", "Glu", "Glutamic acid"],
    GGA: ["G", "Gly", "Glycine"],
    GTG: ["V", "Val", "Valine"],
    GCG: ["A", "Ala", "Alanine"],
    GAG: ["E", "Glu", "Glutamic acid"],
    GGG: ["G", "Gly", "Glycine"]
};
CanvasXpress.reverseComplement = {
    A: "T",
    C: "G",
    G: "C",
    T: "A",
    U: "A",
    Y: "R",
    R: "Y",
    W: "W",
    S: "S",
    K: "M",
    M: "K",
    B: "V",
    V: "B",
    D: "H",
    H: "D",
    X: "X",
    N: "N",
    a: "t",
    c: "g",
    g: "c",
    t: "a",
    u: "a",
    y: "r",
    r: "y",
    w: "w",
    s: "s",
    k: "m",
    m: "k",
    b: "v",
    v: "b",
    d: "h",
    h: "d",
    x: "x",
    n: "n",
    " ": " ",
    "-": "-",
    "/": "/",
    "[": "[",
    "]": "]"
};
CanvasXpress.themes = {
    economist: {
        backgroundType: "solid",
        backgroundWindow: "#D5E4EB",
        background: "#D5E4EB",
        colorScheme: "Economist",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: false,
        legendBoxColor: "#000000",
        legendBackgroundColor: "#D5E4EB",
        legendColumns: 4,
        legendInside: true,
        legendPosition: "top",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 2,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: false,
        xAxisTickColor: "#000000",
        xAxisLeftMajorTick: false,
        xAxisRightMajorTick: false,
        xAxisTickStyle: "solid",
        xAxisLeftRightTickColor: "#000000",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: false,
        yAxis2Show: true,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#FFFFFF",
        yAxisTopMajorTick: false,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#000000",
        titleAlign: "left",
        titleColor: "#000000",
        subtitleAlign: "left",
        subtitleColor: "#000000",
        mapOutlineColor: "#D5E4EB",
        conditional: {
            OneDPlots: {
                xAxisMajorTicks: true
            }
        }
    },
    excel: {
        backgroundType: "window",
        backgroundWindow: "#C0C0C0",
        background: "#FFFFFF",
        colorScheme: "Excel",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: true,
        legendBoxColor: "#000000",
        legendBackgroundColor: "#FFFFFF",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: false,
        xAxisTickColor: "#000000",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: true,
        xAxisTickStyle: "solid",
        xAxisLeftRightTickColor: "#000000",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#000000",
        yAxisTopMajorTick: true,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#000000",
        titleAlign: "left",
        titleColor: "#000000",
        subtitleAlign: "left",
        subtitleColor: "#000000",
        mapOutlineColor: "#C0C0C0",
        conditional: {
            OneDPlots: {
                xAxisMajorTicks: true
            }
        }
    },
    tableau: {
        backgroundType: "window",
        backgroundWindow: "#FFFFFF",
        background: "#E5E5E5",
        colorScheme: "TableauMedium",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: true,
        legendBoxColor: "#E5E5E5",
        legendBackgroundColor: "#FFFFFF",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "#E5E5E5",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: true,
        xAxisLeftRightTickColor: "#E5E5E5",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#E5E5E5",
        yAxisTopMajorTick: true,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#E5E5E5",
        titleAlign: "left",
        titleColor: "#000000",
        subtitleAlign: "left",
        subtitleColor: "#000000",
        mapOutlineColor: "#E5E5E5"
    },
    stata: {
        backgroundType: "window",
        backgroundWindow: "#FFFFFF",
        background: "#EAF2F3",
        colorScheme: "Stata",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: true,
        legendBoxColor: "#000000",
        legendBackgroundColor: "#FFFFFF",
        legendColumns: 4,
        legendInside: false,
        legendPosition: "bottom",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 2,
        xAxisMinorTicks: false,
        xAxisMajorTicks: false,
        xAxisTickStyle: "solid",
        xAxisTickColor: "#000000",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: false,
        xAxisLeftRightTickColor: "#000000",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#EAF2F3",
        yAxisTopMajorTick: false,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#000000",
        titleAlign: "center",
        titleColor: "#000000",
        subtitleAlign: "center",
        subtitleColor: "#000000",
        mapOutlineColor: "#EAF2F3",
        conditional: {
            OneDPlots: {
                xAxisMajorTicks: true
            }
        }
    },
    igray: {
        backgroundType: "window",
        backgroundWindow: "#FFFFFF",
        background: "#E5E5E5",
        colorScheme: "GGPlot",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: false,
        legendBoxColor: "#000000",
        legendBackgroundColor: "#FFFFFF",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "#E5E5E5",
        xAxisLeftMajorTick: false,
        xAxisRightMajorTick: false,
        xAxisLeftRightTickColor: "#000000",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#E5E5E5",
        yAxisTopMajorTick: false,
        yAxisBottomMajorTick: false,
        yAxisTopBottomTickColor: "#000000",
        titleAlign: "center",
        titleColor: "#000000",
        subtitleAlign: "center",
        subtitleColor: "#000000",
        mapOutlineColor: "#FFFFFF"
    },
    solarized: {
        backgroundType: "solid",
        backgroundWindow: "#FDF6E3",
        background: "#FDF6E3",
        colorScheme: "Solarized",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#93A1A1",
        legendBox: true,
        legendBoxColor: "#93A1A1",
        legendBackgroundColor: "#FFFFFF",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#93A1A1",
        axisTitleColor: "#93A1A1",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 2,
        xAxisMinorTicks: false,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "#93A1A1",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: false,
        xAxisLeftRightTickColor: "#93A1A1",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#93A1A1",
        yAxisTopMajorTick: false,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#93A1A1",
        titleAlign: "left",
        titleColor: "#93A1A1",
        subtitleAlign: "left",
        subtitleColor: "#93A1A1",
        mapOutlineColor: "#FDF6E3"
    },
    paulTol: {
        backgroundType: "solid",
        backgroundWindow: "#FFFFFF",
        background: "#FFFFFF",
        colorScheme: "PaulTol",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: false,
        legendBoxColor: "#000000",
        legendBackgroundColor: "#FFFFFF",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "#E5E5E5",
        xAxisLeftMajorTick: false,
        xAxisRightMajorTick: false,
        xAxisLeftRightTickColor: "#E5E5E5",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#E5E5E5",
        yAxisTopMajorTick: false,
        yAxisBottomMajorTick: false,
        yAxisTopBottomTickColor: "#E5E5E5",
        titleAlign: "left",
        titleColor: "#000000",
        subtitleAlign: "left",
        subtitleColor: "#000000",
        mapOutlineColor: "#FFFFFF"
    },
    ggplot: {
        backgroundType: "window",
        backgroundWindow: "#E5E5E5",
        background: "#FFFFFF",
        colorScheme: "GGPlot",
        guides: false,
        guidesColor: "#FFFFFF",
        legendColor: "#000000",
        legendBox: true,
        legendBoxColor: "#FFFFFF",
        legendBackgroundColor: "#E5E5E5",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "#FFFFFF",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: false,
        xAxisLeftRightTickColor: "#FFFFFF",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#FFFFFF",
        yAxisTopMajorTick: false,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#FFFFFF",
        titleAlign: "center",
        titleColor: "#000000",
        subtitleAlign: "center",
        subtitleColor: "#000000",
        mapOutlineColor: "#FFFFFF"
    },
    wallStreetJournal: {
        backgroundType: "solid",
        backgroundWindow: "#F8F2E4",
        background: "#F8F2E4",
        colorScheme: "WallStreetJournal3",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: false,
        legendBoxColor: "#000000",
        legendBackgroundColor: "#F8F2E4",
        legendColumns: 4,
        legendInside: true,
        legendPosition: "top",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 2,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: false,
        xAxisTickStyle: "dotted",
        xAxisTickColor: "#000000",
        xAxisLeftMajorTick: false,
        xAxisRightMajorTick: false,
        xAxisLeftRightTickColor: "#000000",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "dotted",
        yAxisTickColor: "#000000",
        yAxisTopMajorTick: false,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#000000",
        titleAlign: "left",
        titleColor: "#000000",
        subtitleAlign: "left",
        subtitleColor: "#000000",
        mapOutlineColor: "#F8F2E4",
        conditional: {
            OneDPlots: {
                xAxisMajorTicks: true
            }
        }
    },
    cx: {
        backgroundType: "window",
        backgroundWindow: "#E8E8E8",
        background: "#FFFFFF",
        colorScheme: "CanvasXpress",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        legendColor: "#000000",
        legendBox: true,
        legendBoxColor: "#FFFFFF",
        legendBackgroundColor: "#E8E8E8",
        lineDecoration: "symbol",
        axisTickColor: "#000000",
        axisTitleColor: "#000000",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: false,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "#FFFFFF",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: true,
        xAxisLeftRightTickColor: "#337AB7",
        yAxisMajorTicks: true,
        yAxisMinorTicks: false,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "#FFFFFF",
        yAxisTopMajorTick: true,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "#337AB7",
        titleAlign: "center",
        titleColor: "#000000",
        subtitleAlign: "center",
        subtitleColor: "#000000",
        mapOutlineColor: "rgb(204,204,204)",
        conditional: {
            OneDPlots: {
                plotBox: true,
                plotBoxColor: "#337AB7"
            }
        }
    },
    blackAndWhite: {
        backgroundType: "solid",
        backgroundWindow: "rgb(255,255,255)",
        background: "rgb(255,255,255)",
        colorScheme: "BlackAndWhite",
        foreground: "rgb(0,0,0)",
        guides: false,
        guidesColor: "rgba(255,255,255,0)",
        legendColor: "rgb(0,0,0)",
        legendBox: false,
        legendBoxColor: "rgba(255,255,255,0)",
        legendBackgroundColor: "rgba(255,255,255,0)",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "pattern",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "rgb(0,0,0)",
        axisTitleColor: "rgb(0,0,0)",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: true,
        xAxisMajorTicks: true,
        xAxisTickStyle: "dotted",
        xAxisTickColor: "rgb(0,0,0)",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: true,
        xAxisLeftRightTickColor: "rgb(0,0,0)",
        yAxisMajorTicks: true,
        yAxisMinorTicks: true,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "dotted",
        yAxisTickColor: "rgb(0,0,0)",
        yAxisTopMajorTick: true,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "rgb(0,0,0)",
        titleAlign: "center",
        titleColor: "rgb(0,0,0)",
        subtitleAlign: "center",
        subtitleColor: "rgb(0,0,0)",
        mapOutlineColor: "rgb(0,0,0)",
        plotBoxColor: "rgb(0,0,0)",
        plotBox: true
    },
    lastAirBender: {
        backgroundType: "solid",
        backgroundWindow: "rgb(236,229,211)",
        background: "rgb(236,229,211)",
        foreground: "rgb(51,51,51)",
        guides: false,
        guidesColor: "rgba(255,255,255,0)",
        legendColor: "rgb(51,51,51)",
        legendBox: false,
        legendBoxColor: "rgba(236,229,211,0)",
        legendBackgroundColor: "rgba(236,229,211,0)",
        legendColumns: 3,
        legendInside: false,
        legendPosition: "bottom",
        legendScaleFontFactor: 1,
        lineDecoration: "false",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "rgb(51,51,51)",
        axisTitleColor: "rgb(51,51,51)",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: true,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "rgb(51,51,51)",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: true,
        xAxisLeftRightTickColor: "rgb(51,51,51)",
        yAxisMajorTicks: true,
        yAxisMinorTicks: true,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "rgb(51,51,51)",
        yAxisTopMajorTick: true,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "rgb(51,51,51)",
        titleAlign: "center",
        titleColor: "rgb(51,51,51)",
        subtitleAlign: "center",
        subtitleColor: "rgb(51,51,51)",
        mapOutlineColor: "rgb(51,51,51)",
        plotBoxColor: "rgb(51,51,51)",
        plotBox: false
    },
    gameOfThrones: {
        backgroundType: "solid",
        backgroundWindow: "rgb(255,255,255)",
        background: "rgb(255,255,255)",
        foreground: "rgb(51,51,51)",
        guides: false,
        guidesColor: "rgba(255,255,255,0)",
        legendColor: "rgb(51,51,51)",
        legendBox: false,
        legendBoxColor: "rgba(255,255,255,0)",
        legendBackgroundColor: "rgba(255,255,255,0)",
        legendColumns: 3,
        legendInside: false,
        legendPosition: "bottom",
        legendScaleFontFactor: 1,
        lineDecoration: "false",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "rgb(51,51,51)",
        axisTitleColor: "rgb(51,51,51)",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: true,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "rgb(51,51,51)",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: true,
        xAxisLeftRightTickColor: "rgb(51,51,51)",
        yAxisMajorTicks: true,
        yAxisMinorTicks: true,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "rgb(51,51,51)",
        yAxisTopMajorTick: true,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "rgb(51,51,51)",
        titleAlign: "center",
        titleColor: "rgb(51,51,51)",
        subtitleAlign: "center",
        subtitleColor: "rgb(51,51,51)",
        mapOutlineColor: "rgb(51,51,51)",
        plotBoxColor: "rgb(51,51,51)",
        plotBox: false
    },
    none: {
        backgroundType: "solid",
        backgroundWindow: "rgb(244,244,244)",
        background: "rgb(255,255,255)",
        colorScheme: "User",
        guides: false,
        guidesColor: "rgb(204,204,204)",
        colors: CanvasXpress.colorSchemes.Default[20],
        legendColor: "rgb(0,0,0)",
        legendBox: false,
        legendBoxColor: "rgb(204,204,204)",
        legendBackgroundColor: "rgba(255,255,255,0)",
        legendColumns: 1,
        legendInside: false,
        legendPosition: "right",
        legendScaleFontFactor: 1,
        lineDecoration: "symbol",
        axisTickScaleFontFactor: 1,
        axisTitleScaleFontFactor: 1,
        axisTickColor: "rgb(0,0,0)",
        axisTitleColor: "rgb(0,0,0)",
        axisTickThickness: 1,
        axisMinMaxTickThickness: 1,
        xAxisMinorTicks: true,
        xAxisMajorTicks: true,
        xAxisTickStyle: "solid",
        xAxisTickColor: "rgb(204,204,204)",
        xAxisLeftMajorTick: true,
        xAxisRightMajorTick: true,
        xAxisLeftRightTickColor: "rgb(204,204,204)",
        yAxisMajorTicks: true,
        yAxisMinorTicks: true,
        yAxisShow: true,
        yAxis2Show: false,
        yAxisTickStyle: "solid",
        yAxisTickColor: "rgb(204,204,204)",
        yAxisTopMajorTick: true,
        yAxisBottomMajorTick: true,
        yAxisTopBottomTickColor: "rgb(204,204,204)",
        titleAlign: "center",
        titleColor: "rgb(0,0,0)",
        subtitleAlign: "center",
        subtitleColor: "rgb(0,0,0)",
        mapOutlineColor: "rgb(204,204,204)"
    }
};
CanvasXpress.themes.CanvasXpress = CanvasXpress.themes.cx;
CanvasXpress.themes.canvasXpress = CanvasXpress.themes.cx;
CanvasXpress.themes.canvasxpress = CanvasXpress.themes.cx;
CanvasXpress.themes.paultol = CanvasXpress.themes.paulTol;
CanvasXpress.themes.PaulTol = CanvasXpress.themes.paulTol;
CanvasXpress.R = {
    lty: [
        [0, 0],
        [],
        [8, 6],
        [1, 3],
        [1, 3, 5, 3],
        [14, 6],
        [4, 3, 8, 3]
    ],
    ltyNames: ["blank", "solid", "dashed", "dotted", "dotdash", "longdash", "twodash"]
};
CanvasXpress.prototype.initDOM = function() {
    this.$ = function(id) {
        return window.document.getElementById(id)
    };
    this.$cX = function(t, p, s) {
        var e = window.document.createElement(t);
        if (p) {
            for (var i in p) {
                e[i] = p[i]
            }
        }
        if (s) {
            for (var i in s) {
                e.style[i] = s[i]
            }
        }
        return e
    };
    this.$cXI = function(k, p, s, x, d) {
        var el = document.createElementNS("http://www.w3.org/2000/svg", "svg");
        var t = "";
        var classes = function(svg) {
            var sn = {};
            var sp = svg.split(/class=/);
            var c = "<style>";
            for (var ii = 1; ii < sp.length; ii++) {
                var m = sp[ii].match(/"(.+?)"/);
                if (m) {
                    var cs = m[1].split(/\s+/);
                    for (var jj = 0; jj < cs.length; jj++) {
                        var ms = cs[jj];
                        if (CanvasXpress.icons.classes.hasOwnProperty(ms) && !sn.hasOwnProperty(ms)) {
                            c += "." + ms + CanvasXpress.icons.classes[ms]
                        }
                    }
                }
            }
            c += "</style>";
            return c
        };
        if (CanvasXpress.icons.use.hasOwnProperty(k)) {
            var svg = '<rect class="cxnc" x="0" y="0" width="100" height="100" />';
            if (CanvasXpress.icons.gradients.hasOwnProperty(k)) {
                svg += CanvasXpress.icons.gradients[k].replace(/&quot;/g, '"')
            }
            for (var i = 0; i < CanvasXpress.icons.use[k].length; i++) {
                svg += CanvasXpress.icons.symbols[CanvasXpress.icons.use[k][i]].replace(/&quot;/g, '"').replace(/&apos;/g, "'")
            }
            var c = classes(svg);
            if (!d) {
                d = 24
            }
            el.setAttribute("xmlns", "http://www.w3.org/2000/svg");
            el.setAttribute("viewBox", "0 0 100 100");
            el.setAttribute("style", "width:" + d + "px;height:" + d + "px;");
            if (p) {
                for (var i in p) {
                    if (i == "className") {
                        el.setAttribute("class", p[i])
                    } else {
                        el.setAttribute(i, p[i]);
                        if (i == "title") {
                            t = "<title>" + p[i] + "</title>"
                        }
                    }
                }
            }
            if (s) {
                for (var i in s) {
                    el.style[i] = s[i]
                }
            }
            el.innerHTML = t + c + svg
        }
        return x ? new XMLSerializer().serializeToString(el) : el
    };
    this.$cXIU = function(el, k, p, s) {
        var t = "";
        var classes = function(svg) {
            var sn = {};
            var sp = svg.split(/class=/);
            var c = "<style>";
            for (var ii = 1; ii < sp.length; ii++) {
                var m = sp[ii].match(/"(.+?)"/);
                if (m) {
                    var cs = m[1].split(/\s+/);
                    for (var jj = 0; jj < cs.length; jj++) {
                        var ms = cs[jj];
                        if (CanvasXpress.icons.classes.hasOwnProperty(ms) && !sn.hasOwnProperty(ms)) {
                            c += "." + ms + CanvasXpress.icons.classes[ms]
                        }
                    }
                }
            }
            c += "</style>";
            return c
        };
        if (el && CanvasXpress.icons.use.hasOwnProperty(k)) {
            var svg = '<rect class="cxnc" x="0" y="0" width="100" height="100" />';
            if (CanvasXpress.icons.gradients.hasOwnProperty(k)) {
                svg += CanvasXpress.icons.gradients[k].replace(/&quot;/g, '"')
            }
            for (var i = 0; i < CanvasXpress.icons.use[k].length; i++) {
                svg += CanvasXpress.icons.symbols[CanvasXpress.icons.use[k][i]].replace(/&quot;/g, '"').replace(/&apos;/g, "'")
            }
            var c = classes(svg);
            if (p) {
                for (var i in p) {
                    if (i == "className") {
                        el.setAttribute("class", p[i])
                    } else {
                        el.setAttribute(i, p[i]);
                        if (i == "title") {
                            t = "<title>" + p[i] + "</title>"
                        }
                    }
                }
            }
            if (s) {
                for (var i in s) {
                    el.style[i] = s[i]
                }
            }
            el.innerHTML = t + c + svg
        }
    };
    this.setPixelImage = function() {
        if (CanvasXpress.instances.length == 1) {
            this.beaconImage = this.$cX("img", {
                id: this.target + "-cX-Beacon-Image",
                src: (window.navigator.onLine ? "https://www.canvasxpress.org/assets/images/beacon.gif?" + CanvasXpress.factory.client : CanvasXpress.png),
                title: "",
                alt: ""
            })
        } else {
            this.beaconImage = CanvasXpress.instances[0].beaconImage
        }
    };
    this.$$ = function() {
        var t = this;
        var c = CanvasXpress;
        var f = function(k) {
            if (!k) {
                k = c[d[4]]
            }
            var len = k.length;
            var ini = Number(k.substring(2, 3));
            var end = Number(k.substring(len - 3, len - 2));
            var str = k.substring(3 + ini, 3 + ini + 5)[d[7]]("")[d[8]]()[d[9]]("");
            var fns = k.substring(len - (3 + end + 5), len - (3 + end));
            return Number(str + "" + fns + "000")
        };
        var w = ["686578546f537472696e67", "6472617754657874", "666163746f7279", "73797374656d", "72656769737465726564", "76616c6964", "737562737472696e67", "73706c6974", "72657665727365", "6a6f696e", "43616e766173587072657373", "4e6f7420612076616c696420636f7079206f6620", "556e737570706f727465642056657273696f6e206f6620", "20522056657273696f6e", "204e6f64652056657273696f6e", "697352566965776572", "697352436f6e736f6c65", "68726566", "2f7777772e63616e7661737870726573732e6f72672f646973742f", "72616e646f6d496e744265747765656e", "666f6e7453697a65"];
        var h = t.hexToString("686578546f537472696e67");
        var d = [];
        for (var i = 0; i < w.length; i++) {
            d.push(t[h](w[i]))
        }
        var r = Number(f());
        var s = Number(t.meta.time.start);
        var v = isNaN(c[d[2]][d[5]]) ? Number(f(c[d[2]][d[5]])) : 0;
        var x = new RegExp(d[18]).test(c[d[2]][d[17]]) || c[d[3]][d[15]] || c[d[3]][d[16]];
        var m = d[10];
        var b = t[d[20]];
        var q = 1;
        if (!x) {
            if (r - s < 0) {
                if (!v || v - s < 0) {
                    if (c[d[2]][d[5]]) {
                        b += 4;
                        q += 2;
                        m = d[11] + d[10]
                    }
                    setTimeout(function() {
                        t[d[1]](m, t.width - (b / 4), t.height - (b / 2), t.font, "rgba(0,0,0,0." + q + ")", "right", "middle")
                    }, t[d[19]](1, 8) * 1000)
                }
            }
        }
    };
    this.showMask = function() {
        var c = this.$(this.target);
        var l = this.$(this.target + "canvasXpressLoadingTimer");
        if (l) {
            l.style.height = parseInt((c.height / 2) - 100.5) + "px";
            l.style.display = "block"
        }
    };
    this.hideMask = function() {
        var l = this.$(this.target + "canvasXpressLoadingTimer");
        if (l) {
            l.style.display = "none"
        }
        this.loaded = true;
        this.$$()
    };
    this.createNewTarget = function() {
        var cn = this.$cX("canvas").setAttribute("id", this.newId("-canvasXpress-"));
        window.document.body.appendChild(cn);
        return cn.id
    };
    this.newId = function(t) {
        var n = 0;
        var i = this.target + t + n;
        while (this.meta.ids[i]) {
            n++;
            i = this.target + t + n
        }
        this.meta.ids[i] = true;
        return i
    };
    this.insertTarget = function(t, p, w, h, a) {
        if (t && p) {
            var c = this.$(t);
            if (c) {
                return
            } else {
                c = this.$cX("canvas", {
                    id: t,
                    width: w,
                    height: h
                });
                this.castCanvasAttributes(c)
            }
            if (a) {
                p.parentNode.insertBefore(c, p.nextSibling)
            } else {
                p.parentNode.insertBefore(c, p)
            }
        }
    };
    this.castCanvasAttributes = function(c, e) {
        if (!e) {
            e = this.meta.canvas.ctx.canvas
        }
        CanvasXpress.transferDatasetAttributes(e, c)
    };
    this.removeTarget = function(t) {
        var n = this.$(t);
        if (n) {
            n.parentNode.removeChild(n)
        }
    };
    this.getWindowSize = function() {
        var doc = window.document;
        var w = window.innerWidth || doc.documentElement.clientWidth || doc.body.clientWidth;
        var h = window.innerHeight || doc.documentElement.clientHeight || doc.body.clientHeight;
        return [w, h]
    };
    this.getWindowScroll = function() {
        var d = window.document.documentElement;
        var l = (window.pageXOffset || d.scrollLeft) - (d.clientLeft || 0);
        var t = (window.pageYOffset || d.scrollTop) - (d.clientTop || 0);
        return [l, t]
    };
    this.isInViewport = function(el, d) {
        var w = this.getWindowSize();
        var b = el.getBoundingClientRect();
        var c = b.right - (this.width * 0.5);
        var m = b.bottom - (this.height * 0.5);
        return b.left >= 0 && b.top >= 0 && c <= w[0] && m <= w[1]
    };
    this.hasClass = function(e, n) {
        return e ? e.classList.contains(n) : false
    };
    this.addClass = function(e, n) {
        if (e) {
            e.classList.add(n)
        }
    };
    this.removeClass = function(e, n) {
        if (e) {
            e.classList.remove(n)
        }
    };
    this.getComputedCSS = function(e) {
        var s = "";
        var o = getComputedStyle(e);
        for (var i = 0; i < o.length; i++) {
            s += o[i] + ":" + o.getPropertyValue(o[i]) + ";"
        }
        return s
    };
    this.cancelEvent = function(e) {
        if (!e) {
            return
        }
        if (CanvasXpress.system.browser.match(/safari/i)) {
            return false
        } else {
            if (e.preventDefault) {
                e.preventDefault()
            } else {
                e.returnValue = false
            }
        }
    };
    this.stopEvent = function(e) {
        if (!e) {
            return
        }
        if (e.stopPropagation) {
            e.stopPropagation()
        } else {
            e.cancelBubble = true
        }
    };
    this.normalizeEvtName = function(e) {
        return CanvasXpress.system.isIE ? "on" + e : e
    };
    this.copyEvent = function(e) {
        var ce = {};
        for (var i in e) {
            ce[i] = e[i]
        }
        return ce
    };
    this.addEvtListener = function(o, e, c, f) {
        if (o && (typeof o) == "string") {
            o = this.$(o)
        }
        if (o && e && c) {
            var m = this.meta.events;
            if (o.id) {
                if (!m[o.id]) {
                    m[o.id] = {}
                }
                m[o.id][e] = [c, f]
            } else {
                if (!m[o]) {
                    m[o] = {}
                }
                m[o][e] = [c, f]
            }
            if (CanvasXpress.system.isIE) {
                o.attachEvent(this.normalizeEvtName(e), c)
            } else {
                if (e == "touchstart") {
                    o.addEventListener(e, c, f)
                } else {
                    if (e == "mousewheel") {
                        o.addEventListener(e, c, f);
                        o.addEventListener("DOMMouseScroll", c, f)
                    } else {
                        o.addEventListener(e, c, f)
                    }
                }
            }
        }
    };
    this.removeEvtListener = function(o, e, c, f) {
        if (o && (typeof o) == "string") {
            o = this.$(o)
        }
        if (o && e && c) {
            var m = this.meta.events;
            var k = m[o.id || o];
            if (k && k.hasOwnProperty(e)) {
                delete(k[e]);
                if (CanvasXpress.system.isIE) {
                    o.detachEvent(this.normalizeEvtName(e), c)
                } else {
                    o.removeEventListener(e, c, f);
                    if (e == "mousewheel") {
                        o.removeEventListener("DOMMouseScroll", c, f)
                    }
                }
                var v = this.getKeys(m[o.id || o]);
                if (v && v.length < 1) {
                    delete(m[o.id || o])
                }
            }
        }
    };
    this.addRemoveEvtListener = function(t, o, e, c, f) {
        if (t && o && e && c) {
            this[t](o, e, c, f)
        }
    };
    this.purgeEventListeners = function() {
        var m = this.meta.events;
        for (var i in m) {
            var o = this.$(i) || i;
            for (var e in m[i]) {
                this.removeEvtListener(o, e, m[i][0], m[i][1])
            }
        }
    };
    this.preventSelection = function() {
        var d = window.document;
        if (d.selection) {
            d.selection.empty()
        } else {
            if (window.getSelection) {
                window.getSelection().removeAllRanges()
            }
        }
    };
    this.getTargetEvent = function(e) {
        var obj = e.target || e.srcElement;
        if (typeof(obj) != "object") {
            obj = this.$(obj)
        }
        if (obj instanceof SVGElement && obj.ownerSVGElement) {
            obj = obj.ownerSVGElement
        }
        return obj
    };
    this.dispatchEvent = function(el, e) {
        el.dispatchEvent(e)
    };
    this.requestAnimationFrame = function(callback, time) {
        if (callback) {
            raf = window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || window.oRequestAnimationFrame || window.msRequestAnimationFrame;
            if (raf) {
                raf(callback)
            } else {
                if (!time) {
                    time = 1000 / 60
                }
                window.setTimeout(callback, time)
            }
        }
    };
    this.setTimeout = function(callback, time) {
        if (this.isR) {
            setTimeout(callback, time)
        } else {
            var that = this;
            var wait = function(t) {
                return new Promise(function(resolve, reject) {
                    if (t) {
                        setTimeout(resolve, t)
                    } else {
                        setTimeout(resolve, 1000)
                    }
                })
            };
            wait(time).then(function() {
                callback.apply(that)
            })
        }
    };
    this.setInterval = function(c, d) {
        this.logConsole("canvasXpress setInterval ready - " + arguments.callee.caller.name + " - " + d);
        return setInterval(c, d)
    };
    if (typeof JSON.decycle !== "function") {
        JSON.decycle = function decycle(object, replacer) {
            var objects = new WeakMap();
            return (function derez(value, path) {
                var old_path;
                var nu;
                if (replacer !== undefined) {
                    value = replacer(value)
                }
                if (typeof value === "object" && value !== null && !(value instanceof Boolean) && !(value instanceof Date) && !(value instanceof Number) && !(value instanceof RegExp) && !(value instanceof String)) {
                    old_path = objects.get(value);
                    if (old_path !== undefined) {
                        return {
                            $ref: old_path
                        }
                    }
                    objects.set(value, path);
                    if (Array.isArray(value)) {
                        nu = [];
                        value.forEach(function(element, i) {
                            nu[i] = derez(element, path + "[" + i + "]")
                        })
                    } else {
                        nu = {};
                        Object.keys(value).forEach(function(name) {
                            nu[name] = derez(value[name], path + "[" + JSON.stringify(name) + "]")
                        })
                    }
                    return nu
                }
                return value
            }(object, "$"))
        }
    }
    if (typeof JSON.retrocycle !== "function") {
        JSON.retrocycle = function retrocycle($) {
            var px = /^\$(?:\[(?:\d+|"(?:[^\\"\u0000-\u001f]|\\([\\"\/bfnrt]|u[0-9a-zA-Z]{4}))*")\])*$/;
            (function rez(value) {
                if (value && typeof value === "object") {
                    if (Array.isArray(value)) {
                        value.forEach(function(element, i) {
                            if (typeof element === "object" && element !== null) {
                                var path = element.$ref;
                                if (typeof path === "string" && px.test(path)) {
                                    value[i] = eval(path)
                                } else {
                                    rez(element)
                                }
                            }
                        })
                    } else {
                        Object.keys(value).forEach(function(name) {
                            var item = value[name];
                            if (typeof item === "object" && item !== null) {
                                var path = item.$ref;
                                if (typeof path === "string" && px.test(path)) {
                                    value[name] = eval(path)
                                } else {
                                    rez(item)
                                }
                            }
                        })
                    }
                }
            }($));
            return $
        }
    }
    if (!Array.from) {
        Array.from = (function() {
            var toStr = Object.prototype.toString;
            var isCallable = function(fn) {
                return typeof fn === "function" || toStr.call(fn) === "[object Function]"
            };
            var toInteger = function(value) {
                var number = Number(value);
                if (isNaN(number)) {
                    return 0
                }
                if (number === 0 || !isFinite(number)) {
                    return number
                }
                return (number > 0 ? 1 : -1) * Math.floor(Math.abs(number))
            };
            var maxSafeInteger = Math.pow(2, 53) - 1;
            var toLength = function(value) {
                var len = toInteger(value);
                return Math.min(Math.max(len, 0), maxSafeInteger)
            };
            return function from(arrayLike) {
                var C = this;
                var items = Object(arrayLike);
                if (arrayLike == null) {
                    throw new TypeError("Array.from requires an array-like object - not null or undefined")
                }
                var mapFn = arguments.length > 1 ? arguments[1] : void undefined;
                var T;
                if (typeof mapFn !== "undefined") {
                    if (!isCallable(mapFn)) {
                        throw new TypeError("Array.from: when provided, the second argument must be a function")
                    }
                    if (arguments.length > 2) {
                        T = arguments[2]
                    }
                }
                var len = toLength(items.length);
                var A = isCallable(C) ? Object(new C(len)) : new Array(len);
                var k = 0;
                var kValue;
                while (k < len) {
                    kValue = items[k];
                    if (mapFn) {
                        A[k] = typeof T === "undefined" ? mapFn(kValue, k) : mapFn.call(T, kValue, k)
                    } else {
                        A[k] = kValue
                    }
                    k += 1
                }
                A.length = len;
                return A
            }
        }())
    }
    if (!Array.prototype.fill) {
        Object.defineProperty(Array.prototype, "fill", {
            value: function(value) {
                if (this == null) {
                    throw new TypeError("this is null or not defined")
                }
                var O = Object(this);
                var len = O.length >>> 0;
                var start = arguments[1];
                var relativeStart = start >> 0;
                var k = relativeStart < 0 ? Math.max(len + relativeStart, 0) : Math.min(relativeStart, len);
                var end = arguments[2];
                var relativeEnd = end === undefined ? len : end >> 0;
                var finl = relativeEnd < 0 ? Math.max(len + relativeEnd, 0) : Math.min(relativeEnd, len);
                while (k < finl) {
                    O[k] = value;
                    k++
                }
                return O
            }
        })
    }
    if (typeof Object.assign != "function") {
        Object.defineProperty(Object, "assign", {
            value: function assign(target, varArgs) {
                if (target == null) {
                    throw new TypeError("Cannot convert undefined or null to object")
                }
                var to = Object(target);
                for (var index = 1; index < arguments.length; index++) {
                    var nextSource = arguments[index];
                    if (nextSource != null) {
                        for (var nextKey in nextSource) {
                            if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
                                to[nextKey] = nextSource[nextKey]
                            }
                        }
                    }
                }
                return to
            },
            writable: true,
            configurable: true
        })
    }
    if (!Array.prototype.map) {
        Array.prototype.map = function(callback) {
            var T, A, k;
            if (this == null) {
                throw new TypeError("this is null or not defined")
            }
            var O = Object(this);
            var len = O.length >>> 0;
            if (typeof callback !== "function") {
                throw new TypeError(callback + " is not a function")
            }
            if (arguments.length > 1) {
                T = arguments[1]
            }
            A = new Array(len);
            k = 0;
            while (k < len) {
                var kValue, mappedValue;
                if (k in O) {
                    kValue = O[k];
                    mappedValue = callback.call(T, kValue, k, O);
                    A[k] = mappedValue
                }
                k++
            }
            return A
        }
    }
    if (!Array.prototype.findIndex) {
        Object.defineProperty(Array.prototype, "findIndex", {
            value: function(predicate) {
                if (this == null) {
                    throw new TypeError('"this" is null or not defined')
                }
                var o = Object(this);
                var len = o.length >>> 0;
                if (typeof predicate !== "function") {
                    throw new TypeError("predicate must be a function")
                }
                var thisArg = arguments[1];
                var k = 0;
                while (k < len) {
                    var kValue = o[k];
                    if (predicate.call(thisArg, kValue, k, o)) {
                        return k
                    }
                    k++
                }
                return -1
            }
        })
    }
    if (typeof window.CustomEvent !== "function") {
        window.CustomEvent = function(event, params) {
            params = params || {
                bubbles: false,
                cancelable: false,
                detail: null
            };
            var evt = document.createEvent("CustomEvent");
            evt.initCustomEvent(event, params.bubbles, params.cancelable, params.detail);
            return evt
        }
    }
    if (!Array.prototype.includes) {
        Object.defineProperty(Array.prototype, "includes", {
            value: function(searchElement, fromIndex) {
                if (this == null) {
                    throw new TypeError('"this" is null or not defined')
                }
                var o = Object(this);
                var len = o.length >>> 0;
                if (len === 0) {
                    return false
                }
                var n = fromIndex | 0;
                var k = Math.max(n >= 0 ? n : len - Math.abs(n), 0);

                function sameValueZero(x, y) {
                    return x === y || (typeof x === "number" && typeof y === "number" && isNaN(x) && isNaN(y))
                }
                while (k < len) {
                    if (sameValueZero(o[k], searchElement)) {
                        return true
                    }
                    k++
                }
                return false
            }
        })
    }
    this.isInIframe = function() {
        try {
            return window.self !== window.top
        } catch (e) {
            return true
        }
    };
    this.initializeBrowser = function() {
        var getBrowserVersion = function() {
            var ua = window.navigator.userAgent;
            var tem;
            var m = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
            if (/trident/i.test(m[1])) {
                tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
                return "IE " + (tem[1] || "")
            }
            if (m[1] === "Chrome") {
                tem = ua.match(/\b(OPR|Edge)\/(\d+)/);
                if (tem != null) {
                    return tem.slice(1).join(" ").replace("OPR", "Opera")
                }
            }
            m = m[2] ? [m[1], m[2]] : [window.navigator.appName, window.navigator.appVersion, "-?"];
            if ((tem = ua.match(/version\/(\d+)/i)) != null) {
                m.splice(1, 1, tem[1])
            }
            return m.join(" ")
        };
        var getOS = function() {
            var userAgent = window.navigator.userAgent;
            var platform = window.navigator.platform;
            var macosPlatforms = ["Macintosh", "MacIntel", "MacPPC", "Mac68K"];
            var windowsPlatforms = ["Win32", "Win64", "Windows", "WinCE"];
            var iosPlatforms = ["iPhone", "iPad", "iPod"];
            var os = null;
            if (macosPlatforms.indexOf(platform) !== -1) {
                os = "Mac OS"
            } else {
                if (iosPlatforms.indexOf(platform) !== -1) {
                    os = "iOS"
                } else {
                    if (windowsPlatforms.indexOf(platform) !== -1) {
                        os = "Windows"
                    } else {
                        if (/Android/.test(userAgent)) {
                            os = "Android"
                        } else {
                            if (!os && /Linux/.test(platform)) {
                                os = "Linux"
                            }
                        }
                    }
                }
            }
            return os
        };
        var str = getBrowserVersion().split(" ");
        var os = getOS();
        CanvasXpress.system = {
            browser: str[0],
            browserVersion: str[1],
            os: os,
            alt: (os == "Mac OS" ? "&#8997;" : "Alt"),
            command: "&#8984;",
            control: (os == "Mac OS" ? "&#8963;" : "Ctrl"),
            shift: (os == "Mac OS" ? "&#8679;" : "Shift"),
            isjQuery: typeof $ === "function",
            isReveal: typeof Reveal != "undefined",
            isZoom: typeof zoom != "undefined",
            isIE: this.browser == "IE" ? true : false,
            isInIframe: (str[0].match(/safari/i) ? true : this.isInIframe()),
            isTouchScreen: ("ontouchstart" in window || "onmsgesturechange" in window || window.navigator.maxTouchPoints)
        }
    }
};
CanvasXpress.prototype.initSVG = function() {
    function g(o, l) {
        var n = Object.keys(l),
            m;
        for (m = 0; m < n.length; m++) {
            o = o.replace(new RegExp("\\{" + n[m] + "\\}", "gi"), l[n[m]])
        }
        return o
    }

    function h(m) {
        var o, n, l;
        if (!m) {
            throw new Error("cannot create a random attribute name for an undefined object")
        }
        o = "ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
        n = "";
        do {
            n = "";
            for (l = 0; l < 12; l++) {
                n += o[Math.floor(Math.random() * o.length)]
            }
        } while (m[n]);
        return n
    }

    function d(n, p) {
        var o, m, r = {},
            q, l;
        n = n.split(",");
        p = p || 10;
        for (o = 0; o < n.length; o += 2) {
            m = "&" + n[o + 1] + ";";
            q = parseInt(n[o], p);
            r[m] = "&#" + q + ";"
        }
        r["\\xa0"] = "&#160;";
        return r
    }

    function f(m) {
        var l = {
            left: "start",
            right: "end",
            center: "middle",
            start: "start",
            end: "end"
        };
        return l[m] || l.start
    }

    function c(m) {
        var l = {
            alphabetic: "alphabetic",
            hanging: "hanging",
            top: "text-before-edge",
            bottom: "text-after-edge",
            middle: "central"
        };
        return l[m] || l.alphabetic
    }
    var a = d("50,nbsp,51,iexcl,52,cent,53,pound,54,curren,55,yen,56,brvbar,57,sect,58,uml,59,copy,5a,ordf,5b,laquo,5c,not,5d,shy,5e,reg,5f,macr,5g,deg,5h,plusmn,5i,sup2,5j,sup3,5k,acute,5l,micro,5m,para,5n,middot,5o,cedil,5p,sup1,5q,ordm,5r,raquo,5s,frac14,5t,frac12,5u,frac34,5v,iquest,60,Agrave,61,Aacute,62,Acirc,63,Atilde,64,Auml,65,Aring,66,AElig,67,Ccedil,68,Egrave,69,Eacute,6a,Ecirc,6b,Euml,6c,Igrave,6d,Iacute,6e,Icirc,6f,Iuml,6g,ETH,6h,Ntilde,6i,Ograve,6j,Oacute,6k,Ocirc,6l,Otilde,6m,Ouml,6n,times,6o,Oslash,6p,Ugrave,6q,Uacute,6r,Ucirc,6s,Uuml,6t,Yacute,6u,THORN,6v,szlig,70,agrave,71,aacute,72,acirc,73,atilde,74,auml,75,aring,76,aelig,77,ccedil,78,egrave,79,eacute,7a,ecirc,7b,euml,7c,igrave,7d,iacute,7e,icirc,7f,iuml,7g,eth,7h,ntilde,7i,ograve,7j,oacute,7k,ocirc,7l,otilde,7m,ouml,7n,divide,7o,oslash,7p,ugrave,7q,uacute,7r,ucirc,7s,uuml,7t,yacute,7u,thorn,7v,yuml,ci,fnof,sh,Alpha,si,Beta,sj,Gamma,sk,Delta,sl,Epsilon,sm,Zeta,sn,Eta,so,Theta,sp,Iota,sq,Kappa,sr,Lambda,ss,Mu,st,Nu,su,Xi,sv,Omicron,t0,Pi,t1,Rho,t3,Sigma,t4,Tau,t5,Upsilon,t6,Phi,t7,Chi,t8,Psi,t9,Omega,th,alpha,ti,beta,tj,gamma,tk,delta,tl,epsilon,tm,zeta,tn,eta,to,theta,tp,iota,tq,kappa,tr,lambda,ts,mu,tt,nu,tu,xi,tv,omicron,u0,pi,u1,rho,u2,sigmaf,u3,sigma,u4,tau,u5,upsilon,u6,phi,u7,chi,u8,psi,u9,omega,uh,thetasym,ui,upsih,um,piv,812,bull,816,hellip,81i,prime,81j,Prime,81u,oline,824,frasl,88o,weierp,88h,image,88s,real,892,trade,89l,alefsym,8cg,larr,8ch,uarr,8ci,rarr,8cj,darr,8ck,harr,8dl,crarr,8eg,lArr,8eh,uArr,8ei,rArr,8ej,dArr,8ek,hArr,8g0,forall,8g2,part,8g3,exist,8g5,empty,8g7,nabla,8g8,isin,8g9,notin,8gb,ni,8gf,prod,8gh,sum,8gi,minus,8gn,lowast,8gq,radic,8gt,prop,8gu,infin,8h0,ang,8h7,and,8h8,or,8h9,cap,8ha,cup,8hb,int,8hk,there4,8hs,sim,8i5,cong,8i8,asymp,8j0,ne,8j1,equiv,8j4,le,8j5,ge,8k2,sub,8k3,sup,8k4,nsub,8k6,sube,8k7,supe,8kl,oplus,8kn,otimes,8l5,perp,8m5,sdot,8o8,lceil,8o9,rceil,8oa,lfloor,8ob,rfloor,8p9,lang,8pa,rang,9ea,loz,9j0,spades,9j3,clubs,9j5,hearts,9j6,diams,ai,OElig,aj,oelig,b0,Scaron,b1,scaron,bo,Yuml,m6,circ,ms,tilde,802,ensp,803,emsp,809,thinsp,80c,zwnj,80d,zwj,80e,lrm,80f,rlm,80j,ndash,80k,mdash,80o,lsquo,80p,rsquo,80q,sbquo,80s,ldquo,80t,rdquo,80u,bdquo,810,dagger,811,Dagger,81g,permil,81p,lsaquo,81q,rsaquo,85c,euro", 32);
    var j = {
        strokeStyle: {
            svgAttr: "stroke",
            canvas: "#000000",
            svg: "none",
            apply: "stroke"
        },
        fillStyle: {
            svgAttr: "fill",
            canvas: "#000000",
            svg: null,
            apply: "fill"
        },
        lineCap: {
            svgAttr: "stroke-linecap",
            canvas: "butt",
            svg: "butt",
            apply: "stroke"
        },
        lineJoin: {
            svgAttr: "stroke-linejoin",
            canvas: "miter",
            svg: "miter",
            apply: "stroke"
        },
        miterLimit: {
            svgAttr: "stroke-miterlimit",
            canvas: 10,
            svg: 4,
            apply: "stroke"
        },
        lineWidth: {
            svgAttr: "stroke-width",
            canvas: 1,
            svg: 1,
            apply: "stroke"
        },
        globalAlpha: {
            svgAttr: "opacity",
            canvas: 1,
            svg: 1,
            apply: "fill stroke"
        },
        font: {
            canvas: "10px sans-serif"
        },
        shadowColor: {
            canvas: "#000000"
        },
        shadowOffsetX: {
            canvas: 0
        },
        shadowOffsetY: {
            canvas: 0
        },
        shadowBlur: {
            canvas: 0
        },
        textAlign: {
            canvas: "start"
        },
        textBaseline: {
            canvas: "alphabetic"
        },
        lineDash: {
            svgAttr: "stroke-dasharray",
            canvas: [],
            svg: null,
            apply: "stroke"
        }
    };
    var i = function(m, l) {
        this.__root = m;
        this.__ctx = l
    };
    i.prototype.addColorStop = function(p, l) {
        var m = this.__ctx.__createElement("stop"),
            n, o;
        m.setAttribute("offset", p);
        if (l.indexOf("rgba") !== -1) {
            n = /rgba\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d?\.?\d*)\s*\)/gi;
            o = n.exec(l);
            m.setAttribute("stop-color", g("rgb({r},{g},{b})", {
                r: o[1],
                g: o[2],
                b: o[3]
            }));
            m.setAttribute("stop-opacity", o[4])
        } else {
            m.setAttribute("stop-color", l)
        }
        this.__root.appendChild(m)
    };
    var e = function(m, l) {
        this.__root = m;
        this.__ctx = l
    };
    var k = function(n) {
        var l = {
                width: 500,
                height: 500,
                enableMirroring: false
            },
            m;
        if (arguments.length > 1) {
            m = l;
            m.width = arguments[0];
            m.height = arguments[1]
        } else {
            if (!n) {
                m = l
            } else {
                m = n
            }
        }
        if (!(this instanceof k)) {
            return new k(m)
        }
        this.width = m.width || l.width;
        this.height = m.height || l.height;
        this.enableMirroring = m.enableMirroring !== undefined ? m.enableMirroring : l.enableMirroring;
        this.canvas = this;
        this.__document = m.document || document;
        if (m.ctx) {
            this.__ctx = m.ctx
        } else {
            this.__canvas = this.__document.createElement("canvas");
            this.__ctx = this.__canvas.getContext("2d")
        }
        this.__setDefaultStyles();
        this.__stack = [this.__getStyleState()];
        this.__groupStack = [];
        this.__root = this.__document.createElementNS("http://www.w3.org/2000/svg", "svg");
        this.__root.setAttribute("version", 1.1);
        this.__root.setAttribute("xmlns", "http://www.w3.org/2000/svg");
        this.__root.setAttributeNS("http://www.w3.org/2000/xmlns/", "xmlns:xlink", "http://www.w3.org/1999/xlink");
        this.__root.setAttribute("width", this.width);
        this.__root.setAttribute("height", this.height);
        this.__ids = {};
        this.__defs = this.__document.createElementNS("http://www.w3.org/2000/svg", "defs");
        this.__root.appendChild(this.__defs);
        this.__currentElement = this.__document.createElementNS("http://www.w3.org/2000/svg", "g");
        this.__root.appendChild(this.__currentElement)
    };
    k.prototype.__createElement = function(l, p, r) {
        if (typeof p === "undefined") {
            p = {}
        }
        var o = this.__document.createElementNS("http://www.w3.org/2000/svg", l),
            q = Object.keys(p),
            n, m;
        if (r) {
            o.setAttribute("fill", "none");
            o.setAttribute("stroke", "none")
        }
        for (n = 0; n < q.length; n++) {
            m = q[n];
            o.setAttribute(m, p[m])
        }
        return o
    };
    k.prototype.__setDefaultStyles = function() {
        var n = Object.keys(j),
            m, l;
        for (m = 0; m < n.length; m++) {
            l = n[m];
            this[l] = j[l].canvas
        }
    };
    k.prototype.__applyStyleState = function(l) {
        var o = Object.keys(l),
            n, m;
        for (n = 0; n < o.length; n++) {
            m = o[n];
            this[m] = l[m]
        }
    };
    k.prototype.__getStyleState = function() {
        var n, l = {},
            o = Object.keys(j),
            m;
        for (n = 0; n < o.length; n++) {
            m = o[n];
            l[m] = this[m]
        }
        return l
    };
    k.prototype.__applyStyleToCurrentElement = function(u) {
        var q = this.__currentElement;
        var n = this.__currentElementsToStyle;
        if (n) {
            q.setAttribute(u, "");
            q = n.element;
            n.children.forEach(function(y) {
                y.setAttribute(u, "")
            })
        }
        var x = Object.keys(j),
            o, l, w, m, v, p;
        for (o = 0; o < x.length; o++) {
            l = j[x[o]];
            w = this[x[o]];
            if (l.apply) {
                if (w instanceof e) {
                    if (w.__ctx) {
                        while (w.__ctx.__defs.childNodes.length) {
                            m = w.__ctx.__defs.childNodes[0].getAttribute("id");
                            this.__ids[m] = m;
                            this.__defs.appendChild(w.__ctx.__defs.childNodes[0])
                        }
                    }
                    q.setAttribute(l.apply, g("url(#{id})", {
                        id: w.__root.getAttribute("id")
                    }))
                } else {
                    if (w instanceof i) {
                        q.setAttribute(l.apply, g("url(#{id})", {
                            id: w.__root.getAttribute("id")
                        }))
                    } else {
                        if (l.apply.indexOf(u) !== -1 && l.svg !== w) {
                            if ((l.svgAttr === "stroke" || l.svgAttr === "fill") && w.indexOf && w.indexOf("rgba") !== -1) {
                                v = /rgba\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d?\.?\d*)\s*\)/gi;
                                p = v.exec(w);
                                q.setAttribute(l.svgAttr, g("rgb({r},{g},{b})", {
                                    r: p[1],
                                    g: p[2],
                                    b: p[3]
                                }));
                                var r = p[4];
                                var t = this.globalAlpha;
                                if (t != null) {
                                    r *= t
                                }
                                q.setAttribute(l.svgAttr + "-opacity", r)
                            } else {
                                var s = l.svgAttr;
                                if (x[o] === "globalAlpha") {
                                    s = u + "-" + l.svgAttr;
                                    if (q.getAttribute(s)) {
                                        continue
                                    }
                                }
                                q.setAttribute(s, w)
                            }
                        }
                    }
                }
            }
        }
    };
    k.prototype.__closestGroupOrSvg = function(l) {
        l = l || this.__currentElement;
        if (l.nodeName === "g" || l.nodeName === "svg") {
            return l
        } else {
            return this.__closestGroupOrSvg(l.parentNode)
        }
    };
    k.prototype.getSerializedSvg = function(s) {
        var q = new XMLSerializer().serializeToString(this.__root),
            n, m, l, p, o, r;
        r = /xmlns="http:\/\/www\.w3\.org\/2000\/svg".+xmlns="http:\/\/www\.w3\.org\/2000\/svg/gi;
        if (r.test(q)) {
            q = q.replace('xmlns="http://www.w3.org/2000/svg', 'xmlns:xlink="http://www.w3.org/1999/xlink')
        }
        if (s) {
            n = Object.keys(a);
            for (m = 0; m < n.length; m++) {
                l = n[m];
                p = a[l];
                o = new RegExp(l, "gi");
                if (o.test(q)) {
                    q = q.replace(o, p)
                }
            }
        }
        return q
    };
    k.prototype.getSvg = function() {
        return this.__root
    };
    k.prototype.save = function() {
        var m = this.__createElement("g");
        var l = this.__closestGroupOrSvg();
        this.__groupStack.push(l);
        l.appendChild(m);
        this.__currentElement = m;
        this.__stack.push(this.__getStyleState())
    };
    k.prototype.restore = function() {
        this.__currentElement = this.__groupStack.pop();
        this.__currentElementsToStyle = null;
        if (!this.__currentElement) {
            this.__currentElement = this.__root.childNodes[1]
        }
        var l = this.__stack.pop();
        this.__applyStyleState(l)
    };
    k.prototype.__addTransform = function(m) {
        var n = this.__closestGroupOrSvg();
        if (n.childNodes.length > 0) {
            if (this.__currentElement.nodeName === "path") {
                if (!this.__currentElementsToStyle) {
                    this.__currentElementsToStyle = {
                        element: n,
                        children: []
                    }
                }
                this.__currentElementsToStyle.children.push(this.__currentElement);
                this.__applyCurrentDefaultPath()
            }
            var o = this.__createElement("g");
            n.appendChild(o);
            this.__currentElement = o
        }
        var l = this.__currentElement.getAttribute("transform");
        if (l) {
            l += " "
        } else {
            l = ""
        }
        l += m;
        this.__currentElement.setAttribute("transform", l)
    };
    k.prototype.scale = function(l, m) {
        if (m === undefined) {
            m = l
        }
        this.__addTransform(g("scale({x},{y})", {
            x: l,
            y: m
        }))
    };
    k.prototype.rotate = function(m) {
        var l = (m * 180 / Math.PI);
        this.__addTransform(g("rotate({angle},{cx},{cy})", {
            angle: l,
            cx: 0,
            cy: 0
        }))
    };
    k.prototype.translate = function(l, m) {
        this.__addTransform(g("translate({x},{y})", {
            x: l,
            y: m
        }))
    };
    k.prototype.transform = function(m, l, q, p, o, n) {
        this.__addTransform(g("matrix({a},{b},{c},{d},{e},{f})", {
            a: m,
            b: l,
            c: q,
            d: p,
            e: o,
            f: n
        }))
    };
    k.prototype.beginPath = function() {
        var m, l;
        this.__currentDefaultPath = "";
        this.__currentPosition = {};
        m = this.__createElement("path", {}, true);
        l = this.__closestGroupOrSvg();
        l.appendChild(m);
        this.__currentElement = m
    };
    k.prototype.__applyCurrentDefaultPath = function() {
        var l = this.__currentElement;
        if (l.nodeName === "path") {
            l.setAttribute("d", this.__currentDefaultPath)
        } else {
            console.error("Attempted to apply path command to node", l.nodeName)
        }
    };
    k.prototype.__addPathCommand = function(l) {
        this.__currentDefaultPath += " ";
        this.__currentDefaultPath += l
    };
    k.prototype.moveTo = function(l, m) {
        if (this.__currentElement.nodeName !== "path") {
            this.beginPath()
        }
        this.__currentPosition = {
            x: l,
            y: m
        };
        this.__addPathCommand(g("M {x} {y}", {
            x: l,
            y: m
        }))
    };
    k.prototype.closePath = function() {
        if (this.__currentDefaultPath) {
            this.__addPathCommand("Z")
        }
    };
    k.prototype.lineTo = function(l, m) {
        this.__currentPosition = {
            x: l,
            y: m
        };
        if (this.__currentDefaultPath.indexOf("M") > -1) {
            this.__addPathCommand(g("L {x} {y}", {
                x: l,
                y: m
            }))
        } else {
            this.__addPathCommand(g("M {x} {y}", {
                x: l,
                y: m
            }))
        }
    };
    k.prototype.bezierCurveTo = function(n, m, p, o, l, q) {
        this.__currentPosition = {
            x: l,
            y: q
        };
        this.__addPathCommand(g("C {cp1x} {cp1y} {cp2x} {cp2y} {x} {y}", {
            cp1x: n,
            cp1y: m,
            cp2x: p,
            cp2y: o,
            x: l,
            y: q
        }))
    };
    k.prototype.quadraticCurveTo = function(n, m, l, o) {
        this.__currentPosition = {
            x: l,
            y: o
        };
        this.__addPathCommand(g("Q {cpx} {cpy} {x} {y}", {
            cpx: n,
            cpy: m,
            x: l,
            y: o
        }))
    };
    var b = function(m) {
        var l = Math.sqrt(m[0] * m[0] + m[1] * m[1]);
        return [m[0] / l, m[1] / l]
    };
    k.prototype.arcTo = function(F, o, E, n, q) {
        var G = this.__currentPosition && this.__currentPosition.x;
        var p = this.__currentPosition && this.__currentPosition.y;
        if (typeof G == "undefined" || typeof p == "undefined") {
            return
        }
        if (q < 0) {
            throw new Error("IndexSizeError: The radius provided (" + q + ") is negative.")
        }
        if (((G === F) && (p === o)) || ((F === E) && (o === n)) || (q === 0)) {
            this.lineTo(F, o);
            return
        }
        var u = b([G - F, p - o]);
        var t = b([E - F, n - o]);
        if (u[0] * t[1] === u[1] * t[0]) {
            this.lineTo(F, o);
            return
        }
        var m = (u[0] * t[0] + u[1] * t[1]);
        var v = Math.acos(Math.abs(m));
        var B = b([u[0] + t[0], u[1] + t[1]]);
        var r = q / Math.sin(v / 2);
        var A = F + r * B[0];
        var z = o + r * B[1];
        var l = [-u[1], u[0]];
        var w = [t[1], -t[0]];
        var s = function(I) {
            var H = I[0];
            var J = I[1];
            if (J >= 0) {
                return Math.acos(H)
            } else {
                return -Math.acos(H)
            }
        };
        var D = s(l);
        var C = s(w);
        this.lineTo(A + l[0] * q, z + l[1] * q);
        this.arc(A, z, q, D, C)
    };
    k.prototype.stroke = function() {
        if (this.__currentElement.nodeName === "path") {
            this.__currentElement.setAttribute("paint-order", "fill stroke markers")
        }
        this.__applyCurrentDefaultPath();
        this.__applyStyleToCurrentElement("stroke")
    };
    k.prototype.fill = function() {
        if (this.__currentElement.nodeName === "path") {
            this.__currentElement.setAttribute("paint-order", "stroke fill markers")
        }
        this.__applyCurrentDefaultPath();
        this.__applyStyleToCurrentElement("fill")
    };
    k.prototype.rect = function(m, o, n, l) {
        if (this.__currentElement.nodeName !== "path") {
            this.beginPath()
        }
        this.moveTo(m, o);
        this.lineTo(m + n, o);
        this.lineTo(m + n, o + l);
        this.lineTo(m, o + l);
        this.lineTo(m, o);
        this.closePath()
    };
    k.prototype.fillRect = function(m, q, o, l) {
        var p, n;
        p = this.__createElement("rect", {
            x: m,
            y: q,
            width: o,
            height: l
        }, true);
        n = this.__closestGroupOrSvg();
        n.appendChild(p);
        this.__currentElement = p;
        this.__applyStyleToCurrentElement("fill")
    };
    k.prototype.strokeRect = function(m, q, o, l) {
        var p, n;
        p = this.__createElement("rect", {
            x: m,
            y: q,
            width: o,
            height: l
        }, true);
        n = this.__closestGroupOrSvg();
        n.appendChild(p);
        this.__currentElement = p;
        this.__applyStyleToCurrentElement("stroke")
    };
    k.prototype.__clearCanvas = function() {
        var o = this.__closestGroupOrSvg(),
            l = o.getAttribute("transform");
        var n = this.__root.childNodes[1];
        var p = n.childNodes;
        for (var m = p.length - 1; m >= 0; m--) {
            if (p[m]) {
                n.removeChild(p[m])
            }
        }
        this.__currentElement = n;
        this.__groupStack = [];
        if (l) {
            this.__addTransform(l)
        }
    };
    k.prototype.clearRect = function(m, q, o, l) {
        if (m === 0 && q === 0 && o === this.width && l === this.height) {
            this.__clearCanvas();
            return
        }
        var p, n = this.__closestGroupOrSvg();
        p = this.__createElement("rect", {
            x: m,
            y: q,
            width: o,
            height: l,
            fill: "#FFFFFF"
        }, true);
        n.appendChild(p)
    };
    k.prototype.createLinearGradient = function(m, o, l, n) {
        var p = this.__createElement("linearGradient", {
            id: h(this.__ids),
            x1: m + "px",
            x2: l + "px",
            y1: o + "px",
            y2: n + "px",
            gradientUnits: "userSpaceOnUse"
        }, false);
        this.__defs.appendChild(p);
        return new i(p, this)
    };
    k.prototype.createRadialGradient = function(o, q, n, m, p, l) {
        var r = this.__createElement("radialGradient", {
            id: h(this.__ids),
            cx: m + "px",
            cy: p + "px",
            r: l + "px",
            fx: o + "px",
            fy: q + "px",
            gradientUnits: "userSpaceOnUse"
        }, false);
        this.__defs.appendChild(r);
        return new i(r, this)
    };
    k.prototype.__parseFont = function() {
        var m = /^\s*(?=(?:(?:[-a-z]+\s*){0,2}(italic|oblique))?)(?=(?:(?:[-a-z]+\s*){0,2}(small-caps))?)(?=(?:(?:[-a-z]+\s*){0,2}(bold(?:er)?|lighter|[1-9]00))?)(?:(?:normal|\1|\2|\3)\s*){0,3}((?:xx?-)?(?:small|large)|medium|smaller|larger|[.\d]+(?:\%|in|[cem]m|ex|p[ctx]))(?:\s*\/\s*(normal|[.\d]+(?:\%|in|[cem]m|ex|p[ctx])))?\s*([-,\'\"\sa-z0-9]+?)\s*$/i;
        var l = m.exec(this.font);
        var n = {
            style: l[1] || "normal",
            size: l[4] || "10px",
            family: l[6] || "sans-serif",
            weight: l[3] || "normal",
            decoration: l[2] || "normal",
            href: null
        };
        if (this.__fontUnderline === "underline") {
            n.decoration = "underline"
        }
        if (this.__fontHref) {
            n.href = this.__fontHref
        }
        return n
    };
    k.prototype.__wrapTextLink = function(m, n) {
        if (m.href) {
            var l = this.__createElement("a");
            l.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", m.href);
            l.appendChild(n);
            return l
        }
        return n
    };
    k.prototype.__applyText = function(q, l, r, p) {
        var n = this.__parseFont(),
            o = this.__closestGroupOrSvg(),
            m = this.__createElement("text", {
                "font-family": n.family,
                "font-size": n.size,
                "font-style": n.style,
                "font-weight": n.weight,
                "text-decoration": n.decoration,
                x: l,
                y: r,
                "text-anchor": f(this.textAlign),
                "dominant-baseline": c(this.textBaseline)
            }, true);
        m.appendChild(this.__document.createTextNode(q));
        this.__currentElement = m;
        this.__applyStyleToCurrentElement(p);
        o.appendChild(this.__wrapTextLink(n, m))
    };
    k.prototype.fillText = function(m, l, n) {
        this.__applyText(m, l, n, "fill")
    };
    k.prototype.strokeText = function(m, l, n) {
        this.__applyText(m, l, n, "stroke")
    };
    k.prototype.measureText = function(l) {
        this.__ctx.font = this.font;
        return this.__ctx.measureText(l)
    };
    k.prototype.arc = function(t, s, q, r, m, v) {
        if (r === m) {
            return
        }
        r = r % (2 * Math.PI);
        m = m % (2 * Math.PI);
        if (r === m) {
            m = ((m + (2 * Math.PI)) - 0.001 * (v ? -1 : 1)) % (2 * Math.PI)
        }
        var z = t + q * Math.cos(m),
            w = s + q * Math.sin(m),
            p = t + q * Math.cos(r),
            o = s + q * Math.sin(r),
            n = v ? 0 : 1,
            l = 0,
            u = m - r;
        if (u < 0) {
            u += 2 * Math.PI
        }
        if (v) {
            l = u > Math.PI ? 0 : 1
        } else {
            l = u > Math.PI ? 1 : 0
        }
        this.lineTo(p, o);
        this.__addPathCommand(g("A {rx} {ry} {xAxisRotation} {largeArcFlag} {sweepFlag} {endX} {endY}", {
            rx: q,
            ry: q,
            xAxisRotation: 0,
            largeArcFlag: l,
            sweepFlag: n,
            endX: z,
            endY: w
        }));
        this.__currentPosition = {
            x: z,
            y: w
        }
    };
    k.prototype.clip = function() {
        var m = this.__closestGroupOrSvg(),
            l = this.__createElement("clipPath"),
            o = h(this.__ids),
            n = this.__createElement("g");
        this.__applyCurrentDefaultPath();
        m.removeChild(this.__currentElement);
        l.setAttribute("id", o);
        l.appendChild(this.__currentElement);
        this.__defs.appendChild(l);
        m.setAttribute("clip-path", g("url(#{id})", {
            id: o
        }));
        m.appendChild(n);
        this.__currentElement = n
    };
    k.prototype.drawImage = function() {
        var n = Array.prototype.slice.call(arguments),
            z = n[0],
            u, t, v, F, x = 0,
            w = 0,
            C, G, s, y, l, q, o, D, p, m, B;
        if (n.length === 3) {
            u = n[1];
            t = n[2];
            C = z.width;
            G = z.height;
            v = C;
            F = G
        } else {
            if (n.length === 5) {
                u = n[1];
                t = n[2];
                v = n[3];
                F = n[4];
                C = z.width;
                G = z.height
            } else {
                if (n.length === 9) {
                    x = n[1];
                    w = n[2];
                    C = n[3];
                    G = n[4];
                    u = n[5];
                    t = n[6];
                    v = n[7];
                    F = n[8]
                } else {
                    throw new Error("Inavlid number of arguments passed to drawImage: " + arguments.length)
                }
            }
        }
        s = this.__closestGroupOrSvg();
        o = this.__currentElement;
        var r = "translate(" + u + ", " + t + ")";
        if (z instanceof k) {
            y = z.getSvg().cloneNode(true);
            if (y.childNodes && y.childNodes.length > 1) {
                l = y.childNodes[0];
                while (l.childNodes.length) {
                    B = l.childNodes[0].getAttribute("id");
                    this.__ids[B] = B;
                    this.__defs.appendChild(l.childNodes[0])
                }
                q = y.childNodes[1];
                if (q) {
                    var E = q.getAttribute("transform");
                    var A;
                    if (E) {
                        A = E + " " + r
                    } else {
                        A = r
                    }
                    q.setAttribute("transform", A);
                    s.appendChild(q)
                }
            }
        } else {
            if (z.nodeName === "CANVAS" || z.nodeName === "IMG") {
                D = this.__createElement("image");
                D.setAttribute("width", v);
                D.setAttribute("height", F);
                D.setAttribute("preserveAspectRatio", "none");
                if (x || w || C !== z.width || G !== z.height) {
                    p = this.__document.createElement("canvas");
                    p.width = v;
                    p.height = F;
                    m = p.getContext("2d");
                    m.drawImage(z, x, w, C, G, 0, 0, v, F);
                    z = p
                }
                D.setAttribute("transform", r);
                D.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", z.nodeName === "CANVAS" ? z.toDataURL() : z.getAttribute("src"));
                s.appendChild(D)
            }
        }
    };
    k.prototype.createPattern = function(o, m) {
        var n = this.__document.createElementNS("http://www.w3.org/2000/svg", "pattern"),
            p = h(this.__ids),
            l;
        n.setAttribute("id", p);
        n.setAttribute("width", o.width);
        n.setAttribute("height", o.height);
        if (o.nodeName === "CANVAS" || o.nodeName === "IMG") {
            l = this.__document.createElementNS("http://www.w3.org/2000/svg", "image");
            l.setAttribute("width", o.width);
            l.setAttribute("height", o.height);
            l.setAttributeNS("http://www.w3.org/1999/xlink", "xlink:href", o.nodeName === "CANVAS" ? o.toDataURL() : o.getAttribute("src"));
            n.appendChild(l);
            this.__defs.appendChild(n)
        } else {
            if (o instanceof k) {
                n.appendChild(o.__root.childNodes[1]);
                this.__defs.appendChild(n)
            }
        }
        return new e(n, this)
    };
    k.prototype.setLineDash = function(l) {
        if (l && l.length > 0) {
            this.lineDash = l.join(",")
        } else {
            this.lineDash = null
        }
    };
    k.prototype.drawFocusRing = function() {};
    k.prototype.createImageData = function() {};
    k.prototype.getImageData = function() {};
    k.prototype.putImageData = function() {};
    k.prototype.globalCompositeOperation = function() {};
    k.prototype.setTransform = function() {};
    this.canvasToSVG = k
};
CanvasXpress.prototype.initInterface = function() {
    this.parseJSON = function(s, r) {
        if (s.match(/<!DOCTYPE/)) {
            return undefined
        } else {
            if (r) {
                return JSON.parse(s, r)
            } else {
                return JSON.parse(s, function(k, v) {
                    if (typeof v === "string" && v.startsWith && v.startsWith("/Function(") && v.endsWith && v.endsWith(")/")) {
                        v = v.substring(10, v.length - 2).replace(/&quot;/g, '"');
                        return eval("(" + v + ")")
                    } else {
                        return v
                    }
                })
            }
        }
    };
    this.stringifyJSON = function(js, r, s) {
        if (r) {
            return JSON.stringify(js, r, s || null)
        } else {
            return js ? JSON.stringify(js, function(k, v) {
                if (typeof v === "function") {
                    return "/Function(" + v.toString().replace(/"/g, "&quot;") + ")/"
                } else {
                    if (k == "state" || k == "stateIndex" || k == "gantt") {
                        return undefined
                    } else {
                        if (v instanceof Array) {
                            for (var p in v) {
                                if (Array.isArray(v[p]) || v[p] instanceof Object) {
                                    return v
                                }
                            }
                            return JSON.stringify(v)
                        } else {
                            return v
                        }
                    }
                }
            }, s || null).replace(/\\n/g, "").replace(/\\/g, "").replace(/\"\[/g, "[").replace(/\]\"/g, "]").replace(/\"\{/g, "{").replace(/\}\"/g, "}").replace(/u0000/g, "") : false
        }
    };
    this.isValidURL = function(str) {
        var pattern = new RegExp("^(https?:\\/\\/)?((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.?)+[a-z]{2,}|((\\d{1,3}\\.){3}\\d{1,3}))(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*(\\?[;,\\s\\(\\)\\[\\]&a-z\\d%_.~+=-]*)?(\\#[-a-z\\d_]*)?$", "i");
        return pattern.test(str)
    };
    this.stringToXML = function(str) {
        var test = false;
        if (window.DOMParser) {
            test = (new DOMParser()).parseFromString(str, "text/xml")
        } else {
            if (typeof window.ActiveXObject != "undefined" && new window.ActiveXObject("Microsoft.XMLDOM")) {
                test = new window.ActiveXObject("Microsoft.XMLDOM");
                test.async = "false";
                test.loadXML(str)
            }
        }
        return test
    };
    this.isValidXML = function(str) {
        var test = this.stringToXML(str);
        return test != null && test.getElementsByTagName("parsererror").length == 0
    };
    this.isValidJSON = function(str) {
        try {
            JSON.parse(str)
        } catch (e) {
            return false
        }
        return true
    };
    this.isValidDelimitedFile = function(str) {
        var test = this.delimitedToArray(str);
        return this.isArray(test) && this.isArray(test[0])
    };
    this.isValidString = function(str) {
        var obj = {
            type: false,
            data: false
        };
        if (this.isValidURL(str)) {
            obj.type = "URL";
            obj.data = str
        } else {
            if (this.isValidXML(str)) {
                obj.type = "XML";
                obj.data = this.stringToXML(str)
            } else {
                if (this.isValidJSON(str)) {
                    obj.type = "JSON";
                    obj.data = JSON.parse(str)
                } else {
                    if (this.isValidDelimitedFile(str)) {
                        obj.type = "DELIM";
                        obj.data = this.delimitedToArray(str, false, true, this.graphType == "Network")
                    }
                }
            }
        }
        return obj
    };
    this.loadParamsFile = function(t) {
        return function(e) {
            t.removeMenus();
            t.resetConfigurator(e);
            var file = e.target.files[0];
            var type = file.type;
            var part = file.name.split(".");
            var reader = new FileReader();
            var ext = part.pop();
            if (ext == "json") {
                reader.onload = function() {
                    try {
                        var data = t.parseJSON(reader.result);
                        t.setConfigDefaults();
                        t.layoutValid = false;
                        for (var p in data.config) {
                            t[p] = data.config[p]
                        }
                        if (data.afterRender) {
                            for (var i = 0; i < data.afterRender.length; i++) {
                                var ar = data.afterRender[i];
                                var fn = ar[0];
                                var pr = ar[1] || [];
                                t[fn].apply(t, pr)
                            }
                        } else {
                            t.draw({
                                func: "loadParamsFile",
                                par: (e)
                            })
                        }
                    } catch (e) {
                        alert("Oooops! Not a valid CanvasXpress json parameter file")
                    }
                };
                reader.readAsText(file)
            } else {
                alert("Oooops! Not a valid CanvasXpress json parameter file")
            }
        }
    }(this);
    this.parseDataFromPNG = function(p) {
        var istEXt = function(dv, idx) {
            var c = "";
            for (var i = 0; i < 4; i++) {
                c += String.fromCharCode(dv.getUint8(idx + i))
            }
            return c == "tEXt"
        };
        var isCanvasXpress = function(dv, idx, len) {
            var c = "";
            for (var i = 0; i < len; i++) {
                c += String.fromCharCode(dv.getUint8(idx + i))
            }
            return c.match(/CanvasXpress/)
        };
        var dv = new DataView(p);
        var ihdr = dv.getUint32(8);
        var soft = dv.getUint32(8 + 4 + 4 + ihdr + 4);
        if (istEXt(dv, 8 + 4 + 4 + ihdr + 4 + 4) && isCanvasXpress(dv, 8 + 4 + 4 + ihdr + 4 + 4 + 4, soft)) {
            var rprs = dv.getUint32(8 + 4 + 4 + ihdr + 4 + 4 + 4 + soft + 4);
            var indx = 8 + 4 + 4 + ihdr + 4 + 4 + 4 + soft + 4 + 4 + 4;
            var res = "";
            for (var i = 0; i < rprs; i++) {
                res += String.fromCharCode(dv.getUint8(indx + i))
            }
            res = res.replace("ReproducibleResearch\0", "");
            return this.parseJSON(res)
        } else {
            alert("Oooops! Not a valid CanvasXpress Image")
        }
    };
    this.parseNodeLinks = function(json) {
        var smps = [];
        var vals = [];
        var srce = [];
        var targ = [];
        for (var i = 0; i < json.links.length; i++) {
            var l = json.links[i];
            if (l.source && l.target && l.value) {
                srce.push(l.source);
                targ.push(l.target);
                vals.push(l.value);
                smps.push("Smp" + (i + 1))
            }
        }
        var data = {
            y: {
                vars: ["Weight"],
                smps: smps,
                data: [vals]
            },
            x: {
                Source: srce,
                Target: targ
            }
        };
        return {
            renderTo: "newSankey",
            data: data,
            config: {
                graphType: "Sankey",
                sankeySource: "Source",
                sankeyTarget: "Target"
            }
        }
    };
    this.parseHierarchy = function(json) {
        var that = this;
        var reformat = function(treeStructure) {
            var max = 0;
            var smps = [];
            var vals = [];
            var seen = {};
            var flatten = function(children, extractChildren, level, parent) {
                return Array.prototype.concat.apply(children.map(function(x) {
                    if (!seen.hasOwnProperty(x.name)) {
                        seen[x.name] = 0
                    }
                    seen[x.name]++;
                    if (seen[x.name] > 1) {
                        x.name += seen[x.name]
                    }
                    var o = that.cloneObject(x);
                    o.level = level || 1;
                    o.parent = parent || null;
                    return o
                }), children.map(function(x) {
                    max = Math.max(max, (level || 1) + 1);
                    if (!x.children) {
                        smps.push(x.name);
                        vals.push(x.value || 1)
                    }
                    return flatten(extractChildren(x) || [], extractChildren, (level || 1) + 1, x.name)
                }))
            };
            var extractChildren = function extractChildren(x) {
                return x.children || null
            };
            var flat = flatten(extractChildren(treeStructure), extractChildren).map(function(x) {
                x.n = x.children ? x.children.length : 0;
                return delete x.children && x
            });
            var data = {
                y: {
                    vars: ["Dummy"],
                    smps: smps,
                    data: [vals]
                },
                x: {}
            };
            for (var i = 0; i < data.y.smps.length; i++) {
                for (var j = 0; j < flat.length; j++) {
                    if (!flat[j].n && data.y.smps[i] == flat[j].name) {
                        flat[j].smp = i;
                        break
                    }
                }
            }
            var hier = [];
            var levl = json.name;
            data.x[levl] = [];
            hier.push(levl);
            for (var i = 2; i < max - 1; i++) {
                data.x[levl + i] = [];
                hier.push(levl + i)
            }
            var map = {};
            for (var i = 0; i < flat.length; i++) {
                map[flat[i].name] = i
            }
            for (var i = 0; i < hier.length; i++) {
                for (var j = 0; j < data.y.smps.length; j++) {
                    data.x[hier[i]][j] = null
                }
            }
            for (var i = 0; i < flat.length; i++) {
                if (flat[i].parent) {
                    var p = flat[i].parent;
                    var m = map[p];
                    var s = flat[i].smp;
                    var l = flat[i].level - 1;
                    var f = flat[m].parent;
                    data.x[levl + (l > 1 ? l : "")][s] = flat[m].name;
                    while (f) {
                        m = map[f];
                        l = flat[m].level;
                        data.x[levl + (l > 1 ? l : "")][s] = flat[m].name;
                        f = flat[m].parent
                    }
                }
            }
            return {
                renderTo: "newTree",
                data: data,
                config: {
                    graphType: "Tree",
                    hierarchy: hier
                }
            }
        };
        return reformat(json)
    };
    this.loadFile = function(t) {
        return function(e, jr, callback, f) {
            t.removeMenus();
            t.resetConfigurator(e);
            t.showMask();
            var checkBackgroundImage = function(data) {
                if (data.config && data.config.backgroundImage && data.config.backgroundImage.match(/^javascript:\/\//) && data.config.backgroundImageSrc) {
                    var im = new Image();
                    im.id = data.config.backgroundImage.split("//")[1];
                    im.style.display = "none";
                    im.src = "data:image/png;base64," + atob(data.config.backgroundImageSrc);
                    document.body.appendChild(im);
                    CanvasXpress.cacheImages[t.getFileName(im.src)] = im
                }
            };
            var file = f ? f : e.target ? e.target.files[0] : e.files[0];
            var type = file.type;
            var part = file.name.split(".");
            var reader = new FileReader();
            if (type == "image/png") {
                var istEXt = function(dv, idx) {
                    var c = "";
                    for (var i = 0; i < 4; i++) {
                        c += String.fromCharCode(dv.getUint8(idx + i))
                    }
                    return c == "tEXt"
                };
                var isCanvasXpress = function(dv, idx, len) {
                    var c = "";
                    for (var i = 0; i < len; i++) {
                        c += String.fromCharCode(dv.getUint8(idx + i))
                    }
                    return c.match(/CanvasXpress/)
                };
                reader.onload = function() {
                    var dv = new DataView(this.result);
                    var ihdr = dv.getUint32(8);
                    var soft = dv.getUint32(8 + 4 + 4 + ihdr + 4);
                    if (istEXt(dv, 8 + 4 + 4 + ihdr + 4 + 4) && isCanvasXpress(dv, 8 + 4 + 4 + ihdr + 4 + 4 + 4, soft)) {
                        var rprs = dv.getUint32(8 + 4 + 4 + ihdr + 4 + 4 + 4 + soft + 4);
                        var indx = 8 + 4 + 4 + ihdr + 4 + 4 + 4 + soft + 4 + 4 + 4;
                        var res = "";
                        for (var i = 0; i < rprs; i++) {
                            res += String.fromCharCode(dv.getUint8(indx + i))
                        }
                        res = res.replace("ReproducibleResearch\0", "");
                        var data = t.parseJSON(res);
                        if (jr) {
                            return data
                        }
                        checkBackgroundImage(data);
                        data.uploadFile = true;
                        t.remoteServiceType = "file";
                        t.updateRemoteData(data, callback);
                        t.hideMask()
                    } else {
                        t.hideMask();
                        alert("Oooops! Not a valid CanvasXpress Image")
                    }
                };
                reader.readAsArrayBuffer(file)
            } else {
                var ext = part.pop();
                if (ext == "json") {
                    reader.onload = function() {
                        try {
                            var data = t.parseJSON(reader.result);
                            checkBackgroundImage(data);
                            if (data.data || (data && data.config && data.config.graphType && data.config.graphType == "Map")) {
                                data.uploadFile = true;
                                t.remoteServiceType = "file";
                                t.updateRemoteData(data, callback);
                                t.hideMask()
                            } else {
                                if (data.config) {
                                    t.setConfigDefaults();
                                    t.layoutValid = false;
                                    for (var p in data.config) {
                                        t[p] = data.config[p]
                                    }
                                    if (data.afterRender) {
                                        for (var i = 0; i < data.afterRender.length; i++) {
                                            var ar = data.afterRender[i];
                                            var fn = ar[0];
                                            var pr = ar[1] || [];
                                            t[fn].apply(t, pr)
                                        }
                                    } else {
                                        t.draw({
                                            func: "loadFile",
                                            par: [e, jr, callback, f]
                                        })
                                    }
                                } else {
                                    if (data.children && data.children.length) {
                                        data = t.parseHierarchy(data);
                                        data.uploadFile = true;
                                        t.remoteServiceType = "file";
                                        t.updateRemoteData(data, callback);
                                        t.hideMask()
                                    } else {
                                        if (data.nodes && data.links) {
                                            data = t.parseNodeLinks(data);
                                            data.uploadFile = true;
                                            t.remoteServiceType = "file";
                                            t.updateRemoteData(data, callback);
                                            t.hideMask()
                                        } else {
                                            if (data.type && data.type.match(/FeatureCollection|Topology/)) {
                                                var datan = {
                                                    data: false,
                                                    config: {
                                                        graphType: "Map",
                                                        topoJSON: data,
                                                        mapId: "cXMap"
                                                    }
                                                };
                                                window.cXMap = data;
                                                t.updateData(datan);
                                                t.hideMask()
                                            } else {
                                                var foo = data.error.error
                                            }
                                        }
                                    }
                                }
                            }
                        } catch (e) {
                            t.hideMask();
                            alert("Oooops! Not a valid CanvasXpress json file")
                        }
                    }
                } else {
                    if (ext == "geojson") {
                        reader.onload = function() {
                            try {
                                var data = t.parseJSON(reader.result);
                                if (data.type && data.type.match(/FeatureCollection|Topology/)) {
                                    var datan = {
                                        data: false,
                                        config: {
                                            graphType: "Map",
                                            topoJSON: data,
                                            mapId: "cXMap"
                                        }
                                    };
                                    window.cXMap = data;
                                    t.updateData(datan);
                                    t.hideMask()
                                } else {
                                    var foo = data.error.error
                                }
                            } catch (e) {
                                t.hideMask();
                                alert("Oooops! Not a valid geojson file")
                            }
                        }
                    } else {
                        if (ext == "svg") {
                            reader.onload = function() {
                                try {
                                    var data = t.SVGtoCX(reader.result);
                                    data.uploadFile = true;
                                    t.remoteServiceType = "file";
                                    t.updateRemoteData(data, callback);
                                    t.hideMask()
                                } catch (e) {
                                    t.hideMask();
                                    alert("Oooops! Not a valid CanvasXpress json file")
                                }
                            }
                        } else {
                            if (ext == "txt" || ext == "csv" || ext == "tsv" || ext == "tab") {
                                reader.onload = function() {
                                    try {
                                        var str = reader.result;
                                        var tc = 0;
                                        var tt = 0;
                                        if (str.match(/,/g)) {
                                            tc = str.match(/,/g).length
                                        }
                                        if (str.match(/\t/g)) {
                                            tt = str.match(/\t/g).length
                                        }
                                        var dl = ext == "csv" && tc > tt ? "," : "\t";
                                        var data;
                                        if (t.graphType == "Network") {
                                            data = t.delimitedToArray(str, dl, false, true);
                                            if (data && !t.isArray(data)) {
                                                var fail = "";
                                                if (data.fail > 0) {
                                                    fail = data.fail + " records couldn't be mapped to network data"
                                                }
                                                alert(data.rows + " " + data.type + " records added to network data\n" + fail);
                                                if (data.type == "node") {
                                                    t.appendNodeData(data.data)
                                                } else {
                                                    t.appendEdgeData(data.data)
                                                }
                                                t.hideMask();
                                                return
                                            } else {
                                                data = t.arrayToCanvasXpress(data)
                                            }
                                        } else {
                                            data = t.isMetaDataFile(t.delimitedToArray(str, dl), t.graphType == "Map");
                                            if (data && !t.isArray(data)) {
                                                if (data.addt) {
                                                    alert(data.recs + " records added as an additional data set\n")
                                                } else {
                                                    alert(data.recs + " records added to meta data\n")
                                                }
                                                t.appendMetaData(data.data, data.addt);
                                                t.hideMask();
                                                return
                                            } else {
                                                data = t.arrayToCanvasXpress(data)
                                            }
                                        }
                                        data.renderTo = part[0];
                                        data.uploadFile = true;
                                        t.remoteServiceType = "file";
                                        t.updateRemoteData(data, callback);
                                        t.hideMask()
                                    } catch (e) {
                                        t.hideMask();
                                        alert("Oooops! Not a valid CanvasXpress delimited file")
                                    }
                                }
                            } else {
                                if (ext == "esv") {
                                    reader.onload = function() {
                                        try {
                                            var str = reader.result;
                                            var tc = 0;
                                            var tt = 0;
                                            if (str.match(/,/g)) {
                                                tc = str.match(/,/g).length
                                            }
                                            if (str.match(/\t/g)) {
                                                tt = str.match(/\t/g).length
                                            }
                                            var dl = tc > tt ? "," : "\t";
                                            var data = t.delimitedToArray(str, dl, false, true, "edge");
                                            data.renderTo = part[0];
                                            data.uploadFile = true;
                                            t.remoteServiceType = "file";
                                            t.updateRemoteData(data, callback);
                                            t.hideMask()
                                        } catch (e) {
                                            t.hideMask();
                                            alert("Oooops! Not a valid CanvasXpress delimited file")
                                        }
                                    }
                                } else {
                                    if (ext == "gml") {
                                        reader.onload = function() {
                                            try {
                                                var data = t.parseGML(reader.result);
                                                data.renderTo = part[0];
                                                data.uploadFile = true;
                                                t.remoteServiceType = "file";
                                                t.updateRemoteData(data, callback);
                                                t.hideMask()
                                            } catch (e) {
                                                t.hideMask();
                                                alert("Oooops! Not a valid gml file for CanvasXpress")
                                            }
                                        }
                                    } else {
                                        if (ext == "gexf") {
                                            reader.onload = function() {
                                                t.remoteServiceType = "file";
                                                try {
                                                    var xml = t.parseXML(reader.result);
                                                    t.gexfToCX(xml, part[0])
                                                } catch (e) {
                                                    t.hideMask();
                                                    alert("Oooops! Not a valid " + ext + " file for CanvasXpress")
                                                }
                                            }
                                        } else {
                                            if (ext.match(/ml$/)) {
                                                reader.onload = function() {
                                                    try {
                                                        var xml = t.parseXML(reader.result);
                                                        t.loadXML(xml, part[0])
                                                    } catch (e) {
                                                        t.hideMask();
                                                        alert("Oooops! Not a valid " + ext + " file for CanvasXpress")
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                reader.readAsText(file)
            }
        }
    }(this);
    this.loadXML = function(xml, target, config, events) {
        this.remoteServiceType = "file";
        var ts1 = xml.childNodes[0];
        var ts2 = xml.childNodes[2] || xml.childNodes[1];
        if (ts1.tagName && ts1.tagName.toLowerCase() == "map") {
            this.metabaseToCX(xml, target, config, events)
        } else {
            if (ts1.tagName && ts1.tagName.toLowerCase() == "graph") {
                this.cytoscapeToCX(xml, target, config, events)
            } else {
                if (ts1.tagName && ts1.tagName.toLowerCase() == "pathway") {
                    this.wikipathwayToCX(xml, target, config, events)
                } else {
                    if (ts2 && ts2.tagName && ts2.tagName.toLowerCase() == "pathway") {
                        this.keggToCX(xml, target, config, events)
                    }
                }
            }
        }
    };
    this.editJSFiddle = function(t) {
        return function(e, f) {
            if (t.editable || f) {
                t.removeMenus();
                var js = "onReady(function () {\n" + t.getCodeJSONJS() + "})";
                var ht = "<link rel='stylesheet' href='https://www.canvasxpress.org/dist/canvasXpress.css' type='text/css'/>\n";
                ht += "<script type='text/javascript' src='https://www.canvasxpress.org/dist/canvasXpress.min.js'><\/script>\n\n";
                ht += "<canvas id='" + t.target + "' width='" + t.width + "' height='" + t.height + "'></canvas>";
                var form = t.$cX("form", {
                    id: "submitToJSFiddle",
                    method: "post",
                    action: "https://jsfiddle.net/api/post/library/pure/",
                    target: "check"
                }, {
                    display: "none"
                });
                document.body.appendChild(form);
                var tatt = t.$cX("textarea", {
                    name: "title",
                    value: (t.title || "CanvasXpress")
                });
                var taht = t.$cX("textarea", {
                    name: "html",
                    value: ht
                });
                var tajs = t.$cX("textarea", {
                    name: "js",
                    value: js
                });
                var btsb = t.$cX("button", {
                    type: "submit"
                });
                form.appendChild(tatt);
                form.appendChild(taht);
                form.appendChild(tajs);
                form.appendChild(btsb);
                btsb.click();
                document.body.removeChild(form)
            }
        }
    }(this);
    this.editCodePen = function(t) {
        return function(e, f) {
            if (t.editable || f) {
                t.removeMenus();
                var js = "onReady(function () {\n" + t.getCodeJSONJS().replace(/\'/g, "") + "})";
                var ht = '<link rel="stylesheet" href="https://www.canvasxpress.org/dist/canvasXpress.css" type="text/css"/>\n';
                ht += '<script type="text/javascript" src="https://www.canvasxpress.org/dist/canvasXpress.min.js"><\/script>\n\n';
                ht += '<canvas id="' + t.target + '" width="' + t.width + '" height="' + t.height + '"></canvas>';
                var rs = "https://www.canvasxpress.org/dist/canvasXpress.css;https://www.canvasxpress.org/dist/canvasXpress.min.js";
                var data = '{"title": "' + (t.title || "CanvasXpress") + '", "html": "' + ht + '" js: "' + js + '" js_external: "' + rs + '"}';
                data = '{"title": "CanvasXpress", "html": "' + ht.replace(/"/g, "'") + '", "js": "' + js.replace(/"/g, "'") + '", "js_external": "' + rs.replace(/"/g, "'") + '"}';
                var form = t.$cX("form", {
                    id: "submitToCodePen",
                    method: "post",
                    action: "https://codepen.io/pen/define",
                    target: "_blank"
                }, {
                    display: "none"
                });
                document.body.appendChild(form);
                var indt = t.$cX("input", {
                    type: "hidden",
                    name: "data",
                    value: data
                });
                var btsb = t.$cX("button", {
                    type: "submit"
                });
                form.appendChild(indt);
                form.appendChild(btsb);
                btsb.click();
                document.body.appendChild(form)
            }
        }
    }(this);
    this.saveCurrent = function() {
        this.resortData();
        var s = CanvasXpress.stack[this.target];
        var a = s.afterRender;
        var ar = [];
        for (var i = 0; i < a.length; i++) {
            if (a[i][0].match(/^sort/)) {
                ar.push(this.cloneObject(a[i]))
            }
        }
        return this.prettyJSON({
            renderTo: s.renderTo,
            data: this.data,
            config: this.getConfig(),
            afterRender: ar,
            factory: s.factory,
            system: s.system,
            version: s.version
        })
    };
    this.save = function(t) {
        return function(e, f, p, o) {
            t.removeMenus();
            t.resetConfigurator(e);
            var flnm = f ? f + ".json" : t.saveFilename ? t.saveFilename + ".json" : "cX-" + t.target + ".json";
            flnm = flnm.replace(/.json.json$/, ".json");
            CanvasXpress.stack[t.target].factory = CanvasXpress.factory;
            CanvasXpress.stack[t.target].system = CanvasXpress.system;
            var obj;
            if (p) {
                obj = t.prettyJSON({
                    config: CanvasXpress.stack[t.target].config,
                    afterRender: CanvasXpress.stack[t.target].afterRender || []
                })
            } else {
                if (o || (e && (e.ctrlKey || e.altKey))) {
                    obj = t.saveCurrent()
                } else {
                    obj = t.prettyJSON(t.cleanDataObject(t.cloneObject(CanvasXpress.stack[t.target])))
                }
            }
            var blob = new Blob([obj], {
                type: "text/plain"
            });
            t.saveAs(blob, flnm)
        }
    }(this);
    this.saveSVG = function(t) {
        return function(e, f) {
            t.removeMenus();
            t.resetConfigurator(e);
            CanvasXpress.stack[t.target].factory = CanvasXpress.factory;
            CanvasXpress.stack[t.target].system = CanvasXpress.system;
            t.isSVG = true;
            var tr = t.showTransition;
            t.showTransition = false;
            t.meta.canvas.SVG = new this.canvasToSVG({
                width: t.width,
                height: t.height,
                desc: t.isReproducibleResearch ? t.prettyJSON(t.cleanDataObject(t.cloneObject(CanvasXpress.stack[t.target]))) : ""
            });
            t.renderGraph(true);
            var svg = t.meta.canvas.SVG.getSerializedSvg();
            if (t.isReproducibleResearch) {
                t.flashInfoSpan(100, 100, "<h2>Please be aware <br>the actual data is stored<br>inside the downloaded image</h2>", 5000)
            }
            var flnm = f ? f + ".svg" : t.saveFilename ? t.saveFilename + ".svg" : "cX-" + t.target + ".svg";
            flnm = flnm.replace(/.svg.svg$/, ".svg");
            var blob = new Blob([svg], {
                type: "image/svg+xml"
            });
            t.saveAs(blob, flnm);
            t.showTransition = tr;
            delete(t.meta.canvas.SVG);
            t.isSVG = false
        }
    }(this);
    this.parseXML = function(xml) {
        var dom = null;
        if (window.DOMParser) {
            try {
                dom = (new DOMParser()).parseFromString(xml, "text/xml")
            } catch (e) {
                dom = null
            }
        } else {
            if (window.ActiveXObject) {
                try {
                    dom = new ActiveXObject("Microsoft.XMLDOM");
                    dom.async = false;
                    if (!dom.loadXML(xml)) {
                        window.alert(dom.parseError.reason + dom.parseError.srcText)
                    }
                } catch (e) {
                    dom = null
                }
            } else {
                alert("cannot parse xml string!")
            }
        }
        return dom
    };
    this.parseHTMLTable = function(table, cx) {
        var ar = [];
        for (var i = 0; i < table.rows.length; i++) {
            var ln = [];
            for (var j = 0; j < table.rows.item(i).cells.length; j++) {
                ln.push(table.rows.item(i).cells.item(j).innerHTML)
            }
            ar.push(ln)
        }
        if (cx) {
            cx = this.arrayToCanvasXpress(ar);
            CanvasXpress.transferDatasetAttributes(table, cx.config, true);
            return cx
        } else {
            return ar
        }
    };
    this.SVGtoCX = function(xml) {
        var dom = this.parseXML(xml);
        var svg = dom.childNodes[0];
        if (svg.tagName.match(/svg/i)) {
            var desc = svg.getAttribute("desc");
            if (desc) {
                return this.parseJSON(desc)
            }
        }
    };
    this.arrayBufferToBase64 = function(buffer) {
        var binary = "";
        var bytes = new Uint8Array(buffer);
        var len = bytes.byteLength;
        for (var i = 0; i < len; i++) {
            binary += String.fromCharCode(bytes[i])
        }
        return window.btoa(binary)
    };
    this.base64ToArrayBuffer = function(base64) {
        var binary_string = window.atob(base64);
        var len = binary_string.length;
        var bytes = new Uint8Array(len);
        for (var i = 0; i < len; i++) {
            bytes[i] = binary_string.charCodeAt(i)
        }
        return bytes.buffer
    };
    this.print = function(t) {
        return function(e, f, c) {
            var wn = window;
            var ow = t.width;
            var oh = t.height;
            var pm = t.printMagnification;
            var as = t.autoScaleFont;
            var st = t.showTransition;
            var ss = t.skipStack;
            var pr = ["outlineWidth", "lineThickness", "axisTickThickness", "axisMinMaxTickThickness", "guidesWidth", "boxplotMedianWidth", "boxplotConnectWidth", "treeLinkWidth", "connectByWidth", "histogramBarWidth", "heatmapCellBoxWidth", "heatmapCellBoxHighlightWidth", "edgeThickness", "maxTextSize", "treemapBorderWidth", "errorBarsThickness", "ganttDependencyThickness"];
            if (!CanvasXpress.stack.hasOwnProperty(t.target)) {
                t = CanvasXpress.getObject(CanvasXpress.current.replace("-events", ""))
            }
            var adjustDPI = function(reset) {
                if (reset && pm != 1) {
                    for (var i = 0; i < pr.length; i++) {
                        t[pr[i]] /= pm
                    }
                    t.autoScaleFont = as;
                    t.showTransition = st;
                    t.setDimensions(ow, oh, true);
                    t.skipStack = ss
                } else {
                    if (pm != 1) {
                        t.skipStack = true;
                        t.showTransition = false;
                        for (var i = 0; i < pr.length; i++) {
                            t[pr[i]] *= pm
                        }
                        t.autoScaleFont = true;
                        t.setDimensions(ow * pm, oh * pm, true)
                    }
                }
            };
            var makeCRCTable = function() {
                var cn;
                var crcTable = [];
                for (var n = 0; n < 256; n++) {
                    cn = n;
                    for (var k = 0; k < 8; k++) {
                        cn = ((cn & 1) ? (3988292384 ^ (cn >>> 1)) : (cn >>> 1))
                    }
                    crcTable[n] = cn
                }
                return crcTable
            };
            var crc32 = function(str) {
                var crcTable = wn.crcTable || (wn.crcTable = makeCRCTable());
                var crc = 0 ^ (-1);
                for (var i = 0; i < str.length; i++) {
                    crc = (crc >>> 8) ^ crcTable[(crc ^ str.charCodeAt(i)) & 255]
                }
                return (crc ^ (-1)) >>> 0
            };
            var appendBuffer = function(buffer1, buffer2) {
                var tmp = new Uint8Array(buffer1.byteLength + buffer2.byteLength);
                tmp.set(new Uint8Array(buffer1), 0);
                tmp.set(new Uint8Array(buffer2), buffer1.byteLength);
                return tmp.buffer
            };
            var getArrayBuffer = function(string) {
                var ztxt = "tEXt";
                var len = string.length;
                var crc = crc32(ztxt + string);
                var mab = new ArrayBuffer(12 + len);
                var ndv = new DataView(mab);
                ndv.setUint32(0, len);
                for (var i = 0; i < ztxt.length; i++) {
                    ndv.setUint8(4 + i, ztxt.charCodeAt(i))
                }
                for (var i = 0; i < string.length; i++) {
                    ndv.setUint8(8 + i, string.charCodeAt(i))
                }
                ndv.setUint32(4 + 4 + len, crc);
                return mab
            };
            var cleanStack = function() {
                if (t.isReproducibleResearch) {
                    if (t.printMagnification != 1) {
                        delete(CanvasXpress.stack[t.target].config.showTransition)
                    }
                    return e && (e.ctrlKey || e.altKey) ? t.saveCurrent() : t.stringifyJSON(t.cleanDataObject(t.cloneObject(CanvasXpress.stack[t.target])))
                } else {
                    var stk = t.parseJSON(e.ctrlKey || e.altKey ? t.saveCurrent() : t.stringifyJSON(CanvasXpress.stack[t.target]));
                    stk.afterRender = [stk.afterRender[0]];
                    return t.stringifyJSON(stk)
                }
            };
            var collectArrayBuffers = function(hab, sab, rab, dab) {
                var nab = appendBuffer(hab, sab);
                nab = appendBuffer(nab, rab);
                nab = appendBuffer(nab, dab);
                return nab
            };
            var toDataUrl = function(blb) {
                var fr = new FileReader();
                var tx = "";
                if (t.isReproducibleResearch) {
                    tx += "<h2>Please be aware that the actual data is stored inside the image! Right click to save!</h2>"
                } else {
                    tx += "<h2>Right click to save image</h2>"
                }
                fr.onload = function(evt) {
                    tx += "<img width=" + t.width + " height=" + t.height + " src= '" + evt.target.result + "'/>";
                    t.showTooltipDiv(e, tx, t.getTargetEvent(e), {
                        maxWidth: t.width + "px",
                        whiteSpace: "normal"
                    }, 40, 40)
                };
                fr.readAsDataURL(blb)
            };
            adjustDPI();
            t.removeMenus();
            t.resetConfigurator(e);
            CanvasXpress.stack[t.target].factory = CanvasXpress.factory;
            CanvasXpress.stack[t.target].system = CanvasXpress.system;
            var cnv = t.meta.canvas.ctx.canvas;
            cnv.toBlob(function(blob) {
                var fr = new FileReader();
                var fn = f ? f + ".png" : t.saveFilename ? t.saveFilename + ".png" : "cX-" + t.target + ".png";
                fn = fn.replace(/.png.png$/, ".png");
                fr.onloadend = function() {
                    var dv = new DataView(this.result);
                    var ihdr = dv.getUint32(8);
                    var idat = 8 + 4 + 4 + ihdr + 4;
                    var hab = this.result.slice(0, idat);
                    var dab = this.result.slice(idat);
                    var sab = getArrayBuffer("Software\0CanvasXpress Version: " + CanvasXpress.factory.version);
                    var rab = getArrayBuffer("ReproducibleResearch\0" + cleanStack());
                    var nab = collectArrayBuffers(hab, sab, rab, dab);
                    var blb = new Blob([nab], {
                        type: "image/png"
                    });
                    t.meta.base64 = t.arrayBufferToBase64(nab);
                    if (c) {
                        c(blb, fn)
                    } else {
                        if (t.printType == "download") {
                            if (t.isReproducibleResearch) {
                                t.flashInfoSpan(100, 100, "<h2>Please be aware <br>the actual data is stored<br>inside the downloaded image</h2>", 5000)
                            }
                            t.saveAs(blb, fn)
                        } else {
                            toDataUrl(blb)
                        }
                    }
                    adjustDPI(true)
                };
                fr.readAsArrayBuffer(blob)
            }, "image/png");
            if (t.maximized) {
                t.clickGraphMaxMin(e)
            }
        }
    }(this);
    this.exportToSVG = function(t) {
        return function(e) {
            var ctx = t.meta.canvas.ctx;
            t.meta.canvas.ctx = new this.canvasToSVG({
                width: t.width,
                height: t.height
            });
            t.draw({
                func: "exportToSVG",
                par: [e]
            });
            var svg = t.prettyXML(t.meta.canvas.ctx.getSerializedSvg());
            var win = window.open("", t.target + "-SVG");
            win.document.write(svg);
            t.meta.canvas.ctx = ctx;
            t.draw({
                func: "exportToSVG",
                par: [e]
            });
            return false
        }
    }(this);
    this.exportToExcel = function(d) {
        return this.exportToTabDelimited(d)
    };
    this.exportToHTML = function(d, t) {
        var str = "<table>";
        for (var i = 0; i < d.length; i++) {
            str += "<tr><td>";
            str += d[i].join("</td><td>");
            str += "</td></tr>"
        }
        str += "</table>";
        return t ? str : window.open().document.write(str)
    };
    this.exportToTabDelimited = function(d) {
        var str = "";
        for (var i = 0; i < d.length; i++) {
            str += d[i].join("\t") + "\n"
        }
        var link = this.$(this.target + "-cX-linkTab");
        if (!link) {
            link = this.$cX("a", {
                id: this.target + "-cX-linkTab"
            }, {
                display: "none"
            });
            window.document.body.appendChild(link)
        }
        link.download = this.target + ".tsv";
        link.href = "data:text/tab-separated-values;charset=UTF-8," + encodeURIComponent(str);
        link.click()
    };
    this.arrayToHTML = function(d) {
        var str = "";
        str += '<div class="CanvasXpressDataTableContainer" style="overflow:scroll;max-height:400px;max-width:600px;position:inherit;padding-left:18px;">';
        str += '<table class="CanvasXpressDataTable" style="position:inherit;">';
        str += "<tbody>";
        str += "<tr>";
        for (var i = 0; i < d[0][0].length; i++) {
            str += '<th class="CanvasXpressTableCellHead" style="height:18px">';
            str += '<div class="CanvasXpressTableCell" style="height:18px">';
            str += d[0][0][i];
            str += "</div>";
            str += "</th>"
        }
        str += "</tr>";
        for (var i = 1; i < d[0].length; i++) {
            str += "<tr>";
            for (var j = 0; j < d[0][i].length; j++) {
                if (j == 0) {
                    str += '<th class="CanvasXpressTableCellHead" style="height:18px">';
                    str += '<div class="CanvasXpressTableCell" style="height:18px">';
                    str += d[0][i][j];
                    str += "</div>";
                    str += "</th>"
                } else {
                    if (d[2] && d[2][i] && d[2][i][j]) {
                        str += '<td class="CanvasXpressTableCell" style="height:18px;background-color:' + d[2][i][j] + '">'
                    } else {
                        str += '<td class="CanvasXpressTableCell" style="height:18px">'
                    }
                    str += '<div class="CanvasXpressTableCell" style="height:18px">';
                    str += d[0][i][j];
                    str += "</div>";
                    str += "</td>"
                }
            }
            str += "</tr>"
        }
        str += "</tbody>";
        str += "</table>";
        str += "</div>";
        return str
    };
    this.rToPrettyR = function(s) {
        var nice = [];
        var lines = s.split(/\n(?=(?:(?:[^"]*"){2})*[^"]*$)/);
        var funcs = ["header", "quote", "row.names", "fill", "check.names", "stringsAsFactors"];
        var call = false;
        for (var i = 0; i < lines.length; i++) {
            var l = lines[i];
            if (l.match(/library\(canvasXpress\)/)) {
                nice.push(l.replace("library(canvasXpress)", 'library(<span class="json-value">canvasXpress</span>)'))
            } else {
                if (l.match(/canvasXpress\(/)) {
                    nice.push(l.replace("canvasXpress(", '<span class="json-value">canvasXpress</span>('));
                    call = true
                } else {
                    if (l.match(/\"http.+\"/)) {
                        l = l.replace(/(\"http.+?\")/, '<span class="json-string">$1</span>');
                        for (var j = 0; j < funcs.length; j++) {
                            l = l.replace(funcs[j], '<span class="json-key">' + funcs[j] + "</span>")
                        }
                        l = l.replace('""', '<span class="json-string">""</span>,');
                        l = l.replace(/\"\t\"/, '<span class="json-string">"&#92;t"</span>');
                        l = l.replace("=1,", '=<span class="json-number">1</span>,');
                        l = l.replace(/FALSE/g, '<span class="json-boolean">FALSE</span>');
                        l = l.replace(/TRUE/g, '<span class="json-boolean">TRUE</span>');
                        nice.push(l)
                    } else {
                        if (call) {
                            if (l.match(/\".+?\"/)) {
                                l = l.replace(/(\".+?\")/g, '<span class="json-string">$1</span>')
                            } else {
                                if (l.match(/[^xis][\d\.]+/)) {
                                    l = l.replace(/([\d\.]+)/, '<span class="json-number">$1</span>')
                                }
                            }
                            l = l.replace(/\n/, "&#92;n");
                            l = l.replace(/(\w+)?=/, '<span class="json-key">$1=</span>');
                            l = l.replace(/FALSE/g, '<span class="json-boolean">FALSE</span>');
                            l = l.replace(/TRUE/g, '<span class="json-boolean">TRUE</span>')
                        }
                        nice.push(l)
                    }
                }
            }
        }
        return '<pre class="CanvasXpressCodeContent">\n<code>' + nice.join("</code>\n<code>") + "</code>\n</pre>"
    };
    this.prettyColoredR = function(o, r, c) {
        var json = this.stringifyJSON(o, r ? r : null, 2);
        if (json.length > 10000) {
            c = false
        }
        if (c) {
            json = json.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;")
        }
        json = json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function(match) {
            var cls = "number";
            if (/^"/.test(match)) {
                if (/:$/.test(match)) {
                    match = match.replace(/"/g, "").replace(":", " =");
                    cls = "key"
                } else {
                    cls = "string"
                }
            } else {
                if (/true|false/.test(match)) {
                    match = match.replace("false", "FALSE").replace("true", "TRUE");
                    cls = "boolean"
                } else {
                    if (/null/.test(match)) {
                        match = match.replace("null", "NULL");
                        cls = "null"
                    }
                }
            }
            return c ? ('<span class="json-' + cls + '">' + match + "</span>") : match
        });
        return json.replace(/\[/g, "list(").replace(/]/g, ")").replace(/{/g, "list(").replace(/}/g, ")").replace(/^list\(\n/, "").replace(/\)$/, "")
    };
    this.dataToR = function() {
        var arr = [];
        var prp = [];
        var cnf, vls, vrs, sps, dat, cod;
        var scr = "";
        var data = CanvasXpress.stack[this.target].data;
        var ini = "<span class=json-value>canvasXpress</span>(\n";
        if (this.meta.config.remote) {
            scr += 'data = "' + this.meta.config.remote.data + '"\n';
            ini += "  <span class=json-key>data</span> = data,\n"
        } else {
            if (this.graphType == "Map") {
                scr += "";
                ini += "  <span class=json-key>data</span> = <span class=json-value>FALSE</span>,\n"
            } else {
                if (data.y) {
                    arr = [];
                    for (var i = 0; i < data.y.vars.length; i++) {
                        var arr2 = [];
                        for (var j = 0; j < data.y.smps.length; j++) {
                            arr2.push(data.y.data[i][j] != null ? data.y.data[i][j] : "NA")
                        }
                        arr.push("<span class=json-number>" + arr2.join("</span>,<span class=json-number>") + "</span>,")
                    }
                    arr[arr.length - 1] = arr[arr.length - 1].replace(/,$/, "");
                    vls = "vals = c(" + arr.join("\n+ ") + ")\n";
                    vrs = 'vars = c(<span class=json-string>"' + data.y.vars.join('"</span>,<span class=json-string>"') + '"</span>)\n';
                    sps = 'smps = c(<span class=json-string>"' + data.y.smps.join('"</span>,<span class=json-string>"') + '"</span>)\n';
                    dat = "data = as.data.frame(matrix(vals, <span class=json-key>nrow</span> = <span class=json-number>" + data.y.vars.length + "</span>, <span class=json-key>ncol</span> = <span class=json-number>" + data.y.smps.length + "</span>, <span class=json-key>byrow</span> = <span class=json-boolean>TRUE</span>, <span class=json-key>dimnames</span> = list(vars, smps)))\n";
                    scr += vls + vrs + sps + dat;
                    ini += "  <span class=json-key>data</span> = data,\n"
                }
                if (data.x) {
                    arr = [];
                    prp = [];
                    vls = "";
                    for (var i in data.x) {
                        if (this.meta.data.x[i].type == "Numeric") {
                            arr.push("<span class=json-number>" + data.x[i].join("</span>,<span class=json-number>") + "</span>,")
                        } else {
                            arr.push('<span class=json-string>"' + data.x[i].join('"</span>,<span class=json-string>"') + '"</span>,')
                        }
                        prp.push(i)
                    }
                    arr[arr.length - 1] = arr[arr.length - 1].replace(/,$/, "");
                    vls = "valx = c(" + arr.join("\n+ ") + ")\n";
                    if (this.graphType == "Tree") {
                        vls = vls.replace(/\"\"/g, "NA")
                    }
                    vrs = 'varx = c(<span class=json-string>"' + prp.join('"</span>,<span class=json-string>"') + '"</span>)\n';
                    dat = "datx = as.data.frame(matrix(valx, <span class=json-key>nrow</span> = <span class=json-number>" + prp.length + "</span>, <span class=json-key>ncol</span> = <span class=json-number>" + data.y.smps.length + "</span>, <span class=json-key>byrow</span> = <span class=json-boolean>TRUE</span>, <span class=json-key>dimnames</span> = list(varx, smps)))\n";
                    scr += vls + vrs + dat;
                    ini += "  <span class=json-key>smpAnnot</span> = datx,\n"
                }
                if (data.z) {
                    arr = [];
                    prp = [];
                    vls = "";
                    for (var i in data.z) {
                        if (this.meta.data.z[i].type == "Numeric") {
                            arr.push("<span class=json-number>" + data.z[i].join("</span>,<span class=json-number>") + "</span>,")
                        } else {
                            arr.push('<span class=json-string>"' + data.z[i].join('"</span>,<span class=json-string>"') + '"</span>,')
                        }
                        prp.push(i)
                    }
                    arr[arr.length - 1] = arr[arr.length - 1].replace(/,$/, "");
                    vls = "valz = c(" + arr.join("\n+ ") + ")\n";
                    sps = 'smpz = c(<span class=json-string>"' + prp.join('"</span>,<span class=json-string>"') + '"</span>)\n';
                    dat = "datz = as.data.frame(matrix(valz, <span class=json-key>nrow</span> = <span class=json-number>" + data.y.vars.length + "</span>, <span class=json-key>ncol</span> = <span class=json-number>" + prp.length + "</span>, <span class=json-key>byrow</span> = <span class=json-boolean>FALSE</span>, <span class=json-key>dimnames</span> = list(vars, smpz)))\n";
                    scr += vls + sps + dat;
                    ini += "  <span class=json-key>varAnnot</span> = datz,\n"
                }
                if (data.nodes) {
                    scr += "nodes = list(\n" + this.prettyColoredR(data.nodes, function(k, v) {
                        if (k != "layout") {
                            return v
                        }
                    }, true) + ")\n";
                    ini += "  <span class=json-key>nodeData</span> = nodes,\n"
                }
                if (data.edges) {
                    scr += "edges = list(\n" + this.prettyColoredR(data.edges, false, true) + ")\n";
                    ini += "  <span class=json-key>edgeData</span> = edges,\n"
                }
                if (data.venn) {
                    scr += "venn = data.frame(\n" + this.prettyColoredR(data.venn.data, false, true) + ")\n";
                    ini += "  <span class=json-key>vennData</span> = venn,\n";
                    if (data.venn.legend) {
                        scr += "legn = data.frame(\n" + this.prettyColoredR(data.venn.legend, false, true) + ")\n";
                        ini += "  <span class=json-key>vennLegend</span> = legn,\n"
                    }
                }
            }
        }
        cnf = this.meta.config.remote ? this.cloneObject(this.meta.config.remote.config) : this.cloneObject(CanvasXpress.stack[this.target].config);
        if (CanvasXpress.stack[this.target].afterRender && CanvasXpress.stack[this.target].afterRender.length > 1) {
            cnf.afterRender = this.cloneObject(CanvasXpress.stack[this.target].afterRender)
        }
        ini += this.prettyColoredR(cnf, false, true) + ")";
        cod = "library(<span class=json-value>canvasXpress</span>)\n" + scr + ini;
        return "<code> " + cod.replace(/\n/g, "</code>\n<code> ") + "</code>"
    };
    this.prettyJSON = function(o, r, c, i) {
        return c && o ? this.prettyColoredJSON(o, r) : o ? this.stringifyJSON(o, r, i || 2) : false
    };
    this.prettyColoredJSON = function(o, r) {
        if (o) {
            var json = this.stringifyJSON(o, r ? r : null, 2);
            if (json.length > 10000) {
                return json
            } else {
                json = json.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;")
            }
            return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function(match) {
                var cls = "number";
                if (/^"/.test(match)) {
                    if (/:$/.test(match)) {
                        cls = "key"
                    } else {
                        cls = "string"
                    }
                } else {
                    if (/true|false/.test(match)) {
                        cls = "boolean"
                    } else {
                        if (/null/.test(match)) {
                            cls = "null"
                        }
                    }
                }
                return '<span class="json-' + cls + '">' + match + "</span>"
            })
        } else {
            return false
        }
    };
    this.prettyXML = function(str) {
        var reg = /(>)\s*(<)(\/*)/g;
        var wsexp = / *(.*) +\n/g;
        var contexp = /(<.+>)(.+\n)/g;
        var xml = str.replace(reg, "$1\n$2$3").replace(wsexp, "$1\n").replace(contexp, "$1\n$2");
        var pad = 0;
        var formatted = "";
        var lines = xml.split("\n");
        var indent = 0;
        var lastType = "other";
        var transitions = {
            "single->single": 0,
            "single->closing": -1,
            "single->opening": 0,
            "single->other": 0,
            "closing->single": 0,
            "closing->closing": -1,
            "closing->opening": 0,
            "closing->other": 0,
            "opening->single": 1,
            "opening->closing": 0,
            "opening->opening": 1,
            "opening->other": 1,
            "other->single": 0,
            "other->closing": -1,
            "other->opening": 0,
            "other->other": 0
        };
        for (var i = 0; i < lines.length; i++) {
            var ln = lines[i];
            var single = Boolean(ln.match(/<.+\/>/));
            var closing = Boolean(ln.match(/<\/.+>/));
            var opening = Boolean(ln.match(/<[^!].*>/));
            var type = single ? "single" : closing ? "closing" : opening ? "opening" : "other";
            var fromTo = lastType + "->" + type;
            lastType = type;
            var padding = "";
            indent += transitions[fromTo];
            for (var j = 0; j < indent; j++) {
                padding += "  "
            }
            formatted += padding + ln + "\n"
        }
        return formatted
    };
    this.delimitedToArrayOrig = function(str, delim, cx) {
        delim = delim || ",";
        var pat = new RegExp(("(\\" + delim + '|\\r?\\n|\\r|^)(?:"([^"]*(?:""[^"]*)*)"|([^"\\' + delim + "\\r\\n]*))"), "gi");
        var arr = [
            []
        ];
        var arrM = null;
        while (arrM = pat.exec(str)) {
            var strM = arrM[1];
            if (strM.length && strM !== delim) {
                arr.push([])
            }
            var strV;
            if (arrM[2]) {
                strV = arrM[2].replace(new RegExp('""', "g"), '"')
            } else {
                strV = arrM[3]
            }
            arr[arr.length - 1].push(this.isNumber(strV) ? Number(strV) : strV != this.missingDataValue ? strV : null)
        }
        return cx ? this.arrayToCanvasXpress(arr) : arr
    };
    this.delimitedToArray = function(str, delim, cx, net, nwt) {
        var nl = /\r\n|\r|\n/g;
        var ar = str.split(nl);
        var setDelim = function() {
            var tc = 0;
            var tt = 0;
            if (str.match(/,/g)) {
                tc = str.match(/,/g).length
            }
            if (str.match(/\t/g)) {
                tt = str.match(/\t/g).length
            }
            delim = tc > tt ? "," : "\t"
        };
        if (!delim) {
            setDelim()
        }
        for (var i = 0; i < ar.length; i++) {
            if (ar[i].match(/^#/)) {
                ar.splice(i, 1);
                i--;
                continue
            }
            var f = ar[i].split(delim);
            for (var x = f.length - 1; x >= 0; x--) {
                if (f[x].replace(/"\s+$/, '"').charAt(f[x].length - 1) == '"') {
                    var tl = f[x].replace(/^\s+"/, '"');
                    if (tl.length > 1 && tl.charAt(0) == '"') {
                        f[x] = f[x].replace(/^\s*"|"\s*$/g, "").replace(/""/g, '"')
                    } else {
                        if (x) {
                            f.splice(x - 1, 2, [f[x - 1], f[x]].join(delim))
                        } else {
                            f = f.shift().split(delim).concat(f)
                        }
                    }
                } else {
                    f[x].replace(/""/g, '"')
                }
            }
            for (var j = 0; j < f.length; j++) {
                if (this.isNumber(f[j])) {
                    f[j] = Number(f[j])
                } else {
                    if (f[j] == this.missingDataValue) {
                        f[j] = null
                    } else {
                        if (f[j].match(/^\[.+\]$/) || f[j].match(/^\{.+\}$/)) {
                            f[j] = this.parseJSON(f[j])
                        }
                    }
                }
            }
            if (f.length == 1 && f[0] == "") {
                ar.splice(i, 1);
                i--;
                continue
            }
            ar[i] = f
        }
        return cx && !nwt ? this.arrayToCanvasXpress(ar) : net ? this.isNetworkFile(ar, nwt) : ar
    };
    this.isMetaDataFile = function(arr, isMap) {
        if (this.varIndices.length && this.smpIndices.length) {
            var that = this;
            var getObject = function(t) {
                if (t == "s") {
                    return {
                        y: {
                            smps: that.cloneObject(that.data.y.smps)
                        },
                        x: {}
                    }
                } else {
                    return {
                        y: {
                            vars: that.cloneObject(that.data.y.vars)
                        },
                        z: {}
                    }
                }
            };
            var map = {};
            if (isMap && this.data.z && this.data.z.hasOwnProperty("cXId")) {
                for (var i = 0; i < this.data.z.cXId.length; i++) {
                    map[this.data.z.cXId[i]] = i
                }
            }
            var rows = {
                s: [],
                v: []
            };
            var cols = {
                s: [],
                v: []
            };
            var idx;
            var min = 2;
            var add = false;
            for (var i = 1; i < arr.length; i++) {
                idx = this.getSampleIndices(arr[i][0]);
                if (idx > -1) {
                    rows.s.push([i, idx]);
                    continue
                }
                idx = isMap && map.hasOwnProperty(arr[i][0]) ? map[arr[i][0]] : this.getVariableIndices(arr[i][0]);
                if (idx > -1) {
                    rows.v.push([i, idx]);
                    continue
                }
            }
            for (var i = 1; i < arr[0].length; i++) {
                idx = isMap && map.hasOwnProperty(arr[i][0]) ? map[arr[i][0]] : this.getVariableIndices(arr[0][i]);
                if (idx > -1) {
                    cols.v.push([i, idx]);
                    continue
                }
                idx = this.getSampleIndices(arr[0][i]);
                if (idx > -1) {
                    cols.s.push([i, idx]);
                    continue
                }
            }
            var rs = rows.s.length > min ? rows.s.length : 0;
            var rv = rows.v.length > min ? rows.v.length : 0;
            var cs = cols.s.length > min ? cols.s.length : 0;
            var cv = cols.v.length > min ? cols.v.length : 0;
            var sl = this.data.y.smps.length;
            var vl = this.data.y.vars.length;
            if (rs || rv || cs || cv) {
                var n = 0;
                if (rs == sl && cv == vl) {
                    var data = [];
                    for (var i = 0; i < cols.v.length; i++) {
                        var ii = cols.v[i][0];
                        var ix = cols.v[i][1];
                        data[ix] = [];
                        for (var j = 0; j < rows.s.length; j++) {
                            var jj = rows.s[j][0];
                            var jx = rows.s[j][1];
                            data[ix][jx] = arr[jj][ii];
                            n++
                        }
                    }
                    add = true
                } else {
                    if (cs == sl && rv == vl) {
                        var data = [];
                        for (var i = 0; i < rows.v.length; i++) {
                            var ii = rows.v[i][0];
                            var ix = rows.v[i][1];
                            data[ix] = [];
                            for (var j = 0; j < cols.s.length; j++) {
                                var jj = cols.s[j][0];
                                var jx = cols.s[j][1];
                                data[ix][jx] = arr[ii][jj];
                                n++
                            }
                        }
                        add = true
                    } else {
                        if (rs >= rv && rs >= cs && rs >= cv) {
                            var data = getObject("s");
                            for (var i = 1; i < arr[0].length; i++) {
                                data.x[arr[0][i]] = [];
                                var m = 0;
                                for (var j = 0; j < rows.s.length; j++) {
                                    var jj = rows.s[j][0];
                                    var jx = rows.s[j][1];
                                    data.x[arr[0][i]][jx] = arr[jj][i];
                                    n++;
                                    m = arr[jj][i] ? m + 1 : m
                                }
                                if (!m) {
                                    delete data.x[arr[0][i]]
                                }
                            }
                        } else {
                            if (rv >= rs && rv >= cs && rv >= cv) {
                                var data = getObject("v");
                                for (var i = 1; i < arr[0].length; i++) {
                                    data.z[arr[0][i]] = [];
                                    var m = 0;
                                    for (var j = 0; j < rows.v.length; j++) {
                                        var jj = rows.v[j][0];
                                        var jx = rows.v[j][1];
                                        data.z[arr[0][i]][jx] = arr[jj][i];
                                        n++;
                                        m = arr[jj][i] ? m + 1 : m
                                    }
                                    if (!m) {
                                        delete data.z[arr[0][i]]
                                    }
                                }
                            } else {
                                if (cs > rs && cs >= rv && cs >= cv) {
                                    var data = getObject("s");
                                    for (var i = 0; i < cols.s.length; i++) {
                                        var ii = cols.s[i][0];
                                        var ix = cols.s[i][1];
                                        var m = 0;
                                        for (var j = 1; j < arr.length; j++) {
                                            if (i == 0) {
                                                data.x[arr[j][0]] = []
                                            }
                                            data.x[arr[j][0]][ix] = arr[j][ii];
                                            n++;
                                            m = arr[j][ii] ? m + 1 : m
                                        }
                                        if (!m) {
                                            delete data.x[arr[j][0]]
                                        }
                                    }
                                } else {
                                    if (cv > rs && cv >= rv && cv >= cs) {
                                        var data = getObject("v");
                                        for (var i = 0; i < rows.s.length; i++) {
                                            var ii = rows.s[i][0];
                                            var ix = rows.s[i][1];
                                            var m = 0;
                                            for (var j = 1; j < arr.length; j++) {
                                                if (i == 0) {
                                                    data.z[arr[j][0]] = []
                                                }
                                                data.z[arr[j][0]][ix] = arr[j][ii];
                                                n++;
                                                m = arr[j][ii] ? m + 1 : m
                                            }
                                            if (!m) {
                                                delete data.z[arr[j][0]]
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                return {
                    data: data,
                    recs: n,
                    addt: add
                }
            } else {
                return arr
            }
        }
        return arr
    };
    this.isNetworkFile = function(arr, nwt) {
        var obj = {};
        var cols = arr[0];
        var nodes = 0;
        var edges = 0;
        var fail = 0;
        var type = nwt || false;
        if (type == "node") {} else {
            if (type == "edge") {
                nodes = {};
                obj.data = {
                    nodes: [],
                    edges: []
                };
                for (var i = 1; i < arr.length; i++) {
                    var n = arr[i][0];
                    var m = arr[i][1];
                    if (n && m) {
                        var e = {
                            id1: n,
                            id2: m
                        };
                        for (var j = 2; j < arr[i].length; j++) {
                            e[arr[0][j]] = arr[i][j]
                        }
                        obj.data.edges.push(e)
                    }
                    nodes[n] = true;
                    nodes[m] = true
                }
                for (var i in nodes) {
                    obj.data.nodes.push({
                        id: i,
                        shape: "sphere"
                    })
                }
                obj.config = {
                    graphType: "Network"
                };
                return obj
            } else {
                var map = {};
                for (var i = 1; i < arr.length; i++) {
                    var n = arr[i][0];
                    var m = arr[i][1];
                    if (this.data.nodeIndices.hasOwnProperty(n) && this.data.nodeIndices.hasOwnProperty(m)) {
                        edges++
                    } else {
                        if (this.data.nodeIndices.hasOwnProperty(n)) {
                            nodes++
                        } else {
                            fail++
                        }
                    }
                    map[n] = i
                }
                if (!nodes && !edges) {
                    for (var i = 0; i < this.data.nodes.length; i++) {
                        var n = this.data.nodes[i];
                        if (n.hasOwnProperty("extId") && map.hasOwnProperty(n.extId)) {
                            arr[map[n.extId]][0] = n.id;
                            nodes++
                        }
                    }
                }
                if (edges > nodes) {
                    nodes = 0;
                    edges = 0;
                    fail = 0;
                    type = "edge";
                    for (var i = 1; i < arr.length; i++) {
                        var n = arr[i][0];
                        var m = arr[i][1];
                        if (this.data.nodeIndices.hasOwnProperty(n) && this.data.nodeIndices.hasOwnProperty(m)) {
                            edges++;
                            obj[n + ":" + m] = {};
                            for (var j = 2; j < cols.length; j++) {
                                obj[n + ":" + m][cols[j]] = arr[i][j]
                            }
                        } else {
                            fail++
                        }
                    }
                } else {
                    if (nodes > 8) {
                        nodes = 0;
                        edges = 0;
                        fail = 0;
                        type = "node";
                        for (var i = 1; i < arr.length; i++) {
                            var n = arr[i][0];
                            if (this.data.nodeIndices.hasOwnProperty(n)) {
                                nodes++;
                                obj[n] = {};
                                for (var j = 1; j < cols.length; j++) {
                                    obj[n][cols[j]] = arr[i][j]
                                }
                            } else {
                                fail++
                            }
                        }
                    } else {
                        return arr
                    }
                }
                if ((type == "edge" && (edges > 5 || edges >= arr.length - 1)) || (type == "node" && (nodes > 5 || nodes >= arr.length - 1))) {
                    return {
                        data: obj,
                        rows: Math.max(nodes, edges),
                        fail: fail,
                        type: type
                    }
                } else {
                    return arr
                }
            }
        }
    };
    this.XMLToJSON = function(xml, json, p, parent) {
        var j = {};
        var prefix = new RegExp(/(?!xmlns)^.*:/);
        var trim = new RegExp(/^\s+|\s+$/g);
        if (!json) {
            json = {}
        }
        if (p && !json[p]) {
            json[p] = []
        }
        if (xml.attributes && xml.attributes.length > 0) {
            for (var i = 0; i < xml.attributes.length; i++) {
                var a = xml.attributes.item(i);
                var n = a.name.replace(prefix, "").replace(/\[/g, "&#91").replace(/\]/g, "&#93").toLowerCase();
                if (p) {
                    j[n] = a.value.replace(trim, "")
                } else {
                    json[n] = a.value.replace(trim, "")
                }
            }
            if (p) {
                json[p].push(j)
            }
        } else {
            if (p == "alt") {
                json[p].push(xml.textContent.replace(/\"/g, "'").replace(/\[/g, "&#91").replace(/\]/g, "&#93"))
            }
        }
        if (xml.hasChildNodes() && !parent) {
            for (var i = 0; i < xml.childNodes.length; i++) {
                var n = xml.childNodes.item(i);
                var p;
                if (n.nodeType == 4) {} else {
                    if (n.nodeType == 3) {} else {
                        if (n.nodeType == 1) {
                            p = n.nodeName.replace(prefix, "").toLowerCase();
                            this.XMLToJSON(n, json, p)
                        }
                    }
                }
            }
        }
        return json
    };
    this.cytoscapeToCX = function(xml, target, config, events) {
        var sp = {
            ELLIPSE: "oval",
            arc: "circle",
            bitmap: "circle",
            line: "minus",
            text: "circle",
            ver_ellipsis: "oval",
            hor_ellipsis: "oval"
        };
        var nodes = [];
        var edges = [];
        var title = "";
        var pw = xml.childNodes[0];
        if (pw.tagName.toLowerCase() == "graph") {
            var ob = this.XMLToJSON(pw, false, false, true);
            for (var i = 0; i < pw.childNodes.length; i++) {
                var el = pw.childNodes[i];
                if (el.nodeName) {
                    var nn = el.nodeName.toLowerCase();
                    var js = this.XMLToJSON(el);
                    switch (nn) {
                        case "node":
                            if (js.graphics && js.id) {
                                var gr = js.graphics[0];
                                var node = {
                                    id: js.id,
                                    x: Number(gr.x),
                                    y: Number(gr.y),
                                    z: Number(gr.z),
                                    width: Number(gr.w),
                                    height: Number(gr.h),
                                    shape: (sp[gr.type] || gr.type),
                                    color: gr.fill,
                                    outline: gr.outline,
                                    outlineWidth: Number(gr.width)
                                };
                                if (js.label) {
                                    node.name = js.label
                                }
                                if (js.att) {
                                    for (var j = 0; j < js.att.length; j++) {
                                        var at = js.att[j];
                                        if (at.name && !at.name.match(/NODE_/) && at.name != "selected" && at.name != "isInPath") {
                                            switch (at.type) {
                                                case "String":
                                                    if (at.name == "COMMON" && at.value) {
                                                        node.label = at.value
                                                    } else {
                                                        if (at.value) {
                                                            node[at.name] = at.value
                                                        }
                                                    }
                                                    break;
                                                case "Double":
                                                case "Integer":
                                                    if (at.value != null) {
                                                        node[at.name] = Number(at.value)
                                                    }
                                                    break;
                                                case "Boolean":
                                                    if (at.value != null) {
                                                        node[at.name] = at.value == 0 ? false : true
                                                    }
                                                    break
                                            }
                                        }
                                    }
                                }
                                nodes.push(node)
                            }
                            break;
                        case "edge":
                            if (js.source && js.target) {
                                var edge = {
                                    id1: js.source,
                                    id2: js.target
                                };
                                if (js.id) {
                                    edge.intId = js.id
                                }
                                if (js.label) {
                                    edge.label = js.label
                                }
                                if (js.directed) {
                                    edge.directed = js.directed
                                }
                                if (js.graphics) {
                                    edge.color = js.graphics[0].fill;
                                    edge.width = js.graphics[0].width
                                }
                                if (js.att) {
                                    for (var j = 0; j < js.att.length; j++) {
                                        var at = js.att[j];
                                        if (at.name && !at.name.match(/EDGE_/) && at.name != "selected" && at.name != "isInPath") {
                                            switch (at.type) {
                                                case "String":
                                                    if (at.value) {
                                                        edge[at.name] = at.value
                                                    }
                                                    break;
                                                case "Double":
                                                case "Integer":
                                                    if (at.value != null) {
                                                        edge[at.name] = Number(at.value)
                                                    }
                                                    break;
                                                case "Boolean":
                                                    if (at.value != null) {
                                                        edge[at.name] = at.value == 0 ? false : true
                                                    }
                                                    break
                                            }
                                        }
                                    }
                                }
                                edges.push(edge)
                            }
                            break;
                        case "att":
                            if (js.name && js.value && js.name == "Dataset Name") {
                                title = js.value
                            }
                            break
                    }
                }
            }
        } else {
            alert("Ooops! Not a cytoscape xgmml file!")
        }
        var res = "Number of Nodes: " + nodes.length + "\nNumber of Edges: " + edges.length + "\n";
        res = res.replace(/\n/g, "<br>");
        var data = {
            data: {
                nodes: nodes,
                edges: edges
            },
            config: {
                adjustBezier: false,
                graphType: "Network",
                calculateLayout: false,
                showAnimation: false,
                networkNodesOnTop: true,
                showNodeNameThreshold: 20000,
                networkFreeze: false,
                preScaleNetwork: false,
                title: title,
                moveParentsWithChildren: true,
                ignoreEventlessOrder: true,
                networkVendor: "Cytoscape"
            },
            renderTo: target,
            events: events,
            uploadFile: (this.dataString ? false : true),
            afterRender: [
                ["flashInfoSpan", [100, 100, res, 5000]],
                ["appendNetworkDataFromURL", []]
            ]
        };
        if (config) {
            for (var p in config) {
                data.config[p] = config[p]
            }
        }
        var clbk = false;
        var rurl = this.dataURL || this.dataString;
        var cnfg = this.cloneObject(this.meta.config.user);
        if (this.graphType == "Network") {
            for (var p in this.meta.config.user) {
                data.config[p] = this.meta.config.user[p]
            }
            clbk = function(t) {
                t.meta.config.remote = {
                    data: rurl,
                    config: cnfg
                };
                t.networkFreeze = true
            }
        }
        this.updateRemoteData(data, clbk);
        this.hideMask()
    };
    this.keggToCX = function(xml, target, config, events) {
        var that = this;
        var pw = xml.childNodes[2] || xml.childNodes[1];
        var nodes = [];
        var edges = [];
        var title, image, link, width, height;
        var addAnchors = function() {
            nodes.push({
                id: "__zero__",
                type: "anchor",
                shape: "circle",
                color: "rgba(0,0,0,0)",
                outline: "rgb(0,0,0)",
                width: 1,
                height: 1,
                x: 0,
                y: 0,
                hideLabel: true
            }, {
                id: "__max__",
                type: "anchor",
                shape: "circle",
                color: "rgba(0,0,0,0)",
                outline: "rgb(0,0,0)",
                width: 1,
                height: 1,
                x: width,
                y: height,
                hideLabel: true
            })
        };
        if (pw.tagName.toLowerCase() == "pathway") {
            var ob = this.XMLToJSON(pw, false, false, true);
            title = ob.title;
            image = ob.image;
            link = ob.link;
            var img = new Image();
            img.onload = function() {
                width = this.width;
                height = this.height;
                var res = "Number of Nodes: " + nodes.length + "\n";
                res += "Number of Edges: " + edges.length + "\n";
                addAnchors();
                that.remoteServiceType = "file";
                that.networkFreeze = false;
                var data = {
                    data: {
                        nodes: nodes,
                        edges: edges
                    },
                    config: {
                        adjustBezier: false,
                        graphType: "Network",
                        calculateLayout: false,
                        showAnimation: false,
                        networkNodesOnTop: false,
                        networkFreeze: false,
                        showNodeNameThreshold: 20000,
                        preScaleNetwork: false,
                        title: title,
                        backgroundType: "image",
                        backgroundImage: image,
                        networkVendor: "Kegg"
                    },
                    renderTo: target,
                    events: events,
                    uploadFile: (that.dataString ? false : true),
                    afterRender: [
                        ["flashInfoSpan", [100, 100, res, 5000]],
                        ["appendNetworkDataFromURL", []]
                    ]
                };
                if (config) {
                    for (var p in config) {
                        data.config[p] = config[p]
                    }
                }
                var clbk = false;
                var rurl = that.dataURL || that.dataString;
                var cnfg = that.cloneObject(that.meta.config.user);
                if (that.graphType == "Network") {
                    for (var p in that.meta.config.user) {
                        data.config[p] = that.meta.config.user[p]
                    }
                    clbk = function(t) {
                        t.meta.config.remote = {
                            data: rurl,
                            config: cnfg
                        };
                        t.networkFreeze = true
                    }
                }
                that.updateRemoteData(data, clbk);
                that.hideMask()
            };
            if ((CanvasXpress.system.isR && !CanvasXpress.system.isInIframe) || !CanvasXpress.system.isR) {
                img.crossOrigin = "anonymous"
            }
            img.src = ob.image;
            for (var i = 0; i < pw.childNodes.length; i++) {
                var el = pw.childNodes[i];
                if (el.nodeName) {
                    var nn = el.nodeName.toLowerCase();
                    switch (nn) {
                        case "entry":
                            var ob = this.XMLToJSON(el);
                            if (ob.graphics[0].type == "roundrectangle") {
                                ob.graphics[0].type = "roundrect";
                                ob.graphics[0].fgcolor = "rgba(0,0,0,0)"
                            }
                            if (ob.graphics && ob.graphics.length == 1 && ob.graphics[0].type != "line") {
                                var ext = ob.type == "group" ? 5 : 0;
                                var node = {
                                    id: ob.id,
                                    type: ob.type,
                                    link: ob.link,
                                    name: ob.graphics[0].name,
                                    shape: ob.graphics[0].type,
                                    color: "rgba(0,0,0,0)",
                                    outline: that.validateColor(ob.graphics[0].fgcolor) || "rgb(0,0,0)",
                                    width: parseInt(ob.graphics[0].width) + ext,
                                    height: parseInt(ob.graphics[0].height) + ext,
                                    x: parseInt(ob.graphics[0].x),
                                    y: parseInt(ob.graphics[0].y),
                                    hideLabel: true,
                                    fixed: true
                                };
                                if (ob.type == "group") {
                                    nodes.unshift(node)
                                } else {
                                    nodes.push(node)
                                }
                            } else {
                                if (ob.graphics && ob.graphics.length == 1 && ob.graphics[0].type == "line") {
                                    var coords = ob.graphics[0].coords.split(",");
                                    if (coords.length == 4) {
                                        var x = [];
                                        var y = [];
                                        var w, h, r;
                                        while (coords.length > 1) {
                                            x.push(parseInt(coords.shift()));
                                            y.push(parseInt(coords.shift()))
                                        }
                                        var mx = parseInt(this.mean(x));
                                        var my = parseInt(this.mean(y));
                                        if (x[0] == x[1]) {
                                            mx += 1;
                                            w = 2;
                                            h = y[1] - y[0];
                                            r = 0
                                        } else {
                                            if (y[0] == y[1]) {
                                                my += 1;
                                                w = x[1] - x[0];
                                                h = 2;
                                                r = 0
                                            } else {
                                                h = this.lineLength(x[0], y[0], x[1], y[1]);
                                                w = 2;
                                                r = this.getAngle(x[0], y[0], x[1], y[1])
                                            }
                                        }
                                        var node = {
                                            id: ob.id,
                                            type: ob.type,
                                            link: ob.link,
                                            name: ob.graphics[0].name,
                                            shape: "rect",
                                            color: "rgba(0,0,0,0)",
                                            outline: "rgba(0,0,0,0)",
                                            x: mx,
                                            y: my,
                                            width: w,
                                            height: h,
                                            rotate: r,
                                            hideLabel: true,
                                            fixed: true
                                        };
                                        nodes.push(node)
                                    }
                                }
                            }
                            break;
                        case "relation":
                        case "reaction":
                            var ob = this.XMLToJSON(el);
                            ob.id1 = this.cloneObject(ob.entry1);
                            ob.id2 = this.cloneObject(ob.entry2);
                            delete(ob.entry1);
                            delete(ob.entry2);
                            ob.color = "rgba(0,0,0,0)";
                            edges.push(ob);
                            break
                    }
                }
            }
        } else {
            alert("Ooops! Not a kgml file!")
        }
    };
    this.wikipathwayToCX = function(xml, target, config, events) {
        var pw = xml.childNodes[0];
        var nodes = {};
        var edges = [];
        var state = {};
        var groups = {};
        var anchors = {};
        var order = {};
        var cntp = 1;
        var cntn = 0;
        var sord = [];
        var groupRef = {};
        var groupGref = {};
        var groupId = {};
        var wrn = "\nWarnings:\n";
        var htt = false;
        var title, subtitle;
        var arrowTypes = {
            Line: false,
            Arrow: "arrow",
            TBar: "square",
            "mim-necessary-stimulation": false,
            "mim-binding": false,
            "mim-conversion": "arrow",
            "mim-stimulation": "arrow",
            "mim-catalysis": "round",
            "mim-modification": false,
            "mim-inhibition": "square",
            "mim-covalent-bond": false,
            "mim-transcription-translation": false
        };
        var createNodeFromGroup = function(grp, id) {
            var mnx = Number.MAX_VALUE;
            var mny = Number.MAX_VALUE;
            var mxx = -Number.MAX_VALUE;
            var mxy = -Number.MAX_VALUE;
            var ids = [];
            var ord = [];
            var shw = false;
            for (var i = 0; i < grp.length; i++) {
                mnx = Math.min(mnx, grp[i][1] - (grp[i][3] / 2));
                mny = Math.min(mny, grp[i][2] - (grp[i][4] / 2));
                mxx = Math.max(mxx, grp[i][1] + (grp[i][3] / 2));
                mxy = Math.max(mxy, grp[i][2] + (grp[i][4] / 2));
                ids.push(grp[i][0]);
                nodes[grp[i][0]].parentNode = id;
                ord.push(nodes[grp[i][0]].zorder);
                if (nodes[grp[i][0]].nodeName != "label") {
                    shw = true
                }
                ord.sort(function(a, b) {
                    return a - b
                })
            }
            var w = mxx - mnx;
            var h = mxy - mny;
            var ob = {
                id: id,
                x: (mnx + mxx) / 2,
                y: (mny + mxy) / 2,
                width: w + (grp.length > 1 && w > 10 ? 5 : 0),
                height: h + (grp.length > 1 && h > 10 ? 5 : 0),
                group: ids,
                hideLabel: true,
                hideTooltip: htt,
                type: "Group",
                color: (shw ? "rgba(245,245,245,0.5)" : "rgba(0,0,0,0)"),
                outline: (shw ? "rgb(0,0,0)" : "rgba(0,0,0,0)"),
                shape: "rectangle",
                zorder: ord[0]
            };
            order[id] = cntn--;
            nodes[id] = ob;
            sord.push(id)
        };
        var createNodeFromPoint = function(p, id) {
            var ob = {
                id: id,
                x: Math.round(p.x * 10) / 10,
                y: Math.round(p.y * 10) / 10,
                width: p.width ? Math.round(p.width) : 1,
                height: p.height ? Math.round(p.height) : 1,
                hideLabel: p.show ? false : true,
                hideTooltip: !htt ? false : p.show ? false : true,
                eventless: p.show ? false : true,
                type: p.type || "Anchor",
                color: p.color || "rgba(0,0,0,0)",
                outline: p.outline || "rgba(0,0,0,0)",
                shape: p.shape || "circle",
                label: p.label || "",
                zorder: p.zorder || 0
            };
            order[id] = cntp++;
            nodes[id] = ob;
            sord.push(id)
        };
        var getDirection = function(s) {
            switch (s) {
                case "r":
                case "l":
                    return "rl";
                case "b":
                case "t":
                case "c":
                    return "tb"
            }
        };
        var getSide = function(p) {
            if (parseInt(p.relx) == 1) {
                return "r"
            } else {
                if (parseInt(p.relx) == -1) {
                    return "l"
                } else {
                    if (parseInt(p.rely) == 1) {
                        return "b"
                    } else {
                        if (parseInt(p.rely) == -1) {
                            return "t"
                        } else {
                            if (Math.abs(p.relx) > Math.abs(p.rely)) {
                                if (parseFloat(p.relx) > 0) {
                                    return "r"
                                } else {
                                    return "l"
                                }
                            } else {
                                if (parseFloat(p.rely) > 0) {
                                    return "b"
                                } else {
                                    if (parseFloat(p.rely) < 0) {
                                        return "t"
                                    } else {
                                        return "c"
                                    }
                                }
                            }
                        }
                    }
                }
            }
        };
        var getNumberOfLines = function(s, t) {
            var findExtra = function(sd, p1, p2) {
                switch (sd) {
                    case "r":
                        if (parseFloat(p1.x) >= parseFloat(p2.x)) {
                            return 2
                        }
                        break;
                    case "l":
                        if (parseFloat(p1.x) <= parseFloat(p2.x)) {
                            return 2
                        }
                        break;
                    case "t":
                    case "c":
                        if (parseFloat(p1.y) <= parseFloat(p2.y)) {
                            return 2
                        }
                        break;
                    case "b":
                        if (parseFloat(p1.y) >= parseFloat(p2.y)) {
                            return 2
                        }
                        break
                }
                return 0
            };
            var ss = getSide(s);
            var ts = getSide(t);
            var ls = 2;
            if (getDirection(ss) == getDirection(ts)) {
                ls++
            }
            if (ss != ts) {
                ls += findExtra(ss, s, t);
                ls += findExtra(ts, t, s)
            }
            return ls
        };
        var getPoint = function(s, a, f) {
            if (f) {
                switch (s) {
                    case "r":
                        return [a[0] + 20, a[1]];
                    case "l":
                        return [a[0] - 20, a[1]];
                    case "t":
                    case "c":
                        return [a[0], a[1] - 20];
                    case "b":
                        return [a[0], a[1] + 20]
                }
            } else {
                switch (s) {
                    case "r":
                    case "l":
                        return [a[0][0], a[1][1]];
                    case "t":
                    case "b":
                    case "c":
                        return [a[1][0], a[0][1]]
                }
            }
        };
        var getCoords = function(d, a) {
            var r = [a[0]];
            var l = a[0];
            for (var i = 1; i < a.length; i++) {
                var c = a[i];
                switch (d) {
                    case "rl":
                        r.push([c[0], l[1]]);
                        break;
                    case "tb":
                        r.push([l[0], c[1]]);
                        break
                }
                l = r[i];
                d = d == "rl" ? "tb" : "rl"
            }
            r.push(a[a.length - 1]);
            return r
        };
        var to2DArray = function(edg) {
            var ps = edg.point;
            var a = [];
            for (var i = 0; i < ps.length; i++) {
                a.push([Math.round(ps[i].x * 10) / 10, Math.round(ps[i].y * 10) / 10])
            }
            return a
        };
        var getElbowPoints = function(edg) {
            var ps = edg.point;
            var n1 = ps.length - 1;
            var ls = getNumberOfLines(ps[0], ps[n1]);
            var s = getSide(ps[0]);
            var t = getSide(ps[n1]);
            var d = getDirection(s);
            var a = to2DArray(edg);
            if (ls == ps.length) {
                a = getCoords(d, a)
            } else {
                if (ps.length == 2) {
                    a.splice(1, 0, getPoint(s, a[0], true));
                    if (ls > 3) {
                        if (ls > 3) {
                            a.splice(2, 0, getPoint(t, a[2], true))
                        }
                        if (ls > 4) {
                            if (ls > 4) {
                                a.splice(3, 0, [(a[1][0] + a[2][0]) / 2, (a[1][1] + a[2][1]) / 2])
                            }
                            if (ls > 5) {
                                a = to2DArray(edg);
                                a = getCoords(d, a)
                            }
                        } else {
                            a.splice(2, 0, getPoint(s, [a[1], a[2]]))
                        }
                    } else {
                        if ((a[0][0] == a[1][0] && a[1][0] == a[2][0]) || (a[0][1] == a[1][1] && a[1][1] == a[2][1])) {
                            a.splice(1, 1)
                        } else {
                            a.splice(2, 0, getPoint(s, [a[1], a[2]]))
                        }
                    }
                } else {
                    if (ps.length > ls) {
                        a = getCoords(d, a)
                    } else {
                        for (var i = 0; i < n1; i++) {
                            var j = i * 2;
                            if (d == "tb") {
                                d = "rl";
                                a.splice(j + 1, 0, [a[j][0], a[j + 1][1]])
                            } else {
                                d = "tb";
                                a.splice(j + 1, 0, [a[j + 1][0], a[j][1]])
                            }
                        }
                    }
                }
            }
            var b = [
                [a[0][0], a[0][1]]
            ];
            for (var i = 1; i < a.length; i++) {
                if (a[i][0] == a[i - 1][0] && a[i][1] == a[i - 1][1]) {
                    continue
                }
                b.push([a[i][0], a[i][1]])
            }
            return b
        };
        var getBezierPoints = function(edg, sn, tn) {
            var ps = edg.point;
            var n1 = ps.length - 1;
            var s = getSide(ps[0]);
            var t = getSide(ps[n1]);
            var ds = getDirection(s);
            var dt = getDirection(t);
            var ar = to2DArray(edg);
            var segs = [];
            var p0, p1, mx, my;
            if (n1 == 1) {
                p0 = ar[0];
                p1 = ar[1];
                if (sn && tn) {
                    if (ds == dt) {
                        mx = (p0[0] + p1[0]) / 2;
                        my = (p0[1] + p1[1]) / 2;
                        if (ds == "tb") {
                            if (t == "t") {
                                if (my > tn.y - tn.height) {
                                    my -= tn.height
                                }
                            } else {
                                if (t == "b") {
                                    if (my < tn.y + tn.height) {
                                        my += tn.height
                                    }
                                }
                            }
                            segs.push([p0[0], p0[1], p0[0], my, mx, my]);
                            segs.push([mx, my, p1[0], my, p1[0], p1[1]])
                        } else {
                            if (t == "l") {
                                if (mx > tn.x - tn.width) {
                                    mx -= tn.width * 0.5
                                }
                            } else {
                                if (t == "r") {
                                    if (mx < tn.x + tn.width) {
                                        mx += tn.width * 0.5
                                    }
                                }
                            }
                            segs.push([p0[0], p0[1], mx, p0[1], mx, my]);
                            segs.push([mx, my, mx, p1[1], p1[0], p1[1]])
                        }
                    } else {
                        if (s == "t" || s == "b") {
                            mx = t == "l" ? -tn.width * 0.5 : t == "r" ? tn.width * 0.5 : -tn.width * 0.5;
                            my = (p1[1] - p0[1]) / 3;
                            if ((t == "l" && p0[0] > tn.x - tn.width) || (t == "r" && p0[0] < tn.x + tn.width)) {
                                segs.push([p0[0], p0[1], p0[0], p0[1] + my, p1[0], p0[1] + my]);
                                segs.push([p1[0], p0[1] + my, p1[0] + mx, p0[1] + my, p1[0] + mx, p0[1] + my + my]);
                                segs.push([p1[0] + mx, p0[1] + my + my, p1[0] + mx, p1[1], p1[0], p1[1]])
                            } else {
                                segs.push([p0[0], p0[1], p0[0], p1[1], p1[0], p1[1]])
                            }
                        } else {
                            mx = (p1[0] - p0[0]) / 3;
                            my = t == "t" ? -tn.height : t == "b" ? tn.height : -tn.height;
                            if ((t == "t" && p0[1] > tn.y - tn.height) || (t == "b" && p0[1] < tn.y + tn.height)) {
                                segs.push([p0[0], p0[1], p0[0] + mx, p0[1], p0[0] + mx, p1[1]]);
                                segs.push([p0[0] + mx, p1[1], p0[0] + mx, p1[1] + my, p0[0] + mx + mx, p1[1] + my]);
                                segs.push([p0[0] + mx + mx, p1[1] + my, p1[0], p1[1] + my, p1[0], p1[1]])
                            } else {
                                segs.push([p0[0], p0[1], p1[0], p0[1], p1[0], p1[1]])
                            }
                        }
                    }
                }
            } else {
                p0 = ar[0];
                if (s == "t" || s == "b") {
                    for (var i = 1; i < n1; i++) {
                        p1 = ar[i];
                        if (i % 2) {
                            segs.push([p0[0], p0[1], p0[0], p1[1], p1[0], p1[1]])
                        } else {
                            segs.push([p0[0], p0[1], p1[0], p0[1], p1[0], p1[1]])
                        }
                        p0 = p1
                    }
                    p1 = ar[n1];
                    if (n1 % 2) {
                        segs.push([p0[0], p0[1], p0[0], p1[1], p1[0], p1[1]])
                    } else {
                        segs.push([p0[0], p0[1], p1[0], p0[1], p1[0], p1[1]])
                    }
                } else {
                    for (var i = 1; i < n1; i++) {
                        p1 = ar[i];
                        if (i % 2) {
                            segs.push([p0[0], p0[1], p1[0], p0[1], p1[0], p1[1]])
                        } else {
                            segs.push([p0[0], p0[1], p0[0], p1[1], p1[0], p1[1]])
                        }
                        p0 = p1
                    }
                    p1 = ar[n1];
                    if (n1 % 2) {
                        segs.push([p0[0], p0[1], p1[0], p0[1], p1[0], p1[1]])
                    } else {
                        segs.push([p0[0], p0[1], p0[0], p1[1], p1[0], p1[1]])
                    }
                }
            }
            return segs
        };
        var getStatePosition = function(n, s) {
            var x = parseFloat(s.relx);
            var y = parseFloat(s.rely);
            var w = n.width / 2;
            var h = n.height / 2;
            return [n.x + (x * w), n.y + (y * h)]
        };
        var XMLToJSON = function(xml, json, p, parent) {
            var j = {};
            var prefix = new RegExp(/(?!xmlns)^.*:/);
            var trim = new RegExp(/^\s+|\s+$/g);
            if (!json) {
                json = {}
            }
            if (p && (p == "point" || p == "anchor") && !json[p]) {
                json[p] = []
            }
            if (xml.attributes && xml.attributes.length > 0) {
                for (var i = 0; i < xml.attributes.length; i++) {
                    var a = xml.attributes.item(i);
                    var n = a.name.replace(prefix, "").replace(/\[/g, "&#91").replace(/\]/g, "&#93").toLowerCase();
                    if (p && (p == "point" || p == "anchor")) {
                        j[n] = a.value.replace(trim, "")
                    } else {
                        json[n] = a.value.replace(trim, "")
                    }
                }
                if (p && (p == "point" || p == "anchor")) {
                    json[p].push(j)
                }
            }
            if (xml.hasChildNodes() && !parent) {
                for (var i = 0; i < xml.childNodes.length; i++) {
                    var n = xml.childNodes.item(i);
                    var p;
                    if (n.nodeType == 4) {} else {
                        if (n.nodeType == 3) {} else {
                            if (n.nodeType == 1) {
                                p = n.nodeName.replace(prefix, "").toLowerCase();
                                XMLToJSON(n, json, p)
                            }
                        }
                    }
                }
            }
            return json
        };
        if (pw.tagName.toLowerCase() == "pathway") {
            var ob = XMLToJSON(pw, false, false, true);
            title = ob.name;
            subtitle = ob.organism;
            for (var i = 0; i < pw.childNodes.length; i++) {
                var el = pw.childNodes[i];
                if (el.nodeName) {
                    var nn = el.nodeName.toLowerCase();
                    switch (nn) {
                        case "comment":
                            break;
                        case "graphics":
                            break;
                        case "state":
                            var ob = XMLToJSON(el);
                            ob.nodeName = nn;
                            state[ob.graphid] = ob;
                            break;
                        case "datanode":
                        case "label":
                        case "shape":
                            var ob = XMLToJSON(el);
                            ob.nodeName = nn;
                            if (ob.centerx) {
                                ob.x = Math.round(ob.centerx * 10) / 10;
                                delete(ob.centerx)
                            }
                            if (ob.centery) {
                                ob.y = Math.round(ob.centery * 10) / 10;
                                delete(ob.centery)
                            }
                            if (ob.width) {
                                ob.width = parseInt(ob.width)
                            }
                            if (ob.height) {
                                ob.height = parseInt(ob.height)
                            }
                            if (ob.textlabel) {
                                ob.label = ob.textlabel;
                                delete(ob.textlabel)
                            }
                            if (ob.database && ob.id) {
                                ob.database += " : " + ob.id
                            }
                            if (ob.graphid) {
                                ob.id = ob.graphid
                            }
                            if (ob.fontsize) {
                                ob.labelSize = parseInt(ob.fontsize)
                            }
                            if (ob.rotation) {
                                ob.rotate = (parseFloat(ob.rotation) * 180 / Math.PI) + 180
                            }
                            if (ob.shapetype) {
                                if (ob.shapetype == "RoundedRectangle") {
                                    ob.shapetype = ob.value && ob.value == "Double" ? "roundrectd" : "roundrect"
                                }
                                if (ob.shapetype == "Arc") {
                                    ob.shapetype = "arc3"
                                }
                                if (ob.shapetype == "Mitochondria") {
                                    ob.shapetype = "image";
                                    ob.imagePath = "https://www.canvasxpress.org/assets/images/mit.png"
                                }
                                if (this.isValidShape(ob.shapetype.toLowerCase())) {
                                    ob.shape = ob.shapetype.toLowerCase()
                                } else {
                                    if (ob.shapetype == "None") {
                                        ob.shape = "rectangle"
                                    } else {
                                        wrn += ob.id + " has an unkown shape: " + ob.shapetype + "\n";
                                        ob.shape = ob.shapetype
                                    }
                                }
                                if (ob.shape == "oval" && ob.value && ob.value == "Double") {
                                    ob.shape = "ovald"
                                }
                                delete(ob.shapetype)
                            }
                            if (!ob.shape) {
                                ob.shape = "rectangle"
                            }
                            if (nn == "shape") {
                                ob.labelColor = ob.color ? this.validateColor(ob.color) : "rgb(0,0,0)"
                            } else {
                                if (ob.color) {
                                    ob.labelColor = this.validateColor(ob.color)
                                } else {
                                    ob.labelColor = "rgb(0,0,0)"
                                }
                            }
                            if (ob.fillcolor) {
                                ob.color = this.validateColor(ob.fillcolor);
                                delete(ob.fillcolor)
                            } else {
                                ob.color = "rgba(0,0,0,0)"
                            }
                            if (ob.color == "rgb(0,0,0)") {
                                ob.color = "rgba(0,0,0,0)"
                            }
                            if (ob.color == "rgb(255,255,255)") {
                                ob.color = "rgba(255,255,255,0)"
                            }
                            if (nn == "label") {
                                if (!ob.label || ob.label == "") {
                                    ob.hideLabel = true;
                                    ob.hideTooltip = htt;
                                    ob.eventless = true
                                }
                                ob.outline = "rgba(0,0,0,0)";
                                ob.color = "rgba(0,0,0,0)"
                            } else {
                                ob.outline = ob.labelColor
                            }
                            if (nn == "shape" && (!ob.label || ob.label == "")) {
                                ob.hideLabel = true;
                                ob.hideTooltip = htt;
                                ob.outline = ob.labelColor
                            }
                            if (ob.groupref) {
                                if (!groupRef.hasOwnProperty(ob.groupref)) {
                                    groupRef[ob.groupref] = []
                                }
                                groupRef[ob.groupref].push([ob.id, ob.x, ob.y, ob.width, ob.height]);
                                ob.parentNode = ob.groupref
                            }
                            order[ob.id] = cntp++;
                            nodes[ob.id] = ob;
                            sord.push(ob.id);
                            break;
                        case "interaction":
                            var ob = XMLToJSON(el);
                            ob.nodeName = nn;
                            if (ob.anchor) {
                                for (var j = 0; j < ob.anchor.length; j++) {
                                    anchors[ob.anchor[j].graphid] = true
                                }
                                delete(ob.anchor)
                            }
                            var n1 = ob.point.length - 1;
                            if (ob.point[0].graphref && ob.point[n1].graphref) {
                                ob.id1 = ob.point[0].graphref;
                                ob.id2 = ob.point[n1].graphref
                            }
                            var type = "solid";
                            if (ob.linestyle && ob.linestyle == "Broken") {
                                type = "dashed"
                            }
                            if (ob.connectortype && ob.connectortype == "Curved") {
                                type += "Bezier"
                            }
                            ob.type = type;
                            if (ob.point[0].arrowhead) {
                                if (arrowTypes[ob.point[0].arrowhead]) {
                                    ob.startArrow = arrowTypes[ob.point[0].arrowhead]
                                }
                            }
                            if (ob.point[n1].arrowhead) {
                                if (arrowTypes[ob.point[n1].arrowhead]) {
                                    ob.endArrow = arrowTypes[ob.point[n1].arrowhead]
                                }
                            }
                            if (ob.linethickness) {
                                ob.thickness = parseInt(ob.linethickness * 10) / 10;
                                delete(ob.linethickness)
                            }
                            if (ob.point[0].relx && ob.point[0].rely) {
                                ob.startX = parseFloat(ob.point[0].relx);
                                ob.startY = parseFloat(ob.point[0].rely)
                            }
                            if (ob.point[n1].relx && ob.point[n1].rely) {
                                ob.endX = parseFloat(ob.point[n1].relx);
                                ob.endY = parseFloat(ob.point[n1].rely)
                            }
                            delete(ob.id);
                            edges.push(ob);
                            break;
                        case "group":
                            var ob = XMLToJSON(el);
                            ob.nodeName = nn;
                            if (ob.groupref && ob.groupid) {
                                if (!groups.hasOwnProperty(ob.groupref)) {
                                    groups[ob.groupref] = []
                                }
                                groups[ob.groupref].push(ob.groupid);
                                groupGref[ob.graphid] = ob.groupref
                            } else {
                                groupId[ob.graphid] = ob.groupid
                            }
                            break;
                        case "infobox":
                            break;
                        case "legend":
                            break;
                        case "biopax":
                            break
                    }
                }
            }
        } else {
            alert("Ooops! Not a gpml file!")
        }
        for (var s in state) {
            var g = state[s].graphref;
            if (nodes[g]) {
                var c = getStatePosition(nodes[g], state[s]);
                var p = {
                    id: g,
                    x: c[0],
                    y: c[1],
                    width: state[s].width,
                    height: state[s].height,
                    label: state[s].textlabel == "" ? " " : state[s].textlabel,
                    type: "State",
                    color: state[s].textlabel == "" ? "rgb(255,255,255)" : this.validateColor(state[s].fillcolor),
                    outline: "rgb(0,0,0)",
                    shape: "oval",
                    show: true
                };
                createNodeFromPoint(p, s)
            }
        }
        for (var g in groupRef) {
            createNodeFromGroup(groupRef[g], g)
        }
        for (var g in groups) {
            if (groupRef.hasOwnProperty(g)) {
                for (var i = 0; i < groups[g].length; i++) {
                    var ob = nodes[groups[g][i]];
                    groupRef[g].push([ob.id, ob.x, ob.y, ob.width, ob.height])
                }
                createNodeFromGroup(groupRef[g], g)
            }
        }
        var edgs = [];
        var fail = [];
        for (var i = 0; i < edges.length; i++) {
            var ob = edges[i];
            var n1 = ob.point.length - 1;
            if (!ob.point[0].graphref && !ob.point[n1].graphref) {
                ob.exact = true
            }
            for (var j = 0; j < ob.point.length; j++) {
                var pt = ob.point[j];
                if (pt.graphref) {
                    if (!nodes.hasOwnProperty(pt.graphref)) {
                        if (j == 0) {
                            if (groupId[pt.graphref]) {
                                ob.id1 = groupId[pt.graphref]
                            } else {
                                createNodeFromPoint(pt, pt.graphref);
                                ob.hideTooltip = htt;
                                ob.exactStart = anchors[pt.graphref] ? true : false;
                                ob.id1 = pt.graphref
                            }
                        } else {
                            if (j == ob.point.length - 1) {
                                if (groupId[pt.graphref]) {
                                    ob.id2 = groupId[pt.graphref]
                                } else {
                                    createNodeFromPoint(pt, pt.graphref);
                                    ob.hideTooltip = htt;
                                    ob.exactEnd = anchors[pt.graphref] ? true : false;
                                    ob.id2 = pt.graphref
                                }
                            }
                        }
                    }
                } else {
                    if (j == 0 || j == ob.point.length - 1) {
                        var id = j == 0 ? ob.graphid + ".1" : ob.graphid + ".2";
                        var ni = j == 0 ? ob.point.length - 1 : 0;
                        createNodeFromPoint(pt, id);
                        if (j == 0) {
                            ob.id1 = id;
                            ob.exactStart = true
                        } else {
                            ob.id2 = id;
                            ob.exactEnd = true
                        }
                        ob.hideTooltip = htt;
                        if (ob.point[ni].graphref) {
                            if (!nodes.hasOwnProperty(ob.point[ni].graphref) && groupId[ob.point[ni].graphref]) {
                                if (j == 0) {
                                    ob.id2 = groupId[ob.point[ni].graphref]
                                } else {
                                    ob.id1 = groupId[ob.point[ni].graphref]
                                }
                            } else {
                                if (j == 0) {
                                    ob.id2 = ob.point[ni].graphref
                                } else {
                                    ob.id1 = ob.point[ni].graphref
                                }
                            }
                        }
                    }
                }
            }
            if (ob.connectortype) {
                if (ob.connectortype == "Elbow") {
                    ob.elbows = getElbowPoints(ob)
                } else {
                    if (ob.connectortype == "Curved") {
                        ob.elbows = getBezierPoints(ob, nodes[ob.id1], nodes[ob.id2])
                    } else {
                        if (ob.connectortype == "Segmented") {
                            ob.elbows = to2DArray(ob)
                        }
                    }
                }
            }
            if (nodes[ob.id1] && nodes[ob.id2]) {
                edgs.push(ob)
            } else {
                fail.push(ob)
            }
        }
        sord.sort(function(a, b) {
            if (nodes[a].zorder && nodes[b].zorder) {
                if (parseInt(nodes[a].zorder) - parseInt(nodes[b].zorder) == 0) {
                    return order[a] - order[b]
                } else {
                    return parseInt(nodes[a].zorder) - parseInt(nodes[b].zorder)
                }
            } else {
                return order[a] - order[b]
            }
        });
        var nods = [];
        for (var i = 0; i < sord.length; i++) {
            nods.push(nodes[sord[i]])
        }
        var res = "Number of Nodes: " + nods.length + "\n";
        res += "Number of Edges: " + edgs.length + "\n";
        if (fail.length > 0) {
            res += "Number of Failed Edges: " + fail.length + "\n";
            for (var i = 0; i < fail.length; i++) {
                res += "\t" + (i + 1) + ". " + fail[i].graphid + "\n"
            }
        }
        if (wrn != "\nWarnings:\n") {
            res += wrn
        }
        res = res.replace(/\n/g, "<br>");
        var data = {
            data: {
                nodes: nods,
                edges: edgs
            },
            config: {
                adjustBezier: false,
                graphType: "Network",
                calculateLayout: false,
                showAnimation: false,
                networkNodesOnTop: false,
                showNodeNameThreshold: 20000,
                networkFreeze: false,
                preScaleNetwork: false,
                title: title,
                networkVendor: "Wikipathways"
            },
            renderTo: target,
            events: events,
            uploadFile: (this.dataString ? false : true),
            afterRender: [
                ["flashInfoSpan", [100, 100, res, 5000]],
                ["appendNetworkDataFromURL", []]
            ]
        };
        if (config) {
            for (var p in config) {
                data.config[p] = config[p]
            }
        }
        var clbk = false;
        var rurl = this.dataURL || this.dataString;
        var cnfg = this.cloneObject(this.meta.config.user);
        if (this.graphType == "Network") {
            for (var p in this.meta.config.user) {
                data.config[p] = this.meta.config.user[p]
            }
            clbk = function(t) {
                t.meta.config.remote = {
                    data: rurl,
                    config: cnfg
                };
                t.networkFreeze = true
            }
        }
        this.updateRemoteData(data, clbk);
        this.hideMask()
    };
    this.metabaseToCX = function(xml, target, config, events) {
        var that = this;
        var sp = {
            ELLIPSE: "oval",
            arc: "circle",
            bitmap: "circle",
            line: "minus",
            text: "circle",
            ver_ellipsis: "oval",
            hor_ellipsis: "oval"
        };
        var loc = {
            3: "microsome",
            13: "epr",
            21: "lysosome",
            43: "nucleus",
            67: "golgi",
            1287: "mitochondria",
            1312: "peroxisome"
        };
        var getMembrane = function(node) {
            var getNode = function() {
                return {
                    shape: "rectangle",
                    color: "rgba(255,255,255,0)",
                    outline: "rgba(0,0,0,0)",
                    outlineWidth: 0,
                    hideLabel: true,
                    immutable: true,
                    eventless: true,
                    type: node.type,
                    zorder: node.zorder + 1,
                    width: 32,
                    height: 32
                }
            };
            var getNodeTL = function() {
                var nd = getNode();
                nd.id = node.id + "-membraneTL";
                nd.pattern = "membraneTL";
                nd.x = node.x - (node.width * 0.5);
                nd.y = node.y - (node.height * 0.5);
                nd.width = 64;
                nd.height = 64;
                return nd
            };
            var getNodeTR = function() {
                var nd = getNode();
                nd.id = node.id + "-membraneTR";
                nd.pattern = "membraneTR";
                nd.x = node.x + (node.width * 0.5) - 32;
                nd.y = node.y - (node.height * 0.5);
                nd.width = 64;
                nd.height = 64;
                return nd
            };
            var getNodeBL = function() {
                var nd = getNode();
                nd.id = node.id + "-membraneBL";
                nd.pattern = "membraneBL";
                nd.x = node.x - (node.width * 0.5);
                nd.y = node.y + (node.height * 0.5) - 32;
                nd.width = 64;
                nd.height = 64;
                return nd
            };
            var getNodeBR = function() {
                var nd = getNode();
                nd.id = node.id + "-membraneBR";
                nd.pattern = "membraneBR";
                nd.x = node.x + (node.width * 0.5) - 32;
                nd.y = node.y + (node.height * 0.5) - 32;
                nd.width = 64;
                nd.height = 64;
                return nd
            };
            var getNodeTop = function(s) {
                var nd = getNode();
                nd.id = node.id + "-membraneT";
                nd.pattern = "membraneTop";
                nd.x = node.x + (s == 0 ? 0 : s == 1 ? -16 : s == 2 ? 16 : 0);
                nd.y = node.y - (node.height * 0.5);
                nd.width = node.width - (s == 0 ? 0 : s == 1 ? 32 : s == 2 ? 32 : 64);
                return nd
            };
            var getNodeBottom = function(s) {
                var nd = getNodeTop(s);
                nd.id = node.id + "-membraneB";
                nd.pattern = "membraneBottom";
                nd.y = node.y + (node.height * 0.5) - 16;
                return nd
            };
            var getNodeRight = function(s) {
                var nd = getNode();
                nd.id = node.id + "-membraneR";
                nd.pattern = "membraneRight";
                nd.x = node.x + (node.width * 0.5) - 16;
                nd.y = node.y + (s == 0 ? 0 : s == 1 ? -16 : s == 2 ? 16 : 0);
                nd.height = node.height - (s == 0 ? 0 : s == 1 ? 32 : s == 2 ? 32 : 64);
                return nd
            };
            var getNodeLeft = function(s) {
                var nd = getNodeRight(s);
                nd.id = node.id + "-membraneL";
                nd.pattern = "membraneLeft";
                nd.x = node.x - (node.width * 0.5);
                return nd
            };
            switch (node.type) {
                case 1:
                    node.shape = "rectangle";
                    return [getNodeTop(0)];
                case 2:
                    node.shape = "rectangle";
                    return [getNodeRight(0)];
                case 3:
                    node.shape = "roundrecttr";
                    return [getNodeTop(1), getNodeRight(2), getNodeTR()];
                case 4:
                    node.shape = "rectangle";
                    return [getNodeBottom(0)];
                case 5:
                    node.shape = "rectangle";
                    return [getNodeTop(0), getNodeBottom(0)];
                case 6:
                    node.shape = "roundrectbr";
                    return [getNodeBottom(1), getNodeRight(1), getNodeBR()];
                case 7:
                    node.shape = "roundrectr";
                    return [getNodeTop(1), getNodeBottom(1), getNodeRight(3), getNodeBR(), getNodeTR()];
                case 8:
                    node.shape = "rectangle";
                    return [getNodeLeft(0)];
                case 9:
                    node.shape = "roundrecttl";
                    return [getNodeTop(2), getNodeLeft(2), getNodeTL()];
                case 10:
                    node.shape = "rectangle";
                    return [getNodeRight(0), getNodeLeft(0)];
                case 11:
                    node.shape = "roundrectt";
                    return [getNodeTop(3), getNodeRight(2), getNodeLeft(2), getNodeTR(), getNodeTL()];
                case 12:
                    node.shape = "roundrectbl";
                    return [getNodeBottom(2), getNodeLeft(1), getNodeBL()];
                case 13:
                    node.shape = "roundrectl";
                    return [getNodeTop(2), getNodeBottom(2), getNodeLeft(3), getNodeTL(), getNodeBL()];
                case 14:
                    node.shape = "roundrectb";
                    return [getNodeBottom(3), getNodeRight(1), getNodeLeft(1), getNodeBR(), getNodeBL()];
                case 15:
                    if (node.width < 64 || node.height < 64) {
                        node.shape = "rectangle";
                        delete node.gradient;
                        delete node.color1;
                        delete node.color2;
                        delete node.color3;
                        return [getNodeTop(0)]
                    }
                    node.shape = "roundrect2";
                    return [getNodeTop(3), getNodeBottom(3), getNodeRight(3), getNodeLeft(3), getNodeTR(), getNodeTL(), getNodeBR(), getNodeBL()]
            }
            return []
        };
        var getLengthToNodeBoundary = function(x0, y0, x1, y1, node) {
            var wi = node.width;
            var he = node.height;
            var cl = that.clip("line", [x0, y0, x1, y1], [x0 - (node.width / 2), y0 - (node.height / 2), node.width + (x0 - (node.width / 2)), node.height + (y0 - (node.height / 2))]);
            return that.lineLength(cl[0], cl[1], cl[2], cl[3]) + 2
        };
        var nodes = [];
        var edges = [];
        var pw = xml.childNodes[0];
        if (pw.tagName.toLowerCase() == "map") {
            var seen = {};
            var sord = [];
            var n = 0;
            var ob = this.XMLToJSON(pw, false, false, true);
            nodes.push({
                id: "__background__",
                type: "background",
                shape: "rectangle",
                color: "rgb(220,231,232)",
                outline: "rgb(29,154,195)",
                outlineWidth: 3,
                width: Number(ob.width),
                height: Number(ob.height),
                x: Number(ob.width) * 0.5,
                y: Number(ob.height) * 0.5,
                hideLabel: true,
                immutable: true,
                eventless: true,
                zorder: 1
            });
            sord.push(n++);
            for (var i = 0; i < pw.childNodes.length; i++) {
                var el = pw.childNodes[i];
                if (el.nodeName) {
                    var nn = el.nodeName.toLowerCase();
                    switch (nn) {
                        case "localizations":
                            for (var j = 0; j < el.childNodes.length; j++) {
                                var nd = el.childNodes[j];
                                if (nd.nodeName && nd.nodeName.toLowerCase() == "loc") {
                                    var js = this.XMLToJSON(nd);
                                    var shp = loc.hasOwnProperty(js.id) ? "image" : js.id == "16" ? "roundrect2" : "roundrect";
                                    var node = {
                                        id: "loc" + (j + 1),
                                        shape: shp,
                                        hideLabel: true,
                                        immutable: true,
                                        eventless: true,
                                        x: Number(js.x) + (Number(js.width) * 0.5),
                                        y: Number(js.y) + (Number(js.height) * 0.5),
                                        width: Number(js.width),
                                        height: Number(js.height),
                                        type: Number(js.type),
                                        zorder: js.appearance && js.appearance[0].zorder ? Number(js.appearance[0].zorder.replace("Integer: ", "")) : 2
                                    };
                                    if (shp != "image") {
                                        node.color = "rgba(0,0,0,0)";
                                        node.outline = js.id == "16" ? "rgba(0,0,0,0)" : "rgb(83,158,188)";
                                        node.outlineWidth = js.id != "16" ? 3 : 0;
                                        if (js.id != "16") {
                                            node.width -= 6;
                                            node.height -= 6
                                        }
                                    }
                                    if (js.appearance && js.appearance[0].rotateangle) {
                                        node.rotate = Number(js.appearance && js.appearance[0].rotateangle.split(": ")[1]);
                                        if (!node.rotate) {
                                            delete node.rotate
                                        } else {
                                            node.widthTMP = node.width;
                                            node.width = node.height;
                                            node.height = node.widthTMP;
                                            delete node.widthTMP
                                        }
                                    }
                                    if (js.id == "16") {
                                        node.gradient = "linear";
                                        node.color1 = "rgb(122,194,226)";
                                        node.color2 = "rgb(223,237,248)";
                                        node.color3 = "rgb(223,237,248)"
                                    }
                                    if (shp == "image") {
                                        if (js.id == "1287") {
                                            node.imagePath = js.type == "1" ? CanvasXpress.images.mitochondria2 : CanvasXpress.images.mitochondria
                                        } else {
                                            node.imagePath = CanvasXpress.images[loc[js.id]]
                                        }
                                    }
                                    for (var p in js) {
                                        if (p.toLowerCase() == "appearance") {
                                            for (var a in js[p][0]) {
                                                vk = js[p][0][a].split(": ");
                                                switch (vk[0]) {
                                                    case "String":
                                                        node[a] = vk[1];
                                                        break;
                                                    case "Integer":
                                                    case "Double":
                                                        node[a] = Number(vk[1]);
                                                        break;
                                                    case "Boolean":
                                                        node[a] = vk[1] == "true" ? true : false;
                                                        break
                                                }
                                            }
                                        }
                                    }
                                    nodes.push(node);
                                    sord.push(n++);
                                    if (Number(js.id) == 16) {
                                        var mem = getMembrane(node);
                                        if (mem.length) {
                                            for (var k = 0; k < mem.length; k++) {
                                                nodes.push(mem[k]);
                                                sord.push(n++)
                                            }
                                        }
                                    }
                                }
                            }
                            break;
                        case "nodes":
                            for (var j = 0; j < el.childNodes.length; j++) {
                                var nd = el.childNodes[j];
                                if (nd.nodeName && nd.nodeName.toLowerCase() == "node") {
                                    var js = this.XMLToJSON(nd);
                                    var node = {};
                                    for (var p in js) {
                                        if (p.toLowerCase() == "alt") {
                                            if (js[p][0].match(/\w/)) {
                                                node.tooltip = js[p][0].replace(/\"/g, "'");
                                                node.tooltip = js[p][0].replace(/\[/g, "&#91");
                                                node.tooltip = js[p][0].replace(/\]/g, "&#93")
                                            }
                                        }
                                        if (p.toLowerCase() == "appearance") {
                                            for (var a in js[p][0]) {
                                                vk = js[p][0][a].split(":");
                                                switch (vk[0]) {
                                                    case "String":
                                                        node[a] = vk[1].replace(/\s/g, "");
                                                        break;
                                                    case "Integer":
                                                    case "Double":
                                                        node[a] = Number(vk[1].replace(/\s/g, ""));
                                                        break;
                                                    case "Boolean":
                                                        node[a] = vk[1].replace(/\s/g, "") == "true" ? true : false;
                                                        break;
                                                    case "Rectangle":
                                                        node[a] = vk[1].replace(/\s/g, "").split(",").map(Number);
                                                        break;
                                                    case "Color":
                                                        node[a] = vk[1].replace(/\s/g, "").split(",").map(Number);
                                                        node[a][3] = Math.round(node[a][3] / 255 * 10) / 10;
                                                        node[a] = "rgba(" + node[a].join(",") + ")";
                                                        break;
                                                    case "Font":
                                                        node[a] = vk[1].replace(/\s/g, "").split(",");
                                                        break
                                                }
                                            }
                                        }
                                        node[p] = js[p] == "true" ? true : js[p] == "false" ? false : !isNaN(js[p]) ? Number(js[p]) : js[p]
                                    }
                                    node.extId = js.id;
                                    node.id = js.nodeid.toString();
                                    node.x = Number(js.x) + (Number(js.width) * 0.5);
                                    node.y = Number(js.y) + (Number(js.height) * 0.5);
                                    node.width = Number(js.width);
                                    node.height = Number(js.height);
                                    if (node.iconarea) {
                                        node.width = node.iconarea[2];
                                        node.height = node.iconarea[3];
                                        node.x = node.iconarea[0] + (node.width * 0.5);
                                        node.y = node.iconarea[1] + (node.height * 0.5);
                                        delete node.iconarea
                                    }
                                    if (js.icontype && (js.type == 0 || js.type == 16)) {
                                        if (isNaN(js.icontype)) {
                                            js.icontype = 1000
                                        }
                                        if (Number(js.icontype) < 10) {
                                            js.icontype = "0" + js.icontype
                                        }
                                        if (CanvasXpress.images.hasOwnProperty(js.icontype)) {
                                            node.zoomX = 50 / node.width;
                                            node.zoomY = 50 / node.height;
                                            node.shape = "image";
                                            node.imagePath = CanvasXpress.images[js.icontype];
                                            node.immutable = false
                                        } else {
                                            node.shape = "roundrect";
                                            node.immutable = true
                                        }
                                    } else {
                                        if (js.icontype) {
                                            switch (js.type) {
                                                case "-10":
                                                    node.width -= 5;
                                                    node.height -= 5;
                                                    node.x += 2.5;
                                                    node.y += 2.5;
                                                    node.shape = node.arcwidth > 40 ? "roundrecto" : "roundrect";
                                                    break;
                                                case "21":
                                                case "61":
                                                case "63":
                                                case "91":
                                                case "-11":
                                                case "-12":
                                                    node.width -= 4;
                                                    node.height -= 4;
                                                    node.x += 2;
                                                    node.y += 2;
                                                    node.shape = "roundrect";
                                                    break;
                                                default:
                                                    break
                                            }
                                            node.immutable = true
                                        } else {
                                            node.shape = "roundrect";
                                            node.immutable = true
                                        }
                                    }
                                    if (node.name == "") {
                                        node.hideLabel = true
                                    } else {
                                        node.name = node.name.toString().replace(/\[/g, "&#91").replace(/\]/g, "&#93").replace(/\"/g, "&quot")
                                    }
                                    if (node.textarea) {
                                        var lines = 1;
                                        if (node.font) {
                                            lines = Math.floor(node.textarea[3] / (Number(node.font[2]) + (Number(node.font[2]) > 12 ? 1 : 0)));
                                            node.labelSize = node.font[2] == 14 ? 1.1 : 1;
                                            if (node.font[0].match(/Bold Italic/i)) {
                                                node.labelStyle = "Bold Italic"
                                            } else {
                                                if (node.font[0].match(/Bold/i)) {
                                                    node.labelStyle = "Bold"
                                                } else {
                                                    if (node.font[0].match(/Italic/i)) {
                                                        node.labelStyle = "Italic"
                                                    }
                                                }
                                            }
                                        }
                                        if (lines > 1 && !node.name.toString().match(/\n/)) {
                                            var fnt = this.nodeFontStyle + " " + Math.floor(10 * node.labelSize) + "px " + this.fontName;
                                            var tst = Math.floor(node.textarea[2] / 5.5);
                                            var wrp = tst > 0 ? this.wrapText(node.name.toString(), tst) : node.name.toString();
                                            var lns = wrp.split(/\n/);
                                            var max = this.measureTextMultiple(wrp, fnt);
                                            if (lns.length > lines) {
                                                while (lns.length > lines && tst < node.name.toString().length) {
                                                    wrp = this.wrapText(node.name.toString(), tst++);
                                                    lns = wrp.split(/\n/);
                                                    max = this.measureTextMultiple(wrp, fnt)
                                                }
                                            }
                                            if (max > node.textarea[2]) {
                                                wrp = wrp.replace("(", "\n(");
                                                lns = wrp.split(/\n/);
                                                max = this.measureTextMultiple(wrp, fnt);
                                                while ((max > node.textarea[2] || lns.length * fnt > node.textarea[3] || lns.length < lines) && tst > 3) {
                                                    wrp = this.wrapText(node.name, tst--);
                                                    lns = wrp.split(/\n/);
                                                    max = this.measureTextMultiple(wrp, fnt)
                                                }
                                            }
                                            node.name = wrp
                                        } else {
                                            if (lines == 0) {
                                                node.hideLabel = true
                                            }
                                        }
                                        node.labelX = node.textarea[0] + (node.textarea[2] * 0.5);
                                        node.labelY = node.textarea[1] + (node.textarea[3] * 0.5)
                                    }
                                    if (node.textalignment != null) {
                                        if (node.textalignment == 0) {
                                            node.labelAlign = "left";
                                            node.labelX -= (node.textarea[2] * 0.45)
                                        } else {
                                            if (node.textalignment == 1) {
                                                node.labelAlign = "center"
                                            } else {
                                                if (node.textalignment == 2) {
                                                    node.labelAlign = "right";
                                                    node.labelX += (node.textarea[2] * 0.45)
                                                }
                                            }
                                        }
                                    }
                                    delete node.textarea;
                                    if (node.fontcolor) {
                                        node.labelColor = node.fontcolor;
                                        delete node.fontcolor
                                    }
                                    if (node.backgroundcolor) {
                                        node.color = node.backgroundcolor;
                                        delete node.backgroundcolor
                                    }
                                    if (node.bordercolor) {
                                        node.outline = node.bordercolor;
                                        delete node.bordercolor
                                    }
                                    if (node.rotateangle) {
                                        node.rotate = node.shape == "image" ? -node.rotateangle : 270 - node.rotateangle;
                                        if (node.shape != "image") {
                                            node.labelRotate = -node.rotateangle
                                        }
                                        delete node.rotateangle
                                    }
                                    if (node.borderwidth) {
                                        node.outlineWidth = Number(node.borderwidth) - 1;
                                        delete node.borderwidth
                                    }
                                    seen[node.id] = n;
                                    delete node.appearance;
                                    delete node.icontype;
                                    nodes.push(node);
                                    sord.push(n++);
                                    if (node.complex) {
                                        nodes.push({
                                            id: node.id + "-complex",
                                            x: node.x,
                                            y: node.y,
                                            width: 14,
                                            height: 14,
                                            shape: "star",
                                            color: "rgb(255,255,255)",
                                            hideLabel: true,
                                            zorder: node.zorder + 1,
                                            parentNode: node.id
                                        });
                                        seen[node.id + "-complex"] = n;
                                        sord.push(n++);
                                        delete node.complex
                                    }
                                    if (node.pathstart) {
                                        var rot = 0;
                                        var ptx = 0;
                                        var pty = 0;
                                        switch (node.sideofpathstarteditor) {
                                            case 0:
                                                rot = 90;
                                                pty = -(40 + node.pathstartarrowmargin);
                                                break;
                                            case 1:
                                                rot = 180;
                                                ptx = (40 + node.pathstartarrowmargin);
                                                break;
                                            case 2:
                                                rot = 270;
                                                pty = (40 + node.pathstartarrowmargin);
                                                break;
                                            case 3:
                                                rot = 0;
                                                ptx = -(40 + node.pathstartarrowmargin);
                                                break
                                        }
                                        nodes.push({
                                            id: node.id + "-pathstart",
                                            x: node.x + ptx,
                                            y: node.y + pty,
                                            width: 40,
                                            height: 40,
                                            shape: "image",
                                            imagePath: CanvasXpress.images["99"],
                                            hideLabel: true,
                                            immutable: true,
                                            rotate: rot,
                                            zorder: node.zorder + 1,
                                            parentNode: node.id
                                        });
                                        seen[node.id + "-pathstart"] = n;
                                        sord.push(n++);
                                        delete node.sideofpathstarteditor;
                                        delete node.pathstartarrowmargin;
                                        delete node.pathstart
                                    }
                                    if (node.organismspecificobject) {
                                        nodes.push({
                                            id: node.id + "-organism",
                                            x: node.x,
                                            y: node.y,
                                            width: 60,
                                            height: 60,
                                            shape: "circle",
                                            color: "rgba(0,0,0,0.1)",
                                            outline: "rgb(255,255,0)",
                                            outlineWidth: 3,
                                            hideLabel: true,
                                            zorder: node.zorder - 1,
                                            parentNode: node.id
                                        });
                                        seen[node.id + "-organism"] = n;
                                        sord.push(n++);
                                        delete node.organismspecificobject
                                    }
                                }
                            }
                            break;
                        case "edges":
                            for (var j = 0; j < el.childNodes.length; j++) {
                                var ed = el.childNodes[j];
                                if (ed.nodeName && ed.nodeName.toLowerCase() == "edge") {
                                    var js = this.XMLToJSON(ed);
                                    var edge = {};
                                    for (var p in js) {
                                        if (p.toLowerCase() == "alt") {
                                            continue
                                        }
                                        if (p.toLowerCase() == "appearance") {
                                            for (var a in js[p][0]) {
                                                if (a == "linkhighlighting") {
                                                    vk = js[p][0][a].split(":");
                                                    if (vk[1] == "Color" && vk[2]) {
                                                        vk[2] = vk[2].split(",");
                                                        vk[2].pop();
                                                        edge.highlight = "rgb(" + vk[2].join(",") + ")"
                                                    }
                                                } else {
                                                    vk = js[p][0][a].split(": ");
                                                    switch (vk[0]) {
                                                        case "String":
                                                            edge[a] = vk[1];
                                                            break;
                                                        case "Integer":
                                                        case "Double":
                                                            edge[a] = Number(vk[1]);
                                                            break;
                                                        case "Boolean":
                                                            edge[a] = vk[1] == "true" ? true : false;
                                                            break;
                                                        case "Rectangle":
                                                            edge[a] = vk[1].replace(/\s/g, "").split(",").map(Number);
                                                            break;
                                                        case "PointArray":
                                                            var cp = [];
                                                            vk[1] = vk[1].replace(/\s/g, "").split(";");
                                                            for (var k = 0; k < vk[1].length - 1; k++) {
                                                                cp.push(vk[1][k].split(",").map(Number))
                                                            }
                                                            edge[a] = cp;
                                                            break
                                                    }
                                                }
                                            }
                                        }
                                        edge[p] = js[p] == "true" ? true : js[p] == "false" ? false : !isNaN(js[p]) ? Number(js[p]) : js[p]
                                    }
                                    edge.id1 = js.src;
                                    edge.id2 = js.dst;
                                    if (edge.type) {
                                        edge.EdgeType = edge.type;
                                        delete edge.type
                                    }
                                    if (edge.directed) {
                                        edge.endArrow = "arrow";
                                        delete edge.directed
                                    }
                                    edge.color = "grey";
                                    edge.type = edge.enhances ? "dashed" : "solid";
                                    if (edge.visualization == "Round") {
                                        edge.type = "quadratic";
                                        edge.angle = edge.angle
                                    } else {
                                        if (edge.visualization == "Bezier") {
                                            if (!edge.controlpoints) {
                                                edge.type = "solid";
                                                edge.linksourcepointindex = 0;
                                                edge.linktargetpointindex = 0
                                            } else {
                                                edge.type = "bezier";
                                                edge.angle = edge.angle
                                            }
                                        }
                                    }
                                    if (edge.hasOwnProperty("effect")) {
                                        if (edge.effect >= 0) {
                                            switch (edge.effect) {
                                                case 0:
                                                    edge.color = "rgb(152,156,158)";
                                                    break;
                                                case 1:
                                                    edge.color = "rgb(0,128,0)";
                                                    break;
                                                case 2:
                                                    edge.color = "rgb(170,0,0)";
                                                    break
                                            }
                                        }
                                        if (edge.mech != null) {
                                            var dec = {};
                                            if (edge.showhexagon) {
                                                var col = edge.hexagoncustomcolor || edge.color;
                                                var idx = edge.hexagonindex || 0;
                                                var pos = edge.hexagoncoordinate || 0.5;
                                                var cll = edge.effect == 0 ? "black" : "rgb(242,216,0)";
                                                var getDec = function(lbl) {
                                                    return {
                                                        label: lbl,
                                                        labelColor: cll,
                                                        shape: "hexagon",
                                                        color: col,
                                                        index: idx,
                                                        pos: pos
                                                    }
                                                };
                                                switch (edge.mech) {
                                                    case -1:
                                                        dec = getDec("");
                                                        break;
                                                    case 0:
                                                        dec = getDec("?");
                                                        break;
                                                    case 2:
                                                        dec = getDec("CM");
                                                        break;
                                                    case 3:
                                                        dec = getDec("+P");
                                                        break;
                                                    case 4:
                                                        dec = getDec("-P");
                                                        break;
                                                    case 5:
                                                        dec = getDec("B");
                                                        break;
                                                    case 6:
                                                        dec = getDec("Cn");
                                                        break;
                                                    case 7:
                                                        dec = getDec("T");
                                                        break;
                                                    case 8:
                                                        dec = getDec("C");
                                                        break;
                                                    case 9:
                                                        dec = getDec("TR");
                                                        break;
                                                    case 10:
                                                        dec = getDec("GR");
                                                        dec.labelColor = "white";
                                                        dec.color = "rgb(0,0,170)";
                                                        break;
                                                    case 11:
                                                        dec = getDec("CR");
                                                        break;
                                                    case 12:
                                                        dec = getDec("IE");
                                                        break;
                                                    case 14:
                                                        dec = getDec("CS");
                                                        dec.labelColor = "white";
                                                        dec.color = "rgb(0,0,170)";
                                                        break;
                                                    case 15:
                                                        dec = getDec("Z");
                                                        break;
                                                    case 16:
                                                        dec = getDec("Tn");
                                                        break;
                                                    case 20:
                                                        dec = getDec("cRT");
                                                        break;
                                                    case 21:
                                                        dec = getDec("PE");
                                                        break;
                                                    case 22:
                                                        dec = getDec("TE");
                                                        break;
                                                    case 24:
                                                        dec = getDec("M");
                                                        break;
                                                    case 31:
                                                        dec = getDec("SR");
                                                        break;
                                                    case 44:
                                                        dec = getDec("RG");
                                                        break;
                                                    default:
                                                        dec = getDec("");
                                                        break
                                                }
                                                if (dec.label != "") {
                                                    edge.decoration = [dec]
                                                }
                                            }
                                            delete edge.effect;
                                            delete edge.mech;
                                            delete edge.hexagonindex;
                                            delete edge.hexagoncoordinate;
                                            delete edge.showhexagon;
                                            delete edge.hexagoncustomcolor
                                        }
                                    }
                                    if (edge.broken) {
                                        if (!edge.decoration) {
                                            edge.decoration = []
                                        }
                                        edge.decoration.push({
                                            label: "X",
                                            labelColor: "purple",
                                            fontSize: 20,
                                            shape: "square",
                                            color: "rgba(0,0,0,0)",
                                            index: (edge.brokenindex || 0),
                                            pos: (edge.brokencoordinate || 0.5)
                                        });
                                        delete edge.broken;
                                        delete edge.brokenindex;
                                        delete edge.brokencoordinate
                                    }
                                    if (edge.weakens) {
                                        if (!edge.decoration) {
                                            edge.decoration = []
                                        }
                                        edge.decoration.push({
                                            label: "-x-",
                                            labelColor: "purple",
                                            fontSize: 12,
                                            shape: "square",
                                            color: "rgba(0,0,0,0)",
                                            index: (edge.weakensindex || 0),
                                            pos: (edge.weakenscoordinate || 0.5)
                                        });
                                        delete edge.weakens;
                                        delete edge.weakensindex;
                                        delete edge.weakenscoordinate
                                    }
                                    if (edge.disease) {
                                        edge.color = "purple";
                                        edge.thickness = 2;
                                        delete edge.disease
                                    }
                                    if (edge.enhances) {
                                        edge.color = "purple";
                                        edge.thickness = 2;
                                        delete edge.enhances
                                    }
                                    delete edge.appearance;
                                    delete edge.src;
                                    delete edge.dst;
                                    if (seen.hasOwnProperty(edge.id1) && seen.hasOwnProperty(edge.id2)) {
                                        var src = nodes[seen[edge.id1]];
                                        var dst = nodes[seen[edge.id2]];
                                        var sx = src.x;
                                        var sy = src.y;
                                        var sw = src.width * 0.5;
                                        var sh = src.height * 0.5;
                                        var ex = 0;
                                        var ey = 0;
                                        var dx = dst.x;
                                        var dy = dst.y;
                                        var dw = dst.width * 0.5;
                                        var dh = dst.height * 0.5;
                                        var ss, sd, sq, ds, dd, dq, xy, cx, cy, rd, frs, lst, n1;
                                        if (edge.visualization && edge.visualization == "Right angle polyline") {
                                            ss = edge.linksourcepointindex ? Math.floor((edge.linksourcepointindex - 1) / src.linkpointcount) : -1;
                                            sd = edge.linksourcepointindex ? (edge.linksourcepointindex - (src.linkpointcount * ss)) / (src.linkpointcount + 1) : 0;
                                            if (edge.firstleg && edge.firstleg == "Vertical") {
                                                frs = edge.controlpoints ? edge.controlpoints[0][1] : false;
                                                sy = frs && frs[1] > 0 ? sy + sh : src.y > dst.y ? sy - sh : frs && frs < 0 ? sy - sh : sy + sh;
                                                if (ss == 0 || ss == 2) {
                                                    sx = (sx - sw) + (src.width * sd)
                                                } else {
                                                    if (ss == 1) {
                                                        sx = sx + sw
                                                    } else {
                                                        if (ss == 3) {
                                                            sx = sx - sw
                                                        }
                                                    }
                                                }
                                                sq = "tb"
                                            } else {
                                                frs = edge.controlpoints ? edge.controlpoints[0][0] : false;
                                                sx = frs && frs > 0 ? sx + sw : src.x > dst.x ? sx - sw : frs && frs < 0 ? sx - sw : sx + sw;
                                                if (ss == 1 || ss == 3) {
                                                    sy = (sy - sh) + (src.height * sd)
                                                } else {
                                                    if (ss == 0) {
                                                        sy = sy - sh
                                                    } else {
                                                        if (ss == 2) {
                                                            sy = sy + sh
                                                        }
                                                    }
                                                }
                                                sq = "lr"
                                            }
                                            ds = edge.linktargetpointindex ? Math.floor((edge.linktargetpointindex - 1) / dst.linkpointcount) : -1;
                                            dd = edge.linktargetpointindex ? (edge.linktargetpointindex - (dst.linkpointcount * ds)) / (dst.linkpointcount + 1) : 0;
                                            if (!edge.controlpoints) {
                                                if (edge.firstleg && edge.firstleg == "Vertical") {
                                                    dx = src.x > dst.x ? dx + dw : dx - dw;
                                                    if (ds == 1 || ds == 3) {
                                                        dy = (dy - dh) + (dst.height * dd)
                                                    }
                                                } else {
                                                    dy = src.y > dst.y ? dy + dh : dy - dh;
                                                    if (ds == 0 || ds == 2) {
                                                        dx = (dx - dw) + (dst.width * dd)
                                                    }
                                                }
                                            } else {
                                                dq = edge.controlpoints.length % 2 ? sq : sq == "tb" ? "lr" : "tb";
                                                n1 = edge.controlpoints.length - 1;
                                                lst = edge.controlpoints[n1];
                                                if (edge.linktargetpointindex) {
                                                    if (ds == 1 || ds == 3) {
                                                        if (src.x + lst[0] > dst.x) {
                                                            dx += dw
                                                        } else {
                                                            dx -= dw
                                                        }
                                                        dy = (dy - dh) + (dst.height * dd)
                                                    } else {
                                                        if (ds == 0 || ds == 2) {
                                                            dx = (dx - dw) + (dst.width * dd);
                                                            if (src.y + lst[1] > dst.y) {
                                                                dy += dh
                                                            } else {
                                                                dy -= dh
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (edge.controlpoints.length % 2) {
                                                        if (sq == dq && sq == "lr") {
                                                            if (src.x + lst[0] > dst.x) {
                                                                dx += dw
                                                            } else {
                                                                dx -= dw
                                                            }
                                                        }
                                                    } else {
                                                        dx = src.x + lst[0] > dst.x ? dx + dw : dx - dw
                                                    }
                                                    if (edge.controlpoints.length % 2) {
                                                        if (sq != dq || sq != "lr") {
                                                            dy = src.y + lst[1] > dst.y ? dy + dh : dy - dh
                                                        }
                                                    } else {
                                                        if (src.y + lst[1] > dst.y) {
                                                            dy = dy + dh
                                                        }
                                                    }
                                                }
                                            }
                                            if (edge.controlpoints) {
                                                edge.elbows = [
                                                    [sx, sy]
                                                ];
                                                cx = sx;
                                                cy = sy;
                                                if (edge.firstleg && edge.firstleg == "Vertical") {
                                                    for (var k = 0; k < edge.controlpoints.length; k++) {
                                                        if (k % 2) {
                                                            cx = sx + edge.controlpoints[k][0]
                                                        } else {
                                                            cy = sy + edge.controlpoints[k][1]
                                                        }
                                                        edge.elbows.push([cx, cy])
                                                    }
                                                    if (edge.controlpoints.length % 2) {
                                                        edge.elbows.push([dx, cy])
                                                    } else {
                                                        edge.elbows.push([cx, dy])
                                                    }
                                                } else {
                                                    for (var k = 0; k < edge.controlpoints.length; k++) {
                                                        if (k % 2) {
                                                            cy = sy + edge.controlpoints[k][1]
                                                        } else {
                                                            cx = sx + edge.controlpoints[k][0]
                                                        }
                                                        edge.elbows.push([cx, cy])
                                                    }
                                                    if (edge.controlpoints.length % 2) {
                                                        edge.elbows.push([cx, dy])
                                                    } else {
                                                        edge.elbows.push([dx, cy])
                                                    }
                                                }
                                                edge.elbows.push([dx, dy])
                                            } else {
                                                if (edge.firstleg && edge.firstleg == "Vertical") {
                                                    edge.elbows = [
                                                        [sx, sy],
                                                        [sx, dy],
                                                        [dx, dy]
                                                    ]
                                                } else {
                                                    edge.elbows = [
                                                        [sx, sy],
                                                        [dx, sy],
                                                        [dx, dy]
                                                    ]
                                                }
                                            }
                                        } else {
                                            if (edge.controlpoints && edge.linksourcepointindex != null && edge.linktargetpointindex != null && edge.id1 != edge.id2) {
                                                if (edge.linksourcepointindex || edge.controlpoints) {
                                                    frs = edge.controlpoints ? edge.controlpoints[0] : [0, 0];
                                                    if (edge.linksourcepointindex == 0) {
                                                        ds = getLengthToNodeBoundary(sx, sy, sx + frs[0], sy + frs[1], src);
                                                        xy = this.getCoordinateAtDistance(sx, sy, sx + frs[0], sy + frs[1], ds);
                                                        rd = this.getRadians(sx, sy, sx + frs[0], sy + frs[1]);
                                                        sx = xy[0];
                                                        sy = xy[1];
                                                        ex = (-ds * -Math.cos(rd));
                                                        ey = ds * Math.sin(rd)
                                                    } else {
                                                        ss = Math.floor((edge.linksourcepointindex - 1) / src.linkpointcount);
                                                        sd = (edge.linksourcepointindex - (src.linkpointcount * ss)) / (src.linkpointcount + 1);
                                                        switch (ss) {
                                                            case 0:
                                                                ex = (src.width * sd);
                                                                ey = 0;
                                                                sx = ex + sx - sw;
                                                                sy = sy - sh;
                                                                break;
                                                            case 1:
                                                                ex = 0;
                                                                ey = (src.height * sd);
                                                                sx = sx + sw;
                                                                sy = ey + sy - sh;
                                                                break;
                                                            case 2:
                                                                ex = (src.width * sd);
                                                                ey = 0;
                                                                sx = ex + sx - sw;
                                                                sy = sy + sh;
                                                                break;
                                                            case 3:
                                                                ex = 0;
                                                                ey = (src.height * sd);
                                                                sx = sx - sw;
                                                                sy = ey + sy - sh;
                                                                break
                                                        }
                                                    }
                                                }
                                                if (edge.linktargetpointindex || edge.controlpoints) {
                                                    lst = edge.controlpoints ? this.cloneObject(edge.controlpoints[edge.controlpoints.length - 1]) : [0, 0];
                                                    if (edge.linktargetpointindex == 0) {
                                                        if (edge.controlpoints) {
                                                            lst[0] = dx - (sx + lst[0]);
                                                            lst[1] = dy - (sy + lst[1])
                                                        }
                                                        ds = getLengthToNodeBoundary(dx, dy, dx + lst[0], dy + lst[1], dst);
                                                        xy = this.getCoordinateAtDistance(dx, dy, dx + lst[0], dy + lst[1], -ds);
                                                        rd = this.getRadians(dx, dy, dx + lst[0], dy + lst[1]);
                                                        dx = xy[0];
                                                        dy = xy[1]
                                                    } else {
                                                        ds = Math.floor((edge.linktargetpointindex - 1) / dst.linkpointcount);
                                                        dd = (edge.linktargetpointindex - (dst.linkpointcount * ds)) / (dst.linkpointcount + 1);
                                                        switch (ds) {
                                                            case 0:
                                                                dx = (dst.width * dd) + dx - dw;
                                                                dy = dy - dh;
                                                                break;
                                                            case 1:
                                                                dx = dx + dw;
                                                                dy = (dst.height * dd) + dy - dh;
                                                                break;
                                                            case 2:
                                                                dx = (dst.width * dd) + dx - dw;
                                                                dy = dy + dh;
                                                                break;
                                                            case 3:
                                                                dx = dx - dw;
                                                                dy = (dst.height * dd) + dy - dh;
                                                                break
                                                        }
                                                    }
                                                }
                                                edge.elbows = [];
                                                for (var k = 0; k < edge.controlpoints.length; k++) {
                                                    edge.elbows.push([sx + edge.controlpoints[k][0] + 5, sy + edge.controlpoints[k][1]])
                                                }
                                                edge.elbows.unshift([sx, sy]);
                                                edge.elbows.push([dx, dy])
                                            } else {
                                                if (edge.id1 == edge.id2) {
                                                    ss = edge.linksourcepointindex ? Math.floor((edge.linksourcepointindex - 1) / src.linkpointcount) : -1;
                                                    ds = edge.linktargetpointindex ? Math.floor((edge.linktargetpointindex - 1) / dst.linkpointcount) : -1;
                                                    if (ss == ds) {
                                                        edge.self = {
                                                            dir: edge.angle > 0,
                                                            pos: (ss == 0 ? "top" : ss == 1 ? "right" : ss = 2 ? "bottom" : "left"),
                                                            size: 20,
                                                            end: "arrow"
                                                        }
                                                    } else {
                                                        if (ss > ds || (ss == 0 && ds == 3)) {
                                                            edge.self = {
                                                                dir: edge.angle > 0,
                                                                pos: (ss == 0 ? "topLeft" : ss = 1 ? "topRight" : ss == 2 ? "bottomRight" : "bottomLeft"),
                                                                size: 20,
                                                                end: "arrow"
                                                            }
                                                        } else {
                                                            if (ds > ss || (ds == 0 && ss == 3)) {
                                                                edge.self = {
                                                                    dir: edge.angle > 0,
                                                                    pos: (ss == 0 ? "topRight" : ss == 1 ? "bottomRight" : ss == 2 ? "bottomLeft" : "topLeft"),
                                                                    size: 20,
                                                                    end: "arrow"
                                                                }
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (edge.linksourcepointindex) {
                                                        ss = edge.linksourcepointindex ? Math.floor((edge.linksourcepointindex - 1) / src.linkpointcount) : -1;
                                                        sd = edge.linksourcepointindex ? (edge.linksourcepointindex - (src.linkpointcount * ss)) / (src.linkpointcount + 1) : 0;
                                                        if (ss == 0 || ss == 2) {
                                                            sx = (sx - sw) + (src.width * sd)
                                                        } else {
                                                            sy = (sy - sh) + (src.height * sd)
                                                        }
                                                    }
                                                    if (edge.linktargetpointindex) {
                                                        ds = edge.linktargetpointindex ? Math.floor((edge.linktargetpointindex - 1) / dst.linkpointcount) : -1;
                                                        dd = edge.linktargetpointindex ? (edge.linktargetpointindex - (dst.linkpointcount * ds)) / (dst.linkpointcount + 1) : 0;
                                                        if (ds == 0 || ds == 2) {
                                                            dx = (dx - dw) + (dst.width * dd)
                                                        } else {
                                                            dy = (dy - dh) + (dst.height * dd)
                                                        }
                                                    }
                                                    if (edge.linksourcepointindex || edge.linktargetpointindex) {
                                                        if (edge.linksourcepointindex) {
                                                            switch (ss) {
                                                                case 0:
                                                                    sy -= sh;
                                                                    break;
                                                                case 1:
                                                                    sx += sw;
                                                                    break;
                                                                case 2:
                                                                    sy += sh;
                                                                    break;
                                                                case 3:
                                                                    sx -= sw;
                                                                    break
                                                            }
                                                            if (!edge.linktargetpointindex) {
                                                                ds = getLengthToNodeBoundary(dx, dy, sx, sy, dst);
                                                                xy = this.getCoordinateAtDistance(dx, dy, sx, sy, ds);
                                                                dx = xy[0];
                                                                dy = xy[1]
                                                            } else {
                                                                switch (ds) {
                                                                    case 0:
                                                                        dy -= dh;
                                                                        break;
                                                                    case 1:
                                                                        dx += dw;
                                                                        break;
                                                                    case 2:
                                                                        dy += dh;
                                                                        break;
                                                                    case 3:
                                                                        dx -= dw;
                                                                        break
                                                                }
                                                            }
                                                        } else {
                                                            switch (ds) {
                                                                case 0:
                                                                    dy -= dh;
                                                                    break;
                                                                case 1:
                                                                    dx += dw;
                                                                    break;
                                                                case 2:
                                                                    dy += dh;
                                                                    break;
                                                                case 3:
                                                                    dx -= dw;
                                                                    break
                                                            }
                                                            ds = getLengthToNodeBoundary(sx, sy, dx, dy, src);
                                                            xy = this.getCoordinateAtDistance(sx, sy, dx, dy, ds);
                                                            sx = xy[0];
                                                            sy = xy[1]
                                                        }
                                                        edge.elbows = [
                                                            [sx, sy],
                                                            [dx, dy]
                                                        ]
                                                    }
                                                }
                                            }
                                        }
                                        delete edge.linksourcepointindex;
                                        delete edge.linktargetpointindex;
                                        delete edge.controlpoints;
                                        delete edge.visualization;
                                        delete edge.firstleg;
                                        edges.push(edge)
                                    }
                                }
                            }
                            break
                    }
                }
            }
            sord.sort(function(a, b) {
                if (nodes[a].zorder - nodes[b].zorder == 0) {
                    return a - b
                } else {
                    return nodes[a].zorder - nodes[b].zorder
                }
            });
            var tmp = [];
            for (var i = 0; i < sord.length; i++) {
                tmp.push(nodes[sord[i]])
            }
            nodes = tmp
        } else {
            alert("Ooops! Not a Metabase xgmml file!")
        }
        var res = "Number of Nodes: " + nodes.length + "\nNumber of Edges: " + edges.length + "\n";
        res = res.replace(/\n/g, "<br>");
        var data = {
            data: {
                nodes: nodes,
                edges: edges
            },
            config: {
                adjustBezier: false,
                graphType: "Network",
                calculateLayout: false,
                showAnimation: false,
                networkNodesOnTop: false,
                showNodeNameThreshold: 20000,
                networkFreeze: false,
                preScaleNetwork: false,
                moveParentsWithChildren: true,
                ignoreEventlessOrder: true,
                networkVendor: "Metabase"
            },
            renderTo: target,
            events: events,
            uploadFile: (this.dataString ? false : true),
            afterRender: [
                ["flashInfoSpan", [100, 100, res, 5000]],
                ["appendNetworkDataFromURL", []]
            ]
        };
        if (config) {
            for (var p in config) {
                data.config[p] = config[p]
            }
        }
        var clbk = false;
        var rurl = this.dataURL || this.dataString;
        var cnfg = this.cloneObject(this.meta.config.user);
        if (this.graphType == "Network") {
            for (var p in this.meta.config.user) {
                data.config[p] = this.meta.config.user[p]
            }
            clbk = function(t) {
                t.meta.config.remote = {
                    data: rurl,
                    config: cnfg
                };
                t.networkFreeze = true
            }
        }
        this.updateRemoteData(data, clbk);
        this.hideMask()
    };
    this.gexfToCX = function(xml, target, config, events) {
        var nodes = [];
        var edges = [];
        var cl = true;
        var gexf = xml.childNodes[0];
        if (gexf.tagName.toLowerCase() == "gexf") {
            for (var i = 0; i < gexf.childNodes.length; i++) {
                var el = gexf.childNodes[i];
                if (el.nodeName && el.nodeName.toLowerCase() == "graph") {
                    for (var j = 0; j < el.childNodes.length; j++) {
                        var nd = el.childNodes[j];
                        if (nd.nodeName && nd.nodeName.toLowerCase() == "nodes") {
                            for (var k = 0; k < nd.childNodes.length; k++) {
                                var n = nd.childNodes[k];
                                if (n.nodeName && n.nodeName.toLowerCase() == "node") {
                                    var js = this.XMLToJSON(n);
                                    var node = {};
                                    if (js.id) {
                                        for (var p in js) {
                                            switch (p.toLowerCase()) {
                                                case "id":
                                                    node.id = js.id;
                                                    break;
                                                case "label":
                                                    node.name = js.label;
                                                    break;
                                                case "color":
                                                    node.color = "rgb(" + js[p][0].r + "," + js[p][0].g + "," + js[p][0].b + ")";
                                                    break;
                                                case "position":
                                                    node.x = Number(js[p][0].x);
                                                    node.y = Number(js[p][0].y);
                                                    node.z = Number(js[p][0].z);
                                                    cl = false;
                                                    break;
                                                case "size":
                                                    node.width = Number(js[p][0].value);
                                                    node.height = Number(js[p][0].value);
                                                    break
                                            }
                                        }
                                        nodes.push(node)
                                    }
                                }
                            }
                        } else {
                            if (nd.nodeName && nd.nodeName.toLowerCase() == "edges") {
                                for (var k = 0; k < nd.childNodes.length; k++) {
                                    var e = nd.childNodes[k];
                                    if (e.nodeName && e.nodeName.toLowerCase() == "edge") {
                                        js = this.XMLToJSON(e);
                                        var edge = {};
                                        if (js.source && js.target) {
                                            edge.id1 = js.source;
                                            edge.id2 = js.target;
                                            edges.push(edge)
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } else {
            alert("Ooops! Not a Gephi gexf file!")
        }
        var res = "Number of Nodes: " + nodes.length + "\nNumber of Edges: " + edges.length + "\n";
        res = res.replace(/\n/g, "<br>");
        var data = {
            data: {
                nodes: nodes,
                edges: edges
            },
            config: {
                graphType: "Network",
                calculateLayout: cl,
                showAnimation: false,
                networkNodesOnTop: true,
                showNodeNameThreshold: 20000,
                networkFreeze: false,
                preScaleNetwork: false,
                moveParentsWithChildren: true,
                ignoreEventlessOrder: true,
                networkVendor: "Gephi"
            },
            renderTo: target,
            events: events,
            uploadFile: (this.dataString ? false : true),
            afterRender: [
                ["flashInfoSpan", [100, 100, res, 5000]],
                ["appendNetworkDataFromURL", []]
            ]
        };
        if (config) {
            for (var p in config) {
                data.config[p] = config[p]
            }
        }
        var clbk = false;
        var rurl = this.dataURL || this.dataString;
        var cnfg = this.cloneObject(this.meta.config.user);
        if (this.graphType == "Network") {
            for (var p in this.meta.config.user) {
                data.config[p] = this.meta.config.user[p]
            }
            clbk = function(t) {
                t.meta.config.remote = {
                    data: rurl,
                    config: cnfg
                };
                t.networkFreeze = true
            }
        }
        this.updateRemoteData(data, clbk);
        this.hideMask()
    };
    this.parseGML = function(gml) {
        var forIn = function(object, callback) {
            Object.keys(object).forEach(function(key) {
                callback(key, object[key])
            })
        };
        var json = ("{\n" + gml + "\n}").replace(/^(\s*)(\w+)\s*\[/gm, '$1"$2": {').replace(/^(\s*)\]/gm, "$1},").replace(/^(\s*)(\w+)\s+(.+)$/gm, '$1"$2": $3,').replace(/,(\s*)\}/g, "$1}");
        var graph = {};
        var nodes = [];
        var edges = [];
        var i = 0;
        json = json.replace(/^(\s*)"node"/gm, function(all, indent) {
            return (indent + '"node[' + (i++) + ']"')
        });
        i = 0;
        json = json.replace(/^(\s*)"edge"/gm, function(all, indent) {
            return (indent + '"edge[' + (i++) + ']"')
        });
        try {
            json = this.parseJSON(json)
        } catch (err) {
            throw new SyntaxError("bad format")
        }
        if (!this.isObject(json.graph)) {
            throw new SyntaxError("no graph tag")
        }
        forIn(json.graph, function(key, value) {
            var matches = key.match(/^(\w+)\[(\d+)\]$/);
            var name;
            var i;
            if (matches) {
                name = matches[1];
                i = parseInt(matches[2], 10);
                if (name === "node") {
                    nodes[i] = value
                } else {
                    if (name === "edge") {
                        edges[i] = value;
                        edges[i].id1 = edges[i].source;
                        edges[i].id2 = edges[i].target;
                        delete(edges[i].source);
                        delete(edges[i].target)
                    } else {
                        graph[key] = value
                    }
                }
            } else {
                graph[key] = value
            }
        });
        graph.nodes = nodes;
        graph.edges = edges;
        return {
            data: graph,
            config: {
                graphType: "Network"
            }
        }
    };
    this.arrayToCanvasXpress = function(arr) {
        var unique = function(a) {
            return a.filter(function(x, i) {
                return a.indexOf(x) === i
            })
        };
        var data = {
            y: {
                vars: [],
                smps: [],
                data: []
            }
        };
        var g = "Scatter2D";
        var cols = arr[0].filter(Number);
        if (cols.length == 0) {
            cols = arr.shift()
        } else {
            cols = [];
            for (var i = 0; i < arr[0].length; i++) {
                cols.push("C" + (i + 1))
            }
        }
        var rows = [];
        for (var i = 0; i < arr.length; i++) {
            rows.push(arr[i][0].toString())
        }
        var urow = unique(rows);
        if (urow.length == rows.length) {
            for (var i = 0; i < arr.length; i++) {
                arr[i].shift(arr[i][0])
            }
        } else {
            rows = [];
            for (var i = 0; i < arr.length; i++) {
                rows.push("R" + (i + 1))
            }
        }
        if (cols.length > arr[0].length) {
            cols.shift();
            if (!cols.length == arr[0].length) {
                return false
            }
        }
        if (arr[0].length != arr[arr.length - 1].length) {
            arr.pop();
            rows.pop();
            if (arr[0].length != arr[arr.length - 1].length) {
                return false
            }
        }
        var types = [];
        var total = 0;
        for (var i = 0; i < cols.length; i++) {
            types[i] = false;
            for (var j = 0; j < rows.length; j++) {
                if (isNaN(arr[j][i])) {
                    types[i] = true;
                    break
                }
            }
            if (!types[i]) {
                for (var j = 0; j < rows.length; j++) {
                    arr[j][i] = arr[j][i] == null || arr[j][i] == undefined ? null : !isNaN(parseFloat(arr[j][i])) && isFinite(arr[j][i]) ? Number(arr[j][i]) : null
                }
                total++
            } else {
                data.z = {}
            }
        }
        var trans = false;
        if (total > 1) {
            var n = Math.ceil(total * 0.6);
            var q = 0;
            for (var i = types.length - 1; i >= 0; i--) {
                if (!types[i]) {
                    q++
                } else {
                    if (q < n) {
                        trans = true
                    }
                }
            }
        }
        for (var i = 0; i < rows.length; i++) {
            data.y.data[i] = [];
            data.y.vars.push(rows[i])
        }
        for (var i = 0; i < cols.length; i++) {
            if (types[i] || (this.metaData && this.metaData.hasOwnProperty(cols[i]))) {
                data.z[cols[i]] = [];
                for (var j = 0; j < rows.length; j++) {
                    data.z[cols[i]].push(arr[j][i])
                }
            } else {
                data.y.smps.push(cols[i]);
                for (var j = 0; j < rows.length; j++) {
                    data.y.data[j].push(arr[j][i])
                }
            }
        }
        if (data.y.smps.length == 0) {
            var n = data.y.data.length;
            data.y.data = [
                []
            ];
            for (var i = 0; i < n; i++) {
                data.y.data[0].push(1)
            }
            data.y.smps = data.y.vars;
            data.y.vars = ["counts"];
            data.x = data.z;
            delete(data.z);
            g = "Bar"
        } else {
            if (data.y.smps.length == 1 || trans) {
                var trp = function(mat) {
                    return mat[0].map(function(_, c) {
                        return mat.map(function(r) {
                            return r[c]
                        })
                    })
                };
                data.y.data = trp(data.y.data);
                data.y.vars = data.y.smps;
                data.y.smps = rows;
                data.x = data.z;
                delete(data.z);
                g = "Bar"
            }
        }
        return {
            data: data,
            config: {
                graphType: g
            }
        }
    };
    this.getRDatasets = function() {
        var setRDataSets = function(t) {
            return function(r) {
                t.Rdatasets = t.parseJSON(r)
            }
        }(this);
        var url = this.RdatasetsURL + "datasets.json";
        this.ajaxRequest(url, false, setRDataSets)
    };
    this.getRLibraryDataSets = function(s) {
        this.getDataSetListFromURL(this.RdatasetsURL + "json/" + s + "/datasets.json")
    };
    this.appendNetworkDataFromURL = function() {
        var that = this;
        var url = this.appendNetworkData.length > 0 ? this.appendNetworkData.shift() : false;
        var appendDelimitedData = function(r) {
            var tc = 0;
            var tt = 0;
            if (r.match(/,/g)) {
                tc = r.match(/,/g).length
            }
            if (r.match(/\t/g)) {
                tt = r.match(/\t/g).length
            }
            var dl = url.match(/\.csv$/) && tc > tt ? "," : "\t";
            var data = that.delimitedToArray(r, dl, false, true);
            if (data && !that.isArray(data)) {
                var fail = "";
                if (data.fail > 0) {
                    fail = data.fail + " records couldn't be mapped to network data"
                }
                that.flashInfoSpan(100, 150, data.rows + " " + data.type + " records added to network data\n" + fail, 5000);
                var cn = that.meta.config.user;
                var at = ["colorNodeBy", "shapeNodeBy", "sizeNodeBy", "patternNodeBy", "colorEdgeBy", "SizeEdgeBy", "decorations"];
                for (var i = 0; i < at.length; i++) {
                    var a = at[i];
                    if (cn.hasOwnProperty(a)) {
                        that[a] = cn[a]
                    }
                }
                if (data.type == "node") {
                    that.appendNodeData(data.data)
                } else {
                    that.appendEdgeData(data.data)
                }
                if (that.appendNetworkData.length > 0) {
                    that.appendNetworkDataFromURL()
                } else {
                    that.draw({
                        func: "appendNetworkDataFromURL"
                    });
                    that.hideMask()
                }
            }
        };
        var appendJSONData = function(r) {
            if (r.type == "node") {
                that.appendNodeData(r.data)
            } else {
                that.appendEdgeData(r.data)
            }
            if (that.appendNetworkData.length > 0) {
                that.appendNetworkDataFromURL()
            } else {
                that.draw({
                    func: "appendNetworkDataFromURL"
                });
                that.hideMask()
            }
        };
        var appendDataURL = function(t) {
            return function(r) {
                if (url.match(/\.txt$/) || url.match(/\.csv$/) || url.match(/\.tsv$/) || url.match(/\.tab$/)) {
                    appendDelimitedData(r)
                } else {
                    t.hideMask();
                    alert("Oooops! Not a CanvasXpress Network delimited file")
                }
            }
        }(this);
        if (url) {
            if (typeof(url) == "string") {
                var obj = this.isValidString(url);
                switch (obj.type) {
                    case "URL":
                        this.ajaxRequest(url, false, appendDataURL);
                        break;
                    case "XML":
                        alert("XML not supported!");
                        break;
                    case "JSON":
                        appendJSONData(obj.data);
                    case "DELIM":
                        appendDelimitedData(url);
                        break
                }
            } else {
                appendJSONData(url)
            }
        }
    };
    this.getDataFromURLOrString = function(target, config, events, info, callback) {
        if (this.dataURL) {
            var that = this;
            var getJSON = function(s) {
                try {
                    return that.parseJSON(s)
                } catch (e) {
                    return false
                }
            };
            var format = this.dataURL.match(/\.png$/) ? "arraybuffer" : false;
            var setData = function(t) {
                return function(r) {
                    var data = getJSON(r);
                    t.remoteService = t.dataURL;
                    t.remoteServiceType = "file";
                    if (t.isObject(data)) {
                        if (Array.isArray(data)) {
                            return t.setDataSetsFromURL(r)
                        }
                    } else {
                        if (t.dataURL.match(/\.png$/)) {
                            data = t.parseDataFromPNG(r)
                        } else {
                            if (t.dataURL.match(/\.svg$/)) {
                                data = t.SVGtoCX(r)
                            } else {
                                if (t.dataURL.match(/\.txt$/) || t.dataURL.match(/\.csv$/) || t.dataURL.match(/\.tsv$/) || t.dataURL.match(/\.tab$/)) {
                                    data = t.delimitedToArray(r, false, true)
                                } else {
                                    if (t.dataURL.match(/.gexf/)) {
                                        var xml = t.parseXML(r);
                                        return t.gexfToCX(xml, trg)
                                    } else {
                                        if (t.dataURL.match(/\ml$/)) {
                                            var xml = t.parseXML(r);
                                            var ts1 = xml.childNodes[0];
                                            var ts2 = xml.childNodes[2];
                                            var trg = target ? target : t.newId("-cX-data-url-");
                                            if (ts1.tagName && ts1.tagName.toLowerCase() == "map") {
                                                return t.metabaseToCX(xml, trg)
                                            } else {
                                                if (ts1.tagName && ts1.tagName.toLowerCase() == "graph") {
                                                    return t.cytoscapeToCX(xml, trg)
                                                } else {
                                                    if (ts1.tagName && ts1.tagName.toLowerCase() == "pathway") {
                                                        return t.wikipathwayToCX(xml, trg)
                                                    } else {
                                                        if (ts2 && ts2.tagName && ts2.tagName.toLowerCase() == "pathway") {
                                                            return t.keggToCX(xml, trg)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    data.records = 0;
                    data.renderTo = target ? target : data.renderTo ? data.renderTo : t.newId("-cX-data-url-");
                    data.config = config ? config : data.config ? data.config : {
                        graphType: "Scatter2D"
                    };
                    if (data.config.graphType == "Network") {
                        data.config.appendNetworkData = t.appendNetworkData
                    }
                    data.events = events ? events : data.events ? data.events : false;
                    data.info = info ? info.toString().replace(/'/g, "'").replace(/"/g, "'") : data.info ? data.info.toString().replace(/'/g, "'").replace(/"/g, "'") : false;
                    data.noValidate = true;
                    if (!data.afterRender) {
                        data.afterRender = []
                    }
                    if (data.config.graphType == "Network") {
                        data.afterRender.push(["appendNetworkDataFromURL", []])
                    }
                    var rurl = t.dataURL;
                    var cnfg = t.cloneObject(t.meta.config.user);
                    t.updateRemoteData(data, function(that) {
                        that.meta.config.remote = {
                            data: rurl,
                            config: cnfg
                        };
                        that.reInitStack(data);
                        if (callback) {
                            callback()
                        }
                    })
                }
            }(this);
            this.ajaxRequest(this.dataURL, false, setData, format)
        } else {
            if (this.topoJSONURL) {
                var setData = function(t) {
                    return function(r) {
                        var json = t.parseJSON(r);
                        var rd = t.isExample ? false : t.cloneObject(t.data);
                        var rc = t.cloneObject(t.meta.config.user);
                        var data = {
                            renderTo: t.target,
                            data: t.isExample ? false : t.data,
                            config: t.meta.config.user
                        };
                        if (!window[t.mapId]) {
                            data.config.remoteTransitionEffect = "none";
                            window[t.mapId] = json;
                            t.remoteServiceType = "file";
                            t.updateRemoteData(data, function(that) {
                                that.meta.config.remote = {
                                    data: rd,
                                    config: rc
                                };
                                that.reInitStack(data);
                                if (callback) {
                                    callback()
                                }
                            })
                        }
                    }
                }(this);
                this.ajaxRequest(this.topoJSONURL, false, setData)
            } else {
                if (this.dataString) {
                    this.loadXML(this.dataString, target, config, events)
                }
            }
        }
    };
    this.getDataSetListFromURL = function(u) {
        this.remoteService = u;
        this.ajaxRequest(u, false, this.setDataSetsFromURL)
    };
    this.setDataSetsFromURL = function(t) {
        return function(r) {
            var setDataSetsFromURLRemote = function(t) {
                return function(r) {
                    var obj = n.parseJSON(r);
                    n.updateRemoteData({
                        data: obj,
                        ids: n.remoteIds,
                        records: n.remoteIds.length
                    })
                }
            }(n);
            var getParentId = function() {
                var par = t.$("container-" + t.target).parentNode;
                while (par.id.match("canvasXpressRemoteWindow")) {
                    par = par.parentNode
                }
                if (!par.id) {
                    par.id = t.newId("-cX-data-sets-url-container-")
                }
                return par.id
            };
            var obj = t.parseJSON(r);
            var url = obj[0][1];
            var ids = [];
            for (var i = 0; i < obj.length; i++) {
                ids.push(obj[i][0])
            }
            var pid = getParentId();
            var par = t.$("container-" + t.target).parentNode;
            var cid = t.newId("-cX-data-sets-");
            var cnv = t.$cX("canvas", {
                id: cid,
                width: t.originalWidth,
                height: t.originalHeight
            });
            t.castCanvasAttributes(cnv);
            par.appendChild(cnv);
            var n = new CanvasXpress(cid, false, {
                remoteService: t.remoteService
            });
            t.remoteIds = ids;
            t.destroy(t.target);
            n.remoteData = obj;
            n.remoteParentId = pid;
            n.remoteIds = ids;
            n.remoteServiceType = "file";
            n.ajaxRequest(url, false, setDataSetsFromURLRemote)
        }
    }(this);
    this.initStack = function(data, config, events, info, afterRender) {
        if (!CanvasXpress.stack) {
            CanvasXpress.stack = {}
        }
        var cnv = this.$(this.target);
        if (cnv) {
            CanvasXpress.stack[this.target] = {
                version: CanvasXpress.factory.version,
                renderTo: this.target,
                data: (data ? this.cloneObject(data) : false),
                config: config || false,
                events: events ? events : false,
                info: info ? info.toString().replace(/'/g, "'").replace(/"/g, "'") : false,
                afterRenderInit: afterRender ? afterRender : false,
                afterRender: [
                    ["setDimensions", [cnv.originalWidth, cnv.originalHeight, true]]
                ],
                state: [],
                stateIndex: 0,
                noValidate: true
            }
        }
    };
    this.reInitStack = function(data) {
        if (data.data) {
            if (data.config.stringSampleFactors) {
                for (var i = 0; i < data.config.stringSampleFactors.length; i++) {
                    var f = data.config.stringSampleFactors[i];
                    for (var j = 0; j < data.data.x[f].length; j++) {
                        data.data.x[f][j] = data.data.x[f][j].replace("\x00", "")
                    }
                }
            }
            if (data.config.stringVariableFactors) {
                for (var i = 0; i < data.config.stringVariableFactors.length; i++) {
                    var f = data.config.stringVariableFactors[i];
                    for (var j = 0; j < data.data.z[f].length; j++) {
                        data.data.z[f][j] = data.data.z[f][j].replace("\x00", "")
                    }
                }
            }
            CanvasXpress.stack[this.target].data = data.data
        }
    };
    this.getStack = function() {
        return CanvasXpress.stack[this.target].afterRender
    };
    this.getConfigState = function() {
        var skip = {
            meta: true,
            animationOn: true,
            arrows: true,
            beaconImage: true,
            bubble: true,
            changingColorItemOn: true,
            changingColorOn: true,
            changingSliderItemOn: true,
            currentCanvasContext: true,
            draggingOn: true,
            doubleClick: true,
            events: true,
            functions: true,
            gantt: true,
            images: true,
            info: true,
            infoStartTime: true,
            isHighlightCanvas: true,
            isTransitionOn: true,
            keyOn: true,
            lastCanvasEvent: true,
            lastMousemove: true,
            lines: true,
            moveSankey: true,
            movingOn: true,
            nodes: true,
            panningOn: true,
            patterns: true,
            resetOn: true,
            resizeCanvasCursorShow: true,
            shapes: true,
            sizes: true,
            skipClick: true,
            skipTransition: true,
            times: true,
            touchEvent: true,
            touches: true,
            transitionIter: true,
            userId: true,
            validGraphTypes: true,
            vennCompartments: true,
            xMouseDown: true,
            yMouseDown: true
        };
        if (this.graphType != "Network") {
            skip.data = true
        }
        var keys = Object.keys(this);
        var cfg = this.getObjectArray(CanvasXpress.config);
        var props = [];
        for (var i = 0; i < keys.length; i++) {
            var c = keys[i];
            if (cfg.hasOwnProperty(c)) {
                props.push(c)
            } else {
                if (!this.isFunction(this[c]) && !skip.hasOwnProperty(c)) {
                    props.push(c)
                }
            }
        }
        var config = {};
        for (var i = 0; i < props.length; i++) {
            var c = props[i];
            config[c] = this.isObject(this[c]) ? this.cloneObject(this[c], true) : this[c]
        }
        return config
    };
    this.setConfigState = function(idx) {
        if (!idx) {
            idx = 0
        }
        var config = CanvasXpress.stack[this.target].state[idx];
        for (var c in config) {
            this[c] = config[c]
        }
        var tmp = {
            calculateLayout: this.calculateLayout
        };
        this.calculateLayout = false;
        this.skipStack = true;
        this.draw({
            func: "setConfigState",
            par: [idx]
        });
        this.skipStack = false;
        for (var c in tmp) {
            this[c] = tmp[c]
        }
    };
    this.stack = function(o) {
        if (!this.skipStack && o) {
            var f = o.func;
            var a = o.par ? this.cleanEventInArguments(o.par) : [];
            var p = o.prop || {};
            var t = new Date().getTime();
            var n = CanvasXpress.stack[this.target].afterRender.length;
            if (f) {
                switch (f) {
                    case "setDimensions":
                        if (a && a[0] == this.width && a[1] == this.height) {
                            return
                        }
                        if (a && a[5]) {
                            f = "clickGraphMaxMin";
                            a = a[5] > 0 ? [false, false, true] : [false, this.maximized, false]
                        }
                        CanvasXpress.stack[this.target].afterRender.push([f, a, {}, t]);
                        break;
                    case "broadcastDraw":
                        f = a[0].func;
                        a = a[0] && a[0].par ? this.cleanEventInArguments(a[0].par) : [];
                        p = a[0] && a[0].prop || {};
                        if (f) {
                            CanvasXpress.stack[this.target].afterRender.push([f, a, p, t])
                        }
                        break;
                    case "drawIndicesAfterPannEvent":
                    case "drawIndicesAfterWheelEvent":
                    case "drawRangesAfterWheelEvent":
                    case "updateDragCircular":
                    case "updateDragScatter":
                    case "updateDragNetwork":
                    case "updateDragGenome":
                    case "updateDragMap":
                    case "updateDragMarker":
                        var u = CanvasXpress.stack[this.target].afterRender;
                        var q = CanvasXpress.stack[this.target].state;
                        var m = f == "updateDragNetwork" && a[0].shiftKey ? false : true;
                        if (n > 1 && u[n - 1][0] == f && m) {
                            var l = t - u[n - 1][3];
                            if (l < 1000) {
                                u.pop();
                                q.pop()
                            }
                        }
                        CanvasXpress.stack[this.target].afterRender.push([f, a, p, t]);
                        break;
                    case "handleWheelEvent":
                        CanvasXpress.stack[this.target].afterRender.push([f, a, p, t]);
                        break;
                    case "resortSankey":
                        var u = CanvasXpress.stack[this.target].afterRender;
                        var q = CanvasXpress.stack[this.target].state;
                        if (n > 1 && u[n - 1][0] == "resortSankey") {
                            var l = t - u[n - 1][3];
                            if (l < 1000) {
                                u.pop();
                                q.pop()
                            }
                        }
                        default:
                            CanvasXpress.stack[this.target].afterRender.push([f, a, p, t]);
                            break
                }
                if (!this.disableUndoRedoKeys && CanvasXpress.stack[this.target].stateIndex < CanvasXpress.stack[this.target].state.length - 1) {
                    CanvasXpress.stack[this.target].state.splice(CanvasXpress.stack[this.target].stateIndex, CanvasXpress.stack[this.target].state.length - 1)
                }
                this.meta.stack.push([f, this.meta.time.start, this.meta.time.elapsed]);
                if (!this.disableUndoRedoKeys) {
                    var s = this.getConfigState();
                    CanvasXpress.stack[this.target].state.push(s);
                    CanvasXpress.stack[this.target].stateIndex = CanvasXpress.stack[this.target].state.length - 1
                }
            }
        }
    };
    this.reproducePlay = function(t) {
        return function(e) {
            t.reproduce(e, true)
        }
    }(this);
    this.reproduce = function(t) {
        return function(e, p, d) {
            t.skipStack = true;
            t.reproducing = true;
            t.resetMenus();
            t.resetLinks();
            t.resetSelected(e, true);
            t.meta.ids = {};
            if (d) {
                t.setMotionObject();
                t.clickMotion(e, true, true)
            } else {
                t.addMotionDiv(e);
                if ((e && e.shiftKey) || p) {
                    t.clickMotion(e, true)
                }
            }
        }
    }(this);
    this.animate = function(t) {
        return function(e) {
            t.replot(e, true)
        }
    }(this);
    this.replot = function(t) {
        return function(e, a, o) {
            var d = t.cloneObject(CanvasXpress.stack[t.target]);
            if (!this.isRawData) {
                if (d.data.y) {
                    delete d.data.y.data
                }
            }
            this.isQQ = false;
            this.isCDF = false;
            d.config.showTransition = a ? true : false;
            if (o) {
                var ar = t.cloneObject(d.afterRender);
                d.afterRender = [];
                for (var i = 0; i < ar.length; i++) {
                    var c = ar[i];
                    if (c[0] == "addQQPlot" && d.config.decorations) {
                        delete d.config.decorations.qq
                    }
                    if (c[0] == "addCDFPlot" && d.config.decorations) {
                        delete d.config.decorations.cdf
                    }
                    if (c && c[4]) {
                        d.afterRender.push(c)
                    }
                }
            }
            var m = false;
            if (t.maximized) {
                t.clickGraphMaxMin()
            }
            t.destroy(t.target, true);
            new CanvasXpress(d)
        }
    }(this)
};
CanvasXpress.prototype.initSave = function() {
    /*! @source http://purl.eligrey.com/github/Blob.js/blob/master/Blob.js */
    (function(g) {
        g.URL = g.URL || g.webkitURL;
        if (g.Blob && g.URL) {
            try {
                new Blob;
                return
            } catch (j) {}
        }
        var i = g.BlobBuilder || g.WebKitBlobBuilder || g.MozBlobBuilder || (function(v) {
            var m = function(F) {
                    return Object.prototype.toString.call(F).match(/^\[object\s(.*)\]$/)[1]
                },
                E = function s() {
                    this.data = []
                },
                C = function o(H, F, G) {
                    this.data = H;
                    this.size = H.length;
                    this.type = F;
                    this.encoding = G
                },
                w = E.prototype,
                B = C.prototype,
                y = v.FileReaderSync,
                k = function(F) {
                    this.code = this[this.name = F]
                },
                x = ("NOT_FOUND_ERR SECURITY_ERR ABORT_ERR NOT_READABLE_ERR ENCODING_ERR NO_MODIFICATION_ALLOWED_ERR INVALID_STATE_ERR SYNTAX_ERR").split(" "),
                A = x.length,
                r = v.URL || v.webkitURL || v,
                z = r.createObjectURL,
                l = r.revokeObjectURL,
                q = r,
                u = v.btoa,
                p = v.atob,
                n = v.ArrayBuffer,
                t = v.Uint8Array,
                D = /^[\w-]+:\/*\[?[\w\.:-]+\]?(?::[0-9]+)?/;
            C.fake = B.fake = true;
            while (A--) {
                k.prototype[x[A]] = A + 1
            }
            if (!r.createObjectURL) {
                q = v.URL = function(G) {
                    var F = document.createElementNS("http://www.w3.org/1999/xhtml", "a"),
                        H;
                    F.href = G;
                    if (!("origin" in F)) {
                        if (F.protocol.toLowerCase() === "data:") {
                            F.origin = null
                        } else {
                            H = G.match(D);
                            F.origin = H && H[1]
                        }
                    }
                    return F
                }
            }
            q.createObjectURL = function(G) {
                var H = G.type,
                    F;
                if (H === null) {
                    H = "application/octet-stream"
                }
                if (G instanceof C) {
                    F = "data:" + H;
                    if (G.encoding === "base64") {
                        return F + ";base64," + G.data
                    } else {
                        if (G.encoding === "URI") {
                            return F + "," + decodeURIComponent(G.data)
                        }
                    }
                    if (u) {
                        return F + ";base64," + u(G.data)
                    } else {
                        return F + "," + encodeURIComponent(G.data)
                    }
                } else {
                    if (z) {
                        return z.call(r, G)
                    }
                }
            };
            q.revokeObjectURL = function(F) {
                if (F.substring(0, 5) !== "data:" && l) {
                    l.call(r, F)
                }
            };
            w.append = function(J) {
                var L = this.data;
                if (t && (J instanceof n || J instanceof t)) {
                    var K = "",
                        G = new t(J),
                        H = 0,
                        I = G.length;
                    for (; H < I; H++) {
                        K += String.fromCharCode(G[H])
                    }
                    L.push(K)
                } else {
                    if (m(J) === "Blob" || m(J) === "File") {
                        if (y) {
                            var F = new y;
                            L.push(F.readAsBinaryString(J))
                        } else {
                            throw new k("NOT_READABLE_ERR")
                        }
                    } else {
                        if (J instanceof C) {
                            if (J.encoding === "base64" && p) {
                                L.push(p(J.data))
                            } else {
                                if (J.encoding === "URI") {
                                    L.push(decodeURIComponent(J.data))
                                } else {
                                    if (J.encoding === "raw") {
                                        L.push(J.data)
                                    }
                                }
                            }
                        } else {
                            if (typeof J !== "string") {
                                J += ""
                            }
                            L.push(unescape(encodeURIComponent(J)))
                        }
                    }
                }
            };
            w.getBlob = function(F) {
                if (!arguments.length) {
                    F = null
                }
                return new C(this.data.join(""), F, "raw")
            };
            w.toString = function() {
                return "[object BlobBuilder]"
            };
            B.slice = function(I, F, H) {
                var G = arguments.length;
                if (G < 3) {
                    H = null
                }
                return new C(this.data.slice(I, G > 1 ? F : this.data.length), H, this.encoding)
            };
            B.toString = function() {
                return "[object Blob]"
            };
            B.close = function() {
                this.size = 0;
                delete this.data
            };
            return E
        }(g));
        g.Blob = function(o, n) {
            var q = n ? (n.type || "") : "";
            var m = new i();
            if (o) {
                for (var p = 0, k = o.length; p < k; p++) {
                    if (Uint8Array && o[p] instanceof Uint8Array) {
                        m.append(o[p].buffer)
                    } else {
                        m.append(o[p])
                    }
                }
            }
            var l = m.getBlob(q);
            if (!l.slice && l.webkitSlice) {
                l.slice = l.webkitSlice
            }
            return l
        };
        var h = Object.getPrototypeOf || function(k) {
            return k.__proto__
        };
        g.Blob.prototype = h(new g.Blob())
    }(typeof self !== "undefined" && self || typeof window !== "undefined" && window || this.content || this));
    /*! @source http://purl.eligrey.com/github/canvas-toBlob.js/blob/master/canvas-toBlob.js */
    (function(g) {
        var h = g.Uint8Array,
            j = g.HTMLCanvasElement,
            i = j && j.prototype,
            k = /\s*;\s*base64\s*(?:;|$)/i,
            l = "toDataURL",
            n, m = function(u) {
                var v = u.length,
                    r = new h(v / 4 * 3 | 0),
                    t = 0,
                    x = 0,
                    y = [0, 0],
                    o = 0,
                    w = 0,
                    s, p, q;
                while (v--) {
                    p = u.charCodeAt(t++);
                    s = n[p - 43];
                    if (s !== 255 && s !== q) {
                        y[1] = y[0];
                        y[0] = p;
                        w = (w << 6) | s;
                        o++;
                        if (o === 4) {
                            r[x++] = w >>> 16;
                            if (y[1] !== 61) {
                                r[x++] = w >>> 8
                            }
                            if (y[0] !== 61) {
                                r[x++] = w
                            }
                            o = 0
                        }
                    }
                }
                return r
            };
        if (h) {
            n = new h([62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, 0, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51])
        }
        if (j && (!i.toBlob || !i.toBlobHD)) {
            if (!i.toBlob) {
                i.toBlob = function(v, t) {
                    if (!t) {
                        t = "image/png"
                    }
                    if (this.mozGetAsFile) {
                        v(this.mozGetAsFile("canvas", t));
                        return
                    }
                    if (this.msToBlob && /^\s*image\/png\s*(?:$|;)/i.test(t)) {
                        v(this.msToBlob());
                        return
                    }
                    var s = Array.prototype.slice.call(arguments, 1),
                        q = this[l].apply(this, s),
                        p = q.indexOf(","),
                        u = q.substring(p + 1),
                        o = k.test(q.substring(0, p)),
                        r;
                    if (Blob.fake) {
                        r = new Blob;
                        if (o) {
                            r.encoding = "base64"
                        } else {
                            r.encoding = "URI"
                        }
                        r.data = u;
                        r.size = u.length
                    } else {
                        if (h) {
                            if (o) {
                                r = new Blob([m(u)], {
                                    type: t
                                })
                            } else {
                                r = new Blob([decodeURIComponent(u)], {
                                    type: t
                                })
                            }
                        }
                    }
                    v(r)
                }
            }
            if (!i.toBlobHD && i.toDataURLHD) {
                i.toBlobHD = function() {
                    l = "toDataURLHD";
                    var o = this.toBlob();
                    l = "toDataURL";
                    return o
                }
            } else {
                i.toBlobHD = i.toBlob
            }
        }
    }(typeof self !== "undefined" && self || typeof window !== "undefined" && window || this.content || this));
    var f = typeof window === "object" && window.window === window ? window : typeof self === "object" && self.self === self ? self : typeof global === "object" && global.global === global ? global : this;

    function e(g, h) {
        if (typeof h === "undefined") {
            h = {
                autoBom: false
            }
        } else {
            if (typeof h !== "object") {
                console.warn("Depricated: Expected third argument to be a object");
                h = {
                    autoBom: !h
                }
            }
        }
        if (h.autoBom && /^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(g.type)) {
            return new Blob([String.fromCharCode(65279), g], {
                type: g.type
            })
        }
        return g
    }

    function b(h, g, i) {
        var j = new XMLHttpRequest();
        j.open("GET", h);
        j.responseType = "blob";
        j.onload = function() {
            a(j.response, g, i)
        };
        j.onerror = function() {
            console.error("could not download file")
        };
        j.send()
    }

    function c(g) {
        var h = new XMLHttpRequest();
        h.open("HEAD", g, false);
        h.send();
        return h.status >= 200 && h.status <= 299
    }

    function d(h) {
        try {
            h.dispatchEvent(new MouseEvent("click"))
        } catch (i) {
            var g = document.createEvent("MouseEvents");
            g.initMouseEvent("click", true, true, window, 0, 0, 0, 80, 20, false, false, false, false, 0, null);
            h.dispatchEvent(g)
        }
    }
    var a = f.saveAs || (typeof window !== "object" || window !== f) ? function a() {} : "download" in HTMLAnchorElement.prototype ? function a(i, j, k) {
        var g = f.URL || f.webkitURL;
        var h = document.createElement("a");
        j = j || i.name || "download";
        h.download = j;
        h.rel = "noopener";
        if (typeof i === "string") {
            h.href = i;
            if (h.origin !== location.origin) {
                c(h.href) ? b(i, j, k) : d(h, h.target = "_blank")
            } else {
                d(h)
            }
        } else {
            h.href = g.createObjectURL(i);
            setTimeout(function() {
                g.revokeObjectURL(h.href)
            }, 40000);
            setTimeout(function() {
                d(h)
            }, 0)
        }
    } : "msSaveOrOpenBlob" in navigator ? function a(h, i, j) {
        i = i || h.name || "download";
        if (typeof h === "string") {
            if (c(h)) {
                b(h, i, j)
            } else {
                var g = document.createElement("a");
                g.href = h;
                g.target = "_blank";
                setTimeout(function() {
                    d(g)
                })
            }
        } else {
            navigator.msSaveOrOpenBlob(e(h, j), i)
        }
    } : function a(h, j, g, k) {
        k = k || open("", "_blank");
        if (k) {
            k.document.title = k.document.body.innerText = "downloading..."
        }
        if (typeof h === "string") {
            return b(h, j, g)
        }
        var l = h.type === "application/octet-stream";
        var o = /constructor/i.test(f.HTMLElement) || f.safari;
        var p = /CriOS\/[\d]+/.test(navigator.userAgent);
        if ((p || (l && o)) && typeof FileReader === "object") {
            var m = new FileReader();
            m.onloadend = function() {
                var q = m.result;
                q = p ? q : q.replace(/^data:[^;]*;/, "data:attachment/file;");
                if (k) {
                    k.location.href = q
                } else {
                    location = q
                }
                k = null
            };
            m.readAsDataURL(h)
        } else {
            var n = f.URL || f.webkitURL;
            var i = n.createObjectURL(h);
            if (k) {
                k.location = i
            } else {
                location.href = i
            }
            k = null;
            setTimeout(function() {
                n.revokeObjectURL(i)
            }, 40000)
        }
    };
    this.saveAs = a
};
CanvasXpress.prototype.initConfig = function() {
    this.setConfigDefaults = function() {
        var a = CanvasXpress.config;
        this.graphType = "Bar";
        a.push("graphType");
        this.graphOrientation = "horizontal";
        a.push("graphOrientation");
        this.transparency = null;
        a.push("transparency");
        this.transparencyHidden = 0.1;
        a.push("transparencyHidden");
        this.canvasBox = false;
        a.push("canvasBox");
        this.canvasBoxColor = "rgb(204,204,204)";
        a.push("canvasBoxColor");
        this.plotBox = false;
        a.push("plotBox");
        this.plotBoxColor = "rgb(204,204,204)";
        a.push("plotBoxColor");
        this.invertGraph = false;
        a.push("invertGraph");
        this.view = "canvas";
        a.push("view");
        this.isR = false;
        a.push("isR");
        this.isReproducibleResearch = true;
        a.push("isReproducibleResearch");
        this.reproduceTime = 500;
        a.push("reproduceTime");
        this.printType = "download";
        a.push("printType");
        this.printMagnification = 1;
        a.push("printMagnification");
        this.printThumbnail = false;
        a.push("printThumbnail");
        this.cacheBase64 = false;
        a.push("cacheBase64");
        this.editable = true;
        a.push("editable");
        this.highlightGreyOut = false;
        a.push("highlightGreyOut");
        this.highlightGreyOutTransparency = 0.67;
        a.push("highlightGreyOutTransparency");
        this.theme = "none";
        a.push("theme");
        this.useRawLines = false;
        a.push("useRawLines");
        this.fullTextMeasureCheck = 500;
        a.push("fullTextMeasureCheck");
        this.showFunctionNamesAfterRender = false;
        a.push("showFunctionNamesAfterRender");
        this.saveFilename = false;
        a.push("saveFilename");
        this.skipRender = false;
        a.push("skipRender");
        this.tags = [];
        a.push("tags");
        this.createVersion = false;
        a.push("createVersion");
        this.createFactory = false;
        a.push("createFactory");
        this.metaData = {};
        a.push("metaData");
        this.functions = [];
        this.effect = "none";
        a.push("effect");
        this.codeEffectIn = "swashIn";
        a.push("codeEffectIn");
        this.codeEffectOut = "holeOut";
        a.push("codeEffectOut");
        this.configuratorEffectIn = "swashIn";
        a.push("configuratorEffectIn");
        this.configuratorEffectOut = "holeOut";
        a.push("configuratorEffectOut");
        this.dataexplorerEffectIn = "holeOut";
        a.push("dataexplorerEffectIn");
        this.dataexplorerEffectOut = "holeOut";
        a.push("dataexplorerEffectOut");
        this.datafilterEffectIn = "holeOut";
        a.push("datafilterEffectIn");
        this.datafilterEffectOut = "holeOut";
        a.push("datafilterEffectOut");
        this.datatableEffectIn = "holeOut";
        a.push("datatableEffectIn");
        this.datatableEffectOut = "holeOut";
        a.push("datatableEffectOut");
        this.motionEffectIn = "swashIn";
        a.push("motionEffectIn");
        this.motionEffectOut = "holeOut";
        a.push("motionEffectOut");
        this.remoteEffectIn = "holeIn";
        a.push("remoteEffectIn");
        this.remoteEffectOut = "holeOut";
        a.push("remoteEffectOut");
        this.toolbarEffectIn = "holeIn";
        a.push("toolbarEffectIn");
        this.toolbarEffectOut = "holeOut";
        a.push("toolbarEffectOut");
        this.tooltipDivEffectIn = "holeOut";
        a.push("tooltipDivEffectIn");
        this.tooltipDivEffectOut = "spaceInUp";
        a.push("tooltipDivEffectOut");
        this.gradient = false;
        a.push("gradient");
        this.gradientType = "radial";
        a.push("gradientType");
        this.gradientOrientation = "vertical";
        a.push("gradientOrientation");
        this.gradientRatio = 1.3;
        a.push("gradientRatio");
        this.adjustAspectRatio = true;
        a.push("adjustAspectRatio");
        this.percentAspectRatioPlotArea = 0.5;
        a.push("percentAspectRatioPlotArea");
        this.fixedAspectRatio = 0;
        a.push("fixedAspectRatio");
        this.variableSpaceFactor = 2;
        a.push("variableSpaceFactor");
        this.sampleSpaceFactor = 1;
        a.push("sampleSpaceFactor");
        this.widthFactor = 1;
        a.push("widthFactor");
        this.dataPointSize = 20;
        a.push("dataPointSize");
        this.dataPointSizeScaleFactor = 1;
        a.push("dataPointSizeScaleFactor");
        this.adjustAspectRatioMax = 3;
        this.adjustAspectRatioYTries = 0;
        this.adjustAspectRatioXTries = 0;
        this.foreground = "rgb(0,0,0)";
        a.push("foreground");
        this.background = "rgb(255,255,255)";
        a.push("background");
        this.backgroundWindow = "rgb(244,244,244)";
        a.push("backgroundWindow");
        this.backgroundType = "solid";
        a.push("backgroundType");
        this.backgroundImage = false;
        a.push("backgroundImage");
        this.margin = 5;
        a.push("margin");
        this.marginLeft = 5;
        a.push("marginLeft");
        this.marginTop = 5;
        a.push("marginTop");
        this.marginBottom = 5;
        a.push("marginBottom");
        this.marginRight = 5;
        a.push("marginRight");
        this.showShadow = false;
        a.push("showShadow");
        this.showTextShadow = false;
        a.push("showTextShadow");
        this.shadowOffsetX = 1;
        a.push("shadowOffsetX");
        this.shadowOffsetY = 1;
        a.push("shadowOffsetY");
        this.shadowBlur = 2;
        a.push("shadowBlur");
        this.shadowColor = "rgba(0,0,0,0.5)";
        a.push("shadowColor");
        this.topoJSON = false;
        a.push("topoJSON");
        this.mapId = false;
        a.push("mapId");
        this.mapProjection = "mercator";
        a.push("mapProjection");
        this.mapLatitudeOrigin = 23;
        a.push("mapLatitudeOrigin");
        this.mapCentralMeridian = -96;
        a.push("mapCentralMeridian");
        this.mapStandardParallel1 = 29.5;
        a.push("mapStandardParallel1");
        this.mapStandardParallel2 = 45.5;
        a.push("mapStandardParallel2");
        this.mapGraticuleShow = false;
        a.push("mapGraticuleShow");
        this.mapGraticuleType = "solid";
        a.push("mapGraticuleType");
        this.mapConfig = false;
        a.push("mapConfig");
        this.mapConfigFeatures = false;
        a.push("mapConfigFeatures");
        this.mapSmps = [];
        a.push("mapSmps");
        this.hiddenMapFeatures = [];
        a.push("hiddenMapFeatures");
        this.visibleMapFeatures = [];
        a.push("visibleMapFeatures");
        this.mapColor = "rgb(105,210,230)";
        a.push("mapColor");
        this.mapOutlineColor = "rgb(204,204,204)";
        a.push("mapOutlineColor");
        this.fonts = [];
        a.push("fonts");
        this.fontsExternal = [];
        a.push("fontsExternal");
        this.fontName = "Arial";
        a.push("fontName");
        this.fontStyle = "";
        a.push("fontStyle");
        this.fontSize = 12;
        a.push("fontSize");
        this.fontScaleFontFactor = 1;
        a.push("fontScaleFontFactor");
        this.align = "center";
        a.push("align");
        this.baseline = "middle";
        a.push("baseline");
        this.maxTextSize = 40;
        a.push("maxTextSize");
        this.minTextSize = 4;
        a.push("minTextSize");
        this.autoScaleFont = true;
        a.push("autoScaleFont");
        this.scaleTextConstantMult = 30;
        this.scaleTextConstantAdd = 2;
        this.title = false;
        a.push("title");
        this.titleAlign = "center";
        a.push("titleAlign");
        this.titleFontSize = 16;
        a.push("titleFontSize");
        this.titleColor = "rgb(0,0,0)";
        a.push("titleColor");
        this.titleColorBackground = false;
        a.push("titleColorBackground");
        this.titleScaleFontFactor = 1;
        a.push("titleScaleFontFactor");
        this.titleFontStyle = "";
        a.push("titleFontStyle");
        this.subtitle = false;
        a.push("subtitle");
        this.subtitleAlign = "center";
        a.push("subtitleAlign");
        this.subtitleFontSize = 14;
        a.push("subtitleFontSize");
        this.subtitleColor = "rgb(0,0,0)";
        a.push("subtitleColor");
        this.subtitleScaleFontFactor = 1;
        a.push("subtitleScaleFontFactor");
        this.subtitleFontStyle = "";
        a.push("subtitleFontStyle");
        this.citation = false;
        a.push("citation");
        this.citationColor = "rgb(0,0,0)";
        a.push("citationColor");
        this.citationFontStyle = "";
        a.push("citationFontStyle");
        this.citationFontSize = 7;
        a.push("citationFontSize");
        this.citationScaleFontFactor = 1;
        a.push("citationScaleFontFactor");
        this.dashLength = 8;
        a.push("dashLength");
        this.dotLength = 1;
        a.push("dotLength");
        this.arrowPointSize = 9;
        a.push("arrowPointSize");
        this.arrowQuadraticFactor = 2.3;
        a.push("arrowQuadraticFactor");
        this.capType = "butt";
        a.push("capType");
        this.joinType = "mitter";
        a.push("joinType");
        this.lineWidthEvent = 2;
        this.outlineWidth = 1;
        a.push("outlineWidth");
        this.lineThickness = 1;
        a.push("lineThickness");
        this.adjustBezier = false;
        a.push("adjustBezier");
        this.lines = ["line", "solid", "straight", "bezier", "curved", "curvedCC", "dashedLine", "dashedBezier", "dashedCurved", "dashedCurvedCC", "dottedLine", "dottedBezier", "dottedCurved", "dottedCurvedCC", "blank", "dashed", "dotted", "dotdash", "longdash", "twodash"];
        this.arrows = ["arrow", "square", "round"];
        this.colorScheme = "User";
        a.push("colorScheme");
        this.colors = ["#fe296c", "#487eb6", "#a7ce31", "#f8cc03", "#ff8c02", "#699696", "#b77844", "#83acd0", "#c2e076", "#fadc5a", "#ff549f", "#ffaf54", "#9ab8b7", "#d2a683", "#3d699b", "#87ac22", "#cda908", "#d02158", "#d07300", "#567676"];
        a.push("colors");
        this.colorHSV = [0, 0, 1];
        this.colorRGB = [1, 1, 1];
        this.colorSpectrum = ["#4575b4", "#91bfdb", "#e0f3f8", "#ffffbf", "#fee090", "#fc8d59", "#d73027"];
        a.push("colorSpectrum");
        this.colorSpectrumBreaks = [];
        a.push("colorSpectrumBreaks");
        this.colorSpectrumZeroValue = null;
        a.push("colorSpectrumZeroValue");
        this.colorSpectrumNumber = 100;
        a.push("colorSpectrumNumber");
        this.colorSpectrumTarget = 10;
        a.push("colorSpectrumTarget");
        this.oddColor = this.background;
        a.push("oddColor");
        this.evenColor = "rgb(245,245,245)";
        a.push("evenColor");
        this.blindnessType = false;
        a.push("blindnessType");
        this.roundedPolygonRadius = 5;
        a.push("roundedPolygonRadius");
        this.useRoundRectangles = false;
        a.push("useRoundRectangles");
        this.useOpenShapes = false;
        a.push("useOpenShapes");
        this.shapes = ["sphere", "square", "triangle", "star", "rhombus", "octagon", "oval", "plus", "minus", "pacman", "pacman2", "mdavid", "rect2", "pentagon", "rect3", "arc", "rectangle"];
        a.push("shapes");
        this.sizes = [8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48];
        a.push("sizes");
        this.images = [];
        a.push("images");
        this.patterns = ["solid", "hatchForward", "hatchReverse", "stripeHorizontal", "stripeVertical", "polkaDot", "crossHatch", "crossStripe", "squares", "circles", "plus", "minus", "bars", "squiglesVertical", "squiglesHorizontal", "brickForward", "brickReverse", "art", "pcx", "hatchForward3", "hatchReverse3"];
        a.push("patterns");
        this.linePatterns = ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"];
        a.push("linePatterns");
        this.maxSmpStringLen = 25;
        a.push("maxSmpStringLen");
        this.smpTitle = false;
        a.push("smpTitle");
        this.smpTitleFontStyle = "";
        a.push("smpTitleFontStyle");
        this.smpTitleFontSize = 12;
        a.push("smpTitleFontSize");
        this.smpTitleFontColor = this.foreground;
        a.push("smpTitleFontColor");
        this.smpTitleScaleFontFactor = 1;
        a.push("smpTitleScaleFontFactor");
        this.smpLabelFontStyle = "";
        a.push("smpLabelFontStyle");
        this.smpLabelFontSize = 12;
        a.push("smpLabelFontSize");
        this.smpLabelFontColor = this.foreground;
        a.push("smpLabelFontColor");
        this.smpLabelScaleFontFactor = 1;
        a.push("smpLabelScaleFontFactor");
        this.smpLabelRotate = 0;
        a.push("smpLabelRotate");
        this.smpLabelInterval = 1;
        a.push("smpLabelInterval");
        this.smpLabelImage = false;
        a.push("smpLabelImage");
        this.smpLabelImageRound = false;
        a.push("smpLabelImageRound");
        this.showSampleNames = true;
        a.push("showSampleNames");
        this.highlightSmp = [];
        a.push("highlightSmp");
        this.smpHighlightColor = "rgb(255,0,0)";
        a.push("smpHighlightColor");
        this.maxVarStringLen = 25;
        a.push("maxVarStringLen");
        this.varTitle = false;
        a.push("varTitle");
        this.varTitleFontStyle = "";
        a.push("varTitleFontStyle");
        this.varTitleFontSize = 12;
        a.push("varTitleFontSize");
        this.varTitleFontColor = this.foreground;
        a.push("varTitleFontColor");
        this.varTitleScaleFontFactor = 1;
        a.push("varTitleScaleFontFactor");
        this.varLabelFontStyle = "";
        a.push("varLabelFontStyle");
        this.varLabelFontSize = 12;
        a.push("varLabelFontSize");
        this.varLabelFontColor = this.foreground;
        a.push("varLabelFontColor");
        this.varLabelScaleFontFactor = 1;
        a.push("varLabelScaleFontFactor");
        this.varLabelRotate = 0;
        a.push("varLabelRotate");
        this.varLabelInterval = 1;
        a.push("varLabelInterval");
        this.showVariableNames = true;
        a.push("showVariableNames");
        this.highlightVar = [];
        a.push("highlightVar");
        this.varHighlightColor = "rgb(255,0,0)";
        a.push("varHighlightColor");
        this.binConfigurations = {};
        a.push("binConfigurations");
        this.maxOverlayStringLen = 30;
        a.push("maxOverlayStringLen");
        this.overlaysThickness = 18;
        a.push("overlaysThickness");
        this.smpOverlays = [];
        a.push("smpOverlays");
        this.smpOverlayProperties = {};
        a.push("smpOverlayProperties");
        this.smpOverlaysLegendColumns = 1;
        a.push("smpOverlaysLegendColumns");
        this.showSmpOverlaysLegend = false;
        a.push("showSmpOverlaysLegend");
        this.varOverlays = [];
        a.push("varOverlays");
        this.varOverlayProperties = {};
        a.push("varOverlayProperties");
        this.varOverlaysLegendColumns = 1;
        a.push("varOverlaysLegendColumns");
        this.showVarOverlaysLegend = false;
        a.push("showVarOverlaysLegend");
        this.overlaysLegendPosition = "topRight";
        a.push("overlaysLegendPosition");
        this.showOverlays = true;
        a.push("showOverlays");
        this.showLevelOverlays = true;
        a.push("showLevelOverlays");
        this.overlayFontStyle = "";
        a.push("overlayFontStyle");
        this.overlayFontSize = 12;
        a.push("overlayFontSize");
        this.overlayFontColor = this.foreground;
        a.push("overlayFontColor");
        this.overlayScaleFontFactor = 1;
        a.push("overlayScaleFontFactor");
        this.showLegend = true;
        a.push("showLegend");
        this.showLegendTitle = true;
        a.push("showLegendTitle");
        this.legendColumns = 1;
        a.push("legendColumns");
        this.legendPosition = "right";
        a.push("legendPosition");
        this.legendPositionAuto = false;
        a.push("legendPositionAuto");
        this.legendInside = false;
        a.push("legendInside");
        this.legendColor = this.foreground;
        a.push("legendColor");
        this.legendBox = false;
        a.push("legendBox");
        this.legendBoxColor = "rgb(204,204,204)";
        a.push("legendBoxColor");
        this.legendBackgroundColor = "rgba(255,255,255,0)";
        a.push("legendBackgroundColor");
        this.legendFontStyle = "";
        a.push("legendFontStyle");
        this.legendFontSize = 12;
        a.push("legendFontSize");
        this.legendScaleFontFactor = 1;
        a.push("legendScaleFontFactor");
        this.legendOrder = false;
        a.push("legendOrder");
        this.legend = [];
        a.push("legend");
        this.showDecorations = true;
        a.push("showDecorations");
        this.showDecorationsLegend = true;
        a.push("showDecorationsLegend");
        this.decorationsPosition = "bottom";
        a.push("decorationsPosition");
        this.decorationsColor = this.foreground;
        a.push("decorationsColor");
        this.decorationsBox = false;
        a.push("decorationsBox");
        this.decorationsBoxColor = "rgb(204,204,204)";
        a.push("decorationsBoxColor");
        this.decorationsBackgroundColor = "rgba(255,255,255,0)";
        a.push("decorationsBackgroundColor");
        this.decorationFontStyle = "";
        a.push("decorationFontStyle");
        this.decorationFontSize = 12;
        a.push("decorationFontSize");
        this.decorationScaleFontFactor = 1;
        a.push("decorationScaleFontFactor");
        this.decorationsWidth = 20;
        a.push("decorationsWidth");
        this.decorationsHeight = 40;
        a.push("decorationsHeight");
        this.decorationsType = "bar";
        a.push("decorationsType");
        this.decorations = false;
        a.push("decorations");
        this.decorationsColors = [];
        a.push("decorationsColors");
        this.decorationsProperties = {};
        a.push("decorationsProperties");
        this.isGroupedData = false;
        this.isBoxplotCalc = false;
        this.groupingFactors = [];
        a.push("groupingFactors");
        this.segregateSamplesBy = [];
        a.push("segregateSamplesBy");
        this.segregateVariablesBy = [];
        a.push("segregateVariablesBy");
        this.summaryType = false;
        a.push("summaryType");
        this.isTransformedData = false;
        this.transformBase = 10;
        this.transformData = false;
        a.push("transformData");
        this.transformAxis = "samples";
        a.push("transformAxis");
        this.ratioReference = 0;
        a.push("ratioReference");
        this.ratioSampleReference = false;
        a.push("ratioSampleReference");
        this.ratioGroupReference = false;
        a.push("ratioGroupReference");
        this.ratioLevelReference = "";
        a.push("ratioLevelReference");
        this.transposeData = false;
        a.push("transposeData");
        this.asSampleFactors = [];
        a.push("asSampleFactors");
        this.asVariableFactors = [];
        a.push("asVariableFactors");
        this.stringSampleFactors = [];
        a.push("stringSampleFactors");
        this.stringVariableFactors = [];
        a.push("stringVariableFactors");
        this.histogramData = false;
        a.push("histogramData");
        this.appendNetworkData = [];
        a.push("appendNetworkData");
        this.timeFormat = "isoDate";
        a.push("timeFormat");
        this.isGraphTime = false;
        a.push("isGraphTime");
        this.timeValues = [];
        this.timeValueIndices = [];
        this.timeValueProperties = {};
        this.sortDir = "ascending";
        a.push("sortDir");
        this.sortCaseSensitive = false;
        a.push("sortCaseSensitive");
        this.sortData = [];
        a.push("sortData");
        this.missingDataColor = "rgb(245,245,245)";
        a.push("missingDataColor");
        this.missingDataValue = "NA";
        a.push("missingDataValue");
        this.showErrorBars = true;
        a.push("showErrorBars");
        this.errorBarsType = "confidenceInterval95";
        a.push("errorBarsType");
        this.errorBarsColor = "rgb(0,0,0)";
        a.push("errorBarsColor");
        this.errorBarsThickness = 3;
        a.push("errorBarsThickness");
        this.errorBarsWidth = 2;
        a.push("errorBarsWidth");
        this.standardDeviationType = "unbiased";
        a.push("standardDeviationType");
        this.showRegressionFullRange = false;
        a.push("showRegressionFullRange");
        this.regressionType = "linear";
        a.push("regressionType");
        this.regressionOrder = 2;
        a.push("regressionOrder");
        this.showConfidenceIntervals = true;
        a.push("showConfidenceIntervals");
        this.confidenceLevel = 0.95;
        a.push("confidenceLevel");
        this.confidenceIntervalType = "log";
        a.push("confidenceIntervalType");
        this.confidenceIntervalColor = "rgb(50,50,50)";
        a.push("confidenceIntervalColor");
        this.invertCensored = false;
        a.push("invertCensored");
        this.kaplanMeierBy = false;
        a.push("kaplanMeierBy");
        this.fitLineColor = "rgb(255,215,0)";
        a.push("fitLineColor");
        this.fitLineStyle = "solid";
        a.push("fitLineStyle");
        this.randomSeed = 8;
        a.push("randomSeed");
        this.pseudoRandom = true;
        a.push("pseudoRandom");
        this.randomMethod = "numericalRecipes";
        a.push("randomMethod");
        this.randomData = false;
        this.randomDataDistribution = "biased";
        a.push("randomDataDistribution");
        this.randomDataTime = false;
        a.push("randomDataTime");
        this.randomDataMin = 1;
        a.push("randomDataMin");
        this.randomDataMax = 100;
        a.push("randomDataMax");
        this.randomDataMean = 0;
        a.push("randomDataMean");
        this.randomDataSigma = 1;
        a.push("randomDataSigma");
        this.randomDataVariables = 3;
        a.push("randomDataVariables");
        this.randomDataSamples = 36;
        a.push("randomDataSamples");
        this.randomDataVariableAnnotations = 2;
        a.push("randomDataVariableAnnotations");
        this.randomDataSampleAnnotations = 2;
        a.push("randomDataSampleAnnotations");
        this.randomMissingDataPercentage = 0;
        a.push("randomMissingDataPercentage");
        this.randomNetworkReduce = true;
        a.push("randomNetworkReduce");
        this.randomNetworkNodes = 40;
        a.push("randomNetworkNodes");
        this.randomNetworkNodeEdgesMax = 5;
        a.push("randomNetworkNodeEdgesMax");
        this.randomNetworkAll = true;
        a.push("randomNetworkAll");
        this.randomNetworkLayout = "forceLayout";
        a.push("randomNetworkLayout");
        this.zoom = 1;
        a.push("zoom");
        this.zoomGlobal = 1;
        this.zoomStep = 0.2;
        a.push("zoomStep");
        this.zoomScale = true;
        a.push("zoomScale");
        this.zoomVariablesDisable = false;
        a.push("zoomVariablesDisable");
        this.zoomSamplesDisable = false;
        a.push("zoomSamplesDisable");
        this.zoomDisable = false;
        a.push("zoomDisable");
        this.panningX = 0;
        a.push("panningX");
        this.panningY = 0;
        a.push("panningY");
        this.panningGlobalX = 0;
        this.panningGlobalY = 0;
        this.panningStep = 0.2;
        a.push("panningStep");
        this.resizerBackgroundColor = CanvasXpress.system.isIE ? "rgb(204,204,204)" : "rgba(204,204,204,0.7)";
        a.push("resizerBackgroundColor");
        this.xAxisAbsMax = null;
        this.xAxisAbsMin = null;
        this.xAxisMaxStrLength = false;
        this.setMaxX = null;
        a.push("setMaxX");
        this.setMinX = null;
        a.push("setMinX");
        this.xAxisCurrent = 0;
        a.push("xAxisCurrent");
        this.xAxisTitle = false;
        a.push("xAxisTitle");
        this.xAxisTitleDynamic = false;
        a.push("xAxisTitleDynamic");
        this.xAxis = [];
        a.push("xAxis");
        this.xAxisTickStyle = "solid";
        a.push("xAxisTickStyle");
        this.xAxisTickFormat = false;
        a.push("xAxisTickFormat");
        this.xAxisTickColor = "rgb(204,204,204)";
        a.push("xAxisTickColor");
        this.xAxisExact = false;
        a.push("xAxisExact");
        this.xAxisValues = [];
        this.xAxisValuesRaw = [];
        this.xAxisMinorValues = [];
        this.xAxisTransform = false;
        a.push("xAxisTransform");
        this.xAxisCeilValue = null;
        a.push("xAxisCeilValue");
        this.xAxisFloorValue = null;
        a.push("xAxisFloorValue");
        this.xAxisTransformTicks = true;
        a.push("xAxisTransformTicks");
        this.xAxisShow = true;
        a.push("xAxisShow");
        this.xAxisS2Show = false;
        a.push("xAxisS2Show");
        this.xAxisTicks = 5;
        a.push("xAxisTicks");
        this.xAxisMinorTicks = true;
        a.push("xAxisMinorTicks");
        this.xAxisMajorTicks = true;
        a.push("xAxisMajorTicks");
        this.xAxisLeftMajorTick = true;
        a.push("xAxisLeftMajorTick");
        this.xAxisRightMajorTick = true;
        a.push("xAxisRightMajorTick");
        this.xAxisLeftRightTickColor = "rgb(204,204,204)";
        a.push("xAxisLeftRightTickColor");
        this.xAxisHistogramShow = false;
        a.push("xAxisHistogramShow");
        this.xAxisHistogramHeight = 80;
        a.push("xAxisHistogramHeight");
        this.xAxisRugShow = false;
        a.push("xAxisRugShow");
        this.xAxisRugHeight = 15;
        a.push("xAxisRugHeight");
        this.xAxisRugPosition = "bottom";
        a.push("xAxisRugPosition");
        this.xAxis2AbsMax = null;
        this.xAxis2AbsMin = null;
        this.xAxis2MaxStrLength = false;
        this.setMaxX2 = null;
        a.push("setMaxX2");
        this.setMinX2 = null;
        a.push("setMinX2");
        this.xAxis2Title = false;
        a.push("xAxis2Title");
        this.xAxis2 = [];
        a.push("xAxis2");
        this.xAxis2TickFormat = false;
        a.push("xAxis2TickFormat");
        this.xAxis2Values = [];
        this.xAxis2ValuesRaw = [];
        this.xAxis2MinorValues = [];
        this.xAxis2Show = true;
        a.push("xAxis2Show");
        this.xAxis2Ticks = null;
        this.yAxisAbsMax = null;
        this.yAxisAbsMin = null;
        this.yAxisMaxStrLength = false;
        this.setMaxY = null;
        a.push("setMaxY");
        this.setMinY = null;
        a.push("setMinY");
        this.yAxisCurrent = 0;
        a.push("yAxisCurrent");
        this.yAxisTitle = false;
        a.push("yAxisTitle");
        this.yAxisTitleDynamic = false;
        a.push("yAxisTitleDynamic");
        this.yAxis2Title = false;
        a.push("yAxis2Title");
        this.yAxis = [];
        a.push("yAxis");
        this.yAxisTickStyle = "solid";
        a.push("yAxisTickStyle");
        this.yAxisTickFormat = false;
        a.push("yAxisTickFormat");
        this.yAxisTickColor = "rgb(204,204,204)";
        a.push("yAxisTickColor");
        this.yAxisExact = false;
        a.push("yAxisExact");
        this.yAxisValues = [];
        this.yAxisValuesRaw = [];
        this.yAxisMinorValues = [];
        this.yAxisTransform = false;
        a.push("yAxisTransform");
        this.yAxisCeilValue = null;
        a.push("yAxisCeilValue");
        this.yAxisFloorValue = null;
        a.push("yAxisFloorValue");
        this.yAxisTransformTicks = true;
        a.push("yAxisTransformTicks");
        this.yAxisShow = true;
        a.push("yAxisShow");
        this.yAxis2Show = false;
        a.push("yAxis2Show");
        this.yAxisTicks = 5;
        a.push("yAxisTicks");
        this.yAxisMinorTicks = true;
        a.push("yAxisMinorTicks");
        this.yAxisMajorTicks = true;
        a.push("yAxisMajorTicks");
        this.yAxisTopMajorTick = true;
        a.push("yAxisTopMajorTick");
        this.yAxisBottomMajorTick = true;
        a.push("yAxisBottomMajorTick");
        this.yAxisTopBottomTickColor = "rgb(204,204,204)";
        a.push("yAxisTopBottomTickColor");
        this.yAxisHistogramShow = false;
        a.push("yAxisHistogramShow");
        this.yAxisHistogramHeight = 80;
        a.push("yAxisHistogramHeight");
        this.yAxisRugShow = false;
        a.push("yAxisRugShow");
        this.yAxisRugHeight = 15;
        a.push("yAxisRugHeight");
        this.yAxisRugPosition = "left";
        a.push("yAxisRugPosition");
        this.zAxisAbsMax = null;
        this.zAxisAbsMin = null;
        this.zAxisMaxStrLength = false;
        this.setMaxZ = null;
        a.push("setMaxZ");
        this.setMinZ = null;
        a.push("setMinZ");
        this.zAxisCurrent = 0;
        a.push("zAxisCurrent");
        this.zAxisTitle = false;
        a.push("zAxisTitle");
        this.zAxisTitleDynamic = false;
        a.push("zAxisTitleDynamic");
        this.zAxis = [];
        a.push("zAxis");
        this.zAxisTickStyle = "solid";
        a.push("zAxisTickStyle");
        this.zAxisTickFormat = false;
        a.push("zAxisTickFormat");
        this.zAxisTickColor = "rgb(204,204,204)";
        a.push("zAxisTickColor");
        this.zAxisExact = false;
        a.push("zAxisExact");
        this.zAxisValues = [];
        this.zAxisValuesRaw = [];
        this.zAxisMinorValues = [];
        this.zAxisTransform = false;
        a.push("zAxisTransform");
        this.zAxisCeilValue = null;
        a.push("zAxisCeilValue");
        this.zAxisFloorValue = null;
        a.push("zAxisFloorValue");
        this.zAxisTransformTicks = true;
        a.push("zAxisTransformTicks");
        this.zAxisShow = true;
        a.push("zAxisShow");
        this.zAxisTicks = 10;
        this.rAxisAbsMax = null;
        this.rAxisAbsMin = null;
        this.rAxisMaxStrLength = false;
        this.rAxisTickFormat = false;
        a.push("rAxisTickFormat");
        this.rAxisTickColor = this.foreground;
        a.push("rAxisTickColor");
        this.rAxisValues = [];
        a.push("rAxisValues");
        this.rAxisValuesRaw = [];
        this.rAxisMinorValues = [];
        a.push("rAxisMinorValues");
        this.rAxisPercentShow = true;
        a.push("rAxisPercentShow");
        this.rAxisShow = true;
        a.push("rAxisShow");
        this.rAxisLabelOrientation = "perpendicular";
        a.push("rAxisLabelOrientation");
        this.rAxisTicks = 5;
        a.push("rAxisTicks");
        this.rAxisMinorTicks = true;
        a.push("rAxisMinorTicks");
        this.rAxisMajorTicks = true;
        a.push("rAxisMajorTicks");
        this.axisTickColor = this.foreground;
        a.push("axisTickColor");
        this.axisTickThickness = 1;
        a.push("axisTickThickness");
        this.axisMinMaxTickThickness = 1;
        a.push("axisMinMaxTickThickness");
        this.axisTickFontStyle = "";
        a.push("axisTickFontStyle");
        this.axisTickFontSize = 12;
        a.push("axisTickFontSize");
        this.axisTickScaleFontFactor = 1;
        a.push("axisTickScaleFontFactor");
        this.axisTitleColor = this.foreground;
        a.push("axisTitleColor");
        this.axisTitleFontStyle = "";
        a.push("axisTitleFontStyle");
        this.axisTitleFontSize = 12;
        a.push("axisTitleFontSize");
        this.axisTitleScaleFontFactor = 1;
        a.push("axisTitleScaleFontFactor");
        this.axisExtension = 0.1;
        a.push("axisExtension");
        this.axisAlgorithm = "wilkinson";
        a.push("axisAlgorithm");
        this.axisWilkinsonLoose = false;
        a.push("axisWilkinsonLoose");
        this.axisCoordinate = false;
        a.push("axisCoordinate");
        this.setMax = null;
        this.setMin = null;
        this.guides = false;
        a.push("guides");
        this.guidesWidth = 1;
        a.push("guidesWidth");
        this.guidesColor = "rgb(204,204,204)";
        a.push("guidesColor");
        this.blockContrast = false;
        a.push("blockContrast");
        this.plotByVariable = false;
        a.push("plotByVariable");
        this.is3DPlot = false;
        a.push("is3DPlot");
        this.showDataValues = false;
        a.push("showDataValues");
        this.binned = false;
        a.push("binned");
        this.binAlignment = "center";
        a.push("binAlignment");
        this.jitter = true;
        a.push("jitter");
        this.jitterColumns = 7;
        a.push("jitterColumns");
        this.objectBorderColor = "rgb(0,0,0)";
        a.push("objectBorderColor");
        this.objectColorTransparency = 1;
        a.push("objectColorTransparency");
        this.dotplotOutlineThreshold = 500;
        a.push("dotplotOutlineThreshold");
        this.lineDecoration = "symbol";
        a.push("lineDecoration");
        this.lineErrorType = "bar";
        a.push("lineErrorType");
        this.coordinateLineColor = false;
        a.push("coordinateLineColor");
        this.lineType = "rect";
        a.push("lineType");
        this.tension = 0.3;
        a.push("tension");
        this.tensionSegments = 16;
        a.push("tensionSegments");
        this.parallelCoordinates = [];
        this.boxplotOutliersRatio = 8;
        a.push("boxplotOutliersRatio");
        this.boxplotWhiskersType = "double";
        a.push("boxplotWhiskersType");
        this.boxplotType = "boxWhiskers";
        a.push("boxplotType");
        this.boxplotNotched = false;
        a.push("boxplotNotched");
        this.boxplotTransparency = 0.5;
        a.push("boxplotTransparency");
        this.boxplotColor = false;
        a.push("boxplotColor");
        this.boxplotCoef = 1.5;
        a.push("boxplotCoef");
        this.boxplotHingeFunction = "summary";
        a.push("boxplotHingeFunction");
        this.showBoxplotOriginalData = false;
        a.push("showBoxplotOriginalData");
        this.showViolinBoxplot = false;
        a.push("showViolinBoxplot");
        this.violinTrim = true;
        a.push("violinTrim");
        this.violinScale = "area";
        a.push("violinScale");
        this.showBoxplotIfViolin = true;
        a.push("showBoxplotIfViolin");
        this.boxplotWidthRatioIfViolin = 0.33;
        a.push("boxplotWidthRatioIfViolin");
        this.violinTransparency = 0.5;
        a.push("violinTransparency");
        this.violinColor = false;
        a.push("violinColor");
        this.violinBorderColor = "rgb(0,0,0)";
        a.push("violinBorderColor");
        this.boxplotDataPointTransparency = 0.5;
        a.push("boxplotDataPointTransparency");
        this.boxplotMedianColor = "rgb(0,0,0)";
        a.push("boxplotMedianColor");
        this.boxplotMedianWidth = 1;
        a.push("boxplotMedianWidth");
        this.boxplotMean = false;
        a.push("boxplotMean");
        this.boxplotMeanColor = "rgb(255,215,0)";
        a.push("boxplotMeanColor");
        this.boxplotMeanColorBorder = "rgb(255,0,0)";
        a.push("boxplotMeanColorBorder");
        this.boxplotConnect = false;
        a.push("boxplotConnect");
        this.boxplotConnectWidth = 2;
        a.push("boxplotConnectWidth");
        this.areaType = "normal";
        a.push("areaType");
        this.dotplotType = "normal";
        a.push("dotplotType");
        this.barType = "normal";
        a.push("barType");
        this.barPath = false;
        a.push("barPath");
        this.barPathTransparency = 0.1;
        a.push("barPathTransparency");
        this.barPathColor = false;
        a.push("barPathColor");
        this.barLollipopFactor = 1.5;
        a.push("barLollipopFactor");
        this.barLollipopOpen = false;
        a.push("barLollipopOpen");
        this.swimHigh = false;
        a.push("swimHigh");
        this.swimStart = false;
        a.push("swimStart");
        this.swimEnd = false;
        a.push("swimEnd");
        this.swimStatus = false;
        a.push("swimStatus");
        this.swimHighCap = false;
        a.push("swimHighCap");
        this.ganttStart = false;
        a.push("ganttStart");
        this.ganttEnd = false;
        a.push("ganttEnd");
        this.ganttCompletion = false;
        a.push("ganttCompletion");
        this.ganttDependency = false;
        a.push("ganttDependency");
        this.ganttDependencyEnd = false;
        a.push("ganttDependencyEnd");
        this.ganttDependencyColor = false;
        a.push("ganttDependencyColor");
        this.ganttDependencyThickness = false;
        a.push("ganttDependencyThickness");
        this.ganttCompletionTransparency = 0.5;
        a.push("ganttCompletionTransparency");
        this.meterType = "gauge";
        a.push("meterType");
        this.meterMin = 0;
        a.push("meterMin");
        this.meterMax = 100;
        a.push("meterMax");
        this.meterStart = 270;
        a.push("meterStart");
        this.meterEnd = 90;
        a.push("meterEnd");
        this.meterSegments = [25, 75];
        a.push("meterSegments");
        this.meterColors = ["rgb(0,255,0)", "rgb(255,255,0)", "rgb(255,0,0)"];
        a.push("meterColors");
        this.meterAxis = "variables";
        a.push("meterAxis");
        this.meterIndex = 0;
        a.push("meterIndex");
        this.meterNeedleColor = "rgb(0,0,0)";
        a.push("meterNeedleColor");
        this.meterBackgroundColor = "rgb(229,229,229)";
        a.push("meterBackgroundColor");
        this.meterThickness = 50;
        a.push("meterThickness");
        this.fishParents = [];
        a.push("fishParents");
        this.fishTimepoints = [];
        a.push("fishTimepoints");
        this.fishSeparateIndependentClones = false;
        a.push("fishSeparateIndependentClones");
        this.fishShape = "polygon";
        a.push("fishShape");
        this.fishAxis = [];
        a.push("fishAxis");
        this.fishAxisLabels = [];
        a.push("fishAxisLabels");
        this.fishCloneLabels = [];
        a.push("fishCloneLabels");
        this.sankeyNodeWidth = 20;
        a.push("sankeyNodeWidth");
        this.sankeyIterations = 32;
        this.sankeySource = false;
        a.push("sankeySource");
        this.sankeyTarget = false;
        a.push("sankeyTarget");
        this.sankeyColor = "rgba(150,150,150,0.5)";
        a.push("sankeyColor");
        this.sankeyCoordinateColor = false;
        a.push("sankeyCoordinateColor");
        this.hierarchy = [];
        a.push("hierarchy");
        this.hierarchyVar = false;
        a.push("hierarchyVar");
        this.hierarchyVarIndex = 0;
        this.treeNodeSize = 5;
        this.treeLinkColor = "rgb(150,150,150)";
        a.push("treeLinkColor");
        this.treeNodeOutlineColor = "rgb(51,122,183)";
        a.push("treeNodeOutlineColor");
        this.treeLinkWidth = 1;
        a.push("treeLinkWidth");
        this.treeCircular = false;
        a.push("treeCircular");
        this.treeInverted = false;
        a.push("treeInverted");
        this.treeVarIndex = 0;
        a.push("treeVarIndex");
        this.treeNodeId = 0;
        this.colorBy = false;
        a.push("colorBy");
        this.colorByShowLegend = true;
        a.push("colorByShowLegend");
        this.colorKey = false;
        a.push("colorKey");
        this.shapeBy = false;
        a.push("shapeBy");
        this.shapeByContinuous = false;
        a.push("shapeByContinuous");
        this.shapeByShowLegend = true;
        a.push("shapeByShowLegend");
        this.shapeKey = false;
        a.push("shapeKey");
        this.shapeByData = false;
        a.push("shapeByData");
        this.shapeByShape = false;
        a.push("shapeByShape");
        this.sizeBy = false;
        a.push("sizeBy");
        this.sizeByContinuous = false;
        a.push("sizeByContinuous");
        this.sizeByShowLegend = true;
        a.push("sizeByShowLegend");
        this.sizeKey = false;
        a.push("sizeKey");
        this.sizeByData = false;
        a.push("sizeByData");
        this.outlineBy = false;
        a.push("outlineBy");
        this.outlineByShowLegend = true;
        a.push("outlineByShowLegend");
        this.outlineByData = false;
        a.push("outlineByData");
        this.patternBy = false;
        a.push("patternBy");
        this.patternByShowLegend = true;
        a.push("patternByShowLegend");
        this.patternKey = false;
        a.push("patternKey");
        this.patternByData = false;
        a.push("patternByData");
        this.connectBy = false;
        a.push("connectBy");
        this.connectByNoColor = false;
        a.push("connectByNoColor");
        this.connectByColor = "rgb(204,204,204)";
        a.push("connectByColor");
        this.connectByWidth = 2;
        a.push("connectByWidth");
        this.connectByShowLegend = true;
        a.push("connectByShowLegend");
        this.connectKey = false;
        a.push("connectKey");
        this.connectByData = {};
        this.treemapBy = [];
        a.push("treemapBy");
        this.stackBy = false;
        a.push("stackBy");
        this.motionBy = false;
        a.push("motionBy");
        this.markerBy = false;
        a.push("markerBy");
        this.ellipseBy = false;
        a.push("ellipseBy");
        this.spiderBy = false;
        a.push("spiderBy");
        this.ridgeBy = false;
        a.push("ridgeBy");
        this.motionWidth = 250;
        a.push("motionWidth");
        this.motionCurrentColor = "rgba(0,0,0,0.3)";
        a.push("motionCurrentColor");
        this.motionCurrentFontStyle = "";
        a.push("motionCurrentFontStyle");
        this.motionCurrentFontSize = 60;
        a.push("motionCurrentFontSize");
        this.motionCurrentScaleFontFactor = 1;
        a.push("motionCurrentScaleFontFactor");
        this.scatterType = false;
        a.push("scatterType");
        this.visiumFlip = false;
        a.push("visiumFlip");
        this.visiumPanning = false;
        a.push("visiumPanning");
        this.visiumFixedAspectRatio = true;
        a.push("visiumFixedAspectRatio");
        this.scatterAxesEqual = false;
        a.push("scatterAxesEqual");
        this.scatterOutlineThreshold = 50000;
        a.push("scatterOutlineThreshold");
        this.chromosomeLengths = [];
        a.push("chromosomeLengths");
        this.manhattanMarkerChromosomeNumber = false;
        a.push("manhattanMarkerChromosomeNumber");
        this.manhattanMarkerPosition = false;
        a.push("manhattanMarkerPosition");
        this.manhattanMarkerLogPValue = false;
        a.push("manhattanMarkerLogPValue");
        this.manhattanColors = ["rgb(128,128,128)", "rgb(135,206,235)"];
        a.push("manhattanColors");
        this.manhattanContrastColor = "rgba(0,0,0,0.1)";
        a.push("manhattanContrastColor");
        this.selectionMode = "highlight";
        a.push("selectionMode");
        this.selectionColor = "rgb(255,0,0)";
        a.push("selectionColor");
        this.selectionMetadata = false;
        a.push("selectionMetadata");
        this.selectedDataPoints = [];
        a.push("selectedDataPoints");
        this.contourType = "color";
        a.push("contourType");
        this.contourStartLevel = false;
        a.push("contourStartLevel");
        this.contourEndLevel = false;
        a.push("contourEndLevel");
        this.contourLevelStep = false;
        a.push("contourLevelStep");
        this.showContourLevel = false;
        a.push("showContourLevel");
        this.isHistogram = false;
        a.push("isHistogram");
        this.histogramBarWidth = false;
        this.histogramBins = false;
        a.push("histogramBins");
        this.histogramBinWidth = false;
        a.push("histogramBinWidth");
        this.histogramType = "dodged";
        a.push("histogramType");
        this.showHistogramDensity = false;
        a.push("showHistogramDensity");
        this.showFilledHistogramDensity = false;
        a.push("showFilledHistogramDensity");
        this.histogramDensityFillTransparency = 0.6;
        a.push("histogramDensityFillTransparency");
        this.showHistogramDataPoints = false;
        a.push("showHistogramDataPoints");
        this.showHistogramQuantiles = false;
        a.push("showHistogramQuantiles");
        this.showHistogramMedian = false;
        a.push("showHistogramMedian");
        this.histogramMedianLineStyle = "dashed";
        a.push("histogramMedianLineStyle");
        this.hideHistogram = false;
        a.push("hideHistogram");
        this.histogramSizeEstimator = "sturges";
        a.push("histogramSizeEstimator");
        this.histogramStat = "density";
        a.push("histogramStat");
        this.isCreateHistogram = false;
        this.showScatterDensity = false;
        a.push("showScatterDensity");
        this.densityPixels = 1000;
        a.push("densityPixels");
        this.densityKernel = "gaussian";
        a.push("densityKernel");
        this.bandwidthRule = "nrd0";
        a.push("bandwidthRule");
        this.bandwidthCut = 3;
        a.push("bandwidthCut");
        this.ridgelineScale = 1.5;
        a.push("ridgelineScale");
        this.loessDegree = 2;
        a.push("loessDegree");
        this.loessSteps = 30;
        a.push("loessSteps");
        this.loessSurfaceSteps = 30;
        a.push("loessSurfaceSteps");
        this.loessBandwidth = 0.8;
        a.push("loessBandwidth");
        this.loessSpan = 0.8;
        a.push("loessSpan");
        this.loessIterations = 1;
        this.loessAccuracy = 1e-12;
        this.showLoessFit = false;
        a.push("showLoessFit");
        this.qqDistribution = "normal";
        a.push("qqDistribution");
        this.qqSamples = 10000;
        a.push("qqSamples");
        this.qqPoints = 100;
        a.push("qqPoints");
        this.maxDOENumber = 8;
        a.push("maxDOENumber");
        this.includeDOE = [];
        a.push("includeDOE");
        this.autoexpandDOE = true;
        a.push("autoexpandDOE");
        this.scatterPlotMatrix = false;
        a.push("scatterPlotMatrix");
        this.scatterPlotMatrixType = "both";
        a.push("scatterPlotMatrixType");
        this.showScatterPlotMatrixLabels = false;
        a.push("showScatterPlotMatrixLabels");
        this.xRotate = 45;
        a.push("xRotate");
        this.yRotate = 0;
        a.push("yRotate");
        this.zRotate = 0;
        a.push("zRotate");
        this.x3DRatio = 1;
        a.push("x3DRatio");
        this.y3DRatio = 1;
        a.push("y3DRatio");
        this.z3DRatio = 1;
        a.push("z3DRatio");
        this.show3DGrid = true;
        a.push("show3DGrid");
        this.rotationSensitivity = 450;
        a.push("rotationSensitivity");
        this.rotationStep = 2;
        a.push("rotationStep");
        this.perspectiveFactor = 2.2;
        a.push("perspectiveFactor");
        this.varIndicesStart = -1;
        this.smpIndicesStart = -1;
        this.grpIndicesStart = -1;
        this.isMultidimensionalData = false;
        this.heatmapAutoAdjust = false;
        a.push("heatmapAutoAdjust");
        this.heatmapCellBox = true;
        a.push("heatmapCellBox");
        this.heatmapCellBoxColor = "rgb(102,102,102)";
        a.push("heatmapCellBoxColor");
        this.heatmapCellBoxWidth = 1;
        a.push("heatmapCellBoxWidth");
        this.heatmapCellBoxColorHighlight = "rgb(255,215,0)";
        a.push("heatmapCellBoxColorHighlight");
        this.heatmapCellBoxHighlightWidth = 1;
        a.push("heatmapCellBoxHighlightWidth");
        this.heatmapSmpSeparateBy = false;
        a.push("heatmapSmpSeparateBy");
        this.heatmapVarSeparateBy = false;
        a.push("heatmapVarSeparateBy");
        this.heatmapSeparatorThickness = 3;
        a.push("heatmapSeparatorThickness");
        this.varTitleLabelPosition = "bottom";
        a.push("varTitleLabelPosition");
        this.smpTitleLabelPosition = "left";
        a.push("smpTitleLabelPosition");
        this.showHeatmapIndicator = true;
        a.push("showHeatmapIndicator");
        this.heatmapIndicatorHeight = 25;
        a.push("heatmapIndicatorHeight");
        this.heatmapIndicatorWidth = 250;
        a.push("heatmapIndicatorWidth");
        this.adjustAspectRatioHeatmapIndicator = true;
        a.push("adjustAspectRatioHeatmapIndicator");
        this.heatmapIndicatorPosition = "right";
        a.push("heatmapIndicatorPosition");
        this.heatmapIndicatorHistogram = false;
        a.push("heatmapIndicatorHistogram");
        this.heatmapIndicatorHistogramColor = "rgb(0,255,255)";
        a.push("heatmapIndicatorHistogramColor");
        this.heatmapType = "normal";
        a.push("heatmapType");
        this.heatmapCollapse = false;
        a.push("heatmapCollapse");
        this.isOncoprint = false;
        this.oncoprintCNA = false;
        a.push("oncoprintCNA");
        this.oncoprintMUT = false;
        a.push("oncoprintMUT");
        this.oncoprintHeatmapSwitch = false;
        a.push("oncoprintHeatmapSwitch");
        this.oncoprintNoAlterations = true;
        a.push("oncoprintNoAlterations");
        this.oncoprintColSummary = false;
        a.push("oncoprintColSummary");
        this.oncoprintRowSummary = false;
        a.push("oncoprintRowSummary");
        this.oncoprintHeatmapSwitch = false;
        a.push("oncoprintHeatmapSwitch");
        this.showHeatmapOncoprint = false;
        a.push("showHeatmapOncoprint");
        this.oncoprintHeatmapPosition = "bottom";
        a.push("oncoprintHeatmapPosition");
        this.treemapBorderWidth = 3;
        a.push("treemapBorderWidth");
        this.treemapBorderColor = "rgb(204,204,204)";
        a.push("treemapBorderColor");
        this.correlationAxis = "samples";
        a.push("correlationAxis");
        this.correlationAnchorLegend = false;
        a.push("correlationAnchorLegend");
        this.correlationAnchorLegendAlignWidth = 40;
        a.push("correlationAnchorLegendAlignWidth");
        this.correlationLabelInterval = 1;
        a.push("correlationLabelInterval");
        this.correlationType = "diamond";
        a.push("correlationType");
        this.showVarDendrogram = true;
        a.push("showVarDendrogram");
        this.varDendrogramNewick = false;
        a.push("varDendrogramNewick");
        this.varDendrogramPosition = "top";
        a.push("varDendrogramPosition");
        this.colorVarDendrogramBy = false;
        a.push("colorVarDendrogramBy");
        this.showSmpDendrogram = true;
        a.push("showSmpDendrogram");
        this.smpDendrogramNewick = false;
        a.push("smpDendrogramNewick");
        this.smpDendrogramPosition = "left";
        a.push("smpDendrogramPosition");
        this.colorSmpDendrogramBy = false;
        a.push("colorSmpDendrogramBy");
        this.dendrogramHeight = 80;
        a.push("dendrogramHeight");
        this.dendrogramColor = "rgb(0,0,0)";
        a.push("dendrogramColor");
        this.distance = "euclidian";
        a.push("distance");
        this.linkage = "complete";
        a.push("linkage");
        this.clusterAxis = "samples";
        this.kmeansVarClusters = 3;
        a.push("kmeansVarClusters");
        this.kmeansSmpClusters = 3;
        a.push("kmeansSmpClusters");
        this.maxIterations = 500;
        a.push("maxIterations");
        this.imputeMethod = "mean";
        a.push("imputeMethod");
        this.samplesClustered = false;
        a.push("samplesClustered");
        this.variablesClustered = false;
        a.push("variablesClustered");
        this.samplesKmeaned = false;
        a.push("samplesKmeaned");
        this.variablesKmeaned = false;
        a.push("variablesKmeaned");
        this.vennLegendColors = false;
        a.push("vennLegendColors");
        this.vennGroups = 4;
        a.push("vennGroups");
        this.vennCompartments = ["A", "B", "AB", "C", "AC", "BC", "ABC", "D", "AD", "BD", "CD", "ABD", "ACD", "BCD", "ABCD"];
        a.push("vennCompartments");
        this.vennColors = [];
        a.push("vennColors");
        this.pieType = "separated";
        a.push("pieType");
        this.pieSegmentPrecision = 0;
        a.push("pieSegmentPrecision");
        this.pieSegmentSeparation = 1;
        a.push("pieSegmentSeparation");
        this.pieSegmentLabels = "inside";
        a.push("pieSegmentLabels");
        this.pieLabelType = "percentage";
        a.push("pieLabelType");
        this.maxPieSectors = 20;
        a.push("maxPieSectors");
        this.showPieGrid = true;
        a.push("showPieGrid");
        this.showPieValues = true;
        a.push("showPieValues");
        this.showPieSampleLabel = true;
        a.push("showPieSampleLabel");
        this.startPieSectors = 270;
        a.push("startPieSectors");
        this.pieInnerRadius = 0;
        a.push("pieInnerRadius");
        this.pieColors = [];
        a.push("pieColors");
        this.circularType = "normal";
        a.push("circularType");
        this.chordThickness = 28;
        a.push("chordThickness");
        this.chordColor = "source";
        a.push("chordColor");
        this.bubbleColor = "rgba(204,204,204,0.33)";
        a.push("bubbleColor");
        this.circularCenterProportion = 0.3;
        a.push("circularCenterProportion");
        this.arcSegmentsSeparation = 8;
        a.push("arcSegmentsSeparation");
        this.circularRotate = 0;
        a.push("circularRotate");
        this.circularArc = 360;
        a.push("circularArc");
        this.ringSeparation = 5;
        a.push("ringSeparation");
        this.ringGraphType = [];
        a.push("ringGraphType");
        this.ringGraphWeight = [];
        a.push("ringGraphWeight");
        this.arcSegmentsRadius = [];
        a.push("arcSegmentsRadius");
        this.ringsOrder = [];
        a.push("ringsOrder");
        this.rAxis = false;
        a.push("rAxis");
        this.rAxisZero = false;
        a.push("rAxisZero");
        this.showCircularConnections = true;
        a.push("showCircularConnections");
        this.connections = [];
        a.push("connections");
        this.circularLetterSeparationFactor = 1.5;
        a.push("circularLetterSeparationFactor");
        this.circularConnectionsTransparency = 0.5;
        a.push("circularConnectionsTransparency");
        this.overlayLevelOrientation = "circular";
        a.push("overlayLevelOrientation");
        this.smpLabelOrientation = "perpendicular";
        a.push("smpLabelOrientation");
        this.circularLabelsAlign = "outside";
        a.push("circularLabelsAlign");
        this.circularScalesAlign = "inside";
        a.push("circularScalesAlign");
        this.circularAnchorsAlign = "inside";
        a.push("circularAnchorsAlign");
        this.circularAnchors2Align = "outside";
        a.push("circularAnchors2Align");
        this.circularDataPosition = "distributed";
        a.push("circularDataPosition");
        this.circularAnchorLength = 15;
        a.push("circularAnchorLength");
        this.circularAnchorColor = "rgb(0,0,255)";
        a.push("circularAnchorColor");
        this.showIdeogram = false;
        a.push("showIdeogram");
        this.ideogram = "hg38";
        a.push("ideogram");
        this.ideogramChromosome = "chr";
        a.push("ideogramChromosome");
        this.ideogramChromosomePosition = "pos";
        a.push("ideogramChromosomePosition");
        this.tagCloudTextWeightFactor = 1;
        a.push("tagCloudTextWeightFactor");
        this.tagCloudTextGridSize = 8;
        a.push("tagCloudTextGridSize");
        this.tagCloudTextEllipticity = 0.65;
        a.push("tagCloudTextEllipticity");
        this.tagCloudTextRotateRatio = 0.1;
        a.push("tagCloudTextRotateRatio");
        this.tagCloudShape = false;
        a.push("tagCloudShape");
        this.tagCloudMask = false;
        a.push("tagCloudMask");
        this.tagCloudGridPoints = [];
        this.calculateLayout = true;
        a.push("calculateLayout");
        this.networkFreeze = false;
        a.push("networkFreeze");
        this.networkFreezeOnLoad = false;
        a.push("networkFreezeOnLoad");
        this.preScaleNetwork = false;
        a.push("preScaleNetwork");
        this.ignoreEventlessOrder = false;
        a.push("ignoreEventlessOrder");
        this.subNetworks = false;
        this.networkLayoutType = "forceDirected";
        a.push("networkLayoutType");
        this.networkRoot = false;
        a.push("networkRoot");
        this.isNetworkMetrics = false;
        a.push("isNetworkMetrics");
        this.showNetworkRadialLayout = false;
        a.push("showNetworkRadialLayout");
        this.is3DNetwork = false;
        a.push("is3DNetwork");
        this.networkNodesOnTop = true;
        a.push("networkNodesOnTop");
        this.moveParentsWithChildren = false;
        a.push("moveParentsWithChildren");
        this.highlightNode = [];
        a.push("highlightNode");
        this.nodeHighlightColor = "rgb(255,0,0)";
        a.push("nodeHighlightColor");
        this.showNodeNameThreshold = 50;
        a.push("showNodeNameThreshold");
        this.showNodeNameSizeThreshold = 20;
        a.push("showNodeNameSizeThreshold");
        this.nodeSize = 15;
        this.edgeThickness = 1;
        this.labelNodePosition = "auto";
        a.push("labelNodePosition");
        this.nodeFontStyle = "";
        a.push("nodeFontStyle");
        this.nodeFontSize = 15;
        this.nodeFontColor = this.foreground;
        a.push("nodeFontColor");
        this.nodeScaleFontFactor = 1;
        a.push("nodeScaleFontFactor");
        this.networkVendor = false;
        a.push("networkVendor");
        this.attractiveForceFunction = "square";
        a.push("attractiveForceFunction");
        this.repulsiveForceFunction = "square";
        a.push("repulsiveForceFunction");
        this.useBarnesHutSimulation = false;
        a.push("useBarnesHutSimulation");
        this.networkSpeed = 0.1;
        a.push("networkSpeed");
        this.networkGravity = 0.75;
        a.push("networkGravity");
        this.networkSpringLength = 35;
        a.push("networkSpringLength");
        this.networkSpringCoeff = 0.0008;
        a.push("networkSpringCoeff");
        this.networkRepulsion = -1;
        a.push("networkRepulsion");
        this.networkTheta = 0.8;
        a.push("networkTheta");
        this.networkDragCoeff = 0.09;
        a.push("networkDragCoeff");
        this.networkTimeStep = 20;
        a.push("networkTimeStep");
        this.barnesHutUpdateQueue = [];
        this.barnesHutNodesCache = [];
        this.barnesHutNodesCacheCurrent = 0;
        this.colorNodeBy = false;
        a.push("colorNodeBy");
        this.shapeNodeBy = false;
        a.push("shapeNodeBy");
        this.sizeNodeBy = false;
        a.push("sizeNodeBy");
        this.patternNodeBy = false;
        a.push("patternNodeBy");
        this.colorEdgeBy = false;
        a.push("colorEdgeBy");
        this.sizeEdgeBy = false;
        a.push("sizeEdgeBy");
        this.showNetworkCommunities = false;
        a.push("showNetworkCommunities");
        this.calculateNetworkCommunities = true;
        a.push("calculateNetworkCommunities");
        this.coordinateNetworkConvexHullCommunityColor = false;
        a.push("coordinateNetworkConvexHullCommunityColor");
        this.hullScale = 1.25;
        a.push("hullScale");
        this.networkCommunities = null;
        this.networkConvexHulls = [];
        this.genomeTicks = 50;
        a.push("genomeTicks");
        this.trackNameFontStyle = "";
        a.push("trackNameFontStyle");
        this.trackNameFontSize = 12;
        a.push("trackNameFontSize");
        this.trackNameFontColor = this.foreground;
        a.push("trackNameFontColor");
        this.trackFillColor = this.background;
        a.push("trackFillColor");
        this.trackDirColor = this.foreground;
        a.push("trackDirColor");
        this.subtracksMaxDefault = 8;
        a.push("subtracksMaxDefault");
        this.showFeatureNameThereshold = 20;
        a.push("showFeatureNameThereshold");
        this.featureNameFontStyle = "";
        a.push("featureNameFontStyle");
        this.featureNameFontSize = 12;
        a.push("featureNameFontSize");
        this.featureNameFontColor = this.foreground;
        a.push("featureNameFontColor");
        this.featureFillColor = this.background;
        a.push("featureFillColor");
        this.featureDirColor = this.foreground;
        a.push("featureDirColor");
        this.maxFeatureStringLen = 30;
        a.push("maxFeatureStringLen");
        this.featureWidthDefault = 3;
        a.push("featureWidthDefault");
        this.featureHeightDefault = 14;
        a.push("featureHeightDefault");
        this.featureSpliceStyle = "rect";
        a.push("featureSpliceStyle");
        this.featureTraceHeight = 40;
        a.push("featureTraceHeight");
        this.featureTraceTrim = 1;
        a.push("featureTraceTrim");
        this.featureTracesShow = true;
        a.push("featureTracesShow");
        this.featureQualityHeight = 14;
        a.push("featureQualityHeight");
        this.featureQualityValues = false;
        a.push("featureQualityValues");
        this.featureQualityShow = true;
        a.push("featureQualityShow");
        this.featureSignalToNoiseHeight = 14;
        a.push("featureSignalToNoiseHeight");
        this.featureSignalToNoiseValues = false;
        a.push("featureSignalToNoiseValues");
        this.featureSignalToNoiseShow = true;
        a.push("featureSignalToNoiseShow");
        this.featureCoordinateHeight = 14;
        a.push("featureCoordinateHeight");
        this.featureCoordinateShow = true;
        a.push("featureCoordinateShow");
        this.featureTranslateHeight = 14;
        a.push("featureTranslateHeight");
        this.featureTranslateShow = true;
        a.push("featureTranslateShow");
        this.featureTypeDefault = "line";
        a.push("featureTypeDefault");
        this.featureStaggered = false;
        a.push("featureStaggered");
        this.sequenceFontStyle = "";
        a.push("sequenceFontStyle");
        this.sequenceFontSize = 12;
        a.push("sequenceFontSize");
        this.sequenceFill = false;
        a.push("sequenceFill");
        this.sequenceGAPColor = "rgb(255,0,255)";
        a.push("sequenceGAPColor");
        this.sequenceAColor = "rgb(0,103,0)";
        a.push("sequenceAColor");
        this.sequenceBColor = "rgb(0,0,0)";
        a.push("sequenceBColor");
        this.sequenceCColor = "rgb(0,0,255)";
        a.push("sequenceCColor");
        this.sequenceDColor = "rgb(0,0,0)";
        a.push("sequenceDColor");
        this.sequenceEColor = "rgb(0,0,0)";
        a.push("sequenceEColor");
        this.sequenceFColor = "rgb(0,0,255)";
        a.push("sequenceFColor");
        this.sequenceGColor = "rgb(0,0,0)";
        a.push("sequenceGColor");
        this.sequenceHColor = "rgb(255,0,0)";
        a.push("sequenceHColor");
        this.sequenceIColor = "rgb(0,103,0)";
        a.push("sequenceIColor");
        this.sequenceKColor = "rgb(255,0,0)";
        a.push("sequenceKColor");
        this.sequenceLColor = "rgb(0,103,0)";
        a.push("sequenceLColor");
        this.sequenceMColor = "rgb(0,103,0)";
        a.push("sequenceMColor");
        this.sequenceNColor = "rgb(0,0,0)";
        a.push("sequenceNColor");
        this.sequencePColor = "rgb(255,165,0)";
        a.push("sequencePColor");
        this.sequenceQColor = "rgb(0,0,0)";
        a.push("sequenceQColor");
        this.sequenceRColor = "rgb(255,0,0)";
        a.push("sequenceRColor");
        this.sequenceSColor = "rgb(255,165,0)";
        a.push("sequenceSColor");
        this.sequenceTColor = "rgb(255,0,0)";
        a.push("sequenceTColor");
        this.sequenceUColor = "rgb(255,0,0)";
        a.push("sequenceUColor");
        this.sequenceVColor = "rgb(0,103,0)";
        a.push("sequenceVColor");
        this.sequenceWColor = "rgb(0,0,255)";
        a.push("sequenceWColor");
        this.sequenceXColor = "rgb(0,0,0)";
        a.push("sequenceXColor");
        this.sequenceYColor = "rgb(0,0,255)";
        a.push("sequenceYColor");
        this.sequenceZColor = "rgb(0,0,0)";
        a.push("sequenceZColor");
        this.sequenceStartColor = "rgb(0,204,0)";
        a.push("sequenceStartColor");
        this.sequenceEndColor = "rgb(255,0,0)";
        a.push("sequenceEndColor");
        this.wireColor = "rgba(204,204,204,0.1)";
        a.push("wireColor");
        this.periodTicksLabels = 5;
        a.push("periodTicksLabels");
        this.genomeResolution = "low";
        this.trackConfigurableProperties = ["name", "hideName", "hideFeatureNames", "type", "height", "fill", "outline", "hide", "connect", "subtracksMax", "highlight"];
        a.push("trackConfigurableProperties");
        this.featureConfigurableProperties = ["id", "name", "label", "hideName", "fill", "outline", "dir", "showDir", "connect", "offset", "data", "subtype", "quality", "signalToNoise", "coordinate", "sequence", "trace", "gaps", "translate", "hide", "counter"];
        a.push("featureConfigurableProperties");
        this.errors = [];
        this.debug = false;
        a.push("debug");
        this.verbose = false;
        a.push("verbose");
        this.offline = false;
        a.push("offline");
        this.showVersion = true;
        a.push("showVersion");
        this.showCode = false;
        a.push("showCode");
        this.codeType = "params";
        a.push("codeType");
        this.disableEvents = false;
        a.push("disableEvents");
        this.disableCode = false;
        a.push("disableCode");
        this.disableMenu = false;
        a.push("disableMenu");
        this.disableToolbar = false;
        a.push("disableToolbar");
        this.disableDataTable = false;
        a.push("disableDataTable");
        this.disableDataFilters = false;
        a.push("disableDataFilters");
        this.disableConfigurator = false;
        a.push("disableConfigurator");
        this.disableDataExplorer = false;
        a.push("disableDataExplorer");
        this.disableCanvas = false;
        a.push("disableCanvas");
        this.disableKeys = false;
        a.push("disableKeys");
        this.disableShowShortcuts = false;
        a.push("disableShowShortcuts");
        this.disablePlusMinusKeys = true;
        a.push("disablePlusMinusKeys");
        this.disableUndoRedoKeys = true;
        a.push("disableUndoRedoKeys");
        this.disableDocument = false;
        a.push("disableDocument");
        this.disableWindow = false;
        a.push("disableWindow");
        this.disableWheel = false;
        a.push("disableWheel");
        this.playable = false;
        a.push("playable");
        this.resizable = true;
        a.push("resizable");
        this.resizableX = true;
        a.push("resizableX");
        this.resizableY = true;
        a.push("resizableY");
        this.movable = true;
        a.push("movable");
        this.maxSubMenus = 22;
        a.push("maxSubMenus");
        this.showPrimaryMenus = false;
        a.push("showPrimaryMenus");
        this.maxItemMenuCheckbox = 10;
        a.push("maxItemMenuCheckbox");
        this.configuratorWidth = 250;
        a.push("configuratorWidth");
        this.configuratorExamplesSize = 500;
        this.alignConfiguratorExamples = false;
        a.push("alignConfiguratorExamples");
        this.showConfiguratorExamplesOnSelect = false;
        a.push("showConfiguratorExamplesOnSelect");
        this.resizeWidthOnLayout = true;
        a.push("resizeWidthOnLayout");
        this.resizeHeightOnLayout = true;
        a.push("resizeHeightOnLayout");
        this.skipClick = false;
        this.infoTimeOut = 3000;
        a.push("infoTimeOut");
        this.infoStartTime = new Date().getTime();
        this.infoTimeIn = 50;
        a.push("infoTimeIn");
        this.broadcast = true;
        a.push("broadcast");
        this.showMousePositionOnDrag = true;
        a.push("showMousePositionOnDrag");
        this.toolbarType = "under";
        a.push("toolbarType");
        this.lazyLoad = false;
        a.push("lazyLoad");
        this.showAnimation = false;
        a.push("showAnimation");
        this.showTransition = false;
        a.push("showTransition");
        this.transitionStep = 20;
        a.push("transitionStep");
        this.transitionStaggering = 10;
        a.push("transitionStaggering");
        this.transitionFunction = "easeInOutQuad";
        a.push("transitionFunction");
        this.weight = 1;
        this.scaleX = 1;
        this.scaleY = 1;
        this.translateX = 0;
        this.translateY = 0;
        this.offsetX = 0;
        this.offsetY = 0;
        this.layoutWidth = 0;
        this.layoutHeight = 0;
        this.layout = "1X1";
        this.layoutTopology = false;
        a.push("layoutTopology");
        this.layoutComb = false;
        this.layoutAdjust = false;
        a.push("layoutAdjust");
        this.layoutCollapse = false;
        a.push("layoutCollapse");
        this.layoutType = "wrap";
        a.push("layoutType");
        this.layoutRemoveEmpty = true;
        a.push("layoutRemoveEmpty");
        this.layoutCanvasCompartments = false;
        a.push("layoutCanvasCompartments");
        this.layoutBoxLabelColors = [];
        a.push("layoutBoxLabelColors");
        this.layoutBoxShow = true;
        a.push("layoutBoxShow");
        this.layoutLabelColor = "rgb(0,0,0)";
        a.push("layoutLabelColor");
        this.layoutLabelBoxThickness = 30;
        a.push("layoutLabelBoxThickness");
        this.layoutLabelShow = true;
        a.push("layoutLabelShow");
        this.layoutConfig = [];
        a.push("layoutConfig");
        this.layoutCurrent = 0;
        this.layoutAxis = 3;
        this.imageTimeOut = 1000;
        a.push("imageTimeOut");
        this.imageMaxTries = 10;
        a.push("imageMaxTries");
        this.imageTries = 0;
        this.remoteService = false;
        a.push("remoteService");
        this.remoteServiceType = "webService";
        a.push("remoteServiceType");
        this.remoteParams = {};
        a.push("remoteParams");
        this.remoteDirection = "next";
        a.push("remoteDirection");
        this.remoteAutoPlay = false;
        a.push("remoteAutoPlay");
        this.remoteAutoPlayDelay = 3000;
        a.push("remoteAutoPlayDelay");
        this.remoteParamOverride = true;
        a.push("remoteParamOverride");
        this.remoteTransitionEffect = "slide";
        a.push("remoteTransitionEffect");
        this.remoteAutoSize = true;
        a.push("remoteAutoSize");
        this.remoteParentId = "";
        this.remoteDataIndex = 0;
        this.remoteIds = [];
        this.remoteData = [];
        this.remoteUpdating = false;
        this.RdatasetsURL = "https://raw.githubusercontent.com/neuhausi/Rdatasets/master/";
        this.loadRDatasets = false;
        a.push("loadRDatasets");
        this.maxDataExplorerEntries = 10000;
        a.push("maxDataExplorerEntries");
        this.skipConfigurableProperties = true;
        a.push("skipConfigurableProperties");
        this.nodesProperties = [];
        a.push("nodesProperties");
        this.edgesProperties = [];
        a.push("edgesProperties");
        this.featuresProperties = [];
        a.push("featuresProperties");
        this.dataFilterWidth = 220;
        a.push("dataFilterWidth");
        this.filterType = "and";
        a.push("filterType");
        this.filterMode = "remove";
        a.push("filterMode");
        this.filterSkipNullKeys = false;
        a.push("filterSkipNullKeys");
        this.filterSkipNullValues = false;
        a.push("filterSkipNullValues");
        this.filterVarBy = {
            cases: [],
            comp: [],
            op: [],
            type: [],
            value: []
        };
        a.push("filterVarBy");
        this.filterSmpBy = {
            cases: [],
            comp: [],
            op: [],
            type: [],
            value: []
        };
        a.push("filterSmpBy");
        this.filterNodeBy = {
            cases: [],
            comp: [],
            op: [],
            type: [],
            value: []
        };
        a.push("filterNodeBy");
        this.filterEdgeBy = {
            cases: [],
            comp: [],
            op: [],
            type: [],
            value: []
        };
        a.push("filterEdgeBy");
        this.filterFeatureBy = {
            cases: [],
            comp: [],
            op: [],
            type: [],
            value: []
        };
        a.push("filterFeatureBy");
        this.filterDataBy = {
            cases: [],
            comp: [],
            op: [],
            type: [],
            value: []
        };
        a.push("filterDataBy");
        this.filtersExposed = [];
        a.push("filtersExposed");
        this.showDataTable = false;
        a.push("showDataTable");
        this.dataTableTransposed = true;
        a.push("dataTableTransposed");
        this.maxRows = 10;
        a.push("maxRows");
        this.maxCols = 6;
        a.push("maxCols");
        this.colWidth = 100;
        a.push("colWidth");
        this.rowHeight = 18;
        a.push("rowHeight");
        this.dataTableFontSize = 12;
        a.push("dataTableFontSize");
        this.dataTableFontFamily = "unset";
        a.push("dataTableFontFamily");
        this.refresehDataTableOnDraw = false;
        a.push("refresehDataTableOnDraw");
        this.showDataTableOnSelect = false;
        a.push("showDataTableOnSelect");
        this.networkShowDataTable = "nodes";
        a.push("networkShowDataTable");
        this.colorDataTable = true;
        a.push("colorDataTable");
        this.backgroundDataTable = "rgba(255,255,255,0.95)";
        a.push("backgroundDataTable");
        this.colorDataTableTransparency = 0.5;
        a.push("colorDataTableTransparency");
        this.dataTableStyle = false;
        a.push("dataTableStyle");
        this.startCol = 0;
        this.startRow = 0;
        this.totalCols = null;
        this.totalRows = null;
        this.dataTableColumnWidth = [];
        this.dataTableRowHeight = []
    };
    this.updateTheme = function(a) {
        for (var d in a) {
            if (d == "conditional") {
                for (var e in a[d]) {
                    if (CanvasXpress.graphTypes[e].includes(this.graphType)) {
                        for (var b in a[d][e]) {
                            this[b] = a[d][e][b]
                        }
                    }
                }
            } else {
                this[d] = a[d]
            }
        }
    };
    this.setTheme = function(d) {
        if (!d) {
            d = CanvasXpress.stack[this.target] ? CanvasXpress.stack[this.target].config : false
        }
        if (d && d.hasOwnProperty("theme") && d.theme) {
            var a = d.theme.toLowerCase().replace(" ", "");
            var b = "none";
            switch (a) {
                case "cx":
                case "canvasxpress":
                    b = "cx";
                    break;
                case "paultol":
                    b = "paulTol";
                    break;
                case "wallstreetjournal":
                case "wallstreet":
                    b = "wallStreetJournal";
                    break;
                case "blackandwhite":
                    b = "blackAndWhite";
                    break;
                case "lastairbenderfire":
                    b = "lastAirBender";
                    this.colorScheme = "LastAirBenderFire";
                    break;
                case "lastairbenderair":
                    b = "lastAirBender";
                    this.colorScheme = "LastAirBenderAir";
                    break;
                case "lastairbenderwater":
                    b = "lastAirBender";
                    this.colorScheme = "LastAirBenderWater";
                    break;
                case "lastairbenderearth":
                    b = "lastAirBender";
                    this.colorScheme = "LastAirBenderEarth";
                    break;
                case "gameofthronestargaryen":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesTargaryen";
                    break;
                case "gameofthronesstark":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesStark";
                    break;
                case "gameofthronesstannis":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesStannis";
                    break;
                case "gameofthroneslannister":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesLannister";
                    break;
                case "gameofthronestyrell":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesTyrell";
                    break;
                case "gameofthronesmartell":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesMartell";
                    break;
                case "gameofthronestully":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesTully";
                    break;
                case "gameofthronesgreyjoy":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesGreyjoy";
                    break;
                case "gameofthronesmanderly":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesManderly";
                    break;
                case "gameofthronesarryn":
                    b = "gameOfThrones";
                    this.colorScheme = "GameOfThronesArryn";
                    break;
                default:
                    b = a;
                    break
            }
            if (CanvasXpress.themes.hasOwnProperty(b)) {
                this.updateTheme(CanvasXpress.themes[b])
            }
        }
    };
    this.resetInitialFontSize = function() {
        var a = ["fontSize", "titleFontSize", "subtitleFontSize", "smpTitleFontSize", "smpLabelFontSize", "varTitleFontSize", "varLabelFontSize", "overlayFontSize", "legendFontSize", "decorationFontSize", "axisTickFontSize", "axisTitleFontSize", "nodeFontSize", "trackNameFontSize", "featureNameFontSize", "sequenceFontSize"];
        for (var b = 0; b < a.length; b++) {
            this[a[b]] = Number(CanvasXpress.doc.P[a[b]].D)
        }
        this.setInitialFonts()
    };
    this.setInitialFonts = function() {
        this.font = this.fontStyle + " " + this.fontSize + "px " + this.fontName;
        this.titleFont = this.titleFontStyle + " " + this.titleFontSize + "px " + this.fontName;
        this.subtitleFont = this.subtitleFontStyle + " " + this.subtitleFontSize + "px " + this.fontName;
        this.citationFont = this.citationFontStyle + " " + this.citationFontSize + "px " + this.fontName;
        this.smpTitleFont = this.smpTitleFontStyle + " " + this.smpTitleFontSize + "px " + this.fontName;
        this.smpLabelFont = this.smpLabelFontStyle + " " + this.smpLabelFontSize + "px " + this.fontName;
        this.varTitleFont = this.varTitleFontStyle + " " + this.varTitleFontSize + "px " + this.fontName;
        this.varLabelFont = this.varLabelFontStyle + " " + this.varLabelFontSize + "px " + this.fontName;
        this.overlayFont = this.overlayFontStyle + " " + this.overlayFontSize + "px " + this.fontName;
        this.legendFont = this.legendFontStyle + " " + this.legendFontSize + "px " + this.fontName;
        this.decorationFont = this.decorationFontStyle + " " + this.decorationFontSize + "px " + this.fontName;
        this.axisTickFont = this.axisTickFontStyle + " " + this.axisTickFontSize + "px " + this.fontName;
        this.axisTitleFont = this.axisTitleFontStyle + " " + this.axisTitleFontSize + "px " + this.fontName;
        this.motionCurrentFont = this.motionCurrentFontStyle + " " + this.motionCurrentFontSize + "px " + this.fontName;
        this.nodeFont = this.nodeFontStyle + " " + this.nodeFontSize + "px " + this.fontName;
        this.trackNameFont = this.trackNameFontStyle + " " + this.trackNameFontSize + "px " + this.fontName;
        this.featureNameFont = this.featureNameFontStyle + " " + this.featureNameFontSize + "px " + this.fontName;
        this.sequenceFont = this.sequenceFontStyle + " " + this.sequenceFontSize + "px " + this.fontName
    };
    this.setInitialConfig = function() {
        if (this.meta.config.user) {
            delete(this.meta.config.user.skipRender);
            for (var a in this.meta.config.user) {
                if (this.isCreateHistogram) {
                    if (a == "setMaxX" || a == "setMinX") {
                        continue
                    }
                }
                if (this.isPivot) {
                    if (a == "groupingFactors") {
                        continue
                    }
                }
                if (CanvasXpress.doc.P[a] && CanvasXpress.doc.P[a].hasOwnProperty("T")) {
                    if (CanvasXpress.doc.P[a].T == "integer" || CanvasXpress.doc.P[a].T == "float") {
                        this.meta.config.user[a] = this.meta.config.user[a] === null ? null : Number(this.meta.config.user[a])
                    }
                    this[a] = this.meta.config.user[a]
                } else {
                    this[a] = this.meta.config.user[a]
                }
            }
        }
    };
    this.resetConfig = function(b) {
        var d = {};
        if (b) {
            for (var c = 0; c < b.length; c++) {
                d[b[c]] = this[b[c]]
            }
        }
        this.setConfigDefaults();
        for (var c in d) {
            this[c] = d[c]
        }
    };
    this.updateConfig = function(b) {
        if (b) {
            this.meta.config.user = b;
            for (var a in b) {
                this[a] = b[a]
            }
        }
    };
    this.getConfig = function() {
        var g = this;
        var a = {};
        var b = CanvasXpress.config.sort();
        var m = function(c) {
            if (g.theme && CanvasXpress.themes[g.theme] && CanvasXpress.themes[g.theme].hasOwnProperty(c)) {
                return CanvasXpress.themes[g.theme][c]
            } else {
                return CanvasXpress.doc.P[c].D
            }
        };
        var p = {
            shapes: true,
            images: true,
            randomSeed: true,
            xAxisValues: true,
            xAxisValuesRaw: true,
            xAxisMinorValues: true,
            yAxisValues: true,
            yAxisValuesRaw: true,
            yAxisMinorValues: true,
            zAxisValues: true,
            zAxisValuesRaw: true,
            zAxisMinorValues: true,
            trackConfigurableProperties: true,
            featureConfigurableProperties: true,
            remoteServiceType: true
        };
        if (this.isTransformedData) {
            a.isTransformedData = this.isTransformedData
        }
        for (var f = 0; f < b.length; f++) {
            var e = b[f];
            if (e.match(/FontSize$/)) {
                continue
            }
            if (CanvasXpress.doc.P[e] && CanvasXpress.doc.P[e].hasOwnProperty("D")) {
                var h = m(e);
                if (p[e]) {
                    continue
                }
                var n = g[e] === undefined ? false : g[e];
                if (typeof(n) == "object") {
                    if (h == "[]") {
                        h = []
                    }
                    if (h == "{}") {
                        h = {}
                    }
                    if (n === null) {
                        if (h != "null") {
                            a[e] = n
                        }
                    } else {
                        if (e == "sizes") {
                            if (!this.isSameObject(n, h.map(Number))) {
                                a[e] = n
                            }
                        } else {
                            if (e == "colorSpectrum" || e == "colors") {
                                var q = [];
                                for (var l = 0; l < n.length; l++) {
                                    q.push(this.rgbToHex(n[l]).toLowerCase())
                                }
                                if (!this.isSameObject(q, h)) {
                                    a[e] = n
                                }
                            } else {
                                if (e.match("filter") && e != "filtersExposed") {
                                    if (!this.isSameObject(n, this.parseJSON(h.replace(/'/g, '"')))) {
                                        a[e] = n
                                    }
                                } else {
                                    if (!this.isSameObject(n, h)) {
                                        a[e] = n
                                    }
                                }
                            }
                        }
                    }
                } else {
                    if (h.toString().match(/false|true|null/)) {
                        if (e == "summaryType" && n == "raw") {
                            continue
                        } else {
                            if (n.toString() != h.toString()) {
                                a[e] = n
                            }
                        }
                    } else {
                        if (n != h) {
                            a[e] = n
                        }
                    }
                }
            }
        }
        if (a.backgroundImage && a.backgroundImage.match(/javascript:\/\//)) {
            a.backgroundImageSrc = btoa(CanvasXpress.cacheImages[a.backgroundImage.split("//")[1]].replace("data:image/png;base64,", ""))
        }
        return a
    };
    this.getUserConfig = function() {
        return this.meta.config.user
    };
    this.getNewCanvasContext = function(b) {
        var a = this.$(b);
        if (!a || a.tagName.toLowerCase() != "canvas") {
            a = this.$cX("canvas", {
                id: b
            });
            window.body.appendChild(a)
        }
        return this.get2DCanvasContext(a)
    };
    this.setCanvasPixelRatio = function() {
        var b = window.devicePixelRatio || 1;
        var a = this.get2DCanvasContext(this.$cX("canvas"));
        var c = a.webkitBackingStorePixelRatio || a.mozBackingStorePixelRatio || a.msBackingStorePixelRatio || a.oBackingStorePixelRatio || a.backingStorePixelRatio || 1;
        this.meta.canvas.canvasPixelRatio = b / c
    };
    this.setDPI = function(b, c) {
        b.style.width = b.style.width || b.width + "px";
        b.style.height = b.style.height || b.height + "px";
        var g = c / 96;
        var a = parseFloat(b.style.width);
        var h = parseFloat(b.style.height);
        var d = b.width / a;
        var f = g / d;
        var e = b.cloneNode(false);
        this.get2DCanvasContext(e).drawImage(b, 0, 0);
        var i = this.get2DCanvasContext(b);
        b.width = Math.ceil(a * g);
        b.height = Math.ceil(h * g);
        i.setTransform(f, 0, 0, f, 0, 0);
        i.drawImage(e, 0, 0);
        i.setTransform(g, 0, 0, g, 0, 0)
    };
    this.setCanvas = function() {
        var a = this.$(this.target);
        if (a) {
            this.setCanvasPixelRatio();
            this.checkCanvasXpressOrgSite();
            this.meta.canvas.ctx = this.get2DCanvasContext(a);
            this.meta.canvas.ctx.setTransform(this.meta.canvas.canvasPixelRatio, 0, 0, this.meta.canvas.canvasPixelRatio, 0, 0)
        }
    };
    this.get2DCanvasContext = function(a) {
        return a.getContext("2d")
    };
    this.getCanvasContext = function() {
        var a = this.isSVG ? this.meta.canvas.SVG : this.isHighlightCanvas ? this.meta.canvas.ctx2 : this.meta.canvas.ctx;
        this.currentCanvasContext = a.canvas.id;
        return a
    };
    this.checkCanvasXpressOrgSite = function() {
        var f = new RegExp("/www.canvasxpress.org/dist/");
        var b = window.document.getElementsByTagName("head")[0];
        for (var a = 0; a < b.childNodes.length; a++) {
            var d = b.childNodes[a];
            if (d.type == "text/javascript" && f.test(d.src)) {
                CanvasXpress.factory.siteSrc = true
            }
        }
    };
    this.inititalizeConfig = function(a) {
        CanvasXpress.config = [];
        this.setConfigDefaults();
        if (a && a.graphType) {
            this.graphType = a.graphType
        }
        this.setTheme(a);
        if (a) {
            for (var c = 0; c < CanvasXpress.config.length; c++) {
                var e = CanvasXpress.config[c];
                var b = CanvasXpress.doc.P[e] ? CanvasXpress.doc.P[e].T : false;
                if (a.hasOwnProperty(e)) {
                    if (b == "array") {
                        if (a[e] instanceof Array) {
                            this[e] = a[e]
                        } else {
                            this[e] = [a[e]];
                            a[e] = [a[e]]
                        }
                    } else {
                        this[e] = a[e]
                    }
                }
            }
        }
        this.setInitialFonts();
        for (var d in this.url) {
            if (this.hasOwnProperty(d)) {
                this[d] = this.url[d]
            }
        }
        this.setCanvas();
        CanvasXpress.system.isR = this.isR;
        CanvasXpress.system.isHTMLWidgets = typeof HTMLWidgets != "undefined";
        CanvasXpress.system.isShiny = typeof window.Shiny !== "undefined" && !!window.Shiny.outputBindings;
        CanvasXpress.system.isRViewer = /\bviewer_pane=1\b/.test(window.location);
        CanvasXpress.system.isRConsole = CanvasXpress.system.isHTMLWidgets && !CanvasXpress.system.isShiny && !CanvasXpress.system.isRViewer;
        CanvasXpress.system.isNode = typeof exports === "object" && typeof module !== "undefined";
        if (CanvasXpress.system.isShiny) {
            this.disableUndoRedoKeys = true
        }
    }
};
CanvasXpress.prototype.initDate = function() {
    var a = function() {
        var b = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
            c = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
            e = /[^-+\dA-Z]/g,
            d = function(g, f) {
                g = String(g);
                f = f || 2;
                while (g.length < f) {
                    g = "0" + g
                }
                return g
            };
        return function(j, w, r) {
            var h = a;
            if (arguments.length == 1 && Object.prototype.toString.call(j) == "[object String]" && !/\d/.test(j)) {
                w = j;
                j = undefined
            }
            j = j ? new Date(j) : new Date;
            if (isNaN(j)) {
                throw SyntaxError("invalid date")
            }
            w = String(h.masks[w] || w || h.masks["default"]);
            if (w.slice(0, 4) == "UTC:") {
                w = w.slice(4);
                r = true
            }
            var u = r ? "getUTC" : "get",
                n = j[u + "Date"](),
                f = j[u + "Day"](),
                k = j[u + "Month"](),
                q = j[u + "FullYear"](),
                t = j[u + "Hours"](),
                l = j[u + "Minutes"](),
                v = j[u + "Seconds"](),
                p = j[u + "Milliseconds"](),
                g = r ? 0 : j.getTimezoneOffset(),
                i = {
                    d: n,
                    dd: d(n),
                    ddd: h.i18n.dayNames[f],
                    dddd: h.i18n.dayNames[f + 7],
                    m: k + 1,
                    mm: d(k + 1),
                    mmm: h.i18n.monthNames[k],
                    mmmm: h.i18n.monthNames[k + 12],
                    yy: String(q).slice(2),
                    yyyy: q,
                    h: t % 12 || 12,
                    hh: d(t % 12 || 12),
                    H: t,
                    HH: d(t),
                    M: l,
                    MM: d(l),
                    s: v,
                    ss: d(v),
                    l: d(p, 3),
                    L: d(p > 99 ? Math.round(p / 10) : p),
                    t: t < 12 ? "a" : "p",
                    tt: t < 12 ? "am" : "pm",
                    T: t < 12 ? "A" : "P",
                    TT: t < 12 ? "AM" : "PM",
                    Z: r ? "UTC" : (String(j).match(c) || [""]).pop().replace(e, ""),
                    o: (g > 0 ? "-" : "+") + d(Math.floor(Math.abs(g) / 60) * 100 + Math.abs(g) % 60, 4),
                    S: ["th", "st", "nd", "rd"][n % 10 > 3 ? 0 : (n % 100 - n % 10 != 10) * n % 10]
                };
            return w.replace(b, function(m) {
                return m in i ? i[m] : m.slice(1, m.length - 1)
            })
        }
    }();
    a.masks = {
        "default": "ddd mmm dd yyyy HH:MM:ss",
        shortDate: "m/d/yy",
        mediumDate: "mmm d, yyyy",
        longDate: "mmmm d, yyyy",
        fullDate: "dddd, mmmm d, yyyy",
        shortTime: "h:MM TT",
        mediumTime: "h:MM:ss TT",
        longTime: "h:MM:ss TT Z",
        isoDate: "yyyy-mm-dd",
        isoTime: "HH:MM:ss",
        isoDateTime: "yyyy-mm-dd'T'HH:MM:ss",
        isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'",
        year: "yyyy",
        month: "mmmm",
        day: "dddd",
        hour: "HH",
        minute: "MM",
        second: "ss"
    };
    a.i18n = {
        dayNames: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
        monthNames: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"]
    };
    Date.prototype.format = function(b, c) {
        return a(this, b, c)
    };
    this.isValidDateFormat = function(b) {
        return !isNaN(new Date(b))
    };
    this.dateFormat = a
};
CanvasXpress.prototype.initText = function() {
    this.setTextShadow = function(a) {
        if (this.showTextShadow) {
            if (a) {
                this.meta.canvas.ctx.shadowOffsetX = this.shadowOffsetX;
                this.meta.canvas.ctx.shadowOffsetY = this.shadowOffsetY;
                this.meta.canvas.ctx.shadowBlur = this.shadowBlur;
                this.meta.canvas.ctx.shadowColor = this.shadowColor
            } else {
                this.meta.canvas.ctx.shadowOffsetX = 0;
                this.meta.canvas.ctx.shadowOffsetY = 0;
                this.meta.canvas.ctx.shadowBlur = 0;
                this.meta.canvas.ctx.shadowColor = this.background
            }
        }
    };
    this.getArcTextArea = function(C, A, z, a, D, u, p, v, j, w, d, g, B) {
        if (C == undefined) {
            C = ""
        }
        var q = ["poly"];
        var o = this.getFontPt(p);
        var j = this.measureText(C, p, B) * (Math.PI * 0.5) / a;
        D = (D + (u / 2)) - (j / 2) % (Math.PI * 2);
        u = D + j;
        var n = this.traceArc1(A, z, a, D, u, true);
        for (var k = 0; k < n.length; k++) {
            q.push(n[k][0], n[k][1])
        }
        n = this.traceArc1(A, z, a - o, D, u);
        for (var k = 0; k < n.length; k++) {
            q.push(n[k][0], n[k][1])
        }
        if (this.graphType == "Network") {
            return this.preScaleNetwork && !this.isAnimation ? q : this.adjustNetworkObjects(q)
        } else {
            return q
        }
    };
    this.drawArcText = function(B, z, w, a, C, p, o, q, j, v, g, h, A) {
        if (B == undefined) {
            B = ""
        }
        if (!A) {
            A = this.getCanvasContext()
        }
        if (B == null) {
            return
        }
        if (!A) {
            if (this.debug) {
                alert("Dude, there is no canvas")
            }
            return
        }
        if (isNaN(z) || isNaN(w)) {
            if (this.debug) {
                alert("Not a valid coordinate (" + z + ", " + w + ") to draw " + B)
            }
            return
        }
        if (!h && !isNaN(B)) {
            B = this.formatNumber(B)
        }
        B = B.toString().replace("\x00", "");
        if (!z) {
            z = 0
        }
        if (!w) {
            w = 0
        }
        if (!o) {
            o = this.font
        }
        if (!q) {
            q = this.foreground
        }
        if (!j) {
            j = this.align
        }
        if (!v) {
            v = this.baseline
        }
        this.saveCanvas(A);
        A.strokeStyle = this.isArray(q) ? q[0] : q;
        A.fillStyle = this.isArray(q) ? q[0] : q;
        A.font = o;
        A.textAlign = j;
        A.textBaseline = v;
        this.setTextShadow(true);
        var d = j == "right" ? 1 : -1;
        var u = this.getFontPt(o);
        if (((["left", "center"].indexOf(j) > -1) && g) || (j == "right" && !g)) {
            B = B.split("").reverse().join("");
            if (this.isArray(q)) {
                q = q.reverse()
            }
        }
        A.translate(z, w);
        C += (Math.PI * !g);
        C += (Math.PI / 2) + (p / 2);
        if (j == "center") {
            for (var k = 0; k < B.length; k++) {
                var n = this.measureText(B[k], o, A);
                C += ((n + (k == B.length - 1 ? 0 : this.circularLetterSeparationFactor)) / (a - u)) / 2 * -d
            }
        }
        p = C;
        this.rotateCanvas(C, A);
        for (var k = 0; k < B.length; k++) {
            var n = this.measureText(B[k], o, A);
            p += (n / 2) / (a - u) * d;
            this.rotateCanvas((n / 2) / (a - u) * d, A);
            if (this.isArray(q)) {
                A.strokeStyle = q[k];
                A.fillStyle = q[k]
            }
            A.fillText(B[k], 0, (g ? 1 : -1) * (0 - a + u / 2));
            p += (n / 2 + this.circularLetterSeparationFactor) / (a - u) * d;
            this.rotateCanvas((n / 2 + this.circularLetterSeparationFactor) / (a - u) * d), A
        }
        this.restoreCanvas(A);
        this.setTextShadow(false)
    };
    this.getTextMultipleArea = function(o, n, k, A, B, E, D, g, q, p, j) {
        if (o == undefined) {
            o = ""
        }
        var r = o.split(/\n/);
        var w = this.getFontPt(A);
        var C = [];
        var F = k + (r % 2 ? 0 : w / 2) - (r.length * w / 2);
        for (var u = 0; u < r.length; u++) {
            C.push(this.getTextArea(r[u], n, F, A, B, E, D, g, q, p, j));
            F += w
        }
        var z = C[0][1];
        var e = C[0][2];
        var v = C[0][3];
        var d = C[0][4];
        for (var u = 1; u < C.length; u++) {
            z = Math.min(z, C[u][1]);
            e = Math.min(e, C[u][2]);
            v = Math.max(v, C[u][3]);
            d = Math.max(d, C[u][4])
        }
        return [C[0][0], z, e, v, d]
    };
    this.drawTextMultiple = function(B, w, r, o, q, v, u, e, h, C, z, A) {
        var j = B.split(/\n/);
        var d = o;
        if (!d) {
            d = this.font
        }
        var n = this.getFontPt(d);
        var p = r + (j % 2 ? 0 : n / 2) - (j.length * n / 2);
        for (var k = 0; k < j.length; k++) {
            this.drawText(j[k], w, p, d, q, v, u, e, h, C, z, A);
            p += n;
            if (e && e < 90) {
                w += n;
                p -= n
            }
        }
    };
    this.getTextArea = function(p, n, l, C, D, F, E, g, r, q, k, u) {
        var j = this;
        var v = function(b) {
            b.shift();
            var a = ["poly"];
            a = a.concat(j.rotatePoint(b[0], b[1], n, l, g));
            a = a.concat(j.rotatePoint(b[2], b[1], n, l, g));
            a = a.concat(j.rotatePoint(b[2], b[3], n, l, g));
            a = a.concat(j.rotatePoint(b[0], b[3], n, l, g));
            return a
        };
        if (p == undefined) {
            p = ""
        }
        if (k) {
            if (n < this.marginLeft + this.offsetX + this.left || n > this.marginLeft + this.offsetX + this.left + this.x) {
                return
            }
            if (l < this.marginTop + this.offsetY + this.top || l > this.marginTop + this.offsetY + this.top + this.y) {
                return
            }
        }
        if (this.isMultipleLines(p)) {
            return this.getTextMultipleArea(p, n, l, C, D, F, E, g, r, q, k)
        }
        var G = [];
        var o = this.measureText(p, C, u);
        var z = this.getFontPt(C);
        var B, e, A, d;
        var i = 0;
        if (r) {
            while (o > r && i < 10) {
                p = p.substring(0, p.length - 1);
                o = this.measureText(p, C, u);
                i++
            }
        }
        if (F == "left") {
            B = n;
            A = B + o
        } else {
            if (F == "right") {
                B = n - o;
                A = n
            } else {
                B = n - (o / 2);
                A = n + (o / 2)
            }
        }
        if (E == "top") {
            e = l;
            d = e + z
        } else {
            if (E == "bottom") {
                e = l - z;
                d = l
            } else {
                e = l - (z / 2);
                d = l + (z / 2)
            }
        }
        G = ["rect", B, e, A, d];
        G = g ? v(G) : G;
        if (this.graphType == "Network") {
            return this.preScaleNetwork && !this.isAnimation ? G : this.adjustNetworkObjects(G)
        } else {
            return G
        }
    };
    this.drawText = function(r, n, j, h, i, l, k, d, e, u, p, q) {
        if (r == undefined) {
            r = ""
        }
        if (!q) {
            q = this.getCanvasContext()
        }
        var g = 0;
        if (r == null) {
            return
        }
        if (this.isMultipleLines(r)) {
            return this.drawTextMultiple(r, n, j, h, i, l, k, d, e, u, p, q)
        }
        if (!q) {
            if (this.debug) {
                alert("Dude, there is no canvas")
            }
            return
        }
        if (isNaN(n) || isNaN(j)) {
            if (this.debug) {
                alert("Not a valid coordinate (" + n + ", " + j + ") to draw " + r)
            }
            return
        }
        if (p) {
            if (n < this.marginLeft + this.offsetX + this.left || n > this.marginLeft + this.offsetX + this.left + this.x) {
                return
            }
            if (j < this.marginTop + this.offsetY + this.top || j > this.marginTop + this.offsetY + this.top + this.y) {
                return
            }
        }
        if (!n) {
            n = 0
        }
        if (!j) {
            j = 0
        }
        if (!h) {
            h = this.font
        }
        if (!i) {
            i = this.foreground
        }
        if (!l) {
            l = this.align
        }
        if (!k) {
            k = this.baseline
        }
        var o = this.measureText(r, h, q);
        if (e) {
            while (o > e && g < 10) {
                r = r.substring(0, r.length - 1);
                o = this.measureText(r, h, q);
                g++
            }
        }
        this.saveCanvas(q);
        q.strokeStyle = i;
        q.fillStyle = i;
        q.font = h;
        this.translateCanvas(n, j, q);
        q.textAlign = l;
        q.textBaseline = k;
        this.setTextShadow(true);
        if (d) {
            this.rotateCanvas(d, q)
        }
        r = r.toString().replace("\x00", "").replace("u0000", "");
        if (u) {
            q.strokeText(r, 0, 0)
        } else {
            q.fillText(r, 0, 0)
        }
        this.restoreCanvas(q);
        this.setTextShadow(false)
    };
    this.isMultipleLines = function(b) {
        var a = b.toString().split(/\n/);
        return a.length - 1
    };
    this.capitalize = function(a) {
        if (a) {
            return a.charAt(0).toUpperCase() + a.slice(1)
        }
    };
    this.decapitalize = function(a) {
        if (a) {
            return a.charAt(0).toLowerCase() + a.slice(1)
        }
    };
    this.measureTextMultiple = function(e, g, c) {
        var b = e.split(/\n/);
        var a = 0;
        if (!c) {
            c = this.getCanvasContext();
            if (!c) {
                return 0
            }
        }
        if (!g) {
            g = this.font
        }
        c.font = g;
        for (var d = 0; d < b.length; d++) {
            a = Math.max(a, c.measureText(b[d]).width)
        }
        return a
    };
    this.measureText = function(b, c, a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        if (!b || !a) {
            return 0
        }
        b = b.toString();
        if (!c) {
            c = this.font
        }
        if (!CanvasXpress.cacheText[c]) {
            CanvasXpress.cacheText[c] = {}
        }
        if (!CanvasXpress.cacheText[c][b]) {
            a.font = c;
            if (this.isMultipleLines(b)) {
                CanvasXpress.cacheText[c][b] = this.measureTextMultiple(b, c, a)
            } else {
                CanvasXpress.cacheText[c][b] = a.measureText(b).width
            }
        }
        return CanvasXpress.cacheText[c][b]
    };
    this.measureTextWidth = function(b, c) {
        var a = this.isMultipleLines(b);
        if (a > 0) {
            return (this.getFontPt(c) + this.margin) * (a + 1)
        } else {
            return this.getFontPt(c)
        }
    };
    this.scaleTextToFont = function(c, g, b, d, a) {
        var e = this.fontStyle + " " + g + "px " + this.fontName;
        if (c) {
            while (this.measureText(c, e, a) > b && g >= this.minTextSize) {
                g -= 2;
                e = this.fontStyle + " " + g + "px " + this.fontName
            }
            if (d) {
                while (parseInt(g / 1.33) > d - 2) {
                    g--
                }
                e = this.fontStyle + " " + g + "px " + this.fontName
            }
        }
        return e
    };
    this.getFontPt = function(a) {
        return a ? Math.max(1, parseInt(a.toString().match(/[\-\d]+/)[0])) : 1
    };
    this.scaleTextToSize = function(a) {
        var d = this.scaleTextConstantMult;
        if (!a) {
            a = 1
        }
        return Math.ceil(1 / Math.sqrt(a) * d)
    };
    this.wrapText = function(c, b) {
        var a = new RegExp("(?![^\\n]{1," + b + "}$)([^\\n]{1," + b + "})([\\s|-])", "g");
        return c.toString().replace(a, "$1$2\n").replace(" \n", "\n")
    };
    this.scaleFont = function(a, b) {
        var d = this.getFontPt(a);
        var c = Math.max(1, parseInt(d * b));
        return a.replace(d + "px", c + "px")
    };
    this.formatNumber = function(f, e) {
        var c = (!isNaN(e) && parseInt(e != null ? e : 10) > 0) ? parseFloat(f).toFixed(parseInt(e != null ? e : 10)) : Number(f);
        var b = parseFloat(c);
        if (Math.abs(b) < 0.0001 || Math.abs(b) > 99999 || b.toString().length >= 8) {
            var a = b.toExponential(2).toString().replace("e+0", "").replace(".00", "").replace(/(\.[0-9])(0)/, "$1");
            if (a.match(/e\+1$/) || a.match(/e\+2$/) || a.match(/e\-1$/)) {
                a = (a * 1).toString()
            }
            return a
        } else {
            return b.toString()
        }
    };
    this.getMaxtTextBySampling = function(b, h) {
        var c = {};
        var f = [];
        var g = [];
        for (var e = 0; e < b.length; e++) {
            var d = b[e] != null ? b[e].toString() : "";
            if (!c.hasOwnProperty(d)) {
                c[d] = true;
                f.push([d, d.length])
            }
        }
        f.sort(function(j, i) {
            return j[1] < i[1] ? -1 : j[1] > i[1] ? 1 : 0
        });
        if (!h) {
            h = 10
        }
        if (f.length < h) {
            h = f.length
        }
        for (var e = 0; e < h; e++) {
            g.push(f[e][0])
        }
        return this.getMaxText(g)
    };
    this.getMaxText = function(e, j, d) {
        var h = "";
        var b = 0;
        if (e && e.length > 0) {
            if (!j) {
                j = this.font
            }
            for (var g = 0; g < e.length; g++) {
                if (e[g]) {
                    var k = this.measureText(e[g].toString(), j, d);
                    if (k > b) {
                        h = e[g].toString();
                        b = k
                    }
                }
            }
        }
        return h
    };
    this.shortenText = function(c, b, a) {
        if (c == null) {
            return ""
        }
        c = c.toString();
        if (!c) {
            return ""
        }
        if (a && c.length > b) {
            return c.substring(0, Math.max(parseInt(a / b) - 2, 1)) + ".."
        } else {
            if (c.length <= b) {
                return c
            } else {
                return c.substring(0, b - 3) + "..."
            }
        }
    };
    this.convertToNumber = function(a) {
        if (!isNaN(a)) {
            return parseFloat(a)
        } else {
            return a
        }
    };
    this.stringToHex = function(c) {
        var b = "";
        for (var a = 0; a < c.length; a++) {
            b += "" + c.charCodeAt(a).toString(16)
        }
        return b
    };
    this.hexToString = function(b) {
        var c = "";
        for (var a = 0; a < b.length; a += 2) {
            c += String.fromCharCode(parseInt(b.substr(a, 2), 16))
        }
        return c
    };
    this.sprintf = function() {
        var k = function(c, a) {
            for (var f = []; a > 0; f[--a] = c) {}
            return (f.join(""))
        };
        var g = 0,
            n, h = arguments[g++],
            d = [],
            e, b, j, l;
        while (h) {
            if (e = /^[^\x25]+/.exec(h)) {
                d.push(e[0])
            } else {
                if (e = /^\x25{2}/.exec(h)) {
                    d.push("%")
                } else {
                    if (e = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-gosuxX])/.exec(h)) {
                        if (((n = arguments[e[1] || g++]) == null) || (n == undefined)) {
                            throw ("Too few arguments.")
                        }
                        if (/[^s]/.test(e[7]) && (typeof(n) != "number")) {
                            throw ("Expecting number but found " + typeof(n))
                        }
                        switch (e[7]) {
                            case "b":
                                n = n.toString(2);
                                break;
                            case "c":
                                n = String.fromCharCode(n);
                                break;
                            case "d":
                                n = parseInt(n);
                                break;
                            case "e":
                                n = e[6] ? n.toExponential(e[6]) : n.toExponential();
                                break;
                            case "f":
                                n = e[6] ? parseFloat(n).toFixed(e[6]) : parseFloat(n);
                                break;
                            case "g":
                                n = e[6] ? String(Number(n).toPrecision(e[6])) : parseFloat(n);
                                break;
                            case "o":
                                n = n.toString(8);
                                break;
                            case "s":
                                n = ((n = String(n)) && e[6] ? n.substring(0, e[6]) : n);
                                break;
                            case "u":
                                n = Math.abs(n);
                                break;
                            case "x":
                                n = n.toString(16);
                                break;
                            case "X":
                                n = n.toString(16).toUpperCase();
                                break
                        }
                        n = (/[def]/.test(e[7]) && e[2] && n > 0 ? "+" + n : n);
                        j = e[3] ? e[3] == "0" ? "0" : e[3].charAt(1) : " ";
                        l = e[5] - String(n).length;
                        b = e[5] ? k(j, l) : "";
                        d.push(e[4] ? n + b : b + n)
                    } else {
                        throw ("Huh ?!")
                    }
                }
            }
            h = h.substring(e[0].length)
        }
        return d.join("")
    }
};
CanvasXpress.prototype.initTime = function() {
    Date.prototype.getWeek = function() {
        var a = new Date(this.getFullYear(), 0, 1);
        return Math.ceil((((this - a) / 86400000) + a.getDay() + 1) / 7)
    };
    Date.prototype.getDayYear = function() {
        var a = new Date(this.getFullYear(), 0, 1);
        return Math.ceil((this - a) / 86400000)
    };
    Date.prototype.addMilliseconds = function(a) {
        let date = new Date(this.valueOf());
        date.setDate(date.getMilliseconds() + a);
        return date
    };
    Date.prototype.addSeconds = function(a) {
        let date = new Date(this.valueOf());
        date.setDate(date.getSeconds() + a);
        return date
    };
    Date.prototype.addMinutes = function(a) {
        let date = new Date(this.valueOf());
        date.setDate(date.getMinutes() + a);
        return date
    };
    Date.prototype.addHours = function(a) {
        let date = new Date(this.valueOf());
        date.setDate(date.getHours() + a);
        return date
    };
    Date.prototype.addDays = function(a) {
        let date = new Date(this.valueOf());
        date.setDate(date.getDate() + a);
        return date
    };
    Date.prototype.addMonths = function(a) {
        let date = new Date(this.valueOf());
        date.setMonth(date.getMonth() + a);
        return date
    };
    Date.prototype.addYears = function(a) {
        let date = new Date(this.valueOf());
        date.setYear(date.getFullYear() + a);
        return date
    };
    this.getMillisecond = function(a) {
        return a.getMilliseconds()
    };
    this.getSecond = function(a) {
        return a.getSeconds()
    };
    this.getMinuteSecond = function(a) {
        return a.getMinutes() + "." + a.getSeconds()
    };
    this.getMinute = function(a) {
        return a.getMinutes()
    };
    this.getHourMinute = function(a) {
        return a.getHours() + "." + a.getMinutes()
    };
    this.getHour = function(a) {
        return a.getHours()
    };
    this.getYearWeek = function(a) {
        return a.getFullYear() + "." + a.getWeek()
    };
    this.getMonthDay = function(a) {
        return (a.getMonth() + 1) + "." + (a.getDay() + 1)
    };
    this.getYearMonth = function(a) {
        return a.getFullYear() + "." + (a.getMonth() + 1)
    };
    this.getYear = function(a) {
        return a.getFullYear()
    };
    this.times = {
        second: 1000,
        minute: 60000,
        hour: 3600000,
        day: 86400000,
        week: 604800000,
        month: 2592000000,
        year: 31556952000
    };
    this.parseDate = function(j) {
        var f = 0;
        var c = 0;
        var e = 0;
        var k = parseInt(j.toString().substring(0, 4));
        var a = parseInt(j.toString().substring(4, 6).replace(/^0/, ""));
        var g = parseInt(j.toString().substring(6, 8).replace(/^0/, ""));
        var b = j.toString().match(/\:/) ? j.toString().substring(10).split(":") : false;
        if (b) {
            f = b[0] ? parseInt(b[0].replace(/^0/, "")) : 0;
            c = b[1] ? parseInt(b[1].replace(/^0/, "")) : 0;
            e = b[2] ? parseInt(b[2].replace(/^0/, "")) : 0
        }
        return new Date(k, a - 1, g, f, c, e)
    };
    this.formatDate = function(f, w) {
        var A, j, q, b, p, i, k, g, u, o, d, v, c, x, y, r, t, n, l, z, a, e;
        f = new Date(f);
        j = ((A = f.getFullYear()) + "").slice(-2);
        p = (i = f.getMonth() + 1) < 10 ? ("0" + i) : i;
        b = (q = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"][i - 1]).substring(0, 3);
        u = (o = f.getDate()) < 10 ? ("0" + o) : o;
        g = (k = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"][f.getDay()]).substring(0, 3);
        e = (o >= 10 && o <= 20) ? "th" : ((a = o % 10) == 1) ? "st" : (a == 2) ? "nd" : (a == 3) ? "rd" : "th";
        w = w.replace("#YYYY#", A).replace("#YY#", j).replace("#MMMM#", q).replace("#MMM#", b).replace("#MM#", p).replace("#M#", i).replace("#DDDD#", k).replace("#DDD#", g).replace("#DD#", u).replace("#D#", o).replace("#th#", e);
        x = (v = f.getHours());
        if (x == 0) {
            x = 24
        }
        if (x > 12) {
            x -= 12
        }
        c = x < 10 ? ("0" + x) : x;
        d = v < 10 ? ("0" + v) : v;
        z = (l = v < 12 ? "am" : "pm").toUpperCase();
        y = (r = f.getMinutes()) < 10 ? ("0" + r) : r;
        t = (n = f.getSeconds()) < 10 ? ("0" + n) : n;
        return w.replace("#hhhh#", d).replace("#hhh#", v).replace("#hh#", c).replace("#h#", x).replace("#mm#", y).replace("#m#", r).replace("#ss#", t).replace("#s#", n).replace("#ampm#", l).replace("#AMPM#", z)
    };
    this.setTimeAxis = function() {
        var h = this.validateTimeAxis();
        if (h.length) {
            var k = Date.parse(h[0]);
            var a = Date.parse(h[h.length - 1]);
            var g = a - k;
            var c;
            if (this.timeFormat == "year" || g > this.times.year * 2) {
                if (g / h.length >= this.times.year) {
                    c = "addYears"
                } else {
                    c = "addDays"
                }
            } else {
                if (this.timeFormat == "month" || g > this.times.week) {
                    c = "addDays"
                } else {
                    if (g < this.times.second) {
                        c = "addMilliseconds"
                    } else {
                        if (g < this.times.minute) {
                            c = "addSeconds"
                        } else {
                            if (g < this.times.hour) {
                                c = "addMinutes"
                            } else {
                                if (g < this.times.day) {
                                    c = "addHourss"
                                }
                            }
                        }
                    }
                }
            }
            this.timeValues = [this.dateFormat(new Date(k)[c](-1), this.timeFormat)];
            this.timeValueIndices = [-1];
            while (k <= a) {
                var j = new Date(k);
                var e = this.dateFormat(j, this.timeFormat);
                var b = this.getSampleIndices(this.timeFormat.match(/year|hour|minute|second/) ? Number(e) : e);
                this.timeValues.push(e);
                this.timeValueIndices.push(b);
                j = j[c](1);
                k = Date.parse(j)
            }
        } else {
            return []
        }
    };
    this.createRandomTimes = function(b) {
        var e;
        var g = new Date();
        var a = g.getTime();
        var f = [new Date(a)];
        var h = this.isGroupedData ? this.data.w.labs : this.data.y.smps;
        if (!b || !this.times[b]) {
            b = "day"
        }
        for (var c = 0; c < h.length; c++) {
            e = Date.parse(h[c]);
            if (!isNaN(e)) {
                a = e
            } else {
                a -= this.times[b]
            }
            f.unshift(new Date(a))
        }
        return f
    };
    this.validateTimeAxis = function() {
        var j = this.isGroupedData ? this.data.w.labs : this.data.y.smps;
        var b = false;
        var h = [];
        for (var c = 0; c < j.length; c++) {
            var a = j[c];
            var e = this.timeFormat;
            switch (this.timeFormat) {
                case "Year":
                case "year":
                    a += "/01/02";
                    e = "isoDate";
                    break;
                case "Month":
                case "month":
                    a = "2018/" + CanvasXpress.dates[a] + "/02";
                    e = "isoDate";
                    break;
                case "Day":
                case "day":
                    a = "2018/01/" + CanvasXpress.dates[a];
                    e = "isoDate";
                    break
            }
            if (!this.isValidDateFormat(a)) {
                this.isGraphTime = false;
                alert("Invalid Date! Graph converted from Time Graph");
                return []
            }
            var g = Date.parse(this.dateFormat(a, e));
            if (isNaN(g)) {
                if (this.isExample) {
                    h = this.createRandomTimes();
                    return h
                } else {
                    b = true;
                    break
                }
            } else {
                h.push(new Date(g))
            }
        }
        h.sort(function(f, d) {
            return f - d
        });
        return b ? false : h
    }
};
CanvasXpress.prototype.initColor = function() {
    this.validateColor = function(j, e, g) {
        var k = j;
        if (k) {
            k = k.toString();
            k = k.replace(/\s/g, "");
            var b = (/rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/).exec(k);
            var d = (/rgba\((\d{1,3}),(\d{1,3}),(\d{1,3}),([0-9\.]+)\)/).exec(k);
            var i = (/^#?([0-9abcdef]{6})/i).exec(k);
            var a = (/^([0-9abcdef]{6})/i).exec(k);
            if (CanvasXpress.colorNames.hasOwnProperty(k)) {
                k = this.hexToRgb(CanvasXpress.colorNames[k])
            } else {
                if (b != null) {
                    k = b[0]
                } else {
                    if (d != null) {
                        k = d[0]
                    } else {
                        if (i != null) {
                            k = this.hexToRgb(i[0])
                        } else {
                            if (a != null) {
                                k = this.hexToRgb("#" + a[0])
                            } else {
                                if (k == "[objectCanvasGradient]") {
                                    return j
                                } else {
                                    k = false
                                }
                            }
                        }
                    }
                }
            }
        }
        k = k && e != null ? this.addColorTransparency(k, e, true) : k ? k : false;
        return k && g ? this.rgbToHex(k) : k
    };
    this.darkenLightenColor = function(j, e) {
        j = this.rgbToHex(this.validateColor(j)).substring(1, 7);
        var i = parseInt(j, 16);
        var h = (i >> 16) + e;
        h = h > 255 ? 255 : h < 0 ? 0 : h;
        var f = ((i >> 8) & 255) + e;
        f = f > 255 ? 255 : f < 0 ? 0 : f;
        var d = (i & 255) + e;
        d = d > 255 ? 255 : d < 0 ? 0 : d;
        j = d | (f << 8) | (h << 16);
        return this.hexToRgb(j.toString(16))
    };
    this.rgbToHex = function(b) {
        var a = function(c) {
            c = parseInt(c, 10);
            if (isNaN(c)) {
                return "00"
            }
            c = Math.max(0, Math.min(c, 255));
            return "0123456789ABCDEF".charAt((c - c % 16) / 16) + "0123456789ABCDEF".charAt(c % 16)
        };
        if (b && b.substr(0, 1) === "#") {
            return b
        }
        if (b && b.match(/^rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/)) {
            return "#" + a(RegExp.$1) + a(RegExp.$2) + a(RegExp.$3)
        } else {
            if (b && b.match(/^rgba\((\d{1,3}),(\d{1,3}),(\d{1,3}),([0-9\.]+)\)/)) {
                return "#" + a(RegExp.$1) + a(RegExp.$2) + a(RegExp.$3)
            } else {
                return b
            }
        }
    };
    this.rgbToHsl = function(m) {
        var i = this.colorAsArray(m);
        var a = i[0] / 255;
        var j = i[1] / 255;
        var n = i[2] / 255;
        var o = Math.max(a, j, n);
        var e = Math.min(a, j, n);
        var f, p;
        var c = (o + e) / 2;
        if (o == e) {
            f = 0;
            p = 0
        } else {
            var k = o - e;
            p = c > 0.5 ? k / (2 - o - e) : k / (o + e);
            switch (o) {
                case a:
                    f = (j - n) / k + (j < n ? 6 : 0);
                    break;
                case j:
                    f = (n - a) / k + 2;
                    break;
                case n:
                    f = (a - j) / k + 4;
                    break
            }
            f /= 6
        }
        return "hsl(" + Math.floor(f * 100) + "," + Math.floor(p * 100) + "%," + Math.floor(c * 100) + "%)"
    };
    this.complementaryColor = function(j, e) {
        var d = this.validateColor(j.toString());
        if (d.match(/^rgba?\((\d{1,3}),(\d{1,3}),(\d{1,3})(?:,([0-9\.]+))?/i)) {
            var i = parseInt(255 - RegExp.$1);
            var f = parseInt(255 - RegExp.$2);
            var a = parseInt(255 - RegExp.$3);
            if (i == f && f == a) {
                if (i >= 127) {
                    d = "rgb(255,255,255)"
                } else {
                    d = "rgb(0,0,0)"
                }
            } else {
                d = "rgb(" + i + "," + f + "," + a + ")"
            }
            return e ? this.rgbToHex(d) : d
        } else {
            return j
        }
    };
    this.hexToRgb = function(c) {
        var b = function() {
            return parseInt(c.substring(0, 2), 16)
        };
        var a = function() {
            return parseInt(c.substring(2, 4), 16)
        };
        var d = function() {
            return parseInt(c.substring(4, 6), 16)
        };
        c = c.charAt(0) == "#" ? c.substring(1, 7) : c;
        return "rgb(" + b() + "," + a() + "," + d() + ")"
    };
    this.hslToRgb = function(n) {
        var j = n.split(",");
        var i = Number(j[0].replace(/\s/g, "").replace("hsl(", ""));
        var o = Number(j[0].replace(/\s/g, "").replace("%", ""));
        var f = Number(j[0].replace(/\s/g, "").replace("%)", ""));
        if (o == 0) {
            return "rgb(" + f + "," + f + "," + f + ")"
        } else {
            var e = function(h, g, b) {
                if (b < 0) {
                    b += 1
                }
                if (b > 1) {
                    b -= 1
                }
                if (b < 1 / 6) {
                    return h + (g - h) * 6 * b
                }
                if (b < 1 / 2) {
                    return g
                }
                if (b < 2 / 3) {
                    return h + (g - h) * (2 / 3 - b) * 6
                }
                return h
            };
            var c = f < 0.5 ? f * (1 + o) : f + o - f * o;
            var d = 2 * f - c;
            var a = Math.round(e(d, c, i + 1 / 3) * 255);
            var k = Math.round(e(d, c, i) * 255);
            var m = Math.round(e(d, c, i - 1 / 3) * 255);
            return "rgb(" + a + "," + k + "," + m + ")"
        }
    };
    this.addColorTransparency = function(e, d, b) {
        if (e) {
            if (e instanceof CanvasGradient) {
                return e
            }
            var a = e.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i);
            if (!a || !b) {
                e = this.validateColor(e);
                a = e && e.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i)
            }
            return a ? "rgba(" + a[1] + "," + Math.min(d, (a[2] != null ? a[2] : 1)) + ")" : false
        } else {
            return false
        }
    };
    this.removeColorTransparency = function(d, b) {
        if (d) {
            var a = d.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i);
            if (!a || !b) {
                d = this.validateColor(d);
                a = d && d.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i)
            }
            return a ? "rgb(" + a[1] + ")" : false
        } else {
            return false
        }
    };
    this.isColorTransparency = function(d, b) {
        if (!b) {
            d = this.validateColor(d)
        }
        if (d) {
            var a = d.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i);
            return !a ? null : a[2] != null ? Number(a[2]) : null
        }
    };
    this.isColorTransparent = function(e, b) {
        if (!b) {
            e = this.validateColor(e)
        }
        var d;
        if (e && e.match(/^rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/)) {
            return false
        } else {
            if (e) {
                var a = e.match(/^rgba?\((\d{1,3},\d{1,3},\d{1,3})(?:,([0-9\.]+))?/i);
                return !a ? false : a[2] != null && a[2] == 0 ? true : false
            } else {
                return false
            }
        }
    };
    this.combineColors = function(j) {
        var e = [];
        var d = [];
        var n = [];
        var k = [];
        for (var f = 0; f < j.length; f++) {
            j[f] = this.validateColor(j[f])
        }
        for (var f = 0; f < j.length; f++) {
            var l = j[f];
            if (l && l.match(/^rgba?\((\d{1,3}),(\d{1,3}),(\d{1,3})(?:,([0-9\.]+))?/i)) {
                e.push(parseInt(RegExp.$1));
                d.push(parseInt(RegExp.$2));
                n.push(parseInt(RegExp.$3));
                if (RegExp.$4) {
                    k.push(parseFloat(RegExp.$4))
                }
            }
        }
        if (e.length > 0) {
            var a = parseInt(this.mean(e));
            var h = parseInt(this.mean(d));
            var m = parseInt(this.mean(n));
            if (k.length > 0) {
                var o = parseFloat(this.mean(k));
                return "rgba(" + a + "," + h + "," + m + "," + o + ")"
            } else {
                return "rgb(" + a + "," + h + "," + m + ")"
            }
        }
        return false
    };
    this.colorAsArray = function(f) {
        f = this.validateColor(f);
        var b = [];
        if (f) {
            var d = (/rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/).exec(f);
            var e = (/rgba\((\d{1,3}),(\d{1,3}),(\d{1,3}),([0-9\.]+)\)/).exec(f);
            if (d != null) {
                b = [parseInt(d[1]), parseInt(d[2]), parseInt(d[3])]
            } else {
                if (e != null) {
                    b = [parseInt(e[1]), parseInt(e[2]), parseInt(e[3]), Number(e[4])]
                }
            }
        }
        return b
    };
    this.monoColor = function(f, d) {
        var b = this.colorAsArray(f);
        var e = 0.3 * b[0] + 0.59 * b[1] + 0.11 * b[2];
        if (d != null) {
            return "rgba(" + e + "," + e + "," + e + "," + d + ")"
        } else {
            return "rgb(" + e + "," + e + "," + e + ")"
        }
    };
    this.blindColor = function(S, I) {
        var q = this.colorAsArray(this.validateColor(S, I));
        var J = q[0];
        var Q = q[1];
        var T = q[2];
        var x = [0.7465, 0.2535, 1.273463, -0.073894];
        var A = [1.4, -0.04, 0.968437, 0.003331];
        var u = [1.748, 0, 0.062921, 0.292119];
        if (J == 0 && Q == 0 && T == 0) {
            return "rgb(0,0,0)"
        }
        var l;
        switch (this.blindnessType) {
            case "protanopia":
                l = x;
                break;
            case "deuteranopia":
                l = A;
                break;
            case "tritanopia":
                l = u;
                break;
            case "monochromatic":
                var S = Math.ceil((J * 0.212656 + J * 0.715158 + J * 0.072186));
                return "rgb(" + S + "," + S + "," + S + ")"
        }
        var F = l[0];
        var D = l[1];
        var K = l[2];
        var z = l[3];
        var n = 1;
        var y = Math.pow(J, 2.2);
        var B = Math.pow(Q, 2.2);
        var C = Math.pow(T, 2.2);
        var i = y * 0.412424 + B * 0.357579 + C * 0.180464;
        var h = y * 0.212656 + B * 0.715158 + C * 0.072185;
        var f = y * 0.019332 + B * 0.119193 + C * 0.950444;
        var k = i / (i + h + f);
        var j = h / (i + h + f);
        var w = (j - D) / (k - F);
        var L = j - k * w;
        var e = (z - L) / (w - K);
        var a = (w * e) + L;
        i = e * h / a;
        f = (1 - (e + a)) * h / a;
        var O = 0.312713 * h / 0.329016;
        var M = 0.358271 * h / 0.329016;
        var G = O - i;
        var E = M - f;
        var H = G * 3.24071 + E * -0.498571;
        var N = G * -0.969258 + E * 0.0415557;
        var R = G * 0.0556352 + E * 1.05707;
        var d = i * 3.24071 + h * -1.53726 + f * -0.498571;
        var o = i * -0.969258 + h * 1.87599 + f * 0.0415557;
        var s = i * 0.0556352 + h * -0.203996 + f * 1.05707;
        var U = ((H < 0 ? 0 : 1) - d) / H;
        var m = ((N < 0 ? 0 : 1) - o) / N;
        var p = ((R < 0 ? 0 : 1) - s) / R;
        var P = [(U > 1 || U < 0) ? 0 : U, (m > 1 || m < 0) ? 0 : m, (p > 1 || m < 0) ? 0 : p];
        P = Math.max.apply(null, P);
        d = d + (P * H);
        o = o + (P * N);
        s = s + (P * R);
        d = Math.pow(d, 1 / 2.2);
        o = Math.pow(o, 1 / 2.2);
        s = Math.pow(s, 1 / 2.2);
        J = Math.ceil(d);
        Q = Math.ceil(o);
        T = Math.ceil(s);
        if (J > 255) {
            J -= 255
        }
        if (Q > 255) {
            Q -= 255
        }
        if (T > 255) {
            T -= 255
        }
        return "rgb(" + J + "," + Q + "," + J + ")"
    };
    this.disableGradientTransparencyShadow = function() {
        if (!this.gradientTemp) {
            this.gradientTemp = this.gradient
        }
        if (this.transparencyTemp == null) {
            this.transparencyTemp = this.transparency
        }
        if (!this.showShadowTemp) {
            this.showShadowTemp = this.showShadow
        }
        this.gradient = false;
        this.transparency = null;
        this.showShadow = false
    };
    this.enableGradientTransparencyShadow = function() {
        this.gradient = this.gradientTemp;
        this.transparency = this.transparencyTemp;
        this.showShadow = this.showShadowTemp
    };
    this.resetGradientTransparencyShadow = function() {
        delete(this.gradientTemp);
        delete(this.transparencyTemp);
        delete(this.showShadowTemp)
    };
    this.getGradient = function(f, e, d, c, b, a) {
        if (this.gradientType == "radial") {
            return this.getRadialGradient(f, e, d, b, a, true)
        } else {
            return this.getLinearGradient(f, e, d, c, b, a, true)
        }
    };
    this.getLinearGradient = function(d, o, a, m, j, l, k) {
        if (!k) {
            this.saveCanvas()
        }
        var p = this.getCanvasContext();
        var h = p.createLinearGradient(d, o, a, m);
        if (!j) {
            j = this.colorSpectrum
        } else {
            if (this.validateColor(j) && (!this.isArray(j) || j.length < 2)) {
                j = [j, "black"]
            }
        }
        if (!l || !this.isArray(l)) {
            l = this.colorSpectrumBreaks
        }
        var q = 1 / (j.length - 1);
        var e = q;
        for (var f = 0; f < j.length; f++) {
            j[f] = this.validateColor(j[f])
        }
        h.addColorStop(l[0] || 0, this.transparency != null ? this.addColorTransparency(j[0]) : j[0]);
        for (var f = 1; f < j.length; f++) {
            h.addColorStop(l[f] || e, this.transparency != null ? this.addColorTransparency(j[0]) : j[f]);
            e += q
        }
        return h
    };
    this.getRadialGradient = function(p, k, a, j, m, l) {
        if (!l) {
            this.saveCanvas()
        }
        var q = this.getCanvasContext();
        var d = a / 5.5;
        var h = q.createRadialGradient(p - d, k - d, 1, p, k, a);
        if (!j) {
            j = this.colorSpectrum
        } else {
            if (this.validateColor(j) && (!this.isArray(j) || j.length < 2)) {
                j = [j, "black"]
            }
        }
        if (!m || !this.isArray(m)) {
            m = this.colorSpectrumBreaks
        }
        var t = 1 / (j.length - 1);
        var e = t;
        h.addColorStop(m[0] || 0, this.transparency != null ? this.addColorTransparency(j[0]) : j[0]);
        for (var f = 1; f < j.length; f++) {
            h.addColorStop(m[f] || e, this.transparency != null ? this.addColorTransparency(j[0]) : j[f]);
            e += t
        }
        return h
    };
    this.colorRGBfromString = function(b) {
        var a = b.match(/^\W*([0-9A-F]{3}([0-9A-F]{3})?)\W*$/i);
        if (a) {
            if (a[1].length === 6) {
                this.colorFromRgb(parseInt(a[1].substr(0, 2), 16) / 255, parseInt(a[1].substr(2, 2), 16) / 255, parseInt(a[1].substr(4, 2), 16) / 255)
            } else {
                this.colorFromRgb(parseInt(a[1].charAt(0) + a[1].charAt(0), 16) / 255, parseInt(a[1].charAt(1) + a[1].charAt(1), 16) / 255, parseInt(a[1].charAt(2) + a[1].charAt(2), 16) / 255)
            }
        }
    };
    this.colorFromRgb = function(e, d, a) {
        if (this.colorRGB) {
            if (e != null) {
                this.colorRGB[0] = Math.min(Math.max(0, e), 1)
            }
            if (d != null) {
                this.colorRGB[1] = Math.min(Math.max(0, d), 1)
            }
            if (a != null) {
                this.colorRGB[2] = Math.min(Math.max(0, a), 1)
            }
            var c = this.rgbFromHsv(this.colorRGB[0], this.colorRGB[1], this.colorRGB[2]);
            if (c[0] != null) {
                this.colorHSV[0] = c[0]
            }
            if (c[2] != 0) {
                this.colorHSV[1] = c[1]
            }
            this.colorHSV[2] = c[2]
        }
    };
    this.rgbFromHsv = function(i, f, c) {
        var j = Math.min(Math.min(i, f), c);
        var d = Math.max(Math.max(i, f), c);
        var a = d - j;
        if (a == 0) {
            return [null, 0, d]
        } else {
            var e = i == j ? 3 + (c - f) / a : (f == j ? 5 + (i - c) / a : 1 + (f - i) / a);
            return [e == 6 ? 0 : e, a / d, d]
        }
    };
    this.colorFromHsv = function(c, b, a) {
        if (c != null) {
            this.colorHSV[0] = Math.min(Math.max(0, c), 6)
        }
        if (b != null) {
            this.colorHSV[1] = Math.min(Math.max(0, b), 1)
        }
        if (a != null) {
            this.colorHSV[2] = Math.min(Math.max(0, a), 1)
        }
        this.colorRGB = this.hsvFromRgb(this.colorHSV[0], this.colorHSV[1], this.colorHSV[2])
    };
    this.hsvFromRgb = function(e, d, b) {
        if (e == null) {
            return [b, b, b]
        }
        var c = Math.floor(e);
        var g = c % 2 ? e - c : 1 - (e - c);
        var a = b * (1 - d);
        var j = b * (1 - d * g);
        switch (c) {
            case 0:
                return [b, j, a];
            case 1:
                return [j, b, a];
            case 2:
                return [a, b, j];
            case 3:
                return [a, j, b];
            case 4:
                return [j, a, b];
            case 5:
                return [b, a, j];
            case 6:
                return [b, a, j]
        }
    };
    this.colorRGBToString = function() {
        if (this.colorRGB) {
            return (256 | Math.round(255 * this.colorRGB[0])).toString(16).substr(1) + (256 | Math.round(255 * this.colorRGB[1])).toString(16).substr(1) + (256 | Math.round(255 * this.colorRGB[2])).toString(16).substr(1)
        }
    };
    this.getColorNames = function() {
        return this.sortObject(CanvasXpress.colorNames)
    };
    this.getColorSchemes = function() {
        return this.sortObject(CanvasXpress.colorSchemes)
    };
    this.getHexColor = function(b) {
        var c = /^#?[0-9a-fA-F]{6}$/i;
        var a = /rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)/;
        if (c.test(b)) {
            return b.substring(b.length - 6, b.length)
        } else {
            if (a.test(b)) {
                return this.rgbToHex(b)
            } else {
                var d = b.toLowerCase();
                if (CanvasXpress.colorNames.hasOwnProperty(d)) {
                    return CanvasXpress.colorNames[d]
                } else {
                    throw new Error(b + " is not a valid color.")
                }
            }
        }
    };
    this.getColorForValue = function(a, c) {
        if (!a) {
            a = this.meta.def.colorBrew
        }
        for (var d = 0; d < a.breaks.length; d++) {
            if (a.breaks[d] >= c) {
                return a.colors[d]
            }
        }
        return a.colors[a.colors.length - 1]
    };
    this.setColorForValues = function(a, d) {
        var g = this;
        var c = function(l) {
            var j = function(t, q) {
                var n = a.grads[l];
                var s = n.min;
                var z = n.max;
                var p = n.scol.replace("#", "").substring(t, q);
                var A = n.ecol.replace("#", "").substring(t, q);
                var w = d < s ? s : d > z ? z : d;
                var i = z - s;
                var x = parseInt(p, 16);
                var m = parseInt(A, 16);
                var u = (m - x) / i;
                if (isNaN(u)) {
                    u = 0
                }
                var o = Math.round(u * (w - s) + x);
                var y = o.toString(16);
                return y.length == 1 ? "0" + y : y
            };
            var k = j(0, 2);
            var h = j(2, 4);
            var b = j(4, 6);
            return g.hexToRgb("#" + k + h + b)
        };
        if (!a) {
            a = this.meta.def.colorBrew
        }
        if (a.length == 1) {
            return c(0)
        } else {
            for (var e = 0; e < a.grads.length; e++) {
                if (a.grads[e].min <= d && a.grads[e].max > d) {
                    return c(e)
                }
            }
            var f = (a.max - a.min) / a.grads.length;
            var e = Math.min(Math.floor((Math.max(d, a.min) - a.min) / f), a.grads.length - 1);
            return c(e)
        }
    };
    this.getColorBrew = function(K, B, E, g, f, c) {
        var h = K || this.colorSpectrum;
        if (B != null && E != null && B == E) {
            E += 0.1
        }
        var F = B != null && f && f.length ? Math.min(B, f[0]) : B != null ? B : this.minData != null ? this.minData : 0;
        var o = E != null && f && f.length ? Math.max(E, f[f.length - 1]) : E != null ? E : this.maxData != null ? this.maxData : 100;
        var I = !c && this.setMinX != null ? this.setMinX : null;
        var w = !c && this.setMaxX != null ? this.setMaxX : null;
        var C, t;
        var L = [];
        if (g == null) {
            zero = (F + o) / 2
        } else {
            zero = g;
            var C = g - F;
            var t = o - g;
            if (C > t) {
                o = g + C
            } else {
                F = g - t
            }
        }
        var q = this[this.axisAlgorithm](Math.min(I || F, w || o), Math.max(I || F, w || o), 5, this.axisWilkinsonLoose);
        if (o == Math.abs(F) && g == 0 && q.length % 2) {
            q[Math.floor(q.length / 2)] = 0
        }
        var G = (q[q.length - 1] - q[0]) / (h.length - 1);
        var a = this.getAxisDecimals(q[1] - q[0]);
        var d = [];
        for (var D = 0; D < q.length; D++) {
            d[D] = q[D].toFixed(a)
        }
        var e = this.getMaxText(d);
        var H = this.measureText(e.toString(), this.font);
        var m = q[q.length - 1] - q[0];
        var u = [];
        if (f && f.length > 1 && f.length == h.length) {
            for (var D = 0; D < f.length; D++) {
                f[D] = Number(f[D]);
                u.push(this.formatNumber(f[D].toString()))
            }
            e = this.getMaxText(u);
            H = this.measureText(e.toString(), this.font);
            f = f.sort(function(l, i) {
                return l - i
            });
            var x = f[0];
            var A = Math.ceil(100 / h.length) + 1;
            for (var D = 1; D < f.length; D++) {
                var k = f[D];
                var J = this.seq(x, k, false, A);
                x = J.pop();
                L = L.concat(J)
            }
            L.push(x);
            this.colorSpectrumNumber = L.length
        } else {
            L = this.seq(q[0], q[q.length - 1], false, this.colorSpectrumNumber)
        }
        var j = {
            spectrum: h,
            stops: f,
            z: g,
            colors: [],
            smooth: [],
            grads: [],
            rmin: F,
            rmax: o,
            min: (f && f.length > 1 ? f[0] : q[0]),
            max: (f && f.length > 1 ? f[f.length - 1] : q[q.length - 1]),
            range: m,
            zero: zero,
            vals: q,
            valStr: d,
            incr: G,
            decs: a,
            breaks: L,
            maxLevLen: H,
            maxLevChr: e.toString().length,
            maxLevStr: e
        };
        for (var D = 0; D < h.length - 1; D++) {
            var y = {
                scol: this.getHexColor(h[D]),
                ecol: this.getHexColor(h[D + 1]),
                min: (f && f.length > 1 ? f[D] : q[0] + (G * D)),
                max: (f && f.length > 1 ? f[D + 1] : q[0] + (G * (D + 1)))
            };
            j.grads.push(y)
        }
        for (var D = 0; D < this.colorSpectrumNumber; D++) {
            v = this.setColorForValues(j, L[D]);
            j.colors.push(v)
        }
        return j
    };
    this.setColorBrew = function(d, e) {
        this.setColorSpectrum();
        if (!this.meta.def.colorBrew || d) {
            if (this.meta.vals.colors) {
                this.meta.vals.colors = {}
            }
            if (this.graphType.match(/Stacked/)) {
                this.meta.def.colorBrew = this.getColorBrew(this.colorSpectrum, this.minDataStacked, this.maxDataStacked, this.colorSpectrumZeroValue, this.colorSpectrumBreaks)
            } else {
                if (this.heatmapAutoAdjust || !this.meta.def.colorBrew) {
                    this.meta.def.colorBrew = this.getColorBrew(this.colorSpectrum, this.minData, this.maxData, this.colorSpectrumZeroValue, this.colorSpectrumBreaks)
                } else {
                    var b = this.meta.def.colorBrew;
                    if (e) {
                        if (this.isTransformedData) {
                            var c = this.isHistogram ? 0.000001 : this.minData;
                            var a = this.maxData;
                            switch (this.isTransformedData) {
                                case "log2":
                                    c = Math.log(c) / Math.LN2;
                                    a = Math.log(a) / Math.LN2;
                                    break;
                                case "log10":
                                    c = Math.log(c) / Math.LN10;
                                    a = Math.log(a) / Math.LN10;
                                    break;
                                case "exp2":
                                    c = Math.pow(2, c);
                                    a = Math.pow(2, a);
                                    break;
                                case "exp10":
                                    c = Math.pow(10, c);
                                    a = Math.pow(10, a);
                                    break
                            }
                            if (!this.isNumber(c, true) || !this.isNumber(a, true)) {
                                c = this.min(this.data.y.trans);
                                a = this.max(this.data.y.trans)
                            }
                            this.meta.def.colorBrew = this.getColorBrew(this.colorSpectrum, c, a, this.colorSpectrumZeroValue, this.colorSpectrumBreaks)
                        } else {
                            this.meta.def.colorBrew = this.getColorBrew(this.colorSpectrum, this.minData || b.rmin, this.maxData || b.rmax, this.colorSpectrumZeroValue || b.z, this.colorSpectrumBreaks || b.stops)
                        }
                    } else {
                        this.meta.def.colorBrew = this.getColorBrew(this.colorSpectrum, b.rmin, b.rmax, b.z, b.stops)
                    }
                }
            }
        }
    };
    this.getCustomColorScheme = function(f) {
        if (!f) {
            f = 8
        }
        var b = this.getKeys(CanvasXpress.colorSchemes[this.colorScheme]);
        b.sort(function(g, d) {
            return g - d
        });
        if (CanvasXpress.colorSchemes[this.colorScheme]) {
            if (CanvasXpress.colorSchemes[this.colorScheme][f]) {
                return CanvasXpress.colorSchemes[this.colorScheme][f]
            } else {
                if (f > b[b.length - 1]) {
                    var e = f - b.length;
                    f--;
                    while (!CanvasXpress.colorSchemes[this.colorScheme][f]) {
                        f--
                    }
                    var c = CanvasXpress.colorSchemes[this.colorScheme][f];
                    for (var a = 0; a < e; a++) {
                        c.push(CanvasXpress.colorSchemes[this.colorScheme][f][a % CanvasXpress.colorSchemes[this.colorScheme][f].length])
                    }
                    return c
                } else {
                    f++;
                    while (!CanvasXpress.colorSchemes[this.colorScheme][f]) {
                        f++
                    }
                    return CanvasXpress.colorSchemes[this.colorScheme][f]
                }
            }
        } else {
            return this.colors
        }
    };
    this.setColorSpectrum = function() {
        if (this.blindnessType && !this.meta.def.colorSpectrum) {
            this.meta.def.colorSpectrum = this.cloneObject(this.colorSpectrum);
            var b = [];
            for (var a = 0; a < this.colorSpectrum.length; a++) {
                b.push(this.blindColor(this.colorSpectrum[a]))
            }
            this.colorSpectrum = b;
            delete this.meta.def.colorBrew
        } else {
            if (this.meta.def.colorSpectrum && this.meta.def.blindnessTypeSpectrum != this.blindnessType) {
                if (this.blindnessType) {
                    var b = [];
                    for (var a = 0; a < this.colorSpectrum.length; a++) {
                        b.push(this.blindColor(this.colorSpectrum[a]))
                    }
                    this.colorSpectrum = b;
                    delete this.meta.def.colorBrew
                } else {
                    this.colorSpectrum = this.cloneObject(this.meta.def.colorSpectrum)
                }
            }
        }
        this.meta.def.blindnessTypeSpectrum = this.blindnessType
    };
    this.setColorScheme = function(k) {
        var e = this;
        var a = false;
        var h;
        var c = function(o) {
            if (e.data[o]) {
                if (e.colorBy) {
                    return e.data[o].hasOwnProperty(e.colorBy) && e.meta.data[o][e.colorBy].colors ? e.meta.data[o][e.colorBy].colors.length : e.data.y.smps.length
                } else {
                    var n = e.data.y.smps.length;
                    for (var m in e.meta.data[o]) {
                        if (e.meta.data[o][m].levels) {
                            n = Math.max(n, e.meta.data[o][m].levels.length)
                        }
                    }
                    return n
                }
            }
            return e.data.y.smps.length
        };
        if (this.colorScheme == "User") {
            h = this.cloneObject(this.colors)
        } else {
            if (this.colorScheme == "ColorSpectrum") {
                var j = this.colorSpectrumNumber;
                this.colorSpectrumNumber = this.graphType == "Circular" ? Math.max(this.data.y.vars.length, this.data.y.smps.length) : this.data.y.vars.length;
                var l = this.getColorBrew(this.colorSpectrum, 0, this.data.y.vars.length);
                h = l.colors;
                this.colorSpectrumNumber = j
            } else {
                if (CanvasXpress.colorSchemes[this.colorScheme]) {
                    var b;
                    var g = this.getKeys(CanvasXpress.colorSchemes[this.colorScheme]);
                    g.sort(function(m, i) {
                        return m - i
                    });
                    g = parseInt(g[g.length - 1]);
                    if (k && k.type == "String") {
                        b = k.levels.length
                    } else {
                        if (this.graphType.match(/Scatter/)) {
                            if (this.layoutValid) {
                                b = c("z")
                            } else {
                                if (this.colorBy && this.meta.data.hasOwnProperty("z") && this.meta.data.z.hasOwnProperty(this.colorBy) && this.meta.data.z[this.colorBy].colors) {
                                    b = this.meta.data.z[this.colorBy].levels.length
                                } else {
                                    b = this.data.y.smps.length
                                }
                            }
                        } else {
                            if (this.graphType.match(/Treemap|TagCloud|Sankey|Tree|Circular/)) {
                                b = this.colorBy && this.data.x && this.data.x.hasOwnProperty(this.colorBy) && this.meta.data.x[this.colorBy].colors ? this.meta.data.x[this.colorBy].colors.length : this.data.y.smps.length
                            } else {
                                if (this.graphType.match(/Venn/)) {
                                    b = this.vennGroups
                                } else {
                                    if (this.graphType.match(/Pie/)) {
                                        b = this.data.y.vars.length
                                    } else {
                                        if (this.graphType.match(/Network|Genome|Correlation/)) {
                                            b = g
                                        } else {
                                            if (this.graphType == "ParallelCoordinates") {
                                                b = this.colorBy && this.data.x && this.data.x.hasOwnProperty(this.colorBy) && this.meta.data.x[this.colorBy].colors ? this.meta.data.x[this.colorBy].colors.length : this.data.y.smps.length
                                            } else {
                                                if (this.graphType.match(/BarLine|DotLine/) && this.coordinateLineColor && (!this.isGroupedData || !this.colorBy)) {
                                                    b = Math.max(this.xAxis.length, this.xAxis2.length)
                                                } else {
                                                    if (this.colorBy && this.data.x && this.data.x.hasOwnProperty(this.colorBy)) {
                                                        b = this.meta.data.x[this.colorBy].colors ? this.meta.data.x[this.colorBy].colors.length : this.meta.data.x[this.colorBy].levels ? this.meta.data.x[this.colorBy].levels.length : this.data.y.vars.length
                                                    } else {
                                                        b = this.data.y.vars.length
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (CanvasXpress.colorSchemes[this.colorScheme][b]) {
                        h = CanvasXpress.colorSchemes[this.colorScheme][b]
                    } else {
                        if (b > g) {
                            b--;
                            while (!CanvasXpress.colorSchemes[this.colorScheme][b]) {
                                b--
                            }
                        } else {
                            b++;
                            while (!CanvasXpress.colorSchemes[this.colorScheme][b]) {
                                b++
                            }
                        }
                        h = CanvasXpress.colorSchemes[this.colorScheme][b]
                    }
                    if (this.meta.def.colors) {
                        this.meta.def.colors = this.cloneObject(h);
                        a = true
                    }
                } else {
                    h = CanvasXpress.colorSchemes.Balanced[20]
                }
            }
        }
        if ((this.blindnessType && !this.meta.def.colors) || a) {
            this.meta.def.colors = this.cloneObject(h);
            if (this.blindnessType) {
                var f = [];
                for (var d = 0; d < h.length; d++) {
                    f.push(this.blindColor(h[d]))
                }
                h = f
            }
        } else {
            if (this.meta.def.colors && this.meta.def.blindnessTypeColors != this.blindnessType) {
                h = this.cloneObject(this.meta.def.colors);
                if (this.blindnessType) {
                    var f = [];
                    for (var d = 0; d < h.length; d++) {
                        f.push(this.blindColor(h[d]))
                    }
                    h = f
                }
            }
        }
        this.meta.def.blindnessTypeColors = this.blindnessType;
        for (var d = 0; d < h.length; d++) {
            h[d] = this.validateColor(h[d])
        }
        if (!k) {
            this.colors = h
        }
        this.updateMetaDataColors(h, k)
    };
    this.validateUserColors = function() {
        var b = [];
        for (var c = 0; c < this.colors.length; c++) {
            b.push(this.validateColor(this.colors[c]))
        }
        if (b.length > 0) {
            this.colors = b
        }
        var a = [];
        for (var c = 0; c < this.colorSpectrum.length; c++) {
            a.push(this.validateColor(this.colorSpectrum[c]))
        }
        if (a.length > 0) {
            this.colorSpectrum = a
        }
    }
};
CanvasXpress.prototype.initAttributes = function() {
    this.setStyle = function(c, b, d, a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        if (this.transparency != null) {
            c = this.addColorTransparency(c, this.transparency, true)
        }
        a.fillStyle = c;
        a.strokeStyle = c;
        a.lineWidth = b ? b : this.outlineWidth;
        a.lineCap = d ? d : this.capType;
        this.setShadow(true, a)
    };
    this.setClipBoundaries = function(c) {
        var b, d, a, e;
        if (c && c.length == 4) {
            b = c[0];
            d = c[1];
            a = c[2];
            e = c[3]
        } else {
            b = this.marginLeft + this.offsetX + this.left - 1;
            d = this.marginTop + this.offsetY + this.top - 1;
            a = this.x + 2;
            e = this.y + 2
        }
        return [b, d, a, e]
    };
    this.setClipArea = function(a, e) {
        if (this.graphType == "Tree") {
            return
        }
        if (!e) {
            e = this.getCanvasContext()
        }
        this.saveCanvas(e);
        var d, f, c, g;
        if (a) {
            d = a[0];
            f = a[1];
            c = a[2];
            g = a[3]
        } else {
            d = this.marginLeft + this.offsetX + this.left;
            f = this.marginTop + this.offsetY + this.top;
            c = this.x + 1;
            g = this.y + 1
        }
        e.rect(d, f, c, g);
        e.clip();
        this.meta.state.clip = [d, f, c, g]
    };
    this.resetClipArea = function(a) {
        if (this.graphType == "Tree") {
            return
        }
        this.restoreCanvas(a);
        this.setClipArea([0, 0, 0, 0], a);
        this.restoreCanvas(a);
        this.meta.state.clip = false
    };
    this.resetStyle = function(a) {
        this.setShadow(false, a)
    };
    this.setShadow = function(c, a) {
        if (this.showShadow) {
            if (!a) {
                a = this.getCanvasContext()
            }
            var b = "rgba(255,255,255,0)";
            if (c) {
                a.shadowOffsetX = this.shadowOffsetX;
                a.shadowOffsetY = this.shadowOffsetY;
                a.shadowBlur = this.shadowBlur;
                a.shadowColor = this.shadowColor
            } else {
                a.shadowOffsetX = 0;
                a.shadowOffsetY = 0;
                a.shadowBlur = 0;
                a.shadowColor = this.background;
                a.strokeStyle = "rgba(255,255,255,0)";
                a.fillStyle = "rgba(255,255,255,0)"
            }
        }
    };
    this.lineTo = function(c, h, b, g, i) {
        if (this.graphType == "Network") {
            return this.lineRawTo(c, h, b, g, i)
        }
        var f = ~~(c + 0.5);
        var a = ~~(h + 0.5);
        var d = ~~(b + 0.5);
        var j = ~~(g + 0.5);
        if (Math.abs(f - d) == 1) {
            f = (f + d) / 2;
            d = f
        } else {
            f += 0.5;
            d += 0.5
        }
        if (Math.abs(a - j) == 1) {
            a = (a + j) / 2;
            j = a
        } else {
            a += 0.5;
            j += 0.5
        }
        if (!i) {
            i = this.getCanvasContext()
        }
        if (f == d && a == j) {
            var e = this.lineThickness / 1.5;
            i.fillRect(f, a, e, e)
        } else {
            i.moveTo(f, a);
            i.lineTo(d, j)
        }
        i.stroke()
    };
    this.lineRawTo = function(c, e, b, d, a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        a.moveTo(c, e);
        a.lineTo(b, d);
        a.stroke()
    };
    this.lineToOld = function(c, e, b, d, a) {
        if (c == b) {
            c = (((c + 0.5) << 1) >> 1) + 0.5;
            b = c
        } else {
            if (e == d) {
                e = (((e + 0.5) << 1) >> 1) + 0.5;
                d = e
            }
        }
        if (!a) {
            a = this.getCanvasContext()
        }
        a.moveTo(c, e);
        a.lineTo(b, d);
        a.stroke()
    };
    this.bitCode = function(b, c) {
        var a = 0;
        if (b[0] < c[0]) {
            a |= 1
        } else {
            if (b[0] > c[2]) {
                a |= 2
            }
        }
        if (b[1] < c[1]) {
            a |= 4
        } else {
            if (b[1] > c[3]) {
                a |= 8
            }
        }
        return a
    };
    this.intersect = function(d, c, e, f) {
        return e & 8 ? [d[0] + (c[0] - d[0]) * (f[3] - d[1]) / (c[1] - d[1]), f[3]] : e & 4 ? [d[0] + (c[0] - d[0]) * (f[1] - d[1]) / (c[1] - d[1]), f[1]] : e & 2 ? [f[2], d[1] + (c[1] - d[1]) * (f[2] - d[0]) / (c[0] - d[0])] : e & 1 ? [f[0], d[1] + (c[1] - d[1]) * (f[0] - d[0]) / (c[0] - d[0])] : null
    };
    this.lineClip = function(n, l, h) {
        var k, j, d, m;
        if (!l) {
            l = this.setClipBoundaries();
            l[2] += l[0];
            l[3] += l[1]
        }
        if (!h) {
            h = []
        }
        var g = n.length;
        var e = this.bitCode(n[0], l);
        var c = [];
        for (var f = 1; f < g; f++) {
            k = n[f - 1];
            j = n[f];
            d = m = this.bitCode(j, l);
            while (true) {
                if (!(e | d)) {
                    c.push(k);
                    if (d !== m) {
                        c.push(j);
                        if (f < g - 1) {
                            h.push(c);
                            c = []
                        }
                    } else {
                        if (f === g - 1) {
                            c.push(j)
                        }
                    }
                    break
                } else {
                    if (e & d) {
                        break
                    } else {
                        if (e) {
                            k = this.intersect(k, j, e, l);
                            e = this.bitCode(k, l)
                        } else {
                            j = this.intersect(k, j, d, l);
                            d = this.bitCode(j, l)
                        }
                    }
                }
            }
            e = m
        }
        if (c.length) {
            h.push(c)
        }
        return h
    };
    this.polygonClip = function(k, j, c) {
        var h, d, g, a, e;
        if (!j) {
            j = this.setClipBoundaries();
            j[2] += j[0];
            j[3] += j[1]
        }
        if (c) {
            xy = [];
            for (var f = 1; f < k.length; f += 2) {
                xy.push([k[f], k[f + 1]])
            }
        } else {
            xy = k
        }
        for (var b = 1; b <= 8; b *= 2) {
            h = [];
            d = xy[xy.length - 1];
            g = !(this.bitCode(d, j) & b);
            for (var f = 0; f < xy.length; f++) {
                a = xy[f];
                e = !(this.bitCode(a, j) & b);
                if (e !== g) {
                    h.push(this.intersect(d, a, b, j))
                }
                if (e) {
                    h.push(a)
                }
                d = a;
                g = e
            }
            xy = h;
            if (!xy.length) {
                break
            }
        }
        if (c) {
            k = ["poly"];
            for (var f = 0; f < h.length; f++) {
                k.push(h[f][0]);
                k.push(h[f][1])
            }
            return k
        }
        return h
    };
    this.lineIntersect = function(e, l, d, j, b, h, m, g) {
        if ((e === d && l === j) || (b === m && h === g)) {
            return false
        }
        var f = ((g - h) * (d - e) - (m - b) * (j - l));
        if (f === 0) {
            return false
        }
        var c = ((m - b) * (l - h) - (g - h) * (e - b)) / f;
        var a = ((d - e) * (l - h) - (j - l) * (e - b)) / f;
        if (c < 0 || c > 1 || a < 0 || a > 1) {
            return false
        }
        var k = e + c * (d - e);
        var i = l + c * (j - l);
        return [k, i]
    };
    this.clip = function(v, f, k) {
        var d, c, p, n, j, o, v;
        var q, e, a, m;
        var u = [];
        if (!k) {
            k = this.setClipBoundaries()
        }
        var e = k[0];
        var q = k[1];
        var a = k[2];
        var m = k[3];
        switch (v) {
            case "path":
                u[0] = [];
                u[1] = [];
                for (var g = 0; g < f[0].length; g++) {
                    c = f[0][g];
                    n = f[1][g];
                    if (c < e || c > a) {
                        c = null
                    }
                    if (n < q || n > m) {
                        n = null
                    }
                    u[0].push(c);
                    u[1].push(n)
                }
                break;
            case "arrow":
            case "box":
            case "rect":
            case "rectangle":
            case "rect2":
            case "rect3":
            case "roundrect":
            case "roundrectt":
            case "roundrectb":
            case "roundrectr":
            case "roundrectl":
            case "roundrecttr":
            case "roundrecttl":
            case "roundrectbr":
            case "roundrectbl":
            case "roundrect2":
            case "roundrectd":
            case "roundrecto":
                d = this.parseInt(f[0] - (f[2] / 2));
                p = this.parseInt(f[1] - (f[3] / 2));
                c = this.parseInt(d + f[2]);
                n = this.parseInt(p + f[3]);
                if (c > d) {
                    if (n > p) {
                        if (d > a + this.outlineWidth || p > m + this.outlineWidth || c < e || n < q) {
                            return false
                        }
                        if (d < e) {
                            d = e
                        }
                        if (c > a) {
                            c = a
                        }
                        if (p < q) {
                            p = q
                        }
                        if (n > m) {
                            n = m
                        }
                    } else {
                        if (d > a + this.outlineWidth || n > m + this.outlineWidth || c < e || p < q) {
                            return false
                        }
                        if (d < e) {
                            d = e
                        }
                        if (c > a) {
                            c = a
                        }
                        if (p > m) {
                            p = m
                        }
                        if (n < q) {
                            n = q
                        }
                    }
                } else {
                    if (n > p) {
                        if (c > a + this.outlineWidth || p > m + this.outlineWidth || d < e || n < q) {
                            return false
                        }
                        if (d > a) {
                            d = a
                        }
                        if (c < e) {
                            c = e
                        }
                        if (p < q) {
                            p = q
                        }
                        if (n > m) {
                            n = m
                        }
                    } else {
                        if (c > a + this.outlineWidth || n > m + this.outlineWidth || d < e || p < q) {
                            return false
                        }
                        if (d > a) {
                            d = a
                        }
                        if (c < e) {
                            c = e
                        }
                        if (p > m) {
                            p = m
                        }
                        if (n < q) {
                            n = q
                        }
                    }
                }
                u = [d, p, c - d, n - p];
                break;
            case "poly":
                break;
            case "circle":
            case "sphere":
            case "square":
            case "triangle":
            case "triangle2":
            case "equilateral":
            case "equilateral2":
            case "diamond":
            case "rhombus":
            case "pentagon":
            case "hexagon":
            case "octagon":
            case "oval":
            case "oval2":
            case "oval3":
            case "arc":
            case "arc2":
            case "ellipse":
            case "ellipse2":
            case "ellipse3":
            case "plus":
            case "minus":
            case "mdavid":
            case "star":
            case "pie":
            case "pie0":
            case "pie1":
            case "pie2":
            case "pie3":
            case "pie4":
            case "pie5":
            case "pie6":
            case "pie7":
            case "pie8":
            case "pie9":
            case "pacman":
            case "pacman2":
                d = parseInt(f[0]);
                p = parseInt(f[1]);
                if (d > e + a || d < e || p < q || p > q + m) {
                    return false
                }
                u = [d, p];
                break;
            case "line":
                d = parseFloat(f[0]);
                p = parseFloat(f[1]);
                c = parseFloat(f[2]);
                n = parseFloat(f[3]);
                if (d == c) {
                    if (d < e || d > a) {
                        return false
                    } else {
                        if (p > n) {
                            if (p < q) {
                                return false
                            } else {
                                if (p > m) {
                                    p = m
                                }
                            }
                            if (n > m) {
                                return false
                            } else {
                                if (n < q) {
                                    n = q
                                }
                            }
                        } else {
                            if (p > m) {
                                return false
                            } else {
                                if (p < q) {
                                    p = q
                                }
                            }
                            if (n < q) {
                                return false
                            } else {
                                if (n > m) {
                                    n = m
                                }
                            }
                        }
                    }
                } else {
                    if (p == n) {
                        if (p < q || p > m) {
                            return false
                        } else {
                            if (d > c) {
                                if (d < e) {
                                    return false
                                } else {
                                    if (d > a) {
                                        d = a
                                    }
                                }
                                if (c > a) {
                                    return false
                                } else {
                                    if (c < e) {
                                        c = e
                                    }
                                }
                            } else {
                                if (d > a) {
                                    return false
                                } else {
                                    if (d < e) {
                                        d = e
                                    }
                                }
                                if (c < e) {
                                    return false
                                } else {
                                    if (c > a) {
                                        c = a
                                    }
                                }
                            }
                        }
                    } else {
                        if (d > c) {
                            if (d < e || c > a) {
                                return false
                            } else {
                                if (p > n) {
                                    if (p < q || n > m) {
                                        return false
                                    } else {
                                        j = p - n;
                                        o = d - c;
                                        if (d > a) {
                                            p -= (d - a) * j / o;
                                            d = a
                                        }
                                        if (p > m) {
                                            d -= (p - m) * o / j;
                                            p = m
                                        }
                                        if (c < e) {
                                            n += (e - c) * j / o;
                                            c = e
                                        }
                                        if (n < q) {
                                            c += (q - n) * o / j;
                                            n = q
                                        }
                                    }
                                } else {
                                    if (n < q || p > m) {
                                        return false
                                    } else {
                                        j = n - p;
                                        o = d - c;
                                        if (d > a) {
                                            p += (d - a) * j / o;
                                            d = a
                                        }
                                        if (p < q) {
                                            d -= (q - p) * o / j;
                                            p = q
                                        }
                                        if (c < e) {
                                            n -= (e - c) * j / o;
                                            c = e
                                        }
                                        if (n > m) {
                                            c += (n - m) * o / j;
                                            n = m
                                        }
                                    }
                                }
                            }
                        } else {
                            if (c < e || d > a) {
                                return false
                            } else {
                                if (p > n) {
                                    if (p < q || n > m) {
                                        return false
                                    } else {
                                        j = p - n;
                                        o = c - d;
                                        if (d < e) {
                                            p -= (e - d) * j / o;
                                            d = e
                                        }
                                        if (p > m) {
                                            d += (p - m) * o / j;
                                            p = m
                                        }
                                        if (c > a) {
                                            n += (c - a) * j / o;
                                            c = a
                                        }
                                        if (n < q) {
                                            c -= (q - n) * o / j;
                                            n = q
                                        }
                                    }
                                } else {
                                    if (n < q || p > m) {
                                        return false
                                    } else {
                                        j = n - p;
                                        o = c - d;
                                        if (d < e) {
                                            p += (e - d) * j / o;
                                            d = e
                                        }
                                        if (p < q) {
                                            d += (q - p) * o / j;
                                            p = q
                                        }
                                        if (c > a) {
                                            n -= (c - a) * j / o;
                                            c = a
                                        }
                                        if (n > m) {
                                            c -= (n - m) * o / j;
                                            n = m
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                u = [d, p, c, n];
                break;
            default:
                return false
        }
        return u
    };
    this.getLineArea = function(P, D, a, B, af, aa, O, T, Q, ab, ac, ad, R, U, V, E) {
        var W = Math.max((O || 1), this.lineWidthEvent);
        var S = [];
        var I = ["poly"];
        P = this.validateBezier(P, D, a, B, af, Q, ab);
        if (P.match(/error/)) {
            if (this.showErrorBars && this.isNumeric([D, a, B, af, O])) {
                D = Math.ceil(D);
                B = Math.ceil(B);
                a = Math.ceil(a);
                af = Math.ceil(af);
                O = Math.ceil(O);
                var K = O / 2;
                if (O > 0) {
                    I = ["poly", D, a - W, B - W, af - W, B - W, af - K, B + W, af - K, B + W, af + K, B - W, af + K, B - W, af + W, D, a + W]
                } else {
                    I = ["poly", B - W, af + W, B - K, af + W, B - K, af - W, B + K, af - W, B + K, af + W, B + W, af + W, D + W, a, D - W, a]
                }
            } else {
                return false
            }
        } else {
            if (P == "spline" || P == "cardinalSpline") {
                if (D.length < 3) {
                    return D.length < 2 ? false : this.getLineArea("line", D[0], a[0], D[1], a[1], aa, O, T, Q, ab, ac, ad, R, U, V)
                }
                for (var Z = 0; Z < D.length; Z++) {
                    I.push(D[Z], a[Z] - W);
                    S.push(a[Z] + W, D[Z])
                }
                I = I.concat(S.reverse())
            } else {
                if (P == "arch") {
                    if (D.length != 3 || a.length != 3) {
                        return false
                    }
                    for (var Z = 0; Z < D.length; Z++) {
                        if (!this.isNumeric([D[Z], a[Z]])) {
                            return false
                        }
                    }
                    S = this.traceQuadraticCurve(D[0], a[0], D[1], a[1], D[2], a[2], 0.25, true);
                    for (var Z = 0; Z < S.length; Z++) {
                        I.push(S[Z][0], S[Z][1])
                    }
                    S = this.traceQuadraticCurve(D[0], a[0], D[1], a[1], D[2], a[2], 0.25);
                    for (var Z = 0; Z < S.length; Z++) {
                        I.push(S[Z][0], S[Z][1])
                    }
                } else {
                    if (P == "arc") {
                        I = ["poly"];
                        S = this.traceArc1(D, a, B, Q, ab, true);
                        for (var Z = 0; Z < S.length; Z++) {
                            I.push(S[Z][0], S[Z][1])
                        }
                        S = this.traceArc1(D, a, B - W, Q, ab);
                        for (var Z = 0; Z < S.length; Z++) {
                            I.push(S[Z][0], S[Z][1])
                        }
                    } else {
                        if (P == "quadratic") {
                            var v = this.perpendicularLinePoints(D, a, B, af, false, Math.min(1, this.arrowQuadraticFactor * Math.abs(R)) * (R > 0 ? -1 : 1));
                            var C = this.shortenLine(D, a, B, af, Q, ab, P, R);
                            var x = this.parallelLinePoints(C[0], C[1], v[0], v[1], W);
                            var u = this.parallelLinePoints(v[0], v[1], C[2], C[3], W);
                            S = this.traceQuadraticCurve(x[0], x[1], x[4], x[5], u[4], u[5], 0.1, true);
                            for (var Z = 0; Z < S.length; Z++) {
                                I.push(S[Z][0], S[Z][1])
                            }
                            var M = [];
                            S = this.traceQuadraticCurve(x[2], x[3], x[6], x[7], u[6], u[7], 0.1, true);
                            for (var Z = 0; Z < S.length; Z++) {
                                M.push(S[Z][1], S[Z][0])
                            }
                            I = I.concat(M.reverse())
                        } else {
                            if (P == "roundLine") {
                                I = ["poly", D - W, a, D - W, af + W, B, af + W, B, af - W, D + W, af - W, D + W, a]
                            } else {
                                if (this.isNumeric([D, a, B, af])) {
                                    var G = this.shortenLine(D, a, B, af, (Q || 0), (ab || 0), P);
                                    D = G[0];
                                    a = G[1];
                                    B = G[2];
                                    af = G[3];
                                    if (ac) {
                                        G = this.clip("line", [D, a, B, af], ad);
                                        if (G) {
                                            D = G[0];
                                            a = G[1];
                                            B = G[2];
                                            af = G[3]
                                        } else {
                                            return false
                                        }
                                    }
                                    if (R && this.isArray(R) && R.length > 0) {
                                        if (this.isNumeric2DArray(R)) {
                                            if (P.match(/bezier/i)) {
                                                if (R[0].length == 6) {
                                                    var ae = [R[0][0], R[0][1]];
                                                    for (var Z = 0; Z < R.length; Z++) {
                                                        ae = ae.concat(R[Z])
                                                    }
                                                    ae.push(R[R.length - 1][0], R[R.length - 1][1]);
                                                    var d = this.cloneObject(ae);
                                                    for (var Z = 0; Z < R.length; Z++) {
                                                        S = this.traceBezierCurve(d[0], d[1] - W, d[2], d[3] - W, d[4], d[5] - W, d[6], d[7] - W, 0.1, true);
                                                        for (var Y = 0; Y < S.length; Y++) {
                                                            I.push(S[Y][0], S[Y][1])
                                                        }
                                                        for (var Y = 0; Y < 6; Y++) {
                                                            d.shift()
                                                        }
                                                    }
                                                    d = this.cloneObject(ae);
                                                    var M = [];
                                                    for (var Z = 0; Z < R.length; Z++) {
                                                        S = this.traceBezierCurve(d[0], d[1] + W, d[2], d[3] + W, d[4], d[5] + W, d[6], d[7] + W, 0.1, true);
                                                        for (var Y = 0; Y < S.length; Y++) {
                                                            M.push(S[Y][1], S[Y][0])
                                                        }
                                                        for (var Y = 0; Y < 6; Y++) {
                                                            d.shift()
                                                        }
                                                    }
                                                    I = I.concat(M.reverse())
                                                } else {
                                                    if (R.length == 4) {
                                                        var x = this.parallelLinePoints(R[0][0], R[0][1], R[1][0], R[1][1], W);
                                                        var u = this.parallelLinePoints(R[2][0], R[2][1], R[3][0], R[3][1], W);
                                                        S = this.traceBezierCurve(x[0], x[1], x[4], x[5], u[0], u[1], u[4], u[5], 0.1, true);
                                                        for (var Y = 0; Y < S.length; Y++) {
                                                            I.push(S[Y][0], S[Y][1])
                                                        }
                                                        S = this.traceBezierCurve(x[2], x[3], x[6], x[7], u[2], u[3], u[6], u[7], 0.1, true);
                                                        var M = [];
                                                        for (var Y = 0; Y < S.length; Y++) {
                                                            M.push(S[Y][1], S[Y][0])
                                                        }
                                                        I = I.concat(M.reverse())
                                                    } else {
                                                        var A = this.parallelLinePoints(R[0][0], R[0][1], R[R.length - 1][0], R[R.length - 1][1], W);
                                                        I = ["poly", A[0], A[1], A[2], A[3], A[6], A[7], A[4], A[5]]
                                                    }
                                                }
                                            } else {
                                                if (R.length > 2) {
                                                    I = ["poly"];
                                                    var L = [];
                                                    for (var Z = 0; Z < R.length - 1; Z++) {
                                                        L.push([R[Z][0], R[Z][1]])
                                                    }
                                                    for (var Z = R.length - 1; Z >= 1; Z--) {
                                                        L.push([R[Z][0], R[Z][1]])
                                                    }
                                                    S = this.enlargePolygon(L, W, 1);
                                                    for (var Z = 0; Z < S.length; Z++) {
                                                        I.push(S[Z][0], S[Z][1])
                                                    }
                                                } else {
                                                    var A = this.parallelLinePoints(R[0][0], R[0][1], R[1][0], R[1][1], W);
                                                    I = ["poly", A[0], A[1], A[2], A[3], A[6], A[7], A[4], A[5]]
                                                }
                                            }
                                        } else {
                                            return false
                                        }
                                    } else {
                                        if (P.match(/curved/i)) {
                                            var z = D == B && a == af && E;
                                            var o = this.lineMidPoint(D, a, B, af);
                                            var N = this.lineLength(D, a, o[0], o[1]);
                                            var J = (Q || 0) / N;
                                            var F = (ab || 0) / N;
                                            var y = P.match(/curvedcc/i) && D > B ? false : !P.match(/curvedcc/i) && B >= D ? true : false;
                                            var l = B >= D ? Math.asin((o[1] - a) / N) : Math.asin(-(o[1] - a) / N);
                                            var X = l + Math.PI;
                                            var k = [];
                                            if (z) {
                                                if (l < 0) {
                                                    l += Math.PI * 2
                                                }
                                                var r = E.size * 1.25;
                                                var H = E.size / 1.25;
                                                switch (E.pos) {
                                                    case "top":
                                                        k = [D, a - r, H, Math.PI * 0.75, Math.PI * 0.25, false];
                                                        break;
                                                    case "topRight":
                                                        k = [D + r, a - r, H, Math.PI, Math.PI * 0.5, false];
                                                        break;
                                                    case "right":
                                                        k = [D + r, a, H, Math.PI * 1.25, Math.PI * 0.75, false];
                                                        break;
                                                    case "bottomRight":
                                                        k = [D + r, a + r, H, Math.PI * 1.5, Math.PI, false];
                                                        break;
                                                    case "bottom":
                                                        k = [D, a + r, H, Math.PI * 1.75, Math.PI * 1.25, false];
                                                        break;
                                                    case "bottomLeft":
                                                        k = [D - r, a + r, H, 0, Math.PI * 1.5, false];
                                                        break;
                                                    case "left":
                                                        k = [D - r, a, H, Math.PI * 0.25, Math.PI * 1.75, false];
                                                        break;
                                                    case "topLeft":
                                                        k = [D - r, a - r, H, Math.PI * 0.5, 0, false];
                                                        break
                                                }
                                            } else {
                                                if (B >= D) {
                                                    k = [o[0], o[1], Math.max(0, N), l - F, X + J, y]
                                                } else {
                                                    k = [o[0], o[1], Math.max(0, N), l + J, X - F, y]
                                                }
                                            }
                                            I = ["poly"];
                                            S = this.traceArc(k[0], k[1], k[2] + W, k[3], k[4], k[5]);
                                            for (var Z = 0; Z < S.length; Z++) {
                                                I.push(S[Z][0], S[Z][1])
                                            }
                                            S = this.traceArc(k[0], k[1], k[2] - W, k[3], k[4], !k[5]);
                                            for (var Z = 0; Z < S.length; Z++) {
                                                I.push(S[Z][0], S[Z][1])
                                            }
                                        } else {
                                            if (P.match(/bezier/i)) {
                                                var h = (D + B) / 2;
                                                var g = (a + af) / 2;
                                                if (P.match(/beziery/i)) {
                                                    S = this.traceBezierCurve(D, a - W, D, g - W, B, g - W, B, af - W, 0.25, true)
                                                } else {
                                                    S = this.traceBezierCurve(D, a - W, h, a - W, h, af - W, B, af - W, 0.25, true)
                                                }
                                                for (var Z = 0; Z < S.length; Z++) {
                                                    I.push(S[Z][0], S[Z][1])
                                                }
                                                if (P.match(/beziery/i)) {
                                                    S = this.traceBezierCurve(D, a + W, D, g + W, B, g + W, B, af + W, 0.25)
                                                } else {
                                                    S = this.traceBezierCurve(D, a + W, h, a + W, h, af + W, B, af + W, 0.25)
                                                }
                                                for (var Z = 0; Z < S.length; Z++) {
                                                    I.push(S[Z][0], S[Z][1])
                                                }
                                            } else {
                                                if (D == B && a != af) {
                                                    I = ["poly", D - W, a, D + W, a, B + W, af, B - W, af]
                                                } else {
                                                    if (a == af && D != B) {
                                                        I = ["poly", D, a - W, B, a - W, B, af + W, D, af + W]
                                                    } else {
                                                        var A = this.parallelLinePoints(D, a, B, af, W);
                                                        I = ["poly", A[0], A[1], A[2], A[3], A[6], A[7], A[4], A[5]]
                                                    }
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    return false
                                }
                            }
                        }
                    }
                }
            }
        }
        if (this.graphType == "Network") {
            return this.preScaleNetwork && !this.isAnimation ? I : this.adjustNetworkObjects(I)
        } else {
            return I
        }
    };
    this.setDashDot = function(c, a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        var b = [];
        this.tempCap = a.lineCap;
        if (c.match(/blank/i)) {
            b = CanvasXpress.R.lty[0]
        } else {
            if (c.match(/solid/i)) {
                b = CanvasXpress.R.lty[1]
            } else {
                if (c.match(/dashed/i)) {
                    b = CanvasXpress.R.lty[2];
                    b = [this.dashLength, this.dashLength - 2]
                } else {
                    if (c.match(/dotted/i)) {
                        b = CanvasXpress.R.lty[3];
                        b = [this.dotLength, this.dotLength + 2]
                    } else {
                        if (c.match(/dotdash/i)) {
                            b = CanvasXpress.R.lty[4]
                        } else {
                            if (c.match(/longdash/i)) {
                                b = CanvasXpress.R.lty[5]
                            } else {
                                if (c.match(/twodash/i)) {
                                    b = CanvasXpress.R.lty[6]
                                }
                            }
                        }
                    }
                }
            }
        }
        a.setLineDash(b)
    };
    this.resetDashDot = function(a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        a.lineCap = this.tempCap;
        a.setLineDash([])
    };
    this.validateBezier = function(c, b, g, a, f, d, h) {
        if (this.adjustBezier) {
            if (c.match(/bezier/i) && (b == a || g == f)) {
                return "line"
            }
            if (Math.abs(a - b) >= Math.abs(f - g)) {
                if (c.match(/beziery/i)) {
                    c = c.replace("beziery", "bezier");
                    c = c.replace("bezierY", "bezier")
                }
            } else {
                if (c.match(/bezierx/i)) {
                    c = c.replace("bezierx", "beziery");
                    c = c.replace("bezierX", "bezierY")
                } else {
                    if (c.match(/bezier/i)) {
                        c = c.replace("bezier", "bezierY")
                    }
                }
            }
            if (d != null && h != null) {
                if (c.match(/beziery/i)) {
                    if (f > g) {
                        if (g + d > f - h) {
                            c = "line"
                        }
                    } else {
                        if (g - d < f + h) {
                            c = "line"
                        }
                    }
                } else {
                    if (c.match(/beziery/i)) {
                        if (a > b) {
                            if (b + d > a - h) {
                                c = "line"
                            }
                        } else {
                            if (b - d < a + h) {
                                c = "line"
                            }
                        }
                    }
                }
            }
        }
        return c
    };
    this.drawLine = function(N, z, a, x, ad, W, M, R, P, Y, Z, ab, Q, S, T, A, K, B) {
        if (!B) {
            B = this.getCanvasContext()
        }
        this.setDashDot(N, B);
        N = this.validateBezier(N, z, a, x, ad, P, Y);
        var d = false;
        var H = function() {
            var c = Math.sqrt(Math.pow(x - z, 2) + Math.pow(ad - a, 2));
            var b = ad > a ? this.roundedPolygonRadius / c : (c - this.roundedPolygonRadius) / c;
            return [z + (b * (x - z)), a + (b * (ad - a))]
        };
        var C = function(b) {
            switch (b) {
                case "arrow":
                    d = 0;
                    break;
                case "square":
                    d = 1;
                    break;
                case "round":
                    d = 2;
                    break;
                case "roundDocked":
                    d = false;
                    break
            }
        };
        if (N.match(/error/)) {
            if (this.showErrorBars && this.isNumeric([z, a, x, ad, M])) {
                z = Math.ceil(z);
                x = Math.ceil(x);
                a = Math.ceil(a);
                ad = Math.ceil(ad);
                M = Math.ceil(M);
                var J = M / 2;
                this.setStyle(W, false, R, B);
                if (!this.isColorTransparent(W, true)) {
                    B.beginPath();
                    this.lineTo(z, a, x, ad, B);
                    if (Math.abs(M) > this.errorBarsWidth) {
                        if (M > 0) {
                            this.lineTo(x, ad - J, x, ad + J, B)
                        } else {
                            this.lineTo(x - J, ad, x + J, ad, B)
                        }
                    }
                }
            }
            this.resetStyle(B)
        } else {
            if (N.match(/spline|cardinalSpline/i)) {
                if (z.length < 3) {
                    return z.length < 2 ? false : this.drawLine(N == "dashedSpline" ? "dashedLine" : "line", z[0], a[0], z[1], a[1], W, M, R, P, Y, Z, ab, Q, S, T, false, false, B)
                }
                var O = [];
                var aa = [];
                var X = 0;
                for (var V = 0; V < z.length; V++) {
                    if (this.isNumeric([z[V], a[V]])) {
                        aa.push(z[V], a[V]);
                        X += 2
                    } else {
                        return
                    }
                }
                this.setStyle(W, M, R, B);
                if (!this.isColorTransparent(W, true)) {
                    if (N.match(/spline/i)) {
                        for (var V = 0; V < X - 4; V += 2) {
                            O = O.concat(this.splineControlPoint(aa[V], aa[V + 1], aa[V + 2], aa[V + 3], aa[V + 4], aa[V + 5]))
                        }
                        B.beginPath();
                        B.moveTo(aa[0], aa[1]);
                        B.quadraticCurveTo(O[0], O[1], aa[2], aa[3]);
                        for (var V = 2; V < X - 5; V += 2) {
                            B.bezierCurveTo(O[2 * V - 2], O[2 * V - 1], O[2 * V], O[2 * V + 1], aa[V + 2], aa[V + 3])
                        }
                        B.moveTo(aa[X - 2], aa[X - 1]);
                        B.quadraticCurveTo(O[2 * X - 10], O[2 * X - 9], aa[X - 4], aa[X - 3]);
                        B.stroke()
                    } else {
                        aa = this.curvePoints(aa);
                        B.beginPath();
                        B.moveTo(aa[0], aa[1]);
                        for (var V = 2; V < aa.length - 1; V += 2) {
                            B.lineTo(aa[V], aa[V + 1])
                        }
                        B.stroke()
                    }
                }
                this.resetStyle(B)
            } else {
                if (N.match(/arch/)) {
                    if (z.length != 3 || a.length != 3) {
                        return false
                    }
                    for (var V = 0; V < z.length; V++) {
                        if (!this.isNumeric([z[V], a[V]])) {
                            return false
                        }
                    }
                    this.setStyle(W, M, R, B);
                    if (!this.isColorTransparent(W, true)) {
                        B.beginPath();
                        B.moveTo(z[0], a[0]);
                        B.quadraticCurveTo(z[1], a[1], z[2], a[2]);
                        B.stroke()
                    }
                    this.resetStyle(B)
                } else {
                    if (N == "arc") {
                        this.setStyle(W, M, R, B);
                        B.beginPath();
                        B.arc(z, a, Math.max(0, x), P, Y, false);
                        B.stroke();
                        this.resetStyle(B)
                    } else {
                        if (N == "quadratic") {
                            this.setStyle(W, M, R, B);
                            var r = this.perpendicularLinePoints(z, a, x, ad, false, Math.min(1, this.arrowQuadraticFactor * Math.abs(Q)) * (Q > 0 ? -1 : 1));
                            var y = this.shortenLine(z, a, x, ad, P, Y, N, Q);
                            var ac = this.traceQuadraticCurve(y[0], y[1], r[0], r[1], y[2], y[3], 0.1, true);
                            B.beginPath();
                            B.moveTo(y[0], y[1]);
                            B.quadraticCurveTo(r[0], r[1], y[2], y[3]);
                            B.stroke();
                            this.resetStyle(B);
                            if (T) {
                                z = ac[9][0];
                                a = ac[9][1];
                                x = y[2];
                                ad = y[3];
                                C(T);
                                this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                            }
                            if (S) {
                                z = ac[1][0];
                                a = ac[1][1];
                                x = y[0];
                                ad = y[1];
                                C(S);
                                this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                            }
                        } else {
                            if (N == "roundLine") {
                                this.setStyle(W, M, R, B);
                                B.beginPath();
                                B.moveTo(z, a);
                                if (a > ad) {
                                    B.lineTo(z, ad + this.roundedPolygonRadius);
                                    if (z > x) {
                                        B.quadraticCurveTo(z, ad, z + this.roundedPolygonRadius, ad)
                                    } else {
                                        B.quadraticCurveTo(z, ad, z - this.roundedPolygonRadius, ad)
                                    }
                                } else {
                                    B.lineTo(z, ad - this.roundedPolygonRadius);
                                    if (z > x) {
                                        B.quadraticCurveTo(z, ad, z - this.roundedPolygonRadius, ad)
                                    } else {
                                        B.quadraticCurveTo(z, ad, z + this.roundedPolygonRadius, ad)
                                    }
                                }
                                B.lineTo(x, ad);
                                B.stroke();
                                this.resetStyle(B);
                                if (T) {
                                    C(T);
                                    this.drawArrowHead(z, ad, x, ad, W, M, d, false, B)
                                }
                                if (S) {
                                    C(S);
                                    this.drawArrowHead(z, ad, x, ad, W, M, d, true, B)
                                }
                            } else {
                                if (this.isNumeric([z, a, x, ad])) {
                                    var E = this.shortenLine(z, a, x, ad, (P || 0), (Y || 0), N);
                                    z = E[0];
                                    a = E[1];
                                    x = E[2];
                                    ad = E[3];
                                    if (Z) {
                                        E = this.clip("line", [z, a, x, ad], ab);
                                        if (E) {
                                            z = E[0];
                                            a = E[1];
                                            x = E[2];
                                            ad = E[3]
                                        } else {
                                            return false
                                        }
                                    }
                                    if (Q && this.isArray(Q) && Q.length > 0) {
                                        var G = Q.length - 1;
                                        if (this.isNumeric2DArray(Q)) {
                                            this.setStyle(W, M, R, B);
                                            if (N.match(/bezier/i)) {
                                                if (!this.isColorTransparent(W, true)) {
                                                    if (Q[0].length == 6) {
                                                        B.beginPath();
                                                        B.moveTo(Q[0][0], Q[0][1]);
                                                        for (var V = 0; V < Q.length; V++) {
                                                            B.bezierCurveTo(Q[V][0], Q[V][1], Q[V][2], Q[V][3], Q[V][4], Q[V][5])
                                                        }
                                                        B.stroke();
                                                        var ac;
                                                        if (T) {
                                                            ac = this.traceBezierCurve(Q[G][0], Q[G][1], Q[G][0], Q[G][1], Q[G][2], Q[G][3], Q[G][4], Q[G][5], 0.1, true);
                                                            z = ac[9][0];
                                                            a = ac[9][1];
                                                            x = ac[10][0];
                                                            ad = ac[10][1];
                                                            C(T);
                                                            this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                                                        }
                                                        if (S) {
                                                            ac = this.traceBezierCurve(Q[0][0], Q[0][1], Q[0][0], Q[0][1], Q[0][2], Q[0][3], Q[0][4], Q[0][5], 0.1, true);
                                                            z = ac[1][0];
                                                            a = ac[1][1];
                                                            x = ac[0][0];
                                                            ad = ac[0][1];
                                                            C(S);
                                                            this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                                                        }
                                                    } else {
                                                        if (Q.length == 4) {
                                                            B.beginPath();
                                                            B.moveTo(Q[0][0], Q[0][1]);
                                                            B.bezierCurveTo(Q[1][0], Q[1][1], Q[2][0], Q[2][1], Q[3][0], Q[3][1]);
                                                            B.stroke();
                                                            var ac = this.traceBezierCurve(Q[0][0], Q[0][1], Q[1][0], Q[1][1], Q[2][0], Q[2][1], Q[3][0], Q[3][1], 0.1, true);
                                                            if (T) {
                                                                z = ac[9][0];
                                                                a = ac[9][1];
                                                                x = Q[3][0];
                                                                ad = Q[3][1];
                                                                C(T);
                                                                this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                                                            }
                                                            if (S) {
                                                                z = ac[1][0];
                                                                a = ac[1][1];
                                                                x = Q[1][0];
                                                                ad = Q[1][1];
                                                                C(S);
                                                                this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                                                            }
                                                        } else {
                                                            B.beginPath();
                                                            B.moveTo(Q[0][0], Q[0][1]);
                                                            this.lineTo(Q[G][0], Q[G][1], false, false, B);
                                                            B.stroke();
                                                            if (T) {
                                                                z = Q[G - 1][0];
                                                                a = Q[G - 1][1];
                                                                x = Q[G][0];
                                                                ad = Q[G][1];
                                                                C(T);
                                                                this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                                                            }
                                                            if (S) {
                                                                z = Q[0][0];
                                                                a = Q[0][1];
                                                                x = Q[1][0];
                                                                ad = Q[1][1];
                                                                C(S);
                                                                this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (!this.isColorTransparent(W, true)) {
                                                    B.beginPath();
                                                    this.lineTo(Q[0][0], Q[0][1], Q[1][0], Q[1][1], B);
                                                    for (var V = 1; V < G; V++) {
                                                        this.lineTo(Q[V][0], Q[V][1], Q[V + 1][0], Q[V + 1][1], B)
                                                    }
                                                    if (T) {
                                                        z = Q[G - 1][0];
                                                        a = Q[G - 1][1];
                                                        x = Q[G][0];
                                                        ad = Q[G][1];
                                                        C(T);
                                                        this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                                                    }
                                                    if (S) {
                                                        z = Q[0][0];
                                                        a = Q[0][1];
                                                        x = Q[1][0];
                                                        ad = Q[1][1];
                                                        C(S);
                                                        this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                                                    }
                                                }
                                            }
                                            this.resetStyle(B)
                                        } else {
                                            return false
                                        }
                                    } else {
                                        if (N.match(/curved/i)) {
                                            var v = z == x && a == ad && A;
                                            var l = this.lineMidPoint(z, a, x, ad);
                                            var L = this.lineLength(z, a, l[0], l[1]);
                                            var I = (P || 0) / L;
                                            var D = (Y || 0) / L;
                                            var u = N.match(/curvedcc/i) && z > x ? false : !N.match(/curvedcc/i) && x >= z ? true : false;
                                            var k = x >= z ? Math.asin((l[1] - a) / L) : Math.asin(-(l[1] - a) / L);
                                            var U = k + Math.PI;
                                            var j = [];
                                            this.setStyle(W, M, R, B);
                                            if (!this.isColorTransparent(W, true)) {
                                                B.beginPath();
                                                if (v) {
                                                    if (k < 0) {
                                                        k += Math.PI * 2
                                                    }
                                                    if (A.dir) {
                                                        T = false;
                                                        S = A.end
                                                    } else {
                                                        T = A.end;
                                                        S = false
                                                    }
                                                    var o = A.size * 1.25;
                                                    var F = A.size / 1.25;
                                                    switch (A.pos) {
                                                        case "top":
                                                            j = [z, a - o, F, Math.PI * 0.75, Math.PI * 0.25, false];
                                                            break;
                                                        case "topRight":
                                                            j = [z + o, a - o, F, Math.PI, Math.PI * 0.5, false];
                                                            break;
                                                        case "right":
                                                            j = [z + o, a, F, Math.PI * 1.25, Math.PI * 0.75, false];
                                                            break;
                                                        case "bottomRight":
                                                            j = [z + o, a + o, F, Math.PI * 1.5, Math.PI, false];
                                                            break;
                                                        case "bottom":
                                                            j = [z, a + o, F, Math.PI * 1.75, Math.PI * 1.25, false];
                                                            break;
                                                        case "bottomLeft":
                                                            j = [z - o, a + o, F, 0, Math.PI * 1.5, false];
                                                            break;
                                                        case "left":
                                                            j = [z - o, a, F, Math.PI * 0.25, Math.PI * 1.75, false];
                                                            break;
                                                        case "topLeft":
                                                            j = [z - o, a - o, F, Math.PI * 0.5, 0, false];
                                                            break
                                                    }
                                                } else {
                                                    if (x >= z) {
                                                        j = [l[0], l[1], Math.max(0, L), k - D, U + I, u]
                                                    } else {
                                                        j = [l[0], l[1], Math.max(0, L), k + I, U - D, u]
                                                    }
                                                }
                                                B.arc(j[0], j[1], j[2], j[3], j[4], j[5]);
                                                var ac = this.traceArc(j[0], j[1], j[2], j[3], j[4], j[5]);
                                                B.stroke()
                                            }
                                            this.resetStyle(B);
                                            if (T) {
                                                C(T);
                                                z = ac[15][0];
                                                a = ac[15][1];
                                                x = ac[16][0];
                                                ad = ac[16][1];
                                                this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                                            }
                                            if (S) {
                                                z = ac[1][0];
                                                a = ac[1][1];
                                                x = ac[0][0];
                                                ad = ac[0][1];
                                                C(S);
                                                this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                                            }
                                        } else {
                                            if (N.match(/bezier/i)) {
                                                var h = (z + x) / 2;
                                                var g = (a + ad) / 2;
                                                var ac;
                                                this.setStyle(W, M, R, B);
                                                if (!this.isColorTransparent(W, true)) {
                                                    B.beginPath();
                                                    B.moveTo(z, a);
                                                    if (this.graphType == "Tree" && this.treeCircular && K) {
                                                        B.bezierCurveTo(K[2], K[3], K[0], K[1], x, ad);
                                                        ac = this.traceBezierCurve(z, a, K[0], K[1], K[0], K[1], x, ad, 0.1, true)
                                                    } else {
                                                        if (N.match(/beziery/i)) {
                                                            B.bezierCurveTo(z, g, x, g, x, ad);
                                                            ac = this.traceBezierCurve(z, a, z, g, x, g, x, ad, 0.1, true)
                                                        } else {
                                                            B.bezierCurveTo(h, a, h, ad, x, ad);
                                                            ac = this.traceBezierCurve(z, a, h, a, h, ad, x, ad, 0.1, true)
                                                        }
                                                    }
                                                    B.stroke()
                                                }
                                                this.resetStyle(B);
                                                if (T) {
                                                    z = ac[9][0];
                                                    a = ac[9][1];
                                                    x = ac[10][0];
                                                    ad = ac[10][1];
                                                    C(T);
                                                    this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                                                }
                                                if (S) {
                                                    x = ac[0][0];
                                                    ad = ac[0][1];
                                                    z = ac[1][0];
                                                    a = ac[1][1];
                                                    C(S);
                                                    this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                                                }
                                            } else {
                                                if (N.match(/needle/i)) {
                                                    this.setStyle(W, M, R, B);
                                                    var r = this.parallelLinePoints(z, a, x, ad, M);
                                                    if (!this.isColorTransparent(W, true)) {
                                                        B.beginPath();
                                                        B.moveTo(r[0], r[1]);
                                                        B.lineTo(x, ad);
                                                        B.lineTo(r[2], r[3]);
                                                        B.closePath();
                                                        B.stroke();
                                                        B.fill();
                                                        B.arc(z, a, M * 3, 0, Math.PI * 2);
                                                        B.stroke();
                                                        B.fill()
                                                    }
                                                    this.resetStyle(B)
                                                } else {
                                                    this.setStyle(W, M, R, B);
                                                    if (!this.isColorTransparent(W, true)) {
                                                        B.beginPath();
                                                        if (N.match(/R$/) || this.useRawLines) {
                                                            this.lineRawTo(z, a, x, ad, B)
                                                        } else {
                                                            this.lineTo(z, a, x, ad, B)
                                                        }
                                                    }
                                                    this.resetStyle(B);
                                                    if (T) {
                                                        C(T);
                                                        this.drawArrowHead(z, a, x, ad, W, M, d, false, B)
                                                    }
                                                    if (S) {
                                                        C(S);
                                                        this.drawArrowHead(z, a, x, ad, W, M, d, true, B)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    this.resetDashDot(B);
                                    return false
                                }
                            }
                        }
                    }
                }
            }
        }
        this.resetDashDot(B)
    };
    this.drawArrowHead = function(v, c, t, b, u, l, h, e, q) {
        if (!q) {
            q = this.getCanvasContext()
        }
        var s = function(z, C, f, D) {
            var w = [];
            for (var A = 0; A < z.length; A++) {
                w.push([(z[A][0] * Math.cos(C)) - (z[A][1] * Math.sin(C)), (z[A][0] * Math.sin(C)) + (z[A][1] * Math.cos(C))])
            }
            var B = [];
            for (var A = 0; A < w.length; A++) {
                B.push([w[A][0] + f, w[A][1] + D])
            }
            return B
        };
        var p = this.arrowPointSize;
        var d = Math.max((p / 2) - 1, 1);
        var a = Math.max((p * 2 / 3), 1);
        var n = l ? l / 2 : this.outlineWidth / 2;
        var j = l ? l * 2 : this.outlineWidth * 2;
        var o = h == 1 ? [
            [-n, -p],
            [-n, p]
        ] : h == 0 ? [
            [1.5, -0.5],
            [-p, -d * l],
            [-p, d * l]
        ] : false;
        var m = t - v;
        var k = b - c;
        this.setStyle(u, h == 1 ? l + 2 : l, false, q);
        if (h < 2) {
            var g = s(o, Math.atan2(k, m), t, b);
            q.beginPath();
            q.moveTo(g[0][0], g[0][1]);
            for (var r = 1; r < g.length; r++) {
                if (!isNaN(g[r][0]) && !isNaN(g[r][1])) {
                    q.lineTo(g[r][0], g[r][1])
                }
            }
            if (h == 0) {
                if (!isNaN(g[0][0]) && !isNaN(g[0][1])) {
                    q.lineTo(g[0][0], g[0][1])
                }
                q.closePath();
                q.fill()
            } else {
                q.closePath();
                q.stroke()
            }
        } else {
            if (h == 2) {
                q.beginPath();
                q.arc(t, b, Math.max(0, d * 1.3), 0, Math.PI * 2, true);
                q.closePath();
                q.fill()
            } else {}
        }
        this.resetStyle(q)
    };
    this.createPatterns = function(b) {
        var h = function(c) {
            c.strokeStyle = "rgb(29,137,182)";
            var j = [4, 6, 9, 12, 16, 21, 27, 14, 17, 21, 26];
            var l = [27, 21, 16, 12, 9, 6, 4, 26, 21, 17, 14];
            for (var k = 0; k < j.length; k++) {
                c.moveTo(j[k], l[k]);
                c.arc(j[k], l[k], 2, 0, Math.PI * 2)
            }
            c.moveTo(3, 32);
            c.arc(3, 32, 2, Math.PI, 0);
            c.moveTo(13, 32);
            c.arc(13, 32, 2, Math.PI, 0);
            c.moveTo(32, 3);
            c.arc(32, 3, 2, Math.PI * 0.5, Math.PI * 1.5);
            c.moveTo(32, 13);
            c.arc(32, 13, 2, Math.PI * 0.5, Math.PI * 1.5);
            j = [
                [7, 11],
                [8, 12],
                [11, 14],
                [14, 17],
                [18, 20],
                [22, 24],
                [28, 29]
            ];
            l = [
                [28, 29],
                [22, 24],
                [18, 20],
                [14, 17],
                [11, 14],
                [8, 12],
                [7, 11]
            ];
            for (var k = 0; k < j.length; k++) {
                c.moveTo(j[k][0], l[k][0]);
                c.lineTo(j[k][1], l[k][1])
            }
            c.stroke()
        };
        var g = function(c) {
            c.strokeStyle = "rgb(29,137,182)";
            c.moveTo(3, 0);
            c.arc(3, 0, 2, Math.PI, 0, true);
            c.moveTo(3, 5);
            c.arc(3, 5, 2, Math.PI, 0);
            c.moveTo(6, 1);
            c.lineTo(8, 4);
            c.lineTo(10, 1);
            c.moveTo(13, 0);
            c.arc(13, 0, 2, Math.PI, 0, true);
            c.moveTo(13, 5);
            c.arc(13, 5, 2, Math.PI, 0);
            c.stroke()
        };
        var d = function(c) {
            c.strokeStyle = "rgb(29,137,182)";
            c.moveTo(0, 3);
            c.arc(0, 3, 2, Math.PI * 1.5, Math.PI * 0.5);
            c.moveTo(5, 3);
            c.arc(5, 3, 2, Math.PI * 1.5, Math.PI * 0.5, true);
            c.moveTo(1, 6);
            c.lineTo(4, 8);
            c.lineTo(1, 10);
            c.moveTo(0, 13);
            c.arc(0, 13, 2, Math.PI * 1.5, Math.PI * 0.5);
            c.moveTo(5, 13);
            c.arc(5, 13, 2, Math.PI * 1.5, Math.PI * 0.5, true);
            c.stroke()
        };
        if (!b) {
            b = this.getCanvasContext()
        }
        var e;
        var f = this.$cX("canvas");
        f.width = 5;
        f.height = 5;
        var a = this.get2DCanvasContext(f);
        if (!CanvasXpress.cachePatterns.hasOwnProperty("hatchForward")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(0, 0);
            a.lineTo(5, 5);
            a.stroke();
            CanvasXpress.cachePatterns.hatchForward = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("hatchReverse")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(5, 0);
            a.lineTo(0, 5);
            a.stroke();
            CanvasXpress.cachePatterns.hatchReverse = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("stripeVertical")) {
            f.width = 3;
            f.height = 3;
            a.clearRect(0, 0, 3, 3);
            a.beginPath();
            a.moveTo(1.5, 0);
            a.lineTo(1.5, 3);
            a.stroke();
            CanvasXpress.cachePatterns.stripeVertical = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("stripeHorizontal")) {
            a.clearRect(0, 0, 3, 3);
            a.beginPath();
            a.moveTo(0, 1.5);
            a.lineTo(3, 1.5);
            a.stroke();
            CanvasXpress.cachePatterns.stripeHorizontal = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("polkaDot")) {
            f.width = 5;
            f.height = 5;
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.arc(2.5, 2.5, 2, 0, Math.PI * 2);
            a.fill();
            CanvasXpress.cachePatterns.polkaDot = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("crossHatch")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(0, 0);
            a.lineTo(5, 5);
            a.stroke();
            a.beginPath();
            a.moveTo(5, 0);
            a.lineTo(0, 5);
            a.stroke();
            CanvasXpress.cachePatterns.crossHatch = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("crossStripe")) {
            f.width = 3;
            f.height = 3;
            a.clearRect(0, 0, 3, 3);
            a.beginPath();
            a.moveTo(1.5, 0);
            a.lineTo(1.5, 3);
            a.stroke();
            a.beginPath();
            a.moveTo(0, 1.5);
            a.lineTo(3, 1.5);
            a.stroke();
            CanvasXpress.cachePatterns.crossStripe = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("squares")) {
            f.width = 5;
            f.height = 5;
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.strokeRect(1, 1, 4, 4);
            a.stroke();
            CanvasXpress.cachePatterns.squares = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("circles")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.arc(2.5, 2.5, 1, 0, Math.PI * 2);
            a.stroke();
            CanvasXpress.cachePatterns.circles = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("plus")) {
            f.width = 7;
            f.height = 7;
            a.clearRect(0, 0, 7, 7);
            a.beginPath();
            a.moveTo(3.5, 1);
            a.lineTo(3.5, 6);
            a.stroke();
            a.beginPath();
            a.moveTo(1, 3.5);
            a.lineTo(6, 3.5);
            a.stroke();
            CanvasXpress.cachePatterns.plus = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("minus")) {
            f.width = 7;
            f.height = 7;
            a.clearRect(0, 0, 7, 7);
            a.beginPath();
            a.moveTo(1, 3.5);
            a.lineTo(6, 3.5);
            a.stroke();
            CanvasXpress.cachePatterns.minus = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("bars")) {
            f.width = 7;
            f.height = 7;
            a.clearRect(0, 0, 7, 7);
            a.beginPath();
            a.moveTo(3.5, 1);
            a.lineTo(3.5, 6);
            a.stroke();
            CanvasXpress.cachePatterns.bars = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("squiglesHorizontal")) {
            f.width = 5;
            f.height = 5;
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(0, 5);
            a.lineTo(2.5, 0);
            a.lineTo(5, 5);
            a.stroke();
            CanvasXpress.cachePatterns.squiglesHorizontal = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("squiglesVertical")) {
            f.width = 5;
            f.height = 5;
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(0, 0);
            a.lineTo(5, 2.5);
            a.lineTo(0, 5);
            a.stroke();
            CanvasXpress.cachePatterns.squiglesVertical = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("brickForward")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(0, 0);
            a.lineTo(3, 0);
            a.lineTo(0, 3);
            a.closePath();
            a.stroke();
            a.fill();
            a.beginPath();
            a.moveTo(2, 5);
            a.lineTo(5, 2);
            a.lineTo(5, 5);
            a.closePath();
            a.stroke();
            a.fill();
            CanvasXpress.cachePatterns.brickForward = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("brickReverse")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(5, 0);
            a.lineTo(2, 0);
            a.lineTo(5, 3);
            a.closePath();
            a.stroke();
            a.fill();
            a.beginPath();
            a.moveTo(0, 5);
            a.lineTo(0, 2);
            a.lineTo(3, 5);
            a.closePath();
            a.stroke();
            a.fill();
            CanvasXpress.cachePatterns.brickReverse = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("art")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.arc(2.5, 2.5, 2, 0, Math.PI * 2);
            a.moveTo(0, 5);
            a.lineTo(5, 0);
            a.stroke();
            CanvasXpress.cachePatterns.art = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("pcx")) {
            a.clearRect(0, 0, 5, 5);
            a.beginPath();
            a.moveTo(2, 0);
            a.lineTo(0, 0);
            a.lineTo(0, 3);
            a.lineTo(2, 3);
            a.stroke();
            a.beginPath();
            a.moveTo(3, 3);
            a.lineTo(5, 5);
            a.stroke();
            a.beginPath();
            a.moveTo(5, 3);
            a.lineTo(3, 5);
            a.stroke();
            CanvasXpress.cachePatterns.pcx = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("hatchForward3")) {
            f.width = 5;
            f.height = 3;
            a.clearRect(0, 0, 5, 3);
            a.beginPath();
            a.moveTo(0, 0);
            a.lineTo(5, 3);
            a.stroke();
            CanvasXpress.cachePatterns.hatchForward3 = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("hatchReverse3")) {
            a.clearRect(0, 0, 5, 3);
            a.beginPath();
            a.moveTo(5, 0);
            a.lineTo(0, 3);
            a.stroke();
            CanvasXpress.cachePatterns.hatchReverse3 = b.createPattern(f, "repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneTop")) {
            f.width = 5;
            f.height = 16;
            a.clearRect(0, 0, 5, 16);
            d(a);
            CanvasXpress.cachePatterns.membraneTop = b.createPattern(f, "repeat-x")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneBottom")) {
            f.width = 5;
            f.height = 16;
            a.clearRect(0, 0, 5, 16);
            a.translate(5, 0);
            a.scale(-1, 1);
            d(a);
            CanvasXpress.cachePatterns.membraneBottom = b.createPattern(f, "repeat-x")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneRight")) {
            f.width = 16;
            f.height = 5;
            a.clearRect(0, 0, 16, 5);
            g(a);
            CanvasXpress.cachePatterns.membraneRight = b.createPattern(f, "repeat-y")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneLeft")) {
            f.width = 16;
            f.height = 5;
            a.clearRect(0, 0, 16, 5);
            a.translate(0, 5);
            a.scale(1, -1);
            g(a);
            CanvasXpress.cachePatterns.membraneLeft = b.createPattern(f, "repeat-y")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneTL")) {
            f.width = 32;
            f.height = 32;
            a.clearRect(0, 0, 32, 32);
            h(a);
            CanvasXpress.cachePatterns.membraneTL = b.createPattern(f, "no-repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneBL")) {
            f.width = 32;
            f.height = 32;
            a.clearRect(0, 0, 32, 32);
            a.translate(0, 32);
            a.scale(1, -1);
            h(a);
            CanvasXpress.cachePatterns.membraneBL = b.createPattern(f, "no-repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneTR")) {
            f.width = 32;
            f.height = 32;
            a.clearRect(0, 0, 32, 32);
            a.translate(32, 0);
            a.scale(-1, 1);
            h(a);
            CanvasXpress.cachePatterns.membraneTR = b.createPattern(f, "no-repeat")
        }
        if (!CanvasXpress.cachePatterns.hasOwnProperty("membraneBR")) {
            f.width = 32;
            f.height = 32;
            a.clearRect(0, 0, 32, 32);
            a.translate(32, 32);
            a.scale(-1, -1);
            h(a);
            CanvasXpress.cachePatterns.membraneBR = b.createPattern(f, "no-repeat")
        }
    };
    this.sphere = function(f, e, d, m, h, g, F, E, D) {
        var c = Math.sin(F);
        var A = Math.cos(F);
        var b = Math.sin(E);
        var x = Math.cos(E);
        var a = Math.sin(D);
        var v = Math.cos(D);
        var C = function(j) {
            var k = j.y;
            j.y = (k * A) + (j.z * c * -1);
            j.z = (k * c) + (j.z * A);
            var i = j.x;
            j.x = (i * x) + (j.z * b * -1);
            j.z = (i * b) + (j.z * x);
            var i = j.x;
            j.x = (i * v) + (j.y * a * -1);
            j.y = (i * a) + (j.y * v)
        };
        var l = [];
        var n = Math.PI / 12;
        var t = Math.PI * 2;
        var r = Math.PI / 2;
        for (var B = 1; B >= -1; B -= 2) {
            for (var z = 0; z < r; z += n) {
                var u = Math.cos(z) * m;
                var o = Math.cos(z) * g;
                var q = Math.sin(z) * h * B * -1;
                for (var w = 0; w < t; w += n) {
                    var s = {
                        x: (Math.cos(w) * u),
                        y: q,
                        z: (Math.sin(w) * o)
                    };
                    C(s);
                    s.x += f;
                    s.y += e;
                    s.z += d;
                    if (B > 0) {
                        l.push([s.x, s.y, s.z])
                    } else {
                        l.unshift([s.x, s.y, s.z])
                    }
                }
            }
        }
        return l
    };
    this.roundedPolygon = function(h) {
        var v = function(x, r, i) {
            i.x = r.x - x.x;
            i.y = r.y - x.y;
            i.len = Math.sqrt(i.x * i.x + i.y * i.y);
            i.nx = i.x / i.len;
            i.ny = i.y / i.len;
            i.ang = Math.atan2(i.ny, i.nx)
        };
        var s = [];
        for (var t = 0; t < h.length; t++) {
            s.push({
                x: h[t][0],
                y: h[t][1]
            })
        }
        var m = [];
        var o = this.roundedPolygonRadius;
        var e = {};
        var d = {};
        var u = s.length;
        var c = s[u - 1];
        for (var t = 0; t < u; t++) {
            var b = s[(t) % u];
            var a = s[(t + 1) % u];
            v(b, c, e);
            v(b, a, d);
            var j = e.nx * d.ny - e.ny * d.nx;
            var p = e.nx * d.nx - e.ny * -d.ny;
            var w = Math.asin(j);
            var q = 1;
            var f = false;
            if (p < 0) {
                if (w < 0) {
                    w = Math.PI + w
                } else {
                    w = Math.PI - w;
                    q = -1;
                    f = true
                }
            } else {
                if (w > 0) {
                    q = -1;
                    f = true
                }
            }
            var g;
            var n = w / 2;
            var z = Math.abs(Math.cos(n) * o / Math.sin(n));
            if (z > Math.min(e.len / 2, d.len / 2)) {
                z = Math.min(e.len / 2, d.len / 2);
                g = Math.abs(z * Math.sin(n) / Math.cos(n))
            } else {
                g = o
            }
            var l = b.x + d.nx * z;
            var k = b.y + d.ny * z;
            l += -d.ny * g * q;
            k += d.nx * g * q;
            m.push([l, k, g, e.ang + Math.PI / 2 * q, d.ang - Math.PI / 2 * q, f]);
            c = b;
            b = a
        }
        return m
    };
    this.drawShapeSetShapeStyle = function(j, i, k, d, e, c, b, a, g, l) {
        if (!l) {
            l = this.getCanvasContext()
        }
        this.saveCanvas(l);
        this.translateCanvas(j, i, l);
        if (a) {
            this.rotateCanvas(a, l)
        }
        if (this.transparency != null) {
            e = this.addColorTransparency(e, this.transparency, true)
        }
        if (this.gradient) {
            if (this.gradientType == "radial") {
                l.fillStyle = this.getGradient(0, 0, Math.max(Math.abs(k), Math.abs(d)), false, e)
            } else {
                l.fillStyle = this.getGradient(0, 0, k, d, e)
            }
        } else {
            if (b) {
                switch (b) {
                    case "closed":
                    case "solid":
                        l.fillStyle = e;
                        break;
                    case "open":
                        break;
                    default:
                        if (e) {
                            if (e.match(/0.1\)$/) && c.match(/0.1\)$/)) {
                                l.globalAlpha = 0.1
                            }
                        }
                        l.fillStyle = CanvasXpress.cachePatterns[b] ? CanvasXpress.cachePatterns[b] : e;
                        break
                }
            } else {
                l.fillStyle = e
            }
        }
        l.strokeStyle = c ? c : this.foreground;
        l.lineWidth = g ? g : this.outlineWidth;
        l.lineJoin = this.joinType;
        if ((k && l.lineWidth >= k) || (d && l.lineWidth >= d)) {
            l.strokeStyle = e
        }
        this.setShadow(true, l)
    };
    this.drawShapeDraw = function(d, c, b) {
        if (!b) {
            b = this.getCanvasContext()
        }
        if (d && d.length > 1) {
            var a = d.shift();
            while (a[0] == null || a[1] == null) {
                a = d.shift()
            }
            b.beginPath();
            b.moveTo(a[0] + 0.5, a[1] + 0.5);
            while (d.length > 0) {
                a = d.shift();
                while (a[0] == null || a[1] == null) {
                    a = d.shift()
                }
                b.lineTo(a[0] + 0.5, a[1] + 0.5)
            }
            if (!c) {
                b.closePath()
            }
        }
    };
    this.drawShapeFillStroke = function(b, d, c, a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        if (c && c == "open") {
            a.stroke()
        } else {
            if (d == b || a.strokeStyle == a.fillStyle) {
                a.fill()
            } else {
                a.fill();
                a.stroke()
            }
        }
    };
    this.drawShapeRestore = function(a, d, c, b) {
        if (!b) {
            b = this.getCanvasContext()
        }
        b.globalAlpha = 1;
        this.setShadow(false, b);
        if (c) {}
        this.restoreCanvas(b)
    };
    this.getShapeArea = function(v, m, l, n, G, H, D, C, B, k, L, M, A, I, q, J) {
        var j = this;
        var F = function(d) {
            if (j.graphType == "Network" || v == "arrow") {
                return d
            }
            d.shift();
            var b = ["poly"];
            var f = Math.cos(B);
            var c = Math.sin(B);
            for (var e = 0; e < d.length; e += 2) {
                b.push((f * (m - d[e])) + (c * (l - d[e + 1])) + d[e]);
                b.push((f * (l - d[e + 1])) - (c * (m - d[e])) + d[e + 1])
            }
            return b
        };
        var g, a;
        var N = ["poly"];
        var K = [];
        if (!M) {
            M = this.setClipBoundaries()
        }
        switch (v) {
            case "arc2":
                K = this.traceArc1(m, l, G, A, I, true);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                K = this.traceArc1(m, l, G - n, A, I);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                break;
            case "pie":
                N.push(m, l);
                K = this.traceArc1(m, l, G, A, I, true);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                break;
            case "confidence":
                for (var E = 0; E < m.length; E++) {
                    N.push(m[E][0], l[E][0]);
                    K.push(l[E][1], m[E][1])
                }
                N = this.polygonClip(N.concat(K.reverse()), false, true);
                break;
            case "violin":
            case "fish":
                for (var E = 0; E < m[0].length; E++) {
                    N.push(m[0][E], l[0][E]);
                    K.push(l[1][E], m[1][E])
                }
                N = N.concat(K.reverse());
                break;
            case "bezier":
                K = this.traceBezierCurve(m[0], l[0], m[1], l[1], m[2], l[2], m[3], l[3], 0.25, true);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                K = this.traceBezierCurve(m[0], l[0] + G, m[1], l[1] + G, m[2], l[2] + G, m[3], l[3] + G, 0.25);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                break;
            case "arch":
                K = this.traceQuadraticCurve(m[0], l[0], m[1], l[1], m[2], l[2], 0.25, true);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                K = this.traceArc1(m[4], l[4], G[0], n[2], n[3]);
                for (var E = 1; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                if (m[0] == m[3] && l[0] == l[3] && m[1] == m[4] && l[1] == l[4] && m[2] == m[5] && l[2] == l[5]) {
                    break
                }
                K = this.traceQuadraticCurve(m[3], l[3], m[4], l[4], m[5], l[5], 0.25, true);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                K = this.traceArc1(m[1], l[1], G[1], n[0], n[1]);
                for (var E = 0; E < K.length; E++) {
                    N.push(K[E][0], K[E][1])
                }
                break;
            case "polygon":
            case "roundpolygon":
            case "path":
            case "spline":
            case "hull":
                for (var E = 0; E < m.length; E++) {
                    if (v == "spline") {
                        N.push(m[E], l[E] - 2)
                    } else {
                        N.push(m[E], l[E] - 2);
                        K.unshift(m[E], l[E] + 2)
                    }
                }
                break;
            default:
                g = n / 2;
                a = G / 2;
                break
        }
        switch (v) {
            case "image":
                N = ["rect", m - (g * this.zoom), l - (a * this.zoom), m + (g * this.zoom), l + (a * this.zoom)];
                break;
            case "path":
                N = N.concat(K);
                break;
            case "mdavid":
            case "star":
            case "circle":
            case "sphere":
                N = ["circle", m, l, n];
                break;
            case "drop":
            case "teardrop":
            case "marker":
                N = ["circle", m, l - n, g];
                break;
            case "diamond":
            case "rhombus":
                N = ["poly", m, l - a, m + g, l, m, l + a, m - g, l];
                break;
            case "arrow":
            case "box":
            case "rect":
            case "rectangle":
            case "roundrect":
            case "roundrectt":
            case "roundrectb":
            case "roundrectr":
            case "roundrectl":
            case "roundrecttr":
            case "roundrecttl":
            case "roundrectbr":
            case "roundrectbl":
            case "roundrect2":
            case "roundrectd":
            case "roundrecto":
            case "brace":
            case "square":
            case "pentagon":
            case "hexagon":
            case "octagon":
            case "oval":
            case "arc":
            case "arc3":
            case "ellipse":
            case "plus":
            case "minus":
            case "pch0":
            case "pch1":
            case "pch2":
            case "pch3":
            case "pch4":
            case "pch5":
            case "pch6":
            case "pch7":
            case "pch8":
            case "pch9":
            case "pch10":
            case "pch11":
            case "pch12":
            case "pch13":
            case "pch14":
            case "pch15":
            case "pch16":
            case "pch17":
            case "pch18":
            case "pch21":
            case "pch22":
            case "pch23":
            case "pch24":
            case "pch25":
                N = ["rect", m - g, l - a, m + g, l + a];
                break;
            case "pch19":
                g += 2;
                a += 2;
                N = ["rect", m - g, l - a, m + g, l + a];
                break;
            case "pch20":
                g -= 2;
                a -= 2;
                g = Math.max(2, g);
                a = Math.max(2, a);
                N = ["rect", m - g, l - a, m + g, l + a];
                break;
            case "rect2":
                return this.getShapeArea("rectangle", m, l, n, n / 2, H, D, C, B, k, L, M, A, I, q, J);
            case "rect3":
                return this.getShapeArea("rectangle", m, l, n, n / 3, H, D, C, B, k, L, M, A, I, q, J);
            case "triangle":
            case "equilateral":
                N = ["poly", m, l - a, m + g, l + a, m - g, l + a];
                break;
            case "triangle2":
            case "equilateral2":
                N = ["poly", m, l + a, m + g, l - a, m - g, l - a];
                break;
            case "oval2":
                return this.getShapeArea("oval", m, l, n, n / 2, H, D, C, B, k, L, M, A, I, q, J);
            case "oval3":
                return this.getShapeArea("oval", m, l, n, n / 3, H, D, C, B, k, L, M, A, I, q, J);
            case "ellipse2":
                return this.getShapeArea("ellipse", m, l, n, n / 2, H, D, C, B, k, L, M, A, I, q, J);
            case "ellipse3":
                return this.getShapeArea("ellipse", m, l, n, n / 3, H, D, C, B, k, L, M, A, I, q, J);
            case "pie0":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI / 5, q, J);
            case "pie1":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI / 3.5, q, J);
            case "pie2":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI / 2, q, J);
            case "pie3":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI / 1.5, q, J);
            case "pie4":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI, q, J);
            case "pie5":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI * 1.2, q, J);
            case "pie6":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI * 1.4, q, J);
            case "pie7":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI * 1.6, q, J);
            case "pie8":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI * 1.8, q, J);
            case "pie9":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, 0, Math.PI * 2, q, J);
            case "pacman":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, Math.PI * 1 / 4, Math.PI * 7 / 4, q, J);
            case "pacman2":
                return this.getShapeArea("pie", m, l, n, n / 2, H, D, C, B, k, L, M, Math.PI * 5 / 4, Math.PI * 3 / 4, q, J)
        }
        N = B ? F(N) : N;
        if (this.graphType == "Network") {
            return this.preScaleNetwork && !this.isAnimation ? N : this.adjustNetworkObjects(N)
        } else {
            return N
        }
    };
    this.drawShape = function(ab, W, V, Y, ap, aq, ag, af, ad, U, aw, ay, ac, at, Z, av, O) {
        var T, ax, j, az, ae, aj;
        if (!O) {
            O = this.getCanvasContext()
        }
        if (af) {
            switch (af) {
                case "closed":
                case "solid":
                case "open":
                    break;
                default:
                    var aA = af;
                    af = "closed";
                    this.drawShape(ab, W, V, Y, ap, aq, aq, af, ad, U, aw, ay, ac, at, Z, av);
                    af = aA;
                    break
            }
        }
        switch (ab) {
            case "polygon":
            case "roundpolygon":
            case "path":
            case "spline":
            case "arch":
            case "hull":
            case "confidence":
            case "violin":
            case "bezier":
            case "fish":
                var al = Number.MAX_VALUE;
                var R = Number.MAX_VALUE * -1;
                var ak = Number.MAX_VALUE;
                var P = Number.MAX_VALUE * -1;
                ax = [];
                T = [];
                if (W.length == V.length) {
                    if (ab == "spline" && W.length < 5) {
                        return this.drawShape("polygon", W, V, Y, ap, aq, ag, af, ad, U, aw, ay, ac, at, Z, av)
                    }
                    if (ab == "arch" && (W.length != 6 || V.length != 6 || Y.length != 4 || ap.length != 2)) {
                        return false
                    }
                    if (ab == "bezier") {
                        if (this.isNumeric(W) && this.isNumeric(V) && this.isNumeric(ap)) {
                            for (var ao = 0; ao < W.length; ao++) {
                                al = Math.min(al, W[ao]);
                                R = Math.max(R, W[ao]);
                                ak = Math.min(ak, V[ao]);
                                P = Math.max(P, V[ao]);
                                T.push([W[ao], V[ao]])
                            }
                            W = (al + R) / 2;
                            V = (ak + P) / 2;
                            for (var ao = 0; ao < T.length; ao++) {
                                T[ao][0] -= W;
                                T[ao][1] -= V;
                                ax.push(T[ao][0], T[ao][1])
                            }
                        } else {
                            return false
                        }
                    } else {
                        if (ab == "confidence") {
                            for (var ao = 0; ao < W.length; ao++) {
                                if (W[ao][0] != null && W[ao][1] != null && V[ao][0] != null && V[ao][1] != null && this.isNumeric([W[ao][0], W[ao][1], V[ao][0], V[ao][1]])) {
                                    al = Math.min(al, Math.min(W[ao][0], W[ao][1]));
                                    R = Math.max(R, Math.max(W[ao][0], W[ao][1]));
                                    ak = Math.min(ak, Math.min(V[ao][0], V[ao][1]));
                                    P = Math.max(P, Math.max(V[ao][0], V[ao][1]));
                                    T.push([
                                        [W[ao][0], W[ao][1]],
                                        [V[ao][0], V[ao][1]]
                                    ])
                                }
                            }
                            W = (al + R) / 2;
                            V = (ak + P) / 2;
                            for (var ao = 0; ao < T.length; ao++) {
                                T[ao][0][0] -= W;
                                T[ao][0][1] -= W;
                                T[ao][1][0] -= V;
                                T[ao][1][1] -= V;
                                ax.push([T[ao][0][0], T[ao][0][1]], [T[ao][1][0], T[ao][1][1]])
                            }
                        } else {
                            if (ab == "violin" || ab == "fish") {
                                if (W[0].length == V[0].length && W[1].length == V[1].length && W[0].length == W[1].length) {
                                    for (var ao = 0; ao < W[0].length; ao++) {
                                        if (this.isNumeric([W[0][ao], W[1][ao], V[0][ao], V[1][ao]])) {
                                            al = Math.min(al, Math.min(W[0][ao], W[1][ao]));
                                            R = Math.max(R, Math.max(W[0][ao], W[1][ao]));
                                            ak = Math.min(ak, Math.min(V[0][ao], V[1][ao]));
                                            P = Math.max(P, Math.max(V[0][ao], V[1][ao]));
                                            T.push([
                                                [W[0][ao], W[1][ao]],
                                                [V[0][ao], V[1][ao]]
                                            ])
                                        }
                                    }
                                    W = (al + R) / 2;
                                    V = (ak + P) / 2;
                                    for (var ao = 0; ao < T.length; ao++) {
                                        T[ao][0][0] -= W;
                                        T[ao][0][1] -= W;
                                        T[ao][1][0] -= V;
                                        T[ao][1][1] -= V;
                                        ax.push([T[ao][0][0], T[ao][0][1]], [T[ao][1][0], T[ao][1][1]])
                                    }
                                } else {
                                    return false
                                }
                            } else {
                                for (var ao = 0; ao < W.length; ao++) {
                                    if (W[ao] && V[ao] && this.isNumeric([W[ao], V[ao]])) {
                                        al = Math.min(al, W[ao]);
                                        R = Math.max(R, W[ao]);
                                        ak = Math.min(ak, V[ao]);
                                        P = Math.max(P, V[ao]);
                                        T.push([W[ao], V[ao]])
                                    }
                                }
                                W = ab == "arch" ? W[1] : (al + R) / 2;
                                V = ab == "arch" ? V[1] : (ak + P) / 2;
                                for (var ao = 0; ao < T.length; ao++) {
                                    T[ao][0] -= W;
                                    T[ao][1] -= V;
                                    ax.push(T[ao][0], T[ao][1])
                                }
                            }
                        }
                    }
                } else {
                    return false
                }
                break;
            default:
                if (this.isNumeric([W, V, Y, ap])) {
                    if (aw) {
                        T = this.clip(ab, [W, V, Y, ap], ay);
                        if (T) {
                            if (T.length == 4) {
                                Y = Math.max(1, T[2]);
                                ap = Math.max(1, T[3]);
                                W = T[0] + (Y / 2);
                                V = T[1] + (ap / 2)
                            } else {
                                if (T.length == 2) {
                                    W = T[0];
                                    V = T[1]
                                }
                            }
                        } else {
                            return false
                        }
                    } else {
                        Y = Math.max(1, Y);
                        ap = Math.max(1, ap)
                    }
                    j = Y / 2;
                    az = ap / 2;
                    ae = ap / Y;
                    aj = 1.5
                } else {
                    return false
                }
                break
        }
        switch (ab) {
            case "image":
                var N = Array.isArray(Z) ? this.backgroundImageMD5 : this.getFileName(Z);
                if (Z && (CanvasXpress.cacheImages[N] || CanvasXpress.images[Z])) {
                    this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                    if (CanvasXpress.images[Z]) {
                        this.drawImage(CanvasXpress.images[Z], -j * this.zoom, -az * this.zoom, Y * this.zoom, ap * this.zoom, false, false, false, false, aq, af, O)
                    } else {
                        this.drawImage(CanvasXpress.cacheImages[N], -j * this.zoom, -az * this.zoom, Y * this.zoom, ap * this.zoom, false, false, false, false, aq, af, O)
                    }
                } else {
                    return this.drawShape("rectangle", W, V, Y, ap, "rgba(0,0,0,0.5)", "rgba(0,0,0,0.5)", af, ad, U, aw, ay, ac, at, Z, av)
                }
                break;
            case "circle":
            case "sphere":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                if (!this.isColorTransparent(aq, true) || !this.isColorTransparent(ag, true)) {
                    O.beginPath();
                    O.arc(0, 0, Math.max(0, Y / 2), 0, Math.PI * 2, false);
                    O.closePath();
                    this.drawShapeFillStroke(aq, ag, af, O)
                }
                break;
            case "drop":
            case "teardrop":
            case "marker":
                var F = j * 2 / 3;
                var E = F * 0.5;
                var S = this.graphType == "Map" ? -F * 3 : 0;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.arc(0, S, Math.max(0, j), 0, Math.PI, true);
                O.bezierCurveTo(-j, S + j, 0, S + E, 0, S + (F * 3));
                O.bezierCurveTo(0, S + E, j, S + j, j, S);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                O.beginPath();
                O.arc(0, S, Math.max(0, j * 0.3), 0, Math.PI * 2, true);
                O.closePath();
                this.drawShapeFillStroke("white", "black", af, O);
                break;
            case "arrow":
                T = [
                    [-j, -az],
                    [j, -az],
                    [j, az],
                    [-j, az]
                ];
                if (ad) {
                    ad = false;
                    this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                    var F = ap / 4;
                    O.beginPath();
                    O.moveTo(j - ap, -az);
                    O.lineTo(j - ap, -az - F);
                    O.lineTo(j, 0);
                    O.lineTo(j - ap, az + F);
                    O.lineTo(j - ap, az);
                    O.lineTo(-j, az);
                    O.lineTo(-j, -az);
                    O.closePath();
                    this.drawShapeFillStroke(aq, ag, af, O)
                } else {
                    this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                    var q = Y / 4;
                    O.beginPath();
                    O.moveTo(-j, -az + Y);
                    O.lineTo(-j - q, -az + Y);
                    O.lineTo(0, -az);
                    O.lineTo(j + q, -az + Y);
                    O.lineTo(j, -az + Y);
                    O.lineTo(j, az);
                    O.lineTo(-j, az);
                    O.closePath();
                    this.drawShapeFillStroke(aq, ag, af, O)
                }
                break;
            case "box":
            case "rect":
                T = [
                    [-j, -az],
                    [j, -az],
                    [j, az],
                    [-j, az]
                ];
                this.drawShapeSetShapeStyle(Math.round(W), Math.round(V), Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az);
                O.lineTo(j, -az);
                O.lineTo(j, az);
                O.lineTo(-j, az);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "rectangle":
                T = [
                    [-j, -az],
                    [j, -az],
                    [j, az],
                    [-j, az]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                if (af && af == "open") {
                    O.strokeRect(-j, -az, Y, ap)
                } else {
                    if (ag == aq || O.strokeStyle == O.fillStyle) {
                        O.fillRect(-j, -az, Y, ap)
                    } else {
                        O.fillRect(-j, -az, Y, ap);
                        O.strokeRect(-j, -az, Y, ap)
                    }
                }
                break;
            case "rect2":
                return this.drawShape("rectangle", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, ac, at, Z, av);
                break;
            case "rect3":
                return this.drawShape("rectangle", W, V, Y, Y / 3, aq, ag, af, ad, U, aw, ay, ac, at, Z, av);
                break;
            case "roundrectt":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az + X);
                O.lineTo(-j, az);
                O.lineTo(j, az);
                O.lineTo(j, -az + X);
                O.quadraticCurveTo(j, -az, j - X, -az);
                O.lineTo(-j + X, -az);
                O.quadraticCurveTo(-j, -az, -j, -az + X);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrectb":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az);
                O.lineTo(-j, az - X);
                O.quadraticCurveTo(-j, az, -j + X, az);
                O.lineTo(j - X, az);
                O.quadraticCurveTo(j, az, j, az - X);
                O.lineTo(j, -az);
                O.lineTo(-j, -az);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrectr":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az);
                O.lineTo(-j, az);
                O.lineTo(j - X, az);
                O.quadraticCurveTo(j, az, j, az - X);
                O.lineTo(j, -az + X);
                O.quadraticCurveTo(j, -az, j - X, -az);
                O.lineTo(-j, -az);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrectl":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az + X);
                O.lineTo(-j, az - X);
                O.quadraticCurveTo(-j, az, -j + X, az);
                O.lineTo(j, az);
                O.lineTo(j, -az);
                O.lineTo(-j + X, -az);
                O.quadraticCurveTo(-j, -az, -j, -az + X);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrecttr":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az);
                O.lineTo(-j, az);
                O.lineTo(j, az);
                O.lineTo(j, -az + X);
                O.quadraticCurveTo(j, -az, j - X, -az);
                O.lineTo(-j, -az);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrecttl":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az + X);
                O.lineTo(-j, az);
                O.lineTo(j, az);
                O.lineTo(j, -az);
                O.lineTo(-j + X, -az);
                O.quadraticCurveTo(-j, -az, -j, -az + X);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrectbr":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az);
                O.lineTo(-j, az);
                O.lineTo(j - X, az);
                O.quadraticCurveTo(j, az, j, az - X);
                O.lineTo(j, -az);
                O.lineTo(-j, -az);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrectbl":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap : Y;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az);
                O.lineTo(-j, az - X);
                O.quadraticCurveTo(-j, az, -j + X, az);
                O.lineTo(j, az);
                O.lineTo(j, -az);
                O.lineTo(-j, -az);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrecto":
                var X = Y < ap ? j : az;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                if (Y < ap) {
                    O.arc(0, -az + X, X, Math.PI, 0);
                    O.lineTo(j, az - X);
                    O.arc(0, az - X, X, 0, Math.PI);
                    O.lineTo(-j, -az + X)
                } else {
                    O.arc(-j + X, 0, X, Math.PI * 0.5, Math.PI * 1.5);
                    O.lineTo(j - X, -az);
                    O.arc(j - X, 0, X, Math.PI * 1.5, Math.PI * 0.5);
                    O.lineTo(-j + X, az)
                }
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundrect":
            case "roundrect2":
            case "roundrectd":
                var X = Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius ? this.roundedPolygonRadius : Y > ap ? ap / 4 : Y / 4;
                if (ab == "roundrect2") {
                    X *= 4
                }
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az + X);
                O.lineTo(-j, az - X);
                O.quadraticCurveTo(-j, az, -j + X, az);
                O.lineTo(j - X, az);
                O.quadraticCurveTo(j, az, j, az - X);
                O.lineTo(j, -az + X);
                O.quadraticCurveTo(j, -az, j - X, -az);
                O.lineTo(-j + X, -az);
                O.quadraticCurveTo(-j, -az, -j, -az + X);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                if (ab == "roundrectd" && Y > this.roundedPolygonRadius && ap > this.roundedPolygonRadius) {
                    Y -= this.roundedPolygonRadius;
                    ap -= this.roundedPolygonRadius;
                    j = Y / 2;
                    az = ap / 2;
                    O.beginPath();
                    O.moveTo(-j, -az + X);
                    O.lineTo(-j, az - X);
                    O.quadraticCurveTo(-j, az, -j + X, az);
                    O.lineTo(j - X, az);
                    O.quadraticCurveTo(j, az, j, az - X);
                    O.lineTo(j, -az + X);
                    O.quadraticCurveTo(j, -az, j - X, -az);
                    O.lineTo(-j + X, -az);
                    O.quadraticCurveTo(-j, -az, -j, -az + X);
                    O.closePath();
                    this.drawShapeFillStroke(aq, ag, af, O)
                }
                break;
            case "brace":
                var X = Y > ap ? ap / 4 : Y / 4;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(-j, -az);
                O.bezierCurveTo(-j, 0, 0, 0, 0, az);
                O.bezierCurveTo(0, 0, j, 0, j, -az);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "square":
                T = [
                    [-j, -j],
                    [j, -j],
                    [j, j],
                    [-j, j]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "triangle":
                if (Y == ap) {
                    return this.drawShape("equilateral", W, V, Y, ap, aq, ag, af, ad, U, aw, ay, ac, at, Z, av)
                }
                T = [
                    [0, -az],
                    [j, az],
                    [-j, az]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "triangle2":
                if (Y == ap) {
                    return this.drawShape("equilateral2", W, V, Y, ap, aq, ag, af, ad, U, aw, ay, ac, at, Z, av)
                }
                T = [
                    [0, az],
                    [j, -az],
                    [-j, -az]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "equilateral":
                var X = Y * Math.sqrt(3) / 6;
                var g = X / 2;
                var H = Math.sqrt((X * X) - (g * g));
                T = [
                    [0, -az],
                    [j, az],
                    [-j, az]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "equilateral2":
                var X = Y * Math.sqrt(3) / 6;
                var g = X / 2;
                var H = Math.sqrt((X * X) - (g * g));
                T = [
                    [0, az],
                    [j, -az],
                    [-j, -az]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "diamond":
            case "rhombus":
                T = [
                    [0, -az],
                    [j, 0],
                    [0, az],
                    [-j, 0]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "hexagon":
                var au = Y / 3;
                var v = au - j;
                T = [
                    [v, -az],
                    [-v, -az],
                    [j, 0],
                    [-v, az],
                    [v, az],
                    [-j, 0]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "pentagon":
                var au = Y / 3;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                for (var ao = 0; ao < 5; ao++) {
                    var G = (ao / 5) * Math.PI * 2 + (-Math.PI / 2);
                    O.lineTo(Math.cos(G) * au, Math.sin(G) * au)
                }
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "octagon":
                var aB = Y / 4;
                var an = ap / 4;
                T = [
                    [-aB, -az],
                    [aB, -az],
                    [j, -an],
                    [j, an],
                    [aB, az],
                    [-aB, az],
                    [-j, an],
                    [-j, -an]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "oval":
            case "ovald":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.saveCanvas(O);
                this.scaleCanvas(1, ae, O);
                O.beginPath();
                O.arc(0, 0, Math.max(0, Y / 2), 0, Math.PI * 2, true);
                O.closePath();
                this.restoreCanvas(O);
                this.drawShapeFillStroke(aq, ag, af, O);
                if (ab == "ovald") {
                    Y -= this.margin * 2;
                    ap -= this.margin * 2;
                    ae = ap / Y;
                    this.saveCanvas(O);
                    this.scaleCanvas(1, ae, O);
                    O.beginPath();
                    O.arc(0, 0, Math.max(0, Y / 2), 0, Math.PI * 2, true);
                    O.closePath();
                    this.restoreCanvas(O);
                    this.drawShapeFillStroke(aq, ag, af, O)
                }
                break;
            case "oval2":
                return this.drawShape("oval", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, ac, at, Z, av);
                break;
            case "oval3":
                return this.drawShape("oval", W, V, Y, Y / 3, aq, ag, af, ad, U, aw, ay, ac, at, Z, av);
                break;
            case "arc":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.saveCanvas(O);
                this.scaleCanvas(1, ae, O);
                O.beginPath();
                O.arc(0, 0, Math.max(0, Y / 2), 0, Math.PI, true);
                if (af != "open") {
                    O.closePath()
                }
                this.restoreCanvas(O);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "arc2":
                var J = ap * Math.cos(ac);
                var aE = ap * Math.sin(ac);
                var I = ap * Math.cos(at);
                var aC = ap * Math.sin(at);
                var D = this.shortenLine(0, 0, J, aE, 0, Y, "line");
                var B = this.shortenLine(0, 0, I, aC, 0, Y, "line");
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(D[2], D[3]);
                O.lineTo(J, aE);
                O.arc(0, 0, Math.max(0, ap), ac, at, false);
                O.lineTo(B[2], B[3]);
                O.arc(0, 0, Math.max(0, ap - Y), at, ac, true);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "arc3":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.saveCanvas(O);
                this.scaleCanvas(1, ae, O);
                O.beginPath();
                O.arc(0, 0, Math.max(0, Y / 2), 0, Math.PI, true);
                this.restoreCanvas(O);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "arch":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(T[0][0], T[0][1]);
                O.quadraticCurveTo(T[1][0], T[1][1], T[2][0], T[2][1]);
                O.arc(0, 0, Math.max(0, ap[0]), Y[3], Y[2], true);
                O.quadraticCurveTo(T[4][0], T[4][1], T[5][0], T[5][1]);
                O.arc(0, 0, Math.max(0, ap[1]), Y[1], Y[0], true);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "path":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T, af == "open");
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "roundpolygon":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                T = this.roundedPolygon(T);
                O.beginPath();
                for (var ao = 0; ao < T.length; ao++) {
                    O.arc(T[ao][0], T[ao][1], T[ao][2], T[ao][3], T[ao][4])
                }
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "polygon":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T, af == "open");
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "spline":
                var aa = [];
                var ai = [];
                var K = [];
                ai.push(ax.shift());
                ai.push(ax.shift());
                K.push(ax.pop());
                K.unshift(ax.pop());
                var ah = ax.length;
                for (var ao = 0; ao < ah - 4; ao += 2) {
                    aa = aa.concat(this.splineControlPoint(ax[ao], ax[ao + 1], ax[ao + 2], ax[ao + 3], ax[ao + 4], ax[ao + 5]))
                }
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(ai[0], ai[1]);
                O.lineTo(ax[0], ax[1]);
                O.quadraticCurveTo(aa[0], aa[1], ax[2], ax[3]);
                for (var ao = 2; ao < ah - 5; ao += 2) {
                    O.bezierCurveTo(aa[2 * ao - 2], aa[2 * ao - 1], aa[2 * ao], aa[2 * ao + 1], ax[ao + 2], ax[ao + 3])
                }
                O.quadraticCurveTo(aa[2 * ah - 10], aa[2 * ah - 9], ax[ah - 2], ax[ah - 1]);
                O.lineTo(K[0], K[1]);
                O.lineTo(ai[0], ai[1]);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "hull":
                var am;
                var ah = 1;
                var L = [];
                while (ax.length > 1) {
                    L.push([ax.shift(), ax.shift()])
                }
                var aa = this.hullControlPoints(L);
                var m = [
                    [L[0][0], L[0][1], aa[aa.length - 1][0], aa[aa.length - 1][1], aa[0][0], aa[0][1], L[1][0], L[1][1]]
                ];
                for (var ao = 1; ao < L.length - 1; ao++) {
                    m.push([L[ao][0], L[ao][1], aa[ah][0], aa[ah][1], aa[ah + 1][0], aa[ah + 1][1], L[ao + 1][0], L[ao + 1][1]]);
                    ah += 2
                }
                m.push([L[ao][0], L[ao][1], aa[ah][0], aa[ah][1], aa[ah + 1][0], aa[ah + 1][1], L[0][0], L[0][1]]);
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(m[0][0], m[0][1]);
                for (var ao = 0; ao < m.length; ao++) {
                    O.bezierCurveTo(m[ao][2], m[ao][3], m[ao][4], m[ao][5], m[ao][6], m[ao][7])
                }
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "violin":
                var ah = ax.length;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(ax[0][0], ax[1][0]);
                for (var ao = 2; ao < ah; ao += 2) {
                    O.lineTo(ax[ao][0], ax[ao + 1][0])
                }
                O.lineTo(ax[ah - 2][1], ax[ah - 1][1]);
                for (var ao = 2; ao < ah; ao += 2) {
                    var aD = (ah - 1) - ao;
                    O.lineTo(ax[aD - 1][1], ax[aD][1])
                }
                O.lineTo(ax[0][0], ax[1][0]);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "fish":
                var ah = ax.length;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(ax[0][0], ax[1][0]);
                for (var ao = 2; ao < ah; ao += 2) {
                    var A = (ax[ao - 2][0] + ax[ao][0]) / 2;
                    O.bezierCurveTo(A, ax[ao - 1][0], A, ax[ao + 1][0], ax[ao][0], ax[ao + 1][0])
                }
                O.lineTo(ax[ah - 2][1], ax[ah - 1][1]);
                for (var ao = 2; ao < ah; ao += 2) {
                    var aD = (ah - 1) - ao;
                    var A = (ax[aD + 1][1] + ax[aD - 1][1]) / 2;
                    O.bezierCurveTo(A, ax[aD + 2][1], A, ax[aD][1], ax[aD - 1][1], ax[aD][1])
                }
                O.lineTo(ax[0][0], ax[1][0]);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "confidence":
                var ah = ax.length;
                var aa = [];
                var Q = [];
                for (var ao = 0; ao < ah - 4; ao += 2) {
                    var aD = (ah - 1) - ao;
                    aa = aa.concat(this.splineControlPoint(ax[ao][0], ax[ao + 1][0], ax[ao + 2][0], ax[ao + 3][0], ax[ao + 4][0], ax[ao + 5][0]));
                    Q = Q.concat(this.splineControlPoint(ax[aD - 1][1], ax[aD][1], ax[aD - 3][1], ax[aD - 2][1], ax[aD - 5][1], ax[aD - 4][1]))
                }
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(ax[0][0], ax[1][0]);
                O.quadraticCurveTo(aa[0], aa[1], ax[2][0], ax[3][0]);
                for (var ao = 2; ao < ah - 5; ao += 2) {
                    O.bezierCurveTo(aa[2 * ao - 2], aa[2 * ao - 1], aa[2 * ao], aa[2 * ao + 1], ax[ao + 2][0], ax[ao + 3][0])
                }
                O.quadraticCurveTo(aa[2 * ah - 10], aa[2 * ah - 9], ax[ah - 2][0], ax[ah - 1][0]);
                O.lineTo(ax[ah - 2][1], ax[ah - 1][1]);
                O.quadraticCurveTo(Q[0], Q[1], ax[ah - 4][1], ax[ah - 3][1]);
                for (var ao = 2; ao < ah - 5; ao += 2) {
                    var aD = (ah - 1) - ao;
                    O.bezierCurveTo(Q[2 * ao - 2], Q[2 * ao - 1], Q[2 * ao], Q[2 * ao + 1], ax[aD - 3][1], ax[aD - 2][1])
                }
                O.quadraticCurveTo(Q[2 * ah - 10], Q[2 * ah - 9], ax[0][1], ax[1][1]);
                O.lineTo(ax[0][0], ax[1][0]);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "bezier":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(ax[0], ax[1]);
                O.bezierCurveTo(ax[2], ax[3], ax[4], ax[5], ax[6], ax[7]);
                O.lineTo(ax[6], ax[7] + ap);
                O.bezierCurveTo(ax[4], ax[5] + ap, ax[2], ax[3] + ap, ax[0], ax[1] + ap);
                O.lineTo(ax[0], ax[1]);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "ellipse":
                var a = j * 0.5522848;
                var ar = az * 0.5522848;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.moveTo(0, az);
                O.bezierCurveTo(0, az - ar, j - a, 0, j, 0);
                O.bezierCurveTo(j + a, 0, Y, az - ar, Y, az);
                O.bezierCurveTo(Y, az + ar, j + a, ap, j, ap);
                O.bezierCurveTo(j - a, ap, 0, az + ar, 0, az);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "ellipse2":
                return this.drawShape("ellipse", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, ac, at, Z, av);
                break;
            case "ellipse3":
                return this.drawShape("ellipse", W, V, Y, Y / 3, aq, ag, af, ad, U, aw, ay, ac, at, Z, av);
                break;
            case "plus":
                T = [
                    [-aj, -az],
                    [aj, -az],
                    [aj, -aj],
                    [j, -aj],
                    [j, aj],
                    [aj, aj],
                    [aj, az],
                    [-aj, az],
                    [-aj, aj],
                    [-j, aj],
                    [-j, -aj],
                    [-aj, -aj],
                    [-aj, -az]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "minus":
                T = [
                    [-j, -aj],
                    [j, -aj],
                    [j, aj],
                    [-j, aj],
                    [-j, -aj]
                ];
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.drawShapeDraw(T);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "mdavid":
                var au = Y / 3;
                var C = Math.PI / 6;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.saveCanvas(O);
                this.scaleCanvas(0.8, 0.8, O);
                this.rotateCanvas(M * 0.45, O);
                O.beginPath();
                O.moveTo(au, 0);
                for (var ao = 0; ao < 11; ao++) {
                    this.rotateCanvas(C, O);
                    if (ao % 2 == 0) {
                        O.lineTo((au / 0.55), 0)
                    } else {
                        O.lineTo(au, 0)
                    }
                }
                O.closePath();
                this.restoreCanvas(O);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "star":
                var k = (Y / 4);
                var M = Math.PI / 5;
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                this.saveCanvas(O);
                this.scaleCanvas(0.7, 0.7, O);
                this.rotateCanvas(M * 0.45, O);
                O.beginPath();
                O.moveTo(k, 0);
                for (var ao = 0; ao < 9; ao++) {
                    this.rotateCanvas(M, O);
                    if (ao % 2 == 0) {
                        O.lineTo((k / 0.35), 0)
                    } else {
                        O.lineTo(k, 0)
                    }
                }
                O.closePath();
                this.restoreCanvas(O);
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "pie":
                if (typeof(ac) == "undefined") {
                    ac = 0
                }
                if (typeof(at) == "undefined") {
                    at = Math.PI * 2
                }
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                O.beginPath();
                O.arc(0, 0, Math.max(0, Y / 2), ac, at, false);
                O.lineTo(0, 0);
                O.closePath();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "pie0":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI / 5, Z, av);
                break;
            case "pie1":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI / 3.5, Z, av);
                break;
            case "pie2":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI / 2, Z, av);
                break;
            case "pie3":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI / 1.5, Z, av);
                break;
            case "pie4":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI, Z, av);
                break;
            case "pie5":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI * 1.2, Z, av);
                break;
            case "pie6":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI * 1.4, Z, av);
                break;
            case "pie7":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI * 1.6, Z, av);
                break;
            case "pie8":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI * 1.8, Z, av);
                break;
            case "pie9":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, 0, Math.PI * 2, Z, av);
                break;
            case "pacman":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, Math.PI * 1 / 4, Math.PI * 7 / 4, Z, av);
                break;
            case "pacman2":
                return this.drawShape("pie", W, V, Y, Y / 2, aq, ag, af, ad, U, aw, ay, Math.PI * 5 / 4, Math.PI * 3 / 4, Z, av);
                break;
            case "pch0":
                this.drawShape("square", W, V, Y, Y, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch1":
                this.drawShape("circle", W, V, Y, Y, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch2":
                this.drawShape("equilateral", W, V, Y, Y, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch3":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, "open", false, U, O);
                O.moveTo(0, -az);
                this.lineTo(0, -az, 0, az, O);
                O.stroke();
                O.moveTo(-j, 0);
                this.lineTo(-j, 0, j, 0, O);
                O.stroke();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "pch4":
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, "open", false, U, O);
                O.moveTo(-j, -az);
                this.lineTo(-j, -az, j, az, O);
                O.stroke();
                O.moveTo(j, -az);
                this.lineTo(j, -az, -j, az, O);
                O.stroke();
                this.drawShapeFillStroke(aq, ag, af, O);
                break;
            case "pch5":
                this.drawShape("diamond", W, V, Y, Y, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch6":
                this.drawShape("equilateral2", W, V, Y, Y, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch7":
                this.drawShape("pch0", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch4", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch8":
                this.drawShape("pch3", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch4", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch9":
                this.drawShape("pch3", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch5", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch10":
                this.drawShape("pch1", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch3", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch11":
                this.drawShape("pch2", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch6", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch12":
                this.drawShape("pch0", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch3", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch13":
                this.drawShape("pch1", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch4", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch14":
                this.drawShape("pch0", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                this.drawShape("pch6", W, V, Y, ap, aq, ag, "open", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch15":
            case "pch22":
                this.drawShape("square", W, V, Y, Y, aq || this.foreground, ag, "closed", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch16":
            case "pch21":
                this.drawShape("circle", W, V, Y, Y, aq || this.foreground, ag, "closed", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch17":
            case "pch24":
                this.drawShape("equilateral", W, V, Y, Y, aq || this.foreground, ag, "closed", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch18":
            case "pch23":
                this.drawShape("diamond", W, V, Y, Y, aq || this.foreground, ag, "closed", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch19":
                this.drawShape("circle", W, V, Y + 2, Y + 2, aq || this.foreground, ag, "closed", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch20":
                this.drawShape("circle", W, V, Math.max(2, Y - 2), Math.max(2, Y - 2), aq || this.foreground, ag, "closed", false, U, aw, ay, ac, at, Z, av);
                break;
            case "pch25":
                this.drawShape("equilateral2", W, V, Y, Y, aq || this.foreground, ag, "closed", false, U, aw, ay, ac, at, Z, av);
                break;
            default:
                this.drawShapeSetShapeStyle(W, V, Y, ap, aq, ag, af, ad, U, O);
                break
        }
        if (ab == "box" || ab == "rect") {
            this.drawShapeRestore(Math.round(W), Math.round(V), ad, O)
        } else {
            this.drawShapeRestore(W, V, ad, O)
        }
    };
    this.imageToCanvas = function(a) {
        var b = this.$cX("canvas", {
            width: a.naturalWidth,
            height: a.naturalHeight
        });
        b.ctx = this.get2DCanvasContext(b);
        b.ctx.drawImage(a, 0, 0);
        return b
    };
    this.colorizeImage = function(e, k) {
        var m = this.imageToCanvas(e);
        var b = k ? this.colorAsArray(k) : false;
        var j = m.ctx.getImageData(0, 0, e.naturalWidth, e.naturalHeight);
        var l = j.data;
        for (var e = 0; e < l.length; e += 4) {
            var h = 0.34 * l[e] + 0.5 * l[e + 1] + 0.16 * l[e + 2];
            if (h > 220) {
                h = 255;
                l[e] = h;
                l[e + 1] = h;
                l[e + 2] = h;
                l[e + 3] = 0
            } else {
                l[e] = k ? b[0] : h;
                l[e + 1] = k ? b[1] : h;
                l[e + 2] = k ? b[2] : h
            }
        }
        m.ctx.putImageData(j, 0, 0);
        return m
    };
    this.createImage = function(l) {
        var k = l.length;
        var q = l[0].length;
        var n = this.$cX("canvas", {
            width: q,
            height: k
        });
        n.ctx = this.get2DCanvasContext(n);
        n.ctx.clearRect(0, 0, q, k);
        for (var f = 0; f < k; f++) {
            var s = k - (f + 1);
            for (var e = 0; e < q; e++) {
                var d = parseInt(l[s][e][0] * 255);
                var m = parseInt(l[s][e][1] * 255);
                var o = parseInt(l[s][e][2] * 255);
                var p = l[s][e][3] ? parseInt(l[s][e][3] * 255) : 255;
                n.ctx.fillStyle = "rgba(" + d + "," + m + "," + o + "," + p + ")";
                if (this.scatterType == "visium" && this.visiumFlip) {
                    n.ctx.fillRect(e, f, 1, 1)
                } else {
                    n.ctx.fillRect(e, s, 1, 1)
                }
            }
        }
        if (this.scatterType == "visium") {
            this.backgroundImageRows = k;
            this.backgroundImageCols = q
        }
        return n.toDataURL("img/png")
    };
    this.drawImage = function(x, v, m, j, y, D, s, p, F, g, o, u) {
        if (!u) {
            u = this.getCanvasContext()
        }
        try {
            v = parseInt(Math.round(v || 0));
            m = parseInt(Math.round(m || 0));
            j = parseInt(Math.round(j || x.naturalWidth));
            y = parseInt(Math.round(y || x.naturalHeight));
            if (this.scatterType == "visium") {
                if (this.visiumFlip) {
                    var A = this.xAxisMin;
                    var z = this.xAxisMax;
                    var b = x.naturalHeight - this.yAxisMax;
                    var c = x.naturalHeight - this.yAxisMin;
                    var f = z - A;
                    var E = b - c;
                    var a = j / f;
                    var G = y / E;
                    var k = (j - f) / 2;
                    var B = (y - E) / 2;
                    var n = this.yAxisMax;
                    u.scale(a, G);
                    u.drawImage(x, A, n, f, E, v + k, m + B, f, E);
                    u.scale(1 / a, 1 / G)
                } else {
                    var A = this.xAxisMin;
                    var z = this.xAxisMax;
                    var b = this.yAxisMax;
                    var c = this.yAxisMin;
                    var f = z - A;
                    var E = b - c;
                    var a = j / f;
                    var G = y / E;
                    var k = (j - f) / 2;
                    var B = (y - E) / 2;
                    var n = x.naturalHeight - this.yAxisMax;
                    u.scale(a, G);
                    u.drawImage(x, A, n, f, E, v + k, m + B, f, E);
                    u.scale(1 / a, 1 / G)
                }
            } else {
                if (D && s && p && F) {
                    D = parseInt(Math.round(D));
                    s = parseInt(Math.round(s));
                    p = parseInt(Math.round(p));
                    F = parseInt(Math.round(F));
                    u.drawImage(x, v, m, j, y, D, s, p, F);
                    u.drawImage(this.colorizeImage(x, g), v, m, j, y, D, s, p, F)
                } else {
                    if (g && g == "b&w") {
                        u.drawImage(this.colorizeImage(x), v, m, j, y)
                    } else {
                        if (g) {
                            u.drawImage(x, v, m, j, y);
                            u.drawImage(this.colorizeImage(x, g), v, m, j, y)
                        } else {
                            if (o) {
                                var q = Math.max(j, y) / 2;
                                this.saveCanvas(u);
                                u.arc(v + q, m + q, q, 0, Math.PI * 2);
                                u.clip();
                                u.drawImage(x, v, m, j, y);
                                this.restoreCanvas(u);
                                this.setClipArea([0, 0, 0, 0], u);
                                this.restoreCanvas(u)
                            } else {
                                u.drawImage(x, v, m, j, y)
                            }
                        }
                    }
                }
            }
        } catch (C) {
            console.log(C);
            var d = this;
            setTimeout(function() {
                d.draw({
                    func: "drawImage",
                    par: [x, v, m, j, y, D, s, p, F, g]
                })
            }, 100)
        }
    };
    this.trackTransforms = function(k) {
        if (!k) {
            k = this.getCanvasContext()
        }
        var f = document.createElementNS("http://www.w3.org/2000/svg", "svg");
        var i = f.createSVGMatrix();
        k.getTransform = function() {
            return i
        };
        var j = [];
        var g = k.save;
        k.save = function() {
            j.push(i.translate(0, 0));
            return g.call(k)
        };
        var h = k.restore;
        k.restore = function() {
            i = j.pop();
            return h.call(k)
        };
        var c = k.scale;
        k.scale = function(n, m) {
            i = i.scaleNonUniform(n, m);
            return c.call(k, n, m)
        };
        var d = k.rotate;
        k.rotate = function(m) {
            i = i.rotate(m * 180 / Math.PI);
            return d.call(k, m)
        };
        var b = k.translate;
        k.translate = function(n, m) {
            i = i.translate(n, m);
            return b.call(k, n, m)
        };
        var a = k.transform;
        k.transform = function(n, m, s, r, q, p) {
            var o = f.createSVGMatrix();
            o.a = n;
            o.b = m;
            o.c = s;
            o.d = r;
            o.e = q;
            o.f = p;
            i = i.multiply(o);
            return a.call(k, n, m, s, r, q, p)
        };
        var e = k.setTransform;
        k.setTransform = function(n, m, r, q, p, o) {
            i.a = n;
            i.b = m;
            i.c = r;
            i.d = q;
            i.e = p;
            i.f = o;
            return e.call(k, n, m, r, q, p, o)
        };
        var l = f.createSVGPoint();
        k.transformedPoint = function(m, n) {
            l.x = m;
            l.y = n;
            return l.matrixTransform(i.inverse())
        }
    };
    this.setGlobalCompositionOperation = function(b, a) {
        if (!CanvasXpress.system.isIE && b) {
            if (!a) {
                a = this.getCanvasContext()
            }
            a.globalCompositeOperation = b;
            this.meta.state.globalCompositeOperation = b
        }
    };
    this.rectangleClear = function(a, e, c, d, b) {
        if (!b) {
            b = this.getCanvasContext()
        }
        b.clearRect(a, e, c, d)
    };
    this.translateCanvas = function(a, c, b) {
        if (!b) {
            b = this.getCanvasContext()
        }
        b.translate(a, c);
        this.meta.state.translate[0] += a;
        this.meta.state.translate[1] += c
    };
    this.rotateCanvas = function(b, a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        a.rotate(b);
        this.meta.state.rotate[0] += b
    };
    this.scaleCanvas = function(a, c, b) {
        if (!b) {
            b = this.getCanvasContext()
        }
        b.scale(a, c);
        this.meta.state.scale[0] *= a;
        this.meta.state.scale[1] *= c
    };
    this.saveCanvas = function(a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        a.save();
        this.meta.state.save++;
        this.meta.state.last = {
            translate: [this.meta.state.translate[0], this.meta.state.translate[1]],
            scale: [this.meta.state.scale[0], this.meta.state.scale[1]],
            rotate: [this.meta.state.rotate[0]]
        }
    };
    this.restoreCanvas = function(a) {
        if (!a) {
            a = this.getCanvasContext()
        }
        a.restore();
        this.meta.state.translate[0] = this.meta.state.last.translate[0];
        this.meta.state.translate[1] = this.meta.state.last.translate[1];
        this.meta.state.scale[0] = this.meta.state.last.scale[0];
        this.meta.state.scale[1] = this.meta.state.last.scale[1];
        this.meta.state.rotate[0] = this.meta.state.last.rotate[0];
        this.meta.state.save--
    }
};
CanvasXpress.prototype.initRangeAlgorithms = function() {
    this.heckbert = function(d, k, b) {
        var c = function(i, m) {
            var o;
            var p = Math.floor(Math.log(i) / Math.LN10);
            var n = i / Math.pow(10, p);
            if (m) {
                if (n < 1.5) {
                    o = 1
                } else {
                    if (n < 3) {
                        o = 2
                    } else {
                        if (n < 7) {
                            o = 5
                        } else {
                            o = 10
                        }
                    }
                }
            } else {
                if (n < 1) {
                    o = 1
                } else {
                    if (n < 2) {
                        o = 2
                    } else {
                        if (n < 5) {
                            o = 5
                        } else {
                            o = 10
                        }
                    }
                }
            }
            return o * Math.pow(10, p)
        };
        if (d > k) {
            var f = k;
            d = k;
            d = f
        } else {
            if (k - d < 1e-8) {
                k += 0.1
            }
        }
        var j = [];
        var g = c(k - d, false);
        var l = c(g / (b - 1), true);
        var a = Math.floor(d / l) * l;
        var h = Math.ceil(k / l) * l;
        for (var e = a; e <= h; e += l) {
            j.push(this.approx(e))
        }
        if (j[0] == j[j.length - 1]) {
            var j = [];
            for (var e = a; e <= h; e += l) {
                j.push(e)
            }
        }
        return j
    };
    this.wilkinson = function(c, h, a) {
        var b = function(z, B, A, y) {
            var u = [10, 1, 5, 2, 2.5, 3, 4, 1.5, 7, 6, 8, 9];
            var w = B - z;
            var r = A - 1;
            var o = 1 - Math.abs(A - y) / y;
            var D = w / r;
            var t = Math.floor(Math.log(D) / Math.LN10);
            var E = Math.pow(10, t);
            var p = null;
            for (var C = 0; C < u.length; C++) {
                var s = u[C] * E;
                var F = Math.floor(z / s) * s;
                var n = F + r * s;
                if (F <= z && n >= B) {
                    var v = 1 - (C - (F <= 0 && n >= 0 ? 1 : 0)) / u.length;
                    var q = (B - z) / (n - F);
                    if (q > 0.8) {
                        var x = o + v + q;
                        if (p == null || x > p.score) {
                            p = {
                                lmin: F,
                                lmax: n,
                                lstep: s,
                                score: x
                            }
                        }
                    }
                }
            }
            if (!p) {
                p = {
                    lmin: z,
                    lmax: B,
                    lstep: 1,
                    score: 0
                }
            }
            return p
        };
        if (c > h) {
            var g = h;
            c = h;
            c = g
        } else {
            if (h - c < 1e-8) {
                h += 0.1
            }
        }
        var j = [];
        var e = null;
        var l = [];
        for (var f = Math.max(Math.floor(a / 2), 2); f <= Math.ceil(6 * a); f++) {
            l.push(f)
        }
        for (var f = 0; f < l.length; f++) {
            var d = l[f];
            var m = b(c, h, d, a);
            if ((m != null && e == null) || (m && e && m.score > e.score)) {
                e = m
            }
        }
        for (var f = e.lmin; f <= e.lmax; f += e.lstep) {
            j.push(this.approx(f))
        }
        if (j[0] == j[j.length - 1]) {
            var j = [];
            for (var f = e.lmin; f <= e.lmax; f += e.lstep) {
                j.push(f)
            }
        }
        return j
    };
    this.wilkinsonExtended = function(a, y, R, C) {
        var A = 2.22e-14;
        var f = function(j, g) {
            for (var c = 0; c < g.length; c++) {
                if (j == g[c]) {
                    return c
                }
            }
        };
        var J = function(c, w, m, g, z, Y) {
            var k = w.length;
            var s = f(c, w);
            var Z = (g % Y < A || Y - (g % Y) < A) && g <= 0 && z >= 0 ? 1 : 0;
            return 1 - s / (k - 1) - m + Z
        };
        var K = function(s, m, g) {
            var w = m.length;
            var k = f(s, m);
            var c = 1;
            return 1 - k / (w - 1) - g + c
        };
        var h = function(c, i, j, g) {
            return 1 - 0.5 * (Math.pow(i - g, 2) + Math.pow(c - j, 2)) / Math.pow(0.1 * (i - c), 2)
        };
        var r = function(c, k, i) {
            var g = k - c;
            if (i > g) {
                var j = (i - g) / 2;
                return 1 - 0.5 * (Math.pow(j, 2) + Math.pow(j, 2)) / Math.pow(0.1 * g, 2)
            } else {
                return 1
            }
        };
        var o = function(j, c, i, s, w, q) {
            var n = (j - 1) / (q - w);
            var g = (c - 1) / (Math.max(q, s) - Math.min(i, w));
            return 2 - Math.max(n / g, g / n)
        };
        var X = function(g, c) {
            return g >= c ? 2 - (g - 1) / (c - 1) : 1
        };
        var e = [1, 5, 2, 2.5, 4, 3];
        var G = [0.25, 0.2, 0.5, 0.05];
        var P = e.length;
        var L = {
            score: -2
        };
        var H = [];
        if (a > y) {
            var l = a;
            a = y;
            y = l
        } else {
            if (y - a < 1e-8) {
                y += 0.1
            }
        }
        if (y - a < A) {
            for (var U = 0; U <= R; U++) {
                H.push(a)
            }
            return H
        }
        var T = 1;
        while (T < Number.POSITIVE_INFINITY) {
            for (var U = 0; U < P; U++) {
                var N = e[U];
                var u = K(N, e, T);
                if ((G[0] * u + G[1] + G[2] + G[3] < L.score)) {
                    T = Number.POSITIVE_INFINITY;
                    break
                }
                var S = 2;
                while (S < Number.POSITIVE_INFINITY) {
                    var p = X(S, R);
                    if ((G[0] * u + G[1] + G[2] * p + G[3] < L.score)) {
                        break
                    }
                    var E = (y - a) / (S + 1) / T / N;
                    var F = Math.ceil(Math.log(E) / Math.LN10);
                    while (F < Number.POSITIVE_INFINITY) {
                        var D = T * N * Math.pow(10, F);
                        var B = r(a, y, D * (S - 1));
                        if ((G[0] * u + G[1] * B + G[2] * p + G[3] < L.score)) {
                            break
                        }
                        var v = Math.floor(y / D) * T - (S - 1) * T;
                        var O = Math.ceil(a / D) * T;
                        if (v > O) {
                            F++;
                            continue
                        }
                        for (var x = v; x <= O; x++) {
                            var t = x * (D / T);
                            var M = t + D * (S - 1);
                            var d = D;
                            var I = J(N, e, T, t, M, d);
                            var W = h(a, y, t, M);
                            var V = o(S, R, a, y, t, M);
                            var b = G[0] * I + G[1] * W + G[2] * V + G[3];
                            if (b > L.score && (!C || (t <= a && M >= y))) {
                                L = {
                                    lmin: t,
                                    lmax: M,
                                    lstep: d,
                                    score: b
                                }
                            }
                        }
                        F++
                    }
                    S++
                }
            }
            T++
        }
        for (var U = L.lmin; U <= L.lmax; U += L.lstep) {
            H.push(this.approx(U))
        }
        if (H[0] == H[H.length - 1]) {
            var H = [];
            for (var U = L.lmin; U <= L.lmax; U += L.lstep) {
                H.push(U)
            }
        }
        return H
    };
    this.rPretty = function(o, p, r) {
        if (o > p) {
            var w = p;
            o = p;
            o = w
        } else {
            if (p - o < 1e-8) {
                p += 0.1
            }
        }
        var a, e, b;
        var l = [];
        var q = Math.floor(r) - 1;
        var s = Math.floor(q % 3);
        var g = 0.75;
        var v = 1.5;
        var d = 0.5 + 1.5 * v;
        var f = p - o;
        if (f == 0 && p == 0) {
            a = 1;
            e = true;
            b = 1
        } else {
            a = Math.max(Math.abs(o), Math.abs(p));
            b = 1 + d >= 1.5 * v + 0.5 ? 1 / (1 + v) : 1.5 / 1 + d;
            e = f < (a * b * Math.max(1, q) * 1e-7 * 3)
        }
        if (e) {
            if (a > 10) {
                a = 9 + a / 10
            }
            a = a * g;
            if (s > 1) {
                a /= s
            }
        } else {
            a = f;
            if (q > 1) {
                a /= q
            }
        }
        if (a < 20 * 1e-7) {
            a = 20 * 1e-7
        }
        var c = Math.pow(10, Math.floor(Math.log(a) / Math.LN10));
        var j = c;
        if ((2 * c) - a < v * (a - j)) {
            j = 2 * c;
            if ((5 * c) - a < d * (a - j)) {
                j = 5 * c;
                if ((10 * c) - a < v * (a - j)) {
                    j = 10 * c
                }
            }
        }
        var y = Math.floor(o / j + 1e-7);
        var x = Math.ceil(p / j - 1e-7);
        while (y * j > o + (1e-7 * j)) {
            y--
        }
        while (x * j < p - (1e-7 * j)) {
            x++
        }
        var t = Math.floor(0.5 + x - y);
        if (t < s) {
            t = s - t;
            if (y >= 0) {
                x += t / 2;
                y = y - t / 2 + t % 2
            } else {
                y -= t / 2;
                x = x + t / 2 + t % 2
            }
            q = s
        } else {
            q = t
        }
        for (var u = y * j; u <= x * j; u += j) {
            l.push(this.approx(u))
        }
        if (l[0] == l[l.length - 1]) {
            var l = [];
            for (var u = y * j; u <= x * j; u += j) {
                l.push(u)
            }
        }
        return l
    };
    this.getAxisDecimals = function(a) {
        a = this.approx(a).toString();
        return a.indexOf(".") >= 0 ? Math.min(Number(a.length - (a.indexOf(".") + 1)), 20) : 0
    }
};
CanvasXpress.prototype.initPrimitives = function() {
    this.initText();
    this.initTime();
    this.initColor();
    this.initAttributes();
    this.initRangeAlgorithms()
};
CanvasXpress.prototype.initGeneralUtils = function() {
    this.modifyObjectArray = function(c, g, h, f, j) {
        if (this.isTransition()) {
            return
        }
        var e = this[h];
        if (f) {
            var a = {};
            if (this.isArray(c)) {
                var b = c.length;
                for (var d = 0; d < b; d++) {
                    a[c[d]] = true
                }
            } else {
                a[c] = true
            }
            for (var d in a) {
                if (e.includes(d)) {
                    e = this.removeFromArray(d, e);
                    delete(a[d])
                }
            }
            for (var d in a) {
                e.push(d)
            }
            this[h] = e
        } else {
            if (g) {
                var a = {};
                var k = [];
                if (this.isArray(c)) {
                    var b = c.length;
                    for (var d = 0; d < b; d++) {
                        a[c[d]] = 1
                    }
                } else {
                    a[c] = 1
                }
                var b = e.length;
                for (var d = 0; d < b; d++) {
                    if (!a.hasOwnProperty(e[d])) {
                        k.push(e[d])
                    }
                }
                this[h] = k
            } else {
                if (this.isArray(c)) {
                    var b = c.length;
                    for (var d = 0; d < b; d++) {
                        e.push(c[d])
                    }
                } else {
                    e.push(c)
                }
            }
        }
        if (j) {
            this.draw({
                func: "modifyObjectArray",
                par: [c, g, h, f, j]
            })
        }
    };
    this.getObjectArray = function(b) {
        var d = {};
        if (b && this.isArray(b)) {
            var e = b.length;
            for (var c = 0; c < e; c++) {
                d[b[c]] = true
            }
        }
        return d
    };
    this.getObjectArrayOrder = function(b) {
        var d = {};
        if (b && this.isArray(b)) {
            var e = b.length;
            for (var c = 0; c < e; c++) {
                d[b[c] + ""] = c
            }
        }
        return d
    };
    this.intersectArray = function(e, d) {
        var h = [];
        if (!this.isArray(e)) {
            e = this.toArray(e)
        }
        var f = this.getObjectArray(this.toArray(d));
        for (var g = 0; g < e.length; g++) {
            if (f.hasOwnProperty(e[g].toString())) {
                h.push(e[g])
            }
        }
        return h
    };
    this.removeFromArray = function(e, b) {
        if (this.isArray(b)) {
            var d = [];
            var f = b.length;
            for (var c = 0; c < f; c++) {
                if (b[c] != e) {
                    d.push(b[c])
                }
            }
        }
        return d
    };
    this.isFunction = function(a) {
        return a && typeof a === "function";
        var b = {};
        return a && b.toString.call(a) === "[object Function]"
    };
    this.isArray = function(a) {
        return Array.isArray(a)
    };
    this.isObject = function(a) {
        return a instanceof Object
    };
    this.isUnique = function(b) {
        return this.getUniqueEls(b).length == b.length
    };
    this.isBoolean = function(b) {
        var d = b.length;
        if (this.isR) {
            for (var c = 0; c < d; c++) {
                if (this.isObject(b[c])) {
                    return false
                } else {
                    if (b[c] == null) {
                        continue
                    } else {
                        if (typeof(b[c]) == "string") {
                            if (b[c].toLowerCase() != "true" && b[c].toLowerCase() != "false" && b[c] !== "") {
                                return false
                            }
                        }
                    }
                }
            }
        } else {
            for (var c = 0; c < d; c++) {
                if (this.isObject(b[c])) {
                    return false
                } else {
                    if (b[c] !== true && b[c] !== false && b[c] !== "" && b[c] !== null) {
                        return false
                    }
                }
            }
        }
        return true
    };
    this.toArray = function(a) {
        return this.isArray(a) ? a : [a]
    };
    this.getKeys = function(a) {
        return this.isArray(a) ? a : this.isObject(a) ? Object.keys(a) : []
    };
    this.unique = function(a) {
        if (this.isArray(a)) {
            return this.getUniqueEls(a)
        } else {
            if (this.isObject(a)) {
                return Object.keys(a)
            } else {
                return [a]
            }
        }
    };
    this.getUniqueEls = function(b) {
        var g = b.length;
        var f = [];
        var e = new Set();
        for (var d = 0; d < g; d++) {
            var c = b[d];
            if (e.has(c)) {
                continue
            }
            e.add(c);
            f.push(c)
        }
        return f
    };
    this.getUniqueKeys = function(a) {
        if (this.isArray(a)) {
            return this.getUniqueEls(a)
        } else {
            if (this.isObject(a)) {
                return this.getUniqueEls(this.getKeys(a))
            } else {
                return [a]
            }
        }
    };
    this.shuffleArray = function(b) {
        for (var d = b.length; d > 0; d--) {
            var c = Math.floor(this.random() * d);
            var a = b[--d];
            b[d] = b[c];
            b[c] = a
        }
        return b
    };
    this.toNumber = function(c) {
        var f = [];
        var d = this.isArray(c);
        c = this.toArray(c);
        var b = c.length;
        for (var e = 0; e < b; e++) {
            f.push(Number(c[e]))
        }
        return d ? f : f[0]
    };
    this.zip = function(d, c) {
        return d.map(function(b, a) {
            return [d[a], c[a]]
        })
    };
    this.unzip = function(b, a) {
        return b.map(function(d, c) {
            return d[a]
        })
    };
    this.extend = function(c, b) {
        if (c == null || typeof(c) != "object") {
            return b
        }
        if (b == null || typeof(b) != "object") {
            return c
        }
        if (Object.assign) {
            return Object.assign({}, c, b)
        } else {
            for (var a in c) {
                if (c.hasOwnProperty(a)) {
                    b[a] = c[a]
                }
            }
            return b
        }
    };
    this.cloneObjectR = function(c, a) {
        var b = this;
        if (c == null || typeof(c) != "object") {
            return c
        }
        if (this.isArray(c)) {
            return c.map(function(d) {
                return b.isArray(d) ? d.slice() : b.cloneObjectR(d, a)
            })
        } else {
            if (a) {
                return this.isObject(c) ? Object.assign({}, c) : this.parseJSON(this.stringifyJSON(c))
            } else {
                return this.parseJSON(this.stringifyJSON(c))
            }
        }
    };
    this.cloneObject = function(e, d) {
        var c = {
            bubble: true,
            gantt: true,
            sankey: true,
            tree: true
        };
        if (typeof e !== "object") {
            return e
        }
        if (!e) {
            return e
        }
        if (Object.prototype.toString.apply(e) === "[object Array]") {
            var f = [];
            var a = e.length;
            for (var b = 0; b < a; b++) {
                f[b] = this.cloneObject(e[b])
            }
            return f
        }
        var f = {};
        for (b in e) {
            if (d && c.hasOwnProperty(b)) {
                continue
            }
            if ((e[b] && e.hasOwnProperty(b)) || e[b] === false || e[b] === 0) {
                f[b] = this.cloneObject(e[b], b == "data")
            }
        }
        return f
    };
    this.isSameObject = function(d, c) {
        if (d === c) {
            return true
        }
        if (typeof(d) != "object" || typeof(c) != "object") {
            return false
        }
        return JSON.stringify(d) == JSON.stringify(c)
    };
    this.isNumber = function(b, a) {
        if (a) {
            return !isNaN(parseFloat(b)) && isFinite(b)
        } else {
            return b === null || b === undefined ? true : !isNaN(parseFloat(b)) && isFinite(b)
        }
    };
    this.toNumber = function(a) {
        if (this.isNumber(a, true)) {
            return a
        } else {
            return Number.NaN
        }
    };
    this.isNumeric2DArray = function(a) {
        var e = a.length;
        for (var d = 0; d < e; d++) {
            var c = a[d].length;
            for (var b = 0; b < c; b++) {
                if (!this.isNumber(a[d][b])) {
                    return false
                }
            }
        }
        return true
    };
    this.isNumeric = function(a) {
        var c = a.length;
        for (var b = 0; b < c; b++) {
            if (!this.isNumber(a[b])) {
                return false
            }
        }
        return true
    };
    this.isNull = function(a) {
        var c = a.length;
        for (var b = 0; b < c; b++) {
            if (a[b] != null) {
                return false
            }
        }
        return true
    };
    this.isEmpty = function(a) {
        var c = a.length;
        for (var b = 0; b < c; b++) {
            if (a[b] !== "") {
                return false
            }
        }
        return true
    };
    this.isDate = function(a) {
        var c = function(e) {
            if (toString.call(e) === "[object Date]") {
                return true
            }
            if (typeof e.replace === "function") {
                e.replace(/^\s+|\s+$/gm, "")
            }
            var g = /(^\d{1,4}?[\.|\\/|-]\d{1,2}?[\.|\\/|-]\d{1,4})(\s*(?:0?[1-9]:[0-5]|1(?=[012])\d:[0-5])\d\s*[ap]m)?$/;
            return g.test(e)
        };
        var d = a.length;
        for (var b = 0; b < d; b++) {
            if (a[b] && !c(a[b])) {
                return false
            }
        }
        return true
    };
    this.isCountry = function(a) {
        var b = function(e) {
            return CanvasXpress.countries.hasOwnProperty(e)
        };
        var d = a.length;
        for (var c = 0; c < d; c++) {
            if (a[c] && !b(a[c])) {
                return false
            }
        }
        return true
    };
    this.isUsa = function(a) {
        var b = function(e) {
            return CanvasXpress.usa.hasOwnProperty(e)
        };
        var d = a.length;
        for (var c = 0; c < d; c++) {
            if (a[c] && !b(a[c])) {
                return false
            }
        }
        return true
    };
    this.padNumber = function(b, a) {
        if (!a) {
            a = 4
        }
        b = b + "";
        return b.length >= a ? b : new Array(a - b.length + 1).join("0") + b
    };
    this.isPivotable = function() {
        var b = this.data.y.vars.length;
        var c = this.data.x ? this.getKeys(this.data.x) : [];
        var a = c.length;
        return (this.data.x || b + a == 3) ? true : false
    };
    this.pivotMatrix = function(j, g, l, d) {
        var c = {};
        var f = [];
        var e = [];
        var a = j.length;
        for (var b = 0; b < a; b++) {
            if (!c[j[b][g]]) {
                c[j[b][g]] = {}
            }
            c[j[b][g]][j[b][l]] = j[b][d];
            if (f.indexOf(j[b][l]) == -1) {
                f.push(j[b][l])
            }
        }
        f = this.stringRangeSort(f);
        var k = [];
        k.push("Vars");
        k.push.apply(k, f);
        e.push(k);
        for (var h in c) {
            k = [];
            k.push(h);
            a = f.length;
            for (var b = 0; b < a; b++) {
                k.push(c[h][f[b]] || "")
            }
            e.push(k)
        }
        return e
    };
    this.transposeMatrix = function(a) {
        return a[0].map(function(b, d) {
            return a.map(function(c) {
                return c[d]
            })
        })
    };
    this.filterNumbers = function(a, c) {
        var d = [];
        var e = a.length;
        for (var b = 0; b < e; b++) {
            if (this.isNumber(a[b], c)) {
                d.push(a[b])
            }
        }
        return d
    };
    this.cleanArray = function(b, a, e) {
        var d = [];
        if (a) {
            var f = this.smpIndices.length;
            for (var c = 0; c < f; c++) {
                d.push(b[this.smpIndices[c]])
            }
            d = this.filterNumbers(d, true)
        } else {
            if (e) {
                var f = this.varIndices.length;
                for (var c = 0; c < f; c++) {
                    d.push(b[this.varIndices[c]])
                }
                d = this.filterNumbers(d, true)
            } else {
                d = this.filterNumbers(b, true)
            }
        }
        return d
    };
    this.cleanArrays = function(j, h, g, e) {
        var d = [];
        var c = [];
        if (g) {
            var b = this.smpIndices.length;
            for (var f = 0; f < b; f++) {
                var k = this.filterNumbers([j[this.smpIndices[f]], h[this.smpIndices[f]]], true);
                if (k.length == 2) {
                    d.push(j[this.smpIndices[f]]);
                    c.push(h[this.smpIndices[f]])
                }
            }
        } else {
            if (e) {
                var b = this.varIndices.length;
                for (var f = 0; f < b; f++) {
                    var k = this.filterNumbers([j[this.varIndices[f]], h[this.varIndices[f]]], true);
                    if (k.length == 2) {
                        d.push(j[this.varIndices[f]]);
                        c.push(h[this.varIndices[f]])
                    }
                }
            } else {
                var b = j.length;
                for (var f = 0; f < b; f++) {
                    var k = this.filterNumbers([j[f], h[f]], true);
                    if (k.length == 2) {
                        d.push(j[f]);
                        c.push(h[f])
                    }
                }
            }
        }
        return [d, c]
    };
    this.reverseArray = function(a) {
        tmp = a.reverse();
        return tmp
    };
    this.parseInt = function(a) {
        return ((a + 0.5) << 1) >> 1
    };
    this.ungroupGroupedData = function() {
        return this.isGroupedData && (this.graphType == "Dotplot" || (this.graphType == "Boxplot" && this.showBoxplotOriginalData) || this.graphType == "Gantt")
    };
    this.getIpRangeFromAddressAndNetmask = function(g) {
        var c = g.split("/");
        var e = c[0].split(".");
        var d = ["0", "0", "0", "0"];
        if (!/\d+\.\d+\.\d+\.\d+/.test(c[1])) {
            d = ("1".repeat(parseInt(c[1], 10)) + "0".repeat(32 - parseInt(c[1], 10))).match(/.{1,8}/g);
            d = d.map(function(h) {
                return parseInt(h, 2)
            })
        } else {
            d = c[1].split(".").map(function(h) {
                return parseInt(h, 10)
            })
        }
        var b = d.map(function(h) {
            return h ^ 255
        });
        var a = e.map(function(i, h) {
            return i & d[h]
        });
        var f = e.map(function(i, h) {
            return i | b[h]
        });
        return [a.join("."), f.join(".")]
    };
    this.int2Ip = function(a) {
        return ((a >>> 24) + "." + (a >> 16 & 255) + "." + (a >> 8 & 255) + "." + (a & 255))
    };
    this.ip2Int = function(a) {
        return a.split(".").reduce(function(c, b) {
            return (c << 8) + parseInt(b, 10)
        }, 0) >>> 0
    };
    this.md5 = function(b) {
        var d = function(o, q) {
            var p = o[0];
            var n = o[1];
            var s = o[2];
            var r = o[3];
            p = a(p, n, s, r, q[0], 7, -680876936);
            r = a(r, p, n, s, q[1], 12, -389564586);
            s = a(s, r, p, n, q[2], 17, 606105819);
            n = a(n, s, r, p, q[3], 22, -1044525330);
            p = a(p, n, s, r, q[4], 7, -176418897);
            r = a(r, p, n, s, q[5], 12, 1200080426);
            s = a(s, r, p, n, q[6], 17, -1473231341);
            n = a(n, s, r, p, q[7], 22, -45705983);
            p = a(p, n, s, r, q[8], 7, 1770035416);
            r = a(r, p, n, s, q[9], 12, -1958414417);
            s = a(s, r, p, n, q[10], 17, -42063);
            n = a(n, s, r, p, q[11], 22, -1990404162);
            p = a(p, n, s, r, q[12], 7, 1804603682);
            r = a(r, p, n, s, q[13], 12, -40341101);
            s = a(s, r, p, n, q[14], 17, -1502002290);
            n = a(n, s, r, p, q[15], 22, 1236535329);
            p = i(p, n, s, r, q[1], 5, -165796510);
            r = i(r, p, n, s, q[6], 9, -1069501632);
            s = i(s, r, p, n, q[11], 14, 643717713);
            n = i(n, s, r, p, q[0], 20, -373897302);
            p = i(p, n, s, r, q[5], 5, -701558691);
            r = i(r, p, n, s, q[10], 9, 38016083);
            s = i(s, r, p, n, q[15], 14, -660478335);
            n = i(n, s, r, p, q[4], 20, -405537848);
            p = i(p, n, s, r, q[9], 5, 568446438);
            r = i(r, p, n, s, q[14], 9, -1019803690);
            s = i(s, r, p, n, q[3], 14, -187363961);
            n = i(n, s, r, p, q[8], 20, 1163531501);
            p = i(p, n, s, r, q[13], 5, -1444681467);
            r = i(r, p, n, s, q[2], 9, -51403784);
            s = i(s, r, p, n, q[7], 14, 1735328473);
            n = i(n, s, r, p, q[12], 20, -1926607734);
            p = f(p, n, s, r, q[5], 4, -378558);
            r = f(r, p, n, s, q[8], 11, -2022574463);
            s = f(s, r, p, n, q[11], 16, 1839030562);
            n = f(n, s, r, p, q[14], 23, -35309556);
            p = f(p, n, s, r, q[1], 4, -1530992060);
            r = f(r, p, n, s, q[4], 11, 1272893353);
            s = f(s, r, p, n, q[7], 16, -155497632);
            n = f(n, s, r, p, q[10], 23, -1094730640);
            p = f(p, n, s, r, q[13], 4, 681279174);
            r = f(r, p, n, s, q[0], 11, -358537222);
            s = f(s, r, p, n, q[3], 16, -722521979);
            n = f(n, s, r, p, q[6], 23, 76029189);
            p = f(p, n, s, r, q[9], 4, -640364487);
            r = f(r, p, n, s, q[12], 11, -421815835);
            s = f(s, r, p, n, q[15], 16, 530742520);
            n = f(n, s, r, p, q[2], 23, -995338651);
            p = l(p, n, s, r, q[0], 6, -198630844);
            r = l(r, p, n, s, q[7], 10, 1126891415);
            s = l(s, r, p, n, q[14], 15, -1416354905);
            n = l(n, s, r, p, q[5], 21, -57434055);
            p = l(p, n, s, r, q[12], 6, 1700485571);
            r = l(r, p, n, s, q[3], 10, -1894986606);
            s = l(s, r, p, n, q[10], 15, -1051523);
            n = l(n, s, r, p, q[1], 21, -2054922799);
            p = l(p, n, s, r, q[8], 6, 1873313359);
            r = l(r, p, n, s, q[15], 10, -30611744);
            s = l(s, r, p, n, q[6], 15, -1560198380);
            n = l(n, s, r, p, q[13], 21, 1309151649);
            p = l(p, n, s, r, q[4], 6, -145523070);
            r = l(r, p, n, s, q[11], 10, -1120210379);
            s = l(s, r, p, n, q[2], 15, 718787259);
            n = l(n, s, r, p, q[9], 21, -343485551);
            o[0] = e(p, o[0]);
            o[1] = e(n, o[1]);
            o[2] = e(s, o[2]);
            o[3] = e(r, o[3])
        };
        var k = function(v, p, o, n, u, r) {
            p = e(e(p, v), e(n, r));
            return e((p << u) | (p >>> (32 - u)), o)
        };
        var a = function(p, o, v, u, n, r, q) {
            return k((o & v) | ((~o) & u), p, o, n, r, q)
        };
        var i = function(p, o, v, u, n, r, q) {
            return k((o & u) | (v & (~u)), p, o, n, r, q)
        };
        var f = function(p, o, v, u, n, r, q) {
            return k(o ^ v ^ u, p, o, n, r, q)
        };
        var l = function(p, o, v, u, n, r, q) {
            return k(v ^ (o | (~u)), p, o, n, r, q)
        };
        var j = function(q) {
            txt = "";
            var t = q.length;
            var r = [1732584193, -271733879, -1732584194, 271733878];
            var p;
            for (p = 64; p <= q.length; p += 64) {
                d(r, m(q.substring(p - 64, p)))
            }
            q = q.substring(p - 64);
            var o = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
            for (p = 0; p < q.length; p++) {
                o[p >> 2] |= q.charCodeAt(p) << ((p % 4) << 3)
            }
            o[p >> 2] |= 128 << ((p % 4) << 3);
            if (p > 55) {
                d(r, o);
                for (p = 0; p < 16; p++) {
                    o[p] = 0
                }
            }
            o[14] = t * 8;
            d(r, o);
            return r
        };
        var m = function(o) {
            var p = [];
            var n;
            for (n = 0; n < 64; n += 4) {
                p[n >> 2] = o.charCodeAt(n) + (o.charCodeAt(n + 1) << 8) + (o.charCodeAt(n + 2) << 16) + (o.charCodeAt(n + 3) << 24)
            }
            return p
        };
        var h = "0123456789abcdef".split("");
        var g = function(q) {
            var p = "";
            var o = 0;
            for (; o < 4; o++) {
                p += h[(q >> (o * 8 + 4)) & 15] + h[(q >> (o * 8)) & 15]
            }
            return p
        };
        var c = function(n) {
            for (var o = 0; o < n.length; o++) {
                n[o] = g(n[o])
            }
            return n.join("")
        };
        var e = function(o, n) {
            return (o + n) & 4294967295
        };
        return c(j(this.stringifyJSON(b)))
    }
};
CanvasXpress.prototype.initPlotUtils = function() {
    this.drawLayoutCanvasCompartments = function() {
        var n = this.canvasBoxColor;
        var m = this.height;
        var s = this.width;
        var g = this.left;
        var d = this.right;
        var p = this.bottom;
        var u = this.top;
        var j = this.marginLeft;
        var e = this.marginRight;
        var q = this.marginBottom;
        var a = this.marginTop;
        var o = this.layoutLeft;
        var k = this.layoutRight;
        var f = this.layoutBottom;
        var i = this.layoutTop;
        this.toRender({
            p: ["drawShape", "rectangle", (j + this.offsetX) + (this.layoutWidth / 2), (a + this.offsetY) + (this.layoutHeight / 2), this.layoutWidth, this.layoutHeight, false, n, "open"],
            t: "Size"
        });
        this.toRender({
            p: ["drawShape", "rectangle", (j + this.offsetX + g) + (this.x / 2), (a + this.offsetY + u) + (this.y / 2), this.x, this.y, false, "red", "open"],
            t: "Size"
        });
        this.toRender({
            p: ["drawShape", "rectangle", (j + this.offsetX + g + this.x) + (d / 2), (a + this.offsetY + u) + (this.y / 2), d, this.y, false, "blue", "open"],
            t: "Size"
        });
        this.toRender({
            p: ["drawShape", "rectangle", (j + this.offsetX) + (g / 2), (a + this.offsetY + u) + (this.y / 2), g, this.y, false, "blue", "open"],
            t: "Size"
        });
        this.toRender({
            p: ["drawShape", "rectangle", (j + this.offsetX + g) + (this.x / 2), (a + this.offsetY) + (u / 2), this.x, u, false, "blue", "open"],
            t: "Size"
        });
        this.toRender({
            p: ["drawShape", "rectangle", (j + this.offsetX + g) + (this.x / 2), (a + this.offsetY + u + this.y) + (p / 2), this.x, p, false, "blue", "open"],
            t: "Size"
        });
        return
    };
    this.drawCanvasBox = function(a) {
        if (this.canvasBox && (this.graphType != "Network" || a)) {
            this.toRender({
                p: ["disableGradientTransparencyShadow"],
                t: "Size"
            });
            this.toRender({
                p: ["drawShape", "rectangle", this.width / 2, this.height / 2, this.width - 2, this.height - 2, false, this.canvasBoxColor, "open"],
                t: "Size"
            });
            this.toRender({
                p: ["enableGradientTransparencyShadow"],
                t: "Size"
            })
        }
    };
    this.drawPlotWindow = function() {
        if (this.backgroundType.match("window")) {
            this.toRender({
                p: ["disableGradientTransparencyShadow"],
                t: "Size"
            });
            var a = this.marginLeft + this.offsetX + this.left;
            var b = this.marginTop + this.offsetY + this.top;
            if (!this.layoutValid) {
                this.toRender({
                    p: ["drawShape", "rectangle", this.width * 0.5, this.height * 0.5, this.width, this.height, this.background, this.background],
                    t: "Size"
                })
            }
            if (this.backgroundType == "windowSolidGradient") {
                var c = this.getLinearGradient(a, b, this.gradientOrientation == "vertical" ? a : b + this.y, this.gradientOrientation == "vertical" ? a + this.x : b);
                this.toRender({
                    p: ["drawShape", "rectangle", a + (this.x / 2), b + (this.y / 2), this.x, this.y, c, c],
                    t: "Size"
                })
            } else {
                if (this.backgroundType == "windowImage") {
                    this.toRender({
                        p: ["drawShape", "image", a + (this.x / 2), b + (this.y / 2), this.x, this.y, false, false, false, false, false, false, false, false, false, this.backgroundImage],
                        t: "Size"
                    })
                } else {
                    this.toRender({
                        p: ["drawShape", "rectangle", a + (this.x / 2), b + (this.y / 2), this.x, this.y, this.backgroundWindow, this.backgroundWindow],
                        t: "Size"
                    })
                }
            }
            this.toRender({
                p: ["enableGradientTransparencyShadow"],
                t: "Size"
            })
        }
    };
    this.validateSegregation = function() {
        var e = "";
        var b = this.segregateVariablesBy;
        var d = this.segregateSamplesBy;
        if (b.length > 0) {
            var a = [];
            for (var c = 0; c < b.length; c++) {
                if ((this.data.z && this.data.z.hasOwnProperty(b[c])) || b[c] == "variable") {
                    a.push(b[c])
                }
            }
            b = a
        }
        if (d.length > 0) {
            var a = [];
            for (var c = 0; c < d.length; c++) {
                if ((this.data.x && this.data.x.hasOwnProperty(d[c])) || d[c] == "sample") {
                    a.push(d[c])
                }
            }
            d = a
        }
        if (b.length > 0 && d.length > 0) {
            if (d.length > 1) {
                while (d.length > 1) {
                    d.pop()
                }
                e += "Only one sample segregation when variable segregation is selected\n";
                e += "segregateSamplesBy was set to: " + d[0] + "\n"
            }
            if (b.length > 1) {
                while (b.length > 1) {
                    b.pop()
                }
                e += "Only one variable segregation when sample segregation is selected\n";
                e += "segregateVariblesBy was set to: " + b[0] + "\n"
            }
        } else {
            if (d.length > 0) {
                if (d.length > 2) {
                    while (d.length > 2) {
                        d.pop()
                    }
                    e += "Maximum of two sample segregations\n";
                    e += "segregateSamplesBy was set to: " + d[0] + "," + d[1] + "\n"
                }
            } else {
                if (b.length > 0) {
                    if (b.length > 2) {
                        while (b.length > 2) {
                            b.pop()
                        }
                        e += "Maximum of two variable segregations\n";
                        e += "segregateVariablesBy was set to: " + b[0] + "," + b[1] + "\n"
                    }
                }
            }
        }
        if (e != "") {
            this.removeMenus();
            alert(e);
            return false
        }
        return true
    };
    this.checkSegregation = function() {
        if (!this.isDOE) {
            if (this.validateSegregation()) {
                if (this.layoutValid && this.data.l) {
                    if (this.segregateSamplesBy.length == 0) {} else {
                        if (!this.data.l.smps) {
                            this.segregateSamples(this.segregateSamplesBy, true)
                        }
                    }
                    if (this.segregateVariablesBy.length == 0) {} else {
                        if (!this.data.l.vars) {
                            this.segregateVariables(this.segregateVariablesBy, true)
                        }
                    }
                } else {
                    if (this.segregateSamplesBy.length > 0 && this.segregateVariablesBy.length > 0) {
                        this.segregateSamplesVariables(true)
                    } else {
                        if (this.segregateSamplesBy.length > 0) {
                            this.segregateSamples(this.segregateSamplesBy, true)
                        } else {
                            if (this.segregateVariablesBy.length > 0) {
                                this.segregateVariables(this.segregateVariablesBy, true)
                            }
                        }
                    }
                }
            }
        }
    };
    this.validateOverlays = function() {
        if (this.smpOverlays.length > 0) {
            var a = [];
            for (var b = 0; b < this.smpOverlays.length; b++) {
                if (this.smpOverlays[b] == "-" || (this.data.x && this.data.x.hasOwnProperty(this.smpOverlays[b]))) {
                    a.push(this.smpOverlays[b])
                }
            }
            this.smpOverlays = a
        }
        if (this.varOverlays.length > 0) {
            var a = [];
            for (var b = 0; b < this.varOverlays.length; b++) {
                if (this.varOverlays[b] == "-" || (this.data.z && this.data.z.hasOwnProperty(this.varOverlays[b]))) {
                    a.push(this.varOverlays[b])
                }
            }
            this.varOverlays = a
        }
    };
    this.isDotplotGraph = function() {
        if (this.graphType.match(/Dotplot/)) {
            return true
        } else {
            if (this.graphType == "Boxplot" && (this.showBoxplotOriginalData || this.showViolinBoxplot)) {
                return true
            } else {
                return false
            }
        }
    };
    this.isAttributedGraph = function() {
        return this.colorBy || this.shapeBy || this.sizeBy || this.patternBy
    };
    this.isSegregatable = function() {
        var a = this;
        var b = function() {
            if (a.isTransitionOn) {
                CanvasXpress.transitions[a.target].push([a.isSegregatable]);
                return true
            } else {
                return false
            }
        };
        return !b() && !this.isDOE && !CanvasXpress.graphTypes.NonSegregatable.includes(this.graphType)
    };
    this.validateNetworkDecorations = function() {
        if (this.decorations.length) {
            var c = this.meta.data.nodes;
            var a = [];
            for (var b = 0; b < this.decorations.length; b++) {
                if (c.hasOwnProperty(this.decorations[b])) {
                    a.push(this.decorations[b])
                }
            }
            this.decorations = a
        }
    }
};
CanvasXpress.prototype.initConfigUtils = function() {
    this.encode = function(a) {
        return btoa(encodeURIComponent(a).replace(/%([0-9A-F]{2})/g, function(b, c) {
            return String.fromCharCode("0x" + c)
        }))
    };
    this.decode = function(a) {
        return decodeURIComponent(Array.prototype.map.call(atob(a), function(b) {
            return "%" + ("00" + b.charCodeAt(0).toString(16)).slice(-2)
        }).join(""))
    };
    this.getFileName = function(a) {
        return a.substring(a.lastIndexOf("/") + 1)
    };
    this.getTitleSubtitleHeight = function() {
        var b = 0;
        var a;
        this.setTitleSubtitleFont();
        if (this.title) {
            a = this.title.split(/\n/);
            b += (this.margin + this.getFontPt(this.titleFont)) * a.length;
            if (this.subtitle) {
                a = this.subtitle.split(/\n/);
                b += (this.margin + this.getFontPt(this.subtitleFont)) * a.length
            }
            b += this.margin
        }
        return b
    };
    this.setTitleSubtitleFont = function() {
        this.setPropertyFontSize(this.width, "titleFont");
        this.adjustFont(this.title, "titleFont", this.width);
        this.setPropertyFontSize(this.width, "subtitleFont");
        this.adjustFont(this.subtitle, "subtitleFont", this.width)
    };
    this.drawTitle = function() {
        this.setTitleSubtitleFont();
        if (this.title) {
            var a = this.title.split(/\n/);
            var c = this.marginTop + ((this.getFontPt(this.titleFont) + this.margin) * a.length);
            if (this.subtitle) {
                a = this.subtitle.split(/\n/);
                c += (this.getFontPt(this.subtitleFont) + this.margin) * a.length
            }
            if (this.titleColorBackground) {
                this.toRender({
                    p: ["drawShape", "rectangle", this.width / 2, c / 2, this.width, c, this.titleColorBackground, this.titleColorBackground],
                    t: "Titles"
                })
            }
            var b = this.titleAlign == "left" ? this.marginLeft + this.left : this.titleAlign == "right" ? this.width - (this.marginRight + this.right) : this.width / 2;
            var d = this.marginTop + (this.measureTextWidth(this.title, this.titleFont) / 2);
            this.toRender({
                p: ["drawText", this.title, b, d, this.titleFont, this.titleColor, this.titleAlign == "left" ? "left" : this.titleAlign == "right" ? "right" : "center", "middle"],
                t: "Titles"
            });
            if (this.subtitle) {
                b = this.subtitleAlign == "left" ? this.marginLeft + this.left : this.subtitleAlign == "right" ? this.width - (this.marginRight + this.right) : this.width / 2;
                this.toRender({
                    p: ["drawText", this.subtitle, b, d + (this.getFontPt(this.titleFont) / 2) + this.margin + (this.getFontPt(this.subtitleFont) / 2), this.subtitleFont, this.subtitleColor, this.subtitleAlign == "left" ? "left" : this.subtitleAlign == "right" ? "right" : "center", "middle"],
                    t: "Titles"
                })
            }
        }
    };
    this.getCitationHeight = function() {
        var b = 0;
        var a;
        this.setCitationFont();
        if (this.citation) {
            a = this.citation.split(/\n/);
            b += (this.margin + this.getFontPt(this.citationFont)) * a.length;
            b += this.margin
        }
        return b
    };
    this.setCitationFont = function() {
        var b = 20 * this.printMagnification;
        this.setPropertyFontSize(this.width, "citationFont", b);
        var a = this.measureText(this.citation, this.citationFont);
        var c = 1;
        while (a > this.width || c > 9) {
            b /= 2;
            this.setPropertyFontSize(this.width, "citationFont", b);
            a = this.measureText(this.citation, this.citationFont);
            c++
        }
        return
    };
    this.drawCitation = function() {
        if (this.citation) {
            var a = this.width - this.margin;
            var b = this.height - this.margin;
            this.toRender({
                p: ["drawText", this.citation, a, b, this.citationFont, this.citationColor, "right", "bottom"],
                t: "Citations"
            })
        }
    };
    this.getFontHeight = function() {
        this.setMainFont();
        return this.getFontPt(this.font)
    };
    this.setMainFont = function() {
        var b;
        if (this.autoScaleFont) {
            var c = 1 - this.percentAspectRatioPlotArea;
            var a = this.layoutComb ? (this.width / this.layoutCols) * c * 2.5 : this.width * c;
            var e = this.layoutComb ? (this.height / this.layoutRows) * c * 2.5 : this.height * c;
            b = Math.min(Math.max(parseInt((Math.max(a, e) / 30) * this.fontScaleFontFactor), this.minTextSize), this.maxTextSize)
        } else {
            b = Math.min(Math.max(parseInt(this.fontSize * this.fontScaleFontFactor), this.minTextSize), this.maxTextSize)
        }
        this.font = this.fontStyle + " " + b + "px " + this.fontName
    };
    this.setPropertyFontSize = function(h, f, c) {
        if (!h || !f) {
            return
        }
        var a = 5;
        var e = {
            titleFont: a + 4,
            subtitleFont: a + 2,
            decorationFont: a,
            axisTickFont: a,
            axisTitleFont: a,
            smpLabelFont: a,
            smpTitleFont: (this.graphType == "Meter" ? a + 4 : a),
            varLabelFont: a,
            varTitleFont: a,
            legendFont: a - 2,
            overlayFont: a - 6,
            citationFont: a - 10,
            motionCurrentFont: a + 50
        };
        var g = f.replace("Font", "ScaleFontFactor");
        this[f + "Size"] = Math.min(Math.max(parseInt((h / 30) * this[g]) + e[f], this.minTextSize), c || this.maxTextSize);
        this[f] = this[f + "Style"] + " " + this[f + "Size"] + "px " + this.fontName
    };
    this.adjustFont = function(b, c, g) {
        if (b && c && g) {
            var e = this.getFontPt(this[c]);
            var a = this.measureText(b, this[c]);
            while (a > g && e > this.minTextSize) {
                e--;
                this[c] = this[c + "Style"] + " " + e + "px " + this.fontName;
                a = this.measureText(b, this[c])
            }
        }
    };
    this.setAspectRatioProperties = function() {
        if (this.adjustAspectRatio && this.graphType != "Genome") {
            var a = this.meta.config.orig;
            var b = this.meta.config.user;
            var g = Math.min(this.width, this.height);
            var f = this.zoomScale ? this.zoom : 1;
            var e = ["ringSeparation", "roundedPolygonRadius", "margin", "marginLeft", "marginTop", "marginRight", "marginBottom", "overlaysThickness", "dendrogramHeight", "heatmapSeparatorThickness", "xAxisHistogramHeight", "xAxisRugHeight", "yAxisHistogramHeight", "yAxisRugHeight", "dataPointSize", "layoutLabelBoxThickness"];
            if (this.adjustAspectRatioHeatmapIndicator) {
                e.push("heatmapIndicatorHeight");
                e.push("heatmapIndicatorWidth")
            }
            for (var c = 0; c < e.length; c++) {
                if (!a[e[c]]) {
                    a[e[c]] = this[e[c]]
                }
            }
            for (var c = 0; c < e.length; c++) {
                this[e[c]] = Number(Math.max(0.5, g * this[e[c]] / 833).toFixed(1))
            }
            if (this.isDOE || (this.layoutValid && this.graphType.match(/Scatter/) && this.scatterPlotMatrix && this.scatterPlotMatrixType.match(/Density|Histogram|all/))) {
                this.dataPointSize = Number(Math.max(0.5, this.dataPointSize / Math.max(this.layoutRows, this.layoutCols)).toFixed(1)) * (this.isDOE ? 1.5 : 1)
            }
        }
    };
    this.resetAspectRatioProperties = function() {
        if (this.adjustAspectRatio && this.graphType != "Genome") {
            if (this.graphType == "Network" && !this.isLayoutDone) {
                this.setTimeout(this.resetAspectRatioProperties, 50);
                return
            }
            var a = this.meta.config.orig;
            var c = ["ringSeparation", "roundedPolygonRadius", "margin", "marginLeft", "marginTop", "marginRight", "marginBottom", "overlaysThickness", "dendrogramHeight", "heatmapSeparatorThickness", "xAxisHistogramHeight", "xAxisRugHeight", "yAxisHistogramHeight", "yAxisRugHeight", "dataPointSize", "layoutLabelBoxThickness"];
            if (this.adjustAspectRatioHeatmapIndicator) {
                c.push("heatmapIndicatorHeight");
                c.push("heatmapIndicatorWidth")
            }
            for (var b = 0; b < c.length; b++) {
                if (a[c[b]]) {
                    this[c[b]] = a[c[b]];
                    delete(a[c[b]])
                }
            }
        }
    };
    this.getGroupColor = function(b, e) {
        var h;
        if (this.isGroupedData) {
            var a = this.data.w.grps[e];
            if (a) {
                this.isGroupedData = false;
                h = this.getPropertyValue(b, a[0], "colorBy");
                for (var d = 1; d < a.length; d++) {
                    var f = this.getPropertyValue(b, a[d], "colorBy");
                    if (f != h) {
                        this.isGroupedData = true;
                        return this.foreground
                    }
                }
                this.isGroupedData = true
            } else {
                h = this.getPropertyValue(b, e, "colorBy")
            }
        } else {
            h = this.getPropertyValue(b, e, "colorBy")
        }
        return h
    };
    this.getVarColor = function(a, c) {
        if (this.isArray(this.highlightVar)) {
            for (var b = 0; b < this.highlightVar.length; b++) {
                if (this.highlightVar[b] == a) {
                    return this.varHighlightColor
                }
            }
        } else {
            if (this.highlightVar == a) {
                return this.varHighlightColor
            }
        }
        return c ? this.dendrogramColor : this.varLabelFontColor
    };
    this.getSmpColor = function(c, b) {
        if (this.isArray(this.highlightSmp)) {
            for (var a = 0; a < this.highlightSmp.length; a++) {
                if (this.highlightSmp[a] == c) {
                    return this.smpHighlightColor
                }
            }
        } else {
            if (this.highlightSmp == c) {
                return this.smpHighlightColor
            }
        }
        return b ? this.dendrogramColor : this.smpLabelFontColor
    };
    this.getNodeColor = function(e, a) {
        if (this.isArray(this.highlightNode)) {
            for (var c = 0; c < this.highlightNode.length; c++) {
                if (this.highlightNode[c] == e) {
                    return this.nodeHighlightColor
                }
            }
        } else {
            if (this.highlightNode == e) {
                return this.nodeHighlightColor
            }
        }
        var d = this.isSelected(e);
        var b = this.selectionMode == "ghost" && CanvasXpress.selector.selections && !d;
        return d && this.selectionMode == "highlight" ? this.selectionColor : b ? this.addColorTransparency(a, 0.1, true) : a ? a : this.nodeColor
    };
    this.getEdgeColor = function(f, d, a) {
        if (this.isArray(this.highlightNode)) {
            for (var c = 0; c < this.highlightNode.length; c++) {
                if (this.highlightNode[c] == f || this.highlightNode[c] == d) {
                    return this.nodeHighlightColor
                }
            }
        } else {
            if (this.highlightNode == f || this.highlightNode == d) {
                return this.nodeHighlightColor
            }
        }
        var e = this.isSelected(f) || this.isSelected(d);
        var b = this.selectionMode == "ghost" && CanvasXpress.selector.selections && !e;
        return e && this.selectionMode == "highlight" ? this.selectionColor : b ? this.addColorTransparency(a, 0.1, true) : a ? a : this.nodeColor
    };
    this.getDendrogramColor = function(a, c) {
        if (a) {
            if (this.colorVarDendrogramBy && this.data.z && this.data.z.hasOwnProperty(this.colorVarDendrogramBy)) {
                var b = this.getVariableIndices(a);
                if (b > -1) {
                    return this.getPropertyValue(b, false, "colorVarDendrogramBy")
                }
            }
            return this.getVarColor(a, true)
        } else {
            if (this.colorSmpDendrogramBy && this.data.x && this.data.x.hasOwnProperty(this.colorSmpDendrogramBy)) {
                var b = this.getSampleIndices(c);
                if (b > -1) {
                    return this.getPropertyValue(false, b, "colorSmpDendrogramBy")
                }
            }
            return this.getSmpColor(c, true)
        }
    };
    this.isStringOverlays = function(c) {
        var a = this.meta.data;
        if ((!c || c == "v") && a.z && this.varOverlays.length > 0) {
            for (var b = 0; b < this.varOverlays.length; b++) {
                var d = this.varOverlays[b];
                if (a.z[d].type != "Numeric") {
                    return true
                }
            }
        }
        if ((!c || c == "s") && a.x && this.smpOverlays.length > 0) {
            for (var b = 0; b < this.smpOverlays.length; b++) {
                var d = this.smpOverlays[b];
                if (a.x[d].type != "Numeric") {
                    return true
                }
            }
        }
        return false
    };
    this.isUniqueFactor = function(b) {
        var a = this.meta.data;
        if ((!b || b == "v") && a.z) {
            for (var c in a.z) {
                if (a.z[c].unique) {
                    return true
                }
            }
        }
        if ((!b || b == "s") && a.x) {
            for (var c in a.x) {
                if (a.x[c].unique) {
                    return true
                }
            }
        }
        return false
    };
    this.isNumericFactor = function(b) {
        var a = this.meta.data;
        if ((!b || b == "v") && a.z) {
            for (var c in a.z) {
                if (a.z[c].type == "Numeric") {
                    return true
                }
            }
        }
        if ((!b || b == "s") && a.x) {
            for (var c in a.x) {
                if (a.x[c].type == "Numeric") {
                    return true
                }
            }
        }
        return false
    };
    this.isStringFactor = function(b) {
        var a = this.meta.data;
        if ((!b || b == "v") && a.z) {
            for (var c in a.z) {
                if (a.z[c].type != "Numeric") {
                    return true
                }
            }
        }
        if ((!b || b == "s") && a.x) {
            for (var c in a.x) {
                if (a.x[c].type != "Numeric") {
                    return true
                }
            }
        }
        return false
    };
    this.getBestSizes = function(g, f) {
        if (this.graphType == "Network") {
            var d = f ? 0.5 : 0.05;
            var a = Math.min(parseInt(2 / g * 10) / 10, d);
            var e = [0.5];
            for (var c = 0; c < g - 1; c++) {
                e.push(e[c] + a)
            }
            return e
        } else {
            if (g > this.sizes.length) {
                return this.cloneObject(this.sizes)
            } else {
                var e = [];
                var b = Math.floor(this.sizes.length / g);
                for (var c = 0; c < g; c++) {
                    e.push(this.sizes[c * b])
                }
                return e
            }
        }
    };
    this.isBinConfigurations = function() {
        for (var a in this.binConfigurations) {
            return true
        }
        return false
    };
    this.initValidity = function() {
        var B = this.hexToString("686578546f537472696e67");
        var E = this[B]("6d657461");
        var p = this[B]("666163746f7279");
        var o = this[B]("636c69656e74");
        var g = this[B]("656e636f6465");
        var e = this[B]("73797374656d");
        var C = this[B]("76616c6964");
        var d = this[B]("74696d65");
        var F = this[B]("7374617274");
        var b = this[B]("73697465537263");
        var D = this[B]("757365724964");
        var b = this[B]("76657273696f6e");
        var j = this[B]("68726566");
        var A = this[B]("69734e6f6465");
        var y = new RegExp(this[B]("63616e7661737870726573732e6f7267"));
        var k = new RegExp(this[B]("5e66696c653a"));
        var i = new RegExp(this[B]("6c6f63616c686f7374"));
        CanvasXpress[p][o] = this[g]([this[E][d][F], this[D], CanvasXpress[p][b], this[j]].join("::"));
        this.setPixelImage();
        if (this[D] == 1) {
            if (window.navigator.onLine) {
                if (this[j] && CanvasXpress[p][b]) {
                    CanvasXpress[p][C] = 0
                } else {
                    if (this[j] && k.test(this[j])) {
                        CanvasXpress[p][C] = 0
                    } else {
                        if (this[j] && i.test(this[j])) {
                            CanvasXpress[p][C] = 0
                        } else {
                            if (this[j] && !y.test(this[j])) {
                                CanvasXpress[p][C] = 1
                            } else {
                                CanvasXpress[p][C] = 0
                            }
                        }
                    }
                }
            } else {
                CanvasXpress[p][C] = 0
            }
        } else {
            if (this[D] == 2) {
                if (this.isR) {
                    CanvasXpress[p][C] = 0
                } else {
                    CanvasXpress[p][C] = 3
                }
            } else {
                if (CanvasXpress[e][A]) {
                    if (this[D] < 5) {
                        CanvasXpress[p][C] = 4
                    } else {
                        CanvasXpress[p][C] = 0
                    }
                } else {
                    CanvasXpress[p][C] = 0
                }
            }
        }
    };
    this.getWorstAspectRatio = function(k, j) {
        if (!k || k.length == 0) {
            return Number.MAX_VALUE
        } else {
            var e = 0;
            var f = 0;
            var b = Number.MAX_VALUE;
            for (var c = 0; c < k.length; c++) {
                var g = k[c].area;
                e += g;
                b = (b < g) ? b : g;
                f = (f > g) ? f : g
            }
            var d = j * j;
            var h = e * e;
            return Math.max(d * f / h, h / (d * b))
        }
    };
    this.adjustTreemapCoords = function(f, e) {
        if (f) {
            var c = this.treemapBorderWidth && !this.isDOE ? 1 : 0;
            var a = this.treemapBorderWidth;
            var b = a * 2;
            var d = this.smpLabelFontSize * c;
            e.left += a;
            if (e.height > d + b) {
                e.top += d + a;
                e.height -= (d + b);
                e.border = 2
            } else {
                if (e.height > b) {
                    e.top += a;
                    e.height -= b;
                    e.border = 1
                } else {
                    if (e.height > a) {
                        e.height -= a;
                        e.border = 0
                    } else {
                        e.border = -1
                    }
                }
            }
            e.width -= b
        }
    };
    this.setTreemapRowVerticalLayout = function(k, h, g, f) {
        var c = 0;
        for (var b = 0; b < k.length; b++) {
            c += k[b].area
        }
        var a = c / h;
        var e = 0;
        for (var b = 0; b < k.length; b++) {
            var j = k[b].area / a;
            k[b].coords = {
                width: a,
                height: j,
                left: g.left,
                top: g.top + e
            };
            this.adjustTreemapCoords(f, k[b].coords);
            e += j
        }
        var d = {
            width: g.width - a,
            height: g.height,
            left: g.left + a,
            top: g.top
        };
        d.orientation = Math.min(d.width, d.height);
        if (d.orientation != d.height) {
            this.treemapOrientation = this.treemapOrientation == "horizontal" ? "vertical" : "horizontal"
        }
        return d
    };
    this.setTreemapRowHorizontalLayout = function(l, j, h, g) {
        var d = 0;
        for (var c = 0; c < l.length; c++) {
            d += l[c].area
        }
        var k = d / j;
        var f = h.top;
        var b = 0;
        for (var c = 0; c < l.length; c++) {
            var a = l[c].area / k;
            l[c].coords = {
                width: a,
                height: k,
                left: h.left + b,
                top: f
            };
            this.adjustTreemapCoords(g, l[c].coords);
            b += a
        }
        var e = {
            width: h.width,
            height: h.height - k,
            left: h.left,
            top: h.top + k
        };
        e.orientation = Math.min(e.width, e.height);
        if (e.orientation != e.width) {
            this.treemapOrientation = this.treemapOrientation == "horizontal" ? "vertical" : "horizontal"
        }
        return e
    };
    this.setTreemapRowLayout = function(a, b, c, d) {
        if (this.treemapOrientation == "horizontal") {
            return this.setTreemapRowVerticalLayout(a, b, c, d)
        } else {
            return this.setTreemapRowHorizontalLayout(a, b, c, d)
        }
    };
    this.computeTreemapDimensions = function(a, c, b, f, h) {
        if (a.length + c.length == 1) {
            var e = (a.length == 1) ? a : c;
            e[0].coords = f;
            this.adjustTreemapCoords(h, e[0].coords);
            return
        }
        if (a.length >= 2 && c.length == 0) {
            c = [a.shift()]
        }
        if (a.length == 0) {
            if (c.length > 0) {
                this.setTreemapRowLayout(c, b, f, h)
            }
            return
        }
        var d = a[0];
        if (this.getWorstAspectRatio(c, b) >= this.getWorstAspectRatio([d].concat(c), b)) {
            this.computeTreemapDimensions(a.slice(1), c.concat([d]), b, f, d.title)
        } else {
            var g = this.setTreemapRowLayout(c, b, f, h);
            this.computeTreemapDimensions(a, [], g.orientation, g, d.title)
        }
    };
    this.squarifyTreemap = function(a, g) {
        var f = g.width * g.height;
        var e = 0;
        var b = [];
        for (var d = 0; d < a.length; d++) {
            b[d] = parseFloat(a[d].area);
            e += b[d]
        }
        for (var d = 0; d < b.length; d++) {
            a[d].area = f * b[d] / e
        }
        var c = this.treemapOrientation == "horizontal" ? g.height : g.width;
        a.sort(function(i, h) {
            return h.area - i.area
        });
        this.computeTreemapDimensions(a.slice(1), [a[0]], c, g, a[0].title)
    };
    this.processTreemap = function(b, d) {
        if (!this.treemapOrientation) {
            this.treemapOrientation = "horizontal"
        }
        if (d.width >= d.height) {
            this.treemapOrientation = "horizontal"
        } else {
            this.treemapOrientation = "vertical"
        }
        if (b.length) {
            this.squarifyTreemap(b, d);
            for (var c = 0; c < b.length; c++) {
                var a = b[c].children ? b[c].children : b[c];
                var d = {
                    width: b[c].coords.width,
                    height: b[c].coords.height,
                    left: b[c].coords.left,
                    top: b[c].coords.top
                };
                this.processTreemap(a, d)
            }
        }
        return b
    };
    this.getCloudPointsAtRadius = function(a) {
        if (this.tagCloudGridPoints[a]) {
            return this.tagCloudGridPoints[a]
        }
        var b = a * 8;
        var c = b;
        var d = [];
        if (a == 0) {
            d.push([this.tagCloudGridCenter[0], this.tagCloudGridCenter[1], 0])
        }
        while (c--) {
            var e = 1;
            if (this.tagCloudShapeFunction !== "circle") {
                e = this.tagCloudShapeFunction(c / b * 2 * Math.PI)
            }
            d.push([this.tagCloudGridCenter[0] + a * e * Math.cos(-c / b * 2 * Math.PI), this.tagCloudGridCenter[1] + a * e * Math.sin(-c / b * 2 * Math.PI) * this.tagCloudTextEllipticity, c / b * 2 * Math.PI])
        }
        this.tagCloudGridPoints[a] = d;
        return d
    };
    this.getCloudRotateDeg = function() {
        if (this.tagCloudTextRotateRatio == 0) {
            return 0
        }
        if (this.random() > this.tagCloudTextRotateRatio) {
            return 0
        }
        return (-Math.PI / 2) + (this.random() * Math.PI)
    };
    this.getCloudTextInfo = function(z, n, o) {
        var a = Math.min(500, Math.floor(this.tagCloudTextWeightFactor * n));
        var s = this.$cX("canvas");
        var A = s.getContext("2d", {
            willReadFrequently: true
        });
        var p = a + "px " + this.fontName;
        A.font = p;
        var b = this.measureText(z, p);
        var m = a;
        var i = b + m * 2;
        var g = m * 3;
        var B = Math.ceil(i / this.tagCloudTextGridSize);
        var c = Math.ceil(g / this.tagCloudTextGridSize);
        i = B * this.tagCloudTextGridSize;
        g = c * this.tagCloudTextGridSize;
        var t = -b * 0.5;
        var q = -m * 0.5;
        var u = Math.ceil((i * Math.abs(Math.sin(o)) + g * Math.abs(Math.cos(o))) / this.tagCloudTextGridSize);
        var d = Math.ceil((i * Math.abs(Math.cos(o)) + g * Math.abs(Math.sin(o))) / this.tagCloudTextGridSize);
        var v = d * this.tagCloudTextGridSize;
        var r = u * this.tagCloudTextGridSize;
        if (v < 1 || r < 1) {
            return {
                occupied: [],
                bounds: [0, 0, 0, 0],
                gw: d,
                gh: u,
                fillTextOffsetX: t,
                fillTextOffsetY: q,
                fillTextWidth: b,
                fillTextHeight: m,
                fontSize: a
            }
        }
        s.setAttribute("width", v);
        s.setAttribute("height", r);
        A.save();
        A.translate(v / 2, r / 2);
        A.rotate(-o);
        A.font = a + "px " + this.fontName;
        A.fillStyle = "#000";
        A.textBaseline = "middle";
        A.fillText(z, t, q + a * 0.5);
        A.restore();
        var w = A.getImageData(0, 0, v, r).data;
        var f = [];
        var l = d,
            k, j, h;
        var e = [u / 2, d / 2, u / 2, d / 2];
        while (l--) {
            k = u;
            while (k--) {
                h = this.tagCloudTextGridSize;
                singleGridLoop: {
                    while (h--) {
                        j = this.tagCloudTextGridSize;
                        while (j--) {
                            if (w[((k * this.tagCloudTextGridSize + h) * v + (l * this.tagCloudTextGridSize + j)) * 4 + 3]) {
                                f.push([l, k]);
                                if (l < e[3]) {
                                    e[3] = l
                                }
                                if (l > e[1]) {
                                    e[1] = l
                                }
                                if (k < e[0]) {
                                    e[0] = k
                                }
                                if (k > e[2]) {
                                    e[2] = k
                                }
                                break singleGridLoop
                            }
                        }
                    }
                }
            }
        }
        return {
            occupied: f,
            bounds: e,
            gw: d,
            gh: u,
            fillTextOffsetX: t,
            fillTextOffsetY: q,
            fillTextWidth: b,
            fillTextHeight: m,
            fontSize: a
        }
    };
    this.canFitCloudText = function(g, f, h, b, a) {
        var e = a.length;
        while (e--) {
            var d = g + a[e][0];
            var c = f + a[e][1];
            if (d >= this.tagCloudGridWidth || c >= this.tagCloudGridHeight || d < 0 || c < 0 || !this.tagCloudGrid[d][c]) {
                return false
            }
        }
        return true
    };
    this.fillCloudGridAt = function(a, b) {
        if (a >= this.tagCloudGridWidth || b >= this.tagCloudGridHeight || a < 0 || b < 0) {
            return
        }
        this.tagCloudGrid[a][b] = false
    };
    this.updateCloudGrid = function(e, c, d) {
        var a = d.occupied;
        var b = a.length;
        while (b--) {
            this.fillCloudGridAt(e + a[b][0], c + a[b][1])
        }
    };
    this.drawCloudTag = function(c, i, g, d) {
        var k = this;
        var m = this.getCloudRotateDeg();
        var e = this.getCloudTextInfo(c, i, m);
        if (!e) {
            return false
        }
        var b = e.bounds;
        if ((b[1] - b[3] + 1) > this.tagCloudGridWidth || (b[2] - b[0] + 1) > this.tagCloudGridHeight) {
            return false
        }
        var a = this.tagCloudGridMaxRadius + 1;
        var j = this.addColorTransparency(g, 0, true);
        var f = this.get1DLeft();
        var p = this.get1DTop();
        while (a--) {
            var n = this.getCloudPointsAtRadius(this.tagCloudGridMaxRadius - a);
            n = [].concat(n);
            this.shuffleArray(n);
            var h = n.some(function o(q) {
                var w = Math.floor(q[0] - e.gw / 2);
                var v = Math.floor(q[1] - e.gh / 2);
                var z = e.gw;
                var s = e.gh;
                var r = e.fontSize + "px " + k.fontName;
                var l = "1px " + k.fontName;
                if (!k.canFitCloudText(w, v, z, s, e.occupied)) {
                    return false
                }
                var u = ((w + e.gw / 2) * k.tagCloudTextGridSize);
                var t = ((v + e.gh / 2) * k.tagCloudTextGridSize);
                k.renderTagCloud.push([
                    ["drawText", c, u + f, t + p, r, g, "center", "middle", -m], d, false, null, false, [k.width / 2, k.height / 2, l, j, -Math.PI * 2]
                ]);
                k.updateCloudGrid(w, v, e);
                return true
            });
            if (h) {
                return true
            }
        }
        return false
    };
    this.setTagCloud = function(b) {
        this.tagCloudTextGridSize = Math.max(this.tagCloudTextGridSize, 4);
        this.tagCloudGridWidth = Math.floor(this.x / this.tagCloudTextGridSize);
        this.tagCloudGridHeight = Math.floor(this.y / this.tagCloudTextGridSize);
        this.tagCloudGridCenter = [this.tagCloudGridWidth / 2, this.tagCloudGridHeight / 2];
        this.tagCloudGridMaxRadius = Math.floor(Math.sqrt(this.tagCloudGridWidth * this.tagCloudGridWidth + this.tagCloudGridHeight * this.tagCloudGridHeight));
        this.tagCloudGridPoints = [];
        if (!b) {
            this.setTagCloudTextWeightFactor()
        } else {
            this.tagCloudTextWeightFactor *= b
        }
        this.tagCloudGrid = [];
        var c = this.tagCloudGridWidth;
        var a;
        while (c--) {
            this.tagCloudGrid[c] = [];
            a = this.tagCloudGridHeight;
            while (a--) {
                this.tagCloudGrid[c][a] = true
            }
        }
    };
    this.setTagCloudTextWeightFactor = function() {
        var h = 0;
        var b = 0;
        var k = this.varIndices[0];
        for (var g = 0; g < this.smpIndices.length; g++) {
            var f = this.smpIndices[g];
            var j = this.getDataAtPos(k, f);
            var e = this.data.y.smps[f].length;
            var c = e * j * 0.5 * j;
            b = Math.max(c, b);
            h += c
        }
        if (!this.tagCloudTries) {
            this.tagCloudTries = 1
        }
        b = parseInt(Math.max(this.x, this.y));
        if (h > b) {
            this.tagCloudTextWeightFactor = (this.x * this.y) / (h * this.tagCloudTries)
        } else {
            this.tagCloudTextWeightFactor = (this.x * this.y) / (h * this.tagCloudTries * (b / h))
        }
        this.tagCloudTries += 1
    };
    this.tryRenderTagCloud = function(g) {
        var e = this.randomSeed;
        this.renderTagCloud = [];
        this.setTagCloud(g);
        var j = this.varIndices[0];
        for (var b = 0; b < this.smpIndices.length; b++) {
            var a = this.smpIndices[b];
            var h = this.getDataAtPos(j, a);
            var k = this.colorBy ? this.getPropertyValue(j, a, "colorBy") : this.foreground;
            if (!this.drawCloudTag(this.data.y.smps[a], h, k, [j, a])) {
                this.resizeCanvas();
                this.renderTagCloud = [];
                if (this.pseudoRandom) {
                    this.randomSeed = e
                }
                this.tryRenderTagCloud(0.9);
                break
            }
        }
        if (this.pseudoRandom) {
            this.randomSeed = e
        }
    };
    this.getVariableColor = function(a) {
        for (var b = 0; b < this.data.y.vars.length; b++) {
            if (this.data.y.vars[b] == a) {
                return this.colors[b % this.colors.length]
            }
        }
        return this.colors[0]
    };
    this.getOutlineColor = function(b, a, g) {
        var i;
        if ((this.graphType.match(/Bar/) && this.barType == "lollipop" && !this.isGroupedData) || (this.useOpenShapes && !g)) {
            i = this.removeColorTransparency(b, true)
        } else {
            if (this.graphType == "Dotplot" || (this.graphType == "Boxplot" && this.showBoxplotOriginalData)) {
                var d = this.layoutValid ? this.data.y.vars.length * this.data.y.smps.length : this.varIndices.length * this.smpIndices.length;
                if (d > this.dotplotOutlineThreshold) {
                    i = b
                } else {
                    i = this.objectBorderColor ? this.objectBorderColor : this.removeColorTransparency(b, true)
                }
            } else {
                i = this.isContour && this.contourType == "color" ? this.addColorTransparency(b, 0, true) : this.objectBorderColor && this.graphType != "Map" ? this.objectBorderColor : this.removeColorTransparency(b, true)
            }
        }
        if (a) {
            var f = this.isSelected(a);
            var e = this.isVarHighlughted(a[0]);
            var d = this.selectionMode == "ghost" && CanvasXpress.selector.selections && !f;
            i = e ? this.varHighlightColor : f && this.selectionMode == "highlight" ? this.selectionColor : d ? this.addColorTransparency(i, 0.1, true) : i
        }
        return i
    };
    this.getFillColor = function(b, a, g) {
        var i = ((this.useOpenShapes && !g) || (this.isContour && this.contourType == "color"));
        var j = this.addColorTransparency(b, (i ? 0 : this.objectColorTransparency), true);
        if (a) {
            var f = this.isSelected(a);
            var e = this.isVarHighlughted(a[0]);
            var d = this.selectionMode == "ghost" && CanvasXpress.selector.selections && !f;
            j = e ? this.varHighlightColor : f && this.selectionMode == "highlight" ? this.selectionColor : d ? this.addColorTransparency(j, 0.1, true) : j
        }
        return j
    };
    this.isVarHighlughted = function(a) {
        if (this.highlightVar.length && a != null) {
            var b = this.data.y.vars[a];
            return this.highlightVar.includes(b)
        }
    };
    this.getDefaultMetaDataObject = function() {
        var a = this.meta.def.colorBrew;
        return {
            rmin: a.rmin,
            rmax: a.rmax,
            min: a.min,
            max: a.max,
            decs: a.decs,
            vals: a.vals,
            maxLevLen: a.maxLevLen,
            maxLevChr: a.maxLevChr,
            maxLevStr: a.maxLevStr,
            colorBrew: a
        }
    };
    this.resetCacheColors = function() {
        delete(this.cacheColors)
    };
    this.setCacheColors = function() {
        if (!this.cacheColors) {
            this.cacheColors = {}
        }
        if (!this.cacheColors[this.colorScheme]) {
            this.cacheColors[this.colorScheme] = {}
        }
    };
    this.setPieData = function(n, q, m) {
        this.setCacheColors();
        var e = {
            no: 0,
            idso: [],
            ids: [],
            cols: [],
            data: {},
            raw: {},
            oprc: 0,
            tot: this.sum(n)
        };
        var b = this.getCustomColorScheme(n.length);
        for (var l = 0; l < n.length; l++) {
            var h = q ? this.varIndices[l] : l;
            var a = n[h] / e.tot;
            var g = q ? this.data.y.vars[h] : l;
            var o;
            if (m && m[l % m.length]) {
                o = m[l % m.length]
            } else {
                if (this.cacheColors[this.colorScheme].hasOwnProperty(g)) {
                    o = this.cacheColors[this.colorScheme][g]
                } else {
                    o = this.pieColors[l] || b[l % b.length];
                    this.cacheColors[this.colorScheme][g] = o
                }
            }
            if (this.isNumber(a, true)) {
                e.data[h] = a;
                e.raw[h] = n[h];
                if (l >= this.maxPieSectors - 1) {
                    e.oprc += a;
                    e.idso.push(h);
                    e.no++
                } else {
                    e.ids.push(h)
                }
                e.cols.push(o)
            }
        }
        if (e.no) {
            e.ids.push(-1)
        }
        return e
    };
    this.drawPie = function(u, h, g, t, I, w) {
        var f = this;
        var q = function() {
            for (var a = 0; a < u.ids.length; a++) {
                if (u.data[u.ids[a]] && u.data[u.ids[a]] > -1 && !f.isNumber(u.data[u.ids[a]], true)) {
                    return false
                }
            }
            return true
        };
        if (q()) {
            var z, d;
            var m = this.startPieSectors != null ? (this.startPieSectors * Math.PI / 180) % 360 : 0;
            var A = this.pieSegmentLabels == "inside" ? t - (t / 3) : t + (t / 6);
            var G = 0;
            var C = this.layoutComb ? this.smpIndices[0] : this.xAxisIndices ? this.xAxisIndices[0] : 0;
            for (var E = 0; E < u.ids.length; E++) {
                var k = u.ids[E];
                var v = k > -1 ? u.data[k] : u.oprc;
                var o = this.graphType == "Network" || this.graphType != "Pie" ? I[E] : k > -1 ? [k, C] : u.idso;
                var e = this.graphType == "Map" ? u.cols[E] : this.getFillColor(u.cols[E], o, this.isDOE);
                var D = this.getOutlineColor(e, this.graphType == "Map" ? E : o);
                z = d != null ? parseFloat(d) : parseFloat((Math.PI * (2 * G)) + m);
                d = parseFloat(z + (Math.PI * (2 * (v))));
                var H = (z + d) / 2;
                var B = (d - z) / 32;
                var J = this.graphType == "Network" || this.graphType == "Map" ? "Decorations" : this.graphType != "Pie" ? "Overlays" : "Data";
                var D = this.pieType == "separated" ? this.background : this.getOutlineColor(e);
                if (this.graphType == "Network" || this.graphType == "Map") {
                    this.toRender({
                        p: ["drawShape", "pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d],
                        a: this.getShapeArea("pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d),
                        i: (this.graphType == "Map" ? I[0] : I[E]),
                        m: w,
                        t: J,
                        h: this.isHidden(this.graphType == "Map" ? I[0][0] : I[E])
                    })
                } else {
                    if (this.graphType != "Pie") {
                        this.toRender({
                            p: ["drawShape", "pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d],
                            a: this.getShapeArea("pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d),
                            i: I[E],
                            t: J
                        })
                    } else {
                        if (k > -1) {
                            I = this.isDOE ? [k, C, "Facet-" + this.layoutCurrent] : [k, C];
                            this.toRender({
                                p: ["drawShape", "pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d],
                                a: this.getShapeArea("pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d),
                                i: I,
                                t: J,
                                h: this.isHidden(I[0])
                            })
                        } else {
                            this.toRender({
                                p: ["drawShape", "pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d],
                                a: this.getShapeArea("pie", h, g, (t * 2), t, e, D, "closed", false, 1, false, false, z, d),
                                i: u.idso,
                                t: J
                            })
                        }
                    }
                }
                var F = u.ids.length > 1 ? h - Math.sin(H - (Math.PI / 2)) * A : h;
                var b = u.ids.length > 1 ? g + Math.cos(H - (Math.PI / 2)) * A : g;
                if (this.graphType != "Network" && this.graphType != "Map" && this.showPieValues && (d - z) > 0.05) {
                    if (this.pieLabelType == "value") {
                        this.toRender({
                            p: ["drawText", u.raw[k], F, b, this.axisTickFont, this.axisTickColor, "center", "middle"],
                            t: J
                        })
                    } else {
                        this.toRender({
                            p: ["drawText", this.sprintf("%." + this.pieSegmentPrecision + "f", v * 100) + "%", F, b, this.axisTickFont, this.axisTickColor, "center", "middle"],
                            t: J
                        })
                    }
                }
                G += v
            }
            G = 0;
            d = null;
            if (u.ids.length > 1 && this.graphType != "Map") {
                for (var E = 0; E < u.ids.length; E++) {
                    var k = u.ids[E];
                    var v = k > -1 ? u.data[k] : u.oprc;
                    var e = this.getFillColor(u.cols[E]);
                    z = d != null ? parseFloat(d) : parseFloat((Math.PI * (2 * G)) + m);
                    d = parseFloat(z + (Math.PI * (2 * (v))));
                    var D = this.pieType == "separated" ? this.background : this.getOutlineColor(e);
                    this.toRender({
                        p: ["drawShape", "pie", h, g, (t * 2), t, false, D, "open", false, this.pieSegmentSeparation, false, false, z, d],
                        s: true,
                        t: J
                    });
                    G += v
                }
            }
            if (this.pieInnerRadius > 0 && this.pieInnerRadius < 1 && this.graphType != "Map") {
                this.toRender({
                    p: ["drawShape", "circle", h, g, t * this.pieInnerRadius * 2, t * this.pieInnerRadius * 2, this.background, this.background, "closed"],
                    t: J
                })
            }
        }
    };
    this.drawBarPlot = function(ah, ag, Y, Q, N, T, P, K, X, V, ak, U, an, W, ae, aa, M, am) {
        var O, L, af, S;
        var J = this;
        var j = function(a) {
            return J.isGroupedData ? M.smps[J.data.w.smps[J.grpIndices[a]]] : M.smps[J.data.y.smps[J.smpIndices[a]]]
        };
        var R = this.variableSpaceFactor / 2;
        var ad = N / 2;
        var ac = am ? "Overlays" : this.graphType == "Network" ? "Decorations" : "Data";
        if (V == "vertical" || this.graphType == "Network") {
            for (var ab = 0; ab < ah.length; ab++) {
                O = ((ah[ab] - X) * P) - K;
                var ai;
                var Z = (M && M.cap && M.cap[j(ab)]) || this.barType == "arrow" ? "arrow" : this.useRoundRectangles && O > 0 ? "roundrectt" : this.useRoundRectangles ? "roundrectb" : "rectangle";
                var A = this.getFillColor(M ? M.fill[j(ab)] : ak[ab], an[ab]);
                var al = N - this.variableSpaceFactor > 5 ? this.getOutlineColor(A, an[ab]) : A;
                var I = this.isHidden(an[ab][0], an[ab][1]);
                if (this.isNumber(O, true)) {
                    if (this.barPath) {
                        var B = this.addColorTransparency(this.barPathColor || A, this.barPathTransparency);
                        this.toRender({
                            p: ["drawShape", "rectangle", (Y + R) + ((N - this.variableSpaceFactor) / 2), K + (this.y / 2), N - this.variableSpaceFactor, this.y * 2, B, B],
                            t: "Decorations"
                        })
                    }
                    if (O < 0) {
                        ai = this.toRender({
                            p: ["drawShape", Z, (Y + R) + ((N - this.variableSpaceFactor) / 2), Q + (-O / 2), N - this.variableSpaceFactor, -O, A, al, U[ab], false, false, ae],
                            a: this.getShapeArea(Z, (Y + R) + ((N - this.variableSpaceFactor) / 2), Q + (-O / 2), N - this.variableSpaceFactor, -O, A, al, U[ab], false, false, ae),
                            i: an[ab],
                            m: W,
                            t: ac,
                            h: I
                        })
                    } else {
                        ai = this.toRender({
                            p: ["drawShape", Z, (Y + R) + ((N - this.variableSpaceFactor) / 2), Q - (O / 2), N - this.variableSpaceFactor, O, A, al, U[ab], false, false, ae],
                            a: this.getShapeArea(Z, (Y + R) + ((N - this.variableSpaceFactor) / 2), Q - (O / 2), N - this.variableSpaceFactor, O, A, al, U[ab], false, false, ae),
                            i: an[ab],
                            m: W,
                            t: ac,
                            h: I
                        })
                    }
                    af = Q - O;
                    S = Y + ad;
                    if (ag[ab] && this.isNumber(ag[ab], true)) {
                        L = (ag[ab] / 2) * P;
                        this.toRender({
                            p: ["drawLine", "error", S, af, S, af - L, this.errorBarsColor, -ad, "butt"],
                            g: ai,
                            t: ac,
                            h: I
                        });
                        this.toRender({
                            p: ["drawLine", "error", S, af, S, af + L, this.errorBarsColor, -ad, "butt"],
                            g: ai,
                            t: ac,
                            h: I
                        })
                    }
                    if (M) {
                        var H = j(ab);
                        for (var aj in M) {
                            if (aj != "cap" && aj != "high" && aj != "color" && aj != "fill") {
                                if (M[aj][H]) {
                                    for (var F = 0; F < M[aj][H].length; F++) {
                                        var E = ((M[aj][H][F][0] - X) * P) - K;
                                        var G = ((M[aj][H][F][1] - X) * P) - K;
                                        var D = (Y + R) + ((N - this.variableSpaceFactor) / 2);
                                        this.toRender({
                                            p: ["drawShape", this.shapes[0], D, Q - E, N / 2, N / 2, M.color[aj], M.color[aj]],
                                            g: ai,
                                            t: ac,
                                            h: I
                                        });
                                        if (!this.isNumber(G, true)) {
                                            G = O - this.margin
                                        } else {
                                            this.toRender({
                                                p: ["drawShape", this.shapes[1], D, Q - G, N / 2, N / 2, M.color[aj], M.color[aj]],
                                                g: ai,
                                                t: ac,
                                                h: I
                                            })
                                        }
                                        this.toRender({
                                            p: ["drawLine", "line", D, Q - E, D, Q - G, M.color[aj], this.margin],
                                            g: ai,
                                            t: ac,
                                            h: I
                                        })
                                    }
                                }
                            }
                        }
                    }
                    if (this.showDataValues && this.barType != "lollipop") {
                        this.toRender({
                            p: ["drawText", this.formatNumber(ah[ab]), S, Q - (O + (this.margin / 4)), this.smpLabelFont, A, "center", "bottom"],
                            g: ai,
                            t: ac,
                            h: I
                        })
                    }
                }
                Y += T
            }
        } else {
            for (var ab = 0; ab < ah.length; ab++) {
                O = ((ah[ab] - X) * P) - K;
                var ai;
                var Z = (M && M.cap && M.cap[j(ab)]) || this.barType == "arrow" ? "arrow" : !this.useRoundRectangles ? "rectangle" : aa || O < 0 ? "roundrectl" : "roundrectr";
                var A = this.getFillColor(M ? M.fill[j(ab)] : ak[ab], an[ab]);
                var al = N - this.variableSpaceFactor > 5 ? this.getOutlineColor(A, an[ab]) : A;
                var I = this.isHidden(an[ab][0], an[ab][1]);
                if (this.isNumber(O, true)) {
                    if (this.barPath) {
                        var B = this.addColorTransparency(this.barPathColor || A, this.barPathTransparency);
                        this.toRender({
                            p: ["drawShape", "rectangle", K + (this.x / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), this.x * 2, N - this.variableSpaceFactor, B, B],
                            t: "Decorations"
                        })
                    }
                    if (O < 0) {
                        if (aa) {
                            ai = this.toRender({
                                p: ["drawShape", Z, ((Y + aa) - K) + (-O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), -O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae],
                                a: this.getShapeArea(Z, ((Y + aa) - K) + (-O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), -O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae),
                                i: an[ab],
                                m: W,
                                t: ac,
                                h: I
                            })
                        } else {
                            ai = this.toRender({
                                p: ["drawShape", Z, (Y + O) + (-O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), -O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae],
                                a: this.getShapeArea(Z, (Y + O) + (-O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), -O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae),
                                i: an[ab],
                                m: W,
                                t: ac,
                                h: I
                            })
                        }
                    } else {
                        if (aa) {
                            ai = this.toRender({
                                p: ["drawShape", Z, ((Y + aa) - (O + K)) + (O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae],
                                a: this.getShapeArea(Z, ((Y + aa) - (O + K)) + (O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae),
                                i: an[ab],
                                m: W,
                                t: ac,
                                h: I
                            })
                        } else {
                            ai = this.toRender({
                                p: ["drawShape", Z, Y + (O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae],
                                a: this.getShapeArea(Z, Y + (O / 2), (Q + R) + ((N - this.variableSpaceFactor) / 2), O, N - this.variableSpaceFactor, A, al, U[ab], Z == "arrow" ? true : false, false, ae),
                                i: an[ab],
                                m: W,
                                t: ac,
                                h: I
                            })
                        }
                    }
                    af = aa ? (Y + aa) - (O + K) : Y + O;
                    S = Q + ad;
                    if (ag[ab] && this.isNumber(ag[ab], true)) {
                        L = (ag[ab] / 2) * P;
                        this.toRender({
                            p: ["drawLine", "error", af, S, af + L, S, this.errorBarsColor, ad, "butt"],
                            g: ai,
                            t: ac,
                            h: I
                        });
                        this.toRender({
                            p: ["drawLine", "error", af, S, af - L, S, this.errorBarsColor, ad, "butt"],
                            g: ai,
                            t: ac,
                            h: I
                        })
                    }
                    if (M) {
                        var H = j(ab);
                        for (var aj in M) {
                            if (aj != "cap" && aj != "high" && aj != "color" && aj != "fill") {
                                if (M[aj][H]) {
                                    for (var F = 0; F < M[aj][H].length; F++) {
                                        var E = ((M[aj][H][F][0] - X) * P) - K;
                                        var G = ((M[aj][H][F][1] - X) * P) - K;
                                        var C = (Q + R) + ((N - this.variableSpaceFactor) / 2);
                                        this.toRender({
                                            p: ["drawShape", this.shapes[0], Y + E, C, N / 2, N / 2, M.color[aj], M.color[aj]],
                                            g: ai,
                                            t: ac,
                                            h: I
                                        });
                                        if (!this.isNumber(G, true)) {
                                            G = O - this.margin
                                        } else {
                                            this.toRender({
                                                p: ["drawShape", this.shapes[1], Y + G, C, N / 2, N / 2, M.color[aj], M.color[aj]],
                                                g: ai,
                                                t: ac,
                                                h: I
                                            })
                                        }
                                        this.toRender({
                                            p: ["drawLine", "line", Y + E, C, Y + G, C, M.color[aj], this.margin],
                                            g: ai,
                                            t: ac,
                                            h: I
                                        })
                                    }
                                }
                            }
                        }
                    }
                    if (this.showDataValues && this.barType != "lollipop") {
                        this.toRender({
                            p: ["drawText", this.formatNumber(ah[ab]), af + (this.margin / 4), S, this.smpLabelFont, ak[ab], "left", "middle"],
                            g: ai,
                            t: ac,
                            h: I
                        })
                    }
                }
                Q += T
            }
        }
    };
    this.drawLinePlot = function(ae, ad, V, O, M, aa, N, U, S, ag, Q, P, aj, ac, ab, W, F, ai) {
        var I = function() {
            var b = [
                [],
                []
            ];
            if (S == "vertical") {
                for (var a = 0; a < r[0].length; a++) {
                    b[0].push(r[0][a]);
                    b[1].push(r[1][a][0])
                }
                for (var a = r[0].length - 1; a >= 0; a--) {
                    b[0].push(r[0][a]);
                    b[1].push(r[1][a][1])
                }
            } else {
                for (var a = 0; a < r[1].length; a++) {
                    b[0].push(r[0][a][0]);
                    b[1].push(r[1][a])
                }
                for (var a = r[1].length - 1; a >= 0; a--) {
                    b[0].push(r[0][a][1]);
                    b[1].push(r[1][a])
                }
            }
            return b
        };
        var R, A, y, x, j, al, ak, af, J, B;
        var L = null;
        var D = null;
        var H = M / 2;
        var G = Math.min(10, M / 3);
        var ah = Q == "open" ? ag : this.foreground;
        var T = ae.length - 1;
        var K = [
            [],
            []
        ];
        var r = [
            [],
            []
        ];
        var X = [];
        var C = this.getVariableIndices(F);
        var Z = ai ? "Overlays" : "Data";
        if (S == "vertical") {
            A = V;
            y = V + aa;
            if (L == null) {
                L = A
            }
            for (var Y = 1; Y < ae.length; Y++) {
                R = Y - 1;
                if (this.isObject(N)) {
                    j = O - ((ae[R] - N[R].min) * N[R].units);
                    al = O - ((ae[Y] - N[Y].min) * N[Y].units)
                } else {
                    j = O - ((ae[R] - U) * N);
                    al = O - ((ae[Y] - U) * N)
                }
                if (D == null) {
                    D = j
                }
                if (this.isNumber(j, true)) {
                    if (this.lineDecoration && this.lineDecoration != "pattern" && P) {
                        af = this.toRender({
                            p: ["drawShape", P, A, j, G, G, ag, ah, Q[R], false, false, ab],
                            a: this.getShapeArea(P, A, j, G, G, ag, ah, Q[R], false, false, ab),
                            i: aj[R],
                            m: ac,
                            g: J,
                            b: [L, D],
                            t: Z,
                            h: this.isHidden(aj[R][0], aj[R][1])
                        })
                    } else {
                        af = this.toRender({
                            p: ["drawShape", "sphere", A, j, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[R], false, false, ab],
                            a: this.getShapeArea("sphere", A, j, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[R], false, false, ab),
                            i: aj[R],
                            m: ac,
                            g: J,
                            b: [L, D],
                            t: Z,
                            h: this.isHidden(aj[R][0], aj[R][1])
                        })
                    }
                    if (!J) {
                        J = af
                    }
                    if (this.isNumber(ad[R], true)) {
                        ak = (ad[R] / 2) * this.isObject(N) ? N[R].units : N;
                        if (this.lineErrorType == "bar") {
                            this.toRender({
                                p: ["drawLine", "error", A, j, A, j + ak, ag, -H, "butt"],
                                a: this.getLineArea("error", A, j, A, j + ak, ag, -H, "butt"),
                                i: ["Line:" + F + ":" + C],
                                g: J,
                                b: [L, D],
                                t: Z,
                                h: this.isHidden(C)
                            });
                            this.toRender({
                                p: ["drawLine", "error", A, j, A, j - ak, ag, -H, "butt"],
                                a: this.getLineArea("error", A, j, A, j - ak, ag, -H, "butt"),
                                i: ["Line:" + F + ":" + C],
                                g: J,
                                b: [L, D],
                                t: Z,
                                h: this.isHidden(C)
                            })
                        } else {
                            r[0].push([A, A]);
                            r[1].push([j + ak, j - ak]);
                            X.push([A, j])
                        }
                    }
                    if (this.lineType == "spline") {
                        K[0].push(A);
                        K[1].push(j)
                    }
                }
                if ((this.lineType != "spline" && this.isNumber(j, true) && this.isNumber(al, true)) || ae.length < 3) {
                    af = this.toRender({
                        p: ["drawLine", this.lineDecoration == "pattern" ? Q[R] : this.lineType, A, j, y, al, ag, this.lineThickness, "butt", false, false, ab],
                        a: this.getLineArea("line", A, j, y, al, ag, this.lineThickness, "butt", false, false, ab),
                        i: ["Line:" + F + ":" + C],
                        g: J,
                        b: [L, D],
                        t: Z,
                        h: this.isHidden(C)
                    })
                } else {
                    if (this.lineType == "spline" && !this.isNumber(al, true)) {
                        af = this.toRender({
                            p: ["drawLine", "spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab],
                            a: this.getLineArea("spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab),
                            i: ["Line:" + F + ":" + C],
                            g: J,
                            b: [L, D],
                            t: Z,
                            h: this.isHidden(C)
                        });
                        K = [
                            [],
                            []
                        ];
                        L = null;
                        D = null
                    }
                }
                if (!J) {
                    J = af
                }
                if (r[0].length > 0 && !this.isNumber(al, true)) {
                    var v = this.addColorTransparency(ag, 0.3, true);
                    if (this.lineType == "spline") {
                        this.toRender({
                            p: ["drawShape", "confidence", r[0], r[1], false, false, v, v, "closed"],
                            a: this.getShapeArea("confidence", r[0], r[1], false, false, v, v, "closed"),
                            i: ["Line-Error:" + F + ":" + C],
                            b: X,
                            t: Z,
                            h: this.isHidden(C)
                        })
                    } else {
                        var E = I();
                        this.toRender({
                            p: ["drawShape", "path", E[0], E[1], false, false, v, v, "closed"],
                            a: this.getShapeArea("path", E[0], E[1], false, false, v, v, "closed"),
                            i: ["Line-Error:" + F + ":" + C],
                            b: X,
                            t: Z,
                            h: this.isHidden(C)
                        })
                    }
                    r = [
                        [],
                        []
                    ];
                    X = []
                }
                A += aa;
                y += aa
            }
            if (this.isNumber(al, true)) {
                if (this.lineDecoration && this.lineDecoration != "pattern" && P) {
                    af = this.toRender({
                        p: ["drawShape", P, A, al, G, G, ag, ah, Q[T], false, false, ab],
                        a: this.getShapeArea(P, A, al, G, G, ag, ah, Q[T], false, false, ab),
                        i: aj[T],
                        m: ac,
                        g: J,
                        b: [L, D],
                        t: Z,
                        h: this.isHidden(aj[T][0], aj[T][1])
                    })
                } else {
                    af = this.toRender({
                        p: ["drawShape", "sphere", A, al, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[T], false, false, ab],
                        a: this.getShapeArea("sphere", A, al, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[T], false, false, ab),
                        i: aj[T],
                        m: ac,
                        g: J,
                        b: [L, D],
                        t: Z,
                        h: this.isHidden(aj[T][0], aj[T][1])
                    })
                }
                if (!J) {
                    J = af
                }
                if (this.isNumber(ad[T], true)) {
                    ak = (ad[T] / 2) * this.isObject(N) ? N[T].units : N;
                    if (this.lineErrorType == "bar") {
                        this.toRender({
                            p: ["drawLine", "error", A, al, A, al + ak, ag, -H, "butt"],
                            a: this.getLineArea("error", A, al, A, al + ak, ag, -H, "butt"),
                            i: ["Line:" + F + ":" + C],
                            g: J,
                            t: Z,
                            h: this.isHidden(C)
                        });
                        this.toRender({
                            p: ["drawLine", "error", A, al, A, al - ak, ag, -H, "butt"],
                            a: this.getLineArea("error", A, al, A, al - ak, ag, -H, "butt"),
                            i: ["Line:" + F + ":" + C],
                            g: J,
                            t: Z,
                            h: this.isHidden(C)
                        })
                    } else {
                        if (Y == ae.length) {
                            r[0].push([A, A]);
                            r[1].push([al + ak, al - ak]);
                            X.push([A, al])
                        }
                    }
                }
                if (this.lineType == "spline") {
                    K[0].push(A);
                    K[1].push(al)
                }
            }
            if (this.lineType == "spline") {
                af = this.toRender({
                    p: ["drawLine", "spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab],
                    a: this.getLineArea("spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab),
                    i: ["Line:" + F + ":" + C],
                    b: [L, D],
                    t: Z,
                    h: this.isHidden(C)
                })
            }
            if (!J) {
                J = af
            }
            if (r[0].length > 0) {
                var v = this.addColorTransparency(ag, 0.3, true);
                if (this.lineType == "spline") {
                    this.toRender({
                        p: ["drawShape", "confidence", r[0], r[1], false, false, v, v, "closed"],
                        a: this.getShapeArea("confidence", r[0], r[1], false, false, v, v, "closed"),
                        i: ["Line-Error:" + F + ":" + C],
                        b: X,
                        t: Z,
                        h: this.isHidden(C)
                    })
                } else {
                    var E = I();
                    this.toRender({
                        p: ["drawShape", "path", E[0], E[1], false, false, v, v, "closed"],
                        a: this.getShapeArea("path", E[0], E[1], false, false, v, v, "closed"),
                        i: ["Line-Error:" + F + ":" + C],
                        b: X,
                        t: Z,
                        h: this.isHidden(C)
                    })
                }
            }
        } else {
            j = O;
            al = O + aa;
            if (D == null) {
                D = j
            }
            for (var Y = 1; Y < ae.length; Y++) {
                R = Y - 1;
                if (this.isObject(N)) {
                    A = W ? V + W - ((ae[R] - N[R].min) * N[R].units) : V + ((ae[R] - N[R].min) * N[R].units);
                    y = W ? V + W - ((ae[Y] - N[Y].min) * N[Y].units) : V + ((ae[Y] - N[Y].min) * N[Y].units)
                } else {
                    A = W ? V + W - ((ae[R] - U) * N) : V + ((ae[R] - U) * N);
                    y = W ? V + W - ((ae[Y] - U) * N) : V + ((ae[Y] - U) * N)
                }
                if (L == null) {
                    L = A
                }
                if (this.isNumber(A, true)) {
                    if (this.lineDecoration && this.lineDecoration != "pattern" && P) {
                        this.toRender({
                            p: ["drawShape", P, A, j, G, G, ag, ah, Q[R], false, false, ab],
                            a: this.getShapeArea(P, A, j, G, G, ag, ah, Q[R], false, false, ab),
                            i: aj[R],
                            m: ac,
                            b: [L, D],
                            t: Z,
                            h: this.isHidden(aj[R][0], aj[R][1])
                        })
                    } else {
                        this.toRender({
                            p: ["drawShape", "sphere", A, j, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[R], false, false, ab],
                            a: this.getShapeArea("sphere", A, j, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[R], false, false, ab),
                            i: aj[R],
                            m: ac,
                            b: [L, D],
                            t: Z,
                            h: this.isHidden(aj[R][0], aj[R][1])
                        })
                    }
                    if (this.isNumber(ad[R], true)) {
                        x = (ad[R] / 2) * this.isObject(N) ? N[R].units : N;
                        if (this.lineErrorType == "bar") {
                            af = this.toRender({
                                p: ["drawLine", "error", A, j, A + x, j, ag, H, "butt"],
                                a: this.getLineArea("error", A, j, A + x, j, ag, H, "butt"),
                                i: ["Line:" + F + ":" + C],
                                g: J,
                                t: Z,
                                h: this.isHidden(C)
                            });
                            if (!J) {
                                J = af
                            }
                            this.toRender({
                                p: ["drawLine", "error", A, j, A - x, j, ag, H, "butt"],
                                a: this.getLineArea("error", A, j, A - x, j, ag, H, "butt"),
                                i: ["Line:" + F + ":" + C],
                                g: J,
                                t: Z
                            })
                        } else {
                            r[0].push([A + x, A - x]);
                            r[1].push([j, j]);
                            X.push([A, j])
                        }
                    }
                    if (this.lineType == "spline") {
                        K[0].push(A);
                        K[1].push(j)
                    }
                }
                if ((this.lineType != "spline" && this.isNumber(A, true) && this.isNumber(y, true)) || ae.length < 3) {
                    af = this.toRender({
                        p: ["drawLine", this.lineDecoration == "pattern" ? Q[R] : this.lineType, A, j, y, al, ag, this.lineThickness, "butt", false, false, ab],
                        a: this.getLineArea("line", A, j, y, al, ag, this.lineThickness, "butt", false, false, ab),
                        i: ["Line:" + F + ":" + C],
                        b: [L, D],
                        t: Z,
                        h: this.isHidden(C)
                    })
                } else {
                    if (this.lineType == "spline" && !this.isNumber(y, true)) {
                        af = this.toRender({
                            p: ["drawLine", "spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab],
                            a: this.getLineArea("spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab),
                            i: ["Line:" + F + ":" + C],
                            b: [L, D],
                            t: Z,
                            h: this.isHidden(C)
                        });
                        K = [
                            [],
                            []
                        ];
                        L = null;
                        D = null
                    }
                }
                if (!J) {
                    J = af
                }
                if (r[1].length > 0 && !this.isNumber(y, true)) {
                    var v = this.addColorTransparency(ag, 0.3, true);
                    if (this.lineType == "spline") {
                        this.toRender({
                            p: ["drawShape", "confidence", r[0], r[1], false, false, v, v, "closed"],
                            a: this.getShapeArea("confidence", r[0], r[1], false, false, v, v, "closed"),
                            i: ["Line-Error:" + F + ":" + C],
                            b: X,
                            t: Z,
                            h: this.isHidden(C)
                        })
                    } else {
                        var E = I();
                        this.toRender({
                            p: ["drawShape", "path", E[0], E[1], false, false, v, v, "closed"],
                            a: this.getShapeArea("path", E[0], E[1], false, false, v, v, "closed"),
                            i: ["Line-Error:" + F + ":" + C],
                            b: X,
                            t: Z,
                            h: this.isHidden(C)
                        })
                    }
                    r = [
                        [],
                        []
                    ];
                    X = []
                }
                j += aa;
                al += aa
            }
            if (this.isNumber(y, true)) {
                if (this.lineDecoration && this.lineDecoration != "pattern" && P) {
                    this.toRender({
                        p: ["drawShape", P, y, j, G, G, ag, ah, Q[T], false, false, ab],
                        a: this.getShapeArea(P, y, j, G, G, ag, ah, Q[T], false, false, ab),
                        i: aj[T],
                        m: ac,
                        b: [L, D],
                        t: Z,
                        h: this.isHidden(aj[T][0], aj[T][1])
                    })
                } else {
                    this.toRender({
                        p: ["drawShape", "sphere", y, j, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[T], false, false, ab],
                        a: this.getShapeArea("sphere", y, j, G, G, this.addColorTransparency(ag, 0, true), "rgba(0,0,0,0)", Q[T], false, false, ab),
                        i: aj[T],
                        m: ac,
                        b: [L, D],
                        t: Z,
                        h: this.isHidden(aj[T][0], aj[T][1])
                    })
                }
                if (this.isNumber(ad[T], true)) {
                    x = (ad[T] / 2) * this.isObject(N) ? N[T].units : N;
                    if (this.lineErrorType == "bar") {
                        af = this.toRender({
                            p: ["drawLine", "error", y, j, y + x, j, ag, H, "butt"],
                            a: this.getLineArea("error", y, j, y + x, j, ag, H, "butt"),
                            i: ["Line:" + F + ":" + C],
                            g: J,
                            t: Z,
                            h: this.isHidden(C)
                        });
                        if (!J) {
                            J = af
                        }
                        this.toRender({
                            p: ["drawLine", "error", y, j, y - x, j, ag, H, "butt"],
                            a: this.getLineArea("error", y, j, y - x, j, ag, H, "butt"),
                            i: ["Line:" + F + ":" + C],
                            g: J,
                            t: Z,
                            h: this.isHidden(C)
                        })
                    } else {
                        r[0].push([y + x, y - x]);
                        r[1].push([j, j]);
                        X.push([y, j])
                    }
                }
                if (this.lineType == "spline") {
                    K[0].push(y);
                    K[1].push(j)
                }
            }
            if (this.lineType == "spline") {
                af = this.toRender({
                    p: ["drawLine", "spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab],
                    a: this.getLineArea("spline", K[0], K[1], false, false, ag, this.lineThickness, false, false, false, ab),
                    i: ["Line:" + F + ":" + C],
                    b: [L, D],
                    t: Z,
                    h: this.isHidden(C)
                })
            }
            if (!J) {
                J = af
            }
            if (r[1].length > 0) {
                var v = this.addColorTransparency(ag, 0.3, true);
                if (this.lineType == "spline") {
                    this.toRender({
                        p: ["drawShape", "confidence", r[0], r[1], false, false, v, v, "closed"],
                        a: this.getShapeArea("confidence", r[0], r[1], false, false, v, v, "closed"),
                        i: ["Line-Error:" + F + ":" + C],
                        b: X,
                        t: Z,
                        h: this.isHidden(C)
                    })
                } else {
                    var E = I();
                    this.toRender({
                        p: ["drawShape", "path", E[0], E[1], false, false, v, v, "closed"],
                        a: this.getShapeArea("path", E[0], E[1], false, false, v, v, "closed"),
                        i: ["Line-Error:" + F + ":" + C],
                        b: X,
                        t: Z,
                        h: this.isHidden(C)
                    })
                }
            }
        }
    };
    this.drawStackedPlot = function(S, L, D, A, U, G, P, C, x, H, T, F, V, J, M, Q, R) {
        var j = D;
        var y = L;
        var r = this;
        var W = R ? "Overlays" : "Data";
        var O = function(c, e, b, d, a) {
            return r.processTreemap(c, {
                width: d,
                height: a,
                left: e,
                top: b
            })
        };
        if (H == "vertical") {
            D = j - x;
            for (var N = 0; N < S.length; N++) {
                if (S[N] > 0) {
                    var B = G ? (S[N] * 100 / P[0]) * C : S[N] * C;
                    var K = N == S.length - 1 && this.useRoundRectangles ? "roundrectt" : "rectangle";
                    var s = this.getFillColor(T[N], V[N]);
                    var m = A > 5 ? this.getOutlineColor(s, V[N]) : s;
                    if (this.graphType == "Network") {
                        this.toRender({
                            p: ["drawShape", K, L + (A / 2), D - (B / 2), A, B, T[N], T[N]],
                            a: this.getShapeArea(K, L + (A / 2), D - (B / 2), A, B, T[N], T[N]),
                            i: V[N],
                            m: J,
                            t: "Decorations"
                        })
                    } else {
                        if (U) {
                            var I = O(U[N], L, D - B, A, B);
                            this.drawTreemap(I, 0, 0)
                        } else {
                            var h = this.stackBy ? this.isHidden(false, false, "Property:" + this.stackBy + ":" + V[N][4] + ":x") : this.isHidden(V[N][0], V[N][1]);
                            var E = this.toRender({
                                p: ["drawShape", K, L + (A / 2), D - (B / 2), A, B, s, m, F[N]],
                                a: this.getShapeArea(K, L + (A / 2), D - (B / 2), A, B, s, m, F[N]),
                                i: V[N],
                                m: J,
                                b: Q,
                                t: W,
                                h: h
                            });
                            if (this.showDataValues) {
                                this.toRender({
                                    p: ["drawText", this.formatNumber(S[N]), L + (A / 2), D - (B / 2), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                    g: E,
                                    t: W,
                                    h: h
                                })
                            }
                        }
                    }
                    D -= B
                }
            }
            D = j - x;
            for (var N = S.length - 1; N >= 0; N--) {
                if (S[N] < 0) {
                    var B = G ? (S[N] * 100 / -P[1]) * C : S[N] * C;
                    var K = N > 0 || !this.useRoundRectangles ? "rectangle" : "roundrectb";
                    var s = this.getFillColor(T[N], V[N]);
                    var m = A > 5 ? this.getOutlineColor(s, V[N]) : s;
                    if (this.graphType == "Network") {
                        this.toRender({
                            p: ["drawShape", K, L + (A / 2), D - (B / 2), A, -B, T[N], T[N]],
                            a: this.getShapeArea(K, L + (A / 2), D - (B / 2), A, -B, T[N], T[N]),
                            i: V[N],
                            m: J,
                            t: "Decorations"
                        })
                    } else {
                        if (U) {
                            var I = O(U[N], L, D - B, A, -B);
                            this.drawTreemap(I, 0, 0)
                        } else {
                            var h = this.stackBy ? this.isHidden(false, false, "Property:" + this.stackBy + ":" + V[N][4] + ":x") : this.isHidden(V[N][0], V[N][1]);
                            var E = this.toRender({
                                p: ["drawShape", K, L + (A / 2), D - (B / 2), A, -B, s, m, F[N]],
                                a: this.getShapeArea(K, L + (A / 2), D - (B / 2), A, -B, s, m, F[N]),
                                i: V[N],
                                m: J,
                                b: Q,
                                t: W,
                                h: h
                            });
                            if (this.showDataValues) {
                                this.toRender({
                                    p: ["drawText", this.formatNumber(S[N]), L + (A / 2), D - (B / 2), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                    g: E,
                                    t: W,
                                    h: h
                                })
                            }
                        }
                    }
                    D -= B
                }
            }
        } else {
            L = y + x;
            for (var N = 0; N < S.length; N++) {
                if (S[N] > 0) {
                    var B = G ? (S[N] * 100 / P[0]) * C : S[N] * C;
                    var K = N < S.length - 1 || !this.useRoundRectangles ? "rectangle" : M ? "roundrectl" : "roundrectr";
                    var s = this.getFillColor(T[N], V[N]);
                    var m = A > 5 ? this.getOutlineColor(s, V[N]) : s;
                    if (M) {
                        if (this.graphType == "Network") {
                            this.toRender({
                                p: ["drawShape", K, L + M - (B / 2), D + (A / 2), B, A, T[N], T[N], F[N]],
                                a: this.getShapeArea(K, L + M - (B / 2), D + (A / 2), B, A, T[N], T[N], F[N]),
                                i: V[N],
                                m: J,
                                t: "Decorations"
                            })
                        } else {
                            if (U) {
                                var I = O(U[N], L + M - B, D, B, A);
                                this.drawTreemap(I, 0, 0)
                            } else {
                                var h = this.stackBy ? this.isHidden(false, false, "Property:" + this.stackBy + ":" + V[N][4] + ":x") : this.isHidden(V[N][0], V[N][1]);
                                var E = this.toRender({
                                    p: ["drawShape", K, L + M - (B / 2), D + (A / 2), B, A, s, m, F[N]],
                                    a: this.getShapeArea(K, L + M - (B / 2), D + (A / 2), B, A, s, m, F[N]),
                                    i: V[N],
                                    m: J,
                                    b: Q,
                                    t: W,
                                    h: h
                                });
                                if (this.showDataValues) {
                                    this.toRender({
                                        p: ["drawText", this.formatNumber(S[N]), L + M - (B / 2), D + (A / 2), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                        g: E,
                                        t: W,
                                        h: h
                                    })
                                }
                            }
                        }
                        L -= B
                    } else {
                        if (this.graphType == "Network") {
                            this.toRender({
                                p: ["drawShape", K, L + (B / 2), D + (A / 2), B, A, T[N], T[N], F[N]],
                                a: this.getShapeArea(K, L + (B / 2), D + (A / 2), B, A, T[N], T[N], F[N]),
                                i: V[N],
                                m: J,
                                t: "Decorations"
                            })
                        } else {
                            if (U) {
                                var R = O(U[N], L, D, B, A);
                                this.drawTreemap(R, 0, 0)
                            } else {
                                var h = this.stackBy ? this.isHidden(false, false, "Property:" + this.stackBy + ":" + V[N][4] + ":x") : this.isHidden(V[N][0], V[N][1]);
                                var E = this.toRender({
                                    p: ["drawShape", K, L + (B / 2), D + (A / 2), B, A, s, m, F[N]],
                                    a: this.getShapeArea(K, L + (B / 2), D + (A / 2), B, A, s, m, F[N]),
                                    i: V[N],
                                    m: J,
                                    b: Q,
                                    t: W,
                                    h: h
                                });
                                if (this.showDataValues) {
                                    this.toRender({
                                        p: ["drawText", this.formatNumber(S[N]), L + (B / 2), D + (A / 2), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                        g: E,
                                        t: W,
                                        h: h
                                    })
                                }
                            }
                        }
                        L += B
                    }
                }
            }
            L = y + x;
            for (var N = S.length - 1; N >= 0; N--) {
                if (S[N] < 0) {
                    var B = G ? (S[N] * 100 / -P[1]) * C : S[N] * C;
                    var K = N > 0 || !this.useRoundRectangles ? "rectangle" : M ? "roundrectr" : "roundrectl";
                    var s = this.getFillColor(T[N], V[N]);
                    var m = A > 5 ? this.getOutlineColor(s, V[N]) : s;
                    if (M) {
                        if (this.graphType == "Network") {
                            this.toRender({
                                p: ["drawShape", K, L + M - (B / 2), D + (A / 2), -B, A, T[N], T[N], F[N]],
                                a: this.getShapeArea(K, L + M - (B / 2), D + (A / 2), -B, A, T[N], T[N], F[N]),
                                i: V[N],
                                m: J,
                                t: "Decorations"
                            })
                        } else {
                            if (U) {
                                var I = O(U[N], L + M - B, D, -B, A);
                                this.drawTreemap(I, 0, 0)
                            } else {
                                var h = this.stackBy ? this.isHidden(false, false, "Property:" + this.stackBy + ":" + V[N][4] + ":x") : this.isHidden(V[N][0], V[N][1]);
                                var E = this.toRender({
                                    p: ["drawShape", K, L + M - (B / 2), D + (A / 2), -B, A, s, m, F[N]],
                                    a: this.getShapeArea(K, L + M - (B / 2), D + (A / 2), -B, A, s, m, F[N]),
                                    i: V[N],
                                    m: J,
                                    b: Q,
                                    t: W,
                                    h: h
                                });
                                if (this.showDataValues) {
                                    this.toRender({
                                        p: ["drawText", this.formatNumber(S[N]), L + M - (B / 2), D + (A / 2), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                        g: E,
                                        t: W,
                                        h: h
                                    })
                                }
                            }
                        }
                        L -= B
                    } else {
                        if (this.graphType == "Network") {
                            this.toRender({
                                p: ["drawShape", K, L + (B / 2), D + (A / 2), -B, A, T[N], T[N], F[N]],
                                a: this.getShapeArea(K, L + (B / 2), D + (A / 2), -B, A, T[N], T[N], F[N]),
                                i: V[N],
                                m: J,
                                t: "Decorations"
                            })
                        } else {
                            if (U) {
                                var R = O(U[N], L, D, -B, A);
                                this.drawTreemap(R, 0, 0)
                            } else {
                                var h = this.stackBy ? this.isHidden(false, false, "Property:" + this.stackBy + ":" + V[N][4] + ":x") : this.isHidden(V[N][0], V[N][1]);
                                var E = this.toRender({
                                    p: ["drawShape", K, L + (B / 2), D + (A / 2), -B, A, s, m, F[N]],
                                    a: this.getShapeArea(K, L + (B / 2), D + (A / 2), -B, A, s, m, F[N]),
                                    i: V[N],
                                    m: J,
                                    b: Q,
                                    t: W,
                                    h: h
                                });
                                if (this.showDataValues) {
                                    this.toRender({
                                        p: ["drawText", this.formatNumber(S[N]), L + (B / 2), D + (A / 2), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                        g: E,
                                        t: W,
                                        h: h
                                    })
                                }
                            }
                        }
                        L += B
                    }
                }
            }
        }
    };
    this.drawAreaPlot = function(ai, Z, S, Q, ae, T, ag, V, J, D, m, X, af, ak, W, an, al, M, G, am) {
        var Y = ai.length - 1;
        var aa = af && this.lineType == "rect" ? "path" : this.lineType == "rect" ? "polygon" : "spline";
        var A = [];
        var B = [];
        var U = [];
        var ao = -D * J;
        var C = m * J;
        var ad = am ? "Overlays" : "Data";
        var L = function(b, a) {
            for (var c = a + 1; c < ai[b].length; c++) {
                if (ai[b][c] > 0) {
                    return 1
                } else {
                    if (ai[b][c] < 0) {
                        return -1
                    }
                }
            }
            return 0
        };
        if (X == "vertical") {
            for (var ac = 0; ac < ai[0].length; ac++) {
                A[ac] = ag == "stacked" && D < 0 ? S - C : S;
                B[ac] = S - C
            }
            for (var ac = 0; ac < ai.length; ac++) {
                var ah = Z;
                var P = af ? [] : [Z];
                var N = af ? [] : [S - ao];
                var H = 0;
                var aj, K;
                for (var ab = 0; ab < ai[0].length; ab++) {
                    if (!this.isNumber(ai[ac][ab], true)) {
                        if (!af) {
                            P.push(ah - T);
                            N.push(S - ao)
                        }
                        if (af && this.lineType == "spline") {
                            this.toRender({
                                p: ["drawLine", aa, P, N, false, false, ak[ac], this.lineThickness],
                                a: this.getLineArea(aa, P, N, false, false, ak[ac], this.lineThickness),
                                i: an[ac],
                                m: al,
                                b: S - ao,
                                t: ad,
                                h: this.isHidden(an[ac][0])
                            })
                        } else {
                            if (D >= 0 && Y > 0 && ag != "normal") {
                                var E = U[U.length - 1][1];
                                P.shift();
                                var F = [];
                                var ap = [];
                                for (var ac = 1; ac < N.length; ac++) {
                                    F.push([P[ac - 1], P[ac - 1]]);
                                    ap.push([N[ac], E[ac]])
                                }
                                this.toRender({
                                    p: ["drawShape", "confidence", F, ap, this.width, this.height, this.getFillColor(ak[Y], an[Y]), this.getOutlineColor(ak[Y], an[Y]), W[Y]],
                                    a: this.getShapeArea("confidence", F, ap, this.width, this.height, this.getFillColor(ak[Y], an[Y]), this.getOutlineColor(ak[Y], an[Y]), W[Y]),
                                    i: an[Y],
                                    m: al,
                                    b: S - ao,
                                    t: ad,
                                    h: this.isHidden(an[Y][0])
                                })
                            } else {
                                this.toRender({
                                    p: ["drawShape", aa, P, N, this.width, this.height, this.getFillColor(ak[ac], an[ac]), this.getOutlineColor(ak[ac], an[ac]), W[ac]],
                                    a: this.getShapeArea(aa, P, N, this.width, this.height, this.getFillColor(ak[ac], an[ac]), this.getOutlineColor(ak[ac], an[ac]), W[ac]),
                                    i: an[ac],
                                    m: al,
                                    b: S - ao,
                                    t: ad,
                                    h: this.isHidden(an[ac][0])
                                })
                            }
                        }
                        if (G) {
                            var u = this.addColorTransparency(ak[ac], 0, true);
                            for (var I = 0; I < P.length; I++) {
                                aj = this.toRender({
                                    p: ["drawShape", "sphere", P[I], N[I], T, T, u, "rgba(0,0,0,0)", W[ac]],
                                    a: this.getShapeArea("sphere", P[I], N[I], T, T, u, "rgba(0,0,0,0)", W[ac]),
                                    i: [an[ac][0], G[I]],
                                    s: true,
                                    t: ad
                                });
                                if (!af) {
                                    this.toRender({
                                        p: ["drawLine", "line", P[I], N[I] + T, P[I], N[0], u, T],
                                        a: this.getLineArea("line", P[I], N[I] + T, P[I], N[0], u, T),
                                        i: [an[ac][0], G[I]],
                                        g: aj,
                                        s: true,
                                        t: ad
                                    })
                                }
                            }
                        }
                        P = af ? [] : [ah + T];
                        N = af ? [] : [S - ao]
                    } else {
                        var R = ag == "percent" ? ((ai[ac][ab] - D) * 100 / V[ab]) * J : (ai[ac][ab] - (ag == "stacked" && D < 0 ? 0 : D)) * J;
                        P.push(ah);
                        if (ag && (ag == "stacked" || ag == "percent")) {
                            if (ai[ac][ab] > 0 || H > 0) {
                                N.push(A[ab] - R);
                                A[ab] -= R;
                                H = 1
                            } else {
                                if (ai[ac][ab] < 0 || H < 0) {
                                    N.push(B[ab] - R);
                                    B[ab] -= R;
                                    H = -1
                                } else {
                                    var O = L(ac, ab);
                                    if (O < 0) {
                                        N.push(B[ab] - R);
                                        B[ab] -= R;
                                        H = -1
                                    } else {
                                        if (O > 0) {
                                            N.push(A[ab] - R);
                                            A[ab] -= R;
                                            H = 1
                                        } else {
                                            N.push(ao)
                                        }
                                    }
                                }
                            }
                        } else {
                            N.push(S - R)
                        }
                    }
                    ah += T
                }
                if (!af) {
                    P.push(Z + Q);
                    N.push(S - ao)
                }
                U.push([P, N, ak[ac], W[ac], an[ac]])
            }
        } else {
            for (var ac = 0; ac < ai[0].length; ac++) {
                A[ac] = M ? Z + M : ag == "stacked" && D < 0 ? Z + C : Z;
                B[ac] = Z + C
            }
            for (var ac = 0; ac < ai.length; ac++) {
                var ah = S;
                var P = af ? [] : M ? [Z + M] : [Z + ao];
                var N = af ? [] : [S];
                var H = 0;
                var aj, K;
                for (var ab = 0; ab < ai[0].length; ab++) {
                    if (!this.isNumber(ai[ac][ab], true)) {
                        if (!af) {
                            P.push(M ? Z + M : Z + ao);
                            N.push(ah - T)
                        }
                        if (af && this.lineType == "spline") {
                            this.toRender({
                                p: ["drawLine", aa, P, N, false, false, ak[ac], this.lineThickness],
                                a: this.getLineArea(aa, P, N, false, false, ak[ac], this.lineThickness),
                                i: an[ac],
                                m: al,
                                b: Z + ao,
                                t: ad,
                                h: this.isHidden(an[ac][0])
                            })
                        } else {
                            var E = U[U.length - 1][0];
                            if (D >= 0 && Y > 0 && ag != "normal") {
                                N.shift();
                                var F = [];
                                var ap = [];
                                for (var ac = 1; ac < P.length; ac++) {
                                    F.push([P[ac], E[ac]]);
                                    ap.push([N[ac - 1], N[ac - 1]])
                                }
                                this.toRender({
                                    p: ["drawShape", "confidence", F, ap, this.width, this.height, this.getFillColor(ak[Y], an[Y]), this.getOutlineColor(ak[Y], an[Y]), W[Y]],
                                    a: this.getShapeArea("confidence", F, ap, this.width, this.height, this.getFillColor(ak[Y], an[Y]), this.getOutlineColor(ak[Y], an[Y]), W[Y]),
                                    i: an[Y],
                                    m: al,
                                    b: Z + ao,
                                    t: ad,
                                    h: this.isHidden(an[Y][0])
                                })
                            } else {
                                this.toRender({
                                    p: ["drawShape", aa, P, N, this.width, this.height, this.getFillColor(ak[ac], an[ac]), this.getOutlineColor(ak[ac], an[ac]), W[ac]],
                                    a: this.getShapeArea(aa, P, N, this.width, this.height, this.getFillColor(ak[ac], an[ac]), this.getOutlineColor(ak[ac], an[ac]), W[ac]),
                                    i: an[ac],
                                    m: al,
                                    b: Z + ao,
                                    t: ad,
                                    h: this.isHidden(an[ac][0])
                                })
                            }
                        }
                        if (G) {
                            var u = this.addColorTransparency(ak[ac], 0, true);
                            for (var I = 0; I < P.length; I++) {
                                aj = this.toRender({
                                    p: ["drawShape", "sphere", P[I], N[I], T, T, u, "rgba(0,0,0,0)", W[ac]],
                                    a: this.getShapeArea("sphere", P[I], N[I], T, T, u, "rgba(0,0,0,0)", W[ac]),
                                    i: [an[ac][0], G[I]],
                                    s: true,
                                    t: ad
                                });
                                if (!af) {
                                    this.toRender({
                                        p: ["drawLine", "line", P[I] - T, N[I], P[0], N[I], u, T],
                                        a: this.getLineArea("line", P[I] - T, N[I], P[0], N[I], u, T),
                                        i: [an[ac][0], G[I]],
                                        g: aj,
                                        s: true,
                                        t: ad
                                    })
                                }
                            }
                        }
                        P = af ? [] : [M ? Z + M : Z + ao];
                        N = af ? [] : [ah + T]
                    } else {
                        var R = ag == "percent" ? ((ai[ac][ab] - D) * 100 / V[ab]) * J : (ai[ac][ab] - (ag == "stacked" && D < 0 ? 0 : D)) * J;
                        N.push(ah);
                        if (ag && (ag == "stacked" || ag == "percent")) {
                            if (M) {
                                P.push(A[ab] - R);
                                A[ab] -= R
                            } else {
                                if (ai[ac][ab] > 0 || H > 0) {
                                    P.push(A[ab] + R);
                                    A[ab] += R;
                                    H = 1
                                } else {
                                    if (ai[ac][ab] < 0 || H < 0) {
                                        P.push(B[ab] + R);
                                        B[ab] += R;
                                        H = -1
                                    } else {
                                        var O = L(ac, ab);
                                        if (O < 0) {
                                            P.push(B[ab] + R);
                                            B[ab] += R;
                                            H = -1
                                        } else {
                                            if (O > 0) {
                                                P.push(A[ab] + R);
                                                A[ab] += R;
                                                H = 1
                                            } else {
                                                N.push(ao)
                                            }
                                        }
                                    }
                                }
                            }
                        } else {
                            P.push(M ? Z + M - R : Z + R)
                        }
                    }
                    ah += T
                }
                if (!af) {
                    P.push(M ? Z + M : Z + ao);
                    N.push(S + ae)
                }
                U.push([P, N, ak[ac], W[ac], an[ac]])
            }
        }
        while (Y >= 0) {
            var aj, K;
            var ab = U.pop();
            if (af) {
                if (this.lineType == "spline") {
                    this.toRender({
                        p: ["drawLine", aa, ab[0], ab[1], false, false, ab[2], this.lineThickness],
                        a: this.getLineArea(aa, ab[0], ab[1], false, false, ab[2], this.lineThickness),
                        i: ab[4],
                        m: al,
                        b: X == "vertical" ? S - ao : Z + ao,
                        t: ad,
                        h: this.isHidden(ab[4][0])
                    })
                } else {
                    var K = null;
                    for (var ac = 1; ac < ab[0].length; ac++) {
                        var aj = this.toRender({
                            p: ["drawLine", aa, ab[0][ac - 1], ab[1][ac - 1], ab[0][ac], ab[1][ac], ab[2], this.lineThickness],
                            a: this.getLineArea(aa, ab[0][ac - 1], ab[1][ac - 1], ab[0][ac], ab[1][ac], ab[2], this.lineThickness),
                            i: ab[4],
                            m: al,
                            g: K,
                            b: X == "vertical" ? S - ao : Z + ao,
                            t: ad,
                            h: this.isHidden(ab[4][0])
                        });
                        if (K == null) {
                            K = aj
                        }
                    }
                }
            } else {
                if (D >= 0 && Y > 0 && ag != "normal") {
                    var E = X == "vertical" ? U[U.length - 1][1] : U[U.length - 1][0];
                    if (X == "vertical") {
                        ab[0].shift();
                        ab[0].pop();
                        var F = [];
                        var ap = [];
                        for (var ac = 1; ac < ab[1].length - 1; ac++) {
                            F.push([ab[0][ac - 1], ab[0][ac - 1]]);
                            ap.push([ab[1][ac], E[ac]])
                        }
                        ab[1].shift();
                        ab[1].pop();
                        this.toRender({
                            p: ["drawShape", "confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]],
                            a: this.getShapeArea("confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]),
                            i: ab[4],
                            m: al,
                            b: S - ao,
                            t: ad,
                            h: this.isHidden(ab[4][0])
                        })
                    } else {
                        ab[1].shift();
                        ab[1].pop();
                        var F = [];
                        var ap = [];
                        for (var ac = 1; ac < ab[0].length - 1; ac++) {
                            F.push([ab[0][ac], E[ac]]);
                            ap.push([ab[1][ac - 1], ab[1][ac - 1]])
                        }
                        ab[0].shift();
                        ab[0].pop();
                        this.toRender({
                            p: ["drawShape", "confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]],
                            a: this.getShapeArea("confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]),
                            i: ab[4],
                            m: al,
                            b: Z + ao,
                            t: ad,
                            h: this.isHidden(ab[4][0])
                        })
                    }
                } else {
                    if (ag == "normal" || ag == "stacked") {
                        this.toRender({
                            p: ["drawShape", aa, ab[0], ab[1], this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]],
                            a: this.getShapeArea(aa, ab[0], ab[1], this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]),
                            i: ab[4],
                            m: al,
                            b: X == "vertical" ? S - ao : Z + ao,
                            t: ad,
                            h: this.isHidden(ab[4][0])
                        })
                    } else {
                        if (X == "vertical") {
                            var ap = [];
                            for (var ac = 1; ac < ab[1].length - 1; ac++) {
                                ap.push([ab[1][ac], ab[1][0]])
                            }
                            this.toRender({
                                p: ["drawShape", "confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]],
                                a: this.getShapeArea("confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]),
                                i: ab[4],
                                m: al,
                                b: S - ao,
                                t: ad,
                                h: this.isHidden(ab[4][0])
                            })
                        } else {
                            var F = [];
                            for (var ac = 1; ac < ab[0].length - 1; ac++) {
                                F.push([ab[0][ac], ab[0][0]])
                            }
                            this.toRender({
                                p: ["drawShape", "confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]],
                                a: this.getShapeArea("confidence", F, ap, this.width, this.height, this.getFillColor(ab[2]), this.getOutlineColor(ab[2]), ab[3]),
                                i: ab[4],
                                m: al,
                                b: Z + ao,
                                t: ad,
                                h: this.isHidden(ab[4][0])
                            })
                        }
                    }
                }
            }
            if (G) {
                var u = this.addColorTransparency(ab[2], 0, true);
                var g = Math.min(10, T);
                for (var ac = 1; ac < ab[0].length - 1; ac++) {
                    if (this.isGraphTime && G[ac - 1] < 0) {
                        continue
                    }
                    aj = this.toRender({
                        p: ["drawShape", "sphere", ab[0][ac], ab[1][ac], g, g, u, "rgba(0,0,0,0)", ab[3]],
                        a: this.getShapeArea("sphere", ab[0][ac], ab[1][ac], g, g, u, "rgba(0,0,0,0)", ab[3]),
                        i: [ab[4][0], G[ac - 1]],
                        s: true,
                        t: ad
                    });
                    if (!af) {
                        if (X == "vertical") {
                            this.toRender({
                                p: ["drawLine", "line", ab[0][ac], ab[1][ac] + T, ab[0][ac], ab[1][0], u, T],
                                a: this.getLineArea("line", ab[0][ac], ab[1][ac] + T, ab[0][ac], ab[1][0], u, T),
                                i: [ab[4][0], G[ac - 1]],
                                g: aj,
                                s: true,
                                t: ad
                            })
                        } else {
                            this.toRender({
                                p: ["drawLine", "line", ab[0][ac] - T, ab[1][ac], ab[0][0], ab[1][ac], u, T],
                                a: this.getLineArea("line", ab[0][ac] - T, ab[1][ac], ab[0][0], ab[1][ac], u, T),
                                i: [ab[4][0], G[ac - 1]],
                                g: aj,
                                s: true,
                                t: ad
                            })
                        }
                    }
                }
            }
            Y--
        }
    };
    this.drawBoxPlot = function(aq, ag, Y, V, ab, X, af, ad, ar, ac, au, am, n, U) {
        var S = this;
        var ae = this.segregateSamplesBy.length && this.isGroupedData && this.groupingFactors.includes(this.segregateSamplesBy[0]);
        var C = function(f) {
            var d;
            if (S.layoutValid && !S.isDOE) {
                if (S.segregateVariablesBy.length > 0) {
                    d = f
                } else {
                    if (S.segregateSamplesBy.length > 0) {
                        var a = !ae ? [S.data.l.name[S.layoutCurrent], S.data.w.glab[f]].join("::") : S.data.w.labs[f] ? S.data.w.labs[f] : S.data.w.glab[f];
                        for (var c = 0; c < k.g[D].length; c++) {
                            if (k.g[D][c].density.name == a) {
                                d = c;
                                break
                            }
                        }
                    }
                }
            } else {
                d = S.grpIndices[f]
            }
            return k.g[D][d]
        };
        var T = function(a) {
            return ad == "vertical" ? Y - ((a - af) * X) : ag + ((a - af) * X)
        };
        var k = this.meta.data.d;
        var D = this.getVariableIndices(U);
        var Z = this.variableSpaceFactor / 2;
        var ak = V / 2;
        var G = ak / 2;
        var E = G / 2;
        var ao = V / this.boxplotOutliersRatio;
        var F = {};
        var R = {};
        var K = false;
        var P = this.isGroupedData && this.showViolinBoxplot && this.isRawData ? (V - this.variableSpaceFactor) * this.boxplotWidthRatioIfViolin : V - this.variableSpaceFactor;
        var O = this.isGroupedData && this.showViolinBoxplot && this.isRawData ? V * this.boxplotWidthRatioIfViolin : 0;
        var N = this.isGroupedData && this.showViolinBoxplot && this.isRawData ? O / 2 : ak;
        var b = Math.max(1, V / 4);
        if (ad == "vertical") {
            for (var aj = 0; aj < aq.length; aj++) {
                if (this.isGraphTime && au[aj][1] < 0) {
                    ag += ab;
                    continue
                }
                var Q = this.showBoxplotOriginalData ? this.isHidden(au[aj][0]) : this.scatterPlotMatrix && this.scatterType == "boxplot" ? this.isHidden(false, false, au[aj][1]) : this.isHidden(au[aj][0], au[aj][1], false, true);
                if (this.isGroupedData && this.showViolinBoxplot && this.isRawData && aq[aj].length > 1) {
                    var B = C(this.layoutValid ? au[aj][1] : aj);
                    if (B) {
                        this.drawViolin(B, ag + (V / 2), Y, V / this.varIndices.length, X, af, ad, am[aj], n[aj], au[aj], Q);
                        if (!this.showBoxplotIfViolin) {
                            K = true
                        }
                    }
                }
                var aa = ag + ak;
                var W = [];
                var A = [];
                var L = this.showBoxplotOriginalData || this.showViolinBoxplot ? am[aj] : ar[aj];
                for (var ai = 0; ai < 5; ai++) {
                    W.push(T(aq[aj][ai]));
                    A.push(W[W.length - 1].toString())
                }
                if (!K) {
                    var M = (ag + Z) + ((V - this.variableSpaceFactor) / 2);
                    var an = W[3] + ((W[2] - W[3]) / 2);
                    var al = P;
                    var at = W[2] - W[3];
                    var e = this.boxplotNotched ? T(aq[aj][7][0]) : false;
                    var ah = this.boxplotNotched ? T(aq[aj][7][1]) : false;
                    var I = this.showBoxplotOriginalData ? this.addColorTransparency(this.getFillColor(ar[aj], au[aj]), this.boxplotTransparency, true) : this.getFillColor(ar[aj], au[aj]);
                    var H = this.getOutlineColor(I, au[aj]);
                    var ap, J, x;
                    if (this.boxplotNotched && this.boxplotType != "range") {
                        if (this.showViolinBoxplot) {
                            J = [ag + (V - Z - O) - b, ag + Z + O, ag + Z + O, ag + (V - Z - O), ag + (V - Z - O), ag + Z + O + b, ag + (V - Z - O) - b]
                        } else {
                            J = [ag + Z + O + b, ag + Z + O, ag + Z + O, ag + (V - Z - O), ag + (V - Z - O), ag + (V - Z - O) - b, ag + Z + O + b]
                        }
                        x = [W[4], e, W[2], W[2], e, W[4], W[4]];
                        ap = this.toRender({
                            p: ["drawShape", "polygon", J, x, false, false, I, H, ac[aj]],
                            a: this.getShapeArea("polygon", J, x, false, false, I, H, ac[aj]),
                            i: au[aj],
                            b: Y,
                            t: "Data",
                            h: Q
                        });
                        x = [W[4], ah, W[3], W[3], ah, W[4], W[4]];
                        this.toRender({
                            p: ["drawShape", "polygon", J, x, false, false, I, H, ac[aj]],
                            a: this.getShapeArea("polygon", J, x, false, false, I, H, ac[aj]),
                            i: au[aj],
                            g: ap,
                            b: Y,
                            t: "Data",
                            h: Q
                        })
                    } else {
                        if (this.boxplotType == "range") {
                            ap = this.toRender({
                                p: ["drawLine", "line", M, W[1], M, W[0], this.useOpenShapes ? H : I, ao, "round"],
                                a: this.getLineArea("line", M, W[1], M, W[0], this.useOpenShapes ? H : I, ao, "round"),
                                i: au[aj],
                                b: Y,
                                t: "Data",
                                h: Q
                            })
                        } else {
                            ap = this.toRender({
                                p: ["drawShape", this.useRoundRectangles ? "roundrect" : "rectangle", M, an, al, at, I, H, ac[aj]],
                                a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "rectangle", M, an, al, at, I, H, ac[aj]),
                                i: au[aj],
                                b: Y,
                                t: "Data",
                                h: Q
                            })
                        }
                    }
                    if (this.unique(A).length != 0) {
                        if (this.boxplotNotched && this.boxplotType != "range") {
                            this.toRender({
                                p: ["drawLine", "median", ag + Z + O + b, W[4], ag + (V - Z - O) - b, W[4], this.boxplotMedianColor, this.boxplotMedianWidth, "butt"],
                                a: this.getLineArea("median", ag + Z + O + b, W[4], ag + (V - Z - O) - b, W[4], this.boxplotMedianColor, this.boxplotMedianWidth, "butt"),
                                i: au[aj],
                                g: ap,
                                t: "Data",
                                h: Q
                            })
                        } else {
                            if (this.boxplotType == "range") {
                                this.toRender({
                                    p: ["drawShape", "sphere", M, W[4], ao * 2.5, ao * 2.5, this.useOpenShapes ? H : I, this.useOpenShapes ? H : I],
                                    a: this.getShapeArea("sphere", M, W[4], ao * 2.5, ao * 2.5, this.useOpenShapes ? H : I, this.useOpenShapes ? H : I),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                })
                            } else {
                                this.toRender({
                                    p: ["drawLine", "median", ag + Z + O, W[4], ag + (V - Z - O), W[4], this.boxplotMedianColor, this.boxplotMedianWidth, "butt"],
                                    a: this.getLineArea("median", ag + Z + O, W[4], ag + (V - Z - O), W[4], this.boxplotMedianColor, this.boxplotMedianWidth, "butt"),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                })
                            }
                        }
                        if (this.boxplotType != "range") {
                            if (this.boxplotWhiskersType == "single") {
                                this.toRender({
                                    p: ["drawLine", "line", aa, W[2], aa, W[0], H, false, "butt"],
                                    a: this.getLineArea("line", aa, W[2], aa, W[0], H, false, "butt"),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                });
                                this.toRender({
                                    p: ["drawLine", "line", aa, W[3], aa, W[1], H, false, "butt"],
                                    a: this.getLineArea("line", aa, W[3], aa, W[1], H, false, "butt"),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                })
                            } else {
                                if (this.boxplotWhiskersType == "double") {
                                    this.toRender({
                                        p: ["drawLine", "error", aa, W[2], aa, W[0], H, -N, "butt"],
                                        a: this.getLineArea("error", aa, W[2], aa, W[0], H, -N, "butt"),
                                        i: au[aj],
                                        g: ap,
                                        t: "Data",
                                        h: Q
                                    });
                                    this.toRender({
                                        p: ["drawLine", "error", aa, W[3], aa, W[1], H, -N, "butt"],
                                        a: this.getLineArea("error", aa, W[3], aa, W[1], H, -N, "butt"),
                                        i: au[aj],
                                        g: ap,
                                        t: "Data",
                                        h: Q
                                    })
                                }
                            }
                        }
                    }
                    if (this.boxplotMean) {
                        this.toRender({
                            p: ["drawShape", this.useRoundRectangles ? "roundrect" : "rectangle", aa, T(aq[aj][6]), G, G, this.boxplotMeanColor, this.boxplotMeanColorBorder],
                            a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "rectangle", aa, T(aq[aj][6]), G, G, this.boxplotMeanColor, this.boxplotMeanColorBorder),
                            i: au[aj],
                            g: ap,
                            b: Y,
                            t: "Data",
                            h: Q
                        })
                    }
                    if (aq[aj][5] && !this.showBoxplotOriginalData) {
                        for (var ai = 0; ai < aq[aj][5].length; ai++) {
                            this.toRender({
                                p: ["drawShape", "sphere", aa, T(aq[aj][5][ai]), ao, ao, I, H, ac[aj]],
                                a: this.getShapeArea("sphere", aa, T(aq[aj][5][ai]), ao, ao, I, H, ac[aj]),
                                i: au[aj],
                                g: ap,
                                b: Y,
                                t: "Data",
                                h: Q
                            })
                        }
                    }
                }
                if (!F.hasOwnProperty(L)) {
                    F[L] = [];
                    R[L] = this.cloneObject(au[aj])
                }
                F[L].push([ag + Z + (V / 2), W[4]]);
                ag += ab
            }
        } else {
            for (var aj = 0; aj < aq.length; aj++) {
                if (this.isGraphTime && au[aj][1] < 0) {
                    Y += ab;
                    continue
                }
                var Q = this.showBoxplotOriginalData ? this.isHidden(au[aj][0]) : this.isHidden(au[aj][0], au[aj][1], false, true);
                if (this.isGroupedData && this.showViolinBoxplot && this.isRawData && aq[aj].length > 1) {
                    var B = C(this.layoutValid ? au[aj][1] : aj);
                    if (B) {
                        this.drawViolin(B, ag, Y + (V / 2), V / this.varIndices.length, X, af, ad, am[aj], n[aj], au[aj], Q);
                        if (!this.showBoxplotIfViolin) {
                            K = true
                        }
                    }
                }
                var aa = Y + ak;
                var W = [];
                var A = [];
                var L = this.showBoxplotOriginalData || this.showViolinBoxplot ? am[aj] : ar[aj];
                for (var ai = 0; ai < 5; ai++) {
                    W.push(T(aq[aj][ai]));
                    A.push(W[W.length - 1].toString())
                }
                if (!K) {
                    var M = W[2] + ((W[3] - W[2]) / 2);
                    var an = (Y + Z) + ((V - this.variableSpaceFactor) / 2);
                    var al = W[3] - W[2];
                    var at = P;
                    var e = this.boxplotNotched ? T(aq[aj][7][0]) : false;
                    var ah = this.boxplotNotched ? T(aq[aj][7][1]) : false;
                    var I = this.showBoxplotOriginalData ? this.addColorTransparency(this.getFillColor(ar[aj], au[aj]), this.boxplotTransparency, true) : this.getFillColor(ar[aj], au[aj]);
                    var H = this.getOutlineColor(I, au[aj]);
                    var ap, J, x;
                    if (this.boxplotNotched && this.boxplotType != "range") {
                        J = [W[4], e, W[2], W[2], e, W[4], W[4]];
                        if (this.showViolinBoxplot) {
                            x = [Y + (V - Z - O) - b, Y + Z + O, Y + Z + O, Y + (V - Z - O), Y + (V - Z - O), Y + Z + O + b, Y + (V - Z - O) - b]
                        } else {
                            x = [Y + Z + O + b, Y + Z + O, Y + Z + O, Y + (V - Z - O), Y + (V - Z - O), Y + (V - Z - O) - b, Y + Z + O + b]
                        }
                        ap = this.toRender({
                            p: ["drawShape", "polygon", J, x, false, false, I, H, ac[aj]],
                            a: this.getShapeArea("polygon", J, x, false, false, I, H, ac[aj]),
                            i: au[aj],
                            b: Y,
                            t: "Data",
                            h: Q
                        });
                        J = [W[4], ah, W[3], W[3], ah, W[4], W[4]];
                        this.toRender({
                            p: ["drawShape", "polygon", J, x, false, false, I, H, ac[aj]],
                            a: this.getShapeArea("polygon", J, x, false, false, I, H, ac[aj]),
                            i: au[aj],
                            g: ap,
                            b: Y,
                            t: "Data",
                            h: Q
                        })
                    } else {
                        if (this.boxplotType == "range") {
                            ap = this.toRender({
                                p: ["drawLine", "line", W[0], an, W[1], an, this.useOpenShapes ? H : I, ao, "round"],
                                a: this.getLineArea("line", W[0], an, W[1], an, this.useOpenShapes ? H : I, ao, "round"),
                                i: au[aj],
                                b: ag,
                                t: "Data",
                                h: Q
                            })
                        } else {
                            ap = this.toRender({
                                p: ["drawShape", this.useRoundRectangles ? "roundrect" : "rectangle", M, an, al, at, I, H, ac[aj]],
                                a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "rectangle", M, an, al, at, I, H, ac[aj]),
                                i: au[aj],
                                b: ag,
                                t: "Data",
                                h: Q
                            })
                        }
                    }
                    if (this.unique(A).length != 0) {
                        if (this.boxplotNotched && this.boxplotType != "range") {
                            this.toRender({
                                p: ["drawLine", "median", W[4], Y + Z + O + b, W[4], Y + (V - Z - O) - b, this.boxplotMedianColor, this.boxplotMedianWidth, "butt"],
                                a: this.getLineArea("median", W[4], Y + Z + O + b, W[4], Y + (V - Z - O) - b, this.boxplotMedianColor, this.boxplotMedianWidth, "butt"),
                                i: au[aj],
                                g: ap,
                                t: "Data",
                                h: Q
                            })
                        } else {
                            if (this.boxplotType == "range") {
                                this.toRender({
                                    p: ["drawShape", "sphere", W[4], an, ao * 2.5, ao * 2.5, this.useOpenShapes ? H : I, this.useOpenShapes ? H : I],
                                    a: this.getShapeArea("sphere", W[4], an, ao * 2.5, ao * 2.5, this.useOpenShapes ? H : I, this.useOpenShapes ? H : I),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                })
                            } else {
                                this.toRender({
                                    p: ["drawLine", "median", W[4], Y + Z + O, W[4], Y + (V - Z - O), this.boxplotMedianColor, this.boxplotMedianWidth, "butt"],
                                    a: this.getLineArea("median", W[4], Y + Z + O, W[4], Y + (V - Z - O), this.boxplotMedianColor, this.boxplotMedianWidth, "butt"),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                })
                            }
                        }
                        if (this.boxplotType != "range") {
                            if (this.boxplotWhiskersType == "single") {
                                this.toRender({
                                    p: ["drawLine", "line", W[2], aa, W[0], aa, H, false, "butt"],
                                    a: this.getLineArea("line", W[2], aa, W[0], aa, H, false, "butt"),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                });
                                this.toRender({
                                    p: ["drawLine", "line", W[3], aa, W[1], aa, H, false, "butt"],
                                    a: this.getLineArea("line", W[3], aa, W[1], aa, H, false, "butt"),
                                    i: au[aj],
                                    g: ap,
                                    t: "Data",
                                    h: Q
                                })
                            } else {
                                if (this.boxplotWhiskersType == "double") {
                                    this.toRender({
                                        p: ["drawLine", "error", W[2], aa, W[0], aa, H, N, "butt"],
                                        a: this.getLineArea("error", W[2], aa, W[0], aa, H, N, "butt"),
                                        i: au[aj],
                                        g: ap,
                                        t: "Data",
                                        h: Q
                                    });
                                    this.toRender({
                                        p: ["drawLine", "error", W[3], aa, W[1], aa, H, N, "butt"],
                                        a: this.getLineArea("error", W[3], aa, W[1], aa, H, N, "butt"),
                                        i: au[aj],
                                        g: ap,
                                        t: "Data",
                                        h: Q
                                    })
                                }
                            }
                        }
                    }
                    if (this.boxplotMean) {
                        this.toRender({
                            p: ["drawShape", this.useRoundRectangles ? "roundrect" : "rectangle", T(aq[aj][6]), aa, G, G, this.boxplotMeanColor, this.boxplotMeanColorBorder],
                            a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "rectangle", T(aq[aj][6]), aa, G, G, this.boxplotMeanColor, this.boxplotMeanColorBorder),
                            i: au[aj],
                            g: ap,
                            b: ag,
                            t: "Data",
                            h: Q
                        })
                    }
                    if (aq[aj][5] && !this.showBoxplotOriginalData) {
                        for (var ai = 0; ai < aq[aj][5].length; ai++) {
                            this.toRender({
                                p: ["drawShape", "sphere", T(aq[aj][5][ai]), aa, ao, ao, I, H, ac[aj]],
                                a: this.getShapeArea("sphere", T(aq[aj][5][ai]), aa, ao, ao, I, H, ac[aj]),
                                i: au[aj],
                                g: ap,
                                b: ag,
                                t: "Data",
                                h: Q
                            })
                        }
                    }
                }
                if (!F.hasOwnProperty(L)) {
                    F[L] = [];
                    R[L] = this.cloneObject(au[aj])
                }
                F[L].push([W[4], Y + Z + (V / 2)]);
                Y += ab
            }
        }
        if (this.boxplotConnect) {
            for (var L in F) {
                if (F[L].length > 1) {
                    var ap = this.toRender({
                        p: ["drawLine", "line", F[L][0][0], F[L][0][1], F[L][1][0], F[L][1][1], L, this.boxplotConnectWidth, "butt"],
                        a: this.getLineArea("line", F[L][0][0], F[L][0][1], F[L][1][0], F[L][1][1], L, this.boxplotConnectWidth, "butt"),
                        i: ["Line:", R[L][0], R[L][1]],
                        t: "Data",
                        h: Q
                    });
                    for (var aj = 1; aj < F[L].length - 1; aj++) {
                        this.toRender({
                            p: ["drawLine", "line", F[L][aj][0], F[L][aj][1], F[L][aj + 1][0], F[L][aj + 1][1], L, this.boxplotConnectWidth, "butt"],
                            a: this.getLineArea("line", F[L][aj][0], F[L][aj][1], F[L][aj + 1][0], F[L][aj + 1][1], L, this.boxplotConnectWidth, "butt"),
                            i: ["Line:", R[L][0], R[L][1]],
                            g: ap,
                            t: "Data",
                            h: Q
                        })
                    }
                }
            }
        }
    };
    this.drawGanttPlot = function(R, E, T, H, L, C, P, B, K, F, S, U) {
        var y = function(a) {
            return L + ((a - K) * B)
        };
        var x = null;
        for (var N = 0; N < R.length; N++) {
            var J = y(R[N][0]);
            var f = y(R[N][1]);
            var A = J + ((f - J) / 2);
            var e = C + (P / 2);
            var W = f - J;
            var v = E[N] ? W * E[N] : false;
            var w = this.getFillColor(S[N], U[N]);
            var g = this.addColorTransparency(w, this.ganttCompletionTransparency, true);
            var s = this.getOutlineColor(w, U[N]);
            var r = this.isHidden(false, U[N][0]);
            var D = this.toRender({
                p: ["drawShape", "roundrect", A, e, W, P, g, g, F[N]],
                a: this.getShapeArea("roundrect", A, e, W, P, g, g, F[N]),
                i: U[N],
                g: x,
                b: L,
                t: "Data",
                h: r
            });
            if (!x) {
                x = D
            }
            if (E[N]) {
                if (E[N] == 1) {
                    this.toRender({
                        p: ["drawShape", "roundrect", A, e, W, P, w, w, F[N]],
                        a: this.getShapeArea("roundrect", A, e, W, P, w, w, F[N]),
                        i: U[N],
                        g: x,
                        b: L,
                        t: "Data",
                        h: r
                    })
                } else {
                    this.toRender({
                        p: ["drawShape", "roundrectl", A - ((W - v) / 2), e, v, P, w, w, F[N]],
                        a: this.getShapeArea("roundrectl", A - ((W - v) / 2), e, v, P, w, w, F[N]),
                        i: U[N],
                        g: x,
                        b: L,
                        t: "Data",
                        h: r
                    })
                }
            }
            this.toRender({
                p: ["drawShape", "roundrect", A, e, W, P, false, s, "open"],
                a: this.getShapeArea("roundrect", A, e, W, P, false, s, "open"),
                i: U[N],
                g: x,
                b: L,
                t: "Data",
                h: r
            });
            if (H.length) {
                for (var M = 0; M < H.length; M++) {
                    var I = y(H[M][0]);
                    this.toRender({
                        p: ["drawShape", "triangle2", I, C, P / 3, P / 3, w, s],
                        a: this.getShapeArea("triangle2", I, C, P / 3, P / 3, w, s),
                        i: [].concat(U[N].concat(H[M][1])),
                        g: x,
                        b: L,
                        t: "Data",
                        h: r
                    })
                }
            }
            if (T[N]) {
                var G = y(T[N][0]);
                var X = y(T[N][1]);
                var V = T[N][2] + (P / 2);
                var Q = e == V ? X : G + ((X - G) / 2);
                var n = e == V ? V : V + (P / 2);
                var O = A - (W / 2);
                var k = e;
                this.toRender({
                    p: ["drawLine", n == k ? "line" : "roundLine", Q, n, O, k, this.getOutlineColor(T[N][4]), T[N][5], "butt", 0, 0, false, false, false, false, T[N][3]],
                    a: this.getLineArea(n == k ? "line" : "roundLine", Q, n, O, k, this.getOutlineColor(T[N][4]), T[N][5], "butt", 0, 0, false, false, false, false, T[N][3]),
                    i: U[N],
                    g: x,
                    b: L,
                    t: "Data",
                    h: r
                })
            }
        }
    };
    this.drawViolin = function(k, E, r, I, n, D, B, J, A, w, e) {
        var f = [];
        var G = [];
        var b = [];
        var C = [];
        var a = [
            [],
            []
        ];
        var F, d, j, g;
        switch (this.violinScale) {
            case "area":
                F = I / k.density.maxY * k.density.maxY / k.scale * 0.9;
                break;
            case "count":
                F = I / k.density.maxY * k.density.sumY / k.area * 0.9;
                break;
            case "width":
                F = I / k.density.maxY * 0.9;
                break
        }
        var s = this.addColorTransparency(this.violinColor || J, this.showBoxplotOriginalData && !this.violinColor ? 0 : this.violinTransparency, true);
        if (this.violinTrim && (k.density.trim[1] - k.density.trim[0] < 1000)) {
            d = [];
            for (var H = k.density.trim[0]; H < k.density.trim[1]; H++) {
                d.push(k.density.xy[H])
            }
        } else {
            d = k.density.xy
        }
        if (B == "vertical") {
            for (var H = 0; H < d.length; H++) {
                j = (d[H][1] * F);
                g = ((d[H][0] - D) * n);
                f.push(E - j);
                G.push(r - g);
                b.push(E + j);
                C.push(r - g);
                a[0].push(E);
                a[1].push(r - g)
            }
        } else {
            for (var H = 0; H < d.length; H++) {
                j = ((d[H][0] - D) * n);
                g = (d[H][1] * F);
                f.push(E + j);
                G.push(r - g);
                b.push(E + j);
                C.push(r + g);
                a[0].push(E + j);
                a[1].push(r)
            }
        }
        if (f.length > 1 && G.length > 1) {
            this.toRender({
                p: ["drawShape", "violin", [f, b],
                    [G, C], false, false, s, this.violinBorderColor, A
                ],
                a: this.getShapeArea("violin", [f, b], [G, C], false, false, s, this.violinBorderColor, A),
                i: w,
                b: a,
                t: "Data",
                h: e
            })
        }
    };
    this.drawDotPlot = function(an, am, ab, T, ag, W, S, aa, U, Y, ap, ac, X, av, Q, V, P, I, H, ar) {
        var O = this;
        var b = function() {
            var h = O.jitterColumns % 2 ? O.jitterColumns + 2 : O.jitterColumns + 3;
            var c = Math.max(ag - O.sizes[0], O.sizes[0]) / (h - 1);
            var a = [0];
            var d = 1;
            for (var e = 0; e < h / 2; e += 2) {
                a.push(d * -c);
                a.push(d * c);
                d++
            }
            return a
        };
        var G = function(l, c) {
            var a = c[0];
            var j = 0;
            var e = "";
            var m = {
                n: {},
                arr: {}
            };
            for (var h = 0; h < l.length; h++) {
                var d = l[h].toString();
                if (!m.n.hasOwnProperty(d)) {
                    m.n[d] = 0;
                    m.arr[d] = []
                }
                m.n[d]++;
                if (m.n[d] > j) {
                    j = m.n[d];
                    e = d
                }
            }
            if (m.n[e] * a > ag) {
                a = ag * (O.binAlignment == "center" ? 1 : 0.5) / m.n[e]
            }
            for (var d in m.n) {
                switch (O.binAlignment) {
                    case "bottom":
                    case "right":
                        m.arr[d].push(0);
                        m.n[d]--;
                        while (m.n[d] > 0) {
                            var k = m.arr[d][0];
                            m.arr[d].unshift(k - a);
                            m.n[d]--
                        }
                        break;
                    case "top":
                    case "left":
                        m.arr[d].push(0);
                        m.n[d]--;
                        while (m.n[d] > 0) {
                            var k = m.arr[d][m.arr[d].length - 1];
                            m.arr[d].push(k + a);
                            m.n[d]--
                        }
                        break;
                    case "center":
                        if (m.n[d] % 2) {
                            m.arr[d].push(0);
                            m.n[d]--
                        } else {
                            m.arr[d].push(-a / 2);
                            m.n[d]--;
                            m.arr[d].push(a / 2);
                            m.n[d]--
                        }
                        while (m.n[d] > 0) {
                            var k = m.arr[d][0];
                            m.arr[d].unshift(k - a);
                            m.n[d]--;
                            k = m.arr[d][m.arr[d].length - 1];
                            m.arr[d].push(k + a);
                            m.n[d]--
                        }
                        break
                }
            }
            return m.arr
        };
        var B = [];
        var E = this.dotplotType == "movement" ? false : b();
        var af = ar ? "Overlays" : "Data";
        if (Y == "vertical") {
            for (var ae = 0; ae < an.length; ae++) {
                if ((this.showBoxplotOriginalData && this.isRawData) || this.graphType.match(/Dot/) || (this.graphType.match(/Bar/) && this.barType == "lollipop" && !this.isGroupedData)) {
                    var aq = this.dotplotType == "movement" ? false : this.binned ? G(an[ae], U[ae]) : false;
                    for (var ad = 0; ad < an[ae].length; ad++) {
                        if (this.isGraphTime && an[ae][ad] == null) {
                            continue
                        }
                        var Z = this.dotplotType == "movement" ? 0 : this.binned ? aq[an[ae][ad].toString()].shift() : this.jitter ? E[ad % E.length] : 0;
                        var g = av ? av[ae][ad] : false;
                        var R = T - ((an[ae][ad] - aa) * S);
                        var K = this.getFillColor(ap[ae][ad], g);
                        var L = this.getOutlineColor(K, g);
                        if (this.graphType.match(/Bar/) && this.barType == "lollipop") {
                            g.push("Lollipop")
                        }
                        if (this.isNumber(R, true)) {
                            var ao;
                            B.push([ab + Z, R, U[ae][ad] / 2, g]);
                            if (this.graphType.match(/Dot/) && this.dotplotType == "movement" && ad > 0) {
                                var M = B.length - 1;
                                var D = B.length - 2;
                                while (!this.isNumber(B[D][1], true) && D >= 0) {
                                    D--
                                }
                                if (this.isNumber(B[D][1], true)) {
                                    var au = B[M];
                                    var al = B[D];
                                    var ak = this.addColorTransparency(K, 0.2);
                                    this.toRender({
                                        p: ["drawShape", "polygon", [au[0] - au[2], al[0] - al[2], al[0] + al[2], au[0] + au[2]],
                                            [au[1], al[1], al[1], au[1]], false, false, ak, ak
                                        ],
                                        t: "Decorations",
                                        h: this.isHidden(au[3][0], au[3][1]) || this.isHidden(al[3][0], al[3][1])
                                    })
                                }
                            }
                            if (this.graphType.match(/Bar/) && this.barType == "lollipop" && !this.isGroupedData && this.barLollipopOpen) {
                                ao = this.toRender({
                                    p: ["drawShape", X[ae][ad], ab + Z, R, U[ae][ad], U[ae][ad], this.background, K, ac[ae][ad], false, 2, V],
                                    a: this.getShapeArea(X[ae][ad], ab + Z, R, U[ae][ad], U[ae][ad], this.background, K, ac[ae][ad], false, 2, V),
                                    i: g,
                                    m: Q,
                                    b: T,
                                    t: af,
                                    h: this.isHidden(g[0], g[1])
                                })
                            } else {
                                ao = this.toRender({
                                    p: ["drawShape", X[ae][ad], ab + Z, R, U[ae][ad], U[ae][ad], K, L, ac[ae][ad], false, false, V],
                                    a: this.getShapeArea(X[ae][ad], ab + Z, R, U[ae][ad], U[ae][ad], K, L, ac[ae][ad], false, false, V),
                                    i: g,
                                    m: Q,
                                    b: T,
                                    t: af,
                                    h: this.isHidden(g[0], this.isGroupedData || (this.graphType == "Dotplot" && g[2] != null) ? g[2] : g[1])
                                })
                            }
                            if (this.showDataValues) {
                                this.toRender({
                                    p: ["drawText", this.formatNumber(an[ae][ad]), ab + Z, R, this.smpLabelFont, this.barLollipopOpen ? K : this.foreground, "center", "middle"],
                                    g: ao,
                                    t: af,
                                    h: this.isHidden(g[0], g[1])
                                })
                            }
                            if (!this.isGroupedData) {
                                if (am[ae] && am[ae][ad] && this.isNumber(am[ae][ad], true)) {
                                    var at = (am[ae][ad] / 2) * S;
                                    this.toRender({
                                        p: ["drawLine", "error", ab + Z, R, ab + Z, R + at, K, -ag, "butt", false, false, true],
                                        a: this.getLineArea("error", ab + Z, R, ab + Z, R + at, K, -ag, "butt", false, false, true),
                                        i: g,
                                        g: ao,
                                        t: af,
                                        h: this.isHidden(g[0], g[1])
                                    });
                                    this.toRender({
                                        p: ["drawLine", "error", ab + Z, R, ab + Z, R - at, K, -ag, "butt", false, false, true],
                                        a: this.getLineArea("error", ab + Z, R, ab + Z, R - at, K, -ag, "butt", false, false, true),
                                        i: g,
                                        g: ao,
                                        t: af,
                                        h: this.isHidden(g[0], g[1])
                                    })
                                }
                            }
                        } else {
                            B.push([ab + Z, Number.NaN, U[ae][ad] / 2, g])
                        }
                    }
                    if (this.showErrorBars && this.isGroupedData && am[ae] && am[ae] && this.isNumber(am[ae][0], true) && this.isNumber(am[ae][1], true)) {
                        var R = T - ((am[ae][0] - aa) * S);
                        var at = (am[ae][1] / 2) * S;
                        var g = av ? [av[ae][0][0], av[ae][0][1], "error"] : false;
                        this.toRender({
                            p: ["drawShape", "diamond", ab, R, this.margin * this.errorBarsThickness, this.margin * this.errorBarsThickness, this.errorBarsColor, this.errorBarsColor, "closed", false, false, V],
                            h: this.isHidden(false, av[ae][0][0]),
                            t: af
                        });
                        this.toRender({
                            p: ["drawLine", "line", ab, R - at, ab, R + at, this.errorBarsColor, this.errorBarsThickness, "butt", false, false, V],
                            h: this.isHidden(false, av[ae][0][0]),
                            t: af
                        })
                    }
                }
                ab += W
            }
        } else {
            for (var ae = 0; ae < an.length; ae++) {
                if ((this.showBoxplotOriginalData && this.isRawData) || this.graphType.match(/Dot/) || (this.graphType.match(/Bar/) && this.barType == "lollipop" && !this.isGroupedData)) {
                    var aq = this.dotplotType == "movement" ? false : this.binned ? G(an[ae], U[ae]) : false;
                    for (var ad = 0; ad < an[ae].length; ad++) {
                        if (this.isGraphTime && an[ae][ad] == null) {
                            continue
                        }
                        var Z = this.dotplotType == "movement" ? 0 : this.binned ? aq[an[ae][ad].toString()].shift() : this.jitter ? E[ad % E.length] : 0;
                        var g = av ? av[ae][ad] : false;
                        var R = P ? ab + P - ((an[ae][ad] - aa) * S) : ab + ((an[ae][ad] - aa) * S);
                        var K = this.getFillColor(ap[ae][ad], g);
                        var L = this.getOutlineColor(K, g);
                        if (this.graphType.match(/Bar/) && this.barType == "lollipop") {
                            g.push("Lollipop")
                        }
                        if (this.isNumber(R, true)) {
                            var ao;
                            B.push([R, T + Z, U[ae][ad] / 2, g]);
                            if (this.graphType.match(/Dot/) && this.dotplotType == "movement" && ad > 0) {
                                var M = B.length - 1;
                                var D = B.length - 2;
                                while (!this.isNumber(B[D][0], true) && D >= 0) {
                                    D--
                                }
                                if (this.isNumber(B[D][0], true)) {
                                    var au = B[M];
                                    var al = B[D];
                                    var ak = this.addColorTransparency(K, 0.2);
                                    this.toRender({
                                        p: ["drawShape", "polygon", [au[0], al[0], al[0], au[0]],
                                            [au[1] - au[2], al[1] - al[2], al[1] + al[2], au[1] + au[2]], false, false, ak, ak
                                        ],
                                        t: "Decorations",
                                        h: this.isHidden(au[3][0], au[3][1]) || this.isHidden(al[3][0], al[3][1])
                                    })
                                }
                            }
                            if (this.graphType.match(/Bar/) && this.barType == "lollipop" && !this.isGroupedData && this.barLollipopOpen) {
                                ao = this.toRender({
                                    p: ["drawShape", X[ae][ad], R, T + Z, U[ae][ad], U[ae][ad], this.background, K, ac[ae][ad], false, 2, V],
                                    a: this.getShapeArea(X[ae][ad], R, T + Z, U[ae][ad], U[ae][ad], this.background, K, ac[ae][ad], false, 2, V),
                                    i: g,
                                    m: Q,
                                    b: ab,
                                    t: af,
                                    h: this.isHidden(g[0], g[1])
                                })
                            } else {
                                ao = this.toRender({
                                    p: ["drawShape", X[ae][ad], R, T + Z, U[ae][ad], U[ae][ad], K, L, ac[ae][ad], false, false, V],
                                    a: this.getShapeArea(X[ae][ad], R, T + Z, U[ae][ad], U[ae][ad], K, L, ac[ae][ad], false, false, V),
                                    i: g,
                                    m: Q,
                                    b: ab,
                                    t: af,
                                    h: this.isHidden(g[0], this.isGroupedData || (this.graphType == "Dotplot" && g[2] != null) ? g[2] : g[1])
                                })
                            }
                            if (this.showDataValues) {
                                this.toRender({
                                    p: ["drawText", this.formatNumber(an[ae][ad]), R, T + Z, this.smpLabelFont, this.barLollipopOpen ? K : this.foreground, "center", "middle"],
                                    g: ao,
                                    t: af,
                                    h: this.isHidden(g[0], g[1])
                                })
                            }
                            if (!this.isGroupedData) {
                                if (am[ae] && am[ae][ad] && this.isNumber(am[ae][ad], true)) {
                                    var at = (am[ae][ad] / 2) * S;
                                    this.toRender({
                                        p: ["drawLine", "error", R, T + Z, R + at, T + Z, K, ag, "butt", false, false, true],
                                        a: this.getLineArea("error", R, T + Z, R + at, T + Z, K, ag, "butt", false, false, true),
                                        i: g,
                                        g: ao,
                                        t: af,
                                        h: this.isHidden(g[0], g[1])
                                    });
                                    this.toRender({
                                        p: ["drawLine", "error", R, T + Z, R - at, T + Z, K, ag, "butt", false, false, true],
                                        a: this.getLineArea("error", R, T + Z, R - at, T + Z, K, ag, "butt", false, false, true),
                                        i: g,
                                        g: ao,
                                        t: af,
                                        h: this.isHidden(g[0], g[1])
                                    })
                                }
                            }
                        } else {
                            B.push([Number.NaN, T + Z, U[ae][ad] / 2, g])
                        }
                    }
                }
                if (this.showErrorBars && this.isGroupedData && am[ae] && am[ae] && this.isNumber(am[ae][0], true) && this.isNumber(am[ae][1], true)) {
                    var R = ab + ((am[ae][0] - aa) * S);
                    var at = (am[ae][1] / 2) * S;
                    var g = av ? [av[ae][0][0], av[ae][0][1], "error"] : false;
                    this.toRender({
                        p: ["drawShape", "diamond", R, T, this.margin * this.errorBarsThickness, this.margin * this.errorBarsThickness, this.errorBarsColor, this.errorBarsColor, "closed", false, false, V],
                        h: this.isHidden(false, false, "Var-" + av[ae][0][0]),
                        t: af
                    });
                    this.toRender({
                        p: ["drawLine", "line", R - at, T, R + at, T, this.errorBarsColor, this.errorBarsThickness, "butt", false, false, V],
                        h: this.isHidden(false, false, "Var-" + av[ae][0][0]),
                        t: af
                    })
                }
                T += W
            }
        }
        if (this.connectBy && this.data.x && this.data.x.hasOwnProperty(this.connectBy) && this.isRawData) {
            var x = this.meta.data.x[this.connectBy];
            var F = 0;
            var ah = this.getKeys(this.connectByData);
            var f = this.getCustomColorScheme(ah.length);
            var J = {};
            if (this.isGraphTime) {
                for (var ae = 0; ae < this.timeValueIndices.length; ae++) {
                    if (this.timeValueIndices[ae] > 0) {
                        J[ae.toString()] = this.timeValueIndices[ae]
                    }
                }
            }
            for (var ae in this.connectByData) {
                var ao;
                var N = null;
                var an = this.connectByData[ae];
                var K = this.connectByNoColor ? this.connectByColor : x && x.type != "Numeric" ? x.connects[x.order[ae] % x.connects.length] : f[F % f.length];
                if (an.length > 1) {
                    for (var ad = 1; ad < an.length; ad++) {
                        var R = this.isGraphTime ? B[J[an[ad - 1]]] : B[an[ad - 1]];
                        var at = this.isGraphTime ? B[J[an[ad]]] : B[an[ad]];
                        if (R && at) {
                            ao = this.toRender({
                                p: ["drawLine", "line", R[0], R[1], at[0], at[1], K, this.connectByWidth, "butt", R[2], at[2], V],
                                a: this.getLineArea("line", R[0], R[1], at[0], at[1], K, this.connectByWidth, "butt", R[2], at[2], V),
                                i: ["Line:" + this.connectBy + " " + ae, R[3][0], R[3][2], at[3][2]],
                                g: N,
                                t: af,
                                h: this.isHidden(false, R[3][2])
                            });
                            if (N == null) {
                                N = ao
                            }
                        }
                    }
                }
                F++
            }
        } else {
            if (this.connectBy && this.data.z && this.data.z.hasOwnProperty(this.connectBy) && this.isRawData) {
                this.connectByDataVar.push(B);
                if (H) {
                    var x = this.connectBy == this.colorBy ? this.meta.data.z[this.colorBy] : false;
                    for (var ae in this.connectByData) {
                        var an = this.connectByData[ae];
                        if (an.length > 1) {
                            for (var ac = 0; ac < this.connectByDataVar[0].length; ac++) {
                                for (var ad = 1; ad < an.length; ad++) {
                                    var R = this.connectByDataVar[an[ad - 1]][ac];
                                    var at = this.connectByDataVar[an[ad]][ac];
                                    var aj = ae;
                                    if (R && at) {
                                        var C = this.data.y.vars[R[3][0]];
                                        var ai = this.data.y.vars[at[3][0]];
                                        var A = this.data.y.smps[R[3][(this.isGroupedData ? 2 : 1)]];
                                        var z = this.data.y.smps[at[3][(this.isGroupedData ? 2 : 1)]];
                                        if (A == z) {
                                            aj = C + " - " + ai + " (" + A + ")"
                                        } else {
                                            aj = C + " (" + A + ") - " + ai + " (" + z + ")"
                                        }
                                    }
                                    this.toRender({
                                        p: ["drawLine", "line", R[0], R[1], at[0], at[1], this.connectByColor, this.connectByWidth, "butt", R[2], at[2], V],
                                        a: this.getLineArea("line", R[0], R[1], at[0], at[1], this.connectByColor, this.connectByWidth, "butt", R[2], at[2], V),
                                        i: ["Line:" + this.connectBy + " " + aj],
                                        t: af,
                                        h: this.isHidden(false, R[3][2])
                                    })
                                }
                            }
                        }
                    }
                }
            }
        }
    };
    this.drawHeatmap = function(H, C, s, j, E, G, K, F, z, J, y) {
        var n = 0;
        var g = C;
        var x = 0.75;
        var B = this.meta.vals;
        if (!B.colors) {
            B.colors = {}
        }
        for (var D = 0; D < H.length; D++) {
            var k = H[D];
            var I = this.isContour && this.contourType == "color" ? "rgba(0,0,0,0)" : k == null || !this.isNumber(k, true) ? this.missingDataColor : B.colors[k.toString()] ? B.colors[k.toString()] : this.getColorForValue(J, k);
            var A = G && y ? this.addColorTransparency(I, y, true) : G ? I : this.heatmapCellBoxColor;
            B.colors[k == null ? "null" : k.toString()] = I;
            if (y) {
                I = this.addColorTransparency(I, y, true)
            }
            if (this.graphType == "Network") {
                if (this.shapeByShape) {
                    this.toRender({
                        p: ["drawShape", this.shapeByShape, C + (j / 2), s + (E / 2), j / 2, E / 2, I, A, z[D]],
                        a: this.getShapeArea(this.shapeByShape, C + (j / 2), s + (E / 2), j / 2, E / 2, I, A, z[D]),
                        i: K[D],
                        m: F,
                        t: "Decorations",
                        h: this.isHidden(K[D])
                    })
                } else {
                    this.toRender({
                        p: ["drawShape", "rectangle", C + (j / 2), s + (E / 2), j, E, I, I, z[D]],
                        a: this.getShapeArea("rectangle", C + (j / 2), s + (E / 2), j, E, I, I, z[D]),
                        i: K[D],
                        m: F,
                        t: "Decorations",
                        h: this.isHidden(K[D])
                    })
                }
            } else {
                if (this.shapeByShape) {
                    this.toRender({
                        p: ["drawShape", this.shapeByShape, C + (j / 2), s + (E / 2), j / 2, E / 2, I, A, z ? z[D] : false],
                        a: this.getShapeArea(this.shapeByShape, C + (j / 2), s + (E / 2), j / 2, E / 2, I, A, z ? z[D] : false),
                        i: K[D],
                        m: F,
                        t: "Data",
                        h: this.isHidden(K[D][0], K[D][1])
                    })
                } else {
                    if (D > 0 && D < H.length - 1) {
                        if (n >= 0.5) {
                            this.toRender({
                                p: ["drawShape", "rect", C + ((j + x) / 2), s + ((E + x) / 2), j + x, E + x, I, I, z ? z[D] : false],
                                a: this.getShapeArea("rect", C + ((j + x) / 2), s + ((E + x) / 2), j + x, E + x, I, I, z ? z[D] : false),
                                i: K[D],
                                m: F,
                                b: [g, s + ((E + x) / 2), 0, E + x],
                                h: this.isHidden(K[D][0], K[D][1]),
                                t: "Data"
                            });
                            n = 0
                        }
                    } else {
                        this.toRender({
                            p: ["drawShape", "rect", C + ((j + x) / 2), s + ((E + x) / 2), j + x, E + x, I, I, z ? z[D] : false],
                            a: this.getShapeArea("rect", C + ((j + x) / 2), s + ((E + x) / 2), j + x, E + x, I, I, z ? z[D] : false),
                            i: K[D],
                            m: F,
                            b: [g, s + ((E + x) / 2), 0, E + x],
                            h: this.isHidden(K[D][0], K[D][1]),
                            t: "Data"
                        })
                    }
                }
            }
            if (this.showDataValues) {
                this.toRender({
                    p: ["drawText", this.formatNumber(k), (C + j) - 2, (s + E) - 2, this.smpLabelFont, this.foreground, "right", "bottom"],
                    t: "Data"
                })
            }
            C += j;
            n += j
        }
    };
    this.drawTreemap = function(B, u, p, C, D) {
        var f = this;
        var r = this.graphOrientation == "vertical" ? this.top + this.y : this.left;
        var k = function(d, c) {
            if (c) {
                f.toRender({
                    p: ["drawShape", "rectangle", (d.coords.left + u) + (d.coords.width / 2), (d.coords.top + p) + (d.coords.height / 2), d.coords.width, d.coords.height, false, f.getOutlineColor(d.color), "open", false, d.outline, C, D],
                    b: r,
                    t: "Data"
                })
            } else {
                f.toRender({
                    p: ["drawShape", "rectangle", (d.coords.left + u) + (d.coords.width / 2), (d.coords.top + p) + (d.coords.height / 2), d.coords.width, d.coords.height, f.getFillColor(d.color, d.index), f.getOutlineColor(d.color, d.index), "closed", false, false, C, D],
                    a: f.getShapeArea("rectangle", (d.coords.left + u) + (d.coords.width / 2), (d.coords.top + p) + (d.coords.height / 2), d.coords.width, d.coords.height, f.getFillColor(d.color, d.index), f.getOutlineColor(d.color, d.index), "closed", false, false, C, D),
                    i: d.index,
                    b: r,
                    t: "Data",
                    h: f.isHidden(d.index[0], d.index[1])
                })
            }
            if (d.label) {
                var b = f.measureText(d.label, f.overlayFont);
                if (b + f.margin < d.coords.width && f.overlayFontSize + f.margin < d.coords.height) {
                    if (c) {
                        f.toRender({
                            p: ["drawText", d.label, d.coords.left + u + (d.coords.width / 2), d.coords.top + p + (d.coords.height / 2), f.overlayFont, f.addColorTransparency(f.foreground, 0.5, true), "center", "middle"],
                            t: "Data"
                        })
                    } else {
                        f.toRender({
                            p: ["drawText", d.label, d.coords.left + u + f.margin, d.coords.top + p + f.margin, f.overlayFont, f.foreground, "left", "top"],
                            t: "Data"
                        })
                    }
                } else {
                    if (b + f.margin < d.coords.height && f.overlayFontSize + f.margin < d.coords.width) {
                        if (c) {
                            f.toRender({
                                p: ["drawText", d.label, d.coords.left + u + (d.coords.width / 2), d.coords.top + p + (d.coords.height / 2), f.overlayFont, f.addColorTransparency(f.foreground, 0.5, true), "center", "middle", -Math.PI / 2],
                                t: "Data"
                            })
                        } else {
                            f.toRender({
                                p: ["drawText", d.label, d.coords.left + u + f.margin, d.coords.top + p + f.margin, f.overlayFont, f.foreground, "right", "top", -Math.PI / 2],
                                t: "Data"
                            })
                        }
                    }
                }
            }
        };
        var s = function(c) {
            for (var b = 0; b < c.length; b++) {
                if (c[b].children) {
                    s(c[b].children);
                    k(c[b], true)
                } else {
                    k(c[b])
                }
            }
        };
        for (var v = 0; v < B.length; v++) {
            var a = B[v];
            var q = this.treemapBorderWidth && !this.isDOE ? 1 : 0;
            var E = this.isDOE ? 0 : this.treemapBorderWidth;
            var o = E * 2;
            var e = this.smpLabelFontSize * q;
            var g = this.treemapBorderColor;
            var m = u + a.coords.left - E;
            var j = p + a.coords.top - (e + E);
            var n = a.coords.width + o;
            var A = a.coords.height + e + o;
            if (a.title) {
                this.toRender({
                    p: ["disableGradientTransparencyShadow"],
                    t: "Data"
                });
                if (a.coords.border > 1) {
                    this.toRender({
                        p: ["drawShape", "rectangle", m + (n / 2), j + ((e + (E / 2)) / 2), n, e + (E / 2), g, g, "close", false, E, C, D],
                        t: "Data"
                    });
                    this.toRender({
                        p: ["drawShape", "rectangle", m + (n / 2), j + (A / 2), n, A, false, g, "open", false, E, C, D],
                        t: "Data"
                    })
                } else {
                    if (a.coords.border > 0) {
                        this.toRender({
                            p: ["drawShape", "rectangle", m + (n / 2), (j + (e + E)) + ((A - (e + E)) / 2), n, A - (e + E), false, g, "open", false, E, C, D],
                            t: "Data"
                        })
                    } else {
                        if (a.coords.border > -1) {
                            this.toRender({
                                p: ["drawShape", "rectangle", m + (n / 2), (j + (e + E)) + ((A - (e + E)) / 2), n, A - (e + E), false, g, "open", false, E, C, D],
                                t: "Data"
                            })
                        }
                    }
                }
                var z = this.measureText(a.title, this.smpLabelFont);
                if (z + this.margin < n && this.smpLabelFontSize <= e && a.coords.height > e + (E / 2)) {
                    this.toRender({
                        p: ["drawText", a.title, m + this.margin, j + (this.smpLabelFontSize / 2), this.smpLabelFont, this.foreground, "left", "middle"],
                        t: "Data"
                    })
                }
                this.toRender({
                    p: ["enableGradientTransparencyShadow"],
                    t: "Data"
                })
            }
            if (a.children) {
                s(a.children)
            } else {
                k(a)
            }
        }
    };
    this.drawSankey = function(b) {
        var f = b.links[0].target.x - b.links[0].source.x;
        for (var a = 0; a < b.links.length; a++) {
            var c = b.links[a];
            this.toRender({
                p: ["drawShape", "bezier", c.plotX, c.plotY, f, c.dy, this.getFillColor(c.color), this.getOutlineColor(c.color), false, c.colors],
                a: this.getShapeArea("bezier", c.plotX, c.plotY, f, c.dy, this.getFillColor(c.color), this.getOutlineColor(c.color), false, c.colors),
                i: c.tooltip,
                b: [this.left, this.top + this.y / 2, f, c.dy],
                t: "Data"
            })
        }
        for (var a = 0; a < b.nodes.length; a++) {
            var e = b.nodes[a];
            this.toRender({
                p: ["drawShape", "rectangle", e.plotX + (e.dx / 2), e.plotY + (e.dy / 2), e.dx, e.dy, e.color, this.foreground],
                a: this.getShapeArea("rectangle", e.plotX + (e.dx / 2), e.plotY + (e.dy / 2), e.dx, e.dy, e.color, this.foreground),
                i: e.tooltip,
                b: [this.left, this.top + this.y / 2, e.dx, e.dy],
                t: "Data"
            });
            this.toRender({
                p: ["drawText", e.name, e.plotX + (e.dx / 2), e.plotY + (e.dy / 2), this.overlayFont, this.overlayFontColor, "center", "middle", -Math.PI / 2],
                a: this.getTextArea(e.name, e.plotX + (e.dx / 2), e.plotY + (e.dy / 2), this.overlayFont, this.overlayFontColor, "center", "middle", -Math.PI / 2),
                i: [e.tooltip[0] + ":T"],
                t: "Data"
            })
        }
    };
    this.drawTree = function(a, f) {
        if (this.data.tree && this.data.tree.plot) {
            var k = this.data.tree.plot;
            var d = this.treeNodeSize / 2;
            var h = this.treeNodeSize / 4;
            var e = a == "vertical" ? true : false;
            var g = this;
            var j = function(t) {
                var l = e ? t.x0 : t.y0;
                var s = e ? t.y0 : t.x0;
                var p = g.isHidden(false, t.id);
                g.toRender({
                    p: ["drawShape", t.data.shape, l, s, t.data.size, t.data.size, g.getFillColor(t.data.color, t.id), g.treeNodeOutlineColor, t.data.pattern, false, g.treeLinkWidth],
                    a: g.getShapeArea(t.data.shape, l, s, t.data.size, t.data.size, g.getFillColor(t.data.color, t.id), g.treeNodeOutlineColor, t.data.pattern, false, g.treeLinkWidth),
                    i: ["Tree-Node:" + t.id],
                    b: [b, i],
                    t: "Data",
                    h: p
                });
                if (t.children) {
                    for (var o = 0; o < t.children.length; o++) {
                        j(t.children[o])
                    }
                    if (g.treeCircular) {
                        var m = (Math.PI / 2) - t.angle;
                        var q = (((g.treeNodeSize / 2) + g.margin) * Math.cos(m)) * (g.treeInverted ? -1 : 1);
                        var r = (((g.treeNodeSize / 2) + g.margin) * Math.sin(m)) * (g.treeInverted ? -1 : 1);
                        if (t.angle <= Math.PI) {
                            g.toRender({
                                p: ["drawText", t.data.name, l - q, s - r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "left" : "right", "middle", m],
                                a: g.getTextArea(t.data.name, l - q, s - r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "left" : "right", "middle", m),
                                i: ["Tree-Text:" + t.id],
                                b: [b, i],
                                t: "Data",
                                h: p
                            })
                        } else {
                            g.toRender({
                                p: ["drawText", t.data.name, l - q, s - r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "right" : "left", "middle", m - Math.PI],
                                a: g.getTextArea(t.data.name, l - q, s - r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "right" : "left", "middle", m - Math.PI),
                                i: ["Tree-Text:" + t.id],
                                b: [b, i],
                                t: "Data",
                                h: p
                            })
                        }
                    } else {
                        if (e) {
                            if (t.parent) {
                                g.toRender({
                                    p: ["drawText", t.data.name, l, s - ((g.treeNodeSize / 2) + g.margin), g.smpLabelFont, g.smpLabelFontColor, "right", "middle", Math.PI / 2],
                                    a: g.getTextArea(t.data.name, l, s - ((g.treeNodeSize / 2) + g.margin), g.smpLabelFont, g.smpLabelFontColor, "right", "middle", Math.PI / 2),
                                    i: ["Tree-Text:" + t.id],
                                    b: [b, i],
                                    t: "Data",
                                    h: p
                                })
                            } else {
                                g.toRender({
                                    p: ["drawText", t.data.name, l, s - ((g.treeNodeSize / 2) + g.margin), g.smpLabelFont, g.smpLabelFontColor, "center", "bottom"],
                                    a: g.getTextArea(t.data.name, l, s - ((g.treeNodeSize / 2) + g.margin), g.smpLabelFont, g.smpLabelFontColor, "center", "bottom"),
                                    i: ["Tree-Text:" + t.id],
                                    b: [b, i],
                                    t: "Data",
                                    h: p
                                })
                            }
                        } else {
                            g.toRender({
                                p: ["drawText", t.data.name, l - ((g.treeNodeSize / 2) + g.margin), s, g.smpLabelFont, g.smpLabelFontColor, "right", "middle"],
                                a: g.getTextArea(t.data.name, l - ((g.treeNodeSize / 2) + g.margin), s, g.smpLabelFont, g.smpLabelFontColor, "right", "middle"),
                                i: ["Tree-Text:" + t.id],
                                b: [b, i],
                                t: "Data",
                                h: p
                            })
                        }
                    }
                } else {
                    if (g.treeCircular) {
                        var m = (Math.PI / 2) - t.angle;
                        var q = (((g.treeNodeSize / 2) + g.margin) * Math.cos(m)) * (g.treeInverted ? -1 : 1);
                        var r = (((g.treeNodeSize / 2) + g.margin) * Math.sin(m)) * (g.treeInverted ? -1 : 1);
                        if (t.angle <= Math.PI) {
                            g.toRender({
                                p: ["drawText", t.data.name, l + q, s + r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "right" : "left", "middle", m],
                                a: g.getTextArea(t.data.name, l + q, s + r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "right" : "left", "middle", m),
                                i: ["Tree-Text:" + t.id],
                                b: [b, i],
                                t: "Data",
                                h: p
                            })
                        } else {
                            g.toRender({
                                p: ["drawText", t.data.name, l + q, s + r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "left" : "right", "middle", m - Math.PI],
                                a: g.getTextArea(t.data.name, l + q, s + r, g.smpLabelFont, g.smpLabelFontColor, g.treeInverted ? "left" : "right", "middle", m - Math.PI),
                                i: ["Tree-Text:" + t.id],
                                b: [b, i],
                                t: "Data",
                                h: p
                            })
                        }
                    } else {
                        if (e) {
                            g.toRender({
                                p: ["drawText", t.data.name, l, s + (g.treeNodeSize / 2) + g.margin, g.smpLabelFont, g.smpLabelFontColor, "left", "middle", Math.PI / 2],
                                a: g.getTextArea(t.data.name, l, s + (g.treeNodeSize / 2) + g.margin, g.smpLabelFont, g.smpLabelFontColor, "left", "middle", Math.PI / 2),
                                i: ["Tree-Text-:" + t.id],
                                b: [b, i],
                                t: "Data",
                                h: p
                            })
                        } else {
                            g.toRender({
                                p: ["drawText", t.data.name, l + (g.treeNodeSize / 2) + g.margin, s, g.smpLabelFont, g.smpLabelFontColor, "left", "middle"],
                                a: g.getTextArea(t.data.name, l + (g.treeNodeSize / 2) + g.margin, s, g.smpLabelFont, g.smpLabelFontColor, "left", "middle"),
                                i: ["Tree-Text:" + t.id],
                                b: [b, i],
                                t: "Data",
                                h: p
                            })
                        }
                    }
                }
                if (t._children) {
                    g.toRender({
                        p: ["drawLine", "line", l - h, s, l + h, s, g.foreground],
                        a: g.getLineArea("line", l - h, s, l + h, s, g.foreground),
                        i: ["Tree-Line1:" + t.id],
                        b: [b, i],
                        t: "Data",
                        h: p
                    });
                    g.toRender({
                        p: ["drawLine", "line", l, s - h, l, s + h, g.foreground],
                        a: g.getLineArea("line", l, s - h, l, s + h, g.foreground),
                        i: ["Tree-Line2:" + t.id],
                        b: [b, i],
                        t: "Data",
                        h: p
                    })
                } else {
                    if (t.children) {
                        g.toRender({
                            p: ["drawLine", "line", l - h, s, l + h, s, g.foreground],
                            a: g.getLineArea("line", l - h, s, l + h, s, g.foreground),
                            i: ["Tree-Line1:" + t.id],
                            b: [b, i],
                            t: "Data",
                            h: p
                        })
                    }
                }
            };
            var c = function(t) {
                if (t.children) {
                    for (var m = 0; m < t.children.length; m++) {
                        c(t.children[m])
                    }
                }
                if (t.parent) {
                    var l = e ? t.x0 : t.y0;
                    var s = e ? t.y0 : t.x0;
                    var p = e ? t.parent.x0 : t.parent.y0;
                    var r = e ? t.parent.y0 : t.parent.x0;
                    var q = t._clicked ? [p, r, p, r] : [b, i, b, i];
                    var o = g.isHidden(false, t.id);
                    g.toRender({
                        p: ["drawLine", "bezier", p, r, l, s, g.treeLinkColor, g.treeLinkWidth, false, false, false, false, false, false, false, false, false, g.treeCircular ? [t.mx, t.my, t.mx2, t.my2] : false],
                        a: g.getLineArea("bezier", p, r, l, s, g.treeLinkColor, g.treeLinkWidth, false, false, false, false, false, false, false, false, false, g.treeCircular ? [t.mx, t.my, t.mx2, t.my2] : false),
                        i: [t.parent.id + ":" + t.id],
                        b: q,
                        t: "Data",
                        h: o
                    });
                    t._clicked = false
                }
            };
            var b = e ? k.x0 : k.y0;
            var i = e ? k.y0 : k.x0;
            c(k);
            if (!f) {
                j(k)
            }
        }
    };
    this.zoomOncoprintVariables = function(c) {
        if (this.isTransition()) {
            return
        }
        var b = [];
        this.setOriginalIndices(false, this.varIndices, this.smpIndices);
        this.varIndicesStart = 0;
        for (var a = 0; a < Math.min(c, this.varIndices.length); a++) {
            b.push(this.varIndices[a])
        }
        this.varIndices = b;
        this.draw({
            func: "zoomOncoprintVariables",
            par: [c]
        })
    }
};
CanvasXpress.prototype.init3dUtils = function() {
    this.setTrigonometry = function() {
        if (!this.meta.math) {
            this.meta.math = {
                sin: [0],
                cos: [1]
            };
            for (var b = 1; b <= 360; b++) {
                var a = Math.PI / (180 / b);
                this.meta.math.sin[b] = Math.sin(a);
                this.meta.math.cos[b] = Math.cos(a)
            }
        }
    };
    this.set3DRotation = function() {
        this.setTrigonometry();
        var a = ["xRotate", "yRotate", "zRotate"];
        for (var b = 0; b < a.length; b++) {
            if (this[a[b]] > 360) {
                this[a[b]] -= 360
            }
            if (this[a[b]] < 0) {
                this[a[b]] = 360
            }
        }
    };
    this.set3DParams = function() {
        var b = this.zoom;
        var a = this.x;
        this.perspective = a * this.perspectiveFactor;
        this.lenX = a / 4 * b * this.x3DRatio;
        this.lenY = a / 4 * b * this.y3DRatio;
        this.lenZ = a / 4 * b * this.z3DRatio;
        this.padX = a / 2;
        this.padY = this.y / 2;
        this.padZ = this.padY
    };
    this.get3DTransfrom = function(g, a, k) {
        var f, e, b;
        var h = [];
        var n = this.meta.math.sin;
        var j = this.meta.math.cos;
        var d = this.perspective;
        var m = this.xRotate;
        var l = this.yRotate;
        var i = this.zRotate;
        e = a;
        b = k;
        a = e * j[parseInt(l)] - b * n[parseInt(l)];
        k = e * n[parseInt(l)] + b * j[parseInt(l)];
        f = g;
        b = k;
        g = b * n[parseInt(m)] + f * j[parseInt(m)];
        k = b * j[parseInt(m)] - f * n[parseInt(m)];
        f = g;
        e = a;
        g = f * j[parseInt(i)] - e * n[parseInt(i)];
        a = f * n[parseInt(i)] + e * j[parseInt(i)];
        if (this.perspective) {
            g = g * (d / (k + d));
            a = a * (d / (k + d));
            k = k * (d / (k + d))
        }
        h.push(g + this.padX);
        h.push(a + this.padY);
        h.push(k + this.padZ);
        return h
    }
};
CanvasXpress.prototype.initApiUtils = function() {
    this.getValidGraphTypes = function() {
        return this.validGraphTypes
    };
    this.setHeatmapScheme = function() {
        this.initializeAttributes()
    };
    this.hasIndicator = function() {
        if (this.graphType.match(/Scatter/) || this.graphType == "Bar") {
            return true
        } else {
            return false
        }
    };
    this.hasLegend = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Correlation" && this.graphType != "Heatmap") {
            return true
        } else {
            return false
        }
    };
    this.hasLegendProperties = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Correlation" && this.graphType != "Heatmap" && this.graphType != "Pie") {
            return true
        } else {
            return false
        }
    };
    this.hasData = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Venn") {
            return true
        } else {
            return false
        }
    };
    this.hasDataSamples = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Venn" && this.graphType != "Pie" && !this.graphType.match(/Scatter/)) {
            if (this.graphType == "Correlation" && this.correlationAxis != "samples") {
                return false
            }
            return true
        } else {
            return false
        }
    };
    this.hasDataGroups = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Venn" && this.graphType != "Pie" && !this.graphType.match(/Scatter/)) {
            if (this.graphType == "Correlation" && this.correlationAxis != "samples") {
                return false
            }
            if (this.data.x) {
                return true
            } else {
                return false
            }
        } else {
            return false
        }
    };
    this.hasDataVariables = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Venn") {
            if (this.graphType == "Correlation" && this.correlationAxis != "variables") {
                return false
            }
            return true
        } else {
            return false
        }
    };
    this.hasDataProperties = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Heatmap" && this.graphType != "Venn" && this.graphType != "Pie" && this.graphType != "Correlation") {
            return true
        } else {
            return false
        }
    };
    this.hasOrientation = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Venn" && this.graphType != "Pie" && this.graphType != "Correlation" && this.graphType != "Circular" && !this.graphType.match(/Scatter/)) {
            return true
        } else {
            return false
        }
    };
    this.hasOverlays = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Venn" && this.graphType != "Pie" && this.graphType != "Correlation" && !this.graphType.match(/Scatter/)) {
            return true
        } else {
            return false
        }
    };
    this.hasDendrograms = function() {
        if (this.graphType != "Heatmap" && (this.smpDendrogramNewick || this.varDendrogramNewick)) {
            return true
        } else {
            return false
        }
    };
    this.hasDecorations = function() {
        return this.decorations && (this.decorations.nlfit || this.decorations.line || this.decorations.reg || this.decorations.nor || this.decorations.area) ? true : false
    };
    this.isSegregable = function() {
        if (this.graphType != "Network" && this.graphType != "Genome" && this.graphType != "Venn" && this.graphType != "Pie" && this.graphType != "Correlation" && !this.graphType.match(/Scatter/)) {
            return true
        } else {
            return false
        }
    };
    this.getLineTypes = function() {
        var e = ["line"];
        var c = ["", "dashed", "dotted", "bezierY", "bezierX", "curved"];
        var a = ["arrow", "arrowHead", "arrowTail", "arrowHeadSquareTail", "arrowTailSquareHead", "square", "squareHead", "squareTail", "squareHeadArrowTail", "squareTailArrowHead"];
        for (var d = 0; d < a.length; d++) {
            e.push(a[d] + "Line")
        }
        for (var d = 1; d < c.length; d++) {
            for (var b = 0; b < a.length; b++) {
                e.push(c[d] + this.capitalize(a[b]) + "Line")
            }
        }
        return e
    };
    this.isValidShape = function(c) {
        var a = ["circle", "sphere", "box", "rect", "rectangle", "rect2", "rect3", "roundrect", "brace", "square", "triangle", "triangle2", "equilateral", "equilateral2", "star", "diamond", "rhombus", "pentagon", "hexagon", "octagon"];
        a = a.concat(["oval", "oval2", "oval3", "arc", "arc2", "arc3", "arch", "path", "polygon", "roundpolygon", "spline", "hull", "violin", "confidence", "bezier", "ellipse", "ellipse2", "ellipse2", "plus", "minus"]);
        a = a.concat(["pie", "pie0", "pie1", "pie2", "pie3", "pie4", "pie5", "pie6", "pie7", "pie8", "pie9", "pacman", "pacman2", "mdavid", "image"]);
        a = a.concat(["pch0", "pch1", "pch2", "pch3", "pch4", "pch5", "pch6", "pch7", "pch8", "pch9", "pch10", "pch11", "pch12", "pch13", "pch14", "pch15", "pch16", "pch17", "pch18", "pch19", "pch20", "pch21", "pch22", "pch23", "pch24", "pch25"]);
        for (var b = 0; b < a.length; b++) {
            if (a[b] == c) {
                return true
            }
        }
        return false
    };
    this.getHeatmapSchemes = function() {
        var c = [];
        var d = ["blue", "red", "green", "yellow", "cyan", "purple", "white", "black"];
        for (var b = 0; b < d.length; b++) {
            c.push(d[b]);
            for (var a = 0; a < d.length; a++) {
                if (d[b] != d[a]) {
                    c.push(d[b] + "-" + d[a])
                }
            }
        }
        return c
    };
    this.isCompatibleGraphType = function(b, a) {
        if (b.match(/^Bar$|^Line$|Boxplot|Dotplot/)) {
            return a.match(/^Bar$|^Line$|Boxplot|Dotplot/) ? true : false
        } else {
            return false
        }
    };
    this.isOneDimensionalGraph = function() {
        return !this.graphType.match(/Scatter|Network|Venn|Genome|Circular|Correlation/)
    };
    this.isOneDimensionalCombinationGraph = function() {
        return this.graphType.match(/BarLine|StackedLine|StackedPercentLine|AreaLine|DotLine/)
    };
    this.isHistogramLayout = function() {
        return this.isHistogram && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 0
    };
    this.modifyHighlights = function(c, b, d) {
        var a = d ? "highlightVar" : "highlightSmp";
        this.modifyObjectArray(c, b, a)
    };
    this.getHighlights = function(a) {
        return this.getObjectArray(a ? this.highlightVar : this.highlightSmp)
    };
    this.modifyOverlaysProperties = function(g) {
        if (this.isTransition()) {
            return
        }
        var e = [];
        if (!this.isArray(g)) {
            for (var d = 0; d < arguments.length; d++) {
                e.push(this.cloneObject(arguments[d]))
            }
            g = this.cloneObject(e)
        } else {
            e = this.cloneObject(g)
        }
        var b;
        var c = this;
        var a = e.shift();
        var f = this.cloneObject(e);
        while (f.length > 1) {
            b = f.shift();
            if (!c[b]) {
                c[b] = {}
            }
            c = c[b]
        }
        b = f.shift();
        c[b] = b == "showLegend" ? !c[b] : isNaN(a) ? a : Number(a);
        this.draw({
            func: "modifyOverlaysProperties",
            par: [g]
        })
    };
    this.modifySmpOverlays = function(b, a) {
        this.modifyObjectArray(b, a, "smpOverlays")
    };
    this.modifyVarOverlays = function(b, a) {
        this.modifyObjectArray(b, a, "varOverlays")
    };
    this.getSmpOverlays = function() {
        return this.getObjectArray(this.smpOverlays)
    };
    this.getVarOverlays = function() {
        return this.getObjectArray(this.varOverlays)
    };
    this.getXData = function() {
        var b = [];
        if (this.data.x) {
            for (var a in this.data.x) {
                b.push(a)
            }
        }
        return b
    };
    this.getZData = function() {
        var b = [];
        if (this.data.z) {
            for (var a in this.data.z) {
                b.push(a)
            }
        }
        return b
    };
    this.getXZData = function() {
        return this.graphType.match(/Scatter/) ? this.getZData() : this.getXData()
    };
    this.getSamplesVariablesAsArray = function() {
        return this.graphType.match(/scatter/i) ? this.getSamplesAsArray() : this.getVariablesAsArray
    };
    this.getSamplesAsArray = function() {
        var d = this.getSamples();
        var b = [];
        for (var c = 0; c < d.length; c++) {
            b.push(d[c].name)
        }
        return b
    };
    this.getVariablesAsArray = function() {
        var d = this.getVariables();
        var b = [];
        for (var c = 0; c < d.length; c++) {
            b.push(d[c].name)
        }
        return b
    };
    this.getNodeData = function(a) {
        return this.getNetworkData("nodes", a)
    };
    this.getEdgeData = function(a) {
        return this.getNetworkData("edges", a)
    };
    this.isBooleanData = function(c) {
        for (var a in c) {
            if (c[a]["t"] == "numeric") {
                var b = this.getKeys(c[a]["o"]);
                if (b.length == 2 && (c[a]["o"].hasOwnProperty("true") && c[a]["o"].hasOwnProperty("false"))) {
                    c[a]["t"] = "string"
                } else {
                    if (b.length == 1 && (c[a]["o"].hasOwnProperty("true") || c[a]["o"].hasOwnProperty("false"))) {
                        c[a]["t"] = "string"
                    } else {
                        if (b.length == 1 && c[a]["o"].hasOwnProperty("")) {
                            c[a]["t"] = "string"
                        }
                    }
                }
            }
        }
    };
    this.getSampleVariableData = function(l, r, q, k, s) {
        var h = {
            smps: {
                idx: "smpIndices",
                spc: "x"
            },
            vars: {
                idx: "varIndices",
                spc: "z"
            }
        };
        var c = {};
        c[l] = {
            o: {},
            t: "string"
        };
        if (r) {
            c[l]["o"] = this.getObjectArray(this.data.y[l])
        } else {
            for (var f = 0; f < this[h[l]["idx"]].length; f++) {
                c[l]["o"][this.data.y[l][this[h[l]["idx"]][f]]] = true
            }
        }
        if (k || s) {
            var n = k ? this.getVariableIndices(q) : this.getSampleIndices(q, true);
            if (this.isArray(q)) {
                for (var b = 0; b < q.length; b++) {
                    var n = k ? this.getVariableIndices(q[b]) : this.getSampleIndices(q[b], true);
                    if (n > -1) {
                        c[q[b]] = {
                            o: {},
                            t: "numeric"
                        };
                        if (r) {
                            var e = this.meta.data.y.range[q[b]];
                            c[q[b]]["o"] = {
                                min: e.min,
                                max: e.max
                            }
                        } else {
                            var g = [];
                            if (k) {
                                for (var f = 0; f < this.smpIndices.length; f++) {
                                    g.push(this.data.y.data[n][this.smpIndices[f]])
                                }
                            } else {
                                for (var f = 0; f < this.varIndices.length; f++) {
                                    g.push(this.data.y.data[this.varIndices[f]][n])
                                }
                            }
                            var a = this.range(g);
                            c[q[b]]["o"] = {
                                min: a[0],
                                max: a[1]
                            }
                        }
                    }
                }
            } else {
                var n = k ? this.getVariableIndices(q) : this.getSampleIndices(q, true);
                if (n > -1) {
                    c = {};
                    c[q] = {
                        o: {},
                        t: "numeric"
                    };
                    if (r) {
                        var e = this.meta.data.y.range[q];
                        c[q]["o"] = {
                            min: e.min,
                            max: e.max
                        }
                    } else {
                        var g = [];
                        if (k) {
                            for (var f = 0; f < this.smpIndices.length; f++) {
                                g.push(this.data.y.data[n][this.smpIndices[f]])
                            }
                        } else {
                            for (var f = 0; f < this.varIndices.length; f++) {
                                g.push(this.data.y.data[this.varIndices[f]][n])
                            }
                        }
                        var a = this.range(g);
                        c[q]["o"] = {
                            min: a[0],
                            max: a[1]
                        }
                    }
                }
            }
        }
        if (this.data[h[l]["spc"]]) {
            for (var j in this.data[h[l]["spc"]]) {
                if (q && j != q) {
                    continue
                }
                var e = this.meta.data[h[l]["spc"]][j];
                c[j] = {
                    o: {},
                    t: e.type.toLowerCase()
                };
                if (r) {
                    if (e.type == "Numeric") {
                        c[j]["t"] = "numeric";
                        c[j]["o"] = {
                            min: e.rmin,
                            max: e.rmax
                        }
                    } else {
                        c[j]["t"] = "string";
                        c[j]["o"] = this.cloneObject(e.levels)
                    }
                } else {
                    for (var f = 0; f < this[h[l]["idx"]].length; f++) {
                        var d = this.getMetadataValue(this[h[l]["idx"]][f], h[l]["spc"], j, true);
                        if (!c[j]["o"].hasOwnProperty(d)) {
                            c[j]["o"][d] = true
                        }
                    }
                    if (c[j]["t"] == "numeric") {
                        var g = [];
                        for (var d in c[j]["o"]) {
                            for (var f = 0; f < c[j]["o"][d]; f++) {
                                g.push(d)
                            }
                        }
                        var a = this.range(g);
                        c[j]["o"] = {
                            min: a[0],
                            max: a[1]
                        }
                    }
                }
            }
        }
        return c
    };
    this.getNetworkData = function(d, a) {
        if (this.graphType == "Network" && !this[d + "Data"]) {
            this[d + "Data"] = {};
            var f = this.meta.data[d];
            for (var b in f) {
                if (f[b].type == "String") {
                    this[d + "Data"][b] = {
                        o: f[b].order,
                        t: f[b].type.toLowerCase()
                    }
                } else {
                    this[d + "Data"][b] = {
                        o: {
                            min: f[b].rmin,
                            max: f[b].rmax
                        },
                        t: f[b].type.toLowerCase()
                    }
                }
            }
            if (this[d + "Properties"].length > 0) {
                for (var c = 0; c < this.data[d].length; c++) {
                    var e = this.data[d][c];
                    this.getAdditionalData(e, this[d + "Data"], this[d + "Properties"])
                }
            }
        }
        if (this.graphType == "Network") {
            return a ? this[d + "Data"] : this.getKeys(this[d + "Data"])
        } else {
            return false
        }
    };
    this.getFilteredNetworkData = function(g, j) {
        var b = {};
        b[g] = {};
        if (this.graphType == "Network") {
            for (var e = 0; e < this.data[g].length; e++) {
                var d = this.data[g][e];
                if (j || (!j && !d.hide)) {
                    for (var h in d) {
                        if (typeof(d[h]) != "object") {
                            if (b[g].hasOwnProperty(h)) {
                                b[g][h]["o"][d[h]] = true;
                                if (isNaN(d[h])) {
                                    b[g][h]["t"] = "string"
                                }
                            } else {
                                b[g][h] = {
                                    o: {},
                                    t: isNaN(d[h]) ? "string" : "numeric"
                                };
                                b[g][h]["o"][d[h]] = true
                            }
                        }
                    }
                }
                if (this[g + "Properties"].length > 0) {
                    this.getAdditionalData(d, b, this[g + "Properties"])
                }
            }
            this.isBooleanData(b[g]);
            for (var h in b[g]) {
                if (b[g][h]["t"] == "numeric") {
                    var f = [];
                    for (var c in b[g][h]["o"]) {
                        f.push(c)
                    }
                    var a = this.range(f);
                    b[g][h]["o"] = {
                        min: a[0],
                        max: a[1]
                    }
                }
            }
        }
        return b[g]
    };
    this.getFeatureData = function(a) {
        if (!this.featuresData) {
            var h = {};
            var d = this.skipConfigurableProperties ? this.getObjectArray(this.featureConfigurableProperties) : {};
            for (var g = 0; g < this.data.tracks.length; g++) {
                var c = this.data.tracks[g];
                var b = c.data;
                for (var e = 0; e < b.length; e++) {
                    var l = b[e];
                    for (var k in l) {
                        if (!d[k]) {
                            if (typeof(l[k]) != "object") {
                                if (h.hasOwnProperty(k)) {
                                    if (h[k]["o"].hasOwnProperty(l[k])) {
                                        h[k]["o"][l[k]] = true
                                    }
                                    if (isNaN(l[k])) {
                                        h[k]["t"] = "string"
                                    }
                                } else {
                                    h[k] = {
                                        o: {},
                                        t: isNaN(l[k]) ? "string" : "numeric"
                                    };
                                    h[k]["o"][l[k]] = true
                                }
                            }
                        }
                    }
                }
                if (this.featuresProperties.length > 0) {
                    this.getAdditionalData(b, h, this.featuresProperties)
                }
            }
            this.featuresData = h
        }
        return a ? this.featuresData : this.getKeys(this.featuresData)
    };
    this.getAdditionalData = function(d, e, h) {
        for (var f = 0; f < h.length; f++) {
            var b = d;
            var k = false;
            if (h[f].length > 0) {
                for (var c = 0; c < h[f].length; c++) {
                    var a = h[f][c];
                    if (b[a]) {
                        b = b[a]
                    } else {
                        k = true;
                        break
                    }
                }
                if (!k) {
                    for (var g in b) {
                        if (typeof(b[g]) != "object") {
                            if (e.hasOwnProperty(g)) {
                                if (isNaN(b[g])) {
                                    e[g]["t"] = "string"
                                }
                            } else {
                                e[g] = {
                                    o: {},
                                    t: isNaN(b[g]) ? "string" : "numeric",
                                    r: f
                                };
                                e[g]["o"][b[g]] = true
                            }
                        }
                    }
                }
            }
        }
    };
    this.getOperators = function() {
        return ["", "like", "not like", ">", ">=", "<", "<=", "==", "null", "not null"]
    };
    this.zoonIn = function(a) {
        this.handleWheelEvent(a, 1)
    };
    this.zoonOut = function(a) {
        this.handleWheelEvent(a, -1)
    };
    this.clusterSamples = function(b, a) {
        if (this.isTransition()) {
            return
        }
        this.clusterAxis = "samples";
        if (b || !this.smpDendrogramNewick) {
            this.smpDendrogramNewick = this.cluster()
        }
        if (!a) {
            this.draw({
                func: "clusterSamples",
                par: [b, a]
            })
        }
    };
    this.clusterVariables = function(b, a) {
        if (this.isTransition()) {
            return
        }
        this.clusterAxis = "variables";
        if (b || !this.varDendrogramNewick) {
            this.varDendrogramNewick = this.cluster()
        }
        if (!a) {
            this.draw({
                func: "clusterVariables",
                par: [b, a]
            })
        }
    };
    this.kmeansSamples = function(e, d) {
        if (this.isTransition()) {
            return
        }
        this.clusterAxis = "samples";
        if (!this.data.x) {
            this.data.x = {}
        }
        if (e || !this.data.x["k-Means-S"]) {
            var a = this.kmeans();
            this.data.x["k-Means-S"] = [];
            for (var b = 0; b < this.smpIndices.length; b++) {
                var c = this.smpIndices[b];
                this.data.x["k-Means-S"][c] = a[b]
            }
            if (!this.smpOverlays.includes("k-Means-S")) {
                this.smpOverlays.push("k-Means-S")
            }
            this.updateMetaData("x", "k-Means-S", false, true);
            this.modifySort("cat", "smp", "k-Means-S", true)
        }
        if (!d) {
            this.draw({
                func: "kmeansSamples",
                par: [e, d]
            })
        }
    };
    this.kmeansVariables = function(e, d) {
        if (this.isTransition()) {
            return
        }
        this.clusterAxis = "variables";
        if (!this.data.z) {
            this.data.z = {}
        }
        if (e || !this.data.z["k-Means-V"]) {
            var a = this.kmeans();
            this.data.z["k-Means-V"] = [];
            for (var b = 0; b < this.varIndices.length; b++) {
                var c = this.varIndices[b];
                this.data.z["k-Means-V"][c] = a[b]
            }
            if (!this.varOverlays.includes("k-Means-V")) {
                this.varOverlays.push("k-Means-V")
            }
            this.updateMetaData("z", "k-Means-V", false, true);
            this.modifySort("cat", "var", "k-Means-V", true)
        }
        if (!d) {
            this.draw({
                func: "kmeansVariables",
                par: [e, d]
            })
        }
    };
    this.setFunctions = function() {
        var a = this.functions;
        a.push("clusterSamples");
        a.push("clusterVariables");
        a.push("transpose");
        a.push("transform");
        a.push("hideUnhideSmps");
        a.push("hideUnhideVars");
        a.push("desegregateSamples");
        a.push("segregateSamples");
        a.push("groupSamples");
        a.push("ungroupSamples");
        a.push("desegregateVariables");
        a.push("segregateVariables");
        a.push("kmeansSamples");
        a.push("kmeansVariables");
        a.push("createContour");
        a.push("removeContour");
        a.push("showCodeDiv");
        a.push("hideCodeDiv");
        a.push("showInfoDiv");
        a.push("hideInfoDiv");
        a.push("updateCodeDiv");
        a.push("createHistogram");
        a.push("removeHistogram");
        a.push("addRegressionLine");
        a.push("addNormalDistributionLine");
        a.push("recalculateLayout");
        a.push("createRandomData");
        a.push("drawArea");
        a.push("draw");
        a.push("reset");
        a.push("print")
    };
    this.initializeApi = function() {
        this.setFunctions()
    }
};
CanvasXpress.prototype.initDimensionUtils = function() {
    this.resizeCanvas = function(a, o, e) {
        var c = this.margin;
        var j = this.meta.canvas.canvasPixelRatio;
        if (a || o || e) {
            if (o || e) {
                if (o) {
                    this.width = o;
                    this.originalWidth = o
                }
                if (e) {
                    this.height = e;
                    this.originalHeight = e
                }
            } else {
                if (a) {
                    this.width = this.originalWidth;
                    this.height = this.originalHeight
                }
            }
            this.top = c + this.getTitleSubtitleHeight();
            this.left = c;
            this.right = c;
            this.bottom = c;
            this.resetRender()
        }
        if (!this.isSVG) {
            this.meta.canvas.ctx.canvas.width = this.width * j;
            this.meta.canvas.ctx.canvas.height = this.height * j;
            this.meta.canvas.ctx.canvas.style.width = this.width + "px";
            this.meta.canvas.ctx.canvas.style.height = this.height + "px";
            this.meta.canvas.ctx2.canvas.width = this.width * j;
            this.meta.canvas.ctx2.canvas.height = this.height * j;
            this.meta.canvas.ctx2.canvas.style.width = this.width + "px";
            this.meta.canvas.ctx2.canvas.style.height = this.height + "px";
            this.meta.canvas.ctx.scale(j, j);
            this.meta.canvas.ctx2.scale(j, j)
        }
        this.toRender({
            p: ["disableGradientTransparencyShadow"],
            t: "Size"
        });
        if (this.backgroundType == "image") {
            if (this.graphType == "Network") {
                var n = this.scaleFactorX || 1;
                var l = this.scaleFactorY || 1;
                var b = this.offsetX * n;
                var q = this.offsetY * l;
                var k = this.maxX ? this.maxX * n : this.maxX;
                var d = this.maxY ? this.maxY * l : this.maxY;
                var p = this.colorNodeBy || (this.decorations.length && this.showDecorations) ? "b&w" : false;
                CanvasXpress.system.isRStudio = this.isInIframe() && this.isR ? true : false;
                if (CanvasXpress.system.isRStudio) {
                    this.toRender({
                        p: ["drawShape", "image", (k / 2) + b, (d / 2) + q, k, d, false, false, false, false, false, false, false, false, false, this.backgroundImage],
                        t: "Size"
                    })
                } else {
                    this.drawImage(CanvasXpress.cacheImages[this.getFileName(this.backgroundImage)], 0, 0, this.maxX, this.maxY, b, q, k, d, p)
                }
            } else {
                this.toRender({
                    p: ["drawShape", "image", this.width / 2, this.height / 2, this.width, this.height, false, false, false, false, false, false, false, false, false, this.backgroundImage],
                    t: "Size"
                })
            }
        } else {
            if (this.backgroundType == "windowImage") {
                if (this.graphType == "Network") {
                    this.toRender({
                        p: ["drawShape", "image", this.left + (this.x / 2), this.top + (this.y / 2), this.x, this.y, false, false, false, false, false, false, false, false, false, this.backgroundImage],
                        t: "Size"
                    })
                }
            } else {
                if (this.backgroundType == "solid" || this.backgroundType == "window" || this.backgroundType == "windowSolidGradient") {
                    this.toRender({
                        p: ["drawShape", "rectangle", 0 + (this.width / 2), 0 + (this.height / 2), this.width, this.height, this.background, this.background],
                        t: "Size"
                    })
                } else {
                    var i = this.getLinearGradient(0, 0, this.gradientOrientation == "vertical" ? 0 : this.height, this.gradientOrientation == "vertical" ? this.height : 0);
                    this.toRender({
                        p: ["drawShape", "rectangle", 0 + (this.width / 2), 0 + (this.height / 2), this.width, this.height, i, i],
                        t: "Size"
                    })
                }
            }
        }
        this.toRender({
            p: ["enableGradientTransparencyShadow"],
            t: "Size"
        })
    };
    this.setWidth = function(a, b) {
        this.setDimensions(a, false, b)
    };
    this.setHeight = function(b, a) {
        this.setDimensions(false, b, a)
    };
    this.getWidth = function() {
        return this.marginLeft + this.left + this.x + this.right + this.marginRight
    };
    this.getHeight = function() {
        return this.marginTop + this.top + this.y + this.bottom + this.marginBottom
    };
    this.setDimensions = function(d, g, f, e, b, a) {
        if (this.isTransition()) {
            return
        }
        if (!this.resizable) {
            return
        }
        if (d && g) {
            if (Math.abs(this.width - d) < 5 && Math.abs(this.height - g) < 5) {
                return
            }
        }
        if (!d || !this.resizableX) {
            d = this.width
        }
        if (!g || !this.resizableY) {
            g = this.height
        }
        var j = this.meta.canvas.ctx.canvas;
        d = j.originalWidth = parseInt(d);
        g = j.originalHeight = parseInt(g);
        this.clickLayoutNoAnimation(f);
        if (!this.reproducing) {
            this.removeMotionDiv(true)
        }
        if (this.graphType == "Network") {
            this.scaleFactorX = null;
            this.scaleFactorY = null
        }
        this.draw({
            width: d,
            height: g,
            func: "setDimensions",
            par: [d, g, f, e, b, a]
        });
        this.updateRemoteNavigationWindow();
        if (e) {
            var i = this;
            setTimeout(function() {
                i.resizeViewport()
            }, e)
        } else {
            this.resizeViewport()
        }
        if (b) {
            b()
        }
    };
    this.initializeDimensions = function() {
        var a = this.margin;
        var b = this.meta.canvas.ctx.canvas;
        if (b.width) {
            this.originalWidth = b.width;
            this.width = b.width
        } else {
            if (this.width) {
                this.originalWidth = this.width;
                b.width = this.width
            } else {
                this.width = 600;
                this.originalWidth = this.width;
                b.width = this.width
            }
        }
        if (b.height) {
            this.originalHeight = b.height;
            this.height = b.height
        } else {
            if (this.height) {
                this.originalHeight = this.height;
                b.height = this.height
            } else {
                this.height = 600;
                this.originalHeight = this.height;
                b.height = this.height
            }
        }
        this.top = a + this.getTitleSubtitleHeight();
        this.left = a;
        this.right = a;
        this.bottom = a;
        this.x = this.width - (this.leftMargin + this.left + this.rightMargin + this.right);
        this.y = this.height - (this.topMargin + this.top + this.bottomMargin + this.bottom)
    }
};
CanvasXpress.prototype.initUtils = function() {
    this.initGeneralUtils();
    this.initPlotUtils();
    this.initConfigUtils();
    this.init3dUtils();
    this.initApiUtils();
    this.initDimensionUtils()
};
CanvasXpress.prototype.initLegendUtils = function() {
    this.validateLegendPositions = function() {
        if (!this.legendInside) {
            if (this.decorationsPosition != "right" && this.decorationsPosition != "bottom" && this.graphType != "Network") {
                this.decorationsPosition = "bottom"
            }
            if (this.legendPosition != "top" && this.legendPosition != "bottom" && this.legendPosition != "right" && this.legendPosition != "left") {
                if (this.graphType == "Circular") {
                    if (this.legendPosition != "top") {
                        this.legendPosition = "right"
                    }
                } else {
                    if (this.graphType != "Pie") {
                        this.legendPosition = "right"
                    }
                }
            }
        }
        if (this.graphType == "Pie" && this.layoutValid) {
            this.legendPosition = "right"
        }
        if (!this.overlaysLegendPosition) {
            this.overlaysLegendPosition = "topRight"
        }
        if (this.layoutValid && !this.getLayoutConfig("legendPosition")) {
            var a = this.meta.config.orig;
            a.insideLegend = this.insideLegend;
            this.insideLegend = false;
            if (this.legendPosition != "top" && this.legendPosition != "bottom" && this.legendPosition != "right" && this.legendPosition != "left") {
                a.legendPosition = this.legendPosition;
                this.legendPosition = "right"
            }
        }
    };
    this.setLegendFont = function() {
        if (this.autoScaleFont) {
            var e = (1 - this.percentAspectRatioPlotArea);
            var b = this.layoutComb && this.isDOE ? this.layoutWidth : this.width;
            var c = this.layoutComb && this.isDOE ? this.layoutHeight : this.height;
            var a = this.min(b * e, c * e);
            this.setPropertyFontSize(a / (this.graphType == "Circular" ? 1.66 : 1), "legendFont")
        } else {
            this.legendFont = this.legendFontStyle + " " + parseInt(this.legendFontSize) + "px " + this.fontName
        }
    };
    this.drawLegendBackgroundBox = function(e, s, p, g, m, o, j, f) {
        var n = j ? this.decorationsBackgroundColor : this.legendBackgroundColor;
        var c = f ? this.legendBackgroundColor : j ? this.decorationsBoxColor : this.legendBoxColor;
        var q = j ? this.decorationsBox : this.legendBox;
        var k = this.graphType;
        var u = [0, 0, this.width, this.height];
        var r = this.useRoundRectangles ? "roundrect" : "rectangle";
        if (m) {
            if (q && n && !f && k != "Network") {
                this.toRender({
                    p: ["disableGradientTransparencyShadow"],
                    t: "Legends"
                });
                this.toRender({
                    p: ["drawShape", r, e + (p / 2), s + (g / 2), p, g, n, n, "solid", false, false, true, u],
                    a: this.getShapeArea(r, e + (p / 2), s + (g / 2), p, g, n, n, "solid", false, false, true, u),
                    i: [-1],
                    m: o,
                    t: "Legends"
                });
                this.toRender({
                    p: ["enableGradientTransparencyShadow"],
                    t: "Legends"
                })
            } else {
                if (n) {
                    this.toRender({
                        p: ["drawShape", r, e + (p / 2), s + (g / 2), p, g, n, n, "solid", false, false, true, u],
                        a: this.getShapeArea(r, e + (p / 2), s + (g / 2), p, g, n, n, "solid", false, false, true, u),
                        i: [-1],
                        m: o,
                        t: "Legends"
                    })
                } else {
                    this.toRender({
                        p: ["drawShape", r, e + (p / 2), s + (g / 2), p, g, false, "rgba(0,0,0,0)", "open", false, false, true, u],
                        a: this.getShapeArea(r, e + (p / 2), s + (g / 2), p, g, false, "rgba(0,0,0,0)", "open", false, false, true, u),
                        i: [-1],
                        m: o,
                        t: "Legends"
                    })
                }
            }
        } else {
            if (q) {
                this.toRender({
                    p: ["disableGradientTransparencyShadow"],
                    t: "Legends"
                });
                this.toRender({
                    p: ["drawShape", r, e + (p / 2), s + (g / 2), p, g, false, c, "open", false, false, true, u],
                    t: "Legends"
                });
                this.toRender({
                    p: ["enableGradientTransparencyShadow"],
                    t: "Legends"
                })
            }
        }
    };
    this.getDiameterLegend = function() {
        var a = Math.min(this.width, this.height);
        return Number(Math.max(0.5, a * 12 / 833).toFixed(1)) * this.legendScaleFontFactor
    };
    this.setCustomLegendDimensions = function(j) {
        var e = j.text.length;
        var u = this.getDiameterLegend();
        var z = j.size;
        if (z) {
            for (var k = 0; k < z.length; k++) {
                if (z[k]) {
                    u = Math.max(u, z[k])
                }
            }
        }
        var y = this.measureText(j.title && this.showLegendTitle ? j.title : "", this.legendFont);
        var g = this.measureText(this.getMaxText(j.text), this.legendFont);
        var p = this.getFontPt(this.legendFont);
        var v = this.legendColumns > e ? e : this.legendColumns;
        var a = Math.ceil(e / v);
        var b = Math.max(y, (g + u + (this.margin * 2)) * v);
        var x = b + (this.margin * (v + 2));
        var o = j.title && this.showLegendTitle ? (a * (Math.max(u, p) + this.margin)) + p + (this.margin * 2) : (a * (Math.max(u, p) + this.margin)) + (this.margin * 1);
        this["legend" + j.id + "Width"] = x;
        this["legend" + j.id + "Height"] = o + this.margin
    };
    this.setPropertyLegendDimensions = function(c, n, b) {
        var a = this.decapitalize(c) + "By";
        if ((this[a] && (this[a + "ShowLegend"] || this.graphType == "Network")) || c == "Sample") {
            var r, g, o;
            if (n) {
                r = this[a];
                if (b.type == "Numeric" && ((c.match(/shape/i) && !this.shapeByContinuous) || (c.match(/size/i) && !this.sizeByContinuous))) {
                    g = " " + n + " - " + n + " ";
                    if (b) {
                        b.maxLevStrMod = g;
                        b.isRange = true
                    }
                } else {
                    g = n
                }
                o = b && b.sizes ? b.sizes : this.sizes
            } else {
                if (this.data.x && this.data.x.hasOwnProperty(this[a])) {
                    r = this[a];
                    g = this.meta.data.x[this[a]].maxLevStrMod || this.meta.data.x[this[a]].maxLevStr;
                    o = this.meta.data.x[this[a]].sizes || this.sizes
                } else {
                    if (this.data.z && this.data.z.hasOwnProperty(this[a])) {
                        r = this[a];
                        g = this.meta.data.z[this[a]].maxLevStrMod || this.meta.data.z[this[a]].maxLevStr;
                        o = this.meta.data.z[this[a]].sizes || this.sizes
                    } else {
                        if (a.match("Node")) {
                            r = this[a];
                            g = this.meta.data.nodes[this[a]].maxLevStr;
                            o = this.meta.data.nodes[this[a]].sizes || this.sizes
                        } else {
                            if (a.match("Edge")) {
                                r = this[a];
                                g = this.meta.data.edges[this[a]].maxLevStr;
                                o = this.meta.data.edges[this[a]].sizes || this.sizes
                            } else {
                                r = 0;
                                g = 0;
                                o = this.sizes
                            }
                        }
                    }
                }
            }
            var k = this.getDiameterLegend();
            if (c == "Size" || c == "SizeNode" || c == "SizeEdge") {
                for (var h = 0; h < this["legend" + c + "sN"]; h++) {
                    if (o[h]) {
                        k = Math.max(k, o[h])
                    }
                }
            } else {
                if (c == "Sample") {
                    r = 0;
                    g = this.legendSampleMaxStr
                }
            }
            if (g.length > this.maxTextSize) {
                g = g.substring(0, this.maxTextSize - 3) + "..."
            }
            var j = this.getFontPt(this.legendFont);
            var t = this.legendColumns > this["legend" + (c == "Outline" ? "Color" : c) + "sN"] ? this["legend" + (c == "Outline" ? "Color" : c) + "sN"] : this.legendColumns;
            var e = Math.ceil(this["legend" + (c == "Outline" ? "Color" : c) + "sN"] / t);
            var q = this.showLegendTitle ? this.measureText(r, this.legendFont) : 0;
            var s = (this.measureText(g, this.legendFont) + k + (this.margin * 2)) * t;
            this["legend" + (c == "Outline" ? "Color" : c) + "Width"] = Math.max(q, s) + (this.margin * (t + 2));
            this["legend" + (c == "Outline" ? "Color" : c) + "Height"] = (e * (Math.max(k, j) + this.margin)) + (c == "Sample" ? 0 : (this.showLegendTitle ? j + (this.margin * 5) : (this.margin * 3)));
            if (this["legend" + (c == "Outline" ? "Color" : c) + "Height"] > this.height) {
                this.legendColumns++;
                this.maxTextSize = Math.max(10, this.maxTextSize - 5);
                this.setPropertyLegendDimensions(c, n, b)
            }
        }
    };
    this.setPropertyLegendIndicatorDimensions = function(e, b) {
        var j = this.decapitalize(e) + "By";
        var d = 0;
        var g = 0;
        var i = this.getFontPt(this.legendFont);
        if (this[j] || e == "Decoration") {
            switch (e) {
                case "Color":
                case "ColorNode":
                case "ColorEdge":
                case "Outline":
                case "Decoration":
                    var a = this.showLegendTitle ? this.measureText(this.colorBy || this.outlineBy || this.colorNodeBy || this.colorEdgeBy || "", this.legendFont) : 0;
                    var c = b.maxLevLen;
                    if (this.legendPosition.match(/top|bottom/)) {
                        g = this.heatmapIndicatorHeight + (this.margin * 4) + (i * 2);
                        if (this.showLegendTitle) {
                            g += i + this.margin
                        }
                        d = this.heatmapIndicatorWidth + Math.max(a, c)
                    } else {
                        g = this.heatmapIndicatorWidth + (this.margin * 3) + (this.showLegendTitle ? (i * 2) : 0);
                        d = this.heatmapIndicatorHeight + (this.margin * 4) + Math.max(a, c)
                    }
                    break;
                case "Shape":
                case "ShapeNode":
                case "ShapeEdge":
                case "Size":
                case "SizeNode":
                case "SizeEdge":
                    this.setPropertyLegendDimensions(e, b.maxLevStr, b);
                    return;
                case "Pattern":
                case "PatternNode":
                case "PatternEdge":
                    d = 0;
                    g = 0;
                    break
            }
        }
        this["legend" + (e == "Outline" ? "Color" : e) + "Width"] = d;
        this["legend" + (e == "Outline" ? "Color" : e) + "Height"] = g
    };
    this.setDecorationsLegendDimensions = function() {
        this.legendDecorationWidth = 0;
        this.legendDecorationHeight = 0;
        this.legendDecorationMaxLabel = 0;
        if (this.showDecorations && this.showDecorationsLegend && this.decorations) {
            if (!this.legendInside) {
                if (this.decorationsPosition != "right" && this.decorationsPosition != "bottom" && this.graphType != "Network") {
                    this.decorationsPosition = "bottom"
                }
            }
            var o = this.getFontPt(this.decorationFont);
            var h = this.decorations;
            var n = 0;
            var m = ["nlfit", "reg", "nor", "area", "qq", "cdf", "kaplanMeier"];
            var g = [96, 45, 30, 0, 0, 0, 0];
            var k = [5, 2, 1, 0, 0, 0, 0];
            for (var f = 0; f < m.length; f++) {
                if (h[m[f]]) {
                    var b = k[f] ? this.measureText(this.sprintf("%" + g[f] + "s", "X"), this.decorationFont) + (this.margin * k[f]) + this.margin : 0;
                    var l = 0;
                    for (var c = 0; c < h[m[f]].length; c++) {
                        var e = this.measureText(h[m[f]][c].label, this.decorationFont);
                        l = Math.max(e, l);
                        this.legendDecorationMaxLabel = Math.max(l, this.legendDecorationMaxLabel)
                    }
                    n = Math.max(n, this.margin + l + this.margin + b);
                    this.legendDecorationHeight = (h[m[f]].length * o * 2) + o + this.margin
                }
            }
            if (this.graphType == "Map" && h.pie && h.pie[0] && h.pie[0].smps && h.pie[0].smps.length) {
                var l = 0;
                var a = this.getFontPt(this.decorationFont);
                for (var f = 0; f < h.pie[0].smps.length; f++) {
                    var e = this.measureText(h.pie[0].smps[f], this.decorationFont);
                    l = Math.max(e, l);
                    this.legendDecorationMaxLabel = Math.max(l, this.legendDecorationMaxLabel)
                }
                n = Math.max(n, (l + (this.margin * 3) + (a * 2)) * Math.min(h.pie[0].smps.length, this.legendColumns));
                this.legendDecorationHeight += (Math.ceil(h.pie[0].smps.length / Math.min(h.pie[0].smps.length, this.legendColumns)) * a * 1.5) + (this.margin * 2)
            }
            this.legendDecorationWidth = n
        }
    };
    this.setOncoprintLegendDimension = function() {
        this.legendOncoprintWidth = 0;
        this.legendOncoprintHeight = 0;
        this.legendOncoprintColors = {};
        if (this.isOncoprint) {
            var g = this.cloneObject(this.meta.data[this.oncoprintCNA].levels);
            var h = this.cloneObject(this.meta.data[this.oncoprintCNA].colors);
            var b = [];
            g.push("No Alteration");
            h.push("rgb(220,220,220");
            for (var e = 0; e < g.length; e++) {
                b.push("CNA")
            }
            var k = g.length;
            if (this.oncoprintMUT) {
                g = g.concat(this.cloneObject(this.meta.data[this.oncoprintMUT].levels));
                h = h.concat(this.cloneObject(this.meta.data[this.oncoprintMUT].colors));
                for (var e = k; e < g.length; e++) {
                    b.push("MUT")
                }
            }
            var j = [];
            var f = [];
            for (var e = 0; e < g.length; e++) {
                if (g[e]) {
                    j.push(g[e]);
                    f.push(b[e]);
                    this.legendOncoprintColors[g[e]] = h[e];
                    if (h[e] == "rgb(220,220,220") {
                        this.legendOncoprintMutations = j.length
                    }
                }
            }
            var d = this.getMaxText(j, this.legendFont);
            var c = this.measureText(d, this.legendFont);
            var a = Math.ceil(c + 5 + (this.margin * 8));
            var h = Math.floor(this.width / a);
            var l = Math.ceil(j.length / h);
            this.legendOncoprintWidth = a * h;
            this.legendOncoprintHeight = ((21 + this.margin) * l) + this.margin;
            this.legendOncoprintRows = l;
            this.legendOncoprintCols = h;
            this.legendOncoprintLabels = j;
            this.legendOncoprintObjects = f
        }
    };
    this.setSampleLegendDimension = function() {
        this.legendSampleWidth = 0;
        this.legendSampleHeight = 0;
        this.legendSampleMaxStr = "";
        this.legendSampleMaxStrLen = 0;
        this.legendSamplesN = 1;
        var n = this.getFontPt(this.legendFont);
        var k = 0;
        var m = 0;
        var a = this.decorations && this.decorations.kaplanMeier;
        var l = this.decorations && this.decorations.qq;
        var d = this.decorations && this.decorations.cdf;
        var b = [];
        var c = {};
        if (this.ridgeBy && this.dataStndBy.y.smps.length == 1) {
            return
        }
        if (this.isHistogram && this.isHistogramLayout()) {
            for (var f = 0; f < this.data.l.axes.length; f++) {
                for (var e = 0; e < this.data.l.axes[f].yAxis.length; e++) {
                    if (this.data.l.axes[f].yAxis[e]) {
                        if (this.segregateVariablesBy.length || !this.data.l.axes[f].yAxis[e].match(":")) {
                            c[this.data.l.axes[f].yAxis[e].split(":")[0]] = true
                        } else {
                            if (this.data.l.axes.length == this.dataStndBy.y.smps.length) {
                                c[this.data.l.axes[f].yAxis[e].split(":")[1]] = true
                            } else {
                                c[this.data.l.axes[f].yAxis[e]] = true
                            }
                        }
                    }
                }
            }
            b = this.getKeys(c)
        }
        if (this.graphType.match(/Scatter/) && !a && !l && !d) {
            m = this.ridgeBy ? this.dataStndBy.y.smps.length : Math.max(this.xAxisIndices.length, this.yAxisIndices.length);
            if (this.ridgeBy) {
                k = this.measureText(this.shortenText(this.getMaxText(this.dataStndBy.y.smps), this.maxSmpStringLen), this.legendFont)
            } else {
                if (this.isHistogram) {
                    k = this.measureText(this.shortenText(this.getMaxText(this.data.y.smps), this.maxSmpStringLen), this.legendFont);
                    m = this.data.y.smps.length - 1;
                    if (this.isHistogramLayout()) {
                        m = b.length;
                        k = this.measureText(this.shortenText(this.getMaxText(b), this.maxSmpStringLen), this.legendFont)
                    }
                } else {
                    if (this.xAxisIndices.length != this.yAxisIndices.length || this.xAxisIndices.length > 1) {
                        if (this.xAxisIndices.length == this.yAxisIndices.length && this.xAxisIndices.length > 1) {
                            for (var f = 0; f < this.xAxisIndices.length; f++) {
                                var h = this.shortenText(this.xAxis[f], this.maxSmpStringLen) + " vs " + this.shortenText(this.yAxis[f], this.maxSmpStringLen);
                                var g = this.measureText(h, this.legendFont);
                                if (g > k) {
                                    this.legendSampleMaxStr = h
                                }
                                k = Math.max(g, k)
                            }
                        } else {
                            if (this.xAxisIndices.length > this.yAxisIndices.length) {
                                this.legendSampleMaxStr = this.shortenText(this.getMaxText(this.xAxis), this.maxSmpStringLen) + " vs " + this.shortenText(this.yAxis[0], this.maxSmpStringLen);
                                k = this.measureText(this.legendSampleMaxStr, this.legendFont)
                            } else {
                                if (this.yAxisIndices.length > this.xAxisIndices.length) {
                                    this.legendSampleMaxStr = this.shortenText(this.getMaxText(this.yAxis), this.maxSmpStringLen) + " vs " + this.shortenText(this.xAxis[0], this.maxSmpStringLen);
                                    k = this.measureText(this.legendSampleMaxStr, this.legendFont)
                                }
                            }
                        }
                    }
                }
            }
            if (k) {
                this.legendSamplesN = m;
                this.legendSampleMaxStrLen = k;
                this.legendSampleWidth = ((n - 1) + k + (this.margin * 3)) * this.legendColumns;
                this.legendSampleHeight = (Math.ceil(m / this.legendColumns) * (n + this.margin)) + this.margin
            }
        }
    };
    this.setVariableLegendDimension = function() {
        if (this.showLegend) {
            this.legendVariableWidth = 0;
            this.legendVariableHeight = 0;
            var h = this;
            var g = function() {
                if (h.isDOE && h.layoutCurrentDOE) {
                    if (h.layoutCurrentDOE) {
                        if (h.meta.data.x && h.meta.data.x.hasOwnProperty(h.layoutCurrentDOE)) {
                            return h.meta.data.x[h.layoutCurrentDOE]
                        } else {
                            if (h.meta.data.z && h.meta.data.z.hasOwnProperty(h.layoutCurrentDOE)) {
                                return h.meta.data.z[h.layoutCurrentDOE]
                            }
                        }
                    }
                }
                return h.meta.data.y
            };
            var c = g();
            var a = this.getFontPt(this.legendFont);
            if (this.graphType == "Fish") {
                var o = this.getFontPt(this.legendFont);
                var b = this.varIndices.length;
                var f = this.shortenText(c.maxVarStr, this.maxVarStringLen);
                this.legendVariableWidth = ((o - 1) + this.measureText(f, this.legendFont) + (this.margin * 6)) * Math.min(b, this.legendColumns);
                this.legendVariableHeight = (Math.ceil(b / Math.min(b, this.legendColumns)) * (o + this.margin)) + (this.margin * 5)
            }
            if (this.graphType == "Pie") {
                var b = this.varIndices.length > this.maxPieSectors ? this.maxPieSectors : this.varIndices.length;
                var f = this.isDOE && this.layoutCurrentDOE ? this.shortenText(c.maxLevStr, this.maxVarStringLen) : this.shortenText(c.maxVarStr, this.maxVarStringLen);
                if (this.maxPieSectors < this.varIndices.length && f.length < 5) {
                    f = this.shortenText("Other", this.maxVarStringLen)
                }
                var e = this.measureText(f, this.legendFont) + a + (this.margin * 3);
                var k = this.layoutComb && this.isDOE ? this.layoutWidth : this.width;
                var j = (1 - this.percentAspectRatioPlotArea);
                this.legendVariableWidth = e > k * j ? k * j : this.measureText(f, this.legendFont) + a + (this.margin * 5);
                this.legendVariableHeight = ((a + this.margin) * b) + (this.margin * 2)
            } else {
                if (this.layoutValid && this.segregateVariablesBy.length > 0 && !this.graphType.match(/Scatter/)) {
                    if (this.segregateVariablesBy[0] == "variable" || (this.segregateVariablesBy.length > 1 && this.segregateVariablesBy[1] == "variable")) {
                        return
                    } else {
                        if (!this.colorBy || (this.colorBy && this.colorBy == "variable")) {
                            var o = c.maxVarChr > this.maxVarStringLen ? c.maxVarStr.substring(0, this.maxVarStringLen) : c.maxVarStr;
                            var b = this.varIndices.length;
                            this.legendVariableWidth = ((this.margin * 3) + (a * 2) + this.measureText(o, this.legendFont)) * Math.min(b, this.legendColumns);
                            this.legendVariableHeight = (Math.ceil(b / Math.min(b, this.legendColumns)) * a * 1.5) + (this.margin * 2)
                        } else {
                            return
                        }
                    }
                } else {
                    if ((this.colorBy && this.colorBy == "variable") || (this.shapeBy && this.shapeBy == "variable") || (this.sizeBy && this.sizeBy == "variable") || (this.patternBy && this.patternBy == "variable")) {
                        var o = this.sizeBy && this.sizeBy == "variable" ? Math.max(this.sizes[this.varIndices.length - 1], this.getFontPt(this.legendFont)) : this.getFontPt(this.legendFont);
                        var b = this.varIndices.length;
                        var f = this.shortenText(c.maxVarStr, this.maxVarStringLen);
                        this.legendVariableWidth = ((o - 1) + this.measureText(f, this.legendFont) + (this.margin * 3)) * Math.min(b, this.legendColumns);
                        this.legendVariableHeight = (Math.ceil(b / Math.min(b, this.legendColumns)) * (o + this.margin)) + (this.margin * 2)
                    } else {
                        if (!this.colorBy && (this.graphType == "BarLine" || this.graphType == "DotLine" || this.graphType == "AreaLine" || this.graphType == "StackedLine" || this.graphType == "StackedPercentLine")) {
                            var o = c.maxVarChr > this.maxVarStringLen ? c.maxVarStr.substring(0, this.maxVarStringLen) : c.maxVarStr;
                            var b = this.xAxisVarIndices.length + this.xAxis2VarIndices.length;
                            this.legendVariableWidth = ((this.margin * 3) + (a * 2) + this.measureText(o, this.legendFont)) * Math.min(b, this.legendColumns);
                            this.legendVariableHeight = (Math.ceil(b / Math.min(b, this.legendColumns)) * a * 1.5) + (this.margin * 2)
                        } else {
                            if (!this.colorBy && (this.graphType == "Bar" || this.graphType == "Line" || this.graphType == "Area" || this.graphType == "Dotplot" || this.graphType == "Stacked" || this.graphType == "StackedPercent" || this.graphType == "Boxplot")) {
                                var o = c.maxVarChr > this.maxVarStringLen ? c.maxVarStr.substring(0, this.maxVarStringLen) : c.maxVarStr;
                                var b = this.varIndices.length;
                                this.legendVariableWidth = ((this.margin * 3) + (a * 2) + this.measureText(o, this.legendFont)) * Math.min(b, this.legendColumns);
                                this.legendVariableHeight = (Math.ceil(this.varIndices.length / Math.min(b, this.legendColumns)) * a * 1.5) + (this.margin * 2)
                            } else {
                                if (this.graphType == "Circular" && !this.showIdeogram) {
                                    var o = c.maxVarChr > this.maxVarStringLen ? c.maxVarStr.substring(0, this.maxVarStringLen) : c.maxVarStr;
                                    var i = this.rAxisIndex >= 0 ? this.varIndices.length - 1 : this.varIndices.length;
                                    this.legendVariableWidth = ((this.margin * 3) + (a * 2) + this.measureText(o, this.legendFont)) * Math.min(i, this.legendColumns);
                                    this.legendVariableHeight = (Math.ceil(i / Math.min(i, this.legendColumns)) * a * 1.5) + (this.margin * 2)
                                }
                            }
                        }
                    }
                }
            }
            if (this.legendVariableHeight > this.height) {
                this.legendColumns++;
                this.maxVarStringLen = Math.max(10, this.maxVarStringLen - 5);
                this.setVariableLegendDimension()
            }
        }
    };
    this.setVennLegendDimension = function() {
        var a = this.data.venn.legend ? this.getMaxText(this.data.venn.legend) : "N/A";
        this.legendWidth = this.measureText(a, this.legendFont) + (this.margin * 6);
        this.legendHeight = this.margin + this.margin + ((this.getFontPt(this.legendFont) + this.margin) * this.vennGroups)
    };
    this.setOverlaysLegendDimensions = function() {
        var b = this.getFontPt(this.legendFont) + 2;
        var s = this.getDiameterLegend();
        var k = Math.max(b, s);
        var d = ["varOverlays", "smpOverlays"];
        var e = ["varOverlayProperties", "smpOverlayProperties"];
        var y = ["showVarOverlaysLegend", "showSmpOverlaysLegend"];
        this.legendOverlaysLayout = [];
        this.legendOverlaysWidth = 0;
        this.legendOverlaysHeight = 0;
        var q = this.margin;
        var n = this.margin;
        var a = 0;
        var g = 0;
        var l = 0;
        var B = false;
        if (this.showOverlays && (this.showVarOverlaysLegend || this.showSmpOverlaysLegend)) {
            for (var v = 0; v < d.length; v++) {
                if (this[d[v]].length > 0 && this[y[v]]) {
                    for (var t = 0; t < this[d[v]].length; t++) {
                        var f = 0;
                        var x = 0;
                        var p = this[d[v]][t];
                        if (p != "-") {
                            var A = d[v] == "varOverlays" ? "z" : "x";
                            var r = this.meta.data[A][p];
                            var u = this.measureText(r.maxLevStr, this.legendFont);
                            var z = this.measureText(p, this.legendFont);
                            if (this.graphType == "Circular" || (this[e[v]][p] && this[e[v]][p].type == "Default" && this[e[v]][p].showLegend)) {
                                B = true;
                                if (r.type == "String") {
                                    f = Math.max(z, u + k + (this.margin * 3)) * this[d[v] + "LegendColumns"];
                                    x = ((Math.max(b, s) + this.margin) * Math.ceil(r.levels.length / this[d[v] + "LegendColumns"])) + b + this.margin
                                } else {
                                    if (this.overlaysLegendPosition.match(/right/i)) {
                                        f = Math.max(this.heatmapIndicatorHeight + (this.margin * 2) + u, z);
                                        x = this.heatmapIndicatorWidth + (this.margin * 3) + b
                                    } else {
                                        f = this.heatmapIndicatorWidth + (this.margin * 3) + b;
                                        x = Math.max(this.heatmapIndicatorHeight + (this.margin * 2) + u, z)
                                    }
                                }
                                this["legend" + p + "Width"] = f;
                                this["legend" + p + "Height"] = x;
                                if (this.overlaysLegendPosition.match(/right/i)) {
                                    if (g + this.margin + x > (this.height - (this.top + this.bottom))) {
                                        q += this.margin + f;
                                        a = f;
                                        g = x;
                                        if (this.legendOverlaysLayout[l]) {
                                            l++
                                        }
                                        this.legendOverlaysLayout[l] = [
                                            [A, p, f, x]
                                        ]
                                    } else {
                                        if (f > a) {
                                            q += (f - a);
                                            a = f
                                        }
                                        g += x;
                                        if (!this.legendOverlaysLayout[l]) {
                                            this.legendOverlaysLayout[l] = []
                                        }
                                        this.legendOverlaysLayout[l].push([A, p, f, x])
                                    }
                                } else {
                                    if (a + this.margin + f > (this.width - (this.left + this.right))) {
                                        n += this.margin + x;
                                        a = f;
                                        g = x;
                                        if (this.legendOverlaysLayout[l]) {
                                            l++
                                        }
                                        this.legendOverlaysLayout[l] = [
                                            [A, p, f, x]
                                        ]
                                    } else {
                                        if (x > g) {
                                            n += (x - g);
                                            g = x
                                        }
                                        a += f;
                                        if (!this.legendOverlaysLayout[l]) {
                                            this.legendOverlaysLayout[l] = []
                                        }
                                        this.legendOverlaysLayout[l].push([A, p, f, x])
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        if (this.overlaysLegendPosition.match(/right/i)) {
            this.legendOverlaysWidth = B ? q + this.margin : 0;
            this.legendOverlaysHeight = B ? g + this.margin : 0
        } else {
            this.legendOverlaysWidth = B ? a + this.margin : 0;
            this.legendOverlaysHeight = B ? n + this.margin : 0
        }
    };
    this.setLegendDimensions = function() {
        if (this.showDecorations && this.showDecorationsLegend && this.decorations) {
            this.decorationLayout = [0]
        }
        if (this.showLegend) {
            this.legendLayout = [];
            this.legendWidth = 0;
            this.legendHeight = 0;
            var a = this.margin;
            var k = this.margin;
            var b = 0;
            var j = 0;
            var g = 0;
            var e = this.graphType == "Network" ? ["ColorNode", "ShapeNode", "SizeNode", "PatternNode", "ColorEdge", "SizeEdge", "Decoration"] : this.scatterPlotMatrix ? ["Color", "Shape", "Size", "Pattern", "Variable"] : this.connectByNoColor ? ["Color", "Shape", "Size", "Pattern", "Variable", "Sample"] : ["Color", "Shape", "Size", "Pattern", "Connect", "Variable", "Sample"];
            for (var c = 0; c < e.length; c++) {
                var f = this["legend" + e[c] + "Width"];
                var d = this["legend" + e[c] + "Height"];
                if (e[c] == "Decoration" && !this.showDecorations) {
                    continue
                }
                if (e[c] == "Size" && this.graphType == "Map" && this.decorations && this.decorations.pie) {
                    continue
                }
                if (f > 0) {
                    if (this.legendPosition.match(/right|left/i)) {
                        if (j + this.margin + d > this.height) {
                            a += this.margin + f;
                            b = f;
                            j = d;
                            this.legendLayout[g] = [e[c]];
                            g++
                        } else {
                            if (f > b) {
                                a += (f - b);
                                b = f
                            }
                            j += d;
                            if (!this.legendLayout[g]) {
                                this.legendLayout[g] = []
                            }
                            this.legendLayout[g].push(e[c])
                        }
                    } else {
                        if (b + this.margin + f > this.width) {
                            k += this.margin + d;
                            b = f;
                            j = d;
                            this.legendLayout[c] = [e[c]];
                            g++
                        } else {
                            if (d > j) {
                                k += (d - j);
                                j = d
                            }
                            b += f;
                            if (!this.legendLayout[g]) {
                                this.legendLayout[g] = []
                            }
                            this.legendLayout[g].push(e[c])
                        }
                    }
                }
            }
            for (var c = 0; c < this.legend.length; c++) {
                this.legend[c].id = "Custom" + c;
                this.setCustomLegendDimensions(this.legend[c]);
                var f = this["legendCustom" + c + "Width"];
                var d = this["legendCustom" + c + "Height"];
                if (this.legendPosition.match(/right|left/i)) {
                    if (j + this.margin + d > this.height) {
                        a += this.margin + f;
                        b = f;
                        j = d;
                        this.legendLayout[g] = [this.legend[c].id];
                        g++
                    } else {
                        if (f > b) {
                            a += (f - b);
                            b = f
                        }
                        j += d;
                        if (!this.legendLayout[g]) {
                            this.legendLayout[g] = []
                        }
                        this.legendLayout[g].push(this.legend[c].id)
                    }
                } else {
                    if (b + this.margin + f > this.width) {
                        k += this.margin + d;
                        b = f;
                        j = d;
                        this.legendLayout[c] = [this.legend[c].id];
                        g++
                    } else {
                        if (d > j) {
                            k += (d - j);
                            j = d
                        }
                        b += f;
                        if (!this.legendLayout[g]) {
                            this.legendLayout[g] = []
                        }
                        this.legendLayout[g].push(this.legend[c].id)
                    }
                }
            }
            this.legendWidth = b == 0 && a == this.margin ? 0 : this.legendPosition.match(/right|left/i) ? a + this.margin : b + this.margin;
            this.legendHeight = j == 0 && k == this.margin ? 0 : this.legendPosition.match(/right|left/i) ? j + this.margin : k + this.margin;
            if (this.legendPositionAuto && !this.legendInside && !this.legendPositionTest) {
                if (this.legendPosition.match(/right|left/i) && this.legendWidth > this.legendHeight * 1.5) {
                    this.legendPositionTest = true;
                    this.legendPosition = "bottom";
                    this.setLegends()
                } else {
                    if (this.legendPosition.match(/top|bottom/i) && this.legendHeight > this.legendWidth * 1.5) {
                        this.legendPositionTest = true;
                        this.legendPosition = "right";
                        this.setLegends()
                    }
                }
                this.legendPositionTest = false
            }
        }
    };
    this.setLegends = function(q) {
        var h = this;
        var g = this.graphType == "Network" ? ["ColorNode", "ShapeNode", "SizeNode", "PatternNode", "ColorEdge", "SizeEdge"] : this.connectByNoColor ? ["Color", "Shape", "Size", "Pattern", "Outline"] : ["Color", "Shape", "Size", "Pattern", "Outline", "Connect"];
        var r = ["shapeByData", "sizeByData", "patternByData", "outlineByData"];
        var n = function(a, o, t) {
            var u = o == "Outline" ? "Color" : o;
            var s = (h.decapitalize(u) + "s").replace("Node", "").replace("Edge", "").replace("decorations", "colors");
            delete(h["legend" + u + "sS"]);
            h["legend" + u + "Meta"] = a;
            if (t) {
                h["legend" + u + "Meta"].vals = h.rPretty(t[0], t[1], 5);
                h["legend" + u + "Meta"].decs = h.getAxisDecimals(t[1] - t[0]);
                h["legend" + u + "Meta"].maxLevStr = h.getMaxText(h["legend" + (o == "Outline" ? "Color" : o) + "Meta"].vals);
                h["legend" + u + "Meta"].maxLevLen = h.measureText(h["legend" + u + "Meta"].maxLevStr, h.font);
                h["legend" + u + "Meta"].maxLevChr = h["legend" + u + "Meta"].maxLevStr.toString().length
            }
            if (h.ridgeBy && h.colorBy == "data") {
                h["legend" + u + "Meta"].min = h["legend" + u + "Meta"].vals[0];
                h["legend" + u + "Meta"].max = h["legend" + u + "Meta"].vals[h["legend" + u + "Meta"].vals.length - 1]
            }
            h["legend" + u + "sMax"] = h["legend" + u + "Meta"].maxLevStr;
            h["legend" + u + "sN"] = h["legend" + u + "Meta"].vals.length;
            for (var p = 0; p < h["legend" + u + "Meta"].vals.length; p++) {
                h["legend" + u + "s"][h["legend" + u + "Meta"].vals[p].toString()] = u == "Connect" ? h.colors[p] : h[s][p]
            }
            h.setPropertyLegendIndicatorDimensions(o, h["legend" + u + "Meta"])
        };
        var j = function(B, I, x, D, y) {
            var F = 0;
            var v = 0;
            var A = false;
            var C = {};
            var s = {};
            var a = B[h.decapitalize(D).replace("Node", "").replace("Edge", "") + "s"] || h[h.decapitalize(D).replace("Node", "").replace("Edge", "") + "s"];
            var z = h.isGroupedData && h.graphType != "Dotplot" && h.graphType != "Boxplot" && !h.showBoxplotOriginalData && h.groupingFactors.length == 1;
            if (I == "x") {
                var t = h.isGroupedData ? h.grpIndices : h.smpIndices;
                for (var G = 0; G < t.length; G++) {
                    var u = t[G];
                    if (h.isGroupedData && (h.graphType == "Dotplot" || h.graphType == "Boxplot" || h.barType == "swimmer" || h.graphType == "Gantt" || h.stackBy)) {
                        h.isGroupedData = false;
                        for (var E = 0; E < h.data.w.grps[u].length; E++) {
                            var w = h.getMetadataValue(h.data.w.grps[u][E], I, h[x]);
                            s[w] = true
                        }
                        h.isGroupedData = true
                    } else {
                        var w;
                        if (h.isGroupedData) {
                            h.isGroupedData = false;
                            w = h.getSmpAnnotations(h[x], h.data.w.grps[G], true);
                            h.isGroupedData = true
                        } else {
                            w = h.getMetadataValue(u, I, h[x])
                        }
                        s[w] = true
                    }
                }
            } else {
                if (I == "z") {
                    if (h.graphType == "Map" && h.varIndices.length < B.levels.length) {
                        for (var G = 0; G < B.levels.length; G++) {
                            var w = B.levels[G];
                            s[w] = true
                        }
                    } else {
                        for (var G = 0; G < h.varIndices.length; G++) {
                            var u = h.varIndices[G];
                            var w = h.getMetadataValue(u, I, h[x]);
                            s[w] = true
                        }
                    }
                } else {
                    if (I == "m") {
                        for (var G = 0; G < h.varIndices.length; G++) {
                            for (var E = 0; E < h.smpIndices.length; E++) {
                                var w = y[h.varIndices[G]][h.smpIndices[E]];
                                s[w] = true
                            }
                        }
                    } else {
                        if (I == "modified") {
                            B.order = {};
                            for (var G = 0; G < B.levels.length; G++) {
                                s[B.levels[G]] = true;
                                B.order[B.levels[G]] = G
                            }
                        } else {
                            if (I == "nodes" || I == "edges") {
                                B.order = {};
                                for (var G = 0; G < B.levels.length; G++) {
                                    s[B.levels[G]] = true;
                                    B.order[B.levels[G]] = G
                                }
                            }
                        }
                    }
                }
            }
            s = h.getKeys(s);
            if (B.type == "Numeric") {
                if (B.orderS) {
                    s.sort(function(l, i) {
                        return B.orderS[l] - B.orderS[i]
                    })
                } else {
                    s.sort(function(l, i) {
                        return l - i
                    });
                    B.orderS = {};
                    for (var G = 0; G < s.length; G++) {
                        B.orderS[s[G]] = G
                    }
                }
            } else {
                s.sort(function(l, i) {
                    return B.order[l] - B.order[i]
                })
            }
            for (var G = 0; G < s.length; G++) {
                var w = s[G] != null ? s[G] : "NA";
                var H = h.measureText(w, h.legendFont);
                if (H > F) {
                    F = H;
                    h["legend" + D + "sMax"] = w
                }
                C[w] = (B.type == "Numeric" ? B.orderS[w] : B.order[w]) % a.length;
                h["legend" + D + "s"][w] = a[C[w]];
                v++
            }
            h["legend" + D + "sS"] = s;
            A = I == "m" || I == "modified" ? h["legend" + D + "sMax"] : false;
            h["legend" + D + "sN"] = v;
            h["legend" + D + "Meta"] = B;
            h.setPropertyLegendDimensions(D, A, B)
        };
        if (!this.hiddenLegends) {
            this.hiddenLegends = {}
        }
        this.validateLegendPositions();
        this.setLegendFont();
        if (this.graphType == "Meter") {
            return
        } else {
            if (this.graphType == "Venn") {
                this.setVennLegendDimension();
                return
            } else {
                if (this.graphType == "Network") {
                    for (var f = 0; f < g.length; f++) {
                        var e = g[f];
                        var k = this.decapitalize(g[f]);
                        var b = k + "By";
                        this["legend" + e + "s"] = {};
                        this["legend" + e + "sN"] = 0;
                        this["legend" + e + "Width"] = 0;
                        this["legend" + e + "Height"] = 0;
                        if (this[b]) {
                            var d = this.meta.data[e.match("Node") ? "nodes" : "edges"][this[b]];
                            if (d.type == "Numeric") {
                                n(d, e)
                            } else {
                                j(d, e.match("Node") ? "nodes" : "edges", b, e)
                            }
                        }
                    }
                    if (this.decorations.length && this.decorationsType == "heatmap" && this.meta.data.decorations.n && this.showDecorations) {
                        var d = this.meta.data.decorations;
                        var e = "Decoration";
                        this["legend" + e + "s"] = {};
                        this["legend" + e + "sN"] = 0;
                        this["legend" + e + "Width"] = 0;
                        this["legend" + e + "Height"] = 0;
                        n(d, e)
                    }
                } else {
                    if (this.isMultidimensionalData) {
                        for (var f = 0; f < r.length; f++) {
                            if (this.data.y[this[r[f]]]) {
                                var c = this.data.y[this[r[f]]];
                                var d = this.meta.data[this[r[f]]];
                                var e = r[f].replace("ByData", "");
                                e = this.capitalize(e);
                                var k = this.decapitalize(e);
                                var b = k + "By";
                                this["legend" + (e == "Outline" ? "Color" : e) + "s"] = [];
                                this["legend" + (e == "Outline" ? "Color" : e) + "sN"] = 0;
                                if (d.type == "Numeric") {
                                    n(d, e, [d.min, d.max])
                                } else {
                                    j(d, "m", b, e, c)
                                }
                            }
                        }
                    } else {
                        for (var f = 0; f < g.length; f++) {
                            var e = g[f];
                            var k = this.decapitalize(g[f]);
                            var b = k + "By";
                            this["legend" + e + "s"] = {};
                            this["legend" + e + "sN"] = 0;
                            this["legend" + e + "Width"] = 0;
                            this["legend" + e + "Height"] = 0;
                            if (q) {
                                continue
                            }
                            if (this[b]) {
                                if (this.data.x && this.data.x.hasOwnProperty(this[b])) {
                                    var d = this.meta.data.x[this[b]];
                                    this[k + "ByType"] = "x";
                                    if (d.type == "Numeric" && !d[b]) {
                                        n(d, e)
                                    } else {
                                        j(d, "x", b, e)
                                    }
                                } else {
                                    if (this.data.z && this.data.z.hasOwnProperty(this[b])) {
                                        var d = this.meta.data.z[this[b]];
                                        this[k + "ByType"] = "z";
                                        if (d.type == "Numeric" && !d[b]) {
                                            n(d, e)
                                        } else {
                                            j(d, "z", b, e)
                                        }
                                    } else {
                                        if (this.getSampleIndices(this[b]) > -1 && this.meta.data.y.range[this[b]]) {
                                            var d = this.meta.data;
                                            if (d.modified && d.modified.z && d.modified.z[this[b]]) {
                                                d = d.modified.z;
                                                if (!d.meta) {
                                                    d.meta = {}
                                                }
                                                d.meta[this[b]] = {
                                                    levels: d[this[b]]
                                                };
                                                j(d.meta[this[b]], "modified", b, e)
                                            } else {
                                                d = d.y.range[this[b]];
                                                n(d, e, [d.min, d.max])
                                            }
                                        } else {
                                            if (this[b] == "variable") {
                                                h["legend" + e + "sN"] = this.varIndices.length
                                            } else {
                                                if (this.ridgeBy && this[b] == "data") {
                                                    n({
                                                        type: "Numeric"
                                                    }, e, [this.xAxisMin, this.xAxisMax])
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        this.setDecorationsLegendDimensions();
        this.setSampleLegendDimension();
        this.setVariableLegendDimension();
        this.setOncoprintLegendDimension();
        this.setOverlaysLegendDimensions();
        this.setLegendDimensions()
    };
    this.addLegend = function(c, b) {
        if (c) {
            if (b) {
                var a = this.findXYCoordinates(b);
                c.x = a.x;
                c.y = a.y
            }
            this.legend.push(c)
        }
    };
    this.deleteLegend = function(c) {
        if (c && c.id) {
            var b = [];
            for (var a = 0; a < this.legend.length; a++) {
                if (this.legend[a].id != c.id) {
                    b.push(this.legend[a])
                }
            }
            this.legend = b
        }
    };
    this.drawDecorationData = function() {
        this.toRender({
            p: ["setClipArea", this.setClipBoundaries()],
            t: "Decorations"
        });
        var ad = this.marginLeft + this.offsetX + this.left;
        var Y = this.marginTop + this.offsetY + this.top;
        var al = this.decorations;
        if (this.showDecorations && al) {
            if (this.graphType.match(/Scatter/)) {
                if (al.qq) {
                    for (var ah = 0; ah < al.qq.length; ah++) {
                        var an = al.qq[ah].data;
                        var N = al.qq[ah].color;
                        var aG = al.qq[ah].index;
                        if (this.smpIndices.includes(aG)) {
                            for (var ag = 0; ag < this.qqPoints; ag++) {
                                var J = ad + (an.x[ag] * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                var g = (Y + this.y) - (an.y[ag] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                this.toRender({
                                    p: ["drawShape", "circle", J, g, this.dataPointSize, this.dataPointSize, false, N, "open"],
                                    a: this.getShapeArea("circle", J, g, this.dataPointSize, this.dataPointSize, false, N, "open"),
                                    i: ["QQ-" + ah + "-" + ag],
                                    t: "Decorations"
                                })
                            }
                            this.toRender({
                                p: ["drawLine", "line", ad, Y + this.y, ad + this.x, Y, this.fitLineColor, 2],
                                t: "Decorations"
                            })
                        }
                    }
                } else {
                    if (al.cdf) {
                        for (var ah = 0; ah < al.cdf.length; ah++) {
                            var an = al.cdf[ah].data;
                            var N = al.cdf[ah].color;
                            var aG = al.cdf[ah].index;
                            if (this.smpIndices.includes(aG)) {
                                var aL = [];
                                var aA = [];
                                for (var ag = 0; ag < an.x.length; ag++) {
                                    aL.push(ad + (an.x[ag] * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit));
                                    aA.push((Y + this.y) - (an.y[ag] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit))
                                }
                                this.toRender({
                                    p: ["drawLine", "spline", aL, aA, false, false, N, 2],
                                    a: this.getLineArea("spline", aL, aA, false, false, N, 2),
                                    i: ["CDF-" + ah],
                                    t: "Decorations"
                                })
                            }
                        }
                    } else {
                        if (!al.qq && !al.cdf) {
                            if (al.nlfit) {
                                var h, O, f;
                                var G = this.varIndices;
                                var J, g;
                                for (var ah = 0; ah < al.nlfit.length; ah++) {
                                    var aK = [];
                                    var aI = [];
                                    var N = ah % this.colors.length;
                                    var a = Number(this.transformValue(this.yAxisTransform, al.nlfit[ah].param[0]));
                                    var aY = Number(this.transformValue(this.yAxisTransform, al.nlfit[ah].param[1]));
                                    var aW = Number(al.nlfit[ah].param[2]);
                                    var aU = Number(al.nlfit[ah].param[3]);
                                    var Z = this.xAxisIndices.length == 1 ? this.xAxisIndices[0] : this.xAxisIndices[ah];
                                    var aL = this.getDataForSmpGrpAtIndex(Z);
                                    if (this.xAxisTransform == "percentile") {
                                        h = this.range(aL);
                                        f = h[0];
                                        O = h[1]
                                    }
                                    G.sort(function(i, d) {
                                        return aL[i] - aL[d]
                                    });
                                    N = al.nlfit[ah].color ? al.nlfit[ah].color : this.colors[N];
                                    for (var ag = 0; ag < G.length; ag++) {
                                        var C = G[ag];
                                        var R = this.getDataAtPos(C, Z);
                                        var Q;
                                        var M = [];
                                        if (R > 0) {
                                            if (ag > 0) {
                                                var aJ = G[ag - 1];
                                                var aM = this.getDataAtPos(aJ, Z);
                                                if (aM > 0) {
                                                    var S = (R - aM) / 25;
                                                    for (var af = 0; af < 25; af++) {
                                                        M.push(aM);
                                                        aM += S
                                                    }
                                                }
                                            } else {
                                                M = [R]
                                            }
                                            for (var af = 0; af < M.length; af++) {
                                                if (al.nlfit[ah].type == "reg") {
                                                    Q = a + ((aY - a) / (1 + aW / (Math.pow(M[af], aU))))
                                                } else {
                                                    Q = a + ((aY - a) / (1 + (Math.pow((M[af] / aW), aU))))
                                                }
                                                if (this.xAxisTransform) {
                                                    M[af] = this.xAxisTransform == "percentile" ? this.percentile(f, O, M[af]) : this.transformValue(this.xAxisTransform, M[af])
                                                }
                                                J = ad + ((M[af] - this.xAxisMin) * this.xAxisUnit);
                                                g = (Y + this.y) - ((Q - this.yAxisMin) * this.yAxisUnit);
                                                aK.push(J);
                                                aI.push(g)
                                            }
                                        }
                                    }
                                    if (aK.length > 0) {
                                        this.toRender({
                                            p: ["drawShape", "path", aK, aI, false, false, N, N, "open", false, false, true],
                                            a: this.getShapeArea("path", aK, aI, false, false, N, N, "open", false, false, true),
                                            i: ["Decor-Non-Lin-" + ag + "-" + ah],
                                            t: "Decorations"
                                        });
                                        if (al.nlfit[ah].type == "reg") {
                                            Q = a + ((aY - a) / (1 + aW / (Math.pow(aW, aU))))
                                        } else {
                                            Q = a + ((aY - a) / (1 + (Math.pow((aW / aW), aU))))
                                        }
                                        if (this.xAxisTransform) {
                                            aW = this.xAxisTransform == "percentile" ? this.percentile(f, O, aW) : this.transformValue(this.xAxisTransform, aW)
                                        }
                                        J = ad + ((aW - this.xAxisMin) * this.xAxisUnit);
                                        g = (Y + this.y) - ((Q - this.yAxisMin) * this.yAxisUnit);
                                        var aG = this.toRender({
                                            p: ["drawLine", "dottedLine", ad, g, J, g, N],
                                            a: this.getLineArea("dottedLine", ad, g, J, g, N),
                                            i: ["Decor-Non-Lin-EC-h" + ag + "-" + ah],
                                            t: "Decorations"
                                        });
                                        this.toRender({
                                            p: ["drawLine", "dottedLine", J, g, J, (Y + this.y), N],
                                            a: this.getLineArea("dottedLine", J, g, J, (Y + this.y), N),
                                            i: ["Decor-Non-Lin-EC-v" + ag + "-" + ah],
                                            g: aG,
                                            t: "Decorations"
                                        })
                                    }
                                }
                            }
                            if (al.text) {
                                for (var ah = 0; ah < al.text.length; ah++) {
                                    if (al.text[ah].x != null || al.text[ah].y != null) {
                                        var N = al.text[ah].color ? al.text[ah].color : this.foreground;
                                        var R = al.text[ah].x != null ? al.text[ah].x : null;
                                        var Q = al.text[ah].y != null ? al.text[ah].y : null;
                                        var o = al.text[ah].label || false;
                                        var ay = al.text[ah].scope || false;
                                        var aO = al.text[ah].align || "left";
                                        var J, g;
                                        if (ay) {
                                            var au = this.layoutValid ? false : true;
                                            if (this.layoutValid) {
                                                var W = this.data.l.name[this.layoutCurrent];
                                                if (!this.isArray(W)) {
                                                    W = [W]
                                                }
                                                for (var ag = 0; ag < W.length; ag++) {
                                                    if (ay.toString() == W[ag].toString().replace("\x00", "")) {
                                                        au = true;
                                                        break
                                                    }
                                                }
                                            }
                                            if (!au) {
                                                continue
                                            }
                                        }
                                        if (R != null && Q != null && o) {
                                            J = ad + ((R - this.xAxisMin) * this.xAxisUnit);
                                            g = Y + this.y - ((Q - this.yAxisMin) * this.yAxisUnit);
                                            if (aO == "right") {
                                                this.toRender({
                                                    p: ["drawText", o, J, g, this.decorationFont, N, "right", "middle"],
                                                    t: "Decorations"
                                                })
                                            } else {
                                                if (aO == "center") {
                                                    this.toRender({
                                                        p: ["drawText", o, J, g, this.decorationFont, N, "center", "middle"],
                                                        t: "Decorations"
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", o, J, g, this.decorationFont, N, "left", "middle"],
                                                        t: "Decorations"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            if (al.line) {
                                for (var ah = 0; ah < al.line.length; ah++) {
                                    if (al.line[ah].x != null || al.line[ah].y != null) {
                                        var N = al.line[ah].color ? al.line[ah].color : this.colors[ah % this.colors.length];
                                        var ap = al.line[ah].type ? al.line[ah].type : "line";
                                        var R = al.line[ah].x != null ? al.line[ah].x : null;
                                        var Q = al.line[ah].y != null ? al.line[ah].y : null;
                                        var F = al.line[ah].x2 != null ? al.line[ah].x2 : null;
                                        var b = al.line[ah].y2 != null ? al.line[ah].y2 : null;
                                        var T = al.line[ah].width ? al.line[ah].width : 1;
                                        var o = al.line[ah].label || false;
                                        var aO = al.line[ah].align || "left";
                                        var ay = al.line[ah].scope || false;
                                        var J, g, H, e, ar;
                                        if (ay) {
                                            var au = this.layoutValid ? false : true;
                                            if (this.layoutValid) {
                                                var W = this.data.l.name[this.layoutCurrent];
                                                if (!this.isArray(W)) {
                                                    W = [W]
                                                }
                                                for (var ag = 0; ag < W.length; ag++) {
                                                    if (ay.toString() == W[ag].toString().replace("\x00", "")) {
                                                        au = true;
                                                        break
                                                    }
                                                }
                                            }
                                            if (!au) {
                                                continue
                                            }
                                        }
                                        if (R != null && Q != null && F != null && b != null) {
                                            J = ad + ((R - this.xAxisMin) * this.xAxisUnit);
                                            H = ad + ((F - this.xAxisMin) * this.xAxisUnit);
                                            g = Y + this.y - ((Q - this.yAxisMin) * this.yAxisUnit);
                                            e = Y + this.y - ((b - this.yAxisMin) * this.yAxisUnit);
                                            ar = al.line[ah].tooltip || ("(" + R + "," + Q + ") &rarr; (" + F + "," + b + ")");
                                            this.toRender({
                                                p: ["drawLine", ap, J, g, H, e, N, T],
                                                a: this.getLineArea(ap, J, g, H, e, N, T),
                                                i: [ar + ":Decor-Line-" + ah],
                                                t: "Decorations"
                                            })
                                        } else {
                                            if (R != null) {
                                                J = ad + ((R - this.xAxisMin) * this.xAxisUnit);
                                                g = Y;
                                                H = J;
                                                e = g + this.y;
                                                ar = al.line[ah].tooltip || ("x &rarr; " + R);
                                                this.toRender({
                                                    p: ["drawLine", ap, J, g, H, e, N, T],
                                                    a: this.getLineArea(ap, J, g, H, e, N, T),
                                                    i: [ar + ":Decor-Line-" + ah],
                                                    t: "Decorations"
                                                })
                                            } else {
                                                if (Q != null) {
                                                    J = ad;
                                                    g = Y + this.y - ((Q - this.yAxisMin) * this.yAxisUnit);
                                                    H = J + this.x;
                                                    e = g;
                                                    ar = al.line[ah].tooltip || ("y &rarr; " + Q);
                                                    this.toRender({
                                                        p: ["drawLine", ap, J, g, H, e, N, T],
                                                        a: this.getLineArea(ap, J, g, H, e, N, T),
                                                        i: [ar + ":Decor-Line-" + ah],
                                                        t: "Decorations"
                                                    })
                                                }
                                            }
                                        }
                                        if (o) {
                                            if (al.line[ah].y2 != null) {
                                                var aD = this.getRadians(J, g, H, e);
                                                if (aO == "right") {
                                                    this.toRender({
                                                        p: ["drawText", o, H, e, this.decorationFont, this.decorationColor, "right", "bottom", aD],
                                                        t: "Decorations"
                                                    })
                                                } else {
                                                    if (aO == "center") {
                                                        this.toRender({
                                                            p: ["drawText", o, (J + H) / 2, (g + e) / 2, this.decorationFont, this.decorationColor, "center", "bottom", aD],
                                                            t: "Decorations"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawText", o, J, g, this.decorationFont, this.decorationColor, "left", "bottom", aD],
                                                            t: "Decorations"
                                                        })
                                                    }
                                                }
                                            } else {
                                                if (aO == "right") {
                                                    this.toRender({
                                                        p: ["drawText", o, H - this.margin, e - this.margin, this.decorationFont, this.decorationColor, "right", "bottom"],
                                                        t: "Decorations"
                                                    })
                                                } else {
                                                    if (aO == "center") {
                                                        this.toRender({
                                                            p: ["drawText", o, (J + H) / 2, e - this.margin, this.decorationFont, this.decorationColor, "center", "bottom"],
                                                            t: "Decorations"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawText", o, J + this.margin, e - this.margin, this.decorationFont, this.decorationColor, "left", "bottom"],
                                                            t: "Decorations"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            if (al.reg) {
                                for (var ah = 0; ah < al.reg.length; ah++) {
                                    if (al.reg[ah].slope && al.reg[ah].intercept) {
                                        var p = al.reg[ah].fit ? al.reg[ah].fit : this.colors[ah % this.colors.length];
                                        var N = al.reg[ah].color ? al.reg[ah].color : this.colors[ah % this.colors.length];
                                        var I = this.addColorTransparency(N, 0.3, true);
                                        var m = this.getPropertyValue(ah, false, "patternBy");
                                        var am = al.reg[ah].style ? al.reg[ah].style : this.fitLineStyle;
                                        var aQ = Number(al.reg[ah].slope);
                                        var ak = Number(al.reg[ah].intercept);
                                        var ae = al.reg[ah].id;
                                        var K = al.reg[ah].cor;
                                        var z = "y ~ " + this.formatNumber(aQ, this.yAxisDecs + 1) + "x + " + this.formatNumber(ak, this.yAxisDecs + 1) + " (r = " + this.formatNumber(K, 3) + ")";
                                        var U = al.reg[ah].ci;
                                        var L = U.length - 1;
                                        var J = this.showRegressionFullRange || !U ? this.xAxisMin : U[0][0];
                                        var g = (aQ * J) + ak;
                                        var H = this.showRegressionFullRange || !U ? this.xAxisMax : U[L][0];
                                        var e = (aQ * H) + ak;
                                        J = ad + (J * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                        g = (Y + this.y) - (g * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        H = ad + (H * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                        e = (Y + this.y) - (e * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        var aC = this.lineClip([
                                            [J, g],
                                            [H, e]
                                        ]);
                                        if (aC.length) {
                                            this.toRender({
                                                p: ["drawLine", am, aC[0][0][0], aC[0][0][1], aC[0][1][0], aC[0][1][1], p, 2],
                                                a: this.getLineArea(am, aC[0][0][0], aC[0][0][1], aC[0][1][0], aC[0][1][1], p, 2),
                                                i: ["Decor-Reg-" + ah, ae],
                                                t: "Decorations",
                                                h: this.isHidden(false, false, ae)
                                            })
                                        }
                                        if (U) {
                                            var A = [];
                                            var u = [];
                                            var aw = [];
                                            for (var ag = 0; ag < U.length; ag++) {
                                                J = ad + (U[ag][0] * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                                g = (Y + this.y) - (U[ag][1] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                                e = (Y + this.y) - (U[ag][2] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                                A.push([J, J]);
                                                u.push([g, e]);
                                                aw.push([J, (g + e) / 2])
                                            }
                                            if (this.showConfidenceIntervals) {
                                                this.toRender({
                                                    p: ["drawShape", "confidence", A, u, false, false, I, N, m],
                                                    a: this.getShapeArea("confidence", A, u, false, false, I, N, m),
                                                    i: [z + ":Confidence", ae],
                                                    b: aw,
                                                    t: "Decorations",
                                                    h: this.isHidden(false, false, ae)
                                                })
                                            }
                                        }
                                    }
                                }
                            }
                            if (al.nor) {
                                for (var ah = 0; ah < al.nor.length; ah++) {
                                    if (al.nor[ah].mu && al.nor[ah].sigma) {
                                        var E = [];
                                        var D = [];
                                        var aH = [];
                                        var J, g;
                                        var N = ah % this.colors.length;
                                        var ax = al.nor[ah].mu;
                                        var at = al.nor[ah].sigma;
                                        var r = al.nor[ah].start ? al.nor[ah].start : al.nor[ah].yAxis ? this.yAxisMin : this.xAxisMin;
                                        var ai = al.nor[ah].end ? al.nor[ah].end : al.nor[ah].yAxis ? this.yAxisMax : this.xAxisMax;
                                        var az = 120;
                                        if (r < ax && ax < ai) {
                                            var aM, aB, s, c;
                                            var S = (ax - r) / az;
                                            var v = at * at;
                                            var X = v * 2;
                                            var aj = 1 / Math.sqrt(2 * Math.PI * v);
                                            if (al.nor[ah].yAxis) {
                                                s = al.nor[ah].max ? al.nor[ah].max * this.xAxisUnit : this.x - (this.x * this.axisExtension);
                                                c = s / aj;
                                                aM = r;
                                                for (var ag = 0; ag < az - 1; ag++) {
                                                    aB = (aj * Math.pow(Math.E, -Math.pow(aM - ax, 2) / v));
                                                    aH.push([aM, aB]);
                                                    J = ad + (aB * c);
                                                    g = (Y + this.y) - (aM * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                                    E.push(J);
                                                    D.push(g);
                                                    aM += S
                                                }
                                                S = (ai - ax) / az;
                                                aM = ax;
                                                for (var ag = 0; ag < az; ag++) {
                                                    aB = (aj * Math.pow(Math.E, -Math.pow(aM - ax, 2) / v));
                                                    aH.push([aM, aB]);
                                                    J = ad + (aB * c);
                                                    g = (Y + this.y) - (aM * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                                    E.push(J);
                                                    D.push(g);
                                                    aM += S
                                                }
                                                N = al.nor[ah].color ? al.nor[ah].color : this.colors[N];
                                                this.toRender({
                                                    p: ["drawShape", "path", E, D, false, false, N, N, "open", false, false, true],
                                                    a: this.getShapeArea("path", E, D, false, false, N, N, "open", false, false, true),
                                                    i: ["Decor-Nor-" + ah],
                                                    t: "Decorations"
                                                })
                                            } else {
                                                s = al.nor[ah].max ? al.nor[ah].max * this.yAxisUnit : this.y - (this.y * this.axisExtension);
                                                c = s / aj;
                                                aM = r;
                                                for (var ag = 0; ag < az - 1; ag++) {
                                                    aB = (aj * Math.pow(Math.E, -Math.pow(aM - ax, 2) / v));
                                                    aH.push([aM, aB]);
                                                    J = ad + (aM * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                                    g = (Y + this.y) - (aB * c);
                                                    E.push(J);
                                                    D.push(g);
                                                    aM += S
                                                }
                                                S = (ai - ax) / az;
                                                aM = ax;
                                                for (var ag = 0; ag < az; ag++) {
                                                    aB = (aj * Math.pow(Math.E, -Math.pow(aM - ax, 2) / v));
                                                    aH.push([aM, aB]);
                                                    J = ad + (aM * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                                    g = (Y + this.y) - (aB * c);
                                                    E.push(J);
                                                    D.push(g);
                                                    aM += S
                                                }
                                                N = al.nor[ah].color ? al.nor[ah].color : this.colors[N];
                                                this.toRender({
                                                    p: ["drawShape", "path", E, D, false, false, N, N, "open", false, false, true],
                                                    a: this.getShapeArea("path", E, D, false, false, N, N, "open", false, false, true),
                                                    i: ["Decor-Nor-" + ah],
                                                    t: "Decorations"
                                                })
                                            }
                                        }
                                    }
                                }
                            }
                            if (al.area) {
                                for (var ah = 0; ah < al.area.length; ah++) {
                                    if (al.area[ah].type && al.area[ah].x && al.area[ah].y && al.area[ah].width && al.area[ah].height) {
                                        if (this.isValidShape(al.area[ah].type)) {
                                            var J = ad + (al.area[ah].x * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                            var g = (Y + this.y) - (al.area[ah].y * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                            var N = al.area[ah].color ? al.area[ah].color : this.colors[ah % this.colors.length];
                                            var q = al.area[ah].width * this.xAxisUnit;
                                            var ao = al.area[ah].height * this.yAxisUnit;
                                            this.oRender({
                                                p: ["drawShape", al.area[ah].type, J, g, q, ao, N, al.area[ah].outline, al.area[ah].pattern, al.area[ah].rotate],
                                                a: this.getShapeArea(al.area[ah].type, J, g, q, ao, N, al.area[ah].outline, al.area[ah].pattern, al.area[ah].rotate),
                                                i: ["Decor-Area-" + ah],
                                                t: "Decorations"
                                            })
                                        }
                                    }
                                }
                            }
                            if (al.kaplanMeier) {
                                var J, g, H, e, aP, aN, ab, aa, N, I, aq, aR, aT, aS, aF, aG, ac, aX, aV, n, av;
                                for (var ah = 0; ah < al.kaplanMeier.length; ah++) {
                                    aq = [
                                        [],
                                        []
                                    ];
                                    aR = [
                                        [],
                                        []
                                    ];
                                    aT = [
                                        [],
                                        []
                                    ];
                                    N = al.kaplanMeier[ah].color;
                                    I = this.addColorTransparency(N, 0.3, true);
                                    n = this.getSampleIndices(al.kaplanMeier[ah].time, false, this.isDOE);
                                    av = this.getSampleIndices(al.kaplanMeier[ah].censored, false, this.isDOE);
                                    ac = this.kaplanMeier(this.getDataForSmpGrpAtIndex(n, al.kaplanMeier[ah].indices), this.getDataForSmpGrpAtIndex(av, al.kaplanMeier[ah].indices));
                                    J = ad;
                                    g = (Y + this.y) - (this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                    H = ad + (Number(ac.time[0]) * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                    e = (Y + this.y) - (ac.kaplanMeier[0] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                    aN = (Y + this.y) - (ac.upperLimit[0] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                    aa = (Y + this.y) - (ac.lowerLimit[0] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                    aS = J;
                                    aF = g;
                                    aX = e - this.margin;
                                    aV = e + this.margin;
                                    aG = this.toRender({
                                        p: ["drawLine", "line", J, g, H, g, N],
                                        a: this.getLineArea("line", J, g, H, g, N),
                                        i: ["Decor-KM-h-0-" + ah],
                                        b: [aS, aF, aS, aF],
                                        t: "Decorations"
                                    });
                                    this.toRender({
                                        p: ["drawShape", "circle", H, e, 1, 1, N],
                                        a: this.getShapeArea("circle", H, e, 1, 1, N),
                                        i: ["Decor-KM-x-0-" + ah],
                                        g: aG,
                                        b: [aS, aF],
                                        t: "Decorations"
                                    });
                                    this.toRender({
                                        p: ["drawLine", "line", H, g, H, e, N],
                                        a: this.getLineArea("line", H, g, H, e, N),
                                        i: ["Decor-KM-v-0-" + ah],
                                        g: aG,
                                        b: [aS, aF, aS, aF],
                                        t: "Decorations"
                                    });
                                    if (ac.nCensored[0]) {
                                        this.toRender({
                                            p: ["drawLine", "line", H, aX, H, aV, N, 2],
                                            a: this.getLineArea("line", H, aX, H, aV, N, 2),
                                            i: ["Decor-KM-c-0-" + ah],
                                            g: aG,
                                            b: [aS, aF, aS, aF],
                                            t: "Decorations"
                                        })
                                    }
                                    aq[0].push(J, H);
                                    aq[1].push(aN, aN);
                                    aR[0].push(J, H);
                                    aR[1].push(aa, aa);
                                    for (var ag = 1; ag < ac.time.length - 1; ag++) {
                                        J = ad + (Number(ac.time[ag - 1]) * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                        g = (Y + this.y) - (ac.kaplanMeier[ag] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        aP = (Y + this.y) - (ac.upperLimit[ag] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        ab = (Y + this.y) - (ac.lowerLimit[ag] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        H = ad + (Number(ac.time[ag]) * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                        e = (Y + this.y) - (ac.kaplanMeier[ag + 1] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        aN = (Y + this.y) - (ac.upperLimit[ag + 1] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        aa = (Y + this.y) - (ac.lowerLimit[ag + 1] * this.yAxisUnit) + (this.yAxisMin * this.yAxisUnit);
                                        aX = e - this.margin;
                                        aV = e + this.margin;
                                        this.toRender({
                                            p: ["drawLine", "line", J, g, H, g, N],
                                            a: this.getLineArea("line", J, g, H, g, N),
                                            i: ["Decor-KM-h-" + ag + "-" + ah],
                                            g: aG,
                                            b: [aS, aF, aS, aF],
                                            t: "Decorations"
                                        });
                                        this.toRender({
                                            p: ["drawShape", "circle", H, e, 1, 1, N],
                                            a: this.getShapeArea("circle", H, e, 1, 1, N),
                                            i: ["Decor-KM-x-" + ag + "-" + ah],
                                            g: aG,
                                            b: [aS, aF],
                                            t: "Decorations"
                                        });
                                        this.toRender({
                                            p: ["drawLine", "line", H, g, H, e, N],
                                            a: this.getLineArea("line", H, g, H, e, N),
                                            i: ["Decor-KM-v-" + ag + "-" + ah],
                                            g: aG,
                                            b: [aS, aF, aS, aF],
                                            t: "Decorations"
                                        });
                                        if (ac.nCensored[ag]) {
                                            this.toRender({
                                                p: ["drawLine", "line", H, aX, H, aV, N, 2],
                                                a: this.getLineArea("line", H, aX, H, aV, N, 2),
                                                i: ["Decor-KM-c-" + ag + "-" + ah],
                                                g: aG,
                                                b: [aS, aF, aS, aF],
                                                t: "Decorations"
                                            })
                                        }
                                        aq[0].push(J, H, H);
                                        aq[1].push(aP, aP, aN);
                                        aR[0].push(J, H, H);
                                        aR[1].push(ab, ab, aa)
                                    }
                                    J = H;
                                    H = ad + (Number(ac.time[ag]) * this.xAxisUnit) - (this.xAxisMin * this.xAxisUnit);
                                    this.toRender({
                                        p: ["drawLine", "line", J, e, H, e, N],
                                        a: this.getLineArea("line", J, e, H, e, N),
                                        i: ["Decor-KM-h-" + ag + "-" + ah],
                                        g: aG,
                                        b: [aS, aF, aS, aF],
                                        t: "Decorations"
                                    });
                                    aq[0].push(H, H);
                                    aq[1].push(aN, aN);
                                    aR[0].push(H, H);
                                    aR[1].push(aa, aa);
                                    if (this.showConfidenceIntervals) {
                                        aT[0] = aq[0].concat(aR[0].reverse());
                                        aT[1] = aq[1].concat(aR[1].reverse());
                                        this.toRender({
                                            p: ["drawShape", "polygon", aT[0], aT[1], false, false, I, I, "closed"],
                                            a: this.getShapeArea("polygon", aT[0], aT[1], false, false, I, I, "closed"),
                                            i: ["Decor-KM-Conf" + ah],
                                            t: "Decorations"
                                        })
                                    }
                                }
                            }
                        }
                    }
                }
            } else {
                if (al.line) {
                    for (var ah = 0; ah < al.line.length; ah++) {
                        var J, g, H, e;
                        var au = true;
                        var ap = al.line[ah].type || "line";
                        var B = al.line[ah].color;
                        var V = this.transformValue(this.isTransformedData, al.line[ah].value || 0);
                        var o = al.line[ah].label || false;
                        var aE = al.line[ah].width || 1;
                        var aO = al.line[ah].align || "left";
                        var ay = al.line[ah].scope || false;
                        if (this.graphOrientation == "vertical") {
                            J = this.marginLeft + this.offsetX + this.left;
                            H = J + this.x;
                            g = this.marginTop + this.offsetY + this.top + this.y - ((V - this.xAxisMin) * this.xAxisUnit);
                            e = g;
                            au = g <= this.marginTop + this.offsetY + this.top + this.y && g >= this.marginTop + this.offsetY + this.top ? true : false
                        } else {
                            J = this.marginLeft + this.offsetX + this.left + ((V - this.xAxisMin) * this.xAxisUnit);
                            H = J;
                            g = this.marginTop + this.offsetY + this.top;
                            e = g + this.y;
                            au = J <= this.marginLeft + this.offsetX + this.left + this.x && this.marginLeft + this.offsetX + this.left ? true : false
                        }
                        if (au && ay) {
                            if (this.layoutValid) {
                                au = false;
                                var W = this.toArray(this.data.l.name[this.layoutCurrent]);
                                for (var ag = 0; ag < W.length; ag++) {
                                    if (ay == W[ag]) {
                                        au = true
                                    }
                                }
                            }
                        }
                        if (au) {
                            var P = this.isR ? 6 : 3;
                            if (o) {
                                if (this.graphOrientation == "vertical") {
                                    if (aO == "right") {
                                        this.toRender({
                                            p: ["drawText", o, H - this.margin, e - this.margin, this.decorationFont, this.decorationColor, "right", "bottom"],
                                            t: "Decorations"
                                        })
                                    } else {
                                        if (aO == "center") {
                                            this.toRender({
                                                p: ["drawText", o, J + (this.x / 2), e - this.margin, this.decorationFont, this.decorationColor, "center", "bottom"],
                                                t: "Decorations"
                                            })
                                        } else {
                                            this.toRender({
                                                p: ["drawText", o, J + this.margin, e - this.margin, this.decorationFont, this.decorationColor, "left", "bottom"],
                                                t: "Decorations"
                                            })
                                        }
                                    }
                                } else {
                                    if (aO == "right") {
                                        this.toRender({
                                            p: ["drawText", o, H + (this.margin * 2), e - (this.margin * P), this.decorationFont, this.decorationColor, "left", "middle"],
                                            t: "Decorations"
                                        })
                                    } else {
                                        if (aO == "center") {
                                            this.toRender({
                                                p: ["drawText", o, H + (this.margin * 2), g + (this.y / 2), this.decorationFont, this.decorationColor, "left", "middle"],
                                                t: "Decorations"
                                            })
                                        } else {
                                            this.toRender({
                                                p: ["drawText", o, H + (this.margin * 2), g + (this.margin * P), this.decorationFont, this.decorationColor, "left", "middle"],
                                                t: "Decorations"
                                            })
                                        }
                                    }
                                }
                            }
                            var ar = al.line[ah].tooltip || ("&rarr; " + V);
                            this.toRender({
                                p: ["drawLine", ap, J, g, H, e, B, aE],
                                a: this.getLineArea(ap, J, g, H, e, B, aE),
                                i: [ar + ":Decor-Line" + ah],
                                t: "Decorations"
                            })
                        }
                    }
                }
                if (al.marker) {
                    this.drawMarkers()
                }
            }
        }
        this.toRender({
            p: ["resetClipArea"],
            t: "Decorations"
        })
    };
    this.drawOncoprintLegend = function() {
        if (this.isOncoprint) {
            var b = (this.width / 2) - (this.legendOncoprintWidth / 2);
            var p = this.height - (this.marginBottom + this.legendOncoprintHeight - this.margin);
            var a = 0;
            var o = this.legendOncoprintWidth / this.legendOncoprintCols;
            var k = 2;
            this.toRender({
                p: ["drawShape", "rect", this.width / 2, p + (this.legendOncoprintHeight / 2) - this.margin, this.legendOncoprintWidth, this.legendOncoprintHeight, this.background, this.background],
                a: this.getShapeArea("rect", this.width / 2, p + (this.legendOncoprintHeight / 2) - this.margin, this.legendOncoprintWidth, this.legendOncoprintHeight, this.background, this.background),
                i: [-1],
                m: ["-legend-oncoprint"],
                t: "Legends"
            });
            for (var g = 0; g < this.legendOncoprintRows; g++) {
                var d = b;
                for (var e = 0; e < this.legendOncoprintCols; e++) {
                    if (a < this.legendOncoprintLabels.length) {
                        var h = this.legendOncoprintLabels[a];
                        var m = this.legendOncoprintObjects[a];
                        if (a < this.legendOncoprintMutations) {
                            this.toRender({
                                p: ["drawShape", "rect", d + 2.5, p + 10.5, 5, 21, this.legendOncoprintColors[h]],
                                a: this.getShapeArea("rect", d + 2.5, p + 10.5, 5, 21, this.legendOncoprintColors[h]),
                                i: ["Onc-" + h + "-" + m],
                                t: "Legends"
                            });
                            d += 5 + this.margin;
                            this.toRender({
                                p: ["drawText", h, d, p + 10.5 + k, this.legendFont, this.legendColor, "left", "middle"],
                                t: "Legends"
                            });
                            d += o
                        } else {
                            this.toRender({
                                p: ["drawShape", "rect", d + 2.5, p + 10.5, 5, 21, "rgb(220,220,220"],
                                a: this.getShapeArea("rect", d + 2.5, p + 10.5, 5, 21, "rgb(220,220,220"),
                                i: ["Onc-" + h + "-" + m],
                                t: "Legends"
                            });
                            this.toRender({
                                p: ["drawShape", "rect", d + 2.5, p + 10.5, 5, 7, this.legendOncoprintColors[h]],
                                a: this.getShapeArea("rect", d + 2.5, p + 10.5, 5, 7, this.legendOncoprintColors[h]),
                                i: ["Onc-" + h + "-" + m],
                                t: "Legends"
                            });
                            d += 5 + this.margin;
                            this.toRender({
                                p: ["drawText", h, d, p + 10.5 + k, this.legendFont, this.legendColor, "left", "middle"],
                                t: "Legends"
                            });
                            d += o
                        }
                        a++
                    }
                }
                p += 21 + this.margin
            }
        }
    };
    this.drawSampleLegend = function(z, d) {
        var f = this;
        var c = function(i, j) {
            if (f.isCreateHistogram) {
                if (f.isCreateHistogram.colors.length < f.legendSamplesN && f.isCreateHistogram.factor) {
                    if (f.cacheColors[f.colorScheme].hasOwnProperty(j)) {
                        return f.cacheColors[f.colorScheme][j]
                    } else {
                        return k[f.isCreateHistogram.factor].colors ? k[f.isCreateHistogram.factor].colors[i] : f.colors[i % f.colors.length]
                    }
                } else {
                    if (f.isCreateHistogram.colors.length == f.legendSamplesN) {
                        return f.isCreateHistogram.colors[i]
                    } else {
                        return f.cacheColors[f.colorScheme].hasOwnProperty(j) ? f.cacheColors[f.colorScheme][j] : f.colors[i % f.colors.length]
                    }
                }
            } else {
                return f.colors[i % f.colors.length]
            }
        };
        var v = function(j) {
            if (f.isCreateHistogram) {
                if (!f.xAxisIndices.length && !f.yAxisIndices.length) {
                    var i;
                    if (f.isHistogramLayout()) {
                        i = f.getSampleIndices(b[j]);
                        if (i < 0) {
                            i = j + 1
                        }
                    } else {
                        i = f.getSampleIndices(f.data.l.axes[0].yAxis[j])
                    }
                    return "Series:0:" + i
                } else {
                    if (f.data.l && f.data.l.axes && f.data.l.axes[u] && f.data.l.axes[u].yAxis && f.data.l.axes[u].yAxis[s] && !f.data.l.axes[u].yAxis[s].match(":")) {
                        return "Series:0:" + f.data.l.ids[j + 1]
                    } else {
                        return f.xAxisIndices.length == f.yAxisIndices.length ? "Series:" + f.xAxisIndices[j] + ":" + f.yAxisIndices[j] : f.xAxisIndices.length > f.yAxisIndices.length ? "Series:" + f.xAxisIndices[j] + ":0" : "Series:0:" + f.yAxisIndices[j]
                    }
                }
            } else {
                return f.xAxisIndices.length == f.yAxisIndices.length ? "Series:" + f.xAxisIndices[j] + ":" + f.yAxisIndices[j] : f.xAxisIndices.length > f.yAxisIndices.length ? "Series:" + f.xAxisIndices[j] + ":0" : "Series:0:" + f.yAxisIndices[j]
            }
        };
        var p = z;
        var A = d;
        var t = 0;
        var o = this.getFontPt(this.legendFont);
        var r = (o - 1) / 2;
        d += this.margin + r;
        this.drawLegendBackgroundBox(p, A, this.legendSampleWidth, this.legendSampleHeight, true, "-legend-sample");
        var y = this.legendSampleWidth / this.legendColumns;
        var a = Math.ceil(this.legendSamplesN / this.legendColumns);
        var k = f.meta.data.z;
        var b = [];
        var x = {};
        if (this.ridgeBy) {
            for (var u = 0; u < a; u++) {
                for (var s = 0; s < this.legendColumns; s++) {
                    z = p + ((this.margin + y) * s);
                    if (t < this.legendSamplesN) {
                        var m = this.shortenText(this.dataStndBy.y.smps[t], this.maxSmpStringLen);
                        var e = this.colors[t % this.colors.length];
                        var B = "Series:0:" + t;
                        var g = z + r + this.margin;
                        this.toRender({
                            p: ["drawShape", "circle", g, d, o - 1, o - 1, this.getFillColor(e), this.getOutlineColor(e), "solid"],
                            a: this.getShapeArea("circle", g, d, o - 1, o - 1, this.getFillColor(e), this.getOutlineColor(e), "solid"),
                            i: [B],
                            t: "Legends",
                            h: this.isHidden(false, false, B)
                        });
                        this.toRender({
                            p: ["drawText", m, g + r + this.margin, d, this.legendFont, this.legendColor, "left", "middle"],
                            a: this.getTextArea(m, g + r + this.margin, d, this.legendFont, this.legendColor, "left", "middle"),
                            i: [B],
                            t: "Legends",
                            h: this.isHidden(false, false, B)
                        });
                        t++
                    }
                }
                d += o + this.margin
            }
        } else {
            if (this.isHistogram && this.isHistogramLayout()) {
                for (var u = 0; u < this.data.l.axes.length; u++) {
                    for (var s = 0; s < this.data.l.axes[u].yAxis.length; s++) {
                        if (this.data.l.axes[u].yAxis[s]) {
                            if (this.segregateVariablesBy.length || !this.data.l.axes[u].yAxis[s].match(":")) {
                                x[this.data.l.axes[u].yAxis[s].split(":")[0]] = true
                            } else {
                                if (this.data.l.axes.length == this.dataStndBy.y.smps.length) {
                                    x[this.data.l.axes[u].yAxis[s].split(":")[1]] = true
                                } else {
                                    x[this.data.l.axes[u].yAxis[s]] = true
                                }
                            }
                        }
                    }
                }
                b = this.getKeys(x)
            }
        }
        if (!this.ridgeBy) {
            for (var u = 0; u < a; u++) {
                for (var s = 0; s < this.legendColumns; s++) {
                    z = p + ((this.margin + y) * s);
                    if (t < this.legendSamplesN) {
                        var q = 0;
                        var h = this.getPropertyValue(u, false, "patternBy");
                        var l = this.xAxisIndices.length == this.yAxisIndices.length ? this.yAxis[t] : this.xAxisIndices.length > this.yAxisIndices.length ? this.yAxis[this.yAxisCurrent] : this.yAxis[t];
                        var n = this.xAxisIndices.length == this.yAxisIndices.length ? this.xAxis[t] : this.xAxisIndices.length > this.yAxisIndices.length ? this.xAxis[t] : this.xAxis[this.xAxisCurrent];
                        var B = v(t);
                        var m = this.isHistogramLayout() ? b[t] : this.isHistogram ? this.shortenText(l, this.maxSmpStringLen) : this.shortenText(l, this.maxSmpStringLen) + " vs " + this.shortenText(n, this.maxSmpStringLen);
                        var e = c(t, m);
                        var g = z + r + this.margin;
                        var w = d + r + this.margin;
                        if (this.isCreateHistogram) {
                            this.toRender({
                                p: ["drawShape", this.shapes[q], g, d, o - 1, o - 1, this.getFillColor(e), this.getOutlineColor(e), h],
                                a: this.getShapeArea(this.shapes[q], g, d, o - 1, o - 1, this.getFillColor(e), this.getOutlineColor(e), h),
                                i: [B],
                                t: "Legends",
                                h: this.isHidden(false, false, B)
                            })
                        } else {
                            if (this.colorBy) {
                                this.toRender({
                                    p: ["drawShape", this.shapes[q], g, d, o - 1, o - 1, false, this.getFillColor(e), "open"],
                                    a: this.getShapeArea(this.shapes[q], g, d, o - 1, o - 1, false, this.getFillColor(e), "open"),
                                    i: [B],
                                    t: "Legends",
                                    h: this.isHidden(false, false, B)
                                })
                            } else {
                                this.toRender({
                                    p: ["drawShape", this.shapes[q], g, d, o - 1, o - 1, this.getFillColor(e), this.getOutlineColor(e), h],
                                    a: this.getShapeArea(this.shapes[q], g, d, o - 1, o - 1, this.getFillColor(e), this.getOutlineColor(e), h),
                                    i: [B],
                                    t: "Legends",
                                    h: this.isHidden(false, false, B)
                                })
                            }
                        }
                        this.toRender({
                            p: ["drawText", m, g + r + this.margin, d, this.legendFont, this.legendColor, "left", "middle"],
                            a: this.getTextArea(m, g + r + this.margin, d, this.legendFont, this.legendColor, "left", "middle"),
                            i: [B],
                            t: "Legends",
                            h: this.isHidden(false, false, B)
                        })
                    } else {
                        break
                    }
                    t++
                }
                d += o + this.margin
            }
        }
        this.drawLegendBackgroundBox(p, A, this.legendSampleWidth, this.legendSampleHeight)
    };
    this.drawVariableLegend = function(p, a) {
        var D = p;
        var t = a;
        var k = this.getFontPt(this.legendFont);
        var f = k / 2;
        var M = k * 2;
        var e = k * 1.5;
        var u = 0;
        var C = this;
        var L = this.layoutValid && !this.isDOE && this.isOneDimensionalGraph() && this.meta.config.user.graphType != this.graphType ? this.meta.config.user.graphType : this.graphType;
        var F = function(g) {
            if (g < C.xAxisVarIndices.length) {
                return C.colors[g % C.colors.length]
            } else {
                return C.colors[(g - C.xAxisVarIndices.length) % C.colors.length]
            }
        };
        if (this.legendVariableWidth == 0 || this.legendVariableHeight == 0) {
            return
        } else {
            if (L == "Circular" && this.circularType == "sunburst") {
                return
            } else {
                if (L == "Pie") {
                    var n = !this.layoutComb ? this.width - (p + (this.margin * 1.5)) : this.isDOE ? this.layoutWidth - ((p - this.offsetX) + (this.margin * 1.5)) : 999999;
                    if (this.isDOE && this.legendVariableWidth > n) {
                        this.legendVariableWidth = n
                    }
                    this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight, true, "-legend-variable");
                    p += f + (this.margin * 2);
                    a += k;
                    for (var J = 0; J < this.varPie.ids.length; J++) {
                        var I = false;
                        var z = this.varPie.ids[J];
                        var l = this.varPie.cols[J];
                        var G = z > -1 ? this.shortenText(this.data.y.vars[z], this.maxVarStringLen) : "Other";
                        this.toRender({
                            p: ["drawShape", this.useRoundRectangles ? "roundrect" : "square", p, a, k, k, this.getFillColor(l), this.getOutlineColor(l), "closed"],
                            a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "square", p, a, k, k, this.getFillColor(l), this.getOutlineColor(l), "closed"),
                            i: ["PieVar-" + z],
                            t: "Legends",
                            h: this.isHidden(false, false, "Var-" + z)
                        });
                        if (n > 0) {
                            while ((this.measureText(G, this.legendFont) + k + (this.margin * 3)) > n && G.length > 1) {
                                G = G.substring(0, G.length - 1);
                                I = true
                            }
                            if (I) {
                                G = G + "..."
                            }
                            this.toRender({
                                p: ["drawText", G, p + k, a, this.legendFont, this.legendColor, "left", "middle"],
                                a: this.getTextArea(G, p + k, a, this.legendFont, this.legendColor, "left", "middle"),
                                i: ["PieVar-" + z],
                                t: "Legends",
                                h: this.isHidden(false, false, "Var-" + z)
                            })
                        }
                        a += k + this.margin;
                        if (this.layoutComb) {
                            if ((a - this.offsetY) > this.layoutHeight) {
                                this.toRender({
                                    p: ["drawText", "...", p + k, a, this.legendFont, this.legendColor, "left", "bottom"],
                                    t: "Legends"
                                });
                                break
                            }
                        } else {
                            if (a > this.height) {
                                this.toRender({
                                    p: ["drawText", "...", p + k, a, this.legendFont, this.legendColor, "left", "bottom"],
                                    t: "Legends"
                                });
                                break
                            }
                        }
                    }
                    this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight)
                } else {
                    if ((this.colorBy && this.colorBy == "variable") || (this.shapeBy && this.shapeBy == "variable") || (this.sizeBy && this.sizeBy == "variable") || (this.patternBy && this.patternBy == "variable")) {
                        this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight, true, "-legend-variable");
                        var x = this.sizeBy && this.sizeBy == "variable" ? Math.max(this.sizes[this.varIndices.length - 1], k) : k;
                        var b = x / 2;
                        var o = this.legendVariableWidth / this.legendColumns;
                        var w = Math.ceil(this.varIndices.length / this.legendColumns);
                        a += (this.margin * 3);
                        for (var J = 0; J < w; J++) {
                            for (var H = 0; H < this.legendColumns; H++) {
                                p = D + (this.margin + (o * H));
                                if (u < this.varIndices.length) {
                                    var z = this.varIndices[u];
                                    var l = L == "Circular" || (this.colorBy && this.colorBy == "variable") ? u % this.colors.length : 0;
                                    var y = this.shapeBy && this.shapeBy == "variable" ? u % this.shapes.length : 0;
                                    var d = this.sizeBy && this.sizeBy == "variable" ? this.sizes[u % this.sizes.length] : x;
                                    var h = this.patternBy && this.patternBy == "variable" ? this.patterns[u % this.patterns.length] : this.getPropertyValue(z, false, "patternBy");
                                    var B = p + b;
                                    var q = a + b;
                                    var G = this.shortenText(this.data.y.vars[z], this.maxVarStringLen);
                                    var A = this.isHidden(false, false, "Var-" + z);
                                    if (this.colorBy && this.colorBy != "variable") {
                                        this.toRender({
                                            p: ["drawShape", this.shapes[y], B, a, d, d, this.background, this.foreground, h],
                                            a: this.getShapeArea(this.shapes[y], B, a, d, d, this.background, this.foreground, h),
                                            i: ["Var-" + z],
                                            t: "Legends",
                                            h: A
                                        })
                                    } else {
                                        this.toRender({
                                            p: ["drawShape", this.shapes[y], B, a, d, d, this.getFillColor(this.colors[l]), this.getOutlineColor(this.colors[l]), h],
                                            a: this.getShapeArea(this.shapes[y], B, a, d, d, this.getFillColor(this.colors[l]), this.getOutlineColor(this.colors[l]), h),
                                            i: ["Var-" + z],
                                            t: "Legends",
                                            h: A
                                        })
                                    }
                                    this.toRender({
                                        p: ["drawText", G, B + b + this.margin, a, this.legendFont, this.legendColor, "left", "middle"],
                                        a: this.getTextArea(G, B + b + this.margin, a, this.legendFont, this.legendColor, "left", "middle"),
                                        i: ["Var-" + z],
                                        t: "Legends",
                                        h: A
                                    })
                                } else {
                                    break
                                }
                                u++
                            }
                            a += x + this.margin
                        }
                        this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight)
                    } else {
                        if (L == "BarLine" || L == "DotLine" || L == "AreaLine" || L == "StackedLine" || L == "StackedPercentLine") {
                            this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight, true, "-legend-variable");
                            var c = this.xAxisVarIndices.concat(this.xAxis2VarIndices);
                            var o = this.legendVariableWidth / this.legendColumns;
                            var w = Math.ceil(c.length / this.legendColumns);
                            a += (this.margin * 2);
                            for (var J = 0; J < w; J++) {
                                for (var H = 0; H < this.legendColumns; H++) {
                                    p = D + this.margin + (o * H);
                                    if (u < c.length) {
                                        var z = u < this.xAxisVarIndices.length ? this.xAxisVarIndices[u] : this.xAxis2VarIndices[u - this.xAxisVarIndices.length];
                                        var l = this.theme == "blackAndWhite" ? "rgb(0,0,0)" : this.coordinateLineColor ? F(u) : this.getVariableColor(this.data.y.vars[z]);
                                        var h = this.getPropertyValue(z, false, "patternBy");
                                        var G = this.shortenText(this.data.y.vars[z], this.maxVarStringLen);
                                        var A = this.isHidden(false, false, "Var-" + z);
                                        if (u < this.xAxisVarIndices.length) {
                                            var s = L == "DotLine" ? "circle" : this.useRoundRectangles ? "roundrect" : "rectangle";
                                            var K;
                                            if (this.lineDecoration == "pattern") {
                                                K = this.toRender({
                                                    p: ["drawShape", s, p + (k / 2), a + (k / 2), k, k, "rgba(0,0,0,0)", "rgba(0,0,0,0)", h],
                                                    a: this.getShapeArea(s, p + (k / 2), a + (k / 2), k, k, "rgba(0,0,0,0)", "rgba(0,0,0,0)", h),
                                                    i: ["Var-" + z],
                                                    t: "Legends",
                                                    h: A
                                                })
                                            } else {
                                                K = this.toRender({
                                                    p: ["drawShape", s, p + (k / 2), a + (k / 2), k, k, this.getFillColor(l), this.getOutlineColor(l), h],
                                                    a: this.getShapeArea(s, p + (k / 2), a + (k / 2), k, k, this.getFillColor(l), this.getOutlineColor(l), h),
                                                    i: ["Var-" + z],
                                                    t: "Legends",
                                                    h: A
                                                })
                                            }
                                            this.toRender({
                                                p: ["drawText", G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"],
                                                a: this.getTextArea(G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"),
                                                i: ["Var-" + z],
                                                g: K,
                                                t: "Legends",
                                                h: A
                                            })
                                        } else {
                                            var r = this.lineDecoration == "pattern" ? this.linePatterns[u % this.linePatterns.length] : "line";
                                            var K = this.toRender({
                                                p: ["drawLine", r, p, a + f, p + k, a + f, l, 2],
                                                a: this.getLineArea("line", p, a + f, p + k, a + f, l, 2),
                                                i: ["Var-" + z],
                                                t: "Legends",
                                                h: A
                                            });
                                            if (this.lineDecoration && this.lineDecoration != "pattern" && !this.segregateVariablesBy.length && L != "DotLine" && L != "AreaLine") {
                                                this.toRender({
                                                    p: ["drawShape", this.lineDecoration == "symbol" ? this.shapes[(u - this.xAxisVarIndices.length) % this.shapes.length] : "circle", p + f, a + f, f, f, l, this.foreground, h],
                                                    a: this.getShapeArea(this.lineDecoration == "symbol" ? this.shapes[(u - this.xAxisVarIndices.length) % this.shapes.length] : "circle", p + f, a + f, f, f, l, this.foreground, h),
                                                    i: ["Var-" + z],
                                                    g: K,
                                                    t: "Legends",
                                                    h: A
                                                })
                                            }
                                            this.toRender({
                                                p: ["drawText", G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"],
                                                a: this.getTextArea(G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"),
                                                i: ["Var-" + z],
                                                g: K,
                                                t: "Legends",
                                                h: A
                                            })
                                        }
                                    } else {
                                        break
                                    }
                                    u++
                                }
                                a += e
                            }
                            this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight)
                        } else {
                            if (L == "Bar" || L == "Line" || L == "ParallelCoordinates" || L == "Area" || L == "Dotplot" || L == "Stacked" || L == "StackedPercent" || L == "Boxplot" || L == "Fish") {
                                this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight, true, "-legend-variable");
                                var o = this.legendVariableWidth / Math.min(this.varIndices.length, this.legendColumns);
                                var w = Math.ceil(this.varIndices.length / Math.min(this.varIndices.length, this.legendColumns));
                                a += (this.margin * 2);
                                for (var J = 0; J < w; J++) {
                                    for (var H = 0; H < Math.min(this.varIndices.length, this.legendColumns); H++) {
                                        p = D + this.margin + (o * H);
                                        if (u < this.varIndices.length) {
                                            var z = this.varIndices[u];
                                            var l = this.theme == "blackAndWhite" && L == "Line" ? "rgb(0,0,0)" : this.getFillColor(this.getVariableColor(this.data.y.vars[z]));
                                            var E = this.getOutlineColor(l);
                                            var h = this.getPropertyValue(z, false, "patternBy");
                                            var G = this.shortenText(this.data.y.vars[z], this.maxVarStringLen);
                                            var A = this.isHidden(false, false, "Var-" + z);
                                            var K = null;
                                            if (L == "Line" || L == "ParallelCoordinates") {
                                                var r = this.lineDecoration == "pattern" ? this.linePatterns[u % this.linePatterns.length] : this.lineType;
                                                K = this.toRender({
                                                    p: ["drawLine", r, p, a + f, p + k, a + f, l, 2],
                                                    a: this.getLineArea("line", p, a + f, p + k, a + f, l, 2),
                                                    i: ["Var-" + z],
                                                    g: K,
                                                    t: "Legends",
                                                    h: A
                                                });
                                                if (this.lineDecoration && this.lineDecoration != "pattern" && !this.segregateVariablesBy.length) {
                                                    this.toRender({
                                                        p: ["drawShape", this.lineDecoration == "symbol" ? this.shapes[u % this.shapes.length] : "circle", p + f, a + f, f, f, l, E, h],
                                                        a: this.getShapeArea(this.lineDecoration == "symbol" ? this.shapes[u % this.shapes.length] : "circle", p + f, a + f, f, f, l, E, h),
                                                        i: ["Var-" + z],
                                                        g: K,
                                                        t: "Legends",
                                                        h: A
                                                    })
                                                }
                                            } else {
                                                if (L == "Dotplot" || (L == "Boxplot" && this.showBoxplotOriginalData)) {
                                                    if (this.shapeBy) {
                                                        K = this.toRender({
                                                            p: ["drawShape", this.shapes[u % this.shapes.length], p + f, a + f, k, k, l, E, h],
                                                            a: this.getShapeArea(this.shapes[u % this.shapes.length], p + f, a + f, k, k, l, E, h),
                                                            i: ["Var-" + z],
                                                            g: K,
                                                            t: "Legends",
                                                            h: A
                                                        })
                                                    } else {
                                                        K = this.toRender({
                                                            p: ["drawShape", "circle", p + f, a + f, k, k, l, E, h],
                                                            a: this.getShapeArea("circle", p + f, a + f, k, k, l, E, h),
                                                            i: ["Var-" + z],
                                                            g: K,
                                                            t: "Legends",
                                                            h: A
                                                        })
                                                    }
                                                } else {
                                                    K = this.toRender({
                                                        p: ["drawShape", this.useRoundRectangles ? "roundrect" : "rectangle", p + (k / 2), a + (k / 2), k, k, l, E, h],
                                                        a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "rectangle", p + (k / 2), a + (k / 2), k, k, l, E, h),
                                                        i: ["Var-" + z],
                                                        g: K,
                                                        t: "Legends",
                                                        h: A
                                                    });
                                                    if (L == "Boxplot" && (!this.showBoxplotOriginalData || this.boxplotColor)) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", p, a + (k / 2), p + k, a + (k / 2), this.foreground],
                                                            t: "Legends",
                                                            g: K,
                                                            h: A
                                                        });
                                                        this.toRender({
                                                            p: ["drawLine", "line", p + (k / 2), a, p + (k / 2), a - this.margin, this.foreground],
                                                            t: "Legends",
                                                            g: K,
                                                            h: A
                                                        });
                                                        this.toRender({
                                                            p: ["drawLine", "line", p + (k / 2), a + k, p + (k / 2), a + k + this.margin, this.foreground],
                                                            t: "Legends",
                                                            g: K,
                                                            h: A
                                                        })
                                                    }
                                                }
                                            }
                                            this.toRender({
                                                p: ["drawText", G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"],
                                                a: this.getTextArea(G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"),
                                                i: ["Var-" + z],
                                                g: K,
                                                t: "Legends",
                                                h: A
                                            })
                                        } else {
                                            break
                                        }
                                        u++
                                    }
                                    a += e
                                }
                                this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight)
                            } else {
                                if (L == "Circular" && !this.showIdeogram) {
                                    var m = this.r / 2.7;
                                    if (this.legendVariableWidth > m || this.legendVariableHeight > m) {}
                                    this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight, true, "-legend-variable");
                                    var v = [];
                                    if (this.rAxisIndex >= 0) {
                                        for (var J = 0; J < this.varIndices.length; J++) {
                                            if (J == this.rAxisIndex) {
                                                continue
                                            }
                                            v.push(this.varIndices[J])
                                        }
                                    } else {
                                        v = this.varIndices
                                    }
                                    var o = this.legendVariableWidth / this.legendColumns;
                                    var w = Math.ceil(v.length / this.legendColumns);
                                    a += (this.margin * 2);
                                    for (var J = 0; J < w; J++) {
                                        for (var H = 0; H < this.legendColumns; H++) {
                                            p = D + this.margin + (o * H);
                                            if (u < v.length) {
                                                var z = v[u];
                                                var l = this.colors[u % this.colors.length];
                                                var h = this.getPropertyValue(z, false, "patternBy");
                                                var G = this.shortenText(this.data.y.vars[z], this.maxVarStringLen);
                                                this.toRender({
                                                    p: ["drawShape", this.useRoundRectangles ? "roundrect" : "rectangle", p + (k / 2), a + (k / 2), k, k, this.getFillColor(l), this.getOutlineColor(l), h],
                                                    a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "rectangle", p + (k / 2), a + (k / 2), k, k, this.getFillColor(l), this.getOutlineColor(l), h),
                                                    i: ["Var-" + z],
                                                    t: "Legends",
                                                    h: this.isHidden(false, false, "Var-" + z)
                                                });
                                                this.toRender({
                                                    p: ["drawText", G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"],
                                                    a: this.getTextArea(G, p + M, a + f, this.legendFont, this.legendColor, "left", "middle"),
                                                    i: ["VarLbl-" + z],
                                                    t: "Legends",
                                                    h: this.isHidden(false, false, "VarLbl-" + z)
                                                })
                                            } else {
                                                break
                                            }
                                            u++
                                        }
                                        a += e
                                    }
                                    this.drawLegendBackgroundBox(D, t, this.legendVariableWidth, this.legendVariableHeight)
                                }
                            }
                        }
                    }
                }
            }
        }
    };
    this.drawVennLegend = function() {
        if (this.showLegend) {
            var j = this.getFontPt(this.legendFont);
            var d = this.vennMarginLeft + this.marginLeft + this.left;
            var c = d + (j * 2);
            var g = this.vennMarginTop + this.marginTop + this.top + this.y + this.margin + (j / 2);
            var h = [];
            var a = [];
            for (var f in this.data.venn.legend) {
                a.push(f)
            }
            a = a.sort();
            if (this.vennGroups == 4) {
                h.push(this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(255,0,0)");
                h.push(this.vennColors.length > 1 && this.validateColor(this.vennColors[1]) ? this.validateColor(this.vennColors[1]) : "rgb(0,153,51)");
                h.push(this.vennColors.length > 2 && this.validateColor(this.vennColors[2]) ? this.validateColor(this.vennColors[3]) : "rgb(153,204,0)");
                h.push(this.vennColors.length > 3 && this.validateColor(this.vennColors[3]) ? this.validateColor(this.vennColors[2]) : "rgb(0,0,255)")
            } else {
                if (this.vennGroups == 3) {
                    h.push(this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(255,0,0)");
                    h.push(this.vennColors.length > 1 && this.validateColor(this.vennColors[1]) ? this.validateColor(this.vennColors[1]) : "rgb(0,255,0)");
                    h.push(this.vennColors.length > 2 && this.validateColor(this.vennColors[2]) ? this.validateColor(this.vennColors[2]) : "rgb(0,0,255)")
                } else {
                    if (this.vennGroups == 2) {
                        h.push(this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(0,0,255)");
                        h.push(this.vennColors.length > 1 && this.validateColor(this.vennColors[1]) ? this.validateColor(this.vennColors[1]) : "rgb(255,0,0)")
                    } else {
                        h.push(this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(255,0,0)")
                    }
                }
            }
            for (var f = 0; f < this.vennGroups; f++) {
                if (!this.vennLegendColors) {
                    this.toRender({
                        p: ["drawText", a[f] + ": ", d, g, this.legendFont, this.legendColor, "left", "middle"],
                        t: "Legends"
                    })
                }
                var b = this.data.venn.legend && this.data.venn.legend[a[f]] ? this.data.venn.legend[a[f]] : "N/A";
                var e = (this.measureText(b, this.legendFont) > this.x) ? this.scaleTextToFont(b, j, this.x - this.margin) : this.legendFont;
                if (!this.vennLegendColors) {
                    this.toRender({
                        p: ["drawText", b, c, g, e, this.legendColor, "left", "middle"],
                        t: "Legends"
                    })
                } else {
                    this.toRender({
                        p: ["drawText", b, d, g, e, h[f], "left", "middle"],
                        t: "Legends"
                    })
                }
                g += this.margin + j
            }
        }
    };
    this.drawColorIndicator = function(A, d, o, G, D, f) {
        if (f || D || this.colorBy || this.outlineBy || this.colorNodeBy || this.colorEdgeBy || this.colorNodeBy || this.colorEdgeBy || (this.graphType == "Network" && this.decorations.length && this.decorationsType == "heatmap" && this.showDecorations && !this.colorNodeBy && !this.colorEdgeBy)) {
            var l = this;
            var h = function(H) {
                if (o.decs > 3) {
                    o.decs = l.getAxisDecimals(H[1] - H[0])
                }
                var j = [];
                for (var c = 0; c < H.length; c++) {
                    j[c] = H[c].toFixed(o.decs)
                }
                return j
            };
            var r = G || this.colorBy || this.outlineBy || this.colorNodeBy || this.colorEdgeBy;
            var n = f ? "-legend-" + f + "-color" : D ? "-legend-indicator-color" : "-legend-color";
            var g = f ? "overlaysLegendPosition" : D ? "heatmapIndicatorPosition" : "legendPosition";
            var F = f ? f : D ? 0 : this.legendColorWidth ? this.legendColorWidth / 2 : 10;
            var s = A;
            var E = d;
            var a = 0;
            var z = this.heatmapIndicatorHeight;
            var b = this.heatmapIndicatorHeight;
            var u = o.min;
            var x = o.max;
            var q = o.vals;
            var e = o.valStr ? o.valStr : o.colorBrew && o.colorBrew.valStr ? o.colorBrew.valStr : h(q);
            var p = this.heatmapIndicatorWidth / (x - u);
            var C = this.graphType == "Circular" ? o : o.colorBrew ? o.colorBrew : this.meta.def.colorBrew;
            var m = this.heatmapIndicatorWidth / this.colorSpectrumNumber;
            var t = g == "overlaysLegendPosition" && this[g] == "topRight" ? true : false;
            if (this[g] && this[g].toString().match(/top|bottom/) && !t) {
                if (r) {
                    if (this.showLegendTitle) {
                        this.toRender({
                            p: ["drawText", r, A + (this.heatmapIndicatorWidth / 2), d, this.legendFont, this.legendColor, "center", "top"],
                            t: "Legends"
                        })
                    }
                    a = this.margin + this.getFontPt(this.legendFont);
                    d += a
                }
                for (var w = 0; w < this.colorSpectrumNumber; w++) {
                    var B = this.transparency != null ? this.addColorTransparency(C.colors[w], this.transparency, true) : C.colors[w];
                    this.toRender({
                        p: ["drawLine", "line", A, d, A, d + b, B, Math.round(m + 1.5)],
                        t: "Legends"
                    });
                    A += m
                }
                A = s;
                d += b + this.margin;
                if (C && C.stops && C.stops.length) {
                    var y = 0;
                    for (var w = 0; w < C.stops.length; w++) {
                        for (var v = 0; v < this.colorSpectrumNumber; v++) {
                            if (C.breaks[v] >= C.stops[w]) {
                                A = s + (v * m);
                                var k = (this.measureText(this.formatNumber(C.stops[w].toString()), this.legendFont) / 2);
                                if (A - k > y || w == 0 || w == C.stops.length - 1) {
                                    this.toRender({
                                        p: ["drawText", this.formatNumber(C.stops[w]), A, d, this.legendFont, this.legendColor, "center", "top"],
                                        t: "Legends"
                                    });
                                    y = A + k
                                }
                                break
                            }
                        }
                    }
                } else {
                    for (var w = 0; w < q.length; w++) {
                        A = s + ((q[w] - u) * p);
                        this.toRender({
                            p: ["drawText", e[w], A, d, this.legendFont, this.legendColor, "center", "top"],
                            t: "Legends"
                        })
                    }
                }
                if (this.graphType == "Heatmap" && this.heatmapIndicatorHistogram) {
                    this.drawHeatmapIndicatorHistogram(s, E + a)
                }
            } else {
                if (r) {
                    if (this.showLegendTitle) {
                        this.toRender({
                            p: ["drawText", r, A + F + this.margin, d, this.legendFont, this.legendColor, "center", "top"],
                            t: "Legends"
                        })
                    }
                    d += (this.margin * 1.5) + this.getFontPt(this.legendFont)
                }
                d += (this.colorSpectrumNumber * m) - m;
                for (var w = 0; w < this.colorSpectrumNumber; w++) {
                    var B = this.transparency != null ? this.addColorTransparency(C.colors[w], this.transparency, true) : C.colors[w];
                    this.toRender({
                        p: ["drawLine", "line", A, d, A + z, d, B, Math.round(m + 1.5)],
                        t: "Legends"
                    });
                    d -= m
                }
                A += z;
                if (r) {
                    d = E + (this.margin * 1.5) + this.getFontPt(this.legendFont)
                } else {
                    d = E
                }
                if (C && C.stops && C.stops.length) {
                    d += this.colorSpectrumNumber * m;
                    var y = d;
                    for (var w = 0; w < C.stops.length; w++) {
                        for (var v = 0; v < this.colorSpectrumNumber; v++) {
                            if (C.breaks[v] >= C.stops[w]) {
                                b = d - (v * m);
                                if (b + this.legendFontSize < y || w == 0 || w == C.stops.length - 1) {
                                    this.toRender({
                                        p: ["drawText", this.formatNumber(C.stops[w]), A + this.margin, b, this.legendFont, this.legendColor, "left", "middle"],
                                        t: "Legends"
                                    });
                                    y = b
                                }
                                break
                            }
                        }
                    }
                } else {
                    d += this.colorSpectrumNumber * m;
                    for (var w = 0; w < q.length; w++) {
                        var b = d - ((q[w] - u) * p);
                        this.toRender({
                            p: ["drawText", e[w], A + this.margin, b, this.legendFont, this.legendColor, "left", "middle"],
                            t: "Legends"
                        })
                    }
                }
            }
        }
    };
    this.drawHeatmapIndicatorHistogram = function(x, b) {
        var w, a;
        var o = x;
        var z = b + this.heatmapIndicatorHeight;
        var y = [];
        for (var u = 0; u < this.data.y.vars.length; u++) {
            for (var s = 0; s < this.data.y.smps.length; s++) {
                var g = this.getDataAtPos(u, s, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                if (g != null && g !== "" && !isNaN(g)) {
                    y.push(g)
                }
            }
        }
        var k = this.range(y);
        var r = k[0];
        var t = k[1];
        var q = this[this.histogramSizeEstimator](y);
        var m = Math.ceil((t - r) / q);
        if (q > 1000) {
            m *= q / 1000;
            q = 1000
        }
        var e = [];
        for (var u = 0; u < q; u++) {
            e[u] = 0
        }
        for (var u = 0; u < this.data.y.vars.length; u++) {
            for (var s = 0; s < this.data.y.smps.length; s++) {
                var g = this.getDataAtPos(u, s, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                if (g != null && g !== "" && !isNaN(g)) {
                    var n = parseInt((g - r) / m);
                    e[n]++
                }
            }
        }
        r = 0;
        t = 0;
        for (var u = 0; u < q; u++) {
            r = Math.min(r, e[u]);
            t = Math.max(t, e[u])
        }
        var l = this.legendFont;
        var h = this[this.axisAlgorithm](r, t, 3, this.axisWilkinsonLoose);
        var p = this.getMaxText(h);
        var f = (this.heatmapIndicatorWidth - 1) / q;
        var c = this.heatmapIndicatorHeight / h[h.length - 1];
        if (this.heatmapIndicatorPosition == "topLeft") {
            l = this.scaleTextToFont(p, this.getFontPt(this.legendFont), this.left - (this.heatmapIndicatorWidth + (this.margin * 3)))
        }
        for (var u = 0; u < h.length; u++) {
            b = (h[u] * c);
            this.toRender({
                p: ["drawLine", "line", o - this.margin, z - b, o, z - b, this.foreground],
                t: "Legends"
            });
            this.toRender({
                p: ["drawText", this.formatNumber(h[u]), o - (this.margin * 1.5), z - b, l, this.legendColor, "right", "middle"],
                t: "Legends"
            })
        }
        b = (e[0] * c);
        this.toRender({
            p: ["drawLine", "line", o, z, o, z - b, this.heatmapIndicatorHistogramColor],
            t: "Legends"
        });
        for (var u = 0; u < q; u++) {
            b = (e[u] * c);
            this.toRender({
                p: ["drawLine", "line", o, z - b, o + f, z - b, this.heatmapIndicatorHistogramColor],
                t: "Legends"
            });
            if (u < q - 1) {
                a = (e[u + 1] * c);
                this.toRender({
                    p: ["drawLine", "line", o + f, z - b, o + f, z - a, this.heatmapIndicatorHistogramColor],
                    t: "Legends"
                })
            }
            o += f
        }
        this.toRender({
            p: ["drawLine", "line", o, z - a, o, z, this.heatmapIndicatorHistogramColor],
            t: "Legends"
        })
    };
    this.isDrawPropertyLegend = function(a) {
        if (a) {
            if (this.graphType == "Network") {
                return (this[a + "By"] && this.meta.data.edges[this[a + "By"]]) || (this[a + "By"] && this.meta.data.nodes[this[a + "By"]])
            } else {
                return (this[a + "By"] && this.isMultidimensionalData) || (this[a + "By"] && ((this.data.x && this.data.x.hasOwnProperty(this[a + "By"])) || (this.data.z && this.data.z.hasOwnProperty(this[a + "By"])) || this.getSampleIndices(this[a + "By"]) > -1))
            }
        } else {
            if (this.graphType == "Network") {
                return (this.colorEdgeBy && this.meta.data.edges[this.colorEdgeBy]) || (this.colorNodeBy && this.meta.data.nodes[this.colorNodeBy]) || (this.decorations.length && this.decorationsType == "heatmap")
            } else {
                return (this.outlineBy && this.isMultidimensionalData) || (this.colorBy && ((this.data.x && this.data.x.hasOwnProperty(this.colorBy)) || (this.data.z && this.data.z.hasOwnProperty(this.colorBy)) || this.getSampleIndices(this.colorBy) > -1 || (this.colorBy == "data" && this.ridgeBy)))
            }
        }
    };
    this.drawColorLegend = function(a, b, d, c) {
        if (this.graphType == "Map") {
            a += parseInt(this.meta.canvas.ctx2.canvas.style.left);
            b += parseInt(this.meta.canvas.ctx2.canvas.style.top)
        }
        if (this.isDrawPropertyLegend()) {
            if (d.type == "Numeric" && !d.colorBy) {
                this.drawColorIndicator(a, b, this.isTransformedData && this.graphType != "Heatmap" ? this.getDefaultMetaDataObject() : d)
            } else {
                this.drawPropertyLegend(c, a, b, d)
            }
        }
    };
    this.drawShapeLegend = function(a, b, d, c) {
        this.drawPropertyLegend(c, a, b, d)
    };
    this.drawSizeLegend = function(a, b, d, c) {
        this.drawPropertyLegend(c, a, b, d)
    };
    this.drawPatternLegend = function(a, b, d, c) {
        this.drawPropertyLegend(c, a, b, d)
    };
    this.drawConnectLegend = function(a, b, d, c) {
        this.drawPropertyLegend(c, a, b, d)
    };
    this.drawPropertyLegend = function(f, G, h, u) {
        var n = this;
        var v = function() {
            if (n.graphType == "Boxplot") {
                if (!n.showBoxplotOriginalData && !n.boxplotColor) {
                    return n.useRoundRectangles ? "roundrect" : "rectangle"
                } else {
                    return "circle"
                }
            } else {
                return "circle"
            }
        };
        var x = this.decapitalize(f);
        if (this.isDrawPropertyLegend(x)) {
            var H = f.replace("Node", "").replace("Edge", "") == "Size" ? 0 : this.getDiameterLegend();
            if (f.replace("Node", "").replace("Edge", "") == "Size") {
                for (var E = 0; E < (this.legendSizesN || u.levels.length); E++) {
                    H = Math.max(H, u.sizes ? u.sizes[E] : this.sizes[E])
                }
            }
            var z = this.getFontPt(this.legendFont);
            var j = z / 2;
            var b = this.legendColumns > this["legend" + f + "sN"] ? this["legend" + f + "sN"] : this.legendColumns;
            var e = Math.ceil(this["legend" + f + "sN"] / b);
            var o = this["legend" + f + "Width"] / b;
            var t = "legend" + f + "Meta";
            var g = h + (this.margin * 2) + j;
            var D = Math.max(H, z);
            var l = v();
            var B = 0;
            this.drawLegendBackgroundBox(G, h, this["legend" + f + "Width"], this["legend" + f + "Height"], true, "-legend-" + x);
            var K = f.replace("Node", "").replace("Edge", "") == "Color" && this.outlineBy ? this.outlineBy : this[x + "By"];
            if (this.showLegendTitle) {
                this.toRender({
                    p: ["drawText", K, G + (this["legend" + f + "Width"] / 2), g, this.legendFont, this.legendColor, "center", "middle"],
                    t: "Legends"
                });
                g += j + this.margin;
                this.disableGradientTransparencyShadow();
                if (this.legendBox) {
                    this.toRender({
                        p: ["drawLine", "line", G, g, G + this["legend" + f + "Width"], g, this.legendBoxColor],
                        t: "Legends"
                    })
                }
                this.enableGradientTransparencyShadow();
                g += this.margin + (D / 2)
            }
            var a = this["legend" + f + "sS"] || this.sortObject(this["legend" + f + "s"]);
            var J = u.origin ? u.origin : this.meta.data.modified ? "modified" : this.isOncoprint || this.isMultidimensionalData ? this[x + "ByData"] : "y";
            for (var w = 0; w < e; w++) {
                for (var I = 0; I < b; I++) {
                    var q = G + this.margin + H / 2 + (o * I);
                    if (B < this["legend" + f + "sN"]) {
                        var A = a[B];
                        var m = this.isHidden(false, false, "Property:" + K + ":" + A + ":" + J);
                        if (f.replace("Node", "").replace("Edge", "") == "Color") {
                            var k = u.colorBy && u.colorBy.hasOwnProperty(A) ? this.validateColor(u.colorBy[A]) : this.legendColors ? this.validateColor(this.legendColors[A]) : this.validateColor(u.colors[B]);
                            if (this.graphType == "Boxplot" && this.showViolinBoxplot) {
                                k = this.addColorTransparency(k, this.violinTransparency, true)
                            }
                            if (this.outlineBy) {
                                this.toRender({
                                    p: ["drawShape", l, q, g, H, H, false, this.getFillColor(k), "open", false, 2],
                                    a: this.getShapeArea(l, q, g, H, H, false, this.getFillColor(k), "open", false, 2),
                                    i: ["Property:" + K + ":" + A + ":" + J],
                                    t: "Legends",
                                    h: m
                                })
                            } else {
                                this.toRender({
                                    p: ["drawShape", l, q, g, H, H, this.getFillColor(k), this.getOutlineColor(k), "closed"],
                                    a: this.getShapeArea(l, q, g, H, H, this.getFillColor(k), this.getOutlineColor(k), "closed"),
                                    i: ["Property:" + K + ":" + A + ":" + J],
                                    t: "Legends",
                                    h: m
                                })
                            }
                        } else {
                            if (f.replace("Node", "").replace("Edge", "") == "Shape") {
                                var y = u.shapeBy && u.shapeBy.hasOwnProperty(A) ? u.shapeBy[A] : this.legendShapes ? this.legendShapes[A] : u.shapes[B];
                                this.toRender({
                                    p: ["drawShape", y, q, g, H, H, this.background, this.foreground, "closed"],
                                    a: this.getShapeArea(y, q, g, H, H, this.background, this.foreground, "closed"),
                                    i: ["Property:" + K + ":" + A + ":" + J],
                                    t: "Legends",
                                    h: m
                                })
                            } else {
                                if (f.replace("Node", "").replace("Edge", "") == "Size") {
                                    var C = u.sizeBy && u.sizeBy.hasOwnProperty(A) ? u.sizeBy[A] : this.legendSizes ? this.legendSizes[A] : u.sizes[B];
                                    if (u.rmax == u.max && u.rmin == u.min) {
                                        this.toRender({
                                            p: ["drawShape", l, q, g, C, C, this.background, this.foreground, "closed"],
                                            a: this.getShapeArea(l, q, g, C, C, this.background, this.foreground, "closed"),
                                            i: ["Property:" + K + ":" + A + ":" + J],
                                            t: "Legends",
                                            h: m
                                        })
                                    } else {
                                        this.toRender({
                                            p: ["drawShape", l, q, g, C, C, this.background, this.foreground, "closed"],
                                            t: "Legends",
                                            h: m
                                        })
                                    }
                                } else {
                                    if (f.replace("Node", "").replace("Edge", "") == "Pattern") {
                                        var s = u.patternBy && u.patternBy.hasOwnProperty(A) ? u.patternBy[A] : this.legendPatterns ? this.legendPatterns[A] : u.patterns[B];
                                        this.toRender({
                                            p: ["drawShape", this.useRoundRectangles ? "roundrect" : "square", q, g, H, H, this.background, this.foreground, s],
                                            a: this.getShapeArea(this.useRoundRectangles ? "roundrect" : "square", q, g, H, H, this.background, this.foreground, s),
                                            i: ["Property:" + K + ":" + A + ":" + J],
                                            t: "Legends",
                                            h: m
                                        })
                                    } else {
                                        if (f == "Connect") {
                                            var k = u.connectBy && u.connectBy.hasOwnProperty(A) ? u.connectBy[A] : this.legendConnects ? this.legendConnects[A] : u.connects[B];
                                            this.toRender({
                                                p: ["drawLine", "line", q - (H / 2), g, q + (H / 2), g, k, this.connectByWidth],
                                                t: "Legends",
                                                h: m
                                            })
                                        }
                                    }
                                }
                            }
                        }
                        if (this.graphType == "Boxplot" && f != "Connect" && (!this.showBoxplotOriginalData || this.boxplotColor)) {
                            var k = u.connectBy && u.connectBy.hasOwnProperty(A) ? u.connectBy[A] : this.legendConnects ? this.legendConnects[A] : u.connects[B];
                            this.toRender({
                                p: ["drawLine", "line", q - (H / 2), g, q + (H / 2), g, this.getOutlineColor(k)],
                                t: "Legends",
                                h: m
                            });
                            this.toRender({
                                p: ["drawLine", "line", q, g - (H / 2), q, g - ((H / 2) + this.margin), this.getOutlineColor(k)],
                                t: "Legends",
                                h: m
                            });
                            this.toRender({
                                p: ["drawLine", "line", q, g + (H / 2), q, g + ((H / 2) + this.margin), this.getOutlineColor(k)],
                                t: "Legends",
                                h: m
                            })
                        }
                        if (u.type == "Numeric" && ((f == "Shape" && !this.shapeByContinuous) || (f == "Size" && !this.sizeByContinuous))) {
                            if (w == 0 && I == 0) {
                                this.toRender({
                                    p: ["drawText", "<= " + A, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"],
                                    a: this.getTextArea("<= " + A, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"),
                                    i: ["Property:" + K + ":" + A + ":" + J],
                                    t: "Legends",
                                    h: m
                                })
                            } else {
                                if (w == e - 1 && I == b - 1) {
                                    this.toRender({
                                        p: ["drawText", a[B - 1] + " - " + A, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"],
                                        a: this.getTextArea(a[B - 1] + " - " + A, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"),
                                        i: ["Property:" + K + ":" + A + ":" + J],
                                        t: "Legends",
                                        h: m
                                    })
                                } else {
                                    nxt = A;
                                    this.toRender({
                                        p: ["drawText", Number(a[B - 1]) + " - " + nxt, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"],
                                        a: this.getTextArea(Number(a[B - 1]) + " - " + nxt, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"),
                                        i: ["Property:" + K + ":" + A + ":" + J],
                                        t: "Legends",
                                        h: m
                                    })
                                }
                            }
                        } else {
                            var F = A.length > this.maxTextSize ? A.substring(0, this.maxTextSize - 3) + "..." : A;
                            this.toRender({
                                p: ["drawText", F, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"],
                                a: this.getTextArea(A, q + (D / 2) + this.margin, g, this.legendFont, this.legendColor, "left", "middle"),
                                i: ["Property:" + K + ":" + A + ":" + J],
                                t: "Legends",
                                h: m
                            })
                        }
                    }
                    B++
                }
                g += this.margin + D
            }
            this.drawLegendBackgroundBox(G, h, this["legend" + f + "Width"], this["legend" + f + "Height"])
        }
    };
    this.drawCustomLegend = function(F, b, k, H, w) {
        var z = w.text.length;
        var B = this.getDiameterLegend();
        var u = w.size;
        if (u) {
            for (var C = 0; C < u.length; C++) {
                if (u[C]) {
                    B = Math.max(B, u[C])
                }
            }
        }
        var g = this.getFontPt(this.legendFont);
        var d = g / 2;
        var l = this.legendColumns > z ? z : this.legendColumns;
        var e = Math.ceil(z / l);
        var m = k / l;
        var E = b + this.margin + d;
        var t = Math.max(B, g);
        var j = 0;
        this.drawLegendBackgroundBox(F, b, k, H, true, "-legend-" + w.id);
        if (w.title) {
            this.toRender({
                p: ["drawText", w.title, F + (k / 2), E, this.legendFont, this.legendColor, "center", "middle"],
                t: "Legends"
            });
            E += d + this.margin;
            this.disableGradientTransparencyShadow();
            if (this.legendBox) {
                this.toRender({
                    p: ["drawLine", "line", F, E, F + k, E, this.legendBoxColor],
                    t: "Legends"
                })
            }
            this.enableGradientTransparencyShadow();
            E += this.margin + (t / 2)
        } else {
            E += (t / 2) - d
        }
        var A = false;
        for (var v = 0; v < e; v++) {
            for (var G = 0; G < l; G++) {
                var p = F + this.margin + B / 2 + (m * G);
                if (j < z) {
                    var a = w.text[j];
                    if (w.shape && w.shape[j]) {
                        var q = w.size[j] || B;
                        var G = this.getFillColor(w.shapeColor[j] || this.background);
                        var y = this.getOutlineColor(G);
                        this.toRender({
                            p: ["drawShape", w.shape[j], p, E, q, q, G, y, "closed"],
                            a: this.getShapeArea(w.shape[j], p, E, q, q, G, y, "closed"),
                            i: ["legend-shape-" + a],
                            t: "Legends",
                            h: this.isHidden(false, false, "legend-shape-" + a)
                        });
                        A = true
                    }
                    if (w.line && w.line[j]) {
                        var q = w.size[j] || B;
                        var D = q / 2;
                        var G = w.lineColor[j] || this.background;
                        var f = w.lineStart && w.lineStart[j] ? w.lineStart[j] : false;
                        var x = w.lineEnd && w.lineEnd[j] ? w.lineEnd[j] : false;
                        this.toRender({
                            p: ["drawLine", w.line[j], p - D, E, p + D, E, G, false, false, false, false, false, false, false, f, x],
                            a: this.getLineArea(w.line[j], p - D, E, p + D, E, G, false, false, false, false, false, false, false, f, x),
                            i: ["legend-line-" + a],
                            t: "Legends",
                            h: this.isHidden(false, false, "legend-line-" + a)
                        });
                        A = true
                    }
                    if (A) {
                        this.toRender({
                            p: ["drawText", w.text[j], p + (t / 2) + this.margin, E, this.legendFont, this.legendColor, "left", "middle"],
                            a: this.getTextArea(w.text[j], p + (t / 2) + this.margin, E, this.legendFont, this.legendColor, "left", "middle"),
                            i: ["legend-text-" + a],
                            t: "Legends",
                            h: this.isHidden(false, false, "legend-text-" + a)
                        })
                    } else {
                        this.toRender({
                            p: ["drawText", w.text[j], p + (k / 2), E, this.legendFont, this.legendColor, "center", "middle"],
                            a: this.getTextArea(w.text[j], p + (k / 2), E, this.legendFont, this.legendColor, "center", "middle"),
                            i: ["legend-text-" + a],
                            t: "Legends",
                            h: this.isHidden(false, false, "legend-text-" + a)
                        })
                    }
                }
                j++
            }
            E += this.margin + t
        }
        this.drawLegendBackgroundBox(F, b, k, H)
    };
    this.drawGenericLegend = function(r, o, m, x, p, z, n) {
        var s = this.getDiameterLegend();
        var c = this.getFontPt(this.legendFont) + 2;
        var q = Math.max(s, c);
        var d = 0;
        this.drawLegendBackgroundBox(r, o, m, x, true, "-legend");
        this.toRender({
            p: ["drawText", z, r + (m / 2), o + this.margin + (c / 2), this.legendFont, this.legendColor, "center", "middle"],
            t: "Legends"
        });
        d = o + c + this.margin;
        if (this.legendBox) {
            this.toRender({
                p: ["drawLine", "line", r, d, r + m, d, this.legendBoxColor],
                t: "Legends"
            })
        }
        d += this.margin;
        if (!n) {
            n = 1
        }
        var b = m / n;
        var e = Math.ceil(p.levels.length / n);
        var f = 0;
        var a = d;
        var g = p.origin ? p.origin : this.meta.data.modified ? "modified" : "y";
        for (var v = 0; v < e; v++) {
            for (var u = 0; u < n; u++) {
                var y = r + this.margin + (b * u);
                if (f < p.levels.length) {
                    var k = p.type == "String" ? p.colors[f] : this.getColorForValue(p.colorBrew, p.levels[f]);
                    this.toRender({
                        p: ["drawShape", this.useRoundRectangles ? "rounderect" : "square", y + (q / 2), a + (q / 2), q, q, this.getFillColor(k), this.getOutlineColor(k)],
                        a: this.getShapeArea(this.useRoundRectangles ? "rounderect" : "square", y + (q / 2), a + (q / 2), q, q, this.getFillColor(k), this.getOutlineColor(k)),
                        i: ["Property:" + z + ":" + p.levels[f] + ":" + g],
                        t: "Legends",
                        h: this.isHidden(false, false, "Property:" + z + ":" + p.levels[f] + ":" + g)
                    });
                    this.toRender({
                        p: ["drawText", p.levels[f], y + q + this.margin, a + (q / 2), this.legendFont, this.legendColor, "left", "middle"],
                        a: this.getTextArea(p.levels[f], y + q + this.margin, a + (q / 2), this.legendFont, this.legendColor, "left", "middle"),
                        i: ["Property:" + z + ":" + p.levels[f] + ":" + g],
                        t: "Legends",
                        h: this.isHidden(false, false, "Property:" + z + ":" + p.levels[f] + ":" + g)
                    })
                } else {
                    break
                }
                f++
            }
            a += q
        }
        this.drawLegendBackgroundBox(r, o, m, x)
    };
    this.drawDecorationLegend = function(m, f) {
        if (this.graphType.match(/Scatter/)) {
            var v = this.decorations;
            var k = this.getFontPt(this.decorationFont);
            var c = this.measureText(this.sprintf("%15s", "X"), this.decorationFont);
            var g = v.nlfit || v.nor || v.reg ? c : 0;
            var h = m + (g ? this.legendDecorationMaxLabel + c : this.margin);
            var u = h;
            var x = f;
            var a = x;
            this.legendDecorationCurX = m;
            this.legendDecorationCurY = f;
            this.drawLegendBackgroundBox(m, (f - ((k / 2) + this.margin)), this.legendDecorationWidth, this.legendDecorationHeight + this.margin, true, "-legend-decorations", true);
            if (v.qq) {
                for (var q = 0; q < v.qq.length; q++) {
                    this.toRender({
                        p: ["drawText", v.qq[q].label, u, a, this.decorationFont, v.qq[q].color, "left", "middle"],
                        t: "Legends"
                    });
                    a += k + k
                }
            } else {
                if (v.cdf) {
                    for (var q = 0; q < v.cdf.length; q++) {
                        this.toRender({
                            p: ["drawText", v.cdf[q].label, u, a, this.decorationFont, v.cdf[q].color, "left", "middle"],
                            t: "Legends"
                        });
                        a += k + k
                    }
                } else {
                    if (!v.qq && !v.cdf) {
                        if (v.nlfit) {
                            this.toRender({
                                p: ["drawText", "Min", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "Max", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "EC50", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "Slope", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "p-Val", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "F-Chg", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            a += k + k;
                            for (var q = 0; q < v.nlfit.length; q++) {
                                var n = q % this.colors.length;
                                n = v.nlfit[q].color ? v.nlfit[q].color : this.colors[n];
                                u = (h + this.margin) - c;
                                if (this.graphType == "ScatterBubble2D" && this.decorationsPosition == "right" && this.zAxisShow) {
                                    u += this.margin + this.getFontPt(this.axisTitleFont) + this.margin
                                }
                                this.toRender({
                                    p: ["drawText", v.nlfit[q].label, u, a, this.decorationFont, n, "right", "middle"],
                                    t: "Legends"
                                });
                                u = h;
                                for (var p = 0; p < 6; p++) {
                                    var y = v.nlfit[q].param[p];
                                    if (p < 2) {
                                        y = this.transformValue(this.yAxisTransform, y)
                                    } else {
                                        if (p == 2) {}
                                    }
                                    this.toRender({
                                        p: ["drawText", this.formatNumber(y, this.yAxisDecs + 1), u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                        t: "Legends"
                                    });
                                    u += c + this.margin
                                }
                                a += k + k
                            }
                        }
                        if (v.line) {
                            for (var q = 0; q < v.line.length; q++) {
                                if (v.line[q].label) {
                                    for (var q = 0; q < v.line.length; q++) {
                                        var n = v.line[q].color ? v.line[q].color : this.colors[q % this.colors.length];
                                        if (this.graphType == "ScatterBubble2D" && this.decorationsPosition == "right" && this.zAxisShow) {
                                            u += this.margin + this.getFontPt(this.axisTitleFont) + this.margin
                                        }
                                        this.toRender({
                                            p: ["drawText", v.line[q].label, u, a, this.decorationFont, n, "left", "middle"],
                                            t: "Legends"
                                        });
                                        a += k + k
                                    }
                                }
                            }
                        }
                        if (v.reg) {
                            this.toRender({
                                p: ["drawText", "Slope", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "Int", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "Cor", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            a += k + k;
                            for (var q = 0; q < v.reg.length; q++) {
                                var n = v.reg[q].color ? v.reg[q].color : this.colors[q % this.colors.length];
                                u = (h + this.margin) - c;
                                if (this.graphType == "ScatterBubble2D" && this.decorationsPosition == "right" && this.zAxisShow) {
                                    u += this.margin + this.getFontPt(this.axisTitleFont) + this.margin
                                }
                                this.toRender({
                                    p: ["drawText", v.reg[q].label, u, a, this.decorationFont, n, "right", "middle"],
                                    t: "Legends"
                                });
                                u = h;
                                this.toRender({
                                    p: ["drawText", this.formatNumber(v.reg[q].slope, 2), u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                    t: "Legends"
                                });
                                u += c + this.margin;
                                this.toRender({
                                    p: ["drawText", this.formatNumber(v.reg[q].intercept, this.yAxisDecs + 1), u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                    t: "Legends"
                                });
                                u += c + this.margin;
                                this.toRender({
                                    p: ["drawText", this.formatNumber(v.reg[q].cor, 3), u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                    t: "Legends"
                                });
                                u += c + this.margin;
                                a += k + k
                            }
                        }
                        if (v.nor) {
                            this.toRender({
                                p: ["drawText", "Mu", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            u += c + this.margin;
                            this.toRender({
                                p: ["drawText", "Sigma", u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                t: "Legends"
                            });
                            a += k + k;
                            for (var q = 0; q < v.nor.length; q++) {
                                var n = q % this.colors.length;
                                n = v.nor[q].color ? v.nor[q].color : this.colors[n];
                                u = (h + this.margin) - c;
                                if (this.graphType == "ScatterBubble2D" && this.decorationsPosition == "right" && this.zAxisShow) {
                                    u += this.margin + this.getFontPt(this.axisTitleFont) + this.margin
                                }
                                this.toRender({
                                    p: ["drawText", v.nor[q].label, u, a, this.decorationFont, n, "right", "middle"],
                                    t: "Legends"
                                });
                                u = h;
                                this.toRender({
                                    p: ["drawText", this.formatNumber(v.nor[q].mu, this.xAxisDecs + 1), u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                    t: "Legends"
                                });
                                u += c + this.margin;
                                this.toRender({
                                    p: ["drawText", this.formatNumber(v.nor[q].sigma, this.xAxisDecs + 2), u, a, this.decorationFont, this.decorationsColor, "right", "middle"],
                                    t: "Legends"
                                });
                                u += c + this.margin;
                                a += k + k
                            }
                        }
                        if (v.area) {
                            for (var q = 0; q < v.area.length; q++) {
                                if (v.area[q].label) {
                                    var n = v.area[q].color ? v.area[q].color : this.colors[q % this.colors.length];
                                    if (this.graphType == "ScatterBubble2D" && this.decorationsPosition == "right" && this.zAxisShow) {
                                        u += this.margin + this.getFontPt(this.axisTitleFont) + this.margin
                                    }
                                    this.toRender(["drawText", v.area[q].label, u, a, this.decorationFont, n, "left", "middle"]);
                                    a += k + k
                                }
                            }
                        }
                        if (v.kaplanMeier) {
                            for (var q = 0; q < v.kaplanMeier.length; q++) {
                                if (v.kaplanMeier[q].label) {
                                    var n = v.kaplanMeier[q].color ? v.kaplanMeier[q].color : this.colors[q % this.colors.length];
                                    if (this.graphType == "ScatterBubble2D" && this.decorationsPosition == "right" && this.zAxisShow) {
                                        u += this.margin + this.getFontPt(this.axisTitleFont) + this.margin
                                    }
                                    this.toRender({
                                        p: ["drawText", v.kaplanMeier[q].label, u, a, this.decorationFont, n, "left", "middle"],
                                        t: "Legends"
                                    });
                                    a += k + k
                                }
                            }
                        }
                    }
                }
            }
            this.drawLegendBackgroundBox(m, (f - ((k / 2) + this.margin)), this.legendDecorationWidth, this.legendDecorationHeight + this.margin, false, false, true)
        } else {
            if (this.graphType == "Map" && this.decorations.pie && this.decorations.pie[0] && this.decorations.pie[0].smps && this.decorations.pie[0].smps.length) {
                var v = this.decorations.pie[0];
                var k = this.getFontPt(this.decorationFont);
                var b = k / 2;
                var w = Math.ceil(v.smps.length / this.legendColumns);
                var s = this.legendDecorationWidth / this.legendColumns;
                var o = 0;
                var h = m;
                var x = f;
                for (var q = 0; q < w; q++) {
                    for (var p = 0; p < this.legendColumns; p++) {
                        u = h + (this.margin + (s * p));
                        if (o < v.smps.length) {
                            var c = v.colors[o];
                            var e = u + b;
                            var r = x + b;
                            this.toRender({
                                p: ["drawShape", "circle", e, r, k, k, c, this.background],
                                a: this.getShapeArea("circle", e, r, k, k, c, this.background),
                                t: "Legends"
                            });
                            this.toRender({
                                p: ["drawText", v.smps[o], e + b + this.margin, r, this.decorationFont, this.decorationColor, "left", "middle"],
                                a: this.getTextArea(v.smps[o], e + b + this.margin, r, this.decorationFont, this.decorationColor, "left", "middle"),
                                t: "Legends"
                            })
                        } else {
                            break
                        }
                        o++
                    }
                }
            }
        }
    };
    this.resetLegends = function(c) {
        if (c) {
            delete(this.legendDecorationCurX);
            delete(this.legendDecorationCurY);
            delete(this.legendDecorationX);
            delete(this.legendDecorationY)
        }
        var a = this.graphType == "Network" ? ["ColorNode", "ShapeNode", "SizeNode", "PatternNode", "ColorEdge", "SizeEdge"] : this.scatterPlotMatrix ? ["Color", "Shape", "Size", "Pattern", "Variable"] : this.connectByNoColor ? ["Color", "Shape", "Size", "Pattern", "Variable", "Sample"] : ["Color", "Shape", "Size", "Pattern", "Connect", "Variable", "Sample"];
        for (var b = 0; b < a.length; b++) {
            this["legend" + a[b] + "Width"] = 0;
            this["legend" + a[b] + "Height"] = 0;
            if (c) {
                delete(this["legend" + a[b] + "CurX"]);
                delete(this["legend" + a[b] + "CurY"]);
                delete(this["legend" + a[b] + "X"]);
                delete(this["legend" + a[b] + "Y"])
            }
        }
        delete(this.legendColorIndicatorCurX);
        delete(this.legendColorIndicatorCurY)
    };
    this.getXYLegendCoords = function(B, s, o) {
        var k, g, r;
        var n = -1;
        var A = -1;
        var f = this;
        var c = this.graphType == "Network" ? 0 : this.offsetX;
        var b = this.graphType == "Network" ? 0 : this.offsetY;
        var d = function() {
            for (var l = 0; l < f.legendLayout.length; l++) {
                if (f.legendLayout[l]) {
                    for (var h = 0; h < f.legendLayout[l].length; h++) {
                        if (f.legendLayout[l][h] == B) {
                            return [l, h]
                        }
                    }
                }
            }
            return [-1, -1]
        };
        if (this.legendLayout) {
            var e = d();
            n = e[0];
            A = e[1];
            if (n > -1 && A > -1) {
                var a = 0;
                var p = 0;
                if (this.legendPosition.match(/right|left/i)) {
                    for (var v = 0; v < n; v++) {
                        var m = 0;
                        if (this.legendLayout[v]) {
                            for (var u = 0; u < this.legendLayout[v].length; u++) {
                                m = Math.max(m, this["legend" + this.legendLayout[v][u] + "Width"] + this.margin)
                            }
                        }
                        a += m
                    }
                    if (this.legendLayout[v]) {
                        for (var u = 0; u < this.legendLayout[n].length; u++) {
                            p += this["legend" + this.legendLayout[n][u] + "Height"] + this.margin
                        }
                    }
                } else {
                    for (var v = 0; v < n; v++) {
                        var z = 0;
                        if (this.legendLayout[v]) {
                            for (var u = 0; u < this.legendLayout[v].length; u++) {
                                z = Math.max(z, this["legend" + this.legendLayout[v][u] + "Height"] + this.margin)
                            }
                        }
                        p += z
                    }
                    if (this.legendLayout[v]) {
                        for (var u = 0; u < this.legendLayout[n].length; u++) {
                            a += this["legend" + this.legendLayout[n][u] + "Width"] + this.margin
                        }
                    }
                }
                if (this.graphType == "Circular") {
                    k = s;
                    g = o
                } else {
                    if (this.legendPosition.match(/right|left/i)) {
                        o = A == 0 && (this.scatterPlotMatrix || (this.layoutValid && !this.getLayoutConfig("legendPosition"))) ? this.marginTop + this.layoutTop : A == 0 ? this.marginTop + b + this.top : o;
                        k = s + a + (this.graphType == "Network" ? -10 : 0);
                        r = this.legendPosition.match(/top/) ? this.margin : this.legendPosition.match(/bottom/) ? this.y - (p + this.margin) : ((this.y - p) / 2);
                        g = A == 0 && (this.scatterPlotMatrix || (this.layoutValid && !this.getLayoutConfig("legendPosition"))) ? (this.height - p) / 2 : A == 0 ? this.marginTop + b + this.top + r : o;
                        s = A == this.legendLayout[n].length - 1 ? s + a : s;
                        o = g + this["legend" + this.legendLayout[n][A] + "Height"] + this.margin
                    } else {
                        s = A == 0 && (this.scatterPlotMatrix || (this.layoutValid && !this.getLayoutConfig("legendPosition"))) ? this.marginLeft + this.layoutLeft : A == 0 ? this.marginLeft + c + this.left : s;
                        k = A == 0 && (this.scatterPlotMatrix || (this.layoutValid && !this.getLayoutConfig("legendPosition"))) ? (this.width - a) / 2 : A == 0 ? this.marginLeft + c + this.left + ((this.x - a) / 2) + this.margin : s + this.margin;
                        g = o + p;
                        s = k + this["legend" + this.legendLayout[n][A] + "Width"] + this.margin;
                        o = A == this.legendLayout[n].length - 1 ? o + p : o
                    }
                }
            }
        }
        return [k, g, s, o]
    };
    this.getVariableLegendPosition = function() {
        var c, h;
        if (this.graphType == "Pie" && this.layoutValid) {
            if (this.legendPosition == "right") {
                c = this.width - (this.marginRight + this.legendVariableWidth + this.margin);
                h = (this.height / 2) - (this.legendVariableHeight / 2)
            } else {
                c = (this.width / 2) - (this.legendVariableWidth / 2);
                h = this.height - (this.marginBottom + this.legendVariableHeight + this.margin)
            }
        } else {
            if (this.graphType == "Treemap" || this.graphType == "TagCloud") {
                return [0, 0]
            } else {
                if (this.graphType == "Circular") {
                    c = this.width - (this.marginRight + this.legendVariableWidth + this.margin);
                    h = this.height - (this.marginBottom + this.legendVariableHeight + this.margin);
                    return [c, h]
                } else {
                    if (this.layoutValid && this.graphType != "Pie") {
                        var d = this.width - (this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight);
                        var b = this.height - (this.marginTop + this.layoutTop + this.layoutBottom + this.marginBottom);
                        var j = this.legendVariableHeight + this.legendOverlaysHeight + (this.margin * -0.5);
                        var e = this.legendVariableWidth + this.legendOverlaysWidth + (this.margin * -0.5);
                        c = this.legendPosition == "right" ? this.width - (this.marginRight + e) : this.legendPosition == "left" ? this.marginLeft + this.margin : this.marginLeft + this.layoutLeft + (d / 2) - (e / 2);
                        h = this.legendPosition == "bottom" ? this.height - (this.marginBottom + j) : this.legendPosition == "top" ? this.marginTop + this.margin + this.getTitleSubtitleHeight() : this.marginTop + this.layoutTop + (b / 2) - (j / 2)
                    } else {
                        var f = this.marginLeft + this.offsetX + this.left;
                        var k = this.marginTop + this.offsetY + this.top;
                        var a = this.legendVariableHeight;
                        var i = this.legendVariableWidth;
                        if (this.legendInside || this.graphType == "Pie") {
                            switch (this.legendPosition) {
                                case "bottomRight":
                                    c = f + this.x - (i + this.margin);
                                    h = k + this.y - (a + this.margin);
                                    break;
                                case "bottom":
                                    c = f + (this.x / 2) - (i / 2);
                                    h = k + this.y - (this.graphType == "Pie" ? 0 : (a + this.margin));
                                    break;
                                case "bottomLeft":
                                    c = f + this.margin;
                                    h = k + this.y - (a + this.margin);
                                    break;
                                case "left":
                                    c = f + this.margin - (this.graphType == "Pie" ? (i + this.margin) : 0);
                                    h = k + (this.y / 2) - (a / 2);
                                    break;
                                case "topLeft":
                                    c = f + this.margin;
                                    h = k + this.margin;
                                    break;
                                case "top":
                                    c = f + (this.x / 2) - (i / 2);
                                    h = k + this.margin - (this.graphType == "Pie" ? (a + this.margin) : 0);
                                    break;
                                case "topRight":
                                    c = f + this.x - (i + this.margin);
                                    h = k + this.margin;
                                    break;
                                default:
                                    c = f + this.x - (this.graphType == "Pie" ? 0 : (i + this.margin));
                                    h = k + (this.y / 2) - (a / 2)
                            }
                        } else {
                            var m = this.overlaysLegendPosition.match(/top|bottom/i) ? this.legendOverlaysHeight : 0;
                            var g = this.overlaysLegendPosition.match(/right|left/i) ? this.legendOverlaysWidth : 0;
                            switch (this.legendPosition) {
                                case "bottom":
                                    c = f + (this.x / 2) - (i / 2);
                                    h = k + this.y + this.bottom - (a + m + this.margin);
                                    break;
                                case "top":
                                    c = f + (this.x / 2) - (i / 2);
                                    h = this.marginTop + this.offsetY + this.margin + this.getTitleSubtitleHeight();
                                    break;
                                case "left":
                                    c = this.marginLeft + this.offsetX + this.margin;
                                    h = k + (this.y / 2) - (a / 2);
                                    break;
                                default:
                                    c = f + this.x + this.right - (i + g + this.margin);
                                    h = k + (this.y / 2) - (a / 2)
                            }
                        }
                    }
                }
            }
        }
        return [c, h]
    };
    this.getScatterLegendPosition = function() {
        var j = 0;
        var h = 0;
        var g = 0;
        var d = 0;
        var a = 0;
        var i = 0;
        var c = this.graphType == "Network" ? 10 : this.offsetX;
        var b = this.graphType == "Network" ? 10 : this.offsetY;
        var e = this.marginLeft + c + this.left + this.margin;
        var k = this.marginTop + b + this.top + this.margin;
        if (this.scatterPlotMatrix || (this.layoutValid && !this.getLayoutConfig("legendPosition"))) {
            if (this.legendPosition == "left") {
                g = this.marginLeft + this.margin
            } else {
                g = this.width + this.margin - (this.marginRight + (this.legendWidth || 0))
            }
            if (this.legendPosition == "top") {
                d = this.marginTop + this.margin + this.getTitleSubtitleHeight()
            } else {
                d = this.height + this.margin - (this.marginBottom + (this.legendHeight || 0))
            }
            j = g - (this.legendDecorationWidth + this.margin);
            h = d - (this.legendDecorationHeight + this.margin)
        } else {
            if (this.graphType == "Circular") {
                if (this.circularType == "sunburst" && this.colorBy) {
                    g = this.legendPosition == "top" ? this.marginLeft + this.left : this.width - (this.legendColorWidth + this.right + this.marginRight);
                    d = this.legendPosition == "top" ? this.marginTop + this.top : this.height - (this.legendColorHeight + this.bottom + this.marginBottom)
                } else {
                    g = this.legendPosition == "top" ? this.marginLeft + this.left : this.width - (this.legendVariableWidth + this.right + this.marginRight);
                    d = this.legendPosition == "top" ? this.marginTop + this.top : this.height - (this.legendVariableHeight + this.bottom + this.marginBottom)
                }
            } else {
                if (this.legendInside || this.isQQ || this.isCDF) {
                    if (this.legendDecorationWidth > 0 && this.legendDecorationHeight > 0) {
                        var f = this.legendDecorationWidth + (this.margin * 2);
                        if (this.isQQ || this.isCDF) {
                            j = e + this.x - f;
                            h = k + this.y - (this.legendDecorationHeight + this.margin)
                        } else {
                            switch (this.decorationsPosition) {
                                case "bottomRight":
                                    j = e + this.x - f;
                                    h = k + this.y - (this.legendDecorationHeight + this.margin);
                                    break;
                                case "bottom":
                                    j = e + (this.x / 2) - (this.legendDecorationWidth / 2);
                                    h = k + this.y - (this.legendDecorationHeight + this.margin);
                                    break;
                                case "bottomLeft":
                                    j = e + this.margin;
                                    h = k + this.y - (this.legendDecorationHeight + this.margin);
                                    break;
                                case "left":
                                    j = e + this.margin;
                                    h = k + (this.y / 2) - (this.legendDecorationHeight / 2);
                                    break;
                                case "topLeft":
                                    j = e + this.margin;
                                    h = k + (this.margin * 2);
                                    break;
                                case "top":
                                    j = e + (this.x / 2) - (this.legendDecorationWidth / 2);
                                    h = k + (this.margin * 2);
                                    break;
                                case "topRight":
                                    j = e + this.x - f;
                                    h = k + (this.margin * 2);
                                    break;
                                default:
                                    j = e + this.x - f;
                                    h = k + (this.y / 2) - (this.legendDecorationHeight / 2);
                                    break
                            }
                        }
                    }
                    if (this.legendWidth > 0 && this.legendHeight > 0) {
                        switch (this.legendPosition) {
                            case "bottomRight":
                                g = e + this.x - this.legendWidth;
                                d = k + this.y - this.legendHeight;
                                break;
                            case "bottom":
                                g = e + (this.x / 2) - (this.legendWidth / 2);
                                d = k + this.y - this.legendHeight;
                                break;
                            case "bottomLeft":
                                g = e;
                                d = k + this.y - this.legendHeight;
                                break;
                            case "left":
                                g = e;
                                d = k + (this.y / 2) - (this.legendHeight / 2);
                                break;
                            case "topLeft":
                                g = e;
                                d = k;
                                break;
                            case "top":
                                g = e + (this.x / 2) - (this.legendWidth / 2);
                                d = k;
                                break;
                            case "topRight":
                                g = e + this.x - this.legendWidth;
                                d = k;
                                break;
                            default:
                                g = e + this.x - this.legendWidth;
                                d = k + (this.y / 2) - (this.legendHeight / 2);
                                break
                        }
                    }
                } else {
                    switch (this.decorationsPosition) {
                        case "bottom":
                            j = e + (this.x / 2) - (this.legendDecorationWidth / 2);
                            h = k + this.y + this.bottom - this.legendDecorationHeight;
                            break;
                        default:
                            j = e + this.x + this.right - (this.legendDecorationWidth + (this.margin * 2));
                            h = k + (this.y / 2) - (this.legendDecorationHeight / 2);
                            break
                    }
                    a = this.legendPosition == this.decorationsPosition ? this.legendDecorationWidth : 0;
                    i = this.legendPosition == this.decorationsPosition ? this.legendDecorationHeight : 0;
                    switch (this.legendPosition) {
                        case "bottom":
                            g = e + (this.x / 2) - (this.legendWidth / 2);
                            d = k + this.y + this.bottom - (this.legendHeight + (i ? i + this.margin : 0));
                            if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                d += this.legendHeight
                            }
                            break;
                        case "top":
                            g = e + (this.x / 2) - (this.legendWidth / 2);
                            d = this.marginTop + b + this.margin + this.getTitleSubtitleHeight();
                            if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                d += this.legendHeight
                            }
                            break;
                        case "left":
                            g = this.marginLeft + c + this.margin;
                            d = k + (this.y / 2) - (this.legendHeight / 2);
                            if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                g += this.legendWidth
                            }
                            break;
                        default:
                            g = e + this.x + this.right - (this.legendWidth + a);
                            d = k + (this.y / 2) - (this.legendHeight / 2);
                            if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                g += this.legendWidth
                            }
                            if (this.isMultidimensionalData && this.heatmapIndicatorPosition == "right") {
                                g -= (this.heatmapIndicatorHeight + this.meta.def.colorBrew.maxLevLen + this.margin)
                            }
                            break
                    }
                }
            }
        }
        return [j, h, g, d]
    };
    this.drawIndicator = function(a, b, c) {
        delete(this.legendColorIndicatorCurX);
        delete(this.legendColorIndicatorCurY);
        this.drawColorIndicator(a, b, false, c)
    };
    this.drawLegend = function(a) {
        if (this.graphType == "Meter") {
            return
        } else {
            if (this.graphType == "Fish") {
                var b = this.getVariableLegendPosition();
                this.drawVariableLegend(b[0], b[1])
            } else {
                if (this.graphType == "Venn") {
                    this.drawVennLegend()
                } else {
                    if (this.graphType == "Circular") {
                        if (this.circularType == "sunburst") {
                            this.drawScatterLegend(a)
                        } else {
                            if (this.circularType == "bubble") {} else {
                                if (this.showLegend) {
                                    this.drawOverlaysLegend();
                                    var b = this.getVariableLegendPosition();
                                    this.drawVariableLegend(b[0], b[1])
                                }
                            }
                        }
                    } else {
                        if (this.graphType == "Network") {
                            this.drawScatterLegend()
                        } else {
                            if (this.graphType.match(/Scatter/) || this.is3DPlot || ((this.isAttributedGraph() || this.connectBy) && (CanvasXpress.graphTypes.AttGraphs.includes(this.graphType) || this.graphType == "Map"))) {
                                this.drawScatterLegend(a);
                                if (this.isOncoprint) {
                                    this.drawOncoprintLegend()
                                }
                                this.drawOverlaysLegend()
                            } else {
                                if (this.graphType == "Pie" && this.layoutValid && !this.isDOE) {
                                    if (this.layoutCurrent == this.data.l.smps.length - 1) {
                                        this.draw1DLegend()
                                    }
                                } else {
                                    this.draw1DLegend();
                                    this.drawOverlaysLegend()
                                }
                            }
                        }
                    }
                }
            }
        }
    };
    this.draw1DLegend = function() {
        if (this.showLegend && ((this.graphType != "Heatmap") || (this.graphType == "Heatmap" && this.isAttributedGraph()))) {
            if (this.isMultidimensionalData || (this.isAttributedGraph() && CanvasXpress.graphTypes.AttGraphs.includes(this.graphType))) {
                if (this.isOncoprint) {
                    this.drawOncoprintLegend()
                }
                this.drawScatterLegend()
            } else {
                if (this.graphType == "Treemap" || this.graphType == "TagCloud") {
                    return
                }
                var c = this.getVariableLegendPosition();
                var a = c[0];
                var b = c[1];
                if (this.legendVariableX && this.legendVariableY) {
                    a = this.legendVariableX;
                    b = this.legendVariableY
                }
                this.legendVariableCurX = a;
                this.legendVariableCurY = b;
                this.drawVariableLegend(a, b)
            }
        } else {
            if (this.isOncoprint) {
                this.drawOncoprintLegend()
            }
        }
    };
    this.drawOverlaysLegend = function() {
        var s, e;
        if (this.overlaysLegendPosition.match(/right/i)) {
            s = this.layoutValid ? this.marginTop + this.layoutTop : this.marginTop + this.offsetY + this.top;
            if (this.overlaysLegendPosition == "right") {
                s += (this.y / 2) - (this.legendOverlaysHeight / 2)
            }
            e = this.layoutValid ? this.width - (this.marginRight + this.layoutRight + this.legendOverlaysWidth) : this.width - (this.marginRight + this.legendOverlaysWidth);
            if (this.graphType == "Heatmap" && this.heatmapIndicatorPosition == "right") {
                e -= this.getHeatmapIndicatorWidth() - this.margin
            }
        } else {
            s = this.layoutValid ? this.height - (this.marginBottom + this.layoutBottom + this.legendOverlaysHeight) : this.height - (this.marginBottom + this.legendOverlaysHeight);
            e = this.layoutValid ? this.marginLeft + this.layoutLeft : this.marginLeft + this.offsetX + this.left;
            if (this.overlaysLegendPosition == "bottom") {
                e += (this.x / 2) - (this.legendOverlaysWidth / 2)
            }
        }
        var v = s;
        var f = e;
        for (var k = 0; k < this.legendOverlaysLayout.length; k++) {
            var n = this.legendOverlaysLayout[k];
            var r, b, d, a;
            var u = mw = 0;
            var p = mh = 0;
            for (var g = 0; g < n.length; g++) {
                r = n[g][0];
                b = n[g][1];
                mw = Math.max(u, n[g][2]);
                mh = Math.max(p, n[g][3])
            }
            for (var g = 0; g < n.length; g++) {
                r = n[g][0];
                b = n[g][1];
                d = this.meta.data[r][b];
                u = this["legend" + b + "Width"];
                p = this["legend" + b + "Height"];
                a = r == "z" ? this.varOverlaysLegendColumns : this.smpOverlaysLegendColumns;
                if (d.type == "String") {
                    this.drawGenericLegend(f, v, u, p, d, b, a)
                } else {
                    this.drawColorIndicator(f, v, d, b, false, u / 2)
                }
                if (this.overlaysLegendPosition.match(/right/i)) {
                    v += p + this.margin
                } else {
                    f += u + this.margin
                }
            }
            if (this.overlaysLegendPosition.match(/right/i)) {
                f += mw + this.margin;
                v = s
            } else {
                f = e;
                v += mh + this.margin
            }
        }
    };
    this.drawScatterLegend = function(f) {
        var n = this.getScatterLegendPosition();
        if (this.showDecorations && this.showDecorationsLegend && this.decorations && !this.layoutValid) {
            if (this.legendDecorationX != null && this.legendDecorationY != null) {
                this.drawDecorationLegend(this.legendDecorationX, this.legendDecorationY)
            } else {
                this.drawDecorationLegend(n[0], n[1])
            }
        }
        if (this.graphType.match(/Scatter/) && (this.isQQ || this.isCDF)) {
            return
        }
        if (this.showLegend) {
            var k = this.graphType == "Network" ? ["ColorNode", "ShapeNode", "SizeNode", "PatternNode", "ColorEdge", "SizeEdge", "Decoration"] : this.scatterPlotMatrix ? ["Color", "Shape", "Size", "Pattern", "Variable"] : this.connectByNoColor ? ["Color", "Shape", "Size", "Pattern", "Variable", "Sample"] : ["Color", "Shape", "Size", "Pattern", "Connect", "Variable", "Sample"];
            var e = n[2];
            var o = n[3];
            for (var g = 0; g < k.length; g++) {
                var s = this["legend" + k[g] + "Width"];
                var j = this["legend" + k[g] + "Height"];
                var r = this["legend" + k[g] + "X"];
                var l = this["legend" + k[g] + "Y"];
                var a = this.isHistogramLayout() && k[g] == "Sample";
                if (s > 0) {
                    if (f && !a) {
                        this.setPropertyLegendDimensions(k[g]);
                        s = this["legend" + k[g] + "Width"];
                        j = this["legend" + k[g] + "Height"]
                    }
                    var d = ("draw" + k[g] + "Legend").replace("Node", "").replace("Edge", "").replace("Decoration", "Color");
                    var c = this["legend" + k[g] + "Meta"];
                    var p = this.getXYLegendCoords(k[g], e, o);
                    if (r && l) {
                        this[d](r, l, c, k[g]);
                        this["legend" + k[g] + "CurX"] = r;
                        this["legend" + k[g] + "CurY"] = l
                    } else {
                        this[d](p[0], p[1], c, k[g]);
                        this["legend" + k[g] + "CurX"] = p[0];
                        this["legend" + k[g] + "CurY"] = p[1]
                    }
                    if (this.legendPosition.match(/right|left/i)) {
                        o = p[3] + this.margin
                    } else {
                        e = p[2] + this.margin
                    }
                }
            }
            for (var g = 0; g < this.legend.length; g++) {
                if (this.graphType == "Network" && !this.showDecorations) {
                    continue
                }
                var b = "Custom" + g;
                var s = this["legend" + b + "Width"];
                var j = this["legend" + b + "Height"];
                var r = this["legend" + b + "X"];
                var l = this["legend" + b + "Y"];
                var p = this.getXYLegendCoords(b, e, o);
                if (r && l) {
                    this.drawCustomLegend(r, l, s, j, this.legend[g]);
                    this["legend" + b + "CurX"] = r;
                    this["legend" + b + "CurY"] = l
                } else {
                    this.drawCustomLegend(p[0], p[1], s, j, this.legend[g]);
                    this["legend" + b + "CurX"] = p[0];
                    this["legend" + b + "CurY"] = p[1]
                }
                if (this.legendPosition.match(/right|left/i)) {
                    o = p[3] + this.margin
                } else {
                    e = p[2] + this.margin
                }
            }
        }
    };
    this.setMarker = function(t) {
        var g = this;
        var A = function(F) {
            var p = g.meta.render.objects;
            for (var j = 0; j < p.length; j++) {
                var m = p[j];
                if (m.type == "Data" && m.idx) {
                    var h = m.idx.join(":");
                    if (h == F || h == F + ":false" || h == F + ":true" || h == F + ":box") {
                        if (g.layoutValid) {
                            if (m.layout == g.layoutCurrent) {
                                return m
                            }
                        } else {
                            return m
                        }
                    }
                }
            }
            return false
        };
        var c = function() {
            if (t.fontSize) {
                return (t.fontStyle || "") + " " + parseInt(t.fontSize) + "px " + g.fontName
            } else {
                return g.decorationFont
            }
        };
        if (!t.variable) {
            return false
        }
        var e = this.graphType.match(/Treemap|Stacked|Dotplot/) ? true : false;
        var D = this.isArray(t.variable) ? this.getVariableIndices(t.variable) : this.getVariableIndices([t.variable]);
        var b = t.variable2 && this.isArray(t.variable2) ? this.getVariableIndices(t.variable2) : t.variable2 ? this.getVariableIndices([t.variable2]) : false;
        var B = [];
        var a;
        var z = false;
        var E = false;
        if (this.layoutValid && this.data.l.smps && this.data.l.smps[this.layoutCurrent]) {
            if (this.graphType == "Boxplot" && !this.showBoxplotOriginalData) {
                for (var x = 0; x < this.data.w.grps.length; x++) {
                    for (var w = 0; w < this.data.w.grps[x].length; w++) {
                        if (this.data.y.smps[this.data.w.grps[x][w]] == t.sample) {
                            B.push(x);
                            break
                        }
                    }
                }
            } else {
                for (var x = 0; x < this.data.l.smps[this.layoutCurrent].length; x++) {
                    if (this.data.l.smps[this.layoutCurrent][x] == t.sample) {
                        B.push(this.data.l.ids[this.layoutCurrent][x])
                    }
                }
            }
            if (!B.length && this.isGroupedData) {
                if (this.data.l.name[this.layoutCurrent] == t.sample) {
                    B.push(this.data.l.ids[this.layoutCurrent][0])
                }
            }
            if (this.isArray(t.scope)) {
                if (this.data.x) {
                    for (var x = 0; x < B.length; x++) {
                        var n = B[x];
                        var y = 0;
                        for (var o in this.data.x) {
                            if (t.scope.includes(this.data.x[o][n])) {
                                y++
                            }
                        }
                        if (y == t.scope.length) {
                            B = n;
                            break
                        }
                    }
                    if (this.isArray(B)) {
                        B = B[0]
                    }
                } else {
                    B = B[0]
                }
            } else {
                B = B[0]
            }
        } else {
            B = this.isArray(t.sample) ? this.getSampleIndices(t.sample, e) : this.getSampleIndices([t.sample], e);
            a = t.sample2 && this.isArray(t.sample2) ? this.getSampleIndices(t.sample2, e) : t.sample2 ? this.getSampleIndices([t.sample2], e) : false
        }
        if (t.group && !z) {
            z = [this.getSampleIndices(t.group)]
        }
        if (t.group2) {
            E = [this.getSampleIndices(t.group2)]
        }
        var q = this.graphType == "Boxplot" && !this.showBoxplotOriginalData && z.length ? D.concat(z).join(":") : z ? D.concat(z).concat(B).join(":") : D.concat(B).join(":");
        var s = b && a && E ? b.concat(E).concat(a).join(":") : b && a ? b.concat(a).join(":") : false;
        var u = A(q);
        var v = s ? A(s) : false;
        var d = u ? this.centroidArea(u.area) : false;
        var r = v ? this.centroidArea(v.area) : false;
        var k = u ? u.params[4] : 0;
        var C = u ? u.params[3] : 0;
        var l = v ? v.params[4] : 0;
        var f = v ? v.params[3] : 0;
        if (t.id == null) {
            t.id = this.newId("-marker-")
        }
        t.vi = D;
        t.si = B;
        t.vi2 = b;
        t.si2 = a;
        if (!this.isArray(t.variable)) {
            t.variable = [t.variable]
        }
        if (!this.isArray(t.sample)) {
            t.sample = [t.sample]
        }
        if (t.variable2 && !this.isArray(t.variable2)) {
            t.variable2 = [t.variable2]
        }
        if (t.sample2 && !this.isArray(t.sample2)) {
            t.sample2 = [t.sample2]
        }
        if (!t.type) {
            t.type = "line"
        }
        t.b = [this.marginLeft + this.offsetX + this.left, this.marginTop + this.offsetY + this.top, this.x, this.y];
        t.len = this.measureText(t.text, c());
        t.width = this.measureTextWidth(t.text, c());
        t.tx = d && this.graphOrientation == "vertical" ? d[0] : d && this.graphOrientation != "vertical" ? d[0] + (C / 2) + (t.width * 2) + (this.margin * 2) : false;
        t.ty = d && t.type != "line" && this.graphOrientation == "vertical" ? d[1] - ((k / 2) + t.width) : d && t.type != "line" && this.graphOrientation != "vertical" ? d[1] : d ? d[1] : false;
        t.tx2 = r && this.graphOrientation == "vertical" ? r[0] : r && this.graphOrientation != "vertical" ? r[0] + (f / 2) + (t.width * 2) + (this.margin * 2) : false;
        t.ty2 = r && t.type != "line" && this.graphOrientation == "vertical" ? r[1] - ((l / 2) + t.width) : r && t.type != "line" && this.graphOrientation != "vertical" ? r[1] : r ? r[1] : false;
        if (d && this.graphType.match(/Scatter/)) {
            t.tx = d[0];
            t.ty = d[1]
        }
        if (t.offsetX && d) {
            t.tx = d[0] + t.offsetX
        }
        if (t.offsetX && r) {
            t.tx2 = r[0] + t.offsetX
        }
        if (t.offsetY && d) {
            t.ty = d[1] + t.offsetY
        }
        if (t.offsetY && r) {
            t.ty2 = r[1] + t.offsetY
        }
        return t
    };
    this.getMarker = function(c) {
        if (c && this.decorations && this.decorations.marker) {
            for (var b = 0; b < this.decorations.marker.length; b++) {
                var a = this.decorations.marker[b];
                if (c == a.id) {
                    return a
                }
            }
        }
    };
    this.drawMarkers = function(a) {
        var f = this;
        var z = function(d, c, h) {
            if (f.layoutValid) {
                if (d.si != null) {
                    return d.ty > f.offsetY && d.ty < f.offsetY + f.layoutParams[f.layoutCurrent].height && d.tx > f.offsetX && d.tx < f.offsetX + f.layoutParams[f.layoutCurrent].width
                } else {
                    return false
                }
            } else {
                return d.ty > 0 && d.ty < f.height && d.tx > 0 && d.tx < f.width
            }
        };
        var b = function() {
            if (A.fontSize) {
                return (A.fontStyle || "") + " " + parseInt(A.fontSize) + "px " + f.fontName
            } else {
                return f.decorationFont
            }
        };
        if (a) {
            this.clearHighlightCanvas();
            this.isHighlightCanvas = true
        } else {
            if (this.moveMarker) {
                return
            }
        }
        if (this.decorations && this.decorations.marker) {
            var G = this.decorations.marker;
            for (var D = 0; D < G.length; D++) {
                var A = this.setMarker(G[D]);
                if (A && A.tx && A.ty && A.b) {
                    var o, l, F, e;
                    o = A.offsetX ? A.tx : A.x ? A.b[0] + (A.x * A.b[2]) : this.graphOrientation == "vertical" ? A.tx : A.tx + this.margin;
                    l = A.offsetY ? A.ty : A.y ? A.b[1] + (A.y * A.b[3]) : this.graphOrientation == "vertical" ? A.ty - this.margin : A.ty;
                    F = A.tx2 && A.offsetX ? A.tx2 : A.tx2 && this.graphOrientation == "vertical" ? A.tx2 : A.tx2 ? A.tx2 + this.margin : false;
                    e = A.ty2 && A.offsetY ? A.ty2 : A.ty2 && this.graphOrientation == "vertical" ? A.ty2 - this.margin : A.ty2 ? A.ty2 : false;
                    if (A.type == "comparison" && o && l && F && e) {
                        if (this.graphOrientation == "vertical") {
                            l = Math.min(l, e) - this.getFontPt(b(A));
                            e = l
                        } else {
                            o = Math.max(o, F);
                            F = o
                        }
                    }
                    if (z(A, o, l)) {
                        var q = A.scope || false;
                        if (q) {
                            var p = this.layoutValid ? false : true;
                            if (this.layoutValid) {
                                var t = this.data.l.name[this.layoutCurrent];
                                if (!this.isArray(t)) {
                                    t = [t]
                                }
                                for (var C = 0; C < t.length; C++) {
                                    var w = t[C].toString().replace("\x00", "");
                                    if (this.isArray(q)) {
                                        for (var B = 0; B < q.length; B++) {
                                            if (q[B].toString() == w) {
                                                p = true;
                                                break
                                            }
                                        }
                                    } else {
                                        if (q.toString() == w) {
                                            p = true;
                                            break
                                        }
                                    }
                                }
                            }
                            if (!p) {
                                continue
                            }
                        }
                        var g = A.rotate ? Math.PI * A.rotate / 180 : false;
                        var v;
                        if (A.type == "comparison") {
                            if (this.graphOrientation == "vertical") {
                                v = this.toRender({
                                    p: ["drawText", A.text, (o + F) / 2, l, b(A), A.color || this.decorationsColor, A.align, A.baseline, g],
                                    a: this.getTextArea(A.text, (o + F) / 2, l, b(A), A.color || this.decorationsColor, A.align, A.baseline, g),
                                    i: ["Marker:" + A.id],
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                })
                            } else {
                                v = this.toRender({
                                    p: ["drawText", A.text, o + (A.len / 2), (l + e) / 2, b(A), A.color || this.decorationsColor, A.align, A.baseline, g],
                                    a: this.getTextArea(A.text, o + (A.len / 2), (l + e) / 2, b(A), A.color || this.decorationsColor, A.align, A.baseline, g),
                                    i: ["Marker:" + A.id],
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                })
                            }
                        } else {
                            v = this.toRender({
                                p: ["drawText", A.text, o, l, b(A), A.color || this.decorationsColor, A.align, A.baseline, g],
                                a: this.getTextArea(A.text, o, l, b(A), A.color || this.decorationsColor, A.align, A.baseline, g),
                                i: ["Marker:" + A.id],
                                t: "Decorations",
                                d: this.moveMarker ? true : false
                            })
                        }
                        var u = this.meta.render.objects[v].area;
                        if (A.type == "comparison") {
                            var H = A.color || this.decorationsColor;
                            var E = this.getFontPt(b(A));
                            if (this.graphOrientation == "vertical") {
                                this.toRender({
                                    p: ["drawLine", "line", o, l + E, F, e + E, H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                });
                                this.toRender({
                                    p: ["drawLine", "line", o, l + E - this.margin, o, l + E + this.margin, H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                });
                                this.toRender({
                                    p: ["drawLine", "line", F, e + E - this.margin, F, e + E + this.margin, H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                })
                            } else {
                                this.toRender({
                                    p: ["drawLine", "line", o - E, l, F - E, e, H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                });
                                this.toRender({
                                    p: ["drawLine", "line", o - (E + this.margin), l, o + this.margin - E, l, H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                });
                                this.toRender({
                                    p: ["drawLine", "line", F - (E + this.margin), e, F + this.margin - E, e, H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                })
                            }
                        }
                        if (A.type == "line") {
                            var H = A.color || this.decorationsColor;
                            var E;
                            A.curX = o;
                            A.curY = l;
                            if (A.tx < u[1] - A.len) {
                                E = (u[2] + u[4]) / 2;
                                this.toRender({
                                    p: ["drawLine", "line", u[1] - this.margin, u[2], u[1] - this.margin, u[4], H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                });
                                this.toRender({
                                    p: ["drawLine", A.type, A.tx, A.ty, u[1] - this.margin, E, H],
                                    g: v,
                                    t: "Decorations",
                                    d: this.moveMarker ? true : false
                                })
                            } else {
                                if (A.tx > u[3] + A.len) {
                                    E = (u[2] + u[4]) / 2;
                                    this.toRender({
                                        p: ["drawLine", "line", u[3] + this.margin, u[2], u[3] + this.margin, u[4], H],
                                        g: v,
                                        t: "Decorations",
                                        d: this.moveMarker ? true : false
                                    });
                                    this.toRender({
                                        p: ["drawLine", A.type, A.tx, A.ty, u[3] + this.margin, E, H],
                                        g: v,
                                        t: "Decorations",
                                        d: this.moveMarker ? true : false
                                    })
                                } else {
                                    if (A.ty > u[4] + (A.width * 0.2)) {
                                        E = (u[1] + u[3]) / 2;
                                        this.toRender({
                                            p: ["drawLine", "line", u[1], u[4] + this.margin, u[3], u[4] + this.margin, H],
                                            g: v,
                                            t: "Decorations",
                                            d: this.moveMarker ? true : false
                                        });
                                        this.toRender({
                                            p: ["drawLine", A.type, A.tx, A.ty, E, u[4] + this.margin, H],
                                            g: v,
                                            t: "Decorations",
                                            d: this.moveMarker ? true : false
                                        })
                                    } else {
                                        if (A.ty < u[2] - (A.width * 0.2)) {
                                            E = (u[1] + u[3]) / 2;
                                            this.toRender({
                                                p: ["drawLine", "line", u[1], u[2] - this.margin, u[3], u[2] - this.margin, H],
                                                g: v,
                                                t: "Decorations",
                                                d: this.moveMarker ? true : false
                                            });
                                            this.toRender({
                                                p: ["drawLine", A.type, A.tx, A.ty, E, u[2] - this.margin, H],
                                                g: v,
                                                t: "Decorations",
                                                d: this.moveMarker ? true : false
                                            })
                                        } else {
                                            if (A.tx < u[1]) {
                                                E = (u[2] + u[4]) / 2;
                                                this.toRender({
                                                    p: ["drawLine", "line", u[1] - this.margin, u[2], u[1] - this.margin, u[4], H],
                                                    g: v,
                                                    t: "Decorations",
                                                    d: this.moveMarker ? true : false
                                                });
                                                this.toRender({
                                                    p: ["drawLine", A.type, A.tx, A.ty, u[1] - this.margin, E, H],
                                                    g: v,
                                                    t: "Decorations",
                                                    d: this.moveMarker ? true : false
                                                })
                                            } else {
                                                E = (u[2] + u[4]) / 2;
                                                this.toRender({
                                                    p: ["drawLine", "line", u[3] + this.margin, u[2], u[3] + this.margin, u[4], H],
                                                    g: v,
                                                    t: "Decorations",
                                                    d: this.moveMarker ? true : false
                                                });
                                                this.toRender({
                                                    p: ["drawLine", A.type, A.tx, A.ty, u[3] + this.margin, E, H],
                                                    g: v,
                                                    t: "Decorations",
                                                    d: this.moveMarker ? true : false
                                                })
                                            }
                                        }
                                    }
                                }
                            }
                        } else {
                            A.curX = o;
                            A.curY = l
                        }
                    }
                }
            }
        }
        if (a) {
            this.isHighlightCanvas = false
        }
    }
};
CanvasXpress.prototype.initFilterUtils = function() {
    this.handleSelector = function(l) {
        this.hiddenLegends[l.id] = this.hiddenLegends[l.id] ? false : true;
        var c = !this.hiddenLegends[l.id];
        var m = this.showTransition;
        this.showTransition = false;
        switch (l.type) {
            case "var":
                this.filterVariables(l.type + "s", "exact", (this.isArray(l.name) ? l.name : [l.name]), c);
                break;
            case "smp":
                this.filterSamples(l.type + "s", "exact", (this.isArray(l.name) ? l.name : [l.name]), c);
                break;
            case "series":
                if (this.isHistogramLayout()) {
                    var b = (!this.segregateVariablesBy.length || this.segregateVariablesBy[0] != this.isCreateHistogram.factor) ? l.name[1].split(":")[1] : (this.segregateVariablesBy[0] == this.isCreateHistogram.factor) ? l.name[1].split(":")[0] : false;
                    if (b) {
                        l.name = [l.name[0]];
                        for (var e = 0; e < this.data.y.smps.length; e++) {
                            var g = this.data.y.smps[e].split(":");
                            for (var d = 0; d < g.length; d++) {
                                if (g[d] == b) {
                                    l.name.push(this.data.y.smps[e]);
                                    continue
                                }
                            }
                        }
                    }
                }
                this.filterSamples("smps", "exact", (this.isArray(l.name) ? l.name : [l.name]), c);
                break;
            case "meta":
                var k = this.isOncoprint || this.isMultidimensionalData && !this.meta.data[l.object][l.factor] && this.meta.data[l.object] ? this.meta.data[l.object] : this.meta.data[l.object][l.factor];
                switch (l.object) {
                    case "x":
                        if (k.type == "Numeric") {
                            var h = k.order[l.level];
                            var a = Number(l.level);
                            var f = k.isRange && h == 0 ? Number(l.level) - k.incr : k.isRange ? (k.levels[h - 1] + 1e-8) : Number(l.level);
                            this.filterSamplesByCategory(l.factor, "between", [f, a], c)
                        } else {
                            this.filterSamplesByCategory(l.factor, "exact", (this.isArray(l.level) ? l.level : [l.level]), c)
                        }
                        break;
                    case "z":
                        if (k.type == "Numeric") {
                            var h = k.order[l.level];
                            var a = Number(l.level);
                            var f = k.isRange && h == 0 ? Number(l.level) - k.incr : k.isRange ? (k.levels[h - 1] + 1e-8) : Number(l.level);
                            this.filterVariablesByCategory(l.factor, "between", [f, a], c)
                        } else {
                            this.filterVariablesByCategory(l.factor, "exact", (this.isArray(l.level) ? l.level : [l.level]), c)
                        }
                        break;
                    case "y":
                        var k = this.shapeBy == l.factor ? this.legendShapeMeta : this.sizeBy == l.factor ? this.legendSizeMeta : false;
                        if (!k) {
                            return
                        }
                        var h = 0;
                        for (var e = 0; e < k.vals.length; e++) {
                            if (Number(l.level) == k.vals[e]) {
                                h = e;
                                break
                            }
                        }
                        var a = k.vals[h];
                        var f = h == 0 ? Number(l.level) - 1e-9 : k.vals[h - 1] + 1e-9;
                        this.filterVariablesByCategory(l.factor, "between", [f, a], c);
                        break;
                    case "modified":
                        if (this.meta.data.modified.x && this.meta.data.modified.x.meta && this.meta.data.modified.x.meta[l.factor]) {
                            alert("Ooops! Needs to develop this case!")
                        } else {
                            if (this.meta.data.modified.z && this.meta.data.modified.z.meta && this.meta.data.modified.z.meta[l.factor]) {
                                this.filterUserData("filterSmpBy", l.factor, "exact", [this.meta.data.modified.z.meta[l.factor].order[l.level]], c)
                            }
                        }
                        break;
                    default:
                        if (k && k.type == "Numeric") {
                            var h = k.order[l.level];
                            var a = Number(l.level);
                            var f = k.isRange && h == 0 ? Number(l.level) - k.incr : k.isRange ? (k.levels[h - 1] + 1e-8) : Number(l.level);
                            this.filterDataByCategory(l.object, "between", [f, a], c)
                        } else {
                            this.filterDataByCategory(l.object, "exact", [l.level], c)
                        }
                        break
                }
                break;
            case "data":
                this.filterDataByCategory(l.object, "exact", [l.name], c);
                break
        }
        this.showTransition = m
    };
    this.filterVariables = function(f, e, c, d, a) {
        this.filterUserData("filterVarBy", "vars", e, c, d, a)
    };
    this.filterVariablesByCategory = function(f, e, c, d, a) {
        this.filterUserData("filterVarBy", f, e, c, d, a)
    };
    this.filterSamples = function(f, e, c, d, a) {
        this.filterUserData("filterSmpBy", "smps", e, c, d, a)
    };
    this.filterSamplesByCategory = function(c, f, d, e, a) {
        this.filterUserData("filterSmpBy", c, f, d, e, a)
    };
    this.filterDataByCategory = function(g, f, d, e, a) {
        this.filterUserData("filterDataBy", g, f, d, e, a)
    };
    this.filterUserData = function(j, k, c, l, a, m) {
        if (this.isTransition()) {
            return
        }
        var e = {
            min: ">=",
            max: "<=",
            between: "between",
            like: "like",
            exact: "exact"
        };
        this.showMask();
        var f = this.ungroupGroupedData();
        if (a) {
            for (var d = 0; d < this[j].comp.length; d++) {
                if (this[j].comp[d] == k && this[j].op[d] == e[c] && this[j].cases[d] == false && this[j].type[d] == "Legend" && this.isSameObject(this[j].value[d], l)) {
                    this[j].comp.splice(d, 1);
                    this[j].op.splice(d, 1);
                    this[j].cases.splice(d, 1);
                    this[j].type.splice(d, 1);
                    this[j].value.splice(d, 1)
                }
            }
        } else {
            this[j].comp.push(k);
            this[j].op.push(e[c]);
            this[j].cases.push(false);
            this[j].type.push("Legend");
            this[j].value.push(l)
        }
        this.reset(true, true, false, m);
        this.filterData(f, !m);
        if (this.isGroupedData && this.smpIndices.length > 0) {
            var b = this.cloneObject(this.data.w.grpIdxs);
            this.groupSamples(this.groupingFactors, false, b, true, true, false, f ? false : true)
        }
        this.draw({
            func: "filterUserData",
            par: [j, k, c, l, a, m],
            prop: {
                hiddenLegends: this.hiddenLegends
            }
        })
    };
    this.filterData = function(E, H) {
        if (this.isDOE) {
            return
        }
        this.showMask();
        var y = {};
        var P = {};
        var c = {};
        var J = false;
        var F = this;
        var u = function() {
            var a = [];
            if (F.graphType.match(/line/i) && F.xAxis.length && F.xAxis2.length) {
                a = F.getVariableIndices(F.xAxis);
                return a.concat(F.getVariableIndices(F.xAxis2))
            } else {
                return F.varIndices
            }
        };
        var G = function(s, v, g) {
            if (v.hasOwnProperty(s)) {
                return v[s]
            } else {
                if (s.match(":::")) {
                    var d = s.split(":::");
                    if (g[d[1]]) {
                        d[1] = parseInt(d[1]);
                        for (var k = 0; k < g[d[1]].length; k++) {
                            var h = g[d[1]][k];
                            if (v.hasOwnProperty(h)) {
                                v = v[h]
                            } else {
                                return false
                            }
                        }
                        if (v.hasOwnProperty(d[0])) {
                            return v[d[0]]
                        }
                    }
                }
                return false
            }
        };
        var o = function(a) {
            var d = {
                s: [],
                v: []
            };
            if (F.filterSmpBy.comp.length) {
                for (var g = 0; g < F.filterSmpBy.comp.length; g++) {
                    if (F.filterSmpBy.comp[g]) {
                        if (a && F.filterSmpBy.type[g] != "Legend") {
                            continue
                        }
                        d.s[g] = F.getSampleIndices(F.filterSmpBy.comp[g])
                    }
                }
            }
            if (F.filterVarBy.comp.length) {
                for (var g = 0; g < F.filterVarBy.comp.length; g++) {
                    if (F.filterVarBy.comp[g]) {
                        if (a && F.filterVarBy.type[g] != "Legend") {
                            continue
                        }
                        d.v[g] = F.getSampleIndices(F.filterVarBy.comp[g])
                    }
                }
            }
            return d
        };
        var I = function(aa) {
            var ac = F.motionBy ? F.seq(0, F.data.y.vars.length - 1, 1) : F.graphType.match(/line/i) ? u() : F.varIndices;
            var Z = o(aa);
            var s = [];
            var a;
            var k = false;
            for (var v = 0; v < ac.length; v++) {
                var ad = ac[v];
                var h = false;
                a = F.filterSmpBy;
                if (a.comp.length > 0) {
                    for (var p = 0; p < a.comp.length; p++) {
                        if (a.comp[p]) {
                            if (aa && a.type[p] != "Legend") {
                                continue
                            }
                            var ab = Z.s[p];
                            if (ab >= 0) {
                                k = true;
                                var g = A(F.data.y.data[ad][ab], a.op[p], a.value[p], a.cases[p]);
                                if (F.filterType == "and" && !aa) {
                                    if (g) {
                                        h = true
                                    } else {
                                        h = false;
                                        break
                                    }
                                } else {
                                    if (g) {
                                        h = true;
                                        break
                                    }
                                }
                            }
                        }
                    }
                }
                a = F.filterVarBy;
                if (a.comp.length > 0) {
                    for (var p = 0; p < a.comp.length; p++) {
                        if (a.comp[p]) {
                            if (aa && a.type[p] != "Legend") {
                                continue
                            }
                            var ab = Z.v[p];
                            if (ab == -1) {
                                k = true;
                                var d = a.comp[p] == "vars" ? F.data.y.vars[ad] : F.getMetadataValue(ad, "z", a.comp[p]);
                                var g = A(d, a.op[p], a.value[p], a.cases[p]);
                                if (F.filterType == "and" && !aa) {
                                    if (g) {
                                        h = true
                                    } else {
                                        h = false;
                                        break
                                    }
                                } else {
                                    if (g || h) {
                                        h = true;
                                        break
                                    }
                                }
                            } else {
                                k = true;
                                var d = F.data.y.data[ad][ab];
                                var g = A(d, a.op[p], a.value[p], a.cases[p]);
                                if (F.filterType == "and" && !aa) {
                                    if (g) {
                                        h = true
                                    } else {
                                        h = false;
                                        break
                                    }
                                } else {
                                    if (g || h) {
                                        h = true;
                                        break
                                    }
                                }
                            }
                        }
                    }
                }
                if (h) {
                    s.push(ad)
                }
            }
            return k ? s : false
        };
        var M = function(ad, ac) {
            if (F.isGroupedData && (!E || ac)) {
                var af = F.grpIndices;
                var Z = [];
                var a;
                var s = false;
                for (var aa = 0; aa < af.length; aa++) {
                    var ag = af[aa];
                    var h = false;
                    a = F.filterSmpBy;
                    if (a.comp.length > 0) {
                        for (var v = 0; v < a.comp.length; v++) {
                            if (a.comp[v]) {
                                if (ad && a.type[v] != "Legend") {
                                    continue
                                }
                                s = true;
                                if (a.comp[v] == "smps") {
                                    var g = false;
                                    for (var p = 0; p < F.data.w.grps[ag].length; p++) {
                                        if (A(F.data.y.smps[F.data.w.grps[ag][p]], a.op[v], a.value[v], a.cases[v])) {
                                            g = true;
                                            break
                                        }
                                    }
                                    if (F.filterType == "and" && !ad) {
                                        if (g) {
                                            h = true
                                        } else {
                                            h = false;
                                            break
                                        }
                                    } else {
                                        if (g || h) {
                                            h = true;
                                            break
                                        }
                                    }
                                } else {
                                    var g = A(F.data.w.factors[a.comp[v]][aa], a.op[v], a.value[v], a.cases[v]);
                                    if (F.filterType == "and" && !ad) {
                                        if (g) {
                                            h = true
                                        } else {
                                            h = false;
                                            break
                                        }
                                    } else {
                                        if (g || h) {
                                            h = true;
                                            break
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (h) {
                        Z.push(ag)
                    }
                }
            } else {
                var af = F.smpIndices;
                var ab = o(ad);
                var Z = [];
                var a;
                var s = false;
                for (var aa = 0; aa < af.length; aa++) {
                    var ag = af[aa];
                    var h = false;
                    a = F.filterVarBy;
                    if (a.comp.length > 0) {
                        for (var v = 0; v < a.comp.length; v++) {
                            if (a.comp[v]) {
                                if (ad && a.type[v] != "Legend") {
                                    continue
                                }
                                var ae = ab.v[v];
                                if (ae >= 0) {
                                    s = true;
                                    var g = A(F.data.y.data[ae][ag], a.op[v], a.value[v], a.cases[v]);
                                    if (F.filterType == "and" && !ad) {
                                        if (g) {
                                            h = true
                                        } else {
                                            h = false;
                                            break
                                        }
                                    } else {
                                        if (g) {
                                            h = true;
                                            break
                                        }
                                    }
                                }
                            }
                        }
                    }
                    a = F.filterSmpBy;
                    if (a.comp.length > 0) {
                        for (var v = 0; v < a.comp.length; v++) {
                            if (a.comp[v]) {
                                if (ad && a.type[v] != "Legend") {
                                    continue
                                }
                                var ae = ab.s[v];
                                if (ae == -1) {
                                    s = true;
                                    var d = a.comp[v] == "smps" ? F.data.y.smps[ag] : F.getMetadataValue(ag, "x", a.comp[v], true);
                                    var g = A(d, a.op[v], a.value[v], a.cases[v]);
                                    if (F.filterType == "and" && !ad) {
                                        if (g) {
                                            h = true
                                        } else {
                                            h = false;
                                            break
                                        }
                                    } else {
                                        if (g || h) {
                                            h = true;
                                            break
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (h) {
                        Z.push(ag)
                    }
                }
            }
            return s ? Z : false
        };
        var A = function(j, s, h, g) {
            if (!s) {
                return true
            }
            if (F.filterSkipNullValues && (j == null || j == "")) {
                return true
            }
            if (s == ">") {
                return parseFloat(j) - parseFloat(h) > 0
            } else {
                if (s == ">=") {
                    return parseFloat(j) - parseFloat(h) > 0 || parseFloat(j) - parseFloat(h) == 0
                } else {
                    if (s == "<") {
                        return parseFloat(j) - parseFloat(h) < 0
                    } else {
                        if (s == "<=") {
                            return parseFloat(j) - parseFloat(h) < 0 || parseFloat(j) - parseFloat(h) == 0
                        } else {
                            if (s == "between") {
                                return (parseFloat(j) - parseFloat(h[0]) > 0 || parseFloat(j) - parseFloat(h[0]) == 0) && (parseFloat(j) - parseFloat(h[1]) < 0 || parseFloat(j) - parseFloat(h[1]) == 0)
                            } else {
                                if (s == "=" || s == "==") {
                                    return parseFloat(j) - parseFloat(h) == 0
                                } else {
                                    if (s == "null") {
                                        return j == null
                                    } else {
                                        if (s == "not null") {
                                            return j != null
                                        } else {
                                            if (s == "exact") {
                                                for (var d = 0; d < h.length; d++) {
                                                    if ((j + "").toString() == (h[d] + "").toString()) {
                                                        return true
                                                    }
                                                }
                                                return false
                                            } else {
                                                if (s == "like" || s == "not like") {
                                                    var k = false;
                                                    if (g) {
                                                        for (var d = 0; d < h.length; d++) {
                                                            if ((j + "").search(h[d] + "") != -1 || h[d].toString() == j.toString()) {
                                                                k = true;
                                                                if (s == "like") {
                                                                    break
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        var a = (j + "").toLowerCase();
                                                        for (var d = 0; d < h.length; d++) {
                                                            var p = (h[d] + "").toLowerCase();
                                                            if (a.search(p) != -1 || a.toString() == p.toString()) {
                                                                k = true;
                                                                if (s == "like") {
                                                                    break
                                                                }
                                                            }
                                                        }
                                                    }
                                                    return s == "like" ? k : !k
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        };
        var w = function(a) {
            if (!c[a]) {
                c[a] = 0
            }
            c[a]++
        };
        if (this.graphType == "Genome" && this.filterFeatureBy.comp.length > 0) {
            for (var T = 0; T < this.filterFeatureBy.comp.length; T++) {
                if (this.filterFeatureBy.comp[T]) {
                    for (var S = 0; S < this.data.tracks.length; S++) {
                        var q = this.data.tracks[S];
                        var e = q.data;
                        for (var R = 0; R < e.length; R++) {
                            var B = e[R];
                            if (this.filterSkipNullKeys && !B.hasOwnProperty(this.filterFeatureBy.comp[T])) {
                                continue
                            }
                            var K = G(this.filterFeatureBy.comp[T], B, this.featuresProperties);
                            if (!A(K, this.filterFeatureBy.opp[T], this.filterFeatureBy.value[T], this.filterFeatureBy.cases[T])) {
                                B.hide = this.filterType == "and" ? true : y[S + ":" + R] ? false : true;
                                P[S + ":" + R] = true
                            } else {
                                y[S + ":" + R] = true;
                                if (this.filterType == "or" && P[S + ":" + R]) {
                                    B.hide = false
                                }
                            }
                        }
                    }
                }
            }
        } else {
            if (this.graphType == "Network" && (this.filterNodeBy.comp.length > 0 || this.filterEdgeBy.comp.length)) {
                for (var T = 0; T < this.filterNodeBy.comp.length; T++) {
                    if (this.filterNodeBy.comp[T]) {
                        for (var S = 0; S < this.data.nodes.length; S++) {
                            if (this.filterSkipNullKeys && !this.data.nodes[S].hasOwnProperty(this.filterNodeBy.comp[T])) {
                                continue
                            }
                            if (this.data.nodes[S].hide) {
                                continue
                            }
                            var K = G(this.filterNodeBy.comp[T], this.data.nodes[S], this.nodesProperties);
                            if (!A(K, this.filterNodeBy.op[T], this.filterNodeBy.value[T], this.filterNodeBy.cases[T])) {
                                this.data.nodes[S].hide = this.filterType == "and" ? true : y[this.data.nodes[S].id] ? false : true;
                                P[this.data.nodes[S].id] = true
                            } else {
                                y[this.data.nodes[S].id] = true;
                                if (this.filterType == "or" && P[this.data.nodes[S].id]) {
                                    this.data.nodes[S].hide = false
                                }
                            }
                        }
                    }
                }
                for (var T = 0; T < this.filterEdgeBy.comp.length; T++) {
                    if (this.filterEdgeBy.comp[T]) {
                        for (var S = 0; S < this.data.edges.length; S++) {
                            var z = this.data.nodes[this.data.nodeIndices[this.data.edges[S].id1]];
                            var x = this.data.nodes[this.data.nodeIndices[this.data.edges[S].id2]];
                            var D = z.id + ":" + x.id;
                            if (this.filterSkipNullKeys && !this.data.edges[S].hasOwnProperty(this.filterEdgeBy.comp[T])) {
                                continue
                            }
                            var K = G(this.filterEdgeBy.comp[T], this.data.edges[S], this.edgesProperties);
                            if (!A(K, this.filterEdgeBy.op[T], this.filterEdgeBy.value[T], this.filterEdgeBy.cases[T])) {
                                this.data.edges[S].hide = this.filterType == "and" ? true : y[D] ? false : true;
                                P[D] = true
                            } else {
                                y[D] = true;
                                if (this.filterType == "or" && P[D]) {
                                    this.data.edges[S].hide = false
                                }
                            }
                            if (!this.data.edges[S].hide) {
                                w(z.id);
                                w(x.id)
                            }
                        }
                    }
                }
                if (this.filterEdgeBy.comp.length > 0) {
                    for (var T = 0; T < this.data.nodes.length; T++) {
                        var b = this.data.nodes[T];
                        if (!c[b.id]) {
                            b.hide = true
                        }
                    }
                }
            } else {
                if (this.isCreateHistogram && !H) {
                    if (this.filterVarBy.length > 0) {
                        var X = this.dataStndBy;
                        var U = this.data.y.histogram;
                        console.log("Not implemented Yet")
                    }
                } else {
                    if (this.graphType == "Scatter2D" && this.scatterPlotMatrix && this.scatterPlotMatrixType.match(/correlation|all/) && !H) {
                        if (this.filterVarBy.length > 0) {
                            console.log("Not implemented Yet")
                        }
                    } else {
                        if (this.filterDataBy.comp.length > 0) {
                            var N = [];
                            var f = this.filterDataBy;
                            for (var T = 0; T < this.varIndices.length; T++) {
                                var K = this.varIndices[T];
                                var V = false;
                                for (var S = 0; S < this.smpIndices.length; S++) {
                                    var L = this.smpIndices[S];
                                    for (var R = 0; R < f.comp.length; R++) {
                                        var t = this.data.y[f.comp[R]][K][L];
                                        var r = f.value[R] == "No Alteration" ? [""] : f.value[R];
                                        var C = A(t, f.op[R], r, f.cases[R]);
                                        if (this.filterType == "and" && !H) {
                                            if (C) {
                                                V = true
                                            } else {
                                                V = false;
                                                break
                                            }
                                        } else {
                                            if (C) {
                                                V = true;
                                                break
                                            }
                                        }
                                    }
                                    if (V) {
                                        break
                                    }
                                }
                                if (V) {
                                    N.push(K)
                                }
                            }
                            if (H) {
                                for (var T = 0; T < N.length; T++) {
                                    this.hiddenVars[N[T]] = true
                                }
                            }
                        } else {
                            if (this.filterVarBy.comp.length > 0 || this.filterSmpBy.comp.length > 0) {
                                var N = I(H);
                                var Q = M(H);
                                var n = this.isGroupedData && this.layoutValid ? M(H, true) : false;
                                delete this.data.bubble;
                                delete this.data.tree;
                                if (H && N) {
                                    for (var T = 0; T < N.length; T++) {
                                        this.hiddenVars[N[T]] = true
                                    }
                                } else {
                                    if (this.filterMode != "remove" && N) {
                                        for (var T = 0; T < this.hiddenVars.length; T++) {
                                            this.hiddenVars[T] = true
                                        }
                                        for (var T = 0; T < N.length; T++) {
                                            this.hiddenVars[N[T]] = false
                                        }
                                    } else {
                                        if (N) {
                                            this.varIndices = N
                                        }
                                    }
                                }
                                if (this.isGroupedData && !E) {
                                    if (H && Q) {
                                        for (var T = 0; T < Q.length; T++) {
                                            this.hiddenGrps[Q[T]] = true
                                        }
                                    } else {
                                        if (Q) {
                                            this.grpIndices = Q
                                        }
                                    }
                                } else {
                                    if (H && Q) {
                                        for (var T = 0; T < Q.length; T++) {
                                            this.hiddenSmps[Q[T]] = true
                                        }
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.axesType == "X" && this.xAxisIndices.length > 1) {
                                                if (this.hiddenSmps[this.yAxisIndices[0]]) {
                                                    this.hiddenSmps[this.yAxisIndices[0]] = false
                                                }
                                            } else {
                                                if (this.axesType == "Y" && this.yAxisIndices.length > 1) {
                                                    if (this.hiddenSmps[this.xAxisIndices[0]]) {
                                                        this.hiddenSmps[this.xAxisIndices[0]] = false
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        if (this.filterMode != "remove" && Q) {
                                            for (var T = 0; T < this.hiddenSmps.length; T++) {
                                                this.hiddenSMps[T] = true
                                            }
                                            for (var T = 0; T < Q.length; T++) {
                                                this.hiddenSmps[Q[T]] = false
                                            }
                                        } else {
                                            if (Q) {
                                                this.smpIndices = Q
                                            }
                                        }
                                    }
                                }
                                if (n && H) {
                                    this.hiddenGrpsLayout = [];
                                    for (var T = 0; T < n.length; T++) {
                                        this.hiddenGrpsLayout[n[T]] = true
                                    }
                                } else {
                                    this.hiddenGrpsLayout = false
                                }
                            } else {
                                this.hiddenGrpsLayout = false
                            }
                        }
                    }
                }
            }
        }
        if (this.layoutComb && this.layoutParams && !this.graphType.match(/Scatter/)) {
            this.restoreEmptyCompartments();
            var m = this.getObjectArray(this.varIndices);
            var l = this.getObjectArray(this.smpIndices);
            for (var T = 0; T < this.data.l.comp.length; T++) {
                var O = this.layoutParams[T];
                var K = O.startingVarIndices;
                var L = O.startingSmpIndices;
                var W = O.startingGrpIndices;
                var Y = [];
                if (K) {
                    for (var S = 0; S < K.length; S++) {
                        if (m.hasOwnProperty(K[S])) {
                            Y.push(K[S])
                        }
                    }
                    O.varIndices = Y
                }
                Y = [];
                if (this.isGroupedData) {
                    if (W) {
                        for (var S = 0; S < W.length; S++) {
                            if (l.hasOwnProperty(W[S])) {
                                Y.push(W[S])
                            }
                        }
                        O.grpIndices = Y
                    }
                } else {
                    if (L) {
                        for (var S = 0; S < L.length; S++) {
                            if (l.hasOwnProperty(L[S])) {
                                Y.push(L[S])
                            }
                        }
                        O.smpIndices = Y
                    }
                }
            }
        }
    };
    this.resetFilters = function(f, b) {
        var e = this;
        var d = function(g) {
            if (b != null && e[g].comp.length > 0) {
                e[g].comp.splice(b, 1);
                e[g].op.splice(b, 1);
                e[g].value.splice(b, 1);
                e[g].cases.splice(b, 1);
                e[g].type.splice(b, 1)
            } else {
                e[g].comp = [];
                e[g].op = [];
                e[g].value = [];
                e[g].cases = [];
                e[g].type = []
            }
        };
        var a = f ? [f] : ["filterSmpBy", "filterVarBy", "filterNodeBy", "filterEdgeBy", "filterFeatureBy"];
        this.hiddenLegends = {};
        for (var c = 0; c < a.length; c++) {
            d(a[c])
        }
        delete this.data.bubble;
        delete this.data.tree
    };
    this.isHidden = function(b, c, a, d) {
        if (this.graphType == "Network") {
            return false
        } else {
            if (this.graphType == "Boxplot" && !a) {
                if (!this.showBoxplotOriginalData) {
                    if (this.hiddenGrps) {
                        return this.hiddenVars[b] || this.hiddenGrps[c]
                    } else {
                        return this.hiddenVars[b] || this.hiddenSmps[c]
                    }
                } else {
                    if (c != null) {
                        if (this.hiddenGrps) {
                            return this.hiddenVars[b] || (d ? this.hiddenGrps[c] : this.hiddenSmps[c])
                        } else {
                            return this.hiddenVars[b] || this.hiddenSmps[c]
                        }
                    } else {
                        return this.hiddenVars[b]
                    }
                }
            } else {
                if (this.graphType == "Gantt") {
                    return a ? this.hiddenLegends[a] : this.hiddenSmps[c]
                } else {
                    if (this.graphType == "Dotplot") {
                        return a ? this.hiddenLegends[a] : (this.hiddenVars[b] || this.hiddenSmps[c])
                    } else {
                        if (this.graphType == "Bar" && this.is3DPlot) {
                            return a ? this.hiddenLegends[a] : this.hiddenVars[b]
                        } else {
                            if (a) {
                                return this.hiddenLegends[a]
                            } else {
                                if (this.isGroupedData && this.hiddenGrps) {
                                    return this.hiddenVars[b] || this.hiddenGrps[c]
                                } else {
                                    return this.hiddenVars[b] || this.hiddenSmps[c]
                                }
                            }
                        }
                    }
                }
            }
        }
    }
};
CanvasXpress.prototype.initClusterUtils = function() {
    this.setDendrograms = function() {
        if (this.smpDendrogramNewick) {
            this.smpDendrogram = {};
            this.parseNewick(this.smpDendrogramNewick, "smpDendrogram")
        }
        if (this.varDendrogramNewick) {
            this.varDendrogram = {};
            this.parseNewick(this.varDendrogramNewick, "varDendrogram")
        }
    };
    this.parseNewick = function(a, d) {
        var k = this;
        var w = 0;
        var b = [];
        var t = {};
        var c = 0;
        var g = 0;
        var u = 0;
        var p = 0;
        var j = [];
        var z = 0;
        var A = 0;
        this[d + "NodeId"] = 0;
        var q = a.split(/\s*(;|\(|\)|,|:)\s*/);
        var l = function(D) {
            var x = [];
            for (var C = 0; C < D.length; C++) {
                x.push(D[C].mid)
            }
            return k.mean(x)
        };
        var o = function(C) {
            if (C.children) {
                C.depth = g++;
                z = Math.max(z, C.depth);
                for (var x = 0; x < C.children.length; x++) {
                    o(C.children[x]);
                    if (C.children[x].children) {
                        C.children[x].mid = l(C.children[x].children)
                    }
                }
                g--;
                p++
            } else {
                C.depth = g;
                u++
            }
        };
        var e = function(C) {
            if (C.children) {
                for (var x = 0; x < C.children.length; x++) {
                    e(C.children[x]);
                    if (C.children[x].children) {
                        C.children[x].len = 1 + z - C.children[x].depth
                    }
                }
            } else {
                C.len = 1 + z - C.depth
            }
        };
        for (var y = 0; y < q.length; y++) {
            if (!w) {
                var h = q[y];
                switch (h) {
                    case "(":
                        var B = {};
                        t.children = [B];
                        b.push(t);
                        t = B;
                        break;
                    case ",":
                        if (b.length > 0) {
                            var B = {};
                            b[b.length - 1].children.push(B);
                            t = B
                        } else {
                            w++
                        }
                        break;
                    case ")":
                        t = b.pop();
                        t.nodeId = this[d + "NodeId"]++;
                        break;
                    case ":":
                        break;
                    default:
                        var m = q[y - 1];
                        if (m == ")" || m == "(" || m == ",") {
                            t.name = h;
                            if (h && !t.children) {
                                var s = d == "smpDendrogram" ? this.getSampleIndices(h) : this.getVariableIndices(h);
                                if (s == -1) {
                                    s = parseInt(h);
                                    t.name = d == "smpDendrogram" ? this.data.y.smps[s] : this.data.y.vars[s];
                                    t.idx = s
                                } else {
                                    t.idx = s
                                }
                                j.push(t.idx);
                                t.ord = c++;
                                t.mid = t.ord
                            }
                        } else {
                            if (m == ":") {
                                t.height = parseFloat(h);
                                A++
                            }
                        }
                }
            } else {
                if (w < 3) {
                    this.parseNewick("(" + a + ")", d);
                    return
                } else {
                    alert(d + "is not in a valid Newick format");
                    this[d] = false;
                    if (d == "varDendrogram") {
                        this.varDendrogramNewick = false
                    } else {
                        this.smpDendrogramNewick = false
                    }
                    return
                }
            }
        }
        o(t);
        e(t);
        t.max = z + 1;
        t.leafs = u;
        t.useHeight = A == p;
        t.mid = l(t.children);
        t.axis = d;
        this[d] = t;
        var r = {
            labl: d == "varDendrogram" ? "variable" : "sample",
            show: d == "varDendrogram" ? "showVarDendrogram" : "showSmpDendrogram",
            data: d == "varDendrogram" ? "vars" : "smps",
            indx: d == "varDendrogram" ? "varIndices" : "smpIndices",
            strt: d == "varDendrogram" ? "varIndicesStart" : this.isGroupedData ? "grpIndicesStart" : "smpIndicesStart"
        };
        if (this[r.show]) {
            var f;
            if (this[r.strt] < 0) {
                if (u != this.data.y[r.data].length) {
                    f = "Dude! The length of the " + r.labl + " nodes in the dendrogram (" + u + ") is different to that one in the data (" + this.data.y[r.data].length + "). This ain't gonna work!";
                    this.logConsole(f);
                    if (this.verbose) {
                        this.flashInfoSpan(100, 100, f, 3000)
                    }
                    this[r.show] = false
                } else {
                    if (u != this[r.indx].length) {
                        f = "Ooops! Cannot show dendrogram with " + u + " nodes when only " + this[r.indx].length + " " + r.labl + " are visible.";
                        this.logConsole(f);
                        if (this.verbose) {
                            this.flashInfoSpan(100, 100, f, 3000)
                        }
                        this[r.show] = false
                    } else {
                        this[r.indx] = j
                    }
                }
            } else {
                var v = this[r.strt] + this[r.indx].length;
                this[r.indx] = [];
                for (var y = this[r.strt]; y < v; y++) {
                    this[r.indx].push(j[y])
                }
            }
        } else {
            if (this[r.strt] < 0) {
                this[r.indx] = j
            } else {
                var v = this[r.strt] + this[r.indx].length;
                this[r.indx] = [];
                for (var y = this[r.strt]; y < v; y++) {
                    this[r.indx].push(j[y])
                }
            }
        }
    };
    this.writeNewick = function(b) {
        var d = "";
        if (b.children) {
            var a = [];
            for (var c = 0; c < b.children.length; c++) {
                a.push(this.writeNewick(b.children[c]))
            }
            if (a.length > 0) {
                d = "(" + a.join(",") + ")"
            }
        } else {
            d = b.idx
        }
        if (b.height) {
            d += ":" + this.sprintf("%.1f", b.height)
        }
        return d
    };
    this.euclidianDistance = function(b, a) {
        b = this.filterNumbers(b, true);
        a = this.filterNumbers(a, true);
        var e = 0;
        if (b.length == a.length) {
            for (var c = 0; c < b.length; c++) {
                e += Math.pow(b[c] - a[c], 2)
            }
            e = Math.sqrt(e)
        }
        return e
    };
    this.manhattanDistance = function(b, a) {
        b = this.filterNumbers(b, true);
        a = this.filterNumbers(a, true);
        var e = 0;
        if (b.length == a.length) {
            for (var c = 0; c < b.length; c++) {
                e += Math.abs(b[c] - a[c])
            }
        }
        return e
    };
    this.maxDistance = function(b, a) {
        b = this.filterNumbers(b, true);
        a = this.filterNumbers(a, true);
        var e = 0;
        if (b.length == a.length) {
            for (var c = 0; c < b.length; c++) {
                e = Math.max(e, Math.abs(b[c] - a[c]))
            }
        }
        return e
    };
    this.classifyKmeansVector = function(f, c) {
        var e = Number.POSITIVE_INFINITY;
        var a = 0;
        for (var d = 0; d < c.length; d++) {
            var b = this[this.distance + "Distance"](f, c[d]);
            if (b < e) {
                e = b;
                a = d
            }
        }
        return a
    };
    this.addVectors = function(c, b) {
        c = this.filterNumbers(c, true);
        b = this.filterNumbers(b, true);
        var a = [];
        if (c.length == b.length) {
            for (var d = 0; d < c.length; d++) {
                a.push(c[d] + b[d])
            }
        }
        return a
    };
    this.compareVectors = function(b, a) {
        if (this.isArray(b) && this.isArray(a)) {
            if (b.length != a.length) {
                return false
            }
            for (var c = 0; c < b.length; c++) {
                if (this.isArray(b[c]) && this.isArray(a[c])) {
                    if (!this.compareArrays(b[c], a[c])) {
                        return false
                    }
                }
                if (b[c] !== a[c]) {
                    return false
                }
            }
            return true
        }
    };
    this.vectorDotProduct = function(b, a) {
        b = this.filterNumbers(b, true);
        a = this.filterNumbers(a, true);
        var d = 0;
        if (b.length == a.length) {
            for (var c = 0; c < b.length; c++) {
                d += b[c] * a[c]
            }
        }
        return d
    };
    this.multiplyVectorByValue = function(a, c) {
        a = this.filterNumbers(a, true);
        for (var b = 0; b < a.length; b++) {
            a[b] *= c
        }
        return a
    };
    this.getCentroid = function(d, g, f, a) {
        var h = [];
        if (g.length == a.length) {
            var e = d + f;
            for (var b = 0; b < g.length; b++) {
                h.push((d * g[b] + f * a[b]) / e)
            }
        }
        return h
    };
    this.createClusterNode = function(i, b, e, f, h, a) {
        var g = {
            id: i,
            left: b,
            right: e,
            dist: f,
            centroid: h
        };
        if (a != null) {
            g.mid = a
        }
        if (b == null && e == null) {
            g.size = 1;
            g.depth = 0
        } else {
            g.size = b.size + e.size;
            g.depth = 1 + Math.max(b.depth, e.depth)
        }
        return g
    };
    this.createRandomCentroids = function(c) {
        var b = this;
        var a = c.slice(0);
        a.sort(function() {
            return (Math.round(b.random()) - 0.5)
        });
        return a.slice(0, this.clusterAxis == "samples" ? this.kmeansSmpClusters : this.kmeansVarClusters)
    };
    this.createRandomVectors = function(d, g) {
        var c = g.length;
        if (d > c) {
            return null
        }
        var l = [];
        var f = [];
        var a = {};
        var m = 0;
        var o = 0;
        var j, b;
        while (o < d) {
            if (m == c) {
                return null
            }
            var h = Math.floor(this.random() * c);
            if (h in a) {
                continue
            }
            a[h] = 1;
            m++;
            j = g[h];
            b = true;
            for (var e = 0; e < o; e++) {
                if (this.compareVectors(j, l[e])) {
                    b = false;
                    break
                }
            }
            if (b) {
                l[o] = j;
                f[o] = h;
                o++
            }
        }
        return {
            vectors: l,
            indices: f
        }
    };
    this.imputeDatum = function(a) {
        var d = [];
        if (this.clusterAxis == "samples") {
            for (var b = 0; b < this.varIndices.length; b++) {
                var c = this.varIndices[b];
                d.push(this.data.y.data[c][a])
            }
        } else {
            for (var b = 0; b < this.smpIndices.length; b++) {
                var c = this.smpIndices[b];
                d.push(this.data.y.data[a][c])
            }
        }
        return this[this.imputeMethod](d)
    };
    this.getIdsForClustering = function() {
        var e = [];
        if (this.clusterAxis == "samples") {
            for (var b = 0; b < this.smpIndices.length; b++) {
                var c = this.smpIndices[b];
                var a = this.getSampleIndices(c);
                e[b] = a == -1 ? c : this.data.y.smps[c]
            }
        } else {
            for (var b = 0; b < this.varIndices.length; b++) {
                var c = this.varIndices[b];
                var a = this.getVariableIndices(c);
                e[b] = a == -1 ? c : this.data.y.smps[c]
            }
        }
        return e
    };
    this.getDataForClustering = function() {
        var h = [];
        var a = [];
        if (this.clusterAxis == "samples") {
            for (var c = 0; c < this.smpIndices.length; c++) {
                h[c] = []
            }
            for (var c = 0; c < this.varIndices.length; c++) {
                var e = this.varIndices[c];
                for (var b = 0; b < this.smpIndices.length; b++) {
                    var f = this.smpIndices[b];
                    var g = this.data.y.data[e][f];
                    if (isNaN(g)) {
                        if (!a[b]) {
                            a[b] = this.imputeDatum(f)
                        }
                        g = a[b]
                    }
                    h[b][c] = g
                }
            }
        } else {
            for (var c = 0; c < this.varIndices.length; c++) {
                h[c] = []
            }
            for (var c = 0; c < this.varIndices.length; c++) {
                var e = this.varIndices[c];
                for (var b = 0; b < this.smpIndices.length; b++) {
                    var f = this.smpIndices[b];
                    var g = this.data.y.data[e][f];
                    if (isNaN(g)) {
                        if (!a[c]) {
                            a[c] = this.imputeDatum(e)
                        }
                        g = a[c]
                    }
                    h[c][b] = g
                }
            }
        }
        return h
    };
    this.cluster = function() {
        var n = function() {
            var i = a[s][0].id;
            var d = a[r][0].id;
            if (i < 0 && d >= 0) {
                return true
            } else {
                if (i < 0 && d < 0) {
                    return d > i
                } else {
                    if (i >= 0 && d >= 0) {
                        return i > d
                    } else {
                        return false
                    }
                }
            }
        };
        var h;
        var z = this.getDataForClustering();
        var v = this.getIdsForClustering();
        var o = [];
        var e = [];
        var B = [];
        var a = [];
        if (!this.meta.tree) {
            this.meta.tree = {}
        }
        var u = this.meta.tree;
        u[this.clusterAxis] = [];
        for (var y = 0; y < z.length; y++) {
            o[y] = []
        }
        o[0][0] = Number.POSITIVE_INFINITY;
        for (var y = 0; y < z.length - 1; y++) {
            for (var x = y + 1; x < z.length; x++) {
                o[x][x] = Number.POSITIVE_INFINITY;
                o[y][x] = this[this.distance + "Distance"](z[y], z[x]);
                o[x][y] = o[y][x]
            }
        }
        for (var y = 0; y < z.length; y++) {
            e[y] = 0;
            for (var x = 0; x < z.length; x++) {
                if (o[y][e[y]] > o[y][x]) {
                    e[y] = x
                }
            }
        }
        for (var y = 0; y < z.length; y++) {
            a[y] = [];
            a[y][0] = this.createClusterNode(v[y], null, null, 0, z[y]);
            B[y] = 1
        }
        var b = -1;
        for (var q = 0; q < z.length - 1; q++) {
            var s = 0;
            for (var y = 0; y < z.length; y++) {
                if (o[y][e[y]] < o[s][e[s]]) {
                    s = y
                }
            }
            var r = e[s];
            if (n()) {
                var c = r;
                r = s;
                s = c
            }
            var f = a[s][0];
            var t = a[r][0];
            var g = this.getCentroid(f.size, f.centroid, t.size, t.centroid);
            var A = this.createClusterNode(b, f, t, o[s][r], g);
            a[s].splice(0, 0, A);
            for (var x = 0; x < z.length; x++) {
                if (this.linkage == "single") {
                    if (o[s][x] > o[r][x]) {
                        o[x][s] = o[s][x] = o[r][x]
                    }
                } else {
                    if (this.linkage == "complete") {
                        if (o[s][x] < o[r][x]) {
                            o[x][s] = o[s][x] = o[r][x]
                        }
                    } else {
                        if (this.linkage == "average") {
                            o[x][s] = o[s][x] = ((B[s] * o[s][x]) + (B[r] * o[r][x])) / (B[s] + B[r])
                        }
                    }
                }
            }
            B[s] += B[r];
            o[s][s] = Number.POSITIVE_INFINITY;
            for (var y = 0; y < z.length; y++) {
                o[y][r] = o[r][y] = Number.POSITIVE_INFINITY
            }
            for (var x = 0; x < z.length; x++) {
                if (e[x] == r) {
                    e[x] = s
                }
            }
            for (var x = 0; x < z.length; x++) {
                for (var w = 0; w < z.length; w++) {
                    if (o[w][x] < o[w][e[w]]) {
                        e[w] = x
                    }
                }
            }
            h = A;
            u[this.clusterAxis].push([f.id, t.id, h.dist]);
            b--
        }
        return this.writeNewickCluster(h, true)
    };
    this.isLeafNode = function(a) {
        if (a.left == null && a.right == null) {
            return true
        } else {
            return false
        }
    };
    this.writeNewickCluster = function(k, g, j) {
        var h = "";
        var e = "";
        var f = false;
        if (this.isLeafNode(k)) {
            f = true;
            if (isNaN(k.id)) {
                h = this.clusterAxis == "variables" ? this.getVariableIndices(k.id) : this.getSampleIndices(k.id)
            } else {
                h = k.id
            }
        } else {
            var b;
            var c = this.writeNewickCluster(k.left, g, true);
            var a = this.writeNewickCluster(k.right, g, false);
            if (k.mid) {
                for (var d = 0; d < k.mid.length; d++) {
                    if (g && k.mid[d].dist) {
                        e += "," + k.mid[d].id + ":" + k.mid[d].dist
                    } else {
                        e += "," + k.mid[d].id
                    }
                    e += k.mid[d].id
                }
            }
            h = "(" + c + e + "," + a + ")"
        }
        if (g && !f) {
            h += ":" + this.sprintf("%.1f", k.dist)
        }
        return h
    };
    this.kmeans = function() {
        var p = this.getDataForClustering();
        var q = this.createRandomCentroids(p);
        var m = new Array(p.length);
        var b = this.clusterAxis == "samples" ? this.kmeansSmpClusters : this.kmeansVarClusters;
        var n = new Array(b);
        var s = 0;
        var v = true;
        while (v) {
            for (var e = 0; e < p.length; e++) {
                m[e] = this.classifyKmeansVector(p[e], q)
            }
            v = false;
            for (var c = 0; c < b; c++) {
                var l = [];
                for (var e = 0; e < m.length; e++) {
                    if (m[e] == c) {
                        l.push(p[e])
                    }
                }
                if (!l.length) {
                    continue
                }
                var o = q[c];
                var u = new Array(o.length);
                for (var f = 0; f < o.length; f++) {
                    var h = 0;
                    for (var e = 0; e < l.length; e++) {
                        if (!isNaN(l[e][f])) {
                            h += l[e][f]
                        }
                    }
                    u[f] = h / l.length;
                    if (u[f] != o[f]) {
                        v = true
                    }
                }
                q[c] = u;
                n[c] = l
            }
            s++;
            if (s > this.maxIterations) {
                v = false
            }
        }
        var r = [];
        for (var e = 0; e < b; e++) {
            r[e] = {
                distance: this[this.distance + "Distance"](q[0], q[e]),
                assign: e
            }
        }
        r = r.sort(function(g, d) {
            return g.distance - d.distance
        });
        var a = {};
        for (var e = 0; e < r.length; e++) {
            a[r[e].assign] = e
        }
        for (var e = 0; e < m.length; e++) {
            var t = a[m[e]] + 1;
            if (t > 9) {
                m[e] = "K" + t
            } else {
                m[e] = "K-0" + t
            }
        }
        return m
    }
};
CanvasXpress.prototype.initSortUtils = function() {
    this.sortNetworkIndices = function(h) {
        if (this.isTransition()) {
            return
        }
        var g = this.data[this.networkShowDataTable];
        var c = [h] ? h : this.networkShowDataTable == "nodes" ? "id" : "id1";
        var b = [];
        var f = [];
        for (var e = 0; e < g.length; e++) {
            b.push(e);
            f.push(g[e][c] ? g[e][c] : null)
        }
        if (this.isNumeric(f)) {
            var a = Number.MAX_VALUE * -1;
            b.sort(function(j, i) {
                return (f[j] || a) - (f[i] || a)
            })
        } else {
            b.sort(function(j, i) {
                return f[j] > f[i] ? 1 : f[j] < f[i] ? -1 : 0
            })
        }
        var d = [];
        for (var e = 0; e < g.length; e++) {
            d.push(g[b[e]])
        }
        if (this.sortDir == "ascending") {
            d.reverse()
        }
        this.data[this.networkShowDataTable] = d;
        if (this.networkShowDataTable == "nodes") {
            this.setNodeIndices()
        }
        this.draw({
            func: "sortNetworkIndices",
            par: [h]
        })
    };
    this.sortOncoprint = function() {
        if (this.isOncoprint) {
            this.sortIndices("smps", "desc", ["Altered-Smps"]);
            this.sortIndices("vars", "desc", ["Altered-Vars"])
        }
    };
    this.sortIndices = function(d, k, b, c, n, p) {
        var e = this.sortCaseSensitive;
        var v = function(m, i) {
            if (m == null) {
                m = ""
            }
            if (i == null) {
                i = ""
            }
            if (e) {
                return (m.toString()).localeCompare(i.toString())
            } else {
                return (m.toString().toLowerCase()).localeCompare(i.toString().toLowerCase())
            }
        };
        var h = "";
        var l;
        var a = [];
        var q = this.meta.data;
        var x = [];
        for (var s = 0; s < this.varIndices.length; s++) {
            x.push(this.varIndices[s])
        }
        x.sort(function(m, i) {
            return m - i
        });
        var w = [];
        for (var s = 0; s < this.smpIndices.length; s++) {
            w.push(this.smpIndices[s])
        }
        w.sort(function(m, i) {
            return m - i
        });
        var u = [];
        if (this.grpIndices && this.grpIndices.length) {
            for (var s = 0; s < this.grpIndices.length; s++) {
                u.push(this.grpIndices[s])
            }
        } else {
            if (this.isGroupedData && this.data.w) {
                u = this.data.w.grpIdxs
            }
        }
        if (b) {
            b = this.toArray(b)
        }
        if (c) {
            c = this.toArray(c)
        }
        if (n) {
            n = this.toArray(n)
        }
        if (!k) {
            k = this.sortDir
        }
        if (b && d == "vars") {
            for (var s = 0; s < b.length; s++) {
                var f = b[s];
                a.push(this.data.z[f]);
                h += q.z[f].type == "Numeric" ? "N" : "S"
            }
            l = "varIndices"
        } else {
            if (b && d == "smps") {
                if (this.isGroupedData) {
                    this.isGroupedData = false;
                    this.sortIndices(d, k, b, c, n, p);
                    this.isGroupedData = true
                }
                for (var s = 0; s < b.length; s++) {
                    var f = b[s];
                    a.push(this.isGroupedData ? this.data.w.factors[f] : this.data.x[f]);
                    h += q.x[f].type == "Numeric" ? "N" : "S"
                }
                l = this.isGroupedData ? "grpIndices" : "smpIndices"
            } else {
                if (p) {
                    if (p == "varIndex" || p == "smpIndex" || p == "grpIndex") {
                        j = p == "grpIndex" ? u : p == "smpIndex" ? w : x;
                        l = p == "grpIndex" ? "grpIndices" : p == "smpIndex" ? "smpIndices" : "varIndices";
                        if (this.sortDir == "ascending") {
                            j = j.sort(function(m, i) {
                                return m - i
                            })
                        } else {
                            j = j.sort(function(m, i) {
                                return i - m
                            })
                        }
                        this[l] = j;
                        if (this.layoutValid && this.layoutParams) {
                            for (var s = 0; s < this.layoutParams.length; s++) {
                                this.layoutParams[s][l] = this.sortDir == "ascending" ? this.layoutParams[s][l].sort(function(m, i) {
                                    return m - i
                                }) : this.layoutParams[s][l].sort(function(m, i) {
                                    return i - m
                                });
                                this.layoutParams[s].dragged = true
                            }
                        }
                        h = "I"
                    } else {
                        var s = c ? parseInt(this.getVariableIndices(c[0])) : parseInt(this.getSampleIndices(n[0]));
                        a.push(this.data.y[p][s]);
                        h = "N"
                    }
                } else {
                    if (c) {
                        for (var s = 0; s < c.length; s++) {
                            a.push(this.getDataForSmpGrpAtIndex(c[s] - 1, x, p));
                            h += "N"
                        }
                        l = "varIndices"
                    } else {
                        if (n) {
                            if (this.isGroupedData) {
                                this.isGroupedData = false;
                                this.sortIndices(d, k, b, c, n, p);
                                this.isGroupedData = true
                            }
                            var y = this.isGroupedData && this.summaryType == "iqr" ? this.data.w.median : this.isGroupedData ? this.data.w[this.summaryType] : p ? this.data.y[p] : this.data.y.data;
                            for (var s = 0; s < n.length; s++) {
                                var g = n[s] - 1;
                                if (!y[g]) {
                                    g = 0
                                }
                                a.push(y[g]);
                                h += "N"
                            }
                            l = this.isGroupedData ? "grpIndices" : "smpIndices"
                        } else {
                            if (this.isGroupedData) {
                                this.isGroupedData = false;
                                this.sortIndices(d, k, b, c, n, p);
                                this.isGroupedData = true
                            }
                            a.push(this.isGroupedData ? this.data.w.smps : d == "vars" ? this.data.y.vars : this.data.y.smps);
                            l = this.isGroupedData ? "grpIndices" : d == "vars" ? "varIndices" : "smpIndices";
                            h = "S"
                        }
                    }
                }
            }
        }
        var j = l == "grpIndices" ? u : l == "smpIndices" ? w : x;
        var r = Number.MAX_VALUE * -1;
        switch (h) {
            case "I":
                break;
            case "S":
                j.sort(function(m, i) {
                    return v(a[0][m], a[0][i]) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return v(a[0][m], a[0][i]) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "N":
                j.sort(function(m, i) {
                    return ((a[0][m] || r) - (a[0][i] || r)) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return ((a[0][m] || r) - (a[0][i] || r)) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "SS":
                j.sort(function(m, i) {
                    return v(a[0][m], a[0][i]) || v(a[1][m], a[1][i]) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return v(a[0][m], a[0][i]) || v(a[1][m], a[1][i]) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "SN":
                j.sort(function(m, i) {
                    return v(a[0][m], a[0][i]) || ((a[1][m] || r) - (a[1][i] || r)) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return v(a[0][m], a[0][i]) || ((a[1][m] || r) - (a[1][i] || r)) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "NN":
                j.sort(function(m, i) {
                    return ((a[0][m] || r) - (a[0][i] || r)) || ((a[1][m] || r) - (a[1][i] || r)) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return ((a[0][m] || r) - (a[0][i] || r)) || ((a[1][m] || r) - (a[1][i] || r)) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "NS":
                j.sort(function(m, i) {
                    return ((a[0][m] || r) - (a[0][i] || r)) || v(a[1][m], a[1][i]) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return ((a[0][m] || r) - (a[0][i] || r)) || v(a[1][m], a[1][i]) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "SSS":
                j.sort(function(m, i) {
                    return v(a[0][m], a[0][i]) || v(a[1][m], a[1][i]) || v(a[2][m], a[2][i]) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return v(a[0][m], a[0][i]) || v(a[1][m], a[1][i]) || v(a[2][m], a[2][i]) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "SSN":
                j.sort(function(m, i) {
                    return v(a[0][m], a[0][i]) || v(a[1][m], a[1][i]) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            v(a[0][m], a[0][i]) || v(a[1][m], a[1][i]) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "SNS":
                j.sort(function(m, i) {
                    return v(a[0][m], a[0][i]) || ((a[1][m] || r) - (a[1][i] || r)) || v(a[2][m], a[2][i]) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return v(a[0][m], a[0][i]) || ((a[1][m] || r) - (a[1][i] || r)) || v(a[2][m], a[2][i]) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "NSS":
                j.sort(function(m, i) {
                    return ((a[0][m] || r) - (a[0][i] || r)) || v(a[1][m], a[1][i]) || v(a[2][m], a[2][i]) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return ((a[0][m] || r) - (a[0][i] || r)) || v(a[1][m], a[1][i]) || v(a[2][m], a[2][i]) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "NNN":
                j.sort(function(m, i) {
                    return ((a[0][m] || r) - (a[0][i] || r)) || ((a[1][m] || r) - (a[1][i] || r)) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return ((a[0][m] || r) - (a[0][i] || r)) || ((a[1][m] || r) - (a[1][i] || r)) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "NNS":
                j.sort(function(m, i) {
                    return ((a[0][m] || r) - (a[0][i] || r)) || ((a[1][m] || r) - (a[1][i] || r)) || v(a[2][m], a[2][i]) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return ((a[0][m] || r) - (a[0][i] || r)) || ((a[1][m] || r) - (a[1][i] || r)) || v(a[2][m], a[2][i]) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "NSN":
                j.sort(function(m, i) {
                    return ((a[0][m] || r) - (a[0][i] || r)) || v(a[1][m], a[1][i]) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return ((a[0][m] || r) - (a[0][i] || r)) || v(a[1][m], a[1][i]) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break;
            case "SNN":
                j.sort(function(m, i) {
                    return v(a[0][m], a[0][i]) || ((a[1][m] || r) - (a[1][i] || r)) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                });
                if (this.layoutValid && this.layoutParams) {
                    for (var s = 0; s < this.layoutParams.length; s++) {
                        this.layoutParams[s][l].sort(function(m, i) {
                            return v(a[0][m], a[0][i]) || ((a[1][m] || r) - (a[1][i] || r)) || ((a[2][m] || r) - (a[2][i] || r)) || (m - i)
                        });
                        this.layoutParams[s].dragged = true
                    }
                }
                break
        }
        if (k != "ascending" && k != "asc" && h != "I") {
            j.reverse();
            if (this.layoutValid && this.layoutParams) {
                for (var s = 0; s < this.layoutParams.length; s++) {
                    this.layoutParams[s][l].reverse();
                    this.layoutParams[s].dragged = true
                }
            }
        }
        this.sorting = [d, k, b, c, n, p];
        this[l] = j;
        if (this.isGroupedData && l == "grpIndices" && this.data.w && this[l].length == this.data.w.grpIdxs.length) {
            this.data.w.grpIdxs = this.cloneObject(j)
        }
    };
    this.sortArray = function(a, b) {
        var d = [];
        if (a.length != b.length) {
            return a
        }
        for (var c = 0; c < a.length; c++) {
            if (a[b[c]]) {
                d[c] = a[b[c]]
            } else {
                return a
            }
        }
        return d
    };
    this.isAsciiArray = function(a) {
        return !this.isNumeric(a)
    };
    this.sortObject = function(b) {
        var a = Object.keys(b);
        if (this.isAsciiArray(a)) {
            if (this.sortCaseSensitive) {
                return a.sort()
            } else {
                return a.sort(function(d, c) {
                    return d.toLowerCase().localeCompare(c.toLowerCase())
                })
            }
        } else {
            return a.sort(function(d, c) {
                return d - c
            })
        }
    };
    this.stringRangeSort = function(d) {
        var c = {};
        var a;
        for (var b = 0; b < d.length; b++) {
            if (d[b].match(/^\d+\-\d+/)) {
                a = d[b].split(/\-/);
                c[b] = Number(a[0])
            } else {
                if (d[b].match(/^\>\d+/)) {
                    a = d[b].split(/\>/);
                    c[b] = Number(a[1]) + 1e-8
                } else {
                    if (d[b].match(/^\<\d+/)) {
                        a = d[b].split(/\</);
                        c[b] = Number(a[1]) - 1e-8
                    } else {
                        if (d[b].match(/^\d+/)) {
                            a = d[b];
                            c[b] = a
                        } else {
                            return d.sort()
                        }
                    }
                }
            }
        }
        d.sort(function(f, e) {
            c[f] - c[e]
        });
        return d
    };
    this.resetSorting = function() {
        delete this.sorting
    };
    this.radixSort = function(n) {
        var h = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var e = new Int32Array(n.length);
        var f = [].concat(h);
        var g = [].concat(h);
        var j = [].concat(h);
        var l = [].concat(h);
        var a = 0;
        var i;
        var b = 0;
        var k;
        var c = 0;
        var m;
        var d = 0;
        var o;
        var p;
        for (p = 0; p < n.length; p++) {
            i = n[p] & 255;
            k = (n[p] >> 8) & 255;
            m = (n[p] >> 16) & 255;
            o = (n[p] >> 24) & 255 ^ 128;
            f[i]++;
            g[k]++;
            j[m]++;
            l[o]++
        }
        for (p = 0; p < 256; p++) {
            i = a + f[p];
            k = b + g[p];
            m = c + j[p];
            o = d + l[p];
            f[p] = a;
            g[p] = b;
            j[p] = c;
            l[p] = d;
            a = i;
            b = k;
            c = m;
            d = o
        }
        for (p = 0; p < n.length; p++) {
            i = n[p] & 255;
            e[f[i]] = n[p];
            f[i]++
        }
        for (p = 0; p < n.length; p++) {
            k = (e[p] >> 8) & 255;
            n[g[k]] = e[p];
            g[k]++
        }
        for (p = 0; p < n.length; p++) {
            m = (n[p] >> 16) & 255;
            e[j[m]] = n[p];
            j[m]++
        }
        for (p = 0; p < n.length; p++) {
            o = (e[p] >> 24) & 255 ^ 128;
            n[l[o]] = e[p];
            l[o]++
        }
        return n
    };
    this.resortData = function() {
        var g = {
            y: {
                vars: [],
                smps: [],
                data: []
            }
        };
        var h = [];
        var b = [];
        var a = this.data.l ? true : false;
        for (var d = 0; d < this.varIndices.length; d++) {
            var e = this.varIndices[d];
            g.y.vars[d] = this.data.y.vars[e];
            h.push(d)
        }
        for (var c = 0; c < this.smpIndices.length; c++) {
            var f = this.smpIndices[c];
            g.y.smps[c] = this.data.y.smps[f];
            b.push(c)
        }
        for (var d = 0; d < this.varIndices.length; d++) {
            var e = this.varIndices[d];
            g.y.data[d] = [];
            for (var c = 0; c < this.smpIndices.length; c++) {
                var f = this.smpIndices[c];
                g.y.data[d][c] = this.data.y.data[e][f]
            }
        }
        if (this.data.x) {
            g.x = {};
            for (var d in this.data.x) {
                g.x[d] = [];
                for (var c = 0; c < this.smpIndices.length; c++) {
                    var f = this.smpIndices[c];
                    g.x[d][c] = this.data.x[d][f]
                }
            }
        }
        if (this.data.z) {
            g.z = {};
            for (var d in this.data.z) {
                g.z[d] = [];
                for (var c = 0; c < this.varIndices.length; c++) {
                    var f = this.varIndices[c];
                    g.z[d][c] = this.data.z[d][f]
                }
            }
        }
        this.data = g;
        this.varIndices = h;
        this.smpIndices = b;
        this.startingVarIndices = h;
        this.startingSmpIndices = b;
        if (this.isGroupedData) {
            this.isGroupedData = false;
            this.groupSamples(this.groupingFactors, false, false, false, true)
        }
        if (this.segregateVariablesBy.length + this.segregateSamplesBy.length > 0) {
            this.segregateVariablesAndOrSamples(this.segregateVariablesBy, this.segregateSamplesBy)
        }
    }
};
CanvasXpress.prototype.initNumeric = function() {
    this.numeric = function(s, m) {
        var M = function(S) {
            var U = this.length,
                T;
            for (T = 0; T < U; ++T) {
                if (this[T] === S) {
                    return T
                }
            }
            return -1
        };
        var p = (Array.prototype.indexOf) ? Array.prototype.indexOf : M;
        var a = function a(S) {
            var V, U;

            function T(W) {
                var X = [];
                while (typeof W === "object") {
                    X.push(W.length);
                    W = W[0]
                }
                return X
            }
            if (typeof S === "object") {
                V = S[0];
                if (typeof V === "object") {
                    U = V[0];
                    if (typeof U === "object") {
                        return T(S)
                    }
                    return [S.length, V.length]
                }
                return [S.length]
            }
            return []
        };
        var D = function(W, T, S) {
            if (typeof S === "undefined") {
                S = 0
            }
            var X = W[S],
                U = Array(X),
                V;
            if (S === W.length - 1) {
                for (V = X - 2; V >= 0; V -= 2) {
                    U[V + 1] = T;
                    U[V] = T
                }
                if (V === -1) {
                    U[0] = T
                }
                return U
            }
            for (V = X - 1; V >= 0; V--) {
                U[V] = D(W, T, S + 1)
            }
            return U
        };
        var R = function(Z, Y) {
            var S = function(ap, ao) {
                var aj, ah, af, ad, ac, ab, al, an, ak, ai, ag, am, aq, ae;
                ad = ap.length;
                ac = ao.length;
                ab = ao[0].length;
                al = Array(ad);
                for (aj = ad - 1; aj >= 0; aj--) {
                    an = Array(ab);
                    ak = ap[aj];
                    for (af = ab - 1; af >= 0; af--) {
                        ai = ak[ac - 1] * ao[ac - 1][af];
                        for (ah = ac - 2; ah >= 1; ah -= 2) {
                            ag = ah - 1;
                            ai += ak[ah] * ao[ah][af] + ak[ag] * ao[ag][af]
                        }
                        if (ah === 0) {
                            ai += ak[0] * ao[0][af]
                        }
                        an[af] = ai
                    }
                    al[aj] = an
                }
                return al
            };
            var V = function(ac, ad, ab) {
                var af = ac.length,
                    ae;
                for (ae = af - 1; ae > 0; --ae) {
                    ab[ae] = ac[ae][ad];
                    --ae;
                    ab[ae] = ac[ae][ad]
                }
                if (ae === 0) {
                    ab[0] = ac[0][ad]
                }
            };
            var W = function(am, al) {
                var an = V,
                    ab = al.length,
                    ao = Array(ab);
                var ae = am.length,
                    ad = al[0].length,
                    ac = new Array(ae),
                    aj;
                var ag = aa;
                var ai, ah, af, ak;
                --ab;
                --ae;
                for (ai = ae; ai !== -1; --ai) {
                    ac[ai] = Array(ad)
                }--ad;
                for (ai = ad; ai !== -1; --ai) {
                    an(al, ai, ao);
                    for (ah = ae; ah !== -1; --ah) {
                        ak = 0;
                        aj = am[ah];
                        ac[ah][ai] = ag(aj, ao)
                    }
                }
                return ac
            };
            var T = function(ab, ag) {
                var af = ab.length,
                    ae = ag.length,
                    ad;
                var ac = Array(af);
                for (ad = af - 1; ad >= 0; ad--) {
                    ac[ad] = aa(ab[ad], ag)
                }
                return ac
            };
            var U = function(ai, ah) {
                var aq, ap, ao, al, ak, aj, aw, au, at, af, an, ag, ad, ar, ae, ac, ab, am, av;
                al = ai.length;
                ak = ah[0].length;
                aw = Array(ak);
                for (ao = ak - 1; ao >= 0; ao--) {
                    af = ai[al - 1] * ah[al - 1][ao];
                    for (ap = al - 2; ap >= 1; ap -= 2) {
                        an = ap - 1;
                        af += ai[ap] * ah[ap][ao] + ai[an] * ah[an][ao]
                    }
                    if (ap === 0) {
                        af += ai[0] * ah[0][ao]
                    }
                    aw[ao] = af
                }
                return aw
            };
            var aa = function(ab, ag) {
                var ad, af = ab.length,
                    ae, ac = ab[af - 1] * ag[af - 1];
                for (ad = af - 2; ad >= 1; ad -= 2) {
                    ae = ad - 1;
                    ac += ab[ad] * ag[ad] + ab[ae] * ag[ae]
                }
                if (ad === 0) {
                    ac += ab[0] * ag[0]
                }
                return ac
            };
            var X = a;
            switch (X(Z).length * 1000 + X(Y).length) {
                case 2002:
                    if (Y.length < 10) {
                        return S(Z, Y)
                    } else {
                        return W(Z, Y)
                    }
                    case 2001:
                        return T(Z, Y);
                    case 1002:
                        return U(Z, Y);
                    case 1001:
                        return aa(Z, Y);
                    case 1000:
                        return mulVS(Z, Y);
                    case 1:
                        return mulSV(Z, Y);
                    case 0:
                        return Z * Y;
                    default:
                        throw new Error("dot only works on vectors and matrices")
            }
        };
        var k = function(X) {
            var V, W, U, Y = X.length,
                S = Array(Y),
                T;
            for (V = Y - 1; V >= 0; V--) {
                T = Array(Y);
                W = V + 2;
                for (U = Y - 1; U >= W; U -= 2) {
                    T[U] = 0;
                    T[U - 1] = 0
                }
                if (U > V) {
                    T[U] = 0
                }
                T[V] = X[V];
                for (U = V - 1; U >= 1; U -= 2) {
                    T[U] = 0;
                    T[U - 1] = 0
                }
                if (U === 0) {
                    T[0] = 0
                }
                S[V] = T
            }
            return S
        };
        var C = function(S) {
            var V = Math.min(S.length, S[0].length),
                U, T = Array(V);
            for (U = V - 1; U >= 1; --U) {
                T[U] = S[U][U];
                --U;
                T[U] = S[U][U]
            }
            if (U === 0) {
                T[0] = S[0][0]
            }
            return T
        };
        var G = function(S) {
            return k(D([S], 1))
        };
        var I = function(S, Y, V, T, W) {
            if (T === V.length - 1) {
                W(S, Y);
                return
            }
            var U, X = V[T];
            for (U = X - 1; U >= 0; U--) {
                I(typeof S === "object" ? S[U] : S, typeof Y === "object" ? Y[U] : Y, V, T + 1, W)
            }
        };
        var L = function(S, Z, W, T, X) {
            if (T === W.length - 1) {
                return X(S, Z)
            }
            var V, Y = W[T],
                U = Array(Y);
            for (V = Y - 1; V >= 0; --V) {
                U[V] = L(typeof S === "object" ? S[V] : S, typeof Z === "object" ? Z[V] : Z, W, T + 1, X)
            }
            return U
        };
        var A = function(S, V, T, W) {
            if (T === V.length - 1) {
                W(S);
                return
            }
            var U, X = V[T];
            for (U = X - 1; U >= 0; U--) {
                A(S[U], V, T + 1, W)
            }
        };
        var H = function(S, W, T, X) {
            if (T === W.length - 1) {
                return X(S)
            }
            var V, Y = W[T],
                U = Array(Y);
            for (V = Y - 1; V >= 0; V--) {
                U[V] = H(S[V], W, T + 1, X)
            }
            return U
        };
        var d = function() {
            var X = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] + ag[af]
                }
                return ae
            };
            var Y = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac + ag[af]
                }
                return ae
            };
            var Z = function(ac, ag) {
                var ad = ac.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] + ag
                }
                return ae
            };
            var S = arguments.length,
                V, ab = arguments[0],
                aa;
            var T = X,
                W = Z,
                U = Y;
            for (V = 1; V !== S; ++V) {
                aa = arguments[V];
                if (typeof ab === "object") {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(ab), 0, T)
                    } else {
                        ab = L(ab, aa, a(ab), 0, W)
                    }
                } else {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(aa), 0, U)
                    } else {
                        ab += aa
                    }
                }
            }
            return ab
        };
        var x = function() {
            var S = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] - ag[af]
                }
                return ae
            };
            var T = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac - ag[af]
                }
                return ae
            };
            var V = function(ac, ag) {
                var ad = ac.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] - ag
                }
                return ae
            };
            var U = arguments.length,
                Y, ab = arguments[0],
                aa;
            var W = S,
                Z = V,
                X = T;
            for (Y = 1; Y !== U; ++Y) {
                aa = arguments[Y];
                if (typeof ab === "object") {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(ab), 0, W)
                    } else {
                        ab = L(ab, aa, a(ab), 0, Z)
                    }
                } else {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(aa), 0, X)
                    } else {
                        ab -= aa
                    }
                }
            }
            return ab
        };
        var c = function() {
            var Z = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] * ag[af]
                }
                return ae
            };
            var aa = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac * ag[af]
                }
                return ae
            };
            var ab = function(ac, ag) {
                var ad = ac.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] * ag
                }
                return ae
            };
            var S = arguments.length,
                V, Y = arguments[0],
                X;
            var T = Z,
                W = ab,
                U = aa;
            for (V = 1; V !== S; ++V) {
                X = arguments[V];
                if (typeof Y === "object") {
                    if (typeof X === "object") {
                        Y = L(Y, X, a(Y), 0, T)
                    } else {
                        Y = L(Y, X, a(Y), 0, W)
                    }
                } else {
                    if (typeof X === "object") {
                        Y = L(Y, X, a(X), 0, U)
                    } else {
                        Y *= X
                    }
                }
            }
            return Y
        };
        var K = function() {
            var aa = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] / ag[af]
                }
                return ae
            };
            var ab = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac / ag[af]
                }
                return ae
            };
            var S = function(ac, ag) {
                var ad = ac.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] / ag
                }
                return ae
            };
            var T = arguments.length,
                W, Z = arguments[0],
                Y;
            var U = aa,
                X = S,
                V = ab;
            for (W = 1; W !== T; ++W) {
                Y = arguments[W];
                if (typeof Z === "object") {
                    if (typeof Y === "object") {
                        Z = L(Z, Y, a(Z), 0, U)
                    } else {
                        Z = L(Z, Y, a(Z), 0, X)
                    }
                } else {
                    if (typeof Y === "object") {
                        Z = L(Z, Y, a(Y), 0, V)
                    } else {
                        Z /= Y
                    }
                }
            }
            return Z
        };
        var h = function() {
            var ab = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] !== ag[af]
                }
                return ae
            };
            var S = function(ac, ag) {
                var ad = ag.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac !== ag[af]
                }
                return ae
            };
            var T = function(ac, ag) {
                var ad = ac.length;
                var af, ae = Array(ad);
                for (af = ad - 1; af !== -1; --af) {
                    ae[af] = ac[af] !== ag
                }
                return ae
            };
            var U = arguments.length,
                X, aa = arguments[0],
                Z;
            var V = ab,
                Y = T,
                W = S;
            for (X = 1; X !== U; ++X) {
                Z = arguments[X];
                if (typeof aa === "object") {
                    if (typeof Z === "object") {
                        aa = L(aa, Z, a(aa), 0, V)
                    } else {
                        aa = L(aa, Z, a(aa), 0, Y)
                    }
                } else {
                    if (typeof Z === "object") {
                        aa = L(aa, Z, a(Z), 0, W)
                    } else {
                        aa = aa !== Z
                    }
                }
            }
            return aa
        };
        var u = function() {
            var T = function(ac, ah) {
                var ad = ah.length;
                var ag, ae = Array(ad);
                var af = Math.atan2;
                for (ag = ad - 1; ag !== -1; --ag) {
                    ae[ag] = af(ac[ag], ah[ag])
                }
                return ae
            };
            var U = function(ac, ah) {
                var ad = ah.length;
                var ag, ae = Array(ad);
                var af = Math.atan2;
                for (ag = ad - 1; ag !== -1; --ag) {
                    ae[ag] = af(ac, ah[ag])
                }
                return ae
            };
            var X = function(ac, ah) {
                var ad = ac.length;
                var ag, ae = Array(ad);
                var af = Math.atan2;
                for (ag = ad - 1; ag !== -1; --ag) {
                    ae[ag] = af(ac[ag], ah)
                }
                return ae
            };
            var S = arguments.length,
                Y, ab = arguments[0],
                aa;
            var V = T,
                Z = X,
                W = U;
            for (Y = 1; Y !== S; ++Y) {
                aa = arguments[Y];
                if (typeof ab === "object") {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(ab), 0, V)
                    } else {
                        ab = L(ab, aa, a(ab), 0, Z)
                    }
                } else {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(aa), 0, W)
                    } else {
                        ab = u(ab, aa)
                    }
                }
            }
            return ab
        };
        var w = function() {
            var X = function(ad, ah) {
                var ae = ah.length;
                var ag, af = Array(ae);
                var ac = Math.max;
                for (ag = ae - 1; ag !== -1; --ag) {
                    af[ag] = ac(ad[ag], ah[ag])
                }
                return af
            };
            var Y = function(ad, ah) {
                var ae = ah.length;
                var ag, af = Array(ae);
                var ac = Math.max;
                for (ag = ae - 1; ag !== -1; --ag) {
                    af[ag] = ac(ad, ah[ag])
                }
                return af
            };
            var aa = function(ad, ah) {
                var ae = ad.length;
                var ag, af = Array(ae);
                var ac = Math.max;
                for (ag = ae - 1; ag !== -1; --ag) {
                    af[ag] = ac(ad[ag], ah)
                }
                return af
            };
            var S = arguments.length,
                V, ab = arguments[0],
                Z;
            var T = X,
                W = aa,
                U = Y;
            for (V = 1; V !== S; ++V) {
                Z = arguments[V];
                if (typeof ab === "object") {
                    if (typeof Z === "object") {
                        ab = L(ab, Z, a(ab), 0, T)
                    } else {
                        ab = L(ab, Z, a(ab), 0, W)
                    }
                } else {
                    if (typeof Z === "object") {
                        ab = L(ab, Z, a(Z), 0, U)
                    } else {
                        ab = w(ab, Z)
                    }
                }
            }
            return ab
        };
        var O = function() {
            var V = function(ac, ah) {
                var ad = ah.length;
                var ag, ae = Array(ad);
                var af = Math.min;
                for (ag = ad - 1; ag !== -1; --ag) {
                    ae[ag] = af(ac[ag], ah[ag])
                }
                return ae
            };
            var X = function(ac, ah) {
                var ad = ah.length;
                var ag, ae = Array(ad);
                var af = Math.min;
                for (ag = ad - 1; ag !== -1; --ag) {
                    ae[ag] = af(ac, ah[ag])
                }
                return ae
            };
            var Z = function(ac, ah) {
                var ad = ac.length;
                var ag, ae = Array(ad);
                var af = Math.min;
                for (ag = ad - 1; ag !== -1; --ag) {
                    ae[ag] = af(ac[ag], ah)
                }
                return ae
            };
            var S = arguments.length,
                W, ab = arguments[0],
                aa;
            var T = V,
                Y = Z,
                U = X;
            for (W = 1; W !== S; ++W) {
                aa = arguments[W];
                if (typeof ab === "object") {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(ab), 0, T)
                    } else {
                        ab = L(ab, aa, a(ab), 0, Y)
                    }
                } else {
                    if (typeof aa === "object") {
                        ab = L(ab, aa, a(aa), 0, U)
                    } else {
                        ab = O(ab, aa)
                    }
                }
            }
            return ab
        };
        var q = function(S) {
            var U = function(V) {
                var Y = V.length;
                var aa, Z = Array(Y);
                for (aa = Y - 1; aa !== -1; --aa) {
                    Z[aa] = -(V[aa])
                }
                return Z
            };
            if (typeof S !== "object") {
                return -(S)
            }
            var W;
            var T = U;
            var X = a(S);
            return H(S, X, 0, T)
        };
        var v = function(S) {
            var U = function(V) {
                var Y = V.length;
                var aa, Z = Array(Y);
                for (aa = Y - 1; aa !== -1; --aa) {
                    Z[aa] = (V[aa])
                }
                return Z
            };
            if (typeof S !== "object") {
                return (S)
            }
            var W;
            var T = U;
            var X = a(S);
            return H(S, X, 0, T)
        };
        var y = function(S) {
            var X = function(Y) {
                var Z = Y.length;
                var ab, aa = Array(Z);
                var V = Math.abs;
                for (ab = Z - 1; ab !== -1; --ab) {
                    aa[ab] = V(Y[ab])
                }
                return aa
            };
            if (typeof S !== "object") {
                return y(S)
            }
            var U;
            var T = X;
            var W = a(S);
            return H(S, W, 0, T)
        };
        var f = function(S) {
            var X = function(V) {
                var Y = V.length;
                var aa, Z = Array(Y);
                var ab = Math.cos;
                for (aa = Y - 1; aa !== -1; --aa) {
                    Z[aa] = ab(V[aa])
                }
                return Z
            };
            if (typeof S !== "object") {
                return f(S)
            }
            var U;
            var T = X;
            var W = a(S);
            return H(S, W, 0, T)
        };
        var Q = function(S) {
            var U = function(V) {
                var Y = V.length;
                var aa, Z = Array(Y);
                var ab = Math.exp;
                for (aa = Y - 1; aa !== -1; --aa) {
                    Z[aa] = ab(V[aa])
                }
                return Z
            };
            if (typeof S !== "object") {
                return Q(S)
            }
            var W;
            var T = U;
            var X = a(S);
            return H(S, X, 0, T)
        };
        var o = function(T) {
            var S = function(V) {
                var Y = V.length;
                var aa, Z = Array(Y);
                var ab = Math.log;
                for (aa = Y - 1; aa !== -1; --aa) {
                    Z[aa] = ab(V[aa])
                }
                return Z
            };
            if (typeof T !== "object") {
                return o(T)
            }
            var W;
            var U = S;
            var X = a(T);
            return H(T, X, 0, U)
        };
        var r = function(S) {
            var X = function(V) {
                var Z = V.length;
                var ab, aa = Array(Z);
                var Y = Math.sin;
                for (ab = Z - 1; ab !== -1; --ab) {
                    aa[ab] = Y(V[ab])
                }
                return aa
            };
            if (typeof S !== "object") {
                return r(S)
            }
            var U;
            var T = X;
            var W = a(S);
            return H(S, W, 0, T)
        };
        var F = function(S) {
            var X = function(V) {
                var Y = V.length;
                var aa, Z = Array(Y);
                var ab = Math.sqrt;
                for (aa = Y - 1; aa !== -1; --aa) {
                    Z[aa] = ab(V[aa])
                }
                return Z
            };
            if (typeof S !== "object") {
                return F(S)
            }
            var U;
            var T = X;
            var W = a(S);
            return H(S, W, 0, T)
        };
        var J = function(S, Y, V) {
            var X = function(aa) {
                var ae = aa.length;
                var ad, ac;
                var ab = 0;
                for (ad = ae - 1; ad !== -1; --ad) {
                    ac = aa[ad];
                    ab += ac * ac
                }
                return ab
            };
            var U = 0;
            if (typeof S !== "object") {
                T = S;
                U += T * T;
                return U
            }
            if (typeof Y === "undefined") {
                Y = a(S)
            }
            if (typeof V === "undefined") {
                V = 0
            }
            if (V === Y.length - 1) {
                return X(S)
            }
            var T;
            var Z = S.length,
                W;
            for (W = Z - 1; W !== -1; --W) {
                T = arguments.callee(S[W]);
                U += T * T
            }
            return U
        };
        var t = function(aa) {
            var Y, W, U = aa.length,
                S = aa[0].length,
                Z = Array(S),
                V, T, X;
            for (W = 0; W < S; W++) {
                Z[W] = Array(U)
            }
            for (Y = U - 1; Y >= 1; Y -= 2) {
                T = aa[Y];
                V = aa[Y - 1];
                for (W = S - 1; W >= 1; --W) {
                    X = Z[W];
                    X[Y] = T[W];
                    X[Y - 1] = V[W];
                    --W;
                    X = Z[W];
                    X[Y] = T[W];
                    X[Y - 1] = V[W]
                }
                if (W === 0) {
                    X = Z[0];
                    X[Y] = T[0];
                    X[Y - 1] = V[0]
                }
            }
            if (Y === 0) {
                V = aa[0];
                for (W = S - 1; W >= 1; --W) {
                    Z[W][0] = V[W];
                    --W;
                    Z[W][0] = V[W]
                }
                if (W === 0) {
                    Z[0][0] = V[0]
                }
            }
            return Z
        };
        var n = function(aa) {
            var Y, W, U = aa.length,
                S = aa[0].length,
                Z = Array(S),
                V, T, X;
            for (W = 0; W < S; W++) {
                Z[W] = Array(U)
            }
            for (Y = U - 1; Y >= 1; Y -= 2) {
                T = aa[Y];
                V = aa[Y - 1];
                for (W = S - 1; W >= 1; --W) {
                    X = Z[W];
                    X[Y] = -T[W];
                    X[Y - 1] = -V[W];
                    --W;
                    X = Z[W];
                    X[Y] = -T[W];
                    X[Y - 1] = -V[W]
                }
                if (W === 0) {
                    X = Z[0];
                    X[Y] = -T[0];
                    X[Y - 1] = -V[0]
                }
            }
            if (Y === 0) {
                V = aa[0];
                for (W = S - 1; W >= 1; --W) {
                    Z[W][0] = -V[W];
                    --W;
                    Z[W][0] = -V[W]
                }
                if (W === 0) {
                    Z[0][0] = -V[0]
                }
            }
            return Z
        };
        var l = function(S) {
            return Math.sqrt(J(S))
        };
        var j = function(S, W, V) {
            var T = a(S);

            function U(X, Z) {
                var ab, Y = W[Z],
                    ac = V[Z] - Y,
                    aa = Array(ac);
                if (Z === T.length - 1) {
                    for (ab = ac; ab >= 0; ab--) {
                        aa[ab] = X[ab + Y]
                    }
                    return aa
                }
                for (ab = ac; ab >= 0; ab--) {
                    aa[ab] = U(X[ab + Y], Z + 1)
                }
                return aa
            }
            return U(S, 0)
        };
        var e = function(S, X, W, V) {
            var T = a(S);

            function U(Y, ad, aa) {
                var ab, Z = X[aa],
                    ac = W[aa] - Z;
                if (aa === T.length - 1) {
                    for (ab = ac; ab >= 0; ab--) {
                        Y[ab + Z] = ad[ab]
                    }
                }
                for (ab = ac; ab >= 0; ab--) {
                    U(Y[ab + Z], ad[ab], aa + 1)
                }
            }
            U(S, V, 0);
            return S
        };
        var i = function(T, ab, aa) {
            var W = ab.length,
                V = aa.length;
            var Y, X;
            var S = Array(W),
                Z, U;
            for (Y = W - 1; Y !== -1; --Y) {
                S[Y] = Array(V);
                Z = S[Y];
                U = T[ab[Y]];
                for (X = V - 1; X !== -1; --X) {
                    Z[X] = U[aa[X]]
                }
            }
            return S
        };
        var B = function(Z, Y) {
            if (typeof Z === "number" || typeof Y === "number") {
                return c(Z, Y)
            }
            var ac = a(Z),
                aa = a(Y);
            if (ac.length !== 1 || aa.length !== 1) {
                throw new Error("numeric: tensor product is only defined for vectors")
            }
            var U = ac[0],
                T = aa[0],
                S = Array(U),
                ab, W, V, X;
            for (W = U - 1; W >= 0; W--) {
                ab = Array(T);
                X = Z[W];
                for (V = T - 1; V >= 3; --V) {
                    ab[V] = X * Y[V];
                    --V;
                    ab[V] = X * Y[V];
                    --V;
                    ab[V] = X * Y[V];
                    --V;
                    ab[V] = X * Y[V]
                }
                while (V >= 0) {
                    ab[V] = X * Y[V];
                    --V
                }
                S[W] = ab
            }
            return S
        };
        var g = function g(S, T) {
            this.x = S;
            this.y = T
        };
        g.prototype = {};
        g.prototype.add = function(T) {
            var S = this;
            if (!(T instanceof g)) {
                T = new g(T)
            }
            if (S.y) {
                if (T.y) {
                    return new g(d(S.x, T.x), d(S.y, T.y))
                }
                return new g(d(S.x, T.x), S.y)
            }
            if (T.y) {
                return new g(d(S.x, T.x), T.y)
            }
            return new g(d(S.x, T.x))
        };
        g.prototype.sub = function(T) {
            var S = this;
            if (!(T instanceof g)) {
                T = new g(T)
            }
            if (S.y) {
                if (T.y) {
                    return new g(x(S.x, T.x), x(S.y, T.y))
                }
                return new g(x(S.x, T.x), S.y)
            }
            if (T.y) {
                return new g(x(S.x, T.x), q(T.y))
            }
            return new g(x(S.x, T.x))
        };
        g.prototype.mul = function(T) {
            var S = this;
            if (!(T instanceof g)) {
                T = new g(T)
            }
            if (S.y) {
                if (T.y) {
                    return new g(x(c(S.x, T.x), c(S.y, T.y)), d(c(S.x, T.y), c(S.y, T.x)))
                }
                return new g(c(S.x, T.x), c(S.y, T.x))
            }
            if (T.y) {
                return new g(c(S.x, T.x), c(S.x, T.y))
            }
            return new g(c(S.x, T.x))
        };
        g.prototype.reciprocal = function() {
            if (this.y) {
                var S = d(c(this.x, this.x), c(this.y, this.y));
                return new g(K(this.x, S), K(q(this.y), S))
            }
            return new g(K(1, this.x))
        };
        g.prototype.div = function(S) {
            if (!(S instanceof g)) {
                S = new g(S)
            }
            if (S.y) {
                return this.mul(S.reciprocal())
            }
            if (this.y) {
                return new g(K(this.x, S.x), K(this.y, S.x))
            }
            return new g(K(this.x, S.x))
        };
        g.prototype.dot = function(T) {
            var S = this;
            if (!(T instanceof g)) {
                T = new g(T)
            }
            if (S.y) {
                if (T.y) {
                    return new g(x(R(S.x, T.x), R(S.y, T.y)), d(R(S.x, T.y), R(S.y, T.x)))
                }
                return new g(R(S.x, T.x), R(S.y, T.x))
            }
            if (T.y) {
                return new g(R(S.x, T.x), R(S.x, T.y))
            }
            return new g(R(S.x, T.x))
        };
        g.prototype.transpose = function() {
            var T = t,
                S = this.x,
                U = this.y;
            if (U) {
                return new g(T(S), T(U))
            }
            return new g(T(S))
        };
        g.prototype.transjugate = function() {
            var T = t,
                S = this.x,
                U = this.y;
            if (U) {
                return new g(T(S), n(U))
            }
            return new g(T(S))
        };
        g.prototype.exp = function() {
            var S = this;
            var T = Q(S.x);
            if (S.y) {
                return new g(c(f(S.y), T), c(r(S.y), T))
            }
            return new g(T)
        };
        g.prototype.conj = function() {
            var S = this;
            if (S.y) {
                return new g(S.x, q(S.y))
            }
            return new g(S.x)
        };
        g.prototype.neg = function() {
            var S = this;
            if (S.y) {
                return new g(q(S.x), q(S.y))
            }
            return new g(q(S.x))
        };
        g.prototype.sin = function() {
            var S = this;
            if (S.y) {
                return S.exp().sub(S.neg().exp()).div(new g(0, 2))
            }
            return new g(r(S.x))
        };
        g.prototype.cos = function() {
            var S = this;
            if (S.y) {
                return S.exp().add(S.neg().exp()).div(2)
            }
            return new g(f(S.x))
        };
        g.prototype.abs = function() {
            var S = this;
            if (S.y) {
                return new g(F(d(c(S.x, S.x), c(S.y, S.y))))
            }
            return new g(y(S.x))
        };
        g.prototype.log = function() {
            var S = this;
            if (S.y) {
                var T = new g(u(S.y, S.x)),
                    U = S.abs();
                return new g(o(U.x), T.x)
            }
            return new g(o(S.x))
        };
        g.prototype.norm2 = function() {
            var S = this;
            if (S.y) {
                var T = J;
                return Math.sqrt(T(S.x) + T(S.y))
            }
            return l(S.x)
        };
        g.prototype.get = function(V) {
            var S = this.x,
                X = this.y,
                T = 0,
                U, W = V.length;
            if (X) {
                while (T < W) {
                    U = V[T];
                    S = S[U];
                    X = X[U];
                    T++
                }
                return new g(S, X)
            }
            while (T < W) {
                U = V[T];
                S = S[U];
                T++
            }
            return new g(S)
        };
        g.prototype.set = function(U, aa) {
            var Y = this.x,
                W = this.y,
                T = 0,
                Z, S = U.length,
                X = aa.x,
                V = aa.y;
            if (S === 0) {
                if (V) {
                    this.y = V
                } else {
                    if (W) {
                        this.y = undefined
                    }
                }
                this.x = Y;
                return this
            }
            if (V) {
                if (W) {} else {
                    W = D(a(Y), 0);
                    this.y = W
                }
                while (T < S - 1) {
                    Z = U[T];
                    Y = Y[Z];
                    W = W[Z];
                    T++
                }
                Z = U[T];
                Y[Z] = X;
                W[Z] = V;
                return this
            }
            if (W) {
                while (T < S - 1) {
                    Z = U[T];
                    Y = Y[Z];
                    W = W[Z];
                    T++
                }
                Z = U[T];
                Y[Z] = X;
                if (X instanceof Array) {
                    W[Z] = D(a(X), 0)
                } else {
                    W[Z] = 0
                }
                return this
            }
            while (T < S - 1) {
                Z = U[T];
                Y = Y[Z];
                T++
            }
            Z = U[T];
            Y[Z] = X;
            return this
        };
        g.prototype.getRows = function(W, U) {
            var Z = U - W + 1,
                T;
            var X = Array(Z),
                V, S = this.x,
                Y = this.y;
            for (T = W; T <= U; T++) {
                X[T - W] = S[T]
            }
            if (Y) {
                V = Array(Z);
                for (T = W; T <= U; T++) {
                    V[T - W] = Y[T]
                }
                return new g(X, V)
            }
            return new g(X)
        };
        g.prototype.setRows = function(X, V, T) {
            var U;
            var Y = this.x,
                W = this.y,
                S = T.x,
                Z = T.y;
            for (U = X; U <= V; U++) {
                Y[U] = S[U - X]
            }
            if (Z) {
                if (!W) {
                    W = D(a(Y), 0);
                    this.y = W
                }
                for (U = X; U <= V; U++) {
                    W[U] = Z[U - X]
                }
            } else {
                if (W) {
                    for (U = X; U <= V; U++) {
                        W[U] = D([S[U - X].length], 0)
                    }
                }
            }
            return this
        };
        g.prototype.getRow = function(T) {
            var S = this.x,
                U = this.y;
            if (U) {
                return new g(S[T], U[T])
            }
            return new g(S[T])
        };
        g.prototype.setRow = function(U, T) {
            var W = this.x,
                V = this.y,
                S = T.x,
                X = T.y;
            W[U] = S;
            if (X) {
                if (!V) {
                    V = D(a(W), 0);
                    this.y = V
                }
                V[U] = X
            } else {
                if (V) {
                    V = D([S.length], 0)
                }
            }
            return this
        };
        g.prototype.getBlock = function(W, V) {
            var T = this.x,
                U = this.y,
                S = j;
            if (U) {
                return new g(S(T, W, V), S(U, W, V))
            }
            return new g(S(T, W, V))
        };
        g.prototype.setBlock = function(Z, Y, U) {
            if (!(U instanceof g)) {
                U = new g(U)
            }
            var T = this.x,
                X = this.y,
                S = e,
                W = U.x,
                V = U.y;
            if (V) {
                if (!X) {
                    this.y = D(a(this), 0);
                    X = this.y
                }
                S(T, Z, Y, W);
                S(X, Z, Y, V);
                return this
            }
            S(T, Z, Y, W);
            if (X) {
                S(X, Z, Y, D(a(W), 0))
            }
        };
        g.rep = function(U, T) {
            if (!(T instanceof g)) {
                T = new g(T)
            }
            var S = T.x,
                W = T.y,
                V = D;
            if (W) {
                return new g(V(U, S), V(U, W))
            }
            return new g(V(U, S))
        };
        g.diag = function(T) {
            if (!(T instanceof g)) {
                T = new g(T)
            }
            var S = T.x,
                U = T.y;
            if (U) {
                return new g(k(S), k(U))
            }
            return new g(k(S))
        };
        g.eig = function() {
            if (this.y) {
                throw new Error("eig: not implemented for complex matrices.")
            }
            return N(this.x)
        };
        g.identity = function(S) {
            return new g(G(S))
        };
        g.prototype.getDiag = function() {
            var S = this.x,
                T = this.y;
            if (T) {
                return new g(C(S), C(T))
            }
            return new g(C(S))
        };
        var P = function(S) {
            var T = v(S);
            var U = S[0] >= 0 ? 1 : -1;
            var V = U * l(S);
            T[0] += V;
            var W = l(T);
            if (W === 0) {
                throw new Error("eig: internal error")
            }
            return K(T, W)
        };
        var b = function(ac) {
            var ag = a(ac);
            if (ag.length !== 2 || ag[0] !== ag[1]) {
                throw new Error("numeric: toUpperHessenberg() only works on square matrices")
            }
            var X = ag[0],
                aa, Z, Y, ad, af, V = v(ac),
                U, S, ae, T, ab = G(X),
                W;
            for (Z = 0; Z < X - 2; Z++) {
                ad = Array(X - Z - 1);
                for (aa = Z + 1; aa < X; aa++) {
                    ad[aa - Z - 1] = V[aa][Z]
                }
                if (l(ad) > 0) {
                    af = P(ad);
                    U = j(V, [Z + 1, Z], [X - 1, X - 1]);
                    S = B(af, R(af, U));
                    for (aa = Z + 1; aa < X; aa++) {
                        ae = V[aa];
                        T = S[aa - Z - 1];
                        for (Y = Z; Y < X; Y++) {
                            ae[Y] -= 2 * T[Y - Z]
                        }
                    }
                    U = j(V, [0, Z + 1], [X - 1, X - 1]);
                    S = B(R(U, af), af);
                    for (aa = 0; aa < X; aa++) {
                        ae = V[aa];
                        T = S[aa];
                        for (Y = Z + 1; Y < X; Y++) {
                            ae[Y] -= 2 * T[Y - Z - 1]
                        }
                    }
                    U = Array(X - Z - 1);
                    for (aa = Z + 1; aa < X; aa++) {
                        U[aa - Z - 1] = ab[aa]
                    }
                    S = B(af, R(af, U));
                    for (aa = Z + 1; aa < X; aa++) {
                        W = ab[aa];
                        T = S[aa - Z - 1];
                        for (Y = 0; Y < X; Y++) {
                            W[Y] -= 2 * T[Y]
                        }
                    }
                }
            }
            return {
                H: V,
                Q: ab
            }
        };
        var z = function(af, V) {
            if (typeof V === "undefined") {
                V = 10000
            }
            af = v(af);
            var ah = v(af);
            var ai = a(af),
                am = ai[0],
                ae, ag, av, au, at, ar, X, S, W, aa = G(am),
                ac, ab, al, ak, aj, aq, ao, an, ap;
            if (am < 3) {
                return {
                    Q: aa,
                    B: [
                        [0, am - 1]
                    ]
                }
            }
            var aw = 2.220446049250313e-16;
            for (ap = 0; ap < V; ap++) {
                for (ao = 0; ao < am - 1; ao++) {
                    if (Math.abs(af[ao + 1][ao]) < aw * (Math.abs(af[ao][ao]) + Math.abs(af[ao + 1][ao + 1]))) {
                        var Z = z(j(af, [0, 0], [ao, ao]), V);
                        var Y = z(j(af, [ao + 1, ao + 1], [am - 1, am - 1]), V);
                        al = Array(ao + 1);
                        for (aq = 0; aq <= ao; aq++) {
                            al[aq] = aa[aq]
                        }
                        ak = R(Z.Q, al);
                        for (aq = 0; aq <= ao; aq++) {
                            aa[aq] = ak[aq]
                        }
                        al = Array(am - ao - 1);
                        for (aq = ao + 1; aq < am; aq++) {
                            al[aq - ao - 1] = aa[aq]
                        }
                        ak = R(Y.Q, al);
                        for (aq = ao + 1; aq < am; aq++) {
                            aa[aq] = ak[aq - ao - 1]
                        }
                        return {
                            Q: aa,
                            B: Z.B.concat(d(Y.B, ao + 1))
                        }
                    }
                }
                av = af[am - 2][am - 2];
                au = af[am - 2][am - 1];
                at = af[am - 1][am - 2];
                ar = af[am - 1][am - 1];
                S = av + ar;
                X = (av * ar - au * at);
                W = j(af, [0, 0], [2, 2]);
                if (S * S >= 4 * X) {
                    var U, T;
                    U = 0.5 * (S + Math.sqrt(S * S - 4 * X));
                    T = 0.5 * (S - Math.sqrt(S * S - 4 * X));
                    W = d(x(R(W, W), c(W, U + T)), k(D([3], U * T)))
                } else {
                    W = d(x(R(W, W), c(W, S)), k(D([3], X)))
                }
                ae = [W[0][0], W[1][0], W[2][0]];
                ag = P(ae);
                al = [af[0], af[1], af[2]];
                ak = B(ag, R(ag, al));
                for (aq = 0; aq < 3; aq++) {
                    ab = af[aq];
                    aj = ak[aq];
                    for (an = 0; an < am; an++) {
                        ab[an] -= 2 * aj[an]
                    }
                }
                al = j(af, [0, 0], [am - 1, 2]);
                ak = B(R(al, ag), ag);
                for (aq = 0; aq < am; aq++) {
                    ab = af[aq];
                    aj = ak[aq];
                    for (an = 0; an < 3; an++) {
                        ab[an] -= 2 * aj[an]
                    }
                }
                al = [aa[0], aa[1], aa[2]];
                ak = B(ag, R(ag, al));
                for (aq = 0; aq < 3; aq++) {
                    ac = aa[aq];
                    aj = ak[aq];
                    for (an = 0; an < am; an++) {
                        ac[an] -= 2 * aj[an]
                    }
                }
                var ad;
                for (ao = 0; ao < am - 2; ao++) {
                    for (an = ao; an <= ao + 1; an++) {
                        if (Math.abs(af[an + 1][an]) < aw * (Math.abs(af[an][an]) + Math.abs(af[an + 1][an + 1]))) {
                            var Z = z(j(af, [0, 0], [an, an]), V);
                            var Y = z(j(af, [an + 1, an + 1], [am - 1, am - 1]), V);
                            al = Array(an + 1);
                            for (aq = 0; aq <= an; aq++) {
                                al[aq] = aa[aq]
                            }
                            ak = R(Z.Q, al);
                            for (aq = 0; aq <= an; aq++) {
                                aa[aq] = ak[aq]
                            }
                            al = Array(am - an - 1);
                            for (aq = an + 1; aq < am; aq++) {
                                al[aq - an - 1] = aa[aq]
                            }
                            ak = R(Y.Q, al);
                            for (aq = an + 1; aq < am; aq++) {
                                aa[aq] = ak[aq - an - 1]
                            }
                            return {
                                Q: aa,
                                B: Z.B.concat(d(Y.B, an + 1))
                            }
                        }
                    }
                    ad = Math.min(am - 1, ao + 3);
                    ae = Array(ad - ao);
                    for (aq = ao + 1; aq <= ad; aq++) {
                        ae[aq - ao - 1] = af[aq][ao]
                    }
                    ag = P(ae);
                    al = j(af, [ao + 1, ao], [ad, am - 1]);
                    ak = B(ag, R(ag, al));
                    for (aq = ao + 1; aq <= ad; aq++) {
                        ab = af[aq];
                        aj = ak[aq - ao - 1];
                        for (an = ao; an < am; an++) {
                            ab[an] -= 2 * aj[an - ao]
                        }
                    }
                    al = j(af, [0, ao + 1], [am - 1, ad]);
                    ak = B(R(al, ag), ag);
                    for (aq = 0; aq < am; aq++) {
                        ab = af[aq];
                        aj = ak[aq];
                        for (an = ao + 1; an <= ad; an++) {
                            ab[an] -= 2 * aj[an - ao - 1]
                        }
                    }
                    al = Array(ad - ao);
                    for (aq = ao + 1; aq <= ad; aq++) {
                        al[aq - ao - 1] = aa[aq]
                    }
                    ak = B(ag, R(ag, al));
                    for (aq = ao + 1; aq <= ad; aq++) {
                        ac = aa[aq];
                        aj = ak[aq - ao - 1];
                        for (an = 0; an < am; an++) {
                            ac[an] -= 2 * aj[an]
                        }
                    }
                }
            }
            throw new Error("numeric: eigenvalue iteration does not converge -- increase maxiter?")
        };
        var N = function(ak, W) {
            var T = b(ak);
            var X = z(T.H, W);
            var an = ak.length,
                at, ap, ar = false,
                ai = X.B,
                ae = R(X.Q, R(T.H, t(X.Q)));
            var Z = new g(R(X.Q, T.Q)),
                ag;
            var ao = ai.length,
                aq;
            var ax, aw, av, au, V, U, S, ad, ac, aj, ah, ab, aa;
            var ay = Math.sqrt;
            for (ap = 0; ap < ao; ap++) {
                at = ai[ap][0];
                if (at === ai[ap][1]) {} else {
                    aq = at + 1;
                    ax = ae[at][at];
                    aw = ae[at][aq];
                    av = ae[aq][at];
                    au = ae[aq][aq];
                    if (aw === 0 && av === 0) {
                        continue
                    }
                    V = -ax - au;
                    U = ax * au - aw * av;
                    S = V * V - 4 * U;
                    if (S >= 0) {
                        if (V < 0) {
                            ad = -0.5 * (V - ay(S))
                        } else {
                            ad = -0.5 * (V + ay(S))
                        }
                        ab = (ax - ad) * (ax - ad) + aw * aw;
                        aa = av * av + (au - ad) * (au - ad);
                        if (ab > aa) {
                            ab = ay(ab);
                            aj = (ax - ad) / ab;
                            ah = aw / ab
                        } else {
                            aa = ay(aa);
                            aj = av / aa;
                            ah = (au - ad) / aa
                        }
                        ag = new g([
                            [ah, -aj],
                            [aj, ah]
                        ]);
                        Z.setRows(at, aq, ag.dot(Z.getRows(at, aq)))
                    } else {
                        ad = -0.5 * V;
                        ac = 0.5 * ay(-S);
                        ab = (ax - ad) * (ax - ad) + aw * aw;
                        aa = av * av + (au - ad) * (au - ad);
                        if (ab > aa) {
                            ab = ay(ab + ac * ac);
                            aj = (ax - ad) / ab;
                            ah = aw / ab;
                            ad = 0;
                            ac /= ab
                        } else {
                            aa = ay(aa + ac * ac);
                            aj = av / aa;
                            ah = (au - ad) / aa;
                            ad = ac / aa;
                            ac = 0
                        }
                        ag = new g([
                            [ah, -aj],
                            [aj, ah]
                        ], [
                            [ad, ac],
                            [ac, -ad]
                        ]);
                        Z.setRows(at, aq, ag.dot(Z.getRows(at, aq)))
                    }
                }
            }
            var Y = Z.dot(ak).dot(Z.transjugate()),
                an = ak.length,
                af = g.identity(an);
            for (aq = 0; aq < an; aq++) {
                if (aq > 0) {
                    for (ap = aq - 1; ap >= 0; ap--) {
                        var al = Y.get([ap, ap]),
                            am = Y.get([aq, aq]);
                        if (h(al.x, am.x) || h(al.y, am.y)) {
                            ad = Y.getRow(ap).getBlock([ap], [aq - 1]);
                            ac = af.getRow(aq).getBlock([ap], [aq - 1]);
                            af.set([aq, ap], (Y.get([ap, aq]).neg().sub(ad.dot(ac))).div(al.sub(am)))
                        } else {
                            af.setRow(aq, af.getRow(ap));
                            continue
                        }
                    }
                }
            }
            for (aq = 0; aq < an; aq++) {
                ad = af.getRow(aq);
                af.setRow(aq, ad.div(ad.norm2()))
            }
            af = af.transpose();
            af = Z.transjugate().dot(af);
            return {
                lambda: Y.getDiag(),
                E: af
            }
        };
        var E = function(ab) {
            var ag = a(ab),
                ah = Math.abs,
                V = ag[0],
                U = ag[1];
            var T = v(ab),
                ad, aa;
            var ac = G(V),
                S, af;
            var Z, Y, W, ab;
            for (Y = 0; Y < U; ++Y) {
                var X = -1;
                var ae = -1;
                for (Z = Y; Z !== V; ++Z) {
                    W = ah(T[Z][Y]);
                    if (W > ae) {
                        X = Z;
                        ae = W
                    }
                }
                aa = T[X];
                T[X] = T[Y];
                T[Y] = aa;
                af = ac[X];
                ac[X] = ac[Y];
                ac[Y] = af;
                ab = aa[Y];
                for (W = Y; W !== U; ++W) {
                    aa[W] /= ab
                }
                for (W = U - 1; W !== -1; --W) {
                    af[W] /= ab
                }
                for (Z = V - 1; Z !== -1; --Z) {
                    if (Z !== Y) {
                        ad = T[Z];
                        S = ac[Z];
                        ab = ad[Y];
                        for (W = Y + 1; W !== U; ++W) {
                            ad[W] -= aa[W] * ab
                        }
                        for (W = U - 1; W > 0; --W) {
                            S[W] -= af[W] * ab;
                            --W;
                            S[W] -= af[W] * ab
                        }
                        if (W === 0) {
                            S[0] -= af[0] * ab
                        }
                    }
                }
            }
            return ac
        };
        switch (s) {
            case "inv":
                return E(m);
            case "eig":
                return N(m)
        }
    }
};
CanvasXpress.prototype.initjLouvain = function() {
    this.jLouvain = function() {
        var l = -1;
        var k = 1e-7;
        var i;
        var y;
        var s = {};
        var a;

        function d(C) {
            var B = {};
            C.forEach(function(E, D) {
                B[E] = true
            });
            return Object.keys(B)
        }

        function x(D) {
            var C = [];
            for (var B in D) {
                if (D.hasOwnProperty(B)) {
                    C.push(D[B])
                }
            }
            return C
        }

        function v(E, C) {
            var B = E._assoc_mat[C] ? Object.keys(E._assoc_mat[C]) : [];
            var D = 0;
            B.forEach(function(F, G) {
                var H = E._assoc_mat[C][F] || 1;
                if (C == F) {
                    H *= 2
                }
                D += H
            });
            return D
        }

        function f(D, C) {
            if (typeof D._assoc_mat[C] == "undefined") {
                return []
            }
            var B = Object.keys(D._assoc_mat[C]);
            return B
        }

        function g(D, C, B) {
            return D._assoc_mat[C] ? D._assoc_mat[C][B] : undefined
        }

        function A(C) {
            var B = 0;
            C.edges.forEach(function(D) {
                B += D.weight
            });
            return B
        }

        function c(D, C) {
            e(D, C);
            var B = D.edges.map(function(E) {
                return E.id1 + "_" + E.id2
            }).indexOf(C.id1 + "_" + C.id2);
            if (B != -1) {
                D.edges[B].weight = C.weight
            } else {
                D.edges.push(C)
            }
        }

        function z(B) {
            var C = {};
            B.forEach(function(E, D) {
                E.weight = E.weight || 1;
                C[E.id1] = C[E.id1] || {};
                C[E.id1][E.id2] = E.weight;
                C[E.id2] = C[E.id2] || {};
                C[E.id2][E.id1] = E.weight
            });
            return C
        }

        function e(C, B) {
            C._assoc_mat[B.id1] = C._assoc_mat[B.id1] || {};
            C._assoc_mat[B.id1][B.id2] = B.weight;
            C._assoc_mat[B.id2] = C._assoc_mat[B.id2] || {};
            C._assoc_mat[B.id2][B.id1] = B.weight
        }

        function t(D) {
            if (D == null || typeof(D) != "object") {
                return D
            }
            var B = D.constructor();
            for (var C in D) {
                B[C] = t(D[C])
            }
            return B
        }

        function p(D, B, C) {
            B.nodes_to_com = {};
            B.total_weight = 0;
            B.internals = {};
            B.degrees = {};
            B.gdegrees = {};
            B.loops = {};
            B.total_weight = A(D);
            if (typeof C == "undefined") {
                D.nodes.forEach(function(G, E) {
                    B.nodes_to_com[G] = E;
                    var F = v(D, G);
                    if (F < 0) {
                        throw "Bad graph type, use positive weights!"
                    }
                    B.degrees[E] = F;
                    B.gdegrees[G] = F;
                    B.loops[G] = g(D, G, G) || 0;
                    B.internals[E] = B.loops[G]
                })
            } else {
                D.nodes.forEach(function(I, G) {
                    var E = C[I];
                    B.nodes_to_com[I] = E;
                    var H = v(D, I);
                    B.degrees[E] = (B.degrees[E] || 0) + H;
                    B.gdegrees[I] = H;
                    var J = 0;
                    var F = f(D, I);
                    F.forEach(function(K, L) {
                        var M = D._assoc_mat[I][K];
                        if (M <= 0) {
                            throw "Bad graph type, use positive weights"
                        }
                        if (C[K] == E) {
                            if (K == I) {
                                J += M
                            } else {
                                J += M / 2
                            }
                        }
                    });
                    B.internals[E] = (B.internals[E] || 0) + J
                })
            }
        }

        function o(C) {
            var E = C.total_weight;
            var B = 0;
            var D = d(x(C.nodes_to_com));
            D.forEach(function(F, G) {
                var I = C.internals[F] || 0;
                var H = C.degrees[F] || 0;
                if (E > 0) {
                    B = B + I / E - Math.pow((H / (2 * E)), 2)
                }
            });
            return B
        }

        function m(D, E, B) {
            var C = {};
            var F = f(E, D);
            F.forEach(function(G, H) {
                if (G != D) {
                    var I = E._assoc_mat[D][G] || 1;
                    var J = B.nodes_to_com[G];
                    C[J] = (C[J] || 0) + I
                }
            });
            return C
        }

        function u(D, C, E, B) {
            B.nodes_to_com[D] = +C;
            B.degrees[C] = (B.degrees[C] || 0) + (B.gdegrees[D] || 0);
            B.internals[C] = (B.internals[C] || 0) + E + (B.loops[D] || 0)
        }

        function r(D, C, E, B) {
            B.degrees[C] = ((B.degrees[C] || 0) - (B.gdegrees[D] || 0));
            B.internals[C] = ((B.internals[C] || 0) - E - (B.loops[D] || 0));
            B.nodes_to_com[D] = -1
        }

        function j(F) {
            var D = 0;
            var B = t(F);
            var C = {};
            var E = Object.keys(F);
            E.forEach(function(H) {
                var I = F[H];
                var G = typeof C[I] == "undefined" ? -1 : C[I];
                if (G == -1) {
                    C[I] = D;
                    G = D;
                    D = D + 1
                }
                B[H] = G
            });
            return B
        }

        function b(F, B) {
            var D = true,
                G = 0,
                E = o(B),
                C = E;
            while (D && G != l) {
                E = C;
                D = false;
                G += 1;
                F.nodes.forEach(function(J, I) {
                    var M = B.nodes_to_com[J];
                    var O = (B.gdegrees[J] || 0) / (B.total_weight * 2);
                    var L = m(J, F, B);
                    r(J, M, (L[M] || 0), B);
                    var N = M;
                    var H = 0;
                    var K = Object.keys(L);
                    K.forEach(function(P, Q) {
                        var R = L[P] - (B.degrees[P] || 0) * O;
                        if (R > H) {
                            H = R;
                            N = P
                        }
                    });
                    u(J, N, L[N] || 0, B);
                    if (N != M) {
                        D = true
                    }
                });
                C = o(B);
                if (C - E < k) {
                    break
                }
            }
        }

        function h(C, G) {
            var B = {
                nodes: [],
                edges: [],
                _assoc_mat: {}
            };
            var D, F;
            var E = x(C);
            B.nodes = B.nodes.concat(d(E));
            G.edges.forEach(function(I, H) {
                F = I.weight || 1;
                var L = C[I.id1];
                var J = C[I.id2];
                D = (g(B, L, J) || 0);
                var K = (D + F);
                c(B, {
                    source: L,
                    target: J,
                    weight: K
                })
            });
            return B
        }

        function w(C, E) {
            var B = t(C[0]);
            for (var D = 1; D < E + 1; D++) {
                Object.keys(B).forEach(function(H, G) {
                    var I = H;
                    var F = B[H];
                    B[I] = C[D][F]
                })
            }
            return B
        }

        function n(J, D) {
            if (J.edges.length == 0) {
                var C = {};
                J.nodes.forEach(function(L, K) {
                    C[L] = L
                });
                return C
            }
            var F = {};
            p(s, F, D);
            var H = o(F);
            var I = [];
            b(s, F);
            var B = o(F);
            var G = j(F.nodes_to_com);
            I.push(G);
            H = B;
            var E = h(G, s);
            p(E, F);
            while (true) {
                b(E, F);
                B = o(F);
                if (B - H < k) {
                    break
                }
                G = j(F.nodes_to_com);
                I.push(G);
                H = B;
                E = h(G, E);
                p(E, F)
            }
            return I
        }
        var q = function() {
            var B = {};
            var C = n(s, a);
            return w(C, C.length - 1)
        };
        q.nodes = function(B) {
            if (arguments.length > 0) {
                i = B
            }
            return q
        };
        q.edges = function(C) {
            if (typeof i == "undefined") {
                throw "Please provide the graph nodes first!"
            }
            if (arguments.length > 0) {
                y = C;
                var B = z(C);
                s = {
                    nodes: i,
                    edges: y,
                    _assoc_mat: B
                }
            }
            return q
        };
        q.partition_init = function(B) {
            if (arguments.length > 0) {
                a = B
            }
            return q
        };
        return q
    }
};
CanvasXpress.prototype.initMathUtils = function() {
        this.isNaN = function(a) {
            return isNaN(a) ? true : a == Number.POSITIVE_INFINITY ? true : a == Number.NEGATIVE_INFINITY ? true : false
        };
        this.isFinite = function(a) {
            if (this.isArray(a)) {
                for (var b = 0; b < a.length; b++) {
                    if (!isFinite(a[b])) {
                        return false
                    }
                }
                return true
            } else {
                return isFinite(a)
            }
        };
        this.getPolar = function(b, e, d, c) {
            return {
                x: b + d * Math.cos(c * Math.PI / 180),
                y: e + d * Math.sin(c * Math.PI / 180)
            }
        };
        this.triCube = function(a) {
            return (a = 1 - a * a * a) * a * a
        };
        this.degreesToArcLength = function(b, a) {
            return b * a
        };
        this.radiansToArcLength = function(a, b) {
            return (a * Math.PI * b) / 180
        };
        this.arcLengthToDegrees = function(b, a) {
            return (a * 180) / (b * Math.PI)
        };
        this.arcLengthToRadians = function(b, a) {
            return a / b
        };
        this.radians = function(a) {
            return a * Math.PI / 180
        };
        this.degrees = function(a) {
            return a * 180 / Math.PI
        };
        this.getAngle = function(e, h, c, g, d) {
            var b = (Math.atan2(g - h, c - e) * 180 / Math.PI) % 360;
            if (!d) {
                d = 0
            }
            while (b < d) {
                b += 360
            }
            while (b >= (d + 360)) {
                b -= 360
            }
            return b
        };
        this.getRadians = function(d, g, c, e) {
            var b = Math.atan2(e - g, c - d);
            if (b < 0) {
                b += (2 * Math.PI)
            }
            return b
        };
        this.rotatePoint = function(c, i, b, h, d) {
            var g = Math.cos(d) * (c - b) - Math.sin(d) * (i - h) + b;
            var e = Math.sin(d) * (c - b) + Math.cos(d) * (i - h) + h;
            return [g, e]
        };
        this.lineLength = function(b, d, a, c) {
            return Math.sqrt(Math.pow(a - b, 2) + Math.pow(c - d, 2))
        };
        this.lineMidPoint = function(b, d, a, c) {
            return [(b + a) / 2, (d + c) / 2]
        };
        this.getCoordinateAtDistance = function(b, j, a, i, h) {
            var c = a - b;
            var k = i - j;
            var e = Math.sqrt(Math.pow(c, 2) + Math.pow(k, 2));
            var g = h / e;
            return [b + (c * g), j + (k * g)]
        };
        this.parallelLinePoints = function(t, d, r, b, p) {
            var j = r - t;
            var i = b - d;
            var q = this.lineLength(t, d, r, b);
            var w = j / q;
            var v = i / q;
            var u = -v;
            var s = w;
            var c = t + p * u;
            var g = d + p * s;
            var a = t - p * u;
            var e = d - p * s;
            var k = r + p * u;
            var o = b + p * s;
            var h = r - p * u;
            var n = b - p * s;
            return [c, g, a, e, k, o, h, n]
        };
        this.perpendicularLinePoints = function(b, o, a, j, c, g) {
            var h = this.lineLength(b, o, a, j);
            var p = this.lineMidPoint(b, o, a, j);
            if (!c) {
                c = h * g
            }
            var s = a - p[0];
            var r = j - p[1];
            var e = s / h;
            var d = r / h;
            var q = -d;
            var n = e;
            var k = p[0] + c * q;
            var i = p[1] + c * n;
            return [k, i]
        };
        this.shortenLine = function(g, p, c, o, t, j, u, a) {
            if (this.isNumeric([g, p, c, o, t, j])) {
                if (u.match(/bezier/i)) {
                    if (u.match(/beziery/i)) {
                        return o > p ? [g, p + t, c, o - j] : [g, p - t, c, o + j]
                    } else {
                        return c > g ? [g + t, p, c - j, o] : [g - t, p, c + j, o]
                    }
                } else {
                    if (u.match(/quadratic/i)) {
                        var l = this.lineLength(g, p, c, o);
                        var d = this.perpendicularLinePoints(g, p, c, o, false, Math.min(1, this.arrowQuadraticFactor * Math.abs(a)) * (a > 0 ? -1 : 1));
                        var b = this.traceQuadraticCurve(g, p, d[0], d[1], c, o, t / l, true);
                        var r = this.traceQuadraticCurve(c, o, d[0], d[1], g, p, j / l, true);
                        return [b[1][0], b[1][1], r[1][0], r[1][1]]
                    } else {
                        if (u.match(/curved/i)) {
                            return [g, p, c, o]
                        } else {
                            var h = Math.atan2(o - p, c - g);
                            var i = Math.cos(h);
                            var n = Math.sin(h);
                            var k = this.lineLength(g, p, c, o);
                            if (k) {
                                while (k < (t + j)) {
                                    t /= 1.1;
                                    j /= 1.1
                                }
                                g += i * t;
                                p += n * t;
                                c -= i * j;
                                o -= n * j
                            }
                            return [g, p, c, o]
                        }
                    }
                }
            }
        };
        this.traceArc = function(c, b, a, n, h, d) {
            if (n > h) {
                var k = n;
                n = h;
                h = k
            }
            var l = [];
            var j = ((Math.PI * 2) - (h - n)) / 16;
            l.push([a * Math.cos(n) + c, a * Math.sin(n) + b]);
            for (var g = 0; g < 16; g++) {
                n -= j;
                l.push([a * Math.cos(n) + c, a * Math.sin(n) + b])
            }
            return d ? l.reverse() : l
        };
        this.traceArc1 = function(c, b, a, o, i, d) {
            if (o > i) {
                var l = o;
                o = i;
                i = l
            }
            var n = [];
            var h = Math.PI;
            var j = i - o;
            var g = 32;
            var k = j / g;
            if (k < 1e-9) {
                n.push([a * Math.cos(o) + c, a * Math.sin(o) + b])
            } else {
                n.push([a * Math.cos(o) + c, a * Math.sin(o) + b]);
                o += k;
                while (o < i) {
                    n.push([a * Math.cos(o) + c, a * Math.sin(o) + b]);
                    o += k
                }
                n.push([a * Math.cos(i) + c, a * Math.sin(i) + b])
            }
            return d ? n : n.reverse()
        };
        this.traceQuadraticCurve = function(n, l, e, c, k, j, b, g) {
            var o = [];
            b = Math.max(0.01, b);
            var a = function(i, s, r, q) {
                var p = 1 - i;
                return p * p * s + 2 * p * i * r + i * i * q
            };
            var d = function(i) {
                return [a(i, n, e, k), a(i, l, c, j)]
            };
            for (var h = 0; h <= 1; h += b) {
                o.push(d(h))
            }
            return g ? o : o.reverse()
        };
        this.traceBezierCurve = function(k, j, c, b, n, l, h, g, a, d) {
            var o = [];
            a = Math.max(0.01, a);
            for (var e = 0; e <= 1; e += a) {
                o.push(this.deCasteljau([
                    [k, j],
                    [c, b],
                    [n, l],
                    [h, g]
                ], e))
            }
            return d ? o : o.reverse()
        };
        this.splineControlPoint = function(e, o, d, n, c, l) {
            var p = Math.sqrt(Math.pow(d - e, 2) + Math.pow(n - o, 2));
            var i = Math.sqrt(Math.pow(c - d, 2) + Math.pow(l - n, 2));
            var h = this.tension * p / (p + i);
            var g = this.tension - h;
            var b = d + h * (e - c);
            var a = n + h * (o - l);
            var k = d - g * (e - c);
            var j = n - g * (o - l);
            return [b, a, k, j]
        };
        this.smooth = function(d, g) {
            var n = [];
            for (var c = 0; c < d.length; c++) {
                var a = c - g;
                var k = a >= 0 ? a : 0;
                var l = c + g + 1;
                var h = 0;
                var e = 0;
                for (var b = k; b < l && b < d.length; b++) {
                    e += d[b];
                    h++
                }
                n[c] = e / h
            }
            return n
        };
        this.spline = function(e, h) {
            var g = [];
            var a = e[0];
            var d = e[1];
            for (var c = 0; c < a.length; c++) {
                g.push(a[c]);
                g.push(d[c])
            }
            var b = this.curvePoints(g, h);
            a = [];
            d = [];
            while (b.length) {
                a.push(b.shift());
                d.push(b.shift())
            }
            return [a, d]
        };
        this.curvePoints = function(z, l) {
            var a = [];
            var A = [];
            var g = this.tension;
            var h = this.tensionSegments;
            l = l ? l : false;
            a = z.slice(0);
            if (l) {
                a.unshift(z[z.length - 1]);
                a.unshift(z[z.length - 2]);
                a.unshift(z[z.length - 1]);
                a.unshift(z[z.length - 2]);
                a.push(z[0]);
                a.push(z[1])
            } else {
                a.unshift(z[1]);
                a.unshift(z[0]);
                a.push(z[z.length - 2]);
                a.push(z[z.length - 1])
            }
            var e, d, c, p, b, n, r, q, o, k, u;
            for (var w = 2; w < (a.length - 4); w += 2) {
                for (var v = 0; v <= h; v++) {
                    c = (a[w + 2] - a[w - 2]) * g;
                    p = (a[w + 4] - a[w]) * g;
                    b = (a[w + 3] - a[w - 1]) * g;
                    n = (a[w + 5] - a[w + 1]) * g;
                    u = v / h;
                    r = 2 * Math.pow(u, 3) - 3 * Math.pow(u, 2) + 1;
                    q = -(2 * Math.pow(u, 3)) + 3 * Math.pow(u, 2);
                    o = Math.pow(u, 3) - 2 * Math.pow(u, 2) + u;
                    k = Math.pow(u, 3) - Math.pow(u, 2);
                    e = r * a[w] + q * a[w + 2] + o * c + k * p;
                    d = r * a[w + 1] + q * a[w + 3] + o * b + k * n;
                    A.push(e);
                    A.push(d)
                }
            }
            return A
        };
        this.hullControlPoints = function(g) {
            var c = this;
            var g;
            var e = [];
            var h = 0;
            var b, a;
            var d = function(r, p, o) {
                var n = function(t, s) {
                    var v = s[0] - t[0];
                    var u = s[1] - t[1];
                    return Math.sqrt(v * v + u * u)
                };
                var q = n(r, p);
                var l = n(p, o);
                var i = c.tension * q / (q + l);
                var k = [((r[0] - o[0]) * i) + p[0], ((r[1] - o[1]) * i) + p[1]];
                var j = [p[0] - ((r[0] - o[0]) * i), (p[1] - (r[1] - o[1]) * i)];
                return [k, j]
            };
            for (b = 0; b < g.length - 2; b++) {
                e.push.apply(e, d(g[b], g[b + 1], g[b + 2]))
            }
            e.push.apply(e, d(g[b], g[b + 1], g[0]));
            e.push.apply(e, d(g[b + 1], g[0], g[1]));
            return e
        };
        this.expandPolygon = function(r, y) {
            var b = function(i) {
                var d = Math.sqrt(i.x * i.x + i.y * i.y);
                return {
                    x: i.x / d,
                    y: i.y / d
                }
            };
            var u = function(d, i) {
                return {
                    x: d.x * i,
                    y: d.y * i
                }
            };
            var n = function(i, d) {
                return i.x * d.x + i.y * d.y
            };
            var c = function(d) {
                return {
                    x: d.y,
                    y: -d.x
                }
            };
            var z = function(d) {
                return {
                    x: -d.y,
                    y: d.x
                }
            };
            var x = function(H, G) {
                var i = H[1].x - H[0].x;
                var F = G[0].x - G[1].x;
                var D = G[0].x - H[0].x;
                var d = H[1].y - H[0].y;
                var E = G[0].y - G[1].y;
                var p = G[0].y - H[0].y;
                var I = (F * p - E * D) / (d * F - i * E);
                return {
                    x: H[0].x + I * (H[1].x - H[0].x),
                    y: H[0].y + I * (H[1].y - H[0].y)
                }
            };
            var B = function(d) {
                return n(c({
                    x: d[1].x - d[0].x,
                    y: d[1].y - d[0].y
                }), {
                    x: d[2].x - d[1].x,
                    y: d[2].y - d[1].y
                }) >= 0
            };
            var v = [];
            var h = B(r) ? z : c;
            for (var w = 0; w < r.length; ++w) {
                var l = r[(w > 0) ? w - 1 : r.length - 1];
                var j = r[w];
                var g = r[(w < r.length - 1) ? w + 1 : 0];
                var o = {
                    x: j[0] - l[0],
                    y: j[1] - l[1]
                };
                var A = {
                    x: g[0] - j[0],
                    y: g[1] - j[1]
                };
                var q = u(b(h(o)), y);
                var C = u(b(h(A)), y);
                var t = {
                    x: l[0] + q.x,
                    y: l[1] + q.y
                };
                var k = {
                    x: j[0] + q.x,
                    y: j[1] + q.y
                };
                var e = {
                    x: j[0] + C.x,
                    y: j[1] + C.y
                };
                var s = {
                    x: g[0] + C.x,
                    y: g[1] + C.y
                };
                var a = x([t, k], [e, s]);
                v.push([a.x, a.y])
            }
            return v
        };
        this.enlargePolygon = function(u, A, t) {
            var g = function(i, e, d) {
                return ((d.x - i.x) * (e.y - i.y)) - ((e.x - i.x) * (d.y - i.y))
            };
            var B = function(p, s) {
                var e = p.vrs[s];
                var d = p.vrs[(s + 1) % p.vrs.length];
                var i = p.vrs[(s + p.vrs.length - 1) % p.vrs.length];
                return (g(i, d, e) < 0) ? true : false
            };
            var j = function(s) {
                var i = s.v2.x - s.v1.x;
                var d = s.v2.y - s.v1.y;
                var p = Math.sqrt(i * i + d * d);
                return {
                    x: -d / p,
                    y: i / p
                }
            };
            var r = function(d) {
                var i = j(d);
                return {
                    x: -i.x,
                    y: -i.y
                }
            };
            var b = function(L) {
                var p = {
                    vrs: L
                };
                var K = [];
                var F = (L.length > 0) ? L[0].x : undefined;
                var v = (L.length > 0) ? L[0].y : undefined;
                var s = F;
                var d = v;
                for (var G = 0; G < p.vrs.length; G++) {
                    L[G].label = String(G);
                    L[G].isReflex = B(p, G);
                    var H = {
                        v1: L[G],
                        v2: L[(G + 1) % L.length],
                        pol: p,
                        index: G
                    };
                    H.outwardNormal = r(H);
                    H.inwardNormal = j(H);
                    K.push(H);
                    var J = L[G].x;
                    var I = L[G].y;
                    F = Math.min(J, F);
                    v = Math.min(I, v);
                    s = Math.max(J, s);
                    d = Math.max(I, d)
                }
                p.edges = K;
                p.minX = F;
                p.minY = v;
                p.maxX = s;
                p.maxY = d;
                p.closed = true;
                return p
            };
            var n = function(p, i, d) {
                return {
                    v1: {
                        x: p.v1.x + i,
                        y: p.v1.y + d
                    },
                    v2: {
                        x: p.v2.x + i,
                        y: p.v2.y + d
                    }
                }
            };
            var E = function(p, e) {
                var s = (e.v2.y - e.v1.y) * (p.v2.x - p.v1.x) - (e.v2.x - e.v1.x) * (p.v2.y - p.v1.y);
                if (s == 0) {
                    return null
                }
                var i = ((e.v2.x - e.v1.x) * (p.v1.y - e.v1.y) - (e.v2.y - e.v1.y) * (p.v1.x - e.v1.x)) / s;
                var d = ((p.v2.x - p.v1.x) * (p.v1.y - e.v1.y) - (p.v2.y - p.v1.y) * (p.v1.x - e.v1.x)) / s;
                if (i < 0 || d < 0 || i > 1 || d > 1) {
                    return null
                }
                return {
                    x: p.v1.x + i * (p.v2.x - p.v1.x),
                    y: p.v1.y + i * (p.v2.y - p.v1.y)
                }
            };
            var c = function(N, G, d, M, H, s) {
                var L = Math.PI * 2;
                var J = Math.atan2(M.y - G.y, M.x - G.x);
                var F = Math.atan2(H.y - G.y, H.x - G.x);
                if (J < 0) {
                    J += L
                }
                if (F < 0) {
                    F += L
                }
                var I = ((J > F) ? (J - F) : (J + L - F));
                var e = ((s) ? -I : L - I) / t;
                N.push(M);
                for (var p = 1; p < t; ++p) {
                    var I = J + e * p;
                    var K = {
                        x: G.x + Math.cos(I) * d,
                        y: G.y + Math.sin(I) * d
                    };
                    N.push(K)
                }
                N.push(H)
            };
            var w = [];
            var x = [];
            for (var y = 0; y < u.length; y++) {
                x.push({
                    x: u[y][0],
                    y: u[y][1]
                })
            }
            var k = b(x);
            for (var y = 0; y < k.edges.length; y++) {
                var z = k.edges[y];
                var q = z.outwardNormal.x * A;
                var l = z.outwardNormal.y * A;
                w.push(n(z, q, l))
            }
            x = [];
            for (var y = 0; y < w.length; y++) {
                var h = w[y];
                var D = w[(y + w.length - 1) % w.length];
                var o = E(D, h);
                if (o) {
                    x.push(o)
                } else {
                    var C = k.edges[y].v1;
                    c(x, C, A, D.v2, h.v1, false)
                }
            }
            var a = [];
            for (var y = 0; y < x.length; y++) {
                a.push([x[y].x, x[y].y])
            }
            return a
        };
        this.sample = function(c, h) {
            if (c) {
                if (!h || h <= 0) {
                    h = c.length
                }
                var e, b;
                var g = c.slice(0);
                var d = c.length;
                var a = d - h;
                while (d-- > a) {
                    b = Math.floor((d + 1) * this.random());
                    e = g[b];
                    g[b] = g[d];
                    g[d] = e
                }
                return g.slice(a)
            } else {
                return []
            }
        };
        this.expandGrid = function(H, e, d) {
            var b = function(c) {
                var x = {};
                var y = [];
                for (var r = 0; r < c.length; r++) {
                    var j = c[r];
                    if (!isNaN(j) && !x.hasOwnProperty(j.toString())) {
                        y.push(j);
                        x[j.toString()] = true
                    }
                }
                y = y.sort(function(z, i) {
                    return z - i
                });
                return y
            };
            var F = function(c, J) {
                var r = 0;
                var I = 0;
                for (var j = 0; j < H.length; j++) {
                    if (H[j][0] == c && H[j][1] == J) {
                        r += H[j][2];
                        I++
                    }
                }
                return r / I
            };
            var u = function(c, j) {
                for (var r = 0; r < j.length; r++) {
                    if (c == j[r]) {
                        return r
                    } else {
                        if (j[r] > c) {
                            return j[r] - c < c - j[r - 1] ? r : Math.max(0, r - 1)
                        } else {
                            if (c > j[j.length - 1]) {
                                return j[j.length - 1]
                            }
                        }
                    }
                }
            };
            var p = [];
            var A = [];
            for (var E = 0; E < H.length; E++) {
                p.push(H[E][0]);
                A.push(H[E][1])
            }
            p = b(p);
            A = b(A);
            var G = [];
            for (var E = 0; E < p.length; E++) {
                var s = p[E];
                G[E] = [];
                for (var C = 0; C < A.length; C++) {
                    var q = A[C];
                    var o = F(s, q);
                    G[E].push([q, o])
                }
                G[E] = G[E].length > 1 ? this.linearRegression(G[E]) : {
                    params: [1, 0]
                }
            }
            var v = [];
            for (var E = 0; E < A.length; E++) {
                var q = p[E];
                v[E] = [];
                for (var C = 0; C < p.length; C++) {
                    var s = p[C];
                    var o = F(s, q);
                    v[E].push([s, o])
                }
                v[E] = v[E].length > 1 ? this.linearRegression(v[E]) : {
                    params: [1, 0]
                }
            }
            var D = p[0] - (p[1] - p[0]);
            var B = p[p.length - 1] + (p[p.length - 1] - p[p.length - 2]);
            var n = A[0] - (A[1] - A[0]);
            var k = A[A.length - 1] + (A[A.length - 1] - A[A.length - 2]);
            var w = [];
            var t = [];
            var l = [];
            for (var E = 0; E < A.length; E++) {
                l[E] = []
            }
            for (var E = 0; E < p.length; E++) {
                for (var C = 0; C < A.length; C++) {
                    l[E][C] = (C * G[E].params[0]) + G[E].params[1]
                }
            }
            l.unshift([]);
            l.push([]);
            for (var E = 0; E < p.length; E++) {
                var h = (n * G[E].params[0]) + G[E].params[1];
                var g = (k * G[E].params[0]) + G[E].params[1];
                l[0][p.length - (E + 1)] = g;
                l[l.length - 1][p.length - (E + 1)] = h;
                w.push([p[E], g]);
                t.push([p[E], h])
            }
            w = this.linearRegression(w);
            t = this.linearRegression(t);
            l[0].push((D * w.params[0]) + w.params[1]);
            l[0].unshift((B * w.params[0]) + w.params[1]);
            for (var E = 0; E < A.length; E++) {
                l[v.length - E].push((D * v[E].params[0]) + v[E].params[1]);
                l[v.length - E].unshift((B * v[E].params[0]) + v[E].params[1])
            }
            l[l.length - 1].push((D * t.params[0]) + t.params[1]);
            l[l.length - 1].unshift((B * t.params[0]) + t.params[1]);
            p.push(B);
            p.unshift(D);
            A.push(k);
            A.unshift(n);
            var a = [];
            for (var E = 0; E < l.length; E++) {
                for (var C = 0; C < l[E].length; C++) {
                    a.push(l[E][C])
                }
            }
            return {
                x: p,
                y: A,
                data: a,
                matrix: l
            }
        };
        this.seq = function(h, c, g, a) {
            var d = [];
            if (h != null && c != null && (a || g)) {
                var b = c < h;
                if (c < h) {
                    var e = h;
                    h = c;
                    c = e
                }
                if (a) {
                    a = Math.abs(a);
                    g = (c - h) / (a - 1)
                } else {
                    g = Math.abs(g)
                }
                if (g) {
                    while (c >= h) {
                        d.push(h);
                        h += g
                    }
                }
                if (a) {
                    d[a - 1] = c
                } else {
                    if (d[d.length - 1] < c) {
                        d.push(c)
                    }
                }
            }
            return b ? d.reverse() : d
        };
        this.runif = function(g, e, b) {
            var c = [];
            if (e != null && b != null) {
                for (var d = 0; d < g; d++) {
                    c.push(this.randomBetween(e, b))
                }
            } else {
                for (var d = 0; d < g; d++) {
                    c.push(this.random())
                }
            }
            return c
        };
        this.rnorm = function(j, b, d) {
            var h = this;
            var c = [];
            if (b == null) {
                b = 0
            }
            if (d == null) {
                d = 1
            }
            d = Math.sqrt(d);
            var g = function() {
                var k, i;
                var a = 2;
                while (a > 1) {
                    k = h.random() * 2 - 1;
                    i = h.random() * 2 - 1;
                    a = k * k + i * i
                }
                return b + d * k * Math.sqrt(-2 * Math.log(a) / a)
            };
            for (var e = 0; e < j; e++) {
                c.push(g())
            }
            return c
        };
        this.percentile2 = function(a, g) {
            if (a.length === 0) {
                return 0
            }
            if (typeof g !== "number") {
                throw new TypeError("p must be a number")
            }
            if (g <= 0) {
                return a[0]
            }
            if (g >= 1) {
                return a[a.length - 1]
            }
            var c = a.length * g;
            var b = Math.floor(c);
            var d = b + 1;
            var e = c % 1;
            if (d >= a.length) {
                return a[b]
            } else {
                return a[b] * (1 - e) + a[d] * e
            }
        };
        this.percentRank = function(a, c) {
            if (typeof c !== "number") {
                throw new TypeError("v must be a number")
            }
            for (var d = 0, b = a.length; d < b; d++) {
                if (c <= a[d]) {
                    while (d < b && c === a[d]) {
                        d++
                    }
                    if (d === 0) {
                        return 0
                    }
                    if (c !== a[d - 1]) {
                        d += (c - a[d - 1]) / (a[d] - a[d - 1])
                    }
                    return d / b
                }
            }
            return 1
        };
        this.percentile = function(d, a, e) {
            var b = a - d;
            if (b == 0) {
                return 50
            }
            var c = e - d;
            return c * 100 / b
        };
        this.percentile3 = function(b) {
            if (b.length === 0) {
                return b
            }
            var e = this.min(b);
            var a = this.max(b);
            var c = a - e;
            var g = [];
            for (var d = 0; d < b.length; d++) {
                var h = b[d] - e;
                g.push(h / c)
            }
            return g
        };
        this.rank = function(a) {
            var c = [];
            for (var b = 0; b < a.length; b++) {
                c.push(b)
            }
            c.sort(function(e, d) {
                return a[e] - a[d]
            });
            return c
        };
        this.rank2 = function(b) {
            var d = b.slice().sort(function(h, g) {
                return h - g
            });
            var e = b.slice().map(function(g) {
                return d.indexOf(g) + 1
            });
            var c = {};
            e.map(function(g) {
                c[g] = c[g] ? c[g]++ : 1
            });
            var a = e.map(function(g) {
                return g / c[g]
            });
            return a
        };
        this.min = function(b, a, g) {
            if (this.isArray(b)) {
                var e = Number.POSITIVE_INFINITY;
                if (this.isArray(b[0])) {
                    for (var d = 0; d < b.length; d++) {
                        for (var c = 0; c < b[d].length; c++) {
                            if (this.isNumber(b[d][c], true)) {
                                e = Math.min(e, b[d][c])
                            }
                        }
                    }
                } else {
                    b = this.cleanArray(b, a, g);
                    for (var d = 0; d < b.length; d++) {
                        if (this.isNumber(b[d], true)) {
                            e = Math.min(e, b[d])
                        }
                    }
                }
                return e
            } else {
                return this.Min(b, a)
            }
        };
        this.max = function(c, b, g) {
            if (this.isArray(c)) {
                var a = Number.NEGATIVE_INFINITY;
                if (this.isArray(c[0])) {
                    for (var e = 0; e < c.length; e++) {
                        for (var d = 0; d < c[e].length; d++) {
                            if (this.isNumber(c[e][d], true)) {
                                a = Math.max(a, c[e][d])
                            }
                        }
                    }
                } else {
                    c = this.cleanArray(c, b, g);
                    for (var e = 0; e < c.length; e++) {
                        if (this.isNumber(c[e], true)) {
                            a = Math.max(a, c[e])
                        }
                    }
                }
                return a
            } else {
                return this.Max(c, b)
            }
        };
        this.sum = function(b, a, h, e, g) {
            b = this.cleanArray(b, a, h);
            var d = 0;
            for (var c = 0; c < b.length; c++) {
                if (e) {
                    if (b[c] > 0) {
                        d += b[c]
                    }
                } else {
                    if (g) {
                        if (b[c] < 0) {
                            d += b[c]
                        }
                    } else {
                        d += b[c]
                    }
                }
            }
            return d
        };
        this.sumSquared = function(b, a, g, e) {
            b = this.cleanArray(b, a, g);
            var d = 0;
            for (var c = 0; c < b.length; c++) {
                if (e) {
                    if (b[c] > 0) {
                        d += b[c] * b[c]
                    }
                } else {
                    d += b[c] * b[c]
                }
            }
            return d
        };
        this.sumSquaredError = function(b, a, h) {
            b = this.cleanArray(b, a, h);
            var c = this.mean(b);
            var g = 0;
            for (var e = 0; e < b.length; e++) {
                var d = b[e] - c;
                g += d * d
            }
            return g
        };
        this.mean = function(b, a, e) {
            b = this.cleanArray(b, a, e);
            var c = 0;
            var g = 0;
            for (var d = 0; d < b.length; d++) {
                if (!this.isNaN(b[d])) {
                    c += Number(b[d]);
                    g++
                }
            }
            if (g > 0) {
                c /= g
            }
            return c
        };
        this.range = function(c, b, g) {
            c = this.cleanArray(c, b, g);
            var e = Number.MAX_VALUE;
            var a = Number.MAX_VALUE * -1;
            for (var d = 0; d < c.length; d++) {
                e = Math.min(c[d], e);
                a = Math.max(c[d], a)
            }
            return e == a && e == 0 ? [-0.005, 0.005] : e == a ? [Number(e) - 0.005, Number(a) + 0.005] : [Number(e), Number(a)]
        };
        this.range2D = function(b) {
            var e = Number.MAX_VALUE;
            var a = Number.MAX_VALUE * -1;
            for (var d = 0; d < b.length; d++) {
                for (var c = 0; c < b[d].length; c++) {
                    if (this.isNumber(b[d][c], true)) {
                        e = Math.min(b[d][c], e);
                        a = Math.max(b[d][c], a)
                    }
                }
            }
            return e == a && e == 0 ? [0, 0.01] : e == a ? [Number(e), Number(a)] : [Number(e), Number(a)]
        };
        this.median = function(b, a, g) {
            b = this.cleanArray(b, a, g);
            var e = [];
            var d = [];
            var h = 0;
            e[0] = Number.NaN;
            e[1] = Number.NaN;
            for (var c = 0; c < b.length; c++) {
                d.push(b[c]);
                h++
            }
            if (h > 0) {
                e[1] = h;
                d.sort(function(j, i) {
                    return j - i
                });
                if (h % 2) {
                    e[0] = d[parseInt(h / 2)]
                } else {
                    e[0] = (d[parseInt((h - 1) / 2)] + d[h / 2]) / 2
                }
            }
            return e
        };
        this.Abs = function(b, a, e) {
            b = this.cleanArray(b, a, e);
            var d = [];
            for (var c = 0; c < b.length; c++) {
                d.push(Math.abs(b[c]))
            }
            return d
        };
        this.square = function(b, a, e) {
            b = this.cleanArray(b, a, e);
            var d = [];
            for (var c = 0; c < b.length; c++) {
                d.push(b[c] * b[c])
            }
            return d
        };
        this.subtractArray = function(c, e) {
            var b = [];
            for (var d = 0; d < c.length; d++) {
                b.push(c[d] - e)
            }
            return b
        };
        this.addArray = function(c, e) {
            var b = [];
            for (var d = 0; d < c.length; d++) {
                b.push(c[d] + e)
            }
            return b
        };
        this.replaceArray = function(c, e) {
            var b = [];
            for (var d = 0; d < c.length; d++) {
                b.push(e)
            }
            return b
        };
        this.nextSeed = function(a) {
            if (this.randomMethod == "numericalRecipes") {
                return (a * 9301 + 49297) % 233280
            } else {
                a = ((a + 2127912214) + (a << 12)) & 4294967295;
                a = ((a ^ 3345072700) ^ (a >>> 19)) & 4294967295;
                a = ((a + 374761393) + (a << 5)) & 4294967295;
                a = ((a + 3550635116) ^ (a << 9)) & 4294967295;
                a = ((a + 4251993797) + (a << 3)) & 4294967295;
                a = ((a ^ 3042594569) ^ (a >>> 16)) & 4294967295;
                return a
            }
        };
        this.random = function(a) {
            if (this.pseudoRandom) {
                this.randomSeed = this.nextSeed(a || this.randomSeed);
                return this.randomMethod == "numericalRecipes" ? this.randomSeed / 233280 : (this.randomSeed & 268435455) / 268435456;
                return
            } else {
                return Math.random()
            }
        };
        this.randomBetween = function(c, a, b) {
            return (this.random(b) * (a - c + 1)) + c
        };
        this.randomInt = function(a) {
            return parseInt(this.random(a))
        };
        this.randomIntBetween = function(c, a, b) {
            return Math.floor(this.random(b) * (a - c + 1)) + c
        };
        this.sumarizeErrorData = function(b, a, c) {
            if (this.errorBarsType == "standardErrorMean") {
                return this.meanStandardErrorN(b, a, c)
            } else {
                if (this.errorBarsType == "confidenceInterval95") {
                    return this.mean95ConfidenceIntervalN(b, a, c)
                } else {
                    return this.meanStandardDeviationN(b, a, c)
                }
            }
        };
        this.meanStandardErrorN = function(b, a, d) {
            var c = this.variance(b, a, d, true);
            if (this.isNaN(c[1])) {
                return [Number.NaN, Number.NaN, Number.NaN]
            }
            return [c[0], Math.sqrt(c[1]) / Math.sqrt(c[2]), c[2]]
        };
        this.mean95ConfidenceIntervalN = function(b, a, d) {
            var c = this.meanStandardErrorN(b, a, d, true);
            if (this.isNaN(c[1])) {
                return [Number.NaN, Number.NaN, Number.NaN]
            }
            return [c[0], c[1] * 1.96, c[2]]
        };
        this.meanStandardDeviationN = function(b, a, d) {
            var c = this.variance(b, a, d, true);
            if (this.isNaN(c[1])) {
                return [Number.NaN, Number.NaN, Number.NaN]
            }
            return [c[0], Math.sqrt(c[1]), c[2]]
        };
        this.fivenum = function(a) {
            a.sort(function(i, d) {
                return i - d
            });
            var h = a.length;
            var b = Math.floor((h + 3) / 2) / 2;
            var g = [1, b, (h + 1) / 2, h + 1 - b, h];
            var e = [];
            for (var c = 0; c < g.length; c++) {
                e.push((a[Math.floor(g[c]) - 1] + a[Math.ceil(g[c]) - 1]) * 0.5)
            }
            return e
        };
        this.boxplot = function(a, d, c) {
            if (a.length > 0) {
                a = this.cleanArray(a, d, c);
                var e = [];
                var n = [];
                var b = this.fivenum(a);
                var h = this.boxplotHingeFunction == "summary" ? this.quantile(a, [0.25, 0.75]) : [b[1], b[3]];
                var w = b[0];
                var s = h[0];
                var q = b[2];
                var u = b[2];
                var p = h[1];
                var v = b[4];
                var l = p - s;
                var r = s - this.boxplotCoef * l;
                var o = p + this.boxplotCoef * l;
                var k = (b[3] - b[1]) / Math.sqrt(a.length);
                for (var t = 0; t < a.length; t++) {
                    if (a[t] < r || a[t] > o) {
                        e.push(a[t])
                    } else {
                        n.push(a[t])
                    }
                }
                if (e.length > 0) {
                    var g = this.range(n);
                    w = g[0];
                    v = g[1]
                }
                var j = [u - 1.58 * k, u + 1.58 * k];
                return [u, s, q, p, w, v, e, a.length, j]
            }
            return [Number.NaN, Number.NaN, Number.NaN, Number.NaN, Number.NaN, Number.NaN, Number.NaN]
        };
        this.quantileBin = function(b, a) {
            if (a < b[0]) {
                return 0
            } else {
                if (a >= b[0] && a < b[1]) {
                    return 1
                } else {
                    if (a >= b[1] && a < b[2]) {
                        return 2
                    } else {
                        if (a >= b[2]) {
                            return 3
                        }
                    }
                }
            }
        };
        this.quantile = function(b, c) {
            b = this.cleanArray(b);
            b = b.slice().sort(function(g, e) {
                return g - e
            });
            var d = b.length - 1;
            var a = c || [0.25, 0.5, 0.75];
            return a.map(function(k) {
                if (k === 0) {
                    return b[0]
                } else {
                    if (k === 1) {
                        return b[d]
                    } else {
                        var g = 1 + k * d;
                        var j = Math.floor(g);
                        var i = g - j;
                        var e = b[j - 1];
                        return i === 0 ? e : e + i * (b[j] - e)
                    }
                }
            })
        };
        this.iqr = function(a) {
            var b = this.quantile(a, [0.25, 0.75]);
            return b[1] - b[0]
        };
        this.variance = function(e, g, c, a) {
            e = this.cleanArray(e, g, c);
            var b = e.length;
            if (b < 1) {
                return a ? [Number.NaN, Number.NaN, Number.NaN] : Number.NaN
            } else {
                if (b == 1) {
                    return a ? [e[0], 0, 1] : 0
                } else {
                    var k = this.mean(e);
                    var j = 0;
                    var d = b;
                    while (--d >= 0) {
                        if (!this.isNaN(e[d])) {
                            var h = e[d] - k;
                            j += h * h
                        }
                    }
                    if (a) {
                        return this.standardDeviationType == "unbiased" ? [k, j / (b - 1), b] : [k, j / b, b]
                    } else {
                        return this.standardDeviationType == "unbiased" ? j / (b - 1) : j / b
                    }
                }
            }
        };
        this.deviation = function(b, a, g) {
            b = this.cleanArray(b, a, g);
            var h = b.length;
            if (h < 1) {
                return [Number.NaN]
            } else {
                if (h == 1) {
                    return [0]
                } else {
                    var c = this.mean(b);
                    var d = [];
                    for (var e = 0; e < h; e++) {
                        if (!this.isNaN(b[e])) {
                            d[e] = b[e] - c
                        } else {
                            d[e] = NaN
                        }
                    }
                    return d
                }
            }
        };
        this.standardDeviation = function(b, a, d) {
            var c = this.variance(b, a, d);
            if (this.isNaN(c)) {
                return c
            }
            return Math.sqrt(c)
        };
        this.standardError = function(b, a, d) {
            var c = this.variance(b, a, d, true);
            if (this.isNaN(c[1])) {
                return c[1]
            }
            return Math.sqrt(c[1]) / Math.sqrt(c[2])
        };
        this.meanSquaredError = function(b, a, c) {
            b = this.cleanArray(b, a, c);
            return this.sumSquaredError(this.sumSquaredError(b, a, c)) / b.length
        };
        this.confidenceInterval95 = function(c, b, d) {
            var a = this.standardError(c, b, d);
            if (this.isNaN(a)) {
                return a
            }
            return a * 1.96
        };
        this.covariance = function(j, h, e, c) {
            var g = this.cleanArrays(j, h, e, c);
            j = g[0];
            h = g[1];
            var o = 0;
            var a = [];
            var b = 0;
            var l = this.mean(j);
            var k = this.mean(h);
            for (var d = 0; d < j.length; d++) {
                a[d] = (j[d] - l) * (h[d] - k);
                o += a[d];
                b++
            }
            if (b > 0) {
                return o / (this.standardDeviationType == "unbiased" ? b - 1 : b)
            } else {
                return NaN
            }
        };
        this.correlation = function(c, b, a, e, d) {
            if (d && d == "spearman") {
                return this.correlationSpearman(c, b, a, e)
            } else {
                return this.correlationPearson(c, b, a, e)
            }
        };
        this.correlationSpearman = function(p, o, j, g) {
            var l = this.cleanArrays(p, o, j, g);
            p = l[0];
            o = l[1];
            var a = p.length;
            var b = 0;
            var e = this.rank2(p);
            var c = this.rank2(o);
            for (var h = 0; h < p.length; h++) {
                var k = e[h] - c[h];
                b += k * k
            }
            return 1 - (6 * b / (a * (a * a - 1)))
        };
        this.correlationPearson = function(c, b, a, d) {
            return this.covariance(c, b, a, d) / this.standardDeviation(c, a, d) / this.standardDeviation(b, a, d)
        };
        this.regression = function(l, k, h, b, c, n) {
            var g = [];
            var j = this.cleanArrays(l, k, h, b);
            l = j[0];
            k = j[1];
            for (var e = 0; e < l.length; e++) {
                if (!this.isNaN(l[e]) && !this.isNaN(k[e])) {
                    g.push([l[e], k[e]])
                }
            }
            var a = this.regressionType + "Regression";
            var d = this[a](g);
            return [d.params[0], d.params[1], d.r2, d.confidence]
        };
        this.slope = function(b, d, a, c) {
            return d != c ? (a - b) / (c - d) : 0
        };
        this.intercept = function(a, c, b) {
            return c - (a * b)
        };
        this.slopeIntercept = function(b, e, a, d) {
            var c = this.slope(b, e, a, d);
            return [c, this.intercept(b, e, c)]
        };
        this.normalize = function(g) {
            var e = this.standardDeviationType;
            this.standardDeviationType = "biased";
            for (var c = 0; c < g.length; c++) {
                var a = this.meanStandardDeviationN(g[c]);
                for (var b = 0; b < g[c].length; b++) {
                    g[c][b] = (g[c][b] - a[0]) / a[1]
                }
            }
            this.standardDeviationType = e;
            return g
        };
        this.coefficientDetermination = function(j, g) {
            var c = 0;
            for (var b = 0; b < j.length; b++) {
                c += j[b][1]
            }
            var k = c / j.length;
            var e = 0;
            for (var b = 0; b < j.length; b++) {
                var h = j[b][1] - k;
                e += h * h
            }
            var d = 0;
            for (var b = 0; b < j.length; b++) {
                var a = j[b][1] - g[b][1];
                d += a * a
            }
            return 1 - (d / e)
        };
        this.gaussianElimination = function(p, b) {
            var q = p;
            var a = p.length - 1;
            var c = [b];
            for (var h = 0; h < a; h++) {
                var l = h;
                for (var e = h + 1; e < a; e++) {
                    if (Math.abs(q[h][e]) > Math.abs(q[h][l])) {
                        l = e
                    }
                }
                for (var d = h; d < a + 1; d++) {
                    var g = q[d][h];
                    q[d][h] = q[d][l];
                    q[d][l] = g
                }
                for (var e = h + 1; e < a; e++) {
                    for (var d = a; d >= h; d--) {
                        q[d][e] -= (q[d][h] * q[h][e]) / q[h][h]
                    }
                }
            }
            for (var e = a - 1; e >= 0; e--) {
                var o = 0;
                for (var d = e + 1; d < a; d++) {
                    o += q[d][e] * c[d]
                }
                c[e] = (q[a][e] - o) / q[e][e]
            }
            return c
        };
        this.linearRegression = function(x) {
            var c = [0, 0, 0, 0, 0];
            var t = 0;
            var r = Number.NEGATIVE_INFINITY;
            var o = Number.POSITIVE_INFINITY;
            for (var l = 0; l < x.length; l++) {
                t++;
                r = Math.max(r, x[l][0]);
                o = Math.min(o, x[l][0]);
                c[0] += x[l][0];
                c[1] += x[l][1];
                c[2] += x[l][0] * x[l][0];
                c[3] += x[l][0] * x[l][1];
                c[4] += x[l][1] * x[l][1]
            }
            var j = ((t * c[2]) - (c[0] * c[0]));
            var a = ((t * c[3]) - (c[0] * c[1]));
            var b = j === 0 ? 0 : a / j;
            var v = (c[1] / t) - ((b * c[0]) / t);
            var q = [];
            for (var l = 0; l < x.length; l++) {
                q[l] = [x[l][0], (x[l][0] * b) + v]
            }
            var e = [];
            var k = 0;
            var w = 0;
            var s = c[0] / t;
            var h = Math.max(l - 2, 1);
            var d = this.seq(o, r, (r - o) / 10);
            var g = this.tinv(1 - this.confidenceLevel, h, true);
            for (var p = 0; p < l; p++) {
                k += Math.pow(x[p][1] - q[p][1], 2);
                w += Math.pow(x[p][0] - s, 2)
            }
            k = Math.sqrt(k / h);
            for (var p = 0; p < d.length; p++) {
                var y = -g * k * Math.sqrt((1 / l) + Math.pow(d[p] - s, 2) / w);
                var u = b * d[p] + v;
                e.push([d[p], u + y, u - y, y])
            }
            return {
                predict: q,
                params: [b, v],
                r2: this.coefficientDetermination(x, q),
                confidence: e,
                string: v === 0 ? "y = " + b + "x" : "y = " + b + "x + " + v
            }
        };
        this.exponentialRegression = function(h) {
            var g = [0, 0, 0, 0, 0, 0];
            for (var j = 0; j < h.length; j++) {
                g[0] += h[j][0];
                g[1] += h[j][1];
                g[2] += h[j][0] * h[j][0] * h[j][1];
                g[3] += h[j][1] * Math.log(h[j][1]);
                g[4] += h[j][0] * h[j][1] * Math.log(h[j][1]);
                g[5] += h[j][0] * h[j][1]
            }
            var i = ((g[1] * g[2]) - (g[5] * g[5]));
            var d = Math.exp(((g[2] * g[3]) - (g[5] * g[4])) / i);
            var c = ((g[1] * g[4]) - (g[5] * g[3])) / i;
            var e = [];
            for (var j = 0; j < h.length; j++) {
                e[j] = [h[j][0], d * Math.exp(c * h[j][0])]
            }
            return {
                predict: e,
                params: [d, c],
                r2: this.coefficientDetermination(h, e),
                confidence: false,
                string: "y = " + d + "e^(" + c + "x)"
            }
        };
        this.logarithmicRegression = function(i) {
            var h = [0, 0, 0, 0];
            var d = i.length;
            for (var j = 0; j < d; j++) {
                h[0] += Math.log(i[j][0]);
                h[1] += i[j][1] * Math.log(i[j][0]);
                h[2] += i[j][1];
                h[3] += Math.pow(Math.log(i[j][0]), 2)
            }
            const c = ((d * h[1]) - (h[2] * h[0])) / ((d * h[3]) - (h[0] * h[0]));
            const e = (h[2] - (c * h[0])) / d;
            var g = [];
            for (var j = 0; j < i.length; j++) {
                g[j] = [i[j][0], e + (c * Math.log(i[j][0]))]
            }
            return {
                predict: g,
                params: [e, c],
                r2: this.coefficientDetermination(i, g),
                confidence: false,
                string: "y = " + e + " + " + c + "ln(x)"
            }
        };
        this.powerRegression = function(i) {
            var h = [0, 0, 0, 0, 0];
            var d = i.length;
            for (var j = 0; j < d; j++) {
                h[0] += Math.log(i[j][0]);
                h[1] += Math.log(i[j][1]) * Math.log(i[j][0]);
                h[2] += Math.log(i[j][1]);
                h[3] += Math.pow(Math.log(i[j][0]), 2)
            }
            var c = ((d * h[1]) - (h[0] * h[2])) / ((d * h[3]) - Math.pow(h[0], 2));
            var e = Math.exp(((h[2] - (c * h[0])) / d));
            var g = [];
            for (var j = 0; j < i.length; j++) {
                g[j] = [i[j][0], e * Math.pow(i[j][0], c)]
            }
            return {
                predict: g,
                params: [e, c],
                r2: this.coefficientDetermination(i, g),
                confidence: false,
                string: "y = " + e + "x^" + c
            }
        };
        this.polynomialRegression = function(q) {
            this.regressionOrder = 2;
            var h = [];
            var u = [];
            var x = 0;
            var w = 0;
            var t = q.length;
            var o = this.regressionOrder + 1;
            for (var r = 0; r < o; r++) {
                for (var g = 0; g < t; g++) {
                    x += Math.pow(q[g][0], r) * q[g][1]
                }
                h.push(x);
                x = 0;
                var v = [];
                for (var p = 0; p < o; p++) {
                    for (var g = 0; g < t; g++) {
                        w += Math.pow(q[g][0], (r + p))
                    }
                    v.push(w);
                    w = 0
                }
                u.push(v)
            }
            u.push(h);
            var e = this.gaussianElimination(u, o);
            var y = [];
            for (var d = 0; d < q.length; d++) {
                y[d] = [q[d][0], e[0] + (e[1] * Math.pow(q[d][0], e[2]))]
            }
            var s = "y = ";
            for (var r = e.length - 1; r >= 0; r--) {
                if (r > 1) {
                    s += e[r] + "x^" + r + " + "
                } else {
                    if (r === 1) {
                        s += e[r] + "x + "
                    } else {
                        s += e[r]
                    }
                }
            }
            return {
                predict: y,
                params: e.reverse(),
                r2: this.coefficientDetermination(q, y),
                confidence: false,
                string: s
            }
        };
        this.commonElementsInArrays = function(c, b) {
            var a = [];
            var e = {};
            for (var d = 0; d < c.length; d++) {
                e[c[d]] = true
            }
            for (var d = 0; d < b.length; d++) {
                if (e[b[d]]) {
                    a.push(b[d])
                }
            }
            return a
        };
        this.checkLoessCache = function(b) {
            var a = this.meta;
            if (!a.vals.loess) {
                a.vals.loess = {}
            }
            var c = this.cloneObject(b);
            c.push(this.loessDegree, this.loessSteps, this.loessSurfaceSteps, this.loessBandwidth, this.loessSpan, this.transformData);
            c = c.join(":");
            return a.vals.loess.hasOwnProperty(c) ? a.vals.loess[c] : false
        };
        this.loess = function(aa, J, S) {
            var o = this.checkLoessCache(S);
            if (o) {
                return o
            }
            var H = this;
            var Y = function(d) {
                var k = Math.abs(d);
                var i = 1 / (1 + k / 2);
                var j = i * Math.exp(-k * k - 1.26551223 + i * (1.00002368 + i * (0.37409196 + i * (0.09678418 + i * (-0.18628806 + i * (0.27886807 + i * (-1.13520398 + i * (1.48851587 + i * (-0.82215223 + i * 0.17087277)))))))));
                return d >= 0 ? j : 2 - j
            };
            var n = function(d) {
                if (d >= 2) {
                    return -100
                }
                if (d <= 0) {
                    return 100
                }
                var ac = (d < 1) ? d : 2 - d;
                var k = Math.sqrt(-2 * Math.log(ac / 2));
                var y = -0.70711 * ((2.30753 + k * 0.27061) / (1 + k * (0.99229 + k * 0.04481)) - k);
                for (var i = 0; i < 2; i++) {
                    var w = Y(y) - ac;
                    y += w / (1.1283791670955126 * Math.exp(-(y * y)) - y * w)
                }
                return (d < 1) ? y : -y
            };
            var Z = function(i, j, d) {
                var k = Math.sqrt(j);
                return i - k * Math.sqrt(2) * n(2 * d)
            };
            var Q = function(d) {
                var y = Math.ceil(0.1 * d.length);
                var k = H.cloneObject(d);
                k = k.sort(function(i, ac) {
                    return i - ac
                });
                for (var j = 0; j < y; j++) {
                    k.shift();
                    k.pop()
                }
                var w = H.standardDeviation(k);
                return function(i) {
                    return i.map(function(ac) {
                        return ac / w
                    })
                }
            };
            var a = function(j, d) {
                var w = [];
                for (var k = 0; k < j.length; k++) {
                    if (H.isArray(j[k]) && H.isArray(d[k])) {
                        w.push(a(j[k], d[k]))
                    } else {
                        w.push(j[k] * d[k])
                    }
                }
                return w
            };
            var q = function(j, ad) {
                var w = function(d, ae, ag) {
                    if (ag > 1) {
                        for (var af = ae; af < j.length; af++) {
                            w(a(d, j[af]), af, ag - 1)
                        }
                    } else {
                        ac.push(d)
                    }
                };
                var ac = [];
                var y = Array(j[0].length).fill(1);
                for (var k = 0; k <= ad; k++) {
                    w(y, 0, k + 1)
                }
                return ac
            };
            var p = function(j, i) {
                if (j.length < 2) {
                    return Math.abs(j[0] - i[0])
                } else {
                    return Math.sqrt(j.reduce(function(d, k, w) {
                        return d + Math.pow(k - i[w], 2)
                    }, 0))
                }
            };
            var R = function(i, d) {
                return i.map(function(j) {
                    return d.map(function(k) {
                        return p(j, k)
                    })
                })
            };
            var s = function(k, j, i) {
                return k < j ? Math.pow(1 - Math.pow(k / j, i), i) : 0
            };
            var t = function(k, j, i) {
                return k.map(function(ac) {
                    var ae = H.rank(ac);
                    var ad = [];
                    for (var y = 0; y < ae.length; y++) {
                        ad.push([ac[ae[y]], j[ae[y]]])
                    }
                    var ag = H.sum(j) * i;
                    var d = 0;
                    var w = ad.findIndex(function(ah) {
                        d += ah[1];
                        return d >= ag
                    });
                    var af = i > 1 ? ad[ad.length - 1][0] * i : ad[w][0];
                    return a(ac.map(function(ah) {
                        return s(ah, af, 3)
                    }), j)
                })
            };
            var u = function(af, ae) {
                var ad = af.length;
                var k = af[0].length;
                var w = ae.length;
                var ag = ae[0].length;
                var j = new Array(ad);
                for (var d = 0; d < ad; d++) {
                    j[d] = new Array(ag);
                    for (var ac = 0; ac < ag; ac++) {
                        j[d][ac] = 0;
                        for (var y = 0; y < k; y++) {
                            j[d][ac] += af[d][y] * ae[y][ac]
                        }
                    }
                }
                return j
            };
            var h = function(w, k) {
                var d = new Array(w.length);
                for (var ac = 0; ac < d.length; ac++) {
                    d[ac] = new Array(w[ac].length);
                    for (var y = 0; y < d[ac].length; y++) {
                        d[ac][y] = w[ac][y] - k[ac][y]
                    }
                }
                return d
            };
            var x = function(d) {
                var j = [];
                for (var k = 0; k < d.length; k++) {
                    j.push(d[k][0])
                }
                return j
            };
            var K = function(j, k, w) {
                var ad = a(w, k);
                var ae = H.transpose(j.map(function(ag) {
                    return a(w, ag)
                }));
                var ac = u(j, ae);
                var d = u(j, H.transpose([ad]));
                var y = u(H.numeric("inv", ac), d);
                var i = u(H.transpose(y), j);
                var af = h([k], i);
                return {
                    beta: y,
                    yhat: i,
                    residuals: af
                }
            };
            var e = function(d) {
                b = [];
                V = [];
                P = a(d, M);
                var i = H.transpose(O);
                i.forEach(function(k, j) {
                    var w = K(ab, I, P[j]);
                    b.push(x(u([k], w.beta)));
                    V.push(w.residuals);
                    var y = H.median(H.Abs(w.residuals[0]));
                    d[j] = w.residuals.map(function(ac) {
                        return s(ac, 6 * y[0], 2)
                    })
                })
            };
            this.loessDegree = parseInt(this.loessDegree);
            if (this.loessDegree < 0 || this.loessDegree > 2) {
                this.loessDegree = 2
            }
            this.loessBandWidth = Number(this.loessBandwidth);
            if (this.loessBandwidth < 0 || this.loessBandwidth > 1) {
                this.loessBandwidth = 0.8
            }
            this.loessSpan = Number(this.loessSpan);
            if (this.loessSpan < 0 || this.loessSpan > 1) {
                this.loessSpan = 0.8
            }
            var B = [aa[0]];
            var v = [this.loessSteps];
            var I = aa[1];
            if (aa[2]) {
                B.push(aa[2]);
                v.push(this.loessSteps)
            }
            if (!J) {
                J = Array(aa[0].length).fill(1)
            }
            var ab = q(B, this.loessDegree);
            var c = B.map(Q);
            var N = B.map(function(i, d) {
                return c[d](i)
            });
            var l = this.transposeMatrix(N);
            var G = [];
            var L = [];
            B.forEach(function(ae, af) {
                var d = ae.sort(function(ag, i) {
                    return ag - i
                });
                var j = d[0];
                var y = d[d.length - 1];
                var k = (y - j) / (v[af] - 1);
                L.push([]);
                for (var w = 0; w < v[af]; w++) {
                    L[af].push(j + w * k)
                }
                var ac = 1;
                var ad = 1;
                for (var w = af - 1; w >= 0; w--) {
                    ac *= v[w]
                }
                for (var w = af + 1; w < B.length; w++) {
                    ad *= v[w]
                }
                G.push([]);
                for (var w = 0; w < ac; w++) {
                    G[af] = G[af].concat(L[af].reduce(function(i, ag) {
                        return i.concat(Array(ad).fill(ag))
                    }, []))
                }
            });
            var C = this.cloneObject(G);
            var X = G[0].length;
            var O = q(C, this.loessDegree);
            var W = C.map(function(i, d) {
                return c[d](i)
            });
            var g = R(this.transpose(W), l);
            var M = t(g, J, this.loessBandwidth);
            var b;
            var V;
            var P;
            var E = Array(X).fill(Array(aa[0].length).fill(1));
            for (var A = 0; A < this.loessIterations; A++) {
                e(E)
            }
            var z = {
                fitted: x(b),
                residuals: V,
                weights: P
            };
            (function() {
                var i = Z(0, 1, 1 - (1 - H.loessSpan) / 2);
                var d = P.map(function(ac, k) {
                    var w = H.sum(ac);
                    var j = u([ac], H.transpose([ac]));
                    var y = Math.sqrt(u([H.square(V[k][0])], H.transpose([ac])) / (w - j[0] / w));
                    return y * i
                });
                Object.assign(z, {
                    halfwidth: d
                })
            })();
            var D = [];
            if (aa[2]) {
                for (var U = 0; U < this.loessSurfaceSteps; U++) {
                    var F = [];
                    for (var T = 0; T < this.loessSurfaceSteps; T++) {
                        F.push(z.fitted[T * this.loessSurfaceSteps + U])
                    }
                    D.push(F)
                }
            }
            if (!this.meta.vals.loess) {
                this.meta.vals.loess = {}
            }
            var r = this.cloneObject(S);
            r.push(this.loessDegree, this.loessSteps, this.loessSurfaceSteps, this.loessBandwidth, this.loessSpan);
            r = r.join(":");
            if (aa[2]) {
                this.meta.vals.loess[r] = {
                    x: L[0],
                    y: L[1],
                    z: D,
                    c: z.halfwidth
                }
            } else {
                this.meta.vals.loess[r] = {
                    x: G[0],
                    y: z.fitted,
                    c: z.halfwidth
                }
            }
            return this.meta.vals.loess[r]
        };
        this.errorEllipse = function(a, c, b) {
            if (b) {
                return this.errorEllipse3D(a, c, b)
            } else {
                return this.errorEllipse2D(a, c)
            }
        };
        this.errorEllipse2D = function(l, h) {
            var j = this.variance(l, false, false, true);
            var i = this.variance(h, false, false, true);
            var k = this.covariance(l, h);
            var o = [
                [j[1], k],
                [k, i[1]]
            ];
            var p = this.numeric("eig", o);
            var n = Math.sqrt(2 * this.gammaPinv(this.confidenceLevel, 1));
            var g = p.lambda.x[0] > p.lambda.x[1] ? 0 : 1;
            var e = p.lambda.x[0] < p.lambda.x[1] ? 0 : 1;
            var b = j[1] > i[1] ? Math.sqrt(p.lambda.x[g]) * n : Math.sqrt(p.lambda.x[e]) * n;
            var a = i[1] > j[1] ? Math.sqrt(p.lambda.x[g]) * n : Math.sqrt(p.lambda.x[e]) * n;
            var c = Math.atan2(p.E.x[g][1], p.E.x[g][0]);
            if (c < 0) {
                c += Math.PI / 2
            }
            var d = {
                rx: b,
                ry: a,
                cx: j[0],
                cy: i[0],
                rot: c
            };
            return d
        };
        this.errorEllipse3D = function(p, o, l) {
            var j = function(z) {
                for (var y = 0; y < z.length; y++) {
                    for (var x = 0; x < z[y].length; x++) {
                        if (isNaN(z[y][x])) {
                            return false
                        }
                    }
                }
                return true
            };
            var s = this.variance(p, false, false, true);
            var r = this.variance(o, false, false, true);
            var q = this.variance(l, false, false, true);
            var c = this.covariance(p, o);
            var b = this.covariance(p, l);
            var k = this.covariance(o, l);
            var w = [
                [s[1], c, b],
                [c, r[1], k],
                [b, k, q[1]]
            ];
            if (j(w)) {
                var n = this.numeric("eig", w);
                var a = Math.sqrt(2 * this.gammaPinv(this.confidenceLevel, 1));
                var g = this.rank(n.lambda.x);
                var v = g[2];
                var t = g[1];
                var u = g[0];
                var i = Math.sqrt(n.lambda.x[v]) * a;
                var e = Math.sqrt(n.lambda.x[t]) * a;
                var d = Math.sqrt(n.lambda.x[u]) * a;
                var C = Math.atan2(n.E.x[2][v] * -1, n.E.x[1][v] * -1);
                var B = Math.atan2(n.E.x[2][v] * -1, n.E.x[0][v] * -1);
                var A = Math.atan2(n.E.x[1][v] * -1, n.E.x[0][v] * -1);
                if (C < 0) {}
                if (B < 0) {
                    B += Math.PI / 2
                }
                if (A < 0) {}
                var h = {
                    rx: [i],
                    ry: [e],
                    rz: [d],
                    cx: s[0],
                    cy: r[0],
                    cz: q[0],
                    rot: [C, B, A]
                };
                return h
            } else {
                return false
            }
        };
        this.cdfNormal = function(a, c, b) {
            var a = (a - c) / b;
            var g = 1 / (1 + 0.2315419 * Math.abs(a));
            var h = 0.3989423 * Math.exp(-a * a / 2);
            var e = h * g * (0.3193815 + g * (-0.3565638 + g * (1.781478 + g * (-1.821256 + g * 1.330274))));
            if (a > 0) {
                e = 1 - e
            }
            return e
        };
        this.cdf = function(c) {
            var b = this.cleanArray(c);
            var a = this.cloneObject(b);
            a = a.sort(function(i, h) {
                return i - h
            });
            var g = [];
            var e = b.length;
            for (var d = 0; d < e; d++) {
                g.push((d + 1) / e)
            }
            return {
                x: a,
                y: g
            }
        };
        this.qq = function(c) {
            var h = this.cleanArray(c);
            var p = this.mean(h);
            var b = this.standardDeviation(h);
            var n;
            var l = this.cloneObject(h);
            switch (this.qqDistribution) {
                case "normal":
                    n = this.rnorm(this.qqSamples, p, b);
                case "uniform":
                    n = this.runif(this.qqSamples)
            }
            n = n.sort(function(q, i) {
                return q - i
            });
            l = l.sort(function(q, i) {
                return q - i
            });
            var g = n.length - 1;
            var a = l.length - 1;
            var o = [];
            var j = [];
            for (var e = 0; e < this.qqPoints; e++) {
                var k = ~~(e * g / this.qqPoints);
                var d = ~~(e * a / this.qqPoints);
                o.push(n[k]);
                j.push(l[d])
            }
            return {
                x: o,
                y: this.percentile3(j)
            }
        };
        this.uniformKernel = function(a) {
            return (a <= 1 && a >= -1) ? 0.5 : 0
        }, this.triangularKernel = function(a) {
            return (a <= 1 && a >= -1) ? 1 - Math.abs(a) : 0
        }, this.epanechnikovKernel = function(a) {
            return (a <= 1 && a >= -1) ? 0.75 * (1 - a * a) : 0
        }, this.quarticKernel = function(a) {
            if (a <= 1 && a >= -1) {
                var b = 1 - a * a;
                return (15 / 16) * b * b
            } else {
                return 0
            }
        }, this.triweightKernel = function(a) {
            if (a <= 1 && a >= -1) {
                var b = 1 - a * a;
                return (35 / 32) * b * b * b
            } else {
                return 0
            }
        }, this.gaussianKernel = function(a) {
            return 1 / Math.sqrt(2 * Math.PI) * Math.exp(-0.5 * a * a)
        }, this.cosineKernel = function(a) {
            return (a <= 1 && a >= -1) ? Math.PI / 4 * Math.cos(Math.PI / 2 * a) : 0
        };
        this.silvermanRule = function(c) {
            var a = Math.sqrt(this.variance(c));
            var b = 4 * Math.pow(a, 5);
            var d = 3 * c.length;
            return Math.pow(b / d, 0.2)
        };
        this.nrd0Rule = function(d) {
            var a = Math.sqrt(this.variance(d));
            var e = this.iqr(d) / 1.34;
            var c = Math.pow(d.length, -0.2);
            var b = e > 0 ? Math.min(a, e) : a;
            return 0.9 * b * c
        };
        this.nrdRule = function(d) {
            var a = Math.sqrt(this.variance(d));
            var e = this.iqr(d) / 1.34;
            var c = Math.pow(d.length, -0.2);
            var b = e > 0 ? Math.min(a, e) : a;
            return 1.6 * b * c
        };
        this.getBandwidthEstimate = function(a) {
            return Math.max(this[this.bandwidthRule + "Rule"](a), 0.1)
        };
        this.kernelDensityEstimator = function(a, c) {
            var b = this[this.densityKernel + "Kernel"];
            return function(e, d) {
                return a.map(function(g) {
                    var h = -1;
                    var k = 0;
                    var j = e.length;
                    while (++h < j) {
                        k += b((g - e[h]) / c)
                    }
                    return [g, k / c / j]
                })
            }
        };
        this.density = function(u, H) {
            var o = function(j) {
                var x = [];
                for (var v = 0; v < j.length; v++) {
                    if (!isNaN(parseFloat(j[v])) && isFinite(j[v])) {
                        x.push(j[v])
                    }
                }
                return x
            };
            var F = o(u);
            if (!F.length) {
                return {
                    range: [0, 0],
                    median: 0,
                    trim: [0, 0],
                    xy: [],
                    bw: 0,
                    values: [],
                    quantilesX: [],
                    quantilesY: [],
                    indecesY: [],
                    sumY: 0,
                    maxY: 0,
                    minY: 0,
                    minData: 0,
                    maxData: 0,
                    globalMaxY: 0,
                    histogram: false,
                    name: H,
                    n: 0
                }
            }
            var g = this.range(F);
            var q = this.median(F);
            var y = g[0];
            var C = g[1];
            var t = this.getBandwidthEstimate(F);
            var w = (y - this.bandwidthCut * t);
            var c = (C + this.bandwidthCut * t);
            var z = (c - w) / 256;
            var n = [];
            for (var p = w; p < c; p += z) {
                n.push(p)
            }
            var E = this.kernelDensityEstimator(n, t);
            var h = E(F);
            var e = [];
            var d = [];
            var s = 0;
            var b = Infinity;
            var a = 0;
            var D = this.hist(F, H);
            for (var B = 0; B < h.length; B++) {
                if (isNaN(h[B][1])) {
                    h[B][1] = 0
                }
            }
            for (var B = 0; B < h.length; B++) {
                if (h[B][0] > y && h[B][0] < C) {
                    if (e.length == 0) {
                        w = B;
                        e.push(h[B - 1][0]);
                        d.push(h[B - 1][1]);
                        a += h[B - 1][1];
                        s = Math.max(s, h[B - 1][1]);
                        b = Math.min(b, h[B - 1][1])
                    }
                    e.push(h[B][0]);
                    d.push(h[B][1]);
                    a += h[B][1];
                    s = Math.max(s, h[B][1]);
                    b = Math.min(b, h[B][1])
                } else {
                    if (h[B][0] >= C) {
                        c = B;
                        e.push(h[B][0]);
                        d.push(h[B][1]);
                        a += h[B][1];
                        s = Math.max(s, h[B][1]);
                        b = Math.min(b, h[B][1]);
                        break
                    }
                }
            }
            var l = this.boxplot(e);
            var k = this.boxplot(d);
            var G = this[this.axisAlgorithm](0, s, this.yAxisTicks, this.axisWilkinsonLoose);
            var r = [];
            for (var B = 0; B < 6; B++) {
                for (var A = 0; A < e.length; A++) {
                    if (e[A] >= l[B]) {
                        r.push(d[A]);
                        break
                    }
                }
            }
            return {
                range: g,
                median: q,
                trim: [w, Math.max(w, c)],
                xy: h,
                bw: t,
                values: G,
                quantilesX: l,
                quantilesY: k,
                indecesY: r,
                sumY: a,
                maxY: s,
                minY: b,
                minData: y,
                maxData: C,
                globalMaxY: s,
                histogram: D,
                name: H,
                n: F.length
            }
        };
        this.freedmanDiaconis = function(b, a, c) {
            if (b && b.length > 1) {
                b = this.cleanArray(b, a, c);
                var d = this.iqr(b);
                return d == 0 ? 1 : Math.ceil(2 * d * Math.pow(b.length, -1 / 3))
            } else {
                if (b && b.length == 1) {
                    return Number(b[0])
                } else {
                    return 1
                }
            }
        };
        this.sturges = function(b, a, d) {
            if (b && b.length > 1) {
                b = this.cleanArray(b, a, d);
                var c = this.range(b);
                return Math.ceil(Math.log(b.length) / Math.LN2) + 1
            } else {
                if (b && b.length == 1) {
                    return Number(b[0])
                } else {
                    return 1
                }
            }
        };
        this.scott = function(b, a, e) {
            if (b && b.length > 1) {
                b = this.cleanArray(b, a, e);
                var c = this.range(b);
                var d = Math.sqrt(this.vriance(b));
                return Math.ceil((c[1] - c[0]) / (3.5 * d * Math.pow(b.length, -1 / 3)))
            } else {
                if (b && b.length == 1) {
                    return Number(b[0])
                } else {
                    return 1
                }
            }
        };
        this.histBin = function(e, d, g, c) {
            var a = Math.floor((e - d) / g);
            if (e == c[a] && a > 0) {
                a--
            }
            return a
        };
        this.hist2D = function(a, s, z) {
            if (this.isArray(a) && this.isArray(a[0]) && a.length > 0) {
                var k = 0;
                for (var w = 0; w < s.length; w++) {
                    k = Math.max(k, this.meta.data.d.s[s[w].toString()].maxY)
                }
                for (var w = 0; w < s.length; w++) {
                    this.meta.data.d.s[s[w].toString()].globalMaxY = k
                }
                var y = [];
                for (var w = 0; w < a.length; w++) {
                    y = y.concat(a[w])
                }
                var d = this.density(y, z);
                var r = d.histogram.count.length;
                var l = d.histogram.size;
                var p = d.histogram.breaks;
                var e = this.isTransformedData ? this.data.y.trans : this.data.y.data;
                var t = p[0];
                var h = {
                    data: [],
                    vars: [],
                    smps: [],
                    histogram: [],
                    cols: [],
                    values: [],
                    density: [],
                    global: d.histogram
                };
                for (var w = 0; w < r; w++) {
                    h.vars.push("Bin" + (w + 1) + " (" + d.histogram.breaks[w] + " - " + d.histogram.breaks[w + 1] + ")");
                    h.data[w] = [];
                    h.data[w][0] = p[w + 1] - t;
                    h.histogram[w] = [];
                    h.values[w] = [];
                    for (var u = 0; u < s.length; u++) {
                        h.histogram[w][u] = [];
                        h.values[w][u] = []
                    }
                }
                h.smps.push("Bin");
                for (var w = 0; w < s.length; w++) {
                    var q = 0;
                    var x = 0;
                    h.smps.push(this.data.y.smps[s[w]]);
                    var b = [];
                    for (var u = 0; u < r; u++) {
                        b[u] = 0
                    }
                    for (var u = 0; u < this.varIndices.length; u++) {
                        var g = e[this.varIndices[u]][s[w]];
                        if (g != null && g !== "" && !isNaN(g)) {
                            var o = this.histBin(g, t, l, p);
                            b[o]++;
                            h.histogram[o][w].push(this.varIndices[u]);
                            h.values[o][w].push(g);
                            q++
                        }
                    }
                    for (var u = 0; u < r; u++) {
                        h.data[u][w + 1] = b[u];
                        x = Math.max(x, b[u])
                    }
                    h.cols.push(x);
                    h.density[w] = this.meta.data.d.s[s[w].toString()]
                }
                return h
            }
        };
        this.hist = function(t, v) {
            var c = this;
            var r = function(z, i, w) {
                if (c.histogramBinWidth) {
                    var y = c.rPretty(z, i, Math.ceil((i - z) / w));
                    z = y[0];
                    i = y.pop();
                    var x = [z];
                    while (x[x.length - 1] < i) {
                        x.push(x[x.length - 1] + c.histogramBinWidth)
                    }
                    return x
                } else {
                    return c.rPretty(z, i, Math.max(c.histogramBins || 10, w))
                }
            };
            var b = this.range(t);
            var g = b[0];
            var l = b[0] == b[1] ? b[0] + 1 : b[1];
            var u = this.histogramBinWidth || this[this.histogramSizeEstimator](t);
            var j = r(g, l, u);
            var h = this.approx(j[1] - j[0]);
            var a = this.approx(h / 2);
            var k = [];
            var s = [];
            var q = [];
            var e = [];
            if (j[0] > g) {
                j.unshift(j[0] - h)
            }
            if (j[j.length - 1] < l) {
                j.push(j[j.length - 1] + h)
            }
            var o = j.length;
            for (var n = 0; n < o - 1; n++) {
                k[n] = 0;
                q[n] = [];
                s[n] = this.approx(j[n] + a)
            }
            for (var n = 0; n < t.length; n++) {
                var d = this.histBin(t[n], j[0], h, j);
                k[d]++;
                q[d].push(n)
            }
            var p = -Infinity;
            for (var n = 0; n < k.length; n++) {
                p = Math.max(p, k[n]);
                e.push("Bin" + (n + 1) + " (" + j[n] + " - " + j[n + 1] + ")")
            }
            return {
                estimator: u,
                breaks: j,
                count: k,
                mids: s,
                idxs: q,
                size: h,
                half: a,
                maxY: p,
                name: v,
                labels: e
            }
        };
        this.getHistogramBin = function(c, a) {
            var d = a * Math.floor(c / a);
            return parseFloat(d.toFixed(this.getAxisDecimals(a)))
        };
        this.approx = function(g) {
            var e = g;
            var d = g.toString();
            var j = d.indexOf("99999");
            var h = d.indexOf("00000");
            var i = d.indexOf(".");
            var b = j >= 0 && i < j ? j : h >= 0 ? h : null;
            if (b != null) {
                e = d.substring(0, b);
                f = Math.pow(10, e.length - (e.indexOf(".") + 1));
                return Number(Math.round(Number(d) * f) / f)
            } else {
                return Number(d)
            }
        };
        this.bezierCalculatePoints = function(h, e) {
            var b = h[0][0];
            var a = h[0][1];
            var d = h[1][0];
            var c = h[1][1];
            var i = b + (d - b) * e;
            var g = a + (c - a) * e;
            return [i, g]
        };
        this.deCasteljau = function(e, d) {
            if (d === 1) {
                return e[e.length - 1]
            }
            if (d === 0) {
                return e[0]
            }
            if (e.length == 1) {
                return e[0]
            }
            var b = [];
            for (var c = 1, a = e.length; c < a; c++) {
                b.push(this.bezierCalculatePoints([e[c - 1], e[c]], d))
            }
            return this.deCasteljau(b, d)
        };
        this.divideBezierCurve = function(g, e, c, h) {
            c = c || [];
            h = h || [];
            c.push(g[0]);
            h.push(g[g.length - 1]);
            if (g.length === 1) {
                return [c, h]
            }
            var b = [];
            for (var d = 1, a = g.length; d < a; d++) {
                b.push(this.bezierCalculatePoints([g[d - 1], g[d]], e))
            }
            return this.divideBezierCurve(b, e, c, h)
        };
        this.centroid = function(a) {
            var c = [];
            if (!a || a.length < 2) {
                return [0, 0]
            } else {
                if (a.length < 3 || a.length % 2) {
                    return [a[0], a[1]]
                } else {
                    while (a.length > 1) {
                        c.push([a.shift(), a.shift()])
                    }
                }
            }
            var b = c.reduce(function(d, e) {
                return [d[0] + e[0] / c.length, d[1] + e[1] / c.length]
            }, [0, 0]);
            return b
        };
        this.centroidArea = function(a) {
            var b = this.cloneObject(a);
            b.shift();
            return this.centroid(b)
        };
        this.prufer = function(c) {
            var b = [];
            var e = Array.apply(null, Array(c.length + 2)).map(function(a, j) {
                return j
            });
            var k = Array.apply(null, Array(1 * e.length)).map(function() {
                return 1
            });
            c.map(function(a) {
                k[a]++
            });
            for (var g = 0; g < c.length; g++) {
                for (var d = 0; d < e.length; d++) {
                    if (k[e[d]] === 1) {
                        b.push([c[g], e[d]]);
                        k[c[g]]--;
                        k[e[d]]--;
                        break
                    }
                }
            }
            var h = e.filter(function(a) {
                return k[a] === 1
            });
            b.push(h);
            return b
        };
        this.probabilityOfZ = function(c) {
            var e = 6;
            var d, a, b;
            if (c == 0) {
                a = 0
            } else {
                d = 0.5 * Math.abs(c);
                if (d > (e * 0.5)) {
                    a = 1
                } else {
                    if (d < 1) {
                        b = d * d;
                        a = ((((((((0.000124818987 * b - 0.001075204047) * b + 0.005198775019) * b - 0.019198292004) * b + 0.059054035642) * b - 0.151968751364) * b + 0.319152932694) * b - 0.5319230073) * b + 0.797884560593) * d * 2
                    } else {
                        d -= 2;
                        a = (((((((((((((-0.000045255659 * d + 0.00015252929) * d - 0.000019538132) * d - 0.000676904986) * d + 0.001390604284) * d - 0.00079462082) * d - 0.002034254874) * d + 0.006549791214) * d - 0.010557625006) * d + 0.011630447319) * d - 0.009279453341) * d + 0.005353579108) * d - 0.002141268741) * d + 0.000535310849) * d + 0.999936657524
                    }
                }
            }
            return c > 0 ? ((a + 1) * 0.5) : ((1 - a) * 0.5)
        };
        this.criticalNormalZ = function(e) {
            var h = 6;
            var c = 0.000001;
            var g = -h;
            var d = h;
            var b = 0;
            var a;
            if (e < 0) {
                e = 0
            }
            if (e > 1) {
                e = 1
            }
            while ((d - g) > c) {
                a = this.probabilityOfZ(b);
                if (a > e) {
                    d = b
                } else {
                    g = b
                }
                b = (d + g) * 0.5
            }
            return b
        };
        this.kaplanMeier = function(k, b) {
            var h = this;

            function l(w, i) {
                firstSecond = h.zip(w, i);
                firstSecond.sort(function(y, x) {
                    return y[1] - x[1]
                });
                return h.unzip(firstSecond, 0)
            }

            function u(w, i) {
                return w - i
            }
            var t = {
                times: [],
                events: []
            };
            for (var q = 0; q < k.length; q++) {
                if (!isNaN(k[q])) {
                    t.times.push(k[q]);
                    if (this.invertCensored) {
                        t.events.push(isNaN(b[q]) ? 1 : b[q] ? 0 : 1)
                    } else {
                        t.events.push(isNaN(b[q]) ? 0 : b[q])
                    }
                }
            }
            k = t.times;
            b = t.events;
            var d = this.unique(k).sort(u);
            var r = new Array(d.length);
            var a = new Array(d.length);
            var n = new Array(d.length);
            var e = new Array(d.length);
            var v = new Array(d.length);
            var j = new Array(d.length);
            var o = new Array(d.length);
            var p = 0;
            b = l(b, k);
            k.sort(u);
            for (var g = 0; g < d.length; g++) {
                v[g] = k.length;
                j[g] = 0;
                o[g] = 0;
                for (var q = 0; q < k.length; q++) {
                    if (k[q] == d[g]) {
                        j[g] += b[q];
                        o[g] += !b[q]
                    } else {
                        break
                    }
                }
                var s = q;
                r[g] = (1 - j[g] / v[g]) * ((g == 0) ? 1 : r[g - 1]);
                p += j[g] / (v[g] * (v[g] - j[g]));
                a[g] = Math.sqrt(p) * r[g];
                n[g] = Math.sqrt(p);
                e[g] = Math.sqrt(p) / Math.log(r[g]);
                b = b.slice(s);
                k = k.slice(s)
            }
            var c = this.kaplanMeierConfidence(r, this.confidenceIntervalType == "log" ? n : this.confidenceIntervalType == "loglog" ? e : a);
            return {
                time: d,
                nAtRisk: v,
                nEvents: j,
                nCensored: o,
                kaplanMeier: r,
                greenwoodSE: a,
                greenwoodSELog: n,
                greenwoodSELogLog: e,
                lowerLimit: c[0],
                upperLimit: c[1]
            }
        };
        this.kaplanMeierConfidence = function(b, g) {
            var h = this.criticalNormalZ(this.confidenceLevel);
            var j = b.length;
            var c = new Array(j);
            var e = new Array(j);
            for (var d = 0; d < j; d++) {
                var a = b[d];
                if (this.confidenceIntervalType == "log") {
                    a = Math.log(a)
                }
                if (this.confidenceIntervalType == "loglog") {
                    a = Math.log(-Math.log(a))
                }
                c[d] = a - h * g[d];
                e[d] = a + h * g[d];
                if (this.confidenceIntervalType == "log") {
                    c[d] = Math.exp(c[d]);
                    e[d] = Math.exp(e[d])
                }
                if (this.confidenceIntervalType == "loglog") {
                    c[d] = Math.exp(-Math.exp(c[d]));
                    e[d] = Math.exp(-Math.exp(e[d]))
                }
                c[d] = Math.max(0, c[d]);
                e[d] = Math.min(1, e[d])
            }
            return [c, e]
        };
        this.getD3Sankey = function() {
            var i = function(F, E) {
                return F < E ? -1 : F > E ? 1 : F >= E ? 0 : NaN
            };
            var g = function(J, H) {
                var G = 0,
                    I = J.length,
                    E, F = -1;
                if (H == null) {
                    while (++F < I) {
                        if (E = +J[F]) {
                            G += E
                        }
                    }
                } else {
                    while (++F < I) {
                        if (E = +H(J[F], F, J)) {
                            G += E
                        }
                    }
                }
                return G
            };
            var v = function(J, H) {
                var G = -1,
                    I = J.length,
                    F, E;
                if (H == null) {
                    while (++G < I) {
                        if ((E = J[G]) != null && E >= E) {
                            F = E;
                            break
                        }
                    }
                    while (++G < I) {
                        if ((E = J[G]) != null && F > E) {
                            F = E
                        }
                    }
                } else {
                    while (++G < I) {
                        if ((E = H(J[G], G, J)) != null && E >= E) {
                            F = E;
                            break
                        }
                    }
                    while (++G < I) {
                        if ((E = H(J[G], G, J)) != null && F > E) {
                            F = E
                        }
                    }
                }
                return F
            };
            var z = function(F, E) {
                return F = +F, E -= F,
                    function(G) {
                        return F + E * G
                    }
            };
            var x = "$";

            function k() {}
            k.prototype = C.prototype = {
                constructor: k,
                has: function(E) {
                    return (x + E) in this
                },
                get: function(E) {
                    return this[x + E]
                },
                set: function(E, F) {
                    this[x + E] = F;
                    return this
                },
                remove: function(E) {
                    var F = x + E;
                    return F in this && delete this[F]
                },
                clear: function() {
                    for (var E in this) {
                        if (E[0] === x) {
                            delete this[E]
                        }
                    }
                },
                keys: function() {
                    var E = [];
                    for (var F in this) {
                        if (F[0] === x) {
                            E.push(F.slice(1))
                        }
                    }
                    return E
                },
                values: function() {
                    var E = [];
                    for (var F in this) {
                        if (F[0] === x) {
                            E.push(this[F])
                        }
                    }
                    return E
                },
                entries: function() {
                    var E = [];
                    for (var F in this) {
                        if (F[0] === x) {
                            E.push({
                                key: F.slice(1),
                                value: this[F]
                            })
                        }
                    }
                    return E
                },
                size: function() {
                    var E = 0;
                    for (var F in this) {
                        if (F[0] === x) {
                            ++E
                        }
                    }
                    return E
                },
                empty: function() {
                    for (var E in this) {
                        if (E[0] === x) {
                            return false
                        }
                    }
                    return true
                },
                each: function(F) {
                    for (var E in this) {
                        if (E[0] === x) {
                            F(this[E], E.slice(1), this)
                        }
                    }
                }
            };

            function C(E, H) {
                var I = new k;
                if (E instanceof k) {
                    E.each(function(M, L) {
                        I.set(L, M)
                    })
                } else {
                    if (Array.isArray(E)) {
                        var G = -1,
                            K = E.length,
                            J;
                        if (H == null) {
                            while (++G < K) {
                                I.set(G, E[G])
                            }
                        } else {
                            while (++G < K) {
                                I.set(H(J = E[G], G, E), J)
                            }
                        }
                    } else {
                        if (E) {
                            for (var F in E) {
                                I.set(F, E[F])
                            }
                        }
                    }
                }
                return I
            }
            var B = function() {
                var I = [],
                    K = [],
                    H, J, G;

                function F(R, P, N, S) {
                    if (P >= I.length) {
                        return J != null ? J(R) : (H != null ? R.sort(H) : R)
                    }
                    var Q = -1,
                        L = R.length,
                        V = I[P++],
                        O, T, M = C(),
                        U, W = N();
                    while (++Q < L) {
                        if (U = M.get(O = V(T = R[Q]) + "")) {
                            U.push(T)
                        } else {
                            M.set(O, [T])
                        }
                    }
                    M.each(function(X, Y) {
                        S(W, Y, F(X, P, N, S))
                    });
                    return W
                }

                function E(M, N) {
                    if (++N > I.length) {
                        return M
                    }
                    var O, L = K[N - 1];
                    if (J != null && N >= I.length) {
                        O = M.entries()
                    } else {
                        O = [], M.each(function(Q, P) {
                            O.push({
                                key: P,
                                values: E(Q, N)
                            })
                        })
                    }
                    return L != null ? O.sort(function(Q, P) {
                        return L(Q.key, P.key)
                    }) : O
                }
                return G = {
                    object: function(L) {
                        return F(L, 0, t, q)
                    },
                    map: function(L) {
                        return F(L, 0, u, D)
                    },
                    entries: function(L) {
                        return E(F(L, 0, u, D), 0)
                    },
                    key: function(L) {
                        I.push(L);
                        return G
                    },
                    sortKeys: function(L) {
                        K[I.length - 1] = L;
                        return G
                    },
                    sortValues: function(L) {
                        H = L;
                        return G
                    },
                    rollup: function(L) {
                        J = L;
                        return G
                    }
                }
            };

            function t() {
                return {}
            }

            function q(E, F, G) {
                E[F] = G
            }

            function u() {
                return C()
            }

            function D(G, E, F) {
                G.set(E, F)
            }
            var n = {};
            var e = 12;
            var j = 5;
            var o = [1, 1];
            var r = [];
            var d = [];
            n.nodeWidth = function(E) {
                if (!arguments.length) {
                    return e
                }
                e = +E;
                return n
            };
            n.nodePadding = function(E) {
                if (!arguments.length) {
                    return j
                }
                j = +E;
                return n
            };
            n.nodes = function(E) {
                if (!arguments.length) {
                    return r
                }
                r = E;
                return n
            };
            n.links = function(E) {
                if (!arguments.length) {
                    return d
                }
                d = E;
                return n
            };
            n.size = function(E) {
                if (!arguments.length) {
                    return o
                }
                o = E;
                return n
            };
            n.layout = function(E) {
                c();
                l();
                a();
                h(E);
                b();
                w();
                return n
            };
            n.relayout = function() {
                b();
                w();
                return n
            };
            n.link = function() {
                var F = 0.5;

                function E(N) {
                    var K = N.source.x + N.source.dx,
                        J = N.target.x,
                        I = z(K, J),
                        H = I(F),
                        G = I(1 - F),
                        M = N.source.y + N.sy + N.dy / 2,
                        L = N.target.y + N.ty + N.dy / 2;
                    return "M" + K + "," + M + "C" + H + "," + M + " " + G + "," + L + " " + J + "," + L
                }
                E.curvature = function(G) {
                    if (!arguments.length) {
                        return F
                    }
                    F = +G;
                    return E
                };
                return E
            };

            function w() {
                var E = 0.5;
                d.forEach(function(M) {
                    var J = M.source.x + M.source.dx,
                        I = M.target.x,
                        H = z(J, I),
                        G = H(E),
                        F = H(1 - E),
                        L = M.source.y + M.sy + M.dy / 2,
                        K = M.target.y + M.ty + M.dy / 2;
                    M.bezier = [
                        [J, G, F, I],
                        [L, L, K, K]
                    ]
                })
            }

            function c() {
                r.forEach(function(E) {
                    E.sourceLinks = [];
                    E.targetLinks = []
                });
                d.forEach(function(E) {
                    var F = E.source,
                        G = E.target;
                    if (typeof F === "number") {
                        F = E.source = r[E.source]
                    }
                    if (typeof G === "number") {
                        G = E.target = r[E.target]
                    }
                    F.sourceLinks.push(E);
                    G.targetLinks.push(E)
                })
            }

            function l() {
                r.forEach(function(E) {
                    E.value = Math.max(g(E.sourceLinks, s), g(E.targetLinks, s))
                })
            }

            function a() {
                var F = r,
                    G, E = 0;
                while (F.length) {
                    G = [];
                    F.forEach(function(H) {
                        H.x = E;
                        H.breadth = E;
                        H.dx = e;
                        H.sourceLinks.forEach(function(I) {
                            G.push(I.target)
                        })
                    });
                    F = G;
                    ++E
                }
                y(E);
                p((o[0] - e) / (E - 1))
            }

            function y(E) {
                r.forEach(function(F) {
                    if (!F.sourceLinks.length) {
                        F.x = E - 1
                    }
                })
            }

            function p(E) {
                r.forEach(function(F) {
                    F.x *= E
                })
            }

            function h(J) {
                var E = B().key(function(M) {
                    return M.x
                }).sortKeys(i).entries(r).map(function(M) {
                    return M.values
                });
                H();
                L();
                for (var K = 1; J > 0; --J) {
                    F(K *= 0.99);
                    L();
                    G(K);
                    L()
                }

                function H() {
                    var M = v(E, function(N) {
                        return (o[1] - (N.length - 1) * j) / g(N, s)
                    });
                    E.forEach(function(N) {
                        N.forEach(function(P, O) {
                            P.y = O;
                            P.dy = P.value * M
                        })
                    });
                    d.forEach(function(N) {
                        N.dy = N.value * M
                    })
                }

                function G(N) {
                    E.forEach(function(O, P) {
                        O.forEach(function(Q) {
                            if (Q.targetLinks.length) {
                                var R = g(Q.targetLinks, M) / g(Q.targetLinks, s);
                                Q.y += (R - A(Q)) * N
                            }
                        })
                    });

                    function M(O) {
                        return A(O.source) * O.value
                    }
                }

                function F(N) {
                    E.slice().reverse().forEach(function(O) {
                        O.forEach(function(P) {
                            if (P.sourceLinks.length) {
                                var Q = g(P.sourceLinks, M) / g(P.sourceLinks, s);
                                P.y += (Q - A(P)) * N
                            }
                        })
                    });

                    function M(O) {
                        return A(O.target) * O.value
                    }
                }

                function L() {
                    E.forEach(function(N) {
                        var Q, M, P = 0,
                            R = N.length,
                            O;
                        N.sort(I);
                        for (O = 0; O < R; ++O) {
                            Q = N[O];
                            M = P - Q.y;
                            if (M > 0) {
                                Q.y += M
                            }
                            P = Q.y + Q.dy + j
                        }
                        M = P - j - o[1];
                        if (M > 0) {
                            P = Q.y -= M;
                            for (O = R - 2; O >= 0; --O) {
                                Q = N[O];
                                M = Q.y + Q.dy + j - P;
                                if (M > 0) {
                                    Q.y -= M
                                }
                                P = Q.y
                            }
                        }
                    })
                }

                function I(N, M) {
                    return N.y - M.y
                }
            }

            function b() {
                r.forEach(function(G) {
                    G.sourceLinks.sort(E);
                    G.targetLinks.sort(F)
                });
                r.forEach(function(H) {
                    var I = 0,
                        G = 0;
                    H.sourceLinks.forEach(function(J) {
                        J.sy = I;
                        I += J.dy
                    });
                    H.targetLinks.forEach(function(J) {
                        J.ty = G;
                        G += J.dy
                    })
                });

                function F(H, G) {
                    return H.source.y - G.source.y
                }

                function E(H, G) {
                    return H.target.y - G.target.y
                }
            }

            function A(E) {
                return E.y + E.dy / 2
            }

            function s(E) {
                return E.value
            }
            return n
        };
        this.setSankey = function() {
            var a = this.getD3Sankey();
            a.nodeWidth(this.sankeyNodeWidth);
            a.nodePadding(this.margin);
            a.size([this.x, this.y]);
            a.nodes(this.data.sankey.nodes);
            a.links(this.data.sankey.links);
            a.layout(this.sankeyIterations);
            this.data.sankey.object = a
        };
        this.getD3Tree = function() {
            var b = this;
            var n = function(A, z, y) {
                var B = y / (z.i - A.i);
                z.c -= B;
                z.s += y;
                A.c += B;
                z.z += y;
                z.m += y
            };
            var g = function(A) {
                var z = 0;
                var D = 0;
                var C = A.children;
                var B = C.length;
                var y;
                while (--B >= 0) {
                    y = C[B];
                    y.z += z;
                    y.m += z;
                    z += y.s + (D += y.c)
                }
            };
            var a = function(z, y, A) {
                return z.a.parent === y.parent ? z.a : A
            };
            var t = function(y) {
                var z = y.children;
                return z ? z[0] : y.t
            };
            var x = function(y) {
                var z = y.children;
                return z ? z[z.length - 1] : y.t
            };
            var e = function(z, y) {
                return z.parent === y.parent ? 1 : 2
            };
            var j = 1;
            var h = 1;
            var p = null;
            var i = function(B, z) {
                if (B === z) {
                    return B
                }
                var A = B.ancestors();
                var y = z.ancestors();
                var C = null;
                B = A.pop();
                z = y.pop();
                while (B === z) {
                    C = B;
                    B = A.pop();
                    z = y.pop()
                }
                return C
            };
            var d = function(y) {
                y.data = y.data.data
            };
            var k = function(z) {
                var y = 0;
                do {
                    z.height = y
                } while ((z = z.parent) && (z.height < ++y))
            };
            var c = function(E, A) {
                var H = new w(E);
                var F = +E.value && (H.value = E.value);
                var C;
                var y = [H];
                var z;
                var G;
                var D;
                var B;
                if (A == null) {
                    A = function(I) {
                        return I.children
                    }
                }
                while (C = y.pop()) {
                    if (F) {
                        C.value = +C.data.value
                    }
                    if ((G = A(C.data)) && (B = G.length)) {
                        C.children = new Array(B);
                        for (D = B - 1; D >= 0; --D) {
                            y.push(z = C.children[D] = new w(G[D]));
                            z.parent = C;
                            z.depth = C.depth + 1
                        }
                    }
                }
                return H.eachBefore(k)
            };
            var w = function(y) {
                this.data = y;
                this.depth = 0;
                this.height = 0;
                this.parent = null;
                if (this.nid == null) {
                    this.id = b.treeNodeId++
                }
            };
            w.prototype = c.prototype = {
                constructor: w,
                count: function() {
                    return this.eachAfter(count)
                },
                each: function(E) {
                    var B = this;
                    var C;
                    var A = [B];
                    var z, y, D;
                    do {
                        C = A.reverse();
                        A = [];
                        while (B = C.pop()) {
                            E(B);
                            z = B.children;
                            if (z) {
                                for (y = 0, D = z.length; y < D; ++y) {
                                    A.push(z[y])
                                }
                            }
                        }
                    } while (A.length);
                    return this
                },
                eachAfter: function(E) {
                    var C = this;
                    var y = [C];
                    var B = [];
                    var A, z, D;
                    while (C = y.pop()) {
                        B.push(C);
                        A = C.children;
                        if (A) {
                            for (z = 0, D = A.length; z < D; ++z) {
                                y.push(A[z])
                            }
                        }
                    }
                    while (C = B.pop()) {
                        E(C)
                    }
                    return this
                },
                eachBefore: function(C) {
                    var B = this;
                    var y = [B];
                    var A, z;
                    while (B = y.pop()) {
                        C(B);
                        A = B.children;
                        if (A) {
                            for (z = A.length - 1; z >= 0; --z) {
                                y.push(A[z])
                            }
                        }
                    }
                    return this
                },
                sum: function(y) {
                    return this.eachAfter(function(C) {
                        var B = +y(C.data) || 0;
                        var A = C.children;
                        var z = A && A.length;
                        while (--z >= 0) {
                            B += A[z].value
                        }
                        C.value = B
                    })
                },
                sort: function(y) {
                    return this.eachBefore(function(z) {
                        if (z.children) {
                            z.children.sort(y)
                        }
                    })
                },
                path: function(y) {
                    var C = this;
                    var B = i(C, y);
                    var A = [C];
                    while (C !== B) {
                        C = C.parent;
                        A.push(C)
                    }
                    var z = A.length;
                    while (y !== B) {
                        A.splice(z, 0, y);
                        y = y.parent
                    }
                    return A
                },
                ancestors: function() {
                    var z = this;
                    var y = [z];
                    while (z = z.parent) {
                        y.push(z)
                    }
                    return y
                },
                descendants: function() {
                    var y = [];
                    this.each(function(z) {
                        y.push(z)
                    });
                    return y
                },
                leaves: function() {
                    var y = [];
                    this.eachBefore(function(z) {
                        if (!z.children) {
                            y.push(z)
                        }
                    });
                    return y
                },
                links: function() {
                    var y = this;
                    var z = [];
                    y.each(function(A) {
                        if (A !== y) {
                            z.push({
                                source: A.parent,
                                target: A
                            })
                        }
                    });
                    return z
                },
                copy: function() {
                    return c(this).eachBefore(d)
                }
            };
            var r = function(z, y) {
                this._ = z;
                this.parent = null;
                this.children = null;
                this.A = null;
                this.a = this;
                this.z = 0;
                this.m = 0;
                this.c = 0;
                this.s = 0;
                this.t = null;
                this.i = y
            };
            r.prototype = Object.create(w.prototype);
            var s = function(z) {
                var y = new r(z, 0);
                var D;
                var A = [y];
                var F;
                var C;
                var B;
                var E;
                while (D = A.pop()) {
                    if (C = D._.children) {
                        D.children = new Array(E = C.length);
                        for (B = E - 1; B >= 0; --B) {
                            A.push(F = D.children[B] = new r(C[B], B));
                            F.parent = D
                        }
                    }
                }(y.parent = new r(null, 0)).children = [y];
                return y
            };

            function l(D) {
                var F = s(D);
                F.eachAfter(v), F.parent.m = -F.z;
                F.eachBefore(q);
                if (p) {
                    D.eachBefore(u)
                } else {
                    var z = D;
                    var E = D;
                    var y = D;
                    D.eachBefore(function(H) {
                        if (H.x < z.x) {
                            z = H
                        }
                        if (H.x > E.x) {
                            E = H
                        }
                        if (H.depth > y.depth) {
                            y = H
                        }
                    });
                    var G = z === E ? 1 : e(z, E) / 2;
                    var A = G - z.x;
                    var C = j / (E.x + G + A);
                    var B = h / (y.depth || 1);
                    D.eachBefore(function(H) {
                        H.x = (H.x + A) * C;
                        H.y = H.depth * B
                    })
                }
                return D
            }

            function v(z) {
                var B = z.children;
                var C = z.parent.children;
                var y = z.i ? C[z.i - 1] : null;
                if (B) {
                    g(z);
                    var A = (B[0].z + B[B.length - 1].z) / 2;
                    if (y) {
                        z.z = y.z + e(z._, y._);
                        z.m = z.z - A
                    } else {
                        z.z = A
                    }
                } else {
                    if (y) {
                        z.z = y.z + e(z._, y._)
                    }
                }
                z.parent.A = o(z, y, z.parent.A || C[0])
            }

            function q(y) {
                y._.x = y.z + y.parent.m;
                y.m += y.parent.m
            }

            function o(J, I, D) {
                if (I) {
                    var A = J;
                    var z = J;
                    var C = I;
                    var B = A.parent.children[0];
                    var F = A.m;
                    var E = z.m;
                    var H = C.m;
                    var G = B.m;
                    var y;
                    while (C = x(C), A = t(A), C && A) {
                        B = t(B);
                        z = x(z);
                        z.a = J;
                        y = C.z + H - A.z - F + e(C._, A._);
                        if (y > 0) {
                            n(a(C, J, D), J, y);
                            F += y;
                            E += y
                        }
                        H += C.m;
                        F += A.m;
                        G += B.m;
                        E += z.m
                    }
                    if (C && !x(z)) {
                        z.t = C;
                        z.m += H - E
                    }
                    if (A && !t(B)) {
                        B.t = A;
                        B.m += F - G;
                        D = J
                    }
                }
                return D
            }

            function u(y) {
                y.x *= j;
                y.y = y.depth * h
            }
            l.separation = function(y) {
                return arguments.length ? (e = y, l) : e
            };
            l.size = function(y) {
                return arguments.length ? (p = false, j = +y[0], h = +y[1], l) : (p ? null : [j, h])
            };
            l.nodeSize = function(y) {
                return arguments.length ? (p = true, j = +y[0], h = +y[1], l) : (p ? [j, h] : null)
            };
            l.setTree = function(z, y) {
                return c(z, y)
            };
            l.collapse = function(y) {
                l.collapseTree(y);
                l.update(y)
            };
            l.expand = function(y) {
                l.expandTree(y);
                l.update(y)
            };
            l.collapseTree = function(y) {
                if (y.children) {
                    y._children = y.children;
                    y._children.forEach(l.collapseTree);
                    y.children = null
                }
            };
            l.expandTree = function(y) {
                if (y._children) {
                    y.children = y._children;
                    y.children.forEach(l.expandTree);
                    delete y._children
                }
            };
            return l
        };
        this.setTree = function() {
            var b = [];
            if (this.treeCircular) {
                b = this.x > this.y ? [360, this.y / 2] : [360, this.x / 2]
            } else {
                b = [this.graphOrientation == "vertical" ? this.x : this.y, this.graphOrientation == "vertical" ? this.y : this.x]
            }
            var a = function(d, c) {
                return (d.parent == c.parent ? 1 : 2) / d.depth
            };
            this.data.tree.object = this.treeCircular ? this.getD3Tree().size(b).separation(a) : this.getD3Tree().size(b);
            if (!this.data.tree.root) {
                this.data.tree.root = this.getD3Tree().setTree(this.data.tree.data, function(c) {
                    return c.children
                })
            }
            this.data.tree.plot = this.data.tree.object(this.data.tree.root);
            this.data.tree.plot.size = b
        };
        this.getD3CirclePack = function() {
            var n = this;
            var t = function(M, K) {
                if (M === K) {
                    return M
                }
                var L = M.ancestors();
                var J = K.ancestors();
                var N = null;
                M = L.pop();
                K = J.pop();
                while (M === K) {
                    N = M;
                    M = L.pop();
                    K = J.pop()
                }
                return N
            };
            var q = function(J) {
                J.data = J.data.data
            };
            var y = function(K) {
                var J = 0;
                do {
                    K.height = J
                } while ((K = K.parent) && (K.height < ++J))
            };
            var o = function(P, L) {
                var S = new H(P);
                var Q = +P.value && (S.value = P.value);
                var N;
                var J = [S];
                var K;
                var R;
                var O;
                var M;
                if (L == null) {
                    L = function(T) {
                        return T.children
                    }
                }
                while (N = J.pop()) {
                    if (Q) {
                        N.value = +N.data.value
                    }
                    if ((R = L(N.data)) && (M = R.length)) {
                        N.children = new Array(M);
                        for (O = M - 1; O >= 0; --O) {
                            J.push(K = N.children[O] = new H(R[O]));
                            K.parent = N;
                            K.depth = N.depth + 1
                        }
                    }
                }
                return S.eachBefore(y)
            };
            var H = function(J) {
                this.data = J;
                this.depth = 0;
                this.height = 0;
                this.parent = null;
                if (this.nid == null) {
                    this.id = n.treeNodeId++
                }
            };
            H.prototype = o.prototype = {
                constructor: H,
                count: function() {
                    return this.eachAfter(count)
                },
                each: function(P) {
                    var M = this;
                    var N;
                    var L = [M];
                    var K, J, O;
                    do {
                        N = L.reverse();
                        L = [];
                        while (M = N.pop()) {
                            P(M);
                            K = M.children;
                            if (K) {
                                for (J = 0, O = K.length; J < O; ++J) {
                                    L.push(K[J])
                                }
                            }
                        }
                    } while (L.length);
                    return this
                },
                eachAfter: function(P) {
                    var N = this;
                    var J = [N];
                    var M = [];
                    var L, K, O;
                    while (N = J.pop()) {
                        M.push(N);
                        L = N.children;
                        if (L) {
                            for (K = 0, O = L.length; K < O; ++K) {
                                J.push(L[K])
                            }
                        }
                    }
                    while (N = M.pop()) {
                        P(N)
                    }
                    return this
                },
                eachBefore: function(N) {
                    var M = this;
                    var J = [M];
                    var L, K;
                    while (M = J.pop()) {
                        N(M);
                        L = M.children;
                        if (L) {
                            for (K = L.length - 1; K >= 0; --K) {
                                J.push(L[K])
                            }
                        }
                    }
                    return this
                },
                sum: function(J) {
                    return this.eachAfter(function(N) {
                        var M = +J(N.data) || 0;
                        var L = N.children;
                        var K = L && L.length;
                        while (--K >= 0) {
                            M += L[K].value
                        }
                        N.value = M
                    })
                },
                sort: function(J) {
                    return this.eachBefore(function(K) {
                        if (K.children) {
                            K.children.sort(J)
                        }
                    })
                },
                path: function(J) {
                    var N = this;
                    var M = t(N, J);
                    var L = [N];
                    while (N !== M) {
                        N = N.parent;
                        L.push(N)
                    }
                    var K = L.length;
                    while (J !== M) {
                        L.splice(K, 0, J);
                        J = J.parent
                    }
                    return L
                },
                ancestors: function() {
                    var K = this;
                    var J = [K];
                    while (K = K.parent) {
                        J.push(K)
                    }
                    return J
                },
                descendants: function() {
                    var J = [];
                    this.each(function(K) {
                        J.push(K)
                    });
                    return J
                },
                leaves: function() {
                    var J = [];
                    this.eachBefore(function(K) {
                        if (!K.children) {
                            J.push(K)
                        }
                    });
                    return J
                },
                links: function() {
                    var J = this;
                    var K = [];
                    J.each(function(L) {
                        if (L !== J) {
                            K.push({
                                source: L.parent,
                                target: L
                            })
                        }
                    });
                    return K
                },
                copy: function() {
                    return o(this).eachBefore(q)
                }
            };
            var e = null;
            var u = 1;
            var s = 1;
            var i = function(J) {
                this._ = J;
                this.next = null
            };
            var h = function(O) {
                var K;
                var N = (O = O.slice()).length;
                var J = null;
                var M = J;
                while (N) {
                    var L = new i(O[N - 1]);
                    if (M) {
                        M = M.next = L
                    } else {
                        M = J = L
                    }
                    O[K] = O[--N]
                }
                return {
                    head: J,
                    tail: M
                }
            };
            var v = function(J) {
                return I(h(J), [])
            };
            var d = function(L, J) {
                var M = J.x - L.x;
                var K = J.y - L.y;
                var N = L.r - J.r;
                return N * N + 0.000001 > M * M + K * K
            };
            var I = function(K, Q) {
                var O;
                var N = null;
                var M = K.head;
                var J;
                var P;
                switch (Q.length) {
                    case 1:
                        O = A(Q[0]);
                        break;
                    case 2:
                        O = z(Q[0], Q[1]);
                        break;
                    case 3:
                        O = w(Q[0], Q[1], Q[2]);
                        break
                }
                while (M) {
                    P = M._;
                    J = M.next;
                    if (!O || !d(O, P)) {
                        if (N) {
                            K.tail = N;
                            N.next = null
                        } else {
                            K.head = K.tail = null
                        }
                        Q.push(P);
                        O = I(K, Q);
                        Q.pop();
                        if (K.head) {
                            M.next = K.head;
                            K.head = M
                        } else {
                            M.next = null;
                            K.head = K.tail = M
                        }
                        N = K.tail;
                        N.next = J
                    } else {
                        N = M
                    }
                    M = J
                }
                K.tail = N;
                return O
            };
            var A = function(J) {
                return {
                    x: J.x,
                    y: J.y,
                    r: J.r
                }
            };
            var z = function(U, R) {
                var K = U.x;
                var T = U.y;
                var M = U.r;
                var J = R.x;
                var Q = R.y;
                var L = R.r;
                var P = J - K;
                var S = Q - T;
                var N = L - M;
                var O = Math.sqrt(P * P + S * S);
                return {
                    x: (K + J + P / O * N) / 2,
                    y: (T + Q + S / O * N) / 2,
                    r: (O + M + L) / 2
                }
            };
            var w = function(ai, ag, af) {
                var ae = ai.x;
                var N = ai.y;
                var Z = ai.r;
                var ad = ag.x;
                var M = ag.y;
                var X = ag.r;
                var aa = af.x;
                var K = af.y;
                var W = af.r;
                var al = 2 * (ae - ad);
                var P = 2 * (N - M);
                var V = 2 * (X - Z);
                var am = ae * ae + N * N - Z * Z - ad * ad - M * M + X * X;
                var aj = 2 * (ae - aa);
                var O = 2 * (N - K);
                var U = 2 * (W - Z);
                var ak = ae * ae + N * N - Z * Z - aa * aa - K * K + W * W;
                var ah = aj * P - al * O;
                var ac = (P * ak - O * am) / ah - ae;
                var Y = (O * V - P * U) / ah;
                var L = (aj * am - al * ak) / ah - N;
                var J = (al * U - aj * V) / ah;
                var T = Y * Y + J * J - 1;
                var S = 2 * (ac * Y + L * J + Z);
                var R = ac * ac + L * L - Z * Z;
                var Q = (-S - Math.sqrt(S * S - 4 * T * R)) / (2 * T);
                return {
                    x: ac + Y * Q + ae,
                    y: L + J * Q + N,
                    r: Q
                }
            };
            var p = function(O, M, K) {
                var J = O.x;
                var S = O.y;
                var T = M.r + K.r;
                var R = O.r + K.r;
                var U = M.x - J;
                var Q = M.y - S;
                var P = U * U + Q * Q;
                if (P) {
                    var N = 0.5 + ((R *= R) - (T *= T)) / (2 * P);
                    var L = Math.sqrt(Math.max(0, 2 * T * (R + P) - (R -= P) * R - T * T)) / (2 * P);
                    K.x = J + N * U + L * Q;
                    K.y = S + N * Q - L * U
                } else {
                    K.x = J + R;
                    K.y = S
                }
            };
            var a = function(L, J) {
                var M = J.x - L.x;
                var K = J.y - L.y;
                var N = L.r + J.r;
                return N * N - 0.000001 > M * M + K * K
            };
            var C = function(O, K, Q) {
                var M = O._;
                var J = O.next._;
                var P = M.r + J.r;
                var N = (M.x * J.r + J.x * M.r) / P - K;
                var L = (M.y * J.r + J.y * M.r) / P - Q;
                return N * N + L * L
            };
            var j = function(J) {
                this._ = J;
                this.next = null;
                this.previous = null
            };
            var l = function(R) {
                if (!(P = R.length)) {
                    return 0
                }
                var W, P, T, X, X, V;
                var Z = R[0];
                Z.x = 0;
                Z.y = 0;
                if (!(P > 1)) {
                    return Z.r
                }
                var Y = R[1];
                Z.x = -Y.r;
                Y.x = Z.r;
                Y.y = 0;
                if (!(P > 2)) {
                    return Z.r + Y.r
                }
                p(Y, Z, W = R[2]);
                var ab = Z.r * Z.r;
                var N = Y.r * Y.r;
                var O = W.r * W.r;
                var S = ab + N + O;
                var M = ab * Z.x + N * Y.x + O * W.x;
                var L = ab * Z.y + N * Y.y + O * W.y;
                var K, J, U, T, Q, X, V;
                Z = new j(Z);
                Y = new j(Y);
                W = new j(W);
                Z.next = W.previous = Y;
                Y.next = Z.previous = W;
                W.next = Y.previous = Z;
                D: for (var U = 3; U < P; ++U) {
                    p(Z._, Y._, W = R[U]);
                    W = new j(W);
                    T = Y.next;
                    Q = Z.previous;
                    X = Y._.r;
                    V = Z._.r;
                    do {
                        if (X <= V) {
                            if (a(T._, W._)) {
                                Y = T;
                                Z.next = Y;
                                Y.previous = Z;
                                --U;
                                continue D
                            }
                            X += T._.r;
                            T = T.next
                        } else {
                            if (a(Q._, W._)) {
                                Z = Q;
                                Z.next = Y;
                                Y.previous = Z;
                                --U;
                                continue D
                            }
                            V += Q._.r;
                            Q = Q.previous
                        }
                    } while (T !== Q.next);
                    W.previous = Z;
                    W.next = Y;
                    Z.next = Y.previous = Y = W;
                    S += O = W._.r * W._.r;
                    M += O * W._.x;
                    L += O * W._.y;
                    ab = C(Z, K = M / S, J = L / S);
                    while ((W = W.next) !== Y) {
                        if ((O = C(W, K, J)) < ab) {
                            Z = W;
                            ab = O
                        }
                    }
                    Y = Z.next
                }
                Z = [Y._];
                W = Y;
                while ((W = W.next) !== Y) {
                    Z.push(W._)
                }
                W = v(Z);
                for (var U = 0; U < P; ++U) {
                    Z = R[U];
                    Z.x -= W.x;
                    Z.y -= W.y
                }
                return W.r
            };
            var k = function(J) {
                l(J);
                return J
            };
            var G = function(J) {
                return J == null ? null : r(J)
            };
            var r = function(J) {
                if (typeof J !== "function") {
                    throw new Error
                }
                return J
            };
            var B = function() {
                return 0
            };
            var g = function(J) {
                return function() {
                    return J
                }
            };
            var F = function(J) {
                return Math.sqrt(J.value)
            };
            var G = function(J) {
                return J == null ? null : r(J)
            };
            var E = function(J) {
                return function(K) {
                    if (!K.children) {
                        K.r = Math.max(0, +J(K) || 0)
                    }
                }
            };
            var c = function(K, J) {
                return function(O) {
                    if (M = O.children) {
                        var M, L, Q = M.length,
                            N = K(O) * J || 0,
                            P;
                        if (N) {
                            for (L = 0; L < Q; ++L) {
                                M[L].r += N
                            }
                        }
                        P = l(M);
                        if (N) {
                            for (L = 0; L < Q; ++L) {
                                M[L].r -= N
                            }
                        }
                        O.r = P + N
                    }
                }
            };
            var b = function(J) {
                return function(L) {
                    var K = L.parent;
                    L.r *= J;
                    if (K) {
                        L.x = K.x + J * L.x;
                        L.y = K.y + J * L.y
                    }
                }
            };
            var x = B;

            function D(J) {
                J.x = u / 2, J.y = s / 2;
                if (e) {
                    J.eachBefore(E(e)).eachAfter(c(x, 0.5)).eachBefore(b(1))
                } else {
                    J.eachBefore(E(F)).eachAfter(c(B, 1)).eachAfter(c(x, J.r / Math.min(u, s))).eachBefore(b(Math.min(u, s) / (2 * J.r)))
                }
                return J
            }
            D.radius = function(J) {
                return arguments.length ? (e = G(J), D) : e
            };
            D.size = function(J) {
                return arguments.length ? (u = +J[0], s = +J[1], D) : [u, s]
            };
            D.padding = function(J) {
                return arguments.length ? (x = typeof J === "function" ? J : g(+J), D) : x
            };
            D.setPack = function(J) {
                return o(J).sum(function(K) {
                    return K.size
                }).sort(function(L, K) {
                    return K.value - L.value
                })
            };
            return D
        };
        this.setCirclePack = function() {
            var b = Math.max(this.top, this.right);
            var a = this.width - (this.right + this.left + this.marginLeft + this.marginRight);
            var e = this.height - (this.top + this.bottom + this.marginTop + this.marginBottom);
            var c = a > e ? e : a;
            this.data.bubble.object = this.getD3CirclePack().size([c, c]).padding(2);
            if (!this.data.bubble.root) {
                this.data.bubble.root = this.getD3CirclePack().setPack(this.data.bubble.data)
            }
            this.data.bubble.plot = this.data.bubble.object(this.data.bubble.root);
            this.data.bubble.plot.diameter = c
        };
        this.getD3Contour = function() {
            var h = Array.prototype.slice;
            var b = function(p, o) {
                return p - o
            };
            var a = function(o) {
                var p = 0;
                var r = o.length;
                var q = o[r - 1][1] * o[0][0] - o[r - 1][0] * o[0][1];
                while (++p < r) {
                    q += o[p - 1][1] * o[p][0] - o[p - 1][0] * o[p][1]
                }
                return q
            };
            var g = function(o) {
                return function() {
                    return o
                }
            };
            var c = function(o, q) {
                var p = -1;
                var s = q.length;
                var r;
                while (++p < s) {
                    if (r = e(o, q[p])) {
                        return r
                    }
                }
                return 0
            };
            var e = function(s, D) {
                var C = D[0],
                    B = D[1],
                    q = -1;
                for (var v = 0, o = s.length, t = o - 1; v < o; t = v++) {
                    var w = s[v],
                        A = w[0],
                        r = w[1],
                        u = s[t],
                        z = u[0],
                        p = u[1];
                    if (j(w, u, D)) {
                        return 0
                    }
                    if (((r > B) !== (p > B)) && ((C < (z - A) * (B - r) / (p - r) + A))) {
                        q = -q
                    }
                }
                return q
            };
            var j = function(p, o, r) {
                var q;
                return n(p, o, r) && d(p[q = +(p[0] === o[0])], r[q], o[q])
            };
            var n = function(p, o, q) {
                return (o[0] - p[0]) * (q[1] - p[1]) === (q[0] - p[0]) * (o[1] - p[1])
            };
            var d = function(t, s, o) {
                return t <= s && s <= o || o <= s && s <= t
            };
            var l = function() {};
            var k = [
                [],
                [
                    [
                        [1, 1.5],
                        [0.5, 1]
                    ]
                ],
                [
                    [
                        [1.5, 1],
                        [1, 1.5]
                    ]
                ],
                [
                    [
                        [1.5, 1],
                        [0.5, 1]
                    ]
                ],
                [
                    [
                        [1, 0.5],
                        [1.5, 1]
                    ]
                ],
                [
                    [
                        [1, 1.5],
                        [0.5, 1]
                    ],
                    [
                        [1, 0.5],
                        [1.5, 1]
                    ]
                ],
                [
                    [
                        [1, 0.5],
                        [1, 1.5]
                    ]
                ],
                [
                    [
                        [1, 0.5],
                        [0.5, 1]
                    ]
                ],
                [
                    [
                        [0.5, 1],
                        [1, 0.5]
                    ]
                ],
                [
                    [
                        [1, 1.5],
                        [1, 0.5]
                    ]
                ],
                [
                    [
                        [0.5, 1],
                        [1, 0.5]
                    ],
                    [
                        [1.5, 1],
                        [1, 1.5]
                    ]
                ],
                [
                    [
                        [1.5, 1],
                        [1, 0.5]
                    ]
                ],
                [
                    [
                        [0.5, 1],
                        [1.5, 1]
                    ]
                ],
                [
                    [
                        [1, 1.5],
                        [1.5, 1]
                    ]
                ],
                [
                    [
                        [0.5, 1],
                        [1, 1.5]
                    ]
                ],
                []
            ];
            var i = function() {
                var r = 1;
                var q = 1;
                var v = function(w) {
                    var x = threshold(w);
                    x = x.slice().sort(b);
                    return x.map(function(y) {
                        return t(w, y)
                    })
                };
                var s = function(w) {
                    return w[0] * 2 + w[1] * (r + 1) * 4
                };
                var p = function(x, w, y) {
                    x.forEach(function(B) {
                        var A = B[0];
                        var F = B[1];
                        var C = A | 0;
                        var D = F | 0;
                        var z;
                        var E = w[D * r + C];
                        if (A > 0 && A < r && C === A) {
                            z = w[D * r + C - 1];
                            B[0] = A + (y - z) / (E - z) - 0.5
                        }
                        if (F > 0 && F < q && D === F) {
                            z = w[(D - 1) * r + C];
                            B[1] = F + (y - z) / (E - z) - 0.5
                        }
                    })
                };
                var o = p;
                var t = function(y, z) {
                    var x = [];
                    var w = [];
                    u(y, z, function(A) {
                        o(A, y, z);
                        if (a(A) > 0) {
                            x.push([A])
                        } else {
                            w.push(A)
                        }
                    });
                    w.forEach(function(C) {
                        for (var B = 0, D = x.length, A; B < D; ++B) {
                            if (c((A = x[B])[0], C) !== -1) {
                                A.push(C);
                                return
                            }
                        }
                    });
                    return {
                        type: "MultiPolygon",
                        value: z,
                        coordinates: x
                    }
                };
                var u = function(I, H, J) {
                    var z = new Array;
                    var A = new Array;
                    var G, F, E, D, C, B;
                    var w = function(y) {
                        var O = [y[0][0] + G, y[0][1] + F];
                        var x = [y[1][0] + G, y[1][1] + F];
                        var N = s(O);
                        var M = s(x);
                        var L, K;
                        if (L = A[N]) {
                            if (K = z[M]) {
                                delete A[L.end];
                                delete z[K.start];
                                if (L === K) {
                                    L.ring.push(x);
                                    J(L.ring)
                                } else {
                                    z[L.start] = A[K.end] = {
                                        start: L.start,
                                        end: K.end,
                                        ring: L.ring.concat(K.ring)
                                    }
                                }
                            } else {
                                delete A[L.end];
                                L.ring.push(x);
                                A[L.end = M] = L
                            }
                        } else {
                            if (L = z[M]) {
                                if (K = A[N]) {
                                    delete z[L.start];
                                    delete A[K.end];
                                    if (L === K) {
                                        L.ring.push(x);
                                        J(L.ring)
                                    } else {
                                        z[K.start] = A[L.end] = {
                                            start: K.start,
                                            end: L.end,
                                            ring: K.ring.concat(L.ring)
                                        }
                                    }
                                } else {
                                    delete z[L.start];
                                    L.ring.unshift(O);
                                    z[L.start = N] = L
                                }
                            } else {
                                z[N] = A[M] = {
                                    start: N,
                                    end: M,
                                    ring: [O, x]
                                }
                            }
                        }
                    };
                    G = F = -1;
                    D = I[0] >= H;
                    k[D << 1].forEach(w);
                    while (++G < r - 1) {
                        E = D, D = I[G + 1] >= H;
                        k[E | D << 1].forEach(w)
                    }
                    k[D << 0].forEach(w);
                    while (++F < q - 1) {
                        G = -1;
                        D = I[F * r + r] >= H;
                        C = I[F * r] >= H;
                        k[D << 1 | C << 2].forEach(w);
                        while (++G < r - 1) {
                            E = D, D = I[F * r + r + G + 1] >= H;
                            B = C, C = I[F * r + G + 1] >= H;
                            k[E | D << 1 | C << 2 | B << 3].forEach(w)
                        }
                        k[D | C << 3].forEach(w)
                    }
                    G = -1;
                    C = I[F * r] >= H;
                    k[C << 2].forEach(w);
                    while (++G < r - 1) {
                        B = C, C = I[F * r + G + 1] >= H;
                        k[C << 2 | B << 3].forEach(w)
                    }
                    k[C << 3].forEach(w)
                };
                v.contour = t;
                v.size = function(w) {
                    if (!arguments.length) {
                        return [r, q]
                    }
                    var y = Math.ceil(w[0]);
                    var x = Math.ceil(w[1]);
                    if (!(y > 0) || !(x > 0)) {
                        throw new Error("invalid size")
                    }
                    return r = y, q = x, v
                };
                v.thresholds = function(w) {
                    return arguments.length ? (threshold = typeof w === "function" ? w : Array.isArray(w) ? g(h.call(w)) : g(w), v) : threshold
                };
                v.smooth = function(w) {
                    return arguments.length ? (o = w ? p : l, v) : o === p
                };
                return v
            };
            return i
        };
        this.circularLayout = function(c, g) {
            var e = this;
            if (c.length > 0) {
                var b, h, d;
                if (g) {} else {
                    b = this.x / 2;
                    h = this.y / 2;
                    d = Math.max(this.x, this.y)
                }
                this.calculateCircularLayoutFinalNodePosition(c, b, h, d);
                var a = function() {
                    if (e.iteration <= 15) {
                        e.updateCircularLayoutNodePositions(c);
                        e.renderNetwork(false);
                        e.drawNetworkProgressBar("Optimizing ...", e.iteration / 15);
                        e.requestAnimationFrame(a)
                    } else {
                        e.finalizeNetworkLayout("circularLayout")
                    }
                };
                a()
            }
        };
        this.calculateCircularLayoutFinalNodePosition = function(b, h, g, a) {
            if (this.sizeNodeBy) {
                var k = 0;
                for (var d = 0; d < b.length; d++) {
                    var c = b[d];
                    if (!c.hide) {
                        k += (this.nodeSize * this.getNodeEdgePropertyValue(c, false, "sizeNodeBy") * 2) + this.nodeSize
                    }
                }
                var e = 2 * Math.PI / k;
                var j = 0;
                for (var d = 0; d < b.length; d++) {
                    var c = b[d];
                    var k = (this.nodeSize * this.getNodeEdgePropertyValue(c, false, "sizeNodeBy") * 2) + this.nodeSize;
                    if (!c.hide) {
                        j += e * k * 0.5;
                        c.layout.lastPosition.x = h + a + a * Math.sin(j);
                        c.layout.lastPosition.y = g + a + a * Math.cos(j);
                        c.layout.lastPosition.r = this.networkRadialRadius;
                        c.layout.lastPosition.a = j * 180 / Math.PI;
                        c.radius = this.networkRadialRadius;
                        c.angle = j * 180 / Math.PI;
                        j += e * k * 0.5
                    }
                }
            } else {
                var e = 2 * Math.PI / b.length;
                for (var d = 0; d < b.length; d++) {
                    var c = b[d];
                    if (!c.hide) {
                        c.layout.lastPosition.x = h + a + a * Math.sin(d * e);
                        c.layout.lastPosition.y = g + a + a * Math.cos(d * e);
                        c.layout.lastPosition.r = this.networkRadialRadius;
                        c.layout.lastPosition.a = d * e * 180 / Math.PI;
                        c.radius = this.networkRadialRadius;
                        c.angle = d * e * 180 / Math.PI
                    }
                }
            }
        };
        this.updateCircularLayoutNodePositions = function(d) {
                var l = Math.atan((this.iteration++/15)*10-5)*0.5/Math.atan(5) + 0.5;
                            for (var e = 0; e < d.length; e++) {
                                var j = d[e].layout;
                                var h = j.lastPosition;
                                var b = h.a * l;
                                var g = h.r * l;
                                var k = this.getPolar(this.networkXCenter, this.networkYCenter, g, b);
                                j.position.x = k.x;
                                j.position.y = k.y
                            }
                            this.updateLayoutNodePositions(d)
                        }; this.radialLayout = function(a, d) {
                            var c = this;
                            if (a && a.length) {
                                this.calculateRadialLayoutFinalNodePosition(d);
                                this.resetRadialLayoutNodePositions(a);
                                var b = function() {
                                    if (c.iteration < 15) {
                                        c.updateRadialLayoutNodePositions(a);
                                        c.renderNetwork(false);
                                        c.drawNetworkProgressBar("Optimizing ...", c.iteration / 15);
                                        c.requestAnimationFrame(b)
                                    } else {
                                        c.finalizeNetworkLayout("radialLayout")
                                    }
                                };
                                b()
                            }
                        }; this.orderRadialLayout = function(d) {
                            var b = this.data.nodeIndices[d];
                            var c = 0;
                            for (var a = b; a < this.data.nodes.length; a++) {
                                this.data.nodes[a].layout.order = c++
                            }
                            for (var a = 0; a < b; a++) {
                                this.data.nodes[a].layout.order = c++
                            }
                        }; this.updateRadialLayoutNodePositions = function(d) {
                            var g = Math.atan((this.iteration++/15)*10-5)*0.5/Math.atan(5) + 0.5;
                                    var e = 1 - g;
                                    for (var j = 0; j < d.length; j++) {
                                        var h = d[j].layout;
                                        var p = h.lastPosition;
                                        var l = ((e * h.angle) + (g * p.a));
                                        var b = ((e * h.radius) + (g * p.r));
                                        var k = this.getPolar(this.networkXCenter, this.networkYCenter, b, l);
                                        d[j].layout.position.x = k.x;
                                        d[j].layout.position.y = k.y
                                    }
                                    this.updateLayoutNodePositions(d)
                                }; this.resetRadialLayoutNodePositions = function(a) {
                                    for (var b = 0; b < a.length; b++) {
                                        var e = a[b].layout;
                                        var c = e.lastPosition;
                                        if (c.r == 0) {
                                            e.angle = c.a
                                        }
                                        if (c.r == 0) {
                                            c.a = e.angle
                                        }
                                        var g = (c.a - e.angle);
                                        if (g < 0) {
                                            g += 360
                                        }
                                        if (g > 360) {
                                            g -= 360
                                        }
                                        if (g > 180) {
                                            g -= 360
                                        }
                                        c.a = e.angle + g
                                    }
                                }; this.calculateRadialLayoutFinalNodePosition = function(h, d) {
                                    var q = this;
                                    var u = 0;
                                    var t = [];
                                    var p = this.data.nodes[this.data.nodeIndices[h]];
                                    var j = p.layout;
                                    if (j.hierarchy != "done") {
                                        if (!p.hide && !p.hiddenParent) {
                                            if (j.children.length > 1 && !d) {
                                                this.orderRadialLayout(h);
                                                j.children.sort(function(i, c) {
                                                    var n = q.data.nodes[q.data.nodeIndices[i]].layout;
                                                    var l = q.data.nodes[q.data.nodeIndices[c]].layout;
                                                    return n.order - l.order
                                                });
                                                for (var o = 0; o < j.children.length; o++) {
                                                    var e = j.children[o];
                                                    var v = this.data.nodes[this.data.nodeIndices[e]].layout;
                                                    if (v.level > j.level) {
                                                        this.calculateRadialLayoutFinalNodePosition(e);
                                                        t.push(v.angle)
                                                    }
                                                }
                                                if (t.length > 0) {
                                                    var g = t.length - 1;
                                                    if (t.length == 1) {
                                                        u = t[0]
                                                    } else {
                                                        if (t[0] > t[g]) {
                                                            u = ((t[0] + t[g]) % 360) / 2
                                                        } else {
                                                            u = (t[0] + t[g]) / 2
                                                        }
                                                    }
                                                } else {
                                                    this.calculateRadialLayoutFinalNodePosition(h, true)
                                                }
                                            } else {
                                                u = this.networkCurrentAngle;
                                                this.networkCurrentAngle = (this.networkCurrentAngle + this.networkAngleStep)
                                            }
                                            var k = (this.networkDepth - 1) - j.level;
                                            var s = this.getPolar(this.networkXCenter, this.networkYCenter, this.networkRadialRadius, u);
                                            var w = this.shortenLine(this.networkXCenter, this.networkYCenter, s.x, s.y, 0, this.networkLevelSize * k, "line");
                                            var b = this.lineLength(this.networkXCenter, this.networkYCenter, w[2], w[3]);
                                            if (j.level == 0) {
                                                u = 0;
                                                b = 0
                                            }
                                            j.lastPosition.x = w[2];
                                            j.lastPosition.y = w[3];
                                            j.lastPosition.r = b;
                                            j.lastPosition.a = u % 360;
                                            j.hierarchy = "done";
                                            j.angle = u
                                        }
                                    }
                                }; this.forceDirectedLayout = function(b, a) {
                                    var d = this;
                                    if (b && b.length) {
                                        var c = function() {
                                            var e = d.calculateForcedDirectedLayoutMovement(b, a);
                                            var g = e / b.length;
                                            if (g >= 0.01 && d.iteration < d.maxIterations) {
                                                d.iteration++;
                                                if (d.iteration % 2) {
                                                    d.renderNetwork(false)
                                                }
                                                d.drawNetworkProgressBar("Optimizing ...", d.iteration / d.maxIterations);
                                                d.requestAnimationFrame(c)
                                            } else {
                                                d.finalizeNetworkLayout("forceDirectedLayout")
                                            }
                                        };
                                        c()
                                    }
                                }; this.calculateForcedDirectedLayoutMovement = function(b, a) {
                                    if (this.useBarnesHutSimulation || a) {
                                        this.accumulateForceDirectedLayoutForces();
                                        return this.integrateForceDirectedLayout(b)
                                    } else {
                                        this.setForceDirectedLayoutNodeDisplacement(b);
                                        return this.integrateForceDirectedLayoutDisplacement(b)
                                    }
                                }; this.integrateForceDirectedLayoutDisplacement = function(a) {
                                    var d = this.averageForceDirectedLayoutMovement(a);
                                    var b = a.length;
                                    if (b) {
                                        while (b--) {
                                            var c = a[b];
                                            if (!c.fixed && this.iteration % 2) {
                                                c.layout.prevPosition.x = c.layout.position.x;
                                                c.layout.prevPosition.y = c.layout.position.y
                                            }
                                        }
                                    }
                                    this.updateLayoutNodePositions(a);
                                    return d * a.length
                                }; this.setForceDirectedLayoutNodeDisplacement = function(d) {
                                    var b = {};
                                    var j = [];
                                    var h = d.length;
                                    for (var k = 0; k < h; k++) {
                                        var g = d[k];
                                        for (var p = 0; p < g.layout.edges.length; p++) {
                                            var n = g.layout.edges[p];
                                            var o = n.id1 + ":" + n.id2;
                                            if (!b.hasOwnProperty(o)) {
                                                j.push(n);
                                                b[o] = true
                                            }
                                        }
                                        if (!g.fixed && !this.iteration) {
                                            g.layout.displacement = {
                                                x: g.x,
                                                y: g.y,
                                                z: g.z
                                            };
                                            g.layout.force = {
                                                x: 0,
                                                y: 0,
                                                z: 0
                                            }
                                        }
                                    }
                                    this.calculateForceDirectedLayoutRepulsiveDisplacement(d);
                                    this.calculateForceDirectedLayoutAttractiveDisplacement(d, j);
                                    this.applyForceDirectedLayoutDisplacement(d)
                                }; this.calculateForceDirectedLayoutRepulsiveDisplacement = function(b) {
                                    var w = this;
                                    var g = b.length;
                                    var h = Math.sqrt((g * g) / g + 1);
                                    var s = function(i) {
                                        switch (w.repulsiveForceFunction) {
                                            case "FruchtermanReingold":
                                            case "square":
                                                return (h * h) / i;
                                            case "cubic":
                                                return (h * h * h) / i;
                                            case "Eades":
                                            case "log":
                                                return h / Math.log(i);
                                            case "pow":
                                                return h * Math.pow(2, i);
                                            case "sqrt":
                                                return h / Math.sqrt(i)
                                        }
                                    };
                                    for (var o = 0; o < g; o++) {
                                        var e = b[o];
                                        var c = e.layout.displacement;
                                        var r = e.layout.force;
                                        if (!e.fixed) {
                                            for (var n = 0; n < g; n++) {
                                                if (o != n) {
                                                    var d = b[n];
                                                    var a = d.layout.displacement;
                                                    var x = c.x - a.x;
                                                    var v = c.y - a.y;
                                                    var u = c.z - a.z;
                                                    var q = Math.sqrt((x * x) + (v * v) + (u * u)) + 0.01;
                                                    var p = s(q);
                                                    r.x += x / q * p;
                                                    r.y += v / q * p;
                                                    r.z += u / q * p
                                                }
                                            }
                                        }
                                    }
                                }; this.calculateForceDirectedLayoutAttractiveDisplacement = function(j, a) {
                                    var g = this;
                                    var p = j.length;
                                    var s = Math.sqrt((p * p) / p + 1);
                                    var x = function(i) {
                                        switch (g.attractiveForceFunction) {
                                            case "FruchtermanReingold":
                                            case "square":
                                                return (i * i) / s;
                                            case "cubic":
                                                return (i * i * i) / s;
                                            case "Eades":
                                            case "log":
                                                return i * Math.log(m);
                                            case "pow":
                                                return i * Math.pow(2, s);
                                            case "sqrt":
                                                return i / Math.sqrt(s)
                                        }
                                    };
                                    var p = a.length;
                                    for (var v = 0; v < p; v++) {
                                        var b = a[v];
                                        var u = this.nodes[b.id1];
                                        var q = this.nodes[b.id2];
                                        var r = u.layout.displacement;
                                        var o = q.layout.displacement;
                                        var y = u.layout.force;
                                        var w = q.layout.force;
                                        var e = r.x - o.x;
                                        var d = r.y - o.y;
                                        var c = r.z - o.z;
                                        var h = Math.sqrt((e * e) + (d * d) + (c * c)) + 0.01;
                                        var n = x(h);
                                        if (!u.fixed) {
                                            y.x -= e / h * n;
                                            y.y -= d / h * n;
                                            y.z -= c / h * n
                                        }
                                        if (!q.fixed) {
                                            w.x += e / h * n;
                                            w.y += d / h * n;
                                            w.z += c / h * n
                                        }
                                    }
                                }; this.applyForceDirectedLayoutDisplacement = function(b) {
                                    var s = this;
                                    var e = b.length;
                                    var d = Math.sqrt(e * e) / 10;
                                    var g = Math.sqrt((e * e) / e + 1);
                                    for (var h = 0; h < e; h++) {
                                        var p = b[h].layout.displacement;
                                        var j = b[h].layout.force;
                                        var n = Math.sqrt((p.x * p.x) + (p.y * p.y) + (p.z * p.z));
                                        var a = g * this.networkGravity * n * 0.01;
                                        j.x -= a * p.x / n;
                                        j.y -= a * p.y / n;
                                        j.z -= a * p.z / n;
                                        j.x *= this.networkSpeed;
                                        j.y *= this.networkSpeed;
                                        j.z *= this.networkSpeed;
                                        if (!b[h].fixed) {
                                            var u = j.x;
                                            var r = j.y;
                                            var q = j.z;
                                            var n = Math.sqrt((u * u) + (r * r) + (q * q));
                                            if (n > 0) {
                                                var o = Math.min(d * this.networkSpeed, n);
                                                p.x += u / n * o;
                                                p.y += r / n * o;
                                                p.z += q / n * o
                                            }
                                        }
                                    }
                                    for (var h = 0; h < e; h++) {
                                        var c = b[h];
                                        var p = b[h].layout.displacement;
                                        c.layout.position = {
                                            x: p.x,
                                            y: p.y,
                                            z: p.z
                                        }
                                    }
                                }; this.accumulateForceDirectedLayoutForces = function() {
                                    var c = this.data.nodes;
                                    var b = this.data.edges;
                                    var d = c.length;
                                    if (d) {
                                        var a = this.barnesHutInsertBodies(c);
                                        while (d--) {
                                            var e = c[d];
                                            if (!e.fixed) {
                                                e.layout.force = {
                                                    x: 0,
                                                    y: 0,
                                                    z: 0
                                                };
                                                this.barnesHutUpdateBodyForce(e, a);
                                                this.updateForceDirectedLayoutDragForce(e)
                                            }
                                        }
                                    }
                                    d = b.length;
                                    while (d--) {
                                        this.updateForceDirectedLayoutSpringForce(b[d])
                                    }
                                    this.updateLayoutNodePositions(c)
                                }; this.barnesHutNewNode = function() {
                                    this.barnesHutNodesCache[this.barnesHutNodesCacheCurrent] = {
                                        body: null,
                                        quad0: null,
                                        quad1: null,
                                        quad2: null,
                                        quad3: null,
                                        quad4: null,
                                        quad5: null,
                                        quad6: null,
                                        quad7: null,
                                        mass: 0,
                                        massX: 0,
                                        massY: 0,
                                        left: 0,
                                        top: 0,
                                        bottom: 0,
                                        right: 0,
                                        back: 0,
                                        front: 0
                                    };
                                    var a = this.barnesHutNodesCache[this.barnesHutNodesCacheCurrent];
                                    ++this.barnesHutNodesCacheCurrent;
                                    return a
                                }; this.barnesHutInsertBodies = function(e, q) {
                                    var d = this;
                                    var a = function(Y) {
                                        var U = function(y, x) {
                                            if (x === 0) {
                                                return y.quad0
                                            }
                                            if (x === 1) {
                                                return y.quad1
                                            }
                                            if (x === 2) {
                                                return y.quad2
                                            }
                                            if (x === 3) {
                                                return y.quad3
                                            }
                                            return null
                                        };
                                        var T = function(y, x, z) {
                                            if (x === 0) {
                                                y.quad0 = z
                                            } else {
                                                if (x === 1) {
                                                    y.quad1 = z
                                                } else {
                                                    if (x === 2) {
                                                        y.quad2 = z
                                                    } else {
                                                        if (x === 3) {
                                                            y.quad3 = z
                                                        }
                                                    }
                                                }
                                            }
                                        };
                                        var X = function(ab, aa) {
                                            var z = Math.abs(ab.x - aa.x);
                                            var y = Math.abs(ab.y - aa.y);
                                            var x = Math.abs(ab.z - aa.z);
                                            return (z < 1e-8 && y < 1e-8 && x < 1e-8)
                                        };
                                        var Z = {
                                            stack: [],
                                            popIdx: 0,
                                            isEmpty: function() {
                                                return this.popIdx === 0
                                            },
                                            push: function(y, x) {
                                                this.stack[this.popIdx] = {
                                                    node: y,
                                                    body: x
                                                };
                                                ++this.popIdx
                                            },
                                            pop: function() {
                                                if (this.popIdx > 0) {
                                                    return this.stack[--this.popIdx]
                                                }
                                            },
                                            reset: function() {
                                                this.popIdx = 0
                                            }
                                        };
                                        Z.reset();
                                        Z.push(q, Y);
                                        while (!Z.isEmpty()) {
                                            var B = Z.pop();
                                            var R = B.node;
                                            var N = B.body;
                                            if (!R.body) {
                                                var K = N.layout.position.x;
                                                var I = N.layout.position.y;
                                                var H = N.layout.position.z;
                                                R.mass = R.mass + N.layout.mass;
                                                R.massX = R.massX + N.layout.mass * K;
                                                R.massY = R.massY + N.layout.mass * I;
                                                R.massZ = R.massZ + N.layout.mass * H;
                                                var A = 0;
                                                var C = R.left;
                                                var W = (R.right + C) / 2;
                                                var P = R.top;
                                                var G = (R.bottom + P) / 2;
                                                var Q = R.back;
                                                var F = (R.front - Q) / 2;
                                                if (this.is3DNetwork) {
                                                    if (K > W) {
                                                        A = A + 1;
                                                        var S = C;
                                                        C = W;
                                                        W = W + (W - S)
                                                    }
                                                    if (I > G) {
                                                        A = A + 2;
                                                        var i = P;
                                                        P = G;
                                                        G = G + (G - i)
                                                    }
                                                    if (H > F) {
                                                        A = A + 4;
                                                        var w = Q;
                                                        Q = F;
                                                        F = Q + (Q - w)
                                                    }
                                                } else {
                                                    if (K > W) {
                                                        A = A + 1;
                                                        C = W;
                                                        W = R.right
                                                    }
                                                    if (I > G) {
                                                        A = A + 2;
                                                        P = G;
                                                        G = R.bottom
                                                    }
                                                }
                                                var E = U(R, A);
                                                if (!E) {
                                                    E = d.barnesHutNewNode();
                                                    E.left = C;
                                                    E.top = P;
                                                    E.right = W;
                                                    E.bottom = G;
                                                    E.back = Q;
                                                    E.front = F;
                                                    E.body = N;
                                                    T(R, A, E)
                                                } else {
                                                    Z.push(E, N)
                                                }
                                            } else {
                                                var M = R.body;
                                                R.body = null;
                                                if (X(M.layout.position, N.layout.position)) {
                                                    var V = 3;
                                                    while (V > 0 && X(M.layout.position, N.layout.position)) {
                                                        var D = d.random();
                                                        var O = (R.right - R.left) * D;
                                                        var L = (R.bottom - R.top) * D;
                                                        var J = (R.front - R.back) * D;
                                                        M.layout.position.x = R.left + O;
                                                        M.layout.position.y = R.top + L;
                                                        M.layout.position.z = R.back + J;
                                                        V -= 1
                                                    }
                                                    if (V === 0 && X(M.layout.position, N.layout.position)) {
                                                        return
                                                    }
                                                }
                                                Z.push(R, M);
                                                Z.push(R, N)
                                            }
                                        }
                                    };
                                    var v = Number.MAX_VALUE;
                                    var c = Number.MAX_VALUE;
                                    var p = Number.MAX_VALUE;
                                    var u = Number.MIN_VALUE;
                                    var b = Number.MIN_VALUE;
                                    var n = Number.MIN_VALUE;
                                    var s = e.length;
                                    var t = s;
                                    while (t--) {
                                        var k = e[t].layout.position.x;
                                        var h = e[t].layout.position.y;
                                        var g = e[t].layout.position.y;
                                        if (k < v) {
                                            v = k
                                        }
                                        if (k > u) {
                                            u = k
                                        }
                                        if (h < c) {
                                            c = h
                                        }
                                        if (h > b) {
                                            b = h
                                        }
                                        if (g < p) {
                                            p = g
                                        }
                                        if (g > n) {
                                            n = g
                                        }
                                    }
                                    var o = u - v;
                                    var l = b - c;
                                    var j = n - p;
                                    var r = Math.max(o, Math.max(l, j));
                                    if (this.is3DNetwork) {
                                        u = v + r;
                                        b = c + r;
                                        n = p + r
                                    } else {
                                        if (o > l) {
                                            b = c + o
                                        } else {
                                            u = v + l
                                        }
                                    }
                                    this.barnesHutNodesCacheCurrent = 0;
                                    q = this.barnesHutNewNode();
                                    q.left = v;
                                    q.right = u;
                                    q.top = c;
                                    q.bottom = b;
                                    q.back = p;
                                    q.from = n;
                                    t = s - 1;
                                    if (t >= 0) {
                                        q.body = e[t]
                                    }
                                    while (t--) {
                                        a(e[t], q)
                                    }
                                    return q
                                }; this.barnesHutUpdateBodyForce = function(k, n) {
                                    var j = this.barnesHutUpdateQueue;
                                    var o;
                                    var t;
                                    var s;
                                    var q;
                                    var a;
                                    var h = 0;
                                    var d = 0;
                                    var b = 0;
                                    var g = 1;
                                    var l = 0;
                                    var e = 1;
                                    j[0] = n;
                                    while (g) {
                                        var c = j[l];
                                        var i = c.body;
                                        g -= 1;
                                        l += 1;
                                        var p = (i !== k);
                                        if (i && p) {
                                            t = i.layout.position.x - k.layout.position.x;
                                            s = i.layout.position.y - k.layout.position.y;
                                            q = i.layout.position.z - k.layout.position.z;
                                            a = Math.sqrt(t * t + s * s + q * q);
                                            if (a === 0) {
                                                t = (this.random() - 0.5) / 50;
                                                s = (this.random() - 0.5) / 50;
                                                q = (this.random() - 0.5) / 50;
                                                a = Math.sqrt(t * t + s * s + q * q)
                                            }
                                            o = this.networkRepulsion * i.layout.mass * k.layout.mass / (a * a * a);
                                            h += o * t;
                                            d += o * s;
                                            b += o * q
                                        } else {
                                            if (p) {
                                                t = c.massX / c.mass - k.layout.position.x;
                                                s = c.massY / c.mass - k.layout.position.y;
                                                q = c.massZ / c.mass - k.layout.position.z;
                                                a = Math.sqrt(t * t + s * s + q * q);
                                                if (a === 0) {
                                                    t = (this.random() - 0.5) / 50;
                                                    s = (this.random() - 0.5) / 50;
                                                    q = (this.random() - 0.5) / 50;
                                                    a = Math.sqrt(t * t + s * s + q * q)
                                                }
                                                if ((c.right - c.left) / a < this.networkTheta) {
                                                    o = this.networkRepulsion * c.mass * k.layout.mass / (a * a * a);
                                                    h += o * t;
                                                    d += o * s;
                                                    b += o * q
                                                } else {
                                                    if (c.quad0) {
                                                        j[e] = c.quad0;
                                                        g += 1;
                                                        e += 1
                                                    }
                                                    if (c.quad1) {
                                                        j[e] = c.quad1;
                                                        g += 1;
                                                        e += 1
                                                    }
                                                    if (c.quad2) {
                                                        j[e] = c.quad2;
                                                        g += 1;
                                                        e += 1
                                                    }
                                                    if (c.quad3) {
                                                        j[e] = c.quad3;
                                                        g += 1;
                                                        e += 1
                                                    }
                                                    if (this.is3DNetwork) {
                                                        if (c.quad4) {
                                                            j[e] = c.quad4;
                                                            g += 1;
                                                            e += 1
                                                        }
                                                        if (c.quad5) {
                                                            j[e] = c.quad5;
                                                            g += 1;
                                                            e += 1
                                                        }
                                                        if (c.quad6) {
                                                            j[e] = c.quad6;
                                                            g += 1;
                                                            e += 1
                                                        }
                                                        if (c.quad7) {
                                                            j[e] = c.quad7;
                                                            g += 1;
                                                            e += 1
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    k.layout.force.x += h;
                                    k.layout.force.y += d;
                                    k.layout.force.z += b
                                }; this.updateLayoutNodePositions = function(a) {
                                    var b = a.length;
                                    while (b--) {
                                        a[b].x = a[b].layout.position.x;
                                        a[b].y = a[b].layout.position.y;
                                        a[b].z = a[b].layout.position.z
                                    }
                                }; this.updateForceDirectedLayoutSpringForce = function(b) {
                                    var i = this.data.nodes[this.data.nodeIndices[b.id1]];
                                    var h = this.data.nodes[this.data.nodeIndices[b.id2]];
                                    var c = b.layout.length < 0 ? this.networkSpringLength : b.layout.length;
                                    var k = h.layout.position.x - i.layout.position.x;
                                    var j = h.layout.position.y - i.layout.position.y;
                                    var a = Math.sqrt(k * k + j * j);
                                    if (a === 0) {
                                        k = (this.random() - 0.5) / 50;
                                        j = (this.random() - 0.5) / 50;
                                        a = Math.sqrt(k * k + j * j)
                                    }
                                    var g = a - c;
                                    var e = ((!b.layout.coeff || b.layout.coeff < 0) ? this.networkSpringCoeff : b.layout.coeff) * g / a * b.layout.weight;
                                    i.layout.force.x += e * k;
                                    i.layout.force.y += e * j;
                                    h.layout.force.x -= e * k;
                                    h.layout.force.y -= e * j
                                }; this.integrateForceDirectedLayout = function(a) {
                                    var o = 0;
                                    var e = 0;
                                    var n = 0;
                                    var c = 0;
                                    var k = a.length;
                                    if (k === 0) {
                                        return 0
                                    }
                                    for (var d = 0; d < k; ++d) {
                                        var b = a[d];
                                        var g = this.networkTimeStep / b.layout.mass;
                                        b.layout.velocity.x += g * b.layout.force.x;
                                        b.layout.velocity.y += g * b.layout.force.y;
                                        var j = b.layout.velocity.x;
                                        var h = b.layout.velocity.y;
                                        var l = Math.sqrt(j * j + h * h);
                                        if (l > 1) {
                                            b.layout.velocity.x = j / l;
                                            b.layout.velocity.y = h / l
                                        }
                                        o = this.networkTimeStep * b.layout.velocity.x;
                                        n = this.networkTimeStep * b.layout.velocity.y;
                                        b.layout.position.x += o;
                                        b.layout.position.y += n;
                                        e += Math.abs(o);
                                        c += Math.abs(n)
                                    }
                                    return (e * e + c * c) / k
                                }; this.updateForceDirectedLayoutDragForce = function(a) {
                                    a.layout.force.x -= this.networkDragCoeff * a.layout.velocity.x;
                                    a.layout.force.y -= this.networkDragCoeff * a.layout.velocity.y
                                }; this.averageForceDirectedLayoutMovement = function(c) {
                                    var d = c.length;
                                    var b = 0;
                                    var a = 0;
                                    while (d--) {
                                        var g = c[d];
                                        var h = g.layout.position;
                                        var e = g.layout.prevPosition;
                                        b += Math.abs(h.x - e.x);
                                        a += Math.abs(h.y - e.y)
                                    }
                                    return Math.sqrt(b * b + a * a) / c.length
                                }; this.networkBetweenness = function(c, g) {
                                    var l = this;
                                    var k = [];
                                    var h = [];
                                    var d = {};
                                    var n = {};
                                    var p = {};
                                    var o = {};
                                    var a = {};
                                    var b = function(w) {
                                        var z = function(s, i) {
                                            if (n[i] === -1) {
                                                n[i] = n[s] + 1;
                                                k.push(i)
                                            }
                                            if (n[i] === n[s] + 1) {
                                                p[i] += p[s];
                                                d[i].push(s)
                                            }
                                        };
                                        var x = function(B) {
                                            var A = l.nodes[B].layout.edges;
                                            for (var C = 0; C < A.length; C++) {
                                                var D = A[C];
                                                var s = D.id1;
                                                if (B == s) {
                                                    if (z(B, s)) {
                                                        return true
                                                    }
                                                }
                                            }
                                        };
                                        var u = function(B) {
                                            var A = l.nodes[B].layout.edges;
                                            for (var C = 0; C < A.length; C++) {
                                                var D = A[C];
                                                var s = D.id1 == B ? D.id2 : D.id1;
                                                if (z(B, s)) {
                                                    return true
                                                }
                                            }
                                        };
                                        var y = function(i) {
                                            if (g) {
                                                return x(i)
                                            } else {
                                                return u(i)
                                            }
                                        };
                                        for (var t = 0; t < c.length; t++) {
                                            d[c[t].id] = [];
                                            n[c[t].id] = -1;
                                            p[c[t].id] = 0
                                        }
                                        n[w] = 0;
                                        p[w] = 1;
                                        k.push(w);
                                        while (k.length) {
                                            var r = k.shift();
                                            h.push(r);
                                            y(r)
                                        }
                                    };
                                    var q = function() {
                                        for (var x = 0; x < c.length; x++) {
                                            o[c[x].id] = 0
                                        }
                                        while (h.length) {
                                            var r = h.pop();
                                            var t = (1 + o[r]) / p[r];
                                            var u = d[r];
                                            for (var x = 0; x < u.length; ++x) {
                                                var s = u[x];
                                                o[s] += p[s] * t
                                            }
                                            if (r !== e.id) {
                                                a[r] += o[r]
                                            }
                                        }
                                    };
                                    for (var j = 0; j < c.length; j++) {
                                        var e = c[j].layout;
                                        if (!e.metrics) {
                                            e.metrics = {
                                                betweenness: -1,
                                                closeness: -1,
                                                degree: -1,
                                                eccentricity: -1
                                            };
                                            e.edges = this.edgesForNode(this.data.edges, c[j].id)
                                        }
                                        a[c[j].id] = 0
                                    }
                                    for (var j = 0; j < c.length; j++) {
                                        var e = c[j];
                                        b(e.id);
                                        q()
                                    }
                                    for (var j = 0; j < c.length; j++) {
                                        var e = c[j].layout;
                                        e.metrics.betweenness = g ? a[c[j].id] : a[c[j].id] / 2
                                    }
                                }; this.networkCloseness = function(b, e) {
                                    var k = this;
                                    var j = [];
                                    var l = {};
                                    var g = {};
                                    var c;
                                    var a = function(r) {
                                        var w = function(s, i) {
                                            if (l[i] === -1) {
                                                l[i] = l[s] + 1;
                                                j.push(i)
                                            }
                                        };
                                        var t = function(y) {
                                            var x = k.nodes[y].layout.edges;
                                            for (var z = 0; z < x.length; z++) {
                                                var A = x[z];
                                                var s = A.id1;
                                                if (y == s) {
                                                    if (w(y, s)) {
                                                        return true
                                                    }
                                                }
                                            }
                                        };
                                        var q = function(y) {
                                            var x = k.nodes[y].layout.edges;
                                            for (var z = 0; z < x.length; z++) {
                                                var A = x[z];
                                                var s = A.id1 == y ? A.id2 : A.id1;
                                                if (w(y, s)) {
                                                    return true
                                                }
                                            }
                                        };
                                        var u = function(i) {
                                            if (e) {
                                                return t(i)
                                            } else {
                                                return q(i)
                                            }
                                        };
                                        for (var p = 0; p < b.length; p++) {
                                            l[b[p].id] = -1
                                        }
                                        l[r] = 0;
                                        j.push(r);
                                        while (j.length) {
                                            var o = j.shift();
                                            u(o)
                                        }
                                    };
                                    var n = function() {
                                        var o = Object.keys(l).map(function(q) {
                                            return l[q]
                                        }).filter(function(q) {
                                            return q !== -1
                                        });
                                        var p = o.length;
                                        var i = o.reduce(function(r, q) {
                                            return r + q
                                        });
                                        if (i > 0) {
                                            g[c] = (p - 1) / i
                                        } else {
                                            g[c] = 0
                                        }
                                    };
                                    for (var h = 0; h < b.length; h++) {
                                        var d = b[h].layout;
                                        if (!d.metrics) {
                                            d.metrics = {
                                                betweenness: -1,
                                                closeness: -1,
                                                degree: -1,
                                                eccentricity: -1
                                            };
                                            d.edges = this.edgesForNode(this.data.edges, b[h].id)
                                        }
                                        g[b[h].id] = 0
                                    }
                                    for (var h = 0; h < b.length; h++) {
                                        var d = b[h];
                                        c = b[h].id;
                                        a(d.id);
                                        n()
                                    }
                                    for (var h = 0; h < b.length; h++) {
                                        var d = b[h].layout;
                                        d.metrics.closeness = g[b[h].id]
                                    }
                                }; this.networkEccentricity = function(b, g) {
                                    var k = this;
                                    var j = [];
                                    var l = {};
                                    var c = {};
                                    var d;
                                    var a = function(r) {
                                        var w = function(s, i) {
                                            if (l[i] === -1) {
                                                l[i] = l[s] + 1;
                                                j.push(i)
                                            }
                                        };
                                        var t = function(y) {
                                            var x = k.nodes[y].layout.edges;
                                            for (var z = 0; z < x.length; z++) {
                                                var A = x[z];
                                                var s = A.id1;
                                                if (y == s) {
                                                    if (w(y, s)) {
                                                        return true
                                                    }
                                                }
                                            }
                                        };
                                        var q = function(y) {
                                            var x = k.nodes[y].layout.edges;
                                            for (var z = 0; z < x.length; z++) {
                                                var A = x[z];
                                                var s = A.id1 == y ? A.id2 : A.id1;
                                                if (w(y, s)) {
                                                    return true
                                                }
                                            }
                                        };
                                        var u = function(i) {
                                            if (g) {
                                                return t(i)
                                            } else {
                                                return q(i)
                                            }
                                        };
                                        for (var p = 0; p < b.length; p++) {
                                            l[b[p].id] = -1
                                        }
                                        l[r] = 0;
                                        j.push(r);
                                        while (j.length) {
                                            var o = j.shift();
                                            u(o)
                                        }
                                    };
                                    var n = function() {
                                        var i = 0;
                                        Object.keys(l).forEach(function(o) {
                                            var p = l[o];
                                            if (i < p) {
                                                i = p
                                            }
                                        });
                                        c[d] = i
                                    };
                                    for (var h = 0; h < b.length; h++) {
                                        var e = b[h].layout;
                                        if (!e.metrics) {
                                            e.metrics = {
                                                betweenness: -1,
                                                closeness: -1,
                                                degree: -1,
                                                eccentricity: -1
                                            };
                                            e.edges = this.edgesForNode(this.data.edges, b[h].id)
                                        }
                                        c[b[h].id] = 0
                                    }
                                    for (var h = 0; h < b.length; h++) {
                                        var e = b[h];
                                        d = b[h].id;
                                        a(e.id);
                                        n()
                                    }
                                    for (var h = 0; h < b.length; h++) {
                                        var e = b[h].layout;
                                        e.metrics.eccentricity = c[b[h].id]
                                    }
                                }; this.networkDegree = function(b, d) {
                                    for (var c = 0; c < b.length; c++) {
                                        var g = b[c].layout;
                                        var a = g.edges || this.edgesForNode(this.data.edges, b[c].id);
                                        var e = 0;
                                        switch (d) {
                                            case "in":
                                                for (var c = 0; c < a.length; c++) {
                                                    e += (a[c].id1 == b[c].id) ? 1 : 0
                                                }
                                                break;
                                            case "out":
                                                for (var c = 0; c < a.length; c++) {
                                                    e += (a[c].id2 == b[c].id) ? 1 : 0
                                                }
                                                break;
                                            default:
                                                e = a.length
                                        }
                                        g.metrics.degree = e
                                    }
                                }; this.exposeNetworkMetrics = function() {
                                    for (var a = 0; a < this.data.nodes.length; a++) {
                                        var b = this.data.nodes[a];
                                        if (b.layout) {
                                            b.betweenness = b.layout.metrics.betweenness;
                                            b.closeness = b.layout.metrics.closeness;
                                            b.degree = b.layout.metrics.degree;
                                            b.eccentricity = b.layout.metrics.eccentricity
                                        }
                                    }
                                }; this.updateForceDirectedLayoutBoundingBox = function(q, h, y, c, w, a) {
                                    var A = Number.MAX_VALUE;
                                    var d = Number.MAX_VALUE;
                                    var z = Number.MIN_VALUE;
                                    var b = Number.MIN_VALUE;
                                    var v, u, t, s;
                                    var x = q.length;
                                    if (x === 0) {
                                        return
                                    }
                                    while (x--) {
                                        var r = q[x];
                                        if (!r.hide) {
                                            if (r.fixed) {
                                                r.layout.position.x = r.layout.prevPosition.x;
                                                r.layout.position.y = r.layout.prevPosition.y
                                            } else {
                                                r.layout.prevPosition.x = r.layout.position.x;
                                                r.layout.prevPosition.y = r.layout.position.y
                                            }
                                            if (r.layout.position.x < A) {
                                                A = r.layout.position.x;
                                                v = r
                                            }
                                            if (r.layout.position.x > z) {
                                                z = r.layout.position.x;
                                                u = r
                                            }
                                            if (r.layout.position.y < d) {
                                                d = r.layout.position.y;
                                                t = r
                                            }
                                            if (r.layout.position.y > b) {
                                                b = r.layout.position.y;
                                                s = r
                                            }
                                        }
                                    }
                                    h.x1 = A;
                                    h.x2 = z;
                                    h.y1 = d;
                                    h.y2 = b;
                                    return;
                                    var C = v.width ? v.width : v.size ? (this.nodeSize * v.size * this.scaleFactorX) : this.nodeSize * this.scaleFactorX;
                                    var B = u.width ? u.width : u.size ? (this.nodeSize * u.size * this.scaleFactorX) : this.nodeSize * this.scaleFactorX;
                                    var g = t.height ? t.height : t.size ? (this.nodeSize * t.size * this.scaleFactorY) : this.nodeSize * this.scaleFactorY;
                                    var e = s.height ? s.height : s.size ? (this.nodeSize * s.size * this.scaleFactorY) : this.nodeSize * this.scaleFactorY;
                                    if (!y) {
                                        y = this.left
                                    }
                                    if (!w) {
                                        w = this.left + this.x
                                    }
                                    if (!c) {
                                        c = this.top
                                    }
                                    if (!a) {
                                        a = this.top + this.y
                                    }
                                    C = A - (C / 2);
                                    B = z + (B / 2);
                                    g = d - (g / 2);
                                    e = b + (e / 2);
                                    var k = w - y;
                                    var j = a - c;
                                    var n = B - C;
                                    var l = e - g;
                                    var p = k / n;
                                    var o = j / l;
                                    var x = q.length;
                                    while (x--) {
                                        var r = q[x];
                                        if (!r.hide) {
                                            r.layout.position.x = (r.layout.position.x - C) * p;
                                            r.layout.position.y = (r.layout.position.y - g) * o
                                        }
                                        if (r.fixed) {
                                            r.layout.position.x = r.layout.prevPosition.x;
                                            r.layout.position.y = r.layout.prevPosition.y
                                        } else {
                                            r.layout.prevPosition.x = r.layout.position.x;
                                            r.layout.prevPosition.y = r.layout.position.y
                                        }
                                    }
                                    h.x1 = y;
                                    h.x2 = w;
                                    h.y1 = c;
                                    h.y2 = a
                                }
                            };
                            CanvasXpress.prototype.initLayout = function() {
                                this.isLayoutComb = function() {
                                    return (this.scatterPlotMatrix || this.isDOE || (this.graphType == "Pie" && !this.isDOE && this.xAxis.length > 1) || (this.graphType != "Circular" && (this.segregateVariablesBy.length || this.segregateSamplesBy.length))) ? true : false
                                };
                                this.isValidLayout = function() {
                                    var b = this.layoutTopology ? this.layoutTopology.split(/X/i) : this.layout.split(/X/i);
                                    if (this.layoutTopology) {
                                        this.layoutRows = b[0];
                                        this.layoutCols = b[1]
                                    } else {
                                        if (this.layout) {
                                            this.layoutRows = b[0];
                                            this.layoutCols = b[1]
                                        } else {
                                            this.layoutRows = 1;
                                            this.layoutCols = 1;
                                            this.layoutValid = false
                                        }
                                    }
                                    if (!this.scatterPlotMatrix && this.layoutComb && this.data.l && (this.data.l.vars || this.data.l.smps) && this.data.l.weight && this.data.l.type) {
                                        this.data.l.comp = [];
                                        if (this.data.l.vars && this.data.l.smps) {
                                            var q = {};
                                            for (var o = 0; o < this.data.y.vars.length; o++) {
                                                if (!q[this.data.y.vars[o]]) {
                                                    q[this.data.y.vars[o]] = []
                                                }
                                                q[this.data.y.vars[o]].push(o)
                                            }
                                            var t = {};
                                            for (var o = 0; o < this.data.y.smps.length; o++) {
                                                if (!t[this.data.y.smps[o]]) {
                                                    t[this.data.y.smps[o]] = []
                                                }
                                                t[this.data.y.smps[o]].push(o)
                                            }
                                            var s = 0;
                                            var p = this.layoutTypeVariablesFirst;
                                            if (this.layoutType == "wrap" || (this.layoutType == "cols" && p) || this.layoutType == "rows" && !p) {
                                                for (var o = 0; o < this.data.l.smps.length; o++) {
                                                    var f = [];
                                                    var e = this.data.l.smps[o].length;
                                                    for (var m = 0; m < e; m++) {
                                                        for (var h = 0; h < t[this.data.l.smps[o][m]].length; h++) {
                                                            f.push(t[this.data.l.smps[o][m]][h])
                                                        }
                                                    }
                                                    for (var m = 0; m < this.data.l.vars.length; m++) {
                                                        var d = [];
                                                        var e = this.data.l.vars[m].length;
                                                        for (var h = 0; h < e; h++) {
                                                            for (var g = 0; g < q[this.data.l.vars[m][h]].length; g++) {
                                                                d.push(q[this.data.l.vars[m][h]][g])
                                                            }
                                                        }
                                                        this.data.l.comp[s] = [d, f];
                                                        s++
                                                    }
                                                }
                                            } else {
                                                for (var o = 0; o < this.data.l.vars.length; o++) {
                                                    var d = [];
                                                    var e = this.data.l.vars[o].length;
                                                    for (var m = 0; m < e; m++) {
                                                        for (var h = 0; h < q[this.data.l.vars[o][m]].length; h++) {
                                                            d.push(q[this.data.l.vars[o][m]][h])
                                                        }
                                                    }
                                                    for (var m = 0; m < this.data.l.smps.length; m++) {
                                                        var f = [];
                                                        var e = this.data.l.smps[m].length;
                                                        for (var h = 0; h < e; h++) {
                                                            for (var g = 0; g < t[this.data.l.smps[m][h]].length; g++) {
                                                                f.push(t[this.data.l.smps[m][h]][g])
                                                            }
                                                        }
                                                        this.data.l.comp[s] = [d, f];
                                                        s++
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.data.l.vars) {
                                                if (this.isUnique(this.data.y.smps)) {
                                                    var a = {};
                                                    var u = this.isHistogram ? "smps" : "vars";
                                                    for (var o = 0; o < this.data.y[u].length; o++) {
                                                        if (!a[this.data.y[u][o]]) {
                                                            a[this.data.y[u][o]] = []
                                                        }
                                                        a[this.data.y[u][o]].push(o)
                                                    }
                                                    for (var o = 0; o < this.data.l.vars.length; o++) {
                                                        this.data.l.comp[o] = [];
                                                        var e = this.data.l.vars[o].length;
                                                        for (var m = 0; m < e; m++) {
                                                            if (!this.isDOE && this.data.l.vars[o][m]) {
                                                                for (var h = 0; h < a[this.data.l.vars[o][m]].length; h++) {
                                                                    this.data.l.comp[o].push(a[this.data.l.vars[o][m]][h])
                                                                }
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    for (var o = 0; o < this.data.l.ids.length; o++) {
                                                        this.data.l.comp[o] = [];
                                                        var e = this.data.l.ids[o].length;
                                                        var a = {};
                                                        for (var m = 0; m < this.data.l.ids[o].length; m++) {
                                                            if (!a[this.data.y.vars[this.data.l.ids[o][m]]]) {
                                                                a[this.data.y.vars[this.data.l.ids[o][m]]] = []
                                                            }
                                                            a[this.data.y.vars[this.data.l.ids[o][m]]].push(this.data.l.ids[o][m])
                                                        }
                                                        for (var m = 0; m < e; m++) {
                                                            if (!this.isDOE) {
                                                                for (var h = 0; h < a[this.data.y.vars[this.data.l.ids[o][m]]].length; h++) {
                                                                    this.data.l.comp[o].push(a[this.data.y.vars[this.data.l.ids[o][m]]][h])
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (this.isUnique(this.data.y.smps)) {
                                                    var a = {};
                                                    for (var o = 0; o < this.data.y.smps.length; o++) {
                                                        if (!a[this.data.y.smps[o]]) {
                                                            a[this.data.y.smps[o]] = []
                                                        }
                                                        a[this.data.y.smps[o]].push(o)
                                                    }
                                                    for (var o = 0; o < this.data.l.smps.length; o++) {
                                                        this.data.l.comp[o] = [];
                                                        var e = this.data.l.smps[o].length;
                                                        for (var m = 0; m < e; m++) {
                                                            if (!this.isDOE) {
                                                                for (var h = 0; h < a[this.data.l.smps[o][m]].length; h++) {
                                                                    this.data.l.comp[o].push(a[this.data.l.smps[o][m]][h])
                                                                }
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    for (var o = 0; o < this.data.l.ids.length; o++) {
                                                        this.data.l.comp[o] = [];
                                                        var e = this.data.l.ids[o].length;
                                                        var a = {};
                                                        for (var m = 0; m < this.data.l.ids[o].length; m++) {
                                                            if (!a[this.data.y.smps[this.data.l.ids[o][m]]]) {
                                                                a[this.data.y.smps[this.data.l.ids[o][m]]] = []
                                                            }
                                                            a[this.data.y.smps[this.data.l.ids[o][m]]].push(this.data.l.ids[o][m])
                                                        }
                                                        for (var m = 0; m < e; m++) {
                                                            if (!this.isDOE) {
                                                                for (var h = 0; h < a[this.data.y.smps[this.data.l.ids[o][m]]].length; h++) {
                                                                    this.data.l.comp[o].push(a[this.data.y.smps[this.data.l.ids[o][m]]][h])
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.layoutValid = true
                                    } else {
                                        if (this.layoutComb && this.data.l && this.data.l.smps && this.data.l.weight && this.data.l.type) {
                                            this.data.l.comp = [];
                                            var r = [];
                                            for (var o = 0; o < this.data.y.vars.length; o++) {
                                                r.push(o)
                                            }
                                            for (var o = 0; o < this.data.l.type.length; o++) {
                                                this.data.l.comp[o] = r
                                            }
                                            this.layoutValid = true
                                        } else {
                                            if (this.data.l && this.data.l.comp) {
                                                if (this.data.l.comp.length <= (this.layoutRows * this.layoutCols)) {
                                                    this.layoutValid = true
                                                } else {
                                                    this.layoutValid = false
                                                }
                                            } else {
                                                this.layoutValid = false
                                            }
                                        }
                                    }
                                    if (this.layoutValid) {
                                        this.meta.config.orig.adjustAspectRatio = this.adjustAspectRatio;
                                        this.adjustAspectRatio = true;
                                        this.layoutComb = true
                                    }
                                };
                                this.validateLayoutTopology = function() {
                                    var a = this.layoutTopology ? this.layoutTopology.split(/X/i) : this.layout.split(/X/i);
                                    if (this.layoutTopology) {
                                        if (this.layoutRows == a[0] && this.layoutCols == a[1]) {
                                            return
                                        }
                                    } else {
                                        if (this.layout) {
                                            if (this.layoutRows == a[0] && this.layoutCols == a[1]) {
                                                return
                                            }
                                        }
                                    }
                                    this.isValidLayout();
                                    var e = 1 / this.layoutCols;
                                    var d = 1 / this.layoutRows;
                                    for (var b = 0; b < this.data.l.comp.length; b++) {
                                        this.data.l.weight[b] = [e, d]
                                    }
                                };
                                this.setLayoutFonts = function() {
                                    this.setLegends();
                                    if (this.graphType.match(/Scatter/)) {
                                        this.set2DFont()
                                    } else {
                                        if (this.graphType == "Pie") {
                                            this.setPieFont()
                                        } else {
                                            this.set1DFont()
                                        }
                                    }
                                };
                                this.getLayoutAxisTitleHeight = function(a) {
                                    var b = 0;
                                    if (this.graphType == "Treemap" || this.graphType == "TagCloud" || this.graphType == "Pie" || this.graphType == "Heatmap") {
                                        return 0
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (a) {
                                                return this.yAxisTitle ? this.axisTitleFontSize + (this.margin * 2) : 0
                                            } else {
                                                return this.xAxisTitle ? this.axisTitleFontSize + (this.margin * 2) : 0
                                            }
                                        } else {
                                            if (this.graphOrientation == "vertical") {
                                                b = a ? this.getAxisDescription(true) : this.getAxisDescription();
                                                b = b != "" ? this.axisTitleFontSize + (this.margin * 2) : 0
                                            } else {
                                                b = a ? this.getAxisDescription(true) : this.getAxisDescription();
                                                b = b != "" ? this.axisTitleFontSize + (this.margin * 2) : 0
                                            }
                                        }
                                    }
                                    return b
                                };
                                this.setLayoutSameSamples = function() {
                                    var f = [];
                                    if (this.data.l.group && this.data.l.smps) {
                                        for (var d = 0; d < this.data.l.smps.length; d++) {
                                            var a = {};
                                            for (var c = 0; c < this.data.l.ids[d].length; c++) {
                                                var k = this.data.l.ids[d][c];
                                                var l = [];
                                                for (var b = 0; b < this.data.l.group.length; b++) {
                                                    var e = this.data.l.group[b];
                                                    var g = this.getMetadataValue(k, "x", e, true);
                                                    if (g == null) {
                                                        g = "NA"
                                                    }
                                                    l.push(g)
                                                }
                                                l = l.sort();
                                                a[l.join("")] = true
                                            }
                                            f.push(Object.keys(a).sort())
                                        }
                                        for (var c = 1; c < f.length; c++) {
                                            if (!this.isSameObject(f[c - 1], f[c])) {
                                                this.layoutSameSamples = false;
                                                return
                                            }
                                        }
                                        this.layoutSameSamples = true
                                    } else {
                                        this.layoutSameSamples = false
                                    }
                                };
                                this.setLayoutLeft = function() {
                                    var a = 0;
                                    if (this.isDOE) {
                                        a = 0
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.showLegend) {
                                                a += this.legendPosition == "left" ? this.legendWidth : this.margin
                                            }
                                            if (!this.layoutAdjust || this.layoutAdjust == "axis" || this.scatterPlotMatrixType.match(/correlation|all/)) {
                                                a += this.get2DYAxisWidth()
                                            } else {
                                                a += this.getLayoutAxisTitleHeight()
                                            }
                                        } else {
                                            if (this.graphType == "Pie") {
                                                a = (this.margin * 2) + this.measureText("XX", this.smpLabelFont)
                                            } else {
                                                if (this.graphType == "Heatmap") {
                                                    a = 0
                                                } else {
                                                    if (!this.layoutAdjust) {
                                                        if (this.segregateVariablesBy.length > 0) {
                                                            if (this.graphOrientation != "vertical") {
                                                                a = this.getSampleLabelLength()
                                                            } else {
                                                                a = this.getAxisTitleTickLength()
                                                            }
                                                        } else {
                                                            if (this.segregateSamplesBy.length > 0) {
                                                                if (this.graphOrientation == "vertical") {
                                                                    a = this.getAxisTitleTickLength()
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (this.graphOrientation != "vertical") {
                                                            if (this.segregateVariablesBy.length) {
                                                                a = this.getSampleLabelLength()
                                                            } else {
                                                                if (this.segregateSamplesBy.length && !this.layout.match(/X1/)) {
                                                                    this.setLayoutSameSamples();
                                                                    if (this.layoutSameSamples) {
                                                                        a = this.getSampleLabelLength()
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    if (this.graphOrientation == "vertical") {
                                                        a += this.getLayoutAxisTitleHeight()
                                                    } else {
                                                        a += this.smpTitle ? this.smpTitleFontSize + (this.margin * 2) : 0
                                                    }
                                                    if (this.showLegend) {
                                                        a += this.legendPosition == "left" ? this.legendWidth : this.margin
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.setLayoutRight = function() {
                                    var a = 0;
                                    var b = this.layoutType == "rows" || (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1);
                                    if (this.isDOE) {
                                        a = 0
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.showLegend) {
                                                a = this.legendPosition == "right" && this.legendWidth ? this.legendWidth + (this.margin * 2) : this.margin
                                            }
                                            if (this.scatterPlotMatrix && this.showScatterPlotMatrixLabels && this.scatterPlotMatrixType != "first") {
                                                a += this.layoutLabelBoxThickness
                                            } else {
                                                if (this.layoutType == "rows" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 0) {
                                                    a += this.get2DYAxisWidth(true);
                                                    a += this.layoutLabelBoxThickness
                                                } else {
                                                    if (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1) {
                                                        a += this.get2DYAxisWidth(true);
                                                        a += this.layoutLabelBoxThickness
                                                    } else {
                                                        if (this.layoutType == "wrap") {
                                                            a += this.get2DYAxisWidth(true)
                                                        } else {
                                                            if (!this.layoutAdjust) {
                                                                a += this.get2DYAxisWidth(true)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.graphType == "Pie") {
                                                if (this.showLegend && this.legendPosition == "right") {
                                                    a = this.legendVariableWidth
                                                }
                                            } else {
                                                if (this.graphType == "Heatmap") {
                                                    if (this.layoutType == "rows" || (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1)) {
                                                        a += this.layoutLabelBoxThickness
                                                    } else {
                                                        return 0
                                                    }
                                                } else {
                                                    if (!this.layoutAdjust) {
                                                        if (this.graphOrientation == "vertical" && !b) {
                                                            a = this.getAxisTitleTickLength(true)
                                                        }
                                                    } else {
                                                        a = 0
                                                    }
                                                    if (this.graphOrientation == "vertical" && !b) {
                                                        a += this.getLayoutAxisTitleHeight(true)
                                                    }
                                                    if (this.showLegend && this.legendPosition == "right") {
                                                        a += this.getLegendWidth("right");
                                                        if (this.graphOrientation != "vertical") {
                                                            a += this.margin
                                                        }
                                                    }
                                                    if (b) {
                                                        a += this.layoutLabelBoxThickness
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.setLayoutTop = function() {
                                    if (this.isDOE) {
                                        return 0
                                    }
                                    var a = this.getTitleSubtitleHeight();
                                    var b = this.layoutType == "cols" || (this.layoutType == "rows" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1);
                                    if (this.graphType == "Pie") {
                                        a += this.layoutLabelBoxThickness
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.showLegend && this.legendPosition == "top") {
                                                a += this.legendHeight
                                            }
                                            if (this.scatterPlotMatrix && this.showScatterPlotMatrixLabels && this.scatterPlotMatrixType != "first") {
                                                a += this.layoutLabelBoxThickness
                                            } else {
                                                if (this.layoutType == "rows" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1) {
                                                    a += this.get2DXAxisHeight(true);
                                                    a += this.layoutLabelBoxThickness
                                                } else {
                                                    if (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 0) {
                                                        a += this.get2DXAxisHeight(true);
                                                        a += this.layoutLabelBoxThickness
                                                    } else {
                                                        if (this.layoutType == "wrap") {
                                                            a += this.get2DXAxisHeight(true)
                                                        } else {
                                                            if (!this.layoutAdjust) {
                                                                a += this.get2DXAxisHeight(true)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.graphType != "Heatmap") {
                                                if (this.showLegend && this.legendPosition == "top") {
                                                    a += this.legendHeight
                                                }
                                                if (!this.layoutAdjust) {
                                                    if (this.graphOrientation != "vertical" && !b) {
                                                        a += this.getAxisTitleTickLength()
                                                    }
                                                }
                                                if (this.graphOrientation != "vertical" && !b) {
                                                    a += this.getLayoutAxisTitleHeight()
                                                }
                                            }
                                            if (b) {
                                                a += this.layoutLabelBoxThickness
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.setLayoutBottom = function() {
                                    var a = 0;
                                    if (this.isDOE) {
                                        a = 0
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (!this.layoutAdjust || this.layoutAdjust == "axis" || this.scatterPlotMatrixType.match(/correlation|all/)) {
                                                a = this.get2DXAxisHeight()
                                            } else {
                                                a += this.getLayoutAxisTitleHeight()
                                            }
                                            if (this.showLegend && this.legendPosition == "bottom") {
                                                a += this.legendHeight
                                            }
                                        } else {
                                            if (this.graphType == "Pie") {
                                                if (this.showLegend && this.legendPosition == "bottom") {}
                                            } else {
                                                if (this.graphType == "Heatmap") {
                                                    a = this.getHeatmapIndicatorHeight()
                                                } else {
                                                    if (!this.layoutAdjust) {
                                                        if (this.graphOrientation != "vertical") {
                                                            a = this.getAxisTitleTickLength(true)
                                                        }
                                                    }
                                                    if (this.graphOrientation == "vertical") {
                                                        if (this.segregateVariablesBy.length > 0) {
                                                            a = this.getSampleLabelLength()
                                                        } else {
                                                            if (this.segregateSamplesBy.length && !this.layout.match(/1X/)) {
                                                                this.setLayoutSameSamples();
                                                                if (this.layoutSameSamples) {
                                                                    a = this.getSampleLabelLength()
                                                                }
                                                            }
                                                        }
                                                        a += this.smpTitle ? this.smpTitleFontSize + (this.margin * 2) : 0
                                                    } else {
                                                        a += this.getLayoutAxisTitleHeight(this.layoutType == "cols" ? false : true);
                                                        if (this.layoutType == "rows" && this.isGroupedData) {
                                                            a += this.axisTitleFontSize
                                                        }
                                                    }
                                                    if (this.showLegend && this.legendPosition == "bottom") {
                                                        a += this.getLegendHeight("bottom")
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    a += this.getCitationHeight();
                                    return a
                                };
                                this.drawLayoutSampleOverlays = function(b) {
                                    var a = this.smpIndices;
                                    this.smpIndices = b;
                                    this.smpIndices = a;
                                    this.showSampleNames = true;
                                    this.showOverlays = true;
                                    this.draw1DYLayout()
                                };
                                this.setLayoutDimensions = function() {
                                    this.offsetX = 0;
                                    this.offsetY = 0;
                                    this.layoutLeft = this.setLayoutLeft();
                                    this.layoutRight = this.setLayoutRight();
                                    this.layoutTop = this.setLayoutTop();
                                    this.layoutBottom = this.setLayoutBottom();
                                    if (this.layoutCanvasCompartments) {
                                        var a = this.width - (this.marginLeft + this.layoutLeft + this.marginRight + this.layoutRight);
                                        var b = this.height - (this.marginTop + this.layoutTop + this.marginBottom + this.layoutBottom);
                                        this.toRender({
                                            p: ["drawShape", "rectangle", this.marginLeft + this.layoutLeft + (a / 2), this.marginTop + this.layoutTop + (b / 2), a, b, false, this.canvasBoxColor, "open"],
                                            t: "Size"
                                        })
                                    }
                                };
                                this.setLayoutLegends = function() {
                                    var a = this.isGroupedData;
                                    this.isGroupedData = false;
                                    this.setLayoutFonts();
                                    if (this.graphType == "Pie" || this.isDOE) {
                                        this.setVariableLegendDimension()
                                    } else {
                                        if (this.graphType.match(/Scatter/) || this.isMultidimensionalData || ((this.isAttributedGraph() || this.connectBy) && this.graphType.match(/^Bar$|Boxplot|Dotplot|Treemap|Heatmap/))) {
                                            this.validatePropertyValues(true);
                                            if (this.isHistogram) {
                                                this.setSampleLegendDimension()
                                            }
                                        } else {
                                            this.setVariableLegendDimension()
                                        }
                                    }
                                    this.isGroupedData = a
                                };
                                this.drawLabelsTitlesLayout = function() {
                                    var k = 0;
                                    var f = 0;
                                    var q = 0;
                                    var C = 0;
                                    var D = this.width - (this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight);
                                    var b = this.height - (this.marginTop + this.layoutTop + this.layoutBottom + this.marginBottom);
                                    if (this.graphType == "Treemap") {
                                        return
                                    }
                                    if (this.graphType == "Pie" && (this.showPieGrid || this.showPieSampleLabel)) {
                                        var z, m;
                                        var A = 0;
                                        this.setMainFont();
                                        var s = this.getFontPt(this.font);
                                        var d = this.marginTop;
                                        var a = this.marginLeft + this.layoutLeft;
                                        var n = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];
                                        for (var v = 0; v < this.layoutRows; v++) {
                                            z = b * this.layoutParams[A].weight[1];
                                            k = (this.marginLeft + this.layoutLeft) - this.margin;
                                            d += z;
                                            if (this.showPieGrid) {
                                                this.toRender({
                                                    p: ["drawText", n[v], k, d - ((z / 2) + (this.margin * 0)), this.font, this.foreground, "right", "middle"],
                                                    t: "LabelsTitle"
                                                })
                                            }
                                            for (var u = 0; u < this.layoutCols; u++) {
                                                if (this.xAxis.length <= A) {
                                                    break
                                                }
                                                m = D * this.layoutParams[A].weight[0];
                                                a += m;
                                                f = (this.marginTop + this.layoutTop) - (this.layoutLabelBoxThickness / 2);
                                                if (v == 0) {
                                                    if (this.showPieGrid) {
                                                        this.toRender({
                                                            p: ["drawText", u + 1, (a + (s / 2)) - (m / 2), f, this.font, this.foreground, "center", "bottom"],
                                                            t: "LabelsTitle"
                                                        })
                                                    }
                                                }
                                                if (this.showPieSampleLabel) {
                                                    this.toRender({
                                                        p: ["drawText", this.xAxis[A], a - (m / 1.1), d - (z / 5), this.legendFont, this.foreground, "center", "middle"],
                                                        t: "LabelsTitle"
                                                    })
                                                }
                                                A++
                                            }
                                            a = this.marginLeft + this.layoutLeft
                                        }
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.yAxisTitle) {
                                                var B = ((this.height - (this.marginTop + this.layoutTop + this.marginBottom + this.layoutBottom)) / 2) + (this.marginTop + this.layoutTop);
                                                var o = this.marginLeft + this.margin + (this.axisTitleFontSize / 2) + ((this.showLegend && this.legendPosition == "left" ? this.legendWidth : 0) - this.margin);
                                                this.toRender({
                                                    p: ["drawText", this.yAxisTitle, o, B, this.axisTitleFont, this.axisTitleFontColor, "center", "middle", -Math.PI / 2],
                                                    t: "LabelsTitle"
                                                })
                                            }
                                            if (this.xAxisTitle) {
                                                var t = 0;
                                                var m = this.width - (this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight);
                                                var z = this.marginBottom + this.margin + (this.axisTitleFontSize / 2) + t + (this.showLegend && this.legendPosition == "bottom" ? this.legendHeight : 0);
                                                this.toRender({
                                                    p: ["drawText", this.xAxisTitle, this.marginLeft + this.layoutLeft + (m / 2), this.height - z, this.axisTitleFont, this.axisTitleFontColor, "center", "middle"],
                                                    t: "LabelsTitle"
                                                })
                                            }
                                            if (this.zAxisTitle) {
                                                var B = ((this.height - (this.marginTop + this.layoutTop + this.marginBottom + this.layoutBottom)) / 2) + (this.marginTop + this.layoutTop);
                                                var o = this.width - ((this.axisTitleFontSize / 2) + ((this.showLegend && this.legendPosition == "right" ? this.legendWidth : 0) + (this.margin * 2)));
                                                this.toRender({
                                                    p: ["drawText", "Size : " + this.zAxisTitle, o, B, this.axisTitleFont, this.axisTitleFontColor, "center", "middle", Math.PI / 2],
                                                    t: "LabelsTitle"
                                                })
                                            }
                                        } else {
                                            if (this.graphType == "Heatmap") {
                                                this.draw1DXLayout()
                                            }
                                            if (this.smpTitle && this.graphType != "Heatmap") {
                                                if (this.graphOrientation == "vertical") {
                                                    var t = this.legendPosition == "bottom" ? this.legendHeight : 0;
                                                    var m = this.width - (this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight);
                                                    var z = this.marginBottom + this.margin + (this.smpTitleFontSize / 2) + t;
                                                    this.toRender({
                                                        p: ["drawText", this.smpTitle, this.marginLeft + this.layoutLeft + (m / 2), this.height - z, this.smpTitleFont, this.smpTitleFontColor, "center", "middle"],
                                                        t: "LabelsTitle"
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", this.smpTitle, this.marginLeft + this.margin + (this.smpTitleFontSize / 2), this.height / 2, this.smpTitleFont, this.smpTitleFontColor, "center", "middle", -Math.PI / 2],
                                                        t: "LabelsTitle"
                                                    })
                                                }
                                            }
                                            var g = this.getAxisDescription();
                                            var e = this.getAxisDescription(true, this.layoutType == "rows" && this.isGroupedData);
                                            if (g != "" && this.graphType != "Heatmap" && this.xAxisShow && this.layoutType != "rows") {
                                                if (this.graphOrientation == "vertical") {
                                                    var o = this.marginLeft + this.margin + (this.axisTitleFontSize / 2) + (this.showLegend && this.legendPosition == "left" ? this.legendWidth : 0);
                                                    var B = ((this.height - this.layoutTop) / 2) + this.layoutTop;
                                                    this.toRender({
                                                        p: ["drawText", g, o, B, this.axisTitleFont, this.axisTitleFontColor, "center", "middle", -Math.PI / 2],
                                                        t: "LabelsTitle"
                                                    })
                                                } else {
                                                    var m = this.width - (this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight);
                                                    var z;
                                                    if (this.layoutType == "cols") {
                                                        z = this.marginTop + this.layoutTop + this.layoutHeight + this.getTitleSubtitleHeight()
                                                    } else {
                                                        z = this.margin + (this.axisTitleFontSize / 2) + this.getTitleSubtitleHeight() + (this.showLegend && this.legendPosition == "top" ? this.legendHeight : 0)
                                                    }
                                                    this.toRender({
                                                        p: ["drawText", g, this.marginLeft + this.layoutLeft + (m / 2), this.marginTop + z, this.axisTitleFont, this.axisTitleFontColor, "center", "middle"],
                                                        t: "LabelsTitle"
                                                    })
                                                }
                                            }
                                            if ((e != "" && this.graphType != "Heatmap" && this.xAxis2Show) || (this.layoutType == "rows" && this.isGroupedData)) {
                                                if (this.graphOrientation == "vertical") {
                                                    var t = this.legendPosition == "right" ? this.legendWidth : 0;
                                                    var p = this.marginRight + this.margin + (this.axisTitleFontSize / 2) + t;
                                                    this.toRender({
                                                        p: ["drawText", e, this.width - p, this.height / 2, this.axisTitleFont, this.axisTitleFontColor, "center", "middle", Math.PI / 2],
                                                        t: "LabelsTitle"
                                                    })
                                                } else {
                                                    var t = this.legendPosition == "bottom" ? this.legendHeight : 0;
                                                    var m = this.width - (this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight);
                                                    var z = this.marginBottom + this.margin + (this.axisTitleFontSize / 2) + t;
                                                    this.toRender({
                                                        p: ["drawText", e, this.marginLeft + this.layoutLeft + (m / 2), this.height - z, this.axisTitleFont, this.axisTitleFontColor, "center", "middle"],
                                                        t: "LabelsTitle"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawDOELabelsLayout = function(m) {
                                    var g = this.foreground;
                                    var j = this.font;
                                    var e = this.measureText(m, j);
                                    var b = this.getFontPt(j) / 2;
                                    var l = this.layoutWidth;
                                    var d = this.layoutHeight;
                                    var k = this.marginLeft + this.offsetX;
                                    var i = this.marginTop + this.offsetY;
                                    var a = k + l - 5;
                                    var c = i + d - 5;
                                    this.toRender({
                                        p: ["drawText", m, k + 20, i, j, g, "left", "top"],
                                        t: "Labels"
                                    });
                                    this.toRender({
                                        p: ["drawLine", "line", k + b, i + b, k + 15, i + b, g],
                                        t: "Labels"
                                    });
                                    this.toRender({
                                        p: ["drawLine", "line", k + e + 25, i + b, a, i + b, g],
                                        t: "Labels"
                                    });
                                    this.toRender({
                                        p: ["drawLine", "line", a, i + b, a, c, g],
                                        t: "Labels"
                                    });
                                    this.toRender({
                                        p: ["drawLine", "line", k + b, c, a, c, g],
                                        t: "Labels"
                                    });
                                    this.toRender({
                                        p: ["drawLine", "line", k + b, i + b, k + b, c, g],
                                        t: "Labels"
                                    })
                                };
                                this.setLayoutWeights = function() {
                                    var a = this.data.l.weight;
                                    var d = this.layoutParams;
                                    var e = this.data.l.comp;
                                    if (a) {
                                        if (this.isDOE || this.scatterPlotMatrix || (this.data.l.vars && this.data.l.smps)) {
                                            for (var b = 0; b < a.length; b++) {
                                                d[b].weight = a[b]
                                            }
                                        } else {
                                            if (this.graphType == "Pie") {
                                                for (var b = 0; b < e.length; b++) {
                                                    d[b].weight = a[b]
                                                }
                                            } else {
                                                for (var b = 0; b < a.length; b++) {
                                                    d[b].weight = a[b]
                                                }
                                            }
                                        }
                                    } else {
                                        if (e) {
                                            a = [];
                                            for (var b = 0; b < e.length; b++) {
                                                a[b] = e.length;
                                                d[b].weight = a[b]
                                            }
                                        } else {
                                            alert("Wuz going on dude? This aint't gonna work!")
                                        }
                                    }
                                };
                                this.setLayoutGraphTypes = function() {
                                    var b = this.data.l.type;
                                    if (b) {
                                        for (var a = 0; a < b.length; a++) {
                                            this.layoutParams[a].graphType = b && b[a] ? b[a] : this.graphType
                                        }
                                    }
                                };
                                this.setLayoutIndices = function(g) {
                                    var b;
                                    var a = this.xAxis.length && this.xAxis2.length ? this.getVariableIndices(this.xAxis).concat(this.getVariableIndices(this.xAxis2)) : this.varIndices;
                                    var c = this.getObjectArray(a);
                                    var f = this.getObjectArray(this.smpIndices);
                                    for (var e = 0; e < this.data.l.comp.length; e++) {
                                        if (this.data.l.vars && this.data.l.smps) {
                                            b = [];
                                            var c = this.getObjectArray(this.data.l.comp[e][0]);
                                            for (var d = 0; d < a.length; d++) {
                                                if (c.hasOwnProperty(a[d])) {
                                                    b.push(a[d])
                                                }
                                            }
                                            this.layoutParams[e].varIndices = b;
                                            b = [];
                                            var f = this.getObjectArray(this.data.l.comp[e][1]);
                                            for (var d = 0; d < this.smpIndices.length; d++) {
                                                if (f.hasOwnProperty(this.smpIndices[d])) {
                                                    b.push(this.smpIndices[d])
                                                }
                                            }
                                            this.layoutParams[e].smpIndices = b;
                                            this.setOriginalIndices(e, this.layoutParams[e].varIndices, this.layoutParams[e].smpIndices)
                                        } else {
                                            if (this.data.l.comp[e]) {
                                                b = [];
                                                if (this.data.l.vars) {
                                                    var c = this.getObjectArray(this.data.l.comp[e]);
                                                    for (var d = 0; d < a.length; d++) {
                                                        if (c.hasOwnProperty(a[d])) {
                                                            b.push(a[d])
                                                        }
                                                    }
                                                    this.layoutParams[e].varIndices = this.isHistogram ? a : b;
                                                    this.layoutParams[e].smpIndices = this.smpIndices;
                                                    this.setOriginalIndices(e, this.layoutParams[e].varIndices, this.smpIndices)
                                                } else {
                                                    var f = this.getObjectArray(this.data.l.comp[e]);
                                                    for (var d = 0; d < this.smpIndices.length; d++) {
                                                        if (f.hasOwnProperty(this.smpIndices[d])) {
                                                            b.push(this.smpIndices[d])
                                                        }
                                                    }
                                                    this.layoutParams[e].varIndices = a;
                                                    if (!this.layoutParams[e].smpIndices || this.layoutParams[e].smpIndices.length != b.length) {
                                                        this.layoutParams[e].smpIndices = b
                                                    }
                                                    this.setOriginalIndices(e, a, this.layoutParams[e].smpIndices)
                                                }
                                            } else {
                                                if (this.data.l.vars) {
                                                    this.layoutParams[e].varIndices = [];
                                                    this.layoutParams[e].smpIndices = this.smpIndices
                                                } else {
                                                    this.layoutParams[e].varIndices = a;
                                                    this.layoutParams[e].smpIndices = []
                                                }
                                            }
                                        }
                                        this.layoutParams[e].varIndicesStart = -1;
                                        this.layoutParams[e].smpIndicesStart = -1;
                                        this.layoutParams[e].grpIndicesStart = -1
                                    }
                                    for (var e = 0; e < this.data.l.type.length; e++) {
                                        for (var d = 0; d < g.length; d++) {
                                            if (!this.layoutParams[e].hasOwnProperty(g[d])) {
                                                this.layoutParams[e][g[d]] = this[g[d]]
                                            }
                                        }
                                    }
                                };
                                this.resetLayout = function() {
                                    delete(this.data.l);
                                    delete(this.layoutParams);
                                    this.offsetX = 0;
                                    this.offsetY = 0;
                                    this.layoutValidN = false;
                                    this.layoutValidR = false;
                                    this.layoutValidC = false;
                                    this.layoutValidBounds = false;
                                    this.layoutCurrent = false;
                                    this.layoutComb = false;
                                    this.layoutRestore = false;
                                    this.layout = "1X1"
                                };
                                this.setDOE = function() {
                                    this.oneDPlot(true);
                                    this.Scatter2D(true);
                                    this.Scatter3D(true);
                                    this.Pie(true)
                                };
                                this.resetLayoutRestore = function() {
                                    this.layoutRestore = false
                                };
                                this.setLayoutRestore = function() {
                                    if (!this.layoutRestore) {
                                        this.layoutRestore = {};
                                        var c = ["title", "subtitle", "varIndices", "smpIndices", "grpIndices", "varIndicesStart", "smpIndicesStart", "grpIndicesStart", "smpTitle", "showVariableNames", "showSampleNames", "showOverlays", "showLegend", "legendInside", "showDecorationsLegend", "xAxisShow", "xAxis2Show", "xAxisS2Show", "yAxisShow", "yAxisS2Show", "xAxisTitle", "xAxis2Title", "yAxisTitle", "zAxisTitle", "legendLayout"];
                                        c.push("legendDecorationWidth");
                                        c.push("legendDecorationHeight");
                                        var a = ["Color", "Shape", "Size", "Pattern", "Connect", "Sample"];
                                        for (var b = 0; b < a.length; b++) {
                                            c.push("legend" + a[b] + "s");
                                            c.push("legend" + a[b] + "sMax");
                                            c.push("legend" + a[b] + "sN");
                                            c.push("legend" + a[b] + "sS");
                                            c.push("legend" + a[b] + "Width");
                                            c.push("legend" + a[b] + "Height")
                                        }
                                        for (var b = 0; b < c.length; b++) {
                                            this.layoutRestore[c[b]] = this[c[b]]
                                        }
                                        if (this.isGroupedData && this.data.w) {
                                            this.layoutRestore.isGroupedData = this.isGroupedData
                                        }
                                    }
                                };
                                this.setLayoutParams = function() {
                                    if (!this.layoutParams && this.data.l.comp) {
                                        this.layoutParams = []
                                    }
                                    for (var a = 0; a < this.data.l.type.length; a++) {
                                        if (!this.layoutParams[a]) {
                                            this.layoutParams[a] = {}
                                        }
                                    }
                                };
                                this.removeEmptyCompartments = function() {
                                    if (this.layoutRemoveEmpty && this.layoutParams && !this.isDOE) {
                                        var f = {};
                                        var d = [];
                                        var g = ["comp", "desc", "name", "type", "vars", "smps", "weight"];
                                        var h = 0;
                                        for (var c = 0; c < g.length; c++) {
                                            if (this.data.l[g[c]]) {
                                                f[g[c]] = []
                                            }
                                        }
                                        for (var c = 0; c < this.data.l.weight.length; c++) {
                                            var b = this.layoutParams[c].varIndices.length;
                                            var e = this.layoutParams[c].smpIndices.length;
                                            if (b && e) {
                                                d.push(this.layoutParams[c]);
                                                for (var a = 0; a < g.length; a++) {
                                                    if (this.data.l[g[a]]) {
                                                        f[g[a]].push(this.data.l[g[a]][c])
                                                    }
                                                }
                                                if (this.data.l.group) {
                                                    f.group = this.data.l.group
                                                }
                                                h++
                                            }
                                        }
                                        if (h != this.data.l.weight.length) {
                                            this.stndByLayoutData = {};
                                            this.stndByLayoutData.data = this.cloneObject(this.data.l);
                                            this.stndByLayoutData.pars = this.cloneObject(this.layoutParams);
                                            this.stndByLayoutData.layoutRows = this.layoutRows;
                                            this.stndByLayoutData.layoutCols = this.layoutCols;
                                            this.stndByLayoutData.layout = this.layout;
                                            this.data.l = f;
                                            this.layoutParams = d;
                                            this.layoutRows = Math.ceil(Math.sqrt(h));
                                            this.layoutCols = this.layoutRows * (this.layoutRows - 1) >= h ? this.layoutRows - 1 : this.layoutRows;
                                            this.layout = this.layoutRows + "X" + this.layoutCols;
                                            for (var c = 0; c < this.data.l.weight.length; c++) {
                                                this.data.l.weight[c] = [1 / this.layoutCols, 1 / this.layoutRows]
                                            }
                                        }
                                    }
                                };
                                this.restoreEmptyCompartments = function() {
                                    if (this.stndByLayoutData) {
                                        this.data.l = this.stndByLayoutData.data;
                                        this.layoutParams = this.stndByLayoutData.pars;
                                        this.layoutRows = this.stndByLayoutData.layoutRows;
                                        this.layoutCols = this.stndByLayoutData.layoutCols;
                                        this.layout = this.stndByLayoutData.layout;
                                        delete(this.stndByLayoutData)
                                    }
                                };
                                this.getLayoutAxisSamples = function(c) {
                                    if (this.data.l.smps) {
                                        if (this.graphType.match(/Scatter2D/) && this.segregateSamplesBy && this.segregateSamplesBy.length == 1 && this.segregateSamplesBy[0] == "sample") {
                                            var e = this.cloneObject(this[c + "Axis"]);
                                            if (e[0] == "Bin") {
                                                if (c == "x") {
                                                    return ["Bin"]
                                                } else {
                                                    e.shift();
                                                    return e
                                                }
                                            } else {
                                                return this.cloneObject(this.data.y.smps)
                                            }
                                        } else {
                                            var e = {};
                                            var b = c == "x" ? 0 : 1;
                                            for (var d = 0; d < this.data.l.smps.length; d++) {
                                                if (this.data.l.smps[d] && (this.data.l.smps[d][b] || this.data.l.smps[d][b] == 0)) {
                                                    e[this.data.l.smps[d][b]] = true
                                                } else {
                                                    if (this.data.l.smps[d][c + "Axis"]) {
                                                        e[this.data.l.smps[d][c + "Axis"]] = true
                                                    }
                                                }
                                            }
                                            return this.getKeys(e)
                                        }
                                    } else {
                                        if (this[c + "Axis"].length > 0) {
                                            return this[c + "Axis"]
                                        } else {
                                            return this.data.y.smps
                                        }
                                    }
                                };
                                this.preCalculateAdjustLayout = function(f) {
                                    if (!this.isDOE && this.graphType != "Pie") {
                                        delete this.xAxisLayoutMaxTickStr;
                                        delete this.xAxisLayoutMaxTickStrLength;
                                        delete this.xAxis2LayoutMaxTickStr;
                                        delete this.xAxis2LayoutMaxTickStrLength;
                                        delete this.yAxisLayoutMaxTickStr;
                                        delete this.yAxisLayoutMaxTickStrLength;
                                        var a = this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight;
                                        var g = this.marginTop + this.layoutTop + this.layoutBottom + this.marginBottom;
                                        var l = 0;
                                        for (var e = 0; e < this.layoutRows; e++) {
                                            for (var d = 0; d < this.layoutCols; d++) {
                                                this.layoutCurrent = l;
                                                if (this.layoutParams.length <= l) {
                                                    break
                                                }
                                                if (this.layoutParams[l]) {
                                                    for (var b = 0; b < f.length; b++) {
                                                        this[f[b]] = this.layoutParams[l].hasOwnProperty(f[b]) ? this.layoutParams[l][f[b]] : this[f[b]]
                                                    }
                                                }
                                                this.setLayoutGraphDimensions(a, g, l);
                                                if (this.graphType.match(/Scatter/) || (this.graphType.match(/Boxplot/) && this.scatterPlotMatrix)) {
                                                    this.drawLayoutCompartmentsScatter(a, g, e, d, l)
                                                } else {
                                                    this.drawLayoutCompartmentsOneD(a, g, l)
                                                }
                                                l++
                                            }
                                        }
                                        this.restoreLayoutParameters()
                                    }
                                };
                                this.setLayoutHidden = function() {
                                    this.layoutHidden = {};
                                    var b = ["hiddenVars", "hiddensSmps", "hiddenLegends"];
                                    for (var a = 0; a < b.length; a++) {
                                        this.layoutHidden[b[a]] = this.cloneObject(this[b[a]])
                                    }
                                };
                                this.restoreLayoutHidden = function() {
                                    var b = ["hiddenVars", "hiddensSmps", "hiddenLegends"];
                                    for (var a = 0; a < b.length; a++) {
                                        this[b[a]] = this.layoutHidden[b[a]]
                                    }
                                };
                                this.drawLayoutCompartments = function(b) {
                                    var C = ["left", "right", "top", "bottom", "x", "y", "offsetX", "offsetY", "graphType", "summaryType", "transformData", "smpInfo", "varInfo", "minData", "maxData", "xAxisMin", "xAxisMax", "xAxisRange", "xAxis2Min", "xAxis2Max", "xAxis2Range", "yAxisMin", "yAxisMax", "yAxisRange", "zAxisMin", "zAxisMax", "zAxisRange", "xAxisAbsMin", "xAxisAbsMax", "xAxis2AbsMin", "xAxis2AbsMax", "yAxisAbsMin", "yAxisAbsMax", "zAxisAbsMin", "zAxisAbsMax", "xAxisUnit", "xAxis2Unit", "yAxisUnit", "zAxisUnit"];
                                    var u = ["layoutTop", "layoutRight", "layoutBottom", "layoutLeft", "layoutWidth", "layoutHeight", "layoutValid", "layoutComb", "offsetX", "offsetY"];
                                    var f = ["weight", "graphType", "varIndices", "smpIndices", "grpIndices", "varIndicesStart", "smpIndicesStart", "grpIndicesStart", "setMin", "setMax", "setMin2", "setMax2", "setMinX", "setMaxX", "setMinY", "setMaxY", "setMinZ", "setMaxZ"];
                                    if (this.layoutComb) {
                                        this.validateLayoutTopology();
                                        if (this.isDOE) {
                                            C.push("data");
                                            this.setDOE()
                                        }
                                        this.removeEmptyCompartments();
                                        if (this.graphType.match(/Scatter/)) {
                                            this.dataPointSize = Number(Math.max(0.5, this.dataPointSize / Math.max(this.layoutRows, this.layoutCols)).toFixed(1));
                                            this.xAxisTmp = this.cloneObject(this.xAxis);
                                            this.yAxisTmp = this.cloneObject(this.yAxis);
                                            this.xAxis = this.getLayoutAxisSamples("x");
                                            this.yAxis = this.getLayoutAxisSamples("y");
                                            this.initializeAxis();
                                            this.xAxis = this.xAxisTmp;
                                            this.yAxis = this.yAxisTmp;
                                            this.xAxisIndices = this.getSampleIndices(this.xAxis);
                                            this.yAxisIndices = this.getSampleIndices(this.yAxis);
                                            this.meta.data.i = {
                                                vars: this.cloneObject(this.varIndices),
                                                smps: this.cloneObject(this.smpIndices)
                                            }
                                        } else {
                                            if (this.data.l && this.data.l.group) {
                                                this.meta.data.i = {
                                                    vars: this.cloneObject(this.varIndices),
                                                    smps: this.cloneObject(this.smpIndices),
                                                    grps: this.cloneObject(this.grpIndices)
                                                };
                                                this.meta.data.g = this.data.w;
                                                if (this.stackBy && this.data.l.group.length) {
                                                    this.groupSamples(this.data.l.group, false, false, true, true, true);
                                                    this.initializeAxis()
                                                }
                                            } else {
                                                this.initAxes()
                                            }
                                        }
                                        this.setLayoutLegends();
                                        this.setLayoutRestore();
                                        this.setLayoutParams();
                                        this.setLayoutWeights();
                                        this.setLongestLayoutLabel();
                                        this.setLayoutGraphTypes();
                                        this.setLayoutIndices(f);
                                        this.preCalculateAdjustLayout(f);
                                        this.setLayoutHidden();
                                        this.setLayoutDimensions();
                                        this.title = "";
                                        this.subtitle = "";
                                        this.offsetX = this.layoutLeft;
                                        this.offsetY = this.graphType == "Pie" ? 0 : this.layoutTop;
                                        var g = this.marginLeft + this.layoutLeft + this.layoutRight + this.marginRight;
                                        var z = this.marginTop + this.layoutTop + this.layoutBottom + this.marginBottom;
                                        var B = 0;
                                        for (var y = 0; y < this.layoutRows; y++) {
                                            for (var v = 0; v < this.layoutCols; v++) {
                                                this.layoutCurrent = B;
                                                this.layoutCurrentR = y;
                                                this.layoutCurrentC = v;
                                                if (this.isDOE) {
                                                    if (this.dataStndBy.l.smps.length <= B) {
                                                        break
                                                    }
                                                } else {
                                                    if (this.graphType == "Pie") {
                                                        if (this.data.l.smps.length <= B) {
                                                            break
                                                        }
                                                    } else {
                                                        if (this.isCreateHistogram) {
                                                            if (this.data.l.axes.length >= B) {}
                                                        } else {
                                                            if (this.layoutParams.length <= B) {
                                                                break
                                                            }
                                                        }
                                                    }
                                                }
                                                if (this.layoutParams[B]) {
                                                    for (var t = 0; t < f.length; t++) {
                                                        this[f[t]] = this.layoutParams[B].hasOwnProperty(f[t]) ? this.layoutParams[B][f[t]] : this[f[t]]
                                                    }
                                                }
                                                this.setLayoutGraphDimensions(g, z, B);
                                                if (this.isDOE) {
                                                    this.offsetX = this.layoutLeft + ((this.width - g) / this.layoutCols * this.dataStndBy.l.coords[B][1]);
                                                    this.offsetY = this.layoutTop + ((this.height - z) / this.layoutRows * this.dataStndBy.l.coords[B][0]);
                                                    this.drawLayoutCompartmentsDOE(g, z, B)
                                                } else {
                                                    if (this.graphType.match(/Scatter/) || (this.graphType.match(/Boxplot/) && this.scatterPlotMatrix)) {
                                                        this.drawLayoutCompartmentsScatter(g, z, y, v, B)
                                                    } else {
                                                        if (this.graphType == "Pie") {
                                                            this.drawLayoutCompartmentsPie(g, z, B)
                                                        } else {
                                                            if (!this.scatterPlotMatrix) {
                                                                this.drawLayoutCompartmentsOneD(g, z, B)
                                                            }
                                                        }
                                                    }
                                                }
                                                var D = {};
                                                if (this.layoutConfig && this.layoutConfig[B]) {
                                                    for (var q in this.layoutConfig[B]) {
                                                        D[q] = this.cloneObject(this[q]);
                                                        this[q] = this.layoutConfig[B][q]
                                                    }
                                                }
                                                if (!this.isDOE && this.varIndices.length > 0 && this.smpIndices.length > 0) {
                                                    if (this.scatterPlotMatrix) {
                                                        if (this.scatterPlotMatrixType.match(/correlation|all/)) {
                                                            if (v > y) {
                                                                if (this.scatterPlotMatrixType.match(/all/) && v == this.layoutCols - 1) {
                                                                    var A = this.cloneObject(this.data.l.data[B]);
                                                                    var n = this.data.l.params[B];
                                                                    if (A && n) {
                                                                        var o = {};
                                                                        for (var q in n) {
                                                                            o[q] = this[q];
                                                                            this[q] = n[q]
                                                                        }
                                                                        if (this.scatterType == "boxplot" && this.isTransformedData) {
                                                                            for (t = 0; t < A.y.vars.length; t++) {
                                                                                A.y.data[t][1] = this.transformValue(this.isTransformedData, A.y.data[t][1])
                                                                            }
                                                                        }
                                                                        this.initializeData(A, false, true);
                                                                        this.initializeAxis();
                                                                        b.call(this);
                                                                        for (var q in o) {
                                                                            this[q] = o[q]
                                                                        }
                                                                        this.switchData(false, true)
                                                                    }
                                                                }
                                                            } else {
                                                                if (v == y || (y == this.layoutRows - 1 && this.scatterPlotMatrixType.match(/all/))) {
                                                                    var l = y == this.layoutRows - 1 && this.scatterPlotMatrixType.match(/all/) ? v : y;
                                                                    var m = this.data.l.group && this.meta.data.d.z[this.data.l.group] && this.meta.data.d.z[this.data.l.group][l] && this.meta.data.d.z[this.data.l.group][l][this.data.y.smps[this.smpIndices[l]]] ? this.meta.data.d.z[this.data.l.group][l][this.data.y.smps[this.smpIndices[l]]] : this.meta.data.d.s[l] ? this.meta.data.d.s[l] : false;
                                                                    if (m && this.scatterPlotMatrixType != "correlation") {
                                                                        this.data.l.data[B] = m.data;
                                                                        for (var q in m.params) {
                                                                            this[q] = m.params[q]
                                                                        }
                                                                        if (this.scatterPlotMatrixType.match(/all/) && v == y) {
                                                                            this.hideHistogram = true;
                                                                            this.showHistogramDensity = true
                                                                        }
                                                                        var o = [];
                                                                        for (var q = 0; q < u.length; q++) {
                                                                            o.push(this[u[q]])
                                                                        }
                                                                        if (this.scatterPlotMatrixType.match(/Histogram|Density|all/)) {
                                                                            this.initializeData(m.data, false, true)
                                                                        }
                                                                        this.initializeAxis();
                                                                        b.call(this);
                                                                        this.removeHistogram(true);
                                                                        this.restoreMargins();
                                                                        for (var q = 0; q < u.length; q++) {
                                                                            this[u[q]] = o[q]
                                                                        }
                                                                        if (this.scatterPlotMatrixType.match(/all/) && v == y) {
                                                                            this.hideHistogram = false;
                                                                            this.showHistogramDensity = false
                                                                        }
                                                                    } else {
                                                                        if (this.scatterPlotMatrixType == "correlation" && y == 0) {
                                                                            b.call(this)
                                                                        } else {
                                                                            if (y == this.layoutRows - 1 && v == this.layoutCols - 1 && this.scatterPlotMatrixType.match(/all/)) {
                                                                                this.removeHistogram(true);
                                                                                this.restoreMargins()
                                                                            }
                                                                        }
                                                                    }
                                                                } else {
                                                                    this.restoreLayoutHidden();
                                                                    b.call(this)
                                                                }
                                                            }
                                                        } else {
                                                            b.call(this)
                                                        }
                                                    } else {
                                                        if (this.graphType.match(/Scatter/)) {
                                                            if (this.xAxis.length && this.yAxis.length) {
                                                                b.call(this)
                                                            }
                                                        } else {
                                                            b.call(this)
                                                        }
                                                    }
                                                }
                                                if (this.layoutConfig && this.layoutConfig[B]) {
                                                    for (var q in this.layoutConfig[B]) {
                                                        this[q] = D[q]
                                                    }
                                                }
                                                for (var t = 0; t < C.length; t++) {
                                                    this.layoutParams[B][C[t]] = this.cloneObject(this[C[t]])
                                                }
                                                if (this.data.w) {
                                                    this.layoutParams[B].w = this.cloneObject(this.data.w)
                                                }
                                                if (this.layoutCanvasCompartments) {
                                                    this.drawLayoutCanvasCompartments()
                                                }
                                                if (this.isDOE || this.graphType == "Pie") {} else {
                                                    if (this.graphType.match(/Scatter/) || (this.graphType.match(/Boxplot/) && this.scatterPlotMatrix && this.scatterPlotMatrixType.match(/all/))) {
                                                        if (this.scatterPlotMatrix || this.segregateVariablesBy.length || this.segregateSamplesBy.length) {
                                                            this.drawTrellisLabels(B, y, v, g)
                                                        }
                                                    } else {
                                                        if (!this.layoutAdjust) {
                                                            var e = this.graphOrientation == "vertical" ? v : y;
                                                            var d = this.graphOrientation == "vertical" ? this.layoutCols - 1 : this.layoutRows - 1;
                                                            var r = this.graphOrientation == "vertical" && (this.layoutType == "rows" || (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1));
                                                            var a = this.graphOrientation != "vertical" && (this.layoutType == "cols" || (this.layoutType == "rows" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1));
                                                            if (e == 0 && this.layoutRestore.xAxisShow && this.graphType != "Heatmap" && !a) {
                                                                this.layoutAxis = 1;
                                                                this.xAxisShow = true;
                                                                this.draw1DXLayout()
                                                            }
                                                            if (e == d && this.layoutRestore.xAxis2Show && this.graphType != "Heatmap" && !r) {
                                                                this.layoutAxis = 2;
                                                                this.xAxis2Show = true;
                                                                this.draw1DXLayout()
                                                            }
                                                        }
                                                        if (this.segregateVariablesBy.length) {
                                                            var s = false;
                                                            if (this.graphOrientation == "vertical") {
                                                                if (y == this.layoutRows - 1) {
                                                                    s = true
                                                                } else {
                                                                    if (y == this.layoutRows - 2 && (B + 1 + parseInt(this.layoutCols)) > this.data.l.weight.length) {
                                                                        s = true
                                                                    }
                                                                }
                                                            } else {
                                                                if (v == 0) {
                                                                    s = true
                                                                }
                                                            }
                                                            if (s) {
                                                                this.showSampleNames = this.layoutRestore.showSampleNames;
                                                                this.draw1DYLayout()
                                                            }
                                                        } else {
                                                            if (this.graphOrientation == "vertical" && this.segregateSamplesBy.length && this.layoutSameSamples && y == this.layoutRows - 1) {
                                                                this.showSampleNames = this.layoutRestore.showSampleNames;
                                                                this.draw1DYLayout()
                                                            } else {
                                                                if (this.graphOrientation != "vertical" && this.segregateSamplesBy.length && this.layoutSameSamples && v == 0) {
                                                                    this.showSampleNames = this.layoutRestore.showSampleNames;
                                                                    this.draw1DYLayout()
                                                                }
                                                            }
                                                        }
                                                        this.drawTrellisLabels(B, y, v)
                                                    }
                                                }
                                                this.offsetX += this.layoutWidth;
                                                B++
                                            }
                                            this.offsetX = this.layoutLeft;
                                            this.offsetY += this.layoutHeight
                                        }
                                        this.layoutCurrent = false;
                                        this.restoreLayoutParameters();
                                        if (this.isDOE) {
                                            this.data = this.dataStndBy;
                                            this.graphType = this.data.l.type[0]
                                        } else {
                                            this.drawTitle();
                                            this.drawLabelsTitlesLayout();
                                            if (this.showLegend) {
                                                if (this.isDOE || this.graphType != "Pie") {
                                                    if (this.graphType.match(/Scatter/)) {
                                                        this.setLegends()
                                                    }
                                                    this.drawLegend(true)
                                                }
                                            }
                                        }
                                        if (this.graphType.match(/Scatter/) && this.scatterPlotMatrix) {
                                            this.varIndices = this.meta.data.i.vars;
                                            this.smpIndices = this.meta.data.i.smps
                                        } else {
                                            if (this.meta.data.g) {
                                                this.data.w = this.meta.data.g;
                                                this.varIndices = this.meta.data.i.vars;
                                                this.smpIndices = this.meta.data.i.smps;
                                                this.grpIndices = this.meta.data.i.grps;
                                                delete(this.meta.data.g);
                                                delete(this.meta.data.i)
                                            } else {
                                                this.isGroupedData = false
                                            }
                                        }
                                    }
                                };
                                this.restoreMargins = function() {
                                    for (var a in this.meta.config.user) {
                                        if (a.match(/margin|dataPointSize/)) {
                                            delete this.meta.config.user[a]
                                        }
                                    }
                                };
                                this.restoreLayoutParameters = function() {
                                    for (var a in this.layoutRestore) {
                                        this[a] = this.layoutRestore[a]
                                    }
                                };
                                this.setLayoutGraphDimensions = function(a, b, d) {
                                    this.layoutWidth = (this.width - a) * this.layoutParams[d].weight[0];
                                    this.layoutHeight = (this.height - b) * this.layoutParams[d].weight[1];
                                    this.layoutParams[d].width = this.layoutWidth;
                                    this.layoutParams[d].height = this.layoutHeight
                                };
                                this.setLongestLayoutLabel = function() {
                                    var a = [];
                                    if (this.scatterPlotMatrix) {} else {
                                        if ((this.segregateSamplesBy.length > 0 && this.segregateVariablesBy.length > 0) || (this.segregateSamplesBy.length > 1 || this.segregateVariablesBy.length > 1)) {
                                            for (var b = 0; b < this.data.l.name.length; b++) {
                                                a.push(this.data.l.name[b][0]);
                                                a.push(this.data.l.name[b][1])
                                            }
                                        } else {
                                            if (this.data.l.name) {
                                                for (var b = 0; b < this.data.l.name.length; b++) {
                                                    a.push(this.data.l.name[b])
                                                }
                                            }
                                        }
                                        this.longestLayoutLabel = this.getMaxText(a)
                                    }
                                };
                                this.setLayoutLabels = function(a) {
                                    this.layoutLabels = [];
                                    if (this.isHistogram) {
                                        if (this.segregateVariablesBy.length && this.meta.data.z[this.segregateVariablesBy[0]]) {
                                            this.layoutLabels.push(this.meta.data.z[this.segregateVariablesBy[0]].levels[a])
                                        } else {
                                            if (this.segregateSamplesBy.length) {
                                                this.layoutLabels.push(this.legendSamplesN == this.data.l.axes.length ? this.dataStndBy.y.smps[a] : this.data.l.axes[a].yAxis[0])
                                            } else {
                                                this.layoutLabels.push(this.data.l.name[a + 1])
                                            }
                                        }
                                    } else {
                                        if (this.segregateSamplesBy.length > 0 && this.segregateVariablesBy.length > 0) {
                                            this.layoutLabels.push(this.data.l.name[a][this.graphType.match(/Scatter/) ? 1 : 0]);
                                            this.layoutLabels.push(this.data.l.name[a][this.graphType.match(/Scatter/) ? 0 : 1])
                                        } else {
                                            if (this.segregateSamplesBy.length > 1 || this.segregateVariablesBy.length > 1) {
                                                this.layoutLabels.push(this.data.l.name[a][this.graphType.match(/Scatter/) ? 0 : 1]);
                                                this.layoutLabels.push(this.data.l.name[a][this.graphType.match(/Scatter/) ? 1 : 0])
                                            } else {
                                                if (this.scatterPlotMatrix) {} else {
                                                    this.layoutLabels.push(this.data.l.name[a])
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawLayoutCompartmentsDOE = function(k, y, D) {
                                    this.legendPosition = "right";
                                    this.graphOrientation = "vertical";
                                    if (D == 0) {
                                        this.isShowDOEData = true;
                                        this.showLegend = this.layoutRestore.showLegend;
                                        if (this.graphType != "Map") {
                                            this.drawDOELabelsLayout("Data")
                                        }
                                        if (this.graphType.match(/Scatter/i)) {
                                            this.isHistogram = false;
                                            this.xAxis = this.configStndBy.xAxis || [];
                                            this.yAxis = this.configStndBy.yAxis || [];
                                            this.zAxis = this.configStndBy.zAxis || [];
                                            this.xAxisTitle = this.configStndBy.xAxisTitle;
                                            this.yAxisTitle = this.configStndBy.yAxisTitle;
                                            this.zAxisTitle = this.configStndBy.zAxisTitle;
                                            this.initializeData(this.dataStndBy);
                                            this.varIndices = this.dataStndBy.l.doe
                                        } else {
                                            this.initializeData(this.dataStndBy);
                                            this.smpIndices = this.dataStndBy.l.doe
                                        }
                                        this.initializeAxis();
                                        this.showLegend = false;
                                        if (this.graphType == "Map") {
                                            this.drawMapData()
                                        } else {
                                            if (this.graphType == "Scatter3D") {
                                                this.draw3DPlot()
                                            } else {
                                                if (this.graphType.match(/Scatter/i)) {
                                                    if (!this.data.l.histogram) {
                                                        this.draw2DPlot()
                                                    }
                                                } else {
                                                    this.plotByVariable = this.configStndBy.plotByVariable;
                                                    if (this.configStndBy.summaryType) {
                                                        this.summaryType = this.configStndBy.summaryType
                                                    }
                                                    if (this.configStndBy.groupingFactors.length > 0) {
                                                        this.isGroupedData = true;
                                                        if (this.dataStndBy.y.smps.length != this.smpIndices.length) {
                                                            this.layoutComb = false;
                                                            this.groupSamples(this.configStndBy.groupingFactors, false, false, true, true);
                                                            this.layoutComb = true
                                                        }
                                                        this.initializeAxis();
                                                        if (!this.data.l.histogram) {
                                                            this.draw1DPlot()
                                                        }
                                                        this.isGroupedData = false;
                                                        this.groupingFactors = []
                                                    } else {
                                                        if (!this.data.l.histogram) {
                                                            this.draw1DPlot()
                                                        }
                                                    }
                                                    this.plotByVariable = false
                                                }
                                            }
                                        }
                                        if (this.data.l.histogram) {
                                            this.ridgeBy = this.data.l.histogram.ridgeBy;
                                            this.createHistogram(this.data.l.histogram.ridgeBy || this.data.l.histogram.isAnnt, false, true);
                                            this.dataStndBy.l.data = this.cloneObject(this.data);
                                            this.initializeAxis();
                                            this.draw2DPlot();
                                            this.ridgeBy = false
                                        }
                                        this.showLegend = true;
                                        this.isShowDOEData = false
                                    } else {
                                        if (!this.layoutConfig[D]) {
                                            this.layoutConfig[D] = {}
                                        }
                                        var o = this.dataStndBy;
                                        var r = o.l;
                                        var A = this.layoutConfig[D].graphType || r.type[D];
                                        this.drawDOELabelsLayout(r.smps[D][0]);
                                        this.top = 5;
                                        this.bottom = 5;
                                        this.right = 5;
                                        this.left = 5;
                                        if (A == "Pie") {
                                            this.showLegend = false;
                                            this.createPie(r.smps[D][0]);
                                            this.graphType = A;
                                            this.layoutCurrentDOE = r.smps[D][0];
                                            this.legendBox = false;
                                            this.drawPiePlot()
                                        } else {
                                            if (A == "Treemap") {
                                                this.createTreemap(r.smps[D][0]);
                                                this.graphType = A;
                                                this.draw1DPlot()
                                            } else {
                                                if (A == "Scatter2D") {
                                                    this.createHistogram(r.smps[D][0]);
                                                    this.graphType = A;
                                                    this.initializeAxis();
                                                    this.showLegend = false;
                                                    this.xAxisTitle = "";
                                                    this.yAxisTitle = "";
                                                    this.zAxisTitle = "";
                                                    this.draw2DPlot();
                                                    this.isHistogram = false;
                                                    this.isCreateHistogram = false
                                                } else {
                                                    if (A == "Scatter") {
                                                        A = "Scatter2D"
                                                    }
                                                    this.graphType = A;
                                                    var f = o.x || o.z;
                                                    var z = this.layoutConfig[D].xAxis || r.smps[D][0];
                                                    var b = this.layoutConfig[D].yAxis || r.smps[D][0];
                                                    var t = f.hasOwnProperty(z.toString()) ? f[z] : o.y.data[z];
                                                    var a = f.hasOwnProperty(b.toString()) ? f[b] : o.y.data[b];
                                                    var p = ["colorBy", "shapeBy", "siseBy"];
                                                    var q = {
                                                        graphType: true,
                                                        xAxis: true,
                                                        yAxis: true,
                                                        sortDir: true
                                                    };
                                                    var m;
                                                    if (A == "Scatter2D") {
                                                        var C = {
                                                            y: {
                                                                smps: [f.hasOwnProperty(z) ? z : o.y.vars[z]],
                                                                vars: [],
                                                                data: []
                                                            }
                                                        };
                                                        for (var v = 0; v < r.doe.length; v++) {
                                                            var n = r.doe[v];
                                                            C.y.vars.push(o.y.smps[n])
                                                        }
                                                        if (z != b) {
                                                            C.y.smps.push(f.hasOwnProperty(b) ? b : o.y.vars[b])
                                                        }
                                                        for (var v = 0; v < r.doe.length; v++) {
                                                            var n = o.l.doe[v];
                                                            if (z != b) {
                                                                C.y.data.push([t[n], a[n]])
                                                            } else {
                                                                C.y.data.push([t[n]])
                                                            }
                                                        }
                                                        this.isHistogram = false;
                                                        this.isCreateHistogram = false;
                                                        this.initializeData(C);
                                                        this.graphType = A;
                                                        this.initializeAxis();
                                                        this.draw2DPlot()
                                                    } else {
                                                        var C = {
                                                            y: {
                                                                vars: r.smps[D],
                                                                smps: [],
                                                                data: [
                                                                    []
                                                                ]
                                                            }
                                                        };
                                                        var e = this.cloneObject(r.doe);
                                                        if (this.layoutConfig[D].sortType) {
                                                            if (this.layoutConfig[D].sortType == "Numeric") {
                                                                if (this.layoutConfig[D].sortDir == "ascending") {
                                                                    e = e.sort(function(d, c) {
                                                                        return f[r.smps[D][0]][d] - f[r.smps[D][0]][c]
                                                                    })
                                                                } else {
                                                                    e = e.sort(function(d, c) {
                                                                        return f[r.smps[D][0]][c] - f[r.smps[D][0]][d]
                                                                    })
                                                                }
                                                            } else {
                                                                if (this.layoutConfig[D].sortDir == "ascending") {
                                                                    e.sort(function(d, c) {
                                                                        return o.y.smps[d] > o.y.smps[c]
                                                                    })
                                                                } else {
                                                                    e.sort(function(d, c) {
                                                                        return o.y.smps[d] > o.y.smps[c]
                                                                    });
                                                                    e.reverse()
                                                                }
                                                            }
                                                        }
                                                        for (var v = 0; v < e.length; v++) {
                                                            var n = e[v];
                                                            C.y.smps.push(o.x ? o.y.smps[n] : o.y.vars[n])
                                                        }
                                                        for (var v = 0; v < e.length; v++) {
                                                            var n = e[v];
                                                            if (this.layoutConfig[D].transformType) {
                                                                C.y.data[0].push(this.transformValue(this.layoutConfig[D].transformType, f[r.smps[D][0]][n]))
                                                            } else {
                                                                C.y.data[0].push(f[r.smps[D][0]][n])
                                                            }
                                                        }
                                                        var m = {};
                                                        var F = false;
                                                        for (var v = 0; v < p.length; v++) {
                                                            if (this.layoutConfig[D][p[v]]) {
                                                                F = true;
                                                                m[this.layoutConfig[D][p[v]]] = [];
                                                                var E;
                                                                if (f.hasOwnProperty(this.layoutConfig[D][p[v]])) {
                                                                    E = f[this.layoutConfig[D][p[v]]]
                                                                } else {
                                                                    for (var u = 0; u < o.y.vars.length; u++) {
                                                                        if (o.y.vars[u] == this.layoutConfig[D][p[v]]) {
                                                                            E = o.y.data[u];
                                                                            break
                                                                        }
                                                                    }
                                                                }
                                                                for (var u = 0; u < e.length; u++) {
                                                                    var B = e[u];
                                                                    m[this.layoutConfig[D][p[v]]].push(E[B])
                                                                }
                                                            }
                                                        }
                                                        if (F) {
                                                            C.x = m
                                                        }
                                                        this.initializeData(C);
                                                        this.graphType = A;
                                                        for (var v in this.layoutConfig[D]) {
                                                            if (!q[v]) {
                                                                this[v] = this.layoutConfig[D][v]
                                                            }
                                                        }
                                                        this.initializeAxis();
                                                        this.draw1DPlot();
                                                        for (var v in this.layoutConfig[D]) {
                                                            if (!q[v]) {
                                                                this[v] = false
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawLayoutCompartmentsScatter = function(a, e, d, b, g) {
                                    if (this.segregateVariablesBy.length && this.segregateSamplesBy.length) {
                                        this.xAxis = [this.data.l.smps[Math.floor(g / this.data.l.smps.length)][0]];
                                        this.yAxis = [this.data.l.smps[Math.floor(g / this.data.l.smps.length)][1]];
                                        this.xAxisIndices = this.getSampleIndices(this.xAxis);
                                        this.yAxisIndices = this.getSampleIndices(this.yAxis);
                                        this.setLayoutLabels(g)
                                    } else {
                                        if (this.data.l.smps && this.data.l.smps[g].xAxis && this.data.l.smps[g].yAxis) {
                                            this.xAxis = this.data.l.smps[g].xAxis;
                                            this.yAxis = this.data.l.smps[g].yAxis;
                                            this.xAxisIndices = this.getSampleIndices(this.xAxis);
                                            this.yAxisIndices = this.getSampleIndices(this.yAxis)
                                        } else {
                                            if (!this.scatterPlotMatrix && this.data.l.smps && this.data.l.smps[g]) {
                                                if (this.isHistogram) {
                                                    if (this.data.l.axes[g]) {
                                                        this.xAxis = this.data.l.axes[g].xAxis;
                                                        this.yAxis = this.data.l.axes[g].yAxis;
                                                        this.xAxisIndices = this.getSampleIndices(this.xAxis);
                                                        this.yAxisIndices = this.getSampleIndices(this.yAxis)
                                                    } else {
                                                        this.xAxis = [];
                                                        this.yAxis = [];
                                                        this.xAxisIndices = [];
                                                        this.yAxisIndices = []
                                                    }
                                                } else {
                                                    this.xAxis = [this.data.l.smps[g][0]];
                                                    if (this.isQQ) {
                                                        this.yAxis = [this.data.l.smps[g][0]]
                                                    } else {
                                                        this.yAxis = [this.data.l.smps[g][1] || this.data.l.smps[g][0]]
                                                    }
                                                    this.xAxisIndices = this.getSampleIndices(this.xAxis);
                                                    this.yAxisIndices = this.getSampleIndices(this.yAxis)
                                                }
                                                this.setLayoutLabels(g)
                                            } else {
                                                if (this.data.l.vars && this.data.l.vars[g]) {
                                                    if (this.data.l.axes) {
                                                        if (this.data.l.axes[g]) {
                                                            this.xAxis = this.data.l.axes[g].xAxis;
                                                            this.yAxis = this.data.l.axes[g].yAxis;
                                                            this.xAxisIndices = this.getSampleIndices(this.xAxis);
                                                            this.yAxisIndices = this.getSampleIndices(this.yAxis);
                                                            this.setLayoutLabels(g)
                                                        } else {
                                                            this.xAxis = [];
                                                            this.yAxis = [];
                                                            this.xAxisIndices = [];
                                                            this.yAxisIndices = []
                                                        }
                                                    } else {
                                                        this.setLayoutLabels(g)
                                                    }
                                                } else {
                                                    this.xAxis = false;
                                                    this.yAxis = false;
                                                    this.xAxisIndices = false;
                                                    this.yAxisIndices = false
                                                }
                                            }
                                        }
                                    }
                                    if (this.layoutAdjust && this.xAxis && this.yAxis) {
                                        this.initializeAxis();
                                        this.layoutAxis = 3
                                    } else {
                                        this.layoutAxis = b == 0 ? 2 : 0;
                                        this.layoutAxis = d == this.layoutRows && this.layoutAxis ? 3 : d == this.layoutRows ? 1 : 0
                                    }
                                    if (this.isQQ) {
                                        this.setAxes("qq")
                                    } else {
                                        if (this.isCDF) {
                                            this.setAxes("cdf")
                                        }
                                    }
                                    if (this.data.l.reg) {
                                        if (this.data.l.reg[g]) {
                                            if (this.decorations && this.decorations.reg) {
                                                delete(this.decorations.reg)
                                            }
                                            for (var f = 0; f < this.data.l.reg[g].length; f++) {
                                                this.addRegressionDecoration(this.data.l.reg[g][f].reg, this.data.l.reg[g][f].cor, this.data.l.reg[g][f].lab, this.data.l.reg[g][f].col, this.data.l.reg[g][f].fit, this.data.l.reg[g][f].id, this.data.l.reg[g][f].n, this.data.l.reg[g][f].factor)
                                            }
                                        }
                                    }
                                    this.showLegend = false;
                                    this.legendInside = true;
                                    this.showDecorationsLegend = true;
                                    this.xAxisTitle = "";
                                    this.yAxisTitle = "";
                                    if (!this.layoutAdjust || this.layoutAdjust == "axis" || this.scatterPlotMatrixType.match(/correlation|all/)) {
                                        this.xAxisShow = false;
                                        this.yAxisShow = false;
                                        this.xAxisS2Show = false;
                                        this.yAxisS2Show = false;
                                        if (d == 0 && b % 2 > 0) {
                                            this.xAxisS2Show = true
                                        }
                                        if (d == this.layoutRows - 1 && (b % 2 == 0 || this.scatterPlotMatrixType.match(/correlation|all/) || this.layoutAdjust == "axis")) {
                                            this.xAxisShow = true
                                        }
                                        if (b == 0 && (d % 2 > 0 || this.scatterPlotMatrixType.match(/correlation|all/) || this.layoutAdjust == "axis")) {
                                            if (d == 0 || (d == this.layoutRows - 1 && this.scatterPlotMatrixType.match(/all/))) {
                                                this.yAxisShow = false
                                            } else {
                                                this.yAxisShow = true
                                            }
                                        }
                                        if (d == this.layoutRows - 1 && this.scatterPlotMatrixType.match(/all/)) {
                                            this.yAxisShow = true
                                        }
                                        if (d == b && this.scatterPlotMatrix && this.scatterPlotMatrixType != "first") {
                                            this.xAxisShow = true;
                                            this.yAxisShow = true
                                        }
                                        if (b == this.layoutCols - 1 && d % 2 == 0 && (!this.scatterPlotMatrixType.match(/correlation|all/) || this.layoutAdjust == "axis")) {
                                            this.yAxisS2Show = true
                                        }
                                    }
                                    if (this.scatterType == "manhattan") {
                                        if (this.meta.config.user.xAxisShow === false) {
                                            this.xAxisShow = false;
                                            this.xAxisS2Show = false
                                        }
                                        this.yAxisShow = true
                                    }
                                    this.xAxisMajorTicks = true;
                                    this.yAxisMajorTicks = true;
                                    if ((d == b && (this.scatterPlotMatrixType.match(/correlation|all/) || this.layoutAdjust == "axis")) || (d == this.layoutRows - 1 && this.scatterPlotMatrixType.match(/all/))) {
                                        this.xAxisMajorTicks = false;
                                        this.yAxisMajorTicks = false
                                    }
                                };
                                this.drawLayoutCompartmentsPie = function(a, b, d) {
                                    this.smpIndices = [this.getSampleIndices(this.data.l.smps[d])];
                                    this.showLegend = true
                                };
                                this.drawLayoutCompartmentsOneD = function(b, e, g) {
                                    this.showLegend = false;
                                    this.showOverlays = true;
                                    this.isGroupedData = false;
                                    this.xAxisTitle = false;
                                    this.xAxis2Title = false;
                                    this.smpTitle = false;
                                    this.adjustAspectRatioXTries = 0;
                                    this.adjustAspectRatioYTries = 0;
                                    this.setLayoutLabels(g);
                                    if (this.varIndices.length > 0 && this.smpIndices.length > 0) {
                                        if (this.data.l.group) {
                                            this.groupSamples(this.data.l.group, false, false, true, true, true);
                                            var a = this.layoutParams[g].dragged && this.layoutParams[g].grpIndices.length == this.data.w.grpIdxs.length ? this.layoutParams[g].grpIndices : this.data.w.grpIdxs;
                                            this.groupSamples(this.data.l.group, false, a, true, true, true);
                                            this.layoutParams[g].grpIndices = this.grpIndices;
                                            if (this.colorBy && this.groupingFactors.includes(this.colorBy) && this.layoutRestore.showLegend) {}
                                            var f = false;
                                            for (var d = 0; d < this.data.l.group.length; d++) {
                                                if (this.segregateSamplesBy.includes(this.data.l.group[d])) {
                                                    f = true;
                                                    break
                                                }
                                            }
                                            if (this.data.w.smps.length == 1 && this.graphType != "Heatmap" && f) {
                                                this.showSampleNames = false
                                            }
                                            if (this.segregateSamplesBy.length && this.layoutSameSamples) {
                                                this.showSampleNames = false
                                            }
                                            if (this.hiddenGrpsLayout) {
                                                if (this.hiddenGrps.length == 1) {
                                                    if (this.hiddenGrpsLayout[g]) {
                                                        this.hiddenGrps[0] = true
                                                    }
                                                } else {
                                                    for (var d = 0; d < this.hiddenGrps.length; d++) {
                                                        if (this.hiddenGrpsLayout[d]) {
                                                            this.hiddenGrps[d] = true
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.smpIndices.length == 1 && this.graphType != "Heatmap") {}
                                        }
                                        if (this.segregateVariablesBy.length > 0 && this.graphType != "Heatmap") {
                                            this.showSampleNames = false
                                        }
                                        if (this.layoutAdjust) {
                                            this.layoutAxis = 3;
                                            if (this.varIndices.length > 0 && this.smpIndices.length > 0) {
                                                this.initializeAxis()
                                            }
                                        } else {
                                            if (this.graphOrientation == "vertical") {
                                                this.xAxisShowLayout = !(g % this.layoutCols) ? true : false
                                            } else {
                                                this.xAxisShowLayout = g < this.layoutCols ? true : false;
                                                this.xAxis2ShowLayout = g >= this.layoutCols * (this.layoutRows - 1) ? true : false
                                            }
                                            this.xAxisShow = false;
                                            this.xAxis2Show = false
                                        }
                                    }
                                };
                                this.drawTrellisLabels = function(R, A, O, S) {
                                    var n = this;
                                    if (this.scatterPlotMatrix) {
                                        var o = this.yAxisTopBottomTickColor || this.foreground;
                                        var L = R == 0 ? this.margin : 0;
                                        switch (this.scatterPlotMatrixType) {
                                            case "first":
                                                if (this.data.y.smps[R + 1]) {
                                                    var P = this.layoutLabelBoxThickness;
                                                    var C = this.scaleTextToFont(this.meta.data.y.maxSmpStr + " & " + this.meta.data.y.maxSmpStr, this.maxTextSize, (this.width - S) * 0.8 / this.layoutCols, P);
                                                    if (this.layoutBoxLabelColors[0]) {
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top - (P / 2), this.x, P, this.layoutBoxLabelColors[0], this.foreground],
                                                            t: "Labels"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top - (P / 2), this.x, P, false, this.foreground, "open"],
                                                            t: "Labels"
                                                        })
                                                    }
                                                    this.toRender({
                                                        p: ["drawText", this.data.y.smps[0] + " & " + this.data.y.smps[R + 1], this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top - (P / 2), C, this.foreground, "center", "middle"],
                                                        t: "Labels"
                                                    })
                                                }
                                                break;
                                            case "both":
                                            case "upper":
                                            case "lower":
                                            case "correlation":
                                                if (A == O) {
                                                    var C = this.scaleTextToFont(this.meta.data.y.maxSmpStr, this.maxTextSize, (this.width - S) * 0.7 / this.layoutCols, this.y);
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), this.x, this.y, false, this.foreground, "open"],
                                                        t: "Labels"
                                                    });
                                                    this.toRender({
                                                        p: ["drawText", this.data.y.smps[A], this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), C, this.foreground, "center", "middle"],
                                                        t: "Labels"
                                                    })
                                                } else {
                                                    if (O > A && this.scatterPlotMatrixType == "correlation") {
                                                        var j = this.meta.data.c;
                                                        var H = this.data.y.smps[this.smpIndices[A]] + "::" + this.data.y.smps[this.smpIndices[O]];
                                                        var e = this.colorBy && j.z[this.colorBy] && j.z[this.colorBy][H] ? j.z[this.colorBy][H] : j.s[H] ? j.s[H] : false;
                                                        var C = this.scaleTextToFont(this.meta.data.y.maxSmpStr, this.maxTextSize, (this.width - S) * 0.7 / this.layoutCols, this.y);
                                                        this.drawPlotWindow();
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), this.x, this.y, false, o, "open"],
                                                            t: "Labels"
                                                        });
                                                        if (e) {
                                                            var g = this.y / (e.length + 1);
                                                            for (var K = 0; K < e.length; K++) {
                                                                var T = this.formatNumber(e[K].cor, 3);
                                                                var k = e[K].col;
                                                                var G = (K + 1) * g;
                                                                this.toRender({
                                                                    p: ["drawText", T, this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + G, C, k, "center", "middle"],
                                                                    t: "Labels"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                                break;
                                            case "correlationHistogram":
                                            case "correlationDensity":
                                            case "all":
                                                if (this.scatterPlotMatrixType == "all" && O == this.layoutCols - 1 && A == this.layoutRows - 1) {
                                                    break;
                                                    this.drawPlotWindow();
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), this.x, this.y, false, o, "open"],
                                                        t: "Labels"
                                                    })
                                                }
                                                if (this.showScatterPlotMatrixLabels) {
                                                    var P = this.layoutLabelBoxThickness;
                                                    var C = this.scaleTextToFont(this.meta.data.y.maxSmpStr, this.fontSize, Math.min(this.layoutWidth, this.layoutHeight), P);
                                                    if (A == 0) {
                                                        var E = this.data.z && this.data.z.hasOwnProperty(this.scatterPlotMatrix) ? this.scatterPlotMatrix : "Variation";
                                                        var H = this.scatterPlotMatrixType == "all" && O == this.layoutCols - 1 ? E : this.data.y.smps[O];
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top - (P / 2), this.x, P, false, this.foreground, "open"],
                                                            t: "Labels"
                                                        });
                                                        this.toRender({
                                                            p: ["drawText", H, this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top - (P / 2), C, this.foreground, "center", "middle"],
                                                            t: "Labels"
                                                        })
                                                    }
                                                    if (O == this.layoutCols - 1) {
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + this.x + (P / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), P, this.y, false, this.foreground, "open"],
                                                            t: "Labels"
                                                        });
                                                        this.toRender({
                                                            p: ["drawText", this.data.y.smps[A], this.marginLeft + this.offsetX + this.left + this.x + (P / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), C, this.foreground, "center", "middle", Math.PI / 2],
                                                            t: "Labels"
                                                        })
                                                    }
                                                } else {
                                                    if (A == O) {
                                                        var C = this.scaleTextToFont(this.meta.data.y.maxSmpStr, this.maxTextSize, (this.width - S) * 0.7 / this.layoutCols, this.y);
                                                        var P = this.layoutLabelBoxThickness;
                                                        this.toRender({
                                                            p: ["drawText", this.data.y.smps[A], this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + P, C, this.foreground, "center", "middle"],
                                                            t: "Labels"
                                                        })
                                                    }
                                                }
                                                if (O > A) {
                                                    if (this.scatterPlotMatrixType == "all" && O == this.layoutCols - 1) {
                                                        break
                                                    }
                                                    var j = this.meta.data.c;
                                                    var H = this.data.y.smps[this.smpIndices[A]] + "::" + this.data.y.smps[this.smpIndices[O]];
                                                    var e = this.colorBy && j.z[this.colorBy] && j.z[this.colorBy][H] ? j.z[this.colorBy][H] : j.s[H] ? j.s[H] : false;
                                                    var C = this.scaleTextToFont(this.meta.data.y.maxSmpStr, this.maxTextSize, (this.width - S) * 0.7 / this.layoutCols, this.y);
                                                    this.drawPlotWindow();
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), this.x, this.y, false, o, "open"],
                                                        t: "Labels"
                                                    });
                                                    if (e) {
                                                        var g = this.y / (e.length + 1);
                                                        for (var K = 0; K < e.length; K++) {
                                                            var T = this.formatNumber(e[K].cor, 3);
                                                            var k = e[K].col;
                                                            var G = (K + 1) * g;
                                                            this.toRender({
                                                                p: ["drawText", T, this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + G, C, k, "center", "middle"],
                                                                t: "Labels"
                                                            })
                                                        }
                                                    }
                                                }
                                                break
                                        }
                                    } else {
                                        if (this.layoutValid && this.layoutLabelShow) {
                                            var J = function() {
                                                var c = n.marginLeft + n.offsetX;
                                                if (n.layoutCollapse || (n.layoutType != "wrap" && n.graphOrientation == "horizontal" && !n.graphType.match(/Scatter/))) {
                                                    return c + (n.layoutCollapse ? 0 : n.margin)
                                                } else {
                                                    if (n.graphType.match(/Scatter/) && (n.isQQ || n.isCDF) || n.layoutType != "wrap") {
                                                        return c + n.margin
                                                    } else {
                                                        return c + (n.graphOrientation == "horizontal" ? n.left : n.left) + (n.graphType.match(/Scatter/) ? 0 : 0)
                                                    }
                                                }
                                            };
                                            var a = function() {
                                                var c = n.marginTop + n.offsetY;
                                                if (n.layoutCollapse || (n.layoutType != "wrap" && n.graphOrientation == "horizontal" && !n.graphType.match(/Scatter/))) {
                                                    return c
                                                } else {
                                                    return c + (n.top - (n.layoutLabels.length * Q * (n.layoutType == "wrap" ? 1 : 0)))
                                                }
                                            };
                                            var b = function() {
                                                var c = n.layoutWidth;
                                                if (n.layoutCollapse) {
                                                    return c
                                                } else {
                                                    if (n.graphType.match(/Scatter/)) {
                                                        return c - n.margin
                                                    } else {
                                                        if (n.layoutType != "wrap") {
                                                            return c - (n.margin * (n.graphOrientation == "horizontal" ? 1 : 2))
                                                        } else {
                                                            return c - (n.left + n.right);
                                                            if (n.layoutAdjust) {
                                                                return c - (n.graphOrientation == "horizontal" ? (n.right + n.margin) : n.left + n.right)
                                                            } else {
                                                                return c - (n.margin * 2)
                                                            }
                                                        }
                                                    }
                                                }
                                            };
                                            var v = function() {
                                                var c = n.layoutHeight;
                                                if (n.layoutCollapse) {
                                                    return c
                                                } else {
                                                    if (n.graphType.match(/Scatter/)) {
                                                        return c - n.margin
                                                    } else {
                                                        if (n.layoutType != "wrap") {
                                                            return c - (n.margin * (n.graphOrientation == "horizontal" ? 1 : 2))
                                                        } else {
                                                            if (n.layoutAdjust) {
                                                                return c - (n.graphOrientation == "horizontal" ? ((n.top + n.bottom) - (n.layoutLabels.length * Q)) : n.bottom)
                                                            } else {
                                                                return c - (n.graphOrientation == "horizontal" ? n.margin : n.bottom)
                                                            }
                                                        }
                                                    }
                                                }
                                            };
                                            var s = this.layoutCollapse || this.layoutType != "wrap";
                                            var Q = this.layoutLabelBoxThickness;
                                            var I = J() + 0.5;
                                            var B = a() + 0.5;
                                            var u = b();
                                            var M = v();
                                            var F = u / 2;
                                            var N = this.layoutLabels.length ? this.scaleTextToFont(this.longestLayoutLabel, (this.layoutBoxShow ? this.fontSize : this.maxFontSize), u, M) : this.font;
                                            var D = this.layoutBoxShow ? this.foreground : "rgba(0,0,0,0)";
                                            var p = 1;
                                            if (this.layoutType == "wrap") {
                                                for (var K = 0; K < this.layoutLabels.length; K++) {
                                                    if (this.layoutBoxLabelColors[K]) {
                                                        this.toRender({
                                                            p: ["drawShape", "box", I + (u / 2), B + (Q / 2) + (Q * K), u, Q, this.layoutBoxLabelColors[K], this.layoutBoxShow ? this.foreground : this.layoutBoxLabelColors[K]],
                                                            t: "Labels"
                                                        })
                                                    }
                                                }
                                            } else {
                                                if (this.layoutType == "cols") {
                                                    if (this.layoutLabels.length > 1) {}
                                                } else {
                                                    if (this.layoutType == "rows") {
                                                        if (this.layoutLabels.length > 1) {}
                                                    }
                                                }
                                            }
                                            if (n.graphType.match(/Scatter/)) {
                                                if (!this.xAxis.length || !this.yAxis.length) {
                                                    return
                                                } else {
                                                    if (this.layoutType == "wrap") {
                                                        this.toRender({
                                                            p: ["drawShape", "box", I + (u / 2), B + (this.layoutLabels.length * Q / 2), u, this.layoutLabels.length * Q, false, D, "open", false, p],
                                                            t: "Labels"
                                                        })
                                                    }
                                                }
                                            } else {
                                                this.toRender({
                                                    p: ["drawShape", "box", I + (u / 2), B + (M / 2), u, M, false, D, "open"],
                                                    t: "Labels"
                                                })
                                            }
                                            if (this.layoutType == "wrap") {
                                                for (var K = 0; K < this.layoutLabels.length; K++) {
                                                    this.toRender({
                                                        p: ["drawText", this.layoutLabels[K], I + F, B + (Q / 2) + (Q * K), N, this.layoutLabelColor, "center", "middle"],
                                                        t: "Labels"
                                                    });
                                                    var r = B + Q + (Q * K);
                                                    this.toRender({
                                                        p: ["drawLine", "line", I, r, I + u, r, D],
                                                        t: "Labels"
                                                    })
                                                }
                                            } else {
                                                if (this.layoutType == "cols") {
                                                    if (A == 0) {
                                                        this.toRender({
                                                            p: ["drawText", this.layoutLabels[this.layoutLabels.length > 1 ? 1 : 0], I + F, B - (Q / 2), N, this.layoutLabelColor, "center", "middle"],
                                                            t: "Labels"
                                                        });
                                                        this.toRender({
                                                            p: ["drawShape", "box", I + (u / 2), B - (Q / 2), u, Q, false, D, "open", false, p],
                                                            s: true,
                                                            t: "Labels"
                                                        })
                                                    }
                                                    if (this.layoutLabels.length > 1 && Number(O) + 1 == this.layoutCols) {
                                                        this.toRender({
                                                            p: ["drawText", this.layoutLabels[0], I + u + (Q / 2), B + (M / 2), N, this.layoutLabelColor, "center", "middle", Math.PI / 2]
                                                        });
                                                        this.toRender({
                                                            p: ["drawShape", "box", I + u + (Q / 2), B + (M / 2), Q, M, false, D, "open", false, p],
                                                            s: true,
                                                            t: "Labels"
                                                        })
                                                    }
                                                } else {
                                                    if (this.layoutType == "rows") {
                                                        if (Number(O) + 1 == this.layoutCols) {
                                                            this.toRender({
                                                                p: ["drawText", this.layoutLabels[0], I + u + (Q / 2), B + (M / 2), N, this.layoutLabelColor, "center", "middle", Math.PI / 2]
                                                            });
                                                            this.toRender({
                                                                p: ["drawShape", "box", I + u + (Q / 2), B + (M / 2), Q, M, false, D, "open", false, p],
                                                                s: true,
                                                                t: "Labels"
                                                            })
                                                        }
                                                        if (this.layoutLabels.length > 1 && A == 0) {
                                                            this.toRender({
                                                                p: ["drawText", this.layoutLabels[1], I + F, B - (Q / 2), N, this.layoutLabelColor, "center", "middle"],
                                                                t: "Labels"
                                                            });
                                                            this.toRender({
                                                                p: ["drawShape", "box", I + (u / 2), B - (Q / 2), u, Q, false, D, "open", false, p],
                                                                s: true,
                                                                t: "Labels"
                                                            })
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getLayoutConfig = function(a) {
                                    if (this.layoutValid && this.layoutConfig && this.layoutConfig[this.layoutCurrent] && this.layoutConfig[this.layoutCurrent][a]) {
                                        return this.layoutConfig[this.layoutCurrent][a]
                                    } else {
                                        return false
                                    }
                                };
                                this.initializeLayout = function() {
                                    this.isValidLayout()
                                }
                            };
                            CanvasXpress.prototype.initViewport = function() {
                                this.setViewport = function(v) {
                                    var d = this.$("container-" + this.target);
                                    if (!d) {
                                        var y = this.$(this.target);
                                        var A = y.attributes;
                                        for (var w = 0; w < A.length; w++) {
                                            this.meta.dom[A[w].name] = A[w].value
                                        }
                                        var s = y.parentNode;
                                        y.className = "CanvasXpress";
                                        if (!y.hasAttribute("data-maxWidth")) {
                                            y.setAttribute("data-maxWidth", y.hasAttribute("width") ? Number(y.getAttribute("width")) : s.clientWidth)
                                        }
                                        if (!y.hasAttribute("data-maxHeight")) {
                                            y.setAttribute("data-maxHeight", y.hasAttribute("height") ? Number(y.getAttribute("height")) : s.clientHeight)
                                        }
                                        if (!s.id) {
                                            s.id = "CanvasXpress-ParentNode-" + this.target
                                        }
                                        if (!CanvasXpress.system.isShiny) {
                                            s.classList.add("CanvasXpress-ParentNode")
                                        }
                                        if (!s.style.margin && !s.style.marginTop && this.toolbarType.match(/over|fixed/)) {
                                            s.style.marginTop = "36px"
                                        }
                                        this.targetParentNode = s.id;
                                        this.targetParentNodeResponsive = false;
                                        this.targetParentNodeAspectRatio = [];
                                        var u = y.hasAttribute("data-responsive") ? JSON.parse(y.getAttribute("data-responsive")) : false;
                                        var q = y.hasAttribute("data-aspectRatio") ? y.getAttribute("data-aspectRatio") : false;
                                        var f = y.hasAttribute("data-resizable") ? y.getAttribute("data-resizable") : false;
                                        if (f) {
                                            if (f == "both") {
                                                this.resizable = true;
                                                this.resizableX = true;
                                                this.resizableY = true
                                            } else {
                                                if (f == "x" || f == "X") {
                                                    this.resizable = true;
                                                    this.resizableX = true;
                                                    this.resizableY = false
                                                } else {
                                                    if (f == "y" || f == "Y") {
                                                        this.resizable = true;
                                                        this.resizableX = false;
                                                        this.resizableY = true
                                                    } else {
                                                        if (f == "none") {
                                                            this.resizable = false;
                                                            this.resizableX = false;
                                                            this.resizableY = false
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (u) {
                                            this.targetParentNodeResponsive = true;
                                            var l = q ? q.split(/:/) : [];
                                            var j = this.getMaxCanvasWidthHeight(y, l);
                                            y.width = j[0];
                                            y.height = j[1];
                                            this.targetParentNodeAspectRatio = [y.width, y.height]
                                        }
                                        y.width = y.originalWidth = parseInt(y.width);
                                        y.height = y.originalHeight = parseInt(y.height);
                                        if (y.width == 0) {
                                            y.width = 500
                                        }
                                        if (y.height == 0) {
                                            y.height = 500
                                        }
                                        y.style.width = y.width + "px";
                                        y.style.height = y.height + "px";
                                        var o = this.$cX("canvas", {
                                            id: this.target + "-events",
                                            className: "CanvasXpress",
                                            width: y.width,
                                            height: y.height
                                        }, {
                                            position: "absolute",
                                            left: 0,
                                            top: 0
                                        });
                                        this.target2 = this.target + "-events";
                                        var d = this.$cX("div", {
                                            id: "container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            backgroundColor: this.background
                                        });
                                        if (v) {
                                            d.style.display = "none"
                                        }
                                        var B = this.$cX("div", {
                                            id: "northest-container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            width: y.width + "px",
                                            clear: "left",
                                            backgroundColor: this.background
                                        });
                                        var n = this.$cX("div", {
                                            id: "northest-wrapper-" + this.target,
                                            className: "CanvasXpressWrapper"
                                        }, {
                                            width: y.width + "px",
                                            backgroundColor: this.background
                                        });
                                        var k = this.$cX("div", {
                                            id: "north-container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            width: y.width + "px",
                                            height: "0px",
                                            clear: "left",
                                            backgroundColor: this.background
                                        });
                                        var z = this.$cX("div", {
                                            id: "north-wrapper-" + this.target,
                                            className: "CanvasXpressWrapper"
                                        }, {
                                            width: y.width + "px",
                                            height: "0px",
                                            backgroundColor: this.background
                                        });
                                        var D = this.$cX("div", {
                                            id: "middle-container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            width: y.width + "px",
                                            height: y.height + "px",
                                            clear: "left",
                                            backgroundColor: this.background
                                        });
                                        var m = this.$cX("div", {
                                            id: "west-container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            width: "0px",
                                            height: y.height + "px",
                                            cssFloat: "left",
                                            backgroundColor: this.background
                                        });
                                        var C = this.$cX("div", {
                                            id: "west-wrapper-" + this.target,
                                            className: "CanvasXpressWrapper"
                                        }, {
                                            width: "0px",
                                            height: y.height + "px",
                                            backgroundColor: this.background
                                        });
                                        var e = this.$cX("div", {
                                            id: "center-wrapper-" + this.target,
                                            className: "CanvasXpressWrapper"
                                        }, {
                                            backgroundColor: this.background
                                        });
                                        var h = this.$cX("div", {
                                            id: "east-container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            width: "0px",
                                            height: y.height + "px",
                                            backgroundColor: this.background
                                        });
                                        var x = this.$cX("div", {
                                            id: "east-wrapper-" + this.target,
                                            className: "CanvasXpressWrapper"
                                        }, {
                                            width: "0px",
                                            height: y.height + "px",
                                            backgroundColor: this.background
                                        });
                                        var b = this.$cX("div", {
                                            id: "south-container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            width: y.width + "px",
                                            height: "0px",
                                            clear: "left",
                                            backgroundColor: this.background
                                        });
                                        var r = this.$cX("div", {
                                            id: "south-wrapper-" + this.target,
                                            className: "CanvasXpressWrapper",
                                            state: "open"
                                        }, {
                                            width: y.width + "px",
                                            height: "0px",
                                            backgroundColor: this.background
                                        });
                                        var t = this.$cX("div", {
                                            id: "southest-container-" + this.target,
                                            className: "CanvasXpressContainer"
                                        }, {
                                            width: y.width + "px",
                                            clear: "left",
                                            backgroundColor: this.background
                                        });
                                        var g = this.$cX("div", {
                                            id: "southest-wrapper-" + this.target,
                                            className: "CanvasXpressWrapper"
                                        }, {
                                            width: y.width + "px",
                                            backgroundColor: this.background
                                        });
                                        B.appendChild(n);
                                        t.appendChild(g);
                                        k.appendChild(z);
                                        m.appendChild(C);
                                        h.appendChild(x);
                                        b.appendChild(r);
                                        D.appendChild(m);
                                        D.appendChild(e);
                                        D.appendChild(h);
                                        d.appendChild(B);
                                        d.appendChild(k);
                                        d.appendChild(D);
                                        d.appendChild(b);
                                        d.appendChild(t);
                                        d.appendChild(this.createLoadingTimer());
                                        y.parentNode.insertBefore(d, y);
                                        e.appendChild(y.parentNode.appendChild(y));
                                        y.parentNode.appendChild(o);
                                        this.meta.canvas.ctx2 = this.get2DCanvasContext(o);
                                        this.meta.canvas.ctx2.setTransform(this.meta.canvas.canvasPixelRatio, 0, 0, this.meta.canvas.canvasPixelRatio, 0, 0)
                                    }
                                };
                                this.getMaxCanvasWidthHeight = function(k, f) {
                                    var m, i;
                                    if (!k) {
                                        k = this.$(this.target)
                                    }
                                    if (!f) {
                                        f = this.targetParentNodeAspectRatio
                                    }
                                    var d = this.targetParentNode && this.$(this.targetParentNode) ? this.$(this.targetParentNode) : false;
                                    var n = Number(k.getAttribute("data-maxWidth"));
                                    var j = Number(k.getAttribute("data-maxHeight"));
                                    if (d) {
                                        if (d.parentNode) {
                                            d = d.parentNode
                                        }
                                    } else {
                                        return [n, j]
                                    }
                                    var a = d.getClientRects();
                                    var e = parseInt(getComputedStyle(d).paddingLeft);
                                    var g = Number(a[0] != null ? a[0].width : this.width);
                                    var b = Number(a[0] != null ? a[0].height : this.height);
                                    g = g > n ? n : g;
                                    b = b > j ? j : b;
                                    if (f.length == 2) {
                                        f[0] = Number(f[0]);
                                        f[1] = Number(f[1]);
                                        if (f[0] == f[1]) {
                                            m = g - (g >= n ? 0 : (e ? e * 2 : 0));
                                            i = m
                                        } else {
                                            if (f[0] > f[1]) {
                                                m = parseInt(g);
                                                i = parseInt(m * f[1] / f[0])
                                            } else {
                                                i = parseInt(b);
                                                m = parseInt(i * f[0] / f[1])
                                            }
                                        }
                                    } else {
                                        m = g;
                                        i = b
                                    }
                                    return [m, i]
                                };
                                this.createLoadingTimerOld = function() {
                                    var j = this.target + "canvasXpressLoadingTimer";
                                    if (this.$(j)) {
                                        return
                                    }
                                    var h = this.$(this.target);
                                    var g = this.$cX("div", {
                                        id: j
                                    }, {
                                        display: "none",
                                        position: "absolute",
                                        width: "100%",
                                        top: parseInt((h.height / 2) - 100.5) + "px"
                                    });
                                    var e = this.$cX("div", {
                                        className: "counter"
                                    });
                                    var b = this.$cX("div", {
                                        className: "timer"
                                    });
                                    var a = this.$cX("div", {
                                        className: "imer-val-container seconds-single"
                                    });
                                    for (var d = 0; d < 10; d++) {
                                        a.appendChild(this.$cX("div", {
                                            className: "timer-val",
                                            innerHTML: d
                                        }))
                                    }
                                    b.appendChild(a);
                                    e.appendChild(b);
                                    g.appendChild(e);
                                    var f = this.$cX("div", {
                                        className: "sk-fading-circle"
                                    });
                                    for (var d = 1; d < 13; d++) {
                                        f.appendChild(this.$cX("div", {
                                            className: "sk-circle" + d + " sk-circle"
                                        }))
                                    }
                                    g.appendChild(f);
                                    return g
                                };
                                this.createLoadingTimer = function() {
                                    var f = this.target + "canvasXpressLoadingTimer";
                                    if (this.$(f)) {
                                        return
                                    }
                                    var e = this.$(this.target);
                                    var d = this.$cX("div", {
                                        id: f
                                    }, {
                                        display: "block",
                                        position: "absolute",
                                        top: parseInt((e.height / 2) - 40) + "px",
                                        left: parseInt((e.width / 2) - 40) + "px"
                                    });
                                    var a = this.$cX("div", {
                                        className: "lds-ring"
                                    });
                                    for (var b = 0; b < 4; b++) {
                                        a.appendChild(this.$cX("div"))
                                    }
                                    d.appendChild(a);
                                    return d
                                };
                                this.resizeViewportNorth = function() {
                                    var e = this.meta.canvas.canvasPixelRatio;
                                    var f = this.$("west-container-" + this.target);
                                    var d = this.$("east-container-" + this.target);
                                    var b = this.$("northest-container-" + this.target);
                                    var c = this.$("northest-wrapper-" + this.target);
                                    var g = this.$("north-container-" + this.target);
                                    var a = this.$("north-wrapper-" + this.target);
                                    if (f && d && b && c && g && a) {
                                        b.style.width = (parseInt(f.style.width) + (this.meta.canvas.ctx.canvas.width / e) + parseInt(d.style.width)) + "px";
                                        c.style.width = (parseInt(f.style.width) + (this.meta.canvas.ctx.canvas.width / e) + parseInt(d.style.width)) + "px";
                                        g.style.width = (parseInt(f.style.width) + (this.meta.canvas.ctx.canvas.width / e) + parseInt(d.style.width)) + "px";
                                        a.style.width = (parseInt(f.style.width) + (this.meta.canvas.ctx.canvas.width / e) + parseInt(d.style.width)) + "px";
                                        g.style.height = "0px";
                                        a.style.height = "0px"
                                    }
                                };
                                this.resizeViewportWest = function() {
                                    var e = this.$(this.target + "-cX-Configurator");
                                    var a = this.meta.canvas.canvasPixelRatio;
                                    var b = this.$("west-container-" + this.target);
                                    var d = this.$("west-wrapper-" + this.target);
                                    if (b && d) {
                                        b.style.width = "0px";
                                        d.style.width = "0px";
                                        b.style.height = (this.meta.canvas.ctx.canvas.height / a) + "px";
                                        d.style.height = (this.meta.canvas.ctx.canvas.height / a) + "px"
                                    }
                                };
                                this.resizeViewportEast = function() {
                                    var d = this.$(this.target + "-cX-DataFilter");
                                    var c = this.meta.canvas.canvasPixelRatio;
                                    var a = this.$("east-container-" + this.target);
                                    var b = this.$("east-wrapper-" + this.target);
                                    if (a && b) {
                                        a.style.width = "0px";
                                        b.style.width = "0px";
                                        a.style.height = (this.meta.canvas.ctx.canvas.height / c) + "px";
                                        b.style.height = (this.meta.canvas.ctx.canvas.height / c) + "px"
                                    }
                                };
                                this.resizeViewportSouth = function(b) {
                                    var h = this.$(this.target + "-cX-DataTable");
                                    var e = this.meta.canvas.canvasPixelRatio;
                                    var f = this.$("west-container-" + this.target);
                                    var c = this.$("east-container-" + this.target);
                                    var g = this.$("south-container-" + this.target);
                                    var a = this.$("south-wrapper-" + this.target);
                                    if (h && f && c && g && a) {
                                        if (b) {
                                            g.style.height = parseInt(h.style.height) + "px";
                                            a.style.height = parseInt(h.style.height) + "px";
                                            g.style.width = parseInt(h.style.width) + "px";
                                            a.style.width = parseInt(h.style.width) + "px"
                                        } else {
                                            g.style.width = (parseInt(f.style.width) + (this.meta.canvas.ctx.canvas.width / e) + parseInt(c.style.width)) + "px";
                                            a.style.width = (parseInt(f.style.width) + (this.meta.canvas.ctx.canvas.width / e) + parseInt(c.style.width)) + "px";
                                            g.style.height = "0px";
                                            a.style.height = "0px"
                                        }
                                    }
                                };
                                this.resizeViewport = function() {
                                    var b = this.meta.canvas.canvasPixelRatio;
                                    var d = this.$("middle-container-" + this.target);
                                    var a = this.$("east-container-" + this.target);
                                    var c = this.$("west-container-" + this.target);
                                    if (d && a && c) {
                                        this.resizeViewportWest();
                                        this.resizeViewportEast();
                                        this.resizeViewportNorth();
                                        this.resizeViewportSouth();
                                        d.style.width = (parseInt(c.style.width) + (this.meta.canvas.ctx.canvas.width / b) + parseInt(a.style.width) + 0) + "px";
                                        d.style.height = ((this.meta.canvas.ctx.canvas.height / b) + 0) + "px"
                                    }
                                };
                                this.resizeViewportMiddle = function(a, c) {
                                    var e = this.$("middle-container-" + this.target);
                                    var b = this.$("east-container-" + this.target);
                                    var d = this.$("west-container-" + this.target);
                                    if (e && b && d) {
                                        this.resizeViewportWest();
                                        this.resizeViewportEast();
                                        this.resizeViewportNorth();
                                        this.resizeViewportSouth();
                                        e.style.width = (parseInt(d.style.width) + a + parseInt(b.style.width) + 0) + "px";
                                        e.style.height = (c + 0) + "px"
                                    }
                                };
                                this.resetViewportOverflow = function(b) {
                                    if (b) {
                                        var a = this.$(b + "-wrapper-" + this.target);
                                        if (a) {
                                            a.style.overflow = "visible"
                                        }
                                    }
                                };
                                this.initializeViewport = function(a) {
                                    this.setViewport(a)
                                }
                            };
                            CanvasXpress.prototype.initMenus = function() {
                                this.addMenu = function(C, a, o, b, g, d, z, B, n) {
                                    if (this.disableMenu) {
                                        return
                                    }
                                    var q;
                                    var p;
                                    var j = this.$("north-wrapper-" + this.target);
                                    var c = this.$("west-container-" + this.target);
                                    this.resetLinkDiv();
                                    if (j && c) {
                                        if (a) {
                                            p = this.newId("-cX-Menu-");
                                            q = this.$cX("div", {
                                                id: p,
                                                className: "CanvasXpressMenu draggable",
                                                par: o
                                            }, {
                                                left: "0px",
                                                top: "0px",
                                                zIndex: this.menuIndex++,
                                                display: "none"
                                            })
                                        } else {
                                            this.removeMenus();
                                            if (b) {
                                                a = b;
                                                g += c.offsetWidth
                                            } else {
                                                a = this.setMenu(C);
                                                var A = this.getTargetEvent(C);
                                                var D = this.adjustedCoordinates(C, A);
                                                if (B) {
                                                    g = 8;
                                                    d = 8
                                                } else {
                                                    g = D.x + c.offsetWidth;
                                                    d = D.y
                                                }
                                            }
                                            p = this.newId("-cX-Menu-");
                                            q = this.$cX("div", {
                                                id: p,
                                                className: "CanvasXpressMenu draggable"
                                            }, {
                                                left: g + "px",
                                                top: d + "px",
                                                zIndex: this.menuIndex++
                                            })
                                        }
                                        var k = this.$cX("ul", {
                                            id: this.newId("-cX-List-"),
                                            className: "CanvasXpressList",
                                            header: z,
                                            colorBackground: n
                                        });
                                        q.appendChild(k);
                                        j.appendChild(q);
                                        var v = this.maxSubMenus;
                                        var r = a.length > v ? v : a.length;
                                        if (a.length > v && this.graphType != "Network") {
                                            k.rawMenu = a;
                                            k.rawMenuIndex = 0;
                                            this.addMenuItemScroller(k, "Top")
                                        }
                                        for (var t = 0; t < r; t++) {
                                            if (a[t][0] == "-") {
                                                this.addMenuItemSep(k)
                                            } else {
                                                if (a[t][0] == "-text-") {
                                                    this.addMenuItemText(a[t], k)
                                                } else {
                                                    if (a[t][0] == "-color-") {
                                                        this.addMenuItemColor(a[t], k)
                                                    } else {
                                                        if (a[t][0] == "-slider-") {
                                                            this.addMenuItemSlider(a[t], k)
                                                        } else {
                                                            if (a[t][0] == "-filter-") {
                                                                this.addMenuItemFilter(a[t], k)
                                                            } else {
                                                                this.addMenuItem(a[t], k)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (a.length > v) {
                                            this.addMenuItemScroller(k, "Bottom")
                                        }
                                    }
                                    return p
                                };
                                this.pageMenuItem = function(e, f) {
                                    var g, j, a, i;
                                    var h = e.rawMenuMatch || e.rawMenu;
                                    if (h) {
                                        var d = e.childNodes.length - 2;
                                        if (f == "Top" && e.rawMenuIndex > 0) {
                                            g = e.childNodes[e.childNodes.length - 2];
                                            j = h[e.rawMenuIndex - 1];
                                            a = e.childNodes[2];
                                            i = true;
                                            e.rawMenuIndex--
                                        } else {
                                            if (f == "Bottom" && h.length > (e.rawMenuIndex + d)) {
                                                g = e.childNodes[2];
                                                j = h[e.rawMenuIndex + d];
                                                a = e.childNodes[e.childNodes.length - 1];
                                                i = true;
                                                e.rawMenuIndex++
                                            }
                                        }
                                        if (i) {
                                            this.addRemoveItemListeners("removeEvtListener", g);
                                            g.parentNode.removeChild(g);
                                            if (j[0] == "-") {
                                                this.addMenuItemSep(e, a)
                                            } else {
                                                if (j[0] == "-text-") {
                                                    this.addMenuItemText(j, e, a)
                                                } else {
                                                    if (j[0] == "-color-") {
                                                        this.addMenuItemColor(j, e, a)
                                                    } else {
                                                        if (j[0] == "-slider-") {
                                                            this.addMenuItemSlider(j, e, a)
                                                        } else {
                                                            if (j[0] == "-filter-") {
                                                                this.addMenuItemFilter(j, e, a)
                                                            } else {
                                                                this.addMenuItem(j, e, a)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.filterScrollSearch = function(b) {
                                    var k = this.$(b);
                                    if (k) {
                                        var c = k.value;
                                        var n = new RegExp(k.value, "i");
                                        var h = k.parentNode.parentNode;
                                        var j = h.rawMenu;
                                        var f = [];
                                        for (var e = 0; e < j.length; e++) {
                                            if (j[e][0].match(n)) {
                                                f.push(j[e])
                                            }
                                        }
                                        if (f.length != j.length) {
                                            h.rawMenuMatch = f
                                        } else {
                                            delete(h.rawMenuMatch)
                                        }
                                        while (h.childNodes.length > 0) {
                                            var d = h.childNodes[0];
                                            this.addRemoveItemListeners("removeEvtListener", d);
                                            h.removeChild(d)
                                        }
                                        var m = this.maxSubMenus;
                                        var g = f.length > m ? m : f.length;
                                        h.rawMenuIndex = 0;
                                        var a = this.addMenuItemScroller(h, "Top", c);
                                        for (var e = 0; e < g; e++) {
                                            this.addMenuItem(f[e], h)
                                        }
                                        this.addMenuItemScroller(h, "Bottom");
                                        a.focus();
                                        a.value = c
                                    }
                                };
                                this.addMenuItemSep = function(d, a) {
                                    var c = this.$cX("li", {
                                        id: this.newId("-cX-List-Item-Sep-"),
                                        className: "CanvasXpressListItemSep"
                                    });
                                    var e = this.$cX("span", {
                                        id: this.newId("-cX-List-Item-Text-Sep-"),
                                        className: "CanvasXpressListItemTextSep",
                                        innerHTML: "&nbsp;"
                                    });
                                    c.appendChild(e);
                                    if (a) {
                                        a.parentNode.insertBefore(c, a)
                                    } else {
                                        d.appendChild(c)
                                    }
                                };
                                this.addMenuItemScroller = function(c, d) {
                                    var b = this.$cX("li", {
                                        id: this.newId("-cX-List-Item-Scroll-" + d),
                                        className: "CanvasXpressListItemScroll" + d
                                    });
                                    var f = this.$cX("span", {
                                        id: this.newId("-cX-List-Item-Text-Scroll-" + d),
                                        className: "CanvasXpressListItemTextScroll" + d,
                                        innerHTML: "&nbsp;"
                                    });
                                    b.appendChild(f);
                                    c.appendChild(b);
                                    this.addRemoveItemListeners("addEvtListener", b);
                                    if (d == "Top") {
                                        var a = this.$cX("li", {
                                            id: this.newId("-cX-List-Item-Scroll-Search"),
                                            className: "CanvasXpressListItemScrollSearch" + d
                                        });
                                        var e = this.$cX("input", {
                                            id: this.newId("-cX-List-Item-Scroll-Search-Input"),
                                            className: "CanvasXpressListItemScrollSearch",
                                            type: "text",
                                            placeholder: " Search menu"
                                        });
                                        a.appendChild(e);
                                        c.appendChild(a);
                                        return e
                                    }
                                };
                                this.getMenuItemValue = function(d) {
                                    if (d[2][2]) {
                                        var c = this.cloneObject(d[2][2]);
                                        var b = this;
                                        while (c.length > 0) {
                                            var a = c.shift();
                                            if (b[a]) {
                                                b = b[a]
                                            } else {
                                                return ""
                                            }
                                        }
                                        return b != null ? b : ""
                                    } else {
                                        return this[d[2][0]] || ""
                                    }
                                };
                                this.addMenuItem = function(r, j, w) {
                                    var d = this.newId("-cX-List-Item-");
                                    var t = this.$cX("li", {
                                        id: d,
                                        className: "CanvasXpressListItem",
                                        click: r[2],
                                        params: r[3] || [],
                                        upload: r[0] && r[0] == "Load" ? true : false,
                                        uploadParams: r[0] && r[0] == "Load Parameters" ? true : false
                                    });
                                    if (j.colorBackground) {
                                        var c = CanvasXpress.colorSchemes[r[0]];
                                        var m, e, f;
                                        if (c && c[3]) {
                                            m = this.rgbToHex(c[3][0]);
                                            e = this.rgbToHex(c[3][1]);
                                            f = this.rgbToHex(c[3][2])
                                        } else {
                                            var z = this.getKeys(c).sort(function(l, i) {
                                                return l - i
                                            });
                                            var h = c[z[0]].length;
                                            m = this.rgbToHex(c[z[0]][0]);
                                            e = this.rgbToHex(c[z[0]][Math.floor(h / 2)]);
                                            f = this.rgbToHex(c[z[0]][h - 1])
                                        }
                                        t.style.background = "linear-gradient(to right, " + m + "70 33%, " + e + "70 33% 67%, " + f + "70 67%)"
                                    }
                                    var x;
                                    var k = {
                                        cursor: "grab",
                                        cursor: "-moz-grab",
                                        cursor: "-webkit-grab"
                                    };
                                    var y = false;
                                    if (r[5]) {
                                        x = this.$cX("a", {
                                            id: this.newId("-cX-List-Item-A-"),
                                            className: "CanvasXpressListItemAArrow",
                                            hidefocus: "true",
                                            unselectable: "on",
                                            href: "#",
                                            menu: d,
                                            menuId: "false",
                                            menuFunc: r[5],
                                            menuParm: r[6],
                                            draggable: false
                                        }, k);
                                        y = true
                                    } else {
                                        x = this.$cX("a", {
                                            id: this.newId("-cX-List-Item-A-"),
                                            className: "CanvasXpressListItemA",
                                            hidefocus: "true",
                                            unselectable: "on",
                                            href: "#",
                                            menuFunc: r[2],
                                            menuParm: r[3],
                                            draggable: false
                                        })
                                    }
                                    var v = this.$cXI(r[1] && CanvasXpress.icons.use.hasOwnProperty(r[1]) ? r[1] : CanvasXpress.png, {
                                        id: this.newId("-cX-List-Icon-"),
                                        className: "CanvasXpressListIcon",
                                        src: r[1],
                                        key: r[1]
                                    });
                                    var n;
                                    if (r[0] && (r[0] == "Load" || r[0] == "Load Parameters")) {
                                        n = this.$cX("span", {
                                            id: this.newId("-cX-List-Item-Text-"),
                                            className: "CanvasXpressListItemText",
                                            draggable: false
                                        }, {
                                            marginRight: 0
                                        });
                                        var g = this.$cX("input", {
                                            id: this.newId("-cX-List-Item-Text-File-Upload"),
                                            className: "CanvasXpressListItemText",
                                            type: "file",
                                            draggable: false
                                        }, {
                                            color: "transparent",
                                            width: "100px"
                                        });
                                        n.appendChild(g)
                                    } else {
                                        n = this.$cX("span", {
                                            id: this.newId("-cX-List-Item-Text-"),
                                            className: "CanvasXpressListItemText",
                                            innerHTML: r[0] || "",
                                            draggable: false
                                        }, y ? k : false)
                                    }
                                    if (j.colorBackground) {
                                        n.style.fontWeight = "bolder"
                                    }
                                    var p = this.$cX("span", {
                                        className: "CanvasXpressListItemTextShort",
                                        innerHTML: r[4] || "",
                                        draggable: false
                                    });
                                    x.appendChild(v);
                                    x.appendChild(n);
                                    x.appendChild(p);
                                    t.appendChild(x);
                                    if (w) {
                                        w.parentNode.insertBefore(t, w)
                                    } else {
                                        j.appendChild(t)
                                    }
                                    this.addRemoveItemListeners("addEvtListener", t)
                                };
                                this.addMenuItemText = function(c, m, j) {
                                    var h = this.newId("-cX-List-Item-Text-");
                                    var f = this.newId("-cX-List-Item-Text-Input-");
                                    var d = this.getMenuItemValue(c);
                                    var e = this.$cX("li", {
                                        id: h,
                                        className: "CanvasXpressListItem",
                                        click: c[1],
                                        params: [c[2], f]
                                    });
                                    var n = this.$cX("input", {
                                        id: f,
                                        className: "CanvasXpressList",
                                        type: "text",
                                        value: d
                                    }, {
                                        paddingLeft: "3px",
                                        width: "200px"
                                    });
                                    var k = this.$cX("a", {
                                        id: this.newId("-cX-List-Text-Item-A-"),
                                        className: "CanvasXpressListItemA",
                                        hidefocus: "true",
                                        unselectable: "on",
                                        href: "#"
                                    });
                                    var g = this.$cXI("op_refresh", {
                                        id: this.newId("-cX-List-Text-Icon-"),
                                        className: "CanvasXpressListIcon",
                                        src: "op_refresh",
                                        key: "refreshForm"
                                    }, {
                                        marginTop: "4px"
                                    });
                                    k.appendChild(g);
                                    k.appendChild(n);
                                    e.appendChild(k);
                                    if (j) {
                                        j.parentNode.insertBefore(e, j)
                                    } else {
                                        m.appendChild(e)
                                    }
                                    this.addRemoveItemListeners("addEvtListener", e)
                                };
                                this.addMenuItemColor = function(E, v, L) {
                                    var m = this.newId("-cX-List-Item-Color-");
                                    var n = this.newId("-cX-List-Item-Color-Container-");
                                    var g = this.newId("-cX-List-Item-Color-Current-");
                                    var B = this.newId("-cX-List-Item-Color-Palete-");
                                    var f = this.newId("-cX-List-Item-Color-Palete-Current-");
                                    var k = this.newId("-cX-List-Item-Color-Saturation-");
                                    var w = this.newId("-cX-List-Item-Color-Saturation-Current-");
                                    var N = this[E[2][0]] || "";
                                    var G = this.$cX("li", {
                                        id: m,
                                        className: "CanvasXpressListItem",
                                        click: E[1],
                                        params: [E[2], g],
                                        palete: B,
                                        paleteCurrent: f,
                                        colorCurrent: g,
                                        saturation: k,
                                        saturationCurrent: w
                                    });
                                    var M = this.$cX("a", {
                                        id: this.newId("-cX-List-Color-Item-A-"),
                                        className: "CanvasXpressListItemA",
                                        hidefocus: "true",
                                        unselectable: "on",
                                        href: "#"
                                    }, {
                                        height: "140px",
                                        width: "250px"
                                    });
                                    var I = this.$cXI("op_refresh", {
                                        id: this.newId("-cX-List-Color-Icon-"),
                                        className: "CanvasXpressListIcon",
                                        src: "op_refresh",
                                        key: "refreshForm"
                                    }, {
                                        marginTop: "2px"
                                    });
                                    var J = N ? this.rgbToHex(this.validateColor(N.replace(/[\'\"]/g, ""))) : this.foreground;
                                    this.colorRGBfromString(J);
                                    var t = Math.round(this.colorHSV[0] / 6 * 180);
                                    var r = Math.round((1 - this.colorHSV[1]) * 100);
                                    var q = Math.round((1 - this.colorHSV[2]) * 100);
                                    var K = this.$cX("div", {
                                        id: n
                                    }, {
                                        width: "188px",
                                        height: "138px",
                                        cssFloat: "left"
                                    });
                                    var C = this.$cX("div", {
                                        id: g,
                                        parentItem: m,
                                        className: "CanvasXpressConfiguratorColor",
                                        value: N
                                    }, {
                                        width: "203px",
                                        height: "24px",
                                        cssFloat: "left",
                                        marginBottom: "5px",
                                        cursor: "default",
                                        lineHeight: "24px"
                                    });
                                    var D = this.$cX("div", {
                                        id: B,
                                        parentItem: m,
                                        className: "CanvasXpressConfiguratorColorMain"
                                    }, {
                                        position: "relative",
                                        left: "0px",
                                        top: "0px",
                                        width: "181px",
                                        height: "101px"
                                    });
                                    var d = this.$cX("div", {
                                        id: f,
                                        parentItem: m,
                                        className: "CanvasXpressConfiguratorColorExtra"
                                    }, {
                                        position: "relative",
                                        left: (t - 7) + "px",
                                        top: (r - 7) + "px",
                                        width: "195px",
                                        height: "115px"
                                    });
                                    D.appendChild(d);
                                    var A = this.$cX("div", {
                                        id: k,
                                        parentItem: m,
                                        className: "CanvasXpressConfiguratorColor"
                                    }, {
                                        position: "relative",
                                        left: "188px",
                                        top: "-102px",
                                        width: "15px",
                                        height: "100px",
                                        border: "1px solid rgb(51,122,183)",
                                        clear: "left",
                                        cursor: "c_rosshair"
                                    });
                                    for (var H = 0; H < 100; H += 4) {
                                        var F = this.$cX("div", false, {
                                            height: "4px",
                                            position: "relative",
                                            left: "0px",
                                            cursor: "c_rosshair"
                                        });
                                        A.appendChild(F)
                                    }
                                    var e = this.$cX("div", {
                                        id: w,
                                        parentItem: m,
                                        className: "CanvasXpressConfiguratorColorExtra"
                                    }, {
                                        position: "relative",
                                        left: "0px",
                                        top: (q - 108) + "px",
                                        width: "29px",
                                        height: "115px"
                                    });
                                    A.appendChild(e);
                                    K.appendChild(C);
                                    K.appendChild(D);
                                    K.appendChild(A);
                                    M.appendChild(I);
                                    M.appendChild(K);
                                    G.appendChild(M);
                                    if (L) {
                                        L.parentNode.insertBefore(G, L)
                                    } else {
                                        v.appendChild(G)
                                    }
                                    this.colorizeCurrentItemColor(G);
                                    this.colorizeSaturationItemColor(G);
                                    this.addRemoveItemListeners("addEvtListener", G)
                                };
                                this.colorizeCurrentItemColor = function(a) {
                                    var e = this.$(a.colorCurrent);
                                    if (e) {
                                        var d = this.colorRGBToString();
                                        var b = this.hexToRgb("#" + d);
                                        e.style.backgroundColor = "#" + d;
                                        e.innerHTML = "&nbsp;&nbsp;" + b;
                                        e.style.color = this.complementaryColor(b, true);
                                        e.value = b
                                    }
                                };
                                this.colorizeSaturationItemColor = function(a) {
                                    var d = function(m, k, c, j, h) {
                                        return "rgb(" + (m * (1 - j / h) * 100) + "%," + (k * (1 - j / h) * 100) + "%," + (c * (1 - j / h) * 100) + "%)"
                                    };
                                    var f = this.$(a.saturation);
                                    if (f && this.colorHSV) {
                                        var g = f.childNodes;
                                        var b = this.hsvFromRgb(this.colorHSV[0], this.colorHSV[1], 1);
                                        if (b) {
                                            for (var e = 0; e < g.length - 1; e++) {
                                                g[e].style.backgroundColor = d(b[0], b[1], b[2], e, g.length - 1)
                                            }
                                        }
                                    }
                                };
                                this.updateColorItemValue = function(b, c) {
                                    if (!b) {
                                        var g = this.getMenuItemComp(c);
                                        if (g) {
                                            b = g[0]
                                        } else {
                                            return false
                                        }
                                    }
                                    if (this.changingColorItemOn) {
                                        if (this.changingColorItemOn == "palette") {
                                            var a = this.$(b.palete);
                                            var h = this.$(b.paleteCurrent);
                                            if (a && h) {
                                                var j = this.adjustedCoordinates(c, a);
                                                if (j) {
                                                    var i = Math.min(Math.max(0, j.x), 181);
                                                    var f = Math.min(Math.max(0, j.y - 25), 101);
                                                    h.style.left = (i - 7) + "px";
                                                    h.style.top = (f - 7) + "px";
                                                    this.colorFromHsv(i * 6 / 180, 1 - f / 100, null);
                                                    this.colorizeCurrentItemColor(b);
                                                    this.colorizeSaturationItemColor(b)
                                                }
                                            }
                                        } else {
                                            var k = this.$(b.saturation);
                                            var d = this.$(b.saturationCurrent);
                                            if (k && d) {
                                                var j = this.adjustedCoordinates(c, k);
                                                if (j) {
                                                    var f = Math.min(Math.max(0, j.y - 25), 101);
                                                    d.style.top = (f - 108) + "px";
                                                    this.colorFromHsv(null, null, 1 - f / 100);
                                                    this.colorizeCurrentItemColor(b)
                                                }
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.endColorItemChange = function(a) {
                                    this.changingColorItemOn = false
                                };
                                this.addMenuItemSlider = function(q, m, I) {
                                    var f = this.newId("-cX-List-Item-Slider-");
                                    var e = this.newId("-cX-List-Item-Slider-Container-");
                                    var E = this.newId("-cX-List-Item-Slider-Table-");
                                    var K = q[2][0] || "";
                                    var D = this.formatNumber(this.binConfigurations[K]["max"], this.binConfigurations[K]["dec"]);
                                    var v = this.$cX("li", {
                                        id: f,
                                        className: "CanvasXpressListItem",
                                        click: q[1],
                                        params: [q[2][0], e],
                                        slider: K
                                    });
                                    var J = this.$cX("a", {
                                        id: this.newId("-cX-List-Slider-Item-A-"),
                                        className: "CanvasXpressListItemA",
                                        hidefocus: "true",
                                        unselectable: "on",
                                        href: "#"
                                    });
                                    var H = this.$cX("div", {
                                        id: e,
                                        className: "CanvasXpressList"
                                    });
                                    var n = this.$cX("table", {
                                        id: E,
                                        className: "CanvasXpressListItemTable"
                                    }, {
                                        width: "100%"
                                    });
                                    var g = this.$cX("tbody");
                                    var h = D.length * 8;
                                    for (var B = 0; B < this.binConfigurations[K]["n"]; B++) {
                                        var s = Number(B > 0 ? this.binConfigurations[K]["bins"][B - 1]["value"] : this.binConfigurations[K]["min"]);
                                        var A = Number(B < this.binConfigurations[K]["n"] - 1 ? this.binConfigurations[K]["bins"][B + 1]["value"] : this.binConfigurations[K]["max"]);
                                        var k = this.$cX("input", {
                                            id: E + "-Range-" + B,
                                            className: "CanvasXpressListItem",
                                            type: "range",
                                            value: this.binConfigurations[K]["bins"][B]["value"],
                                            min: s,
                                            max: A,
                                            step: Number(this.formatNumber((A - s) / 20, this.binConfigurations[K]["dec"])),
                                            slider: K,
                                            sliderRange: B,
                                            sliderNumber: false
                                        }, {
                                            width: "120px"
                                        });
                                        var j = this.$cX("input", {
                                            id: E + "-Number-" + B,
                                            className: "CanvasXpressListItem",
                                            type: "number",
                                            value: this.binConfigurations[K]["bins"][B]["value"],
                                            min: s,
                                            max: A,
                                            step: Number(this.formatNumber((A - s) / 20, this.binConfigurations[K]["dec"])),
                                            slider: K,
                                            sliderRange: B,
                                            sliderNumber: true
                                        }, {
                                            width: (h + 18) + "px",
                                            textAlign: "right"
                                        });
                                        var c = this.$cX("tr");
                                        var G = this.$cX("th", {
                                            innerHTML: this.binConfigurations[K]["bins"][B]["name"]
                                        }, {
                                            paddingRight: "5px"
                                        });
                                        var F = this.$cX("td", {
                                            id: E + "-Min-" + B,
                                            innerHTML: this.formatNumber(s, this.binConfigurations[K]["dec"])
                                        }, {
                                            width: h + "px",
                                            textAlign: "right"
                                        });
                                        var C = this.$cX("td");
                                        C.appendChild(k);
                                        var z = this.$cX("td", {
                                            id: E + "-Max-" + B,
                                            innerHTML: this.formatNumber(A, this.binConfigurations[K]["dec"])
                                        }, {
                                            width: h + "px"
                                        });
                                        var w = this.$cX("td", false, {
                                            paddingLeft: "5px"
                                        });
                                        w.appendChild(j);
                                        c.appendChild(G);
                                        c.appendChild(F);
                                        c.appendChild(C);
                                        c.appendChild(z);
                                        c.appendChild(w);
                                        g.appendChild(c)
                                    }
                                    n.appendChild(g);
                                    H.appendChild(n);
                                    H.appendChild(this.$cX("br"));
                                    var p = this.$cXI("op_refresh", {
                                        id: this.newId("-cX-List-Icon-"),
                                        className: "CanvasXpressListIcon",
                                        src: "op_refresh",
                                        key: "refreshForm"
                                    }, {
                                        marginTop: "4px"
                                    });
                                    J.appendChild(p);
                                    J.appendChild(H);
                                    v.appendChild(J);
                                    if (I) {
                                        I.parentNode.insertBefore(v, I)
                                    } else {
                                        m.appendChild(v)
                                    }
                                    this.addRemoveItemListeners("addEvtListener", v)
                                };
                                this.updateSliderItemValue = function(h) {
                                    var a = this.changingSliderItemOn.slider;
                                    var g = this.changingSliderItemOn.sliderRange;
                                    var c = Number(this.formatNumber(this.changingSliderItemOn.value, this.binConfigurations[a]["dec"]));
                                    var d = this.$(this.changingSliderItemOn.id.replace("-Range-", "-Number-"));
                                    var f = this.$(this.changingSliderItemOn.id.replace("-Range-" + g, "-Range-" + (g - 1)));
                                    var j = this.$(this.changingSliderItemOn.id.replace("-Range-" + g, "-Max-" + (g - 1)));
                                    var b = this.$(this.changingSliderItemOn.id.replace("-Range-" + g, "-Range-" + (g + 1)));
                                    var i = this.$(this.changingSliderItemOn.id.replace("-Range-" + g, "-Min-" + (g + 1)));
                                    this.binConfigurations[a]["bins"][g]["value"] = c;
                                    if (d) {
                                        d.value = c
                                    }
                                    if (f && j) {
                                        f.max = c;
                                        f.step = (f.max - f.min) / 20;
                                        j.innerHTML = c
                                    }
                                    if (b && i) {
                                        b.min = c;
                                        b.step = (b.max - b.min) / 20;
                                        i.innerHTML = c
                                    }
                                    this.applySliderItemValue(a);
                                    return false
                                };
                                this.endSliderItemChange = function(g) {
                                    if (this.changingSliderItemOn.sliderNumber) {
                                        var a = this.changingSliderItemOn.slider;
                                        var f = this.changingSliderItemOn.sliderRange;
                                        var c = Number(this.formatNumber(this.changingSliderItemOn.value, this.binConfigurations[a]["dec"]));
                                        var i = this.$(this.changingSliderItemOn.id.replace("-Number-", "-Range-"));
                                        var d = this.$(this.changingSliderItemOn.id.replace("-Number-" + f, "-Range-" + (f - 1)));
                                        var j = this.$(this.changingSliderItemOn.id.replace("-Number-" + f, "-Max-" + (f - 1)));
                                        var b = this.$(this.changingSliderItemOn.id.replace("-Number-" + f, "-Range-" + (f + 1)));
                                        var h = this.$(this.changingSliderItemOn.id.replace("-Number-" + f, "-Min-" + (f + 1)));
                                        this.binConfigurations[a]["bins"][f]["value"] = c;
                                        if (i) {
                                            i.value = c
                                        }
                                        if (d && j) {
                                            d.max = c;
                                            d.step = (d.max - d.min) / 20;
                                            j.innerHTML = c
                                        }
                                        if (b && h) {
                                            b.min = c;
                                            b.step = (b.max - b.min) / 20;
                                            h.innerHTML = c
                                        }
                                        this.applySliderItemValue(a)
                                    }
                                    this.changingSliderItemOn = false
                                };
                                this.applySliderItemValue = function(f) {
                                    var a = this.binConfigurations[f]["name"];
                                    var e = this.binConfigurations[f]["vi"];
                                    this.data.x[a] = [];
                                    for (var d = 0; d < this.data.y.data[e].length; d++) {
                                        var b = this.data.y.data[e][d];
                                        if (!isNaN(b) && b !== "" && b != null) {
                                            for (var c = 0; c < this.binConfigurations[f]["n"]; c++) {
                                                if (b <= this.binConfigurations[f]["bins"][c].value) {
                                                    this.data.x[a][d] = this.binConfigurations[f]["bins"][c].name;
                                                    break
                                                }
                                            }
                                        } else {
                                            this.data.x[a][d] = ""
                                        }
                                    }
                                    if (this.isGroupedData) {
                                        this.ungroupSamples(true)
                                    }
                                    this.updateData(this.data);
                                    this.groupSamples([a]);
                                    this.sortSamplesByCategory([a])
                                };
                                this.addMenuItemFilter = function(f, d, a) {
                                    var e = this.newId("-cX-List-Item-");
                                    var c = this.$cX("li", {
                                        id: e,
                                        className: "CanvasXpressListItem",
                                        type: "filter",
                                        selector: f[1].id.split(":")[1]
                                    });
                                    c.appendChild(f[1]);
                                    if (a) {
                                        a.parentNode.insertBefore(c, a)
                                    } else {
                                        d.appendChild(c)
                                    }
                                };
                                this.addRemoveItemListeners = function(b, a) {
                                    if (!a) {
                                        return this.removeMenus()
                                    } else {
                                        if (a.className == "CanvasXpressListItemSep") {
                                            return
                                        }
                                    }
                                    var g = a.parentNode.parentNode;
                                    var d = false;
                                    var h = a.id.match("-cX-List-Item-Color-");
                                    if (this.hasClass(g, "draggable") && !h) {
                                        this[b](g, "mousedown", this.registerMousemove, d)
                                    }
                                    if (a.upload) {
                                        var e = a.childNodes[0].childNodes[1].childNodes[0];
                                        this[b](e, "change", this.loadFile, d)
                                    } else {
                                        if (a.uploadParams) {
                                            var e = a.childNodes[0].childNodes[1].childNodes[0];
                                            this[b](e, "change", this.loadParamsFile, d)
                                        } else {
                                            this[b](a, "click", this.clickMenuItem, d)
                                        }
                                    }
                                    this[b](a, "mouseover", this.mouseoverMenuItem, d);
                                    this[b](a, "mouseout", this.mouseoutMenuItem, d);
                                    this[b](a, "mousewheel", this.mousewheelMenuItem, d);
                                    this[b](a, "contextmenu", this.contextMenuItem, d);
                                    if (a.className.match(/Scroll/)) {
                                        this[b](a, "mousedown", this.mousedownMenuItem, d);
                                        this[b](a, "mouseup", this.mouseupMenuItem, d)
                                    }
                                    if (a.paleteCurrent && a.saturation) {
                                        this[b](a, "mousedown", this.mousedownMenuItemColor, d)
                                    }
                                    if (a.slider) {
                                        this[b](a, "mousedown", this.mousedownMenuItemSlider, d)
                                    }
                                };
                                this.contextMenuItem = function(a) {
                                    return function(h) {
                                        a.cancelEvent(h);
                                        var b = a.getTargetEvent(h);
                                        var n = a.getMenuItemComp(h);
                                        var f = n[1].childNodes[0];
                                        var g = n[1].childNodes[1].innerText;
                                        var k = n[1].menuFunc;
                                        var j = n[1].menuParm;
                                        var p = n[1].menuId;
                                        var q = n[2].offsetLeft;
                                        var l = n[2].offsetTop + n[1].offsetTop;
                                        a.removeMenus();
                                        var o = [
                                            ["Pin " + g + " to Toolbar", "fp_pin", "pinToToolbar", [f, g, k, j, p, false, true]]
                                        ];
                                        var d = a.addMenu(h, o);
                                        var c = a.$(d);
                                        c.style.left = q + "px";
                                        c.style.top = l + "px";
                                        c.style.display = "block";
                                        return false
                                    }
                                }(this);
                                this.pinToToolbar = function(c, d, f, e, g, i, h) {
                                    this.removeMenus();
                                    var b = this.$(this.target + "-cX-Toolbar-Custom");
                                    if (b) {
                                        var a = this.target + "-cX-Custom-Toolbar-Menu-" + f;
                                        if (!this.$(a)) {
                                            c.id = a;
                                            c.className = "CanvasXpressToolbarImage";
                                            c.style.width = "24px";
                                            c.style.height = "24px";
                                            c.style.cssFloat = "left";
                                            c.title = d;
                                            c.fun = f;
                                            c.par = this.stringifyJSON(e);
                                            c.mid = g || this.newId("-cX-Default-Toolbar-Menu-");
                                            c.style.setProperty("background-color", this.background, "important");
                                            if (h) {
                                                b.insertBefore(c, b.firstChild)
                                            } else {
                                                b.appendChild(c)
                                            }
                                            if (!this.disableToolbar) {
                                                this.addRemoveEvtListener("addEvtListener", c, "click", this.addCustomToolbarMenu, false);
                                                this.addRemoveEvtListener("addEvtListener", c, "contextmenu", this.unpinFromToolbar, false)
                                            }
                                            if (!i) {
                                                CanvasXpress.stack[this.target].afterRender.push(["addImageToToolbar", [c.key, d, f, e, g]])
                                            }
                                        }
                                    }
                                };
                                this.unpinFromToolbar = function(a) {
                                    return function(j) {
                                        a.cancelEvent(j);
                                        var c = a.getTargetEvent(j);
                                        var g = c.offsetLeft;
                                        var h = c.offsetTop;
                                        var f = [
                                            ["Unpin " + c.title + " from Toolbar", "fp_pinremove", "removeImageFromToolbar", [c.id]]
                                        ];
                                        var d = a.addMenu(j, f);
                                        var b = a.$(d);
                                        b.style.left = g + "px";
                                        b.style.top = h + "px";
                                        b.style.display = "block";
                                        return false
                                    }
                                }(this);
                                this.addCustomToolbarMenu = function(a) {
                                    return function(h) {
                                        a.cancelEvent(h);
                                        var d = a.getTargetEvent(h);
                                        var g = d.getAttribute("par");
                                        var j = a[d.fun].apply(a, g ? a.parseJSON(g) : []);
                                        if (d.mid) {
                                            a.removeMenus();
                                            var f = a.addMenu(false, j);
                                            var b = a.$(f);
                                            if (d.id.match(/DataExplorer/)) {
                                                if (a.menuIndex < 10002) {
                                                    a.menuIndex = 10002
                                                }
                                                var k = a.getBoundingClientRect(d);
                                                b.style.left = parseInt(k.left) + "px";
                                                b.style.top = parseInt(k.top) + "px";
                                                b.style.zIndex = a.menuIndex++
                                            } else {
                                                b.style.left = d.offsetLeft + "px";
                                                b.style.top = "10px"
                                            }
                                            b.style.display = "block"
                                        }
                                    }
                                }(this);
                                this.addImageToToolbar = function(h, c, e, d, f, i, g, a) {
                                    var b;
                                    if (a) {
                                        b = this.$cX(h, {
                                            className: "CanvasXpressToolbarImage",
                                            src: h,
                                            key: h
                                        }, a)
                                    } else {
                                        b = this.$cX(h, {
                                            className: "CanvasXpressToolbarImage",
                                            src: h,
                                            key: h
                                        })
                                    }
                                    this.pinToToolbar(b, c, e, d, f, i, g)
                                };
                                this.removeImageFromToolbar = function(c, b) {
                                    var a = this.$(c);
                                    if (a && !this.disableToolbar) {
                                        this.addRemoveEvtListener("removeEvtListener", a, "click", this.addCustomToolbarMenu, false);
                                        this.addRemoveEvtListener("removeEvtListener", a, "contextmenu", this.unpinFromToolbar, false);
                                        a.parentNode.removeChild(a);
                                        this.removeMenus();
                                        if (!b) {
                                            CanvasXpress.stack[this.target].afterRender.push(["removeImageFromToolbar", [c]])
                                        }
                                    }
                                };
                                this.removeAllImagesFromToolbar = function() {
                                    var a = this.$(this.target + "-cX-Toolbar-Custom");
                                    if (a) {
                                        var b = a.getElementsByTagName("svg");
                                        while (b.length > 0) {
                                            this.removeImageFromToolbar(b[0].id, true)
                                        }
                                    }
                                };
                                this.clickMenuItem = function(a) {
                                    return function(h) {
                                        a.cancelEvent(h);
                                        var b = a.getTargetEvent(h);
                                        var m = a.getMenuItemComp(h);
                                        if (m && !/input|textarea|select/i.test(b.tagName)) {
                                            if (m[0].className.match(/Scroll/) || m[1].className.match(/Scroll/)) {
                                                var c = m[0].className.match(/Scroll/) ? m[0] : m[1];
                                                var n = c.parentNode;
                                                var j = c.className.match(/ScrollTop/) ? "Top" : "Bottom";
                                                a.pageMenuItem(n, j)
                                            } else {
                                                var f = [];
                                                if (m[0].params) {
                                                    for (var g = 0; g < m[0].params.length; g++) {
                                                        if (m[0].params[g] == "event") {
                                                            f.push(h)
                                                        } else {
                                                            if (m[0].params[g] == "component") {
                                                                f.push(m)
                                                            } else {
                                                                f.push(m[0].params[g])
                                                            }
                                                        }
                                                    }
                                                }
                                                if (a[m[0].click]) {
                                                    a[m[0].click].apply(a, f);
                                                    var o = m[1].firstChild;
                                                    var d = o.tagName.toUpperCase() == "SVG" ? o.getAttribute("key") : false;
                                                    if (d) {
                                                        if (d.match("sl_checkboxoff")) {
                                                            o.setAttribute("key", "sl_checkboxon");
                                                            a.$cXIU(o, "sl_checkboxon")
                                                        } else {
                                                            if (d.match("sl_checkboxon")) {
                                                                o.setAttribute("key", "sl_checkboxoff");
                                                                a.$cXIU(o, "sl_checkboxoff")
                                                            } else {
                                                                if (d.match("sl_eclose")) {
                                                                    o.setAttribute("key", "sl_eopen");
                                                                    a.$cXIU(o, "sl_eopen");
                                                                    m[1].childNodes[1].innerHTML = m[1].childNodes[1].innerHTML.replace("Hide", "Show")
                                                                } else {
                                                                    if (d.match("sl_eopen")) {
                                                                        o.setAttribute("key", "sl_eclose");
                                                                        a.$cXIU(o, "sl_eclose");
                                                                        m[1].childNodes[1].innerHTML = m[1].childNodes[1].innerHTML.replace("Show", "Hide")
                                                                    } else {
                                                                        if (d == "sl_lightbulbon") {
                                                                            o.setAttribute("key", "sl_lightbulboff");
                                                                            a.$cXIU(o, "sl_lightbulboff")
                                                                        } else {
                                                                            if (d == "sl_lightbulboff") {
                                                                                o.setAttribute("key", "sl_lightbulbon");
                                                                                a.$cXIU(o, "sl_lightbulbon")
                                                                            } else {
                                                                                if (d == "sr_azd") {
                                                                                    o.setAttribute("key", "sr_azi");
                                                                                    a.$cXIU(o, "sr_azi");
                                                                                    m[0].params[1] = "sr_azi"
                                                                                } else {
                                                                                    if (d == "sr_azi") {
                                                                                        o.setAttribute("key", "sr_azd");
                                                                                        a.$cXIU(o, "sr_azd");
                                                                                        m[0].params[1] = "sr_azd"
                                                                                    } else {
                                                                                        if (d.match("sl_radioon")) {
                                                                                            a.resetRadioMenuItem(m[2].firstChild.childNodes);
                                                                                            if (f[1] && f[1].match(/xAxis|yAxis|zAxis/)) {
                                                                                                o.setAttribute("key", "sl_radioon");
                                                                                                a.$cXIU(o, "sl_radioon")
                                                                                            } else {
                                                                                                o.setAttribute("key", "sl_radiooff");
                                                                                                a.$cXIU(o, "sl_radiooff")
                                                                                            }
                                                                                        } else {
                                                                                            if (d.match("sl_radiooff")) {
                                                                                                a.resetRadioMenuItem(m[2].firstChild.childNodes);
                                                                                                o.setAttribute("key", "sl_radioon");
                                                                                                a.$cXIU(o, "sl_radioon")
                                                                                            } else {
                                                                                                if ((d == "variables" || d == "samples") && f[0] == "sortDir") {
                                                                                                    m[0].params[1] = m[0].params[1] == "sr_azd" ? "sr_azi" : "sr_azd"
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            return false
                                        } else {
                                            return false
                                        }
                                    }
                                }(this);
                                this.resetRadioMenuItem = function(b) {
                                    for (var c = 0; c < b.length; c++) {
                                        var a = b[c].firstChild.firstChild;
                                        if (a && a.nodeName.match(/svg/i)) {
                                            this.$cXIU(a, "sl_radiooff", {
                                                src: "sl_radiooff",
                                                key: "sl_radiooff"
                                            })
                                        }
                                    }
                                };
                                this.adjustMenuItemPosition = function(f, p, o) {
                                    var g, x;
                                    var q = this.remoteParentId && this.$(this.remoteParentId) ? this.$(this.remoteParentId) : this.$("container-" + this.target);
                                    var i = window.innerWidth;
                                    var b = window.innerHeight;
                                    var u = q.offsetLeft;
                                    var k = q.offsetTop;
                                    var s = q.clientWidth;
                                    var j = q.clientHeight;
                                    var a = i - u;
                                    var v = f.clientWidth;
                                    var n = f.clientHeight;
                                    if (p) {
                                        g = p.offsetLeft + p.offsetWidth - 5;
                                        if (g + v + 5 > a) {
                                            g = p.offsetLeft - v + 5
                                        }
                                        x = p.offsetTop + o.offsetTop
                                    } else {
                                        g = f.offsetLeft;
                                        x = f.offsetTop
                                    }
                                    f.style.left = g + "px";
                                    f.style.top = x + "px"
                                };
                                this.mouseoverMenuItem = function(a) {
                                    return function(j) {
                                        var h = a.getMenuItemComp(j);
                                        if (!h) {
                                            return false
                                        }
                                        if ((h[0] && h[0].className && h[0].className.toString().match(/Scroll/)) || (h[1] && h[1].className && h[1].className.toString().match(/Scroll/))) {
                                            var n = h[0] && h[0].className && h[0].className.match(/Scroll/) ? h[0] : h[1];
                                            n.className += "Active";
                                            return false
                                        }
                                        var f = h[2].firstChild.childNodes;
                                        a.hideMenusRecursively(f);
                                        h[0].className = "CanvasXpressListItemActive";
                                        if (h[1] && h[1].menu) {
                                            var l = a[h[1].menuFunc].apply(a, h[1].menuParm);
                                            var g = a.addMenu(false, l, h[1].menu, false, false, false, false, false, h[1].innerText == "Scheme");
                                            var b = a.$(g);
                                            var k = h[2];
                                            b.style.left = "0px";
                                            b.style.top = "0px";
                                            b.style.display = "block";
                                            a.adjustMenuItemPosition(b, k, h[1]);
                                            h[1].className = "CanvasXpressListItemAArrowActive";
                                            h[1].menuId = g
                                        } else {
                                            if (h[1]) {
                                                h[1].className = "CanvasXpressListItemAActive"
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.mouseoutMenuItem = function(a) {
                                    return function(y) {
                                        if (a.fastScrollMenuOn) {
                                            a.fastScrollMenuOn = false;
                                            clearInterval(a.fastScrollMenu)
                                        }
                                        var w, v, u, s, h, g, f, c;
                                        var A = a.adjustedCoordinates(y);
                                        if (A) {
                                            var j = a.$("north-container-" + a.target);
                                            var k = a.$("west-container-" + a.target);
                                            A.x += k.offsetWidth;
                                            A.y += j.offsetHeight;
                                            var n = a.getMenuItemComp(y);
                                            if (!n) {
                                                return false
                                            } else {
                                                if (n[1] && n[1].menu) {
                                                    var p = a.$(n[1].menuId);
                                                    var o = p.firstChild.firstChild;
                                                    w = p.offsetLeft;
                                                    h = p.offsetTop;
                                                    v = w + p.offsetWidth;
                                                    g = h + p.offsetHeight;
                                                    if (A.x >= w && A.x <= v && A.y >= h && A.y <= g) {
                                                        return false
                                                    }
                                                    a.hideMenu(n, p);
                                                    if (o && o.type == "filter") {
                                                        var z = o.firstChild;
                                                        if (z.type == "string") {
                                                            var r = a.$(a.target + ":" + o.selector + ":cX-DataFilterMask");
                                                            if (r) {
                                                                a.addRemoveStringDataFilterListeners("removeEvtListener", r)
                                                            }
                                                        } else {
                                                            var q = a.$(a.target + ":" + o.selector + ":cX-DataFilterMin");
                                                            var l = a.$(a.target + ":" + o.selector + ":cX-DataFilterMinLabel");
                                                            var i = a.$(a.target + ":" + o.selector + ":cX-DataFilterRange");
                                                            var t = a.$(a.target + ":" + o.selector + ":cX-DataFilterMax");
                                                            var x = a.$(a.target + ":" + o.selector + ":cX-DataFilterMaxLabel");
                                                            var b = a.$(a.target + ":" + o.selector + ":cX-DataFilterScale");
                                                            if (q && l && i && t && x && b) {
                                                                a.addRemoveNumericDataFilterListeners("removeEvtListener", q, t, l, x, b)
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    a.hideMenu(n)
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.mousedownMenuItemColor = function(a) {
                                    return function(d) {
                                        var b = a.getTargetEvent(d);
                                        var c = a.getMenuItemComp(d);
                                        if (!c) {
                                            return false
                                        } else {
                                            if (b.id && b.id.match(/-cX-List-Item-Color-Palete-/)) {
                                                a.changingColorItemOn = "palette";
                                                if (a.colorHSV[2] == 0) {
                                                    a.colorFromHsv(null, null, 1);
                                                    a.colorizeCurrentItemColor(c[0]);
                                                    var f = a.$(c[0].saturationCurrent);
                                                    if (f) {
                                                        f.style.top = "-108px"
                                                    }
                                                }
                                                a.updateColorItemValue(c[0], d);
                                                a.colorizeSaturationItemColor(c[0])
                                            } else {
                                                if (b.parentNode.id && b.parentNode.id.match(/-cX-List-Item-Color-Saturation-/)) {
                                                    a.changingColorItemOn = "saturation";
                                                    a.updateColorItemValue(c[0], d)
                                                }
                                            }
                                        }
                                        a.cancelEvent(d);
                                        return false
                                    }
                                }(this);
                                this.mousedownMenuItemSlider = function(a) {
                                    return function(b) {
                                        a.changingSliderItemOn = a.getTargetEvent(b);
                                        return false
                                    }
                                }(this);
                                this.mousedownMenuItem = function(a) {
                                    return function(b) {
                                        a.fastScrollMenuOn = true;
                                        a.fastScrollMenu = a.setInterval(function() {
                                            a.clickMenuItem(b)
                                        }, 100);
                                        return false
                                    }
                                }(this);
                                this.mouseupMenuItem = function(a) {
                                    return function(b) {
                                        if (a.fastScrollMenuOn) {
                                            a.fastScrollMenuOn = false;
                                            clearInterval(a.fastScrollMenu)
                                        }
                                    }
                                }(this);
                                this.mousewheelMenuItem = function(a) {
                                    return function(g) {
                                        a.cancelEvent(g);
                                        var h = 0;
                                        if (g.wheelDelta) {
                                            h = g.wheelDelta;
                                            if (window.opera) {
                                                h = -h
                                            }
                                        } else {
                                            if (g.detail) {
                                                h = -g.detail
                                            }
                                        }
                                        if (h) {
                                            var b = a.getTargetEvent(g);
                                            var f = a.getMenuItemComp(g);
                                            if (!f) {
                                                return false
                                            }
                                            var c = f[0].parentNode;
                                            if (h > 0) {
                                                a.pageMenuItem(c, "Top")
                                            } else {
                                                a.pageMenuItem(c, "Bottom")
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.getMenuItemComp = function(b) {
                                    var a = this.getTargetEvent(b);
                                    while (a && a.tagName && !a.tagName.match(/li/i)) {
                                        a = a.parentNode
                                    }
                                    return a.parentNode && a.parentNode.parentNode ? [a, a.firstChild, a.parentNode.parentNode] : false
                                };
                                this.hideMenu = function(e, f) {
                                    if (e) {
                                        if ((e[0] && e[0].className && e[0].className.toString().match(/Scroll/)) || (e[1] && e[1].className && e[1].className.toString().match(/Scroll/))) {
                                            var g = e[0] && e[0].className && e[0].className.match(/Scroll/) ? e[0] : e[1];
                                            g.className = g.className.replace("Active", "")
                                        } else {
                                            if (e[0] || e[1]) {
                                                if (e[1] && e[1].menu) {
                                                    e[1].className = "CanvasXpressListItemAArrow"
                                                } else {
                                                    if (e[1]) {
                                                        e[1].className = "CanvasXpressListItemA"
                                                    }
                                                }
                                                if (e[0]) {
                                                    e[0].className = "CanvasXpressListItem"
                                                }
                                            }
                                        }
                                    }
                                    if (f) {
                                        var b = f.firstChild.childNodes;
                                        for (var d = 0; d < b.length; d++) {
                                            var a = b[d];
                                            if (!a.className.match(/Scroll|ItemSep/)) {
                                                this.addRemoveItemListeners("removeEvtListener", a)
                                            }
                                        }
                                        f.parentNode.removeChild(f)
                                    }
                                };
                                this.hideMenusRecursively = function(e) {
                                    for (var f = 0; f < e.length; f++) {
                                        var c = e[f];
                                        if (c && c.className && !c.className.toString().match(/Scroll|ItemSep/)) {
                                            var d = c.firstChild;
                                            var b = d && d.menu ? this.$(d.menuId) : false;
                                            if (b) {
                                                this.hideMenusRecursively(b.firstChild.childNodes)
                                            }
                                            this.hideMenu([c, d], b)
                                        }
                                    }
                                };
                                this.removeMenus = function(k) {
                                    var f = [];
                                    if (this.skipHeaderMouseout) {
                                        this.skipHeaderMouseout.className = "CanvasXpressTableCellHead";
                                        this.skipHeaderMouseout.firstChild.firstChild.className = "CanvasXpressTableCellHead";
                                        this.skipHeaderMouseout = false
                                    }
                                    if (!k) {
                                        var c = this.$("north-wrapper-" + this.target);
                                        if (c) {
                                            var h = c.getElementsByTagName("div");
                                            for (var g = 0; g < h.length; g++) {
                                                if (this.hasClass(h[g], "CanvasXpressMenu")) {
                                                    f.unshift(this.$(h[g].id))
                                                }
                                            }
                                        }
                                        this.menuIndex = 10000
                                    } else {
                                        f.push(this.$(this.target + "-cX-Menu-" + k))
                                    }
                                    if (f.length > 0) {
                                        for (g in this.meta.ids) {
                                            if (g.match(/cX-Menu-|cX-Menu/)) {
                                                delete(this.meta.ids[g])
                                            }
                                        }
                                        for (var g = 0; g < f.length; g++) {
                                            var a = f[g];
                                            var b = a.getElementsByTagName("li");
                                            for (var e = 0; e < b.length; e++) {
                                                if (b[e].className != "CanvasXpressListItemSep") {
                                                    this.addRemoveItemListeners("removeEvtListener", b[e])
                                                }
                                            }
                                            a.parentNode.removeChild(a)
                                        }
                                    }
                                    this.isMenu = false
                                };
                                this.changeAttributeMenu = function(f, c, d, e) {
                                    var a = [];
                                    if (e) {
                                        for (var b = 0; b < c.length; b++) {
                                            a.push([c[b], e[b], "changeAttribute", [f, d[b]]])
                                        }
                                    } else {
                                        for (var b = 0; b < c.length; b++) {
                                            a.push([c[b], this[f] == d[b] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [f, d[b]]])
                                        }
                                    }
                                    return a
                                };
                                this.changeTextColorAttributeMenu = function(a, b) {
                                    return this.isArray(b) ? [
                                        [a, "changeTextColorAttribute", b]
                                    ] : [
                                        [a, "changeTextColorAttribute", [b]]
                                    ]
                                };
                                this.getAxisLayoutTypeMenu = function() {
                                    var a = [];
                                    a.push(["Both panels ", this.scatterPlotMatrixType == "both" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["both"]]);
                                    a.push(["Upper panel ", this.scatterPlotMatrixType == "upper" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["upper"]]);
                                    a.push(["Lower panel ", this.scatterPlotMatrixType == "lower" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["lower"]]);
                                    a.push(["Correlation ", this.scatterPlotMatrixType == "densityCorrelation" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["correlation"]]);
                                    a.push(["Correlation - Density ", this.scatterPlotMatrixType == "correlationDensity" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["correlationDensity"]]);
                                    a.push(["Correlation - Histogram ", this.scatterPlotMatrixType == "correlationHistogram" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["correlationHistogram"]]);
                                    a.push(["All ", this.scatterPlotMatrixType == "all" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["all"]]);
                                    a.push(["First ", this.scatterPlotMatrixType == "first" ? "sl_radioon" : "sl_radiooff", "modifyLayoutType", ["first"]]);
                                    return a
                                };
                                this.getAxisLayoutMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Auto-Adjust", this.layoutAdjust ? "sl_lightbulbon" : "sl_lightbulbOff", "toggleAttribute", ["layoutAdjust"]]);
                                    a.push(["Type", "ly_splom", b, b, b, "getAxisLayoutTypeMenu", []]);
                                    return a
                                };
                                this.getAxisSampleMenu = function(c) {
                                    var d = [];
                                    var a = this.getObjectArray(this[c + "Axis"]);
                                    for (var b = 0; b < this.data.y.smps.length; b++) {
                                        d.push([this.data.y.smps[b], a[this.data.y.smps[b]] ? "sl_checkboxon" : "sl_checkboxoff", "changeSampleInAxis", [this.data.y.smps[b], c + "Axis"]])
                                    }
                                    return d
                                };
                                this.getAxisMenu = function(g, d) {
                                    var c = g.toUpperCase();
                                    var b = d ? "2" : "";
                                    var a = [];
                                    var e = false;
                                    a.push([this[g + "Axis" + b + "Show"] ? "Hide Axis" : "Show Axis", this[g + "AxisShow"] ? "sl_eclose" : "sl_eopen", "toggleAttribute", [g + "Axis" + b + "Show"]]);
                                    a.push(["Set Min", "dtp_min", e, e, e, "changeTextColorAttributeMenu", ["-text-", "setMin" + c + b]]);
                                    a.push(["Set Max", "dtp_max", e, e, e, "changeTextColorAttributeMenu", ["-text-", "setMax" + c + b]]);
                                    a.push(["Transform", "ch_ofx", e, e, e, "getAxisTransformMenu", [g]]);
                                    if (this.graphType == "Scatter3D" || this.graphType == "ScatterBubble2D" || this.is3DPlot) {
                                        a.push(["Exact Range", "dtp_exact", "toggleAttribute", [g + "AxisExact"]])
                                    }
                                    a.push(["Format", "tx_format", e, e, e, "changeTextColorAttributeMenu", ["-text-", g + "Axis" + b + "TickFormat"]]);
                                    if (this.graphType.match(/Scatter/)) {
                                        a.push(["Samples", "ch_ls", e, e, e, "getAxisSampleMenu", [g]])
                                    }
                                    return a
                                };
                                this.getFirstAxisMenu = function() {
                                    return [
                                        [this.xAxisShow ? "Hide Axis" : "Show Axis", this.xAxisShow ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["xAxisShow"]]
                                    ]
                                };
                                this.getSecondAxisMenu = function() {
                                    return [
                                        [this.xAxis2Show ? "Hide Axis" : "Show Axis", this.xAxis2Show ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["xAxis2Show"]]
                                    ]
                                };
                                this.getRangeAxisMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Set Min", "dtp_min", b, b, b, "changeTextColorAttributeMenu", ["-text-", "setMinX"]]);
                                    a.push(["Set Max", "dtp_max", b, b, b, "changeTextColorAttributeMenu", ["-text-", "setMaxX"]]);
                                    return a
                                };
                                this.getAxesMenu = function() {
                                    var b = [];
                                    var a = false;
                                    if (this.graphType == "Scatter2D") {
                                        b.push(["X-Axis", "p_g2axistitlex", a, a, a, "getAxisMenu", ["x"]]);
                                        b.push(["Y-Axis", "p_g2axistitley", a, a, a, "getAxisMenu", ["y"]]);
                                        b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "axisTickColor"]]);
                                        b.push(["Font", "ch_oaa", a, a, a, "getFontStyleMenu", ["axisTick"]]);
                                        if (this.scatterPlotMatrix) {
                                            b.push(["Axes Layout", "g_splom", a, a, a, "getAxisLayoutMenu", []])
                                        }
                                    } else {
                                        if (this.graphType == "Scatter3D" || this.graphType == "ScatterBubble2D" || this.is3DPlot) {
                                            b.push(["X-Axis", "p_g3axistitlex", a, a, a, "getAxisMenu", ["x"]]);
                                            b.push(["Y-Axis", "p_g3axistitley", a, a, a, "getAxisMenu", ["y"]]);
                                            b.push(["Z-Axis", "p_g3axistitlez", a, a, a, "getAxisMenu", ["z"]]);
                                            b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "axisTickColor"]]);
                                            b.push(["Font", "ch_oaa", a, a, a, "getFontStyleMenu", ["axisTick"]])
                                        } else {
                                            if (this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/)) {
                                                b.push(["First Axis", "p_g1axistitle1", a, a, a, "getAxisMenu", ["x"]]);
                                                b.push(["Second Axis", "p_g1axistitle2", a, a, a, "getAxisMenu", ["x", true]]);
                                                b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "axisTickColor"]]);
                                                b.push(["Font", "ch_oaa", a, a, a, "getFontStyleMenu", ["axisTick"]])
                                            } else {
                                                b.push(["First Axis", "p_g1axistitle1", a, a, a, "getFirstAxisMenu", []]);
                                                b.push(["Second Axis", "p_g1axistitle2", a, a, a, "getSecondAxisMenu", []]);
                                                b.push(["Range", "dtp_range", a, a, a, "getRangeAxisMenu", []]);
                                                b.push(["Format", "tx_format", a, a, a, "changeTextColorAttributeMenu", ["-text-", "xAxisTickFormat"]]);
                                                b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "axisTickColor"]]);
                                                b.push(["Font", "ch_oaa", a, a, a, "getFontStyleMenu", ["axisTick"]]);
                                                if (this.layoutValid) {
                                                    b.push(["Auto-Adjust", this.layoutAdjust ? "sl_lightbulbon" : "sl_lightbulboff", "toggleAttribute", ["layoutAdjust"]])
                                                }
                                            }
                                        }
                                    }
                                    return b
                                };
                                this.getHeatmapBoxMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "heatmapCellBoxColor"]]);
                                    b.push(["Width", "sp_thickness2", a, a, a, "changeTextColorAttributeMenu", ["-text-", "heatmapCellBoxWidth"]]);
                                    b.push([this.heatmapCellBox ? "Hide Box" : "Show Box", this.heatmapCellBox ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["heatmapCellBox"]]);
                                    return b
                                };
                                this.getHeatmapHighlightMenu = function() {
                                    var a = false;
                                    return [
                                        ["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "heatmapCellBoxColorHighlight"]]
                                    ]
                                };
                                this.getHeatmapVarSmpSeparatorsMenu = function(h, d, j) {
                                    var e = this.meta.data;
                                    var k = [];
                                    if (e[h] && d.length > 0) {
                                        var f = {};
                                        for (var g = 0; g < d.length; g++) {
                                            var a = d[g];
                                            if (e[h][a].type != "Numeric") {
                                                f[a] = true
                                            }
                                        }
                                        var b = this.sortObject(f);
                                        for (var g = 0; g < b.length; g++) {
                                            k.push([b[g], b[g] == this[j] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [j, b[g]]])
                                        }
                                    }
                                    return k
                                };
                                this.getHeatmapSeparatorsMenu = function() {
                                    var a = [];
                                    var b = false;
                                    if (this.isStringOverlays("v")) {
                                        a.push(["Variables", "ch_lv", b, b, b, "getHeatmapVarSmpSeparatorsMenu", ["z", this.varOverlays, "heatmapVarSeparateBy"]])
                                    }
                                    if (this.isStringOverlays("s")) {
                                        a.push(["Samples", "ch_ls", b, b, b, "getHeatmapVarSmpSeparatorsMenu", ["x", this.smpOverlays, "heatmapSmpSeparateBy"]])
                                    }
                                    return a
                                };
                                this.getHeatmapMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Cell Boxes", "dps_square", a, a, a, "getHeatmapBoxMenu", []]);
                                    b.push(["Highlight", "gc_ghcell", a, a, a, "getHeatmapHighlightMenu", []]);
                                    if (this.isStringOverlays()) {
                                        b.push(["Separators", "gc_ghspace", a, a, a, "getHeatmapSeparatorsMenu", []])
                                    }
                                    if (this.isOncoprint) {
                                        b.push(["Oncoprint <-> Heatmap", "op_refresh", "toggleAttribute", ["oncoprintHeatmapSwitch"]]);
                                        b.push([this.oncoprintNoAlterations ? "Hide No Alterations" : "Show No Alterations", this.oncoprintNoAlterations ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["oncoprintNoAlterations", "modifyOncoprintNoAlterations"]])
                                    }
                                    return b
                                };
                                this.getPlotAreaMajorTicksMenu = function(a) {
                                    return [
                                        [this[a] ? "Hide Major Ticks" : "Show Major Ticks", this[a] ? "sl_eclose" : "sl_eopen", "toggleAttribute", [a]]
                                    ]
                                };
                                this.getPlotAreaMinorTicksMenu = function(a) {
                                    return [
                                        [this[a] ? "Hide Minor Ticks" : "Show Minor Ticks", this[a] ? "sl_eclose" : "sl_eopen", "toggleAttribute", [a]]
                                    ]
                                };
                                this.getPlotAreaTickTypeMenu = function(a) {
                                    var b = [];
                                    b.push(["Solid", "gr_stylesolid", "changeAttribute", [a, "solid"]]);
                                    b.push(["Dotted", "gr_styledotted", "changeAttribute", [a, "dotted"]]);
                                    b.push(["Dashed", "gr_styledashed", "changeAttribute", [a, "dashed"]]);
                                    return b
                                };
                                this.getPlotAreaGridMenu = function(c) {
                                    var a = [];
                                    var b = false;
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", c + "AxisTickColor"]]);
                                    if (this.graphType != "Scatter3D" && !this.is3DPlot) {
                                        a.push(["Major Ticks", "gr_major", b, b, b, "getPlotAreaMajorTicksMenu", [c + "AxisMajorTicks"]]);
                                        a.push(["Minor Ticks", "gr_minor", b, b, b, "getPlotAreaMinorTicksMenu", [c + "AxisMinorTicks"]]);
                                        a.push(["Number", "ch_snumber", b, b, b, "changeTextColorAttributeMenu", ["-text-", c + "AxisTicks"]])
                                    }
                                    a.push(["Style", "gr_style", b, b, b, "getPlotAreaTickTypeMenu", [c + "AxisTickStyle"]]);
                                    return a
                                };
                                this.getPlotAreaScatterGridMenu = function() {
                                    var a = [];
                                    var b = false;
                                    if (this.graphType == "Scatter2D" || this.graphType == "ScatterBubble2D") {
                                        a.push(["X-Axis", "gr_g2x", b, b, b, "getPlotAreaGridMenu", ["x"]]);
                                        a.push(["Y-Axis", "gr_g2y", b, b, b, "getPlotAreaGridMenu", ["y"]])
                                    } else {
                                        if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                            a.push(["X-Axis", "gr_g2x", b, b, b, "getPlotAreaGridMenu", ["x"]]);
                                            a.push(["Y-Axis", "gr_g2y", b, b, b, "getPlotAreaGridMenu", ["y"]]);
                                            a.push(["Z-Axis", "gr_g2z", b, b, b, "getPlotAreaGridMenu", ["z"]])
                                        }
                                    }
                                    return a
                                };
                                this.getPlotAreaAxisAlgorithmMenu = function() {
                                    var b = ["Heckbert", "R Pretty", "Wilkinson", "Wilkinson Extended"];
                                    var a = ["heckbert", "rPretty", "wilkinson", "wilkinsonExtended"];
                                    return this.changeAttributeMenu("axisAlgorithm", b, a)
                                };
                                this.getPlotAreaBarsTypeMenu = function() {
                                    var b = ["Standard Deviation", "Standard Error of Mean", "95% Confidence Interval"];
                                    var a = ["standardDeviation", "standardErrorMean", "confidenceInterval95"];
                                    return this.changeAttributeMenu("errorBarsType", b, a)
                                };
                                this.getPlotAreaErrorBarsMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "errorBarsColor"]]);
                                    b.push(["Thickness", "sp_thickness", a, a, a, "changeTextColorAttributeMenu", ["-text-", "errorBarsThickness"]]);
                                    b.push(["Type", "ch_lt", a, a, a, "getPlotAreaBarsTypeMenu", []]);
                                    b.push([this.showErrorBars ? "Hide Error Bars" : "Show Error Bars", this.showErrorBars ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showErrorBars"]]);
                                    return b
                                };
                                this.getPlotAreaOneVariableSpaceMenu = function() {
                                    var a = [];
                                    a.push(["Farther", "sp_farther", "setFontAttributeSize", ["variableSpaceFactor", "increase"]]);
                                    a.push(["Closer", "sp_closer", "setFontAttributeSize", ["variableSpaceFactor", "decrease"]]);
                                    return a
                                };
                                this.getPlotAreaOneSampleWidthMenu = function() {
                                    var a = [];
                                    a.push(["Wider", "sp_thicker", "setFontAttributeSize", ["widthFactor", "increase"]]);
                                    a.push(["Thinner", "sp_thinner", "setFontAttributeSize", ["widthFactor", "decrease"]]);
                                    return a
                                };
                                this.getBoxplotMedianMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Median Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "boxplotMedianColor"]]);
                                    a.push(["Width", "sp_thickness", b, b, b, "changeTextColorAttributeMenu", ["-text-", "boxplotMedianWidth"]]);
                                    return a
                                };
                                this.getBoxplotMeanMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Mean Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "boxplotMeanColor"]]);
                                    a.push(["Mean Border Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "boxplotMeanColorBorder"]]);
                                    a.push([this.boxplotMean ? "Hide Mean" : "Show Mean", this.boxplotMean ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["boxplotMean"]]);
                                    return a
                                };
                                this.getWhiskersMenu = function() {
                                    var c = ["None", "Single", "Double"];
                                    var a = ["none", "single", "double"];
                                    var b = ["bx_wishkersn", "bx_wishkerss", "bx_wishkersd"];
                                    return this.changeAttributeMenu("boxplotWhiskersType", c, a, b)
                                };
                                this.getBoxplotTypeMenu = function() {
                                    var b = ["Box and Whiskers", "Range"];
                                    var a = ["boxWhiskers", "range"];
                                    return this.changeAttributeMenu("boxplotType", b, a)
                                };
                                this.getBinAlignmentMenu = function() {
                                    var c = ["Left", "Center", "Right"];
                                    var a = ["left", "center", "right"];
                                    var b = ["dp_binl", "dp_binc", "dp_binr"];
                                    return this.changeAttributeMenu("binAlignment", c, a, b)
                                };
                                this.getDataPointsMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Jitter", "dp_jittered", "toggleAttribute", ["jitter"]]);
                                    b.push(["Binned", "dp_binned", "toggleAttribute", ["binned"]]);
                                    b.push(["Bin Aligment", "dp_bin", a, a, a, "getBinAlignmentMenu", []]);
                                    if (this.graphType == "Boxplot") {
                                        b.push([this.showBoxplotOriginalData ? "Hide Data" : "Show Data", this.showBoxplotOriginalData ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showBoxplotOriginalData"]])
                                    }
                                    return b
                                };
                                this.getBoxplotAttributesMenu = function() {
                                    var b = [];
                                    var c = false;
                                    b.push(["Notch", "bx_notched", "toggleAttribute", ["boxplotNotched"]]);
                                    b.push(["Whiskers", "bx_wishkers", c, c, c, "getWhiskersMenu"]);
                                    b.push(["Boxplot Mean", "bx_mean", c, c, c, "getBoxplotMeanMenu", []]);
                                    b.push(["Boxplot Median", "bx_medianw", c, c, c, "getBoxplotMedianMenu", []]);
                                    return b
                                };
                                this.getViolinTrimMenu = function() {
                                    var b = ["Trim", "Not Trim"];
                                    var a = [true, false];
                                    return this.changeAttributeMenu("violinTrim", b, a)
                                };
                                this.getViolinScaleMenu = function() {
                                    var b = ["Area", "Count", "Width"];
                                    var a = ["area", "count", "width"];
                                    return this.changeAttributeMenu("violinScale", b, a)
                                };
                                this.getViolinAttributesMenu = function() {
                                    var b = [];
                                    var c = false;
                                    b.push(["Trim", "bx_violin", c, c, c, "getViolinTrimMenu", []]);
                                    b.push(["Scale", "wp_scale", c, c, c, "getViolinScaleMenu", []]);
                                    b.push([this.showBoxplotIfViolin ? "Hide Boxplot" : "Show Boxplot", this.showBoxplotIfViolin ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showBoxplotIfViolin"]]);
                                    b.push(["Boxplot ratio", "sp_thickness", c, c, c, "changeTextColorAttributeMenu", ["-text-", "boxplotWidthRatioIfViolin"]]);
                                    b.push([this.showViolinBoxplot ? "Hide Violin" : "Show Violin", this.showViolinBoxplot ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showViolinBoxplot"]]);
                                    return b
                                };
                                this.getBoxplotMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Type", "bx_type", b, b, b, "getBoxplotTypeMenu", []]);
                                    a.push(["Data Points", "bx_data", b, b, b, "getDataPointsMenu", []]);
                                    a.push(["at_tributes", "bx_median", b, b, b, "getBoxplotAttributesMenu", []]);
                                    a.push(["Violin Attributes", "bx_violin", b, b, b, "getViolinAttributesMenu", []]);
                                    a.push(["Connect Boxplot", "bx_connect", "toggleAttribute", ["boxplotConnect"]]);
                                    return a
                                };
                                this.getPlotAreaOneMenu = function() {
                                    var b = [];
                                    var c = false;
                                    b.push(["Axis Algorithm", "ga_axisx", c, c, c, "getPlotAreaAxisAlgorithmMenu", []]);
                                    b.push(["Error Bars", "gc_gerrors", c, c, c, "getPlotAreaErrorBarsMenu", []]);
                                    b.push(["Border Color", "at_col", c, c, c, "changeTextColorAttributeMenu", ["-color-", "plotBoxColor"]]);
                                    b.push([this.plotBox ? "Hide Border" : "Show Border", this.plotBox ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["plotBox"]]);
                                    if (this.graphType.match(/Bar|Boxplot/) && this.data.y.vars.length > 1) {
                                        b.push(["Variable Space", "sp_spacing", c, c, c, "getPlotAreaOneVariableSpaceMenu", []])
                                    }
                                    b.push(["Sample Width", "sp_thickness", c, c, c, "getPlotAreaOneSampleWidthMenu", []]);
                                    return b
                                };
                                this.getPlotAreaScatterMenu = function() {
                                    var b = [];
                                    var c = false;
                                    b.push(["Axis Algorithm", this.graphType == "Scatter3D" || this.is3DPlot ? "ga_axisxyz" : "ga_axisxy", c, c, c, "getPlotAreaAxisAlgorithmMenu", []]);
                                    b.push(["Error Bars", "gc_gerrors", c, c, c, "getPlotAreaErrorBarsMenu", []]);
                                    b.push(["Border Color", "at_col", c, c, c, "changeTextColorAttributeMenu", ["-color-", "plotBoxColor"]]);
                                    b.push([this.plotBox ? "Hide Border" : "Show Border", this.plotBox ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["plotBox"]]);
                                    return b
                                };
                                this.getAxesTitleXMenu = function() {
                                    var a = false;
                                    return [
                                        ["Text", "ch_oa", a, a, a, "changeTextColorAttributeMenu", ["-text-", "xAxisTitle"]]
                                    ]
                                };
                                this.getAxesTitleX2Menu = function() {
                                    var a = false;
                                    return [
                                        ["Text", "ch_oa", a, a, a, "changeTextColorAttributeMenu", ["-text-", "xAxis2Title"]]
                                    ]
                                };
                                this.getAxesTitleYMenu = function() {
                                    var a = false;
                                    return [
                                        ["Text", "ch_oa", a, a, a, "changeTextColorAttributeMenu", ["-text-", "yAxisTitle"]]
                                    ]
                                };
                                this.getAxesTitleZMenu = function() {
                                    var a = false;
                                    return [
                                        ["Text", "ch_oa", a, a, a, "changeTextColorAttributeMenu", ["-text-", "zAxisTitle"]]
                                    ]
                                };
                                this.getAxesTitleMenu = function() {
                                    var a = [];
                                    var b = false;
                                    if (this.graphType.match(/scatter/i) || this.is3DPlot) {
                                        if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                            a.push(["X-Axis", "p_g3axistitlex", b, b, b, "getAxesTitleXMenu", []]);
                                            a.push(["Y-Axis", "p_g3axistitley", b, b, b, "getAxesTitleYMenu", []]);
                                            a.push(["Z-Axis", "p_g3axistitlez", b, b, b, "getAxesTitleZMenu", []])
                                        } else {
                                            a.push(["X-Axis", "p_g2axistitlex", b, b, b, "getAxesTitleXMenu", []]);
                                            a.push(["Y-Axis", "p_g2axistitley", b, b, b, "getAxesTitleYMenu", []])
                                        }
                                    } else {
                                        a.push(["First Axis", "p_g1axistitle1", b, b, b, "getAxesTitleXMenu", []]);
                                        a.push(["Second Axis", "p_g1axistitle2", b, b, b, "getAxesTitleX2Menu", []])
                                    }
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "axisTitleColor"]]);
                                    a.push(["Font", "ch_oaa", b, b, b, "getFontStyleMenu", ["axisTitle"]]);
                                    return a
                                };
                                this.getTitleMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "titleColor"]]);
                                    a.push(["Font", "ch_oaa", b, b, b, "getFontStyleMenu", ["title"]]);
                                    a.push(["Text", "ch_oa", b, b, b, "changeTextColorAttributeMenu", ["-text-", "title"]]);
                                    return a
                                };
                                this.getSubtitleMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "subtitleColor"]]);
                                    a.push(["Font", "ch_oaa", b, b, b, "getFontStyleMenu", ["subtitle"]]);
                                    a.push(["Text", "ch_oa", b, b, b, "changeTextColorAttributeMenu", ["-text-", "subtitle"]]);
                                    return a
                                };
                                this.getTitleSubtitleMenu = function() {
                                    var a = [];
                                    var b = false;
                                    if (this.graphType.match(/scatter/i) || this.is3DPlot) {
                                        a.push(["Title", "p_g2title", b, b, b, "getTitleMenu", []]);
                                        a.push(["Subtitle", "p_g2subtitle", b, b, b, "getSubtitleMenu", []])
                                    } else {
                                        a.push(["Title", this.graphType == "Heatmap" ? "p_ghtitle" : "p_g1title", b, b, b, "getTitleMenu", []]);
                                        a.push(["Subtitle", this.graphType == "Heatmap" ? "p_ghsubtitle" : "p_g1subtitle", b, b, b, "getSubtitleMenu", []])
                                    }
                                    return a
                                };
                                this.getLegendLocationMenu = function() {
                                    var a = [];
                                    a.push(["Inside Plot", "dps_toinside", "changeAttribute", ["legendInside", true]]);
                                    a.push(["Outside Plot", "dps_tooutside", "changeAttribute", ["legendInside", false]]);
                                    return a
                                };
                                this.getLegendPositionMenu = function() {
                                    var a = [];
                                    if (this.legendInside) {
                                        a.push(["Top", "ps_top", "changeAttribute", ["legendPosition", "top"]]);
                                        a.push(["Top Right", "ps_topright", "changeAttribute", ["legendPosition", "topRight"]]);
                                        a.push(["Right", "ps_right", "changeAttribute", ["legendPosition", "right"]]);
                                        a.push(["Bottom Right", "ps_bottomright", "changeAttribute", ["legendPosition", "bottomRight"]]);
                                        a.push(["Bottom", "ps_bottom", "changeAttribute", ["legendPosition", "bottom"]]);
                                        a.push(["Bottom Left", "ps_bottomleft", "changeAttribute", ["legendPosition", "bottomLeft"]]);
                                        a.push(["Left", "ps_left", "changeAttribute", ["legendPosition", "left"]]);
                                        a.push(["Top Left", "ps_topleft", "changeAttribute", ["legendPosition", "topLeft"]])
                                    } else {
                                        a.push(["Top", "ps_top", "changeAttribute", ["legendPosition", "top"]]);
                                        a.push(["Bottom", "ps_bottom", "changeAttribute", ["legendPosition", "bottom"]]);
                                        a.push(["Right", "ps_right", "changeAttribute", ["legendPosition", "right"]]);
                                        a.push(["Left", "ps_left", "changeAttribute", ["legendPosition", "left"]])
                                    }
                                    return a
                                };
                                this.getLegendBorderMenu = function() {
                                    var a = [];
                                    var c = false;
                                    a.push(["Color", "at_col", c, c, c, "changeTextColorAttributeMenu", ["-color-", "legendBoxColor"]]);
                                    a.push([this.legendBox ? "Hide Border" : "Show Border", this.legendBox ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["legendBox"]]);
                                    return a
                                };
                                this.getLegendMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Border", "dps_square", b, b, b, "getLegendBorderMenu", []]);
                                    a.push(["Background", "b_bbody", b, b, b, "changeTextColorAttributeMenu", ["-color-", "legendBackgroundColor"]]);
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "legendColor"]]);
                                    a.push(["Font", "ch_oaa", b, b, b, "getFontStyleMenu", ["legend"]]);
                                    if (this.graphType != "Network") {
                                        a.push(["Position", this.legendInside ? "ps_toloc3" : "ps_toloc2", b, b, b, "getLegendPositionMenu", []]);
                                        a.push(["Location", "ps_toloc", b, b, b, "getLegendLocationMenu", []])
                                    }
                                    a.push(["Columns", "ch_snumber", b, b, b, "changeTextColorAttributeMenu", ["-text-", "legendColumns"]]);
                                    if (this.graphType != "Network") {
                                        a.push(["Reset Positions", "op_refresh", "resetLegendPosition"])
                                    }
                                    a.push([this.showLegend ? "Hide Legend" : "Show Legend", this.showLegend ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showLegend"]]);
                                    return a
                                };
                                this.getIndicatorPositionMenu = function() {
                                    var a = [];
                                    a.push(["Right", "ps_right", "changeAttribute", ["heatmapIndicatorPosition", "right"]]);
                                    a.push(["Top Right", "ps_topright", "changeAttribute", ["heatmapIndicatorPosition", "topRight"]]);
                                    a.push(["Top", "ps_top", "changeAttribute", ["heatmapIndicatorPosition", "top"]]);
                                    a.push(["Top Left", "ps_topleft", "changeAttribute", ["heatmapIndicatorPosition", "topLeft"]]);
                                    return a
                                };
                                this.getIndicatorMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Position", "ps_toloc2", b, b, b, "getIndicatorPositionMenu", []]);
                                    a.push(["Height", "sp_heightness", b, b, b, "changeTextColorAttributeMenu", ["-text-", "heatmapIndicatorHeight"]]);
                                    a.push(["Width", "sp_thickness", b, b, b, "changeTextColorAttributeMenu", ["-text-", "heatmapIndicatorWidth"]]);
                                    a.push(["Histogram", "i_hist", "toggleAttribute", ["heatmapIndicatorHistogram"]]);
                                    a.push([this.showHeatmapIndicator ? "Hide Indicator" : "Show Indicator", this.showHeatmapIndicator ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showHeatmapIndicator"]]);
                                    return a
                                };
                                this.getDecorationsBorderMenu = function() {
                                    var a = [];
                                    var c = false;
                                    a.push(["Color", "at_col", c, c, c, "changeTextColorAttributeMenu", ["-color-", "decorationsBoxColor"]]);
                                    a.push([this.decorationsBox ? "Hide Border" : "Show Border", this.decorationsBox ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["decorationsBox"]]);
                                    return a
                                };
                                this.getDecorationsPositionMenu = function() {
                                    var a = [];
                                    if (this.legendInside) {
                                        a.push(["Top", "ps_top", "changeAttribute", ["decorationsPosition", "top"]]);
                                        a.push(["Top Right", "ps_topright", "changeAttribute", ["decorationsPosition", "topRight"]]);
                                        a.push(["Right", "ps_right", "changeAttribute", ["decorationsPosition", "right"]]);
                                        a.push(["Bottom Right", "ps_bottomright", "changeAttribute", ["decorationsPosition", "bottomRight"]]);
                                        a.push(["Bottom", "ps_bottom", "changeAttribute", ["decorationsPosition", "bottom"]]);
                                        a.push(["Bottom Left", "ps_bottomleft", "changeAttribute", ["decorationsPosition", "bottomLeft"]]);
                                        a.push(["Left", "ps_left", "changeAttribute", ["decorationsPosition", "left"]]);
                                        a.push(["Top Left", "ps_topleft", "changeAttribute", ["decorationsPosition", "topLeft"]])
                                    } else {
                                        a.push(["Bottom", "ps_bottom", "changeAttribute", ["decorationsPosition", "bottom"]]);
                                        a.push(["Right", "ps_right", "changeAttribute", ["decorationsPosition", "right"]])
                                    }
                                    return a
                                };
                                this.getDecorationsDataMenu = function() {
                                    return [
                                        [this.showDecorations ? "Hide Decorations" : "Show Decorations", this.showDecorations ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showDecorations"]]
                                    ]
                                };
                                this.getDecorationsLegendMenu = function() {
                                    return [
                                        [this.showDecorationsLegend ? "Hide Decorations Legend" : "Show Decorations Legend", this.showDecorationsLegend ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showDecorationsLegend"]]
                                    ]
                                };
                                this.getDecorationsConfidenceLevelMenu = function() {
                                    var a = [];
                                    var b = [0.5, 0.75, 0.8, 0.85, 0.9, 0.95, 0.99];
                                    for (var c = 0; c < b.length; c++) {
                                        a.push([b[c], this.confidenceLevel == b[c] ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["confidenceLevel", b[c]]])
                                    }
                                    return a
                                };
                                this.getDecorationsConfidenceTypeMenu = function() {
                                    var a = [];
                                    var c = ["ordinary", "log", "loglog"];
                                    for (var b = 0; b < c.length; b++) {
                                        a.push([c[b], this.confidenceIntervalType == c[b] ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["confidenceIntervalType", c[b]]])
                                    }
                                    return a
                                };
                                this.getDecorationsConfidenceIntervalsMenu = function() {
                                    var c = this.decorations;
                                    var b = false;
                                    var a = [];
                                    if (c.reg || c.kaplanMeier) {
                                        a.push([this.showConfidenceIntervals ? "Hide Confidence Intervals" : "Show Confidence Intervals", this.showConfidenceIntervals ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showConfidenceIntervals"]])
                                    }
                                    if (c.kaplanMeier) {
                                        a.push(["Confidence Level", "cr_normal", b, b, b, "getDecorationsConfidenceLevelMenu", []]);
                                        a.push(["Confidence Type", "ch_ofx", b, b, b, "getDecorationsConfidenceTypeMenu", []])
                                    }
                                    return a
                                };
                                this.getKaplanMeierByMenu = function() {
                                    var a = [];
                                    var c = this.sortObject(this.data.z);
                                    for (var b = 0; b < c.length; b++) {
                                        a.push([c[b], c[b] == this.kaplanMeierBy ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["kaplanMeierBy", c[b], false, "updateKaplanMeier"]])
                                    }
                                    return a
                                };
                                this.getKaplanMeierMenu = function() {
                                    var a = [];
                                    var b = false;
                                    var c = this.decorations && this.decorations.kaplanMeier;
                                    a.push([c ? "Remove Kaplan-Meier Plot" : "Create Kaplan-Meier Plot", c ? "sl_eclose" : "sl_eopen", "modifyKaplanMeier"]);
                                    a.push(["Invert Censor Value", this.invertCensored ? "sl_lightbulbon" : "sl_lightbulboff", "toggleAttribute", ["invertCensored"]]);
                                    if (c) {
                                        a.push(["Confidence Intervals", "dt_kmconf", b, b, b, "getDecorationsConfidenceIntervalsMenu", []])
                                    }
                                    if (this.data.z) {
                                        a.push(["Kaplan Meier By", "dt_km", b, b, b, "getKaplanMeierByMenu", []])
                                    }
                                    return a
                                };
                                this.getDecorationsMenu = function() {
                                    var c = this.decorations;
                                    var b = false;
                                    var a = [];
                                    a.push(["Border", "dps_square", b, b, b, "getDecorationsBorderMenu", []]);
                                    a.push(["Background", "b_bbody", b, b, b, "changeTextColorAttributeMenu", ["-color-", "decorationsBackgroundColor"]]);
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "decorationsColor"]]);
                                    a.push(["Font", "ch_oaa", b, b, b, "getFontStyleMenu", ["decoration"]]);
                                    a.push(["Position", this.legendInside ? "dps_toinside" : "ps_toloc3", b, b, b, "getDecorationsPositionMenu", []]);
                                    a.push(["Data and Legend", "wp_datawrangling", b, b, b, "getDecorationsDataMenu", []]);
                                    a.push(["Legend", "lg_g2", b, b, b, "getDecorationsLegendMenu", []]);
                                    if (c.reg) {
                                        a.push(["Confidence Intervals", "dt_corconf", b, b, b, "getDecorationsConfidenceIntervalsMenu", []])
                                    }
                                    return a
                                };
                                this.getOverlaysMemebersMenu = function(g, b) {
                                    var f = [];
                                    var e = {};
                                    for (var a = 0; a < this[b + "Overlays"].length; a++) {
                                        e[this[b + "Overlays"][a]] = true
                                    }
                                    var d = this.sortObject(this.data[g]);
                                    for (var a = 0; a < d.length; a++) {
                                        f.push([d[a], e[d[a]] ? "sl_checkboxon" : "sl_checkboxoff", b == "var" ? "modifyVariableOverlays" : "modifySampleOverlays", [d[a]]])
                                    }
                                    return f
                                };
                                this.getOverlaysLegendMenu = function(g, b) {
                                    var e = [];
                                    var f = this[b + "OverlayProperties"];
                                    var d = this.sortObject(this.data[g]);
                                    for (var a = 0; a < d.length; a++) {
                                        e.push([d[a], f[d[a]].showLegend ? "sl_eclose" : "sl_eopen", "modifyOverlaysProperties", [false, b + "OverlayProperties", d[a], "showLegend"]])
                                    }
                                    return e
                                };
                                this.getOverlaysPositionMemberMenu = function(a, b) {
                                    var c = [];
                                    if (a == "var") {
                                        c.push(["Bottom", "ps_bottom", "modifyOverlaysProperties", ["bottom", a + "OverlayProperties", b, "position"]]);
                                        c.push(["Top", "ps_top", "modifyOverlaysProperties", ["top", a + "OverlayProperties", b, "position"]])
                                    } else {
                                        if (this.graphType == "Heatmap" || this.graphOrientation == "horizontal") {
                                            c.push(["Left", "ps_left", "modifyOverlaysProperties", ["left", a + "OverlayProperties", b, "position"]]);
                                            c.push(["Right", "ps_right", "modifyOverlaysProperties", ["right", a + "OverlayProperties", b, "position"]])
                                        } else {
                                            c.push(["Bottom", "ps_bottom", "modifyOverlaysProperties", ["bottom", a + "OverlayProperties", b, "position"]]);
                                            c.push(["Top", "ps_top", "modifyOverlaysProperties", ["top", a + "OverlayProperties", b, "position"]])
                                        }
                                    }
                                    return c
                                };
                                this.getOverlaysPositionMenu = function(h, b) {
                                    var g = [];
                                    var e = false;
                                    var d = this.sortObject(this.data[h]);
                                    for (var a = 0; a < d.length; a++) {
                                        g.push([d[a], "op_config", e, e, e, "getOverlaysPositionMemberMenu", [b, d[a]]])
                                    }
                                    return g
                                };
                                this.getOverlaysThicknessMenu = function(h, b) {
                                    var g = [];
                                    var e = false;
                                    var d = this.sortObject(this.data[h]);
                                    for (var a = 0; a < d.length; a++) {
                                        g.push([d[a], "op_config", e, e, e, "changeTextColorAttributeMenu", ["-text-", [e, "modifyOverlaysProperties", [b + "OverlayProperties", d[a], "thickness"]]]])
                                    }
                                    return g
                                };
                                this.getOverlaysColorSchemesMenu = function(g, f) {
                                    var e = [];
                                    var b = this.meta.data[g];
                                    var a = this.getColorSchemes();
                                    for (var d = 0; d < a.length; d++) {
                                        e.push([a[d], b[f].spectrum == a[d] ? "sl_radioon" : "sl_radiooff", "modifyColorProperties", [a[d], f, g]])
                                    }
                                    return e
                                };
                                this.getOverlaysColorMenu = function(j, d) {
                                    var h = [];
                                    var g = false;
                                    var a = this.meta.data[j];
                                    var e = this.sortObject(this.data[j]);
                                    for (var b = 0; b < e.length; b++) {
                                        if (this.isNumeric(this.data[j][e[b]])) {
                                            if (this[d + "OverlayProperties"][e[b]] && this[d + "OverlayProperties"][e[b]].type && this[d + "OverlayProperties"][e[b]].type == "Heatmap") {
                                                h.push([e[b], "op_config", g, g, g, "getColorSpectrumMenu", [a[e[b]].colorBrew.spectrum, "modifyColorProperties", e[b], j]])
                                            } else {
                                                h.push([e[b], "op_config", g, g, g, "changeTextColorAttributeMenu", ["-color-", [g, "modifyOverlaysProperties", [d + "OverlayProperties", e[b], "color"]]]])
                                            }
                                        } else {
                                            h.push([e[b], "op_config", g, g, g, "getOverlaysColorSchemesMenu", [j, e[b]]])
                                        }
                                    }
                                    return h
                                };
                                this.getOverlaysGraphTypeMenu = function(d, f) {
                                    var e = [];
                                    var b = ["Area", "AreaLine", "Bar", "BarLine", "Dotplot", "DotLine", "Heatmap", "Line", "Pie", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "Treemap"];
                                    var a = ["g_area", "g_arealine", "g_bar", "g_barline", "g_dotplot", "g_dotline", "g_heatmap", "g_line", "g_pie", "g_stacked", "g_stackedline", "g_stackedpercentage", "g_stackedpercentageline", "g_treemap"];
                                    for (var c = 0; c < b.length; c++) {
                                        e.push([b[c], a[c], "modifyOverlaysProperties", [b[c], d + "OverlayProperties", f, "type"]])
                                    }
                                    return e
                                };
                                this.getOverlaysGraphDefaultMenu = function(a, c) {
                                    var b = [];
                                    b.push(["Default", "g_heatmap", "modifyOverlaysProperties", ["Heatmap", a + "OverlayProperties", c, "type"]]);
                                    b.push(["Text", "ch_lt", "modifyOverlaysProperties", ["Text", a + "OverlayProperties", c, "type"]]);
                                    b.push(["Treemap", "g_treemap", "modifyOverlaysProperties", ["Treemap", a + "OverlayProperties", c, "type"]]);
                                    return b
                                };
                                this.getOverlaysGraphMenu = function(j, d) {
                                    var h = [];
                                    var g = false;
                                    var a = this.meta.data[j];
                                    var e = this.sortObject(this.data[j]);
                                    for (var b = 0; b < e.length; b++) {
                                        if (this.isNumeric(this.data[j][e[b]])) {
                                            h.push([e[b], "op_config", g, g, g, "getOverlaysGraphTypeMenu", [d, e[b]]])
                                        } else {
                                            h.push([e[b], "op_config", g, g, g, "getOverlaysGraphDefaultMenu", [d, e[b]]])
                                        }
                                    }
                                    return h
                                };
                                this.getOverlaysPropertiesMenu = function(e, a) {
                                    var d = [];
                                    var b = false;
                                    if (a == "var") {
                                        d.push(["Position", "ar_v", b, b, b, "getOverlaysPositionMenu", [e, a]])
                                    } else {
                                        if (this.graphType == "Heatmap" || this.graphOrientation == "vertical") {
                                            d.push(["Position", "ar_h", b, b, b, "getOverlaysPositionMenu", [e, a]])
                                        } else {
                                            d.push(["Position", "ar_v", b, b, b, "getOverlaysPositionMenu", [e, a]])
                                        }
                                    }
                                    d.push(["Thickness", "sp_thickness", b, b, b, "getOverlaysThicknessMenu", [e, a]]);
                                    d.push(["Color", "at_col", b, b, b, "getOverlaysColorMenu", [e, a]]);
                                    d.push(["Type", "ly_doe", b, b, b, "getOverlaysGraphMenu", [e, a]]);
                                    d.push(["Legend", this.graphType == "Heatmap" ? "lg_h" : "lg_g1", b, b, b, "getOverlaysLegendMenu", [e, a]]);
                                    return d
                                };
                                this.getLegendOverlaysPositionMenu = function() {
                                    var a = [];
                                    a.push(["Top Right", "ps_topright", "changeAttribute", ["overlaysLegendPosition", "topRight"]]);
                                    a.push(["Right", "ps_right", "changeAttribute", ["overlaysLegendPosition", "right"]]);
                                    a.push(["Bottom Left", "ps_bottomleft", "changeAttribute", ["overlaysLegendPosition", "bottomLeft"]]);
                                    a.push(["Bottom", "ps_bottom", "changeAttribute", ["overlaysLegendPosition", "bottom"]]);
                                    return a
                                };
                                this.getLegendOverlaysMenu = function(a) {
                                    var b = "show" + a + "OverlaysLegend";
                                    return [
                                        [this[b] ? "Hide Legend" : "Show Legend", this[b] ? "sl_eclose" : "sl_eopen", "toggleAttribute", [b]]
                                    ]
                                };
                                this.getOverlaysMenu = function() {
                                    var b = [];
                                    var a = false;
                                    if (this.graphType == "Heatmap" && this.data.z) {
                                        b.push(["Variable Overlays", "o_ghvars", a, a, a, "getOverlaysMemebersMenu", ["z", "var"]]);
                                        b.push(["Variable Overlays Properties", "o_ghvars", a, a, a, "getOverlaysPropertiesMenu", ["z", "var"]]);
                                        b.push(["Variable Overlays Legend", "lg_h", a, a, a, "getLegendOverlaysMenu", ["Var"]]);
                                        b.push(["-"])
                                    }
                                    if (this.data.x) {
                                        b.push(["Sample Overlays", this.graphType == "Heatmap" ? "o_ghsmps" : "o_g1", a, a, a, "getOverlaysMemebersMenu", ["x", "smp"]]);
                                        b.push(["Sample Overlays Properties", this.graphType == "Heatmap" ? "o_ghsmpsp" : "o_g1p", a, a, a, "getOverlaysPropertiesMenu", ["x", "smp"]]);
                                        b.push(["Sample Overlays Legend", this.graphType == "Heatmap" ? "lg_h" : "lg_g1", a, a, a, "getLegendOverlaysMenu", ["Smp"]]);
                                        b.push(["-"])
                                    }
                                    b.push(["Overlays Legend Position", "ps_toloc3", a, a, a, "getLegendOverlaysPositionMenu", []]);
                                    b.push(["-"]);
                                    b.push(["Label Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "overlayFontColor"]]);
                                    b.push(["Label Font", "ch_oaa", a, a, a, "getFontStyleMenu", ["overlay"]]);
                                    b.push(["Default Thickness", "sp_thickness", a, a, a, "changeTextColorAttributeMenu", ["-text-", "overlaysThickness"]]);
                                    if (this.data.x || this.data.z) {
                                        b.push([this.showOverlays ? "Hide Overlays" : "Show Overlays", this.showOverlays ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showOverlays"]])
                                    }
                                    b.push(["More", "op_more", "showConfiguratorCategory", ["event", "Overlays"]]);
                                    return b
                                };
                                this.getBinDataPercentileMenu = function(d) {
                                    var b = [];
                                    for (var a = 0; a < this.data.y.vars.length; a++) {
                                        if (d) {
                                            b.push([this.data.y.vars[a], "sl_radiooff", "binDataByPercentile", [a, true]])
                                        } else {
                                            b.push([this.data.y.vars[a], "sl_radiooff", "binDataByPercentile", [a]])
                                        }
                                    }
                                    return b
                                };
                                this.getBinDataQuantileMenu = function(d) {
                                    var b = [];
                                    for (var a = 0; a < this.data.y.vars.length; a++) {
                                        if (d) {
                                            b.push([this.data.y.vars[a], "sl_radiooff", "binDataByQuantile", [a, true]])
                                        } else {
                                            b.push([this.data.y.vars[a], "sl_radiooff", "binDataByQuantile", [a]])
                                        }
                                    }
                                    return b
                                };
                                this.getBinDataCustomBinMenu = function(b) {
                                    var c = [];
                                    for (var a = 2; a < 9; a++) {
                                        c.push([a + " bins", "sl_radiooff", "binDataCustom", [b, a]])
                                    }
                                    return c
                                };
                                this.getBinDataCustomMenu = function() {
                                    var e = [];
                                    var d = false;
                                    for (var a = 0; a < this.data.y.vars.length; a++) {
                                        var b = this.data.y.vars[a].substring(0, 1).toLowerCase();
                                        e.push([this.data.y.vars[a], "ch_l" + b, d, d, d, "getBinDataCustomBinMenu", [a]])
                                    }
                                    return e
                                };
                                this.getBinDataMenu = function() {
                                    var a = [];
                                    var c = false;
                                    a.push(["By Percentile Discrete", "ch_spercent", c, c, c, "getBinDataPercentileMenu", []]);
                                    a.push(["By Percentile Continuous", "ch_spercent", c, c, c, "getBinDataPercentileMenu", [true]]);
                                    a.push(["By Quantile Discrete", "ch_oquantile", c, c, c, "getBinDataQuantileMenu", []]);
                                    a.push(["By Quantile Continuous", "ch_oquantile", c, c, c, "getBinDataQuantileMenu", [true]]);
                                    a.push(["Custom", "ch_lc", c, c, c, "getBinDataCustomMenu", []]);
                                    return a
                                };
                                this.getGroupSamplesMenu = function() {
                                    if (this.data.x) {
                                        var d = [];
                                        var b = {};
                                        var a = this.sortObject(this.data.x);
                                        for (var c = 0; c < this.groupingFactors.length; c++) {
                                            b[this.groupingFactors[c]] = true
                                        }
                                        for (var c = 0; c < a.length; c++) {
                                            d.push([a[c], b[a[c]] ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleGroups", [a[c]]])
                                        }
                                        return d
                                    } else {
                                        return false
                                    }
                                };
                                this.getSmpLabelHighlightLevelMenu = function() {
                                    var c = [];
                                    var b = {};
                                    var d = this.isGroupedData ? this.data.w : this.data.y;
                                    for (var a = 0; a < this.highlightSmp.length; a++) {
                                        b[this.highlightSmp[a]] = true
                                    }
                                    for (var a = 0; a < d.smps.length; a++) {
                                        c.push([d.smps[a], b[d.smps[a]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyObjectArray", [d.smps[a], false, "highlightSmp", true, true]])
                                    }
                                    return c
                                };
                                this.getSmpLabelHighlightMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Samples", "ch_ls", b, b, b, "getSmpLabelHighlightLevelMenu", []]);
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "smpHighlightColor"]]);
                                    return a
                                };
                                this.getSmpLabelMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "smpLabelFontColor"]]);
                                    a.push(["Font", "ch_oaa", b, b, b, "getFontStyleMenu", ["smpLabel"]]);
                                    a.push(["Highlight", this.graphType == "Heatmap" ? "p_ghsamplelabels" : "p_g1samplelabels", b, b, b, "getSmpLabelHighlightMenu", []]);
                                    a.push(["Interval", "ch_snumber", b, b, b, "changeTextColorAttributeMenu", ["-text-", "smpLabelInterval"]]);
                                    a.push(["Rotate", "rt_c", b, b, b, "changeTextColorAttributeMenu", ["-text-", "smpLabelRotate"]]);
                                    a.push([this.showSampleNames ? "Hide Labels" : "Show Labels", this.showSampleNames ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showSampleNames"]]);
                                    return a
                                };
                                this.getVarLabelHighlightLevelMenu = function() {
                                    var d = [];
                                    var c = {};
                                    var a = this.data.y.vars;
                                    for (var b = 0; b < this.highlightVar.length; b++) {
                                        c[this.highlightVar[b]] = true
                                    }
                                    for (var b = 0; b < a.length; b++) {
                                        d.push([a[b], c[a[b]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyObjectArray", [a[b], false, "highlightVar", true, true]])
                                    }
                                    return d
                                };
                                this.getVarLabelHighlightMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Variables", "ch_lv", b, b, b, "getVarLabelHighlightLevelMenu", []]);
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "varHighlightColor"]]);
                                    return a
                                };
                                this.getVarLabelMenu = function(c) {
                                    var a = [];
                                    var b = false;
                                    a.push(["Color", "at_col", b, b, b, "changeTextColorAttributeMenu", ["-color-", "varLabelFontColor"]]);
                                    a.push(["Font", "ch_oaa", b, b, b, "getFontStyleMenu", ["varLabel"]]);
                                    a.push(["Highlight", "p_ghvariablelabels", b, b, b, "getVarLabelHighlightMenu", []]);
                                    a.push(["Interval", "ch_snumber", b, b, b, "changeTextColorAttributeMenu", ["-text-", "varLabelInterval"]]);
                                    a.push(["Rotate", "rt_c", b, b, b, "changeTextColorAttributeMenu", ["-text-", "varLabelRotate"]]);
                                    a.push([this.showVariableNames ? "Hide Labels" : "Show Labels", this.showVariableNames ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showVariableNames"]]);
                                    return a
                                };
                                this.getGraphPartMenu = function(e, c) {
                                    var b = [];
                                    var d = false;
                                    b.push(["Color", "at_col", d, d, d, "changeTextColorAttributeMenu", ["-color-", e + (c ? "FontColor" : "Color")]]);
                                    b.push(["Font", "ch_oaa", d, d, d, "getFontStyleMenu", [e]]);
                                    b.push(["Text", "ch_oa", d, d, d, "changeTextColorAttributeMenu", ["-text-", e]]);
                                    return b
                                };
                                this.getFontStyleMenu = function(c) {
                                    var b = [];
                                    var a = "ScaleFontFactor";
                                    b.push(["Bigger", "sr_aai", "setFontAttributeSize", [c + a, "increase"]]);
                                    b.push(["Smaller", "sr_aad", "setFontAttributeSize", [c + a, "decrease"]]);
                                    b.push(["Normal", "ch_oa", "setFontAttributeStyle", [c + "FontStyle", "ch_oa"]]);
                                    b.push(["Bold", "ch_lb", "setFontAttributeStyle", [c + "FontStyle", "bold"]]);
                                    b.push(["Italic", "ch_oitalic", "setFontAttributeStyle", [c + "FontStyle", "ch_oitalic"]]);
                                    return b
                                };
                                this.getDataPointAttributesPropertySampleMenu = function(b) {
                                    var d = [];
                                    var c = this.isGroupedData ? this.data.w : this.data.y;
                                    for (var a = 0; a < c.smps.length; a++) {
                                        d.push([c.smps[a], this[b] == c.smps[a] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [b, c.smps[a]]])
                                    }
                                    return d
                                };
                                this.getDataPointAttributesPropertyMenu = function(h) {
                                    var j = [];
                                    var e = false;
                                    if (this.isHistogram && this.dataStndBy.z) {
                                        var d = this.sortObject(this.dataStndBy.z);
                                        for (var c = 0; c < d.length; c++) {
                                            j.push([d[c], d[c] == this[h] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [h, d[c]]])
                                        }
                                    } else {
                                        if (h == "treemapBy") {
                                            var a = {};
                                            var b = this.sortObject(this.data.x);
                                            for (var c = 0; c < this.treemapBy.length; c++) {
                                                a[this.treemapBy[c]] = true
                                            }
                                            for (var c = 0; c < b.length; c++) {
                                                j.push([b[c], a[b[c]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyTreemapGroups", [b[c]]])
                                            }
                                        } else {
                                            if (this.isDOE) {
                                                var g = this.graphType.match(/scatter/i) || this.graphType == "Map" ? this.sortObject(this.data.z) : this.sortObject(this.data.x);
                                                for (var c = 0; c < g.length; c++) {
                                                    j.push([g[c], g[c] == this[h] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [h, g[c]]])
                                                }
                                            } else {
                                                if (this.graphType != "Line" && this.graphType != "ParallelCoordinates") {
                                                    var g = this.graphType.match(/scatter/i) || this.graphType == "Map" ? this.sortObject(this.data.z) : this.sortObject(this.data.x);
                                                    for (var c = 0; c < g.length; c++) {
                                                        j.push([g[c], g[c] == this[h] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [h, g[c]]])
                                                    }
                                                    j.push(["-"])
                                                }
                                                var c = "variable";
                                                if (h != "connectBy" && h != "ellipseBy" && h != "ridgeBy") {
                                                    j.push(["Variable", c == this[h] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [h, c]])
                                                }
                                                if (((!this.graphType.match(/scatter/i) && !this.graphType == "Map") || this.graphType == "Dotplot") && this.data.z) {
                                                    var d = this.sortObject(this.data.z);
                                                    if (h != "connectBy" || this.graphType == "Dotplot") {
                                                        j.push(["-"])
                                                    }
                                                    for (var c = 0; c < d.length; c++) {
                                                        if (h != "connectBy" || this.graphType == "Dotplot") {
                                                            j.push([d[c], d[c] == this[h] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [h, d[c]]])
                                                        }
                                                    }
                                                }
                                                if (this.graphType == "Line" || this.graphType == "ParallelCoordinates" || this.graphType == "Map") {
                                                    j.push(["-"]);
                                                    j.push(["Sample", "ch_ls", e, e, e, "getDataPointAttributesPropertySampleMenu", [h]])
                                                }
                                            }
                                        }
                                    }
                                    return j
                                };
                                this.getDataPointAttributesMenu = function() {
                                    var a = [];
                                    var b = false;
                                    if (this.isHistogram && this.dataStndBy.z) {
                                        a.push(["Color By", "at_col", b, b, b, "getDataPointAttributesPropertyMenu", ["colorBy"]]);
                                        if (!this.isValidQQ() && !this.isValidCDF() && !this.scatterPlotMatrix) {
                                            a.push(["Ridge By", "g_ridgeline", b, b, b, "getDataPointAttributesPropertyMenu", ["ridgeBy"]])
                                        }
                                    } else {
                                        if (this.graphType != "Heatmap") {
                                            a.push(["Color By", "at_col", b, b, b, "getDataPointAttributesPropertyMenu", ["colorBy"]])
                                        }
                                        if (this.graphType.match(/scatter/i) || this.is3DPlot || this.graphType == "Dotplot" || this.graphType == "Tree" || (this.graphType == "Boxplot" && this.showBoxplotOriginalData)) {
                                            a.push(["Shape By", "at_shp", b, b, b, "getDataPointAttributesPropertyMenu", ["shapeBy"]]);
                                            a.push(["Size By", "at_sze", b, b, b, "getDataPointAttributesPropertyMenu", ["sizeBy"]])
                                        }
                                        if (!this.graphType.match(/parallelcoordinates|line/i)) {
                                            a.push(["Pattern By", "at_pat", b, b, b, "getDataPointAttributesPropertyMenu", ["patternBy"]])
                                        }
                                        if (this.graphType.match(/scatter/i) || this.is3DPlot || this.graphType == "Dotplot" || (this.graphType == "Boxplot" && this.showBoxplotOriginalData)) {
                                            a.push(["Connect By", "bx_connect", b, b, b, "getDataPointAttributesPropertyMenu", ["connectBy"]])
                                        }
                                        if (this.graphType.match(/stacked/i) && this.data.x && this.isGroupedData) {
                                            a.push(["Treemap By", "g_treemap", b, b, b, "getDataPointAttributesPropertyMenu", ["treemapBy"]])
                                        }
                                        if (this.graphType.match(/scatter/i)) {
                                            a.push(["Ellipse By", "at_ellipse", b, b, b, "getDataPointAttributesPropertyMenu", ["ellipseBy"]]);
                                            if (this.graphType == "Scatter2D" && !this.isValidQQ() && !this.isValidCDF() && !this.scatterPlotMatrix) {
                                                a.push(["Ridge By", "g_ridgeline", b, b, b, "getDataPointAttributesPropertyMenu", ["ridgeBy"]])
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.getDendrogramColorMenu = function(d) {
                                    var e = [];
                                    if (d) {
                                        var c = this.sortObject(this.data.z);
                                        for (var b = 0; b < c.length; b++) {
                                            e.push([c[b], this.colorVarDendrogramBy == c[b] ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["colorVarDendrogramBy", c[b]]])
                                        }
                                    } else {
                                        var a = this.sortObject(this.data.x);
                                        for (var b = 0; b < a.length; b++) {
                                            e.push([a[b], this.colorSmpDendrogramBy == a[b] ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["colorSmpDendrogramBy", a[b]]])
                                        }
                                    }
                                    return e
                                };
                                this.getDendrogramsMenu = function() {
                                    var a = [];
                                    var b = false;
                                    if (this.graphType == "Tree") {
                                        a.push(["Radial Layout", this.treeCircular ? "sl_checkboxon" : "sl_checkboxoff", "toggleAttribute", ["treeCircular"]]);
                                        a.push(["Inverted Tree", this.treeInverted ? "sl_checkboxon" : "sl_checkboxoff", "toggleAttribute", ["treeInverted"]])
                                    } else {
                                        if (this.graphType == "Heatmap") {
                                            a.push(["Cluster Variable", "cl_vertical", "clusterVariables", [true]]);
                                            a.push(["K-Means Variable", "cl_verticalk", "kmeansVariables", [true]]);
                                            if (this.varDendrogram) {
                                                a.push(["Color Variable Cluster By", "at_col", b, b, b, "getDendrogramColorMenu", [true]]);
                                                if (this.showVarDendrogram) {
                                                    a.push(["Hide Dendrogram", "sl_eclose", "showHideDendrogram", ["showVarDendrogram"]])
                                                } else {
                                                    a.push(["Show Dendrogram", "sl_eopen", "showHideDendrogram", ["showVarDendrogram"]])
                                                }
                                            }
                                            a.push(["-"])
                                        }
                                        a.push(["Cluster Samples", "cl_horizontal", "clusterSamples", [true]]);
                                        a.push(["K-Means Samples", "cl_horizontalk", "kmeansSamples", [true]]);
                                        if (this.smpDendrogram) {
                                            a.push(["Color Sample Cluster By", "at_col", b, b, b, "getDendrogramColorMenu", []]);
                                            if (this.showSmpDendrogram) {
                                                a.push(["Hide Dendrogram", "sl_eclose", "showHideDendrogram", ["showSmpDendrogram"]])
                                            } else {
                                                a.push(["Show Dendrogram", "sl_eopen", "showHideDendrogram", ["showSmpDendrogram"]])
                                            }
                                        }
                                        a.push(["-"]);
                                        a.push(["More", "op_more", "showConfiguratorCategory", ["event", "Clustering"]])
                                    }
                                    return a
                                };
                                this.getGraphTypeMenu = function() {
                                    var a = [];
                                    a.push(["Area", "g_area", "changeAttribute", ["graphType", "Area"]]);
                                    a.push(["Area Line", "g_arealine", "changeAttribute", ["graphType", "AreaLine"]]);
                                    a.push(["Bar", "g_bar", "changeAttribute", ["graphType", "Bar"]]);
                                    a.push(["Bar Line", "g_barline", "changeAttribute", ["graphType", "BarLine"]]);
                                    a.push(["Boxplot", "g_boxplot", "changeAttribute", ["graphType", "Boxplot"]]);
                                    a.push(["Circular", "g_circular", "changeAttribute", ["graphType", "Circular"]]);
                                    a.push(["Correlation", "g_correlation", "changeAttribute", ["graphType", "Correlation"]]);
                                    a.push(["Dot Line", "g_dotline", "changeAttribute", ["graphType", "DotLine"]]);
                                    a.push(["Dotplot", "g_dotplot", "changeAttribute", ["graphType", "Dotplot"]]);
                                    a.push(["Gantt Chart", "g_gantt", "changeAttribute", ["graphType", "g_gantt"]]);
                                    a.push(["Heatmap", "g_heatmap", "changeAttribute", ["graphType", "Heatmap"]]);
                                    a.push(["Line", "g_line", "changeAttribute", ["graphType", "Line"]]);
                                    a.push(["Map", "g_map", "changeAttribute", ["graphType", "Map"]]);
                                    a.push(["Pie Chart", "g_pie", "changeAttribute", ["graphType", "Pie"]]);
                                    if (this.data.y.smps.length > 1) {
                                        a.push(["Scatter 2D", "g_scatter2d", "changeAttribute", ["graphType", "Scatter2D"]])
                                    }
                                    if (this.data.y.smps.length > 2) {
                                        a.push(["Scatter Bubble 2D", "g_scatterbubble2d", "changeAttribute", ["graphType", "ScatterBubble2D"]]);
                                        a.push(["Scatter 3D", "g_scatter3d", "changeAttribute", ["graphType", "Scatter3D"]])
                                    }
                                    a.push(["Stacked", "g_stacked", "changeAttribute", ["graphType", "Stacked"]]);
                                    a.push(["Stacked Line", "g_stackedline", "changeAttribute", ["graphType", "StackedLine"]]);
                                    a.push(["Stacked Percent", "g_stackedpercent", "changeAttribute", ["graphType", "StackedPercent"]]);
                                    a.push(["Stacked Percent Line", "g_stackedpercentline", "changeAttribute", ["graphType", "StackedPercentLine"]]);
                                    a.push(["Tag Cloud", "g_tagcloud", "changeAttribute", ["graphType", "TagCloud"]]);
                                    a.push(["Parallel Coordinates", "g_parallelcoordinates", "changeAttribute", ["graphType", "ParallelCoordinates"]]);
                                    a.push(["Sankey", "g_sankey", "changeAttribute", ["graphType", "Sankey"]]);
                                    a.push(["Tree", "g_tree", "changeAttribute", ["graphType", "Tree"]]);
                                    a.push(["Treemap", "g_treemap", "changeAttribute", ["graphType", "Treemap"]]);
                                    return a
                                };
                                this.getGraphOrientationMenu = function() {
                                    var a = [];
                                    a.push(["Horizontal", "gc_gohorizontal", "changeAttribute", ["graphOrientation", "horizontal"]]);
                                    a.push(["Vertical", "gc_govertical", "changeAttribute", ["graphOrientation", "vertical"]]);
                                    return a
                                };
                                this.getMarginsMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["g_lobal", "mr_all", a, a, a, "changeTextColorAttributeMenu", ["-text-", "margin"]]);
                                    b.push(["-"]);
                                    b.push(["Bottom", "mr_bottom", a, a, a, "changeTextColorAttributeMenu", ["-text-", "marginBottom"]]);
                                    b.push(["Left", "mr_left", a, a, a, "changeTextColorAttributeMenu", ["-text-", "marginLeft"]]);
                                    b.push(["Top", "mr_top", a, a, a, "changeTextColorAttributeMenu", ["-text-", "marginTop"]]);
                                    b.push(["Right", "mr_right", a, a, a, "changeTextColorAttributeMenu", ["-text-", "marginRight"]]);
                                    return b
                                };
                                this.getShadesMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Objects", "at_shd", "toggleAttribute", ["showShadow"]]);
                                    b.push(["Text", "tx_shadow", "toggleAttribute", ["showTextShadow"]]);
                                    b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "shadowColor"]]);
                                    b.push(["More", "op_more", "showConfiguratorCategory", ["event", "Shadows"]]);
                                    return b
                                };
                                this.getCanvasBorderMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Color", "at_col", a, a, a, "changeTextColorAttributeMenu", ["-color-", "canvasBoxColor"]]);
                                    b.push([this.canvasBox ? "Hide Border" : "Show Border", this.canvasBox ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["canvasBox"]]);
                                    return b
                                };
                                this.getGradientsOrientationMenu = function() {
                                    var a = [];
                                    a.push(["Horizontal", "b_grhl", "changeAttribute", ["gradientOrientation", "horizontal"]]);
                                    a.push(["Vertical", "b_grvt", "changeAttribute", ["gradientOrientation", "vertical"]]);
                                    return a
                                };
                                this.getGradientsTypeMenu = function() {
                                    var a = [];
                                    a.push(["Linear", "b_grvt", "changeAttribute", ["gradientType", "linear"]]);
                                    a.push(["Radial", "b_grc", "changeAttribute", ["gradientType", "radial"]]);
                                    return a
                                };
                                this.getGradientsMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Gradient", "b_gsswitch", "toggleAttribute", ["gradient"]]);
                                    a.push(["Orientation", "b_gsori", b, b, b, "getGradientsOrientationMenu", []]);
                                    a.push(["Type", "b_gstype", b, b, b, "getGradientsTypeMenu", []]);
                                    a.push(["-"]);
                                    a.push(["More", "op_more", "showConfiguratorCategory", ["event", "Gradients"]]);
                                    return a
                                };
                                this.getBackgroundTypeMenu = function() {
                                    var a = [];
                                    a.push(["Solid", "b_bbody", "changeAttribute", ["backgroundType", "solid", "solid"]]);
                                    a.push(["Gradient", "b_bgradient", "changeAttribute", ["backgroundType", "gradient", "gradient"]]);
                                    a.push(["Solid Window", "b_bwindowsolid", "changeAttribute", ["backgroundType", "window", "window"]]);
                                    a.push(["Solid Window on Gradient", "b_bbodygradient", "changeAttribute", ["backgroundType", "windowGradient", "windowGradient"]]);
                                    a.push(["Gradient Window on Solid", "b_bwindowgradient", "changeAttribute", ["backgroundType", "windowSolidGradient", "windowSolidGradient"]]);
                                    return a
                                };
                                this.getBackgroundMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Type", "b_btype", a, a, a, "getBackgroundTypeMenu", []]);
                                    b.push(["-"]);
                                    b.push(["Background Color", "b_bbody", a, a, a, "changeTextColorAttributeMenu", ["-color-", "background"]]);
                                    b.push(["Window Color", "b_bwindowsolid", a, a, a, "changeTextColorAttributeMenu", ["-color-", "backgroundWindow"]]);
                                    b.push(["Gradient Start Color", "b_grvt", a, a, a, "changeTextColorAttributeMenu", ["-color-", "backgroundGradient1Color"]]);
                                    b.push(["Gradient End Color", "b_grvb", a, a, a, "changeTextColorAttributeMenu", ["-color-", "backgroundGradient2Color"]]);
                                    b.push(["-"]);
                                    b.push(["More", "op_more", "showConfiguratorCategory", ["event", "Background"]]);
                                    return b
                                };
                                this.getFontsSizeStyleMenu = function() {
                                    var a = [];
                                    a.push(["Bigger", "sr_aai", "setFontAttributeSize", ["fontScaleFontFactor", "increase"]]);
                                    a.push(["Smaller", "sr_aad", "setFontAttributeSize", ["fontScaleFontFactor", "decrease"]]);
                                    a.push(["Normal", "ch_oa", "setFontAttributeStyle", ["fontStyle", "ch_oa"]]);
                                    a.push(["Bold", "ch_lb", "setFontAttributeStyle", ["fontStyle", "bold"]]);
                                    a.push(["ch_oitalic", "ch_oitalic", "setFontAttributeStyle", ["fontStyle", "ch_oitalic"]]);
                                    return a
                                };
                                this.getFontsMenu = function() {
                                    var a = [];
                                    var c = false;
                                    a.push(["Size and Style", "ch_oaa", c, c, c, "getFontsSizeStyleMenu", []]);
                                    a.push(["-"]);
                                    for (var b in CanvasXpress.fonts) {
                                        a.push([b, this.fontName == b ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["fontName", b, b]])
                                    }
                                    a.push(["-"]);
                                    a.push(["More", "op_more", "showConfiguratorCategory", ["event", "Text"]]);
                                    return a
                                };
                                this.getLayoutVarMenu = function() {
                                    var d = [];
                                    var a = {};
                                    for (var b = 0; b < this.segregateVariablesBy.length; b++) {
                                        a[this.segregateVariablesBy[b]] = true
                                    }
                                    if (this.data.z) {
                                        var c = this.sortObject(this.data.z);
                                        for (var b = 0; b < c.length; b++) {
                                            d.push([c[b], a[c[b]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyVariableSegregation", [c[b]]])
                                        }
                                        if (!this.graphType.match(/Scatter/)) {
                                            d.push(["-"])
                                        }
                                    }
                                    if (!this.graphType.match(/Scatter/)) {
                                        d.push(["variable", a.variable ? "sl_checkboxon" : "sl_checkboxoff", "modifyVariableSegregation", ["variable"]])
                                    }
                                    return d
                                };
                                this.getLayoutSmpMenu = function() {
                                    var a = [];
                                    var d = {};
                                    for (var c = 0; c < this.segregateSamplesBy.length; c++) {
                                        d[this.segregateSamplesBy[c]] = true
                                    }
                                    if (this.data.x) {
                                        var b = this.sortObject(this.data.x);
                                        for (var c = 0; c < b.length; c++) {
                                            a.push([b[c], d[b[c]] ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleSegregation", [b[c]]])
                                        }
                                        if (!this.graphType.match(/Scatter/)) {
                                            a.push(["-"])
                                        }
                                    }
                                    if (!this.graphType.match(/Scatter/)) {
                                        a.push(["sample", d.sample ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleSegregation", ["sample"]])
                                    }
                                    return a
                                };
                                this.getLayoutMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Segregate Samples By", "ch_ls", b, b, b, "getLayoutSmpMenu", []]);
                                    a.push(["Segregate Variables By", "ch_lv", b, b, b, "getLayoutVarMenu", []]);
                                    return a
                                };
                                this.getSegregationMenu = function() {
                                    var c = {};
                                    var d = [];
                                    if (this.isHistogram && this.dataStndBy.z) {
                                        var e = this.sortObject(this.dataStndBy.z);
                                        for (var b = 0; b < this.segregateVariablesBy.length; b++) {
                                            c[this.segregateVariablesBy[b]] = true
                                        }
                                        for (var b = 0; b < e.length; b++) {
                                            d.push([e[b], c[e[b]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyVariableSegregation", [e[b]]])
                                        }
                                        if (!this.ridgeBy) {
                                            d.push(["sample", this.segregateSamplesBy.includes("sample") ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleSegregation", ["sample"]])
                                        }
                                    } else {
                                        if ((this.isQQ || this.isCDF) && !this.ridgeBy) {
                                            d.push(["sample", this.segregateSamplesBy.includes("sample") ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleSegregation", ["sample"]])
                                        } else {
                                            if (this.data.z && !this.scatterPlotMatrix) {
                                                var e = this.sortObject(this.data.z);
                                                for (var b = 0; b < this.segregateVariablesBy.length; b++) {
                                                    c[this.segregateVariablesBy[b]] = true
                                                }
                                                for (var b = 0; b < e.length; b++) {
                                                    d.push([e[b], c[e[b]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyVariableSegregation", [e[b]]])
                                                }
                                            }
                                            if (this.data.x && !this.scatterPlotMatrix) {
                                                var a = this.sortObject(this.data.x);
                                                for (var b = 0; b < this.segregateSamplesBy.length; b++) {
                                                    c[this.segregateSamplesBy[b]] = true
                                                }
                                                for (var b = 0; b < a.length; b++) {
                                                    d.push([a[b], c[a[b]] ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleSegregation", [a[b]]])
                                                }
                                            }
                                            if (!this.graphType.match(/Scatter/)) {
                                                d.push(["variable", this.segregateVariablesBy.includes("variable") ? "sl_checkboxon" : "sl_checkboxoff", "modifyVariableSegregation", ["variable"]]);
                                                d.push(["sample", this.segregateSamplesBy.includes("sample") ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleSegregation", ["sample"]])
                                            } else {
                                                if (!this.ridgeBy) {
                                                    d.push(["sample", this.segregateSamplesBy.includes("sample") ? "sl_checkboxon" : "sl_checkboxoff", "modifySampleSegregation", ["sample"]])
                                                }
                                            }
                                        }
                                    }
                                    if (!this.is3DPlot && d.length > 0) {
                                        return d
                                    } else {
                                        return false
                                    }
                                };
                                this.getColorSpectrumMenu = function(b, g, m, l, k) {
                                    var c = [];
                                    var a = this.getObjectArray(b);
                                    var f = this.getColorNames();
                                    for (var e = 0; e < f.length; e++) {
                                        if (a[f[e]]) {
                                            var h = 0;
                                            for (var d = 0; d < b.length; d++) {
                                                if (f[e] == b[d]) {
                                                    h = d;
                                                    break
                                                }
                                            }
                                            if (m && l) {
                                                c.push([f[e] + " (" + (h + 1) + ")", "sl_checkboxon", g, [f[e], m, l]])
                                            } else {
                                                c.push([f[e] + " (" + (h + 1) + ")", "sl_checkboxon", g, [f[e]]])
                                            }
                                        } else {
                                            if (m && l) {
                                                c.push([f[e], "sl_checkboxoff", g, [f[e], m, l]])
                                            } else {
                                                c.push([f[e], "sl_checkboxoff", g, [f[e]]])
                                            }
                                        }
                                    }
                                    return c
                                };
                                this.getColorSpectrumSchemeMenu = function(e, f) {
                                    var d = [];
                                    var a = this.getColorSchemes();
                                    for (var b = 0; b < a.length; b++) {
                                        d.push([a[b], this[e] == a[b] ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["colorSpectrum", [], false, f, a[b]]])
                                    }
                                    return d
                                };
                                this.getColorSchemeMenu = function(e, f) {
                                    var d = [];
                                    var a = this.getColorSchemes();
                                    for (var b = 0; b < a.length; b++) {
                                        d.push([a[b], this[e] == a[b] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [e, a[b], false, f]])
                                    }
                                    return d
                                };
                                this.getColorsSpectrumCompMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Spectrum By Colors", "at_col", a, a, a, "getColorSpectrumMenu", [this.colorSpectrum, "modifyColorSpectrum"]]);
                                    b.push(["Spectrum By Scheme", "at_palette", a, a, a, "getColorSpectrumSchemeMenu", ["colorScheme", "modifyColorSpectrumByScheme"]]);
                                    b.push(["Spectrum Color Number", "ch_snumber", a, a, a, "changeTextColorAttributeMenu", ["-text-", "colorSpectrumTarget"]]);
                                    b.push(["Zero-Center", "ch_lz", a, a, a, "changeTextColorAttributeMenu", ["-text-", [a, "modifyColorSpectrumZeroValue", [null]]]]);
                                    return b
                                };
                                this.getColorBlindTypeMenu = function() {
                                    var a = [];
                                    a.push(["No Blind Type", !this.blindnessType ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["blindnessType", false]]);
                                    a.push(["Protanopia", this.blindnessType == "protanopia" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["blindnessType", "protanopia"]]);
                                    a.push(["Deuteranopia", this.blindnessType == "deuteranopia" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["blindnessType", "deuteranopia"]]);
                                    a.push(["Tritanopia", this.blindnessType == "tritanopia" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["blindnessType", "tritanopia"]]);
                                    a.push(["Monochromatic", this.blindnessType == "monochromatic" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["blindnessType", "monochromatic"]]);
                                    return a
                                };
                                this.getColorsMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Blind Type", "sl_eopen", a, a, a, "getColorBlindTypeMenu", []]);
                                    b.push(["Scheme", "at_palette", a, a, a, "getColorSchemeMenu", ["colorScheme", "modifyColorScheme"]]);
                                    b.push(["Spectrum", "at_sch", a, a, a, "getColorsSpectrumCompMenu", []]);
                                    return b
                                };
                                this.getResizeMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Height", "dps_height", a, a, a, "changeTextColorAttributeMenu", ["-text-", ["height", "setHeight"]]]);
                                    b.push(["Width", "dps_width", a, a, a, "changeTextColorAttributeMenu", ["-text-", ["width", "setWidth"]]]);
                                    return b
                                };
                                this.getThemeMenu = function() {
                                    var a = [];
                                    a.push(["CanvasXpress", this.theme == "cx" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["cx"]]);
                                    a.push(["Economist", this.theme == "economist" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["economist"]]);
                                    a.push(["GGPlot", this.theme == "ggplot" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_Gplot"]]);
                                    a.push(["Gray-Inverse", this.theme == "igray" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["igray"]]);
                                    a.push(["Excel", this.theme == "excel" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["excel"]]);
                                    a.push(["Paul Tol", this.theme == "paulTol" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["paulTol"]]);
                                    a.push(["Black And White", this.theme == "blackAndWhite" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["blackAndWhite"]]);
                                    a.push(["Solarized", this.theme == "solarized" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["solarized"]]);
                                    a.push(["Stata", this.theme == "stata" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["stata"]]);
                                    a.push(["Tableau", this.theme == "tableau" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["tableau"]]);
                                    a.push(["Wall Street Journal", this.theme == "wallStreetJournal" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["wallStreetJournal"]]);
                                    a.push(["-"]);
                                    a.push(["Last Air Bender Fire", this.theme == "lastAirBenderFire" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["lastAirBenderFire"]]);
                                    a.push(["Last Air Bender Air", this.theme == "lastAirBenderAir" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["lastAirBenderAir"]]);
                                    a.push(["Last Air Bender Water", this.theme == "lastAirBenderWater" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["lastAirBenderWater"]]);
                                    a.push(["Last Air Bender Earth", this.theme == "lastAirBenderEarth" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["lastAirBenderEarth"]]);
                                    a.push(["-"]);
                                    a.push(["g_ame Of Thrones Targaryen", this.theme == "g_ameOfThronesTargaryen" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesTargaryen"]]);
                                    a.push(["g_ame Of Thrones Stark", this.theme == "g_ameOfThronesStark" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesStark"]]);
                                    a.push(["g_ame Of Thrones Stannis", this.theme == "g_ameOfThronesStannis" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesStannis"]]);
                                    a.push(["g_ame Of Thrones Lannister", this.theme == "g_ameOfThronesLannister" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesLannister"]]);
                                    a.push(["g_ame Of Thrones Tyrell", this.theme == "g_ameOfThronesTyrell" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesTyrell"]]);
                                    a.push(["g_ame Of Thrones Martell", this.theme == "g_ameOfThronesMartell" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesMartell"]]);
                                    a.push(["g_ame Of Thrones Tully", this.theme == "g_ameOfThronesTully" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesTully"]]);
                                    a.push(["g_ame Of Thrones Greyjoy", this.theme == "g_ameOfThronesGreyjoy" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesGreyjoy"]]);
                                    a.push(["g_ame Of Thrones Manderly", this.theme == "g_ameOfThronesManderly" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesManderly"]]);
                                    a.push(["g_ame Of Thrones Arryn", this.theme == "g_ameOfThronesArryn" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["g_ameOfThronesArryn"]]);
                                    a.push(["-"]);
                                    a.push(["None", this.theme == "none" ? "sl_radioon" : "sl_radiooff", "changeTheme", ["none"]]);
                                    return a
                                };
                                this.getGeneralMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Background", "b_bbody", a, a, a, "getBackgroundMenu", []]);
                                    b.push(["Border", "dps_square", a, a, a, "getCanvasBorderMenu", []]);
                                    b.push(["Color", "at_col", a, a, a, "getColorsMenu", []]);
                                    b.push(["Font", "ch_oaa", a, a, a, "getFontsMenu", []]);
                                    b.push(["Gradients", "b_grvt", a, a, a, "getGradientsMenu", []]);
                                    if (!this.graphType.match(/Scatter/) && !this.is3DPlot) {
                                        b.push(["Graph Orientation", "gc_goverticalhorizontal", a, a, a, "getGraphOrientationMenu", []])
                                    }
                                    b.push(["Graph Type", "ly_doe", a, a, a, "getGraphTypeMenu", []]);
                                    if (!this.is3DPlot && (this.data.x || this.data.z)) {
                                        b.push(["Layout", "ly_segregate", a, a, a, "getLayoutMenu", []])
                                    }
                                    b.push(["Margins", "mr_all", a, a, a, "getMarginsMenu", []]);
                                    b.push(["Shadows", "at_shd", a, a, a, "getShadesMenu", []]);
                                    b.push(["Size", "dps_resize", a, a, a, "getResizeMenu", []]);
                                    b.push(["Theme", "at_sch", a, a, a, "getThemeMenu", []]);
                                    b.push(["Transparency", "at_trn", a, a, a, "changeTextColorAttributeMenu", ["-text-", "transparency"]]);
                                    return b
                                };
                                this.getSwitchSmpToAnnotationMenu = function() {
                                    var b = [];
                                    for (var a = 0; a < this.data.y.smps.length; a++) {
                                        b.push([this.data.y.smps[a], "sl_radiooff", "switchSmpToAnnotation", [this.data.y.smps[a]]])
                                    }
                                    return b
                                };
                                this.getSwitchAnnotationToSmpMenu = function() {
                                    var c = [];
                                    var b = this.sortObject(this.data.z);
                                    for (var a = 0; a < b.length; a++) {
                                        if (this.meta.data.z[b[a]]) {
                                            c.push([b[a], "sl_radiooff", "switchAnnotationToSmp", [b[a]]])
                                        }
                                    }
                                    return c
                                };
                                this.getSwitchSmpAnnotationToIdMenu = function() {
                                    var c = [];
                                    var a = this.sortObject(this.data.x);
                                    for (var b = 0; b < a.length; b++) {
                                        if (this.meta.data.x[a[b]].unique) {
                                            c.push([a[b], "sl_radiooff", "switchSmpAnnotationToId", [a[b]]])
                                        }
                                    }
                                    return c
                                };
                                this.getSwitchVarToAnnotationMenu = function() {
                                    var a = [];
                                    for (var b = 0; b < this.data.y.vars.length; b++) {
                                        a.push([this.data.y.vars[b], "sl_radiooff", "switchVarToAnnotation", [this.data.y.vars[b]]])
                                    }
                                    return a
                                };
                                this.getSwitchAnnotationToVarMenu = function() {
                                    var b = [];
                                    var a = this.sortObject(this.data.x);
                                    for (var c = 0; c < a.length; c++) {
                                        if (this.meta.data.x[a[c]]) {
                                            b.push([a[c], "sl_radiooff", "switchAnnotationToVar", [a[c]]])
                                        }
                                    }
                                    return b
                                };
                                this.getSwitchVarAnnotationToIdMenu = function() {
                                    var c = [];
                                    var b = this.sortObject(this.data.z);
                                    for (var a = 0; a < b.length; a++) {
                                        if (this.meta.data.z[b[a]].unique) {
                                            c.push([b[a], "sl_radiooff", "switchVarAnnotationToId", [b[a]]])
                                        }
                                    }
                                    return c
                                };
                                this.getSwitchSamplesMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Sample to Annotation", "sw_down", b, b, b, "getSwitchSmpToAnnotationMenu", []]);
                                    if (this.data.z) {
                                        a.push(["Annotation to Sample", "sw_up", b, b, b, "getSwitchAnnotationToSmpMenu", []])
                                    }
                                    if (this.data.x && this.isUniqueFactor("s")) {
                                        a.push(["Annotation to Id", "sw_updown", b, b, b, "getSwitchSmpAnnotationToIdMenu", []])
                                    }
                                    a.push(["Create New Sample Id", "op_more", "switchSmpIdToAnnotation", []]);
                                    return a
                                };
                                this.getSwitchVariablesMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Variable to Annotation", "sw_down", b, b, b, "getSwitchVarToAnnotationMenu", []]);
                                    if (this.data.x) {
                                        a.push(["Annotation to Variable", "sw_up", b, b, b, "getSwitchAnnotationToVarMenu", []])
                                    }
                                    if (this.data.z && this.isUniqueFactor("v")) {
                                        a.push(["Annotation to Id", "sw_updown", b, b, b, "getSwitchVarAnnotationToIdMenu", []])
                                    }
                                    a.push(["Create New Variable Id", "op_more", "switchVarIdToAnnotation", []]);
                                    return a
                                };
                                this.getSwitchMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Samples", "ch_ls", b, b, b, "getSwitchSamplesMenu", []]);
                                    a.push(["Variables", "ch_lv", b, b, b, "getSwitchVariablesMenu", []]);
                                    return a
                                };
                                this.getConvertNumericToStringMenu = function(f, b) {
                                    var d = [];
                                    var e = this.sortObject(this.data[f]);
                                    for (var a = 0; a < e.length; a++) {
                                        if (this.meta.data[f][e[a]] && this.meta.data[f][e[a]].type == "Numeric") {
                                            d.push([e[a], "sl_radiooff", "switchNumericToString", [e[a], b]])
                                        }
                                    }
                                    return d
                                };
                                this.getConvertStringToNumericMenu = function(f, b) {
                                    var d = [];
                                    var e = this.sortObject(this.data[f]);
                                    for (var a = 0; a < e.length; a++) {
                                        if (this.meta.data[f][e[a]] && this.meta.data[f][e[a]].type != "Numeric") {
                                            d.push([e[a], "sl_radiooff", "switchStringToNumeric", [e[a], b]])
                                        }
                                    }
                                    return d
                                };
                                this.getConvertVarSmpMenu = function(e, a) {
                                    var d = [];
                                    var b = false;
                                    if (this.isNumericFactor(a)) {
                                        d.push(["Numeric to String", "tx_tostring", b, b, b, "getConvertNumericToStringMenu", [e, a == "s"]])
                                    }
                                    if (this.isStringFactor(a)) {
                                        d.push(["String to Numeric", "tx_tonumeric", b, b, b, "getConvertStringToNumericMenu", [e, a == "s"]])
                                    }
                                    return d
                                };
                                this.getConvertMenu = function() {
                                    var b = [];
                                    var a = false;
                                    if (this.data.x) {
                                        b.push(["Samples", "ch_ls", a, a, a, "getConvertVarSmpMenu", ["x", "s"]])
                                    }
                                    if (this.data.z) {
                                        b.push(["Variables", "ch_lv", a, a, a, "getConvertVarSmpMenu", ["z", "v"]])
                                    }
                                    return b
                                };
                                this.getTransformPercentMenu = function() {
                                    var a = [];
                                    a.push(["By Sample", "ch_ls", "transform", ["percentile", "samples"]]);
                                    a.push(["By Variable", "ch_lv", "transform", ["percentile", "variables"]]);
                                    return a
                                };
                                this.getTransformZScoreMenu = function() {
                                    var a = [];
                                    a.push(["By Sample", "ch_ls", "transform", ["zscore", "samples"]]);
                                    a.push(["By Variable", "ch_lv", "transform", ["zscore", "variables"]]);
                                    return a
                                };
                                this.getTransformRatioMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["To Sample", "ch_ls", a, a, a, "getTransformRatioSmpMenu", []]);
                                    if (this.data.x && this.isGroupedData) {
                                        b.push(["To Group", "ch_lg", a, a, a, "getTransformRatioGrpMenu", []]);
                                        if (this.ratioGroupReference && this.data.x.hasOwnProperty(this.ratioGroupReference)) {
                                            b.push(["To Level", "ch_ll", a, a, a, "getTransformRatioLevMenu", []])
                                        }
                                    }
                                    return b
                                };
                                this.getTransformRatioLevMenu = function() {
                                    var c = [];
                                    var a = this.sortObject(this.getObjectArray(this.data.x[this.ratioGroupReference]));
                                    for (var b = 0; b < a.length; b++) {
                                        if (a[b] != null) {
                                            c.push([a[b], this.ratioLevelReference == a[b] ? "sl_radioon" : "sl_radiooff", "modifyTransformRatio", ["level", a[b]]])
                                        }
                                    }
                                    return c
                                };
                                this.getTransformRatioGrpMenu = function() {
                                    var b = [];
                                    var a = this.sortObject(this.data.x);
                                    for (var c = 0; c < a.length; c++) {
                                        b.push([a[c], this.ratioGroupReference == a[c] ? "sl_radioon" : "sl_radiooff", "modifyTransformRatio", ["group", a[c]]])
                                    }
                                    return b
                                };
                                this.getTransformRatioSmpMenu = function() {
                                    var c = [];
                                    for (var a = 0; a < this.data.y.smps.length; a++) {
                                        var b = this.data.y.smps[a];
                                        c.push([b, this.ratioSampleReference == b ? "sl_radioon" : "sl_radiooff", "modifyTransformRatio", ["sample", b]])
                                    }
                                    return c
                                };
                                this.getTransformMenu = function() {
                                    var b = [];
                                    if (this.isDOE) {
                                        b.push(["Log Base 2", "ch_olog2", "changeAttribute", ["transformType", "log2"]]);
                                        b.push(["Log Base 10", "ch_olog10", "changeAttribute", ["transformType", "log10"]]);
                                        b.push(["Exp Base 2", "ch_oe2", "changeAttribute", ["transformType", "exp2"]]);
                                        b.push(["Exp Base 10", "ch_oe10", "changeAttribute", ["transformType", "exp10"]]);
                                        b.push(["Reset", "op_refresh", "changeAttribute", ["transformType", "reset"]])
                                    } else {
                                        var a = false;
                                        b.push(["Log Base 2", "ch_olog2", "transform", ["log2"]]);
                                        b.push(["Log Base 10", "ch_olog10", "transform", ["log10"]]);
                                        b.push(["Exp Base 2", "ch_oe2", "transform", ["exp2"]]);
                                        b.push(["Exp Base 10", "ch_oe10", "transform", ["exp10"]]);
                                        b.push(["Ceil data", "ch_oceil", a, a, a, "changeTextColorAttributeMenu", ["-text-", [a, "modifyTransform", ["tceil"]]]]);
                                        b.push(["Floor data", "ch_ofloor", a, a, a, "changeTextColorAttributeMenu", ["-text-", [a, "modifyTransform", ["tfloor"]]]]);
                                        b.push(["Percentile", "ch_spercent", a, a, a, "getTransformPercentMenu", []]);
                                        b.push(["Z-Score", "ch_lz", a, a, a, "getTransformZScoreMenu", []]);
                                        b.push(["Ratio", "ch_lr", a, a, a, "getTransformRatioMenu", []]);
                                        b.push(["-"]);
                                        b.push(["Reset", "op_refresh", "transform", ["reset"]]);
                                        b.push(["-"]);
                                        b.push(["Overwrite data", "sv_disk", "transform", ["save"]])
                                    }
                                    return b
                                };
                                this.getAxisTransformMenu = function(b) {
                                    var c = [];
                                    b = b.toLowerCase();
                                    c.push(["Log Base 2", "ch_olog2", "changeAttribute", [b + "AxisTransform", "log2"]]);
                                    c.push(["Log Base 10", "ch_olog10", "changeAttribute", [b + "AxisTransform", "log10"]]);
                                    c.push(["Exp Base 2", "ch_oe2", "changeAttribute", [b + "AxisTransform", "exp2"]]);
                                    c.push(["Exp Base 10", "ch_oe10", "changeAttribute", [b + "AxisTransform", "exp10"]]);
                                    c.push(["Percentile", "ch_spercent", "changeAttribute", [b + "AxisTransform", "exp10"]]);
                                    c.push(["-"]);
                                    c.push(["Reset", "op_refresh", "changeAttribute", [b + "AxisTransform", false]]);
                                    return c
                                };
                                this.getSortSmpIntensityMenu = function() {
                                    var c = [];
                                    var a = {};
                                    if (this.sortingSamples) {
                                        for (var b = 0; b < this.sortingSamples.length; b++) {
                                            a[this.sortingSamples[b]] = true
                                        }
                                    }
                                    for (var b = 0; b < this.data.y.smps.length; b++) {
                                        c.push([this.data.y.smps[b], a[b + 1] ? "sl_radioon" : "sl_radiooff", "modifySort", ["smp", "var", this.data.y.smps[b]]])
                                    }
                                    return c
                                };
                                this.getSortVarIntensityMenu = function() {
                                    var c = [];
                                    var a = {};
                                    if (this.sortingVariables) {
                                        for (var b = 0; b < this.sortingVariables.length; b++) {
                                            a[this.sortingVariables[b]] = true
                                        }
                                    }
                                    for (var b = 0; b < this.data.y.vars.length; b++) {
                                        c.push([this.data.y.vars[b], a[b + 1] ? "sl_radioon" : "sl_radiooff", "modifySort", ["var", "smp", this.data.y.vars[b]]])
                                    }
                                    return c
                                };
                                this.getSortSmpCatMenu = function() {
                                    var d = [];
                                    var b = {};
                                    var a = this.sortObject(this.data.x);
                                    if (this.sortingSampleCategories) {
                                        for (var c = 0; c < this.sortingSampleCategories.length; c++) {
                                            b[this.sortingSampleCategories[c]] = true
                                        }
                                    }
                                    for (var c = 0; c < a.length; c++) {
                                        d.push([a[c], b[a[c]] ? "sl_checkboxon" : "sl_checkboxoff", "modifySort", ["cat", "smp", a[c]]])
                                    }
                                    return d
                                };
                                this.getSortVarCatMenu = function() {
                                    var d = [];
                                    var a = {};
                                    var c = this.sortObject(this.data.z);
                                    if (this.sortingVariableCategories) {
                                        for (var b = 0; b < this.sortingVariableCategories.length; b++) {
                                            a[this.sortingVariableCategories[b]] = true
                                        }
                                    }
                                    for (var b = 0; b < c.length; b++) {
                                        d.push([c[b], a[c[b]] ? "sl_checkboxon" : "sl_checkboxoff", "modifySort", ["cat", "var", c[b]]])
                                    }
                                    return d
                                };
                                this.getSortSmpMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["By Variable Intensity", "ch_lv", b, b, b, "getSortVarIntensityMenu", []]);
                                    if (this.data.x) {
                                        a.push(["By Sample Category", "ch_lx", b, b, b, "getSortSmpCatMenu", []])
                                    }
                                    a.push(["By Name", "ch_ls", "modifySort", [false, "smp", "samples"]]);
                                    return a
                                };
                                this.getSortVarMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["By Sample Intensity", "ch_ls", b, b, b, "getSortSmpIntensityMenu", []]);
                                    if (this.data.z) {
                                        a.push(["By Variable Category", "ch_lz", b, b, b, "getSortVarCatMenu", []])
                                    }
                                    a.push(["By Name", "ch_lv", "modifySort", [false, "var", "variables"]]);
                                    return a
                                };
                                this.getSortChangeMenu = function() {
                                    var a = [];
                                    a.push(["Samples", "ch_ls", "changeAttribute", ["sortDir", this.sortDir, true, "modifySort", [this.isGroupedData ? "grpIndex" : "smpIndex"]]]);
                                    a.push(["Variables", "ch_lv", "changeAttribute", ["sortDir", this.sortDir, true, "modifySort", ["varIndex"]]]);
                                    return a
                                };
                                this.getSortMenu = function() {
                                    var a = [];
                                    if (this.isDOE) {
                                        a.push(["Sort string", "sr_az", "changeAttribute", ["sortType", "String"]]);
                                        a.push(["Sort numeric", "sr19", "changeAttribute", ["sortType", "Numeric"]])
                                    } else {
                                        var b = false;
                                        a.push(["Change Sort", "sr_azi", b, b, b, "getSortChangeMenu", []]);
                                        a.push(["Case Sensitive", this.sortCaseSensitive ? "sl_checkboxon" : "sl_checkboxoff", "toggleAttribute", ["sortCaseSensitive", "modifySort", ["both"]]]);
                                        a.push(["-"]);
                                        a.push(["Sort Samples", "ch_ls", b, b, b, "getSortSmpMenu", []]);
                                        a.push(["Sort Variables", "ch_lv", b, b, b, "getSortVarMenu", []])
                                    }
                                    return a
                                };
                                this.getSliderMenu = function() {
                                    var b = [];
                                    var a = false;
                                    for (var c in this.binConfigurations) {
                                        b.push([c, a, a, a, a, [
                                            ["-slider-", "changeBin", [c]]
                                        ]])
                                    }
                                    return b
                                };
                                this.getPivotMenu = function() {
                                    var c = [];
                                    if (this.isPivotable()) {
                                        var a = this.data.x ? this.sortObject(this.data.x) : [];
                                        if (this.data.y.vars.length == 3) {
                                            var d = this.data.y.vars;
                                            c.push([d[0] + " as Variables; " + d[1] + " as Samples", "sl_radiooff", "pivotYY", [d[0], d[1]]]);
                                            c.push([d[0] + " as Variables; " + d[2] + " as Samples", "sl_radiooff", "pivotYY", [d[0], d[2]]]);
                                            c.push([d[1] + " as Variables; " + d[0] + " as Samples", "sl_radiooff", "pivotYY", [d[1], d[0]]]);
                                            c.push([d[1] + " as Variables; " + d[2] + " as Samples", "sl_radiooff", "pivotYY", [d[1], d[2]]]);
                                            c.push([d[2] + " as Variables; " + d[0] + " as Samples", "sl_radiooff", "pivotYY", [d[2], d[0]]]);
                                            c.push([d[2] + " as Variables; " + d[1] + " as Samples", "sl_radiooff", "pivotYY", [d[2], d[1]]])
                                        } else {
                                            if (this.data.y.vars.length == 2) {
                                                var d = this.data.y.vars;
                                                c.push([a[0] + " as Variables; " + d[0] + " as Samples", "sl_radiooff", "pivotXY", [a[0], d[0]]]);
                                                c.push([a[0] + " as Variables; " + d[1] + " as Samples", "sl_radiooff", "pivotXY", [a[0], d[1]]]);
                                                c.push([d[0] + " as Variables; " + a[0] + " as Samples", "sl_radiooff", "pivotXY", [d[0], a[0]]]);
                                                c.push([d[1] + " as Variables; " + a[0] + " as Samples", "sl_radiooff", "pivotXY", [d[1], a[0]]])
                                            } else {
                                                if (a.length == 2) {
                                                    c.push([a[0] + " as Variables; " + a[1] + " as Samples", "sl_radiooff", "pivotXX", [a[0], a[1]]]);
                                                    c.push([a[1] + " as Variables; " + a[0] + " as Samples", "sl_radiooff", "pivotXX", [a[1], a[0]]])
                                                }
                                            }
                                        }
                                        for (var b = 0; b < a.length; b++) {
                                            if (this.meta.data.x[a[b]].type == "String") {
                                                c.push(["Pivot on " + a[b], "sl_radiooff", "pivotX", [a[b]]])
                                            }
                                        }
                                    }
                                    return c
                                };
                                this.getRdatasetsMenu = function() {
                                    var a = [];
                                    if (this.Rdatasets) {
                                        var c = this.sortObject(this.Rdatasets);
                                        c = c.sort(function(e, d) {
                                            return e.toLowerCase() > d.toLowerCase()
                                        });
                                        for (var b = 0; b < c.length; b++) {
                                            a.push([c[b], "sl_radiooff", "getRLibraryDataSets", [c[b]]])
                                        }
                                    }
                                    return a
                                };
                                this.getRangeMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Set Min", "dtp_min", b, b, b, "changeTextColorAttributeMenu", ["-text-", "setMinX"]]);
                                    a.push(["Set Max", "dtp_max", b, b, b, "changeTextColorAttributeMenu", ["-text-", "setMaxX"]]);
                                    a.push(["Exact Range", "dtp_exact", "toggleAttribute", ["xAxisExact"]]);
                                    return a
                                };
                                this.getSummaryTypeMenu = function() {
                                    var c = [];
                                    var b = ["mean", "median", "min", "max", "sum", "count"];
                                    c.push(["Raw", !this.summaryType || this.summaryType == "raw" ? "sl_radioon" : "sl_radiooff", "modifySummaryType", ["raw"]]);
                                    for (var a = 0; a < b.length; a++) {
                                        c.push([this.capitalize(b[a]), this.summaryType == b[a] ? "sl_radioon" : "sl_radiooff", "modifySummaryType", [b[a]]])
                                    }
                                    return c
                                };
                                this.getDataMenu = function() {
                                    var b = this.graphType.match(/Area|Gantt/);
                                    var a = [];
                                    var c = false;
                                    if (this.isBinConfigurations() && !b && !this.isDOE) {
                                        a.push(["Configure Bins", "ch_lb", c, c, c, "getSliderMenu", []])
                                    }
                                    if ((this.data.x || this.data.z) && !this.isDOE) {
                                        a.push(["Convert Annotations", "tx_stringnumeric", c, c, c, "getConvertMenu", []])
                                    }
                                    if (this.graphType == "Heatmap" && !this.isDOE) {
                                        a.push(["Range", "dtp_range", c, c, c, "getRangeMenu", []])
                                    }
                                    if (!b && !this.isDOE) {
                                        a.push(["Summary Type", "ch_ssum", c, c, c, "getSummaryTypeMenu", []])
                                    }
                                    if (!this.isDOE) {
                                        a.push(["Switch Data", "sw_updown", c, c, c, "getSwitchMenu", []])
                                    }
                                    if (!this.graphType.match(/Scatter/i)) {
                                        a.push(["Sort", "sr_azi", c, c, c, "getSortMenu", []])
                                    }
                                    if (!b) {
                                        a.push(["Transform", "ch_ofx", c, c, c, "getTransformMenu", []])
                                    }
                                    if (!this.layoutValid) {
                                        a.push(["Transpose", "dtt_transpose", "transpose"])
                                    }
                                    if (this.isPivotable() && !this.isPivot && !b && !this.isDOE) {
                                        a.push(["Pivot", "dtt_pivot", c, c, c, "getPivotMenu", []])
                                    } else {
                                        if (this.isPivot && !b && !this.isDOE) {
                                            a.push(["Remove Pivot", "dtt_pivotremove", "removePivot"])
                                        }
                                    }
                                    if (!this.layoutValid && !b && !this.isDOE) {
                                        a.push(["Bin Data", "dt_hist", c, c, c, "getBinDataMenu", []])
                                    }
                                    return a
                                };
                                this.getLoessMenu = function() {
                                    var a = [];
                                    a.push([this.showLoessFit ? "Hide Loess Fit" : "Show Loess Fit", this.showLoessFit ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showLoessFit"]]);
                                    return a
                                };
                                this.getHistogramDensityMenu = function() {
                                    var b = ["epanechnikov", "uniform", "triangular", "quartic", "triweight", "g_aussian", "cosine"];
                                    var a = [];
                                    for (var c = 0; c < b.length; c++) {
                                        a.push([b[c], b[c] == this.densityKernel ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["densityKernel", b[c], false, "modifyHistogram"]])
                                    }
                                    return a
                                };
                                this.getHistogramMedianLineStyleMenu = function() {
                                    var a = [];
                                    a.push(["Solid", "ln_stylesolid", "changeAttribute", ["histogramMedianLineStyle", "solid"]]);
                                    a.push(["Dotted", "ln_styledotted", "changeAttribute", ["histogramMedianLineStyle", "dotted"]]);
                                    a.push(["Dashed", "ln_styledashed", "changeAttribute", ["histogramMedianLineStyle", "dashed"]]);
                                    return a
                                };
                                this.getHistogramTypeMenu = function() {
                                    var a = [
                                        ["Dodged", this.histogramType == "dodged" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["histogramType", "dodged", false, "modifyHistogram"]],
                                        ["Staggered", this.histogramType == "staggered" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["histogramType", "staggered", false, "modifyHistogram"]],
                                        ["Stacked", this.histogramType == "stacked" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["histogramType", "stacked", false, "modifyHistogram"]]
                                    ];
                                    return a
                                };
                                this.getHistogramMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Bin Number", "ch_snumber", a, a, a, "changeTextColorAttributeMenu", ["-text-", ["histogramBins", "modifyHistogram"]]]);
                                    b.push(["Density Kernel", "dt_denfit", a, a, a, "getHistogramDensityMenu", []]);
                                    b.push(["Remove Histogram", "dt_histremove", "removeHistogram"]);
                                    b.push([this.hideHistogram ? "Show Histogram Bars" : "Hide Histogram Bars", this.hideHistogram ? "sl_eopen" : "sl_eclose", "toggleAttribute", ["hideHistogram"]]);
                                    b.push(["Histogram Type", "dt_histstag", a, a, a, "getHistogramTypeMenu", []]);
                                    b.push([this.showHistogramDensity ? "Hide Density" : "Show Density", this.showHistogramDensity ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showHistogramDensity", "modifyHistogram"]]);
                                    b.push([this.showFilledHistogramDensity ? "Hide Filled Density" : "Show Filled Density", this.showFilledHistogramDensity ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showFilledHistogramDensity"]]);
                                    b.push(["Fill Transparency", "at_trn", a, a, a, "changeTextColorAttributeMenu", ["-text-", "histogramDensityFillTransparency"]]);
                                    b.push([this.showHistogramMedian ? "Hide Median" : "Show Median", this.showHistogramMedian ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showHistogramMedian"]]);
                                    b.push(["Median Line Style", "ln_style", a, a, a, "getHistogramMedianLineStyleMenu", []]);
                                    return b
                                };
                                this.getHistogramCreateMenu = function() {
                                    var d = [];
                                    var b = this.sortObject(this.data.z);
                                    for (var a = 0; a < b.length; a++) {
                                        d.push([b[a], "sl_radiooff", "createHistogram", [b[a]]])
                                    }
                                    d.push(["Single", "sl_radiooff", "createHistogram", []]);
                                    return d
                                };
                                this.getCorrelateMenu = function() {
                                    var d = [];
                                    var b = this.sortObject(this.data.z);
                                    for (var a = 0; a < b.length; a++) {
                                        d.push([b[a], "sl_radiooff", "addRegressionLine", [b[a]]])
                                    }
                                    d.push(["Single", "sl_radiooff", "correlateData", []]);
                                    return d
                                };
                                this.getDOEMenu = function() {
                                    var d = [];
                                    var c = this.initialGraphType.match(/Scatter|Map/) ? this.getKeys(this.dataStndBy.z) : this.getKeys(this.dataStndBy.x);
                                    var a = this.getObjectArray(this.includeDOE);
                                    for (var b = 0; b < c.length; b++) {
                                        d.push([c[b], a[c[b]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyDOE", [c[b]]])
                                    }
                                    return d
                                };
                                this.getDOEConfigurationMenu = function() {
                                    var a = [];
                                    var e = this.layoutCurrent;
                                    var b = this.layoutConfig[e] && this.layoutConfig[e].graphType ? this.layoutConfig[e].graphType : this.data.l.type[e];
                                    var d = false;
                                    if (e) {
                                        a.push(["Graph Type", "ly_doe", d, d, d, "getDOEGraphTypeMenu", []]);
                                        a.push(["Graph Size", "ar_minmax", d, d, d, "getDOEGraphSizeMenu", []]);
                                        if (b == "Scatter") {
                                            a.push(["Axes", "p_g2axes", d, d, d, "getDOEAxesMenu", []])
                                        }
                                    } else {
                                        a.push(["Graph Size", "ar_minmax", d, d, d, "getDOEGraphSizeMenu", []])
                                    }
                                    return a
                                };
                                this.getDOEGraphTypeMenu = function() {
                                    var b = this.layoutCurrent;
                                    var a = [];
                                    if (this.data.l.type[b].match(/Pie|Treemap/)) {
                                        a.push(["Pie Chart", "g_pie", "updateDOEGraphType", ["Pie"]]);
                                        a.push(["Treemap", "g_treemap", "updateDOEGraphType", ["Treemap"]])
                                    } else {
                                        a.push(["Bar", "g_bar", "updateDOEGraphType", ["Bar"]]);
                                        a.push(["Dotplot", "g_dotplot", "updateDOEGraphType", ["Dotplot"]]);
                                        a.push(["Line", "g_line", "updateDOEGraphType", ["Line"]]);
                                        a.push(["Scatter 2D", "g_scatter2d", "updateDOEGraphType", ["Scatter"]]);
                                        a.push(["Histogram", "g_histogram", "updateDOEGraphType", ["Scatter2D"]])
                                    }
                                    return a
                                };
                                this.getDOEGraphSizeMenu = function() {
                                    var f = [];
                                    var h = this.layoutCurrent;
                                    var a = this.layoutConfig[h] && this.layoutConfig[h].size ? this.layoutConfig[h].size : "1X1";
                                    var g = this.layout.split("X");
                                    for (var e = 0; e < g[0]; e++) {
                                        for (var d = 0; d < g[1]; d++) {
                                            var b = (e + 1) + "X" + (d + 1);
                                            f.push([b, a == b ? "sl_radioon" : "sl_radiooff", "updateDOEGraphSize", [b]])
                                        }
                                    }
                                    return f
                                };
                                this.getDOETopologyMenu = function() {
                                    var d = [];
                                    for (var c = 2; c < 5; c++) {
                                        for (var b = 2; b < 5; b++) {
                                            var a = c + "X" + b;
                                            d.push([a, this.layoutTopology == a ? "sl_radioon" : "sl_radiooff", "modifyDOE", ["layout", a]])
                                        }
                                    }
                                    return d
                                };
                                this.getDOEAxesMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["X-Axis", "p_g2axisx", a, a, a, "getDOEAxisMenu", ["x"]]);
                                    b.push(["Y-Axis", "p_g2axisy", a, a, a, "getDOEAxisMenu", ["y"]]);
                                    return b
                                };
                                this.getDOEAxisMenu = function(b) {
                                    var a = false;
                                    return [
                                        ["Series", "ch_ls", a, a, a, "getDOEAxisSeriesMenu", [b]]
                                    ]
                                };
                                this.getDOEAxisSeriesMenu = function(b) {
                                    var k = [];
                                    var e = this.sortObject(this.data.x);
                                    var f = this.layoutCurrent;
                                    var h = this.dataStndBy.x;
                                    var a = this.layoutConfig[f] && this.layoutConfig[f].xAxis ? this.layoutConfig[f].xAxis : this.data.l.smps[f][0];
                                    var g = this.layoutConfig[f] && this.layoutConfig[f].yAxis ? this.layoutConfig[f].yAxis : this.data.l.smps[f][0];
                                    var j = b == "x" ? (h.hasOwnProperty(a) ? a : this.data.y.vars[a]) : (h.hasOwnProperty(g) ? g : this.data.y.vars[g]);
                                    for (var d = 0; d < e.length; d++) {
                                        if (this.meta.data.x[e[d]].type == "Numeric") {
                                            k.push([e[d], e[d] == j ? "sl_radioon" : "sl_radiooff", "updateDOEAxis", [b, e[d]]])
                                        }
                                    }
                                    if (k.length) {
                                        k.push(["-"])
                                    }
                                    for (var d = 0; d < this.data.y.vars.length; d++) {
                                        k.push([this.data.y.vars[d], this.data.y.vars[d] == j ? "sl_radioon" : "sl_radiooff", "updateDOEAxis", [b, d]])
                                    }
                                    return k
                                };
                                this.getCorrelationCatMenu = function(f, d) {
                                    var b = [];
                                    var e = this.sortObject(this.data[f]);
                                    for (var a = 0; a < e.length; a++) {
                                        if (this.isNumeric(this.data[f][e[a]])) {
                                            b.push([e[a], "sl_radiooff", "correlateData", [d, e[a]]])
                                        }
                                    }
                                    return b
                                };
                                this.getCorrelationMenu = function() {
                                    var c = [];
                                    var b = [];
                                    var a = false;
                                    if (this.data.y.vars.length >= 3) {
                                        c.push(["Samples", "ch_ls", "correlateData"])
                                    }
                                    if (this.data.y.smps.length >= 3 && this.data.x && this.isNumericFactor("s")) {
                                        c.push(["Sample Annotation", "ch_ls", a, a, a, "getCorrelationCatMenu", ["x", true]])
                                    }
                                    if (this.data.y.smps.length >= 3) {
                                        c.push(["Variables", "ch_lv", "correlateData", [true]])
                                    }
                                    if (this.data.y.vars.length >= 3 && this.data.z && this.isNumericFactor("v")) {
                                        c.push(["Variable Annotation", "ch_lv", a, a, a, "getCorrelationCatMenu", ["z", a]])
                                    }
                                    return c
                                };
                                this.getMagnificationMenu = function() {
                                    var a = [];
                                    for (var b = 1; b <= 10; b++) {
                                        a.push([(96 * b) + " DPI", this.printMagnification == b ? "sl_radioon" : "sl_radiooff", "changeAttributeNoDraw", ["printMagnification", b]])
                                    }
                                    return a
                                };
                                this.getParametersMenu = function() {
                                    var a = [];
                                    a.push(["Load Parameters", "cd_upload", true, []]);
                                    a.push(["Save as JSON", "sv_diskjson", "save", [false, "cX-" + this.target + "-param", true]]);
                                    return a
                                };
                                this.getReproducibleResearchMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Reproducible Research code", "c_rrcode", "clickRepResearch", []]);
                                    a.push(["Show JSON code", "cd_json", "clickShowCode", []]);
                                    a.push(["Show R code", "c_rcode", "clickShowRCode", []]);
                                    a.push(["Show Meta data", "cd_params", "clickShowMetaCode", []]);
                                    if (!this.motionBy) {
                                        a.push(["Reproduce", "op_redo", "reproduce", [b], CanvasXpress.system.control + " + " + CanvasXpress.system.alt + " + R"]);
                                        a.push(["Replay", "sv_video", "reproduce", [b, true], CanvasXpress.system.shift + " + " + CanvasXpress.system.control + " + R"]);
                                        a.push(["Print Sequence", "sv_pictures", "reproduce", [b, b, true], CanvasXpress.system.shift + " + " + CanvasXpress.system.control + " + P"])
                                    }
                                    a.push(["-"]);
                                    return a
                                };
                                this.getFileMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Save as PNG", "sv_image", "print", [], CanvasXpress.system.control + " + P"]);
                                    if (!this.graphType.match(/Venn|TagCloud|Map/)) {
                                        a.push(["Save as SVG", "sv_svg", "saveSVG", []])
                                    }
                                    a.push(["Save as JSON", "sv_diskjson", "save", [], CanvasXpress.system.control + " + S"]);
                                    if (this.editable) {
                                        a.push(["Edit in JS Fiddle", "c_jsfiddle", "editJSFiddle", []]);
                                        a.push(["Edit in CodePen", "c_codepen", "editCodePen", []])
                                    }
                                    a.push(["Print Magnification", "z_zoom", b, b, b, "getMagnificationMenu", []]);
                                    a.push(["-"]);
                                    a.push(["Reproducible Research", "c_rr", b, b, b, "getReproducibleResearchMenu", []]);
                                    if (this.remoteService && this.remoteServiceType == "webService") {
                                        a.push(["Save customizations to server", "sv_disk", "saveRemote", ["afterRender"]]);
                                        a.push(["Clear parameters from server", "sv_diskremove", "clearRemote", []])
                                    }
                                    a.push(["-"]);
                                    a.push(["Load", "cd_upload", true, []]);
                                    if (this.Rdatasets) {
                                        a.push(["R Datasets", "c_r", b, b, b, "getRdatasetsMenu", []])
                                    }
                                    a.push(["-"]);
                                    a.push(["Parameters", "wp_configuration", b, b, b, "getParametersMenu", []]);
                                    a.push(["-"]);
                                    a.push(["Reset", "op_refresh", "masterReset", [], "ESC"]);
                                    a.push(["Hard Reset", "op_redo", "replot", [false, false, true], CanvasXpress.system.shift + " ESC"]);
                                    return a
                                };
                                this.getExploreMenu = function() {
                                    var a = this.getObjectArray(CanvasXpress.graphTypes.OneDGraphs);
                                    var b = [];
                                    if (!this.disableDataFilters) {
                                        b.push(["Filters", "fp_funnel", "clickDataFilters", []])
                                    }
                                    if (!this.disableDataTable) {
                                        b.push(["Table", "tb_table", "clickDataTable", []])
                                    }
                                    if (!this.disableDataExplorer) {
                                        b.push(["Configure", "wp_installation", "clickDataExplorer", []])
                                    }
                                    if (!this.isCorrelate && !this.isDOE) {
                                        if (a[this.graphType] && !this.is3DPlot) {
                                            if (this.data.x) {
                                                b.push(["-"]);
                                                b.push(["Explore Meta-Data", "ly_doe", "createDOE"])
                                            }
                                        } else {
                                            if (this.graphType == "Scatter2D") {
                                                if (this.data.z && !this.scatterPlotMatrix) {
                                                    b.push(["-"]);
                                                    b.push(["Explore Meta-Data", "ly_doe", "createDOE"])
                                                } else {
                                                    if (this.isHistogram && this.dataStndBy.z) {
                                                        b.push(["-"]);
                                                        b.push(["Explore Meta-Data", "ly_doe", "createDOE"])
                                                    }
                                                }
                                            } else {
                                                if (this.graphType == "Map") {
                                                    if (this.data.z) {
                                                        b.push(["-"]);
                                                        b.push(["Explore Meta-Data", "ly_doe", "createDOE"])
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (!this.disableConfigurator) {
                                        b.push(["-"]);
                                        b.push(["Search Parameters", "z_zoom", "addConfiguratorCloseMenus"])
                                    }
                                    return b
                                };
                                this.getConfigurationMenu = function() {
                                    var g = this.decorations;
                                    var e = false;
                                    var b = {
                                        Bar: true,
                                        Line: true,
                                        Area: true,
                                        AreaLine: true,
                                        BarLine: true,
                                        Boxplot: true,
                                        Dotplot: true,
                                        DotLine: true,
                                        Gantt: true,
                                        Heatmap: true,
                                        Treemap: true,
                                        TagCloud: true,
                                        ParallelCoordinates: true,
                                        Sankey: true,
                                        Stacked: true,
                                        StackedLine: true,
                                        StackedPercent: true,
                                        StackedPercentLine: true
                                    };
                                    var a = [];
                                    if (this.graphType == "Map" || this.graphType == "Tree") {
                                        a.push(["Citation", "p_g1citation", e, e, e, "getGraphPartMenu", ["citation"]]);
                                        a.push(["Legend", "lg_legend", e, e, e, "getLegendMenu", []]);
                                        a.push(["Title / Subtitle", this.graphType == "Heatmap" ? "p_ghtitlesubtitle" : "p_g1titlesubtitle", e, e, e, "getTitleSubtitleMenu", []])
                                    } else {
                                        if (b[this.graphType] && !this.is3DPlot) {
                                            if (this.graphType != "Heatmap") {
                                                a.push(["Axes", "p_g1axes", e, e, e, "getAxesMenu", []]);
                                                a.push(["Axes Titles", "p_g1axestitles", e, e, e, "getAxesTitleMenu", []])
                                            }
                                            a.push(["Citation", this.graphType == "Heatmap" ? "p_ghcitation" : "p_g1citation", e, e, e, "getGraphPartMenu", ["citation"]]);
                                            a.push(["General", this.graphType == "Heatmap" ? "gc_ggh" : "gc_gg1", e, e, e, "getGeneralMenu", []]);
                                            if (this.graphType != "Heatmap") {
                                                a.push(["Grid", "gr_g1", e, e, e, "getPlotAreaGridMenu", ["x"]]);
                                                if (this.graphType.match(/Dot/)) {
                                                    a.push(["Dotplot", "g_dotplot", e, e, e, "getDataPointsMenu", []])
                                                } else {
                                                    if (this.graphType == "Boxplot") {
                                                        a.push(["Boxplot", "g_boxplot", e, e, e, "getBoxplotMenu", []])
                                                    }
                                                }
                                                a.push(["Plot Area", "gc_gg1", e, e, e, "getPlotAreaOneMenu", []]);
                                                if (g) {
                                                    a.push(["Decorations", g.marker ? "gd_g1marker" : "gd_g1line", e, e, e, "getDecorationsMenu", []])
                                                }
                                                a.push(["Legend", "lg_g1", e, e, e, "getLegendMenu", []]);
                                                if (this.data.x) {
                                                    a.push(["Overlays", "o_g1", e, e, e, "getOverlaysMenu", []])
                                                }
                                            }
                                            if (this.graphType == "Heatmap") {
                                                a.push(["Indicator", "i_h", e, e, e, "getIndicatorMenu", []]);
                                                a.push(["Heatmap", "g_heatmap", e, e, e, "getHeatmapMenu", []]);
                                                if (this.data.x || this.data.z) {
                                                    a.push(["Overlays", "o_ghsmps", e, e, e, "getOverlaysMenu", []])
                                                }
                                            }
                                            a.push(["Sample Labels", this.graphType == "Heatmap" ? "p_ghsamplelabels" : "p_g1samplelabels", e, e, e, "getSmpLabelMenu", []]);
                                            a.push(["Samples Title", this.graphType == "Heatmap" ? "p_ghsampletitle" : "p_g1sampletitle", e, e, e, "getGraphPartMenu", ["smpTitle", true]]);
                                            if (this.graphType == "Heatmap") {
                                                a.push(["Variable Labels", "p_ghvariablelabels", e, e, e, "getVarLabelMenu", []]);
                                                a.push(["Variables Title", "p_ghvariabletitle", e, e, e, "getGraphPartMenu", ["varTitle", true]])
                                            }
                                            a.push(["Title / Subtitle", this.graphType == "Heatmap" ? "p_ghtitlesubtitle" : "p_g1titlesubtitle", e, e, e, "getTitleSubtitleMenu", []])
                                        } else {
                                            if (this.graphType.match(/scatter/i) || this.is3DPlot) {
                                                if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                                    a.push(["Axes", "p_g3axes", e, e, e, "getAxesMenu", []]);
                                                    a.push(["Axes Titles", "p_g3axestitles", e, e, e, "getAxesTitleMenu", []]);
                                                    a.push(["Citation", "p_g3citation", e, e, e, "getGraphPartMenu", ["citation"]]);
                                                    a.push(["General", "gc_gg3", e, e, e, "getGeneralMenu", []])
                                                } else {
                                                    a.push(["Axes", "p_g2axes", e, e, e, "getAxesMenu", []]);
                                                    a.push(["Axes Titles", "p_g2axestitles", e, e, e, "getAxesTitleMenu", []]);
                                                    a.push(["Citation", "p_g2citation", e, e, e, "getGraphPartMenu", ["citation"]]);
                                                    a.push(["General", "gc_gg2", e, e, e, "getGeneralMenu", []])
                                                }
                                                a.push(["Grid", "gr_g2xy", e, e, e, "getPlotAreaScatterGridMenu", []]);
                                                a.push(["Plot Area", "gc_gg2", e, e, e, "getPlotAreaScatterMenu", []]);
                                                if (g) {
                                                    var c = g.nlfit ? "nonlinearFit" : g.line ? "gd_g2line" : g.reg ? "dt_cor" : g.nor ? "dt_denfit" : g.area ? "dt_denfitfilled" : g.qq ? "dt_qq" : g.cdf ? "dt_cdf" : g.kaplanMeier ? "dt_km" : g.marker ? "gd_g2marker" : e;
                                                    a.push(["Decorations", c, e, e, e, "getDecorationsMenu", []])
                                                }
                                                a.push(["Legend", "lg_g2", e, e, e, "getLegendMenu", []]);
                                                a.push(["Title / Subtitle", "p_g2titlesubtitle", e, e, e, "getTitleSubtitleMenu", []]);
                                                if (this.isSelectDataPoints) {
                                                    a.push(["Show hidden data points", "sl_eopen", "showHideSelectedData", [e, 45], "Ctrl + Insert"]);
                                                    a.push(["Hide data points", "sl_eremove", "showHideSelectedData", [e, 46], "Ctrl + Delete"])
                                                }
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.getAlignNetworkMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Top", "a_aligntop", "alignDistributeSelectedNodes", [a, 84]]);
                                    b.push(["Right", "a_alignright", "alignDistributeSelectedNodes", [a, 82]]);
                                    b.push(["Bottom", "a_alignbottom", "alignDistributeSelectedNodes", [a, 66]]);
                                    b.push(["Left", "a_alignleft", "alignDistributeSelectedNodes", [a, 76]]);
                                    return b
                                };
                                this.getDistributeNetworkMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["Vertically", "a_distributever", "alignDistributeSelectedNodes", [a, 86]]);
                                    b.push(["Horozontally", "a_distributehor", "alignDistributeSelectedNodes", [a, 72]]);
                                    return b
                                };
                                this.getRotateNetworkMenu = function() {
                                    var a = [];
                                    a.push(["Clockwise", "rt_c", "arrowMove", [34]]);
                                    a.push(["Clockwise - Animate", "rt_c2", "arrowMove", [39, true]]);
                                    a.push(["Anticlockwise", "rt_ac", "arrowMove", [33]]);
                                    a.push(["Anticlockwise - Animate", "rt_ac2", "arrowMove", [37, true]]);
                                    return a
                                };
                                this.getOrderNetworkMenu = function() {
                                    var a = [];
                                    a.push(["Send to back", "a_moveback", "orderNodes", ["sendNodeToBack"]]);
                                    a.push(["Send backward", "a_movebackward", "orderNodes", ["sendNodeBackward"]]);
                                    a.push(["Bring to front", "a_movefront", "orderNodes", ["bringNodeToFront"]]);
                                    a.push(["Bring forward", "a_moveforward", "orderNodes", ["bringNodeForward"]]);
                                    return a
                                };
                                this.getNetworkDecorationsPositionMenu = function() {
                                    var a = [];
                                    a.push(["Center", "ps_center", "changeAttribute", ["decorationsPosition", "center"]]);
                                    a.push(["Top", "ps_top", "changeAttribute", ["decorationsPosition", "top"]]);
                                    a.push(["Right", "ps_right", "changeAttribute", ["decorationsPosition", "right"]]);
                                    a.push(["Bottom", "ps_bottom", "changeAttribute", ["decorationsPosition", "bottom"]]);
                                    a.push(["Left", "ps_left", "changeAttribute", ["decorationsPosition", "left"]]);
                                    return a
                                };
                                this.getNetworkDecorationAttributesMenu = function() {
                                    var d = [];
                                    var c = [];
                                    var a = this.sortObject(this.meta.data.nodes);
                                    var f = {
                                        x: true,
                                        y: true,
                                        z: true,
                                        width: true,
                                        height: true,
                                        community: true,
                                        decorationsXi: true,
                                        decorationsYi: true
                                    };
                                    for (var e = 0; e < a.length; e++) {
                                        if (this.meta.data.nodes[a[e]].type == "Numeric" && !f[a[e]]) {
                                            c.push(a[e])
                                        }
                                    }
                                    var b = {};
                                    for (var e = 0; e < this.decorations.length; e++) {
                                        b[this.decorations[e]] = true
                                    }
                                    for (var e = 0; e < c.length; e++) {
                                        d.push([c[e], b[c[e]] ? "sl_checkboxon" : "sl_checkboxoff", "modifyNetworkDecorations", [c[e]]])
                                    }
                                    return d
                                };
                                this.getNetworkDecorationsTypeMenu = function() {
                                    var a = [];
                                    a.push(["Bar", "g_bar", "changeAttribute", ["decorationsType", "bar"]]);
                                    a.push(["Heatmap", "g_heatmap", "changeAttribute", ["decorationsType", "heatmap"]]);
                                    a.push(["Pie Chart", "g_pie", "changeAttribute", ["decorationsType", "pie"]]);
                                    a.push(["Stacked", "g_stacked", "changeAttribute", ["decorationsType", "stacked"]]);
                                    return a
                                };
                                this.getNetworkDecorationsMenu = function() {
                                    var b = [];
                                    var a = false;
                                    b.push(["at_tributes", "ch_la", a, a, a, "getNetworkDecorationAttributesMenu", []]);
                                    b.push(["Height", "sp_heightness", a, a, a, "changeTextColorAttributeMenu", ["-text-", "decorationsHeight"]]);
                                    b.push(["Width", "sp_thickness", a, a, a, "changeTextColorAttributeMenu", ["-text-", "decorationsWidth"]]);
                                    b.push(["Position", "ps_toloc2", a, a, a, "getNetworkDecorationsPositionMenu", []]);
                                    b.push(["Type", "ly_doe", a, a, a, "getNetworkDecorationsTypeMenu", []]);
                                    b.push([this.showDecorations ? "Hide Decorations" : "Show Decorations", this.showDecorations ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showDecorations"]]);
                                    return b
                                };
                                this.getNetworkNodeEdgeAttributesMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Nodes", "n_nodes", b, b, b, "getNetworkNodeAttributesMenu", []]);
                                    a.push(["Edges", "n_edges", b, b, b, "getNetworkEdgeAttributesMenu", []]);
                                    return a
                                };
                                this.getNetworkNodeAttributesPropertyMenu = function(b) {
                                    var d = [];
                                    var c = this.sortObject(this.meta.data.nodes);
                                    for (var a = 0; a < c.length; a++) {
                                        if (b.match(/shape|pattern/i)) {
                                            if (this.meta.data.nodes[c[a]].type == "Numeric") {
                                                continue
                                            }
                                        }
                                        d.push([c[a], this[b] == c[a] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [b, c[a]]])
                                    }
                                    return d
                                };
                                this.getNetworkNodeAttributesMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Color By", "at_col", b, b, b, "getNetworkNodeAttributesPropertyMenu", ["colorNodeBy"]]);
                                    a.push(["Shape By", "at_shp", b, b, b, "getNetworkNodeAttributesPropertyMenu", ["shapeNodeBy"]]);
                                    a.push(["Size By", "at_sze", b, b, b, "getNetworkNodeAttributesPropertyMenu", ["sizeNodeBy"]]);
                                    a.push(["Pattern By", "at_pat", b, b, b, "getNetworkNodeAttributesPropertyMenu", ["patternNodeBy"]]);
                                    return a
                                };
                                this.getNetworkEdgeAttributesPropertyMenu = function(b) {
                                    var d = [];
                                    var c = this.sortObject(this.meta.data.edges);
                                    for (var a = 0; a < c.length; a++) {
                                        if (b.match(/shape|pattern/)) {
                                            if (this.meta.data.edges[c[a]].type == "Numeric") {
                                                continue
                                            }
                                        }
                                        d.push([c[a], this[b] == c[a] ? "sl_radioon" : "sl_radiooff", "changeAttribute", [b, c[a]]])
                                    }
                                    return d
                                };
                                this.getQQPlotDistributionMenu = function() {
                                    var a = [];
                                    a.push(["Normal", this.qqDistribution == "ch_oa" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["qqDistribution", "ch_oa"]]);
                                    a.push(["Uniform", this.qqDistribution == "uniform" ? "sl_radioon" : "sl_radiooff", "changeAttribute", ["qqDistribution", "uniform"]]);
                                    return a
                                };
                                this.getQQPlotMenu = function() {
                                    var a = [];
                                    a.push(["Distribution", "dt_qq", false, false, false, "getQQPlotDistributionMenu", []]);
                                    a.push([this.isQQ ? "Remove QQ Plot" : "Show QQ Plot", this.isQQ ? "sl_eclose" : "sl_eopen", "modifyQQPlot", [this.isQQ]]);
                                    return a
                                };
                                this.getNetworkEdgeAttributesMenu = function() {
                                    var a = [];
                                    var b = false;
                                    a.push(["Color By", "at_col", b, b, b, "getNetworkEdgeAttributesPropertyMenu", ["colorEdgeBy"]]);
                                    a.push(["Size By", "sp_thickness2", b, b, b, "getNetworkEdgeAttributesPropertyMenu", ["sizeEdgeBy"]]);
                                    return a
                                };
                                this.setMenu = function(d) {
                                    var b = this.getObjectArray(CanvasXpress.graphTypes.OneDGraphs);
                                    var g = this.decorations;
                                    var a = d && this.layoutValid ? this.getActiveLayout(d) : false;
                                    var c = false;
                                    this.layoutCurrent = a ? a.idx : false;
                                    this.menu = [];
                                    if (this.graphType != "Network") {
                                        this.menu.push(["File", "cd_folder", c, c, c, "getFileMenu", []]);
                                        this.menu.push(["-"]);
                                        if (!this.isDOE && this.graphType != "Genome") {
                                            this.menu.push(["Explore", "z_zoom", c, c, c, "getExploreMenu", []]);
                                            this.menu.push(["-"])
                                        }
                                    }
                                    if (this.graphType == "Network") {
                                        if (CanvasXpress.selector.selections) {
                                            this.menu.push(["Align", "a_alignbottom", c, c, c, "getAlignNetworkMenu", []]);
                                            this.menu.push(["Distribute", "a_distributever", c, c, c, "getDistributeNetworkMenu", []]);
                                            this.menu.push(["Order", "a_order", c, c, c, "getOrderNetworkMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Show conections", "g_network", "showHideSelectedData", [c, 36], "Ctrl + Home"]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Hide nodes", "sl_eremove", "showHideSelectedData", [c, 46], "Ctrl + Delete"]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Layout Selected Nodes", "op_refresh", "recalculateLayoutSelectedNodes"])
                                        } else {
                                            this.menu.push(["File", "cd_folder", c, c, c, "getFileMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Explore", "z_zoom", c, c, c, "getExploreMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Legend", "lg_legend", c, c, c, "getLegendMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Data Point Properties", "at_colshpsze", c, c, c, "getNetworkNodeEdgeAttributesMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Decorations", "wp_installation", c, c, c, "getNetworkDecorationsMenu", []]);
                                            this.menu.push(["Color", "at_col", c, c, c, "getColorsMenu", []]);
                                            if (!this.networkVendor) {
                                                this.menu.push(["-"]);
                                                this.menu.push([this.showNetworkCommunities ? "Hide Communities" : "Show Communities", this.showNetworkCommunities ? "sl_eclose" : "sl_eopen", "toggleAttribute", ["showNetworkCommunities"]]);
                                                if (this.showNetworkCommunities && !this.colorNodeBy) {
                                                    this.menu.push(["Coordinate Convex Hull Color", "at_col", "toggleAttribute", ["coordinateNetworkConvexHullCommunityColor"]])
                                                }
                                            }
                                            if (!this.isNetworkMetricsDone) {
                                                this.menu.push(["-"]);
                                                this.menu.push(["Calculate Network metrics", "n_nodes", "calculateNetworkMetrics", [true]])
                                            }
                                            this.menu.push(["-"]);
                                            if (this.isHiddenNodes) {
                                                this.menu.push(["Show hidden nodes", "sl_eopen", "hideUnhideNodes", [], "Ctrl + Insert"]);
                                                this.menu.push(["-"])
                                            }
                                            this.menu.push(["Rotate", "rt_ac", c, c, c, "getRotateNetworkMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Undo", "op_undo", "undo", [], "Ctrl + z"]);
                                            this.menu.push(["Redo", "op_redo", "redo", [], "Ctrl + y"]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Redraw", "op_refresh", "recalculateLayout"])
                                        }
                                    }
                                    if (this.graphType == "Map") {
                                        this.menu.push(["Customize", "wp_configuration", c, c, c, "getConfigurationMenu", []]);
                                        this.menu.push(["-"]);
                                        if (this.data.z) {
                                            this.menu.push(["Color By", "at_col", c, c, c, "getDataPointAttributesPropertyMenu", ["colorBy"]])
                                        }
                                    } else {
                                        if (this.graphType == "Tree") {
                                            this.menu.push(["Customize", "wp_configuration", c, c, c, "getConfigurationMenu", []]);
                                            this.menu.push(["-"]);
                                            if (this.data.x) {
                                                this.menu.push(["Data Point Properties", "at_colshpsze", c, c, c, "getDataPointAttributesMenu", []]);
                                                this.menu.push(["-"])
                                            }
                                            this.menu.push(["Layout", "cl_horizontal", c, c, c, "getDendrogramsMenu", []])
                                        } else {
                                            if (this.graphType == "Circular" && this.circularType == "normal") {
                                                this.menu.push(["Cluster", "cl_horizontal", c, c, c, "getDendrogramsMenu", []]);
                                                this.menu.push(["-"])
                                            }
                                        }
                                    }
                                    if (this.isDOE) {
                                        if (this.layoutCurrent) {
                                            this.menu.push(["Data Point Properties", "at_colshpsze", c, c, c, "getDataPointAttributesMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Customize", "wp_configuration", c, c, c, "getDOEConfigurationMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Data", "wp_data", c, c, c, "getDataMenu", []]);
                                            this.menu.push(["-"])
                                        } else {
                                            this.menu.push(["Customize", "wp_configuration", c, c, c, "getDOEConfigurationMenu", []]);
                                            this.menu.push(["-"])
                                        }
                                        this.menu.push(["Modify Meta-Data Plots", "ly_doe", c, c, c, "getDOEMenu", []]);
                                        this.menu.push(["Meta-Data Plots Topology", "ly_segregate", c, c, c, "getDOETopologyMenu", []]);
                                        this.menu.push(["Remove Meta-Data Plots", "ly_doeremove", "removeDOE"]);
                                        this.menu.push(["-"])
                                    } else {
                                        if (b[this.graphType] && !this.is3DPlot) {
                                            this.menu.push(["Customize", "wp_configuration", c, c, c, "getConfigurationMenu", []]);
                                            this.menu.push(["-"]);
                                            this.menu.push(["Data", "wp_data", c, c, c, "getDataMenu", []]);
                                            this.menu.push(["-"]);
                                            if (this.data.x || this.graphType == "ParallelCoordinates" || this.graphType == "Line") {
                                                this.menu.push(["Data Point Properties", "at_colshpsze", c, c, c, "getDataPointAttributesMenu", []]);
                                                this.menu.push(["-"])
                                            }
                                            if ((this.data.x || this.data.z) && this.isRawData) {
                                                if (this.data.x) {
                                                    this.menu.push(["Group Samples", "a_group", c, c, c, "getGroupSamplesMenu", []])
                                                }
                                                if ((this.data.x || this.data.z) && !this.isGraphTime && this.barType != "lollipop") {
                                                    this.menu.push(["Segregate Data", "ly_segregate", c, c, c, "getSegregationMenu", []])
                                                }
                                                this.menu.push(["-"])
                                            }
                                            if (!this.layoutValid && this.isRawData && !this.graphType.match(/Gantt/) && !this.isContour) {
                                                this.menu.push(["Cluster", "cl_horizontal", c, c, c, "getDendrogramsMenu", []]);
                                                this.menu.push(["-"]);
                                                if (this.isHistogram) {
                                                    this.menu.push(["Histogram", "dt_hist", c, c, c, "getHistogramMenu", []])
                                                } else {
                                                    if (!this.isCorrelate && !this.isHistogram && !this.graphType.match(/Gantt/) && !this.isContour) {
                                                        this.menu.push(["Correlate", "dt_cor", c, c, c, "getCorrelationMenu", []]);
                                                        this.menu.push(["Histogram", "dt_hist", "createHistogram"])
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.graphType == "Circular") {
                                                this.menu.push(["Data", "wp_data", c, c, c, "getDataMenu", []]);
                                                this.menu.push(["-"]);
                                                if (this.data.x || this.data.z) {
                                                    if (this.data.x || this.data.z) {
                                                        this.menu.push(["Segregate Data", "ly_segregate", c, c, c, "getSegregationMenu", []])
                                                    }
                                                    this.menu.push(["-"])
                                                }
                                            } else {
                                                if (this.graphType.match(/scatter/i) || this.is3DPlot) {
                                                    this.menu.push(["Customize", "wp_configuration", c, c, c, "getConfigurationMenu", []]);
                                                    this.menu.push(["-"]);
                                                    if (this.graphType == "Scatter2D" && this.scatterType != "manhattan" && !this.isValidKaplanMeier()) {
                                                        this.menu.push(["Data", "wp_data", c, c, c, "getDataMenu", []]);
                                                        this.menu.push(["-"])
                                                    }
                                                    if (this.graphType == "Scatter2D" && this.scatterType != "manhattan") {
                                                        if (this.isHistogram) {
                                                            this.menu.push(["Histogram", "dt_hist", c, c, c, "getHistogramMenu", []])
                                                        } else {
                                                            if (this.isCorrelate) {
                                                                this.menu.push(["Remove Correlation", "dt_corremove", "removeCorrelation"])
                                                            } else {
                                                                if (this.isQQ) {
                                                                    this.menu.push(["QQ Plot", "dt_qq", c, c, c, "getQQPlotMenu", []])
                                                                } else {
                                                                    if (this.isCDF) {
                                                                        this.menu.push(["Remove CDF plot", "dt_cdfremove", "removeCDFPlot"])
                                                                    } else {
                                                                        if (g && g.reg) {
                                                                            this.menu.push(["Remove Correlation", "dt_corremove", "removeCorrelation"])
                                                                        } else {
                                                                            this.menu.push(["Loess", "cr_bezier", c, c, c, "getLoessMenu", []]);
                                                                            if (this.data.z) {
                                                                                this.menu.push(["Correlate", "dt_cor", c, c, c, "getCorrelateMenu", []])
                                                                            } else {
                                                                                this.menu.push(["Correlate", "dt_cor", "correlateData"])
                                                                            }
                                                                            if (!this.scatterPlotMatrix) {
                                                                                this.menu.push(["Kaplan Meier", "dt_km", c, c, c, "getKaplanMeierMenu", []])
                                                                            }
                                                                            this.menu.push(["QQ Plot", "dt_qq", c, c, c, "getQQPlotMenu", []]);
                                                                            this.menu.push(["CDF Plot", "dt_cdf", "addCDFPlot"])
                                                                        }
                                                                        if (!this.scatterPlotMatrix) {
                                                                            if (this.decorations && this.decorations.kaplanMeier) {} else {
                                                                                if (this.data.z) {
                                                                                    this.menu.push(["Create Histogram", "dt_hist", c, c, c, "getHistogramCreateMenu", []])
                                                                                } else {
                                                                                    this.menu.push(["Create Histogram", "dt_hist", "createHistogram"])
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (this.graphType == "Scatter3D") {
                                                            this.menu.push(["Loess", "cr_bezier", c, c, c, "getLoessMenu", []])
                                                        }
                                                    }
                                                    if (this.data.z || (this.isHistogram && this.dataStndBy.z)) {
                                                        this.menu.push(["Data Point Properties", "at_colshpsze", c, c, c, "getDataPointAttributesMenu", []])
                                                    }
                                                    if ((this.isQQ || this.isCDF || this.data.z || (this.isHistogram && this.dataStndBy.z)) && !this.scatterPlotMatrix && this.graphType != "Scatter3D" && !this.is3DPlot) {
                                                        this.menu.push(["-"]);
                                                        this.menu.push(["Segregate Data", "ly_segregate", c, c, c, "getSegregationMenu", []])
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return this.menu
                                };
                                this.resetMenus = function() {
                                    this.removeMenus()
                                };
                                this.initializeMenus = function() {
                                    if (this.showPrimaryMenus) {
                                        var a = this.setMenu();
                                        for (var c = 0; c < a.length; c++) {
                                            var e = a[c];
                                            var d = c == 0 ? {
                                                marginLeft: "13px"
                                            } : false;
                                            if (e[5]) {
                                                this.addImageToToolbar(e[1], e[0], e[5], e[6], false, true, false, d)
                                            }
                                        }
                                        var b = this.$(this.target + "-cX-Toolbar-Custom");
                                        if (b) {
                                            if (b.clientWidth > (this.width * 0.8)) {
                                                this.removeAllImagesFromToolbar()
                                            }
                                        }
                                    }
                                };
                                this.initializeMenus()
                            };
                            CanvasXpress.prototype.initLinks = function() {
                                this.addLinkDiv = function() {
                                    var b = this.$(this.target + "-cX-Link");
                                    if (b) {
                                        this.resetLinkDiv();
                                        return b
                                    }
                                    var b = this.$cX("div", {
                                        id: this.target + "-cX-Link",
                                        className: "CanvasXpressLink"
                                    }, {
                                        zIndex: 10002,
                                        display: "none"
                                    });
                                    var a = this.$cX("ul", {
                                        id: this.target + "-cX-Link-Content",
                                        className: "CanvasXpressList"
                                    });
                                    var c = this.$("north-wrapper-" + this.target);
                                    if (c) {
                                        b.appendChild(a);
                                        c.appendChild(b)
                                    }
                                    return b
                                };
                                this.showLinkDiv = function(J, b, D) {
                                    var K = this.$(this.target + "-cX-Link-Content");
                                    if (!K) {
                                        K = this.addLinkDiv()
                                    }
                                    var k = this.$("west-container-" + this.target);
                                    var M = false;
                                    if (K) {
                                        this.resetLinkDiv();
                                        var L = this.adjustedCoordinates(J);
                                        if (L) {
                                            var h = L.x + k.offsetWidth;
                                            var f = L.y;
                                            for (var H = 0; H < b.length; H++) {
                                                var o = b[H].url;
                                                var C = b[H].name;
                                                var r = b[H].title;
                                                var E = b[H].icon;
                                                var v = b[H].source;
                                                var B = b[H].params;
                                                if (o) {
                                                    M = true
                                                } else {
                                                    if (v && this.data.links && this.data.links[v]) {
                                                        o = this.data.links[v].url;
                                                        M = true;
                                                        if (B) {
                                                            for (var G in B) {
                                                                o = o.replace("$" + G + "$", B[G])
                                                            }
                                                        }
                                                    }
                                                }
                                                var F = this.$cX("li", {
                                                    className: "CanvasXpressListItem"
                                                });
                                                var c = r ? r : this.data.links && v && this.data.links[v] && this.data.links[v].title ? this.data.links[v].title : "";
                                                var N = this.$cX("a", {
                                                    className: "CanvasXpressListItemA",
                                                    href: o,
                                                    alt: c,
                                                    title: c,
                                                    target: "_blank"
                                                });
                                                var I = this.$cX("img", {
                                                    className: "CanvasXpressListIcon",
                                                    src: E ? E : this.data.links && v && this.data.links[v] && this.data.links[v].icon ? this.data.links[v].icon : CanvasXpress.png
                                                });
                                                var A = this.$cX("span", {
                                                    className: "CanvasXpressListItemText",
                                                    innerHTML: C ? C : this.data.links && v && this.data.links[v] && this.data.links[v].name ? this.data.links[v].name : H
                                                });
                                                N.appendChild(I);
                                                N.appendChild(A);
                                                F.appendChild(N);
                                                this.addRemoveLinkListeners("addEvtListener", F);
                                                K.appendChild(F)
                                            }
                                            K.parentNode.style.left = h + "px";
                                            K.parentNode.style.top = f + "px";
                                            K.parentNode.style.display = M ? "block" : "none"
                                        }
                                    }
                                };
                                this.addRemoveLinkListeners = function(b, a) {
                                    if (a) {
                                        this.addRemoveEvtListener(b, a, "click", this.clickLink, false);
                                        this.addRemoveEvtListener(b, a, "mouseover", this.mouseoverLink, false);
                                        this.addRemoveEvtListener(b, a, "mouseout", this.mouseoutLink, false)
                                    }
                                };
                                this.clickLink = function(a) {
                                    return function(b) {
                                        a.resetLinkDiv();
                                        return false
                                    }
                                }(this);
                                this.mouseoverLink = function(a) {
                                    return function(c) {
                                        var b = a.getMenuItemComp(c);
                                        if (b) {
                                            b[0].className = "CanvasXpressListItemActive";
                                            b[1].className = "CanvasXpressListItemAActive"
                                        }
                                        return false
                                    }
                                }(this);
                                this.mouseoutLink = function(a) {
                                    return function(c) {
                                        var b = a.getMenuItemComp(c);
                                        if (b) {
                                            b[0].className = "CanvasXpressListItem";
                                            b[1].className = "CanvasXpressListItemA"
                                        }
                                        return false
                                    }
                                }(this);
                                this.resetLinkDiv = function() {
                                    var a = this.$(this.target + "-cX-Link-Content");
                                    if (a && a.childNodes) {
                                        while (a.childNodes.length > 0) {
                                            this.addRemoveLinkListeners("removeEvtListener", a.childNodes[0]);
                                            a.removeChild(a.childNodes[0])
                                        }
                                        a.parentNode.style.display = "none"
                                    }
                                };
                                this.resetLinks = function() {
                                    this.resetLinkDiv()
                                };
                                this.initializeLinks = function() {
                                    if (!this.disableEvents) {
                                        return this.addLinkDiv()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initTooltip = function() {
                                this.addInfoSpan = function() {
                                    var b = this.$(this.target + "-cX-Info");
                                    if (b) {
                                        this.resetInfoSpan();
                                        return b
                                    }
                                    var d = this.$("center-wrapper-" + this.target);
                                    if (d) {
                                        b = this.$cX("span", {
                                            id: this.target + "-cX-Info",
                                            className: "CanvasXpressTooltip"
                                        }, {
                                            display: "none"
                                        });
                                        var a = this.$cX("div", {
                                            id: this.target + "-cX-Info-Left",
                                            className: "CanvasXpressTooltipArrowLeft"
                                        }, {
                                            display: "none"
                                        });
                                        d.appendChild(b);
                                        d.appendChild(a)
                                    }
                                };
                                this.resetInfoSpan = function(g, c) {
                                    var b = this.$(this.target + "-cX-Info");
                                    if (!b) {
                                        b = this.initializeTooltip()
                                    }
                                    var d = this.$(this.target + "-cX-Info-Left");
                                    if (b && !this.noInfoSpanReset) {
                                        var a = new Date().getTime() - this.infoStartTime;
                                        if (a > this.infoTimeIn || c) {
                                            b.style.left = "0px";
                                            b.style.top = "0px";
                                            b.style.display = "none";
                                            d.style.display = "none";
                                            b.innerHTML = ""
                                        }
                                    }
                                };
                                this.flashInfoSpan = function(f, e, h, b, a) {
                                    var d = this;
                                    if (b) {}
                                    var j = this.$(this.target + "-cX-Info");
                                    if (!j) {
                                        j = this.initializeTooltip()
                                    }
                                    if (j) {
                                        j.innerHTML = h;
                                        j.style.display = "block";
                                        j.style.left = (f || 0) + "px";
                                        j.style.top = (e || 0) + "px";
                                        if (a) {
                                            for (var c in a) {
                                                j.style[c] = a[c]
                                            }
                                        }
                                        if (b) {
                                            var g = function() {
                                                this.update = function() {
                                                    var k = new Date().getTime();
                                                    if (k - d.infoStartTime > b) {
                                                        d.resetInfoSpan();
                                                        clearInterval(i)
                                                    }
                                                };
                                                var i = d.setInterval(this.update, b)
                                            };
                                            g.call()
                                        }
                                    }
                                };
                                this.showInfoSpan = function(q, l, p, a) {
                                    if ((this.draggingOn || this.remoteUpdating || this.noInfoSpanReset || (this.lassoPoints && this.lassoPoints.length)) && !a) {
                                        return
                                    }
                                    var k = new Date().getTime() - this.infoStartTime;
                                    var m = this.$(this.target + "-cX-Info");
                                    if (!m) {
                                        m = this.initializeTooltip()
                                    }
                                    var n = this.$(this.target + "-cX-Info-Left");
                                    var b = window;
                                    var v = window.document;
                                    if (m && l && l != "" && k > this.infoTimeIn) {
                                        var u = p ? this.regularCoordinates(q, p) : this.adjustedCoordinates(q, m);
                                        if (u) {
                                            var i = u.x;
                                            var g = q ? u.y : u.y + 25;
                                            if (CanvasXpress.system.isIE) {
                                                i += v.body.scrollLeft;
                                                g += v.body.scrollTop
                                            }
                                            var d;
                                            var c;
                                            if (q && q.type == "touchmove") {
                                                d = 25;
                                                c = 40
                                            } else {
                                                d = 10;
                                                c = 20
                                            }
                                            if (!isNaN(l)) {
                                                l = l.toString()
                                            }
                                            if (l.match(/\w/)) {
                                                m.innerHTML = l;
                                                m.style.left = (i + d) + "px";
                                                m.style.top = (g - c) + "px";
                                                m.style.display = "inline";
                                                var o = (m.clientHeight / 2) + 1.5;
                                                n.style.left = (i + d + 2.5) + "px";
                                                n.style.top = (g + o - c) + "px";
                                                var j = parseInt(m.clientWidth);
                                                var o = parseInt(m.clientHeight);
                                                if (j < b.innerWidth && j > (b.innerWidth + b.pageXOffset) - i && (j + c) < (i - b.pageXOffset)) {
                                                    m.style.left = (i - (j + c)) + "px";
                                                    m.style.left = (i - (parseInt(m.clientWidth) + c)) + "px"
                                                }
                                                if (o < b.innerHeight && o > (b.innerHeight + b.pageYOffset) - g && (o - (d * 1.5)) < (g - b.pageYOffset)) {
                                                    m.style.top = (g - (o - (d * 1.5))) + "px";
                                                    m.style.top = (g - (parseInt(m.clientHeight) - (d * 1.5))) + "px"
                                                }
                                                this.infoStartTime = new Date().getTime();
                                                var f = this;
                                                var r = function() {
                                                    this.update = function() {
                                                        var h = new Date().getTime();
                                                        if (h - f.infoStartTime > f.infoTimeOut) {
                                                            f.resetInfoSpan();
                                                            clearInterval(e)
                                                        }
                                                    };
                                                    var e = f.setInterval(this.update, 100)
                                                };
                                                r.call()
                                            }
                                        }
                                    }
                                };
                                this.initializeTooltip = function() {
                                    if (!this.disableEvents) {
                                        return this.addInfoSpan()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initTooltipMouse = function() {
                                this.addMousePositionDiv = function() {
                                    var e = this.$(this.target + "-cX-MousePosition");
                                    if (e) {
                                        return e
                                    }
                                    e = this.$cX("div", {
                                        id: this.target + "-cX-MousePosition",
                                        className: "CanvasXpressMousePosition"
                                    }, {
                                        left: "0px",
                                        top: "0px",
                                        display: "none"
                                    });
                                    var b = this.$cXI("ar_cross", {
                                        className: "CanvasXpressMousePosition",
                                        src: "ar_cross"
                                    });
                                    var c = this.$cX("span", {
                                        id: this.target + "-cX-MousePositionCoordinates",
                                        className: "CanvasXpressMousePosition",
                                        innerHTML: "0, 0"
                                    });
                                    e.appendChild(b);
                                    e.appendChild(c);
                                    var a = this.$("center-wrapper-" + this.target);
                                    if (a) {
                                        a.appendChild(e)
                                    }
                                    return e
                                };
                                this.showMousePosition = function(f, h) {
                                    if (h) {} else {
                                        if (f) {
                                            h = this.adjustedCoordinates(f)
                                        } else {
                                            return
                                        }
                                    }
                                    var a = h.x + ", " + h.y;
                                    var g = this.$(this.target + "-cX-MousePosition");
                                    if (!g) {
                                        g = this.initializeTooltipMouse()
                                    }
                                    var b = this.$(this.target + "-cX-MousePositionCoordinates");
                                    if (g && b) {
                                        g.style.left = h.x + "px";
                                        g.style.top = h.y + "px";
                                        g.style.display = "block";
                                        b.innerHTML = a;
                                        this.mousePositioning = true
                                    }
                                };
                                this.resetMousePosition = function() {
                                    var b = this.$(this.target + "-cX-MousePosition");
                                    if (!b) {
                                        b = this.initializeTooltipMouse()
                                    }
                                    var a = this.$(this.target + "-cX-MousePositionCoordinates");
                                    if (b && a) {
                                        b.style.left = "0px";
                                        b.style.top = "0px";
                                        b.style.display = "none";
                                        a.innerHTML = "0, 0";
                                        this.mousePositioning = false
                                    }
                                };
                                this.initializeTooltipMouse = function() {
                                    if (!this.disableEvents) {
                                        return this.addMousePositionDiv()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initTooltipDiv = function() {
                                this.addTooltipDiv = function(w, v, u, b, f) {
                                    this.resetInfoSpan();
                                    var g = 0;
                                    var k = this.target + "-cX-TooltipDiv" + g;
                                    var A = this.$(this.target + "-cX-Info");
                                    if (A && A.style.display != "none") {
                                        v = parseInt(A.style.left);
                                        u = parseInt(A.style.top)
                                    }
                                    var l = this.$(k);
                                    while (l) {
                                        g++;
                                        k = this.target + "-cX-TooltipDiv" + g;
                                        l = this.$(k)
                                    }
                                    var p = this.$cX("div", {
                                        id: k,
                                        className: "CanvasXpressTooltip draggable"
                                    }, {
                                        left: v + "px",
                                        top: u + "px"
                                    });
                                    var r = this.$cXI("op_cancel", {
                                        id: k + "Close",
                                        className: "CanvasXpressTooltip",
                                        src: "op_cancel",
                                        title: "Close"
                                    });
                                    var h = this.$cXI("fp_pencil", {
                                        id: k + "Marker",
                                        className: "CanvasXpressTooltip",
                                        src: "fp_pencil",
                                        obj: this.stringifyJSON(f),
                                        title: "Add Marker"
                                    });
                                    if (!b) {
                                        b = {}
                                    }
                                    b.clear = "both";
                                    var a = 1;
                                    if (b.hasOwnProperty("opacity")) {
                                        a = b.opacity;
                                        delete(b.opacity)
                                    }
                                    p.style.opacity = a;
                                    var z = this.$cX("div", {
                                        id: k + "HTML",
                                        innerHTML: w || ""
                                    }, b);
                                    p.appendChild(r);
                                    if (f) {
                                        p.appendChild(h)
                                    }
                                    p.appendChild(z);
                                    var j = this.$("center-wrapper-" + this.target);
                                    j.appendChild(p);
                                    return p
                                };
                                this.addRemoveTooltipDivsListeners = function(a, b) {
                                    this.addRemoveEvtListener(a, b, "mousedown", this.registerMousemove, false);
                                    this.addRemoveEvtListener(a, b, "touchstart", this.registerMousemove, false);
                                    this.addRemoveEvtListener(a, b.childNodes[0], "click", this.closeTooltipDiv, false);
                                    if (b.childNodes[1] && b.childNodes[0].tagName.toUpperCase() == "SVG") {
                                        this.addRemoveEvtListener(a, b.childNodes[1], "click", this.addMarkerTooltipDiv, false)
                                    }
                                };
                                this.closeTooltipDiv = function(a) {
                                    return function(f, h, c) {
                                        var b = f ? (f.target || f.srcElement) : false;
                                        var g = b ? b.parentNode : h ? a.$(h) : false;
                                        if (g) {
                                            a.addRemoveTooltipDivsListeners("removeEvtListener", g);
                                            a.transitionMagic(g, c || "holeOut", function() {
                                                g.parentNode.removeChild(g)
                                            })
                                        }
                                        return false
                                    }
                                }(this);
                                this.addMarkerTooltipDiv = function(a) {
                                    return function(c) {
                                        var b = c.target || c.srcElement;
                                        if (b) {
                                            var d = b.getAttribute("obj");
                                            if (d) {
                                                a.addMarkerConfigurator(c, a.parseJSON(d))
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.showTooltipDiv = function(g, k, c, b, j, i, f, a) {
                                    var h;
                                    if (j != null && i != null) {
                                        h = this.addTooltipDiv(k, j, i, b, f);
                                        this.addRemoveTooltipDivsListeners("addEvtListener", h)
                                    } else {
                                        var m = this.$(this.target + "-cX-Info");
                                        var l = c ? this.regularCoordinates(g, c) : this.adjustedCoordinates(g, m);
                                        if (l) {
                                            j = l.x;
                                            i = g ? l.y : l.y + 25;
                                            h = this.addTooltipDiv(k, j, i, b, f);
                                            this.addRemoveTooltipDivsListeners("addEvtListener", h)
                                        }
                                    }
                                    this.transitionMagic(h, a || "spaceInUp");
                                    return h
                                };
                                this.resetTooltipDivs = function() {
                                    var c = 0;
                                    var a = this.target + "-cX-TooltipDiv" + c;
                                    var b = this.$(a);
                                    while (b) {
                                        this.addRemoveTooltipDivsListeners("removeEvtListener", b);
                                        b.parentNode.removeChild(b);
                                        c++;
                                        a = this.target + "-cX-TooltipDiv" + c;
                                        b = this.$(a)
                                    }
                                };
                                this.addMarkerConfigurator = function(U, K) {
                                    var D = this.$("center-wrapper-" + this.target);
                                    if (D) {
                                        var B = this.target + "-cX-Marker";
                                        if (this.$(B)) {
                                            this.closeMarkerConfigurator(false, this.$(B))
                                        }
                                        var q = U.target || U.srcElement;
                                        var k = q.parentNode;
                                        var r = this.adjustedCoordinates(U);
                                        var E = K.y ? K.y.vars : K.w.vars;
                                        var H = K.y ? K.y.smps : K.w.smps;
                                        var S = K.w ? K.w.smps[0] : false;
                                        var X = K.c && this.graphType == "Map" ? this.parseJSON(K.c) : false;
                                        var a = this.graphType.match(/Treemap|Stacked|Dotplot/) ? true : false;
                                        var u = this.getVariableIndices(E);
                                        var t = this.getSampleIndices(H, a);
                                        var l = S ? this.getSampleIndices(S) : false;
                                        var L = {};
                                        var V = false;
                                        var b = {
                                            id: this.newId("-marker-"),
                                            vi: u,
                                            si: t,
                                            gi: l,
                                            coords: X,
                                            variable: E,
                                            sample: H,
                                            group: S,
                                            update: false
                                        };
                                        var M = false;
                                        var I = ["text", "color", "fontSize", "fontStyle", "align", "baseline", "type", "x", "y"];
                                        for (var R = 0; R < I.length; R++) {
                                            L[I[R]] = ""
                                        }
                                        L.align = "center";
                                        L.baseline = "middle";
                                        L.type = "line";
                                        if (this.decorations && this.decorations.marker) {
                                            for (var R = 0; R < this.decorations.marker.length; R++) {
                                                var N = this.decorations.marker[R];
                                                if (this.isSameObject(N.variable, E) && this.isSameObject(N.sample, H)) {
                                                    for (var P = 0; P < I.length; P++) {
                                                        L[I[P]] = N[I[P]]
                                                    }
                                                    M = true;
                                                    b.update = true
                                                }
                                            }
                                        }
                                        var T = this.$cX("div", {
                                            id: B,
                                            className: "CanvasXpressMarker draggable",
                                            par: k.id,
                                            obj: b
                                        }, {
                                            left: r.x + "px",
                                            top: (r.y - this.height) + "px",
                                            display: "block",
                                            position: "relative"
                                        });
                                        if (X) {
                                            T.style.height = "180px"
                                        }
                                        var f = this.$cXI("op_cancel", {
                                            id: B + "ConfiguratorMarkerClose",
                                            className: "CanvasXpressDataTableToolbarImage",
                                            src: "op_cancel",
                                            title: "Close"
                                        });
                                        var A = this.$cX("div", {
                                            id: B + "Container",
                                            className: "CanvasXpressDataTableContainer"
                                        }, {
                                            left: "12px"
                                        });
                                        var Q = this.$cX("table", {
                                            id: B + "MarkerTable",
                                            className: "CanvasXpressDataTable"
                                        });
                                        var C = this.$cX("tbody");
                                        for (var R = 0; R < I.length; R++) {
                                            var W = this.$cX("tr");
                                            var d = this.$cX("th", {
                                                className: "CanvasXpressTableCellHead"
                                            }, {
                                                height: I[R] == "text" ? "64px" : "18px",
                                                width: "80px",
                                                backgroundRepeat: "repeat"
                                            });
                                            var J = this.$cX("div", {
                                                className: "CanvasXpressTableCell",
                                                innerHTML: this.capitalize(I[R])
                                            }, {
                                                height: I[R] == "text" ? "64px" : "18px",
                                                width: "80px"
                                            });
                                            var h = this.$cX("td", {
                                                className: "CanvasXpressTableCell"
                                            }, {
                                                height: I[R] == "text" ? "64px" : "18px",
                                                width: "160px",
                                                border: "1px solid #ccc"
                                            });
                                            var O = this.$cX("div", {
                                                className: "CanvasXpressTableCell"
                                            }, {
                                                height: I[R] == "text" ? "64px" : "18px",
                                                width: "160px"
                                            });
                                            var F;
                                            if (I[R] == "text") {
                                                F = this.$cX("textarea", {
                                                    id: B + "ConfiguratorMarker-" + I[R],
                                                    className: "CanvasXpressMarker",
                                                    name: I[R],
                                                    value: L[I[R]],
                                                    rows: 3
                                                }, {
                                                    width: "100%",
                                                    border: "none"
                                                })
                                            } else {
                                                if (I[R] == "color") {
                                                    F = this.$cX("input", {
                                                        id: B + "ConfiguratorMarker-" + I[R],
                                                        className: "CanvasXpressMarker",
                                                        type: "color",
                                                        name: I[R],
                                                        value: L[I[R]] ? this.validateColor(L[I[R]], null, true) : ""
                                                    }, {
                                                        width: "100%",
                                                        border: "none"
                                                    })
                                                } else {
                                                    if (I[R] == "type") {
                                                        F = this.$cX("select", {
                                                            id: B + "ConfiguratorMarker-" + I[R],
                                                            className: "CanvasXpressMarker",
                                                            size: 1
                                                        }, {
                                                            width: "100%",
                                                            border: "none",
                                                            backgroundColor: "white"
                                                        });
                                                        var y = this.$cX("option", {
                                                            text: "line",
                                                            value: "line"
                                                        });
                                                        try {
                                                            F.add(y, null)
                                                        } catch (G) {
                                                            F.add(y)
                                                        }
                                                        var Y = this.$cX("option", {
                                                            text: "annotation",
                                                            value: "annotation"
                                                        });
                                                        try {
                                                            F.add(Y, null)
                                                        } catch (G) {
                                                            F.add(Y)
                                                        }
                                                        if (L[I[R]] && L[I[R]] != "line") {
                                                            F.options[1].selected = true;
                                                            V = true
                                                        }
                                                    } else {
                                                        if (I[R] == "x" || I[R] == "y") {
                                                            F = this.$cX("input", {
                                                                id: B + "ConfiguratorMarker-" + I[R],
                                                                className: "CanvasXpressMarker",
                                                                type: "number",
                                                                name: I[R],
                                                                value: L[I[R]] ? this.sprintf("%.2f", Number(L[I[R]])) : 0,
                                                                min: 0,
                                                                max: 1,
                                                                step: 0.01
                                                            }, {
                                                                width: "100%",
                                                                border: "none"
                                                            });
                                                            if (V) {
                                                                F.disabled = true
                                                            }
                                                        } else {
                                                            if (I[R].match(/fontSize/)) {
                                                                F = this.$cX("input", {
                                                                    id: B + "ConfiguratorMarker-" + I[R],
                                                                    className: "CanvasXpressMarker",
                                                                    type: "number",
                                                                    name: I[R],
                                                                    value: L[I[R]] || 12
                                                                }, {
                                                                    width: "100%",
                                                                    border: "none"
                                                                })
                                                            } else {
                                                                F = this.$cX("input", {
                                                                    id: B + "ConfiguratorMarker-" + I[R],
                                                                    className: "CanvasXpressMarker",
                                                                    type: "text",
                                                                    name: I[R],
                                                                    value: L[I[R]] || ""
                                                                }, {
                                                                    width: "100%",
                                                                    border: "none"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            var z = this.$cX("input", {
                                                id: B + "ConfiguratorMarkerRemove",
                                                value: "Remove",
                                                type: "button"
                                            }, {
                                                cssFloat: "left",
                                                borderRadius: "5px",
                                                position: "relative",
                                                top: (X ? "148px" : "308px"),
                                                left: "12px",
                                                width: "125px",
                                                height: "24px"
                                            });
                                            var x = this.$cX("input", {
                                                id: B + "ConfiguratorMarkerAdd",
                                                value: M ? "Update" : "Add",
                                                type: "button"
                                            }, {
                                                cssFloat: "left",
                                                borderRadius: "5px",
                                                position: "relative",
                                                top: (X ? "148px" : "308px"),
                                                left: "24px",
                                                width: "125px",
                                                height: "24px"
                                            });
                                            O.appendChild(F);
                                            h.appendChild(O);
                                            d.appendChild(J);
                                            W.appendChild(d);
                                            W.appendChild(h);
                                            if (X) {
                                                if (I[R] == "text" || I[R] == "color") {
                                                    C.appendChild(W)
                                                }
                                            } else {
                                                C.appendChild(W)
                                            }
                                        }
                                        Q.appendChild(C);
                                        A.appendChild(Q);
                                        T.appendChild(f);
                                        T.appendChild(A);
                                        T.appendChild(z);
                                        T.appendChild(x);
                                        D.appendChild(T);
                                        this.addRemoveMarkerConfiguratorListeners("addEvtListener")
                                    }
                                };
                                this.addRemoveMarkerConfiguratorListeners = function(e) {
                                    var b = this.$(this.target + "-cX-Marker");
                                    var h = this.$(this.target + "-cX-MarkerConfiguratorMarkerClose");
                                    var g = this.$(this.target + "-cX-MarkerConfiguratorMarkerRemove");
                                    var d = this.$(this.target + "-cX-MarkerConfiguratorMarkerAdd");
                                    var f = this.$(this.target + "-cX-MarkerConfiguratorMarker-type");
                                    if (b && h && g && d) {
                                        this[e](b, "mousedown", this.registerMousemove, false);
                                        this[e](h, "click", this.closeMarkerConfigurator, false);
                                        this[e](g, "click", this.removeMarker, false);
                                        this[e](d, "click", this.addMarker, false);
                                        if (f) {
                                            this[e](f, "change", this.changeTypeMarker, false)
                                        }
                                    }
                                };
                                this.closeMarkerConfigurator = function(a) {
                                    return function(f, b) {
                                        var c = f ? (f.target || f.srcElement) : false;
                                        var d = c ? a.$(c.parentNode.par) : b ? a.$(b.par) : false;
                                        if (d) {
                                            a.addRemoveTooltipDivsListeners("removeEvtListener", d);
                                            d.parentNode.removeChild(d)
                                        }
                                        if (!b) {
                                            b = c.parentNode
                                        }
                                        a.addRemoveMarkerConfiguratorListeners("removeEvtListener", b);
                                        b.parentNode.removeChild(b);
                                        return false
                                    }
                                }(this);
                                this.removeMarker = function(a) {
                                    return function(c) {
                                        var b = c.target || c.srcElement;
                                        a.modifyMarker(b.parentNode.obj, true);
                                        a.closeMarkerConfigurator(c);
                                        return false
                                    }
                                }(this);
                                this.addMarker = function(a) {
                                    return function(c) {
                                        var b = c.target || c.srcElement;
                                        a.modifyMarker(b.parentNode.obj);
                                        a.closeMarkerConfigurator(c);
                                        return false
                                    }
                                }(this);
                                this.changeTypeMarker = function(a) {
                                    return function(d) {
                                        var c = d.target || d.srcElement;
                                        var f = this.value;
                                        var b = c.parentNode.parentNode.parentNode.nextElementSibling;
                                        var g = b.nextElementSibling;
                                        b.childNodes[1].childNodes[0].childNodes[0].disabled = f == "line" ? false : true;
                                        g.childNodes[1].childNodes[0].childNodes[0].disabled = f == "line" ? false : true;
                                        return false
                                    }
                                }(this);
                                this.modifyMarker = function(e, a) {
                                    var d = ["text", "color", "fontSize", "fontStyle", "align", "baseline", "type", "x", "y"];
                                    for (var b = 0; b < d.length; b++) {
                                        var c = this.$(this.target + "-cX-MarkerConfiguratorMarker-" + d[b]);
                                        if (c) {
                                            e[d[b]] = c.value
                                        }
                                    }
                                    this.updateMarker(e, a)
                                };
                                this.updateMarker = function(e, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (b) {
                                        if (e.update) {
                                            var d = [];
                                            for (var c = 0; c < this.decorations.marker.length; c++) {
                                                var a = this.decorations.marker[c];
                                                if (this.isSameObject(a.variable, e.variable) && this.isSameObject(a.sample, e.sample)) {
                                                    continue
                                                }
                                                d.push(a)
                                            }
                                            this.decorations.marker = d
                                        } else {
                                            return false
                                        }
                                    } else {
                                        if (e.update) {
                                            for (var c = 0; c < this.decorations.marker.length; c++) {
                                                var a = this.decorations.marker[c];
                                                if (this.isSameObject(a.variable, e.variable) && this.isSameObject(a.sample, e.sample)) {
                                                    a.text = e.text;
                                                    a.color = e.color;
                                                    a.fontSize = Number(e.fontSize);
                                                    if (e.fontStyle != "") {
                                                        a.fontStyle = e.fontStyle
                                                    }
                                                    a.align = e.align;
                                                    a.baseline = e.baseline;
                                                    a.x = Number(e.x);
                                                    a.y = Number(e.y);
                                                    a.type = e.type;
                                                    break
                                                }
                                            }
                                        } else {
                                            if (!this.decorations) {
                                                this.decorations = {}
                                            }
                                            if (!this.decorations.marker) {
                                                this.decorations.marker = []
                                            }
                                            this.decorations.marker.push({
                                                vi: e.vi,
                                                si: e.si,
                                                gi: e.gi,
                                                variable: e.variable,
                                                sample: e.sample,
                                                group: e.group,
                                                text: e.text,
                                                color: e.color,
                                                coords: e.coords,
                                                fontSize: Number(e.fontSize),
                                                fontStyle: e.fontStyle,
                                                align: e.align,
                                                baseline: e.baseline,
                                                x: Number(e.x),
                                                y: Number(e.y),
                                                type: e.type
                                            })
                                        }
                                    }
                                    this.draw({
                                        func: "updateMarker",
                                        par: [e, b]
                                    })
                                }
                            };
                            CanvasXpress.prototype.initToolbar = function() {
                                this.addToolbarDiv = function() {
                                    var i = this.$(this.target + "-cX-Toolbar");
                                    if (i) {
                                        return i
                                    }
                                    i = this.$cX("div", {
                                        id: this.target + "-cX-Toolbar",
                                        className: "CanvasXpressToolbar"
                                    }, {
                                        position: "absolute",
                                        overflow: "hidden",
                                        width: this.width + "px",
                                        height: (this.toolbarType == "fixed" ? "36px" : "0px"),
                                        top: (this.toolbarType == "fixed" ? "-37px" : "0px"),
                                        right: 0,
                                        zIndex: 1,
                                        backgroundColor: "rgba(255,255,255,0)"
                                    });
                                    var t = this.$cX("div", {
                                        id: this.target + "-cX-Toolbar-Custom",
                                        className: "CanvasXpressToolbar"
                                    }, {
                                        cssFloat: "left"
                                    });
                                    var b = this.$cXI("wp_threebars", {
                                        id: this.target + "-cX-ToolbarMenu",
                                        className: "CanvasXpressToolbarImage",
                                        src: "wp_threebars",
                                        title: "Open menus"
                                    }, {
                                        display: "none"
                                    });
                                    b.style.setProperty("background-color", this.background, "important");
                                    var f = this.$cXI("sv_image", {
                                        id: this.target + "-cX-ToolbarSave",
                                        className: "CanvasXpressToolbarImage",
                                        src: "sv_image",
                                        title: "Save as png"
                                    });
                                    f.style.setProperty("background-color", this.background, "important");
                                    var a = this.$cXI("tm_history", {
                                        id: this.target + "-cX-ToolbarReproduce",
                                        className: "CanvasXpressToolbarImage",
                                        src: "tm_history",
                                        title: "Reproduce"
                                    }, {
                                        display: (this.afterRender.length ? "display" : "none")
                                    });
                                    a.style.setProperty("background-color", this.background, "important");
                                    var k = this.$cXI("ps_toloc2", {
                                        id: this.target + "-cX-ToolbarMove",
                                        className: "CanvasXpressToolbarImage",
                                        src: "ps_toloc2",
                                        title: "Move Canvas (Grab here)",
                                        draggable: false
                                    }, {
                                        display: (this.movable ? "none" : "block"),
                                        cursor: "move"
                                    });
                                    k.style.setProperty("background-color", this.background, "important");
                                    var u = this.$cXI("tb_table", {
                                        id: this.target + "-cX-ToolbarView",
                                        className: "CanvasXpressToolbarImage",
                                        src: "tb_table",
                                        title: "View table"
                                    }, {
                                        display: (this.graphType.match(/Genome/) || this.disableDataTable || this.isDOE ? "none" : "block")
                                    });
                                    u.style.setProperty("background-color", this.background, "important");
                                    var n = this.$cXI("fp_funnel", {
                                        id: this.target + "-cX-ToolbarLayout",
                                        className: "CanvasXpressToolbarImage",
                                        src: "fp_funnel",
                                        title: "Explore data"
                                    }, {
                                        display: (this.graphType.match(/Genome|Fish/) || this.disableDataFilters || this.disableDataTable || this.disableConfigurator || this.isDOE ? "none" : "block")
                                    });
                                    n.style.setProperty("background-color", this.background, "important");
                                    var h = this.$cXI("m_zlasso", {
                                        id: this.target + "-cX-ToolbarLasso",
                                        className: "CanvasXpressToolbarImage",
                                        src: "m_zlasso",
                                        title: "Lasso Selection"
                                    }, {
                                        display: (this.graphType == "Scatter2D" && !this.isDOE ? "block" : "none")
                                    });
                                    h.style.setProperty("background-color", this.background, "important");
                                    var j = this.$cXI("wp_installation", {
                                        id: this.target + "-cX-ToolbarDataExplorer",
                                        className: "CanvasXpressToolbarImage",
                                        src: "wp_installation",
                                        title: "Configure"
                                    }, {
                                        display: ((this.disableDataExplorer || this.graphType.match(/Genome|Network|Venn/) || this.isDOE) ? "none" : "block")
                                    });
                                    j.style.setProperty("background-color", this.background, "important");
                                    var o = this.$cXI("ch_oinfo", {
                                        id: this.target + "-cX-ToolbarInformation",
                                        className: "CanvasXpressToolbarImage",
                                        src: "ch_oinfo",
                                        title: "Data Details"
                                    }, {
                                        display: (this.info ? "block" : "none")
                                    });
                                    o.style.setProperty("background-color", this.background, "important");
                                    var g = this.$cXI("ar_minmax", {
                                        id: this.target + "-cX-ToolbarMaxMin",
                                        className: "CanvasXpressToolbarImage",
                                        src: "ar_minmax",
                                        title: "Minimize / Maximize"
                                    }, {
                                        marginRight: "13px"
                                    });
                                    g.style.setProperty("background-color", this.background, "important");
                                    i.appendChild(this.beaconImage);
                                    i.appendChild(g);
                                    i.appendChild(o);
                                    i.appendChild(j);
                                    i.appendChild(h);
                                    i.appendChild(n);
                                    i.appendChild(u);
                                    i.appendChild(k);
                                    i.appendChild(a);
                                    i.appendChild(f);
                                    i.appendChild(b);
                                    i.appendChild(t);
                                    var s = this.$("north-wrapper-" + this.target);
                                    if (s) {
                                        s.appendChild(i);
                                        this.addRemoveToolbarListeners("addEvtListener")
                                    }
                                };
                                this.addRemoveToolbarListeners = function(c) {
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarMenu"), "click", this.clickMenu, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarSave"), "click", this.print, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarReproduce"), "click", this.reproducePlay, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarMove"), "mousedown", this.registerMousemove, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarLayout"), "click", this.clickLayout, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarLasso"), "click", this.clickLasso, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarDataExplorer"), "click", this.clickDataExplorer, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarView"), "click", this.clickView, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarInformation"), "click", this.clickDataDetails, false);
                                    this.addRemoveEvtListener(c, this.$(this.target + "-cX-ToolbarMaxMin"), "click", this.clickGraphMaxMin, false);
                                    var a = this.$(this.target + "-cX-Toolbar-Custom");
                                    if (c == "removeEvtListener" && a) {
                                        for (var b = 0; b < a.childNodes.length; b++) {
                                            this.addRemoveEvtListener(c, a.childNodes[b], "click", this.addCustomToolbarMenu, false);
                                            this.addRemoveEvtListener(c, a.childNodes[b], "contextmenu", this.unpinFromToolbar, false)
                                        }
                                    }
                                };
                                this.backgroundMask = function(a) {
                                    var b = this.$("container-" + this.target);
                                    if (b) {
                                        if (a) {
                                            b.style.position = "fixed";
                                            b.style.zIndex = 1000000;
                                            b.style.padding = "2px";
                                            b.style.width = a[0] + "px";
                                            b.style.height = a[1] + "px";
                                            b.style.left = 0 + "px";
                                            b.style.top = 0 + "px";
                                            b.style.backgroundColor = "white"
                                        } else {
                                            b.style.position = "relative";
                                            b.style.zIndex = "unset";
                                            b.style.padding = "unset";
                                            b.style.width = "unset";
                                            b.style.height = "unset";
                                            b.style.left = "unset";
                                            b.style.top = "unset";
                                            b.style.backgroundColor = "unset"
                                        }
                                    }
                                };
                                this.clickMenu = function(a) {
                                    return function(c, b) {
                                        if (a.isMenu) {
                                            a.removeMenus()
                                        } else {
                                            a.removeMenus();
                                            a.addMenu(c, false, false, false, false, false, false, true);
                                            a.isMenu = true
                                        }
                                    }
                                }(this);
                                this.clickLasso = function(a) {
                                    return function(c, b) {
                                        a.removeMenus();
                                        a.lassoSelected = true
                                    }
                                }(this);
                                this.clickLayoutNoAnimation = function(b) {
                                    if (this.appLayout && !b) {
                                        var a = this;
                                        this.hideTable(false, function() {
                                            a.hideDataFilter();
                                            a.appLayout = false;
                                            a.activeAccordion = false
                                        });
                                        return false
                                    }
                                };
                                this.clickLayoutShowDataFilter = function(d, c, b) {
                                    var a = this;
                                    this.showDataFilter(d, function() {
                                        a.moveDataFilter(false, "dock", function() {
                                            a.transitionMagic(a.$(a.target + "-cX-DataFilter"), b || "holeIn", c)
                                        }, d)
                                    })
                                };
                                this.clickDataFilters = function(a) {
                                    return function(g, f, d) {
                                        a.removeMenus();
                                        if (a.maximized) {
                                            if (a.appLayout) {
                                                a.clickLayout(g, function() {
                                                    a.clickDataFilters(g, f)
                                                })
                                            } else {
                                                if (a.appLayoutDataTable) {
                                                    a.clickDataTable(g, function() {
                                                        a.clickLayout(g, f)
                                                    })
                                                } else {
                                                    var c = a.dataFilterWidth + 10;
                                                    a.appLayoutDataFilter = a.appLayoutDataFilter ? false : true;
                                                    if (a.appLayoutDataFilter) {
                                                        a.setDimensions(a.width - c, a.height, true);
                                                        a.resizeWidthOnLayoutActive = c;
                                                        a.resizeDataFilterHeight();
                                                        a.clickLayoutShowDataFilter(g, f, d)
                                                    } else {
                                                        var b = function() {
                                                            a.hideDataFilter(g, function() {
                                                                a.resizeViewportMiddle(a.width + c, a.height);
                                                                a.setDimensions(a.width + c, a.height, true, 250);
                                                                a.resizeWidthOnLayoutActive = false;
                                                                if (f) {
                                                                    f(g)
                                                                }
                                                            }, brc)
                                                        };
                                                        if (a.activeAccordion) {
                                                            a.activateAccordion(false, a.activeAccordion.previousSibling, b)
                                                        } else {
                                                            b()
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            a.showDataFilter(g, function() {
                                                a.transitionMagic(a.$(a.target + "-cX-DataFilter"), d || "holeIn", f)
                                            })
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickLayoutShowDataTable = function(h, d, g, b, c) {
                                    this.updateDataTable(false, false, true);
                                    if (!this.dataTableLastState || (this.dataTableLastState && this.dataTableLastState != "docked")) {
                                        this.moveDataTableDiv("dockMagic")
                                    }
                                    var a = this.getDataFilterState();
                                    var f = this.$("middle-container-" + this.target);
                                    if (!g) {
                                        g = parseInt(f.style.width) + (a == "docked" ? (this.dataFilterWidth + 6) : 0) - (this.appLayoutDataTable ? 17 : -1)
                                    }
                                    if (!b) {
                                        b = this.dataTableLastHeight || parseInt(this.dataTableTarget.style.height)
                                    }
                                    this.dataTableTarget = this.$(this.target + "-cX-DataTable");
                                    this.updateDataTableResizerDiv(false, g, b);
                                    this.endDataTableResizerDiv(true);
                                    this.transitionMagic(this.$(this.target + "-cX-DataTable"), c || "holeIn", d)
                                };
                                this.clickDataTable = function(a) {
                                    return function(g, f, c) {
                                        var d = a.$(a.target + "-cX-DataTable");
                                        if (!d) {
                                            d = a.initializeDataTable()
                                        }
                                        a.removeMenus();
                                        if (d) {
                                            if (a.maximized) {
                                                if (a.appLayout) {
                                                    a.clickLayout(g, function() {
                                                        a.clickDataTable(g, f)
                                                    })
                                                } else {
                                                    if (a.appLayoutDataFilter) {
                                                        a.clickDataFilters(g, function() {
                                                            a.clickLayout(g, f)
                                                        })
                                                    } else {
                                                        a.setDataTableDimensions();
                                                        var b = a.dataTableLastHeight ? a.dataTableLastHeight + 6 : a.dataTableRowsHeight + 81;
                                                        a.appLayoutDataTable = a.appLayoutDataTable ? false : true;
                                                        if (a.appLayoutDataTable) {
                                                            a.setDimensions(a.width, a.height - b, true);
                                                            a.resizeHeightOnLayoutActive = true;
                                                            a.clickLayoutShowDataTable(g, f, false, false, c)
                                                        } else {
                                                            a.hideTable(g, function() {
                                                                a.setDimensions(a.width, a.height + b, true, 250);
                                                                a.resizeHeightOnLayoutActive = false;
                                                                if (f) {
                                                                    f(g)
                                                                }
                                                            })
                                                        }
                                                    }
                                                }
                                            } else {
                                                a.updateDataTable(false, false, true);
                                                a.transitionMagic(d, c || "holeIn", f)
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickView = function(a) {
                                    return function(i, c, h) {
                                        var f = a.$(a.target + "-cX-DataTable");
                                        if (!f) {
                                            f = a.initializeDataTable()
                                        }
                                        if (f) {
                                            if (a.view == "canvas") {
                                                var d = a.isGroupedData ? a.cloneObject(this.groupingFactors) : false;
                                                a.removeMenus();
                                                a.skipRender = true;
                                                if (!i) {
                                                    a.meta.canvas.ctx.canvas.style.opacity = 0
                                                }
                                                a.hideToolbar();
                                                a.disableToolbar = true;
                                                if (d) {
                                                    a.ungroupSamples(true)
                                                }
                                                a.dataTableTarget = f;
                                                a.updateDataTable(false, false, i);
                                                a.viewTable = [f.clientWidth, f.clientHeight, d];
                                                a.updateDataTableResizerDiv(false, a.width, a.height);
                                                a.endDataTableResizerDiv(i);
                                                f = a.$(a.target + "-cX-DataTable");
                                                f.style.top = -(a.height + 3) + "px";
                                                f.style.left = 0;
                                                a.view = "table";
                                                var b = a.$(a.target + "-cX-DataTableToolbar");
                                                b.className = "CanvasXpressDataTableToolbar";
                                                if (i) {
                                                    a.transitionMagic(a.meta.canvas.ctx.canvas, h || "holeOut", function() {
                                                        a.meta.canvas.ctx.canvas.style.opacity = 0
                                                    }, 1000);
                                                    a.transitionMagic(a.$(a.target + "-cX-DataTable"), c || "swashIn", function() {
                                                        a.modifyDataTableToolbarView()
                                                    }, 1000)
                                                }
                                                a.stack({
                                                    func: "clickView",
                                                    par: [i, c, h]
                                                })
                                            } else {
                                                var d = a.viewTable[2];
                                                a.removeMenus();
                                                a.skipRender = false;
                                                a.disableToolbar = false;
                                                a.showDataTable = false;
                                                if (d) {
                                                    a.groupSamples(d, false, false, false, true)
                                                }
                                                if (i) {
                                                    a.draw({
                                                        func: "clickView",
                                                        par: [i, c, h]
                                                    });
                                                    a.transitionMagic(a.meta.canvas.ctx.canvas, c || "swashIn", function() {
                                                        a.meta.canvas.ctx.canvas.style.opacity = 1
                                                    });
                                                    a.view = "canvas";
                                                    a.hideTable(i, function() {
                                                        f = a.$(a.target + "-cX-DataTable");
                                                        a.dataTableTarget = f;
                                                        a.updateDataTableResizerDiv(false, a.viewTable[0], a.viewTable[1]);
                                                        var e = a.$(a.target + "-cX-DataTableToolbar");
                                                        e.className = "CanvasXpressDataTableToolbar draggable";
                                                        a.viewTable = false
                                                    }, h || "holeOut")
                                                } else {
                                                    f = a.$(a.target + "-cX-DataTable");
                                                    a.dataTableTarget = f;
                                                    a.updateDataTableResizerDiv(false, a.viewTable[0], a.viewTable[1]);
                                                    a.endDataTableResizerDiv();
                                                    a.updateDataTable();
                                                    a.moveDataTableDiv("hide");
                                                    a.hideUnhideDataTable(true);
                                                    a.resetDataTable(true);
                                                    a.meta.canvas.ctx.canvas.style.opacity = 1;
                                                    var b = a.$(a.target + "-cX-DataTableToolbar");
                                                    b.className = "CanvasXpressDataTableToolbar draggable";
                                                    a.draw({
                                                        func: "clickView",
                                                        par: [i, c, h]
                                                    });
                                                    a.view = "canvas";
                                                    a.viewTable = false
                                                }
                                            }
                                            a.modifyDataTableToolbarView()
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickLayout = function(a) {
                                    return function(i, g, f) {
                                        if (a.appLayoutDataTable) {
                                            a.clickDataTable(i, function() {
                                                a.clickDataFilters(i, g)
                                            })
                                        } else {
                                            if (a.appLayoutDataFilter) {
                                                a.clickDataFilters(i, function() {
                                                    a.clickDataTable(i, g)
                                                })
                                            } else {
                                                a.appLayout = a.appLayout ? false : true;
                                                if (a.resizeHeightOnLayout) {
                                                    a.setDataTableDimensions()
                                                }
                                                if (a.appLayout) {
                                                    var c = a.width;
                                                    var b = a.dataFilterWidth + 10;
                                                    var d = a.dataTableLastHeight ? a.dataTableLastHeight + 6 : a.dataTableRowsHeight + 81;
                                                    if (a.resizeWidthOnLayout && a.width - b >= b * 1.3) {
                                                        if (a.resizeHeightOnLayout && a.height - d >= d * 1) {
                                                            a.setDimensions(a.width - b, a.height - d, true);
                                                            a.resizeWidthOnLayoutActive = b;
                                                            a.resizeHeightOnLayoutActive = d
                                                        } else {
                                                            a.setDimensions(a.width - b, a.height, true);
                                                            a.resizeWidthOnLayoutActive = b
                                                        }
                                                    } else {
                                                        if (a.resizeHeightOnLayout && a.height - d >= d * 1) {
                                                            a.setDimensions(a.width, a.height - d, true);
                                                            a.resizeHeightOnLayoutActive = d
                                                        }
                                                    }
                                                    a.resizeDataFilterHeight();
                                                    a.hideToolbar(1);
                                                    a.clickLayoutShowDataFilter(i, false, f);
                                                    a.clickLayoutShowDataTable(i, function() {
                                                        if (g) {
                                                            g(i)
                                                        }
                                                    }, c - 3, false, f)
                                                } else {
                                                    a.hideToolbar(1);
                                                    a.hideTable(i);
                                                    a.hideDataFilter(i, function() {
                                                        var e = function() {
                                                            a.resizeWidthOnLayoutActive = false;
                                                            a.resizeHeightOnLayoutActive = false;
                                                            a.updateRemoteNavigationWindow(function() {
                                                                if (g) {
                                                                    g(i)
                                                                }
                                                            })
                                                        };
                                                        if (a.resizeWidthOnLayoutActive) {
                                                            if (a.resizeHeightOnLayoutActive) {
                                                                a.setDimensions(a.width + a.resizeWidthOnLayoutActive, a.height + a.resizeHeightOnLayoutActive, true, false, e)
                                                            } else {
                                                                a.setDimensions(a.width + a.resizeWidthOnLayoutActive, a.height, true, false, e)
                                                            }
                                                        } else {
                                                            if (a.resizeHeightOnLayoutActive) {
                                                                a.setDimensions(a.width, a.height + a.resizeHeightOnLayoutActive, true, false, e)
                                                            }
                                                        }
                                                    })
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickDataExplorer = function(a) {
                                    return function(c, b) {
                                        a.removeMenus();
                                        a.addDataExplorer();
                                        a.transitionMagic(a.$(a.target + "-cX-DataExplorer"), b || "holeIn");
                                        return false
                                    }
                                }(this);
                                this.clickDataDetails = function(a) {
                                    return function(g, f) {
                                        if (!g) {
                                            g = window.event
                                        }
                                        a.removeMenus();
                                        var h = window.document;
                                        var b = h.body.scrollLeft;
                                        var i = h.body.scrollTop;
                                        var c = {
                                            width: "auto",
                                            height: "auto",
                                            maxWidth: "500px",
                                            maxHeight: "500px",
                                            whiteSpace: "normal",
                                            overflow: "auto",
                                            textAlign: "left",
                                            opacity: 0
                                        };
                                        a.showTooltipDiv(g, a.info, false, c, 20, 20, false, f || "holeIn");
                                        return false
                                    }
                                }(this);
                                this.clickRepResearch = function(a) {
                                    return function(h, m, c) {
                                        if (!h) {
                                            h = window.event
                                        }
                                        a.removeMenus();
                                        var i = window.document;
                                        var l = i.body.scrollLeft;
                                        var k = i.body.scrollTop;
                                        var g = a.prettyColoredJSON(CanvasXpress.stack[a.target], null, true);
                                        var b = '<pre class="CanvasXpressCodeContent">' + g + "</pre>\n";
                                        var f = "<code> " + b.replace(/\n/g, "</code>\n<code> ") + "</code>";
                                        var o = {
                                            width: "auto",
                                            height: "auto",
                                            maxWidth: "500px",
                                            maxHeight: "500px",
                                            whiteSpace: "normal",
                                            overflow: "auto",
                                            textAlign: "left",
                                            opacity: 0
                                        };
                                        a.showTooltipDiv(h, f, false, o, 20, 20, false, c || "holeIn");
                                        return false
                                    }
                                }(this);
                                this.clickShowCode = function(a) {
                                    return function(c, d, b) {
                                        if (!c) {
                                            c = window.event
                                        }
                                        a.removeMenus();
                                        a.showCodeDiv(c, b);
                                        return false
                                    }
                                }(this);
                                this.clickShowRCode = function(a) {
                                    return function(c, b) {
                                        if (!c) {
                                            c = window.event
                                        }
                                        a.removeMenus();
                                        a.showRCodeDiv(c, b);
                                        return false
                                    }
                                }(this);
                                this.clickShowMetaCode = function(a) {
                                    return function(c, b) {
                                        if (!c) {
                                            c = window.event
                                        }
                                        a.removeMenus();
                                        a.showMetaCodeDiv(c, b);
                                        return false
                                    }
                                }(this);
                                this.moveCanvasXpressContainer = function(g, c) {
                                    if (g) {
                                        if (this.maximized || c) {
                                            var b = this.$(this.target + "-CanvasXpressAnchor");
                                            if (b) {
                                                b.parentNode.insertBefore(g, b);
                                                b.parentNode.removeChild(b)
                                            }
                                        } else {
                                            var e = window.document;
                                            var b = this.$cX("div", {
                                                id: this.target + "-CanvasXpressAnchor"
                                            }, {
                                                width: g.clientWidth + "px",
                                                height: g.clientHeight + "px",
                                                postion: "absolute"
                                            });
                                            g.parentNode.insertBefore(b, g);
                                            e.body.insertBefore(g, e.body.firstElementChild)
                                        }
                                    }
                                };
                                this.clickGraphMaxMin = function(a) {
                                    return function(j, d, b) {
                                        if (a.appLayout || a.appLayoutDataTable || a.appLayoutDataFilter) {
                                            if (a.appLayout) {
                                                a.clickLayout(j, a.clickGraphMaxMin)
                                            } else {
                                                if (a.appLayoutDataTable) {
                                                    a.clickDataTable(j, a.clickGraphMaxMin)
                                                } else {
                                                    if (a.appLayoutDataFilter) {
                                                        a.clickDataFilters(j, a.clickGraphMaxMin)
                                                    }
                                                }
                                            }
                                        } else {
                                            var l = a.remoteService && a.$(a.remoteParentId + "-canvasXpressRemoteWindow") ? a.$(a.remoteParentId + "-canvasXpressRemoteWindow") : a.$("container-" + a.target);
                                            var g = a.$(a.target + "-cX-Toolbar");
                                            var f = a.$(a.target + "-cX-ToolbarMaxMin");
                                            var i = a.$("northest-container-" + a.target);
                                            var k = a.$("southest-container-" + a.target);
                                            var h = window.innerWidth;
                                            var c = window.innerHeight;
                                            var m = window.document;
                                            if (l && g && f && i && k) {
                                                a.moveCanvasXpressContainer(l);
                                                if (a.maximized && !b) {
                                                    if (a.toolbarType == "fixed") {
                                                        g.style.top = "-37px"
                                                    }
                                                    a.backgroundMask();
                                                    f.title = "Maximize";
                                                    a.setDimensions(a.maximized[0], a.maximized[1], false, false, false, -1);
                                                    l.style.left = a.maximized[2];
                                                    l.style.top = a.maximized[3];
                                                    m.documentElement.style.overflowX = a.maximized[4];
                                                    m.documentElement.style.overflowY = a.maximized[5];
                                                    a.maximized = false;
                                                    a.resizeDataFilterHeight()
                                                } else {
                                                    if (a.toolbarType == "fixed") {
                                                        g.style.top = "0px"
                                                    }
                                                    a.backgroundMask([h, c]);
                                                    f.title = "Minimize";
                                                    a.maximized = d || [a.width, a.height, l.style.left, l.style.top, m.body.style.overflowX, m.body.style.overflowY];
                                                    m.documentElement.style.overflowX = "hidden";
                                                    m.documentElement.style.overflowY = "hidden";
                                                    a.setDimensions(h - 4, c - (4 + i.clientHeight + k.clientHeight), false, false, false, 1);
                                                    a.resizeDataFilterHeight()
                                                }
                                                a.hideToolbar(1)
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.showToolbar = function(g) {
                                    if (!this.disableToolbar && !this.dataTableMaximized) {
                                        var b = this.$(this.target + "-cX-Toolbar");
                                        if (!b) {
                                            b = this.initializeToolbar()
                                        }
                                        if (b) {
                                            var e = this.$("west-container-" + this.target);
                                            var a = this.$(this.target + "-cX-ToolbarMove");
                                            var c = this.$(this.target + "-cX-ToolbarReproduce");
                                            if (b && parseInt(b.style.height) == 0 && e && a && c) {
                                                a.style.display = this.movable && !this.maximized ? "block" : "none";
                                                c.style.display = this.meta.stack.length ? "block" : "none";
                                                if (this.toolbarType == "fixed") {
                                                    b.style.height = "36px";
                                                    b.style.top = "-37px"
                                                } else {
                                                    this.resizeMove(b, 0, (this.maximized ? 0 : this.toolbarType == "over" ? -37 : 0), this.width, 36, 250);
                                                    if (g) {
                                                        var d = this;
                                                        setTimeout(function() {
                                                            d.hideToolbar(g)
                                                        }, g)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.hideToolbar = function(e, a) {
                                    if (this.toolbarType != "fixed") {
                                        var b = this.$(this.target + "-cX-Toolbar");
                                        if (!b) {
                                            b = this.initializeToolbar()
                                        }
                                        var d = this.$("west-container-" + this.target);
                                        if (b && parseInt(b.style.height) == 36 && d) {
                                            this.resizeMove(b, 0, 0, this.width, 0, 500, a)
                                        } else {
                                            if (e && b && parseInt(b.style.height) > 0) {
                                                var c = this;
                                                setTimeout(function() {
                                                    c.hideToolbar(e, a)
                                                }, e)
                                            }
                                        }
                                    }
                                };
                                this.isToolbar = function(c) {
                                    var b = this.adjustedCoordinates(c);
                                    if (b) {
                                        var a = b.x;
                                        var d = b.y;
                                        if (d > 0 && d < 36 && a > 0 && a < this.width) {
                                            this.showToolbar()
                                        } else {
                                            if (d > 36 && d < this.height && a > 0 && a < this.width && this.toolbarType != "fixed") {
                                                this.hideToolbar()
                                            }
                                        }
                                    }
                                };
                                this.removeToolbar = function() {
                                    var b = this.$("north-wrapper-" + this.target);
                                    var a = this.$(this.target + "-cX-Toolbar");
                                    if (b && a) {
                                        this.addRemoveToolbarListeners("removeEvtListener");
                                        b.removeChild(a)
                                    }
                                };
                                this.initializeToolbar = function() {
                                    if (!this.disableEvents && !this.disableToolbar) {
                                        return this.addToolbarDiv()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initConfigurator = function() {
                                this.addConfigurator = function(a) {
                                    return function(ab, C, K, J) {
                                        var w = false;
                                        if (a.disableConfigurator && !ab.ctrlKey) {
                                            return
                                        }
                                        var ae = a.$(a.target + "-cX-Configurator");
                                        if (ae) {
                                            w = true;
                                            if (a.activeTarget) {
                                                a.activeTarget.style.zIndex = 10000
                                            }
                                            a.activeTarget = ae;
                                            a.activeTarget.style.zIndex = 10001
                                        }
                                        var E = "Search property or function";
                                        a.configuringOn = true;
                                        if (C) {
                                            if (a.isArray(C)) {
                                                C = a.isNumber(C[0]) ? C[0] : Number(C[0].replace("-lab", ""))
                                            }
                                            if (a.graphType == "Network") {
                                                if (!isNaN(C)) {
                                                    a.configuringNetwork = C;
                                                    if (a.data.nodes.length > C) {
                                                        E = "Configure " + (a.data.nodes[C].label || a.data.nodes[C].name || a.data.nodes[C].id)
                                                    } else {
                                                        var A = a.data.edges[C - a.data.nodes.length];
                                                        var G = a.data.nodes[a.data.nodeIndices[A.id1]];
                                                        var F = a.data.nodes[a.data.nodeIndices[A.id2]];
                                                        E = "Configure " + (G.label || G.name || G.id) + " - " + (F.label || G.name || F.id)
                                                    }
                                                }
                                            } else {
                                                if (a.graphType == "Genome") {
                                                    a.configuringGenome = C;
                                                    E = "Configure track " + C
                                                }
                                            }
                                        }
                                        var B = K != null && J != null ? {
                                            x: K,
                                            y: J
                                        } : ab ? a.adjustedCoordinates(ab) : {
                                            x: 20,
                                            y: 20
                                        };
                                        if (B) {
                                            K = B.x;
                                            J = B.y;
                                            if (w) {
                                                ae.style.left = K + "px";
                                                ae.style.top = J + "px";
                                                return
                                            } else {
                                                ae = a.$cX("div", {
                                                    id: a.target + "-cX-Configurator",
                                                    className: "CanvasXpressConfigurator draggable"
                                                }, {
                                                    cursor: "move",
                                                    left: K + "px",
                                                    top: J + "px",
                                                    padding: "10px",
                                                    position: "absolute",
                                                    zIndex: 10001,
                                                    opacity: 0
                                                })
                                            }
                                            var Y = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorKeyText"
                                            }, {
                                                display: "block",
                                                marginBottom: "5px",
                                                width: a.configuratorWidth + "px",
                                                height: "24px"
                                            });
                                            var Z = a.$cX("span", {
                                                id: a.target + "-cX-ConfiguratorKeyTextSpan",
                                                className: "CanvasXpressConfigurator",
                                                innerHTML: E
                                            });
                                            var H = a.$cXI("wp_list", {
                                                id: a.target + "-cX-ConfiguratorKeyMenu",
                                                className: "CanvasXpressConfigurator",
                                                src: "wp_list",
                                                title: "Open menus"
                                            });
                                            var aa = a.$cXI("z_zoom", {
                                                id: a.target + "-cX-ConfiguratorKeySearch",
                                                className: "CanvasXpressConfigurator",
                                                src: "z_zoom",
                                                title: "Browse properties by category"
                                            });
                                            var W = a.$cXI("op_cancel", {
                                                id: a.target + "-cX-ConfiguratorKeyClose",
                                                className: "CanvasXpressConfigurator",
                                                src: "op_cancel",
                                                title: "Close"
                                            });
                                            var X = a.$cX("input", {
                                                id: a.target + "-cX-ConfiguratorKey",
                                                className: "CanvasXpressConfigurator",
                                                type: "text"
                                            }, {
                                                display: "block",
                                                width: a.configuratorWidth + "px"
                                            });
                                            var V = a.$cX("select", {
                                                id: a.target + "-cX-ConfiguratorCategories",
                                                className: "CanvasXpressConfigurator",
                                                size: 5
                                            }, {
                                                display: "none",
                                                width: a.configuratorWidth + "px"
                                            });
                                            var P = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorSugestionsText",
                                                innerHTML: "Select property"
                                            }, {
                                                display: "none",
                                                margin: "5px 0px 5px 0px",
                                                width: a.configuratorWidth + "px"
                                            });
                                            var O = a.$cX("select", {
                                                id: a.target + "-cX-ConfiguratorSugestions",
                                                className: "CanvasXpressConfigurator",
                                                size: 10
                                            }, {
                                                display: "none",
                                                width: a.configuratorWidth + "px"
                                            });
                                            var ad = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorSugestionsDescription"
                                            }, {
                                                display: "none",
                                                margin: "5px 0px 5px 0px",
                                                width: a.configuratorWidth + "px",
                                                minHeight: "56px",
                                                overflow: "auto"
                                            });
                                            var M = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorValueText",
                                                innerHTML: "Current value"
                                            }, {
                                                display: "none",
                                                margin: "5px 0px 5px 0px",
                                                width: a.configuratorWidth + "px"
                                            });
                                            var ag = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorSeeAlso"
                                            }, {
                                                display: "none",
                                                width: a.configuratorWidth + "px",
                                                minHeight: "20px",
                                                overflow: "auto"
                                            });
                                            var L = a.$cX("input", {
                                                id: a.target + "-cX-ConfiguratorValue",
                                                className: "CanvasXpressConfigurator",
                                                type: "text"
                                            }, {
                                                display: "none",
                                                width: a.configuratorWidth + "px"
                                            });
                                            var D = a.$cX("input", {
                                                id: a.target + "-cX-ConfiguratorApply",
                                                value: "Apply",
                                                type: "button"
                                            }, {
                                                display: "none",
                                                cssFloat: "left",
                                                borderRadius: "5px",
                                                top: "4px",
                                                position: "relative",
                                                width: (a.configuratorWidth / 2) + "px"
                                            });
                                            var af = a.$cX("input", {
                                                id: a.target + "-cX-ConfiguratorButton",
                                                value: "Draw",
                                                type: "button"
                                            }, {
                                                display: "none",
                                                cssFloat: "left",
                                                borderRadius: "5px",
                                                top: "4px",
                                                position: "relative",
                                                width: (a.configuratorWidth / 2) + "px"
                                            });
                                            var Q = a.$cXI("op_cancel", {
                                                id: a.target + "-cX-ConfiguratorOptionsClose",
                                                className: "CanvasXpressConfigurator",
                                                src: "op_cancel",
                                                title: "Close"
                                            });
                                            var I = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorOptions",
                                                className: "CanvasXpressConfigurator draggable"
                                            }, {
                                                cursor: "move",
                                                display: "none",
                                                padding: "10px",
                                                position: "absolute"
                                            });
                                            var S = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorColorCurrent",
                                                className: "CanvasXpressConfiguratorColor"
                                            }, {
                                                width: "181px",
                                                height: "24px",
                                                cssFloat: "left",
                                                cursor: "default",
                                                lineHeight: "24px"
                                            });
                                            var R = a.$cXI("op_cancel", {
                                                id: a.target + "-cX-ConfiguratorColorClose",
                                                className: "CanvasXpressConfigurator",
                                                src: "op_cancel",
                                                title: "Close"
                                            });
                                            var U = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorColor",
                                                className: "CanvasXpressConfigurator draggable"
                                            }, {
                                                width: "212px",
                                                cursor: "move",
                                                display: "none",
                                                padding: "10px",
                                                position: "absolute"
                                            });
                                            var N = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorExample",
                                                className: "CanvasXpressConfiguratorExample draggable"
                                            }, {
                                                width: (a.configuratorExamplesSize + 35) + "px",
                                                maxHeight: (a.configuratorExamplesSize) + "px",
                                                cursor: "move",
                                                display: "none",
                                                padding: "10px",
                                                position: "absolute",
                                                overflow: "auto",
                                                paddingBottom: "35px"
                                            });
                                            var ac = a.$cX("span", {
                                                id: a.target + "-cX-ConfiguratorExampleSpan",
                                                className: "CanvasXpressConfiguratorExample",
                                                innerHTML: ""
                                            });
                                            var t = a.$cX("op_cancel", {
                                                id: a.target + "-cX-ConfiguratorExampleClose",
                                                className: "CanvasXpressConfigurator",
                                                src: "op_cancel",
                                                title: "Close"
                                            });
                                            var h = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorExampleContent",
                                                className: "CanvasXpressConfiguratorExampleContent"
                                            }, {
                                                maxWidth: (a.configuratorExamplesSize + 35) + "px",
                                                maxHeight: (a.configuratorExamplesSize) + "px"
                                            });
                                            Y.appendChild(Z);
                                            Y.appendChild(W);
                                            Y.appendChild(aa);
                                            Y.appendChild(H);
                                            I.appendChild(window.document.createTextNode("Select option ..."));
                                            I.appendChild(Q);
                                            I.appendChild(a.$cX("br"));
                                            U.appendChild(S);
                                            U.appendChild(R);
                                            U.appendChild(a.$cX("br"));
                                            N.appendChild(ac);
                                            N.appendChild(t);
                                            N.appendChild(a.$cX("br"));
                                            N.appendChild(h);
                                            ae.appendChild(Y);
                                            ae.appendChild(X);
                                            ae.appendChild(V);
                                            ae.appendChild(P);
                                            ae.appendChild(O);
                                            ae.appendChild(ad);
                                            ae.appendChild(ag);
                                            ae.appendChild(M);
                                            ae.appendChild(L);
                                            ae.appendChild(D);
                                            ae.appendChild(af);
                                            ae.appendChild(I);
                                            ae.appendChild(U);
                                            ae.appendChild(N);
                                            var T = a.$("west-wrapper-" + a.target);
                                            if (T) {
                                                T.appendChild(ae);
                                                if (a.activeTarget) {
                                                    a.activeTarget.style.zIndex = 10000
                                                }
                                                a.activeTarget = ae;
                                                a.addRemoveConfiguratorListeners("addEvtListener");
                                                if (a.configuringNetwork || a.configuringGenome) {
                                                    a.selectConfig(false, true)
                                                }
                                                this.transitionMagic(ae, "swashIn", function() {
                                                    X.focus()
                                                })
                                            }
                                        }
                                    }
                                }(this);
                                this.addConfiguratorCloseMenus = function(a) {
                                    return function(d, c, b, f) {
                                        a.removeMenus();
                                        a.addConfigurator(d, c, b, f)
                                    }
                                }(this);
                                this.addRemoveConfiguratorListeners = function(y) {
                                    var u = this.$(this.target + "-cX-Configurator");
                                    var h = this.$(this.target + "-cX-ConfiguratorCategories");
                                    var A = this.$(this.target + "-cX-ConfiguratorSugestions");
                                    var w = this.$(this.target + "-cX-ConfiguratorApply");
                                    var v = this.$(this.target + "-cX-ConfiguratorButton");
                                    var j = this.$(this.target + "-cX-ConfiguratorKeyClose");
                                    var k = this.$(this.target + "-cX-ConfiguratorKeySearch");
                                    var g = this.$(this.target + "-cX-ConfiguratorKeyMenu");
                                    var r = this.$(this.target + "-cX-ConfiguratorOptions");
                                    var a = this.$(this.target + "-cX-ConfiguratorOptionsClose");
                                    var e = this.$(this.target + "-cX-ConfiguratorColor");
                                    var d = this.$(this.target + "-cX-ConfiguratorColorClose");
                                    var o = this.$(this.target + "-cX-ConfiguratorExample");
                                    var x = this.$(this.target + "-cX-ConfiguratorExampleClose");
                                    if (u && h && A && v && w && j && k && g && r && a && e && d && o && x) {
                                        this[y](u, "mousedown", this.registerMousemove, false);
                                        this[y](h, "change", this.changeCategory, false);
                                        this[y](h, "click", this.changeCategory, false);
                                        this[y](A, "change", this.clickSuggestions, false);
                                        this[y](A, "click", this.clickSuggestions, false);
                                        this[y](w, "click", this.clickApplyConfigurator, false);
                                        this[y](v, "click", this.clickConfigurator, false);
                                        this[y](g, "click", this.clickMenuDropDown, false);
                                        this[y](k, "click", this.clickSearch, false);
                                        this[y](j, "click", this.closeConfigurator, false);
                                        this[y](r, "mousedown", this.registerMousemove, false);
                                        this[y](a, "click", this.closePropertyOptions, false);
                                        this[y](e, "mousedown", this.registerMousemove, false);
                                        this[y](d, "click", this.closePropertyColor, false);
                                        this[y](o, "mousedown", this.registerMousemove, false);
                                        this[y](x, "click", this.closePropertyExample, false)
                                    }
                                };
                                this.getConfigurableProperties = function() {
                                    if (this.configuringNetwork) {
                                        if (this.data.nodes.length > this.configuringNetwork) {
                                            return this.getNodeConfigurableProperties(this.configuringNetwork)
                                        } else {
                                            return this.getEdgeConfigurableProperties(this.configuringNetwork - this.data.nodes.length)
                                        }
                                    } else {
                                        if (this.configuringGenome) {
                                            if (!isNaN(this.configuringGenome) || this.configuringGenome.match(/:/)) {
                                                return this.featureConfigurableProperties
                                            } else {
                                                if (this.configuringGenome.match(/track/)) {
                                                    return this.trackConfigurableProperties
                                                } else {
                                                    this.configuringGenome = false
                                                }
                                            }
                                        }
                                    }
                                    var c = [];
                                    for (var b in CanvasXpress.doc.P) {
                                        if (!CanvasXpress.doc.P[b].Z) {
                                            var a = this.getGraphTypes(CanvasXpress.doc.P[b], true);
                                            if (a.hasOwnProperty(this.graphType)) {
                                                c.push(b)
                                            }
                                        }
                                    }
                                    return c
                                };
                                this.getConfigurableObjectDoc = function(a) {
                                    return CanvasXpress.doc.P[a] ? CanvasXpress.doc.P[a] : false
                                };
                                this.selectConfig = function(D, F) {
                                    var z = this.$(this.target + "-cX-ConfiguratorKey");
                                    var q = this.$(this.target + "-cX-ConfiguratorSugestionsText");
                                    var n = this.$(this.target + "-cX-ConfiguratorSugestions");
                                    var E = this.$(this.target + "-cX-ConfiguratorSugestionsDescription");
                                    var l = this.$(this.target + "-cX-ConfiguratorValueText");
                                    var H = this.$(this.target + "-cX-ConfiguratorSeeAlso");
                                    var j = this.$(this.target + "-cX-ConfiguratorValue");
                                    var f = this.$(this.target + "-cX-ConfiguratorApply");
                                    var G = this.$(this.target + "-cX-ConfiguratorButton");
                                    var B = this.$(this.target + "-cX-ConfiguratorValueHREF");
                                    var m = window.document.activeElement;
                                    var y = this.getConfigurableProperties();
                                    var w = [];
                                    if (this.getKeyCode(D) == 13) {
                                        this.resetOptionColorExamples();
                                        if (n && j && j.value) {
                                            var g = false;
                                            for (var A = 0; A < y.length; A++) {
                                                if (n.value == y[A]) {
                                                    g = true;
                                                    break
                                                }
                                            }
                                            if (g) {
                                                this.clickConfigurator(D, n, j)
                                            } else {
                                                this.resetConfigurator(D)
                                            }
                                        }
                                    } else {
                                        if (z && m.id == z.id || F) {
                                            this.resetOptionColorExamples();
                                            for (var A = 0; A < y.length; A++) {
                                                if (y[A].toLowerCase().indexOf(z.value.toLowerCase()) >= 0) {
                                                    w.push(y[A])
                                                }
                                            }
                                            if (w.length > 0 && q && n && E && l && H && j && G && f) {
                                                this.resetSugestions();
                                                w.sort();
                                                if (!this.configuringNetwork && !this.configuringGenome) {
                                                    for (var A = 0; A < w.length; A++) {
                                                        var y = this.$cX("option", {
                                                            text: w[A],
                                                            value: w[A]
                                                        });
                                                        try {
                                                            n.add(y, null)
                                                        } catch (C) {
                                                            n.add(y)
                                                        }
                                                    }
                                                } else {
                                                    for (var A = 0; A < w.length; A++) {
                                                        var y = this.$cX("option", {
                                                            text: w[A],
                                                            value: w[A]
                                                        });
                                                        try {
                                                            n.add(y, null)
                                                        } catch (C) {
                                                            n.add(y)
                                                        }
                                                    }
                                                }
                                                n.options[0].selected = true;
                                                this.setConfiguratorPropertyValue(n, E, l, H, j);
                                                q.innerHTML = "Select property (" + w.length + ")";
                                                q.style.display = "block";
                                                n.style.display = "block";
                                                E.style.display = "block";
                                                l.style.display = "block";
                                                H.style.display = "block";
                                                j.style.display = "block";
                                                G.style.display = "block";
                                                f.style.display = "block"
                                            } else {
                                                z.value = z.value.slice(0, z.value.length - 1)
                                            }
                                        } else {
                                            if (j && m.id == j.id) {
                                                this.resetOptionColorExamples();
                                                if (B && B.innerHTML == "color") {
                                                    B.style.color = j.value ? this.rgbToHex(this.validateColor(j.value.replace(/[\'\"]/g, ""))) : this.foreground
                                                }
                                            } else {
                                                if (this.remoteService) {
                                                    this.resetOptionColorExamples();
                                                    this.selectDataSet(D)
                                                }
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.clickSearch = function(a) {
                                    return function(G) {
                                        a.configuringNetwork = false;
                                        a.configuringGenome = false;
                                        a.resetOptionColorExamples();
                                        var E = a.$(a.target + "-cX-ConfiguratorKeyTextSpan");
                                        var C = a.$(a.target + "-cX-ConfiguratorKey");
                                        var A = a.$(a.target + "-cX-ConfiguratorCategories");
                                        var w = a.$(a.target + "-cX-ConfiguratorSugestionsText");
                                        var t = a.$(a.target + "-cX-ConfiguratorSugestions");
                                        var H = a.$(a.target + "-cX-ConfiguratorSugestionsDescription");
                                        var q = a.$(a.target + "-cX-ConfiguratorValueText");
                                        var J = a.$(a.target + "-cX-ConfiguratorSeeAlso");
                                        var p = a.$(a.target + "-cX-ConfiguratorValue");
                                        var I = a.$(a.target + "-cX-ConfiguratorButton");
                                        var c = a.$(a.target + "-cX-ConfiguratorApply");
                                        var h = a.$(a.target + "-cX-ConfiguratorOptions");
                                        var y = a.$(a.target + "-cX-ConfiguratorColor");
                                        var B = a.getKeys(CanvasXpress.doc.M).sort();
                                        var j = [];
                                        if (C && C.style.display == "none") {
                                            if (E) {
                                                E.innerText = "Search property or function"
                                            }
                                            if (A) {
                                                A.style.display = "none"
                                            }
                                            C.value = "";
                                            C.style.display = "block"
                                        } else {
                                            if (E) {
                                                for (var D = 0; D < B.length; D++) {
                                                    if (CanvasXpress.doc.M[B[D]].U) {
                                                        var f = a.getGraphTypes({
                                                            M: B[D]
                                                        }, true);
                                                        if (f.hasOwnProperty(a.graphType)) {
                                                            j.push(B[D])
                                                        }
                                                    } else {
                                                        j.push(B[D])
                                                    }
                                                    E.innerText = "Select category (" + j.length + ")"
                                                }
                                            }
                                            if (C) {
                                                C.style.display = "none"
                                            }
                                            if (A) {
                                                a.resetCategories();
                                                for (var D = 0; D < j.length; D++) {
                                                    var x = a.$cX("option", {
                                                        text: j[D],
                                                        value: j[D]
                                                    });
                                                    try {
                                                        A.add(x, null)
                                                    } catch (F) {
                                                        A.add(x)
                                                    }
                                                }
                                                A.style.display = "block"
                                            }
                                        }
                                        if (w && t && H && q && J && p && I && c && h && y) {
                                            w.style.display = "none";
                                            t.style.display = "none";
                                            H.style.display = "none";
                                            q.style.display = "none";
                                            J.style.display = "none";
                                            p.style.display = "none";
                                            I.style.display = "none";
                                            c.style.display = "none";
                                            h.style.display = "none";
                                            y.style.dysplay = "none"
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickMenuDropDown = function(a) {
                                    return function(b) {
                                        a.closeConfigurator(b);
                                        a.addMenu(b, false, false, false, 8, 8);
                                        return false
                                    }
                                }(this);
                                this.closeConfigurator = function(a) {
                                    return function(b) {
                                        a.resetViewportOverflow("west");
                                        a.resetConfigurator(b);
                                        return false
                                    }
                                }(this);
                                this.changeCategory = function(a) {
                                    return function(F, C, H) {
                                        a.resetOptionColorExamples();
                                        var B = a.$(a.target + "-cX-ConfiguratorCategories");
                                        var t = a.$(a.target + "-cX-ConfiguratorSugestionsText");
                                        var q = a.$(a.target + "-cX-ConfiguratorSugestions");
                                        var G = a.$(a.target + "-cX-ConfiguratorSugestionsDescription");
                                        var l = a.$(a.target + "-cX-ConfiguratorValueText");
                                        var J = a.$(a.target + "-cX-ConfiguratorSeeAlso");
                                        var k = a.$(a.target + "-cX-ConfiguratorValue");
                                        var f = a.$(a.target + "-cX-ConfiguratorApply");
                                        var I = a.$(a.target + "-cX-ConfiguratorButton");
                                        var g = a.$(a.target + "-cX-ConfiguratorOptions");
                                        var A = a.$(a.target + "-cX-ConfiguratorColor");
                                        var h = CanvasXpress.doc.M;
                                        if (H) {
                                            B.value = H
                                        }
                                        if (B && B.value && t && q && G && l && J && k && I && g && A) {
                                            var w = h[B.value].P.sort();
                                            a.resetSugestions();
                                            for (var D = 0; D < w.length; D++) {
                                                if (H && w[D] == H) {
                                                    C = D
                                                }
                                                var y = a.$cX("option", {
                                                    text: w[D],
                                                    value: w[D]
                                                });
                                                try {
                                                    q.add(y, null)
                                                } catch (E) {
                                                    q.add(y)
                                                }
                                            }
                                            q.options[C || 0].selected = true;
                                            t.innerHTML = "Select property (" + w.length + ")";
                                            a.setConfiguratorPropertyValue(q, G, l, J, k);
                                            t.style.display = "block";
                                            q.style.display = "block";
                                            G.style.display = "block";
                                            l.style.display = "block";
                                            J.style.display = "block";
                                            k.style.display = "block";
                                            f.style.display = "block";
                                            I.style.display = "block";
                                            g.style.display = "none";
                                            A.style.display = "none"
                                        }
                                        return false
                                    }
                                }(this);
                                this.hideCategories = function() {
                                    var a = this.$(this.target + "-cX-ConfiguratorCategories");
                                    var b = this.$(this.target + "-cX-ConfiguratorKeyTextSpan");
                                    var c = this.$(this.target + "-cX-ConfiguratorKeySearch");
                                    var e = this.$(this.target + "-cX-ConfiguratorKeyDock");
                                    if (a && b && c && e) {
                                        a.style.display = "none";
                                        b.innerHTML = "";
                                        c.style.display = "none";
                                        e.style.display = "none"
                                    }
                                };
                                this.resetCategories = function() {
                                    var a = this.$(this.target + "-cX-ConfiguratorCategories");
                                    if (a) {
                                        if (a.hasChildNodes()) {
                                            while (a.childNodes.length >= 1) {
                                                a.removeChild(a.firstChild)
                                            }
                                        }
                                        a.style.display = "none"
                                    }
                                };
                                this.clickSuggestions = function(a) {
                                    return function(b) {
                                        a.resetOptionColorExamples();
                                        a.setConfiguratorPropertyValue();
                                        return false
                                    }
                                }(this);
                                this.setConfiguratorPropertyValue = function(l, e, j, g, h) {
                                    if (!l) {
                                        l = this.$(this.target + "-cX-ConfiguratorSugestions")
                                    }
                                    if (!e) {
                                        e = this.$(this.target + "-cX-ConfiguratorSugestionsDescription")
                                    }
                                    if (!j) {
                                        j = this.$(this.target + "-cX-ConfiguratorValueText")
                                    }
                                    if (!g) {
                                        g = this.$(this.target + "-cX-ConfiguratorSeeAlso")
                                    }
                                    if (!h) {
                                        h = this.$(this.target + "-cX-ConfiguratorValue")
                                    }
                                    var k;
                                    var f = this.$(this.target + "-cX-ConfiguratorOptions");
                                    var c = this.getConfigurableObjectDoc(l.value);
                                    h.value = "";
                                    h.style.readonly = false;
                                    if (this.configuringNetwork) {
                                        if (typeof(this[l.value]) == "function") {
                                            h.style.disabled = "disabled";
                                            h.style.readonly = false
                                        } else {
                                            if (this.configuringNetwork < this.data.nodes.length) {
                                                k = this.data.nodes[this.configuringNetwork][l.value]
                                            } else {
                                                k = this.data.edges[this.configuringNetwork - this.data.nodes.length][l.value]
                                            }
                                        }
                                    } else {
                                        if (this.configuringGenome) {
                                            var b = this.subtracksInfo;
                                            if (!isNaN(this.configuringGenome)) {
                                                k = this.data.tracks[b[this.configuringGenome].track].data[b[this.configuringGenome].index][l.value]
                                            } else {
                                                if (this.configuringGenome.match(/:/)) {
                                                    k = parseInt(this.configuringGenome.split(":")[1]);
                                                    k = this.data.tracks[b[k].track].data[b[k].index][l.value]
                                                } else {
                                                    k = parseInt(this.configuringGenome.replace("track-", ""));
                                                    k = this.data.tracks[b[k].track][l.value]
                                                }
                                            }
                                        } else {
                                            if (typeof(this[l.value]) == "function") {
                                                j.innerHTML = "Current&nbsp;value&nbsp;[&nbsp;<i>function</i>&nbsp;]&nbsp;" + this[l.value].length + "&nbsp;parameter(s)";
                                                if (this[l.value].length == 0) {
                                                    h.style.disabled = "disabled";
                                                    h.style.readonly = false
                                                }
                                            } else {
                                                k = this[l.value]
                                            }
                                        }
                                    }
                                    h.value = k ? this.stringifyJSON(k) : "";
                                    this.addPropertyDescription(e, c, l.value);
                                    this.addPropertySeeAlsoLinks(g, c);
                                    this.addPropertyOptions(j, f, c, l.value, k);
                                    if (this.showConfiguratorExamplesOnSelect) {
                                        this.resetPropertyExample();
                                        this.clickExamplePropertyDescription(false, l.value)
                                    }
                                };
                                this.resetSugestions = function() {
                                    var a = this.$(this.target + "-cX-ConfiguratorSugestions");
                                    if (a) {
                                        if (a.hasChildNodes()) {
                                            while (a.childNodes.length >= 1) {
                                                a.removeChild(a.firstChild)
                                            }
                                        }
                                        a.style.display = "none"
                                    }
                                };
                                this.addPropertyDescription = function(l, f, e) {
                                    var n = f && f.C ? f.C : "";
                                    var g = f && f.M ? f.M : "";
                                    var t = f && f.H ? true : false;
                                    this.resetPropertyDescription(l);
                                    var a = this.$cX("i", {
                                        innerHTML: e
                                    });
                                    var u = this.$cX("span", {
                                        id: this.target + "-cX-ConfiguratorSugestionsDescriptionEditSpan",
                                        className: "CanvasXpressConfigurator",
                                        prop: e,
                                        innerHTML: " : " + n
                                    });
                                    var j = this.$cX("i", {
                                        innerHTML: g
                                    });
                                    var k = this.$cX("a", {
                                        id: this.target + "-cX-ConfiguratorSugestionsDescriptionExample",
                                        href: "javascript:void(0)",
                                        alt: "Show examples",
                                        title: "Show examples"
                                    });
                                    var r = this.$cX("span", false, {
                                        className: "CanvasXpressConfigurator"
                                    });
                                    k.appendChild(a);
                                    r.appendChild(window.document.createTextNode("Description [ "));
                                    r.appendChild(j);
                                    r.appendChild(window.document.createTextNode(" ]"));
                                    l.appendChild(r);
                                    l.appendChild(this.$cX("br"));
                                    l.appendChild(t ? k : a);
                                    l.appendChild(u);
                                    this.addEvtListener(k, "click", this.clickExamplePropertyDescription, false)
                                };
                                this.resetPropertyDescription = function(b, a) {
                                    if (!b) {
                                        b = this.$(this.target + "-cX-ConfiguratorSugestionsDescription")
                                    }
                                    if (b) {
                                        if (!a) {
                                            a = this.$(this.target + "-cX-ConfiguratorSugestionsDescriptionExample")
                                        }
                                        if (a) {
                                            this.removeEvtListener(a, "click", this.clickExamplePropertyDescription, false)
                                        }
                                        while (b.childNodes.length > 0) {
                                            var e = b.childNodes[0];
                                            b.removeChild(e)
                                        }
                                    }
                                };
                                this.getGraphTypes = function(e, c) {
                                    var a = [];
                                    if (e.U) {
                                        for (var b = 0; b < e.U.length; b++) {
                                            var d = e.U[b];
                                            a = a.concat(CanvasXpress.graphTypes[d])
                                        }
                                    } else {
                                        if (CanvasXpress.doc.M[e.M].U) {
                                            for (var b = 0; b < CanvasXpress.doc.M[e.M].U.length; b++) {
                                                var d = CanvasXpress.doc.M[e.M].U[b];
                                                a = a.concat(CanvasXpress.graphTypes[d])
                                            }
                                        } else {
                                            a = ["Bar"]
                                        }
                                    }
                                    return c ? this.getObjectArray(a) : this.getUniqueEls(a).sort()
                                };
                                this.getExamplesDocObject = function(c, v) {
                                    var h = [];
                                    if (c) {
                                        var g = this.getConfigurableObjectDoc(c);
                                        var w = this.getGraphTypes(g);
                                        for (var n = 0; n < g.H.length; n++) {
                                            if (g.H[n].match(/^\{\[/)) {
                                                var s = [];
                                                var a = g.H[n] == "{[*]}" || g.H[n].match(/^\{\[.+?\]\}[^,]/) || g.H[n].match(/^\{\[.+\]\}[^,]$/) ? {} : this.parseJSON(String(g.H[n].replace(/^\{\[.+?\],/, "{")));
                                                var e = a.data ? this.getDataSet(a.data) : false;
                                                var l = a.skipExample ? this.getObjectArray(a.skipExample) : {};
                                                var q = a.functions ? a.functions : false;
                                                if (e) {
                                                    delete(a.data)
                                                }
                                                if (l) {
                                                    delete(a.skipExample)
                                                }
                                                if (q) {
                                                    delete(a.functions)
                                                }
                                                if (g.H[n].match(/^\{\[[^\*].+\]/)) {
                                                    s = g.H[n].replace(/"/g, "");
                                                    s = s.split("]")[0].replace("{[", "").split(",")
                                                } else {
                                                    if (g.T == "option") {
                                                        s = g.O
                                                    } else {
                                                        if (g.T == "boolean") {
                                                            s = [true, false]
                                                        } else {
                                                            if (g.T == "color") {
                                                                s = ["rgb(255,125,51)", "rgb(51,255,125)", "rgb(125,51,255)"];
                                                                s.unshift(g.D)
                                                            } else {
                                                                if (g.T == "float") {
                                                                    s = g.D == "null" ? [null, 0.5] : [parseFloat(g.D), Math.max(parseFloat(g.D) * 2, 1)]
                                                                } else {
                                                                    if (g.T == "integer") {
                                                                        s = g.D == 0 ? [0, 1] : [parseInt(g.D), parseInt((parseInt(g.D) * 2) + 0.5)]
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                if (s.length > 8) {
                                                    s = this.sample(s, 8)
                                                }
                                                for (var m = 0; m < s.length; m++) {
                                                    if (l.hasOwnProperty(s[m])) {
                                                        continue
                                                    }
                                                    var b = (v ? c : this.target) + "-cX-ConfiguratorExample-" + c + "-" + String(s[m]).replace(/\s/m, "-") + "-" + n;
                                                    var k = this.cloneObject(a);
                                                    if (s[m] == "null" || s[m] == null) {
                                                        k[c] = null
                                                    } else {
                                                        k[c] = g.T == "integer" || g.T == "float" ? Number(s[m]) : s[m];
                                                        if (k[c] == "false") {
                                                            k[c] = false
                                                        } else {
                                                            if (k[c] == "true") {
                                                                k[c] = true
                                                            }
                                                        }
                                                    }
                                                    if (!k.graphType) {
                                                        k.graphType = w[2] || w[0]
                                                    }
                                                    if (q) {
                                                        h.push([b, e, k, q])
                                                    } else {
                                                        h.push([b, e, k])
                                                    }
                                                }
                                            } else {
                                                var m = this.parseJSON(String(g.H[n]));
                                                var t = m.data ? this.getDataSet(m.data) : false;
                                                var r = m.functions ? m.functions : false;
                                                if (t) {
                                                    delete(m.data)
                                                }
                                                if (r) {
                                                    delete(m.functions)
                                                }
                                                var b = (v ? c : this.target) + "-cX-ConfiguratorExample-" + c + "-" + n;
                                                if (!m.graphType) {
                                                    m.graphType = w[2] || w[0]
                                                }
                                                if (r) {
                                                    h.push([b, t, m, r])
                                                } else {
                                                    h.push([b, t, m])
                                                }
                                            }
                                        }
                                    }
                                    return h
                                };
                                this.clickExamplePropertyDescription = function(a) {
                                    return function(x, q, B) {
                                        a.resetPropertyExample();
                                        var d = function() {
                                            if (a.graphType != l) {
                                                l = a.graphType;
                                                A = a.getDataSet()
                                            }
                                            return A
                                        };
                                        var w = B ? a.$(q + "-cX-API-Example") : a.$(a.target + "-cX-ConfiguratorExample");
                                        var f = B ? a.$(q + "-cX-API-ExampleSpan") : a.$(a.target + "-cX-ConfiguratorExampleSpan");
                                        var o = B ? a.$(q + "-cX-API-ExampleContent") : a.$(a.target + "-cX-ConfiguratorExampleContent");
                                        var l = a.graphType;
                                        var A = a.getDataSet();
                                        if (w && o) {
                                            if (!q) {
                                                q = this.firstChild.innerHTML
                                            }
                                            var g = a.getExamplesDocObject(q);
                                            if (g.length) {
                                                w.style.display = "block";
                                                if (f) {
                                                    f.innerHTML = q
                                                }
                                                for (var t = 0; t < Math.min(g.length, 10); t++) {
                                                    var r = g[t][0];
                                                    var u = g[t][2];
                                                    a.graphType = u.graphType;
                                                    var n = g[t][1] ? a.cleanData(a.cloneObject(g[t][1])) : a.cleanData(d());
                                                    var h = g[t][3];
                                                    var y = a.$cX("canvas", {
                                                        id: r,
                                                        width: a.configuratorExamplesSize,
                                                        height: a.configuratorExamplesSize
                                                    });
                                                    y.setAttribute("data-responsive", true);
                                                    y.setAttribute("data-aspectRatio", "1:1");
                                                    o.appendChild(y);
                                                    if (!u.title) {
                                                        if (u[q] != null) {
                                                            if (a.isArray(u[q])) {
                                                                u.title = q + " : " + u[q].join(",")
                                                            } else {
                                                                if (a.isObject(u[q])) {
                                                                    u.title = q + " : Object"
                                                                } else {
                                                                    u.title = q + " : " + u[q]
                                                                }
                                                            }
                                                        } else {
                                                            u.title = q + " : null"
                                                        }
                                                    }
                                                    var k = new CanvasXpress(r, n, u);
                                                    if (h) {
                                                        for (var s = 0; s < h.length; s++) {
                                                            if (h[s].match(/:/)) {
                                                                var b = h[s].split(":");
                                                                k[b.shift()].apply(k, b)
                                                            } else {
                                                                k[h[s]]()
                                                            }
                                                        }
                                                    }
                                                }
                                                if (!B) {
                                                    if (a.alignConfiguratorExamples) {
                                                        var m = a.$(a.target + "-cX-Configurator");
                                                        w.style.left = m.offsetWidth + "px";
                                                        w.style.top = "-1px";
                                                        w.style.height = (m.clientHeight - 45) + "px";
                                                        o.style.maxHeight = (m.clientHeight - 45) + "px";
                                                        a.removeClass(w, "draggable")
                                                    } else {
                                                        var z = a.adjustedCoordinates(x, w);
                                                        w.style.left = z.x + "px";
                                                        w.style.top = z.y + "px";
                                                        delete(w.style.height);
                                                        o.style.Maxheight = "500px";
                                                        a.addClass(w, "draggable")
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }(this);
                                this.addPropertySeeAlsoLinks = function(f, j) {
                                    this.resetPropertySeeAlsoLinks(f);
                                    var h = window.document;
                                    var e = this.$cX("span", false, {
                                        className: "CanvasXpressConfigurator"
                                    });
                                    e.appendChild(h.createTextNode("See Also: "));
                                    f.appendChild(e);
                                    if (j && j.S) {
                                        for (var g = 0; g < j.S.length; g++) {
                                            var k = this.$cX("a", {
                                                href: "javascript:void(0)",
                                                innerHTML: j.S[g]
                                            });
                                            this.addEvtListener(k, "click", this.clickPropertySeeAlsoLinks, false);
                                            f.appendChild(k);
                                            if (g < j.S.length - 1) {
                                                f.appendChild(h.createTextNode(", "))
                                            }
                                        }
                                    }
                                };
                                this.clickPropertySeeAlsoLinks = function(a) {
                                    return function(h) {
                                        var f = a.$(a.target + "-cX-ConfiguratorKey");
                                        var b = a.$(a.target + "-cX-ConfiguratorCategories");
                                        var g = a.$(a.target + "-cX-ConfiguratorSugestions");
                                        var c = h.target || h.srcElement;
                                        if (b && b.style.display == "block") {
                                            var l = CanvasXpress.doc.P[c.innerHTML];
                                            var j = CanvasXpress.doc.M[l.M].P.sort();
                                            b.value = l.M;
                                            for (i = 0; i < j.length; i++) {
                                                if (j[i] == c.innerHTML) {
                                                    a.changeCategory(h, i);
                                                    return false
                                                }
                                            }
                                            a.changeCategory(h)
                                        } else {
                                            if (f) {
                                                f.value = c.innerHTML;
                                                a.selectConfig(h, true)
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.resetPropertySeeAlsoLinks = function(b) {
                                    if (!b) {
                                        b = this.$(this.target + "-cX-ConfiguratorSeeAlso")
                                    }
                                    if (b && b.childNodes) {
                                        while (b.childNodes.length > 0) {
                                            var d = b.childNodes[0];
                                            if (d.nodeName.toLowerCase() == "a") {
                                                this.removeEvtListener(d, "click", this.clickPropertySeeAlsoLinks, false)
                                            }
                                            b.removeChild(d)
                                        }
                                    }
                                };
                                this.addPropertyOptions = function(x, p, f, g, w) {
                                    this.resetPropertyOptions(x, p);
                                    var s = window.document;
                                    var q = this.$cX("span", false, {
                                        className: "CanvasXpressConfigurator"
                                    });
                                    var l = this.$cX("i");
                                    q.appendChild(s.createTextNode("Current value"));
                                    if (f && f.T && (f.T == "option" || f.T == "array" || f.T == "boolean")) {
                                        var y = this.$cX("div", {
                                            id: this.target + "-cX-ConfiguratorOptionsContainer",
                                            className: "CanvasXpressConfiguratorOptions"
                                        });
                                        var r = this.$cX("a", {
                                            href: "javascript:void(0)",
                                            innerHTML: f.T,
                                            alt: "Modify property",
                                            title: "Modify property"
                                        });
                                        this.addEvtListener(r, "click", this.clickPropertyOptions, false);
                                        q.appendChild(s.createTextNode(" ["));
                                        l.appendChild(r);
                                        q.appendChild(s.createTextNode(" "));
                                        q.appendChild(l);
                                        q.appendChild(s.createTextNode(" ]"));
                                        if (f.T == "array") {
                                            var n = f.X ? this[f.X]() : f.O ? f.O : [];
                                            var m = this.getObjectArray(w);
                                            if (n.length > 0) {
                                                for (var h = 0; h < n.length; h++) {
                                                    var g = this.$cX("input", {
                                                        type: "checkbox",
                                                        value: n[h],
                                                        checked: m.hasOwnProperty(n[h]) ? true : false
                                                    }, {
                                                        marginLeft: "0px"
                                                    });
                                                    this.addEvtListener(g, "change", this.updatePropertyValue, false);
                                                    y.appendChild(s.createTextNode((h + 1) + ". "));
                                                    y.appendChild(g);
                                                    y.appendChild(s.createTextNode(n[h]));
                                                    y.appendChild(this.$cX("br"))
                                                }
                                            } else {
                                                y.appendChild(this.$cX("br"));
                                                y.appendChild(s.createTextNode("This array is user defined"));
                                                y.appendChild(this.$cX("br"))
                                            }
                                        } else {
                                            var n = f.T == "boolean" ? ["true", "false"] : f.X ? this[f.X]() : f.O ? f.O : [];
                                            if (f.X && f.O) {
                                                n = n.concat(f.O)
                                            }
                                            for (var h = 0; h < n.length; h++) {
                                                var g = this.$cX("a", {
                                                    href: "javascript:void(0)",
                                                    innerHTML: n[h],
                                                    alt: "Modify property",
                                                    title: "Modify property"
                                                }, {
                                                    padding: "2px"
                                                });
                                                this.addEvtListener(g, "click", this.updatePropertyValue, false);
                                                y.appendChild(s.createTextNode((h + 1) + ". "));
                                                y.appendChild(g);
                                                y.appendChild(this.$cX("br"))
                                            }
                                        }
                                        p.appendChild(y)
                                    } else {
                                        if (f && f.T) {
                                            q.appendChild(s.createTextNode(" ["));
                                            if (f.T == "color") {
                                                var n;
                                                if (this.configuringNetwork) {
                                                    if (this.configuringNetwork < this.data.nodes.length) {
                                                        n = this.data.nodes[this.configuringNetwork][g]
                                                    } else {
                                                        n = this.data.edges[this.configuringNetwork - this.data.nodes.length][g]
                                                    }
                                                } else {
                                                    if (this.configuringGenome) {
                                                        var e = this.subtracksInfo;
                                                        if (!isNaN(this.configuringGenome)) {
                                                            n = this.data.tracks[e[this.configuringGenome].track].data[e[this.configuringGenome].index]
                                                        } else {
                                                            if (this.configuringGenome.match(/:/)) {
                                                                n = parseInt(this.configuringGenome.split(":")[1]);
                                                                n = this.data.tracks[e[n].track].data[e[n].index]
                                                            } else {
                                                                n = parseInt(this.configuringGenome.replace("track-", ""));
                                                                n = this.data.tracks[e[n].track]
                                                            }
                                                        }
                                                    } else {
                                                        n = this[g]
                                                    }
                                                }
                                                var r = this.$cX("a", {
                                                    id: this.target + "-cX-ConfiguratorValueHREF",
                                                    href: "javascript:void(0)",
                                                    innerHTML: f.T,
                                                    alt: "Modify color",
                                                    title: "Modify color"
                                                }, {
                                                    color: n ? this.rgbToHex(this.validateColor(n)) : this.foreground
                                                });
                                                this.addEvtListener(r, "click", this.addPropertyColor, false);
                                                l.appendChild(r)
                                            } else {
                                                l.appendChild(s.createTextNode(f.T))
                                            }
                                            q.appendChild(s.createTextNode(" "));
                                            q.appendChild(l);
                                            q.appendChild(s.createTextNode(" ]"))
                                        }
                                    }
                                    x.appendChild(q)
                                };
                                this.clickPropertyOptions = function(a) {
                                    return function(b) {
                                        var c = a.$(a.target + "-cX-ConfiguratorOptions");
                                        if (c) {
                                            c.style.display = "block";
                                            c.style.left = b.layerX + "px";
                                            c.style.top = b.layerY + "px"
                                        }
                                        return false
                                    }
                                }(this);
                                this.closePropertyOptions = function(a) {
                                    return function(b) {
                                        a.handleHideDiv(a.target + "-cX-ConfiguratorOptions")
                                    }
                                }(this);
                                this.resetPropertyOptions = function(a, e, b) {
                                    if (!a) {
                                        a = this.$(this.target + "-cX-ConfiguratorValueText")
                                    }
                                    if (!e) {
                                        e = this.$(this.target + "-cX-ConfiguratorOptions")
                                    }
                                    if (a && a.childNodes && !b) {
                                        while (a.childNodes.length > 0) {
                                            var f = a.childNodes[0];
                                            if (f.nodeName.toLowerCase() == "a") {
                                                this.removeEvtListener(f, "click", this.clickPropertyOptions, false)
                                            }
                                            a.removeChild(f)
                                        }
                                    }
                                    if (e) {
                                        var d = this.$(this.target + "-cX-ConfiguratorOptionsContainer");
                                        if (d) {
                                            while (d.childNodes.length > 0) {
                                                var f = d.childNodes[0];
                                                if (f.nodeName.toLowerCase() == "a") {
                                                    this.removeEvtListener(f, "click", this.updatePropertyValue, false)
                                                } else {
                                                    if (f.nodeName.toLowerCase() == "input" && f.type == "checkbox") {
                                                        this.removeEvtListener(f, "change", this.updatePropertyValue, false)
                                                    }
                                                }
                                                d.removeChild(f)
                                            }
                                            e.removeChild(d)
                                        }
                                        e.style.display = "none"
                                    }
                                };
                                this.closePropertyExample = function(a) {
                                    return function(b) {
                                        a.handleHideDiv(a.target + "-cX-ConfiguratorExample");
                                        a.resetPropertyExample()
                                    }
                                }(this);
                                this.resetPropertyExample = function(a) {
                                    var b = this.$(this.target + "-cX-ConfiguratorExample");
                                    if (b) {
                                        this.destroyInDOM(b.getElementsByTagName("canvas"));
                                        if (!a) {
                                            b.style.display = "none"
                                        }
                                    }
                                };
                                this.addPropertyColor = function(a) {
                                    return function(j) {
                                        var d = a.$(a.target + "-cX-ConfiguratorColor");
                                        var t = a.$(a.target + "-cX-ConfiguratorValue");
                                        if (d && t) {
                                            var g = t.value ? a.rgbToHex(a.validateColor(t.value.replace(/[\'\"]/g, ""))) : a.foreground;
                                            a.colorRGBfromString(g);
                                            var r = Math.round(a.colorHSV[0] / 6 * 180);
                                            var q = Math.round((1 - a.colorHSV[1]) * 100);
                                            var m = Math.round((1 - a.colorHSV[2]) * 100);
                                            var l = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorColorContainer"
                                            }, {
                                                width: "210px",
                                                height: "101px",
                                                marginTop: "7px"
                                            });
                                            var b = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorColorPalette",
                                                className: "CanvasXpressConfiguratorColorMain"
                                            }, {
                                                position: "relative",
                                                left: "0px",
                                                top: "0px",
                                                width: "181px",
                                                height: "101px"
                                            });
                                            var o = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorColorPaletteCurrent",
                                                className: "CanvasXpressConfiguratorColorExtra"
                                            }, {
                                                position: "relative",
                                                left: (r - 7) + "px",
                                                top: (q - 7) + "px",
                                                width: "195px",
                                                height: "115px"
                                            });
                                            b.appendChild(o);
                                            var w = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorColorSaturation",
                                                className: "CanvasXpressConfiguratorColor"
                                            }, {
                                                position: "relative",
                                                left: "188px",
                                                width: "15px",
                                                height: "100px",
                                                border: "1px solid rgb(51,122,183)",
                                                cursor: "crosshair"
                                            });
                                            for (var f = 0; f < 100; f += 4) {
                                                var u = a.$cX("div", false, {
                                                    height: "4px",
                                                    position: "relative",
                                                    left: "0px",
                                                    cursor: "crosshair"
                                                });
                                                w.appendChild(u)
                                            }
                                            var k = a.$cX("div", {
                                                id: a.target + "-cX-ConfiguratorColorSaturationCurrent",
                                                className: "CanvasXpressConfiguratorColorExtra"
                                            }, {
                                                position: "relative",
                                                left: "0px",
                                                top: (m - 108) + "px",
                                                width: "29px",
                                                height: "115px"
                                            });
                                            w.appendChild(k);
                                            l.appendChild(b);
                                            l.appendChild(w);
                                            d.appendChild(l);
                                            a.colorizeCurrentColorDiv();
                                            a.colorizeSaturationColorDiv();
                                            a.addEvtListener(b, "mousedown", a.registerPalette, false);
                                            a.addEvtListener(w, "mousedown", a.registerSaturation, false);
                                            d.style.display = "block";
                                            d.style.left = j.layerX + "px";
                                            d.style.top = j.layerY + "px"
                                        }
                                        return false
                                    }
                                }(this);
                                this.registerPalette = function(a) {
                                    return function(b) {
                                        a.changingColorOn = "palette";
                                        if (a.colorHSV[2] == 0) {
                                            a.colorFromHsv(null, null, 1);
                                            a.colorizeCurrentColorDiv();
                                            var c = a.$(a.target + "-cX-ConfiguratorColorSaturationCurrent");
                                            if (c) {
                                                c.style.top = "-108px"
                                            }
                                        }
                                        a.updateColorValue(b);
                                        a.colorizeSaturationColorDiv();
                                        return false
                                    }
                                }(this);
                                this.registerSaturation = function(a) {
                                    return function(b) {
                                        a.changingColorOn = "saturation";
                                        a.updateColorValue(b);
                                        return false
                                    }
                                }(this);
                                this.updateColorValue = function(g) {
                                    if (this.changingColorOn) {
                                        if (this.changingColorOn == "palette") {
                                            var f = this.$(this.target + "-cX-ConfiguratorColorPalette");
                                            var b = this.$(this.target + "-cX-ConfiguratorColorPaletteCurrent");
                                            if (f && b) {
                                                var d = this.adjustedCoordinates(g, f);
                                                if (d) {
                                                    var a = Math.min(Math.max(0, d.x), 181);
                                                    var j = Math.min(Math.max(0, d.y), 101);
                                                    b.style.left = (a - 7) + "px";
                                                    b.style.top = (j - 7) + "px";
                                                    this.colorFromHsv(a * 6 / 180, 1 - j / 100, null);
                                                    this.colorizeCurrentColorDiv();
                                                    this.colorizeSaturationColorDiv()
                                                }
                                            }
                                        } else {
                                            var c = this.$(this.target + "-cX-ConfiguratorColorSaturation");
                                            var h = this.$(this.target + "-cX-ConfiguratorColorSaturationCurrent");
                                            if (c && h) {
                                                var d = this.adjustedCoordinates(g, c);
                                                if (d) {
                                                    var j = Math.min(Math.max(0, d.y), 101);
                                                    h.style.top = (j - 108) + "px";
                                                    this.colorFromHsv(null, null, 1 - j / 100);
                                                    this.colorizeCurrentColorDiv()
                                                }
                                            }
                                        }
                                    }
                                };
                                this.colorizeCurrentColorDiv = function() {
                                    var f = this.$(this.target + "-cX-ConfiguratorColorCurrent");
                                    var a = this.$(this.target + "-cX-ConfiguratorValue");
                                    var d = this.$(this.target + "-cX-ConfiguratorValueHREF");
                                    if (f && a && d) {
                                        var e = this.colorRGBToString();
                                        var b = this.hexToRgb("#" + e);
                                        f.style.backgroundColor = "#" + e;
                                        f.innerHTML = "&nbsp;&nbsp;" + b;
                                        f.style.color = this.complementaryColor(b, true);
                                        a.value = b;
                                        d.style.color = "#" + e
                                    }
                                };
                                this.colorizeSaturationColorDiv = function() {
                                    var b = function(m, k, c, j, h) {
                                        return "rgb(" + (m * (1 - j / h) * 100) + "%," + (k * (1 - j / h) * 100) + "%," + (c * (1 - j / h) * 100) + "%)"
                                    };
                                    var e = this.$(this.target + "-cX-ConfiguratorColorSaturation");
                                    if (e && this.colorHSV) {
                                        var f = e.childNodes;
                                        var a = this.hsvFromRgb(this.colorHSV[0], this.colorHSV[1], 1);
                                        if (a) {
                                            for (var d = 0; d < f.length - 1; d++) {
                                                f[d].style.backgroundColor = b(a[0], a[1], a[2], d, f.length - 1)
                                            }
                                        }
                                    }
                                };
                                this.endColorChange = function(a) {
                                    this.changingColorOn = false
                                };
                                this.closePropertyColor = function(a) {
                                    return function(b) {
                                        a.handleHideDiv(a.target + "-cX-ConfiguratorColor");
                                        a.resetPropertyColor()
                                    }
                                }(this);
                                this.resetPropertyColor = function() {
                                    var c = this.$(this.target + "-cX-ConfiguratorColor");
                                    var b = this.$(this.target + "-cX-ConfiguratorColorPalette");
                                    var a = this.$(this.target + "-cX-ConfiguratorColorSaturation");
                                    if (c && b && a) {
                                        if (c && c.childNodes) {
                                            while (c.childNodes.length > 3) {
                                                c.removeChild(c.childNodes[3])
                                            }
                                            this.removeEvtListener(b, "mousedown", this.registerPalette, false);
                                            this.removeEvtListener(a, "mousedown", this.registerSaturation, false)
                                        }
                                        c.style.display = "none"
                                    }
                                };
                                this.updatePropertyValue = function(a) {
                                    return function(h) {
                                        var f = a.$(a.target + "-cX-ConfiguratorValue");
                                        var j = a.$(a.target + "-cX-ConfiguratorOptions");
                                        var d = h.target || h.srcElement;
                                        if (d.nodeName.toLowerCase() == "input") {
                                            var b = [];
                                            for (var g = 0; g < d.parentNode.childNodes.length; g++) {
                                                var k = d.parentNode.childNodes[g];
                                                if (k.checked) {
                                                    b.push(k.value)
                                                }
                                            }
                                            f.value = b.length > 0 ? '["' + b.join('", "') + '"]' : "[]"
                                        } else {
                                            if (f && j) {
                                                f.value = d.innerHTML;
                                                j.style.display = "none"
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickApplyConfigurator = function(a) {
                                    return function(b) {
                                        return a.clickConfigurator(b, false, false, true)
                                    }
                                }(this);
                                this.clickConfigurator = function(a) {
                                    return function(h, d, c, b) {
                                        var g = function(e) {
                                            if (e == "true" || e == "false" || e == "null" || e.match(/{|\[/)) {
                                                return a.parseJSON(e)
                                            } else {
                                                return e
                                            }
                                        };
                                        if (!d) {
                                            d = a.$(a.target + "-cX-ConfiguratorSugestions")
                                        }
                                        if (!c) {
                                            c = a.$(a.target + "-cX-ConfiguratorValue")
                                        }
                                        if (d && c) {
                                            var f = a.getConfigurableObjectDoc(d.value);
                                            if (c.value) {
                                                var j = g(c.value);
                                                if (f.T == "color" && !a.validateColor(j)) {
                                                    alert('"' + j + '" is NOT a valid color');
                                                    return false
                                                }
                                            }
                                        }
                                        a.updateClickConfigurator(h, d.value, c.value, b);
                                        return false
                                    }
                                }(this);
                                this.updateClickConfigurator = function(j, o, m, l) {
                                    var h = this;
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = function(a) {
                                        if (a == "true" || a == "false" || a == "null" || a.match(/{|\[/)) {
                                            return h.parseJSON(a)
                                        } else {
                                            return a
                                        }
                                    };
                                    if (this.configuringNetwork) {
                                        if (this.configuringNetwork < this.data.nodes.length) {
                                            if (typeof(this[o]) == "function") {
                                                this[o](this.data.nodes[this.configuringNetwork])
                                            } else {
                                                this.data.nodes[this.configuringNetwork][o] = d(m)
                                            }
                                        } else {
                                            if (typeof(this[o]) == "function") {
                                                this[o](this.data.edges[this.configuringNetwork - this.data.nodes.length])
                                            } else {
                                                this.data.edges[this.configuringNetwork - this.data.nodes.length][o] = d(m)
                                            }
                                        }
                                    } else {
                                        if (this.configuringGenome) {
                                            var b = this.subtracksInfo;
                                            if (!isNaN(this.configuringGenome)) {
                                                this.data.tracks[b[this.configuringGenome].track].data[b[this.configuringGenome].index][o] = d(m)
                                            } else {
                                                if (this.configuringGenome.match(/:/)) {
                                                    var k = parseInt(this.configuringGenome.split(":")[1]);
                                                    this.data.tracks[b[k].track].data[b[k].index][o] = d(m)
                                                } else {
                                                    var k = parseInt(this.configuringGenome.replace("track-", ""));
                                                    this.data.tracks[k][o] = d(m)
                                                }
                                            }
                                        } else {
                                            if (typeof(this[o]) == "function") {
                                                if (this[o].length > 0 && m) {
                                                    var c = d(m);
                                                    this[o](c)
                                                } else {
                                                    this[o]()
                                                }
                                                this.resetConfigurator(j);
                                                return false
                                            } else {
                                                if (o == "summaryType" && this.isGroupedData && this[o] != d(m)) {
                                                    var n = this.groupingFactors;
                                                    this.ungroupSamples(true);
                                                    this[o] = d(m);
                                                    this.meta.config.user[o] = this[o];
                                                    this.groupSamples(n, false, false, false, true)
                                                } else {
                                                    if (o == "theme" && this[o] != d(m)) {
                                                        this.changeTheme(d(m), true)
                                                    } else {
                                                        this[o] = d(m);
                                                        this.meta.config.user[o] = this[o]
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (!l) {
                                        this.resetConfigurator(j)
                                    }
                                    var g = o.match(/filter(.+)By/);
                                    if (g) {
                                        this.reset(false, false, j);
                                        this.filterData()
                                    }
                                    this.resetPropertyExample();
                                    this.draw({
                                        func: "updateClickConfigurator",
                                        par: [j, o, m, l]
                                    })
                                };
                                this.handleHideDiv = function(a) {
                                    var b = this.$(a);
                                    if (b) {
                                        b.style.display = "none"
                                    }
                                    return false
                                };
                                this.resetOptionColorExamples = function() {
                                    this.resetPropertyOptions(false, false, true);
                                    this.resetPropertyColor();
                                    this.resetPropertyExample()
                                };
                                this.resetConfigurator = function(a) {
                                    if (this.configuringOn && this.configuringOn != "docked") {
                                        var b = this.$(this.target + "-cX-Configurator");
                                        this.resetOptionColorExamples();
                                        this.resetPropertyDescription();
                                        this.resetPropertySeeAlsoLinks();
                                        this.configuringOn = false;
                                        this.configuringNetwork = false;
                                        this.configuringGenome = false;
                                        this.addRemoveConfiguratorListeners("removeEvtListener");
                                        this.transitionMagic(b, "holeOut", function() {
                                            b.parentNode.removeChild(b)
                                        })
                                    }
                                }
                            };
                            CanvasXpress.prototype.initCodeInfo = function() {
                                this.addInfoCodeDiv = function() {
                                    var g = this.$(this.target + "-cX-Code");
                                    if (g) {
                                        return g
                                    }
                                    g = this.$cX("div", {
                                        id: this.target + "-cX-Code",
                                        className: "CanvasXpressCode draggable"
                                    }, {
                                        left: "25px",
                                        top: "-" + (this.height - 25) + "px",
                                        display: "none"
                                    });
                                    var h = this.$cXI("op_cancel", {
                                        id: this.target + "-cX-CodeCloseImage",
                                        className: "CanvasXpressCode",
                                        src: "op_cancel",
                                        title: "Close Code"
                                    });
                                    var e = this.$cXI("cd_linesindent", {
                                        id: this.target + "-cX-CodePrettyImage",
                                        className: "CanvasXpressCode",
                                        src: "cd_linesindent",
                                        title: "Pretty Code"
                                    });
                                    var d = this.$cXI("cd_lines", {
                                        id: this.target + "-cX-CodeCompactImage",
                                        className: "CanvasXpressCode",
                                        src: "cd_lines",
                                        title: "Compact Code"
                                    });
                                    var b = this.$cXI("cd_params", {
                                        id: this.target + "-cX-CodeParamsImage",
                                        className: "CanvasXpressCode",
                                        src: "cd_params",
                                        title: "Params Code"
                                    });
                                    var j = this.$cXI("cd_select", {
                                        id: this.target + "-cX-CodeSelectImage",
                                        className: "CanvasXpressCode",
                                        src: "cd_select",
                                        title: "Select Code"
                                    });
                                    var f = this.$cX("div", {
                                        id: this.target + "-cX-CodeContainer",
                                        className: "CanvasXpressCodeContainer"
                                    });
                                    var a = this.$("north-wrapper-" + this.target);
                                    var k = this.$("south-wrapper-" + this.target);
                                    if (a) {
                                        a.appendChild(f)
                                    }
                                    if (k) {
                                        g.appendChild(h);
                                        g.appendChild(e);
                                        g.appendChild(d);
                                        g.appendChild(b);
                                        g.appendChild(j);
                                        g.appendChild(f);
                                        k.appendChild(g);
                                        this.addRemoveCodeListeners("addEvtListener")
                                    }
                                    return g
                                };
                                this.addRemoveCodeListeners = function(a) {
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-Code"), "mousedown", this.registerMousemove, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-CodeCloseImage"), "click", this.clickCode, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-CodePrettyImage"), "click", this.clickChangeCode, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-CodeCompactImage"), "click", this.clickChangeCode, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-CodeParamsImage"), "click", this.clickChangeCode, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-CodeSelectImage"), "click", this.clickSelectCode, false)
                                };
                                this.clickCode = function(a) {
                                    return function(b) {
                                        a.hideCodeDiv(b);
                                        return false
                                    }
                                }(this);
                                this.clickChangeCode = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        switch (b.id) {
                                            case a.target + "-cX-CodePrettyImage":
                                                a.codeType = "pretty";
                                                break;
                                            case a.target + "-cX-CodeCompactImage":
                                                a.codeType = "compact";
                                                break;
                                            case a.target + "-cX-CodeParamsImage":
                                                a.codeType = "params";
                                                break;
                                            default:
                                                break
                                        }
                                        a.updateCodeDiv();
                                        return false
                                    }
                                }(this);
                                this.clickSelectCode = function(a) {
                                    return function(d) {
                                        var b;
                                        var c = a.$(a.target + "-cX-CodeContent");
                                        if (c) {
                                            if (document.selection) {
                                                b = document.body.createTextRange();
                                                b.moveToElementText(c);
                                                b.select()
                                            } else {
                                                if (window.getSelection()) {
                                                    b = document.createRange();
                                                    b.selectNode(c);
                                                    window.getSelection().removeAllRanges();
                                                    window.getSelection().addRange(b)
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.clearCodeDiv = function() {
                                    var b = this.$(this.target + "-cX-Code");
                                    if (!b) {
                                        b = this.initializeCodeInfo()
                                    }
                                    var a = this.$(this.target + "-cX-CodeContent");
                                    if (b && a) {
                                        a.parentNode.removeChild(a);
                                        b.style.display = "none"
                                    }
                                };
                                this.getDataJSON = function(c, b) {
                                    var a = {
                                        x: true,
                                        y: true,
                                        z: true,
                                        venn: true,
                                        nodes: true,
                                        edges: true,
                                        tracks: true
                                    };
                                    var d = CanvasXpress.stack[this.target].data;
                                    var f = {};
                                    for (var e in d) {
                                        if (a.hasOwnProperty(e)) {
                                            f[e] = this.cloneObject(d[e], true)
                                        }
                                    }
                                    if (f.y) {
                                        this.cleanDataObject(f)
                                    }
                                    return b ? f : c ? this.prettyJSON(f, null, true) : this.stringifyJSON(f)
                                };
                                this.cleanDataObject = function(c) {
                                    if (c && c.data) {
                                        if (c.data && c.data.y) {
                                            var b = this.isRawData ? ["labs", "glab", "desc", "mean", "median", "stdev", "n", "qtl1", "qtl3", "iqr", "iqr1", "iqr3", "out", "conf", "trans", "tstdev", "cor", "min", "max", "sum", "count", "grps", "grpIdxs", "factors"] : ["labs", "glab", "desc", "data"];
                                            for (var a = 0; a < b.length; a++) {
                                                delete c.data.y[b[a]]
                                            }
                                            var d = ["l", "w", "sankey", "tree", "bubble", "gantt", "contour"];
                                            for (var a = 0; a < d.length; a++) {
                                                delete c.data[d[a]]
                                            }
                                        }
                                        return c
                                    } else {
                                        if (c && this.graphType == "Map") {
                                            return c
                                        }
                                    }
                                };
                                this.getConfigJSON = function(a) {
                                    return a ? this.prettyJSON(this.getConfig(), null, true) : this.stringifyJSON(this.getConfig())
                                };
                                this.getEventsJSON = function(a) {
                                    var b = CanvasXpress.stack[this.target].events || false;
                                    return a ? this.prettyJSON(b, null, true) : this.stringifyJSON(b)
                                };
                                this.getCodeJSONJS = function(f) {
                                    var h = this.getDataJSON(f);
                                    var i = this.getConfigJSON(f);
                                    var g = this.getEventsJSON(f);
                                    if (f) {
                                        var b = '<span class=json-value>new</span> CanvasXpress(<span class=json-string>"canvas"</span>, ' + h + ", " + i + ", " + g + ");";
                                        return "<code> " + b.replace(/\n/g, "</code>\n<code> ") + "</code>"
                                    } else {
                                        var b = this.prettyJSON(CanvasXpress.stack[this.target], false, false, 4).replace(/}$/, "  }");
                                        return "  new CanvasXpress(" + b + ");\n"
                                    }
                                };
                                this.updateCodeDiv = function(i) {
                                    var a = this.getDataJSON(this.codeType == "pretty");
                                    var f = this.codeType == "params" ? "{\n  ...\n}" : a;
                                    var j = this.getConfigJSON(this.codeType == "pretty" || this.codeType == "params");
                                    var e = this.getEventsJSON(true);
                                    var k = '<span class=json-value>new</span> CanvasXpress(<span class=json-string>"canvasID"</span>, ' + f + ", " + j + ", " + e + ");";
                                    var b = "<code> " + k.replace(/\n/g, "</code>\n<code> ") + "</code>";
                                    var g = this.$(this.target + "-cX-Code");
                                    if (!g) {
                                        g = this.initializeCodeInfo()
                                    }
                                    var d = this.$(this.target + "-cX-CodeContainer");
                                    if (g && d) {
                                        this.clearCodeDiv();
                                        var l = this.codeType == "compact" ? "span" : "pre";
                                        d.appendChild(this.$cX(l, {
                                            id: this.target + "-cX-CodeContent",
                                            className: "CanvasXpressCodeContent",
                                            innerHTML: b
                                        }));
                                        g.style.display = "block";
                                        if (i) {
                                            g.style.zIndex = i
                                        }
                                    }
                                };
                                this.updateInfoDiv = function(a) {
                                    var b = this.$(this.target + "-cX-Info");
                                    if (b && a) {
                                        b.innerHTML = a
                                    }
                                };
                                this.showDiv = function(a, c, b) {
                                    var f = this.$(this.target + "-cX-" + a);
                                    if (!f) {
                                        f = this.initializeCodeInfo()
                                    }
                                    if (f) {
                                        f.style.opacity = 1;
                                        f.style.display = "block";
                                        this.transitionMagic(f, b || "swashIn")
                                    }
                                };
                                this.hideDiv = function(a, c, b) {
                                    var f = this.$(this.target + "-cX-" + a);
                                    if (!f) {
                                        f = this.initializeCodeInfo()
                                    }
                                    if (f) {
                                        this.transitionMagic(f, b || "holeOut", function() {
                                            f.style.display = "none"
                                        })
                                    }
                                };
                                this.showCodeDiv = function(b, a) {
                                    this.updateCodeDiv();
                                    this.removeMenus();
                                    this.showDiv("Code", b, a)
                                };
                                this.showRCodeDiv = function(d, b) {
                                    this.removeMenus();
                                    var f = this.$(this.target + "-cX-Code");
                                    if (!f) {
                                        f = this.initializeCodeInfo()
                                    }
                                    var a = this.$(this.target + "-cX-CodeContainer");
                                    if (f && a) {
                                        this.clearCodeDiv();
                                        a.appendChild(this.$cX("pre", {
                                            id: this.target + "-cX-CodeContent",
                                            className: "CanvasXpressCodeContent",
                                            innerHTML: this.dataToR()
                                        }));
                                        this.$(this.target + "-cX-CodePrettyImage").style.display = "none";
                                        this.$(this.target + "-cX-CodeCompactImage").style.display = "none";
                                        this.$(this.target + "-cX-CodeParamsImage").style.display = "none";
                                        this.showDiv("Code", d, b);
                                        if (this.graphType == "Map") {
                                            f.style.zIndex = 1000
                                        }
                                    }
                                };
                                this.showMetaCodeDiv = function(d, b) {
                                    this.removeMenus();
                                    var g = this.$(this.target + "-cX-Code");
                                    if (!g) {
                                        g = this.initializeCodeInfo()
                                    }
                                    var a = this.$(this.target + "-cX-CodeContainer");
                                    if (g && a) {
                                        var f = {
                                            version: this.createVersion || this.version,
                                            factory: this.createFactory || CanvasXpress.factory
                                        };
                                        this.clearCodeDiv();
                                        a.appendChild(this.$cX("pre", {
                                            id: this.target + "-cX-CodeContent",
                                            className: "CanvasXpressCodeContent",
                                            innerHTML: "<code> " + this.prettyJSON(f, null, true).replace(/\n/g, "</code>\n<code> ") + "</code>"
                                        }));
                                        this.$(this.target + "-cX-CodePrettyImage").style.display = "none";
                                        this.$(this.target + "-cX-CodeCompactImage").style.display = "none";
                                        this.$(this.target + "-cX-CodeParamsImage").style.display = "none";
                                        this.showDiv("Code", d, b);
                                        if (this.graphType == "Map") {
                                            g.style.zIndex = 1000
                                        }
                                    }
                                };
                                this.hideCodeDiv = function(b, a) {
                                    this.$(this.target + "-cX-CodePrettyImage").style.display = "block";
                                    this.$(this.target + "-cX-CodeCompactImage").style.display = "block";
                                    this.$(this.target + "-cX-CodeParamsImage").style.display = "block";
                                    if (this.graphType == "Map") {
                                        var d = this.$(this.target + "-cX-Code");
                                        delete d.style.zIndex
                                    }
                                    this.hideDiv("Code", b, a)
                                };
                                this.showInfoDiv = function(b, a) {
                                    this.removeMenus();
                                    this.showDiv("Info", b, a)
                                };
                                this.hideInfoDiv = function(b, a) {
                                    this.hideDiv("Info", b, a)
                                };
                                this.initializeCodeInfo = function() {
                                    if (!this.disableEvents && !this.disableCode) {
                                        return this.addInfoCodeDiv()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initBin = function() {
                                this.addBinConfigurator = function(M, B) {
                                    this.removeMenus();
                                    var z = this.target + "-" + M + "-cX-Bin";
                                    var f = this.range(this.data.y.data[M]);
                                    var E = (f[1] - f[0]) / B;
                                    var w = this.getAxisDecimals(f[0]) + 1;
                                    this.binConfigurations[z] = {};
                                    this.binConfigurations[z]["apply"] = false;
                                    this.binConfigurations[z]["n"] = B;
                                    this.binConfigurations[z]["vi"] = M;
                                    this.binConfigurations[z]["min"] = f[0];
                                    this.binConfigurations[z]["max"] = f[1];
                                    this.binConfigurations[z]["dec"] = w;
                                    this.binConfigurations[z]["name"] = "Custom-" + this.data.y.vars[M] + "-Bin";
                                    this.binConfigurations[z]["bins"] = [];
                                    for (var H = 0; H < B; H++) {
                                        this.binConfigurations[z]["bins"][H] = {
                                            name: "Bin-" + (H + 1),
                                            value: Number(f[0] + ((H + 1) * E))
                                        }
                                    }
                                    var I = this.$cX("div", {
                                        id: z,
                                        className: "CanvasXpressBin draggable"
                                    }, {
                                        left: "30px",
                                        top: -(this.height - 30) + "px",
                                        display: "block"
                                    });
                                    var g = this.$cXI("op_cancel", {
                                        id: z + "CloseImage",
                                        className: "CanvasXpressBin",
                                        src: "op_cancel",
                                        title: "Close Bin Configurator"
                                    });
                                    var J = this.$cX("div", {
                                        id: z + "Container",
                                        className: "CanvasXpressBinContainer"
                                    });
                                    var C = this.$cX("input", {
                                        id: z + "Name",
                                        className: "CanvasXpressBin",
                                        type: "text",
                                        value: "Custom-" + this.data.y.vars[M] + "-Bin"
                                    }, {
                                        width: "97%"
                                    });
                                    var A = this.$cX("div", {
                                        id: z + "NameSegmentContainer",
                                        className: "CanvasXpressBinNameContainer"
                                    });
                                    var y = this.$cX("table", {
                                        id: z + "NameSegment",
                                        className: "CanvasXpressBinTable"
                                    }, {
                                        width: "100%"
                                    });
                                    var v = this.$cX("tbody");
                                    var G = this.$cX("th", {
                                        innerHTML: "Bin"
                                    }, {
                                        textAlign: "center"
                                    });
                                    var F = this.$cX("th", {
                                        innerHTML: "Name"
                                    }, {
                                        textAlign: "center"
                                    });
                                    var D = this.$cX("th", {
                                        innerHTML: "Max"
                                    }, {
                                        textAlign: "center"
                                    });
                                    var o = this.$cX("tr");
                                    o.appendChild(G);
                                    o.appendChild(F);
                                    o.appendChild(D);
                                    v.appendChild(o);
                                    for (var H = 0; H < B; H++) {
                                        var G = this.$cX("td", {
                                            innerHTML: H + 1
                                        }, {
                                            width: (this.configuratorWidth * 0.1) + "px",
                                            textAlign: "center",
                                            fontWeight: "bold"
                                        });
                                        var F = this.$cX("td");
                                        var D = this.$cX("td");
                                        var e = this.$cX("input", {
                                            id: z + "Name" + H,
                                            className: "CanvasXpressBin",
                                            type: "text",
                                            value: "Bin-" + (H + 1)
                                        }, {
                                            width: (this.configuratorWidth * 0.65) + "px",
                                            textAlign: "center",
                                            fontWeight: "bold"
                                        });
                                        var h = this.$cX("input", {
                                            id: z + "Value" + H,
                                            className: "CanvasXpressBin",
                                            type: "text",
                                            value: this.formatNumber(f[0] + ((H + 1) * E), w)
                                        }, {
                                            width: (this.configuratorWidth * 0.25) + "px"
                                        });
                                        var o = this.$cX("tr");
                                        D.appendChild(h);
                                        F.appendChild(e);
                                        o.appendChild(G);
                                        o.appendChild(F);
                                        o.appendChild(D);
                                        v.appendChild(o)
                                    }
                                    y.appendChild(v);
                                    A.appendChild(y);
                                    var L = this.$cX("input", {
                                        id: z + "Apply",
                                        value: "Apply",
                                        type: "button"
                                    }, {
                                        cssFloat: "left",
                                        borderRadius: "5px",
                                        top: "4px",
                                        position: "relative",
                                        width: "46%",
                                        padding: "3px",
                                        margin: "5px"
                                    });
                                    var K = this.$cX("input", {
                                        id: z + "Button",
                                        value: "Done",
                                        type: "button"
                                    }, {
                                        cssFloat: "left",
                                        borderRadius: "5px",
                                        top: "4px",
                                        position: "relative",
                                        width: "46%",
                                        padding: "3px",
                                        margin: "5px"
                                    });
                                    var u = this.$("south-wrapper-" + this.target);
                                    if (u) {
                                        J.appendChild(this.$cX("span", {
                                            className: "CanvasXpressBin",
                                            innerHTML: "Edit Name"
                                        }));
                                        J.appendChild(this.$cX("br"));
                                        J.appendChild(C);
                                        J.appendChild(this.$cX("br"));
                                        J.appendChild(this.$cX("br"));
                                        J.appendChild(this.$cX("span", {
                                            className: "CanvasXpressBin",
                                            innerHTML: "Edit Bin Name and Range"
                                        }));
                                        J.appendChild(this.$cX("br"));
                                        J.appendChild(A);
                                        J.appendChild(L);
                                        J.appendChild(K);
                                        J.appendChild(this.$cX("br"));
                                        I.appendChild(g);
                                        I.appendChild(J);
                                        u.appendChild(I);
                                        this.addRemoveBinListeners("addEvtListener", z)
                                    }
                                };
                                this.addRemoveBinListeners = function(b, d) {
                                    var c = d ? [d] : this.getKeys(this.binConfigurations);
                                    for (var a = 0; a < c.length; a++) {
                                        this.addRemoveEvtListener(b, this.$(c[a]), "mousedown", this.registerMousemove, false);
                                        this.addRemoveEvtListener(b, this.$(c[a] + "CloseImage"), "click", this.closeBinConfigurator, false);
                                        this.addRemoveEvtListener(b, this.$(c[a] + "Apply"), "click", this.applyBinConfigurator, false);
                                        this.addRemoveEvtListener(b, this.$(c[a] + "Button"), "click", this.doneBinConfigurator, false);
                                        if (b == "removeEvtListener" && this.binConfigurations[c[a]] && !this.binConfigurations[c[a]]["apply"]) {
                                            delete(this.binConfigurations[c[a]])
                                        }
                                    }
                                };
                                this.closeBinConfigurator = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        var f = b.id.replace("CloseImage", "");
                                        var d = a.$(f);
                                        if (d) {
                                            a.addRemoveBinListeners("removeEvtListener", f);
                                            d.parentNode.removeChild(d)
                                        }
                                        return false
                                    }
                                }(this);
                                this.validateBinning = function(a) {
                                    var e = false;
                                    var h = this.$(a + "Name0").value;
                                    var m = this.$(a + "Value0").value;
                                    for (var k = 1; k < this.binConfigurations[a]["n"]; k++) {
                                        var p = this.$(a + "Name" + k).value;
                                        var b = this.$(a + "Value" + k).value;
                                        if (h == "" || h == null) {
                                            e = "Value for Bin " + k + " CANNOT be null";
                                            break
                                        } else {
                                            if (p == "" || p == null) {
                                                e = "Value for Bin " + (k + 1) + " CANNOT be null";
                                                break
                                            } else {
                                                if (m == "" || m == null) {
                                                    e = "Value for " + h + " (" + m + ") CANNOT be null";
                                                    break
                                                } else {
                                                    if (b == "" || b == null) {
                                                        e = "Value for " + p + " (" + b + ") CANNOT be null";
                                                        break
                                                    } else {
                                                        if (isNaN(m)) {
                                                            e = "Value for " + h + " (" + m + ") is NOT a number";
                                                            break
                                                        } else {
                                                            if (isNaN(b)) {
                                                                e = "Value for " + p + " (" + b + ") is NOT a number";
                                                                break
                                                            } else {
                                                                if (m > b) {
                                                                    e = "Value for " + h + " (" + m + ")CANNOT be greater that value for " + p + " (" + b + ")";
                                                                    break
                                                                }
                                                                h = p;
                                                                m = b
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (e) {
                                        alert(e);
                                        return false
                                    } else {
                                        for (var k = 0; k < this.binConfigurations[a]["n"]; k++) {
                                            var c = this.$(a + "Name" + k).value;
                                            var o = this.$(a + "Value" + k).value;
                                            this.binConfigurations[a]["bins"][k] = {
                                                name: c,
                                                value: o
                                            }
                                        }
                                        var d = this.binConfigurations[a]["name"];
                                        var g = this.binConfigurations[a]["vi"];
                                        this.data.x[d] = [];
                                        for (var k = 0; k < this.data.y.data[g].length; k++) {
                                            var o = this.data.y.data[g][k];
                                            if (!isNaN(o) && o !== "" && o != null) {
                                                for (var f = 0; f < this.binConfigurations[a]["n"]; f++) {
                                                    if (o <= this.binConfigurations[a]["bins"][f].value) {
                                                        this.data.x[d][k] = this.binConfigurations[a]["bins"][f].name;
                                                        break
                                                    }
                                                }
                                            } else {
                                                this.data.x[d][k] = ""
                                            }
                                        }
                                        if (this.isGroupedData) {
                                            this.ungroupSamples(true)
                                        }
                                        this.updateData(this.data);
                                        this.groupSamples([d]);
                                        this.sortSamplesByCategory([d]);
                                        this.binConfigurations[a]["apply"] = true;
                                        return true
                                    }
                                };
                                this.applyBinConfigurator = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        var d = b.id.replace("Apply", "");
                                        a.validateBinning(d)
                                    }
                                }(this);
                                this.doneBinConfigurator = function(a) {
                                    return function(d) {
                                        var b = a.getTargetEvent(d);
                                        var g = b.id.replace("Button", "");
                                        var c = a.validateBinning(g);
                                        var f = a.$(g);
                                        if (f && c) {
                                            a.addRemoveBinListeners("removeEvtListener", g);
                                            f.parentNode.removeChild(f)
                                        }
                                        return false
                                    }
                                }(this)
                            };
                            CanvasXpress.prototype.initDataExplorer = function() {
                                this.addDataExplorer = function() {
                                    var p = this.target + "-cX-DataExplorer";
                                    var s = this.$(p);
                                    if (s) {
                                        return
                                    }
                                    var r = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorer",
                                        className: "CanvasXpressBin draggable"
                                    }, {
                                        left: "34px",
                                        top: "-" + (this.height - 36) + "px",
                                        display: "block",
                                        opacity: 0,
                                        width: "min-content"
                                    });
                                    var j = this.$cXI("op_cancel", {
                                        id: this.target + "-cX-DataExplorerCloseImage",
                                        className: "CanvasXpressBin",
                                        src: "op_cancel",
                                        title: "Close Data Explorer"
                                    });
                                    var l = this.$cXI("tb_table", {
                                        id: this.target + "-cX-DataExplorerDataTableImage",
                                        className: "CanvasXpressBin",
                                        src: "tb_table",
                                        title: "Show Data in Table"
                                    });
                                    var m = this.$cXI("fp_funnel", {
                                        id: this.target + "-cX-DataExplorerDataFilterImage",
                                        className: "CanvasXpressBin",
                                        src: "fp_funnel",
                                        title: "Filter Data"
                                    });
                                    var h = this.$cXI("wp_configuration", {
                                        id: this.target + "-cX-DataExplorerCustomizeImage",
                                        className: "CanvasXpressBin",
                                        src: "wp_configuration",
                                        title: "Customize",
                                        fun: "getConfigurationMenu",
                                        par: [],
                                        mid: this.newId("-cX-DataExplorer-Menu-")
                                    });
                                    var i = this.$cXI("ch_oinfo", {
                                        id: this.target + "-cX-DataExplorerHelpImage",
                                        className: "CanvasXpressBin",
                                        src: "ch_oinfo",
                                        alt: "Mouse over Headers\nin Data Explorer to\nLearn Functionality",
                                        title: "Mouse over Headers\nin Data Explorer to\nLearn Functionality"
                                    });
                                    var g = this.loadMainTab();
                                    var u = this.loadDOETab();
                                    var t = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerContainer",
                                        className: "CanvasXpressBinContainer"
                                    });
                                    var o = this.$("south-wrapper-" + this.target);
                                    if (o) {
                                        r.appendChild(j);
                                        r.appendChild(l);
                                        r.appendChild(m);
                                        r.appendChild(h);
                                        r.appendChild(g);
                                        r.appendChild(u);
                                        var e = this.loadDataExplorerTopPanel();
                                        t.appendChild(e);
                                        t.appendChild(this.$cX("hr", {
                                            className: "CanvasXpressDataExplorer"
                                        }, {
                                            width: "241px"
                                        }));
                                        var f = this.$cX("span", {
                                            innerHTML: "Columns",
                                            title: "Columns in Data"
                                        }, {
                                            postion: "abosulte",
                                            margin: "5px",
                                            floatCSS: "left",
                                            lineHeight: "32px",
                                            fontWeight: "bold"
                                        });
                                        t.appendChild(f);
                                        var k = this.data.x ? this.$cXI("dps_collapse", {
                                            id: this.target + "-cX-DataExplorerMinimizeImage1",
                                            className: "CanvasXpressBin",
                                            src: "dps_collapse",
                                            srt: "dps_expand",
                                            title: "Collapse Variables and Sample Metadata"
                                        }) : this.$cXI("dps_expand", {
                                            id: this.target + "-cX-DataExplorerMinimizeImage1",
                                            className: "CanvasXpressBin",
                                            srt: "dps_collapse",
                                            src: "dps_expand",
                                            title: "Expand Variables and Sample Metadata"
                                        });
                                        t.appendChild(k);
                                        var b = this.loadDataExplorerMiddlePanel();
                                        t.appendChild(b);
                                        t.appendChild(this.$cX("hr", {
                                            className: "CanvasXpressDataExplorer"
                                        }, {
                                            width: "241px"
                                        }));
                                        var n = this.$cX("span", {
                                            innerHTML: "Rows",
                                            title: "Rows in Data"
                                        }, {
                                            postion: "abosulte",
                                            margin: "5px",
                                            floatCSS: "left",
                                            lineHeight: "32px",
                                            fontWeight: "bold"
                                        });
                                        t.appendChild(n);
                                        var q = this.data.z && !this.data.x ? this.$cXI("dps_collapse", {
                                            id: this.target + "-cX-DataExplorerMinimizeImage2",
                                            className: "CanvasXpressBin",
                                            src: "dps_collapse",
                                            srt: "dps_expand",
                                            title: "Collapse Samples and Variable Metadata"
                                        }) : this.$cXI("dps_expand", {
                                            id: this.target + "-cX-DataExplorerMinimizeImage2",
                                            className: "CanvasXpressBin",
                                            srt: "dps_collapse",
                                            src: "dps_expand",
                                            title: "Expand Samples and Variable Metadata"
                                        });
                                        t.appendChild(q);
                                        var a = this.loadDataExplorerBottomPanel();
                                        t.appendChild(a);
                                        r.appendChild(t);
                                        o.appendChild(r);
                                        this.addRemoveDataExplorerListeners("addEvtListener")
                                    }
                                };
                                this.loadDataExplorerTopPanel = function() {
                                    var l = this.loadFormatDataExplorerDiv();
                                    var f = this.loadLayoutDataExplorerDiv();
                                    var g = this.loadMetadataDataExplorerDiv();
                                    var a = this.loadPropertiesDataExplorerDiv();
                                    var m = this.loadOrientationDataExplorerDiv();
                                    var k = this.loadFileUploadDataExplorerDiv();
                                    var c = this.loadOverlaysDataExplorerDiv();
                                    var e = this.loadThemesDataExplorerDiv();
                                    var i = this.loadGraphTypesDataExplorerDiv();
                                    var j = this.loadAxesDataExplorerDiv();
                                    var d = this.loadSortDataExplorerDiv();
                                    var h = this.loadSummaryDataExplorerDiv();
                                    var b = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerTopPanel",
                                        className: "CanvasXpressDataExplorerPanelOpen"
                                    }, {
                                        display: "block"
                                    });
                                    b.appendChild(l);
                                    b.appendChild(f);
                                    b.appendChild(g);
                                    b.appendChild(this.$cX("br"));
                                    b.appendChild(a);
                                    b.appendChild(m);
                                    b.appendChild(k);
                                    b.appendChild(c);
                                    b.appendChild(e);
                                    b.appendChild(this.$cX("br"));
                                    b.appendChild(i);
                                    b.appendChild(j);
                                    b.appendChild(d);
                                    b.appendChild(h);
                                    b.appendChild(this.$cX("br"));
                                    return b
                                };
                                this.loadDataExplorerMiddlePanel = function() {
                                    var b = this.loadVariablesDataExplorerDiv();
                                    var a = this.loadAnnotationsDataExplorerDiv();
                                    var c = this.$cX("div", {
                                        className: (this.data.x ? "CanvasXpressDataExplorerPanelOpen" : "CanvasXpressDataExplorerPanel")
                                    });
                                    c.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Variables / Data Series"
                                    }));
                                    c.appendChild(this.$cXI("sr_azi", {
                                        id: this.target + "-cX-DataExplorerSortVariables",
                                        className: "CanvasXpressDataExplorer2",
                                        src: "sr_azi",
                                        asr: "sr_zad",
                                        params: this.stringifyJSON(["sortDataExplorer"]),
                                        title: "Sort Variables"
                                    }));
                                    c.appendChild(b);
                                    c.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Sample Metadata"
                                    }));
                                    c.appendChild(this.$cXI("sr_azi", {
                                        id: this.target + "-cX-DataExplorerSortAnnotations",
                                        className: "CanvasXpressDataExplorer2",
                                        src: "sr_azi",
                                        asr: "sr_zad",
                                        params: this.stringifyJSON(["sortDataExplorer"]),
                                        title: "Sort Sample Metadata"
                                    }));
                                    c.appendChild(this.$cX("br"));
                                    c.appendChild(a);
                                    return c
                                };
                                this.loadDataExplorerBottomPanel = function() {
                                    var a = this.loadSamplesDataExplorerDiv();
                                    var c = this.loadDescriptionsDataExplorerDiv();
                                    var b = this.$cX("div", {
                                        className: (!this.data.x && this.data.z ? "CanvasXpressDataExplorerPanelOpen" : "CanvasXpressDataExplorerPanel")
                                    });
                                    b.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Samples"
                                    }));
                                    b.appendChild(this.$cXI("sr_azi", {
                                        id: this.target + "-cX-DataExplorerSortSamples",
                                        className: "CanvasXpressDataExplorer2",
                                        src: "sr_azi",
                                        asr: "sr_zad",
                                        params: this.stringifyJSON(["sortDataExplorer"]),
                                        title: "Sort Samples"
                                    }));
                                    b.appendChild(a);
                                    b.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Variable Metadata"
                                    }));
                                    b.appendChild(this.$cXI("sr_azi", {
                                        id: this.target + "-cX-DataExplorerSortDescriptions",
                                        className: "CanvasXpressDataExplorer2",
                                        src: "sr_azi",
                                        asr: "sr_zad",
                                        params: this.stringifyJSON(["sortDataExplorer"]),
                                        title: "Sort Variable Metadata"
                                    }));
                                    b.appendChild(this.$cX("br"));
                                    b.appendChild(c);
                                    return b
                                };
                                this.loadMainTab = function() {
                                    var a = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerMainTab",
                                        className: "CanvasXpressBinContainerTab"
                                    }, {
                                        width: "36px",
                                        height: "16px",
                                        textAlign: "center",
                                        cssFloat: "left"
                                    });
                                    a.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Main",
                                        title: "Main tab"
                                    }, {
                                        width: "36px",
                                        margin: "0",
                                        cursor: "pointer"
                                    }));
                                    return a
                                };
                                this.loadDOETab = function() {
                                    var a = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerDOETab",
                                        className: "CanvasXpressBinContainerTab"
                                    }, {
                                        width: "36px",
                                        height: "16px",
                                        textAlign: "center",
                                        cssFloat: "left"
                                    });
                                    a.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "DOE",
                                        title: "DOE tab"
                                    }, {
                                        width: "36px",
                                        margin: "0",
                                        cursor: "pointer"
                                    }));
                                    return a
                                };
                                this.loadFormatDataExplorerDiv = function() {
                                    var c = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerFormat",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "76px",
                                        height: "54px",
                                        textAlign: "center",
                                        cssFloat: "left"
                                    });
                                    var b = this.$cXI("dtt_transpose", {
                                        id: this.target + "-cX-DataExplorerTranspose",
                                        className: "CanvasXpressDataExplorer",
                                        src: "dtt_transpose",
                                        params: this.stringifyJSON(["transpose"]),
                                        title: "Toggle to Transpose Data"
                                    }, false, false, 32);
                                    var a = this.$cXI("dtt_pivot", {
                                        id: this.target + "-cX-DataExplorerPivot",
                                        className: "CanvasXpressDataExplorer",
                                        src: "dtt_pivot",
                                        asr: "dtt_pivotremove",
                                        params: this.stringifyJSON(["pivotX"]),
                                        title: "Drag Sample Metadata to Pivot Data"
                                    }, false, false, 32);
                                    c.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Format"
                                    }, {
                                        width: "76px",
                                        margin: "0"
                                    }));
                                    c.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "82px"
                                    }));
                                    c.appendChild(b);
                                    c.appendChild(a);
                                    return c
                                };
                                this.loadLayoutDataExplorerDiv = function() {
                                    var c = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerLayout",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "76px",
                                        height: "54px",
                                        textAlign: "center",
                                        cssFloat: "left"
                                    });
                                    var a = this.$cXI("a_group", {
                                        id: this.target + "-cX-DataExplorerGroupSamples",
                                        className: "CanvasXpressDataExplorer",
                                        src: "a_group",
                                        params: this.stringifyJSON(["groupSamples"]),
                                        title: "Drag Sample Metadata to Group Samples / Click to Reset"
                                    }, false, false, 32);
                                    var b = this.$cXI("ly_segregate", {
                                        id: this.target + "-cX-DataExplorerSegregate",
                                        className: "CanvasXpressDataExplorer",
                                        src: "ly_segregate",
                                        params: this.stringifyJSON(["segregate"]),
                                        title: "Drag Sample Metadata to Segregate Data / Click to Reset"
                                    }, false, false, 32);
                                    c.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Layout"
                                    }, {
                                        width: "76px",
                                        margin: "0"
                                    }));
                                    c.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "82px"
                                    }));
                                    c.appendChild(a);
                                    c.appendChild(b);
                                    return c
                                };
                                this.loadMetadataDataExplorerDiv = function() {
                                    var a = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerMetadata",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "40px",
                                        height: "54px",
                                        textAlign: "center",
                                        cssFloat: "left"
                                    });
                                    var b = this.$cXI("ly_doe", {
                                        id: this.target + "-cX-DataExplorerDOE",
                                        className: "CanvasXpressDataExplorer",
                                        src: "ly_doe",
                                        params: this.stringifyJSON(["createDOE"]),
                                        title: "Toggle to Explore Meta Data"
                                    }, false, false, 32);
                                    a.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "DOE"
                                    }, {
                                        width: "40px",
                                        margin: "0"
                                    }));
                                    a.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "46px"
                                    }));
                                    a.appendChild(b);
                                    return a
                                };
                                this.loadPropertiesDataExplorerDiv = function() {
                                    var a = ["at_col", "at_shp", "at_sze", "at_pat", "bx_connect", "g_stacked"];
                                    var b = ["Color", "Shape", "Size", "Pattern", "Connect", "Stack"];
                                    var d = ["colorBy", "shapeBy", "sizeBy", "patternBy", "connectBy", "stackBy"];
                                    var e = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerProperties",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "76px",
                                        height: "135px",
                                        textAlign: "center",
                                        cssFloat: "left"
                                    });
                                    e.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Properties"
                                    }, {
                                        width: "76px",
                                        margin: "0"
                                    }));
                                    e.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "82px"
                                    }));
                                    for (var c = 0; c < a.length; c++) {
                                        e.appendChild(this.$cXI(a[c], {
                                            id: this.target + "-cX-DataExplorer" + b[c],
                                            className: "CanvasXpressDataExplorer",
                                            src: a[c],
                                            params: this.stringifyJSON([d[c]]),
                                            title: "Drag Metadata to Change " + b[c] + " of Data / Click to Reset"
                                        }, false, false, 32))
                                    }
                                    return e
                                };
                                this.loadOrientationDataExplorerDiv = function() {
                                    var b = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerOrientation",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "76px",
                                        height: "54px",
                                        textAlign: "center",
                                        cssFloat: "left",
                                        display: (this.graphType.match(/Scatter/) ? "none" : "block")
                                    });
                                    var a = this.$cXI("gc_govertical", {
                                        id: this.target + "-cX-DataExplorerVertical",
                                        className: "CanvasXpressDataExplorer",
                                        src: "gc_govertical",
                                        params: this.stringifyJSON(["changeAttribute", ["graphOrientation", "vertical"]]),
                                        title: "Click to change Orientation to Vertical Graph"
                                    }, false, false, 32);
                                    var c = this.$cXI("gc_gohorizontal", {
                                        id: this.target + "-cX-DataExplorerHorizontal",
                                        className: "CanvasXpressDataExplorer",
                                        src: "gc_gohorizontal",
                                        params: this.stringifyJSON(["changeAttribute", ["graphOrientation", "horizontal"]]),
                                        title: "Click to change Orientation to Horizontal Graph"
                                    }, false, false, 32);
                                    b.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Orientation",
                                        margin: "0"
                                    }, {
                                        width: "76px"
                                    }));
                                    b.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "82px"
                                    }));
                                    b.appendChild(a);
                                    b.appendChild(c);
                                    return b
                                };
                                this.loadFileUploadDataExplorerDiv = function() {
                                    var a = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerFileUpload",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "40px",
                                        height: "54px",
                                        textAlign: "center",
                                        cssFloat: "left"
                                    });
                                    var b = this.$cX("input", {
                                        id: this.target + "-cX-DataExplorerFileUploader",
                                        type: "file"
                                    }, {
                                        display: "none"
                                    });
                                    var c = this.$cXI("cd_upload", {
                                        id: this.target + "-cX-DataExplorerLoadFile",
                                        className: "CanvasXpressDataExplorer",
                                        src: "cd_upload",
                                        params: this.stringifyJSON(["fileUpload"]),
                                        title: "Click icon to upload new data file"
                                    }, false, false, 32);
                                    a.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "File"
                                    }, {
                                        width: "40px",
                                        margin: "0"
                                    }));
                                    a.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "46px"
                                    }));
                                    a.appendChild(c);
                                    a.appendChild(b);
                                    return a
                                };
                                this.loadOverlaysDataExplorerDiv = function() {
                                    var b = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerOverlays",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "51px",
                                        height: "67px",
                                        textAlign: "center",
                                        cssFloat: "none",
                                        position: "absolute",
                                        top: "169px",
                                        left: "93px",
                                        display: (this.graphType.match(/Scatter/) ? "none" : "block")
                                    });
                                    var a = this.$cXI("o_g1", {
                                        id: this.target + "-cX-DataExplorerOverlay",
                                        className: "CanvasXpressDataExplorer3",
                                        src: "o_g1",
                                        params: this.stringifyJSON(["overlays"]),
                                        title: "Drag Sample Metadata to Add Overlays"
                                    }, false, false, 32);
                                    a.style.setProperty("margin-top", "10px", "important");
                                    b.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Overlays"
                                    }, {
                                        width: "51px",
                                        margin: "0"
                                    }));
                                    b.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "58px",
                                        marginBottom: "5px"
                                    }));
                                    b.appendChild(a);
                                    return b
                                };
                                this.loadThemesDataExplorerDiv = function() {
                                    var b = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerThemes",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "65px",
                                        height: "67px",
                                        textAlign: "center",
                                        cssFloat: "none",
                                        position: "absolute",
                                        top: "169px",
                                        left: "158px"
                                    });
                                    var e = ["c_canvasxpress", "c_excel", "c_ggplot", "c_paultol", "c_solarized", "c_stata", "c_tableau", "c_economist", "c_wallstreetjournal", "dummy"];
                                    var g = ["CanvasXpress", "Excel", "GGPlot", "Paul Tol", "Solarized", "Stata", "Tableau", "The Economist", "Wall Street Journal", "None"];
                                    var j = ["cx", "excel", "ggplot", "paulTol", "solarized", "stata", "tableau", "economist", "wallStreetJournal", "none"];
                                    var c = [];
                                    for (var d = 0; d < e.length; d++) {
                                        var h = this.$cXI(e[d], {
                                            className: "CanvasXpressCarousel",
                                            src: e[d],
                                            title: "Click to Change Color Theme to " + g[d],
                                            theme: j[d]
                                        }, {
                                            width: "24px",
                                            height: "24px",
                                            padding: "1px",
                                            margin: "1px 0px 0px 0px",
                                            background: "rgba(0,0,0,0)",
                                            border: "0 none",
                                            boxShadow: "0 0 10px rgba(0,0,0,0)"
                                        }, false, false, 32);
                                        c.push(h)
                                    }
                                    var k = this.createCarousel(c, 28, 28, 64, 4, "horizontal", {
                                        margin: "5px 14px 3px 16px"
                                    });
                                    var f = this.$cX("span", {
                                        className: "CanvasXpressCarousel",
                                        title: "Previous",
                                        innerHTML: "<",
                                        trgId: k.id
                                    }, {
                                        top: "57px",
                                        left: "2px"
                                    });
                                    var a = this.$cX("span", {
                                        className: "CanvasXpressCarousel",
                                        title: "Next",
                                        innerHTML: ">",
                                        trgId: k.id
                                    }, {
                                        top: "57px",
                                        left: "58px"
                                    });
                                    b.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Theme"
                                    }, {
                                        width: "65px",
                                        margin: "0"
                                    }));
                                    b.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "72px"
                                    }));
                                    b.appendChild(k);
                                    b.appendChild(f);
                                    b.appendChild(a);
                                    return b
                                };
                                this.loadGraphTypesDataExplorerDiv = function() {
                                    var a = ["g_area", "g_bar", "g_boxplot", "g_correlation", "g_circular", "g_heatmap", "g_dotplot", "g_line", "g_pie", "g_scatter2d", "g_scatterbubble2d", "g_scatter3d", "g_stacked", "g_stackedpercent", "g_tagcloud", "g_treemap"];
                                    var b = ["Area", "Bar", "Boxplot", "Correlation", "Circular", "Heatmap", "Dotplot", "Line", "Pie", "Scatter 2D", "Scatter Bubble 2D", "Scatter 3D", "Stacked", "Stacked Percent", "Tag Cloud", "Treemap"];
                                    var d = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerGraphs",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "152px",
                                        height: "168px",
                                        textAlign: "center",
                                        cssFloat: "left",
                                        marginBottom: "6px"
                                    });
                                    d.appendChild(this.$cX("span", {
                                        id: this.target + "-cX-DataExplorerGraphTypes",
                                        className: "CanvasXpressBin",
                                        innerHTML: "Graph Types ...",
                                        title: "Click to See Additional Graph Types",
                                        fun: "getGraphTypeMenu",
                                        par: [],
                                        mid: this.newId("-cX-DataExplorer-Menu-")
                                    }, {
                                        width: "132px",
                                        cursor: "pointer",
                                        margin: "0"
                                    }));
                                    d.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "158px"
                                    }));
                                    for (var c = 0; c < a.length; c++) {
                                        var e = b[c].replace(/\s/g, "");
                                        d.appendChild(this.$cXI(a[c], {
                                            id: this.target + "-cX-DataExplorer" + e,
                                            className: "CanvasXpressDataExplorer",
                                            src: a[c],
                                            params: this.stringifyJSON(["changeAttribute", ["graphType", e]]),
                                            title: "Clcik to Change Graph Type to " + b[c]
                                        }, false, false, 32))
                                    }
                                    return d
                                };
                                this.loadAxesDataExplorerDiv = function() {
                                    var b = ["p_g2axisx", "p_g2axisy", "p_g3axisz"];
                                    var c = ["x", "y", "z"];
                                    var e = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerAxes",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "54px",
                                        height: "168px",
                                        textAlign: "center",
                                        cssFloat: "left",
                                        marginBottom: "6px",
                                        display: (this.graphType.match(/Scatter/) ? "block" : "none")
                                    });
                                    e.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Axes"
                                    }, {
                                        width: "54px",
                                        margin: "0"
                                    }));
                                    e.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "60px"
                                    }));
                                    for (var d = 0; d < b.length; d++) {
                                        var a = c[d].toUpperCase();
                                        e.appendChild(this.$cXI(b[d], {
                                            id: this.target + "-cX-DataExplorer" + a + "Axis",
                                            className: "CanvasXpressDataExplorer",
                                            src: b[d],
                                            params: this.stringifyJSON(["addToAxis", [c[d] + "Axis"]]),
                                            title: "Drag Sample to change the " + a + "-Axis"
                                        }, false, false, 29));
                                        e.appendChild(this.$cXI("ch_olin", {
                                            id: this.target + "-cX-DataExplorerLinLog" + a + "Axis",
                                            className: "CanvasXpressDataExplorer4",
                                            src: (this[c[d] + "AxisTransform"] && this[c[d] + "AxisTransform"].match("log") ? "ch_olog" : "ch_olin"),
                                            srt: (this[c[d] + "AxisTransform"] && this[c[d] + "AxisTransform"].match("log") ? "ch_olin" : "ch_olog"),
                                            params: this.stringifyJSON(["linLog", [c[d] + "Axis"]]),
                                            title: "Click to Toggle " + a + "-Axis Lin / Log"
                                        }, {
                                            width: "13px",
                                            height: "13px"
                                        }, false, false, 29))
                                    }
                                    e.appendChild(this.$cXI("at_motion", {
                                        id: this.target + "-cX-DataExplorerMotion",
                                        className: "CanvasXpressDataExplorer",
                                        src: "at_motion",
                                        params: this.stringifyJSON(["motion"]),
                                        title: "Drag Sample to Filter By Motion"
                                    }, false, false, 32));
                                    return e
                                };
                                this.loadSortDataExplorerDiv = function() {
                                    var d = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerSort",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "54px",
                                        height: "168px",
                                        textAlign: "center",
                                        cssFloat: "left",
                                        marginBottom: "6px",
                                        display: (this.graphType.match(/Scatter/) ? "none" : "block")
                                    });
                                    var c = this.$cXI("sr_zad", {
                                        id: this.target + "-cX-DataExplorerDataSortDir",
                                        className: "CanvasXpressDataExplorer",
                                        src: (this.sortDir == "ascending" ? "sr_zad" : "sr_azi"),
                                        srt: (this.sortDir == "ascending" ? "sr_azi" : "sr_zad"),
                                        params: this.stringifyJSON(["sortDir"]),
                                        title: "Clcik to Sort Direction"
                                    }, false, false, 32);
                                    var a = this.$cXI("ch_oaa", {
                                        id: this.target + "-cX-DataExplorerDataSortCase",
                                        className: "CanvasXpressDataExplorer",
                                        src: "ch_oaa",
                                        params: this.stringifyJSON(["sortCase"]),
                                        title: "Click to Sort Case"
                                    }, false, false, 32);
                                    var b = this.$cXI("ch_lv", {
                                        id: this.target + "-cX-DataExplorerDataSortVariables",
                                        className: "CanvasXpressDataExplorer",
                                        src: "ch_lv",
                                        params: this.stringifyJSON(["sortVariables"]),
                                        title: "Click to Sort Variables"
                                    }, false, false, 32);
                                    var e = this.$cXI("ch_ls", {
                                        id: this.target + "-cX-DataExplorerDataSortSamples",
                                        className: "CanvasXpressDataExplorer",
                                        src: "ch_ls",
                                        params: this.stringifyJSON(["sortSamples"]),
                                        title: "Click to Sort Samples"
                                    }, false, false, 32);
                                    d.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Sort"
                                    }, {
                                        width: "54px",
                                        margin: "0"
                                    }));
                                    d.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "60px"
                                    }));
                                    d.appendChild(c);
                                    d.appendChild(a);
                                    d.appendChild(b);
                                    d.appendChild(e);
                                    return d
                                };
                                this.loadSummaryDataExplorerDiv = function() {
                                    var b = ["ch_omean", "dtp_max", "dtp_min", "ch_ssum", "dtp_count"];
                                    var d = ["mean", "max", "min", "sum", "count"];
                                    var c = this.$cX("div", {
                                        id: this.target + "-cX-DataExplorerSummary",
                                        className: "CanvasXpressDataExplorer"
                                    }, {
                                        width: "220px",
                                        height: "54px",
                                        textAlign: "center",
                                        cssFloat: "left",
                                        display: (this.graphType.match(/Scatter/) ? "none" : "block")
                                    });
                                    c.appendChild(this.$cX("span", {
                                        className: "CanvasXpressBin",
                                        innerHTML: "Grouping Summary",
                                        margin: "0"
                                    }));
                                    c.appendChild(this.$cX("hr", {
                                        className: "CanvasXpressDataExplorer for Groups"
                                    }));
                                    for (var e = 0; e < b.length; e++) {
                                        var a = d[e].toUpperCase();
                                        c.appendChild(this.$cXI(b[e], {
                                            id: this.target + "-cX-DataExplorer" + a,
                                            className: "CanvasXpressDataExplorer",
                                            src: b[e],
                                            params: this.stringifyJSON(["changeAttribute", ["summaryType", d[e]]]),
                                            title: "Click to Select " + a + " Value for Groups"
                                        }, false, false, 32))
                                    }
                                    return c
                                };
                                this.updateDataExplorerContainerPopulation = function(b) {
                                    var f = [];
                                    var d = b.firstChild;
                                    var a = 0;
                                    for (var e = 0; e < d.childNodes.length; e++) {
                                        var g = d.childNodes[e];
                                        f.push([g.offsetLeft - b.offsetLeft, g.offsetTop - b.offsetTop, g.textContent]);
                                        if (g.offsetTop - b.offsetTop < b.clientHeight) {
                                            a = e
                                        }
                                    }
                                    while (d.childNodes[a + 1]) {
                                        d.removeChild(d.childNodes[a + 1])
                                    }
                                    if (f.length) {
                                        d.style.height = (f[f.length - 1][1] + 31) + "px"
                                    } else {
                                        d.style.height = b.style.height
                                    }
                                    b.population = f
                                };
                                this.minimizeDataExplorerContainer = function(b) {
                                    var h = window.document;
                                    var g = [];
                                    b.style.visibility = "hidden";
                                    h.body.appendChild(b);
                                    var e = b.firstChild;
                                    var a = 0;
                                    for (var f = 0; f < e.childNodes.length; f++) {
                                        var j = e.childNodes[f];
                                        g.push([j.offsetLeft - b.offsetLeft, j.offsetTop - b.offsetTop, j.textContent]);
                                        if (j.offsetTop - b.offsetTop < b.clientHeight) {
                                            a = f
                                        }
                                    }
                                    while (e.childNodes[a + 1]) {
                                        e.removeChild(e.childNodes[a + 1])
                                    }
                                    if (g.length) {
                                        e.style.height = (g[g.length - 1][1] + 31) + "px"
                                    } else {
                                        e.style.height = b.style.height
                                    }
                                    b.population = g;
                                    h.body.removeChild(b);
                                    b.style.visibility = "visible";
                                    return b
                                };
                                this.removeEntriesDataExplorerContainer = function(b) {
                                    var a, f, c;
                                    for (var d = 0; d < b.childNodes.length; d++) {
                                        var e = b.childNodes[d];
                                        if (d == 0) {
                                            a = e.type;
                                            f = e.params
                                        }
                                        this.addRemoveEvtListener("removeEvtListener", e, "dragstart", this.dragStartDataExplorer, false);
                                        this.addRemoveEvtListener("removeEvtListener", e, "dragend", this.dragEndDataExplorer, false);
                                        if (e.type == "vars" || e.type == "smps" || e.type == "x" || e.type == "z") {
                                            if (d == 0) {
                                                c = this.meta.data[e.type]
                                            }
                                            this.addRemoveEvtListener("removeEvtListener", e, "dblclick", this.dataExplorerDblclick, false)
                                        }
                                    }
                                    while (b.childNodes.length) {
                                        b.removeChild(b.childNodes[0])
                                    }
                                    return {
                                        type: a,
                                        params: f,
                                        meta: c
                                    }
                                };
                                this.addEntriesDataExplorerContainer = function(q, m, f, l, k) {
                                    var j = 0;
                                    var b = [];
                                    for (var g = 0; g < l.length; g++) {
                                        var h = l[g][2];
                                        var e = this.$cX("img", {
                                            id: this.target + "-cX-DataExplorerEntriesImage-" + h,
                                            src: CanvasXpress.png,
                                            className: "CanvasXpressDataExplorerMask"
                                        });
                                        var d = this.$cX("span", {
                                            id: this.target + "-cX-DataExplorerEntries-" + h,
                                            innerHTML: h,
                                            className: "CanvasXpressDataExplorerNumeric draggable",
                                            type: f.type,
                                            numeric: true,
                                            params: f.params,
                                            draggable: true,
                                            spellcheck: false
                                        });
                                        if (f.meta) {
                                            d.className = f.meta[h].unique ? "CanvasXpressDataExplorerUnique draggable" : f.meta[h].type == "String" ? "CanvasXpressDataExplorerString draggable" : "CanvasXpressDataExplorerNumeric draggable";
                                            d.unique = f.meta[h].unique;
                                            d.numeric = f.meta[h].type == "String" ? false : true;
                                            if (f.meta[h].unique) {
                                                d.alt = "Double-click to convert to Id";
                                                d.title = "Double-click to convert to Id"
                                            }
                                        }
                                        d.appendChild(e);
                                        m.appendChild(d);
                                        if (!k) {
                                            b.push([d.offsetLeft - q.offsetLeft, d.offsetTop - q.offsetTop, d.textContent]);
                                            if (d.offsetTop - q.offsetTop < q.clientHeight) {
                                                j = g
                                            }
                                        } else {
                                            d.style.top = (l[0][1] - 7) + "px"
                                        }
                                    }
                                    if (!k) {
                                        while (m.childNodes[j + 1]) {
                                            m.removeChild(m.childNodes[j + 1])
                                        }
                                    }
                                    for (var g = 0; g < m.childNodes.length; g++) {
                                        var c = m.childNodes[g];
                                        this.addRemoveEvtListener("addEvtListener", c, "dragstart", this.dragStartDataExplorer, false);
                                        this.addRemoveEvtListener("addEvtListener", c, "dragend", this.dragEndDataExplorer, false);
                                        if (c.type == "vars" || c.type == "smps" || c.type == "x" || c.type == "z") {
                                            this.addRemoveEvtListener("addEvtListener", c, "dblclick", this.dataExplorerDblclick, false)
                                        }
                                    }
                                    return b
                                };
                                this.loadVariablesDataExplorerDiv = function(b, a) {
                                    var c = this.$(this.target + "-cX-DataExplorerVariables");
                                    if (!c) {
                                        c = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerVariables",
                                            className: "CanvasXpressDataExplorer",
                                            type: "vars"
                                        }, {
                                            width: "220px",
                                            height: "58px",
                                            overflowY: "auto",
                                            overflowX: "hidden"
                                        })
                                    }
                                    if (!b) {
                                        b = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerVariables-Mask"
                                        }, {
                                            width: "220px"
                                        })
                                    }
                                    for (var d = 0; d < Math.min(this.data.y.vars.length, this.maxDataExplorerEntries); d++) {
                                        var f = this.$cX("img", {
                                            id: this.target + "-cX-DataExplorerVariablesImage-" + this.data.y.vars[d],
                                            src: CanvasXpress.png,
                                            className: "CanvasXpressDataExplorerMask"
                                        });
                                        var e = this.$cX("span", {
                                            id: this.target + "-cX-DataExplorerVariables-" + this.data.y.vars[d],
                                            innerHTML: this.data.y.vars[d],
                                            className: "CanvasXpressDataExplorerNumeric draggable",
                                            type: "vars",
                                            numeric: true,
                                            params: ["switchVarToAnnotation"],
                                            draggable: true,
                                            spellcheck: false
                                        });
                                        e.appendChild(f);
                                        b.appendChild(e)
                                    }
                                    c.appendChild(b);
                                    if (!a) {
                                        return this.minimizeDataExplorerContainer(c)
                                    }
                                };
                                this.loadSamplesDataExplorerDiv = function(b, a) {
                                    var d = this.$(this.target + "-cX-DataExplorerSamples");
                                    if (!d) {
                                        d = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerSamples",
                                            className: "CanvasXpressDataExplorer",
                                            type: "smps"
                                        }, {
                                            width: "220px",
                                            height: "58px",
                                            overflowY: "auto",
                                            overflowX: "hidden"
                                        })
                                    }
                                    if (!b) {
                                        b = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerSamples-Mask"
                                        }, {
                                            width: "220px"
                                        })
                                    }
                                    for (var c = 0; c < Math.min(this.data.y.smps.length, this.maxDataExplorerEntries); c++) {
                                        var f = this.$cX("img", {
                                            id: this.target + "-cX-DataExplorerSamplesImage-" + this.data.y.smps[c],
                                            src: CanvasXpress.png,
                                            className: "CanvasXpressDataExplorerMask"
                                        });
                                        var e = this.$cX("span", {
                                            id: this.target + "-cX-DataExplorerSamples-" + this.data.y.smps[c],
                                            innerHTML: this.data.y.smps[c],
                                            className: "CanvasXpressDataExplorerNumeric draggable",
                                            type: "smps",
                                            numeric: true,
                                            params: ["switchSmpToAnnotation"],
                                            draggable: true,
                                            spellcheck: false
                                        });
                                        e.appendChild(f);
                                        b.appendChild(e)
                                    }
                                    d.appendChild(b);
                                    if (!a) {
                                        return this.minimizeDataExplorerContainer(d)
                                    }
                                };
                                this.loadAnnotationsDataExplorerDiv = function(c, b) {
                                    var e = this.meta.data.x;
                                    var a = this.$(this.target + "-cX-DataExplorerAnnotations");
                                    if (!a) {
                                        a = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerAnnotations",
                                            className: "CanvasXpressDataExplorer",
                                            type: "x"
                                        }, {
                                            width: "220px",
                                            height: "58px",
                                            overflowY: "auto",
                                            overflowX: "hidden"
                                        })
                                    }
                                    if (!c) {
                                        c = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerAnnotations-Mask"
                                        }, {
                                            width: "220px"
                                        })
                                    }
                                    if (this.data.x) {
                                        for (var f in this.data.x) {
                                            var d = e[f].unique ? "CanvasXpressDataExplorerUnique draggable" : e[f].type == "String" ? "CanvasXpressDataExplorerString draggable" : "CanvasXpressDataExplorerNumeric draggable";
                                            var h = this.$cX("img", {
                                                id: this.target + "-cX-DataExplorerAnnotationsImage-" + f,
                                                src: CanvasXpress.png,
                                                className: "CanvasXpressDataExplorerMask"
                                            });
                                            var g = this.$cX("span", {
                                                id: this.target + "-cX-DataExplorerAnnotations-" + f,
                                                innerHTML: f,
                                                className: d,
                                                type: "x",
                                                unique: e[f].unique,
                                                numeric: e[f].type == "String" ? false : true,
                                                params: ["switchAnnotationToVar"],
                                                draggable: true,
                                                spellcheck: false
                                            });
                                            if (e[f].unique) {
                                                g.alt = "Double-click to convert to Id";
                                                g.title = "Double-click to convert to Id"
                                            }
                                            g.appendChild(h);
                                            c.appendChild(g)
                                        }
                                    }
                                    a.appendChild(c);
                                    if (!b) {
                                        return this.minimizeDataExplorerContainer(a)
                                    }
                                };
                                this.loadDescriptionsDataExplorerDiv = function(b, a) {
                                    var d = this.meta.data.z;
                                    var g = this.$(this.target + "-cX-DataExplorerDescriptions");
                                    if (!g) {
                                        g = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerDescriptions",
                                            className: "CanvasXpressDataExplorer",
                                            type: "z"
                                        }, {
                                            width: "220px",
                                            height: "58px",
                                            overflowY: "auto",
                                            overflowX: "hidden"
                                        })
                                    }
                                    if (!b) {
                                        b = this.$cX("div", {
                                            id: this.target + "-cX-DataExplorerDescriptions-Mask"
                                        }, {
                                            width: "220px"
                                        })
                                    }
                                    if (this.data.z) {
                                        for (var e in this.data.z) {
                                            var c = d[e].unique ? "CanvasXpressDataExplorerUnique draggable" : d[e].type == "String" ? "CanvasXpressDataExplorerString draggable" : "CanvasXpressDataExplorerNumeric draggable";
                                            var h = this.$cX("img", {
                                                id: this.target + "-cX-DataExplorerDescriptionsImage-" + e,
                                                src: CanvasXpress.png,
                                                className: "CanvasXpressDataExplorerMask"
                                            });
                                            var f = this.$cX("span", {
                                                id: this.target + "-cX-DataExplorerDescriptions-" + e,
                                                innerHTML: e,
                                                className: c,
                                                type: "z",
                                                unique: d[e].unique,
                                                numeric: d[e].type == "String" ? false : true,
                                                params: ["switchAnnotationToSmp"],
                                                draggable: true,
                                                spellcheck: false
                                            });
                                            if (d[e].unique) {
                                                f.alt = "Double-click to convert to Id";
                                                f.title = "Double-click to convert to Id"
                                            }
                                            f.appendChild(h);
                                            b.appendChild(f)
                                        }
                                    }
                                    g.appendChild(b);
                                    if (!a) {
                                        return this.minimizeDataExplorerContainer(g)
                                    }
                                };
                                this.addRemoveDataExplorerListeners = function(w) {
                                    var J = this.$(this.target + "-cX-DataExplorerFormat");
                                    var B = this.$(this.target + "-cX-DataExplorerMetadata");
                                    var L = this.$(this.target + "-cX-DataExplorerOrientation");
                                    var k = this.$(this.target + "-cX-DataExplorerFileUpload");
                                    var n = this.$(this.target + "-cX-DataExplorerOverlays");
                                    var b = this.$(this.target + "-cX-DataExplorerThemes");
                                    var I = this.$(this.target + "-cX-DataExplorerGraphs");
                                    var M = this.graphType.match(/Scatter/) ? this.$(this.target + "-cX-DataExplorerAxes") : false;
                                    var F = this.graphType.match(/Scatter/) ? false : this.$(this.target + "-cX-DataExplorerSort");
                                    var K = this.$(this.target + "-cX-DataExplorerSummary");
                                    var D = this.$(this.target + "-cX-DataExplorerLayout");
                                    var A = this.$(this.target + "-cX-DataExplorerProperties");
                                    var u = this.$(this.target + "-cX-DataExplorerVariables-Mask");
                                    var E = this.$(this.target + "-cX-DataExplorerSortVariables");
                                    var y = this.$(this.target + "-cX-DataExplorerSamples-Mask");
                                    var C = this.$(this.target + "-cX-DataExplorerSortSamples");
                                    var r = this.$(this.target + "-cX-DataExplorerAnnotations-Mask");
                                    var q = this.$(this.target + "-cX-DataExplorerSortAnnotations");
                                    var o = this.$(this.target + "-cX-DataExplorerDescriptions-Mask");
                                    var e = this.$(this.target + "-cX-DataExplorerSortDescriptions");
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerMinimizeImage1"), "click", this.collapseExpandDataExplorerPanel, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerMinimizeImage2"), "click", this.collapseExpandDataExplorerPanel, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorer"), "mousedown", this.registerMousemove, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerCustomizeImage"), "click", this.addCustomToolbarMenu, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerGraphTypes"), "click", this.addCustomToolbarMenu, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerMainTab"), "click", this.clickDataExplorerMain, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerDOETab"), "click", this.clickDataExplorerDOE, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerDataTableImage"), "click", this.clickDataTable, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerDataFilterImage"), "click", this.clickDataFilters, false);
                                    this.addRemoveEvtListener(w, this.$(this.target + "-cX-DataExplorerCloseImage"), "click", this.closeDataExplorer, false);
                                    if (b) {
                                        var h = b.getElementsByTagName("span");
                                        for (var H = 0; H < h.length; H++) {
                                            if (h[H].trgId) {
                                                this[w](h[H], "click", this.clickDataExplorerCarousel, false);
                                                h[H].click()
                                            }
                                        }
                                        h = b.getElementsByTagName("svg");
                                        for (var H = 0; H < h.length; H++) {
                                            if (h[H].getAttribute("theme")) {
                                                this[w](h[H], "click", this.clickDataExplorerTheme, false)
                                            }
                                        }
                                    }
                                    var h = [J, B, L, k, I, K];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            this.addRemoveEvtListener(w, h[H], "click", this.dataExplorerClick, false);
                                            if (h[H].id == this.target + "-cX-DataExplorerFileUpload") {
                                                this[w](h[H].childNodes[3], "change", this.loadFile, false)
                                            }
                                        }
                                    }
                                    var h = [u, y, r, o];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            this.addRemoveEvtListener(w, h[H].parentNode, "scroll", this.scrollDataExplorer, false)
                                        }
                                    }
                                    var h = [J, n, M, F, D, A, u, y, r, o];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            if (h[H].id == this.target + "-cX-DataExplorerTranspose") {
                                                continue
                                            }
                                            if (h[H].id == this.target + "-cX-DataExplorerDataSortDir") {
                                                continue
                                            }
                                            if (h[H].id == this.target + "-cX-DataExplorerDataSortCase") {
                                                continue
                                            }
                                            this.addRemoveEvtListener(w, h[H], "drop", this.dropDataExplorer, false);
                                            this.addRemoveEvtListener(w, h[H], "dragover", this.dragOverDataExplorer, false);
                                            this.addRemoveEvtListener(w, h[H], "dragenter", this.dragEnterDataExplorer, false);
                                            this.addRemoveEvtListener(w, h[H], "dragleave", this.dragLeaveDataExplorer, false);
                                            for (var G = 0; G < h[H].childNodes.length; G++) {
                                                var c = h[H].childNodes[G];
                                                if (c.tagName == "SPAN" && c.childNodes.length && c.lastChild.tagName && c.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                    this.addRemoveEvtListener(w, c, "dragstart", this.dragStartDataExplorer, false);
                                                    this.addRemoveEvtListener(w, c, "dragend", this.dragEndDataExplorer, false);
                                                    this.addRemoveEvtListener(w, c, "dblclick", this.dblclickDataExplorer, false)
                                                }
                                            }
                                        }
                                    }
                                    var h = [u, y, r, o];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            for (var G = 0; G < h[H].childNodes.length; G++) {
                                                var c = h[H].childNodes[G];
                                                if (c.tagName == "SPAN" && c.childNodes.length && c.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                    this.addRemoveEvtListener(w, c, "dblclick", this.dataExplorerDblclick, false)
                                                }
                                            }
                                        }
                                    }
                                    var h = [n, D, A];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            this.addRemoveEvtListener(w, h[H], "click", this.dataExplorerClickReset, false)
                                        }
                                    }
                                    var h = [F];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            this.addRemoveEvtListener(w, h[H], "click", this.dataExplorerClickDataSort, false)
                                        }
                                    }
                                    var h = [E, C, q, e];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            this.addRemoveEvtListener(w, h[H], "click", this.dataExplorerClickSort, false)
                                        }
                                    }
                                    var h = [M];
                                    for (var H = 0; H < h.length; H++) {
                                        if (h[H]) {
                                            for (var G = 0; G < h[H].childNodes.length; G++) {
                                                var c = h[H].childNodes[G];
                                                if (c.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                    if (c.id.match(/LinLog/)) {
                                                        this.addRemoveEvtListener(w, c, "click", this.dataExplorerClickLinLog, false)
                                                    } else {
                                                        this.addRemoveEvtListener(w, c, "click", this.dataExplorerClickReset, false)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.clickDataExplorerMain = function(a) {
                                    return function(c) {
                                        var b = a.$(a.target + "-cX-DataExplorerTopPanel");
                                        if (b) {
                                            b.style.display = "block"
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickDataExplorerDOE = function(a) {
                                    return function(c) {
                                        var b = a.$(a.target + "-cX-DataExplorerTopPanel");
                                        if (b) {
                                            b.style.display = "none"
                                        }
                                        return false
                                    }
                                }(this);
                                this.scrollDataExplorer = function(a) {
                                    return function(r) {
                                        var d = a.getTargetEvent(r);
                                        var f = d.population;
                                        var k = d.firstChild;
                                        var u = d.scrollTop;
                                        var v = k.firstChild;
                                        var t = [];
                                        var l = null;
                                        for (var n = 0; n < f.length; n++) {
                                            if (f[n][1] > u && f[n][1] < d.clientHeight + u) {
                                                if (l == null) {
                                                    l = n
                                                }
                                                t.push(f[n])
                                            } else {
                                                if (f[n][1] > u + v.scrollHeight) {
                                                    break
                                                }
                                            }
                                        }
                                        if (t[0][2] == v.textContent) {
                                            return false
                                        } else {
                                            if (l > 0) {
                                                l--;
                                                for (var n = 0; n < 2; n++) {
                                                    if (l >= 0 && f[l]) {
                                                        var q = f[l][1];
                                                        while (f[l] && f[l][1] == q && l >= 0) {
                                                            t.unshift(f[l]);
                                                            l--
                                                        }
                                                    }
                                                }
                                            }
                                            var g = a.removeEntriesDataExplorerContainer(k);
                                            a.addEntriesDataExplorerContainer(d, k, g, t, true)
                                        }
                                        return false
                                    }
                                }(this);
                                this.collapseExpandDataExplorerPanel = function(a) {
                                    return function(f) {
                                        var b = a.getTargetEvent(f);
                                        var d = b.nextElementSibling;
                                        var c = b.getAttribute("title");
                                        if (c.match("Collapse")) {
                                            b.setAttribute("title", c.replace("Collapse", "Expand"));
                                            d.className = "CanvasXpressDataExplorerPanel"
                                        } else {
                                            b.setAttribute("title", c.replace("Expand", "Collapse"));
                                            d.className = "CanvasXpressDataExplorerPanelOpen"
                                        }
                                        var g = b.getAttribute("src");
                                        b.setAttribute("src", b.getAttribute("srt"));
                                        b.setAttribute("srt", g);
                                        a.$cXIU(b, b.getAttribute("src"), {
                                            title: b.getAttribute("title")
                                        });
                                        return false
                                    }
                                }(this);
                                this.dragStartDataExplorer = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c).parentNode;
                                        b.style.opacity = "0.3";
                                        c.dataTransfer.setDragImage(b, 0, 0);
                                        c.dataTransfer.setData("text", b.id);
                                        return false
                                    }
                                }(this);
                                this.resetDataExplorerDivs = function(b) {
                                    var e = ["Variables", "Annotations", "Samples", "Descriptions"];
                                    for (var a = 0; a < e.length; a++) {
                                        var c = this.$(this.target + "-cX-DataExplorer" + e[a]);
                                        if (c) {
                                            c.className = "CanvasXpressDataExplorer"
                                        }
                                    }
                                };
                                this.dragEnterDataExplorer = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        if (b.parentNode.tagName == "SPAN") {
                                            b = b.parentNode
                                        }
                                        if (b.tagName.toUpperCase().match(/SVG/)) {
                                            if (b.parentNode.id.match(/-Mask$/)) {
                                                b.parentNode.parentNode.className = "CanvasXpressDataExplorerActive"
                                            } else {
                                                b.setAttribute("class", "CanvasXpressDataExplorerActive")
                                            }
                                        } else {
                                            if (b.tagName == "SPAN" && b.parentNode.lastChild && !b.parentNode.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                if (b.parentNode.id.match(/-Mask$/)) {
                                                    b.parentNode.parentNode.className = "CanvasXpressDataExplorerActive"
                                                } else {
                                                    b.parentNode.className = "CanvasXpressDataExplorerActive"
                                                }
                                            } else {
                                                if (b.tagName == "SPAN" && b.parentNode.lastChild && b.parentNode.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                    if (b.parentNode.id.match(/-Mask$/)) {
                                                        b.parentNode.parentNode.className = "CanvasXpressDataExplorer"
                                                    } else {
                                                        b.parentNode.className = "CanvasXpressDataExplorer"
                                                    }
                                                } else {
                                                    if ((b.tagName == "DIV" && b.lastChild && !b.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) || b.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                        if (b.id.match(/-Mask$/)) {
                                                            b.parentNode.className = "CanvasXpressDataExplorer"
                                                        } else {
                                                            if (b.parentNode.id.match(/-Mask$/)) {
                                                                b.parentNode.parentNode.className = "CanvasXpressDataExplorerActive"
                                                            } else {
                                                                b.className = "CanvasXpressDataExplorerActive"
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.dragOverDataExplorer = function(a) {
                                    return function(c) {
                                        a.cancelEvent(c);
                                        var b = a.getTargetEvent(c);
                                        if (b.parentNode.tagName == "SPAN") {
                                            b = b.parentNode
                                        }
                                        if (b.tagName.toUpperCase().match(/SVG/)) {
                                            if (b.parentNode.id.match(/-Mask$/)) {
                                                b.parentNode.parentNode.className = "CanvasXpressDataExplorerActive"
                                            } else {
                                                b.setAttribute("class", "CanvasXpressDataExplorerActive")
                                            }
                                        } else {
                                            if (b.tagName == "SPAN" && b.parentNode.lastChild && !b.parentNode.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                if (b.parentNode.id.match(/-Mask$/)) {
                                                    b.parentNode.parentNode.className = "CanvasXpressDataExplorerActive"
                                                } else {
                                                    b.parentNode.className = "CanvasXpressDataExplorerActive"
                                                }
                                            } else {
                                                if (b.tagName == "DIV" && b.lastChild && !b.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                    if (b.id.match(/-Mask$/)) {
                                                        b.parentNode.className = "CanvasXpressDataExplorerActive"
                                                    } else {
                                                        b.className = "CanvasXpressDataExplorerActive"
                                                    }
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.dragLeaveDataExplorer = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        if (b.parentNode.tagName == "SPAN") {
                                            b = b.parentNode
                                        }
                                        if (b.tagName.toUpperCase().match(/SVG/)) {
                                            if (b.parentNode.id.match(/-Mask$/)) {
                                                b.parentNode.parentNode.className = "CanvasXpressDataExplorer"
                                            } else {
                                                b.setAttribute("class", "CanvasXpressDataExplorer")
                                            }
                                        } else {
                                            if (b.tagName == "DIV") {
                                                if (b.id.match(/-Mask$/)) {
                                                    b.parentNode.className = "CanvasXpressDataExplorer"
                                                } else {
                                                    if (b.parentNode.id.match(/-Mask$/)) {
                                                        b.parentNode.className = "CanvasXpressDataExplorer"
                                                    } else {
                                                        b.className = "CanvasXpressDataExplorer"
                                                    }
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.dblclickDataExplorer = function(a) {
                                    return function(h) {
                                        var b = a.getTargetEvent(h);
                                        if (b.parentNode.tagName == "SPAN") {
                                            b = b.parentNode
                                        }
                                        if (b.type && b.type.match(/vars|smps/) && a.data.y[b.type].length > 1) {
                                            var d = b.innerText;
                                            var j = b.params[0];
                                            var k = b.parentNode.parentNode;
                                            var c = a.$(k.id.replace("DataExplorerVariables", "DataExplorerAnnotations").replace("DataExplorerSamples", "DataExplorerDescriptions"));
                                            var f = k.childNodes[0].childNodes;
                                            var l = j.match("Var") ? "switchAnnotationToVar" : "switchAnnotationToSmp";
                                            while (f.length > 1) {
                                                for (var g = 0; g < f.length; g++) {
                                                    if (f[g].innerText != d) {
                                                        f[g].type = c.type;
                                                        a.resetAxes(true);
                                                        a[j](f[g].innerText, f.length == 1);
                                                        f[g].params[0] = l;
                                                        c.firstChild.appendChild(f[g]);
                                                        break
                                                    }
                                                }
                                            }
                                            a.updateDataExplorerContainerPopulation(k);
                                            a.updateDataExplorerContainerPopulation(c);
                                            a.resetDataExplorer()
                                        }
                                        return false
                                    }
                                }(this);
                                this.dragEndDataExplorer = function(a) {
                                    return function(g) {
                                        var c = a.getTargetEvent(g);
                                        if (c.parentNode.tagName == "SPAN") {
                                            c.blur();
                                            c = c.parentNode;
                                            c.focus()
                                        }
                                        c.style.opacity = "1.0";
                                        var d = c.parentNode;
                                        if (d) {
                                            if (d.tagName == "SPAN") {
                                                d = d.parentNode
                                            }
                                            if (c.parentNode.id.match(/-Mask$/)) {
                                                d.parentNode.className = "CanvasXpressDataExplorer"
                                            } else {
                                                d.className = "CanvasXpressDataExplorer"
                                            }
                                            var f = d.type;
                                            var b = c.type;
                                            if (f == b) {
                                                return false
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.dropDataExplorer = function(a) {
                                    return function(t) {
                                        a.cancelEvent(t);
                                        var q, m, f, n;
                                        var u = t.dataTransfer.getData("text");
                                        var g = a.$(u);
                                        var q = a.getTargetEvent(t);
                                        if (g) {
                                            var B = g.innerText;
                                            var A = g.type;
                                            var h = g.numeric;
                                            var y = g.params[0];
                                            var k = g.parentNode.parentNode;
                                            a.resetDataExplorerDivs();
                                            if (q.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                var w = a.parseJSON(q.getAttribute("params"));
                                                m = w ? w[0] : "empty";
                                                q.setAttribute("class", "CanvasXpressDataExplorer");
                                                n = q.getAttribute("title").split(" : ")[0];
                                                switch (m) {
                                                    case "empty":
                                                        break;
                                                    case "overlays":
                                                        if (A == "x") {
                                                            a.modifySampleOverlays(B)
                                                        } else {
                                                            if (A == "z") {
                                                                a.modifyVariableOverlays(B)
                                                            } else {
                                                                alert("Ooops! Only Sample or Variable factors")
                                                            }
                                                        }
                                                        break;
                                                    case "treemapBy":
                                                        if (A == "x") {
                                                            var s = a.treemapBy;
                                                            if (s.includes(B)) {
                                                                var b = [];
                                                                for (var p = 0; p < s.length; p++) {
                                                                    if (s[p] != B) {
                                                                        b.push(s[p])
                                                                    }
                                                                }
                                                                s = b
                                                            } else {
                                                                s.push(B)
                                                            }
                                                            if (s.length > 0) {
                                                                q.setAttribute("title", n + " : " + a.treemapBy.join(", "))
                                                            } else {
                                                                q.setAttribute("title", n)
                                                            }
                                                        } else {
                                                            alert("Ooops! Only Sample factors")
                                                        }
                                                        a.draw({
                                                            func: "dropDataExplorer",
                                                            par: [t]
                                                        });
                                                        break;
                                                    case "pivotX":
                                                        if (A == "x") {
                                                            if (a.isPivot) {
                                                                a.removePivot()
                                                            } else {
                                                                a.pivotX(B)
                                                            }
                                                            var v = q.getAttribute("src");
                                                            q.setAttribute("src", q.getAttribute("asr"));
                                                            q.setAttribute("asr", v)
                                                        } else {
                                                            alert("Ooops! Only Sample factors")
                                                        }
                                                        break;
                                                    case "sortVariables":
                                                        if (A == "z") {
                                                            a.modifySort("cat", "var", B)
                                                        } else {
                                                            if (A == "smps") {
                                                                a.modifySort("smp", "var", B)
                                                            } else {
                                                                if (A == "vars") {
                                                                    alert("Ooops! No sorting variables by variable data!")
                                                                } else {
                                                                    alert("Ooops! No sorting variables by sample metadata!")
                                                                }
                                                            }
                                                        }
                                                        break;
                                                    case "sortSamples":
                                                        if (A == "x") {
                                                            a.modifySort("cat", "smp", B)
                                                        } else {
                                                            if (A == "vars") {
                                                                a.modifySort("var", "smp", B)
                                                            } else {
                                                                if (A == "smps") {
                                                                    alert("Ooops! No sorting samples by sample data!")
                                                                } else {
                                                                    alert("Ooops! No sorting samples by variable metadata!")
                                                                }
                                                            }
                                                        }
                                                        break;
                                                    case "groupSamples":
                                                        if (A == "x") {
                                                            var c = a.groupingFactors;
                                                            if (c.includes(B)) {
                                                                var b = [];
                                                                for (var p = 0; p < c.length; p++) {
                                                                    if (c[p] != B) {
                                                                        b.push(c[p])
                                                                    }
                                                                }
                                                                c = b
                                                            } else {
                                                                c.push(B)
                                                            }
                                                            if (c.length > 0) {
                                                                a.groupSamples(c);
                                                                q.setAttribute("title", n + " : " + a.groupingFactors.join(", "))
                                                            } else {
                                                                a.ungroupSamples();
                                                                q.setAttribute("title", n)
                                                            }
                                                        } else {
                                                            alert("Ooops! Only Sample factors")
                                                        }
                                                        break;
                                                    case "segregate":
                                                        if (A == "x") {
                                                            var r = a.segregateSamplesBy;
                                                            if (r.includes(B)) {
                                                                var b = [];
                                                                for (var p = 0; p < r.length; p++) {
                                                                    if (r[p] != B) {
                                                                        b.push(r[p])
                                                                    }
                                                                }
                                                                if (b.length > 0) {
                                                                    a.segregateSamplesBy = b;
                                                                    a.segregate("Samples", b)
                                                                } else {
                                                                    a.segregateSamplesBy = [];
                                                                    a.desegregate("Samples")
                                                                }
                                                            } else {
                                                                if (a.segregateSamplesBy.length + a.segregateVariablesBy.length < 2) {
                                                                    r.push(B);
                                                                    a.segregate("Samples", r)
                                                                } else {
                                                                    alert("Ooops! Only 2 segregation factors")
                                                                }
                                                            }
                                                        } else {
                                                            if (A == "z") {
                                                                var r = a.segregateVariablesBy;
                                                                if (r.includes(B)) {
                                                                    var b = [];
                                                                    for (var p = 0; p < r.length; p++) {
                                                                        if (r[p] != B) {
                                                                            b.push(r[p])
                                                                        }
                                                                    }
                                                                    if (b.length > 0) {
                                                                        a.segregateVariablesBy = b;
                                                                        a.segregate("Variables", b)
                                                                    } else {
                                                                        a.segregateVariablesBy = [];
                                                                        a.desegregate("Variables")
                                                                    }
                                                                } else {
                                                                    if (a.segregateSamplesBy.length + a.segregateVariablesBy.length < 2) {
                                                                        r.push(B);
                                                                        a.segregate("Variables", r)
                                                                    } else {
                                                                        alert("Ooops! Only 2 segregation factors")
                                                                    }
                                                                }
                                                            } else {
                                                                alert("Ooops! Only Sample or Variable factors")
                                                            }
                                                        }
                                                        var b = a.segregateVariablesBy;
                                                        b = b.concat(a.segregateSamplesBy);
                                                        q.setAttribute("title", b.length > 0 ? n + " : " + b.join(", ") : n);
                                                        break;
                                                    case "addToAxis":
                                                        var o = w[1][0];
                                                        if (A == "smps") {
                                                            if (t.shiftKey) {
                                                                a.changeSampleInAxis(B, o)
                                                            } else {
                                                                a.changeSampleInAxis(B, o, true)
                                                            }
                                                            q.setAttribute("title", n + " : " + a[o].join(", "))
                                                        } else {
                                                            alert("Ooops! Only samples allowed")
                                                        }
                                                        break;
                                                    case "motion":
                                                        f = q.getAttribute("type");
                                                        if (A == "smps") {
                                                            g.type = f;
                                                            a.resetAxes(true);
                                                            a[y](B);
                                                            g.params[0] = "switchAnnotationToSmp";
                                                            var j = a.$(a.target + "-cX-DataExplorerDescriptions");
                                                            if (j) {
                                                                j.appendChild(g)
                                                            }
                                                        } else {
                                                            if (A == "vars") {
                                                                g.type = f;
                                                                a.resetAxes(true);
                                                                a[y](B);
                                                                g.params[0] = "switchAnnotationToVar";
                                                                var l = a.$(a.target + "-cX-DataExplorerAnnotations");
                                                                if (l) {
                                                                    l.appendChild(g)
                                                                }
                                                            }
                                                        }
                                                        a.changeAttribute("motionBy", B);
                                                        q.setAttribute("title", n + " : " + B);
                                                        break;
                                                    case "linLog":
                                                        break;
                                                    default:
                                                        a.changeAttribute(m, B);
                                                        q.setAttribute("title", n + " : " + B);
                                                        break
                                                }
                                            } else {
                                                if (q.tagName == "SPAN" && q.parentNode.lastChild && !q.parentNode.lastChild.tagName.toUpperCase().match(/SVG|IMG/)) {
                                                    q = q.parentNode
                                                } else {
                                                    if (t.target.tagName == "DIV") {
                                                        q = q.parentNode
                                                    }
                                                }
                                                f = q.type;
                                                if (A == f) {
                                                    return false
                                                } else {
                                                    if (A == "smps" && f == "z") {
                                                        g.type = f;
                                                        a.resetAxes(true);
                                                        a[y](B);
                                                        g.params[0] = "switchAnnotationToSmp"
                                                    } else {
                                                        if (A == "z" && f == "smps") {
                                                            g.type = f;
                                                            a.resetAxes(true);
                                                            a[y](B);
                                                            g.params[0] = "switchSmpToAnnotation"
                                                        } else {
                                                            if (A == "vars" && f == "x") {
                                                                g.type = f;
                                                                a.resetAxes(true);
                                                                a[y](B);
                                                                g.params[0] = "switchAnnotationToVar"
                                                            } else {
                                                                if (A == "x" && f == "vars") {
                                                                    g.type = f;
                                                                    a.resetAxes(true);
                                                                    a[y](B);
                                                                    g.params[0] = "switchVarToAnnotation"
                                                                } else {
                                                                    alert("Ooops! Only changes between data and ortogonal numeric metadata");
                                                                    return false
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                q.firstChild.appendChild(g);
                                                a.updateDataExplorerContainerPopulation(k);
                                                a.updateDataExplorerContainerPopulation(q);
                                                a.resetDataExplorer()
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.dataExplorerClick = function(a) {
                                    return function(i) {
                                        var c = a.getTargetEvent(i);
                                        if (c.tagName.toUpperCase().match(/input/i)) {
                                            return true
                                        }
                                        var k = a.parseJSON(c.getAttribute("params"));
                                        if (k && k[1]) {
                                            if (k[0] == "changeAttribute" && k[1][0] == "graphType") {
                                                var j = a.$(a.target + "-cX-DataExplorerAxes");
                                                var l = a.$(a.target + "-cX-DataExplorerSort");
                                                var h = a.$(a.target + "-cX-DataExplorerSummary");
                                                var d = a.$(a.target + "-cX-DataExplorerOrientation");
                                                var b = a.$(a.target + "-cX-DataExplorerOverlays");
                                                if (a.graphType.match(/Scatter/) && !k[1][1].match(/Scatter/)) {
                                                    j.style.display = "none";
                                                    d.style.display = "block";
                                                    b.style.display = "block";
                                                    l.style.display = "block";
                                                    h.style.display = "block"
                                                } else {
                                                    if (!a.graphType.match(/Scatter/) && k[1][1].match(/Scatter/)) {
                                                        j.style.display = "block";
                                                        d.style.display = "none";
                                                        b.style.display = "none";
                                                        l.style.display = "none";
                                                        h.style.display = "none"
                                                    }
                                                }
                                            }
                                            a[k[0]].apply(a, k[1])
                                        } else {
                                            if (k && k[0] == "pivotX") {
                                                if (a.isPivot) {
                                                    a.removePivot();
                                                    var f = c.src;
                                                    c.src = c.asr;
                                                    c.asr = f
                                                }
                                            } else {
                                                if (k && k[0] == "createDOE" && a.isDOE) {
                                                    a.removeDOE()
                                                } else {
                                                    if (k && k[0] == "fileUpload") {
                                                        a.$(a.target + "-cX-DataExplorerFileUploader").click();
                                                        return false
                                                    } else {
                                                        if (k) {
                                                            a[k[0]]()
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.dataExplorerDblclick = function(a) {
                                    return function(h) {
                                        var c = a.getTargetEvent(h).parentNode;
                                        var f = c.type;
                                        var b = c.innerText;
                                        if (f == "z") {
                                            if (a.isUnique(a.data.z[b])) {
                                                a.switchVarAnnotationToId(b)
                                            } else {
                                                if (c.numeric) {
                                                    a.switchNumericToString(b)
                                                } else {
                                                    a.switchStringToNumeric(b)
                                                }
                                            }
                                        } else {
                                            if (f == "x") {
                                                if (a.isUnique(a.data.x[b])) {
                                                    a.switchSmpAnnotationToId(b)
                                                } else {
                                                    if (c.numeric) {
                                                        a.switchNumericToString(b, true)
                                                    } else {
                                                        a.switchStringToNumeric(b, true)
                                                    }
                                                }
                                            } else {
                                                if (f == "vars") {
                                                    var g = [];
                                                    for (var d = 0; d < a.data.y.vars.length; d++) {
                                                        if (a.data.y.vars[d] != b) {
                                                            g.push(a.data.y.vars[d])
                                                        }
                                                    }
                                                    for (var d = 0; d < g.length; d++) {
                                                        a.switchVarToAnnotation(g[d])
                                                    }
                                                } else {
                                                    if (f == "smps") {
                                                        var j = [];
                                                        for (var d = 0; d < a.data.y.smps.length; d++) {
                                                            if (a.data.y.smps[d] != b) {
                                                                j.push(a.data.y.smps[d])
                                                            }
                                                        }
                                                        for (var d = 0; d < j.length; d++) {
                                                            a.switchSmpToAnnotation(j[d])
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        a.resetDataExplorer();
                                        return false
                                    }
                                }(this);
                                this.dataExplorerClickSort = function(a) {
                                    return function(d) {
                                        var b = a.getTargetEvent(d);
                                        var h = b.id.replace("-cX-DataExplorerSort", "-cX-DataExplorer");
                                        var c = a.$(h);
                                        if (c) {
                                            var g = a.removeEntriesDataExplorerContainer(c.firstChild);
                                            c.population = a.addEntriesDataExplorerContainer(c, c.firstChild, g, c.population.reverse());
                                            var f = b.getAttribute("src");
                                            b.setAttribute("src", b.getAttribute("asr"));
                                            b.setAttribute("asr", f);
                                            a.$cXIU(b, b.getAttribute("src"))
                                        }
                                        return false
                                    }
                                }(this);
                                this.dataExplorerClickDataSort = function(a) {
                                    return function(f) {
                                        var b = a.getTargetEvent(f);
                                        var d = a.parseJSON(b.getAttribute("params"))[0];
                                        switch (d) {
                                            case "sortDir":
                                                a.modifySort("both");
                                                a.sortDir = a.sortDir == "ascending" ? "descending" : "ascending";
                                                break;
                                            case "sortCase":
                                                a.modifySort("both");
                                                a.sortCaseSensitive = a.sortCaseSensitive ? false : true;
                                                break;
                                            case "sortVariables":
                                                a.sortVariables();
                                            case "sortSamples":
                                                a.sortSamples();
                                                break
                                        }
                                        if (b.srt) {
                                            var c = b.src;
                                            b.src = b.srt;
                                            b.srt = c
                                        }
                                        return false
                                    }
                                }(this);
                                this.dataExplorerClickLinLog = function(a) {
                                    return function(g) {
                                        var c = a.getTargetEvent(g);
                                        var b = a.parseJSON(c.getAttribute("params"));
                                        if (c && b) {
                                            var f = b[1][0] + "Transform";
                                            var d = c.getAttribute("src");
                                            c.setAttribute("src", c.getAttribute("srt"));
                                            c.setAttribute("srt", d);
                                            if (a[f]) {
                                                a.changeAttribute(f, false)
                                            } else {
                                                a.changeAttribute(f, a.transformBase == 2 ? "log2" : "log10")
                                            }
                                            a.$cXIU(c, c.getAttribute("src"))
                                        }
                                        return false
                                    }
                                }(this);
                                this.dataExplorerClickReset = function(a) {
                                    return function(j) {
                                        var c = a.getTargetEvent(j);
                                        var f = c.getAttribute("title") ? c.getAttribute("title").split(" : ")[0] : "";
                                        var b = a.parseJSON(c.getAttribute("params"));
                                        c.setAttribute("title", f);
                                        switch (b[0]) {
                                            case "overlays":
                                                a.varOverlays = [];
                                                a.smpOverlays = [];
                                                a.draw({
                                                    func: "dataExplorerClickReset",
                                                    par: [j]
                                                });
                                                return false;
                                            case "treemapBy":
                                                if (a.treemapBy.length > 0) {
                                                    a.treemapBy = []
                                                }
                                                a.draw({
                                                    func: "dataExplorerClickReset",
                                                    par: [j]
                                                });
                                                return false;
                                            case "groupSamples":
                                                if (a.groupingFactors.length > 0) {
                                                    a.ungroupSamples()
                                                }
                                                return false;
                                            case "segregate":
                                                for (var g = 0; g < a.segregateSamplesBy.length; g++) {
                                                    a.modifySampleSegregation(a.segregateSamplesBy[g])
                                                }
                                                for (var g = 0; g < a.segregateVariablesBy.length; g++) {
                                                    a.modifyVariableSegregation(a.segregateVariablesBy[g])
                                                }
                                                return false;
                                            case "addToAxis":
                                                var h = b[1][0];
                                                var d = a[h];
                                                a.changeSampleInAxis(d[0], h, true);
                                                c.setAttribute("title", f + " : " + a[h].join(", "));
                                                return false;
                                            case "motion":
                                                a.changeAttribute("motionBy", false);
                                                return false;
                                            default:
                                                if (a[b[0]]) {
                                                    a.changeAttribute(b[0], false)
                                                }
                                                return false
                                        }
                                    }
                                }(this);
                                this.clickDataExplorerCarousel = function(a) {
                                    return function(f) {
                                        var c = a.getTargetEvent(f);
                                        var d = a.$(c.trgId);
                                        var b = c.innerHTML == "&lt;" ? d.current - 1 : d.current + 1;
                                        if (b < 0) {
                                            b = d.limit
                                        } else {
                                            if (b > d.limit) {
                                                b = 0
                                            }
                                        }
                                        d.current = b;
                                        a.rotateCarousel(d, b);
                                        return false
                                    }
                                }(this);
                                this.clickDataExplorerTheme = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        a.changeTheme(b.getAttribute("theme"));
                                        return false
                                    }
                                }(this);
                                this.closeDataExplorer = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        var f = b.id.replace("CloseImage", "");
                                        var d = a.$(f);
                                        if (d) {
                                            a.addRemoveDataExplorerListeners("removeEvtListener");
                                            a.transitionMagic(d, "holeOut", function() {
                                                d.parentNode.removeChild(d)
                                            })
                                        }
                                        return false
                                    }
                                }(this);
                                this.resetDataExplorer = function() {
                                    var j = this.$(this.target + "-cX-DataExplorerContainer");
                                    var b = this.$(this.target + "-cX-DataExplorerVariables-Mask");
                                    var g = this.$(this.target + "-cX-DataExplorerSamples-Mask");
                                    var a = this.$(this.target + "-cX-DataExplorerAnnotations-Mask");
                                    var h = this.$(this.target + "-cX-DataExplorerDescriptions-Mask");
                                    this.addRemoveDataExplorerListeners("removeEvtListener");
                                    var e = [b, g, a, h];
                                    for (var d = 0; d < e.length; d++) {
                                        var f = e[d];
                                        while (f.childNodes.length > 0) {
                                            f.removeChild(f.childNodes[0])
                                        }
                                    }
                                    this.loadVariablesDataExplorerDiv(b, true);
                                    this.loadSamplesDataExplorerDiv(g, true);
                                    this.loadAnnotationsDataExplorerDiv(a, true);
                                    this.loadDescriptionsDataExplorerDiv(h, true);
                                    this.addRemoveDataExplorerListeners("addEvtListener")
                                }
                            };
                            CanvasXpress.prototype.initDataFilter = function() {
                                this.heigthOffsetDataFilter = function() {
                                    return this.graphType == "Genome" ? 82 : 119
                                };
                                this.addDataFilterDiv = function() {
                                    if (this.$(this.target + "-cX-DataFilter")) {
                                        return
                                    }
                                    var x = this.meta.canvas.canvasPixelRatio;
                                    var j = this.dataFilterLastX != null ? parseInt(this.dataFilterLastX) : -(this.meta.canvas.ctx.canvas.width / x) * 0.5;
                                    var h = this.dataFilterLastY != null ? parseInt(this.dataFilterLastY) : (this.meta.canvas.ctx.canvas.height / x) * 0.5;
                                    var u = this.heigthOffsetDataFilter();
                                    this.dataFilterHeight = (this.meta.canvas.ctx.canvas.height / x) - u;
                                    this.activeAccordion = null;
                                    var B = this.$cX("div", {
                                        id: this.target + "-cX-DataFilter",
                                        className: "CanvasXpressDataFilter draggable-container"
                                    }, {
                                        top: h + "px",
                                        left: j + "px",
                                        display: "none",
                                        zIndex: 10000,
                                        marginLeft: "3px",
                                        width: (this.dataFilterWidth + 6) + "px",
                                        height: "100%"
                                    });
                                    var o = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterToolbar",
                                        className: "CanvasXpressDataFilterToolbar draggable"
                                    }, {
                                        width: this.dataFilterWidth + "px"
                                    });
                                    var b = this.$cX("span", {
                                        innerHTML: "Filters",
                                        className: "CanvasXpressDataFilterToolbarText"
                                    });
                                    var s = this.$cXI(this.filterFlashingOn ? "sl_lightbulbon" : "sl_lightbulboff", {
                                        id: this.target + "-cX-DataFilterKeyFlash",
                                        className: "CanvasXpressDataFilterToolbarImage",
                                        src: this.filterFlashingOn ? "sl_lightbulbon" : "sl_lightbulboff",
                                        title: this.filterFlashingOn ? "Turn off Flashing" : "Turn on Flashing"
                                    }, {
                                        display: this.graphType == "Network" ? "block" : "none"
                                    });
                                    if (CanvasXpress.system.isIE) {
                                        s.style.marginTop = "-10px"
                                    }
                                    var g = this.$cXI("fp_funnelremove", {
                                        id: this.target + "-cX-DataFilterKeyReset",
                                        className: "CanvasXpressDataFilterToolbarImage",
                                        src: "fp_funnelremove",
                                        title: "Reset filters"
                                    });
                                    if (CanvasXpress.system.isIE) {
                                        g.style.marginTop = "-10px"
                                    }
                                    var v = this.$cX(this.dataFilterLastState && this.dataFilterLastState == "docked" ? "fp_pinremove" : "fp_pin", {
                                        id: this.target + "-cX-DataFilterKeyDock",
                                        className: "CanvasXpressDataFilterToolbarImage",
                                        src: this.dataFilterLastState && this.dataFilterLastState == "docked" ? "fp_pinremove" : "fp_pin",
                                        title: this.dataFilterLastState && this.dataFilterLastState == "docked" ? "Undock" : "Dock",
                                        state: this.dataFilterLastState && this.dataFilterLastState == "docked" ? "docked" : "free"
                                    });
                                    if (CanvasXpress.system.isIE) {
                                        v.style.marginTop = "-10px"
                                    }
                                    var x = this.$cXI("op_cancel", {
                                        id: this.target + "-cX-DataFilterKeyClose",
                                        className: "CanvasXpressDataFilterToolbarImage",
                                        src: "op_cancel",
                                        title: "Close"
                                    });
                                    if (CanvasXpress.system.isIE) {
                                        x.style.marginTop = "-10px"
                                    }
                                    var C = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterContainer",
                                        className: "CanvasXpressDataFilterContainer"
                                    }, {
                                        width: "fit-content"
                                    });
                                    var m = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterVariableHeader",
                                        className: "CanvasXpressDataFilterHead"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        display: this.graphType.match(/Genome|Network/) ? "none" : "block"
                                    });
                                    var r = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterVariableContent",
                                        className: "CanvasXpressDataFilterContent"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        height: "0px",
                                        display: "none"
                                    });
                                    var e = this.$cX("span", {
                                        innerHTML: "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Variables",
                                        className: "CanvasXpressDataFilterText"
                                    });
                                    var k = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterSampleHeader",
                                        className: "CanvasXpressDataFilterHead"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        display: this.graphType.match(/Genome|Network/) ? "none" : "block"
                                    });
                                    var q = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterSampleContent",
                                        className: "CanvasXpressDataFilterContent"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        height: "0px",
                                        display: "none"
                                    });
                                    var c = this.$cX("span", {
                                        innerHTML: "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Samples",
                                        className: "CanvasXpressDataFilterText"
                                    });
                                    var y = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterNodeHeader",
                                        className: "CanvasXpressDataFilterHead"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        display: this.graphType == "Network" ? "block" : "none"
                                    });
                                    var A = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterNodeContent",
                                        className: "CanvasXpressDataFilterContent"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        height: "0px",
                                        display: "none"
                                    });
                                    var n = this.$cX("span", {
                                        innerHTML: "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Nodes",
                                        className: "CanvasXpressDataFilterText"
                                    });
                                    var t = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterEdgeHeader",
                                        className: "CanvasXpressDataFilterHead"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        display: this.graphType == "Network" ? "block" : "none"
                                    });
                                    var z = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterEdgeContent",
                                        className: "CanvasXpressDataFilterContent"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        height: "0px",
                                        display: "none"
                                    });
                                    var i = this.$cX("span", {
                                        innerHTML: "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Edges",
                                        className: "CanvasXpressDataFilterText"
                                    });
                                    var f = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterGenomeHeader",
                                        className: "CanvasXpressDataFilterHead"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        display: this.graphType == "Genome" ? "block" : "none"
                                    });
                                    var l = this.$cX("div", {
                                        id: this.target + "-cX-DataFilterGenomeContent",
                                        className: "CanvasXpressDataFilterContent"
                                    }, {
                                        width: this.dataFilterWidth + "px",
                                        height: "0px",
                                        display: "none"
                                    });
                                    var a = this.$cX("span", {
                                        innerHTML: "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Features",
                                        className: "CanvasXpressDataFilterText"
                                    });
                                    o.appendChild(b);
                                    o.appendChild(x);
                                    o.appendChild(v);
                                    o.appendChild(g);
                                    o.appendChild(s);
                                    m.appendChild(e);
                                    k.appendChild(c);
                                    y.appendChild(n);
                                    t.appendChild(i);
                                    f.appendChild(a);
                                    C.appendChild(m);
                                    C.appendChild(r);
                                    C.appendChild(k);
                                    C.appendChild(q);
                                    C.appendChild(y);
                                    C.appendChild(A);
                                    C.appendChild(t);
                                    C.appendChild(z);
                                    C.appendChild(f);
                                    C.appendChild(l);
                                    B.appendChild(o);
                                    B.appendChild(C);
                                    var p = this.$("east-wrapper-" + this.target);
                                    if (p) {
                                        p.appendChild(B);
                                        this.addRemoveDataFilterListeners("addEvtListener")
                                    }
                                };
                                this.addRemoveDataFilterListeners = function(k) {
                                    var e = this.$(this.target + "-cX-DataFilterToolbar");
                                    var a = this.$(this.target + "-cX-DataFilterKeyFlash");
                                    var g = this.$(this.target + "-cX-DataFilterKeyReset");
                                    var b = this.$(this.target + "-cX-DataFilterKeyDock");
                                    var c = this.$(this.target + "-cX-DataFilterKeyClose");
                                    var h = this.$(this.target + "-cX-DataFilterVariableHeader");
                                    var i = this.$(this.target + "-cX-DataFilterSampleHeader");
                                    var d = this.$(this.target + "-cX-DataFilterNodeHeader");
                                    var f = this.$(this.target + "-cX-DataFilterEdgeHeader");
                                    var j = this.$(this.target + "-cX-DataFilterGenomeHeader");
                                    if (e && a && g && b && c && h && i && d && f && j) {
                                        this[k](e, "mousedown", this.registerMousemove, false);
                                        this[k](a, "click", this.flashDataFilter, false);
                                        this[k](g, "click", this.resetDataFilter, false);
                                        this[k](b, "click", this.dockUndockDataFilter, false);
                                        this[k](c, "click", this.hideDataFilter, false);
                                        this[k](h, "click", this.activateAccordion, false);
                                        this[k](i, "click", this.activateAccordion, false);
                                        this[k](d, "click", this.activateAccordion, false);
                                        this[k](f, "click", this.activateAccordion, false);
                                        this[k](j, "click", this.activateAccordion, false)
                                    }
                                };
                                this.flashDataFilter = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        if (a.filterFlashingOn) {
                                            a.filterFlashingOn = false;
                                            a.$cXIU(b, "sl_lightbulboff", {
                                                title: "Turn on Flashing"
                                            })
                                        } else {
                                            a.filterFlashingOn = true;
                                            a.$cXIU(b, "sl_lightbulbon", {
                                                title: "Turn off Flashing"
                                            })
                                        }
                                        return false
                                    }
                                }(this);
                                this.activateAccordion = function(a) {
                                    return function(g, c, f, b) {
                                        if (!c) {
                                            c = a.getTargetEvent(g)
                                        }
                                        if (c) {
                                            if (c.tagName.toLowerCase() == "span") {
                                                c = c.parentNode
                                            }
                                            c.className = "CanvasXpressDataFilterHeadActive";
                                            c.firstChild.className = "CanvasXpressDataFilterTextActive";
                                            var d = c.nextSibling;
                                            if (d) {
                                                setTimeout(function() {
                                                    if (a.activeAccordion && d.id == a.activeAccordion.id) {
                                                        d = false
                                                    }
                                                    a.transitionAccordion(new Date().getTime(), 250, d, a.activeAccordion, f, b);
                                                    if (a.activeAccordion) {
                                                        var e = a.activeAccordion.previousSibling;
                                                        e.className = "CanvasXpressDataFilterHead";
                                                        e.firstChild.className = "CanvasXpressDataFilterText"
                                                    }
                                                    a.activeAccordion = d
                                                }, b ? 0 : 33)
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.resizeDataFilterHeight = function() {
                                    var b = this.$(this.target + "-cX-DataFilter");
                                    var a = this.meta.canvas.canvasPixelRatio;
                                    this.dataFilterHeight = (this.meta.canvas.ctx.canvas.height / a) - this.heigthOffsetDataFilter();
                                    if (this.activeAccordion) {
                                        this.activeAccordion.style.height = this.dataFilterHeight + "px"
                                    } else {
                                        return;
                                        if (this.graphType == "Genome") {
                                            this.activeAccordion = this.$(this.target + "-cX-DataFilterGenomeHeader").nextSibling
                                        } else {
                                            if (this.graphType == "Network") {
                                                this.activeAccordion = this.$(this.target + "-cX-DataFilterNodeHeader").nextSibling
                                            } else {
                                                this.activeAccordion = this.$(this.target + "-cX-DataFilterVariableHeader").nextSibling
                                            }
                                        }
                                    }
                                };
                                this.moveDataFilter = function(n, r, l, u) {
                                    var m, s;
                                    var q = this.meta.canvas.canvasPixelRatio;
                                    var v = this.$(this.target + "-cX-DataFilter");
                                    var j = this.$(this.target + "-cX-DataFilterToolbar");
                                    var f = this.$(this.target + "-cX-DataFilterKeyDock");
                                    var d = this.$(this.remoteParentId + "-canvasXpressRemoteWindow");
                                    var g = this.$("north-container-" + this.target);
                                    var a = this.$("south-container-" + this.target);
                                    var k = this.$("west-container-" + this.target);
                                    var z = this.$("middle-container-" + this.target);
                                    var c = this.$("east-container-" + this.target);
                                    var t = this.$("east-wrapper-" + this.target);
                                    var b = 64;
                                    var x = 0;
                                    var o = (this.meta.canvas.ctx.canvas.height / q);
                                    var p = this.dataFilterWidth;
                                    if (v && j && f && g && a && k && z && c && t) {
                                        var y = (j.clientWidth - p) + 2;
                                        s = parseInt(g.clientHeight) + o + parseInt(a.clientHeight);
                                        if (f.state == "free" && !n) {
                                            f.state = "docked";
                                            this.dataFilterLastState = "docked";
                                            this.dataFilterLastX = v.style.left;
                                            this.dataFilterLastY = v.style.top;
                                            var m = parseInt(k.style.width) + (this.meta.canvas.ctx.canvas.width / q) + j.clientWidth + 2;
                                            if (d) {
                                                this.resizeMoveObject(d, 0, 0, Math.max(m, parseInt(a.clientWidth)) + x, s + b)
                                            }
                                            this.resizeMoveObject(z, 0, 0, m, o);
                                            this.resizeMoveObject(c, 0, 0, p + y, o);
                                            this.resizeMoveObject(t, 0, 0, p + y, o);
                                            if (r || l) {
                                                this.resizeMoveObject(v, 0, 0, p, o, l)
                                            } else {
                                                this.resizeMove(v, 0, 0, p, o)
                                            }
                                        } else {
                                            f.state = "free";
                                            this.dataFilterLastState = "free";
                                            if (n) {
                                                delete(this.dataFilterLastState);
                                                this.dataFilterLastX = null;
                                                this.dataFilterLastY = null;
                                                v.style.width = p + "px";
                                                v.style.height = o + "px"
                                            }
                                            m = parseInt(k.style.width) + (this.meta.canvas.ctx.canvas.width / q);
                                            if (d) {
                                                this.resizeMoveObject(d, 0, 0, Math.max(m, parseInt(a.clientWidth)) + x, s + b)
                                            }
                                            if (!n) {
                                                this.resizeMove(v, -(this.meta.canvas.ctx.canvas.width / q) * 0.5, o * 0.5, p, o)
                                            } else {
                                                var i = this;
                                                this.transitionMagic(v, "holeOut", function() {
                                                    v.style.display = "none";
                                                    i.resizeMoveObject(z, 0, 0, m, o);
                                                    i.resizeMoveObject(c, 0, 0, 0, o);
                                                    i.resizeMoveObject(t, 0, 0, 0, o, l)
                                                })
                                            }
                                        }
                                        if (r) {
                                            f.state = r
                                        }
                                        if (f.state == "docked") {
                                            this.$cXIU(f, "fp_pinremove", {
                                                title: "Undock"
                                            })
                                        } else {
                                            this.$cXIU(f, "fp_pin", {
                                                title: "Dock"
                                            })
                                        }
                                    }
                                };
                                this.getDataFilterState = function() {
                                    var a = this.$(this.target + "-cX-DataFilterKeyDock");
                                    return a ? a.getAttribute("state") : false
                                };
                                this.updateDataFilter = function(c, a, r) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var q = this;
                                    var f = this.isDOE;
                                    var l, n;
                                    var d = this.$(this.target + "-cX-DataTable");
                                    var j = d && d.style.display == "block" ? false : true;
                                    var b = function(x, i, y, e, w) {
                                        var u = {
                                            min: ">=",
                                            max: "<=",
                                            like: "like",
                                            exact: "exact"
                                        };
                                        if (u[y]) {
                                            q[x].comp.push(w != null && w != false ? e + ":::" + w : e);
                                            q[x].op.push(u[y]);
                                            q[x].cases.push(false);
                                            q[x].type.push("Filter");
                                            q[x].value.push(q.toDoFilter[i][e][y])
                                        }
                                    };
                                    if (this.filteringStringOn || this.filteringNumericOn || c) {
                                        this.resetFilters();
                                        var s = false;
                                        if (f) {
                                            this.removeDOE(true)
                                        }
                                        for (var o in this.toDoFilter) {
                                            for (var h in this.toDoFilter[o]) {
                                                for (var p in this.toDoFilter[o][h]) {
                                                    var g = this.toDoFilter[o][h]["ref"];
                                                    if (p != "ref") {
                                                        if (o == "sample") {
                                                            b("filterSmpBy", o, p, h, g)
                                                        } else {
                                                            if (o == "variable") {
                                                                b("filterVarBy", o, p, h, g)
                                                            } else {
                                                                if (o == "node") {
                                                                    b("filterNodeBy", o, p, h, g)
                                                                } else {
                                                                    if (o == "edge") {
                                                                        b("filterEdgeBy", o, p, h, g)
                                                                    } else {
                                                                        if (o == "feature") {
                                                                            b("filterFeatureBy", o, p, h, g)
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.reset(true, a, r);
                                        this.filterData(true);
                                        this.updateDataTable();
                                        if (j) {
                                            this.hideUnhideDataTable(true)
                                        }
                                        if (this.layoutComb) {
                                            l = this.varIndices;
                                            n = this.smpIndices
                                        }
                                        if (this.motionBy && this.motionObject) {
                                            this.motionObject.varIndices = this.cloneObject(this.varIndices);
                                            this.motionObject.smpIndices = this.cloneObject(this.smpIndices)
                                        }
                                        if (f) {
                                            this.createDOE(false, false, true)
                                        }
                                        if (this.decorations && this.decorations.reg) {
                                            this.updateCorrelation()
                                        }
                                        if (this.validateAxesOnFilterData()) {
                                            if (this.graphType == "Network" && this.filterFlashingOn) {
                                                var k = [];
                                                for (var m = 0; m < this.data.nodes.length; m++) {
                                                    if (!this.data.nodes[m].hide) {
                                                        k.push(this.data.nodes[m].id)
                                                    }
                                                }
                                                this.flashNode(k, false, 5)
                                            } else {
                                                if (this.isGroupedData && this.smpIndices.length > 0) {
                                                    this.groupSamples(this.groupingFactors, false, false, true, true)
                                                }
                                                this.draw({
                                                    func: "updateDataFilter",
                                                    par: [true, a, r],
                                                    prop: {
                                                        toDoFilter: this.toDoFilter
                                                    }
                                                });
                                                if (this.layoutComb) {
                                                    this.varIndices = l;
                                                    this.smpIndices = n
                                                }
                                            }
                                        } else {
                                            if (!this.scatterPlotMatrix) {
                                                this.reset(true, false, r)
                                            }
                                            this.draw({
                                                func: "updateDataFilter",
                                                par: [true, a, r],
                                                prop: {
                                                    toDoFilter: this.toDoFilter
                                                }
                                            });
                                            if (this.layoutComb) {
                                                this.varIndices = l;
                                                this.smpIndices = n
                                            }
                                        }
                                    }
                                };
                                this.refreshDataFilters = function(B, w, G, R, z, D) {
                                    if (w && G && R && !D) {
                                        this.refreshDataFilters(R, w, G, false, false, true)
                                    } else {
                                        if (B && w) {
                                            var b = function(c) {
                                                var a = 1000000;
                                                return (((c * a) - (parseInt(c) * a)) / a).toString().replace(/\./, "").length - 1
                                            };
                                            var h = CanvasXpress.system.isIE ? 46 : 44;
                                            var P, A;
                                            switch (w) {
                                                case "variable":
                                                    A = this.getVariableIndices(G);
                                                    P = A >= 0 ? this.getSampleVariableData("smps") : this.getSampleVariableData("vars");
                                                    break;
                                                case "sample":
                                                    A = this.getSampleIndices(G);
                                                    P = A >= 0 ? this.getSampleVariableData("vars") : this.getSampleVariableData("smps");
                                                    break;
                                                case "node":
                                                    P = this.getFilteredNetworkData("nodes");
                                                    break;
                                                case "edge":
                                                    P = this.getFilteredNetworkData("edges");
                                                    break
                                            }
                                            if (P) {
                                                if (!this.lastRefreshedFilter) {
                                                    this.lastRefreshedFilter = []
                                                }
                                                var F = this.lastRefreshedFilter.length > 0 ? this.lastRefreshedFilter[this.lastRefreshedFilter.length - 1] : "";
                                                var N = false;
                                                while (F == G) {
                                                    this.lastRefreshedFilter.pop();
                                                    F = this.lastRefreshedFilter[this.lastRefreshedFilter.length - 1];
                                                    N = true
                                                }
                                                for (var J = 0; J < B.childNodes.length; J++) {
                                                    var Q = B.childNodes[J];
                                                    var y = this.$(Q.id.replace("DataFilterContainer", "DataFilterScroll"));
                                                    var C = this.$(Q.id.replace("DataFilterContainer", "DataFilterOptions"));
                                                    var E = this.$(Q.id.replace("DataFilterContainer", "DataFilterRange"));
                                                    var I = this.$(Q.id.replace("DataFilterContainer", "DataFilterMin"));
                                                    var x = this.$(Q.id.replace("DataFilterContainer", "DataFilterMax"));
                                                    var m = this.$(Q.id.replace("DataFilterContainer", "DataFilterMinLabel"));
                                                    var O = this.$(Q.id.replace("DataFilterContainer", "DataFilterMaxLabel"));
                                                    if (y && C && P.hasOwnProperty(y.uvalue)) {
                                                        if (y.uvalue != G) {
                                                            var u = this.sortObject(P[y.uvalue]["o"]);
                                                            if (y.uvalue == F) {
                                                                y.fvalues = this.cloneObject(y.values)
                                                            } else {
                                                                y.fvalues = ["(All) " + u.length + " values"];
                                                                for (var H = 0; H < u.length; H++) {
                                                                    y.fvalues.push(u[H])
                                                                }
                                                                y.fvalues.push("")
                                                            }
                                                        } else {
                                                            if (R && N && (F == y.uvalue || this.lastRefreshedFilter.length == 0)) {
                                                                y.fvalues = y.values
                                                            }
                                                        }
                                                        while (C.childNodes.length > 0) {
                                                            C.removeChild(C.childNodes[0])
                                                        }
                                                        this.loadStringFilter(y.fvalues, y.uvalue, C, y.values.length, P[y.uvalue]["o"]);
                                                        if (Q.className.match(/Out$/)) {
                                                            y.firstChild.firstChild.style.display = "none"
                                                        }
                                                        if (y.type == "long") {
                                                            y.style.height = y.fvalues.length - 2 > this.maxItemMenuCheckbox ? ((y.fvalues.length + 1) * 16) + "px" : (((y.fvalues.length - 1) * 19) + 4) + "px"
                                                        }
                                                    } else {
                                                        if (E && I && x && m && O && P.hasOwnProperty(E.uvalue)) {
                                                            var M = b(P[E.uvalue]["o"].max - P[E.uvalue]["o"].min);
                                                            var L, e;
                                                            if (E.uvalue != G) {
                                                                if (E.min == P[E.uvalue]["o"].min && E.max != P[E.uvalue]["o"].max) {
                                                                    if (E.scale == "log") {
                                                                        L = P[E.uvalue]["o"].max ? (Math.log(P[E.uvalue]["o"].max) - E.lmin) / E.lunits : 0
                                                                    } else {
                                                                        L = (P[E.uvalue]["o"].max - E.min) / E.units
                                                                    }
                                                                    L = Math.ceil(L);
                                                                    E.style.width = Math.max(0, Math.floor(L) - parseInt(I.style.left)) + "px"
                                                                } else {
                                                                    if (E.min != P[E.uvalue]["o"].min && E.max == P[E.uvalue]["o"].max) {
                                                                        if (E.scale == "log") {
                                                                            L = P[E.uvalue]["o"].min ? (Math.log(P[E.uvalue]["o"].min) - E.lmin) / E.lunits : 0
                                                                        } else {
                                                                            L = (P[E.uvalue]["o"].min - E.min) / E.units
                                                                        }
                                                                        L = Math.ceil(L);
                                                                        E.style.width = (parseInt(E.style.width) - L + parseInt(I.style.left)) + "px";
                                                                        I.style.left = L + "px";
                                                                        E.style.left = L + "px";
                                                                        x.style.left = L + "px"
                                                                    } else {
                                                                        if (E.min != P[E.uvalue]["o"].min && E.max != P[E.uvalue]["o"].max) {
                                                                            if (E.scale == "log") {
                                                                                L = P[E.uvalue]["o"].max ? (Math.log(P[E.uvalue]["o"].max) - E.lmin) / E.lunits : 0;
                                                                                e = P[E.uvalue]["o"].min ? (Math.log(P[E.uvalue]["o"].min) - E.lmin) / E.lunits : 0
                                                                            } else {
                                                                                L = (P[E.uvalue]["o"].max - E.min) / E.units;
                                                                                e = (P[E.uvalue]["o"].min - E.min) / E.units
                                                                            }
                                                                            if (!this.isNumber(e) || !this.isNumber(L)) {
                                                                                continue
                                                                            }
                                                                            e = Math.ceil(e);
                                                                            L = Math.ceil(L);
                                                                            E.style.width = (L - e) + "px";
                                                                            I.style.left = e + "px";
                                                                            E.style.left = e + "px";
                                                                            x.style.left = e + "px"
                                                                        } else {
                                                                            if (E.min == P[E.uvalue]["o"].min && E.max == P[E.uvalue]["o"].max) {
                                                                                E.style.width = (this.dataFilterWidth - h) + "px";
                                                                                I.style.left = "0px";
                                                                                E.style.left = "0px";
                                                                                x.style.left = "0px"
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                m.value = this.formatNumber(P[E.uvalue]["o"].min, M);
                                                                O.value = this.formatNumber(P[E.uvalue]["o"].max, M)
                                                            }
                                                        }
                                                    }
                                                }
                                                if (R) {
                                                    this.refreshDataFilters(R, w, G)
                                                } else {
                                                    this.lastRefreshedFilter.push(G)
                                                }
                                            }
                                        } else {
                                            if (z) {
                                                var N = this.$(this.target + "-cX-DataFilterContainer");
                                                if (N) {
                                                    this.lastRefreshedFilter = [];
                                                    for (var J = 0; J < N.childNodes.length; J++) {
                                                        if (N.childNodes[J].id.match("Content")) {
                                                            var Q = N.childNodes[J];
                                                            for (var H = 0; H < Q.childNodes.length; H++) {
                                                                if (Q.childNodes[H].id.match("Items")) {
                                                                    var K = Q.childNodes[H];
                                                                    for (var G = 0; G < K.childNodes.length; G++) {
                                                                        if (K.childNodes[G].id.match("Container")) {
                                                                            var P = K.childNodes[G];
                                                                            var y = this.$(P.id.replace("DataFilterContainer", "DataFilterScroll"));
                                                                            var C = this.$(P.id.replace("DataFilterContainer", "DataFilterOptions"));
                                                                            if (y && C) {
                                                                                y.fvalues = y.values;
                                                                                while (C.childNodes.length > 0) {
                                                                                    C.removeChild(C.childNodes[0])
                                                                                }
                                                                                this.loadStringFilter(y.fvalues, y.uvalue, C, y.values.length)
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.validateAxesOnFilterData = function() {
                                    if (!this.startingXAxisIndices) {
                                        this.startingXAxis = this.xAxis;
                                        this.startingXAxisIndices = this.graphType.match(/Scatter/i) ? this.xAxisIndices : this.xAxisVarIndices
                                    }
                                    if (!this.startingXAxis2Indices) {
                                        this.startingXAxis2 = this.xAxis2;
                                        this.startingXAxis2Indices = this.xAxis2VarIndices
                                    }
                                    if (!this.startingYAxisIndices) {
                                        this.startingYAxis = this.yAxis;
                                        this.startingYAxisIndices = this.yAxisIndices
                                    }
                                    if (!this.startingZAxisIndices) {
                                        this.startingZAxis = this.zAxis;
                                        this.startingZAxisIndices = this.zAxisIndices
                                    }
                                    if (this.graphType.match(/Scatter/i)) {
                                        var a = this.getObjectArray(this.smpIndices);
                                        this.xAxis = [];
                                        this.xAxisIndices = [];
                                        for (var b = 0; b < this.startingXAxisIndices.length; b++) {
                                            if (a.hasOwnProperty(this.startingXAxisIndices[b])) {
                                                this.xAxis.push(this.data.y.smps[this.startingXAxisIndices[b]]);
                                                this.xAxisIndices.push(this.startingXAxisIndices[b])
                                            }
                                        }
                                        if (this.xAxisIndices.length < 1) {
                                            this.xAxis = this.startingXAxis;
                                            this.xAxisIndices = this.startingXAxisIndices;
                                            if (this.debug) {
                                                alert("Cannot filter since there are no samples left in X-Axis")
                                            }
                                            return false
                                        }
                                        this.yAxis = [];
                                        this.yAxisIndices = [];
                                        for (var b = 0; b < this.startingYAxisIndices.length; b++) {
                                            if (a.hasOwnProperty(this.startingYAxisIndices[b])) {
                                                this.yAxis.push(this.data.y.smps[this.startingYAxisIndices[b]]);
                                                this.yAxisIndices.push(this.startingYAxisIndices[b])
                                            }
                                        }
                                        if (this.yAxisIndices.length < 1) {
                                            this.yAxis = this.startingYAxis;
                                            this.yAxisIndices = this.startingYAxisIndices;
                                            if (this.debug) {
                                                alert("Cannot filter since there are no samples left in Y-Axis")
                                            }
                                            return false
                                        }
                                        if (this.graphType == "Scatter3D" || this.graphType == "ScatterBubble2D") {
                                            this.zAxis = [];
                                            this.zAxisIndices = [];
                                            for (var b = 0; b < this.startingZAxisIndices.length; b++) {
                                                if (a.hasOwnProperty(this.startingZAxisIndices[b])) {
                                                    this.zAxis.push(this.data.y.smps[this.startingZAxisIndices[b]]);
                                                    this.zAxisIndices.push(this.startingZAxisIndices[b])
                                                }
                                            }
                                            if (this.zAxisIndices.length < 1) {
                                                this.zAxis = this.startingZAxis;
                                                this.zAxisIndices = this.startingZAxisIndices;
                                                if (this.debug) {
                                                    alert("Cannot filter since there are no samples left in Z-Axis")
                                                }
                                                return false
                                            }
                                        }
                                    } else {
                                        if (this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/)) {
                                            var a = this.getObjectArray(this.varIndices);
                                            this.xAxis = [];
                                            this.xAxisIndices = [];
                                            for (var b = 0; b < this.startingXAxisIndices.length; b++) {
                                                if (a.hasOwnProperty(this.startingXAxisIndices[b])) {
                                                    this.xAxis.push(this.data.y.vars[this.startingXAxisIndices[b]]);
                                                    this.xAxisIndices.push(this.startingXAxisIndices[b])
                                                }
                                            }
                                            if (this.xAxisIndices.length < 1) {
                                                this.xAxis = this.startingXAxis;
                                                this.xAxisIndices = this.startingXAxisIndices;
                                                if (this.debug) {
                                                    alert("Cannot filter since there are no variables left in X-Axis")
                                                }
                                                return false
                                            }
                                            this.xAxis2 = [];
                                            this.xAxis2Indices = [];
                                            for (var b = 0; b < this.startingXAxis2Indices.length; b++) {
                                                if (a.hasOwnProperty(this.startingXAxis2Indices[b])) {
                                                    this.xAxis2.push(this.data.y.vars[this.startingXAxis2Indices[b]]);
                                                    this.xAxis2Indices.push(this.startingXAxis2Indices[b])
                                                }
                                            }
                                            if (this.xAxis2Indices.length < 1) {
                                                this.xAxis2 = this.startingXAxis2;
                                                this.xAxisIndices2 = this.startingXAxis2Indices;
                                                if (this.debug) {
                                                    alert("Cannot filter since there are no variables left in X-Axis2")
                                                }
                                                return false
                                            }
                                        }
                                    }
                                    return true
                                };
                                this.showDataFilter = function(a) {
                                    return function(g, i) {
                                        var h = a.$(a.target + "-cX-DataFilter");
                                        if (!h) {
                                            if (!a.disableEvents && !a.disableDataFilters) {
                                                a.addDataFilterDiv();
                                                h = a.$(a.target + "-cX-DataFilter")
                                            }
                                        }
                                        if (h) {
                                            if (h.style.left == "0px" && h.style.top == "0px") {
                                                var b = this.meta.canvas.canvasPixelRatio;
                                                var d = a.$("west-container-" + a.target);
                                                var f = a.$("middle-container-" + a.target);
                                                if (d && f) {
                                                    f.style.width = (parseInt(d.clientWidth) + (a.meta.canvas.ctx.canvas.width / b) + a.dataFilterWidth) + "px"
                                                }
                                            }
                                            if (a.activeTarget) {
                                                a.activeTarget.style.zIndex = 10000
                                            }
                                            a.activeTarget = h;
                                            h.style.display = "block";
                                            h.style.opacity = 0;
                                            a.loadDataFilter();
                                            a.resizeDataFilterHeight();
                                            if (!a.activeAccordion) {
                                                if (a.graphType == "Genome") {
                                                    a.activateAccordion(false, a.$(a.target + "-cX-DataFilterGenomeHeader"), i, true)
                                                } else {
                                                    if (a.graphType == "Network") {
                                                        a.activateAccordion(false, a.$(a.target + "-cX-DataFilterNodeHeader"), i, true)
                                                    } else {
                                                        a.activateAccordion(false, a.$(a.target + "-cX-DataFilterVariableHeader"), i, true)
                                                    }
                                                }
                                            } else {
                                                if (i) {
                                                    i()
                                                }
                                            }
                                            h.style.zIndex = 10001
                                        }
                                        return false
                                    }
                                }(this);
                                this.removeGenericDataFilterListenersOrReset = function(A) {
                                    var z = [];
                                    var x = [];
                                    switch (this.graphType) {
                                        case "Bar":
                                        case "Line":
                                        case "BarLine":
                                        case "Area":
                                        case "AreaLine":
                                        case "Dotplot":
                                        case "DotLine":
                                        case "Heatmap":
                                        case "Stacked":
                                        case "StackedLine":
                                        case "StackedPercent":
                                        case "StackedPercentLine":
                                        case "Boxplot":
                                        case "Correlation":
                                        case "Pie":
                                        case "Scatter2D":
                                        case "ScatterBubble2D":
                                        case "Scatter3D":
                                        case "Circular":
                                        case "Map":
                                        case "Gantt":
                                            var l = this.$(this.target + "-cX-DataFilterSampleContent");
                                            var m = this.$(this.target + "-cX-DataFilterVariableContent");
                                            if (l && m) {
                                                z.push(l, m);
                                                x.push(this.getSampleVariableData("smps", true));
                                                x.push(this.getSampleVariableData("vars", true))
                                            }
                                            break;
                                        case "Venn":
                                            return;
                                        case "Network":
                                            var t = this.$(this.target + "-cX-DataFilterNodeContent");
                                            var p = this.$(this.target + "-cX-DataFilterEdgeContent");
                                            if (t && p) {
                                                z.push(t, p);
                                                x.push(this.getNodeData(true));
                                                x.push(this.getEdgeData(true))
                                            }
                                            break;
                                        case "Genome":
                                            var h = this.$(this.target + "-cX-DataFilterGenomeContent");
                                            if (h) {
                                                z.push(h);
                                                x.push(this.getFeatureData(true))
                                            }
                                            break
                                    }
                                    for (var u = 0; u < x.length; u++) {
                                        var g = z[u];
                                        var n = x[u];
                                        var C = this.getKeys(n);
                                        C.sort();
                                        for (var r = 0; r < C.length; r++) {
                                            var B = n[C[r]]["t"];
                                            var y = C[r].replace(/\W/g, "_");
                                            if (B == "string") {
                                                var b = this.$(this.target + ":" + y + ":cX-DataFilterInput");
                                                var q = this.$(this.target + ":" + y + ":cX-DataFilterScroll");
                                                var w = this.$(this.target + ":" + y + ":cX-DataFilterMask");
                                                if (q && b) {
                                                    if (A) {
                                                        b.value = "";
                                                        this.resetSelectStringFilter(q)
                                                    } else {
                                                        this.addRemoveStringDataFilterListeners("removeEvtListener", w)
                                                    }
                                                }
                                            } else {
                                                var o = this.$(this.target + ":" + y + ":cX-DataFilterMin");
                                                var k = this.$(this.target + ":" + y + ":cX-DataFilterMinLabel");
                                                var f = this.$(this.target + ":" + y + ":cX-DataFilterRange");
                                                var s = this.$(this.target + ":" + y + ":cX-DataFilterMax");
                                                var v = this.$(this.target + ":" + y + ":cX-DataFilterMaxLabel");
                                                var a = this.$(this.target + ":" + y + ":cX-DataFilterScale");
                                                var e = CanvasXpress.system.isIE ? 46 : 44;
                                                if (o && k && f && s && v && a) {
                                                    if (A) {
                                                        o.style.left = "0px";
                                                        k.value = this.formatNumber(f.min, f.decis);
                                                        f.style.left = "0px";
                                                        f.style.width = (this.dataFilterWidth - e) + "px";
                                                        s.style.left = "0px";
                                                        v.value = this.formatNumber(f.max, f.decis)
                                                    } else {
                                                        this.addRemoveNumericDataFilterListeners("removeEvtListener", o, s, k, v, a)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.loadDataFilter = function() {
                                    if (!this.toDoFilter) {
                                        this.toDoFilter = {}
                                    }
                                    switch (this.graphType) {
                                        case "Bar":
                                        case "Line":
                                        case "BarLine":
                                        case "Area":
                                        case "AreaLine":
                                        case "Dotplot":
                                        case "DotLine":
                                        case "Heatmap":
                                        case "Stacked":
                                        case "StackedLine":
                                        case "StackedPercent":
                                        case "StackedPercentLine":
                                        case "Boxplot":
                                        case "Correlation":
                                        case "Pie":
                                        case "Scatter2D":
                                        case "ScatterBubble2D":
                                        case "Scatter3D":
                                        case "Circular":
                                        case "Map":
                                        case "Gantt":
                                            return this.loadDataFilterSmpVar();
                                        case "Venn":
                                            return;
                                        case "Network":
                                            return this.loadDataFilterNetwork();
                                        case "Genome":
                                            return this.loadDataFilterGenome()
                                    }
                                };
                                this.loadDataFilterGeneric = function(b, t, k) {
                                    var p = this.graphType == "Genome" ? 95 : 116;
                                    var q = this.getKeys(k);
                                    q.sort();
                                    if (!t.loaded) {
                                        t.loaded = {}
                                    }
                                    var a = t.id + "Search";
                                    if (!this.$(a)) {
                                        var l = this.$cX("div", {
                                            id: a,
                                            className: "CanvasXpressDataFilterContainerHoverable"
                                        }, {
                                            width: "97%"
                                        });
                                        var r = this.$cX("input", {
                                            id: a + "Input",
                                            type: "text",
                                            placeholder: " Search filters"
                                        }, {
                                            cursor: "default",
                                            width: "97%",
                                            margin: "3px",
                                            border: "none"
                                        });
                                        var n = this.$cX("div", {
                                            id: a + "Items"
                                        });
                                        l.appendChild(r);
                                        t.appendChild(l);
                                        t.appendChild(n)
                                    }
                                    var j = this.$(a + "Items");
                                    var f = this.meta.canvas.canvasPixelRatio;
                                    if (j) {
                                        j.style.height = (this.meta.canvas.ctx.canvas.height / f) - p
                                    }
                                    for (var h = 0; h < q.length; h++) {
                                        var m = k[q[h]]["t"];
                                        var e = k[q[h]]["r"];
                                        var o = this.getKeys(k[q[h]]["o"]);
                                        var g = this.target + ":" + q[h].replace(/\W/g, "_") + ":cX-DataFilterContainer";
                                        if (!this.$(g)) {
                                            if (o.length > 0) {
                                                if (m == "string") {
                                                    if (!t.loaded[q[h]]) {
                                                        n.appendChild(this.createStringFilter(b, q[h], o, e));
                                                        t.loaded[q[h]] = true
                                                    }
                                                } else {
                                                    if (!t.loaded[q[h]]) {
                                                        if (o[0] == "min" && o[1] == "max") {
                                                            o = [k[q[h]]["o"]["min"], k[q[h]]["o"]["max"]]
                                                        }
                                                        n.appendChild(this.createNumericFilter(b, q[h], o, e));
                                                        t.loaded[q[h]] = true
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.loadDataFilterSmpVar = function() {
                                    var c = this.$(this.target + "-cX-DataFilterSampleContent");
                                    var a = this.$(this.target + "-cX-DataFilterVariableContent");
                                    var d = this.graphType == "Scatter2D" && this.scatterType == "manhattan";
                                    var b = d ? [this.manhattanMarkerChromosomeNumber, this.manhattanMarkerLogPValue] : false;
                                    if (c && a) {
                                        this.loadDataFilterGeneric("sample", c, this.getSampleVariableData("smps", true, b, false, d));
                                        this.loadDataFilterGeneric("variable", a, this.getSampleVariableData("vars", true))
                                    }
                                };
                                this.loadDataFilterNetwork = function() {
                                    var b = this.$(this.target + "-cX-DataFilterNodeContent");
                                    var a = this.$(this.target + "-cX-DataFilterEdgeContent");
                                    if (b && a) {
                                        this.loadDataFilterGeneric("node", b, this.getNodeData(true));
                                        this.loadDataFilterGeneric("edge", a, this.getEdgeData(true))
                                    }
                                };
                                this.loadDataFilterGenome = function() {
                                    var a = this.$(this.target + "-cX-DataFilterGenomeContent");
                                    if (a) {
                                        this.loadDataFilterGeneric("feature", a, this.getFeatureData(true))
                                    }
                                };
                                this.createNumericFilter = function(n, C, m, w, j, F) {
                                    var i = this;
                                    var a = function(d) {
                                        var b = 1000000;
                                        return (((d * b) - (parseInt(d) * b)) / b).toString().replace(/\./, "").length - 1
                                    };
                                    var c = function() {
                                        if (F) {
                                            return [(F[1] - F[0]) / A, (F[0] - m[0]) / A]
                                        } else {
                                            return [i.dataFilterWidth - h, 0]
                                        }
                                    };
                                    var h = CanvasXpress.system.isIE ? 46 : 44;
                                    m = this.filterNumbers(m);
                                    m.sort(function(e, d) {
                                        return e - d
                                    });
                                    var H = C.replace(/\W/g, "_");
                                    var x = j ? this.target + ":" + H + "_" : this.target + ":" + H;
                                    var J = this.$cX("div", {
                                        id: x + ":cX-DataFilterContainer",
                                        className: "CanvasXpressDataFilterContainerHoverable",
                                        type: "numeric",
                                        args: [n, C, m, w, j]
                                    });
                                    var B = this.$cX("div", {
                                        id: x + ":cX-DataFilterScale",
                                        className: m[0] <= 0 ? "CanvasXpressDataFilterContainerScaleNone" : "CanvasXpressDataFilterContainerScaleLinearLog",
                                        innerHTML: C,
                                        draggable: true
                                    }, {
                                        width: (this.dataFilterWidth - 18) + "px",
                                        margin: "5px"
                                    });
                                    var u = this.$cX("div", false, {
                                        width: (this.dataFilterWidth - 18) + "px",
                                        height: "18px",
                                        margin: "2px"
                                    });
                                    var E = parseFloat(m[0]) < 0 ? false : parseFloat(m[0]) == 0 ? 0 : Math.log(parseFloat(m[0]));
                                    var I = parseFloat(m[m.length - 1]) < 0 ? false : parseFloat(m[m.length - 1]) == 0 ? 0 : Math.log(parseFloat(m[m.length - 1]));
                                    var L = E != null && I != null ? (I - E) / (this.dataFilterWidth - h) : false;
                                    var A = (m[m.length - 1] - m[0]) / (this.dataFilterWidth - h);
                                    var f = c();
                                    var p = this.$cX("div", {
                                        id: x + ":cX-DataFilterRange",
                                        className: "CanvasXpressDataFilterContainerRange",
                                        min: parseFloat(m[0]),
                                        max: parseFloat(m[m.length - 1]),
                                        cmin: parseFloat(m[0]),
                                        cmax: parseFloat(m[m.length - 1]),
                                        range: m[m.length - 1] - m[0],
                                        units: A,
                                        decis: a(m[m.length - 1] - m[0]),
                                        lmin: E,
                                        lmax: I,
                                        lunits: L,
                                        scale: L ? "linear" : false,
                                        filter: n,
                                        ref: w,
                                        uvalue: C
                                    }, {
                                        width: f[0] + "px",
                                        left: f[1] + "px"
                                    });
                                    var D = this.$cX("input", {
                                        id: x + ":cX-DataFilterMinLabel",
                                        className: "CanvasXpressDataFilterContainerMinValue",
                                        type: "text",
                                        value: this.formatNumber(F ? F[0] : m[0], p.decis)
                                    });
                                    var o = this.$cX("input", {
                                        id: x + ":cX-DataFilterMaxLabel",
                                        className: "CanvasXpressDataFilterContainerMaxValue",
                                        type: "text",
                                        value: this.formatNumber(F ? F[1] : m[m.length - 1], p.decis)
                                    });
                                    var K = this.$cX("div", {
                                        className: "CanvasXpressDataFilterContainerNumeric"
                                    }, {
                                        width: (i.dataFilterWidth - 16) + "px"
                                    });
                                    var G = this.$cX("div", {
                                        id: x + ":cX-DataFilterMin",
                                        className: "CanvasXpressDataFilterContainerMin"
                                    }, {
                                        left: f[1] + "px"
                                    });
                                    var y = this.$cX("div", {
                                        id: x + ":cX-DataFilterMax",
                                        className: "CanvasXpressDataFilterContainerMax"
                                    }, {
                                        left: f[1] + "px"
                                    });
                                    u.appendChild(D);
                                    u.appendChild(o);
                                    K.appendChild(G);
                                    K.appendChild(p);
                                    K.appendChild(y);
                                    J.appendChild(B);
                                    J.appendChild(u);
                                    J.appendChild(K);
                                    this.addRemoveNumericDataFilterListeners("addEvtListener", G, y, D, o, B);
                                    return J
                                };
                                this.addRemoveNumericDataFilterListeners = function(e, d, a, f, c, b) {
                                    if (e && d && a && f && c && b) {
                                        this[e](d, "mousedown", this.mousedownNumericFilter, false);
                                        this[e](a, "mousedown", this.mousedownNumericFilter, false);
                                        this[e](f, "change", this.changeNumericFilter, false);
                                        this[e](c, "change", this.changeNumericFilter, false);
                                        this[e](b, "click", this.clickNumericFilter, false);
                                        this[e](b, "dragstart", this.dragStartDataFilter, false);
                                        this[e](b, "dragend", this.dragEndDataFilter, false)
                                    }
                                };
                                this.dragStartDataFilter = function(a) {
                                    return function(c) {
                                        c.acs = a.adjustedCoordinates(c);
                                        var b = a.getTargetEvent(c);
                                        if (b) {
                                            c.dataTransfer.setDragImage(b.parentNode, -5, -5);
                                            b.parentNode.style.opacity = "0.3";
                                            c.dataTransfer.setData("text", b.parentNode.id);
                                            a.xMouseDown = c.screenX;
                                            a.yMouseDown = c.screenY
                                        }
                                        return false
                                    }
                                }(this);
                                this.dragEndDataFilter = function(a) {
                                    return function(f) {
                                        f.ace = a.adjustedCoordinates(f);
                                        var c = a.getTargetEvent(f);
                                        if (c) {
                                            a.addRemoveDataFilter(f.srcElement.parentNode);
                                            var d = f.screenX - a.xMouseDown;
                                            var b = f.screenY - a.yMouseDown
                                        }
                                        return false
                                    }
                                }(this);
                                this.addRemoveDataFilter = function(b, d, h, u, k, q) {
                                    var t = false;
                                    if (!b) {
                                        this.loadDataFilter();
                                        if (d && h && u) {
                                            if (u == "string") {
                                                h[2].shift();
                                                h[2].pop()
                                            }
                                            b = k ? this.$(k) : this[d].apply(this, h)
                                        } else {
                                            return
                                        }
                                        t = true
                                    }
                                    if (!d) {
                                        d = b.type == "string" ? "createStringFilter" : "createNumericFilter"
                                    }
                                    if (!h) {
                                        h = b.args
                                    }
                                    if (!b) {
                                        return
                                    }
                                    b.style.opacity = "1.0";
                                    b.style.cssFloat = q && q.position && q.position.match(/Right/) ? "right" : "left";
                                    var o = b.parentNode;
                                    if ((t && !k) || o.id.match(/DataFilter/)) {
                                        b.className = "CanvasXpressDataFilterContainerHoverableOut";
                                        if (b.type == "string") {
                                            var e = b.getElementsByClassName("CanvasXpressDataFilterContainerMaskNoOverflow");
                                            var c = b.getElementsByClassName("CanvasXpressDataFilterContainerMask");
                                            var g;
                                            if (e.length) {
                                                g = b.childNodes[1];
                                                g.className = "CanvasXpressDataFilterContainerMaskNoOverflowOut";
                                                g.style.height = "16px";
                                                g.firstChild.firstChild.style.display = "flex";
                                                g.firstChild.firstChild.firstChild.style.display = "none"
                                            } else {
                                                if (c.length) {
                                                    g = b.childNodes[2];
                                                    g.style.display = "none"
                                                }
                                            }
                                        }
                                        var v = this.$("northest-wrapper-" + this.target);
                                        var l = this.$("southest-wrapper-" + this.target);
                                        if (v && l) {
                                            if (q && q.position && q.position.match(/bottom/)) {
                                                l.appendChild(b)
                                            } else {
                                                v.appendChild(b)
                                            }
                                        }
                                        if (!t && !q) {
                                            CanvasXpress.stack[this.target].afterRender.push(["addRemoveDataFilter", [false, d, h, b.type]])
                                        }
                                    } else {
                                        b.className = "CanvasXpressDataFilterContainerHoverableOut";
                                        var i = b.id.split(":")[1];
                                        var j;
                                        if (b.type == "string") {
                                            var e = b.getElementsByClassName("CanvasXpressDataFilterContainerMaskNoOverflowOut");
                                            var c = b.getElementsByClassName("CanvasXpressDataFilterContainerMaskOut");
                                            var g;
                                            if (e.length) {
                                                g = b.childNodes[1];
                                                g.className = "CanvasXpressDataFilterContainerMaskNoOverflow";
                                                g.style.height = g.firstChild.style.height;
                                                g.firstChild.firstChild.style.display = "";
                                                g.firstChild.firstChild.firstChild.style.display = ""
                                            } else {
                                                if (c.length) {
                                                    g = b.childNodes[2];
                                                    g.style.display = ""
                                                }
                                            }
                                            var n = this.$(this.target + ":" + i + ":cX-DataFilterMask");
                                            if (n) {
                                                j = this.rebuildDataTableFilter();
                                                this.addRemoveStringDataFilterListeners("removeEvtListener", n)
                                            }
                                        } else {
                                            var m = this.$(this.target + ":" + i + ":cX-DataFilterMin");
                                            var f = this.$(this.target + ":" + i + ":cX-DataFilterMinLabel");
                                            var r = this.$(this.target + ":" + i + ":cX-DataFilterMax");
                                            var s = this.$(this.target + ":" + i + ":cX-DataFilterMaxLabel");
                                            var a = this.$(this.target + ":" + i + ":cX-DataFilterScale");
                                            if (m && f && r && s) {
                                                j = this.rebuildDataTableFilter();
                                                this.addRemoveNumericDataFilterListeners("removeEvtListener", m, r, f, s, a)
                                            }
                                        }
                                        if (!t) {
                                            CanvasXpress.stack[this.target].afterRender.push(["addRemoveDataFilter", [false, d, h, b.type, i]])
                                        }
                                        o.removeChild(b);
                                        if (j) {
                                            this.rebuildDataTableFilter(j)
                                        }
                                    }
                                };
                                this.changeNumericFilter = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        if (b) {
                                            a.filteringNumericOn = b;
                                            a.updateNumericFilter(c)
                                        }
                                        return false
                                    }
                                }(this);
                                this.mousedownNumericFilter = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        if (b) {
                                            a.filteringNumericOn = b;
                                            a.xMouseDown = c.clientX;
                                            a.yMouseDown = c.clientY
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickNumericFilter = function(a) {
                                    return function(h) {
                                        var d = a.getTargetEvent(h);
                                        if (d) {
                                            var c = a.$(d.id.replace("cX-DataFilterScale", "cX-DataFilterRange"));
                                            var g = a.adjustedCoordinates(h, d);
                                            if (c && g && c.scale) {
                                                var f = a.isIE ? 46 : 44;
                                                var b = parseInt(a.dataFilterWidth - 18);
                                                if (g.x > b - 13) {
                                                    d.className = "CanvasXpressDataFilterContainerScaleLinearLog";
                                                    c.scale = "log"
                                                } else {
                                                    if (g.x > b - 26) {
                                                        d.className = "CanvasXpressDataFilterContainerScaleLogLinear";
                                                        c.scale = "linear"
                                                    }
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.updateNumericFilter = function(v) {
                                    if (this.filteringNumericOn) {
                                        var i = this;
                                        var q = function() {
                                            if (t.parentNode.parentNode.parentNode.className == "CanvasXpressListItem") {
                                                if (i.graphType == "Network") {
                                                    if (f == "node") {
                                                        return i.$(i.target + "-cX-DataFilterNodeContentSearchItems")
                                                    } else {
                                                        return i.$(i.target + "-cX-DataFilterEdgeContentSearchItems")
                                                    }
                                                } else {
                                                    var e;
                                                    if (f == "sample") {
                                                        e = i.getSampleIndices(y);
                                                        return e >= 0 ? i.$(i.target + "-cX-DataFilterVariableContentSearchItems") : i.$(i.target + "-cX-DataFilterSampleContentSearchItems")
                                                    } else {
                                                        e = i.getVariableIndices(y);
                                                        return e >= 0 ? i.$(i.target + "-cX-DataFilterSampleContentSearchItems") : i.$(i.target + "-cX-DataFilterVariableContentSearchItems")
                                                    }
                                                }
                                            } else {
                                                return t.parentNode.parentNode.parentNode
                                            }
                                        };
                                        this.cancelEvent(v);
                                        var t = this.filteringNumericOn;
                                        var x, p, r, h, j, w, b;
                                        if (t.id.match(/cX-DataFilterMin(Label)?/)) {
                                            b = RegExp.$1;
                                            x = true;
                                            p = t.id.replace("cX-DataFilterMin" + b, "cX-DataFilterMin");
                                            r = t.id.replace("cX-DataFilterMin" + b, "cX-DataFilterMax");
                                            h = t.id.replace("cX-DataFilterMin" + b, "cX-DataFilterRange");
                                            j = t.id.replace("cX-DataFilterMin" + b, "cX-DataFilterMinLabel");
                                            w = t.id.replace("cX-DataFilterMin" + b, "cX-DataFilterMaxLabel")
                                        } else {
                                            if (t.id.match(/cX-DataFilterMax(Label)?/)) {
                                                b = RegExp.$1;
                                                x = false;
                                                r = t.id.replace("cX-DataFilterMax" + b, "cX-DataFilterMax");
                                                p = t.id.replace("cX-DataFilterMax" + b, "cX-DataFilterMin");
                                                h = t.id.replace("cX-DataFilterMax" + b, "cX-DataFilterRange");
                                                j = t.id.replace("cX-DataFilterMax" + b, "cX-DataFilterMinLabel");
                                                w = t.id.replace("cX-DataFilterMax" + b, "cX-DataFilterMaxLabel")
                                            }
                                        }
                                        p = this.$(p);
                                        r = this.$(r);
                                        h = this.$(h);
                                        j = this.$(j);
                                        w = this.$(w);
                                        if (p && r && h && j && w) {
                                            var l, u;
                                            var c = CanvasXpress.system.isIE ? 46 : 44;
                                            var m = this.dataFilterWidth - c;
                                            if (b) {
                                                var B = t.value - 0;
                                                var n;
                                                var g = j.value - 0;
                                                var d = w.value - 0;
                                                var s = false;
                                                if (t === w && B < g) {
                                                    B = g;
                                                    s = true
                                                }
                                                if (t === j && B > d) {
                                                    B = d;
                                                    s = true
                                                }
                                                if (B < h.min) {
                                                    B = h.min;
                                                    s = true
                                                }
                                                if (B > h.max) {
                                                    B = h.max;
                                                    s = true
                                                }
                                                if (s) {
                                                    t.value = this.formatNumber(B, h.decis)
                                                }
                                                if (h.scale == "log") {
                                                    u = B ? (Math.log(B) - h.lmin) / h.lunits : 0
                                                } else {
                                                    u = (B - h.min) / h.units
                                                }
                                                u = Math.ceil(u);
                                                if (x) {
                                                    u = Math.ceil(u);
                                                    h.style.width = (parseInt(h.style.width) - u + parseInt(p.style.left)) + "px";
                                                    p.style.left = u + "px";
                                                    h.style.left = u + "px";
                                                    r.style.left = u + "px"
                                                } else {
                                                    h.style.width = Math.max(0, Math.floor(u) - parseInt(p.style.left)) + "px"
                                                }
                                            } else {
                                                l = v.clientX - this.xMouseDown;
                                                u = parseInt(p.style.left) + l;
                                                var a = x ? parseInt(h.style.width) - l : parseInt(h.style.width) + l;
                                                var o = this.absoluteCoordinates(p);
                                                var k = this.absoluteCoordinates(r);
                                                if (x) {
                                                    if (u > 0 && a > 0) {
                                                        this.xMouseDown = v.clientX;
                                                        u = Math.max(0, Math.min(m, u));
                                                        a = Math.max(0, Math.min(m, a))
                                                    } else {
                                                        if (u > 0) {
                                                            u -= l;
                                                            a = (k.x - o.x) - 29
                                                        } else {
                                                            a += u;
                                                            u = 0
                                                        }
                                                    }
                                                    p.style.left = u + "px";
                                                    h.style.left = u + "px";
                                                    h.style.width = a + "px";
                                                    r.style.left = u + "px";
                                                    var z;
                                                    if (h.scale == "log") {
                                                        z = u != 0 ? Math.exp((h.lunits * u) + h.lmin) : 0
                                                    } else {
                                                        z = (h.units * u) + h.min
                                                    }
                                                    z = Math.min(Math.max(z, h.min), parseFloat(w.value));
                                                    j.value = this.formatNumber(z, h.decis)
                                                } else {
                                                    if (u + a <= m && a >= 0) {
                                                        this.xMouseDown = v.clientX;
                                                        u = Math.max(0, Math.min(m, u));
                                                        a = Math.max(0, Math.min(m - u, a))
                                                    } else {
                                                        if (u + a > m) {
                                                            u -= l;
                                                            a = m - u
                                                        }
                                                    }
                                                    h.style.width = Math.max(0, a) + "px";
                                                    var A;
                                                    if (h.scale == "log") {
                                                        A = a != m ? Math.exp((h.lunits * (u + a)) + h.lmin) : h.max
                                                    } else {
                                                        A = (h.units * (u + a)) + h.min
                                                    }
                                                    A = Math.max(Math.min(A, h.max), parseFloat(j.value));
                                                    w.value = this.formatNumber(A, h.decis)
                                                }
                                            }
                                            var y = h.uvalue;
                                            var f = h.filter;
                                            if (!this.toDoFilter) {
                                                this.toDoFilter = {}
                                            }
                                            if (!this.toDoFilter[f]) {
                                                this.toDoFilter[f] = {}
                                            }
                                            if (!this.toDoFilter[f][y]) {
                                                this.toDoFilter[f][y] = {}
                                            }
                                            if (b) {
                                                if (x) {
                                                    this.toDoFilter[f][y]["min"] = B
                                                } else {
                                                    this.toDoFilter[f][y]["max"] = B
                                                }
                                            } else {
                                                if (z != null) {
                                                    this.toDoFilter[f][y]["min"] = z
                                                }
                                                if (A != null) {
                                                    this.toDoFilter[f][y]["max"] = A
                                                }
                                            }
                                            if (h.ref != null) {
                                                this.toDoFilter[f][y]["ref"] = h.ref
                                            }
                                            this.refreshDataFilters(q(), f, y);
                                            if (b) {
                                                this.endNumericFilter(v)
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.endNumericFilter = function(a) {
                                    if (this.filteringNumericOn) {
                                        this.updateDataFilter(false, false, a);
                                        this.filteringNumericOn = false
                                    }
                                };
                                this.createStringFilter = function(y, j, x, a, w, p) {
                                    x.sort();
                                    x.unshift("(All) " + x.length + " values");
                                    x.push("");
                                    var r = j.replace(/\W/g, "_");
                                    var b = w ? this.target + ":" + r + "_" : this.target + ":" + r;
                                    var u = this.$cX("div", {
                                        id: b + ":cX-DataFilterContainer",
                                        className: "CanvasXpressDataFilterContainerHoverable",
                                        type: "string",
                                        args: [y, j, x, a, w]
                                    });
                                    if (w) {
                                        u.style.width = "180px"
                                    }
                                    var h = this.$cX("div", {
                                        id: b + ":cX-DataFilterLabel",
                                        innerHTML: j,
                                        draggable: true
                                    }, {
                                        width: "98%",
                                        margin: "5px"
                                    });
                                    var n = this.$cX("input", {
                                        id: b + ":cX-DataFilterInput",
                                        type: "text",
                                        placeholder: " Search values"
                                    }, {
                                        cursor: "default",
                                        width: "92%",
                                        marginLeft: "5px"
                                    });
                                    var f = this.$cX("div", {
                                        id: b + ":cX-DataFilterMask",
                                        className: x.length - 2 > this.maxItemMenuCheckbox ? "CanvasXpressDataFilterContainerMask" : "CanvasXpressDataFilterContainerMaskNoOverflow"
                                    }, {
                                        height: x.length - 2 > this.maxItemMenuCheckbox ? "80px" : (((x.length - 1) * 19) + 4) + "px"
                                    });
                                    var A = this.$cX("div", {
                                        id: b + ":cX-DataFilterScroll",
                                        type: (x.length - 2) > this.maxItemMenuCheckbox ? "long" : "short",
                                        filter: y,
                                        uvalue: j,
                                        values: x,
                                        fvalues: x,
                                        selected: {
                                            0: p ? false : true
                                        },
                                        ref: a,
                                        skey: r,
                                        last: 0
                                    }, {
                                        backgroundColor: "rgba(255, 255, 255, 0.95)",
                                        height: x.length - 2 > this.maxItemMenuCheckbox ? ((x.length + 1) * 16) + "px" : (((x.length - 1) * 19) + 4) + "px"
                                    });
                                    var c = this.$cX("div", {
                                        id: b + ":cX-DataFilterOptions"
                                    }, {
                                        width: "100%",
                                        position: "relative"
                                    });
                                    this.loadStringFilter(x, r, c, x.length, false, w, p);
                                    A.appendChild(c);
                                    f.appendChild(A);
                                    u.appendChild(h);
                                    if (x.length - 2 > this.maxItemMenuCheckbox) {
                                        u.appendChild(n)
                                    }
                                    u.appendChild(f);
                                    this.addRemoveStringDataFilterListeners("addEvtListener", f);
                                    return u
                                };
                                this.loadStringFilter = function(E, t, h, j, F, B, x) {
                                    if (E && t && h) {
                                        var D = x ? this.getObjectArray(x) : false;
                                        if (j - 2 > this.maxItemMenuCheckbox) {
                                            for (var u = 0; u < Math.min(5, E.length); u++) {
                                                var b = E[u].length > 30 ? E[u].substr(0, 30) + " ..." : E[u];
                                                var A = (!F && !x && u == 0) || (F && F.hasOwnProperty(E[u])) || (x && D.hasOwnProperty(E[u])) ? "CanvasXpressDataFilterContainerItemSelected" : "CanvasXpressDataFilterContainerItem";
                                                var e = B ? this.target + ":" + t + "_:cX-DataFilterItem-" + u : this.target + ":" + t + ":cX-DataFilterItem-" + u;
                                                var C = this.$cX("div", {
                                                    id: e,
                                                    className: A,
                                                    innerHTML: b,
                                                    title: E[u],
                                                    index: u
                                                }, {});
                                                h.appendChild(C)
                                            }
                                        } else {
                                            for (var u = 0; u < E.length - 1; u++) {
                                                var b = E[u].length > 30 ? E[u].substr(0, 30) + " ..." : E[u];
                                                var e = B ? this.target + ":" + t + "_:cX-DataFilterDivItem-" + u : this.target + ":" + t + ":cX-DataFilterDivItem-" + u;
                                                var y = this.$cX("div", {
                                                    id: e,
                                                    title: E[u],
                                                    value: b,
                                                    index: u
                                                });
                                                var f = B ? this.target + ":" + t + "_:cX-DataFilterInputItem-" + u : this.target + ":" + t + ":cX-DataFilterInputItem-" + u;
                                                var C = this.$cX("input", {
                                                    id: f,
                                                    className: "CanvasXpressCheckbox",
                                                    type: "checkbox",
                                                    checked: F && !F.hasOwnProperty(E[u]) ? false : true,
                                                    value: b,
                                                    index: u,
                                                    name: ""
                                                });
                                                if (x) {
                                                    C.checked = D.hasOwnProperty(E[u]) ? true : false
                                                }
                                                var m = this.$cX("label", {
                                                    "for": this.target + ":" + t + ":cX-DataFilterItem-" + u,
                                                    className: "CanvasXpressCheckboxLabel",
                                                    innerHTML: E[u]
                                                });
                                                y.appendChild(C);
                                                y.appendChild(m);
                                                h.appendChild(y)
                                            }
                                        }
                                    }
                                };
                                this.addRemoveStringDataFilterListeners = function(c, b) {
                                    if (c && b) {
                                        var a = b.parentNode.firstElementChild;
                                        if (b.firstChild.type == "long") {
                                            this[c](b, "scroll", this.scrollStringFilter, false)
                                        }
                                        this[c](b, "mousedown", this.registerStringFilter, false);
                                        this[c](b, "mouseup", this.endStringFilter, false);
                                        this[c](a, "dragstart", this.dragStartDataFilter, false);
                                        this[c](a, "dragend", this.dragEndDataFilter, false)
                                    }
                                };
                                this.scrollStringFilter = function(a) {
                                    return function(j, c, n) {
                                        if (!c) {
                                            c = a.getTargetEvent(j)
                                        }
                                        var p = c.firstChild;
                                        var f = p.firstChild;
                                        var g = p.skey;
                                        if (p.fvalues) {
                                            var m = Math.max(0, Math.min(Math.ceil(c.scrollTop / 16), p.fvalues.length - 5));
                                            f.style.top = c.scrollTop + "px";
                                            for (var h = 0; h < Math.min(5, p.fvalues.length); h++) {
                                                var l = a.$(a.target + ":" + g + ":cX-DataFilterItem-" + h) || a.$(a.target + ":" + g + "_:cX-DataFilterItem-" + h);
                                                if (l) {
                                                    var c = p.fvalues[m + h].length > 30 ? p.fvalues[m + h].substr(0, 30) + " ..." : p.fvalues[m + h];
                                                    l.className = p.selected[m + h] ? "CanvasXpressDataFilterContainerItemSelected" : "CanvasXpressDataFilterContainerItem";
                                                    l.innerHTML = c;
                                                    l.title = p.fvalues[m + h];
                                                    l.index = m + h
                                                }
                                            }
                                            if (a.filteringStringOn && !n) {
                                                a.updateSelectStringFilter(false, a.$(a.target + ":" + g + ":cX-DataFilterItem-4"), true)
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.registerStringFilter = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        if (!b.id) {
                                            b = b.parentNode
                                        }
                                        if (!b.id.match(/cX-DataFilterMask/)) {
                                            if (!b.id.match(/cX-DataFilterDivItem/)) {
                                                if (b.parentNode.id.match(/cX-DataFilterDivItem/)) {
                                                    a.updateSelectStringFilter(false, b, false, true);
                                                    a.filteringStringOn = b.parentNode
                                                } else {
                                                    a.$(b.parentNode.id.replace("cX-DataFilterOptions", "cX-DataFilterInput")).value = "";
                                                    a.updateSelectStringFilter(false, b, c.shiftKey, c.ctrlKey);
                                                    a.filteringStringOn = b
                                                }
                                            } else {
                                                a.updateSelectStringFilter(false, b.firstChild, false, true);
                                                a.filteringStringOn = b
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.endStringFilter = function(a) {
                                    return function(k, d, g) {
                                        if (!d && a.filteringStringOn && a.filteringStringOn.parentNode) {
                                            d = a.filteringStringOn.parentNode.parentNode
                                        }
                                        if (!d || !d.selected) {
                                            return
                                        }
                                        var m = function() {
                                            if (d.parentNode.parentNode.parentNode.className == "CanvasXpressListItem") {
                                                if (a.graphType == "Network") {
                                                    if (j == "node") {
                                                        return a.$(a.target + "-cX-DataFilterNodeContentSearchItems")
                                                    } else {
                                                        return a.$(a.target + "-cX-DataFilterEdgeContentSearchItems")
                                                    }
                                                } else {
                                                    var e;
                                                    if (j == "sample") {
                                                        e = a.getVariableIndices(t);
                                                        return e >= 0 ? a.$(a.target + "-cX-DataFilterVariableContentSearchItems") : a.$(a.target + "-cX-DataFilterSampleContentSearchItems")
                                                    } else {
                                                        e = a.getSampleIndices(t);
                                                        return e >= 0 ? a.$(a.target + "-cX-DataFilterSampleContentSearchItems") : a.$(a.target + "-cX-DataFilterVariableContentSearchItems")
                                                    }
                                                }
                                            } else {
                                                return d.parentNode.parentNode.parentNode
                                            }
                                        };
                                        var u = d.selected;
                                        var j = d.filter;
                                        var t = d.uvalue;
                                        var b = d.ref;
                                        var p = d.fvalues;
                                        var c = g ? "like" : "exact";
                                        var n;
                                        if (!a.toDoFilter) {
                                            a.toDoFilter = {}
                                        }
                                        if (!u[0]) {
                                            if (!a.toDoFilter[j]) {
                                                a.toDoFilter[j] = {}
                                            }
                                            if (!a.toDoFilter[j][t]) {
                                                a.toDoFilter[j][t] = {}
                                            }
                                            a.toDoFilter[j][t][c] = [];
                                            for (var h in u) {
                                                a.toDoFilter[j][t][c].push(p[h])
                                            }
                                            if (b != null) {
                                                a.toDoFilter[j][t]["ref"] = b
                                            }
                                        } else {
                                            if (a.toDoFilter[j] && a.toDoFilter[j][t]) {
                                                delete(a.toDoFilter[j][t])
                                            }
                                            if (a.toDoFilter[j] && Object.keys(a.toDoFilter[j]).length == 0) {
                                                delete(a.toDoFilter[j])
                                            }
                                        }
                                        if (Object.keys(a.toDoFilter).length == 0) {
                                            if (a.layoutComb) {
                                                for (var h = 0; h < a.layoutParams.length; h++) {
                                                    delete a.layoutParams[h].dragged
                                                }
                                            }
                                            a.reset(true)
                                        }
                                        a.filteringStringOn = true;
                                        a.updateDataFilter(false, false, k);
                                        a.refreshDataFilters(m(), j, t, d.parentNode.parentNode.parentNode.className == "CanvasXpressListItem" ? d.parentNode.parentNode.parentNode : false);
                                        a.scrollStringFilter(false, d.parentNode, true);
                                        a.filteringStringOn = false;
                                        return false
                                    }
                                }(this);
                                this.updateStringFilter = function(c) {
                                    var a = this.getTargetEvent(c);
                                    var d = this.filteringStringOn && this.filteringStringOn.id ? this.filteringStringOn.id.replace(/-\d$/, "") : "";
                                    if (a.id.match(d) && !c.ctrlKey) {
                                        this.updateSelectStringFilter(false, a, true);
                                        this.dragStringFilter = [a.parentNode.parentNode.parentNode, a.id.split("-")[2]]
                                    } else {
                                        if (this.dragStringFilter) {
                                            var b = this.dragStringFilter[1] >= 3 ? 16 : -16;
                                            this.dragStringFilter[0].scrollTop += b;
                                            this.scrollStringFilter(false, this.dragStringFilter[0], false)
                                        }
                                    }
                                };
                                this.updateSelectStringFilter = function(j, I, F, c) {
                                    if (j) {
                                        var H = this.$(j);
                                        var A = this.$(j.replace("cX-DataFilterInput", "cX-DataFilterScroll"));
                                        var k = A.fvalues.length > 10000 ? 2 : A.fvalues.length > 1000 ? 1 : 0;
                                        if (H.value && H.value.length > k) {
                                            var u;
                                            try {
                                                u = new RegExp(H.value.toLowerCase())
                                            } catch (H) {
                                                return
                                            }
                                            var B = 0;
                                            var y = A.firstChild;
                                            var J = y.childNodes[0].index;
                                            var G = null;
                                            var m = 0;
                                            A.selected = {};
                                            for (var D = 1; D < A.fvalues.length - 1; D++) {
                                                if (A.fvalues[D].toLowerCase().match(u)) {
                                                    if (!G) {
                                                        G = D;
                                                        m = D * 16
                                                    }
                                                    A.selected[D] = true;
                                                    B++
                                                }
                                            }
                                            if (B + 2 == A.fvalues.length) {
                                                A.selected = {
                                                    0: true
                                                };
                                                G = 0
                                            }
                                            if (G != null) {
                                                A.parentNode.scrollTop = m;
                                                this.scrollStringFilter(false, A.parentNode)
                                            }
                                            this.endStringFilter(false, A)
                                        } else {
                                            this.resetSelectStringFilter(A);
                                            this.endStringFilter(false, A)
                                        }
                                    } else {
                                        if (I) {
                                            var d = I.index;
                                            var y = I.parentNode;
                                            var w = false;
                                            if (!y.id) {
                                                return false
                                            }
                                            while (!y.id.match(/cX-DataFilterOptions/)) {
                                                y = y.parentNode;
                                                w = true;
                                                if (!y.id) {
                                                    return false
                                                }
                                            }
                                            var m = y.parentNode;
                                            var C = m.last;
                                            var E = m.selected;
                                            var g = m.fvalues;
                                            var J = y.childNodes[0].index;
                                            var B = 0;
                                            var a = c && m.selected[d];
                                            m.selected = {};
                                            if (!a) {
                                                m.selected[d] = true
                                            }
                                            if (F) {
                                                if (d > C) {
                                                    for (var D = C; D <= d; D++) {
                                                        m.selected[D] = true;
                                                        if (D) {
                                                            B++
                                                        }
                                                    }
                                                } else {
                                                    for (var D = d; D <= C; D++) {
                                                        m.selected[D] = true;
                                                        if (D) {
                                                            B++
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (c) {
                                                    if (!a) {
                                                        m.last = d
                                                    }
                                                    if (w && d == 0) {
                                                        for (var D = 0; D < g.length - 1; D++) {
                                                            m.selected[D] = true
                                                        }
                                                    } else {
                                                        for (var D in E) {
                                                            if (D == d && a) {
                                                                continue
                                                            }
                                                            m.selected[D] = true;
                                                            if (D) {
                                                                B++
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    m.last = d
                                                }
                                            }
                                            if (B > 0) {
                                                delete(m.selected[0])
                                            }
                                            if (!w) {
                                                delete(m.selected[g.length - 1]);
                                                for (var D = 0; D < y.childNodes.length; D++) {
                                                    y.childNodes[D].className = m.selected[D + J] ? "CanvasXpressDataFilterContainerItemSelected" : "CanvasXpressDataFilterContainerItem"
                                                }
                                            }
                                        }
                                    }
                                };
                                this.resetSelectStringFilter = function(a) {
                                    if (a) {
                                        a.selected = {
                                            0: true
                                        };
                                        var b = a.parentNode;
                                        b.scrollTop = 0;
                                        this.scrollStringFilter(false, b)
                                    }
                                };
                                this.updateSearchFilters = function(e) {
                                    var g = this.$(e).parentNode.parentNode;
                                    if (g) {
                                        var h = g.childNodes;
                                        var b = new RegExp(h[0].firstChild.value, "i");
                                        for (var d = 0; d < h[1].childNodes.length; d++) {
                                            var a = h[1].childNodes[d].id.split(":");
                                            if (a[1].match(b)) {
                                                h[1].childNodes[d].style.display = "block"
                                            } else {
                                                h[1].childNodes[d].style.display = "none"
                                            }
                                        }
                                    }
                                };
                                this.hideDataFilter = function(a) {
                                    return function(c, b) {
                                        a.removeMenus();
                                        var f = a.$(a.target + "-cX-DataFilter");
                                        if (f) {
                                            delete(a.dragStringFilter);
                                            a.moveDataFilter(true, false, b, c)
                                        }
                                        return false
                                    }
                                }(this);
                                this.dockUndockDataFilter = function(a) {
                                    return function(c) {
                                        var b = a.$(a.target + "-cX-DataFilter");
                                        if (b) {
                                            a.moveDataFilter()
                                        }
                                        return false
                                    }
                                }(this);
                                this.resetDataFilter = function(a) {
                                    return function(j, k, d, b, c) {
                                        if (a.isTransition()) {
                                            return
                                        }
                                        a.resetFilters();
                                        a.refreshDataFilters(false, false, false, false, true);
                                        a.toDoFilter = {};
                                        a.reset(false, false, j);
                                        a.updateDataTable();
                                        var i = j && (j.shiftKey || j.ctrlKey || j.altKey || j.metaKey);
                                        if (d) {
                                            var g = a.$(a.target + "-cX-DataFilter");
                                            if (g) {
                                                a.removeGenericDataFilterListenersOrReset();
                                                g.parentNode.removeChild(g);
                                                a.addDataFilterDiv()
                                            }
                                        } else {
                                            a.removeGenericDataFilterListenersOrReset(true)
                                        }
                                        if (a.sorting && !i) {
                                            a.sortIndices.apply(a, a.sorting)
                                        }
                                        if (b) {
                                            this.varIndices = b
                                        }
                                        if (c) {
                                            this.smpIndices = c
                                        }
                                        if (a.motionBy && a.motionObject) {
                                            a.motionObject.varIndices = a.cloneObject(a.varIndices);
                                            a.motionObject.smpIndices = a.cloneObject(a.smpIndices)
                                        }
                                        if (!k) {
                                            if (a.isGroupedData) {
                                                a.groupSamples(a.groupingFactors)
                                            } else {
                                                a.draw({
                                                    func: "resetDataFilter",
                                                    par: [j, k, d, b, c]
                                                })
                                            }
                                        } else {
                                            this.regroupSamples()
                                        }
                                        return false
                                    }
                                }(this);
                                this.rebuildDataFilter = function() {
                                    this.resetDataFilter(false, true, true)
                                };
                                this.initializeDataFilters = function() {
                                    if (this.filtersExposed.length) {
                                        this.showDataFilter();
                                        for (var a = 0; a < this.filtersExposed.length; a++) {
                                            var b = this.filtersExposed[a];
                                            var c = this.$(this.target + ":" + b.name + ":cX-DataFilterContainer");
                                            if (c) {
                                                this.addRemoveDataFilter(c, false, false, false, false, b)
                                            }
                                        }
                                        this.hideDataFilter()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initDataTable = function() {
                                this.addDataTableDiv = function(M, N) {
                                    if (this.$(this.target + "-cX-DataTable")) {
                                        return
                                    }
                                    var F = this;
                                    var g = function() {
                                        if (F.graphType.match(/Correlation|Venn/)) {
                                            return "none"
                                        } else {
                                            return "block"
                                        }
                                    };
                                    var R = function(n, d, b) {
                                        var o = F.$cX(d == 0 || b == 0 ? "th" : "td", {
                                            id: F.target + "-cX-DataTableCell." + d + "." + b,
                                            className: d == 0 || b == 0 ? "CanvasXpressTableCellHead" : "CanvasXpressTableCell"
                                        }, {
                                            width: F.colWidth + "px",
                                            height: F.rowHeight + "px"
                                        });
                                        if (F.dataTableStyle == "stripped") {
                                            o.style.background = d % 2 ? "rgba(0,0,0,0)" : "rgba(0,0,0,0.05)"
                                        } else {
                                            o.style.background = ""
                                        }
                                        if (d == 0) {
                                            o.style.textAlign = "center"
                                        }
                                        n.appendChild(o)
                                    };
                                    if (!N) {
                                        this.setDataTableDimensions(M)
                                    }
                                    var c = 60;
                                    var V = 60;
                                    var G = this.dataTableLastX != null ? parseInt(this.dataTableLastX) : 0;
                                    var E = this.dataTableLastY != null ? parseInt(this.dataTableLastY) : -this.meta.canvas.ctx.canvas.height * 0.25;
                                    var H = this.dataTableLastWidth || this.dataTableColsWidth + c;
                                    var O = this.dataTableLastHeight || this.dataTableRowsHeight + V;
                                    var L = ((this.colWidth + 8) * 3) + 6;
                                    var a = ((this.rowHeight + 4) * 3) + 8;
                                    var T = this.$cX("div", {
                                        id: this.target + "-cX-DataTable",
                                        className: "CanvasXpressDataTable draggable-container"
                                    }, {
                                        top: E + "px",
                                        left: G + "px",
                                        width: H + "px",
                                        height: O + "px",
                                        minWidth: (L + c) + "px",
                                        minHeight: (a + V + 28) + "px",
                                        display: "none",
                                        marginTop: "3px",
                                        border: this.dataTableStyle == "stripped" ? "none" : "1px solid rgb(51, 122, 183)",
                                        backgroundColor: this.backgroundDataTable
                                    });
                                    var l = this.$cX("div", {
                                        id: this.target + "-cX-DataTableToolbar",
                                        className: "CanvasXpressDataTableToolbar draggable"
                                    }, {
                                        position: "absolute",
                                        overflow: "hidden",
                                        width: H + "px",
                                        minWidth: (L + c) + "px",
                                        height: 0,
                                        top: 0,
                                        right: 0,
                                        zIndex: 1,
                                        backgroundColor: "rgba(255,255,255,0)"
                                    });
                                    var p = this.$cX("div", {
                                        id: this.target + "-cX-DataTableToolbarImages",
                                        className: "CanvasXpressDataTableToolbar"
                                    }, {
                                        cssFloat: "right",
                                        position: "relative",
                                        height: "36px",
                                        backgroundColor: "rgba(0,0,0,0)"
                                    });
                                    var f = this.$cXI(this.getGraphTypeIcon(), {
                                        id: this.target + "-cX-DataTableViewImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: this.getGraphTypeIcon(),
                                        title: "View " + this.graphType
                                    }, {
                                        display: "none"
                                    });
                                    var y = this.$cXI("sv_disk", {
                                        id: this.target + "-cX-DataTableSaveImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: "sv_disk",
                                        title: "Save data"
                                    });
                                    var h = this.$cXI("ar_minmax", {
                                        id: this.target + "-cX-DataTableMaximizeMinimizeImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: "ar_minmax",
                                        title: "Minimize / Maximize"
                                    });
                                    var z = this.$cXI("at_col", {
                                        id: this.target + "-cX-DataTableColorImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: "at_col",
                                        title: "Color Data Table"
                                    }, {
                                        display: g()
                                    });
                                    var S = this.$cXI("tb_stripped", {
                                        id: this.target + "-cX-DataTableStripeImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: "tb_stripped",
                                        title: "Toggle Stripe Data Table"
                                    });
                                    var q = this.$cXI("dtt_transpose", {
                                        id: this.target + "-cX-DataTableTransposeImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: "dtt_transpose",
                                        title: "Transpose data"
                                    });
                                    var v = this.$cXI(this.networkShowDataTable == "nodes" ? "n_edges" : "n_nodes", {
                                        id: this.target + "-cX-DataTableNetworkImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: this.networkShowDataTable == "nodes" ? "n_edges" : "n_nodes",
                                        title: this.networkShowDataTable == "nodes" ? "Show edge data" : "Show node data"
                                    }, {
                                        display: this.graphType == "Network" ? "block" : "none"
                                    });
                                    var u = this.$cXI("fp_funnelremove", {
                                        id: this.target + "-cX-DataTableFilterResetImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: "fp_funnelremove",
                                        title: "Reset filters"
                                    });
                                    var B = this.$cXI(this.dataTableLastState && this.dataTableLastState == "docked" ? "fp_pinremove" : "fp_pin", {
                                        id: this.target + "-cX-DataTableDockImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: this.dataTableLastState && this.dataTableLastState == "docked" ? "fp_pinremove" : "fp_pin",
                                        title: this.dataTableLastState && this.dataTableLastState == "docked" ? "Undock" : "Dock"
                                    });
                                    var D = this.$cXI("op_cancel", {
                                        id: this.target + "-cX-DataTableCloseImage",
                                        className: "CanvasXpressDataTableToolbarImage",
                                        src: "op_cancel",
                                        title: "Close table"
                                    }, {
                                        marginRight: "10px"
                                    });
                                    var A = this.$cX("input", {
                                        id: this.target + "-cX-DataTableSearch",
                                        type: "text",
                                        placeholder: "Search"
                                    }, {
                                        cursor: "default",
                                        borderRadius: "3px",
                                        width: "101px",
                                        margin: "2px 2px 2px 32px",
                                        padding: "5px",
                                        border: "1px solid #ccc",
                                        cssFloat: "left",
                                        backgroundColor: this.backgroundDataTable
                                    });
                                    var x = this.$cX("div", {
                                        id: this.target + "-cX-DataTableContainer",
                                        className: "CanvasXpressDataTableContainer"
                                    }, {
                                        width: H + "px",
                                        height: (O - 28) + "px",
                                        minWidth: (L + c) + "px",
                                        minHeight: (a + V) + "px"
                                    });
                                    var W = this.$cX("div", {
                                        id: this.target + "-cX-DataTableTableMask",
                                        className: "CanvasXpressDataTableMask"
                                    }, {
                                        width: (H - c) + "px",
                                        height: (O - V) + "px",
                                        minWidth: L + "px",
                                        minHeight: (a + 28) + "px"
                                    });
                                    var J = this.$cX("table", {
                                        id: this.target + "-cX-DataTableTable",
                                        className: "CanvasXpressDataTable"
                                    }, {
                                        fontSize: this.dataTableFontSize + "px",
                                        fontFamily: this.dataTableFontFamily
                                    });
                                    if (this.dataTableStyle == "stripped") {
                                        J.style.setProperty("border-collapse", "collapse", "important")
                                    }
                                    var U = this.$cX("tbody");
                                    for (var Q = 0; Q < this.maxRows; Q++) {
                                        var K = this.$cX("tr");
                                        for (var P = 0; P < this.maxCols; P++) {
                                            R(K, Q, P)
                                        }
                                        U.appendChild(K)
                                    }
                                    var e = this.$cX("div", {
                                        id: this.target + "-cX-DataTableVer",
                                        className: "CanvasXpressDataTableVertical"
                                    }, {
                                        height: (O - V) + "px",
                                        minHeight: (a + 28) + "px",
                                        backgroundColor: this.backgroundDataTable
                                    });
                                    var s = this.$cX("img", {
                                        id: this.target + "-cX-DataTableVerImage",
                                        className: "CanvasXpressDataTableVertical",
                                        src: CanvasXpress.png,
                                        width: 1,
                                        height: this.dataTableTotalHeight,
                                        title: "",
                                        alt: ""
                                    });
                                    e.appendChild(s);
                                    var k = this.$cX("div", {
                                        id: this.target + "-cX-DataTableHor",
                                        className: "CanvasXpressDataTableHorizontal"
                                    }, {
                                        width: (H - c) + "px",
                                        minWidth: L + "px",
                                        backgroundColor: this.backgroundDataTable
                                    });
                                    var C = this.$cX("img", {
                                        id: this.target + "-cX-DataTableHorImage",
                                        className: "CanvasXpressDataTableHorizontal",
                                        src: CanvasXpress.png,
                                        width: this.dataTableTotalWidth,
                                        height: 1,
                                        title: "",
                                        alt: ""
                                    });
                                    k.appendChild(C);
                                    var m = this.$cX("div", {
                                        id: this.target + "-cX-DataTableResizer",
                                        className: "CanvasXpressDataTableResizer resizable"
                                    });
                                    l.appendChild(A);
                                    p.appendChild(D);
                                    p.appendChild(B);
                                    p.appendChild(u);
                                    p.appendChild(q);
                                    p.appendChild(S);
                                    p.appendChild(z);
                                    p.appendChild(h);
                                    p.appendChild(y);
                                    p.appendChild(f);
                                    p.appendChild(v);
                                    l.appendChild(p);
                                    J.appendChild(U);
                                    W.appendChild(J);
                                    x.appendChild(W);
                                    x.appendChild(e);
                                    x.appendChild(k);
                                    x.appendChild(m);
                                    T.appendChild(l);
                                    T.appendChild(x);
                                    var I = this.$("south-wrapper-" + this.target);
                                    if (I) {
                                        I.appendChild(T);
                                        this.modifyDataTableToolbarView();
                                        this.addRemoveDataTableListeners("addEvtListener");
                                        return T
                                    }
                                };
                                this.showDataTableToolbar = function(h, b, f) {
                                    var d = this;
                                    var g = function() {
                                        d.isDataTableToolbarBusy = false
                                    };
                                    var a = this.$(this.target + "-cX-DataTableToolbar");
                                    if (a && parseInt(a.style.height) == 0 && !this.isDataTableToolbarBusy) {
                                        this.isDataTableToolbarBusy = true;
                                        var c = parseInt(a.parentNode.style.width);
                                        this.resizeMove(a, 0, 0, c, 36, 250, g)
                                    }
                                };
                                this.hideDataTableToolbar = function(g, b, j) {
                                    var f = this;
                                    var h = function() {
                                        f.isDataTableToolbarBusy = false
                                    };
                                    var d = this.$(this.target + "-cX-DataTableToolbar");
                                    var a = this.$(this.target + "-cX-DataTableSearch");
                                    var i = Math.abs(j.y);
                                    if (b && Math.abs(b.offsetTop) - i < 36) {
                                        return
                                    }
                                    if (a && (document.activeElement == a || a.value != "")) {
                                        return
                                    }
                                    if (d && parseInt(d.style.height) == 36 && !this.isDataTableToolbarBusy) {
                                        this.isDataTableToolbarBusy = true;
                                        var c = parseInt(d.parentNode.style.width);
                                        this.resizeMove(d, 0, 0, c, 0, 500, h)
                                    }
                                };
                                this.isDataTableToolbar = function(c) {
                                    var a = this.getTargetEvent(c);
                                    var b = this.adjustedCoordinates(c, a);
                                    if (a && a.id == this.target + "-cX-DataTable" && b) {
                                        var d = Math.abs(b.y);
                                        if (Math.abs(a.offsetTop) - d < 36) {
                                            this.showDataTableToolbar(c, a, b)
                                        } else {
                                            this.hideDataTableToolbar(c, a, b)
                                        }
                                    } else {
                                        this.hideDataTableToolbar(c, a, b)
                                    }
                                };
                                this.modifyDataTableToolbarView = function() {
                                    var a = this.$(this.target + "-cX-DataTableViewImage");
                                    var c = [this.$(this.target + "-cX-DataTableDockImage"), this.$(this.target + "-cX-DataTableCloseImage"), this.$(this.target + "-cX-DataTableResizer")];
                                    if (this.view == "canvas") {
                                        a.style.display = "none";
                                        for (var b = 0; b < c.length; b++) {
                                            c[b].style.display = "block"
                                        }
                                    } else {
                                        a.style.display = this.dataTableMaximized && !this.maximized ? "none" : "block";
                                        for (var b = 0; b < c.length; b++) {
                                            c[b].style.display = "none"
                                        }
                                    }
                                };
                                this.getGraphTypeIcon = function() {
                                    var a = {
                                        Area: "g_area",
                                        AreaLine: "g_arealine",
                                        Bar: "g_bar",
                                        BarLine: "g_barline",
                                        Boxplot: "g_boxplot",
                                        Circular: "g_circular",
                                        Correlation: "g_correlation",
                                        DotLine: "g_dotline",
                                        Dotplot: "g_dotplot",
                                        Fish: "g_fish",
                                        Gantt: "g_gantt",
                                        Heatmap: "g_heatmap",
                                        Line: "g_line",
                                        Map: "g_map",
                                        Meter: "g_meter",
                                        Network: "g_network",
                                        Pie: "g_pie",
                                        Scatter2D: "g_scatter2d",
                                        ScatterBubble2D: "g_scatterbubble2d",
                                        Scatter3D: "g_scatter3d",
                                        Stacked: "g_stacked",
                                        StackedLine: "g_stackedline",
                                        StackedPercent: "g_stackedpercent",
                                        StackedPercentLine: "g_stackedpercentline",
                                        TagCloud: "g_tagcloud",
                                        ParallelCoordinates: "g_parallelcoordinates",
                                        Sankey: "g_sankey",
                                        Tree: "g_tree",
                                        Treemap: "g_treemap",
                                        Venn: "g_venn"
                                    };
                                    return a[this.graphType] || CanvasXpress.png
                                };
                                this.addRemoveDataTableListeners = function(a) {
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTable"), "mousewheel", this.scrollDataTable, {
                                        passive: false
                                    });
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableHor"), "scroll", this.scrollTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableVer"), "scroll", this.scrollTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableToolbar"), "mousedown", this.registerMousemove, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableViewImage"), "click", this.clickView, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableSaveImage"), "click", this.saveTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableMaximizeMinimizeImage"), "click", this.maximizeMinimizeTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableStripeImage"), "click", this.stripeTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableColorImage"), "click", this.colorTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableFilterResetImage"), "click", this.filterResetTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableNetworkImage"), "click", this.networkUpdateTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableTransposeImage"), "click", this.transposeDataTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableDockImage"), "click", this.dockUndockTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCloseImage"), "click", this.hideTable, false);
                                    this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableResizer"), "mousedown", this.mousedownDataTableResizer, false);
                                    var e = this.maxRows;
                                    var f = this.maxCols;
                                    for (var d = 0; d < f; d++) {
                                        this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell.0." + d), "click", this.clickDataTableHeader, false);
                                        this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell.0." + d), "mousemove", this.mousemoveDataTableHeader, false);
                                        this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell.0." + d), "mousedown", this.mousedownDataTableHeader, false);
                                        this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell.0." + d), "mouseover", this.mouseoverDataTableHeader, false);
                                        this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell.0." + d), "mouseout", this.mouseoutDataTableHeader, false)
                                    }
                                    for (var d = 0; d < e; d++) {
                                        this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell." + d + ".0"), "mouseover", this.mouseoverDataTableHeader, false);
                                        this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell." + d + ".0"), "mouseout", this.mouseoutDataTableHeader, false)
                                    }
                                    for (var d = 1; d < e; d++) {
                                        for (var b = 1; b < f; b++) {
                                            this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell." + d + "." + b), "mouseover", this.mouseoverDataTableCell, false);
                                            this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell." + d + "." + b), "mouseout", this.mouseoutDataTableCell, false);
                                            this.addRemoveEvtListener(a, this.$(this.target + "-cX-DataTableCell." + d + "." + b), "click", this.clickDataTableCell, false)
                                        }
                                    }
                                };
                                this.scrollDataTable = function(a) {
                                    return function(c) {
                                        a.removeMenus();
                                        a.cancelEvent(c);
                                        var b = a.$(a.target + "-cX-DataTableVer");
                                        if (b) {
                                            if (c.wheelDelta > 0) {
                                                b.scrollTop += 100
                                            } else {
                                                b.scrollTop -= 100
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.scrollTable = function(a) {
                                    return function(g) {
                                        a.removeMenus();
                                        var j = a.$(a.target + "-cX-DataTable");
                                        var b = a.$(a.target + "-cX-DataTableVer");
                                        var f = a.$(a.target + "-cX-DataTableHor");
                                        if (j && b && f && !a.resizingDataTableOn) {
                                            var i = Math.ceil(f.scrollLeft / (f.scrollWidth / a.totalCols));
                                            var c = Math.ceil(b.scrollTop / (b.scrollHeight / a.totalRows));
                                            a.dataTableLastScrollLeft = f.scrollLeft;
                                            a.dataTableLastScrollTop = b.scrollTop;
                                            a.dataTableLastScrollWidth = f.scrollWidth;
                                            a.dataTableLastScrollHeight = b.scrollHeight;
                                            if (i != a.startCol || c != a.startRow) {
                                                a.startCol = i;
                                                a.startRow = c;
                                                a.updateDataTable()
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.maximizeMinimizeTable = function(a) {
                                    return function(j) {
                                        a.removeMenus();
                                        var n = window;
                                        var o = n.document;
                                        var f = a.$(a.target + "-cX-DataTable");
                                        var m = a.$(a.target + "-cX-DataFilter");
                                        var i = n.innerWidth;
                                        var c = n.innerHeight;
                                        var l = a.remoteService ? a.$(a.remoteParentId + "-canvasXpressRemoteWindow") : a.$("container-" + a.target);
                                        var d = a.$(a.target + "-cX-DataTableViewImage");
                                        var h = a.view != "table" && m && a.activeAccordion ? a.dataFilterWidth + 10 : 0;
                                        var b = a.view != "table" && m ? a.activeAccordion : false;
                                        var k, g;
                                        if (f) {
                                            a.dataTableTarget = f;
                                            if (a.dataTableMaximized) {
                                                if (!a.maximized) {
                                                    a.moveCanvasXpressContainer(l, true);
                                                    a.backgroundMask();
                                                    if (d) {
                                                        d.style.display = "block"
                                                    }
                                                }
                                                g = a.dataTableMaximized[2];
                                                k = a.dataTableMaximized[3];
                                                if (!a.maximized) {
                                                    o.documentElement.style.overflowX = a.dataTableMaximized[4];
                                                    o.documentElement.style.overflowY = a.dataTableMaximized[5]
                                                }
                                                a.updateDataTableResizerDiv(false, a.dataTableMaximized[0], a.dataTableMaximized[1]);
                                                if (a.view != "table" && m && a.activeAccordion) {
                                                    a.dataFilterHeight = a.dataTableMaximized[6];
                                                    m.style.left = a.dataTableMaximized[7];
                                                    b.style.height = a.dataTableMaximized[8]
                                                }
                                                delete(a.dataTableMaximized)
                                            } else {
                                                if (!a.maximized) {
                                                    a.moveCanvasXpressContainer(l);
                                                    a.backgroundMask([i, c]);
                                                    if (d) {
                                                        d.style.display = "none"
                                                    }
                                                }
                                                a.dataTableMaximized = [a.dataTableLastWidth, a.dataTableLastHeight, parseInt(f.style.left), parseInt(f.style.top), o.body.style.overflowX, o.body.style.overflowY];
                                                if (!a.maximized) {
                                                    o.documentElement.style.overflowX = "hidden";
                                                    o.documentElement.style.overflowY = "hidden"
                                                }
                                                k = -(a.height + 3);
                                                g = 0;
                                                a.updateDataTableResizerDiv(false, i - (6 + h), c - 6);
                                                if (a.view != "table" && m && a.activeAccordion) {
                                                    a.dataTableMaximized.push(a.dataFilterHeight, m.style.left, b.style.height);
                                                    a.dataFilterHeight = c - (a.heigthOffsetDataFilter() + 4);
                                                    m.style.left = (i - (a.width + a.dataFilterWidth + 13)) + "px";
                                                    b.style.height = a.dataFilterHeight + "px"
                                                }
                                            }
                                            a.endDataTableResizerDiv();
                                            f = a.$(a.target + "-cX-DataTable");
                                            f.style.top = k + "px";
                                            f.style.left = g + "px"
                                        }
                                        return false
                                    }
                                }(this);
                                this.colorTable = function(a) {
                                    return function(b) {
                                        a.removeMenus();
                                        a.colorDataTable = a.colorDataTable ? false : true;
                                        a.updateDataTable();
                                        return false
                                    }
                                }(this);
                                this.stripeTable = function(a) {
                                    return function(b) {
                                        a.removeMenus();
                                        a.dataTableStyle = a.dataTableStyle == "stripped" ? false : "stripped";
                                        if (a.dataTableStyle == "stripped") {
                                            a.colorDataTable = false;
                                            a.rowHeight = Number(a.dataTableFontSize + 16)
                                        } else {
                                            a.colorDataTable = true;
                                            a.rowHeight = Number(a.dataTableFontSize + 6)
                                        }
                                        a.resetDataTable(true);
                                        a.dataTableRowHeight = [];
                                        a.dataTableColumnWidth = [];
                                        a.updateDataTable(false, true);
                                        a.$(a.target + "-cX-DataTable").style.top = -(a.meta.canvas.ctx.canvas.height / a.meta.canvas.canvasPixelRatio) + "px";
                                        return false
                                    }
                                }(this);
                                this.filterResetTable = function(a) {
                                    return function(b) {
                                        a.removeMenus();
                                        a.resetDataFilter(b);
                                        a.resetDataTableSearch(b);
                                        a.updateDataTable();
                                        return false
                                    }
                                }(this);
                                this.saveTable = function(a) {
                                    return function(b) {
                                        a.removeMenus();
                                        a.exportToExcel(a.getDataClassAsArray(a.data, 0, a.totalCols, 0, a.totalRows, true)[0]);
                                        return false
                                    }
                                }(this);
                                this.dockUndockTable = function(a) {
                                    return function(d) {
                                        a.removeMenus();
                                        var c = a.dataTableLastState && a.dataTableLastState == "docked" ? "undock" : "dock";
                                        var b = a.getTargetEvent(d);
                                        if (c == "dock") {
                                            a.$cXIU(b, "fp_pinremove", {
                                                title: "Undock"
                                            })
                                        } else {
                                            a.$cXIU(b, "fp_pin", {
                                                title: "Dock"
                                            })
                                        }
                                        a.moveDataTableDiv(c);
                                        return false
                                    }
                                }(this);
                                this.transposeDataTable = function(a) {
                                    return function(b) {
                                        a.dataTableTransposed = a.dataTableTransposed ? false : true;
                                        a.resetDataTableRowsCols();
                                        return false
                                    }
                                }(this);
                                this.networkUpdateTable = function(a) {
                                    return function(b) {
                                        a.networkShowDataTable = a.networkShowDataTable == "nodes" ? "edges" : "nodes";
                                        a.resetDataTableRowsCols();
                                        return false
                                    }
                                }(this);
                                this.hideTable = function(a) {
                                    return function(b, e, c) {
                                        a.removeMenus();
                                        var f = a.$(a.target + "-cX-DataTable");
                                        if (f) {
                                            a.transitionMagic(f, c || "holeOut", function() {
                                                a.showDataTable = false;
                                                a.moveDataTableDiv("hide");
                                                a.hideUnhideDataTable(true);
                                                a.resetDataTable(true);
                                                if (e) {
                                                    e()
                                                }
                                            })
                                        }
                                        return false
                                    }
                                }(this);
                                this.hideUnhideDataTable = function(a) {
                                    var b = this.$(this.target + "-cX-DataTable");
                                    if (b) {
                                        if (a == true) {
                                            b.style.display = "none"
                                        } else {
                                            b.style.display = "block"
                                        }
                                    }
                                };
                                this.resetDataTable = function(a) {
                                    this.addRemoveDataTableListeners("removeEvtListener");
                                    this.removeTarget(this.target + "-cX-DataTable");
                                    this.addDataTableDiv(false, a)
                                };
                                this.rebuildDataTable = function() {
                                    this.resetDataTable()
                                };
                                this.resetDataTableRowsCols = function(a) {
                                    this.removeMenus();
                                    this.startRow = 0;
                                    this.startCol = 0;
                                    this.totalRows = null;
                                    this.totalCols = null;
                                    this.sortDataTableHead = false;
                                    this.dataTableHide = {};
                                    this.updateDataTable(false, true);
                                    this.adjustDataTable();
                                    if (this.dataTableMaximized) {
                                        this.$(this.target + "-cX-DataTable").style.top = -(this.height + 3) + "px"
                                    }
                                };
                                this.mousedownDataTableResizer = function(a) {
                                    return function(d) {
                                        a.removeMenus();
                                        var b = d.target || d.srcElement;
                                        if (a.hasClass(b, "resizable")) {
                                            var f = a.$(a.target + "-cX-DataTable");
                                            if (f) {
                                                a.dataTableTarget = f;
                                                a.xMouseDown = d.clientX;
                                                a.yMouseDown = d.clientY;
                                                a.dataTableWidth = parseInt(a.dataTableTarget.style.width);
                                                a.dataTableHeight = parseInt(a.dataTableTarget.style.height);
                                                a.resizingDataTableOn = true
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.mousemoveDataTableHeader = function(a) {
                                    return function(j) {
                                        var c = a.resizingDataTableColumnOn ? a.dataTableColumnTarget : a.getTargetEvent(j);
                                        var n = a.adjustedCoordinates(j, c);
                                        var l = a.$(a.target + "-cX-DataTableHorImage");
                                        if (n && l) {
                                            if (a.resizingDataTableColumnOn) {
                                                var b = a.dataTableColumnTarget.id.split(".");
                                                var g = parseInt(b[2]);
                                                var k = n.x - a.xMouseDown;
                                                var m = Math.max(a.colWidth, (a.dataTableColumnWidth[a.startCol + g] || a.colWidth) + k);
                                                a.dataTableColumnTarget.firstChild.style.width = m + "px";
                                                l.width += k;
                                                l.style.maxWidth = l.width + "px";
                                                for (var h = a.startRow; h < a.startRow + a.totalRows; h++) {
                                                    var d = a.$(a.target + "-cX-DataTableCell." + h + "." + g);
                                                    if (d) {
                                                        d.style.width = m + "px";
                                                        d.firstChild.style.width = m + "px"
                                                    }
                                                }
                                                a.dataTableColumnWidth[a.startCol + g] = m;
                                                a.xMouseDown = n.x;
                                                a.yMouseDown = n.y;
                                                window.document.body.style.cursor = "col-resize"
                                            } else {
                                                var f = (c.offsetLeft + c.clientWidth) - n.x;
                                                if (f < 5 && c.nodeName.toLowerCase() == "th") {
                                                    c.style.cursor = "col-resize"
                                                } else {
                                                    c.style.cursor = a.isResizeDataTable(c, n) ? "col-resize" : "default"
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.mousedownDataTableHeader = function(a) {
                                    return function(d) {
                                        var b = a.getTargetEvent(d);
                                        b = b.nodeName.toLowerCase() == "th" || !a.isIE ? b : b.parentNode;
                                        var c = a.adjustedCoordinates(d, b);
                                        if (c) {
                                            if (a.isResizeDataTable(b, c)) {
                                                a.dataTableColumnTarget = b;
                                                a.xMouseDown = c.x;
                                                a.yMouseDown = c.y;
                                                a.resizingDataTableColumnOn = true;
                                                window.document.body.style.cursor = "col-resize"
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.isResizeDataTable = function(a, b) {
                                    return (a.offsetLeft + a.offsetWidth) - b.x < (CanvasXpress.system.isIE ? 10 : 5) && (a.nodeName.toLowerCase() == "th" || (CanvasXpress.system.isIE && a.parentNode && a.parentNode.nodeName.toLowerCase() == "th"))
                                };
                                this.getColumnsDataTableHeaderMenu = function() {
                                    var a = this.dataTableHide;
                                    this.dataTableHide = {};
                                    var e = this.getDataClassAsArray(this.data, 0, this.totalCols, 0, 0, true)[0][0];
                                    this.dataTableHide = a;
                                    var f = [];
                                    for (var b = 1; b < e.length; b++) {
                                        f.push([e[b], this.dataTableHide[e[b]] ? "sl_checkboxoff" : "sl_checkboxon", "hideUnhideDataTableColumn", [e[b]]])
                                    }
                                    return f
                                };
                                this.getColumnsDataTableHeaderFilterMenu = function(c, i) {
                                    var a, k, j, h;
                                    if (this.graphType == "Network") {
                                        a = this.networkShowDataTable.replace(/s$/, "");
                                        k = this.networkShowDataTable;
                                        j = this.getFilteredNetworkData(k, true);
                                        h = this.getFilteredNetworkData(k)
                                    } else {
                                        switch (c) {
                                            case "cxv":
                                                a = "variable";
                                                k = "vars";
                                                break;
                                            case "cxx":
                                                a = "sample";
                                                k = "smps";
                                                break;
                                            case "cxs":
                                                a = "sample";
                                                k = "smps";
                                                break;
                                            case "cxz":
                                                a = "variable";
                                                k = "vars";
                                                break;
                                            case "cxb":
                                                return false
                                        }
                                        j = this.getSampleVariableData(k, true, i, c == "cxv", c == "cxs");
                                        h = this.getSampleVariableData(k, false, i, c == "cxv", c == "cxs")
                                    }
                                    var b = this.getKeys(j[i]["o"]);
                                    var g = this.getKeys(h[i]["o"]);
                                    if (j[i].t == "numeric" && b[0] == "min" && b[1] == "max") {
                                        b = [j[i]["o"]["min"], j[i]["o"]["max"]];
                                        g = [h[i]["o"]["min"], h[i]["o"]["max"]]
                                    }
                                    var g = j[i].t == "string" ? this.createStringFilter(a, i, b, false, true, this.isSameObject(b, g) ? false : g) : this.createNumericFilter(a, i, b, false, true, this.isSameObject(b, g) ? false : g);
                                    return [
                                        ["-filter-", g]
                                    ]
                                };
                                this.clickDataTableHeader = function(a) {
                                    return function(j, c) {
                                        if (a.noSorting) {
                                            return
                                        }
                                        if (!c) {
                                            a.cancelEvent(j);
                                            c = a.getTargetEvent(j)
                                        }
                                        var d = a.target + "-cX-DataTableCell.0.0";
                                        if (c.tagName.match(/th/i)) {
                                            c = c.firstChild
                                        }
                                        if (c.tagName.match(/^a$/i)) {
                                            if (a.skipHeaderMouseout && a.skipHeaderMouseout.id == this.id) {
                                                a.removeMenus();
                                                return false
                                            }
                                            var b = [];
                                            b.push(["Sort Ascending", "sr_azi", "sortDataTableByColumn", ["asc", c.parentNode]]);
                                            b.push(["Sort Descending", "sr_zad", "sortDataTableByColumn", ["desc", c.parentNode]]);
                                            b.push(["-"]);
                                            b.push(["Columns", "tb_table", false, false, false, "getColumnsDataTableHeaderMenu", []]);
                                            if (!a.graphType.match(/Correlation|Venn|Genome/) && c.parentNode.type != "cxb") {
                                                b.push(["-"]);
                                                b.push(["Filter", "fp_funnel", false, false, false, "getColumnsDataTableHeaderFilterMenu", [c.parentNode.type, c.parentNode.innerText]])
                                            }
                                            var i = a.absoluteCoordinates(c);
                                            var f = a.absoluteCoordinates(a.$(a.target + "-cX-DataTable"));
                                            var h = a.absoluteCoordinates(a.$(a.target));
                                            a.addMenu(j, false, false, b, (i.x - f.x) + (f.x - h.x), i.y - (h.y - 18), this);
                                            a.skipHeaderMouseout = this
                                        } else {
                                            if (c.className == "CanvasXpressTableCellSortDesc") {
                                                c.className = "CanvasXpressTableCellSortAsc"
                                            } else {
                                                c.className = "CanvasXpressTableCellSortDesc"
                                            }
                                            if (a.sortDataTableHead) {
                                                if (a.sortDataTableHead.id != c.id) {
                                                    var g = a.$(a.sortDataTableHead.id);
                                                    if (g) {
                                                        if (c.parentNode.id == d) {
                                                            a.sortDataTableHead.id = a.target + "-cX-DataTableCellContent.0.0"
                                                        }
                                                        g.className = "CanvasXpressTableCell"
                                                    }
                                                }
                                            }
                                            a.removeMenus();
                                            a.sortDataTableHead = c;
                                            a.sortDataTable(j)
                                        }
                                        return false
                                    }
                                }(this);
                                this.mouseoverDataTableHeader = function(a) {
                                    return function(b) {
                                        this.className = "CanvasXpressTableCellHeadActive";
                                        if (this.firstChild && this.firstChild.firstChild) {
                                            this.firstChild.firstChild.className = "CanvasXpressTableCellHeadActive"
                                        }
                                        return false
                                    }
                                }(this);
                                this.mouseoutDataTableHeader = function(a) {
                                    return function(b) {
                                        if (a.skipHeaderMouseout && a.skipHeaderMouseout.id == this.id) {
                                            return false
                                        } else {
                                            this.className = "CanvasXpressTableCellHead";
                                            if (this.firstChild && this.firstChild.firstChild) {
                                                this.firstChild.firstChild.className = "CanvasXpressTableCellHead"
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.mouseoverDataTableCell = function(a) {
                                    return function(b) {
                                        this.className = "CanvasXpressTableCellActive";
                                        if (a.colorDataTable && this.style.background) {
                                            this.style.background = a.removeColorTransparency(this.style.background, true)
                                        }
                                        return false
                                    }
                                }(this);
                                this.mouseoutDataTableCell = function(a) {
                                    return function(b) {
                                        this.className = "CanvasXpressTableCell";
                                        if (a.colorDataTable && this.style.background) {
                                            this.style.background = a.addColorTransparency(this.style.background, a.colorDataTableTransparency, true)
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickDataTableCell = function(a) {
                                    return function(b) {
                                        a.removeMenus();
                                        return false
                                    }
                                }(this);
                                this.hideUnhideDataTableColumn = function(a) {
                                    if (this.dataTableHide[a]) {
                                        delete(this.dataTableHide[a])
                                    } else {
                                        this.dataTableHide[a] = true
                                    }
                                    this.updateDataTable()
                                };
                                this.sortDataTableByColumn = function(b, a) {
                                    if (b == "asc") {
                                        a.className = "CanvasXpressTableCellSortDesc"
                                    } else {
                                        a.className = "CanvasXpressTableCellSortAsc"
                                    }
                                    this.sortDataTableHead = a;
                                    this.clickDataTableHeader(false, a)
                                };
                                this.setDataTableDimensions = function(d, g) {
                                    if (!d) {
                                        d = this.data
                                    }
                                    if (!this.dataTableHide) {
                                        this.dataTableHide = {}
                                    }
                                    var l = 0;
                                    if (d.x) {
                                        for (var e in d.x) {
                                            if (!this.dataTableHide[e]) {
                                                l++
                                            }
                                        }
                                    }
                                    var j = 0;
                                    if (d.z) {
                                        for (var e in d.z) {
                                            if (!this.dataTableHide[e]) {
                                                j++
                                            }
                                        }
                                    }
                                    var p = 0;
                                    var m = 0;
                                    if (d.y && d.y.vars && d.y.smps) {
                                        for (var e = 0; e < d.y.smps.length; e++) {
                                            if (!this.dataTableHide[d.y.smps[e]]) {
                                                p++
                                            }
                                        }
                                        for (var e = 0; e < d.y.vars.length; e++) {
                                            if (!this.dataTableHide[d.y.vars[e]]) {
                                                m++
                                            }
                                        }
                                    }
                                    this.adjustDataTableRowsCols();
                                    var n = this.getDataTableDimensions();
                                    var b = 0;
                                    var h = 0;
                                    if (this.graphType == "Network") {
                                        var k = this.getAllNetworkAttributes(d);
                                        b = this.dataTableTransposed ? 1 + d[this.networkShowDataTable].length : 1 + k[1];
                                        h = this.dataTableTransposed ? 1 + k[1] : 1 + d[this.networkShowDataTable].length
                                    } else {
                                        if (this.graphType == "Genome") {
                                            b = 1;
                                            h = 1
                                        } else {
                                            if (this.graphType == "Venn") {
                                                var m = this.getVennCompartments(d);
                                                b = this.dataTableTransposed ? 1 + m.length : 2;
                                                h = this.dataTableTransposed ? 2 : 1 + m.length
                                            } else {
                                                if (this.graphType == "Correlation") {
                                                    b = this.correlationAxis == "samples" ? 1 + p : 1 + m;
                                                    h = b
                                                } else {
                                                    if (d.y && d.y.vars && d.y.smps) {
                                                        b = this.dataTableTransposed ? 1 + j + p : 1 + l + m;
                                                        h = this.dataTableTransposed ? 1 + l + m : 1 + j + p
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.totalRows == null || this.totalCols == null) {
                                        this.totalRows = b + 2;
                                        this.totalCols = h + 1
                                    }
                                    this.dataTableTotalHeight = 1;
                                    for (var e = 0; e < this.totalRows; e++) {
                                        this.dataTableTotalHeight += (this.setDataTableRowHeight(e) + 10)
                                    }
                                    this.dataTableRowsHeight = 1;
                                    for (var e = this.startRow; e < this.startRow + this.maxRows; e++) {
                                        this.dataTableRowsHeight += (this.setDataTableRowHeight(e) + 10)
                                    }
                                    this.dataTableTotalWidth = 1;
                                    for (var e = 0; e < this.totalCols; e++) {
                                        this.dataTableTotalWidth += (this.setDataTableColumnWidth(e) + 14)
                                    }
                                    this.dataTableColsWidth = 1;
                                    for (var e = this.startCol; e < this.startCol + this.maxCols; e++) {
                                        this.dataTableColsWidth += (this.setDataTableColumnWidth(e) + 14)
                                    }
                                    if (g) {
                                        this.resetDataTable(true)
                                    } else {
                                        if (this.showDataTable) {
                                            this.hideUnhideDataTable()
                                        }
                                    }
                                };
                                this.setDataTableColumnWidth = function(b, a) {
                                    if (!this.dataTableColumnWidth[b]) {
                                        this.dataTableColumnWidth[b] = this.colWidth
                                    } else {
                                        if (a) {
                                            this.dataTableColumnWidth[b] = Math.max(a, this.colWidth)
                                        }
                                    }
                                    return this.dataTableColumnWidth[b]
                                };
                                this.setDataTableRowHeight = function(a, b) {
                                    if (!this.dataTableRowHeight[a]) {
                                        this.dataTableRowHeight[a] = this.rowHeight
                                    } else {
                                        if (b) {
                                            this.dataTableRowHeight[a] = Math.max(b, this.rowHeight)
                                        }
                                    }
                                    return this.dataTableRowHeight[a]
                                };
                                this.getAllNetworkAttributes = function(g) {
                                    if (this.graphType == "Network") {
                                        var e = [];
                                        var c = [];
                                        var b = this.getNetworkData(this.networkShowDataTable, true);
                                        var h = this.getKeys(b).length;
                                        switch (this.networkShowDataTable) {
                                            case "nodes":
                                                for (var f in b) {
                                                    if (f == "id") {
                                                        for (var d = 0; d < g[this.networkShowDataTable].length; d++) {
                                                            e.push(g[this.networkShowDataTable][d].id)
                                                        }
                                                        c.push(f)
                                                    } else {
                                                        c.push(f)
                                                    }
                                                }
                                                break;
                                            case "edges":
                                                for (var f in b) {
                                                    if (f == "id1") {
                                                        for (var d = 0; d < g[this.networkShowDataTable].length; d++) {
                                                            e.push(g[this.networkShowDataTable][d].id1 + "::" + g[this.networkShowDataTable][d].id2)
                                                        }
                                                        c.push(f)
                                                    } else {
                                                        c.push(f)
                                                    }
                                                }
                                                break
                                        }
                                        return [b, h, e, c]
                                    } else {
                                        return false
                                    }
                                };
                                this.getVennCompartments = function(c) {
                                    var d = 0;
                                    if (!c.venn.indices) {
                                        c.venn.indices = [];
                                        for (var a in c.venn.data) {
                                            c.venn.indices[a] = d++
                                        }
                                    }
                                    var b = Object.keys(this.data.venn.data);
                                    b = b.sort(function(f, e) {
                                        return c.venn.indices[f] - c.venn.indices[e]
                                    });
                                    return b
                                };
                                this.getDataTableDimensions = function() {
                                    var f = 0;
                                    var i = 0;
                                    var e = 0;
                                    var b = 0;
                                    var d = this.$(this.target + "-cX-DataTableTable");
                                    var g = this.$(this.target + "-cX-DataTableCell.0.0");
                                    if (d) {
                                        var a = d.childNodes[0].rows;
                                        if (a) {
                                            f = a.length;
                                            i = a[0].cells.length;
                                            e = g && g.firstChild && g.firstChild.style ? parseInt(g.firstChild.style.height) : 0;
                                            b = g && g.firstChild && g.firstChild.style ? parseInt(g.firstChild.style.width) : 0
                                        }
                                    }
                                    return [f, i, e, b]
                                };
                                this.adjustDataTableRowsCols = function() {
                                    var e = this.$(this.target + "-cX-DataTableContainer");
                                    if (e) {
                                        var b = 1;
                                        this.maxCols = 0;
                                        for (var d = this.startCol; d < this.totalCols; d++) {
                                            b += this.dataTableColumnWidth[d] + 14;
                                            if (parseInt(e.style.width) < b) {
                                                this.maxCols++;
                                                break
                                            } else {
                                                this.maxCols++
                                            }
                                        }
                                        if (b < parseInt(e.style.width) && this.startCol > 0) {
                                            for (var d = this.startCol; d >= 0; d--) {
                                                if (b + this.dataTableColumnWidth[d] + 14 < parseInt(e.style.width)) {
                                                    b += this.dataTableColumnWidth[d] + 14;
                                                    this.maxCols++;
                                                    this.startCol--
                                                } else {
                                                    break
                                                }
                                            }
                                        }
                                        if (parseInt(e.style.width) > this.dataTableTotalWidth) {
                                            this.maxCols = (this.totalCols - this.startCol)
                                        }
                                        this.maxCols = Math.max(2, Math.min(this.maxCols, (this.totalCols - this.startCol)));
                                        var a = 1;
                                        this.maxRows = 0;
                                        for (var d = this.startRow; d < this.totalRows; d++) {
                                            a += this.dataTableRowHeight[d] + 10;
                                            if (parseInt(e.style.height) < a) {
                                                this.maxRows++;
                                                break
                                            } else {
                                                this.maxRows++
                                            }
                                        }
                                        if (a < parseInt(e.style.height) && this.startRow > 0) {
                                            for (var d = this.startRow; d >= 0; d--) {
                                                if (a + this.dataTableRowHeight[d] + 10 < parseInt(e.style.height)) {
                                                    a += this.dataTableRowHeight[d] + 10;
                                                    this.maxRows++;
                                                    this.startRow--
                                                } else {
                                                    break
                                                }
                                            }
                                        }
                                        if (parseInt(e.style.height) > this.dataTableTotalHeight) {
                                            this.totalRows = (this.totalRows - this.startRow)
                                        }
                                        this.maxRows = Math.max(2, Math.min(this.maxRows, (this.totalRows - this.startRow)))
                                    }
                                };
                                this.adjustDataTableScrollers = function() {
                                    var a = this.$(this.target + "-cX-DataTableVer");
                                    var b = this.$(this.target + "-cX-DataTableHor");
                                    if (a && b) {
                                        if (!CanvasXpress.system.isIE) {
                                            a.scrollHeight = this.dataTableLastScrollHeight
                                        }
                                        a.scrollTop = this.dataTableLastScrollTop ? this.dataTableLastScrollTop : a.scrollTop;
                                        if (!CanvasXpress.system.isIE) {
                                            b.scrollWidth = this.dataTableLastScrollWidth
                                        }
                                        b.scrollLeft = this.dataTableLastScrollLeft ? this.dataTableLastScrollLeft : b.scrollLeft
                                    }
                                };
                                this.adjustDataTable = function(a) {
                                    this.adjustDataTableRowsCols();
                                    this.updateDataTable(false, true, a);
                                    this.adjustDataTableScrollers();
                                    if (this.dataTableLastState == "docked") {
                                        this.resizeViewportSouth(true)
                                    }
                                };
                                this.sortDataTableVenn = function(c) {
                                    var f = this;
                                    if (c == "No") {
                                        var e = Object.keys(this.data.venn.data);
                                        e = e.sort(function(h, g) {
                                            if (f.sortDir == "ascending") {
                                                return f.data.venn.data[h] - f.data.venn.data[g]
                                            } else {
                                                return f.data.venn.data[g] - f.data.venn.data[h]
                                            }
                                        });
                                        for (var d = 0; d < e.length; d++) {
                                            this.data.venn.indices[e[d]] = d
                                        }
                                    } else {
                                        var b = 0;
                                        var a = Object.keys(this.data.venn.data).length;
                                        for (var d in this.data.venn.data) {
                                            if (this.sortDir == "descending") {
                                                this.data.venn.indices[d] = b++
                                            } else {
                                                this.data.venn.indices[d] = --a
                                            }
                                        }
                                    }
                                };
                                this.sortDataTable = function(c) {
                                    this.sortDir = this.sortDataTableHead.className == "CanvasXpressTableCellSortDesc" ? "descending" : "ascending";
                                    var b = this.sortDataTableHead.innerText ? this.sortDataTableHead.innerText : this.sortDataTableHead.textContent;
                                    if (this.graphType == "Network") {
                                        if (this.dataTableTransposed) {
                                            if (this.sortDataTableHead.type == "cxb") {
                                                this.sortDataTableHead.className = "CanvasXpressTableCell";
                                                this.sortDataTableHead = false;
                                                return
                                            } else {
                                                this.sortNetworkIndices(b)
                                            }
                                        } else {
                                            this.sortDataTableHead.className = "CanvasXpressTableCell";
                                            this.sortDataTableHead = false;
                                            return
                                        }
                                    } else {
                                        if (this.graphType == "Genome") {
                                            this.sortDataTableHead.className = "CanvasXpressTableCell";
                                            this.sortDataTableHead = false;
                                            return
                                        } else {
                                            if (this.graphType == "Venn") {
                                                this.sortDataTableHead.className = "CanvasXpressTableCell";
                                                this.sortDataTableHead = false;
                                                this.sortDataTableVenn(b)
                                            } else {
                                                if (this.graphType == "Correlation") {
                                                    if (this.correlationAxis == "samples") {
                                                        if (this.sortDataTableHead.type == "cxb") {
                                                            this.sortSamples()
                                                        } else {
                                                            this.sortSamples(false, false, b, "cor");
                                                            this.sortDataTableHead.className = "CanvasXpressTableCell";
                                                            this.sortDataTableHead = false
                                                        }
                                                    } else {
                                                        if (this.sortDataTableHead.type == "cxb") {
                                                            this.sortVariables()
                                                        } else {
                                                            this.sortVariables(false, false, b, "cor");
                                                            this.sortDataTableHead.className = "CanvasXpressTableCell";
                                                            this.sortDataTableHead = false
                                                        }
                                                    }
                                                } else {
                                                    if (this.data.y.vars && this.data.y.smps) {
                                                        var a = this.view == "table";
                                                        if (!c.ctrlKey) {
                                                            this.sortingSampleCategories = [];
                                                            this.sortingVariables = []
                                                        }
                                                        if (this.dataTableTransposed) {
                                                            if (this.sortDataTableHead.type == "cxx") {
                                                                this.modifySort("cat", "smp", b, a)
                                                            } else {
                                                                if (this.sortDataTableHead.type == "cxv") {
                                                                    this.modifySort("var", "smp", b, a)
                                                                } else {
                                                                    if (this.sortDataTableHead.type == "cxb") {
                                                                        this.modifySort("samples", "smp", "samples", a)
                                                                    }
                                                                }
                                                            }
                                                        } else {
                                                            if (!c.ctrlKey) {
                                                                this.sortingVariableCategories = [];
                                                                this.sortingSamples = []
                                                            }
                                                            if (this.sortDataTableHead.type == "cxz") {
                                                                this.modifySort("cat", "var", b, a)
                                                            } else {
                                                                if (this.sortDataTableHead.type == "cxs") {
                                                                    this.modifySort("smp", "var", b, a)
                                                                } else {
                                                                    if (this.sortDataTableHead.type == "cxb") {
                                                                        this.modifySort("variables", "var", "variables", a)
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    this.updateDataTable(false, true)
                                };
                                this.getDataClassAsArray = function(G, g, U, J, I, h) {
                                    var p = 0;
                                    var n = 0;
                                    var F = 0;
                                    var y = 0;
                                    var P = [];
                                    var Q = [];
                                    var R = [];
                                    var C = [];
                                    var A = [];
                                    var M = [];
                                    var H = this.meta.data;
                                    var e = this.isGroupedData;
                                    this.isGroupedData = false;
                                    var B = this.$(this.target + "-cX-DataTable");
                                    if (!B) {
                                        B = this.initializeDataTable()
                                    }
                                    var k = function(m, q, b, s) {
                                        if (q.hasOwnProperty(m)) {
                                            return q[m] != null ? q[m] : ""
                                        } else {
                                            if (b[0][m] && b[0][m].hasOwnProperty("r")) {
                                                var r = b[0][m]["r"];
                                                for (var f = 0; f < s[r].length; f++) {
                                                    var d = s[r][f];
                                                    if (q.hasOwnProperty(d)) {
                                                        q = q[d]
                                                    } else {
                                                        return ""
                                                    }
                                                }
                                                if (q.hasOwnProperty(m)) {
                                                    return q[m] != null ? q[m] : ""
                                                }
                                            }
                                            return ""
                                        }
                                    };
                                    if (g == null) {
                                        g = 0
                                    }
                                    if (U == null) {
                                        U = 999
                                    }
                                    if (J == null) {
                                        J = 0
                                    }
                                    if (I == null) {
                                        I = 999
                                    }
                                    if (this.graphType == "Network") {
                                        var S = this.getAllNetworkAttributes(G);
                                        C.push("");
                                        A.push("cxb");
                                        M.push(false);
                                        if (this.dataTableTransposed) {
                                            for (var L = 0; L < S[3].length; L++) {
                                                if (n < U && y >= g && !this.dataTableHide[S[3][L]]) {
                                                    C.push(S[3][L]);
                                                    A.push("cxx");
                                                    M.push(false);
                                                    n++
                                                }
                                                y++
                                            }
                                            P.push(C);
                                            Q.push(A);
                                            R.push(M);
                                            for (var L = 0; L < S[2].length; L++) {
                                                if (!G[this.networkShowDataTable][L].hide) {
                                                    if (p < I && F >= J && !this.dataTableHide[S[2][L]]) {
                                                        n = 0;
                                                        y = 0;
                                                        C = [S[2][L]];
                                                        A = ["cxz"];
                                                        M = [false];
                                                        for (var K = 0; K < S[3].length; K++) {
                                                            if (n < U && y >= g && !this.dataTableHide[S[3][K]]) {
                                                                var x = k(S[3][K], G[this.networkShowDataTable][L], S, this[this.networkShowDataTable + "Properties"]);
                                                                var E = H[this.networkShowDataTable][S[3][K]].type.match(/String|Object/) ? H[this.networkShowDataTable][S[3][K]].colors[H[this.networkShowDataTable][S[3][K]].order[x]] : this.getColorForValue(H[this.networkShowDataTable][S[3][K]].colorBrew, x);
                                                                C.push(x);
                                                                A.push("cxy");
                                                                M.push(E);
                                                                n++
                                                            }
                                                            y++
                                                        }
                                                        P.push(C);
                                                        Q.push(A);
                                                        R.push(M);
                                                        p++
                                                    }
                                                    F++
                                                }
                                            }
                                        } else {
                                            for (var L = 0; L < S[2].length; L++) {
                                                if (!G[this.networkShowDataTable][L].hide) {
                                                    if (n < U && y >= g && !this.dataTableHide[S[2][L]]) {
                                                        C.push(S[2][L]);
                                                        A.push("cxz");
                                                        M.push(false);
                                                        n++
                                                    }
                                                    y++
                                                }
                                            }
                                            P.push(C);
                                            Q.push(A);
                                            R.push(M);
                                            for (var L = 0; L < S[3].length; L++) {
                                                if (p < I && F >= J && !this.dataTableHide[S[3][L]]) {
                                                    n = 0;
                                                    y = 0;
                                                    C = [S[3][L]];
                                                    A = ["cxx"];
                                                    M = [false];
                                                    for (var K = 0; K < G[this.networkShowDataTable].length; K++) {
                                                        if (!G[this.networkShowDataTable][K].hide) {
                                                            if (n < U && y >= g && !this.dataTableHide[S[2][K]]) {
                                                                var x = k(S[3][L], G[this.networkShowDataTable][K], S, this[this.networkShowDataTable + "Properties"]);
                                                                var E = H[this.networkShowDataTable][S[3][L]].type.match(/String|Object/) ? H[this.networkShowDataTable][S[3][L]].colors[H[this.networkShowDataTable][S[3][L]].order[x]] : this.getColorForValue(H[this.networkShowDataTable][S[3][L]].colorBrew, x);
                                                                C.push(x);
                                                                A.push("cxy");
                                                                M.push(E);
                                                                n++
                                                            }
                                                            y++
                                                        }
                                                    }
                                                    P.push(C);
                                                    Q.push(A);
                                                    R.push(M);
                                                    p++
                                                }
                                                F++
                                            }
                                        }
                                    } else {
                                        if (this.graphType == "Genome") {
                                            P = [
                                                ["Not implemented"]
                                            ];
                                            Q = [
                                                ["cxb"]
                                            ]
                                        } else {
                                            if (this.graphType == "Venn") {
                                                var x = this.getVennCompartments(G);
                                                C.push("");
                                                A.push("cxb");
                                                M.push(false);
                                                if (this.dataTableTransposed) {
                                                    C.push("No");
                                                    A.push("cxz");
                                                    M.push(false);
                                                    P.push(C);
                                                    Q.push(A);
                                                    R.push(M);
                                                    for (var L = 0; L < x.length; L++) {
                                                        if (p < I && F >= J) {
                                                            n = 0;
                                                            y = 0;
                                                            C = [x[L]];
                                                            A = ["cxx"];
                                                            M = [false];
                                                            if (n < U && y >= g) {
                                                                C.push(G.venn.data[x[L]]);
                                                                A.push("cxy");
                                                                M.push(false);
                                                                n++
                                                            }
                                                            y++;
                                                            P.push(C);
                                                            Q.push(A);
                                                            R.push(M);
                                                            p++
                                                        }
                                                        F++
                                                    }
                                                } else {
                                                    for (var L = 0; L < x.length; L++) {
                                                        if (n < U && y >= g) {
                                                            C.push(x[L]);
                                                            A.push("cxx");
                                                            M.push(false);
                                                            n++
                                                        }
                                                        y++
                                                    }
                                                    P.push(C);
                                                    Q.push(A);
                                                    R.push(M);
                                                    if (p < I && F >= J) {
                                                        n = 0;
                                                        y = 0;
                                                        C = ["No"];
                                                        A = ["cxz"];
                                                        M = [false];
                                                        for (var L in x[0]) {
                                                            if (n < U && y >= g) {
                                                                C.push(G.venn.data[x[L]]);
                                                                A.push("cxy");
                                                                M.push(false);
                                                                n++
                                                            }
                                                            y++
                                                        }
                                                        P.push(C);
                                                        Q.push(A);
                                                        R.push(M)
                                                    }
                                                }
                                            } else {
                                                if (this.graphType == "Correlation") {
                                                    var w = this.correlationAxis == "samples" ? G.y.smps : G.y.vars;
                                                    var l = this.correlationAxis == "samples" ? this.smpIndices : this.varIndices;
                                                    var t = this.correlationAxis == "samples" ? "cxs" : "cxv";
                                                    C.push("");
                                                    A.push("cxb");
                                                    M.push(false);
                                                    for (var L = 0; L < w.length; L++) {
                                                        if (n < U && y >= g && !this.dataTableHide[h ? w[l[L]] : w[L]]) {
                                                            C.push(h ? w[l[L]] : w[L]);
                                                            A.push(t);
                                                            M.push(false);
                                                            n++
                                                        }
                                                        y++
                                                    }
                                                    P.push(C);
                                                    Q.push(A);
                                                    R.push(M);
                                                    for (var L = 0; L < w.length; L++) {
                                                        if (p < I && F >= J && !this.dataTableHide[h ? w[l[L]] : w[L]]) {
                                                            n = 0;
                                                            y = 0;
                                                            C = [h ? w[l[L]] : w[L]];
                                                            A = [t];
                                                            M = [false];
                                                            if (C[0] != undefined) {
                                                                for (var K = 0; K < w.length; K++) {
                                                                    if (n < U && y >= g && !this.dataTableHide[h ? w[l[K]] : w[K]]) {
                                                                        if (G.y.cor) {
                                                                            C.push(h ? G.y.cor[l[L]][l[K]] : G.y.cor[L][K])
                                                                        } else {
                                                                            C.push(L == K ? 1 : G.y.data)
                                                                        }
                                                                        A.push("cxy");
                                                                        M.push(false);
                                                                        n++
                                                                    }
                                                                    y++
                                                                }
                                                            }
                                                            P.push(C);
                                                            Q.push(A);
                                                            R.push(M);
                                                            p++
                                                        }
                                                        F++
                                                    }
                                                } else {
                                                    if (G.y && G.y.vars && G.y.smps) {
                                                        var O = h ? this.varIndices.length : G.y.vars.length;
                                                        var N = h ? this.smpIndices.length : G.y.smps.length;
                                                        var D = G.x ? this.sortObject(G.x) : false;
                                                        var z = G.z ? this.sortObject(G.z) : false;
                                                        C.push("");
                                                        A.push("cxb");
                                                        M.push(false);
                                                        if (this.dataTableTransposed) {
                                                            if (G.x) {
                                                                for (var L = 0; L < D.length; L++) {
                                                                    if (n < U && y >= g && !this.dataTableHide[D[L]]) {
                                                                        C.push(D[L]);
                                                                        A.push("cxx");
                                                                        M.push(H.x[D[L]].type);
                                                                        n++
                                                                    }
                                                                    y++
                                                                }
                                                            }
                                                            for (var L = 0; L < O; L++) {
                                                                if (n < U && y >= g && !this.dataTableHide[h ? G.y.vars[this.varIndices[L]] : G.y.vars[L]]) {
                                                                    C.push(h ? G.y.vars[this.varIndices[L]] : G.y.vars[L]);
                                                                    A.push("cxv");
                                                                    M.push(false);
                                                                    n++
                                                                }
                                                                y++
                                                            }
                                                            P.push(C);
                                                            Q.push(A);
                                                            R.push(M);
                                                            if (G.z) {
                                                                for (var L = 0; L < z.length; L++) {
                                                                    if (p < I && F >= J && !this.dataTableHide[z[L]]) {
                                                                        n = 0;
                                                                        y = 0;
                                                                        C = [z[L]];
                                                                        A = ["cxz"];
                                                                        M = [H.z[z[L]].type];
                                                                        if (G.x) {
                                                                            for (var K = 0; K < D.length; K++) {
                                                                                if (n < U && y >= g && !this.dataTableHide[D[K]]) {
                                                                                    C.push("");
                                                                                    A.push("cxb");
                                                                                    M.push(false);
                                                                                    n++
                                                                                }
                                                                                y++
                                                                            }
                                                                        }
                                                                        for (var K = 0; K < O; K++) {
                                                                            if (n < U && y >= g && !this.dataTableHide[h ? G.y.vars[this.varIndices[K]] : G.y.vars[K]]) {
                                                                                var T = h ? this.getMetadataValue(this.varIndices[K], "z", z[L]) : G.z[z[L]][K];
                                                                                var u = H.z[z[L]].type == "String" ? H.z[z[L]].colors[H.z[z[L]].order[T]] : this.getColorForValue(H.z[z[L]].colorBrew, T);
                                                                                C.push(T);
                                                                                A.push("cxz");
                                                                                M.push(u);
                                                                                n++
                                                                            }
                                                                            y++
                                                                        }
                                                                        P.push(C);
                                                                        Q.push(A);
                                                                        R.push(M);
                                                                        p++
                                                                    }
                                                                    F++
                                                                }
                                                            }
                                                            for (var L = 0; L < N; L++) {
                                                                if (p < I && F >= J && !this.dataTableHide[h ? G.y.smps[this.smpIndices[L]] : G.y.smps[L]]) {
                                                                    n = 0;
                                                                    y = 0;
                                                                    C = [h ? G.y.smps[this.smpIndices[L]] : G.y.smps[L]];
                                                                    A = ["cxs"];
                                                                    M = [false];
                                                                    if (G.x) {
                                                                        for (var K = 0; K < D.length; K++) {
                                                                            if (n < U && y >= g && !this.dataTableHide[D[K]]) {
                                                                                var T = h ? this.getMetadataValue(this.smpIndices[L], "x", D[K]) : G.x[D[K]][L];
                                                                                var u = H.x[D[K]].type == "String" ? H.x[D[K]].colors[H.x[D[K]].order[T]] : this.getColorForValue(H.x[D[K]].colorBrew, T);
                                                                                C.push(T);
                                                                                A.push("cxx");
                                                                                M.push(u);
                                                                                n++
                                                                            }
                                                                            y++
                                                                        }
                                                                    }
                                                                    for (var K = 0; K < O; K++) {
                                                                        if (n < U && y >= g && !this.dataTableHide[h ? G.y.vars[this.varIndices[K]] : G.y.vars[K]]) {
                                                                            if (h) {
                                                                                C.push(G.y.data[this.varIndices[K]][this.smpIndices[L]])
                                                                            } else {
                                                                                C.push(G.y.data[K][L] != null ? G.y.data[K][L] : G.y.data[L])
                                                                            }
                                                                            A.push("cxy");
                                                                            M.push(false);
                                                                            n++
                                                                        }
                                                                        y++
                                                                    }
                                                                    P.push(C);
                                                                    Q.push(A);
                                                                    R.push(M);
                                                                    p++
                                                                }
                                                                F++
                                                            }
                                                        } else {
                                                            if (G.z) {
                                                                for (var L = 0; L < z.length; L++) {
                                                                    if (n < U && y >= g && !this.dataTableHide[z[L]]) {
                                                                        C.push(z[L]);
                                                                        A.push("cxz");
                                                                        M.push(H.z[z[L]].type);
                                                                        n++
                                                                    }
                                                                    y++
                                                                }
                                                            }
                                                            for (var L = 0; L < N; L++) {
                                                                if (n < U && y >= g && !this.dataTableHide[h ? G.y.smps[this.smpIndices[L]] : G.y.smps[L]]) {
                                                                    C.push(h ? G.y.smps[this.smpIndices[L]] : G.y.smps[L]);
                                                                    A.push("cxs");
                                                                    M.push(false);
                                                                    n++
                                                                }
                                                                y++
                                                            }
                                                            P.push(C);
                                                            Q.push(A);
                                                            R.push(M);
                                                            if (G.x) {
                                                                for (var L = 0; L < D.length; L++) {
                                                                    if (p < I && F >= J && !this.dataTableHide[D[L]]) {
                                                                        n = 0;
                                                                        y = 0;
                                                                        C = [D[L]];
                                                                        A = ["cxx"];
                                                                        M = [H.x[D[L]].type];
                                                                        if (G.z) {
                                                                            for (var K = 0; K < z.length; K++) {
                                                                                if (n < U && y >= g && !this.dataTableHide[z[K]]) {
                                                                                    C.push("");
                                                                                    A.push("cxb");
                                                                                    M.push(false);
                                                                                    n++
                                                                                }
                                                                                y++
                                                                            }
                                                                        }
                                                                        for (var K = 0; K < N; K++) {
                                                                            if (n < U && y >= g && !this.dataTableHide[h ? G.y.smps[this.smpIndices[K]] : G.y.smps[K]]) {
                                                                                var T = h ? this.getMetadataValue(this.smpIndices[K], "x", D[L]) : G.x[D[L]][K];
                                                                                var u = H.x[D[L]].type == "String" ? H.x[D[L]].colors[H.x[D[L]].order[T]] : this.getColorForValue(H.x[D[L]].colorBrew, T);
                                                                                C.push(T);
                                                                                A.push("cxx");
                                                                                M.push(u);
                                                                                n++
                                                                            }
                                                                            y++
                                                                        }
                                                                        P.push(C);
                                                                        Q.push(A);
                                                                        R.push(M);
                                                                        p++
                                                                    }
                                                                    F++
                                                                }
                                                            }
                                                            for (var L = 0; L < O; L++) {
                                                                if (p < I && F >= J && !this.dataTableHide[h ? G.y.vars[this.varIndices[L]] : G.y.vars[L]]) {
                                                                    n = 0;
                                                                    y = 0;
                                                                    C = [h ? G.y.vars[this.varIndices[L]] : G.y.vars[L]];
                                                                    A = ["cxv"];
                                                                    M = [false];
                                                                    if (G.z) {
                                                                        for (var K = 0; K < z.length; K++) {
                                                                            if (n < U && y >= g && !this.dataTableHide[z[K]]) {
                                                                                var T = h ? this.getMetadataValue(this.varIndices[L], "z", z[K]) : G.z[z[K]][L];
                                                                                var u = H.z[z[K]].type == "String" ? H.z[z[K]].colors[H.z[z[K]].order[T]] : this.getColorForValue(H.z[z[K]].colorBrew, T);
                                                                                C.push(T);
                                                                                A.push("cxz");
                                                                                M.push(u);
                                                                                n++
                                                                            }
                                                                            y++
                                                                        }
                                                                    }
                                                                    for (var K = 0; K < N; K++) {
                                                                        if (n < U && y >= g && !this.dataTableHide[h ? G.y.smps[this.smpIndices[K]] : G.y.smps[K]]) {
                                                                            if (h) {
                                                                                C.push(G.y.data[this.varIndices[L]][this.smpIndices[K]])
                                                                            } else {
                                                                                C.push(G.y.data[L][K] != null ? G.y.data[L][K] : G.y.data[K])
                                                                            }
                                                                            A.push("cxy");
                                                                            M.push(false);
                                                                            n++
                                                                        }
                                                                        y++
                                                                    }
                                                                    P.push(C);
                                                                    Q.push(A);
                                                                    R.push(M);
                                                                    p++
                                                                }
                                                                F++
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    this.isGroupedData = e;
                                    return [P, Q, R]
                                };
                                this.updateDataTable = function(i, g, d) {
                                    var e = this.$(this.target + "-cX-DataTable");
                                    if (!e) {
                                        e = this.initializeDataTable()
                                    }
                                    if (e) {
                                        if (this.dataTableLastState && this.dataTableLastState == "docked") {
                                            this.dataTableLastX = 0;
                                            this.dataTableLastY = 0
                                        }
                                        if (!this.dataTableLastState) {
                                            this.dataTableLastState = "free"
                                        }
                                        var b = e.style.left;
                                        var c = e.style.top;
                                        if (!i) {
                                            i = this.data
                                        } else {
                                            i = this.getUngroupedDataObject(i)
                                        }
                                        this.setDataTableDimensions(i, g);
                                        var a = this.getDataClassAsArray(i, this.startCol, this.maxCols, this.startRow, this.maxRows, true);
                                        this.loadDataTableValues(a[0], a[1], a[2], d);
                                        this.$(this.target + "-cX-DataTable").style.left = b;
                                        this.$(this.target + "-cX-DataTable").style.top = c;
                                        if (this.dataTableMaximized) {
                                            this.$(this.target + "-cX-DataTable").style.top = -(this.height + 3) + "px"
                                        }
                                    }
                                };
                                this.loadDataTableValues = function(E, F, G, y) {
                                    var K = window.document;
                                    var r = this.$(this.target + "-cX-DataTable");
                                    if (r) {
                                        var v = this.setDataTableRowHeight(0);
                                        var g = this.setDataTableColumnWidth(0);
                                        for (var B = 0; B < this.maxRows; B++) {
                                            for (var A = 0; A < this.maxCols; A++) {
                                                var x = this.target + "-cX-DataTableCell." + B + "." + A;
                                                var H = this.target + "-cX-DataTableCellContent." + B + "." + A;
                                                var k = this.target + "-cX-DataTableCellContentA." + B + "." + A;
                                                var D = this.$(x);
                                                if (D) {
                                                    if (D.hasChildNodes()) {
                                                        while (D.childNodes.length >= 1) {
                                                            D.removeChild(D.firstChild)
                                                        }
                                                    }
                                                    var h = this.$cX("div", {
                                                        id: H,
                                                        className: "CanvasXpressTableCell ",
                                                        title: ""
                                                    });
                                                    if (B == 0) {
                                                        var I = this.$cX("a", {
                                                            id: k,
                                                            className: "CanvasXpressTableCellHead ",
                                                            href: "#"
                                                        });
                                                        h.appendChild(I)
                                                    }
                                                    h.appendChild(K.createTextNode(""));
                                                    if (A == 0) {
                                                        h.style.height = v + "px";
                                                        D.style.height = v + "px"
                                                    }
                                                    if (B == 0) {
                                                        h.style.width = g + "px";
                                                        D.style.width = g + "px"
                                                    }
                                                    if (this.dataTableStyle == "stripped") {
                                                        D.style.background = B % 2 ? "rgba(0,0,0,0)" : "rgba(0,0,0,0.05)"
                                                    } else {
                                                        D.style.background = ""
                                                    }
                                                    D.appendChild(h)
                                                }
                                            }
                                        }
                                        var q = this.startRow;
                                        for (var B = 0; B < E.length; B++) {
                                            var C = this.startCol;
                                            for (var A = 0; A < E[B].length + this.startCol; A++) {
                                                var x = this.target + "-cX-DataTableCell." + B + "." + A;
                                                var H = this.target + "-cX-DataTableCellContent." + q + "." + C;
                                                var k = this.target + "-cX-DataTableCellContentA." + q + "." + C;
                                                var D = this.$(x);
                                                if (D) {
                                                    if (D.hasChildNodes()) {
                                                        while (D.childNodes.length >= 1) {
                                                            D.removeChild(D.firstChild)
                                                        }
                                                    }
                                                    var p = typeof E[B][A] == "object" ? true : false;
                                                    var J = E[B][A] != null ? E[B][A].toString().replace("\x00", "") : "";
                                                    var f = F[B][A] != null ? F[B][A] : "";
                                                    var m = G[B][A];
                                                    if (!isNaN(J) && f == "cxy" && E[B][A] != null && this.graphType != "Network") {
                                                        J = this.formatNumber(J)
                                                    } else {
                                                        if (J === "NaN") {
                                                            J = ""
                                                        }
                                                    }
                                                    var h = this.$cX("div", {
                                                        id: H,
                                                        className: "CanvasXpressTableCell ",
                                                        title: (p ? this.prettyJSON(E[B][A]) : J),
                                                        type: f
                                                    }, {
                                                        lineHeight: this.dataTableStyle == "stripped" ? (this.dataTableFontSize + 16) + "px" : (this.dataTableFontSize + 6) + "px"
                                                    });
                                                    if (B == 0) {
                                                        var I = this.$cX("a", {
                                                            id: k,
                                                            className: "CanvasXpressTableCellHead ",
                                                            href: "#"
                                                        });
                                                        h.appendChild(I)
                                                    }
                                                    h.appendChild(K.createTextNode(J));
                                                    if (f.match(/cxv|cxs|cxy/)) {
                                                        h.style.fontStyle = "normal"
                                                    } else {
                                                        h.style.fontStyle = "italic"
                                                    }
                                                    if (B != 0) {
                                                        h.style.height = this.setDataTableRowHeight(q) + "px";
                                                        D.style.height = this.setDataTableRowHeight(q) + "px"
                                                    } else {
                                                        h.style.height = this.setDataTableRowHeight(0) + "px";
                                                        D.style.height = this.setDataTableRowHeight(0) + "px"
                                                    }
                                                    if (A != 0) {
                                                        h.style.width = this.setDataTableColumnWidth(C) + "px";
                                                        D.style.width = this.setDataTableColumnWidth(C) + "px"
                                                    } else {
                                                        h.style.width = this.setDataTableColumnWidth(0) + "px";
                                                        D.style.width = this.setDataTableColumnWidth(0) + "px"
                                                    }
                                                    D.appendChild(h);
                                                    if (this.colorDataTable) {
                                                        if (m && B > 0 && A > 0) {
                                                            D.style.background = this.addColorTransparency(m, this.colorDataTableTransparency, true)
                                                        } else {
                                                            if (B > 0 && A > 0) {
                                                                D.style.background = ""
                                                            } else {
                                                                if (B == 0 && A == 0) {
                                                                    h.title = (this.totalRows - 1) + " X " + (this.totalCols - 1) + " data points"
                                                                } else {
                                                                    if (A == 0) {
                                                                        h.title = "Row " + q + ": " + J
                                                                    } else {
                                                                        h.title = "Col " + C + ": " + J
                                                                    }
                                                                }
                                                                h.ftype = m
                                                            }
                                                        }
                                                    }
                                                    C++
                                                }
                                            }
                                            q++
                                        }
                                        if (this.sortDataTableHead) {
                                            var u = this.$(this.sortDataTableHead.id);
                                            var l = this.$(this.target + "-cX-DataTableCell.0.0").firstChild;
                                            var n = this.target + "-cX-DataTableCellContent.0.0";
                                            if (u) {
                                                u.className = this.sortDataTableHead.className
                                            }
                                            if (l) {
                                                l.className = this.sortDataTableHead.id == n ? this.sortDataTableHead.className : "CanvasXpressTableCell"
                                            }
                                        }
                                        this.activeTarget = r;
                                        if (y) {
                                            r.style.opacity = 0
                                        }
                                        r.style.display = "block"
                                    }
                                };
                                this.moveDataTableDiv = function(f) {
                                    var n = this.$(this.target + "-cX-DataTable");
                                    if (n) {
                                        var p, r, j;
                                        var a = this.$(this.remoteParentId + "-canvasXpressRemoteWindow");
                                        var i = this.$("north-container-" + this.target);
                                        var e = this.$("west-container-" + this.target);
                                        var m = this.$("east-container-" + this.target);
                                        var o = this.$("south-container-" + this.target);
                                        var q = this.$("south-wrapper-" + this.target);
                                        var b = this.meta.canvas.canvasPixelRatio;
                                        var c = 64;
                                        var g = 0;
                                        var k = this;
                                        if (e && m && o && q) {
                                            if (f && (f == "dock" || f == "dockMagic")) {
                                                this.dataTableLastState = "docked";
                                                this.dataTableLastHeight = n.clientHeight;
                                                this.dataTableLastX = n.offsetLeft;
                                                this.dataTableLastY = n.offsetTop;
                                                r = Math.max(n.clientWidth, parseInt(e.style.width) + parseInt(m.style.width) + (this.meta.canvas.ctx.canvas.width / b)) + 2;
                                                j = parseInt(i.style.height) + (this.meta.canvas.ctx.canvas.height / b) + n.clientHeight + 2;
                                                if (a) {
                                                    this.resizeMoveObject(a, 0, 0, r + g, j + c)
                                                }
                                                this.resizeMoveObject(o, 0, 0, r, n.clientHeight + 2);
                                                this.resizeMoveObject(q, 0, 0, r, n.clientHeight + 2);
                                                if (f == "dockMagic") {
                                                    this.resizeMoveObject(n, 0, 0, n.clientWidth, n.clientHeight)
                                                } else {
                                                    this.resizeMove(n, 0, 0, n.clientWidth, n.clientHeight)
                                                }
                                            } else {
                                                if (f && f == "hide") {
                                                    delete(this.dataTableLastState);
                                                    delete(this.dataTableLastX);
                                                    delete(this.dataTableLastY);
                                                    r = parseInt(e.style.width) + parseInt(m.style.width) + (this.meta.canvas.ctx.canvas.width / b);
                                                    j = parseInt(i.style.height) + (this.meta.canvas.ctx.canvas.height / b);
                                                    if (a) {
                                                        this.resizeMoveObject(a, 0, 0, r + g, j + c)
                                                    }
                                                    if (f == "hide") {
                                                        n.style.display = "none"
                                                    }
                                                    this.resizeMoveObject(q, 0, 0, r, 0);
                                                    this.resizeMoveObject(o, 0, 0, r, 0)
                                                } else {
                                                    if (f && (f == "max" || f == "release" || f == "undock")) {
                                                        this.dataTableLastState = "free";
                                                        r = parseInt(e.style.width) + parseInt(m.style.width) + (this.meta.canvas.ctx.canvas.width / b);
                                                        j = parseInt(i.style.height) + (this.meta.canvas.ctx.canvas.height / b);
                                                        if (a) {
                                                            this.resizeMoveObject(a, 0, 0, r + r, j + c)
                                                        }
                                                        if (f == "max" || f == "undock") {
                                                            this.resizeMove(n, parseInt(this.dataTableLastX), parseInt(this.dataTableLastY), n.clientWidth, parseInt(this.dataTableLastHeight) || (this.dataTableRowsHeight + 42))
                                                        }
                                                        this.resizeMoveObject(q, 0, 0, r, 0);
                                                        this.resizeMoveObject(o, 0, 0, r, 0)
                                                    } else {
                                                        return
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.updateDataTableResizerDiv = function(g, l, k) {
                                    if (g && (l == null || k == null)) {
                                        l = Math.abs(this.dataTableWidth) - (this.xMouseDown - g.clientX);
                                        k = Math.abs(this.dataTableHeight) - (this.yMouseDown - g.clientY)
                                    }
                                    if (this.dataTableTarget && this.dataTableTarget.style && l && k) {
                                        var i = this.$(this.target + "-cX-DataTable");
                                        var j = this.$(this.target + "-cX-DataTableContainer");
                                        var a = this.$(this.target + "-cX-DataTableTableMask");
                                        var n = this.$(this.target + "-cX-DataTableVer");
                                        var b = this.$(this.target + "-cX-DataTableHor");
                                        var o = this.$(this.target + "-cX-DataTableToolbar");
                                        var f = 60;
                                        var p = 60;
                                        if (i && j && a && n && b && o) {
                                            this.dataTableTarget.style.width = CanvasXpress.system.isIE ? Math.max(0, l) + "px" : l + "px";
                                            j.style.width = CanvasXpress.system.isIE ? Math.max(0, l) + "px" : l + "px";
                                            a.style.width = CanvasXpress.system.isIE ? Math.max(0, (l - f)) + "px" : (l - f) + "px";
                                            b.style.width = CanvasXpress.system.isIE ? Math.max(0, (l - f)) + "px" : (l - f) + "px";
                                            o.style.width = CanvasXpress.system.isIE ? Math.max(0, l) + "px" : l + "px";
                                            this.dataTableTarget.style.height = CanvasXpress.system.isIE ? Math.max(0, k) + "px" : k + "px";
                                            j.style.height = CanvasXpress.system.isIE ? Math.max(0, (k - 28)) + "px" : (k - 28) + "px";
                                            a.style.height = CanvasXpress.system.isIE ? Math.max(0, (k - p)) + "px" : (k - p) + "px";
                                            n.style.height = CanvasXpress.system.isIE ? Math.max(0, (k - p)) + "px" : (k - p) + "px";
                                            this.dataTableLastWidth = l;
                                            this.dataTableLastHeight = k
                                        }
                                    }
                                };
                                this.endDataTableResizerDiv = function(a) {
                                    if (this.dataTableTarget != null) {
                                        this.adjustDataTable(a);
                                        this.xMouseDown = null;
                                        this.yMouseDown = null;
                                        this.dataTableWidth = null;
                                        this.dataTableHeight = null;
                                        this.dataTableTarget = false;
                                        this.resizingDataTableOn = false
                                    }
                                };
                                this.endDataTableColumnResize = function(a) {
                                    that = this;
                                    this.xMouseDown = null;
                                    this.yMouseDown = null;
                                    this.resizingDataTableColumnOn = false;
                                    this.dataTableColumnTarget = false;
                                    this.noSorting = true;
                                    window.document.body.style.cursor = "default";
                                    setTimeout(function() {
                                        that.noSorting = false
                                    }, 200)
                                };
                                this.updateSearchDataTable = function(b) {
                                    var e = this.$(b).value;
                                    var a = new RegExp(e, "i");
                                    var h = this.getAllNetworkAttributes(this.data);
                                    this.dataTableHide = {};
                                    if (h) {
                                        var d = this.data[this.networkShowDataTable];
                                        for (var g = 0; g < h[2].length; g++) {
                                            this.dataTableHide[h[2][g]] = true
                                        }
                                        var l = false;
                                        for (var g = 0; g < h[2].length; g++) {
                                            if (h[2] != null && h[2][g].toString().match(a)) {
                                                delete this.dataTableHide[h[2][g]];
                                                continue
                                            } else {
                                                l = false;
                                                for (var f = 0; f < h[3].length; f++) {
                                                    if (d[g][h[3][f]] != null && d[g][h[3][f]].toString().match(a)) {
                                                        l = true;
                                                        break
                                                    }
                                                }
                                            }
                                            if (l) {
                                                delete this.dataTableHide[h[2][g]]
                                            }
                                        }
                                    }
                                    if (this.data.z) {
                                        for (var g = 0; g < this.data.y.vars.length; g++) {
                                            this.dataTableHide[this.data.y.vars[g]] = true
                                        }
                                        for (var k in this.data.z) {
                                            this.dataTableHide[k] = false
                                        }
                                        for (var g = 0; g < this.data.y.vars.length; g++) {
                                            for (var k in this.data.z) {
                                                if (this.data.z[k][g].toString().match(a)) {
                                                    delete this.dataTableHide[this.data.y.vars[g]]
                                                }
                                            }
                                        }
                                    }
                                    if (this.data.x) {
                                        for (var g = 0; g < this.data.y.smps.length; g++) {
                                            this.dataTableHide[this.data.y.smps[g]] = true
                                        }
                                        for (var k in this.data.x) {
                                            this.dataTableHide[k] = false
                                        }
                                        for (var g = 0; g < this.data.y.smps.length; g++) {
                                            for (var k in this.data.x) {
                                                if (this.data.x[k][g].toString().match(a)) {
                                                    delete this.dataTableHide[this.data.y.smps[g]]
                                                }
                                            }
                                        }
                                    }
                                    this.updateDataTable(false, true);
                                    this.$(this.target + "-cX-DataTableToolbar").style.height = "36px";
                                    this.$(this.target + "-cX-DataTableSearch").value = e;
                                    this.$(this.target + "-cX-DataTableSearch").focus()
                                };
                                this.resetDataTableSearch = function() {
                                    this.$(this.target + "-cX-DataTableSearch").value = "";
                                    this.dataTableHide = {}
                                };
                                this.initializeDataTable = function() {
                                    if (!this.disableEvents && !this.disableDataTable && this.graphType != "Genome") {
                                        if (this.dataTableStyle == "stripped") {
                                            this.colorDataTable = false;
                                            this.rowHeight = Number(28)
                                        }
                                        return this.addDataTableDiv()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initCanvasResizerEvents = function() {
                                this.addCanvasResizerDiv = function(a) {
                                    if (a) {
                                        if (this.$("canvasXpressCanvasResize")) {
                                            return
                                        }
                                    } else {
                                        if (this.$(this.target + "canvasXpressCanvasResize")) {
                                            return
                                        }
                                    }
                                    var b = this.$cX("div", {
                                        id: a ? "canvasXpressCanvasResize" : this.target + "canvasXpressCanvasResize",
                                        className: "CanvasXpressCanvasResizer"
                                    }, {
                                        left: "0px",
                                        top: "0px",
                                        width: "0.5px",
                                        height: "0.5px",
                                        position: "absolute",
                                        display: "none",
                                        zIndex: 100001
                                    });
                                    if (a) {
                                        b.style.opacity = 0.5;
                                        b.style.filter = "alpha(opacity = 50)";
                                        b.style.backgroundColor = this.resizerBackgroundColor
                                    }
                                    if (a) {
                                        window.document.body.appendChild(b);
                                        return b
                                    } else {
                                        this.meta.canvas.ctx.canvas.parentNode.appendChild(b)
                                    }
                                };
                                this.isCanvasResize = function(c) {
                                    if (this.resizable) {
                                        var b = this.adjustedCoordinates(c);
                                        if (b) {
                                            var a = b.x;
                                            var d = b.y;
                                            if (a > this.width - 18 && this.resizableX && d > this.height - 18 && this.resizableY) {
                                                this.resizeCanvasCursorShow = "se-resize";
                                                return true
                                            } else {
                                                if (a > this.width - 18 && this.resizableX && d > 20) {
                                                    this.resizeCanvasCursorShow = "e-resize";
                                                    return true
                                                } else {
                                                    if (d > this.height - 18 && this.resizableY) {
                                                        this.resizeCanvasCursorShow = "s-resize";
                                                        return true
                                                    } else {
                                                        this.resizeCanvasCursorShow = false;
                                                        return false
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.updateCanvasResizerCursor = function(d) {
                                    if (this.resizable) {
                                        var b = this.$(this.target2);
                                        if (b) {
                                            var c = this.adjustedCoordinates(d);
                                            if (c) {
                                                var a = c.x;
                                                var f = c.y;
                                                if (a <= this.width && f <= this.height) {
                                                    if (a > this.width - 18 && this.resizableX && f > this.height - 18 && this.resizableY) {
                                                        b.style.cursor = "se-resize";
                                                        this.resizeCanvasCursorShow = "se-resize"
                                                    } else {
                                                        if (a > this.width - 18 && this.resizableX && f > 20) {
                                                            b.style.cursor = "e-resize";
                                                            this.resizeCanvasCursorShow = "e-resize"
                                                        } else {
                                                            if (f > this.height - 18 && this.resizableY) {
                                                                b.style.cursor = "s-resize";
                                                                this.resizeCanvasCursorShow = "s-resize"
                                                            } else {
                                                                if (!this.movingOn) {
                                                                    b.style.cursor = "default";
                                                                    this.resizeCanvasCursorShow = false
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.updateCanvasResizer = function(f) {
                                    if (this.resizingCanvasOn && this.resizeCanvasCursorShow) {
                                        window.document.body.style.cursor = this.resizeCanvasCursorShow;
                                        var c = this.$(this.target + "canvasXpressCanvasResize");
                                        var a = this.$("canvasXpressCanvasResize");
                                        var b = this.adjustedCoordinates(f);
                                        var d = this.relativeCoordinates(this.meta.canvas.ctx.canvas);
                                        if (c && b && d) {
                                            if (this.resizeCanvasCursorShow == "se-resize") {
                                                w = b.x;
                                                h = b.y
                                            } else {
                                                if (this.resizeCanvasCursorShow == "e-resize") {
                                                    w = b.x;
                                                    h = this.height
                                                } else {
                                                    if (this.resizeCanvasCursorShow == "s-resize") {
                                                        w = this.width;
                                                        h = b.y
                                                    }
                                                }
                                            }
                                            if (!a) {
                                                a = this.addCanvasResizerDiv(true)
                                            }
                                            this.preventSelection();
                                            dx = b.x - this.meta.canvas.ctx.canvas.width;
                                            dy = b.y - this.meta.canvas.ctx.canvas.height;
                                            c.style.width = w + "px";
                                            c.style.height = h + "px";
                                            c.style.display = "block";
                                            a.style.left = d.x + "px";
                                            a.style.top = d.y + "px";
                                            a.style.width = w + "px";
                                            a.style.height = h + "px";
                                            a.style.display = "block";
                                            CanvasXpress.resizing = true
                                        }
                                    }
                                };
                                this.endCanvasResizer = function(f) {
                                    if (this.resizingCanvasOn) {
                                        if (this.isTransition()) {
                                            return
                                        }
                                        var c = this.$(this.target);
                                        var a = this.$(this.target + "canvasXpressCanvasResize");
                                        var l = this.$("canvasXpressCanvasResize");
                                        var b = this.$("west-container-" + this.target);
                                        var j = this.$("middle-container-" + this.target);
                                        var d = this.$("east-container-" + this.target);
                                        if (c && a && l) {
                                            this.clickLayoutNoAnimation();
                                            var k = parseInt(a.style.width);
                                            var g = parseInt(a.style.height);
                                            j.style.width = (parseInt(b.style.width) + parseInt(a.style.width) + parseInt(d.style.width)) + "px";
                                            j.style.height = a.style.height;
                                            this.draw({
                                                width: k,
                                                height: g,
                                                func: "setDimensions",
                                                par: [k, g]
                                            });
                                            a.style.width = "0.5px";
                                            a.style.height = "0.5px";
                                            a.style.display = "none";
                                            c.style.cursor = "default";
                                            this.updateRemoteNavigationWindow();
                                            this.resetMotionDiv();
                                            window.document.body.removeChild(l);
                                            this.resizeCanvasCursorShow = false;
                                            this.resizingCanvasOn = false;
                                            CanvasXpress.resizing = false
                                        }
                                    }
                                };
                                this.initializeCanvasResizerEvents = function() {
                                    if (!this.disableEvents) {
                                        this.addCanvasResizerDiv();
                                        this.showMask()
                                    }
                                };
                                this.initializeCanvasResizerEvents()
                            };
                            CanvasXpress.prototype.initMotionEvents = function() {
                                this.addMotionDiv = function(ag) {
                                    var M = this.target + "-cX-Motion";
                                    if (!this.reproducing && (this.$(M) || !this.motionBy)) {
                                        if (!this.motionBy) {
                                            this.removeMotionDiv(false, ag)
                                        } else {
                                            if (this.motionObject && this.motionObject.name != this.motionBy) {
                                                this.resetMotionDiv(ag)
                                            } else {
                                                if (this.motionObject && this.motionObject.setIndices) {
                                                    this.updateMotionIndices([this.motionObject.current])
                                                }
                                            }
                                        }
                                        return
                                    } else {
                                        if (this.reproducing && this.$(M)) {
                                            return
                                        }
                                    }
                                    var R = this.reproducing ? 1 : 3;
                                    var G = this.reproducing ? 40 : 0;
                                    var E = this.reproducing ? 18 : 0;
                                    var ae = this.margin * 2;
                                    var ad = this.reproducing ? this.motionWidth : this.width - (this.margin * 6);
                                    var b = this.reproducing ? -this.motionWidth - 23 : this.margin * R;
                                    var f = 45 + this.margin + G;
                                    var af = this.reproducing ? 0 : this.height - (f + this.margin);
                                    var g = 20;
                                    var w = this.margin;
                                    var A = g;
                                    var m = 21 + this.margin + G;
                                    var k = ad - (g + (this.margin * 8));
                                    var y = this.margin * 4;
                                    var B = 14;
                                    var n = this.margin + G;
                                    var I = ad - (g + (this.margin * 8));
                                    var O = this.margin * 4;
                                    var T = 10;
                                    var K = this.margin + G;
                                    var C = ad + 17 - (g + (this.margin * 8) + 2);
                                    var F = 15 + (this.margin * 4);
                                    var J = 14;
                                    var D = this.margin + G;
                                    this.motionControlWidth = k;
                                    this.setMotionObject();
                                    var h = this.motionObject;
                                    var N = this.reproducing ? h.levels.length * 32 : 0;
                                    var ah = this.$cX("div", {
                                        id: M,
                                        className: this.reproducing ? "CanvasXpressMotion draggable" : "CanvasXpressMotion"
                                    }, {
                                        left: b + "px",
                                        top: af + "px",
                                        width: (ad + E) + "px",
                                        height: f + "px",
                                        position: "absolute",
                                        maxHeight: this.height + "px"
                                    });
                                    if (this.reproducing) {
                                        ah.style.backgroundColor = "rgba(245, 245, 245, 0.95)";
                                        ah.style.border = "1px solid rgb(51, 122, 183)";
                                        ah.style.borderRadius = "5px";
                                        ah.style.boxSizing = "content-box";
                                        ah.style.opacity = 0
                                    }
                                    var Y = this.$cXI("op_cancel", {
                                        id: M + "CloseImage",
                                        className: "CanvasXpressMotion unselectable",
                                        src: "op_cancel",
                                        title: "Close Reproducer"
                                    }, {
                                        cssFloat: "right",
                                        padding: "3px"
                                    });
                                    var ab = this.$cX("span", {
                                        id: M + "Span",
                                        className: "CanvasXpressMotion unselectable",
                                        innerHTML: "Customization Timeline"
                                    }, {
                                        left: "8px",
                                        top: "5px",
                                        position: "absolute",
                                        cssFloat: "left",
                                        fontWeight: "bold"
                                    });
                                    var Z = this.$cXI("v_play", {
                                        id: M + "Play",
                                        className: "unselectable",
                                        src: "v_play",
                                        className: "CanvasXpressMotion"
                                    }, {
                                        left: w + "px",
                                        top: m + "px",
                                        width: g + "px",
                                        height: A + "px",
                                        position: "relative",
                                        cssFloat: "left"
                                    });
                                    var W = this.$cX("div", {
                                        id: M + "Scale",
                                        className: "CanvasXpressMotion"
                                    }, {
                                        left: y + "px",
                                        top: n + "px",
                                        width: k + "px",
                                        height: B + "px",
                                        position: "relative",
                                        cssFloat: "left"
                                    });
                                    var S = this.$cX("div", {
                                        id: M + "Ticks",
                                        className: "CanvasXpressMotion"
                                    }, {
                                        left: O + "px",
                                        top: K + "px",
                                        width: I + "px",
                                        height: T + "px",
                                        position: "relative",
                                        cssFloat: "left"
                                    });
                                    var ai = this.$cX("div", {
                                        id: M + "Container",
                                        className: "CanvasXpressMotionContainer"
                                    }, {
                                        left: F + "px",
                                        top: D + "px",
                                        width: C + "px",
                                        height: J + "px",
                                        position: "relative",
                                        cssFloat: "left",
                                        clear: "none"
                                    });
                                    var aj = this.$cX("div", {
                                        id: M + "Current",
                                        className: "CanvasXpressMotionCurrent"
                                    }, {
                                        left: "0px",
                                        cursor: "pointer"
                                    });
                                    var X = this.$cX("div", {
                                        id: M + "Range",
                                        className: "CanvasXpressMotionRange"
                                    }, {
                                        width: 0,
                                        maxWidth: C + "px"
                                    });
                                    var P = this.$cX("div", {
                                        id: M + "Selection",
                                        className: "unselectable",
                                        draggable: false
                                    }, {
                                        left: w + "px",
                                        top: (D + this.margin) + "px",
                                        width: (this.motionWidth + E - ae) + "px",
                                        position: "relative",
                                        cssFloat: "left",
                                        clear: "both",
                                        maxHeight: (this.height - 100) + "px"
                                    });
                                    var U = this.$cX("ul", {
                                        className: "CanvasXpressList unselectable",
                                        draggable: false
                                    }, {
                                        height: (this.height - 100) + "px"
                                    });
                                    P.appendChild(U);
                                    if (h.type == "String") {
                                        if (h.levels.length < 100) {
                                            for (var ac = 0; ac < h.levels.length; ac++) {
                                                var ad = this.measureText(ac.toString(), " 2pt Arial");
                                                var Q = h.levels[ac].length > 18 ? h.levels[ac].substring(0, 15) + "..." : h.levels[ac];
                                                var aa = this.$cX("div", {
                                                    className: "unselectable",
                                                    innerHTML: ac.toString(),
                                                    title: h.levels[ac]
                                                }, {
                                                    left: (parseInt((ac * h.unit) - (ad / 2))) + "px",
                                                    cssFloat: "left",
                                                    position: "absolute",
                                                    fontSize: "xx-small",
                                                    cursor: "pointer"
                                                });
                                                W.appendChild(aa);
                                                var V = this.$cX("div", {
                                                    className: "unselectable",
                                                    innerHTML: "|"
                                                }, {
                                                    left: (parseInt(ac * h.unit) + 1) + "px",
                                                    cssFloat: "left",
                                                    position: "absolute",
                                                    fontSize: "xx-small"
                                                });
                                                S.appendChild(V);
                                                if (this.reproducing) {
                                                    var L = this.$cX("li", {
                                                        className: "CanvasXpressListItem"
                                                    }, {
                                                        height: "initial"
                                                    });
                                                    var o = this.$cX("a", {
                                                        className: "CanvasXpressListItemA",
                                                        unselectable: "on",
                                                        draggable: false
                                                    });
                                                    var H = this.$cXI(ac < h.levels.length - 1 ? "sl_radiooff" : "sl_radioon", {
                                                        className: "CanvasXpressListIcon unselectable",
                                                        idx: ac,
                                                        src: ac < h.levels.length - 1 ? "sl_radiooff" : "sl_radioon"
                                                    });
                                                    var v = this.$cX("span", {
                                                        innerHTML: ac + ". " + h.levels[ac],
                                                        className: "CanvasXpressListItemText unselectable",
                                                        idx: ac,
                                                        draggable: false
                                                    });
                                                    o.appendChild(H);
                                                    o.appendChild(v);
                                                    L.appendChild(o);
                                                    U.appendChild(L)
                                                }
                                            }
                                        }
                                    } else {
                                        for (var ac = 0; ac < h.values.length; ac++) {
                                            var ad = this.measureText(h.values[ac].toString(), " 2pt Arial");
                                            var aa = this.$cX("div", {
                                                className: "unselectable",
                                                innerHTML: h.values[ac],
                                                title: h.values[ac]
                                            }, {
                                                left: (parseInt(((h.values[ac] - h.min) * h.unit) - (ad / 2))) + "px",
                                                cssFloat: "left",
                                                position: "absolute",
                                                fontSize: "xx-small",
                                                cursor: "pointer"
                                            });
                                            W.appendChild(aa);
                                            var V = this.$cX("div", {
                                                className: "unselectable",
                                                innerHTML: "|"
                                            }, {
                                                left: (parseInt((h.values[ac] - h.min) * h.unit) + 1) + "px",
                                                cssFloat: "left",
                                                position: "absolute",
                                                fontSize: "xx-small"
                                            });
                                            S.appendChild(V)
                                        }
                                    }
                                    if (this.reproducing) {
                                        ah.appendChild(Y)
                                    }
                                    ai.appendChild(X);
                                    ai.appendChild(aj);
                                    if (this.reproducing) {
                                        ah.appendChild(ab)
                                    }
                                    ah.appendChild(Z);
                                    ah.appendChild(W);
                                    ah.appendChild(S);
                                    ah.appendChild(ai);
                                    if (this.reproducing) {
                                        ah.style.height = (f + N + ae) + "px";
                                        ah.appendChild(P)
                                    }
                                    this.updateMotionIndices();
                                    var C = this.$("center-wrapper-" + this.target);
                                    if (C) {
                                        C.appendChild(ah);
                                        this.addRemoveMotionListeners("addEvtListener")
                                    }
                                    if (this.motionCache) {
                                        this.refreshMotionDiv()
                                    }
                                    if (this.reproducing) {
                                        this.transitionMagic(ah, "swashIn")
                                    }
                                };
                                this.setMotionObject = function() {
                                    if (this.motionObject && this.motionObject.name == this.motionBy) {
                                        return
                                    } else {
                                        if (this.reproducing) {
                                            var h = CanvasXpress.stack[this.target].afterRender;
                                            var g = h.length;
                                            var a = {
                                                type: "String",
                                                levels: [],
                                                unit: this.motionControlWidth / (g - 1),
                                                current: h[0][0],
                                                currentIdx: 0,
                                                name: "Reproduce",
                                                fraction: 0,
                                                initialized: false
                                            };
                                            for (var c = 0; c < g; c++) {
                                                a.levels.push(h[c][0])
                                            }
                                            this.motionObject = a
                                        } else {
                                            var a = {};
                                            var d = [];
                                            var b = {};
                                            var e = this.data.x && this.data.x[this.motionBy] ? this.meta.data.x[this.motionBy] : this.meta.data.z[this.motionBy];
                                            if (e.type == "Numeric") {
                                                if (this.data.x && this.data.x[this.motionBy]) {
                                                    for (var c = 0; c < this.data.x[this.motionBy].length; c++) {
                                                        var f = this.data.x[this.motionBy][c];
                                                        if (!b.hasOwnProperty(f)) {
                                                            d.push(f);
                                                            b[f] = true
                                                        }
                                                    }
                                                    a.meta = "x"
                                                } else {
                                                    for (var c = 0; c < this.data.z[this.motionBy].length; c++) {
                                                        var f = this.data.z[this.motionBy][c];
                                                        if (!b.hasOwnProperty(f)) {
                                                            d.push(f);
                                                            b[f] = true
                                                        }
                                                    }
                                                    a.meta = "z"
                                                }
                                                if (d.length > 20) {
                                                    a.type = "Numeric";
                                                    a.values = [];
                                                    a.min = e.rmin;
                                                    a.max = e.rmax;
                                                    a.unit = this.motionControlWidth / (e.vals[e.vals.length - 1] - e.rmin);
                                                    a.current = e.rmin;
                                                    for (var c = 0; c < e.vals.length; c++) {
                                                        if (e.vals[c] >= e.rmin) {
                                                            a.values.push(e.vals[c])
                                                        }
                                                    }
                                                    a.range = e.rmax - e.rmin;
                                                    a.step = Math.pow(10, Math.floor(Math.log(a.range / a.values.length) / Math.LN10));
                                                    a.decs = this.getAxisDecimals(a.step);
                                                    a.levels = d.sort(function(j, i) {
                                                        return j - i
                                                    })
                                                } else {
                                                    a.type = "String";
                                                    a.levels = d.sort(function(j, i) {
                                                        return j - i
                                                    });
                                                    a.unit = this.motionControlWidth / (d.length - 1);
                                                    a.current = d[0]
                                                }
                                            } else {
                                                a.type = "String";
                                                a.levels = e.levels;
                                                a.unit = this.motionControlWidth / (e.levels.length - 1);
                                                a.current = e.levels[0]
                                            }
                                            a.varIndices = this.cloneObject(this.varIndices);
                                            a.smpIndices = this.cloneObject(this.smpIndices);
                                            a.grpIndices = this.cloneObject(this.grpIndices);
                                            a.varIndicesMotion = [];
                                            a.smpIndicesMotion = [];
                                            a.grpIndicesMotion = [];
                                            a.name = this.motionBy;
                                            a.fraction = 0;
                                            this.motionObject = a
                                        }
                                    }
                                };
                                this.updateMotionIndices = function(g, a) {
                                    if (this.motionBy && this.motionObject) {
                                        var c = [];
                                        var h = this.motionObject.meta == "x" ? this.motionObject.smpIndices : this.motionObject.varIndices;
                                        var k = this.motionObject.meta == "x" ? this.data.x[this.motionBy] : this.data.z[this.motionBy];
                                        if (this.motionObject.type == "String") {
                                            var b = g && g[0] != null ? g[0] : this.motionObject.levels[0];
                                            for (var e = 0; e < h.length; e++) {
                                                var j = h[e];
                                                if (k[j] == b) {
                                                    c.push(j)
                                                }
                                            }
                                        } else {
                                            var d = g && g[0] != null ? g[0] : this.motionObject.min;
                                            var f = g && g[1] != null ? g[1] : this.motionObject.values[0];
                                            for (var e = 0; e < h.length; e++) {
                                                var j = h[e];
                                                if (k[j] > d && k[j] <= f) {
                                                    c.push(j)
                                                }
                                            }
                                        }
                                        if (this.motionObject.meta == "x") {
                                            this.smpIndices = c
                                        } else {
                                            this.varIndices = c
                                        }
                                        if (g && g.length > 0 && !a) {
                                            this.motionObject.varIndicesMotion.push(this.cloneObject(this.varIndices));
                                            this.motionObject.smpIndicesMotion.push(this.cloneObject(this.smpIndices));
                                            this.motionObject.grpIndicesMotion.push(this.cloneObject(this.grpIndices))
                                        }
                                        if (this.motionObject.varIndicesMotion.length > 3) {
                                            this.motionObject.varIndicesMotion.shift()
                                        }
                                        if (this.motionObject.smpIndicesMotion.length > 3) {
                                            this.motionObject.smpIndicesMotion.shift()
                                        }
                                        if (this.motionObject.grpIndicesMotion.length > 3) {
                                            this.motionObject.grpIndicesMotion.shift()
                                        }
                                    }
                                };
                                this.addRemoveMotionListeners = function(l) {
                                    var d = this.$(this.target + "-cX-Motion");
                                    var a = this.$(this.target + "-cX-MotionPlay");
                                    var g = this.$(this.target + "-cX-MotionCurrent");
                                    if (l && d && a && g) {
                                        if (this.reproducing) {
                                            var h = this.$(this.target + "-cX-MotionCloseImage");
                                            if (h) {
                                                this[l](h, "click", this.closeMotion, false)
                                            }
                                            this[l](d, "mousedown", this.registerMousemove, false);
                                            var n = this.$(this.target + "-cX-MotionSelection");
                                            if (n) {
                                                for (var f = 0; f < n.childNodes[0].childNodes.length; f++) {
                                                    var k = n.childNodes[0].childNodes[f].childNodes[0];
                                                    for (var e = 0; e < k.childNodes.length; e++) {
                                                        var b = k.childNodes[e];
                                                        this[l](b, "click", this.clickMotionSelection, false)
                                                    }
                                                }
                                            }
                                        }
                                        this[l](a, "click", this.clickMotion, false);
                                        this[l](g, "mousedown", this.mousedownMotion, false)
                                    }
                                };
                                this.closeMotion = function(a) {
                                    return function(c) {
                                        var b = a.getTargetEvent(c);
                                        if (b) {
                                            var f = a.$(a.target + "-cX-Motion");
                                            a.transitionMagic(f, "holeOut", function() {
                                                a.updateReproducing(a.motionObject.levels.length - 1);
                                                a.removeMotionDiv(false, c)
                                            })
                                        }
                                    }
                                }(this);
                                this.mousedownMotion = function(a) {
                                    return function(d) {
                                        var b = a.getTargetEvent(d);
                                        if (b) {
                                            var c = a.$(a.target + "-cX-MotionRange");
                                            if (c) {
                                                a.motionOn = c.style.width;
                                                a.xMouseDown = d.clientX;
                                                a.yMouseDown = d.clientY
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.updateMotionToCurrent = function(b, g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var f = this.$(this.target + "-cX-MotionRange");
                                    if (f) {
                                        var a = this.motionObject.levels;
                                        var e = null;
                                        for (var c = 0; c < a.length; c++) {
                                            if (a[c] == b) {
                                                e = c + 0.99;
                                                if (c == a.length - 1) {
                                                    e += 0.05
                                                }
                                                break
                                            }
                                        }
                                        if (e != null) {
                                            var d = this.motionControlWidth / a.length * e;
                                            this.disableMotion = true;
                                            this.updateMotion(false, d, false, g);
                                            delete this.disableMotion
                                        }
                                    }
                                };
                                this.updateMotion = function(j, l, h, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = this.$(this.target + "-cX-MotionRange");
                                    if (a) {
                                        var c;
                                        var k = this.motionControlWidth;
                                        var m = l != null ? Math.min(Math.max(0, l), k) : j ? Math.min(Math.max(0, j.clientX + parseInt(this.motionOn) - this.xMouseDown), k) : 0;
                                        var g = m / this.motionObject.unit;
                                        a.style.width = m + "px";
                                        this.motionFraction = m / k;
                                        this.motionObject.last = m;
                                        if (this.motionObject.type == "String") {
                                            c = parseInt(g);
                                            if (this.reproducing) {
                                                this.updateReproducing(c)
                                            } else {
                                                if (this.motionObject.levels[c] != this.motionObject.current || h) {
                                                    this.updateMotionIndices([this.motionObject.levels[c]], h);
                                                    this.motionObject.current = this.motionObject.levels[c];
                                                    if (this.userEvents.motion) {
                                                        this.userEvents.motion.call(this, this.motionObject.current, j, this)
                                                    }
                                                    if (!b) {
                                                        this.draw({
                                                            func: "updateMotion",
                                                            par: [j, l, h, b]
                                                        })
                                                    }
                                                }
                                            }
                                        } else {
                                            c = g + this.motionObject.min;
                                            for (var d = 1; d < this.motionObject.values.length; d++) {
                                                if (this.motionObject.values[d] > c) {
                                                    this.updateMotionIndices([this.motionObject.values[d - 1], c], h);
                                                    if (this.motionObject.decs) {
                                                        this.motionObject.current = this.formatNumber(c, this.motionObject.decs)
                                                    } else {
                                                        this.motionObject.current = parseInt(c)
                                                    }
                                                    if (this.userEvents.motion) {
                                                        this.userEvents.motion.call(this, this.motionObject.current, j, this)
                                                    }
                                                    if (!b) {
                                                        this.draw({
                                                            func: "updateMotion",
                                                            par: [j, l, h, b]
                                                        })
                                                    }
                                                    break
                                                }
                                            }
                                        }
                                    }
                                };
                                this.updateReproducing = function(a) {
                                    if (!this.motionObject.initialized) {
                                        this.initializeDataReproduceMotion();
                                        this.motionObject.initialized = true
                                    }
                                    if (a != this.motionObject.currentIdx) {
                                        if (a == (this.motionObject.currentIdx + 1)) {
                                            this.reproduceMotionDataToIdx(a, this.motionObject.currentIdx, true)
                                        } else {
                                            this.motionObject.currentIdx = null;
                                            this.reproduceMotionDataToIdx(a, null)
                                        }
                                        this.motionObject.currentIdx = a
                                    } else {
                                        if (!this.reproduceMotionDragOn) {
                                            this.reproduceMotionDrag(a + 1)
                                        }
                                    }
                                };
                                this.initializeDataReproduceMotion = function() {
                                    var d = this.parseJSON(this.stringifyJSON(CanvasXpress.stack[this.target].data));
                                    var b = this.parseJSON(this.stringifyJSON(CanvasXpress.stack[this.target].config));
                                    var f = CanvasXpress.stack[this.target].afterRender;
                                    var a = this.showTransition;
                                    this.setConfigDefaults();
                                    for (var e in b) {
                                        this[e] = b[e]
                                    }
                                    this.reproducing = true;
                                    this.showTransition = false;
                                    this.skipRender = false;
                                    this.layoutValid = false;
                                    this.initializeData(d, true);
                                    this.resetLegendPosition(true);
                                    this.resetDendrograms();
                                    this.setTheme();
                                    this.initializeGraph(true);
                                    this[f[0][0]].apply(this, f[0][1]);
                                    this.hideMask();
                                    this.showTransition = a
                                };
                                this.getDragDivDimensions = function(E, y, A) {
                                    var w, k, m, i, x, n, r, j, B, s, z, q;
                                    var F = y[0];
                                    var G = null;
                                    var D = this.graphType;
                                    switch (E) {
                                        case "handleDragEventGenome":
                                        case "handleDragEventHeatmap":
                                        case "handleDragEventOneDimension":
                                        case "handleDragEventScatter":
                                        case "handlePanning":
                                        case "showHideSelectedData":
                                            G = y[1];
                                            break;
                                        case "updateDragNetwork":
                                            G = y[5];
                                            break
                                    }
                                    var H = G != null ? this.getBoundsXY(G) : false;
                                    if (H != false) {
                                        var C = F.xMouseDown;
                                        var v = F.yMouseDown;
                                        var u = F.ac.x;
                                        var a = F.ac.y;
                                        if (C >= H[0] && C <= H[1] && v >= H[2] && v <= H[3]) {
                                            if ((!D.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation == "vertical" && !F.shiftKey) || (!D.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation != "vertical" && F.shiftKey)) {
                                                w = x = H[0];
                                                m = r = H[1] - H[0]
                                            } else {
                                                w = x = Math.min(C, u);
                                                m = 0;
                                                r = u > C ? u - C : C - u
                                            }
                                            B = x;
                                            z = x + r;
                                            if ((!D.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation != "vertical" && !F.shiftKey) || (!D.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation == "vertical" && F.shiftKey) || D == "Genome") {
                                                k = n = H[2];
                                                i = j = H[3] - H[2]
                                            } else {
                                                k = n = Math.min(v, a);
                                                i = 0;
                                                j = a > v ? a - v : v - a
                                            }
                                            s = n;
                                            q = n + j
                                        } else {
                                            if (A && C >= H[4] && C <= H[5] && v >= H[6] && v <= H[7]) {
                                                var h = function() {
                                                    w = x = H[4];
                                                    k = v;
                                                    n = a;
                                                    m = r = H[5] - H[4];
                                                    i = j = 3;
                                                    B = C;
                                                    s = v;
                                                    z = C;
                                                    q = n
                                                };
                                                var d = function() {
                                                    w = C;
                                                    x = u;
                                                    k = n = H[6];
                                                    m = r = 3;
                                                    i = j = H[7] - H[6];
                                                    B = C;
                                                    s = v;
                                                    z = x;
                                                    q = v
                                                };
                                                if (A.moveDendrogram) {
                                                    if (A.moveDendrogram == "varDendrogram" || (A.moveDendrogram == "smpDendrogram" && this.graphOrientation == "vertical")) {
                                                        h()
                                                    } else {
                                                        d()
                                                    }
                                                } else {
                                                    if (A.moveSmpOverlay) {
                                                        if (D.match(/Heatmap/) || this.graphOrientation == "horizontal") {
                                                            d()
                                                        } else {
                                                            h()
                                                        }
                                                    } else {
                                                        if (A.moveSmp) {
                                                            if (D.match(/Heatmap/) || this.graphOrientation == "horizontal") {
                                                                h()
                                                            } else {
                                                                d()
                                                            }
                                                        } else {
                                                            if (A.moveVarOverlay) {
                                                                h()
                                                            } else {
                                                                if (A.moveVar) {
                                                                    d()
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return [w, k, m, i, x, n, r, j, B, s, z, q]
                                };
                                this.getReproduceMotionDragIcon = function(a, b) {
                                    if (a == "updateClickConfigurator") {
                                        return this.$cXI("m_left2", false, false, true)
                                    } else {
                                        if (b.type.match(/wheel/)) {
                                            return this.$cXI("m_wheel", false, false, true)
                                        } else {
                                            if (b.type.match(/key/)) {
                                                return this.$cXI("ch_cesc", false, false, true)
                                            } else {
                                                if (b.type.match(/mouse/)) {
                                                    return this.$cXI("m_left", false, false, true)
                                                } else {
                                                    return this.$cXI("m_right", false, false, true)
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getHTMLReproduceMotionDragIcon = function(c, d) {
                                    var b = this.getReproduceMotionDragIcon(c, d);
                                    var a = b ? [b] : [];
                                    if (d.shiftKey) {
                                        a.push(this.$cXI("ch_cshift", false, false, true))
                                    }
                                    if (d.ctrlKey) {
                                        a.push(this.$cXI("ch_cctrl", false, false, true))
                                    }
                                    if (d.altKey) {
                                        a.push(this.$cXI("ch_calt", false, false, true))
                                    }
                                    return a.length > 0 ? a.join("") : ""
                                };
                                this.reproduceMotionCode = function(i, j) {
                                    var b = CanvasXpress.stack[this.target].afterRender[i];
                                    if (!b) {
                                        this.flashInfoSpan(this.width / 2, this.height / 2, "<b>That's All Folks</b>", 2000);
                                        return
                                    }
                                    var f = b[0];
                                    var a = b[1] || [];
                                    var h = b[2] || {};
                                    var e = j ? "<b>Function " + i + ":</b> " + f + "<br><br>" : "<b>Next modification...</b><br><br><b>Function " + i + ":</b> " + f + "<br><br>";
                                    var d = a[0] && a[0].type ? this.getHTMLReproduceMotionDragIcon(f, a[0]) : f == "updateDragScatter" || f == "setDimensions" ? this.$cXI("m_left", false, false, true) : "";
                                    var g = this.prettyJSON(a);
                                    if (g.length > 200) {
                                        g = g.substring(0, 250) + "..."
                                    }
                                    e += "<b>Parameters:</b> " + d + '<pre class="CanvasXpressCode">' + g + "</pre><br>";
                                    var c = this.prettyJSON(h);
                                    if (c.length > 200) {
                                        c = g.substring(0, 250) + "..."
                                    }
                                    e += '<b>Config:</b> <pre class="CanvasXpressCode">' + c + "</pre><br>";
                                    if (this.reproduceMotionCurrentDiv) {
                                        this.closeTooltipDiv(false, this.reproduceMotionCurrentDiv.id)
                                    }
                                    if (j) {
                                        this.reproduceMotionCurrentDiv = this.showTooltipDiv(false, e, false, false, this.width + 1, -2)
                                    } else {
                                        this.reproduceMotionCurrentDiv = this.flashInfoSpan(this.width + 1, -2, e)
                                    }
                                };
                                this.reproduceMotionDrag = function(m) {
                                    if (this.motioningOn) {
                                        this.reproduceMotionCode(m);
                                        var l = window.document;
                                        var c = l.scrollingElement;
                                        var b = this.$(this.target);
                                        var p = b.parentNode.getClientRects();
                                        var g = this.$(this.target + "-cX-Drag");
                                        var h = this.$(this.target + "-cX-Icon-Reproduce");
                                        if (!h) {
                                            h = this.$cXI("tm_history", {
                                                id: this.target + "-cX-Icon-Reproduce",
                                                src: "tm_history"
                                            }, {
                                                display: "none",
                                                position: "absolute",
                                                zIndex: 239010
                                            });
                                            l.body.appendChild(h)
                                        }
                                        var d = CanvasXpress.stack[this.target].afterRender[m];
                                        if (!d || !d[1] || !d[1][0] || !d[1][0].type) {
                                            this.resetReproduceDragDiv();
                                            return
                                        }
                                        var i = d[0];
                                        var a = d[1] || [];
                                        var k = d[2] || {};
                                        var o = a[0] && a[0].type && a[0].type.match(/wheel/) ? true : false;
                                        var n = this.reproduceTime * 0.95;
                                        var j = (c.scrollLeft || 0) + p[0].left - 16;
                                        var e = (c.scrollTop || 0) + p[0].top - 16;
                                        if (o) {
                                            this.resetReproduceDragDiv();
                                            this.reproduceMotionDragOn = true;
                                            this.$cXIU(h, "m_wheel", false, {
                                                left: j + a[0].ac.x + "px",
                                                top: e + a[0].ac.y + "px",
                                                width: "24px",
                                                height: "24px",
                                                display: "block",
                                                position: "absolute"
                                            })
                                        } else {
                                            if (i != "updateDragScatter" && i != "setDimensions") {
                                                this.reproduceMotionDragOn = true;
                                                var f = this.getDragDivDimensions(i, a, k);
                                                this.$cXIU(h, "m_left", false, {
                                                    left: j + f[8] + "px",
                                                    top: e + f[9] + "px",
                                                    width: "24px",
                                                    height: "24px",
                                                    display: "block",
                                                    position: "absolute"
                                                });
                                                g.style.left = f[0] + "px";
                                                g.style.top = f[1] + "px";
                                                g.style.width = f[2] + "px";
                                                g.style.height = f[3] + "px";
                                                g.style.display = "block";
                                                this.resizeMove(g, f[4] + 16, f[5], f[6], f[7], n);
                                                this.resizeMove(h, j + f[10] + 16, e + f[11], 32, 32, n)
                                            }
                                        }
                                    }
                                };
                                this.reproduceMotionDataToIdx = function(d, n, l) {
                                    var j = CanvasXpress.stack[this.target].afterRender.length - 1;
                                    var g = n != null ? n : 1;
                                    if (g != d || d != j) {
                                        this.showMask();
                                        if (!l) {
                                            this.initializeDataReproduceMotion()
                                        }
                                        for (var e = g; e <= d; e++) {
                                            if (e == this.motionObject.currentIdx) {
                                                continue
                                            }
                                            var m = this.showTransition;
                                            var b = CanvasXpress.stack[this.target].afterRender[e];
                                            var h = b[0];
                                            var a = b[1] || [];
                                            var k = b[2] || {};
                                            for (var f in k) {
                                                this[f] = k[f]
                                            }
                                            if (h == "createHistogram") {
                                                this.isDOE = false
                                            }
                                            this.reproducing = true;
                                            this.showTransition = false;
                                            this.updateMotionSelection(e);
                                            this.skipStack = true;
                                            this[h].apply(this, a);
                                            this.skipStack = false;
                                            this.reproduceMotionDrag(e + 1);
                                            this.showTransition = m
                                        }
                                        this.hideMask()
                                    }
                                };
                                this.clickMotion = function(a) {
                                    return function(h, c, b) {
                                        if (b) {
                                            for (var f = 0; f < a.motionObject.levels.length; f++) {
                                                a.updateReproducing(f);
                                                a.print(false, (a.saveFilename ? a.saveFilename : "cX-" + a.target) + "-" + f + ".png")
                                            }
                                        } else {
                                            if (h || c) {
                                                var g = a.$(a.target + "-cX-MotionPlay");
                                                if (a.motioningOn) {
                                                    a.$cXIU(g, "v_play");
                                                    a.motioningOnStop = true;
                                                    return
                                                }
                                                a.$cXIU(g, "v_stop");
                                                a.motionOn = a.reproducing ? 0 : "0px";
                                                a.motioningOn = true;
                                                a.motioningOnStop = false;
                                                var j = a.motionControlWidth;
                                                var k = j / a.motionObject.levels.length;
                                                var m = a.motionObject.last || 0;
                                                if (a.reproducing) {
                                                    a.updateMotionSelection(a.motionObject.lastSelection || 0)
                                                }
                                                if (m == 0) {
                                                    a.resetSelected(h, true);
                                                    a.meta.ids = {}
                                                }
                                                var d = function() {
                                                    if (m >= j || a.motioningOnStop) {
                                                        var i = function() {
                                                            var o = a.reproducing ? 0 : a.motionObject.varIndicesMotion.length;
                                                            if (o < 1) {
                                                                a.motionOn = false;
                                                                a.motioningOn = false;
                                                                a.motioningOnStop = false;
                                                                a.motionObject.last = m >= j ? 0 : m;
                                                                a.resetReproduceDragDiv();
                                                                clearInterval(e);
                                                                a.$cXIU(g, "v_play");
                                                                a.skipStack = false;
                                                                a.skipTransition = false;
                                                                return
                                                            }
                                                            if (!a.reproducing) {
                                                                a.motionObject.varIndicesMotion.shift();
                                                                a.motionObject.smpIndicesMotion.shift();
                                                                a.motionObject.grpIndicesMotion.shift()
                                                            }
                                                            if (!a.motioningOnStop) {
                                                                a.updateMotion(h, j, false, true)
                                                            }
                                                        };
                                                        clearInterval(l);
                                                        var e = a.setInterval(i, a.reproduceTime)
                                                    }
                                                    m += k;
                                                    a.updateMotion(h, m, false, true)
                                                };
                                                if (a.reproducing && !a.motionObject.initialized) {
                                                    a.initializeDataReproduceMotion();
                                                    a.motionObject.initialized = true
                                                }
                                                a.updateMotion(h, m, false, true);
                                                a.skipStack = true;
                                                a.skipTransition = true;
                                                var l = a.setInterval(d, a.reproduceTime)
                                            }
                                        }
                                    };
                                    return false
                                }(this);
                                this.clickMotionSelection = function(a) {
                                    return function(d) {
                                        var c = a.getTargetEvent(d);
                                        if (c) {
                                            var b = c.getAttribute("idx");
                                            if (b == 0) {
                                                a.resetSelected(d, true);
                                                a.meta.ids = {}
                                            }
                                            a.updateMotionSelection(b);
                                            a.updateMotionSelectionScale(b);
                                            a.updateReproducing(b);
                                            a.reproduceMotionCode(b, true)
                                        }
                                    };
                                    return false
                                }(this);
                                this.updateMotionSelection = function(b) {
                                    var g = this.$(this.target + "-cX-MotionSelection");
                                    if (g) {
                                        var a = 0;
                                        var f = parseInt(g.style.maxHeight);
                                        if (g.childNodes[0].childNodes.length > 1) {
                                            a = g.childNodes[0].childNodes[1].offsetTop - g.childNodes[0].childNodes[0].offsetTop
                                        }
                                        for (var d = 0; d < g.childNodes[0].childNodes.length; d++) {
                                            var c = g.childNodes[0].childNodes[d].childNodes[0].childNodes[0];
                                            if (c.getAttribute("idx") == b) {
                                                this.$cXIU(c, "sl_radioon");
                                                var j = g.childNodes[0];
                                                var h = g.childNodes[0].childNodes[d];
                                                if (h.offsetTop > f - j.scrollTop) {
                                                    j.scrollTop = h.offsetTop
                                                } else {
                                                    if (h.offsetTop < j.scrollTop) {
                                                        j.scrollTop = h.offsetTop
                                                    }
                                                }
                                            } else {
                                                this.$cXIU(c, "sl_radiooff")
                                            }
                                        }
                                        this.motionObject.lastSelection = b
                                    }
                                };
                                this.updateMotionSelectionScale = function(a) {
                                    var c = this.$(this.target + "-cX-MotionRange");
                                    if (c && this.motionObject.type == "String") {
                                        var b = this.motionControlWidth / (this.motionObject.levels.length - 1) * a;
                                        c.style.width = b + "px";
                                        this.motionObject.last = b
                                    }
                                };
                                this.refreshMotionDiv = function() {
                                    this.updateMotionIndices([this.motionCache.current], true);
                                    this.motionObject.current = this.motionCache.current;
                                    var a = this.$(this.target + "-cX-MotionRange");
                                    if (a) {
                                        a.style.width = parseInt(Number(this.motionControlWidth) * Number(this.motionCache.fraction)) + "px"
                                    }
                                    this.motionObject.setIndices = false;
                                    delete(this.motionCache)
                                };
                                this.removeMotionDiv = function(a, b) {
                                    var d = this.$(this.target + "-cX-Motion");
                                    if (d) {
                                        if (this.reproduceMotionCurrentDiv) {
                                            this.closeTooltipDiv(false, this.reproduceMotionCurrentDiv.id)
                                        }
                                        this.addRemoveMotionListeners("removeEvtListener");
                                        var c = this.reproducing ? CanvasXpress.stack[this.target].afterRender.length - 1 : 0;
                                        if (a) {
                                            this.motionCache = {
                                                name: this.motionObject.name,
                                                current: this.motionObject.type == "String" ? [this.motionObject.current] : [this.motionObject.current],
                                                fraction: this.motionFraction
                                            }
                                        }
                                        this.reset(false, false, b, true);
                                        this.initializeAxis();
                                        if (c) {
                                            this.reproduceMotionDataToIdx(c, this.motionObject.currentIdx)
                                        }
                                        this.skipStack = false;
                                        this.reproducing = false;
                                        delete(this.motionObject);
                                        d.parentNode.removeChild(d);
                                        this.hideMask()
                                    }
                                };
                                this.endMotion = function() {
                                    this.motionOn = false;
                                    return false
                                };
                                this.resetReproduceDragDiv = function() {
                                    var a = this.$(this.target + "-cX-Icon-Reproduce");
                                    if (a) {
                                        a.style.display = "none"
                                    }
                                    if (this.reproduceMotionCurrentDiv) {
                                        this.closeTooltipDiv(false, this.reproduceMotionCurrentDiv.id)
                                    }
                                    this.resetDrag();
                                    this.reproduceMotionDragOn = false
                                };
                                this.resetMotionDiv = function(a) {
                                    if (this.motionBy && !this.disableEvents) {
                                        this.skipStack = true;
                                        this.removeMotionDiv(false, a);
                                        this.addMotionDiv()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initDraggingEvents = function() {
                                this.getActiveLayout = function(k) {
                                    if (k) {
                                        var h = {};
                                        if (k && k.type == "keydown") {
                                            h.x = (this.layoutComb ? this.layoutParams[0].width : this.width) / 2;
                                            h.y = (this.layoutComb ? this.layoutParams[0].height : this.height) / 2
                                        } else {
                                            h = this.adjustedCoordinates(k)
                                        }
                                        if (this.layoutValid) {
                                            var a = h.x;
                                            var g = h.y;
                                            var m = 0;
                                            for (var f = 0; f < this.layoutRows; f++) {
                                                for (var d = 0; d < this.layoutCols; d++) {
                                                    if (m < this.data.l.weight.length) {
                                                        var b = this.getBoundsXY(m);
                                                        if (a >= b[4] && a <= b[5] && g >= b[6] && g <= b[7]) {
                                                            this.layoutValidR = f;
                                                            this.layoutValidC = d;
                                                            this.layoutValidN = m;
                                                            this.layoutValidBounds = b;
                                                            m = {
                                                                idx: m,
                                                                row: f,
                                                                col: d,
                                                                ac: h,
                                                                bounds: b
                                                            };
                                                            return m
                                                        }
                                                        m++
                                                    } else {
                                                        return false
                                                    }
                                                }
                                            }
                                        } else {
                                            return {
                                                idx: 0,
                                                row: 0,
                                                col: 0,
                                                ac: h
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.setActiveLayout = function(a) {
                                    var b = this.getActiveLayout(a);
                                    if (b && b.row != null && b.col != null && b.idx != null) {
                                        this.layoutValidR = b.row;
                                        this.layoutValidC = b.col;
                                        this.layoutValidN = b.idx;
                                        this.layoutValidBounds = b.bounds
                                    }
                                };
                                this.getActiveLayoutIndicesMetadata = function(f) {
                                    var g = this.getActiveLayout(f);
                                    if (g) {
                                        var q = this.layoutComb ? this.layoutParams[g.idx] : this;
                                        var a = this.cloneObject(q.varIndices);
                                        var h = this.isGroupedData ? this.cloneObject(q.grpIndices) : this.cloneObject(q.smpIndices);
                                        if (a && h) {
                                            this.setOriginalIndices(g.idx, a, h);
                                            var n = g.ac.x - (q.offsetX + this.marginLeft + q.left);
                                            var k = g.ac.y - (q.offsetY + this.marginTop + q.top);
                                            var m = Math.min(Math.max(n, 0), q.x) / q.x;
                                            var l = Math.ceil(a.length / 10) * 2;
                                            var d = Math.round(m * l);
                                            var p = l - d;
                                            var j = Math.min(Math.max(k, 0), q.y) / q.y;
                                            var i = Math.ceil(h.length / 10) * 2;
                                            var b = Math.round(j * i);
                                            var o = i - b;
                                            return {
                                                ac: g.ac,
                                                row: g.row,
                                                col: g.col,
                                                idx: g.idx,
                                                lcx: m,
                                                stx: d,
                                                edx: p,
                                                lcy: j,
                                                sty: b,
                                                edy: o,
                                                vin: a,
                                                sin: h
                                            }
                                        } else {
                                            var n = g.ac.x - (q.offsetX + this.marginLeft + q.left);
                                            var k = g.ac.y - (q.offsetY + this.marginTop + q.top);
                                            var m = Math.min(Math.max(n, 0), q.x) / q.x;
                                            var j = Math.min(Math.max(k, 0), q.y) / q.y;
                                            return {
                                                ac: g.ac,
                                                row: g.row,
                                                col: g.col,
                                                idx: g.idx,
                                                lcx: m,
                                                lcy: j
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.isDragNotClick = function(b, a) {
                                    return Math.abs(b.x - a.x) + Math.abs(b.y - a.y) > 2
                                };
                                this.setIndicesAfterWheelEvent = function(k, l) {
                                    var h, a, p, j, n, f, o;
                                    var c = false;
                                    var b = this.getActiveLayoutIndicesMetadata(k);
                                    if (b) {
                                        var q = this.layoutComb ? this.layoutParams[b.idx] : this;
                                        if (this.graphType == "Correlation" && !this.zoomDisable) {
                                            h = this.correlationAxis == "variables" ? true : false;
                                            a = this.correlationAxis == "samples" ? true : false;
                                            p = b.stx;
                                            j = b.edx;
                                            n = b.stx;
                                            f = b.edx;
                                            o = false
                                        } else {
                                            if (this.graphType == "Heatmap") {
                                                h = !this.zoomVariablesDisable && !this.zoomDisable ? true : false;
                                                a = !this.zoomSamplesDisable && !this.zoomDisable ? true : false;
                                                p = b.stx;
                                                j = b.edx;
                                                n = b.sty;
                                                f = b.edy;
                                                o = false
                                            } else {
                                                if (this.graphType.match(/Bar|Line|Dotplot|Boxplot|Area|Stacked/) && !this.zoomDisable) {
                                                    h = false;
                                                    a = true;
                                                    p = false;
                                                    j = false;
                                                    n = this.graphOrientation == "vertical" ? b.stx : b.sty;
                                                    f = this.graphOrientation == "vertical" ? b.edx : b.edy;
                                                    o = true
                                                }
                                            }
                                        }
                                        if (l > 0) {
                                            if (h && b.vin.length > 3) {
                                                if (q.varIndicesStart < 0) {
                                                    q.varIndicesStart++
                                                }
                                                for (var g = 0; g < p; g++) {
                                                    b.vin.shift();
                                                    q.varIndicesStart++
                                                }
                                                for (var g = 0; g < j; g++) {
                                                    b.vin.pop()
                                                }
                                                c = true
                                            }
                                            if (a && b.sin.length > 3) {
                                                if (this.isGroupedData) {
                                                    if (q.grpIndicesStart < 0) {
                                                        q.grpIndicesStart++
                                                    }
                                                    for (var g = 0; g < n; g++) {
                                                        b.sin.shift();
                                                        q.grpIndicesStart++
                                                    }
                                                } else {
                                                    if (q.smpIndicesStart < 0) {
                                                        q.smpIndicesStart++
                                                    }
                                                    for (var g = 0; g < n; g++) {
                                                        b.sin.shift();
                                                        q.smpIndicesStart++
                                                    }
                                                }
                                                for (var g = 0; g < f; g++) {
                                                    b.sin.pop()
                                                }
                                                c = true
                                            }
                                        } else {
                                            if (h) {
                                                for (var g = 0; g < p; g++) {
                                                    if (q.varIndicesStart >= 0 && q.varIndicesStart + b.vin.length < q.startingVarIndices.length) {
                                                        b.vin.push(q.startingVarIndices[q.varIndicesStart + b.vin.length]);
                                                        c = true
                                                    } else {
                                                        if (q.varIndicesStart > 0) {
                                                            q.varIndicesStart--;
                                                            b.vin.unshift(q.startingVarIndices[q.varIndicesStart]);
                                                            c = true
                                                        }
                                                    }
                                                }
                                                for (var g = 0; g < j; g++) {
                                                    if (q.varIndicesStart > 0) {
                                                        q.varIndicesStart--;
                                                        b.vin.unshift(q.startingVarIndices[q.varIndicesStart]);
                                                        c = true
                                                    } else {
                                                        if (q.varIndicesStart >= 0 && q.varIndicesStart + b.vin.length < q.startingVarIndices.length) {
                                                            b.vin.push(q.startingVarIndices[q.varIndicesStart + b.vin.length]);
                                                            c = true
                                                        }
                                                    }
                                                }
                                            }
                                            if (a) {
                                                if (this.isGroupedData) {
                                                    for (var g = 0; g < n; g++) {
                                                        if (q.grpIndicesStart >= 0 && q.grpIndicesStart + b.sin.length < q.startingGrpIndices.length) {
                                                            b.sin.push(q.startingGrpIndices[q.grpIndicesStart + b.sin.length]);
                                                            c = true
                                                        } else {
                                                            if (q.grpIndicesStart > 0) {
                                                                q.grpIndicesStart--;
                                                                b.sin.unshift(q.startingGrpIndices[q.grpIndicesStart]);
                                                                c = true
                                                            }
                                                        }
                                                    }
                                                    for (var g = 0; g < f; g++) {
                                                        if (q.grpIndicesStart > 0) {
                                                            q.grpIndicesStart--;
                                                            b.sin.unshift(q.startingGrpIndices[q.grpIndicesStart]);
                                                            c = true
                                                        } else {
                                                            if (q.grpIndicesStart >= 0 && q.grpIndicesStart + b.sin.length < q.startingGrpIndices.length) {
                                                                b.sin.push(q.startingGrpIndices[q.grpIndicesStart + b.sin.length]);
                                                                c = true
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    for (var g = 0; g < n; g++) {
                                                        if (q.smpIndicesStart >= 0 && q.smpIndicesStart + b.sin.length < q.startingSmpIndices.length) {
                                                            b.sin.push(q.startingSmpIndices[q.smpIndicesStart + b.sin.length]);
                                                            c = true
                                                        } else {
                                                            if (q.smpIndicesStart > 0) {
                                                                q.smpIndicesStart--;
                                                                b.sin.unshift(q.startingSmpIndices[q.smpIndicesStart]);
                                                                c = true
                                                            }
                                                        }
                                                    }
                                                    for (var g = 0; g < f; g++) {
                                                        if (q.smpIndicesStart > 0) {
                                                            q.smpIndicesStart--;
                                                            b.sin.unshift(q.startingSmpIndices[q.smpIndicesStart]);
                                                            c = true
                                                        } else {
                                                            if (q.smpIndicesStart >= 0 && q.smpIndicesStart + b.sin.length < q.startingSmpIndices.length) {
                                                                b.sin.push(q.startingSmpIndices[q.smpIndicesStart + b.sin.length]);
                                                                c = true
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (c) {
                                            this.drawIndicesAfterWheelEvent(k, h, b.vin, a, b.sin, o, b.idx)
                                        }
                                    }
                                };
                                this.drawIndicesAfterWheelEvent = function(i, h, f, c, g, b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = this.layoutComb ? this.layoutParams[a] : this;
                                    if (h) {
                                        d.varIndices = f
                                    }
                                    if (c) {
                                        if (b) {
                                            this.setSamplesVisible(g, true)
                                        }
                                        if (d.isGroupedData) {
                                            d.grpIndices = g
                                        } else {
                                            d.smpIndices = g
                                        }
                                    }
                                    this.draw({
                                        func: "drawIndicesAfterWheelEvent",
                                        par: [i, h, f, c, g, b, a],
                                        prop: {
                                            varIndicesStart: this.varIndicesStart,
                                            smpIndicesStart: this.smpIndicesStart,
                                            grpIndicesStart: this.grpIndicesStart
                                        }
                                    })
                                };
                                this.setRangesAfterWheelEvent = function(i, k) {
                                    var c = this.getActiveLayoutIndicesMetadata(i);
                                    if (c && !this.zoomDisable) {
                                        var p, j, n, h;
                                        var q = this.layoutComb ? this.layoutParams[c.idx] : this;
                                        var l = c.ac.x > (this.marginLeft + q.offsetX + q.left) && c.ac.x < (this.marginLeft + q.offsetX + q.left + q.x);
                                        var f = c.ac.y > (this.marginTop + q.offsetY + q.top) && c.ac.y < (this.marginTop + q.offsetY + q.top + q.y);
                                        var b = (q.xAxisMax - q.xAxisMin) * this.zoomStep * c.lcx;
                                        var a = (q.yAxisMax - q.yAxisMin) * this.zoomStep * c.lcy;
                                        var o = (q.xAxisMax - q.xAxisMin) * this.zoomStep * (1 - c.lcx);
                                        var g = (q.yAxisMax - q.yAxisMin) * this.zoomStep * (1 - c.lcy);
                                        if (k > 0) {
                                            if (l) {
                                                p = this.setMinX = q.setMinX != null ? q.setMinX + b : q.xAxisMin + b;
                                                j = this.setMaxX = q.setMaxX != null ? q.setMaxX - o : q.xAxisMax - o
                                            }
                                            if (f && this.graphType != "Genome") {
                                                n = this.setMinY = q.setMinY != null ? q.setMinY + g : q.yAxisMin + g;
                                                h = this.setMaxY = q.setMaxY != null ? q.setMaxY - a : q.yAxisMax - a
                                            }
                                        } else {
                                            if (l) {
                                                p = this.setMinX = q.setMinX != null ? q.setMinX - b : q.xAxisMin - b;
                                                j = this.setMaxX = q.setMaxX != null ? q.setMaxX + o : q.xAxisMax + o
                                            }
                                            if (f && this.graphType != "Genome") {
                                                n = this.setMinY = q.setMinY != null ? q.setMinY - g : q.yAxisMin - g;
                                                h = this.setMaxY = q.setMaxY != null ? q.setMaxY + a : q.yAxisMax + a
                                            }
                                            if (this.graphType.match(/Scatter/) && p < q.xAxisMin) {
                                                p = q.xAxisMin;
                                                j = q.xAxisMax
                                            }
                                            if (this.graphType.match(/Scatter/) && n < q.yAxisMin) {
                                                n = q.yAxisMin;
                                                h = q.yAxisMax
                                            }
                                        }
                                        if ((p <= q.xAxisAbsMin || j >= q.xAxisAbsMax || n <= q.yAxisAbsMin || h >= q.yAxisAbsMax) && k < 0 && this.graphType != "Genome") {
                                            this.setMinX = null;
                                            this.setMaxX = null;
                                            this.setMinY = null;
                                            this.setMaxY = null
                                        }
                                        if (q.setMinX == "Infinity" || q.setMaxX == "Infinity") {
                                            this.setMinX = p;
                                            this.setMaxX = j
                                        }
                                        if (q.setMinY == "Infinity" || q.setMaxY == "Infinity") {
                                            this.setMinY = n;
                                            this.setMaxY = h
                                        }
                                        this.drawRangesAfterWheelEvent(this.setMinX, this.setMaxX, this.setMinY, this.setMaxY, c.idx)
                                    }
                                };
                                this.drawRangesAfterWheelEvent = function(g, e, f, d, h) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.scatterPlotMatrix && (this.scatterPlotMatrixType.match(/correlation|all/) || this.layoutAdjust == "axis")) {
                                        var a = 0;
                                        for (var c = 0; c < this.layoutRows; c++) {
                                            for (var b = 0; b < this.layoutCols; b++) {
                                                var k = this.layoutParams[a];
                                                if (c == this.layoutValidR) {
                                                    k.setMinY = f;
                                                    k.setMaxY = d
                                                }
                                                if (b == this.layoutValidC) {
                                                    k.setMinX = g;
                                                    k.setMaxX = e
                                                }
                                                a++
                                            }
                                        }
                                    } else {
                                        var k = this.layoutComb ? this.layoutParams[h] : this;
                                        k.setMinX = g;
                                        k.setMaxX = e;
                                        k.setMinY = f;
                                        k.setMaxY = d
                                    }
                                    this.draw({
                                        func: "drawRangesAfterWheelEvent",
                                        par: [g, e, f, d, h]
                                    })
                                };
                                this.setIndicesAfterPannEvent = function(j, b) {
                                    var a, r;
                                    var h = 0;
                                    var p = this.layoutComb ? this.layoutParams[this.layoutValidN || 0] : this;
                                    var c = this.cloneObject(p.varIndices);
                                    var n = p.isGroupedData ? this.cloneObject(p.grpIndices) : this.cloneObject(p.smpIndices);
                                    var o = this.draggingOn ? Math.max(1, Math.floor(c.length / 10)) : 1;
                                    var q = this.draggingOn ? Math.max(1, Math.floor(n.length / 10)) : 1;
                                    this.setOriginalIndices(this.layoutComb ? this.layoutValidN : 0, c, n);
                                    if (this.graphType == "Correlation") {
                                        h = 1;
                                        switch (b) {
                                            case 37:
                                                r = p.varIndicesStart > 0 ? 3 : p.smpIndicesStart > 0 ? 4 : 1;
                                                break;
                                            case 39:
                                                r = p.varIndicesStart > -1 ? 5 : p.smpIndicesStart > -1 ? 6 : 1;
                                                break
                                        }
                                    } else {
                                        if (this.graphType == "Heatmap") {
                                            h = 2
                                        } else {
                                            if (this.graphType.match(/Bar|Line|Dotplot|Boxplot|Area|Stacked/)) {
                                                h = 3
                                            }
                                        }
                                    }
                                    switch (b) {
                                        case 33:
                                            a = h == 1 ? 1 : h == 2 ? 4 : h == 3 ? 4 : 1;
                                            break;
                                        case 34:
                                            a = h == 1 ? 1 : h == 2 ? 6 : h == 3 ? 6 : 1;
                                            break;
                                        case 35:
                                            a = h == 1 ? 1 : h == 2 ? 1 : h == 3 ? 1 : 1;
                                            break;
                                        case 36:
                                            a = h == 1 ? 1 : h == 2 ? 2 : h == 3 ? 1 : 1;
                                            break;
                                        case 37:
                                            a = h == 1 ? r : h == 2 ? 3 : h == 3 ? 4 : 1;
                                            break;
                                        case 38:
                                            a = h == 1 ? 1 : h == 2 ? 4 : h == 3 ? 4 : 1;
                                            break;
                                        case 39:
                                            a = h == 1 ? r : h == 2 ? 5 : h == 3 ? 6 : 1;
                                            break;
                                        case 40:
                                            a = h == 1 ? 1 : h == 2 ? 6 : h == 3 ? 6 : 1;
                                            break
                                    }
                                    var l = false;
                                    if (a == 1) {
                                        return false
                                    } else {
                                        if (a == 2) {
                                            p.varIndicesStart = -1;
                                            p.smpIndicesStart = -1;
                                            p.grpIndicesStart = -1;
                                            p.varIndices = p.startingVarIndices;
                                            if (p.isGroupedData) {
                                                p.grpIndices = p.startingGrpIndices
                                            } else {
                                                p.smpIndices = p.startingSmpIndices
                                            }
                                            l = true
                                        } else {
                                            if (a == 3) {
                                                for (var f = 0; f < o; f++) {
                                                    if (p.varIndicesStart > 0) {
                                                        c.unshift(p.startingVarIndices[p.varIndicesStart - 1]);
                                                        c.pop();
                                                        p.varIndicesStart--;
                                                        l = true
                                                    }
                                                }
                                            } else {
                                                if (a == 4) {
                                                    if (this.isGroupedData) {
                                                        for (var f = 0; f < q; f++) {
                                                            if (p.grpIndicesStart > 0) {
                                                                n.unshift(p.startingGrpIndices[p.grpIndicesStart - 1]);
                                                                n.pop();
                                                                p.grpIndicesStart--;
                                                                l = true
                                                            }
                                                        }
                                                    } else {
                                                        for (var f = 0; f < q; f++) {
                                                            if (p.smpIndicesStart > 0) {
                                                                n.unshift(p.startingSmpIndices[p.smpIndicesStart - 1]);
                                                                n.pop();
                                                                p.smpIndicesStart--;
                                                                l = true
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (a == 5) {
                                                        for (var f = 0; f < o; f++) {
                                                            if (p.varIndicesStart > -1 && p.varIndicesStart + c.length < p.startingVarIndices.length) {
                                                                c.push(p.startingVarIndices[p.varIndicesStart + c.length]);
                                                                c.shift();
                                                                p.varIndicesStart++;
                                                                l = true
                                                            }
                                                        }
                                                    } else {
                                                        if (a == 6) {
                                                            if (this.isGroupedData) {
                                                                for (var f = 0; f < q; f++) {
                                                                    if (p.grpIndicesStart > -1 && p.grpIndicesStart + n.length < p.startingGrpIndices.length) {
                                                                        n.push(p.startingGrpIndices[p.grpIndicesStart + n.length]);
                                                                        n.shift();
                                                                        p.grpIndicesStart++;
                                                                        l = true
                                                                    }
                                                                }
                                                            } else {
                                                                for (var f = 0; f < q; f++) {
                                                                    if (p.smpIndicesStart > -1 && p.smpIndicesStart + n.length < p.startingSmpIndices.length) {
                                                                        n.push(p.startingSmpIndices[p.smpIndicesStart + n.length]);
                                                                        n.shift();
                                                                        p.smpIndicesStart++;
                                                                        l = true
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (l) {
                                        this.drawIndicesAfterPannEvent(j, c, n, this.layoutValidN || 0)
                                    }
                                };
                                this.setRangesAfterPannEvent = function(g, d) {
                                    var c = this.getActiveLayoutIndicesMetadata(g);
                                    if (c) {
                                        var j, h, i, f;
                                        var n = this.layoutComb ? this.layoutParams[c.idx] : this;
                                        var b = n.xAxisRange * this.zoomStep;
                                        var a = n.yAxisRange * this.zoomStep;
                                        switch (d) {
                                            case 37:
                                                this.setMinX -= b;
                                                this.setMaxX -= b;
                                                break;
                                            case 38:
                                                this.setMinY += a;
                                                this.setMaxY += a;
                                                break;
                                            case 39:
                                                this.setMinX += b;
                                                this.setMaxX += b;
                                                break;
                                            case 40:
                                                this.setMinY -= a;
                                                this.setMaxY -= a;
                                                break
                                        }
                                        var l = this.showTransition;
                                        this.showTransition = false;
                                        this.drawRangesAfterWheelEvent(this.setMinX, this.setMaxX, this.setMinY, this.setMaxY, c.idx);
                                        this.showTransition = l
                                    }
                                };
                                this.drawIndicesAfterPannEvent = function(f, b, c, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = this.layoutComb ? this.layoutParams[a] : this;
                                    d.varIndices = b;
                                    if (d.isGroupedData) {
                                        d.grpIndices = c
                                    } else {
                                        d.smpIndices = c
                                    }
                                    this.draw({
                                        func: "drawIndicesAfterPannEvent",
                                        par: [f, b, c, a],
                                        prop: {
                                            varIndicesStart: this.varIndicesStart,
                                            smpIndicesStart: this.smpIndicesStart,
                                            grpIndicesStart: this.grpIndicesStart
                                        }
                                    })
                                };
                                this.addDragDiv = function() {
                                    if (this.$(this.target + "-cX-Drag")) {
                                        return
                                    }
                                    var a = this.$cX("div", {
                                        id: this.target + "-cX-Drag",
                                        className: "CanvasXpressDrag"
                                    }, {
                                        width: "0px",
                                        height: "0px",
                                        zIndex: 9000
                                    });
                                    this.meta.canvas.ctx.canvas.parentNode.appendChild(a)
                                };
                                this.addDragDivLayout = function() {
                                    if (this.$(this.target + "-cX-Drag-Layout")) {
                                        return
                                    }
                                    var a = this.$cX("div", {
                                        id: this.target + "-cX-Drag-Layout",
                                        className: "CanvasXpressDragLayout"
                                    }, {
                                        width: "0px",
                                        height: "0px",
                                        zIndex: 8900
                                    });
                                    this.meta.canvas.ctx.canvas.parentNode.appendChild(a)
                                };
                                this.registerDragNetwork = function(k) {
                                    var d, i, g;
                                    var j = this.isEventIndices(k);
                                    var b = this.getTargetEvent(k);
                                    var h = k.shiftKey;
                                    var m = this.adjustBackNetworkObjectX(this.xMouseDown);
                                    var l = this.adjustBackNetworkObjectY(this.yMouseDown);
                                    if (j) {
                                        var a = this.isArray(j) ? j[0].toString() : j.toString();
                                        if (a && a.match(/-lab$/)) {
                                            if (h) {
                                                i = true
                                            }
                                            d = a.split("-")[0]
                                        } else {
                                            if (a && a.match(/-dec$/)) {
                                                if (h) {
                                                    d = a.split("-")[0];
                                                    g = true
                                                } else {
                                                    this.resetDrag(k);
                                                    this.resetFlags(k)
                                                }
                                            } else {
                                                if (a && a.match(/-elbow$/)) {
                                                    j = a.replace("-elbow", "").split(",");
                                                    b.style.cursor = "move";
                                                    this.moveEdge = true;
                                                    this.moveEdgeIndex = j[0] - this.data.nodes.length;
                                                    this.moveEdgeElbow = j[1]
                                                } else {
                                                    if (a && a.match(/-resize/)) {
                                                        d = a.split("-")[0];
                                                        this.resizeNode = a.split("-resize")[1]
                                                    } else {
                                                        d = j
                                                    }
                                                }
                                            }
                                        }
                                        if (this.moveEdge) {
                                            var c = this.data.edges[this.moveEdgeIndex].elbows[this.moveEdgeElbow];
                                            this.moveEdgeX = c[0] - m;
                                            this.moveEdgeY = c[1] - l
                                        } else {
                                            if (!isNaN(d) && d < this.data.nodes.length) {
                                                b.style.cursor = "move";
                                                this.moveNode = true;
                                                this.moveNodeIndex = d;
                                                if (i) {
                                                    this.moveNodeLab = true
                                                } else {
                                                    if (g) {
                                                        this.moveNodeDec = true
                                                    }
                                                }
                                                var f = this.data.nodes[this.moveNodeIndex];
                                                this.moveNodeW = f.width ? f.width : f.size ? (this.nodeSize * f.size) : this.nodeSize;
                                                this.moveNodeH = f.height ? f.height : f.size ? (this.nodeSize * f.size) : this.nodeSize;
                                                if (this.moveNodeLab) {
                                                    this.moveNodeX = f.labelX != null ? f.labelX - m : f.labelXi - m;
                                                    this.moveNodeY = f.labelY != null ? f.labelY - l : f.labelYi - l
                                                } else {
                                                    if (this.moveNodeDec) {
                                                        this.moveNodeX = f.decorationsX != null ? f.decorationsX - m : f.decorationsXi - m;
                                                        this.moveNodeY = f.decorationsY != null ? f.decorationsY - l : f.decorationsYi - l
                                                    } else {
                                                        this.moveNodeX = f.x - m;
                                                        this.moveNodeY = f.y - l
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.registerDragGenome = function(b) {
                                    var a = this.isEventIndices(b, true);
                                    if (a && isNaN(a[0][0])) {
                                        this.moveGenome = a[0][0]
                                    } else {
                                        this.moveGenome = false
                                    }
                                };
                                this.registerDragCircular = function(b) {
                                    var a = this.isEventIndices(b, true);
                                    if (a) {
                                        this.moveCircular = {
                                            id: a,
                                            x: this.cx,
                                            y: this.cy,
                                            ac: this.adjustedCoordinates(b),
                                            ring: a[0].toString().match("Ring") ? Number(a[0].toString().split(":")[1]).toString() : null
                                        }
                                    } else {
                                        this.moveCircular = false
                                    }
                                };
                                this.registerDragScatter = function(c) {
                                    var b = this.isEventIndices(c, true);
                                    var d = this.xMouseDown;
                                    var a = this.yMouseDown;
                                    if (b && this.isArray(b)) {
                                        b = b[0].toString()
                                    }
                                    if (b && b.match(/-legend-/)) {
                                        if (b.match(/-legend-sample/)) {
                                            ml = "legendSample";
                                            mx = this["legendSampleCurX"] - d;
                                            my = this["legendSampleCurY"] - a
                                        } else {
                                            if (b.match(/-legend-variable/)) {
                                                ml = "legendVariable";
                                                mx = this["legendVariableCurX"] - d;
                                                my = this["legendVariableCurY"] - a
                                            } else {
                                                if (b.match(/-legend-indicator-color/)) {
                                                    ml = "legendColorIndicator";
                                                    if (c.shiftKey) {
                                                        this.resizeLegend = true
                                                    } else {
                                                        mx = this["legendColorIndicatorCurX"] - d;
                                                        my = this["legendColorIndicatorCurY"] - a
                                                    }
                                                } else {
                                                    if (b.match(/-legend-color/)) {
                                                        ml = "legendColor";
                                                        mx = this["legendColorCurX"] - d;
                                                        my = this["legendColorCurY"] - a
                                                    } else {
                                                        if (b.match(/-legend-size/)) {
                                                            ml = "legendSize";
                                                            mx = this["legendSizeCurX"] - d;
                                                            my = this["legendSizeCurY"] - a
                                                        } else {
                                                            if (b.match(/-legend-shape/)) {
                                                                ml = "legendShape";
                                                                mx = this["legendShapeCurX"] - d;
                                                                my = this["legendShapeCurY"] - a
                                                            } else {
                                                                if (b.match(/-legend-pattern/)) {
                                                                    ml = "legendPattern";
                                                                    mx = this["legendPatternCurX"] - d;
                                                                    my = this["legendPatternCurY"] - a
                                                                } else {
                                                                    if (b.match(/-legend-oncoprint/)) {
                                                                        ml = "legendOncoprint";
                                                                        mx = this["legendOncoprintCurX"] - d;
                                                                        my = this["legendOncoprintCurY"] - a
                                                                    } else {
                                                                        if (b.match(/-legend-decoration/)) {
                                                                            ml = "legendDecoration";
                                                                            mx = this["legendDecorationCurX"] - d;
                                                                            my = this["legendDecorationCurY"] - a
                                                                        } else {
                                                                            ml = this.moveLegend;
                                                                            mx = this.moveLegendX;
                                                                            my = this.moveLegendY
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.moveLegend = ml;
                                        this.moveLegendX = mx;
                                        this.moveLegendY = my
                                    }
                                };
                                this.isLegend = function(a) {
                                    var b = this.isEventIndices(a);
                                    if (b && !this.isArray(b) && b.match(/legend/)) {
                                        this.registerDragScatter(a)
                                    }
                                };
                                this.isMarkerDrag = function(f, b, d) {
                                    var g = this.isEventIndices(f);
                                    if (g && this.isArray(g) && g[0].toString().match(/^Marker/)) {
                                        var c = g[0].split(":");
                                        this.skipClick = false;
                                        this.draggingOn = true;
                                        this.xMouseDown = b;
                                        this.yMouseDown = d;
                                        var a = this.getMarker(c[1]);
                                        if (a) {
                                            this.moveMarker = c[1];
                                            this.moveMarkerX = a.curX - b;
                                            this.moveMarkerY = a.curY - d;
                                            this.draw({
                                                func: "isMarkerDrag",
                                                par: [f, b, d],
                                                prop: {
                                                    moveMarker: this.moveMarker
                                                }
                                            })
                                        }
                                    }
                                };
                                this.registerSankey = function(j, d, k) {
                                    var b = this.isEventIndices(j, true);
                                    if (b && b[0] && b[0].toString().match(/^Sankey/)) {
                                        var a = b[0].toString().split(":");
                                        var g = this.data.sankey.nodes[a[2]];
                                        this.skipClick = false;
                                        this.draggingOn = true;
                                        this.xMouseDown = d;
                                        this.yMouseDown = k;
                                        this.moveSankey = g;
                                        this.moveSankeyMin = g.y;
                                        this.moveSankeyX = g.x;
                                        this.moveSankeyY = k;
                                        var c = [];
                                        for (var h = 0; h < this.data.sankey.nodes.length; h++) {
                                            var f = this.data.sankey.nodes[h];
                                            if (f.breadth == this.moveSankey.breadth) {
                                                c.push({
                                                    idx: h,
                                                    id: f.id,
                                                    y: f.y,
                                                    dy: f.dy
                                                })
                                            }
                                        }
                                        this.moveSankeyOrder = c.sort(function(i, e) {
                                            return i.y - e.y
                                        })
                                    }
                                };
                                this.registerMap = function(c, a, b) {
                                    this.skipClick = false;
                                    this.draggingOn = true;
                                    this.xMouseDown = a;
                                    this.yMouseDown = b;
                                    this.moveMap = true
                                };
                                this.registerDrag = function(r) {
                                    if (this.isCanvasResize(r)) {
                                        this.resizingCanvasOn = true
                                    } else {
                                        if (this.isDOE) {
                                            var b = this.getTargetEvent(r);
                                            var h = r.shiftKey;
                                            var w = this.adjustedCoordinates(r);
                                            if (w) {
                                                this.xMouseDown = w.x;
                                                this.yMouseDown = w.y;
                                                this.skipClick = true
                                            }
                                            return false
                                        } else {
                                            if (!r) {
                                                return false
                                            }
                                            if (!this.touches) {
                                                this.touches = []
                                            }
                                            var b = this.getTargetEvent(r);
                                            var h = r.shiftKey;
                                            var w = this.adjustedCoordinates(r);
                                            if (w) {
                                                CanvasXpress.current = b.id;
                                                var k = w.x;
                                                var x = w.y;
                                                var v = 0;
                                                for (var n = 0; n < this.layoutRows; n++) {
                                                    for (var m = 0; m < this.layoutCols; m++) {
                                                        var a = this.layoutComb ? v < this.data.l.weight.length : true;
                                                        if (a) {
                                                            var p = this.layoutComb ? this.layoutParams[v].graphType : this.graphType;
                                                            var u = this.getBoundsXY(v);
                                                            this.isMarkerDrag(r, k, x);
                                                            if (this.moveMarker) {
                                                                return false
                                                            }
                                                            if (p.match(/Pie|Venn|Stacked|Area|Treemap|TagCloud|ParallelCoordinates|Tree|Gantt|Meter|Fish/)) {
                                                                if (CanvasXpress.system.isTouchScreen) {
                                                                    if (k >= u[0] && k <= u[1] && x >= u[2] && x <= u[3] || this.moveGenome) {
                                                                        this.skipClick = false;
                                                                        this.draggingOn = true;
                                                                        this.xMouseDown = k;
                                                                        this.yMouseDown = x;
                                                                        if (r.touches) {
                                                                            this.touches[0] = this.cleanTouchEvent(r.touches[0])
                                                                        }
                                                                        return false
                                                                    }
                                                                } else {
                                                                    this.isLegend(r);
                                                                    return false
                                                                }
                                                            } else {
                                                                if (p == "Genome") {
                                                                    this.registerDragGenome(r)
                                                                } else {
                                                                    if (p == "Circular") {
                                                                        this.registerDragCircular(r)
                                                                    } else {
                                                                        if (p == "Sankey") {
                                                                            this.registerSankey(r, k, x);
                                                                            return false
                                                                        } else {
                                                                            if (p == "Map") {
                                                                                this.registerMap(r, k, x);
                                                                                return false
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            if (k >= u[0] && k <= u[1] && x >= u[2] && x <= u[3] || this.moveGenome) {
                                                                this.skipClick = false;
                                                                this.draggingOn = true;
                                                                this.xMouseDown = k;
                                                                this.yMouseDown = x;
                                                                if (r.touches) {
                                                                    this.touches[0] = this.cleanTouchEvent(r.touches[0])
                                                                }
                                                                if (p == "Correlation") {
                                                                    return false
                                                                }
                                                                if (p.match(/Scatter/)) {
                                                                    if (this.lassoSelected) {
                                                                        this.lassoPoints = [
                                                                            [k],
                                                                            [x]
                                                                        ];
                                                                        return
                                                                    }
                                                                    this.registerDragScatter(r);
                                                                    if (this.moveLegend) {
                                                                        return false
                                                                    }
                                                                }
                                                                if (!p.match(/Network|Genome|Venn|Correlation|Scatter/)) {
                                                                    this.isLegend(r);
                                                                    if (this.moveLegend) {
                                                                        return false
                                                                    }
                                                                }
                                                                var s = this.$(this.target + "-cX-Drag");
                                                                if (p == "Network") {
                                                                    this.registerDragNetwork(r)
                                                                }
                                                                if ((!p.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation == "vertical" && !h) || (!p.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation != "vertical" && h)) {
                                                                    s.style.left = u[0] + "px"
                                                                } else {
                                                                    s.style.left = this.xMouseDown + "px"
                                                                }
                                                                if ((!p.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation != "vertical" && !h) || (!p.match(/Scatter|Heatmap|Network|Genome|Circular/) && this.graphOrientation == "vertical" && h) || p == "Genome") {
                                                                    s.style.top = u[2] + "px"
                                                                } else {
                                                                    s.style.top = this.yMouseDown + "px"
                                                                }
                                                                if (this.layoutValid) {
                                                                    this.layoutValidR = n;
                                                                    this.layoutValidC = m;
                                                                    this.layoutValidN = v;
                                                                    this.layoutValidBounds = u
                                                                }
                                                                return false
                                                            } else {
                                                                if (k >= u[4] && k <= u[5] && x >= u[6] && x <= u[7]) {
                                                                    var f = this.isEventIndices(r);
                                                                    if (f) {
                                                                        this.skipClick = false;
                                                                        this.draggingOn = true;
                                                                        this.xMouseDown = k;
                                                                        this.yMouseDown = x;
                                                                        if (r.touches) {
                                                                            this.touches[0] = this.cleanTouchEvent(r.touches[0])
                                                                        }
                                                                        if (p == "Correlation") {
                                                                            return false
                                                                        }
                                                                        if (p.match(/Scatter/)) {
                                                                            if (this.lassoSelected) {
                                                                                this.lassoPoints = [
                                                                                    [k],
                                                                                    [x]
                                                                                ];
                                                                                return
                                                                            }
                                                                            this.registerDragScatter(r);
                                                                            if (this.moveLegend) {
                                                                                return false
                                                                            }
                                                                        }
                                                                        if (!p.match(/Network|Genome|Venn|Correlation|Scatter/)) {
                                                                            this.isLegend(r);
                                                                            if (this.moveLegend) {
                                                                                return false
                                                                            }
                                                                        }
                                                                        var s = this.$(this.target + "-cX-Drag");
                                                                        if (f[0].toString().match(/^varDendrogram|^smpDendrogram/)) {
                                                                            this.moveDendrogram = f[0].split(":")[0];
                                                                            b.style.cursor = "move";
                                                                            if (f[0].match(/^varDendrogram/) || (f[0].match(/^smpDendrogram/) && this.graphOrientation == "vertical")) {
                                                                                s.style.left = u[4] + "px";
                                                                                s.style.width = (u[5] - u[4]) + "px";
                                                                                s.style.height = "3px"
                                                                            } else {
                                                                                s.style.width = "3px";
                                                                                s.style.top = u[6] + "px";
                                                                                s.style.height = (u[7] - u[6]) + "px"
                                                                            }
                                                                        } else {
                                                                            if (f[0].toString().match("SmpOverlay")) {
                                                                                this.moveSmpOverlay = f[0];
                                                                                b.style.cursor = "move";
                                                                                if (p.match(/Heatmap/) || this.graphOrientation == "horizontal") {
                                                                                    s.style.width = "3px";
                                                                                    s.style.top = u[6] + "px";
                                                                                    s.style.height = (u[7] - u[6]) + "px"
                                                                                } else {
                                                                                    s.style.left = u[4] + "px";
                                                                                    s.style.width = (u[5] - u[4]) + "px";
                                                                                    s.style.height = "3px"
                                                                                }
                                                                            } else {
                                                                                if (f[0].toString().match("Smp")) {
                                                                                    this.moveSmp = f[0];
                                                                                    b.style.cursor = "move";
                                                                                    if (p.match(/Heatmap/) || this.graphOrientation == "horizontal") {
                                                                                        s.style.left = u[4] + "px";
                                                                                        s.style.width = (u[5] - u[4]) + "px";
                                                                                        s.style.height = "3px"
                                                                                    } else {
                                                                                        s.style.width = "3px";
                                                                                        s.style.top = u[6] + "px";
                                                                                        s.style.height = (u[7] - u[6]) + "px"
                                                                                    }
                                                                                } else {
                                                                                    if (f[0].toString().match("VarOverlay")) {
                                                                                        this.moveVarOverlay = f[0];
                                                                                        b.style.cursor = "move";
                                                                                        s.style.left = u[4] + "px";
                                                                                        s.style.width = (u[5] - u[4]) + "px";
                                                                                        s.style.height = "3px"
                                                                                    } else {
                                                                                        if (f[0].toString().match("Var")) {
                                                                                            this.moveVar = f[0];
                                                                                            b.style.cursor = "move";
                                                                                            s.style.width = "3px";
                                                                                            s.style.top = u[6] + "px";
                                                                                            s.style.height = (u[7] - u[6]) + "px"
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                        return false
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        v++
                                                    }
                                                }
                                                return false
                                            }
                                        }
                                    }
                                };
                                this.updateDragCircular = function(q, k, A, v, x, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.moveCircular) {
                                        var v = this.moveCircular;
                                        var b = this.ringInfo;
                                        if (v.ring != null) {
                                            var j = b.length - 1;
                                            var g = b[v.ring];
                                            var s = this.euclidianDistance([v.x, v.y], [k, A]);
                                            var p;
                                            for (var m = j; m >= 0; m--) {
                                                if (b[m] > s) {
                                                    p = m;
                                                    v.last = m.toString();
                                                    break
                                                }
                                            }
                                            var u = this.$(this.target + "-cX-Drag");
                                            if (u) {
                                                u.style.width = (b[p] * 2) + "px";
                                                u.style.height = (b[p] * 2) + "px";
                                                u.style.left = (v.x - (b[p] + 3)) + "px";
                                                u.style.top = (v.y - (b[p] + 3)) + "px";
                                                u.style.borderRadius = "50%";
                                                u.style.backgroundColor = "rgba(0,0,0,0)";
                                                u.style.border = "3px solid black"
                                            }
                                        } else {
                                            var y = (Math.atan2(x - this.cx, a - this.cy) * 180 / Math.PI) + this.circularRotate;
                                            var f = (Math.atan2(k - this.cx, A - this.cy) * 180 / Math.PI);
                                            var w = y - f;
                                            this.circularRotate = w
                                        }
                                    } else {
                                        this.panningX -= this.xMouseDown - k;
                                        this.panningY -= this.yMouseDown - A
                                    }
                                    this.xMouseDown = k;
                                    this.yMouseDown = A;
                                    this.skipTransition = true;
                                    this.draw({
                                        func: "updateDragCircular",
                                        par: [q, k, A, v, x, a],
                                        prop: {
                                            circularRotate: this.circularRotate,
                                            moveCircular: this.moveCircular,
                                            panningX: this.panningX,
                                            panningY: this.panningY,
                                            xMouseDown: this.xMouseDown,
                                            yMouseDown: this.yMouseDown
                                        }
                                    });
                                    this.skipClick = true
                                };
                                this.updateDragScatter3D = function(e, n, g, j, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = j;
                                    var i = a;
                                    var b = e;
                                    var h = n;
                                    var k = this.layoutComb ? this.layoutParams[g].x : this.x;
                                    var f = this.layoutComb ? this.layoutParams[g].y : this.y;
                                    var o = ((b - d) * this.rotationSensitivity) / k;
                                    var m = ((h - i) * this.rotationSensitivity) / f;
                                    this.xRotate -= o;
                                    this.yRotate += m;
                                    this.xMouseDown = e;
                                    this.yMouseDown = n;
                                    this.skipTransition = true;
                                    this.draw({
                                        func: "updateDragScatter3D",
                                        par: [e, n, g, j, a]
                                    })
                                };
                                this.updateDragScatter = function(b, d) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.lassoSelected) {
                                        this.lassoPoints[0].push(b);
                                        this.lassoPoints[1].push(d)
                                    } else {
                                        if (this.resizeLegend) {
                                            var c = b - this.xMouseDown;
                                            var a = d - this.yMouseDown;
                                            this.heatmapIndicatorWidth += parseInt(c / 10);
                                            this.heatmapIndicatorHeight += parseInt(a / 10);
                                            this.heatmapIndicatorWidth = Math.max(10, this.heatmapIndicatorWidth);
                                            this.heatmapIndicatorHeight = Math.max(10, this.heatmapIndicatorHeight)
                                        } else {
                                            var e = this.moveLegend;
                                            var c = this[e + "CurX"] - b - this.moveLegendX;
                                            var a = this[e + "CurY"] - d - this.moveLegendY;
                                            this[e + "CurX"] -= c;
                                            this[e + "CurY"] -= a;
                                            this[e + "X"] = this[e + "CurX"];
                                            this[e + "Y"] = this[e + "CurY"]
                                        }
                                    }
                                    this.skipTransition = true;
                                    if (!this.lassoSelected) {
                                        this.draw({
                                            func: "updateDragScatter",
                                            par: [b, d],
                                            prop: {
                                                moveLegend: this.moveLegend,
                                                moveLegendX: this.moveLegendX,
                                                moveLegendY: this.moveLegendY,
                                                moveLegendCurX: this.moveLegendCurX,
                                                moveLegendCurY: this.moveLegendCurY
                                            }
                                        })
                                    }
                                    this.skipClick = true
                                };
                                this.updateDragNetwork = function(O, J, H) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var B, d, c, P, K, G, M, m, b, r, s, A, z, I, a, j, v, R, Q;
                                    var o = {};
                                    var f = this.data;
                                    var i = this.moveNodeX;
                                    var g = this.moveNodeY;
                                    var n = this.moveNodeW;
                                    var u = this.moveNodeH;
                                    var D = O.shiftKey;
                                    var L = O.ctrlKey;
                                    this.movingOn = true;
                                    var F = this.adjustBackNetworkObjectX(J);
                                    var E = this.adjustBackNetworkObjectY(H);
                                    var p = this.getTargetEvent(O);
                                    var C = this.adjustNetworkMouseDownX(J);
                                    var N = this.adjustNetworkMouseDownY(H);
                                    if (p) {
                                        p.style.cursor = D ? "se-resize" : "move"
                                    }
                                    if (this.moveNode || this.moveEdge || this.moveLegend) {
                                        if (this.moveLegend) {
                                            m = f.legend;
                                            if (this.moveLegend.match("Text")) {
                                                P = parseInt(this.moveLegend.replace("Text", ""));
                                                d = m.text[P].x - F - this.moveLegendX;
                                                c = m.text[P].y - E - this.moveLegendY;
                                                m.text[P].x -= d;
                                                m.text[P].y -= c
                                            } else {
                                                P = this.moveLegend.toLowerCase();
                                                d = m.pos[P].x - F - this.moveLegendX;
                                                c = m.pos[P].y - E - this.moveLegendY;
                                                m.pos[P].x -= d;
                                                m.pos[P].y -= c
                                            }
                                        } else {
                                            if (f.edges[this.moveEdgeIndex]) {
                                                b = f.edges[this.moveEdgeIndex].elbows[this.moveEdgeElbow];
                                                d = b[0] - F - this.moveEdgeX;
                                                c = b[1] - E - this.moveEdgeY;
                                                this.modifyXYEdgeElbow(this.moveEdgeIndex, this.moveEdgeElbow, d, c)
                                            } else {
                                                if (f.nodes[this.moveNodeIndex]) {
                                                    B = f.nodes[this.moveNodeIndex];
                                                    if (this.moveNodeLab) {
                                                        d = B.labelX != null ? B.labelX - F - i : B.labelXi - F - i;
                                                        c = B.labelY != null ? B.labelY - E - g : B.labelYi - E - g;
                                                        this.modifyXYNodeLab(B.id, d, c)
                                                    } else {
                                                        if (this.moveNodeDec) {
                                                            d = B.decorationsX != null ? B.decorationsX - F - i : B.decorationsXi - F - i;
                                                            c = B.decorationsY != null ? B.decorationsY - E - g : B.decorationsYi - E - g;
                                                            this.modifyXYNodeDec(B.id, d, c)
                                                        } else {
                                                            d = B.x - F - i;
                                                            c = B.y - E - g;
                                                            if (D && !O.ctrlKey) {
                                                                G = (n - d) + C;
                                                                M = (u - c) + N;
                                                                this.modifyNodeSize(B.id, Math.abs(G), Math.abs(M));
                                                                for (var P in CanvasXpress.selector.nodes) {
                                                                    if (P != B.id) {
                                                                        this.modifyNodeSize(P, G, M)
                                                                    }
                                                                }
                                                            } else {
                                                                if (this.resizeNode) {
                                                                    s = B.rotate != null ? B.rotate : 0;
                                                                    switch (this.resizeNode) {
                                                                        case "ROT":
                                                                            s = 180 - (Math.atan2(F - B.x, E - B.y) * 180 / Math.PI);
                                                                            G = n;
                                                                            M = u;
                                                                            d = 0;
                                                                            c = 0;
                                                                            break;
                                                                        case "TL":
                                                                            G = D ? (n - d) + C : n - C;
                                                                            M = D ? (u - c) + N : u - N;
                                                                            d += C / 2;
                                                                            c += N / 2;
                                                                            break;
                                                                        case "TR":
                                                                            G = D ? (n - d) + C : n + C;
                                                                            M = D ? (u - c) + N : u - N;
                                                                            d += C / 2;
                                                                            c += N / 2;
                                                                            break;
                                                                        case "BL":
                                                                            G = D ? (n - d) + C : n - C;
                                                                            M = D ? (u - c) + N : u + N;
                                                                            d += C / 2;
                                                                            c += N / 2;
                                                                            break;
                                                                        case "BR":
                                                                            G = D ? (n - d) + C : n + C;
                                                                            M = D ? (u - c) + N : u + N;
                                                                            d += C / 2;
                                                                            c += N / 2;
                                                                            break;
                                                                        case "TM":
                                                                            G = D ? (n - d) + C : n;
                                                                            M = D ? (u - c) + N : u - N;
                                                                            d = 0;
                                                                            c += N / 2;
                                                                            break;
                                                                        case "BM":
                                                                            G = D ? (n - d) + C : n;
                                                                            M = D ? (u - c) + N : u + N;
                                                                            d = 0;
                                                                            c += N / 2;
                                                                            break;
                                                                        case "ML":
                                                                            G = D ? (n - d) + C : n - C;
                                                                            M = D ? (u - c) + N : u;
                                                                            d += C / 2;
                                                                            c = 0;
                                                                            break;
                                                                        case "MR":
                                                                            G = D ? (n - d) + C : n + C;
                                                                            M = D ? (u - c) + N : u;
                                                                            d += C / 2;
                                                                            c = 0;
                                                                            break
                                                                    }
                                                                    I = this.getNodeWidth(B);
                                                                    a = this.getNodeHeight(B);
                                                                    j = Math.abs(G) / I;
                                                                    v = Math.abs(M) / a;
                                                                    R = (Math.abs(G) - I) / 2;
                                                                    Q = (Math.abs(M) - a) / 2
                                                                }
                                                                r = this.findParentNodes(B.id);
                                                                if (this.networkLayoutType != "radial" && ((this.moveParentsWithChildren && !D && !L) || (!this.moveParentsWithChildren && D && L)) && r) {
                                                                    B = f.nodes[f.nodeIndices[r[0]]]
                                                                }
                                                                this.modifyXYNode(B.id, d, c);
                                                                if (B.community != null && this.networkConvexHulls[B.community]["nodes"] && L) {
                                                                    for (var K = 0; K < this.networkConvexHulls[B.community]["nodes"].length; K++) {
                                                                        if (this.networkConvexHulls[B.community]["nodes"][K] != this.moveNodeIndex) {
                                                                            var q = f.nodes[this.networkConvexHulls[B.community]["nodes"][K]];
                                                                            this.modifyXYNode(q.id, d, c)
                                                                        }
                                                                    }
                                                                }
                                                                if (s != null) {
                                                                    B.rotate = s
                                                                }
                                                                if (CanvasXpress.selector.nodes.hasOwnProperty(B.id) || L) {
                                                                    if (L && !CanvasXpress.selector.nodes.hasOwnProperty(B.id)) {
                                                                        this.addRemoveToSelected({
                                                                            nodes: [B]
                                                                        }, false, O)
                                                                    }
                                                                    o[B.id] = true;
                                                                    r = this.findChildrenNodeIndices(B.id);
                                                                    if (r) {
                                                                        for (var K = 0; K < r.length; K++) {
                                                                            o[f.nodes[r[K]].id] = true
                                                                        }
                                                                    }
                                                                    for (var P in CanvasXpress.selector.nodes) {
                                                                        if (!o.hasOwnProperty(P)) {
                                                                            var q = f.nodes[f.nodeIndices[P]];
                                                                            r = this.findParentNodes(q.id);
                                                                            if (this.networkLayoutType != "radial" && ((this.moveParentsWithChildren && !D && !L) || (!this.moveParentsWithChildren && D && L)) && r) {
                                                                                q = f.nodes[f.nodeIndices[r[0]]]
                                                                            }
                                                                            if (this.resizeNode) {
                                                                                I = this.getNodeWidth(q);
                                                                                a = this.getNodeHeight(q);
                                                                                switch (this.resizeNode) {
                                                                                    case "ROT":
                                                                                        R = 0;
                                                                                        Q = 0;
                                                                                        break;
                                                                                    case "TL":
                                                                                        break;
                                                                                    case "TR":
                                                                                        break;
                                                                                    case "BL":
                                                                                        break;
                                                                                    case "BR":
                                                                                        break;
                                                                                    case "TM":
                                                                                        break;
                                                                                    case "BM":
                                                                                        break;
                                                                                    case "ML":
                                                                                        break;
                                                                                    case "MR":
                                                                                        break
                                                                                }
                                                                                this.modifyXYNode(q.id, -R, -Q)
                                                                            } else {
                                                                                this.modifyXYNode(q.id, d, c)
                                                                            }
                                                                            o[q.id] = true;
                                                                            r = this.findChildrenNodeIndices(q.id);
                                                                            if (s != null) {
                                                                                q.rotate = s
                                                                            }
                                                                            if (r) {
                                                                                for (var K = 0; K < r.length; K++) {
                                                                                    o[f.nodes[r[K]].id] = true
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                } else {
                                                                    this.resetSelected(O)
                                                                }
                                                                if (this.resizeNode) {
                                                                    this.modifyNodeSize(B.id, Math.abs(G), Math.abs(M));
                                                                    for (var P in CanvasXpress.selector.nodes) {
                                                                        if (P != B.id) {
                                                                            var q = f.nodes[f.nodeIndices[P]];
                                                                            this.modifyNodeSize(P, this.getNodeWidth(q) * j, this.getNodeHeight(q) * v)
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        this.panningX = C;
                                        this.panningY = N
                                    }
                                    this.skipClick = d != null || c != null ? true : false;
                                    this.skipTransition = true;
                                    this.draw({
                                        network: true,
                                        func: "updateDragNetwork",
                                        par: [O, J, H],
                                        prop: {
                                            moveLegend: this.moveLegend,
                                            moveLegendX: this.moveLegendX,
                                            moveLegendY: this.moveLegendY,
                                            moveEdge: this.moveEdge,
                                            moveEdgeIndex: this.moveEdgeIndex,
                                            moveEdgeElbow: this.moveEdgeElbow,
                                            moveNode: this.moveNode,
                                            moveNodeIndex: this.moveNodeIndex,
                                            moveNodeLab: this.moveNodeLab,
                                            moveNodeDec: this.moveNodeDec,
                                            moveNodeW: this.moveNodeW,
                                            moveNodeH: this.moveNodeH,
                                            moveNodeX: this.moveNodeX,
                                            moveNodeY: this.moveNodeY,
                                            xMouseDown: this.xMouseDown,
                                            yMouseDown: this.yMouseDown
                                        }
                                    });
                                    if (this.is3DNetwork && B) {
                                        this.moveNodeIndex = f.nodeIndices[B.id]
                                    }
                                };
                                this.updateDragGenome = function(a, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.moveGenome) {
                                        this.movingOn = true;
                                        var c = this.$(this.target + "-cX-Drag");
                                        c.style.left = "0px";
                                        c.style.width = this.width + "px";
                                        c.style.top = b + "px";
                                        c.style.height = "3px"
                                    } else {
                                        var c = (a - this.xMouseDown) / this.xAxisUnit;
                                        if (this.setMinX == null) {
                                            this.setMinX = this.xAxisMin
                                        }
                                        if (this.setMaxX == null) {
                                            this.setMaxX = this.xAxisMax
                                        }
                                        this.setMinX -= c;
                                        this.setMaxX -= c;
                                        this.skipTransition = true;
                                        this.draw({
                                            func: "updateDragGenome",
                                            par: [a, b],
                                            prop: {
                                                moveGenome: this.moveGenome,
                                                setMinX: this.setMinX,
                                                setMaxX: this.setMaxX,
                                                xMouseDown: this.xMouseDown
                                            }
                                        });
                                        this.xMouseDown = a
                                    }
                                };
                                this.updateDragMap = function(a, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.moveMap) {
                                        this.panningX -= this.xMouseDown - a;
                                        this.panningY -= this.yMouseDown - b;
                                        this.xMouseDown = a;
                                        this.yMouseDown = b;
                                        this.skipTransition = true;
                                        this.draw({
                                            func: "updateDragMap",
                                            par: [a, b],
                                            prop: {
                                                moveMap: this.moveMap,
                                                panningX: this.panningX,
                                                panningY: this.panningY,
                                                xMouseDown: this.xMouseDown,
                                                yMouseDown: this.yMouseDown
                                            }
                                        });
                                        this.skipClick = true
                                    }
                                };
                                this.updateDragMarker = function(c, e) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = this.getMarker(this.moveMarker);
                                    var d = a.curX - c;
                                    var b = a.curY - e;
                                    a.curX -= d;
                                    a.curY -= b;
                                    this.moveMarkerX = a.curX;
                                    this.moveMarkerY = a.curY;
                                    a.x = Math.max(0.01, Math.min(a.curX * a.x / (a.b[0] + (a.x * a.b[2])), 1));
                                    a.y = Math.max(0.01, Math.min(a.curY * a.y / (a.b[1] + (a.y * a.b[3])), 1));
                                    this.skipTransition = true;
                                    this.drawMarkers(true);
                                    this.skipClick = true
                                };
                                this.updateDragSankey = function(b, c) {
                                    var a = Math.max(-this.moveSankey.y, Math.min(this.y - (this.moveSankey.y + this.moveSankey.dy), c - this.moveSankeyY));
                                    this.moveSankey.y += a;
                                    this.moveSankeyY = c;
                                    this.resortSankey()
                                };
                                this.resortSankey = function(e) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = [];
                                    var c = this.moveSankeyMin;
                                    var b = 0;
                                    for (var a = 0; a < this.data.sankey.nodes.length; a++) {
                                        var f = this.data.sankey.nodes[a];
                                        if (f.breadth == this.moveSankey.breadth) {
                                            d.push({
                                                idx: a,
                                                id: f.id,
                                                y: f.y,
                                                dy: f.dy
                                            });
                                            c = Math.min(c, f.y);
                                            b += f.dy + this.margin
                                        }
                                    }
                                    if (c + b - this.margin > this.y) {
                                        c = this.y - (b - this.margin)
                                    }
                                    d.sort(function(h, g) {
                                        return h.y - g.y
                                    });
                                    if (!this.isSameObject(d, this.moveSankeyOrder) || e) {
                                        for (var a = 0; a < d.length; a++) {
                                            var f = this.data.sankey.nodes[d[a].idx];
                                            if (f.id != this.moveSankey.id || e) {
                                                f.y = c
                                            }
                                            c += f.dy + this.margin
                                        }
                                    }
                                    this.data.sankey.object.relayout();
                                    this.draw({
                                        func: "resortSankey",
                                        par: [e],
                                        prop: {
                                            moveSankey: this.moveSankey,
                                            moveSankeyY: this.moveSankeyY,
                                            moveSankeyMin: this.moveSankeyMin,
                                            moveSankeyOrder: this.moveSankeyOrder
                                        }
                                    })
                                };
                                this.updateDrag = function(A) {
                                    if (this.draggingOn) {
                                        var h = this;
                                        var u = function(e) {
                                            var d = e.meta.config.user;
                                            var i = e.setMinX != null && e.setMinY != null && e.setMaxX != null && e.setMaxY != null;
                                            var j = d.setMinX != null && d.setMinY != null && d.setMaxX != null && d.setMaxY != null;
                                            var g = e.graphType.match(/Scatter/) && e.scatterType == "visium" && !e.visiumPanning;
                                            return g ? false : j ? false : i ? true : false
                                        };
                                        if (this.resetOn) {
                                            this.resetOn = false;
                                            this.stopEvent(A);
                                            return
                                        }
                                        var x = A.shiftKey;
                                        var f = A.ctrlKey;
                                        var r = A.altKey;
                                        var D = this.adjustedCoordinates(A);
                                        if (D) {
                                            this.touchEvent = "drag";
                                            var v = D.x;
                                            var n = D.y;
                                            var y = this.layoutValidR;
                                            var w = this.layoutValidC;
                                            var C = this.layoutValidN || 0;
                                            var p = this.layoutValidBounds;
                                            var h = this.layoutComb ? this.layoutParams[C] : this;
                                            var z = h.graphType;
                                            if (z != "Scatter3D" && !this.lassoSelected && this.showMousePositionOnDrag) {
                                                this.showMousePosition(A)
                                            }
                                            if (CanvasXpress.system.isTouchScreen) {
                                                if (n < this.yMouseDown || v > this.xMouseDown) {
                                                    this.handleWheelEvent(A, 1, D)
                                                } else {
                                                    this.handleWheelEvent(A, -1, D)
                                                }
                                                return false
                                            } else {
                                                if (this.moveMarker) {
                                                    this.updateDragMarker(v, n);
                                                    return false
                                                } else {
                                                    if (z.match(/Pie|Venn|Stacked|Area|Treemap|TagCloud|ParallelCoordinates|Tree|Gantt|Meter|Fish/)) {
                                                        if (CanvasXpress.system.isTouchScreen) {
                                                            this.movingOn = true;
                                                            this.resetOn = false
                                                        }
                                                        if (!z.match(/Network|Genome|Venn|Correlation|Gantt|Scatter/) && this.moveLegend) {
                                                            this.updateDragScatter(v, n);
                                                            this.movingOn = true;
                                                            this.resetOn = false
                                                        } else {
                                                            return false
                                                        }
                                                    }
                                                }
                                            }
                                            if (z == "Sankey") {
                                                this.updateDragSankey(v, n)
                                            } else {
                                                if (z.match(/Scatter/) && (this.moveLegend || this.lassoSelected)) {
                                                    this.updateDragScatter(v, n)
                                                } else {
                                                    if (!z.match(/Network|Genome|Venn|Correlation|Scatter/) && this.moveLegend) {
                                                        this.updateDragScatter(v, n)
                                                    } else {
                                                        if ((z == "Scatter3D" && !x) || this.is3DPlot) {
                                                            this.updateDragScatter3D(v, n, C, this.xMouseDown, this.yMouseDown)
                                                        } else {
                                                            if (z == "Circular") {
                                                                if (this.moveLegend) {
                                                                    this.updateDragScatter(v, n);
                                                                    this.movingOn = true;
                                                                    this.resetOn = false
                                                                } else {
                                                                    this.updateDragCircular(A, v, n, C, this.xMouseDown, this.yMouseDown)
                                                                }
                                                            } else {
                                                                if (z == "Network" && ((this.moveNode || this.moveLegend) || (!f && !x && !r))) {
                                                                    this.updateDragNetwork(A, v, n)
                                                                } else {
                                                                    if (z == "Genome" && (this.moveGenome || (!x))) {
                                                                        this.updateDragGenome(v, n)
                                                                    } else {
                                                                        if (z == "Map") {
                                                                            this.updateDragMap(v, n)
                                                                        } else {
                                                                            if (this.moveDendrogram) {
                                                                                var o = this.getBoundsXY(C);
                                                                                var B = this.$(this.target + "-cX-Drag");
                                                                                this.skipClick = true;
                                                                                if (v >= o[4] && v <= o[5] && n >= o[6] && n <= o[7]) {
                                                                                    if (this.moveDendrogram == "varDendrogram" || (this.moveDendrogram == "smpDendrogram" && this.graphOrientation == "vertical")) {
                                                                                        B.style.top = n + "px"
                                                                                    } else {
                                                                                        B.style.left = v + "px"
                                                                                    }
                                                                                }
                                                                            } else {
                                                                                if (this.moveVarOverlay || this.moveSmpOverlay) {
                                                                                    var o = this.getBoundsXY(C);
                                                                                    var B = this.$(this.target + "-cX-Drag");
                                                                                    this.skipClick = true;
                                                                                    if (v >= o[4] && v <= o[5] && n >= o[6] && n <= o[7]) {
                                                                                        if (this.moveSmpOverlay) {
                                                                                            if (z.match(/Heatmap/) || this.graphOrientation == "horizontal") {
                                                                                                B.style.left = v + "px"
                                                                                            } else {
                                                                                                B.style.top = n + "px"
                                                                                            }
                                                                                        } else {
                                                                                            B.style.top = n + "px"
                                                                                        }
                                                                                    }
                                                                                } else {
                                                                                    if (this.moveVar || this.moveSmp) {
                                                                                        var o = this.getBoundsXY(C);
                                                                                        var B = this.$(this.target + "-cX-Drag");
                                                                                        this.skipClick = true;
                                                                                        if (v >= o[4] && v <= o[5] && n >= o[6] && n <= o[7]) {
                                                                                            if (this.moveSmp) {
                                                                                                if (z.match(/Heatmap/) || this.graphOrientation == "horizontal") {
                                                                                                    B.style.top = n + "px"
                                                                                                } else {
                                                                                                    B.style.left = v + "px"
                                                                                                }
                                                                                            } else {
                                                                                                B.style.left = v + "px"
                                                                                            }
                                                                                        }
                                                                                    } else {
                                                                                        var s;
                                                                                        if (h.varIndicesStart > 0 || h.smpIndicesStart > 0 || h.grpIndicesStart > 0) {
                                                                                            s = true
                                                                                        } else {
                                                                                            if (h.varIndicesStart == 0 && h.startingVarIndices && h.startingVarIndices) {
                                                                                                if (h.varIndicesStart + h.varIndices.length < h.startingVarIndices.length) {
                                                                                                    s = true
                                                                                                } else {
                                                                                                    s = false
                                                                                                }
                                                                                            } else {
                                                                                                if (this.isGroupedData && h.grpIndicesStart == 0 && h.startingGrpIndices && h.startingGrpIndices) {
                                                                                                    if (h.grpIndicesStart + h.grpIndices.length < h.startingGrpIndices.length) {
                                                                                                        s = true
                                                                                                    } else {
                                                                                                        s = false
                                                                                                    }
                                                                                                } else {
                                                                                                    if (h.smpIndicesStart == 0 && h.startingSmpIndices && h.startingSmpIndices) {
                                                                                                        if (h.smpIndicesStart + h.smpIndices.length < h.startingSmpIndices.length) {
                                                                                                            s = true
                                                                                                        } else {
                                                                                                            s = false
                                                                                                        }
                                                                                                    } else {
                                                                                                        if (u(this)) {
                                                                                                            s = true
                                                                                                        } else {
                                                                                                            s = false
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                        if (z.match(/Heatmap|Bar|Line|Dotplot|Boxplot|Correlation|Scatter/) && s) {
                                                                                            this.panningOn = true;
                                                                                            var m = Math.abs(this.xMouseDown - v);
                                                                                            var k = Math.abs(this.yMouseDown - n);
                                                                                            var B = false;
                                                                                            if (m > k) {
                                                                                                if (m > this.x / 20) {
                                                                                                    B = this.xMouseDown > v ? 39 : 37;
                                                                                                    this.xMouseDown = v;
                                                                                                    this.yMouseDown = n
                                                                                                }
                                                                                            } else {
                                                                                                if (k > this.y / 20) {
                                                                                                    B = this.yMouseDown > n ? 40 : 38;
                                                                                                    this.xMouseDown = v;
                                                                                                    this.yMouseDown = n
                                                                                                }
                                                                                            }
                                                                                            if (B) {
                                                                                                this.handlePanning(A, B)
                                                                                            }
                                                                                            this.movingOn = true;
                                                                                            this.resetOn = false;
                                                                                            return false
                                                                                        }
                                                                                        if (z.match(/Correlation/)) {
                                                                                            return false
                                                                                        }
                                                                                        var o = this.getBoundsXY(C);
                                                                                        var a = z.match(/Scatter|Heatmap|Network|Genome|Circular/);
                                                                                        var b = this.graphOrientation == "vertical";
                                                                                        var B = this.$(this.target + "-cX-Drag");
                                                                                        this.skipClick = true;
                                                                                        if ((!a && b && !x) || (!a && !b && x)) {
                                                                                            B.style.width = (o[1] - o[0]) + "px"
                                                                                        } else {
                                                                                            if (v > this.xMouseDown) {
                                                                                                if (v > o[1]) {
                                                                                                    B.style.width = (o[1] - this.xMouseDown) + "px"
                                                                                                } else {
                                                                                                    B.style.width = (v - this.xMouseDown) + "px"
                                                                                                }
                                                                                            } else {
                                                                                                if (v < o[0]) {
                                                                                                    B.style.left = o[0] + "px";
                                                                                                    B.style.width = (this.xMouseDown - o[0]) + "px"
                                                                                                } else {
                                                                                                    B.style.left = v + "px";
                                                                                                    B.style.width = (this.xMouseDown - v) + "px"
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                        if ((!a && !b && !x) || (!a && b && x) || z == "Genome") {
                                                                                            B.style.height = (o[3] - o[2]) + "px"
                                                                                        } else {
                                                                                            if (n > this.yMouseDown) {
                                                                                                if (n > o[3]) {
                                                                                                    B.style.height = (o[3] - this.yMouseDown) + "px"
                                                                                                } else {
                                                                                                    B.style.height = (n - this.yMouseDown) + "px"
                                                                                                }
                                                                                            } else {
                                                                                                if (n < o[2]) {
                                                                                                    B.style.top = o[2] + "px";
                                                                                                    B.style.height = (this.yMouseDown - o[2]) + "px"
                                                                                                } else {
                                                                                                    B.style.top = n + "px";
                                                                                                    B.style.height = (this.yMouseDown - n) + "px"
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.movingOn = true;
                                        this.resetOn = false
                                    }
                                };
                                this.endDrag = function(w) {
                                    if (this.draggingOn) {
                                        if (this.isTransition()) {
                                            return
                                        }
                                        var b = this.layoutComb ? this.layoutParams[this.layoutValidN || 0].graphType : this.graphType;
                                        if (b.match(/Venn|Stacked|Area|Treemap|TagCloud|ParallelCoordinates|Tree|Gantt|Meter|Fish/) && !this.userEvents.drag) {
                                            return false
                                        }
                                        var j = this.$(this.target);
                                        if (j) {
                                            j.style.cursor = "default";
                                            var r = this.getTargetEvent(w);
                                            if (r && r.style) {
                                                r.style.cursor = "default"
                                            }
                                        }
                                        this.panningGlobalX += this.panningX;
                                        this.panningGlobalY += this.panningY;
                                        this.resetMousePosition();
                                        if (b != "Circular" && b != "Map") {
                                            this.panningX = 0;
                                            this.panningY = 0
                                        }
                                        if (this.moveMarker) {
                                            this.resetDrag();
                                            this.moveMarker = false;
                                            this.draw({
                                                func: "endDrag",
                                                par: [w]
                                            })
                                        } else {
                                            if (this.moveSankey) {
                                                this.resortSankey(true);
                                                this.resetDrag()
                                            } else {
                                                if ((b == "Scatter3D" && !w.shiftKey) || this.is3DPlot) {
                                                    this.resetDrag(w)
                                                } else {
                                                    if (b == "Network" && (this.moveNode || this.moveEdge || this.moveLegend)) {
                                                        if (j) {
                                                            this.endDragNetwork(w)
                                                        }
                                                    } else {
                                                        if (b == "Genome" && (this.moveGenome || !w.shiftKey)) {
                                                            if (this.movingOn && this.moveGenome) {
                                                                var y = this.adjustedCoordinates(w);
                                                                var z = this.subtracksInfo;
                                                                if (y) {
                                                                    var k = y.y;
                                                                    if (k != this.yMouseDown) {
                                                                        var x = this.moveGenome.replace("track-", "").split(":");
                                                                        var a = parseInt(x[0]);
                                                                        var p = x.length > 1 ? parseInt(x[1]) : null;
                                                                        for (var q = 0; q < z.length; q++) {
                                                                            if (z[q]) {
                                                                                var n = z[q].start;
                                                                                var h = z[q].track;
                                                                                var g = z[q].index;
                                                                                if (n > k) {
                                                                                    if (a != h && a != h - 1) {
                                                                                        if (h > a) {
                                                                                            h--
                                                                                        }
                                                                                        var m = this.data.tracks.splice(a, 1)[0];
                                                                                        this.data.tracks.splice(h, 0, m);
                                                                                        this.draw({
                                                                                            func: "endDrag",
                                                                                            par: [w]
                                                                                        })
                                                                                    } else {
                                                                                        if (p != null) {
                                                                                            if (a == h - 1) {
                                                                                                g = z[q - 1].index;
                                                                                                g++
                                                                                            }
                                                                                            p = z[p].index;
                                                                                            if (p != g) {
                                                                                                if (g > p) {
                                                                                                    g--
                                                                                                }
                                                                                                var m = this.data.tracks[a].data.splice(p, 1)[0];
                                                                                                this.data.tracks[a].data.splice(g, 0, m);
                                                                                                this.draw({
                                                                                                    func: "endDrag",
                                                                                                    par: [w]
                                                                                                })
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                    break
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            this.resetDrag(w)
                                                        } else {
                                                            if (b.match(/Scatter/) && this.moveLegend) {
                                                                this.resetDrag(w)
                                                            } else {
                                                                if (b == "Circular") {
                                                                    this.handleDragEvent(w);
                                                                    this.resetDrag(w)
                                                                } else {
                                                                    if (b == "Map") {
                                                                        this.skipTransition = false;
                                                                        this.skipClick = false
                                                                    } else {
                                                                        if (this.moveLegend) {
                                                                            this.resetDrag(w)
                                                                        } else {
                                                                            if (this.movingOn && !this.panningOn) {
                                                                                var y = this.adjustedCoordinates(w);
                                                                                if (y) {
                                                                                    var o = y.x;
                                                                                    var k = y.y;
                                                                                    if (o != this.xMouseDown || k != this.yMouseDown) {
                                                                                        var x = this.$(this.target + "-cX-Drag");
                                                                                        var o = this.lassoSelected || this.graphType == "Scatter3D";
                                                                                        var v = parseFloat(x.style.left);
                                                                                        var f = parseFloat(x.style.top);
                                                                                        var u = v + parseInt(x.style.width);
                                                                                        var c = f + parseInt(x.style.height);
                                                                                        this.handleDragEvent(w, v, f, u, c);
                                                                                        this.resetDrag(w, o)
                                                                                    }
                                                                                }
                                                                            } else {
                                                                                this.resetDrag(w)
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        this.resetDrag(w)
                                    }
                                    if (this.userEvents.drag) {
                                        this.userEvents.drag.call(this, w, this)
                                    }
                                };
                                this.endDragNetwork = function(d) {
                                    if (CanvasXpress.selector.selections && this.movingOn) {
                                        this.resetSelected(d);
                                        this.draw({
                                            func: "endDragNetwork",
                                            par: [d]
                                        })
                                    }
                                    if (this.userEvents.enddragnode && this.movingOn) {
                                        var c;
                                        if (this.moveLegend) {
                                            c = {
                                                legend: this.moveLegend
                                            }
                                        } else {
                                            var a = this.moveNodeIndex;
                                            var b = this.findChildrenNodeIndices(this.data.nodes[a].id);
                                            if (b) {
                                                b.push(a)
                                            } else {
                                                b = [a]
                                            }
                                            c = this.extractDataObject(b)
                                        }
                                        this.resetDrag(d);
                                        this.userEvents.enddragnode.call(this, c, this)
                                    } else {
                                        this.resetDrag(d)
                                    }
                                };
                                this.validateMinMax = function(c, a, d, b) {
                                    if (!isNaN(c) && !isNaN(a)) {
                                        if (c > a || d > c || b < a) {
                                            return false
                                        }
                                        return true
                                    } else {
                                        return false
                                    }
                                };
                                this.handleDragEventCircular = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.moveCircular) {
                                        if (this.isDragNotClick(this.adjustedCoordinates(b), this.moveCircular.ac)) {
                                            var c = this.ringsOrder;
                                            var a = c.splice(this.moveCircular.ring, 1);
                                            c.splice(this.moveCircular.last, 0, a[0]);
                                            this.draw({
                                                func: "handleDragEventCircular",
                                                par: [b]
                                            });
                                            this.skipClick = false
                                        }
                                    }
                                };
                                this.handleDragEventNetwork = function(m, c, u, a, q) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var f = {};
                                    var k = [];
                                    var x = [];
                                    var v = [];
                                    var p = [];
                                    var r = {};
                                    var l = [];
                                    for (var j = 0; j < this.meta.render.objects.length; j++) {
                                        var b = this.meta.render.objects[j];
                                        if (b.idx != null && this.isObjectInsideArea(b.area, c, u, a, q)) {
                                            if (b.idx[0] < this.data.nodes.length) {
                                                f[b.idx[0]] = 1
                                            }
                                        }
                                    }
                                    for (var j = 0; j < this.data.nodes.length; j++) {
                                        if (!f[j]) {
                                            k.push(this.data.nodes[j].id)
                                        } else {
                                            x.push(this.data.nodes[j].id);
                                            l.push(this.data.nodes[j]);
                                            v.push(j)
                                        }
                                    }
                                    if (k.length < this.data.nodes.length) {
                                        if (m.shiftKey) {
                                            if (!m.ctrlKey) {
                                                this.resetSelected(m, true)
                                            }
                                            this.addRemoveToSelected(false, {
                                                nodes: l
                                            }, m);
                                            this.broadcastDraw({
                                                func: "handleDragEventNetwork",
                                                par: [m, c, u, a, q]
                                            });
                                            this.draggingOn = false;
                                            this.showInfoSpan(m, "While mouse-over nodes:<br>1. Press Shift and drag mouse to resize nodes<br>2. Drag mouse to move nodes")
                                        } else {
                                            this.resetZoomPan();
                                            this.hideUnhideNodes(k, true);
                                            this.translateCanvas(-this.offsetX, -this.offsetY);
                                            this.scaleCanvas(1 / this.scaleFactorX, 1 / this.scaleFactorY);
                                            this.draw({
                                                network: true,
                                                func: "handleDragEventNetwork",
                                                par: [m, c, u, a, q]
                                            })
                                        }
                                        if (this.showDataTableOnSelect) {
                                            if (this.networkShowDataTable == "edges") {
                                                for (var j = 0; j < x.length; j++) {
                                                    r[x[j]] = 1
                                                }
                                                for (var j = 0; j < this.data.edges.length; j++) {
                                                    if (r[this.data.edges[j].id1] || r[this.data.edges[j].id2]) {
                                                        p.push(this.data.nodes.length + j)
                                                    }
                                                }
                                                this.updateDataTable(this.extractDataObject(p))
                                            } else {
                                                this.updateDataTable(this.extractDataObject(v))
                                            }
                                        }
                                    }
                                };
                                this.handleDragEventHeatmap = function(k, m, f, p, b, n) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var q = [];
                                    var u = [];
                                    var r = this.layoutComb ? this.layoutParams[m] : this;
                                    var h = this.cloneObject(r.varIndices);
                                    var l = this.isGroupedData ? this.cloneObject(r.grpIndices) : this.cloneObject(r.smpIndices);
                                    this.setOriginalIndices(m, h, l);
                                    r.varIndicesStart = r.varIndicesStart < 0 ? 0 : r.varIndicesStart;
                                    r.smpIndicesStart = r.smpIndicesStart < 0 ? 0 : r.smpIndicesStart;
                                    r.grpIndicesStart = r.grpIndicesStart < 0 ? 0 : r.grpIndicesStart;
                                    r.varIndices = [];
                                    r.grpIndices = [];
                                    r.smpIndices = [];
                                    for (var j = 0; j < this.meta.render.objects.length; j++) {
                                        var a = this.meta.render.objects[j];
                                        var g = a.area;
                                        if (a.idx && ((f < g[1] || f < g[3]) && b > g[1] && (p < g[2] || p < g[4]) && n > g[2])) {
                                            if (!q[a.idx[0]]) {
                                                r.varIndices.push(a.idx[0]);
                                                q[a.idx[0]] = 1
                                            }
                                            if (!u[a.idx[1]]) {
                                                if (r.isGroupedData) {
                                                    r.grpIndices.push(a.idx[1])
                                                } else {
                                                    r.smpIndices.push(a.idx[1])
                                                }
                                                u[a.idx[1]] = 1
                                            }
                                        }
                                    }
                                    if (r.varIndices.length > 0 && r.smpIndices.length > 0) {
                                        for (var j = 0; j < h.length; j++) {
                                            if (h[j] == r.varIndices[0]) {
                                                r.varIndicesStart += j
                                            }
                                        }
                                        for (var j = 0; j < l.length; j++) {
                                            if (r.isGroupedData) {
                                                if (l[j] == r.grpIndices[0]) {
                                                    r.grpIndicesStart += j
                                                }
                                            } else {
                                                if (l[j] == r.smpIndices[0]) {
                                                    r.smpIndicesStart += j
                                                }
                                            }
                                        }
                                        var d = this.extractDataObject(this.smpIndices, this.varIndices);
                                        this.draw({
                                            func: "handleDragEventHeatmap",
                                            par: [k, m, f, p, b, n]
                                        });
                                        if (this.showDataTableOnSelect) {
                                            this.updateDataTable(d)
                                        }
                                        this.skipClick = false
                                    } else {
                                        r.varIndices = h;
                                        if (r.isGroupedData) {
                                            r.grpIndices = l
                                        } else {
                                            r.smpIndices = l
                                        }
                                    }
                                };
                                this.handleDragEventCorrelation = function(f, b, d, a, c) {
                                    return this.handleDragEventHeatmap(f, 0, b, d, a, c)
                                };
                                this.isTransformedAxis = function(c, b, a) {
                                    if (this[c + "Transform"]) {
                                        if ((this[c + "Transform"] == "log2" && !a) || (this[c + "Transform"] == "exp2" && a)) {
                                            this["setMin" + b] = Math.pow(2, this["setMin" + b]);
                                            this["setMax" + b] = Math.pow(2, this["setMax" + b])
                                        } else {
                                            if ((this[c + "Transform"] == "log10" && !a) || (this[c + "Transform"] == "exp10" && a)) {
                                                this["setMin" + b] = Math.pow(10, this["setMin" + b]);
                                                this["setMax" + b] = Math.pow(10, this["setMax" + b])
                                            } else {
                                                if ((this[c + "Transform"] == "exp2" && !a) || (this[c + "Transform"] == "log2" && a)) {
                                                    this["setMin" + b] = Math.log(this["setMin" + b]) / Math.LN2;
                                                    this["setMax" + b] = Math.log(this["setMax" + b]) / Math.LN2
                                                } else {
                                                    if ((this[c + "Transform"] == "exp10" && !a) || (this[c + "Transform"] == "log10" && a)) {
                                                        this["setMin" + b] = Math.log(this["setMin" + b]) / Math.LN10;
                                                        this["setMax" + b] = Math.log(this["setMax" + b]) / Math.LN10
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.isTransformedRange = function(b, a) {
                                    if (this[b + "Transform"]) {
                                        if (this[b + "Transform"] == "log2") {} else {
                                            if (this[b + "Transform"] == "log10") {
                                                return Math.log(a) / Math.LN10
                                            } else {
                                                if (this[b + "Transform"] == "exp2") {} else {
                                                    if (this[b + "Transform"] == "exp10") {}
                                                }
                                            }
                                        }
                                    } else {
                                        return a
                                    }
                                };
                                this.handleDragEventScatter = function(A, B, z, k, x, h) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = {
                                        v: {},
                                        s: {},
                                        c: {}
                                    };
                                    var p = 0;
                                    var r = false;
                                    var m = this.data.y.vars;
                                    var q = this.data.y.smps;
                                    if (A.shiftKey || this.lassoSelected) {
                                        for (var w = 0; w < this.meta.render.objects.length; w++) {
                                            var u = this.meta.render.objects[w];
                                            var y = false;
                                            if (this.lassoSelected) {
                                                y = u.idx && this.isAreaInsidePolygon(u.area, this.lassoPoints)
                                            } else {
                                                y = u.idx && this.isObjectInsideArea(u.area, z, k, x, h)
                                            }
                                            if (y && u.type == "Data") {
                                                a.v[u.idx[0]] = true;
                                                a.s[u.idx[1]] = true;
                                                a.s[u.idx[2]] = true;
                                                a.c[m[u.idx[0]] + "::" + q[u.idx[1]] + "::" + q[u.idx[2]]] = true;
                                                p++;
                                                exc = this.getSelectedExcludedFromRender(u.idx);
                                                if (exc) {
                                                    for (var v = 0; v < exc.length; v++) {
                                                        a.v[exc[v]] = true;
                                                        a.c[m[exc[v]] + "::" + q[u.idx[1]] + "::" + q[u.idx[2]]] = true;
                                                        p++
                                                    }
                                                }
                                            }
                                        }
                                        if (p > 0) {
                                            var r = this.extractDataObject(this.getKeys(a.s), this.getKeys(a.v));
                                            r.y.comp = a.c;
                                            if (!A.ctrlKey) {
                                                this.resetSelected(A, true)
                                            }
                                            this.addRemoveToSelected(false, r, A);
                                            this.broadcastDraw({
                                                func: "handleDragEventScatter",
                                                par: [A, B, z, k, x, h],
                                                prop: {
                                                    lassoPoints: this.lassoPoints,
                                                    lassoSelected: this.lassoSelected
                                                }
                                            });
                                            if (this.showDataTableOnSelect) {
                                                this.updateDataTable(r)
                                            }
                                        }
                                        if (this.lassoSelected) {
                                            this.lassoPoints = [];
                                            this.lassoSelected = false
                                        }
                                    } else {
                                        var l = [];
                                        var r = this.layoutComb ? this.layoutParams[B] : this;
                                        var g = r.xAxisMin + ((z - (this.marginLeft + r.offsetX + r.left)) / r.xAxisUnit);
                                        var f = r.xAxisMin + ((x - (this.marginLeft + r.offsetX + r.left)) / r.xAxisUnit);
                                        var b = r.yAxisMax - ((k - (this.marginTop + r.offsetY + r.top)) / r.yAxisUnit);
                                        var d = r.yAxisMax - ((h - (this.marginTop + r.offsetY + r.top)) / r.yAxisUnit);
                                        if (this.validateMinMax(g, f, r.xAxisMin, r.xAxisMax) && this.validateMinMax(d, b, r.yAxisMin, r.yAxisMax)) {
                                            if (this.scatterPlotMatrix && (this.scatterPlotMatrixType.match(/correlation|all/) || this.layoutAdjust == "axis")) {
                                                var t = 0;
                                                for (var w = 0; w < this.layoutRows; w++) {
                                                    for (var v = 0; v < this.layoutCols; v++) {
                                                        r = this.layoutParams[t];
                                                        if (w == this.layoutValidR) {
                                                            r.setMinY = d;
                                                            r.setMaxY = b
                                                        }
                                                        if (v == this.layoutValidC) {
                                                            r.setMinX = g;
                                                            r.setMaxX = f
                                                        }
                                                        if (w == this.layoutValidR || v == this.layoutValidC) {}
                                                        t++
                                                    }
                                                }
                                            } else {
                                                r = this.layoutComb && this.layoutAdjust ? this.layoutParams[B] : this;
                                                r.setMinX = g;
                                                r.setMaxX = f;
                                                r.setMaxY = b;
                                                r.setMinY = d
                                            }
                                            this.draw({
                                                func: "handleDragEventScatter",
                                                par: [A, B, z, k, x, h]
                                            })
                                        }
                                    }
                                };
                                this.handleDragEventGenome = function(f, h, d, j, a, i) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var g, k;
                                    var b = this.layoutComb ? this.layoutParams[h] : this;
                                    var g = b.xAxisMin + ((d - (this.marginLeft + b.offsetX + b.left)) / b.xAxisUnit);
                                    var k = b.xAxisMin + ((a - (this.marginLeft + b.offsetX + b.left)) / b.xAxisUnit);
                                    if (this.validateMinMax(g, k, this.xAxisMin, this.xAxisMax)) {
                                        this.setMinX = g;
                                        this.setMaxX = k;
                                        this.draw({
                                            func: "handleDragEventGenome",
                                            par: [f, h, d, j, a, i]
                                        })
                                    }
                                };
                                this.handleDragEventOneDimension = function(K, M, j, a, h, O, l) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var y = this.graphType;
                                    var E = 0.95;
                                    var m = {
                                        moveDendrogram: this.moveDendrogram,
                                        moveVarOverlay: this.moveVarOverlay,
                                        varOverlayInfo: this.varOverlayInfo,
                                        moveVar: this.moveVar,
                                        varInfo: this.varInfo,
                                        moveSmpOverlay: this.moveSmpOverlay,
                                        smpOverlayInfo: this.smpOverlayInfo,
                                        moveSmp: this.moveSmp,
                                        smpInfo: this.smpInfo
                                    };
                                    if (this.moveDendrogram) {
                                        var b = this.layoutComb ? this.layoutParams[M] : this;
                                        var v;
                                        if (this.moveDendrogram == "varDendrogram") {
                                            v = a > this.marginTop + b.offsetY + b.top + (b.y * E) ? "bottom" : "top";
                                            if (this.varDendrogramPosition != v) {
                                                this.varDendrogramPosition = v;
                                                this.draw({
                                                    func: "handleDragEventOneDimension",
                                                    par: [K, M, j, a, h, O, l],
                                                    prop: m
                                                })
                                            }
                                        } else {
                                            if (y == "Heatmap" || this.graphOrientation == "horizontal") {
                                                v = j > this.marginLeft + b.offsetX + b.left + (b.x * E) ? "right" : "left"
                                            } else {
                                                v = a > this.marginTop + b.offsetY + b.top + (b.y * E) ? "bottom" : "top"
                                            }
                                            if (this.smpDendrogramPosition != v) {
                                                this.smpDendrogramPosition = v;
                                                this.draw({
                                                    func: "handleDragEventOneDimension",
                                                    par: [K, M, j, a, h, O, l],
                                                    prop: m
                                                })
                                            }
                                        }
                                        this.skipClick = false
                                    } else {
                                        if (this.moveVarOverlay) {
                                            var b = this.layoutComb ? this.layoutParams[M] : this;
                                            var x = this.moveVarOverlay.split("-")[1];
                                            var u = this.varOverlays[x];
                                            var v = a < this.marginTop + b.offsetY + b.top ? "top" : "bottom";
                                            this.varOverlays.splice(x, 1);
                                            var L = this.varOverlays.length;
                                            for (var F = 0; F < this.varOverlays.length; F++) {
                                                var D = this.varOverlays[F];
                                                if (this.varOverlayInfo[D] > a) {
                                                    L = F;
                                                    break
                                                }
                                            }
                                            this.varOverlays.splice(L, 0, u);
                                            if (!this.varOverlayProperties.hasOwnProperty(u)) {
                                                this.varOverlayProperties[u] = {}
                                            }
                                            this.varOverlayProperties[u]["position"] = v;
                                            this.draw({
                                                func: "handleDragEventOneDimension",
                                                par: [K, M, j, a, h, O, l],
                                                prop: m
                                            });
                                            this.skipClick = false
                                        } else {
                                            if (this.moveVar) {
                                                var x = this.moveVar.split("-")[1];
                                                if (this.showVarDendrogram && this.varDendrogram) {
                                                    alert("Ooops. Cannot change order when showing the dendrogram");
                                                    return false
                                                }
                                                var J = this.layoutComb ? this.layoutParams[M].varIndices : this.varIndices;
                                                var I = this.layoutComb ? this.cloneObject(this.layoutParams[M].varInfo) : this.cloneObject(this.varInfo);
                                                var L;
                                                var d = [];
                                                if (this.moveVar.match(/VarOvr/)) {
                                                    var r = this.moveVar.split("-")[2];
                                                    var g = this.data.z[this.varOverlays[r]];
                                                    for (var F = 0; F < J.length; F++) {
                                                        if (J[F] == x) {
                                                            L = F;
                                                            break
                                                        }
                                                    }
                                                    if (L > 0) {
                                                        while (L > 0 && g[J[L - 1]] == g[J[L]]) {
                                                            L--
                                                        }
                                                    }
                                                    d = [L];
                                                    while (g[J[L + 1]] == g[J[L]]) {
                                                        L++;
                                                        d.push(L)
                                                    }
                                                } else {
                                                    for (var F = 0; F < J.length; F++) {
                                                        if (J[F] == x) {
                                                            L = F;
                                                            break
                                                        }
                                                    }
                                                    d = [L]
                                                }
                                                d = J.splice(d[0], d.length);
                                                I.splice(d[0], d.length);
                                                for (var F = 0; F < J.length; F++) {
                                                    if (I[F] > j) {
                                                        L = F;
                                                        break
                                                    }
                                                }
                                                for (var F = 0; F < d.length; F++) {
                                                    J.splice(L + F, 0, d[F])
                                                }
                                                this.draw({
                                                    func: "handleDragEventOneDimension",
                                                    par: [K, M, j, a, h, O, l],
                                                    prop: m
                                                });
                                                this.skipClick = false
                                            } else {
                                                if (this.moveSmpOverlay) {
                                                    var q, v;
                                                    var b = this.layoutComb ? this.layoutParams[M] : this;
                                                    var x = this.moveSmpOverlay.split("-")[1];
                                                    var u = this.smpOverlays[x];
                                                    if (y.match(/Heatmap/) || this.graphOrientation == "horizontal") {
                                                        q = j;
                                                        v = q > this.marginLeft + b.offsetX + b.left + (b.x * E) ? "right" : "left"
                                                    } else {
                                                        q = a;
                                                        v = q < this.marginTop + b.offsetY + b.top ? "top" : "bottom"
                                                    }
                                                    this.smpOverlays.splice(x, 1);
                                                    var L = this.smpOverlays.length;
                                                    for (var F = 0; F < this.smpOverlays.length; F++) {
                                                        var D = this.smpOverlays[F];
                                                        if (this.smpOverlayInfo[D] > q) {
                                                            L = F;
                                                            break
                                                        }
                                                    }
                                                    this.smpOverlays.splice(L, 0, u);
                                                    if (!this.smpOverlayProperties.hasOwnProperty(u)) {
                                                        this.smpOverlayProperties[u] = {}
                                                    }
                                                    this.smpOverlayProperties[u]["position"] = v;
                                                    this.draw({
                                                        func: "handleDragEventOneDimension",
                                                        par: [K, M, j, a, h, O, l],
                                                        prop: m
                                                    });
                                                    this.skipClick = false
                                                } else {
                                                    if (this.moveSmp) {
                                                        var x = this.moveSmp.split("-")[1];
                                                        var H;
                                                        var f = this.layoutComb ? this.cloneObject(this.layoutParams[M].smpInfo) : this.cloneObject(this.smpInfo);
                                                        if (this.layoutComb) {
                                                            this.layoutParams[M].dragged = true
                                                        }
                                                        if (this.isGroupedData) {
                                                            H = this.layoutComb ? this.layoutParams[M].grpIndices : this.grpIndices
                                                        } else {
                                                            H = this.layoutComb ? this.layoutParams[M].smpIndices : this.smpIndices;
                                                            if (this.showSmpDendrogram && this.smpDendrogram) {
                                                                alert("Ooops. Cannot change order when showing the dendrogram");
                                                                return false
                                                            }
                                                        }
                                                        var L;
                                                        var d = [];
                                                        if (this.moveSmp.match(/SmpOvr/)) {
                                                            var r = this.moveSmp.split("-")[2];
                                                            var g = this.isGroupedData ? this.data.w.factors[this.smpOverlays[r]] : this.data.x[this.smpOverlays[r]];
                                                            for (var F = 0; F < H.length; F++) {
                                                                if (H[F] == x) {
                                                                    L = F;
                                                                    break
                                                                }
                                                            }
                                                            if (L > 0) {
                                                                while (L > 0 && g[H[L - 1]] == g[H[L]]) {
                                                                    L--
                                                                }
                                                            }
                                                            d = [L];
                                                            while (g[H[L + 1]] == g[H[L]]) {
                                                                L++;
                                                                d.push(L)
                                                            }
                                                        } else {
                                                            for (var F = 0; F < H.length; F++) {
                                                                if (H[F] == x) {
                                                                    L = F;
                                                                    break
                                                                }
                                                            }
                                                            d = [L]
                                                        }
                                                        d = H.splice(d[0], d.length);
                                                        f.splice(d[0], d.length);
                                                        var q = y.match(/Heatmap/) || this.graphOrientation == "horizontal" ? a : j;
                                                        for (var F = 0; F < H.length; F++) {
                                                            if (f[F] > q) {
                                                                L = F;
                                                                break
                                                            }
                                                        }
                                                        for (var F = 0; F < d.length; F++) {
                                                            H.splice(L + F, 0, d[F])
                                                        }
                                                        this.draw({
                                                            func: "handleDragEventOneDimension",
                                                            par: [K, M, j, a, h, O, l],
                                                            prop: m
                                                        });
                                                        this.skipClick = false
                                                    } else {
                                                        if (K.shiftKey || l) {
                                                            var C = {};
                                                            var k = [];
                                                            var H;
                                                            var J = this.layoutComb ? this.layoutParams[M].varIndices : this.varIndices;
                                                            var G = this.isGroupedData ? this.grpIndices : this.smpIndices;
                                                            var w = false;
                                                            if (this.isGroupedData) {
                                                                H = this.layoutComb ? this.layoutParams[M].grpIndices : this.grpIndices
                                                            } else {
                                                                H = this.layoutComb ? this.layoutParams[M].smpIndices : this.smpIndices
                                                            }
                                                            this.setOriginalIndices(M, J, H);
                                                            for (var F = 0; F < this.meta.render.objects.length; F++) {
                                                                var z = this.meta.render.objects[F];
                                                                if (z.idx && this.isObjectInsideArea(z.area, j, a, h, O)) {
                                                                    C[z.idx[1]] = true
                                                                }
                                                            }
                                                            for (var F = 0; F < G.length; F++) {
                                                                if (C.hasOwnProperty(G[F])) {
                                                                    k.push(G[F]);
                                                                    if (!w) {
                                                                        if (this.isGroupedData) {
                                                                            this.grpIndicesStart = F;
                                                                            w = true
                                                                        } else {
                                                                            this.smpIndicesStart = F;
                                                                            w = true
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            this.setSamplesVisible(k, true);
                                                            var D = this.extractDataObject(k, this.varIndices);
                                                            this.draw({
                                                                func: "handleDragEventOneDimension",
                                                                par: [K, M, j, a, h, O, l],
                                                                prop: m
                                                            });
                                                            if (this.showDataTableOnSelect) {
                                                                this.updateDataTable(D)
                                                            }
                                                        } else {
                                                            var D = this.layoutComb ? this.layoutParams[M] : this;
                                                            var N = D.xAxisMin;
                                                            var t = D.xAxisMax;
                                                            var B = this.marginLeft + D.offsetX + D.left;
                                                            var p = B + D.x;
                                                            var A = this.marginTop + D.offsetY + D.top;
                                                            var n = A + D.y;
                                                            if (this.graphOrientation == "vertical") {
                                                                N = N + (Math.max(n - O, 0) / D.xAxisUnit);
                                                                t = t - (Math.max(a - A, 0) / D.xAxisUnit)
                                                            } else {
                                                                N = N + (Math.max(j - B, 0) / D.xAxisUnit);
                                                                t = t - (Math.max(p - h, 0) / D.xAxisUnit)
                                                            }
                                                            if (this.validateMinMax(N, t, this.xAxisMin, this.xAxisMax)) {
                                                                D = this.layoutComb && this.layoutAdjust ? this.layoutParams[M] : this;
                                                                D.setMinX = N;
                                                                D.setMaxX = t;
                                                                this.draw({
                                                                    func: "handleDragEventOneDimension",
                                                                    par: [K, M, j, a, h, O, l],
                                                                    prop: m
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.handleDragEvent = function(h, b, f, a, d) {
                                    var i = this.layoutComb ? this.layoutValidN : 0;
                                    var g = this.layoutComb ? this.layoutParams[i].graphType : this.graphType;
                                    if (g == "Correlation") {
                                        this.handleDragEventCorrelation(h, b, f, a, d)
                                    } else {
                                        if (g == "Circular") {
                                            this.handleDragEventCircular(h)
                                        } else {
                                            if (g == "Network") {
                                                this.handleDragEventNetwork(h, b, f, a, d)
                                            } else {
                                                if (g == "Heatmap" && !this.moveDendrogram && !this.moveVar && !this.moveSmp && !this.moveVarOverlay && !this.moveSmpOverlay) {
                                                    this.handleDragEventHeatmap(h, i, b, f, a, d)
                                                } else {
                                                    if (g.match(/Scatter/)) {
                                                        this.handleDragEventScatter(h, i, b, f, a, d)
                                                    } else {
                                                        if (g == "Genome") {
                                                            this.handleDragEventGenome(h, i, b, f, a, d)
                                                        } else {
                                                            this.handleDragEventOneDimension(h, i, b, f, a, d)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.updateLayoutDrag = function(i) {
                                    var g = this;
                                    var c = function() {
                                        var l = 0;
                                        for (var e = 0; e < g.layoutRows; e++) {
                                            for (var b = 0; b < g.layoutCols; b++) {
                                                var h = g.getBoundsXY(l);
                                                if (n >= h[4] && n <= h[5] && k >= h[6] && k <= h[7]) {
                                                    return {
                                                        bounds: h,
                                                        target: l
                                                    }
                                                }
                                                l++
                                            }
                                        }
                                        return false
                                    };
                                    var m = this.layoutValidDrag || this.layoutValidBounds;
                                    var j = this.$(this.target + "-cX-Drag");
                                    var q = this.adjustedCoordinates(i);
                                    if (m && j && q) {
                                        var n = q.x;
                                        var k = q.y;
                                        var a = c();
                                        if (!this.layoutValidDrag) {
                                            this.layoutValidDrag = this.cloneObject(m);
                                            this.layoutValidDrag.push(this.xMouseDown);
                                            this.layoutValidDrag.push(this.yMouseDown);
                                            this.layoutValidDrag.push(this.layoutValidN)
                                        }
                                        var d = (m[4] + (n - this.layoutValidDrag[8]));
                                        var p = (m[6] + (k - this.layoutValidDrag[9]));
                                        var o = m[5] - m[4];
                                        var f = m[7] - m[6];
                                        j.style.left = d + "px";
                                        j.style.top = p + "px";
                                        j.style.width = o + "px";
                                        j.style.height = f + "px";
                                        j.style.border = "1px solid grey";
                                        if (a) {
                                            var o = this.$(this.target + "-cX-Drag-Layout");
                                            if (o) {
                                                o.style.left = a.bounds[4] + "px";
                                                o.style.top = a.bounds[6] + "px";
                                                o.style.width = (a.bounds[5] - a.bounds[4]) + "px";
                                                o.style.height = (a.bounds[7] - a.bounds[6]) + "px";
                                                o.style.border = "1px solid grey";
                                                this.layoutValidDrag[11] = a.target
                                            }
                                        }
                                    }
                                };
                                this.endDragLayout = function(b) {
                                    if (this.layoutValidDrag && this.layoutValidDrag[10] && this.layoutValidDrag[11]) {
                                        if (this.layoutValidDrag[10] != this.layoutValidDrag[11] && this.includeDOE.length) {
                                            var a = this.includeDOE.splice(this.layoutValidDrag[10] - 1, 1);
                                            var d = this.layoutConfig.splice(this.layoutValidDrag[10], 1);
                                            this.includeDOE.splice(this.layoutValidDrag[11] - 1, 0, a[0]);
                                            this.layoutConfig.splice(this.layoutValidDrag[11], 0, d[0]);
                                            this.createDOE(false, false, true);
                                            this.draw({
                                                func: "endDragLayout",
                                                par: [b],
                                                prop: {
                                                    layoutValidDrag: this.layoutValidDrag
                                                }
                                            })
                                        }
                                    }
                                    this.resetDrag(b)
                                };
                                this.resetDrag = function(c, b) {
                                    var f = this.$(this.target + "-cX-Drag");
                                    if (f) {
                                        f.style.left = "0px";
                                        f.style.top = "0px";
                                        f.style.width = "0px";
                                        f.style.height = "0px";
                                        f.style.borderRadius = "";
                                        f.style.backgroundColor = this.resizerBackgroundColor;
                                        f.style.border = "none"
                                    }
                                    var a = this.$(this.target + "-cX-Drag-Layout");
                                    if (a) {
                                        a.style.left = "0px";
                                        a.style.top = "0px";
                                        a.style.width = "0px";
                                        a.style.height = "0px";
                                        a.style.border = "none"
                                    }
                                    if (this.isDOE) {
                                        this.layoutValidDrag = false;
                                        this.cancelEvent(c);
                                        this.stopEvent(c)
                                    }
                                    if (!b) {
                                        this.skipClick = false
                                    }
                                };
                                this.initializeDraggingEvents = function() {
                                    if (!this.disableEvents) {
                                        this.addDragDiv();
                                        this.addDragDivLayout()
                                    }
                                };
                                this.initializeDraggingEvents()
                            };
                            CanvasXpress.prototype.initKeyEvents = function() {
                                this.getKeyCode = function(a) {
                                    if (a) {
                                        if ((a.charCode) && (a.keyCode == 0)) {
                                            return a.charCode
                                        } else {
                                            return a.keyCode
                                        }
                                    }
                                };
                                this.registerKey = function(h) {
                                    var b = this.getTargetEvent(h);
                                    var d = h.shiftKey;
                                    var f = h.ctrlKey;
                                    var a = h.altKey;
                                    var g = window.document;
                                    var i = this.getKeyCode(h);
                                    if (!this.disableKeys || (f && a && i == 107)) {
                                        if (this.motioningOn) {
                                            this.stopEvent(h);
                                            return false
                                        } else {
                                            if (i == 13) {
                                                return
                                            } else {
                                                if (i == 27) {
                                                    if (d) {
                                                        return this.replot(h, a)
                                                    } else {
                                                        if (this.animationOn) {
                                                            this.animationOn = false;
                                                            return false
                                                        }
                                                        if (f) {
                                                            this.resetFilters()
                                                        }
                                                        if (this.view != "table") {
                                                            this.masterReset(h)
                                                        }
                                                    }
                                                    return
                                                } else {
                                                    if (i == 16) {
                                                        if (this.disableShowShortcuts) {
                                                            return
                                                        }
                                                        this.showShortcuts()
                                                    } else {
                                                        if (i == 17) {
                                                            if (this.disableShowShortcuts) {
                                                                return
                                                            }
                                                            this.showShortcuts()
                                                        } else {
                                                            if ((i == 18 || i == 224)) {
                                                                if (this.disableShowShortcuts) {
                                                                    return
                                                                }
                                                                this.showShortcuts()
                                                            } else {
                                                                if ((i == 91 || i == 93)) {} else {
                                                                    if (f && d) {
                                                                        if (i >= 33 && i <= 40) {
                                                                            this.arrowMove(i, true)
                                                                        } else {
                                                                            if (i == 80) {
                                                                                if (!this.motionBy) {
                                                                                    this.reproduce(h, false, true)
                                                                                }
                                                                            } else {
                                                                                if (i == 82) {
                                                                                    if (!this.motionBy) {
                                                                                        this.reproduce(h)
                                                                                    }
                                                                                } else {
                                                                                    if (i == 83) {
                                                                                        this.save(h)
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                        g.defaultAction = true
                                                                    } else {
                                                                        if (f && a) {
                                                                            if (i == 80 && !this.keyOn) {
                                                                                this.keyOn = true;
                                                                                this.print(h)
                                                                            } else {
                                                                                if (i == 82) {
                                                                                    if (!this.motionBy) {
                                                                                        this.reproduce(h)
                                                                                    }
                                                                                } else {
                                                                                    if (i == 68) {
                                                                                        this.flashInfoSpan(100, 100, "Debug info dropped to JavaScript console!", 3000);
                                                                                        console.log({
                                                                                            system: CanvasXpress.system,
                                                                                            factory: CanvasXpress.factory
                                                                                        })
                                                                                    } else {
                                                                                        if (i == 83) {
                                                                                            if (!this.motionBy) {
                                                                                                this.save(h)
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                            g.defaultAction = true
                                                                        } else {
                                                                            if (d && a) {
                                                                                if (i >= 50 && i < 90 && !this.keyOn) {
                                                                                    this.keyOn = true
                                                                                }
                                                                                g.defaultAction = true
                                                                            } else {
                                                                                if (f) {
                                                                                    if (i >= 33 && i <= 40) {
                                                                                        if (i == 36 && CanvasXpress.selector.selections && this.graphType == "Network") {
                                                                                            this.showHideSelectedData(h, i)
                                                                                        } else {
                                                                                            this.arrowMove(i)
                                                                                        }
                                                                                    } else {
                                                                                        if ((i == 45 || i == 46) && !this.keyOn) {
                                                                                            this.keyOn = true;
                                                                                            this.showHideSelectedData(h, i)
                                                                                        } else {
                                                                                            if ((i >= 48 && i < 58) && !this.keyOn) {
                                                                                                this.keyOn = true
                                                                                            } else {
                                                                                                if (i >= 65 && i <= 90) {
                                                                                                    if (this.graphType == "Network" && !this.keyOn && !/input|textarea|select/i.test(b.tagName)) {
                                                                                                        if (i == 66 || i == 72 || i == 76 || i == 82 || i == 84 || i == 86) {
                                                                                                            this.keyOn = true;
                                                                                                            this.alignDistributeSelectedNodes(h, i)
                                                                                                        }
                                                                                                    } else {
                                                                                                        if (i == 80 && !this.keyOn) {
                                                                                                            this.keyOn = true;
                                                                                                            this.print(h)
                                                                                                        } else {
                                                                                                            if (i == 82) {
                                                                                                                if (!this.motionBy) {
                                                                                                                    this.reproduce(h)
                                                                                                                }
                                                                                                            } else {
                                                                                                                if (i == 83) {
                                                                                                                    if (!this.motionBy) {
                                                                                                                        this.save(h)
                                                                                                                    }
                                                                                                                } else {
                                                                                                                    if (i == 89) {
                                                                                                                        this.keyOn = true;
                                                                                                                        this.redo()
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                    if (i == 90) {
                                                                                                        this.keyOn = true;
                                                                                                        this.undo()
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                    g.defaultAction = true
                                                                                } else {
                                                                                    if (i == 107 || i == 109 || i == 61 || i == 187 || i == 189) {
                                                                                        if (!this.disablePlusMinusKeys && !/input|textarea|select/i.test(b.tagName)) {
                                                                                            if (i == 109 || i == 189) {
                                                                                                this.handleWheelEvent(h, -1)
                                                                                            } else {
                                                                                                this.handleWheelEvent(h, 1)
                                                                                            }
                                                                                        }
                                                                                    } else {
                                                                                        if (d && i >= 33 && i <= 40) {
                                                                                            if (!this.disableArrowKeys && !/input|textarea|select/i.test(b.tagName)) {
                                                                                                this.handlePanning(h, i)
                                                                                            } else {
                                                                                                g.defaultAction = true
                                                                                            }
                                                                                        } else {
                                                                                            if (i >= 36 && i <= 40) {
                                                                                                if (!this.disableArrowKeys && !/input|textarea|select/i.test(b.tagName)) {
                                                                                                    this.handlePanning(h, i)
                                                                                                }
                                                                                            } else {
                                                                                                if (d) {
                                                                                                    g.defaultAction = true
                                                                                                } else {
                                                                                                    if (a) {
                                                                                                        g.defaultAction = true
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.showShortcuts = function() {
                                    var a = "<br>";
                                    a += "<b>Crtl P</b> : Print PNG <br>";
                                    a += "<b>Ctrl S</b> : Save as JSON <br>";
                                    a += "<b>Ctrl R</b> : Open Reproduce Widget <br>";
                                    a += "<br>";
                                    a += "<b>Ctrl + Shift + P</b> : Print PNGs over time <br>";
                                    a += "<b>Ctrl + Shift + S</b> : Save as JSON overwrite <br>";
                                    a += "<b>Ctrl + Shift + R</b> : Play reproduce auto <br>";
                                    a += "<b>Ctrl + Shift + D</b> : Print debug info to console <br>";
                                    a += "<br>";
                                    a += "<b>Ctrl + Alt/Option P</b> : Print PNG overwrite <br>";
                                    a += "<b>Ctrl + Alt/Option S</b> : Save as JSON overwrite <br>";
                                    a += "<b>Ctrl + Alt/Option R</b> : Open Reproduce Widget <br>";
                                    a += "<br>";
                                    this.flashInfoSpan(this.width - 100, 10, a, 5000)
                                };
                                this.undo = function() {
                                    if (!this.disableUndoRedoKeys && CanvasXpress.stack[this.target].stateIndex >= 1) {
                                        CanvasXpress.stack[this.target].stateIndex--;
                                        this.setConfigState(CanvasXpress.stack[this.target].stateIndex, true)
                                    }
                                };
                                this.redo = function() {
                                    var a = CanvasXpress.stack[this.target].state.length - 1;
                                    if (!this.disableUndoRedoKeys && CanvasXpress.stack[this.target].stateIndex < a) {
                                        CanvasXpress.stack[this.target].stateIndex++;
                                        this.setConfigState(CanvasXpress.stack[this.target].stateIndex, true)
                                    }
                                };
                                this.handlePanning = function(f, h) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.graphType == "Correlation" || this.graphType == "Heatmap" || this.graphType.match(/Bar|Line|Dotplot|Boxplot|Area|Stacked/)) {
                                        this.cancelEvent(f);
                                        if (this.layoutComb && !this.layoutAdjust && this.graphType != "Correlation" && this.graphType != "Heatmap") {
                                            return false
                                        }
                                        this.setIndicesAfterPannEvent(f, h)
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            this.setRangesAfterPannEvent(f, h)
                                        } else {
                                            if (this.graphType == "Network") {
                                                this.cancelEvent(f);
                                                var a = Math.abs(this.x * this.panningStep);
                                                var g = Math.abs(this.y * this.panningStep);
                                                if (h == 33) {
                                                    this.panningY -= g * 5
                                                } else {
                                                    if (h == 34) {
                                                        this.panningY += g * 5
                                                    } else {
                                                        if (h == 35) {
                                                            this.panningX = a * 20;
                                                            this.panningY = g * 20
                                                        } else {
                                                            if (h == 36) {
                                                                this.panningX = 0;
                                                                this.panningY = 0
                                                            } else {
                                                                if (h == 37) {
                                                                    this.panningX -= a
                                                                } else {
                                                                    if (h == 38) {
                                                                        this.panningY -= g
                                                                    } else {
                                                                        if (h == 39) {
                                                                            this.panningX += a
                                                                        } else {
                                                                            if (h == 40) {
                                                                                this.panningY += g
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                this.draw({
                                                    network: true,
                                                    func: "handlePanning",
                                                    par: [f, h]
                                                })
                                            } else {
                                                if (this.graphType == "Genome") {
                                                    var b = this.genomeResolution == "high" ? 1 : this.xAxisRange * this.panningStep;
                                                    if (this.setMinX == null) {
                                                        this.setMinX = this.xAxisMin
                                                    }
                                                    if (this.setMaxX == null) {
                                                        this.setMaxX = this.xAxisMax
                                                    }
                                                    this.cancelEvent(f);
                                                    if (h == 37 || h == 38) {
                                                        this.setMinX -= b;
                                                        this.setMaxX -= b
                                                    } else {
                                                        if (h == 39 || h == 40) {
                                                            this.setMinX += b;
                                                            this.setMaxX += b
                                                        } else {
                                                            if (h == 33) {
                                                                this.setMinX += this.xAxisRange * 0.95;
                                                                this.setMaxX += this.xAxisRange * 0.95
                                                            } else {
                                                                if (h == 34) {
                                                                    this.setMinX -= this.xAxisRange * 0.95;
                                                                    this.setMaxX -= this.xAxisRange * 0.95
                                                                } else {
                                                                    if (h == 35) {
                                                                        this.setMaxX = null
                                                                    } else {
                                                                        if (h == 36) {
                                                                            this.setMinX = null
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    this.draw({
                                                        func: "handlePanning",
                                                        par: [f, h]
                                                    })
                                                } else {
                                                    if (this.graphType == "Map") {
                                                        var d = this.rotationStep;
                                                        if (h == 33 || h == 38) {
                                                            this.panningY -= (d * 8)
                                                        } else {
                                                            if (h == 39) {
                                                                this.panningX += (d * 8)
                                                            } else {
                                                                if (h == 37) {
                                                                    this.panningX -= (d * 8)
                                                                } else {
                                                                    if (h == 34 || h == 40) {
                                                                        this.panningY += (d * 8)
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        this.draw({
                                                            func: "handlePanning",
                                                            par: [f, h]
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.arrowMove = function(k, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var f = this.graphType;
                                    if (this.is3DPlot) {
                                        f = "Scatter3D"
                                    }
                                    var e = this.rotationStep;
                                    switch (f) {
                                        case "Network":
                                            if (this.is3DNetwork) {
                                                if (k == 33) {
                                                    this.xRotate += (e * 3);
                                                    this.yRotate -= (e * 3)
                                                } else {
                                                    if (k == 34) {
                                                        this.xRotate -= (e * 3);
                                                        this.yRotate += (e * 3)
                                                    } else {
                                                        if (k == 37) {
                                                            this.xRotate += e
                                                        } else {
                                                            if (k == 38) {
                                                                this.yRotate -= e
                                                            } else {
                                                                if (k == 39) {
                                                                    this.xRotate -= e
                                                                } else {
                                                                    if (k == 40) {
                                                                        this.yRotate += e
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (k == 33) {
                                                    this.network2DRotate -= (e * 3)
                                                } else {
                                                    if (k == 34) {
                                                        this.network2DRotate += (e * 3)
                                                    } else {
                                                        if (k == 37 || k == 38) {
                                                            this.network2DRotate -= e
                                                        } else {
                                                            if (k == 39 || k == 40) {
                                                                this.network2DRotate += e
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            break;
                                        case "Scatter2D":
                                        case "ScatterBubble2D":
                                            var h;
                                            var j;
                                            if (this.axesType == "XYZ") {
                                                h = ["xAxisCurrent", "yAxisCurrent", "zAxisCurrent"];
                                                j = ["xAxis", "yAxis", "zAxis"]
                                            } else {
                                                if (this.axesType == "XY") {
                                                    h = ["zAxisCurrent"];
                                                    j = ["zAxis"]
                                                } else {
                                                    if (this.axesType == "X") {
                                                        h = ["yAxisCurrent", "zAxisCurrent"];
                                                        j = ["yAxis", "zAxis"]
                                                    } else {
                                                        h = ["xAxisCurrent", "zAxisCurrent"];
                                                        j = ["xAxis", "zAxis"]
                                                    }
                                                }
                                            }
                                            if (k == 33) {
                                                for (var d = 0; d < h.length; d++) {
                                                    this[h[d]] += 2
                                                }
                                            } else {
                                                if (k == 34) {
                                                    for (var d = 0; d < h.length; d++) {
                                                        this[h[d]] -= 2
                                                    }
                                                } else {
                                                    if (k == 35) {
                                                        for (var d = 0; d < h.length; d++) {
                                                            this[h[d]] = this[j[d]].length - 1
                                                        }
                                                    } else {
                                                        if (k == 36) {
                                                            for (var d = 0; d < h.length; d++) {
                                                                this[h[d]] = 0
                                                            }
                                                        } else {
                                                            if (k == 37 || k == 40) {
                                                                for (var d = 0; d < h.length; d++) {
                                                                    this[h[d]]--
                                                                }
                                                            } else {
                                                                if (k == 38 || k == 39) {
                                                                    for (var d = 0; d < h.length; d++) {
                                                                        this[h[d]]++
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            this.xAxisCurrent = this.xAxisCurrent < 0 ? this.xAxis.length - 1 : this.xAxisCurrent > this.xAxis.length - 1 ? 0 : this.xAxisCurrent;
                                            this.yAxisCurrent = this.yAxisCurrent < 0 ? this.xAxis.length - 1 : this.yAxisCurrent > this.yAxis.length - 1 ? 0 : this.yAxisCurrent;
                                            this.zAxisCurrent = this.zAxisCurrent < 0 ? this.xAxis.length - 1 : this.zAxisCurrent > this.zAxis.length - 1 ? 0 : this.zAxisCurrent;
                                            break;
                                        case "Scatter3D":
                                            if (k == 33) {
                                                this.xRotate += (e * 3);
                                                this.yRotate -= (e * 3)
                                            } else {
                                                if (k == 34) {
                                                    this.xRotate -= (e * 3);
                                                    this.yRotate += (e * 3)
                                                } else {
                                                    if (k == 35) {
                                                        this.xRotate = 0;
                                                        this.yRotate = 0;
                                                        this.zRotate = 45
                                                    } else {
                                                        if (k == 36) {
                                                            this.xRotate = 45;
                                                            this.yRotate = 0;
                                                            this.zRotate = 0
                                                        } else {
                                                            if (k == 37) {
                                                                this.xRotate += e
                                                            } else {
                                                                if (k == 38) {
                                                                    this.yRotate -= e
                                                                } else {
                                                                    if (k == 39) {
                                                                        this.xRotate -= e
                                                                    } else {
                                                                        if (k == 40) {
                                                                            this.yRotate += e
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            break
                                    }
                                    if (b && !this.animationOn) {
                                        this.animationOn = true;
                                        this.animateParams(k)
                                    } else {
                                        this.draw({
                                            network: true,
                                            func: "arrowMove",
                                            par: [k, b]
                                        })
                                    }
                                };
                                this.animateParams = function(d) {
                                    var a = this;
                                    var b = function() {
                                        this.update = function() {
                                            if (!a.animationOn) {
                                                clearInterval(c)
                                            }
                                            a.arrowMove(d);
                                            var f = a.graphType;
                                            if (a.is3DPlot) {
                                                f = "Scatter3D"
                                            }
                                            var e = this.rotationStep;
                                            switch (f) {
                                                case "Network":
                                                    if (this.is3DNetwork) {
                                                        if (d == 33) {
                                                            this.xRotate += (e * 3);
                                                            this.yRotate -= (e * 3)
                                                        } else {
                                                            if (d == 34) {
                                                                this.xRotate -= (e * 3);
                                                                this.yRotate += (e * 3)
                                                            } else {
                                                                if (d == 37) {
                                                                    this.xRotate -= e
                                                                } else {
                                                                    if (d == 38) {
                                                                        this.yRotate -= e
                                                                    } else {
                                                                        if (d == 39) {
                                                                            this.xRotate += e
                                                                        } else {
                                                                            if (d == 40) {
                                                                                this.yRotate += e
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (d == 33) {
                                                            this.network2DRotate += (e * 3)
                                                        } else {
                                                            if (d == 34) {
                                                                this.network2DRotate -= (e * 3)
                                                            } else {
                                                                if (d == 37 || d == 38) {
                                                                    this.network2DRotate -= e
                                                                } else {
                                                                    if (d == 39 || d == 40) {
                                                                        this.network2DRotate += e
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    break;
                                                case "Scatter2D":
                                                case "ScatterBubble2D":
                                                    if (d != 37) {
                                                        if (a.graphType == "ScatterBubble2D" && a.xAxisIndices.length > 1 && a.xAxisIndices.length == a.yAxisIndices.length && a.xAxisIndices.length == a.zAxisIndices.length) {
                                                            if (a.xAxisCurrent >= a.xAxis.length - 1) {
                                                                a.xAxisCurrent = a.xAxis.length - 1;
                                                                a.yAxisCurrent = a.yAxis.length - 1;
                                                                a.zAxisCurrent = a.zAxis.length - 1;
                                                                d = 37
                                                            }
                                                        } else {
                                                            if (a.xAxisIndices.length > 1 && a.xAxisIndices.length == a.yAxisIndices.length) {
                                                                if (a.zAxisCurrent >= a.zAxis.length - 1) {
                                                                    a.zAxisCurrent = a.zAxis.length - 1;
                                                                    d = 37
                                                                }
                                                            } else {
                                                                if (a.xAxisIndices.length > a.yAxisIndices.length) {
                                                                    if (a.yAxisCurrent >= a.yAxis.length - 1) {
                                                                        a.yAxisCurrent = a.yAxis.length - 1
                                                                    }
                                                                    if (a.zAxisCurrent >= a.zAxis.length - 1) {
                                                                        a.zAxisCurrent = a.zAxis.length - 1
                                                                    }
                                                                    if (a.yAxisCurrent >= a.yAxis.length - 1 && a.zAxisCurrent >= a.zAxis.length - 1) {
                                                                        d = 37
                                                                    }
                                                                } else {
                                                                    if (a.xAxisCurrent >= a.xAxis.length - 1) {
                                                                        a.xAxisCurrent = a.xAxis.length - 1
                                                                    }
                                                                    if (a.zAxisCurrent >= a.zAxis.length - 1) {
                                                                        a.zAxisCurrent = a.zAxis.length - 1
                                                                    }
                                                                    if (a.xAxisCurrent >= a.xAxis.length - 1 && a.zAxisCurrent >= a.zAxis.length - 1) {
                                                                        d = 37
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (d != 39) {
                                                            if (a.graphType == "ScatterBubble2D" && a.xAxisIndices.length > 1 && a.xAxisIndices.length == a.yAxisIndices.length && a.xAxisIndices.length == a.zAxisIndices.length) {
                                                                if (a.xAxisCurrent <= 0) {
                                                                    a.xAxisCurrent = 0;
                                                                    a.yAxisCurrent = 0;
                                                                    a.zAxisCurrent = 0;
                                                                    d = 39
                                                                }
                                                            } else {
                                                                if (a.xAxisIndices.length > 1 && a.xAxisIndices.length == a.yAxisIndices.length) {
                                                                    if (a.zAxisCurrent <= 0) {
                                                                        a.zAxisCurrent = 0;
                                                                        d = 39
                                                                    }
                                                                } else {
                                                                    if (a.xAxisIndices.length > a.yAxisIndices.length) {
                                                                        if (a.yAxisCurrent <= 0) {
                                                                            a.yAxisCurrent = 0
                                                                        }
                                                                        if (a.zAxisCurrent <= 0) {
                                                                            a.zAxisCurrent = 0
                                                                        }
                                                                        if (a.yAxisCurrent <= 0 && a.zAxisCurrent <= 0) {
                                                                            d = 39
                                                                        }
                                                                    } else {
                                                                        if (a.xAxisCurrent <= 0) {
                                                                            a.xAxisCurrent = 0
                                                                        }
                                                                        if (a.zAxisCurrent <= 0) {
                                                                            a.zAxisCurrent = 0
                                                                        }
                                                                        if (a.xAxisCurrent <= 0 && a.zAxisCurrent <= 0) {
                                                                            d = 39
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    break;
                                                case "Scatter3D":
                                                    if (a.xRotate <= 0 && (d == 39 || d < 37)) {
                                                        a.xRotate = 0;
                                                        a.yRotate = 0;
                                                        d = 40
                                                    } else {
                                                        if (a.xRotate >= 90 && (d == 37 || d < 37)) {
                                                            a.xRotate = 90;
                                                            a.yRotate = 90;
                                                            d = 38
                                                        } else {
                                                            if (a.yRotate <= 0 && (d == 38 || d < 37)) {
                                                                a.yRotate = 0;
                                                                a.xRotate = 90;
                                                                d = 39
                                                            } else {
                                                                if (a.yRotate >= 90 && (d == 40 || d < 37)) {
                                                                    a.yRotate = 90;
                                                                    a.xRotate = 0;
                                                                    d = 37
                                                                }
                                                            }
                                                        }
                                                    }
                                                    break
                                            }
                                        };
                                        var c = a.setInterval(this.update, 30)
                                    };
                                    this.removeMenus();
                                    b.call()
                                };
                                this.reset = function(a, d, i, h) {
                                    this.varIndicesStart = -1;
                                    this.smpIndicesStart = -1;
                                    this.grpIndicesStart = -1;
                                    var b = d ? this.cloneObject(this.varIndices) : false;
                                    var c = d ? this.cloneObject(this.smpIndices) : false;
                                    var f = d ? this.cloneObject(this.grpIndices) : false;
                                    if (!h) {
                                        this.resetSelected(i)
                                    }
                                    switch (this.graphType) {
                                        case "Area":
                                        case "AreaLine":
                                        case "Stacked":
                                        case "StackedLine":
                                        case "StackedPercent":
                                        case "StackedPercentLine":
                                        case "Heatmap":
                                        case "Correlation":
                                        case "Venn":
                                        case "Pie":
                                        case "Bar":
                                        case "Line":
                                        case "BarLine":
                                        case "Boxplot":
                                        case "Dotplot":
                                        case "DotLine":
                                        case "Circular":
                                        case "Treemap":
                                        case "TagCloud":
                                        case "ParallelCoordinates":
                                        case "Sankey":
                                        case "Tree":
                                        case "Gantt":
                                        case "Meter":
                                            this.setAllVariablesVisible(b, a);
                                            this.setAllSamplesVisible(c, a);
                                            if (this.isGroupedData && this.data.w && d) {
                                                this.data.w.grpIdxs = f
                                            }
                                            break;
                                        case "Scatter2D":
                                        case "ScatterBubble2D":
                                        case "Scatter3D":
                                        case "Fish":
                                            this.setAllVariablesVisible(b, a);
                                            this.setAllSamplesVisible(c, a);
                                            if (this.motionBy && this.motionObject) {
                                                this.motionObject.setIndices = true
                                            }
                                            break;
                                        case "Network":
                                            this.setAllNodesVisible();
                                            this.translateCanvas(-this.offsetX, -this.offsetY);
                                            this.scaleCanvas(1 / this.scaleFactorX, 1 / this.scaleFactorY);
                                            break;
                                        case "Genome":
                                            this.setAllFeaturesVisible(a);
                                            break;
                                        case "Map":
                                            this.setAllVariablesVisible(b, a);
                                            this.setAllSamplesVisible(c, a);
                                            this.setAllMapFeaturesVisible();
                                            break
                                    }
                                    if (this.startingVarIndices && this.startingVarIndices.length == this.varIndices.length) {
                                        this.varIndices = this.startingVarIndices
                                    }
                                    if (this.startingSmpIndices && this.startingSmpIndices.length == this.smpIndices.length) {
                                        this.smpIndices = this.startingSmpIndices
                                    }
                                    if (this.startingGrpIndices && this.startingGrpIndices.length == this.grpIndices.length) {
                                        this.grpIndices = this.startingGrpIndices
                                    }
                                };
                                this.hardReset = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.varIndicesStart = -1;
                                    this.smpIndicesStart = -1;
                                    this.grpIndicesStart = -1;
                                    this.resetSelected(b);
                                    switch (this.graphType) {
                                        case "Area":
                                        case "AreaLine":
                                        case "Stacked":
                                        case "StackedLine":
                                        case "StackedPercent":
                                        case "StackedPercentLine":
                                        case "Correlation":
                                        case "Circular":
                                        case "Venn":
                                        case "Pie":
                                        case "Treemap":
                                        case "TagCloud":
                                        case "ParallelCoordinates":
                                        case "Sankey":
                                        case "Tree":
                                            this.setAllVariablesVisible();
                                            this.setAllSamplesVisible();
                                            this.circularRotate = 0;
                                            break;
                                        case "Bar":
                                        case "Line":
                                        case "BarLine":
                                        case "Boxplot":
                                        case "Dotplot":
                                        case "DotLine":
                                        case "Genome":
                                        case "Gantt":
                                        case "Meter":
                                            this.setAllVariablesVisible();
                                            this.setAllSamplesVisible();
                                            this.resetRange();
                                            this.xRotate = 45;
                                            this.yRotate = 0;
                                            break;
                                        case "Scatter2D":
                                        case "ScatterBubble2D":
                                        case "Fish":
                                            this.setAllVariablesVisible();
                                            this.setAllSamplesVisible();
                                            this.resetRange();
                                            if (this.motionBy && this.motionObject) {
                                                this.motionObject.setIndices = true
                                            }
                                            break;
                                        case "Scatter3D":
                                            this.setAllVariablesVisible();
                                            this.setAllSamplesVisible();
                                            this.xRotate = 45;
                                            this.yRotate = 0;
                                            break;
                                        case "Heatmap":
                                            this.setAllVariablesVisible();
                                            this.setAllSamplesVisible();
                                            this.sortOncoprint();
                                            break;
                                        case "Network":
                                            this.setAllNodesVisible();
                                            this.network2DRotate = 0;
                                            if (this.randomData) {
                                                this.isLayoutDone = true
                                            }
                                            this.networkFreeze = false;
                                            this.setNetworkMinMaxRangeXY();
                                            this.setNetworkScaleFactor();
                                            this.translateCanvas(-this.offsetX, -this.offsetY);
                                            this.scaleCanvas(1 / this.scaleFactorX, 1 / this.scaleFactorY);
                                            break;
                                        case "Map":
                                            this.setAllVariablesVisible();
                                            this.setAllSamplesVisible();
                                            this.setAllMapFeaturesVisible();
                                            var a = this.meta.map.geojson;
                                            this.panningX = 0;
                                            this.panningY = 0;
                                            this.zoom = 1;
                                            delete(a.isZoomed);
                                            a.geometry.zoom = this.cloneObject(a.geometry.initial.zoom);
                                            a.geometry.center = this.cloneObject(a.geometry.initial.center);
                                            this.setMapAttributes(true);
                                            break
                                    }
                                    this.setInitialConfig()
                                };
                                this.resetZoomPan = function() {
                                    this.zoom = 1;
                                    this.panningX = 0;
                                    this.panningY = 0;
                                    this.panningGlobalX = 0;
                                    this.panningGlobalY = 0;
                                    this.padX = this.x / 2;
                                    this.padY = this.y / 2;
                                    this.padZ = this.y / 2
                                };
                                this.resetRange = function() {
                                    if (this.layoutComb && this.scatterPlotMatrix && (this.scatterPlotMatrixType.match(/correlation|all/) || this.layoutAdjust == "axis")) {
                                        var d = 0;
                                        for (var b = 0; b < this.layoutRows; b++) {
                                            for (var a = 0; a < this.layoutCols; a++) {
                                                c = this.layoutParams[d++];
                                                if (c) {
                                                    c.setMinX = null;
                                                    c.setMaxX = null;
                                                    c.setMinX2 = null;
                                                    c.setMaxX2 = null;
                                                    c.setMinY = null;
                                                    c.setMaxY = null;
                                                    c.setMinZ = null;
                                                    c.setMaxZ = null
                                                }
                                            }
                                        }
                                    } else {
                                        var c = this.layoutComb && this.layoutAdjust && this.layoutValidN != null ? this.layoutParams[this.layoutValidN] : this;
                                        if (c) {
                                            c.setMinX = null;
                                            c.setMaxX = null;
                                            c.setMinX2 = null;
                                            c.setMaxX2 = null;
                                            c.setMinY = null;
                                            c.setMaxY = null;
                                            c.setMinZ = null;
                                            c.setMaxZ = null
                                        }
                                    }
                                };
                                this.resetTouches = function() {
                                    var b = this;
                                    var a = function() {
                                        clearTimeout(a);
                                        b.touches = false;
                                        b.touchEvent = false
                                    };
                                    setTimeout(a, 500)
                                };
                                this.masterReset = function(f) {
                                    if (this.isDOE) {
                                        this.resetDOE()
                                    } else {
                                        var c = f && (f.shiftKey || f.ctrlKey || f.altKey || f.metaKey);
                                        var a = this.broadcast && c ? CanvasXpress.instances : [this];
                                        for (var b = 0; b < a.length; b++) {
                                            var d = a[b];
                                            d.resetTooltipDivs();
                                            d.resetDrag(f);
                                            d.resetSelected(f);
                                            d.resetDataFilter(f, true);
                                            if (d.dataTableLastState && d.dataTableLastState != "docked") {
                                                d.hideUnhideDataTable(true)
                                            }
                                            d.resetConfigurator(f);
                                            d.resetFlags(f);
                                            d.resetZoomPan();
                                            d.redraw(f)
                                        }
                                    }
                                }
                            };
                            CanvasXpress.prototype.initSelectEvents = function() {
                                this.showHideSelectedData = function(k, m, g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (k) {
                                        this.stopEvent(k)
                                    }
                                    var o = this.layoutComb ? this.layoutValidN : 0;
                                    var p = this.layoutComb ? this.layoutParams[o].graphType : this.graphType;
                                    if (m == 45 || m == 46) {
                                        if (p == "Network") {
                                            var a = [];
                                            var l = m == 45 ? false : true;
                                            for (var d in CanvasXpress.selector.nodes) {
                                                a.push(d)
                                            }
                                            if (a.length) {
                                                this.hideUnhideNodes(a, l)
                                            }
                                        } else {
                                            if (p.match(/Scatter/)) {
                                                for (v in CanvasXpress.selector.vars) {
                                                    this.hideUnhideVars(v)
                                                }
                                            }
                                        }
                                        if (!g) {
                                            this.draw({
                                                func: "showHideSelectedData",
                                                par: [k, m, g]
                                            })
                                        }
                                    } else {
                                        if ((m == 36 || m == 1000) && p == "Network") {
                                            var b = {};
                                            var j = [];
                                            var a = this.data.nodes;
                                            var f = this.data.edges;
                                            for (var h = 0; h < f.length; h++) {
                                                if (m == 1000) {
                                                    if (CanvasXpress.selector.nodes.hasOwnProperty(f[h].id1) && CanvasXpress.selector.nodes.hasOwnProperty(f[h].id2)) {
                                                        b[f[h].id1] = true;
                                                        b[f[h].id2] = true
                                                    }
                                                } else {
                                                    if (CanvasXpress.selector.nodes.hasOwnProperty(f[h].id1) || CanvasXpress.selector.nodes.hasOwnProperty(f[h].id2)) {
                                                        b[f[h].id1] = true;
                                                        b[f[h].id2] = true
                                                    }
                                                }
                                            }
                                            for (var h = 0; h < a.length; h++) {
                                                if (!b.hasOwnProperty(a[h].id) || a[h].hide) {
                                                    j.push(a[h].id)
                                                }
                                            }
                                            this.resetSelected(k);
                                            if (j.length > 0) {
                                                this.hideUnhideNodes(j, true);
                                                if (!g) {
                                                    this.draw({
                                                        func: "showHideSelectedData",
                                                        par: [k, m, g]
                                                    })
                                                }
                                            }
                                        }
                                    }
                                };
                                this.broadcastDraw = function(d) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = this.broadcast ? CanvasXpress.instances : [this];
                                    for (var b = 0; b < a.length; b++) {
                                        var c = a[b];
                                        if (c.graphType == "Map" && c.mapProjection == "orthographic" && c.eventMapCenter) {
                                            c.transitionMap(c, d)
                                        } else {
                                            c.filterSelected();
                                            c.draw(d)
                                        }
                                    }
                                };
                                this.filterSelected = function() {
                                    if (CanvasXpress.graphTypes.OneTwoThreeeDGraphs.includes(this.graphType) && this.selectionMode == "filter") {
                                        var e = [];
                                        for (var b in CanvasXpress.selector.smps) {
                                            e.push(b)
                                        }
                                        var d = [];
                                        for (var b in CanvasXpress.selector.vars) {
                                            d.push(b)
                                        }
                                        var a = CanvasXpress.selector.graphType;
                                        if (this.graphType.match(/Scatter/)) {
                                            if (a && this.data.y.histogram) {
                                                var c = this.dataStndBy.y.smps[0];
                                                this.removeHistogram(true);
                                                this.selectionMode = "filter";
                                                this.filterVariables(false, "exact", a.match(/Scatter/) ? d : e, false, true);
                                                this.createHistogram(c)
                                            } else {
                                                if (a && a.match(/Scatter/)) {
                                                    this.filterVariables(false, "exact", d, false, true)
                                                } else {
                                                    if (a) {
                                                        this.filterVariables(false, "exact", e, false, true)
                                                    } else {
                                                        var c = false;
                                                        if (this.data.y.histogram) {
                                                            c = this.dataStndBy.y.smps[0];
                                                            this.removeHistogram(true);
                                                            this.selectionMode = "filter"
                                                        }
                                                        this.resetFilters();
                                                        this.toDoFilter = {};
                                                        this.reset();
                                                        if (c) {
                                                            this.createHistogram(c)
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (a && this.graphType.match(/Pie|Treemap/)) {
                                                if (this.data.y.pie || this.data.y.treemap) {
                                                    var c = this.graphType == "Pie" ? this.data.y.smps[0] : this.data.y.vars[0];
                                                    if (this.graphType == "Pie") {
                                                        this.removePie(true)
                                                    } else {
                                                        this.removeTreemap(true)
                                                    }
                                                    this.selectionMode = "filter";
                                                    this.filterSamples(false, "exact", a.match(/Scatter/) ? d : e, false, true);
                                                    if (this.graphType == "Pie") {
                                                        this.createPie(c)
                                                    } else {
                                                        this.createTreemap(c)
                                                    }
                                                } else {
                                                    this.filterVariables(false, "exact", d, false, true)
                                                }
                                            } else {
                                                if (a && a.match(/Scatter/)) {
                                                    this.filterSamples(false, "exact", d, false, true)
                                                } else {
                                                    if (a) {
                                                        this.filterSamples(false, "exact", e, false, true)
                                                    } else {
                                                        var c = false;
                                                        if (this.data.y.pie || this.data.y.treemap) {
                                                            c = this.graphType == "Pie" ? this.data.y.smps[0] : this.data.y.vars[0];
                                                            if (this.graphType == "Pie") {
                                                                this.removePie(true)
                                                            } else {
                                                                this.removeTreemap(true)
                                                            }
                                                        }
                                                        this.resetFilters();
                                                        this.toDoFilter = {};
                                                        this.reset();
                                                        if (c) {
                                                            if (this.graphType == "Pie") {
                                                                this.createPie(c)
                                                            } else {
                                                                this.createTreemap(c)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.isSelected = function(p) {
                                    if (CanvasXpress.selector.selections) {
                                        var c = CanvasXpress.selector.graphType || "";
                                        if (this.graphType.match(/Genome/)) {} else {
                                            if (this.graphType == "Network") {
                                                var b = this.data.nodes[this.data.nodeIndices[p]];
                                                if (b) {
                                                    var z = b.name || "AbsurdName";
                                                    var a = b.label || "AbsurdName";
                                                    return CanvasXpress.selector.nodes.hasOwnProperty(p) || CanvasXpress.selector.mixed.hasOwnProperty(z) || CanvasXpress.selector.mixed.hasOwnProperty(a)
                                                } else {
                                                    return CanvasXpress.selector.nodes.hasOwnProperty(p)
                                                }
                                            } else {
                                                if (this.graphType == "Map") {
                                                    if (!this.isArray(p)) {
                                                        return false
                                                    }
                                                    if (this.motionBy) {
                                                        var d = this.motionObject.levels;
                                                        for (var e = 0; e < d.length; e++) {
                                                            if (CanvasXpress.selector.vars.hasOwnProperty(d[e])) {
                                                                this.updateMotionToCurrent(d[e], true);
                                                                break
                                                            } else {
                                                                if (CanvasXpress.selector.smps.hasOwnProperty(d[e])) {
                                                                    this.updateMotionToCurrent(d[e], true);
                                                                    break
                                                                }
                                                            }
                                                        }
                                                    }
                                                    return CanvasXpress.selector.vars.hasOwnProperty(p[0].split(":")[1]) || CanvasXpress.selector.mixed.hasOwnProperty(p[0].split(":")[1])
                                                } else {
                                                    if (this.graphType.match(/Scatter/)) {
                                                        var q = this.data.y.vars[p[0]];
                                                        var m = this.data.y.smps[p[1]];
                                                        var k = this.data.y.smps[p[2]];
                                                        if (c.match(/Scatter/)) {
                                                            if (this.isCreateHistogram || this.xAxisIndices.length > 1 || this.yAxisIndices.length > 1) {
                                                                if (CanvasXpress.selector.comp.hasOwnProperty(q + "::" + m + "::" + k)) {
                                                                    return true
                                                                } else {
                                                                    var f = this.getVariableIndices(q);
                                                                    if (f >= 0 && this.data.y.histogram) {
                                                                        for (var r = 0; r < this.data.y.histogram[f][0].length; r++) {
                                                                            var u = this.dataStndBy.y.vars[this.data.y.histogram[f][0][r]];
                                                                            if (CanvasXpress.selector.vars.hasOwnProperty(u)) {
                                                                                return true
                                                                            }
                                                                        }
                                                                    }
                                                                    return false
                                                                }
                                                            } else {
                                                                return CanvasXpress.selector.vars.hasOwnProperty(q)
                                                            }
                                                        } else {
                                                            if (this.isCreateHistogram && !this.isDOE) {
                                                                var f = this.getVariableIndices(q);
                                                                if (f >= 0) {
                                                                    for (var r = 0; r < this.data.y.histogram[f][0].length; r++) {
                                                                        var u = this.dataStndBy.y.vars[this.data.y.histogram[f][0][r]];
                                                                        if (CanvasXpress.selector.smps.hasOwnProperty(u)) {
                                                                            return true
                                                                        }
                                                                    }
                                                                }
                                                                return false
                                                            } else {
                                                                return CanvasXpress.selector.nodes.hasOwnProperty(q) || CanvasXpress.selector.smps.hasOwnProperty(q)
                                                            }
                                                        }
                                                    } else {
                                                        var q = this.data.y.vars[p[0]];
                                                        var w = p.length == 5 ? p[3] : p.length == 3 ? this.data.y.smps[p[2]] : this.data.y.smps[p[1]];
                                                        var h = this.isGroupedData ? this.data.w.smps[p[1]] : false;
                                                        if (c.match(/Scatter/)) {
                                                            if (this.isGroupedData) {
                                                                if (this.graphType == "Dotplot" || (this.graphType == "Boxplot" && this.showBoxplotOriginalData)) {
                                                                    return CanvasXpress.selector.vars.hasOwnProperty(q) && CanvasXpress.selector.smps.hasOwnProperty(w)
                                                                } else {
                                                                    return CanvasXpress.selector.comp.hasOwnProperty(q + "::" + h)
                                                                }
                                                            } else {
                                                                if (this.graphType == "Treemap" || this.graphType == "Pie") {
                                                                    var o = this.graphType.toLowerCase();
                                                                    var f = this.graphType == "Treemap" ? this.getSampleIndices(w) : this.getVariableIndices(q);
                                                                    if (f >= 0 && this.data.y[o]) {
                                                                        for (var r = 0; r < this.data.y[o][f].length; r++) {
                                                                            var u = this.dataStndBy.y.smps[this.data.y[o][f][r]];
                                                                            if (CanvasXpress.selector.vars.hasOwnProperty(u)) {
                                                                                return true
                                                                            }
                                                                        }
                                                                    }
                                                                    return false
                                                                } else {
                                                                    return CanvasXpress.selector.vars.hasOwnProperty(w)
                                                                }
                                                            }
                                                        } else {
                                                            if (c.match(/Pie|Treemap/)) {
                                                                if (this.isGroupedData) {
                                                                    if (this.graphType == "Dotplot" || (this.graphType == "Boxplot" && this.showBoxplotOriginalData)) {
                                                                        return CanvasXpress.selector.vars.hasOwnProperty(q) && CanvasXpress.selector.smps.hasOwnProperty(w)
                                                                    } else {
                                                                        return CanvasXpress.selector.comp.hasOwnProperty(q + "::" + h)
                                                                    }
                                                                } else {
                                                                    if (this.data.y.hasOwnProperty("pie") || this.data.y.hasOwnProperty("treemap")) {
                                                                        if (CanvasXpress.selector.meta.hasOwnProperty(q) && CanvasXpress.selector.meta[q].hasOwnProperty(w)) {
                                                                            return true
                                                                        }
                                                                        var o = this.graphType.toLowerCase();
                                                                        var f = this.graphType == "Treemap" ? this.getSampleIndices(w) : this.getVariableIndices(q);
                                                                        if (f >= 0 && this.data.y[o]) {
                                                                            for (var r = 0; r < this.data.y[o][f].length; r++) {
                                                                                var u = this.dataStndBy.y.smps[this.data.y[o][f][r]];
                                                                                if (CanvasXpress.selector.smps.hasOwnProperty(u)) {
                                                                                    return true
                                                                                }
                                                                            }
                                                                        }
                                                                        return false
                                                                    } else {
                                                                        return this.graphType == "Pie" ? CanvasXpress.selector.vars.hasOwnProperty(q) : CanvasXpress.selector.smps.hasOwnProperty(w)
                                                                    }
                                                                }
                                                            } else {
                                                                if (this.isGroupedData) {
                                                                    if (this.graphType == "Dotplot" || (this.graphType == "Boxplot" && this.showBoxplotOriginalData)) {
                                                                        return CanvasXpress.selector.vars.hasOwnProperty(q) && CanvasXpress.selector.smps.hasOwnProperty(w)
                                                                    } else {
                                                                        if (this.graphType == "Bar" && this.stackBy) {
                                                                            return CanvasXpress.selector.comp.hasOwnProperty(q + "::" + h + "::" + this.stackBy + "::" + p[4])
                                                                        } else {
                                                                            return CanvasXpress.selector.comp.hasOwnProperty(q + "::" + h)
                                                                        }
                                                                    }
                                                                } else {
                                                                    if (this.graphType == "Treemap" || this.graphType == "Pie") {
                                                                        var o = this.graphType.toLowerCase();
                                                                        var f = this.graphType == "Treemap" ? this.getSampleIndices(w) : this.getVariableIndices(q);
                                                                        if (f >= 0 && this.data.y[o]) {
                                                                            for (var r = 0; r < this.data.y[o][f].length; r++) {
                                                                                var u = this.dataStndBy.y.smps[this.data.y[o][f][r]];
                                                                                if (CanvasXpress.selector.smps.hasOwnProperty(u)) {
                                                                                    return true
                                                                                }
                                                                            }
                                                                        }
                                                                        return false
                                                                    } else {
                                                                        switch (this.graphType) {
                                                                            case "Heatmap":
                                                                                return CanvasXpress.selector.comp.hasOwnProperty(q + "::" + w);
                                                                            case "Boxplot":
                                                                                if (this.showBoxplotOriginalData) {
                                                                                    return CanvasXpress.selector.comp.hasOwnProperty(q + "::" + w)
                                                                                } else {
                                                                                    return CanvasXpress.selector.vars.hasOwnProperty(q) && CanvasXpress.selector.smps.hasOwnProperty(w)
                                                                                }
                                                                                default:
                                                                                    if (this.data.y.vars.length == 1 || c == "Map" || this.layoutValid) {
                                                                                        return CanvasXpress.selector.smps.hasOwnProperty(w)
                                                                                    } else {
                                                                                        return CanvasXpress.selector.vars.hasOwnProperty(q) && CanvasXpress.selector.smps.hasOwnProperty(w)
                                                                                    }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.addRemoveToSelected = function(q, a, g) {
                                    var n = function(d, i, e) {
                                        if (!CanvasXpress.selector[i].hasOwnProperty(d)) {
                                            CanvasXpress.selector[i][d] = true;
                                            CanvasXpress.selector.selections++
                                        } else {
                                            if (CanvasXpress.selector[i][d]) {
                                                if (!e) {
                                                    delete CanvasXpress.selector[i][d];
                                                    CanvasXpress.selector.selections--
                                                }
                                            } else {
                                                CanvasXpress.selector[i][d] = true;
                                                CanvasXpress.selector.selections++
                                            }
                                        }
                                    };
                                    if (a && (a.y || a.w)) {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.isCreateHistogram) {
                                                var f = q[1] - 1;
                                                for (var b = 0; b < a.y.histogram[f].length; b++) {
                                                    var r = this.dataStndBy.y.vars[a.y.histogram[f][b]];
                                                    n(r, "vars")
                                                }
                                                n(this.data.y.vars[q[0]] + "::" + this.data.y.smps[q[1]] + "::" + this.data.y.smps[q[2]], "comp")
                                            } else {
                                                if (this.xAxisIndices.length > 1 || this.yAxisIndices.length > 1) {
                                                    if (a.y.comp) {
                                                        for (var f in a.y.comp) {
                                                            n(f, "comp")
                                                        }
                                                    } else {
                                                        for (var f = 0; f < a.y.vars.length; f++) {
                                                            n(a.y.vars[f] + "::" + a.y.smps[0] + "::" + a.y.smps[1], "comp")
                                                        }
                                                    }
                                                }
                                                if (a.y.vars) {
                                                    for (var f = 0; f < a.y.vars.length; f++) {
                                                        n(a.y.vars[f], "vars")
                                                    }
                                                }
                                                if (a.y.smps) {
                                                    for (var f = 0; f < a.y.smps.length; f++) {
                                                        n(a.y.smps[f], "smps", this.getKeys(CanvasXpress.selector.vars).length)
                                                    }
                                                }
                                            }
                                        } else {
                                            var p = this.graphType.toLowerCase();
                                            if (this.data.y[p]) {
                                                if (!CanvasXpress.selector.meta.hasOwnProperty(a.y.vars[0])) {
                                                    CanvasXpress.selector.meta[a.y.vars[0]] = {}
                                                }
                                                if (a.y && !CanvasXpress.selector.meta[a.y.vars[0]].hasOwnProperty(a.y.smps[0])) {
                                                    CanvasXpress.selector.meta[a.y.vars[0]][a.y.smps[0]] = true
                                                } else {
                                                    if (a.y) {
                                                        CanvasXpress.selector.meta[a.y.vars[0]][a.y.smps[0]] = CanvasXpress.selector.meta[a.y.vars[0]][a.y.smps[0]] ? false : true
                                                    }
                                                }
                                                var f = this.graphType == "Pie" ? this.getVariableIndices(a.y.vars[0]) : this.graphType == "Treemap" ? this.getSampleIndices(a.y.smps[0]) : this.getSampleIndices(a.y.smps[0]);
                                                for (var t = 0; t < this.data.y[p][f].length; t++) {
                                                    var r = this.dataStndBy.y.smps[this.data.y[p][f][t]];
                                                    n(r, "smps")
                                                }
                                            } else {
                                                if (this.isGroupedData && a.objectType && a.objectType == "Stack" && a.y && a.w) {
                                                    n(a.y.vars[0], "vars");
                                                    for (var f = 0; f < a.y.smps.length; f++) {
                                                        n(a.y.smps[f], "smps")
                                                    }
                                                    n(a.y.vars[0] + "::" + a.w.smps[0] + "::" + this.stackBy + "::" + a.stack, "comp")
                                                }
                                                if (this.isGroupedData && a.w) {
                                                    if ((this.graphType.match(/Dotplot/) || (this.graphType == "Boxplot" && this.showBoxplotOriginalData)) && a.y) {
                                                        n(a.y.vars, "vars");
                                                        n(a.y.smps, "smps")
                                                    } else {
                                                        for (var f = 0; f < a.w.vars.length; f++) {
                                                            n(a.w.vars[f], "vars")
                                                        }
                                                        for (var f = 0; f < a.w.grps.length; f++) {
                                                            for (var b = 0; b < a.w.grps[f].length; b++) {
                                                                n(this.data.y.smps[a.w.grps[f][b]], "smps")
                                                            }
                                                        }
                                                    }
                                                    n(this.groupingFactors.join("::") + "::" + a.w.smps.join("::"), "meta");
                                                    n(a.w.vars.join("::") + "::" + a.w.smps.join("::"), "comp")
                                                } else {
                                                    if (this.graphType.match(/Heatmap/)) {
                                                        for (var f = 0; f < a.y.vars.length; f++) {
                                                            for (var b = 0; b < a.y.smps.length; b++) {
                                                                n(a.y.vars[f] + "::" + a.y.smps[b], "comp")
                                                            }
                                                        }
                                                    }
                                                    if (a.y.vars) {
                                                        for (var f = 0; f < a.y.vars.length; f++) {
                                                            n(a.y.vars[f], "vars")
                                                        }
                                                    }
                                                    if (a.y.smps) {
                                                        for (var f = 0; f < a.y.smps.length; f++) {
                                                            n(a.y.smps[f], "smps")
                                                        }
                                                    }
                                                    if (this.graphType == "Map" && q && q[0] && q[0].toString().match(":")) {
                                                        n(q[0].split(":")[1], "mixed")
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        if (a && a.objectType == "Histogram" && this.xAxisIndices.length == this.yAxisIndices.length && this.xAxisIndices.length > 1) {
                                            var k = this[a.a].cntx[a.d];
                                            var m = k[0];
                                            var l = k[1];
                                            var r = this[a.a].histogram[a.b][a.c - 1];
                                            for (var f = 0; f < r.length; f++) {
                                                n(this.data.y.vars[r[f]] + "::" + this.data.y.smps[m] + "::" + this.data.y.smps[l], "comp")
                                            }
                                            for (var f = 0; f < r.length; f++) {
                                                n(this.data.y.vars[r[f]], "vars")
                                            }
                                            n(this.data.y.smps[m], "smps");
                                            n(this.data.y.smps[l], "smps")
                                        } else {
                                            if (a && a.nodes) {
                                                for (var f = 0; f < a.nodes.length; f++) {
                                                    n(a.nodes[f].id, "nodes");
                                                    if (a.nodes[f].name) {
                                                        n(a.nodes[f].name, "mixed")
                                                    }
                                                    if (a.nodes[f].label) {
                                                        n(a.nodes[f].label, "mixed")
                                                    }
                                                }
                                            } else {
                                                if (q) {
                                                    this.addRemoveToSelected(false, this.extractDataObject(q), g)
                                                } else {
                                                    if (a && a.idx && this.graphType == "Map") {
                                                        n(a.idx, "vars");
                                                        n(a.idx, "mixed")
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (CanvasXpress.selector.selections) {
                                        CanvasXpress.selector.graphType = this.graphType
                                    }
                                    if (a) {
                                        if (this.userEvents.select) {
                                            if (a.y) {
                                                var r = this.getVariableIndices(this.getKeys(CanvasXpress.selector.vars));
                                                var u = this.getSampleIndices(this.getKeys(CanvasXpress.selector.smps));
                                                var h = this.extractDataObject(u, r);
                                                this.userEvents.select.call(this, h, g, this)
                                            } else {
                                                if (a.nodes) {
                                                    this.userEvents.select.call(this, a, g, this)
                                                } else {
                                                    this.userEvents.select.call(this, a, g, this)
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawSelectedLabel = function(b, a, c) {
                                    if (this.isSelected(b)) {
                                        if (this.selectionMode == "name") {
                                            if (this.selectionMetadata && this.data.z && this.data.z[this.selectionMetadata]) {
                                                lab = this.data.z[this.selectionMetadata][b[0]] || this.data.y.vars[b[0]]
                                            } else {
                                                lab = this.data.y.vars[b[0]]
                                            }
                                            this.toRender({
                                                p: ["drawText", lab, a, c, this.varLabelFont, this.foreground, "center", "middle"],
                                                t: "Labels"
                                            })
                                        }
                                    }
                                };
                                this.resetSelected = function(b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (CanvasXpress.selector.selections) {
                                        var f = {
                                            y: {
                                                vars: [],
                                                smps: [],
                                                data: []
                                            }
                                        };
                                        var d = {
                                            nodes: [],
                                            edges: []
                                        };
                                        var c = this.getKeys(CanvasXpress.selector.vars).length ? f : d;
                                        CanvasXpress.selector = {
                                            meta: {},
                                            vars: {},
                                            smps: {},
                                            comp: {},
                                            nodes: {},
                                            edges: {},
                                            mixed: {},
                                            selections: 0,
                                            graphType: false
                                        };
                                        if (this.userEvents.select) {
                                            this.userEvents.select.call(this, c, b, this)
                                        }
                                        if (!a) {
                                            this.broadcastDraw({
                                                func: "resetSelected",
                                                par: [b, a]
                                            })
                                        }
                                    }
                                };
                                this.getSelectedExcludedFromRender = function(d) {
                                    if (!this.graphType.match(/Scatter/)) {
                                        return false
                                    }
                                    var c = this.graphType.match(/Scatter2D/) ? d[1] + ":" + d[2] : d[1] + ":" + d[2] + ":" + d[3];
                                    var e = this.graphType.match(/Scatter2D/) && this.meta.data.d.a.hasOwnProperty(c) ? this.meta.data.d.a[c] : {
                                        skip: {},
                                        density: {}
                                    };
                                    var a = [];
                                    if (e.density.hasOwnProperty(d[0])) {
                                        for (var b in e.skip) {
                                            if (e.skip[b] == d[0]) {
                                                a.push(Number(b))
                                            }
                                        }
                                    }
                                    return a
                                }
                            };
                            CanvasXpress.prototype.initDendrogramEvents = function() {
                                this.zoomDendrogram = function(a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (!a || !a.objectType || !a.objectType.match(/Dendrogram/)) {
                                        return false
                                    }
                                    var g = function(l) {
                                        if (l.children) {
                                            for (var k = 0; k < l.children.length; k++) {
                                                g(l.children[k])
                                            }
                                        } else {
                                            e.push(l.idx)
                                        }
                                        return e
                                    };
                                    var d = function(l) {
                                        if (!b) {
                                            if (l.nodeId != null && l.nodeId == a.nodeId) {
                                                b = true;
                                                f = l
                                            }
                                            if (l.children) {
                                                for (var k = 0; k < l.children.length; k++) {
                                                    d(l.children[k])
                                                }
                                            }
                                        }
                                    };
                                    var e = [];
                                    var f = {};
                                    var b = false;
                                    var j = this[a.objectType];
                                    d(j);
                                    this.setOriginalIndices();
                                    var h = this.layoutComb ? this.layoutParams[a.c || 0] : this;
                                    if (a.objectType == "varDendrogram") {
                                        h.varIndices = g(f);
                                        for (var c = 0; c < h.startingVarIndices.length; c++) {
                                            if (h.startingVarIndices[c] == h.varIndices[0]) {
                                                h.varIndicesStart = c;
                                                break
                                            }
                                        }
                                    } else {
                                        if (this.isGroupedData) {
                                            h.grpIndices = g(f);
                                            for (var c = 0; c < h.startingGrpIndices.length; c++) {
                                                if (h.startingGrpIndices[c] == h.grpIndices[0]) {
                                                    h.grpIndicesStart = c;
                                                    break
                                                }
                                            }
                                        } else {
                                            h.smpIndices = g(f);
                                            for (var c = 0; c < h.startingSmpIndices.length; c++) {
                                                if (h.startingSmpIndices[c] == h.smpIndices[0]) {
                                                    h.smpIndicesStart = c;
                                                    break
                                                }
                                            }
                                        }
                                    }
                                    this.draw({
                                        func: "zoomDendrogram",
                                        par: [a]
                                    })
                                };
                                this.modifyDendrogram = function(g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (!g || !g.objectType || !g.objectType.match(/Dendrogram/)) {
                                        return false
                                    }
                                    var c = function(k) {
                                        if (k.children) {
                                            for (var j = 0; j < k.children.length; j++) {
                                                c(k.children[j])
                                            }
                                        } else {
                                            b.push(k.idx)
                                        }
                                        return b
                                    };
                                    var e = function(k) {
                                        if (!d) {
                                            if (k.nodeId != null && k.nodeId == g.nodeId) {
                                                k.children.reverse();
                                                d = true
                                            }
                                            if (k.children) {
                                                for (var j = 0; j < k.children.length; j++) {
                                                    e(k.children[j])
                                                }
                                            }
                                        }
                                    };
                                    var b = [];
                                    var d = false;
                                    var a = this[g.objectType];
                                    var h = g.objectType + "Newick";
                                    this.setOriginalIndices();
                                    e(a);
                                    this[h] = this.writeNewick(a);
                                    var f = this.layoutComb ? this.layoutParams[g.c || 0] : this;
                                    if (g.objectType == "varDendrogram") {
                                        f.startingVarIndices = c(a)
                                    } else {
                                        if (this.isGroupedData) {
                                            f.startingGrpIndices = c(a)
                                        } else {
                                            f.startingSmpIndices = c(a)
                                        }
                                    }
                                    this.draw({
                                        func: "modifyDendrogram",
                                        par: [g]
                                    })
                                }
                            };
                            CanvasXpress.prototype.initCanvasEvents = function() {
                                this.moveCanvas = function(a, b) {
                                    var d = this.remoteService ? this.$(this.remoteParentId + "-canvasXpressRemoteWindow") : this.$("container-" + this.target);
                                    if (d) {
                                        d.style.left = a;
                                        d.style.top = b
                                    }
                                };
                                this.contextmenuCanvas = function(a) {
                                    return function(b) {
                                        if (b) {
                                            if (a.motioningOn) {
                                                a.stopEvent(b)
                                            } else {
                                                if (b.ctrlKey) {
                                                    a.cancelEvent(b);
                                                    a.clickCanvas(b)
                                                } else {
                                                    a.cancelEvent(b);
                                                    a.handleMouseEvents(b, "contextmenu", a.isEventIndices(b))
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.mousedownCanvas = function(a) {
                                    return function(c) {
                                        if (a.motioningOn) {
                                            a.stopEvent(c)
                                        } else {
                                            if (CanvasXpress.system.isTouchScreen && c.type == "touchstart") {
                                                if (c.preventDefault) {
                                                    c.preventDefault()
                                                } else {
                                                    c.returnValue = false
                                                }
                                                a.touchEvent = "click";
                                                if (!a.touches) {
                                                    a.touches = []
                                                }
                                                for (var b = 0; b < c.touches.length; b++) {
                                                    var d = c.touches[b].identifier;
                                                    if (!a.touches[d]) {
                                                        a.touches[d] = a.cleanTouchEvent(c.touches[b])
                                                    }
                                                }
                                                if (!a.tapBuffer) {
                                                    a.tapBuffer = setTimeout(function() {
                                                        a.tapBuffer = null
                                                    }, 200)
                                                } else {
                                                    clearTimeout(a.tapBuffer);
                                                    a.tapBuffer = null;
                                                    a.touchEvent = a.touches.length > 1 ? "contextmenu" : "dblclick";
                                                    a.registerDrag(c)
                                                }
                                            } else {
                                                if (c && c.which ? c.which != 3 : c && c.button ? c.button != 2 : false) {
                                                    if (!a.configuringOn) {
                                                        a.registerDrag(c)
                                                    }
                                                }
                                            }
                                        }
                                        return false
                                    }
                                }(this);
                                this.clickCanvas = function(a) {
                                    return function(b) {
                                        if (a.isIE) {
                                            b = a.copyEvent(b)
                                        }
                                        a.resetMenus();
                                        a.resetLinks();
                                        a.clickBuffer = function() {
                                            if (a.motioningOn) {
                                                a.stopEvent(b);
                                                return false
                                            } else {
                                                if (!a.doubleClick) {
                                                    if (!a.configuringOn) {
                                                        if (!a.skipClick) {
                                                            a.handleMouseEvents(b, "click", a.isEventIndices(b))
                                                        }
                                                    } else {
                                                        a.resetConfigurator(b)
                                                    }
                                                    a.lastCanvasEvent = "click"
                                                }
                                            }
                                        };
                                        setTimeout(a.clickBuffer, 250);
                                        setTimeout(function() {
                                            a.doubleClick = false
                                        }, 500)
                                    }
                                }(this);
                                this.dblclickCanvas = function(a) {
                                    return function(c) {
                                        a.doubleClick = true;
                                        if (a.motioningOn) {
                                            a.stopEvent(c);
                                            return false
                                        } else {
                                            if (a.clickBuffer) {
                                                clearTimeout(a.clickBuffer);
                                                a.clickBuffer = null
                                            }
                                        }
                                        if (!a.skipClick) {
                                            var b = a.isEventIndices(c);
                                            if (b) {
                                                a.handleMouseEvents(c, "dblclick", b)
                                            } else {
                                                a.cancelEvent(c);
                                                a.addConfigurator(c)
                                            }
                                            a.lastCanvasEvent = "dblclick"
                                        }
                                        return false
                                    }
                                }(this);
                                this.wheelCanvas = function(a) {
                                    return function(f, h, b) {
                                        if (a.motioningOn) {
                                            a.stopEvent(f);
                                            return false
                                        } else {
                                            if (a.lastWheel) {
                                                if (new Date().getTime() - a.lastWheel < 20) {
                                                    a.cancelEvent(f);
                                                    return false
                                                }
                                            }
                                        }
                                        a.lastWheel = new Date().getTime();
                                        var g = 0;
                                        if (f.wheelDelta) {
                                            g = f.wheelDelta / 120;
                                            if (window.opera) {
                                                g = -g
                                            }
                                        } else {
                                            if (f.detail) {
                                                g = -f.detail / 3
                                            } else {
                                                if (h) {
                                                    g = h
                                                }
                                            }
                                        }
                                        if (g) {
                                            a.handleWheelEvent(f, g, b)
                                        }
                                    }
                                }(this);
                                this.dropCanvas = function(a) {
                                    return function(k) {
                                        a.cancelEvent(k);
                                        var j = k.dataTransfer;
                                        var h = k.dataTransfer.getData("text/html");
                                        var g = k.dataTransfer.getData("text/uri-list");
                                        if (a.motioningOn || a.mousePositioning) {
                                            a.stopEvent(k);
                                            return false
                                        } else {
                                            if (j && j.files.length > 0) {
                                                a.loadFile(j)
                                            } else {
                                                if (j && g) {
                                                    var m = a.newId("-cX-data-url-");
                                                    var b = function() {
                                                        var d = CanvasXpress.$(m);
                                                        var e = d.$("container-" + m);
                                                        e.style.display = "block"
                                                    };
                                                    a.dataURL = g;
                                                    a.getDataFromURLOrString(m, false, false, false, b)
                                                } else {
                                                    if (h.match(/img.+src=.+png/)) {
                                                        var l = a.$cX("div");
                                                        l.innerHTML = h;
                                                        var g = l.firstChild.src;
                                                        var c = function() {
                                                            return function(e) {
                                                                var d = new FileReader();
                                                                d.onloadend = function() {
                                                                    var f = a.parseDataFromPNG(this.result);
                                                                    f.uploadFile = true;
                                                                    a.remoteServiceType = "file";
                                                                    a.updateRemoteData(f)
                                                                };
                                                                d.readAsArrayBuffer(e)
                                                            }
                                                        }(a);
                                                        a.ajaxRequest(g, false, c, "blob")
                                                    }
                                                }
                                            }
                                        }
                                        this.className = "CanvasXpress"
                                    }
                                }(this);
                                this.dragEnterCanvas = function(a) {
                                    return function(b) {
                                        if (!a.motioningOn && !a.mousePositioning) {
                                            a.cancelEvent(b);
                                            this.className = "CanvasXpressUpload";
                                            return false
                                        }
                                    }
                                }(this);
                                this.dragOverCanvas = function(a) {
                                    return function(b) {
                                        if (!a.motioningOn && !a.mousePositioning) {
                                            a.cancelEvent(b);
                                            this.className = "CanvasXpressUpload";
                                            return false
                                        }
                                    }
                                }(this);
                                this.dragLeaveCanvas = function(a) {
                                    return function(b) {
                                        this.className = "CanvasXpress";
                                        return false
                                    }
                                }(this);
                                this.addRemoveCanvasListeners = function(a) {
                                    var b = this.meta.canvas.ctx2.canvas;
                                    this[a](b, "contextmenu", this.contextmenuCanvas, false);
                                    this[a](b, "mousedown", this.mousedownCanvas, false);
                                    this[a](b, "touchstart", this.mousedownCanvas, {
                                        passive: false
                                    });
                                    this[a](b, "click", this.clickCanvas, false);
                                    this[a](b, "dblclick", this.dblclickCanvas, false);
                                    this[a](b, "mousewheel", this.wheelCanvas, {
                                        passive: false
                                    });
                                    this[a](b, "drop", this.dropCanvas, false);
                                    this[a](b, "dragenter", this.dragEnterCanvas, false);
                                    this[a](b, "dragover", this.dragOverCanvas, false);
                                    this[a](b, "dragleave", this.dragLeaveCanvas, false)
                                };
                                this.isVersion = function(b) {
                                    if (this.showVersion) {
                                        var a = this.adjustedCoordinates(b);
                                        return a && a.x >= 0 && a.x <= 13 && a.y >= 0 && a.y <= 13 ? true : false
                                    }
                                };
                                this.isHelp = function(b) {
                                    var a = this.adjustedCoordinates(b);
                                    return a && a.x > 0 && a.x <= 13 && a.y > 0 && a.y <= 13 ? true : false
                                };
                                this.handleWheelEvent = function(E, G, K) {
                                    if (this.isTransition() || this.disableWheel) {
                                        return
                                    }
                                    this.skipTransition = true;
                                    var D = this.getTargetEvent(E);
                                    if (D && /CanvasXpress/.test(D.className)) {
                                        CanvasXpress.current = D.id
                                    }
                                    var f = {
                                        panningX: this.panningX,
                                        panningY: this.panningY
                                    };
                                    if (this.graphType == "Correlation" || this.graphType == "Heatmap" || (this.graphType.match(/Bar|Line|Dotplot|Boxplot|Area|Stacked/) && !this.is3DPlot)) {
                                        this.cancelEvent(E);
                                        if (this.layoutComb && !this.layoutAdjust && this.graphType != "Correlation" && this.graphType != "Heatmap") {
                                            return false
                                        }
                                        this.setIndicesAfterWheelEvent(E, G)
                                    } else {
                                        if (this.graphType == "Scatter2D" || this.graphType == "ScatterBubble2D" || this.graphType == "Genome") {
                                            this.cancelEvent(E);
                                            if (this.graphType == "Genome" && this.xAxisUnit > 100 && G > 0) {
                                                return
                                            }
                                            this.setRangesAfterWheelEvent(E, G)
                                        } else {
                                            if (this.graphType == "Scatter3D" || this.is3DPlot) {
                                                this.cancelEvent(E);
                                                if (!K) {
                                                    K = this.adjustedCoordinates(E);
                                                    E.ac = {
                                                        x: K.x,
                                                        y: K.y
                                                    }
                                                }
                                                if (K) {
                                                    K.x -= (this.marginLeft + this.left);
                                                    K.y -= (this.marginTop + this.top);
                                                    var z = (Math.min(Math.max(K.x, 0), this.x) / this.x) - 0.5;
                                                    var w = (Math.min(Math.max(K.y, 0), this.y) / this.y) - 0.5
                                                }
                                                if (G > 0) {
                                                    if (this.zoom >= 4) {
                                                        return
                                                    }
                                                    this.zoom *= 1.1;
                                                    this.padX -= z * this.padX / 4;
                                                    this.padY -= w * this.padY / 4
                                                } else {
                                                    if (this.zoom <= 0.5) {
                                                        return
                                                    }
                                                    this.zoom *= 0.9;
                                                    this.padX += z * this.padX / 4;
                                                    this.padY += w * this.padY / 4
                                                }
                                                this.draw({
                                                    func: "handleWheelEvent",
                                                    par: [E, G, K],
                                                    prop: f
                                                })
                                            } else {
                                                if (this.graphType == "Network") {
                                                    this.cancelEvent(E);
                                                    if (!K) {
                                                        K = this.adjustedCoordinates(E);
                                                        E.ac = {
                                                            x: K.x,
                                                            y: K.y
                                                        }
                                                    }
                                                    if (K) {
                                                        if (E.type == "keydown") {
                                                            K.x = this.width / 2;
                                                            K.y = this.height / 2
                                                        }
                                                        var c = (K.x / this.scaleFactorX) - this.offsetX;
                                                        var b = (K.y / this.scaleFactorY) - this.offsetY;
                                                        var l = this.scaleFactorX * this.zoomStep;
                                                        var k = this.scaleFactorY * this.zoomStep;
                                                        var B = Math.min(l, k);
                                                        var h = Math.abs(G > 0 ? this.zoom + B : this.zoom - B);
                                                        var v = this.networkFreeze ? Math.min(this.scaleFactorX, this.scaleFactorY) * h : Math.min(this.x / (this.maxX - this.minX), this.y / (this.maxY - this.minY)) * h;
                                                        var s = v;
                                                        var M = this.x / v;
                                                        var L = this.y / s;
                                                        var i = ((M / 2) - ((this.minX + this.maxX) / 2)) + (this.left / v);
                                                        var g = ((L / 2) - ((this.minY + this.maxY) / 2)) + (this.top / s);
                                                        var H = (K.x / v) - i;
                                                        var F = (K.y / s) - g;
                                                        var r = (H - c);
                                                        var q = (F - b);
                                                        this.panningX = r;
                                                        this.panningY = q;
                                                        this.zoom = h;
                                                        this.draw({
                                                            network: true,
                                                            func: "handleWheelEvent",
                                                            par: [E, G, K],
                                                            prop: f
                                                        })
                                                    }
                                                } else {
                                                    if (this.graphType == "Circular") {
                                                        this.cancelEvent(E);
                                                        if (!K) {
                                                            K = this.adjustedCoordinates(E);
                                                            E.ac = {
                                                                x: K.x,
                                                                y: K.y
                                                            }
                                                        }
                                                        if (K) {
                                                            var A = (this.width / 2);
                                                            var u = (this.height / 2);
                                                            var p = A - K.x;
                                                            var o = u - K.y;
                                                            var J = G > 0 ? -1 : 1;
                                                            var t = 0.1;
                                                            var a = 1 * J * t;
                                                            this.panningX += p * a * 2;
                                                            this.panningY += o * a * 2;
                                                            this.zoom += a;
                                                            this.draw({
                                                                func: "handleWheelEvent",
                                                                par: [E, G, K],
                                                                prop: f
                                                            })
                                                        }
                                                    } else {
                                                        if (this.graphType == "Map" && !this.layoutComb) {
                                                            this.cancelEvent(E);
                                                            if (!K) {
                                                                K = this.adjustedCoordinates(E);
                                                                E.ac = {
                                                                    x: K.x,
                                                                    y: K.y
                                                                }
                                                            }
                                                            if (K) {
                                                                if (this.mapProjection == "orthographic") {
                                                                    this.zoom += G > 0 ? this.zoom * 0.1 : this.zoom * -0.1
                                                                } else {
                                                                    this.panningX = 0;
                                                                    this.panningY = 0;
                                                                    var C = this.meta.map.geojson;
                                                                    var a = C.zoom + (G > 0 ? 0.1 : -0.1);
                                                                    var N = Math.pow(2, a) / Math.pow(2, C.zoom);
                                                                    var n = ((this.width / 2) + ((K.x - (this.width / 2)) * (1 - 1 / N)));
                                                                    var m = ((this.height / 2) + ((K.y - (this.height / 2)) * (1 - 1 / N)));
                                                                    var I = this.mapPointToCoordinate([n + C.center[0], m + C.center[1]]);
                                                                    C.geometry.zoom = a;
                                                                    C.geometry.center = I;
                                                                    C.isZoomed = true
                                                                }
                                                                this.draw({
                                                                    func: "handleWheelEvent",
                                                                    par: [E, G, K],
                                                                    prop: f
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.userEvents.wheel) {
                                        this.userEvents.wheel.call(this, E, G, this)
                                    }
                                    return false
                                };
                                this.getTreeNode = function(e) {
                                    if (e != null) {
                                        e = e.toString().replace("Tree-Node:", "");
                                        var b = this.data.tree.plot.descendants();
                                        var a = b.length;
                                        for (var c = 0; c < a; c++) {
                                            var d = b[c];
                                            if (d.id == e) {
                                                return d
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.handleTreeClick = function(b) {
                                    if (b) {
                                        var a = false;
                                        var c = this.getTreeNode(b.id);
                                        if (c) {
                                            a = true;
                                            this.data.tree.click = c;
                                            if (c.children) {
                                                c._children = c.children;
                                                c.children = null
                                            } else {
                                                c.children = c._children;
                                                c._children = null
                                            }
                                        }
                                        if (a) {
                                            this.draw({
                                                func: "handleTreeClick",
                                                par: [b]
                                            })
                                        }
                                    }
                                };
                                this.handleDOEClick = function(a) {
                                    var b = a ? this.extractDataObject(a) : false;
                                    if (this.isDOE && a && this.layoutValidN) {
                                        if (a[0].toString().match(/legend|PieVar/)) {
                                            return false
                                        } else {
                                            if (b && b.w) {
                                                if (b.y) {
                                                    this.dataStndBy.l.doe = [a[2]]
                                                } else {
                                                    this.dataStndBy.l.doe = b.w.grps[0]
                                                }
                                            } else {
                                                if (b && b.y.pie) {
                                                    this.dataStndBy.l.doe = b.y.pie[0]
                                                } else {
                                                    if (b && b.y.treemap) {
                                                        this.dataStndBy.l.doe = b.y.treemap[0];
                                                        this.dataStndBy.l.treemap = b.y.smps[0]
                                                    } else {
                                                        if (b && b.y.histogram) {
                                                            this.dataStndBy.l.doe = b.y.histogram[0]
                                                        } else {
                                                            if (a && a[1]) {
                                                                this.dataStndBy.l.doe = [a[1]]
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.draw({
                                            func: "handleDOEClick",
                                            par: [a]
                                        })
                                    }
                                };
                                this.handleChordMouseOver = function(a) {
                                    if (a) {
                                        this.highlightCanvas(this.getKeys(this.circularChord.segments[a.id].ribbons))
                                    }
                                };
                                this.getEventAreaData = function(a) {
                                    return this.extractDataObject(this.isEventIndices(a))
                                };
                                this.handleMouseEvents = function(c, b, a) {
                                    if (this.isTransition()) {
                                        return false
                                    }
                                    if (this.layoutComb) {
                                        this.setActiveLayout(c);
                                        if (!this.layoutValidN == null) {
                                            return false
                                        }
                                    }
                                    var d = a ? this.extractDataObject(a) : false;
                                    if (this.userEvents[b]) {
                                        if (typeof(this.userEvents[b]) == "object" && this.userEvents[b].handler && this.userEvents[b].scope) {
                                            this.userEvents[b].handler.apply(this.userEvents[b].scope, [d, c, this, a])
                                        } else {
                                            if (typeof(this.userEvents[b]) == "object" && this.userEvents[b].handler) {
                                                this.userEvents[b].handler(d, c, this, a)
                                            } else {
                                                this.userEvents[b](d, c, this, a)
                                            }
                                        }
                                    }
                                    return d && d.objectType == "Chord"
                                };
                                this.formatCoords = function(m, g) {
                                    var b = [];
                                    var f = g.length;
                                    if (this.graphType != "Network") {
                                        for (var d = 0; d < f; d++) {
                                            if (d % 2) {
                                                b.push(this.sprintf("%.0f", (g[d] + this.translateY) * this.scaleY))
                                            } else {
                                                if (this.layoutValid && m == "circle" && d == 2) {
                                                    b.push(this.sprintf("%.0f", g[d] * ((this.scaleX + this.scaleY) / 2)))
                                                } else {
                                                    b.push(this.sprintf("%.0f", (g[d] + this.translateX) * this.scaleX))
                                                }
                                            }
                                        }
                                    } else {
                                        for (var d = 0; d < f; d++) {
                                            b.push(this.sprintf("%.0f", parseInt(g[d])))
                                        }
                                    }
                                    if (m == "rect") {
                                        var a = Math.min(b[0], b[2]);
                                        var k = Math.min(b[1], b[3]);
                                        var j = Math.max(b[0], b[2]);
                                        var e = Math.max(b[1], b[3]);
                                        b = [a, k, j, e]
                                    }
                                    return b.join(",")
                                };
                                this.drawArea = function(k) {
                                    var m = this.meta.canvas.ctx2;
                                    m.strokeStyle = "red";
                                    m.fillStyle = "green";
                                    m.lineWidth = 2;
                                    var f = [];
                                    var e = this.meta.render.objects;
                                    var h = e.length;
                                    if (k) {
                                        f.push(k)
                                    } else {
                                        for (var d = 0; d < h; d++) {
                                            if (e[d].idx) {
                                                f.push(d)
                                            }
                                        }
                                    }
                                    var l = f.length;
                                    for (var d = 0; d < l; d++) {
                                        var b = this.cloneObject(e[f[d]]);
                                        if (b.idx) {
                                            var g = b.area;
                                            switch (g[0]) {
                                                case "rect":
                                                    m.beginPath();
                                                    m.moveTo(g[1], g[2]);
                                                    m.lineTo(g[3], g[2]);
                                                    m.lineTo(g[3], g[4]);
                                                    m.lineTo(g[1], g[4]);
                                                    m.closePath();
                                                    m.stroke();
                                                    break;
                                                case "circle":
                                                    m.beginPath();
                                                    m.arc(g[1], g[2], Math.abs(g[3]), 0, Math.PI * 2, true);
                                                    m.closePath();
                                                    m.stroke();
                                                    break;
                                                case "poly":
                                                    m.beginPath();
                                                    m.moveTo(g[1], g[2]);
                                                    m.arc(g[1], g[2], 5, 0, Math.PI * 2, true);
                                                    m.closePath();
                                                    m.fill();
                                                    m.beginPath();
                                                    m.moveTo(g[1], g[2]);
                                                    for (var c = 3; c < g.length; c += 2) {
                                                        m.lineTo(g[c], g[c + 1])
                                                    }
                                                    m.closePath();
                                                    m.stroke();
                                                    break
                                            }
                                        }
                                    }
                                };
                                this.adjustNetworkObjects = function(c) {
                                    if (c) {
                                        if (c[0] == "circle") {
                                            c[1] = this.adjustNetworkObjectX(c[1]);
                                            c[2] = this.adjustNetworkObjectY(c[2]);
                                            c[3] = c[3] * Math.min(this.scaleFactorX, this.scaleFactorY) * 0.75
                                        } else {
                                            var a = c.length;
                                            for (var b = 1; b < a; b++) {
                                                if (b % 2) {
                                                    c[b] = this.adjustNetworkObjectX(c[b])
                                                } else {
                                                    c[b] = this.adjustNetworkObjectY(c[b])
                                                }
                                            }
                                        }
                                    } else {
                                        return false
                                    }
                                    return c
                                };
                                this.adjustNetworkObjectFont = function(b) {
                                    var c = this.getFontPt(b);
                                    var a = Math.floor(c * Math.min(this.scaleFactorX, this.scaleFactorY));
                                    return b.replace(c, a)
                                };
                                this.adjustNetworkObjectX = function(a) {
                                    return (this.offsetX + a) * this.scaleFactorX
                                };
                                this.adjustNetworkObjectY = function(a) {
                                    return (this.offsetY + a) * this.scaleFactorY
                                };
                                this.adjustBackNetworkObjectX = function(a) {
                                    return (a / this.scaleFactorX) - this.offsetX
                                };
                                this.adjustBackNetworkObjectY = function(a) {
                                    return (a / this.scaleFactorY) - this.offsetY
                                };
                                this.adjustNetworkMouseDownX = function(a) {
                                    return (a - this.xMouseDown) / this.scaleFactorX
                                };
                                this.adjustNetworkMouseDownY = function(a) {
                                    return (a - this.yMouseDown) / this.scaleFactorY
                                };
                                this.clearHighlightCanvas = function() {
                                    this.meta.canvas.ctx2.canvas.width = this.width;
                                    this.meta.canvas.ctx2.canvas.height = this.height
                                };
                                this.highlightCanvas = function(d) {
                                    this.clearHighlightCanvas();
                                    this.isHighlightCanvas = true;
                                    var m = this.meta.render.objects;
                                    var l = function(f) {
                                        for (var c = f; c >= 0; c--) {
                                            if (m[c].func == "setClipArea") {
                                                return m[c].params[0]
                                            }
                                        }
                                        return false
                                    };
                                    var a = function() {
                                        for (var c = 0; c < v.length; c++) {
                                            if (m[v[c]].type == "Data") {
                                                return true
                                            }
                                        }
                                        return false
                                    };
                                    if (this.lassoSelected && this.lassoPoints && this.lassoPoints.length) {
                                        this.drawShape("polygon", this.lassoPoints[0], this.lassoPoints[1], false, false, "rgba(245,245,245,0.75)", "rgb(0,0,0)")
                                    } else {
                                        if (d) {
                                            var u = {
                                                polygon: true,
                                                path: true,
                                                spline: true,
                                                confidence: true,
                                                violin: true
                                            };
                                            var r = {
                                                Legends: true,
                                                Titles: true
                                            };
                                            var v = [];
                                            var b = d.length;
                                            for (var C = 0; C < b; C++) {
                                                v = v.concat(this.meta.render.groups[m[d[C]].group])
                                            }
                                            v = v.sort();
                                            var e = {};
                                            var F = false;
                                            var n = this.outlineWidth;
                                            if (this.highlightGreyOut && a()) {
                                                var x = "rgba(255,255,255," + this.highlightGreyOutTransparency + ")";
                                                this.drawShape("rectangle", this.width / 2, this.height / 2, this.width, this.height, x, x)
                                            }
                                            var q = v.length;
                                            var h = Math.PI * 2;
                                            for (var C = 0; C < q; C++) {
                                                if (!e[v[C]]) {
                                                    e[v[C]] = true;
                                                    var z = this.meta.render.objects[v[C]];
                                                    var E = z.func;
                                                    var y = this.cloneObject(z.params);
                                                    var D = this.graphType;
                                                    this.outlineWidth = n;
                                                    if (z && z.type.match(/Axes/)) {
                                                        continue
                                                    }
                                                    if (E && y) {
                                                        switch (E) {
                                                            case "drawLine":
                                                                if (y[1] == y[3]) {
                                                                    y[1] = (((y[1] + 0.5) << 1) >> 1) + 0.5;
                                                                    y[3] = y[1]
                                                                } else {
                                                                    if (y[2] == y[4]) {
                                                                        y[2] = (((y[2] + 0.5) << 1) >> 1) + 0.5;
                                                                        y[4] = y[2]
                                                                    }
                                                                }
                                                                if (D == "Network" && !this.preScaleNetwork) {
                                                                    y[1] = this.adjustNetworkObjectX(y[1]);
                                                                    y[2] = this.adjustNetworkObjectY(y[2]);
                                                                    y[3] = this.adjustNetworkObjectX(y[3]);
                                                                    y[4] = this.adjustNetworkObjectY(y[4]);
                                                                    if (this.isArray(y[12])) {
                                                                        pc = [];
                                                                        for (var B = 0; B < y[12].length; B++) {
                                                                            pc[B] = [];
                                                                            for (var A = 0; A < y[12][B].length; A++) {
                                                                                if (A % 2) {
                                                                                    pc[B][A] = this.adjustNetworkObjectY(y[12][B][A])
                                                                                } else {
                                                                                    pc[B][A] = this.adjustNetworkObjectX(y[12][B][A])
                                                                                }
                                                                            }
                                                                        }
                                                                        y[12] = pc
                                                                    }
                                                                    y[8] = y[8] * this.scaleFactorX;
                                                                    y[9] = y[9] * this.scaleFactorY
                                                                }
                                                                if (y[0] == "error") {
                                                                    this.outlineWidth = 3
                                                                } else {
                                                                    y[6] = y[6] ? parseFloat(y[6]) + 2 : 3
                                                                }
                                                                if (D != "Network" && !F) {
                                                                    this.setClipArea(y[11] ? y[11] : l(v[C]));
                                                                    F++
                                                                }
                                                                break;
                                                            case "drawShape":
                                                                if (typeof z.params[5] == "object") {
                                                                    y[5] = z.params[5]
                                                                }
                                                                if (D == "Network" && !this.preScaleNetwork && z.type != "Legends") {
                                                                    y[1] = this.adjustNetworkObjectX(y[1]);
                                                                    y[2] = this.adjustNetworkObjectY(y[2]);
                                                                    y[3] = (y[3] + 4) * this.scaleFactorX;
                                                                    y[4] = (y[4] + 4) * this.scaleFactorY
                                                                } else {
                                                                    if (u.hasOwnProperty(y[0])) {
                                                                        y[9] = 2
                                                                    } else {
                                                                        if (y[0] == "arch") {
                                                                            y[4][0] = parseFloat(y[4][0]) + 1;
                                                                            y[4][1] = parseFloat(y[4][1]) + 1
                                                                        } else {
                                                                            y[3] = parseFloat(y[3]) + 4;
                                                                            y[4] = parseFloat(y[4]) + 4
                                                                        }
                                                                    }
                                                                }
                                                                if (y[0] == "sphere" && this.isColorTransparent(y[5])) {
                                                                    y[5] = this.removeColorTransparency(y[5], true);
                                                                    y[6] = this.foreground;
                                                                    y[9] = 2
                                                                } else {
                                                                    if (y[0] == "bezier" && y[8] && this.isArray(y[8])) {
                                                                        y[5] = this.getLinearGradient(0, 0, y[3], 0, [y[8][0], y[8][1]]);
                                                                        y[6] = this.foreground
                                                                    } else {
                                                                        if (y[0] == "pie" && (y[12] % h) == (y[13] % h)) {
                                                                            y[0] = "sphere";
                                                                            y[5] = this.addColorTransparency(y[5], 0.7, true);
                                                                            y[6] = this.foreground;
                                                                            y[12] = false;
                                                                            y[13] = false
                                                                        } else {
                                                                            y[5] = this.addColorTransparency(y[5], 0.7, true);
                                                                            y[6] = this.foreground
                                                                        }
                                                                    }
                                                                }
                                                                if (D != "Network" && !F) {
                                                                    this.setClipArea(y[11] ? y[11] : l(v[C]));
                                                                    F++
                                                                }
                                                                break;
                                                            case "drawArcText":
                                                            case "drawText":
                                                                if (D == "Network" && !this.preScaleNetwork && z.type != "Legends") {
                                                                    y[1] = this.adjustNetworkObjectX(y[1]);
                                                                    y[2] = this.adjustNetworkObjectY(y[2]);
                                                                    y[3] = this.adjustNetworkObjectFont(y[3])
                                                                } else {
                                                                    y[1] -= 0;
                                                                    y[2] -= 0
                                                                }
                                                                break;
                                                            default:
                                                                this.isHighlightCanvas = false;
                                                                this.outlineWidth = n;
                                                                return
                                                        }
                                                        this[E].apply(this, y);
                                                        this.outlineWidth = n
                                                    }
                                                }
                                            }
                                            if (F) {
                                                this.resetClipArea()
                                            }
                                        }
                                    }
                                    this.isHighlightCanvas = false
                                };
                                this.flash = function(b, p, m, f, k, a) {
                                    var j = this.$cX("div", {
                                        id: this.target + "canvasXpressFlash" + new Date().getTime()
                                    }, {
                                        left: (b - (m / 2)) + "px",
                                        top: (p - (f / 2)) + "px",
                                        width: m + "px",
                                        height: f + "px",
                                        borderRadius: "999px",
                                        WebkitBorderRadius: "999px",
                                        MozBorderRadius: "999px",
                                        opacity: 0.6,
                                        filter: "alpha(opacity = 60)",
                                        position: "absolute",
                                        zIndex: 100000,
                                        display: "block",
                                        backgroundColor: k ? k : this.resizerBackgroundColor
                                    });
                                    this.meta.canvas.ctx.canvas.parentNode.appendChild(j);
                                    if (!a) {
                                        a = 3
                                    }
                                    var g = this;
                                    var e = 1;
                                    var o = function() {
                                        this.update = function() {
                                            if (e % 2) {
                                                j.style.display = "none"
                                            } else {
                                                j.style.display = "block"
                                            }
                                            if (e >= (a * 2)) {
                                                g.meta.canvas.ctx.canvas.parentNode.removeChild(j);
                                                clearInterval(c)
                                            }
                                            e++
                                        };
                                        var c = g.setInterval(this.update, 300)
                                    };
                                    o.call()
                                };
                                this.initializeCanvasEvents = function() {
                                    if (!this.disableEvents && !this.disableCanvas) {
                                        this.addRemoveCanvasListeners("addEvtListener")
                                    }
                                };
                                this.toRender = function(m) {
                                    var b = function(i) {
                                        return q && q.map.hasOwnProperty(i) ? q.map[i] : false
                                    };
                                    var n = m.p;
                                    var j = m.a;
                                    var o = m.i;
                                    var w = m.m;
                                    var k = m.g;
                                    var r = m.s;
                                    var c = m.b;
                                    var x = m.t;
                                    var e = m.h;
                                    var p = m.d;
                                    var g = this.meta.render;
                                    var q = g.transition;
                                    var v = n.shift();
                                    var a = v.match(/^draw/) ? v.replace("draw", "").substring(0, 1) : "O";
                                    var f = g.objects.length;
                                    var l = this.transparencyHidden;
                                    k = k != null ? k.toString() : f;
                                    if (!g.groups.hasOwnProperty(k)) {
                                        g.groups[k] = []
                                    }
                                    if (!g.types.hasOwnProperty(x)) {
                                        g.types[x] = {
                                            all: [],
                                            drawShape: [],
                                            drawLine: [],
                                            drawText: [],
                                            drawArcText: [],
                                            other: []
                                        }
                                    }
                                    if (!g.order.includes(x)) {
                                        g.order.push(x)
                                    }
                                    var u = g.types[x].hasOwnProperty(v) ? g.types[x][v].length : g.types[x].other.length;
                                    var s = o && this.isArray(o) ? o.join(":") : o ? o : x + ":" + a + ":" + this.padNumber(u);
                                    g.objects.push({
                                        func: v,
                                        params: n,
                                        idx: o,
                                        id: s,
                                        modifier: w,
                                        group: k,
                                        area: j,
                                        layout: (this.layoutComb ? this.layoutCurrent : false),
                                        type: x,
                                        skip: r,
                                        baseline: c
                                    });
                                    g.groups[k].push(f);
                                    g.types[x].all.push(f);
                                    switch (v) {
                                        case "drawShape":
                                            g.types[x].drawShape.push(f);
                                            break;
                                        case "drawLine":
                                            g.types[x].drawLine.push(f);
                                            break;
                                        case "drawText":
                                            g.types[x].drawText.push(f);
                                            break;
                                        case "drawArcText":
                                            g.types[x].drawText.push(f);
                                            break;
                                        default:
                                            g.types[x].other.push(f);
                                            break
                                    }
                                    if (k != f && v == "drawLine" && g.objects[k].idx) {
                                        if (!o) {
                                            o = g.objects[k].idx
                                        }
                                        s = o.join(":") + ":" + g.groups[k].length;
                                        g.objects[f].id = s;
                                        if (this.showBoxplotOriginalData) {}
                                    }
                                    g.origin[f] = [];
                                    if (x == "Data" && o && !this.graphType.match(/Scatter|Treemap/)) {
                                        if (this.isGroupedData) {
                                            if ((this.isDotplotGraph() && o[o.length - 1] != "box") || this.graphType.match(/Stacked/)) {
                                                s = o[0] + ":" + o[o.length - 1];
                                                g.map[s] = f;
                                                g.origin[f].push(b(s))
                                            } else {
                                                if (o.length == 2 && k == f) {
                                                    var d = this.data.w.grps[o[1]];
                                                    var h = d.length;
                                                    for (var t = 0; t < h; t++) {
                                                        s = o[0] + ":" + d[t];
                                                        g.map[s] = f;
                                                        g.origin[f].push(b(s))
                                                    }
                                                } else {
                                                    if (o.length == 3 && o[2] == "box") {
                                                        var d = this.data.w.grps[o[1]];
                                                        var h = d.length;
                                                        for (var t = 0; t < h; t++) {
                                                            s = o[0] + ":" + d[t] + ":box";
                                                            g.map[s] = f;
                                                            g.origin[f].push(b(s))
                                                        }
                                                    } else {
                                                        g.map[s] = f;
                                                        g.origin[f].push(b(s))
                                                    }
                                                }
                                            }
                                        } else {
                                            g.map[s] = f;
                                            g.origin[f].push(b(s))
                                        }
                                    } else {
                                        g.map[s] = f;
                                        g.origin[f].push(b(s))
                                    }
                                    if (CanvasXpress.graphTypes.OneTwoThreeeDGraphs.includes(this.graphType) || this.graphType == "TagCloud" || this.graphType == "Map") {
                                        if (e) {
                                            if (this.filterMode == "color") {
                                                switch (v) {
                                                    case "drawShape":
                                                        n[5] = this.missingDataColor;
                                                        n[6] = this.missingDataColor;
                                                        break;
                                                    case "drawLine":
                                                        n[5] = this.missingDataColor;
                                                        break;
                                                    case "drawText":
                                                        n[4] = this.missingDataColor;
                                                        break;
                                                    case "drawArcText":
                                                        n[7] = this.missingDataColor;
                                                        break
                                                }
                                            } else {
                                                switch (v) {
                                                    case "drawShape":
                                                        n[5] = this.addColorTransparency(n[5], l, true);
                                                        n[6] = this.addColorTransparency(n[6] || this.foreground, l, true);
                                                        break;
                                                    case "drawLine":
                                                        n[5] = this.addColorTransparency(n[5], l, true);
                                                        break;
                                                    case "drawText":
                                                        n[4] = this.addColorTransparency(n[4], l, true);
                                                        break;
                                                    case "drawArcText":
                                                        n[7] = this.addColorTransparency(n[7], l, true);
                                                        break
                                                }
                                            }
                                        }
                                    }
                                    if (this.debug || CanvasXpress.system.isRStudio || p) {
                                        this[v].apply(this, n)
                                    }
                                    return f
                                };
                                this.resetRender = function(b, c) {
                                    var a = this.meta.render;
                                    if (a.objects.length > 0 && !this.skipTransition) {
                                        delete(a.transition);
                                        if (!c) {
                                            a.transition = this.cloneObject(a)
                                        }
                                    }
                                    if (!b) {
                                        a.objects = [];
                                        a.groups = {};
                                        a.types = {};
                                        a.order = [];
                                        a.map = {};
                                        a.origin = []
                                    }
                                };
                                this.render = function(c, g) {
                                    if (!this.debug && !this.skipRender && !CanvasXpress.system.isRStudio) {
                                        this.meta.time.render.push(new Date().getTime());
                                        var a = this.getCanvasContext();
                                        var d = this.meta.render.objects;
                                        if (d.length > 0) {
                                            if (!c) {
                                                c = 0
                                            }
                                            if (!g) {
                                                g = d.length
                                            }
                                            for (var b = c; b < g; b++) {
                                                var h = d[b];
                                                var f = h.params;
                                                switch (h.func) {
                                                    case "drawShape":
                                                        this.drawShape(f[0], f[1], f[2], f[3], f[4], f[5], f[6], f[7], f[8], f[9], f[10], f[11], f[12], f[13], f[14], f[15], a);
                                                        break;
                                                    case "drawLine":
                                                        this.drawLine(f[0], f[1], f[2], f[3], f[4], f[5], f[6], f[7], f[8], f[9], f[10], f[11], f[12], f[13], f[14], f[15], f[16], a);
                                                        break;
                                                    case "drawText":
                                                        this.drawText(f[0], f[1], f[2], f[3], f[4], f[5], f[6], f[7], f[8], f[9], f[10], a);
                                                        break;
                                                    case "setClipArea":
                                                        this.setClipArea(f[0], a);
                                                        break;
                                                    case "resetClipArea":
                                                        this.resetClipArea(a);
                                                        break;
                                                    default:
                                                        this[h.func].apply(this, h.params);
                                                        break
                                                }
                                            }
                                        }
                                    }
                                };
                                this.initializeCanvasEvents()
                            };
                            CanvasXpress.prototype.initCleanupEvents = function() {
                                this.destroy = function(a, b) {
                                    if (a) {
                                        if (typeof(a) == "object" && a.target) {
                                            a = a.target
                                        }
                                        if (CanvasXpress.instances.length == 1 && CanvasXpress.instances[0].target == a) {
                                            return this.destroy(false, b)
                                        } else {
                                            this.removeInstance(a, b)
                                        }
                                    } else {
                                        this.removeInstance(this.target, b);
                                        CanvasXpress.cacheImages = {};
                                        CanvasXpress.cacheText = {};
                                        CanvasXpress.stack = {};
                                        CanvasXpress.current = false;
                                        CanvasXpress.selector = {
                                            vars: {},
                                            smps: {},
                                            meta: {},
                                            comp: {},
                                            nodes: {},
                                            edges: {},
                                            mixed: {},
                                            selections: 0,
                                            graphType: false
                                        }
                                    }
                                };
                                this.destroyInDOM = function(c) {
                                    var b = 0;
                                    var a = c.length;
                                    while (c.length > 0 && b <= a) {
                                        this.destroy(c[0].id);
                                        b++
                                    }
                                };
                                this.monitorInstances = function() {
                                    var a = this;
                                    setTimeout(function() {
                                        var d = [];
                                        for (var b = 0; b < CanvasXpress.instances.length; b++) {
                                            var e = a.$(CanvasXpress.instances[b].target);
                                            if (!e) {
                                                d.push(CanvasXpress.instances[b].target)
                                            }
                                        }
                                        for (var b = 0; b < d.length; b++) {
                                            a.destroy(d[b])
                                        }
                                    }, 1000)
                                };
                                this.removeInstance = function(e, g) {
                                    var d = CanvasXpress.instances;
                                    CanvasXpress.instances = [];
                                    for (var c = 0; c < d.length; c++) {
                                        if (d[c].target != e) {
                                            CanvasXpress.instances.push(d[c])
                                        } else {
                                            var h = d[c];
                                            if (h.isR || g) {
                                                var b = h.$("container-" + h.target);
                                                if (b) {
                                                    var f = b.parentNode;
                                                    var a = h.$cX("canvas", h.meta.dom);
                                                    h.resetTooltipDivs();
                                                    h.cleanEvtListeners();
                                                    h.removeTarget("container-" + h.target);
                                                    h.removeTarget(h.target + "-cX-Info");
                                                    delete CanvasXpress.stack[h.target];
                                                    f.appendChild(a);
                                                    if (h.graphType == "Network" && this.isR) {
                                                        a.width = 0;
                                                        a.height = 0
                                                    }
                                                }
                                            } else {
                                                h.resetTooltipDivs();
                                                h.cleanEvtListeners();
                                                h.removeTarget("container-" + h.target);
                                                h.removeTarget(h.target + "-cX-Info");
                                                delete CanvasXpress.stack[h.target]
                                            }
                                        }
                                    }
                                };
                                this.cleanEvtListeners = function() {
                                    this.addRemoveLinkListeners("removeEvtListener");
                                    this.addRemoveToolbarListeners("removeEvtListener");
                                    this.addRemoveCodeListeners("removeEvtListener");
                                    this.addRemoveBinListeners("removeEvtListener");
                                    this.addRemoveDataExplorerListeners("removeEvtListener");
                                    this.addRemoveItemListeners("removeEvtListener");
                                    this.addRemoveConfiguratorListeners("removeEvtListener");
                                    this.addRemoveDataTableListeners("removeEvtListener");
                                    this.removeGenericDataFilterListenersOrReset();
                                    this.addRemoveDataFilterListeners("removeEvtListener");
                                    this.addRemoveCanvasListeners("removeEvtListener");
                                    this.addRemoveMotionListeners("removeEvtListener");
                                    this.addRemoveNavigationListeners("removeEvtListener");
                                    this.removeEvtListener(document, "mousemove", this.mousemoveDoc, false);
                                    this.removeEvtListener(document, "touchmove", this.mousemoveDoc, false);
                                    this.removeEvtListener(document, "mouseup", this.mouseupDoc, false);
                                    this.removeEvtListener(document, "touchend", this.mouseupDoc, false);
                                    this.removeEvtListener(document, "keydown", this.keydownDoc, false);
                                    this.removeEvtListener(document, "keyup", this.keyupDoc, false);
                                    this.removeEvtListener(window, "resize", this.resizeWindow, false)
                                }
                            };
                            CanvasXpress.prototype.initEvents = function() {
                                this.cloneEvent = function(h) {
                                    var g = ["ac", "altKey", "bubbles", "button", "buttons", "cancelBubble", "cancelable", "charCode", "code", "clientX", "clientY", "ctrlKey", "defaultPrevented", "deltaMode", "deltaX", "deltaY", "deltaZ", "detail", "eventPhase", "isTrusted", "isTrusted", "keyCode", "keyIdentifier", "location", "layerX", "layerY", "metaKey", "movementX", "movementY", "offsetX", "offsetY", "pageX", "pageY", "repeat", "returnValue", "screenX", "screenY", "shiftKey", "timeStamp", "type", "wheelDelta", "wheelDeltaX", "wheelDeltaY", "which", "x", "y"];
                                    var f = ["clientX", "clientY", "force", "identifier", "pageX", "pageY", "radiusX", "radiusY", "rotationAngle", "screenX", "screenY"];
                                    var a = {
                                        srcElement: h.srcElement ? h.srcElement.id : h.target.id,
                                        target: h.target.id
                                    };
                                    for (var d = 0; d < g.length; d++) {
                                        a[g[d]] = h[g[d]]
                                    }
                                    if (!a.ac) {
                                        a.ac = this.adjustedCoordinates(a)
                                    }
                                    a.xMouseDown = this.xMouseDown;
                                    a.yMouseDown = this.yMouseDown;
                                    if (h.touches) {
                                        a.touches = [];
                                        for (var d = 0; d < h.touches.length; d++) {
                                            a.touches[d] = {
                                                target: h.touches[d].target.id
                                            };
                                            for (var b = 0; b < f.length; b++) {
                                                a.touches[d][f[b]] = h.touches[d][f[b]]
                                            }
                                            if (!a.touches[d].ac) {
                                                a.touches[d].ac = this.adjustedCoordinates(h.touches[d], h.touches[d].target)
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.cleanTouchEvent = function(f) {
                                    var d = ["clientX", "clientY", "force", "identifier", "pageX", "pageY", "radiusX", "radiusY", "rotationAngle", "screenX", "screenY"];
                                    var a = {
                                        target: f.target.id,
                                        ac: this.adjustedTouchCoordinates(f, f.target),
                                        time: new Date().getTime()
                                    };
                                    for (var b = 0; b < d.length; b++) {
                                        a[d[b]] = f[d[b]]
                                    }
                                    return a
                                };
                                this.cleanEventInArguments = function(b) {
                                    for (var d = 0; d < b.length; d++) {
                                        if (b[d] instanceof Event) {
                                            b[d] = this.cloneEvent(b[d])
                                        }
                                    }
                                    return b
                                };
                                this.getOffset = function(b) {
                                    var a = 0;
                                    var d = 0;
                                    while (b && !isNaN(b.offsetLeft) && !isNaN(b.offsetTop)) {
                                        a += b.offsetLeft - b.scrollLeft;
                                        d += b.offsetTop - b.scrollTop;
                                        b = b.offsetParent
                                    }
                                    return {
                                        top: d,
                                        left: a
                                    }
                                };
                                this.regularCoordinates = function(i, g) {
                                    var k = {};
                                    if (i && i.ac) {
                                        k.x = i.ac.x;
                                        k.y = i.ac.y
                                    } else {
                                        if (i.pageX == null && g.clientX != null) {
                                            var h = i.target.ownerDocument || window.document;
                                            var j = h.documentElement;
                                            var a = h.body;
                                            k.x = g.clientX + (j && j.scrollLeft || a && a.scrollLeft || 0) - (j && j.clientLeft || a && a.clientLeft || 0);
                                            k.y = g.clientY + (j && j.scrollTop || a && a.scrollTop || 0) - (j && j.clientTop || a && a.clientTop || 0)
                                        } else {
                                            k.x = i.pageX;
                                            k.y = i.pageY
                                        }
                                    }
                                    return k
                                };
                                this.relativeCoordinates = function(a) {
                                    var b = {
                                        x: 0,
                                        y: 0
                                    };
                                    if (a && a.ac) {
                                        b.x = a.ac.x;
                                        b.y = a.ac.y
                                    } else {
                                        while (a && !isNaN(a.offsetLeft) && !isNaN(a.offsetTop)) {
                                            b.x += a.offsetLeft;
                                            b.y += a.offsetTop;
                                            a = a.offsetParent
                                        }
                                    }
                                    return b
                                };
                                this.absoluteCoordinates = function(a) {
                                    var b = {
                                        x: 0,
                                        y: 0
                                    };
                                    if (a && a.ac) {
                                        b.x = a.ac.x;
                                        b.y = a.ac.y
                                    } else {
                                        while (a && !isNaN(a.offsetLeft) && !isNaN(a.offsetTop)) {
                                            b.x += a.offsetLeft - a.scrollLeft;
                                            b.y += a.offsetTop - a.scrollTop;
                                            a = a.offsetParent
                                        }
                                    }
                                    return b
                                };
                                this.getBoundingClientRect = function(f) {
                                    var i = window;
                                    var h = i.document;
                                    var b = h.body;
                                    var a = i.pageXOffset !== undefined ? i.pageXOffset : (h.documentElement || b.parentNode || b).scrollLeft;
                                    var j = i.pageYOffset !== undefined ? i.pageYOffset : (h.documentElement || b.parentNode || b).scrollTop;
                                    var g = f.getBoundingClientRect();
                                    if (f !== b) {
                                        var d = f.parentNode;
                                        while (d !== b && d.scrollLeft && d.scrollTop) {
                                            a += d.scrollLeft;
                                            j += d.scrollTop;
                                            d = d.parentNode
                                        }
                                    }
                                    return {
                                        bottom: g.bottom + j,
                                        height: g.height,
                                        left: g.left + a,
                                        right: g.right + a,
                                        top: g.top + j,
                                        width: g.width
                                    }
                                };
                                this.adjustedCoordinates = function(j, g) {
                                    if (!g) {
                                        g = this.$(this.target)
                                    }
                                    if (g && j) {
                                        var s = j.target || j.srcElement;
                                        var n = {};
                                        if (CanvasXpress.system.isReveal && s && s.tagName && s.tagName.toLowerCase() == "canvas") {
                                            var a = 1 / Reveal.getScale();
                                            var q = zoom.zoomLevel();
                                            var v = s.getClientRects();
                                            n.x = j.x - (v[0].left / a);
                                            n.y = j.y - (v[0].top / a)
                                        } else {
                                            try {
                                                var f = g.parentNode.getClientRects();
                                                var h = j && j.changedTouches ? j.changedTouches[0] : false;
                                                if (j && j.ac) {
                                                    n.x = j.ac.x;
                                                    n.y = j.ac.y
                                                } else {
                                                    if (f && f[0]) {
                                                        var k = window.document;
                                                        var i = f[0].left;
                                                        var A = f[0].top;
                                                        var w = j && j.clientX ? j.clientX : h ? h.clientX : j && j[0] ? j[0] : i;
                                                        var u = j && j.clientY ? j.clientY : h ? h.clientY : j && j[1] ? j[1] : A;
                                                        n.x = k.body.scrollLeft > Math.abs(i) + w && w > k.body.scrollLeft - i ? Math.abs(i) + w : w - i;
                                                        n.y = k.body.scrollTop > Math.abs(A) + u && u > k.body.scrollTop - A ? Math.abs(A) + u : (u - A)
                                                    } else {
                                                        n.x = 0;
                                                        n.y = 0
                                                    }
                                                }
                                            } catch (j) {
                                                return false
                                            }
                                        }
                                        return n
                                    } else {
                                        return false
                                    }
                                };
                                this.adjustedTouchCoordinates = function(g, b) {
                                    if (!b) {
                                        b = this.$(this.target)
                                    }
                                    if (b) {
                                        var i = {};
                                        var h = window.document;
                                        var a = b.parentNode.getClientRects();
                                        var f = a[0].left;
                                        var m = a[0].top;
                                        var k = g.clientX;
                                        var j = g.clientY;
                                        i.x = h.body.scrollLeft > Math.abs(f) + k && k > h.body.scrollLeft - f ? Math.abs(f) + k : k - f;
                                        i.y = h.body.scrollTop > Math.abs(m) + j && j > h.body.scrollTop - m ? Math.abs(m) + j : (j - m);
                                        return i
                                    }
                                };
                                this.isPointInsidePolygon = function(o, n, a) {
                                    var f = false;
                                    for (var k = 0, h = a[0].length - 1; k < a[0].length; h = k++) {
                                        var m = a[0][k];
                                        var g = a[1][k];
                                        var l = a[0][h];
                                        var d = a[1][h];
                                        var b = ((g > n) != (d > n)) && (o < (l - m) * (n - g) / (d - g) + m);
                                        if (b) {
                                            f = !f
                                        }
                                    }
                                    return f
                                };
                                this.isAreaInsidePolygon = function(f, d) {
                                    var a, g;
                                    switch (f[0]) {
                                        case "rect":
                                            a = (f[1] + f[3]) / 2;
                                            g = (f[2] + f[4]) / 2;
                                            break;
                                        case "circle":
                                            a = f[1];
                                            g = f[2];
                                            break;
                                        case "poly":
                                            var b = this.centroidArea(f);
                                            a = b[0];
                                            g = b[1];
                                            break
                                    }
                                    return this.isPointInsidePolygon(a, g, d)
                                };
                                this.isObjectInsideArea = function(i, f, h, b, g) {
                                    var a, j;
                                    switch (i[0]) {
                                        case "rect":
                                            a = (i[1] + i[3]) / 2;
                                            j = (i[2] + i[4]) / 2;
                                            break;
                                        case "circle":
                                            a = i[1];
                                            j = i[2];
                                            break;
                                        case "poly":
                                            var d = this.centroidArea(i);
                                            a = d[0];
                                            j = d[1];
                                            break
                                    }
                                    return this.isPointInsideArea(a, j, ["rect", f, h, b, g])
                                };
                                this.isPointInsideArea = function(n, m, l) {
                                    if (l) {
                                        switch (l[0]) {
                                            case "rect":
                                                if (l[1] > l[3]) {
                                                    l[5] = l[1];
                                                    l[1] = l[3];
                                                    l[3] = l[5]
                                                }
                                                if (l[2] > l[4]) {
                                                    l[5] = l[2];
                                                    l[2] = l[4];
                                                    l[4] = l[5]
                                                }
                                                if (n >= l[1] && n <= l[3] && m >= l[2] && m <= l[4]) {
                                                    return true
                                                } else {
                                                    return false
                                                }
                                                case "circle":
                                                    var g = l[3] / 2;
                                                    if (n >= l[1] - g && n <= l[1] + g && m >= l[2] - g && m <= l[2] + g) {
                                                        return true
                                                    } else {
                                                        return false
                                                    }
                                                    case "poly":
                                                        var d = [];
                                                        var a = [];
                                                        var k = false;
                                                        for (var f = 1; f < l.length; f++) {
                                                            if (f % 2) {
                                                                d.push(l[f])
                                                            } else {
                                                                a.push(l[f])
                                                            }
                                                        }
                                                        if (a[0] < a[1]) {
                                                            a = a.reverse();
                                                            d = d.reverse()
                                                        }
                                                        for (var f = 0, b = d.length - 1; f < d.length; b = f++) {
                                                            if (((a[f] <= m && m < a[b]) || (a[b] <= m && m < a[f])) && (n < (d[b] - d[f]) * (m - a[f]) / (a[b] - a[f]) + d[f])) {
                                                                k = !k
                                                            }
                                                        }
                                                        return k
                                        }
                                    } else {
                                        return false
                                    }
                                };
                                this.isEvent = function(j, d) {
                                    var l = this.adjustedCoordinates(j);
                                    if (l) {
                                        var a = this.getTargetEvent(j);
                                        this.xMouseMove = l.x;
                                        this.yMouseMove = l.y;
                                        if (a && a.id && a.id.match(this.target)) {
                                            var g = this.meta.render.objects;
                                            var k = [];
                                            var f = g.length - 1;
                                            for (var h = f; h >= 0; h--) {
                                                var b = g[h];
                                                if (b.idx) {
                                                    if (this.isPointInsideArea(l.x, l.y, b.area)) {
                                                        if (d) {
                                                            k.push(h)
                                                        } else {
                                                            return [h]
                                                        }
                                                    }
                                                }
                                            }
                                            if (d && k.length > 0) {
                                                return k
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.isEventIndices = function(j, f, d) {
                                    var b = [];
                                    var a = d ? d : this.isEvent(j, f);
                                    if (a) {
                                        if (a.length == 1) {
                                            var k = this.meta.render.objects[a[0]];
                                            return k.modifier ? [k.idx + k.modifier] : k.idx
                                        } else {
                                            var g = a.length;
                                            for (var h = 0; h < g; h++) {
                                                var k = this.meta.render.objects[a[h]];
                                                b.push(k.idx)
                                            }
                                            return b
                                        }
                                    }
                                    return false
                                };
                                this.getBoundsXY = function(f) {
                                    var d = this.layoutComb && this.layoutParams && this.layoutParams.length ? this.layoutParams[f] : this;
                                    var a = this.graphType == "Network" ? 0 : this.marginLeft + d.offsetX;
                                    var b = this.graphType == "Network" ? 0 : this.marginTop + d.offsetY;
                                    return [a + d.left, a + d.left + d.x, b + d.top, b + d.top + d.y, a, a + d.left + d.x + d.right, b, b + d.top + d.y + d.bottom]
                                };
                                this.getUngroupedDataObject = function(b, a) {
                                    if (this.isGroupedData && this.graphType.match(/Dotplot|Boxplot/) && b.y) {
                                        this.isGroupedData = false;
                                        b = this.extractDataObject([a[0], a[2]]);
                                        this.isGroupedData = true
                                    } else {
                                        if (this.isDOE && this.graphType.match(/Dotplot|Boxplot/) && b.w) {
                                            this.isDOE = false;
                                            b = this.extractDataObject(b.w.grps[0], this.getVariableIndices(b.w.vars));
                                            this.isDOE = true
                                        } else {
                                            if (this.isGroupedData && b.w) {
                                                this.isGroupedData = false;
                                                b = this.extractDataObject(b.w.grps[0], this.getVariableIndices(b.w.vars));
                                                this.isGroupedData = true
                                            }
                                        }
                                    }
                                    return b
                                };
                                this.extractDataObject = function(m, Q) {
                                    var P = this;
                                    var L = this.layoutParams;
                                    var I = this.layoutValidN || 0;
                                    var f = this.scatterPlotMatrix && this.data.l.data[I] ? this.data.l.data[I] : this.isDOE && I == 0 && this.data.l.data ? this.data.l.data : this.data;
                                    var E = this.meta.data;
                                    var an = this.layoutComb && I !== false && L && L.length ? L[I].graphType : this.graphType;
                                    var F = [];
                                    var D = [];
                                    var ae = [];
                                    var W = function(d) {
                                        var n = {};
                                        var k = P.isGroupedData;
                                        P.isGroupedData = false;
                                        for (var l in f.x) {
                                            n[l] = [];
                                            if (d && d.length) {
                                                for (var j = 0; j < d.length; j++) {
                                                    n[l].push(P.getMetadataValue(d[j], "x", l, k == "Gantt"))
                                                }
                                            }
                                        }
                                        P.isGroupedData = k;
                                        return n
                                    };
                                    var R = function(d) {
                                        var k = {};
                                        for (var j in f.z) {
                                            k[j] = [];
                                            for (var g = 0; g < d.length; g++) {
                                                k[j].push(P.getMetadataValue(d[g], "z", j, an == "Gantt"))
                                            }
                                        }
                                        return k
                                    };
                                    var A = function(d) {
                                        var j = [];
                                        if (P.isDOE) {
                                            for (var g = 0; g < d.length; g++) {
                                                j.push(L[I].data.y.vars[d[g]])
                                            }
                                        } else {
                                            for (var g = 0; g < d.length; g++) {
                                                j.push(f.y.vars[d[g]])
                                            }
                                        }
                                        return j
                                    };
                                    var C = function(j, n) {
                                        var d = n ? n : f.y.smps;
                                        var p = [];
                                        if (P.isDOE) {
                                            p.push(L[I].data.y.smps[j[0]])
                                        } else {
                                            if (j && j.length) {
                                                for (var k = 0; k < j.length; k++) {
                                                    p.push(d[j[k]])
                                                }
                                            }
                                        }
                                        return p
                                    };
                                    var G = function(d, k) {
                                        var l = [];
                                        if (k) {
                                            for (var j = 0; j < d.length; j++) {
                                                l.push(k[d[j]])
                                            }
                                        }
                                        return l
                                    };
                                    var ai = function(g, d) {
                                        var k = [];
                                        for (var j = 0; j < g.length; j++) {
                                            k.push(d.grps[g[j]])
                                        }
                                        return k
                                    };
                                    var H = function(g, d, p) {
                                        var n = [];
                                        if (P.isDOE) {
                                            for (var l = 0; l < g.length; l++) {
                                                n[l] = [];
                                                if (L[I].data.y.data[g[l]]) {
                                                    n[l].push(L[I].data.y.data[g[l]][d[0]])
                                                } else {
                                                    if (L[I].data.y.data[l]) {
                                                        n[l].push(L[I].data.y.data[l][d[0]])
                                                    } else {
                                                        return false
                                                    }
                                                }
                                            }
                                        } else {
                                            if (!p) {
                                                p = "data"
                                            }
                                            if (d) {
                                                for (var l = 0; l < g.length; l++) {
                                                    n[l] = [];
                                                    if (P.isTransformedData && f.y.trans) {
                                                        for (var k = 0; k < d.length; k++) {
                                                            n[l].push(P.formatNumber(f.y.trans[g[l]][d[k]]))
                                                        }
                                                    } else {
                                                        for (var k = 0; k < d.length; k++) {
                                                            n[l].push(f.y[p][g[l]][d[k]])
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (P.isTransformedData && f.y.trans) {
                                                    for (var l = 0; l < g.length; l++) {
                                                        n.push(P.formatNumber(f.y.trans[g[l]]))
                                                    }
                                                } else {
                                                    for (var l = 0; l < g.length; l++) {
                                                        n.push(f.y[p][g[l]])
                                                    }
                                                }
                                            }
                                        }
                                        return n
                                    };
                                    switch (an) {
                                        case "Area":
                                        case "AreaLine":
                                        case "Bar":
                                        case "Line":
                                        case "BarLine":
                                        case "Boxplot":
                                        case "Dotplot":
                                        case "DotLine":
                                        case "Heatmap":
                                        case "Pie":
                                        case "Stacked":
                                        case "StackedLine":
                                        case "StackedPercent":
                                        case "StackedPercentLine":
                                        case "Scatter2D":
                                        case "ScatterBubble2D":
                                        case "Scatter3D":
                                        case "Gantt":
                                        case "Meter":
                                        case "Circular":
                                        case "Treemap":
                                        case "TagCloud":
                                        case "ParallelCoordinates":
                                        case "Sankey":
                                        case "Tree":
                                        case "Map":
                                            if (!m || m.length == 0 || m[0] == null) {
                                                return
                                            } else {
                                                if (isNaN(m[0])) {
                                                    if (m[0] && m[0].match(/ScatterBoxplot/)) {
                                                        var ag = {};
                                                        var af = m[0].split(":::");
                                                        ag.display = af[1];
                                                        ag.objectType = "ScatterBoxplot";
                                                        return ag
                                                    } else {
                                                        if (m[0] && m[0].match(/Decor-Line/)) {
                                                            var ap = m[0].split(":");
                                                            var ag = {
                                                                display: ap[0],
                                                                objectType: "Decoration"
                                                            };
                                                            return ag
                                                        } else {
                                                            if (m[0] && m[0].match(/Confidence/)) {
                                                                var ap = m[0].split(":");
                                                                var ag = {
                                                                    display: ap[0],
                                                                    objectType: "Confidence"
                                                                };
                                                                return ag
                                                            } else {
                                                                if (m[0] && m[0].match(/Chr/)) {
                                                                    var ag = {
                                                                        display: m[0],
                                                                        objectType: "Chr"
                                                                    };
                                                                    return ag
                                                                } else {
                                                                    if (m[0] && m[0].match(/Ring/)) {
                                                                        var ag = {
                                                                            display: m[0],
                                                                            objectType: "Ring"
                                                                        };
                                                                        return ag
                                                                    } else {
                                                                        if (m[0] && m[0].match(/Line|Area/)) {
                                                                            var ap = m[0].split(":");
                                                                            var ag = {
                                                                                display: ap[1],
                                                                                objectType: "Line"
                                                                            };
                                                                            return ag
                                                                        } else {
                                                                            if (m[0] && m[0].match(/Sankey/)) {
                                                                                var ap = m[0].split(":");
                                                                                var ag = {
                                                                                    display: ap[1],
                                                                                    objectType: "Sankey"
                                                                                };
                                                                                return ag
                                                                            } else {
                                                                                if (m[0] && m[0].match(/Tree/)) {
                                                                                    var ag = {};
                                                                                    var b = this.getTreeNode(m[0]);
                                                                                    if (b) {
                                                                                        ag = {
                                                                                            id: b.id,
                                                                                            display: b.data.tooltip,
                                                                                            objectType: "Tree"
                                                                                        }
                                                                                    }
                                                                                    return ag
                                                                                } else {
                                                                                    if (m[0] && m[0].match(/Marker/)) {
                                                                                        var ap = m[0].split(":");
                                                                                        var ag = {
                                                                                            id: ap[1],
                                                                                            display: ap[2],
                                                                                            objectType: "Marker"
                                                                                        };
                                                                                        return ag
                                                                                    } else {
                                                                                        if (m[0] && m[0].match(/Sunburst/)) {
                                                                                            var ap = m[0].split(":");
                                                                                            var ag = {
                                                                                                display: ap[1],
                                                                                                objectType: "Sunburst"
                                                                                            };
                                                                                            return ag
                                                                                        } else {
                                                                                            if (m[0] && m[0].match(/Bubble/)) {
                                                                                                var ap = m[0].split(":");
                                                                                                var ag = {
                                                                                                    display: ap[1],
                                                                                                    objectType: "Bubble"
                                                                                                };
                                                                                                return ag
                                                                                            } else {
                                                                                                if (m[0] && m[0].match(/Connect/)) {
                                                                                                    var ap = m[0].split(":");
                                                                                                    var ag = {
                                                                                                        display: ap[1],
                                                                                                        objectType: "Connect"
                                                                                                    };
                                                                                                    return ag
                                                                                                } else {
                                                                                                    if (m[0] && m[0].match(/Chord/)) {
                                                                                                        var ap = m[0].split(":");
                                                                                                        var ag = {
                                                                                                            id: ap[1],
                                                                                                            display: ap[2],
                                                                                                            objectType: "Chord"
                                                                                                        };
                                                                                                        return ag
                                                                                                    } else {
                                                                                                        if (m[0] && m[0].match(/Outlier/)) {
                                                                                                            var ap = m[0].split(":");
                                                                                                            var ag = {
                                                                                                                display: ap[1],
                                                                                                                objectType: "Outlier"
                                                                                                            };
                                                                                                            return ag
                                                                                                        } else {
                                                                                                            if (m[0] && m[0].match(/Series/)) {
                                                                                                                var ap = m[0].split(":");
                                                                                                                ap.shift();
                                                                                                                var ag = {
                                                                                                                    display: this.data.y.smps[ap[0]] + " : " + this.data.y.smps[ap[1]],
                                                                                                                    selector: {
                                                                                                                        type: "series",
                                                                                                                        name: [this.data.y.smps[ap[0]], this.data.y.smps[ap[1]]],
                                                                                                                        id: m[0]
                                                                                                                    },
                                                                                                                    objectType: "Series"
                                                                                                                };
                                                                                                                return ag
                                                                                                            } else {
                                                                                                                if (m[0] && m[0].match(/Property/)) {
                                                                                                                    var ap = m[0].split(":");
                                                                                                                    ap.shift();
                                                                                                                    var aa = ap.shift();
                                                                                                                    var V = ap.pop();
                                                                                                                    var Y = ap.join(":");
                                                                                                                    return {
                                                                                                                        display: aa + " : " + Y,
                                                                                                                        selector: {
                                                                                                                            type: "meta",
                                                                                                                            object: V,
                                                                                                                            factor: aa,
                                                                                                                            level: Y,
                                                                                                                            id: "Property:" + aa + ":" + Y + ":" + V
                                                                                                                        },
                                                                                                                        objectType: "Property"
                                                                                                                    }
                                                                                                                } else {
                                                                                                                    if (m[0] && m[0].match(/Histogram/)) {
                                                                                                                        var af = m[0].split("-");
                                                                                                                        return {
                                                                                                                            a: af[0],
                                                                                                                            b: af[1],
                                                                                                                            c: af[2],
                                                                                                                            d: af[3],
                                                                                                                            objectType: "Histogram"
                                                                                                                        }
                                                                                                                    } else {
                                                                                                                        if (m[0] && m[0].match(/Dendrogram/)) {
                                                                                                                            var af = m[0].split("-");
                                                                                                                            if (af.length > 1) {
                                                                                                                                return {
                                                                                                                                    nodeId: parseInt(af.shift()),
                                                                                                                                    height: Number(af.shift()),
                                                                                                                                    objectType: af.shift(),
                                                                                                                                    name: (af[0] ? af.join("-") : false)
                                                                                                                                }
                                                                                                                            } else {
                                                                                                                                return {
                                                                                                                                    display: (this.graphType == "Circular" ? "" : "<i>Drag to move</i>")
                                                                                                                                }
                                                                                                                            }
                                                                                                                        } else {
                                                                                                                            if (m[0] && m[0].match(/,error/)) {
                                                                                                                                var af = m[0].split(",");
                                                                                                                                F = [parseInt(af[0])];
                                                                                                                                D = [parseInt(af[1])]
                                                                                                                            } else {
                                                                                                                                if (m[0] && m[0].match(/PieVar/)) {
                                                                                                                                    var af = m[0].split("-");
                                                                                                                                    var am = parseInt(af[1]);
                                                                                                                                    return {
                                                                                                                                        display: f.y.vars[am],
                                                                                                                                        objectType: "Var",
                                                                                                                                        selector: {
                                                                                                                                            type: "var",
                                                                                                                                            index: am,
                                                                                                                                            name: f.y.vars[am],
                                                                                                                                            id: "Var-" + am
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                } else {
                                                                                                                                    if (m[0] && m[0].match(/Var/)) {
                                                                                                                                        var af = m[0].split("-");
                                                                                                                                        var am = parseInt(af[1]);
                                                                                                                                        var at = !m[0].match(/VarOvr|VarOverlay/) ? [am].concat(this.smpIndices) : this.smpIndices;
                                                                                                                                        var ag = m[0].match(/VarOvr|VarOverlay/) ? {} : this.extractDataObject(at);
                                                                                                                                        if (m[0].match(/VarOvr/)) {
                                                                                                                                            var aj = this.getMetadataValue(am, "z", this.varOverlays[af[2]]);
                                                                                                                                            ag.display = this.varOverlays[af[2]] + " : " + aj;
                                                                                                                                            ag.objectType = "VarOverlay";
                                                                                                                                            ag.selector = {
                                                                                                                                                type: "meta",
                                                                                                                                                object: "z",
                                                                                                                                                factor: this.varOverlays[af[2]],
                                                                                                                                                level: aj,
                                                                                                                                                id: "Property:" + this.varOverlays[af[2]] + ":" + aj + ":z"
                                                                                                                                            }
                                                                                                                                        } else {
                                                                                                                                            if (m[0].match(/VarOverlay/)) {
                                                                                                                                                ag.display = this.varOverlays[af[1]];
                                                                                                                                                ag.objectType = "VarOverlay"
                                                                                                                                            } else {
                                                                                                                                                ag.display = f.y.vars[am];
                                                                                                                                                ag.objectType = "Var";
                                                                                                                                                ag.selector = {
                                                                                                                                                    type: "var",
                                                                                                                                                    index: am,
                                                                                                                                                    name: f.y.vars[am],
                                                                                                                                                    id: "Var-" + am
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                        return ag
                                                                                                                                    } else {
                                                                                                                                        if (m[0] && m[0].match(/Smp/)) {
                                                                                                                                            var af = m[0].split("-");
                                                                                                                                            var am = parseInt(af[1]);
                                                                                                                                            var ag;
                                                                                                                                            if (this.isDOE) {
                                                                                                                                                ag = this.extractDataObject([am], this.layoutParams[this.layoutValidN].varIndices)
                                                                                                                                            } else {
                                                                                                                                                if (this.isGroupedData && f.w && an != "Treemap" && an != "Gantt" && !this.treemapBy.length > 0 && !this.isDOE) {
                                                                                                                                                    ag = {
                                                                                                                                                        y: {
                                                                                                                                                            vars: A(this.varIndices),
                                                                                                                                                            smps: C(f.w.grps[am])
                                                                                                                                                        },
                                                                                                                                                        z: R(this.varIndices),
                                                                                                                                                        x: W(f.w.grps[am])
                                                                                                                                                    };
                                                                                                                                                    ag.y.data = H(this.varIndices, f.w.grps[am])
                                                                                                                                                } else {
                                                                                                                                                    ag = this.extractDataObject([am], this.varIndices)
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            if (m[0].match(/SmpOvrSgr/)) {
                                                                                                                                                af.shift();
                                                                                                                                                var K = this.segregateSamplesBy[af.shift()];
                                                                                                                                                var aj = af.join("-");
                                                                                                                                                ag.display = K + " : " + aj;
                                                                                                                                                ag.objectType = "SmpOverlaySgr";
                                                                                                                                                ag.selector = {
                                                                                                                                                    type: "meta",
                                                                                                                                                    object: "x",
                                                                                                                                                    factor: K,
                                                                                                                                                    level: aj,
                                                                                                                                                    id: "Property:" + K + ":" + aj + ":x"
                                                                                                                                                }
                                                                                                                                            } else {
                                                                                                                                                if (m[0].match(/SmpOvr/)) {
                                                                                                                                                    var K = this.smpOverlays[af[2]];
                                                                                                                                                    var aj = this.layoutValid && f.l.group && L && L[I].w && L[I].w.factors && L[I].w.factors[K] ? L[I].w.factors[K][am] : this.isGroupedData && f.w ? f.w.factors[this.smpOverlays[af[2]]][am] : this.getMetadataValue(am, "x", this.smpOverlays[af[2]]);
                                                                                                                                                    ag.display = this.smpOverlays[af[2]] + " : " + aj;
                                                                                                                                                    ag.objectType = "SmpOverlay";
                                                                                                                                                    ag.selector = {
                                                                                                                                                        type: "meta",
                                                                                                                                                        object: "x",
                                                                                                                                                        factor: this.smpOverlays[af[2]],
                                                                                                                                                        level: aj,
                                                                                                                                                        id: "Property:" + this.smpOverlays[af[2]] + ":" + aj + ":x"
                                                                                                                                                    }
                                                                                                                                                } else {
                                                                                                                                                    if (m[0].match(/SmpOverlay/)) {
                                                                                                                                                        ag.display = this.smpOverlays[af[1]];
                                                                                                                                                        ag.objectType = "SmpOverlay"
                                                                                                                                                    } else {
                                                                                                                                                        ag.display = this.layoutValid && f.l.group && L && L[I].w && L[I].w.glab && L[I].w.glab[am] ? L[I].w.glab[am] : this.isGroupedData && f.w ? f.w.smps[am] : this.isGraphTime ? this.dateFormat(f.y.smps[am], this.timeFormat) : this.isDOE == 1 && this.layoutValidN == 0 && f.w && f.w.smps[am] ? f.w.smps[am] : this.isDOE && this.layoutValidN ? ag.y.smps[0] : f.y.smps[am];
                                                                                                                                                        ag.objectType = "Smp";
                                                                                                                                                        ag.selector = {
                                                                                                                                                            type: (this.isGroupedData ? "grp" : "smp"),
                                                                                                                                                            index: am,
                                                                                                                                                            name: ag.display,
                                                                                                                                                            id: "Smp-" + am
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                            return ag
                                                                                                                                        } else {
                                                                                                                                            if (m[0] && m[0].match(/Cat/)) {
                                                                                                                                                var ag = {};
                                                                                                                                                var af = m[0].split("-");
                                                                                                                                                ag.display = af[1];
                                                                                                                                                ag.objectType = "Cat";
                                                                                                                                                return ag
                                                                                                                                            } else {
                                                                                                                                                if (m[0] && m[0].match(/Onc/)) {
                                                                                                                                                    var ag = {};
                                                                                                                                                    var af = m[0].split("-");
                                                                                                                                                    ag.display = af[1];
                                                                                                                                                    ag.objectType = "Onc";
                                                                                                                                                    ag.selector = {
                                                                                                                                                        type: "data",
                                                                                                                                                        object: this["oncoprint" + af[2]],
                                                                                                                                                        name: ag.display,
                                                                                                                                                        id: "Onc-" + ag.display + "-" + af[2]
                                                                                                                                                    };
                                                                                                                                                    return ag
                                                                                                                                                } else {
                                                                                                                                                    if (m[0] && m[0].match(/Density/)) {
                                                                                                                                                        var ag = {};
                                                                                                                                                        var af = m[0].split(":");
                                                                                                                                                        ag.display = af[1];
                                                                                                                                                        ag.objectType = "Density";
                                                                                                                                                        return ag
                                                                                                                                                    } else {
                                                                                                                                                        if (m[0] && m[0].match(/MapKey/)) {
                                                                                                                                                            F = this.mapVarIds[m[0].split(":")[1]];
                                                                                                                                                            D = m[1];
                                                                                                                                                            var aq = this.canvasPointToCoordinate(this.xMouseMove, this.yMouseMove);
                                                                                                                                                            var S = "[ " + aq[1].toFixed(1) + ", " + aq[0].toFixed(1) + " ]";
                                                                                                                                                            var ag;
                                                                                                                                                            if (F && F.length) {
                                                                                                                                                                ag = {
                                                                                                                                                                    y: {
                                                                                                                                                                        vars: A(F),
                                                                                                                                                                        smps: C(D)
                                                                                                                                                                    },
                                                                                                                                                                    z: R(F)
                                                                                                                                                                };
                                                                                                                                                                ag.y.data = H(F, D);
                                                                                                                                                                ag.c = S
                                                                                                                                                            } else {
                                                                                                                                                                var h = m[0].split(":")[1];
                                                                                                                                                                if (CanvasXpress.countries[h]) {
                                                                                                                                                                    ag = {
                                                                                                                                                                        display: CanvasXpress.countries[h][0] + "<br>" + S,
                                                                                                                                                                        type: "MapCountry"
                                                                                                                                                                    }
                                                                                                                                                                } else {
                                                                                                                                                                    if (this.meta.map.geojson && this.meta.map.geojson.features && this.meta.map.geojson.features[h] && this.meta.map.geojson.features[h].properties) {
                                                                                                                                                                        for (var am in this.meta.map.geojson.features[h].properties) {
                                                                                                                                                                            if (am.match(/name/i)) {
                                                                                                                                                                                ag = {
                                                                                                                                                                                    idx: h,
                                                                                                                                                                                    display: this.meta.map.geojson.features[h].properties[am] + "<br>" + S,
                                                                                                                                                                                    type: "MapProperty"
                                                                                                                                                                                };
                                                                                                                                                                                return ag
                                                                                                                                                                            }
                                                                                                                                                                        }
                                                                                                                                                                    }
                                                                                                                                                                    return false
                                                                                                                                                                }
                                                                                                                                                            }
                                                                                                                                                            return ag
                                                                                                                                                        } else {
                                                                                                                                                            return
                                                                                                                                                        }
                                                                                                                                                    }
                                                                                                                                                }
                                                                                                                                            }
                                                                                                                                        }
                                                                                                                                    }
                                                                                                                                }
                                                                                                                            }
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if ((an == "Pie" || an == "Gantt") && m.length > 2 && !this.isDOE) {
                                                        D = [m[0]];
                                                        for (var am = 1; am < m.length; am++) {
                                                            F.push(m[am])
                                                        }
                                                    } else {
                                                        if (an.match(/Pie|Treemap/) && this.isDOE) {
                                                            F = [m[0]];
                                                            D = [m[1]]
                                                        } else {
                                                            if (Q) {
                                                                F = Q;
                                                                D = m
                                                            } else {
                                                                if (this.isGroupedData && this.stackBy) {
                                                                    F = [m[0]];
                                                                    D = m[3] ? m[3] : [m[1]]
                                                                } else {
                                                                    F = [m[0]];
                                                                    D = [];
                                                                    for (var am = 1; am < m.length; am++) {
                                                                        if (m[am] !== false && !m[am].toString().match(/[A-Za-z]/)) {
                                                                            D.push(m[am])
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    if (an.match(/Scatter/)) {
                                                        if (this.colorBy) {
                                                            var r = this.getSampleIndices(this.colorBy);
                                                            if (!this.isArray(r) && r > -1) {
                                                                D.push(r)
                                                            }
                                                        }
                                                        if (this.shapeBy) {
                                                            var r = this.getSampleIndices(this.shapeBy);
                                                            if (!this.isArray(r) && r > -1) {
                                                                D.push(r)
                                                            }
                                                        }
                                                        if (this.sizeBy) {
                                                            var r = this.getSampleIndices(this.sizeBy);
                                                            if (!this.isArray(r) && r > -1) {
                                                                D.push(r)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            if ((this.isGroupedData && f.w && an != "Treemap" && an != "Gantt" && !this.treemapBy.length > 0 && !this.isDOE) || (this.isDOE && I == 0 && f.w) || (this.layoutValid && f.l && f.l.group && !this.isOneDimensionalGraph() && !this.scatterPlotMatrix && !this.isDOE)) {
                                                var ag = {
                                                    x: {},
                                                    w: {},
                                                    z: R(F)
                                                };
                                                if (an.match(/Boxplot|Dotplot|DotLine|Gantt/) && D[1] != null) {
                                                    ag.y = {
                                                        data: f.y.data[F[0]][D[1]],
                                                        vars: f.y.vars[F[0]],
                                                        smps: f.y.smps[D[1]]
                                                    };
                                                    var J = W([D[1]]);
                                                    for (var af in J) {
                                                        ag.y[af] = J[af][0]
                                                    }
                                                    D.pop()
                                                } else {
                                                    if (an == "Bar" && this.stackBy) {
                                                        var O = this.isGroupedData;
                                                        this.isGroupedData = false;
                                                        ag.x = W(D);
                                                        ag.y = {
                                                            data: H(F, D),
                                                            vars: A(F),
                                                            smps: C(D),
                                                            idxs: D
                                                        };
                                                        ag.display = m[2];
                                                        ag.objectType = "Stack";
                                                        ag.stack = m[4];
                                                        D = [m[1]];
                                                        this.isGroupedData = O
                                                    }
                                                }
                                                var au = this.layoutValid && f.l.group && L && L[I].w ? L[I].w : f.w;
                                                if (D && F) {
                                                    for (var af in au) {
                                                        if (af == "smps") {
                                                            ag.w[af] = C(D, au.smps)
                                                        } else {
                                                            if (af == "labs") {
                                                                ag.w[af] = G(D, au.labs)
                                                            } else {
                                                                if (af == "glab") {
                                                                    ag.w[af] = G(D, au.glabs)
                                                                } else {
                                                                    if (af == "grps") {
                                                                        ag.w[af] = ai(D, au)
                                                                    } else {
                                                                        if (af == "vars") {
                                                                            ag.w[af] = A(F)
                                                                        } else {
                                                                            if (au[af].length > F[0] && au[af][F[0]] && au[af][F[0]].length > D[0]) {
                                                                                ag.w[af] = [];
                                                                                ag.w[af].push(au[af][F[0]][D[0]])
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                if (!this.stackBy && ag.w.grps[0]) {
                                                    var O = this.isGroupedData;
                                                    this.isGroupedData = false;
                                                    for (var af in f.x) {
                                                        var M = [];
                                                        for (var am = 0; am < ag.w.grps[0].length; am++) {
                                                            M.push(this.getMetadataValue(ag.w.grps[0][am], "x", af))
                                                        }
                                                        ag.x[af] = M
                                                    }
                                                    this.isGroupedData = O
                                                }
                                            } else {
                                                var ag = {
                                                    y: {
                                                        vars: A(F),
                                                        smps: C(D)
                                                    },
                                                    z: R(F)
                                                };
                                                if (!this.isDOE) {
                                                    ag.x = W(D)
                                                }
                                                if (this.isHistogram && !this.isDOE && f.y.histogram) {
                                                    ag.y.histogram = f.y.histogram[F]
                                                }
                                                if (this.isDOE && f.l) {
                                                    var u = f.l.type[0];
                                                    if (L[I].data.y.pie) {
                                                        ag.y.pie = [];
                                                        for (var am = 0; am < F.length; am++) {
                                                            ag.y.pie.push(L[I].data.y.pie[F[am]])
                                                        }
                                                        ag.x = W(L[I].data.y.pie[F[0]])
                                                    } else {
                                                        if (L[I].data.y.treemap) {
                                                            ag.y.treemap = [];
                                                            for (var am = 0; am < F.length; am++) {
                                                                ag.y.treemap.push(L[I].data.y.treemap[D[am]])
                                                            }
                                                            ag.x = W(L[I].data.y.treemap[D[0]])
                                                        } else {
                                                            if (L[I].data.y.histogram) {
                                                                ag.y.histogram = L[I].data.y.histogram[F];
                                                                ag.x = W(L[I].data.y.histogram[F[0]][0])
                                                            }
                                                        }
                                                    }
                                                }
                                                ag.y.data = H(F, D);
                                                if (this.isMultidimensionalData) {
                                                    var B = ["outline", "shape", "size"];
                                                    for (var am = 0; am < B.length; am++) {
                                                        var N = B[am] + "ByData";
                                                        if (f.y[this[N]]) {
                                                            ag.y[this[N]] = H(F, D, this[N])
                                                        }
                                                    }
                                                } else {
                                                    if (an == "Sankey") {
                                                        ag.links = this.data.sankey.links[D]
                                                    }
                                                }
                                            }
                                            return ag;
                                        case "Fish":
                                            var ag = {};
                                            if (m[0] && m[0].match(/fish/)) {
                                                var ap = m[0].split("-").pop();
                                                ag = {
                                                    display: this.fishCloneLabels.length && this.fishCloneLabels[ap] ? this.fishCloneLabels[ap] : this.data.y.vars[ap]
                                                }
                                            } else {
                                                if (m[0] && m[0].match(/Var/)) {
                                                    var af = m[0].split("-");
                                                    var am = parseInt(af[1]);
                                                    ag.display = this.data.y.vars[am];
                                                    ag.objectType = "Var";
                                                    ag.selector = {
                                                        type: "var",
                                                        index: am,
                                                        name: this.data.y.vars[am],
                                                        id: "Var-" + am
                                                    }
                                                }
                                            }
                                            return ag;
                                        case "Correlation":
                                            var ap;
                                            if (!m || m[0] == undefined || (isNaN(m[0]) && !m[0].match(/^\d/))) {
                                                return
                                            } else {
                                                ap = this.isGroupedData && f.w ? f.w.cor : f.y.cor
                                            }
                                            if (this.correlationAxis == "samples") {
                                                var ag = {
                                                    x: {},
                                                    y: {}
                                                };
                                                for (var af in f.x) {
                                                    var M = [];
                                                    for (var am = 0; am < m.length; am++) {
                                                        M.push(this.getMetadataValue(m[am], "x", af))
                                                    }
                                                    ag.x[af] = M
                                                }
                                                ag.y.smps = [f.y.smps[m[0]], f.y.smps[m[1]]]
                                            } else {
                                                var ag = {
                                                    y: {},
                                                    z: {}
                                                };
                                                for (var af in f.y) {
                                                    var ar = [];
                                                    for (var am = 0; am < m.length; am++) {
                                                        ar.push(f.y[af][m[am]])
                                                    }
                                                    ag.z[af] = ar
                                                }
                                                ag.y.vars = [f.y.vars[m[0]], f.y.vars[m[1]]]
                                            }
                                            ag.y.data = ap[m[0]][m[1]];
                                            return ag;
                                        case "Venn":
                                            var ag = {
                                                venn: {
                                                    data: {}
                                                }
                                            };
                                            ag.venn.data[this.vennCompartments[m[0]]] = f.venn.data[this.vennCompartments[m[0]]];
                                            return ag;
                                        case "Network":
                                            var ag = {};
                                            if (!m || m.length == 0) {
                                                return
                                            } else {
                                                if (!this.isArray(m)) {
                                                    m = [m]
                                                }
                                            }
                                            if (isNaN(m[0])) {
                                                m[0] = m[0].toString();
                                                if (m[0].match(/legend/)) {
                                                    if (m[0].match(/Nodes/)) {
                                                        ag = {
                                                            nodeLegend: f.legend.nodes
                                                        }
                                                    } else {
                                                        if (m[0].match(/Edges/)) {
                                                            ag = {
                                                                edgeLegend: f.legend.edges
                                                            }
                                                        } else {
                                                            if (m[0].match(/Decorations/)) {
                                                                ag = {
                                                                    decorationLegend: f.legend.decorations
                                                                }
                                                            } else {
                                                                if (m[0].match(/-legend-indicator-color/)) {
                                                                    ag = {
                                                                        indicatorLegend: "ColorIndicator"
                                                                    }
                                                                } else {
                                                                    if (m[0].match(/legend-shape|legend-line-|legend-text/)) {
                                                                        ag = {
                                                                            display: m[0].split("-")[2]
                                                                        };
                                                                        ag = {}
                                                                    } else {
                                                                        var ab = parseInt(m[0].replace("-1-legend-Text", ""));
                                                                        ag = f.legend && f.legend.text ? {
                                                                            textLegend: f.legend.text[ab]
                                                                        } : {}
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (m[0].match(/-dec/)) {
                                                        var am = m[0].split("-");
                                                        var ah = f.nodes[am[0]];
                                                        var ap = this.decorations[am[1]];
                                                        var ad = ah.tooltip || ah.name || ah.label || ah.id;
                                                        var Z = ah[ap] ? ah[ap] : ah.decorations && ah.decorations[ap] ? ah.decorations[ap] : false;
                                                        var ak = am[3] ? am[2] : false;
                                                        if (ak) {
                                                            if (Z) {
                                                                if (Z[ak] != null) {
                                                                    ag.display = ad + "<br><b>" + ap + "</b> : " + ak + " : " + Z[ak]
                                                                } else {
                                                                    ag.display = ad + "<br><b>" + ap + "</b> : " + ak + " : NA"
                                                                }
                                                            } else {
                                                                ag.display = ad + "<br><b>" + ap + "</b> : NA"
                                                            }
                                                        } else {
                                                            ag.display = ad + "<br><b>" + ap + "</b> : " + (Z || "NA")
                                                        }
                                                    } else {
                                                        if (m[0].match(/-elbow/)) {
                                                            ag = {
                                                                edges: [f.edges[parseInt(m[0].split("-")) - f.nodes.length]]
                                                            }
                                                        } else {
                                                            if (m[0].match(/-lab/)) {
                                                                ag.nodes = [f.nodes[parseInt(m[0].split("-")[0])]]
                                                            } else {
                                                                if (m[0].match(/-edge/)) {
                                                                    ag = {
                                                                        edges: [f.edges[parseInt(m[0].split("-")) - f.nodes.length]]
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                for (var am = 0; am < m.length; am++) {
                                                    if (m[am] >= f.nodes.length) {
                                                        if (!ag.edges) {
                                                            ag.edges = []
                                                        }
                                                        ag.edges.push(f.edges[m[am] - f.nodes.length])
                                                    } else {
                                                        if (!ag.nodes) {
                                                            ag.nodes = []
                                                        }
                                                        ag.nodes.push(f.nodes[m[am]])
                                                    }
                                                }
                                            }
                                            return ag;
                                        case "Genome":
                                            var an;
                                            var ag = [];
                                            ag[0] = {
                                                data: []
                                            };
                                            var ab = 0;
                                            var ac = isNaN(m[0]) && m[0].match(":") ? m[0].match(/:(\d+)/)[1] : false;
                                            for (var am = 0; am < f.tracks.length; am++) {
                                                var ah = f.tracks[am].data.length;
                                                ab += ah;
                                                if (isNaN(m[0])) {
                                                    if (m[0] == "track-" + am) {
                                                        return {
                                                            name: f.tracks[am].name
                                                        }
                                                    } else {
                                                        if (m[0] == "track-" + am + ":" + ac) {
                                                            var ao = parseInt(ac) - (ab - ah);
                                                            for (var af in f.tracks[am]) {
                                                                if (af == "data") {
                                                                    ag[0][af].push(f.tracks[am][af][ao])
                                                                } else {
                                                                    ag[0][af] = f.tracks[am][af]
                                                                }
                                                            }
                                                            return ag
                                                        } else {
                                                            if (m[0] == "dataframe-" + am + ":" + ac) {
                                                                var U = f.tracks[am].data[0].data[ac].xAxis;
                                                                var T = f.tracks[am].data[0].data[ac].yAxis;
                                                                var X = f.tracks[am].dataframe;
                                                                ag = {
                                                                    display: "<b>" + U + "</b> :" + X[U][m[1]] + "<br><b>" + T + "</b> :" + X[T][m[1]] + "<br>"
                                                                };
                                                                if (f.tracks[am].data[0].data[ac].colorBy) {
                                                                    ag.display += "<b>" + f.tracks[am].data[0].data[ac].colorBy + "</b> :" + X[f.tracks[am].data[0].data[ac].colorBy][m[1]] + "<br>"
                                                                }
                                                                return ag
                                                            }
                                                        }
                                                    }
                                                    continue
                                                }
                                                if (m[m.length - 1] < ab) {
                                                    for (var al = 0; al < m.length; al++) {
                                                        var ao = m[al] - (ab - ah);
                                                        for (var af in f.tracks[am]) {
                                                            if (af == "data") {
                                                                ag[0][af].push(f.tracks[am][af][ao])
                                                            } else {
                                                                ag[0][af] = f.tracks[am][af]
                                                            }
                                                        }
                                                    }
                                                    return ag
                                                }
                                            }
                                    }
                                };
                                this.getSummaryDataObject = function(b, m) {
                                    if (b) {
                                        switch (this.graphType) {
                                            case "Bar":
                                            case "Line":
                                            case "Area":
                                            case "AreaLine":
                                            case "BarLine":
                                            case "Boxplot":
                                            case "Dotplot":
                                            case "DotLine":
                                            case "Fish":
                                            case "Heatmap":
                                            case "Stacked":
                                            case "StackedLine":
                                            case "StackedPercent":
                                            case "StackedPercentLine":
                                            case "Scatter2D":
                                            case "ScatterBubble2D":
                                            case "Scatter3D":
                                            case "Meter":
                                            case "Circular":
                                            case "Treemap":
                                            case "TagCloud":
                                            case "ParallelCoordinates":
                                            case "Map":
                                                var n = "";
                                                if (b.display) {
                                                    return b.objectType && b.objectType.match(/ScatterBoxplot|Dendrogram/) ? b.display : "<b>" + b.display + "</b><br>"
                                                } else {
                                                    if ((this.isGroupedData && b.w) || (this.configStndBy && this.configStndBy.groupingFactors && b.w)) {
                                                        n = "<b>" + b.w.vars[0] + "</b><br>";
                                                        if (this.summaryType == "mean") {
                                                            n += "<b>" + b.w.smps[0] + "</b>: " + this.formatNumber(b.w.mean[0]);
                                                            if (b.w.stdev && b.w.stdev[0] != null) {
                                                                n += " <i>&plusmn;" + this.formatNumber(b.w.stdev[0]) + "</i>"
                                                            }
                                                            if (b.w.n && b.w.n[0] != null) {
                                                                n += " (" + b.w.n + ")"
                                                            }
                                                            n += "<br>"
                                                        } else {
                                                            if (this.summaryType == "median" || this.summaryType == "iqr" || (this.graphType == "Boxplot")) {
                                                                if (b.w.labs && b.w.median && b.w.labs[0]) {
                                                                    n += "<b>" + b.w.labs[0] + "</b>: " + this.formatNumber(b.w.median[0])
                                                                } else {
                                                                    if (b.w.smps && b.w.median) {
                                                                        n += "<b>" + b.w.smps[0] + "</b>: " + this.formatNumber(b.w.median[0])
                                                                    }
                                                                }
                                                                if (b.w.stdev && b.w.stdev[0] != null) {
                                                                    n += " <i>&plusmn;" + this.formatNumber(b.w.stdev[0]) + "</i>"
                                                                }
                                                                if (b.w.n && b.w.n[0] != null) {
                                                                    n += " (" + b.w.n + ")"
                                                                }
                                                                n += "<br>"
                                                            } else {
                                                                if (this.summaryType == "sum") {
                                                                    n += "<b>" + b.w.smps[0] + "</b>: " + this.formatNumber(b.w.sum[0]);
                                                                    if (b.w.stdev && b.w.stdev[0] != null) {
                                                                        n += " <i>&plusmn;" + this.formatNumber(b.w.stdev[0]) + "</i>"
                                                                    }
                                                                    if (b.w.n && b.w.n[0] != null) {
                                                                        n += " (" + b.w.n + ")"
                                                                    }
                                                                    n += "<br>"
                                                                } else {
                                                                    if (this.summaryType == "min" || this.summaryType == "max" || this.summaryType == "count") {
                                                                        n += "<b>" + b.w.smps[0] + "</b>: " + this.formatNumber(b.w[this.summaryType][0]);
                                                                        n += "<br>"
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        if (this.graphType.match(/Boxplot|Dotplot|DotLine/) && b.y && b.y.smps) {
                                                            n += "<b>" + b.y.smps + "</b>: " + this.formatNumber(b.y.data) + "<br>"
                                                        } else {
                                                            if (this.graphType == "Boxplot" && b.w && b.w.iqr1) {
                                                                n = "<b>" + b.w.vars[0] + " - " + b.w.labs[0] + "</b><br>";
                                                                n += "<table>";
                                                                n += "<tr><th>1st IQR </th><td> : </td><td>" + this.formatNumber(b.w.iqr1[0]) + "</td></tr>";
                                                                n += "<tr><th>1st Qtl </th><td> : </td><td>" + this.formatNumber(b.w.qtl1[0]) + "</td></tr>";
                                                                n += "<tr><th>Median </th><td> : </td><td>" + this.formatNumber(b.w.median[0]) + "</td></tr>";
                                                                n += "<tr><th>3rd Qtl </th><td> : </td><td>" + this.formatNumber(b.w.qtl3[0]) + "</td></tr>";
                                                                n += "<tr><th>3rd IQR </th><td> : </td><td>" + this.formatNumber(b.w.iqr3[0]) + "</td></tr>";
                                                                n += "<tr><th>Outliers </th><td> : </td><td>" + b.w.out[0].length + "</td></tr>";
                                                                n += "<tr><th>N-Data</th><td> : </td><td>" + b.w.n + "</td></tr>";
                                                                n += "</table>"
                                                            }
                                                        }
                                                    } else {
                                                        if (b.y) {
                                                            n = "<b>" + b.y.vars[0] + "</b><br>";
                                                            for (var f = 0; f < b.y.smps.length; f++) {
                                                                if (this.isMultidimensionalData) {
                                                                    var p = [b.y.data[0][f]];
                                                                    var i = ["outline", "shape", "size"];
                                                                    for (var d = 0; d < i.length; d++) {
                                                                        var q = i[d] + "ByData";
                                                                        if (b.y[this[q]] && b.y[this[q]][0][f]) {
                                                                            p.push(b.y[this[q]][0][f])
                                                                        }
                                                                    }
                                                                    n += "<b>" + b.y.smps[f] + "</b>: " + p.join(", ") + "<br>"
                                                                } else {
                                                                    if (this.graphType == "Map" && this.motionBy && this.motionObject) {
                                                                        for (var d = 0; d < this.motionObject.levels.length; d++) {
                                                                            if (this.motionObject.levels[d] == this.motionObject.current) {
                                                                                if (b.y.data[d]) {
                                                                                    n += "<b>" + (this.isGraphTime ? this.dateFormat(b.y.smps[f], this.timeFormat) : b.y.smps[f]) + "</b>: " + b.y.data[d][f] + "<br>"
                                                                                } else {
                                                                                    n += "<b>" + (this.isGraphTime ? this.dateFormat(b.y.smps[f], this.timeFormat) : b.y.smps[f]) + "</b>: " + b.y.data[b.y.data.length - 1][f] + "<br>"
                                                                                }
                                                                            }
                                                                        }
                                                                    } else {
                                                                        if (b.y && b.y.histogram && f > 0) {} else {
                                                                            n += "<b>" + (this.isGraphTime ? this.dateFormat(b.y.smps[f], this.timeFormat) : b.y.smps[f]) + "</b>: " + b.y.data[0][f] + "<br>"
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        } else {
                                                            if (b && b.objectType == "Histogram") {
                                                                n = "<b>" + this[b.a].vars[b.b] + "</b><br>n: " + this[b.a].data[b.b][b.c] + "<br>"
                                                            } else {
                                                                if (b && b.objectType && b.objectType.match(/Dendrogram/)) {
                                                                    if (b.name) {
                                                                        n = "<b>" + b.name + "</b><br><i>Click to flip<br>Dbl-click to focus</i>"
                                                                    } else {
                                                                        if (this.graphType == "Circular") {
                                                                            n = b.nodeId ? "<i>Click to flip</i>" : ""
                                                                        } else {
                                                                            n = "<i>Click to flip<br>Dbl-click to focus</i>"
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                if (this.graphType == "Map" && b.c) {
                                                    n += b.c
                                                }
                                                return n.replace("u0000", "");
                                            case "Gantt":
                                                n = "";
                                                if (b.y) {
                                                    var u = this.dateFormat(this.parseDate(b.y.data[0][0]), this.timeFormat).replace(/-/g, "/");
                                                    var m = this.dateFormat(this.parseDate(b.y.data[1][0]), this.timeFormat).replace(/-/g, "/");
                                                    n = "<b>" + u + " - " + m + "</b><br>";
                                                    if (b.y.data.length > 2 && b.y.data[2][0]) {
                                                        n += "<b>Milestone</b>: " + this.dateFormat(this.parseDate(b.y.data[2][0]), this.timeFormat).replace(/-/g, "/") + "<br>"
                                                    }
                                                }
                                                return n;
                                            case "Sankey":
                                                if (b.links) {
                                                    var n = "<b>" + b.links.source.name + " &#8702; " + b.links.target.name + "</b><br>";
                                                    n += "<b>" + b.y.vars[0] + "</b>: " + b.y.data[0][0] + "<br>"
                                                } else {
                                                    if (b.display) {
                                                        return "<b>" + b.display + "</b><br>"
                                                    }
                                                }
                                                return n;
                                            case "Tree":
                                                if (b.display) {
                                                    return "<b>" + b.display + "</b><br>"
                                                } else {}
                                                return n;
                                            case "Pie":
                                                if (b.display) {
                                                    return "<b>" + b.display + "</b><br>"
                                                } else {
                                                    var r = "<b>" + b.y.smps[0] + "</b><br>";
                                                    for (var f = 0; f < b.y.vars.length; f++) {
                                                        var a = this.sprintf("%." + this.pieSegmentPrecision + "f", (b.y.data[f] / this.varPie.tot) * 100);
                                                        r += "<b>" + b.y.vars[f] + "</b>: " + b.y.data[f] + " (" + a + "%)<br>"
                                                    }
                                                    return r
                                                }
                                                case "Correlation":
                                                    var r;
                                                    if (this.correlationAxis == "samples") {
                                                        r = "<b>" + b.y.smps[0] + "</b> vs <b>" + b.y.smps[1] + "</b><br>Cor: " + Math.round(b.y.data * 100) / 100
                                                    } else {
                                                        r = "<b>" + b.y.vars[0] + "</b> vs <b>" + b.y.vars[1] + "</b><br>Cor: " + Math.round(b.y.data * 100) / 100
                                                    }
                                                    return r;
                                                case "Venn":
                                                    for (var g in b.venn.data) {
                                                        return g + " = " + b.venn.data[g]
                                                    }
                                                    case "Network":
                                                        var r;
                                                        if (b.display) {
                                                            return "<b>" + b.display + "</b><br>"
                                                        } else {
                                                            if (b && b.nodes) {
                                                                if (b.nodes[0]) {
                                                                    r = b.nodes[0].hideTooltip ? "" : b.nodes[0].tooltip || b.nodes[0].name || b.nodes[0].label || b.nodes[0].id
                                                                }
                                                                if (this.colorNodeBy) {
                                                                    r += "<br><b>" + this.colorNodeBy + "</b>: " + (b.nodes[0][this.colorNodeBy] || "")
                                                                }
                                                            } else {
                                                                if (b && b.edges) {
                                                                    var l = this.nodes[b.edges[0].id1];
                                                                    var h = this.nodes[b.edges[0].id2];
                                                                    r = (l.label || l.id) + " - " + (h.label || h.id);
                                                                    r = b.edges[0].hideTooltip ? "" : b.edges[0].tooltip || b.edges[0].name || b.edges[0].label || r
                                                                }
                                                            }
                                                        }
                                                        return r;
                                                    case "Genome":
                                                        return b.display || b.name || b[0].data[0].id
                                        }
                                    } else {
                                        return ""
                                    }
                                };
                                this.setUserEvents = function() {
                                    var d = {};
                                    var b = this.events;
                                    var a = this;
                                    if (this.disableEvents) {
                                        this.userEvents = {};
                                        return
                                    }
                                    d.enddragnode = function(g, f) {
                                        if (b && b.enddragnode) {
                                            b.enddragnode.call(f, g, f)
                                        }
                                    };
                                    d.select = function(h, g, f) {
                                        if (b && b.select) {
                                            b.select.call(f, h, g, f)
                                        }
                                    };
                                    d.enddraw = function(f) {
                                        if (b && b.enddraw) {
                                            b.enddraw.call(f, f)
                                        }
                                    };
                                    d.remoteupdate = function(f) {
                                        if (b && b.remoteupdate) {
                                            b.remoteupdate.call(f, f)
                                        }
                                    };
                                    d.motion = function(h, g, f) {
                                        if (!f) {
                                            f = a
                                        }
                                        if (!f.disableMotion) {
                                            f.resetSelected(g, true);
                                            f.addRemoveToSelected(false, {
                                                y: {
                                                    vars: [h],
                                                    smps: [h]
                                                }
                                            }, g);
                                            if (b && b.motion) {
                                                b.motion.call(f, h, g, f)
                                            }
                                            f.broadcastDraw({
                                                func: "userEventsMotion",
                                                par: [h, g, false]
                                            })
                                        }
                                    };
                                    d.drag = function(g, f) {
                                        if (b && b.drag) {
                                            b.drag.call(f, g, f)
                                        }
                                    };
                                    d.wheel = function(g, h, f) {
                                        if (b && b.wheel) {
                                            b.wheel.call(f, g, h, f)
                                        }
                                    };
                                    d.mouseout = function(j, h, g, f) {
                                        g.resetInfoSpan(h);
                                        if (b && b.mouseout) {
                                            b.mouseout.call(g, j, h, g, f)
                                        }
                                    };
                                    d.mouseup = function(j, h, g, f) {
                                        if (b && b.mouseup) {
                                            b.mouseout.call(g, j, h, g, f)
                                        }
                                    };
                                    d.contextmenu = function(j, h, g, f) {
                                        if (g.graphType == "Network") {
                                            if (h.ctrlKey) {
                                                return false
                                            }
                                            if (j && j.nodes && j.nodes.length == 1) {
                                                if (!CanvasXpress.selector.nodes.hasOwnProperty([j.nodes[0].id])) {
                                                    g.resetSelected(h)
                                                }
                                            }
                                        }
                                        g.addMenu(h);
                                        if (b && b.contextmenu) {
                                            b.contextmenu.call(g, j, h, g, f)
                                        }
                                    };
                                    d.click = function(m, l, j, h) {
                                        if (!j) {
                                            j = a
                                        }
                                        var f = function() {
                                            var n = l.ctrlKey;
                                            var i = l.altKey;
                                            if (n && i) {
                                                j.flashInfoSpan(10, 10, "Object printed to console", 3000);
                                                console.log(j.prettyJSON(m))
                                            } else {
                                                if (!n) {
                                                    j.resetSelected(l, true)
                                                }
                                                j.addRemoveToSelected(h, m, l);
                                                j.broadcastDraw({
                                                    func: "userEventsClick",
                                                    par: [m, l, false, h]
                                                });
                                                j.flashInfoSpan(10, 10, "Click ESC to reset graph", 3000)
                                            }
                                        };
                                        if (j.isDOE && h) {
                                            j.setActiveLayout(l);
                                            j.handleDOEClick(h)
                                        } else {
                                            if (m) {
                                                if (m && m.objectType) {
                                                    if (m.objectType.match(/Histogram|Stack/)) {
                                                        f()
                                                    } else {
                                                        if (m.objectType.match(/Dendrogram/)) {
                                                            j.modifyDendrogram(m)
                                                        } else {
                                                            if (m.objectType == "Tree") {
                                                                j.skipTransition = false;
                                                                j.handleTreeClick(m)
                                                            } else {
                                                                if (m.objectType == "Ring") {} else {
                                                                    if (m && m.objectType && m.selector) {
                                                                        j.handleSelector(m.selector);
                                                                        j.flashInfoSpan(10, 10, "Click ESC to reset graph", 3000)
                                                                    } else {
                                                                        j.logConsole("Click on " + m.display);
                                                                        if (j.verbose) {
                                                                            j.flashInfoSpan(100, 100, "Click on " + m.display, 3000)
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (m && (m.nodes || m.edges)) {
                                                        f();
                                                        if (m && m.nodes && m.nodes.length == 1 && m.nodes[0].links) {
                                                            j.showLinkDiv(l, m.nodes[0].links, m.nodes[0].label != null ? m.nodes[0].label : m.nodes[0].name ? m.nodes[0].name : m.nodes[0].id)
                                                        } else {
                                                            if (m && m.edges && m.edges.length == 1 && m.edges[0].links) {
                                                                j.showLinkDiv(l, m.edges[0].links, m.edges[0].label != null ? m.edges[0].label : m.edges[0].name ? m.edges[0].name : m.edges[0].id1 + "-" + m.edges[0].id2)
                                                            }
                                                        }
                                                    } else {
                                                        if (m.y || m.w || j.graphType == "Map") {
                                                            if (j.graphType && j.mapProjection == "orthographic") {
                                                                var k = j.adjustedCoordinates(l);
                                                                var g = j.geoProjectInvert([k.x, k.y]);
                                                                j.eventMapCenter = [-g[0], -g[1]]
                                                            }
                                                            f()
                                                        }
                                                    }
                                                }
                                            } else {
                                                j.resetSelected(l, !CanvasXpress.selector.selections)
                                            }
                                        }
                                        if (b && b.click) {
                                            b.click.call(j, m, l, j, h)
                                        }
                                        return false
                                    };
                                    d.dblclick = function(j, h, g, f) {
                                        if (j && j.objectType && j.objectType.match(/Dendrogram/) && g.graphType != "Circular") {
                                            g.zoomDendrogram(j)
                                        } else {
                                            if (j && j.objectType && j.objectType == "Ring") {} else {
                                                if (j && g.graphType == "Fish") {} else {
                                                    if (j && j.objectType) {
                                                        g.logConsole("Double Click on " + j.display);
                                                        if (this.verbose) {
                                                            g.flashInfoSpan(100, 100, "Double Click on " + j.display, 3000)
                                                        }
                                                    } else {
                                                        if (g.graphType == "Network" || g.graphType == "Genome") {
                                                            g.addConfigurator(h, f)
                                                        } else {
                                                            if (j && !g.graphType.match(/Tree|Circular/)) {
                                                                if (j.display && j.display.match(/Drag/)) {} else {
                                                                    g.showTooltipDiv(h, g.arrayToHTML(g.getDataClassAsArray(g.getUngroupedDataObject(j, f))), false, false, null, null, j)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (b && b.dblclick) {
                                            b.dblclick.call(g, j, h, g, f)
                                        }
                                        return false
                                    };
                                    d.mouseover = function(k, i, g, h) {
                                        if (b && b.mouseover) {
                                            b.mouseover.call(g, k, i, g, h)
                                        }
                                        var j = g.getSummaryDataObject(k, i);
                                        if (j && j != "") {
                                            g.showInfoSpan(i, j);
                                            if (k.objectType == "Chord") {
                                                g.handleChordMouseOver(k)
                                            }
                                            if (h && h[0].toString().match("elbow")) {
                                                var f = g.getTargetEvent(i);
                                                f.style.cursor = "move"
                                            }
                                        }
                                    };
                                    d.mousemove = function(k, i, g, h) {
                                        if (b && b.mousemove) {
                                            b.mousemove.call(g, k, i, g, h)
                                        }
                                        var j = g.getSummaryDataObject(k, i);
                                        if (j && j != "") {
                                            g.showInfoSpan(i, j);
                                            if (k.objectType == "Chord") {
                                                g.handleChordMouseOver(k)
                                            }
                                            if (h && h[0].toString().match("elbow")) {
                                                var f = g.getTargetEvent(i);
                                                f.style.cursor = "move"
                                            }
                                        }
                                    };
                                    this.userEvents = d
                                };
                                this.userEventsClick = function(f, d, b, a) {
                                    this.userEvents.click(f, d, b, a)
                                };
                                this.userEventsDblClick = function(f, d, b, a) {
                                    this.userEvents.dblclick(f, d, b, a)
                                };
                                this.userEventsMotion = function() {
                                    this.userEvents.motion(c, e, t)
                                };
                                this.userEventsMouseover = function(f, d, b, a) {
                                    this.userEvents.mouseover(f, d, b, a)
                                };
                                this.userEventsMousemove = function(f, d, b, a) {
                                    this.userEvents.mousemove(f, d, b, a)
                                };
                                this.userEventsDrag = function(b, a) {
                                    this.userEvents.drag(b, a)
                                };
                                this.userEventsWheel = function(b, f, a) {
                                    this.userEvents.wheel(b, f, a)
                                };
                                this.resetFlags = function(a) {
                                    this.resetOn = true;
                                    this.animationOn = false;
                                    this.skipTransition = false;
                                    this.draggingOn = false;
                                    this.movingOn = false;
                                    this.panningOn = false;
                                    this.changingColorOn = false;
                                    this.changingColorItemOn = false;
                                    this.changingSliderItemOn = false;
                                    this.keyOn = false;
                                    this.lassoOn = false;
                                    this.xMouseDown = false;
                                    this.yMouseDown = false;
                                    this.resetTouches();
                                    this.moveNode = false;
                                    this.moveNodeIndex = false;
                                    this.moveNodeLab = false;
                                    this.moveNodeDec = false;
                                    this.moveNodeX = false;
                                    this.moveNodeY = false;
                                    this.moveNodeW = false;
                                    this.moveNodeH = false;
                                    this.moveEdge = false;
                                    this.moveEdgeIndex = false;
                                    this.moveEdgeElbow = false;
                                    this.moveEdgeX = false;
                                    this.moveEdgeY = false;
                                    this.resizeNode = false;
                                    this.resizeLegend = false;
                                    this.moveLegend = false;
                                    this.moveLegendX = false;
                                    this.moveLegendY = false;
                                    this.moveMarker = false;
                                    this.moveMarkerX = false;
                                    this.moveMarkerY = false;
                                    this.moveSankey = false;
                                    this.moveSankeyX = false;
                                    this.moveSankeyY = false;
                                    this.moveGenome = false;
                                    this.moveMap = false;
                                    this.moveCircular = false;
                                    this.moveDendrogram = false;
                                    this.moveVar = false;
                                    this.moveSmp = false;
                                    this.moveVarOverlay = false;
                                    this.moveSmpOverlay = false;
                                    if (a) {
                                        this.stopEvent(a)
                                    }
                                    window.document.defaultAction = true;
                                    window.document.body.style.cursor = "default"
                                };
                                this.mousemoveDoc = function(a) {
                                    return function(i) {
                                        var b = i.target || i.srcElement;
                                        if (b.className == "CanvasXpress" && !CanvasXpress.resizing) {
                                            CanvasXpress.current = b.id
                                        }
                                        var g = function() {
                                            var m = "CanvasXpress<br>ver : " + CanvasXpress.factory.version + "<br>date : " + CanvasXpress.factory.buildDate;
                                            if (a.createVersion) {
                                                m += "<br><br>- Original Plot -<br>CanvasXpress<br>ver : " + a.createVersion
                                            }
                                            return m
                                        };
                                        var d = function() {
                                            if (b && b.className && b.className.toString().match(/canvasxpress/i)) {
                                                var o = a.isEvent(i);
                                                if (a.isDOE) {
                                                    a.setActiveLayout(i)
                                                }
                                                if (o || a.lassoSelected) {
                                                    if (b.className == "CanvasXpress") {
                                                        if (a.lassoPoints && a.lassoPoints.length) {
                                                            a.resetInfoSpan(i, true)
                                                        }
                                                        if (a.varIndicesStart > 0 || a.smpIndicesStart > 0 || a.grpIndicesStart > 0) {
                                                            b.style.cursor = "move"
                                                        }
                                                        var n = a.handleMouseEvents(i, "mousemove", a.isEventIndices(i, false, o));
                                                        if (!n) {
                                                            a.highlightCanvas(o)
                                                        }
                                                    }
                                                } else {
                                                    a.clearHighlightCanvas();
                                                    if (a.graphType == "Map" && a.canvasPointToCoordinate && b.className == "CanvasXpress") {
                                                        var p = a.canvasPointToCoordinate(a.xMouseMove, a.yMouseMove);
                                                        var m = " [ " + p[1].toFixed(1) + ", " + p[0].toFixed(1) + " ]";
                                                        a.showInfoSpan(i, m)
                                                    } else {
                                                        a.resetInfoSpan(i, true)
                                                    }
                                                }
                                            }
                                        };
                                        if (a.motioningOn) {
                                            return d()
                                        }
                                        if (CanvasXpress.system.isTouchScreen && i.type == "touchmove" && a.touches) {
                                            if (a.touchEvent == "click") {
                                                a.mouseupDoc()
                                            } else {
                                                if (a.touches.length > 1 && i.touches.length > 1 && a.touchEvent != "mousemove") {
                                                    a.touchEvent = "pinch";
                                                    var k = a.euclidianDistance([a.touches[0].clientX, a.touches[0].clientY], [a.touches[1].clientX, a.touches[1].clientY]);
                                                    var f = a.euclidianDistance([i.touches[0].clientX, i.touches[0].clientY], [i.touches[1].clientX, i.touches[1].clientY]);
                                                    var l = (i.touches[0].clientX + i.touches[1].clientX) / 2;
                                                    var h = (i.touches[0].clientY + i.touches[1].clientY) / 2;
                                                    if (Math.abs(f - k) > 100) {
                                                        return a.wheelCanvas(i, f - k, {
                                                            x: l,
                                                            y: h
                                                        })
                                                    }
                                                }
                                            }
                                            a.touchEvent = "mousemove"
                                        }
                                        if ((CanvasXpress.current && CanvasXpress.current == a.target) || (CanvasXpress.current && CanvasXpress.current == a.target2) || CanvasXpress.resizing || (b.id && b.id.match(/-cX-API-Example/))) {
                                            if (a.lastMousemove && a.graphType == "Scatter3D") {
                                                if (new Date().getTime() - a.lastMousemove < 100) {
                                                    return
                                                }
                                            }
                                            a.lastMousemove = new Date().getTime();
                                            a.isToolbar(i);
                                            a.isDataTableToolbar(i);
                                            if (a.isVersion(i)) {
                                                var j = a.$(a.target);
                                                j.style.cursor = "help";
                                                a.showInfoSpan([i.clientX, i.clientY + 30], g())
                                            } else {
                                                if (a.filteringNumericOn) {
                                                    a.preventSelection();
                                                    a.updateNumericFilter(i)
                                                } else {
                                                    if (a.filteringStringOn) {
                                                        a.preventSelection();
                                                        a.updateStringFilter(i)
                                                    } else {
                                                        if (a.draggingTargetOn) {
                                                            a.preventSelection();
                                                            a.updateMousemove(i)
                                                        } else {
                                                            if (a.resizingDataTableOn) {
                                                                a.preventSelection();
                                                                a.updateDataTableResizerDiv(i)
                                                            } else {
                                                                if (a.motionOn) {
                                                                    a.preventSelection();
                                                                    a.updateMotion(i)
                                                                } else {
                                                                    if (a.resizingDataTableColumnOn) {
                                                                        a.preventSelection();
                                                                        a.mousemoveDataTableHeader(i)
                                                                    } else {
                                                                        if (a.changingColorOn) {
                                                                            a.preventSelection();
                                                                            a.updateColorValue(i)
                                                                        } else {
                                                                            if (a.changingColorItemOn) {
                                                                                a.preventSelection();
                                                                                a.updateColorItemValue(false, i)
                                                                            } else {
                                                                                if (a.changingSliderItemOn) {
                                                                                    a.preventSelection();
                                                                                    a.updateSliderItemValue(i)
                                                                                } else {
                                                                                    if (a.isDOE && a.skipClick) {
                                                                                        a.preventSelection();
                                                                                        a.updateLayoutDrag(i);
                                                                                        d()
                                                                                    } else {
                                                                                        if (!a.configuringOn) {
                                                                                            if (a.draggingOn) {
                                                                                                a.preventSelection();
                                                                                                a.cancelEvent(i);
                                                                                                a.updateDrag(i);
                                                                                                a.lastCanvasEvent = "drag";
                                                                                                if (a.moveMarker) {
                                                                                                    return
                                                                                                }
                                                                                            } else {
                                                                                                if (a.resizingCanvasOn && a.resizeCanvasCursorShow) {
                                                                                                    a.preventSelection();
                                                                                                    a.cancelEvent(i);
                                                                                                    a.updateCanvasResizer(i);
                                                                                                    a.lastCanvasEvent = "resize"
                                                                                                } else {
                                                                                                    a.updateCanvasResizerCursor(i)
                                                                                                }
                                                                                            }
                                                                                            d()
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {}
                                        return false
                                    }
                                }(this);
                                this.registerMousemove = function(a) {
                                    return function(f) {
                                        var b = f.target || f.srcElement;
                                        if (a.motioningOn) {
                                            a.stopEvent(f)
                                        } else {
                                            if (a.hasClass(this, "CanvasXpressMenu")) {
                                                if (a.draggableTarget) {
                                                    return
                                                }
                                                var d = this;
                                                while (a.hasClass(d.previousSibling, "CanvasXpressMenu")) {
                                                    d = d.previousSibling
                                                }
                                                a.draggableTarget = d;
                                                a.draggableTargetEl = b;
                                                a.activeTarget = a.draggableTarget;
                                                a.activeTarget.style.zIndex = 10001;
                                                a.xMouseDown = f.clientX;
                                                a.yMouseDown = f.clientY;
                                                a.draggableXoffset = parseInt(a.draggableTarget.style.left) || 0;
                                                a.draggableYoffset = parseInt(a.draggableTarget.style.top) || 0;
                                                a.draggableTargetEl.style.cursor = "grabbing";
                                                a.draggableTargetEl.style.cursor = "-moz-grabbing";
                                                a.draggableTargetEl.style.cursor = "-webkit-grabbing";
                                                a.draggingTargetOn = true
                                            } else {
                                                if ((f.button == 1 && window.event != null || f.button == 0) && a.hasClass(b, "draggable") && b.className.match("CanvasXpressDataExplorer") && b.tagName.toUpperCase() == "SPAN") {
                                                    return
                                                } else {
                                                    if ((f.button == 1 && window.event != null || f.button == 0) && a.hasClass(b, "draggable")) {
                                                        if (a.activeTarget) {
                                                            a.activeTarget.style.zIndex = 10000
                                                        }
                                                        a.draggableTarget = b.parentNode && a.hasClass(b.parentNode, "draggable-container") ? b.parentNode : b;
                                                        a.activeTarget = a.draggableTarget;
                                                        a.activeTarget.style.zIndex = 10001;
                                                        a.xMouseDown = f.clientX;
                                                        a.yMouseDown = f.clientY;
                                                        a.draggableXoffset = parseInt(a.draggableTarget.style.left) || 0;
                                                        a.draggableYoffset = parseInt(a.draggableTarget.style.top) || 0;
                                                        a.draggingTargetOn = true;
                                                        a.removeMenus()
                                                    } else {
                                                        if (b.id == a.target + "-cX-ToolbarMove") {
                                                            a.draggableTarget = a.remoteService ? a.$(a.remoteParentId + "-canvasXpressRemoteWindow") : a.$("container-" + a.target);
                                                            a.activeTarget = a.draggableTarget;
                                                            a.activeTarget.style.zIndex = 10001;
                                                            a.xMouseDown = f.clientX;
                                                            a.yMouseDown = f.clientY;
                                                            a.draggableXoffset = parseInt(a.draggableTarget.style.left) || 0;
                                                            a.draggableYoffset = parseInt(a.draggableTarget.style.top) || 0;
                                                            a.draggingTargetOn = true;
                                                            a.removeMenus()
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }(this);
                                this.updateMousemove = function(i) {
                                    if (this.draggableTarget && this.draggableTarget.style) {
                                        var h = parseInt(this.draggableTarget.style.left);
                                        var g = parseInt(this.draggableTarget.style.top);
                                        var a = this.draggableXoffset + i.clientX - this.xMouseDown;
                                        var j = this.draggableYoffset + i.clientY - this.yMouseDown;
                                        this.draggableTarget.style.left = a + "px";
                                        this.draggableTarget.style.top = j + "px";
                                        this.draggableLastX = a;
                                        this.draggableLastY = j;
                                        if (this.draggableTarget.id == this.target + "-cX-DataTable" && this.dataTableLastState == "docked") {
                                            this.moveDataTableDiv("release")
                                        } else {
                                            if (this.hasClass(this.draggableTarget, "CanvasXpressMenu")) {
                                                var d = a - h;
                                                var b = j - g;
                                                var f = this.draggableTarget.nextSibling;
                                                while (f && this.hasClass(f, "CanvasXpressMenu")) {
                                                    f.style.left = (parseInt(f.style.left) + d) + "px";
                                                    f.style.top = (parseInt(f.style.top) + b) + "px";
                                                    f = f.nextSibling
                                                }
                                            }
                                        }
                                    }
                                };
                                this.endMousemove = function(a) {
                                    if (this.draggableTarget != null) {
                                        this.moveDataTableDiv();
                                        window.document.onselectstart = null;
                                        var b = this.remoteService ? this.remoteParentId + "-canvasXpressRemoteWindow" : "container-" + this.target;
                                        if (this.draggableTarget.id == b) {
                                            CanvasXpress.stack[this.target].afterRender.push(["moveCanvas", [this.draggableTarget.style.left, this.draggableTarget.style.top]]);
                                            this.draggableTarget.style.zIndex = "unset"
                                        }
                                        if (this.hasClass(this.draggableTarget, "CanvasXpressMenu")) {
                                            this.draggableTargetEl.style.cursor = "grab";
                                            this.draggableTargetEl.style.cursor = "-moz-grab";
                                            this.draggableTargetEl.style.cursor = "-webkit-grab";
                                            delete(this.draggableTargetEl)
                                        }
                                        this.yMouseDown = null;
                                        this.draggableXoffset = null;
                                        this.draggableYoffset = null;
                                        this.draggableTarget.ondragstart = null;
                                        this.draggableTarget = false;
                                        this.draggingTargetOn = false
                                    }
                                };
                                this.mousedownDoc = function(a) {
                                    return function(b) {
                                        a.mousedownElement = b.target || b.srcElement;
                                        return false
                                    }
                                }(this);
                                this.mouseupDoc = function(a) {
                                    return function(f) {
                                        var d = f.target || f.srcElement;
                                        var b = d.className;
                                        if ((CanvasXpress.current && CanvasXpress.current == a.target) || (CanvasXpress.current && CanvasXpress.current == a.target2) || (d && d.id && d.id.match(/-cX-API-Example/)) || a.resizingCanvasOn || a.draggingOn || a.draggingTargetOn) {
                                            a.resetMousePosition();
                                            if (a.motioningOn) {
                                                a.stopEvent(f);
                                                return false
                                            } else {
                                                if (a.draggingTargetOn) {
                                                    a.endMousemove(f)
                                                } else {
                                                    if (a.motionOn) {
                                                        a.endMotion(f)
                                                    } else {
                                                        if (a.resizingDataTableOn) {
                                                            a.endDataTableResizerDiv()
                                                        } else {
                                                            if (a.resizingDataTableColumnOn) {
                                                                a.endDataTableColumnResize(f)
                                                            } else {
                                                                if (a.changingColorOn) {
                                                                    a.endColorChange(f)
                                                                } else {
                                                                    if (a.changingColorItemOn) {
                                                                        a.endColorItemChange(f)
                                                                    } else {
                                                                        if (a.changingSliderItemOn) {
                                                                            a.endSliderItemChange(f)
                                                                        } else {
                                                                            if (a.isDOE && a.skipClick) {
                                                                                a.endDragLayout(f)
                                                                            } else {
                                                                                if (!a.configuringOn) {
                                                                                    if (a.isR && (!a.mousedownElement || a.mousedownElement.className.match(/shiny/i))) {
                                                                                        return
                                                                                    }
                                                                                    a.stopEvent(f);
                                                                                    a.endDrag(f);
                                                                                    a.endCanvasResizer(f);
                                                                                    a.endNumericFilter(f);
                                                                                    a.endStringFilter(f);
                                                                                    a.resetFlags(f)
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            if (a.userEvents[f.type]) {
                                                a.handleMouseEvents(f, f.type)
                                            }
                                        }
                                    }
                                }(this);
                                this.touchendDoc = function(a) {
                                    return function(b) {
                                        if (CanvasXpress.current && CanvasXpress.current == a.target || CanvasXpress.current && CanvasXpress.current == a.target2) {
                                            switch (a.touchEvent) {
                                                case "click":
                                                    var f = new Date().getTime() - (a.touches ? a.touches[0].time : 0);
                                                    if (f > 500) {
                                                        a.touchEvent = "reset";
                                                        a.masterReset(b)
                                                    } else {
                                                        a.clickCanvas(b)
                                                    }
                                                    break;
                                                case "dblclick":
                                                    a.dblclickCanvas(b);
                                                    break;
                                                case "contextmenu":
                                                    a.contextmenuCanvas(b);
                                                    break;
                                                case "mousemove":
                                                    a.mouseupDoc(b);
                                                    break;
                                                case "drag":
                                                    a.touchEvent = false;
                                                    break;
                                                case "pinch":
                                                    a.mouseupDoc(b);
                                                    break;
                                                case "mousewheel":
                                                    break;
                                                default:
                                                    a.mouseupDoc(b);
                                                    break
                                            }
                                            a.resetTouches();
                                            return false
                                        }
                                    }
                                }(this);
                                this.keydownDoc = function(a) {
                                    return function(d) {
                                        var b = d.target || d.srcElement;
                                        if (CanvasXpress.current && CanvasXpress.current == a.target || CanvasXpress.current && CanvasXpress.current == a.target2) {
                                            if (!a.configuringOn && !b.id.match(/cX-DataTableSearch/) && !b.id.match(/cX-DataFilter.+ContentSearch/) && !b.id.match(/cX-DataFilterInput/) && b.className != "CanvasXpressListItemScrollSearch") {
                                                a.registerKey(d)
                                            }
                                        } else {
                                            if (b.className.match(/CanvasXpressMap/)) {
                                                CanvasXpress.$(b._cX).registerKey(d)
                                            }
                                        }
                                    }
                                }(this);
                                this.keyupDoc = function(a) {
                                    return function(d) {
                                        var b = d.target || d.srcElement;
                                        if (b.parentNode && b.parentNode.id.match(/cX-DataTableToolbar/)) {
                                            if (b.id.match(a.target)) {
                                                a.keyOn = false;
                                                if (b.id.match(/cX-DataTableSearch/)) {
                                                    a.updateSearchDataTable(b.id)
                                                }
                                            }
                                            a.stopEvent()
                                        } else {
                                            if (CanvasXpress.current && CanvasXpress.current == a.target || CanvasXpress.current && CanvasXpress.current == a.target2) {
                                                a.keyOn = false;
                                                if (b.id.match(/cX-DataTableSearch/)) {
                                                    a.updateSearchDataTable(b.id)
                                                } else {
                                                    if (b.id.match(/cX-DataFilter.+ContentSearch/)) {
                                                        a.updateSearchFilters(b.id)
                                                    } else {
                                                        if (b.id.match(/cX-DataFilterInput/)) {
                                                            a.updateSelectStringFilter(b.id)
                                                        } else {
                                                            if (b.className == "CanvasXpressListItemScrollSearch") {
                                                                a.filterScrollSearch(b.id)
                                                            } else {
                                                                if (a.configuringOn) {
                                                                    a.selectConfig(d)
                                                                } else {
                                                                    if (a.remoteService) {
                                                                        a.selectDataSet(d)
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (b.className.match(/CanvasXpressMap/)) {}
                                            }
                                        }
                                    }
                                }(this);
                                this.resizeWindow = function(a) {
                                    return function(i) {
                                        var h;
                                        var g = function() {
                                            if (a.targetParentNodeResponsive) {
                                                var j = a.getMaxCanvasWidthHeight(a.$(a.target), a.targetParentNodeAspectRatio);
                                                a.setDimensions(j[0], j[1])
                                            }
                                        };
                                        var f = this;
                                        var d = arguments;
                                        var b = function() {
                                            h = null;
                                            g.apply(f, d)
                                        };
                                        clearTimeout(h);
                                        h = setTimeout(b, 250);
                                        a.scrollWindow(i)
                                    }
                                }(this);
                                this.scrollWindow = function(a) {
                                    return function(d) {
                                        for (var b = 0; b < CanvasXpress.instances.length; b++) {
                                            var f = CanvasXpress.instances[b];
                                            if (!f.loaded && f.lazyLoad) {
                                                if (a.isInViewport(f.meta.canvas.ctx.canvas)) {
                                                    f.continueInitialization()
                                                }
                                            }
                                        }
                                    }
                                }(this);
                                this.initDocEvents = function() {
                                    if (!this.disableEvents) {
                                        var a = window.document;
                                        if (!this.disableDocument) {
                                            this.addEvtListener(a, "mousedown", this.mousedownDoc, false);
                                            this.addEvtListener(a, "mousemove", this.mousemoveDoc, false);
                                            this.addEvtListener(a, "touchmove", this.mousemoveDoc, false);
                                            this.addEvtListener(a, "mouseup", this.mouseupDoc, false);
                                            this.addEvtListener(a, "touchend", this.touchendDoc, false)
                                        }
                                        if (!this.disableKeys) {
                                            this.addEvtListener(a, "keydown", this.keydownDoc, false);
                                            this.addEvtListener(a, "keyup", this.keyupDoc, false)
                                        }
                                        if (!this.disableWindow) {
                                            this.addEvtListener(window, "resize", this.resizeWindow, false);
                                            this.addEvtListener(window, "scroll", this.scrollWindow, false)
                                        }
                                    }
                                };
                                this.initializeEvents = function() {
                                    this.setUserEvents();
                                    this.initDraggingEvents();
                                    this.initCanvasResizerEvents();
                                    this.initMotionEvents();
                                    this.initKeyEvents();
                                    this.initSelectEvents();
                                    this.initDendrogramEvents();
                                    this.initCanvasEvents();
                                    this.initDocEvents();
                                    this.initCleanupEvents()
                                }
                            };
                            CanvasXpress.prototype.initAnimation = function() {
                                this.moveMenu = function(e, c) {
                                    var b = parseInt(e.style.left);
                                    var a = b - c;
                                    var d = (a - b) / 5;
                                    this.updateMoveMenu(e, b, a, d)
                                };
                                this.updateMoveMenu = function(e, b, a, d) {
                                    var c = this;
                                    b = this.stepResizeMove(b, a, d);
                                    e.style.left = Math.round(b) + "px";
                                    if (b == a) {
                                        return
                                    }
                                    setTimeout(function() {
                                        c.updateMoveMenu(e, b, a, d)
                                    }, 40)
                                };
                                this.resizeMoveObject = function(f, b, d, a, e, g) {
                                    f.style.left = Math.round(b) + "px";
                                    f.style.top = Math.round(d) + "px";
                                    f.style.width = Math.round(a) + "px";
                                    f.style.height = Math.round(e) + "px";
                                    if (g != null) {
                                        g()
                                    }
                                };
                                this.resizeMove = function(e, b, n, l, f, s, m, d) {
                                    if (e) {
                                        if (!d) {
                                            if (!s) {
                                                s = 500
                                            }
                                            var r = parseInt(e.style.left) || 0;
                                            var j = parseInt(e.style.top) || 0;
                                            var h = parseInt(e.style.width) || e.clientWidth || 0;
                                            var a = parseInt(e.style.height) || e.clientHeight || 0;
                                            var k = 1;
                                            if (s > 0) {
                                                k = s / 40
                                            }
                                            var p = b - r;
                                            if (p != 0) {
                                                p /= k
                                            }
                                            var i = n - j;
                                            if (i != 0) {
                                                i /= k
                                            }
                                            var g = l - h;
                                            if (g != 0) {
                                                g /= k
                                            }
                                            var u = f - a;
                                            if (u != 0) {
                                                u /= k
                                            }
                                            this.updateResizeMove(e, r, b, p, j, n, i, h, l, g, a, f, u, m)
                                        } else {
                                            e.style.left = Math.round(b) + "px";
                                            e.style.top = Math.round(n) + "px";
                                            e.style.width = Math.round(l) + "px";
                                            e.style.height = Math.round(f) + "px";
                                            if (m != null) {
                                                m()
                                            }
                                        }
                                    }
                                };
                                this.updateResizeMove = function(d, n, b, m, i, l, h, g, j, f, a, e, q, k) {
                                    if (d) {
                                        var p = this;
                                        n = this.stepResizeMove(n, b, m);
                                        i = this.stepResizeMove(i, l, h);
                                        g = this.stepResizeMove(g, j, f);
                                        a = this.stepResizeMove(a, e, q);
                                        d.style.left = Math.round(n) + "px";
                                        d.style.top = Math.round(i) + "px";
                                        d.style.width = Math.round(g) + "px";
                                        d.style.height = Math.round(a) + "px";
                                        if (n == b && i == l && a == e && g == j) {
                                            if (k != null) {
                                                k()
                                            }
                                            return
                                        }
                                        setTimeout(function() {
                                            p.updateResizeMove(d, n, b, m, i, l, h, g, j, f, a, e, q, k)
                                        }, 50)
                                    }
                                };
                                this.stepResizeMove = function(d, b, a) {
                                    if (a == 0 || d == b) {
                                        return b
                                    }
                                    d += a;
                                    if ((a > 0 && d >= b) || (a < 0 && d <= b)) {
                                        return b
                                    }
                                    return d
                                };
                                this.move = function(d, a, i, l, h, b) {
                                    if (d) {
                                        if (!b) {
                                            if (!l) {
                                                l = 1000
                                            }
                                            var k = parseInt(d.style.left) || 0;
                                            var f = parseInt(d.style.top) || 0;
                                            var g = 1;
                                            if (l > 0) {
                                                g = l / 40
                                            }
                                            var j = a - k;
                                            if (j != 0) {
                                                j /= g
                                            }
                                            var e = i - f;
                                            if (e != 0) {
                                                e /= g
                                            }
                                            this.updateMove(d, k, a, j, f, i, e, h)
                                        } else {
                                            d.style.left = Math.round(a) + "px";
                                            d.style.top = Math.round(i) + "px";
                                            if (h != null) {
                                                h()
                                            }
                                        }
                                    }
                                };
                                this.updateMove = function(b, i, a, h, e, g, d, f) {
                                    if (b) {
                                        var j = this;
                                        i = this.stepResizeMove(i, a, h);
                                        e = this.stepResizeMove(e, g, d);
                                        b.style.left = Math.round(i) + "px";
                                        b.style.top = Math.round(e) + "px";
                                        if (i == a && e == g) {
                                            if (f != null) {
                                                f()
                                            }
                                            return
                                        }
                                        setTimeout(function() {
                                            j.updateMove(b, i, a, h, e, g, d, f)
                                        }, 30)
                                    }
                                };
                                this.transitionAccordion = function(d, m, a, h, i, j) {
                                    var f = this;
                                    var k = new Date().getTime();
                                    var g = k - d;
                                    if (m <= g || j) {
                                        if (a) {
                                            a.style.height = this.dataFilterHeight + "px";
                                            a.style.display = "block"
                                        }
                                        if (h) {
                                            h.style.height = "0px";
                                            h.style.display = "none"
                                        }
                                        if (i) {
                                            i()
                                        }
                                        return
                                    }
                                    m -= g;
                                    var b = Math.round((m / 250) * this.dataFilterHeight);
                                    if (a) {
                                        a.style.height = (this.dataFilterHeight - b) + "px";
                                        a.style.display = "block"
                                    }
                                    if (h) {
                                        h.style.height = b + "px"
                                    }
                                    setTimeout(function() {
                                        f.transitionAccordion(k, m, a, h, i)
                                    }, 33)
                                };
                                this.createCarousel = function(e, q, g, b, v, d, l) {
                                    var a;
                                    if (!q) {
                                        q = 100
                                    }
                                    if (!g) {
                                        g = 100
                                    }
                                    if (!v) {
                                        v = 0
                                    }
                                    if (!d || (d != "vertical" && d != "horizontal")) {
                                        d = "vertical";
                                        a = "rotateX"
                                    } else {
                                        a = "rotateY"
                                    }
                                    var u = 360 / e.length;
                                    var k = Math.round(((d = "vertical" ? g : q) / 2) / Math.tan(Math.PI / e.length));
                                    var m = this.$cX("div", {
                                        id: this.newId("-cX-Carousel-"),
                                        className: "CanvasXpressCarouselScene",
                                        rotate: a,
                                        theta: u,
                                        radius: k,
                                        current: 0,
                                        limit: e.length - 1
                                    }, {
                                        width: (q + (v * 2)) + "px",
                                        height: (g + (v * 2)) + "px",
                                        perspective: b + "px"
                                    });
                                    if (l) {
                                        for (f in l) {
                                            m.style[f] = l[f]
                                        }
                                    }
                                    var n = this.$cX("div", {
                                        className: "CanvasXpressCarousel"
                                    });
                                    for (var f = 0; f < e.length; f++) {
                                        var j = this.$cX("div", {
                                            className: "CanvasXpressCarouselCell"
                                        }, {
                                            width: q + "px",
                                            height: g + "px",
                                            transform: a + "(" + (u * f) + "deg) translateZ(" + k + "px)"
                                        });
                                        j.appendChild(e[f]);
                                        n.appendChild(j)
                                    }
                                    m.appendChild(n);
                                    this.rotateCarousel(m, 6);
                                    return m
                                };
                                this.rotateCarousel = function(b, a) {
                                    b.firstChild.style.transform = "translateZ(" + -b.radius + "px) " + b.rotate + "(" + (b.theta * -a) + "deg)"
                                };
                                this.transitionMagic = function(g, f, h, a) {
                                    var b = this;
                                    if (!f) {
                                        f = "holeOut"
                                    }
                                    if (a == null) {
                                        a = 1000
                                    }
                                    g.style.opacity = 1;
                                    this.addClass(g, "magictime");
                                    this.addClass(g, f);
                                    setTimeout(function() {
                                        b.removeClass(g, "magictime");
                                        b.removeClass(g, f);
                                        if (h) {
                                            h()
                                        }
                                    }, a)
                                };
                                this.initTransitions = function() {
                                    if (!CanvasXpress.transitions) {
                                        CanvasXpress.transitions = {}
                                    }
                                    CanvasXpress.transitions[this.target] = []
                                };
                                this.isTransition = function() {
                                    if (this.isTransitionOn) {
                                        var a = arguments.callee.caller;
                                        if (a) {
                                            CanvasXpress.transitions[this.target].push([a, this.cleanEventInArguments(Array.from(a.arguments))])
                                        }
                                        return true
                                    } else {
                                        return false
                                    }
                                };
                                this.getTransitionSteps = function() {
                                    var c = [];
                                    var a = 1 / (this.transitionStep - 1);
                                    for (var b = 0; b < this.transitionStep; b++) {
                                        c.push(this.easeVal(a * b))
                                    }
                                    return c
                                };
                                this.getTransitionObjectsSteps = function(g, a, f) {
                                    var d = this.getTransitionSteps();
                                    var b = Math.ceil(g / this.getTransitionStaggeringSteps(f));
                                    var e = [];
                                    for (var c = 0; c < g; c++) {
                                        e.push(Math.max(0, d[Math.min(d.length - 1, Math.max(0, a - Math.floor(c / b)))]))
                                    }
                                    return e
                                };
                                this.getTransitionStaggeringSteps = function(a) {
                                    if (this.graphType == "Tree" || this.graphType.match(/Scatter/) || this.graphType == "Sankey" || this.graphType == "Circular" || this.graphType == "Correlation" || this.graphType == "Venn" || (this.decorations && this.decorations.kaplanMeier) || this.connectBy || (this.graphType.match(/Bar/) && this.barType == "lollipop" && !this.isGroupedData)) {
                                        return 1
                                    } else {
                                        if (a) {
                                            if (a == "Data") {
                                                return this.transitionStaggering
                                            } else {
                                                return 1
                                            }
                                        } else {
                                            return this.transitionStaggering
                                        }
                                    }
                                };
                                this.transition = function() {
                                    var d = this;
                                    var a = this.transitionStep + this.getTransitionStaggeringSteps();
                                    var e = this.mapTransitionObject();
                                    var c = d.meta.render.order;
                                    if (this.meta.render.transition) {
                                        for (var b in this.meta.render.transition.types) {
                                            if (!this.meta.render.types.hasOwnProperty(b)) {
                                                c.push(b)
                                            }
                                        }
                                    }
                                    this.transitionIter = 0;
                                    this.isTransitionOn = true;
                                    var f = function() {
                                        if (d.transitionIter >= a) {
                                            if (CanvasXpress.transitions[d.target].length > 0) {
                                                var h = CanvasXpress.transitions[d.target].shift();
                                                if (h[2]) {
                                                    for (var j in h[2]) {
                                                        d[j] = h[2][j]
                                                    }
                                                }
                                                d.isTransitionOn = false;
                                                return h[0].apply(d, h[1] || false)
                                            } else {
                                                d.isTransitionOn = false;
                                                return d.triggerDataLoaded("transition")
                                            }
                                        }
                                        for (var g = 0; g < c.length; g++) {
                                            if (e[c[g]]) {
                                                d.disableGradientTransparencyShadow();
                                                if (c[g] == "Data" && d.graphType == "Venn") {
                                                    d.rectangleClear(0, 0, d.width, d.height);
                                                    d.setGlobalCompositionOperation("lighter")
                                                }
                                                if ((c[g] == "Legends" || c[g] == "Labels") && d.graphType != "Circular") {
                                                    d.transitionPropertyDataTransparency(d.transitionIter, c[g])
                                                } else {
                                                    if (c[g] == "Size") {
                                                        d.transitionPropertyDataNoInterpolate(c[g])
                                                    } else {
                                                        d.transitionPropertyData(d.transitionIter, e[c[g]], c[g])
                                                    }
                                                }
                                                if (c[g] == "Data" && d.graphType == "Venn") {
                                                    d.setGlobalCompositionOperation("source-over")
                                                }
                                                d.enableGradientTransparencyShadow()
                                            }
                                        }
                                        d.transitionIter++;
                                        this.requestAnimationFrame(f)
                                    };
                                    f()
                                };
                                this.transitionPropertyData = function(M, W, m) {
                                    var J = this.meta.render.transition.objects;
                                    var g = this.meta.render.objects;
                                    var a = this.getTransitionObjectsSteps(W.length, M, m);
                                    var Q = W.length;
                                    for (var N = 0; N < Q; N++) {
                                        var D = a[N];
                                        var k = W[N][0];
                                        var F = W[N][1];
                                        var n = this.isObject(k) ? k : J[k];
                                        var K = this.isObject(F) ? F : g[F];
                                        if (!n || !K) {
                                            continue
                                        }
                                        var u = n.func;
                                        var L = K.func;
                                        if (u != L) {
                                            continue
                                        }
                                        var E = n.params;
                                        var T = K.params;
                                        switch (u) {
                                            case "drawShape":
                                                if (E[0] == "arch") {
                                                    var H = this.interpolateChord(E, T, D);
                                                    var A = H[0];
                                                    var v = H[1];
                                                    var B = H[2];
                                                    var O = H[3];
                                                    var V = this.interpolateColor(E[5], T[5], D);
                                                    this.drawShape(T[0], A, v, B, O, V, T[6], T[7], T[8], T[9], T[10], T[11], T[12], T[13], T[14], T[15])
                                                } else {
                                                    if (E[0] != T[0] && E[0] != "arc2" && T[0] != "arc2" && !E[0].match("roundrect") && !T[0].match("roundrect")) {
                                                        var A = this.interpolateNumber(E[1], T[1], D);
                                                        var v = this.interpolateNumber(E[2], T[2], D);
                                                        var B = this.interpolateNumber(E[3], T[3], D);
                                                        var O = this.interpolateNumber(E[4], T[4], D);
                                                        var V = this.interpolateColor(E[5], T[5], D);
                                                        var o = E[0].match(/circle|sphere/) && T[0].match(/rect|square/) && M > 5 ? T[0] : "oval";
                                                        var I = E[0] == "pie" || E[0].match(/arc/) ? this.interpolateNumber(E[12], T[12], D) : false;
                                                        var H = E[0] == "pie" || E[0].match(/arc/) ? this.interpolateNumber(E[13], T[13], D) : false;
                                                        var G = E[0] == "ellipse2" ? this.interpolateNumber(E[8], T[8], D) : false;
                                                        this.drawShape(o, A, v, B, O, V, T[6], T[7], G, T[9], T[10], T[11], I, H, T[14], T[15])
                                                    } else {
                                                        if (E[0] == "arc2" && T[0] != "arc2") {
                                                            var j = E[4] - (E[3] / 2);
                                                            var S = (j * Math.cos(E[12])) + E[1];
                                                            var d = (j * Math.sin(E[12])) + E[2];
                                                            var P = (j * Math.cos(E[13])) + E[1];
                                                            var b = (j * Math.sin(E[13])) + E[2];
                                                            var C = (S + P) / 2;
                                                            var U = (d + b) / 2;
                                                            var l = this.euclidianDistance([S, d], [P, b]);
                                                            var A = this.interpolateNumber(C, T[1], D);
                                                            var v = this.interpolateNumber(U, T[2], D);
                                                            var O = this.interpolateNumber(l, T[3], D);
                                                            var B = this.interpolateNumber(E[3], T[4], D);
                                                            var V = this.interpolateColor(E[5], T[5], D);
                                                            var I = this.interpolateNumber(E[12], T[12], D);
                                                            var H = this.interpolateNumber(E[13], T[13], D);
                                                            var G = this.interpolateNumber(E[12], Math.PI, D);
                                                            this.drawShape(T[0], A, v, Math.max(B, O), Math.min(B, O), V, T[6], T[7], G, T[9], T[10], T[11], I, H, T[14], T[15])
                                                        } else {
                                                            if (E[0] != "arc2" && T[0] == "arc2") {
                                                                var j = T[4] - (T[3] / 2);
                                                                var S = (j * Math.cos(T[12])) + T[1];
                                                                var d = (j * Math.sin(T[12])) + T[2];
                                                                var P = (j * Math.cos(T[13])) + T[1];
                                                                var b = (j * Math.sin(T[13])) + T[2];
                                                                var C = (S + P) / 2;
                                                                var U = (d + b) / 2;
                                                                var l = this.euclidianDistance([S, d], [P, b]);
                                                                var A = this.interpolateNumber(E[1], C, D);
                                                                var v = this.interpolateNumber(E[2], U, D);
                                                                var O = this.interpolateNumber(E[3], l, D);
                                                                var B = this.interpolateNumber(E[4], T[3], D);
                                                                var V = this.interpolateColor(E[5], T[5], D);
                                                                var I = E[0] == "pie" || E[0].match(/arc/) ? this.interpolateNumber(E[12], T[12], D) : false;
                                                                var H = E[0] == "pie" || E[0].match(/arc/) ? this.interpolateNumber(E[13], T[13], D) : false;
                                                                var G = this.interpolateNumber(Math.PI, T[12], D);
                                                                this.drawShape(E[0], A, v, Math.max(B, O), Math.min(B, O), V, T[6], T[7], G, T[9], T[10], T[11], I, H, T[14], T[15])
                                                            } else {
                                                                if (E[0] == "arrow" && T[0] == "arrow") {
                                                                    var A = this.interpolateNumber(E[8] == T[8] ? E[1] : E[2], T[1], D);
                                                                    var v = this.interpolateNumber(E[8] == T[8] ? E[2] : E[1], T[2], D);
                                                                    var B = this.interpolateNumber(E[8] == T[8] ? E[3] : E[4], T[3], D);
                                                                    var O = this.interpolateNumber(E[8] == T[8] ? E[4] : E[3], T[4], D);
                                                                    var V = this.interpolateColor(E[5], T[5], D);
                                                                    var G = E[8] == T[8] ? E[8] : !E[8] && T[8] ? true : false;
                                                                    this.drawShape(T[0], A, v, B, O, V, T[6], T[7], G, T[9], T[10])
                                                                } else {
                                                                    var A = this.interpolateNumber(E[1], T[1], D);
                                                                    var v = this.interpolateNumber(E[2], T[2], D);
                                                                    var B = this.interpolateNumber(E[3], T[3], D);
                                                                    var O = this.interpolateNumber(E[4], T[4], D);
                                                                    var V = this.interpolateColor(E[5], T[5], D);
                                                                    var I = E[0] == "pie" || E[0].match(/arc/) ? this.interpolateNumber(E[12], T[12], D) : false;
                                                                    var H = E[0] == "pie" || E[0].match(/arc/) ? this.interpolateNumber(E[13], T[13], D) : false;
                                                                    var G = E[0] == "ellipse2" ? this.interpolateNumber(E[8], T[8], D) : false;
                                                                    this.drawShape(T[0], A, v, B, O, V, T[6], T[7], G, T[9], T[10], T[11], I, H, T[14], T[15])
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                break;
                                            case "drawLine":
                                                var S = this.interpolateNumber(E[1], T[1], D);
                                                var d = this.interpolateNumber(E[2], T[2], D);
                                                var P = this.interpolateNumber(E[3], T[3], D);
                                                var b = this.interpolateNumber(E[4], T[4], D);
                                                var B = E[0] == "error" ? this.interpolateNumber(E[6], T[6], D) : T[6];
                                                var V = this.interpolateColor(E[5], T[5], D);
                                                this.drawLine(T[0], S, d, P, b, V, B, T[7], T[8], T[9], T[10], T[11], T[12], T[13], T[14]);
                                                break;
                                            case "drawText":
                                                var A = this.interpolateNumber(E[1], T[1], D);
                                                var v = this.interpolateNumber(E[2], T[2], D);
                                                var R = this.interpolateTextFont(E[3], T[3], D);
                                                var V = this.interpolateColor(E[4], T[4], D);
                                                var G = this.interpolateNumber(E[7] || 0, T[7] || 0, D);
                                                this.drawText(T[0], A, v, R, V, T[5], T[6], G, T[8], T[9], T[10], T[11]);
                                                break;
                                            case "drawArcText":
                                                var A = this.interpolateNumber(E[1], T[1], D);
                                                var v = this.interpolateNumber(E[2], T[2], D);
                                                var G = this.interpolateNumber(E[3], T[3], D);
                                                var I = this.interpolateNumber(E[4], T[4], D);
                                                var H = this.interpolateNumber(E[5], T[5], D);
                                                var R = this.interpolateTextFont(E[6], T[6], D);
                                                var V = this.interpolateColor(E[7], T[7], D);
                                                this.drawArcText(T[0], A, v, G, I, H, R, V, T[8], T[9], T[10], T[11]);
                                                break;
                                            default:
                                                if (!this.layoutValid && this.graphType != "Correlation" && m != "Axes") {
                                                    this[u].apply(this, T)
                                                }
                                                break
                                        }
                                    }
                                };
                                this.transitionPropertyDataNoInterpolate = function(g) {
                                    var b = this.meta.render.types.hasOwnProperty(g) ? this.meta.render.types[g].all : [];
                                    for (var c = 0; c < b.length; c++) {
                                        var a = this.meta.render.objects[b[c]];
                                        var d = a.func;
                                        var f = a.params;
                                        switch (d) {
                                            case "drawShape":
                                                this.drawShape(f[0], f[1], f[2], f[3], f[4], f[5], f[6], f[7], f[8], f[9], f[10], f[11], f[12], f[13], f[14], f[15]);
                                                break;
                                            case "drawLine":
                                                this.drawLine(f[0], f[1], f[2], f[3], f[4], f[5], f[6], f[7], f[8], f[9], f[10], f[11], f[12], f[13], f[14]);
                                                break;
                                            case "drawText":
                                                this.drawText(f[0], f[1], f[2], f[3], f[4], f[5], f[6], f[7], f[8], f[9], f[10], f[11]);
                                                break;
                                            case "drawArcText":
                                                this.drawArcText(f[0], f[1], f[2], f[3], f[4], f[5], f[6], f[7], f[8], f[9], f[10], f[11]);
                                                break
                                        }
                                    }
                                };
                                this.transitionPropertyDataTransparency = function(j, b) {
                                    var d = this.meta.render.types.hasOwnProperty(b) ? this.meta.render.types[b].all : [];
                                    var h = this.getTransitionObjectsSteps(d.length, j);
                                    for (var f = 0; f < d.length; f++) {
                                        var a = this.meta.render.objects[d[f]];
                                        var c = a.func;
                                        var g = a.params;
                                        var k = h[f];
                                        switch (c) {
                                            case "drawShape":
                                                this.drawShape(g[0], g[1], g[2], g[3], g[4], this.addColorTransparency(g[5], k, true), this.addColorTransparency(g[6], k, true), g[7], g[8], g[9], g[10], g[11], g[12], g[13], g[14], g[15]);
                                                break;
                                            case "drawLine":
                                                this.drawLine(g[0], g[1], g[2], g[3], g[4], this.addColorTransparency(g[5], k, true), g[6], g[7], g[8], g[9], g[10], g[11], g[12], g[13], g[14]);
                                                break;
                                            case "drawText":
                                                this.drawText(g[0], g[1], g[2], g[3], this.addColorTransparency(g[4], k, true), g[5], g[6], g[7], g[8], g[9], g[10], g[11]);
                                                break;
                                            case "drawArcText":
                                                this.drawArcText(g[0], g[1], g[2], g[3], g[4], g[5], g[6], this.addColorTransparency(g[7], k, true), g[8], g[9], g[10], g[11]);
                                                break
                                        }
                                    }
                                };
                                this.transitionMap = function(b, g) {
                                    var f = b;
                                    var e = f.getTransitionSteps();
                                    var a = f.transitionStep;
                                    var d = f.geoProjection.rotate();
                                    var c = f.eventMapCenter;
                                    f.transitionIter = 0;
                                    f.isTransitionOn = true;
                                    var h = function() {
                                        if (f.transitionIter >= a) {
                                            delete f.eventMapZoom;
                                            delete f.eventMapCenter;
                                            f.isTransitionOn = false;
                                            return f.draw({
                                                func: "broadcastDraw",
                                                par: [g]
                                            })
                                        }
                                        var j = e[f.transitionIter++];
                                        var k = f.interpolateNumber(d[0], c[0], j);
                                        var i = f.interpolateNumber(d[1], c[1], j);
                                        f.geoProjection.rotate([k, i]);
                                        f.eventMapCenter = [k, i];
                                        f.draw({
                                            func: "broadcastDraw",
                                            par: [g]
                                        });
                                        f.requestAnimationFrame(h)
                                    };
                                    h()
                                };
                                this.easeVal = function(a) {
                                    switch (this.transitionFunction) {
                                        case "linear":
                                            return a;
                                        case "easeInQuad":
                                            return a * a;
                                        case "easeOutQuad":
                                            return a * (2 - a);
                                        case "easeInOutQuad":
                                            return a < 0.5 ? 2 * a * a : -1 + (4 - 2 * a) * a;
                                        case "easeInCubic":
                                            return a * a * a;
                                        case "easeOutCubic":
                                            return (--a) * a * a + 1;
                                        case "easeInOutCubic":
                                            return a < 0.5 ? 4 * a * a * a : (a - 1) * (2 * a - 2) * (2 * a - 2) + 1;
                                        case "easeInQuart":
                                            return a * a * a * a;
                                        case "easeOutQuart":
                                            return 1 - (--a) * a * a * a;
                                        case "easeInOutQuart":
                                            return a < 0.5 ? 8 * a * a * a * a : 1 - 8 * (--a) * a * a * a;
                                        case "easeInQuint":
                                            return a * a * a * a * a;
                                        case "easeOutQuint":
                                            return 1 + (--a) * a * a * a * a;
                                        case "easeInOutQuint":
                                            return a < 0.5 ? 16 * a * a * a * a * a : 1 + 16 * (--a) * a * a * a * a;
                                        default:
                                            return a
                                    }
                                };
                                this.interpolateNumber = function(q, p, v) {
                                    var o = [];
                                    var u = this.isArray(q);
                                    var r = this.isArray(p);
                                    if (u && r) {
                                        var m = q.length;
                                        for (var l = 0; l < m; l++) {
                                            var n = [];
                                            var k = this.isArray(q[l]);
                                            var e = this.isArray(p[l]);
                                            if (k && e) {
                                                var s = q[l].length;
                                                for (var h = 0; h < s; h++) {
                                                    n.push(q[l][h] + v * (p[l][h] - q[l][h]))
                                                }
                                                o.push(n)
                                            } else {
                                                if (k) {
                                                    var s = q[l].length;
                                                    for (var h = 0; h < s; h++) {
                                                        n.push(q[l][h] + v * (p[l] - q[l][h]))
                                                    }
                                                    o.push(n)
                                                } else {
                                                    if (e) {
                                                        var f = p[l].length;
                                                        for (var h = 0; h < f; h++) {
                                                            n.push(q[l] + v * (p[l][h] - q[l]))
                                                        }
                                                        o.push(n)
                                                    } else {
                                                        o.push(q[l] + v * (p[l] - q[l]))
                                                    }
                                                }
                                            }
                                        }
                                        return o
                                    } else {
                                        if (u) {
                                            var m = q.length;
                                            for (var l = 0; l < m; l++) {
                                                o.push(q[l] + v * (p - q[l]))
                                            }
                                            return o
                                        } else {
                                            if (r) {
                                                var g = p.length;
                                                for (var l = 0; l < g; l++) {
                                                    o.push(q + v * (p[l] - q))
                                                }
                                                return o
                                            } else {
                                                return q + v * (p - q)
                                            }
                                        }
                                    }
                                };
                                this.interpolateChord = function(q, i, o) {
                                    var n = this.interpolateNumber(q[3], i[3], o);
                                    var g = this.interpolateNumber(q[4], i[4], o);
                                    var f = this.interpolateNumber(q[1][1], i[1][1], o);
                                    var d = this.interpolateNumber(q[2][1], i[2][1], o);
                                    var c = f + (g[0] * Math.cos(n[0]));
                                    var m = d + (g[0] * Math.sin(n[0]));
                                    var b = f + (g[1] * Math.cos(n[3]));
                                    var l = d + (g[1] * Math.sin(n[3]));
                                    var a = f + (g[1] * Math.cos(n[2]));
                                    var k = d + (g[1] * Math.sin(n[2]));
                                    var p = f + (g[0] * Math.cos(n[1]));
                                    var j = d + (g[0] * Math.sin(n[1]));
                                    return [
                                        [c, f, b, a, f, p],
                                        [m, d, l, k, d, j], n, g
                                    ]
                                };
                                this.interpolateColor = function(e, d, f) {
                                    if (e instanceof CanvasGradient) {
                                        return e
                                    }
                                    if (d instanceof CanvasGradient) {
                                        return d
                                    }
                                    e = this.colorAsArray(e);
                                    d = this.colorAsArray(d);
                                    var g = [];
                                    g[0] = parseInt(this.interpolateNumber(e[0], d[0], f));
                                    g[1] = parseInt(this.interpolateNumber(e[1], d[1], f));
                                    g[2] = parseInt(this.interpolateNumber(e[2], d[2], f));
                                    if (e.length == 4 && d.length == 4) {
                                        g[3] = parseInt(this.interpolateNumber(e[3], d[3], f) * 10) / 10
                                    } else {
                                        g[3] = parseInt(this.interpolateNumber(e[3] != null ? e[3] : 1, d[3] != null ? d[3] : 1, f) * 10) / 10
                                    }
                                    return (g.length == 4 ? "rgba(" : "rgb(") + g.join(",") + ")"
                                };
                                this.interpolateTextFont = function(d, c, f) {
                                    var g = this.getFontPt(d);
                                    var e = this.getFontPt(c);
                                    var h = Math.floor(this.interpolateNumber(g, e, f));
                                    return d.replace(g, h)
                                };
                                this.setTransitionObject = function(c, j, k) {
                                    var h = c.func;
                                    var d = this.meta.render;
                                    var l = this.meta.render.transition;
                                    var e = function() {
                                        return j ? d.objects[c.group] : l.objects[c.group];
                                        var a = j ? d.objects[c.group].id : l.objects[c.group].id;
                                        return j ? l.objects[l.map[a]] : d.objects[d.map[a]]
                                    };
                                    switch (h) {
                                        case "drawShape":
                                            var n = c.params[0];
                                            switch (n) {
                                                case "box":
                                                case "rect":
                                                case "rectangle":
                                                case "roundrect":
                                                case "roundrectt":
                                                case "roundrectr":
                                                case "roundrectb":
                                                case "roundrectl":
                                                    if (c.baseline != null) {
                                                        if (this.isArray(c.baseline) && c.baseline.length == 4) {
                                                            c.params[1] = c.baseline[0];
                                                            c.params[2] = c.baseline[1];
                                                            c.params[3] = c.baseline[2];
                                                            c.params[4] = c.baseline[3]
                                                        } else {
                                                            if (this.isArray(c.baseline)) {
                                                                c.params[1] = c.baseline[0];
                                                                c.params[2] = c.baseline[1];
                                                                c.params[3] = 0;
                                                                c.params[4] = 0
                                                            } else {
                                                                if (this.graphOrientation == "vertical") {
                                                                    c.params[2] = c.baseline;
                                                                    c.params[4] = 0
                                                                } else {
                                                                    c.params[1] = c.baseline;
                                                                    c.params[3] = 0
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (this.graphOrientation == "vertical") {
                                                            c.params[2] += c.params[4] / 2;
                                                            c.params[4] = 0
                                                        } else {
                                                            c.params[1] -= c.params[3] / 2;
                                                            c.params[3] = 0
                                                        }
                                                    }
                                                    break;
                                                case "spline":
                                                    if (c.baseline != null) {
                                                        if (this.isArray(c.baseline)) {
                                                            c.params[1] = this.replaceArray(c.params[1], c.baseline[0]);
                                                            c.params[2] = this.replaceArray(c.params[2], c.baseline[1])
                                                        } else {
                                                            if (this.graphOrientation == "vertical") {
                                                                c.params[2] = this.replaceArray(c.params[2], c.baseline)
                                                            } else {
                                                                c.params[1] = this.replaceArray(c.params[1], c.baseline)
                                                            }
                                                        }
                                                    }
                                                    break;
                                                case "violin":
                                                    if (c.baseline != null) {
                                                        if (this.isArray(c.baseline)) {
                                                            c.params[1][0] = c.baseline[0];
                                                            c.params[1][1] = c.baseline[0];
                                                            c.params[2][0] = c.baseline[1];
                                                            c.params[2][1] = c.baseline[1]
                                                        }
                                                    }
                                                    break;
                                                case "confidence":
                                                    if (c.baseline != null) {
                                                        if (this.isArray(c.baseline)) {
                                                            for (var g = 0; g < c.params[1].length; g++) {
                                                                c.params[1][g][0] = c.params[1][g][1] = c.baseline[g][0];
                                                                c.params[2][g][0] = c.params[2][g][1] = c.baseline[g][1]
                                                            }
                                                        } else {
                                                            if (this.graphOrientation == "vertical") {
                                                                for (var g = 0; g < c.params[2].length; g++) {
                                                                    c.params[2][g][0] = c.params[2][g][1] = c.baseline
                                                                }
                                                            } else {
                                                                for (var g = 0; g < c.params[1].length; g++) {
                                                                    c.params[1][g][0] = c.params[1][g][1] = c.baseline
                                                                }
                                                            }
                                                        }
                                                    }
                                                    break;
                                                case "polygon":
                                                    for (var g = 1; g < c.params[1].length; g++) {
                                                        c.params[1][g] = c.params[1][0];
                                                        c.params[2][g] = c.params[2][0]
                                                    }
                                                    break;
                                                case "arc2":
                                                    c.params[3] = 0;
                                                    c.params[4] = 0;
                                                    c.params[12] = 0;
                                                    c.params[13] = 0;
                                                    break;
                                                case "pie":
                                                    c.params[12] = 0;
                                                    c.params[13] = 0;
                                                    break;
                                                case "arch":
                                                    c.params[1][0] = c.params[1][2] = c.params[1][3] = c.params[1][5] = c.params[1][1];
                                                    c.params[2][0] = c.params[2][2] = c.params[2][3] = c.params[2][5] = c.params[2][1];
                                                    c.params[3][0] = c.params[3][1] = c.params[3][2] = c.params[3][3] = 0;
                                                    c.params[4] = [1, 1];
                                                    break;
                                                default:
                                                    if (c.baseline != null) {
                                                        if (this.isArray(c.baseline)) {
                                                            c.params[1] = c.baseline[0];
                                                            c.params[2] = c.baseline[1];
                                                            c.params[3] = c.baseline[2] || 0;
                                                            c.params[4] = c.baseline[3] || 0
                                                        } else {
                                                            if (this.graphOrientation == "vertical") {
                                                                c.params[2] = c.baseline;
                                                                c.params[3] = 0;
                                                                c.params[4] = 0
                                                            } else {
                                                                c.params[1] = c.baseline;
                                                                c.params[3] = 0;
                                                                c.params[4] = 0
                                                            }
                                                        }
                                                    } else {
                                                        c.params[3] = 0;
                                                        c.params[4] = 0
                                                    }
                                                    if (n == "ellipse2") {
                                                        c.params[8] = c.params[8] > 0 ? Math.PI / 2 : -Math.PI / 2
                                                    }
                                                    break
                                            }
                                            if (!j) {
                                                c.params[5] = this.addColorTransparency(c.params[5], 0, true);
                                                c.params[6] = this.addColorTransparency(c.params[6], 0, true)
                                            }
                                            break;
                                        case "drawLine":
                                            var n = c.params[0];
                                            switch (n) {
                                                case "error":
                                                    var b = e();
                                                    if (b) {
                                                        if (c.params[6] > 0) {
                                                            c.params[1] = c.params[3] = b.baseline || b.params[1]
                                                        } else {
                                                            c.params[2] = c.params[4] = b.baseline || b.params[2]
                                                        }
                                                        c.params[6] = 0
                                                    }
                                                    break;
                                                case "median":
                                                    var b = e();
                                                    if (b) {
                                                        if (this.graphOrientation == "vertical") {
                                                            c.params[1] = c.params[3] = (c.params[1] + c.params[3]) / 2;
                                                            c.params[2] = c.params[4] = b.baseline || b.params[2]
                                                        } else {
                                                            c.params[2] = c.params[4] = (c.params[2] + c.params[4]) / 2;
                                                            c.params[1] = c.params[3] = b.baseline || b.params[1]
                                                        }
                                                    }
                                                    break;
                                                case "spline":
                                                    if (c.baseline != null) {
                                                        if (this.isArray(c.baseline)) {
                                                            for (var g = 0; g < c.params[1].length; g++) {
                                                                c.params[1][g] = c.baseline[0];
                                                                c.params[2][g] = c.baseline[1]
                                                            }
                                                        } else {
                                                            if (this.graphOrientation == "vertical") {
                                                                for (var g = 0; g < c.params[2].length; g++) {
                                                                    c.params[2][g] = c.baseline
                                                                }
                                                            } else {
                                                                for (var g = 0; g < c.params[1].length; g++) {
                                                                    c.params[1][g] = c.baseline
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (this.graphOrientation == "vertical") {
                                                            for (var g = 1; g < c.params[1].length; g++) {
                                                                c.params[1][g] = c.params[1][0]
                                                            }
                                                        } else {
                                                            for (var g = 1; g < c.params[2].length; g++) {
                                                                c.params[2][g] = c.params[2][0]
                                                            }
                                                        }
                                                    }
                                                    break;
                                                case "arc":
                                                    c.params[3] = 0;
                                                    c.params[4] = 0;
                                                    c.params[8] = 0;
                                                    c.params[9] = 0;
                                                    break;
                                                default:
                                                    if (k) {
                                                        c.params[5] = this.addColorTransparency(c.params[5], 0, true);
                                                        c.params[6] = 0.1
                                                    } else {
                                                        if (c.baseline != null) {
                                                            if (this.isArray(c.baseline)) {
                                                                if (c.baseline.length == 4) {
                                                                    c.params[1] = c.baseline[0];
                                                                    c.params[2] = c.baseline[1];
                                                                    c.params[3] = c.baseline[2];
                                                                    c.params[4] = c.baseline[3]
                                                                } else {
                                                                    c.params[1] = c.baseline[0];
                                                                    c.params[2] = c.baseline[1];
                                                                    c.params[3] = c.baseline[0];
                                                                    c.params[4] = c.baseline[1]
                                                                }
                                                            } else {
                                                                if (this.graphOrientation == "vertical") {
                                                                    c.params[2] = c.baseline;
                                                                    c.params[4] = c.baseline
                                                                } else {
                                                                    c.params[1] = c.baseline;
                                                                    c.params[3] = c.baseline
                                                                }
                                                            }
                                                        } else {
                                                            if (this.graphOrientation == "vertical") {
                                                                c.params[3] = c.params[1];
                                                                c.params[4] = c.params[2]
                                                            } else {
                                                                c.params[3] = c.params[1];
                                                                c.params[4] = c.params[2]
                                                            }
                                                        }
                                                    }
                                                    break
                                            }
                                            if (!j) {
                                                c.params[5] = this.addColorTransparency(c.params[5], 0, true)
                                            }
                                            break;
                                        case "drawText":
                                            if (c.baseline != null) {
                                                if (this.isArray(c.baseline)) {
                                                    c.params[1] = c.baseline[0];
                                                    c.params[2] = c.baseline[1];
                                                    if (c.baseline[2]) {
                                                        c.params[3] = c.baseline[2]
                                                    }
                                                    if (c.baseline[3]) {
                                                        c.params[4] = c.baseline[3]
                                                    }
                                                    if (c.baseline[4]) {
                                                        c.params[7] = c.baseline[4]
                                                    }
                                                } else {
                                                    if (this.graphOrientation == "vertical") {
                                                        c.params[2] = c.baseline
                                                    } else {
                                                        c.params[1] = c.baseline
                                                    }
                                                }
                                            } else {
                                                c.params[3] = "1px " + this.fontName;
                                                c.params[4] = "rgba(0,0,0,0)"
                                            }
                                            if (!j) {
                                                c.params[3] = "1px " + this.fontName;
                                                c.params[4] = "rgba(0,0,0,0)"
                                            }
                                            break;
                                        case "drawArcText":
                                            c.params[1] = this.cx || this.width / 2;
                                            c.params[2] = this.cy || this.height / 2;
                                            c.params[3] = 0;
                                            c.params[4] = 0;
                                            c.params[5] = 0;
                                            c.params[6] = "1px " + this.fontName;
                                            c.params[7] = "rgba(0,0,0,0)";
                                            if (!j) {
                                                c.params[4] = "rgba(0,0,0,0)"
                                            }
                                            break;
                                        default:
                                    }
                                    return c
                                };
                                this.initTransitionObject = function() {
                                    var a = this.meta.render;
                                    if (a.transition) {
                                        this.resetRender(true)
                                    } else {
                                        this.resetRender(true);
                                        for (var b = 0; b < a.transition.objects.length; b++) {
                                            this.setTransitionObject(a.transition.objects[b])
                                        }
                                    }
                                };
                                this.mapTransitionObject = function() {
                                    var f = this;
                                    var a = this.meta.render;
                                    var b = {};
                                    var g = {};
                                    var d = false;
                                    var e = function() {
                                        var n = {};
                                        var k;
                                        var o = f.data.tree.click;
                                        var s = o._children ? a.transition.objects : a.objects;
                                        var l = "Tree-Node:" + o.id;
                                        var m = o._children ? a.objects[a.map["Tree-Node:" + o.id]] : a.transition.objects[a.transition.map["Tree-Node:" + o.id]];
                                        if (o._children) {
                                            o.children = o._children;
                                            k = o.descendants();
                                            o._children = o.children;
                                            o.children = null
                                        } else {
                                            k = o.descendants()
                                        }
                                        for (var p = 0; p < k.length; p++) {
                                            n[k[p].id.toString()] = true
                                        }
                                        for (var p = 0; p < s.length; p++) {
                                            for (var q in n) {
                                                var j = new RegExp(":" + q + "$");
                                                if (s[p].id.match(j)) {
                                                    switch (s[p].func) {
                                                        case "drawLine":
                                                            s[p].baseline = [m.params[1], m.params[2], m.params[1], m.params[2]];
                                                            break;
                                                        default:
                                                            s[p].baseline = [m.params[1], m.params[2]];
                                                            break
                                                    }
                                                }
                                            }
                                        }
                                        f.data.tree.click = false
                                    };
                                    var h = function(u) {
                                        var A = a.transition.types.hasOwnProperty(u) ? a.transition.types[u].all : [];
                                        var p = a.types.hasOwnProperty(u) ? a.types[u].all : [];
                                        var s = a.transition.objects;
                                        var y = a.objects;
                                        var I = a.origin;
                                        var E = {};
                                        var l = [];
                                        var z = A.length > 0 && u == "Data" ? s[A[0]].params[0] : false;
                                        if (u == "Data" && z != "rectangle" && ((f.data.y && f.data.y.histogram) || (f.meta.vals.histogram))) {
                                            var F = f.data.y && f.data.y.histogram ? f.data.y.histogram : f.meta.vals.histogram;
                                            for (var D = 0; D < F.length; D++) {
                                                for (var C = 0; C < F[D].length; C++) {
                                                    for (var B = 0; B < F[D][C].length; B++) {
                                                        var x = F[D][C][B] + ":0:" + C + ":false";
                                                        var w = F[D][C][B] + ":0:" + (C + 1) + ":false";
                                                        if (f.meta.vals.histogram) {
                                                            var n = a.map[x];
                                                            var m = a.map[w];
                                                            var x = D + ":" + (C + 1);
                                                            var H = a.transition.map[x];
                                                            if (H != null && n != null) {
                                                                l.push([H, n])
                                                            } else {
                                                                if (H != null && m != null) {
                                                                    l.push([H, m])
                                                                }
                                                            }
                                                        } else {
                                                            var H = a.transition.map[x];
                                                            var G = a.transition.map[w];
                                                            var o = D + ":" + (C + 1) + ":0";
                                                            var n = a.map[o];
                                                            if (H != null && n != null) {
                                                                l.push([H, n])
                                                            } else {
                                                                if (G != null && n != null) {
                                                                    l.push([G, n])
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (u == "Data" && z == "rectangle" && f.meta.vals.histogram) {
                                                var F = f.meta.vals.histogram;
                                                for (var D = 0; D < F.length; D++) {
                                                    for (var C = 0; C < F[D].length; C++) {
                                                        for (var B = 0; B < F[D][C].length; B++) {
                                                            var x = F[D][C][B] + ":0:" + C + ":false";
                                                            var w = F[D][C][B] + ":0:" + (C + 1) + ":false";
                                                            var n = a.map[x];
                                                            var m = a.map[w];
                                                            var x = D + ":" + (C + 1) + ":0";
                                                            var H = a.transition.map[x];
                                                            if (H != null && n != null) {
                                                                l.push([H, n])
                                                            } else {
                                                                if (H != null && m != null) {
                                                                    l.push([H, m])
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                for (var D = 0; D < p.length; D++) {
                                                    var v = y[p[D]];
                                                    if (!v.skip) {
                                                        for (var C = 0; C < I[p[D]].length; C++) {
                                                            var r = I[p[D]][C];
                                                            if (r) {
                                                                var q = s[r];
                                                                l.push([r, p[D]])
                                                            } else {
                                                                l.push([f.setTransitionObject(f.cloneObject(v), true), p[D]])
                                                            }
                                                            E[r] = true
                                                        }
                                                    }
                                                }
                                                if (!d) {
                                                    for (var D = 0; D < A.length; D++) {
                                                        var r = s[A[D]];
                                                        if (!r.skip) {
                                                            if (!E[A[D]]) {
                                                                l.push([A[D], f.setTransitionObject(f.cloneObject(r), false, u.match(/Axes/))])
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        return l
                                    };
                                    if (!a.transition) {
                                        this.initTransitionObject();
                                        d = true
                                    }
                                    if (this.graphType == "Tree" && this.data.tree.click) {
                                        e()
                                    }
                                    for (var c in a.types) {
                                        g[c] = h(c);
                                        b[c] = true
                                    }
                                    for (var c in a.transition.types) {
                                        if (!b.hasOwnProperty(c)) {
                                            g[c] = h(c)
                                        }
                                    }
                                    return g
                                }
                            };
                            CanvasXpress.prototype.initExample = function() {
                                this.getDataSet = function(f) {
                                    if (f && f.match(/RandomFunction/)) {
                                        return this.createRandomFunction()
                                    } else {
                                        if (f && f.match(/RandomVenn/)) {
                                            return this.createRandomVenn()
                                        } else {
                                            if (f && f.match(/RandomChord/)) {
                                                return this.createRandomChord()
                                            } else {
                                                if (f && f.match(/RandomNonLinearFit/)) {
                                                    return this.createRandomNonLinearFit()
                                                } else {
                                                    if (f && f.match(/RandomKaplanMeier/)) {
                                                        return this.createRandomKaplanMeier()
                                                    } else {
                                                        if (f && f.match(/RandomGenome/)) {
                                                            return this.createRandomGenome()
                                                        } else {
                                                            if (f && f.match(/RandomSankey/)) {
                                                                return this.createRandomSankey()
                                                            } else {
                                                                if (f && f.match(/RandomCircular/)) {
                                                                    return this.createRandomCircular(f)
                                                                } else {
                                                                    if (f && f.match(/RandomIdeogram/)) {
                                                                        return this.createRandomIdeogram(f)
                                                                    } else {
                                                                        if (f && f.match(/RandomNetwork/)) {
                                                                            var c = f.split(":");
                                                                            var b = {
                                                                                randomNetworkReduce: this.randomNetworkReduce,
                                                                                randomNetworkNodes: this.randomNetworkNodes,
                                                                                randomNetworkNodeEdgesMax: this.randomNetworkNodeEdgesMax,
                                                                                randomNetworkAll: this.randomNetworkAll,
                                                                                randomNetworkDummy: this.randomNetworkDummy,
                                                                                randomNetworkLayout: this.randomNetworkLayout
                                                                            };
                                                                            if (c.length > 0) {
                                                                                if (c[1] != null && Number(c[1]) > 0) {
                                                                                    this.randomNetworkReduce = true
                                                                                } else {
                                                                                    this.randomNetworkReduce = false
                                                                                }
                                                                                if (c[2] != null) {
                                                                                    this.randomNetworkNodes = Number(c[2])
                                                                                }
                                                                                if (c[3] != null) {
                                                                                    this.randomNetworkNodeEdgesMax = Number(c[3])
                                                                                }
                                                                                if (c[4] != null && Number(c[4]) > 0) {
                                                                                    this.randomNetworkAll = true
                                                                                } else {
                                                                                    this.randomNetworkAll = false
                                                                                }
                                                                                if (c[5] != null && Number(c[5]) > 0) {
                                                                                    this.randomNetworkDummy = true
                                                                                } else {
                                                                                    this.randomNetworkDummy = false
                                                                                }
                                                                                if (c[6] != null) {
                                                                                    this.randomNetworkLayout = c[6]
                                                                                }
                                                                            }
                                                                            var e = this.createRandomNetwork();
                                                                            this.randomNetworkReduce = b.randomNetworkReduce;
                                                                            this.randomNetworkNodes = b.randomNetworkNodes;
                                                                            this.randomNetworkNodeEdgesMax = b.randomNetworkNodeEdgesMax;
                                                                            this.randomNetworkAll = b.randomNetworkAll;
                                                                            this.randomNetworkDummy = b.randomNetworkDummy;
                                                                            this.randomNetworkLayout = b.randomNetworkLayout;
                                                                            return e
                                                                        } else {
                                                                            if (f && f.match(/Random/)) {
                                                                                var a = f.match(/Multidimensional/) ? true : false;
                                                                                var c = f.split(":");
                                                                                var b = {
                                                                                    randomDataVariables: this.randomDataVariables,
                                                                                    randomDataSamples: this.randomDataSamples,
                                                                                    randomDataVariableAnnotations: this.randomDataVariableAnnotations,
                                                                                    randomDataSampleAnnotations: this.randomDataSampleAnnotations,
                                                                                    randomDataMin: this.randomDataMin,
                                                                                    randomDataMax: this.randomDataMax,
                                                                                    randomMissingDataPercentage: this.randomMissingDataPercentage,
                                                                                    randomDataTime: this.randomDataTime,
                                                                                    randomDataDistribution: this.randomDataDistribution,
                                                                                    randomDataMean: this.randomDataMean,
                                                                                    randomDataSigma: this.randomDataSigma
                                                                                };
                                                                                if (c.length > 0) {
                                                                                    if (c[1] != null) {
                                                                                        this.randomDataVariables = Number(c[1])
                                                                                    }
                                                                                    if (c[2] != null) {
                                                                                        this.randomDataSamples = Number(c[2])
                                                                                    }
                                                                                    this.randomDataVariableAnnotations = c[3] != null ? Number(c[3]) : 0;
                                                                                    this.randomDataSampleAnnotations = c[4] != null ? Number(c[4]) : 0;
                                                                                    if (c[5] != null) {
                                                                                        this.randomDataSampleMin = Number(c[5])
                                                                                    }
                                                                                    if (c[6] != null) {
                                                                                        this.randomDataSampleMax = Number(c[6])
                                                                                    }
                                                                                    this.randomMissingDataPercentage = c[7] != null ? Number(c[7]) : 0;
                                                                                    this.randomDataTime = c[8] == null || c[8] == "false" ? false : true;
                                                                                    if (c[9] != null) {
                                                                                        this.randomDataDistribution = c[9]
                                                                                    }
                                                                                    if (c[10] != null) {
                                                                                        this.randomDataMean = Number(c[10])
                                                                                    }
                                                                                    if (c[11] != null) {
                                                                                        this.randomDataSigma = Number(c[11])
                                                                                    }
                                                                                }
                                                                                var e = this.createRandomData(a, true);
                                                                                this.randomDataVariables = b.randomDataVariables;
                                                                                this.randomDataSamples = b.randomDataSamples;
                                                                                this.randomDataVariableAnnotations = b.randomDataVariableAnnotations;
                                                                                this.randomDataSampleAnnotations = b.randomDataSampleAnnotations;
                                                                                this.randomDataMin = b.randomDataMin;
                                                                                this.randomDataMax = b.randomDataMax;
                                                                                this.randomMissingDataPercentage = b.randomMissingDataPercentage;
                                                                                this.randomDataTime = b.randomDataTime;
                                                                                this.randomDataDistribution = b.randomDataDistribution;
                                                                                this.randomDataMean = b.randomDataMean;
                                                                                this.randomDataSigma = b.randomDataSigma;
                                                                                return e
                                                                            } else {
                                                                                if (this.graphType == "Venn") {
                                                                                    return this.createRandomVenn()
                                                                                } else {
                                                                                    if (this.graphType == "Genome") {
                                                                                        return this.createRandomGenome()
                                                                                    } else {
                                                                                        if (this.graphType == "Sankey") {
                                                                                            return this.createRandomSankey()
                                                                                        } else {
                                                                                            if (this.graphType == "Circular") {
                                                                                                return this.showIdeogram ? this.createRandomIdeogram() : this.createRandomCircular("RandomCircular")
                                                                                            } else {
                                                                                                if (this.graphType == "Network") {
                                                                                                    return this.getDataSet("RandomNetwork:1:20:10:0:0:large")
                                                                                                } else {
                                                                                                    return this.getDataSet("Random:4:8:1:2:1:100:0:false:biased:0:1")
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            };
                            CanvasXpress.prototype.initData = function() {
                                this.isValidPlotData = function(a) {
                                    var b = this.isGroupedData ? this.data.w : this.data.y;
                                    if (a == "cor" && b.cor) {
                                        return true
                                    } else {
                                        if (a == "venn" && this.data.venn) {
                                            return true
                                        } else {
                                            if (a == "network" && this.data.nodes) {
                                                return true
                                            } else {
                                                if (a == "genome" && this.data.tracks) {
                                                    return true
                                                } else {
                                                    if (a == "sum" && b.sum && b.sum[0].length > 0) {
                                                        return true
                                                    } else {
                                                        if (a == "max" && b.max && b.max[0].length > 0) {
                                                            return true
                                                        } else {
                                                            if (a == "min" && b.min && b.min[0].length > 0) {
                                                                return true
                                                            } else {
                                                                if (a == "count" && b.count && b.count[0].length > 0) {
                                                                    return true
                                                                } else {
                                                                    if (a == "mean" && b.mean && b.mean[0].length > 0) {
                                                                        return true
                                                                    } else {
                                                                        if (a == "median" && b.median && b.median[0].length > 0) {
                                                                            return true
                                                                        } else {
                                                                            if (a == "iqr" && b.iqr1 && b.qtl1 && b.median && b.qtl3 && b.iqr3 && b.median[0].length > 0) {
                                                                                return true
                                                                            } else {
                                                                                if (a == "raw" && this.isRawData) {
                                                                                    return true
                                                                                } else {
                                                                                    return false
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setRangeData = function(ag, e, H, S, B) {
                                    var M = this;
                                    var p = this.isGroupedData && !e && this.data.w ? this.data.w : this.data.y;
                                    var T = this.graphType == "Scatter2D" && this.scatterType == "visium" ? CanvasXpress.cacheImages[this.backgroundImageMD5 || this.getFileName(this.backgroundImage)] : false;
                                    var ad = Number.POSITIVE_INFINITY;
                                    var C = Number.NEGATIVE_INFINITY;
                                    if (this.setMin != null && this.setMax != null) {
                                        this.minData = this.setMin;
                                        this.maxData = this.setMax;
                                        return
                                    }
                                    if (this.isGroupedData && !ag) {
                                        ag = this.graphType == "Boxplot" ? "iqr" : this.summaryType;
                                        if (this.graphType == "Boxplot" && !this.isBoxplotCalc) {
                                            this.groupSamples(this.groupingFactors, false, false, false, true);
                                            p = this.data.w
                                        }
                                    }
                                    if (this.graphType == "Meter") {
                                        ad = this.meterMin;
                                        C = this.meterMax
                                    } else {
                                        if (ag == "fish") {
                                            if (B == "xAxis") {
                                                ad = this.fishTimepoints[0] - ((this.fishTimepoints[this.fishTimepoints.length - 1] - this.fishTimepoints[0]) / 5);
                                                C = this.fishTimepoints[this.fishTimepoints.length - 1]
                                            } else {
                                                ad = 0;
                                                C = 100
                                            }
                                        } else {
                                            if (ag == "genome") {
                                                var J = this.data.tracks.length;
                                                for (var W = 0; W < J; W++) {
                                                    var w = this.data.tracks[W].data.length;
                                                    for (var V = 0; V < w; V++) {
                                                        if (this.data.tracks[W].type == "box") {
                                                            var ae = this.data.tracks[W].data[V].data.length;
                                                            for (var U = 0; U < ae; U++) {
                                                                O = this.data.tracks[W].data[V].data[U];
                                                                C = Math.max(C, Math.max(O[0], O[1]));
                                                                ad = Math.min(ad, Math.min(O[0], O[1]))
                                                            }
                                                        } else {
                                                            if (this.data.tracks[W].type == "sequence") {
                                                                O = this.data.tracks[W].data[V].offset;
                                                                C = Math.max(C, O + this.data.tracks[W].data[V].sequence.length);
                                                                ad = Math.min(ad, O)
                                                            } else {
                                                                if (this.data.tracks[W].type.match(/bar|heatmap/)) {
                                                                    O = this.data.tracks[W].data[V].offset;
                                                                    C = this.data.tracks[W].autowidth ? Math.max(C, O + this.data.tracks[W].data[V].data.length) : Math.max(C, O);
                                                                    ad = Math.min(ad, O)
                                                                } else {
                                                                    if (this.data.tracks[W].type == "dataframe") {
                                                                        var ae = this.data.tracks[W].data[0].data.length;
                                                                        for (var U = 0; U < ae; U++) {
                                                                            O = this.data.tracks[W].dataframe[this.data.tracks[W].data[0].data[U].xAxis];
                                                                            C = Math.max(C, O[O.length - 1]);
                                                                            ad = Math.min(ad, O[0], O[1])
                                                                        }
                                                                    } else {
                                                                        if (this.data.tracks[W].type == "marker") {
                                                                            var ae = this.data.tracks[W].data[V].data.length;
                                                                            for (var U = 0; U < ae; U++) {
                                                                                O = this.data.tracks[W].data[V].data[U];
                                                                                C = Math.max(C, O[O.length - 1]);
                                                                                ad = Math.min(ad, O[0])
                                                                            }
                                                                        } else {
                                                                            O = this.data.tracks[W].data[V].offset;
                                                                            C = Math.max(C, O);
                                                                            ad = Math.min(ad, O)
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (ag == "circular") {
                                                    if (this.circularType == "chord") {
                                                        this.circularChord = this.chordifyData();
                                                        ad = 0;
                                                        C = this.circularChord.total
                                                    } else {
                                                        var ab = this.getVariableIndices(this.rAxis);
                                                        if (ab >= 0) {
                                                            var Q = this.range(this.data.y.data[ab]);
                                                            ad = Q[0];
                                                            C = Q[1]
                                                        } else {
                                                            ad = 0;
                                                            C = 1
                                                        }
                                                    }
                                                } else {
                                                    if (ag == "gantt") {
                                                        if (!this.data.gantt) {
                                                            this.isGanttDataFormated = false;
                                                            this.setGanttData()
                                                        }
                                                        var W = this.getVariableIndices(this.ganttStart);
                                                        var V = this.getVariableIndices(this.ganttEnd);
                                                        var ac = this.cloneObject(this.data.gantt);
                                                        ad = ac[W].sort(function(d, c) {
                                                            return d - c
                                                        })[0];
                                                        C = ac[V].sort(function(d, c) {
                                                            return c - d
                                                        })[0]
                                                    } else {
                                                        if (ag == "km" && !e) {
                                                            ad = 0;
                                                            C = 1
                                                        } else {
                                                            if (ag == "qq") {
                                                                if (this.isQQ) {
                                                                    for (var W = 0; W < this.decorations.qq.length; W++) {
                                                                        var ab = this.decorations.qq[W].index;
                                                                        var l = this.decorations.qq[W].data;
                                                                        if (this.smpIndices.includes(ab)) {
                                                                            if (!isNaN(l[B][0])) {
                                                                                ad = Math.min(ad, l[B][0])
                                                                            }
                                                                            if (!isNaN(l[B][l[B].length - 1])) {
                                                                                C = Math.max(C, l[B][l[B].length - 1])
                                                                            }
                                                                        }
                                                                    }
                                                                } else {
                                                                    ad = 0;
                                                                    C = 1
                                                                }
                                                            } else {
                                                                if (ag == "cdf") {
                                                                    if (this.isCDF && B == "x") {
                                                                        for (var W = 0; W < this.decorations.cdf.length; W++) {
                                                                            var ab = this.decorations.cdf[W].index;
                                                                            var l = this.decorations.cdf[W].data;
                                                                            if (this.smpIndices.includes(ab)) {
                                                                                if (!isNaN(l[B][0])) {
                                                                                    ad = Math.min(ad, l[B][0])
                                                                                }
                                                                                if (!isNaN(l[B][l[B].length - 1])) {
                                                                                    C = Math.max(C, l[B][l[B].length - 1])
                                                                                }
                                                                            }
                                                                        }
                                                                    } else {
                                                                        ad = 0;
                                                                        C = 1
                                                                    }
                                                                } else {
                                                                    if (ag == "density" && p.density) {
                                                                        if (this.histogramType == "stacked" && this.histogramStat == "count") {
                                                                            if (this.layoutValid && this.data.l) {
                                                                                var G = function(d) {
                                                                                    for (var c = 1; c < M.data.l.name.length; c++) {
                                                                                        if (M.data.l.name[c] == d) {
                                                                                            return c - 1
                                                                                        }
                                                                                    }
                                                                                    return 0
                                                                                };
                                                                                for (var W = 0; W < this.data.l.axes.length; W++) {
                                                                                    var q = [];
                                                                                    var g = 0;
                                                                                    for (var V = 0; V < this.data.l.axes[W].yAxis.length; V++) {
                                                                                        var ab = G(this.data.l.axes[W].yAxis[V]);
                                                                                        g += p.density[ab].histogram.maxY
                                                                                    }
                                                                                    C = Math.max(C, g)
                                                                                }
                                                                            } else {
                                                                                C = p.global.maxY
                                                                            }
                                                                        } else {
                                                                            for (var W = 0; W < this.smpIndices.length; W++) {
                                                                                if (this.histogramType == "stacked") {
                                                                                    C += p.density[this.smpIndices[W] - 1].globalMaxY
                                                                                } else {
                                                                                    C = Math.max(C, p.density[this.smpIndices[W] - 1].globalMaxY)
                                                                                }
                                                                            }
                                                                        }
                                                                        ad = 0
                                                                    } else {
                                                                        if (ag == "percentile" && !e && !S) {
                                                                            ad = 0;
                                                                            C = 100
                                                                        } else {
                                                                            if ((ag == "mean" || ag == "median" || ag == "sum" || ag == "max" || ag == "min" || ag == "count") && (!e)) {
                                                                                if (S) {
                                                                                    C = 0;
                                                                                    ad = 0;
                                                                                    maxSt = 0;
                                                                                    minSt = 0;
                                                                                    var h = this.isGroupedData ? this.grpIndices : this.smpIndices;
                                                                                    var aa = this.isTransformedData ? p.trans : p[this.summaryType];
                                                                                    var L = this.graphType == "Circular" && this.showIdeogram;
                                                                                    var y = L ? [this.varIndices, h] : [h, this.varIndices];
                                                                                    var s = y[0].length;
                                                                                    for (var W = 0; W < s; W++) {
                                                                                        var J = y[0][W];
                                                                                        var b = 0;
                                                                                        var f = 0;
                                                                                        var t = y[1].length;
                                                                                        for (var V = 0; V < t; V++) {
                                                                                            var w = this.isGroupedData ? V : y[1][V];
                                                                                            var F = L ? aa[J][w] : aa[w][J];
                                                                                            if (!isNaN(F)) {
                                                                                                minSt = Math.min(F, minSt);
                                                                                                maxSt = Math.max(F, maxSt);
                                                                                                if (F > 0) {
                                                                                                    b += F
                                                                                                } else {
                                                                                                    if (F < 0) {
                                                                                                        f += F
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                        C = Math.max(b, C);
                                                                                        ad = Math.min(f, ad)
                                                                                    }
                                                                                } else {
                                                                                    var A = this.isDOE && this.isDOE == 1 ? this.data.y.vars.length : this.varIndices.length;
                                                                                    for (var W = 0; W < A; W++) {
                                                                                        var J = this.varIndices[W];
                                                                                        var O;
                                                                                        var R;
                                                                                        if (this.isTransformedData) {
                                                                                            O = p.trans[W];
                                                                                            R = p.tstdev ? p.tstdev[W] : false
                                                                                        } else {
                                                                                            if (this.summaryType == "mean") {
                                                                                                O = p.mean[W] || p.mean[J]
                                                                                            } else {
                                                                                                if (this.summaryType == "median") {
                                                                                                    O = p.median[W] || p.median[J]
                                                                                                } else {
                                                                                                    if (this.summaryType == "sum") {
                                                                                                        O = p.sum[W] || p.sum[J]
                                                                                                    } else {
                                                                                                        if (this.summaryType == "max") {
                                                                                                            O = p.max[W] || p.max[J]
                                                                                                        } else {
                                                                                                            if (this.summaryType == "min") {
                                                                                                                O = p.min[W] || p.min[J]
                                                                                                            } else {
                                                                                                                if (this.summaryType == "count") {
                                                                                                                    O = p.count[W] || p.count[J]
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                            R = p.stdev ? (p.stdev[W] || p.stdev[J]) : false
                                                                                        }
                                                                                        if (O) {
                                                                                            var Y = O.length;
                                                                                            for (var V = 0; V < Y; V++) {
                                                                                                var P;
                                                                                                var F = O[V];
                                                                                                if (R) {
                                                                                                    P = R[V] / 2
                                                                                                } else {
                                                                                                    P = Number.NaN
                                                                                                }
                                                                                                if (!isNaN(F)) {
                                                                                                    if (!isNaN(P)) {
                                                                                                        if (H) {
                                                                                                            if (F > 0) {
                                                                                                                ad = Math.min(F - P, ad);
                                                                                                                C = Math.max(F + P, C)
                                                                                                            }
                                                                                                        } else {
                                                                                                            ad = Math.min(F - P, ad);
                                                                                                            C = Math.max(F + P, C)
                                                                                                        }
                                                                                                    } else {
                                                                                                        if (H) {
                                                                                                            if (F > 0) {
                                                                                                                ad = Math.min(F, ad);
                                                                                                                C = Math.max(F, C)
                                                                                                            }
                                                                                                        } else {
                                                                                                            ad = Math.min(F, ad);
                                                                                                            C = Math.max(F, C)
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            } else {
                                                                                if (this.summaryType == "mean" && !this.isRawData) {
                                                                                    var J = this.isDOE && this.isDOE == 1 ? this.data.y.vars.length : this.varIndices.length;
                                                                                    for (var W = 0; W < J; W++) {
                                                                                        var w = this.smpIndices.length;
                                                                                        for (var V = 0; V < w; V++) {
                                                                                            var F = p.mean[this.varIndices[W]][this.smpIndices[V]];
                                                                                            var X = p.stdev && p.stdev[this.varIndices[W]] && p.stdev[this.varIndices[W]][this.smpIndices[V]] / 2 ? p.stdev[this.varIndices[W]][this.smpIndices[V]] / 2 : 0;
                                                                                            if (!isNaN(F)) {
                                                                                                if (!isNaN(X)) {
                                                                                                    ad = Math.min(F - X, ad);
                                                                                                    C = Math.max(F + X, C)
                                                                                                } else {
                                                                                                    ad = Math.min(F, ad);
                                                                                                    C = Math.max(F, C)
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                } else {
                                                                                    if ((ag == "iqr" && !e && this.grpIndices) || (this.summaryType == "iqr" && !this.isRawData)) {
                                                                                        var A = this.isDOE && this.isDOE == 1 ? this.data.y.vars.length : this.varIndices.length;
                                                                                        for (var W = 0; W < A; W++) {
                                                                                            var J = this.varIndices[W];
                                                                                            var E = this.grpIndices ? this.grpIndices : this.smpIndices;
                                                                                            var af = E.length;
                                                                                            for (var V = 0; V < af; V++) {
                                                                                                var w = E[V];
                                                                                                var x = p.iqr1[J][w];
                                                                                                var u = p.iqr3[J][w];
                                                                                                var N = p.out[J][w];
                                                                                                if (!isNaN(x) && !isNaN(u)) {
                                                                                                    if (H) {
                                                                                                        if (x > 0 && u > 0) {
                                                                                                            ad = Math.min(x, ad);
                                                                                                            C = Math.max(u, C)
                                                                                                        }
                                                                                                    } else {
                                                                                                        ad = Math.min(x, ad);
                                                                                                        C = Math.max(u, C)
                                                                                                    }
                                                                                                }
                                                                                                if (N) {
                                                                                                    var K = N.length;
                                                                                                    for (var U = 0; U < K; U++) {
                                                                                                        if (!isNaN(N[U])) {
                                                                                                            if (H) {
                                                                                                                if (N[U] > 0) {
                                                                                                                    ad = Math.min(N[U], ad);
                                                                                                                    C = Math.max(N[U], C)
                                                                                                                }
                                                                                                            } else {
                                                                                                                ad = Math.min(N[U], ad);
                                                                                                                C = Math.max(N[U], C)
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    } else {
                                                                                        if (ag == "cor") {
                                                                                            var h = this.correlationAxis == "variables" ? this.varIndices : this.isGroupedData ? this.grpIndices : this.smpIndices;
                                                                                            var J = h.length;
                                                                                            for (var W = 0; W < J; W++) {
                                                                                                var w = h.length;
                                                                                                for (var V = 0; V < w; V++) {
                                                                                                    var F = this.isTransformedData && p.trans ? p.trans[W][V] : p.cor[W][V];
                                                                                                    if (!isNaN(F)) {
                                                                                                        if (H) {
                                                                                                            if (F > 0) {
                                                                                                                ad = Math.min(F, ad);
                                                                                                                C = Math.max(F, C)
                                                                                                            }
                                                                                                        } else {
                                                                                                            ad = Math.min(F, ad);
                                                                                                            C = Math.max(F, C)
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        } else {
                                                                                            var aa = this.isTransformedData && p.trans ? p.trans : p.data;
                                                                                            var a = T ? T.height : false;
                                                                                            if (aa && aa.length > 0) {
                                                                                                if (S) {
                                                                                                    var L = this.graphType == "Circular" && this.showIdeogram;
                                                                                                    var y = L ? [this.varIndices, this.smpIndices] : [this.smpIndices, this.varIndices];
                                                                                                    var s = y[0].length;
                                                                                                    C = 0;
                                                                                                    ad = 0;
                                                                                                    maxSt = 0;
                                                                                                    minSt = 0;
                                                                                                    for (var W = 0; W < s; W++) {
                                                                                                        var b = 0;
                                                                                                        var f = 0;
                                                                                                        var t = y[1].length;
                                                                                                        for (var V = 0; V < t; V++) {
                                                                                                            var F = L ? aa[y[0][W]][y[1][V]] : aa[y[1][V]][y[0][W]];
                                                                                                            if (!isNaN(F)) {
                                                                                                                minSt = Math.min(F, minSt);
                                                                                                                maxSt = Math.max(F, maxSt);
                                                                                                                if (F > 0) {
                                                                                                                    b += F
                                                                                                                } else {
                                                                                                                    if (F < 0) {
                                                                                                                        f += F
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                        C = Math.max(b, C);
                                                                                                        ad = Math.min(f, ad)
                                                                                                    }
                                                                                                } else {
                                                                                                    var J = this.motionBy || (this.isDOE && this.isDOE == 1) ? this.data.y.vars.length : this.varIndices.length;
                                                                                                    for (var W = 0; W < J; W++) {
                                                                                                        var w = this.smpIndices.length;
                                                                                                        for (var V = 0; V < w; V++) {
                                                                                                            var D = this.motionBy ? W : this.varIndices[W];
                                                                                                            var F = a ? a - aa[D][this.smpIndices[V]] : aa[D][this.smpIndices[V]];
                                                                                                            if (!isNaN(F)) {
                                                                                                                if (H) {
                                                                                                                    if (F > 0) {
                                                                                                                        ad = Math.min(F, ad);
                                                                                                                        C = Math.max(F, C)
                                                                                                                    }
                                                                                                                } else {
                                                                                                                    ad = Math.min(F, ad);
                                                                                                                    C = Math.max(F, C)
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.graphType == "Boxplot" && this.showViolinBoxplot && !this.violinTrim) {
                                        var r = this.meta.data.d;
                                        if (this.isGroupedData) {
                                            r = r.g;
                                            var J = r.length;
                                            for (var W = 0; W < J; W++) {
                                                var w = r[W].length;
                                                for (var V = 0; V < w; V++) {
                                                    var Z = r[W][V].density.xy;
                                                    if (Z.length) {
                                                        ad = Math.min(ad, Z[0][0]);
                                                        C = Math.max(C, Z[Z.length - 1][0])
                                                    }
                                                }
                                            }
                                        } else {
                                            r = r.v;
                                            var J = r.length;
                                            for (var W = 0; W < J; W++) {
                                                var Z = r[W].density.xy;
                                                if (Z.length) {
                                                    ad = Math.min(ad, Z[0][0]);
                                                    C = Math.max(C, Z[Z.length - 1][0])
                                                }
                                            }
                                        }
                                    } else {
                                        if (this.graphType == "Scatter2D" && this.scatterType == "visium") {
                                            var I = CanvasXpress.cacheImages[this.backgroundImageMD5 || this.getFileName(this.backgroundImage)];
                                            ad = 0;
                                            C = B.match(/y/i) ? I.height : I.width
                                        }
                                    }
                                    this.minData = this.setMin != null ? this.setMin : ad == Number.POSITIVE_INFINITY || ad == Number.NEGATIVE_INFINITY ? 0 : ad;
                                    this.maxData = this.setMax != null ? this.setMax : C == Number.NEGATIVE_INFINITY || C == Number.POSITIVE_INFINITY ? 1 : C;
                                    if (S && ag != "percentile") {
                                        this.minDataStacked = minSt;
                                        this.maxDataStacked = maxSt
                                    }
                                };
                                this.setRangeDataObject = function(g) {
                                    var d = Number.POSITIVE_INFINITY;
                                    var a = Number.NEGATIVE_INFINITY;
                                    var e = this.varIndices.length;
                                    for (var c = 0; c < e; c++) {
                                        var f = this.smpIndices.length;
                                        for (var b = 0; b < f; b++) {
                                            var h = g[this.varIndices[c]][this.smpIndices[b]];
                                            if (!isNaN(h)) {
                                                d = Math.min(h, d);
                                                a = Math.max(h, a)
                                            }
                                        }
                                    }
                                    d = d == Number.POSITIVE_INFINITY || d == Number.NEGATIVE_INFINITY ? -1 : d;
                                    a = a == Number.NEGATIVE_INFINITY || a == Number.POSITIVE_INFINITY ? 1 : a;
                                    return [d, a]
                                };
                                this.checkObject = function() {
                                    var d = this.data.y;
                                    if (this.isGroupedData) {
                                        this.data.w = {};
                                        d = this.data.w
                                    }
                                    var b = ["vars", "smps", "labs", "glab", "desc", "data", "mean", "median", "stdev", "n", "qtl1", "qtl3", "iqr1", "iqr3", "out", "conf", "trans", "tstdev", "cor", "min", "max", "sum", "count", "grps", "grpIdxs", "factors"];
                                    var c = b.length;
                                    for (var a = 0; a < c; a++) {
                                        if (!d[b[a]]) {
                                            if (b[a] == "factors") {
                                                d[b[a]] = {}
                                            } else {
                                                d[b[a]] = []
                                            }
                                        }
                                    }
                                    d.iqr = d.median
                                };
                                this.resetObject = function(a) {
                                    var c = ["mean", "median", "stdev", "n", "qtl1", "qtl3", "iqr1", "iqr3", "out", "conf", "cor", "min", "max", "sum", "count", "grps", "grpIdxs", "factors"];
                                    var d = c.length;
                                    if (this.isGroupedData) {
                                        if (!this.isTransformedData) {
                                            c.push("trans");
                                            c.push("tstdev")
                                        }
                                        d = c.length;
                                        for (var b = 0; b < d; b++) {
                                            delete(this.data.y[c[b]])
                                        }
                                        delete(this.data.w)
                                    } else {
                                        if (!this.isTransformedData) {
                                            c.push("trans");
                                            c.push("tstdev")
                                        }
                                        d = c.length;
                                        if (this.isRawData) {
                                            for (var b = 0; b < d; b++) {
                                                delete(this.data.y[c[b]])
                                            }
                                        } else {}
                                    }
                                    if (a && this.isRawData) {
                                        this.checkObject()
                                    }
                                };
                                this.summarize = function(f, I) {
                                    var b = this.isGroupedData ? this.data.w : this.data.y;
                                    var l = this.isGroupedData ? false : true;
                                    if (!this.isGroupedData) {
                                        this.checkObject()
                                    }
                                    var c = ["trans", "tstdev", "mean", "median", "stdev", "qtl1", "qtl3", "iqr1", "iqr3", "out", "conf", "n", "min", "max", "sum", "count"];
                                    var D = function(k, j) {
                                        if (!b[k][j]) {
                                            b[k][j] = []
                                        }
                                    };
                                    if (f == "cor") {
                                        this.isBoxplotCalc = false;
                                        if (this.correlationAxis == "samples") {
                                            if (this.isGroupedData && b.cor.length == 0) {
                                                this.ungroupSamples(true, true, true)
                                            }
                                            var s = this.isGroupedData ? this.grpIndices : this.smpIndices;
                                            var h = s.length;
                                            for (var G = 0; G < h; G++) {
                                                var x = s[G];
                                                var t = this.getDataForSmpGrpAtIndex(x);
                                                if (!b.cor[x]) {
                                                    b.cor[x] = []
                                                }
                                                var g = s.length;
                                                for (var E = G; E < g; E++) {
                                                    var H = s[E];
                                                    if (!b.cor[H]) {
                                                        b.cor[H] = []
                                                    }
                                                    var r = this.getDataForSmpGrpAtIndex(H);
                                                    if (G == E) {
                                                        if (this.isTransformedData) {
                                                            b.trans[x][H] = 1
                                                        }
                                                        b.cor[x][H] = 1
                                                    } else {
                                                        b.cor[x][H] = this.correlation(t, r);
                                                        b.cor[H][x] = b.cor[x][H];
                                                        if (this.isTransformedData) {
                                                            b.trans[x][H] = b.cor[x][H];
                                                            b.trans[H][x] = b.cor[H][x]
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            var h = this.varIndices.length;
                                            for (var G = 0; G < h; G++) {
                                                var x = this.varIndices[G];
                                                if (!b.cor[x]) {
                                                    b.cor[x] = []
                                                }
                                                var g = this.varIndices.length;
                                                for (var E = G; E < g; E++) {
                                                    var H = this.varIndices[E];
                                                    if (!b.cor[H]) {
                                                        b.cor[H] = []
                                                    }
                                                    if (G == E) {
                                                        b.cor[x][H] = 1;
                                                        if (this.isTransformedData) {
                                                            b.trans[x][H] = 1
                                                        }
                                                    } else {
                                                        b.cor[x][H] = this.correlation(b.data[x], b.data[H], l);
                                                        b.cor[H][x] = b.cor[x][H];
                                                        if (this.isTransformedData) {
                                                            b.trans[x][H] = b.cor[x][H];
                                                            b.trans[H][x] = b.cor[H][x]
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        this.isBoxplotCalc = f == "iqr" ? true : false;
                                        var h = this.isDOE && this.isDOE == 1 ? this.data.y.vars.length : this.varIndices.length;
                                        for (var G = 0; G < h; G++) {
                                            var a;
                                            var x = this.varIndices[G];
                                            var w = c.length;
                                            for (var E = 0; E < w; E++) {
                                                D(c[E], x)
                                            }
                                            if (this.isGroupedData) {
                                                if (!I) {
                                                    var A = this.isTransformedData ? this.data.y.trans : this.data.y.data;
                                                    a = [];
                                                    var q = this.data.w.grps.length;
                                                    for (var E = 0; E < q; E++) {
                                                        a[E] = [];
                                                        var p = this.data.w.grps[E].length;
                                                        for (var C = 0; C < p; C++) {
                                                            var e = this.data.w.grps[E][C];
                                                            a[E].push(A[x][e])
                                                        }
                                                    }
                                                } else {
                                                    a = I[x]
                                                }
                                            } else {
                                                b.grps = [];
                                                a = [];
                                                var g = this.smpIndices.length;
                                                for (var E = 0; E < g; E++) {
                                                    var H = this.smpIndices[E];
                                                    b.grps[E] = [];
                                                    b.grps[E].push(H);
                                                    a[E] = [this.isTransformedData && b.trans ? b.trans[x][H] : b.data[x][H]]
                                                }
                                            }
                                            if (f == "iqr") {
                                                this.summaryType = "iqr";
                                                if (this.isRawData) {
                                                    if (!this.isGroupedData) {
                                                        var g = this.smpIndices.length;
                                                        for (var E = 0; E < g; E++) {
                                                            var H = this.smpIndices[E];
                                                            if (this.isTransformedData) {
                                                                b.trans[x][E] = a[E][0]
                                                            }
                                                            b.mean[x][H] = a[E][0];
                                                            b.median[x][H] = a[E][0];
                                                            b.qtl1[x][H] = a[E][0];
                                                            b.qtl3[x][H] = a[E][0];
                                                            b.iqr1[x][H] = a[E][0];
                                                            b.iqr3[x][H] = a[E][0];
                                                            b.out[x][H] = [];
                                                            b.conf[x][H] = [];
                                                            b.n[x][H] = 1
                                                        }
                                                    } else {
                                                        var w = a.length;
                                                        for (var E = 0; E < w; E++) {
                                                            var y = this.boxplot(a[E]);
                                                            if (this.isTransformedData) {
                                                                b.trans[x][E] = y[1]
                                                            }
                                                            b.mean[x][E] = y[0];
                                                            b.median[x][E] = y[2];
                                                            b.qtl1[x][E] = y[1];
                                                            b.qtl3[x][E] = y[3];
                                                            b.iqr1[x][E] = y[4];
                                                            b.iqr3[x][E] = y[5];
                                                            b.out[x][E] = y[6];
                                                            b.n[x][E] = y[7];
                                                            b.conf[x][E] = y[8]
                                                        }
                                                    }
                                                }
                                                b.iqr = b.median
                                            } else {
                                                if (f == "median") {
                                                    this.summaryType = "median";
                                                    if (this.isRawData) {
                                                        var w = a.length;
                                                        for (var E = 0; E < w; E++) {
                                                            var y = this.median(a[E], l);
                                                            if (this.isTransformedData) {
                                                                b.trans[x][E] = y[1]
                                                            }
                                                            b.median[x][E] = y[0];
                                                            b.n[x][E] = y[1]
                                                        }
                                                    }
                                                } else {
                                                    if (f == "mean" || f == "raw") {
                                                        this.summaryType = "mean";
                                                        if (this.isRawData) {
                                                            var w = a.length;
                                                            for (var E = 0; E < w; E++) {
                                                                var y = this.sumarizeErrorData(a[E], l);
                                                                if (this.isTransformedData) {
                                                                    b.trans[x][E] = y[0];
                                                                    b.tstdev[x][E] = y[1]
                                                                }
                                                                b.mean[x][E] = y[0];
                                                                b.stdev[x][E] = y[1];
                                                                b.n[x][E] = y[2]
                                                            }
                                                        }
                                                    } else {
                                                        if (f == "sum") {
                                                            this.summaryType = "sum";
                                                            if (this.isRawData) {
                                                                var w = a.length;
                                                                for (var E = 0; E < w; E++) {
                                                                    var d = this.sum(a[E], l);
                                                                    if (this.isTransformedData) {
                                                                        b.trans[x][E] = d
                                                                    }
                                                                    b.sum[x][E] = d;
                                                                    b.n[x][E] = a[E].length
                                                                }
                                                            }
                                                        } else {
                                                            if (f == "max") {
                                                                this.summaryType = "max";
                                                                if (this.isRawData) {
                                                                    var w = a.length;
                                                                    for (var E = 0; E < w; E++) {
                                                                        var F = this.max(a[E], l);
                                                                        if (this.isTransformedData) {
                                                                            b.trans[x][E] = F
                                                                        }
                                                                        b.max[x][E] = F;
                                                                        b.n[x][E] = a[E].length
                                                                    }
                                                                }
                                                            } else {
                                                                if (f == "min") {
                                                                    this.summaryType = "min";
                                                                    if (this.isRawData) {
                                                                        var w = a.length;
                                                                        for (var E = 0; E < w; E++) {
                                                                            var B = this.min(a[E], l);
                                                                            if (this.isTransformedData) {
                                                                                b.trans[x][E] = B
                                                                            }
                                                                            b.min[x][E] = B;
                                                                            b.n[x][E] = a[E].length
                                                                        }
                                                                    }
                                                                } else {
                                                                    if (f == "count") {
                                                                        this.summaryType = "count";
                                                                        if (this.isRawData) {
                                                                            var w = a.length;
                                                                            for (var E = 0; E < w; E++) {
                                                                                var u = a[E].length;
                                                                                if (this.isTransformedData) {
                                                                                    b.trans[x][E] = u
                                                                                }
                                                                                b.count[x][E] = u;
                                                                                b.n[x][E] = u
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.copySummarizedData = function() {
                                    var e = this.isGroupedData ? this.data.w : this.data.y;
                                    var d;
                                    for (var b = 0; b < this.varIndices.length; b++) {
                                        var c = this.varIndices[b];
                                        e.data[c] = [];
                                        e.trans[c] = [];
                                        if (this.summaryType == "mean") {
                                            for (var a = 0; a < e.mean[c].length; a++) {
                                                e.data[c][a] = e.mean[c][a]
                                            }
                                        } else {
                                            if (this.summaryType == "median" || this.summaryType == "iqr") {
                                                for (var a = 0; a < e.median[c].length; a++) {
                                                    e.data[c][a] = e.median[c][a]
                                                }
                                            } else {
                                                if (this.summaryType == "sum") {
                                                    for (var a = 0; a < e.sum[c].length; a++) {
                                                        e.data[c][a] = e.sum[c][a]
                                                    }
                                                } else {
                                                    if (this.summaryType == "max") {
                                                        for (var a = 0; a < e.max[c].length; a++) {
                                                            e.data[c][a] = e.max[c][a]
                                                        }
                                                    } else {
                                                        if (this.summaryType == "min") {
                                                            for (var a = 0; a < e.min[c].length; a++) {
                                                                e.data[c][a] = e.min[c][a]
                                                            }
                                                        } else {
                                                            if (this.summaryType == "count") {
                                                                for (var a = 0; a < e.count[c].length; a++) {
                                                                    e.data[c][a] = e.count[c][a]
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (!d) {
                                            d = c
                                        }
                                    }
                                    return d
                                };
                                this.transformValue = function(b, c, a) {
                                    switch (b) {
                                        case "log2":
                                            return a ? Math.pow(2, c) : Math.log(c) / Math.LN2;
                                        case "log10":
                                            return a ? Math.pow(10, c) : Math.log(c) / Math.LN10;
                                        case "exp2":
                                            return a ? Math.log(c) / Math.LN2 : Math.pow(2, c);
                                        case "exp10":
                                            return a ? Math.log(c) / Math.LN10 : Math.pow(10, c);
                                        default:
                                            return c
                                    }
                                };
                                this.transform = function(e, d, a, c) {
                                    if (this.isTransition() || this.graphType.match(/Area/)) {
                                        return
                                    }
                                    if (!this.isGroupedData) {
                                        this.checkObject()
                                    }
                                    var b = this.transformData;
                                    this.transformData = e;
                                    this.transformAxis = d;
                                    this.xAxisMaxStrLength = false;
                                    this.xAxis2MaxStrLength = false;
                                    this.yAxisMaxStrLength = false;
                                    this.zAxisMaxStrLength = false;
                                    if (e == "reset" || e == "undo") {
                                        this.transformReset();
                                        this.transformData = false;
                                        this.isTransformedData = false;
                                        if (this.tempIndices) {
                                            if (this.isGroupedData) {
                                                this.grpIndices = this.tempIndices
                                            } else {
                                                this.smpIndices = this.tempIndices
                                            }
                                            this.tempIndices = false
                                        }
                                    } else {
                                        if (e == "save") {
                                            this.transformSave();
                                            this.transformData = false;
                                            this.isTransformedData = false
                                        } else {
                                            if (e == "log2" || e == "log10" || e == "exp2" || e == "exp10") {
                                                if (this.transformLogExp(e)) {
                                                    this.isTransformedData = e
                                                } else {
                                                    this.transformData = b;
                                                    return
                                                }
                                            } else {
                                                if (e == "ratio2" || e == "ratio10") {
                                                    this.transformRatio(e, a);
                                                    this.isTransformedData = e
                                                } else {
                                                    this.transformRelative(e, d, !this.isRawData || this.isGroupedData ? this.copySummarizedData() : 0);
                                                    this.isTransformedData = e
                                                }
                                            }
                                        }
                                    }
                                    delete(this.meta.def.colorBrew);
                                    if (this.graphType == "Boxplot") {
                                        this.summarizeBoxplot = true
                                    }
                                    this.resetCorrelation();
                                    this.resetRange();
                                    if (!c) {
                                        this.draw({
                                            func: "transform",
                                            par: [e, d, a, c]
                                        })
                                    }
                                };
                                this.transformReset = function() {
                                    var d = this.data.y;
                                    for (var b = 0; b < this.varIndices.length; b++) {
                                        var c = this.varIndices[b];
                                        for (var a = 0; a < d.data[c].length; a++) {
                                            if (d.trans && d.trans[c] && !isNaN(d.data[c][a])) {
                                                d.trans[c][a] = d.data[c][a]
                                            }
                                        }
                                    }
                                    if (this.isGroupedData) {
                                        this.isTransformedData = false;
                                        this.groupSamples(this.groupingFactors, false, false, false, true)
                                    }
                                };
                                this.transformSave = function() {
                                    var a = this.isGroupedData ? this.groupingFactors : false;
                                    var e = this.data.y;
                                    if (e.trans && e.trans.length > 0) {
                                        this.ungroupSamples();
                                        for (var c = 0; c < this.varIndices.length; c++) {
                                            var d = this.varIndices[c];
                                            for (var b = 0; b < e.data[d].length; b++) {
                                                if (!isNaN(e.data[d][b])) {
                                                    e.data[d][b] = e.trans[d][b]
                                                }
                                            }
                                        }
                                        if (a) {
                                            this.isTransformedData = false;
                                            this.groupSamples(a, false, false, false, true)
                                        }
                                    }
                                };
                                this.transformLogExp = function(e) {
                                    var g = this.isGroupedData ? this.data.y : this.dataStndBy && !this.isDOE ? this.dataStndBy.y : this.data.y;
                                    var a = this.range2D(g.data);
                                    if (e.match(/log/)) {
                                        if (a[0] <= 0) {
                                            alert("Cannot log transform values <= 0");
                                            return false
                                        }
                                        e = e == "log2" ? "log2" : "log10"
                                    } else {
                                        if (e.match(/exp/)) {
                                            if (a[1] >= 1000) {
                                                alert("Cannot exp transform values > 1000");
                                                return false
                                            }
                                            e = e == "exp2" ? "exp2" : "exp10"
                                        }
                                    }
                                    if (!g.trans) {
                                        g.trans = []
                                    }
                                    if (!g.tstdev) {
                                        g.tstdev = []
                                    }
                                    var f = this.motionBy ? this.data.y.vars.length : this.isGroupedData ? this.data.y.vars.length : this.dataStndBy && !this.isDOE ? this.dataStndBy.y.vars.length : this.varIndices.length;
                                    for (var c = 0; c < f; c++) {
                                        var d = this.motionBy || (this.dataStndBy && !this.isDOE) ? c : this.varIndices[c];
                                        if (!g.trans[d]) {
                                            g.trans[d] = []
                                        }
                                        if (!g.tstdev[d]) {
                                            g.tstdev[d] = []
                                        }
                                        for (var b = 0; b < g.data[d].length; b++) {
                                            if (!isNaN(g.data[d][b])) {
                                                if (e == "log2") {
                                                    this.transformBase = 2;
                                                    g.trans[d][b] = Math.log(g.data[d][b]) / Math.LN2
                                                } else {
                                                    if (e == "log10") {
                                                        this.transformBase = 10;
                                                        g.trans[d][b] = Math.log(g.data[d][b]) / Math.LN10
                                                    } else {
                                                        if (e == "exp2") {
                                                            this.transformBase = 2;
                                                            g.trans[d][b] = Math.pow(2, g.data[d][b])
                                                        } else {
                                                            if (e == "exp10") {
                                                                this.transformBase = 10;
                                                                g.trans[d][b] = Math.pow(10, g.data[d][b])
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.isGroupedData) {
                                        this.isTransformedData = e;
                                        this.groupSamples(this.groupingFactors, false, false, true, true)
                                    }
                                    return true
                                };
                                this.transformRatio = function() {
                                    var h = [];
                                    var q = this.data;
                                    var a = this.isGroupedData && !this.graphType.match(/dotplot|boxplot/i) ? q.w : q.y;
                                    if (this.isGroupedData && this.ratioGroupReference && q.x.hasOwnProperty(this.ratioGroupReference)) {
                                        if (!this.ratioLevelReference) {
                                            for (var w = 0; w < q.x[this.ratioGroupReference].length; w++) {
                                                if (q.x[this.ratioGroupReference][w] != null) {
                                                    this.ratioLevelReference = q.x[this.ratioGroupReference][w];
                                                    break
                                                }
                                            }
                                        }
                                        if (this.groupingFactors.length == 1) {
                                            this.ratioReference = this.getSampleIndices(this.ratioLevelReference);
                                            if (this.ratioReference < 0) {
                                                this.ratioLevelReference = q.w.smps[0];
                                                this.ratioReference = 0
                                            }
                                            h = [this.ratioReference]
                                        } else {
                                            var f = [];
                                            for (var w = 0; w < this.groupingFactors.length; w++) {
                                                if (this.groupingFactors[w] != this.ratioGroupReference) {
                                                    f.push(this.groupingFactors[w])
                                                }
                                            }
                                            var b = {};
                                            var y = [];
                                            var u = 0;
                                            for (var w = 0; w < this.smpIndices.length; w++) {
                                                var k = this.smpIndices[w];
                                                var p = [];
                                                var C;
                                                for (var t = 0; t < f.length; t++) {
                                                    var x = f[t];
                                                    C = q.x[x][k];
                                                    if (!C) {
                                                        C = "NA"
                                                    }
                                                    p.push(C)
                                                }
                                                C = p.join(" - ");
                                                if (!b.hasOwnProperty(C)) {
                                                    q.w.smps.push(C);
                                                    y[u] = C;
                                                    b[C] = [];
                                                    b[C].push(k);
                                                    u++
                                                } else {
                                                    b[C].push(k)
                                                }
                                            }
                                            h = this.getSamplesByAnnotationLevel(this.ratioGroupReference, this.ratioLevelReference);
                                            this.ratioReference = [];
                                            for (var w = 0; w < q.w.grps.length; w++) {
                                                var g = q.w.grps[w][0];
                                                var r = false;
                                                for (var s in b) {
                                                    for (var t = 0; t < b[s].length; t++) {
                                                        if (g == b[s][t]) {
                                                            r = this.getObjectArray(b[s]);
                                                            break
                                                        }
                                                    }
                                                    if (r) {
                                                        break
                                                    }
                                                }
                                                for (var t = 0; t < h.length; t++) {
                                                    if (r.hasOwnProperty(h[t])) {
                                                        this.ratioReference.push(h[t]);
                                                        break
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        if (this.ratioSampleReference) {
                                            var A = this.isGroupedData && this.graphType.match(/dotplot|boxplot/i);
                                            if (A) {
                                                this.isGroupedData = false;
                                                this.ratioReference = this.getSampleIndices(this.ratioSampleReference);
                                                this.isGroupedData = true
                                            } else {
                                                this.ratioReference = this.getSampleIndices(this.ratioSampleReference)
                                            }
                                        }
                                        if (this.ratioReference < 0) {
                                            this.ratioSampleReference = q.y.smps[0];
                                            this.ratioReference = 0
                                        }
                                        h = [this.ratioReference]
                                    }
                                    for (var w = 0; w < this.varIndices.length; w++) {
                                        var k = this.varIndices[w];
                                        if (!a.trans) {
                                            a.trans = []
                                        }
                                        if (!a.stdev) {
                                            a.stdev = []
                                        }
                                        if (!a.trans[k]) {
                                            a.trans[k] = []
                                        }
                                        if (!a.stdev[k]) {
                                            a.stdev[k] = []
                                        }
                                        for (var t = 0; t < a.data[k].length; t++) {
                                            var e;
                                            if (this.isGroupedData && this.ratioGroupReference && q.x.hasOwnProperty(this.ratioGroupReference)) {
                                                if (this.groupingFactors.length == 1) {
                                                    e = q.w.mean[k][this.ratioReference]
                                                } else {
                                                    e = q.w.mean[k][this.ratioReference[t]]
                                                }
                                            } else {
                                                e = a.data[k][this.ratioReference]
                                            }
                                            if (!isNaN(a.data[k][t]) && !isNaN(e) && e > 0) {
                                                var c = this.transformBase == 2 ? "ratio2" : "ratio10";
                                                var B = a.data[k][t] / e;
                                                var d = a.stdev[k][t];
                                                if (c == "ratio2") {
                                                    a.trans[k][t] = Math.log(B) / Math.LN2;
                                                    if (d && d > 0) {
                                                        a.tstdev[k][t] = Math.log(d) / Math.LN2
                                                    }
                                                } else {
                                                    if (c == "ratio10") {
                                                        a.trans[k][t] = Math.log(B) / Math.LN10;
                                                        if (d && d > 0) {
                                                            a.tstdev[k][t] = Math.log(d) / Math.LN10
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.transformRelative = function(u, q, p) {
                                    var c = this.isGroupedData && !this.graphType.match(/dotplot|boxplot/i) ? this.data.w : this.data.y;
                                    var k = this.isGroupedData ? false : true;
                                    var r;
                                    q = q ? q : this.transformAxis;
                                    if (q == "samples") {
                                        for (var g = 0; g < c.data[p].length; g++) {
                                            var b = [];
                                            for (var d = 0; d < this.varIndices.length; d++) {
                                                var h = this.varIndices[d];
                                                b.push(c.data[h][g])
                                            }
                                            if (u == "percentile") {
                                                r = this.range(b)
                                            } else {
                                                if (u == "zscore") {
                                                    r = this.sumarizeErrorData(b, k)
                                                }
                                            }
                                            for (var d = 0; d < this.varIndices.length; d++) {
                                                var h = this.varIndices[d];
                                                if (!c.trans) {
                                                    c.trans = []
                                                }
                                                if (!c.trans[h]) {
                                                    c.trans[h] = []
                                                }
                                                if (!isNaN(c.data[h][g])) {
                                                    if (u == "percentile") {
                                                        c.trans[h][g] = this.percentile(r[0], r[1], c.data[h][g])
                                                    } else {
                                                        if (u == "zscore") {
                                                            c.trans[h][g] = (c.data[h][g] - r[0]) / r[1]
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        for (var g = 0; g < this.varIndices.length; g++) {
                                            var s = this.varIndices[g];
                                            if (!c.trans) {
                                                c.trans = []
                                            }
                                            if (!c.trans[s]) {
                                                c.trans[s] = []
                                            }
                                            var b = c.data[s];
                                            if (u == "percentile") {
                                                r = this.range(b)
                                            } else {
                                                if (u == "zscore") {
                                                    r = this.sumarizeErrorData(b, k)
                                                }
                                            }
                                            for (var d = 0; d < b.length; d++) {
                                                if (!isNaN(c.data[s][d])) {
                                                    if (u == "percentile") {
                                                        c.trans[s][d] = this.percentile(r[0], r[1], c.data[s][d])
                                                    } else {
                                                        if (u == "zscore") {
                                                            c.trans[s][d] = (c.data[s][d] - r[0]) / r[1]
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.groupSamples = function(Q, F, N, b, y, f, q) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (!this.isRawData) {
                                        return
                                    }
                                    var P = this.data;
                                    if (!this.isArray(Q)) {
                                        Q = [Q]
                                    }
                                    if (!Q || Q.length < 1 || !P.x) {
                                        return this.ungroupSamples()
                                    }
                                    for (var L = 0; L < Q.length; L++) {
                                        if (!Q || !P.x[Q[L]]) {
                                            return this.ungroupSamples()
                                        }
                                    }
                                    if (!this.isDOE && this.layoutComb && !P.l.group) {
                                        P.l.group = Q;
                                        if (!y) {
                                            this.draw({
                                                func: "groupSamples",
                                                par: [Q, F, N, b, y, f, q]
                                            })
                                        }
                                        return
                                    }
                                    if (P.l && P.l.group) {
                                        P.l.group = Q
                                    }
                                    if (this.isDOE && this.layoutComb && P.l.comp) {
                                        this.varIndices = [];
                                        var r = P.l.comp.length;
                                        for (var L = 0; L < r; L++) {
                                            var p = P.l.comp[L].length;
                                            for (var K = 0; K < p; K++) {
                                                this.varIndices.push(P.l.comp[L][K])
                                            }
                                        }
                                    }
                                    var e = {};
                                    var G = {};
                                    var w = this.getObjectArray(this.smpOverlays);
                                    var A = P.w && P.w.smps ? P.w.smps : false;
                                    var u = this.cloneObject(this.hiddenGrps);
                                    if (!this.isDOE && !b) {
                                        this.resetIndices(true)
                                    }
                                    if (!b) {
                                        this.resetIndices()
                                    }
                                    this.isGroupedData = true;
                                    this.groupingFactors = Q;
                                    this.resetObject(true);
                                    this.hiddenGrps = q ? u : [];
                                    this.isGroupedData = false;
                                    var r = this.smpIndices.length;
                                    for (var L = 0; L < r; L++) {
                                        var C = this.smpIndices[L];
                                        var E = [];
                                        var H = [];
                                        var S;
                                        var I;
                                        var p = Q.length;
                                        for (var K = 0; K < p; K++) {
                                            var M = Q[K];
                                            S = this.getMetadataValue(C, "x", M);
                                            if (this.meta.data.x[M].type == "Numeric") {
                                                if (S == null) {
                                                    S = "NA"
                                                }
                                            } else {
                                                if (!S) {
                                                    S = "NA"
                                                }
                                            }
                                            E.push(S);
                                            if (!w.hasOwnProperty(M)) {
                                                H.push(S)
                                            }
                                        }
                                        S = E.join(" :: ");
                                        I = H.length > 0 ? H.join(" :: ") : "";
                                        if (!e.hasOwnProperty(S)) {
                                            P.w.smps.push(S);
                                            G[S] = I;
                                            e[S] = [];
                                            e[S].push(C)
                                        } else {
                                            e[S].push(C)
                                        }
                                    }
                                    this.isGroupedData = true;
                                    if (P.w.smps.length < 1) {
                                        P.w.smps = A;
                                        this.draw({
                                            func: "groupSamples",
                                            par: [Q, F, N, b, y, f, q]
                                        });
                                        return
                                    }
                                    var r = P.w.smps.length;
                                    for (var L = 0; L < r; L++) {
                                        var S = P.w.smps[L];
                                        P.w.labs.push(G[S]);
                                        P.w.grps.push(e[S]);
                                        P.w.grpIdxs.push(L)
                                    }
                                    this.grpIndices = [];
                                    if (N) {
                                        var r = N.length;
                                        for (var L = 0; L < r; L++) {
                                            this.grpIndices.push(N[L]);
                                            if (!q) {
                                                this.hiddenGrps.push(false)
                                            }
                                        }
                                    } else {
                                        var r = P.w.grps.length;
                                        for (var L = 0; L < r; L++) {
                                            this.grpIndices.push(L);
                                            if (!q) {
                                                this.hiddenGrps.push(false)
                                            }
                                        }
                                    }
                                    var r = this.varIndices.length;
                                    for (var L = 0; L < r; L++) {
                                        P.w.vars.push(P.y.vars[this.varIndices[L]])
                                    }
                                    var B = {};
                                    for (var S in P.x) {
                                        B[S] = this.meta.data.x[S].type == "Numeric"
                                    }
                                    var r = P.w.grps.length;
                                    for (var L = 0; L < r; L++) {
                                        for (var S in P.x) {
                                            if (!P.w.factors.hasOwnProperty(S)) {
                                                P.w.factors[S] = []
                                            }
                                            var x;
                                            if (B[S]) {
                                                x = [];
                                                var p = P.w.grps[L].length;
                                                for (var K = 0; K < p; K++) {
                                                    var R = this.getMetadataValue(P.w.grps[L][K], "x", S, true);
                                                    if (!isNaN(R)) {
                                                        x.push(R)
                                                    }
                                                }
                                                P.w.factors[S].push(this.mean(x))
                                            } else {
                                                x = {};
                                                var p = P.w.grps[L].length;
                                                for (var K = 0; K < p; K++) {
                                                    var R = this.getMetadataValue(P.w.grps[L][K], "x", S, true);
                                                    if (R != null && R !== "") {
                                                        x[R] = true
                                                    }
                                                }
                                                var c = this.getKeys(x);
                                                P.w.factors[S].push(c.join(" + "))
                                            }
                                        }
                                    }
                                    var B = [];
                                    if (F) {
                                        if (this.isArray(F)) {
                                            B = F
                                        } else {
                                            B.push(F)
                                        }
                                    } else {
                                        F = this.graphType == "Boxplot" ? "iqr" : this.graphType.match(/Stacked/i) ? "sum" : this.summaryType ? this.summaryType : "mean";
                                        B.push(F)
                                    }
                                    for (var D = 0; D < B.length; D++) {
                                        var O = [];
                                        var l = B[D];
                                        if (this.isTransformedData) {
                                            data = P.y.trans ? P.y.trans : this.dataStndBy.y.trans
                                        } else {
                                            if (this.isRawData) {
                                                data = P.y.data
                                            } else {
                                                if (this.summaryType == "median" || this.summaryType == "iqr") {
                                                    data = P.y.median
                                                } else {
                                                    if (this.summaryType == "mean") {
                                                        data = P.y.mean
                                                    } else {
                                                        if (this.summaryType == "cor") {
                                                            data = P.y.cor
                                                        } else {
                                                            if (this.summaryType == "sum") {
                                                                data = P.y.sum
                                                            } else {
                                                                if (this.summaryType == "max") {
                                                                    data = P.y.max
                                                                } else {
                                                                    if (this.summaryType == "min") {
                                                                        data = P.y.min
                                                                    } else {
                                                                        if (this.summaryType == "count") {
                                                                            data = P.y.count
                                                                        } else {
                                                                            data = P.y[this.summaryType]
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        var r = this.isDOE && this.isDOE == 1 ? this.data.y.vars.length : this.varIndices.length;
                                        for (var L = 0; L < r; L++) {
                                            var C = this.varIndices[L];
                                            O[C] = [];
                                            var p = P.w.grps.length;
                                            for (var K = 0; K < p; K++) {
                                                O[C][K] = [];
                                                var h = P.w.grps[K].length;
                                                for (var J = 0; J < h; J++) {
                                                    var g = P.w.grps[K][J];
                                                    O[C][K].push(data[C][g])
                                                }
                                            }
                                        }
                                        this.summarize(l, O)
                                    }
                                    this.setGroupLabels();
                                    this.setOriginalIndices(false, false, false, !this.layoutComb);
                                    if (!f) {
                                        this.xAxisValues = [];
                                        this.xAxis2Values = [];
                                        this.yAxisValues = [];
                                        this.zAxisValues = [];
                                        if (!this.layoutComb || !this.layoutAdjust) {
                                            if (typeof(this.setAxes) == "function") {
                                                this.setAxes()
                                            }
                                        }
                                    }
                                    if (!y) {
                                        this.draw({
                                            func: "groupSamples",
                                            par: [Q, F, N, b, y, f, q]
                                        })
                                    }
                                };
                                this.ungroupSamples = function(e, b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (!this.isGroupedData && !this.groupingFactors.length) {
                                        return
                                    }
                                    this.resetIndices(true);
                                    this.isGroupedData = false;
                                    var c = this.data;
                                    if (c.l) {
                                        delete(c.l.group)
                                    }
                                    if (c.w && !a) {
                                        delete(c.w)
                                    }
                                    this.groupingFactors = [];
                                    this.grpIndices = [];
                                    this.hiddenGrps = [];
                                    this.updateMetaData("w");
                                    if (!b) {
                                        this.setOriginalIndices(false, false, false, true)
                                    }
                                    if (!e) {
                                        this.draw({
                                            func: "ungroupSamples",
                                            par: [e, b, a]
                                        })
                                    }
                                    return
                                };
                                this.regroupSamples = function() {
                                    this.isGroupedData = false;
                                    this.groupSamples(this.groupingFactors, false, false, false, true)
                                };
                                this.removePivot = function(b) {
                                    this.removeMenus();
                                    var a = this.rebuildDataTableFilter();
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.isPivot) {
                                        this.switchData(true, true);
                                        if (this.isPivotSegregateVars.length || this.isPivotSegregateSmps.length) {
                                            this.desegregateVariablesSamples(true)
                                        }
                                        if (this.isPivotGroup) {
                                            this.groupSamples(this.isPivotGroup, false, false, false, true)
                                        }
                                        this.isPivot = false;
                                        if (this.isPivotSegregateVars.length || this.isPivotSegregateSmps.length) {
                                            this.segregateVariablesAndOrSamples(this.isPivotSegregateVars, this.isPivotSegregateSmps, true)
                                        }
                                        if (!b) {
                                            this.draw({
                                                func: "removePivot",
                                                par: [b]
                                            })
                                        }
                                    }
                                    this.rebuildDataTableFilter(a)
                                };
                                this.pivot = function(d, h) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.isPivot = true;
                                    this.isPivotGroup = this.cloneObject(this.groupingFactors);
                                    this.isPivotSegregateVars = this.cloneObject(this.segregateVariablesBy);
                                    this.isPivotSegregateSmps = this.cloneObject(this.segregateSamplesBy);
                                    this.dataStndBy = this.data;
                                    this.configStndBy = this.getConfig();
                                    this.removeMenus();
                                    var f = this.rebuildDataTableFilter();
                                    var e = {
                                        y: {
                                            data: [],
                                            vars: [],
                                            smps: []
                                        }
                                    };
                                    this.desegregateVariablesSamples(true);
                                    if (this.isPivotGroup) {
                                        this.ungroupSamples(true)
                                    }
                                    var g = d.shift();
                                    for (var c = 0; c < d.length; c++) {
                                        e.y.vars.push(d[c][0]);
                                        var a = [];
                                        for (var b = 1; b < g.length; b++) {
                                            a.push(d[c][b])
                                        }
                                        e.y.data.push(a)
                                    }
                                    g.shift();
                                    e.y.smps = g;
                                    this.initializeData(e, true);
                                    this.segregateVariablesAndOrSamples(this.isPivotSegregateVars, this.isPivotSegregateSmps, true);
                                    this.resetObject();
                                    if (!h) {
                                        this.draw({
                                            func: "pivot",
                                            par: [d, h]
                                        })
                                    }
                                    this.rebuildDataTableFilter(f)
                                };
                                this.pivotX = function(b, e) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.isPivot = true;
                                    this.isPivotGroup = this.cloneObject(this.groupingFactors);
                                    this.isPivotSegregateVars = this.cloneObject(this.segregateVariablesBy);
                                    this.isPivotSegregateSmps = this.cloneObject(this.segregateSamplesBy);
                                    this.dataStndBy = this.data;
                                    this.configStndBy = this.getConfig();
                                    this.removeMenus();
                                    var N = {
                                        y: {
                                            vars: [],
                                            smps: [],
                                            data: []
                                        }
                                    };
                                    var a = function(c) {
                                        var d = [];
                                        for (var g = 0; g < f.length; g++) {
                                            if (f[g] != b) {
                                                d.push(L.x[f[g]][c].toString().replace("\x00", ""))
                                            }
                                        }
                                        return d.length ? d.join("\x00") : "x" + c
                                    };
                                    this.desegregateVariablesSamples(true);
                                    var h = this.rebuildDataTableFilter();
                                    var f = this.sortObject(this.data.x);
                                    var K = false;
                                    var E = this.meta.data.x[b];
                                    var L = this.data;
                                    var G = E.levels.length;
                                    var s = [];
                                    var r = {};
                                    var C = [];
                                    var F = [];
                                    var D = 1;
                                    for (var J = 0; J < G; J++) {
                                        s[J] = {};
                                        for (var I = 0; I < L.y.smps.length; I++) {
                                            if (L.x[b][I] == E.levels[J]) {
                                                var M = a(I);
                                                if (!s[J][M]) {
                                                    s[J][M] = []
                                                }
                                                s[J][M].push(I)
                                            }
                                            if (M != null) {
                                                r[M] = true
                                            }
                                        }
                                    }
                                    for (var M in r) {
                                        z = 0;
                                        for (var J = 0; J < G; J++) {
                                            if (s[J].hasOwnProperty(M)) {
                                                z = Math.max(z, s[J][M].length)
                                            }
                                        }
                                        r[M] = z
                                    }
                                    for (var J = 0; J < G; J++) {
                                        for (I = 0; I < L.y.vars.length; I++) {
                                            N.y.data[J + I] = [];
                                            if (L.y.vars.length == 1) {
                                                N.y.vars.push(E.levels[J].replace("\x00", ""))
                                            } else {
                                                N.y.vars.push(L.y.vars[I] + "::" + E.levels[J].replace("\x00", ""))
                                            }
                                            for (var M in r) {
                                                for (var H = 0; H < r[M]; H++) {
                                                    if (J == 0 && I == 0) {
                                                        N.y.smps.push("Smp" + D++);
                                                        var B = M.split("\x00");
                                                        var A = 0;
                                                        for (var y = 0; y < f.length; y++) {
                                                            if (f[y] != b) {
                                                                if (!N.x) {
                                                                    N.x = {}
                                                                }
                                                                if (!N.x.hasOwnProperty(f[y])) {
                                                                    N.x[f[y]] = []
                                                                }
                                                                N.x[f[y]].push(B[A++])
                                                            }
                                                        }
                                                    }
                                                    if (s[J].hasOwnProperty(M) && s[J][M][H] != null) {
                                                        N.y.data[J + I].push(L.y.data[I][s[J][M][H]])
                                                    } else {
                                                        N.y.data[J + I].push(null)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (N.y.data.length != N.y.vars.length || N.y.data[0].length != N.y.smps.length) {
                                        this.isPivot = false;
                                        this.isPivotGroup = false;
                                        this.isPivotSegregateVars = false;
                                        this.isPivotSegregateSmps = false;
                                        this.dataStndBy = false;
                                        this.configStndBy = false;
                                        alert("Invalid Pivoting");
                                        return
                                    }
                                    if (this.groupingFactors) {
                                        this.modifyObjectArray([b], true, "groupingFactors");
                                        this.modifyObjectArray([b], true, "isPivotSegregateVars");
                                        this.modifyObjectArray([b], true, "isPivotSegregateSmps");
                                        K = this.groupingFactors;
                                        this.ungroupSamples(true)
                                    }
                                    this.initializeData(N, true);
                                    this.segregateVariablesAndOrSamples(this.isPivotSegregateVars, this.isPivotSegregateSmps, true);
                                    this.resetObject();
                                    if (K) {
                                        this.groupingFactors = K
                                    }
                                    if (!e) {
                                        this.draw({
                                            func: "pivotX",
                                            par: [b, e]
                                        })
                                    }
                                    this.isPivotSegregateVars = this.cloneObject(this.segregateVariablesBy);
                                    this.isPivotSegregateSmps = this.cloneObject(this.segregateSamplesBy);
                                    this.rebuildDataTableFilter(h)
                                };
                                this.pivotXX = function(h, a, g) {
                                    var c = [];
                                    var f = this.data;
                                    for (var b = 0; b < f.y.smps.length; b++) {
                                        c.push([f.x[h][b], f.x[a][b], f.y.data[0][b]])
                                    }
                                    var e = this.pivotMatrix(c, 0, 1, 2);
                                    return this.pivot(e, g)
                                };
                                this.pivotXY = function(h, a, g) {
                                    var e = [];
                                    var c;
                                    var f = this.data;
                                    if (f.x.hasOwnProperty(h)) {
                                        for (var b = 0; b < f.y.smps.length; b++) {
                                            e.push([f.x[h][b], f.y.data[0][b], f.y.data[1][b]])
                                        }
                                        if (f.y.vars[0] == a) {
                                            c = this.pivotMatrix(e, 0, 1, 2)
                                        } else {
                                            if (f.y.vars[1] == a) {
                                                c = this.pivotMatrix(e, 0, 2, 1)
                                            }
                                        }
                                    } else {
                                        if (f.x.hasOwnProperty(a)) {
                                            for (var b = 0; b < f.y.smps.length; b++) {
                                                e.push([f.x[a][b], f.y.data[0][b], f.y.data[1][b]])
                                            }
                                            if (f.y.vars[0] == h) {
                                                c = this.pivotMatrix(e, 1, 0, 2)
                                            } else {
                                                if (f.y.vars[1] == h) {
                                                    c = this.pivotMatrix(e, 2, 0, 1)
                                                }
                                            }
                                        }
                                    }
                                    return this.pivot(c, g)
                                };
                                this.pivotYY = function(f, a, e) {
                                    var d;
                                    f = this.getVariableIndices(f);
                                    a = this.getVariableIndices(a);
                                    var c = [];
                                    for (var b = 0; b < this.data.y.vars.length; b++) {
                                        if (b != f && b != a) {
                                            d = b;
                                            break
                                        }
                                    }
                                    return this.pivot(this.pivotMatrix(this.transposeMatrix(this.data.y.data), f, a, d), e)
                                };
                                this.transposeDataSet = function(f) {
                                    var h = f.x;
                                    var g = f.z;
                                    if (h) {
                                        f.z = h
                                    } else {
                                        delete(f.z)
                                    }
                                    if (g) {
                                        f.x = g
                                    } else {
                                        delete(f.x)
                                    }
                                    var l = f.y.smps;
                                    f.y.smps = f.y.vars;
                                    f.y.vars = l;
                                    var k = f.y.data;
                                    f.y.data = [];
                                    var b = f.y.vars.length;
                                    for (var c = 0; c < b; c++) {
                                        f.y.data[c] = [];
                                        var e = f.y.smps.length;
                                        for (var a = 0; a < e; a++) {
                                            f.y.data[c][a] = k[a][c]
                                        }
                                    }
                                    return f
                                };
                                this.transpose = function(E, f, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.removeMenus();
                                    if (this.graphType.match(/Gantt/)) {
                                        this.flashInfoSpan(100, 100, "Data transpose not allowed for Gantt graphs", 5000);
                                        return
                                    }
                                    if (this.graphType == "Bar" && this.barType == "lollipop" && !a) {
                                        this.flashInfoSpan(100, 100, "Data transpose not allowed for Lollipops", 5000);
                                        return
                                    }
                                    var w = this.rebuildDataTableFilter();
                                    var C = this.data;
                                    var y = this.meta.data;
                                    if (E) {
                                        return this.transposeMatrix(E)
                                    } else {
                                        this.ungroupSamples(true);
                                        this.transform("reset", false, false, true);
                                        if (C.l) {
                                            delete(C.l)
                                        }
                                        var e = ["varOverlays", "varOverlayInfo", "varOverlayProperties", "varOverlaysStrLength", "varOverlaysThicknessBottom", "varOverlaysThicknessTop", "varDendrogramNewick", "colorVarDendrogramBy", "heatmapVarSeparateBy", "variablesClustered"];
                                        var g = ["smpOverlays", "smpOverlayInfo", "smpOverlayProperties", "smpOverlaysStrLength", "smpOverlaysThicknessBottom", "smpOverlaysThicknessTop", "smpDendrogramNewick", "colorSmpDendrogramBy", "heatmapSmpSeparateBy", "samplesClustered"];
                                        for (var B = 0; B < e.length; B++) {
                                            if (this[e[B]] || this[g[B]]) {
                                                var q = this[e[B]];
                                                var r = this[g[B]];
                                                this[e[B]] = r;
                                                this[g[B]] = q
                                            }
                                        }
                                        var l = C.x;
                                        var k = C.z;
                                        if (l) {
                                            C.z = l
                                        } else {
                                            delete(C.z)
                                        }
                                        if (k) {
                                            C.x = k
                                        } else {
                                            delete(C.x)
                                        }
                                        var t = y.x;
                                        var c = y.z;
                                        y.x = c;
                                        y.z = t;
                                        for (var B in y.x) {
                                            y.x[B].origin = "x"
                                        }
                                        for (var B in y.z) {
                                            y.z[B].origin = "z"
                                        }
                                        var h = y.y.maxSmpChr;
                                        var b = y.y.maxSmpLen;
                                        var F = y.y.maxSmpStr;
                                        y.y.maxSmpChr = y.y.maxVarChr;
                                        y.y.maxSmpLen = y.y.maxVarLen;
                                        y.y.maxSmpStr = y.y.maxVarStr;
                                        y.y.maxVarChr = h;
                                        y.y.maxVarLen = b;
                                        y.y.maxVarStr = F;
                                        var u = C.y.smps;
                                        C.y.smps = C.y.vars;
                                        C.y.vars = u;
                                        var D = C.y.data;
                                        C.y.data = [];
                                        for (var B = 0; B < C.y.vars.length; B++) {
                                            C.y.data[B] = [];
                                            for (var A = 0; A < C.y.smps.length; A++) {
                                                C.y.data[B][A] = D[A][B]
                                            }
                                        }
                                        this.initializeData(this.data);
                                        this.resetObject();
                                        this.setOriginalIndices(false, false, false, true);
                                        this.dataTableTransposed = !this.dataTableTransposed;
                                        if (!f) {
                                            this.draw({
                                                func: "transpose",
                                                par: [E, f]
                                            })
                                        }
                                        this.rebuildDataTableFilter(w)
                                    }
                                };
                                this.chordifyData = function() {
                                    var q = {};
                                    var x = [];
                                    var N = [];
                                    var I = [];
                                    var A = [];
                                    for (var F = 0; F < this.varIndices.length; F++) {
                                        var l = this.varIndices[F];
                                        var L = this.data.y.vars[l];
                                        x.push(L);
                                        q[L] = {};
                                        for (var E = 0; E < this.smpIndices.length; E++) {
                                            var K = this.smpIndices[E];
                                            var J = this.data.y.smps[K];
                                            x.push(J);
                                            q[L][J] = this.data.y.data[l][K]
                                        }
                                    }
                                    x = this.unique(x);
                                    var B = x.length;
                                    var k = 0;
                                    for (var F = 0; F < B; F++) {
                                        N[F] = [];
                                        A.push(this.seq(0, B - 1, 1));
                                        var b = 0;
                                        for (var E = 0; E < B; E++) {
                                            N[F][E] = 0;
                                            if (q[x[F]] && q[x[F]][x[E]]) {
                                                N[F][E] = q[x[F]][x[E]]
                                            }
                                            b += N[F][E]
                                        }
                                        I.push(b);
                                        k += b
                                    }
                                    for (var F = 0; F < A.length; F++) {
                                        A[F].sort(function(d, c) {
                                            return N[F][c] - N[F][d]
                                        })
                                    }
                                    if (this.circularArc > 360) {
                                        this.circularArc = 360
                                    } else {
                                        if (this.circularArc < 90) {
                                            this.circularArc = 90
                                        }
                                    }
                                    var y = this.circularArc * (Math.PI * 2) / 360;
                                    var p = (y - this.radians(this.arcSegmentsSeparation) * (this.circularArc == 360 ? B : B - 1)) / k;
                                    var h = [];
                                    var f = [];
                                    var C = 0;
                                    for (var F = 0; F < B; F++) {
                                        var a = C;
                                        for (var E = 0; E < B; E++) {
                                            var H = A[F][E];
                                            var M = N[F][H];
                                            var D = C;
                                            var P = C += M * p;
                                            h[H * B + F] = {
                                                idx: F,
                                                sid: H,
                                                start: D,
                                                end: P,
                                                value: M,
                                                color: this.colors[H % this.colors.length]
                                            }
                                        }
                                        f[F] = {
                                            name: x[F],
                                            idx: F,
                                            start: a,
                                            end: C,
                                            value: I[F],
                                            color: this.colors[F % this.colors.length]
                                        };
                                        C += this.radians(this.arcSegmentsSeparation)
                                    }
                                    var O = [];
                                    for (var F = 0; F < B; F++) {
                                        for (var E = F; E < B; E++) {
                                            var e = h[E * B + F];
                                            var G = h[F * B + E];
                                            if (e.value || G.value) {
                                                O.push({
                                                    source: e,
                                                    target: G
                                                })
                                            }
                                        }
                                    }
                                    return {
                                        chords: O,
                                        segments: f,
                                        total: k,
                                        unit: p
                                    }
                                };
                                this.summarizeSwimmer = function() {
                                    if (this.isSwimmerSumarized) {
                                        if (this.isGroupedData != this.isSwimmerSumarized.grouped) {
                                            delete this.isSwimmerSumarized
                                        }
                                    }
                                    if (!this.isSwimmerSumarized) {
                                        var w = this;
                                        var p = function() {
                                            var c = {
                                                shape: [w.shapes[0], w.shapes[1]],
                                                shapeColor: ["grey", "grey"],
                                                size: [false, false],
                                                line: [false, false],
                                                lineColor: [false, false],
                                                lineStart: [false, false],
                                                lineEnd: [false, false],
                                                text: ["Response Start", "Response End"]
                                            };
                                            for (var e in B.color) {
                                                c.shape.push(false);
                                                c.shapeColor.push(false);
                                                c.size.push(false);
                                                c.line.push("solid");
                                                c.lineColor.push(B.color[e]);
                                                c.lineStart.push(false);
                                                c.lineEnd.push(false);
                                                c.text.push(e)
                                            }
                                            c.shape.push("triangle");
                                            c.shapeColor.push("grey");
                                            c.size.push(false);
                                            c.line.push(false);
                                            c.lineColor.push(false);
                                            c.lineStart.push(false);
                                            c.lineEnd.push(false);
                                            c.text.push("Continued Response");
                                            return c
                                        };
                                        var B = {
                                            high: [],
                                            cap: [],
                                            fill: [],
                                            color: {},
                                            shape: {},
                                            smps: {},
                                            grouped: this.isGroupedData
                                        };
                                        var a = this.get1DIndices();
                                        var b = this.getVariableIndices(this.swimHigh);
                                        var r = this.getVariableIndices(this.swimStart);
                                        var f = this.getVariableIndices(this.swimEnd);
                                        if (!this.swimStatus) {
                                            this.swimStatus = "Status"
                                        }
                                        if (!this.swimHighCap) {
                                            this.swimHighCap = "HighCap"
                                        }
                                        var D = this.meta.data.x && this.meta.data.x.hasOwnProperty(this.swimStatus) ? this.meta.data.x[this.swimStatus] : false;
                                        var A = this.meta.data.x && this.meta.data.x.hasOwnProperty(this.swimHighCap) ? this.meta.data.x[this.swimHighCap] : false;
                                        if (this.isGroupedData) {
                                            this.isGroupedData = false;
                                            for (var q = 0; q < a.length; q++) {
                                                for (var k = 0; k < this.data.w.grps[a[q]].length; k++) {
                                                    var u = this.data.w.grps[a[q]][k];
                                                    var t = this.getDataAtPos(b, u, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                    var C = this.getDataAtPos(r, u, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                    var x = this.getDataAtPos(f, u, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                    B.smps[this.data.w.smps[a[q]]] = q;
                                                    B.fill[q] = this.getPropertyValue(a[q], u, "colorBy");
                                                    if (D) {
                                                        var d = this.getMetadataValue(u, "x", this.swimStatus);
                                                        if (!B[d]) {
                                                            B[d] = []
                                                        }
                                                        if (!B[d][q]) {
                                                            B[d][q] = []
                                                        }
                                                        B[d][q].push([C, x]);
                                                        B.color[d] = this.darkenLightenColor(this.meta.data.x[this.swimStatus].colors[this.meta.data.x[this.swimStatus].order[d]], -50)
                                                    } else {
                                                        if (!B.none) {
                                                            B.none = []
                                                        }
                                                        if (!B.none[q]) {
                                                            B.none[q] = []
                                                        }
                                                        B.none[q].push([C, x]);
                                                        B.color.none = "green"
                                                    }
                                                    B.high.push(t);
                                                    if (A) {
                                                        var y = this.getMetadataValue(u, "x", this.swimHighCap);
                                                        B.cap[q] = y && y.match(/arrow/i) ? true : false
                                                    }
                                                }
                                            }
                                            this.isGroupedData = true
                                        } else {
                                            for (var q = 0; q < a.length; q++) {
                                                var t = this.getDataAtPos(b, a[q], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                var C = this.getDataAtPos(r, a[q], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                var x = this.getDataAtPos(f, a[q], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                B.smps[this.data.y.smps[a[q]]] = q;
                                                B.fill[q] = this.getPropertyValue(t[q], a[q], "colorBy");
                                                if (D) {
                                                    var d = this.getMetadataValue(a[q], "x", this.swimStatus);
                                                    if (!B[d]) {
                                                        B[d] = []
                                                    }
                                                    if (!B[d][q]) {
                                                        B[d][q] = []
                                                    }
                                                    B[d][q].push([C, x]);
                                                    B.color[d] = this.darkenLightenColor(this.meta.data.x[this.swimStatus].colors[this.meta.data.x[this.swimStatus].order[d]], -50)
                                                } else {
                                                    if (!B.none) {
                                                        B.none = []
                                                    }
                                                    if (!B.none[q]) {
                                                        B.none[q] = []
                                                    }
                                                    B.none[q].push([C, x]);
                                                    B.color.none = "green"
                                                }
                                                B.high.push(t);
                                                if (A) {
                                                    var y = this.getMetadataValue(a[q], "x", this.swimHighCap);
                                                    B.cap[q] = y && y.match(/arrow/i) ? true : false
                                                }
                                            }
                                        }
                                        this.isSwimmerSumarized = B;
                                        this.legend[0] = p()
                                    }
                                };
                                this.summarizeOncoprint = function() {
                                    if (this.isOncoprint && !this.isOncoprintSumarized) {
                                        var g = this;
                                        var r = this.data;
                                        var k = 80;
                                        var q = this.meta.data;
                                        var p = function() {
                                            for (var c = 0; c < q[g.oncoprintCNA].levels.length; c++) {
                                                if (q[g.oncoprintCNA].levels[c].match(/ampli/i)) {
                                                    return c
                                                }
                                            }
                                            return false
                                        };
                                        var a = function() {
                                            for (var c = 0; c < q[g.oncoprintCNA].levels.length; c++) {
                                                if (q[g.oncoprintCNA].levels[c].match(/delet/i)) {
                                                    return c
                                                }
                                            }
                                            return false
                                        };
                                        var l = function() {
                                            var y = q[g.oncoprintCNA].levels.length;
                                            var x = {};
                                            var t = p();
                                            var c = a();
                                            var w = [];
                                            if (t != null) {
                                                x[q[g.oncoprintCNA].levels[t]] = "rgb(255,0,0)"
                                            }
                                            if (c != null) {
                                                x[q[g.oncoprintCNA].levels[c]] = "rgb(0,0,255)"
                                            }
                                            for (var u = 0; u < q[g.oncoprintCNA].levels.length; u++) {
                                                var j = q[g.oncoprintCNA].levels[u];
                                                if (x.hasOwnProperty(j)) {
                                                    w.push(x[j])
                                                } else {
                                                    if (j == "") {
                                                        w.push("rgb(220,220,220)")
                                                    } else {
                                                        w.push(g.colors[u])
                                                    }
                                                }
                                            }
                                            q[g.oncoprintCNA].colors = w
                                        };
                                        var s = function() {
                                            if (g.oncoprintMUT) {
                                                var j = q[g.oncoprintMUT].levels.length;
                                                if (CanvasXpress.colorSchemes.Greens[j]) {
                                                    q[g.oncoprintMUT].colors = CanvasXpress.colorSchemes.Greens[j]
                                                } else {
                                                    if (j == 2) {
                                                        var c = CanvasXpress.colorSchemes.Greens[3];
                                                        q[g.oncoprintMUT].colors = [green[1], c[2]]
                                                    } else {
                                                        if (j == 1) {
                                                            q[g.oncoprintMUT].colors = ["rgb(0,153,0)"]
                                                        } else {
                                                            q[g.oncoprintMUT].colors = CanvasXpress.colorSchemes.Greens[9]
                                                        }
                                                    }
                                                }
                                            }
                                        };
                                        var f = {
                                            cols: [],
                                            rows: []
                                        };
                                        l();
                                        s();
                                        for (var e = 0; e < r.y.vars.length; e++) {
                                            f.rows[e] = {
                                                CNA: {},
                                                MUT: {},
                                                TOT: 0
                                            };
                                            for (var d = 0; d < q[this.oncoprintCNA].levels.length; d++) {
                                                var h = q[this.oncoprintCNA].levels[d];
                                                f.rows[e].CNA[h] = 0
                                            }
                                            for (var d = 0; d < q[this.oncoprintMUT].levels.length; d++) {
                                                var b = q[this.oncoprintMUT].levels[d];
                                                f.rows[e].MUT[b] = 0
                                            }
                                        }
                                        for (var e = 0; e < r.y.smps.length; e++) {
                                            f.cols[e] = {
                                                CNA: {},
                                                MUT: {},
                                                TOT: 0
                                            };
                                            for (var d = 0; d < q[this.oncoprintCNA].levels.length; d++) {
                                                var h = q[this.oncoprintCNA].levels[d];
                                                f.cols[e].CNA[h] = 0
                                            }
                                            for (var d = 0; d < q[this.oncoprintMUT].levels.length; d++) {
                                                var b = q[this.oncoprintMUT].levels[d];
                                                f.cols[e].MUT[b] = 0
                                            }
                                        }
                                        for (var e = 0; e < r.y.vars.length; e++) {
                                            for (var d = 0; d < r.y.smps.length; d++) {
                                                var h = this.getDataAtPos(e, d, false, false, false, false, this.oncoprintCNA);
                                                var b = this.getDataAtPos(e, d, false, false, false, false, this.oncoprintMUT);
                                                if (h) {
                                                    f.rows[e].CNA[h]++;
                                                    f.cols[d].CNA[h]++
                                                }
                                                if (b) {
                                                    f.rows[e].MUT[b]++;
                                                    f.cols[d].MUT[b]++
                                                }
                                                if (h || b) {
                                                    f.rows[e].TOT++;
                                                    f.cols[d].TOT++
                                                }
                                            }
                                        }
                                        if (!r.z) {
                                            r.z = {}
                                        }
                                        for (var e = 0; e < q[this.oncoprintCNA].levels.length; e++) {
                                            var h = q[this.oncoprintCNA].levels[e];
                                            r.z[h] = [];
                                            for (var d = 0; d < r.y.vars.length; d++) {
                                                r.z[h][d] = f.rows[d].CNA[h]
                                            }
                                            this.updateMetaData("z", h, false, true);
                                            this.varOverlayProperties[h] = {
                                                type: "Stacked",
                                                position: "top",
                                                thickness: k,
                                                color: q[this.oncoprintCNA].colors[e],
                                                showName: false,
                                                showBox: false
                                            };
                                            if (this.oncoprintColSummary) {
                                                this.varOverlays.push(h)
                                            }
                                        }
                                        for (var e = 0; e < q[this.oncoprintMUT].levels.length; e++) {
                                            var b = q[this.oncoprintMUT].levels[e];
                                            r.z[b] = [];
                                            for (var d = 0; d < r.y.vars.length; d++) {
                                                r.z[b][d] = f.rows[d].MUT[b]
                                            }
                                            this.updateMetaData("z", b, false, true);
                                            this.varOverlayProperties[b] = {
                                                type: "Stacked",
                                                position: "top",
                                                thickness: k,
                                                color: q[this.oncoprintMUT].colors[e],
                                                showName: false,
                                                showBox: false
                                            };
                                            if (this.oncoprintColSummary) {
                                                this.varOverlays.push(b)
                                            }
                                        }
                                        r.z["Altered-Vars"] = [];
                                        r.z["% Altered-Vars"] = [];
                                        for (var e = 0; e < r.y.vars.length; e++) {
                                            r.z["Altered-Vars"][e] = f.rows[e].TOT;
                                            r.z["% Altered-Vars"][e] = (f.rows[e].TOT / r.y.smps.length * 100).toFixed(1) + "%"
                                        }
                                        this.updateMetaData("z", "Altered-Vars", false, true);
                                        this.updateMetaData("z", "% Altered-Vars", false, true);
                                        this.varOverlayProperties["% Altered-Vars"] = {
                                            type: "Text",
                                            position: "bottom",
                                            thickness: this.overlaysThickness + 2,
                                            showName: false
                                        };
                                        if (!r.x) {
                                            r.x = {}
                                        }
                                        for (var e = 0; e < q[this.oncoprintCNA].levels.length; e++) {
                                            var h = q[this.oncoprintCNA].levels[e];
                                            r.x[h] = [];
                                            for (var d = 0; d < r.y.smps.length; d++) {
                                                r.x[h][d] = f.cols[d].CNA[h]
                                            }
                                            this.updateMetaData("x", h, false, true);
                                            this.smpOverlayProperties[h] = {
                                                type: "Stacked",
                                                position: "right",
                                                thickness: k,
                                                color: q[this.oncoprintCNA].colors[e],
                                                showName: false,
                                                showBox: false
                                            };
                                            if (this.oncoprintRowSummary) {
                                                this.smpOverlays.push(h)
                                            }
                                        }
                                        for (var e = 0; e < q[this.oncoprintMUT].levels.length; e++) {
                                            var b = q[this.oncoprintMUT].levels[e];
                                            r.x[b] = [];
                                            for (var d = 0; d < r.y.smps.length; d++) {
                                                r.x[b][d] = f.cols[d].MUT[b]
                                            }
                                            this.updateMetaData("x", b, false, true);
                                            this.smpOverlayProperties[b] = {
                                                type: "Stacked",
                                                position: "right",
                                                thickness: k,
                                                color: q[this.oncoprintMUT].colors[e],
                                                showName: false,
                                                showBox: false
                                            };
                                            if (this.oncoprintRowSummary) {
                                                this.smpOverlays.push(b)
                                            }
                                        }
                                        r.x["Altered-Smps"] = [];
                                        r.x["% Altered-Smps"] = [];
                                        for (var e = 0; e < r.y.smps.length; e++) {
                                            r.x["Altered-Smps"][e] = f.cols[e].TOT;
                                            r.x["% Altered-Smps"][e] = (f.cols[e].TOT / r.y.vars.length * 100).toFixed(1) + "%"
                                        }
                                        this.updateMetaData("x", "Altered-Smps", false, true);
                                        this.updateMetaData("x", "% Altered-Smps", false, true);
                                        this.smpOverlayProperties["% Altered-Smps"] = {
                                            type: "Text",
                                            position: "left",
                                            thickness: Math.ceil(q.x["% Altered-Smps"].maxLevLen),
                                            showName: false,
                                            rotate: true
                                        };
                                        if (this.oncoprintRowSummary) {
                                            this.smpOverlays.push("% Altered-Smps")
                                        }
                                        this.isOncoprintSumarized = true;
                                        this.sortOncoprint()
                                    }
                                };
                                this.getDataAtPos = function(h, g, p, d, f, q, l, b) {
                                    var c = Number.NaN;
                                    var a = this.isGroupedData ? this.data.w : this.data.y;
                                    if (l) {
                                        c = this.data.y[l][h][g]
                                    } else {
                                        if (this.isGroupedData || !this.isRawData) {
                                            if (this.isTransformedData) {
                                                if (!p) {
                                                    c = a.trans[h][g]
                                                } else {
                                                    if (p == "stdev") {
                                                        c = a.tstdev[h][g]
                                                    } else {
                                                        if (a.hasOwnProperty(p)) {
                                                            c = a[p][h][g]
                                                        }
                                                    }
                                                }
                                            } else {
                                                p = p ? p : this.summaryType;
                                                if (a.hasOwnProperty(p)) {
                                                    c = a[p][h] ? a[p][h][g] : NaN
                                                } else {
                                                    c = 0
                                                }
                                            }
                                        } else {
                                            if (p) {
                                                if (a[p] && a[p][h]) {
                                                    c = a[p][h][g]
                                                } else {
                                                    if (p == "sum" && !this.isGroupedData) {
                                                        c = a.data[h][g]
                                                    }
                                                }
                                            } else {
                                                if (this.isTransformedData && a.trans && a.trans.length) {
                                                    c = a.trans[h][g]
                                                } else {
                                                    c = a.data[h][g]
                                                }
                                                if (b) {
                                                    c = b - c
                                                }
                                            }
                                        }
                                    }
                                    if (d != "percentile" && ((f != null || q != null))) {
                                        if (f != null && f != false && f != undefined) {
                                            if (p == "out") {
                                                for (var e = 0; e < c.length; e++) {
                                                    c[e] = Math.max(f, c[e])
                                                }
                                            } else {
                                                c = Math.max(f, c)
                                            }
                                        }
                                        if (q != null && q != false && q != undefined) {
                                            if (p == "out") {
                                                for (var e = 0; e < c.length; e++) {
                                                    c[e] = Math.min(q, c[e])
                                                }
                                            } else {
                                                c = Math.min(q, c)
                                            }
                                        }
                                    }
                                    if (d) {
                                        if (!isNaN(c)) {
                                            if (d == "log2") {
                                                c = Math.log(c) / Math.LN2
                                            } else {
                                                if (d == "log10") {
                                                    c = Math.log(c) / Math.LN10
                                                } else {
                                                    if (d == "exp2") {
                                                        c = Math.pow(2, c)
                                                    } else {
                                                        if (d == "exp10") {
                                                            c = Math.pow(10, c)
                                                        } else {
                                                            if (d == "percentile") {
                                                                c = this.percentile(f, q, c)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return c == null ? Number.NaN : c
                                };
                                this.getDataForSmpAtPosition = function(b) {
                                    var a = [];
                                    var d = this.data.y.data.length;
                                    for (var c = 0; c < d; c++) {
                                        a.push(this.data.y.data[c][b])
                                    }
                                    return a
                                };
                                this.getDataForSmpGrpAtIndex = function(h, k, g, c) {
                                    var f = [];
                                    if (!k) {
                                        k = this.varIndices
                                    }
                                    if (this.isGroupedData || !this.isRawData) {
                                        var a = this.isGroupedData ? this.data.w : this.data.y;
                                        if (this.isTransformedData) {
                                            if (a.trans[0] && a.trans[0][h]) {
                                                f.push(a.trans[0][h])
                                            }
                                        } else {
                                            g = this.summaryType == "iqr" ? "median" : this.summaryType;
                                            if (a.hasOwnProperty(g) && a[g].length) {
                                                var b = this.isDOE && this.isDOE == 1 ? this.data.y.vars.length : k.length;
                                                for (var e = 0; e < b; e++) {
                                                    var j = k[e];
                                                    f.push(a[g][j][h])
                                                }
                                            }
                                        }
                                    } else {
                                        var d = g ? this.data.y[g] : this.data.y.data;
                                        var b = this.isDOE && this.isDOE == 1 ? this.data.y.vars.length : k.length;
                                        if (this.isTransformedData) {
                                            for (var e = 0; e < b; e++) {
                                                var j = k[e];
                                                f.push(this.data.y.trans[j][h])
                                            }
                                        } else {
                                            if (c) {
                                                for (var e = 0; e < b; e++) {
                                                    var j = k[e];
                                                    f.push(this.getDataAtPos(j, h, false, c))
                                                }
                                            } else {
                                                for (var e = 0; e < b; e++) {
                                                    var j = k[e];
                                                    f.push(d[j][h])
                                                }
                                            }
                                        }
                                    }
                                    return f
                                };
                                this.getDataForVariableAtIndex = function(b) {
                                    var a = [];
                                    var e = this.smpIndices.length;
                                    if (this.isTransformedData) {
                                        for (var c = 0; c < e; c++) {
                                            var d = this.smpIndices[c];
                                            a.push(this.data.y.trans[b][d])
                                        }
                                    } else {
                                        for (var c = 0; c < e; c++) {
                                            var d = this.smpIndices[c];
                                            a.push(this.data.y.data[b][d])
                                        }
                                    }
                                    return a
                                };
                                this.getMetaDataForVariableAtIndex = function(a) {
                                    var c = {};
                                    if (this.data.z) {
                                        for (var b in this.data.z) {
                                            c[b] = this.getMetadataValue(a, "z", b)
                                        }
                                    }
                                    c[name] = this.data.y.vars[a];
                                    return c
                                };
                                this.getMetaDataForSampleAtIndex = function(a) {
                                    if (this.isGroupedData) {
                                        return this.getMetaDataForGrpAtIndex(a)
                                    } else {
                                        return this.getMetaDataForSmpAtIndex(a)
                                    }
                                };
                                this.getMetaDataForSmpAtIndex = function(a) {
                                    var c = {};
                                    if (this.data.x) {
                                        for (var b in this.data.x) {
                                            c[b] = this.getMetadataValue(a, "x", b)
                                        }
                                    } else {
                                        i = Math.min(Math.max(Math.floor(v * (m.vals.length + 1) / m.vals[n]) - 1, 0), n)
                                    }
                                    c[name] = this.data.y.vars[a];
                                    return c
                                };
                                this.getMetaDataForGrpAtIndex = function(a) {
                                    var d = [];
                                    var e = this.data.w.grps[a].length;
                                    for (var b = 0; b < e; b++) {
                                        var c = this.data.w.grps[a][b];
                                        d.push(this.getMetaDataForSmpAtIndex[c])
                                    }
                                    return d
                                };
                                this.setOriginalIndices = function(f, a, b, e) {
                                    var d = this.layoutComb && this.layoutParams ? this.layoutParams[f || 0] : this;
                                    if (!a) {
                                        a = d.varIndices
                                    }
                                    if (!b) {
                                        b = this.isGroupedData ? d.grpIndices : d.smpIndices
                                    }
                                    if (e || !d.startingVarIndices || d.startingVarIndices.length == 0) {
                                        d.startingVarIndices = this.cloneObject(a)
                                    }
                                    if (this.isGroupedData) {
                                        if (e || !d.startingGrpIndices || d.startingGrpIndices.length == 0) {
                                            d.startingGrpIndices = this.cloneObject(b)
                                        }
                                    } else {
                                        if (e || !d.startingSmpIndices || d.startingSmpIndices.length == 0) {
                                            d.startingSmpIndices = this.cloneObject(b)
                                        }
                                    }
                                };
                                this.validateNetworkPropertyValues = function(c) {
                                    var f = ["colorNodeBy", "shapeNodeBy", "sizeNodeBy", "patternNodeBy"];
                                    var h = ["colorEdgeBy", "SizeEdgeBy"];
                                    var g = this.meta.data;
                                    for (var e = 0; e < f.length; e++) {
                                        var b = this[f[e]];
                                        if (!g.nodes.hasOwnProperty(b)) {
                                            this[f[e]] = false
                                        }
                                    }
                                    for (var e = 0; e < h.length; e++) {
                                        var b = this[h[e]];
                                        if (!g.edges.hasOwnProperty(b)) {
                                            this[h[e]] = false
                                        }
                                    }
                                    if (this.decorations) {
                                        var k = [];
                                        for (var e = 0; e < this.decorations.length; e++) {
                                            var j = this.decorations[e];
                                            if (g.nodes.hasOwnProperty(j)) {
                                                k.push(j)
                                            }
                                        }
                                        this.decorations = k
                                    }
                                    if (c) {
                                        this.setLegends()
                                    }
                                };
                                this.validatePropertyValues = function(c) {
                                    var j = ["color", "shape", "size", "pattern", "outline", "connect", "motion", "ellipse", "ridge", "stack"];
                                    var b = "";
                                    for (var f = 0; f < j.length; f++) {
                                        var p = this[j[f] + "By"];
                                        if (this.isArray(p)) {
                                            p = p[0]
                                        }
                                        var k = this[p + "Data"];
                                        if (p) {
                                            if (this.isMultidimensionalData) {
                                                if (k && !this.data.y[k]) {
                                                    this[j[f] + "By"] = false;
                                                    this[p + "Data"] = false
                                                }
                                            } else {
                                                if (p == "variable") {
                                                    continue
                                                } else {
                                                    if (p == "data" && this.ridgeBy) {
                                                        continue
                                                    } else {
                                                        if (this.data.x && this.data.x.hasOwnProperty(p)) {
                                                            continue
                                                        } else {
                                                            if (this.data.z && this.data.z.hasOwnProperty(p)) {
                                                                if (j[f].match(/ellipse|ridge/) && this.meta.data.z[p].type == "Numeric") {
                                                                    this[j[f] + "By"] = false
                                                                }
                                                                continue
                                                            } else {
                                                                if (this.dataStndBy && this.dataStndBy.x && this.dataStndBy.x.hasOwnProperty(p)) {
                                                                    continue
                                                                } else {
                                                                    if (this.dataStndBy && this.dataStndBy.z && this.dataStndBy.z.hasOwnProperty(p)) {
                                                                        continue
                                                                    } else {
                                                                        if (this.getSampleIndices(p) != -1 || this.getSampleIndices(p, true) != -1) {
                                                                            continue
                                                                        } else {
                                                                            this[j[f] + "By"] = false
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.treemapBy.length > 0) {
                                        var g = [];
                                        var e = [];
                                        for (var f = 0; f < this.treemapBy.length; f++) {
                                            if (this.treemapBy[f] == "sample") {
                                                e.push("sample")
                                            } else {
                                                if (!this.data.x || !this.data.x.hasOwnProperty(this.treemapBy[f])) {
                                                    e.push("sample")
                                                } else {
                                                    if (this.data.x && this.data.x.hasOwnProperty(this.treemapBy[f])) {
                                                        g.push(this.treemapBy[f])
                                                    }
                                                }
                                            }
                                        }
                                        if (e.length > 0) {}
                                        this.treemapBy = g
                                    }
                                    var h = this.graphType.match(/Boxplot|Dotplot|Gantt|Scatter|Map/) || this.graphType == "Tree";
                                    if (this.shapeBy && !this.isMultidimensionalData && !h) {
                                        b += "shapeBy changed to false (shapeBy not support in" + this.graphType + ")\n";
                                        this.shapeBy = false
                                    } else {
                                        if (this.shapeBy && this.groupingFactors.length > 1 && !h) {
                                            b += "shapeBy changed to variable (multiple grouping factors not allowed)\n";
                                            this.shapeBy = "variable"
                                        } else {
                                            if (this.shapeBy && this.groupingFactors.length == 1 && this.shapeBy != this.groupingFactors[0] && !h) {
                                                b += "shapeBy changed to variable (grouping factor should the same as shapeBy)\n";
                                                this.shapeBy = "variable"
                                            }
                                        }
                                    }
                                    if (this.sizeBy && !this.isMultidimensionalData && !h) {
                                        b += "sizeBy changed to false (sizeBy not support in" + this.graphType + ")\n";
                                        this.sizeBy = false
                                    } else {
                                        if (this.sizeBy && this.groupingFactors.length > 1 && !h) {
                                            b += "sizeBy changed to variable (multiple grouping factors not allowed)\n";
                                            this.sizeBy = "variable"
                                        } else {
                                            if (this.sizeBy && this.groupingFactors.length == 1 && this.sizeBy != this.groupingFactors[0] && !h) {
                                                b += "sizeBy changed to variable (grouping factor should the same as sizeBy)\n";
                                                this.sizeBy = "variable"
                                            }
                                        }
                                    }
                                    if (this.colorBy && this.graphType == "Heatmap" && !this.isMultidimensionalData) {
                                        b += "colorBy changed to false (colorBy not support in" + this.graphType + ")\n";
                                        this.colorBy = false
                                    } else {
                                        if (this.colorBy && this.groupingFactors.length > 1 && !this.graphType.match(/Boxplot|Dotplot|Gantt|Scatter|Stacked|Treemap/)) {
                                            b += "colorBy changed to variable (multiple grouping factors not allowed)\n";
                                            this.colorBy = "variable"
                                        } else {
                                            if (this.colorBy && this.groupingFactors.length == 1 && this.colorBy != this.groupingFactors[0] && !this.graphType.match(/Boxplot|Dotplot|Gantt|Scatter|Stacked|Treemap/) && this.barType != "swimmer") {
                                                b += "colorBy changed to variable (grouping factor should the same as colorBy)\n";
                                                this.colorBy = "variable"
                                            }
                                        }
                                    }
                                    if ((this.shapeBy || this.sizeBy || this.patternBy || this.outlineBy) && !this.colorBy && !this.isMultidimensionalData && !this.graphType == "Heatmap") {
                                        this.colorBy = "variable"
                                    } else {
                                        if (!this.shapeBy && !this.sizeBy && !this.patternBy && this.colorBy == "variable") {
                                            this.colorBy = false
                                        }
                                    }
                                    if (this.shapeBy == "variable" && !this.colorBy && !this.graphType.match(/Scatter/)) {
                                        this.colorBy = "variable"
                                    }
                                    if (this.sizeBy == "variable" && !this.colorBy && !this.graphType.match(/Scatter/)) {
                                        this.colorBy = "variable"
                                    }
                                    if (this.patternBy == "variable" && !this.colorBy && !this.graphType.match(/Scatter/)) {
                                        this.colorBy = "variable"
                                    }
                                    if (this.stackBy && !this.colorBy) {
                                        this.colorBy = this.stackBy
                                    } else {
                                        if (this.stackBy && this.colorBy && this.stackBy != this.colorBy) {
                                            b += "colorBy changed to stackBy (remove stackBy to color by different factor)\n";
                                            this.colorBy = this.stackBy
                                        }
                                    }
                                    if (b != "") {
                                        this.flashInfoSpan(10, 10, b, 3000)
                                    }
                                    if (c) {
                                        this.setLegends()
                                    }
                                };
                                this.getPropertyValueBin = function(d, f, c, k, e) {
                                    var l = d.vals.length - 1;
                                    var g;
                                    if ((k[e] == "shapes" && !this.shapeByContinuous) || (k[e] == "sizes" && !this.sizeeByContinuous)) {
                                        for (var j = 0; j < d.vals.length; j++) {
                                            if (f <= d.vals[j]) {
                                                g = j;
                                                break
                                            }
                                        }
                                    } else {
                                        g = Math.min(Math.max(Math.floor(f * (d.vals.length + 1) / d.vals[l]) - 1, 0), l)
                                    }
                                    return c ? g : parseInt(this[k[e]][g])
                                };
                                this.getPropertyValueSize = function(b, d, c) {
                                    var e = b.vals.length - 1;
                                    return parseFloat((((d - b.min) / (b.max - b.min)) * (this[c][e] - this[c][0]))) + parseInt(this[c][0])
                                };
                                this.getMetadataValue = function(b, d, e, c) {
                                    if (this.isGroupedData && !c && d != "z") {
                                        return this.data.w && this.data.w.factors.hasOwnProperty(e) ? this.data.w.factors[e][b] : "NoCatFound"
                                    } else {
                                        if (d == "x" && this.data.x && this.data.x.hasOwnProperty(e)) {
                                            var a = this.meta.data.x[e];
                                            if (a.type == "String") {
                                                return this.data.x[e][b]
                                            } else {
                                                return this.data.x[e][b]
                                            }
                                        } else {
                                            if (d == "z" && this.data.z && this.data.z.hasOwnProperty(e)) {
                                                var a = this.meta.data.z[e];
                                                if (a.type == "String") {
                                                    return this.data.z[e][b]
                                                } else {
                                                    return this.data.z[e][b]
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getNodeEdgePropertyValue = function(e, c, r) {
                                    var g = e ? this.meta.data.nodes : this.meta.data.edges;
                                    var b = this[r];
                                    var k = {
                                        colorNodeBy: "colors",
                                        colorEdgeBy: "colors",
                                        shapeNodeBy: "shapes",
                                        sizeNodeBy: "sizes",
                                        sizeEdgeBy: "sizes",
                                        patternNodeBy: "patterns"
                                    };
                                    var l = 0.5;
                                    if (e) {
                                        if (b && g.hasOwnProperty(b) && e.hasOwnProperty(b) && e[b] != null) {
                                            if (g[b].type == "Numeric" && r != "shapeNodeBy") {
                                                switch (r) {
                                                    case "colorNodeBy":
                                                        return e[b] != null ? this.getColorForValue(g[b].colorBrew, Number(e[b])) : false;
                                                    case "shapeNodeBy":
                                                        var j = parseInt(this.percentile(g[b].min, g[b].max, Number(e[b])) / 10);
                                                        return j == 10 ? "circle" : "pie" + j;
                                                    case "sizeNodeBy":
                                                        var q = g[b].max - g[b].min <= 10 ? 100 : g[b].max - g[b].min <= 100 ? 50 : 20;
                                                        var j = parseInt(this.percentile(g[b].min, g[b].max, Number(e[b]))) / q;
                                                        return Math.pow(l + j, 2);
                                                    case "patternNodeBy":
                                                        return "closed"
                                                }
                                            } else {
                                                if (k[r]) {
                                                    var j = g[b].order[e[b]];
                                                    return g[b][k[r]][j]
                                                } else {
                                                    alert("Ooops")
                                                }
                                            }
                                        } else {
                                            r = r.replace("NodeBy", "");
                                            if (e.hasOwnProperty(r)) {
                                                return e[r]
                                            } else {
                                                switch (r) {
                                                    case "color":
                                                        return this.missingDataColor;
                                                    case "shape":
                                                        return "circle";
                                                    case "size":
                                                        return 1;
                                                    case "pattern":
                                                        return "closed"
                                                }
                                            }
                                        }
                                    } else {
                                        if (b && g.hasOwnProperty(b) && (c.hasOwnProperty(b))) {
                                            if (r == "colorEdgeBy") {
                                                if (g[b].type == "Numeric") {
                                                    return this.getColorForValue(g[b].colorBrew, Number(c[b]))
                                                } else {
                                                    if (k[r]) {
                                                        var j = g[b].order[c[b]];
                                                        return g[b][k[r]][j]
                                                    } else {
                                                        alert("Ooops")
                                                    }
                                                }
                                            } else {
                                                if (r = "sizeEdgeBy") {
                                                    if (g[b].type == "Numeric") {
                                                        var j = parseInt(this.percentile(g[b].min, g[b].max, Number(c.thickness)) * 3) / 100;
                                                        return l + (isNaN(j) ? l : j)
                                                    } else {
                                                        if (k[r]) {
                                                            var j = g[b].order[c[b]];
                                                            return g[b][k[r]][j]
                                                        } else {
                                                            alert("Ooops")
                                                        }
                                                    }
                                                } else {
                                                    alert("Ooops. Not implemented yet!")
                                                }
                                            }
                                        } else {
                                            if (r == "colorEdgeBy") {
                                                return c.color || this.foreground
                                            } else {
                                                if (r = "sizeEdgeBy") {
                                                    return c.thickness || this.edgeThickness
                                                } else {
                                                    alert("Ooops. Not implemented yet!")
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getPropertyValue = function(F, D, E) {
                                    var d = this;
                                    var x, w, f, B, j;
                                    var u = this[E];
                                    var C = this.ungroupGroupedData();
                                    var A = this.groupingFactors && this.groupingFactors.length == 1;
                                    var k = this.data;
                                    var G = this.meta.data;
                                    var y = {
                                        colorVarDendrogramBy: "colors",
                                        colorSmpDendrogramBy: "colors",
                                        colorBy: "colors",
                                        outlineBy: "colors",
                                        outlineByData: "colors",
                                        markerBy: "colors",
                                        shapeBy: "shapes",
                                        shapeByData: "shapes",
                                        sizeBy: "sizes",
                                        sizeByData: "sizes",
                                        patternBy: "patterns",
                                        patternByData: "patterns",
                                        stackBy: "colors"
                                    };
                                    var b = function() {
                                        var c = {};
                                        var p = 0;
                                        if (D >= 0 && k.w.grps[D]) {
                                            for (var h = 0; h < k.w.grps[D].length; h++) {
                                                var g = G.x[u].type;
                                                var a = k.x[u][k.w.grps[D][h]];
                                                if (!c.hasOwnProperty(a)) {
                                                    c[a] = true;
                                                    p++
                                                }
                                                if (p > 1) {
                                                    return false
                                                }
                                            }
                                        }
                                        return true
                                    };
                                    var e = function() {
                                        if (!d.patternBy) {
                                            if (F > d.colors.length - 1 && !d.colorBy) {
                                                return d[y[E]][Math.floor(F / d.colors.length)]
                                            } else {
                                                return d[y[E]][0]
                                            }
                                        } else {
                                            return d[y[E]][0]
                                        }
                                    };
                                    var r = E ? this[y[E]].length : false;
                                    if (F != null && D != null && u && k.y.hasOwnProperty(u)) {
                                        x = k.y[u][F][D];
                                        w = G[u];
                                        f = w.type
                                    } else {
                                        if (D != null && u && k.x && k.x.hasOwnProperty(u)) {
                                            w = G.x[u];
                                            if (C || !this.isGroupedData) {
                                                f = w.type;
                                                x = this.graphType == "Gantt" ? k.x[u][D] : this.isGroupedData ? k.w.smps[D] : k.x[u][D];
                                                if (w[E] && w[E].hasOwnProperty(x)) {
                                                    return w[E][x]
                                                } else {
                                                    if (E == "colorSmpDendrogramBy" && w.colorBy && w.colorBy.hasOwnProperty(x)) {
                                                        return w.colorBy[x]
                                                    }
                                                }
                                            } else {
                                                if (A && (this.groupingFactors[0] == u || b())) {
                                                    f = w.type;
                                                    x = D !== false && D >= 0 ? k.x[u][k.w.grps[D][0]] : false;
                                                    if (x && E.match(/color|patternBy/)) {
                                                        if (w[E] && w[E].hasOwnProperty(x)) {
                                                            return w[E][x]
                                                        } else {
                                                            if (w[y[E]]) {
                                                                return w[y[E]][w.order[x] % r]
                                                            } else {
                                                                return this[y[E]][w.order[x] % r]
                                                            }
                                                        }
                                                    } else {
                                                        return w[y[E]] ? w[y[E]][0] : E.match(/color/) ? this[y[E]][0] : E == "patternBy" ? e() : this[y[E]][0]
                                                    }
                                                } else {
                                                    return F != null && E.match(/color/) ? this[y[E]][F % r] : E == "patternBy" ? e() : this[y[E]][0]
                                                }
                                            }
                                        } else {
                                            if (F != null && u && k.z && k.z.hasOwnProperty(u)) {
                                                w = G.z[u];
                                                f = w.type;
                                                x = k.z[u][F];
                                                if (w[E] && w[E].hasOwnProperty(x)) {
                                                    return w[E][x]
                                                } else {
                                                    if (E == "colorVarDendrogramBy" && w.colorBy && w.colorBy.hasOwnProperty(x)) {
                                                        return w.colorBy[x]
                                                    }
                                                }
                                            } else {
                                                if (F != null && D != null && E && ((this.isGroupedData && G.w.smps.hasOwnProperty(E)) || (!this.isGroupedData && G.y.range.hasOwnProperty(E)))) {
                                                    x = k.y.data[F][D];
                                                    w = G.y.range[E];
                                                    f = G.y.type
                                                } else {
                                                    if (F != null && !this.isGroupedData && G.y.range.hasOwnProperty(u)) {
                                                        w = G.y.range[u];
                                                        f = w.type;
                                                        j = D != null ? false : this.getSampleIndices(u);
                                                        x = D != null ? k.y.data[F][D] : k.y.data[F] ? k.y.data[F][j >= 0 ? j : 0] : 0;
                                                        if (G.modified && G.modified.z && G.modified.z[u]) {
                                                            return this[y[E]][x % r]
                                                        } else {
                                                            if (!w.colorBrew) {
                                                                w.colorBrew = this.getColorBrew(false, w.min, w.max);
                                                                w.vals = w.colorBrew.vals
                                                            }
                                                        }
                                                    } else {
                                                        if (F != null) {
                                                            if (u) {
                                                                return this[y[E]][F % r]
                                                            } else {
                                                                return !u && E.match(/color/) ? this[y[E]][F % r] : E == "patternBy" ? e() : this[y[E]][0]
                                                            }
                                                        } else {
                                                            return this[y[E]][0]
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (f == "Numeric") {
                                        if (E.match(/color|outlineBy/)) {
                                            return !isNaN(x) ? this.getColorForValue(w.colorBrew, Number(x)) : this.missingDataColor
                                        } else {
                                            if (E.match(/shapeBy/)) {
                                                if (!isNaN(x)) {
                                                    return this.shapeByContinuous ? "pie" + this.getPropertyValueBin(w, x, true, y, E) : this[y[E]][this.getPropertyValueBin(w, x, true, y, E)]
                                                } else {
                                                    return "sphere"
                                                }
                                            } else {
                                                if (E.match(/sizeBy/)) {
                                                    if (!isNaN(x)) {
                                                        return this.sizeByContinuous ? this.getPropertyValueSize(w, x, y[E]) : this.getPropertyValueBin(w, x, false, y, E)
                                                    } else {
                                                        return this[y[E]][0]
                                                    }
                                                } else {
                                                    if (E.match(/patternBy/)) {
                                                        if (!isNaN(x)) {
                                                            return this.getPropertyValueBin(w, x, false, y, E)
                                                        } else {
                                                            return "closed"
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        if (f == "String") {
                                            if (w[y[E]]) {
                                                return E == "sizeBy" ? parseInt(w[y[E]][w.order[x] % r]) : w[y[E]][w.order[x] % r]
                                            } else {
                                                return E == "sizeBy" ? parseInt(this[y[E]][w.order[x] % r]) : this[y[E]][w.order[x] % r]
                                            }
                                        }
                                    }
                                };
                                this.resetMetaData = function(a) {
                                    delete(this.meta.data);
                                    this.initializeDataAttributes(false, false, false, true, a)
                                };
                                this.getMetadata = function(c, b) {
                                    var d = this.meta.data;
                                    if (b) {
                                        var e = c == "x" ? "z" : "x";
                                        if (c && d[c] && d[c].hasOwnProperty(b)) {
                                            return d[c][b]
                                        } else {
                                            if (d[e] && d[e].hasOwnProperty(b)) {
                                                return d[e][b]
                                            } else {
                                                if (d.x && d.x.hasOwnProperty(b)) {
                                                    return d.x[b]
                                                } else {
                                                    if (d.z && d.z.hasOwnProperty(b)) {
                                                        return d.z[b]
                                                    } else {
                                                        return false
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        if (c) {
                                            if (c == "x") {
                                                return d.x
                                            } else {
                                                if (c == "z") {
                                                    return d.z
                                                } else {
                                                    return d[c] ? d[c] : false
                                                }
                                            }
                                        } else {
                                            return d
                                        }
                                    }
                                };
                                this.updateGenomeMetaData = function(c) {
                                    if (c) {
                                        this.meta.data = {
                                            tracks: []
                                        }
                                    }
                                    for (var I = 0; I < this.data.tracks.length; I++) {
                                        var y = this.data.tracks[I];
                                        var p = {};
                                        if (y.type == "dataframe") {
                                            for (var F in y.dataframe) {
                                                var J = y.dataframe[F];
                                                if (this.isNumeric(J)) {
                                                    var s = this.range(J);
                                                    var a = this[this.axisAlgorithm](s[0], s[1], 5, this.axisWilkinsonLoose);
                                                    var q = [];
                                                    for (var C = 0; C < a.length; C++) {
                                                        q.push(a[C].toString())
                                                    }
                                                    var f = this.getMaxText(q);
                                                    var K = this.measureText(f, this.axisTickFont);
                                                    var B = Math.min(s[0], a[0]);
                                                    var H = Math.max(s[1], a[a.length - 1]);
                                                    var A = (y.height || this.featureTypeDefault) / ((H - B) * 1.05);
                                                    var h = this.getColorBrew(y.colorSpectrum || this.colorSpectrum, B, H);
                                                    p[F] = {
                                                        type: "Numeric",
                                                        range: s,
                                                        values: a,
                                                        valuesStr: q,
                                                        maxValueStrLen: K,
                                                        min: B,
                                                        max: H,
                                                        units: A,
                                                        brew: h
                                                    }
                                                } else {
                                                    var b = {};
                                                    for (var C = 0; C < J.length; C++) {
                                                        b[J[C]] = true
                                                    }
                                                    var x = this.sortObject(b);
                                                    var E = {};
                                                    var G = 0;
                                                    var L = 0;
                                                    var u = "";
                                                    for (var C = 0; C < x.length; C++) {
                                                        E[x[C]] = C;
                                                        var g = this.measureText(x[C], this.axisTickFont);
                                                        if (g > G) {
                                                            G = g;
                                                            L = x[C].length;
                                                            u = x[C]
                                                        }
                                                    }
                                                    var e = [];
                                                    for (var C = 0; C < x.length; C++) {
                                                        if (y.meta && y.meta.hasOwnProperty(F) && y.meta[F].hasOwnProperty("color") && y.meta[F].color.hasOwnProperty(x[C])) {
                                                            e.push(y.meta[F].color[x[C]])
                                                        } else {
                                                            e.push(this.colors[C % this.colors.length])
                                                        }
                                                    }
                                                    var w = [];
                                                    for (var C = 0; C < x.length; C++) {
                                                        if (y.meta && y.meta.hasOwnProperty(F) && y.meta[F].hasOwnProperty("shape") && y.meta[F].shape.hasOwnProperty(x[C])) {
                                                            w.push(y.meta[F].shape[x[C]])
                                                        } else {
                                                            w.push(this.shapes[C % this.shapes.length])
                                                        }
                                                    }
                                                    p[F] = {
                                                        type: "String",
                                                        levels: x,
                                                        order: E,
                                                        maxLevLen: G,
                                                        maxLevChr: L,
                                                        maxLevStr: u,
                                                        colors: e,
                                                        shapes: w,
                                                        sizes: this.getBestSizes(x.length)
                                                    }
                                                }
                                            }
                                        } else {
                                            if (y.type.match(/bar|heatmap/)) {
                                                var J = y.data;
                                                var r = [];
                                                for (var D = 0; D < J.length; D++) {
                                                    for (var C = 0; C < J[D].data.length; C++) {
                                                        r.push(J[D].data[C])
                                                    }
                                                }
                                                var s = this.range(r);
                                                var a = this[this.axisAlgorithm](s[0], s[1], 5, this.axisWilkinsonLoose);
                                                var q = [];
                                                for (var D = 0; D < a.length; D++) {
                                                    q.push(a[D].toString())
                                                }
                                                var f = this.getMaxText(q);
                                                var K = this.measureText(f, this.axisTickFont);
                                                var B = Math.min(s[0], a[0]);
                                                var H = Math.max(s[1], a[a.length - 1]);
                                                var A = (y.height || this.featureTypeDefault) / ((H - B) * 1.05);
                                                var h = this.getColorBrew(y.colorSpectrum || this.colorSpectrum, B, H);
                                                p = {
                                                    range: s,
                                                    values: a,
                                                    valuesStr: q,
                                                    maxValueStrLen: K,
                                                    min: B,
                                                    max: H,
                                                    units: A,
                                                    brew: h
                                                }
                                            }
                                        }
                                        this.meta.data.tracks.push(p)
                                    }
                                };
                                this.updateNetworkMetaData = function(h, P, M) {
                                    var c = this;
                                    var R = this.meta.data;
                                    var x = this.data;
                                    var p = ["nodes", "edges"];
                                    var w = this.nodeFont;
                                    var D = {
                                        x: true,
                                        y: true,
                                        z: true,
                                        width: true,
                                        height: true,
                                        eventless: true,
                                        color: true,
                                        hideLabel: true,
                                        imagePath: true,
                                        size: true,
                                        shape: true,
                                        endArrow: true,
                                        startArrow: true,
                                        elbows: true
                                    };
                                    var e = function(d) {
                                        for (var a in d) {
                                            if (d[a]["t"] == "Numeric") {
                                                var j = c.getKeys(d[a]["o"]);
                                                if (j.length == 2 && (d[a]["o"].hasOwnProperty("true") && d[a]["o"].hasOwnProperty("false"))) {
                                                    d[a]["t"] = "String"
                                                } else {
                                                    if (j.length == 1 && (d[a]["o"].hasOwnProperty("true") || d[a]["o"].hasOwnProperty("false"))) {
                                                        d[a]["t"] = "String"
                                                    } else {
                                                        if (j.length == 1 && d[a]["o"].hasOwnProperty("")) {
                                                            d[a]["t"] = "String"
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        return d
                                    };
                                    var L = function(a) {
                                        var k = {};
                                        for (var j = 0; j < c.data[a].length; j++) {
                                            var r = c.data[a][j];
                                            for (var d in r) {
                                                if (D.hasOwnProperty(d)) {
                                                    continue
                                                }
                                                var l = r[d] === null ? false : r[d];
                                                if (typeof(l) != "object") {
                                                    if (k.hasOwnProperty(d)) {
                                                        if (!k[d]["o"].hasOwnProperty(l)) {
                                                            k[d]["o"][l] = true
                                                        }
                                                        if (isNaN(l)) {
                                                            k[d]["t"] = "String"
                                                        }
                                                    } else {
                                                        k[d] = {
                                                            o: {},
                                                            t: isNaN(l) ? "String" : "Numeric"
                                                        };
                                                        k[d]["o"][l] = true
                                                    }
                                                } else {
                                                    if (!k.hasOwnProperty(d)) {
                                                        k[d] = {
                                                            o: {}
                                                        }
                                                    }
                                                    k[d]["t"] = "Object";
                                                    for (var t in l) {
                                                        k[d]["o"][t] = true
                                                    }
                                                }
                                            }
                                        }
                                        return e(k)
                                    };
                                    if (!h || h == "nodes" || h == "edges") {
                                        if (h && M && R[h][P]) {
                                            delete(R[h][P])
                                        }
                                        for (var K = 0; K < p.length; K++) {
                                            var E = p[K];
                                            if (h) {
                                                if (h != E) {
                                                    continue
                                                }
                                            }
                                            if (x[E]) {
                                                var b = L(E);
                                                for (var H in b) {
                                                    if (P) {
                                                        if (P != H) {
                                                            continue
                                                        }
                                                    }
                                                    R[E][H] = {};
                                                    R[E][H].len = this.measureText(H, w);
                                                    var G = R[E][H].len;
                                                    var N = H.length;
                                                    var u = H;
                                                    R[E][H].type = b[H]["t"];
                                                    var J = 0;
                                                    var Q = 0;
                                                    var A = "";
                                                    if (R[E][H].type == "String" || R[E][H].type == "Object") {
                                                        var B = this.sortObject(b[H]["o"]);
                                                        R[E][H].unique = this.isUnique(B);
                                                        R[E][H].levels = B;
                                                        R[E][H].order = {};
                                                        for (var I = 0; I < B.length; I++) {
                                                            R[E][H].order[B[I]] = I;
                                                            var f = this.measureText(B[I], w);
                                                            if (f > J) {
                                                                J = f;
                                                                Q = B[I].length;
                                                                A = B[I]
                                                            }
                                                        }
                                                        R[E][H].maxLevLen = J;
                                                        R[E][H].maxLevChr = Q;
                                                        R[E][H].maxLevStr = A;
                                                        R[E][H].colors = [];
                                                        var g = 0;
                                                        for (var I = 0; I < B.length; I++) {
                                                            R[E][H].colors.push(this.colors[g % this.colors.length]);
                                                            g++
                                                        }
                                                        R[E][H].shapes = [];
                                                        var g = 0;
                                                        for (var I = 0; I < B.length; I++) {
                                                            R[E][H].shapes.push(this.shapes[g % this.shapes.length]);
                                                            g++
                                                        }
                                                        R[E][H].sizes = this.getBestSizes(B.length, E == "edges");
                                                        R[E][H].patterns = [];
                                                        var g = 0;
                                                        for (var I = 0; I < B.length; I++) {
                                                            R[E][H].patterns.push(this.patterns[g % this.patterns.length]);
                                                            g++
                                                        }
                                                    } else {
                                                        R[E][H].unique = false;
                                                        var B = this.sortObject(b[H]["o"]);
                                                        var s = this.range(B);
                                                        R[E][H].rmin = s[0];
                                                        R[E][H].rmax = s[1];
                                                        R[E][H].n = B.length;
                                                        var O = this.colorSpectrum;
                                                        R[E][H].colorBrew = this.getColorBrew(O, s[0], s[1], this.colorSpectrumZeroValue, this.colorSpectrumBreaks);
                                                        R[E][H].min = R[E][H].colorBrew.min;
                                                        R[E][H].max = R[E][H].colorBrew.max;
                                                        R[E][H].zero = R[E][H].colorBrew.zero;
                                                        R[E][H].vals = R[E][H].colorBrew.vals;
                                                        R[E][H].incr = R[E][H].colorBrew.incr;
                                                        R[E][H].decs = R[E][H].colorBrew.decs;
                                                        R[E][H].levels = R[E][H].colorBrew.vals;
                                                        R[E][H].order = {};
                                                        for (var I = 0; I < R[E][H].levels.length; I++) {
                                                            R[E][H].order[R[E][H].levels[I]] = I;
                                                            var f = this.measureText(R[E][H].levels[I], w);
                                                            if (f > J) {
                                                                J = f;
                                                                Q = R[E][H].levels[I].toString().length;
                                                                A = R[E][H].levels[I]
                                                            }
                                                            R[E][H].maxLevLen = J;
                                                            R[E][H].maxLevChr = Q;
                                                            R[E][H].maxLevStr = A
                                                        }
                                                        R[E][H].shapes = this.shapes;
                                                        R[E][H].sizes = this.sizes;
                                                        R[E][H].patterns = this.patterns
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.decorations.length && this.decorationsType == "heatmap") {
                                        var q = [];
                                        R.decorations = {};
                                        R.decorations.unique = false;
                                        R.decorations.type = "Numeric";
                                        R.decorations.n = 0;
                                        for (var I = 0; I < this.decorations.length; I++) {
                                            var H = this.decorations[I];
                                            if (R.nodes[H] && R.nodes[H].type == "Numeric") {
                                                R.decorations.n += R.nodes[H].n;
                                                q.push(R.nodes[H].rmin);
                                                q.push(R.nodes[H].rmax)
                                            } else {
                                                if (R.nodes[H] && R.nodes[H].type == "Object") {
                                                    for (var F = 0; F < R.nodes[H].levels.length; F++) {
                                                        var y = R.nodes[H].levels[F];
                                                        for (var C = 0; C < x.nodes.length; C++) {
                                                            if (x.nodes[C][H] && x.nodes[C][H].hasOwnProperty(y) && x.nodes[C][H][y] && !isNaN(x.nodes[C][H][y])) {
                                                                R.decorations.n++;
                                                                q.push(x.nodes[C][H][y])
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (q.length) {
                                            var O = this.colorSpectrum;
                                            var s = this.range(q);
                                            R.decorations.rmin = s[0];
                                            R.decorations.rmax = s[1];
                                            R.decorations.colorBrew = this.getColorBrew(O, s[0], s[1], this.colorSpectrumZeroValue, this.colorSpectrumBreaks);
                                            R.decorations.min = R.decorations.colorBrew.min;
                                            R.decorations.max = R.decorations.colorBrew.max;
                                            R.decorations.zero = R.decorations.colorBrew.zero;
                                            R.decorations.vals = R.decorations.colorBrew.vals;
                                            R.decorations.incr = R.decorations.colorBrew.incr;
                                            R.decorations.decs = R.decorations.colorBrew.decs;
                                            R.decorations.levels = R.decorations.colorBrew.vals;
                                            R.decorations.order = {};
                                            for (var I = 0; I < R.decorations.levels.length; I++) {
                                                R.decorations.order[R.decorations.levels[I]] = I;
                                                var f = this.measureText(R.decorations.levels[I], w);
                                                if (f > J) {
                                                    J = f;
                                                    Q = R.decorations.levels[I].toString().length;
                                                    A = R.decorations.levels[I]
                                                }
                                                R.decorations.maxLevLen = J;
                                                R.decorations.maxLevChr = Q;
                                                R.decorations.maxLevStr = A
                                            }
                                        }
                                    }
                                };
                                this.updateMetaDataColors = function(a, p) {
                                    var l = this.meta.data;
                                    var d = this.data;
                                    var q = this.graphType == "Network" ? ["nodes", "edges"] : ["x", "z"];
                                    if (a && p) {
                                        p.colors = a;
                                        p.connects = a
                                    } else {
                                        for (var h = 0; h < q.length; h++) {
                                            var e = q[h];
                                            if (d[e] || this.isCreateHistogram) {
                                                if (this.graphType == "Network") {
                                                    this.decorationsColors = [];
                                                    return
                                                } else {
                                                    var b = d[e] || l[e];
                                                    for (var f in b) {
                                                        if (l[e][f].type == "String") {
                                                            var c = {};
                                                            if (d[e]) {
                                                                for (var g = 0; g < b[f].length; g++) {
                                                                    c[b[f][g]] = true
                                                                }
                                                            } else {
                                                                for (var g = 0; g < b[f].levels.length; g++) {
                                                                    c[b[f].levels[g]] = true
                                                                }
                                                            }
                                                            c = this.stringRangeSort(this.getKeys(c));
                                                            if (!this.colorKey && this.graphType != "Map") {
                                                                l[e][f].colors = [];
                                                                var r = 0;
                                                                for (var g = 0; g < c.length; g++) {
                                                                    l[e][f].colors.push(a[r % a.length]);
                                                                    r++
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.updateMetaData = function(G, X, U, H, y) {
                                    var D = this;
                                    var w = this.meta.data;
                                    var h = y && this.dataStndBy ? this.dataStndBy : this.data;
                                    var p = ["x", "z", "w"];
                                    var Q = this.font;
                                    var A = function(j, d, a, s) {
                                        var t = {};
                                        if (D.legendOrder && D.legendOrder[j]) {
                                            for (var r = 0; r < D.legendOrder[j].length; r++) {
                                                t[D.legendOrder[j][r]] = r
                                            }
                                            var aa = D.legendOrder[j].length;
                                            if (d) {
                                                for (var r in d) {
                                                    if (!t.hasOwnProperty(r)) {
                                                        t[r] = aa++
                                                    }
                                                }
                                            } else {
                                                for (var r = 0; r < a.length; r++) {
                                                    if (!t.hasOwnProperty(a[r])) {
                                                        t[r] = aa++
                                                    }
                                                }
                                            }
                                            return t
                                        } else {
                                            if (s) {
                                                a = [];
                                                for (var r in d) {
                                                    t[r] = new Date(D.dateFormat(r)).getTime();
                                                    a.push(r)
                                                }
                                                a = a.sort(function(ab, k) {
                                                    return t[ab] - t[k]
                                                });
                                                var Z = {};
                                                var aa = 0;
                                                for (var r = 0; r < a.length; r++) {
                                                    if (!Z.hasOwnProperty(a[r])) {
                                                        Z[a[r]] = aa++
                                                    }
                                                }
                                                return Z
                                            } else {
                                                return false
                                            }
                                        }
                                    };
                                    var R = function(Z, d) {
                                        if (D[Z + "Key"] && D[Z + "Key"][M]) {
                                            if (D.isObject(D[Z + "Key"][M])) {
                                                w[L][M][Z + "By"] = D[Z + "Key"][M];
                                                for (var k = 0; k < K.length; k++) {
                                                    if (!w[L][M][Z + "By"].hasOwnProperty(K[k])) {
                                                        var s = Number(K[k].replace("\x00", ""));
                                                        if (!w[L][M][Z + "By"].hasOwnProperty(s)) {
                                                            w[L][M][Z + "By"][K[k]] = d[k % d.length]
                                                        } else {
                                                            w[L][M][Z + "By"][K[k]] = w[L][M][Z + "By"][s]
                                                        }
                                                    } else {
                                                        if (Z == "color") {
                                                            w[L][M][Z + "By"][K[k]] = D.validateColor(w[L][M][Z + "By"][K[k]])
                                                        }
                                                    }
                                                }
                                                w[L][M][Z + "s"] = [];
                                                for (var k = 0; k < K.length; k++) {
                                                    w[L][M][Z + "s"][k] = w[L][M][Z + "By"][K[k]]
                                                }
                                            } else {
                                                if (D.isArray(D[Z + "Key"][M])) {
                                                    w[L][M][Z + "s"] = D[Z + "Key"][M]
                                                } else {
                                                    if (Z == "color") {
                                                        var t = K.length;
                                                        if (CanvasXpress.colorSchemes[D[Z + "Key"][M]][t]) {
                                                            w[L][M][Z + "s"] = CanvasXpress.colorSchemes[D[Z + "Key"][M]][t]
                                                        } else {
                                                            var r = D.getKeys(CanvasXpress.colorSchemes[D[Z + "Key"][M]]);
                                                            r.sort(function(aa, j) {
                                                                return aa - j
                                                            });
                                                            if (t > r[r.length - 1]) {
                                                                t--;
                                                                while (!CanvasXpress.colorSchemes[D[Z + "Key"][M]][t]) {
                                                                    t--
                                                                }
                                                            } else {
                                                                if (t < r[r.length - 1]) {
                                                                    t++;
                                                                    while (!CanvasXpress.colorSchemes[D[Z + "Key"][M]][t]) {
                                                                        t++
                                                                    }
                                                                }
                                                            }
                                                            w[L][M][Z + "s"] = CanvasXpress.colorSchemes[D[Z + "Key"][M]][t]
                                                        }
                                                        for (var k = 0; k < t; k++) {
                                                            w[L][M][Z + "s"][k] = D.validateColor(CanvasXpress.colorSchemes[D[Z + "Key"][M]][t][k])
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            w[L][M][Z + "s"] = [];
                                            var a = 0;
                                            if (Z == "color" && K.length > d.length && d.length == 1 && D.graphType == "Map") {
                                                var t = K.length;
                                                var r = D.getKeys(CanvasXpress.colorSchemes[D.colorScheme]);
                                                r.sort(function(aa, j) {
                                                    return aa - j
                                                });
                                                if (t > r[r.length - 1]) {
                                                    t--;
                                                    while (!CanvasXpress.colorSchemes[D.colorScheme][t]) {
                                                        t--
                                                    }
                                                } else {
                                                    if (t < r[r.length - 1]) {
                                                        t++;
                                                        while (!CanvasXpress.colorSchemes[D.colorScheme][t]) {
                                                            t++
                                                        }
                                                    }
                                                }
                                                for (var k = 0; k < t; k++) {
                                                    w[L][M][Z + "s"][k] = D.validateColor(CanvasXpress.colorSchemes[D.colorScheme][t][k])
                                                }
                                            } else {
                                                for (var k = 0; k < d.length; k++) {
                                                    if (Z == "color") {
                                                        w[L][M][Z + "s"].push(D.validateColor(d[a % d.length]))
                                                    } else {
                                                        w[L][M][Z + "s"].push(d[a % d.length])
                                                    }
                                                    a++
                                                }
                                            }
                                        }
                                    };
                                    var x = function(aa, d) {
                                        var r = D.colorSpectrum;
                                        if (D[aa + "Key"] && D[aa + "Key"][M]) {
                                            if (D.isObject(D[aa + "Key"][M])) {
                                                w[L][M][aa + "By"] = D[aa + "Key"][M];
                                                for (var k = 0; k < h[L][M].length; k++) {
                                                    if (!w[L][M][aa + "By"].hasOwnProperty(h[L][M][k].toString())) {
                                                        w[L][M][aa + "By"][h[L][M][k].toString()] = D[aa + "s"][k % D[aa + "s"].length]
                                                    }
                                                }
                                                w[L][M].orderS = A(M, false, h[L][M])
                                            } else {
                                                if (aa == "color") {
                                                    if (D.isArray(D[aa + "Key"][M])) {
                                                        r = D[aa + "Key"][M]
                                                    } else {
                                                        var s = D.getKeys(CanvasXpress.colorSchemes[D[aa + "Key"][M]]);
                                                        s.sort(function(ab, j) {
                                                            return ab - j
                                                        });
                                                        r = CanvasXpress.colorSchemes[D[aa + "Key"][M]].hasOwnProperty(8) ? CanvasXpress.colorSchemes[D[aa + "Key"][M]][8] : CanvasXpress.colorSchemes[D[aa + "Key"][M]][s[0]]
                                                    }
                                                }
                                            }
                                        }
                                        if (aa == "color") {
                                            w[L][M].colorBrew = D.getColorBrew(r, I[0], I[1], D.colorSpectrumZeroValue, D.colorSpectrumBreaks, true);
                                            var t = ["min", "max", "zero", "vals", "incr", "decs"];
                                            for (var k = 0; k < t.length; k++) {
                                                var a = t[k];
                                                w[L][M][a] = w[L][M].colorBrew[a]
                                            }
                                            w[L][M].levels = w[L][M].colorBrew.vals;
                                            w[L][M].order = {};
                                            for (var k = 0; k < w[L][M].levels.length; k++) {
                                                w[L][M].order[w[L][M].levels[k]] = k;
                                                var Z = D.measureText(w[L][M].levels[k], Q);
                                                if (Z > Y) {
                                                    Y = Z;
                                                    c = w[L][M].levels[k].toString().length;
                                                    T = w[L][M].levels[k]
                                                }
                                                w[L][M].maxLevLen = Y;
                                                w[L][M].maxLevChr = c;
                                                w[L][M].maxLevStr = T
                                            }
                                        } else {
                                            w[L][M][aa + "s"] = aa == "connect" ? D.colors : D[aa + "s"]
                                        }
                                    };
                                    if (!G || G == "w" || G == "x" || G == "z") {
                                        if (G && U) {
                                            if (!X) {
                                                delete(w[G])
                                            } else {
                                                if (w[G][X]) {
                                                    delete(w[G][X])
                                                }
                                            }
                                        }
                                        for (var P = 0; P < p.length; P++) {
                                            var L = p[P];
                                            if (G) {
                                                if (G != L) {
                                                    continue
                                                }
                                            }
                                            Q = L == "z" ? this.varLabelFont : this.smpLabelFont;
                                            if (h[L]) {
                                                for (var M in h[L]) {
                                                    if (X) {
                                                        if (X != M) {
                                                            continue
                                                        }
                                                    }
                                                    if (L == "w") {
                                                        if (M != "smps" && M != "grps") {
                                                            continue
                                                        }
                                                        if (M == "grps") {
                                                            w[L][M] = h[L][M];
                                                            w[L].smps = {};
                                                            for (var N = 0; N < h[L].smps.length; N++) {
                                                                w[L].smps[h[L].smps[N]] = N
                                                            }
                                                            continue
                                                        }
                                                    }
                                                    w[L][M] = {};
                                                    w[L][M].origin = L;
                                                    w[L][M].len = this.measureText(M, Q);
                                                    var V = w[L][M].len;
                                                    var b = M.length;
                                                    var O = M;
                                                    var S = this.isNumeric(h[L][M]) && !this.isEmpty(h[L][M]) && !this.isNull(h[L][M]);
                                                    w[L][M].type = S ? "Numeric" : "String";
                                                    var Y = 0;
                                                    var c = 0;
                                                    var T = "";
                                                    if (w[L][M].type == "String") {
                                                        w[L][M].unique = this.isUnique(h[L][M]);
                                                        w[L][M]["boolean"] = this.isBoolean(h[L][M]);
                                                        w[L][M]["date"] = this.isDate(h[L][M]);
                                                        w[L][M]["geo"] = this.isCountry(h[L][M]) || this.isUsa(h[L][M]);
                                                        if (w[L][M]["boolean"] && this.isR) {
                                                            for (var N = 0; N < h[L][M].length; N++) {
                                                                if (h[L][M][N] != null) {
                                                                    if (typeof(h[L][M][N]) == "string") {
                                                                        if (h[L][M][N].toLowerCase() == "true") {
                                                                            h[L][M][N] = true
                                                                        } else {
                                                                            if (h[L][M][N].toLowerCase() == "false") {
                                                                                h[L][M][N] = false
                                                                            } else {
                                                                                h[L][M][N] = null
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        var K = {};
                                                        for (var N = 0; N < h[L][M].length; N++) {
                                                            K[h[L][M][N]] = true
                                                        }
                                                        var e = A(M, K, false, w[L][M]["date"]);
                                                        K = this.stringRangeSort(this.getKeys(K));
                                                        w[L][M].levels = e ? K.sort(function(j, d) {
                                                            return e[j] - e[d]
                                                        }) : K;
                                                        w[L][M].order = {};
                                                        for (var N = 0; N < K.length; N++) {
                                                            w[L][M].order[K[N]] = e ? e[K[N]] : N;
                                                            var B = this.measureText(K[N], Q);
                                                            if (B > Y) {
                                                                Y = B;
                                                                c = K[N].length;
                                                                T = K[N]
                                                            }
                                                        }
                                                        w[L][M].maxLevLen = Y;
                                                        w[L][M].maxLevChr = c;
                                                        w[L][M].maxLevStr = T;
                                                        R("color", this.colors);
                                                        R("shape", this.shapes);
                                                        R("size", this.getBestSizes(K.length));
                                                        R("pattern", this.patterns);
                                                        R("connect", this.colors)
                                                    } else {
                                                        w[L][M].unique = false;
                                                        w[L][M]["boolean"] = false;
                                                        for (var N = 0; N < h[L][M].length; N++) {
                                                            if (h[L][M][N] != null) {
                                                                h[L][M][N] = Number(h[L][M][N])
                                                            } else {}
                                                        }
                                                        var I = this.range(h[L][M]);
                                                        w[L][M].rmin = I[0];
                                                        w[L][M].rmax = I[1];
                                                        w[L][M].n = h[L][M].length;
                                                        x("color", this.colors);
                                                        x("shape", this.shapes);
                                                        x("size", this.sizes);
                                                        x("pattern", this.patterns);
                                                        x("connect", this.colors)
                                                    }
                                                    if (!w.m[L]) {
                                                        w.m[L] = {}
                                                    }
                                                    if (w.m[L].maxFacLen) {
                                                        if (V > w.m[L].maxFacLen) {
                                                            w.m[L].maxFacLen = V;
                                                            w.m[L].maxFacChr = b;
                                                            w.m[L].maxFacStr = O
                                                        }
                                                    } else {
                                                        w.m[L].maxFacLen = V;
                                                        w.m[L].maxFacChr = b;
                                                        w.m[L].maxFacStr = O
                                                    }
                                                }
                                            }
                                            if (H) {
                                                return
                                            }
                                            var q, C, J;
                                            if (L == "z") {
                                                q = "y";
                                                C = "vars";
                                                J = "Var"
                                            }
                                            if (L == "x" || L == "q") {
                                                q = "y";
                                                C = "smps";
                                                J = "Smp"
                                            }
                                            if (L == "w") {
                                                q = "w";
                                                C = "smps";
                                                J = "Smp"
                                            }
                                            var Y = 0;
                                            var c = 0;
                                            var T = "";
                                            if (h[q]) {
                                                for (var N = 0; N < h[q][C].length; N++) {
                                                    if (h[q][C].length > this.fullTextMeasureCheck) {
                                                        var F = h[q][C][N].toString().length;
                                                        if (F > c) {
                                                            var B = this.measureText(h[q][C][N], Q);
                                                            if (B > Y) {
                                                                Y = B;
                                                                c = F;
                                                                T = h[q][C][N]
                                                            }
                                                        }
                                                    } else {
                                                        var F = h[q][C][N].toString().length;
                                                        if (F >= c) {
                                                            var B = this.measureText(h[q][C][N], Q);
                                                            if (B > Y) {
                                                                Y = B;
                                                                c = F;
                                                                T = h[q][C][N]
                                                            }
                                                        }
                                                    }
                                                }
                                                w[q]["max" + J + "Len"] = Y;
                                                w[q]["max" + J + "Chr"] = c;
                                                w[q]["max" + J + "Str"] = T;
                                                w[q].vars = this.isCountry(h.y.vars) ? "World" : this.isUsa(h.y.vars) ? "USA" : this.isDate(h.y.vars) ? "Date" : "String";
                                                w[q].smps = this.isCountry(h.y.smps) ? "World" : this.isUsa(h.y.smps) ? "USA" : this.isDate(h.y.smps) ? "Date" : "String";
                                                if (L == "x") {
                                                    if (!w[q]["range"]) {
                                                        w[q]["range"] = {}
                                                    }
                                                    for (var N = 0; N < h.y.smps.length; N++) {
                                                        var I = this.range(this.getDataForSmpAtPosition(N));
                                                        w[q]["range"][h.y.smps[N]] = {};
                                                        w[q]["range"][h.y.smps[N]].min = I[0];
                                                        w[q]["range"][h.y.smps[N]].max = I[1];
                                                        w[q]["range"][h.y.smps[N]].type = "Numeric"
                                                    }
                                                }
                                                if (L == "z") {
                                                    if (!w[q]["range"]) {
                                                        w[q]["range"] = {}
                                                    }
                                                    for (var N = 0; N < h.y.data.length; N++) {
                                                        var I = this.range(h.y.data[N]);
                                                        w[q]["range"][h.y.vars[N]] = {};
                                                        w[q]["range"][h.y.vars[N]].min = I[0];
                                                        w[q]["range"][h.y.vars[N]].max = I[1];
                                                        w[q]["range"][h.y.vars[N]].type = "Numeric"
                                                    }
                                                }
                                                if (L == "w") {
                                                    if (!w[q]["range"]) {
                                                        w[q]["range"] = {}
                                                    }
                                                    var g = [];
                                                    var l = this.isGroupedData ? this.data.w : this.data.y;
                                                    if (this.layoutValid && this.data.l && this.data.l.smps) {
                                                        for (var N = 0; N < this.data.l.smps.length; N++) {
                                                            g.push(N)
                                                        }
                                                    } else {
                                                        g = this.isGroupedData && this.grpIndices ? this.grpIndices : this.smpIndices
                                                    }
                                                    for (var N = 0; N < g.length; N++) {
                                                        var I = this.range(this.getDataForSmpGrpAtIndex(N));
                                                        w[q]["range"][l.smps[N]] = {};
                                                        w[q]["range"][l.smps[N]].min = I[0];
                                                        w[q]["range"][l.smps[N]].max = I[1];
                                                        w[q]["range"][l.smps[N]].type = "Numeric"
                                                    }
                                                }
                                            }
                                        }
                                        this.setColorScheme(G && X ? this.meta.data[G][X] : false)
                                    } else {
                                        if (h.y[G]) {
                                            w[G] = {};
                                            var Y = 0;
                                            var c = 0;
                                            var T = "";
                                            if (this.isNumeric2DArray(h.y[G])) {
                                                for (var N = 0; N < h.y[G].length; N++) {
                                                    for (var M = 0; M < h.y[G][N].length; M++) {
                                                        if (h.y[G][N][M] != null) {
                                                            h.y[G][N][M] = Number(h.y[G][N][M])
                                                        } else {
                                                            h.y[G][N][M] = Number.NaN
                                                        }
                                                    }
                                                }
                                                var I = this.setRangeDataObject(h.y[G]);
                                                w[G].rmin = I[0];
                                                w[G].rmax = I[1];
                                                w[G].n = h.y[G].length * h.y[G][0].length;
                                                w[G].type = "Numeric";
                                                w[G].colorBrew = this.getColorBrew(this.colorSpectrum, I[0], I[1], this.colorSpectrumZeroValue, this.colorSpectrumBreaks);
                                                var W = ["min", "max", "zero", "vals", "incr", "decs"];
                                                for (var N = 0; N < W.length; N++) {
                                                    var f = W[N];
                                                    w[G][f] = w[G].colorBrew[f]
                                                }
                                                w[G].levels = w[G].colorBrew.vals;
                                                w[G].order = {};
                                                for (var N = 0; N < w[G].levels.length; N++) {
                                                    w[G].order[w[G].levels[N]] = N;
                                                    var B = this.measureText(w[G].levels[N], Q);
                                                    if (B > Y) {
                                                        Y = B;
                                                        c = w[G].levels[N].toString().length;
                                                        T = w[G].levels[N]
                                                    }
                                                    w[G].maxLevLen = Y;
                                                    w[G].maxLevChr = c;
                                                    w[G].maxLevStr = T
                                                }
                                                w[G].shapes = this.shapes;
                                                w[G].sizes = this.sizes;
                                                w[G].patterns = this.patterns
                                            } else {
                                                var K = {};
                                                for (var N = 0; N < h.y[G].length; N++) {
                                                    for (var M = 0; M < h.y[G][N].length; M++) {
                                                        if (h.y[G][N][M] != null) {
                                                            K[h.y[G][N][M]] = true
                                                        } else {
                                                            h.y[G][N][M] = ""
                                                        }
                                                    }
                                                }
                                                K = this.stringRangeSort(this.getKeys(K));
                                                w[G].levels = K;
                                                w[G].order = {};
                                                for (var N = 0; N < K.length; N++) {
                                                    w[G].order[K[N]] = N;
                                                    var B = this.measureText(K[N], Q);
                                                    if (B > Y) {
                                                        Y = B;
                                                        c = K[N].length;
                                                        T = K[N]
                                                    }
                                                }
                                                w[G].maxLevLen = Y;
                                                w[G].maxLevChr = c;
                                                w[G].maxLevStr = T;
                                                w[G].type = "String";
                                                w[G].colors = [];
                                                var E = 0;
                                                for (var N = 0; N < K.length; N++) {
                                                    w[G].colors.push(this.colors[E % this.colors.length]);
                                                    E++
                                                }
                                                w[G].shapes = [];
                                                var E = 0;
                                                for (var N = 0; N < K.length; N++) {
                                                    w[G].shapes.push(this.shapes[E % this.shapes.length]);
                                                    E++
                                                }
                                                var u = this.getBestSizes(K.length);
                                                w[G].sizes = [];
                                                var E = 0;
                                                for (var N = 0; N < K.length; N++) {
                                                    w[G].sizes.push(u[E % u.length]);
                                                    E++
                                                }
                                                w[G].patterns = [];
                                                var E = 0;
                                                for (var N = 0; N < K.length; N++) {
                                                    w[G].patterns.push(this.patterns[E % this.patterns.length]);
                                                    E++
                                                }
                                            }
                                        } else {
                                            alert("Error while setting metadata. This may not work!")
                                        }
                                    }
                                };
                                this.setMetaData = function(a) {
                                    if (!this.meta.data) {
                                        if (this.graphType == "Network") {
                                            this.meta.data = {
                                                nodes: {},
                                                edges: {},
                                                decorations: {}
                                            };
                                            this.updateNetworkMetaData()
                                        } else {
                                            if (this.graphType == "Genome") {
                                                this.meta.data = {
                                                    tracks: []
                                                };
                                                this.updateGenomeMetaData()
                                            } else {
                                                if (this.graphType == "Venn") {} else {
                                                    this.meta.data = {
                                                        w: {},
                                                        x: {},
                                                        y: {},
                                                        z: {},
                                                        m: {},
                                                        c: {
                                                            z: {},
                                                            s: {},
                                                            p: []
                                                        },
                                                        d: {
                                                            m: {},
                                                            v: [],
                                                            g: [],
                                                            s: {},
                                                            a: {},
                                                            l: [],
                                                            q: null,
                                                            x: {},
                                                            y: {},
                                                            z: {},
                                                            d: {}
                                                        }
                                                    };
                                                    if (this.data.y) {
                                                        var h = this.data.y;
                                                        if (this.isRawData) {
                                                            for (var f = 0; f < h.data.length; f++) {
                                                                for (var e = 0; e < h.data[f].length; e++) {
                                                                    if (h.data[f][e] != null) {
                                                                        h.data[f][e] = h.data[f][e] == this.missingDataValue ? Number.NaN : Number(h.data[f][e])
                                                                    } else {
                                                                        h.data[f][e] = Number.NaN
                                                                    }
                                                                }
                                                            }
                                                        } else {
                                                            var g = this.summaryType == "iqr" ? ["iqr1", "iqr3", "median", "qtl1", "qtl3", "out"] : [this.summaryType];
                                                            for (var f = 0; f < g.length; f++) {
                                                                var q = g[f];
                                                                if (h.hasOwnProperty(q)) {
                                                                    for (var e = 0; e < h[q].length; e++) {
                                                                        for (var c = 0; c < h[q][e].length; c++) {
                                                                            if (q == "out") {
                                                                                for (var b = 0; b < h[q][e][c].length; b++) {
                                                                                    if (h[q][e][c][b] != null) {
                                                                                        h[q][e][c][b] = h[q][e][c][b] == this.missingDataValue ? Number.NaN : Number(h[q][e][c][b])
                                                                                    } else {
                                                                                        h.data[f][e] = Number.NaN
                                                                                    }
                                                                                }
                                                                            } else {
                                                                                if (h[q][e][c] != null) {
                                                                                    h[q][e][c] = h[q][e][c] == this.missingDataValue ? Number.NaN : Number(h[q][e][c])
                                                                                } else {
                                                                                    h[q][e][c] = Number.NaN
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                } else {
                                                                    h[q] = [];
                                                                    var p = this.summaryType == "iqr" ? "median" : this.summaryType;
                                                                    for (var e = 0; e < h[p].length; e++) {
                                                                        h[q][e] = [];
                                                                        for (var c = 0; c < h[p][e].length; c++) {
                                                                            h[q][e][c] = []
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            var q = this.summaryType == "iqr" ? "median" : this.summaryType;
                                                            h.data = [];
                                                            for (var f = 0; f < h[q].length; f++) {
                                                                h.data.push(h[q][f])
                                                            }
                                                        }
                                                    }
                                                    this.updateMetaData(false, false, false, false, a)
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setGroupLabels = function() {
                                    if (this.groupingFactors.length) {
                                        var e = true;
                                        if (this.colorBy && this.groupingFactors.includes(this.colorBy) && this.data.w && this.groupingFactors.length > 1) {
                                            e = false;
                                            var a = this.groupingFactors.indexOf(this.colorBy);
                                            for (var c = 0; c < this.data.w.smps.length; c++) {
                                                if (this.data.w.smps[c].length) {
                                                    if (!this.data.w.glab[c]) {
                                                        this.data.w.glab[c] = this.cloneObject(this.data.w.smps[c])
                                                    }
                                                    var d = this.data.w.glab[c].split(" :: ");
                                                    d.splice(a, 1).join(" :: ");
                                                    if (this.showLegend) {
                                                        this.data.w.smps[c] = d
                                                    }
                                                }
                                            }
                                        }
                                        if (this.shapeBy && this.groupingFactors.includes(this.shapeBy) && this.data.w && this.groupingFactors.length > 1) {
                                            e = false;
                                            var a = this.groupingFactors.indexOf(this.shapeBy);
                                            for (var c = 0; c < this.data.w.smps.length; c++) {
                                                if (this.data.w.smps[c].length) {
                                                    if (!this.data.w.glab[c]) {
                                                        this.data.w.glab[c] = this.cloneObject(this.data.w.smps[c])
                                                    }
                                                    var d = this.data.w.glab[c].split(" :: ");
                                                    d.splice(a, 1).join(" :: ");
                                                    if (this.showLegend) {
                                                        this.data.w.smps[c] = d
                                                    }
                                                }
                                            }
                                        }
                                        if (e) {
                                            if (this.data.w && this.data.w.glab.length == this.data.w.smps.length) {
                                                this.data.w.smps = this.cloneObject(this.data.w.glab)
                                            }
                                        }
                                    }
                                    if (this.data.w && this.data.w.smps && this.groupingFactors.length) {
                                        for (var c = 0; c < this.segregateSamplesBy.length; c++) {
                                            var a = this.groupingFactors.indexOf(this.segregateSamplesBy[c]);
                                            for (var b = 0; b < this.data.w.smps.length; b++) {
                                                if (this.data.w.smps[b].length) {
                                                    if (!this.data.w.glab[b]) {
                                                        this.data.w.glab[b] = this.cloneObject(this.data.w.smps[b])
                                                    }
                                                    var d = this.data.w.glab[b].split(" :: ");
                                                    if (a >= 0) {
                                                        d.splice(a, 1).join(" :: ")
                                                    } else {
                                                        d = d.join(" :: ")
                                                    }
                                                    this.data.w.smps[b] = d
                                                }
                                            }
                                        }
                                    }
                                    if (this.data.w) {
                                        this.updateMetaData("w")
                                    }
                                };
                                this.getIndices = function(b, f, c) {
                                    if (b != null && f) {
                                        if (!c) {
                                            c = this.getObjectArrayOrder(f)
                                        }
                                        var e = [];
                                        if (this.isArray(b)) {
                                            if (this.isArray(f)) {
                                                var g = b.length;
                                                for (var d = 0; d < g; d++) {
                                                    if (c.hasOwnProperty(b[d])) {
                                                        e.push(c[b[d]])
                                                    }
                                                }
                                                return e
                                            } else {
                                                return c.hasOwnProperty(f) ? c[f[d]] : -1
                                            }
                                        } else {
                                            return f.indexOf(b)
                                        }
                                    }
                                };
                                this.getLevelsByAnnotation = function(j, b, h) {
                                    var f = [];
                                    var p = {};
                                    var d = this.data[h];
                                    if (d && j && d[j]) {
                                        for (var g = 0; g < b.length; g++) {
                                            var k = b[g];
                                            var e = this.getMetadataValue(k, h, j);
                                            if (!p.hasOwnProperty(e)) {
                                                f.push(e)
                                            }
                                            p[e] = true
                                        }
                                    }
                                    return f
                                };
                                this.getVariablesSamplesByAnnotationLevel = function(j, d, b, g, f) {
                                    var q = [];
                                    o = this.data[g];
                                    if (o && j && o[j]) {
                                        if (d) {
                                            for (var e = 0; e < b.length; e++) {
                                                var p = b[e];
                                                var k = this.getMetadataValue(p, g, j);
                                                if (k == d) {
                                                    if (f && !f[p]) {
                                                        q.push(p)
                                                    } else {
                                                        q.push(p)
                                                    }
                                                }
                                            }
                                        } else {
                                            for (var e = 0; e < b.length; e++) {
                                                var p = b[e];
                                                var k = this.getMetadataValue(p, g, j);
                                                if (!k) {
                                                    if (f && !f[p]) {
                                                        q.push(p)
                                                    } else {
                                                        q.push(p)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return q
                                };
                                this.getVarSmpAnnotations = function(p, d, l, g, k) {
                                    var b = {};
                                    var h = [];
                                    var j = false;
                                    var e = this.data[k];
                                    if (!d) {
                                        d = k == "x" ? this.smpIndices : this.varIndices
                                    }
                                    if (e && e.hasOwnProperty(p)) {
                                        for (var f = 0; f < d.length; f++) {
                                            var r = d[f];
                                            var q = this.getMetadataValue(r, k, p);
                                            if (q != null) {
                                                b[q] = true;
                                                h.push(q)
                                            } else {
                                                j = true
                                            }
                                        }
                                        if (j) {
                                            h.push("")
                                        }
                                        if (g) {
                                            return l ? h.join("+") : h
                                        } else {
                                            h = []
                                        }
                                        for (var f in b) {
                                            h.push(f)
                                        }
                                        if (j) {
                                            h.push("")
                                        }
                                        return l ? h.join("+") : h
                                    }
                                };
                                this.setAllSamplesVisible = function(a, c, b) {
                                    var f = this.data;
                                    if (f.y) {
                                        var k = f.y.smps;
                                        if (!k && f.y.vars) {
                                            if (!f.y.data) {
                                                alert("Missing data object")
                                            }
                                            k = [];
                                            for (var e = 0; e < f.y.data[0].length; e++) {
                                                k.push("smp" + (e + 1))
                                            }
                                            f.y.smps = k
                                        }
                                        var h = [];
                                        var g = [];
                                        if (a) {
                                            for (var e = 0; e < a.length; e++) {
                                                h.push(a[e]);
                                                g.push(false)
                                            }
                                        } else {
                                            for (var e = 0; e < k.length; e++) {
                                                h.push(e);
                                                g.push(false)
                                            }
                                        }
                                        if (!c && this.varIndices) {
                                            this.filterData()
                                        }
                                        this.smpIndices = this.sortDir == "descending" ? h.reverse() : h;
                                        this.hiddenSmps = this.sortDir == "descending" ? g.reverse() : g
                                    }
                                    if (this.data.w && this.data.w.smps) {
                                        h = [];
                                        g = [];
                                        this.hiddenGrps = [];
                                        for (var e = 0; e < this.data.w.smps.length; e++) {
                                            h.push(e);
                                            g.push(false)
                                        }
                                        this.grpIndices = this.sortDir == "descending" ? h.reverse() : h;
                                        this.hiddenGrps = this.sortDir == "descending" ? g.reverse() : g
                                    }
                                    if (this.layoutComb && this.layoutParams && !b) {
                                        for (var e = 0; e < this.layoutParams.length; e++) {
                                            var j = this.layoutParams[e];
                                            if (j) {
                                                if (j.startingSmpIndices) {
                                                    j.smpIndices = j.startingSmpIndices;
                                                    j.smpIndicesStart = -1
                                                }
                                                if (this.isGroupedData && j.startingGrpIndices) {
                                                    j.grpIndices = j.startingGrpIndices;
                                                    j.grpIndicesStart = -1
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getSampleIndices = function(b, e, d, f, c) {
                                    if (!f) {
                                        f = this.isGroupedData && !e ? this.data.w.smps : d && this.dataStndBy ? this.dataStndBy.y.smps : this.data.y.smps;
                                        c = this.getObjectArrayOrder(f)
                                    }
                                    return this.getIndices(b, f, c)
                                };
                                this.getSamplesByAxis = function(b) {
                                    return this[b] || []
                                };
                                this.getSamplesByAnnotationLevel = function(c, b, d) {
                                    return this.getVariablesSamplesByAnnotationLevel(c, b, d || this.smpIndices, "x", this.hiddenSmps)
                                };
                                this.getSampleLevelsByAnnotation = function(b, c) {
                                    return this.getLevelsByAnnotation(b, c || this.smpIndices, "x")
                                };
                                this.setSamplesVisible = function(b, e) {
                                    if (this.isGroupedData) {
                                        this.grpIndices = [];
                                        for (var d = 0; d < b.length; d++) {
                                            this.grpIndices.push(b[d])
                                        }
                                    } else {
                                        this.smpIndices = [];
                                        for (var d = 0; d < b.length; d++) {
                                            this.smpIndices.push(b[d])
                                        }
                                    }
                                    if (status) {
                                        var c = this.getObjectArray(b);
                                        var g = this.isGroupedData ? this.data.w : this.data.y;
                                        var f = this.isGroupedData ? this.hiddenGrps : this.hiddenSmps;
                                        for (var d = 0; d < g.smps.length; d++) {
                                            if (c.hasOwnProperty(d)) {
                                                f[d] = false
                                            } else {
                                                f[d] = true
                                            }
                                        }
                                    }
                                };
                                this.hideUnhideSmps = function(g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (g) {
                                        var b = this.isGroupedData ? this.data.w : this.data.y;
                                        var e = this.isGroupedData ? this.hiddenGrps : this.hiddenSmps;
                                        var f = [];
                                        if (this.isArray(g)) {
                                            for (var d = 0; d < g.length; d++) {
                                                for (var c = 0; c < b.smps.length; c++) {
                                                    if (b.smps[c] == g[d]) {
                                                        if (e[c]) {
                                                            e[c] = false
                                                        } else {
                                                            e[c] = true
                                                        }
                                                        break
                                                    }
                                                }
                                            }
                                        } else {
                                            for (var d = 0; d < b.smps.length; d++) {
                                                if (b.smps[d] == g) {
                                                    if (e[d]) {
                                                        e[d] = false
                                                    } else {
                                                        e[d] = true
                                                    }
                                                    break
                                                }
                                            }
                                        }
                                        var a = [];
                                        for (var d = 0; d < b.smps.length; d++) {
                                            if (!e[d]) {
                                                a.push(d)
                                            }
                                        }
                                        this.setSamplesVisible(a);
                                        this.draw({
                                            func: "hideUnhideSmps",
                                            par: [g]
                                        })
                                    }
                                };
                                this.getSamples = function() {
                                    var c = [];
                                    var g = this.isGroupedData ? this.data.w.smps : this.data.y.smps;
                                    var h = this.isGroupedData ? this.data.w : this.data.y;
                                    var e = this.isGroupedData ? this.hiddenGrps : this.hiddenSmps;
                                    var f = this.isGroupedData ? this.grpIndices : this.smpIndices;
                                    for (var d = 0; d < g.length; d++) {
                                        var a = -1;
                                        for (var b = 0; b < f.length; b++) {
                                            if (f[b] == d) {
                                                a = b;
                                                break
                                            }
                                        }
                                        c.push({
                                            name: g[d],
                                            hidden: e[d],
                                            index: a
                                        })
                                    }
                                    return c
                                };
                                this.getSmpAnnotations = function(b, e, d, c) {
                                    return this.getVarSmpAnnotations(b, e, d, c, "x")
                                };
                                this.setAllVariablesVisible = function(g, h) {
                                    var j = this.data;
                                    if (j.y) {
                                        var c = j.y.vars;
                                        if (!c && j.y.data) {
                                            c = [];
                                            for (var f = 0; f < j.y.data.length; f++) {
                                                c.push("var" + (f + 1))
                                            }
                                            j.y.vars = c
                                        }
                                        var a = [];
                                        var b = [];
                                        if (!this.isDOE && this.xAxis.length && this.isOneDimensionalGraph()) {
                                            g = this.xAxis2.length ? this.getVariableIndices(this.xAxis).concat(this.getVariableIndices(this.xAxis2)) : this.getVariableIndices(this.xAxis);
                                            if (this.isArray(g)) {
                                                if (!g.length) {
                                                    for (var f = 0; f < j.y.data.length; f++) {
                                                        g.push(f)
                                                    }
                                                }
                                            } else {
                                                if (g >= 0) {
                                                    g = [g]
                                                } else {
                                                    g = false
                                                }
                                            }
                                        }
                                        if (g) {
                                            for (var f = 0; f < g.length; f++) {
                                                a.push(g[f]);
                                                b.push(false)
                                            }
                                        } else {
                                            for (var f = 0; f < c.length; f++) {
                                                a.push(f);
                                                b.push(false)
                                            }
                                        }
                                        if (!h && this.smpIndices) {
                                            this.filterData()
                                        }
                                        if (this.layoutComb && this.layoutParams) {
                                            for (var f = 0; f < this.layoutParams.length; f++) {
                                                var e = this.layoutParams[f];
                                                if (e && e.startingVarIndices) {
                                                    e.varIndices = e.startingVarIndices;
                                                    e.varIndicesStart = -1
                                                }
                                            }
                                        }
                                        this.varIndices = a;
                                        this.hiddenVars = b
                                    }
                                };
                                this.getVariableIndices = function(b, e, d, c) {
                                    if (!d) {
                                        d = e && this.dataStndBy ? this.dataStndBy.y.vars : this.data.y.vars;
                                        c = this.getObjectArrayOrder(d)
                                    }
                                    return this.getIndices(b, d, c)
                                };
                                this.setVariablesVisibleByAxis = function(c, b) {
                                    var d = this[c + "VarIndices"];
                                    d = [];
                                    for (var e = 0; e < b.length; e++) {
                                        d.push(b[e])
                                    }
                                };
                                this.getVariablesVisibleByAxis = function(b) {
                                    return this[b + "VarIndices"]
                                };
                                this.getVariablesByAnnotationLevel = function(c, b, d) {
                                    return this.getVariablesSamplesByAnnotationLevel(c, b, d || this.varIndices, "z", this.hiddenVars)
                                };
                                this.getVariableLevelsByAnnotation = function(b, c) {
                                    return this.getLevelsByAnnotation(b, c || this.varIndices, "z")
                                };
                                this.setVariablesVisible = function(b) {
                                    this.varIndices = [];
                                    for (var c = 0; c < b.length; c++) {
                                        this.varIndices.push(b[c])
                                    }
                                };
                                this.hideUnhideVars = function(f) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var e = this.data.y;
                                    var d = this.hiddenVars;
                                    if (f) {
                                        if (this.isArray(f)) {
                                            for (var c = 0; c < f.length; c++) {
                                                for (var b = 0; b < e.vars.length; b++) {
                                                    if (e.vars[b] == f[c]) {
                                                        if (d[b]) {
                                                            d[b] = false
                                                        } else {
                                                            d[b] = true
                                                        }
                                                        break
                                                    }
                                                }
                                            }
                                        } else {
                                            for (var c = 0; c < e.vars.length; c++) {
                                                if (e.vars[c] == f) {
                                                    if (d[c]) {
                                                        d[c] = false
                                                    } else {
                                                        d[c] = true
                                                    }
                                                    break
                                                }
                                            }
                                        }
                                        var a = [];
                                        for (var c = 0; c < e.vars.length; c++) {
                                            if (!d[c]) {
                                                a.push(c)
                                            }
                                        }
                                        this.setVariablesVisible(a);
                                        this.draw({
                                            func: "hideUnhideVars",
                                            par: [f]
                                        })
                                    }
                                };
                                this.getVariables = function() {
                                    var d = [];
                                    for (var c = 0; c < this.data.y.vars.length; c++) {
                                        var a = -1;
                                        for (var b = 0; b < this.varIndices.length; b++) {
                                            if (this.varIndices[b] == c) {
                                                a = b;
                                                break
                                            }
                                        }
                                        d.push({
                                            name: this.data.y.vars[c],
                                            hidden: this.hiddenVars[c],
                                            index: a
                                        })
                                    }
                                    return d
                                };
                                this.getVarAnnotations = function(b, e, d, c) {
                                    return this.getVarSmpAnnotations(b, e, d, c, "z")
                                };
                                this.setNodeIndices = function() {
                                    var e = this.data.nodes;
                                    var g = {};
                                    var f = {};
                                    var a = {};
                                    for (var b = 0; b < e.length; b++) {
                                        var c = e[b];
                                        g[c.id] = c;
                                        f[c.id] = b;
                                        a[c.id] = false
                                    }
                                    this.nodes = g;
                                    this.data.nodeIndices = f;
                                    this.nodeInitialCache = a
                                };
                                this.setNodes = function() {
                                    if (this.data.nodeIndices) {
                                        var a = this.data.nodeIndices;
                                        var e = this.data.nodes;
                                        var f = {};
                                        for (var b = 0; b < e.length; b++) {
                                            var c = e[b];
                                            f[c.id] = c
                                        }
                                        e = [];
                                        for (var b in a) {
                                            e[a[b]] = f[b]
                                        }
                                        this.data.nodes = e;
                                        this.nodes = f
                                    } else {
                                        this.setNodeIndices()
                                    }
                                };
                                this.setAllNodesVisible = function(c) {
                                    this.nodes = {};
                                    this.data.nodeIndices = {};
                                    var f = this.data.nodes;
                                    for (var a = 0; a < f.length; a++) {
                                        var b = f[a];
                                        b.hide = false;
                                        this.nodes[b.id] = b;
                                        this.data.nodeIndices[b.id] = a
                                    }
                                    var d = this.data.edges;
                                    for (var a = 0; a < d.length; a++) {
                                        d[a].hide = false
                                    }
                                    if (!c) {
                                        this.filterData()
                                    }
                                };
                                this.hideUnhideNodes = function(b, c) {
                                    c = c ? true : false;
                                    this.isHiddenNodes = c;
                                    var f = this.data.nodes;
                                    var j = this.nodes;
                                    if (b) {
                                        if (this.isArray(b)) {
                                            for (var a = 0; a < b.length; a++) {
                                                var g = b[a];
                                                var e = f[this.data.nodeIndices[g]];
                                                e.hide = c;
                                                if (j && j[g] != null) {
                                                    j[g].hide = c
                                                }
                                            }
                                        }
                                    } else {
                                        for (var a = 0; a < f.length; a++) {
                                            var e = f[a];
                                            e.hide = c;
                                            if (j && j[e.id] != null) {
                                                j[e.id].hide = c
                                            }
                                        }
                                        this.removeMenus();
                                        this.draw({
                                            func: "hideUnhideNodes",
                                            par: [b, c]
                                        })
                                    }
                                };
                                this.setAllFeaturesVisible = function() {
                                    var d = this.data.tracks;
                                    for (var c = 0; c < d.length; c++) {
                                        var a = d[c];
                                        a.hide = false;
                                        var e = a.data;
                                        for (var b = 0; b < e.length; b++) {
                                            e[b].hide = false
                                        }
                                    }
                                };
                                this.hideUnhideMapFeatures = function(c, b, d) {
                                    var e = this.meta.map.geojson.features;
                                    if (d) {
                                        for (var a = 0; a < e.length; a++) {
                                            e[a].hidden = d
                                        }
                                    }
                                    for (var a = 0; a < c.length; a++) {
                                        e[c[a]].hidden = b
                                    }
                                };
                                this.setAllMapFeaturesVisible = function() {
                                    if (this.meta.map && this.meta.map.geojson) {
                                        for (var a = 0; a < this.meta.map.geojson.features.length; a++) {
                                            this.meta.map.geojson.features[a].hidden = false
                                        }
                                    }
                                };
                                this.setIndices = function(c, a, b) {
                                    if (this.graphType == "Network") {
                                        this.setNodes()
                                    } else {
                                        if (this.graphType != "Genome" && this.graphType != "Venn") {
                                            this.setAllVariablesVisible(c, b);
                                            this.setAllSamplesVisible(a, b)
                                        }
                                    }
                                };
                                this.resetIndices = function(c) {
                                    if (this.isGroupedData && this.grpIndices) {
                                        if (c && this.grpIndices.length) {
                                            var a = [];
                                            for (var b = 0; b < this.grpIndices.length; b++) {
                                                var d = this.data.w.grps[this.grpIndices[b]];
                                                if (d) {
                                                    a = a.concat(d)
                                                }
                                            }
                                            this.smpIndices = a
                                        } else {
                                            this.setIndices()
                                        }
                                    }
                                };
                                this.initializeDataAttributes = function(j, b, f, e, h) {
                                    var d = this.graphType;
                                    var a = ["outlineByData", "shapeByData", "sizeByData", "patternByData"];
                                    if (!e) {
                                        this.setIndices(j, b, f)
                                    }
                                    if (d == "Network" || d == "Genome") {
                                        this.setMetaData(h)
                                    } else {
                                        if (d != "Venn") {
                                            this.setMetaData(h);
                                            for (var c = 0; c < a.length; c++) {
                                                if (this[a[c]] && this.data.y.hasOwnProperty(this[a[c]])) {
                                                    this.updateMetaData(this[a[c]])
                                                } else {
                                                    this[a[c]] = false
                                                }
                                            }
                                            if (this.oncoprintCNA && this.data.y.hasOwnProperty(this.oncoprintCNA)) {
                                                this.updateMetaData(this.oncoprintCNA);
                                                this.isOncoprint = true
                                            }
                                            if (this.oncoprintMUT && this.data.y.hasOwnProperty(this.oncoprintMUT)) {
                                                this.updateMetaData(this.oncoprintMUT)
                                            }
                                        }
                                    }
                                };
                                this.cleanData = function(c) {
                                    var b = ["sankey", "tree", "bubble", "gantt", "contour"];
                                    for (var a = 0; a < b.length; a++) {
                                        delete(c[b[a]])
                                    }
                                    return c
                                };
                                this.setGanttData = function() {
                                    if (!this.isGanttDataFormated) {
                                        this.data.gantt = [];
                                        for (var b = 0; b < this.data.y.vars.length; b++) {
                                            this.data.gantt[b] = [];
                                            for (var a = 0; a < this.data.y.smps.length; a++) {
                                                var c = this.data.y.data[b][a] != null ? this.parseDate(this.data.y.data[b][a]).getTime() : null;
                                                this.data.gantt[b].push(c)
                                            }
                                        }
                                        this.isGanttDataFormated = true
                                    }
                                };
                                this.setQQData = function() {
                                    if (!this.isQQ) {
                                        this.addQQPlot(true)
                                    } else {
                                        if (this.decorations && this.decorations.qq && this.decorations.qq[0].distribution != this.qqDistribution) {
                                            this.removeQQPlot(true);
                                            this.addQQPlot(true)
                                        }
                                    }
                                };
                                this.setCDFData = function() {
                                    if (!this.isCDF) {
                                        this.addCDFPlot(true)
                                    }
                                };
                                this.setManhattanData = function() {
                                    if (!this.isManhattanDataFormated) {
                                        var f = this;
                                        var l = function(p, s) {
                                            var q = 0;
                                            for (var r = 0; r < p - 1; r++) {
                                                q += f.chromosomeLengths[r]
                                            }
                                            return q + s
                                        };
                                        var g = this.manhattanMarkerChromosomeNumber ? this.getSampleIndices(this.manhattanMarkerChromosomeNumber) : -1;
                                        var j = this.manhattanMarkerPosition ? this.getSampleIndices(this.manhattanMarkerPosition) : -1;
                                        var b = this.manhattanMarkerLogPValue ? this.getSampleIndices(this.manhattanMarkerLogPValue) : -1;
                                        if (g < 0) {
                                            this.scatterType = false;
                                            alert("Missing marker chromosome number");
                                            return
                                        }
                                        if (j < 0) {
                                            this.scatterType = false;
                                            alert("Missing marker base postion");
                                            return
                                        }
                                        if (b < 0) {
                                            this.scatterType = false;
                                            alert("Missing marker p-value");
                                            return
                                        }
                                        if (!this.chromosomeLengths.length) {
                                            var a = [];
                                            for (var e = 0; e < this.data.y.vars.length; e++) {
                                                var d = this.data.y.data[e][g];
                                                var h = this.data.y.data[e][j];
                                                if (!a[d]) {
                                                    a[d] = []
                                                }
                                                a[d].push(h)
                                            }
                                            for (var e = 0; e < a.length; e++) {
                                                this.chromosomeLengths[e] = this.max(a[e] || [0]) + 1
                                            }
                                        }
                                        var k = this.getSampleIndices("Manhattan");
                                        if (k >= 0) {
                                            for (var e = 0; e < this.data.y.vars.length; e++) {
                                                this.data.y.data[e][k] = l(this.data.y.data[e][g], this.data.y.data[e][j])
                                            }
                                        } else {
                                            this.data.y.smps.push("Manhattan");
                                            for (var e = 0; e < this.data.y.vars.length; e++) {
                                                this.data.y.data[e].push(l(this.data.y.data[e][g], this.data.y.data[e][j]))
                                            }
                                        }
                                        var c = this.meta.config.user;
                                        this.manhattanMarkerChromosomeNumberIndex = g;
                                        this.manhattanMarkerPositionIndex = j;
                                        this.manhattanMarkerLogPValueIndex = b;
                                        this.xAxis = ["Manhattan"];
                                        this.xAxisTitle = c.xAxisTitle || "Chromosome";
                                        this.yAxis = [this.data.y.smps[b]];
                                        this.yAxisTitle = c.yAxisTitle || this.data.y.smps[b];
                                        this.xAxisMajorTicks = c.xAxisMajorTicks || false;
                                        this.xAxisMinorTicks = c.xAxisMinorTicks || false;
                                        this.xAxisRightMajorTick = c.xAxisRightMajorTick || false;
                                        this.yAxisMinorTicks = c.yAxisMinorTicks || false;
                                        this.yAxisTopMajorTick = c.yAxisTopMajorTick || false;
                                        this.yAxisBottomMajorTick = c.yAxisBottomMajorTick || false;
                                        this.plotBox = c.plotBox || false;
                                        this.isManhattanDataFormated = true
                                    }
                                };
                                this.setSankeyData = function() {
                                    if (this.sankeySource && this.sankeyTarget) {
                                        this.data.sankey = {
                                            nodes: [],
                                            links: []
                                        };
                                        var g = {};
                                        for (var c = 0; c < this.smpIndices.length; c++) {
                                            var e = this.smpIndices[c];
                                            var d = this.getMetadataValue(e, "x", this.sankeySource);
                                            var b = this.getMetadataValue(e, "x", this.sankeyTarget);
                                            var a = this.getDataAtPos(this.hierarchyVarIndex, e, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                            this.data.sankey.links.push({
                                                source: d,
                                                target: b,
                                                value: a,
                                                id: e
                                            });
                                            g[d] = true;
                                            g[b] = true
                                        }
                                        var h = 0;
                                        for (var c in g) {
                                            this.data.sankey.nodes.push({
                                                name: c,
                                                id: h++
                                            })
                                        }
                                        var f = {};
                                        this.data.sankey.nodes.forEach(function(j) {
                                            f[j.name] = j
                                        });
                                        this.data.sankey.links = this.data.sankey.links.map(function(j) {
                                            return {
                                                source: f[j.source],
                                                target: f[j.target],
                                                value: j.value,
                                                id: j.id
                                            }
                                        })
                                    } else {
                                        if (this.data.sankey) {
                                            delete(this.data.sankey)
                                        }
                                    }
                                };
                                this.setHierarchyData = function(b) {
                                    if (this.graphType == "Sankey" || (this.graphType == "Circular" && (this.circularType == "sunburst" || this.circularType == "bubble"))) {
                                        var f = this.hierarchyVar ? this.getVariableIndices(this.hierarchyVar) : 0;
                                        this.hierarchyVarIndex = f >= 0 ? f : 0
                                    }
                                    if (this.hierarchy.length > 0) {
                                        if (!this.data[b]) {
                                            this.data[b] = {};
                                            this.data[b]["data"] = {
                                                name: this.hierarchy[0],
                                                children: []
                                            };
                                            for (var f = 0; f < this.smpIndices.length; f++) {
                                                var l = this.smpIndices[f];
                                                var a = this.data[b]["data"].children;
                                                for (var e = 0; e < this.hierarchy.length; e++) {
                                                    var c = this.hierarchy[e];
                                                    var h = -1;
                                                    for (var d = 0; d < a.length; d++) {
                                                        if (this.getMetadataValue(l, "x", c) == a[d].name) {
                                                            h = d
                                                        }
                                                    }
                                                    if (h == -1) {
                                                        var g = this.getMetadataValue(l, "x", c);
                                                        if (g != null) {
                                                            a.push({
                                                                name: g,
                                                                children: []
                                                            });
                                                            h = a.length - 1
                                                        } else {
                                                            if (e == this.hierarchy.length - 1) {
                                                                a.push({
                                                                    name: this.data.y.smps[l],
                                                                    size: this.data.y.data[this.hierarchyVarIndex][l],
                                                                    idx: l
                                                                });
                                                                continue
                                                            } else {
                                                                continue
                                                            }
                                                        }
                                                    }
                                                    a = a[h].children;
                                                    if (e === this.hierarchy.length - 1) {
                                                        a.push({
                                                            name: this.data.y.smps[l],
                                                            size: this.data.y.data[this.hierarchyVarIndex][l],
                                                            idx: l
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        this.data[b] = {};
                                        this.data[b]["data"] = {
                                            name: "Samples",
                                            children: []
                                        };
                                        for (var f = 0; f < this.smpIndices.length; f++) {
                                            var l = this.smpIndices[f];
                                            var a = this.data[b]["data"].children;
                                            a.push({
                                                name: this.data.y.smps[l],
                                                size: this.data.y.data[this.hierarchyVarIndex][l],
                                                idx: l
                                            })
                                        }
                                    }
                                };
                                this.initializeData = function(c, b, a) {
                                    this.data = c || this.getDataSet();
                                    this.isExample = c ? false : true;
                                    if (this.isExample) {
                                        this.$(this.target).style.display = "none"
                                    }
                                    this.nodesData = false;
                                    this.edgesData = false;
                                    this.featuresData = false;
                                    if (b) {
                                        delete this.meta.data
                                    }
                                    this.validGraphTypes = [];
                                    if (this.data && (this.data.y || this.data.venn || this.data.nodes || this.data.tracks || this.data.fx)) {
                                        this.FunctionData(this.data.fx ? true : false);
                                        if (this.data.venn) {
                                            if (this.graphType == "Venn") {
                                                this.summaryType = "venn"
                                            }
                                            this.validGraphTypes.push("Venn")
                                        }
                                        if (this.data.nodes) {
                                            if (this.graphType == "Network") {
                                                this.summaryType = "network"
                                            }
                                            this.validGraphTypes.push("Network")
                                        }
                                        if (this.data.tracks) {
                                            if (this.graphType == "Genome") {
                                                this.summaryType = "genome"
                                            }
                                            this.validGraphTypes.push("Genome")
                                        }
                                        if (this.data.y) {
                                            if (!this.data.y && !this.data.y.cor && !this.data.y.close) {
                                                alert("Dude! there is not a valid data structure");
                                                return
                                            } else {
                                                if (this.data.y.data) {
                                                    this.isRawData = true;
                                                    this.summaryType = this.summaryType && this.summaryType.match(/iqr|median|mean|cor|sum|max|min|count|gantt/) ? this.summaryType : "raw";
                                                    if (this.summaryType == "cor") {
                                                        this.graphType = "Correlation"
                                                    } else {
                                                        if (this.summaryType == "iqr") {
                                                            this.graphType = "Boxplot"
                                                        } else {
                                                            if (this.summaryType == "gantt") {
                                                                this.graphType = "Gantt"
                                                            } else {
                                                                if (this.data.y[this.summaryType]) {
                                                                    if (this.isSameObject(this.data.y[this.summaryType], this.data.y.data)) {
                                                                        this.isRawData = false
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    if (this.graphType == "Gantt") {
                                                        if (!this.ganttStart || this.getVariableIndices(this.ganttStart) < 0) {
                                                            this.ganttStart = this.data.y.vars[0]
                                                        }
                                                        if (!this.ganttEnd || this.getVariableIndices(this.ganttEnd) < 0) {
                                                            this.ganttEnd = this.data.y.vars[1] || this.data.y.vars[0]
                                                        }
                                                        this.setGanttData()
                                                    } else {
                                                        if (this.graphType == "Scatter2D" && this.scatterType == "manhattan") {
                                                            this.setManhattanData()
                                                        }
                                                    }
                                                } else {
                                                    this.isRawData = false;
                                                    if (this.data.y.iqr1 && this.data.y.qtl1 && this.data.y.median && this.data.y.qtl3 && this.data.y.iqr3) {
                                                        this.summaryType = "iqr"
                                                    } else {
                                                        if (this.data.y.median) {
                                                            this.summaryType = "median"
                                                        } else {
                                                            if (this.data.y.mean) {
                                                                this.summaryType = "mean"
                                                            } else {
                                                                if (this.data.y.cor) {
                                                                    this.summaryType = "cor"
                                                                } else {
                                                                    if (this.data.y.sum) {
                                                                        this.summaryType = "sum"
                                                                    } else {
                                                                        if (this.data.y.max) {
                                                                            this.summaryType = "max"
                                                                        } else {
                                                                            if (this.data.y.min) {
                                                                                this.summaryType = "min"
                                                                            } else {
                                                                                if (this.data.y.count) {
                                                                                    this.summaryType = "count"
                                                                                } else {
                                                                                    this.summaryType = false
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            this.validGraphTypes.push("Bar");
                                            this.validGraphTypes.push("Line");
                                            this.validGraphTypes.push("Area");
                                            this.validGraphTypes.push("AreaLine");
                                            this.validGraphTypes.push("BarLine");
                                            this.validGraphTypes.push("Boxplot");
                                            this.validGraphTypes.push("Dotplot");
                                            this.validGraphTypes.push("DotLine");
                                            this.validGraphTypes.push("Heatmap");
                                            this.validGraphTypes.push("Stacked");
                                            this.validGraphTypes.push("StackedLine");
                                            this.validGraphTypes.push("StackedPercent");
                                            this.validGraphTypes.push("StackedPercentLine");
                                            this.validGraphTypes.push("Pie");
                                            this.validGraphTypes.push("Correlation");
                                            this.validGraphTypes.push("Circular");
                                            if (this.data.y.smps || this.isDOE) {
                                                if (this.data.y.smps.length > 2 || this.isDOE) {
                                                    this.validGraphTypes.push("Scatter2D");
                                                    this.validGraphTypes.push("ScatterBubble2D");
                                                    this.validGraphTypes.push("Scatter3D")
                                                } else {
                                                    if (this.data.y.smps.length > 1 || this.isDOE) {
                                                        this.validGraphTypes.push("Scatter2D")
                                                    }
                                                }
                                            }
                                        }
                                        this.validGraphTypes.sort();
                                        this.initializeDataAttributes(false, false, a)
                                    }
                                }
                            };
                            CanvasXpress.prototype.initDataUtils = function() {
                                this.switchVarIdToAnnotation = function() {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var g = this.data;
                                    var b = this.meta.data;
                                    var f = function() {
                                        var d = 0;
                                        var a = "Var-Name-" + d;
                                        while (g.z.hasOwnProperty(a) && b.z[a]) {
                                            d++;
                                            a = "Var-Name-" + d
                                        }
                                        return a
                                    };
                                    var c = f();
                                    g.z[c] = [];
                                    for (var e = 0; e < g.y.vars.length; e++) {
                                        g.z[c].push("var" + (e + 1))
                                    }
                                    this.updateMetaData("z", c);
                                    this.switchVarAnnotationToId(c)
                                };
                                this.switchVarAnnotationToId = function(e) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var j = this.data;
                                    var c = this.meta.data;
                                    if (j.z.hasOwnProperty(e) && this.isUnique(j.z[e])) {
                                        var i = this.rebuildDataTableFilter();
                                        var b = this.groupingFactors;
                                        var g = this.cloneObject(j.y.vars);
                                        var h = this.cloneObject(j.z[e]);
                                        var f = e.match(/^--/) ? e.replace(/^--/, "") : "--" + e;
                                        j.z[f] = g;
                                        j.y.vars = h;
                                        delete(j.z[e]);
                                        this.resetMetaData();
                                        if (b && b.length > 0) {
                                            this.ungroupSamples(true);
                                            this.groupSamples(b)
                                        } else {
                                            this.draw({
                                                func: "switchVarAnnotationToId",
                                                par: [e]
                                            })
                                        }
                                        this.removeMenus();
                                        this.rebuildDataTableFilter(i, true)
                                    } else {
                                        alert("Annotation " + e + " is not unique!")
                                    }
                                };
                                this.switchAnnotationToVar = function(j, f) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var h = this.data;
                                    var c = this.meta.data;
                                    if (h.x.hasOwnProperty(j)) {
                                        var b = this.rebuildDataTableFilter();
                                        if (!c.modified) {
                                            c.modified = {}
                                        }
                                        if (!c.modified.z) {
                                            c.modified.z = {}
                                        }
                                        if (!c.modified.z[j]) {
                                            c.modified.z[j] = {}
                                        }
                                        var k = this.groupingFactors;
                                        this.isGroupedData = false;
                                        h.y.vars.push(j);
                                        if (this.isNumeric(h.x[j])) {
                                            h.y.data.push(h.x[j])
                                        } else {
                                            var n = [];
                                            for (var g = 0; g < h.y.smps.length; g++) {
                                                n.push(c.x[j].order[h.x[j][g]])
                                            }
                                            h.y.data.push(n);
                                            if (!c.modified.x) {
                                                c.modified.x = {}
                                            }
                                            if (!c.modified.x[j]) {
                                                c.modified.x[j] = this.cloneObject(c.x[j].levels)
                                            }
                                        }
                                        delete(h.x[j]);
                                        var l = this.getKeys(h.x);
                                        if (l.length < 1) {
                                            delete(h.x)
                                        }
                                        if (h.z) {
                                            var l = this.getKeys(h.z);
                                            for (var g = 0; g < l.length; g++) {
                                                h.z[l[g]].push(c.modified.z[j][l[g]] || "")
                                            }
                                        }
                                        var e = this.cloneObject(c.modified);
                                        this.updateMetaData("x", j, true);
                                        this.updateData(h, false, true);
                                        this.updateDOE(j, true);
                                        this.meta.data.modified = e;
                                        if (!f) {
                                            if (k && k.length > 0) {
                                                this.ungroupSamples(true);
                                                this.groupSamples(k)
                                            } else {
                                                this.draw({
                                                    func: "switchAnnotationToVar",
                                                    par: [j]
                                                })
                                            }
                                        }
                                        this.removeMenus();
                                        this.rebuildDataTableFilter(b, true)
                                    }
                                };
                                this.switchVarToAnnotation = function(l, g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var h = this.getVariableIndices(l);
                                    if (h >= 0) {
                                        var k = this.data;
                                        var c = this.meta.data;
                                        var a = this.rebuildDataTableFilter();
                                        if (!c.modified) {
                                            c.modified = {}
                                        }
                                        if (!c.modified.z) {
                                            c.modified.z = {}
                                        }
                                        if (!c.modified.z[l]) {
                                            c.modified.z[l] = {}
                                        }
                                        var n = this.groupingFactors;
                                        this.isGroupedData = false;
                                        if (!k.x) {
                                            k.x = {}
                                        }
                                        if (c.modified && c.modified.x && c.modified.x[l]) {
                                            var q = [];
                                            for (var f = 0; f < k.y.smps.length; f++) {
                                                q.push(c.modified.x[l][k.y.data[h][f]])
                                            }
                                            k.x[l] = q
                                        } else {
                                            k.x[l] = k.y.data[h]
                                        }
                                        k.y.vars.splice(h, 1);
                                        k.y.data.splice(h, 1);
                                        if (k.z) {
                                            var o = this.getKeys(k.z);
                                            for (var f = 0; f < o.length; f++) {
                                                var b = k.z[o[f]].splice(h, 1);
                                                c.modified.z[l][o[f]] = b[0]
                                            }
                                        }
                                        var e = this.cloneObject(c.modified);
                                        this.updateMetaData("x");
                                        this.updateData(k, false, true);
                                        this.updateDOE(l);
                                        this.meta.data.modified = e;
                                        if (!g) {
                                            if (n && n.length > 0) {
                                                this.ungroupSamples(true);
                                                this.groupSamples(n)
                                            } else {
                                                this.draw({
                                                    func: "switchVarToAnnotation",
                                                    par: [l]
                                                })
                                            }
                                        }
                                        this.removeMenus();
                                        this.rebuildDataTableFilter(a, true)
                                    }
                                };
                                this.switchSmpIdToAnnotation = function() {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var g = this.data;
                                    var b = this.meta.data;
                                    var f = function() {
                                        var d = 0;
                                        var a = "Smp-Name-" + d;
                                        while (g.x.hasOwnProperty(a) && b.x[a]) {
                                            d++;
                                            a = "Smp-Name-" + d
                                        }
                                        return a
                                    };
                                    var c = f();
                                    g.x[c] = [];
                                    for (var e = 0; e < g.y.smps.length; e++) {
                                        g.x[c].push("smp" + (e + 1))
                                    }
                                    this.updateMetaData("x", c);
                                    this.switchSmpAnnotationToId(c)
                                };
                                this.switchSmpAnnotationToId = function(e) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var j = this.data;
                                    var c = this.meta.data;
                                    if (j.x.hasOwnProperty(e) && this.isUnique(j.x[e])) {
                                        var h = this.rebuildDataTableFilter();
                                        var b = this.groupingFactors;
                                        var g = this.cloneObject(j.y.smps);
                                        var i = this.cloneObject(j.x[e]);
                                        var f = e.match(/^--/) ? e.replace(/^--/, "") : "--" + e;
                                        j.x[f] = g;
                                        j.y.smps = i;
                                        delete(j.x[e]);
                                        this.resetMetaData();
                                        if (b && b.length > 0) {
                                            this.ungroupSamples(true);
                                            this.groupSamples(b)
                                        } else {
                                            this.draw({
                                                func: "switchSmpAnnotationToId",
                                                par: [e]
                                            })
                                        }
                                        this.removeMenus();
                                        this.rebuildDataTableFilter(h, true)
                                    } else {
                                        alert("Annotation " + e + " is not unique!")
                                    }
                                };
                                this.switchAnnotationToSmp = function(l, g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var k = this.data;
                                    var c = this.meta.data;
                                    if (k.z.hasOwnProperty(l)) {
                                        var b = this.rebuildDataTableFilter();
                                        if (!c.modified) {
                                            c.modified = {}
                                        }
                                        if (!c.modified.x) {
                                            c.modified.x = {}
                                        }
                                        if (!c.modified.x[l]) {
                                            c.modified.x[l] = {}
                                        }
                                        var n = this.groupingFactors;
                                        this.isGroupedData = false;
                                        k.y.smps.push(l);
                                        if (this.isNumeric(k.z[l])) {
                                            for (var h = 0; h < k.y.vars.length; h++) {
                                                k.y.data[h].push(k.z[l][h])
                                            }
                                        } else {
                                            for (var h = 0; h < k.y.vars.length; h++) {
                                                k.y.data[h].push(c.z[l].order[k.z[l][h]])
                                            }
                                            if (!c.modified.z) {
                                                c.modified.z = {}
                                            }
                                            if (!c.modified.z[l]) {
                                                c.modified.z[l] = this.cloneObject(c.z[l].levels)
                                            }
                                        }
                                        delete(k.z[l]);
                                        var o = this.getKeys(k.z);
                                        if (o.length < 1) {
                                            delete(k.z)
                                        }
                                        if (k.x) {
                                            var o = this.getKeys(k.x);
                                            for (var f = 0; f < o.length; f++) {
                                                k.x[o[f]].push(c.modified.x[l][o[f]] || "")
                                            }
                                        }
                                        var e = this.cloneObject(c.modified);
                                        this.updateMetaData("z", l, true);
                                        this.updateData(k, false, true);
                                        this.resetAxes();
                                        this.meta.data.modified = e;
                                        if (!g) {
                                            if (n && n.length > 0) {
                                                this.ungroupSamples(true);
                                                this.groupSamples(n)
                                            } else {
                                                this.draw({
                                                    func: "switchAnnotationToSmp",
                                                    par: [l]
                                                })
                                            }
                                        }
                                        this.removeMenus();
                                        this.rebuildDataTableFilter(b, true)
                                    }
                                };
                                this.switchSmpToAnnotation = function(q, f) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var h = this.getSampleIndices(q, true);
                                    if (h >= 0) {
                                        var k = this.data;
                                        var c = this.meta.data;
                                        var a = this.rebuildDataTableFilter();
                                        if (!c.modified) {
                                            c.modified = {}
                                        }
                                        if (!c.modified.x) {
                                            c.modified.x = {}
                                        }
                                        if (!c.modified.x[q]) {
                                            c.modified.x[q] = {}
                                        }
                                        var n = this.groupingFactors;
                                        this.isGroupedData = false;
                                        if (!k.z) {
                                            k.z = {}
                                        }
                                        k.y.smps.splice(h, 1);
                                        k.z[q] = [];
                                        if (c.modified && c.modified.z && c.modified.z[q]) {
                                            for (var g = 0; g < k.y.vars.length; g++) {
                                                var l = k.y.data[g].splice(h, 1);
                                                k.z[q].push(c.modified.z[q][l])
                                            }
                                        } else {
                                            for (var g = 0; g < k.y.vars.length; g++) {
                                                k.z[q].push(k.y.data[g].splice(h, 1))
                                            }
                                        }
                                        if (k.x) {
                                            var o = this.getKeys(k.x);
                                            for (var g = 0; g < o.length; g++) {
                                                var b = k.x[o[g]].splice(h, 1);
                                                c.modified.x[q][o[g]] = b[0]
                                            }
                                        }
                                        var e = this.cloneObject(c.modified);
                                        this.updateMetaData("z");
                                        this.updateData(k, false, true);
                                        this.resetAxes();
                                        this.meta.data.modified = e;
                                        if (!f) {
                                            if (n && n.length > 0) {
                                                this.ungroupSamples(true);
                                                this.groupSamples(n)
                                            } else {
                                                this.draw({
                                                    func: "switchSmpToAnnotation",
                                                    par: [q]
                                                })
                                            }
                                        }
                                        this.removeMenus();
                                        this.rebuildDataTableFilter(a, true)
                                    }
                                };
                                this.switchNumericToString = function(g, e, f) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = e ? "x" : "z";
                                    var b = e ? "smps" : "vars";
                                    if (g && this.data[d] && this.data[d][g] && this.meta.data[d][g].type == "Numeric") {
                                        var c = this.rebuildDataTableFilter();
                                        for (var a = 0; a < this.data.y[b].length; a++) {
                                            this.data[d][g][a] = this.data[d][g][a] + "\x00"
                                        }
                                        if (e) {
                                            this.updateMetaData("x", g)
                                        } else {
                                            this.updateMetaData("z", g)
                                        }
                                        this.rebuildDataTableFilter(c, true)
                                    }
                                    this.removeMenus();
                                    if (!f) {
                                        this.draw({
                                            func: "switchNumericToString",
                                            par: [g, e]
                                        })
                                    }
                                };
                                this.switchStringToNumeric = function(g, e, f) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = e ? "x" : "z";
                                    var b = e ? "smps" : "vars";
                                    if (g && this.data[d] && this.data[d][g] && this.meta.data[d][g].type == "String") {
                                        var c = this.rebuildDataTableFilter();
                                        for (var a = 0; a < this.data.y[b].length; a++) {
                                            this.data[d][g][a] = this.data[d][g][a].replace("\x00", "")
                                        }
                                        if (e) {
                                            this.updateMetaData("x", g)
                                        } else {
                                            this.updateMetaData("z", g)
                                        }
                                        this.rebuildDataTableFilter(c, true)
                                    }
                                    this.removeMenus();
                                    if (!f) {
                                        this.draw({
                                            func: "switchStringToNumeric",
                                            par: [g, e]
                                        })
                                    }
                                };
                                this.getSegregationObject = function(m) {
                                    var e = {
                                        lay: {},
                                        idx: [],
                                        ids: {},
                                        nme: [],
                                        n: 0
                                    };
                                    if (this.isHistogramLayout()) {
                                        e.axes = []
                                    }
                                    var r = m == "x" ? "smps" : "vars";
                                    var n = m == "x" ? this.segregateSamplesBy[0] : this.segregateVariablesBy[0];
                                    var l = this.isHistogramLayout();
                                    var d = false;
                                    if (n == "variable") {
                                        m = "y";
                                        n = "vars"
                                    } else {
                                        if (n == "sample") {
                                            m = "y";
                                            n = "smps"
                                        }
                                    }
                                    var g = this.data.hasOwnProperty(m) && this.data[m].hasOwnProperty(n) ? this.data : false;
                                    if (l && !g && this.dataStndBy && this.dataStndBy.hasOwnProperty(m) && this.dataStndBy[m].hasOwnProperty(n)) {
                                        if (m == "z") {
                                            d = this.meta.data.z[n].levels;
                                            m = "y";
                                            n = "smps";
                                            r = "smps"
                                        }
                                        g = this.data.hasOwnProperty(m) && this.data[m].hasOwnProperty(n) ? this.data : false
                                    } else {
                                        if (l && this.colorBy && this.segregateSamplesBy.length && this.dataStndBy) {
                                            d = this.dataStndBy.y.smps
                                        }
                                    }
                                    if (g) {
                                        for (var k = 0; k < g[m][n].length; k++) {
                                            var p = g[m][n][k];
                                            if (!e.lay.hasOwnProperty(p)) {
                                                e.lay[p] = [];
                                                e.ids[p] = [];
                                                e.n++
                                            }
                                            e.lay[p].push(g.y[r][k]);
                                            e.ids[p].push(k)
                                        }
                                        for (var p in e.lay) {
                                            e.nme.push(p);
                                            e.idx.push(e.lay[p])
                                        }
                                        if (l) {
                                            if (this.segregateVariablesBy.length) {
                                                if (d) {
                                                    for (var k = 0; k < d.length; k++) {
                                                        var b = [];
                                                        for (var f = 0; f < e.nme.length; f++) {
                                                            if ((e.nme[f].match(":") && e.nme[f].match(d[k])) || !e.nme[f].match(":") && e.nme[f] == d[k]) {
                                                                b.push(e.nme[f])
                                                            }
                                                        }
                                                        if (!b.length) {
                                                            b = [this.dataStndBy.y.smps[k]]
                                                        }
                                                        e.axes.push({
                                                            xAxis: ["Bin"],
                                                            yAxis: b
                                                        })
                                                    }
                                                } else {
                                                    for (var k = 0; k < this.dataStndBy.y.smps.length; k++) {
                                                        var b = [];
                                                        for (var f = 0; f < e.nme.length; f++) {
                                                            if (e.nme[f].match(this.dataStndBy.y.smps[k])) {
                                                                b.push(e.nme[f])
                                                            }
                                                        }
                                                        if (!b.length) {
                                                            b = [this.dataStndBy.y.smps[k]]
                                                        }
                                                        e.axes.push({
                                                            xAxis: ["Bin"],
                                                            yAxis: b
                                                        })
                                                    }
                                                }
                                            } else {
                                                if (d) {
                                                    for (var k = 0; k < d.length; k++) {
                                                        var b = [];
                                                        for (var f = 0; f < e.nme.length; f++) {
                                                            if ((e.nme[f].match(":") && e.nme[f].match(d[k])) || !e.nme[f].match(":") && e.nme[f] == d[k]) {
                                                                b.push(e.nme[f])
                                                            }
                                                        }
                                                        if (!b.length) {
                                                            b = [this.dataStndBy.y.smps[k]]
                                                        }
                                                        e.axes.push({
                                                            xAxis: ["Bin"],
                                                            yAxis: b
                                                        })
                                                    }
                                                } else {
                                                    for (var k = 1; k < e.nme.length; k++) {
                                                        e.axes.push({
                                                            xAxis: ["Bin"],
                                                            yAxis: [e.nme[k]]
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                        return e
                                    } else {
                                        return false
                                    }
                                };
                                this.segregate = function(f, m, p, E) {
                                    if (!this.isSegregatable()) {
                                        return
                                    }
                                    var L = "segregate" + f + "By";
                                    var h = "desegregate" + f;
                                    var d = f == "Samples" ? "segregateVariablesBy" : "segregateSamplesBy";
                                    var y = f == "Samples" ? "x" : "z";
                                    var O = this[L];
                                    var b = this.cloneObject(this.grpIndices);
                                    var x = this.data.w ? this.cloneObject(this.data.w) : false;
                                    if (E) {
                                        this.modifyObjectArray(m, false, L, true, false);
                                        if (this[L].length == 0) {
                                            this[h](p);
                                            return
                                        }
                                    } else {
                                        if (this[L].length == 0) {
                                            if (!this.isArray(m)) {
                                                m = [m]
                                            }
                                            this[L] = m;
                                            if (!this.validateSegregation()) {
                                                this[L] = O;
                                                return
                                            }
                                        }
                                    }
                                    if (!this.isArray(this[L])) {
                                        this[L] = [this[L]]
                                    }
                                    if (this.treemapBy.length && this.segregateSamplesBy.length && this.segregateVariablesBy.length) {
                                        this.removeMenus();
                                        alert("Ooops. Operation not allowed!");
                                        this[L] = [];
                                        return
                                    } else {
                                        if ((m == "sample" || this.segregateSamplesBy.includes("sample")) && this.segregateSamplesBy.length + this.segregateVariablesBy.length > 1) {
                                            this.removeMenus();
                                            alert("Ooops. Operation not allowed!");
                                            if (m == "sample" || this.segregateSamplesBy.length > 1) {
                                                this.segregateSamplesBy.pop()
                                            } else {
                                                this.segregateVariablesBy.pop()
                                            }
                                            return
                                        }
                                    }
                                    if (this.isGroupedData) {
                                        this.groupingFactorsStdBy = this.groupingFactors;
                                        this.ungroupSamples(true, true)
                                    }
                                    this.resetLayout();
                                    if (this.isCreateHistogram && f == "Variables" && !(this.isCreateHistogram.factor == this[L][0] || this.isCreateHistogram.factor == this.colorBy || this.isCreateHistogram.factor == m)) {
                                        this.removeHistogram(true);
                                        this.createHistogram(this[L][0] || this.colorBy || m, true)
                                    }
                                    if (this[L].length == 1) {
                                        var K = this.getSegregationObject(y);
                                        if (this[d].length > 0) {
                                            this.segregateSamplesVariables(p, d == "segregateVariablesBy", {
                                                func: "segregate",
                                                par: [f, m, p, E]
                                            });
                                            p = true
                                        } else {
                                            this.data.l = {};
                                            if (f == "Samples") {
                                                this.data.l.smps = []
                                            } else {
                                                this.data.l.vars = []
                                            }
                                            this.data.l.ids = [];
                                            this.data.l.weight = [];
                                            this.data.l.type = [];
                                            this.data.l.name = [];
                                            if (this.groupingFactorsStdBy) {
                                                this.data.l.group = this.groupingFactorsStdBy
                                            }
                                            var I = 0;
                                            for (var A in K.lay) {
                                                if (f == "Samples") {
                                                    this.data.l.smps.push(K.lay[A])
                                                } else {
                                                    this.data.l.vars.push(K.lay[A])
                                                }
                                                this.data.l.ids.push(K.ids[A]);
                                                this.data.l.type.push(this.graphType);
                                                this.data.l.name.push(A);
                                                I++
                                            }
                                            this.layoutComb = this.graphType == "Circular" ? false : true;
                                            this.showAnimationTemp = this.showAnimation;
                                            this.showAnimation = false;
                                            var D = this.isHistogram ? K.axes.length : f == "Samples" ? this.data.l.smps.length : this.data.l.vars.length;
                                            var A = Math.ceil(Math.sqrt(D));
                                            var B = this.layoutType == "rows" ? D : this.layoutType == "cols" ? 1 : A * (A - 1) >= D ? A - 1 : A;
                                            var N = this.layoutType == "cols" ? D : this.layoutType == "rows" ? 1 : B * (A - 1) >= D ? A - 1 : A;
                                            this.layout = B + "X" + N;
                                            if (this.layoutTopologyCurrent) {
                                                if (Number(this.layoutTopologyCurrent[0]) * Number(this.layoutTopologyCurrent[1]) == D) {
                                                    this.layoutTopology = this.layoutTopologyCurrent[0] + "X" + this.layoutTopologyCurrent[1]
                                                }
                                            }
                                            for (var A in K.lay) {
                                                this.data.l.weight.push([this.layoutTopology ? 1 / this.layoutTopology.split(/X/i)[1] : 1 / N, this.layoutTopology ? 1 / this.layoutTopology.split(/X/i)[0] : 1 / B])
                                            }
                                            if (this.graphType.match(/Scatter2D/) && this.isCreateHistogram) {
                                                this.data.l.axes = K.axes
                                            }
                                            this.isValidLayout()
                                        }
                                    } else {
                                        var F = {};
                                        var z = {};
                                        var w = f == "Samples" ? this.getSampleLevelsByAnnotation(this.segregateSamplesBy[0]) : this.getVariableLevelsByAnnotation(this.segregateVariablesBy[0]);
                                        var M = f == "Samples" ? this.getSampleLevelsByAnnotation(this.segregateSamplesBy[1]) : this.getVariableLevelsByAnnotation(this.segregateVariablesBy[1]);
                                        var e = w;
                                        if (this.layoutType == "cols") {
                                            w = M;
                                            M = e
                                        }
                                        var u = 1 / w.length;
                                        var a = 1 / M.length;
                                        if (w.length && M.length) {
                                            for (var J = 0; J < w.length; J++) {
                                                F[w[J]] = {};
                                                z[w[J]] = {};
                                                for (var H = 0; H < M.length; H++) {
                                                    F[w[J]][M[H]] = [];
                                                    z[w[J]][M[H]] = [];
                                                    if (f == "Samples") {
                                                        for (var G = 0; G < this.data.y.smps.length; G++) {
                                                            if (this.data[y][this[L][this.layoutType == "cols" ? 1 : 0]][G] == w[J] && this.data[y][this[L][this.layoutType == "cols" ? 0 : 1]][G] == M[H]) {
                                                                F[w[J]][M[H]].push(this.data.y.smps[G]);
                                                                z[w[J]][M[H]].push(G)
                                                            }
                                                        }
                                                    } else {
                                                        for (var G = 0; G < this.data.y.vars.length; G++) {
                                                            if (this.data[y][this[L][this.layoutType == "cols" ? 1 : 0]][G] == w[J] && this.data[y][this[L][this.layoutType == "cols" ? 0 : 1]][G] == M[H]) {
                                                                F[w[J]][M[H]].push(this.data.y.vars[G]);
                                                                z[w[J]][M[H]].push(G)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            this.data.l = {};
                                            if (f == "Samples") {
                                                this.data.l.smps = []
                                            } else {
                                                this.data.l.vars = []
                                            }
                                            this.data.l.ids = [];
                                            this.data.l.weight = [];
                                            this.data.l.type = [];
                                            this.data.l.name = [];
                                            if (this.groupingFactorsStdBy) {
                                                this.data.l.group = this.groupingFactorsStdBy
                                            }
                                            for (var J = 0; J < w.length; J++) {
                                                for (var H = 0; H < M.length; H++) {
                                                    if (this.layoutRemoveEmpty && this.layoutType == "wrap") {
                                                        if (F[w[J]][M[H]].length < 1) {
                                                            continue
                                                        }
                                                    }
                                                    this.data.l.type.push(this.graphType);
                                                    this.data.l.name.push([w[J], M[H]]);
                                                    if (f == "Samples") {
                                                        this.data.l.smps.push(F[w[J]][M[H]]);
                                                        this.data.l.ids.push(z[w[J]][M[H]])
                                                    } else {
                                                        this.data.l.vars.push(F[w[J]][M[H]]);
                                                        this.data.l.ids.push(z[w[J]][M[H]])
                                                    }
                                                }
                                            }
                                            var o = 0;
                                            for (var H = 0; H < M.length; H++) {
                                                var C = 0;
                                                for (var J = 0; J < w.length; J++) {
                                                    if (F[w[J]][M[H]].length > 0 && this.layoutType == "wrap") {
                                                        C++
                                                    }
                                                }
                                                o = Math.max(o, C)
                                            }
                                            var g = 0;
                                            for (var J = 0; J < w.length; J++) {
                                                var q = 0;
                                                for (var H = 0; H < M.length; H++) {
                                                    if (F[w[J]][M[H]].length > 0 && this.layoutType == "wrap") {
                                                        q++
                                                    }
                                                }
                                                g = Math.max(g, q)
                                            }
                                            var D = this.data.l.name.length;
                                            if (this.layoutRemoveEmpty && this.layoutType == "wrap") {
                                                o = g * (o - 1) > D ? o - 1 : o;
                                                g = o * (g - 1) > D ? g - 1 : g
                                            }
                                            if (w.length * M.length > D) {
                                                if (w.length == D) {
                                                    o = D;
                                                    g = 1
                                                } else {
                                                    if (M.length == D) {
                                                        o = 1;
                                                        g = D
                                                    } else {
                                                        g = Math.ceil(Math.sqrt(D));
                                                        o = g * (g - 1) >= D ? g - 1 : g
                                                    }
                                                }
                                            } else {
                                                o = w.length;
                                                g = M.length
                                            }
                                            u = 1 / o;
                                            a = 1 / g;
                                            if (this.layoutTopologyCurrent) {
                                                if (Number(this.layoutTopologyCurrent[0]) * Number(this.layoutTopologyCurrent[1]) == D) {
                                                    this.layoutTopology = this.layoutTopologyCurrent[0] + "X" + this.layoutTopologyCurrent[1]
                                                }
                                            }
                                            for (var J = 0; J < D; J++) {
                                                this.data.l.weight.push([this.layoutTopology ? 1 / this.layoutTopology.split(/X/i)[1] : a, this.layoutTopology ? 1 / this.layoutTopology.split(/X/i)[0] : u])
                                            }
                                            this.layoutComb = this.graphType == "Circular" ? false : true;
                                            this.showAnimationTemp = this.showAnimation;
                                            this.showAnimation = false;
                                            this.layout = this.layoutRemoveEmpty && this.layoutType == "wrap" ? o + "X" + g : w.length + "X" + M.length
                                        } else {
                                            alert("Incompatible Segregation");
                                            if (f == "Samples") {
                                                this.segregateSamplesBy.pop()
                                            } else {
                                                this.segregateVariablesBy.pop()
                                            }
                                            this.removeMenus()
                                        }
                                        this.isValidLayout()
                                    }
                                    this.setColorScheme();
                                    this.resetCorrelation();
                                    this.grpIndices = b;
                                    if (x) {
                                        this.data.w = x
                                    }
                                    if (!p) {
                                        this.draw({
                                            func: "segregate",
                                            par: [f, m, p, E]
                                        })
                                    }
                                };
                                this.segregateVariables = function(b, c, a) {
                                    this.segregate("Variables", b, c, a);
                                    return
                                };
                                this.segregateSamples = function(c, b, a) {
                                    this.segregate("Samples", c, b, a);
                                    return
                                };
                                this.segregateSamplesVariables = function(d, g, o) {
                                    if (!this.isSegregatable()) {
                                        return
                                    }
                                    var b = this.getSegregationObject("x");
                                    var a = this.getSegregationObject("z");
                                    var m = b.idx;
                                    var l = a.idx;
                                    var k = b.nme;
                                    var n = a.nme;
                                    if (this.isGroupedData) {
                                        this.groupingFactorsStdBy = this.groupingFactors;
                                        this.ungroupSamples(true, true)
                                    }
                                    delete(this.data.l);
                                    this.data.l = {};
                                    this.data.l.smps = m;
                                    this.data.l.vars = l;
                                    this.data.l.weight = [];
                                    this.data.l.type = [];
                                    this.data.l.name = [];
                                    if (this.groupingFactorsStdBy) {
                                        this.data.l.group = this.groupingFactorsStdBy
                                    }
                                    if (this.layoutTopologyCurrent) {
                                        if (Number(this.layoutTopologyCurrent[0]) * Number(this.layoutTopologyCurrent[1]) == l.length * m.length) {
                                            this.layoutTopology = this.layoutTopologyCurrent[0] + "X" + this.layoutTopologyCurrent[1]
                                        }
                                    }
                                    var h = this.layoutTopology ? 1 / this.layoutTopology.split(/X/i)[0] : 1 / m.length;
                                    var f = this.layoutTopology ? 1 / this.layoutTopology.split(/X/i)[1] : 1 / l.length;
                                    if ((this.layoutType == "cols" && g) || (this.layoutType == "rows" && !g)) {
                                        for (var e = 0; e < m.length; e++) {
                                            for (var c = 0; c < l.length; c++) {
                                                this.data.l.weight.push([f, h]);
                                                this.data.l.type.push(this.graphType);
                                                this.data.l.name.push([k[e], n[c]])
                                            }
                                        }
                                        this.layout = m.length + "X" + l.length
                                    } else {
                                        for (var e = 0; e < l.length; e++) {
                                            for (var c = 0; c < m.length; c++) {
                                                this.data.l.weight.push([h, f]);
                                                this.data.l.type.push(this.graphType);
                                                this.data.l.name.push([n[e], k[c]])
                                            }
                                        }
                                        this.layout = l.length + "X" + m.length
                                    }
                                    this.layoutComb = true;
                                    this.layoutTypeVariablesFirst = g;
                                    this.isValidLayout();
                                    this.resetCorrelation();
                                    if (!d) {
                                        this.draw({
                                            func: o.func,
                                            par: o.par
                                        })
                                    } else {
                                        if (this.groupingFactorsStdBy && this.groupingFactorsStdBy.length) {
                                            this.groupSamples(this.groupingFactorsStdBy, false, false, false, true)
                                        }
                                    }
                                };
                                this.segregateVariablesAndOrSamples = function(a, c, b) {
                                    if (c && c.length) {
                                        this.segregate("Samples", c, b)
                                    }
                                    if (a && a.length) {
                                        this.segregate("Variables", a, b)
                                    }
                                };
                                this.desegregate = function(d, e) {
                                    if (!this.isSegregatable()) {
                                        return
                                    }
                                    this.showAnimation = this.showAnimationTemp;
                                    this.resetLayout();
                                    var b = d == "Samples" ? "segregateSamplesBy" : "segregateVariablesBy";
                                    var a = d == "Samples" ? "segregateSamples" : "segregateVariables";
                                    if (this[b].length > 0) {
                                        this[a](this[b], e)
                                    } else {
                                        this.isValidLayout()
                                    }
                                    if (this.groupingFactorsStdBy) {
                                        this.groupSamples(this.groupingFactorsStdBy, false, false, true, true);
                                        this.groupingFactorsStdBy = false
                                    }
                                    if (this.isHistogram && !this.layoutValid) {
                                        this.yAxis = this.cloneObject(this.data.y.smps);
                                        this.yAxis.shift();
                                        this.yAxisIndices = this.getSampleIndices(this.yAxis);
                                        var c = this.isCreateHistogram.isAnnt;
                                        this.removeHistogram(true);
                                        this[b] = [];
                                        this.createHistogram(c, true)
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            this.meta.data.d.a = {};
                                            this.meta.data.d.s = {};
                                            this.resetAxes()
                                        }
                                    }
                                    this.resetCorrelation();
                                    if (!e) {
                                        delete(this.layoutConfig);
                                        this.draw({
                                            func: "desegregate",
                                            par: [d, e],
                                            prop: {
                                                segregateSamplesBy: this.segregateSamplesBy,
                                                segregateVariablesBy: this.segregateVariablesBy
                                            }
                                        })
                                    }
                                };
                                this.desegregateVariables = function(a) {
                                    if (!this.isSegregatable()) {
                                        return
                                    }
                                    this.desegregate("Variables", a)
                                };
                                this.desegregateSamples = function(a) {
                                    if (!this.isSegregatable()) {
                                        return
                                    }
                                    this.desegregate("Samples", a)
                                };
                                this.desegregateVariablesSamples = function(a) {
                                    if (!this.isSegregatable()) {
                                        return
                                    }
                                    if (this.segregateVariablesBy.length) {
                                        this.segregateVariablesBy = [];
                                        this.desegregate("Variables", a)
                                    }
                                    if (this.segregateSamplesBy.length) {
                                        this.segregateSamplesBy = [];
                                        this.desegregate("Samples", a)
                                    }
                                };
                                this.setScatterPlotMatrix = function() {
                                    if (this.graphType.match(/Scatter/)) {
                                        var k = this;
                                        var h = function(d) {
                                            var u = {
                                                y: {
                                                    vars: [],
                                                    smps: [],
                                                    data: []
                                                }
                                            };
                                            var j = k.data.z && k.data.z.hasOwnProperty(k.scatterPlotMatrix) ? k.scatterPlotMatrix : false;
                                            var n = j ? k.meta.data.z[k.scatterPlotMatrix].order : false;
                                            var r = j ? k.meta.data.z[k.scatterPlotMatrix].levels.length : 1;
                                            var c = k.getDataForSmpGrpAtIndex(d);
                                            for (var s = 0; s < c.length; s++) {
                                                u.y.data.push([j ? n[k.data.z[j][s]] : 0, c[s]]);
                                                u.y.vars.push("Smp" + (s + 1))
                                            }
                                            u.y.smps = [j || "Global", k.data.y.smps[d]];
                                            if (j) {
                                                u.z = {};
                                                u.z[j] = k.data.z[j]
                                            }
                                            return {
                                                data: u,
                                                params: {
                                                    xAxis: [j || "Global"],
                                                    yAxis: [k.data.y.smps[d]],
                                                    setMinX: -0.5,
                                                    setMaxX: r - 0.5,
                                                    scatterType: "boxplot",
                                                    graphOrientation: "vertical",
                                                    scatterPlotMatrix: j || true
                                                }
                                            }
                                        };
                                        var f, b, o, q, m;
                                        var a = this.scatterPlotMatrixType.match(/first/) ? this.data.y.smps.length - 1 : this.data.y.smps.length;
                                        var p = Math.ceil(Math.sqrt(a));
                                        this.data.l = {};
                                        this.data.l.smps = [];
                                        this.data.l.weight = [];
                                        this.data.l.type = [];
                                        this.data.l.stype = [];
                                        this.data.l.data = [];
                                        this.data.l.group = this.data.z && this.data.z.hasOwnProperty(this.scatterPlotMatrix) ? this.scatterPlotMatrix : false;
                                        this.data.l.params = [];
                                        this.xAxisTemp = this.xAxisTemp || this.xAxis;
                                        this.xAxis = [];
                                        this.yAxisTemp = this.yAxisTemp || this.yAxis;
                                        this.yAxis = [];
                                        this.zAxisTemp = this.zAxisTemp || this.zAxis;
                                        this.zAxis = [];
                                        if (!this.scatterPlotMatrixType.match(/first/)) {
                                            if (this.scatterPlotMatrixType.match(/all/)) {
                                                a++
                                            }
                                            q = a;
                                            o = a;
                                            f = 1 / o;
                                            b = 1 / q;
                                            for (var g = 0; g < a; g++) {
                                                for (var e = 0; e < a; e++) {
                                                    this.data.l.weight.push([f, b]);
                                                    this.data.l.type.push(this.scatterPlotMatrixType.match(/all/) && g == a - 1 && e != a - 1 ? "Boxplot" : this.graphType);
                                                    this.data.l.data.push(false);
                                                    this.data.l.params.push(false);
                                                    if (g == e) {
                                                        if (this.scatterPlotMatrixType.match(/all/) && g == a - 1) {
                                                            this.data.l.smps.push({});
                                                            this.data.l.stype.push(false)
                                                        } else {
                                                            if (this.scatterPlotMatrixType.match(/correlationHistogram/)) {
                                                                this.data.l.smps.push({
                                                                    xAxis: [this.data.y.smps[e]],
                                                                    yAxis: [this.data.y.smps[g]]
                                                                });
                                                                this.data.l.stype.push("Histogram")
                                                            } else {
                                                                if (this.scatterPlotMatrixType.match(/correlationDensity|all/)) {
                                                                    this.data.l.smps.push({
                                                                        xAxis: [this.data.y.smps[e]],
                                                                        yAxis: [this.data.y.smps[g]]
                                                                    });
                                                                    this.data.l.stype.push("Density")
                                                                } else {
                                                                    this.data.l.smps.push({});
                                                                    this.data.l.stype.push(false)
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (this.scatterPlotMatrixType.match(/all/) && g == a - 1) {
                                                            this.data.l.smps.push({
                                                                xAxis: [this.data.y.smps[e]],
                                                                yAxis: [this.data.y.smps[g]]
                                                            });
                                                            this.data.l.stype.push("Histogram")
                                                        } else {
                                                            if (this.scatterPlotMatrixType.match(/all/) && e == a - 1) {
                                                                this.data.l.smps.push(this.data.y.smps[g]);
                                                                this.data.l.stype.push("Boxplot");
                                                                var l = h(g);
                                                                this.data.l.data[this.data.l.data.length - 1] = l.data;
                                                                this.data.l.params[this.data.l.params.length - 1] = l.params
                                                            } else {
                                                                if (this.scatterPlotMatrixType.match(/upper/)) {
                                                                    this.data.l.stype.push(false);
                                                                    if (e > g) {
                                                                        this.data.l.smps.push({
                                                                            xAxis: [this.data.y.smps[e]],
                                                                            yAxis: [this.data.y.smps[g]]
                                                                        })
                                                                    } else {
                                                                        this.data.l.smps.push({})
                                                                    }
                                                                } else {
                                                                    if (this.scatterPlotMatrixType.match(/lower/)) {
                                                                        this.data.l.stype.push(false);
                                                                        if (g > e) {
                                                                            this.data.l.smps.push({
                                                                                xAxis: [this.data.y.smps[e]],
                                                                                yAxis: [this.data.y.smps[g]]
                                                                            })
                                                                        } else {
                                                                            this.data.l.smps.push({})
                                                                        }
                                                                    } else {
                                                                        if (this.scatterPlotMatrixType.match(/both/)) {
                                                                            this.data.l.stype.push(false);
                                                                            if (g != e) {
                                                                                this.data.l.smps.push({
                                                                                    xAxis: [this.data.y.smps[e]],
                                                                                    yAxis: [this.data.y.smps[g]]
                                                                                })
                                                                            } else {
                                                                                this.data.l.smps.push({})
                                                                            }
                                                                        } else {
                                                                            if (e > g) {
                                                                                this.data.l.stype.push(false);
                                                                                this.data.l.smps.push({})
                                                                            } else {
                                                                                this.data.l.stype.push(false);
                                                                                this.data.l.smps.push({
                                                                                    xAxis: [this.data.y.smps[e]],
                                                                                    yAxis: [this.data.y.smps[g]]
                                                                                })
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            q = p * (p - 1) >= a ? p - 1 : p;
                                            o = p;
                                            f = 1 / o;
                                            b = 1 / q;
                                            m = 1;
                                            for (var g = 0; g < q; g++) {
                                                for (var e = 0; e < o; e++) {
                                                    this.data.l.weight.push([f, b]);
                                                    this.data.l.type.push(this.graphType);
                                                    if (this.data.y.smps[m]) {
                                                        this.data.l.smps.push({
                                                            xAxis: [this.data.y.smps[0]],
                                                            yAxis: [this.data.y.smps[m]]
                                                        })
                                                    } else {
                                                        this.data.l.smps.push({});
                                                        break
                                                    }
                                                    m++
                                                }
                                            }
                                        }
                                        this.layout = q + "X" + o;
                                        this.layoutComb = true;
                                        this.showAnimationTemp = this.showAnimation;
                                        this.showAnimation = false;
                                        this.isValidLayout()
                                    }
                                };
                                this.unsetScatterPlotMatrix = function() {
                                    if (this.graphType.match(/Scatter/)) {
                                        if (this.xAxisTemp && this.xAxisTemp.length > 0) {
                                            this.xAxis = this.xAxisTemp;
                                            this.xAxisTmp = []
                                        }
                                        if (this.yAxisTemp && this.yAxisTemp.length > 0) {
                                            this.yAxis = this.yAxisTemp;
                                            this.yAxisTmp = []
                                        }
                                        if (this.zAxisTemp && this.zAxisTemp.length > 0) {
                                            this.zAxis = this.zAxisTemp;
                                            this.zAxisTmp = []
                                        }
                                        if (!this.xAxis || !this.yAxis) {
                                            this.xAxis = [];
                                            this.yAxis = [];
                                            this.xAxisIndices = [];
                                            this.yAxisIndices = [];
                                            this.xAxis = [this.data.y.smps[0]];
                                            for (var a = 1; a < this.data.y.smps.length; a++) {
                                                this.yAxis.push(this.data.y.smps[a])
                                            }
                                            this.xAxisIndices = this.getSampleIndices(this.xAxis);
                                            this.yAxisIndices = this.getSampleIndices(this.yAxis);
                                            this.initializeAxis()
                                        }
                                        this.scatterPlotMatrix = false;
                                        if (this.showAnimationTemp) {
                                            this.showAnimation = this.showAnimationTemp
                                        }
                                        this.resetLayout();
                                        this.isValidLayout()
                                    }
                                };
                                this.setMultiplePies = function() {
                                    if (this.graphType.match(/Pie/)) {
                                        var f, h;
                                        var g = this.xAxis.length;
                                        if (this.layout) {
                                            var b = this.layout.split(/X/i);
                                            f = parseInt(b[0]);
                                            h = parseInt(b[1]);
                                            if (f * h < g) {
                                                f = Math.ceil(Math.sqrt(g));
                                                h = Math.floor(Math.sqrt(g));
                                                this.layout = f + "X" + h
                                            }
                                        } else {
                                            f = Math.ceil(Math.sqrt(g));
                                            h = Math.floor(Math.sqrt(g));
                                            this.layout = f + "X" + h
                                        }
                                        var a = 1 / f;
                                        var e = 1 / h;
                                        delete(this.layoutParams);
                                        delete(this.data.l);
                                        this.data.l = {};
                                        this.data.l.smps = [];
                                        this.data.l.weight = [];
                                        this.data.l.type = [];
                                        for (var d = 0; d < g; d++) {
                                            this.data.l.smps.push([this.xAxis[d]]);
                                            this.data.l.weight.push([e, a]);
                                            this.data.l.type.push(this.graphType)
                                        }
                                        this.layoutComb = true;
                                        this.showAnimationTemp = this.showAnimation;
                                        this.showAnimation = false;
                                        this.isValidLayout()
                                    }
                                };
                                this.createPie = function(j) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = this.groupingFactors && this.groupingFactors.length > 0 ? this.groupingFactors : false;
                                    var b = {
                                        data: {},
                                        smps: {}
                                    };
                                    var g = {
                                        y: {
                                            data: [],
                                            vars: [],
                                            smps: [],
                                            pie: []
                                        }
                                    };
                                    if (!CanvasXpress.cacheImagesReady) {
                                        setTimeout(function() {
                                            that.createPie(j)
                                        }, 200)
                                    } else {
                                        if (d) {
                                            this.ungroupSamples(true)
                                        }
                                        var a, f;
                                        if (this.isDOE) {
                                            a = this.dataStndBy.l.doe;
                                            f = this.isDOE > 1 ? this.dataStndBy.z[j] : this.dataStndBy.x[j]
                                        } else {
                                            a = this.smpIndices;
                                            f = this.data.x[j]
                                        }
                                        for (var e = 0; e < a.length; e++) {
                                            var h = f[a[e]];
                                            if (!b.data[h]) {
                                                b.data[h] = 0;
                                                b.smps[h] = []
                                            }
                                            b.data[h]++;
                                            b.smps[h].push(a[e])
                                        }
                                        g.y.smps.push(j);
                                        for (var e in b.data) {
                                            g.y.vars.push(e);
                                            g.y.data.push([b.data[e]]);
                                            g.y.pie.push(b.smps[e])
                                        }
                                        this.xAxis = false;
                                        this.yAxis = false;
                                        if (this.isDOE) {
                                            this.graphType = "Pie";
                                            this.initializeData(g)
                                        } else {
                                            this.dataStndBy = this.data;
                                            this.configStndBy = this.getConfig();
                                            this.configStndBy.isPie = false;
                                            this.data = {};
                                            this.graphType = "Pie";
                                            this.isPie = true;
                                            this.isPieGroup = d;
                                            this.initializeData(g);
                                            this.removeMenus();
                                            this.draw({
                                                func: "createPie",
                                                par: [j]
                                            })
                                        }
                                    }
                                };
                                this.removePie = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = this.isPieGroup;
                                    this.isPie = false;
                                    this.isPieGroup = false;
                                    this.removeMenus();
                                    this.switchData(false, true);
                                    if (a) {
                                        this.groupSamples(a, false, false, false, b)
                                    } else {
                                        if (!b) {
                                            this.draw({
                                                func: "removePie"
                                            })
                                        }
                                    }
                                };
                                this.createContour = function() {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.isContour = true;
                                    var I = this.getD3Contour();
                                    var K = [];
                                    var D, C, B;
                                    if (this.graphType.match(/Scatter/)) {
                                        var k = this.getAxisDataBySample(this.xAxisIndices);
                                        var h = this.getAxisDataBySample(this.yAxisIndices);
                                        var g = this.getAxisDataBySample(this.zAxisIndices);
                                        D = this.loess([k, g, h], false, [this.xAxisIndices[0], this.yAxisIndices[0], this.zAxisIndices[0]]);
                                        C = D.x;
                                        B = D.y;
                                        for (var F = D.z.length - 1; F >= 0; F--) {
                                            for (var E = D.z[F].length - 1; E >= 0; E--) {
                                                K.push(D.z[F][E])
                                            }
                                        }
                                    } else {
                                        C = this.varIndices;
                                        B = this.isGroupedData ? this.grpIndices : this.smpIndices;
                                        this.setRangeData();
                                        for (var F = 0; F < B.length; F++) {
                                            for (var E = 0; E < C.length; E++) {
                                                K.push(this.getDataAtPos(C[E], B[F]) - this.minData)
                                            }
                                        }
                                    }
                                    var u = this.range(K);
                                    var J = this[this.histogramSizeEstimator](K);
                                    var p = Math.ceil(u[1] / J);
                                    var A = I().size([C.length, B.length]).thresholds(this.seq(this.contourStartLevel || 0, this.contourEndLevel || u[1], this.contourLevelStep || p))(K);
                                    if (this.graphType.match(/Scatter/)) {
                                        var u = [];
                                        var H = this.xAxisAbsMax - this.xAxisAbsMin;
                                        var G = this.yAxisAbsMax - this.yAxisAbsMin;
                                        var k = (this.xAxisAbsMax - this.xAxisAbsMin) / (C.length - 1);
                                        var h = (this.yAxisAbsMax - this.yAxisAbsMin) / (B.length - 1);
                                        for (var F = 0; F < A.length; F++) {
                                            for (var o = 0; o < A[F].coordinates.length; o++) {
                                                for (var w = 0; w < A[F].coordinates[o].length; w++) {
                                                    for (var f = 0; f < A[F].coordinates[o][w].length; f++) {
                                                        A[F].coordinates[o][w][f][0] = C[C.length - 1] - Math.max(Math.min((A[F].coordinates[o][w][f][0] - 0.5) * k, H), 0);
                                                        A[F].coordinates[o][w][f][1] = B[B.length - 1] - Math.max(Math.min((A[F].coordinates[o][w][f][1] - 0.5) * h, G), 0)
                                                    }
                                                }
                                            }
                                            if (A[F].value >= this.zAxisAbsMin && A[F].value <= this.zAxisAbsMax) {
                                                u.push(A[F])
                                            }
                                        }
                                        A = u
                                    }
                                    this.data.y.contour = {};
                                    this.data.y.contour.data = A;
                                    this.data.y.contour.loess = D;
                                    this.data.y.contour.x = C;
                                    this.data.y.contour.y = B;
                                    if (!this.graphType.match(/Scatter/)) {
                                        this.graphType = "Heatmap"
                                    }
                                    this.draw({
                                        func: "createContour"
                                    })
                                };
                                this.removeContour = function() {
                                    if (this.data.y.contour) {
                                        delete this.data.y.contour;
                                        this.isContour = false;
                                        this.draw({
                                            func: "removeContour"
                                        })
                                    }
                                };
                                this.createHierarchy = function(e, j) {
                                    var f = this;
                                    var m = this.meta.data.x;
                                    var h = this.colorBy && m && m.hasOwnProperty(this.colorBy);
                                    var c = e && m && m.hasOwnProperty(e[0]);
                                    var g = h ? this.getCustomColorScheme(m[this.colorBy].colors.length) : c ? this.getCustomColorScheme(m[e[0]].colors.length) : this.colors;
                                    var a = h ? m[this.colorBy].order : c ? m[e[0]].order : false;
                                    if (h) {
                                        m[this.colorBy].colors = g
                                    }
                                    if (!j) {
                                        var d = this.hierarchyVar ? this.getVariableIndices(this.hierarchyVar) : 0;
                                        this.hierarchyVarIndex = d >= 0 ? d : 0;
                                        j = this.hierarchyVarIndex
                                    }
                                    var l = function(i, o) {
                                        if (a) {
                                            return a.hasOwnProperty(i) ? g[a[i]] : o ? o : f.missingDataColor
                                        } else {
                                            return o || f.missingDataColor
                                        }
                                    };
                                    var k = function(w, z, r) {
                                        if (w.length > 0) {
                                            if (e && z + 1 < e.length) {
                                                z++;
                                                var y = f.getSampleLevelsByAnnotation(e[z], w);
                                                var u = [];
                                                var B = 0;
                                                for (var s = 0; s < y.length; s++) {
                                                    var x = l(y[s], r);
                                                    var A = f.getSamplesByAnnotationLevel(e[z], y[s], w);
                                                    var p = k(A, z, x);
                                                    B += p[1];
                                                    u.push({
                                                        name: y[s],
                                                        idx: A,
                                                        children: p[0],
                                                        value: p[1],
                                                        depth: z,
                                                        color: x,
                                                        tooltip: "<b>" + y[s] + "</b><br>" + f.formatNumber(p[1]) + " (" + f.formatNumber(p[1] * 100 / n) + "%)"
                                                    })
                                                }
                                            } else {
                                                var u = [];
                                                var B = 0;
                                                for (var s = 0; s < w.length; s++) {
                                                    var q = f.getDataAtPos(j, w[s]);
                                                    B += q;
                                                    u.push({
                                                        name: f.data.y.smps[w[s]],
                                                        idx: [w[s]],
                                                        value: q,
                                                        depth: z + 1,
                                                        color: g[w[s] % g.length],
                                                        tooltip: "<b>" + f.data.y.smps[w[s]] + "</b><br>" + f.formatNumber(q) + " (" + f.formatNumber(q * 100 / n) + "%)"
                                                    })
                                                }
                                            }
                                            return [u, B]
                                        }
                                    };
                                    var n = this.sum(this.data.y.data[j], true);
                                    var b = k(this.smpIndices, -1);
                                    return [{
                                        name: "root",
                                        children: b[0],
                                        value: b[1],
                                        depth: -1,
                                        color: this.missingDataColor
                                    }]
                                };
                                this.createDOE = function(n, d, x) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var C = function(c, G) {
                                        var I = [];
                                        for (var q = 0; q < a.length; q++) {
                                            for (var g = 0; g < a[q].length; g++) {
                                                if (a[q][g] == null) {
                                                    var l = false;
                                                    for (var r = q; r < q + G[0]; r++) {
                                                        for (var H = g; H < g + G[1]; H++) {
                                                            if (a[r][H] != null || H >= F) {
                                                                l = true;
                                                                break
                                                            }
                                                        }
                                                    }
                                                    if (!l) {
                                                        I = [q, g];
                                                        for (var r = q; r < q + G[0]; r++) {
                                                            for (var H = g; H < g + G[1]; H++) {
                                                                a[r][H] = c
                                                            }
                                                        }
                                                        return I
                                                    }
                                                }
                                            }
                                        }
                                        return [0, 0]
                                    };
                                    var z = this.isHistogram ? this.isCreateHistogram : this.data.l && this.data.l.histogram ? this.data.l.histogram : false;
                                    if (this.data.l && this.data.l.histogram) {} else {
                                        if (this.isHistogram) {
                                            this.removeHistogram(true)
                                        }
                                    }
                                    var k, E, f, o, D;
                                    var b = this.groupingFactors && this.groupingFactors.length > 0 ? this.groupingFactors : false;
                                    var h = this.plotByVariable;
                                    var e = this.initialGraphType || this.graphType;
                                    if (b) {
                                        this.ungroupSamples(true, false, true)
                                    } else {
                                        if (this.configStndBy && this.configStndBy.groupingFactors) {
                                            b = this.configStndBy.groupingFactors
                                        }
                                    }
                                    this.resetFilters();
                                    this.desegregateVariablesSamples(true);
                                    if (e.match(/Scatter|Map/i)) {
                                        this.isDOE = 2;
                                        k = this.varIndices;
                                        E = this.data.z;
                                        f = this.meta.data.z
                                    } else {
                                        if (this.data.x) {
                                            this.isDOE = 1;
                                            k = this.smpIndices;
                                            E = this.data.x;
                                            f = this.meta.data.x
                                        }
                                    }
                                    var u = Number(this.layout.split("X")[0]);
                                    var F = Number(this.layout.split("X")[1]);
                                    var w = u * F;
                                    var p = this.getKeys(E);
                                    if (this.includeDOE.length < 1) {
                                        for (var B = 0; B < p.length; B++) {
                                            if (B >= this.maxDOENumber) {
                                                break
                                            }
                                            this.includeDOE.push(p[B])
                                        }
                                    }
                                    if (w == 1 || d) {
                                        u = Math.ceil(Math.sqrt(this.includeDOE.length + 1));
                                        F = u * (u - 1) >= (this.includeDOE.length + 1) ? u - 1 : u;
                                        this.layout = u + "X" + F
                                    }
                                    var a = [];
                                    for (var B = 0; B < u * F; B++) {
                                        a[B] = [];
                                        for (var A = 0; A < F; A++) {
                                            a[B][A] = null
                                        }
                                    }
                                    this.layoutTopology = this.layout;
                                    delete(this.layoutParams);
                                    delete(this.data.l);
                                    this.data.l = {
                                        histogram: z
                                    };
                                    o = n && n[0] && n[0].size ? n[0].size.split("X") : this.layoutConfig && this.layoutConfig[0] && this.layoutConfig[0].size ? this.layoutConfig[0].size.split("X") : [1, 1];
                                    o = [Number(o[0]), Number(o[1])];
                                    D = n && n[0] && n[0].graphType ? n[0].graphType : this.layoutConfig && this.layoutConfig[0] && this.layoutConfig[0].graphType ? this.layoutConfig[0].graphType : this.graphType;
                                    this.data.l.smps = [
                                        [k]
                                    ];
                                    this.data.l.weight = [
                                        [o[1] / F, o[0] / u]
                                    ];
                                    this.data.l.type = [D];
                                    this.data.l.doe = k;
                                    this.data.l.coords = [C(0, o)];
                                    for (var B = 0; B < this.includeDOE.length; B++) {
                                        var m = B + 1;
                                        o = n && n[m] && n[m].size ? n[m].size.split("X") : this.layoutConfig && this.layoutConfig[m] && this.layoutConfig[m].size ? this.layoutConfig[m].size.split("X") : [1, 1];
                                        o = [Number(o[0]), Number(o[1])];
                                        D = n && n[m] && n[m].graphType ? n[m].graphType : this.layoutConfig && this.layoutConfig[m] && this.layoutConfig[m].graphType ? this.layoutConfig[m].graphType : false;
                                        this.data.l.coords[m] = C(m, o);
                                        this.data.l.smps.push([this.includeDOE[B]]);
                                        this.data.l.weight.push([o[1] / F, o[0] / u]);
                                        if (D) {
                                            this.data.l.type.push(D)
                                        } else {
                                            if (f[this.includeDOE[B]].type == "Numeric") {
                                                this.data.l.type.push("Scatter2D")
                                            } else {
                                                var y = this.unique(E[this.includeDOE[B]]);
                                                this.data.l.type.push(y.length < this.maxPieSectors ? "Pie" : "Treemap")
                                            }
                                        }
                                    }
                                    this.layoutComb = true;
                                    this.plotByVariable = false;
                                    this.isValidLayout();
                                    this.dataStndBy = this.data;
                                    this.configStndBy = this.getConfig();
                                    this.configStndBy.groupingFactors = b;
                                    this.configStndBy.plotByVariable = h;
                                    this.configStndBy.histogramStat = this.histogramStat;
                                    this.configStndBy.stackBy = this.stackBy;
                                    this.configStndBy.summaryType = this.summaryType;
                                    this.histogramStat = "count";
                                    this.showAnimation = false;
                                    if (!this.initialGraphType) {
                                        this.initialGraphType = this.graphType
                                    }
                                    this.title = "";
                                    this.subtitle = "";
                                    this.removeToolbar();
                                    if (!x) {
                                        this.removeMenus();
                                        this.draw({
                                            func: "createDOE",
                                            par: [n, d, x]
                                        })
                                    }
                                };
                                this.removeDOE = function(c) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = this.configStndBy ? this.configStndBy.groupingFactors : false;
                                    var d = this.data.l.histogram ? true : false;
                                    var b = this.data.l.histogram ? this.data.l.histogram.ridgeBy : false;
                                    var e = this.data.l.histogram ? this.data.l.histogram.isAnnt : false;
                                    this.graphType = this.initialGraphType;
                                    this.isDOE = false;
                                    this.isPie = false;
                                    this.isPieGroup = false;
                                    if (!this.data.y.histogram) {
                                        this.isHistogram = false;
                                        this.isCreateHistogram = false
                                    }
                                    this.layoutValid = false;
                                    this.removeMenus();
                                    this.switchData(false, true);
                                    delete(this.data.l);
                                    this.layoutComb = false;
                                    this.layoutModified = false;
                                    this.isValidLayout();
                                    this.removeToolbar();
                                    if (d) {
                                        this.stack({
                                            func: "removeDOE",
                                            par: [c]
                                        });
                                        this.ridgeBy = b;
                                        this.skipStack = true;
                                        this.createHistogram(b || e);
                                        this.skipStack = false
                                    } else {
                                        if (a) {
                                            this.stack({
                                                func: "removeDOE",
                                                par: [c]
                                            });
                                            this.skipStack = true;
                                            this.groupSamples(a, false, false, false, c);
                                            this.skipStack = false
                                        } else {
                                            if (!c) {
                                                this.draw({
                                                    func: "removeDOE",
                                                    par: [c]
                                                })
                                            }
                                        }
                                    }
                                };
                                this.updateDOE = function(d, b) {
                                    if (this.isDOE) {
                                        if (b) {
                                            var a;
                                            for (var c = 1; c < this.data.l.smps.length; c++) {
                                                if (this.data.l.smps[c][0] == d) {
                                                    a = c;
                                                    break
                                                }
                                            }
                                            this.data.l.smps.splice(a, 1);
                                            this.data.l.comp.splice(a, 1);
                                            this.data.l.type.splice(a, 1);
                                            this.data.l.weight.splice(a, 1);
                                            this.layoutConfig.splice(a, 1)
                                        } else {
                                            this.data.l.smps.push([d]);
                                            this.data.l.comp.push([]);
                                            this.data.l.type.push("Scatter2D");
                                            this.data.l.weight.push(this.data.l.weight[0]);
                                            this.layoutConfig.push({})
                                        }
                                    }
                                };
                                this.resetDOE = function() {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    for (var c in this.configStndBy) {
                                        this[c] = this.configStndBy[c]
                                    }
                                    var b = this.isDOE > 1 ? this.dataStndBy.y.vars.length : this.dataStndBy.y.smps.length;
                                    var a = [];
                                    for (var c = 0; c < b; c++) {
                                        a.push(c)
                                    }
                                    this.dataStndBy.l.doe = a;
                                    delete this.dataStndBy.l.treemap;
                                    this.histogramStat = "count";
                                    if (this.configStndBy.groupingFactors.length > 0) {
                                        this.layoutComb = false;
                                        this.groupSamples(this.configStndBy.groupingFactors, false, false, false, true);
                                        this.layoutComb = true
                                    }
                                    this.toDoFilter = {};
                                    if (this.graphType == "Map") {
                                        this.setAllMapFeaturesVisible();
                                        this.hideUnhideMapFeatures(this.hiddenMapFeatures, true);
                                        this.hideUnhideMapFeatures(this.visibleMapFeatures, false, this.visibleMapFeatures.length)
                                    }
                                    this.draw({
                                        func: "resetDOE"
                                    })
                                };
                                this.createTreemap = function(j) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var b = this.groupingFactors && this.groupingFactors.length > 0 ? this.groupingFactors : false;
                                    var h = {
                                        data: {},
                                        vars: {}
                                    };
                                    var f = {
                                        y: {
                                            data: [
                                                []
                                            ],
                                            vars: [],
                                            smps: [],
                                            treemap: []
                                        }
                                    };
                                    if (b) {
                                        this.ungroupSamples(true)
                                    }
                                    var a, e;
                                    if (this.isDOE) {
                                        a = this.dataStndBy.l.doe;
                                        e = this.isDOE > 1 ? this.dataStndBy.z[j] : this.dataStndBy.x[j]
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            a = this.varIndices;
                                            e = this.data.z[j]
                                        } else {
                                            a = this.smpIndices;
                                            e = this.data.x[j]
                                        }
                                    }
                                    for (var d = 0; d < a.length; d++) {
                                        var g = this.isDOE && this.dataStndBy.l.treemap ? this.dataStndBy.l.treemap : e[a[d]];
                                        if (!h.data[g]) {
                                            h.data[g] = 0;
                                            h.vars[g] = []
                                        }
                                        h.data[g]++;
                                        h.vars[g].push(a[d])
                                    }
                                    f.y.vars.push(j);
                                    for (var d in h.data) {
                                        f.y.smps.push(d);
                                        f.y.data[0].push(h.data[d]);
                                        f.y.treemap.push(h.vars[d])
                                    }
                                    if (this.isDOE) {
                                        this.graphType = "Treemap";
                                        this.initializeData(f)
                                    } else {
                                        this.dataStndBy = this.data;
                                        this.configStndBy = this.getConfig();
                                        this.configStndBy.isTreemap = false;
                                        this.data = {};
                                        this.xAxis = false;
                                        this.yAxis = false;
                                        this.graphType = "Treemap";
                                        this.isTreemap = true;
                                        this.isTreemapGroup = b;
                                        this.initializeData(f);
                                        this.removeMenus();
                                        this.draw({
                                            func: "createTreemap",
                                            par: [j]
                                        })
                                    }
                                };
                                this.removeTreemap = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = this.isTreemapGroup;
                                    this.isTreemap = false;
                                    this.isTreemapGroup = false;
                                    this.removeMenus();
                                    this.switchData(false, true);
                                    if (a) {
                                        this.groupSamples(a, false, false, false, b)
                                    } else {
                                        if (!b) {
                                            this.draw({
                                                func: "removeTreemap"
                                            })
                                        }
                                    }
                                };
                                this.createFish = function() {
                                    var m = this;
                                    var D = function(i, d) {
                                        if (d > i.length) {
                                            alert("Cannot have a parent that does not exist in list. (p: " + i + ", x: " + d + ")")
                                        }
                                        if (d < 0) {
                                            alert("Cannot have a value in parents of less than zero")
                                        }
                                        if (i[d - 1] == 0) {
                                            return 0
                                        } else {
                                            return D(i, i[d - 1]) + 1
                                        }
                                    };
                                    var b = function(y) {
                                        var j = [];
                                        for (var d = 1; d <= y.length; d++) {
                                            j.push(D(y, d))
                                        }
                                        return j
                                    };
                                    var e = function(N, M) {
                                        for (var L = 0; L < N[0].length; L++) {
                                            for (var K = 0; K < N.length; K++) {
                                                for (var y = K + 1; y < N.length; y++) {
                                                    if (M[y] == K + 1) {
                                                        N[K][L] -= N[y][L]
                                                    }
                                                }
                                            }
                                        }
                                        return N
                                    };
                                    var u = function(N, M) {
                                        var K = [];
                                        for (var L = 0; L < N[0].length; L++) {
                                            K[L] = 100
                                        }
                                        for (var L = 0; L < M.length; L++) {
                                            if (M[L] == 0) {
                                                for (var y = 0; y < N[0].length; y++) {
                                                    K[y] -= N[L][y]
                                                }
                                            }
                                        }
                                        return K
                                    };
                                    var r = function(K, N) {
                                        for (var y = 0; y < K.length; y++) {
                                            var M = 0;
                                            var L = 0;
                                            for (var p = 0; p < K[y].length; p++) {
                                                if (K[y][p] > 0) {
                                                    if (M == 0) {
                                                        M = p
                                                    } else {
                                                        L = p
                                                    }
                                                }
                                            }
                                            if (M > 0 & L > 0) {
                                                for (var p = M; p <= L; p++) {
                                                    if (K[y][p] == 0) {
                                                        K[y][p] = Math.pow(0.01, N[y])
                                                    }
                                                }
                                            }
                                        }
                                    };
                                    var c = function(K, p) {
                                        if (K == 0) {
                                            return 0
                                        }
                                        var d = [];
                                        for (var j = 0; j < B.length; j++) {
                                            if (B[j] == K) {
                                                d.push(j)
                                            }
                                        }
                                        var y = 0;
                                        for (var j = 0; j < d.length; j++) {
                                            if (I[d[j]][p] > 0) {
                                                y++
                                            }
                                        }
                                        return y
                                    };
                                    var x = this.fishTimepoints;
                                    var B = this.fishParents;
                                    var I = this.data.y.data;
                                    if (!x.length) {
                                        for (var G = 0; G < this.data.y.smps.length; G++) {
                                            x.push(G)
                                        }
                                    } else {
                                        if (!this.isNumeric(x)) {
                                            alert("fishTimepoints must be array of numbers")
                                        }
                                    }
                                    var w = b(B);
                                    var J = e(this.cloneObject(I), B);
                                    var h = u(this.cloneObject(I), B);
                                    var z = [];
                                    var n = [];
                                    var f = [];
                                    r(I, w);
                                    for (var G = 0; G < x.length; G++) {
                                        var g = x[G];
                                        var E = [];
                                        var a = [];
                                        var s = [];
                                        for (var F = 0; F < B.length; F++) {
                                            E[F] = null;
                                            a[F] = null;
                                            s[F] = g
                                        }
                                        var A = [0];
                                        while (A.length > 0) {
                                            var q = A[0];
                                            var l = [];
                                            for (var F = 0; F < B.length; F++) {
                                                if (B[F] == q) {
                                                    l.push(F + 1)
                                                }
                                            }
                                            A.shift();
                                            for (var F = 0; F < l.length; F++) {
                                                A.push(l[F])
                                            }
                                            var k = 0;
                                            var o = h[G] / 2;
                                            if (this.fishSeparateIndependentClones) {
                                                o = 0;
                                                var C = 0;
                                                if (q == 0) {
                                                    for (var F = 0; F < B.length; F++) {
                                                        if (B[F] == 0) {
                                                            C++
                                                        }
                                                    }
                                                    if (C > 1 && h[G] > 0) {
                                                        k = h[G] / (C + 1)
                                                    }
                                                }
                                            }
                                            if (q != 0) {
                                                o = a[q - 1];
                                                k = J[q - 1][G] / (c(q, G) + 1)
                                            }
                                            for (var F = 0; F < l.length; F++) {
                                                var H = l[F] - 1;
                                                if (I[H][G] == 0) {
                                                    s[H] = null;
                                                    if (G > 0) {
                                                        if (I[H][G - 1] > 0) {
                                                            a[H] = o + k / 2;
                                                            E[H] = o + k / 2;
                                                            s[H] = g - 0.25
                                                        }
                                                    }
                                                } else {
                                                    a[H] = o + k;
                                                    o = o + I[H][G];
                                                    E[H] = o + k;
                                                    o = o + k
                                                }
                                            }
                                        }
                                        n.push(a);
                                        z.push(E);
                                        f.push(s)
                                    }
                                    n = this.transposeMatrix(n);
                                    z = this.transposeMatrix(z);
                                    f = this.transposeMatrix(f);
                                    for (var G = 0; G < n.length; G++) {
                                        n[G] = n[G].filter(function(d) {
                                            return d !== null
                                        });
                                        z[G] = z[G].filter(function(d) {
                                            return d !== null
                                        });
                                        f[G] = f[G].filter(function(d) {
                                            return d !== null
                                        })
                                    }
                                    return {
                                        nestLevel: w,
                                        innerSpace: J,
                                        outerSpace: h,
                                        ytop: z,
                                        ybtm: n,
                                        xpos: f
                                    }
                                };
                                this.createHistogram = function(X, a, b) {
                                    if (this.isTransition() || (this.dataStndBy && this.isCreateHistogram && !this.isDOE)) {
                                        return
                                    }
                                    var u = function(ae, an, at) {
                                        var aa = [];
                                        var am = [];
                                        var ay = [];
                                        var ab = [];
                                        var ad = [];
                                        var av = [];
                                        var az = {
                                            y: {
                                                data: [],
                                                vars: [],
                                                smps: [],
                                                histogram: [],
                                                cols: [],
                                                level: [],
                                                maxLevel: 1,
                                                subLevel: [],
                                                values: [],
                                                density: [],
                                                global: false
                                            }
                                        };
                                        if (ae && an && at != null) {
                                            var al = ae.histogram.count.length;
                                            var ah = ae.histogram.size;
                                            var aj = ae.histogram.breaks;
                                            var ao = aj[0];
                                            var ar = aj[aj.length - 1];
                                            var Z = an.length;
                                            for (var aq = 0; aq < al; aq++) {
                                                az.y.vars.push("Bin" + (aq + 1) + " (" + ae.histogram.breaks[aq] + " - " + ae.histogram.breaks[aq + 1] + ")");
                                                az.y.data[aq] = [];
                                                az.y.data[aq][0] = aj[aq + 1] - ao;
                                                az.y.histogram[aq] = [];
                                                for (var ap = 0; ap < Z; ap++) {
                                                    az.y.histogram[aq][ap] = []
                                                }
                                            }
                                            az.y.smps.push("Bin");
                                            az.y.maxLevel = an.length;
                                            var au = 0;
                                            for (var aq = 0; aq < an.length; aq++) {
                                                var ag = X ? D.getVariablesSamplesByAnnotationLevel(X, an[aq], D.varIndices, "z") : D.varIndices;
                                                var ak = 0;
                                                var ax = 0;
                                                av.push(at);
                                                ad.push(aq);
                                                az.y.smps.push(an[aq]);
                                                aa.push(an[aq]);
                                                var ac = [];
                                                for (var ap = 0; ap < al; ap++) {
                                                    ac[ap] = 0
                                                }
                                                for (var ap = 0; ap < ag.length; ap++) {
                                                    var af = D.getDataAtPos(ag[ap], D.smpIndices[at]);
                                                    if (af != null && af !== "" && !isNaN(af)) {
                                                        var ai = D.histBin(af, ao, ah, aj);
                                                        ac[ai]++;
                                                        az.y.histogram[ai][aq].push(ag[ap]);
                                                        ak++
                                                    }
                                                }
                                                am.push(ak);
                                                for (var ap = 0; ap < al; ap++) {
                                                    az.y.data[ap][au + 1] = ac[ap];
                                                    ax = Math.max(ax, ac[ap])
                                                }
                                                az.y.cols.push(ax);
                                                ab.push(au);
                                                au++
                                            }
                                            for (var aq = 0; aq < am.length; aq++) {
                                                ay.push(aq)
                                            }
                                            ay.sort(function(i, c) {
                                                return am[c] - am[i]
                                            });
                                            var aw = {
                                                graphType: "Scatter2D",
                                                isHistogram: true,
                                                isCreateHistogram: {
                                                    min: ao,
                                                    max: ar,
                                                    rmin: ao,
                                                    rmax: ar,
                                                    size: ah,
                                                    transposed: T,
                                                    groups: o,
                                                    smpIndices: ay,
                                                    n: ab,
                                                    factor: X,
                                                    colorBy: D.colorBy,
                                                    ridgeBy: D.ridgeBy,
                                                    isAnnt: A,
                                                    transformed: m,
                                                    level: ad,
                                                    maxLevel: an.length,
                                                    subLevel: av
                                                },
                                                xAxis: ["Bin"],
                                                yAxis: aa,
                                                setMinX: null,
                                                setMaxX: null,
                                                setMinX2: null,
                                                setMaxX2: null,
                                                setMinY: null,
                                                setMaxY: null,
                                                setMinZ: null,
                                                setMaxZ: null,
                                                xAxisExact: true,
                                                summaryType: "raw",
                                                histogramData: X,
                                                hideHistogram: (D.scatterPlotMatrixType.match(/Density/) ? true : false),
                                                histogramType: "staggered",
                                                showHistogramDensity: (D.scatterPlotMatrixType.match(/Density/) ? true : false),
                                                showFilledHistogramDensity: true
                                            };
                                            return D.cloneObject({
                                                data: az,
                                                params: aw
                                            })
                                        } else {
                                            return az
                                        }
                                    };
                                    if (X) {
                                        if (X && this.graphType == "Scatter2D" && this.meta.data && this.meta.data.z && this.meta.data.z[X] && this.meta.data.z[X].type == "Numeric" && !this.isDOE) {
                                            this.flashInfoSpan(100, 100, "Not allowed to create histograms with numerical factors", 5000);
                                            return
                                        } else {
                                            if (this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1) {
                                                alert("Ooops!. Histograms on multiple levels of segregation not supported yet!");
                                                return
                                            } else {
                                                if (this.segregateVariablesBy.length && this.segregateVariablesBy[0] != X) {
                                                    alert("Ooops!. Histograms with a variable factor must match the corresponding segregation!");
                                                    return
                                                } else {
                                                    if (this.segregateSamplesBy.length && this.segregateSamplesBy[0] != X) {}
                                                }
                                            }
                                        }
                                    }
                                    if (!this.isDOE) {
                                        this.dataStndBy = this.data;
                                        this.configStndBy = this.getConfig();
                                        this.configStndBy.isCreateHistogram = false;
                                        this.configStndBy.isHistogram = false
                                    }
                                    var D = this;
                                    var l;
                                    var f = 0;
                                    var o = this.groupingFactors;
                                    var m = this.isTransformedData;
                                    var A = X;
                                    var T = this.smpIndices.length > this.varIndices.length && !this.isDOE ? true : false;
                                    if (T) {
                                        var F = this.cloneObject(this.varIndices);
                                        var C = this.cloneObject(this.smpIndices);
                                        this.transpose(false, true, true);
                                        this.varIndices = C;
                                        this.smpIndices = F
                                    }
                                    if (!X && this.segregateVariablesBy.length) {
                                        X = this.segregateVariablesBy[0]
                                    } else {
                                        if (!X && this.colorBy) {
                                            X = this.colorBy
                                        } else {
                                            if (!X) {
                                                X = false
                                            }
                                        }
                                    }
                                    if (!CanvasXpress.cacheImagesReady) {
                                        setTimeout(function() {
                                            D.createHistogram(X)
                                        }, 200)
                                    } else {
                                        if (!this.isDOE && X && this.data.x && this.data.x.hasOwnProperty(X)) {
                                            alert("Not implemented.\nCreating Histogram by Sample!")
                                        }
                                        if (this.isDOE && X) {
                                            var S = this.dataStndBy.l.doe;
                                            if (b) {
                                                var O = [];
                                                this.meta.data.d.z[X] = {};
                                                var Q = this.getLevelsByAnnotation(X, S, this.isDOE > 1 ? "z" : "x");
                                                for (var N = 0; N < Q.length; N++) {
                                                    var I = this.getVariablesSamplesByAnnotationLevel(X, Q[N], S, this.isDOE > 1 ? "z" : "x");
                                                    var J = this.isDOE > 1 ? this.data.y.smps : this.data.y.vars;
                                                    for (var M = 0; M < J.length; M++) {
                                                        if (!this.meta.data.d.z[X].hasOwnProperty(Q[N])) {
                                                            this.meta.data.d.z[X][Q[N]] = {}
                                                        }
                                                        var s = [];
                                                        for (var L = 0; L < I.length; L++) {
                                                            var G = this.isDOE > 1 ? this.getDataAtPos(I[L], M) : this.getDataAtPos(M, I[L]);
                                                            if (G != null && G !== "" && !isNaN(G)) {
                                                                s.push(G);
                                                                O.push(G)
                                                            }
                                                        }
                                                        this.meta.data.d.z[X][Q[N]][M.toString()] = this.density(s, X + " - " + Q[N] + " - " + J[M]);
                                                        f = Math.max(f, this.meta.data.d.z[X][Q[N]][M.toString()].maxY)
                                                    }
                                                }
                                                for (var N = 0; N < Q.length; N++) {
                                                    var J = this.isDOE > 1 ? this.data.y.smps : this.data.y.vars;
                                                    for (var M = 0; M < J.length; M++) {
                                                        this.meta.data.d.z[X][Q[N]][M.toString()].globalMaxY = f
                                                    }
                                                }
                                                l = this.density(O, "Global");
                                                this.meta.data.d.m = l
                                            } else {
                                                var z = this.isDOE > 1 ? this.dataStndBy.z[X] : this.dataStndBy.x[X];
                                                var s = [];
                                                for (var N = 0; N < S.length; N++) {
                                                    var G = z[S[N]];
                                                    if (G != null && G !== "" && !isNaN(G)) {
                                                        s.push(G)
                                                    }
                                                }
                                                l = this.density(s, X);
                                                this.meta.data.d.d[X] = l
                                            }
                                        } else {
                                            if (this.isDOE && b) {
                                                var S = this.dataStndBy.l.doe;
                                                var I = S;
                                                var J = this.isDOE > 1 ? this.data.y.smps : this.data.y.vars;
                                                var O = [];
                                                for (var N = 0; N < J.length; N++) {
                                                    var s = [];
                                                    for (var M = 0; M < I.length; M++) {
                                                        var G = this.isDOE > 1 ? this.getDataAtPos(I[M], N) : this.getDataAtPos(N, I[M]);
                                                        if (G != null && G !== "" && !isNaN(G)) {
                                                            s.push(G);
                                                            O.push(G)
                                                        }
                                                    }
                                                    l = this.density(s, J[N]);
                                                    this.meta.data.d.s[N.toString()] = l;
                                                    f = Math.max(f, this.meta.data.d.s[N.toString()].maxY)
                                                }
                                                for (var N = 0; N < J.length; N++) {
                                                    this.meta.data.d.s[N.toString()].globalMaxY = f
                                                }
                                                l = this.density(O, "Global");
                                                this.meta.data.d.m = l
                                            } else {
                                                if (X && this.data.z && this.data.z.hasOwnProperty(X)) {
                                                    this.meta.data.d.z[X] = {};
                                                    var Q = this.getLevelsByAnnotation(X, this.varIndices, "z");
                                                    if (this.scatterPlotMatrix) {
                                                        for (var N = 0; N < this.smpIndices.length; N++) {
                                                            var O = [];
                                                            this.meta.data.d.z[X][this.smpIndices[N].toString()] = {};
                                                            for (var M = 0; M < Q.length; M++) {
                                                                var I = this.getVariablesSamplesByAnnotationLevel(X, Q[M], this.varIndices, "z");
                                                                var s = [];
                                                                for (var L = 0; L < I.length; L++) {
                                                                    var G = this.getDataAtPos(I[L], this.smpIndices[N]);
                                                                    if (G != null && G !== "" && !isNaN(G)) {
                                                                        s.push(G);
                                                                        O.push(G)
                                                                    }
                                                                }
                                                                this.meta.data.d.z[X][this.smpIndices[N].toString()][Q[M]] = this.density(s, X + " - " + Q[M] + " - " + this.data.y.smps[this.smpIndices[N]]);
                                                                f = Math.max(f, this.meta.data.d.z[X][this.smpIndices[N].toString()][Q[M]].maxY)
                                                            }
                                                            l = this.density(O, X + this.data.y.smps[this.smpIndices[N]]);
                                                            var R = u(l, Q, N);
                                                            for (var M = 0; M < Q.length; M++) {
                                                                R.data.y.density[M] = [X, this.smpIndices[N].toString(), Q[M]];
                                                                this.meta.data.d.z[X][this.smpIndices[N].toString()][Q[M]].globalMaxY = f
                                                            }
                                                            l.data = R.data;
                                                            l.params = R.params;
                                                            this.meta.data.d.z[X][this.smpIndices[N].toString()][this.data.y.smps[this.smpIndices[N]]] = l
                                                        }
                                                    } else {
                                                        for (var N = 0; N < Q.length; N++) {
                                                            var I = this.getVariablesSamplesByAnnotationLevel(X, Q[N], this.varIndices, "z");
                                                            for (var M = 0; M < this.smpIndices.length; M++) {
                                                                if (!this.meta.data.d.z[X].hasOwnProperty(Q[N])) {
                                                                    this.meta.data.d.z[X][Q[N]] = {}
                                                                }
                                                                var s = [];
                                                                for (var L = 0; L < I.length; L++) {
                                                                    var G = this.getDataAtPos(I[L], this.smpIndices[M]);
                                                                    if (G != null && G !== "" && !isNaN(G)) {
                                                                        s.push(G)
                                                                    }
                                                                }
                                                                this.meta.data.d.z[X][Q[N]][this.smpIndices[M].toString()] = this.density(s, X + " - " + Q[N] + " - " + this.data.y.smps[this.smpIndices[M]]);
                                                                f = Math.max(f, this.meta.data.d.z[X][Q[N]][this.smpIndices[M].toString()].maxY)
                                                            }
                                                        }
                                                        for (var N = 0; N < Q.length; N++) {
                                                            for (var M = 0; M < this.smpIndices.length; M++) {
                                                                this.meta.data.d.z[X][Q[N]][this.smpIndices[M].toString()].globalMaxY = f
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    for (var N = 0; N < this.smpIndices.length; N++) {
                                                        var s = [];
                                                        for (var M = 0; M < this.varIndices.length; M++) {
                                                            var G = this.getDataAtPos(this.varIndices[M], this.smpIndices[N]);
                                                            if (G != null && G !== "" && !isNaN(G)) {
                                                                s.push(G)
                                                            }
                                                        }
                                                        l = this.density(s, this.data.y.smps[N]);
                                                        if (this.scatterPlotMatrix) {
                                                            var R = u(l, [this.data.y.smps[this.smpIndices[N]]], N);
                                                            R.data.y.density.push([this.smpIndices[N].toString()]);
                                                            l.data = R.data;
                                                            l.params = R.params
                                                        }
                                                        this.meta.data.d.s[this.smpIndices[N].toString()] = l;
                                                        f = Math.max(f, this.meta.data.d.s[this.smpIndices[N].toString()].maxY)
                                                    }
                                                    for (var N = 0; N < this.smpIndices.length; N++) {
                                                        this.meta.data.d.s[this.smpIndices[N].toString()].globalMaxY = f
                                                    }
                                                }
                                                if (this.scatterPlotMatrix) {
                                                    this.dataStndBy = this.data;
                                                    if (!this.configStndBy) {
                                                        this.configStndBy = this.getConfig()
                                                    }
                                                    this.configStndBy.isCreateHistogram = false;
                                                    this.configStndBy.isHistogram = false;
                                                    return
                                                }
                                                var s = [];
                                                for (var N = 0; N < this.smpIndices.length; N++) {
                                                    for (var M = 0; M < this.varIndices.length; M++) {
                                                        var G = this.getDataAtPos(this.varIndices[M], this.smpIndices[N]);
                                                        if (G != null && G !== "" && !isNaN(G)) {
                                                            s.push(G)
                                                        }
                                                    }
                                                }
                                                l = this.smpIndices.length == 1 && !X ? this.meta.data.d.s[this.smpIndices[0].toString()] : this.density(s, "Global");
                                                this.meta.data.d.m = l
                                            }
                                        }
                                        var x = [];
                                        var g = [];
                                        var r = [];
                                        var Y = [];
                                        var y = [];
                                        var p = [];
                                        var W = l.histogram.count.length;
                                        var d = l.histogram.size;
                                        var P = l.histogram.breaks;
                                        var V = P[0];
                                        var w = P[P.length - 1];
                                        var J = this.isDOE && X && !b ? 1 : this.isDOE && X && b ? this.getLevelsByAnnotation(X, S, this.isDOE > 1 ? "z" : "x").length : Q ? Q.length * this.smpIndices.length : this.smpIndices.length;
                                        var R = u();
                                        R.y.global = l.histogram;
                                        for (var N = 0; N < W; N++) {
                                            R.y.vars.push("Bin" + (N + 1) + " (" + l.histogram.breaks[N] + " - " + l.histogram.breaks[N + 1] + ")");
                                            R.y.data[N] = [];
                                            R.y.data[N][0] = P[N + 1] - V;
                                            R.y.histogram[N] = [];
                                            R.y.values[N] = [];
                                            for (var M = 0; M < J; M++) {
                                                R.y.histogram[N][M] = [];
                                                R.y.values[N][M] = []
                                            }
                                        }
                                        R.y.smps.push("Bin");
                                        if (this.isDOE && X) {
                                            var S = this.dataStndBy.l.doe;
                                            if (b) {
                                                var Q = this.getLevelsByAnnotation(X, S, this.isDOE > 1 ? "z" : "x");
                                                R.y.maxLevel = Q.length;
                                                var B = 0;
                                                for (var N = 0; N < Q.length; N++) {
                                                    var I = this.getVariablesSamplesByAnnotationLevel(X, Q[N], S, this.isDOE > 1 ? "z" : "x");
                                                    var J = this.isDOE > 1 ? this.data.y.smps : this.data.y.vars;
                                                    for (var M = 0; M < J.length; M++) {
                                                        var h = J.length == 1 ? Q[N] : J[M] + ":" + Q[N];
                                                        var K = 0;
                                                        var U = 0;
                                                        R.y.smps.push(h);
                                                        R.y.level.push(N);
                                                        R.y.subLevel.push(M);
                                                        y.push(N);
                                                        p.push(M);
                                                        x.push(h);
                                                        var H = [];
                                                        for (var L = 0; L < W; L++) {
                                                            H[L] = 0
                                                        }
                                                        for (var L = 0; L < I.length; L++) {
                                                            var G = this.isDOE > 1 ? this.getDataAtPos(I[L], M) : this.getDataAtPos(M, I[L]);
                                                            if (G != null && G !== "" && !isNaN(G)) {
                                                                var e = this.histBin(G, V, d, P);
                                                                H[e]++;
                                                                if (R.y.histogram[e][B]) {
                                                                    R.y.histogram[e][B].push(I[L]);
                                                                    R.y.values[e][B].push(G);
                                                                    K++
                                                                }
                                                            }
                                                        }
                                                        g.push(K);
                                                        for (var L = 0; L < W; L++) {
                                                            R.y.data[L][B + 1] = H[L];
                                                            U = Math.max(U, H[L])
                                                        }
                                                        R.y.cols.push(U);
                                                        R.y.density[B] = this.meta.data.d.z[X][Q[N]][M.toString()];
                                                        Y.push(B);
                                                        B++
                                                    }
                                                }
                                            } else {
                                                R.y.smps = ["Bin", X];
                                                x = [X];
                                                for (var N = 0; N < W; N++) {
                                                    R.y.data[N][1] = l.histogram.count[N];
                                                    R.y.histogram[N][0] = l.histogram.idxs[N]
                                                }
                                                g = [1];
                                                Y = [0];
                                                R.y.density[0] = l
                                            }
                                        } else {
                                            if (this.isDOE && b) {
                                                var S = this.dataStndBy.l.doe;
                                                var I = S;
                                                var J = this.isDOE > 1 ? this.data.y.smps : this.data.y.vars;
                                                for (var N = 0; N < J.length; N++) {
                                                    var K = 0;
                                                    var U = 0;
                                                    R.y.smps.push(J[N]);
                                                    R.y.level.push(0);
                                                    R.y.subLevel.push(N);
                                                    y.push(0);
                                                    p.push(N);
                                                    x.push(J[N]);
                                                    var H = [];
                                                    for (var M = 0; M < W; M++) {
                                                        H[M] = 0
                                                    }
                                                    for (var M = 0; M < I.length; M++) {
                                                        var G = this.isDOE > 1 ? this.getDataAtPos(I[M], N) : this.getDataAtPos(N, I[M]);
                                                        if (G != null && G !== "" && !isNaN(G)) {
                                                            var e = this.histBin(G, V, d, P);
                                                            H[e]++;
                                                            if (R.y.histogram[e][N]) {
                                                                R.y.histogram[e][N].push(I[M]);
                                                                R.y.values[e][N].push(G);
                                                                K++
                                                            }
                                                        }
                                                    }
                                                    g.push(K);
                                                    for (var M = 0; M < W; M++) {
                                                        R.y.data[M][N + 1] = H[M];
                                                        U = Math.max(U, H[M])
                                                    }
                                                    R.y.cols.push(U);
                                                    R.y.density[N] = this.meta.data.d.s[N.toString()];
                                                    Y.push(N)
                                                }
                                            } else {
                                                if (Q) {
                                                    R.y.maxLevel = Q.length;
                                                    var B = 0;
                                                    for (var N = 0; N < Q.length; N++) {
                                                        I = this.getVariablesSamplesByAnnotationLevel(X, Q[N], this.varIndices, "z");
                                                        for (var M = 0; M < this.smpIndices.length; M++) {
                                                            var h = this.smpIndices.length == 1 ? Q[N] : this.data.y.smps[this.smpIndices[M]] + ":" + Q[N];
                                                            var K = 0;
                                                            var U = 0;
                                                            R.y.smps.push(h);
                                                            R.y.level.push(N);
                                                            R.y.subLevel.push(M);
                                                            y.push(N);
                                                            p.push(M);
                                                            x.push(h);
                                                            var H = [];
                                                            for (var L = 0; L < W; L++) {
                                                                H[L] = 0
                                                            }
                                                            for (var L = 0; L < I.length; L++) {
                                                                var G = this.getDataAtPos(I[L], this.smpIndices[M]);
                                                                if (G != null && G !== "" && !isNaN(G)) {
                                                                    var e = this.histBin(G, V, d, P);
                                                                    H[e]++;
                                                                    if (R.y.histogram[e][B]) {
                                                                        R.y.histogram[e][B].push(I[L]);
                                                                        R.y.values[e][B].push(G);
                                                                        K++
                                                                    }
                                                                }
                                                            }
                                                            g.push(K);
                                                            for (var L = 0; L < W; L++) {
                                                                R.y.data[L][B + 1] = H[L];
                                                                U = Math.max(U, H[L])
                                                            }
                                                            R.y.cols.push(U);
                                                            R.y.density[B] = this.meta.data.d.z[X][Q[N]][this.smpIndices[M].toString()];
                                                            Y.push(B);
                                                            B++
                                                        }
                                                    }
                                                } else {
                                                    R.y.level.push(0);
                                                    y.push(0);
                                                    for (var N = 0; N < this.smpIndices.length; N++) {
                                                        var K = 0;
                                                        var U = 0;
                                                        p.push(N);
                                                        R.y.subLevel.push(N);
                                                        R.y.smps.push(this.data.y.smps[this.smpIndices[N]]);
                                                        x.push(this.data.y.smps[this.smpIndices[N]]);
                                                        var H = [];
                                                        for (var M = 0; M < W; M++) {
                                                            H[M] = 0
                                                        }
                                                        for (var M = 0; M < this.varIndices.length; M++) {
                                                            var G = this.getDataAtPos(this.varIndices[M], this.smpIndices[N]);
                                                            if (G != null && G !== "" && !isNaN(G)) {
                                                                var e = this.histBin(G, V, d, P);
                                                                H[e]++;
                                                                if (R.y.histogram[e][N]) {
                                                                    R.y.histogram[e][N].push(this.varIndices[M]);
                                                                    R.y.values[e][N].push(G);
                                                                    K++
                                                                }
                                                            }
                                                        }
                                                        g.push(K);
                                                        for (var M = 0; M < W; M++) {
                                                            R.y.data[M][N + 1] = H[M];
                                                            U = Math.max(U, H[M])
                                                        }
                                                        R.y.cols.push(U);
                                                        R.y.density[N] = this.meta.data.d.s[this.smpIndices[N].toString()];
                                                        Y.push(N)
                                                    }
                                                }
                                            }
                                        }
                                        for (var N = 0; N < g.length; N++) {
                                            r.push(N)
                                        }
                                        if (this.ridgeBy) {
                                            this.showFilledHistogramDensity = true;
                                            this.showHistogramDensity = true;
                                            if (Q.length != r.length) {
                                                var E = this.cloneObject(R.y.smps);
                                                E.shift();
                                                r = r.sort(function(i, c) {
                                                    return E[i].split(":")[1].localeCompare(E[c].split(":")[1]) || E[c].split(":")[0].localeCompare(E[i].split(":")[0])
                                                })
                                            } else {
                                                r.sort(function(i, c) {
                                                    return i - c
                                                })
                                            }
                                        }
                                        if (!this.showHistogramDensity && this.histogramStat == "density") {
                                            this.histogramStat = "count"
                                        }
                                        var q = b ? this.dataStndBy.l.histogram : false;
                                        this.data = {};
                                        this.graphType = "Scatter2D";
                                        this.isHistogram = true;
                                        this.isCreateHistogram = {
                                            min: V,
                                            max: w,
                                            rmin: V,
                                            rmax: w,
                                            size: d,
                                            transposed: (q ? q.transposed : T),
                                            groups: (q ? q.groups : o),
                                            smpIndices: r,
                                            n: Y,
                                            factor: X,
                                            colorBy: this.colorBy,
                                            ridgeBy: (q ? q.ridgeBy : this.ridgeBy),
                                            isAnnt: A,
                                            transformed: (q ? q.transformed : m),
                                            level: y,
                                            maxLevel: (Q ? Q.length : 1),
                                            subLevel: p
                                        };
                                        this.xAxis = ["Bin"];
                                        this.xAxis2 = [];
                                        this.yAxis = x;
                                        this.zAxis = [];
                                        this.resetRange();
                                        this.xAxisExact = true;
                                        this.initializeData(R);
                                        this.graphType = "Scatter2D";
                                        if (!this.isDOE) {
                                            this.removeMenus();
                                            if (!a) {
                                                this.draw({
                                                    func: "createHistogram",
                                                    par: [X, a, b]
                                                })
                                            }
                                        }
                                    }
                                };
                                this.removeHistogram = function(b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var c = this.isCreateHistogram.transposed;
                                    var j = this.isCreateHistogram.groups;
                                    var h = this.densityKernel;
                                    var g = this.showHistogramDensity;
                                    var k = this.histogramBins;
                                    var i = this.histogramBinWidth;
                                    var e = this.histogramType;
                                    this.removeMenus();
                                    this.switchData(false, true, a);
                                    this.ridgeBy = false;
                                    var d = this.segregateVariablesBy;
                                    var f = this.segregateSamplesBy;
                                    this.densityKernel = h;
                                    this.showHistogramDensity = g;
                                    this.histogramBins = k;
                                    this.histogramBinWidth = i;
                                    this.histogramType = e;
                                    if (c) {
                                        this.transpose(false, true, true)
                                    }
                                    this.segregateVariablesAndOrSamples(d, f, true);
                                    if (j && j.length > 0) {
                                        this.groupSamples(j, false, false, false, b)
                                    } else {
                                        if (!b) {
                                            this.draw({
                                                func: "removeHistogram",
                                                par: [b]
                                            })
                                        }
                                    }
                                };
                                this.createCorrelation = function(m) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var o = this;
                                    var p = this.meta.data.c;
                                    if (this.scatterPlotMatrix) {
                                        if (m && this.data.z && this.data.z.hasOwnProperty(m)) {
                                            p.z[m] = {};
                                            var r = this.getLevelsByAnnotation(m, this.varIndices, "z");
                                            for (var x = 0; x < this.smpIndices.length; x++) {
                                                for (var w = x + 1; w < this.smpIndices.length; w++) {
                                                    var b = this.data.y.smps[this.smpIndices[x]] + "::" + this.data.y.smps[this.smpIndices[w]];
                                                    var a = this.data.y.smps[this.smpIndices[w]] + "::" + this.data.y.smps[this.smpIndices[x]];
                                                    p.z[m][b] = [];
                                                    p.z[m][a] = [];
                                                    for (var u = 0; u < r.length; u++) {
                                                        var q = this.getVariablesSamplesByAnnotationLevel(m, r[u], this.varIndices, "z");
                                                        var c = r[u] && this.meta.data.z && this.meta.data.z[m].colors ? this.meta.data.z[m].order : false;
                                                        var g = c ? this.meta.data.z[m].colors[c[r[u]]] : this.confidenceIntervalColor;
                                                        var n = [];
                                                        var h = [];
                                                        for (var s = 0; s < q.length; s++) {
                                                            var f = this.data.y.data[q[s]][this.smpIndices[x]];
                                                            var e = this.data.y.data[q[s]][this.smpIndices[w]];
                                                            if (f != null && f !== "" && !isNaN(f) && e != null && e !== "" && !isNaN(e)) {
                                                                n.push(f);
                                                                h.push(e)
                                                            }
                                                        }
                                                        var d = {
                                                            cor: this.correlation(n, h),
                                                            lab: r[u],
                                                            col: g,
                                                            id: (r[u] ? "Property:" + m + ":" + r[u] + ":z" : false),
                                                            n: n.length
                                                        };
                                                        p.z[m][b].push(d);
                                                        p.z[m][a].push(d)
                                                    }
                                                }
                                            }
                                        } else {
                                            for (var x = 0; x < this.smpIndices.length; x++) {
                                                for (var w = x + 1; w < this.smpIndices.length; w++) {
                                                    var b = this.data.y.smps[this.smpIndices[x]] + "::" + this.data.y.smps[this.smpIndices[w]];
                                                    var a = this.data.y.smps[this.smpIndices[w]] + "::" + this.data.y.smps[this.smpIndices[x]];
                                                    var n = [];
                                                    var h = [];
                                                    for (var u = 0; u < this.varIndices.length; u++) {
                                                        var f = this.data.y.data[this.varIndices[u]][this.smpIndices[x]];
                                                        var e = this.data.y.data[this.varIndices[u]][this.smpIndices[w]];
                                                        if (f != null && f !== "" && !isNaN(f) && e != null && e !== "" && !isNaN(e)) {
                                                            n.push(f);
                                                            h.push(e)
                                                        }
                                                    }
                                                    var d = {
                                                        cor: this.correlation(n, h),
                                                        lab: "Correlation",
                                                        col: this.foreground,
                                                        id: false,
                                                        n: n.length
                                                    };
                                                    p.s[b] = [d];
                                                    p.s[a] = [d]
                                                }
                                            }
                                        }
                                    }
                                };
                                this.correlateData = function(f, d, c, e) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.graphType.match(/Scatter/i)) {
                                        this.isCorrelateS = true;
                                        this.isCorrelateKeyS = d;
                                        this.isCorrelateColorS = c;
                                        this.addRegressionLine(d, c, e)
                                    } else {
                                        this.dataStndBy = this.data;
                                        this.configStndBy = this.getConfig();
                                        var b = this.groupingFactors;
                                        if (d) {
                                            if (f) {
                                                this.switchAnnotationToVar(d)
                                            } else {
                                                this.switchAnnotationToSmp(d)
                                            }
                                        }
                                        var a = f ? this.data.y.vars : this.data.y.smps;
                                        this.graphType = "Scatter2D";
                                        this.axesType = "XY";
                                        if (b) {
                                            this.ungroupSamples(true)
                                        }
                                        if (f) {
                                            this.transpose(false, true);
                                            this.graphType = "Scatter2D"
                                        }
                                        this.xAxis = [a[0]];
                                        this.xAxisTitle = a[0];
                                        this.xAxisIndices = [0];
                                        this.yAxis = [a[1] || a[0]];
                                        this.yAxisTitle = a[1] || a[0];
                                        this.yAxisIndices = a[1] ? [1] : [0];
                                        this.showAnimation = false;
                                        this.addRegressionLine(false, c, true);
                                        this.isCorrelate = true;
                                        this.isCorrelateTranspose = f;
                                        this.isCorrelateGroup = b;
                                        this.isCorrelateKey = d;
                                        this.isCorrelateColor = c;
                                        this.draw({
                                            noImages: true,
                                            func: "correlateData",
                                            par: [f, d, c, e]
                                        })
                                    }
                                    this.removeMenus()
                                };
                                this.removeCorrelation = function(d) {
                                    this.removeMenus();
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.isCorrelate) {
                                        if (this.decorations && this.decorations.reg) {
                                            delete(this.decorations.reg)
                                        }
                                        if (this.data.l && this.data.l.reg) {
                                            delete(this.data.l.reg)
                                        }
                                        var a = this.cloneObject(this.segregateVariablesBy);
                                        var c = this.cloneObject(this.segregateSamplesBy);
                                        var b = this.isCorrelateTranspose;
                                        this.switchData(false, true);
                                        if (this.isCorrelateTranspose) {
                                            this.transpose(false, false, true)
                                        }
                                        if (this.isCorrelateKey) {
                                            if (this.isCorrelateTranspose) {
                                                this.switchVarToAnnotation(this.isCorrelateKey)
                                            } else {
                                                this.switchSmpToAnnotation(this.isCorrelateKey)
                                            }
                                        }
                                        if (a.length || c.length) {
                                            if (b) {
                                                if (a.length) {
                                                    this.segregateVariablesBy = c;
                                                    this.segregate("Samples", a[0], true)
                                                } else {
                                                    this.segregateSamplesBy = a;
                                                    this.segregate("Variables", c[0], true)
                                                }
                                            } else {
                                                if (a.length) {
                                                    this.segregateVariablesBy = a;
                                                    this.segregate("Samples", c[0], true)
                                                } else {
                                                    this.segregateSamplesBy = c;
                                                    this.segregate("Variables", a[0], true)
                                                }
                                            }
                                        }
                                        if (!d) {
                                            if (this.isCorrelateGroup.length) {
                                                this.groupSamples(this.isCorrelateGroup)
                                            } else {
                                                this.draw({
                                                    func: "removeCorrelation"
                                                })
                                            }
                                        }
                                        this.isCorrelate = false;
                                        this.isCorrelateTranspose = false;
                                        this.isCorrelateGroup = false;
                                        this.isCorrelateKey = false;
                                        this.isCorrelateColor = false
                                    } else {
                                        this.isCorrelateS = false;
                                        this.isCorrelateKeyS = false;
                                        this.isCorrelateColorS = false;
                                        if (this.decorations && this.decorations.reg) {
                                            delete(this.decorations.reg)
                                        }
                                        if (this.data.l && this.data.l.reg) {
                                            delete(this.data.l.reg)
                                        }
                                        if (!d) {
                                            this.draw({
                                                func: "removeCorrelation"
                                            })
                                        }
                                    }
                                };
                                this.resetCorrelation = function() {
                                    if (this.isCorrelateS) {
                                        var b = this.isCorrelateKeyS;
                                        var a = this.isCorrelateColorS;
                                        this.removeCorrelation();
                                        this.correlateData(false, b, a, true)
                                    } else {
                                        if (this.decorations && this.decorations.reg) {
                                            this.updateCorrelation()
                                        }
                                    }
                                };
                                this.updateCorrelation = function() {
                                    if (this.ridgeBy) {
                                        return
                                    }
                                    var a = false;
                                    if (this.decorations && this.decorations.reg) {
                                        a = this.decorations.reg[0].factor;
                                        delete(this.decorations.reg)
                                    }
                                    if (this.layoutValid || !this.meta.data.c.p.length) {
                                        this.addRegressionLine(a, false, true)
                                    } else {
                                        this.addRegressionLine(this.meta.data.c.p[0], this.meta.data.c.p[1], true)
                                    }
                                };
                                this.addRegressionLine = function(h, w, p) {
                                    if (this.isTransition() || this.isCreateHistogram) {
                                        return
                                    }
                                    var l = this;
                                    var o, C, g, d, f, b, r, e, B, a, c;
                                    if (!CanvasXpress.cacheImagesReady) {
                                        setTimeout(function() {
                                            l.addRegressionLine(h, w, p)
                                        }, 100)
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.isDOE) {} else {
                                                var A = [];
                                                var q = [];
                                                var s;
                                                if (h) {
                                                    q = this.getVarSmpAnnotations(h, this.varIndices, false, false, "z");
                                                    if (this.meta.data.z && this.meta.data.z[h] && this.meta.data.z[h].levels && this.meta.data.z[h].levels.length == q.length) {
                                                        q = this.cloneObject(this.meta.data.z[h].levels)
                                                    }
                                                    for (var z = 0; z < q.length; z++) {
                                                        A.push(this.getVariablesSamplesByAnnotationLevel(h, q[z], this.varIndices, "z"))
                                                    }
                                                } else {
                                                    A = [this.varIndices]
                                                }
                                                if (this.layoutValid) {
                                                    this.data.l.reg = [];
                                                    if (this.data.l.smps) {
                                                        for (var z = 0; z < this.data.l.smps.length; z++) {
                                                            this.data.l.reg[z] = [];
                                                            B = this.data.l.smps[z];
                                                            if (B.xAxis && B.yAxis) {
                                                                o = this.getSampleIndices(B.xAxis[0]);
                                                                C = this.getSampleIndices(B.yAxis[0]);
                                                                r = this.data.y.smps[o] + " vs " + this.data.y.smps[C];
                                                                for (var y = 0; y < A.length; y++) {
                                                                    a = q[y] && this.meta.data.z && this.meta.data.z[h].colors ? this.meta.data.z[h].order : false;
                                                                    s = w ? w : a ? this.meta.data.z[h].colors[a[q[y]]] : this.fitLineColor;
                                                                    e = w ? w : a ? this.meta.data.z[h].colors[a[q[y]]] : this.confidenceIntervalColor;
                                                                    g = this.getDataForSmpGrpAtIndex(o, A[y]);
                                                                    d = this.getDataForSmpGrpAtIndex(C, A[y]);
                                                                    f = this.regression(g, d);
                                                                    b = this.correlation(g, d);
                                                                    this.data.l.reg[z][y] = {
                                                                        reg: f,
                                                                        cor: b,
                                                                        lab: r,
                                                                        fit: s,
                                                                        col: e,
                                                                        id: (q[y] ? "Property:" + h + ":" + q[y] + ":z" : false),
                                                                        n: g.length,
                                                                        factor: h
                                                                    }
                                                                }
                                                            } else {
                                                                this.data.l.reg[z] = false
                                                            }
                                                        }
                                                    } else {
                                                        for (var z = 0; z < this.data.l.comp.length; z++) {
                                                            this.data.l.reg[z] = [];
                                                            o = this.xAxisIndices[0];
                                                            C = this.yAxisIndices[0];
                                                            r = this.data.y.smps[o] + " vs " + this.data.y.smps[C];
                                                            for (var y = 0; y < A.length; y++) {
                                                                a = q[y] && this.meta.data.z && this.meta.data.z[h].colors ? this.meta.data.z[h].order : false;
                                                                s = w ? w : a ? this.meta.data.z[h].colors[a[q[y]]] : this.fitLineColor;
                                                                e = w ? w : a ? this.meta.data.z[h].colors[a[q[y]]] : this.confidenceIntervalColor;
                                                                if (h) {
                                                                    g = [];
                                                                    d = [];
                                                                    for (var u = 0; u < this.data.l.comp[z].length; u++) {
                                                                        c = this.data.l.comp[z][u];
                                                                        if (this.data.z[h][c] == q[y]) {
                                                                            g.push(this.getDataAtPos(c, o));
                                                                            d.push(this.getDataAtPos(c, C))
                                                                        }
                                                                    }
                                                                } else {
                                                                    g = [];
                                                                    d = [];
                                                                    for (var u = 0; u < this.data.l.comp[z].length; u++) {
                                                                        c = this.data.l.comp[z][u];
                                                                        g.push(this.getDataAtPos(c, o));
                                                                        d.push(this.getDataAtPos(c, C))
                                                                    }
                                                                }
                                                                f = this.regression(g, d);
                                                                b = this.correlation(g, d);
                                                                this.data.l.reg[z][y] = {
                                                                    reg: f,
                                                                    cor: b,
                                                                    lab: r,
                                                                    fit: s,
                                                                    col: e,
                                                                    id: (q[y] ? "Property:" + h + ":" + q[y] + ":z" : false),
                                                                    n: g.length,
                                                                    factor: h
                                                                }
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    this.meta.data.c.p = [h, w];
                                                    if (!this.xAxisIndices) {
                                                        this.xAxisIndices = this.getSampleIndices(this.xAxis)
                                                    }
                                                    if (!this.yAxisIndices) {
                                                        this.yAxisIndices = this.getSampleIndices(this.yAxis)
                                                    }
                                                    var m = this.axesType == "Y" ? [this.xAxisIndices[this.xAxisCurrent]] : this.xAxisIndices;
                                                    var x = this.axesType == "X" ? [this.yAxisIndices[this.yAxisCurrent]] : this.yAxisIndices;
                                                    var n = Math.max(m.length, x.length);
                                                    for (var z = 0; z < A.length; z++) {
                                                        a = q[z] && this.meta.data.z && this.meta.data.z[h].colors ? this.meta.data.z[h].order : false;
                                                        for (var y = 0; y < n; y++) {
                                                            s = w ? w : a ? this.meta.data.z[h].colors[a[q[z]]] : this.fitLineColor;
                                                            e = w ? w : a ? this.meta.data.z[h].colors[a[q[z]]] : this.confidenceIntervalColor;
                                                            o = m[y] ? m[y] : m[0];
                                                            C = x[y] ? x[y] : x[0];
                                                            r = q[z] ? q[z] : this.data.y.smps[o] + " vs " + this.data.y.smps[C];
                                                            g = this.getDataForSmpGrpAtIndex(o, A[z], false, this.xAxisTransform);
                                                            d = this.getDataForSmpGrpAtIndex(C, A[z], false, this.yAxisTransform);
                                                            f = this.regression(g, d);
                                                            b = this.correlation(g, d);
                                                            this.addRegressionDecoration(f, b, r, e, s, q[z] ? "Property:" + h + ":" + q[z] + ":z" : false, g.length, h)
                                                        }
                                                    }
                                                }
                                            }
                                            if (!p) {
                                                this.draw({
                                                    func: "addRegressionLine",
                                                    par: [h, w, p]
                                                })
                                            }
                                            this.removeMenus()
                                        }
                                    }
                                };
                                this.addRegressionDecoration = function(d, e, c, a, b, h, g, f) {
                                    this.showDecorations = true;
                                    if (!this.decorations) {
                                        this.decorations = {}
                                    }
                                    if (!this.decorations.reg) {
                                        this.decorations.reg = []
                                    }
                                    this.decorations.reg.push({
                                        slope: d[0],
                                        intercept: d[1],
                                        cor: d[2],
                                        ci: d[3],
                                        label: c,
                                        color: a,
                                        fit: b,
                                        id: h,
                                        n: g,
                                        factor: f,
                                        r: e
                                    })
                                };
                                this.addNormalDistributionLine = function(c, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var k = this;
                                    var p, g, n, h, j, l, m, f, d, f, a, o;
                                    if (!CanvasXpress.cacheImagesReady) {
                                        setTimeout(function() {
                                            k.addNormalDistributionLine(c)
                                        }, 100)
                                    } else {
                                        if (this.graphType.match(/Scatter/)) {
                                            if (this.axesType == "XYZ") {
                                                n = c == "y" ? this.yAxisIndices[this.yAxisCurrent] : this.xAxisIndices[this.xAxisCurrent];
                                                h = c == "y" ? this.xAxisIndices[this.xAxisCurrent] : this.yAxisIndices[this.yAxisCurrent];
                                                j = this.getDataForSmpGrpAtIndex(n);
                                                l = this.getDataForSmpGrpAtIndex(h);
                                                m = this.max(l);
                                                f = this.data.y.smps[n];
                                                d = this.meanStandardDeviationN(j);
                                                this.addNormalDistributionDecoration(d, m, f, this.foreground, c)
                                            } else {
                                                p = c == "y" ? this.yAxisIndices : this.xAxisIndices;
                                                g = c == "y" ? this.xAxisIndices : this.yAxisIndices;
                                                o = c == "y" ? this.xAxisCurrent : this.yAxisCurrent;
                                                for (var e = 0; e < p.length; e++) {
                                                    a = e % this.colors.length;
                                                    n = p[e];
                                                    h = g[e] ? g[e] : g[o];
                                                    j = this.getDataForSmpGrpAtIndex(n);
                                                    l = this.getDataForSmpGrpAtIndex(h);
                                                    m = this.max(l);
                                                    f = this.data.y.smps[n];
                                                    d = this.meanStandardDeviationN(j);
                                                    this.addNormalDistributionDecoration(d, m, f, this.colors[a], c)
                                                }
                                            }
                                            if (!b) {
                                                this.draw({
                                                    func: "addNormalDistributionLine",
                                                    par: [c, b]
                                                })
                                            }
                                        }
                                    }
                                };
                                this.addNormalDistributionDecoration = function(e, a, c, b, d) {
                                    this.showDecorations = true;
                                    if (!this.decorations) {
                                        this.decorations = {}
                                    }
                                    if (!this.decorations.nor) {
                                        this.decorations.nor = []
                                    }
                                    if (d && d == "y") {
                                        this.decorations.nor.push({
                                            mu: e[0],
                                            sigma: e[1],
                                            yAxis: true,
                                            max: a,
                                            label: c,
                                            color: b
                                        })
                                    } else {
                                        this.decorations.nor.push({
                                            mu: e[0],
                                            sigma: e[1],
                                            max: a,
                                            label: c,
                                            color: b
                                        })
                                    }
                                };
                                this.modifyQQPlot = function(a) {
                                    if (a) {
                                        this.removeQQPlot()
                                    } else {
                                        if (this.decorations && this.decorations.qq) {
                                            this.removeQQPlot(true)
                                        }
                                        this.isQQ = true;
                                        this.scatterType = "qq";
                                        this.addQQPlot()
                                    }
                                };
                                this.addQQPlot = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    for (var a = 0; a < this.smpIndices.length; a++) {
                                        this.addQQDecoration(this.smpIndices[a])
                                    }
                                    this.isQQ = true;
                                    this.scatterType = "qq";
                                    this.setMinX = null;
                                    this.setMaxX = null;
                                    this.setMinY = null;
                                    this.setMaxY = null;
                                    if (!b) {
                                        this.removeMenus();
                                        this.draw({
                                            func: "addQQPlot",
                                            par: [b]
                                        })
                                    }
                                };
                                this.addQQDecoration = function(a) {
                                    this.showDecorations = true;
                                    if (!this.decorations) {
                                        this.decorations = {}
                                    }
                                    if (!this.decorations.qq) {
                                        this.decorations.qq = []
                                    }
                                    this.decorations.qq.push({
                                        distribution: this.qqDistribution,
                                        data: this.qq(this.getDataForSmpGrpAtIndex(a)),
                                        color: this.colors[this.decorations.qq.length % this.colors.length],
                                        label: this.data.y.smps[a],
                                        index: a
                                    })
                                };
                                this.removeQQPlot = function(a) {
                                    delete(this.decorations.qq);
                                    if (!Object.keys(this.decorations).length) {
                                        delete(this.decorations)
                                    }
                                    this.isQQ = false;
                                    this.scatterType = false;
                                    if (!a) {
                                        this.removeMenus();
                                        this.draw({
                                            func: "removeQQPlot",
                                            par: [a]
                                        })
                                    }
                                };
                                this.addCDFPlot = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    for (var a = 0; a < this.smpIndices.length; a++) {
                                        this.addCDFDecoration(this.smpIndices[a])
                                    }
                                    this.isCDF = true;
                                    this.scatterType = "cdf";
                                    this.setMinX = null;
                                    this.setMaxX = null;
                                    this.setMinY = null;
                                    this.setMaxY = null;
                                    if (!b) {
                                        this.removeMenus();
                                        this.draw({
                                            func: "addCDFPlot",
                                            par: [b]
                                        })
                                    }
                                };
                                this.addCDFDecoration = function(a) {
                                    this.showDecorations = true;
                                    if (!this.decorations) {
                                        this.decorations = {}
                                    }
                                    if (!this.decorations.cdf) {
                                        this.decorations.cdf = []
                                    }
                                    this.decorations.cdf.push({
                                        data: this.cdf(this.getDataForSmpGrpAtIndex(a)),
                                        color: this.colors[this.decorations.cdf.length % this.colors.length],
                                        label: this.data.y.smps[a],
                                        index: a
                                    })
                                };
                                this.removeCDFPlot = function(a) {
                                    delete(this.decorations.cdf);
                                    if (!Object.keys(this.decorations).length) {
                                        delete(this.decorations)
                                    }
                                    this.isCDF = false;
                                    this.scatterType = false;
                                    if (!a) {
                                        this.removeMenus();
                                        this.draw({
                                            func: "removeCDFPlot",
                                            par: [a]
                                        })
                                    }
                                };
                                this.addKaplanMeierCurve = function(d, a, j, e, c) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (d && a) {
                                        var b = this.getSampleIndices(d);
                                        var l = this.getSampleIndices(a);
                                        if (b > -1 && l > -1 && this.meta.data.y.range[a]) {
                                            var k = this.meta.data.y.range[a];
                                            if (k.max != 1 && k.min != 0) {
                                                alert("Cannot create Kaplan Meier plot with this data set");
                                                return
                                            } else {
                                                if (this.kaplanMeierBy) {
                                                    var h = this.getVariableLevelsByAnnotation(this.kaplanMeierBy);
                                                    for (var f = 0; f < h.length; f++) {
                                                        var g = this.getVariablesByAnnotationLevel(this.kaplanMeierBy, h[f]);
                                                        this.addKaplanMeierDecoration(d, a, (h[f] || "NA"), e, g)
                                                    }
                                                } else {
                                                    this.addKaplanMeierDecoration(d, a, j, e, this.varIndices)
                                                }
                                            }
                                        }
                                    }
                                    if (!c) {
                                        this.removeMenus();
                                        this.draw({
                                            func: "addKaplanMeierCurve",
                                            par: [d, a, j, e, c]
                                        })
                                    }
                                };
                                this.addKaplanMeierDecoration = function(c, e, b, a, d) {
                                    this.showDecorations = true;
                                    if (!this.decorations) {
                                        this.decorations = {}
                                    }
                                    if (!this.decorations.kaplanMeier) {
                                        this.decorations.kaplanMeier = []
                                    }
                                    this.decorations.kaplanMeier.push({
                                        time: c,
                                        censored: e,
                                        label: b,
                                        color: (a || this.colors[this.decorations.kaplanMeier.length % this.colors.length]),
                                        indices: d
                                    })
                                };
                                this.modifyKaplanMeier = function() {
                                    this.removeMenus();
                                    if (this.decorations && this.decorations.kaplanMeier) {
                                        delete this.decorations.kaplanMeier;
                                        this.removeMenus();
                                        this.draw({
                                            func: "modifyKaplanMeier"
                                        })
                                    } else {
                                        this.addKaplanMeierCurve(this.xAxis[0], this.yAxis[0])
                                    }
                                };
                                this.updateKaplanMeier = function() {
                                    if (this.decorations && this.decorations.kaplanMeier) {
                                        var b = this.decorations.kaplanMeier[0].time;
                                        var a = this.decorations.kaplanMeier[0].censored;
                                        delete this.decorations.kaplanMeier;
                                        this.addKaplanMeierCurve(b, a, false, false, true);
                                        this.removeMenus();
                                        this.draw({
                                            func: "updateKaplanMeier"
                                        })
                                    }
                                };
                                this.addMeanLine = function(p, h, k) {
                                    var d = 0;
                                    var b = 0;
                                    for (var f = 0; f < this.varIndices.length; f++) {
                                        var o = this.varIndices[f];
                                        for (var e = 0; e < this.smpIndices.length; e++) {
                                            var g = this.smpIndices[e];
                                            var l = this.data.y.data[o][g];
                                            if (!isNaN(l)) {
                                                d += l;
                                                b++
                                            }
                                        }
                                    }
                                    this.addLineDecoration(p, h, d / b, "Mean", k);
                                    this.draw({
                                        func: "addMeanLine",
                                        par: [p, h, k]
                                    })
                                };
                                this.addLineDecoration = function(f, g, e, d, b) {
                                    if (!this.graphType.match(/Scatter|Network|Genome|Correlation|Venn|Circular/)) {
                                        if (!this.decorations) {
                                            this.decorations = {}
                                        }
                                        if (!this.decorations.lines) {
                                            this.decorations.line = []
                                        }
                                        if (f && f == "solid") {
                                            f = "line"
                                        }
                                        this.decorations.line.push({
                                            type: f || "line",
                                            color: g || this.foreground,
                                            value: e || 0,
                                            label: d || false,
                                            align: b || "left"
                                        })
                                    }
                                };
                                this.binDataByPercentile = function(g, f) {
                                    var d = this.range(this.data.y.data[g]);
                                    if (!this.data.x) {
                                        this.data.x = {}
                                    }
                                    var a = this.data.y.vars[g] + " Percentile" + (f ? "" : " Category");
                                    this.data.x[a] = [];
                                    for (var c = 0; c < this.data.y.data[g].length; c++) {
                                        var b = this.data.y.data[g][c];
                                        if (!isNaN(b) && b !== "" && b != null) {
                                            var e = this.parseInt(this.percentile(d[0], d[1], b) / 10);
                                            if (e == 10) {
                                                e--
                                            }
                                            this.data.x[a][c] = f ? e + 1 : (e * 10) + "-" + ((e + 1) * 10) + "%"
                                        } else {
                                            this.data.x[a][c] = ""
                                        }
                                    }
                                    if (this.isGroupedData) {
                                        this.ungroupSamples(true)
                                    }
                                    this.updateData(this.data, false, true);
                                    this.groupSamples([a]);
                                    this.sortSamplesByCategory([a]);
                                    this.removeMenus()
                                };
                                this.binDataByQuantile = function(g, f) {
                                    var c = this.quantile(this.data.y.data[g], [0.25, 0.5, 0.75]);
                                    if (!this.data.x) {
                                        this.data.x = {}
                                    }
                                    var a = this.data.y.vars[g] + " Quantile" + (f ? "" : " Category");
                                    this.data.x[a] = [];
                                    for (var d = 0; d < this.data.y.data[g].length; d++) {
                                        var b = this.data.y.data[g][d];
                                        if (!isNaN(b) && b !== "" && b != null) {
                                            var e = this.quantileBin(c, b);
                                            if (f) {
                                                this.data.x[a][d] = e + 1
                                            } else {
                                                if (e == 0) {
                                                    this.data.x[a][d] = "1st Quantile"
                                                } else {
                                                    if (e == 1) {
                                                        this.data.x[a][d] = "2nd Quantile"
                                                    } else {
                                                        if (e == 2) {
                                                            this.data.x[a][d] = "3rd Quantile"
                                                        } else {
                                                            this.data.x[a][d] = "4th Quantile"
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            this.data.x[a][d] = ""
                                        }
                                    }
                                    if (this.isGroupedData) {
                                        this.ungroupSamples(true)
                                    }
                                    this.updateData(this.data, false, true);
                                    this.groupSamples([a]);
                                    this.sortSamplesByCategory([a]);
                                    this.removeMenus()
                                };
                                this.binDataCustom = function(a, b) {
                                    this.addBinConfigurator(a, b);
                                    this.removeMenus()
                                };
                                this.switchData = function(a, b, c) {
                                    if (this.dataStndBy && this.configStndBy) {
                                        this.data = this.dataStndBy;
                                        if (!this.scatterPlotMatrix) {
                                            this.resetConfig(c)
                                        }
                                        this.updateConfig(this.configStndBy);
                                        this.setTheme();
                                        this.updateData(this.data, a, b);
                                        this.layoutComb = this.isLayoutComb()
                                    }
                                };
                                this.updateData = function(g, o, j, e) {
                                    delete(this.data.initialVarIndices);
                                    delete(this.data.initialSmpIndices);
                                    if (e) {
                                        for (var b in e) {
                                            this.meta.config.user[b] = e[b];
                                            this[b] = e[b]
                                        }
                                    }
                                    if (this.isObject(g)) {
                                        var m = typeof g.data == "string" && this.isValidString(g.data).type == "URL" ? g.data : g.config && g.config.graphType == "Map" ? g.data : -1;
                                        if (m == -1) {
                                            this.initializeData(g, this.scatterPlotMatrix ? false : true)
                                        } else {
                                            var h = this.$("container-" + this.target);
                                            var c = 1;
                                            while (!h) {
                                                h = this.$("container-" + this.target + "-" + c);
                                                c++
                                            }
                                            var f = h.id;
                                            var l;
                                            if (f.match(/\d*$/)) {
                                                var i = Number(f.split("-").pop()) + 1;
                                                l = f.replace(/\d*$/, i).replace("container-", "")
                                            } else {
                                                l = this.newId(f)
                                            }
                                            if (this.target != l) {
                                                CanvasXpress.chain[this.target] = l
                                            }
                                            var k = h.parentNode;
                                            var a = this.$cX("canvas", {
                                                id: l,
                                                width: this.originalWidth,
                                                height: this.originalHeight
                                            });
                                            this.castCanvasAttributes(a);
                                            k.appendChild(a);
                                            var c;
                                            if (g && g.data) {
                                                c = new CanvasXpress({
                                                    renderTo: l,
                                                    data: g.data,
                                                    config: e
                                                })
                                            } else {
                                                g.renderTo = l;
                                                c = new CanvasXpress(g)
                                            }
                                            c.destroy(f.replace("container-", ""))
                                        }
                                    } else {
                                        this.initializeData(g, this.scatterPlotMatrix ? false : true)
                                    }
                                    if (!j) {
                                        this.initializeGraph(o)
                                    }
                                };
                                this.appendMetaData = function(d, g) {
                                    if (d.y) {
                                        if (d.y.smps && d.y.smps.length && d.x) {
                                            for (var f in d.x) {
                                                if (!this.data.x) {
                                                    this.data.x = {}
                                                }
                                                if (!this.data.x.hasOwnProperty(f)) {
                                                    this.data.x[f] = []
                                                }
                                                for (var b = 0; b < d.y.smps.length; b++) {
                                                    var a = this.getSampleIndices(d.y.smps[b]);
                                                    if (a > -1) {
                                                        this.data.x[f][a] = d.x[f][b]
                                                    }
                                                }
                                            }
                                            this.updateMetaData("x", false, false, true)
                                        }
                                        if (d.y.vars && d.y.vars.length && d.z) {
                                            for (var f in d.z) {
                                                if (!this.data.z) {
                                                    this.data.z = {}
                                                }
                                                if (!this.data.z.hasOwnProperty(f)) {
                                                    this.data.z[f] = []
                                                }
                                                for (var b = 0; b < d.y.vars.length; b++) {
                                                    var a = this.getVariableIndices(d.y.vars[b]);
                                                    if (a > -1) {
                                                        this.data.z[f][a] = d.z[f][b]
                                                    }
                                                }
                                            }
                                            this.updateMetaData("z", false, false, true)
                                        }
                                        CanvasXpress.stack[this.target].data = this.parseJSON(this.stringifyJSON(this.data))
                                    } else {
                                        if (g) {
                                            var e = 2;
                                            while (this.data.y.hasOwnProperty("data" + e)) {
                                                e++
                                            }
                                            this.data.y["data" + e] = d;
                                            CanvasXpress.stack[this.target].data = this.parseJSON(this.stringifyJSON(this.data))
                                        }
                                    }
                                };
                                this.modifyDOE = function(g, d) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var b = true;
                                    if (d) {
                                        this[g] = d;
                                        b = false
                                    } else {
                                        var h = false;
                                        var c = this.getObjectArray(this.includeDOE);
                                        if (c.hasOwnProperty(g)) {
                                            var a = [];
                                            for (var e = 0; e < this.includeDOE.length; e++) {
                                                if (this.includeDOE[e] != g) {
                                                    a.push(this.includeDOE[e])
                                                }
                                            }
                                            this.includeDOE = a
                                        } else {
                                            this.includeDOE.push(g);
                                            h = true
                                        }
                                        if (this.includeDOE.length >= this.maxDOENumber + 1 && h) {
                                            this.layout = "1X1";
                                            this.layoutTopology = false;
                                            this.maxDOENumber++
                                        } else {
                                            if (this.includeDOE.length < this.maxDOENumber + 1) {
                                                this.layout = "1X1";
                                                this.layoutTopology = false;
                                                this.maxDOENumber--
                                            }
                                        }
                                    }
                                    this.createDOE(false, b, true);
                                    this.draw({
                                        func: "modifyDOE",
                                        par: [g, d]
                                    })
                                };
                                this.updateDOEGraphType = function(a) {
                                    if (!this.layoutConfig[this.layoutCurrent]) {
                                        this.layoutConfig[this.layoutCurrent] = {}
                                    }
                                    this.layoutConfig[this.layoutCurrent].graphType = a;
                                    this.removeMenus();
                                    this.draw({
                                        func: "updateDOEGraphType",
                                        par: [a],
                                        prop: {
                                            layoutCurrent: this.layoutCurrent
                                        }
                                    })
                                };
                                this.updateDOEAxis = function(a, b) {
                                    var d = this.layoutCurrent;
                                    if (!this.layoutConfig[d]) {
                                        this.layoutConfig[d] = {}
                                    }
                                    this.layoutConfig[d][a + "Axis"] = b;
                                    if (a == "x" && this.layoutConfig[d].yAxis == null) {
                                        this.layoutConfig[d].yAxis = this.data.l.smps[d][0]
                                    } else {
                                        if (a == "y" && this.layoutConfig[d].xAxis == null) {
                                            this.layoutConfig[d].xAxis = this.data.l.smps[d][0]
                                        }
                                    }
                                    this.removeMenus();
                                    this.draw({
                                        func: "updateDOEAxis",
                                        par: [a, b],
                                        prop: {
                                            layoutCurrent: this.layoutCurrent
                                        }
                                    })
                                };
                                this.updateDOEGraphSize = function(a) {
                                    var b = this.layoutCurrent || 0;
                                    if (!this.layoutConfig[b]) {
                                        this.layoutConfig[b] = {}
                                    }
                                    this.layoutConfig[b].size = a;
                                    this.createDOE(false, false, true);
                                    this.draw({
                                        func: "updateDOEGraphSize",
                                        par: [a],
                                        prop: {
                                            layoutCurrent: b
                                        }
                                    });
                                    this.layoutCurrent = b
                                };
                                this.modifyHistogram = function() {
                                    if (this.isHistogram) {
                                        var a = this.isCreateHistogram.factor;
                                        this.removeHistogram(true);
                                        this.createHistogram(a)
                                    }
                                };
                                this.modifySampleSegregation = function(e) {
                                    var a = {};
                                    var c = this.segregateSamplesBy;
                                    var d = this.segregateVariablesBy;
                                    if (this.layoutTopology) {
                                        this.layoutTopologyCurrent = this.layoutTopology.split(/X/i)
                                    }
                                    this.layoutTopology = false;
                                    for (var b = 0; b < this.segregateSamplesBy.length; b++) {
                                        a[this.segregateSamplesBy[b]] = true
                                    }
                                    if (a[e]) {
                                        delete(a[e])
                                    } else {
                                        a[e] = true
                                    }
                                    this.segregateSamplesBy = this.getKeys(a);
                                    if (d.length && this.segregateSamplesBy.length && this.isHistogram) {
                                        this.removeMenus();
                                        this.segregateSamplesBy = c;
                                        alert("Only one segregation factor is allowed while Histogram is set")
                                    } else {
                                        if (this.validateSegregation()) {
                                            a = this.segregateSamplesBy;
                                            this.segregateSamplesBy = [];
                                            this.segregateSamples(a, false, true)
                                        } else {
                                            this.segregateSamplesBy = c
                                        }
                                    }
                                };
                                this.modifyVariableSegregation = function(e) {
                                    var a = {};
                                    var c = this.segregateVariablesBy;
                                    var d = this.segregateSamplesBy;
                                    if (this.layoutValid && !this.isDOE && this.isOneDimensionalGraph() && this.meta.config.user.graphType != this.graphType) {
                                        this.graphType = this.meta.config.user.graphType
                                    }
                                    if (this.layoutTopology) {
                                        this.layoutTopologyCurrent = this.layoutTopology.split(/X/i)
                                    }
                                    this.layoutTopology = false;
                                    for (var b = 0; b < this.segregateVariablesBy.length; b++) {
                                        a[this.segregateVariablesBy[b]] = true
                                    }
                                    if (a[e]) {
                                        delete(a[e])
                                    } else {
                                        a[e] = true
                                    }
                                    this.segregateVariablesBy = this.getKeys(a);
                                    if (d.length && this.segregateVariablesBy && this.isHistogram) {
                                        this.removeMenus();
                                        this.segregateVariablesBy = c;
                                        alert("Only one segregation factor is allowed while Histogram is set")
                                    } else {
                                        if (this.validateSegregation()) {
                                            a = this.segregateVariablesBy;
                                            this.segregateVariablesBy = [];
                                            this.segregateVariables(a, false, true)
                                        } else {
                                            this.segregateVariablesBy = c
                                        }
                                    }
                                };
                                this.modifyLayoutType = function(a) {
                                    var b = this.scatterPlotMatrix;
                                    this.removeMenus();
                                    this.showScatterPlotMatrixLabels = true;
                                    this.unsetScatterPlotMatrix();
                                    this.scatterPlotMatrixType = a;
                                    this.scatterPlotMatrix = b !== true ? b : this.colorBy ? this.colorBy : true;
                                    this.draw({
                                        func: "modifyLayoutType",
                                        par: [a]
                                    })
                                };
                                this.modifySummaryType = function(b) {
                                    if (this.summaryType != b) {
                                        if (this.isGroupedData) {
                                            var a = this.groupingFactors;
                                            this.ungroupSamples(true);
                                            this.summaryType = b;
                                            this.meta.config.user.summaryType = b;
                                            this.groupSamples(a)
                                        } else {
                                            this.summaryType = b;
                                            this.draw({
                                                func: "modifySummaryType",
                                                par: [b]
                                            })
                                        }
                                    }
                                };
                                this.modifyTransform = function(a) {
                                    v = a.shift();
                                    t = a[0];
                                    this.transform(t)
                                };
                                this.modifyTransformRatio = function(a, b) {
                                    if (a == "sample") {
                                        if (this.ratioSampleReference == b) {
                                            this.ratioSampleReference = false;
                                            this.transform("reset")
                                        } else {
                                            this.ratioSampleReference = b;
                                            this.transform("ratio")
                                        }
                                    } else {
                                        if (a == "group") {
                                            if (this.ratioGroupReference == b) {
                                                this.ratioLevelReference = false;
                                                this.ratioGroupReference = false;
                                                this.transform("reset")
                                            } else {
                                                this.ratioGroupReference = b;
                                                this.ratioLevelReference = false;
                                                this.transform("ratio")
                                            }
                                            this.removeMenus()
                                        } else {
                                            if (a == "level") {
                                                this.transform("reset");
                                                if (this.ratioLevelReference == b) {
                                                    this.ratioLevelReference = false
                                                } else {
                                                    this.ratioLevelReference = b
                                                }
                                                this.transform("ratio")
                                            }
                                        }
                                    }
                                };
                                this.modifySampleGroups = function(c) {
                                    var b = {};
                                    if (this.data.x) {
                                        for (var a = 0; a < this.groupingFactors.length; a++) {
                                            b[this.groupingFactors[a]] = true
                                        }
                                        if (b[c]) {
                                            delete(b[c])
                                        } else {
                                            b[c] = true
                                        }
                                        this.groupSamples(this.getKeys(b))
                                    }
                                };
                                this.modifyTreemapGroups = function(c) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = {};
                                    for (var b = 0; b < this.treemapBy.length; b++) {
                                        a[this.treemapBy[b]] = true
                                    }
                                    if (a[c]) {
                                        delete(a[c])
                                    } else {
                                        a[c] = true
                                    }
                                    this.treemapBy = this.getKeys(a);
                                    this.draw({
                                        func: "modifyTreemapGroups",
                                        par: [c]
                                    })
                                };
                                this.modifyNetworkDecorations = function(c) {
                                    var b = {};
                                    if (this.meta.data.nodes) {
                                        for (var a = 0; a < this.decorations.length; a++) {
                                            b[this.decorations[a]] = true
                                        }
                                        if (b[c]) {
                                            delete(b[c])
                                        } else {
                                            b[c] = true
                                        }
                                        b = this.getKeys(b).sort();
                                        if (!this.isSameObject(this.decorations, b)) {
                                            this.decorations = b;
                                            this.draw({
                                                func: "modifyNetworkDecorations",
                                                par: [c]
                                            })
                                        }
                                    }
                                };
                                this.modifyVariableOverlays = function(c) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = {};
                                    if (this.graphType == "Heatmap" && this.data.z) {
                                        for (var b = 0; b < this.varOverlays.length; b++) {
                                            a[this.varOverlays[b]] = true
                                        }
                                        if (a[c]) {
                                            delete(a[c])
                                        } else {
                                            a[c] = true
                                        }
                                        this.varOverlays = this.getKeys(a);
                                        this.draw({
                                            func: "modifyVariableOverlays",
                                            par: [c]
                                        })
                                    }
                                };
                                this.modifySampleOverlays = function(c) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var b = {};
                                    if (this.data.x) {
                                        for (var a = 0; a < this.smpOverlays.length; a++) {
                                            b[this.smpOverlays[a]] = true
                                        }
                                        if (b[c]) {
                                            delete(b[c])
                                        } else {
                                            b[c] = true
                                        }
                                        this.smpOverlays = this.getKeys(b);
                                        this.draw({
                                            func: "modifySampleOverlays",
                                            par: [c]
                                        })
                                    }
                                };
                                this.resetDendrograms = function() {
                                    delete(this.varDendrogram);
                                    delete(this.smpDendrogram)
                                };
                                this.showHideDendrogram = function(a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this[a]) {
                                        this[a] = false
                                    } else {
                                        this[a] = true
                                    }
                                    this.draw({
                                        func: "showHideDendrogram",
                                        par: [a]
                                    })
                                };
                                this.changeDendrogramPosition = function(a) {
                                    if (this[a] == "left") {
                                        this[a] = "right"
                                    } else {
                                        if (this[a] == "right") {
                                            this[a] = "left"
                                        } else {
                                            if (this[a] == "top") {
                                                this[a] = "bottom"
                                            } else {
                                                if (this[a] == "bottom") {
                                                    this[a] = "top"
                                                }
                                            }
                                        }
                                    }
                                };
                                this.resetLegendPosition = function(a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.resetLegends(true);
                                    if (!a) {
                                        this.draw({
                                            func: "resetLegendPosition",
                                            par: [a]
                                        })
                                    }
                                };
                                this.modifyColorScheme = function() {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.setColorScheme();
                                    this.resetMetaData();
                                    this.draw({
                                        func: "modifyColorScheme"
                                    })
                                };
                                this.modifyColorSpectrumZeroValue = function(a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.colorSpectrumZeroValue = parseFloat(a[0]);
                                    this.setColorBrew(true);
                                    this.resetMetaData();
                                    this.draw({
                                        func: "modifyColorSpectrumZeroValue",
                                        par: [a]
                                    })
                                };
                                this.modifyColorSpectrum = function(a) {
                                    this.removeMenus();
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.colorSpectrum.includes(a)) {
                                        if (this.colorSpectrum.length == 2) {
                                            alert("Ooops... Can't do... Need at least two colors!");
                                            return
                                        } else {
                                            this.colorSpectrum = this.removeFromArray(a, this.colorSpectrum)
                                        }
                                    } else {
                                        this.colorSpectrum.push(a)
                                    }
                                    this.setColorBrew(true);
                                    this.resetMetaData();
                                    this.draw({
                                        func: "modifyColorSpectrum",
                                        par: [a]
                                    })
                                };
                                this.modifyColorSpectrumByScheme = function(a) {
                                    this.removeMenus();
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var c = this.colorSpectrumTarget;
                                    if (CanvasXpress.colorSchemes[a][c]) {
                                        this.colorSpectrum = CanvasXpress.colorSchemes[a][c]
                                    } else {
                                        var b = this.getKeys(CanvasXpress.colorSchemes[a]);
                                        b.sort(function(e, d) {
                                            return e - d
                                        });
                                        if (c > b[b.length - 1]) {
                                            c--;
                                            while (!CanvasXpress.colorSchemes[a][c]) {
                                                c--
                                            }
                                        } else {
                                            c++;
                                            while (!CanvasXpress.colorSchemes[a][c]) {
                                                c++
                                            }
                                        }
                                        this.colorSpectrum = CanvasXpress.colorSchemes[a][c]
                                    }
                                    this.setColorBrew(true);
                                    this.resetMetaData();
                                    this.draw({
                                        func: "modifyColorSpectrumByScheme",
                                        par: [a]
                                    })
                                };
                                this.changeTheme = function(a, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (a && (CanvasXpress.themes.hasOwnProperty(a) || a.match(/lastAirBender|gameOfThrones/))) {
                                        delete this.layoutRestore;
                                        if (a.match(/lastAirBender/)) {
                                            this.colorScheme = this.capitalize(a);
                                            this.updateTheme(CanvasXpress.themes.lastAirBender)
                                        } else {
                                            if (a.match(/gameOfThrones/)) {
                                                this.colorScheme = this.capitalize(a);
                                                this.updateTheme(CanvasXpress.themes.gameOfThrones)
                                            } else {
                                                this.updateTheme(CanvasXpress.themes[a])
                                            }
                                        }
                                        this.theme = a;
                                        this.setColorScheme();
                                        this.resetMetaData(true);
                                        this.updateDecorationScheme();
                                        if (!b) {
                                            this.draw({
                                                func: "changeTheme",
                                                par: [a, b]
                                            })
                                        }
                                    }
                                };
                                this.updateDecorationScheme = function() {
                                    if (this.graphType.match(/Scatter/)) {
                                        if (this.layoutValid) {
                                            if (this.data.l) {
                                                if (this.data.l.reg) {
                                                    for (var e = 0; e < this.data.l.reg.length; e++) {
                                                        for (var c = 0; c < this.data.l.reg[e].length; c++) {
                                                            var f = this.data.l.reg[e][c].id.split(":");
                                                            var h = f[1];
                                                            var d = f[2];
                                                            var b = f[3];
                                                            var a = this.meta.data[b][h].order;
                                                            var g = this.meta.data[b][h].colors[a[d]];
                                                            if (this.data.l.reg[e][c].fit != this.fitLineColor) {
                                                                this.data.l.reg[e][c].fit = g
                                                            }
                                                            if (this.data.l.reg[e][c].col != this.confidenceIntervalColor) {
                                                                this.data.l.reg[e][c].col = g
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (this.decorations && this.decorations.kaplanMeier) {
                                                        for (var e = 0; e < this.decorations.kaplanMeier.length; e++) {
                                                            this.decorations.kaplanMeier[e].color = this.colors[e % this.colors.length]
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.decorations) {
                                                if (this.decorations.reg) {
                                                    for (var e = 0; e < this.decorations.reg.length; e++) {
                                                        if (this.decorations.reg[e].id) {
                                                            var f = this.decorations.reg[e].id.split(":");
                                                            var h = f[1];
                                                            var d = f[2];
                                                            var b = f[3];
                                                            var a = this.meta.data[b][h].order;
                                                            var g = this.meta.data[b][h].colors[a[d]];
                                                            if (this.decorations.reg[e].fit != this.fitLineColor) {
                                                                this.decorations.reg[e].fit = g
                                                            }
                                                            if (this.decorations.reg[e].color != this.confidenceIntervalColor) {
                                                                this.decorations.reg[e].color = g
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (this.decorations.kaplanMeier) {
                                                        for (var e = 0; e < this.decorations.kaplanMeier.length; e++) {
                                                            this.decorations.kaplanMeier[e].color = this.colors[e % this.colors.length]
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    } else {}
                                };
                                this.modifyColorProperties = function(b, e, h, g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.modifyColorPropertiesOverlays(b, e, h);
                                    var a = this.meta.data[h][e];
                                    if (a.type == "Numeric") {
                                        var d = a.colorBrew.spectrum;
                                        if (this.validateColor(b)) {
                                            d.push(b)
                                        }
                                        a.colorBrew = this.getColorBrew(d, a.rmin, a.rmax)
                                    } else {
                                        var i = a.levels.length;
                                        if (CanvasXpress.colorSchemes[b][i]) {
                                            a.colors = CanvasXpress.colorSchemes[b][i]
                                        } else {
                                            var c = this.getKeys(CanvasXpress.colorSchemes[b]);
                                            c.sort(function(j, f) {
                                                return j - f
                                            });
                                            if (i > c[c.length - 1]) {
                                                i--;
                                                while (!CanvasXpress.colorSchemes[b][i]) {
                                                    i--
                                                }
                                            } else {
                                                i++;
                                                while (!CanvasXpress.colorSchemes[b][i]) {
                                                    i++
                                                }
                                            }
                                            a.colors = CanvasXpress.colorSchemes[b][i]
                                        }
                                    }
                                    if (!g) {
                                        this.draw({
                                            func: "modifyColorProperties",
                                            par: [b, e, h, g]
                                        })
                                    }
                                };
                                this.modifyColorPropertiesOverlays = function(b, d, e) {
                                    if (this.isOneDimensionalGraph()) {
                                        var a = this.meta.data[e][d];
                                        if (a.type == "Numeric") {
                                            var c = a.colorBrew.spectrum;
                                            if (this.validateColor(b)) {
                                                c.push(b)
                                            }
                                            if (e == "x") {
                                                if (!this.smpOverlayProperties) {
                                                    this.smpOverlayProperties = {}
                                                }
                                                if (!this.smpOverlayProperties.hasOwnProperty(d)) {
                                                    this.smpOverlayProperties[d] = {}
                                                }
                                                this.smpOverlayProperties[d]["spectrum"] = c
                                            } else {
                                                if (e == "z") {
                                                    if (!this.varOverlayProperties) {
                                                        this.varOverlayProperties = {}
                                                    }
                                                    if (!this.varOverlayProperties.hasOwnProperty(d)) {
                                                        this.varOverlayProperties[d] = {}
                                                    }
                                                    this.varOverlayProperties[d]["spectrum"] = c
                                                }
                                            }
                                        } else {
                                            if (CanvasXpress.colorSchemes.hasOwnProperty(b)) {
                                                if (e == "x") {
                                                    if (!this.smpOverlayProperties) {
                                                        this.smpOverlayProperties = {}
                                                    }
                                                    if (!this.smpOverlayProperties.hasOwnProperty(d)) {
                                                        this.smpOverlayProperties[d] = {}
                                                    }
                                                    this.smpOverlayProperties[d]["scheme"] = b
                                                } else {
                                                    if (e == "z") {
                                                        if (!this.varOverlayProperties) {
                                                            this.varOverlayProperties = {}
                                                        }
                                                        if (!this.varOverlayProperties.hasOwnProperty(d)) {
                                                            this.varOverlayProperties[d] = {}
                                                        }
                                                        this.varOverlayProperties[d]["scheme"] = b
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setFont = function(b) {
                                    var a = this;
                                    b = this.isArray(b) ? b : [b];
                                    CanvasXpress.loadFonts(b, function() {
                                        a.fontName = b[0];
                                        a.draw({
                                            func: "setFont",
                                            par: [b],
                                            prop: {
                                                layoutCurrent: a.iSDOE ? a.layoutCurrent : 0
                                            }
                                        })
                                    })
                                };
                                this.toggleAttribute = function(a, e, b, d) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.isDOE) {
                                        this.layoutConfig[this.layoutCurrent][a] = this[a] ? false : true;
                                        if (!d) {
                                            this.draw({
                                                func: "toggleAttribute",
                                                par: [a, e, b, d]
                                            })
                                        }
                                        return
                                    }
                                    this[a] = this[a] ? false : true;
                                    if (this.layoutValid && this.layoutRestore.hasOwnProperty(a)) {
                                        this.layoutRestore[a] = this[a]
                                    }
                                    if (e) {
                                        this[e](b)
                                    } else {
                                        this.draw({
                                            func: "toggleAttribute",
                                            par: [a, e, b, d]
                                        })
                                    }
                                };
                                this.changeAttributeNoDraw = function(b, a) {
                                    if (b && a) {
                                        this[b] = a;
                                        this.noDraw({
                                            func: "changeAttributeNoDraw",
                                            par: [b, a]
                                        })
                                    }
                                };
                                this.changeAttribute = function(e, m, j, l, a, f) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var h = {
                                        graphType: true
                                    };
                                    var b = m;
                                    if (CanvasXpress.doc.P[e] && CanvasXpress.doc.P[e].T == "option" && CanvasXpress.doc.P[e].O[0] != "false") {
                                        b = m
                                    } else {
                                        if (typeof(m) == "boolean" || this.hasOwnProperty(e)) {
                                            b = this[e] && this[e] == m && !j ? false : this[e] && this[e] == m && j ? j : m
                                        } else {
                                            if (e && m) {
                                                b = m
                                            }
                                        }
                                    }
                                    if (this.layoutValid && e == "graphType" && !this.isDOE) {
                                        for (var g = 0; g < this.data.l.type.length; g++) {
                                            this.data.l.type[g] = b
                                        }
                                    }
                                    if (this.layoutValid && this.layoutRestore && !this.isDOE) {
                                        delete this.layoutRestore
                                    }
                                    if (this.layoutValid || h.hasOwnProperty(e)) {
                                        this.removeMenus()
                                    }
                                    if (this.isDOE) {
                                        this.layoutConfig[this.layoutCurrent][e] = b;
                                        if (e == "sortType") {
                                            if (!this.layoutConfig[this.layoutCurrent].sortDir) {
                                                this.layoutConfig[this.layoutCurrent].sortDir = this.sortDir
                                            } else {
                                                this.layoutConfig[this.layoutCurrent].sortDir = this.layoutConfig[this.layoutCurrent].sortDir == "ascending" ? "descending" : "ascending"
                                            }
                                        }
                                        if (!f) {
                                            this.draw({
                                                func: "changeAttribute",
                                                par: [e, m, j, l, a, f],
                                                prop: {
                                                    layoutCurrent: this.iSDOE ? this.layoutCurrent : 0
                                                }
                                            })
                                        }
                                        return
                                    }
                                    if (e && e == "fontName") {
                                        if (!CanvasXpress.fonts.hasOwnProperty(m)) {
                                            return this.setFont(m)
                                        }
                                    }
                                    if (e && e == "ridgeBy") {
                                        this.resetRidgeBy()
                                    }
                                    this[e] = b;
                                    if (e == "summaryType" && this.isGroupedData) {
                                        this.regroupSamples()
                                    }
                                    if (l) {
                                        this[l](a)
                                    } else {
                                        this.draw({
                                            func: "changeAttribute",
                                            par: [e, m, j, l, a, f],
                                            prop: {
                                                layoutCurrent: this.iSDOE ? this.layoutCurrent : 0
                                            }
                                        })
                                    }
                                };
                                this.changeTextColorAttribute = function(b, a) {
                                    this.updateTextColorAttribute(b, this.$(a).value)
                                };
                                this.updateTextColorAttribute = function(b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var f = b[0];
                                    var e = b[1];
                                    var d = b[2];
                                    if (f) {
                                        if (CanvasXpress.doc.P[f] && CanvasXpress.doc.P[f].T == "integer") {
                                            this[f] = a !== "" ? parseInt(a) : null
                                        } else {
                                            if (CanvasXpress.doc.P[f] && CanvasXpress.doc.P[f].T == "float") {
                                                this[f] = a !== "" ? parseFloat(a) : null
                                            } else {
                                                if (b == "height" || b == "width") {
                                                    a = Number(a) + 18;
                                                    if (!d) {
                                                        d = [a]
                                                    }
                                                } else {
                                                    this[f] = a;
                                                    if (f.match(/[xyz]AxisTitle$/)) {
                                                        this[f + "Dynamic"] = false
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        d.unshift(a)
                                    }
                                    if (this.layoutValid && this.layoutRestore.hasOwnProperty(f)) {
                                        this.layoutRestore[f] = this[f]
                                    }
                                    if (e) {
                                        this[e](d)
                                    } else {
                                        this.setColorBrew(true);
                                        this.resetMetaData();
                                        this.draw({
                                            func: "updateTextColorAttribute",
                                            par: [b, a]
                                        })
                                    }
                                };
                                this.setFontAttributeStyle = function(b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var c = this[b];
                                    if (a == "bold") {
                                        if (this[b].match(a)) {
                                            this[b] = this[b].replace("bold", "")
                                        } else {
                                            if (c == "italic") {
                                                this[b] = "bold italic"
                                            } else {
                                                this[b] = "bold"
                                            }
                                        }
                                    } else {
                                        if (a == "italic") {
                                            if (this[b].match(a)) {
                                                this[b] = this[b].replace("italic", "")
                                            } else {
                                                if (c == "bold") {
                                                    this[b] = "bold italic"
                                                } else {
                                                    this[b] = "italic"
                                                }
                                            }
                                        } else {
                                            this[b] = this[b].replace("bold italic", "");
                                            this[b] = this[b].replace("bold", "");
                                            this[b] = this[b].replace("italic", "")
                                        }
                                    }
                                    this.draw({
                                        func: "setFontAttributeStyle",
                                        par: [b, a]
                                    })
                                };
                                this.setFontAttributeSize = function(b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (a == "increase") {
                                        this[b] = this[b] * 1.1
                                    } else {
                                        this[b] = this[b] / 1.1
                                    }
                                    this.draw({
                                        func: "setFontAttributeSize",
                                        par: [b, a]
                                    })
                                };
                                this.changeVariableInAxis = function(b, d) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.xAxis && this.xAxis2) {
                                        var c = this.getObjectArray(this.xAxis);
                                        var a = this.getObjectArray(this.xAxis2);
                                        if (d == "xAxis") {
                                            if (a[b]) {
                                                if (this.xAxis2.length > 1) {
                                                    this.removeVariablesFromAxis([b], "xAxis2")
                                                } else {
                                                    alert("Cannot remove " + b + " from X-Axis 2");
                                                    this.removeMenus();
                                                    return
                                                }
                                                this.addVariablesToAxis([b], d)
                                            } else {
                                                if (c[b]) {
                                                    if (this.xAxis.length > 1) {
                                                        this.removeVariablesFromAxis([b], d)
                                                    } else {
                                                        alert("Cannot remove " + b + " from X-Axis");
                                                        this.removeMenus();
                                                        return
                                                    }
                                                } else {
                                                    this.addVariablesToAxis([b], d)
                                                }
                                            }
                                        } else {
                                            if (d == "xAxis2") {
                                                if (c[b]) {
                                                    if (this.xAxis.length > 1) {
                                                        this.removeVariablesFromAxis([b], "xAxis")
                                                    } else {
                                                        alert("Cannot remove " + b + " from X-Axis");
                                                        this.removeMenus();
                                                        return
                                                    }
                                                    this.addVariablesToAxis([b], d)
                                                } else {
                                                    if (a[b]) {
                                                        if (this.xAxis2.length > 1) {
                                                            this.removeVariablesFromAxis([b], d)
                                                        } else {
                                                            alert("Cannot remove " + b + " from X-Axis 2");
                                                            this.removeMenus();
                                                            return
                                                        }
                                                    } else {
                                                        this.addVariablesToAxis([b], d)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    this.draw({
                                        func: "changeVariableInAxis",
                                        par: [b, d]
                                    })
                                };
                                this.changeSampleInAxis = function(e, f, b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.graphType.match(/Scatter/)) {
                                        var c, a, g, d;
                                        c = this.getObjectArray(this.xAxis);
                                        a = this.getObjectArray(this.yAxis);
                                        if (this.graphType == "ScatterBubble2D" || this.graphType == "Scatter3D") {
                                            g = this.getObjectArray(this.zAxis);
                                            d = true
                                        }
                                        if (f == "xAxis") {
                                            if (b) {
                                                this.switchSampleInAxis([e], f)
                                            } else {
                                                if (a[e] && !d) {
                                                    if (this.yAxis.length > 1) {
                                                        this.removeSamplesFromAxis([e], "yAxis")
                                                    } else {
                                                        alert("Cannot remove " + e + " from Y-Axis");
                                                        this.removeMenus();
                                                        return
                                                    }
                                                    this.addSamplesToAxis([e], f)
                                                } else {
                                                    if (g && g[e] && !d) {
                                                        if (this.zAxis.length > 1) {
                                                            this.removeSamplesFromAxis([e], "zAxis")
                                                        } else {
                                                            alert("Cannot remove " + e + " from Z-Axis");
                                                            this.removeMenus();
                                                            return
                                                        }
                                                    } else {
                                                        if (c[e] && !d) {
                                                            if (this.xAxis.length > 1) {
                                                                this.removeSamplesFromAxis([e], f)
                                                            } else {
                                                                alert("Cannot remove " + e + " from X-Axis");
                                                                this.removeMenus();
                                                                return
                                                            }
                                                        } else {
                                                            if (d) {
                                                                this[f] = [];
                                                                this.addSamplesToAxis([e], f)
                                                            } else {
                                                                this.addSamplesToAxis([e], f)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (f == "yAxis") {
                                                if (b) {
                                                    this.switchSampleInAxis([e], f)
                                                } else {
                                                    if (c[e] && !d) {
                                                        if (this.xAxis.length > 1) {
                                                            this.removeSamplesFromAxis([e], "xAxis")
                                                        } else {
                                                            alert("Cannot remove " + e + " from X-Axis");
                                                            this.removeMenus();
                                                            return
                                                        }
                                                        this.addSamplesToAxis([e], f)
                                                    } else {
                                                        if (g && g[e] && !d) {
                                                            if (this.zAxis.length > 1) {
                                                                this.removeSamplesFromAxis([e], "zAxis")
                                                            } else {
                                                                alert("Cannot remove " + e + " from Z-Axis");
                                                                this.removeMenus();
                                                                return
                                                            }
                                                        } else {
                                                            if (a[e] && !d) {
                                                                if (this.yAxis.length > 1) {
                                                                    this.removeSamplesFromAxis([e], f)
                                                                } else {
                                                                    alert("Cannot remove " + e + " from Y-Axis");
                                                                    this.removeMenus();
                                                                    return
                                                                }
                                                            } else {
                                                                if (d) {
                                                                    this[f] = [];
                                                                    this.addSamplesToAxis([e], f)
                                                                } else {
                                                                    this.addSamplesToAxis([e], f)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (f == "zAxis") {
                                                    if (b) {
                                                        this.switchSampleInAxis([e], f)
                                                    } else {
                                                        if (c[e] && !d) {
                                                            if (this.xAxis.length > 1) {
                                                                this.removeSamplesFromAxis([e], "xAxis")
                                                            } else {
                                                                alert("Cannot remove " + e + " from X-Axis");
                                                                this.removeMenus();
                                                                return
                                                            }
                                                            this.addSamplesToAxis([e], f)
                                                        } else {
                                                            if (a[e] && !d) {
                                                                if (this.yAxis.length > 1) {
                                                                    this.removeSamplesFromAxis([e], "yAxis")
                                                                } else {
                                                                    alert("Cannot remove " + e + " from Y-Axis");
                                                                    this.removeMenus();
                                                                    return
                                                                }
                                                            } else {
                                                                if (g[e] && !d) {
                                                                    if (this.zAxis.length > 1) {
                                                                        this.removeSamplesFromAxis([e], f)
                                                                    } else {
                                                                        alert("Cannot remove " + e + " from Z-Axis");
                                                                        this.removeMenus();
                                                                        return
                                                                    }
                                                                } else {
                                                                    if (d) {
                                                                        this[f] = [];
                                                                        this.addSamplesToAxis([e], f)
                                                                    } else {
                                                                        this.addSamplesToAxis([e], f)
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.draw({
                                            func: "changeSampleInAxis",
                                            par: [e, f, b]
                                        })
                                    }
                                };
                                this.modifyOncoprintNoAlterations = function() {
                                    var a = {
                                        sample: {
                                            "Altered-Smps": {
                                                min: 1
                                            }
                                        },
                                        variable: {
                                            "Altered-Vars": {
                                                min: 1
                                            }
                                        }
                                    };
                                    if (this.oncoprintNoAlterations) {
                                        this.resetDataFilter(false, false, false, this.oncoprintVarIndices, this.oncoprintSmpIndices);
                                        this.hideUnhideDataTable(true);
                                        this.oncoprintVarIndices = false;
                                        this.oncoprintSmpIndices = false
                                    } else {
                                        this.oncoprintVarIndices = this.cloneObject(this.varIndices);
                                        this.oncoprintSmpIndices = this.cloneObject(this.smpIndices);
                                        this.toDoFilter = a;
                                        this.updateDataFilter(true, true)
                                    }
                                };
                                this.modifySort = function(h, w, u, f, d, r) {
                                    var l = this;
                                    if (this.isDOE && !r) {
                                        this.layoutConfig[this.layoutCurrent].sortData = [
                                            [h, w, u]
                                        ];
                                        this.draw({
                                            func: "modifySort",
                                            par: [h, w, u, f, d, r]
                                        });
                                        return
                                    }
                                    var g = ["sortingSampleCategories", "sortingVariables"];
                                    var b = ["sortingVariableCategories", "sortingSamples"];
                                    var m = w == "smp" ? g : b;
                                    m = h == "cat" ? [m[0]] : [m[1]];
                                    if (!this.sortingSampleCategories) {
                                        this.sortingSampleCategories = []
                                    }
                                    if (!this.sortingVariableCategories) {
                                        this.sortingVariableCategories = []
                                    }
                                    var s = function(p, k) {
                                        var n = [];
                                        for (var o = 0; o < l[p].length; o++) {
                                            if (l[p][o] != k) {
                                                n.push(l[p][o])
                                            }
                                        }
                                        if (n.length > 0) {
                                            l[p] = n
                                        } else {}
                                    };
                                    var a = function(k, i) {
                                        if (l[k].length < 3) {
                                            l[k].push(u)
                                        } else {
                                            l.removeMenus();
                                            alert("Maximum of three sorting levels reached")
                                        }
                                    };
                                    if (u != "samples" && u != "variables" && h != "both") {
                                        for (var j = 0; j < m.length; j++) {
                                            if (!this[m[j]]) {
                                                this[m[j]] = []
                                            }
                                            var e = this.getObjectArray(this[m[j]]);
                                            var c = null;
                                            if (m[j] == "sortingVariables") {
                                                c = this.getVariableIndices(u)
                                            } else {
                                                if (m[j] == "sortingSamples") {
                                                    c = this.getSampleIndices(u)
                                                }
                                            }
                                            if (c != null && c < 0) {
                                                c = null
                                            }
                                            if (e.hasOwnProperty(c != null ? c + 1 : u)) {
                                                s(m[j], c != null ? c + 1 : u)
                                            } else {
                                                a(m[j], c != null ? c + 1 : u)
                                            }
                                        }
                                    }
                                    if (h == "both") {
                                        var q = this.sortingSampleCategories && this.sortingSampleCategories.length && this.sortingVariableCategories && this.sortingVariableCategories.length;
                                        if (q) {
                                            this.sortSamplesByCategory(this.sortingSampleCategories, true);
                                            this.sortVariablesByCategory(this.sortingVariableCategories, f)
                                        } else {
                                            if (this.sortingSampleCategories && this.sortingSampleCategories.length) {
                                                this.sortSamplesByCategory(this.sortingSampleCategories, false, f)
                                            } else {
                                                if (this.sortingVariableCategories && this.sortingVariableCategories.length) {
                                                    this.sortVariablesByCategory(this.sortingVariableCategories, f)
                                                } else {
                                                    this.sortSamples(false, false, false, false, true);
                                                    this.sortVariables(false, false, false, false, f)
                                                }
                                            }
                                        }
                                    } else {
                                        if (w == "smp") {
                                            if (h == "cat") {
                                                this.sortSamplesByCategory(this.sortingSampleCategories, f)
                                            } else {
                                                if (h == "var") {
                                                    this.sortSamplesByVariable(this.sortingVariables, false, f)
                                                } else {
                                                    if (u == "samples") {
                                                        this.sortSamples(false, false, false, false, f)
                                                    }
                                                }
                                            }
                                        } else {
                                            if (w == "var") {
                                                if (h == "cat") {
                                                    this.sortVariablesByCategory(this.sortingVariableCategories, f)
                                                } else {
                                                    if (h == "smp") {
                                                        this.sortVariablesBySample(this.sortingSamples, f)
                                                    } else {
                                                        if (u == "variables") {
                                                            this.sortVariables(false, false, false, false, f)
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (h[0] == "varIndex" || h[0] == "smpIndex" || h[0] == "grpIndex") {
                                                    this.sortDir = this.sortDir == "ascending" ? "descending" : "ascending";
                                                    if (h == "varIndex") {
                                                        this.sortVariables(this.sortDir, false, false, h[0], f)
                                                    } else {
                                                        this.sortSamples(this.sortDir, false, false, h[0], f)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (d) {
                                        this.resortData()
                                    }
                                };
                                this.sortSamples = function(f, h, e, b, g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.sortIndices("smps", f, h, false, e, b);
                                    this.setOriginalIndices(false, false, false, true);
                                    if (!g) {
                                        this.draw({
                                            func: "sortSamples",
                                            par: [f, h, e, b, g],
                                            prop: {
                                                sortDir: this.sortDir
                                            }
                                        })
                                    }
                                };
                                this.sortSamplesByCategory = function(b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.sortIndices("smps", false, b);
                                    this.setOriginalIndices(false, false, false, true);
                                    if (!a) {
                                        this.draw({
                                            func: "sortSamplesByCategory",
                                            par: [b, a],
                                            prop: {
                                                sortDir: this.sortDir
                                            }
                                        })
                                    }
                                };
                                this.sortSamplesByVariable = function(c, b, e) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var d = parseInt(this.getVariableIndices(c));
                                    this.sortIndices("smps", false, false, false, d + 1, b);
                                    this.setOriginalIndices(false, false, false, true);
                                    if (!e) {
                                        this.draw({
                                            func: "sortSamplesByVariable",
                                            par: [c, b, e],
                                            prop: {
                                                sortDir: this.sortDir
                                            }
                                        })
                                    }
                                };
                                this.sortVariables = function(f, h, e, b, g) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.sortIndices("vars", f, h, e, false, b, g);
                                    this.setOriginalIndices(false, false, false, true);
                                    if (!g) {
                                        this.draw({
                                            func: "sortVariables",
                                            par: [f, h, e, b, g],
                                            prop: {
                                                sortDir: this.sortDir
                                            }
                                        })
                                    }
                                };
                                this.sortVariablesByCategory = function(b, a) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    this.sortIndices("vars", false, b);
                                    this.setOriginalIndices(false, false, false, true);
                                    if (!a) {
                                        this.draw({
                                            func: "sortVariablesByCategory",
                                            par: [b, a],
                                            prop: {
                                                sortDir: this.sortDir
                                            }
                                        })
                                    }
                                };
                                this.sortVariablesBySample = function(b, c) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var a = parseInt(this.getSampleIndices(b));
                                    this.sortIndices("vars", false, false, a + 1);
                                    this.setOriginalIndices(false, false, false, true);
                                    if (!c) {
                                        this.draw({
                                            func: "sortVariablesBySample",
                                            par: [b, c],
                                            prop: {
                                                sortDir: this.sortDir
                                            }
                                        })
                                    }
                                };
                                this.showConfiguratorCategory = function(b, a) {
                                    this.removeMenus();
                                    this.addConfigurator(b);
                                    this.clickSearch(b);
                                    this.changeCategory(b, false, a);
                                    this.hideCategories()
                                };
                                this.rebuildDataTableFilter = function(c, h) {
                                    if (this.graphType.match(/Scatter/) && (this.showLoessFit || this.isContour)) {
                                        return
                                    }
                                    if (c) {
                                        var j = this;
                                        if (c[3] && !h) {
                                            j.resetDataExplorer()
                                        }
                                        setTimeout(function() {
                                            if (c[0]) {
                                                j.clickLayout(false, function() {
                                                    j.activeAccordion = false;
                                                    j.activateAccordion(false, j.$(j.target + "-cX-DataFilterVariableHeader"))
                                                })
                                            } else {
                                                if (c[1]) {
                                                    j.clickDataFilters()
                                                }
                                                if (c[2]) {
                                                    j.clickDataTable()
                                                }
                                            }
                                        }, 2000)
                                    } else {
                                        var j = this;
                                        var f = this.$(this.target + "-cX-DataFilter");
                                        var i = f && f.style.display == "block" ? true : false;
                                        var d = this.$(this.target + "-cX-DataTable");
                                        var a = this.dataTableLastState;
                                        var g = this.$(this.target + "-cX-DataExplorer");
                                        var e = g ? true : false;
                                        var b = this.appLayout;
                                        if (b) {
                                            this.clickLayout()
                                        } else {
                                            if (i) {
                                                this.hideDataFilter()
                                            }
                                            if (a) {
                                                this.hideTable()
                                            }
                                        }
                                        setTimeout(function() {
                                            if (a) {
                                                j.rebuildDataTable()
                                            }
                                            if (i) {
                                                j.rebuildDataFilter()
                                            }
                                        }, 500);
                                        return [b, i, a, e]
                                    }
                                }
                            };
                            CanvasXpress.prototype.initRandom = function() {
                                this.round = function(a, b) {
                                    return Number(Math.round(a + "e" + b) + "e-" + b)
                                };
                                this.createRandomData = function(c, h) {
                                    var k = this;
                                    var v = {};
                                    var s = {};
                                    var e = [];
                                    var g = [];
                                    var f = [];
                                    var d = [];
                                    if (this.graphType == "Network") {
                                        v = this.createRandomNetwork()
                                    } else {
                                        if (this.graphType == "Venn") {
                                            v = this.createRandomVenn()
                                        } else {
                                            if (this.graphType == "Genome") {
                                                v = this.createRandomGenome()
                                            } else {
                                                var r = function() {
                                                    var x = (k.randomDataMax - k.randomDataMin) / 4;
                                                    var n = [];
                                                    var A = 0;
                                                    for (var z = 0; z < 4; z++) {
                                                        n.push(z * x);
                                                        e.push([k.round(Math.max(k.randomDataMin, A - (x * 0.15)), 0), k.round(Math.min(A + (x * 1.15), k.randomDataMax), 0)]);
                                                        A += x
                                                    }
                                                    var B = 0;
                                                    for (var z = 0; z < 2; z++) {
                                                        for (var y = 0; y < 2; y++) {
                                                            s[z + ":" + y] = B;
                                                            B++
                                                        }
                                                    }
                                                };
                                                var l = function(E, C) {
                                                    var D = [];
                                                    if (E) {
                                                        for (var z = 0; z < E; z++) {
                                                            D.push(k.randomBetween(k.randomDataMin, k.randomDataMax))
                                                        }
                                                        return D
                                                    } else {
                                                        switch (k.randomDataDistribution) {
                                                            case "biased":
                                                                for (var z = 0; z < k.randomDataVariables; z++) {
                                                                    var x = v.z ? v.z.Annt1[z].split(":")[1] - 1 : 0;
                                                                    for (var y = 0; y < k.randomDataSamples; y++) {
                                                                        var A = v.x ? v.x.Factor1[y].split(":")[1] - 1 : 0;
                                                                        var B = e[s[x + ":" + A]];
                                                                        if (C) {
                                                                            D.push(k.randomIntBetween(B[0], B[1]))
                                                                        } else {
                                                                            D.push(k.round(k.randomBetween(B[0], B[1]), 2))
                                                                        }
                                                                    }
                                                                }
                                                                return D;
                                                            case "range":
                                                                for (var z = 0; z < k.randomDataVariables; z++) {
                                                                    for (var y = 0; y < k.randomDataSamples; y++) {
                                                                        if (C) {
                                                                            D.push(k.randomIntBetween(k.randomDataMin, k.randomDataMax))
                                                                        } else {
                                                                            D.push(k.round(k.randomBetween(k.randomDataMin, k.randomDataMax), 2))
                                                                        }
                                                                    }
                                                                }
                                                                return D;
                                                            case "normal":
                                                                return k.rnorm(k.randomDataVariables * k.randomDataSamples, k.randomDataMean, k.randomDataSigma);
                                                            case "uniform":
                                                                for (var z = 0; z < k.randomDataVariables; z++) {
                                                                    for (var y = 0; y < k.randomDataSamples; y++) {
                                                                        D.push(100)
                                                                    }
                                                                }
                                                                return D;
                                                            case "symmetrical":
                                                                for (var z = 0; z < k.randomDataVariables; z++) {
                                                                    for (var y = 0; y < k.randomDataSamples; y++) {
                                                                        D.push((z * 10) + ((y + 1) * 5))
                                                                    }
                                                                }
                                                                return D
                                                        }
                                                    }
                                                };
                                                r();
                                                if (this.randomDataVariableAnnotations > 0) {
                                                    v.z = {}
                                                }
                                                for (var q = 0; q < this.randomDataVariableAnnotations; q++) {
                                                    var b = l(this.randomDataVariables, q % 2);
                                                    v.z["Annt" + (q + 1)] = [];
                                                    v.z["VCov" + (q + 1)] = [];
                                                    for (var p = 0; p < this.randomDataVariables; p++) {
                                                        v.z["Annt" + (q + 1)][p] = "Desc:" + this.randomIntBetween(1, q + 2);
                                                        v.z["VCov" + (q + 1)][p] = b[p]
                                                    }
                                                }
                                                if (this.randomDataSampleAnnotations > 0) {
                                                    v.x = {}
                                                }
                                                for (var q = 0; q < this.randomDataSampleAnnotations; q++) {
                                                    var b = l(this.randomDataSamples, q % 2);
                                                    v.x["Factor" + (q + 1)] = [];
                                                    v.x["SCovar" + (q + 1)] = [];
                                                    for (var p = 0; p < this.randomDataSamples; p++) {
                                                        v.x["Factor" + (q + 1)][p] = "Lev:" + this.randomIntBetween(1, q + 2);
                                                        v.x["SCovar" + (q + 1)][p] = b[p]
                                                    }
                                                }
                                                v.y = {};
                                                v.y.data = [];
                                                v.y.vars = [];
                                                v.y.smps = [];
                                                for (var q = 0; q < this.randomDataSamples; q++) {
                                                    if (this.randomDataTime) {
                                                        v.y.smps[q] = new Date(this.meta.time.start + (q * this.times.day))
                                                    } else {
                                                        v.y.smps[q] = "S" + (q + 1)
                                                    }
                                                }
                                                var u = l();
                                                var a = c ? l() : false;
                                                var w = ["A", "B", "C", "D", "E", "F"];
                                                var o = 0;
                                                for (var q = 0; q < this.randomDataVariables; q++) {
                                                    v.y.data[q] = [];
                                                    v.y.vars[q] = "V" + (q + 1);
                                                    g[q] = [];
                                                    f[q] = [];
                                                    d[q] = [];
                                                    for (var p = 0; p < this.randomDataSamples; p++) {
                                                        v.y.data[q][p] = this.round(u[o], 2);
                                                        if (c) {
                                                            g[q][p] = this.round(a[o], 2);
                                                            f[q][p] = w[parseInt(this.random() * 5)];
                                                            d[q][p] = w[parseInt(this.random() * 2)]
                                                        }
                                                        o++
                                                    }
                                                }
                                                if (c) {
                                                    v.y.data2 = g;
                                                    v.y.data3 = f;
                                                    v.y.data4 = d
                                                }
                                                if (this.randomMissingDataPercentage > 0 && this.randomMissingDataPercentage < 1) {
                                                    var m = 0;
                                                    var t = this.randomDataVariables * this.randomDataSamples * this.randomMissingDataPercentage;
                                                    while (m < t) {
                                                        var q = Math.floor(this.random() * this.randomDataVariables);
                                                        var p = Math.floor(this.random() * this.randomDataSamples);
                                                        if (v.y.data[q][p] != null) {
                                                            v.y.data[q][p] = null;
                                                            m++
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (h) {
                                        return v
                                    }
                                    if (this.graphType == "Network") {
                                        this.calculateLayout = true;
                                        this.isLayoutDone = false
                                    }
                                    this.randomData = true;
                                    if (this.data && !this.dataStndBy) {
                                        this.dataStndBy = this.data;
                                        this.configStndBy = this.getConfig();
                                        this.data = {}
                                    }
                                    if (v) {
                                        this.resetConfig(["graphType"]);
                                        this.updateData(v, true)
                                    }
                                };
                                this.restoreRandomData = function() {
                                    this.switchData(true)
                                };
                                this.createRandomFunction = function() {
                                    return {
                                        fx: "sin(2y) * cos(3x) / sec(xy)"
                                    }
                                };
                                this.createRandomSankey = function() {
                                    return {
                                        y: {
                                            vars: ["Weight"],
                                            smps: ["S1", "S2", "S3", "S4", "S5", "S6"],
                                            data: [
                                                [5, 7, 6, 2, 9, 4]
                                            ]
                                        },
                                        x: {
                                            Source: ["A", "A", "A", "B", "B", "B"],
                                            Target: ["X", "Y", "Z", "X", "Y", "Z"],
                                            Source2: ["B", "A", "A", "A", "B", "B"],
                                            Target2: ["Y", "Y", "Z", "X", "X", "Z"],
                                            Weight: [1, 2, 3, 4, 5, 6]
                                        }
                                    }
                                };
                                this.createRandomCircular = function(e) {
                                    var c = this.getDataSet(e.replace(/RandomCircular2/, "Random").replace(/RandomCircular/, "Random"));
                                    if (!c.z) {
                                        c.z = {}
                                    }
                                    c.z.Ring = [];
                                    for (var a = 0; a < c.y.vars.length; a++) {
                                        c.z.Ring.push(this.randomIntBetween(1, 3))
                                    }
                                    if (e.match(/RandomCircular2/)) {
                                        c.z.Ring.push(-1);
                                        c.y.vars.push("Number");
                                        var b = [];
                                        for (var a = 0; a < c.y.smps.length; a++) {
                                            b.push(a + 1)
                                        }
                                        c.y.data.push(b)
                                    }
                                    return c
                                };
                                this.createRandomChord = function() {
                                    return {
                                        y: {
                                            vars: ["A", "B", "C", "D"],
                                            smps: ["A", "B", "C", "D"],
                                            data: [
                                                [11975, 5871, 8916, 2868],
                                                [1951, 10048, 2060, 6171],
                                                [8010, 16145, 8090, 8045],
                                                [1013, 990, 940, 6907]
                                            ]
                                        }
                                    }
                                };
                                this.createRandomIdeogram = function(p) {
                                    var g = CanvasXpress.chromosomes.hg19;
                                    var l = p ? this.getDataSet(p.replace(/RandomIdeogram/, "Random")) : this.getDataSet("Random:200:10:4:4");
                                    var b = 20000000;
                                    if (!l.z) {
                                        l.z = {}
                                    }
                                    l.z.chr = [];
                                    l.z.pos = [];
                                    for (var f = 0; f < g.order.length; f++) {
                                        var o = g.order[f];
                                        var a = g.data[o][g.data[o].length - 1][1];
                                        var p = Math.ceil(a / b);
                                        for (var e = 0; e < p; e++) {
                                            if (l.z.chr.length < l.y.vars.length) {
                                                l.z.chr.push(o);
                                                l.z.pos.push(this.randomIntBetween(1, a))
                                            } else {
                                                break
                                            }
                                        }
                                    }
                                    while (l.z.chr.length < l.y.vars.length) {
                                        var o = g.order[this.randomIntBetween(0, 23)];
                                        var a = g.data[o][g.data[o].length - 1][1];
                                        l.z.chr.push(o);
                                        l.z.pos.push(this.randomIntBetween(1, a))
                                    }
                                    return l
                                };
                                this.createRandomNonLinearFit = function() {
                                    return {
                                        y: {
                                            vars: ["S1", "S2", "S3", "S4", "S5", "S6", "S7", "S8", "S9", "S10", "S11", "S12"],
                                            smps: ["Concentration", "V1"],
                                            data: [
                                                [0.0009, 172],
                                                [0.0018, 177],
                                                [0.0037, 160],
                                                [0.0073, 166],
                                                [0.0146, 211],
                                                [0.0293, 248],
                                                [0.0586, 269],
                                                [0.117, 283],
                                                [0.234, 298],
                                                [0.469, 314],
                                                [0.938, 328],
                                                [1.88, 316]
                                            ]
                                        }
                                    }
                                };
                                this.createRandomKaplanMeier = function() {
                                    return {
                                        y: {
                                            vars: ["p1", "p2", "p3", "p4", "p5", "p6", "p7", "p8", "p9", "p10", "p11", "p12", "p13", "p14", "p15", "p16", "p17", "p18", "p19", "p20"],
                                            smps: ["Time", "Censored-1", "Censored-2"],
                                            data: [
                                                [1, 0, 1],
                                                [2, 0, 1],
                                                [3, 0, 1],
                                                [3, 0, 1],
                                                [1, 1, 1],
                                                [2, 1, 1],
                                                [2, 1, 2],
                                                [3, 1, 1],
                                                [3, 1, 1],
                                                [4, 0, 0],
                                                [5, 0, 0],
                                                [6, 0, 0],
                                                [6, 0, 0],
                                                [7, 1, 0],
                                                [8, 0, 1],
                                                [9, 0, 0],
                                                [9, 0],
                                                [9, 0],
                                                [10, 1],
                                                [11, 1]
                                            ]
                                        },
                                        z: {
                                            grp: ["A", "B", "A", "B", "A", "B", "A", "B", "A", "B", "A", "B", "A", "B", "A", "B", "A", "B", "A", "B"],
                                            cls: ["A", "A", "A", "A", "A", "A", "A", "A", "A", "B", "B", "B", "B", "B", "B", "B", "B", "B", "B", "B"]
                                        }
                                    }
                                };
                                this.createRandomVenn = function() {
                                    return {
                                        venn: {
                                            data: {
                                                A: 340,
                                                B: 562,
                                                C: 620,
                                                D: 592,
                                                AB: 639,
                                                AC: 456,
                                                AD: 257,
                                                BC: 915,
                                                BD: 354,
                                                CD: 143,
                                                ABC: 552,
                                                ABD: 578,
                                                ACD: 298,
                                                BCD: 613,
                                                ABCD: 148
                                            },
                                            legend: {
                                                A: "List1",
                                                B: "List2",
                                                C: "List3",
                                                D: "List4"
                                            }
                                        }
                                    }
                                };
                                this.createRandomNetwork = function() {
                                    var p = this;
                                    var b = function() {
                                        for (var j = 0; j < p.randomNetworkNodes; j++) {
                                            var k = Math.floor(p.random() * p.randomNetworkNodeEdgesMax);
                                            if (!e.hasOwnProperty(j)) {
                                                e[j] = 0
                                            }
                                            if (e[j] > 3 || !p.randomNetworkReduce) {
                                                while (e[j] < k) {
                                                    var c = Math.floor(p.random() * p.randomNetworkNodes);
                                                    if (c != j && !a[c + ":" + j] && !a[j + ":" + c]) {
                                                        if (!e.hasOwnProperty(c)) {
                                                            e[c] = 0
                                                        }
                                                        f.push([c, j]);
                                                        if (!e.hasOwnProperty(c)) {
                                                            e[c] = 0
                                                        }
                                                        if (!e.hasOwnProperty(j)) {
                                                            e[j] = 0
                                                        }
                                                        e[c]++;
                                                        e[j]++;
                                                        a[c + ":" + j] = true;
                                                        a[j + ":" + c] = true
                                                    }
                                                }
                                            }
                                        }
                                    };
                                    var C = function(j, c) {
                                        var i = p.randomNetworkAll && !g ? Math.floor(p.random() * p.shapes.length) : 0;
                                        if (p.shapes[i] == "image") {
                                            i = 0
                                        }
                                        j.shape = p.shapes[i];
                                        j.color = p.randomNetworkAll && !g ? p.colors[Math.floor(p.random() * p.colors.length)] : "lightblue";
                                        j.size = 1;
                                        if (g) {
                                            if (c) {
                                                j.label = c
                                            }
                                            return
                                        }
                                        j.type = "Type" + Math.ceil(p.random() * 3);
                                        j.D1 = Math.floor(p.random() * 4);
                                        j.D2 = Math.floor(p.random() * 6);
                                        j.D3 = Math.floor(p.random() * 8);
                                        j.D4 = {
                                            Da: Math.floor(p.random() * 1),
                                            Db: Math.floor(p.random() * 5),
                                            Dc: Math.floor(p.random() * 10)
                                        };
                                        j.D5 = {
                                            Da: Math.floor(p.random() * 10),
                                            Db: Math.floor(p.random() * 1),
                                            Dc: Math.floor(p.random() * 5)
                                        }
                                    };
                                    var F = function(j) {
                                        j.color = p.randomNetworkAll && !g ? p.colors[Math.floor(p.random() * p.colors.length)] : "black";
                                        j.width = 1;
                                        j.type = "line";
                                        if (!g) {
                                            j.kind = "Type" + Math.ceil(p.random() * 3)
                                        }
                                        if (p.randomNetworkAll && !g) {
                                            j.type = p.lines[Math.floor(p.random() * p.lines.length)];
                                            var c = Math.floor(p.random() * 6);
                                            var i = Math.floor(p.random() * 6);
                                            if (c < 3) {
                                                j.startArrow = p.arrows[c]
                                            }
                                            if (i < 3) {
                                                j.endArrow = p.arrows[i]
                                            }
                                        }
                                    };
                                    var J = {
                                        nodes: [],
                                        edges: []
                                    };
                                    var e = {};
                                    var a = {};
                                    var w = [];
                                    var f = [];
                                    var G = [
                                        [1, 0],
                                        [2, 0],
                                        [2, 1],
                                        [3, 0],
                                        [3, 1],
                                        [3, 2],
                                        [4, 0],
                                        [5, 0],
                                        [6, 0],
                                        [6, 4],
                                        [6, 5],
                                        [7, 0],
                                        [7, 1],
                                        [7, 2],
                                        [7, 3],
                                        [8, 0],
                                        [8, 2],
                                        [9, 2],
                                        [10, 0],
                                        [10, 4],
                                        [10, 5],
                                        [11, 0],
                                        [12, 0],
                                        [12, 3],
                                        [13, 0],
                                        [13, 1],
                                        [13, 2],
                                        [13, 3],
                                        [16, 5],
                                        [16, 6],
                                        [17, 0],
                                        [17, 1],
                                        [19, 0],
                                        [19, 1],
                                        [21, 0],
                                        [21, 1],
                                        [25, 23],
                                        [25, 24],
                                        [27, 2],
                                        [27, 23],
                                        [27, 24],
                                        [28, 2],
                                        [29, 23],
                                        [29, 26],
                                        [30, 1],
                                        [30, 8],
                                        [31, 0],
                                        [31, 24],
                                        [31, 25],
                                        [31, 28],
                                        [32, 2],
                                        [32, 8],
                                        [32, 14],
                                        [32, 15],
                                        [32, 18],
                                        [32, 20],
                                        [32, 22],
                                        [32, 23],
                                        [32, 29],
                                        [32, 30],
                                        [32, 31],
                                        [33, 8],
                                        [33, 9],
                                        [33, 13],
                                        [33, 14],
                                        [33, 15],
                                        [33, 18],
                                        [33, 19],
                                        [33, 20],
                                        [33, 22],
                                        [33, 23],
                                        [33, 26],
                                        [33, 27],
                                        [33, 28],
                                        [33, 29],
                                        [33, 30],
                                        [33, 31],
                                        [33, 32]
                                    ];
                                    var q = ["Myriel", "Napoleon", "MlleBaptistine", "MmeMagloire", "CountessDeLo", "Geborand", "Champtercier", "Cravatte", "Count", "OldMan", "Labarre", "Valjean", "Marguerite", "MmeDeR", "Isabeau", "Gervais", "Tholomyes", "Listolier", "Fameuil", "Blacheville", "Favourite", "Dahlia", "Zephine", "Fantine", "MmeThenardier", "Thenardier", "Cosette", "Javert", "Fauchelevent", "Bamatabois", "Perpetue", "Simplice", "Scaufflaire", "Woman1", "Judge", "Champmathieu", "Brevet", "Chenildieu", "Cochepaille", "Pontmercy", "Boulatruelle", "Eponine", "Anzelma", "Woman2", "MotherInnocent", "Gribier", "Jondrette", "MmeBurgon", "Gavroche", "Gillenormand", "Magnon", "MlleGillenormand", "MmePontmercy", "MlleVaubois", "LtGillenormand", "Marius", "BaronessT", "Mabeuf", "Enjolras", "Combeferre", "Prouvaire", "Feuilly", "Courfeyrac", "Bahorel", "Bossuet", "Joly", "Grantaire", "MotherPlutarch", "Gueulemer", "Babet", "Claquesous", "Montparnasse", "Toussaint", "Child1", "Child2", "Brujon", "MmeHucheloup"];
                                    var E = [
                                        [1, 0],
                                        [2, 0],
                                        [3, 0],
                                        [3, 2],
                                        [4, 0],
                                        [5, 0],
                                        [6, 0],
                                        [7, 0],
                                        [8, 0],
                                        [9, 0],
                                        [11, 10],
                                        [11, 3],
                                        [11, 2],
                                        [11, 0],
                                        [12, 11],
                                        [13, 11],
                                        [14, 11],
                                        [15, 11],
                                        [17, 16],
                                        [18, 16],
                                        [18, 17],
                                        [19, 16],
                                        [19, 17],
                                        [19, 18],
                                        [20, 16],
                                        [20, 17],
                                        [20, 18],
                                        [20, 19],
                                        [21, 16],
                                        [21, 17],
                                        [21, 18],
                                        [21, 19],
                                        [21, 20],
                                        [22, 16],
                                        [22, 17],
                                        [22, 18],
                                        [22, 19],
                                        [22, 20],
                                        [22, 21],
                                        [23, 16],
                                        [23, 17],
                                        [23, 18],
                                        [23, 19],
                                        [23, 20],
                                        [23, 21],
                                        [23, 22],
                                        [23, 12],
                                        [23, 11],
                                        [24, 23],
                                        [24, 11],
                                        [25, 24],
                                        [25, 23],
                                        [25, 11],
                                        [26, 24],
                                        [26, 11],
                                        [26, 16],
                                        [26, 25],
                                        [27, 11],
                                        [27, 23],
                                        [27, 25],
                                        [27, 24],
                                        [27, 26],
                                        [28, 11],
                                        [28, 27],
                                        [29, 23],
                                        [29, 27],
                                        [29, 11],
                                        [30, 23],
                                        [31, 30],
                                        [31, 11],
                                        [31, 23],
                                        [31, 27],
                                        [32, 11],
                                        [33, 11],
                                        [33, 27],
                                        [34, 11],
                                        [34, 29],
                                        [35, 11],
                                        [35, 34],
                                        [35, 29],
                                        [36, 34],
                                        [36, 35],
                                        [36, 11],
                                        [36, 29],
                                        [37, 34],
                                        [37, 35],
                                        [37, 36],
                                        [37, 11],
                                        [37, 29],
                                        [38, 34],
                                        [38, 35],
                                        [38, 36],
                                        [38, 37],
                                        [38, 11],
                                        [38, 29],
                                        [39, 25],
                                        [40, 25],
                                        [41, 24],
                                        [41, 25],
                                        [42, 41],
                                        [42, 25],
                                        [42, 24],
                                        [43, 11],
                                        [43, 26],
                                        [43, 27],
                                        [44, 28],
                                        [44, 11],
                                        [45, 28],
                                        [47, 46],
                                        [48, 47],
                                        [48, 25],
                                        [48, 27],
                                        [48, 11],
                                        [49, 26],
                                        [49, 11],
                                        [50, 49],
                                        [50, 24],
                                        [51, 49],
                                        [51, 26],
                                        [51, 11],
                                        [52, 51],
                                        [52, 39],
                                        [53, 51],
                                        [54, 51],
                                        [54, 49],
                                        [54, 26],
                                        [55, 51],
                                        [55, 49],
                                        [55, 39],
                                        [55, 54],
                                        [55, 26],
                                        [55, 11],
                                        [55, 16],
                                        [55, 25],
                                        [55, 41],
                                        [55, 48],
                                        [56, 49],
                                        [56, 55],
                                        [57, 55],
                                        [57, 41],
                                        [57, 48],
                                        [58, 55],
                                        [58, 48],
                                        [58, 27],
                                        [58, 57],
                                        [58, 11],
                                        [59, 58],
                                        [59, 55],
                                        [59, 48],
                                        [59, 57],
                                        [60, 48],
                                        [60, 58],
                                        [60, 59],
                                        [61, 48],
                                        [61, 58],
                                        [61, 60],
                                        [61, 59],
                                        [61, 57],
                                        [61, 55],
                                        [62, 55],
                                        [62, 58],
                                        [62, 59],
                                        [62, 48],
                                        [62, 57],
                                        [62, 41],
                                        [62, 61],
                                        [62, 60],
                                        [63, 59],
                                        [63, 48],
                                        [63, 62],
                                        [63, 57],
                                        [63, 58],
                                        [63, 61],
                                        [63, 60],
                                        [63, 55],
                                        [64, 55],
                                        [64, 62],
                                        [64, 48],
                                        [64, 63],
                                        [64, 58],
                                        [64, 61],
                                        [64, 60],
                                        [64, 59],
                                        [64, 57],
                                        [64, 11],
                                        [65, 63],
                                        [65, 64],
                                        [65, 48],
                                        [65, 62],
                                        [65, 58],
                                        [65, 61],
                                        [65, 60],
                                        [65, 59],
                                        [65, 57],
                                        [65, 55],
                                        [66, 64],
                                        [66, 58],
                                        [66, 59],
                                        [66, 62],
                                        [66, 65],
                                        [66, 48],
                                        [66, 63],
                                        [66, 61],
                                        [66, 60],
                                        [67, 57],
                                        [68, 25],
                                        [68, 11],
                                        [68, 24],
                                        [68, 27],
                                        [68, 48],
                                        [68, 41],
                                        [69, 25],
                                        [69, 68],
                                        [69, 11],
                                        [69, 24],
                                        [69, 27],
                                        [69, 48],
                                        [69, 41],
                                        [70, 25],
                                        [70, 69],
                                        [70, 68],
                                        [70, 11],
                                        [70, 24],
                                        [70, 27],
                                        [70, 41],
                                        [70, 58],
                                        [71, 27],
                                        [71, 69],
                                        [71, 68],
                                        [71, 70],
                                        [71, 11],
                                        [71, 48],
                                        [71, 41],
                                        [71, 25],
                                        [72, 26],
                                        [72, 27],
                                        [72, 11],
                                        [73, 48],
                                        [74, 48],
                                        [74, 73],
                                        [75, 69],
                                        [75, 68],
                                        [75, 25],
                                        [75, 48],
                                        [75, 41],
                                        [75, 70],
                                        [75, 71],
                                        [76, 64],
                                        [76, 65],
                                        [76, 66],
                                        [76, 63],
                                        [76, 62],
                                        [76, 48],
                                        [76, 58]
                                    ];
                                    var H = {
                                        duo: [],
                                        trio: [0],
                                        pentagon: [0, 0, 0, 0],
                                        hexagon: [0, 0, 0, 0, 0],
                                        octagon: [0, 0, 0, 0, 0, 0],
                                        star: [1, 0, 2, 0, 3, 0, 4, 0, 5],
                                        small: [3, 3, 3, 4],
                                        medium: [0, 1, 0, 2, 2, 4],
                                        large: [3, 2, 3, 4, 5, 6, 2, 2, 5, 5, 5, 1, 4, 1, 0, 7, 7],
                                        huge: [0, 1, 4, 1, 1, 1, 5, 0, 6, 7, 9, 9, 2, 2, 15, 5, 5, 11, 14, 1, 0, 7, 7, 1, 1, 3, 5, 8, 18, 7, 6, 11, 10, 3, 1, 18, 10, 8, 8, 6]
                                    };
                                    var I = Math.ceil(Math.sqrt(this.randomNetworkNodes)) + 1;
                                    var t = I;
                                    var s = I;
                                    while ((s - 1) * t >= this.randomNetworkNodes) {
                                        s--
                                    }
                                    var d = this.x / t;
                                    var h = this.y / s;
                                    var g = false;
                                    if (this.randomNetworkLayout == "lesmiserables") {
                                        g = true;
                                        f = E
                                    } else {
                                        if (this.randomNetworkLayout == "karate") {
                                            g = true;
                                            f = G
                                        }
                                    }
                                    if (this.randomNetworkReduce || g) {
                                        if (!g) {
                                            if (H.hasOwnProperty(this.randomNetworkLayout)) {
                                                f = this.prufer(H[this.randomNetworkLayout])
                                            } else {
                                                var v = this.randomNetworkNodes - 2;
                                                for (var B = 0; B < v; B++) {
                                                    f.push(Math.floor(this.random() * (v - B)))
                                                }
                                                f = this.prufer(f)
                                            }
                                        }
                                        for (var B = 0; B < f.length; B++) {
                                            if (!e.hasOwnProperty(f[B][0])) {
                                                e[f[B][0]] = 0
                                            }
                                            if (!e.hasOwnProperty(f[B][1])) {
                                                e[f[B][1]] = 0
                                            }
                                            e[f[B][0]]++;
                                            e[f[B][1]]++;
                                            a[f[B][0] + ":" + f[B][1]] = true;
                                            a[f[B][1] + ":" + f[B][0]] = true
                                        }
                                        if (!H.hasOwnProperty(this.randomNetworkLayout) && this.randomNetworkLayout != "radial" && !g) {
                                            b()
                                        }
                                        w = this.sortObject(e)
                                    } else {
                                        var v = Math.ceil(this.random() * this.randomNetworkNodes);
                                        for (var B = 0; B < v; B++) {
                                            w.push(B)
                                        }
                                        b()
                                    }
                                    w = w.sort(function(i, c) {
                                        return e[c] - e[i]
                                    });
                                    for (var B = 0; B < w.length; B++) {
                                        var A = w[B];
                                        var u = parseInt(B / t) + 1;
                                        var D = parseInt(B % t) + 1;
                                        var y = this.randomNetworkLayout == "lesmiserables" ? q[A] : false;
                                        var x = {
                                            id: "ND" + A,
                                            x: parseInt(D * d) * 10,
                                            y: parseInt(u * h) * 10,
                                            z: (parseInt(D * d) + parseInt(u * h)) / 2,
                                            n: e[A]
                                        };
                                        if (e[A] == 1) {
                                            for (var z in a) {
                                                var o = z.split(":");
                                                if (o[0] == A) {
                                                    x.parentNode = "ND" + o[1];
                                                    break
                                                }
                                            }
                                        }
                                        C(x, y);
                                        J.nodes.push(x)
                                    }
                                    for (var B = 0; B < f.length; B++) {
                                        var m = {
                                            id1: "ND" + f[B][0],
                                            id2: "ND" + f[B][1]
                                        };
                                        F(m);
                                        J.edges.push(m)
                                    }
                                    return J
                                };
                                this.createRandomGenome = function() {
                                    return {
                                        tracks: [{
                                            name: "Affymetrix Probes",
                                            type: "box",
                                            connect: true,
                                            data: [{
                                                id: "123456_at",
                                                fill: "rgb(255,255,51)",
                                                outline: "rgb(0,0,0)",
                                                dir: "right",
                                                data: [
                                                    [10, 20],
                                                    [30, 40],
                                                    [50, 60],
                                                    [70, 80],
                                                    [90, 100],
                                                    [110, 120]
                                                ],
                                                sequences: ["GTTTTACGTAC", "TACGTACGTAC", "GGTTTACGTAC", "GGTTTACGTAC", "GGTTTACGTAC", "GGTTTACGTAC"]
                                            }, {
                                                id: "345678_at",
                                                fill: "rgb(255,255,51)",
                                                outline: "rgb(0,0,0)",
                                                dir: "right",
                                                data: [
                                                    [100, 110],
                                                    [120, 130],
                                                    [140, 150],
                                                    [160, 170],
                                                    [180, 190]
                                                ]
                                            }]
                                        }, {
                                            name: "Sanger Sequencing (Multiple sequeneces)",
                                            highlight: [{
                                                offset: 80,
                                                width: 1,
                                                color: "rgb(120,120,180)"
                                            }, {
                                                offset: 185,
                                                width: 1,
                                                color: "rgb(180,20,180)"
                                            }],
                                            subtype: "DNA",
                                            type: "sequence",
                                            data: [{
                                                id: "Reference Sequence",
                                                fill: "rgb(51,255,255)",
                                                outline: "rgb(0,0,0)",
                                                dir: "right",
                                                offset: 1,
                                                sequence: "AAAACCCGGGTTTTACGTACGTACGTACGTACGTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTAAACC",
                                                translate: [-3, -2, -1, 1, 2, 3]
                                            }, {
                                                id: "R1-0000-1234",
                                                fill: "rgb(255,255,51)",
                                                outline: "rgb(0,0,0)",
                                                dir: "right",
                                                offset: 1,
                                                gaps: [
                                                    [18, 1],
                                                    [22, 1]
                                                ],
                                                sequence: "AAAACCCGGGTTTTACGTCGTAGTACGTACGTACGTACGTAAACCCGGGTTTACGTACGTAAACCCGGGTTTACGTACGTAA",
                                                coordinate: 50,
                                                trace: {
                                                    A: [57, 127, 237, 371, 486, 531, 486, 371, 237, 127, 57, 54, 117, 217, 339, 442, 484, 442, 339, 217, 117, 54, 10, 24, 60, 130, 240, 375, 490, 535, 490, 375, 240, 130, 60, 24, 10, 56, 121, 222, 346, 452, 494, 452, 346, 222, 121, 56, 7, 14, 27, 48, 74, 95, 104, 95, 74, 48, 27, 14, 7, 6, 8, 14, 27, 46, 69, 90, 98, 90, 69, 46, 27, 14, 8, 6, 4, 5, 7, 14, 27, 47, 72, 93, 101, 93, 72, 47, 27, 14, 7, 5, 4, 5, 11, 23, 42, 65, 85, 92, 85, 65, 42, 23, 11, 5, 7, 14, 27, 48, 74, 95, 104, 95, 74, 48, 27, 14, 7, 1, 2, 4, 10, 22, 42, 65, 85, 93, 85, 65, 42, 22, 10, 4, 2, 1, 5, 12, 24, 44, 68, 88, 97, 88, 68, 44, 24, 12, 5, 4, 5, 7, 14, 27, 47, 72, 94, 102, 94, 72, 47, 27, 14, 7, 5, 4, 2, 4, 10, 22, 41, 64, 83, 91, 83, 64, 41, 22, 10, 4, 2, 12, 24, 43, 67, 87, 95, 87, 67, 43, 24, 12, 21, 52, 113, 210, 328, 429, 469, 429, 328, 210, 113, 52, 21, 4, 6, 13, 26, 47, 72, 93, 102, 93, 72, 47, 26, 13, 6, 4, 4, 6, 13, 26, 46, 71, 92, 100, 92, 71, 46, 26, 13, 6, 4, 6, 8, 14, 27, 46, 69, 89, 97, 89, 69, 46, 27, 14, 8, 6, 4, 5, 8, 14, 28, 49, 76, 98, 107, 98, 76, 49, 28, 14, 8, 5, 4, 7, 13, 25, 45, 68, 88, 96, 88, 68, 45, 25, 13, 7, 5, 11, 24, 43, 67, 88, 96, 88, 67, 43, 24, 11, 5, 22, 54, 118, 219, 342, 447, 489, 447, 342, 219, 118, 54, 22, 5, 12, 25, 46, 71, 93, 102, 93, 71, 46, 25, 12, 5, 5, 12, 24, 44, 68, 89, 97, 89, 68, 44, 24, 12, 5, 20, 54, 121, 226, 355, 465, 508, 465, 355, 226, 121, 54, 20, 3, 4, 6, 13, 25, 45, 70, 91, 99, 91, 70, 45, 25, 13, 6, 4, 3, 6, 8, 15, 27, 47, 71, 91, 99, 91, 71, 47, 27, 15, 8, 6, 1, 2, 4, 11, 24, 44, 69, 90, 98, 90, 69, 44, 24, 11, 4, 2, 1, 6, 11, 25, 60, 128, 237, 369, 482, 527, 482, 369, 237, 128, 60, 25, 11, 6, 2, 5, 12, 25, 47, 74, 97, 106, 97, 74, 47, 25, 12, 5, 2, 5, 8, 15, 29, 51, 78, 101, 110, 101, 78, 51, 29, 15, 8, 5, 5, 12, 26, 48, 75, 98, 107, 98, 75, 48, 26, 12, 5, 6, 18, 48, 107, 201, 315, 412, 451, 412, 315, 201, 107, 48, 18, 6, 9, 16, 31, 53, 81, 105, 114, 105, 81, 53, 31, 16, 9, 6, 8, 15, 28, 48, 73, 94, 103, 94, 73, 48, 28, 15, 8, 6, 11, 23, 42, 65, 85, 92, 85, 65, 42, 23, 11, 19, 51, 113, 212, 332, 434, 475, 434, 332, 212, 113, 51, 19, 8, 15, 28, 49, 74, 95, 104, 95, 74, 49, 28, 15, 8, 12, 26, 49, 76, 99, 109, 99, 76, 49, 26, 12, 12, 24, 43, 67, 86, 94, 86, 67, 43, 24, 12, 22, 54, 118, 218, 341, 445, 487, 445, 341, 218, 118, 54, 22, 21, 52, 112, 208, 324, 423, 462, 423, 324, 208, 112, 52, 21, 10, 23, 54, 115, 212, 330, 430, 471, 430, 330, 212, 115, 54, 23, 10, 2, 3, 5, 12, 25, 45, 69, 91, 99, 91, 69, 45, 25, 12, 5, 3, 2, 2, 3, 5, 12, 24, 44, 68, 88, 97, 88, 68, 44, 24, 12, 5, 3, 2, 8, 15, 28, 50, 77, 100, 109, 100, 77, 50, 28, 15, 8, 12, 26, 48, 74, 96, 105, 96, 74, 48, 26, 12, 13, 27, 48, 74, 96, 105, 96, 74, 48, 27, 13, 13, 25, 45, 70, 91, 99, 91, 70, 45, 25, 13, 7, 14, 28, 49, 75, 97, 105, 97, 75, 49, 28, 14, 7, 2, 5, 12, 26, 48, 74, 97, 106, 97, 74, 48, 26, 12, 5, 2, 16, 30, 53, 80, 103, 113, 103, 80, 53, 30, 16, 25, 61, 133, 246, 384, 501, 548, 501, 384, 246, 133, 61, 25, 6, 13, 25, 45, 69, 90, 98, 90, 69, 45, 25, 13, 6, 5, 6, 9, 15, 29, 50, 77, 99, 108, 99, 77, 50, 29, 15, 9, 6, 5, 10, 23, 42, 65, 86, 94, 86, 65, 42, 23, 10, 9, 23, 55, 120, 223, 348, 454, 497, 454, 348, 223, 120, 55, 23, 9, 2, 4, 11, 23, 43, 67, 88, 96, 88, 67, 43, 23, 11, 4, 2, 2, 3, 6, 12, 26, 48, 74, 96, 105, 96, 74, 48, 26, 12, 6, 3, 2, 15, 28, 49, 74, 96, 104, 96, 74, 49, 28, 15, 22, 55, 120, 223, 348, 455, 498, 455, 348, 223, 120, 55, 22, 22, 53, 115, 213, 332, 434, 474, 434, 332, 213, 115, 53, 22, 7, 20, 53, 118, 221, 346, 454, 496, 454, 346, 221, 118, 53, 20, 7, 2, 3, 5, 11, 24, 44, 67, 88, 96, 88, 67, 44, 24, 11, 5, 3, 2, 15, 28, 50, 75, 97, 106, 97, 75, 50, 28, 15, 1, 2, 5, 12, 25, 47, 74, 96, 105, 96, 74, 47, 25, 12, 5, 2, 1, 6, 8, 15, 28, 49, 74, 96, 104, 96, 74, 49, 28, 15, 8, 6, 5, 12, 26, 47, 72, 94, 103, 94, 72, 47, 26, 12, 5, 8, 15, 27, 47, 71, 92, 100, 92, 71, 47, 27, 15, 8, 3, 5, 11, 23, 42, 65, 84, 92, 84, 65, 42, 23, 11, 5, 3, 5, 12, 25, 45, 70, 91, 100, 91, 70, 45, 25, 12, 5, 1, 2, 4, 10, 22, 41, 64, 84, 92, 84, 64, 41, 22, 10, 4, 2, 1, 7, 20, 51, 113, 212, 331, 433, 474, 433, 331, 212, 113, 51, 20, 7, 2, 3, 5, 12, 25, 46, 72, 94, 102, 94, 72, 46, 25, 12, 5, 3, 2, 2, 4, 11, 25, 46, 72, 94, 102, 94, 72, 46, 25, 11, 4, 2, 2, 3, 6, 12, 26, 48, 74, 97, 106, 97, 74, 48, 26, 12, 6, 3, 2, 10, 25, 61, 133, 247, 386, 504, 551, 504, 386, 247, 133, 61, 25, 10, 15, 27, 47, 71, 92, 100, 92, 71, 47, 27, 15, 5, 8, 15, 28, 50, 76, 99, 108, 99, 76, 50, 28, 15, 8, 5, 2, 3, 6, 13, 26, 48, 75, 98, 107, 98, 75, 48, 26, 13, 6, 3, 2, 8, 22, 57, 127, 238, 372, 487, 532, 487, 372, 238, 127, 57, 22, 8, 60, 129, 237, 370, 483, 528, 483, 370, 237, 129, 60],
                                                    C: [6, 13, 23, 34, 45, 49, 45, 34, 23, 13, 6, 9, 16, 28, 41, 53, 58, 53, 41, 28, 16, 9, 4, 5, 9, 15, 26, 39, 49, 54, 49, 39, 26, 15, 9, 5, 4, 10, 17, 28, 41, 52, 57, 52, 41, 28, 17, 10, 21, 51, 111, 206, 321, 419, 459, 419, 321, 206, 111, 51, 21, 11, 26, 62, 134, 248, 387, 505, 552, 505, 387, 248, 134, 62, 26, 11, 5, 10, 24, 58, 126, 233, 364, 475, 520, 475, 364, 233, 126, 58, 24, 10, 5, 3, 7, 13, 23, 35, 46, 50, 46, 35, 23, 13, 7, 3, 6, 9, 16, 27, 41, 52, 57, 52, 41, 27, 16, 9, 6, 1, 1, 3, 6, 13, 24, 38, 49, 54, 49, 38, 24, 13, 6, 3, 1, 1, 3, 6, 13, 22, 34, 45, 49, 45, 34, 22, 13, 6, 3, 4, 4, 5, 8, 14, 24, 36, 46, 50, 46, 36, 24, 14, 8, 5, 4, 4, 1, 2, 6, 12, 23, 36, 47, 51, 47, 36, 23, 12, 6, 2, 1, 7, 13, 23, 34, 44, 48, 44, 34, 23, 13, 7, 5, 8, 15, 27, 41, 52, 57, 52, 41, 27, 15, 8, 5, 8, 21, 52, 113, 211, 329, 431, 471, 431, 329, 211, 113, 52, 21, 8, 3, 4, 8, 14, 24, 37, 47, 51, 47, 37, 24, 14, 8, 4, 3, 5, 6, 10, 16, 27, 39, 50, 54, 50, 39, 27, 16, 10, 6, 5, 5, 9, 22, 52, 114, 210, 328, 428, 468, 428, 328, 210, 114, 52, 22, 9, 5, 6, 9, 16, 27, 41, 53, 57, 53, 41, 27, 16, 9, 6, 3, 7, 13, 24, 36, 47, 51, 47, 36, 24, 13, 7, 3, 4, 8, 15, 25, 38, 49, 54, 49, 38, 25, 15, 8, 4, 4, 7, 14, 25, 38, 49, 54, 49, 38, 25, 14, 7, 4, 3, 7, 14, 24, 37, 48, 52, 48, 37, 24, 14, 7, 3, 2, 6, 13, 23, 36, 47, 51, 47, 36, 23, 13, 6, 2, 4, 8, 21, 52, 114, 212, 331, 433, 474, 433, 331, 212, 114, 52, 21, 8, 4, 5, 6, 10, 16, 27, 39, 50, 54, 50, 39, 27, 16, 10, 6, 5, 1, 1, 3, 6, 13, 24, 38, 49, 54, 49, 38, 24, 13, 6, 3, 1, 1, 5, 5, 7, 10, 17, 29, 43, 54, 59, 54, 43, 29, 17, 10, 7, 5, 5, 6, 18, 49, 109, 203, 319, 417, 457, 417, 319, 203, 109, 49, 18, 6, 4, 6, 9, 16, 27, 41, 52, 57, 52, 41, 27, 16, 9, 6, 4, 2, 5, 12, 21, 33, 43, 47, 43, 33, 21, 12, 5, 2, 1, 2, 6, 12, 22, 34, 45, 49, 45, 34, 22, 12, 6, 2, 1, 25, 61, 131, 242, 376, 492, 538, 492, 376, 242, 131, 61, 25, 5, 6, 9, 15, 25, 36, 46, 50, 46, 36, 25, 15, 9, 6, 5, 7, 14, 26, 39, 51, 56, 51, 39, 26, 14, 7, 3, 6, 13, 24, 38, 50, 54, 50, 38, 24, 13, 6, 3, 24, 56, 121, 224, 348, 454, 497, 454, 348, 224, 121, 56, 24, 6, 12, 22, 35, 45, 49, 45, 35, 22, 12, 6, 8, 14, 24, 36, 47, 51, 47, 36, 24, 14, 8, 5, 9, 15, 25, 38, 48, 53, 48, 38, 25, 15, 9, 5, 5, 9, 15, 25, 37, 47, 51, 47, 37, 25, 15, 9, 5, 5, 7, 10, 17, 29, 42, 54, 59, 54, 42, 29, 17, 10, 7, 5, 3, 7, 20, 52, 116, 217, 339, 443, 485, 443, 339, 217, 116, 52, 20, 7, 3, 3, 8, 22, 55, 123, 229, 358, 469, 513, 469, 358, 229, 123, 55, 22, 8, 3, 22, 52, 114, 210, 328, 428, 468, 428, 328, 210, 114, 52, 22, 7, 14, 25, 38, 49, 54, 49, 38, 25, 14, 7, 7, 13, 23, 35, 45, 49, 45, 35, 23, 13, 7, 8, 14, 24, 36, 47, 51, 47, 36, 24, 14, 8, 6, 9, 16, 27, 41, 52, 57, 52, 41, 27, 16, 9, 6, 1, 2, 6, 12, 22, 34, 45, 49, 45, 34, 22, 12, 6, 2, 1, 10, 16, 26, 39, 49, 54, 49, 39, 26, 16, 10, 5, 8, 14, 24, 36, 46, 49, 46, 36, 24, 14, 8, 5, 22, 54, 119, 222, 346, 453, 495, 453, 346, 222, 119, 54, 22, 5, 5, 6, 10, 16, 26, 38, 49, 53, 49, 38, 26, 16, 10, 6, 5, 5, 6, 13, 24, 37, 48, 53, 48, 37, 24, 13, 6, 4, 5, 9, 15, 26, 38, 49, 53, 49, 38, 26, 15, 9, 5, 4, 7, 20, 53, 119, 223, 349, 457, 500, 457, 349, 223, 119, 53, 20, 7, 2, 2, 4, 7, 14, 25, 38, 50, 54, 50, 38, 25, 14, 7, 4, 2, 2, 10, 16, 27, 39, 50, 55, 50, 39, 27, 16, 10, 5, 8, 15, 27, 41, 52, 57, 52, 41, 27, 15, 8, 5, 6, 9, 16, 27, 40, 51, 56, 51, 40, 27, 16, 9, 6, 1, 2, 6, 12, 22, 35, 45, 49, 45, 35, 22, 12, 6, 2, 1, 3, 8, 22, 56, 124, 232, 362, 474, 519, 474, 362, 232, 124, 56, 22, 8, 3, 56, 120, 221, 345, 450, 492, 450, 345, 221, 120, 56, 2, 7, 21, 55, 122, 229, 358, 469, 513, 469, 358, 229, 122, 55, 21, 7, 2, 5, 7, 10, 17, 27, 40, 51, 56, 51, 40, 27, 17, 10, 7, 5, 3, 7, 13, 23, 35, 45, 50, 45, 35, 23, 13, 7, 3, 6, 9, 15, 25, 36, 46, 50, 46, 36, 25, 15, 9, 6, 2, 3, 7, 13, 24, 37, 48, 52, 48, 37, 24, 13, 7, 3, 2, 4, 7, 14, 25, 39, 50, 55, 50, 39, 25, 14, 7, 4, 1, 1, 2, 6, 12, 22, 34, 44, 49, 44, 34, 22, 12, 6, 2, 1, 1, 2, 3, 7, 13, 23, 35, 46, 50, 46, 35, 23, 13, 7, 3, 2, 3, 8, 23, 58, 129, 240, 376, 492, 539, 492, 376, 240, 129, 58, 23, 8, 3, 1, 2, 6, 13, 23, 36, 47, 51, 47, 36, 23, 13, 6, 2, 1, 2, 2, 3, 6, 12, 22, 34, 44, 48, 44, 34, 22, 12, 6, 3, 2, 2, 4, 5, 8, 14, 24, 36, 46, 50, 46, 36, 24, 14, 8, 5, 4, 57, 122, 225, 350, 457, 500, 457, 350, 225, 122, 57, 4, 6, 9, 16, 27, 41, 52, 57, 52, 41, 27, 16, 9, 6, 4, 2, 2, 3, 6, 13, 22, 34, 45, 49, 45, 34, 22, 13, 6, 3, 2, 2, 2, 3, 7, 13, 24, 36, 47, 51, 47, 36, 24, 13, 7, 3, 2, 10, 16, 26, 38, 48, 52, 48, 38, 26, 16, 10],
                                                    G: [4, 8, 14, 20, 26, 29, 26, 20, 14, 8, 4, 6, 9, 14, 20, 26, 28, 26, 20, 14, 9, 6, 4, 5, 6, 10, 15, 22, 27, 29, 27, 22, 15, 10, 6, 5, 4, 7, 10, 15, 20, 25, 27, 25, 20, 15, 10, 7, 4, 6, 9, 14, 20, 25, 27, 25, 20, 14, 9, 6, 4, 5, 5, 7, 10, 16, 22, 27, 30, 27, 22, 16, 10, 7, 5, 5, 4, 4, 5, 6, 10, 15, 22, 28, 30, 28, 22, 15, 10, 6, 5, 4, 4, 22, 57, 127, 237, 370, 485, 530, 485, 370, 237, 127, 57, 22, 24, 60, 130, 242, 377, 493, 539, 493, 377, 242, 130, 60, 24, 2, 7, 21, 55, 123, 230, 361, 472, 517, 472, 361, 230, 123, 55, 21, 7, 2, 2, 4, 7, 12, 18, 23, 25, 23, 18, 12, 7, 4, 2, 4, 4, 4, 6, 9, 14, 20, 25, 27, 25, 20, 14, 9, 6, 4, 4, 4, 1, 2, 3, 7, 12, 19, 25, 27, 25, 19, 12, 7, 3, 2, 1, 5, 8, 13, 19, 24, 26, 24, 19, 13, 8, 5, 3, 5, 8, 13, 19, 24, 26, 24, 19, 13, 8, 5, 3, 3, 3, 5, 8, 14, 20, 25, 28, 25, 20, 14, 8, 5, 3, 3, 9, 22, 55, 120, 224, 349, 457, 499, 457, 349, 224, 120, 55, 22, 9, 5, 6, 7, 11, 17, 24, 30, 32, 30, 24, 17, 11, 7, 6, 5, 4, 4, 4, 6, 9, 14, 20, 25, 27, 25, 20, 14, 9, 6, 4, 4, 4, 22, 54, 116, 215, 335, 438, 479, 438, 335, 215, 116, 54, 22, 2, 4, 7, 12, 18, 23, 25, 23, 18, 12, 7, 4, 2, 3, 5, 8, 14, 20, 25, 27, 25, 20, 14, 8, 5, 3, 22, 57, 127, 237, 371, 485, 530, 485, 371, 237, 127, 57, 22, 3, 4, 8, 13, 20, 26, 28, 26, 20, 13, 8, 4, 3, 2, 3, 7, 12, 18, 24, 26, 24, 18, 12, 7, 3, 2, 3, 3, 3, 5, 8, 13, 20, 25, 27, 25, 20, 13, 8, 5, 3, 3, 3, 11, 25, 59, 127, 234, 364, 476, 520, 476, 364, 234, 127, 59, 25, 11, 1, 1, 1, 3, 6, 11, 17, 22, 24, 22, 17, 11, 6, 3, 1, 1, 1, 5, 5, 5, 7, 11, 16, 22, 28, 30, 28, 22, 16, 11, 7, 5, 5, 5, 1, 1, 3, 6, 11, 17, 22, 24, 22, 17, 11, 6, 3, 1, 1, 10, 23, 56, 121, 223, 348, 455, 498, 455, 348, 223, 121, 56, 23, 10, 1, 3, 6, 12, 18, 23, 25, 23, 18, 12, 6, 3, 1, 1, 1, 3, 6, 11, 16, 21, 23, 21, 16, 11, 6, 3, 1, 1, 5, 7, 10, 15, 21, 26, 28, 26, 21, 15, 10, 7, 5, 11, 25, 61, 131, 243, 378, 494, 540, 494, 378, 243, 131, 61, 25, 11, 4, 8, 14, 20, 26, 29, 26, 20, 14, 8, 4, 1, 3, 6, 11, 16, 21, 23, 21, 16, 11, 6, 3, 1, 5, 7, 10, 15, 20, 25, 27, 25, 20, 15, 10, 7, 5, 50, 112, 211, 330, 432, 473, 432, 330, 211, 112, 50, 5, 8, 13, 20, 25, 27, 25, 20, 13, 8, 5, 5, 6, 10, 16, 22, 28, 31, 28, 22, 16, 10, 6, 5, 4, 6, 9, 14, 19, 24, 26, 24, 19, 14, 9, 6, 4, 5, 5, 7, 11, 16, 22, 28, 30, 28, 22, 16, 11, 7, 5, 5, 2, 2, 2, 4, 7, 12, 17, 22, 24, 22, 17, 12, 7, 4, 2, 2, 2, 2, 2, 3, 4, 8, 13, 20, 25, 27, 25, 20, 13, 8, 4, 3, 2, 2, 5, 6, 10, 15, 22, 28, 30, 28, 22, 15, 10, 6, 5, 59, 130, 243, 381, 498, 545, 498, 381, 243, 130, 59, 54, 118, 218, 341, 446, 488, 446, 341, 218, 118, 54, 57, 126, 234, 365, 477, 522, 477, 365, 234, 126, 57, 4, 6, 9, 14, 21, 26, 28, 26, 21, 14, 9, 6, 4, 1, 1, 3, 6, 11, 17, 22, 24, 22, 17, 11, 6, 3, 1, 1, 7, 10, 15, 21, 26, 28, 26, 21, 15, 10, 7, 4, 6, 10, 15, 21, 27, 29, 27, 21, 15, 10, 6, 4, 4, 5, 9, 14, 21, 27, 29, 27, 21, 14, 9, 5, 4, 6, 10, 24, 56, 121, 223, 347, 453, 495, 453, 347, 223, 121, 56, 24, 10, 6, 3, 6, 12, 18, 23, 25, 23, 18, 12, 6, 3, 4, 4, 6, 9, 14, 20, 25, 27, 25, 20, 14, 9, 6, 4, 4, 1, 2, 3, 7, 12, 18, 24, 26, 24, 18, 12, 7, 3, 2, 1, 3, 8, 23, 59, 131, 244, 382, 500, 547, 500, 382, 244, 131, 59, 23, 8, 3, 7, 11, 16, 22, 28, 30, 28, 22, 16, 11, 7, 3, 5, 8, 13, 19, 24, 27, 24, 19, 13, 8, 5, 3, 5, 6, 10, 15, 21, 27, 29, 27, 21, 15, 10, 6, 5, 1, 2, 3, 7, 13, 20, 25, 28, 25, 20, 13, 7, 3, 2, 1, 2, 2, 2, 4, 7, 12, 18, 23, 25, 23, 18, 12, 7, 4, 2, 2, 2, 7, 10, 16, 22, 27, 30, 27, 22, 16, 10, 7, 1, 1, 1, 3, 6, 11, 17, 22, 24, 22, 17, 11, 6, 3, 1, 1, 1, 11, 24, 57, 122, 225, 350, 457, 500, 457, 350, 225, 122, 57, 24, 11, 23, 58, 129, 241, 377, 494, 540, 494, 377, 241, 129, 58, 23, 26, 62, 133, 246, 384, 501, 548, 501, 384, 246, 133, 62, 26, 2, 2, 4, 7, 12, 18, 23, 25, 23, 18, 12, 7, 4, 2, 2, 2, 4, 7, 12, 18, 23, 25, 23, 18, 12, 7, 4, 2, 1, 1, 1, 3, 6, 11, 17, 22, 24, 22, 17, 11, 6, 3, 1, 1, 1, 2, 2, 4, 7, 12, 18, 23, 25, 23, 18, 12, 7, 4, 2, 2, 2, 2, 2, 4, 8, 13, 19, 25, 27, 25, 19, 13, 8, 4, 2, 2, 2, 7, 20, 54, 120, 224, 351, 460, 503, 460, 351, 224, 120, 54, 20, 7, 2, 2, 3, 4, 8, 13, 20, 26, 28, 26, 20, 13, 8, 4, 3, 2, 2, 4, 5, 6, 10, 16, 22, 28, 31, 28, 22, 16, 10, 6, 5, 4, 7, 10, 16, 22, 27, 29, 27, 22, 16, 10, 7, 10, 23, 57, 124, 230, 359, 469, 513, 469, 359, 230, 124, 57, 23, 10, 2, 2, 3, 4, 8, 14, 21, 27, 29, 27, 21, 14, 8, 4, 3, 2, 2, 2, 2, 4, 7, 12, 19, 24, 26, 24, 19, 12, 7, 4, 2, 2, 7, 11, 17, 24, 29, 32, 29, 24, 17, 11, 7],
                                                    T: [3, 4, 6, 8, 10, 11, 10, 8, 6, 4, 3, 5, 6, 8, 11, 13, 14, 13, 11, 8, 6, 5, 4, 4, 5, 6, 8, 11, 13, 14, 13, 11, 8, 6, 5, 4, 4, 5, 7, 9, 11, 13, 14, 13, 11, 9, 7, 5, 4, 5, 6, 8, 11, 13, 14, 13, 11, 8, 6, 5, 4, 5, 5, 6, 7, 9, 12, 14, 15, 14, 12, 9, 7, 6, 5, 5, 4, 4, 4, 5, 6, 8, 10, 13, 14, 13, 10, 8, 6, 5, 4, 4, 4, 2, 3, 4, 6, 8, 11, 11, 11, 8, 6, 4, 3, 2, 4, 5, 6, 8, 10, 12, 13, 12, 10, 8, 6, 5, 4, 1, 1, 1, 2, 3, 5, 7, 9, 10, 9, 7, 5, 3, 2, 1, 1, 1, 23, 59, 131, 244, 382, 501, 548, 501, 382, 244, 131, 59, 23, 5, 10, 24, 59, 129, 239, 373, 488, 534, 488, 373, 239, 129, 59, 24, 10, 5, 6, 19, 50, 112, 210, 329, 431, 472, 431, 329, 210, 112, 50, 19, 6, 54, 118, 219, 342, 447, 488, 447, 342, 219, 118, 54, 3, 4, 5, 7, 9, 11, 12, 11, 9, 7, 5, 4, 3, 3, 3, 4, 5, 7, 10, 12, 13, 12, 10, 7, 5, 4, 3, 3, 3, 3, 4, 5, 7, 10, 12, 13, 12, 10, 7, 5, 4, 3, 3, 10, 23, 54, 115, 213, 331, 433, 473, 433, 331, 213, 115, 54, 23, 10, 4, 4, 4, 5, 6, 8, 11, 13, 14, 13, 11, 8, 6, 5, 4, 4, 4, 4, 4, 6, 8, 10, 12, 13, 12, 10, 8, 6, 4, 4, 21, 54, 119, 223, 348, 456, 498, 456, 348, 223, 119, 54, 21, 3, 3, 5, 7, 9, 11, 12, 11, 9, 7, 5, 3, 3, 2, 3, 4, 6, 8, 11, 12, 11, 8, 6, 4, 3, 2, 23, 58, 129, 242, 378, 495, 541, 495, 378, 242, 129, 58, 23, 1, 2, 3, 5, 8, 10, 11, 10, 8, 5, 3, 2, 1, 3, 3, 3, 4, 5, 7, 10, 12, 13, 12, 10, 7, 5, 4, 3, 3, 3, 5, 5, 5, 7, 9, 11, 13, 14, 13, 11, 9, 7, 5, 5, 5, 2, 6, 19, 51, 113, 212, 332, 435, 476, 435, 332, 212, 113, 51, 19, 6, 2, 5, 5, 5, 6, 7, 9, 12, 14, 15, 14, 12, 9, 7, 6, 5, 5, 5, 1, 1, 2, 3, 5, 8, 10, 11, 10, 8, 5, 3, 2, 1, 1, 4, 4, 4, 6, 8, 10, 12, 13, 12, 10, 8, 6, 4, 4, 4, 20, 53, 119, 222, 349, 456, 499, 456, 349, 222, 119, 53, 20, 1, 1, 1, 3, 5, 7, 9, 10, 9, 7, 5, 3, 1, 1, 1, 5, 6, 7, 9, 12, 15, 15, 15, 12, 9, 7, 6, 5, 5, 5, 6, 7, 9, 12, 14, 15, 14, 12, 9, 7, 6, 5, 5, 57, 126, 235, 367, 481, 526, 481, 367, 235, 126, 57, 1, 2, 3, 5, 8, 10, 11, 10, 8, 5, 3, 2, 1, 5, 6, 7, 9, 12, 14, 15, 14, 12, 9, 7, 6, 5, 2, 3, 5, 7, 9, 10, 9, 7, 5, 3, 2, 58, 128, 237, 371, 485, 530, 485, 371, 237, 128, 58, 4, 4, 6, 8, 10, 12, 13, 12, 10, 8, 6, 4, 4, 4, 4, 6, 8, 10, 12, 13, 12, 10, 8, 6, 4, 4, 5, 5, 6, 7, 9, 11, 14, 15, 14, 11, 9, 7, 6, 5, 5, 2, 2, 2, 2, 4, 6, 8, 10, 11, 10, 8, 6, 4, 2, 2, 2, 2, 2, 2, 2, 3, 4, 6, 9, 11, 12, 11, 9, 6, 4, 3, 2, 2, 2, 4, 5, 6, 8, 11, 13, 14, 13, 11, 8, 6, 5, 4, 2, 4, 6, 8, 10, 11, 10, 8, 6, 4, 2, 4, 5, 7, 9, 12, 12, 12, 9, 7, 5, 4, 4, 5, 7, 10, 12, 13, 12, 10, 7, 5, 4, 23, 55, 119, 221, 345, 451, 493, 451, 345, 221, 119, 55, 23, 7, 22, 58, 130, 243, 381, 499, 546, 499, 381, 243, 130, 58, 22, 7, 61, 133, 245, 381, 498, 545, 498, 381, 245, 133, 61, 4, 4, 6, 8, 10, 12, 13, 12, 10, 8, 6, 4, 4, 3, 4, 5, 7, 10, 12, 13, 12, 10, 7, 5, 4, 3, 5, 5, 5, 6, 7, 9, 12, 14, 15, 14, 12, 9, 7, 6, 5, 5, 5, 50, 111, 207, 325, 426, 466, 426, 325, 207, 111, 50, 4, 4, 5, 6, 8, 11, 13, 14, 13, 11, 8, 6, 5, 4, 4, 1, 1, 2, 3, 5, 8, 10, 11, 10, 8, 5, 3, 2, 1, 1, 2, 2, 2, 2, 4, 6, 8, 10, 11, 10, 8, 6, 4, 2, 2, 2, 2, 56, 119, 220, 342, 447, 489, 447, 342, 220, 119, 56, 3, 4, 5, 7, 9, 11, 12, 11, 9, 7, 5, 4, 3, 4, 5, 6, 8, 11, 14, 14, 14, 11, 8, 6, 5, 4, 1, 1, 2, 3, 5, 8, 10, 11, 10, 8, 5, 3, 2, 1, 1, 2, 2, 2, 3, 4, 6, 8, 10, 11, 10, 8, 6, 4, 3, 2, 2, 2, 5, 7, 9, 11, 13, 14, 13, 11, 9, 7, 5, 1, 1, 1, 2, 3, 5, 8, 10, 11, 10, 8, 5, 3, 2, 1, 1, 1, 5, 5, 6, 7, 9, 12, 14, 15, 14, 12, 9, 7, 6, 5, 5, 2, 2, 4, 6, 8, 10, 11, 10, 8, 6, 4, 2, 2, 5, 6, 7, 9, 12, 14, 15, 14, 12, 9, 7, 6, 5, 7, 21, 53, 117, 219, 343, 449, 491, 449, 343, 219, 117, 53, 21, 7, 21, 55, 122, 228, 356, 466, 510, 466, 356, 228, 122, 55, 21, 2, 6, 18, 48, 108, 202, 316, 414, 452, 414, 316, 202, 108, 48, 18, 6, 2, 2, 2, 2, 4, 6, 8, 10, 11, 10, 8, 6, 4, 2, 2, 2, 2, 2, 2, 3, 4, 6, 8, 10, 11, 10, 8, 6, 4, 3, 2, 2, 2, 1, 1, 1, 3, 5, 7, 9, 10, 9, 7, 5, 3, 1, 1, 1, 3, 8, 23, 59, 132, 246, 385, 504, 551, 504, 385, 246, 132, 59, 23, 8, 3, 4, 4, 5, 6, 8, 10, 12, 13, 12, 10, 8, 6, 5, 4, 4, 6, 7, 9, 11, 13, 14, 13, 11, 9, 7, 6, 4, 4, 5, 6, 8, 10, 12, 13, 12, 10, 8, 6, 5, 4, 4, 3, 7, 21, 53, 117, 219, 343, 448, 491, 448, 343, 219, 117, 53, 21, 7, 3, 2, 2, 2, 4, 6, 8, 10, 11, 10, 8, 6, 4, 2, 2, 2, 5, 7, 9, 11, 13, 14, 13, 11, 9, 7, 5],
                                                    peak: [5, 16, 29, 42, 54, 68, 84, 99, 112, 127, 142, 157, 173, 186, 198, 212, 227, 242, 258, 273, 286, 299, 312, 325, 338, 353, 369, 385, 402, 418, 433, 447, 461, 475, 489, 502, 514, 527, 539, 550, 562, 575, 589, 605, 622, 637, 649, 660, 671, 683, 697, 710, 722, 735, 750, 764, 777, 792, 808, 822, 834, 847, 861, 877, 891, 905, 921, 935, 948, 962, 976, 991, 1007, 1023, 1039, 1055, 1071, 1084, 1097, 1113, 1129, 1142]
                                                }
                                            }]
                                        }, {
                                            name: "Copy Number Variation",
                                            type: "heatmap",
                                            autowidth: true,
                                            height: 20,
                                            data: [{
                                                id: "Cell Line-123",
                                                offset: 10,
                                                data: [7, 5, 5, 5, 6, 7, 9, 8, 8, 8, 8, 5, 7, 9, 15, 15, 16, 9, 9, 7, 8, 10, 9, 21, 22, 22, 24, 20, 24, 26, 24, 25, 24, 31, 29, 33, 33, 33, 33, 33, 20, 17, 19, 18, 18, 18, 27, 23, 31, 26, 31, 31, 31, 34, 32, 31, 30, 30, 30, 30, 30, 24, 24, 20, 21, 17, 17, 27, 29, 25, 31, 31, 31]
                                            }]
                                        }, {
                                            name: "Tissue Distribution (Heart, Liver, Kidney)",
                                            type: "heatmap",
                                            height: 20,
                                            data: [{
                                                id: "123456_at",
                                                offset: 100,
                                                data: [25, 35, 46]
                                            }, {
                                                id: "345678_at",
                                                offset: 181,
                                                data: [65, 46, 29]
                                            }]
                                        }, {
                                            name: "Another CNV",
                                            type: "line",
                                            autowidth: true,
                                            height: 20,
                                            fill: ["rgb(255,0,0)", "rgb(0,255,0)"],
                                            outline: ["rgb(255,0,0)", "rgb(0,255,0)"],
                                            data: [{
                                                id: "Cell Line-124",
                                                offset: 10,
                                                data: [30, 31, 31, 33, 29, 29, 30, 31, 32, 33, 33, 31, 31, 29, 30, 30, 27, 32, 31, 31, 28, 31, 31, 29, 31, 31, 31, 26, 25, 29, 26, 26, 21, 26, 21, 31, 31, 28, 28, 23, 25, 28, 28, 31, 33, 33, 32, 31, 31, 31, 24, 28, 28, 28, 31, 32, 32, 31, 31, 28, 24, 28, 24, 29, 31, 29, 31]
                                            }]
                                        }, {
                                            type: "bar",
                                            height: 20,
                                            fill: ["rgb(255,0,0)", "rgb(0,0,255)", "rgb(255,255,0)"],
                                            outline: ["rgb(255,0,0)", "rgb(0,0,255)", "rgb(255,255,0)"],
                                            data: [{
                                                id: "123456_at",
                                                offset: 100,
                                                data: [25, 35, 46]
                                            }, {
                                                id: "345678_at",
                                                offset: 181,
                                                data: [65, 46, 29]
                                            }]
                                        }, {
                                            name: "Clones",
                                            type: "box",
                                            data: [{
                                                id: "clone-1234567",
                                                fill: "rgb(255,255,51)",
                                                outline: "rgb(0,0,0)",
                                                dir: "left",
                                                data: [
                                                    [121, 196]
                                                ]
                                            }, {
                                                id: "clone-2345678",
                                                fill: "rgb(255,255,51)",
                                                outline: "rgb(0,0,0)",
                                                dir: "right",
                                                data: [
                                                    [371, 400]
                                                ],
                                                landmarks: [{
                                                    offset: 157,
                                                    text: "Gap "
                                                }, {
                                                    offset: 137,
                                                    text: "Insertion "
                                                }]
                                            }]
                                        }, {
                                            name: "SNP Location",
                                            type: "triangle",
                                            data: [{
                                                id: "SNP123",
                                                fill: "rgb(100,0,0)",
                                                outline: "rgb(0,0,0)",
                                                offset: 23
                                            }, {
                                                id: "SNP789",
                                                fill: "rgb(100,0,0)",
                                                outline: "rgb(0,0,0)",
                                                offset: 195
                                            }]
                                        }, {
                                            name: "SNP Sequences",
                                            type: "sequence",
                                            subtype: "DNA",
                                            data: [{
                                                id: "SNP123",
                                                offset: 19,
                                                sequence: "CACA[AT]GCACCTTGTA"
                                            }, {
                                                id: "SNP234",
                                                offset: 41,
                                                sequence: "ATCG[TG]AATA"
                                            }, {
                                                id: "SNP789",
                                                offset: 116,
                                                sequence: "GCCC[CT]AGGG"
                                            }]
                                        }]
                                    }
                                };
                                this.createMesh = function() {
                                    var f = {};
                                    f.nodes = [];
                                    f.edges = [];
                                    var e = 7;
                                    var a = this;
                                    for (var h = 0; h < e * e; h++) {
                                        var c = {};
                                        var g = Math.floor(this.random() * this.shapes.length);
                                        var b = Math.floor(this.random() * this.colors.length);
                                        c.id = "ND" + h;
                                        c.shape = this.shapes[g];
                                        c.color = this.colors[b];
                                        c.size = 1;
                                        f.nodes.push(c)
                                    }
                                    var d = function(m, l) {
                                        var k = {};
                                        var i = Math.floor(a.random() * a.lines.length);
                                        var j = Math.floor(a.random() * a.colors.length);
                                        k.id1 = f.nodes[m].id;
                                        k.id2 = f.nodes[l].id;
                                        k.width = 1;
                                        k.type = a.lines[i];
                                        k.color = a.colors[j];
                                        return k
                                    };
                                    for (var h = 0; h < f.nodes.length; h++) {
                                        if (Math.floor(this.random() * e) != 0) {
                                            if (h + 1 < f.nodes.length && (h + 1) % e != 0) {
                                                f.edges.push(d(h, h + 1))
                                            }
                                            if (h + e < f.nodes.length) {
                                                f.edges.push(d(h, h + e))
                                            }
                                        }
                                    }
                                    return f
                                }
                            };
                            CanvasXpress.prototype.FunctionData = function(a) {
                                this.add = function(c, b) {
                                    return new Number(b) + new Number(c)
                                };
                                this.sub = function(c, b) {
                                    return b - c
                                };
                                this.mul = function(c, b) {
                                    return b * c
                                };
                                this.div = function(c, b) {
                                    return b / c
                                };
                                this.sin = function(b) {
                                    return Math.sin(b)
                                };
                                this.cos = function(b) {
                                    return Math.cos(b)
                                };
                                this.tan = function(b) {
                                    return Math.tan(b)
                                };
                                this.sec = function(b) {
                                    return 1 / Math.cos(b)
                                };
                                this.csc = function(b) {
                                    return 1 / Math.sin(b)
                                };
                                this.cot = function(b) {
                                    return 1 / Math.tan(b)
                                };
                                this.asin = function(b) {
                                    return Math.asin(b)
                                };
                                this.acos = function(b) {
                                    return Math.acos(b)
                                };
                                this.atan = function(b) {
                                    return Math.atan(b)
                                };
                                this.asec = function(b) {
                                    return Math.acos(1 / b)
                                };
                                this.acsc = function(b) {
                                    return Math.asin(1 / b)
                                };
                                this.acot = function(b) {
                                    return Math.atan(1 / b)
                                };
                                this.sinh = function(b) {
                                    return (Math.exp(b) - Math.exp(-b)) * 0.5
                                };
                                this.cosh = function(b) {
                                    return (Math.exp(b) + Math.exp(-b)) * 0.5
                                };
                                this.tanh = function(b) {
                                    return (Math.exp(b) - Math.exp(-b)) / (Math.exp(b) + Math.exp(-b))
                                };
                                this.sech = function(b) {
                                    return 1 / cosh(b)
                                };
                                this.csch = function(b) {
                                    return 1 / sinh(b)
                                };
                                this.coth = function(b) {
                                    return 1 / tanh(b)
                                };
                                this.asinh = function(b) {
                                    return Math.log(b + Math.sqrt(b * b + 1))
                                };
                                this.acosh = function(b) {
                                    return Math.log(b + Math.sqrt(b * b - 1))
                                };
                                this.atanh = function(b) {
                                    return Math.log((1 + b) / (1 - b)) * 0.5
                                };
                                this.asech = function(b) {
                                    return acosh(1 / b)
                                };
                                this.acsch = function(b) {
                                    return asinh(1 / b)
                                };
                                this.acoth = function(b) {
                                    return atanh(1 / b)
                                };
                                this.exp = function(b) {
                                    return Math.exp(b)
                                };
                                this.ln = function(b) {
                                    return Math.log(b)
                                };
                                this.log = function(b) {
                                    return Math.log(b) / Math.LN10
                                };
                                this.logb = function(c, b) {
                                    return Math.log(b) / Math.log(c)
                                };
                                this.pow = function(c, b) {
                                    return Math.pow(b, c)
                                };
                                this.pow10 = function(b) {
                                    return Math.pow(10, b)
                                };
                                this.sq = function(b) {
                                    return b * b
                                };
                                this.sqrt = function(b) {
                                    return Math.sqrt(b)
                                };
                                this.abs = function(b) {
                                    return b >= 0 ? b : -b
                                };
                                this.sgn = function(b) {
                                    return b == 0 ? 0 : (b > 0 ? 1 : -1)
                                };
                                this.chs = function(b) {
                                    return -b
                                };
                                this.neg = function(b) {
                                    return -b
                                };
                                this.floor = function(b) {
                                    return Math.floor(b)
                                };
                                this.ceil = function(b) {
                                    return Math.ceil(b)
                                };
                                this.ip = function(b) {
                                    return parseInt(b)
                                };
                                this.fp = function(b) {
                                    return abs(b) - ip(abs(b))
                                };
                                this.inv = function(b) {
                                    return 1 / b
                                };
                                this.idiv = function(c, b) {
                                    return parseInt(b / c)
                                };
                                this.mod = function(c, b) {
                                    return b % c
                                };
                                this.and = function(c, b) {
                                    return b & c
                                };
                                this.or = function(c, b) {
                                    return b | c
                                };
                                this.xor = function(c, b) {
                                    return b ^ c
                                };
                                this.not = function(b) {
                                    return ~b
                                };
                                this.lt = function(c, b) {
                                    return b < c ? 1 : 0
                                };
                                this.le = function(c, b) {
                                    return b <= c ? 1 : 0
                                };
                                this.eq = function(c, b) {
                                    return b == c ? 1 : 0
                                };
                                this.ne = function(c, b) {
                                    return b != c ? 1 : 0
                                };
                                this.ge = function(c, b) {
                                    return b >= c ? 1 : 0
                                };
                                this.gt = function(c, b) {
                                    return b > c ? 1 : 0
                                };
                                this.Min = function(c, b) {
                                    return Math.min(b, c)
                                };
                                this.Max = function(c, b) {
                                    return Math.max(b, c)
                                };
                                this.pc = function(c, b) {
                                    return b * c / 100
                                };
                                this.pcch = function(c, b) {
                                    return 100 * c / b
                                };
                                this.gammaLn = function(c) {
                                    var b = new Array(76.18009172947146, -86.50532032941678, 24.01409824083091, -1.231739572450155, 0.001208650973866179, -0.000005395239384953);
                                    var g = new Number(c);
                                    var f = new Number(c + 5.5);
                                    var d = new Number(1.000000000190015);
                                    f -= (c + 0.5) * Math.log(f);
                                    for (var e in b) {
                                        d += b[e] / ++g
                                    }
                                    return Math.log(2.5066282746310007 * d / c) - f
                                };
                                this.gammaLn2 = function(b) {
                                    var d = 0;
                                    var g = [76.18009172947146, -86.50532032941678, 24.01409824083091, -1.231739572450155, 0.001208650973866179, -0.000005395239384953];
                                    var c = 1.000000000190015;
                                    var f, h, e;
                                    e = (h = f = b) + 5.5;
                                    e -= (f + 0.5) * Math.log(e);
                                    for (; d < 6; d++) {
                                        c += g[d] / ++h
                                    }
                                    return Math.log(2.5066282746310007 * c / f) - e
                                };
                                this.betaCf = function(q, p, o) {
                                    var i = 1e-30;
                                    var g = 1;
                                    var k = p + o;
                                    var t = p + 1;
                                    var f = p - 1;
                                    var n = 1;
                                    var l = 1 - k * q / t;
                                    var s, e, r, j;
                                    if (Math.abs(l) < i) {
                                        l = i
                                    }
                                    l = 1 / l;
                                    j = l;
                                    for (; g <= 100; g++) {
                                        s = 2 * g;
                                        e = g * (o - g) * q / ((f + s) * (p + s));
                                        l = 1 + e * l;
                                        if (Math.abs(l) < i) {
                                            l = i
                                        }
                                        n = 1 + e / n;
                                        if (Math.abs(n) < i) {
                                            n = i
                                        }
                                        l = 1 / l;
                                        j *= l * n;
                                        e = -(p + g) * (k + g) * q / ((p + s) * (t + s));
                                        l = 1 + e * l;
                                        if (Math.abs(l) < i) {
                                            l = i
                                        }
                                        n = 1 + e / n;
                                        if (Math.abs(n) < i) {
                                            n = i
                                        }
                                        l = 1 / l;
                                        r = l * n;
                                        j *= r;
                                        if (Math.abs(r - 1) < 3e-7) {
                                            break
                                        }
                                    }
                                    return j
                                };
                                this.beta = function(d, e, c) {
                                    var f = (d === 0 || d === 1) ? 0 : Math.exp(this.gammaLn2(e + c) - this.gammaLn2(e) - this.gammaLn2(c) + e * Math.log(d) + c * Math.log(1 - d));
                                    if (d < 0 || d > 1) {
                                        return false
                                    }
                                    if (d < (e + 1) / (e + c + 2)) {
                                        return f * this.betaCf(d, e, c) / e
                                    }
                                    return 1 - f * this.betaCf(1 - d, c, e) / c
                                };
                                this.betaInv = function(m, z, y) {
                                    var n = 1e-8;
                                    var A = z - 1;
                                    var f = y - 1;
                                    var q = 0;
                                    var d, c, r, l, k, e, g, o, v, i, s;
                                    if (m <= 0) {
                                        return 0
                                    }
                                    if (m >= 1) {
                                        return 1
                                    }
                                    if (z >= 1 && y >= 1) {
                                        r = (m < 0.5) ? m : 1 - m;
                                        l = Math.sqrt(-2 * Math.log(r));
                                        g = (2.30753 + l * 0.27061) / (1 + l * (0.99229 + l * 0.04481)) - l;
                                        if (m < 0.5) {
                                            g = -g
                                        }
                                        o = (g * g - 3) / 6;
                                        v = 2 / (1 / (2 * z - 1) + 1 / (2 * y - 1));
                                        i = (g * Math.sqrt(o + v) / v) - (1 / (2 * y - 1) - 1 / (2 * z - 1)) * (o + 5 / 6 - 2 / (3 * v));
                                        g = z / (z + y * Math.exp(2 * i))
                                    } else {
                                        d = Math.log(z / (z + y));
                                        c = Math.log(y / (z + y));
                                        l = Math.exp(z * d) / z;
                                        k = Math.exp(y * c) / y;
                                        i = l + k;
                                        if (m < l / i) {
                                            g = Math.pow(z * i * m, 1 / z)
                                        } else {
                                            g = 1 - Math.pow(y * i * (1 - m), 1 / y)
                                        }
                                    }
                                    s = -this.gammaLn2(z) - this.gammaLn2(y) + this.gammaLn2(z + y);
                                    for (; q < 10; q++) {
                                        if (g === 0 || g === 1) {
                                            return g
                                        }
                                        e = this.beta(g, z, y) - m;
                                        l = Math.exp(A * Math.log(g) + f * Math.log(1 - g) + s);
                                        k = e / l;
                                        g -= (l = k / (1 - 0.5 * Math.min(1, k * (A / g - f / (1 - g)))));
                                        if (g <= 0) {
                                            g = 0.5 * (g + l)
                                        }
                                        if (g >= 1) {
                                            g = 0.5 * (g + l + 1)
                                        }
                                        if (Math.abs(l) < n * g && q > 0) {
                                            break
                                        }
                                    }
                                    return g
                                };
                                this.lowRegGamma = function(r, s) {
                                    var p = this.gammaLn(r);
                                    var f = r;
                                    var m = 1 / r;
                                    var t = m;
                                    var q = s + 1 - r;
                                    var o = 1 / 1e-30;
                                    var n = 1 / q;
                                    var k = n;
                                    var g = 1;
                                    var e = -~(Math.log((r >= 1) ? r : 1 / r) * 8.5 + r * 0.4 + 17);
                                    var j, l;
                                    if (s < 0 || r <= 0) {
                                        return Number.NaN
                                    } else {
                                        if (s < r + 1) {
                                            for (; g <= e; g++) {
                                                m += t *= s / ++f
                                            }
                                            return (m * Math.exp(-s + r * Math.log(s) - (p)))
                                        }
                                    }
                                    for (; g <= e; g++) {
                                        j = -g * (g - r);
                                        q += 2;
                                        n = j * n + q;
                                        o = q + j / o;
                                        n = 1 / n;
                                        k *= n * o
                                    }
                                    return (1 - k * Math.exp(-s + r * Math.log(s) - (p)))
                                };
                                this.gammaPinv = function(c, i) {
                                    var g = 0;
                                    var d = i - 1;
                                    var h = 1e-8;
                                    var b = this.gammaLn(i);
                                    var k, f, o, n, e, m, l;
                                    if (c >= 1) {
                                        return Math.max(100, i + 100 * Math.sqrt(i))
                                    }
                                    if (c <= 0) {
                                        return 0
                                    }
                                    if (i > 1) {
                                        m = Math.log(d);
                                        l = Math.exp(d * (m - 1) - b);
                                        e = (c < 0.5) ? c : 1 - c;
                                        o = Math.sqrt(-2 * Math.log(e));
                                        k = (2.30753 + o * 0.27061) / (1 + o * (0.99229 + o * 0.04481)) - o;
                                        if (c < 0.5) {
                                            k = -k
                                        }
                                        k = Math.max(0.001, i * Math.pow(1 - 1 / (9 * i) - k / (3 * Math.sqrt(i)), 3))
                                    } else {
                                        o = 1 - i * (0.253 + i * 0.12);
                                        if (c < o) {
                                            k = Math.pow(c / o, 1 / i)
                                        } else {
                                            k = 1 - Math.log(1 - (c - o) / (1 - o))
                                        }
                                    }
                                    for (; g < 12; g++) {
                                        if (k <= 0) {
                                            return 0
                                        }
                                        f = this.lowRegGamma(i, k) - c;
                                        if (i > 1) {
                                            o = l * Math.exp(-(k - d) + d * (Math.log(k) - m))
                                        } else {
                                            o = Math.exp(-k + d * Math.log(k) - b)
                                        }
                                        n = f / o;
                                        k -= (o = n / (1 - 0.5 * Math.min(1, n * ((i - 1) / k - 1))));
                                        if (k <= 0) {
                                            k = 0.5 * (k + o)
                                        }
                                        if (Math.abs(o) < h * k) {
                                            break
                                        }
                                    }
                                    return k
                                };
                                this.tinv = function(d, e, c) {
                                    if (c) {
                                        d /= 2
                                    }
                                    var b = this.betaInv(2 * Math.min(d, 1 - d), 0.5 * e, 0.5);
                                    b = Math.sqrt(e * (1 - b) / b);
                                    return (d > 0.5) ? b : -b
                                };
                                this.gamma = function(b) {
                                    return Math.exp(this.gammaLn(b))
                                };
                                this.fact = function(c) {
                                    var b = new Number(c);
                                    if (c <= 1) {
                                        return 1
                                    }
                                    if (c > 100 || (c % 1)) {
                                        return Math.exp(this.gammaLn(c + 1))
                                    }
                                    while (--c) {
                                        b *= c
                                    }
                                    return b
                                };
                                this.comb = function(c, b) {
                                    return Math.floor(0.5 + Math.exp(this.gammaLn(b + 1) - this.gammaLn(c + 1) - this.gammaLn(b - c + 1)))
                                };
                                this.perm = function(c, b) {
                                    return Math.floor(0.5 + Math.exp(this.gammaLn(b + 1) - this.gammaLn(b - c + 1)))
                                };
                                this.gcd = function(d, c) {
                                    if (d == 0) {
                                        return (c || 1)
                                    }
                                    return (c ? this.gcd(c, d % c) : d)
                                };
                                this.lcm = function(d, c) {
                                    return (d / this.gcd(d, c)) * c
                                };
                                this.prime = function(f) {
                                    var e = new Number(5);
                                    var b = new Number(4);
                                    var c = parseInt(f / e);
                                    if (f == 2 || f == 3 || f == 5) {
                                        return 1
                                    }
                                    if (f < 5 || (f & 1) == 0 || (f % 3) == 0) {
                                        return 0
                                    }
                                    while (e * c < f && e < c) {
                                        c = parseInt(f / (e += (b = 6 - b)))
                                    }
                                    return (e * c == f ? 0 : 1)
                                };
                                this.implied = function(b) {
                                    if (b == "neg") {
                                        return false
                                    }
                                    return /^(\d+\.\d+|\d+\.?|\.\d+)(e[-+]?\d+)?|\w+$/.test(b)
                                };
                                this.tokenize = function(g) {
                                    var c;
                                    var b = [];
                                    var f = new String("");
                                    var d = /(\d+\.\d+|\d+\.?|\.\d+)(e[-+]?\d+)?|[xy]|[a-z]+|[-+*\/(),^]|<=?|>=?|==|!=|&&|\|\|/g;
                                    g = g.toLowerCase();
                                    g = g.replace(/\s/g, "");
                                    g = g.replace(/\+\+/g, "+");
                                    g = g.replace(/\+-/g, "-");
                                    g = g.replace(/-\+/g, "-");
                                    g = g.replace(/--/g, "+");
                                    g = g.replace(/^\+/, "");
                                    g = g.replace(/([(*\/&\|<>=])\+/g, "$1");
                                    g = g.replace(/^-/, "neg ");
                                    g = g.replace(/([(*\/&\|<>=])-/g, "$1neg ");
                                    g = g.replace(/\)(\(|\w)/g, ")*$1");
                                    g = g.replace(/(\d)\(/g, "$1*(");
                                    while (c = d.exec(g)) {
                                        if (this.implied(f) && this.implied(c[0].toString())) {
                                            b.push("*")
                                        }
                                        b.push(f = c[0])
                                    }
                                    return b
                                };
                                this.isValidEnd = function(b) {
                                    return /^(\d+\.\d+|\d+\.?|\.\d+)(e[-+]?\d+)?|[)xye]|pi|rand$/.test(b)
                                };
                                this.toPostFx = function(f) {
                                    var c = {
                                        sin: 16,
                                        cos: 16,
                                        tan: 16,
                                        sec: 16,
                                        csc: 16,
                                        cot: 16,
                                        asin: 16,
                                        acos: 16,
                                        atan: 16,
                                        asec: 16,
                                        acsc: 16,
                                        acot: 16,
                                        sinh: 16,
                                        cosh: 16,
                                        tanh: 16,
                                        sech: 16,
                                        csch: 16,
                                        coth: 16,
                                        asinh: 16,
                                        acosh: 16,
                                        atanh: 16,
                                        asech: 16,
                                        acsch: 16,
                                        acoth: 16,
                                        exp: 16,
                                        ln: 16,
                                        log: 16,
                                        logb: 16,
                                        pow: 16,
                                        sq: 16,
                                        sqrt: 16,
                                        abs: 16,
                                        sgn: 16,
                                        chs: 16,
                                        floor: 16,
                                        ceil: 16,
                                        ip: 16,
                                        fp: 16,
                                        inv: 16,
                                        min: 16,
                                        max: 16,
                                        gamma: 16,
                                        fact: 16,
                                        comb: 16,
                                        perm: 16,
                                        rand: 16,
                                        gcd: 16,
                                        lcm: 16,
                                        prime: 16,
                                        and: 16,
                                        or: 16,
                                        xor: 16,
                                        x: 16,
                                        y: 16,
                                        pi: 16,
                                        e: 16,
                                        neg: 15,
                                        not: 15,
                                        "^": 14,
                                        "*": 13,
                                        "/": 13,
                                        mod: 13,
                                        div: 13,
                                        "+": 12,
                                        "-": 12,
                                        "<": 10,
                                        "<=": 10,
                                        "==": 10,
                                        "!=": 10,
                                        ">=": 10,
                                        ">": 10,
                                        "&&": 5,
                                        "||": 4,
                                        ",": 1
                                    };
                                    var d = new String();
                                    var e = new String("");
                                    var b = new Array();
                                    var g = new Array();
                                    while (d = f.shift()) {
                                        if (d == "(") {
                                            b.push(d)
                                        } else {
                                            if (c[d]) {
                                                while (b.length && b[b.length - 1] != "(" && c[b[b.length - 1]] >= c[d]) {
                                                    g.push(b.pop())
                                                }
                                                if (d == "," && !this.isValidEnd(e)) {
                                                    g.push("Unexpected: " + e)
                                                }
                                                if (d != ",") {
                                                    b.push(d)
                                                }
                                            } else {
                                                if (d == ")") {
                                                    if (!this.isValidEnd(e)) {
                                                        g.push("Unexpected: " + e)
                                                    }
                                                    while (b.length && b[b.length - 1] != "(") {
                                                        g.push(b.pop())
                                                    }
                                                    if (b.length == 0) {
                                                        g.push("Unmatched: )")
                                                    }
                                                    b.pop()
                                                } else {
                                                    if (/^[-+]?(\d+\.?|\d*\.\d+)(e[-+]?\d+)?$/.test(d)) {
                                                        g.push(d)
                                                    } else {
                                                        g.push("Unknown: " + d)
                                                    }
                                                }
                                            }
                                        }
                                        e = d
                                    }
                                    if (!this.isValidEnd(e)) {
                                        g.push("Unexpected: " + e)
                                    }
                                    while (d = b.pop()) {
                                        if (d == "(") {
                                            g.push("Unmatched: (")
                                        }
                                        g.push(d)
                                    }
                                    return g
                                };
                                this.syntaxCheck = function(f) {
                                    var e = {
                                        sin: 1,
                                        cos: 1,
                                        tan: 1,
                                        sec: 1,
                                        csc: 1,
                                        cot: 1,
                                        asin: 1,
                                        acos: 1,
                                        atan: 1,
                                        asec: 1,
                                        acsc: 1,
                                        acot: 1,
                                        sinh: 1,
                                        cosh: 1,
                                        tanh: 1,
                                        sech: 1,
                                        csch: 1,
                                        coth: 1,
                                        asinh: 1,
                                        acosh: 1,
                                        atanh: 1,
                                        asech: 1,
                                        acsch: 1,
                                        acoth: 1,
                                        exp: 1,
                                        ln: 1,
                                        log: 1,
                                        logb: 2,
                                        pow: 2,
                                        sq: 1,
                                        sqrt: 1,
                                        abs: 1,
                                        sgn: 1,
                                        chs: 1,
                                        floor: 1,
                                        ceil: 1,
                                        ip: 1,
                                        fp: 1,
                                        inv: 1,
                                        min: 2,
                                        max: 2,
                                        gamma: 1,
                                        fact: 1,
                                        comb: 2,
                                        perm: 2,
                                        gcd: 2,
                                        lcm: 2,
                                        prime: 1,
                                        and: 2,
                                        or: 2,
                                        xor: 2,
                                        neg: 1,
                                        not: 1,
                                        "^": 2,
                                        "*": 2,
                                        "/": 2,
                                        mod: 2,
                                        div: 2,
                                        "+": 2,
                                        "-": 2,
                                        "<": 2,
                                        "<=": 2,
                                        "==": 2,
                                        "!=": 2,
                                        ">=": 2,
                                        ">": 2,
                                        "&&": 2,
                                        "||": 2
                                    };
                                    var b = new Number(0);
                                    var d = new String();
                                    for (var c = 0; c < f.length; c++, b++) {
                                        if (/^Un(matched|known|expected).*/.test(d = f[c])) {
                                            return d
                                        }
                                        if (e[d]) {
                                            if (b < e[d]) {
                                                return "Invalid use of: " + d
                                            }
                                            b -= e[d]
                                        }
                                    }
                                    return b == 1 ? false : (f.length ? "Unused arguments" : "No function")
                                };
                                this.evaluate = function(f, c, g) {
                                    alias = {
                                        "+": "add",
                                        "-": "sub",
                                        "*": "mul",
                                        "/": "div",
                                        "!": "fact",
                                        "x^y": "pow",
                                        "^": "pow",
                                        "10^": "pow10",
                                        div: "idiv",
                                        "<": "lt",
                                        "<=": "le",
                                        "==": "eq",
                                        "!=": "ne",
                                        ">=": "ge",
                                        ">": "gt",
                                        "%": "pc",
                                        "%ch": "pcch"
                                    };
                                    var b = new Array();
                                    var e = new String();
                                    for (var d = 0; d < f.length; d++) {
                                        e = f[d];
                                        if (e == "x") {
                                            b.push(c)
                                        } else {
                                            if (e == "y") {
                                                b.push(g)
                                            } else {
                                                if (e == "pi") {
                                                    b.push(Math.PI)
                                                } else {
                                                    if (e == "e") {
                                                        b.push(Math.E)
                                                    } else {
                                                        if (e == "rand") {
                                                            b.push(Math.random())
                                                        } else {
                                                            if (this[alias[e] || e]) {
                                                                b.push(this[alias[e] || e](b.pop(), this[alias[e] || e].length > 1 ? b.pop() : 0))
                                                            } else {
                                                                b.push(e)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (isNaN(b[b.length - 1])) {
                                            return Number.NaN
                                        }
                                    }
                                    return parseFloat(b.pop())
                                };
                                this.set2DPlot = function(k, h) {
                                    var l = {
                                        vars: [],
                                        smps: ["X", "Y"],
                                        data: []
                                    };
                                    var g = this.setMinX ? this.setMinX : (0 - 1);
                                    var c = this.setMaxX ? this.setMaxX : (1 - 0);
                                    var f = this.setMinY ? this.setMinY : (0 - 1);
                                    var b = this.setMaxY ? this.setMaxY : (1 - 0);
                                    var q = (c - g) / 25;
                                    var p = (b - f) / 25;
                                    var e = 1;
                                    if (h == 1) {
                                        var o = g;
                                        for (var j = 0; j < 25; j++) {
                                            var m = this.evaluate(k, o, 0);
                                            if (isNaN(m)) {
                                                m = ""
                                            }
                                            o += q;
                                            l.vars.push("v" + e);
                                            l.data.push([o, m]);
                                            e++
                                        }
                                    } else {
                                        var m = f;
                                        for (var j = 0; j < 25; j++) {
                                            var o = this.evaluate(k, 0, m);
                                            if (isNaN(o)) {
                                                o = ""
                                            }
                                            m += p;
                                            l.vars.push("v" + e);
                                            l.data.push([o, m]);
                                            e++
                                        }
                                    }
                                    return l
                                };
                                this.set3DPlot = function(l) {
                                    var m = {
                                        vars: [],
                                        smps: ["X", "Y", "Z"],
                                        data: []
                                    };
                                    var g = this.setMinX ? this.setMinX : -Math.PI / 2;
                                    var c = this.setMaxX ? this.setMaxX : Math.PI / 2;
                                    var f = this.setMinY ? this.setMinY : -Math.PI / 2;
                                    var b = this.setMaxY ? this.setMaxY : Math.PI / 2;
                                    var e = 1;
                                    for (var k = 0; k <= 25; k++) {
                                        var p = f + (b - f) * k / 25;
                                        for (var h = 0; h <= 25; h++) {
                                            var q = g + (c - g) * h / 25;
                                            var o = this.evaluate(l, q, p);
                                            if (!isFinite(o)) {
                                                o = 0
                                            }
                                            m.vars.push("v" + e);
                                            m.data.push([q, o, p]);
                                            e++
                                        }
                                    }
                                    return m
                                };
                                this.initializeFunctionData = function() {
                                    var f = this.toPostFx(this.tokenize(this.data.fx));
                                    var d = this.syntaxCheck(f);
                                    if (d) {
                                        alert(d);
                                        return
                                    }
                                    var b = 0;
                                    for (var c in f) {
                                        if (f[c] == "x") {
                                            b |= 1
                                        } else {
                                            if (f[c] == "y") {
                                                b |= 2
                                            }
                                        }
                                    }
                                    var e;
                                    if (b == 0) {
                                        b = 1
                                    }
                                    if (b == 3) {
                                        this.data.y = this.set3DPlot(f);
                                        this.graphType = "Scatter3D";
                                        this.colorBy = "Y"
                                    } else {
                                        this.data.y = this.set2DPlot(f, b);
                                        this.graphType = "Scatter2D";
                                        this.lineType = "spline"
                                    }
                                    this.scatterType = "function"
                                };
                                if (a) {
                                    this.initializeFunctionData()
                                }
                            };
                            CanvasXpress.prototype.initRemote = function(noInit) {
                                this.ajaxRequest = function(url, params, callback, format, method) {
                                    var http = this.getHttpRequest();
                                    var pars = "";
                                    for (var p in params) {
                                        pars += p + "=" + escape(params[p]) + "&"
                                    }
                                    pars += "uid=" + new Date().getTime();
                                    method = method == "POST" ? "POST" : "GET";
                                    if (http && url) {
                                        if (method == "GET") {
                                            if (url.match(/\?/)) {
                                                url += "&" + pars
                                            } else {
                                                url += "?" + pars
                                            }
                                            http.open(method, url, true);
                                            if (http.overrideMimeType) {
                                                http.overrideMimeType("text/xml")
                                            }
                                            if (format == "blob") {
                                                http.responseType = "blob"
                                            } else {
                                                if (format == "arraybuffer") {
                                                    http.responseType = "arraybuffer"
                                                }
                                            }
                                            pars = null
                                        } else {
                                            http.open(method, url, true);
                                            http.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
                                        }
                                        http.onreadystatechange = function() {
                                            if (http.readyState == 4) {
                                                if (http.status == 200 || (http.status == 0 && http.responseURL.match(/^file:/))) {
                                                    var result = "";
                                                    if ((!format || format == "" || format == "text" || format == "json") && http.responseText) {
                                                        result = http.responseText
                                                    }
                                                    if (format == "json") {
                                                        result = result.replace(/[\n\r]/g, "");
                                                        result = eval("(" + result + ")")
                                                    } else {
                                                        if (format == "blob") {
                                                            result = http.response
                                                        } else {
                                                            if (format == "arraybuffer") {
                                                                result = http.response
                                                            }
                                                        }
                                                    }
                                                    if (callback) {
                                                        callback(result)
                                                    }
                                                } else {}
                                            }
                                        };
                                        http.send(pars)
                                    }
                                };
                                this.getHttpRequest = function() {
                                    var http;
                                    if (window.XMLHttpRequest) {
                                        try {
                                            http = new XMLHttpRequest()
                                        } catch (e) {
                                            http = false
                                        }
                                    } else {
                                        if (typeof ActiveXObject != "undefined") {
                                            try {
                                                http = new ActiveXObject("Msxml2.XMLHTTP")
                                            } catch (e) {
                                                try {
                                                    http = new ActiveXObject("Microsoft.XMLHTTP")
                                                } catch (e) {
                                                    http = false
                                                }
                                            }
                                        }
                                    }
                                    return http
                                };
                                this.requestRemoteData = function(ini) {
                                    var params = this.cloneObject(this.remoteParams);
                                    params.index = this.remoteDataIndex;
                                    params.dir = this.remoteDirection;
                                    if (ini) {
                                        params.records = true
                                    }
                                    if (this.remoteServiceType == "file") {
                                        this.ajaxRequest(this.remoteData[this.remoteDataIndex][1], params, this.updateRemoteData, "json", "GET")
                                    } else {
                                        this.ajaxRequest(this.remoteService, params, this.updateRemoteData, "json", "GET")
                                    }
                                };
                                this.updateGenomeData = function(url, params, callback) {
                                    var that = this;
                                    var update = function(data) {
                                        if (params.gene) {
                                            that.setMinX = null;
                                            that.setMaxX = null
                                        }
                                        that.updateData(data);
                                        that.hideMask();
                                        if (callback) {
                                            callback()
                                        }
                                    };
                                    this.ajaxRequest(url, params, update, "json", "GET")
                                };
                                this.getGeneFromGenomeObject = function(o) {
                                    return o && o[0] && o[0].data && o[0].data[0] && o[0].data[0].id ? o[0].data[0].id : false
                                };
                                this.saveRemote = function(type, name, object) {
                                    var params = this.cloneObject(this.remoteParams);
                                    params.index = this.remoteDataIndex;
                                    params.save = type;
                                    if (name) {
                                        params.name = this.stringifyJSON(name)
                                    }
                                    var config = object ? object : this.getConfig();
                                    if (this.graphType == "Network") {
                                        config.calculateLayout = false
                                    }
                                    params.params = this.stringifyJSON(config);
                                    params.afterRender = this.stringifyJSON(CanvasXpress.stack[this.target].afterRender);
                                    params.cxdata = this.stringifyJSON(this.cloneObject(this.data));
                                    this.ajaxRequest(this.remoteService, params, function() {
                                        alert("CanvasXpress data saved " + type + " in the server")
                                    }, "json", "POST")
                                };
                                this.clearRemote = function() {
                                    var that = this;
                                    params.clear = true;
                                    this.ajaxRequest(this.remoteService, params, function() {
                                        alert("CanvasXpress data parameters clear from the server")
                                    }, "json", "POST")
                                };
                                this.castRemoteParameters = function(o) {
                                    o.remoteParentId = this.remoteParentId;
                                    o.remoteService = this.remoteService;
                                    o.remoteDirection = this.remoteDirection;
                                    o.remoteDataIndex = this.remoteDataIndex;
                                    o.remoteAutoPlay = this.remoteAutoPlay;
                                    o.remoteAutoPlayDelay = this.remoteAutoPlayDelay;
                                    o.remoteData = this.remoteData;
                                    o.remoteIds = this.remoteIds;
                                    o.remoteServiceType = this.remoteServiceType;
                                    this.remoteTransitionEffect = o.remoteTransitionEffect;
                                    for (var p in this.remoteParams) {
                                        o.remoteParams[p] = this.remoteParams[p]
                                    }
                                    o.addRemoveNavigationListeners("addEvtListener")
                                };
                                this.getOriginalDimensions = function() {
                                    var o = this.$(this.target);
                                    return [parseInt(o.width), parseInt(o.height)]
                                };
                                this.fitCanvasToCurrent = function(n) {
                                    if (this.remoteAutoSize) {
                                        var atts = ["resizable", "responsive", "aspectratio"];
                                        var fit = false;
                                        for (var i = 0; i < atts.length; i++) {
                                            var v = this.meta.canvas.ctx.canvas.getAttribute(atts[i]);
                                            if (v) {
                                                n.meta.canvas.ctx.canvas.setAttribute(atts[i], v);
                                                fit = true
                                            }
                                        }
                                        if (fit || n.width != this.width || n.height != this.height) {
                                            n.setDimensions(this.width, this.height);
                                            n.resizable = this.resizable;
                                            n.resizableX = this.resizableX;
                                            n.resizableY = this.resizableY
                                        }
                                    }
                                };
                                this.updateRemoteData = function(t) {
                                    return function(res, callback) {
                                        if ((res && res.data) || (res && res.config && res.config.graphType && res.config.graphType == "Map") || (res && res.config && res.config.graphType && res.config.graphType == "Genome" && res.tracks)) {
                                            var d;
                                            if (t.remoteServiceType == "file") {
                                                d = res.config ? res : res.data;
                                                d.renderTo = res.renderTo || t.remoteData[t.remoteDataIndex][0];
                                                var trt = d.renderTo;
                                                var cnt = 0;
                                                var nrt = t.$(d.renderTo);
                                                while (nrt) {
                                                    if (d.renderTo.match(/-\d*$/)) {
                                                        cnt = Number(d.renderTo.split("-").pop()) + 1;
                                                        d.renderTo = d.renderTo.replace(/\d*$/, cnt)
                                                    } else {
                                                        cnt++;
                                                        d.renderTo = trt + "-" + cnt
                                                    }
                                                    nrt = t.$(d.renderTo)
                                                }
                                                if (trt != d.renderTo) {
                                                    CanvasXpress.chain[trt] = d.renderTo
                                                }
                                            } else {
                                                d = t.appendUserConfig(res.data)
                                            }
                                            var a = d.uploadFile || res.uploadFile ? false : t.remoteDirection == "next" ? true : false;
                                            var w = t.$("container-" + t.target);
                                            if (w) {
                                                var p = w.parentNode;
                                                var o = t.getOriginalDimensions();
                                                var l = t.target;
                                                var ar = [];
                                                var fc = res.config || (res.data && res.data.config);
                                                var trg = d.renderTo || t.newId("-cX-data-");
                                                var wid = d.config && d.config.width ? d.config.width : o[0];
                                                var hei = d.config && d.config.height ? d.config.height : o[1];
                                                t.insertTarget(trg, w, wid, hei, a);
                                                d.hidden = d.uploadFile ? false : true;
                                                t.isUpdateRemoteData = true;
                                                d.config.skipRender = t.isOneTimeFunctionInConfig(d.config);
                                                if (d.uploadFile) {
                                                    w.style.display = "none"
                                                }
                                                if (res.afterRender) {
                                                    for (var i = 0; i < res.afterRender.length; i++) {
                                                        if (res.afterRender[i][0] == "segregate") {
                                                            if (res.afterRender[i][1][0] == "Variables") {
                                                                ar.push(["segregateVariables", res.afterRender[i][1][1]])
                                                            } else {
                                                                if (res.afterRender[i][1][0] == "Samples") {
                                                                    ar.push(["segregateSamples", res.afterRender[i][1][1]])
                                                                }
                                                            }
                                                        } else {
                                                            ar.push(t.cloneObject(res.afterRender[i]))
                                                        }
                                                    }
                                                    delete(d.afterRender)
                                                }
                                                if (d.data) {
                                                    t.cleanData(d.data)
                                                }
                                                if (d.data) {
                                                    delete d.data.l;
                                                    delete d.data.w
                                                }
                                                var n = new CanvasXpress(d);
                                                n.isUpdateRemoteData = true;
                                                n.target0 = t.target0 ? t.target0 : t.target;
                                                t.castRemoteParameters(n);
                                                t.addSelectOptionsRemoteData(res.ids);
                                                t.resetInfoSpan(false, true);
                                                t.animateTransition(p, l, d.uploadFile, t.isExample);
                                                if (fc && !n.dataURL) {
                                                    if (n.imagesToLoad.length) {
                                                        n.loadImages(n.imagesToLoad, ar);
                                                        return
                                                    } else {
                                                        n.afterRender(ar);
                                                        n.skipRender = false;
                                                        t.fitCanvasToCurrent(n)
                                                    }
                                                } else {
                                                    if (res.postprocess) {
                                                        for (var i = 0; i < res.postprocess.length; i++) {
                                                            var fn = res.postprocess[i].func;
                                                            var pr = res.postprocess[i].param;
                                                            if (fn) {
                                                                if (fn == "groupSamples" && n.isGroupedData) {
                                                                    continue
                                                                }
                                                                if (pr) {
                                                                    n[fn].apply(n, pr)
                                                                } else {
                                                                    n[fn]()
                                                                }
                                                            }
                                                        }
                                                        t.fitCanvasToCurrent(n)
                                                    }
                                                }
                                                if (res.info) {
                                                    n.updateInfoDiv(res.info)
                                                }
                                                if (t.showCode) {
                                                    n.updateCodeDiv()
                                                }
                                                if (callback) {
                                                    callback(n)
                                                }
                                                if (t.userEvents.remoteupdate) {
                                                    t.userEvents.remoteupdate.call(n, n)
                                                }
                                            }
                                        } else {
                                            t.remoteDataIndex = t.remoteDirection == "next" ? Math.max(0, t.remoteDataIndex - 1) : Number(t.remoteDataIndex) + 1;
                                            t.remoteUpdating = false
                                        }
                                    }
                                }(this);
                                this.appendUserConfig = function(d) {
                                    if (d.config) {
                                        for (var i in this.meta.config.user) {
                                            if (!i.match(/decrease|remote|^calculateLayout$|layoutComb/)) {
                                                if (!d.config[i]) {
                                                    d.config[i] = this.meta.config.user[i]
                                                }
                                            }
                                        }
                                    }
                                    return d
                                };
                                this.updateCurrentRemoteData = function() {
                                    var s = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSelect");
                                    if (s) {
                                        s.selectedIndex = this.remoteDataIndex;
                                        if (this.remoteIds.length == 0) {
                                            for (var i = 0; i < s.childNodes.length; i++) {
                                                this.remoteIds.push(s.childNodes[i].text)
                                            }
                                        }
                                        this.resetSelectOptionsRemoteData()
                                    }
                                };
                                this.resetSelectOptionsRemoteData = function() {
                                    var s = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSelect");
                                    if (s) {
                                        if (this.remoteIds.length == 0) {
                                            for (var i = 0; i < s.childNodes.length; i++) {
                                                this.remoteIds.push(s.childNodes[i].text)
                                            }
                                        }
                                        this.clearSelectOptionsRemoteData();
                                        this.addSelectOptionsRemoteData(this.remoteIds)
                                    }
                                };
                                this.clearSelectOptionsRemoteData = function() {
                                    var s = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSelect");
                                    var d = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDotsDiv");
                                    if (s && s.hasChildNodes() && d) {
                                        while (s.childNodes.length >= 1) {
                                            s.removeChild(s.firstChild)
                                        }
                                        while (d.childNodes.length >= 1) {
                                            d.removeChild(d.firstChild)
                                        }
                                    }
                                };
                                this.addSelectOptionsRemoteData = function(ids) {
                                    if (ids && ids.length > 0) {
                                        this.remoteIds = ids;
                                        var b = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDiv");
                                        var s = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSelect");
                                        var d = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDotsDiv");
                                        var x = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarButtonsDiv");
                                        var f = this.meta.canvas.canvasPixelRatio;
                                        if (b && s && d && x) {
                                            this.clearSelectOptionsRemoteData();
                                            for (var i = 0; i < this.remoteIds.length; i++) {
                                                var opt = this.$cX("option", {
                                                    text: this.remoteIds[i],
                                                    value: i
                                                });
                                                if (this.remoteDataIndex == i) {
                                                    opt.selected = "selected";
                                                    s.selectedIndex = this.remoteDataIndex
                                                }
                                                try {
                                                    s.add(opt, null)
                                                } catch (ex) {
                                                    s.add(opt)
                                                }
                                            }
                                            var max = Math.min(this.remoteIds.length, 8);
                                            var idx = Number(this.remoteDataIndex);
                                            for (var i = 0; i < max; i++) {
                                                var jj = (idx + i) % this.remoteIds.length;
                                                var ii = this.$cX("div", {
                                                    id: this.remoteParentId + "-canvasXpressRemoteWindowBarDotsIndex" + i,
                                                    className: "CanvasXpressSlider CanvasXpressSliderDots",
                                                    alt: this.remoteIds[jj],
                                                    title: this.remoteIds[jj]
                                                }, {
                                                    cssFloat: "left",
                                                    position: "relative",
                                                    border: "1px solid rgba(35, 82, 124, 0.5)"
                                                });
                                                ii.dataset.index = jj;
                                                d.appendChild(ii)
                                            }
                                            if (this.remoteIds.length <= 8) {
                                                x.style.display = "none"
                                            }
                                            if (this.remoteIds.length == 1) {
                                                this.hideNavigation()
                                            } else {
                                                this.showNavigation()
                                            }
                                            var l = (((this.meta.canvas.ctx.canvas.width / f) - d.clientWidth) / 2) + 16;
                                            b.style.left = l + "px"
                                        }
                                    } else {
                                        if (!this.remoteIds || this.remoteIds.length == 1) {
                                            var w = this.$(this.remoteParentId + "-canvasXpressRemoteWindow");
                                            if (w) {
                                                w.style.height = (this.meta.canvas.ctx.canvas.height / f) + "px"
                                            }
                                        }
                                    }
                                };
                                this.updateRemoteDots = function() {
                                    var d = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDotsDiv");
                                    if (d) {
                                        var max = Math.min(this.remoteIds.length, 8);
                                        var idx = this.remoteDataIndex;
                                        for (var i = 0; i < max; i++) {
                                            var jj = (idx + i) % this.remoteIds.length;
                                            var ii = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDotsIndex" + i);
                                            if (ii) {
                                                ii.dataIndex = jj;
                                                ii.alt = this.remoteIds[jj];
                                                ii.title = this.remoteIds[jj]
                                            }
                                        }
                                    }
                                };
                                this.animateTransition = function(b, o, f, q) {
                                    if (b) {
                                        var c1, c2;
                                        var cn = b.childNodes;
                                        for (var i = 0; i < cn.length; i++) {
                                            if (cn[i].nodeName.toUpperCase() == "DIV") {
                                                c1 = cn[i];
                                                c1.className = "CanvasXpressContainerNT";
                                                break
                                            }
                                        }
                                        for (var i = cn.length - 1; i >= 0; i--) {
                                            if (cn[i].nodeName.toUpperCase() == "DIV") {
                                                c2 = cn[i];
                                                c2.className = "CanvasXpressContainerNT";
                                                break
                                            }
                                        }
                                        if (!b.id.match("canvasXpressRemoteWindowBuffer")) {
                                            if (f) {
                                                b.removeChild(c2)
                                            } else {
                                                b.removeChild(c1)
                                            }
                                            this.remoteUpdating = false
                                        } else {
                                            var that = this;
                                            var step = this.transitionStep;
                                            var s = 0;
                                            var w = c1.clientWidth ? c1.clientWidth : b.clientWidth;
                                            var h = c1.clientHeight ? c1.clientHeight : b.clientHeight;
                                            b.parentNode.style.overflow = "hidden";
                                            if (q) {
                                                c1.style.display = "none"
                                            }
                                            if (this.remoteTransitionEffect == "fade") {
                                                var l = this.remoteDirection == "next" && !f ? 1 : 0;
                                                var t = this.remoteDirection == "next" && !f ? 0 : 1;
                                                c1.style.opacity = l;
                                                c1.style.filter = "alpha(opacity = " + (l * 100) + ")";
                                                c1.style.position = "absolute";
                                                c1.style.display = "block";
                                                c2.style.opacity = t;
                                                c2.style.filter = "alpha(opacity = " + (t * 100) + ")";
                                                c2.style.position = "absolute";
                                                c2.style.display = "block";
                                                var updater = function() {
                                                    var n = 1 / step;
                                                    this.update = function() {
                                                        var l, t;
                                                        if (that.remoteDirection == "next" && !f) {
                                                            l = 1 - (n * s);
                                                            t = 0 + (n * s)
                                                        } else {
                                                            t = 1 - (n * s);
                                                            l = 0 + (n * s)
                                                        }
                                                        if (s >= step) {
                                                            clearInterval(clearUpdateInt);
                                                            var c1Id = c1.id.replace("container-", "");
                                                            var c2Id = c2.id.replace("container-", "");
                                                            that.destroy(o);
                                                            var c = CanvasXpress.$(c1Id) || CanvasXpress.$(c2Id);
                                                            c1.style.position = "";
                                                            c2.style.position = "";
                                                            that.remoteUpdating = false;
                                                            that.updateCurrentRemoteData();
                                                            that.isUpdateRemoteData = false;
                                                            that.triggerDataLoaded("animateTransition", c)
                                                        } else {
                                                            c1.style.opacity = l;
                                                            c1.style.filter = "alpha(opacity = " + (l * 100) + ")";
                                                            c2.style.opacity = t;
                                                            c2.style.filter = "alpha(opacity = " + (t * 100) + ")"
                                                        }
                                                        s++
                                                    };
                                                    var clearUpdateInt = that.setInterval(this.update, 100)
                                                };
                                                updater.call()
                                            } else {
                                                var updater = function() {
                                                    this.update = function() {
                                                        b.style.width = (w * 2) + "px";
                                                        b.style.height = (Math.max(c1.clientHeight, c2.clientHeight)) + "px";
                                                        var n = that.remoteTransitionEffect == "slide" ? Math.atan((s / step) * 10 - 5) * 0.5 / Math.atan(5) + 0.5 : 1;
                                                        var l = w * n;
                                                        var t = h * n;
                                                        if (s >= step) {
                                                            clearInterval(clearUpdateInt);
                                                            var c1Id = c1.id.replace("container-", "");
                                                            var c2Id = c2.id.replace("container-", "");
                                                            that.destroy(o);
                                                            var c = CanvasXpress.$(c1Id) || CanvasXpress.$(c2Id);
                                                            if (that.remoteDirection == "next" && !f) {
                                                                c2.style.left = 0 + "px"
                                                            } else {
                                                                c1.style.left = 0 + "px"
                                                            }
                                                            b.parentNode.style.overflow = "visible";
                                                            b.style.width = w + "px";
                                                            b.style.height = h + "px";
                                                            that.remoteUpdating = false;
                                                            that.updateCurrentRemoteData();
                                                            that.isUpdateRemoteData = false;
                                                            that.triggerDataLoaded("animateTransition", c)
                                                        } else {
                                                            if (that.remoteDirection == "next" && !f) {
                                                                c1.style.left = (l * -1) + "px";
                                                                c2.style.left = (l * -1) + "px"
                                                            } else {
                                                                c1.style.left = (-w + l) + "px";
                                                                c2.style.left = (-w + l) + "px"
                                                            }
                                                            c1.style.display = "block";
                                                            c2.style.display = "block"
                                                        }
                                                        s++
                                                    };
                                                    var clearUpdateInt = that.setInterval(this.update, 100)
                                                };
                                                updater.call()
                                            }
                                        }
                                    }
                                };
                                this.handleRemoteSelect = function(t) {
                                    return function(e) {
                                        var s = t.getTargetEvent(e);
                                        var i = s.children[s.selectedIndex].value;
                                        var c = t.$(t.remoteParentId + "-canvasXpressRemoteWindowBarCurrent");
                                        var d = t.$(t.remoteParentId + "-canvasXpressRemoteWindowBarSelectContainerDiv");
                                        t.remoteDirection = i > Number(t.remoteDataIndex) ? "next" : "previous";
                                        t.remoteDataIndex = Number(i);
                                        if (c && s && d) {
                                            t.resetSelectOptionsRemoteData();
                                            c.value = "";
                                            d.style.display = "none"
                                        }
                                        t.requestRemoteData()
                                    }
                                }(this);
                                this.swapRemotePlayStop = function(play) {
                                    var p = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarPlayDiv");
                                    var s = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarStopDiv");
                                    if (p && s) {
                                        p.style.display = play ? "block" : "none";
                                        s.style.display = play ? "none" : "block"
                                    }
                                };
                                this.handleRemoteClickStop = function(t) {
                                    return function(e) {
                                        t.remoteStop = true;
                                        t.swapRemotePlayStop(true)
                                    }
                                }(this);
                                this.handleRemoteClickDot = function(t) {
                                    return function(e) {
                                        var r = t.getTargetEvent(e);
                                        if (r.hasAttribute("data-index")) {
                                            t.remoteDirection = t.remoteDirection > Number(r.dataset.index) ? "next" : "previous";
                                            t.remoteDataIndex = Number(r.dataset.index);
                                            t.requestRemoteData()
                                        }
                                    }
                                }(this);
                                this.handleRemoteClickPlay = function(t) {
                                    return function(e) {
                                        var r = t.getTargetEvent(e);
                                        var s = r.parentNode.parentNode.parentNode.parentNode.lastChild.firstChild.lastChild;
                                        t.remoteDirection = "next";
                                        t.remoteStop = false;
                                        t.handleRemoteClickDown(e, true);
                                        t.playRemoteData(s);
                                        t.swapRemotePlayStop()
                                    }
                                }(this);
                                this.playRemoteData = function(s) {
                                    var getRef = function(trg) {
                                        for (var i = 0; i < CanvasXpress.instances.length; i++) {
                                            if (trg == CanvasXpress.instances[i].target0) {
                                                return CanvasXpress.instances[i];
                                                break
                                            }
                                        }
                                        for (var i = 0; i < CanvasXpress.instances.length; i++) {
                                            if (trg == CanvasXpress.instances[i].target) {
                                                return CanvasXpress.instances[i];
                                                break
                                            }
                                        }
                                        return CanvasXpress.instances[0]
                                    };
                                    var id = this.target0 || this.target;
                                    var updater = function() {
                                        var that = getRef(id);
                                        if (that) {
                                            if (!that.remoteUpdating && !that.remoteStop) {
                                                that.remoteUpdating = true;
                                                that.showInfoSpan(false, "Updating ...", true);
                                                if (s && s.tagName.match(/select/i) && Number(that.remoteDataIndex) >= s.length - 1) {
                                                    that.remoteDataIndex = 0
                                                } else {
                                                    that.remoteDataIndex++
                                                }
                                                that.requestRemoteData()
                                            }
                                        }
                                        this.update = function() {
                                            var that = getRef(id);
                                            if (that) {
                                                if (!that.remoteUpdating && !that.remoteStop) {
                                                    that.remoteUpdating = true;
                                                    that.showInfoSpan(false, "Updating ...", true);
                                                    if (s && s.tagName.match(/select/i) && Number(that.remoteDataIndex) >= s.length - 1) {
                                                        that.remoteDataIndex = 0
                                                    } else {
                                                        that.remoteDataIndex++
                                                    }
                                                    that.requestRemoteData()
                                                }
                                                if (that.remoteStop) {
                                                    clearInterval(cl)
                                                }
                                            } else {
                                                clearInterval(cl)
                                            }
                                        };
                                        var cl = that.setInterval(this.update, that.remoteAutoPlayDelay)
                                    };
                                    updater.call()
                                };
                                this.handleRemoteClickPrev = function(t) {
                                    return function(e) {
                                        if (!t.remoteUpdating) {
                                            t.remoteUpdating = true;
                                            t.showInfoSpan(false, "Updating ...", true);
                                            t.remoteDirection = "previous";
                                            if (t.remoteDataIndex == 0) {
                                                t.remoteDataIndex = t.remoteIds.length - 1
                                            } else {
                                                t.remoteDataIndex--
                                            }
                                            t.requestRemoteData()
                                        }
                                    }
                                }(this);
                                this.handleRemoteClickNext = function(t) {
                                    return function(e) {
                                        if (!t.remoteUpdating) {
                                            t.remoteUpdating = true;
                                            t.showInfoSpan(false, "Updating ...", true);
                                            t.remoteDirection = "next";
                                            if (t.remoteDataIndex == t.remoteIds.length - 1) {
                                                t.remoteDataIndex = 0
                                            } else {
                                                t.remoteDataIndex++
                                            }
                                            t.requestRemoteData()
                                        }
                                    }
                                }(this);
                                this.handleRemoteClickDown = function(t) {
                                    return function(e, x) {
                                        if (!t.remoteUpdating) {
                                            var d = t.$(t.remoteParentId + "-canvasXpressRemoteWindowBarSelectContainerDiv");
                                            var s = t.$(t.remoteParentId + "-canvasXpressRemoteWindowBarSelect");
                                            if (d && s) {
                                                if (d.style.display == "none" && !x) {
                                                    s.options[s.selectedIndex].selected = true;
                                                    d.style.display = "block";
                                                    t.transitionMagic(d, "holeIn")
                                                } else {
                                                    t.transitionMagic(d, "holeOut", function() {
                                                        d.style.display = "none"
                                                    }, 1000)
                                                }
                                                if (!x) {
                                                    t.handleRemoteClickStop(e)
                                                }
                                            }
                                        }
                                    }
                                }(this);
                                this.addRemoteNavigation = function(w) {
                                    var top = ((this.meta.canvas.ctx.canvas.height / 2) - 25);
                                    var nav = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBar"
                                    }, {
                                        width: this.meta.canvas.ctx.canvas.width + "px",
                                        position: "absolute",
                                        zIndex: 2147483647,
                                        display: "none"
                                    });
                                    var prd = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarPrevDiv",
                                        className: "CanvasXpressSliderRemote CanvasXpressSliderLeft"
                                    }, {
                                        top: top + "px"
                                    });
                                    var prv = this.$cXI("v_previous", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarPrev",
                                        src: "v_previous",
                                        title: "Previous graph"
                                    });
                                    prd.appendChild(prv);
                                    nav.appendChild(prd);
                                    var bot = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarDiv"
                                    }, {
                                        height: "36px",
                                        top: (this.meta.canvas.ctx.canvas.height + 8) + "px",
                                        position: "absolute"
                                    });
                                    var dtd = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarDotsDiv",
                                        className: "CanvasXpressSliderDotsContainer"
                                    }, {
                                        cssFloat: "left",
                                        position: "relative"
                                    });
                                    bot.appendChild(dtd);
                                    var but = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarButtonsDiv"
                                    }, {
                                        cssFloat: "left",
                                        position: "relative"
                                    });
                                    var pld = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarPlayDiv",
                                        className: "CanvasXpressSliderRemote"
                                    }, {
                                        cssFloat: "left",
                                        position: "relative",
                                        width: "24px",
                                        height: "24px",
                                        marginLeft: "5px"
                                    });
                                    var ply = this.$cXI("v_play", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarPlay",
                                        src: "v_play",
                                        title: "Iterate over graphs"
                                    }, {
                                        margin: "2px 5px",
                                        width: "16px"
                                    });
                                    pld.appendChild(ply);
                                    but.appendChild(pld);
                                    var psd = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarStopDiv",
                                        className: "CanvasXpressSliderRemote"
                                    }, {
                                        cssFloat: "left",
                                        position: "relative",
                                        width: "24px",
                                        height: "24px",
                                        marginLeft: "5px",
                                        display: "none"
                                    });
                                    var pse = this.$cXI("v_pause", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarStop",
                                        src: "v_pause",
                                        title: "Stop iteration"
                                    }, {
                                        margin: "3px",
                                        width: "16px"
                                    });
                                    psd.appendChild(pse);
                                    but.appendChild(psd);
                                    var srd = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarSearchDiv",
                                        className: "CanvasXpressSliderRemote"
                                    }, {
                                        cssFloat: "left",
                                        position: "relative",
                                        width: "24px",
                                        height: "24px"
                                    });
                                    var srh = this.$cXI("z_zoom", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarSearch",
                                        src: "z_zoom",
                                        title: "Search datasets"
                                    }, {
                                        margin: "3px",
                                        width: "16px"
                                    });
                                    srd.appendChild(srh);
                                    but.appendChild(srd);
                                    bot.appendChild(but);
                                    nav.appendChild(bot);
                                    var nxd = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarNextDiv",
                                        className: "CanvasXpressSliderRemote CanvasXpressSliderRight"
                                    }, {
                                        top: top + "px"
                                    });
                                    var nxt = this.$cXI("v_next", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarNext",
                                        src: "v_next",
                                        title: "Next graph"
                                    });
                                    nxd.appendChild(nxt);
                                    nav.appendChild(nxd);
                                    var wid = this.meta.canvas.ctx.canvas.width * 0.85;
                                    var lft = (this.meta.canvas.ctx.canvas.width - wid) / 2;
                                    var cnd = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarSelectContainerDiv"
                                    }, {
                                        width: wid + "px",
                                        top: top + "px",
                                        left: lft + "px",
                                        position: "absolute",
                                        border: "1px solid rgb(51,122,183)",
                                        borderRadius: "5px",
                                        padding: "5px",
                                        background: "rgba(245, 245, 245, 0.95)",
                                        display: "none"
                                    });
                                    var sld = this.$cX("div", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarSelectDiv"
                                    }, {
                                        border: "1px solid rgb(51,122,183)",
                                        borderRadius: "5px",
                                        background: "rgba(245, 245, 245, 0.95)"
                                    });
                                    var cur = this.$cX("input", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarCurrent",
                                        className: "CanvasXpressSlider",
                                        type: "text",
                                        autocomplete: "off",
                                        placeholder: "Search"
                                    });
                                    sld.appendChild(cur);
                                    var sel = this.$cX("select", {
                                        id: this.remoteParentId + "-canvasXpressRemoteWindowBarSelect",
                                        className: "CanvasXpressSlider",
                                        size: 4
                                    }, {
                                        border: "none"
                                    });
                                    sld.appendChild(sel);
                                    cnd.appendChild(sld);
                                    nav.appendChild(cnd);
                                    return nav
                                };
                                this.addRemoveNavigationListeners = function(t) {
                                    var r = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarPrev");
                                    var p = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarPlay");
                                    var e = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarStop");
                                    var f = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarNext");
                                    var d = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSearch");
                                    var s = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSelect");
                                    var q = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDotsDiv");
                                    if (r) {
                                        this[t](r, "click", this.handleRemoteClickPrev, false)
                                    }
                                    if (p) {
                                        this[t](p, "click", this.handleRemoteClickPlay, false)
                                    }
                                    if (e) {
                                        this[t](e, "click", this.handleRemoteClickStop, false)
                                    }
                                    if (f) {
                                        this[t](f, "click", this.handleRemoteClickNext, false)
                                    }
                                    if (d) {
                                        this[t](d, "click", this.handleRemoteClickDown, false)
                                    }
                                    if (s) {
                                        this[t](s, "change", this.handleRemoteSelect, false)
                                    }
                                    if (q) {
                                        this[t](q, "click", this.handleRemoteClickDot, false)
                                    }
                                };
                                this.selectDataSet = function(e) {
                                    var t = window.document.activeElement;
                                    if (t.id == this.remoteParentId + "-canvasXpressRemoteWindowBarCurrent") {
                                        var s = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSelect");
                                        var p = [];
                                        if (s && t.value.length > 0) {
                                            if (this.remoteIds.length == 0) {
                                                for (var i = 0; i < s.childNodes.length; i++) {
                                                    this.remoteIds.push(s.childNodes[i].text)
                                                }
                                            }
                                            this.clearSelectOptionsRemoteData();
                                            for (var i = 0; i < this.remoteIds.length; i++) {
                                                if (this.remoteIds[i].toLowerCase().indexOf(t.value.toLowerCase()) >= 0) {
                                                    p.push(i)
                                                }
                                            }
                                            for (var i = 0; i < p.length; i++) {
                                                var o = this.$cX("option", {
                                                    text: this.remoteIds[p[i]],
                                                    value: p[i]
                                                });
                                                try {
                                                    s.add(o, null)
                                                } catch (ex) {
                                                    s.add(o)
                                                }
                                            }
                                        }
                                    }
                                };
                                this.updateRemoteNavigationWindow = function(clb) {
                                    var c = this.$(this.target);
                                    var b = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBuffer");
                                    if (c && b) {
                                        this.updateRemoteNavigationWindowBar();
                                        b.style.width = (parseInt(c.parentNode.parentNode.clientWidth) * 2) + "px";
                                        if (clb) {
                                            clb()
                                        }
                                    }
                                };
                                this.updateRemoteNavigationWindowBar = function() {
                                    var top = ((this.meta.canvas.ctx.canvas.height / 2) - 25);
                                    var wid = this.meta.canvas.ctx.canvas.width * 0.85;
                                    var lft = (this.meta.canvas.ctx.canvas.width - wid) / 2;
                                    var bar = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBar");
                                    var prv = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarPrevDiv");
                                    var bot = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDiv");
                                    var dot = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarDotsDiv");
                                    var nxt = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarNextDiv");
                                    var sel = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBarSelectContainerDiv");
                                    if (bar && prv && bot && dot && nxt && sel) {
                                        bar.style.width = this.meta.canvas.ctx.canvas.width + "px";
                                        prv.style.top = top + "px";
                                        bot.style.top = (this.meta.canvas.ctx.canvas.height + 8) + "px";
                                        bot.style.left = (((this.meta.canvas.ctx.canvas.width - dot.clientWidth) / 2) + 16) + "px";
                                        nxt.style.left = (this.meta.canvas.ctx.canvas.width + 10) + "px";
                                        nxt.style.top = top + "px";
                                        sel.style.width = wid + "px";
                                        sel.style.top = top + "px";
                                        sel.style.left = lft + "px"
                                    }
                                };
                                this.addRemoteWindow = function() {
                                    var w = this.$("container-" + this.target);
                                    var c = this.$(this.target);
                                    var p = w.parentNode;
                                    var y = this.topoJSONURL ? 0 : 44;
                                    if (p.id && !p.id.match(/canvasXpressRemoteWindow/)) {
                                        this.remoteParentId = p.id + (p.id.match("-" + this.target) ? "" : "-" + this.target);
                                        var d = this.$cX("div", {
                                            id: this.remoteParentId + "-canvasXpressRemoteWindow"
                                        }, {
                                            height: (y + c.height) + "px",
                                            width: c.width + "px",
                                            position: "relative"
                                        });
                                        var t = this.addRemoteNavigation();
                                        var v = this.$cX("div", {
                                            id: this.remoteParentId + "-canvasXpressRemoteWindowBuffer"
                                        }, {
                                            position: "absolute"
                                        });
                                        d.appendChild(t);
                                        d.appendChild(v);
                                        p.insertBefore(d, w);
                                        v.appendChild(w.parentNode.appendChild(w));
                                        this.addRemoveNavigationListeners("addEvtListener");
                                        this.requestRemoteData(true);
                                        this.initialRemoteDataRequest = true;
                                        if (this.remoteAutoPlay) {
                                            this.remoteUpdating = true;
                                            this.remoteDirection = "next";
                                            this.remoteStop = false;
                                            this.playRemoteData(t.lastChild)
                                        }
                                    } else {
                                        this.initialRemoteDataRequest = false
                                    }
                                };
                                this.hideNavigation = function(n) {
                                    var t = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBar");
                                    if (t) {
                                        t.style.display = "none"
                                    }
                                };
                                this.showNavigation = function() {
                                    var t = this.$(this.remoteParentId + "-canvasXpressRemoteWindowBar");
                                    if (t) {
                                        t.style.display = "block"
                                    }
                                };
                                this.initializeRemote = function() {
                                    if ((this.remoteService || this.dataURL || this.dataString || this.topoJSONURL) && !noInit) {
                                        this.addRemoteWindow()
                                    }
                                }
                            };
                            CanvasXpress.prototype.initGraph = function() {
                                this.draw = function(e) {
                                    var a = e && e.width ? e.width : false;
                                    var d = e && e.height ? e.height : false;
                                    var c = e && e.network ? e.network : false;
                                    var b = e && e.noImages ? e.noImages : false;
                                    this.meta.time.start = new Date().getTime();
                                    this.setUserEvents();
                                    this.validateUserColors();
                                    this.stack(e);
                                    this.initializeGraph(true, a, d, false, c, b);
                                    this.meta.time.end = new Date().getTime();
                                    this.meta.time.elapsed = this.meta.time.end - this.meta.time.start;
                                    this.hideMask()
                                };
                                this.redraw = function(d) {
                                    var a = d && (d.shiftKey || d.ctrlKey || d.altKey || d.metaKey);
                                    if (a) {
                                        this.resetRender(false, true)
                                    }
                                    var c = this.isCorrelate ? {
                                        transpose: this.isCorrelateTranspose,
                                        key: this.isCorrelateKey,
                                        color: this.isCorrelateColor
                                    } : false;
                                    if (c) {
                                        this.removeCorrelation(true)
                                    }
                                    var b = this.isHistogram ? {
                                        histogram: this.isCreateHistogram,
                                        xAxis: this.xAxis,
                                        yAxis: this.yAxis
                                    } : false;
                                    this.hardReset(d);
                                    if (this.isQQ || this.isCDF) {
                                        this.setMinX = null;
                                        this.setMaxX = null;
                                        this.setMinY = null;
                                        this.setMaxY = null
                                    }
                                    if (b) {
                                        this.graphType = "Scatter2D";
                                        this.isHistogram = true;
                                        this.isCreateHistogram = b.histogram;
                                        this.xAxis = b.xAxis;
                                        this.yAxis = b.yAxis
                                    }
                                    if (c) {
                                        this.correlateData(c.transpose, c.key, c.color, true)
                                    }
                                    if ((this.data.y && this.data.y.pie) || this.graphType == "Pie") {
                                        this.xAxis = false;
                                        this.yAxis = false;
                                        this.graphType = "Pie"
                                    }
                                    if (this.data.y && this.data.y.treemap) {
                                        this.xAxis = false;
                                        this.yAxis = false;
                                        this.graphType = "Treemap"
                                    }
                                    this.draw({
                                        func: "redraw",
                                        par: [d]
                                    })
                                };
                                this.noDraw = function(a) {
                                    this.stack(a)
                                };
                                this.isValidGraphType = function(a) {
                                    switch (a) {
                                        case "Bar":
                                        case "Line":
                                        case "Area":
                                        case "AreaLine":
                                        case "Dotplot":
                                        case "Heatmap":
                                        case "Stacked":
                                        case "StackedPercent":
                                        case "Boxplot":
                                        case "Correlation":
                                        case "Treemap":
                                        case "TagCloud":
                                        case "ParallelCoordinates":
                                        case "Sankey":
                                        case "Tree":
                                        case "Pie":
                                        case "Circular":
                                        case "Map":
                                        case "BarLine":
                                        case "DotLine":
                                        case "StackedLine":
                                        case "StackedPercentLine":
                                            if (this.data.y) {
                                                return true
                                            } else {
                                                return false
                                            }
                                            case "Scatter2D":
                                                if (this.data.y && this.data.y.smps && this.data.y.smps.length > 1) {
                                                    return true
                                                } else {
                                                    return false
                                                }
                                                case "ScatterBubble2D":
                                                case "Scatter3D":
                                                    if (this.data.y && this.data.y.smps && this.data.y.smps.length > 2) {
                                                        return true
                                                    } else {
                                                        return false
                                                    }
                                                    case "Venn":
                                                        if (this.data.venn) {
                                                            return true
                                                        } else {
                                                            return false
                                                        }
                                                        case "Network":
                                                            if (this.data.nodes) {
                                                                return true
                                                            } else {
                                                                return false
                                                            }
                                                            case "Genome":
                                                                if (this.data.tracks) {
                                                                    return true
                                                                } else {
                                                                    return false
                                                                }
                                    }
                                    return false
                                };
                                this.reinitializeGraph = function() {
                                    if (this.graphType == "Tree") {
                                        this.setHierarchyData("tree")
                                    } else {
                                        if (this.graphType == "Circular" && this.circularType == "bubble") {
                                            this.setHierarchyData("bubble")
                                        } else {
                                            if (this.graphType == "Sankey" && !this.moveSankey) {
                                                if ((!this.sankeySource || !this.sankeyTarget) && this.data.x) {
                                                    if (!this.sankeySource && this.data.x.hasOwnProperty("Source")) {
                                                        this.sankeySource = "Source"
                                                    }
                                                    if (!this.sankeyTarget && this.data.x.hasOwnProperty("Target")) {
                                                        this.sankeyTarget = "Target"
                                                    }
                                                    var b = this.meta.data.x;
                                                    var d = this.sortObject(this.data.x);
                                                    var a = [];
                                                    for (var c = 0; c < d.length; c++) {
                                                        if (b[d[c]].type == "String") {
                                                            a.push(d[c])
                                                        }
                                                    }
                                                    if (a.length > 0) {
                                                        if (!this.sankeySource) {
                                                            this.sankeySource = a.shift()
                                                        }
                                                        if (!this.sankeyTarget) {
                                                            if (a.length > 0) {
                                                                this.sankeyTarget = a.shift()
                                                            } else {
                                                                this.sankeyTarget = this.sankeySource
                                                            }
                                                        }
                                                    }
                                                }
                                                var c = this.hierarchyVar ? this.getVariableIndices(this.hierarchyVar) : 0;
                                                this.hierarchyVarIndex = c >= 0 ? c : 0;
                                                this.setSankeyData()
                                            } else {
                                                if (this.graphType.match(/Scatter/) && this.scatterPlotMatrix && !this.isDOE) {
                                                    if (!this.data.l) {
                                                        this.setScatterPlotMatrix()
                                                    }
                                                } else {
                                                    if (this.graphType.match(/Pie/) && this.xAxis.length > 1 && !this.isDOE) {
                                                        this.setMultiplePies()
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getNetworkImages = function() {
                                    var a = [];
                                    if (this.graphType == "Network") {
                                        for (var b = 0; b < this.data.nodes.length; b++) {
                                            var c = this.data.nodes[b];
                                            if (c.imagePath) {
                                                a.push(c.imagePath)
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.loadImages = function(a, f) {
                                    var d = this;
                                    var e = this.imageTimeOut / this.imageMaxTries;
                                    var c = function(h, g) {
                                        var i = g ? d.backgroundImageMD5 : d.getFileName(h);
                                        return CanvasXpress.images[i] ? true : CanvasXpress.cacheImages.hasOwnProperty(i) && typeof(CanvasXpress.cacheImages[i]) == "object"
                                    };
                                    for (var b = 0; b < a.length; b++) {
                                        if (!c(a[b], a[b] == this.backgroundImageMD5) && this.imageTries < this.imageMaxTries) {
                                            this.imageTries++;
                                            setTimeout(function() {
                                                d.loadImages(a, f)
                                            }, e);
                                            return
                                        }
                                    }
                                    this.afterRender(f)
                                };
                                this.initializeGraph = function(r, a, q, m, c, d, p) {
                                    var g = this;
                                    var b = 0;
                                    var j = [];
                                    var n = [];
                                    var l = this.imageTimeOut / this.imageMaxTries;
                                    var h = function(s, i) {
                                        var t = i ? g.backgroundImageMD5 : g.getFileName(s);
                                        return CanvasXpress.images[t] ? true : CanvasXpress.cacheImages.hasOwnProperty(t) && typeof(CanvasXpress.cacheImages[t]) == "object"
                                    };
                                    var o = function() {
                                        for (var s = 0; s < j.length; s++) {
                                            if (CanvasXpress.images[j[s]]) {
                                                continue
                                            }
                                            if (!h(j[s], j[s] == g.backgroundImageMD5)) {
                                                return false
                                            }
                                        }
                                        return true
                                    };
                                    var f = function(u, t) {
                                        var s = g.$(u.split("//")[1]);
                                        if (s) {
                                            if (s.tagName.toUpperCase() != "IMG") {
                                                s = s.getElementsByTagName("img")[0]
                                            }
                                            if (s) {
                                                if (s.src) {
                                                    var i = new Image;
                                                    i.id = u;
                                                    CanvasXpress.stack[g.target].config.backgroundImageSrc = btoa(s.src.replace("data:image/png;base64,", ""));
                                                    i.onload = t;
                                                    i.src = s.src
                                                } else {
                                                    if (g.imageTries > g.imageMaxTries) {
                                                        var i = new Image;
                                                        i.id = u;
                                                        i.onload = t;
                                                        i.src = CanvasXpress.png
                                                    } else {
                                                        g.imageTries++;
                                                        setTimeout(function() {
                                                            f(u, t)
                                                        }, l)
                                                    }
                                                }
                                            } else {
                                                if (g.imageTries < g.imageMaxTries) {
                                                    g.imageTries++;
                                                    setTimeout(function() {
                                                        f(u, t)
                                                    }, l)
                                                } else {
                                                    var i = new Image;
                                                    i.id = u;
                                                    i.onload = t;
                                                    i.src = CanvasXpress.png
                                                }
                                            }
                                        } else {
                                            if (t) {
                                                if (g.graphType == "Scatter2D" && g.scatterType == "visium") {
                                                    g.scatterType = false;
                                                    g.backgroundType = "solid"
                                                }
                                                t()
                                            }
                                        }
                                    };
                                    this.showMask();
                                    this.createPatterns();
                                    if (this.graphType == "Network") {
                                        j = this.getNetworkImages()
                                    }
                                    if (this.images.length) {
                                        for (var e = 0; e < this.images.length; e++) {
                                            j.push(this.images[e])
                                        }
                                    }
                                    if (this.backgroundImage) {
                                        if (Array.isArray(this.backgroundImage)) {
                                            this.backgroundImageMD5 = this.md5(this.backgroundImage);
                                            j.push(this.backgroundImageMD5)
                                        } else {
                                            j.push(this.backgroundImage)
                                        }
                                    }
                                    if (j.length > 0) {
                                        if (this.graphType == "Network") {
                                            this.Network(true)
                                        } else {
                                            if (this.graphType == "Scatter3D") {
                                                this.Scatter3D(true)
                                            } else {
                                                if (this.graphType == "Scatter2D" || this.graphType == "ScatterBubble2D") {
                                                    this.Scatter2D(true)
                                                }
                                            }
                                        }
                                    } else {
                                        CanvasXpress.cacheImagesReady = true
                                    }
                                    this.imagesToLoad = this.cloneObject(j);
                                    if (j.length > 0 && !o() && !d) {
                                        for (var e = 0; e < j.length; e++) {
                                            if (!h(j[e], j[e] == this.backgroundImageMD5)) {
                                                n.push(j[e])
                                            }
                                        }
                                        for (var e = 0; e < j.length; e++) {
                                            if (!h(j[e], j[e] == this.backgroundImageMD5)) {
                                                var k = new Image();
                                                k.id = j[e];
                                                if (j[e] == this.backgroundImageMD5 && Array.isArray(this.backgroundImage)) {
                                                    k.onload = function() {
                                                        CanvasXpress.cacheImages[g.backgroundImageMD5] = this;
                                                        b++;
                                                        CanvasXpress.cacheImagesReady = b == n.length;
                                                        if (CanvasXpress.cacheImagesReady) {
                                                            if (!p) {
                                                                g.renderGraph(r, a, q, m, c);
                                                                g.triggerDataLoaded("initializeGraph")
                                                            }
                                                        }
                                                    };
                                                    if ((CanvasXpress.system.isR && !CanvasXpress.system.isInIframe) || !CanvasXpress.system.isR) {
                                                        k.crossOrigin = "anonymous"
                                                    }
                                                    k.src = this.createImage(this.backgroundImage)
                                                } else {
                                                    k.onload = function() {
                                                        if (this.src) {
                                                            if (g.backgroundImage && this.id == g.backgroundImage) {
                                                                g.backgroundImage = this.src
                                                            }
                                                            CanvasXpress.cacheImages[g.getFileName(this.src)] = this;
                                                            b++;
                                                            CanvasXpress.cacheImagesReady = b == n.length;
                                                            if (g.networkVendor == "Kegg") {
                                                                g.networkFreeze = false
                                                            }
                                                            if (g.graphType == "Scatter2D" && g.scatterType == "visium" && !g.visiumFlip && !g.visiumSetMinMaxYFlip) {
                                                                var i = g.setMaxY;
                                                                if (g.setMinY != null) {
                                                                    g.setMaxY = this.height - g.setMinY
                                                                }
                                                                if (g.setMaxY != null) {
                                                                    g.setMinY = this.height - i
                                                                }
                                                            }
                                                            if (CanvasXpress.cacheImagesReady) {
                                                                if (!p) {
                                                                    g.renderGraph(r, a, q, m, c);
                                                                    g.triggerDataLoaded("initializeGraph")
                                                                }
                                                            }
                                                        } else {
                                                            if (!p) {
                                                                g.renderGraph(r, a, q, m, c);
                                                                g.triggerDataLoaded("initializeGraph")
                                                            }
                                                        }
                                                    };
                                                    if ((CanvasXpress.system.isR && !CanvasXpress.system.isInIframe) || !CanvasXpress.system.isR) {
                                                        k.crossOrigin = "anonymous"
                                                    }
                                                    if (j[e].match(/^javascript:\/\//)) {
                                                        f(j[e], k.onload)
                                                    } else {
                                                        k.src = j[e]
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        if (!p) {
                                            this.renderGraph(r, a, q, m, c)
                                        }
                                    }
                                };
                                this.renderGraph = function(g, d, a, c, f) {
                                    if (this.data) {
                                        if (this.skipRender && this.graphType != "Map") {
                                            return
                                        }
                                        this.meta.time.draw.push(new Date().getTime());
                                        if (this.debug) {
                                            this.showTransition = false
                                        }
                                        if (this.initialRemoteDataRequest) {
                                            return
                                        }
                                        this.setColorScheme();
                                        this.reinitializeGraph();
                                        if (!c && this.graphType != "Network") {
                                            if (this.reproducing) {
                                                this.initializeAxis(d, a, true)
                                            } else {
                                                if (!this.motionOn) {
                                                    this.initializeAxis(d, a, true)
                                                }
                                            }
                                            this.setColorBrew(this.isContour ? false : true, g)
                                        }
                                        this.resizeCanvas(g, d, a);
                                        this.setAspectRatioProperties();
                                        var e = this.layoutComb ? true : false;
                                        switch (this.graphType) {
                                            case "Bar":
                                            case "Dotplot":
                                                if (this.isBoxplotCalc && this.isGroupedData) {
                                                    this.groupSamples(this.groupingFactors, false, false, false, true)
                                                }
                                                if (this.is3DPlot) {
                                                    this.showTransition = false;
                                                    this.Scatter3D()
                                                } else {
                                                    this.oneDPlot()
                                                }
                                                break;
                                            case "Line":
                                            case "Area":
                                            case "AreaLine":
                                            case "BarLine":
                                            case "DotLine":
                                            case "Heatmap":
                                            case "Treemap":
                                            case "ParallelCoordinates":
                                            case "Stacked":
                                            case "StackedLine":
                                            case "StackedPercent":
                                            case "StackedPercentLine":
                                                if (this.isBoxplotCalc && this.isGroupedData) {
                                                    this.groupSamples(this.groupingFactors, false, false, false, true)
                                                }
                                                this.oneDPlot();
                                                break;
                                            case "Boxplot":
                                                if (!this.isBoxplotCalc && (this.isGroupedData || this.groupingFactors.length)) {
                                                    this.groupSamples(this.groupingFactors, false, false, false, true)
                                                }
                                                this.oneDPlot();
                                                break;
                                            case "TagCloud":
                                            case "Sankey":
                                            case "Tree":
                                            case "Gantt":
                                            case "Meter":
                                                this.oneDPlot();
                                                break;
                                            case "Scatter2D":
                                            case "ScatterBubble2D":
                                            case "Fish":
                                                this.Scatter2D();
                                                break;
                                            case "Scatter3D":
                                                this.showTransition = false;
                                                this.Scatter3D();
                                                break;
                                            case "Correlation":
                                                this.Correlation();
                                                break;
                                            case "Venn":
                                                this.Venn();
                                                break;
                                            case "Pie":
                                                this.Pie();
                                                break;
                                            case "Circular":
                                                this.Circular();
                                                break;
                                            case "Network":
                                                this.showTransition = false;
                                                if (f) {
                                                    var b = this.calculateLayout;
                                                    var e = this.randomNetwork;
                                                    this.calculateLayout = false;
                                                    this.randomNetwork = false;
                                                    this.Network();
                                                    this.calculateLayout = b;
                                                    this.randomNetwork = e
                                                } else {
                                                    this.Network()
                                                }
                                                break;
                                            case "Genome":
                                                this.showTransition = false;
                                                this.Genome();
                                                break;
                                            case "Map":
                                                this.showTransition = false;
                                                this.Map();
                                                break
                                        }
                                        this.drawCanvasBox();
                                        if (this.showCode) {
                                            this.updateCodeDiv()
                                        }
                                        if (this.showDataTable) {
                                            this.updateDataTable()
                                        } else {
                                            if (!this.dataTableLastState) {
                                                this.hideUnhideDataTable(true)
                                            }
                                        }
                                        if (this.graphType != "Network") {
                                            this.drawCitation()
                                        }
                                        if (window.navigator.onLine) {
                                            if (!this.Rdatasets && this.loadRDatasets) {
                                                this.getRDatasets()
                                            }
                                        }
                                        this.resetAspectRatioProperties();
                                        this.resetGradientTransparencyShadow();
                                        if (this.graphType != "Network") {
                                            this.render()
                                        }
                                        if (this.debug) {
                                            this.drawArea()
                                        }
                                        if (this.userEvents.enddraw) {
                                            this.userEvents.enddraw.call(this, this)
                                        }
                                        this.logConsole("canvasXpress render ready");
                                        this.monitorInstances();
                                        if (this.showTransition && !this.skipTransition) {
                                            this.transition()
                                        }
                                        this.meta.vals.histogram = this.data.y && this.data.y.histogram ? this.cloneObject(this.data.y.histogram) : false;
                                        if (this.layoutValid) {
                                            this.meta.vals.layout = {
                                                l: this.cloneObject(this.data.l),
                                                g: (this.data.w ? this.cloneObject(this.data.w.grps) : false),
                                                v: this.cloneObject(this.segregateVariablesBy),
                                                s: this.cloneObject(this.segregateSamplesBy)
                                            }
                                        } else {
                                            this.meta.vals.layout = false
                                        }
                                    }
                                }
                            };
                            CanvasXpress.prototype.initAxes = function() {
                                this.getValidAxes = function(isPie) {
                                    var axes = [];
                                    if (this.graphType == "Scatter2D") {
                                        axes.push("xAxis");
                                        axes.push("yAxis")
                                    } else {
                                        if (this.graphType == "ScatterBubble2D" || this.graphType == "Scatter3D") {
                                            axes.push("xAxis");
                                            axes.push("yAxis");
                                            axes.push("zAxis")
                                        } else {
                                            if (this.graphType.match(/Network|Genome|Correlation|Venn|Heatmap|Pie/)) {
                                                if (isPie) {
                                                    axes.push("xAxis")
                                                } else {
                                                    return false
                                                }
                                            } else {
                                                if (this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/)) {
                                                    axes.push("xAxis");
                                                    axes.push("xAxis2")
                                                } else {
                                                    if (this.graphType == "Circular") {
                                                        axes.push("xAxis");
                                                        axes.push("rAxis")
                                                    } else {
                                                        axes.push("xAxis")
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return axes
                                };
                                this.addRemoveSamplesInAxis = function(smps, axis, check) {
                                    if (this.graphType == "Scatter2D" || this.graphType == "ScatterBubble2D") {
                                        if (check) {
                                            return this.removeSamplesFromAxis(smps, axis)
                                        } else {
                                            return this.addSamplesToAxis(smps, axis)
                                        }
                                    } else {
                                        if (this.graphType == "Scatter3D" || this.graphType == "Pie") {
                                            return this.switchSampleInAxis(smps, axis)
                                        }
                                    }
                                };
                                this.addSamplesToAxis = function(smps, axis) {
                                    if (this[axis]) {
                                        if (this.isArray(smps)) {
                                            var sia = this.getObjectArray(this[axis]);
                                            for (var i = 0; i < smps.length; i++) {
                                                if (!sia.hasOwnProperty(smps[i])) {
                                                    this[axis].push(smps[i])
                                                }
                                            }
                                        } else {
                                            this[axis].push(smps)
                                        }
                                        return false
                                    } else {
                                        return "Not a valid axis"
                                    }
                                };
                                this.removeSamplesFromAxis = function(smps, axis) {
                                    if (this[axis]) {
                                        if (this[axis].length > 1) {
                                            var seen = {};
                                            var temp = [];
                                            if (this.isArray(smps)) {
                                                for (var i = 0; i < smps.length; i++) {
                                                    seen[smps[i]] = 1
                                                }
                                            } else {
                                                seen[smps] = 1
                                            }
                                            for (var i = 0; i < this[axis].length; i++) {
                                                if (!seen.hasOwnProperty(this[axis][i])) {
                                                    temp.push(this[axis][i])
                                                }
                                            }
                                            this[axis] = temp;
                                            return false
                                        } else {
                                            return axis + " cannot be null"
                                        }
                                    } else {
                                        return "Not a valid axis"
                                    }
                                };
                                this.switchSampleInAxis = function(smp, axis) {
                                    if (this[axis]) {
                                        this[axis][0] = this.isArray(smp) ? smp[0] : smp;
                                        return false
                                    } else {
                                        return "Not a valid axis"
                                    }
                                };
                                this.addRemoveVariablesInAxis = function(vars, axis, check) {
                                    if (check) {
                                        return this.removeVariablesFromAxis(vars, axis)
                                    } else {
                                        return this.addVariablesToAxis(vars, axis)
                                    }
                                };
                                this.addVariablesToAxis = function(vars, axis) {
                                    if (this[axis]) {
                                        if (this.isArray(vars)) {
                                            for (var i = 0; i < vars.length; i++) {
                                                this[axis].push(vars[i])
                                            }
                                        } else {
                                            this[axis].push(vars)
                                        }
                                    }
                                    return false
                                };
                                this.removeVariablesFromAxis = function(vars, axis) {
                                    if (this[axis]) {
                                        var seen = {};
                                        var temp = [];
                                        if (this.isArray(vars)) {
                                            for (var i = 0; i < vars.length; i++) {
                                                seen[vars[i]] = 1
                                            }
                                        } else {
                                            seen[vars] = 1
                                        }
                                        for (var i = 0; i < this[axis].length; i++) {
                                            if (!seen.hasOwnProperty(this[axis][i])) {
                                                temp.push(this[axis][i])
                                            }
                                        }
                                        this[axis] = temp
                                    } else {
                                        return "Not a valid axis"
                                    }
                                    return false
                                };
                                this.formatAxisValue = function(val, axis) {
                                    var s = this.axis == "yAxis" && this.isCreateHistogram;
                                    if (this[axis + "TickFormat"] && !s) {
                                        var frmt = this[axis + "TickFormat"];
                                        if (this.isArray(this[axis + "TickFormat"])) {
                                            frmt = this[axis + "TickFormat"][0];
                                            val = eval(val + this[axis + "TickFormat"][1])
                                        }
                                        return val ? this.sprintf(frmt, val) : val.toString()
                                    } else {
                                        var d = Math.min(this[axis + "Decs"], 20);
                                        return this.formatNumber(val, d)
                                    }
                                };
                                this.getAxisDataBySample = function(idx, axis) {
                                    var vals = [];
                                    var trn = false;
                                    var min = false;
                                    var max = false;
                                    if (axis) {
                                        trn = this[axis + "AxisTransform"];
                                        max = this[axis + "AxisFloorValue"];
                                        min = this[axis + "AxisCeilValue"]
                                    }
                                    if (this.isArray(idx)) {
                                        for (var i = 0; i < this.varIndices.length; i++) {
                                            var ii = this.varIndices[i];
                                            for (var j = 0; j < idx.length; j++) {
                                                vals.push(this.getDataAtPos(ii, idx[j], false, trn, min, max))
                                            }
                                        }
                                    } else {
                                        for (var i = 0; i < this.varIndices.length; i++) {
                                            var ii = this.varIndices[i];
                                            vals.push(this.getDataAtPos(ii, idx, false, trn, min, max))
                                        }
                                    }
                                    return vals
                                };
                                this.getAxisRangeBySample = function(idx) {
                                    return this.range(this.getAxisDataBySample(idx))
                                };
                                this.getAxisIncrements = function(min, max, ticks, exact, add) {
                                    var test, test2;
                                    var decs = 0;
                                    if (min == max) {
                                        return 0.1
                                    }
                                    if (exact) {
                                        test = parseFloat(this.formatNumber((max - min) / ticks, decs));
                                        while (test == 0) {
                                            decs++;
                                            test = parseFloat(this.formatNumber((max - min) / ticks, decs))
                                        }
                                        return test
                                    } else {
                                        if (max - min <= Number.MIN_VALUE) {
                                            return 0.1
                                        }
                                        var adj = ((add || max) - min) * this.axisExtension;
                                        var amin = min - adj;
                                        var amax = (add || max) + adj;
                                        var range = amax - amin;
                                        var len = -Math.floor(Math.log(range / ticks) / Math.LN10);
                                        var step = Math.pow(10, -len);
                                        var decs = this.getAxisDecimals(step);
                                        var norm = ((range / ticks) / step);
                                        if (norm < 1.5) {
                                            test = step
                                        } else {
                                            if (norm < 2) {
                                                test = step * 2
                                            } else {
                                                if (norm < 2.5) {
                                                    test = step * 2.5
                                                } else {
                                                    if (norm < 5) {
                                                        test = step * 5;
                                                        test2 = step * 2.5
                                                    } else {
                                                        if (norm < 7.5) {
                                                            test = step * 7.5
                                                        } else {
                                                            test = step * 10;
                                                            test2 = step * 5
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (this.getAxisMin(min, test) + (test * ticks) < max) {
                                            return this.getAxisIncrements(min, max, ticks, exact, (add || max) + test)
                                        } else {
                                            if (test2 && this.getAxisMin(min, test2) + (test2 * ticks) >= max) {
                                                return test2
                                            } else {
                                                return test
                                            }
                                        }
                                    }
                                };
                                this.getAxisMin = function(min, inc) {
                                    var mm = inc * Math.floor(min / inc);
                                    return isNaN(mm) ? 0 : mm < 0 && this.minData >= 0 ? 0 : mm
                                };
                                this.setAxis = function(axis, isVar) {
                                    var level = this.isGroupedData ? this.data.w : this.data.y;
                                    var indxs = isVar ? this.getVariableIndices(this[axis]) : this.getSampleIndices(this[axis]);
                                    if ((this.isArray(indxs) && indxs.length == 0) || (!this.isArray(indxs) && indxs == -1)) {
                                        this[axis] = []
                                    }
                                    if (this.scatterType == "manhattan") {
                                        if (axis == "xAxis") {
                                            this[axis] = ["Manhattan"]
                                        } else {
                                            if (axis == "yAxis") {
                                                this[axis] = [this.manhattanMarkerLogPValue]
                                            }
                                        }
                                    } else {
                                        if (this[axis].length == 0) {
                                            if (this.isQQ || this.isCDF) {
                                                for (var i = 0; i < this.smpIndices.length; i++) {
                                                    this[axis].push(this.data.y.smps[this.smpIndices[i]])
                                                }
                                            } else {
                                                if (axis == "xAxis") {
                                                    if (isVar) {
                                                        for (var i = 0; i < this.varIndices.length; i++) {
                                                            this[axis].push(this.data.y.vars[this.varIndices[i]])
                                                        }
                                                    } else {
                                                        this[axis].push(level.smps[this.smpIndices[0]])
                                                    }
                                                } else {
                                                    if (axis == "xAxis2") {
                                                        this[axis].push(this.data.y.vars[this.varIndices[this.varIndices.length - 1]])
                                                    } else {
                                                        if (axis == "yAxis") {
                                                            if (level.smps.length > 1) {
                                                                if (this.isHistogram) {
                                                                    this[axis] = this.cloneObject(this.data.y.smps);
                                                                    this[axis].shift()
                                                                } else {
                                                                    this[axis].push(level.smps[this.smpIndices[1]])
                                                                }
                                                            } else {
                                                                this[axis].push(level.smps[this.smpIndices[0]])
                                                            }
                                                        } else {
                                                            if (axis == "zAxis") {
                                                                if (level.smps.length > 2) {
                                                                    this[axis].push(level.smps[this.smpIndices[2]])
                                                                } else {
                                                                    if (level.smps.length > 1) {
                                                                        this[axis].push(level.smps[this.smpIndices[1]])
                                                                    } else {
                                                                        this[axis].push(level.smps[this.smpIndices[0]])
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.graphType == "Scatter3D" && this[axis].length > 1) {
                                                this[axis] = [this[axis][0]]
                                            } else {
                                                if (this.isHistogram && axis == "yAxis" && this[axis][0] == "Bin") {
                                                    this[axis].shift()
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setAxisValues = function(axis, dvals) {
                                    var val, str, prev, valn, mnri, pmnv, redo, msl, mval;
                                    var seen = {};
                                    var mnrv = axis + "MinorValues";
                                    var vals = axis + "Values";
                                    var vraw = axis + "ValuesRaw";
                                    var tick = axis + "Ticks";
                                    var frmt = axis + "TickFormat";
                                    var incr = axis + "Incr";
                                    var decs = axis + "Decs";
                                    var min = axis + "Min";
                                    var max = axis + "Max";
                                    var trns = axis + "Transform";
                                    var maxs = axis + "MaxStrLength";
                                    if (this.graphType == "Gantt") {
                                        this[decs] = 0;
                                        this[vals] = [];
                                        this[vraw] = [];
                                        this[mnrv] = [];
                                        mnri = this[incr] / 5;
                                        val = this[min] - this[incr];
                                        for (var j = 0; j < 5; j++) {
                                            mval = val + (mnri * j);
                                            this[mnrv].push(new Date(mval))
                                        }
                                        val = this[min];
                                        for (var i = 0; i <= this[tick] + 1; i++) {
                                            for (var j = 0; j < 5; j++) {
                                                mval = val + (mnri * j);
                                                this[mnrv].push(new Date(mval))
                                            }
                                            if (val > this[max]) {
                                                break
                                            }
                                            this[vals].push(new Date(val));
                                            this[vraw].push(val);
                                            val += this[incr]
                                        }
                                    } else {
                                        if (this[trns] == "percentile") {
                                            this[decs] = 0;
                                            this[vals] = [];
                                            this[vraw] = [];
                                            this[mnrv] = [];
                                            var ticks = [0, 25, 50, 75, 100];
                                            for (var i = 0; i < ticks.length; i++) {
                                                this[vals].push(ticks[i]);
                                                this[vraw].push(ticks[i])
                                            }
                                            for (var i = 5; i < 100; i += 5) {
                                                this[mnrv].push(i)
                                            }
                                        } else {
                                            this[vals] = [];
                                            this[mnrv] = [];
                                            this[vraw] = [];
                                            mnri = this[incr] / 5;
                                            val = this[min] - this[incr];
                                            for (var j = 0; j < 5; j++) {
                                                mval = val + (mnri * j);
                                                this[mnrv].push(mval)
                                            }
                                            val = this[min];
                                            for (var i = 0; i <= (dvals ? dvals.length + 1 : this[tick] + 1); i++) {
                                                for (var j = 0; j < 5; j++) {
                                                    mval = val + (mnri * j);
                                                    this[mnrv].push(mval)
                                                }
                                                if (this[decs] == 0 && val.toString().match(/\.5$/)) {
                                                    this[decs] = 1
                                                }
                                                str = this.formatAxisValue(val, axis);
                                                if (seen.hasOwnProperty(str) && !this[frmt]) {
                                                    redo = true
                                                } else {
                                                    seen[str] = 1
                                                }
                                                if (str > this[max]) {}
                                                this[vals].push(str);
                                                this[vraw].push(val);
                                                val += this[incr]
                                            }
                                        }
                                    }
                                    if (redo && this[decs] < 20) {
                                        this[decs]++;
                                        this[vals] = [];
                                        this[mnrv] = [];
                                        this[vraw] = [];
                                        if (this[decs] > 10) {
                                            this[decs] = 0;
                                            mnri = this[incr] / 5;
                                            val = this[min] - this[incr];
                                            for (var j = 0; j < 5; j++) {
                                                mval = val + (mnri * j);
                                                this[mnrv].push(mval)
                                            }
                                            val = this[min];
                                            for (var i = 0; i <= this[tick] + 1; i++) {
                                                for (var j = 0; j < 5; j++) {
                                                    mval = val + (mnri * j);
                                                    this[mnrv].push(mval)
                                                }
                                                if (val > this[max]) {
                                                    break
                                                }
                                                this[vals].push(val.toString());
                                                this[vraw].push(val);
                                                this[decs] = Math.max(this[decs], val.toString().split(".").length - 1);
                                                val += this[incr]
                                            }
                                        } else {
                                            this.setAxisValues(axis, dvals)
                                        }
                                    } else {
                                        msl = this.getMaxText(this[vals]);
                                        if (this[frmt]) {
                                            this[maxs] = msl
                                        } else {
                                            this[maxs] = this.formatNumber(msl, this[decs])
                                        }
                                        this[mnrv].unshift(this[mnrv][0] - mnri);
                                        if (this.layoutValid && this.layoutParams && this.layoutParams[this.layoutCurrent]) {
                                            var pr = axis + "MaxStrTick";
                                            this.layoutParams[this.layoutCurrent][pr] = msl;
                                            this.layoutParams[this.layoutCurrent][pr + "Length"] = this.measureText(msl, this.axisTickFont);
                                            if (this[axis + "LayoutMaxTickStrLength"]) {
                                                if (this.layoutParams[this.layoutCurrent][pr + "Length"] > this[axis + "LayoutMaxTickStrLength"]) {
                                                    this[axis + "LayoutMaxTickStr"] = msl;
                                                    this[axis + "LayoutMaxTickStrLength"] = this.layoutParams[this.layoutCurrent][pr + "Length"]
                                                }
                                            } else {
                                                this[axis + "LayoutMaxTickStr"] = msl;
                                                this[axis + "LayoutMaxTickStrLength"] = this.layoutParams[this.layoutCurrent][pr + "Length"]
                                            }
                                        }
                                    }
                                };
                                this.setAxisAttributes = function(axis, type, forceRaw, transform, stacked, noExt) {
                                    var that = this;
                                    var justPositive = transform && transform.match(/log/) ? true : false;
                                    var tick = axis + "Ticks";
                                    var incr = axis + "Incr";
                                    var amin = axis + "AbsMin";
                                    var amax = axis + "AbsMax";
                                    var min = axis + "Min";
                                    var max = axis + "Max";
                                    var flor = axis + "FloorValue";
                                    var ceil = axis + "CeilValue";
                                    var rang = axis + "Range";
                                    var decs = axis + "Decs";
                                    var aemi = axis + "ExtensionMin";
                                    var aema = axis + "ExtensionMax";
                                    this.setRangeData(type, forceRaw, justPositive, stacked, type == "fish" ? axis : type == "qq" || type == "cdf" ? axis.replace("Axis", "") : axis);
                                    var getScatterPoint = function() {
                                        if (that.graphType.match(/Scatter|Dot/i)) {
                                            var p = that.dataPointSize * this.dataPointSizeScaleFactor;
                                            var u = (axis.substring(0, 1) == "x" ? that.width : that.height) / (that.maxData - that.minData);
                                            return that.layoutComb ? Math.ceil((p / u) / that.layoutRows) : p / u
                                        } else {
                                            return 0
                                        }
                                    };
                                    if (this.minData == this.maxData) {
                                        this.minData -= (this.minData * 0.1);
                                        this.maxData += (this.maxData * 0.1)
                                    }
                                    if (transform) {
                                        if (transform == "log2") {
                                            this.minData = Math.log(this.minData) / Math.LN2;
                                            this.maxData = Math.log(this.maxData) / Math.LN2
                                        } else {
                                            if (transform == "log10") {
                                                this.minData = Math.log(this.minData) / Math.LN10;
                                                this.maxData = Math.log(this.maxData) / Math.LN10
                                            } else {
                                                if (transform == "exp2") {
                                                    this.minData = Math.pow(2, this.minData);
                                                    this.maxData = Math.pow(2, this.maxData)
                                                } else {
                                                    if (transform == "exp10") {
                                                        this.minData = Math.pow(10, this.minData);
                                                        this.maxData = Math.pow(10, this.maxData)
                                                    } else {
                                                        if (transform == "percentile") {
                                                            this.minData = this.minData < 0 ? -100 : 0;
                                                            this.maxData = 100
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this[flor]) {
                                        this.minData = Math.max(this.minData, this[flor])
                                    }
                                    if (this[ceil]) {
                                        this.maxData = Math.min(this.maxData, this[ceil])
                                    }
                                    if (this.isHistogram && !this.isOneDimensionalGraph()) {
                                        this.minData = 0
                                    }
                                    if (this.setMin) {
                                        this.minData = this.setMin
                                    }
                                    if (this.setMax) {
                                        this.maxData = this.setMax
                                    }
                                    this[amin] = this.setMin == null ? this.minData : this[amin];
                                    this[amax] = this.setMax == null ? this.maxData : this[amax];
                                    var excp = (this.isContour || this.isHistogram || this.graphType.match(/Stacked|Area/) || (transform && transform == "percentile") || noExt || this.stackBy) ? true : false;
                                    var vals = this[this.axisAlgorithm](this.minData, this.maxData, this[tick], this.axisWilkinsonLoose);
                                    var exts = (this.maxData - this.minData) * this.axisExtension * (this.isContour ? 0.1 : 1);
                                    var sctp = getScatterPoint();
                                    var hist = !this.isOneDimensionalGraph() && this.isHistogram && axis == "xAxis";
                                    this[incr] = vals[1] - vals[0];
                                    this[decs] = this.getAxisDecimals(this[incr]);
                                    this[min] = this.graphType == "Scatter2D" && this.scatterType == "visium" ? this.minData : vals[0];
                                    this[max] = this.graphType == "Scatter2D" && this.scatterType == "manhattan" ? this.maxData * (axis == "xAxis" ? 1.025 : 1.05) : this.graphType == "Scatter2D" && this.scatterType == "visium" ? this.maxData : hist ? Math.min(this.isCreateHistogram.max - this.isCreateHistogram.min, vals[vals.length - 1]) : vals[vals.length - 1];
                                    this.setAxisValues(axis, vals);
                                    if (this.graphType == "Scatter2D" && this.scatterType == "visium") {
                                        this[rang] = this[max] - this[min]
                                    } else {
                                        this[aemi] = false;
                                        if (vals[0] < (this.minData - sctp) || excp) {
                                            this[min] = vals[0]
                                        } else {
                                            if (this.decorations && this.decorations.kaplanMeier) {
                                                this[min] = 0
                                            } else {
                                                if (this.graphType != "Scatter2D" || this.scatterType != "manhattan" || axis != "yAxis") {
                                                    this[min] = this.minData - (this.graphType == "Meter" ? 0 : (this.graphType == "Scatter2D" && this.scatterType == "manhattan" ? exts / 3 : exts))
                                                }
                                                this[aemi] = true
                                            }
                                        }
                                        if (!this[aemi]) {
                                            if ((this.isHistogram && !this.isOneDimensionalGraph() && axis == "yAxis") || (this.scatterMatrixPlot && this.scatterMatrixPlotType.match(/Histogram|Density|all/))) {
                                                this[min] = 0 - ((this.maxData - this.minData) * this.axisExtension / 3)
                                            } else {
                                                if ((this.isHistogram && !this.isOneDimensionalGraph() && axis == "xAxis") || (this.scatterMatrixPlot && this.scatterMatrixPlotType.match(/Histogram|Density|all/))) {
                                                    this[min] -= this.maxData * this.axisExtension / (this.ridgeBy ? 0.5 : 3)
                                                }
                                            }
                                        }
                                        this[aema] = false;
                                        if (vals[vals.length - 1] > (this.maxData + sctp) || excp) {
                                            if (this.graphType != "Scatter2D") {
                                                this[max] = this.isContour || (this.graphType == "Scatter2D" && this.scatterType == "manhattan" && !this.layoutValid) ? this.maxData : hist ? Math.max(this.isCreateHistogram.max - this.isCreateHistogram.min, vals[vals.length - 1]) : vals[vals.length - 1]
                                            }
                                        } else {
                                            this[max] = this.maxData + (this.graphType == "Meter" ? 0 : exts);
                                            this[aema] = true
                                        }
                                        if (!this[aema]) {
                                            if ((this.isHistogram && !this.isOneDimensionalGraph()) || (this.scatterMatrixPlot && this.scatterMatrixPlotType.match(/Histogram|Density|all/)) || (this.graphType == "Scatter2D" && this.scatterType == "manhattan" && !this.layoutValid)) {
                                                this[max] += this.maxData * this.axisExtension / (this.ridgeBy && axis == "xAxis" ? 0.5 : 3)
                                            }
                                        }
                                        if (this.layoutComb && this.isOneDimensionalGraph() && transform != "percentile" && !this.graphType.match(/Percent/) && this.maxData > this[max] - (this[incr] * 0.2)) {
                                            this[max] += this[incr]
                                        }
                                        if (this.setMin != null) {
                                            this[min] = this.setMin
                                        }
                                        if (this.setMax != null) {
                                            this[max] = this.setMax
                                        }
                                        if (this.ridgeBy && axis === "yAxis") {
                                            this[max] = this.maxData
                                        }
                                        this[rang] = this[max] - this[min]
                                    }
                                };
                                this.setAxesType = function() {
                                    if (this.decorations && this.decorations.kaplanMeier) {
                                        this.axesType = "KM"
                                    } else {
                                        if (this.decorations && this.decorations.qq) {
                                            this.axesType = "QQ"
                                        } else {
                                            if (this.decorations && this.decorations.cdf) {
                                                this.axesType = "CDF"
                                            } else {
                                                if (this.graphType == "ScatterBubble2D" && this.xAxisIndices.length > 1 && this.xAxisIndices.length == this.yAxisIndices.length && this.xAxisIndices.length == this.zAxisIndices.length) {
                                                    this.axesType = "XYZ"
                                                } else {
                                                    if (this.xAxisIndices.length > 1 && this.xAxisIndices.length == this.yAxisIndices.length) {
                                                        this.axesType = "XY"
                                                    } else {
                                                        if (this.xAxisIndices.length > this.yAxisIndices.length) {
                                                            this.axesType = "X"
                                                        } else {
                                                            this.axesType = "Y"
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getMarkerVariableIndices = function() {
                                    var o = [];
                                    if (this.decorations && this.decorations.marker) {
                                        var m = this.decorations.marker;
                                        for (var i = 0; i < m.length; i++) {
                                            if (m[i].variable) {
                                                var idx = this.getVariableIndices(m[i].variable);
                                                if (idx >= 0) {
                                                    o[idx] = true
                                                }
                                            }
                                        }
                                    }
                                    return o
                                };
                                this.getScatterVisibleVariables = function() {
                                    if (this.setMinX != null && this.setMaxX != null && this.setMinY != null && this.setMaxY != null && !this.xAxisHistogramShow && !this.yAxisHistogramShow) {
                                        var indices = {};
                                        var max = this.axesType == "XYZ" ? 1 : Math.max(this.xAxisIndices.length, this.yAxisIndices.length);
                                        for (var i = 0; i < max; i++) {
                                            var xi = this.axesType == "Y" || this.axesType == "XYZ" ? this.xAxisIndices[this.xAxisCurrent] : this.xAxisIndices[i];
                                            var yi = this.axesType == "X" || this.axesType == "XYZ" ? this.yAxisIndices[this.yAxisCurrent] : this.yAxisIndices[i];
                                            for (var j = 0; j < this.varIndices.length; j++) {
                                                var x = this.getDataAtPos(this.varIndices[j], xi, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                var y = this.getDataAtPos(this.varIndices[j], yi, false, this.yAxisTransform, this.yAxisFloorValue, this.yAxisCeilValue);
                                                if (x >= this.setMinX && x <= this.setMaxX && y >= this.setMinY && y <= this.setMaxY) {
                                                    indices[this.varIndices[j]] = true
                                                }
                                            }
                                        }
                                        return this.getKeys(indices).sort(function(a, b) {
                                            return a - b
                                        })
                                    } else {
                                        return this.varIndices
                                    }
                                };
                                this.setAxesDensityScatterLayout = function(width, height) {
                                    this.setAxesType();
                                    var that = this;
                                    var meta = this.meta.data.d;
                                    var mark = this.getMarkerVariableIndices();
                                    var max = this.data.l && this.data.l.comp ? this.data.l.comp.length : 0;
                                    var dps = parseInt(Math.min(1000, Math.max(10, (width || this.width) * (height || this.height) * this.densityPixels / (1000000 * Math.min(this.layoutRows, this.layoutCols) * 2))));
                                    var xAxisUnit = dps / this.xAxisRange;
                                    var yAxisUnit = dps / this.yAxisRange;
                                    var override = {};
                                    var vs = false;
                                    var oi = false;
                                    var setVarsSmps = function(c) {
                                        if (that.segregateVariablesBy.length && that.segregateSamplesBy.length) {
                                            vars = that.data.l.comp[c][0];
                                            smps = that.data.l.comp[c][1]
                                        } else {
                                            if (that.data.l.smps && that.data.l.smps[c].xAxis && that.data.l.smps[c].yAxis) {
                                                vars = that.varIndices;
                                                smps = [that.getSampleIndices(that.data.l.smps[c].xAxis[0]), that.getSampleIndices(that.data.l.smps[c].yAxis[0])]
                                            } else {
                                                if (!that.scatterPlotMatrix && that.data.l.smps && that.data.l.smps[c]) {
                                                    vars = that.varIndices;
                                                    smps = [that.data.l.smps[c][0], that.data.l.smps[c][1] || that.data.l.smps[c][0]]
                                                } else {
                                                    if (that.data.l.vars && that.data.l.vars[c]) {
                                                        if (!vs) {
                                                            vs = that.data.y.vars;
                                                            oi = that.getObjectArrayOrder(vs)
                                                        }
                                                        vars = that.getVariableIndices(that.data.l.vars[c], false, vs, oi);
                                                        smps = that.smpIndices
                                                    } else {
                                                        vars = [];
                                                        smps = []
                                                    }
                                                }
                                            }
                                        }
                                    };
                                    for (var i = 0; i < max; i++) {
                                        var xAxisData = [];
                                        var yAxisData = [];
                                        var vars = [];
                                        var smps = [];
                                        setVarsSmps(i);
                                        if (!vars.length || !smps.length) {
                                            meta.l[i] = {
                                                vars: [],
                                                skip: {},
                                                density: {},
                                                max: 1,
                                                n: 0,
                                                colorBrew: false
                                            };
                                            continue
                                        }
                                        var xi = this.scatterType == "manhattan" ? this.getSampleIndices("Manhattan") : smps[0];
                                        var yi = this.scatterType == "manhattan" ? this.manhattanMarkerLogPValueIndex : (smps[1] || smps[0]);
                                        var ki = xi + ":" + yi;
                                        if (this.showHistogramDensity || this.xAxisHistogramShow || this.yAxisHistogramShow) {
                                            if (!meta.s.hasOwnProperty(xi.toString()) && meta.l[i] && this.xAxisHistogramShow) {
                                                var data = [];
                                                for (var j = 0; j < vars.length; j++) {
                                                    data.push(this.getDataAtPos(vars[j], xi, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue))
                                                }
                                                xAxisData.push(data);
                                                meta.s[xi.toString()] = this.density(data, this.data.y.smps[xi])
                                            }
                                            if (!meta.s.hasOwnProperty(yi.toString()) && meta.a.hasOwnProperty(ki) && this.yAxisHistogramShow) {
                                                var data = [];
                                                for (var j = 0; j < vars.length; j++) {
                                                    data.push(this.getDataAtPos(vars[j], yi, false, this.yAxisTransform, this.yAxisFloorValue, this.yAxisCeilValue))
                                                }
                                                yAxisData.push(data);
                                                meta.s[yi.toString()] = this.density(data, this.data.y.smps[yi])
                                            }
                                        }
                                        if (!meta.l[i]) {
                                            meta.l[i] = {
                                                vars: [],
                                                skip: {},
                                                density: {},
                                                max: 1,
                                                n: 0,
                                                colorBrew: false
                                            };
                                            var density = {};
                                            var xdata = [];
                                            var ydata = [];
                                            for (var j = 0; j < vars.length; j++) {
                                                var x = this.getDataAtPos(vars[j], xi, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                var y = this.getDataAtPos(vars[j], yi, false, this.yAxisTransform, this.yAxisFloorValue, this.yAxisCeilValue);
                                                var x0 = parseInt((x - this.xAxisMin) * xAxisUnit);
                                                var y0 = parseInt((y - this.yAxisMin) * yAxisUnit);
                                                var k0 = x0 + ":" + y0 + ":0";
                                                if (this.isNumeric([x0, y0])) {
                                                    if (!density.hasOwnProperty(k0)) {
                                                        density[k0] = []
                                                    }
                                                    density[k0].push(vars[j]);
                                                    if (mark[vars[j]]) {
                                                        override[k0] = true
                                                    }
                                                }
                                                xdata.push(x);
                                                ydata.push(y)
                                            }
                                            if (this.showHistogramDensity || this.xAxisHistogramShow || this.yAxisHistogramShow) {
                                                if (!meta.s.hasOwnProperty(xi.toString()) && xdata.length > 0 && this.xAxisHistogramShow) {
                                                    meta.s[xi.toString()] = this.density(xdata, this.data.y.smps[xi]);
                                                    xAxisData.push(xdata)
                                                }
                                                if (!meta.s.hasOwnProperty(yi.toString()) && ydata.length > 0 && this.yAxisHistogramShow) {
                                                    meta.s[yi.toString()] = this.density(ydata, this.data.y.smps[yi]);
                                                    yAxisData.push(ydata)
                                                }
                                            }
                                            var order = this.getKeys(density).sort(function(a, b) {
                                                return density[a].length - density[b].length || density[a][0] - density[b][0]
                                            });
                                            for (var j = 0; j < order.length; j++) {
                                                var k0 = order[j];
                                                var v0 = density[k0].pop();
                                                meta.l[i].vars.push(v0);
                                                if (density[k0].length > 0 && !override[k0]) {
                                                    meta.l[i].max = Math.max(meta.l[i].max, density[k0].length + 1);
                                                    meta.l[i].density[v0.toString()] = density[k0].length + 1;
                                                    meta.l[i].n++;
                                                    for (var k = 0; k < density[k0].length; k++) {
                                                        if (!this.spiderBy && vars.length > 500) {
                                                            meta.l[i].skip[density[k0][k].toString()] = v0
                                                        }
                                                    }
                                                }
                                            }
                                            meta.l[i].colorBrew = this.getColorBrew(false, 1, meta.l[i].max)
                                        }
                                    }
                                };
                                this.setAxesDensityScatter = function(width, height) {
                                    this.setAxesType();
                                    var meta = this.meta.data.d;
                                    var mark = this.getMarkerVariableIndices();
                                    var vis = this.getScatterVisibleVariables();
                                    var fac = vis.length > 50000 ? 0.5 : 1;
                                    var set = this.setMinX != null && this.setMaxX != null && this.setMinY != null && this.setMaxY != null;
                                    var wid = set ? (width || this.width) : width ? Math.min(width, this.width) : this.width;
                                    var hei = set ? (height || this.height) : height ? Math.min(height, this.height) : this.height;
                                    var max = this.axesType == "XYZ" ? 1 : Math.max(this.xAxisIndices.length, this.yAxisIndices.length);
                                    var dps = parseInt(Math.min(1000, Math.max(10, wid * hei * this.densityPixels * fac / 1000000)));
                                    if (meta.q != null && !set) {
                                        dps = meta.q
                                    }
                                    var xAxisUnit = dps / this.xAxisRange;
                                    var yAxisUnit = dps / this.yAxisRange;
                                    var xAxisData = [];
                                    var yAxisData = [];
                                    var override = {};
                                    if (meta.q == null) {
                                        meta.q = dps
                                    }
                                    meta.a = {};
                                    meta.s = {};
                                    for (var i = 0; i < max; i++) {
                                        var xi = this.axesType == "Y" || this.axesType == "XYZ" ? this.xAxisIndices[this.xAxisCurrent] : this.xAxisIndices[i];
                                        var yi = this.axesType == "X" || this.axesType == "XYZ" ? this.yAxisIndices[this.yAxisCurrent] : this.yAxisIndices[i];
                                        var zi = (this.graphType == "ScatterBubble2D" && !this.sizeBy && this.zAxisIndices.length > 0) || this.axesType == "XYZ" ? this.zAxisIndices[this.zAxisCurrent] : false;
                                        var ki = zi !== false ? xi + ":" + yi + ":" + zi : xi + ":" + yi;
                                        if (this.showHistogramDensity || this.xAxisHistogramShow || this.yAxisHistogramShow) {
                                            if (!meta.s.hasOwnProperty(xi.toString()) && meta.a.hasOwnProperty(ki) && this.xAxisHistogramShow) {
                                                var data = [];
                                                for (var j = 0; j < vis.length; j++) {
                                                    data.push(this.getDataAtPos(vis[j], xi, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue))
                                                }
                                                xAxisData.push(data);
                                                meta.s[xi.toString()] = this.density(data, this.data.y.smps[xi])
                                            }
                                            if (!meta.s.hasOwnProperty(yi.toString()) && meta.a.hasOwnProperty(ki) && this.yAxisHistogramShow) {
                                                var data = [];
                                                for (var j = 0; j < vis.length; j++) {
                                                    data.push(this.getDataAtPos(vis[j], yi, false, this.yAxisTransform, this.yAxisFloorValue, this.yAxisCeilValue))
                                                }
                                                yAxisData.push(data);
                                                meta.s[yi.toString()] = this.density(data, this.data.y.smps[yi])
                                            }
                                        }
                                        if (!meta.a.hasOwnProperty(ki)) {
                                            meta.a[ki] = {
                                                vars: [],
                                                skip: {},
                                                density: {},
                                                max: 1,
                                                n: 0,
                                                colorBrew: false
                                            };
                                            var density = {};
                                            var xdata = [];
                                            var ydata = [];
                                            for (var j = 0; j < vis.length; j++) {
                                                var x = this.getDataAtPos(vis[j], xi, false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                var y = this.getDataAtPos(vis[j], yi, false, this.yAxisTransform, this.yAxisFloorValue, this.yAxisCeilValue);
                                                var z = zi !== false ? this.getDataAtPos(vis[j], zi, false, this.zAxisTransform, this.zAxisFloorValue, this.zAxisCeilValue) : null;
                                                var x0 = parseInt((x - this.xAxisMin) * xAxisUnit);
                                                var y0 = parseInt((y - this.yAxisMin) * yAxisUnit);
                                                var z0 = this.sizeBy ? parseInt(this.getPropertyValue(vis[j], null, "sizeBy")) : zi !== false ? this.sizes[Math.floor(this.percentile(this.zAxisMin, this.zAxisMax, z) / 10) + 1] : this.dataPointSize * this.dataPointSizeScaleFactor;
                                                var k0 = x0 + ":" + y0 + ":" + parseInt(z0);
                                                if (this.isNumeric([x0, y0, z0])) {
                                                    if (!density.hasOwnProperty(k0)) {
                                                        density[k0] = []
                                                    }
                                                    density[k0].push(vis[j]);
                                                    if (mark[vis[j]]) {
                                                        override[k0] = true
                                                    }
                                                }
                                                xdata.push(x);
                                                ydata.push(y)
                                            }
                                            if (this.showHistogramDensity || this.xAxisHistogramShow || this.yAxisHistogramShow) {
                                                if (!meta.s.hasOwnProperty(xi.toString()) && xdata.length > 0 && this.xAxisHistogramShow) {
                                                    meta.s[xi.toString()] = this.density(xdata, this.data.y.smps[xi]);
                                                    xAxisData.push(xdata)
                                                }
                                                if (!meta.s.hasOwnProperty(yi.toString()) && ydata.length > 0 && this.yAxisHistogramShow) {
                                                    meta.s[yi.toString()] = this.density(ydata, this.data.y.smps[yi]);
                                                    yAxisData.push(ydata)
                                                }
                                            }
                                            var order = this.getKeys(density).sort(function(a, b) {
                                                return density[a].length - density[b].length || density[a][0] - density[b][0]
                                            });
                                            for (var j = 0; j < order.length; j++) {
                                                var k0 = order[j];
                                                var v0 = density[k0].pop();
                                                meta.a[ki].vars.push(v0);
                                                if (density[k0].length > 0 && !override[k0]) {
                                                    meta.a[ki].max = Math.max(meta.a[ki].max, density[k0].length + 1);
                                                    meta.a[ki].density[v0.toString()] = density[k0].length + 1;
                                                    meta.a[ki].n++;
                                                    for (var k = 0; k < density[k0].length; k++) {
                                                        if (!this.spiderBy) {
                                                            meta.a[ki].skip[density[k0][k].toString()] = v0
                                                        }
                                                    }
                                                }
                                            }
                                            meta.a[ki].colorBrew = this.getColorBrew(false, 1, meta.a[ki].max)
                                        }
                                    }
                                    if (this.showHistogramDensity || this.xAxisHistogramShow || this.yAxisHistogramShow) {
                                        if (xAxisData.length > 0 && this.xAxisHistogramShow) {
                                            meta.x = this.hist2D(xAxisData, this.xAxisIndices, "xAxis")
                                        }
                                        if (yAxisData.length > 0 && this.yAxisHistogramShow) {
                                            meta.y = this.hist2D(yAxisData, this.yAxisIndices, "yAxis")
                                        }
                                    }
                                };
                                this.setAxesDensity1DGraphs = function() {
                                    var c1 = this.showViolinBoxplot && this.graphType == "Boxplot";
                                    var c2 = this.binned && (this.graphType == "Boxplot" || this.graphType == "Dotplot");
                                    var c3 = this.segregateSamplesBy.length && this.isGroupedData && this.groupingFactors.includes(this.segregateSamplesBy[0]);
                                    if (c1 || c2) {
                                        var s = this.isGroupedData ? this.grpIndices : this.smpIndices;
                                        var m = this.meta.data.d;
                                        for (var i = 0; i < this.varIndices.length; i++) {
                                            var d = [];
                                            var idxs = [];
                                            for (var j = 0; j < s.length; j++) {
                                                if (this.isGroupedData) {
                                                    var dt = this.isTransformedData || (this.showBoxplotOriginalData && this.data.y.trans) ? this.data.y.trans : this.data.y.data;
                                                    for (var k = 0; k < this.data.w.grps[s[j]].length; k++) {
                                                        d.push(dt[this.varIndices[i]][this.data.w.grps[s[j]][k]]);
                                                        idxs.push(this.data.w.grps[s[j]][k])
                                                    }
                                                } else {
                                                    d.push(this.getDataAtPos(this.varIndices[i], s[j], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue));
                                                    idxs.push(s[j])
                                                }
                                            }
                                            var dn = this.density(d, this.data.y.vars[this.varIndices[i]]);
                                            m.v[this.varIndices[i]] = {
                                                density: dn,
                                                area: dn.sumY,
                                                scale: dn.maxY,
                                                indices: idxs,
                                                max: dn.maxY
                                            };
                                            if (this.isGroupedData) {
                                                m.g[this.varIndices[i]] = [];
                                                var area = 0;
                                                var scale = 0;
                                                var max = 0;
                                                if (this.layoutValid && !this.isDOE && !c3 && !this.segregateVariablesBy.length && this.data.l) {
                                                    for (var j = 0; j < this.data.l.comp.length; j++) {
                                                        for (var k = 0; k < this.data.w.grps.length; k++) {
                                                            var inter = this.intersectArray(this.data.l.comp[j], this.data.w.grps[k]);
                                                            if (inter.length) {
                                                                var d = [];
                                                                for (var l = 0; l < inter.length; l++) {
                                                                    d.push(dt[this.varIndices[i]][inter[l]])
                                                                }
                                                                var dns = this.density(d, [this.data.l.name[j], this.data.w.glab[k]].join("::"));
                                                                m.g[this.varIndices[i]].push({
                                                                    density: dns,
                                                                    indices: inter
                                                                });
                                                                area = Math.max(area, dns.sumY);
                                                                scale = Math.max(scale, dns.maxY);
                                                                max = Math.max(max, dns.n)
                                                            }
                                                        }
                                                    }
                                                    for (var j = 0; j < m.g[this.varIndices[i]].length; j++) {
                                                        m.g[this.varIndices[i]][j].area = area;
                                                        m.g[this.varIndices[i]][j].scale = scale;
                                                        m.g[this.varIndices[i]][j].max = max;
                                                        m.g[this.varIndices[i]][j].total = dn.n
                                                    }
                                                } else {
                                                    for (var j = 0; j < s.length; j++) {
                                                        var d = [];
                                                        for (var k = 0; k < this.data.w.grps[s[j]].length; k++) {
                                                            d.push(dt[this.varIndices[i]][this.data.w.grps[s[j]][k]])
                                                        }
                                                        var dns = this.density(d, this.data.w.labs[s[j]]);
                                                        m.g[this.varIndices[i]][s[j]] = {
                                                            density: dns,
                                                            indices: this.data.w.grps[s[j]]
                                                        };
                                                        area = Math.max(area, dns.sumY);
                                                        scale = Math.max(scale, dns.maxY);
                                                        max = Math.max(max, dns.n)
                                                    }
                                                    for (var j = 0; j < s.length; j++) {
                                                        m.g[this.varIndices[i]][s[j]].area = area;
                                                        m.g[this.varIndices[i]][s[j]].scale = scale;
                                                        m.g[this.varIndices[i]][s[j]].max = max;
                                                        m.g[this.varIndices[i]][s[j]].total = dn.n
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setAxes = function(type, noExt, frcStck, width, height) {
                                    if (this.smpIndices && this.smpIndices.length < 1) {
                                        return
                                    }
                                    if (this.graphType.match(/Venn|Network|Sankey|Tree/)) {
                                        return
                                    } else {
                                        if (this.graphType.match(/Correlation/)) {
                                            var level = this.isGroupedData ? this.data.w : this.data.y;
                                            this.setMin = null;
                                            this.setMax = null;
                                            if (this.correlationAnchorLegend) {
                                                this.setAxisAttributes("xAxis")
                                            }
                                            if (!level.cor || level.cor.length == 0) {
                                                this.summarize("cor")
                                            }
                                            this.summaryType = "cor";
                                            this.setRangeData("cor");
                                            if (!this.yAxisTitle) {
                                                this.yAxisTitle = "Correlation"
                                            }
                                        } else {
                                            if (this.graphType.match(/Gantt/)) {
                                                this.summaryType = "gantt";
                                                this.setAxisAttributes("xAxis", "gantt")
                                            } else {
                                                if (this.graphType.match(/Fish/)) {
                                                    this.summaryType = "fish";
                                                    this.setAxisAttributes("xAxis", "fish");
                                                    this.setAxisAttributes("yAxis", "fish")
                                                } else {
                                                    if (this.graphType.match(/Scatter|Pie/)) {
                                                        var smpIndices = this.smpIndices;
                                                        var smpIndicesSel = [];
                                                        var axes = ["xAxis"];
                                                        var ax = ["X"];
                                                        if (this.graphType.match(/Scatter/)) {
                                                            axes.push("yAxis");
                                                            ax.push("Y")
                                                        }
                                                        if (this.graphType.match(/ScatterBubble2D|Scatter3D/)) {
                                                            axes.push("zAxis");
                                                            ax.push("Z")
                                                        }
                                                        if (this.graphType == "Scatter3D") {
                                                            this.xAxisTicks = 10;
                                                            this.yAxisTicks = 10;
                                                            this.zAxisTicks = 10
                                                        }
                                                        if (this.scatterAxesEqual) {
                                                            for (var i = 0; i < axes.length; i++) {
                                                                this.setAxis(axes[i]);
                                                                smpIndicesSel = smpIndicesSel.concat(this.getSampleIndices(this[axes[i]]))
                                                            }
                                                        }
                                                        for (var i = 0; i < axes.length; i++) {
                                                            var indx = axes[i] + "Indices";
                                                            var min = "setMin" + ax[i];
                                                            var max = "setMax" + ax[i];
                                                            this.setMin = null;
                                                            this.setMax = null;
                                                            this.setAxis(axes[i]);
                                                            this[indx] = this.toArray(this.getSampleIndices(this[axes[i]]));
                                                            if (this.scatterAxesEqual) {
                                                                this.setSamplesVisible(smpIndicesSel)
                                                            } else {
                                                                this.setSamplesVisible(this[indx])
                                                            }
                                                            if (this[min] != null) {
                                                                this.setMin = this[min]
                                                            }
                                                            if (this[max] != null) {
                                                                this.setMax = this[max]
                                                            }
                                                            if (this.isQQ || this.isCDF) {
                                                                this.setAxisAttributes(axes[i], type)
                                                            } else {
                                                                if (this.isHistogram && (this.histogramStat == "density" || this.histogramType == "stacked")) {
                                                                    this.setAxisAttributes(axes[i], i > 0 ? "density" : false)
                                                                } else {
                                                                    this.setAxisAttributes(axes[i], i > 0 ? type : false, false, this[axes[i] + "Transform"])
                                                                }
                                                            }
                                                            this.setSamplesVisible(smpIndices)
                                                        }
                                                        if (!this.scatterPlotMatrix && !this.isQQ && !this.isCDF) {
                                                            if ((this.xAxisTitleDynamic && !this.ridgeBy) || !this.xAxisTitle) {
                                                                this.xAxisTitle = this.decorations && this.decorations.kaplanMeier ? false : this.layoutValid && this.graphType.match(/Scatter/) && this.xAxis.length == 1 ? this.xAxis[0] : this.xAxis.length == 1 ? this.xAxis[0] : false
                                                            } else {
                                                                if (this.ridgeBy) {
                                                                    this.xAxisTitle = false
                                                                }
                                                            }
                                                            if (this.graphType.match(/Scatter/)) {
                                                                if (this.yAxisTitleDynamic || !this.yAxisTitle) {
                                                                    this.yAxisTitle = this.decorations && this.decorations.kaplanMeier ? false : this.layoutValid && this.xAxis.length == 1 ? this.yAxis[0] : this.yAxis.length == 1 ? this.yAxis[0] : false
                                                                }
                                                                if (this.graphType.match(/ScatterBubble2D|Scatter3D/)) {
                                                                    if (this.zAxisTitleDynamic) {
                                                                        this.zAxisTitle = this.zAxis.length == 1 ? this.zAxis[0] : false
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        if (this.graphType.match(/Scatter/)) {
                                                            if (this.layoutValid && !this.isDOE) {
                                                                if (!this.scattterPlotMatrix && !this.isHistogram) {
                                                                    this.setAxesDensityScatterLayout(width, height)
                                                                }
                                                            } else {
                                                                this.setAxesDensityScatter(width, height)
                                                            }
                                                        }
                                                    } else {
                                                        if (this.graphType.match(/Genome/)) {
                                                            this.setMax = this.setMaxX != null ? this.setMaxX : null;
                                                            this.setMin = this.setMinX != null ? this.setMinX : null;
                                                            this.setRangeData("genome");
                                                            this.xAxisExact = true;
                                                            this.xAxisTransform = false;
                                                            this.xAxisAbsMin = this.minData;
                                                            this.xAxisAbsMax = this.maxData;
                                                            this.xAxisMin = this.minData - 1;
                                                            this.xAxisMax = this.maxData + 1;
                                                            this.xAxisDecs = 0;
                                                            this.xAxisRange = this.xAxisMax - this.xAxisMin;
                                                            this.xAxisTicks = this.genomeTicks;
                                                            this.xAxisIncr = this.xAxisRange / this.xAxisTicks;
                                                            this.setAxisValues("xAxis")
                                                        } else {
                                                            if (this.graphType == "ParallelCoordinates") {
                                                                this.parallelCoordinates = [];
                                                                var level = this.isGroupedData ? this.data.w : this.data.y;
                                                                var indices = this.isGroupedData ? this.grpIndices : this.smpIndices;
                                                                for (var i = 0; i < indices.length; i++) {
                                                                    var ii = indices[i];
                                                                    var lenSmp = this.measureText(level.smps[ii], this.smpLabelFont);
                                                                    var rng = this.range(this.getDataForSmpGrpAtIndex(ii));
                                                                    var valst = this[this.axisAlgorithm](rng[0], rng[1], this.xAxisTicks, this.axisWilkinsonLoose);
                                                                    var vals = [];
                                                                    for (var j = 0; j < valst.length; j++) {
                                                                        if (valst[j] >= rng[0] && valst[j] <= rng[1]) {
                                                                            vals.push(valst[j])
                                                                        }
                                                                    }
                                                                    var maxText = this.getMaxText(vals);
                                                                    var len = this.measureText(maxText, this.axisTickFont);
                                                                    var o = {
                                                                        smp: level.smps[ii],
                                                                        lenSmp: lenSmp,
                                                                        range: rng,
                                                                        min: rng[0],
                                                                        max: rng[1],
                                                                        vals: vals,
                                                                        maxText: maxText,
                                                                        len: len
                                                                    };
                                                                    if (this.meta.data.modified && this.meta.data.modified.z && this.meta.data.modified.z[level.smps[ii]]) {
                                                                        var levs = this.meta.data.modified.z[level.smps[ii]];
                                                                        var maxTextLev = this.getMaxText(levs);
                                                                        var lenLev = this.measureText(maxTextLev, this.axisTickFont);
                                                                        o.levs = levs;
                                                                        o.maxTextLev = maxTextLev;
                                                                        o.lenLev = lenLev;
                                                                        o.type = "String"
                                                                    } else {
                                                                        o.type = "Numeric"
                                                                    }
                                                                    this.parallelCoordinates.push(o)
                                                                }
                                                            } else {
                                                                if (this.graphType.match(/Heatmap|Correlation/) && this.minData && this.maxData && !this.heatmapAutoAdjust) {
                                                                    return
                                                                } else {
                                                                    var that = this;
                                                                    var isStacked = function() {
                                                                        if (that.graphType == "Stacked" || (that.graphType.match(/Stacked/) && !that.segregateVariablesBy.length) || (that.graphType.match(/Area/) && that.areaType.match(/stacked/) && !that.segregateVariablesBy.length) || frcStck || that.stackBy) {
                                                                            return true
                                                                        } else {
                                                                            if (that.layoutValid && that.graphType.match(/Stacked/)) {
                                                                                return true
                                                                            } else {
                                                                                return false
                                                                            }
                                                                        }
                                                                    };
                                                                    var bothAxes = false;
                                                                    var tSmpIdx = this.smpIndices;
                                                                    var tVarIdx = this.varIndices;
                                                                    var tGrpIdx = this.grpIndices;
                                                                    var varIndices = this.varIndices;
                                                                    var forceRaw = (this.graphType == "Dotplot" || this.graphType == "DotLine") && this.isGroupedData ? true : false;
                                                                    var transform = this.graphType.match(/Percent/) || (this.graphType.match(/Area/) && this.areaType.match(/percent/)) ? "percentile" : this.xAxisTransform;
                                                                    var stacked = isStacked();
                                                                    var ttype = transform ? transform : false;
                                                                    var islcm = this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/);
                                                                    if (!this.is3DPlot) {
                                                                        this.setAxis("xAxis", true);
                                                                        this.xAxisVarIndices = this.getVariableIndices(this.xAxis);
                                                                        if (islcm) {
                                                                            this.setAxis("xAxis2", true);
                                                                            this.xAxis2VarIndices = this.getVariableIndices(this.xAxis2);
                                                                            bothAxes = this.cloneObject(this.xAxisVarIndices).concat(this.cloneObject(this.xAxis2VarIndices))
                                                                        }
                                                                    }
                                                                    if (this.varIndicesStart > -1 || this.smpIndicesStart > -1 || this.grpIndicesStart > -1) {
                                                                        if (this.graphType == "Heatmap") {
                                                                            this.graphOrientation = "horizontal"
                                                                        }
                                                                    } else {
                                                                        if (this.graphType == "StackedPercent" || this.graphType == "StackedPercentLine" || (this.graphType.match(/Area/) && this.areaType.match(/percent/))) {
                                                                            this.setMinX = null;
                                                                            this.setMaxX = null;
                                                                            this.xAxisExact = true
                                                                        } else {
                                                                            if ((this.graphType == "Boxplot" && !this.isGroupedData && this.groupingFactors.length == 0) || this.summarizeBoxplot) {
                                                                                this.summarize("iqr");
                                                                                delete(this.summarizeBoxplot)
                                                                            }
                                                                        }
                                                                    }
                                                                    this.xAxis2Ticks = this.xAxisTicks;
                                                                    if (islcm) {
                                                                        this.setVariablesVisible(this.axisCoordinate ? bothAxes : this.getVariablesVisibleByAxis("xAxis"))
                                                                    }
                                                                    this.setMax = this.setMaxX != null ? this.setMaxX : null;
                                                                    this.setMin = this.setMinX != null ? this.setMinX : null;
                                                                    this.setAxesDensity1DGraphs();
                                                                    this.setAxisAttributes("xAxis", ttype, forceRaw, transform, stacked, noExt);
                                                                    if (islcm) {
                                                                        ttype = false;
                                                                        if (islcm) {
                                                                            this.setVariablesVisible(this.axisCoordinate ? bothAxes : this.getVariablesVisibleByAxis("xAxis2"))
                                                                        }
                                                                        this.setMax = this.setMaxX2 != null ? this.setMaxX2 : null;
                                                                        this.setMin = this.setMinX2 != null ? this.setMinX2 : null;
                                                                        this.setAxisAttributes("xAxis2", ttype, forceRaw, transform, stacked)
                                                                    }
                                                                    this.setMax = this.setMaxR != null ? this.setMaxR : this.setMax;
                                                                    this.setMin = this.setMinR != null ? this.setMinR : this.setMin;
                                                                    if (this.graphType == "Circular" && (this.rAxis || this.circularType == "chord")) {
                                                                        this.setAxisAttributes("rAxis", "circular", forceRaw, transform, false, true)
                                                                    }
                                                                    this.setVariablesVisible(varIndices);
                                                                    this.smpIndices = tSmpIdx;
                                                                    this.varIndices = tVarIdx;
                                                                    this.grpIndices = tGrpIdx
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.resetAxes = function(force) {
                                    this.xAxis = this.meta.config.user && this.meta.config.user.xAxis && !force ? this.meta.config.user.xAxis : [];
                                    this.yAxis = this.meta.config.user && this.meta.config.user.yAxis && !force ? this.meta.config.user.yAxis : [];
                                    this.zAxis = this.meta.config.user && this.meta.config.user.zAxis && !force ? this.meta.config.user.zAxis : [];
                                    if (force) {
                                        this.varIndices = [];
                                        this.smpIndices = []
                                    }
                                    this.setAxes()
                                };
                                this.setAxisUnits = function(axis, gaxis) {
                                    var unit = axis + "Unit";
                                    var rang = axis + "Range";
                                    var a = gaxis ? gaxis : axis.substring(0, 1);
                                    this[unit] = this[a] / this[rang]
                                };
                                this.setAxisFont = function(title, axis) {
                                    if (this.autoScaleFont) {
                                        this.setPropertyFontSize(axis, "decorationFont");
                                        this.setPropertyFontSize(axis, "axisTickFont");
                                        this.setPropertyFontSize(axis, "axisTitleFont");
                                        this.adjustFont(title, "axisTitleFont", axis)
                                    } else {
                                        this.decorationFont = this.decorationFontStyle + " " + parseInt(this.decorationFontSize) + "px " + this.fontName;
                                        this.axisTickFont = this.axisTickFontStyle + " " + parseInt(this.axisTickFontSize) + "px " + this.fontName;
                                        this.axisTitleFont = this.axisTitleFontStyle + " " + parseInt(this.axisTitleFontSize) + "px " + this.fontName
                                    }
                                };
                                this.initializeAxis = function(width, height, noColor) {
                                    if (!this.graphType.match(/Venn|Network/)) {
                                        this.setAxes(false, false, false, width, height);
                                        if (!noColor) {
                                            this.setColorBrew()
                                        }
                                    }
                                }
                            };
                            CanvasXpress.prototype.Pie = function(a) {
                                this.setVarPie = function() {
                                    var g = [];
                                    var b = this.smpIndices[0];
                                    if (this.varIndices.length >= this.maxPieSectors - 1) {
                                        var f = this;
                                        this.varIndices.sort(function(h, d) {
                                            return f.data.y.data[d][b] - f.data.y.data[h][b]
                                        })
                                    }
                                    for (var c = 0; c < this.varIndices.length; c++) {
                                        var e = this.varIndices[c];
                                        g.push(this.getDataAtPos(e, b))
                                    }
                                    this.varPie = this.setPieData(g, true)
                                };
                                this.setPieFont = function() {
                                    if (this.autoScaleFont) {
                                        var b = this.layoutComb && this.isDOE ? this.layoutWidth : this.width;
                                        var c = this.layoutComb && this.isDOE ? this.layoutHeight : this.height;
                                        var e = Math.min(b, c) * (1 - this.percentAspectRatioPlotArea);
                                        this.setAxisFont("Pie", e)
                                    }
                                };
                                this.setPieXYDimensions = function() {
                                    if (this.showLegend) {
                                        if (this.legendPosition == "right") {
                                            this.right = this.layoutComb && !this.isDOE ? this.layoutRight : this.layoutComb ? Math.min(this.layoutWidth / 3, this.legendVariableWidth) : Math.min(this.width / 3, this.legendVariableWidth)
                                        } else {
                                            if (this.legendPosition == "left") {
                                                this.left = this.layoutComb && !this.isDOE ? this.layoutRight : this.layoutComb ? Math.min(this.layoutWidth / 3, this.legendVariableWidth) : Math.min(this.width / 3, this.legendVariableWidth)
                                            } else {
                                                if (this.legendPosition == "top") {
                                                    this.top += this.layoutComb && !this.isDOE ? this.layoutBottom : this.layoutComb ? Math.min(this.layoutHeight / 3, this.legendVariableHeight) : Math.min(this.height / 3, this.legendVariableHeight)
                                                } else {
                                                    if (this.legendPosition == "bottom") {
                                                        this.bottom = this.layoutComb && !this.isDOE ? this.layoutBottom : this.layoutComb ? Math.min(this.layoutHeight / 3, this.legendVariableHeight) : Math.min(this.height / 3, this.legendVariableHeight)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    this.x = this.layoutComb && !this.isDOE ? this.layoutWidth : this.layoutComb ? this.layoutWidth - (this.left + this.right) : this.width - (this.marginLeft + this.left + this.right + this.marginRight);
                                    this.y = this.layoutComb && !this.isDOE ? this.layoutHeight : this.layoutComb ? this.layoutHeight - (this.top + this.bottom) : this.height - (this.marginTop + this.top + this.bottom + this.marginBottom)
                                };
                                this.drawPieDataPoints = function() {
                                    if (!this.isDOE) {
                                        this.toRender({
                                            p: ["setClipArea", this.setClipBoundaries()],
                                            t: "Data"
                                        })
                                    }
                                    var c = Math.min(this.x, this.y);
                                    var d = (c - (c / 5)) / 2;
                                    var b = this.marginLeft + this.offsetX + this.left + (this.x / 2);
                                    var e = this.marginTop + this.offsetY + this.top + (this.y / 2);
                                    this.setVarPie();
                                    this.drawPie(this.varPie, b, e, d, true);
                                    if (!this.isDOE) {
                                        this.toRender({
                                            p: ["resetClipArea"],
                                            t: "Data"
                                        })
                                    }
                                };
                                this.drawPiePlot = function() {
                                    this.setPieFont();
                                    this.setLegends();
                                    this.setPieXYDimensions();
                                    this.drawPieDataPoints();
                                    this.drawLegend();
                                    this.drawTitle()
                                };
                                this.initializePiePlot = function() {
                                    if (!this.data.y.pie && this.xAxisMin < 0) {
                                        alert("Dude you can't draw a pie chart with negative numbers!");
                                        return
                                    }
                                    this.setPropertyFontSize(Math.min(this.width, this.height), "smpLabelFont");
                                    if (this.layoutValid) {
                                        this.drawLayoutCompartments(this.drawPiePlot)
                                    } else {
                                        this.drawPiePlot()
                                    }
                                };
                                if (!a) {
                                    this.initializePiePlot()
                                }
                            };
                            CanvasXpress.prototype.Venn = function() {
                                this.setVennXYDimensions = function() {
                                    var a;
                                    this.vennMarginLeft = 0;
                                    this.vennMarginTop = 0;
                                    this.setAxisFont("Venn", this.width);
                                    if (this.showLegend) {
                                        this.bottom = this.legendHeight
                                    }
                                    if (this.width <= this.height) {
                                        this.x = this.width - (this.marginLeft + this.left + this.right + this.marginRight)
                                    } else {
                                        this.x = this.height - (this.marginTop + this.top + this.bottom + this.marginBottom)
                                    }
                                    this.y = this.vennGroups == 4 ? this.x * 0.8 : this.vennGroups == 3 ? this.x * 0.95 : this.vennGroups == 2 ? this.x * 0.65 : this.x;
                                    this.vennMarginTop = (this.height - (this.marginTop + this.top + this.y + this.bottom + this.marginBottom)) / 2;
                                    this.vennMarginLeft = (this.width - (this.marginLeft + this.left + this.x + this.right + this.marginRight)) / 2;
                                    if (this.x < 400) {
                                        var b = this.getFontPt(this.axisTickFont) - 2;
                                        if (this.x < 200) {
                                            b -= 1
                                        }
                                        this.axisTickFont = b + "px " + this.fontName
                                    }
                                    this.resizeCanvas()
                                };
                                this.drawVennBubble = function(f, g, i, c, d, b) {
                                    var a = this.marginLeft + this.left + (this.x / 2);
                                    var e = this.marginTop + this.top + (this.y / 2);
                                    this.toRender({
                                        p: ["drawShape", i, f, g, c, c, this.getFillColor(d), this.getOutlineColor(d), "closed", b],
                                        b: [a, e, 0, 0],
                                        t: "Data"
                                    })
                                };
                                this.drawVennLayoutBubbles = function() {
                                    var e, f, b, d;
                                    var a = [];
                                    for (var c in this.data.venn.legend) {
                                        a.push(c)
                                    }
                                    this.toRender({
                                        p: ["rectangleClear", 0, 0, this.width, this.height],
                                        t: "Data"
                                    });
                                    this.toRender({
                                        p: ["setGlobalCompositionOperation", "lighter"],
                                        t: "Data"
                                    });
                                    if (this.vennGroups == 4) {
                                        e = this.vennMarginLeft + this.marginLeft + this.margin;
                                        f = this.vennMarginTop + this.marginTop + this.top;
                                        this.drawVennBubble(e + (this.x / 4.94), f + (this.x / 13), "ellipse2", this.x / 1.4, this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(255,0,0)", Math.PI / 4);
                                        this.drawVennBubble(e + (this.x / 2.72), f + (this.x / -40.31), "ellipse2", this.x / 1.4, this.vennColors.length > 1 && this.validateColor(this.vennColors[1]) ? this.validateColor(this.vennColors[1]) : "rgb(0,153,51)", Math.PI / 4);
                                        this.drawVennBubble(e + (this.x / 3.43), f + (this.x / 1.72), "ellipse2", this.x / 1.4, this.vennColors.length > 2 && this.validateColor(this.vennColors[2]) ? this.validateColor(this.vennColors[2]) : "rgb(0,0,255)", -Math.PI / 4);
                                        this.drawVennBubble(e + (this.x / 7.96), f + (this.x / 2.07), "ellipse2", this.x / 1.4, this.vennColors.length > 3 && this.validateColor(this.vennColors[3]) ? this.validateColor(this.vennColors[3]) : "rgb(153,204,0)", -Math.PI / 4);
                                        b = [11.2, 3.05, 1.46, 1.08];
                                        d = [7, 42, 42, 7]
                                    } else {
                                        if (this.vennGroups == 3) {
                                            e = this.vennMarginLeft + this.marginLeft + this.left + (this.x / 2);
                                            f = this.vennMarginTop + this.marginTop + this.top + (this.x / 2.86);
                                            this.drawVennBubble(e, f, "circle", this.x / 2, this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(255,0,0)");
                                            f += (this.x / 3.33);
                                            e = this.vennMarginLeft + this.marginLeft + this.left + (this.x / 3);
                                            this.drawVennBubble(e, f, "circle", this.x / 2, this.vennColors.length > 1 && this.validateColor(this.vennColors[1]) ? this.validateColor(this.vennColors[1]) : "rgb(0,255,0)");
                                            e = this.vennMarginLeft + this.marginLeft + this.left + (this.x / 1.5);
                                            this.drawVennBubble(e, f, "circle", this.x / 2, this.vennColors.length > 2 && this.validateColor(this.vennColors[2]) ? this.validateColor(this.vennColors[2]) : "rgb(0,0,255)");
                                            b = [2, 8.66, 1.13];
                                            d = [20, 2.3, 2.3]
                                        } else {
                                            if (this.vennGroups == 2) {
                                                e = this.vennMarginLeft + this.marginLeft + this.left + (this.x / 3);
                                                f = this.vennMarginTop + this.marginTop + this.top + (this.x / 2.67);
                                                this.drawVennBubble(e, f, "circle", this.x / 2, this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(0,0,255)");
                                                e = this.vennMarginLeft + this.marginLeft + this.left + (this.x / 1.5);
                                                f = this.vennMarginTop + this.marginTop + this.top + (this.x / 2.67);
                                                this.drawVennBubble(e, f, "circle", this.x / 2, this.vennColors.length > 1 && this.validateColor(this.vennColors[1]) ? this.validateColor(this.vennColors[1]) : "rgb(255,0,0)");
                                                b = [3, 1.5];
                                                d = [16, 16]
                                            } else {
                                                if (this.vennGroups == 1) {
                                                    e = this.vennMarginLeft + this.marginLeft + this.left + (this.x / 2);
                                                    f = this.vennMarginTop + this.marginTop + this.top + (this.x / 2);
                                                    this.toRender({
                                                        p: ["drawShape", "circle", e, f, this.x, this.x, this.vennColors.length > 0 && this.validateColor(this.vennColors[0]) ? this.validateColor(this.vennColors[0]) : "rgb(255,0,0)", this.foreground, "closed"],
                                                        t: "Data"
                                                    });
                                                    b = [100];
                                                    d = [100]
                                                }
                                            }
                                        }
                                    }
                                    this.toRender({
                                        p: ["setGlobalCompositionOperation", "source-over"],
                                        t: "Data"
                                    });
                                    this.drawVennLayout(b, d, a)
                                };
                                this.drawVennLayout = function(b, e, a) {
                                    if (!this.vennLegendColors) {
                                        for (var d = 0; d < this.vennGroups; d++) {
                                            var c = this.vennMarginLeft + this.marginLeft + this.left + (this.x / b[d]);
                                            var f = this.vennMarginTop + this.marginTop + this.top + (this.x / e[d]);
                                            this.toRender({
                                                p: ["drawText", a[d], c, f, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                t: "Labels"
                                            })
                                        }
                                    }
                                };
                                this.drawVennDataPoints = function() {
                                    var a, e, g;
                                    this.vennCompartments = this.vennCompartments.sort();
                                    if (this.vennGroups == 4) {
                                        g = [0, 8, 1, 12, 5, 9, 2, 14, 7, 11, 13, 4, 6, 10, 3];
                                        a = [5.6, 2.94, 3.5, 1.54, 3.29, 2, 2.59, 1.212, 2, 1.442, 1.4, 1.757, 2.31, 1.624, 2];
                                        e = [2.94, 7, 3.92, 7, 1.89, 4.06, 2.66, 2.94, 1.54, 1.89, 3.92, 1.729, 1.729, 2.66, 2.03];
                                        this.y = (this.x * 1.1) / 1.4
                                    } else {
                                        if (this.vennGroups == 3) {
                                            g = [0, 4, 1, 6, 3, 5, 2];
                                            a = [2, 3.5, 2.55, 1.4, 1.6, 2, 2];
                                            e = [3.6, 1.54, 2.07, 1.54, 2.07, 1.54, 1.83];
                                            this.y = this.x * 0.95
                                        } else {
                                            if (this.vennGroups == 2) {
                                                g = [0, 2, 1];
                                                a = [3.5, 1.4, 2];
                                                e = [2.66, 2.66, 2.66];
                                                this.y = this.x * 0.65
                                            } else {
                                                if (this.vennGroups == 1) {
                                                    g = [0];
                                                    a = [2];
                                                    e = [2]
                                                }
                                            }
                                        }
                                    }
                                    for (var d = 0; d < g.length; d++) {
                                        var c = this.vennMarginLeft + this.marginLeft + this.left + (this.x / a[d]);
                                        var f = this.vennMarginTop + this.marginTop + this.top + (this.x / e[d]);
                                        var b = this.getFontPt(this.axisTickFont);
                                        var h = this.data.venn.data[this.vennCompartments[g[d]]] ? this.data.venn.data[this.vennCompartments[g[d]]] : 0;
                                        if (this.isArray(h)) {
                                            h = h[0]
                                        }
                                        this.toRender({
                                            p: ["drawText", h, c, f, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                            i: [g[d]],
                                            t: "Labels"
                                        })
                                    }
                                };
                                this.validateVennCompartments = function() {
                                    var b = "";
                                    if (this.vennGroups == 4 && this.vennCompartments.length != 15) {
                                        this.vennCompartments = ["A", "B", "AB", "C", "AC", "BC", "ABC", "D", "AD", "BD", "CD", "ABD", "ACD", "BCD", "ABCD"];
                                        b = "Unless there are exactly 15 vennCompartments the Venn data should be mapped to 'A', 'B', 'AB', 'C', 'AC', 'BC', 'ABC', 'D', 'AD', 'BD', 'CD', 'ABD', 'ACD', 'BCD', 'ABCD'"
                                    } else {
                                        if (this.vennGroups == 3 && this.vennCompartments.length != 7) {
                                            this.vennCompartments = ["A", "B", "AB", "C", "AC", "BC", "ABC"];
                                            b = "Unless there are exactly 7 vennCompartments the Venn data should be mapped to 'A', 'B', 'AB', 'C', 'AC', 'BC', 'ABC'"
                                        } else {
                                            if (this.vennGroups == 2 && this.vennCompartments.length != 3) {
                                                this.vennCompartments = ["A", "B", "AB"];
                                                b = "Unless there are exactly 3 vennCompartments the Venn data should be mapped to 'A', 'B', 'AB'"
                                            } else {
                                                if (this.vennGroups == 1 && this.vennCompartments.length != 1) {
                                                    this.vennCompartments = ["A"];
                                                    b = "Unless there are exactly 1 vennCompartments the Venn data should be mapped to 'A'  "
                                                }
                                            }
                                        }
                                    }
                                    for (var a = 0; a < this.vennCompartments.length; a++) {
                                        if (!this.data.venn.data.hasOwnProperty(this.vennCompartments[a])) {
                                            alert("Data for Venn diagram do not conform to specifications. " + b);
                                            break
                                        }
                                    }
                                };
                                this.drawVennPlot = function() {
                                    this.validateVennCompartments();
                                    this.setLegends();
                                    this.setVennXYDimensions();
                                    this.showShadow = false;
                                    this.drawVennLayoutBubbles();
                                    this.showShadow = this.tmpshowShadow;
                                    this.drawVennDataPoints();
                                    this.drawLegend();
                                    this.drawTitle()
                                };
                                this.initializeVennPlot = function() {
                                    this.transparency = null;
                                    this.tmpshowShadow = this.showShadow;
                                    this.background = "rgb(255,255,255)";
                                    this.foreground = "rgb(0,0,0)";
                                    this.drawVennPlot()
                                };
                                this.initializeVennPlot()
                            };
                            CanvasXpress.prototype.Correlation = function() {
                                this.setCorrelationVarSmpLabelFont = function(a) {
                                    this.setPropertyFontSize(Math.min(this.width, this.height) * 0.5, "varLabelFont");
                                    this.setPropertyFontSize(Math.min(this.width, this.height) * 0.5, "smpLabelFont")
                                };
                                this.getCorrelationLabelsHeight = function() {
                                    var a = 0;
                                    if (this.correlationAxis == "samples") {
                                        if (this.meta.data.y.maxSmpChr > this.maxSmpStringLen) {
                                            a += this.measureText(this.meta.data.y.maxSmpStr.substring(0, this.maxSmpStringLen), this.smpLabelFont)
                                        } else {
                                            a += this.measureText(this.meta.data.y.maxSmpStr, this.smpLabelFont)
                                        }
                                    } else {
                                        if (this.meta.data.y.maxVarChr > this.maxVarStringLen) {
                                            a += this.measureText(this.meta.data.y.maxVarStr.substring(0, this.maxVarStringLen), this.varLabelFont)
                                        } else {
                                            a += this.measureText(this.meta.data.y.maxVarStr, this.varLabelFont)
                                        }
                                    }
                                    if (this.correlationAnchorLegend) {
                                        a += this.correlationAnchorLegendAlignWidth + this.margin
                                    }
                                    return a
                                };
                                this.setCorrelationXYDimensions = function() {
                                    this.corMarginLeft = 0;
                                    this.corMarginTop = 0;
                                    if (this.yAxisShow) {
                                        this.setAxisFont(this.yAxisTitle, Math.min(this.width, this.height));
                                        this.left = this.margin + this.getFontPt(this.axisTitleFont) + this.margin
                                    }
                                    if (this.width <= this.height) {
                                        this.x = this.width - (this.marginLeft + this.left + this.right + this.marginRight)
                                    } else {
                                        this.x = this.height - (this.marginTop + this.top + this.bottom + this.marginBottom)
                                    }
                                    var a = this.correlationAxis == "variables" ? this.varIndices.length : this.isGroupedData ? this.grpIndices.length : this.smpIndices.length;
                                    if (this.correlationType != "circle") {
                                        this.correlationType = "diamond"
                                    }
                                    this.diamondSize = this.x / a;
                                    this.diamondScale = 1;
                                    if (this.correlationType == "circle") {
                                        this.diamondScale = 0.6
                                    }
                                    this.setCorrelationVarSmpLabelFont(a);
                                    this.setLegendFont();
                                    this.y = this.x / 2 + (this.diamondSize / 2);
                                    if (this.xAxisShow) {
                                        this.top += this.margin + this.getCorrelationLabelsHeight() + this.margin
                                    }
                                    if (this.autoAdjust) {
                                        this.height = this.marginTop + this.top + this.y + this.bottom + this.marginBottom;
                                        this.width = this.marginLeft + this.left + this.x + this.right + this.marginRight
                                    } else {
                                        this.corMarginTop = (this.height - (this.marginTop + this.top + this.y + this.bottom + this.marginBottom)) / 2;
                                        this.corMarginLeft = (this.width - (this.marginLeft + this.left + this.x + this.right + this.marginRight)) / 2
                                    }
                                    this.resizeCanvas()
                                };
                                this.drawCorrelationLayout = function() {
                                    if (this.yAxisShow) {
                                        this.toRender({
                                            p: ["drawText", this.yAxisTitle, this.corMarginLeft + this.marginLeft + this.left / 2, this.marginTop + this.top + (this.y / 2), this.axisTitleFont, this.axisTitleColor, "center", "middle", -Math.PI / 2],
                                            t: "Labels"
                                        })
                                    }
                                    if (this.xAxisShow) {
                                        var p = this.corMarginLeft + this.marginLeft + this.left + (this.diamondSize / 2);
                                        var d = (this.corMarginTop + this.marginTop + this.top) - this.margin;
                                        var c = (this.corMarginTop + this.marginTop + this.top) - (this.getCorrelationLabelsHeight() + this.margin);
                                        var b = c + this.correlationAnchorLegendAlignWidth;
                                        var q, j, r;
                                        var a = this.isGroupedData ? this.data.w : this.data.y;
                                        var k = this.diamondSize * this.diamondScale;
                                        var f = this.correlationAxis == "variables" ? this.varIndices : this.isGroupedData ? this.grpIndices : this.smpIndices;
                                        var m = this.correlationAxis == "samples" ? this.maxSmpStringLen : this.maxVarStringLen;
                                        if (this.correlationAnchorLegend) {
                                            r = this.correlationAxis == "samples" ? a.data[0] : this.getDataForSmpGrpAtIndex(0);
                                            if ((this.smpIndicesStart < 0 && this.correlationAxis == "samples") || (this.varIndicesStart < 0 && this.correlationAxis == "variables")) {
                                                f.sort(function(t, i) {
                                                    return r[t] - r[i]
                                                })
                                            }
                                            this.setAxisUnits("xAxis")
                                        }
                                        if (this.correlationAxis == "samples") {
                                            q = a.smps;
                                            j = this.smpLabelFont
                                        } else {
                                            q = a.vars;
                                            j = this.varLabelFont
                                        }
                                        for (var n = 0; n < f.length; n++) {
                                            var h = f[n];
                                            var l = this.shortenText(q[h], m);
                                            var e = this.correlationAxis == "samples" ? this.getSmpColor(q[h]) : this.getVarColor(q[h]);
                                            var g = n / this.correlationLabelInterval;
                                            if (parseInt(g) == parseFloat(g)) {
                                                this.toRender({
                                                    p: ["drawText", l, p, d, j, e, "left", "middle", -Math.PI / 2],
                                                    t: "Labels"
                                                })
                                            }
                                            if (this.correlationAnchorLegend) {
                                                var s;
                                                if ((this.smpIndicesStart < 0 && this.correlationAxis == "samples") || (this.varIndicesStart < 0 && this.correlationAxis == "variables")) {
                                                    s = r[h]
                                                } else {
                                                    s = r[n]
                                                }
                                                var o = this.corMarginLeft + this.marginLeft + this.left + ((s - this.xAxisMin) * this.xAxisUnit);
                                                this.toRender({
                                                    p: ["drawLine", "line", o, c - this.margin, o, c, e],
                                                    t: "Labels"
                                                });
                                                this.toRender({
                                                    p: ["drawLine", "line", o, c, p, b, e],
                                                    t: "Labels"
                                                })
                                            }
                                            p += this.diamondSize
                                        }
                                    }
                                    p = this.corMarginLeft + this.marginLeft + this.left;
                                    d = this.marginTop + this.top + this.y - (this.heatmapIndicatorHeight * 2);
                                    if (this.correlationAnchorLegend) {
                                        this.setRangeData("cor")
                                    }
                                    if (this.minData == null || this.maxData == null) {
                                        this.setRangeData("cor")
                                    }
                                    if (this.showLegend) {
                                        this.drawColorIndicator(p, d, this.getDefaultMetaDataObject(), "Correlation", true)
                                    }
                                };
                                this.drawCorrelationDataPoints = function() {
                                    var q, c;
                                    var m = this.diamondSize / 2;
                                    var t = this.isGroupedData ? this.data.w.cor : this.data.y.cor;
                                    var h = this.diamondSize * this.diamondScale;
                                    var f = this.correlationAxis == "variables" ? this.varIndices : this.isGroupedData ? this.grpIndices : this.smpIndices;
                                    var s = this.corMarginLeft + this.marginLeft + this.left + m;
                                    var d = this.corMarginTop + this.marginTop + this.top + m;
                                    var a = [this.corMarginLeft + this.marginLeft + this.left + (this.x / 2), this.corMarginTop + this.marginTop + this.top + this.y];
                                    for (var o = 0; o < Math.ceil(f.length / 2); o++) {
                                        var g = f[o];
                                        q = s + (this.diamondSize * o);
                                        c = d;
                                        for (var n = o; n < f.length - o; n++) {
                                            var r = f[n];
                                            var u = t[g][r];
                                            var e = this.getFillColor(this.getColorForValue(false, u));
                                            var p = this.correlationType == "circle" ? Math.round(Math.abs(u) * h * 10) / 10 : h;
                                            if (isNaN(u)) {
                                                this.toRender({
                                                    p: ["drawShape", this.correlationType, q, c, h, h, this.getFillColor(this.missingDataColor), this.getFillColor(this.missingDataColor), "closed"],
                                                    a: this.getShapeArea(this.correlationType, q, c, h, h, this.getFillColor(this.missingDataColor), this.getFillColor(this.missingDataColor), "closed"),
                                                    i: [g, r],
                                                    b: a,
                                                    t: "Data"
                                                })
                                            } else {
                                                this.toRender({
                                                    p: ["drawShape", this.correlationType, q, c, p, p, e, e, "closed"],
                                                    a: this.getShapeArea(this.correlationType, q, c, p, p, e, e, "closed"),
                                                    i: [g, r],
                                                    b: a,
                                                    t: "Data"
                                                })
                                            }
                                            q += m;
                                            c += m
                                        }
                                        c -= this.diamondSize;
                                        for (var l = n - 2; l >= o; l--) {
                                            var b = f[(f.length - l) - 1];
                                            var u = t[b][r];
                                            var e = this.getFillColor(this.getColorForValue(false, u));
                                            var p = this.correlationType == "circle" ? Math.round(Math.abs(u) * h * 10) / 10 : h;
                                            if (isNaN(u)) {
                                                this.toRender({
                                                    p: ["drawShape", this.correlationType, q, c, h, h, this.getFillColor(this.missingDataColor), this.getFillColor(this.missingDataColor), "closed"],
                                                    a: this.getShapeArea(this.correlationType, q, c, h, h, this.getFillColor(this.missingDataColor), this.getFillColor(this.missingDataColor), "closed"),
                                                    i: [b, r],
                                                    b: a,
                                                    t: "Data"
                                                })
                                            } else {
                                                this.toRender({
                                                    p: ["drawShape", this.correlationType, q, c, p, p, e, e, "closed"],
                                                    a: this.getShapeArea(this.correlationType, q, c, p, p, e, e, "closed"),
                                                    i: [b, r],
                                                    b: a,
                                                    t: "Data"
                                                })
                                            }
                                            q += m;
                                            c -= m
                                        }
                                    }
                                    if (h < 8) {
                                        return
                                    }
                                    this.toRender({
                                        p: ["drawLine", "line", this.corMarginLeft + this.marginLeft + this.left, this.corMarginTop + this.marginTop + this.top + m, this.corMarginLeft + this.marginLeft + this.left + (this.x / 2), this.corMarginTop + this.marginTop + this.top + this.y, this.foreground, false, "butt"],
                                        s: true,
                                        t: "Data"
                                    });
                                    this.toRender({
                                        p: ["drawLine", "line", this.corMarginLeft + this.marginLeft + this.left + this.x, this.corMarginTop + this.marginTop + this.top + m, this.corMarginLeft + this.marginLeft + this.left + (this.x / 2), this.corMarginTop + this.marginTop + this.top + this.y, this.foreground, false, "butt"],
                                        s: true,
                                        t: "Data"
                                    });
                                    s = this.corMarginLeft + this.marginLeft + this.left + m;
                                    d = this.corMarginTop + this.marginTop + this.top;
                                    q = s + (this.x / 2);
                                    c = (this.corMarginTop + this.marginTop + this.top + this.y) - m;
                                    for (var o = 0; o < f.length; o++) {
                                        this.toRender({
                                            p: ["drawLine", "line", s, d, q, c, this.foreground, false, "butt"],
                                            s: true,
                                            t: "Data"
                                        });
                                        s += this.diamondSize;
                                        q += m;
                                        c -= m
                                    }
                                    s = (this.corMarginLeft + this.marginLeft + this.left + this.x) - m;
                                    d = this.corMarginTop + this.marginTop + this.top;
                                    q = (this.corMarginLeft + this.marginLeft + this.left + (this.x / 2)) - m;
                                    c = (this.corMarginTop + this.marginTop + this.top + this.y) - m;
                                    for (var o = 0; o < f.length; o++) {
                                        this.toRender({
                                            p: ["drawLine", "line", s, d, q, c, this.foreground, false, "butt"],
                                            s: true,
                                            t: "Data"
                                        });
                                        s -= this.diamondSize;
                                        q -= m;
                                        c -= m
                                    }
                                };
                                this.drawCorrelationPlot = function() {
                                    this.setCorrelationXYDimensions();
                                    this.drawCorrelationLayout();
                                    this.drawTitle();
                                    this.drawCorrelationDataPoints()
                                };
                                this.initializeCorrelationPlot = function() {
                                    this.drawCorrelationPlot()
                                };
                                this.initializeCorrelationPlot()
                            };
                            CanvasXpress.prototype.Scatter2D = function(a) {
                                this.get2DYAxisTitleWidth = function(b) {
                                    if (this.yAxisTitle || this.yAxis2Title) {
                                        return this.yAxisShow || b ? this.getFontPt(this.axisTitleFont) + (this.margin * 2) : this.margin
                                    } else {
                                        return this.margin
                                    }
                                };
                                this.get2DYAxisWidth = function(b) {
                                    if (this.scatterPlotMatrix && (!this.layoutAdjust || this.layoutAdjust == "axis" || this.scatterPlotMatrixType.match(/correlation|all/))) {
                                        return this.yAxisShow || b ? this.measureText(this.yAxisMaxStrLength, this.axisTickFont) : this.margin
                                    } else {
                                        var c;
                                        if (this.layoutValid && this.layoutAdjust && this.yAxisLayoutMaxTickStrLength) {
                                            c = this.yAxisLayoutMaxTickStrLength
                                        } else {
                                            if (this.ridgeBy && this.isCreateHistogram) {
                                                c = this.getMaxText(this.data.y.smps);
                                                c = this.measureText(c, this.axisTickFont) + (this.margin * 2)
                                            } else {
                                                c = this.isGraphTime == "y" ? this.dateFormat(new Date(this.yAxisMax), this.timeFormat) : this.yAxisMaxStrLength;
                                                c = this.measureText(this.formatAxisValue(parseFloat(c), "yAxis"), this.axisTickFont) + (this.margin * 3)
                                            }
                                        }
                                        if (this.yAxisTitle || this.yAxis2Title) {
                                            return this.yAxisShow || b ? this.getFontPt(this.axisTitleFont) + c + (this.margin * 5) : this.margin
                                        } else {
                                            return this.yAxisShow || b ? c + (this.margin * 3) : this.margin
                                        }
                                    }
                                };
                                this.get2DXAxisTitleHeight = function(b) {
                                    if (this.xAxisTitle || this.xAxis2Title) {
                                        return this.xAxisShow || b ? this.getFontPt(this.axisTitleFont) + (this.margin * 2) : this.margin
                                    } else {
                                        return this.margin
                                    }
                                };
                                this.get2DXAxisHeight = function(b) {
                                    if (this.scatterPlotMatrix && (!this.layoutAdjust || this.layoutAdjust == "axis" || this.scatterPlotMatrixType.match(/correlation|all/))) {
                                        return this.xAxisShow || b ? this.getFontPt(this.axisTickFont) + (this.margin * 3) : this.margin
                                    } else {
                                        if (this.xAxisTitle || this.xAxis2Title) {
                                            return this.xAxisShow ? this.getFontPt(this.axisTickFont) + this.getFontPt(this.axisTitleFont) + (this.margin * 5) : this.margin
                                        } else {
                                            return this.xAxisShow ? this.getFontPt(this.axisTickFont) + (this.margin * 3) : this.margin
                                        }
                                    }
                                };
                                this.set2DFont = function() {
                                    var e = this.yAxisTitle || "";
                                    var f = this.yAxis2Title || "";
                                    var b = this.xAxisTitle || "";
                                    var h = e.length > f.length ? e : f;
                                    var c = b.length > h.length ? b : h;
                                    var g = Math.min(this.layoutComb && this.isDOE ? this.layoutWidth : this.width, this.layoutComb && this.isDOE ? this.layoutHeight : this.height) * (1 - this.percentAspectRatioPlotArea) * (this.scatterPlotMatrix ? 0.5 : 1);
                                    this.setAxisFont(c, g);
                                    this.setPropertyFontSize(this.layoutComb && this.isDOE ? this.layoutWidth : this.width, "motionCurrentFont", 80)
                                };
                                this.reRangeData = function() {
                                    if (this.isValidQQ()) {
                                        this.setAxes("qq")
                                    } else {
                                        if (this.isValidCDF()) {
                                            this.setAxes("cdf")
                                        } else {
                                            if (this.isValidKaplanMeier()) {
                                                this.xAxis = [];
                                                for (var b = 0; b < this.decorations.kaplanMeier.length; b++) {
                                                    this.xAxis.push(this.decorations.kaplanMeier[b].time);
                                                    this.xAxisTitle = this.decorations.kaplanMeier[b].time
                                                }
                                                this.yAxisTitle = "Probability of Survival";
                                                this.setAxes("km")
                                            }
                                        }
                                    }
                                };
                                this.set2DXYDimensions = function() {
                                    var l = this.isValidKaplanMeier() || this.isValidQQ() || this.isValidCDF();
                                    var g = this.xAxisMajorTicks || this.xAxisMinorTicks || this.xAxisShow;
                                    var e = this.yAxisMajorTicks || this.yAxisMinorTicks || this.yAxisShow;
                                    this.setLegends();
                                    if (l) {
                                        this.reRangeData()
                                    }
                                    var c = this.measureText(this.yAxisValues[this.yAxisValues.length - 1], this.axisTickFont) / 2;
                                    this.right = this.isDOE || this.graphType == "Fish" ? this.margin * 5 : this.layoutComb || (this.scatterType == "visium" && !g) ? 0 : this.yAxis2Show ? this.get2DYAxisWidth(true) : Math.max(c, this.margin);
                                    if (!this.layoutComb) {
                                        if (this.isQQ || this.isCDF) {
                                            this.right += this.margin
                                        } else {
                                            if (!this.legendInside) {
                                                if (this.showLegend && this.legendPosition == "right" && this.legendWidth > 0) {
                                                    this.right += this.legendWidth + this.margin
                                                }
                                                if (this.showDecorations && this.showDecorationsLegend && this.decorationsPosition == "right" && this.legendDecorationWidth > 0) {
                                                    this.right += this.legendDecorationWidth + this.margin
                                                }
                                            }
                                            if (this.yAxisHistogramShow && !this.layoutComb && !this.isCreateHistogram && this.graphType != "Fish" && !l) {
                                                this.right += this.yAxisHistogramHeight + (this.margin * 2)
                                            }
                                            if (this.graphType == "ScatterBubble2D" && this.zAxisShow) {
                                                this.right += this.getFontPt(this.axisTitleFont) + this.margin
                                            } else {
                                                this.right += this.margin
                                            }
                                        }
                                    }
                                    var c = this.measureText(this.yAxisValues[0], this.axisTickFont) / 2;
                                    this.left = this.graphType == "Fish" ? this.margin * 5 : this.isDOE ? this.get2DYAxisWidth() + (this.margin * 1) : this.scatterType == "visium" && !g ? 0 : this.layoutComb && (!this.layoutAdjust || this.layoutAdjust == "axis" || this.scatterPlotMatrixType.match(/correlation|all/)) ? this.margin : Math.max(c, this.get2DYAxisWidth());
                                    if ((this.segregateVariablesBy.length || this.segregateSamplesBy.length || this.scatterPlotMatrix) && this.layoutCollapse && this.graphType != "Fish") {
                                        this.left -= this.margin
                                    }
                                    if (!this.legendInside) {
                                        if (this.showLegend && this.legendPosition == "left" && this.legendWidth > 0 && !l) {
                                            this.left += this.legendWidth + this.margin
                                        }
                                    }
                                    this.top = this.isDOE || this.graphType == "Fish" ? this.margin * 5 : this.layoutValid && this.layoutCollapse ? 0 : this.layoutValid ? this.margin : this.marginTop + this.margin;
                                    if (!this.legendInside && !this.layoutComb && !l) {
                                        if (this.showLegend && this.legendPosition == "top" && this.legendHeight > 0) {
                                            this.top += this.legendHeight + this.margin
                                        }
                                    }
                                    if (!this.layoutComb) {
                                        this.top += this.getTitleSubtitleHeight();
                                        if (this.xAxisHistogramShow && !this.layoutComb && !this.isCreateHistogram && this.graphType != "Fish" && !l) {
                                            this.top += this.xAxisHistogramHeight + (this.margin * 2)
                                        } else {
                                            if (this.graphType == "Fish") {
                                                this.top += this.get2DXAxisHeight()
                                            }
                                        }
                                    } else {
                                        if (this.scatterPlotMatrix && this.scatterPlotMatrixType.match(/first/)) {
                                            this.top += this.layoutLabelBoxThickness
                                        } else {
                                            if (this.layoutValid && this.layoutType == "wrap" && (this.segregateVariablesBy.length || this.segregateSamplesBy.length)) {
                                                this.top += (this.layoutLabelBoxThickness * (this.segregateVariablesBy.length + this.segregateSamplesBy.length)) - this.margin
                                            }
                                        }
                                    }
                                    this.bottom = this.graphType == "Fish" ? this.margin * 5 : this.isDOE ? this.get2DXAxisHeight() + (this.margin * 3) : this.scatterType == "visium" && !e ? 0 : this.layoutComb && (!this.layoutAdjust || this.layoutAdjust == "axis" || this.scatterPlotMatrixType.match(/correlation|all/) || this.segregateVariablesBy.length || this.segregateSamplesBy.length) ? 0 : this.get2DXAxisHeight() + this.margin;
                                    if (!this.legendInside && !this.layoutComb && !this.isValidQQ() && !this.isValidCDF()) {
                                        if (this.showLegend && this.legendPosition == "bottom" && this.legendHeight > 0) {
                                            this.bottom += this.legendHeight + this.margin
                                        }
                                        if (this.showDecorations && this.showDecorationsLegend && this.decorationsPosition == "bottom" && this.legendDecorationHeight > 0) {
                                            this.bottom += this.legendDecorationHeight + this.margin
                                        }
                                    }
                                    if (this.layoutValid && this.graphType != "Fish" && (this.segregateVariablesBy.length || this.segregateSamplesBy.length) && !this.layoutCollapse && this.layoutType == "wrap") {
                                        this.bottom += this.margin
                                    }
                                    if (this.citation && !this.layoutValid) {
                                        this.bottom += this.getCitationHeight()
                                    }
                                    var m = this.width;
                                    var j = this.motionBy && this.graphType != "Fish" ? this.height - 40 : this.height;
                                    this.x = this.layoutComb ? this.layoutWidth - (this.left + this.right) : m - (this.marginLeft + this.left + this.right + this.marginRight);
                                    this.y = this.layoutComb ? this.layoutHeight - (this.top + this.bottom) : j - (this.marginTop + this.top + this.bottom + this.marginBottom);
                                    if (this.fixedAspectRatio || (this.scatterType == "visium" && this.visiumFixedAspectRatio)) {
                                        var f = this.scatterType == "visium" ? CanvasXpress.cacheImages[this.backgroundImageMD5 || this.getFileName(this.backgroundImage)] : false;
                                        var b = this.scatterType == "visium" ? f.height / f.width : Math.abs(this.fixedAspectRatio);
                                        if (this.x > this.y) {
                                            var k = (this.x - (this.y / b)) / 2;
                                            this.left += k;
                                            this.right += k;
                                            this.x -= (k * 2)
                                        } else {
                                            var k = (this.y - (this.x * b)) / 2;
                                            this.top += k;
                                            this.bottom += k;
                                            this.y -= (k * 2)
                                        }
                                    }
                                    if (!this.layoutComb || this.isDOE) {
                                        this.reRangeData()
                                    }
                                    if (this.motionBy && !this.reproducing) {
                                        this.addMotionDiv()
                                    }
                                    if (this.scatterType == "visium") {
                                        this.setAxes();
                                        this.setAxisunitsVisium();
                                        this.checkVisium()
                                    } else {
                                        this.setAxisUnits("xAxis");
                                        this.setAxisUnits("yAxis")
                                    }
                                };
                                this.setAxisunitsVisium = function() {
                                    var k = CanvasXpress.cacheImages[this.backgroundImageMD5 || this.getFileName(this.backgroundImage)];
                                    var m = k.height / k.width;
                                    var f = this.setMinX || 0;
                                    var c = this.setMaxX || k.width;
                                    var h = c - f;
                                    var e = this.setMinY || 0;
                                    var b = this.setMaxY || k.height;
                                    var g = b - e;
                                    if (h * this.height / m > g * this.width * m) {
                                        this.setAxisUnits("xAxis");
                                        this.yAxisUnit = this.xAxisUnit * m;
                                        var j = g * this.yAxisUnit;
                                        var i = this.y - j;
                                        this.y -= i;
                                        this.top += (i / 2);
                                        this.bottom += (i / 2)
                                    } else {
                                        this.setAxisUnits("yAxis");
                                        this.xAxisUnit = this.yAxisUnit / m;
                                        var l = h * this.xAxisUnit;
                                        var i = this.x - l;
                                        this.x -= i;
                                        this.left += (i / 2);
                                        this.right += (i / 2)
                                    }
                                };
                                this.set2DWireFrame = function() {
                                    var b = this.xAxisMajorTicks || this.xAxisMinorTicks || this.xAxisShow;
                                    var g = this.yAxisMajorTicks || this.yAxisMinorTicks || this.yAxisShow;
                                    var d = this.marginLeft + this.offsetX + this.left;
                                    var c = d + this.x;
                                    var f = this.marginTop + this.offsetY + this.top;
                                    var e = f + this.y;
                                    if (!b && !g) {
                                        return
                                    }
                                    if (this.graphType != "Fish" && g) {
                                        this.set2DWireFrameY(d, c)
                                    }
                                    if (b) {
                                        this.set2DWireFrameX(f, e)
                                    }
                                };
                                this.set2DWireFrameY = function(f, c, n) {
                                    this.toRender({
                                        p: ["disableGradientTransparencyShadow"],
                                        t: "Axes2"
                                    });
                                    var j = this.yAxisTickStyle == "dotted" ? "dottedLine" : "line";
                                    if (this.ridgeBy && this.isCreateHistogram) {
                                        var r = this.marginTop + this.offsetY + this.top + this.y + (this.yAxisMin * this.yAxisUnit);
                                        var l = this.ridgelineScale - 1;
                                        var h = Math.max(this.data.y.maxLevel, this.ridgelineScale);
                                        var d = this.y / (this.ridgelineScale > 1 ? h + l : h + 0.1);
                                        for (var k = 0; k < this.data.y.maxLevel; k++) {
                                            var q = r - (d * k);
                                            this.toRender({
                                                p: ["drawLine", j, f, q, c, q, this.yAxisTickColor, this.axisTickThickness / 3, "butt"],
                                                a: this.getLineArea(j, f, q, c, q, this.yAxisTickColor, this.axisTickThickness / 3, "butt"),
                                                i: ["Ym" + this.layoutCurrent + k],
                                                t: "Axes2"
                                            })
                                        }
                                    } else {
                                        if (this.yAxisMinorTicks) {
                                            for (var k = 0; k < this.yAxisMinorValues.length; k++) {
                                                var g = this.yAxisMinorValues[k];
                                                if (g >= this.yAxisMin && g <= this.yAxisMax) {
                                                    var q = (this.marginTop + this.offsetY + this.top + this.y) - ((g - this.yAxisMin) * this.yAxisUnit);
                                                    this.toRender({
                                                        p: ["drawLine", j, f, q, c, q, this.yAxisTickColor, this.axisTickThickness / 3, "butt"],
                                                        a: this.getLineArea(j, f, q, c, q, this.yAxisTickColor, this.axisTickThickness / 3, "butt"),
                                                        i: ["Ym" + this.layoutCurrent + k],
                                                        t: "Axes2"
                                                    })
                                                }
                                            }
                                        }
                                        for (var k = 0; k < this.yAxisValuesRaw.length; k++) {
                                            var g = this.yAxisValuesRaw[k];
                                            if (g >= this.yAxisMin && g <= this.yAxisMax) {
                                                var q = (this.marginTop + this.offsetY + this.top + this.y) - ((g - this.yAxisMin) * this.yAxisUnit);
                                                if (this.yAxisMajorTicks && this.scatterType != "manhattan") {
                                                    this.toRender({
                                                        p: ["drawLine", j, f, q, c, q, this.yAxisTickColor, this.axisTickThickness, "butt"],
                                                        a: this.getLineArea(j, f, q, c, q, this.yAxisTickColor, this.axisTickThickness, "butt"),
                                                        i: ["YM" + this.layoutCurrent + k],
                                                        t: "Axes2"
                                                    });
                                                    if (this.yAxisShow) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", f - this.margin, q, f, q, this.yAxisTopBottomTickColor, 1, "butt"],
                                                            a: this.getLineArea("line", f - this.margin, q, f, q, this.yAxisTopBottomTickColor, 1, "butt"),
                                                            i: ["YMt" + this.layoutCurrent + k],
                                                            t: "Axes2"
                                                        })
                                                    } else {
                                                        if (this.yAxisS2Show) {
                                                            if (this.layoutValid && ((this.scatterPlotMatrix && this.showScatterPlotMatrixLabels && this.scatterPlotMatrixType != "first") || this.layoutType == "rows" || (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1))) {
                                                                var b = c + this.layoutLabelBoxThickness;
                                                                this.toRender({
                                                                    p: ["drawLine", "line", b, q, b + this.margin, q, this.yAxisTopBottomTickColor, 1, "butt"],
                                                                    a: this.getLineArea("line", b, q, b + this.margin, q, this.yAxisTopBottomTickColor, 1, "butt"),
                                                                    i: ["YMt" + this.layoutCurrent + k],
                                                                    t: "Axes2"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawLine", "line", c, q, c + this.margin, q, this.yAxisTopBottomTickColor, 1, "butt"],
                                                                    a: this.getLineArea("line", c, q, c + this.margin, q, this.yAxisTopBottomTickColor, 1, "butt"),
                                                                    i: ["YMt" + this.layoutCurrent + k],
                                                                    t: "Axes2"
                                                                })
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (this.yAxisShow) {
                                                        this.toRender({
                                                            p: ["drawLine", j, f - this.margin, q, f, q, this.yAxisTickColor, this.axisTickThickness, "butt"],
                                                            a: this.getLineArea(j, f - this.margin, q, f, q, this.yAxisTickColor, this.axisTickThickness, "butt"),
                                                            i: ["Y" + this.layoutCurrent + k],
                                                            t: "Axes2"
                                                        })
                                                    }
                                                    if (this.yAxisS2Show || (this.scatterType == "manhattan" && this.yAxis2Show)) {
                                                        this.toRender({
                                                            p: ["drawLine", j, c, q, c + this.margin, q, this.yAxisTickColor, this.axisTickThickness, "butt"],
                                                            a: this.getLineArea(j, c, q, c + this.margin, q, this.yAxisTickColor, this.axisTickThickness, "butt"),
                                                            i: ["Y" + this.layoutCurrent + k],
                                                            t: "Axes2"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (n) {
                                        var f = f - (this.axisMinMaxTickThickness / 2);
                                        var c = c - 0.5;
                                        var q = this.marginTop + this.offsetY + this.top;
                                        var p = q + this.y;
                                        if (this.xAxisLeftMajorTick) {
                                            this.toRender({
                                                p: ["drawLine", "line", f, q, c, q, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                t: "Axes2"
                                            })
                                        }
                                        if (this.xAxisRightMajorTick) {
                                            this.toRender({
                                                p: ["drawLine", "line", f, p, c, p, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                t: "Axes2"
                                            })
                                        }
                                        if (this.yAxisTopMajorTick) {
                                            this.toRender({
                                                p: ["drawLine", "line", c, q, c, p, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                t: "Axes2"
                                            })
                                        }
                                        if (this.yAxisBottomMajorTick) {
                                            this.toRender({
                                                p: ["drawLine", "line", f, q, f, p, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                t: "Axes2"
                                            })
                                        }
                                    } else {
                                        if (this.yAxisTopMajorTick) {
                                            var q = this.marginTop + this.offsetY + this.top;
                                            this.toRender({
                                                p: ["drawLine", "line", f - (this.axisMinMaxTickThickness / 2), q, c + 0.5, q, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                a: this.getLineArea("line", f - (this.axisMinMaxTickThickness / 2), q, c + 0.5, q, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"),
                                                i: ["YT" + this.layoutCurrent],
                                                t: "Axes2"
                                            })
                                        }
                                        if (this.yAxisBottomMajorTick) {
                                            var q = this.marginTop + this.offsetY + this.top + this.y;
                                            this.toRender({
                                                p: ["drawLine", "line", f - (this.axisMinMaxTickThickness / 2), q, c + 0.5, q, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                a: this.getLineArea("line", f - (this.axisMinMaxTickThickness / 2), q, c + 0.5, q, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"),
                                                i: ["YB" + this.layoutCurrent],
                                                t: "Axes2"
                                            })
                                        }
                                    }
                                    this.toRender({
                                        p: ["enableGradientTransparencyShadow"],
                                        t: "Axes2"
                                    })
                                };
                                this.set2DWireFrameX = function(p, o, l) {
                                    this.toRender({
                                        p: ["disableGradientTransparencyShadow"],
                                        t: "Axes"
                                    });
                                    var c = this.setClipBoundaries();
                                    if (this.scatterType == "manhattan") {
                                        this.toRender({
                                            p: ["setClipArea", c],
                                            t: "Axes"
                                        })
                                    }
                                    var h = this.xAxisTickStyle == "dotted" ? "dottedLine" : "line";
                                    if (this.graphType == "Fish") {
                                        var n = this.fishAxis.length ? this.fishAxis : this.fishTimepoints;
                                        for (var j = 0; j < n.length; j++) {
                                            if (n[j] >= this.fishTimepoints[0] && n[j] <= this.fishTimepoints[this.fishTimepoints.length - 1]) {
                                                var f = (this.marginLeft + this.offsetX + this.left) + ((n[j] - this.xAxisMin) * this.xAxisUnit);
                                                this.toRender({
                                                    p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"],
                                                    a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"),
                                                    i: ["Xm" + this.layoutCurrent + j],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    } else {
                                        if (this.xAxisMinorTicks) {
                                            for (var j = 0; j < this.xAxisMinorValues.length; j++) {
                                                var g = this.xAxisMinorValues[j];
                                                if (g >= this.xAxisMin && g <= this.xAxisMax) {
                                                    var f = (this.marginLeft + this.offsetX + this.left) + ((g - this.xAxisMin) * this.xAxisUnit);
                                                    this.toRender({
                                                        p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness / 3, "butt"],
                                                        a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness / 3, "butt"),
                                                        i: ["Xm" + this.layoutCurrent + j],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                        if (this.scatterType == "manhattan") {
                                            var e = 0;
                                            for (var j = 0; j < this.chromosomeLengths.length; j++) {
                                                var g = this.chromosomeLengths[j] / 2;
                                                var f = (this.marginLeft + this.offsetX + this.left) + (((g + e) - this.xAxisMin) * this.xAxisUnit);
                                                var d = this.chromosomeLengths[j] * this.xAxisUnit;
                                                var m = (this.layoutValid ? this.layoutLabelBoxThickness : 0) + this.axisTickThickness + this.margin;
                                                if (this.xAxisShow) {
                                                    this.toRender({
                                                        p: ["drawLine", "line", f, o + this.axisTickThickness, f, o + this.axisTickThickness + this.margin, this.xAxisTickColor, 1, "butt"],
                                                        a: this.getLineArea("line", f, o + this.axisTickThickness, f, o + this.axisTickThickness + this.margin, this.xAxisTickColor, 1, "butt"),
                                                        i: ["X" + this.layoutCurrent + j],
                                                        t: "Axes"
                                                    })
                                                }
                                                if (this.xAxisS2Show) {
                                                    this.toRender({
                                                        p: ["drawLine", "line", f, p - m, f, p - this.layoutLabelBoxThickness, this.xAxisTickColor, 1, "butt"],
                                                        a: this.getLineArea("line", f, p - m, f, p - this.layoutLabelBoxThickness, this.xAxisTickColor, 1, "butt"),
                                                        i: ["X" + this.layoutCurrent + j],
                                                        t: "Axes"
                                                    })
                                                }
                                                if (this.colorBy && j % 2 && j != this.chromosomeLengths.length - 1) {
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", f, o - (this.y / 2), d, this.y, this.manhattanContrastColor, this.manhattanContrastColor],
                                                        t: "Axes"
                                                    })
                                                }
                                                e += this.chromosomeLengths[j]
                                            }
                                        } else {
                                            for (var j = 0; j < this.xAxisValuesRaw.length; j++) {
                                                var g = this.xAxisValuesRaw[j];
                                                if (g >= this.xAxisMin && g <= this.xAxisMax) {
                                                    var f = (this.marginLeft + this.offsetX + this.left) + ((g - this.xAxisMin) * this.xAxisUnit);
                                                    if (this.xAxisMajorTicks) {
                                                        if (this.xAxisShow && this.scatterType != "boxplot") {
                                                            this.toRender({
                                                                p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"],
                                                                a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"),
                                                                i: ["XM" + this.layoutCurrent + j],
                                                                t: "Axes"
                                                            });
                                                            this.toRender({
                                                                p: ["drawLine", "line", f, o + (this.axisTickThickness / 1), f, o + (this.axisTickThickness / 1) + this.margin, this.xAxisLeftRightTickColor, 1, "butt"],
                                                                a: this.getLineArea("line", f, o + (this.axisTickThickness / 1), f, o + (this.axisTickThickness / 1) + this.margin, this.xAxisLeftRightTickColor, 1, "butt"),
                                                                i: ["XMt" + this.layoutCurrent + j],
                                                                t: "Axes"
                                                            })
                                                        } else {
                                                            if (this.xAxisS2Show) {
                                                                if (this.scatterPlotMatrix && this.scatterPlotMatrixType.match(/first/)) {
                                                                    var m = this.layoutLabelBoxThickness;
                                                                    this.toRender({
                                                                        p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"],
                                                                        a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"),
                                                                        i: ["XM" + this.layoutCurrent + j],
                                                                        t: "Axes"
                                                                    });
                                                                    this.toRender({
                                                                        p: ["drawLine", "line", f, p - (m + this.margin), f, p - m, this.xAxisLeftRightTickColor, 1, "butt"],
                                                                        a: this.getLineArea("line", f, p - (m + this.margin), f, p - m, this.xAxisLeftRightTickColor, 1, "butt"),
                                                                        i: ["XMt" + this.layoutCurrent + j],
                                                                        t: "Axes"
                                                                    })
                                                                } else {
                                                                    if (this.segregateVariablesBy.length || this.segregateSamplesBy.length) {
                                                                        if (this.layoutType != "wrap" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 0) {
                                                                            var m = this.layoutLabelBoxThickness;
                                                                            this.toRender({
                                                                                p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"],
                                                                                a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"),
                                                                                i: ["XM" + this.layoutCurrent + j],
                                                                                t: "Axes"
                                                                            });
                                                                            this.toRender({
                                                                                p: ["drawLine", "line", f, p - (m + this.margin), f, p - m, this.xAxisLeftRightTickColor, 1, "butt"],
                                                                                a: this.getLineArea("line", f, p - (m + this.margin), f, p - m, this.xAxisLeftRightTickColor, 1, "butt"),
                                                                                i: ["XMt" + this.layoutCurrent + j],
                                                                                t: "Axes"
                                                                            })
                                                                        } else {
                                                                            if (this.layoutType == "wrap") {
                                                                                var m = this.layoutLabelBoxThickness * (this.segregateVariablesBy.length + this.segregateSamplesBy.length);
                                                                                this.toRender({
                                                                                    p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"],
                                                                                    a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"),
                                                                                    i: ["XM" + this.layoutCurrent + j],
                                                                                    t: "Axes"
                                                                                });
                                                                                this.toRender({
                                                                                    p: ["drawLine", "line", f, p - (m + this.margin), f, p - m, this.xAxisLeftRightTickColor, 1, "butt"],
                                                                                    a: this.getLineArea("line", f, p - (m + this.margin), f, p - m, this.xAxisLeftRightTickColor, 1, "butt"),
                                                                                    i: ["XMt" + this.layoutCurrent + j],
                                                                                    t: "Axes"
                                                                                })
                                                                            }
                                                                        }
                                                                    } else {
                                                                        this.toRender({
                                                                            p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"],
                                                                            a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"),
                                                                            i: ["XM" + this.layoutCurrent + j],
                                                                            t: "Axes"
                                                                        });
                                                                        if (this.scatterPlotMatrix && this.showScatterPlotMatrixLabels) {
                                                                            var m = p - this.layoutLabelBoxThickness;
                                                                            this.toRender({
                                                                                p: ["drawLine", "line", f, m - this.margin, f, m, this.xAxisLeftRightTickColor, 1, "butt"],
                                                                                a: this.getLineArea("line", f, m - this.margin, f, m, this.xAxisLeftRightTickColor, 1, "butt"),
                                                                                i: ["XMt" + this.layoutCurrent + j],
                                                                                t: "Axes"
                                                                            })
                                                                        } else {
                                                                            this.toRender({
                                                                                p: ["drawLine", "line", f, p - this.margin, f, p, this.xAxisLeftRightTickColor, 1, "butt"],
                                                                                a: this.getLineArea("line", f, p - this.margin, f, p, this.xAxisLeftRightTickColor, 1, "butt"),
                                                                                i: ["XMt" + this.layoutCurrent + j],
                                                                                t: "Axes"
                                                                            })
                                                                        }
                                                                    }
                                                                }
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawLine", h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"],
                                                                    a: this.getLineArea(h, f, p, f, o, this.xAxisTickColor, this.axisTickThickness, "butt"),
                                                                    i: ["XM" + this.layoutCurrent + j],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawLine", "line", f, o + (this.axisTickThickness / 1), f, o + (this.axisTickThickness / 1) + this.margin, this.xAxisTickColor, 1, "butt"],
                                                            a: this.getLineArea("line", f, o + (this.axisTickThickness / 1), f, o + (this.axisTickThickness / 1) + this.margin, this.xAxisTickColor, 1, "butt"),
                                                            i: ["X" + this.layoutCurrent + j],
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                        if (l) {
                                            var f = this.marginLeft + this.offsetX + this.left;
                                            var d = f + this.x;
                                            var p = p - 1;
                                            var o = o + (this.axisMinMaxTickThickness / 2);
                                            if (this.xAxisLeftMajorTick) {
                                                this.toRender({
                                                    p: ["drawLine", "line", f, p, f, o, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                    t: "Axes"
                                                })
                                            }
                                            if (this.xAxisRightMajorTick) {
                                                this.toRender({
                                                    p: ["drawLine", "line", d, p, d, o, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                    t: "Axes"
                                                })
                                            }
                                            if (this.yAxisTopMajorTick) {
                                                this.toRender({
                                                    p: ["drawLine", "line", f, p, d, p, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                    t: "Axes"
                                                })
                                            }
                                            if (this.yAxisBottomMajorTick) {
                                                this.toRender({
                                                    p: ["drawLine", "line", f, o, d, o, this.yAxisTopBottomTickColor, this.axisMinMaxTickThickness, "butt"],
                                                    t: "Axes"
                                                })
                                            }
                                        } else {
                                            if (this.scatterType == "manhattan") {
                                                var k = this;
                                                var b = function() {
                                                    var i = 1;
                                                    while (k.yAxisValuesRaw[k.yAxisValuesRaw.length - i] > k.yAxisMax) {
                                                        i++
                                                    }
                                                    return (k.yAxisValuesRaw[k.yAxisValuesRaw.length - i] - k.yAxisMin) * k.yAxisUnit
                                                };
                                                p = this.marginTop + this.offsetY + this.top + this.y - b();
                                                if (this.yAxisShow) {
                                                    var f = this.marginLeft + this.offsetX + this.left;
                                                    this.toRender({
                                                        p: ["drawLine", "line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"],
                                                        a: this.getLineArea("line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"),
                                                        i: ["XL" + this.layoutCurrent],
                                                        t: "Axes"
                                                    })
                                                }
                                                if (this.yAxisS2Show || (this.scatterType == "manhattan" && this.yAxis2Show)) {
                                                    var f = this.marginLeft + this.offsetX + this.left + this.x;
                                                    this.toRender({
                                                        p: ["drawLine", "line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"],
                                                        a: this.getLineArea("line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"),
                                                        i: ["XR" + this.layoutCurrent],
                                                        t: "Axes"
                                                    })
                                                }
                                            } else {
                                                if (this.xAxisLeftMajorTick) {
                                                    var f = this.marginLeft + this.offsetX + this.left;
                                                    this.toRender({
                                                        p: ["drawLine", "line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"],
                                                        a: this.getLineArea("line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"),
                                                        i: ["XL" + this.layoutCurrent],
                                                        t: "Axes"
                                                    })
                                                }
                                                if (this.xAxisRightMajorTick) {
                                                    var f = this.marginLeft + this.offsetX + this.left + this.x;
                                                    this.toRender({
                                                        p: ["drawLine", "line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"],
                                                        a: this.getLineArea("line", f, p - 0.5, f, o + (this.axisMinMaxTickThickness / 2), this.xAxisLeftRightTickColor, this.axisMinMaxTickThickness, "butt"),
                                                        i: ["XR" + this.layoutCurrent],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                    if (this.scatterType == "manhattan") {
                                        this.toRender({
                                            p: ["resetClipArea"],
                                            t: "Axes"
                                        })
                                    }
                                    this.toRender({
                                        p: ["enableGradientTransparencyShadow"],
                                        t: "Axes"
                                    })
                                };
                                this.render2DLayoutTicks = function() {
                                    if (this.scatterPlotMatrix) {
                                        switch (this.scatterPlotMatrixType) {
                                            case "all":
                                                if (this.layoutCurrentR == this.layoutCurrentC) {
                                                    return true
                                                }
                                                return this.layoutCurrentR == Number(this.layoutRows) - 1;
                                            case "correlation":
                                            case "correlationDensity":
                                            case "correlationHistogram":
                                                if (this.layoutCurrentR == this.layoutCurrentC) {
                                                    return true
                                                }
                                                return this.layoutCurrentR == Number(this.layoutRows) - 1 && this.layoutCurrentC > 0
                                        }
                                    }
                                    return false
                                };
                                this.set2DLayout = function() {
                                    if (this.graphType == "Fish") {
                                        var d = this.marginTop + this.offsetY + this.top - (this.margin + this.margin + (this.getFontPt(this.axisTickFont) / 2));
                                        var j = this.fishAxis.length ? this.fishAxis : this.fishTimepoints;
                                        for (var q = 0; q < j.length; q++) {
                                            if (j[q] >= this.fishTimepoints[0] && j[q] <= this.fishTimepoints[this.fishTimepoints.length - 1]) {
                                                var v = (this.marginLeft + this.offsetX + this.left) + ((j[q] - this.xAxisMin) * this.xAxisUnit);
                                                var n = this.fishAxisLabels.length && this.fishAxisLabels[q] != null ? this.fishAxisLabels[q] : j[q];
                                                this.toRender({
                                                    p: ["drawText", n, v, d, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    } else {
                                        var g = this.scatterType == "visium" && !this.visiumFlip ? CanvasXpress.cacheImages[this.backgroundImageMD5 || this.getFileName(this.backgroundImage)] : false;
                                        var v = this.marginLeft + this.offsetX + this.left + (this.margin + this.margin + (this.getFontPt(this.axisTitleFont) / 2)) - this.get2DYAxisWidth();
                                        var u = this.width - (this.margin + this.margin + (this.getFontPt(this.axisTitleFont) / 2));
                                        var d = this.marginTop + this.offsetY + this.top + (this.y / 2);
                                        if (this.yAxisTitle && this.yAxisShow && !this.scatterPlotMatrix) {
                                            this.toRender({
                                                p: ["drawText", this.yAxisTitle, v, d, this.axisTitleFont, this.axisTitleColor, "center", "middle", -Math.PI / 2],
                                                t: "Axes"
                                            })
                                        } else {
                                            if (this.yAxis2Title && this.yAxisS2Show && !this.scatterPlotMatrix && this.yAxis2Title) {
                                                this.toRender({
                                                    p: ["drawText", this.yAxis2Title, u, d, this.axisTitleFont, this.axisTitleColor, "center", "middle", -Math.PI / 2],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                        v = this.marginLeft + this.offsetX + this.left - (this.margin * 2);
                                        u = this.marginLeft + this.offsetX + this.left + this.x + this.margin + this.margin;
                                        if (this.yAxisTransform && this.yAxisTransform.match(/log/) && !this.yAxisTransformTicks) {
                                            this.yAxisDecs = parseInt(Math.abs(this.yAxisMin))
                                        }
                                        if (this.ridgeBy && this.isCreateHistogram) {
                                            if (!this.layoutValid) {
                                                var h = this.marginTop + this.offsetY + this.top + this.y + (this.yAxisMin * this.yAxisUnit);
                                                var w = this.ridgelineScale - 1;
                                                var p = Math.max(this.data.y.maxLevel, this.ridgelineScale);
                                                var k = this.y / (this.ridgelineScale > 1 ? p + w : p + 0.1);
                                                for (var q = 1; q <= this.data.y.maxLevel; q++) {
                                                    var d = h - (k * (this.data.y.maxLevel - q));
                                                    var x = this.isCreateHistogram.maxLevel == this.isCreateHistogram.level.length ? this.data.y.smps[q] : this.meta.data.z[this.ridgeBy].levels[q - 1];
                                                    this.toRender({
                                                        p: ["drawText", x, v, d, this.axisTickFont, this.axisTickColor, "right", "middle"],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        } else {
                                            if (!this.render2DLayoutTicks()) {
                                                for (var q = 0; q < this.yAxisValuesRaw.length; q++) {
                                                    var y = this.yAxisValuesRaw[q];
                                                    if (y >= this.yAxisMin && y <= this.yAxisMax) {
                                                        var l = this.yAxisTransform && !this.yAxisTransformTicks ? this.formatAxisValue(this.transformValue(this.yAxisTransform, y, true), "yAxis") : this.isGraphTime == "y" ? this.dateFormat(new Date(this.yAxisMin + y), this.timeFormat) : this.formatAxisValue(this.scatterType == "visium" && !this.visiumFlip ? g.height - y : y, "yAxis");
                                                        d = ((this.marginTop + this.offsetY + this.top + this.y) - ((y - this.yAxisMin) * this.yAxisUnit));
                                                        if (this.yAxisShow) {
                                                            if (this.layoutValid && this.scatterType == "manhattan" && this.layoutCurrent % this.layoutCols) {} else {
                                                                this.toRender({
                                                                    p: ["drawText", l, v, d, this.axisTickFont, this.axisTickColor, "right", "middle"],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                        if (this.yAxisS2Show || (this.scatterType == "manhattan" && this.yAxis2Show)) {
                                                            if (this.layoutValid && ((this.scatterPlotMatrix && this.showScatterPlotMatrixLabels && this.scatterPlotMatrixType != "first") || this.layoutType == "rows" || (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1))) {
                                                                var s = u + this.layoutLabelBoxThickness;
                                                                this.toRender({
                                                                    p: ["drawText", l, s, d, this.axisTickFont, this.axisTickColor, "left", "middle"],
                                                                    t: "Axes"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawText", l, u, d, this.axisTickFont, this.axisTickColor, "left", "middle"],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        v = this.marginLeft + this.offsetX + this.left + (this.x / 2);
                                        d = this.marginTop + this.offsetY + this.top + this.y + this.margin + this.margin + this.getFontPt(this.axisTickFont) + this.margin + this.margin + (this.getFontPt(this.axisTitleFont) / 2);
                                        if (this.xAxisTitle && this.xAxisShow && !this.scatterPlotMatrix) {
                                            this.toRender({
                                                p: ["drawText", this.xAxisTitle, v, d, this.axisTitleFont, this.axisTitleColor, "center", "middle"],
                                                t: "Axes"
                                            })
                                        }
                                        d = this.marginTop + this.offsetY + this.top + this.y + this.margin + this.margin + (this.getFontPt(this.axisTickFont) / 2);
                                        var b = this.marginTop + this.offsetY + this.top - (this.margin + (this.getFontPt(this.axisTickFont) / 2));
                                        if (this.layoutValid) {
                                            if (this.scatterPlotMatrix && this.scatterPlotMatrixType.match(/first/)) {
                                                b -= this.layoutLabelBoxThickness
                                            } else {
                                                if (this.scatterPlotMatrix && this.showScatterPlotMatrixLabels) {
                                                    b -= this.layoutLabelBoxThickness
                                                } else {
                                                    if (this.layoutType == "rows" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 0) {
                                                        b -= this.layoutLabelBoxThickness
                                                    } else {
                                                        if (this.layoutType == "cols" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 0) {
                                                            b -= this.layoutLabelBoxThickness
                                                        } else {
                                                            if (this.layoutType == "wrap") {
                                                                b -= this.layoutLabelBoxThickness * (this.segregateVariablesBy.length + this.segregateSamplesBy.length)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (this.xAxisTransform && this.xAxisTransform.match(/log/) && !this.xAxisTransformTicks) {
                                            this.xAxisDecs = parseInt(Math.abs(this.xAxisMin))
                                        }
                                        if (this.scatterType == "manhattan") {
                                            var f = 0;
                                            var c = 0;
                                            var u = (this.marginLeft + this.offsetX + this.left);
                                            var s = u + this.x;
                                            for (var q = 0; q < this.chromosomeLengths.length; q++) {
                                                var y = this.chromosomeLengths[q] / 2;
                                                var v = (this.marginLeft + this.offsetX + this.left) + (((y + f) - this.xAxisMin) * this.xAxisUnit);
                                                var l = q + 1;
                                                var r = this.measureText(l, this.axisTickFont);
                                                if (v - u > r && v < s) {
                                                    if (this.xAxisShow) {
                                                        this.toRender({
                                                            p: ["drawText", l, v, d, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                            t: "Axes"
                                                        })
                                                    }
                                                    if (this.xAxisS2Show) {
                                                        this.toRender({
                                                            p: ["drawText", l, v, b, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                            t: "Axes"
                                                        })
                                                    }
                                                    u = v
                                                }
                                                f += this.chromosomeLengths[q]
                                            }
                                        } else {
                                            for (var q = 0; q < this.xAxisValuesRaw.length; q++) {
                                                var y = this.xAxisValuesRaw[q];
                                                if (y >= this.xAxisMin && y <= this.xAxisMax && this.scatterType != "boxplot") {
                                                    var l;
                                                    if (this.isCreateHistogram) {
                                                        l = this.formatAxisValue(y + this.isCreateHistogram.min, "xAxis")
                                                    } else {
                                                        l = this.xAxisTransform && !this.xAxisTransformTicks ? this.formatAxisValue(this.transformValue(this.xAxisTransform, y, true), "xAxis") : this.isGraphTime == "x" ? this.dateFormat(new Date(this.xAxisMin + y), this.timeFormat) : this.formatAxisValue(y, "xAxis")
                                                    }
                                                    v = ((this.marginLeft + this.offsetX + this.left) + ((y - this.xAxisMin) * this.xAxisUnit));
                                                    if (this.xAxisShow) {
                                                        this.toRender({
                                                            p: ["drawText", l, v, d, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                            t: "Axes"
                                                        })
                                                    }
                                                    if (this.xAxisS2Show) {
                                                        this.toRender({
                                                            p: ["drawText", l, v, b, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                        if (this.graphType == "ScatterBubble2D") {
                                            if (this.zAxisTitle && this.zAxisShow && !this.layoutValid) {
                                                v = this.marginLeft + this.offsetX + this.left + this.x + this.margin;
                                                d = this.marginTop + this.offsetY + this.top + (this.y / 2);
                                                this.toRender({
                                                    p: ["drawText", this.zAxisTitle, v, d, this.axisTitleFont, this.axisTitleColor, "center", "bottom", Math.PI / 2],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    }
                                    if (this.plotBox) {
                                        this.toRender({
                                            p: ["disableGradientTransparencyShadow"],
                                            t: "Axes"
                                        });
                                        this.toRender({
                                            p: ["drawShape", "rectangle", this.marginLeft + this.offsetX + this.left + (this.x / 2), this.marginTop + this.offsetY + this.top + (this.y / 2), this.x, this.y, this.plotBoxColor, this.plotBoxColor, "open", false, this.outlineWidth],
                                            t: "Axes"
                                        });
                                        this.toRender({
                                            p: ["enableGradientTransparencyShadow"],
                                            t: "Axes"
                                        })
                                    }
                                };
                                this.isIn2DViewport = function(c, b, d) {
                                    return b > c[0] && b < c[0] + c[2] && d > c[1] && d < c[1] + c[3]
                                };
                                this.get2DVariables = function(d, f, h) {
                                    var c = h !== false ? d + ":" + f + ":" + h : d + ":" + f;
                                    var b = this.layoutValid && this.meta.data.d.l[this.layoutCurrent] ? this.meta.data.d.l[this.layoutCurrent] : this.meta.data.d.a[c];
                                    var j = [];
                                    if (!b) {
                                        j = this.varIndices
                                    } else {
                                        if (this.showScatterDensity) {
                                            j = b.vars
                                        } else {
                                            for (var e = 0; e < this.varIndices.length; e++) {
                                                var g = this.varIndices[e];
                                                if (!b.skip.hasOwnProperty(g.toString())) {
                                                    j.push(g)
                                                } else {
                                                    if (!b.skip.hasOwnProperty(b.skip[g.toString()])) {
                                                        continue
                                                    } else {
                                                        j.push(g)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return j
                                };
                                this.get2DColor = function(d, f, h) {
                                    var g = this;
                                    var j = 0.3;
                                    var i = false;
                                    if (this.isCreateHistogram) {
                                        var b;
                                        if (this.isCreateHistogram.factor) {
                                            var e = function() {
                                                if (g.isDOE && !g.layoutCurrent) {
                                                    return g.data.y.smps[f + 1]
                                                } else {
                                                    if (!g.segregateVariablesBy.length && !g.isCreateHistogram.factor) {
                                                        return g.data.y.smps[f + 1]
                                                    } else {
                                                        if (g.layoutValid && (!g.segregateVariablesBy.length || g.segregateVariablesBy[0] != g.isCreateHistogram.factor) && !g.scatterPlotMatrix) {
                                                            var c = g.data.y.smps[f + 1].split(":");
                                                            return c[1] || c[0]
                                                        } else {
                                                            if (g.layoutValid && g.segregateVariablesBy[0] == g.isCreateHistogram.factor && !g.scatterPlotMatrix) {
                                                                var c = g.data.y.smps[f + 1].split(":");
                                                                return c[0]
                                                            } else {
                                                                return g.data.y.smps[f + 1]
                                                            }
                                                        }
                                                    }
                                                }
                                            };
                                            b = e();
                                            if (this.cacheColors[this.colorScheme].hasOwnProperty(b)) {
                                                i = this.cacheColors[this.colorScheme][b]
                                            } else {
                                                if (d.hasOwnProperty("z") && (this.segregateVariablesBy.length || this.segregateSamplesBy.length) && d.z.hasOwnProperty(this.isCreateHistogram.factor) && d.z[this.isCreateHistogram.factor].order.hasOwnProperty(b)) {
                                                    d = d.z[this.isCreateHistogram.factor];
                                                    i = d.colors[d.order[b]];
                                                    if (this.histogramType == "staggered") {
                                                        i = this.addColorTransparency(i, j, true)
                                                    }
                                                } else {
                                                    if (d.hasOwnProperty("x") && d.x.hasOwnProperty(this.isCreateHistogram.factor) && d.x[this.isCreateHistogram.factor].order.hasOwnProperty(b)) {
                                                        d = d.x[this.isCreateHistogram.factor];
                                                        i = d.colors[d.order[b]];
                                                        if (this.histogramType == "staggered") {
                                                            i = this.addColorTransparency(i, j, true)
                                                        }
                                                    } else {
                                                        i = this.varIndices.length == 1 || this.histogramType != "staggered" || this.scatterPlotMatrix ? this.colors[f % this.colors.length] : this.addColorTransparency(this.colors[f % this.colors.length], j, true)
                                                    }
                                                }
                                            }
                                        } else {
                                            b = this.data.y.smps[f + 1];
                                            if (this.cacheColors[this.colorScheme].hasOwnProperty(b)) {
                                                i = this.cacheColors[this.colorScheme][b]
                                            } else {
                                                i = this.varIndices.length == 1 || this.histogramType != "staggered" || this.scatterPlotMatrix ? this.colors[f % this.colors.length] : this.addColorTransparency(this.colors[f % this.colors.length], j, true)
                                            }
                                        }
                                        this.cacheColors[this.colorScheme][b] = i;
                                        this.isCreateHistogram.colors.push(i)
                                    } else {
                                        if (this.scatterType == "manhattan") {
                                            i = this.colorBy ? this.getPropertyValue(f, null, "colorBy") : this.manhattanColors[this.data.y.data[f][this.manhattanMarkerChromosomeNumberIndex] % this.manhattanColors.length]
                                        } else {
                                            if (this.showScatterDensity) {
                                                var k = d.density.hasOwnProperty(f.toString()) ? d.density[f.toString()] : 1;
                                                i = this.getColorForValue(d.colorBrew, k)
                                            } else {
                                                i = this.colorBy ? this.getPropertyValue(f, null, "colorBy") : this.colors[h % this.colors.length]
                                            }
                                        }
                                    }
                                    return i
                                };
                                this.draw2DBoxplotData = function() {
                                    if (this.scatterType == "boxplot") {
                                        var h = [];
                                        var s = this.data.z && this.data.z.hasOwnProperty(this.scatterPlotMatrix) ? this.scatterPlotMatrix : false;
                                        var r = this.data.y.smps[1];
                                        if (s) {
                                            var e = this.getLevelsByAnnotation(s, this.varIndices, "z");
                                            for (var k = 0; k < e.length; k++) {
                                                var u = this.getVariablesSamplesByAnnotationLevel(s, e[k], this.varIndices, "z");
                                                var m = [];
                                                for (var g = 0; g < u.length; g++) {
                                                    m.push(this.getDataAtPos(u[g], 1))
                                                }
                                                var p = this.boxplot(m);
                                                var d = "<b>" + r + " - " + e[k] + "</b><br>";
                                                d += "<table>";
                                                d += "<tr><th>1st IQR </th><td> : </td><td>" + this.formatNumber(p[4]) + "</td></tr>";
                                                d += "<tr><th>1st Qtl </th><td> : </td><td>" + this.formatNumber(p[1]) + "</td></tr>";
                                                d += "<tr><th>Median </th><td> : </td><td>" + this.formatNumber(p[2]) + "</td></tr>";
                                                d += "<tr><th>3rd Qtl </th><td> : </td><td>" + this.formatNumber(p[5]) + "</td></tr>";
                                                d += "<tr><th>3rd IQR </th><td> : </td><td>" + this.formatNumber(p[3]) + "</td></tr>";
                                                d += "<tr><th>Outliers </th><td> : </td><td>" + p[6].length + "</td></tr>";
                                                d += "<tr><th>N-Data</th><td> : </td><td>" + p[7] + "</td></tr>";
                                                d += "</table>";
                                                h.push({
                                                    data: m,
                                                    boxplot: [p[4], p[5], p[1], p[3], p[2], p[6], p[0], p[8]],
                                                    tooltip: d
                                                })
                                            }
                                        } else {
                                            var m = this.getDataForSmpGrpAtIndex(1);
                                            var p = this.boxplot(m);
                                            var d = "<b>" + r + "</b><br>";
                                            d += "<table>";
                                            d += "<tr><th>1st IQR </th><td> : </td><td>" + this.formatNumber(p[4]) + "</td></tr>";
                                            d += "<tr><th>1st Qtl </th><td> : </td><td>" + this.formatNumber(p[1]) + "</td></tr>";
                                            d += "<tr><th>Median </th><td> : </td><td>" + this.formatNumber(p[2]) + "</td></tr>";
                                            d += "<tr><th>3rd Qtl </th><td> : </td><td>" + this.formatNumber(p[5]) + "</td></tr>";
                                            d += "<tr><th>3rd IQR </th><td> : </td><td>" + this.formatNumber(p[3]) + "</td></tr>";
                                            d += "<tr><th>Outliers </th><td> : </td><td>" + p[6].length + "</td></tr>";
                                            d += "<tr><th>N-Data</th><td> : </td><td>" + p[7] + "</td></tr>";
                                            d += "</table>";
                                            h.push({
                                                data: m,
                                                boxplot: [p[4], p[5], p[1], p[3], p[2], p[6], p[0], p[8]],
                                                tooltip: d
                                            })
                                        }
                                        var f = this.marginLeft + this.offsetX + this.left + (this.xAxisUnit * 0.4);
                                        var v = this.marginTop + this.offsetY + this.top + this.y;
                                        for (var k = 0; k < h.length; k++) {
                                            var o = this.colors[k % this.colors.length];
                                            var n = s ? "Property:" + s + ":" + e[k] + ":z" : "Property:" + r + ":NA:y";
                                            this.drawBoxPlot([h[k].boxplot], f, v, this.xAxisUnit * 0.5, this.xAxisUnit * 0.5, this.yAxisUnit, this.yAxisMin, this.graphOrientation, [o], [
                                                ["open"]
                                            ], [
                                                ["ScatterBoxplot:::" + h[k].tooltip, n]
                                            ]);
                                            f += this.xAxisUnit
                                        }
                                    }
                                };
                                this.draw2DDataPoints = function() {
                                    var u, b, s, at, am, ak;
                                    var ar, aj, G, an;
                                    var O, D, ac, v;
                                    var F, ao, o, V;
                                    var B = [];
                                    var p = [];
                                    var ae = this.marginLeft + this.offsetX + this.left;
                                    var X = this.marginTop + this.offsetY + this.top + this.y;
                                    var e = this.setClipBoundaries();
                                    this.toRender({
                                        p: ["setClipArea", e],
                                        t: "Data"
                                    });
                                    if (this.axesType == "KM" || this.axesType == "QQ" || this.axesType == "CDF") {} else {
                                        if (this.scatterType == "boxplot") {
                                            this.draw2DBoxplotData()
                                        } else {
                                            if (this.isHistogram) {
                                                this.set2DDensityData()
                                            } else {
                                                var J = this.axesType == "XYZ" ? 1 : Math.max(this.xAxisIndices.length, this.yAxisIndices.length);
                                                var E = {};
                                                for (var ai = 0; ai < J; ai++) {
                                                    var S = this.axesType == "Y" || this.axesType == "XYZ" ? this.xAxisIndices[this.xAxisCurrent] : this.xAxisIndices[ai];
                                                    var C = this.axesType == "X" || this.axesType == "XYZ" ? this.yAxisIndices[this.yAxisCurrent] : this.yAxisIndices[ai];
                                                    var d = (this.graphType == "ScatterBubble2D" && !this.sizeBy && this.zAxisIndices.length > 0 && !this.isContour) || this.axesType == "XYZ" ? this.zAxisIndices[this.zAxisCurrent] : false;
                                                    var aa = this.get2DVariables(S, C, d);
                                                    var A = this.isHistogram ? S : S + ":" + C;
                                                    var I = {};
                                                    var ad = this.meta.data.d.a[d !== false ? S + ":" + C + ":" + d : S + ":" + C];
                                                    var K = this.graphType == "ScatterBubble2D" ? ("Series:" + S + ":" + C + ":" + d) : ("Series:" + S + ":" + C);
                                                    var af = this.scatterType == "visium" ? CanvasXpress.cacheImages[this.backgroundImageMD5 || this.getFileName(this.backgroundImage)] : false;
                                                    for (var ah = 0; ah < aa.length; ah++) {
                                                        if ((this.xAxisTransform == "percentile" && ((this.axesType.match(/Y|Z/) && ah == 0) || (this.axesType == "X")))) {
                                                            ar = this.axesType == "XYZ" || this.xAxisTransform != "percentile" ? this.getAxisDataBySample(this.xAxisIndices) : this.getAxisDataBySample(S);
                                                            aj = this.range(ar);
                                                            an = aj[0];
                                                            G = aj[1]
                                                        }
                                                        if ((this.yAxisTransform == "percentile" && ((this.axesType.match(/X|Z/) && ah == 0) || (this.axesType == "Y")))) {
                                                            O = this.axesType == "XYZ" || this.yAxisTransform != "percentile" ? this.getAxisDataBySample(this.yAxisIndices) : this.getAxisDataBySample(C);
                                                            D = this.range(O);
                                                            v = D[0];
                                                            ac = D[1]
                                                        }
                                                        if (d !== false && ah == 0) {
                                                            F = this.axesType == "XYZ" ? this.getAxisDataBySample(this.zAxisIndices, "z") : this.getAxisDataBySample(d, "z");
                                                            ao = this.range(F);
                                                            V = ao[0];
                                                            o = ao[1]
                                                        }
                                                        var r = aa[ah];
                                                        var R = this.getDataAtPos(r, S, false, this.xAxisTransform, this.xAxisFloorValue != null ? this.xAxisFloorValue : an, this.xAxisCeilValue != null ? this.xAxisCeilValue : G);
                                                        var Q = this.getDataAtPos(r, C, false, this.yAxisTransform, this.yAxisFloorValue != null ? this.yAxisFloorValue : v, this.yAxisCeilValue != null ? this.yAxisCeilValue : ac, false, af && !this.visiumFlip ? af.height : false);
                                                        var P = d !== false ? this.getDataAtPos(r, d, false, this.zAxisTransform, this.zAxisFloorValue != null ? this.zAxisFloorValue : V, this.zAxisCeilValue != null ? this.zAxisCeilValue : o) : null;
                                                        var W = this.getDataAtPos(r, S, "stdev");
                                                        var H = this.getDataAtPos(r, C, "stdev");
                                                        var h = this.getFillColor(this.get2DColor(ad, r, ai), [r, S, C]);
                                                        var U = this.getOutlineColor(h, [r, S, C]);
                                                        var L = this.getPropertyValue(r, null, "shapeBy");
                                                        var g = this.scatterType == "visium" ? this.dataPointSize : this.sizeBy ? parseInt(this.getPropertyValue(r, null, "sizeBy")) : d !== false ? this.sizes[Math.round(this.percentile(V, o, P) / 10)] : this.scatterType == "manhattan" ? this.dataPointSize * this.dataPointSizeScaleFactor * 0.5 : this.dataPointSize * this.dataPointSizeScaleFactor;
                                                        var f = this.patternBy ? this.getPropertyValue(r, null, "patternBy") : this.getPropertyValue(ai, null, "patternBy");
                                                        var k = this.scatterType && this.scatterType.match(/image/i) ? this.images[ah] : false;
                                                        var N = k ? "image" : L;
                                                        var al = this.ellipseBy && this.data.z && this.data.z.hasOwnProperty(this.ellipseBy) ? this.data.z[this.ellipseBy][r] : this.ellipseBy && this.ellipseBy == "variable" ? "variable" : false;
                                                        var c = this.spiderBy && this.data.z && this.data.z.hasOwnProperty(this.spiderBy) ? this.data.z[this.spiderBy][r] : false;
                                                        var M = this.isHidden(r) || this.isHidden(false, false, K);
                                                        var ap = this.scatterType == "manhattan" ? [r, this.manhattanMarkerChromosomeNumberIndex, this.manhattanMarkerPositionIndex, this.manhattanMarkerLogPValueIndex] : [r, S, C, d];
                                                        if (this.varIndices.length > this.scatterOutlineThreshold) {
                                                            U = h
                                                        }
                                                        u = ae + ((R - this.xAxisMin) * this.xAxisUnit);
                                                        b = X - ((Q - this.yAxisMin) * this.yAxisUnit);
                                                        am = ae + ((0 - this.xAxisMin) * this.xAxisUnit);
                                                        ak = X - ((0 - this.yAxisMin) * this.yAxisUnit);
                                                        if (this.ellipseBy && al) {
                                                            if (!I.hasOwnProperty(al)) {
                                                                I[al] = [
                                                                    [],
                                                                    []
                                                                ]
                                                            }
                                                            I[al][0].push(R);
                                                            I[al][1].push(Q)
                                                        }
                                                        if (this.scatterType && this.scatterType == "bar" && this.axesType != "XYZ") {
                                                            var T = this.histogramBarWidth;
                                                            at = (this.marginTop + this.offsetY + this.top + this.y) - b;
                                                            if (Q > 0) {
                                                                this.toRender({
                                                                    p: ["drawShape", "rectangle", u, b + (at / 2), T * 2, at, h, U, f],
                                                                    a: this.getShapeArea("rectangle", u, b + (at / 2), T * 2, at, h, U, f),
                                                                    i: [r, S, C],
                                                                    t: "Data",
                                                                    h: M
                                                                });
                                                                this.drawSelectedLabel([r, S, C], u, b)
                                                            }
                                                        } else {
                                                            if (!this.scatterType || !this.scatterType.match(/functio|lineStep/)) {
                                                                if (!this.isIn2DViewport(e, u, b)) {
                                                                    continue
                                                                }
                                                                if (W && !isNaN(W)) {
                                                                    s = (W / 2) * this.xAxisUnit;
                                                                    this.toRender({
                                                                        p: ["drawLine", "error", u, b, u + s, b, h, this.margin],
                                                                        t: "Data",
                                                                        h: M
                                                                    });
                                                                    this.toRender({
                                                                        p: ["drawLine", "error", u, b, u - s, b, h, this.margin],
                                                                        t: "Data",
                                                                        h: M
                                                                    })
                                                                }
                                                                if (H && !isNaN(H)) {
                                                                    at = (H / 2) * this.yAxisUnit;
                                                                    this.toRender({
                                                                        p: ["drawLine", "error", u, b, u, b + at, h, -this.margin],
                                                                        t: "Data",
                                                                        h: M
                                                                    });
                                                                    this.toRender({
                                                                        p: ["drawLine", "error", u, b, u, b - at, h, -this.margin],
                                                                        t: "Data",
                                                                        h: M
                                                                    })
                                                                }
                                                                this.toRender({
                                                                    p: ["drawShape", N, u, b, g, g, h, U, f, false, false, false, false, false, k],
                                                                    a: this.getShapeArea(N, u, b, g, g, h, U, f, false, false, false, false, false, k),
                                                                    i: ap,
                                                                    b: [am, ak, 0, 0],
                                                                    t: "Data",
                                                                    h: M
                                                                });
                                                                if (c) {
                                                                    if (!E.hasOwnProperty(c)) {
                                                                        E[c] = {
                                                                            data: [],
                                                                            color: h
                                                                        }
                                                                    }
                                                                    E[c].data.push([u, b])
                                                                }
                                                                this.drawSelectedLabel([r, S, C], u, b);
                                                                if (this.xAxisRugShow) {
                                                                    if (this.xAxisRugPosition.match(/top|both/)) {
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", u, X - this.y, u, (X - this.y) + this.xAxisRugHeight, h],
                                                                            t: "Data",
                                                                            h: M
                                                                        })
                                                                    }
                                                                    if (this.xAxisRugPosition.match(/bottom|both/)) {
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", u, X - this.xAxisRugHeight, u, X, h],
                                                                            t: "Data",
                                                                            h: M
                                                                        })
                                                                    }
                                                                }
                                                                if (this.yAxisRugShow) {
                                                                    if (this.yAxisRugPosition.match(/left|both/)) {
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", ae, b, ae + this.yAxisRugHeight, b, h],
                                                                            t: "Data",
                                                                            h: M
                                                                        })
                                                                    }
                                                                    if (this.yAxisRugPosition.match(/right|both/)) {
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", ae + this.x - this.yAxisRugHeight, b, ae + this.x, b, h],
                                                                            t: "Data",
                                                                            h: M
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                            if (this.scatterType && this.scatterType.match(/line|functio/i) && ah < this.varIndices.length - 1) {
                                                                r = this.varIndices[ah + 1];
                                                                R = this.getDataAtPos(r, S, false, this.xAxisTransform, this.xAxisFloorValue != null ? this.xAxisFloorValue : an, this.xAxisCeilValue != null ? this.xAxisCeilValue : G);
                                                                Q = this.getDataAtPos(r, C, false, this.yAxisTransform, this.yAxisFloorValue != null ? this.yAxisFloorValue : v, this.yAxisCeilValue != null ? this.yAxisCeilValue : ac);
                                                                s = ae + ((R - this.xAxisMin) * this.xAxisUnit);
                                                                at = X - ((Q - this.yAxisMin) * this.yAxisUnit);
                                                                if (this.scatterType == "lineStep") {
                                                                    this.toRender({
                                                                        p: ["drawLine", "line", u, b, s, b, h],
                                                                        t: "Data",
                                                                        h: M
                                                                    });
                                                                    this.toRender({
                                                                        p: ["drawLine", "line", s, b, s, at, h],
                                                                        t: "Data",
                                                                        h: M
                                                                    })
                                                                } else {
                                                                    if (this.lineType == "spline") {
                                                                        B.push(u);
                                                                        p.push(b)
                                                                    } else {
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", u, b, s, at, h],
                                                                            t: "Data",
                                                                            h: M
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    this.draw2DLoess(ae, X, S, C);
                                                    if (this.scatterType && this.scatterType.match(/line|functio/i) && this.lineType == "spline") {
                                                        B.push(s);
                                                        p.push(at);
                                                        this.toRender({
                                                            p: ["drawLine", "spline", B, p, false, false, h],
                                                            t: "Data"
                                                        });
                                                        B = [];
                                                        p = []
                                                    }
                                                    if (this.ellipseBy) {
                                                        var n = this.ellipseBy && this.data.z && this.data.z.hasOwnProperty(this.ellipseBy) ? this.meta.data.z[this.ellipseBy] : false;
                                                        for (var al in I) {
                                                            var ag = this.errorEllipse(I[al][0], I[al][1]);
                                                            var h = n && n.colors ? n.colors[n.order[al]] : this.colors[ai % this.colors.length];
                                                            var Z = ae + ((ag.cx - this.xAxisMin) * this.xAxisUnit);
                                                            var Y = X - ((ag.cy - this.yAxisMin) * this.yAxisUnit);
                                                            var ab = 2 * ag.rx * this.xAxisUnit;
                                                            var aq = 2 * ag.ry * this.yAxisUnit;
                                                            this.toRender({
                                                                p: ["drawShape", "oval", Z, Y, ab, aq, false, h, "open", ag.rot],
                                                                t: "Data"
                                                            })
                                                        }
                                                    }
                                                    if (this.spiderBy && this.data.z && this.data.z.hasOwnProperty(this.spiderBy)) {
                                                        for (var c in E) {
                                                            for (var q = 1; q < E[c].data.length; q++) {
                                                                this.toRender({
                                                                    p: ["drawLine", "line", E[c].data[q - 1][0], E[c].data[q - 1][1], E[c].data[q][0], E[c].data[q][1], E[c].color, 2],
                                                                    b: [am, ak],
                                                                    t: "Data"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                                if (this.decorations && this.decorations.marker) {
                                                    this.drawMarkers()
                                                }
                                                if (this.motionBy) {
                                                    u = this.left + this.x;
                                                    b = this.top + this.y + (this.margin * 2);
                                                    this.toRender({
                                                        p: ["drawText", this.motionObject.current, u, b, this.motionCurrentFont, this.motionCurrentColor, "right", "bottom"],
                                                        t: "Data"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                    this.toRender({
                                        p: ["resetClipArea"],
                                        t: "Data"
                                    })
                                };
                                this.draw2DLoess = function(q, m, o, A) {
                                    if (this.showLoessFit) {
                                        if (this.isTransformedData && this.isTransformedData.match(/exp/)) {
                                            alert("Loess not shown for exp transformed data");
                                            this.showLoessFit = false;
                                            return
                                        }
                                        var k = this.getAxisDataBySample(o, "x");
                                        var i = this.getAxisDataBySample(A, "y");
                                        if (k.length > 5) {
                                            var r = this.loess([k, i], false, [o, A]);
                                            var h = null;
                                            if (r) {
                                                var C = (0 - this.xAxisMin) * this.xAxisUnit;
                                                var B = (0 - this.yAxisMin) * this.yAxisUnit;
                                                var g = [
                                                    [],
                                                    []
                                                ];
                                                k = r.x;
                                                i = r.y;
                                                var z = r.c;
                                                var w = q + ((k[0] - this.xAxisMin) * this.xAxisUnit);
                                                var e = m - ((i[0] - this.yAxisMin) * this.yAxisUnit);
                                                var p = z[0] * this.yAxisUnit;
                                                g[0].push([w, w]);
                                                g[1].push([e + p, e - p]);
                                                for (var s = 1; s < k.length - 1; s++) {
                                                    var v = q + ((k[s] - this.xAxisMin) * this.xAxisUnit);
                                                    var d = m - ((i[s] - this.yAxisMin) * this.yAxisUnit);
                                                    var u = q + ((k[s + 1] - this.xAxisMin) * this.xAxisUnit);
                                                    var b = m - ((i[s + 1] - this.yAxisMin) * this.yAxisUnit);
                                                    p = z[s] * this.yAxisUnit;
                                                    g[0].push([v, v]);
                                                    g[1].push([d + p, d - p]);
                                                    if (v == u && d == b) {
                                                        continue
                                                    }
                                                    var n = this.toRender({
                                                        p: ["drawLine", this.fitLineStyle, w, e, v, d, this.fitLineColor, 2],
                                                        a: this.getLineArea(this.fitLineStyle, w, e, v, d, this.fitLineColor, 2),
                                                        i: ["loess-" + s],
                                                        g: h,
                                                        b: [C, B],
                                                        t: "Decorations"
                                                    });
                                                    if (h == null) {
                                                        h = n
                                                    }
                                                    w = v;
                                                    e = d
                                                }
                                                this.toRender({
                                                    p: ["drawLine", this.fitLineStyle, v, d, u, b, this.fitLineColor, 2],
                                                    a: this.getLineArea(this.fitLineStyle, v, d, u, b, this.fitLineColor, 2),
                                                    i: ["loess-" + s],
                                                    g: h,
                                                    b: [C, B],
                                                    t: "Decorations"
                                                });
                                                g[0].push([u, u]);
                                                g[1].push([b + p, b - p]);
                                                if (this.showConfidenceIntervals) {
                                                    var f = this.addColorTransparency(this.confidenceIntervalColor, 0.3, true);
                                                    this.toRender({
                                                        p: ["drawShape", "confidence", g[0], g[1], false, false, f, f, "closed"],
                                                        t: "Decorations"
                                                    })
                                                }
                                            }
                                        } else {
                                            alert("Loess not shown for data sets that have less than 5 x,y pair values.");
                                            this.showLoessFit = false;
                                            return
                                        }
                                    }
                                };
                                this.draw2DContour = function() {
                                    this.toRender({
                                        p: ["setClipArea", this.setClipBoundaries()],
                                        t: "Data"
                                    });
                                    var x, d, w, c;
                                    var s = this.marginLeft + this.offsetX + this.left;
                                    var k = this.marginTop + this.offsetY + this.top + this.y;
                                    if (this.isContour && this.data.y.contour) {
                                        var p = this.data.y.contour.data;
                                        var n = this.xAxisMin;
                                        var m = this.yAxisMin;
                                        var y = this.getColorBrew(this.colorSpectrum, 0, p[p.length - 1].value, this.colorSpectrumZeroValue, this.colorSpectrumBreaks, true);
                                        if (this.contourType == "color") {
                                            this.toRender({
                                                p: ["drawShape", "rectangle", s + (this.x / 2), k - (this.y / 2), this.x, this.y, this.getColorForValue(y, 0)],
                                                t: "Data"
                                            });
                                            for (var v = 0; v < p.length; v++) {
                                                var f = this.addColorTransparency(this.getColorForValue(y, p[v].value), 0.33, true);
                                                for (var j = 0; j < p[v].coordinates.length; j++) {
                                                    for (var r = 0; r < p[v].coordinates[j].length; r++) {
                                                        var h = [];
                                                        var u = [];
                                                        for (var e = 0; e < p[v].coordinates[j][r].length; e++) {
                                                            h.push(s + ((p[v].coordinates[j][r][e][0] - n) * this.xAxisUnit));
                                                            u.push(k - ((p[v].coordinates[j][r][e][1] - m) * this.yAxisUnit));
                                                            w = s + ((p[v].coordinates[j][r][e][0] - n) * this.xAxisUnit);
                                                            c = k - ((p[v].coordinates[j][r][e][1] - m) * this.yAxisUnit);
                                                            x = w;
                                                            d = c
                                                        }
                                                        this.toRender({
                                                            p: ["drawShape", this.lineType == "spline" ? "spline" : "path", h, u, false, false, f, this.foreground, "close", false, false, true],
                                                            t: "Data"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                        for (var v = 0; v < p.length; v++) {
                                            for (var j = 0; j < p[v].coordinates.length; j++) {
                                                for (var r = 0; r < p[v].coordinates[j].length; r++) {
                                                    x = s + ((p[v].coordinates[j][r][0][0] - n) * this.xAxisUnit);
                                                    d = k + ((p[v].coordinates[j][r][0][1] - m) * this.yAxisUnit);
                                                    var h = [];
                                                    var u = [];
                                                    for (var e = 1; e < p[v].coordinates[j][r].length; e++) {
                                                        h.push(s + ((p[v].coordinates[j][r][e][0] - n) * this.xAxisUnit));
                                                        u.push(k - ((p[v].coordinates[j][r][e][1] - m) * this.yAxisUnit));
                                                        w = s + ((p[v].coordinates[j][r][e][0] - n) * this.xAxisUnit);
                                                        c = k - ((p[v].coordinates[j][r][e][1] - m) * this.yAxisUnit);
                                                        if (this.lineType != "spline") {}
                                                        x = w;
                                                        d = c
                                                    }
                                                    if (this.lineType == "spline") {}
                                                    if (this.showContourLevel) {
                                                        var g = [0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9];
                                                        var q = false;
                                                        var o = 0;
                                                        while (!q && o < 18) {
                                                            var b = parseInt(h.length * g[Math.round(this.randomBetween(0, 9))]);
                                                            if (h[b] > s && h[b] < s + this.x && u[b] > k - this.y && u[b] < k) {
                                                                this.toRender({
                                                                    p: ["drawText", p[v].value, h[b], u[b], this.legendFont],
                                                                    t: "Data"
                                                                });
                                                                q = true
                                                            }
                                                            o++
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    this.toRender({
                                        p: ["resetClipArea"],
                                        t: "Data"
                                    })
                                };
                                this.drawFishData = function() {
                                    var c = this.setClipBoundaries();
                                    this.toRender({
                                        p: ["setClipArea", c],
                                        t: "Data"
                                    });
                                    var n = this.createFish();
                                    var e = this.marginLeft + this.offsetX + this.left;
                                    var u = this.marginTop + this.offsetY + this.top + this.y;
                                    var s = (this.fishTimepoints[this.fishTimepoints.length - 1] - this.fishTimepoints[0]) / 5;
                                    for (var g = 0; g < this.data.y.vars.length; g++) {
                                        var h = this.fishShape == "polygon" ? "violin" : "fish";
                                        var p = u - ((((n.ytop[g][0] + n.ybtm[g][0]) / 2) - this.yAxisMin) * this.yAxisUnit);
                                        var b = e + (((n.xpos[g][0] - (g == 0 ? s : n.nestLevel[g] <= 1 ? s * 0.3 : s * 0.1)) - this.xAxisMin) * this.xAxisUnit);
                                        var k = e + ((((n.xpos[g][0] - (g == 0 ? s : n.nestLevel[g] <= 1 ? s * 0.3 : s * 0.1)) / 2) - this.xAxisMin) * this.xAxisUnit);
                                        var d = [b];
                                        var r = [p];
                                        var m = [p];
                                        if (this.fishShape == "polygon") {
                                            d.push(k);
                                            r.push(u - ((n.ytop[g][0] - this.yAxisMin) * this.yAxisUnit));
                                            m.push(u - ((n.ybtm[g][0] - this.yAxisMin) * this.yAxisUnit))
                                        }
                                        for (var f = 0; f < n.xpos[g].length; f++) {
                                            d.push(e + ((n.xpos[g][f] - this.xAxisMin) * this.xAxisUnit));
                                            r.push(u - ((n.ytop[g][f] - this.yAxisMin) * this.yAxisUnit));
                                            m.push(u - ((n.ybtm[g][f] - this.yAxisMin) * this.yAxisUnit))
                                        }
                                        var o = this.isHidden(g);
                                        var q = this.toRender({
                                            p: ["drawShape", h, [d, d],
                                                [r, m], false, false, this.colors[g], this.colors[g]
                                            ],
                                            a: this.getShapeArea(h, [d, d], [r, m], false, false, this.colors[g], this.colors[g]),
                                            i: ["fish-" + g],
                                            b: [b, p],
                                            t: "Data",
                                            h: o
                                        });
                                        if (this.fishCloneLabels.length) {
                                            if (this.fishCloneLabels[g] && this.fishCloneLabels[g] != "") {
                                                this.toRender({
                                                    p: ["drawText", this.fishCloneLabels[g], b, p, this.varLabelFont, this.varLabelFontColor, "left", "bottom", this.varLabelRotate],
                                                    a: this.getTextArea(this.fishCloneLabels[g], b, p, this.varLabelFont, this.varLabelFontColor, "left", "bottom", this.varLabelRotate),
                                                    i: ["fish-Label-" + g],
                                                    g: q,
                                                    t: "Labels",
                                                    h: o
                                                })
                                            }
                                        }
                                    }
                                    this.toRender({
                                        p: ["resetClipArea"],
                                        t: "Data"
                                    })
                                };
                                this.setHistogram = function(c) {
                                    var e = c + "AxisHistogram";
                                    var d = this.meta.data.d[c];
                                    var b = this.histogramStat == "count" ? this.max(d.cols) : d.density[0].globalMaxY;
                                    this[e] = d;
                                    this[e].min = d.global.breaks[0];
                                    this[e].size = d.global.size;
                                    this[e].len = d.density.length;
                                    this[e].axis = this[this.axisAlgorithm](0, b, 4, this.axisWilkinsonLoose);
                                    this[e].axisMin = this[e].axis[0];
                                    this[e].axisMax = this[e].axis[this[e].axis.length - 1];
                                    this[e].cntx = []
                                };
                                this.set2DDensityData = function() {
                                    this.setCacheColors();
                                    this.isCreateHistogram.colors = [];
                                    var f = {
                                        n: [],
                                        m: []
                                    };
                                    var j = this.data.y.global && this.data.y.global.count ? [] : false;
                                    if (j) {
                                        for (var b = 0; b < this.data.y.global.count.length; b++) {
                                            j[b] = 0
                                        }
                                    }
                                    if (this.layoutValid && this.data.l && this.data.l.axes) {
                                        if (this.data.l.axes[this.layoutCurrent]) {
                                            var e = this.getSampleIndices(this.data.l.axes[this.layoutCurrent].yAxis);
                                            for (var b = 0; b < e.length; b++) {
                                                f.n.push([this.isCreateHistogram.smpIndices[e[b] - 1]]);
                                                f.m.push([this.isCreateHistogram.n[e[b] - 1]])
                                            }
                                        } else {
                                            return
                                        }
                                    } else {
                                        for (var b = 0; b < this.isCreateHistogram.smpIndices.length; b++) {
                                            f.n.push([this.isCreateHistogram.smpIndices[b]]);
                                            f.m.push([this.isCreateHistogram.n[b]])
                                        }
                                    }
                                    var g = this.isCreateHistogram.smpIndices.length;
                                    for (var b = 0; b < f.n.length; b++) {
                                        for (var d = 0; d < f.n[b].length; d++) {
                                            this.draw2DDensityData(f.n[b][d], this.isCreateHistogram.level[g - 1], j, f.n.length, b, this.isCreateHistogram.subLevel[g - 1]);
                                            g--
                                        }
                                    }
                                };
                                this.draw2DDensityData = function(al, W, C, G, am, E) {
                                    this.histogramBarWidth = (this.isCreateHistogram.size * this.xAxisUnit) - 3;
                                    var Q = this;
                                    var L = function(f) {
                                        if (Q.scatterPlotMatrix) {
                                            var c = [];
                                            if (f.y.density.length == 3) {
                                                for (var b = 0; b < f.y.density.length; b++) {
                                                    c.push(Q.meta.data.d.z[f.y.density[al][0]][f.y.density[al][1]][f.y.density[al][2]])
                                                }
                                            } else {
                                                c = [Q.meta.data.d.s[f.y.density[al]]]
                                            }
                                            return c
                                        } else {
                                            return f.y.density
                                        }
                                    };
                                    var ad = this.marginLeft + this.offsetX + this.left;
                                    var Y = this.marginTop + this.offsetY + this.top + this.y + (this.yAxisMin * this.yAxisUnit);
                                    var ak = this.data;
                                    var R = ak.y.density ? L(ak) : false;
                                    var Z = this.get2DColor(this.meta.data, this.ridgeBy && !this.colorBy ? E : al);
                                    var aa = this.darkenLightenColor(Z, 50);
                                    var an = ak.y.cols[al];
                                    var U = this.histogramType.match(/staggered|stacked/) ? Math.floor(this.histogramBarWidth) : Math.floor(this.histogramBarWidth / (this.ridgeBy && this.isCreateHistogram ? 1 : G));
                                    var ao = this.isCreateHistogram.min;
                                    var X = this.isCreateHistogram.rmin;
                                    if (R && R[al] && (this.showHistogramDensity || this.showHistogramMedian || !this.hideHistogram || this.xAxisRugShow || this.showHistogramDataPoints || this.showHistogramQuantiles)) {
                                        var n = this.yAxisUnit;
                                        if (this.ridgeBy && this.isCreateHistogram) {
                                            var aj = this.ridgelineScale - 1;
                                            var p = Math.max(this.data.y.maxLevel, this.ridgelineScale);
                                            var P = this.y / (this.ridgelineScale > 1 ? p + aj : p + 0.1);
                                            n /= ((this.ridgelineScale > 1 ? p + aj + 0.16 : p + 0.16) / this.ridgelineScale);
                                            Y -= P * (this.layoutValid && !this.isDOE ? (this.data.l.axes.length - 1) - this.layoutCurrent : W)
                                        }
                                        if (this.showHistogramDensity || this.showHistogramDataPoints || this.showHistogramQuantiles) {
                                            var ai = this.histogramStat == "count" ? an / R[al].maxY : 1;
                                            var N = [];
                                            var F = [];
                                            var ae = R[al].xy;
                                            for (var ag = 0; ag < ae.length; ag++) {
                                                var T = ae[ag][0];
                                                var S = this.ridgeBy && this.isCreateHistogram ? Math.max(0, ae[ag][1] * ai) : ae[ag][1] * ai;
                                                N.push(ad + (((T - this.xAxisMin) - ao) * this.xAxisUnit));
                                                F.push(Y - (S * n))
                                            }
                                            var s = this.scatterPlotMatrix && this.scatterPlotMatrix !== true && this.scatterPlotMatrix.match(/\w/) ? ["Density:" + R[al].name + ":" + (al + 1), "Property:" + this.scatterPlotMatrix + ":" + this.data.y.smps[al + 1] + ":z"] : ["Density:" + R[al].name + ":" + (al + 1)];
                                            var h = this.ridgeBy ? this.isHidden(false, false, "Series:0:" + E) : this.scatterPlotMatrix && this.scatterPlotMatrix !== true && this.scatterPlotMatrix.match(/\w/) ? this.isHidden(false, false, s[1]) : this.isHidden(s[0]);
                                            if (this.showFilledHistogramDensity) {
                                                if (this.ridgeBy && this.isCreateHistogram && this.colorBy == "data") {
                                                    var ac = this.mean(N);
                                                    var ah = this.getLinearGradient(ad - ac, 0, ad + this.x - ac, 0);
                                                    this.toRender({
                                                        p: ["drawShape", "spline", N, F, false, false, ah],
                                                        a: this.getShapeArea("spline", N, F, false, false, ah),
                                                        i: s,
                                                        t: "Data",
                                                        h: h
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawShape", "spline", N, F, false, false, this.addColorTransparency(aa, this.histogramDensityFillTransparency, true), aa],
                                                        a: this.getShapeArea("spline", N, F, false, false, this.addColorTransparency(aa, this.histogramDensityFillTransparency, true), aa),
                                                        i: s,
                                                        t: "Data",
                                                        h: (h || this.isHidden(false, al + 1))
                                                    })
                                                }
                                            } else {
                                                if (this.showHistogramDensity) {
                                                    this.toRender({
                                                        p: ["drawLine", "spline", N, F, false, false, aa, 2, false, false, false, true],
                                                        a: this.getLineArea("spline", N, F, false, false, aa, 2, false, false, false, true),
                                                        i: s,
                                                        t: "Data",
                                                        h: (h || this.isHidden(false, al + 1))
                                                    })
                                                }
                                            }
                                            if (this.showHistogramDataPoints) {
                                                var V = this.data.y.values;
                                                var M = Y;
                                                for (var af = 0; af < V.length; af++) {
                                                    for (var D = 0; D < V[af][al].length; D++) {
                                                        var T = V[af][al][D] - this.xAxisMin;
                                                        var H = ad + ((T - ao) * this.xAxisUnit);
                                                        for (var K = 0; K < N.length; K++) {
                                                            var e = F[K];
                                                            if (N[K] > H) {
                                                                e = this.randomBetween(M, e);
                                                                var ab = this.ridgeBy && this.isCreateHistogram && this.colorBy == "data";
                                                                this.toRender({
                                                                    p: ["drawShape", "sphere", H, e, U / 4, U / 4, ab ? false : aa, this.foreground, ab ? "open" : "closed"],
                                                                    t: "Decorations"
                                                                });
                                                                break
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            if (this.showHistogramQuantiles) {
                                                var V = this.data.y.values;
                                                var o = [];
                                                for (var af = 0; af < V.length; af++) {
                                                    for (var D = 0; D < V[af][al].length; D++) {
                                                        o.push(V[af][al][D])
                                                    }
                                                }
                                                var M = Y;
                                                var B = ad + (((R[al].quantilesX[1] - this.xAxisMin) - ao) * this.xAxisUnit);
                                                var A = ad + (((R[al].quantilesX[2] - this.xAxisMin) - ao) * this.xAxisUnit);
                                                var v = ad + (((R[al].quantilesX[3] - this.xAxisMin) - ao) * this.xAxisUnit);
                                                for (var K = 0; K < N.length; K++) {
                                                    var e = F[K];
                                                    if (N[K] > B) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", B, M, B, e, this.foreground],
                                                            t: "Decorations"
                                                        });
                                                        break
                                                    }
                                                }
                                                for (var K = 0; K < N.length; K++) {
                                                    var e = F[K];
                                                    if (N[K] > A) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", A, M, A, e, this.foreground],
                                                            t: "Decorations"
                                                        });
                                                        break
                                                    }
                                                }
                                                for (var K = 0; K < N.length; K++) {
                                                    var e = F[K];
                                                    if (N[K] > v) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", v, M, v, e, this.foreground],
                                                            t: "Decorations"
                                                        });
                                                        break
                                                    }
                                                }
                                            }
                                        }
                                        if (!this.hideHistogram) {
                                            var ai = this.histogramStat == "density" ? R[al].maxY / an : 1;
                                            for (var af = 0; af < this.varIndices.length; af++) {
                                                var D = this.varIndices[af];
                                                var T = (this.getDataAtPos(D, 0) - this.xAxisMin) + (X - ao);
                                                var S = this.getDataAtPos(D, al + 1) * ai;
                                                var H = Math.floor(ad + (T * this.xAxisUnit) + (this.histogramType.match(/staggered|stacked/) ? 0 : this.ridgeBy && this.isCreateHistogram ? U - this.histogramBarWidth : (U * am)) - this.histogramBarWidth);
                                                var I = this.histogramType == "stacked" && C ? C[D] : 0;
                                                var e = Y - ((S * n) + I);
                                                var ar = Y - (e + I);
                                                var J = this.getFillColor(Z, [D, al + 1, 0]);
                                                var O = this.getOutlineColor(Z, [D, al + 1, 0]);
                                                var s = this.scatterPlotMatrix && this.scatterPlotMatrix !== true && this.scatterPlotMatrix.match(/\w/) ? [D, al + 1, 0, "Property:" + this.scatterPlotMatrix + ":" + this.data.y.smps[al + 1] + ":z"] : [D, al + 1, 0];
                                                var h = this.scatterPlotMatrix && this.scatterPlotMatrix !== true && this.scatterPlotMatrix.match(/\w/) ? this.isHidden(false, false, s[3]) : this.isHidden(false, s[1]);
                                                if (S > 0 && ar > 0.5) {
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", H + (U / 2), e + (ar / 2), U, ar, J, O],
                                                        a: this.getShapeArea("rectangle", H + (U / 2), e + (ar / 2), U, ar, J, O),
                                                        i: s,
                                                        b: [H + (U / 2), Y, U, 0],
                                                        t: "Data",
                                                        h: h
                                                    });
                                                    this.drawSelectedLabel([D, al + 1], H, e)
                                                }
                                                if (C) {
                                                    C[D] += (S * n)
                                                }
                                            }
                                        }
                                        if (this.showHistogramMedian) {
                                            var ai = this.histogramStat == "count" ? an / R[al].maxY : 1;
                                            var T = ad + (((R[al].median[0] - this.xAxisMin) - ao) * this.xAxisUnit);
                                            var S = R[al].maxY * ai;
                                            var ar = Y;
                                            var aq = Y - ((S - this.yAxisMin) * n);
                                            var ap = Y - this.y;
                                            this.toRender({
                                                p: ["drawLine", this.histogramMedianLineStyle, T, ar, T, ap, aa, 2, false],
                                                a: this.getLineArea(this.histogramMedianLineStyle, T, ar, T, ap, aa, 2, false),
                                                i: ["DensityMedian:" + R[al].name + ":" + (al + 1)],
                                                t: "Decorations",
                                                h: this.isHidden(false, al + 1)
                                            });
                                            this.toRender({
                                                p: ["drawText", this.formatNumber(R[al].median[0], this.xAxisDecs), T, aq, false, this.foreground],
                                                a: this.getTextArea(this.formatNumber(R[al].median[0], this.xAxisDecs), T, aq, false, this.foreground),
                                                i: ["DensityMedianValue:" + R[al].name + ":" + (al + 1)],
                                                t: "Decorations",
                                                h: this.isHidden(false, al + 1)
                                            })
                                        }
                                        if (this.xAxisRugShow) {
                                            var ac = {};
                                            var V = this.data.y.values;
                                            var u = this.xAxisUnit / 10;
                                            for (var af = 0; af < V.length; af++) {
                                                for (var ae = 0; ae < V[af][al].length; ae++) {
                                                    var T = V[af][al][ae] - this.xAxisMin;
                                                    var N = T.toFixed(1).toString();
                                                    if (!ac.hasOwnProperty(N)) {
                                                        ac[N] = 0
                                                    }
                                                    ac[N]++;
                                                    var H = ad + ((T - this.isCreateHistogram.min) * this.xAxisUnit);
                                                    if (ac[N] > 1) {
                                                        H = this.randomBetween(H - u, H + u)
                                                    }
                                                    var e = Y - (this.yAxisMin * n);
                                                    if (this.xAxisRugPosition.match(/top|both/)) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", H, e - this.y, H, (e - this.y) + this.xAxisRugHeight, Z],
                                                            t: "Decorations",
                                                            h: this.isHidden(false, al + 1)
                                                        })
                                                    }
                                                    if (this.xAxisRugPosition.match(/bottom|both/)) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", H, e - this.xAxisRugHeight, H, e, Z],
                                                            t: "Decorations",
                                                            h: this.isHidden(false, al + 1)
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.set2DHistograms = function() {
                                    if (!this.layoutComb && (this.xAxisHistogramShow || this.yAxisHistogramShow) && !this.isCreateHistogram && !this.isValidQQ() && !this.isValidCDF()) {
                                        if (this.xAxisHistogramShow) {
                                            this.setHistogram("x")
                                        }
                                        if (this.yAxisHistogramShow) {
                                            this.setHistogram("y")
                                        }
                                        var b = this.axesType == "XYZ" ? 1 : Math.max(this.xAxisIndices.length, this.yAxisIndices.length);
                                        for (var e = 0; e < b; e++) {
                                            var c = this.axesType == "Y" || this.axesType == "XYZ" ? this.xAxisIndices[this.xAxisCurrent] : this.xAxisIndices[e];
                                            var d = this.axesType == "X" || this.axesType == "XYZ" ? this.yAxisIndices[this.yAxisCurrent] : this.yAxisIndices[e];
                                            if (this.xAxisHistogramShow) {
                                                this.xAxisHistogram.cntx.push([c, d])
                                            }
                                            if (this.yAxisHistogramShow) {
                                                this.yAxisHistogram.cntx.push([c, d])
                                            }
                                        }
                                    }
                                };
                                this.draw2DHistogramsWireFrame = function() {
                                    var c, m;
                                    var d = ["x", "y"];
                                    this.toRender({
                                        p: ["disableGradientTransparencyShadow"],
                                        t: "Axes"
                                    });
                                    for (var h = 0; h < d.length; h++) {
                                        if (this[d[h] + "AxisHistogramShow"]) {
                                            var e = d[h] == "x" ? this.marginLeft + this.offsetX + this.left : this.marginLeft + this.offsetX + this.left + this.x + (this.margin * 2);
                                            var n = d[h] == "x" ? (this.marginTop + this.offsetY + this.top) - (this.margin * 2) : this.marginTop + this.offsetY + this.top + this.y;
                                            var b = d[h] == "x" ? [e, n - this.xAxisHistogramHeight, this.x, this.xAxisHistogramHeight] : [e, n - this.y, this.yAxisHistogramHeight, this.y];
                                            if (this.backgroundType == "image" || this.backgroundType == "windowImage") {
                                                this.drawImage(CanvasXpress.cacheImages[this.getFileName(this.backgroundImage)], b[0], b[1], b[2], b[3])
                                            } else {
                                                if (this.backgroundType == "solid") {} else {
                                                    if (this.backgroundType == "window" || this.backgroundType == "windowSolidGradient") {
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", b[0] + (b[2] / 2), b[1] + (b[3] / 2), b[2], b[3], this.backgroundWindow, this.backgroundWindow],
                                                            t: "Axes"
                                                        })
                                                    } else {
                                                        var k = this.getLinearGradient(b[0], b[1], b[2], b[3]);
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", b[0] + (b[2] / 2), b[1] + (b[3] / 2), b[2], b[3], k, this.foreground],
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                            }
                                            if (d[h] == "x") {
                                                this.xAxisHistogram.axisUnit = this.xAxisHistogramHeight / (this.xAxisHistogram.axisMax - this.xAxisHistogram.axisMin);
                                                for (var f = 0; f < this.xAxisHistogram.axis.length; f++) {
                                                    m = n - (this.xAxisHistogram.axis[f] * this.xAxisHistogram.axisUnit);
                                                    this.toRender({
                                                        p: ["drawLine", "line", e, m, e + this.x + this.margin, m, this.xAxisTickColor, false, "butt"],
                                                        t: "Axes"
                                                    });
                                                    this.toRender({
                                                        p: ["drawText", this.xAxisHistogram.axis[f], e + this.x + this.margin + 1, m, this.axisTickFont, this.axisTickColor, "left", "middle"],
                                                        t: "Axes"
                                                    })
                                                }
                                                this.set2DWireFrameX(n - this.xAxisHistogramHeight, n, true)
                                            } else {
                                                this.yAxisHistogram.axisUnit = this.yAxisHistogramHeight / (this.yAxisHistogram.axisMax - this.yAxisHistogram.axisMin);
                                                for (var f = 0; f < this.yAxisHistogram.axis.length; f++) {
                                                    c = e + (this.yAxisHistogram.axis[f] * this.yAxisHistogram.axisUnit);
                                                    this.toRender({
                                                        p: ["drawLine", "line", c, n - this.y, c, n + this.margin, this.xAxisTickColor, false, "butt"],
                                                        t: "Axes"
                                                    });
                                                    this.toRender({
                                                        p: ["drawText", this.yAxisHistogram.axis[f], c, n + this.margin + 1, this.axisTickFont, this.axisTickColor, "left", "middle", Math.PI / 2],
                                                        t: "Axes"
                                                    })
                                                }
                                                this.set2DWireFrameY(e, e + this.xAxisHistogramHeight, true)
                                            }
                                            if (this.plotBox) {
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", b[0] + (b[2] / 2), b[1] + (b[3] / 2), b[2], b[3], false, this.plotBoxColor, "open"],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    }
                                    this.toRender({
                                        p: ["enableGradientTransparencyShadow"],
                                        t: "Axes"
                                    })
                                };
                                this.draw2DHistogramsData = function() {
                                    var W, r;
                                    var H = ["x", "y"];
                                    for (var Q = 0; Q < H.length; Q++) {
                                        if (this[H[Q] + "AxisHistogramShow"]) {
                                            var T = H[Q] == "x" ? this.xAxisHistogram : this.yAxisHistogram;
                                            var K = H[Q] == "x" ? this.marginLeft + this.offsetX + this.left : this.marginLeft + this.offsetX + this.left + this.x + (this.margin * 2);
                                            var F = H[Q] == "x" ? (this.marginTop + this.offsetY + this.top) - (this.margin * 2) : this.marginTop + this.offsetY + this.top + this.y;
                                            var Z = H[Q] == "x" ? Math.floor(T.size * this.xAxisUnit) : Math.floor(T.size * this.yAxisUnit);
                                            var C = this.histogramType.match(/staggered|stacked/) ? Math.floor(Z) : Math.floor(Z / T.len);
                                            var Y = H[Q] == "x" ? [K, F - this.xAxisHistogramHeight, this.x + 1, this.xAxisHistogramHeight + 1] : [K, F - this.y, this.yAxisHistogramHeight + 1, this.y + 1];
                                            var S = this[H[Q] + "AxisIndices"];
                                            this.toRender({
                                                p: ["setClipArea", Y],
                                                t: "Decorations"
                                            });
                                            if (this.showHistogramDensity) {
                                                for (var N = 0; N < S.length; N++) {
                                                    var X = T.density[N];
                                                    var V = this.histogramStat == "count" ? T.cols[N] / X.maxY : 1;
                                                    var I = this.addColorTransparency(this.colors[N % this.colors.length], 0.3, true);
                                                    var E = H[Q] == "x" ? this.xAxisHistogram.axisUnit : this.yAxisHistogram.axisUnit;
                                                    var z = [];
                                                    var M = [];
                                                    for (var L = 0; L < X.xy.length; L++) {
                                                        var B = X.xy[L][0];
                                                        var A = X.xy[L][1] * V;
                                                        if (H[Q] == "x") {
                                                            z.push(K + ((B - this.xAxisMin) * this.xAxisUnit));
                                                            M.push(F - (A * E))
                                                        } else {
                                                            z.push(K + (A * E));
                                                            M.push(F - ((B - this.yAxisMin) * this.yAxisUnit))
                                                        }
                                                    }
                                                    if (this.showFilledHistogramDensity) {
                                                        this.toRender({
                                                            p: ["drawShape", "spline", z, M, false, false, this.addColorTransparency(I, this.histogramDensityFillTransparency, true), I],
                                                            a: this.getShapeArea("spline", z, M, false, false, this.addColorTransparency(I, this.histogramDensityFillTransparency, true), I),
                                                            i: ["Density:" + H[Q].toUpperCase() + ":" + S[N]],
                                                            t: "Decorations"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawLine", "spline", z, M, false, false, I, 2, false, false, false, true],
                                                            a: this.getLineArea("spline", z, M, false, false, I, 2, false, false, false, true),
                                                            i: ["Density:" + H[Q].toUpperCase() + ":" + S[N]],
                                                            t: "Decorations"
                                                        })
                                                    }
                                                }
                                            }
                                            if (!this.hideHistogram) {
                                                for (var N = 0; N < T.vars.length; N++) {
                                                    if (this.histogramType == "staggered") {
                                                        var e = [];
                                                        var s = [];
                                                        for (var L = 0; L < T.len; L++) {
                                                            e.push(T.data[N][L + 1]);
                                                            s.push(L)
                                                        }
                                                        s.sort(function(d, c) {
                                                            return e[c] - e[d]
                                                        })
                                                    }
                                                    for (var L = 0; L < T.len; L++) {
                                                        var p = this.histogramType == "staggered" ? s[L] : L;
                                                        var G = H[Q] == "x" ? [H[Q] + "AxisHistogram-" + N + "-" + (p + 1) + "-" + L, "DensityHistogram:X:" + p] : [H[Q] + "AxisHistogram-" + N + "-" + (p + 1) + "-" + L, "DensityHistogram:Y:" + p];
                                                        var v = this.getFillColor(this.colors[p % this.colors.length], G);
                                                        var P = this.getOutlineColor(v, G);
                                                        var D = this.getPropertyValue(L, false, "patternBy");
                                                        var V = this.histogramStat == "density" ? T.density[p].maxY / T.cols[p] : 1;
                                                        var B = T.data[N][0];
                                                        var A = T.data[N][p + 1] * V;
                                                        var J = this[H[Q] + "AxisMin"] - T.min;
                                                        if (!A) {
                                                            continue
                                                        }
                                                        if (H[Q] == "x") {
                                                            W = this.histogramType == "staggered" ? Math.floor(K + ((B - J) * this.xAxisUnit) - Z) : Math.floor(K + ((B - J) * this.xAxisUnit) + (C * p) - Z);
                                                            r = A * this.xAxisHistogram.axisUnit;
                                                            this.toRender({
                                                                p: ["drawShape", "rectangle", W + ((C - 2.5) / 2), F - (r / 2), C - 2.5, r, v, P, D],
                                                                a: this.getShapeArea("rectangle", W + ((C - 2.5) / 2), F - (r / 2), C - 2.5, r, v, P, D),
                                                                i: G,
                                                                t: "Decorations"
                                                            })
                                                        } else {
                                                            W = A * this.yAxisHistogram.axisUnit;
                                                            r = this.histogramType == "staggered" ? Math.floor(F - ((B - J) * this.yAxisUnit)) : Math.floor(F - ((B - J) * this.yAxisUnit) + (C * p));
                                                            this.toRender({
                                                                p: ["drawShape", "rectangle", K + (W / 2), r + ((C - 2.5) / 2), W, C - 2.5, v, P, D],
                                                                a: this.getShapeArea("rectangle", K + (W / 2), r + ((C - 2.5) / 2), W, C - 2.5, v, P, D),
                                                                i: G,
                                                                t: "Decorations"
                                                            })
                                                        }
                                                    }
                                                }
                                            }
                                            if (this.showHistogramMedian) {
                                                for (var N = 0; N < S.length; N++) {
                                                    var X = T.density[N];
                                                    var V = this.histogramStat == "count" ? T.cols[N] / X.maxY : 1;
                                                    var I = this.addColorTransparency(this.colors[N % this.colors.length], 0.7, true);
                                                    var E = H[Q] == "x" ? this.xAxisHistogram.axisUnit : this.yAxisHistogram.axisUnit;
                                                    if (H[Q] == "x") {
                                                        var B = K + ((X.median[0] - this.xAxisMin) * this.xAxisUnit);
                                                        var n = F;
                                                        var m = F - (X.maxY * E * V);
                                                        var g = F - this.xAxisHistogramHeight;
                                                        this.toRender({
                                                            p: ["drawLine", this.histogramMedianLineStyle, B, n, B, g, I, 2, false],
                                                            a: this.getLineArea(this.histogramMedianLineStyle, B, n, B, g, I, 2, false),
                                                            i: ["DensityMedian:X:" + S[N]],
                                                            t: "Decorations"
                                                        });
                                                        this.toRender({
                                                            p: ["drawText", this.formatNumber(X.median[0], this[H[Q] + "AxisDecs"]), B, m],
                                                            a: this.getTextArea(this.formatNumber(X.median[0], this[H[Q] + "AxisDecs"]), B, m),
                                                            i: ["DensityMedianValue:X:" + S[N]],
                                                            t: "Decorations"
                                                        })
                                                    } else {
                                                        var A = F - ((X.median[0] - this.yAxisMin) * this.yAxisUnit);
                                                        var U = K;
                                                        var R = K + (X.maxY * E * V);
                                                        var O = K + this.yAxisHistogramHeight;
                                                        this.toRender({
                                                            p: ["drawLine", this.histogramMedianLineStyle, U, A, O, A, I, 2, false],
                                                            a: this.getLineArea(this.histogramMedianLineStyle, U, A, O, A, I, 2, false),
                                                            i: ["DensityMedian:Y:" + S[N]],
                                                            t: "Decorations"
                                                        });
                                                        this.toRender({
                                                            p: ["drawText", this.formatNumber(X.median[0], this[H[Q] + "AxisDecs"]), R, A],
                                                            a: this.getTextArea(this.formatNumber(X.median[0], this[H[Q] + "AxisDecs"]), R, A),
                                                            i: ["DensityMedianValue:Y:" + S[N]],
                                                            t: "Decorations"
                                                        })
                                                    }
                                                }
                                            }
                                            this.toRender({
                                                p: ["resetClipArea"],
                                                t: "Decorations"
                                            })
                                        }
                                    }
                                };
                                this.set2DprivateParams = function() {
                                    this.set2DFont()
                                };
                                this.resetRidgeBy = function() {
                                    if (this.ridgeBy) {
                                        this.hideHistogram = this.hideHistogramRidgeBy;
                                        this.showFilledHistogramDensity = this.showFilledHistogramDensityRidgeBy;
                                        this.showHistogramDensity = this.showHistogramDensityRidgeBy;
                                        if (!this.isCreateHistogramRidge) {
                                            this.removeHistogram(true)
                                        } else {
                                            if (!this.factorRidgeBy) {
                                                this.removeHistogram(true);
                                                this.createHistogram(false, true)
                                            }
                                        }
                                    } else {
                                        this.hideHistogramRidgeBy = this.hideHistogram;
                                        this.showFilledHistogramDensityRidgeBy = this.showFilledHistogramDensity;
                                        this.showHistogramDensityRidgeBy = this.showHistogramDensity;
                                        if (this.isCreateHistogram) {
                                            this.factorRidgeBy = this.isCreateHistogram.factor;
                                            this.isCreateHistogramRidge = true
                                        } else {
                                            this.isCreateHistogramRidge = false
                                        }
                                    }
                                };
                                this.isValidKaplanMeier = function() {
                                    if (this.decorations && this.decorations.kaplanMeier) {
                                        return true
                                    } else {
                                        return false
                                    }
                                };
                                this.isValidQQ = function() {
                                    if (this.decorations && this.decorations.qq) {
                                        return true
                                    } else {
                                        return false
                                    }
                                };
                                this.isValidCDF = function() {
                                    if (this.decorations && this.decorations.cdf) {
                                        return true
                                    } else {
                                        return false
                                    }
                                };
                                this.checkRidgeEllipse = function() {
                                    if (this.ridgeBy && this.meta.data.z && this.meta.data.z[this.ridgeBy].type == "Numeric") {
                                        this.ridgeBy = false;
                                        this.flashInfoSpan(100, 100, "Not allowed to ridge by a numeric value", 5000)
                                    }
                                    if (this.ellipseBy && this.meta.data.z && this.meta.data.z[this.ellipseBy].type == "Numeric") {
                                        this.ellipseBy = false;
                                        this.flashInfoSpan(100, 100, "Not allowed to ellipse by a numeric value", 5000)
                                    }
                                };
                                this.checkHistogram = function() {
                                    if (this.ridgeBy && !this.isCreateHistogram) {
                                        this.removeCorrelation(true);
                                        this.desegregateVariablesSamples(true);
                                        this.createHistogram(this.ridgeBy, true);
                                        this.initializeAxis()
                                    } else {
                                        if (this.ridgeBy && this.isCreateHistogram && this.isCreateHistogram.factor != this.ridgeBy) {
                                            var c = this.ridgeBy;
                                            this.removeHistogram(true, ["ridgeBy"]);
                                            this.ridgeBy = c;
                                            this.checkHistogram()
                                        } else {
                                            if (this.isCreateHistogram) {
                                                var h = this.isCreateHistogram.transformed != this.isTransformedData;
                                                var f = this.segregateVariablesBy.length && this.isCreateHistogram.factor != this.segregateVariablesBy[0];
                                                var j = this.isCreateHistogram.colorBy != this.colorBy;
                                                var d = this.isCreateHistogram.isAnnt;
                                                if (h || f || j) {
                                                    var g = f ? false : j ? this.colorBy : this.ridgeBy && this.isCreateHistogram ? this.ridgeBy : h ? this.isCreateHistogram.factor : d ? d : false;
                                                    var e = this.isTransformedData;
                                                    var b = this.colorBy;
                                                    var i = this.segregateVariablesBy;
                                                    var k = this.segregateSamplesBy;
                                                    var l = this.ridgeBy;
                                                    this.removeHistogram(true, ["colorBy"]);
                                                    this.isTransformedData = e;
                                                    this.colorBy = b;
                                                    this.segregateVariablesBy = i;
                                                    this.segregateSamplesBy = k;
                                                    this.ridgeBy = l;
                                                    this.createHistogram(g || l, true);
                                                    this.initializeAxis()
                                                }
                                            }
                                        }
                                    }
                                };
                                this.checkQQCDF = function() {
                                    if (this.scatterType == "qq") {
                                        this.setQQData()
                                    } else {
                                        if (this.scatterType == "cdf") {
                                            this.setCDFData()
                                        }
                                    }
                                };
                                this.checkScatterMatrix = function() {
                                    if (this.scatterPlotMatrix) {
                                        this.histogramStat = "count";
                                        var b = this.data.z && this.data.z.hasOwnProperty(this.scatterPlotMatrix) ? this.scatterPlotMatrix : false;
                                        if (this.scatterPlotMatrixType.match(/both|upper|lower/)) {
                                            this.showScatterPlotMatrixLabels = false
                                        } else {
                                            if (this.scatterPlotMatrixType.match(/correlation|all/)) {
                                                this.showScatterPlotMatrixLabels = this.scatterPlotMatrixType == "correlation" ? false : true;
                                                this.layoutAdjust = this.layoutAdjust || "global";
                                                if (!this.data.l.reg) {
                                                    this.createCorrelation(b)
                                                }
                                                if (this.scatterPlotMatrixType.match(/Histogram|Density|all/)) {
                                                    this.createHistogram(b)
                                                }
                                            }
                                        }
                                    }
                                };
                                this.checkVisium = function() {
                                    if (this.scatterType == "visium") {
                                        var c = this.xAxisRange;
                                        var b = this.yAxisRange;
                                        this.dataPointSize = Math.max(this.x, this.y) * 5 / Math.max(c, b) * this.dataPointSizeScaleFactor
                                    }
                                };
                                this.validate2DPropertyDefaults = function() {
                                    this.checkRidgeEllipse();
                                    this.checkHistogram();
                                    this.checkSegregation();
                                    this.checkScatterMatrix();
                                    this.checkQQCDF()
                                };
                                this.draw2DHistograms = function() {
                                    if (!this.layoutComb && !this.isCreateHistogram && !this.isValidQQ() && !this.isValidCDF()) {
                                        this.draw2DHistogramsWireFrame();
                                        this.draw2DHistogramsData()
                                    }
                                };
                                this.draw2DXYPlot = function() {
                                    this.draw2DContour();
                                    this.drawDecorationData();
                                    this.draw2DDataPoints();
                                    this.draw2DHistograms()
                                };
                                this.draw2DPlot = function() {
                                    if (this.xAxis && this.yAxis) {
                                        this.validatePropertyValues()
                                    }
                                    this.set2DprivateParams();
                                    this.set2DXYDimensions();
                                    if (this.xAxis && this.yAxis) {
                                        this.drawPlotWindow();
                                        if (this.graphType == "Fish") {
                                            this.drawFishData()
                                        }
                                        this.set2DWireFrame();
                                        this.set2DLayout();
                                        if (this.graphType != "Fish") {
                                            this.set2DHistograms();
                                            this.draw2DXYPlot()
                                        }
                                        this.drawLegend();
                                        this.drawTitle()
                                    }
                                };
                                this.initializeScatter2D = function() {
                                    this.validate2DPropertyDefaults();
                                    if (this.layoutValid && (this.scatterPlotMatrix || this.isDOE || this.segregateVariablesBy.length > 0 || this.segregateSamplesBy.length > 0)) {
                                        this.drawLayoutCompartments(this.draw2DPlot)
                                    } else {
                                        if (!this.scatterPlotMatrix) {
                                            this.unsetScatterPlotMatrix()
                                        }
                                        this.draw2DPlot()
                                    }
                                };
                                if (!a) {
                                    this.initializeScatter2D()
                                }
                            };
                            CanvasXpress.prototype.Scatter3D = function(a) {
                                this.set3DText = function() {
                                    this.setAxisFont(false, this.x)
                                };
                                this.set3DXYDimensions = function() {
                                    var e = this.width - (this.marginLeft + this.marginRight);
                                    var c = this.height - (this.marginTop + this.marginBottom);
                                    if (this.showLegend) {
                                        this.setLegends();
                                        if (!this.legendInside && this.legendLayout.length > 0) {
                                            if (this.legendPosition == "right") {
                                                e -= this.legendWidth
                                            }
                                            if (this.legendPosition == "bottom") {
                                                c -= this.legendHeight
                                            }
                                        }
                                    }
                                    var b = Math.min(e, c);
                                    var d = 0;
                                    if (e > c) {
                                        d = e - c;
                                        this.left = d / 2;
                                        this.right = d / 2;
                                        this.top = 0;
                                        this.bottom = 0;
                                        this.funcX = d / 2;
                                        this.funcY = 0
                                    } else {
                                        d = c - e;
                                        this.left = 0;
                                        this.right = 0;
                                        this.top = d / 2;
                                        this.bottom = d / 2;
                                        this.funcX = 0;
                                        this.funcY = d / 2
                                    }
                                    this.x = b;
                                    this.y = b
                                };
                                this.draw3DLayout = function(j, b, o, k, c, p, g, d) {
                                    var f, r, e, q, n;
                                    var h = this.marginLeft + this.left + this.offsetX;
                                    var s = this.marginTop + this.top + this.offsetY;
                                    this.toRender({
                                        p: ["disableGradientTransparencyShadow"],
                                        t: "Axes"
                                    });
                                    for (var m = 0; m < j.length; m++) {
                                        n = this.get3DTransfrom(j[m], b[m], o[m]);
                                        f = n[0] + h;
                                        r = n[1] + s;
                                        n = this.get3DTransfrom(k[m], c[m], p[m]);
                                        e = n[0] + h;
                                        q = n[1] + s;
                                        if (d == "dotted") {
                                            this.toRender({
                                                p: ["drawLine", "dottedLine", f, r, e, q, g[m], false, "butt"],
                                                t: "Axes"
                                            })
                                        } else {
                                            this.toRender({
                                                p: ["drawLine", "line", f, r, e, q, g[m], false, "butt"],
                                                t: "Axes"
                                            })
                                        }
                                    }
                                    this.toRender({
                                        p: ["enableGradientTransparencyShadow"],
                                        t: "Axes"
                                    })
                                };
                                this.draw3DBar = function(q, o, n, P, S) {
                                    var H = this.marginLeft + this.left + this.offsetX;
                                    var C = this.marginTop + this.top + this.offsetY;
                                    var k = H + (this.x / 2);
                                    var g = C + (this.y / 2);
                                    var T = 0.25 * this.dataPointSize * this.dataPointSizeScaleFactor * this.widthFactor / this.xAxisUnit;
                                    var R = 0.25 * this.dataPointSize * this.dataPointSizeScaleFactor * this.widthFactor / this.zAxisUnit;
                                    var L = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                    var M = [
                                        [
                                            [q - T, o, n - R],
                                            [q + T, o, n - R],
                                            [q + T, L, n - R],
                                            [q - T, L, n - R]
                                        ],
                                        [
                                            [q + T, o, n - R],
                                            [q + T, o, n + R],
                                            [q + T, L, n + R],
                                            [q + T, L, n - R]
                                        ],
                                        [
                                            [q - T, o, n + R],
                                            [q + T, o, n + R],
                                            [q + T, L, n + R],
                                            [q - T, L, n + R]
                                        ],
                                        [
                                            [q - T, o, n - R],
                                            [q - T, o, n + R],
                                            [q - T, L, n + R],
                                            [q - T, L, n - R]
                                        ],
                                        [
                                            [q - T, o, n - R],
                                            [q + T, o, n - R],
                                            [q + T, o, n + R],
                                            [q - T, o, n + R]
                                        ]
                                    ];
                                    var O = [];
                                    var Q = [];
                                    var N = [];
                                    var G = [];
                                    for (var K = 0; K < M.length; K++) {
                                        O[K] = [];
                                        for (var J = 0; J < M[K].length; J++) {
                                            var E = this.xAxisMin < 0 ? 0 : this.xAxisMin;
                                            var B = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                            var A = this.zAxisMin < 0 ? 0 : this.zAxisMin;
                                            var v = ((M[K][J][0] - E) * this.xAxisUnit) - this.xAxisOffset;
                                            var u = this.yAxisOffset - ((M[K][J][1] - B) * this.yAxisUnit);
                                            var p = ((M[K][J][2] - A) * this.zAxisUnit) - this.zAxisOffset;
                                            O[K].push(this.get3DTransfrom(v, u, p))
                                        }
                                        G.push(K);
                                        N.push(this.euclidianDistance([(O[K][0][0] + O[K][2][0]) / 2, (O[K][0][1] + O[K][2][1]) / 2, (O[K][0][2] + O[K][2][2]) / 2], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]))
                                    }
                                    G.sort(function(d, c) {
                                        return N[c] - N[d]
                                    });
                                    var F;
                                    for (var w = 1; w < O.length; w++) {
                                        var K = G[w];
                                        var D = w < 3 ? this.darkenLightenColor(P, -w * 15) : P;
                                        var m = [];
                                        var I = [];
                                        for (var J = 0; J < O[K].length; J++) {
                                            m.push(O[K][J][0] + H);
                                            I.push(O[K][J][1] + C)
                                        }
                                        F = this.toRender({
                                            p: ["drawShape", "polygon", m, I, false, false, D, this.getOutlineColor(D), "closed"],
                                            a: this.getShapeArea("polygon", m, I, false, false, D, this.getOutlineColor(D), "closed"),
                                            i: S,
                                            t: "Data",
                                            h: this.isHidden(S[0])
                                        })
                                    }
                                };
                                this.set3DXLayout = function() {
                                    var z = [],
                                        d = [],
                                        n = [],
                                        w = [],
                                        c = [],
                                        k = [],
                                        e = [];
                                    var v, m, p, b, A, r, j, h;
                                    var f = this.lenX / 15;
                                    var q = (15 * -f) + f;
                                    var g = this.xAxisTitle ? this.xAxisTitle : this.is3DPlot && this.xAxis.length == 0 ? "Samples" : this.xAxisIndex ? this.data.y.smps[this.xAxisIndex] : this.xAxis[0];
                                    var u = this.marginLeft + this.left + this.offsetX;
                                    var o = this.marginTop + this.top + this.offsetY;
                                    if (this.show3DGrid) {
                                        p = q;
                                        v = 0;
                                        m = 0;
                                        while (p < this.lenX) {
                                            if ((v + 1) % 3) {
                                                if (this.xAxisType == "continuous") {
                                                    z[m] = p;
                                                    d[m] = -this.lenY;
                                                    n[m] = this.lenZ;
                                                    w[m] = p;
                                                    c[m] = this.lenY;
                                                    k[m] = this.lenZ;
                                                    e.push(this.xAxisTickColor);
                                                    m++
                                                }
                                                z[m] = -this.lenX;
                                                d[m] = p * this.lenY / this.lenX;
                                                n[m] = this.lenZ;
                                                w[m] = this.lenX;
                                                c[m] = p * this.lenY / this.lenX;
                                                k[m] = this.lenZ;
                                                e.push(this.xAxisTickColor);
                                                m++
                                            }
                                            p += f;
                                            v++
                                        }
                                        this.draw3DLayout(z, d, n, w, c, k, e, this.xAxisTickStyle);
                                        z = [], d = [], n = [], w = [], c = [], k = [], e = [];
                                        p = q;
                                        v = 0;
                                        m = 0;
                                        A = this.xAxisIncr;
                                        while (p < this.lenX) {
                                            if (!((v + 1) % 3)) {
                                                if (this.xAxisType == "continuous") {
                                                    z[m] = p;
                                                    d[m] = -this.lenY;
                                                    n[m] = this.lenZ;
                                                    w[m] = p;
                                                    c[m] = this.lenY;
                                                    k[m] = this.lenZ;
                                                    e.push(this.foreground);
                                                    m++
                                                }
                                                z[m] = -this.lenX;
                                                d[m] = p * this.lenY / this.lenX;
                                                n[m] = this.lenZ;
                                                w[m] = this.lenX;
                                                c[m] = p * this.lenY / this.lenX;
                                                k[m] = this.lenZ;
                                                e.push(this.foreground);
                                                b = this.get3DTransfrom(p, this.lenY, -this.lenZ);
                                                j = b[0] + u;
                                                h = b[1] + o;
                                                r = this.xAxisTime ? this.dateFormat(new Date(this.xAxisMin + A), this.timeFormat) : this.formatAxisValue(this.xAxisMin + A, "xAxis");
                                                A += this.xAxisIncr;
                                                if (this.xAxisShow && this.xAxisType == "continuous") {
                                                    this.toRender({
                                                        p: ["drawText", r, j, h + 5, this.axisTickFont, this.axisTickColor, "right", false, -Math.PI / 2],
                                                        t: "Axes"
                                                    })
                                                }
                                                m++
                                            }
                                            p += f;
                                            v++
                                        }
                                        this.draw3DLayout(z, d, n, w, c, k, e, this.xAxisTickStyle)
                                    }
                                    if (this.xAxisShow && !this.is3DPlot) {
                                        this.draw3DAxisTitle(q - (f * 2), this.lenX + f, this.lenY + (f * 4), this.lenY + (f * 4), -this.lenZ - (f * 4), -this.lenZ - (f * 4), g, "x")
                                    }
                                    z = [-this.lenX, -this.lenX, this.lenX, -this.lenX];
                                    d = [-this.lenY, -this.lenY, -this.lenY, this.lenY];
                                    n = [this.lenZ, this.lenZ, this.lenZ, this.lenZ];
                                    w = [-this.lenX, this.lenX, this.lenX, this.lenX];
                                    c = [this.lenY, -this.lenY, this.lenY, this.lenY];
                                    k = [this.lenZ, this.lenZ, this.lenZ, this.lenZ];
                                    e = [this.foreground, this.foreground, this.foreground, this.foreground];
                                    this.draw3DLayout(z, d, n, w, c, k, e, this.xAxisTickStyle)
                                };
                                this.set3DYLayout = function() {
                                    var A = [],
                                        d = [],
                                        n = [],
                                        z = [],
                                        c = [],
                                        k = [],
                                        e = [];
                                    var w, m, q, b, B, u, j, h;
                                    var f = this.lenY / 15;
                                    var r = (15 * -f) + f;
                                    var g = this.yAxisTitle ? this.yAxisTitle : this.is3DPlot && this.yAxis.length == 0 ? "Value" : this.yAxisIndex ? this.data.y.smps[this.yAxisIndex] : this.yAxis[0];
                                    var v = this.marginLeft + this.left + this.offsetX;
                                    var o = this.marginTop + this.top + this.offsetY;
                                    var p = [];
                                    if (this.show3DGrid) {
                                        q = r;
                                        w = 0;
                                        m = 0;
                                        while (q < this.lenY) {
                                            if ((w + 1) % 3) {
                                                if (this.zAxisType == "continuous") {
                                                    A[m] = -this.lenX;
                                                    d[m] = -this.lenY;
                                                    n[m] = q * this.lenZ / this.lenY;
                                                    z[m] = -this.lenX;
                                                    c[m] = this.lenY;
                                                    k[m] = q * this.lenZ / this.lenY;
                                                    e.push(this.yAxisTickColor);
                                                    m++
                                                }
                                                A[m] = -this.lenX;
                                                d[m] = q;
                                                n[m] = -this.lenZ;
                                                z[m] = -this.lenX;
                                                c[m] = q;
                                                k[m] = this.lenZ;
                                                e.push(this.yAxisTickColor);
                                                m++
                                            }
                                            q += f;
                                            w++
                                        }
                                        this.draw3DLayout(A, d, n, z, c, k, e, this.yAxisTickStyle);
                                        A = [], d = [], n = [], z = [], c = [], k = [], e = [];
                                        q = r;
                                        w = 0;
                                        m = 0;
                                        B = this.yAxisIncr * 9;
                                        while (q < this.lenY) {
                                            if (!((w + 1) % 3)) {
                                                if (this.zAxisType == "continuous") {
                                                    A[m] = -this.lenX;
                                                    d[m] = -this.lenY;
                                                    n[m] = q * this.lenZ / this.lenY;
                                                    z[m] = -this.lenX;
                                                    c[m] = this.lenY;
                                                    k[m] = q * this.lenZ / this.lenY;
                                                    e.push(this.foreground);
                                                    m++
                                                }
                                                A[m] = -this.lenX;
                                                d[m] = q;
                                                n[m] = -this.lenZ;
                                                z[m] = -this.lenX;
                                                c[m] = q;
                                                k[m] = this.lenZ;
                                                e.push(this.foreground);
                                                b = this.get3DTransfrom(-this.lenX, q, -this.lenZ);
                                                j = b[0] + v;
                                                h = b[1] + o;
                                                u = this.formatAxisValue(this.yAxisMin + B, "yAxis");
                                                B -= this.yAxisIncr;
                                                if (this.yAxisShow) {
                                                    if (this.yRotate >= 45 && this.xRotate >= 45) {
                                                        this.toRender({
                                                            p: ["drawText", u, j, h + 5, this.axisTickFont, this.axisTickColor, "right", false, -Math.PI / 2],
                                                            t: "Axes2"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawText", u, j - 5, h, this.axisTickFont, this.axisTickColor, "right"],
                                                            t: "Axes2"
                                                        })
                                                    }
                                                }
                                                m++
                                            }
                                            q += f;
                                            w++
                                        }
                                        this.draw3DLayout(A, d, n, z, c, k, e, this.yAxisTickStyle)
                                    }
                                    if (this.yAxisShow) {
                                        this.draw3DAxisTitle(-this.lenX - (f * 4), -this.lenX - (f * 4), r - (f * 2), this.lenY + f, -this.lenZ - (f * 4), -this.lenZ - (f * 4), g, "y")
                                    }
                                    A = [-this.lenX, -this.lenX, -this.lenX, -this.lenX];
                                    d = [-this.lenY, -this.lenY, -this.lenY, this.lenY];
                                    n = [-this.lenZ, this.lenZ, this.lenZ, this.lenZ];
                                    z = [-this.lenX, -this.lenX, -this.lenX, -this.lenX];
                                    c = [this.lenY, -this.lenY, this.lenY, this.lenY];
                                    k = [-this.lenZ, -this.lenZ, this.lenZ, -this.lenZ];
                                    e = [this.foreground, this.foreground, this.foreground, this.foreground];
                                    this.draw3DLayout(A, d, n, z, c, k, e, this.yAxisTickStyle)
                                };
                                this.set3DZLayout = function() {
                                    var n = this;
                                    var J = [],
                                        d = [],
                                        w = [],
                                        I = [],
                                        c = [],
                                        q = [],
                                        h = [];
                                    var G, r, A, v, b, L, E, p, o;
                                    var k, f, g, e, C, B, D, j;
                                    var m = this.zAxisTitle ? this.zAxisTitle : this.is3DPlot && this.zAxis.length == 0 ? "Variables" : this.zAxisIndex ? this.data.y.smps[this.zAxisIndex] : this.zAxis[0];
                                    var F = this.marginLeft + this.left + this.offsetX;
                                    var z = this.marginTop + this.top + this.offsetY;
                                    var H = function(u) {
                                        var t = u / n.varLabelInterval;
                                        if (parseInt(t) == parseFloat(t)) {
                                            var s = n.get3DTransfrom(n.lenX, n.lenY, A - (k / 2));
                                            var l = s[0] + F;
                                            var N = s[1] + z;
                                            var M = n.zAxis.length == 0 ? n.data.y.vars[n.varIndices[u]] : e[u];
                                            if (n.xRotate >= 45) {
                                                if (n.yRotate >= 45) {
                                                    n.toRender({
                                                        p: ["drawText", M, l + 5, N, n.axisTickFont, n.axisTickColor, "left"],
                                                        t: "Axes3"
                                                    })
                                                } else {
                                                    n.toRender({
                                                        p: ["drawText", M, l, N + 5, n.axisTickFont, n.axisTickColor, "right", false, -Math.PI / 2],
                                                        t: "Axes3"
                                                    })
                                                }
                                            } else {
                                                n.toRender({
                                                    p: ["drawText", M, l + 5, N, n.axisTickFont, n.axisTickColor, "left"],
                                                    t: "Axes3"
                                                })
                                            }
                                        }
                                    };
                                    var K = function(N, t) {
                                        var M = N / n.smpLabelInterval;
                                        if (parseInt(M) == parseFloat(M)) {
                                            var s = n.get3DTransfrom((t * n.lenX / n.lenZ) - ((f / 2) * n.x3DRatio), n.lenY, -n.lenZ);
                                            var l = s[0] + F;
                                            var P = s[1] + z;
                                            var O = n.xAxis.length == 0 ? n.isGroupedData && n.scatterType == "dot" ? n.data.w.smps[n.grpIndices[N]] : n.data.y.smps[n.smpIndices[N]] : g[N];
                                            n.toRender({
                                                p: ["drawText", O, l, P + 5, n.axisTickFont, n.axisTickColor, "right", false, -Math.PI / 2],
                                                t: "Axes3"
                                            })
                                        }
                                    };
                                    if (this.is3DPlot) {
                                        if (this.zAxis.length > 0) {
                                            if (this.zAxisType == "continuous") {
                                                k = this.lenZ / 15;
                                                C = (15 * -k) + k
                                            } else {
                                                e = this.getVariableLevelsByAnnotation(this.zAxis[0]);
                                                k = this.lenZ / (e.length * 0.5);
                                                C = ((e.length * 0.5) * -k) + k
                                            }
                                        } else {
                                            k = this.lenZ / (this.varIndices.length * 0.5);
                                            C = ((this.varIndices.length * 0.5) * -k) + k
                                        }
                                        if (this.xAxis.length > 0) {
                                            if (this.xAxisType == "continuous") {
                                                f = this.lenX / 15;
                                                B = (15 * -f) + f
                                            } else {
                                                g = this.getVariableLevelsByAnnotation(this.xAxis[0]);
                                                f = this.lenX / (g.length * 0.5);
                                                B = ((g.length * 0.5) * -f) + f
                                            }
                                        } else {
                                            if (this.isGroupedData && this.scatterType == "dot") {
                                                f = this.lenZ / (this.grpIndices.length * 0.5);
                                                B = ((this.grpIndices.length * 0.5) * -f) + f
                                            } else {
                                                f = this.lenZ / (this.smpIndices.length * 0.5);
                                                B = ((this.smpIndices.length * 0.5) * -f) + f
                                            }
                                        }
                                    } else {
                                        k = this.lenZ / 15;
                                        f = false;
                                        C = (15 * -k) + k;
                                        B = false
                                    }
                                    if (this.show3DGrid) {
                                        if (this.zAxisType == "continuous") {
                                            J = [], d = [], w = [], I = [], c = [], q = [], h = [];
                                            A = C;
                                            G = 0;
                                            r = 0;
                                            while (A < this.lenZ) {
                                                if ((G + 1) % 3) {
                                                    J[r] = -this.lenX;
                                                    d[r] = this.lenY;
                                                    w[r] = A;
                                                    I[r] = this.lenX;
                                                    c[r] = this.lenY;
                                                    q[r] = A;
                                                    h.push(this.zAxisTickColor);
                                                    r++
                                                }
                                                A += k;
                                                G++
                                            }
                                            this.draw3DLayout(J, d, w, I, c, q, h, this.zAxisTickStyle)
                                        }
                                        if (this.xAxisType == "continuous") {
                                            J = [], d = [], w = [], I = [], c = [], q = [], h = [];
                                            A = B || C;
                                            G = 0;
                                            r = 0;
                                            while (A < this.lenZ) {
                                                if ((G + 1) % 3) {
                                                    J[r] = A * this.lenX / this.lenZ;
                                                    d[r] = this.lenY;
                                                    w[r] = -this.lenZ;
                                                    I[r] = A * this.lenX / this.lenZ;
                                                    c[r] = this.lenY;
                                                    q[r] = this.lenZ;
                                                    h.push(this.zAxisTickColor);
                                                    r++
                                                }
                                                A += f || k;
                                                G++
                                            }
                                            this.draw3DLayout(J, d, w, I, c, q, h, this.zAxisTickStyle)
                                        }
                                        if (this.zAxisType == "continuous") {
                                            J = [], d = [], w = [], I = [], c = [], q = [], h = [];
                                            A = C;
                                            G = 0;
                                            r = 0;
                                            L = this.zAxisIncr;
                                            while (A < this.lenZ) {
                                                if (!((G + 1) % 3)) {
                                                    J[r] = -this.lenX;
                                                    d[r] = this.lenY;
                                                    w[r] = A;
                                                    I[r] = this.lenX;
                                                    c[r] = this.lenY;
                                                    q[r] = A;
                                                    h.push(this.foreground);
                                                    r++
                                                }
                                                A += k;
                                                G++
                                            }
                                            this.draw3DLayout(J, d, w, I, c, q, h, this.zAxisTickStyle)
                                        }
                                        if (this.xAxisType == "continuous" || this.zAxisType == "continuous") {
                                            J = [], d = [], w = [], I = [], c = [], q = [], h = [];
                                            if (this.xAxisType == "continuous") {
                                                A = B || C
                                            } else {
                                                A = C
                                            }
                                            G = 0;
                                            r = 0;
                                            L = this.zAxisIncr;
                                            while (A < this.lenZ) {
                                                if (!((G + 1) % 3)) {
                                                    J[r] = A * this.lenX / this.lenZ;
                                                    d[r] = this.lenY;
                                                    w[r] = -this.lenZ;
                                                    I[r] = A * this.lenX / this.lenZ;
                                                    c[r] = this.lenY;
                                                    q[r] = this.lenZ;
                                                    h.push(this.foreground);
                                                    r++;
                                                    b = this.get3DTransfrom(this.lenX, this.lenY, A);
                                                    p = b[0] + F;
                                                    o = b[1] + z;
                                                    E = this.zAxisTime ? this.dateFormat(new Date(this.zAxisMin + L), this.timeFormat) : this.formatAxisValue(this.zAxisMin + L, "zAxis");
                                                    L += this.zAxisIncr;
                                                    if (this.zAxisShow && this.zAxisType == "continuous") {
                                                        if (this.xRotate >= 45) {
                                                            if (this.yRotate >= 45) {
                                                                this.toRender({
                                                                    p: ["drawText", E, p + 5, o, this.axisTickFont, this.axisTickColor, "left"],
                                                                    t: "Axes3"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawText", E, p, o + 5, this.axisTickFont, this.axisTickColor, "right", false, -Math.PI / 2],
                                                                    t: "Axes3"
                                                                })
                                                            }
                                                        } else {
                                                            this.toRender({
                                                                p: ["drawText", E, p + 5, o, this.axisTickFont, this.axisTickColor, "left"],
                                                                t: "Axes3"
                                                            })
                                                        }
                                                    }
                                                }
                                                if (this.xAxisType == "continuous") {
                                                    A += f || k
                                                } else {
                                                    A += k
                                                }
                                                G++
                                            }
                                            if (this.xAxisType == "continuous") {
                                                this.draw3DLayout(J, d, w, I, c, q, h, this.zAxisTickStyle)
                                            }
                                        }
                                        if (this.zAxisType == "categorical") {
                                            A = C;
                                            G = 0;
                                            r = 0;
                                            while (A < this.lenZ) {
                                                J[r] = -this.lenX;
                                                d[r] = this.lenY;
                                                w[r] = A;
                                                I[r] = this.lenX;
                                                c[r] = this.lenY;
                                                q[r] = A;
                                                h.push(this.zAxisTickColor);
                                                H(G);
                                                r++;
                                                G++;
                                                A += k
                                            }
                                            this.draw3DLayout(J, d, w, I, c, q, h, this.zAxisTickStyle);
                                            H(G)
                                        }
                                        if (this.xAxisType == "categorical") {
                                            G = 0;
                                            v = B;
                                            while (v < this.lenZ) {
                                                J[r] = v * this.lenX / this.lenZ;
                                                d[r] = this.lenY;
                                                w[r] = -this.lenZ;
                                                I[r] = v * this.lenX / this.lenZ;
                                                c[r] = this.lenY;
                                                q[r] = this.lenZ;
                                                h.push(this.zAxisTickColor);
                                                K(G, v);
                                                r++;
                                                G++;
                                                v += f
                                            }
                                            this.draw3DLayout(J, d, w, I, c, q, h, this.zAxisTickStyle);
                                            K(G, v)
                                        }
                                    }
                                    if (this.zAxisShow && !this.is3DPlot) {
                                        this.draw3DAxisTitle(this.lenX + (k * 6), this.lenX + (k * 6), this.lenY + (k * 6), this.lenY + (k * 6), C - (k * 2), this.lenZ + k, m, "z")
                                    }
                                    J = [-this.lenX, -this.lenX, this.lenX, -this.lenX];
                                    d = [this.lenY, this.lenY, this.lenY, this.lenY];
                                    w = [-this.lenZ, this.lenZ, -this.lenZ, -this.lenZ];
                                    I = [-this.lenX, this.lenX, this.lenX, this.lenX];
                                    c = [this.lenY, this.lenY, this.lenY, this.lenY];
                                    q = [this.lenZ, this.lenZ, this.lenZ, -this.lenZ];
                                    h = [this.foreground, this.foreground, this.foreground, this.foreground];
                                    this.draw3DLayout(J, d, w, I, c, q, h, this.zAxisTickStyle)
                                };
                                this.draw3DAxisTitle = function(v, u, e, d, k, j, n, c) {
                                    var p = this.measureText(n);
                                    var r = p / 2;
                                    var w = n.split("");
                                    var h = (v + u) / 2;
                                    var g = (e + d) / 2;
                                    var f = (k + j) / 2;
                                    var q = this.marginLeft + this.left + this.offsetX;
                                    var m = this.marginTop + this.top + this.offsetY;
                                    var o = this.xRotate >= 45 || this.yRotate >= 45 ? 4 : 0;
                                    if (this.xRotate >= 45 || this.yRotate >= 45) {
                                        p += w.length * 4;
                                        r = p / 2
                                    }
                                    if (c == "x") {
                                        h -= r;
                                        for (var s = 0; s < w.length; s++) {
                                            var b = this.get3DTransfrom(h, g, f);
                                            this.toRender({
                                                p: ["drawText", w[s], q + b[0], m + b[1], this.axisTitleFont, this.axisTitleColor, "left", "top"],
                                                t: "AxesTitle"
                                            });
                                            h += this.measureText(w[s]) + o
                                        }
                                    } else {
                                        if (c == "y") {
                                            g += r;
                                            for (var s = 0; s < w.length; s++) {
                                                var b = this.get3DTransfrom(h, g, f);
                                                this.toRender({
                                                    p: ["drawText", w[s], q + b[0], m + b[1], this.axisTitleFont, this.axisTitleColor, "left", "bottom", -Math.PI / 2],
                                                    t: "AxesTitle"
                                                });
                                                g -= this.measureText(w[s]) + o
                                            }
                                        } else {
                                            if (c == "z") {
                                                f -= r;
                                                for (var s = 0; s < w.length; s++) {
                                                    var b = this.get3DTransfrom(h, g, f);
                                                    this.toRender({
                                                        p: ["drawText", w[s], q + b[0], m + b[1], this.axisTitleFont, this.axisTitleColor, "left", "bottom"],
                                                        t: "AxesTitle"
                                                    });
                                                    f += this.measureText(w[s]) + o
                                                }
                                            }
                                        }
                                    }
                                };
                                this.set3DLayout = function(c) {
                                    if (c) {
                                        this.layoutSet = {
                                            x: false,
                                            y: false,
                                            z: false
                                        }
                                    }
                                    for (var g = 0; g < this.layoutOrder.ord.length; g++) {
                                        var d = this.layoutOrder.ord[g];
                                        var h = c && this.layoutOrder[d];
                                        var f = !c && !this.layoutOrder[d];
                                        var e = c && this.layoutOrder[d + "1"];
                                        if (!this.layoutSet[d]) {
                                            if (h || f || (!h && !f && e)) {
                                                this["set3D" + d.toUpperCase() + "Layout"]();
                                                this.layoutSet[d] = true
                                            }
                                        }
                                    }
                                    if (!c) {
                                        delete(this.layoutSet)
                                    }
                                };
                                this.set3DAxes = function() {
                                    var f = ["x", "y", "z"];
                                    this.setMin = null;
                                    this.setMax = null;
                                    if (this.is3DPlot) {
                                        if (this.yAxis.length == 0) {
                                            if (this.xAxisTitle) {
                                                var c = this.yAxisTitle;
                                                this.yAxisTitle = this.xAxisTitle;
                                                this.xAxisTitle = c
                                            }
                                            this.yAxisMin = this.xAxisMin;
                                            this.yAxisMax = this.xAxisMax;
                                            this.yAxisIncr = this.getAxisIncrements(this.yAxisMin, this.yAxisMax, 10, this.yAxisExact);
                                            this.yAxisDecs = this.getAxisDecimals(this.yAxisIncr);
                                            this.yAxisRange = this.xAxisRange
                                        } else {
                                            var g = this.smpIndices;
                                            this.yAxisIndex = this.getSampleIndices([this.yAxis[0]]);
                                            this.setSamplesVisible([this.yAxisIndex]);
                                            this.setRangeData();
                                            this.yAxisMin = this.setMinY != null ? this.setMinY : this.minData;
                                            this.yAxisMax = this.setMaxY != null ? this.setMaxY : this.maxData;
                                            this.yAxisIncr = this.getAxisIncrements(this.yAxisMin, this.yAxisMax, 10, this.yAxisExact);
                                            this.yAxisDecs = this.getAxisDecimals(this.yAxisIncr);
                                            if (!this.yAxisExact) {
                                                this.yAxisMin = this.getAxisMin(this.yAxisMin, this.yAxisIncr);
                                                this.yAxisMax = this.yAxisMin + (this.yAxisIncr * 10)
                                            }
                                            this.yAxisRange = this.yAxisMax - this.yAxisMin;
                                            this.yAxisUnit = this.lenY * 2 / this.yAxisRange;
                                            this.yAxisOffset = Math.min(this.lenY, (this.yAxisMin + (this.yAxisRange / 2)) * this.yAxisUnit);
                                            this.AxisType = "continuous";
                                            this.setSamplesVisible(g)
                                        }
                                        this.yAxisUnit = this.lenY * 2 / (this.yAxisIncr * 10);
                                        this.yAxisOffset = Math.min(this.lenY, (this.yAxisMin + (this.yAxisIncr * 10 / 2)) * this.yAxisUnit);
                                        this.yAxisType = "continuous";
                                        if (this.xAxis.length > 0) {
                                            if (this.data.z && this.data.z.hasOwnProperty(this.xAxis[0]) && !this.isNumeric(this.data.z[this.xAxis[0]])) {
                                                var e = this.getVariableLevelsByAnnotation(this.xAxis[0]);
                                                this.xAxisMin = 0;
                                                this.xAxisMax = 10;
                                                this.xAxisIncr = 10 / e.length;
                                                this.xAxisDecs = 0;
                                                this.xAxisRange = this.xAxisMax - this.xAxisMin;
                                                this.xAxisUnit = this.lenX * 2 / this.xAxisRange;
                                                this.xAxisOffset = Math.min(this.lenX, (this.xAxisMin + (this.xAxisRange / 2)) * this.xAxisUnit);
                                                this.xAxisType = "categorical"
                                            } else {
                                                if (this.getSampleIndices(this.xAxis[0]) >= 0) {
                                                    var g = this.smpIndices;
                                                    this.xAxisIndex = this.getSampleIndices([this.xAxis[0]]);
                                                    this.setSamplesVisible([this.xAxisIndex]);
                                                    this.setRangeData();
                                                    this.xAxisMin = this.setMinX != null ? this.setMinX : this.minData;
                                                    this.xAxisMax = this.setMaxX != null ? this.setMaxX : this.maxData;
                                                    this.xAxisIncr = this.getAxisIncrements(this.xAxisMin, this.xAxisMax, 10, this.xAxisExact);
                                                    this.xAxisDecs = this.getAxisDecimals(this.xAxisIncr);
                                                    if (!this.xAxisExact) {
                                                        this.xAxisMin = this.getAxisMin(this.xAxisMin, this.xAxisIncr);
                                                        this.xAxisMax = this.xAxisMin + (this.xAxisIncr * 10)
                                                    }
                                                    this.xAxisRange = this.xAxisMax - this.xAxisMin;
                                                    this.xAxisUnit = this.lenX * 2 / this.xAxisRange;
                                                    this.xAxisOffset = Math.min(this.lenX, (this.xAxisMin + (this.xAxisRange / 2)) * this.xAxisUnit);
                                                    this.xAxisType = "continuous";
                                                    this.setSamplesVisible(g)
                                                }
                                            }
                                        } else {
                                            this.xAxisMin = 0;
                                            this.xAxisMax = 10;
                                            this.xAxisIncr = this.isGroupedData ? 10 / this.grpIndices.length : 10 / this.smpIndices.length;
                                            this.xAxisDecs = 0;
                                            this.xAxisRange = this.xAxisMax - this.xAxisMin;
                                            this.xAxisUnit = this.lenX * 2 / this.xAxisRange;
                                            this.xAxisOffset = Math.min(this.lenX, (this.xAxisMin + (this.xAxisRange / 2)) * this.xAxisUnit);
                                            this.xAxisType = "categorical"
                                        }
                                        if (this.zAxis.length > 0) {
                                            if (this.data.z && this.data.z.hasOwnProperty(this.zAxis[0]) && !this.isNumeric(this.data.z[this.zAxis[0]])) {
                                                var e = this.getVariableLevelsByAnnotation(this.zAxis[0]);
                                                this.zAxisMin = 0;
                                                this.zAxisMax = 10;
                                                this.zAxisIncr = 10 / e.length;
                                                this.zAxisDecs = 0;
                                                this.zAxisRange = this.zAxisMax - this.zAxisMin;
                                                this.zAxisUnit = this.lenZ * 2 / this.zAxisRange;
                                                this.zAxisOffset = Math.min(this.lenZ, (this.zAxisMin + (this.zAxisRange / 2)) * this.zAxisUnit);
                                                this.zAxisType = "categorical"
                                            } else {
                                                if (this.getSampleIndices(this.zAxis[0]) >= 0) {
                                                    var g = this.smpIndices;
                                                    this.zAxisIndex = this.getSampleIndices([this.zAxis[0]]);
                                                    this.setSamplesVisible([this.zAxisIndex]);
                                                    this.setRangeData();
                                                    this.zAxisMin = this.setMinZ != null ? this.setMinZ : this.minData;
                                                    this.zAxisMax = this.setMaxZ != null ? this.setMaxZ : this.maxData;
                                                    this.zAxisIncr = this.getAxisIncrements(this.zAxisMin, this.zAxisMax, 10, this.zAxisExact);
                                                    this.zAxisDecs = this.getAxisDecimals(this.zAxisIncr);
                                                    if (!this.zAxisExact) {
                                                        this.zAxisMin = this.getAxisMin(this.zAxisMin, this.zAxisIncr);
                                                        this.zAxisMax = this.zAxisMin + (this.zAxisIncr * 10)
                                                    }
                                                    this.zAxisRange = this.zAxisMax - this.zAxisMin;
                                                    this.zAxisUnit = this.lenZ * 2 / this.zAxisRange;
                                                    this.zAxisOffset = Math.min(this.lenZ, (this.zAxisMin + (this.zAxisRange / 2)) * this.zAxisUnit);
                                                    this.zAxisType = "continuous";
                                                    this.setSamplesVisible(g)
                                                }
                                            }
                                        } else {
                                            this.zAxisMin = 0;
                                            this.zAxisMax = 10;
                                            this.zAxisIncr = 10 / this.varIndices.length;
                                            this.zAxisDecs = 0;
                                            this.zAxisRange = this.zAxisMax - this.zAxisMin;
                                            this.zAxisUnit = this.lenZ * 2 / this.zAxisRange;
                                            this.zAxisOffset = Math.min(this.lenZ, (this.zAxisMin + (this.zAxisRange / 2)) * this.zAxisUnit);
                                            this.zAxisType = "categorical"
                                        }
                                    } else {
                                        for (var b = 0; b < f.length; b++) {
                                            var g = this.smpIndices;
                                            var d = f[b].toUpperCase();
                                            this[f[b] + "AxisIndex"] = this.getSampleIndices(this[f[b] + "Axis"])[0];
                                            this.setSamplesVisible([this[f[b] + "AxisIndex"]]);
                                            this.setRangeData();
                                            if (this.minData == this.maxData) {
                                                this.maxData += 0.5
                                            }
                                            this[f[b] + "AxisMin"] = this["setMin" + d] != null ? this["setMin" + d] : this.minData;
                                            this[f[b] + "AxisMax"] = this["setMax" + d] != null ? this["setMax" + d] : this.maxData;
                                            this[f[b] + "AxisIncr"] = this.getAxisIncrements(this[f[b] + "AxisMin"], this[f[b] + "AxisMax"], 10, this[f[b] + "AxisExact"]);
                                            this[f[b] + "AxisDecs"] = this.getAxisDecimals(this[f[b] + "AxisIncr"]);
                                            if (!this[f[b] + "AxisExact"]) {
                                                this[f[b] + "AxisMin"] = this.getAxisMin(this[f[b] + "AxisMin"], this[f[b] + "AxisIncr"]);
                                                this[f[b] + "AxisMax"] = this[f[b] + "AxisMin"] + (this[f[b] + "AxisIncr"] * 10)
                                            }
                                            this[f[b] + "AxisRange"] = this[f[b] + "AxisMax"] - this[f[b] + "AxisMin"];
                                            this[f[b] + "AxisUnit"] = this["len" + d] * 2 / this[f[b] + "AxisRange"];
                                            this[f[b] + "AxisOffset"] = Math.min(this["len" + d], (this[f[b] + "AxisMin"] + (this[f[b] + "AxisRange"] / 2)) * this[f[b] + "AxisUnit"]);
                                            this[f[b] + "AxisType"] = "continuous";
                                            this[f[b] + "AxisTime"] = this.isGraphTime == f[b] ? true : false;
                                            this.setSamplesVisible(g)
                                        }
                                    }
                                    this.set3DCenter()
                                };
                                this.set3DCenter = function() {
                                    var r = this.xAxisMin < 0 ? 0 : this.xAxisMin;
                                    var q = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                    var o = this.zAxisMin < 0 ? 0 : this.zAxisMin;
                                    var m = ((((this.xAxisMin + this.xAxisMax) / 2) - r) * this.xAxisUnit) - this.xAxisOffset;
                                    var l = this.yAxisOffset - ((((this.yAxisMin + this.yAxisMax) / 2) - q) * this.yAxisUnit);
                                    var k = ((((this.zAxisMin + this.zAxisMax) / 2) - o) * this.zAxisUnit) - this.zAxisOffset;
                                    this.zero3DPoint = this.get3DTransfrom(m, l, k);
                                    var A = this.get3DTransfrom(((this.xAxisMin - r) * this.xAxisUnit) - this.xAxisOffset, l, k);
                                    var w = this.get3DTransfrom(((this.xAxisMax - r) * this.xAxisUnit) - this.xAxisOffset, l, k);
                                    var f = this.get3DTransfrom(m, this.yAxisOffset - ((this.yAxisMin - q) * this.yAxisUnit), k);
                                    var e = this.get3DTransfrom(m, this.yAxisOffset - ((this.yAxisMax - q) * this.yAxisUnit), k);
                                    var p = this.get3DTransfrom(m, l, ((this.zAxisMax - o) * this.zAxisUnit) - this.zAxisOffset);
                                    var n = this.get3DTransfrom(m, l, ((this.zAxisMin - o) * this.zAxisUnit) - this.zAxisOffset);
                                    var u = this.euclidianDistance([A[0], A[1], A[2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]);
                                    var t = this.euclidianDistance([w[0], w[1], w[2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]);
                                    var c = this.euclidianDistance([f[0], f[1], f[2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]);
                                    var b = this.euclidianDistance([e[0], e[1], e[2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]);
                                    var j = this.euclidianDistance([p[0], p[1], p[2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]);
                                    var h = this.euclidianDistance([n[0], n[1], n[2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]);
                                    var s = this.euclidianDistance([this.zero3DPoint[0], this.zero3DPoint[1], this.zero3DPoint[2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]);
                                    var B = [Math.min(u, t), Math.min(c, b), Math.min(j, h)];
                                    var C = {
                                        0: "x",
                                        1: "y",
                                        2: "z"
                                    };
                                    var g = [0, 1, 2];
                                    g = g.sort(function(x, i) {
                                        return B[x] - B[i]
                                    });
                                    var d = [];
                                    for (var v = 0; v < g.length; v++) {
                                        d.push(C[g[v]])
                                    }
                                    this.layoutOrder = {
                                        x0: j,
                                        x1: h,
                                        y0: u,
                                        y1: t,
                                        z0: c,
                                        z1: b,
                                        md: s,
                                        x: j >= h,
                                        y: u >= t,
                                        z: c >= b,
                                        x1: Math.min(j, h) > s,
                                        y1: Math.min(u, t) > s,
                                        z1: Math.min(c, b) > s,
                                        ord: d
                                    }
                                };
                                this.is3DVisibleDataPoint = function(b, d, c) {
                                    if (b >= this.xAxisMin && b <= this.xAxisMax) {
                                        if (d >= this.yAxisMin && d <= this.yAxisMax) {
                                            if (c >= this.zAxisMin && c <= this.zAxisMax) {
                                                return true
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.draw3DDataPoints = function() {
                                    var ae = this.marginLeft + this.left + this.offsetX;
                                    var U = this.marginTop + this.top + this.offsetY;
                                    var aw = this.xAxisIndex + ":" + this.yAxisIndex + ":" + this.zAxisIndex;
                                    var aV = {
                                        data: {},
                                        ellp: {},
                                        sphr: {}
                                    };
                                    var aS = [];
                                    var I = [];
                                    var aR = [];
                                    var E = [];
                                    var b = [];
                                    var N = [];
                                    var ax = [];
                                    var H = [];
                                    var aI = [];
                                    var f = 0;
                                    this.connectByData = {};
                                    if (this.is3DPlot) {
                                        if (this.xAxis.length > 0 && this.yAxis.length > 0 && this.zAxis.length > 0) {
                                            var aJ, aT, ay;
                                            var aj = {};
                                            var ah = {};
                                            var aH = this.getSampleIndices(this.yAxis[0]);
                                            if (this.data.z && this.data.z.hasOwnProperty(this.xAxis[0]) && !this.isNumeric(this.data.z[this.xAxis[0]])) {
                                                aJ = this.getVariableLevelsByAnnotation(this.xAxis[0]);
                                                for (var ai = 0; ai < aJ.length; ai++) {
                                                    aj[aJ[ai]] = ai
                                                }
                                                aT = false
                                            } else {
                                                aT = this.getSampleIndices(this.xAxis[0])
                                            }
                                            if (this.data.z && this.data.z.hasOwnProperty(this.zAxis[0]) && !this.isNumeric(this.data.z[this.zAxis[0]])) {
                                                aJ = this.getVariableLevelsByAnnotation(this.zAxis[0]);
                                                for (var ai = 0; ai < aJ.length; ai++) {
                                                    ah[aJ[ai]] = ai
                                                }
                                                ay = false
                                            } else {
                                                ay = this.getSampleIndices(this.zAxis[0])
                                            }
                                            W = 0;
                                            for (var ai = 0; ai < this.varIndices.length; ai++) {
                                                var Y = this.varIndices[ai];
                                                var S = aT === false ? (aj[this.data.z[this.xAxis[0]][Y]] * this.xAxisIncr) + (this.xAxisIncr / 2) : this.getDataAtPos(Y, aT);
                                                var R = this.getDataAtPos(Y, aH);
                                                var Q = ay === false ? (ah[this.data.z[this.zAxis[0]][Y]] * this.zAxisIncr) + (this.zAxisIncr / 2) : this.getDataAtPos(Y, ay);
                                                var aB = this.xAxisMin < 0 ? 0 : this.xAxisMin;
                                                var aA = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                                var az = this.zAxisMin < 0 ? 0 : this.zAxisMin;
                                                var D = ((S - aB) * this.xAxisUnit) - this.xAxisOffset;
                                                var C = this.yAxisOffset - ((R - aA) * this.yAxisUnit);
                                                var B = ((Q - az) * this.zAxisUnit) - this.zAxisOffset;
                                                ax.push(true);
                                                aS.push([S, R, Q]);
                                                var aU = this.get3DTransfrom(D, C, B);
                                                I.push(aU);
                                                aR.push(aU[2]);
                                                N.push(this.euclidianDistance([I[W][0], I[W][1], I[W][2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]));
                                                aI.push([Y, aH]);
                                                b.push(W++)
                                            }
                                        } else {
                                            if (this.isGroupedData && this.scatterType == "dot") {
                                                this.isGroupedData = false;
                                                var W = 0;
                                                for (var ai = 0; ai < this.varIndices.length; ai++) {
                                                    var Y = this.varIndices[ai];
                                                    for (var ag = 0; ag < this.grpIndices.length; ag++) {
                                                        for (var af = 0; af < this.data.w.grps[this.grpIndices[ag]].length; af++) {
                                                            var J = this.data.w.grps[this.grpIndices[ag]][af];
                                                            var S = (ag * this.xAxisIncr) + (this.xAxisIncr / 2);
                                                            var R = this.getDataAtPos(Y, J);
                                                            var Q = (ai * this.zAxisIncr) + (this.zAxisIncr / 2);
                                                            var aB = 0;
                                                            var aA = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                                            var az = 0;
                                                            var D = ((S - aB) * this.xAxisUnit) - this.xAxisOffset;
                                                            var C = this.yAxisOffset - ((R - aA) * this.yAxisUnit);
                                                            var B = ((Q - az) * this.zAxisUnit) - this.zAxisOffset;
                                                            ax.push(true);
                                                            aS.push([S, R, Q]);
                                                            var aU = this.get3DTransfrom(D, C, B);
                                                            I.push(aU);
                                                            aR.push(aU[2]);
                                                            N.push(this.euclidianDistance([I[W][0], I[W][1], I[W][2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]));
                                                            aI.push([Y, this.grpIndices[ag]]);
                                                            b.push(W++)
                                                        }
                                                    }
                                                }
                                                this.isGroupedData = true
                                            } else {
                                                var W = 0;
                                                for (var ai = 0; ai < this.varIndices.length; ai++) {
                                                    var Y = this.varIndices[ai];
                                                    for (var ag = 0; ag < this.smpIndices.length; ag++) {
                                                        var J = this.smpIndices[ag];
                                                        var S = (ag * this.xAxisIncr) + (this.xAxisIncr / 2);
                                                        var R = this.getDataAtPos(Y, J);
                                                        var Q = (ai * this.zAxisIncr) + (this.zAxisIncr / 2);
                                                        var aB = 0;
                                                        var aA = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                                        var az = 0;
                                                        var D = ((S - aB) * this.xAxisUnit) - this.xAxisOffset;
                                                        var C = this.scatterType && this.scatterType.match(/bar/) ? 0 : this.yAxisOffset - ((R - aA) * this.yAxisUnit);
                                                        var B = ((Q - az) * this.zAxisUnit) - this.zAxisOffset;
                                                        ax.push(true);
                                                        aS.push([S, R, Q]);
                                                        var aU = this.get3DTransfrom(D, C, B);
                                                        I.push(aU);
                                                        aR.push(aU[2]);
                                                        N.push(this.euclidianDistance([I[W][0], I[W][1], I[W][2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]));
                                                        aI.push([Y, J]);
                                                        b.push(W++)
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        for (var ai = 0; ai < this.varIndices.length; ai++) {
                                            var Y = this.varIndices[ai];
                                            var S = this.getDataAtPos(Y, this.xAxisIndex);
                                            var R = this.getDataAtPos(Y, this.yAxisIndex);
                                            var Q = this.getDataAtPos(Y, this.zAxisIndex);
                                            var aB = this.xAxisMin < 0 ? 0 : this.xAxisMin;
                                            var aA = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                            var az = this.zAxisMin < 0 ? 0 : this.zAxisMin;
                                            var D = ((S - aB) * this.xAxisUnit) - this.xAxisOffset;
                                            var C = this.scatterType && this.scatterType.match(/bar/) ? 0 : this.yAxisOffset - ((R - aA) * this.yAxisUnit);
                                            var B = ((Q - az) * this.zAxisUnit) - this.zAxisOffset;
                                            var e = this.ellipseBy && this.data.z && this.data.z.hasOwnProperty(this.ellipseBy) ? this.getMetadataValue(Y, "z", this.ellipseBy) : this.ellipseBy && this.ellipseBy == "variable" ? "variable" : false;
                                            ax.push(this.is3DVisibleDataPoint(S, R, Q));
                                            aS.push([S, R, Q]);
                                            var aU = this.get3DTransfrom(D, C, B);
                                            I.push(aU);
                                            aR.push(aU[2]);
                                            if (this.scatterType != "function") {
                                                b.push(ai);
                                                N.push(this.euclidianDistance([I[ai][0], I[ai][1], I[ai][2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]))
                                            }
                                            if (this.ellipseBy && e) {
                                                if (!aV.data.hasOwnProperty(e)) {
                                                    aV.data[e] = [
                                                        [],
                                                        [],
                                                        []
                                                    ]
                                                }
                                                aV.data[e][0].push(S);
                                                aV.data[e][1].push(R);
                                                aV.data[e][2].push(Q)
                                            }
                                        }
                                        if (this.ellipseBy) {
                                            var ar = this.ellipseBy && this.data.z && this.data.z.hasOwnProperty(this.ellipseBy) ? this.meta.data.z[this.ellipseBy] : false;
                                            var ai = this.varIndices.length;
                                            for (var e in aV.data) {
                                                aV.ellp[e] = this.errorEllipse(aV.data[e][0], aV.data[e][1], aV.data[e][2]);
                                                var aE = aV.ellp[e];
                                                if (aE) {
                                                    aV.sphr[e] = this.sphere(aE.cx, aE.cy, aE.cz, aE.rx[0], aE.ry[0], aE.rz[0], aE.rot[0], aE.rot[1], aE.rot[2]);
                                                    for (var ag = 0; ag < aV.sphr[e].length; ag++) {
                                                        D = ((aV.sphr[e][ag][0] - aB) * this.xAxisUnit) - this.xAxisOffset;
                                                        C = this.yAxisOffset - ((aV.sphr[e][ag][1] - aA) * this.yAxisUnit);
                                                        B = ((aV.sphr[e][ag][2] - az) * this.zAxisUnit) - this.zAxisOffset;
                                                        aU = this.get3DTransfrom(D, C, B);
                                                        I.push(aU);
                                                        aR.push(aU[2]);
                                                        b.push(ai + ag);
                                                        N.push(this.euclidianDistance([I[ai + ag][0], I[ai + ag][1], I[ai + ag][2]], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]))
                                                    }
                                                    ai += aV.sphr[e].length
                                                }
                                            }
                                        }
                                    }
                                    var aO = this.range(aR);
                                    if (this.showLoessFit) {
                                        if (this.varIndices.length > 18) {
                                            var S = this.getAxisDataBySample(this.xAxisIndex);
                                            var R = this.getAxisDataBySample(this.yAxisIndex);
                                            var Q = this.getAxisDataBySample(this.zAxisIndex);
                                            var A = this.loess([Q, R, S], false, [this.xAxisIndex, this.yAxisIndex, this.zAxisIndex]);
                                            var aa = [];
                                            var aB = this.xAxisMin < 0 ? 0 : this.xAxisMin;
                                            var aA = this.yAxisMin < 0 ? 0 : this.yAxisMin;
                                            var az = this.zAxisMin;
                                            for (var ai = 0; ai < A.x.length; ai++) {
                                                for (var ag = 0; ag < A.y.length; ag++) {
                                                    var D = ((A.x[ai] - az) * this.zAxisUnit) - this.zAxisOffset;
                                                    var C = this.yAxisOffset - ((A.z[ai][ag] - aA) * this.yAxisUnit);
                                                    var B = ((A.y[ag] - aB) * this.xAxisUnit) - this.xAxisOffset;
                                                    var aU = this.get3DTransfrom(D, C, B);
                                                    aa.push(aU)
                                                }
                                            }
                                            var ad = A.x.length;
                                            var au = [];
                                            var P = [];
                                            var aD = [];
                                            for (var ai = 1; ai < ad; ai++) {
                                                for (var ag = 0; ag < ad - 1; ag++) {
                                                    var ap = ((ai - 1) * ad) + ag;
                                                    var av = (ai * ad) + ag;
                                                    var ao = ((ai - 1) * ad) + ag + 1;
                                                    var aq = (ai * ad) + ag + 1;
                                                    var aN = [aa[ap][0] + ae, aa[av][0] + ae, aa[aq][0] + ae, aa[ao][0] + ae];
                                                    var aF = [aa[ap][1] + U, aa[av][1] + U, aa[aq][1] + U, aa[ao][1] + U];
                                                    var at = [aa[ap][2], aa[av][2], aa[aq][2], aa[ao][2]];
                                                    au.push(Y++);
                                                    P.push(this.euclidianDistance([this.mean(aN), this.mean(aF), this.mean(at)], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]));
                                                    aD.push([aN, aF])
                                                }
                                            }
                                            au.sort(function(g, c) {
                                                return P[c] - P[g]
                                            });
                                            var aK = this.addColorTransparency("black", 0.1, true);
                                            var M = this.addColorTransparency(this.confidenceIntervalColor, 0.3, true);
                                            for (var Y = 0; Y < aD.length; Y++) {
                                                var ai = au[Y];
                                                if (ai < aD.length) {
                                                    this.toRender({
                                                        p: ["drawShape", "polygon", aD[ai][0], aD[ai][1], false, false, M, aK, "closed"],
                                                        t: "Decorations"
                                                    })
                                                }
                                            }
                                        } else {
                                            this.showLoessFit = false;
                                            alert("Minimum 18 variables to show Loess Fit")
                                        }
                                    }
                                    if (this.scatterType && this.scatterType == "function") {
                                        var ad = Math.sqrt(I.length);
                                        var Y = 0;
                                        var h = [];
                                        var aM = this.colorBy ? this.meta.data.y.range[this.colorBy] : false;
                                        var ac = this.colorBy ? this.getColorBrew(this.colorSpectrum, aM.min, aM.max, this.colorSpectrumZeroValue, this.colorSpectrumBreaks) : false;
                                        for (var ai = 1; ai < ad; ai++) {
                                            for (var ag = 0; ag < ad - 1; ag++) {
                                                var ap = ((ai - 1) * ad) + ag;
                                                var av = (ai * ad) + ag;
                                                var ao = ((ai - 1) * ad) + ag + 1;
                                                var aq = (ai * ad) + ag + 1;
                                                var aN = [I[ap][0] + this.funcX, I[av][0] + this.funcX, I[aq][0] + this.funcX, I[ao][0] + this.funcX];
                                                var aF = [I[ap][1] + this.funcY, I[av][1] + this.funcY, I[aq][1] + this.funcY, I[ao][1] + this.funcY];
                                                var at = [I[ap][2], I[av][2], I[aq][2], I[ao][2]];
                                                var O = this.colorBy ? this.getColorForValue(ac, this.mean([aS[ap][1], aS[av][1], aS[aq][1], aS[ao][1]])) : false;
                                                b.push(Y++);
                                                N.push(this.euclidianDistance([this.mean(aN), this.mean(aF), this.mean(at)], [this.zero3DPoint[0], this.zero3DPoint[1], -this.x]));
                                                h.push([aN, aF, O])
                                            }
                                        }
                                        b.sort(function(g, c) {
                                            return N[c] - N[g]
                                        });
                                        for (var Y = 0; Y < h.length; Y++) {
                                            var ai = b[Y];
                                            if (ax[ai]) {
                                                var an = [ai, this.xAxisIndex, this.yAxisIndex, this.zAxisIndex];
                                                if (this.colorBy) {
                                                    this.toRender({
                                                        p: ["drawShape", "polygon", h[ai][0], h[ai][1], false, false, h[ai][2], h[ai][2], "closed"],
                                                        a: this.getShapeArea("polygon", h[ai][0], h[ai][1], false, false, h[ai][2], h[ai][2], "closed"),
                                                        i: an,
                                                        t: "Data",
                                                        h: this.isHidden(an[0])
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawShape", "polygon", h[ai][0], h[ai][1], false, false, false, this.foreground, "open"],
                                                        a: this.getShapeArea("polygon", h[ai][0], h[ai][1], false, false, false, this.foreground, "open"),
                                                        i: an,
                                                        t: "Data",
                                                        h: this.isHidden(an[0])
                                                    })
                                                }
                                            }
                                        }
                                    } else {
                                        if (CanvasXpress.system.browser == "Firefox") {
                                            b = this.radixSort(b)
                                        } else {
                                            b.sort(function(g, c) {
                                                return N[c] - N[g]
                                            })
                                        }
                                        for (var Y = 0; Y < I.length; Y++) {
                                            var ai = b[Y];
                                            if (this.ellipseBy && ai >= this.varIndices.length) {
                                                var aP = 350;
                                                var aG = 25;
                                                var T = ai - this.varIndices.length;
                                                var aC = ai + 1;
                                                var am = ai + aG;
                                                var aQ = T % aG;
                                                var d = parseInt(T / aP);
                                                var m = (aP * d) + (aP / 2);
                                                var F = m - 24;
                                                var aL = ["Property:" + this.ellipseBy + ":" + this.meta.data.z[this.ellipseBy].levels[d] + ":z"];
                                                var G = this.isHidden(false, false, aL[0]);
                                                if (!aQ && ai + 1 < I.length) {
                                                    this.toRender({
                                                        p: ["drawLine", "line", ae + I[ai][0], U + I[ai][1], ae + I[ai + 1][0], U + I[ai + 1][1], this.colors[d % this.colors.length]],
                                                        a: this.getLineArea("line", ae + I[ai][0], U + I[ai][1], ae + I[ai + 1][0], U + I[ai + 1][1], this.colors[d % this.colors.length]),
                                                        i: aL,
                                                        t: "Data",
                                                        h: G
                                                    })
                                                } else {
                                                    if (parseInt(T / aG) == parseInt((T - 1) / aG) && parseInt(T / aP) == parseInt((T + 1) / aP) && aC < I.length) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", ae + I[ai][0], U + I[ai][1], ae + I[aC][0], U + I[aC][1], this.colors[d % this.colors.length]],
                                                            a: this.getLineArea("line", ae + I[ai][0], U + I[ai][1], ae + I[aC][0], U + I[aC][1], this.colors[d % this.colors.length]),
                                                            i: aL,
                                                            t: "Data",
                                                            h: G
                                                        });
                                                        if (parseInt(T / aP) == parseInt((T + aG) / aP) && am < I.length) {
                                                            if (T < F || T > m) {
                                                                this.toRender({
                                                                    p: ["drawLine", "line", ae + I[ai][0], U + I[ai][1], ae + I[am][0], U + I[am][1], this.colors[d % this.colors.length]],
                                                                    a: this.getLineArea("line", ae + I[ai][0], U + I[ai][1], ae + I[am][0], U + I[am][1], this.colors[d % this.colors.length]),
                                                                    i: aL,
                                                                    t: "Data",
                                                                    h: G
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                var T = this.is3DPlot ? aI[ai][0] : ai;
                                                var an = this.is3DPlot ? [aI[ai][0], aI[ai][1]] : [this.varIndices[ai], this.xAxisIndex, this.yAxisIndex, this.zAxisIndex];
                                                var al = this.getFillColor(this.colorBy ? this.getPropertyValue(this.varIndices[T], null, "colorBy") : this.is3DPlot ? this.colors[T % this.colors.length] : this.colors[0], an);
                                                var ab = I.length > this.scatterOutlineThreshold ? al : this.scatterType && this.scatterType.match(/dot/) ? this.getOutlineColor(this.foreground, an) : this.getOutlineColor(al, an);
                                                var Z = this.getPropertyValue(this.varIndices[T], null, "shapeBy");
                                                var V = this.getPropertyValue(this.varIndices[T], null, "sizeBy");
                                                var W = this.patternBy ? this.getPropertyValue(this.varIndices[T], null, "patternBy") : this.patterns[0];
                                                var ak = this.scatterType && this.scatterType.match(/image/i) ? this.images[ai] : false;
                                                if (ax[ai]) {
                                                    if (this.scatterType && this.scatterType.match(/bar/)) {
                                                        this.draw3DBar(aS[ai][0], aS[ai][1], aS[ai][2], al, an)
                                                    } else {
                                                        if (this.scatterType && this.scatterType.match(/dot/)) {
                                                            var X = ak ? "image" : Z;
                                                            var S = ae + I[ai][0];
                                                            var R = U + I[ai][1];
                                                            var Q = Math.floor(this.percentile(aO[0], aO[1], I[ai][2]));
                                                            this.toRender({
                                                                p: ["drawShape", X, S, R, V, V, al, ab, W, false, false, false, false, false, false, ak],
                                                                a: this.getShapeArea(X, S, R, V, V, al, ab, W, false, false, false, false, false, false, ak),
                                                                i: an,
                                                                t: "Data",
                                                                h: this.isHidden(an[0])
                                                            });
                                                            this.drawSelectedLabel([an[1]], S, R)
                                                        } else {
                                                            var X = ak ? "image" : Z;
                                                            var S = ae + I[ai][0];
                                                            var R = U + I[ai][1];
                                                            var Q = Math.floor(this.percentile(aO[0], aO[1], I[ai][2]));
                                                            this.toRender({
                                                                p: ["drawShape", X, S, R, V, V, al, ab, W, false, false, false, false, false, false, ak],
                                                                a: this.getShapeArea(X, S, R, V, V, al, ab, W, false, false, false, false, false, false, ak),
                                                                i: an,
                                                                t: "Data",
                                                                h: this.isHidden(an[0])
                                                            });
                                                            this.drawSelectedLabel([this.varIndices[ai]], S, R);
                                                            if (this.scatterType && this.scatterType.match(/line/)) {
                                                                E[ai] = [I[ai][0], I[ai][1]]
                                                            } else {
                                                                if (this.connectBy) {
                                                                    if (!this.connectByData[this.data.z[this.connectBy][ai]]) {
                                                                        this.connectByData[this.data.z[this.connectBy][ai]] = []
                                                                    }
                                                                    this.connectByData[this.data.z[this.connectBy][ai]].push([I[ai][0], I[ai][1]])
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (this.scatterType && this.scatterType.match(/line/) && E.length > 0) {
                                            for (var ai = 0; ai < E.length - 1; ai++) {
                                                if (ax[ai] && ax[ai + 1]) {
                                                    var L = ae + E[ai][0];
                                                    var w = U + E[ai][1];
                                                    var K = ae + E[ai + 1][0];
                                                    var u = U + E[ai + 1][1];
                                                    this.toRender({
                                                        p: ["drawLine", "line", L, w, K, u, this.colors[0]],
                                                        t: "Data"
                                                    })
                                                }
                                            }
                                        } else {
                                            if (this.connectBy) {
                                                for (Y in this.connectByData) {
                                                    if (this.connectByData[Y].length > 1) {
                                                        for (var ai = 0; ai < this.connectByData[Y].length - 1; ai++) {
                                                            var L = ae + this.connectByData[Y][ai][0];
                                                            var w = U + this.connectByData[Y][ai][1];
                                                            var K = ae + this.connectByData[Y][ai + 1][0];
                                                            var u = U + this.connectByData[Y][ai + 1][1];
                                                            this.toRender({
                                                                p: ["drawLine", "line", L, w, K, u, this.connectByColor, this.connectByWidth],
                                                                t: "Data"
                                                            })
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (this.decorations && this.decorations.marker) {
                                            this.drawMarkers()
                                        }
                                    }
                                };
                                this.set3DprivateParams = function() {
                                    this.set3DText();
                                    this.set3DParams()
                                };
                                this.draw3DPlot = function() {
                                    this.validatePropertyValues();
                                    this.set3DXYDimensions();
                                    this.set3DprivateParams();
                                    this.set3DRotation();
                                    this.set3DAxes();
                                    this.set3DLayout(true);
                                    this.draw3DDataPoints();
                                    this.set3DLayout();
                                    this.drawLegend();
                                    this.drawTitle()
                                };
                                this.initializeScatter3D = function() {
                                    if (this.layoutValid) {
                                        this.drawLayoutCompartments(this.draw3DPlot)
                                    } else {
                                        this.draw3DPlot()
                                    }
                                };
                                if (!a) {
                                    this.initializeScatter3D()
                                }
                            };
                            CanvasXpress.prototype.oneDPlot = function(a) {
                                this.get1DLeft = function(c) {
                                    var b = this.marginLeft + this.offsetX + this.left;
                                    if (this.isOncoprint && this.showHeatmapOncoprint && c && this.oncoprintHeatmapPosition.match(/right|left/)) {
                                        b += (this.x / 2) + (this.margin * 1)
                                    }
                                    return b
                                };
                                this.get1DTop = function(b) {
                                    var c = this.marginTop + this.offsetY + this.top;
                                    if (this.isOncoprint && this.showHeatmapOncoprint && b && this.oncoprintHeatmapPosition.match(/top|bottom/)) {
                                        c += (this.y / 2) + (this.margin * 1)
                                    }
                                    return c
                                };
                                this.get1DIndices = function() {
                                    return this.isGraphTime ? this.timeValueIndices : this.isGroupedData ? this.grpIndices : this.smpIndices
                                };
                                this.get1DSamples = function() {
                                    return this.isGraphTime ? this.timeValues : this.isGroupedData ? this.data.w.smps : this.data.y.smps
                                };
                                this.get1DLabels = function() {
                                    return this.isGraphTime ? this.timeValues : this.isGroupedData ? this.data.w.smps : false
                                };
                                this.get1DCompBlockMax = function() {
                                    if (this.graphType == "BarLine" || this.graphType == "DotLine") {
                                        var c = this.getVariablesVisibleByAxis("xAxis");
                                        var b = this.getVariablesVisibleByAxis("xAxis2");
                                        return Math.max(c.length, b.length)
                                    } else {
                                        if (this.graphType.match(/Stacked|Line|Area|ParallelCoordinates|Gantt/)) {
                                            return 1
                                        } else {
                                            return this.plotByVariable ? this.get1DIndices().length : this.varIndices.length
                                        }
                                    }
                                };
                                this.setVariableBlock = function() {
                                    this.variableBlock = this.varIndices.length
                                };
                                this.setRowColBlocks = function() {
                                    this.setVariableBlock();
                                    var b = this.isGraphTime ? this.timeValueIndices.length : this.isGroupedData && this.grpIndices ? this.grpIndices.length : this.smpIndices.length;
                                    var e = ["Area", "AreaLine", "Heatmap", "Line", "ParallelCoordinates", "Sankey", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "Tree"];
                                    var d = 0;
                                    var f = 0;
                                    if (this.graphType == "Meter") {
                                        d = 1;
                                        f = 1
                                    } else {
                                        if (this.isOncoprint && this.showHeatmapOncoprint) {
                                            d = b * (this.oncoprintHeatmapPosition.match(/top|bottom/) ? 2 : 1);
                                            f = this.varIndices.length * (this.oncoprintHeatmapPosition.match(/right|left/) ? 2 : 1)
                                        } else {
                                            if (e.includes(this.graphType)) {
                                                d = b;
                                                f = this.graphType == "Heatmap" ? this.varIndices.length : 1
                                            } else {
                                                if (this.graphType == "BarLine" || this.graphType == "DotLine") {
                                                    d = Math.max(this.xAxis.length, this.xAxis2.length) * b;
                                                    f = 1
                                                } else {
                                                    if (this.graphType == "Treemap" || this.graphType == "TagCloud") {
                                                        d = 1;
                                                        f = 1
                                                    } else {
                                                        if (this.graphType == "Gantt") {
                                                            d = b;
                                                            f = 1
                                                        } else {
                                                            d = this.varIndices.length * b;
                                                            f = 1
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    this.rowBlocks = d;
                                    this.colBlocks = f
                                };
                                this.set1DFont = function() {
                                    if (this.autoScaleFont) {
                                        var h = 1 - this.percentAspectRatioPlotArea;
                                        var b = this.layoutComb && this.isDOE ? this.layoutWidth * h : this.width * h;
                                        var i = this.layoutComb && this.isDOE ? this.layoutHeight * h : this.height * h;
                                        var f = this.graphType == "Heatmap" ? Math.ceil(this.width / this.colBlocks) : this.maxTextSize;
                                        var g = this.graphType == "Heatmap" ? Math.ceil(this.height / this.rowBlocks) : Math.ceil(this.width / this.colBlocks);
                                        var c = this.getAxisDescription();
                                        var e = this.getAxisDescription(true);
                                        this.setAxisFont(c.length > e.length ? c : e, this.graphOrientation == "vertical" ? i : b);
                                        this.setPropertyFontSize(this.graphType == "Heatmap" ? i : b, "varTitleFont");
                                        this.setPropertyFontSize(this.graphType == "Heatmap" ? i : b, "varLabelFont", f);
                                        this.setPropertyFontSize(this.graphType == "Heatmap" ? b : this.graphOrientation == "vertical" ? b : i, "smpTitleFont");
                                        this.setPropertyFontSize(this.graphType == "Heatmap" ? b : this.graphOrientation == "vertical" ? b : i, "smpLabelFont", g);
                                        this.setPropertyFontSize((1 - this.percentAspectRatioPlotArea) * (this.graphOrientation == "vertical" ? this.width : this.height), "overlayFont", this.overlaysThickness);
                                        if (this.graphType == "Tree") {
                                            this.smpLabelFont = this.smpLabelFontStyle + " " + parseInt(Math.min(this.treeNodeSize + 3, this.smpLabelFontSize) * this.smpLabelScaleFontFactor) + "px " + this.fontName
                                        }
                                    }
                                };
                                this.setOverlays = function(v) {
                                    var s = this;
                                    var c = {};
                                    var n = this[v + "Overlays"];
                                    var f = this[v + "OverlayProperties"];
                                    var g = v == "smp" ? this.data.x : this.data.z;
                                    var d = v == "smp" ? this.meta.data.x : this.meta.data.z;
                                    var u = (v == "var") || (v == "smp" && this.graphOrientation == "vertical") ? ["Bottom", "Top"] : ["Left", "Right"];
                                    var t = function() {
                                        for (var j = 0; j < n.length; j++) {
                                            if (n[j] != "-" && g.hasOwnProperty(n[j])) {
                                                if (!f[n[j]]) {
                                                    f[n[j]] = {}
                                                }
                                                if (!f[n[j]]["type"]) {
                                                    f[n[j]]["type"] = d[n[j]]["boolean"] ? "Boolean" : "Default"
                                                }
                                                if (!f[n[j]]["color"]) {
                                                    f[n[j]]["color"] = s.colors[j]
                                                }
                                                if (!f[n[j]]["spectrum"]) {
                                                    f[n[j]]["spectrum"] = s.colorSpectrum
                                                }
                                                if (d[n[j]].type == "Numeric" && !s.isSameObject(f[n[j]]["spectrum"], d[n[j]].colorBrew.spectrum)) {
                                                    d[n[j]].colorBrew = s.getColorBrew(f[n[j]]["spectrum"], d[n[j]].rmin, d[n[j]].rmax)
                                                }
                                                if (!f[n[j]]["scheme"]) {
                                                    f[n[j]]["scheme"] = s.colorScheme
                                                }
                                                if (!f[n[j]].hasOwnProperty("showLegend")) {
                                                    f[n[j]]["showLegend"] = true
                                                }
                                                if (!f[n[j]].hasOwnProperty("showName")) {
                                                    f[n[j]]["showName"] = true
                                                }
                                                if (!f[n[j]].hasOwnProperty("showBox")) {
                                                    f[n[j]]["showBox"] = true
                                                }
                                                if (!f[n[j]].hasOwnProperty("rotate")) {
                                                    f[n[j]]["rotate"] = false
                                                }
                                                if (f[n[j]]["scheme"] != s.colorScheme) {
                                                    if (CanvasXpress.colorSchemes.hasOwnProperty(f[n[j]]["scheme"])) {
                                                        s.modifyColorProperties(f[n[j]]["scheme"], n[j], v == "smp" ? "x" : "z", true)
                                                    }
                                                }
                                                if (!f[n[j]]["position"]) {
                                                    if (s.graphType == "Heatmap" || s.graphOrientation == "horizontal") {
                                                        f[n[j]]["position"] = v == "smp" ? "left" : "bottom"
                                                    } else {
                                                        f[n[j]]["position"] = "bottom"
                                                    }
                                                } else {
                                                    if ((v == "var") || (v == "smp" && s.graphOrientation == "vertical")) {
                                                        if (!f[n[j]]["position"].match(/top|bottom/)) {
                                                            f[n[j]]["position"] = f[n[j]]["position"] == "rigth" ? "top" : "bottom"
                                                        }
                                                    } else {
                                                        if (!f[n[j]]["position"].match(/left|right/)) {
                                                            f[n[j]]["position"] = f[n[j]]["position"] == "top" ? "right" : "left"
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    };
                                    var q = function() {
                                        var x = [];
                                        var m = [];
                                        var y = {};
                                        var z = false;
                                        var k = false;
                                        for (var w = 0; w < n.length; w++) {
                                            if (n[w] != "-") {
                                                z = n[w];
                                                if (!k) {
                                                    k = n[w]
                                                }
                                            }
                                            if (n[w] == "-" && z) {
                                                if (!y.hasOwnProperty(z)) {
                                                    y[z] = []
                                                }
                                                y[z].push(n[w])
                                            }
                                        }
                                        for (var w = 0; w < n.length; w++) {
                                            if (n[w] != "-" && f[n[w]]["position"].match(/left|bottom/)) {
                                                x.push(n[w])
                                            }
                                        }
                                        for (var w = 0; w < n.length; w++) {
                                            if (n[w] != "-" && f[n[w]]["position"].match(/right|top/)) {
                                                x.push(n[w])
                                            }
                                        }
                                        for (var w = 0; w < x.length; w++) {
                                            z = x[w];
                                            m.push(z);
                                            if (y.hasOwnProperty(z)) {
                                                for (var p = 0; p < y[z].length; p++) {
                                                    m.push(y[z][p])
                                                }
                                            }
                                        }
                                        z = n.shift();
                                        if (z == "-") {
                                            for (var w = 0; w < m.length; w++) {
                                                if (m[w] == k) {
                                                    while (z == "-") {
                                                        m.splice(w, 0, z);
                                                        z = n.shift()
                                                    }
                                                    break
                                                }
                                            }
                                        }
                                        n = m;
                                        s[v + "Overlays"] = m
                                    };
                                    if (this.isDOE) {} else {
                                        t();
                                        q()
                                    }
                                    this[v + "OverlaysStrLength"] = 0;
                                    for (var o = 0; o < u.length; o++) {
                                        var b = u[o].toLowerCase();
                                        var r = false;
                                        this[v + "OverlaysThickness" + u[o]] = 0;
                                        if (this.showOverlays && n.length > 0) {
                                            if (v == "smp") {
                                                if (this.graphType == "Treemap" || this.graphType == "TagCloud") {
                                                    continue
                                                }
                                            } else {
                                                if (v == "var") {
                                                    if (this.graphType != "Heatmap") {
                                                        continue
                                                    }
                                                } else {
                                                    continue
                                                }
                                            }
                                            for (var l = 0; l < n.length; l++) {
                                                if (n[l] == "-") {
                                                    if (l > 0 && r == b) {
                                                        this[v + "OverlaysThickness" + u[o]] += this.margin
                                                    }
                                                } else {
                                                    if (!c.hasOwnProperty(n[l])) {
                                                        r = f[n[l]]["position"];
                                                        if (r == b) {
                                                            var e = this.getOverlaysForTypePosition(v, f[n[l]]["type"], b, n[l]);
                                                            this[v + "OverlaysThickness" + u[o]] += f[n[l]]["thickness"] || this.overlaysThickness;
                                                            for (var h = 0; h < e.length; h++) {
                                                                this[v + "OverlaysStrLength"] = Math.max(this[v + "OverlaysStrLength"], this.measureText(this.shortenText(e[h], this.maxOverlayStringLen), this.overlayFont) + this.margin);
                                                                c[e[h]] = true
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            if (this[v + "OverlaysThickness" + u[o]] > 0) {
                                                this[v + "OverlaysThickness" + u[o]] += this.margin
                                            }
                                        }
                                    }
                                };
                                this.getOverlaysForTypePosition = function(h, e, k, f) {
                                    var b = [];
                                    var l = h == "smp" ? this.smpOverlayProperties : this.varOverlayProperties;
                                    var g = h == "smp" ? this.smpOverlays : this.varOverlays;
                                    for (var j = 0; j < g.length; j++) {
                                        var d = g[j];
                                        if (d != "-" && l.hasOwnProperty(d)) {
                                            var m = l[d]["type"];
                                            var c = l[d]["position"];
                                            if (k.match(/left|bottom/) && !c.match(/left|bottom/)) {
                                                continue
                                            } else {
                                                if (k.match(/top|right/) && !c.match(/top|right/)) {
                                                    continue
                                                }
                                            }
                                            if (e.match(/Area|AreaLine/) && m.match(/Area|AreaLine/)) {
                                                b.push(d)
                                            } else {
                                                if (e.match(/Bar|BarLine/) && m.match(/Bar|BarLine/)) {
                                                    b.push(d)
                                                } else {
                                                    if (e.match(/Dotplot|DotLine/) && m.match(/Dotplot|DotLine/)) {
                                                        b.push(d)
                                                    } else {
                                                        if (e == "Line" && m == "Line") {
                                                            b.push(d)
                                                        } else {
                                                            if (e.match(/Heatmap|Default|Text|Boolean/)) {
                                                                return [f]
                                                            } else {
                                                                if (e == "Pie" && m == "Pie") {
                                                                    b.push(d)
                                                                } else {
                                                                    if (e == "Treemap" && m == "Treemap") {
                                                                        b.push(d)
                                                                    } else {
                                                                        if ((e == "StackedPercent" || e == "StackedPercentLine") && (m == "StackedPercent" || m == "StackedPercentLine")) {
                                                                            b.push(d)
                                                                        } else {
                                                                            if ((e == "Stacked" || e == "StackedLine") && (m == "Stacked" || m == "StackedLine")) {
                                                                                b.push(d)
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return b
                                };
                                this.getVariableTitleHeight = function() {
                                    if (this.varTitle && this.graphType != "Treemap" && this.graphType != "TagCloud") {
                                        return this.varTitleFontSize + this.margin
                                    } else {
                                        return 0
                                    }
                                };
                                this.getVariableLabelLength = function() {
                                    if (this.showVariableNames && this.graphType != "Treemap" && this.graphType != "TagCloud") {
                                        if (this.varLabelRotate) {
                                            if (Math.abs(this.varLabelRotate) == 90) {
                                                return this.varLabelFontSize + this.margin
                                            } else {
                                                var b = this.measureText(this.shortenText(this.meta.data.y.maxVarStr, this.maxVarStringLen), this.varLabelFont) + this.margin;
                                                return Math.cos(this.radians(this.varLabelRotate)) * b
                                            }
                                        } else {
                                            if (this.isOncoprint && this.varLabelFontSize < 5) {
                                                return 0
                                            } else {
                                                return this.measureText(this.shortenText(this.meta.data.y.maxVarStr, this.maxVarStringLen), this.varLabelFont) + this.margin
                                            }
                                        }
                                    } else {
                                        return 0
                                    }
                                };
                                this.getSampleTitleHeight = function() {
                                    if (this.smpTitle && this.graphType != "Treemap" && this.graphType != "TagCloud" && this.graphType != "Sankey" && this.graphType != "Tree") {
                                        return this.smpTitleFontSize + this.margin
                                    } else {
                                        return 0
                                    }
                                };
                                this.getSampleLabelLength = function() {
                                    var c = this;
                                    if (this.showSampleNames && this.graphType != "Treemap" && this.graphType != "TagCloud" && this.graphType != "Sankey") {
                                        var d = function() {
                                            if (c.smpLabelScaleFontFactor <= 1.5) {
                                                return 1
                                            } else {
                                                if (c.smpLabelScaleFontFactor <= 2.5) {
                                                    return 1.2
                                                } else {
                                                    if (c.smpLabelScaleFontFactor <= 4.5) {
                                                        return 1.5
                                                    } else {
                                                        return 1.6
                                                    }
                                                }
                                            }
                                        };
                                        var b;
                                        if (this.smpLabelRotate && Math.abs(this.smpLabelRotate) == 90) {
                                            if (this.isGroupedData) {
                                                b = this.isArray(this.meta.data.w.maxSmpStr) ? (this.meta.data.w.maxSmpStr.toString()[0].split(" :: ")).length : (this.meta.data.w.maxSmpStr.toString().split(" :: ")).length;
                                                return b * (this.smpLabelFontSize + this.margin)
                                            } else {
                                                return this.smpLabelFontSize + this.margin
                                            }
                                        } else {
                                            if (this.layoutValid && !this.layoutAdjust) {
                                                b = this.isGroupedData && this.meta.data.g ? this.getMaxText(this.meta.data.g.smps) : this.meta.data.y.maxSmpStr
                                            } else {
                                                if (this.isGraphTime) {
                                                    b = this.getMaxText(this.timeValues)
                                                } else {
                                                    b = this.isGroupedData ? this.meta.data.w.maxSmpStr : this.meta.data.y.maxSmpStr
                                                }
                                            }
                                            if (b.length > this.maxSmpStringLen) {
                                                b = this.measureText(b.substring(0, this.maxSmpStringLen), this.smpLabelFont) + (this.margin * 2)
                                            } else {
                                                b = this.measureText(b, this.smpLabelFont) + (this.margin * 2)
                                            }
                                            b = this.smpLabelRotate ? b * (Math.cos(this.radians(this.smpLabelRotate))) * d() : b;
                                            return b + this.margin + (this.smpLabelRotate ? this.smpLabelFontSize : 0)
                                        }
                                    } else {
                                        return 0
                                    }
                                };
                                this.getAxisTitleLayoutLength = function(b) {
                                    var c = b ? "xAxis2Title" : "xAxisTitle";
                                    if (this.layoutConfig && this.layoutConfig[this.layoutCurrent] && this.layoutConfig[this.layoutCurrent][c]) {
                                        return this.axisTitleFontSize
                                    } else {
                                        return 0
                                    }
                                };
                                this.getAxisTitleTickLength = function(o, d) {
                                    if (this.graphType == "Treemap" || this.graphType == "TagCloud" || this.graphType == "Sankey" || this.graphType == "Tree") {
                                        return 0
                                    } else {
                                        if (this.graphOrientation == "vertical") {
                                            var g, m, f, c;
                                            if (((this.xAxisTransform && this.xAxisTransform.match(/log|exp/)) || (this.isTransformedData && this.isTransformedData.match(/log|exp/))) && !this.xAxisTransformTicks) {
                                                var l = this.xAxisValues;
                                                var k = this.xAxis2Values;
                                                var n = [];
                                                for (var e = 0; e < l.length; e++) {
                                                    var b = l[e];
                                                    n.push(this.formatNumber(this.transformValue(this.xAxisTransform || this.isTransformedData, b, true)))
                                                }
                                                f = this.getMaxText(n);
                                                var h = [];
                                                for (var e = 0; e < k.length; e++) {
                                                    var b = k[e];
                                                    h.push(this.transformValue(this.xAxis2Transform || this.isTransformedData, b, true))
                                                }
                                                c = this.getMaxText(h)
                                            } else {
                                                f = this.xAxisMaxStrLength;
                                                c = this.xAxis2MaxStrLength
                                            }
                                            if (this.layoutValid) {
                                                if (this.xAxisLayoutMaxTickStr) {
                                                    f = this.xAxisLayoutMaxTickStr
                                                }
                                                if (this.xAxis2LayoutMaxTickStrLength) {
                                                    c = this.xAxis2LayoutMaxTickStr
                                                }
                                            }
                                            if (this.graphType == "ParallelCoordinates") {
                                                if (this.smpLabelRotate) {
                                                    if (this.smpLabelRotate == 90) {
                                                        g = Math.max(this.parallelCoordinates[0].len, this.parallelCoordinates[0].lenSmp / 2)
                                                    } else {
                                                        g = Math.max(this.parallelCoordinates[0].len, this.parallelCoordinates[0].lenSmp * (Math.sin(this.radians(this.smpLabelRotate))))
                                                    }
                                                } else {
                                                    g = this.parallelCoordinates[0].len
                                                }
                                            } else {
                                                if (this.graphType == "BarLine" || this.graphType == "DotLine") {
                                                    g = o ? this.measureText(c, this.axisTickFont) : this.measureText(f, this.axisTickFont)
                                                } else {
                                                    g = this.measureText(f, this.axisTickFont)
                                                }
                                            }
                                            m = o ? this.getAxisDescription(true) : this.getAxisDescription();
                                            m = this.layoutValid ? this.getAxisTitleLayoutLength(o) : m != "" ? this.axisTitleFontSize : 0;
                                            if (d) {
                                                m = 0
                                            }
                                            if (o) {
                                                if (this.graphType == "ParallelCoordinates") {
                                                    if (this.smpLabelRotate && this.smpLabelRotate == 90) {
                                                        return this.parallelCoordinates[this.parallelCoordinates.length - 1].lenSmp
                                                    } else {
                                                        return 0
                                                    }
                                                } else {
                                                    return this.xAxis2Show ? m + g + (this.margin * 4) : 0
                                                }
                                            } else {
                                                if (this.graphType == "ParallelCoordinates") {
                                                    return m + g + (this.margin * 4)
                                                } else {
                                                    return this.xAxisShow ? m + g + (this.margin * 4) : 0
                                                }
                                            }
                                        } else {
                                            m = o ? this.getAxisDescription(true) : this.getAxisDescription();
                                            m = this.layoutValid ? this.getAxisTitleLayoutLength(o) : m != "" ? this.axisTitleFontSize : 0;
                                            if (d) {
                                                m = 0
                                            }
                                            if (o) {
                                                return this.xAxis2Show ? m + (this.axisTickFontSize + (this.margin * 4) * (this.graphType == "Gantt" ? 2 : 1)) : 0
                                            } else {
                                                return this.xAxisShow ? m + (this.axisTickFontSize + (this.margin * 4) * (this.graphType == "Gantt" ? 2 : 1)) : 0
                                            }
                                        }
                                    }
                                };
                                this.getHeatmapIndicatorWidth = function() {
                                    if (this.showHeatmapIndicator) {
                                        var b = this.getDefaultMetaDataObject();
                                        var c = this.xAxisTitle ? this.measureText(this.xAxisTitle, this.legendFont) : 0;
                                        if (this.heatmapIndicatorPosition == "right") {
                                            return Math.max(c, this.heatmapIndicatorHeight + (this.margin * 2) + b.maxLevLen)
                                        } else {
                                            return Math.max(c, this.heatmapIndicatorWidth + b.maxLevLen)
                                        }
                                    } else {
                                        return 0
                                    }
                                };
                                this.getHeatmapIndicatorHeight = function(b) {
                                    if (this.showHeatmapIndicator) {
                                        var e = (this.margin * 2) + this.getFontPt(this.legendFont);
                                        var c = this.xAxisTitle ? (this.margin * 2) + this.getFontPt(this.legendFont) : 0;
                                        if (b && this.isMultidimensionalData && this.heatmapIndicatorPosition == "bottom") {
                                            return this.legendInside ? 0 : this.heatmapIndicatorHeight + c + e
                                        } else {
                                            return this.heatmapIndicatorHeight + c + e
                                        }
                                    } else {
                                        return 0
                                    }
                                };
                                this.getLegendHeight = function(e) {
                                    var c = this.isOncoprint ? this.legendOncoprintHeight : 0;
                                    var b = this.showLegend && this.legendPosition == e && !this.legendInside;
                                    var d = (this.showVarOverlaysLegend || this.showSmpOverlaysLegend) && this.overlaysLegendPosition.match(/bottom/i);
                                    if (this.graphType == "Heatmap" && !this.isMultidimensionalData && !this.isAttributedGraph()) {
                                        if (b) {
                                            c += this.legendHeight
                                        }
                                        if (d) {
                                            c += this.legendOverlaysHeight
                                        }
                                    } else {
                                        if (this.isMultidimensionalData || (this.isAttributedGraph() && CanvasXpress.graphTypes.AttGraphs.includes(this.graphType))) {
                                            if (b) {
                                                c += this.legendHeight
                                            }
                                            if (d) {
                                                c += this.legendOverlaysHeight
                                            }
                                        } else {
                                            if (this.graphType == "Treemap") {} else {
                                                if (b) {
                                                    c += this.legendVariableHeight + this.margin
                                                }
                                                if (d) {
                                                    c += this.legendOverlaysHeight
                                                }
                                            }
                                        }
                                    }
                                    return c
                                };
                                this.getLegendWidth = function(e) {
                                    var c = 0;
                                    var b = this.showLegend && this.legendPosition == e && !this.legendInside;
                                    var d = (this.showVarOverlaysLegend || this.showSmpOverlaysLegend) && this.overlaysLegendPosition.toLowerCase().match(e ? e.toLowerCase() : "");
                                    if (this.graphType == "Heatmap" && !this.isMultidimensionalData && !this.isAttributedGraph()) {
                                        if (b) {
                                            c += this.legendWidth
                                        }
                                        if (d) {
                                            c += this.legendOverlaysWidth
                                        }
                                    } else {
                                        if (this.isMultidimensionalData || (this.isAttributedGraph() && CanvasXpress.graphTypes.AttGraphs.includes(this.graphType))) {
                                            if (b) {
                                                c += this.legendWidth
                                            }
                                            if (d) {
                                                c += this.legendOverlaysWidth
                                            }
                                        } else {
                                            if (this.graphType == "Treemap") {} else {
                                                if (b) {
                                                    c += this.legendVariableWidth + this.margin
                                                }
                                                if (d) {
                                                    c += this.legendOverlaysWidth
                                                }
                                            }
                                        }
                                    }
                                    return c
                                };
                                this.getVarTreeHeight = function() {
                                    var b = 0;
                                    if (this.graphType == "Heatmap" && this.showVarDendrogram && this.varDendrogram) {
                                        b = this.dendrogramHeight + this.margin
                                    }
                                    return b
                                };
                                this.getSmpTreeWidthHeight = function() {
                                    var b = 0;
                                    if (this.showSmpDendrogram && this.smpDendrogram && !this.isGroupedData && this.graphType != "Treemap" && this.graphType != "TagCloud") {
                                        b = this.dendrogramHeight + this.margin
                                    }
                                    return b
                                };
                                this.getOverlaysTickLabelsLength = function() {
                                    var d = 0;
                                    if (this.smpOverlays.length > 0) {
                                        var b = this.meta.data.x;
                                        var c = [];
                                        for (var f = 0; f < this.smpOverlays.length; f++) {
                                            var h = this.smpOverlays[f];
                                            if (h != "-") {
                                                var g = this.smpOverlayProperties[h].position;
                                                var e = this.smpOverlayProperties[h].type;
                                                if (g.match(/left|right/i) && !e.match(/text|default|increase|decrease/i)) {
                                                    c.push(b[h].min);
                                                    c.push(b[h].max)
                                                }
                                            }
                                        }
                                        d = this.measureText(this.getMaxText(c), this.overlayFont)
                                    }
                                    return d ? d + (this.margin * 3) : 0
                                };
                                this.getTreeRootLabelLength = function() {
                                    return this.measureText(this.hierarchy[0], this.smpLabelFont)
                                };
                                this.set1DXYDimensionsLeft = function() {
                                    var b = 0;
                                    if (this.graphOrientation == "vertical") {
                                        b = this.getAxisTitleTickLength(false, this.layoutValid);
                                        if (this.layoutValid) {
                                            if (this.isDOE) {} else {}
                                        } else {}
                                    } else {
                                        if (this.layoutValid) {
                                            if (this.isDOE) {} else {}
                                        } else {
                                            if (this.smpOverlaysThicknessLeft) {
                                                b += this.smpOverlaysThicknessLeft
                                            }
                                            if (this.smpTitleLabelPosition == "left") {
                                                b += this.getSampleTitleHeight() + this.getSampleLabelLength()
                                            }
                                            if (this.smpDendrogramPosition == "left") {
                                                b += this.getSmpTreeWidthHeight()
                                            }
                                        }
                                    }
                                    b += this.margin + this.getLegendWidth("left");
                                    if (this.layoutValid && this.layoutCollapse) {
                                        b -= this.margin
                                    }
                                    this.left = Math.max(b, this.getOverlaysTickLabelsLength())
                                };
                                this.set1DXYDimensionsRight = function() {
                                    var b = 0;
                                    if (this.graphOrientation == "vertical") {
                                        b = this.getAxisTitleTickLength(true, this.layoutValid);
                                        if (this.layoutValid) {
                                            if (this.isDOE) {} else {}
                                        } else {}
                                    } else {
                                        if (this.layoutValid) {
                                            if (this.isDOE) {} else {}
                                        } else {
                                            if (this.smpOverlaysThicknessRight) {
                                                b += this.smpOverlaysThicknessRight
                                            }
                                            if (this.graphType == "Tree" || this.smpTitleLabelPosition == "right") {
                                                b += this.getSampleTitleHeight() + this.getSampleLabelLength()
                                            }
                                            if (this.smpDendrogramPosition == "right") {
                                                b += this.getSmpTreeWidthHeight()
                                            }
                                        }
                                    }
                                    b += this.margin + this.getLegendWidth("right");
                                    if (this.layoutValid && this.layoutCollapse) {
                                        b -= this.margin
                                    }
                                    if (this.graphType == "Heatmap" && this.heatmapIndicatorPosition == "right") {
                                        b += this.getHeatmapIndicatorWidth()
                                    }
                                    if (this.graphType == "Heatmap" && this.showOverlays && this.varOverlays.length && !this.isOncoprint) {
                                        b = Math.max(b, this.varOverlaysStrLength)
                                    } else {
                                        if (this.graphOrientation == "vertical" && this.smpOverlays.length && this.showOverlays) {
                                            b = Math.max(b, this.smpOverlaysStrLength)
                                        }
                                    }
                                    this.right = b
                                };
                                this.set1DXYDimensionsTop = function() {
                                    var c = this.getTitleSubtitleHeight();
                                    c += this.margin + this.getLegendHeight("top");
                                    if (this.isDOE) {
                                        c += this.margin * 5
                                    } else {
                                        if (this.layoutValid && this.layoutType == "wrap") {
                                            c += (this.layoutLabelBoxThickness * (this.segregateVariablesBy.length + this.segregateSamplesBy.length)) - this.margin
                                        }
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        c += this.smpOverlaysThicknessTop;
                                        if (this.smpDendrogramPosition == "top" || this.smpDendrogramPosition == "left") {
                                            c += this.getSmpTreeWidthHeight()
                                        }
                                        if (this.graphType == "Tree") {
                                            c += this.smpLabelFontSize
                                        }
                                    } else {
                                        if (this.graphType == "Heatmap") {
                                            var b = this.layoutValid ? this.margin : this.getHeatmapIndicatorHeight();
                                            var d = this.varOverlaysThicknessTop;
                                            if (this.varTitleLabelPosition == "top") {
                                                d += this.getVariableTitleHeight() + this.getVariableLabelLength()
                                            }
                                            if (this.varDendrogramPosition == "top") {
                                                d += this.getVarTreeHeight()
                                            }
                                            this.heatmapIndicatorY = c + d;
                                            if (!this.isOncoprint) {
                                                if (this.heatmapIndicatorPosition == "right") {
                                                    c += d
                                                } else {
                                                    if (this.heatmapIndicatorPosition == "top") {
                                                        c += d + b
                                                    } else {
                                                        if (this.heatmapIndicatorPosition == "topLeft") {
                                                            if (this.left > (this.heatmapIndicatorWidth + (this.margin * 6))) {
                                                                c += d
                                                            } else {
                                                                this.heatmapIndicatorY = d + b;
                                                                c += d + b
                                                            }
                                                        } else {
                                                            if (this.heatmapIndicatorPosition == "topRight") {
                                                                if (this.right > (this.heatmapIndicatorWidth + (this.margin * 6))) {
                                                                    c += d
                                                                } else {
                                                                    this.heatmapIndicatorY = d;
                                                                    c += d + b
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            c += this.getAxisTitleTickLength()
                                        }
                                    }
                                    if (this.layoutValid && this.layoutCollapse && this.layoutType != "wrap") {
                                        c -= this.margin * 1
                                    }
                                    this.top = Math.max(c, this.getOverlaysTickLabelsLength())
                                };
                                this.set1DXYDimensionsBottom = function() {
                                    var c = 0;
                                    if (this.isDOE) {
                                        c += this.margin * 3
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        c += this.getSampleTitleHeight() + this.getSampleLabelLength() + this.smpOverlaysThicknessBottom;
                                        if (this.smpDendrogramPosition == "bottom") {
                                            c += this.getSmpTreeWidthHeight()
                                        }
                                    } else {
                                        if (this.graphType == "Heatmap") {
                                            c += this.varOverlaysThicknessBottom;
                                            if (this.varTitleLabelPosition == "bottom") {
                                                c += this.getVariableLabelLength() + this.getVariableTitleHeight()
                                            }
                                            if (this.varDendrogramPosition == "bottom") {
                                                c += this.getVarTreeHeight()
                                            }
                                        } else {
                                            c += this.getAxisTitleTickLength(true) + this.getLegendHeight("bottom")
                                        }
                                    }
                                    c += this.margin + this.getLegendHeight("bottom");
                                    if (this.layoutValid && this.layoutCollapse) {
                                        c -= this.margin
                                    }
                                    if (this.graphOrientation == "horizontal" && this.showOverlays && this.smpOverlays.length) {
                                        c = Math.max(c, this.smpOverlaysStrLength)
                                    }
                                    if (!this.layoutValid && this.citation) {
                                        c += this.getCitationHeight()
                                    }
                                    this.bottom = c
                                };
                                this.adjustLegendFontSize = function() {
                                    var b = this.meta.config.orig;
                                    if (!b.legendFontSize && this.adjustAspectRatio) {
                                        b.legendFontSize = this.legendFontSize
                                    }
                                    if (this.legendFontSize > 3) {
                                        this.legendFontSize -= 2
                                    }
                                };
                                this.adjustSmpFontSize = function() {
                                    if (this.adjustAspectRatio) {
                                        var c = this.meta.config.orig;
                                        this.smpLabelFontSize = parseInt(this.smpLabelFontSize * 0.8);
                                        var b = Math.min(Math.max(parseInt(this.smpLabelFontSize * this.smpLabelScaleFontFactor), this.minTextSize), this.maxTextSize);
                                        if (this.smpLabelFontSize < this.minTextSize) {
                                            if (this.graphType == "Heatmap") {
                                                if (this.rowBlockSize && b > this.rowBlockSize) {
                                                    if (!c.showSampleNames) {
                                                        c.showSampleNames = this.showSampleNames;
                                                        this.showSampleNames = false
                                                    }
                                                }
                                            } else {
                                                if (!c.showSampleNames) {
                                                    c.showSampleNames = this.showSampleNames;
                                                    this.showSampleNames = false
                                                }
                                            }
                                        }
                                        this.smpLabelFont = this.smpLabelFontStyle + " " + b + "px " + this.fontName
                                    }
                                };
                                this.adjustVarFontSize = function() {
                                    if (this.adjustAspectRatio) {
                                        var b = this.meta.config.orig;
                                        this.varLabelFontSize = parseInt(this.varLabelFontSize * 0.8);
                                        if (this.varLabelFontSize < this.minTextSize) {
                                            if (!b.showVariableNames) {
                                                b.showVariableNames = this.showVariableNames;
                                                this.showVariableNames = false
                                            }
                                        }
                                        this.varLabelFont = this.varLabelFontStyle + " " + Math.min(Math.max(parseInt(this.varLabelFontSize * this.varLabelScaleFontFactor), this.minTextSize), this.maxTextSize) + "px " + this.fontName
                                    }
                                };
                                this.adjust1DYDimension = function() {
                                    var b = this.layoutComb ? this.layoutHeight * this.percentAspectRatioPlotArea : this.height * this.percentAspectRatioPlotArea;
                                    var c = this.meta.config.orig;
                                    while (this.adjustAspectRatioYTries <= this.adjustAspectRatioMax && this.y < b) {
                                        this.adjustLegendFontSize();
                                        if (!this.layoutComb) {
                                            this.setLegends()
                                        }
                                        this.adjustVarFontSize();
                                        if (this.graphType != "Heatmap") {
                                            this.adjustSmpFontSize()
                                        }
                                        this.set1DXYDimensionsTop();
                                        this.set1DXYDimensionsBottom();
                                        this.y = this.layoutComb ? this.layoutHeight - (this.top + this.bottom) : this.height - (this.marginTop + this.top + this.bottom + this.marginBottom);
                                        if (this.adjustAspectRatioYTries == this.adjustAspectRatioMax && this.y < b) {
                                            if (this.showLegend && (this.legendPosition == "top" || this.legendPosition == "bottom") && !this.legendInside) {
                                                c.showLegend = this.showLegend;
                                                this.showLegend = false;
                                                this.set1DFont()
                                            }
                                            this.set1DXYDimensionsTop();
                                            this.set1DXYDimensionsBottom();
                                            this.y = this.layoutComb ? this.layoutHeight - (this.top + this.bottom) : this.height - (this.marginTop + this.top + this.bottom + this.marginBottom);
                                            if (this.y < b) {
                                                this.errors.push("The text size doesn't fit in the graph. Either make it smaller or make the graph bigger!\nYou can also reduce the maximum length for the text string!")
                                            }
                                        }
                                        this.adjustAspectRatioYTries++
                                    }
                                };
                                this.adjust1DXDimension = function() {
                                    var b = this.layoutComb ? this.layoutWidth * this.percentAspectRatioPlotArea : this.width * this.percentAspectRatioPlotArea;
                                    var c = this.meta.config.orig;
                                    while (this.adjustAspectRatioXTries <= this.adjustAspectRatioMax && this.x < b) {
                                        this.adjustLegendFontSize();
                                        if (!this.layoutComb) {
                                            this.setLegends()
                                        }
                                        if (this.graphType != "Heatmap") {
                                            this.adjustVarFontSize()
                                        }
                                        this.adjustSmpFontSize();
                                        this.set1DXYDimensionsLeft();
                                        this.set1DXYDimensionsRight();
                                        this.x = this.layoutComb ? this.layoutWidth - (this.left + this.right) : this.width - (this.marginLeft + this.left + this.right + this.marginRight);
                                        if (this.adjustAspectRatioXTries == this.adjustAspectRatioMax && this.x < b) {
                                            if (this.showLegend && (this.legendPosition == "right" || this.legendPosition == "left") && !this.legendInside) {
                                                c.showLegend = this.showLegend;
                                                this.showLegend = false;
                                                this.set1DFont()
                                            }
                                            this.set1DXYDimensionsLeft();
                                            this.set1DXYDimensionsRight();
                                            this.x = this.layoutComb ? this.layoutWidth - (this.left + this.right) : this.width - (this.marginLeft + this.left + this.right + this.marginRight);
                                            if (this.x < b) {
                                                this.errors.push("The text size doesn't fit in the graph. Either make it smaller or make the graph bigger!\nYou can also reduce the maximum length for the text string!")
                                            }
                                        }
                                        this.adjustAspectRatioXTries++
                                    }
                                };
                                this.set1DXYDimensions = function() {
                                    var d = this.layoutComb ? this.layoutWidth * this.percentAspectRatioPlotArea : this.width * this.percentAspectRatioPlotArea;
                                    var c = this.layoutComb ? this.layoutHeight * this.percentAspectRatioPlotArea : this.height * this.percentAspectRatioPlotArea;
                                    if (this.isGraphTime) {
                                        this.setTimeAxis()
                                    }
                                    if (!this.layoutComb) {
                                        this.setLegends()
                                    }
                                    this.setRowColBlocks();
                                    this.set1DFont();
                                    if (this.graphType == "Meter") {
                                        var g = 2;
                                        var e = this.getAxisTitleTickLength() + (this.margin * g);
                                        var f = (this.layoutComb ? this.layoutHeight : this.width) - ((e * 2) + this.meterThickness);
                                        var b = this.meterType == "state" ? this.meterThickness * 4 : f;
                                        this.top = this.layoutValid ? (this.margin * g) : this.getTitleSubtitleHeight() + (this.margin * g);
                                        this.bottom = (this.margin * g);
                                        switch (this.meterType) {
                                            case "gauge":
                                                this.left = e;
                                                this.right = e;
                                                break;
                                            case "speedometer":
                                                this.left = e;
                                                this.right = e;
                                                break;
                                            case "horizontal":
                                                this.left = (this.margin * g * 6);
                                                this.right = (this.margin * g * 6);
                                                this.top *= 24;
                                                this.bottom = this.top;
                                                break;
                                            case "vertical":
                                                this.left = f / 2;
                                                this.right = f / 2;
                                                this.top += (this.margin * g * 6);
                                                this.bottom += (this.margin * g * 6);
                                                break;
                                            case "state":
                                                this.left = f / 2;
                                                this.right = f / 2;
                                                this.top += b / 4;
                                                this.bottom += b / 4;
                                                break;
                                            case "digital":
                                                this.left = (this.margin * g);
                                                this.right = (this.margin * g);
                                                break
                                        }
                                        this.y = this.layoutComb ? this.layoutHeight - (this.top + this.bottom) : this.height - (this.marginTop + this.top + this.bottom + this.marginBottom);
                                        this.x = this.layoutComb ? this.layoutWidth - (this.left + this.right) : this.width - (this.marginLeft + this.left + this.right + this.marginRight)
                                    } else {
                                        if (this.graphOrientation == "vertical") {
                                            this.set1DXYDimensionsTop();
                                            this.set1DXYDimensionsBottom();
                                            if (this.adjustAspectRatio) {
                                                this.y = this.layoutComb ? this.layoutHeight - (this.top + this.bottom) : this.height - (this.marginTop + this.top + this.bottom + this.marginBottom);
                                                if (this.y < c) {
                                                    this.adjust1DYDimension()
                                                }
                                            }
                                            this.set1DXYDimensionsLeft();
                                            this.set1DXYDimensionsRight();
                                            if (this.adjustAspectRatio) {
                                                this.x = this.layoutComb ? this.layoutWidth - (this.left + this.right) : this.width - (this.marginLeft + this.left + this.right + this.marginRight);
                                                if (this.x < d) {
                                                    this.adjust1DXDimension()
                                                }
                                            }
                                        } else {
                                            this.set1DXYDimensionsLeft();
                                            this.set1DXYDimensionsRight();
                                            if (this.adjustAspectRatio) {
                                                this.x = this.layoutComb ? this.layoutWidth - (this.left + this.right) : this.width - (this.marginLeft + this.left + this.right + this.marginRight);
                                                if (this.x < d) {
                                                    this.adjust1DXDimension()
                                                }
                                            }
                                            this.set1DXYDimensionsTop();
                                            this.set1DXYDimensionsBottom();
                                            if (this.adjustAspectRatio) {
                                                this.y = this.layoutComb ? this.layoutHeight - (this.top + this.bottom) : this.height - (this.marginTop + this.top + this.bottom + this.marginBottom);
                                                if (this.y < c) {
                                                    this.adjust1DYDimension()
                                                }
                                            }
                                        }
                                    }
                                };
                                this.set1DPrivateParamsManual = function() {
                                    var b = this.isGraphTime ? this.timeValueIndices.length : this.isGroupedData ? this.grpIndices.length : this.smpIndices.length;
                                    this.rowBlockSize = this.widthFactor * (this.scaleTextToSize(this.rowBlocks) + this.scaleTextConstantAdd);
                                    if (this.graphType == "Heatmap") {
                                        if (this.colBlocks < 20) {
                                            this.colBlockSize = this.scaleTextToSize(this.colBlocks) + (this.scaleTextConstantAdd * 4)
                                        } else {
                                            this.colBlockSize = (parseInt(1 / Math.sqrt(this.colBlocks) * this.scaleTextConstantMult)) + 1
                                        }
                                        this.colBlockSize *= this.widthFactor;
                                        this.blockSeparation = this.rowBlockSize / 2;
                                        this.y = (this.rowBlockSize * this.rowBlocks) + (this.isOncoprint && this.showHeatmapOncoprint && this.oncoprintHeatmapPosition.match(/top|bottom/) ? (this.margin * 3) : 0);
                                        this.x = (this.colBlockSize * this.colBlocks) + (this.isOncoprint && this.showHeatmapOncoprint && this.oncoprintHeatmapPosition.match(/right|left/) ? (this.margin * 3) : 0)
                                    } else {
                                        this.blockSeparation = this.rowBlockSize * this.sampleSpaceFactor;
                                        if (this.graphOrientation == "vertical") {
                                            if (this.graphType.match(/Area|ParallelCoordinates/)) {
                                                this.x = (this.rowBlockSize * (this.rowBlocks - 1)) + (this.blockSeparation * (b - 1))
                                            } else {
                                                if (this.plotByVariable) {
                                                    this.x = (this.rowBlockSize * this.rowBlocks) + (this.blockSeparation * this.variableBlock) + this.blockSeparation
                                                } else {
                                                    this.x = (this.rowBlockSize * this.rowBlocks) + (this.blockSeparation * b) + this.blockSeparation
                                                }
                                            }
                                            this.y = this.height - (this.marginTop + this.top + this.bottom + this.marginBottom)
                                        } else {
                                            if (this.graphType.match(/Area|ParallelCoordinates/)) {
                                                this.y = (this.rowBlockSize * (this.rowBlocks - 1)) + (this.blockSeparation * (b - 1))
                                            } else {
                                                if (this.plotByVariable) {
                                                    this.y = (this.rowBlockSize * this.rowBlocks) + (this.blockSeparation * this.varIndices.length) + this.blockSeparation
                                                } else {
                                                    this.y = (this.rowBlockSize * this.rowBlocks) + (this.blockSeparation * b) + this.blockSeparation
                                                }
                                            }
                                            this.x = this.width - (this.marginLeft + this.left + this.right + this.marginRight)
                                        }
                                        this.colBlockSize = 1
                                    }
                                    this.width = this.marginLeft + ((this.left + this.x + this.right) * this.layoutCols) + this.marginRight;
                                    this.height = this.marginTop + ((this.top + this.y + this.bottom) * this.layoutRows) + this.marginBottom;
                                    this.resizeCanvas()
                                };
                                this.set1DPrivateParamsAuto = function() {
                                    var e = this.isGraphTime ? this.timeValueIndices.length : this.isGroupedData && this.grpIndices ? this.grpIndices.length : this.smpIndices.length;
                                    if (this.graphType == "Heatmap") {
                                        var c = this.margin;
                                        if (this.isOncoprint && this.showHeatmapOncoprint && this.oncoprintHeatmapPosition.match(/right|left/)) {
                                            c = this.margin * 6
                                        }
                                        var f = this.margin;
                                        if (this.isOncoprint && this.showHeatmapOncoprint && this.oncoprintHeatmapPosition.match(/top|bottom/)) {
                                            f = this.margin * 6
                                        }
                                        this.rowBlockSize = (this.y - f) / this.rowBlocks;
                                        this.blockSeparation = this.rowBlockSize;
                                        this.colBlockSize = (this.x - c) / this.colBlocks
                                    } else {
                                        if (this.graphType.match(/Area|ParallelCoordinates/)) {
                                            this.rowBlockSize = this.graphOrientation == "vertical" ? this.x / (this.rowBlocks + e - 2) : this.y / (this.rowBlocks + e - 2)
                                        } else {
                                            if (this.plotByVariable) {
                                                this.rowBlockSize = this.graphOrientation == "vertical" ? this.x / (this.rowBlocks + this.varIndices.length) : this.y / (this.rowBlocks + this.varIndices.length)
                                            } else {
                                                this.rowBlockSize = this.graphOrientation == "vertical" ? this.x / (this.rowBlocks + e) : this.y / (this.rowBlocks + e)
                                            }
                                        }
                                        var d = this.widthFactor + this.sampleSpaceFactor;
                                        var b = this.graphType.match(/Stacked|Gantt/) ? 1 : this.varIndices.length;
                                        if (this.widthFactor > this.sampleSpaceFactor) {
                                            this.blockSeparation = this.rowBlockSize * (this.sampleSpaceFactor / d);
                                            this.rowBlockSize *= 1 + (this.widthFactor / (d * b))
                                        } else {
                                            if (this.sampleSpaceFactor > this.widthFactor) {
                                                this.blockSeparation = this.rowBlockSize * (1 + (this.sampleSpaceFactor / d));
                                                this.rowBlockSize -= ((this.blockSeparation - this.rowBlockSize) / b)
                                            } else {
                                                this.blockSeparation = this.rowBlockSize
                                            }
                                        }
                                        this.colBlockSize = 1
                                    }
                                };
                                this.set1DPrivateParams = function() {
                                    var b = 100;
                                    if (!this.adjustAspectRatio) {
                                        this.set1DPrivateParamsManual()
                                    } else {
                                        this.set1DPrivateParamsAuto()
                                    }
                                    this.rowBlockSize = Math.max(1, Math.floor(this.rowBlockSize * b)) / b;
                                    this.colBlockSize = Math.max(1, Math.floor(this.colBlockSize * b)) / b;
                                    this.blockSeparation = Math.floor(this.blockSeparation * b) / b
                                };
                                this.getTreemapOverlay = function(i, j, c, f, b, e) {
                                    var g = [];
                                    for (var d in i) {
                                        g.push({
                                            area: i[d],
                                            index: -1,
                                            label: d,
                                            color: j.type == "Numeric" ? this.getColorForValue(j.colorBrew, i[d]) : j.colors[j.order[d]]
                                        })
                                    }
                                    return this.processTreemap(g, {
                                        width: c,
                                        height: f,
                                        left: b,
                                        top: e
                                    })
                                };
                                this.getTreemapVariable = function(f, h) {
                                    var l = this;
                                    var n = function(z, r, v, u) {
                                        if (z.length > 1) {
                                            if (r + 1 < l.treemapBy.length) {
                                                r++;
                                                b = l.getSampleLevelsByAnnotation(l.treemapBy[r], z);
                                                for (var w = 0; w < b.length; w++) {
                                                    p = w;
                                                    var A = l.getSamplesByAnnotationLevel(l.treemapBy[r], b[p], z);
                                                    var s = n(A, r, v, []);
                                                    v += isNaN(s[1]) ? 0 : s[1];
                                                    u.push({
                                                        area: v,
                                                        index: -1,
                                                        label: b[p],
                                                        outline: 2,
                                                        children: s[0]
                                                    })
                                                }
                                            } else {
                                                for (var w = 0; w < z.length; w++) {
                                                    var x = z[w];
                                                    var t = l.getDataAtPos(f, x, "sum", l.xAxisTransform, l.xAxisFloorValue, l.xAxisCeilValue);
                                                    var y = l.data.y.smps[x];
                                                    t = isNaN(t) ? 0 : t;
                                                    v += t;
                                                    u.push({
                                                        area: t,
                                                        color: l.getPropertyValue(f, x, "colorBy"),
                                                        pattern: l.getPropertyValue(f, x, "patternBy"),
                                                        label: y,
                                                        index: [f, x]
                                                    })
                                                }
                                            }
                                        } else {
                                            var x = z[0];
                                            var t = l.getDataAtPos(f, x, "sum", l.xAxisTransform, l.xAxisFloorValue, l.xAxisCeilValue);
                                            t = isNaN(t) ? 0 : t;
                                            v += t;
                                            u.push({
                                                area: t,
                                                color: l.getPropertyValue(f, x, "colorBy"),
                                                pattern: l.getPropertyValue(f, x, "patternBy"),
                                                label: l.data.y.smps[x],
                                                index: [f, x]
                                            })
                                        }
                                        return [u, v]
                                    };
                                    var j = [];
                                    var c, p, b;
                                    this.isGroupedData = false;
                                    var q = this.groupingFactors;
                                    this.groupingFactors = [];
                                    var m = this.getSampleLevelsByAnnotation(this.treemapBy[0], h);
                                    var e = 0;
                                    for (var g = 0; g < m.length; g++) {
                                        c = 0;
                                        p = g;
                                        var k = l.getSamplesByAnnotationLevel(l.treemapBy[c], m[p], h);
                                        var d = n(k, c, e, []);
                                        j.push({
                                            area: d[1],
                                            index: -1,
                                            label: l.treemapBy[c] + ":" + m[g],
                                            children: d[0]
                                        })
                                    }
                                    this.isGroupedData = true;
                                    this.groupingFactors = q;
                                    return j
                                };
                                this.getTreemap = function() {
                                    var o = this;
                                    var s = function() {
                                        var j = o.isDOE && o.layoutCurrent > 0;
                                        var k = [];
                                        if (t) {
                                            for (var u = 0; u < o.data.w.grps[q].length; u++) {
                                                var n = o.data.w.grps[q][u];
                                                var v = o.getDataAtPos(g, n);
                                                k.push({
                                                    area: (isNaN(v) ? 0 : v),
                                                    label: o.data.y.smps[n],
                                                    color: o.colorBy && !j ? o.getPropertyValue(g, n, "colorBy") : o.colors[n % o.colors.length],
                                                    index: [g, n]
                                                })
                                            }
                                        } else {
                                            for (var u = 0; u < o.smpIndices.length; u++) {
                                                var n = o.smpIndices[u];
                                                var v = o.getDataAtPos(g, n);
                                                k.push({
                                                    area: (isNaN(v) ? 0 : v),
                                                    label: o.data.y.smps[n],
                                                    color: o.colorBy && !j ? o.getPropertyValue(g, n, "colorBy") : o.colors[n % o.colors.length],
                                                    index: [g, n]
                                                })
                                            }
                                        }
                                        return k
                                    };
                                    var m = [];
                                    var p = [];
                                    var g, q;
                                    var t = this.isGroupedData && this.groupingFactors && this.groupingFactors.length > 0 ? this.groupingFactors : false;
                                    this.isGroupedData = false;
                                    for (var l = 0; l < this.varIndices.length; l++) {
                                        g = this.varIndices[l];
                                        if (t) {
                                            for (var f = 0; f < this.data.w.grps.length; f++) {
                                                var r = 0;
                                                for (var e = 0; e < this.data.w.grps[f].length; e++) {
                                                    var h = this.data.w.grps[f][e];
                                                    var c = this.getDataAtPos(g, h);
                                                    r += isNaN(c) ? 0 : c
                                                }
                                                p.push(r)
                                            }
                                        } else {
                                            var r = 0;
                                            for (var f = 0; f < this.smpIndices.length; f++) {
                                                var h = this.smpIndices[l];
                                                var c = this.getDataAtPos(g, h);
                                                r += isNaN(c) ? 0 : c
                                            }
                                            p.push(r)
                                        }
                                    }
                                    for (var l = 0; l < this.varIndices.length; l++) {
                                        g = this.varIndices[l];
                                        if (t) {
                                            var b = 0;
                                            for (var f = 0; f < this.data.w.grps.length; f++) {
                                                q = f;
                                                m.push({
                                                    area: p[b++],
                                                    title: this.varIndices.length > 1 ? this.data.y.vars[g] + ":" + this.data.w.smps[f] : this.data.w.smps[f],
                                                    index: -1,
                                                    children: s()
                                                })
                                            }
                                        } else {
                                            m.push({
                                                area: p[l],
                                                title: this.data.y.vars[g],
                                                index: -1,
                                                children: s()
                                            })
                                        }
                                    }
                                    if (t) {
                                        this.isGroupedData = true
                                    }
                                    if (this.isDOE) {
                                        return this.processTreemap(m, {
                                            width: this.x - 20,
                                            height: this.y - 20,
                                            left: 10,
                                            top: 10
                                        })
                                    } else {
                                        return this.processTreemap(m, {
                                            width: this.x,
                                            height: this.y,
                                            left: 0,
                                            top: 0
                                        })
                                    }
                                };
                                this.set1DXAxis = function() {
                                    if (this.graphType == "Sankey" || this.graphType == "Tree") {
                                        return
                                    } else {
                                        if (this.graphType == "ParallelCoordinates") {
                                            var d = this.graphOrientation == "vertical" ? this.y - 0.5 : this.x - 0.5;
                                            var f = this.get1DIndices();
                                            for (var c = 0; c < f.length; c++) {
                                                var b = this.parallelCoordinates[c];
                                                b.units = d / (b.max - b.min)
                                            }
                                        } else {
                                            var d = this.graphOrientation == "vertical" ? "y" : "x";
                                            var e = ["BarLine", "DotLine", "AreaLine", "StackedLine", "StackedPercentLine"];
                                            this.setAxisUnits("xAxis", d);
                                            if (e.includes(this.graphType)) {
                                                this.setAxisUnits("xAxis2", d)
                                            }
                                        }
                                    }
                                };
                                this.draw1DWireFrame = function() {
                                    if (this.graphType != "Treemap" && this.graphType != "TagCloud" && this.graphType != "Sankey" && this.graphType != "Tree") {
                                        this.toRender({
                                            p: ["disableGradientTransparencyShadow"],
                                            t: "Axes"
                                        });
                                        if (this.graphType == "Heatmap") {
                                            this.draw1DWireFrameHeatmap()
                                        } else {
                                            if (this.graphType == "ParallelCoordinates") {
                                                this.draw1DWireFrameParallelCoordinates()
                                            } else {
                                                if (this.isGraphTime) {
                                                    this.draw1DWireFrameGraphTime();
                                                    this.draw1DAxisScale()
                                                } else {
                                                    if (!this.plotByVariable) {
                                                        this.draw1DWireFrameOther();
                                                        this.draw1DAxisScale()
                                                    } else {
                                                        this.draw1DAxisScale()
                                                    }
                                                }
                                            }
                                        }
                                        this.toRender({
                                            p: ["enableGradientTransparencyShadow"],
                                            t: "Axes"
                                        })
                                    }
                                };
                                this.draw1DWireFrameHeatmap = function() {
                                    if (this.guides && this.isMultidimensionalData && !this.isGraphTime) {
                                        var d = this.get1DLeft();
                                        var n = this.get1DTop();
                                        var f = this.guides == "dotted" ? "dottedLine" : "line";
                                        var c = d;
                                        var b = d + this.x;
                                        var k = n + (this.blockSeparation / 2);
                                        var j = n + this.y;
                                        var m = this.get1DIndices();
                                        for (var e = 0; e < m.length; e++) {
                                            var h = e / this.smpLabelInterval;
                                            if (parseInt(h) == parseFloat(h)) {
                                                this.toRender({
                                                    p: ["drawLine", f, c, k, b, k, this.guidesColor, this.guidesWidth, "butt"],
                                                    b: j,
                                                    t: "Axes"
                                                })
                                            }
                                            k += this.rowBlockSize
                                        }
                                        c = d + (this.colBlockSize / 2);
                                        k = n;
                                        j = n + this.y;
                                        for (var e = 0; e < this.varIndices.length; e++) {
                                            var h = e / this.varLabelInterval;
                                            if (parseInt(h) == parseFloat(h)) {
                                                this.toRender({
                                                    p: ["drawLine", f, c, k, c, j, this.guidesColor, this.guidesWidth, "butt"],
                                                    b: d,
                                                    t: "Axes"
                                                })
                                            }
                                            c += this.colBlockSize
                                        }
                                    }
                                };
                                this.draw1DWireFrameParallelCoordinates = function() {
                                    var e = this.get1DLeft();
                                    var p = this.get1DTop();
                                    var o = this.get1DIndices();
                                    if (this.graphOrientation == "vertical") {
                                        var d = e;
                                        var c = e;
                                        var n = p;
                                        var m = this.y;
                                        for (var g = 0; g < o.length; g++) {
                                            this.toRender({
                                                p: ["drawLine", "line", d, n, d, n + m, this.xAxisTickColor],
                                                t: "Axes"
                                            });
                                            this.toRender({
                                                p: ["drawLine", "line", d - this.margin, n, d, n, this.xAxisTickColor],
                                                t: "Axes"
                                            });
                                            this.toRender({
                                                p: ["drawLine", "line", d - this.margin, n + m, d, n + m, this.xAxisTickColor],
                                                t: "Axes"
                                            });
                                            var k = this.parallelCoordinates[g];
                                            for (var f = 0; f < k.vals.length; f++) {
                                                var h = n + m - ((k.vals[f] - k.min) * k.units);
                                                this.toRender({
                                                    p: ["drawLine", "line", d - this.margin, h, d, h, this.xAxisTickColor],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawText", k.vals[f], d - (this.margin * 2), h, this.axisTickFont, this.axisTickColor, "right", "middle"],
                                                    t: "Axes"
                                                })
                                            }
                                            d += this.blockSeparation + this.rowBlockSize
                                        }
                                    } else {
                                        var d = e;
                                        var c = this.x;
                                        var n = p;
                                        var m = p;
                                        var h = p + this.blockSeparation + this.rowBlockSize;
                                        for (var g = 0; g < o.length; g++) {
                                            this.toRender({
                                                p: ["drawLine", "line", d, n, e + c, n, this.xAxisTickColor],
                                                t: "Axes"
                                            });
                                            this.toRender({
                                                p: ["drawLine", "line", d, n - this.margin, d, n, this.xAxisTickColor],
                                                t: "Axes"
                                            });
                                            this.toRender({
                                                p: ["drawLine", "line", e + c, n - this.margin, e + c, n, this.xAxisTickColor],
                                                t: "Axes"
                                            });
                                            var k = this.parallelCoordinates[g];
                                            for (var f = 0; f < k.vals.length; f++) {
                                                var b = d + ((k.vals[f] - k.min) * k.units);
                                                this.toRender({
                                                    p: ["drawLine", "line", b, n - this.margin, b, n, this.xAxisTickColor],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawText", k.vals[f], b, n - (this.margin * 2), this.axisTickFont, this.axisTickColor, "center", "bottom"],
                                                    t: "Axes"
                                                })
                                            }
                                            n += this.blockSeparation + this.rowBlockSize
                                        }
                                    }
                                };
                                this.draw1DWireFrameGraphTime = function() {
                                    var f = this.get1DLeft();
                                    var s = this.get1DTop();
                                    var k = this.guides == "dotted" ? "dottedLine" : "line";
                                    var n;
                                    if ((this.graphType == "BarLine" || this.graphType == "DotLine") && this.xAxis2Title) {
                                        var e = this.getVariablesVisibleByAxis("xAxis");
                                        var r = this.getVariablesVisibleByAxis("xAxis2");
                                        n = Math.max(e.length, r.length)
                                    } else {
                                        if (this.graphType.match(/Stacked|Line|Area|Gantt/)) {
                                            n = 1
                                        } else {
                                            n = this.varIndices.length
                                        }
                                    }
                                    var m = n * this.rowBlockSize;
                                    var q = this.get1DIndices();
                                    if (this.graphOrientation == "vertical") {
                                        var d = this.x / q.length;
                                        var j = this.graphType.match(/Area/) ? 0 : f + ((this.blockSeparation + m) / 2);
                                        var p = s;
                                        var o = s + this.y;
                                        for (var h = 0; h < this.timeValueIndices.length; h++) {
                                            var c = (h * d) + j;
                                            if (this.guides) {
                                                this.toRender({
                                                    p: ["drawLine", k, c, p, c, o, this.guidesColor, this.guidesWidth, "butt"],
                                                    b: o,
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    } else {
                                        var d = this.y / q.length;
                                        var j = this.graphType.match(/Area/) ? 0 : s + ((this.blockSeparation + m) / 2);
                                        var c = f;
                                        var b = this.x;
                                        for (var h = 0; h < this.timeValueIndices.length; h++) {
                                            var p = (h * d) + j;
                                            if (this.guides) {
                                                this.toRender({
                                                    p: ["drawLine", k, c, p, b, p, this.guidesColor, this.guidesWidth, "butt"],
                                                    b: f,
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    }
                                };
                                this.draw1DWireFrameOther = function() {
                                    var h = this.get1DLeft();
                                    var v = this.get1DTop();
                                    var k = this.guides == "dotted" ? "dottedLine" : "line";
                                    var o;
                                    if ((this.graphType == "BarLine" || this.graphType == "DotLine") && this.xAxis2Title) {
                                        var f = this.getVariablesVisibleByAxis("xAxis");
                                        var s = this.getVariablesVisibleByAxis("xAxis2");
                                        o = Math.max(f.length, s.length)
                                    } else {
                                        if (this.graphType.match(/Stacked|Line|Area|Gantt|Meter/)) {
                                            o = 1
                                        } else {
                                            o = this.varIndices.length
                                        }
                                    }
                                    var m = o * this.rowBlockSize;
                                    var u = (this.blockSeparation + m) / 2;
                                    var r = this.get1DIndices();
                                    if (this.graphOrientation == "vertical") {
                                        var d = this.graphType.match(/Area/) ? h : h + this.blockSeparation + m;
                                        var c = h;
                                        var b = this.blockSeparation + m;
                                        var q = v;
                                        var p = this.y;
                                        for (var j = 0; j < r.length; j++) {
                                            if (this.blockContrast) {
                                                var e = j % 2 ? this.evenColor : this.oddColor;
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", c + u, q + (p / 2), b, p, e, e],
                                                    t: "Axes"
                                                });
                                                c += b
                                            }
                                            if (this.guides) {
                                                if (this.graphType.match(/Area/) && (j == 0 || j == r.length - 1)) {
                                                    d += this.blockSeparation + m;
                                                    continue
                                                }
                                                this.toRender({
                                                    p: ["drawLine", k, d - u, q, d - u, q + p, this.guidesColor, this.guidesWidth, "butt"],
                                                    t: "Axes"
                                                })
                                            }
                                            d += this.blockSeparation + m
                                        }
                                    } else {
                                        if (r) {
                                            var d = h;
                                            var c = this.x;
                                            var q = this.graphType.match(/Area/) ? v : v + this.blockSeparation + m;
                                            var p = v;
                                            var n = this.blockSeparation + m;
                                            for (var j = 0; j < r.length; j++) {
                                                if (this.blockContrast) {
                                                    var e = j % 2 ? this.evenColor : this.oddColor;
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", d + (c / 2), p + u, c, n, e, e],
                                                        t: "Axes"
                                                    });
                                                    p += n
                                                }
                                                if (this.guides) {
                                                    if (this.graphType.match(/Area/) && (j == 0 || j == r.length - 1)) {
                                                        q += this.blockSeparation + m;
                                                        continue
                                                    }
                                                    this.toRender({
                                                        p: ["drawLine", k, d, q - u, h + c, q - u, this.guidesColor, this.guidesWidth, "butt"],
                                                        t: "Axes"
                                                    })
                                                }
                                                q += this.blockSeparation + m
                                            }
                                        }
                                    }
                                };
                                this.draw1DAxisScale = function() {
                                    var L = this.get1DLeft();
                                    var E = this.get1DTop();
                                    var W = this.xAxisTickStyle == "dotted" || this.yAxisTickStyle == "dotted" ? "dottedLine" : "line";
                                    if (this.graphType == "Meter") {
                                        var A = Math.min(this.x, this.y) * (this.meterType == "digital" ? 0.9 : this.meterType == "gauge" ? 1 : 1.1);
                                        var B = A * (this.meterType == "gauge" ? 0.15 : 0.1);
                                        var P = B * (this.meterType == "speedometer" ? 0.5 : 0.55);
                                        var K = A - B;
                                        var H = K / 2;
                                        var C = this.data.y.data[0][0];
                                        var S = this.meterType.match(/gauge|speedometer/) ? this.scaleTextToFont(C.toString(), K / 8, K / 4) : this.scaleTextToFont(C.toString(), K / 2, K);
                                        var D = Math.PI * (this.meterType == "gauge" ? 1 : this.meterType == "speedometer" ? 1.5 : 2) / this.xAxisRange;
                                        var I = this.meterAxis == "variables" ? this.data.y.vars[this.meterIndex] : this.data.y.smps[this.meterIndex];
                                        var J = (this.meterType == "gauge" ? Math.PI : this.meterType == "speedometer" ? Math.PI * 1.25 : Math.PI / 2);
                                        if (this.meterType.match(/gauge|speedometer/)) {
                                            var p = L + (this.x / 2);
                                            var k = E + (this.y / 2) + (this.meterType == "gauge" ? this.y / 6 : this.meterType == "speedometer" ? this.y / 24 : 0);
                                            for (var N = 0; N < this.meterColors.length; N++) {
                                                var V = this.meterColors[N];
                                                var G = N > 0 ? this.meterSegments[N - 1] : 0;
                                                var T = N < this.meterColors.length - 1 ? this.meterSegments[N] : this.xAxisMax;
                                                this.toRender({
                                                    p: ["drawLine", "arc", p, k, H, H, V, B, false, (G * D) - J, (T * D) - J],
                                                    t: "Axes"
                                                })
                                            }
                                            if (this.xAxisMinorTicks) {
                                                for (var N = 0; N < this.xAxisMinorValues.length - 1; N++) {
                                                    if (this.xAxisMinorValues[N] > this.xAxisMin && this.xAxisMinorValues[N] <= this.xAxisMax) {
                                                        var T = (this.xAxisMinorValues[N] * D) - J;
                                                        var Q = (H * Math.cos(T)) + p;
                                                        var n = (H * Math.sin(T)) + k;
                                                        var O = ((H + P) * Math.cos(T)) + p;
                                                        var j = ((H + P) * Math.sin(T)) + k;
                                                        this.toRender({
                                                            p: ["drawLine", "line", Q, n, O, j, this.xAxisTickColor],
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                            }
                                            for (var N = 0; N < this.xAxisValuesRaw.length - 1; N++) {
                                                if (this.xAxisValuesRaw[N] <= this.xAxisMax) {
                                                    var T = (this.xAxisValuesRaw[N] * D) - J;
                                                    var V = this.meterType == "gauge" ? this.background : this.xAxisTickColor;
                                                    var Q = ((H - (P + (this.meterType == "gauge" ? 0 : this.margin * 2))) * Math.cos(T)) + p;
                                                    var n = ((H - (P + (this.meterType == "gauge" ? 0 : this.margin * 2))) * Math.sin(T)) + k;
                                                    var O = ((H + P) * Math.cos(T)) + p;
                                                    var j = ((H + P) * Math.sin(T)) + k;
                                                    var M = this.meterType == "gauge" ? ((H + (P + (this.margin * 4))) * Math.cos(T)) + p : ((H - (P + (this.margin * 6))) * Math.cos(T)) + p;
                                                    var g = this.meterType == "gauge" ? ((H + (P + (this.margin * 4))) * Math.sin(T)) + k : ((H - (P + (this.margin * 6))) * Math.sin(T)) + k;
                                                    this.toRender({
                                                        p: ["drawLine", "line", Q, n, O, j, V, (this.meterType == "gauge" ? this.margin : false)],
                                                        t: "Axes"
                                                    });
                                                    this.toRender({
                                                        p: ["drawText", this.xAxisValuesRaw[N], M, g, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                            this.toRender({
                                                p: ["drawText", I, p, k - (this.getFontPt(S) * 2), this.smpTitleFont, this.smpTitleFontColor, "center", "middle"],
                                                t: "Axes"
                                            })
                                        } else {
                                            if (this.meterType == "state") {
                                                var B = Math.min(this.x, this.y);
                                                var P = B / 1.4;
                                                var I = P / 1.5;
                                                this.toRender({
                                                    p: ["drawShape", "roundrect", L + (this.x / 2), E + (this.y / 2), B, B * 2.5, "black", "black"],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "pie4", L + (this.x / 2), E + (this.y / 2) - (P + (B / 2)), (B / 2), (B / 2), "black", "black", false, Math.PI],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "pie4", L + (this.x / 2) - I, E + (this.y / 2) - (P + (B / 4)), (B / 1.5), (B / 1.5), "black", "black"],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "pie4", L + (this.x / 2) + I, E + (this.y / 2) - (P + (B / 4)), (B / 1.5), (B / 1.5), "black", "black"],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "circle", L + (this.x / 2), E + (this.y / 2) - P, (B / 2), (B / 2), this.meterBackgroundColor, this.meterBackgroundColor],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "pie4", L + (this.x / 2) - I, E + (this.y / 2) - (0 + (B / 4)), (B / 1.5), (B / 1.5), "black", "black"],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "pie4", L + (this.x / 2) + I, E + (this.y / 2) - (0 + (B / 4)), (B / 1.5), (B / 1.5), "black", "black"],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "circle", L + (this.x / 2), E + (this.y / 2), (B / 2), (B / 2), this.meterBackgroundColor, this.meterBackgroundColor],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "pie4", L + (this.x / 2) - I, E + (this.y / 2) - (-P + (B / 4)), (B / 1.5), (B / 1.5), "black", "black"],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "pie4", L + (this.x / 2) + I, E + (this.y / 2) - (-P + (B / 4)), (B / 1.5), (B / 1.5), "black", "black"],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "circle", L + (this.x / 2), E + (this.y / 2) + P, (B / 2), (B / 2), this.meterBackgroundColor, this.meterBackgroundColor],
                                                    t: "Axes"
                                                });
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", L + (this.x / 2), E + (this.y / 2) + (P + (B / 2)), (B / 2), (B / 2), "black", "black"],
                                                    t: "Axes"
                                                })
                                            } else {
                                                if (this.meterType == "digital") {
                                                    var p = L + (this.x / 2);
                                                    var k = E + (this.y / 2);
                                                    this.toRender({
                                                        p: ["drawLine", "arc", p, k, H, H, this.meterBackgroundColor, B, false, 0, Math.PI * 2],
                                                        t: "Axes"
                                                    });
                                                    for (var N = 0; N < this.meterColors.length; N++) {
                                                        var V = this.meterColors[N];
                                                        var G = N > 0 ? this.meterSegments[N - 1] : 0;
                                                        var T = N < this.meterColors.length - 1 ? Math.min(C, this.meterSegments[N]) : Math.min(C, this.xAxisMax);
                                                        if (G > C) {
                                                            continue
                                                        }
                                                        this.toRender({
                                                            p: ["drawLine", "arc", p, k, H, H, V, B, false, (G * D) - J, (T * D) - J],
                                                            t: "Axes"
                                                        })
                                                    }
                                                    for (var N = 0; N < this.xAxisValuesRaw.length - 1; N++) {
                                                        if (this.xAxisValuesRaw[N] < this.xAxisMax) {
                                                            var T = (this.xAxisValuesRaw[N] * D) - J;
                                                            var Q = ((H - P) * Math.cos(T)) + p;
                                                            var n = ((H - P) * Math.sin(T)) + k;
                                                            var O = ((H + P) * Math.cos(T)) + p;
                                                            var j = ((H + P) * Math.sin(T)) + k;
                                                            var M = ((H + P + (this.margin * 4)) * Math.cos(T)) + p;
                                                            var g = ((H + P + (this.margin * 4)) * Math.sin(T)) + k;
                                                            this.toRender({
                                                                p: ["drawLine", "line", Q, n, O, j, this.background, B * 0.3],
                                                                t: "Axes"
                                                            });
                                                            this.toRender({
                                                                p: ["drawText", this.xAxisValuesRaw[N], M, g, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                                t: "Axes"
                                                            })
                                                        }
                                                    }
                                                    this.toRender({
                                                        p: ["drawText", I, p, k + 10 + (this.getFontPt(S) / 2), this.smpTitleFont, this.smpTitleFontColor, "center", "middle"],
                                                        t: "Axes"
                                                    })
                                                } else {
                                                    var B = Math.min(this.x, this.y);
                                                    var D = (this.meterType == "horizontal" ? this.x : this.y) / this.xAxisRange;
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", L + (this.x / 2), E + (this.y / 2), this.x, this.y, this.meterBackgroundColor, this.meterBackgroundColor],
                                                        t: "Axes"
                                                    });
                                                    var J = 0;
                                                    for (var N = 0; N < this.meterColors.length; N++) {
                                                        var V = this.meterColors[N];
                                                        var G = (N > 0 ? this.meterSegments[N - 1] : 0) * D;
                                                        var T = (N < this.meterColors.length - 1 ? Math.min(C, this.meterSegments[N]) : Math.min(C, this.xAxisMax)) * D;
                                                        var U = (T - G);
                                                        if (G / D > C) {
                                                            continue
                                                        }
                                                        if (this.meterType == "horizontal") {
                                                            this.toRender({
                                                                p: ["drawShape", "rectangle", L + (U / 2) + J, E + (this.y / 2), U, this.y, V, V],
                                                                t: "Axes"
                                                            })
                                                        } else {
                                                            this.toRender({
                                                                p: ["drawShape", "rectangle", L + (this.x / 2), E + this.y - ((U / 2) + J), this.x, U, V, V],
                                                                t: "Axes"
                                                            })
                                                        }
                                                        J += U
                                                    }
                                                    if (this.meterType == "vertical") {
                                                        this.toRender({
                                                            p: ["drawText", I, L - (this.x / 2), E + (this.y / 2), this.smpTitleFont, this.smpTitleFontColor, "center", "middle", -Math.PI / 2],
                                                            t: "Axes"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawText", I, L + (this.x / 2), E - (this.y / 4), this.smpTitleFont, this.smpTitleFontColor, "center", "middle"],
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                        if (!this.meterType.match(this.graphOrientation)) {
                                            return
                                        }
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        var b = this.xAxisMin < 0 ? E + this.y - ((0 - this.xAxisMin) * this.xAxisUnit) : E + this.y;
                                        if (this.xAxisMinorTicks) {
                                            for (var N = 0; N < this.xAxisMinorValues.length; N++) {
                                                var X = this.xAxisMinorValues[N];
                                                if (X >= this.xAxisMin && X <= this.xAxisMax) {
                                                    var x = this.get1DTop() + this.y - ((X - this.xAxisMin) * this.xAxisUnit);
                                                    this.toRender({
                                                        p: ["drawLine", W, L, x, L + (this.graphType == "Meter" ? this.margin : this.x), x, this.xAxisTickColor, this.outlineWidth / 3, "butt"],
                                                        b: b,
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                        var R = this.get1DLeft() - (this.margin * 2);
                                        var Q = L;
                                        var O = L + (this.graphType == "Meter" ? this.margin : this.x);
                                        for (var N = 0; N < this.xAxisValuesRaw.length; N++) {
                                            var X = this.xAxisValuesRaw[N];
                                            if (X >= this.xAxisMin && X <= this.xAxisMax) {
                                                var x = this.get1DTop() + this.y - ((X - this.xAxisMin) * this.xAxisUnit);
                                                if (this.xAxisMajorTicks) {
                                                    this.toRender({
                                                        p: ["drawLine", W, Q, x, O, x, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                        b: b,
                                                        t: "Axes"
                                                    })
                                                }
                                                if (this.xAxisShow || this.xAxisShowLayout) {
                                                    this.toRender({
                                                        p: ["drawLine", W, Q - this.margin, x, Q, x, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                        b: b,
                                                        t: "Axes"
                                                    })
                                                }
                                                if (this.xAxis2Show || this.xAxis2ShowLayout) {
                                                    this.toRender({
                                                        p: ["drawLine", W, O, x, O + this.margin, x, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                        b: b,
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                    } else {
                                        var b = this.xAxisMin < 0 ? L + this.x - ((0 - this.xAxisMin) * this.xAxisUnit) : L;
                                        if (this.xAxisMinorTicks) {
                                            for (var N = 0; N < this.xAxisMinorValues.length; N++) {
                                                var X = this.xAxisMinorValues[N];
                                                if (X >= this.xAxisMin && X <= this.xAxisMax) {
                                                    var R = this.graphInverted ? L + this.x - ((X - this.xAxisMin) * this.xAxisUnit) : L + ((X - this.xAxisMin) * this.xAxisUnit);
                                                    this.toRender({
                                                        p: ["drawLine", W, R, E, R, E + (this.graphType == "Meter" ? this.margin : this.y), this.xAxisTickColor, this.outlineWidth / 3, "butt"],
                                                        b: b,
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                        var x = this.get1DTop() - ((this.margin * 2) + (this.axisTickFontSize / 2));
                                        var n = E;
                                        var j = E + (this.graphType == "Meter" ? this.margin : this.y);
                                        var F = this.layoutValid && this.layoutType == "wrap" ? (this.segregateVariablesBy.length + this.segregateSamplesBy.length) * this.layoutLabelBoxThickness : 0;
                                        var g = n - (F + this.margin);
                                        var y = this.graphOrientation != "vertical" && (this.layoutType == "cols" || (this.layoutType == "rows" && this.segregateVariablesBy.length + this.segregateSamplesBy.length > 1));
                                        for (var N = 0; N < this.xAxisValuesRaw.length; N++) {
                                            var X = this.xAxisValuesRaw[N];
                                            if (X >= this.xAxisMin && X <= this.xAxisMax) {
                                                var R = this.graphInverted ? L + this.x - ((X - this.xAxisMin) * this.xAxisUnit) : L + ((X - this.xAxisMin) * this.xAxisUnit);
                                                if (this.xAxisMajorTicks) {
                                                    this.toRender({
                                                        p: ["drawLine", W, R, n, R, j, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                        b: L,
                                                        t: "Axes"
                                                    })
                                                }
                                                if (this.xAxisShow || this.xAxisShowLayout) {
                                                    if (this.layoutValid) {
                                                        if (this.layoutAdjust) {
                                                            this.toRender({
                                                                p: ["drawLine", W, R, n - this.margin, R, n, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                                b: b,
                                                                t: "Axes"
                                                            })
                                                        } else {
                                                            if (!y) {
                                                                this.toRender({
                                                                    p: ["drawLine", W, R, g, R, g + this.margin, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                                    b: b,
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawLine", W, R, n - this.margin, R, n, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                            b: b,
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                                if (this.xAxis2Show || this.xAxis2ShowLayout) {
                                                    this.toRender({
                                                        p: ["drawLine", W, R, j, R, j + this.margin, this.xAxisTickColor, this.outlineWidth / 2, "butt"],
                                                        b: b,
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawDendrograms = function() {
                                    if (this.graphType == "Treemap" || this.graphType == "TagCloud" || this.graphType == "Sankey" || this.graphType == "Tree" || this.graphType == "Meter") {
                                        return
                                    } else {
                                        if (!this.isGroupedData) {
                                            if (this.showSmpDendrogram) {
                                                var b = false;
                                                if (this.isOncoprint && this.showHeatmapOncoprint && this.oncoprintHeatmapPosition == "bottom") {
                                                    b = true
                                                }
                                                this.drawDendrogram("smpDendrogram", b)
                                            }
                                            if (this.graphType == "Heatmap" && this.showVarDendrogram) {
                                                var b = false;
                                                if (this.isOncoprint && this.showHeatmapOncoprint && this.oncoprintHeatmapPosition == "right") {
                                                    b = true
                                                }
                                                this.drawDendrogram("varDendrogram", b)
                                            }
                                        }
                                    }
                                };
                                this.getDendrogramClipArea = function(d) {
                                    var b = this.get1DLeft();
                                    var c = this.get1DTop();
                                    if (d == "varDendrogram") {
                                        if (this.varDendrogramPosition == "bottom") {
                                            return [b, c + this.y, b + this.x + 1, c + this.y + this.bottom]
                                        } else {
                                            return [b, 0, b + this.x + 1, c]
                                        }
                                    } else {
                                        if (this.graphOrientation == "vertical") {
                                            if (this.smpDendrogramPosition == "bottom") {
                                                return [b, c + this.y, b + this.x + 1, c + this.y + this.bottom]
                                            } else {
                                                if (this.smpDendrogramPosition == "top") {
                                                    return [b, this.margin, b + this.x + 1, c]
                                                } else {
                                                    return [b, this.marginTop + this.offsetY, b + this.x + 1, c]
                                                }
                                            }
                                        } else {
                                            if (this.smpDendrogramPosition == "right") {
                                                return [b + this.x, c, b + this.x + this.right, c + this.y + 1]
                                            } else {
                                                if (this.smpDendrogramPosition == "left") {
                                                    return [this.margin, c, b, c + this.y + 1]
                                                } else {
                                                    return [this.marginLeft + this.offsetX, c, b, c + this.y + 1]
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getDendrogramBlockSize = function(d) {
                                    if (this.graphType != "Heatmap") {
                                        var b;
                                        if ((this.graphType == "BarLine" || this.graphType == "DotLine") && this.xAxis2Title) {
                                            var d = this.getVariablesVisibleByAxis("xAxis");
                                            var c = this.getVariablesVisibleByAxis("xAxis2");
                                            b = Math.max(d.length, c.length)
                                        } else {
                                            if (this.graphType.match(/Stacked|Line|Area/)) {
                                                b = 1
                                            } else {
                                                b = this.varIndices.length
                                            }
                                        }
                                        return (b * this.rowBlockSize) + this.blockSeparation
                                    } else {
                                        return d == "varDendrogram" ? this.colBlockSize : this.rowBlockSize
                                    }
                                };
                                this.getDendrogramTopOffset = function(f, g) {
                                    var e = this.get1DTop(g);
                                    var c = f == "varDendrogram" ? "showVarDendrogram" : "showSmpDendrogram";
                                    var h = 0;
                                    var d = this.getDendrogramBlockSize(f);
                                    var b = this.getDendrogramInverse(f);
                                    if (this[c] && this[f]) {
                                        if (f == "varDendrogram") {
                                            if (this.varDendrogramPosition == "bottom") {
                                                h = e + this.y + this.bottom - (this.dendrogramHeight + this.margin);
                                                if (this.varTitleLabelPosition == "bottom") {
                                                    h -= this.getVariableTitleHeight()
                                                }
                                                if (this.isOncoprint) {
                                                    h -= this.legendOncoprintHeight
                                                }
                                                if (!this.legendInside && this.legendPosition == "bottom") {
                                                    h -= this.legendHeight
                                                }
                                                h = b < 0 ? h + this.dendrogramHeight : h
                                            } else {
                                                if (this.varTitleLabelPosition != "bottom") {
                                                    h = e - (this.varOverlaysThicknessTop + this.getVariableLabelLength() + this.getVarTreeHeight())
                                                } else {
                                                    h = e - (this.margin + this.varOverlaysThicknessTop + this.getVarTreeHeight())
                                                }
                                                if (!this.legendInside && this.legendPosition == "top") {
                                                    h += this.legendHeight
                                                }
                                            }
                                        } else {
                                            if (this.graphOrientation == "vertical") {
                                                if (this.smpDendrogramPosition == "bottom") {
                                                    h = e + this.y + this.bottom - (this.getSampleTitleHeight() + this.getLegendHeight("bottom") + this.getSmpTreeWidthHeight())
                                                } else {
                                                    h = e - (this.getSmpTreeWidthHeight() + this.smpOverlaysThicknessTop)
                                                }
                                                h = b < 0 ? h + this.dendrogramHeight : h
                                            } else {
                                                h = this.graphType.match(/Area/) ? e : e + (d / 2);
                                                if (this.isGroupedData) {
                                                    if (this.grpIndicesStart > -1) {
                                                        h -= d * this.grpIndicesStart
                                                    }
                                                } else {
                                                    if (this.smpIndicesStart > -1) {
                                                        h -= d * this.smpIndicesStart
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return h
                                };
                                this.getDendrogramLeftOffset = function(f, g) {
                                    var d = this.get1DLeft(g);
                                    var c = f == "varDendrogram" ? "showVarDendrogram" : "showSmpDendrogram";
                                    var h = 0;
                                    var e = this.getDendrogramBlockSize(f);
                                    var b = this.getDendrogramInverse(f);
                                    if (this[c] && this[f]) {
                                        if (f == "varDendrogram") {
                                            h = d + (e / 2);
                                            if (this.varIndicesStart > -1) {
                                                h -= e * this.varIndicesStart
                                            }
                                        } else {
                                            if (this.graphOrientation == "vertical") {
                                                h = this.graphType.match(/Area/) ? d : d + (e / 2);
                                                if (this.isGroupedData) {
                                                    if (this.grpIndicesStart > -1) {
                                                        h -= e * this.grpIndicesStart
                                                    }
                                                } else {
                                                    if (this.smpIndicesStart > -1) {
                                                        h -= e * this.smpIndicesStart
                                                    }
                                                }
                                            } else {
                                                if (this.smpDendrogramPosition == "right") {
                                                    h = d + this.x + this.smpOverlaysThicknessRight + (this.smpTitleLabelPosition == "right" ? this.getSampleLabelLength() : 0) + this.margin;
                                                    h = b < 0 ? h + this.dendrogramHeight : h
                                                } else {
                                                    h = this.marginLeft + this.offsetX + this.margin + this.getSampleTitleHeight()
                                                }
                                            }
                                        }
                                    }
                                    return h
                                };
                                this.getDendrogramInverse = function(b) {
                                    if (b == "varDendrogram") {
                                        return this.varDendrogramPosition == "top" ? 1 : -1
                                    } else {
                                        if (this.graphOrientation == "vertical") {
                                            if (!this.smpDendrogramPosition.match(/top|bottom/)) {
                                                this.smpDendrogramPosition = "top"
                                            }
                                            return this.smpDendrogramPosition == "top" ? 1 : -1
                                        } else {
                                            if (!this.smpDendrogramPosition.match(/left|right/)) {
                                                this.smpDendrogramPosition = "left"
                                            }
                                            return this.smpDendrogramPosition == "left" ? 1 : -1
                                        }
                                    }
                                };
                                this.drawDendrogram = function(g, s) {
                                    if (this.graphType != "TagCloud" && this.graphType != "Sankey" && this.graphType != "Tree" && this.graphType != "Meter" && this[g]) {
                                        var j = this;
                                        var k = this[g];
                                        var o = this.getDendrogramBlockSize(g);
                                        var e = this.getDendrogramInverse(g);
                                        var n = this.getDendrogramClipArea(g);
                                        var v = this.getDendrogramTopOffset(g, s);
                                        var i = this.getDendrogramLeftOffset(g, s);
                                        var q = k.useHeight ? this.dendrogramHeight / k.height : this.dendrogramHeight / k.max;
                                        var m = g == "varDendrogram" || this.graphOrientation == "vertical" ? false : true;
                                        var f = 0;
                                        var p = function(d) {
                                            if (d.children) {
                                                for (var b = 0; b < d.children.length; b++) {
                                                    p(d.children[b]);
                                                    if (d.children[b].children) {
                                                        d.children[b].color = d.children[b].children[0].color
                                                    }
                                                }
                                            } else {
                                                if (g == "varDendrogram") {
                                                    d.color = j.getDendrogramColor(d.name)
                                                } else {
                                                    d.color = j.getDendrogramColor(false, d.name)
                                                }
                                            }
                                            if (d.mid != null) {
                                                var c;
                                                if (k.useHeight) {
                                                    c = d.height ? q * (k.height - d.height) * e : j.dendrogramHeight * e
                                                } else {
                                                    c = q * d.depth * e
                                                }
                                                if (m) {
                                                    d.x = i + c;
                                                    d.y = v + (o * d.mid)
                                                } else {
                                                    d.x = i + (o * d.mid);
                                                    d.y = v + c
                                                }
                                            }
                                        };
                                        var h = function(d) {
                                            if (d.children) {
                                                var c = d.x;
                                                var z = d.y;
                                                var u = d.color;
                                                for (var t = 0; t < d.children.length; t++) {
                                                    var b = d.children[t].x;
                                                    var x = d.children[t].y;
                                                    var r = d.children[t].color;
                                                    var y;
                                                    if (j.graphOrientation == "vertical" || g == "varDendrogram") {
                                                        y = j.toRender({
                                                            p: ["drawLine", "line", c, z, b, z, r, false, "butt", false, false, true, n],
                                                            a: j.getLineArea("line", c, z, b, z, r, false, "butt", false, false, true, n),
                                                            i: [g + ":" + f++ + ":" + d.nodeId],
                                                            b: [c, v, b, v],
                                                            t: g
                                                        });
                                                        j.toRender({
                                                            p: ["drawLine", "line", b, z, b, x, r, false, "butt", false, false, true, n],
                                                            a: j.getLineArea("line", b, z, b, x, r, false, "butt", false, false, true, n),
                                                            i: [g + ":" + f++ + ":" + d.nodeId],
                                                            g: y,
                                                            b: [b, v, b, v],
                                                            t: g
                                                        })
                                                    } else {
                                                        y = j.toRender({
                                                            p: ["drawLine", "line", c, z, c, x, r, false, "butt", false, false, true, n],
                                                            a: j.getLineArea("line", c, z, c, x, r, false, "butt", false, false, true, n),
                                                            i: [g + ":" + f++ + ":" + d.nodeId],
                                                            b: [i, z, i, x],
                                                            t: g
                                                        });
                                                        j.toRender({
                                                            p: ["drawLine", "line", c, x, b, x, r, false, "butt", false, false, true, n],
                                                            a: j.getLineArea("line", c, x, b, x, r, false, "butt", false, false, true, n),
                                                            i: [g + ":" + f++ + ":" + d.nodeId],
                                                            b: [i, x, i, x],
                                                            t: g
                                                        })
                                                    }
                                                    h(d.children[t])
                                                }
                                                if (d.nodeId != null && d.children.length > 1) {
                                                    var w = d.name ? d.name : "";
                                                    var l = k.useHeight ? d.height : d.depth;
                                                    j.toRender({
                                                        p: ["drawShape", "circle", d.x, d.y, j.margin * 2, j.margin * 2, "rgba(0,0,0,0)", "rgba(0,0,0,0)"],
                                                        a: j.getShapeArea("circle", d.x, d.y, j.margin * 2, j.margin * 2, "rgba(0,0,0,0)", "rgba(0,0,0,0)"),
                                                        i: [d.nodeId + "-" + l + "-" + g + "-" + w],
                                                        t: g
                                                    })
                                                }
                                            }
                                        };
                                        this.toRender({
                                            p: ["disableGradientTransparencyShadow"],
                                            t: g
                                        });
                                        p(k);
                                        h(k);
                                        this.toRender({
                                            p: ["enableGradientTransparencyShadow"],
                                            t: g
                                        })
                                    }
                                };
                                this.draw1DYLayout = function() {
                                    this.smpInfo = [];
                                    this.varInfo = [];
                                    if (this.graphType == "Treemap" || this.graphType == "TagCloud" || this.graphType == "Sankey" || this.graphType == "Tree" || this.graphType == "Meter") {
                                        return
                                    } else {
                                        if (this.smpTitle) {
                                            this.draw1DYLayoutSampleTitle()
                                        }
                                        if (this.graphType == "Heatmap") {
                                            this.draw1DYLayoutHeatmap();
                                            if (this.isOncoprint && this.showHeatmapOncoprint) {
                                                this.draw1DYLayoutHeatmap(true)
                                            }
                                            if (this.varTitle) {
                                                this.draw1DYLayoutVariableTitle()
                                            }
                                        } else {
                                            this.draw1DYLayoutNoHeatmap()
                                        }
                                    }
                                };
                                this.draw1DYLayoutSampleTitle = function() {
                                    var d, e;
                                    var b = this.get1DLeft() + this.margin;
                                    var c = this.get1DTop();
                                    if (this.graphOrientation == "vertical") {
                                        c -= this.margin;
                                        d = b + (this.x / 2);
                                        if (this.segregateVariablesBy.length > 0) {
                                            e = (c + this.y + this.bottom + this.getSampleLabelLength() + (this.margin * 2)) - (this.margin + (this.smpTitleFontSize / 2))
                                        } else {
                                            e = (c + this.y + this.bottom) - ((this.smpTitleFontSize / 2) - this.margin / 2)
                                        }
                                        e -= this.getLegendHeight("bottom");
                                        this.toRender({
                                            p: ["drawText", this.smpTitle, d, e, this.smpTitleFont, this.smpTitleFontColor, "center", "middle"],
                                            t: "Axes"
                                        })
                                    } else {
                                        if (this.segregateVariablesBy.length > 1) {
                                            d = this.marginLeft + this.getFontHeight() + (this.margin * 2) + (this.smpTitleFontSize / 2)
                                        } else {
                                            if (this.segregateVariablesBy.length > 0) {
                                                d = this.marginLeft + (this.margin * (this.segregateSamplesBy.length > 0 ? 5 : 0)) + (this.smpTitleFontSize / 2)
                                            } else {
                                                d = this.marginLeft + this.offsetX + (this.smpTitleFontSize / 2) - (this.margin / 2)
                                            }
                                        }
                                        e = c + (this.y / 2);
                                        this.toRender({
                                            p: ["drawText", this.smpTitle, d, e, this.smpTitleFont, this.smpTitleFontColor, "center", "middle", -Math.PI / 2],
                                            t: "Axes"
                                        })
                                    }
                                };
                                this.draw1DYLayoutVariableTitle = function() {
                                    var d, e;
                                    var b = this.get1DLeft() + this.margin;
                                    var c = this.get1DTop();
                                    d = b + (this.x / 2);
                                    if (this.varTitleLabelPosition != "bottom") {
                                        e = this.offsetY + (this.margin * 2) + this.top;
                                        e -= this.getVariableLabelLength();
                                        e -= this.varOverlaysThicknessTop;
                                        if (this.varDendrogramPosition == "top") {
                                            e -= this.getVarTreeHeight()
                                        }
                                    } else {
                                        e = c + this.y + this.bottom
                                    }
                                    this.toRender({
                                        p: ["drawText", this.varTitle, d, e, this.varTitleFont, this.varTitleFontColor, "center", "bottom"],
                                        t: "Axes"
                                    })
                                };
                                this.draw1DYLayoutHeatmap = function(s) {
                                    var B, d, A, c;
                                    var v = this.get1DLeft(s) + this.margin;
                                    var q = this.get1DTop(s);
                                    var g = this.get1DIndices();
                                    var r = this.get1DSamples();
                                    var C = this.get1DLabels();
                                    var n = !this.adjustAspectRatio ? this.rowBlockSize * 0.3 : 0;
                                    if (this.showSampleNames && (!s || (s && this.oncoprintHeatmapPosition.match(/top|bottom/)))) {
                                        var x = Math.abs(this.smpLabelRotate) == 90 ? "center" : "right";
                                        if (this.isGraphTime) {
                                            var k = this.y / g.length;
                                            var w = k / 2;
                                            var o = q + w;
                                            B = v - (this.margin * 2);
                                            A = v + this.x + this.margin;
                                            c = q + this.y;
                                            for (var y = 0; y < this.timeValueIndices.length; y++) {
                                                d = (y * k) + o + n;
                                                this.smpInfo[y] = d;
                                                if (this.smpLabelRotate) {
                                                    this.toRender({
                                                        p: ["drawText", this.timeValues[y], B - this.margin, d + n, this.smpLabelFont, f, x, "middle", this.smpLabelRotate * Math.PI / 180],
                                                        a: this.getTextArea(this.timeValues[y], B - this.margin, d + n, this.smpLabelFont, f, x, "middle", this.smpLabelRotate * Math.PI / 180),
                                                        i: ["Smp-" + y],
                                                        t: "Labels",
                                                        h: this.isHidden(false, y)
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", this.timeValues[y], B, d + n, this.smpLabelFont, f, "right", "middle"],
                                                        a: this.getTextArea(this.timeValues[y], B, d + n, this.smpLabelFont, f, "right", "middle"),
                                                        i: ["Smp-" + y],
                                                        t: "Labels",
                                                        h: this.isHidden(false, y)
                                                    })
                                                }
                                            }
                                        } else {
                                            B = v + (this.smpTitleLabelPosition == "right" ? this.x : 0);
                                            A = v + this.x + this.margin;
                                            d = q + (this.blockSeparation / 2);
                                            c = q + this.y;
                                            var h = (this.smpTitleLabelPosition == "right" ? this.smpOverlaysThicknessRight : this.smpOverlaysThicknessLeft);
                                            for (var y = 0; y < g.length; y++) {
                                                var j = y / this.smpLabelInterval;
                                                if (parseInt(j) == parseFloat(j)) {
                                                    var p = g[y];
                                                    var m = this.shortenText(C ? C[p] : r[p], this.maxSmpStringLen);
                                                    var z = ((this.margin * 2) + h) * (this.smpTitleLabelPosition == "right" ? -1 : 1);
                                                    var f = this.getSmpColor(r[p]);
                                                    this.smpInfo[y] = d;
                                                    if (this.smpLabelImage) {} else {
                                                        if (this.smpLabelRotate) {
                                                            this.toRender({
                                                                p: ["drawText", m, B - (z + this.margin), d + n, this.smpLabelFont, f, x, "middle", this.smpLabelRotate * Math.PI / 180],
                                                                a: this.getTextArea(m, B - (z + this.margin), d + n, this.smpLabelFont, f, x, "middle", this.smpLabelRotate * Math.PI / 180),
                                                                i: ["Smp-" + p],
                                                                t: "Labels",
                                                                h: this.isHidden(false, p)
                                                            })
                                                        } else {
                                                            this.toRender({
                                                                p: ["drawText", m, B - z, d + n, this.smpLabelFont, f, (this.smpTitleLabelPosition == "right" ? "left" : "right"), "middle"],
                                                                a: this.getTextArea(m, B - z, d + n, this.smpLabelFont, f, (this.smpTitleLabelPosition == "right" ? "left" : "right"), "middle"),
                                                                i: ["Smp-" + p],
                                                                t: "Labels",
                                                                h: this.isHidden(false, p)
                                                            })
                                                        }
                                                    }
                                                }
                                                d += this.rowBlockSize
                                            }
                                        }
                                    }
                                    if (this.showVariableNames && (!s || (s && this.oncoprintHeatmapPosition.match(/right|left/)))) {
                                        var w = this.colBlockSize / 2;
                                        var e = Math.abs(this.varLabelRotate) == 90 ? "center" : this.varTitleLabelPosition != "bottom" ? "left" : "right";
                                        var D = this.varTitleLabelPosition != "bottom" ? "left" : "right";
                                        var b = this.varTitleLabelPosition != "bottom" ? "right" : "left";
                                        v = (v - this.margin);
                                        d = this.varTitleLabelPosition != "bottom" ? q - (this.margin + this.varOverlaysThicknessTop) : d = q + this.y + this.margin;
                                        if (this.varTitleLabelPosition != "top" && this.varOverlays.length > 0 && this.showOverlays && this.graphType == "Heatmap") {
                                            d += this.varOverlaysThicknessBottom
                                        }
                                        c = this.varTitleLabelPosition != "bottom" ? q + this.y + this.margin : q - this.margin;
                                        for (var y = 0; y < this.varIndices.length; y++) {
                                            B = (v + (y * this.colBlockSize) + w);
                                            var j = y / this.varLabelInterval;
                                            if (parseInt(j) == parseFloat(j)) {
                                                var p = this.varIndices[y];
                                                var u = this.shortenText(this.data.y.vars[p], this.maxVarStringLen);
                                                var f = this.getVarColor(this.data.y.vars[p]);
                                                this.varInfo[y] = B;
                                                if (this.varLabelRotate) {
                                                    this.toRender({
                                                        p: ["drawText", u, B, d, this.varLabelFont, f, e, "middle", -Math.PI / 2 + (this.varLabelRotate * Math.PI / 180)],
                                                        a: this.getTextArea(u, B, d, this.varLabelFont, f, e, "middle", -Math.PI / 2 + (this.varLabelRotate * Math.PI / 180)),
                                                        i: ["Var-" + p],
                                                        t: "Labels",
                                                        h: this.isHidden(p)
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", u, B, d, this.varLabelFont, f, D, "middle", -Math.PI / 2],
                                                        a: this.getTextArea(u, B, d, this.varLabelFont, f, D, "middle", -Math.PI / 2),
                                                        i: ["Var-" + p],
                                                        t: "Labels",
                                                        h: this.isHidden(p)
                                                    })
                                                }
                                            }
                                        }
                                    }
                                };
                                this.draw1DYLayoutNoHeatmap = function() {
                                    var r, b, q, Q, p, P;
                                    var G = this.get1DLeft() + this.margin;
                                    var D = this.get1DTop();
                                    var c = this.get1DIndices();
                                    var E = this.get1DSamples();
                                    var g = this.get1DLabels();
                                    var x = {};
                                    var C = this;
                                    var e = function(T, R, V, X, U) {
                                        var l = T + 1;
                                        var S = V;
                                        var W = g ? g[c[T]] : E[c[T]];
                                        var t = g ? g[c[l]] : E[c[l]];
                                        var Y = 0;
                                        if (C.smpLabelRotate != 90 && C.isGroupedData) {
                                            return V + C.margin
                                        }
                                        if (W) {
                                            W = C.isArray(W) ? W : W.toString().split(" :: ")[R]
                                        }
                                        if (t) {
                                            t = C.isArray(t) ? t : t.toString().split(" :: ")[R]
                                        }
                                        while (C.isSameObject(W, t)) {
                                            Y += C.blockSeparation + J;
                                            S += C.blockSeparation + J;
                                            l++;
                                            t = g ? g[c[l]] : E[c[l]];
                                            if (t) {
                                                t = C.isArray(t) ? t : t.toString().split(" :: ")[R]
                                            }
                                        }
                                        if (V == S) {
                                            return V
                                        } else {
                                            if (C.graphOrientation == "vertical") {
                                                C.toRender({
                                                    p: ["drawLine", "line", V, X - C.margin, V + Y, X - C.margin, U],
                                                    t: "Labels"
                                                })
                                            } else {
                                                C.toRender({
                                                    p: ["drawLine", "line", X + C.margin, V, X + C.margin, V + Y, U],
                                                    t: "Labels"
                                                })
                                            }
                                            return V + (Y / 2)
                                        }
                                    };
                                    var f = function() {
                                        var l = c.length;
                                        c = [];
                                        for (var j = 0; j < l; j++) {
                                            c.push(j)
                                        }
                                    };
                                    if (this.showSampleNames) {
                                        var J = this.get1DCompBlockMax() * this.rowBlockSize;
                                        if (this.graphType == "Gantt") {
                                            f()
                                        }
                                        if (this.graphOrientation == "vertical") {
                                            var h = this.smpLabelRotate > 0 ? -2 : 2;
                                            var F = Math.abs(this.smpLabelRotate) == 90 ? "center" : h > 0 ? "left" : "right";
                                            if (this.isGraphTime) {
                                                var A = this.plotByVariable ? this.x / this.varIndices.length / (c.length + 1) : this.x / c.length;
                                                var v = this.graphType.match(/Area/) ? 0 : this.plotByVariable ? G - this.margin : G + ((this.blockSeparation + J) / 2);
                                                b = D + this.y + this.smpOverlaysThicknessBottom + (this.margin * 1.5);
                                                if (this.plotByVariable) {
                                                    for (var I = 0; I < this.varIndices.length; I++) {
                                                        for (var H = 0; H < this.timeValueIndices.length; H++) {
                                                            var y = H / this.smpLabelInterval;
                                                            if (parseInt(y) == parseFloat(y)) {
                                                                r = (H * A) + v + A;
                                                                this.smpInfo[H] = r;
                                                                if (this.smpLabelRotate) {
                                                                    this.toRender({
                                                                        p: ["drawText", this.timeValues[H], r, b + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)],
                                                                        a: this.getTextArea(this.timeValues[H], r, b + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)),
                                                                        i: ["Smp-" + H],
                                                                        t: "Labels"
                                                                    })
                                                                } else {
                                                                    this.toRender({
                                                                        p: ["drawText", this.timeValues[H], r, b, this.smpLabelFont, d, "right", "middle", -Math.PI / 2],
                                                                        a: this.getTextArea(this.timeValues[H], r, b, this.smpLabelFont, d, "right", "middle", -Math.PI / 2),
                                                                        i: ["Smp-" + H],
                                                                        t: "Labels"
                                                                    })
                                                                }
                                                            }
                                                        }
                                                        v += this.blockSeparation + J
                                                    }
                                                } else {
                                                    for (var I = 0; I < this.timeValueIndices.length; I++) {
                                                        var y = I / this.smpLabelInterval;
                                                        r = (I * A) + v;
                                                        this.smpInfo[I] = r;
                                                        if (parseInt(y) == parseFloat(y)) {
                                                            if (this.smpLabelRotate) {
                                                                this.toRender({
                                                                    p: ["drawText", this.timeValues[I], r, b + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)],
                                                                    a: this.getTextArea(this.timeValues[I], r, b + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)),
                                                                    i: ["Smp-" + I],
                                                                    t: "Labels"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawText", this.timeValues[I], r, b, this.smpLabelFont, d, "right", "middle", -Math.PI / 2],
                                                                    a: this.getTextArea(this.timeValues[I], r, b, this.smpLabelFont, d, "right", "middle", -Math.PI / 2),
                                                                    i: ["Smp-" + I],
                                                                    t: "Labels"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                r = this.plotByVariable ? G + ((this.blockSeparation + this.rowBlockSize) / 2) : this.graphType.match(/Area|ParallelCoordinates/) ? G : G + ((this.blockSeparation + J) / 2) - (this.margin * (!this.smpLabelRotate || this.smpLabelRotate == 90) ? 1 : 4);
                                                b = D;
                                                Q = D + this.y;
                                                P = Q + this.smpOverlaysThicknessBottom + (this.margin * 0.5) + (this.margin * (this.layoutValid ? 1 : 2));
                                                if (this.plotByVariable) {
                                                    for (var I = 0; I < this.varIndices.length; I++) {
                                                        for (var H = 0; H < c.length; H++) {
                                                            var y = H / this.smpLabelInterval;
                                                            if (parseInt(y) == parseFloat(y)) {
                                                                var m = c[H];
                                                                var K = this.shortenText(E[m], this.maxSmpStringLen);
                                                                var d = this.getSmpColor(E[m]);
                                                                this.smpInfo[H] = r;
                                                                if (this.smpLabelImage && CanvasXpress.cacheImages.hasOwnProperty(E[m] + ".png")) {} else {
                                                                    if (this.smpLabelRotate) {
                                                                        this.toRender({
                                                                            p: ["drawText", K, r, P + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)],
                                                                            a: this.getTextArea(K, r, P + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)),
                                                                            i: ["Smp-" + m],
                                                                            t: "Labels"
                                                                        })
                                                                    } else {
                                                                        this.toRender({
                                                                            p: ["drawText", K, r - this.margin, P, this.smpLabelFont, d, "right", "middle", -Math.PI / 2],
                                                                            a: this.getTextArea(K, r - this.margin, P, this.smpLabelFont, d, "right", "middle", -Math.PI / 2),
                                                                            i: ["Smp-" + m],
                                                                            t: "Labels"
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                            r += this.rowBlockSize
                                                        }
                                                        r += this.blockSeparation
                                                    }
                                                } else {
                                                    var s = 0;
                                                    for (var I = 0; I < c.length; I++) {
                                                        var z = c[I];
                                                        var y = I / this.smpLabelInterval;
                                                        var K = g ? g[z] : E[z];
                                                        var d = this.getSmpColor(E[z]);
                                                        if (parseInt(y) == parseFloat(y)) {
                                                            this.smpInfo[I] = r;
                                                            var n = g ? g[c[s]] : E[c[s]];
                                                            var L = this.isArray(n) ? n : n.toString().split(" :: ");
                                                            if (I > 0 && this.parseInt(this.smpInfo[I]) < this.parseInt(this.smpInfo[s] + this.smpLabelFontSize)) {
                                                                if (this.isGroupedData && this.smpLabelRotate == 90) {
                                                                    K = this.isArray(K) ? K : K.toString().split(" :: ");
                                                                    for (var H = 0; H < K.length; H++) {
                                                                        e(I, H, r, P + (H * (this.smpLabelFontSize + this.margin)), d)
                                                                    }
                                                                }
                                                                r += this.blockSeparation + J;
                                                                continue
                                                            }
                                                            if (this.isGroupedData && this.smpLabelRotate == 90) {
                                                                var w = this.isArray(K) ? K : K.toString().split(" :: ");
                                                                for (var H = 0; H < w.length; H++) {
                                                                    if (I > 0) {
                                                                        if (L[H] != w[H]) {
                                                                            delete x[w[H]]
                                                                        }
                                                                    }
                                                                    var N = w[H];
                                                                    var O = P + (H * (this.smpLabelFontSize + this.margin));
                                                                    var B = e(I, H, r, O, d);
                                                                    if (!x.hasOwnProperty(N)) {
                                                                        this.toRender({
                                                                            p: ["drawText", N, B, O + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)],
                                                                            a: this.getTextArea(N, B, O + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)),
                                                                            i: ["Smp-" + z],
                                                                            t: "Labels"
                                                                        });
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", B, Q, B, Q + this.margin, this.xAxisTickColor],
                                                                            t: "Labels"
                                                                        });
                                                                        x[N] = true
                                                                    }
                                                                }
                                                            } else {
                                                                K = this.shortenText(K, this.maxSmpStringLen);
                                                                if (I > 0) {
                                                                    if (n != K) {
                                                                        x = {}
                                                                    }
                                                                }
                                                                var B = e(I, 0, r, P, d);
                                                                if (!x.hasOwnProperty(K)) {
                                                                    if (this.smpLabelImage && CanvasXpress.cacheImages.hasOwnProperty(K + ".png")) {
                                                                        var O = this.getSampleLabelLength();
                                                                        var M = P + (O / 2) - this.margin;
                                                                        this.toRender({
                                                                            p: ["drawShape", "image", B - (this.smpLabelFontSize / 2), M, O, O, false, false, this.smpLabelImageRound, false, false, false, false, false, false, K + ".png"],
                                                                            a: this.getShapeArea("image", B - (this.smpLabelFontSize / 2), M, O, O, false, false, this.smpLabelImageRound, false, false, false, false, false, false, K + ".png"),
                                                                            i: ["Smp-" + z],
                                                                            t: "Labels"
                                                                        })
                                                                    } else {
                                                                        if (this.smpLabelRotate) {
                                                                            this.toRender({
                                                                                p: ["drawText", K, B, P + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)],
                                                                                a: this.getTextArea(K, B, P + (this.smpLabelFontSize / 2), this.smpLabelFont, d, F, "middle", Math.PI / h + (this.smpLabelRotate * Math.PI / 180)),
                                                                                i: ["Smp-" + z],
                                                                                t: "Labels"
                                                                            })
                                                                        } else {
                                                                            this.toRender({
                                                                                p: ["drawText", K, B - this.margin, P, this.smpLabelFont, d, "right", "middle", -Math.PI / 2],
                                                                                a: this.getTextArea(K, B - this.margin, P, this.smpLabelFont, d, "right", "middle", -Math.PI / 2),
                                                                                i: ["Smp-" + z],
                                                                                t: "Labels"
                                                                            })
                                                                        }
                                                                    }
                                                                    this.toRender({
                                                                        p: ["drawLine", "line", B - this.margin, Q, B - this.margin, Q + this.margin, this.xAxisTickColor],
                                                                        t: "Labels"
                                                                    });
                                                                    x[K] = true
                                                                }
                                                            }
                                                            s = I
                                                        }
                                                        r += this.blockSeparation + J
                                                    }
                                                }
                                            }
                                        } else {
                                            var F = Math.abs(this.smpLabelRotate) == 90 ? "center" : "right";
                                            if (this.isGraphTime) {
                                                var A = this.plotByVariable ? this.y / this.varIndices.length / (c.length + 1) : this.y / c.length;
                                                var v = this.graphType.match(/Area/) ? 0 : this.plotByVariable ? D : D + ((this.blockSeparation + J) / 2);
                                                r = G - (this.margin * 2);
                                                if (this.plotByVariable) {
                                                    for (var I = 0; I < this.varIndices.length; I++) {
                                                        for (var H = 0; H < this.timeValueIndices.length; H++) {
                                                            var y = H / this.smpLabelInterval;
                                                            if (parseInt(y) == parseFloat(y)) {
                                                                b = (H * A) + v + A;
                                                                this.smpInfo[H] = b;
                                                                if (this.smpLabelRotate) {
                                                                    this.toRender({
                                                                        p: ["drawText", this.timeValues[H], r - (this.smpLabelFontSize / 2), b, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180],
                                                                        a: this.getTextArea(this.timeValues[H], r - (this.smpLabelFontSize / 2), b, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180),
                                                                        i: ["Smp-" + H],
                                                                        t: "Labels"
                                                                    })
                                                                } else {
                                                                    this.toRender({
                                                                        p: ["drawText", this.timeValues[H], r, b, this.smpLabelFont, d, "right", "middle"],
                                                                        a: this.getTextArea(this.timeValues[H], r, b, this.smpLabelFont, d, "right", "middle"),
                                                                        i: ["Smp-" + H],
                                                                        t: "Labels"
                                                                    })
                                                                }
                                                            }
                                                        }
                                                        v += this.blockSeparation + J
                                                    }
                                                } else {
                                                    for (var I = 0; I < this.timeValueIndices.length; I++) {
                                                        var y = I / this.smpLabelInterval;
                                                        b = (I * A) + v;
                                                        this.smpInfo[I] = b;
                                                        if (parseInt(y) == parseFloat(y)) {
                                                            if (this.smpLabelRotate) {
                                                                this.toRender({
                                                                    p: ["drawText", this.timeValues[I], r - (this.smpLabelFontSize / 2), b, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180],
                                                                    a: this.getTextArea(this.timeValues[I], r - (this.smpLabelFontSize / 2), b, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180),
                                                                    i: ["Smp-" + I],
                                                                    t: "Labels"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawText", this.timeValues[I], r, b, this.smpLabelFont, d, "right", "middle"],
                                                                    a: this.getTextArea(this.timeValues[I], r, b, this.smpLabelFont, d, "right", "middle"),
                                                                    i: ["Smp-" + I],
                                                                    t: "Labels"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                b = this.plotByVariable ? D + ((this.blockSeparation + this.rowBlockSize) / 2) : this.graphType.match(/Area|ParallelCoordinates/) ? D : D + ((this.blockSeparation + J) / 2);
                                                r = G;
                                                q = G + this.x;
                                                p = r - (this.smpOverlaysThicknessLeft + (this.margin * 2)) + (this.margin * (this.layoutValid ? -1 : -2));
                                                if (this.plotByVariable) {
                                                    for (var I = 0; I < this.varIndices.length; I++) {
                                                        for (var H = 0; H < c.length; H++) {
                                                            var y = H / this.smpLabelInterval;
                                                            if (parseInt(y) == parseFloat(y)) {
                                                                var m = c[H];
                                                                var K = this.shortenText(E[m], this.maxSmpStringLen);
                                                                var d = this.getSmpColor(E[m]);
                                                                this.smpInfo[H] = b;
                                                                if (this.smpLabelImage && CanvasXpress.cacheImages.hasOwnProperty(E[m] + ".png")) {} else {
                                                                    if (this.smpLabelRotate) {
                                                                        this.toRender({
                                                                            p: ["drawText", K, p - (this.smpLabelFontSize / 2), b, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180],
                                                                            a: this.getTextArea(K, p - (this.smpLabelFontSize / 2), b, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180),
                                                                            i: ["Smp-" + z],
                                                                            t: "Labels"
                                                                        })
                                                                    } else {
                                                                        this.toRender({
                                                                            p: ["drawText", K, p, b, this.smpLabelFont, d, "right", "middle"],
                                                                            a: this.getTextArea(K, p, b, this.smpLabelFont, d, "right", "middle"),
                                                                            i: ["Smp-" + z],
                                                                            t: "Labels"
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                            b += this.rowBlockSize
                                                        }
                                                        b += this.blockSeparation
                                                    }
                                                } else {
                                                    if (c) {
                                                        var s = 0;
                                                        for (var I = 0; I < c.length; I++) {
                                                            var z = c[I];
                                                            var y = I / this.smpLabelInterval;
                                                            var K = g ? g[z] : E[z];
                                                            var d = this.getSmpColor(E[z]);
                                                            if (parseInt(y) == parseFloat(y)) {
                                                                this.smpInfo[I] = b;
                                                                var n = g ? g[c[s]] : E[c[s]];
                                                                var L = this.isArray(n) ? n : n.toString().split(" :: ");
                                                                if (I > 0 && this.parseInt(this.smpInfo[I]) < this.parseInt(this.smpInfo[s] + this.smpLabelFontSize)) {
                                                                    if (this.isGroupedData && this.smpLabelRotate == 90) {
                                                                        K = this.isArray(K) ? K : K.toString().split(" :: ");
                                                                        for (var H = 0; H < K.length; H++) {
                                                                            e(I, H, b, p - (H * (this.smpLabelFontSize + this.margin)), d)
                                                                        }
                                                                    }
                                                                    b += this.blockSeparation + J;
                                                                    continue
                                                                }
                                                                if (this.isGroupedData && this.smpLabelRotate == 90) {
                                                                    var w = this.isArray(K) ? K : K.toString().split(" :: ");
                                                                    for (var H = 0; H < w.length; H++) {
                                                                        if (I > 0) {
                                                                            if (L[H] != w[H]) {
                                                                                delete x[w[H]]
                                                                            }
                                                                        }
                                                                        var N = w[H];
                                                                        var o = p - (H * (this.smpLabelFontSize + this.margin));
                                                                        var u = e(I, H, b, o, d);
                                                                        if (!x.hasOwnProperty(N)) {
                                                                            this.toRender({
                                                                                p: ["drawText", N, o - (this.smpLabelFontSize / 2), u, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180],
                                                                                a: this.getTextArea(N, o - (this.smpLabelFontSize / 2), u, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180),
                                                                                i: ["Smp-" + z],
                                                                                t: "Labels"
                                                                            });
                                                                            this.toRender({
                                                                                p: ["drawLine", "line", r - (this.margin * 2), u, r - this.margin, u, this.xAxisTickColor],
                                                                                t: "Labels"
                                                                            });
                                                                            x[N] = true
                                                                        }
                                                                    }
                                                                } else {
                                                                    K = this.shortenText(K, this.maxSmpStringLen);
                                                                    if (I > 0) {
                                                                        if (n != K) {
                                                                            x = {}
                                                                        }
                                                                    }
                                                                    var u = e(I, 0, b, p, d);
                                                                    if (!x.hasOwnProperty(K)) {
                                                                        if (this.smpLabelImage && CanvasXpress.cacheImages.hasOwnProperty(K + ".png")) {
                                                                            var o = this.getSampleLabelLength();
                                                                            var k = p + this.margin - (o / 2);
                                                                            this.toRender({
                                                                                p: ["drawShape", "image", k, u - (this.smpLabelFontSize / 2), o, o, false, false, this.smpLabelImageRound, false, false, false, false, false, false, K + ".png"],
                                                                                a: this.getShapeArea("image", k, u - (this.smpLabelFontSize / 2), o, o, false, false, this.smpLabelImageRound, false, false, false, false, false, false, K + ".png"),
                                                                                i: ["Smp-" + z],
                                                                                t: "Labels"
                                                                            })
                                                                        } else {
                                                                            if (this.smpLabelRotate) {
                                                                                this.toRender({
                                                                                    p: ["drawText", K, p - (this.smpLabelFontSize / 2), u, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180],
                                                                                    a: this.getTextArea(K, p - (this.smpLabelFontSize / 2), u, this.smpLabelFont, d, F, "middle", this.smpLabelRotate * Math.PI / 180),
                                                                                    i: ["Smp-" + z],
                                                                                    t: "Labels"
                                                                                })
                                                                            } else {
                                                                                this.toRender({
                                                                                    p: ["drawText", K, p, u, this.smpLabelFont, d, "right", "middle"],
                                                                                    a: this.getTextArea(K, p, u, this.smpLabelFont, d, "right", "middle"),
                                                                                    i: ["Smp-" + z],
                                                                                    t: "Labels"
                                                                                })
                                                                            }
                                                                        }
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", r - (this.margin * 2), u - this.margin, r - this.margin, u - this.margin, this.xAxisTickColor],
                                                                            t: "Labels"
                                                                        });
                                                                        x[K] = true
                                                                    }
                                                                }
                                                                s = I
                                                            }
                                                            b += this.blockSeparation + J
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.draw1DOverlaysDataPoints = function(D, G, O, ak, al, b, K, g, u, ae, ag, Y, V, B, x, H) {
                                    var ad, E, ap, I, w, J, e, ar;
                                    var R = ag;
                                    var L = Y;
                                    var A = [];
                                    var C = [];
                                    var ah = [];
                                    var N = {};
                                    var T = u >= 10 ? Math.min(u * 0.2, this.margin * 2) : u >= 5 ? 1 : 0;
                                    var S = T * 2;
                                    var af = 0;
                                    for (var aj = 0; aj < K.length; aj++) {
                                        N[K[aj]] = af;
                                        af++
                                    }
                                    if (ae == "vertical") {
                                        this.toRender({
                                            p: ["setClipArea", [ag, Y - g, this.x, g]],
                                            t: "Overlays"
                                        })
                                    } else {
                                        this.toRender({
                                            p: ["setClipArea", [ag, Y, g, this.y]],
                                            t: "Overlays"
                                        })
                                    }
                                    if (al != "Pie") {
                                        if (!B) {
                                            B = [];
                                            var r = [];
                                            if (al.match(/Stacked/)) {
                                                var m = false;
                                                for (var ai = 0; ai < ak.length; ai++) {
                                                    var f = 0;
                                                    var X = 0;
                                                    for (var aj = 0; aj < G.length; aj++) {
                                                        var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", G[aj]);
                                                        if (b[G[aj]]["type"].match(/Line/)) {
                                                            A.push(M)
                                                        } else {
                                                            if (M > 0) {
                                                                f += M
                                                            } else {
                                                                if (M < 0) {
                                                                    m = true;
                                                                    X += M
                                                                }
                                                            }
                                                        }
                                                    }
                                                    B.push(f);
                                                    r.push(X)
                                                }
                                                if (al.match(/StackedPercent/)) {
                                                    B = m ? [-100, 100] : [0, 100]
                                                } else {
                                                    if (m) {
                                                        B = B.concat(r)
                                                    } else {
                                                        B.push(0)
                                                    }
                                                    if (A.length > 0) {
                                                        ad = this.range(A);
                                                        ar = ad[1]
                                                    }
                                                }
                                            } else {
                                                for (var aj = 0; aj < G.length; aj++) {
                                                    for (var ai = 0; ai < ak.length; ai++) {
                                                        var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", G[aj]);
                                                        B.push(M)
                                                    }
                                                }
                                            }
                                        }
                                        if (al != "Treemap") {
                                            ad = this.range(B);
                                            if (ar > ad[1]) {
                                                ad[1] = ar
                                            }
                                            E = this[this.axisAlgorithm](ad[0], ad[1], 3, this.axisWilkinsonLoose);
                                            ap = Math.min(ad[0], E[0]);
                                            I = Math.max(ad[1], E[E.length - 1]);
                                            w = (g - 2) / (I - ap);
                                            J = ap < 0 ? Math.abs(ap) * w : 0;
                                            if (x) {
                                                e = u / x
                                            } else {
                                                af = 0;
                                                for (var aj = 0; aj < G.length; aj++) {
                                                    if (b[G[aj]]["type"] != "Line") {
                                                        if (b[G[aj]]["type"] == al) {
                                                            af++
                                                        }
                                                    } else {
                                                        af++
                                                    }
                                                }
                                                e = u / af
                                            }
                                        }
                                    }
                                    var Q = e >= 10 ? Math.min(e * 0.2, this.margin * 2) : e >= 5 ? 1 : 0;
                                    var P = Q * 2;
                                    switch (al) {
                                        case "Area":
                                        case "AreaLine":
                                            var an = [];
                                            var ao = [];
                                            var ac = [];
                                            var aq = [];
                                            for (var aj = 0; aj < G.length; aj++) {
                                                if (b[G[aj]]["type"].match(/Line/)) {
                                                    C.push(G[aj]);
                                                    continue
                                                }
                                                var W = [];
                                                for (var ai = 0; ai < ak.length; ai++) {
                                                    var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", G[aj]);
                                                    W.push(M)
                                                }
                                                an.push(W);
                                                ao.push(b[G[aj]]["color"]);
                                                ac.push("closed");
                                                aq.push([this.capitalize(D) + "Ovr-" + N[G[aj]]])
                                            }
                                            if (ae == "vertical") {
                                                this.drawAreaPlot(an, ag + (u / 2), Y, this.x - u, g, u, false, false, w, ap, I, ae, false, ao, ac, aq, false, V, false, true)
                                            } else {
                                                if (this.graphType == "Area") {
                                                    this.drawAreaPlot(an, ag, Y, g, (ak.length - 1) * u, u, false, false, w, ap, I, ae, false, ao, ac, aq, false, V, false, true)
                                                } else {
                                                    this.drawAreaPlot(an, ag, Y + (u / 2), g, (ak.length - 1) * u, u, false, false, w, ap, I, ae, false, ao, ac, aq, false, V, false, true)
                                                }
                                            }
                                            if (C.length > 0) {
                                                this.draw1DOverlaysDataPoints(D, C, O, ak, "Line", b, K, g, u, ae, R, L, V, B, C.length, H)
                                            }
                                            break;
                                        case "Bar":
                                        case "BarLine":
                                        case "Dotplot":
                                        case "DotLine":
                                        case "Line":
                                            var o = this.jitter;
                                            this.jitter = false;
                                            for (var aj = 0; aj < G.length; aj++) {
                                                if (b[G[aj]]["type"].match(/BarLine|DotLine/) && al != "Line") {
                                                    C.push(G[aj]);
                                                    continue
                                                }
                                                var an = [];
                                                var ao = [];
                                                var aa = [];
                                                var aq = [];
                                                var Z = [];
                                                var ac = [];
                                                if (al == "Dotplot") {
                                                    for (var ai = 0; ai < ak.length; ai++) {
                                                        var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", G[aj]);
                                                        an.push([M]);
                                                        ao.push([b[G[aj]]["color"]]);
                                                        aa.push([false]);
                                                        aq.push([
                                                            [this.capitalize(D) + "Ovr-" + ak[ai] + "-" + N[G[aj]]]
                                                        ]);
                                                        Z.push([this.margin]);
                                                        ac.push(["circle"])
                                                    }
                                                } else {
                                                    for (var ai = 0; ai < ak.length; ai++) {
                                                        var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", G[aj]);
                                                        an.push(M);
                                                        ao.push(b[G[aj]]["color"]);
                                                        aa.push(false);
                                                        aq.push([this.capitalize(D) + "Ovr-" + ak[ai] + "-" + N[G[aj]]])
                                                    }
                                                }
                                                if (al == "Bar") {
                                                    if (ae == "vertical") {
                                                        this.drawBarPlot(an, false, ag + Q, Y - J, e - P, u, w, J, ap, ae, ao, aa, aq, false, false, V, false, true)
                                                    } else {
                                                        this.drawBarPlot(an, false, ag, Y + Q, e - P, u, w, J, ap, ae, ao, aa, aq, false, false, V, false, true)
                                                    }
                                                } else {
                                                    if (al == "Line") {
                                                        if (ae == "vertical") {
                                                            this.drawLinePlot(an, false, ag + (u / 2), Y, e, u, w, ap, ae, ao[0], aa, false, aq, false, false, V, G[aj], true)
                                                        } else {
                                                            this.drawLinePlot(an, false, ag, Y + (u / 2), e, u, w, ap, ae, ao[0], aa, false, aq, false, false, V, G[aj], true)
                                                        }
                                                    } else {
                                                        if (al == "Dotplot") {
                                                            var ab = this.graphType;
                                                            this.graphType = "Dotplot";
                                                            if (ae == "vertical") {
                                                                this.drawDotPlot(an, false, ag + (u / 2), Y, e, u, w, ap, Z, ae, ao, aa, ac, aq, false, false, V, G[aj], false, true)
                                                            } else {
                                                                this.drawDotPlot(an, false, ag, Y + (u / 2), e, u, w, ap, Z, ae, ao, aa, ac, aq, false, false, V, G[aj], false, true)
                                                            }
                                                            this.graphType = ab
                                                        }
                                                    }
                                                }
                                                if (ae == "vertical" && al != "Line" && al != "Dotplot") {
                                                    ag += e
                                                } else {
                                                    if (ae == "horizontal" && al != "Line" && al != "Dotplot") {
                                                        Y += e
                                                    }
                                                }
                                            }
                                            if (C.length > 0) {
                                                this.draw1DOverlaysDataPoints(D, C, O, ak, "Line", b, K, g, u, ae, R, L, V, B, C.length, H)
                                            }
                                            this.jitter = o;
                                            break;
                                        case "Pie":
                                            this.showPieValues = false;
                                            for (var ai = 0; ai < ak.length; ai++) {
                                                this.pieColors = [];
                                                var an = [];
                                                var aq = [];
                                                for (var aj = 0; aj < G.length; aj++) {
                                                    var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", G[aj]);
                                                    this.pieColors.push(b[G[aj]]["color"]);
                                                    an.push(M);
                                                    aq.push([this.capitalize(D) + "Ovr-" + ak[ai] + "-" + N[G[aj]]])
                                                }
                                                var ac = this.setPieData(an);
                                                if (ae == "vertical") {
                                                    this.drawPie(ac, ag + (u / 2), Y - (g / 2), Math.min((g / 2), (u / 2)) - 2, aq);
                                                    ag += u
                                                } else {
                                                    if (ae == "horizontal") {
                                                        this.drawPie(ac, ag + (g / 2), Y + (u / 2), Math.min((g / 2), (u / 2)) - 2, aq);
                                                        Y += u
                                                    }
                                                }
                                            }
                                            break;
                                        case "Stacked":
                                        case "StackedLine":
                                        case "StackedPercent":
                                        case "StackedPercentLine":
                                            for (var aj = 0; aj < G.length; aj++) {
                                                if (b[G[aj]]["type"].match(/Line/)) {
                                                    C.push(G[aj])
                                                } else {
                                                    ah.push(G[aj])
                                                }
                                            }
                                            for (var ai = 0; ai < ak.length; ai++) {
                                                var an = [];
                                                var ao = [];
                                                var aq = [];
                                                var ac = [];
                                                var f = 0;
                                                var X = 0;
                                                for (var aj = 0; aj < ah.length; aj++) {
                                                    var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", ah[aj]);
                                                    if (M > 0) {
                                                        f += M
                                                    } else {
                                                        X += M
                                                    }
                                                }
                                                for (var aj = 0; aj < ah.length; aj++) {
                                                    var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", ah[aj]);
                                                    an.push(M);
                                                    ao.push(b[ah[aj]]["color"]);
                                                    ac.push(false);
                                                    aq.push([this.capitalize(D) + "Ovr-" + ak[ai] + "-" + N[G[aj]]])
                                                }
                                                this.drawStackedPlot(an, ag + (ae == "vertical" ? T : 0), Y + (ae == "horizontal" ? T : 0), u - S, false, al.match(/Percent/) ? true : false, [f, X], w, ap < 0 ? -ap * w : 0, ae, ao, ac, aq, false, V, false, true);
                                                if (ae == "vertical") {
                                                    ag += u
                                                } else {
                                                    if (ae == "horizontal") {
                                                        Y += u
                                                    }
                                                }
                                            }
                                            if (C.length > 0) {
                                                if (al.match(/Percent/)) {
                                                    var F = {};
                                                    for (var aj = 0; aj < C.length; aj++) {
                                                        var M = this.getMetadataValue(ak[ai], D == "smp" ? "x" : "z", C[aj]);
                                                        F[C[aj]] = [];
                                                        ad = this.range(O[C[aj]]);
                                                        for (var ai = 0; ai < ak.length; ai++) {
                                                            F[C[aj]][ak[ai]] = this.percentile(ad[0], ad[1], M)
                                                        }
                                                    }
                                                    this.draw1DOverlaysDataPoints(D, C, F, ak, "Line", b, K, g, u, ae, R, L, V, B, C.length, H)
                                                } else {
                                                    this.draw1DOverlaysDataPoints(D, C, O, ak, "Line", b, K, g, u, ae, R, L, V, B, C.length, H)
                                                }
                                            }
                                            break;
                                        case "Treemap":
                                            var F = {};
                                            var h = this.meta.data[D == "smp" ? "x" : "z"][G[0]];
                                            if (h.type == "String") {
                                                for (var aj = 0; aj < B.length; aj++) {
                                                    if (F.hasOwnProperty(B[aj])) {
                                                        F[B[aj]]++
                                                    } else {
                                                        F[B[aj]] = 1
                                                    }
                                                }
                                            } else {
                                                var v = this.isGroupedData ? this.data.w : this.data.y;
                                                for (var aj = 0; aj < ak.length; aj++) {
                                                    F[v.smps[ak[aj]]] = B[aj]
                                                }
                                            }
                                            var k;
                                            if (ae == "vertical") {
                                                k = this.getTreemapOverlay(F, h, this.x, g, ag, Y - g);
                                                this.drawTreemap(k, 0, 0)
                                            } else {
                                                if (ae == "horizontal") {
                                                    k = this.getTreemapOverlay(F, h, g, this.y, ag, Y);
                                                    this.drawTreemap(k, 0, 0)
                                                }
                                            }
                                            break
                                    }
                                    this.toRender({
                                        p: ["resetClipArea"],
                                        t: "Overlays"
                                    });
                                    if (al != "Pie" && al != "Treemap") {
                                        this.disableGradientTransparencyShadow();
                                        if (ae == "vertical" && !x) {
                                            var U = R - (this.margin * 1.5);
                                            for (var aj = 0; aj < E.length; aj++) {
                                                var y = ((E[aj] - ap) * w);
                                                var am = L - y;
                                                this.toRender({
                                                    p: ["drawLine", "line", R - this.margin, am, R, am, this.xAxisTickColor],
                                                    t: "Overlays"
                                                });
                                                this.toRender({
                                                    p: ["drawText", E[aj].toString(), U, am, this.overlayFont, this.overlayFontColor, "right", "middle"],
                                                    t: "Overlays"
                                                })
                                            }
                                            if (H) {
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", R + (this.x / 2), L - (g / 2), this.x, g, false, this.xAxisTickColor, "open", false, this.outlineWidth],
                                                    t: "Overlays"
                                                })
                                            } else {
                                                this.toRender({
                                                    p: ["drawLine", "line", R, L - g, R, L, this.xAxisTickColor],
                                                    t: "Overlays"
                                                })
                                            }
                                        } else {
                                            if (ae == "horizontal" && !x) {
                                                var am = L - (this.margin * 1.5);
                                                for (var aj = 0; aj < E.length; aj++) {
                                                    var y = ((E[aj] - ap) * w);
                                                    var U = V ? R + V - y : R + y;
                                                    this.toRender({
                                                        p: ["drawLine", "line", U, L - this.margin, U, L, this.xAxisTickColor],
                                                        t: "Overlays"
                                                    });
                                                    this.toRender({
                                                        p: ["drawText", E[aj].toString(), U, am, this.overlayFont, this.overlayFontColor, V ? "left" : "right", "middle", V ? -Math.PI / 2 : Math.PI / 2],
                                                        t: "Overlays"
                                                    })
                                                }
                                                if (H) {
                                                    this.toRender({
                                                        p: ["drawShape", "rectangle", R + (g / 2), L + (this.y / 2), g, this.y, false, this.xAxisTickColor, "open", false, this.outlineWidth],
                                                        t: "Overlays"
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawLine", "line", R, L, R + g, L, this.xAxisTickColor],
                                                        t: "Overlays"
                                                    })
                                                }
                                            }
                                        }
                                        this.enableGradientTransparencyShadow()
                                    }
                                };
                                this.getOverlayClipArea = function(d) {
                                    var b = this.get1DLeft();
                                    var c = this.get1DTop();
                                    switch (d) {
                                        case "top":
                                            return [b, this.marginTop + this.offsetY, b + this.x + 1, c];
                                        case "bottom":
                                            return [b, c + this.y, b + this.x + 1, c + this.y + this.bottom];
                                        case "right":
                                            return [b + this.x, c, b + this.x + this.right, c + this.y + 1];
                                        case "left":
                                            return [this.marginLeft + this.offsetX, c, b, c + this.y + 1];
                                        default:
                                            return false
                                    }
                                };
                                this.isDrawOverlayNames = function() {
                                    return !this.layoutValid;
                                    if (!this.layoutValid) {
                                        return true
                                    } else {
                                        if (this.layoutValid && this.data.l && this.data.l.weight && this.layoutCurrent == this.data.l.weight.length - 1) {
                                            return true
                                        } else {
                                            if (this.layoutValid && !this.layoutTopology) {
                                                return this.layoutAxis == 1
                                            } else {
                                                if (this.graphOrientation == "vertical") {
                                                    return (this.layoutCurrent + 1) % this.layoutRows
                                                } else {
                                                    if (this.graphOrientation == "horizontal") {
                                                        return (this.layoutCurrent + 1) % this.layoutCols
                                                    } else {
                                                        return false
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.draw1DOverlays = function() {
                                    var v, c, u, aa, r, Z, V, B, C, W, O, I, f;
                                    var y = {};
                                    var G = {};
                                    var Q = this.get1DLeft();
                                    var M = this.get1DTop();
                                    var e = this.get1DIndices();
                                    var P = this.meta.data;
                                    this.smpOverlayInfo = {};
                                    this.varOverlayInfo = {};
                                    var L = this;
                                    var H = function(j, i) {
                                        if (j.type == "Numeric") {
                                            return L.getColorForValue(j.colorBrew, i)
                                        } else {
                                            if (j.colorBy) {
                                                return j.colorBy[i]
                                            } else {
                                                if (j.colors) {
                                                    return j.colors[j.order[i]]
                                                }
                                            }
                                        }
                                    };
                                    if (this.graphType == "Treemap" || this.graphType == "TagCloud" || this.graphType == "Sankey" || this.graphType == "Tree" || this.graphType == "Meter") {
                                        return
                                    }
                                    if ((this.graphType == "BarLine" || this.graphType == "DotLine") && this.xAxis2Title) {
                                        var B = this.getVariablesVisibleByAxis("xAxis");
                                        var D = this.getVariablesVisibleByAxis("xAxis2");
                                        C = Math.max(B.length, D.length)
                                    } else {
                                        if (this.graphType.match(/Stacked|Line|Area|Heatmap/)) {
                                            C = 1
                                        } else {
                                            C = this.plotByVariable ? e.length : this.variableBlock
                                        }
                                    }
                                    if (this.showOverlays) {
                                        if (this.smpOverlays.length > 0) {
                                            O = 0;
                                            for (var S = 0; S < this.smpOverlays.length; S++) {
                                                G[this.smpOverlays[S]] = O;
                                                O++
                                            }
                                            V = C * this.rowBlockSize;
                                            W = this.isGroupedData ? this.data.w.factors : this.data.x;
                                            if (this.graphOrientation == "vertical") {
                                                c = M + this.y + this.margin;
                                                for (var S = 0; S < this.smpOverlays.length; S++) {
                                                    var E = this.smpOverlays[S];
                                                    var x = this.shortenText(E, this.maxOverlayStringLen);
                                                    if (E != "-") {
                                                        f = this.getOverlayClipArea(this.smpOverlayProperties[E]["position"]);
                                                        if (this.smpOverlayProperties[E]["position"] == "top" && !I) {
                                                            c = M - this.smpOverlaysThicknessTop;
                                                            I = true
                                                        }
                                                        v = this.graphType.match(/Area/) ? Q - ((V + this.blockSeparation) / 2) : Q;
                                                        u = V + this.blockSeparation;
                                                        r = 0;
                                                        aa = this.smpOverlayProperties[E]["thickness"] || this.overlaysThickness;
                                                        if (!this.smpOverlayProperties[E]["type"].match(/Heatmap|Text|Default|Increase|Decrease|Boolean/)) {
                                                            if (y.hasOwnProperty(E)) {
                                                                continue
                                                            }
                                                            var T = this.smpOverlayProperties[E]["type"];
                                                            var J = this.smpOverlayProperties[E]["position"];
                                                            var z = this.getOverlaysForTypePosition("smp", T, J);
                                                            var K = this.smpOverlayProperties[E]["showName"];
                                                            var A = this.smpOverlayProperties[E]["showBox"];
                                                            var b = [];
                                                            for (var R = 0; R < z.length; R++) {
                                                                b.unshift(z[R])
                                                            }
                                                            this.draw1DOverlaysDataPoints("smp", z, W, e, T, this.smpOverlayProperties, this.smpOverlays, aa, u, "vertical", v, c + aa, false, false, false, A);
                                                            if (this.isDrawOverlayNames()) {
                                                                v = this.graphType.match(/Area/) ? (Q + this.x + this.margin) + ((V + this.blockSeparation) / 2) : Q + this.x + this.margin;
                                                                Z = aa / (z.length + 1);
                                                                for (var R = 0; R < z.length; R++) {
                                                                    var N = b[R];
                                                                    y[N] = true;
                                                                    this.smpOverlayInfo[N] = c + (Z * (R + 1));
                                                                    if (K) {
                                                                        this.toRender({
                                                                            p: ["drawText", x, v, c + (Z * (R + 1)), this.overlayFont, this.smpOverlayProperties[N]["color"], "left", "middle", false, this.measureText(x, this.overlayFont)],
                                                                            a: this.getTextArea(x, v, c + (Z * (R + 1)), this.overlayFont, this.smpOverlayProperties[N]["color"], "left", "middle", false, this.measureText(x, this.overlayFont)),
                                                                            i: ["SmpOverlay-" + G[N]],
                                                                            t: "Overlays"
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                        } else {
                                                            var T = this.smpOverlayProperties[E]["type"];
                                                            var K = this.smpOverlayProperties[E]["showName"];
                                                            var w = this.smpOverlayProperties[E]["rotate"];
                                                            for (var R = 0; R < e.length; R++) {
                                                                var F = this.getMetadataValue(e[R], this.isGroupedData ? "w" : "x", E);
                                                                var g = F != null ? H(P.x[E], F) : this.missingDataColor;
                                                                var U = false;
                                                                if (R < e.length - 1) {
                                                                    U = this.getMetadataValue(e[R + 1], this.isGroupedData ? "w" : "x", E)
                                                                }
                                                                if (F === U && T != "Text" && T != "Boolean") {
                                                                    r += u;
                                                                    continue
                                                                }
                                                                if (T != "Text" && T != "Boolean") {
                                                                    var q = v;
                                                                    var p = v + u + r;
                                                                    var Y = c;
                                                                    var X = c + aa;
                                                                    if (T == "Increase") {
                                                                        this.toRender({
                                                                            p: ["drawShape", "path", [q, p, p, q],
                                                                                [X, Y, X, X], false, false, this.colors[2], false, false, false, false, true, f
                                                                            ],
                                                                            a: this.getShapeArea("path", [q, p, p, q], [X, Y, X, X], false, false, this.colors[2], false, false, false, false, true, f),
                                                                            i: ["SmpOvr-" + e[R] + "-" + S],
                                                                            h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                            t: "Overlays"
                                                                        })
                                                                    } else {
                                                                        if (T == "Decrease") {
                                                                            this.toRender({
                                                                                p: ["drawShape", "path", [q, p, q, q],
                                                                                    [Y, X, X, Y], false, false, this.colors[2], false, false, false, false, true, f
                                                                                ],
                                                                                a: this.getShapeArea("path", [q, p, q, q], [Y, X, X, Y], false, false, this.colors[2], false, false, false, false, true, f),
                                                                                i: ["SmpOvr-" + e[R] + "-" + S],
                                                                                h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                                t: "Overlays"
                                                                            })
                                                                        } else {
                                                                            this.toRender({
                                                                                p: ["drawShape", "rectangle", v + ((u + r) / 2), c + (aa / 2), u + r, aa, g, false, false, false, false, true, f],
                                                                                a: this.getShapeArea("rectangle", v + ((u + r) / 2), c + (aa / 2), u + r, aa, g, false, false, false, false, true, f),
                                                                                i: ["SmpOvr-" + e[R] + "-" + S],
                                                                                h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                                t: "Overlays"
                                                                            })
                                                                        }
                                                                    }
                                                                }
                                                                if ((this.showLevelOverlays || T == "Text") && T != "Boolean") {
                                                                    if (T == "Increase") {
                                                                        this.toRender({
                                                                            p: ["drawText", this.shortenText(F, this.overlayFontSize, u + r), v + (this.margin * 3), c + (this.margin * 3), this.overlayFont, this.overlayFontColor, "left", "middle", false, (u + r) - 2],
                                                                            t: "Overlays"
                                                                        })
                                                                    } else {
                                                                        if (T == "Decrease") {
                                                                            this.toRender({
                                                                                p: ["drawText", this.shortenText(F, this.overlayFontSize, u + r), v + u + r - (this.margin * 3), c + (this.margin * 3), this.overlayFont, this.overlayFontColor, "right", "middle", false, (u + r) - 2],
                                                                                t: "Overlays"
                                                                            })
                                                                        } else {
                                                                            if ((u + r) > aa && !w) {
                                                                                this.toRender({
                                                                                    p: ["drawText", this.shortenText(F, this.overlayFontSize, u + r), v + ((u + r) / 2), c + (aa / 2), this.overlayFont, this.overlayFontColor, "center", "middle", false, (u + r) - 2],
                                                                                    t: "Overlays"
                                                                                })
                                                                            } else {
                                                                                if (this.overlayFontSize < (u + r)) {
                                                                                    this.toRender({
                                                                                        p: ["drawText", this.shortenText(F, this.overlayFontSize, aa), v + ((u + r) / 2), c + (aa / 2), this.overlayFont, this.overlayFontColor, "center", "middle", -Math.PI / 2, aa - 2],
                                                                                        t: "Overlays"
                                                                                    })
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                if (T == "Boolean" && F) {
                                                                    this.toRender({
                                                                        p: ["drawShape", "rectangle", v + ((u + r) / 2), c + (aa / 2), aa / 2, aa / 2, "black", false, false, false, false, true, f],
                                                                        a: this.getShapeArea("rectangle", v + ((u + r) / 2), c + (aa / 2), aa / 2, aa / 2, "black", false, false, false, false, true, f),
                                                                        i: ["SmpOvr-" + e[R] + "-" + S],
                                                                        h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                        t: "Overlays"
                                                                    })
                                                                }
                                                                v += u + r;
                                                                r = 0
                                                            }
                                                            if (this.isDrawOverlayNames()) {
                                                                v = this.graphType.match(/Area/) ? (Q + this.x + this.margin) + ((V + this.blockSeparation) / 2) : Q + this.x + this.margin;
                                                                this.smpOverlayInfo[E] = c + (aa / 2);
                                                                if (K) {
                                                                    this.toRender({
                                                                        p: ["drawText", x, v, c + (aa / 2), this.overlayFont, this.overlayFontColor, "left", "middle", false, this.measureText(x, this.overlayFont)],
                                                                        a: this.getTextArea(x, v, c + (aa / 2), this.overlayFont, this.overlayFontColor, "left", "middle", false, this.measureText(x, this.overlayFont)),
                                                                        i: ["SmpOverlay-" + S],
                                                                        t: "Overlays"
                                                                    })
                                                                }
                                                            }
                                                        }
                                                        c += aa
                                                    } else {
                                                        if (E == "-") {
                                                            c += this.margin
                                                        }
                                                    }
                                                }
                                            } else {
                                                v = Q - this.smpOverlaysThicknessLeft;
                                                for (var S = 0; S < this.smpOverlays.length; S++) {
                                                    var E = this.smpOverlays[S];
                                                    var x = this.shortenText(E, this.maxOverlayStringLen);
                                                    if (E != "-") {
                                                        f = this.getOverlayClipArea(this.smpOverlayProperties[E]["position"]);
                                                        if (this.smpOverlayProperties[E]["position"] == "right" && !I) {
                                                            v = Q + this.x + this.margin;
                                                            I = true
                                                        }
                                                        u = this.smpOverlayProperties[E]["thickness"] || this.overlaysThickness;
                                                        c = this.graphType.match(/Area/) ? M - ((V + this.blockSeparation) / 2) : M;
                                                        aa = this.graphType != "Heatmap" ? V + this.blockSeparation : V;
                                                        Z = 0;
                                                        if (!this.smpOverlayProperties[E]["type"].match(/Heatmap|Text|Default|Increase|Decrease|Boolean/)) {
                                                            if (y.hasOwnProperty(E)) {
                                                                continue
                                                            }
                                                            var T = this.smpOverlayProperties[E]["type"];
                                                            var J = this.smpOverlayProperties[E]["position"];
                                                            var z = this.getOverlaysForTypePosition("smp", T, J);
                                                            var K = this.smpOverlayProperties[E]["showName"];
                                                            var A = this.smpOverlayProperties[E]["showBox"];
                                                            var b = [];
                                                            for (var R = 0; R < z.length; R++) {
                                                                b.unshift(z[R])
                                                            }
                                                            this.draw1DOverlaysDataPoints("smp", z, W, e, T, this.smpOverlayProperties, this.smpOverlays, u, aa, "horizontal", v, c, J == "left" ? u : false, false, false, A);
                                                            if (this.isDrawOverlayNames()) {
                                                                c = this.graphType.match(/Area/) ? (M + this.y + this.margin) + ((V + this.blockSeparation) / 2) : M + this.y + this.margin;
                                                                r = u / (z.length + 1);
                                                                for (var R = 0; R < z.length; R++) {
                                                                    var N = b[R];
                                                                    y[N] = true;
                                                                    this.smpOverlayInfo[N] = v + (r * (R + 1));
                                                                    if (K) {
                                                                        this.toRender({
                                                                            p: ["drawText", this.shortenText(N, this.maxOverlayStringLen), v + (r * (R + 1)), c, this.overlayFont, this.smpOverlayProperties[N]["color"], J == "left" ? "right" : "left", "middle", J == "left" ? -Math.PI / 2 : Math.PI / 2],
                                                                            a: this.getTextArea(this.shortenText(N, this.maxOverlayStringLen), v + (r * (R + 1)), c, this.overlayFont, this.smpOverlayProperties[N]["color"], J == "left" ? "right" : "left", "middle", J == "left" ? -Math.PI / 2 : Math.PI / 2),
                                                                            i: ["SmpOverlay-" + G[N]],
                                                                            t: "Overlays"
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                        } else {
                                                            var T = this.smpOverlayProperties[E]["type"];
                                                            var J = this.smpOverlayProperties[E]["position"];
                                                            var K = this.smpOverlayProperties[E]["showName"];
                                                            var w = this.smpOverlayProperties[E]["rotate"];
                                                            for (var R = 0; R < e.length; R++) {
                                                                var F = this.getMetadataValue(e[R], this.isGroupedData ? "w" : "x", E);
                                                                var g = F != null ? H(P.x[E], F) : this.missingDataColor;
                                                                var U = false;
                                                                if (R < e.length - 1) {
                                                                    U = this.getMetadataValue(e[R + 1], this.isGroupedData ? "w" : "x", E)
                                                                }
                                                                if (F === U && T != "Text" && T != "Boolean") {
                                                                    Z += aa;
                                                                    continue
                                                                }
                                                                if (T != "Text" && T != "Boolean") {
                                                                    var q = J == "left" ? v : v + u;
                                                                    var p = J == "left" ? v + u : v;
                                                                    var Y = c;
                                                                    var X = c + aa + Z;
                                                                    if (T == "Increase") {
                                                                        this.toRender({
                                                                            p: ["drawShape", "path", [p, p, q, p],
                                                                                [Y, X, X, Y], false, false, g, false, false, false, false, true, f
                                                                            ],
                                                                            a: this.getShapeArea("path", [p, p, q, p], [Y, X, X, Y], false, false, g, false, false, false, false, true, f),
                                                                            i: ["SmpOvr-" + e[R] + "-" + S],
                                                                            h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                            t: "Overlays"
                                                                        })
                                                                    } else {
                                                                        if (T == "Decrease") {
                                                                            this.toRender({
                                                                                p: ["drawShape", "path", [q, p, p, q],
                                                                                    [Y, Y, X, Y], false, false, g, false, false, false, false, true, f
                                                                                ],
                                                                                a: this.getShapeArea("path", [q, p, p, q], [Y, Y, X, Y], false, false, g, false, false, false, false, true, f),
                                                                                i: ["SmpOvr-" + e[R] + "-" + S],
                                                                                h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                                t: "Overlays"
                                                                            })
                                                                        } else {
                                                                            this.toRender({
                                                                                p: ["drawShape", "rectangle", v + (u / 2), c + ((aa + Z) / 2), u, aa + Z, g, false, false, false, false, true, f],
                                                                                a: this.getShapeArea("rectangle", v + (u / 2), c + ((aa + Z) / 2), u, aa + Z, g, false, false, false, false, true, f),
                                                                                i: ["SmpOvr-" + e[R] + "-" + S],
                                                                                h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                                t: "Overlays"
                                                                            })
                                                                        }
                                                                    }
                                                                }
                                                                if (this.graphType == "Heatmap" && this.heatmapSmpSeparateBy && this.heatmapSmpSeparateBy == E) {
                                                                    var Y = c + aa + Z;
                                                                    var d = Y - (this.heatmapSeparatorThickness - this.heatmapCellBoxWidth);
                                                                    var k = Y + (this.heatmapSeparatorThickness - this.heatmapCellBoxWidth);
                                                                    if (k < M + this.y - this.margin) {
                                                                        this.toRender({
                                                                            p: ["drawShape", "rectangle", Q - 1 + ((this.x + 1) / 2), d + (this.heatmapSeparatorThickness / 2), this.x + 1, this.heatmapSeparatorThickness, this.background, this.background],
                                                                            t: "Overlays"
                                                                        })
                                                                    }
                                                                }
                                                                if ((this.showLevelOverlays || T == "Text") && T != "Boolean") {
                                                                    if (T == "Increase") {
                                                                        this.toRender({
                                                                            p: ["drawText", this.shortenText(F, this.overlayFontSize, (aa + Z)), v + (J == "left" ? 0 : u) + (this.margin * 3 * (J == "left" ? 1 : -1)), c + (this.margin * 3), this.overlayFont, this.overlayFontColor, "left", "middle", J == "left" ? -Math.PI / 2 : Math.PI / 2, (aa + Z) - 2],
                                                                            t: "Overlays"
                                                                        })
                                                                    } else {
                                                                        if (T == "Decrease") {
                                                                            this.toRender({
                                                                                p: ["drawText", this.shortenText(F, this.overlayFontSize, (aa + Z)), v + (J == "left" ? 0 : u) + (this.margin * 3 * (J == "left" ? 1 : -1)), c + aa + Z - (this.margin * 3), this.overlayFont, this.overlayFontColor, "right", "middle", J == "left" ? -Math.PI / 2 : Math.PI / 2, (aa + Z) - 2],
                                                                                t: "Overlays"
                                                                            })
                                                                        } else {
                                                                            if ((aa + Z) > u && !w) {
                                                                                this.toRender({
                                                                                    p: ["drawText", this.shortenText(F, this.overlayFontSize, (aa + Z)), v + (u / 2), c + ((aa + Z) / 2), this.overlayFont, this.overlayFontColor, "center", "middle", J == "left" ? -Math.PI / 2 : Math.PI / 2, (aa + Z) - 2],
                                                                                    t: "Overlays"
                                                                                })
                                                                            } else {
                                                                                if (this.overlayFontSize < (aa + Z)) {
                                                                                    this.toRender({
                                                                                        p: ["drawText", this.shortenText(F, this.overlayFontSize, u), v + (u / 2), c + ((aa + Z) / 2), this.overlayFont, this.overlayFontColor, "center", "middle", false, u - 2],
                                                                                        t: "Overlays"
                                                                                    })
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                if (T == "Boolean" && F) {
                                                                    this.toRender({
                                                                        p: ["drawShape", "rectangle", v + (u / 2), c + ((aa + Z) / 2), u / 2, u / 2, "black", false, false, false, false, true, f],
                                                                        a: this.getShapeArea("rectangle", v + (u / 2), c + ((aa + Z) / 2), u / 2, u / 2, "black", false, false, false, false, true, f),
                                                                        i: ["SmpOvr-" + e[R] + "-" + S],
                                                                        h: this.isHidden(false, false, "Property:" + E + ":" + F + ":x"),
                                                                        t: "Overlays"
                                                                    })
                                                                }
                                                                c += aa + Z;
                                                                Z = 0
                                                            }
                                                            if (this.isDrawOverlayNames()) {
                                                                c = this.graphType.match(/Area/) ? (M + this.y + this.margin) + ((V + this.blockSeparation) / 2) : M + this.y + this.margin;
                                                                this.smpOverlayInfo[E] = v + (u / 2);
                                                                if (K) {
                                                                    this.toRender({
                                                                        p: ["drawText", x, v + (u / 2), c, this.overlayFont, this.overlayFontColor, J == "left" ? "right" : "left", "middle", J == "left" ? -Math.PI / 2 : Math.PI / 2],
                                                                        a: this.getTextArea(x, v + (u / 2), c, this.overlayFont, this.overlayFontColor, J == "left" ? "right" : "left", "middle", J == "left" ? -Math.PI / 2 : Math.PI / 2),
                                                                        i: ["SmpOverlay-" + G[x]],
                                                                        t: "Overlays"
                                                                    })
                                                                }
                                                            }
                                                        }
                                                        v += u
                                                    } else {
                                                        if (E == "-") {
                                                            v += this.margin
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        y = {};
                                        I = false;
                                        if (this.varOverlays.length > 0 && this.graphType == "Heatmap") {
                                            O = 0;
                                            for (var S = 0; S < this.varOverlays.length; S++) {
                                                G[this.varOverlays[S]] = O;
                                                O++
                                            }
                                            c = M + this.y + this.margin;
                                            for (var S = 0; S < this.varOverlays.length; S++) {
                                                var E = this.varOverlays[S];
                                                var x = this.shortenText(E, this.maxOverlayStringLen);
                                                if (E != "-") {
                                                    f = this.getOverlayClipArea(this.varOverlayProperties[E]["position"]);
                                                    if (this.varOverlayProperties[E]["position"] == "top" && !I) {
                                                        c = M - this.varOverlaysThicknessTop;
                                                        I = true
                                                    }
                                                    v = Q + (this.colBlockSize / 2);
                                                    u = 0;
                                                    aa = this.varOverlayProperties[E]["thickness"] || this.overlaysThickness;
                                                    if (!this.varOverlayProperties[E]["type"].match(/Heatmap|Text|Default|Increase|Decrease|Boolean/)) {
                                                        if (y.hasOwnProperty(E)) {
                                                            continue
                                                        }
                                                        var T = this.varOverlayProperties[E]["type"];
                                                        var J = this.varOverlayProperties[E]["position"];
                                                        var z = this.getOverlaysForTypePosition("var", T, J);
                                                        var K = this.varOverlayProperties[E]["showName"];
                                                        var A = this.varOverlayProperties[E]["showBox"];
                                                        var b = [];
                                                        for (var R = 0; R < z.length; R++) {
                                                            b.unshift(z[R])
                                                        }
                                                        this.draw1DOverlaysDataPoints("var", z, this.data.z, this.varIndices, T, this.varOverlayProperties, this.varOverlays, aa, this.colBlockSize, "vertical", v - (this.colBlockSize / 2), c + aa, false, false, false, A);
                                                        v = Q + (this.colBlockSize * this.varIndices.length) + this.margin;
                                                        Z = aa / (z.length + 1);
                                                        for (var R = 0; R < z.length; R++) {
                                                            var N = b[R];
                                                            var x = this.shortenText(N, this.maxOverlayStringLen);
                                                            y[N] = true;
                                                            this.varOverlayInfo[N] = c + (Z * (R + 1));
                                                            if (K) {
                                                                this.toRender({
                                                                    p: ["drawText", x, v, c + (Z * (R + 1)), this.overlayFont, this.varOverlayProperties[N]["color"], "left", "middle", false, this.measureText(x, this.overlayFont)],
                                                                    a: this.getTextArea(x, v, c + (Z * (R + 1)), this.overlayFont, this.varOverlayProperties[N]["color"], "left", "middle", false, this.measureText(x, this.overlayFont)),
                                                                    i: ["VarOverlay-" + G[N]],
                                                                    t: "Overlays"
                                                                })
                                                            }
                                                        }
                                                    } else {
                                                        var T = this.varOverlayProperties[E]["type"];
                                                        var K = this.varOverlayProperties[E]["showName"];
                                                        var w = this.varOverlayProperties[E]["rotate"];
                                                        for (var R = 0; R < this.varIndices.length; R++) {
                                                            var F = this.getMetadataValue(this.varIndices[R], "z", E);
                                                            var g = F != null ? H(P.z[E], F) : this.missingDataColor;
                                                            var U = R < this.varIndices.length - 1 ? this.getMetadataValue(this.varIndices[R + 1], "z", E) : false;
                                                            if (F == U && T != "Text" && T != "Boolean") {
                                                                u += this.colBlockSize;
                                                                continue
                                                            }
                                                            if (T != "Text" && T != "Boolean") {
                                                                var q = v - (this.colBlockSize / 2);
                                                                var p = q + this.colBlockSize + u;
                                                                var Y = c;
                                                                var X = c + aa;
                                                                if (T == "Increase") {
                                                                    this.toRender({
                                                                        p: ["drawShape", "path", [q, p, p, q],
                                                                            [X, Y, X, X], false, false, g, false, false, false, false, true, f
                                                                        ],
                                                                        a: this.getShapeArea("path", [q, p, p, q], [X, Y, X, X], false, false, g, false, false, false, false, true, f),
                                                                        i: ["VarOvr-" + this.varIndices[R] + "-" + S],
                                                                        h: this.isHidden(false, false, "Property:" + E + ":" + F + ":z"),
                                                                        t: "Overlays"
                                                                    })
                                                                } else {
                                                                    if (T == "Decrease") {
                                                                        this.toRender({
                                                                            p: ["drawShape", "path", [q, p, q, q],
                                                                                [Y, X, X, Y], false, false, g, false, false, false, false, true, f
                                                                            ],
                                                                            a: this.getShapeArea("path", [q, p, q, q], [Y, X, X, Y], false, false, g, false, false, false, false, true, f),
                                                                            i: ["VarOvr-" + this.varIndices[R] + "-" + S],
                                                                            h: this.isHidden(false, false, "Property:" + E + ":" + F + ":z"),
                                                                            t: "Overlays"
                                                                        })
                                                                    } else {
                                                                        this.toRender({
                                                                            p: ["drawShape", "rectangle", (v - (this.colBlockSize / 2)) + ((this.colBlockSize + u) / 2), c + (aa / 2), this.colBlockSize + u, aa, g, false, false, false, false, true, f],
                                                                            a: this.getShapeArea("rectangle", (v - (this.colBlockSize / 2)) + ((this.colBlockSize + u) / 2), c + (aa / 2), this.colBlockSize + u, aa, g, false, false, false, false, true, f),
                                                                            i: ["VarOvr-" + this.varIndices[R] + "-" + S],
                                                                            h: this.isHidden(false, false, "Property:" + E + ":" + F + ":z"),
                                                                            t: "Overlays"
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                            if (this.graphType == "Heatmap" && this.heatmapVarSeparateBy && this.heatmapVarSeparateBy == E) {
                                                                var q = (v - (this.colBlockSize / 2)) + this.colBlockSize + u;
                                                                var s = q - (this.heatmapSeparatorThickness - this.heatmapCellBoxWidth);
                                                                var h = q + (this.heatmapSeparatorThickness - this.heatmapCellBoxWidth);
                                                                if (h < Q + this.x - this.margin) {
                                                                    this.toRender({
                                                                        p: ["drawShape", "rectangle", s + (this.heatmapSeparatorThickness / 2), (M - 1) + ((this.y + 1) / 2), this.heatmapSeparatorThickness, this.y + 1, this.background, this.background],
                                                                        t: "Overlays"
                                                                    })
                                                                }
                                                            }
                                                            if ((this.showLevelOverlays || T == "Text") && T != "Boolean") {
                                                                if (T == "Increase") {
                                                                    this.toRender({
                                                                        p: ["drawText", this.shortenText(F, this.overlayFontSize, this.colBlockSize + u), v + this.margin, c + this.margin, this.overlayFont, this.overlayFontColor, "left", "middle", false, (this.colBlockSize + u) - 2],
                                                                        t: "Overlays"
                                                                    })
                                                                } else {
                                                                    if (T == "Decrease") {
                                                                        this.toRender({
                                                                            p: ["drawText", this.shortenText(F, this.overlayFontSize, this.colBlockSize + u), v + u - this.margin, c + this.margin, this.overlayFont, this.overlayFontColor, "right", "middle", false, (this.colBlockSize + u) - 2],
                                                                            t: "Overlays"
                                                                        })
                                                                    } else {
                                                                        if (this.colBlockSize + u > aa && !w) {
                                                                            this.toRender({
                                                                                p: ["drawText", this.shortenText(F, this.overlayFontSize, this.colBlockSize + u), v + (u / 2), c + (aa / 2), this.overlayFont, this.overlayFontColor, "center", "middle", false, (this.colBlockSize + u) - 2],
                                                                                t: "Overlays"
                                                                            })
                                                                        } else {
                                                                            if (this.overlayFontSize < this.colBlockSize + u) {
                                                                                this.toRender({
                                                                                    p: ["drawText", this.shortenText(F, this.overlayFontSize, aa), v + (u / 2), c + (aa / 2), this.overlayFont, this.overlayFontColor, "center", "middle", -Math.PI / 2, aa - 2],
                                                                                    t: "Overlays"
                                                                                })
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            if (T == "Boolean" && F) {
                                                                this.toRender({
                                                                    p: ["drawShape", "rectangle", (v - (this.colBlockSize / 2)) + ((this.colBlockSize + u) / 2), c + (aa / 2), aa / 2, aa / 2, "black", false, false, false, false, true, f],
                                                                    a: this.getShapeArea("rectangle", (v - (this.colBlockSize / 2)) + ((this.colBlockSize + u) / 2), c + (aa / 2), aa / 2, aa / 2, "black", false, false, false, false, true, f),
                                                                    i: ["VarOvr-" + this.varIndices[R] + "-" + S],
                                                                    h: this.isHidden(false, false, "Property:" + E + ":" + F + ":z"),
                                                                    t: "Overlays"
                                                                })
                                                            }
                                                            v += this.colBlockSize + u;
                                                            u = 0
                                                        }
                                                        v = Q + (this.colBlockSize * this.varIndices.length) + this.margin;
                                                        this.varOverlayInfo[E] = c + (aa / 2);
                                                        if (K) {
                                                            this.toRender({
                                                                p: ["drawText", x, v, c + (aa / 2), this.overlayFont, this.overlayFontColor, "left", "middle", false, this.measureText(x, this.overlayFont)],
                                                                a: this.getTextArea(x, v, c + (aa / 2), this.overlayFont, this.overlayFontColor, "left", "middle", false, this.measureText(x, this.overlayFont)),
                                                                i: ["VarOverlay-" + G[x]],
                                                                t: "Overlays"
                                                            })
                                                        }
                                                    }
                                                    c += aa
                                                } else {
                                                    if (E == "-") {
                                                        c += this.margin
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.getAxisDescription = function(f, d) {
                                    var e;
                                    var b = {
                                        standardDeviation: "Std Dev.",
                                        standardErrorMean: "Std Error of Mean",
                                        confidenceInterval95: "95% CI"
                                    };
                                    var c = this.graphType != "Boxplot" && !this.graphType.match(/stacked/i) && this.graphType != "Treemap";
                                    if (f) {
                                        if (this.getLayoutConfig("xAxis2Title") && !d) {
                                            return this.getLayoutConfig("xAxis2Title")
                                        }
                                        if ((this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/) && this.xAxis2Values.length > 0 && this.barType != "swimmer") || d) {
                                            e = this.xAxis2Title ? this.xAxis2Title + " (Lines)" : d ? "" : "(Lines)";
                                            if (this.showErrorBars && this.isGroupedData && c) {
                                                if (e != "") {
                                                    e = e + "; Error bars are the " + b[this.errorBarsType]
                                                } else {
                                                    e = "Error bars are the " + b[this.errorBarsType]
                                                }
                                            }
                                        } else {
                                            e = this.xAxis2Title ? this.xAxis2Title : ""
                                        }
                                    } else {
                                        if (this.getLayoutConfig("xAxisTitle") && !d) {
                                            return this.getLayoutConfig("xAxisTitle")
                                        }
                                        e = this.xAxisTitle ? this.xAxisTitle : "";
                                        if (this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/) && this.xAxisValues.length > 0 && this.barType != "swimmer") {
                                            if (this.graphType.match(/BarLine|StackedLine|StackedPercentLine/)) {
                                                e = e + " (Bars)"
                                            } else {
                                                if (this.graphType.match(/DotLine/)) {
                                                    e = e + " (Dots)"
                                                } else {
                                                    if (this.graphType == "AreaLine") {
                                                        e = e + " (Area)"
                                                    }
                                                }
                                            }
                                        }
                                        if (this.showErrorBars && (this.isGroupedData || (this.layoutValid && this.data.l && this.data.l.group && c)) && c && this.barType != "swimmer") {
                                            if (e != "") {
                                                e = e + "; Error bars are the " + b[this.errorBarsType]
                                            } else {
                                                e = "Error bars are the " + b[this.errorBarsType]
                                            }
                                        }
                                    }
                                    return this.transformData ? this.transformData + " " + e : e
                                };
                                this.draw1DXLayout = function() {
                                    var u, g, o, p, y, m, v, c, d, b;
                                    var n = this.get1DLeft();
                                    var f = this.get1DTop();
                                    var k = this.graphType == "Gantt" ? 1 : this.layoutComb ? 0 : 0;
                                    var x = this.graphType == "Gantt" ? 1 : this.layoutComb ? 1 : 0;
                                    var e = this;
                                    var j = function(i, h) {
                                        if (e.graphType == "Gantt") {
                                            return e.dateFormat(i, ":yyyy:mmm dd").replace(/:/g, "\n")
                                        } else {
                                            if (e.xAxisTransform && e.xAxisTransform.match(/log|exp/) && !e.xAxisTransformTicks) {
                                                return e.formatAxisValue(e.transformValue(e.xAxisTransform, i, true), h || "xAxis")
                                            } else {
                                                if (e.isTransformedData && e.isTransformedData.match(/log|exp/) && !e.xAxisTransformTicks) {
                                                    return e.formatAxisValue(e.transformValue(e.isTransformedData, i, true), h || "xAxis")
                                                } else {
                                                    return e.formatAxisValue(y, h || "xAxis")
                                                }
                                            }
                                        }
                                    };
                                    if (this.graphType == "Treemap" || this.graphType == "TagCloud" || this.graphType == "ParallelCoordinates" || this.graphType == "Sankey" || this.graphType == "Tree" || (this.graphType == "Meter" && !this.meterType.match(this.graphOrientation))) {
                                        return
                                    }
                                    if (!this.layoutValid) {
                                        this.layoutAxis = 3
                                    }
                                    if (this.graphType == "Heatmap") {
                                        var s = this.getHeatmapIndicatorHeight();
                                        if (this.showHeatmapIndicator) {
                                            if (this.layoutValid) {
                                                v = (this.width / 2) - (this.heatmapIndicatorWidth / 2);
                                                c = this.height - this.layoutBottom
                                            } else {
                                                if (this.heatmapIndicatorPosition == "right") {
                                                    this.heatmapIndicatorY = f;
                                                    v = this.width - (this.marginRight + this.getHeatmapIndicatorWidth())
                                                } else {
                                                    if (this.heatmapIndicatorPosition == "top") {
                                                        v = (n + (this.x / 2)) - (this.heatmapIndicatorWidth / 2)
                                                    } else {
                                                        if (this.heatmapIndicatorPosition == "topLeft") {
                                                            if (this.left > (this.heatmapIndicatorWidth + (this.margin * 6))) {
                                                                v = n - (this.heatmapIndicatorWidth + (this.margin * 4))
                                                            } else {
                                                                v = this.marginLeft + this.offsetX + (this.margin * 6)
                                                            }
                                                        } else {
                                                            if (this.right > (this.heatmapIndicatorWidth + (this.margin * 6))) {
                                                                v = n + this.x + (this.margin * 2)
                                                            } else {
                                                                v = this.width - (this.marginRight + (this.heatmapIndicatorWidth + (this.margin * 6)))
                                                            }
                                                        }
                                                    }
                                                }
                                                c = this.heatmapIndicatorY
                                            }
                                            if (!this.layoutValid && this.heatmapIndicatorPosition != "right") {
                                                if (this.varDendrogramPosition == "top") {
                                                    c -= this.getVarTreeHeight()
                                                }
                                                c -= this.varOverlaysThicknessTop;
                                                if (this.varTitleLabelPosition != "bottom") {
                                                    c -= this.getVariableTitleHeight();
                                                    c -= this.getVariableLabelLength()
                                                }
                                                c -= this.margin
                                            }
                                            if (!this.isOncoprint) {
                                                var r = this.colorBy;
                                                var w = this.outlineBy;
                                                this.colorBy = false;
                                                this.outlineBy = false;
                                                this.drawColorIndicator(v, c, this.getDefaultMetaDataObject(), this.xAxisTitle ? this.xAxisTitle : false, true);
                                                this.colorBy = r;
                                                this.outlineBy = w
                                            }
                                        }
                                    } else {
                                        if ((this.xAxisTransform && this.xAxisTransform.match(/log/) && !this.xAxisTransformTicks) || (this.isTransformedData && this.isTransformedData.match(/log|exp/) && !this.xAxisTransformTicks)) {
                                            this.xAxisDecs = parseInt(Math.abs(this.xAxisMin))
                                        }
                                        if (this.graphOrientation == "vertical") {
                                            b = this.xAxisMin < 0 ? f + this.y - ((0 - this.xAxisMin) * this.xAxisUnit) : f + this.y;
                                            if (this.xAxisShow && (this.layoutAxis == 1 || this.layoutAxis == 3)) {
                                                if (this.xAxisTitle && this.xAxisTitle != "") {
                                                    v = n + (this.axisTitleFontSize / 2) - this.getAxisTitleTickLength();
                                                    c = f + (this.y / 2);
                                                    u = this.getAxisDescription();
                                                    this.toRender({
                                                        p: ["drawText", u, v, c, this.axisTitleFont, this.axisTitleColor, "center", "middle", -Math.PI / 2],
                                                        t: "Axes"
                                                    })
                                                }
                                                p = "right";
                                                g = this.xAxisValuesRaw;
                                                v = n - (this.margin * 2);
                                                for (var q = k; q < g.length - x; q++) {
                                                    y = this.xAxisValuesRaw[q];
                                                    if (y >= this.xAxisMin && (this.graphType == "Meter" ? y <= this.xAxisMax : y < this.xAxisMax)) {
                                                        m = j(y);
                                                        c = f + this.y - ((y - this.xAxisMin) * this.xAxisUnit);
                                                        this.toRender({
                                                            p: ["drawText", m, v, c, this.axisTickFont, this.axisTickColor, "right", "middle"],
                                                            b: b,
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                            }
                                            if (this.xAxis2Show && (this.layoutAxis == 2 || this.layoutAxis == 3) && this.graphType != "Meter") {
                                                p = "left";
                                                v = n + this.x + (this.margin * 2);
                                                if (this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/) && this.xAxis2Values.length > 0) {
                                                    b = this.xAxis2Min < 0 ? f + this.y - ((0 - this.xAxis2Min) * this.xAxis2Unit) : f + this.y;
                                                    for (var q = k; q < this.xAxis2Values.length - x; q++) {
                                                        y = this.xAxis2ValuesRaw[q];
                                                        if (y >= this.xAxis2Min && y < this.xAxis2Max) {
                                                            m = j(y, "xAxis2");
                                                            c = f + this.y - ((y - this.xAxis2Min) * this.xAxis2Unit);
                                                            this.toRender({
                                                                p: ["drawText", m, v, c, this.axisTickFont, this.axisTickColor, "left", "middle"],
                                                                b: b,
                                                                t: "Axes"
                                                            })
                                                        }
                                                    }
                                                } else {
                                                    b = this.xAxisMin < 0 ? f + this.y - ((0 - this.xAxisMin) * this.xAxisUnit) : f + this.y;
                                                    g = this.xAxisValuesRaw;
                                                    for (var q = k; q < g.length - x; q++) {
                                                        y = g[q];
                                                        if (y >= this.xAxisMin && y < this.xAxisMax) {
                                                            m = j(y);
                                                            c = f + this.y - ((y - this.xAxisMin) * this.xAxisUnit);
                                                            this.toRender({
                                                                p: ["drawText", m, v, c, this.axisTickFont, this.axisTickColor, "left", "middle"],
                                                                b: b,
                                                                t: "Axes"
                                                            })
                                                        }
                                                    }
                                                }
                                                if (this.xAxis2Title != "") {
                                                    v = n + this.x + this.getAxisTitleTickLength(true) - (this.axisTitleFontSize / 2);
                                                    c = f + (this.y / 2);
                                                    u = this.getAxisDescription(true);
                                                    this.toRender({
                                                        p: ["drawText", u, v, c, this.axisTitleFont, this.axisTitleColor, "center", "middle", -Math.PI / 2],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        } else {
                                            b = this.xAxisMin < 0 ? n + this.x - ((0 - this.xAxisMin) * this.xAxisUnit) : n;
                                            if (this.xAxisShow && (this.layoutAxis == 1 || this.layoutAxis == 3)) {
                                                if (this.xAxisTitle && this.xAxisTitle != "") {
                                                    v = n + (this.x / 2);
                                                    c = f - ((this.margin * 4) + this.axisTickFontSize + (this.axisTitleFontSize / 2));
                                                    u = this.getAxisDescription();
                                                    this.toRender({
                                                        p: ["drawText", u, v, c, this.axisTitleFont, this.axisTitleColor, "center", "middle"],
                                                        t: "Axes"
                                                    })
                                                }
                                                g = this.xAxisValuesRaw;
                                                c = f - ((this.margin * 2) + (this.axisTickFontSize / 2));
                                                if (this.layoutValid && this.layoutType == "wrap") {
                                                    c -= (this.segregateVariablesBy.length + this.segregateSamplesBy.length) * this.layoutLabelBoxThickness
                                                }
                                                for (var q = k; q < g.length - x; q++) {
                                                    y = g[q];
                                                    if (y >= this.xAxisMin && (this.graphType == "Meter" ? y <= this.xAxisMax : y < this.xAxisMax)) {
                                                        m = j(y);
                                                        if (this.invertGraph) {
                                                            v = n + this.x - ((y - this.xAxisMin) * this.xAxisUnit)
                                                        } else {
                                                            v = n + ((y - this.xAxisMin) * this.xAxisUnit)
                                                        }
                                                        this.toRender({
                                                            p: ["drawText", m, v, c, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                            b: b,
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                            }
                                            if (this.xAxis2Show && (this.layoutAxis == 2 || this.layoutAxis == 3) && this.graphType != "Meter") {
                                                c = f + this.y + (this.margin * 2) + (this.axisTickFontSize / 2);
                                                if (this.graphType.match(/BarLine|DotLine|AreaLine|StackedLine|StackedPercentLine/) && this.xAxis2Values.length > 0) {
                                                    b = this.xAxis2Min < 0 ? n + this.x - ((0 - this.xAxis2Min) * this.xAxis2Unit) : n;
                                                    for (var q = k; q < this.xAxis2Values.length - x; q++) {
                                                        y = this.xAxis2ValuesRaw[q];
                                                        if (y >= this.xAxis2Min && y < this.xAxis2Max) {
                                                            m = j(y, "xAxis2");
                                                            if (this.invertGraph) {
                                                                v = n + this.x - ((y - this.xAxis2Min) * this.xAxis2Unit)
                                                            } else {
                                                                v = n + ((y - this.xAxis2Min) * this.xAxis2Unit)
                                                            }
                                                            this.toRender({
                                                                p: ["drawText", m, v, c, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                                b: b,
                                                                t: "Axes"
                                                            })
                                                        }
                                                    }
                                                } else {
                                                    b = this.xAxisMin < 0 ? n + this.x - ((0 - this.xAxisMin) * this.xAxisUnit) : n;
                                                    g = this.xAxisValuesRaw;
                                                    for (var q = k; q < g.length - x; q++) {
                                                        y = g[q];
                                                        if (y >= this.xAxisMin && y < this.xAxisMax) {
                                                            m = j(y);
                                                            if (this.invertGraph) {
                                                                v = n + this.x - ((y - this.xAxisMin) * this.xAxisUnit)
                                                            } else {
                                                                v = n + ((y - this.xAxisMin) * this.xAxisUnit)
                                                            }
                                                            this.toRender({
                                                                p: ["drawText", m, v, c, this.axisTickFont, this.axisTickColor, "center", "middle"],
                                                                b: b,
                                                                t: "Axes"
                                                            })
                                                        }
                                                    }
                                                }
                                                if (this.xAxis2Title != "") {
                                                    v = n + (this.x / 2);
                                                    c = f + this.y + (this.margin * 3) + this.axisTickFontSize + (this.axisTitleFontSize / 2);
                                                    u = this.getAxisDescription(true);
                                                    this.toRender({
                                                        p: ["drawText", u, v, c, this.axisTitleFont, this.axisTitleColor, "center", "middle"],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                        if (this.plotBox) {
                                            this.disableGradientTransparencyShadow();
                                            this.toRender({
                                                p: ["drawShape", "rectangle", n + (this.x / 2), f + (this.y / 2), this.x, this.y, this.plotBoxColor, this.plotBoxColor, "open", false, this.outlineWidth],
                                                t: "Axes"
                                            });
                                            this.enableGradientTransparencyShadow()
                                        }
                                    }
                                };
                                this.draw1DDataPoints = function() {
                                    if (this.smpIndices && this.smpIndices.length < 1) {
                                        return
                                    }
                                    if (!this.currentErrorBarsType) {
                                        this.currentErrorBarsType = this.errorBarsType
                                    }
                                    if (this.currentErrorBarsType != this.errorBarsType && this.isGroupedData) {
                                        this.regroupSamples();
                                        this.currentErrorBarsType = this.errorBarsType
                                    }
                                    this.toRender({
                                        p: ["setClipArea", this.setClipBoundaries()],
                                        t: "Data"
                                    });
                                    switch (this.graphType) {
                                        case "Bar":
                                            if (this.stackBy) {
                                                this.draw1DStackedDataPoints()
                                            } else {
                                                this.draw1DBarDataPoints(this.varIndices, "xAxis", this.varIndices.length);
                                                if (this.barType == "lollipop") {
                                                    this.draw1DDotplotDataPoints(false, false, this.varIndices.length)
                                                }
                                            }
                                            break;
                                        case "Line":
                                        case "ParallelCoordinates":
                                            this.draw1DLineDataPoints(this.varIndices, "xAxis");
                                            break;
                                        case "BarLine":
                                            this.draw1DBarDataPoints(this.xAxisVarIndices, "xAxis", Math.max(this.xAxisVarIndices.length, this.xAxis2VarIndices.length));
                                            this.draw1DLineDataPoints(this.xAxis2VarIndices, "xAxis2", Math.max(this.xAxisVarIndices.length, this.xAxis2VarIndices.length));
                                            break;
                                        case "Stacked":
                                        case "StackedPercent":
                                            this.draw1DStackedDataPoints();
                                            break;
                                        case "StackedLine":
                                        case "StackedPercentLine":
                                            this.draw1DStackedDataPoints();
                                            this.draw1DLineDataPoints(this.xAxis2VarIndices, "xAxis2");
                                            break;
                                        case "Area":
                                            this.draw1DAreaDataPoints(this.varIndices, "xAxis");
                                            break;
                                        case "AreaLine":
                                            this.draw1DAreaDataPoints(this.xAxisVarIndices, "xAxis");
                                            this.draw1DAreaDataPoints(this.xAxis2VarIndices, "xAxis2", true);
                                            break;
                                        case "Boxplot":
                                            if (this.showBoxplotOriginalData) {
                                                this.draw1DBoxplotDataPoints(true, false);
                                                this.draw1DDotplotDataPoints(true, true, this.varIndices.length)
                                            } else {
                                                if (this.showViolinBoxplot) {
                                                    this.draw1DDotplotDataPoints(true, true, this.varIndices.length);
                                                    this.draw1DBoxplotDataPoints(true)
                                                } else {
                                                    this.draw1DBoxplotDataPoints()
                                                }
                                            }
                                            break;
                                        case "Gantt":
                                            this.draw1DGanttDataPoints();
                                            break;
                                        case "Meter":
                                            this.draw1DMeterDataPoints();
                                            break;
                                        case "Dotplot":
                                            this.draw1DDotplotDataPoints(false, false, this.varIndices.length);
                                            break;
                                        case "DotLine":
                                            this.draw1DDotplotDataPoints(false, false, Math.max(this.xAxisVarIndices.length, this.xAxis2VarIndices.length));
                                            this.draw1DLineDataPoints(this.xAxis2VarIndices, "xAxis2", Math.max(this.xAxisVarIndices.length, this.xAxis2VarIndices.length));
                                            break;
                                        case "Heatmap":
                                            if (this.isContour) {
                                                this.draw1DHeatmapDataPoints();
                                                this.draw1DContour()
                                            } else {
                                                if (this.isOncoprint && this.showHeatmapOncoprint) {
                                                    switch (this.oncoprintHeatmapPosition) {
                                                        case "top":
                                                            this.draw1DHeatmapDataPoints(true);
                                                            this.draw1DHeatmapDataPoints(false, true);
                                                            break;
                                                        case "right":
                                                            this.draw1DHeatmapDataPoints();
                                                            this.draw1DHeatmapDataPoints(true, true);
                                                            break;
                                                        case "bottom":
                                                            this.draw1DHeatmapDataPoints();
                                                            this.draw1DHeatmapDataPoints(true, true);
                                                            break;
                                                        case "left":
                                                            this.draw1DHeatmapDataPoints(true);
                                                            this.draw1DHeatmapDataPoints(false, true);
                                                            break
                                                    }
                                                } else {
                                                    this.draw1DHeatmapDataPoints()
                                                }
                                            }
                                            break;
                                        case "Treemap":
                                            this.draw1DTreemapDataPoints();
                                            break;
                                        case "TagCloud":
                                            this.draw1DTagCloudDataPoints();
                                            break;
                                        case "Sankey":
                                            this.draw1DSankeyDataPoints();
                                            break;
                                        case "Tree":
                                            this.draw1DTreeDataPoints();
                                            break
                                    }
                                    this.toRender({
                                        p: ["resetClipArea"],
                                        t: "Data"
                                    });
                                    return true
                                };
                                this.draw1DBarDataPoints = function(C, h, J) {
                                    var f = this;
                                    var k = function(d) {
                                        if (f.graphType.match(/Line/)) {
                                            var b = [];
                                            for (var c = 0; c < d.length; c++) {
                                                if (f.varIndices.includes(d[c])) {
                                                    b.push(d[c])
                                                }
                                            }
                                            return b
                                        } else {
                                            return d
                                        }
                                    };
                                    var A = this.get1DIndices();
                                    var q = k(C);
                                    var u = A.length;
                                    var g = this.xAxisMin < 0 ? Math.abs(this.xAxisMin) * this.xAxisUnit : 0;
                                    var D = this.get1DLeft();
                                    var r = this.get1DTop();
                                    var B = this.plotByVariable ? this.rowBlockSize : this.blockSeparation + (this.rowBlockSize * J);
                                    var o = this.barType == "swimmer" ? this.rowBlockSize * (q.length - 1) : this.rowBlockSize;
                                    if (this.xAxisTransform && this.xAxisTransform == "percentile") {
                                        this.setRangeData(this.summaryType)
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        D += (this.blockSeparation / 2) + (this.barType == "swimmer" ? this.rowBlockSize / 2 : 0);
                                        r = (r + this.y) - g
                                    } else {
                                        D += g;
                                        r += (this.blockSeparation / 2) + (this.barType == "swimmer" ? this.rowBlockSize / 2 : 0)
                                    }
                                    for (var F = 0; F < q.length; F++) {
                                        var H = [];
                                        var G = [];
                                        var I = [];
                                        var K = [];
                                        var y = [];
                                        for (var E = 0; E < u; E++) {
                                            I.push(this.getPropertyValue(q[F], A[E], "colorBy"));
                                            y.push(this.getPropertyValue(q[F], A[E], "patternBy"));
                                            H.push(this.getDataAtPos(q[F], A[E], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue));
                                            if ((this.isGroupedData || this.data.y.hasOwnProperty("stdev")) && this.barType != "swimmer") {
                                                G.push(this.getDataAtPos(q[F], A[E], "stdev", this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue))
                                            }
                                            K.push([q[F], A[E]])
                                        }
                                        this.drawBarPlot(H, G, D, r, o, B, this[h + "Unit"], g, this[h + "Min"], this.graphOrientation, I, y, K, false, false, this.invertGraph ? this.x - g : false, this.isSwimmerSumarized);
                                        if (this.graphOrientation == "vertical") {
                                            D = this.plotByVariable ? D + (this.blockSeparation + (this.rowBlockSize * u)) : D + this.rowBlockSize
                                        } else {
                                            r = this.plotByVariable ? r + (this.blockSeparation + (this.rowBlockSize * u)) : r + this.rowBlockSize
                                        }
                                        if (this.barType == "swimmer") {
                                            return
                                        }
                                    }
                                };
                                this.draw1DLineDataPoints = function(H, h, g) {
                                    var f = this;
                                    var k = function() {
                                        if (f.graphType.match(/Bar|Stacked|Dot/)) {
                                            var b = [];
                                            for (var c = 0; c < H.length; c++) {
                                                if (f.varIndices.includes(H[c])) {
                                                    b.push(H[c])
                                                }
                                            }
                                            return b
                                        } else {
                                            return H
                                        }
                                    };
                                    var w = function(b) {
                                        return f.layoutValid ? f.linePatterns[H[b] % f.linePatterns.length] : f.linePatterns[b % f.linePatterns.length]
                                    };
                                    var Q = function(b) {
                                        if (f.layoutValid && f.graphType.match(/Bar|Stacked|Dot/)) {
                                            for (J = 0; J < H.length; J++) {
                                                if (H[J] == u[b]) {
                                                    return f.colors[J % f.colors.length]
                                                }
                                            }
                                        }
                                        return f.colors[b % f.colors.length]
                                    };
                                    var F = this.get1DIndices();
                                    var u = k(H);
                                    var A = F.length;
                                    var I = this.get1DLeft();
                                    var y = this.get1DTop();
                                    var B = this.graphType == "BarLine" || this.graphType == "DotLine" ? true : false;
                                    var E = B ? this.blockSeparation + (g * this.rowBlockSize) : this.blockSeparation + this.rowBlockSize;
                                    var G = this.graphType == "ParallelCoordinates" ? 0 : ((this.blockSeparation + this.rowBlockSize) / 2);
                                    var O = this.colorBy ? this.getSampleIndices(this.colorBy) : false;
                                    if (this.xAxisTransform && this.xAxisTransform == "percentile") {
                                        this.setRangeData(this.summaryType)
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        I += G;
                                        y += this.y
                                    } else {
                                        y += G
                                    }
                                    for (var K = 0; K < u.length; K++) {
                                        var M = [];
                                        var L = [];
                                        var N = this.theme == "blackAndWhite" ? "rgb(0,0,0)" : this.colorBy ? this.getPropertyValue(u[K], O, "colorBy") : this.coordinateLineColor ? Q(K) : this.getVariableColor(this.data.y.vars[u[K]]);
                                        var D = this.graphType == "DotLine" ? false : this.lineDecoration == "symbol" ? this.shapes[K % this.shapes.length] : "sphere";
                                        var C = [];
                                        var P = [];
                                        for (var J = 0; J < A; J++) {
                                            M.push(this.getDataAtPos(u[K], F[J], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue));
                                            if (this.isGroupedData || this.data.y.hasOwnProperty("stdev")) {
                                                L.push(this.getDataAtPos(u[K], F[J], "stdev", this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue));
                                                C.push(this.lineDecoration == "pattern" ? w(K) : this.getPropertyValue(u[K], F[J], "patternBy"))
                                            } else {
                                                if (this.lineDecoration == "pattern") {
                                                    C.push(w(K))
                                                }
                                            }
                                            P.push([u[K], F[J]])
                                        }
                                        this.drawLinePlot(M, L, I, y, this.rowBlockSize / 2, E, this.graphType == "ParallelCoordinates" ? this.parallelCoordinates : this[h + "Unit"], this[h + "Min"], this.graphOrientation, N, C, D, P, false, false, this.invertGraph ? this.x : false, this.data.y.vars[u[K]]);
                                        if (B && this.xAxisVarIndices.length == this.xAxis2VarIndices.length) {
                                            if (this.graphOrientation == "vertical") {
                                                I += this.rowBlockSize
                                            } else {
                                                y += this.rowBlockSize
                                            }
                                        }
                                    }
                                };
                                this.draw1DStackedDataPoints = function() {
                                    var h = this;
                                    var r = function() {
                                        if (h.graphType.match(/Line/)) {
                                            var b = [];
                                            for (var c = 0; c < h.xAxisVarIndices.length; c++) {
                                                if (h.varIndices.includes(h.xAxisVarIndices[c])) {
                                                    b.push(h.xAxisVarIndices[c])
                                                }
                                            }
                                            return b
                                        } else {
                                            return h.varIndices
                                        }
                                    };
                                    var F = this.get1DIndices();
                                    var A = F.length;
                                    var I = this.get1DLeft();
                                    var y = this.get1DTop();
                                    var H = this.blockSeparation + this.rowBlockSize;
                                    var x = r();
                                    var u = this.graphType == "StackedPercentLine" && !this.layoutValid ? this.xAxisVarIndices : false;
                                    var D = this.graphType.match(/Percent/) ? true : false;
                                    var o = this.xAxisMin < 0 ? Math.abs(this.xAxisMin) * this.xAxisUnit : 0;
                                    var B = this.invertGraph ? this.x : false;
                                    var e = this.graphOrientation == "vertical" ? this.get1DTop() + this.y : this.get1DLeft();
                                    var E = this.isDOE ? this.configStndBy.groupingFactors : this.groupingFactors;
                                    if (this.xAxisTransform && this.xAxisTransform == "percentile") {
                                        this.setRangeData("sum")
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        I += this.blockSeparation / 2;
                                        y += this.y
                                    } else {
                                        y += this.blockSeparation / 2
                                    }
                                    for (var M = 0; M < A; M++) {
                                        var N = this.sum(this.getDataForSmpGrpAtIndex(F[M], u), false, false, true);
                                        var K = this.sum(this.getDataForSmpGrpAtIndex(F[M], u), false, false, false, true);
                                        var P = [];
                                        var Q = [];
                                        var C = [];
                                        var S = [];
                                        var O = [];
                                        if (this.isGroupedData && this.treemapBy.length > 0) {
                                            for (var L = 0; L < x.length; L++) {
                                                P.push(this.getDataAtPos(x[L], F[M], "sum", this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue));
                                                O.push(this.getTreemapVariable(x[L], this.data.w.grps[F[M]]))
                                            }
                                        } else {
                                            if (this.isGroupedData && this.stackBy.length > 0) {
                                                this.isGroupedData = false;
                                                O = false;
                                                var G = this.getLevelsByAnnotation(this.stackBy, this.smpIndices, "x").sort();
                                                for (var L = 0; L < x.length; L++) {
                                                    for (var J = 0; J < G.length; J++) {
                                                        var R = this.getVariablesSamplesByAnnotationLevel(this.stackBy, G[J], this.data.w.grps[M], "x");
                                                        P.push(R.length);
                                                        Q.push(this.meta.data.x[this.stackBy].colors[J]);
                                                        C.push("solid");
                                                        S.push([x[L], F[M], "<b>" + this.data.y.vars[L] + "</b><br><b>" + this.stackBy + "</b>: " + G[J].replace("u0000", "") + "<br><b>" + E.join("::") + "</b> : " + R.length, R, G[J]])
                                                    }
                                                }
                                                this.isGroupedData = true
                                            } else {
                                                O = false;
                                                for (var L = 0; L < x.length; L++) {
                                                    P.push(this.getDataAtPos(x[L], F[M], "sum", this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue));
                                                    Q.push(this.getPropertyValue(x[L], F[M], "colorBy"));
                                                    C.push(this.getPropertyValue(x[L], F[M], "patternBy"));
                                                    S.push([x[L], F[M]])
                                                }
                                            }
                                        }
                                        this.drawStackedPlot(P, I, y, this.rowBlockSize, O, D, [N, K], this.xAxisUnit, o, this.graphOrientation, Q, C, S, false, B, e);
                                        if (this.graphOrientation == "vertical") {
                                            I += H
                                        } else {
                                            y += H
                                        }
                                    }
                                };
                                this.draw1DAreaDataPoints = function(k, h, H) {
                                    var C = this.get1DIndices();
                                    var u = C.length;
                                    var E = this.get1DLeft();
                                    var r = this.get1DTop();
                                    var D = this.rowBlockSize + this.blockSeparation;
                                    var I = [];
                                    var J = [];
                                    var y = [];
                                    var K = [];
                                    var A = [];
                                    var b = this;
                                    var g = function(c) {
                                        if (h == "xAxis") {
                                            return b.colors[k[c] % b.colors.length]
                                        } else {
                                            return b.colors[c % b.colors.length]
                                        }
                                    };
                                    if (this.xAxisTransform && this.xAxisTransform == "percentile") {
                                        this.setRangeData(this.summaryType)
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        r += this.y
                                    }
                                    if (this.areaType != "stacked" && this.areaType != "percent") {
                                        var B = [];
                                        var L = [];
                                        for (var G = 0; G < k.length; G++) {
                                            B[G] = this.getDataAtPos(k[G], C[0], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                            L[G] = G
                                        }
                                        k.sort(function(d, c) {
                                            return B[d] - B[c]
                                        })
                                    }
                                    for (var F = 0; F < u; F++) {
                                        A.push(0)
                                    }
                                    for (var G = 0; G < k.length; G++) {
                                        var e = [];
                                        var w = this.coordinateLineColor ? g(G) : this.getVariableColor(this.data.y.vars[k[G]]);
                                        for (var F = 0; F < u; F++) {
                                            if (this.isGraphTime && C[F] < 0) {
                                                e.push(0)
                                            } else {
                                                e.push(this.getDataAtPos(k[G], C[F], false, this.xAxisTransform))
                                            }
                                            A[F] += e[F]
                                        }
                                        I.push(e);
                                        J.push(w);
                                        y.push("closed");
                                        K.push([k[G]])
                                    }
                                    if (I.length) {
                                        if (I.length > 1 && I[0].length > 1 || this.areaType != "percent") {
                                            this.drawAreaPlot(I, E, r, this.x, this.y, D, this.areaType, A, this[h + "Unit"], this[h + "Min"], this[h + "Max"], this.graphOrientation, H, J, y, K, false, this.invertGraph ? this.x : false, C)
                                        } else {
                                            this.flashInfoSpan(100, 100, "Area graphs require at least 2 variables", 5000)
                                        }
                                    }
                                    if (this.areaType != "stacked" && this.areaType != "percent") {
                                        k.sort(function(d, c) {
                                            return L[d] - L[c]
                                        })
                                    }
                                };
                                this.draw1DBoxplotDataPoints = function(h, G) {
                                    var B = this.get1DIndices();
                                    var u = B.length;
                                    var f = this.varIndices;
                                    var D = this.get1DLeft();
                                    var g = this.get1DTop();
                                    var C = this.plotByVariable ? this.rowBlockSize : this.blockSeparation + (this.rowBlockSize * f.length);
                                    if (this.isRawData && !this.data.hasOwnProperty("w")) {
                                        return
                                    }
                                    if (this.xAxisTransform && this.xAxisTransform == "percentile") {
                                        this.setRangeData(this.summaryType)
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        D += this.blockSeparation / 2;
                                        g += this.y
                                    } else {
                                        g += this.blockSeparation / 2
                                    }
                                    if (!this.isRawData) {
                                        h = false
                                    }
                                    for (var H = 0; H < f.length; H++) {
                                        var I = [];
                                        var J = [];
                                        var x = [];
                                        var y = [];
                                        var L = [];
                                        var K = [];
                                        for (var F = 0; F < u; F++) {
                                            var w = ["iqr1", "iqr3", "qtl1", "qtl3", "median", "out", "mean", "conf"];
                                            var e = [];
                                            var A = this.getGroupColor(f[H], B[F]);
                                            for (var E = 0; E < w.length; E++) {
                                                e.push(this.getDataAtPos(f[H], B[F], w[E], this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue))
                                            }
                                            if (G && this.isRawData) {
                                                e[5] = false
                                            }
                                            I.push(e);
                                            J.push(h && !this.boxplotColor ? this.foreground : (this.boxplotColor || A));
                                            y.push(h && !this.boxplotColor ? "open" : this.getPropertyValue(f[H], B[F], "patternBy"));
                                            L.push(G ? [f[H], B[F], "box"] : [f[H], B[F]]);
                                            x.push(A);
                                            K.push(this.getPropertyValue(f[H], B[F], "patternBy"))
                                        }
                                        if (this.showViolinBoxplot && this.isRawData) {
                                            this.drawBoxPlot(I, D, g, this.rowBlockSize, C, this.xAxisUnit, this.xAxisMin, this.graphOrientation, J, y, L, x, K, this.data.y.vars[f[H]])
                                        } else {
                                            this.drawBoxPlot(I, D, g, this.rowBlockSize, C, this.xAxisUnit, this.xAxisMin, this.graphOrientation, J, y, L, x, K, this.data.y.vars[f[H]])
                                        }
                                        if (this.graphOrientation == "vertical") {
                                            D = this.plotByVariable ? D + (this.blockSeparation + (this.rowBlockSize * u)) : D + this.rowBlockSize
                                        } else {
                                            g = this.plotByVariable ? g + (this.blockSeparation + (this.rowBlockSize * u)) : g + this.rowBlockSize
                                        }
                                    }
                                };
                                this.draw1DGanttDataPoints = function() {
                                    var y = this.get1DIndices();
                                    var r = this.getVariableIndices(this.ganttStart);
                                    var G = this.getVariableIndices(this.ganttEnd);
                                    var B = this.get1DLeft();
                                    var h = this.get1DTop() + (this.blockSeparation / 4);
                                    var A = this.blockSeparation + this.rowBlockSize;
                                    var c = {};
                                    for (var E = 0; E < y.length; E++) {
                                        var H = [];
                                        var J = [];
                                        var v = [];
                                        var F = [];
                                        var w = [];
                                        var I = [];
                                        var x = [];
                                        if (this.isGroupedData) {
                                            for (var D = 0; D < this.data.w.grps[y[E]].length; D++) {
                                                var g = this.data.w.grps[y[E]][D];
                                                H.push([this.data.gantt[r][g], this.data.gantt[G][g]]);
                                                v.push(this.ganttCompletion ? this.data.x[this.ganttCompletion][g] : 0);
                                                J.push([g, r, G]);
                                                F.push(this.getPropertyValue(r, g, "colorBy"));
                                                w.push(this.getPropertyValue(r, g, "patternBy"));
                                                for (var C = 0; C < this.data.gantt.length; C++) {
                                                    if (C != r && C != G && this.data.gantt[C][g] != null) {
                                                        x.push([this.data.gantt[C][g], C])
                                                    }
                                                }
                                                c[g] = [this.data.gantt[r][g], this.data.gantt[G][g], h];
                                                if (this.ganttDependency && this.data.x[this.ganttDependency][g]) {
                                                    var u = this.getSampleIndices(this.data.x[this.ganttDependency][g], true);
                                                    if (!c[u]) {
                                                        c[u] = []
                                                    }
                                                    c[u].push(this.ganttDependencyEnd && this.data.x[this.ganttDependencyEnd][g] ? this.data.x[this.ganttDependencyEnd][g] : "arrow");
                                                    c[u].push(this.ganttDependencyColor && this.data.x[this.ganttDependencyColor][g] ? this.data.x[this.ganttDependencyColor][g] : "rgb(0,0,0)");
                                                    c[u].push(this.ganttDependencyThickness && this.data.x[this.ganttDependencyThickness][g] ? this.data.x[this.ganttDependencyThickness][g] : 1);
                                                    if (u > -1) {
                                                        I.push(c[u])
                                                    } else {
                                                        I.push(false)
                                                    }
                                                } else {
                                                    I.push(false)
                                                }
                                            }
                                        } else {
                                            H.push([this.data.gantt[r][E], this.data.gantt[G][E]]);
                                            v.push(this.ganttCompletion ? this.data.x[this.ganttCompletion][E] : 0);
                                            J.push([E, r, G]);
                                            F.push(this.getPropertyValue(r, E, "colorBy"));
                                            w.push(this.getPropertyValue(r, E, "patternBy"));
                                            for (var D = 0; D < this.data.gantt.length; D++) {
                                                if (D != r && D != G && this.data.gantt[D][E] != null) {
                                                    x.push([this.data.gantt[D][E], D])
                                                }
                                            }
                                            c[E] = [this.data.gantt[r][E], this.data.gantt[G][E], h];
                                            if (this.ganttDependency && this.data.x[this.ganttDependency][E]) {
                                                var u = this.getSampleIndices(this.data.x[this.ganttDependency][E]);
                                                if (!c[u]) {
                                                    c[u] = []
                                                }
                                                c[u].push(this.ganttDependencyEnd && this.data.x[this.ganttDependencyEnd][E] ? this.data.x[this.ganttDependencyEnd][E] : "arrow");
                                                c[u].push(this.ganttDependencyColor && this.data.x[this.ganttDependencyColor][E] ? this.data.x[this.ganttDependencyColor][E] : "rgb(0,0,0)");
                                                c[u].push(this.ganttDependencyThickness && this.data.x[this.ganttDependencyThickness][E] ? this.data.x[this.ganttDependencyThickness][E] : 1);
                                                if (u > -1) {
                                                    I.push(c[u])
                                                } else {
                                                    I.push(false)
                                                }
                                            } else {
                                                I.push(false)
                                            }
                                        }
                                        this.drawGanttPlot(H, v, I, x, B, h, this.rowBlockSize * 1.5, this.xAxisUnit, this.xAxisMin, w, F, J);
                                        h += A
                                    }
                                };
                                this.draw1DMeterDataPoints = function() {
                                    var j = function(c) {
                                        if (k.meterSegments.length && k.meterColors.length) {
                                            for (var e = 0; e < k.meterSegments.length; e++) {
                                                if (k.meterSegments[e] > c) {
                                                    return k.meterColors[e]
                                                }
                                            }
                                            return k.meterColors[k.meterColors.length - 1]
                                        } else {
                                            return this.meterBackgroundColor
                                        }
                                    };
                                    var k = this;
                                    var E = this.get1DLeft();
                                    var z = this.get1DTop();
                                    var p = Math.min(this.x, this.y) * 0.05;
                                    var D = Math.min(this.x, this.y) - p;
                                    var B = D / 2;
                                    var q = this.data.y.data[0][0];
                                    var I = this.meterType.match(/gauge|speedometer/) ? this.scaleTextToFont(q.toString(), D / 6, D / 3) : this.scaleTextToFont(q.toString(), D / 2, D);
                                    var x = Math.PI * (this.meterType == "gauge" ? 1 : this.meterType == "speedometer" ? 1.5 : 2) / this.xAxisRange;
                                    var C = (this.meterType == "gauge" ? Math.PI : this.meterType == "speedometer" ? Math.PI * 1.25 : Math.PI / 2);
                                    var g = E + (this.x / 2);
                                    var b = z + (this.y / 2) + (this.meterType == "gauge" ? this.y / 6 : this.meterType == "speedometer" ? this.y / 24 : 0);
                                    switch (this.meterType) {
                                        case "gauge":
                                        case "speedometer":
                                            var J = (q * x) - C;
                                            var H = ((B) * Math.cos(J)) + g;
                                            var d = ((B) * Math.sin(J)) + b;
                                            this.toRender({
                                                p: ["drawLine", "needle", g, b, H, d, this.meterNeedleColor, this.margin],
                                                t: "Data"
                                            });
                                            this.toRender({
                                                p: ["drawText", q, g, b + (p * 2), I, j(q), "center", "top"],
                                                t: "Data"
                                            });
                                            break;
                                        case "horizontal":
                                            break;
                                        case "vertical":
                                            break;
                                        case "state":
                                            var p = Math.min(this.x, this.y);
                                            var G = p / 1.4;
                                            var n = z + (this.y / 2) + G;
                                            for (var F = 0; F < this.meterColors.length; F++) {
                                                var A = F > 0 ? this.meterSegments[F - 1] : 0;
                                                var J = F < this.meterColors.length - 1 ? this.meterSegments[F] : this.xAxisMax;
                                                var K = q >= A && q <= J ? this.meterColors[F] : this.addColorTransparency(this.meterColors[F], 0.2);
                                                this.toRender({
                                                    p: ["drawShape", "circle", E + (this.x / 2), n, (p / 2), (p / 2), K, K],
                                                    t: "Axes"
                                                });
                                                n -= G
                                            }
                                            break;
                                        case "digital":
                                            this.toRender({
                                                p: ["drawText", q, g, b + 10, I, j(q), "center", "middle"],
                                                t: "Data"
                                            });
                                            break
                                    }
                                };
                                this.setConnectData = function(g, h) {
                                    if (this.connectBy && this.data.x && this.data.x.hasOwnProperty(this.connectBy)) {
                                        this.connectByDataVar = [];
                                        this.connectByData = {};
                                        var c, f;
                                        var e = 0;
                                        for (var d = 0; d < g.length; d++) {
                                            if (this.isGroupedData) {
                                                if (this.isGraphTime && g[d] < 0) {
                                                    continue
                                                }
                                                for (var b = 0; b < this.data.w.grps[g[d]].length; b++) {
                                                    f = this.data.w.grps[g[d]][b];
                                                    c = this.getMetadataValue(f, "x", this.connectBy, true);
                                                    if (!this.connectByData.hasOwnProperty(c)) {
                                                        this.connectByData[c] = []
                                                    }
                                                    this.connectByData[c].push(e);
                                                    e++
                                                }
                                            } else {
                                                f = g[d];
                                                if (this.isGraphTime && g[d] < 0) {
                                                    continue
                                                }
                                                c = this.getMetadataValue(f, "x", this.connectBy);
                                                if (!this.connectByData.hasOwnProperty(c)) {
                                                    this.connectByData[c] = []
                                                }
                                                this.connectByData[c].push(d)
                                            }
                                        }
                                    } else {
                                        if (this.connectBy && this.data.z && this.data.z.hasOwnProperty(this.connectBy)) {
                                            this.connectByDataVar = [];
                                            this.connectByData = {};
                                            var c, f;
                                            var e = 0;
                                            for (var d = 0; d < h.length; d++) {
                                                f = h[d];
                                                c = this.getMetadataValue(f, "z", this.connectBy);
                                                if (!this.connectByData.hasOwnProperty(c)) {
                                                    this.connectByData[c] = []
                                                }
                                                this.connectByData[c].push(d)
                                            }
                                        }
                                    }
                                };
                                this.draw1DDotplotDataPoints = function(K, G, B) {
                                    var I = this;
                                    var F = function() {
                                        if (I.graphType.match(/Line/)) {
                                            var b = [];
                                            for (var c = 0; c < I.xAxisVarIndices.length; c++) {
                                                if (I.varIndices.includes(I.xAxisVarIndices[c])) {
                                                    b.push(I.xAxisVarIndices[c])
                                                }
                                            }
                                            return b
                                        } else {
                                            return I.varIndices
                                        }
                                    };
                                    var V = this.get1DIndices();
                                    var R = V.length;
                                    var O = F();
                                    var X = this.get1DLeft();
                                    var Q = this.get1DTop();
                                    var ai = this.dotplotType == "stacked" ? ((this.blockSeparation + this.rowBlockSize) / 2) + this.blockSeparation : ((this.blockSeparation + this.rowBlockSize) / 2);
                                    var W = this.plotByVariable ? this.rowBlockSize : this.blockSeparation + (this.rowBlockSize * B);
                                    var C = this.jitter;
                                    var Y = this.binned;
                                    var D = this.meta.data.d.g;
                                    var H = this.layoutValid ? Math.max(this.layoutRows, this.layoutCols) : 1;
                                    var I = this;
                                    var A = function(f, m, h, c) {
                                        if (c) {
                                            var d = I.segregateSamplesBy.length && I.groupingFactors.includes(I.segregateSamplesBy[0]);
                                            var k = d ? I.data.w.glab[m] : [I.data.l.name[I.layoutCurrent], I.data.w.glab[m]].join("::");
                                            for (var g = 0; g < D[f].length; g++) {
                                                if (D[f][g].density.name == k) {
                                                    m = g;
                                                    break
                                                }
                                            }
                                        }
                                        var o = D[f][m].density;
                                        var n = D[f][m].indices;
                                        var b = o.histogram;
                                        var l = o.quantilesX;
                                        var p = null;
                                        for (var g = 0; g < n.length; g++) {
                                            if (n[g] == h) {
                                                p = g;
                                                break
                                            }
                                        }
                                        for (var g = 0; g < b.idxs.length; g++) {
                                            for (var e = 0; e < b.idxs[g].length; e++) {
                                                if (b.idxs[g][e] == p) {
                                                    return g == 0 ? l[4] : g == b.idxs.length - 1 ? l[5] : b.mids[g]
                                                }
                                            }
                                        }
                                    };
                                    this.setConnectData(V, this.varIndices);
                                    if (this.xAxisTransform && this.xAxisTransform == "percentile") {
                                        this.setRangeData(this.summaryType)
                                    }
                                    if (this.barType == "lollipop") {
                                        this.jitter = false;
                                        this.binned = false
                                    }
                                    if (this.graphOrientation == "vertical") {
                                        X += ai;
                                        Q += this.y
                                    } else {
                                        Q += ai
                                    }
                                    for (var ab = 0; ab < O.length; ab++) {
                                        var ag = [];
                                        var af = [];
                                        var ah = [];
                                        var ac = [];
                                        var T = [];
                                        var ae = [];
                                        var aj = [];
                                        var ad = 0;
                                        var U;
                                        for (var aa = 0; aa < R; aa++) {
                                            if (this.isGroupedData) {
                                                var E = this.isGraphTime && V[aa] < 0 ? 0 : this.data.w.grps[V[aa]].length > 1;
                                                var J = [];
                                                var L = [];
                                                var M = [];
                                                var S = [];
                                                var N = [];
                                                var P = [];
                                                var q = this.isTransformedData || (this.showBoxplotOriginalData && this.data.y.trans && this.data.y.trans[0].length) ? this.data.y.trans : this.data.y.data;
                                                this.isGroupedData = false;
                                                if (this.isGraphTime && V[aa] < 0) {
                                                    J.push(null);
                                                    N.push(null);
                                                    L.push(null);
                                                    M.push(null);
                                                    S.push(null);
                                                    P.push([null]);
                                                    ad++
                                                } else {
                                                    for (var Z = 0; Z < this.data.w.grps[V[aa]].length; Z++) {
                                                        U = this.getPropertyValue(O[ab], this.data.w.grps[V[aa]][Z], "colorBy");
                                                        J.push(this.binned && E ? A(O[ab], V[aa], this.data.w.grps[V[aa]][Z], this.layoutValid && !this.isDOE) : q[O[ab]][this.data.w.grps[V[aa]][Z]]);
                                                        N.push(this.getPropertyValue(O[ab], this.data.w.grps[V[aa]][Z], "shapeBy"));
                                                        L.push(this.sizeBy ? this.getPropertyValue(O[ab], this.data.w.grps[V[aa]][Z], "sizeBy") * this.widthFactor : this.dataPointSize * this.dataPointSizeScaleFactor * (K ? 0.3 : 0.5) * (this.data.y.smps.length > this.dotplotOutlineThreshold ? 0.3 * this.widthFactor : 2 * this.widthFactor / H));
                                                        M.push(K ? this.addColorTransparency(U, this.boxplotDataPointTransparency, true) : U);
                                                        S.push(this.getPropertyValue(O[ab], this.data.w.grps[V[aa]][Z], "patternBy"));
                                                        P.push([O[ab], V[aa], this.data.w.grps[V[aa]][Z]]);
                                                        ad++
                                                    }
                                                }
                                                this.isGroupedData = true;
                                                if (this.data.w.hasOwnProperty("stdev")) {
                                                    af.push(false)
                                                }
                                                ag.push(J);
                                                T.push(N);
                                                ae.push(L);
                                                ah.push(M);
                                                ac.push(S);
                                                aj.push(P)
                                            } else {
                                                if (this.isGraphTime && V[aa] < 0) {
                                                    ag.push([null]);
                                                    if (this.data.y.hasOwnProperty("stdev")) {
                                                        af.push([null])
                                                    }
                                                    T.push([null]);
                                                    ae.push([null]);
                                                    ah.push([null]);
                                                    ac.push([null]);
                                                    aj.push([null])
                                                } else {
                                                    U = this.getPropertyValue(O[ab], V[aa], "colorBy");
                                                    ag.push([this.getDataAtPos(O[ab], V[aa], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue)]);
                                                    if (this.data.y.hasOwnProperty("stdev")) {
                                                        af.push([this.getDataAtPos(O[ab], V[aa], "stdev", this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue)])
                                                    }
                                                    T.push([this.getPropertyValue(O[ab], V[aa], "shapeBy")]);
                                                    ae.push([this.barType == "lollipop" ? this.rowBlockSize * this.barLollipopFactor : this.sizeBy ? this.getPropertyValue(O[ab], V[aa], "sizeBy") : this.dataPointSize * this.dataPointSizeScaleFactor * (K ? 0.3 : 0.5) * (this.data.y.smps.length > this.dotplotOutlineThreshold ? 0.3 : 1)]);
                                                    ah.push([K ? this.addColorTransparency(U, this.boxplotDataPointTransparency, true) : U]);
                                                    ac.push([this.getPropertyValue(O[ab], V[aa], "patternBy")]);
                                                    aj.push([
                                                        [O[ab], V[aa]]
                                                    ])
                                                }
                                            }
                                        }
                                        if (this.plotByVariable) {
                                            this.drawDotPlot(ag, af, X, Q, this.rowBlockSize, W, this.xAxisUnit, this.xAxisMin, ae, this.graphOrientation, ah, ac, T, aj, false, false, this.invertGraph ? this.x : false, this.data.y.vars[O[ab]], ab == O.length - 1)
                                        } else {
                                            this.drawDotPlot(ag, af, X, Q, this.blockSeparation, W, this.xAxisUnit, this.xAxisMin, ae, this.graphOrientation, ah, ac, T, aj, false, false, this.invertGraph ? this.x : false, this.data.y.vars[O[ab]], ab == O.length - 1)
                                        }
                                        if (this.graphOrientation == "vertical") {
                                            if (this.dotplotType != "stacked") {
                                                X = this.plotByVariable ? X + (this.blockSeparation + (this.rowBlockSize * R)) : X + this.rowBlockSize
                                            }
                                        } else {
                                            if (this.dotplotType != "stacked") {
                                                Q = this.plotByVariable ? Q + (this.blockSeparation + (this.rowBlockSize * R)) : Q + this.rowBlockSize
                                            }
                                        }
                                    }
                                    this.jitter = C;
                                    this.binned = Y
                                };
                                this.draw1DHeatmapDataPoints = function(B, L) {
                                    var r = this;
                                    var P = this.get1DIndices();
                                    var V = this.isGroupedData ? this.data.w : this.data.y;
                                    var K = P.length;
                                    var R = this.get1DLeft(L);
                                    var J = this.get1DTop(L);
                                    var W = this.isContour || this.colBlockSize < 4 || this.rowBlockSize < 4 || !this.heatmapCellBox ? true : false;
                                    var Q = Math.max(Math.min(this.colBlockSize, this.rowBlockSize) - 10, 3);
                                    var S = this.dataSizes && this.dataSizes.length > 0 ? Q / this.max(this.dataSizes) : 1;
                                    var M = this.outlineWidth;
                                    if (this.xAxisTransform && this.xAxisTransform == "percentile") {
                                        this.setRangeData(this.summaryType)
                                    }
                                    if (this.heatmapType.match(/circle|hexagon/)) {
                                        J += this.rowBlockSize / 2;
                                        for (var U = 0; U < this.varIndices.length; U++) {
                                            for (var T = 0; T < K; T++) {
                                                var F = R + (U * this.colBlockSize) + (this.colBlockSize / 2);
                                                var D = J + (T * this.rowBlockSize) + (this.rowBlockSize / 4 * (U % 2 ? 1 : -1));
                                                var H = this.getDataAtPos(this.varIndices[U], P[T], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                var Y = !isNaN(H) ? this.getColorForValue(false, H) : this.missingDataColor;
                                                var O = this.heatmapCollapse ? Y : this.objectBorderColor;
                                                var I = this.heatmapType == "circle" ? "oval" : "hexagon";
                                                var N = this.heatmapType == "circle" ? 1.2 : 1.5;
                                                this.toRender({
                                                    p: ["drawShape", I, F, D, this.colBlockSize * N, this.rowBlockSize, Y, O],
                                                    a: this.getShapeArea(I, F, D, this.colBlockSize * N, this.rowBlockSize, Y, O),
                                                    i: [this.varIndices[U], P[T]],
                                                    b: this.left,
                                                    t: "Data",
                                                    h: this.isHidden(this.varIndices[U], P[T])
                                                })
                                            }
                                        }
                                    } else {
                                        if ((this.isMultidimensionalData || this.isOncoprint) && !this.oncoprintHeatmapSwitch && !B) {
                                            if (this.isOncoprint) {
                                                var b = "rgb(220,220,220)";
                                                var A = this.colBlockSize * 0.9;
                                                var ab = this.rowBlockSize * 0.9;
                                                var h = this.rowBlockSize * 0.3;
                                                for (var U = 0; U < this.varIndices.length; U++) {
                                                    for (var T = 0; T < K; T++) {
                                                        var F = R + (U * this.colBlockSize) + (this.colBlockSize / 2);
                                                        var D = J + (T * this.rowBlockSize) + (this.rowBlockSize / 2);
                                                        var C = D + h;
                                                        var H = this.getDataAtPos(this.varIndices[U], P[T], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue, this.oncoprintCNA);
                                                        var Q = this.getDataAtPos(this.varIndices[U], P[T], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue, this.oncoprintMUT);
                                                        var N = this.getPropertyValue(this.varIndices[U], P[T], "patternByData");
                                                        var Y = !isNaN(H) ? this.getColorForValue(false, H) : this.missingDataColor;
                                                        var g = this.isOncoprint ? false : this.isHidden(this.varIndices[U], P[T]);
                                                        if (H != "") {
                                                            this.toRender({
                                                                p: ["drawShape", "rect", F, D, A, ab, this.legendOncoprintColors[H], this.legendOncoprintColors[H], N],
                                                                a: this.getShapeArea("rect", F, D, A, ab, this.legendOncoprintColors[H], this.legendOncoprintColors[H], N),
                                                                i: [this.varIndices[U], P[T]],
                                                                b: [this.left, D, 0, ab],
                                                                t: "Data",
                                                                h: g
                                                            })
                                                        } else {
                                                            this.toRender({
                                                                p: ["drawShape", "rect", F, D, A, ab, b, b, N],
                                                                a: this.getShapeArea("rect", F, D, A, ab, b, b, N),
                                                                i: [this.varIndices[U], P[T]],
                                                                b: [this.left, D, 0, ab],
                                                                t: "Data",
                                                                h: g
                                                            })
                                                        }
                                                        if (Q != "") {
                                                            this.toRender({
                                                                p: ["drawShape", "rect", F, D, A, h, this.legendOncoprintColors[Q], this.legendOncoprintColors[Q], N],
                                                                a: this.getShapeArea("rect", F, D, A, h, this.legendOncoprintColors[Q], this.legendOncoprintColors[Q], N),
                                                                i: [this.varIndices[U], P[T]],
                                                                b: [this.left, D, 0, ab],
                                                                t: "Data",
                                                                h: g
                                                            })
                                                        }
                                                    }
                                                }
                                            } else {
                                                for (var U = 0; U < this.varIndices.length; U++) {
                                                    for (var T = 0; T < K; T++) {
                                                        var F = R + (U * this.colBlockSize) + (this.colBlockSize / 2);
                                                        var D = J + (T * this.rowBlockSize) + (this.rowBlockSize / 2);
                                                        var H = this.getDataAtPos(this.varIndices[U], P[T], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue);
                                                        var Y = !isNaN(H) ? this.getColorForValue(false, H) : this.missingDataColor;
                                                        var O = this.outlineBy ? this.getPropertyValue(this.varIndices[U], P[T], "outlineByData") : this.objectBorderColor;
                                                        var I = this.getPropertyValue(this.varIndices[U], P[T], "shapeByData");
                                                        var G = this.getPropertyValue(this.varIndices[U], P[T], "sizeByData");
                                                        var N = this.getPropertyValue(this.varIndices[U], P[T], "patternByData");
                                                        this.toRender({
                                                            p: ["drawShape", I, F, D, G, G, Y, O, N],
                                                            a: this.getShapeArea(I, F, D, G, G, Y, O, N),
                                                            i: [this.varIndices[U], P[T]],
                                                            b: this.left,
                                                            t: "Data",
                                                            h: this.isHidden(this.varIndices[U], P[T])
                                                        });
                                                        if (this.showDataValues) {
                                                            this.toRender({
                                                                p: ["drawText", this.formatNumber(H), (F + (this.colBlockSize / 2)) - 2, (D + (this.rowBlockSize / 2)) - 2, this.overlayFont, this.foreground, "right", "bottom"],
                                                                b: this.left,
                                                                t: "Data"
                                                            })
                                                        }
                                                    }
                                                }
                                            }
                                            this.outlineWidth = M
                                        } else {
                                            var I = 0;
                                            for (var U = 0; U < K; U++) {
                                                var X = [];
                                                var aa = [];
                                                var N = [];
                                                for (var T = 0; T < this.varIndices.length; T++) {
                                                    X.push(this.getDataAtPos(this.varIndices[T], P[U], false, this.xAxisTransform, this.xAxisFloorValue, this.xAxisCeilValue));
                                                    aa.push([this.varIndices[T], P[U]]);
                                                    if (this.patternBy) {
                                                        N.push(this.getPropertyValue(this.varIndices[T], P[U], "patternBy"))
                                                    } else {
                                                        N.push("solid")
                                                    }
                                                }
                                                if (U > 0 && U < K - 1) {
                                                    if (I >= 0.8) {
                                                        this.drawHeatmap(X, R, J, this.colBlockSize, this.rowBlockSize, W, aa, false, N, this.meta.def.colorBrew);
                                                        if (this.heatmapCellBox && !this.isOncoprint && this.rowBlockSize > 1) {
                                                            this.toRender({
                                                                p: ["drawLine", "line", R, J - 1, R + (this.colBlockSize * this.varIndices.length), J - 1, this.heatmapCellBoxColor, this.heatmapCellBoxWidth],
                                                                s: true,
                                                                t: "Data"
                                                            })
                                                        }
                                                        I = 0
                                                    }
                                                } else {
                                                    this.drawHeatmap(X, R, J, this.colBlockSize, this.rowBlockSize, W, aa, false, N, this.meta.def.colorBrew);
                                                    if (this.heatmapCellBox && !this.isOncoprint && this.rowBlockSize > 1 && this.colBlockSize > 1) {
                                                        if (U == K - 1) {
                                                            this.toRender({
                                                                p: ["drawLine", "line", R, J - 0.5, R + (this.colBlockSize * this.varIndices.length), J - 0.5, this.heatmapCellBoxColor, this.heatmapCellBoxWidth],
                                                                s: true,
                                                                t: "Data"
                                                            });
                                                            this.toRender({
                                                                p: ["drawLine", "line", R, J + this.rowBlockSize, R + (this.colBlockSize * this.varIndices.length), J + this.rowBlockSize, this.heatmapCellBoxColor, this.heatmapCellBoxWidth],
                                                                s: true,
                                                                t: "Data"
                                                            })
                                                        } else {
                                                            this.toRender({
                                                                p: ["drawLine", "line", R, J - 0.5, R + (this.colBlockSize * this.varIndices.length), J - 0.5, this.heatmapCellBoxColor, this.heatmapCellBoxWidth],
                                                                s: true,
                                                                t: "Data"
                                                            })
                                                        }
                                                    }
                                                }
                                                J += this.rowBlockSize;
                                                I += this.rowBlockSize
                                            }
                                            if (!W && !this.isOncoprint && this.rowBlockSize > 1 && this.colBlockSize > 1) {
                                                R = this.get1DLeft(L);
                                                J = this.get1DTop(L);
                                                this.toRender({
                                                    p: ["drawLine", "line", R, J - 1, R, J + this.y - (this.margin + 0.5), this.heatmapCellBoxColor, this.heatmapCellBoxWidth],
                                                    s: true,
                                                    t: "Data"
                                                });
                                                R += this.colBlockSize;
                                                for (var U = 1; U <= this.varIndices.length; U++) {
                                                    this.toRender({
                                                        p: ["drawLine", "line", R - 0.5, J - 1, R - 0.5, J + this.y - (this.margin + 0.5), this.heatmapCellBoxColor, this.heatmapCellBoxWidth],
                                                        s: true,
                                                        t: "Data"
                                                    });
                                                    R += this.colBlockSize
                                                }
                                                this.toRender({
                                                    p: ["drawLine", "line", R - (this.colBlockSize + 0.5), J - 1, R - (this.colBlockSize + 0.5), J + this.y - (this.margin + 0.5), this.heatmapCellBoxColor, this.heatmapCellBoxWidth],
                                                    s: true,
                                                    t: "Data"
                                                });
                                                R = this.get1DLeft()
                                            }
                                            if (this.highlightSmp.length > 0 || this.highlightVar.length > 0) {
                                                J = this.get1DTop(L);
                                                R = this.get1DLeft(L);
                                                var ac = this.getObjectArray(this.highlightVar);
                                                var Z = this.getObjectArray(this.highlightSmp);
                                                var G = this.heatmapCellBoxWidth + this.heatmapCellBoxHighlightWidth;
                                                var E = G / 2;
                                                if (this.highlightSmp.length == 0) {
                                                    for (var U = 0; U < this.varIndices.length; U++) {
                                                        if (ac.hasOwnProperty(V.vars[this.varIndices[U]])) {
                                                            this.toRender({
                                                                p: ["drawShape", "rectangle", (R + E) + ((this.colBlockSize - G) / 2), (J + E) + ((this.y - G) / 2), this.colBlockSize - G, this.y - G, false, this.heatmapCellBoxColorHighlight, "open", false, G],
                                                                s: true,
                                                                t: "Data"
                                                            })
                                                        }
                                                        R += this.colBlockSize
                                                    }
                                                } else {
                                                    if (this.highlightVar.length == 0) {
                                                        for (var U = 0; U < K; U++) {
                                                            if (Z.hasOwnProperty(V.smps[P[U]])) {
                                                                this.toRender({
                                                                    p: ["drawShape", "rectangle", (R + E) + ((this.x - G) / 2), (J + E) + ((this.rowBlockSize - G) / 2), this.x - G, this.rowBlockSize - G, false, this.heatmapCellBoxColorHighlight, "open", false, G],
                                                                    s: true,
                                                                    t: "Data"
                                                                })
                                                            }
                                                            J += this.rowBlockSize
                                                        }
                                                    } else {
                                                        for (var U = 0; U < K; U++) {
                                                            R = this.get1DLeft();
                                                            for (var T = 0; T <= this.varIndices.length; T++) {
                                                                if (Z.hasOwnProperty(V.smps[P[U]]) && ac.hasOwnProperty(V.vars[this.varIndices[T]])) {
                                                                    this.toRender({
                                                                        p: ["drawShape", "rectangle", (R + E) + ((this.colBlockSize - G) / 2), (J + E) + ((this.rowBlockSize - G) / 2), this.colBlockSize - G, this.rowBlockSize - G, false, this.heatmapCellBoxColorHighlight, "open", false, G],
                                                                        s: true,
                                                                        t: "Data"
                                                                    })
                                                                }
                                                                R += this.colBlockSize
                                                            }
                                                            J += this.rowBlockSize
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.draw1DTreemapDataPoints = function() {
                                    var c = this.get1DLeft();
                                    var d = this.get1DTop();
                                    var b = this.getTreemap();
                                    this.drawTreemap(b, c, d)
                                };
                                this.draw1DTagCloudDataPoints = function() {
                                    switch (this.tagCloudShape) {
                                        case "circle":
                                        default:
                                            this.tagCloudShapeFunction = "circle";
                                            break;
                                        case "cardioid":
                                            this.tagCloudShapeFunction = function(e) {
                                                return 1 - Math.sin(e)
                                            };
                                            break;
                                        case "diamond":
                                            this.tagCloudShapeFunction = function(e) {
                                                var f = e % (2 * Math.PI / 4);
                                                return 1 / (Math.cos(f) + Math.sin(f))
                                            };
                                            break;
                                        case "square":
                                            this.tagCloudShapeFunction = function(e) {
                                                return Math.min(1 / Math.abs(Math.cos(e)), 1 / Math.abs(Math.sin(e)))
                                            };
                                            break;
                                        case "triangle2":
                                            this.tagCloudShapeFunction = function(e) {
                                                var f = e % (2 * Math.PI / 3);
                                                return 1 / (Math.cos(f) + Math.sqrt(3) * Math.sin(f))
                                            };
                                            break;
                                        case "triangle":
                                            this.tagCloudShapeFunction = function(e) {
                                                var f = (e + Math.PI * 3 / 2) % (2 * Math.PI / 3);
                                                return 1 / (Math.cos(f) + Math.sqrt(3) * Math.sin(f))
                                            };
                                            break;
                                        case "pentagon":
                                            this.tagCloudShapeFunction = function(e) {
                                                var f = (e + 0.955) % (2 * Math.PI / 5);
                                                return 1 / (Math.cos(f) + 0.726543 * Math.sin(f))
                                            };
                                            break;
                                        case "star":
                                            this.tagCloudShapeFunction = function(e) {
                                                var f = (e + 0.955) % (2 * Math.PI / 10);
                                                if ((e + 0.955) % (2 * Math.PI / 5) - (2 * Math.PI / 10) >= 0) {
                                                    return 1 / (Math.cos((2 * Math.PI / 10) - f) + 3.07768 * Math.sin((2 * Math.PI / 10) - f))
                                                } else {
                                                    return 1 / (Math.cos(f) + 3.07768 * Math.sin(f))
                                                }
                                            };
                                            break
                                    }
                                    if (!this.renderTagCloud || this.renderTagCloud.length == 0) {
                                        this.tryRenderTagCloud()
                                    }
                                    if (this.renderTagCloud.length > 0) {
                                        var b = this.cloneObject(this.renderTagCloud);
                                        for (var c = 0; c < this.renderTagCloud.length; c++) {
                                            var d = this.isR ? this.cloneObject(this.renderTagCloud[c]) : this.renderTagCloud[c];
                                            this.toRender({
                                                p: d[0],
                                                i: d[1],
                                                m: d[2],
                                                g: d[3],
                                                s: d[4],
                                                b: d[5],
                                                h: this.isHidden(d[1][0], d[1][1])
                                            })
                                        }
                                        this.renderTagCloud = b;
                                        this.showTransition = false
                                    }
                                };
                                this.draw1DContour = function() {
                                    var x, d, w, c;
                                    if (this.isContour && this.data.y.contour) {
                                        var o = this.data.y.contour.data;
                                        var y = this.getColorBrew(this.colorSpectrum, 0, o[o.length - 1].value, this.colorSpectrumZeroValue, this.colorSpectrumBreaks);
                                        var b = this.varIndices.length - 1;
                                        var n = this.smpIndices.length - 1;
                                        var r = this.x / b;
                                        var q = this.y / n;
                                        var m = (this.varIndices[0] * r) + (this.colBlockSize * 0.67);
                                        var k = (this.smpIndices[0] * q) + (this.rowBlockSize * 0.67);
                                        var s = this.get1DLeft() - m;
                                        var j = this.get1DTop() - k;
                                        if (this.contourType == "color") {
                                            for (var v = 0; v < o.length; v++) {
                                                var f = this.addColorTransparency(this.getColorForValue(y, o[v].value), 0.33, true);
                                                for (var h = 0; h < o[v].coordinates.length; h++) {
                                                    for (var p = 0; p < o[v].coordinates[h].length; p++) {
                                                        var g = [];
                                                        var u = [];
                                                        for (var e = 0; e < o[v].coordinates[h][p].length; e++) {
                                                            g.push(s + (o[v].coordinates[h][p][e][0] * r));
                                                            u.push(j + (o[v].coordinates[h][p][e][1] * q))
                                                        }
                                                        this.toRender({
                                                            p: ["drawShape", this.lineType == "spline" ? "spline" : "path", g, u, false, false, f, f, "close", false, false, true],
                                                            t: "Decorations"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                        for (var v = 0; v < o.length; v++) {
                                            for (var h = 0; h < o[v].coordinates.length; h++) {
                                                for (var p = 0; p < o[v].coordinates[h].length; p++) {
                                                    x = s + (o[v].coordinates[h][p][0][0] * r);
                                                    d = j + (o[v].coordinates[h][p][0][1] * q);
                                                    var g = [];
                                                    var u = [];
                                                    for (var e = 0; e < o[v].coordinates[h][p].length; e++) {
                                                        g.push(s + (o[v].coordinates[h][p][e][0] * r));
                                                        u.push(j + (o[v].coordinates[h][p][e][1] * q));
                                                        w = s + (o[v].coordinates[h][p][e][0] * r);
                                                        c = j + (o[v].coordinates[h][p][e][1] * q);
                                                        if (this.lineType != "spline") {
                                                            this.toRender({
                                                                p: ["drawLine", "line", x, d, w, c, this.foreground, false, false, false, false, true, [this.left + this.margin, this.top + this.margin, this.left + this.x - this.margin, this.top + this.y - this.margin]],
                                                                t: "Decorations"
                                                            })
                                                        }
                                                        x = w;
                                                        d = c
                                                    }
                                                    if (this.lineType == "spline") {
                                                        this.toRender({
                                                            p: ["drawLine", "spline", g, u, false, false, false, this.foreground, "open", false, false, true],
                                                            t: "Decorations"
                                                        })
                                                    }
                                                    if (this.showContourLevel) {
                                                        for (var e = 0; e < g.length; e++) {
                                                            if (g[e] > s && g[e] < s + this.x && u[e] > j && u[e] < j + this.y) {
                                                                if (g[e + 1] > s && g[e + 1] < s + this.x && u[e + 1] > j && u[e + 1] < j + this.y) {
                                                                    this.toRender({
                                                                        p: ["drawText", o[v].value + this.minData, g[e + 1], u[e + 1], this.legendFont],
                                                                        t: "Decorations"
                                                                    })
                                                                } else {
                                                                    this.toRender({
                                                                        p: ["drawText", o[v].value + this.minData, g[e], u[e], this.legendFont],
                                                                        t: "Decorations"
                                                                    })
                                                                }
                                                                break
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.draw1DSankeyDataPoints = function() {
                                    if (!this.moveSankey) {
                                        this.setSankey()
                                    }
                                    var b = this.get1DLeft();
                                    var n = this.get1DTop();
                                    var p = this.data.sankey;
                                    var k = p.links[0].target.x - p.links[0].source.x;
                                    for (var h = 0; h < p.nodes.length; h++) {
                                        var f = p.nodes[h];
                                        f.plotX = f.x + b;
                                        f.plotY = f.y + n;
                                        f.color = this.addColorTransparency(this.colors[h % this.colors.length], 0.75, true);
                                        f.tooltip = ["Sankey:" + f.name + ":" + h]
                                    }
                                    for (var h = 0; h < p.links.length; h++) {
                                        var m = p.links[h];
                                        var o = (m.dy / 2);
                                        m.plotX = [];
                                        m.plotY = [];
                                        m.tooltip = [this.hierarchyVarIndex, m.id];
                                        for (var e = 0; e < 4; e++) {
                                            m.plotX.push(m.bezier[0][e] + b);
                                            m.plotY.push(m.bezier[1][e] + n - o)
                                        }
                                        if (this.colorBy) {
                                            m.color = this.addColorTransparency(this.getPropertyValue(this.hierarchyVarIndex, m.id, "colorBy"), 0.75, true)
                                        } else {
                                            if (this.sankeyCoordinateColor) {
                                                var g = this.addColorTransparency(m.source.color, 0.75, true);
                                                var c = this.addColorTransparency(m.target.color, 0.75, true);
                                                m.color = this.getLinearGradient(0, 0, k, 0, [g, c]);
                                                m.colors = [g, c]
                                            } else {
                                                m.color = this.sankeyColor
                                            }
                                        }
                                    }
                                    this.drawSankey(p)
                                };
                                this.draw1DTreeDataPoints = function() {
                                    this.setTree();
                                    if (this.data.tree && this.data.tree.plot) {
                                        var b = this.data.tree.plot;
                                        var d = this.get1DLeft();
                                        var j = this.get1DTop();
                                        var f = this;
                                        var c = this.data.tree.plot.leaves().length;
                                        var e = this.treeInverted ? -1 : 1;
                                        var i = function(s) {
                                            var l = Math.PI - (s.x / 180 * Math.PI);
                                            var o = s.y;
                                            if (l < 0) {
                                                l += (2 * Math.PI)
                                            }
                                            s.angle = l;
                                            s.radius = o;
                                            s.xi = s.x;
                                            s.yi = s.y;
                                            s.y = e * o * Math.sin(l) + (f.x / 2);
                                            s.x = e * o * Math.cos(l) + (f.y / 2);
                                            if (s.parent) {
                                                var k = Math.PI - (s.xi / 180 * Math.PI);
                                                var p = Math.PI - (s.parent.x / 180 * Math.PI);
                                                o = (s.yi + s.parent.y) / 2;
                                                s.mx = (e * o * Math.sin(k) + (f.x / 2)) + d;
                                                s.my = (e * o * Math.cos(k) + (f.y / 2)) + j;
                                                s.mx2 = (e * o * Math.sin(p) + (f.x / 2)) + d;
                                                s.my2 = (e * o * Math.cos(p) + (f.y / 2)) + j
                                            }
                                        };
                                        var h = function(m) {
                                            var l = m.descendants();
                                            for (var k = 0; k < l.length; k++) {
                                                if (!l[k]._children) {
                                                    delete(l[k].data.color);
                                                    delete(l[k].data.shape);
                                                    delete(l[k].data.size);
                                                    delete(l[k].data.pattern)
                                                }
                                            }
                                        };
                                        var g = function(q) {
                                            if (q.children) {
                                                for (var l = 0; l < q.children.length; l++) {
                                                    g(q.children[l])
                                                }
                                            }
                                            if (f.treeCircular) {
                                                i(q)
                                            }
                                            if (f.graphOrientation == "vertical" && !f.treeCircular) {
                                                q.y0 = f.treeInverted ? (b.size[1] - q.y) + j : q.y + j;
                                                q.x0 = f.treeInverted ? (b.size[0] - q.x) + d : q.x + d
                                            } else {
                                                if (f.graphOrientation == "horizontal" && !f.treeCircular) {
                                                    q.y0 = f.treeInverted ? (b.size[1] - q.y) + d : q.y + d;
                                                    q.x0 = f.treeInverted ? (b.size[0] - q.x) + j : q.x + j
                                                } else {
                                                    q.y0 = q.y + d;
                                                    q.x0 = q.x + j
                                                }
                                            }
                                            if (!f.colorBy) {
                                                q.data.color = f.background
                                            } else {
                                                if (f.colorBy && !q.data.color) {
                                                    q.data.color = q.data.idx != null ? f.getPropertyValue(false, q.data.idx, "colorBy") : f.background
                                                }
                                            }
                                            if (!f.shapeBy) {
                                                q.data.shape = "sphere"
                                            } else {
                                                if (f.shapeBy && !q.data.shape) {
                                                    q.data.shape = q.data.idx != null ? f.getPropertyValue(false, q.data.idx, "shapeBy") : "sphere"
                                                }
                                            }
                                            if (!f.sizeBy) {
                                                q.data.size = f.treeNodeSize
                                            } else {
                                                if (f.sizeBy && !q.data.size) {
                                                    q.data.size = q.data.idx != null ? f.getPropertyValue(false, q.data.idx, "sizeBy") : f.treeNodeSize
                                                }
                                            }
                                            if (!f.patternBy) {
                                                q.data.pattern = "solid"
                                            } else {
                                                if (f.patternBy && !q.data.pattern) {
                                                    q.data.pattern = q.data.idx != null ? f.getPropertyValue(false, q.data.idx, "patternBy") : "solid"
                                                }
                                            }
                                            q.data.tooltip = "Tree:" + q.data.name + " (" + q.leaves().length + ")";
                                            if (q.parent) {
                                                var o = [];
                                                var k = [];
                                                var p = [];
                                                var m = [];
                                                for (var l = 0; l < q.parent.children.length; l++) {
                                                    o.push(q.parent.children[l].data.color);
                                                    k.push(q.parent.children[l].data.size);
                                                    p.push(q.parent.children[l].data.shas);
                                                    m.push(q.parent.children[l].data.pats)
                                                }
                                                q.parent.data.color = f.combineColors(o);
                                                q.parent.data.size = f.mean(k);
                                                if (f.isUnique(p)) {
                                                    q.parent.data.shape = p[0]
                                                }
                                                if (f.isUnique(m)) {
                                                    q.parent.data.pattern = m[0]
                                                }
                                            }
                                        };
                                        h(this.data.tree.plot);
                                        g(this.data.tree.plot);
                                        this.drawTree(f.graphOrientation)
                                    }
                                };
                                this.checkOrientationLayout = function() {
                                    if (this.layoutValid && this.segregateVariablesBy.length && this.segregateSamplesBy.length) {
                                        if ((this.layoutType == "rows" && !this.layoutTypeVariablesFirst) || (this.layoutType == "cols" && this.layoutTypeVariablesFirst)) {
                                            if (this.graphOrientation == "vertical") {
                                                this.flashInfoSpan(100, 100, "Graph orienation switched to horizontal", 5000)
                                            }
                                            this.graphOrientation = "horizontal"
                                        } else {
                                            if ((this.layoutType == "cols" && !this.layoutTypeVariablesFirst) || (this.layoutType == "rows" && !this.layoutTypeVariablesFirst) || (this.layoutType == "wrap" && this.segregateVariablesBy.length && this.segregateSamplesBy.length)) {
                                                if (this.graphOrientation == "horizontal") {
                                                    this.flashInfoSpan(100, 100, "Graph orienation switched to vertical", 5000)
                                                }
                                                this.graphOrientation = "vertical"
                                            }
                                        }
                                    }
                                };
                                this.checkOrientation = function() {
                                    if (this.graphType == "Meter") {
                                        if (this.meterType == "vertical") {
                                            this.graphOrientation = "vertical"
                                        } else {
                                            if (this.meterType == "horizontal") {
                                                this.graphOrientation = "horizontal"
                                            }
                                        }
                                    } else {
                                        if (this.graphType.match(/Heatmap|Gantt/)) {
                                            if (this.graphOrientation == "vertical") {
                                                this.flashInfoSpan(100, 100, "Graph orienation switched to horizontal", 5000)
                                            }
                                            this.graphOrientation = "horizontal"
                                        } else {
                                            if (this.graphType == "Sankey") {
                                                if (this.graphOrientation == "horizontal") {
                                                    this.flashInfoSpan(100, 100, "Graph orienation switched to vertical", 5000)
                                                }
                                                this.graphOrientation = "vertical"
                                            }
                                        }
                                    }
                                    this.checkOrientationLayout()
                                };
                                this.checkClustering = function() {
                                    if (this.samplesClustered) {
                                        this.clusterSamples(false, true)
                                    }
                                    if (this.variablesClustered) {
                                        this.clusterVariables(false, true)
                                    }
                                    if (this.samplesKmeaned) {
                                        this.kmeansSamples(false, true)
                                    }
                                    if (this.variablesKmeaned) {
                                        this.kmeansVariables(false, true)
                                    }
                                };
                                this.checkSamplesGrouping = function() {
                                    if (this.groupingFactors.length > 0 && !this.isGroupedData) {
                                        if (this.layoutComb && this.data.l && this.data.l.group && this.isSameObject(this.data.l.group.sort(), this.groupingFactors.sort())) {} else {
                                            this.groupSamples(this.groupingFactors, false, false, true, true)
                                        }
                                    }
                                    this.setGroupLabels()
                                };
                                this.checkDataTransform = function() {
                                    if (this.transformData != this.isTransformedData) {
                                        this.transform(this.transformData, this.transformAxis, false, true);
                                        this.initializeAxis();
                                        this.setColorBrew(true)
                                    }
                                };
                                this.checkMultidimensional = function() {
                                    var d = this.graphType == "Heatmap" ? ["outline", "shape", "size", "pattern"] : ["color", "outline", "shape", "size", "pattern"];
                                    for (var c = 0; c < d.length; c++) {
                                        var b = d[c] + "ByData";
                                        if (this[b] && this.data.y[this[b]] && this.isArray(this.data.y[this[b]])) {
                                            this.isMultidimensionalData = true
                                        }
                                    }
                                };
                                this.checkTree = function() {
                                    this.treeNodeSize = Math.min(20, Math.max(4, Math.ceil(this.height / this.data.y.smps.length)))
                                };
                                this.checkTreemap = function() {
                                    if (this.graphType == "Treemap") {
                                        this.showVarDendrogram = true
                                    }
                                };
                                this.checkStack = function() {
                                    if (this.stackBy && this.meta.data.x && this.meta.data.x[this.stackBy] && this.meta.data.x[this.stackBy].type == "Numeric") {
                                        this.switchNumericToString(this.stackBy, true, true)
                                    }
                                };
                                this.checkBoxplotWidthRatio = function() {
                                    this.boxplotWidthRatioIfViolin = Math.min(1, Math.max(0.1, this.boxplotWidthRatioIfViolin))
                                };
                                this.checkOncoprint = function() {
                                    if (this.oncoprintCNA && this.data.y.hasOwnProperty(this.oncoprintCNA)) {
                                        this.summarizeOncoprint()
                                    } else {
                                        this.isOncoprint = false;
                                        this.oncoprintCNA = false
                                    }
                                };
                                this.checkSankey = function() {
                                    this.sankeyColor = this.addColorTransparency(this.sankeyColor, 0.5, true)
                                };
                                this.checkSwimmer = function() {
                                    if (this.barType == "swimmer") {
                                        if (this.swimHigh) {
                                            if (this.getVariableIndices(this.swimHigh) == -1) {
                                                this.swimHigh = this.data.y.vars[0]
                                            }
                                        }
                                        if (this.swimStart) {
                                            if (this.getVariableIndices(this.swimStart) == -1) {
                                                if (this.data.y.vars.length > 1) {
                                                    this.swimStart = this.data.y.vars[1]
                                                } else {
                                                    this.barType = "normal"
                                                }
                                            }
                                        }
                                        if (this.swimEnd) {
                                            if (this.getVariableIndices(this.swimEnd) == -1) {
                                                if (this.data.y.vars.length > 2) {
                                                    this.swimEnd = this.data.y.vars[2]
                                                } else {
                                                    this.barType = "normal"
                                                }
                                            }
                                        }
                                        if (this.barType == "swimmer") {
                                            this.summarizeSwimmer()
                                        }
                                    }
                                };
                                this.checkGantt = function() {
                                    if (this.graphType == "Gantt") {
                                        this.showOverlays = false;
                                        this.showVarDendrogram = false;
                                        this.showSmpDendrogram = false;
                                        this.plotByVariable = false;
                                        this.xAxisMajorTicks = false;
                                        this.xAxisMinorTicks = false;
                                        this.xAxisShow = false
                                    }
                                };
                                this.checkAxes = function() {
                                    var b, c;
                                    if (this.xAxis.length) {
                                        b = this.isSameObject(this.getVariableIndices(this.xAxis), this.xAxisVarIndices)
                                    }
                                    if (this.xAxis2.length) {
                                        c = this.isSameObject(this.getVariableIndices(this.xAxis2), this.xAxis2VarIndices)
                                    }
                                    if (!b || !c) {
                                        if (this.layoutAdjust) {
                                            this.setAxes()
                                        } else {
                                            if (!b) {
                                                this.xAxisVarIndices = this.getVariableIndices(this.xAxis)
                                            }
                                            if (!c) {
                                                this.xAxis2VarIndices = this.getVariableIndices(this.xAxis2)
                                            }
                                        }
                                    }
                                    if (this.graphType.match(/Line/) && this.isGroupedData) {
                                        var e = [];
                                        for (var d = 0; d < this.xAxisVarIndices.length; d++) {
                                            e.push(this.xAxisVarIndices[d])
                                        }
                                        for (var d = 0; d < this.xAxis2VarIndices.length; d++) {
                                            e.push(this.xAxis2VarIndices[d])
                                        }
                                        this.setVariablesVisible(e);
                                        this.groupSamples(this.groupingFactors, false, false, true, true, true)
                                    }
                                };
                                this.validate1DPropertyDefaults = function() {
                                    this.checkBoxplotWidthRatio();
                                    this.checkOrientation();
                                    this.checkSamplesGrouping();
                                    this.checkDataTransform();
                                    this.checkClustering();
                                    this.checkSegregation();
                                    this.checkMultidimensional();
                                    this.checkTreemap();
                                    this.checkTree();
                                    this.checkStack();
                                    this.checkOncoprint();
                                    this.checkSankey();
                                    this.checkSwimmer();
                                    this.checkGantt()
                                };
                                this.setOverlaysDendrogramVariable = function() {
                                    if (this.isDOE) {
                                        this.showOverlays = false;
                                        this.showVarDendrogram = false;
                                        this.showSmpDendrogram = false;
                                        this.smpTitle = false
                                    } else {
                                        if (this.plotByVariable) {
                                            if (this.graphType.match(/^Bar$|Boxplot|Dotplot|Gantt/)) {
                                                this.showOverlays = false;
                                                this.showVarDendrogram = false;
                                                this.showSmpDendrogram = false
                                            } else {
                                                this.plotByVariable = false
                                            }
                                        }
                                    }
                                };
                                this.set1DAttributes = function() {
                                    this.checkOrientation();
                                    this.checkAxes();
                                    this.validatePropertyValues();
                                    this.setGroupLabels();
                                    this.setOverlaysDendrogramVariable();
                                    this.setDendrograms();
                                    this.set1DOverlays();
                                    this.set1DXYDimensions();
                                    this.set1DPrivateParams();
                                    this.set1DXAxis()
                                };
                                this.set1DOverlays = function() {
                                    this.validateOverlays();
                                    this.setOverlays("var");
                                    this.setOverlays("smp")
                                };
                                this.draw1DLayout = function() {
                                    this.drawDendrograms();
                                    this.draw1DXLayout();
                                    this.draw1DYLayout()
                                };
                                this.draw1DData = function() {
                                    this.drawPlotWindow();
                                    this.draw1DWireFrame();
                                    this.draw1DDataPoints();
                                    this.draw1DLayout();
                                    this.draw1DOverlays();
                                    this.drawDecorationData();
                                    this.drawLegend();
                                    this.drawTitle()
                                };
                                this.draw1DPlot = function() {
                                    this.set1DAttributes();
                                    this.draw1DData()
                                };
                                this.restoreOriginalSettings = function() {
                                    var e = this.meta.config.orig;
                                    var c = ["varLabelScaleFontFactor", "showVariableNames", "showSampleNames", "smpLabelScaleFontFactor", "insideLegend", "legendFontSize", "showLegend", "legendPosition"];
                                    for (var b = 0; b < c.length; b++) {
                                        var d = c[b];
                                        if (e[d]) {
                                            this[d] = e[d];
                                            delete(e[d])
                                        }
                                    }
                                    this.adjustAspectRatioXTries = 0;
                                    this.adjustAspectRatioYTries = 0
                                };
                                this.initialize1DPlot = function() {
                                    this.validate1DPropertyDefaults();
                                    if (this.layoutValid && this.data.l) {
                                        this.drawLayoutCompartments(this.draw1DPlot)
                                    } else {
                                        this.draw1DPlot()
                                    }
                                    this.restoreOriginalSettings();
                                    this.resetInitialFontSize()
                                };
                                if (!a) {
                                    this.initialize1DPlot()
                                }
                            };
                            CanvasXpress.prototype.Network = function(a) {
                                this.findXYCoordinates = function(d) {
                                    var b = this.adjustedCoordinates(d);
                                    var f = {};
                                    f.x = (b.x / this.scaleFactorX || 1) - this.offsetX;
                                    f.y = (b.y / this.scaleFactorY || 1) - this.offsetY;
                                    return f
                                };
                                this.addNode = function(e, d) {
                                    if (e) {
                                        if (!e.id) {
                                            var b = 0;
                                            var f = "id" + b;
                                            while (this.nodes.hasOwnProperty(f)) {
                                                b++;
                                                f = "id" + b
                                            }
                                            e.id = f
                                        }
                                        if (!e.color) {
                                            e.color = this.colors[0]
                                        }
                                        if (!e.shape) {
                                            e.shape = this.shapes[0]
                                        }
                                        if (!e.size) {
                                            e.size = 1
                                        }
                                        if (d) {
                                            var c = this.findXYCoordinates(d);
                                            e.x = c.x;
                                            e.y = c.y
                                        }
                                        this.data.nodeIndices[e.id] = this.data.nodes.length;
                                        this.data.nodes.push(e);
                                        this.nodes[e.id] = e;
                                        return e
                                    }
                                };
                                this.getNodeConfigurableProperties = function(b) {
                                    return b != null ? this.getKeys(this.data.nodes[b]) : []
                                };
                                this.getEdgeConfigurableProperties = function(b) {
                                    return b != null ? this.getKeys(this.data.edges[b]) : []
                                };
                                this.removeNode = function(f, m) {
                                    if (f && f.id) {
                                        var c = m ? this.getObjectArray(this.findChildrenNodeIndices(f.id)) : false;
                                        var k = [];
                                        var e = 0;
                                        if (f.hasOwnProperty("layout") && f.layout.children.length) {
                                            for (var l = 0; l < f.layout.children.length; l++) {
                                                var d = f.layout.children[l];
                                                if (this.data.nodeIndices[d] != null && this.data.nodes[this.data.nodeIndices[d]]) {
                                                    delete(this.data.nodes[this.data.nodeIndices[d]].parentNode)
                                                }
                                            }
                                        }
                                        this.data.nodeIndices = {};
                                        for (var l = 0; l < this.data.nodes.length; l++) {
                                            var b = this.data.nodes[l];
                                            if (b.id != f.id) {
                                                if (c && c.hasOwnProperty(l)) {
                                                    var h = b.layout.edges;
                                                    for (var g = 0; g < h.length; g++) {
                                                        this.removeEdge(h[g])
                                                    }
                                                } else {
                                                    k.push(b);
                                                    this.data.nodeIndices[b.id] = e;
                                                    e++
                                                }
                                            } else {
                                                var h = b.layout.edges;
                                                for (var g = 0; g < h.length; g++) {
                                                    this.removeEdge(h[g])
                                                }
                                            }
                                            b.layout.edges = this.edgesForNode(this.data.edges, b.id)
                                        }
                                        this.data.nodes = k
                                    }
                                };
                                this.addEdge = function(b) {
                                    if (b && b.id1 && b.id2) {
                                        if (!b.color) {
                                            b.color = this.colors[0]
                                        }
                                        if (!b.width) {
                                            b.width = 1
                                        }
                                        if (!b.type) {
                                            b.type = "line"
                                        }
                                        this.data.edges.push(b)
                                    }
                                };
                                this.removeEdge = function(d) {
                                    if (d && d.id1 && d.id2) {
                                        var c = [];
                                        for (var b = 0; b < this.data.edges.length; b++) {
                                            if (this.data.edges[b].id1 != d.id1 || this.data.edges[b].id2 != d.id2) {
                                                c.push(this.data.edges[b])
                                            }
                                        }
                                        this.data.edges = c
                                    }
                                };
                                this.appendNodeData = function(d) {
                                    for (var e in d) {
                                        if (this.data.nodes[this.data.nodeIndices[e]]) {
                                            var b = this.data.nodes[this.data.nodeIndices[e]];
                                            for (var c in d[e]) {
                                                b[c] = d[e][c]
                                            }
                                        }
                                    }
                                    this.updateNetworkMetaData("nodes");
                                    CanvasXpress.stack[this.target].data = this.data;
                                    delete(this.nodesData)
                                };
                                this.appendEdgeData = function(h) {
                                    for (var d = 0; d < this.data.edges.length; d++) {
                                        var b = this.data.edges[d];
                                        var e = b.id1 + ":" + b.id2;
                                        var c = b.id2 + ":" + b.id1;
                                        var g = h.hasOwnProperty(e) ? h[e] : h.hasOwnProperty(c) ? h[c] : false;
                                        if (g) {
                                            for (var f in g) {
                                                b[f] = g[f]
                                            }
                                        }
                                    }
                                    this.updateNetworkMetaData("edges");
                                    CanvasXpress.stack[this.target].data = this.data;
                                    delete(this.edgesData)
                                };
                                this.modifyXYEdgeElbow = function(e, d, c, b) {
                                    var f = this.data.edges[e].elbows[d];
                                    f[0] -= c;
                                    f[1] -= b
                                };
                                this.getNodeWidth = function(b) {
                                    return (b.width ? b.width : b.size ? (this.nodeSize * b.size) : this.nodeSize)
                                };
                                this.getNodeHeight = function(b) {
                                    return (b.height ? b.height : b.size ? (this.nodeSize * b.size) : this.nodeSize)
                                };
                                this.modifyNodeSize = function(e, b, c) {
                                    var d = this.data.nodes[this.data.nodeIndices[e]];
                                    delete(d.size);
                                    d.width = b;
                                    d.height = c
                                };
                                this.modifyXYNode = function(c, k, j) {
                                    var d = this.data.nodes[this.data.nodeIndices[c]];
                                    if (!d.fixed) {
                                        d.x -= k;
                                        d.y -= j;
                                        var e = this.edgesForNode(this.data.edges, c);
                                        if (e.length > 0) {
                                            for (var f = 0; f < e.length; f++) {
                                                var g = e[f];
                                                if (g.elbows) {
                                                    var h = g.elbows.length - 1;
                                                    if (g.id1 == c) {
                                                        g.elbows[0][0] -= k;
                                                        g.elbows[0][1] -= j
                                                    } else {
                                                        if (g.id2 == c) {
                                                            g.elbows[h][0] -= k;
                                                            g.elbows[h][1] -= j
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (d.labelX != null && d.labelY != null) {
                                            this.modifyXYNodeLab(c, k, j)
                                        }
                                        if (d.decorationsX != null && d.decorationsY != null) {
                                            this.modifyXYNodeDec(c, k, j)
                                        }
                                        if (this.networkLayoutType != "radial") {
                                            if (d.hasOwnProperty("layout") && d.layout.children.length) {
                                                if (this.moveParentsWithChildren) {
                                                    for (var f = 0; f < d.layout.children.length; f++) {
                                                        var b = d.layout.children[f];
                                                        this.modifyXYNode(b, k, j)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.modifyXYNodeLab = function(e, c, b) {
                                    var d = this.data.nodes[this.data.nodeIndices[e]];
                                    if (!d.fixed) {
                                        d.labelX = d.labelX != null ? d.labelX - c : d.labelXi - c;
                                        d.labelY = d.labelY != null ? d.labelY - b : d.labelYi - b
                                    }
                                };
                                this.modifyXYNodeDec = function(e, c, b) {
                                    var d = this.data.nodes[this.data.nodeIndices[e]];
                                    if (!d.fixed) {
                                        d.decorationsX = d.decorationsX != null ? d.decorationsX - c : d.decorationsXi - c;
                                        d.decorationsY = d.decorationsY != null ? d.decorationsY - b : d.decorationsYi - b
                                    }
                                };
                                this.getHiddenNodes = function() {
                                    var c = [];
                                    if (this.data.nodes) {
                                        for (var b = 0; b < this.data.nodes.length; b++) {
                                            if (this.data.nodes[b].hide) {
                                                c.push(this.data.nodes[b])
                                            }
                                        }
                                    }
                                    return c
                                };
                                this.orderNodes = function(c) {
                                    for (var b in CanvasXpress.selector.nodes) {
                                        this[c](this.data.nodes[this.data.nodeIndices[b]])
                                    }
                                };
                                this.sendNodeToBack = function(d) {
                                    var c = [d];
                                    for (var b = 0; b < this.data.nodes.length; b++) {
                                        if (this.data.nodes[b].id != d.id) {
                                            c.push(this.data.nodes[b])
                                        }
                                    }
                                    this.data.nodes = c;
                                    this.setNodeIndices()
                                };
                                this.sendNodeBackward = function(e) {
                                    var d = [];
                                    var b = this.data.nodeIndices[e.id];
                                    if (b > 0) {
                                        for (var c = 0; c < b - 1; c++) {
                                            d.push(this.data.nodes[c])
                                        }
                                        d.push(this.data.nodes[b]);
                                        d.push(this.data.nodes[b - 1]);
                                        for (var c = b + 1; c < this.data.nodes.length; c++) {
                                            d.push(this.data.nodes[c])
                                        }
                                        this.data.nodes = d;
                                        this.setNodeIndices()
                                    }
                                };
                                this.bringNodeToFront = function(d) {
                                    var c = [];
                                    for (var b = 0; b < this.data.nodes.length; b++) {
                                        if (this.data.nodes[b].id != d.id) {
                                            c.push(this.data.nodes[b])
                                        }
                                    }
                                    c.push(d);
                                    this.data.nodes = c;
                                    this.setNodeIndices()
                                };
                                this.bringNodeForward = function(e) {
                                    var d = [];
                                    var b = this.data.nodeIndices[e.id];
                                    if (this.data.nodes.length - 1 > b) {
                                        for (var c = 0; c < b; c++) {
                                            d.push(this.data.nodes[c])
                                        }
                                        d.push(this.data.nodes[b + 1]);
                                        d.push(this.data.nodes[b]);
                                        for (var c = b + 2; c < this.data.nodes.length; c++) {
                                            d.push(this.data.nodes[c])
                                        }
                                        this.data.nodes = d;
                                        this.setNodeIndices()
                                    }
                                };
                                this.flashNode = function(j, e, b) {
                                    j = this.toArray(j);
                                    var q = (this.maxX - this.minX) / this.scaleFactorX;
                                    var n = (this.maxY - this.minY) / this.scaleFactorY;
                                    var d = 0.015;
                                    for (var k = 0; k < j.length; k++) {
                                        var c = j[k];
                                        var f = this.data.nodes[this.data.nodeIndices[c]];
                                        var p = f.width ? f.width : f.size ? f.size : this.nodeSize;
                                        var m = f.height ? f.height : f.size ? f.size : this.nodeSize;
                                        var l = (p < d * q ? d * q : p) * 1.35;
                                        var o = (m < d * n ? d * n : m) * 1.35;
                                        var g = this.adjustNetworkObjects(["circle", f.x, f.y, 1]);
                                        this.flash(g[1], g[2], l * this.scaleFactorX, o * this.scaleFactorY, e || this.nodeHighlightColor, b)
                                    }
                                };
                                this.highlightNodes = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    if (this.isArray(b)) {
                                        this.highlightNode = this.highlightNode.concat(b)
                                    } else {
                                        this.highlightNode.push(b)
                                    }
                                    this.draw({
                                        func: "highlightNodes",
                                        par: [b]
                                    })
                                };
                                this.unHighlightNodes = function(b) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var e = [];
                                    b = this.toArray(b);
                                    for (var d = 0; d < this.highlightNode.length; d++) {
                                        var f = false;
                                        for (var c = 0; c < b.length; c++) {
                                            if (this.highlightNode[d] == b[c]) {
                                                f = true;
                                                break
                                            }
                                        }
                                        if (!f) {
                                            e.push(this.highlightNode[d])
                                        }
                                    }
                                    this.highlightNode = e;
                                    this.draw({
                                        func: "unHighlightNodes",
                                        par: [b]
                                    })
                                };
                                this.alignDistributeSelectedNodes = function(k, d) {
                                    if (this.isTransition()) {
                                        return
                                    }
                                    var g, b, j, q, h;
                                    var l = this.getSelectedNodeCoordinates();
                                    if (l || d == 89 || d == 90) {
                                        if (k) {
                                            this.cancelEvent(k);
                                            this.stopEvent(k)
                                        }
                                        if (d == 84) {
                                            g = this.min(l.y);
                                            for (var h in CanvasXpress.selector.nodes) {
                                                var f = this.data.nodes[this.data.nodeIndices[h]];
                                                this.modifyXYNode(f.id, 0, f.y - g)
                                            }
                                        } else {
                                            if (d == 82) {
                                                g = this.max(l.x);
                                                for (var h in CanvasXpress.selector.nodes) {
                                                    var f = this.data.nodes[this.data.nodeIndices[h]];
                                                    this.modifyXYNode(f.id, f.x - g, 0)
                                                }
                                            } else {
                                                if (d == 66) {
                                                    g = this.max(l.y);
                                                    for (var h in CanvasXpress.selector.nodes) {
                                                        var f = this.data.nodes[this.data.nodeIndices[h]];
                                                        this.modifyXYNode(f.id, 0, f.y - g)
                                                    }
                                                } else {
                                                    if (d == 76) {
                                                        g = this.min(l.x);
                                                        for (var h in CanvasXpress.selector.nodes) {
                                                            var f = this.data.nodes[this.data.nodeIndices[h]];
                                                            this.modifyXYNode(f.id, f.x - g, 0)
                                                        }
                                                    } else {
                                                        if (d == 86) {
                                                            b = this.range(l.y);
                                                            j = this.rank(l.y);
                                                            q = (b[1] - b[0]) / (CanvasXpress.selector.selections - 1);
                                                            g = b[0];
                                                            for (var p = 0; p < j.length; p++) {
                                                                h = l.i[j[p]];
                                                                var f = this.data.nodes[this.data.nodeIndices[h]];
                                                                this.modifyXYNode(f.id, 0, f.y - (g + (p * q)))
                                                            }
                                                        } else {
                                                            if (d == 72) {
                                                                b = this.range(l.x);
                                                                j = this.rank(l.x);
                                                                q = (b[1] - b[0]) / (CanvasXpress.selector.selections - 1);
                                                                g = b[0];
                                                                for (var p = 0; p < j.length; p++) {
                                                                    h = l.i[j[p]];
                                                                    var f = this.data.nodes[this.data.nodeIndices[h]];
                                                                    this.modifyXYNode(f.id, f.x - (g + (p * q)), 0)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.draw({
                                            network: true,
                                            func: "alignDistributeSelectedNodes",
                                            par: [k, d]
                                        })
                                    }
                                    return false
                                };
                                this.getSelectedNodeCoordinates = function() {
                                    var f = {
                                        x: [],
                                        y: [],
                                        i: []
                                    };
                                    var b = false;
                                    for (var d in CanvasXpress.selector.nodes) {
                                        var e = this.data.nodes[this.data.nodeIndices[d]];
                                        f.x.push(e.x);
                                        f.y.push(e.y);
                                        f.i.push(d);
                                        b = true
                                    }
                                    return b ? f : false
                                };
                                this.findNodesBy = function(h) {
                                    var b = [];
                                    var l = 0;
                                    for (var d in h) {
                                        h[d] = this.toArray(h[d]);
                                        l++
                                    }
                                    for (var k = 0; k < this.data.nodes.length; k++) {
                                        var e = this.data.nodes[k];
                                        var f = 0;
                                        for (var d in h) {
                                            var o = h[d];
                                            for (var g = 0; g < o.length; g++) {
                                                if (e[d] && e[d] == o[g]) {
                                                    f++
                                                }
                                            }
                                        }
                                        if (f == l) {
                                            b.push(e)
                                        }
                                    }
                                    return b
                                };
                                this.setNetworkDimensions = function() {
                                    this.left = 10;
                                    this.right = 10;
                                    this.top = this.getTitleSubtitleHeight() + 10;
                                    this.bottom = 10;
                                    if (this.showLegend) {
                                        if (!this.legendInside) {
                                            if (this.legendPosition.match(/right/i)) {
                                                this.right += this.legendWidth + this.margin
                                            } else {
                                                if (this.legendPosition.match(/left/i)) {
                                                    this.left += this.legendWidth + this.margin
                                                } else {
                                                    if (this.legendPosition.match(/bottom/i)) {
                                                        this.bottom += this.legendHeight + this.margin
                                                    } else {
                                                        this.top += this.legendHeight + this.margin
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.networkLayoutType == "circular" && this.showNodeNameThreshold >= this.data.nodes.length) {
                                        var e = this.meta.data.nodes.label ? this.meta.data.nodes.label.maxLevStr : this.meta.data.nodes.name ? this.meta.data.nodes.name.maxLevStr : this.meta.data.nodes.id.maxLevStr;
                                        var b = this.zoomScale ? 1 : this.zoom;
                                        var f = this.nodeFontSize * this.nodeScaleFontFactor;
                                        var d = this.nodeFontStyle + " " + Math.min(Math.max((parseInt(f / b)), this.scaleFactorX > this.minTextSize ? 1 : this.minTextSize), this.maxTextSize) + "px " + this.fontName;
                                        var c = this.measureText(e, d) * 0.3;
                                        this.left += c;
                                        this.right += c;
                                        this.top += c;
                                        this.bottom += c
                                    }
                                    this.x = this.width - (this.left + this.right);
                                    this.y = this.height - (this.top + this.bottom)
                                };
                                this.setNetworkPrivateParams = function(d, h) {
                                    var k, j, i, g, c, f, b;
                                    if (!d) {
                                        d = this.data.nodes;
                                        k = this.x;
                                        j = this.y
                                    } else {
                                        var e = this.getSelectedNodeCoordinates();
                                        g = this.min(e.x);
                                        c = this.max(e.x);
                                        f = this.min(e.y);
                                        b = this.max(e.y);
                                        i = Math.max(c - g, b - f);
                                        k = i;
                                        j = i
                                    }
                                    if (!h) {
                                        h = this.networkLayoutType
                                    }
                                    if (d.length > 0) {
                                        if (h == "radial") {
                                            this.networkLevelSize = this.x * 4 / (this.networkDepth * 2);
                                            this.networkAngleStep = 360 / this.networkDivisions;
                                            this.networkRadialRadius = this.networkLevelSize * (this.networkDepth - 1);
                                            this.networkXCenter = this.x / 2;
                                            this.networkYCenter = this.y / 2
                                        } else {
                                            if (h == "circular") {
                                                this.networkLevelSize = k * 0.5;
                                                this.networkAngleStep = 360 / d.length;
                                                this.networkRadialRadius = this.networkLevelSize;
                                                this.networkXCenter = k / 2;
                                                this.networkYCenter = j / 2
                                            } else {
                                                this.set3DParams()
                                            }
                                        }
                                    }
                                };
                                this.networkContains = function(b, c) {
                                    return this.findNode(b, c) != null
                                };
                                this.findNode = function(d, e) {
                                    for (var c in d) {
                                        var b = d[c];
                                        if (e.call(b)) {
                                            return b
                                        }
                                    }
                                    return null
                                };
                                this.filterEdges = function(e, f) {
                                    var d = [];
                                    for (var c in e) {
                                        var b = e[c];
                                        if (f.call(b)) {
                                            d.push(b)
                                        }
                                    }
                                    return d
                                };
                                this.normalizeGraph = function(j) {
                                    var h = [];
                                    var b = {};
                                    var k = this;
                                    for (var f in j.nodes) {
                                        if (!b.hasOwnProperty(j.nodes[f].id)) {
                                            var e = j.nodes[f];
                                            var d = [];
                                            b[e.id] = 1;
                                            if (!this.networkContains(d, function() {
                                                    return k.networkContains(this.nodes, function() {
                                                        return this.id = e.id
                                                    })
                                                })) {
                                                var c = {
                                                    nodes: [],
                                                    edges: []
                                                };
                                                this.addNodeToGraph(e, c, j);
                                                if (c.nodes.length > 0) {
                                                    h.push(c)
                                                }
                                                for (var g = 0; g < c.nodes.length; g++) {
                                                    b[c.nodes[g].id] = 1
                                                }
                                            }
                                        }
                                    }
                                    return h
                                };
                                this.addNodeToGraph = function(d, f, e) {
                                    if (this.findNodeForId(d.id, f) == null) {
                                        f.nodes.push(d);
                                        var b = this.edgesForNode(e.edges, d.id);
                                        for (edgeIndex in b) {
                                            var c = b[edgeIndex];
                                            f.edges.push(c);
                                            if (c.id1 == d.id) {
                                                this.addNodeToGraph(this.findNodeForId(c.id2, e), f, e)
                                            } else {
                                                this.addNodeToGraph(this.findNodeForId(c.id1, e), f, e)
                                            }
                                        }
                                    }
                                };
                                this.findNodeForId = function(c, b) {
                                    return this.findNode(b.nodes, function() {
                                        return c == this.id
                                    })
                                };
                                this.edgesForNode = function(b, c) {
                                    return this.filterEdges(b, function(d) {
                                        return (this.id1 == c || this.id2 == c)
                                    })
                                };
                                this.translateScaleNetworkCanvas = function(b) {
                                    if (b) {
                                        this.translateCanvas(-this.offsetX, -this.offsetY);
                                        this.scaleCanvas(1 / this.scaleFactorX, 1 / this.scaleFactorY)
                                    } else {
                                        this.scaleCanvas(this.scaleFactorX, this.scaleFactorY);
                                        this.translateCanvas(this.offsetX, this.offsetY)
                                    }
                                };
                                this.disableEnablePreScaling = function(b) {
                                    if (!b) {
                                        this.preScaleNetworkState = this.preScaleNetwork;
                                        this.preScaleNetwork = true
                                    } else {
                                        this.preScaleNetwork = this.preScaleNetworkState;
                                        delete this.preScaleNetworkState
                                    }
                                };
                                this.renderNetwork = function(d) {
                                    if (this.data.nodes.length > 0) {
                                        if (!this.isLayoutDone && !this.showAnimation) {
                                            return
                                        }
                                        var e = this;
                                        var c = function() {
                                            if (!e.ignoreEventlessOrder) {
                                                e.drawNetworkNodes(true)
                                            }
                                            if (e.networkNodesOnTop) {
                                                e.toRender({
                                                    p: ["disableGradientTransparencyShadow"],
                                                    t: "Size"
                                                });
                                                e.drawNetworkEdges();
                                                e.toRender({
                                                    p: ["enableGradientTransparencyShadow"],
                                                    t: "Size"
                                                });
                                                e.drawNetworkNodes()
                                            } else {
                                                e.drawNetworkNodes();
                                                e.toRender({
                                                    p: ["disableGradientTransparencyShadow"],
                                                    t: "Size"
                                                });
                                                e.drawNetworkEdges();
                                                e.toRender({
                                                    p: ["enableGradientTransparencyShadow"],
                                                    t: "Size"
                                                })
                                            }
                                            if (e.isLayoutDone) {
                                                e.renderRadialLayout();
                                                e.drawNetworkCommunities();
                                                e.drawNetworkDecorations()
                                            }
                                        };
                                        var b = function() {
                                            e.disableEnablePreScaling();
                                            e.drawCitation();
                                            e.drawLegend();
                                            e.drawTitle();
                                            e.drawCanvasBox(true);
                                            e.disableEnablePreScaling(true)
                                        };
                                        this.updateCircularLayout();
                                        this.setNetworkMinMaxRangeXY();
                                        this.setNetworkScaleFactor();
                                        this.resetRender();
                                        this.resizeCanvas();
                                        this.setNetworkRotation();
                                        this.setNetworkCommunities();
                                        if (this.scaleFactorX && this.scaleFactorY) {
                                            if (this.showAnimation) {
                                                if (this.preScaleNetwork) {
                                                    this.centerNetwork();
                                                    c()
                                                } else {
                                                    this.toRender({
                                                        p: ["translateScaleNetworkCanvas", false],
                                                        t: "Size"
                                                    });
                                                    c();
                                                    this.toRender({
                                                        p: ["translateScaleNetworkCanvas", true],
                                                        t: "Size"
                                                    })
                                                }
                                                b()
                                            } else {
                                                b();
                                                if (this.preScaleNetwork) {
                                                    this.centerNetwork()
                                                } else {
                                                    this.toRender({
                                                        p: ["translateScaleNetworkCanvas", false],
                                                        t: "Size"
                                                    })
                                                }
                                                c()
                                            }
                                        }
                                        this.render();
                                        if (d) {
                                            this.triggerDataLoaded(d)
                                        }
                                    }
                                };
                                this.updateCircularLayout = function() {
                                    if (this.networkLayoutType == "circular") {
                                        var c = this.data.nodes;
                                        var h = this.x / 2;
                                        var g = this.y / 2;
                                        var b = Math.max(this.x, this.y);
                                        var k = 0;
                                        for (var e = 0; e < c.length; e++) {
                                            var d = c[e];
                                            if (!d.hide) {
                                                k += (this.nodeSize * this.getNodeEdgePropertyValue(d, false, "sizeNodeBy") * 2) + this.nodeSize
                                            }
                                        }
                                        var f = 2 * Math.PI / k;
                                        var j = 0;
                                        for (var e = 0; e < c.length; e++) {
                                            var d = c[e];
                                            var k = (this.nodeSize * this.getNodeEdgePropertyValue(d, false, "sizeNodeBy") * 2) + this.nodeSize;
                                            if (!d.hide) {
                                                j += f * k * 0.5;
                                                d.x = h + b + b * Math.sin(j);
                                                d.y = g + b + b * Math.cos(j);
                                                j += f * k * 0.5
                                            }
                                        }
                                    }
                                };
                                this.renderRadialLayout = function() {
                                    if (this.networkLayoutType == "radial" && this.showNetworkRadialLayout) {
                                        var b = this.data.nodes[this.data.nodeIndices[this.networkRoot]];
                                        for (var c = 1; c < this.networkDepth; c++) {
                                            this.toRender({
                                                p: ["drawShape", "circle", b.x, b.y, c * this.networkLevelSize * 2, c * this.networkLevelSize * 2, this.background, this.infoAreaColor, "open"],
                                                t: "Axes"
                                            })
                                        }
                                    }
                                };
                                this.centerNetwork = function() {
                                    for (var b = 0; b < this.data.nodes.length; b++) {
                                        var c = this.data.nodes[b];
                                        if (!c.hide && !c.hiddenParent) {
                                            c.x = (this.offsetX + c.x) * this.scaleFactorX;
                                            c.y = (this.offsetY + c.y) * this.scaleFactorY
                                        }
                                    }
                                    this.scaleFactorX = 0.9;
                                    this.scaleFactorY = 0.9;
                                    this.offsetX = this.left + (this.x * 0.05);
                                    this.offsetY = this.top + (this.y * 0.05)
                                };
                                this.getLengthToNodeBoundary = function(f, o, d, n, h, g) {
                                    var m = this.networkLayoutType.match(/radial|circular/) ? 1 : this.scaleFactorX;
                                    var l = this.networkLayoutType.match(/radial|circular/) ? 1 : this.scaleFactorY;
                                    var c = this.margin / Math.max(m, l) * this.zoom;
                                    var e = f == d && o == n;
                                    var k = g && !e ? c * 4 : !h.height && !h.width ? c * 1.5 : 0;
                                    if (this.networkLayoutType == "circular") {
                                        return 0
                                    } else {
                                        if (h) {
                                            var j = h.size ? h.size : 1;
                                            var b = (g && h.height ? h.height : h.width ? h.width : this.nodeSize / m * j) * this.zoom;
                                            var i = (g && h.width ? h.width : h.height ? h.height : this.nodeSize / l * j) * this.zoom;
                                            if (b == i) {
                                                return (b / 2) + k
                                            } else {
                                                var p = this.clip("line", [f, o, d, n], [f - (b / 2), o - (i / 2), b + (f - (b / 2)), i + (o - (i / 2))]);
                                                return this.lineLength(p[0], p[1], p[2], p[3]) + k
                                            }
                                        } else {
                                            return k
                                        }
                                    }
                                };
                                this.getEdgeCoordinates = function(e, v, t) {
                                    var p = v.x;
                                    var m = v.y;
                                    var x = t.x;
                                    var w = t.y;
                                    var j = e.id1 == e.id2 ? "curved" : e.type ? e.type : "line";
                                    var d = j.match(/curved/i) ? true : false;
                                    var c = 0;
                                    var b = 0;
                                    if (e.exact) {
                                        c = 0;
                                        b = 0
                                    } else {
                                        if (e.elbows && e.elbows.length > 0) {
                                            var g = e.elbows[0];
                                            var f = e.elbows[e.elbows.length - 1];
                                            c = this.getLengthToNodeBoundary(p, m, g[0], g[1], v, d);
                                            b = this.getLengthToNodeBoundary(x, w, f[0], f[1], t, d)
                                        } else {
                                            var r = null;
                                            var q = null;
                                            var B = null;
                                            var A = null;
                                            if (e.exactStart) {
                                                c = 0
                                            } else {
                                                if (e.startX != null && e.startY != null) {
                                                    var z = e.startX;
                                                    var y = e.startY;
                                                    var i = v.size ? v.size : 1;
                                                    var o = v.width ? v.width / this.zoom / 2 : this.nodeSize * siz / this.zoom / 2;
                                                    var u = v.height ? v.height / this.zoom / 2 : this.nodeSize * siz / this.zoom / 2;
                                                    r = p + (z * o);
                                                    q = m + (y * u);
                                                    c = 0
                                                } else {
                                                    c = this.getLengthToNodeBoundary(p, m, x, w, v, d)
                                                }
                                            }
                                            if (e.exactEnd) {
                                                b = 0
                                            } else {
                                                if (e.endX != null && e.endY != null) {
                                                    var n = e.endX || 0;
                                                    var l = e.endY || 0;
                                                    var h = t.size ? t.size : 1;
                                                    var k = t.width ? t.width / this.zoom / 2 : this.nodeSize * siz / this.zoom / 2;
                                                    var s = t.height ? t.height / this.zoom / 2 : this.nodeSize * siz / this.zoom / 2;
                                                    B = x + (n * k);
                                                    A = w + (l * s);
                                                    b = 0
                                                } else {
                                                    b = this.getLengthToNodeBoundary(x, w, p, m, t, d)
                                                }
                                            }
                                            if (r != null && q != null) {
                                                p = r;
                                                m = q
                                            }
                                            if (B != null && A != null) {
                                                x = B;
                                                w = A
                                            }
                                        }
                                    }
                                    return {
                                        startX: p,
                                        startY: m,
                                        startS: c,
                                        endX: x,
                                        endY: w,
                                        endS: b
                                    }
                                };
                                this.drawNetworkEdges = function() {
                                    if (this.data.nodes.length > 1) {
                                        var s = this.zoomScale ? 1 : this.zoom;
                                        for (var D = 0; D < this.data.edges.length; D++) {
                                            var u = null;
                                            var h = this.data.edges[D];
                                            var B = this.data.nodes[this.data.nodeIndices[h.id1]];
                                            var y = this.data.nodes[this.data.nodeIndices[h.id2]];
                                            var G = !B.hide && !B.hiddenParent && !y.hide && !y.hiddenParent;
                                            var H = B.id + ":" + y.id;
                                            if (G && !h.hide) {
                                                var g = CanvasXpress.selector.nodes.hasOwnProperty(B.id) && CanvasXpress.selector.nodes.hasOwnProperty(y.id) ? this.nodeHighlightColor : this.getNodeEdgePropertyValue(false, h, "colorEdgeBy");
                                                var p = this.getNodeEdgePropertyValue(false, h, "sizeEdgeBy");
                                                var n = h.cap ? h.cap : false;
                                                var x = this.networkLayoutType == "forceDirected" ? "R" : "";
                                                var d = h.id1 == h.id2 ? "curved" : h.type ? h.type : "line" + x;
                                                var r = this.getEdgeCoordinates(h, B, y);
                                                var e = h.id1 == h.id2 && h.self ? h.self : {
                                                    dir: true,
                                                    pos: "topLeft",
                                                    size: 40,
                                                    end: "arrow"
                                                };
                                                var b = false;
                                                if (this.colorNodeBy && !this.colorEdgeBy) {
                                                    g = this.monoColor(g, 0.33)
                                                }
                                                if (this.networkLayoutType == "circular" && this.colorNodeBy) {
                                                    g = this.getNodeEdgePropertyValue(y, false, "colorNodeBy")
                                                }
                                                if (h.elbows) {
                                                    b = [];
                                                    var w = typeof h.elbows == "string" ? this.parseJSON(h.elbows) : h.elbows;
                                                    if (d == "quadratic" && w.length == 2) {
                                                        b = h.angle || -1
                                                    } else {
                                                        for (var C = 0; C < w.length; C++) {
                                                            b[C] = [];
                                                            for (var A = 0; A < w[C].length - 1; A += 2) {
                                                                b[C].push(w[C][A]);
                                                                b[C].push(w[C][A + 1])
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    if (d == "quadratic") {
                                                        b = h.angle || -1
                                                    }
                                                }
                                                if (this.isLayoutDone && !this.isAnimation) {
                                                    if (this.networkLayoutType == "circular") {
                                                        u = this.toRender({
                                                            p: ["drawLine", "arch", [r.startX, this.adjustBackNetworkObjectX(this.left + (this.x / 2)), r.endX],
                                                                [r.startY, this.adjustBackNetworkObjectY(this.top + (this.y / 2)), r.endY], false, false, g, p / s
                                                            ],
                                                            a: this.getLineArea("arch", [r.startX, this.adjustBackNetworkObjectX(this.left + (this.x / 2)), r.endX], [r.startY, this.adjustBackNetworkObjectY(this.top + (this.y / 2)), r.endY], false, false, g, p / s),
                                                            i: [D + this.data.nodes.length],
                                                            t: "Data",
                                                            h: this.isHidden(false, D + this.data.nodes.length)
                                                        })
                                                    } else {
                                                        if (h.highlight) {
                                                            this.toRender({
                                                                p: ["drawLine", d, r.startX, r.startY, r.endX, r.endY, h.highlight, (p / s) * 3, n, Math.max(0, r.startS / s / 1.25), Math.max(0, r.endS / s / 1.25), false, false, b, false, false, e],
                                                                a: this.getLineArea(d, r.startX, r.startY, r.endX, r.endY, h.highlight, (p / s) * 3, n, Math.max(0, r.startS / s / 1.25), Math.max(0, r.endS / s / 1.25), false, false, b, false, false, e),
                                                                i: [D + this.data.nodes.length],
                                                                t: "Data",
                                                                h: this.isHidden(false, D + this.data.nodes.length)
                                                            })
                                                        }
                                                        u = this.toRender({
                                                            p: ["drawLine", d, r.startX, r.startY, r.endX, r.endY, g, p / s, n, Math.max(0, r.startS / s / 1.25), Math.max(0, r.endS / s / 1.25), false, false, b, h.startArrow, h.endArrow, e],
                                                            a: this.getLineArea(d, r.startX, r.startY, r.endX, r.endY, g, p / s, n, Math.max(0, r.startS / s / 1.25), Math.max(0, r.endS / s / 1.25), false, false, b, h.startArrow, h.endArrow, e),
                                                            i: [D + this.data.nodes.length],
                                                            t: "Data",
                                                            h: this.isHidden(false, D + this.data.nodes.length)
                                                        });
                                                        if (b) {
                                                            for (var C = 1; C < b.length - 1; C++) {
                                                                this.toRender({
                                                                    p: ["drawShape", "circle", b[C][0] + 0.5, b[C][1] + 0.5, 2, 2, this.addColorTransparency(g, 0.2, true), this.addColorTransparency(g, 0.2, true)],
                                                                    a: this.getShapeArea("circle", b[C][0] + 0.5, b[C][1] + 0.5, 2, 2, this.addColorTransparency(g, 0.2, true), this.addColorTransparency(g, 0.2, true)),
                                                                    i: [D + this.data.nodes.length, C],
                                                                    m: "-elbow",
                                                                    t: "Data",
                                                                    h: this.isHidden(false, D + this.data.nodes.length)
                                                                })
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    this.toRender({
                                                        p: ["drawLine", d, r.startX, r.startY, r.endX, r.endY, g, p / s, n, Math.max(0, r.startS / s / 1.25), Math.max(0, r.endS / s / 1.25), false, false, b, h.startArrow, h.endArrow, e],
                                                        a: this.getLineArea(d, r.startX, r.startY, r.endX, r.endY, g, p / s, n, Math.max(0, r.startS / s / 1.25), Math.max(0, r.endS / s / 1.25), false, false, b, h.startArrow, h.endArrow, e),
                                                        i: [D + this.data.nodes.length],
                                                        t: "Data",
                                                        h: this.isHidden(false, D + this.data.nodes.length)
                                                    })
                                                }
                                                if (h.decoration) {
                                                    var F, c, E, z, t, o;
                                                    for (var C = 0; C < h.decoration.length; C++) {
                                                        var v = h.decoration[C];
                                                        var m = "Bold " + (v.fontSize || 12) + "px " + this.fontName;
                                                        if (v.color != g) {
                                                            g = v.color
                                                        }
                                                        if (this.colorNodeBy && !this.colorEdgeBy) {
                                                            g = this.monoColor(g, 0.33)
                                                        }
                                                        var f = v.labelColor || "rgb(242,216,0)";
                                                        var l = 1.8;
                                                        if (this.colorNodeBy && !this.colorEdgeBy) {
                                                            f = this.monoColor(f, 0.33)
                                                        }
                                                        if (h.id1 == h.id2) {
                                                            switch (e.pos) {
                                                                case "top":
                                                                    c = [r.startX, r.startY - (e.size * l)];
                                                                    break;
                                                                case "topRight":
                                                                    c = [r.startX + (e.size * l), r.startY - (e.size * l)];
                                                                    break;
                                                                case "right":
                                                                    c = [r.startX + (e.size * l), r.startY];
                                                                    break;
                                                                case "bottomRight":
                                                                    c = [r.startX + (e.size * l), r.startY + (e.size * l)];
                                                                    break;
                                                                case "bottom":
                                                                    c = [r.startX + (e.size * l), r.startY];
                                                                    break;
                                                                case "bottomLeft":
                                                                    c = [r.startX - (e.size * l), r.startY + (e.size * l)];
                                                                    break;
                                                                case "left":
                                                                    c = [r.startX - (e.size * l), r.startY];
                                                                    break;
                                                                case "topLeft":
                                                                    c = [r.startX - (e.size * l), r.startY - (e.size * l)];
                                                                    break
                                                            }
                                                        } else {
                                                            if (d == "quadratic" && v) {
                                                                E = this.perpendicularLinePoints(r.startX, r.startY, r.endX, r.endY, false, Math.min(1, this.arrowQuadraticFactor * Math.abs(b)) * (b > 0 ? -1 : 1));
                                                                z = this.shortenLine(r.startX, r.startY, r.endX, r.endY, Math.max(0, r.startS / s / 1.25), Math.max(0, r.endS / s / 1.25), d, b);
                                                                t = this.traceQuadraticCurve(z[0], z[1], E[0], E[1], z[2], z[3], 0.1, true);
                                                                c = t[Math.floor(v.pos * 10)]
                                                            } else {
                                                                if (h.elbows) {
                                                                    if (v.index == 0) {
                                                                        F = this.lineLength(w[0][0], w[0][1], w[1][0], w[1][1]);
                                                                        c = this.getCoordinateAtDistance(w[0][0], w[0][1], w[1][0], w[1][1], v.pos * F)
                                                                    } else {
                                                                        if (d == "bezier" && v) {
                                                                            o = this.traceBezierCurve(w[0][0], w[0][1], w[1][0], w[1][1], w[2][0], w[2][1], w[3][0], w[3][1], 0.1, true);
                                                                            c = o[Math.floor(v.index * 2 / 10)]
                                                                        } else {
                                                                            if (w[v.index + 1]) {
                                                                                F = this.lineLength(w[v.index][0], w[v.index][1], w[v.index + 1][0], w[v.index + 1][1]);
                                                                                c = this.getCoordinateAtDistance(w[v.index][0], w[v.index][1], w[v.index + 1][0], w[v.index + 1][1], v.pos * F)
                                                                            } else {
                                                                                F = this.lineLength(w[v.index][0], w[v.index][1], r.endX, r.endY);
                                                                                c = this.getCoordinateAtDistance(w[v.index][0], w[v.index][1], r.endX, r.endY, v.pos * F)
                                                                            }
                                                                        }
                                                                    }
                                                                } else {
                                                                    F = this.lineLength(r.startX, r.startY, r.endX, r.endY);
                                                                    c = this.getCoordinateAtDistance(r.startX, r.startY, r.endX, r.endY, v.pos * F)
                                                                }
                                                            }
                                                        }
                                                        if (c) {
                                                            this.toRender({
                                                                p: ["drawShape", v.shape, c[0], c[1] - 1, 22, 20, g, g],
                                                                a: this.getShapeArea(v.shape, c[0], c[1] - 1, 22, 20, g, g),
                                                                i: [D + this.data.nodes.length],
                                                                m: "-edgeDecoration-" + C,
                                                                g: u,
                                                                t: "Data",
                                                                h: this.isHidden(false, D + this.data.nodes.length)
                                                            });
                                                            this.toRender({
                                                                p: ["drawText", " " + v.label, c[0], c[1], m, f, "center", "middle"],
                                                                a: this.getTextArea(" " + v.label, c[0], c[1], m, f, "center", "middle"),
                                                                i: [D + this.data.nodes.length],
                                                                m: "-edgeDecorationLabel-" + C,
                                                                g: u,
                                                                t: "Data",
                                                                h: this.isHidden(false, D + this.data.nodes.length)
                                                            })
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawNetworkSelectionNodePoint = function(D, s, q, t, E, A, p) {
                                    var o, k, g, e, F, f, c, I, B, m, l, G, j, n, C;
                                    var d = 10 / this.scaleFactorX * 1.5;
                                    this.toRender({
                                        p: ["drawShape", "rect", s, q, t, E, this.nodeHighlightColor, this.foreground, "open", A, false, false, false, false, false, false, p],
                                        t: "Size"
                                    });
                                    if (A) {
                                        n = Math.cos(A);
                                        C = Math.sin(A);
                                        m = -(C * ((-E / 2) - d));
                                        l = (n * ((-E / 2) - d));
                                        G = -(C * (-E / 2));
                                        j = (n * (-E / 2));
                                        this.toRender({
                                            p: ["drawLine", "line", m + s, l + q, G + s, j + q, this.foreground],
                                            t: "Size"
                                        });
                                        o = [s - (C * ((-E / 2) - d)), q + (n * ((-E / 2) - d))];
                                        k = [s + (n * (-t / 2)) - (C * (-E / 2)), q + (n * (-E / 2)) + (C * (-t / 2))];
                                        g = [s - (C * (-E / 2)), q + (n * (-E / 2))];
                                        e = [s + (n * (t / 2)) - (C * (-E / 2)), q + (n * (-E / 2)) + (C * (t / 2))];
                                        F = [s + (n * (-t / 2)), q + (C * (-t / 2))];
                                        f = [s + (n * (-t / 2)) - (C * (E / 2)), q + (n * (E / 2)) + (C * (-t / 2))];
                                        c = [s - (C * (E / 2)), q + (n * (E / 2))];
                                        I = [s + (n * (t / 2)) - (C * (E / 2)), q + (n * (E / 2)) + (C * (t / 2))];
                                        B = [s + (n * (t / 2)), q + (C * (t / 2))]
                                    } else {
                                        this.toRender({
                                            p: ["drawLine", "line", s, q - ((E / 2) + d), s, q - (E / 2), this.foreground],
                                            t: "Size"
                                        });
                                        o = [s, q - ((E / 2) + d)];
                                        k = [s - (t / 2), q - (E / 2)];
                                        g = [s, q - (E / 2)];
                                        e = [s + (t / 2), q - (E / 2)];
                                        F = [s - (t / 2), q];
                                        f = [s - (t / 2), q + (E / 2)];
                                        c = [s, q + (E / 2)];
                                        I = [s + (t / 2), q + (E / 2)];
                                        B = [s + (t / 2), q]
                                    }
                                    var b = [o, k, g, e, F, f, c, I, B];
                                    var v = ["-resizeROT", "-resizeTL", "-resizeTM", "-resizeTR", "-resizeML", "-resizeBL", "-resizeBM", "-resizeBR", "-resizeMR"];
                                    var H = this.margin / this.scaleFactorX * 2;
                                    for (var u = 0; u < b.length; u++) {
                                        this.toRender({
                                            p: ["drawShape", "rect", b[u][0], b[u][1], H, H, this.nodeHighlightColor, this.foreground, "closed", A, false, false, false, false, false, false, p],
                                            a: this.getShapeArea("rect", b[u][0], b[u][1], H, H, this.nodeHighlightColor, this.foreground, "closed", A, false, false, false, false, false, false, p),
                                            i: [D],
                                            m: v[u],
                                            t: "Size"
                                        })
                                    }
                                };
                                this.drawNetworkNodeLabel = function(u, n, C, l, B, z) {
                                    var d, c, k, j, p;
                                    switch (this.networkVendor) {
                                        case "Metabase":
                                            break;
                                        case "Wikipathways":
                                            this.nodeFontSize = u.labelSize ? 1 : this.nodeFontSize;
                                            break;
                                        case "Cytoscape":
                                            break;
                                        default:
                                            this.nodeFontSize = Math.min(this.nodeFontSize, Math.ceil(this.nodeSize))
                                    }
                                    var e = this.networkLayoutType == "circular" ? "radial" : this.labelNodePosition == "auto" ? "center" : this.labelNodePosition;
                                    var m = this.zoomScale ? 1 : this.zoom;
                                    var f = u.label ? u.label : u.name ? u.name : u.id;
                                    var A = u.labelRotate ? u.labelRotate * Math.PI / 180 : false;
                                    var v = this.getNodeColor(u.id, u.labelColor);
                                    var s = (u.labelSize ? this.nodeFontSize * u.labelSize * this.nodeScaleFontFactor : this.nodeFontSize * this.nodeScaleFontFactor);
                                    var o = (u.labelStyle ? u.labelStyle : this.nodeFontStyle) + " " + Math.min(Math.max((parseInt(s / m)), this.scaleFactorX > this.minTextSize ? 1 : this.minTextSize), this.maxTextSize) + "px " + this.fontName;
                                    var t = this.measureText(f, o);
                                    var q = s;
                                    if (u.labelX != null && u.labelY != null) {
                                        d = u.labelX;
                                        c = u.labelY;
                                        this.toRender({
                                            p: ["drawText", f, u.labelX, u.labelY, o, v, u.labelAlign || "center", "middle", A],
                                            a: this.getTextArea(f, u.labelX, u.labelY, o, v, u.labelAlign || "center", "middle", A),
                                            i: [z],
                                            m: "-lab",
                                            t: "Labels",
                                            h: this.isHidden(z)
                                        })
                                    } else {
                                        var g = this.isMultipleLines(f);
                                        var b = parseInt(s) + 4;
                                        if (g) {
                                            if (g % 2) {
                                                C -= (parseInt(g / 2) * b) + (b / 2)
                                            } else {
                                                C = (C - (parseInt(g / 2) * b)) - b
                                            }
                                        }
                                        if (u.labelPosition) {
                                            e = u.labelPosition
                                        }
                                        switch (e) {
                                            case "top":
                                                d = n - (t / 2);
                                                c = C - ((B / 2) + this.margin + (q / 2));
                                                k = n;
                                                j = c;
                                                u.labelXi = n;
                                                u.labelYi = c;
                                                break;
                                            case "bottom":
                                                d = n - (t / 2);
                                                c = C + ((B / 2) + this.margin + (q / 2));
                                                k = n;
                                                j = c;
                                                u.labelXi = n;
                                                u.labelYi = c;
                                                break;
                                            case "right":
                                                d = n + ((l / 2) + this.margin + (t / 2));
                                                c = C - (q / 2);
                                                k = d;
                                                j = C;
                                                u.labelXi = d;
                                                u.labelYi = C;
                                                break;
                                            case "left":
                                                d = n - ((l / 2) + this.margin + (t / 2));
                                                c = C - (q / 2);
                                                k = d;
                                                j = C;
                                                u.labelXi = d;
                                                u.labelYi = C;
                                                break;
                                            case "center":
                                                k = n;
                                                j = C;
                                                u.labelXi = n;
                                                u.labelYi = C;
                                                break;
                                            case "radial":
                                                p = (Math.PI / 2) - (u.angle * Math.PI / 180);
                                                k = n + ((l + (this.margin * 3)) * Math.cos(p) * 0.5);
                                                j = C + ((l + (this.margin * 3)) * Math.sin(p) * 0.5);
                                                u.labelXi = n;
                                                u.labelYi = C;
                                                if (p >= -(Math.PI / 2)) {
                                                    this.toRender({
                                                        p: ["drawText", f, k, j, o, v, "left", "middle", p],
                                                        a: this.getTextArea(f, k, j, o, v, "left", "middle", p),
                                                        i: [z],
                                                        m: "-lab",
                                                        t: "Labels",
                                                        h: this.isHidden(z)
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", f, k, j, o, v, "right", "middle", p - Math.PI],
                                                        a: this.getTextArea(f, k, j, o, v, "right", "middle", p - Math.PI),
                                                        i: [z],
                                                        m: "-lab",
                                                        t: "Labels",
                                                        h: this.isHidden(z)
                                                    })
                                                }
                                                return
                                        }
                                        this.toRender({
                                            p: ["drawText", f, k, j, o, v, "center", "middle", A],
                                            a: this.getTextArea(f, k, j, o, v, "center", "middle", A),
                                            i: [z],
                                            m: "-lab",
                                            t: "Labels",
                                            h: this.isHidden(z)
                                        })
                                    }
                                };
                                this.drawNetworkNodes = function(t) {
                                    var j = this;
                                    var d = function(F, i, E, B, D) {
                                        if (j.colorNodeBy && !F.immutable) {
                                            var C = j.getNodeEdgePropertyValue(F, false, "colorNodeBy");
                                            return j.networkVendor == "Kegg" ? j.addColorTransparency(C, 0.6, true) : C
                                        } else {
                                            if (F.communityColor && j.coordinateNetworkConvexHullCommunityColor) {
                                                return F.communityColor
                                            } else {
                                                if (F.gradient && F.color1 && F.color2) {
                                                    if (F.gradient == "linear") {
                                                        if (j.colorNodeBy || j.colorEdgeBy) {
                                                            if (j.gradientOrientation == "vertical") {
                                                                return j.getLinearGradient(0, 0, 0, D, [j.monoColor(F.color1, 0.25), j.monoColor(F.color2, 0.25)])
                                                            } else {
                                                                return j.getLinearGradient(0, 0, B, 0, [j.monoColor(F.color1, 0.25), j.monoColor(F.color2, 0.25)])
                                                            }
                                                        } else {
                                                            if (j.gradientOrientation == "vertical") {
                                                                return j.getLinearGradient(0, 0, 0, D, [F.color1, F.color2])
                                                            } else {
                                                                return j.getLinearGradient(0, 0, B, 0, [F.color1, F.color2])
                                                            }
                                                        }
                                                    } else {
                                                        return j.getRadialGradient(i, E, Math.max(B, D) / 2, [F.color1, F.color2, F.color3])
                                                    }
                                                } else {
                                                    if (j.colorNodeBy || j.colorEdgeBy) {
                                                        return u.shape == "image" ? "b&w" : F.immutable ? j.monoColor(F.color, 0.33) : j.monoColor(j.getNodeEdgePropertyValue(F, false, "colorNodeBy"), 0.33)
                                                    } else {
                                                        return u.shape == "image" ? false : F.immutable ? F.color : j.getNodeEdgePropertyValue(F, false, "colorNodeBy")
                                                    }
                                                }
                                            }
                                        }
                                    };
                                    var n = this.zoomScale ? 1 : this.zoom;
                                    var l = this.data.nodes.length / n < this.showNodeNameThreshold ? true : false;
                                    var g = this.foreground;
                                    var w = this.shapes[0];
                                    var b = 6001;
                                    var h = this.rangeX > this.rangeY ? "bottom" : "right";
                                    for (var x = 0; x < this.data.nodes.length; x++) {
                                        var u = this.data.nodes[x];
                                        if (!this.ignoreEventlessOrder) {
                                            if (t) {
                                                if (!u.eventless) {
                                                    continue
                                                }
                                            } else {
                                                if (u.eventless) {
                                                    continue
                                                }
                                            }
                                        }
                                        if (!u.hide && !u.hiddenParent) {
                                            var o = u.x;
                                            var A = u.y;
                                            var q = this.getNodeEdgePropertyValue(u, false, "shapeNodeBy");
                                            var y = u.outline ? u.outline : this.foreground;
                                            var z = this.getNodeEdgePropertyValue(u, false, "sizeNodeBy");
                                            var m = this.sizeNodeBy ? this.nodeSize * z / n : u.width ? u.width / n : this.nodeSize * z / n;
                                            var s = this.sizeNodeBy ? this.nodeSize * z / n : u.height ? u.height / n : this.nodeSize * z / n;
                                            var v = CanvasXpress.selector.nodes.hasOwnProperty(u.id) ? true : false;
                                            var f = this.getNodeColor(u.id, d(u, o, A, m, s));
                                            var p = this.getNodeEdgePropertyValue(u, false, "patternNodeBy");
                                            var k = u.rotate ? u.rotate * Math.PI / 180 : false;
                                            var r = u.outlineWidth ? u.outlineWidth : false;
                                            var e = u.imagePath ? u.imagePath : false;
                                            var c = u.zIndex ? u.zIndex : e ? b : false;
                                            if (this.isLayoutDone && !this.isAnimation) {
                                                if (u.zoomX) {
                                                    m *= u.zoomX
                                                }
                                                if (u.zoomY) {
                                                    s *= u.zoomY
                                                }
                                                if (!u.eventless) {
                                                    this.toRender({
                                                        p: ["drawShape", q, o, A, m, s, f, y, p, k, r, false, false, false, false, e, c],
                                                        a: this.getShapeArea(q, o, A, m, s, f, y, p, k, r, false, false, false, false, e, c),
                                                        i: [x],
                                                        t: "Data",
                                                        h: this.isHidden(x)
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawShape", q, o, A, m, s, f, y, p, k, r, false, false, false, false, e, c],
                                                        t: "Data"
                                                    })
                                                }
                                                if (v && !u.fixed) {
                                                    this.drawNetworkSelectionNodePoint(x, o, A, m, s, k, r)
                                                } else {
                                                    if (v && u.fixed) {
                                                        this.drawNetworkSelectionNodePoint(u, o, A, m, s, k, r)
                                                    }
                                                }
                                                if (l && !u.hideLabel) {
                                                    if (!u.eventless && (m > this.showNodeNameSizeThreshold || this.data.nodes.length < this.showNodeNameThreshold)) {
                                                        this.drawNetworkNodeLabel(u, o, A, m, s, x)
                                                    }
                                                }
                                            } else {
                                                this.toRender({
                                                    p: ["drawShape", q, o, A, m, s, f, y, p, k, r, false, false, false, false, e, c],
                                                    t: "Data"
                                                })
                                            }
                                            b++
                                        }
                                    }
                                };
                                this.drawNetworkCommunities = function() {
                                    if (this.showNetworkCommunities && !this.networkVendor) {
                                        for (var e = 0; e < this.networkCommunities; e++) {
                                            if (this.networkConvexHulls[e]["nodes"]) {
                                                var d = [];
                                                var g = [];
                                                var k = this.addColorTransparency(this.colors[e % this.colors.length], 0.2, true);
                                                var f = this.getHull(this.networkConvexHulls[e]["nodes"]);
                                                this.networkConvexHulls[e]["convexHull"] = f[0];
                                                for (var b = 0; b < f[0].length; b++) {
                                                    d.push(f[0][b][0]);
                                                    g.push(f[0][b][1])
                                                }
                                                this.toRender({
                                                    p: ["drawShape", "hull", d, g, f[2] - f[1], f[4] - f[3], k],
                                                    t: "Decorations"
                                                })
                                            }
                                        }
                                    }
                                };
                                this.drawNetworkDecorations = function() {
                                    if (this.showDecorations && this.decorations.length > 0) {
                                        var f = this;
                                        var B = function() {
                                            var p = {};
                                            for (var H = 0; H < f.data.nodes.length; H++) {
                                                var I = f.data.nodes[H];
                                                if (!I.hide && !I.hiddenParent) {
                                                    for (var z = 0; z < f.decorations.length; z++) {
                                                        var J = f.decorations[z];
                                                        if (I[J] || (I.decorations && I.decorations[J])) {
                                                            p[H] = true
                                                        }
                                                    }
                                                }
                                            }
                                            return f.getKeys(p).sort(function(j, i) {
                                                return j - i
                                            })
                                        };
                                        var u = function(z) {
                                            var J = {
                                                vals: {}
                                            };
                                            for (var I = 0; I < z.length; I++) {
                                                var K = f.data.nodes[z[I]];
                                                for (var H = 0; H < f.decorations.length; H++) {
                                                    var M = f.decorations[H];
                                                    var L = K[M] ? K[M] : K.decorations ? K.decorations[M] : false;
                                                    if (f.isObject(L)) {
                                                        J.type = "m";
                                                        for (var p in L) {
                                                            J.vals[p] = true
                                                        }
                                                    } else {
                                                        J.type = "s"
                                                    }
                                                }
                                            }
                                            return J
                                        };
                                        var g = function(z, p, P) {
                                            var N = f.getKeys(p.vals);
                                            var K = {
                                                vals: [],
                                                area: [],
                                                cols: [],
                                                col2: [],
                                                patt: [],
                                                shpe: [],
                                                shp2: []
                                            };
                                            if (p.type == "m") {
                                                if (f.decorationsType == "heatmap") {
                                                    for (var L = 0; L < N.length; L++) {
                                                        K.vals[L] = [];
                                                        K.area[L] = [];
                                                        K.patt[L] = []
                                                    }
                                                } else {
                                                    for (var L = 0; L < f.decorations.length; L++) {
                                                        K.vals[L] = [];
                                                        K.area[L] = [];
                                                        K.patt[L] = [];
                                                        K.cols[L] = []
                                                    }
                                                }
                                            }
                                            for (var L = 0; L < f.decorations.length; L++) {
                                                var H = f.decorations[L];
                                                var M = f.decorationsProperties[H] && f.decorationsProperties[H].color ? f.decorationsProperties[H].color : f.decorationsColors[L];
                                                var R = f.decorationsProperties[H] && f.decorationsProperties[H].shape ? f.decorationsProperties[H].shape : "circle";
                                                if (p.type == "m") {
                                                    for (var J = 0; J < N.length; J++) {
                                                        var Q = z[H] ? z[H][N[J]] : z.decorations && z.decorations[H] ? z.decorations[H][N[J]] : "NA";
                                                        var I = f.decorationsProperties[N[J]] && f.decorationsProperties[N[J]].color ? f.decorationsProperties[N[J]].color : f.decorationsColors[f.decorations.length + J];
                                                        var O = f.decorationsProperties[N[J]] && f.decorationsProperties[N[J]].shape ? f.decorationsProperties[N[J]].shape : "rect";
                                                        if (f.decorationsType == "heatmap") {
                                                            K.vals[J].push(Q);
                                                            K.area[J].push([P + "-" + L + "-" + N[J]]);
                                                            K.patt[J].push("closed");
                                                            if (L == 0) {
                                                                K.cols.push(I);
                                                                K.shpe.push(O)
                                                            }
                                                        } else {
                                                            if (f.decorationsType.match(/stacked/)) {
                                                                K.vals[L].push(Q);
                                                                K.area[L].push([P + "-" + L + "-" + N[J]]);
                                                                K.cols[L].push(I);
                                                                K.patt[L].push("closed")
                                                            }
                                                        }
                                                    }
                                                    K.col2.push(M);
                                                    if (f.decorationsType == "heatmap") {
                                                        K.shp2.push(R)
                                                    } else {
                                                        K.shpe.push(R)
                                                    }
                                                } else {
                                                    if (!K.vals[0]) {
                                                        K.vals[0] = []
                                                    }
                                                    var Q = z[H] ? z[H] : z.decorations && z.decorations[H] ? z.decorations[H] : "NA";
                                                    var M = f.decorationsProperties[H] && f.decorationsProperties[H].color ? f.decorationsProperties[H].color : f.decorationsColors[L];
                                                    var R = f.decorationsProperties[H] && f.decorationsProperties[H].shape ? f.decorationsProperties[H].shape : "circle";
                                                    K.vals[0].push(Q);
                                                    K.area.push([P + "-" + L]);
                                                    K.cols.push(M);
                                                    K.patt.push("closed");
                                                    K.shpe.push(R)
                                                }
                                            }
                                            return K
                                        };
                                        var r = B();
                                        var o = u(r);
                                        var A = (this.decorations.length * this.decorationsWidth / 2);
                                        var k = this.decorationsWidth * 0.3;
                                        var e = k * 0.6;
                                        var d = this.decorationsHeight / 2;
                                        var D = this.getColorBrew(this.colorSpectrum, this.decorationsRange[0], this.decorationsRange[1], this.colorSpectrumZeroValue, this.colorSpectrumBreaks);
                                        for (var w = 0; w < r.length; w++) {
                                            var t = this.data.nodes[r[w]];
                                            var F = g(t, o, r[w]);
                                            if (!t.hide && !t.hiddenParent) {
                                                var n = t.x;
                                                var x = t.y;
                                                var G = t.size ? this.nodeSize * t.size : this.nodeSize;
                                                var b = G / 2;
                                                var y, c;
                                                if (t.decorationsX != null && t.decorationsY != null) {
                                                    y = t.decorationsX;
                                                    c = t.decorationsY
                                                } else {
                                                    switch (this.decorationsPosition) {
                                                        case "top":
                                                            y = this.decorationsType == "pie" ? n : n - A;
                                                            if (this.decorationsType == "pie") {
                                                                c = x - (b + d + this.decorationsWidth)
                                                            } else {
                                                                c = x - (b + this.decorationsHeight + this.decorationsWidth)
                                                            }
                                                            break;
                                                        case "bottom":
                                                            y = this.decorationsType == "pie" ? n : n - A;
                                                            c = x + (b + this.decorationsWidth);
                                                            c = this.decorationsType == "pie" ? c + d : c;
                                                            break;
                                                        case "right":
                                                            y = n + b + this.decorationsWidth;
                                                            c = this.decorationsType == "pie" ? x : x - d;
                                                            y = this.decorationsType == "pie" ? y + d : y;
                                                            break;
                                                        case "left":
                                                            if (this.decorationsType == "pie") {
                                                                y = n - (b + (this.decorationsHeight / 2) + this.decorationsWidth)
                                                            } else {
                                                                y = n - (b + (this.decorationsWidth * (this.decorations.length + 1)))
                                                            }
                                                            c = this.decorationsType == "pie" ? x : x - d;
                                                            break;
                                                        case "center":
                                                            y = this.decorationsType == "pie" || this.decorationsType == "heatmap" ? n : n - A;
                                                            c = this.decorationsType == "pie" || this.decorationsType == "heatmap" ? x : x - d;
                                                            break
                                                    }
                                                    t.decorationsXi = y;
                                                    t.decorationsYi = c
                                                }
                                                if (this.decorationsType == "bar") {
                                                    var h = this.decorationsRange[0] < 0 ? Math.abs(this.decorationsRange[0]) * this.decorationsUnits : 0;
                                                    this.drawBarPlot(F.vals[0], [], y, c + this.decorationsHeight - h, this.decorationsWidth, this.decorationsWidth, this.decorationsUnits, h, this.decorationsRange[0], "vertical", F.cols, F.patt, F.area, "-dec")
                                                } else {
                                                    if (this.decorationsType.match(/stacked/)) {
                                                        var q = this.decorationsType.match(/percent/) ? true : false;
                                                        c += this.decorationsHeight;
                                                        if (this.decorationsPosition == "top") {
                                                            c -= this.decorationsWidth
                                                        }
                                                        for (var v = 0; v < this.decorations.length; v++) {
                                                            this.drawStackedPlot(F.vals[v], y, c, this.decorationsWidth, false, q, [this.sum(F.vals[v], false, false, true), this.sum(F.vals[v], false, false, false, true)], this.decorationsUnits, 0, "vertical", F.cols[v], F.patt[v], F.area[v], "-dec");
                                                            this.toRender({
                                                                p: ["drawShape", F.shpe[v], y + this.decorationsWidth / 2, c + this.decorationsWidth, k, k, F.col2[v], this.foreground, "closed"],
                                                                t: "Decorations"
                                                            });
                                                            y += this.decorationsWidth
                                                        }
                                                    } else {
                                                        if (this.decorationsType == "heatmap") {
                                                            if (o.type == "m") {
                                                                var E = this.decorationsHeight / F.vals.length;
                                                                switch (this.decorationsPosition) {
                                                                    case "top":
                                                                        c -= this.decorationsWidth;
                                                                        break;
                                                                    case "bottom":
                                                                        break;
                                                                    case "right":
                                                                        y += this.decorationsWidth;
                                                                        break;
                                                                    case "left":
                                                                        break;
                                                                    case "center":
                                                                        break
                                                                }
                                                                if (this.decorationsPosition == "center") {
                                                                    var m = this.zoomScale ? 1 : this.zoom;
                                                                    var l = this.sizeNodeBy ? this.nodeSize * siz / m : t.width ? t.width / m : this.nodeSize * siz / m;
                                                                    var s = this.sizeNodeBy ? this.nodeSize * siz / m : t.height ? t.height / m : this.nodeSize * siz / m;
                                                                    n -= t.width * 0.5;
                                                                    x -= t.height * 0.5;
                                                                    l /= F.vals[0].length;
                                                                    s /= F.vals.length;
                                                                    for (var v = 0; v < F.vals.length; v++) {
                                                                        this.drawHeatmap(F.vals[v], n, x, l, s, false, F.area[v], "-dec", F.patt[v], D, 0.67);
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", n + t.width - 2, x - 1, n + t.width - 2, x + s - 0.5, F.cols[v], 2],
                                                                            t: "Decorations"
                                                                        });
                                                                        x += s
                                                                    }
                                                                    x -= 1.5;
                                                                    for (var v = 0; v < this.decorations.length; v++) {
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", n, x, n + l, x, F.col2[v], 2],
                                                                            t: "Decorations"
                                                                        });
                                                                        n += l
                                                                    }
                                                                    this.toRender({
                                                                        p: ["drawShape", "rectangle", y, c, t.width, t.height, false, this.foreground, "open"],
                                                                        t: "Decorations"
                                                                    })
                                                                } else {
                                                                    for (var v = 0; v < F.vals.length; v++) {
                                                                        this.drawHeatmap(F.vals[v], y, c, this.decorationsWidth, E, false, F.area[v], "-dec", F.patt[v], D);
                                                                        this.toRender({
                                                                            p: ["drawShape", F.shpe[v], y - e, c + (E / 2), k, E / 2, F.cols[v], F.cols[v], "closed"],
                                                                            t: "Decorations"
                                                                        });
                                                                        c += E
                                                                    }
                                                                    for (var v = 0; v < this.decorations.length; v++) {
                                                                        this.toRender({
                                                                            p: ["drawShape", F.shp2[v], y + this.decorationsWidth / 2, c + e, k, k, F.col2[v], F.col2[v], "closed"],
                                                                            t: "Decorations"
                                                                        });
                                                                        y += this.decorationsWidth
                                                                    }
                                                                }
                                                            } else {
                                                                if (this.decorationsPosition == "top") {
                                                                    c -= this.decorationsWidth
                                                                }
                                                                if (this.decorationsPosition == "center") {
                                                                    var m = this.zoomScale ? 1 : this.zoom;
                                                                    var l = this.sizeNodeBy ? this.nodeSize * siz / m : t.width ? t.width / m : this.nodeSize * siz / m;
                                                                    var s = this.sizeNodeBy ? this.nodeSize * siz / m : t.height ? t.height / m : this.nodeSize * siz / m;
                                                                    n -= t.width * 0.5;
                                                                    x -= t.height * 0.5;
                                                                    l /= this.decorations.length;
                                                                    this.drawHeatmap(F.vals[0], n, x, l, s, false, F.area, "-dec", F.patt, D, 0.67);
                                                                    x += t.height - 1.5;
                                                                    for (var v = 0; v < this.decorations.length; v++) {
                                                                        this.toRender({
                                                                            p: ["drawLine", "line", n, x, n + l, x, F.cols[v], 2],
                                                                            t: "Decorations"
                                                                        });
                                                                        n += l
                                                                    }
                                                                    this.toRender({
                                                                        p: ["drawShape", "rectangle", y, c, t.width, t.height, false, this.foreground, "open"],
                                                                        t: "Decorations"
                                                                    })
                                                                } else {
                                                                    this.drawHeatmap(F.vals[0], y, c, this.decorationsWidth, this.decorationsHeight, false, F.area, "-dec", F.patt, D);
                                                                    for (var v = 0; v < this.decorations.length; v++) {
                                                                        this.toRender({
                                                                            p: ["drawShape", F.shpe[v], y + this.decorationsWidth / 2, c + this.decorationsHeight + e, k, k, F.cols[v], F.cols[v], "closed"],
                                                                            t: "Decorations"
                                                                        });
                                                                        y += this.decorationsWidth
                                                                    }
                                                                }
                                                            }
                                                        } else {
                                                            var C = this.colors;
                                                            this.colors = F.cols;
                                                            this.drawPie(this.setPieData(F.vals[0], false, F.cols), y, c, d, F.area, "-dec");
                                                            this.colors = C
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.findNetworkXYRange = function(c) {
                                    var b = Number.MAX_VALUE;
                                    var g = Number.MAX_VALUE * -1;
                                    var h = Number.MAX_VALUE;
                                    var f = Number.MAX_VALUE * -1;
                                    if (!c) {
                                        c = this.getKeys(this.data.nodeIndices)
                                    }
                                    if (c && c.length > 0) {
                                        for (var d = 0; d < c.length; d++) {
                                            var e = this.data.nodes[this.data.nodeIndices[c[d]]];
                                            if (!e.hide && !e.hiddenParent) {
                                                b = Math.min(b, e.x);
                                                g = Math.max(g, e.x);
                                                h = Math.min(h, e.y);
                                                f = Math.max(f, e.y)
                                            }
                                        }
                                    }
                                    return ({
                                        minX: b,
                                        maxX: g,
                                        minY: h,
                                        maxY: f
                                    })
                                };
                                this.packSubNetworks = function() {
                                    var f = this;
                                    var b = function(w, v, j) {
                                        for (var x = 0; x < w.length; x++) {
                                            var y = f.data.nodes[f.data.nodeIndices[w[x]]];
                                            if (y.hasOwnProperty("layout")) {
                                                y.layout.lastPosition.x += v;
                                                y.layout.lastPosition.y += j
                                            }
                                        }
                                    };
                                    var r = function(i, z, j, v) {
                                        this.x = i;
                                        this.y = z;
                                        this.w = j;
                                        this.h = v
                                    };
                                    r.prototype.fits = function(i) {
                                        return i.w >= this.w && i.h >= this.h
                                    };
                                    r.prototype.sameSize = function(i) {
                                        return i.w == this.w && i.h == this.h
                                    };
                                    var d = function() {
                                        this.l = null;
                                        this.r = null;
                                        this.a = null;
                                        this.f = false
                                    };
                                    d.prototype.insert = function(i) {
                                        if (this.l != null) {
                                            return this.l.insert(i) || this.r.insert(i)
                                        }
                                        if (this.f) {
                                            return null
                                        }
                                        if (!i.fits(this.a)) {
                                            return null
                                        }
                                        if (i.sameSize(this.a)) {
                                            this.f = true;
                                            return this
                                        }
                                        this.l = new d();
                                        this.r = new d();
                                        var j = this.a.w - i.w;
                                        var w = this.a.h - i.h;
                                        var v = this.a;
                                        if (j > w) {
                                            this.l.a = new r(v.x, v.y, i.w, v.h);
                                            this.r.a = new r(v.x + i.w, v.y, v.w - i.w, v.h)
                                        } else {
                                            this.l.a = new r(v.x, v.y, v.w, i.h);
                                            this.r.a = new r(v.x, v.y + i.h, v.w, v.h - i.h)
                                        }
                                        return this.l.insert(i)
                                    };
                                    for (var p = 0; p < this.subNetworks.length; p++) {
                                        for (var o = 0; o < this.subNetworks[p].nodes.length; o++) {
                                            var l = this.data.nodes[this.data.nodeIndices[this.subNetworks[p].nodes[o]]];
                                            if (l.hasOwnProperty("layout")) {
                                                l.layout.lastPosition.x = 0;
                                                l.layout.lastPosition.y = 0
                                            }
                                        }
                                        this.subNetworks[p].mnm = this.findNetworkXYRange(this.subNetworks[p].nodes);
                                        this.subNetworks[p].w = (this.subNetworks[p].mnm.maxX - this.subNetworks[p].mnm.minX);
                                        this.subNetworks[p].h = (this.subNetworks[p].mnm.maxY - this.subNetworks[p].mnm.minY);
                                        b(this.subNetworks[p].nodes, this.subNetworks[p].mnm.minX, this.subNetworks[p].mnm.minY)
                                    }
                                    var c = this.subNetworks[1];
                                    for (var p = 0; p < this.subNetworks.length; p++) {
                                        this.subNetworks[p].w += (c.w * 0.5);
                                        this.subNetworks[p].h += (c.h * 0.5)
                                    }
                                    var t = this.subNetworks[0];
                                    var u = t.nodes.length / this.data.nodes.length;
                                    var k = ((2 + u) * ((this.x / this.y) * t.w));
                                    var g = ((2 + u) * ((this.y / this.x) * t.h));
                                    var h = new d();
                                    var n, m;
                                    h.a = new r(0, 0, k, g);
                                    for (var p = 0; p < this.subNetworks.length; p++) {
                                        var q = this.subNetworks[p];
                                        var s = new r(0, 0, q.w, q.h);
                                        var e = h.insert(s);
                                        if (e) {
                                            b(this.subNetworks[p].nodes, -e.a.x, -e.a.y)
                                        }
                                    }
                                };
                                this.setNetworkMinMaxRangeXY = function(f) {
                                    if (!this.networkFreeze || (this.rangeX == null || this.rangeY == null) || f) {
                                        this.minX = Number.MAX_VALUE;
                                        this.minY = Number.MAX_VALUE;
                                        this.maxX = 0;
                                        this.maxY = 0;
                                        for (var c = 0; c < this.data.nodes.length; c++) {
                                            var e = this.data.nodes[c];
                                            var b = e.width ? e.width : e.size ? (this.nodeSize * e.size) : this.nodeSize;
                                            var d = e.height ? e.height : e.size ? (this.nodeSize * e.size) : this.nodeSize;
                                            if (!e.hide) {
                                                this.minX = Math.min(this.minX, e.x - b / 2);
                                                this.minY = Math.min(this.minY, e.y - d / 2);
                                                this.maxX = Math.max(this.maxX, e.x + b / 2);
                                                this.maxY = Math.max(this.maxY, e.y + d / 2)
                                            }
                                        }
                                        this.rangeX = this.maxX - this.minX;
                                        this.rangeY = this.maxY - this.minY
                                    }
                                };
                                this.setNetworkRotation = function() {
                                    if (this.is3DNetwork && this.isLayoutDone) {
                                        var h = [];
                                        var e = [];
                                        var o = [];
                                        this.set3DRotation();
                                        for (var f = 0; f < this.data.nodes.length; f++) {
                                            e.push(f);
                                            var c = this.data.nodes[f];
                                            var g = this.get3DTransfrom(c.x, c.y, c.z);
                                            c.x = g[0] - this.padX;
                                            c.y = g[1] - this.padY;
                                            c.z = g[2] - this.padZ;
                                            h.push(Math.sqrt((c.x * c.x) + (c.y * c.y) + (c.z * c.z)))
                                        }
                                        e.sort(function(j, i) {
                                            return h[i] - h[j]
                                        });
                                        for (var n = 0; n < this.data.nodes.length; n++) {
                                            var f = e[n];
                                            var c = this.data.nodes[f];
                                            o.push(c)
                                        }
                                        this.data.nodes = o;
                                        this.setNodeIndices()
                                    } else {
                                        if (this.network2DRotate) {
                                            if (this.network2DRotate >= Math.abs(360)) {
                                                this.network2DRotate = 0
                                            }
                                            var k = Math.PI * this.network2DRotate / 360;
                                            for (var f = 0; f < this.data.nodes.length; f++) {
                                                var c = this.data.nodes[f];
                                                if (c.x != null && c.y != null) {
                                                    var m = c.x;
                                                    var l = c.y;
                                                    c.x = (m * Math.cos(k)) - (l * Math.sin(k));
                                                    c.y = (l * Math.cos(k)) + (m * Math.sin(k))
                                                }
                                            }
                                            for (var f = 0; f < this.data.edges.length; f++) {
                                                var b = this.data.edges[f];
                                                if (b.elbows && b.elbows.length > 0) {
                                                    for (var d = 0; d < b.elbows.length; d++) {
                                                        var m = b.elbows[d][0];
                                                        var l = b.elbows[d][1];
                                                        b.elbows[d][0] = (m * Math.cos(k)) - (l * Math.sin(k));
                                                        b.elbows[d][1] = (l * Math.cos(k)) + (m * Math.sin(k))
                                                    }
                                                }
                                            }
                                        }
                                        this.network2DRotate = 0
                                    }
                                };
                                this.setNetworkScaleFactor = function(c) {
                                    var b = this.legendWidth != this.lastNetworkLegendWidth || this.legendHeight != this.lastNetworkLegendHeight;
                                    if (!this.networkFreeze || this.scaleFactorX == null || this.scaleFactorY == null || isNaN(this.scaleFactorX) || isNaN(this.scaleFactorY) || b) {
                                        if (!this.isLayoutDone && this.isAnimation && (this.networkLayoutType == "radial" || this.networkLayoutType == "circular")) {
                                            this.scaleFactorX = this.networkLayoutType == "radial" ? 0.3 : this.networkLayoutType == "circular" ? 1 : this.x / (this.maxX - this.minX);
                                            this.scaleFactorY = this.networkLayoutType == "radial" ? 0.3 : this.networkLayoutType == "circular" ? 1 : this.y / (this.maxY - this.minY)
                                        } else {
                                            this.scaleFactorX = this.x / (this.maxX - this.minX);
                                            this.scaleFactorY = this.y / (this.maxY - this.minY)
                                        }
                                    }
                                    this.lastNetworkLegendWidth = this.legendWidth;
                                    this.lastNetworkLegendHeight = this.legendHeight;
                                    this.scaleFactorX = Math.min(this.scaleFactorX, this.scaleFactorY);
                                    this.scaleFactorY = this.scaleFactorX;
                                    this.scaleFactorX *= this.zoom;
                                    this.scaleFactorY *= this.zoom;
                                    if (this.networkFreeze) {
                                        this.zoomGlobal *= this.zoom;
                                        this.zoom = 1
                                    }
                                    this.widthBounds = this.x / this.scaleFactorX;
                                    this.heightBounds = this.y / this.scaleFactorY;
                                    this.offsetX = ((this.widthBounds / 2) - ((this.minX + this.maxX) / 2)) + this.panningX + this.panningGlobalX + (this.left / this.scaleFactorX);
                                    this.offsetY = ((this.heightBounds / 2) - ((this.minY + this.maxY) / 2)) + this.panningY + this.panningGlobalY + (this.top / this.scaleFactorY);
                                    this.nodeSize = 15 / this.scaleFactorX * this.zoom;
                                    this.edgeThickness = 1 / this.scaleFactorX * this.zoom;
                                    this.outlineWidth = 1 / this.scaleFactorX * this.zoom
                                };
                                this.recalculateLayoutSelectedNodes = function() {
                                    if (CanvasXpress.selector.selections > 0 && this.networkLayoutType != "radial") {
                                        this.randomSeed = 8;
                                        var b = [];
                                        for (var c in CanvasXpress.selector.nodes) {
                                            b.push(this.data.nodes[this.data.nodeIndices[c]])
                                        }
                                        this.fixNetworkNodes();
                                        this.setNetworkPrivateParams(b);
                                        this.setNetworkLayout(b, false, true)
                                    }
                                };
                                this.fixNetworkNodes = function() {
                                    for (var b = 0; b < this.data.nodes.length; b++) {
                                        var c = this.data.nodes[b];
                                        if (!CanvasXpress.selector.nodes.hasOwnProperty(c.id)) {
                                            if (!c.fixed || (c.fixed && c.fixed != 1)) {
                                                c.fixed = 1
                                            }
                                        }
                                    }
                                };
                                this.unfixNetworkNodes = function() {
                                    for (var b = 0; b < this.data.nodes.length; b++) {
                                        var c = this.data.nodes[b];
                                        if (c.fixed == 1) {
                                            delete c.fixed
                                        }
                                    }
                                };
                                this.setNetworkLayout = function(c, b, d) {
                                    if (!c) {
                                        c = this.data.nodes
                                    }
                                    if (!b) {
                                        b = this.networkRoot
                                    }
                                    this.isLayoutDone = false;
                                    this.isAnimation = true;
                                    this.iteration = 0;
                                    this.randomSeed = 8;
                                    if (this.networkLayoutType == "radial") {
                                        this.radialLayout(c, b)
                                    } else {
                                        if (this.networkLayoutType == "circular") {
                                            this.circularLayout(c)
                                        } else {
                                            this.forceDirectedLayout(c, d)
                                        }
                                    }
                                };
                                this.initializeNetworkLayout = function() {
                                    for (var b = 0; b < this.data.nodes.length; b++) {
                                        this.initializeNetworkNodes(this.data.nodes[b])
                                    }
                                    for (var b = 0; b < this.data.nodes.length; b++) {
                                        this.initializeNodeNeighborhood(this.data.nodes[b])
                                    }
                                    if (this.networkLayoutType != "radial" && this.networkLayoutType != "circular") {
                                        for (var b = 0; b < this.data.nodes.length; b++) {
                                            this.setInitialNodePosition(this.data.nodes[b])
                                        }
                                    }
                                    for (var b = 0; b < this.data.edges.length; b++) {
                                        this.initializeNetworkEdges(this.data.edges[b])
                                    }
                                };
                                this.moveSubnetworks = function(e) {
                                    var d = this;
                                    this.isLayoutDone = false;
                                    this.isAnimation = true;
                                    this.iteration = 0;
                                    this.packSubNetworks();
                                    var b = function() {
                                        for (var k = 0; k < d.subNetworks.length; k++) {
                                            for (var h = 0; h < d.subNetworks[k].nodes.length; h++) {
                                                var l = d.data.nodes[d.data.nodeIndices[d.subNetworks[k].nodes[h]]];
                                                var g = (l.layout.lastPosition.x / 15);
                                                var f = (l.layout.lastPosition.y / 15);
                                                d.modifyXYNode(l.id, g, f)
                                            }
                                        }
                                    };
                                    var c = function() {
                                        if (d.iteration++ < 15) {
                                            d.showAnimation = true;
                                            b();
                                            d.renderNetwork(false);
                                            d.drawNetworkProgressBar("Sorting ...", d.iteration / 15);
                                            setTimeout(c, 80)
                                        } else {
                                            d.subNetworks = false;
                                            d.finalizeNetworkLayout(e)
                                        }
                                    };
                                    c()
                                };
                                this.finalizeNetworkLayout = function(b) {
                                    if (this.subNetworks) {
                                        this.moveSubnetworks(b)
                                    } else {
                                        this.isLayoutDone = true;
                                        this.isAnimation = false;
                                        this.iteration = 0;
                                        if (CanvasXpress.stack[this.target]) {
                                            CanvasXpress.stack[this.target].data.nodes = this.parseJSON(this.stringifyJSON(this.data.nodes));
                                            CanvasXpress.stack[this.target].config.calculateLayout = false;
                                            this.renderNetwork(b);
                                            this.networkXCenter = this.x / 2;
                                            this.networkYCenter = this.y / 2;
                                            this.unfixNetworkNodes()
                                        }
                                    }
                                };
                                this.summarizeNetworkNodes = function() {
                                    for (var c = 0; c < this.data.nodes.length; c++) {
                                        var f = this.data.nodes[c];
                                        f.nodeEdges = 0;
                                        for (var b = 0; b < this.data.edges.length; b++) {
                                            var d = this.data.edges[b];
                                            if (d.id1 == f.id || d.id2 == f.id) {
                                                f.nodeEdges++
                                            }
                                        }
                                    }
                                    this.updateNetworkMetaData("nodes", "nodeEdges")
                                };
                                this.initializeNetworkNodes = function(b) {
                                    if (b && !b.layout) {
                                        b.layout = {
                                            angle: 0,
                                            children: [],
                                            displacement: {
                                                x: 0,
                                                y: 0,
                                                z: 0
                                            },
                                            edges: this.edgesForNode(this.data.edges, b.id),
                                            force: {
                                                x: 0,
                                                y: 0,
                                                z: 0
                                            },
                                            hierarchy: false,
                                            lastPosition: {
                                                x: 0,
                                                y: 0,
                                                z: 0,
                                                r: 0,
                                                a: 0
                                            },
                                            level: 0,
                                            mass: 1,
                                            metrics: {
                                                betweenness: -1,
                                                closeness: -1,
                                                degree: -1,
                                                eccentricity: -1
                                            },
                                            neighbors: [],
                                            order: -1,
                                            parent: false,
                                            position: {
                                                x: null,
                                                y: null,
                                                z: 0
                                            },
                                            prevPosition: {
                                                x: 0,
                                                y: 0,
                                                z: 0
                                            },
                                            radius: 0,
                                            velocity: {
                                                x: 0,
                                                y: 0,
                                                z: 0
                                            }
                                        }
                                    }
                                };
                                this.initializeNodeNeighborhood = function(g) {
                                    if (g && g.layout && g.layout.edges.length) {
                                        g.layout.neighbors = [];
                                        var c = Math.min(g.layout.edges.length, 2);
                                        var d = this.nodeInitialCache;
                                        for (var e = 0; e < c; ++e) {
                                            var f = g.layout.edges[e];
                                            var b = f.id1 !== g.id ? f.id1 : f.id2;
                                            if (d[b]) {
                                                g.layout.neighbors.push(b)
                                            }
                                        }
                                        d[g.id] = true
                                    }
                                };
                                this.initializeNetworkEdges = function(d, c, f, b) {
                                    if (d && !d.layout) {
                                        var g = this.data.nodes[this.data.nodeIndices[d.id1]];
                                        var e = this.data.nodes[this.data.nodeIndices[d.id2]];
                                        g.layout.mass = g.layout.edges.length ? 1 + g.layout.edges.length / 3 : 1;
                                        e.layout.mass = e.layout.edges.length ? 1 + e.layout.edges.length / 3 : 1;
                                        d.layout = {
                                            length: (this.isNumber(c) && c !== undefined ? c : -1),
                                            weight: (this.isNumber(f) && f !== undefined ? f : 1),
                                            coeff: (b >= 0 ? b : -1)
                                        }
                                    }
                                };
                                this.setInitialNodePosition = function(f) {
                                    if (f.layout && f.layout.position && (f.layout.position.x == null || f.layout.position.y == null)) {
                                        var b = 0;
                                        var j = 0;
                                        var g = 0;
                                        var d = f.layout.neighbors;
                                        if (d.length) {
                                            for (var c = 0; c < d.length; ++c) {
                                                var h = this.nodes[d[c]];
                                                b += h.layout.position.x;
                                                j += h.layout.position.y;
                                                if (this.is3DNetwork) {
                                                    g += h.layout.position.z
                                                }
                                            }
                                            b /= d.length;
                                            j /= d.length;
                                            if (this.is3DNetwork) {
                                                g /= d.length
                                            }
                                        }
                                        var e = this.networkSpringLength;
                                        f.layout.position.x = (b + this.randomBetween(0, e)) - e / 2;
                                        f.layout.position.y = (j + this.randomBetween(0, e)) - e / 2;
                                        if (this.is3DNetwork) {
                                            f.layout.position.z = (g + this.randomBetween(0, e)) - e / 2
                                        }
                                        f.layout.prevPosition.x = f.layout.position.x;
                                        f.layout.prevPosition.y = f.layout.position.y;
                                        f.layout.prevPosition.z = f.layout.position.z;
                                        f.x = f.layout.position.x;
                                        f.y = f.layout.position.y;
                                        f.z = f.layout.position.z
                                    }
                                };
                                this.setNetworkCommunities = function() {
                                    if (this.networkCommunities == null && !this.networkVendor) {
                                        this.networkCommunities = 0;
                                        this.networkConvexHulls = [];
                                        var d = [];
                                        for (var f = 0; f < this.data.nodes.length; f++) {
                                            d.push(this.data.nodes[f].id)
                                        }
                                        var b = 0;
                                        var g;
                                        if (this.calculateNetworkCommunities) {
                                            g = this.jLouvain().nodes(d).edges(this.data.edges)();
                                            if (g) {
                                                for (var f = 0; f < this.data.nodes.length; f++) {
                                                    var h = g[this.data.nodes[f].id];
                                                    b = Math.max(b, h);
                                                    this.data.nodes[f].community = h;
                                                    this.data.nodes[f].communityColor = this.colors[this.data.nodes[f].community % this.colors.length]
                                                }
                                            }
                                        } else {
                                            for (var f = 0; f < this.data.nodes.length; f++) {
                                                var h = this.data.nodes[f].community || 0;
                                                b = Math.max(b, h);
                                                this.data.nodes[f].community = h;
                                                this.data.nodes[f].communityColor = this.colors[this.data.nodes[f].community % this.colors.length]
                                            }
                                        }
                                        this.networkCommunities = b + 1;
                                        for (var f = 0; f < this.networkCommunities; f++) {
                                            var d = [];
                                            for (var e = 0; e < this.data.nodes.length; e++) {
                                                if (this.data.nodes[e].community == f) {
                                                    d.push(e)
                                                }
                                            }
                                            this.networkConvexHulls[f] = {
                                                nodes: d,
                                                drawn: false
                                            }
                                        }
                                    }
                                };
                                this.getHull = function(s) {
                                    var c = this;
                                    var b = function(m, l, i) {
                                        return (l[0] - m[0]) * (i[1] - m[1]) - (l[1] - m[1]) * (i[0] - m[0])
                                    };
                                    var d = function(p) {
                                        var m = p.size ? p.size : 1;
                                        var i = p.width ? p.width : c.nodeSize * m;
                                        var l = p.height ? p.height : c.nodeSize * m;
                                        return [p.x, p.y, i, l]
                                    };
                                    var v = [];
                                    var C, D;
                                    var A, B;
                                    var o = 0;
                                    for (var w = 0; w < s.length; w++) {
                                        var r = d(this.data.nodes[s[w]]);
                                        var f = r.x;
                                        var e = r.y;
                                        if (r[0] > C || !C) {
                                            C = r[0]
                                        }
                                        if (r[0] < D || !D) {
                                            D = r[0]
                                        }
                                        if (r[1] > A || !A) {
                                            A = r[1]
                                        }
                                        if (r[1] < B || !B) {
                                            B = r[1]
                                        }
                                        o = Math.max(o, Math.max(r[2], r[3]));
                                        v.push([r[0], r[1]])
                                    }
                                    var h = (D + C) / 2;
                                    var g = (B + A) / 2;
                                    if (v.length == 1) {
                                        var r = d(this.data.nodes[s[0]]);
                                        v.push([h - r[2], g]);
                                        v.push([h, g - r[3]]);
                                        v.push([h + r[2], g]);
                                        v.push([h, g + r[3]])
                                    } else {
                                        if (v.length == 2) {
                                            var r = d(this.data.nodes[s[0]]);
                                            var t = d(this.data.nodes[s[1]]);
                                            v.push([h - o, g]);
                                            v.push([h, g - o]);
                                            v.push([h + o, g]);
                                            v.push([h, g + o])
                                        }
                                    }
                                    v.sort(function(l, i) {
                                        return (l[0] - i[0]) || (l[1] - i[1])
                                    });
                                    var E = [0, 0];
                                    var F = [];
                                    var z = [];
                                    var w, u;
                                    for (w = 0, u = v.length; w < u; w++) {
                                        var k = v[w];
                                        var j = v[u - w - 1];
                                        while (F.length >= 2 && b(F[F.length - 2], F[F.length - 1], k) <= 0) {
                                            F.pop()
                                        }
                                        F.push(k);
                                        while (z.length >= 2 && b(z[z.length - 2], z[z.length - 1], j) <= 0) {
                                            z.pop()
                                        }
                                        z.push(j);
                                        E[0] += k[0];
                                        E[1] += k[1]
                                    }
                                    E[0] *= 1 / s.length;
                                    E[1] *= 1 / s.length;
                                    z.pop();
                                    F.pop();
                                    return [this.expandPolygon(F.concat(z), o * this.hullScale), D, C, B, A]
                                };
                                this.setNodeHierarchy = function(d, e, j) {
                                    if (e > this.networkDepth) {
                                        this.networkDepth = e
                                    }
                                    var c = this.data.nodes[this.data.nodeIndices[d]];
                                    var f = c.layout;
                                    if (!c.hide && !c.hiddenParent) {
                                        if (!f.hierarchy) {
                                            var g = f.edges;
                                            if (g.length == 1) {
                                                this.networkDivisions++
                                            }
                                            if (g.length > 0) {
                                                for (var h = 0; h < g.length; h++) {
                                                    if (!f.hierarchy) {
                                                        f.angle = 0;
                                                        f.children = [];
                                                        f.hierarchy = "set", f.lastPosition = {
                                                            x: 0,
                                                            y: 0,
                                                            z: 0,
                                                            r: 0,
                                                            a: 0
                                                        };
                                                        f.level = e;
                                                        f.order = -1;
                                                        f.parent = j;
                                                        f.radius = 0
                                                    }
                                                    if (e < f.level) {
                                                        f.level = e
                                                    }
                                                    if (g[h].id1 == d) {
                                                        f.children.push(g[h].id2);
                                                        this.setNodeHierarchy(g[h].id2, e + 1, d)
                                                    } else {
                                                        if (g[h].id2 == d) {
                                                            f.children.push(g[h].id1);
                                                            this.setNodeHierarchy(g[h].id1, e + 1, d)
                                                        }
                                                    }
                                                }
                                            }
                                        } else {
                                            if (e < f.level) {
                                                f.level = e
                                            }
                                            for (var h = 0; h < f.children.length; h++) {
                                                var b = f.children[h];
                                                var k = this.data.nodes[this.data.nodeIndices[b]].layout;
                                                if (k.hierarchy) {
                                                    if ((e + 1) < k.level) {
                                                        k.level = e + 1;
                                                        k.parent = d
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setNetworkHierarchy = function() {
                                    var h = this;
                                    var g = function(j) {
                                        var i = h.data.nodes[h.data.nodeIndices[j]];
                                        while (i.parentNode) {
                                            j = i.parentNode;
                                            g(j)
                                        }
                                        return j
                                    };
                                    if (this.networkLayoutType == "radial") {
                                        if (!this.networkRoot) {
                                            this.networkRoot = this.data.nodes[0].id
                                        }
                                        this.networkDepth = 0;
                                        this.networkDivisions = 0;
                                        this.networkCurrentAngle = 0;
                                        this.setNodeHierarchy(this.networkRoot, 0, false)
                                    } else {
                                        if (this.networkLayoutType == "circular") {
                                            this.networkDepth = 1;
                                            this.networkDivisions = this.data.nodes.length;
                                            this.networkCurrentAngle = 0
                                        } else {
                                            for (var d = 0; d < this.data.nodes.length; d++) {
                                                var f = this.data.nodes[d];
                                                if (!f.hasOwnProperty("layout")) {
                                                    f.layout = {
                                                        children: []
                                                    }
                                                }
                                                if (f.parentNode) {
                                                    var c = this.data.nodes[this.data.nodeIndices[f.parentNode]];
                                                    if (!c.hasOwnProperty("layout")) {
                                                        c.layout = {
                                                            children: []
                                                        }
                                                    }
                                                    c.layout.children.push(f.id);
                                                    var b = g(c.id);
                                                    var e = this.data.nodes[this.data.nodeIndices[b]];
                                                    if (e.hide) {
                                                        f.hiddenParent = true
                                                    } else {
                                                        f.hiddenParent = false
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.findParentNodes = function(d, b) {
                                    if (this.data.nodes[this.data.nodeIndices[d]].parentNode) {
                                        var c = this.data.nodes[this.data.nodeIndices[d]].parentNode;
                                        if (!b) {
                                            b = []
                                        }
                                        b.push(c);
                                        b = this.findParentNodes(c, b);
                                        return b
                                    } else {
                                        return b ? b.reverse() : false
                                    }
                                };
                                this.findChildrenNodeIndices = function(e, c) {
                                    if (!c) {
                                        c = []
                                    }
                                    var d = this.data.nodes[this.data.nodeIndices[e]];
                                    if (this.networkLayoutType != "radial") {
                                        if (d.hasOwnProperty("layout") && d.layout.children.length) {
                                            for (var b = 0; b < d.layout.children.length; b++) {
                                                c.push(this.data.nodeIndices[d.layout.children[b]]);
                                                c = this.findChildrenNodeIndices(d.layout.children[b], c)
                                            }
                                        }
                                    }
                                    return c.length > 0 ? c : false
                                };
                                this.hasChildren = function(c) {
                                    var b = this.data.nodes[this.data.nodeIndices[c]];
                                    return b.hasOwnProperty("layout") && b.layout.children.length
                                };
                                this.findVisibleParentNode = function(d) {
                                    var c = this.findParentNodes(d);
                                    if (c) {
                                        c.reverse();
                                        for (var b = 0; b < c.length; b++) {
                                            if (!this.nodes[c[b]].hide && !this.nodes[c[b]].hiddenParent) {
                                                return this.nodes[c[b]]
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.collateNetworks = function() {
                                    if (this.data.nodes.length > 0) {
                                        var n = this.normalizeGraph({
                                            nodes: this.data.nodes,
                                            edges: this.data.edges
                                        });
                                        if (n.length > 1) {
                                            var b = [];
                                            for (var k = 0; k < n.length; k++) {
                                                b.push(k)
                                            }
                                            b.sort(function(j, i) {
                                                return n[i].nodes.length - n[j].nodes.length
                                            });
                                            this.subNetworks = [];
                                            for (var s = 0; s < n.length; s++) {
                                                var k = b[s];
                                                var e = [];
                                                var o = [];
                                                var h = n[k].nodes.length;
                                                var m = n[k].edges.length;
                                                var l = {};
                                                var c = h / this.data.nodes.length;
                                                var q = c * (this.x * Math.log(n.length));
                                                var p = c * (this.y * Math.log(n.length));
                                                var f = q * p;
                                                for (var g = 0; g < n[k].nodes.length; g++) {
                                                    e.push(n[k].nodes[g].id)
                                                }
                                                for (var g = 0; g < n[k].edges.length; g++) {
                                                    if (typeof n[k].edges[g] != "function") {
                                                        var d = n[k].edges[g].id1 + "::" + n[k].edges[g].id2;
                                                        if (!l.hasOwnProperty(d)) {
                                                            o.push(n[k].edges[g]);
                                                            l[d] = true
                                                        }
                                                    }
                                                }
                                                this.subNetworks.push({
                                                    nodes: e,
                                                    edges: o,
                                                    x: q,
                                                    y: p,
                                                    isLayoutDone: false
                                                })
                                            }
                                        }
                                    }
                                };
                                this.resetObjectAttributes = function() {
                                    this.colorNodeBy = false;
                                    this.shapeNodeBy = false;
                                    this.sizeNodeBy = false;
                                    this.patternNodeBy = false;
                                    this.colorEdgeBy = false;
                                    this.sizeEdgeBy = false
                                };
                                this.setDecorationsRangeUnits = function() {
                                    this.decorationsRange = [];
                                    var c = {};
                                    var d = {};
                                    var o = {
                                        size: [],
                                        shape: [],
                                        shapeColor: [],
                                        text: []
                                    };
                                    if (this.showDecorations && this.decorations && this.decorations.length > 0) {
                                        var n = [];
                                        for (var l = 0; l < this.data.nodes.length; l++) {
                                            var f = this.data.nodes[l];
                                            for (var h = 0; h < this.decorations.length; h++) {
                                                if (f[this.decorations[h]] || (f.decorations && f.decorations[this.decorations[h]])) {
                                                    var p = f[this.decorations[h]] ? f[this.decorations[h]] : f.decorations[this.decorations[h]];
                                                    if (this.isObject(p)) {
                                                        if (this.decorationsType == "stacked") {
                                                            var r = 0;
                                                            for (var g in p) {
                                                                if (!isNaN(p[g])) {
                                                                    d[g] = true;
                                                                    r += p[g]
                                                                }
                                                            }
                                                            n.push(r)
                                                        } else {
                                                            if (this.decorationsType == "stackedpercent") {
                                                                for (var g in p) {
                                                                    if (!isNaN(p[g])) {
                                                                        d[g] = true
                                                                    }
                                                                }
                                                                n = [0, 100]
                                                            } else {
                                                                if (this.decorationsType == "heatmap") {
                                                                    for (var g in p) {
                                                                        if (!isNaN(p[g])) {
                                                                            d[g] = true;
                                                                            n.push(p[g])
                                                                        }
                                                                    }
                                                                } else {
                                                                    alert("Ooops! canvasXpress does not support " + this.decorationsType + " for this multidimensional plotting");
                                                                    return
                                                                }
                                                            }
                                                        }
                                                    } else {
                                                        if (!isNaN(f[this.decorations[h]]) || (f.decorations && !isNaN(f.decorations[this.decorations[h]]))) {
                                                            n.push(f[this.decorations[h]] ? f[this.decorations[h]] : f.decorations[this.decorations[h]])
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.decorationsRange = this.range(n);
                                        if (this.decorationsType == "stacked") {
                                            this.decorationsRange[0] = 0
                                        }
                                        var b = this.decorationsRange[1] - this.decorationsRange[0];
                                        if (b == 0) {
                                            this.decorationsRange[1] = this.max(n) + 1
                                        }
                                        var m = this.decorationsType.match(/stacked/) ? this.decorationsRange[0] : this.decorationsRange[0] - (b * 0.05);
                                        if (m > 0) {
                                            this.decorationsRange[0] = m;
                                            b = this.decorationsRange[1] - this.decorationsRange[0]
                                        }
                                        this.decorationsUnits = this.decorationsHeight / b;
                                        var u = (this.legendFontSize * this.legendScaleFontFactor) - 2;
                                        for (var l = 0; l < this.decorations.length; l++) {
                                            if (this.decorationsColors[l]) {
                                                c[this.decorationsColors[l]] = true;
                                                o.shape.push(this.decorationsProperties[this.decorations[l]] && this.decorationsProperties[this.decorations[l]].shape ? this.decorationsProperties[this.decorations[l]].shape : "circle");
                                                o.shapeColor.push(this.decorationsProperties[this.decorations[l]] && this.decorationsProperties[this.decorations[l]].color ? this.decorationsProperties[this.decorations[l]].color : this.decorationsColors[l]);
                                                o.text.push(this.decorations[l]);
                                                o.size.push(u)
                                            } else {
                                                for (var h = 0; h < this.colors.length; h++) {
                                                    if (!c.hasOwnProperty(this.colors[h])) {
                                                        var e = this.decorationsProperties[this.decorations[l]] && this.decorationsProperties[this.decorations[l]].color ? this.decorationsProperties[this.decorations[l]].color : this.colors[h];
                                                        var q = this.decorationsProperties[this.decorations[l]] && this.decorationsProperties[this.decorations[l]].shape ? this.decorationsProperties[this.decorations[l]].shape : "circle";
                                                        this.decorationsColors[l] = e;
                                                        c[e] = true;
                                                        o.shape.push(q);
                                                        o.shapeColor.push(e);
                                                        o.text.push(this.decorations[l]);
                                                        o.size.push(u);
                                                        break
                                                    }
                                                }
                                            }
                                        }
                                        var l = this.decorations.length;
                                        for (var g in d) {
                                            if (this.decorationsColors[l]) {
                                                c[this.decorationsColors[l]] = true;
                                                o.shape.push(this.decorationsProperties[g] && this.decorationsProperties[g].shape ? this.decorationsProperties[g].shape : "square");
                                                o.shapeColor.push(this.decorationsProperties[g] && this.decorationsProperties[g].color ? this.decorationsProperties[g].color : this.decorationsColors[l]);
                                                o.text.push(g);
                                                o.size.push(u)
                                            } else {
                                                for (var h = 0; h < this.colors.length; h++) {
                                                    if (!c.hasOwnProperty(this.colors[h])) {
                                                        var e = this.decorationsProperties[g] && this.decorationsProperties[g].color ? this.decorationsProperties[g].color : this.colors[h];
                                                        var q = this.decorationsProperties[g] && this.decorationsProperties[g].shape ? this.decorationsProperties[g].shape : "square";
                                                        this.decorationsColors[l] = e;
                                                        c[e] = true;
                                                        o.shape.push(q);
                                                        o.shapeColor.push(e);
                                                        o.text.push(g);
                                                        o.size.push(u);
                                                        break
                                                    }
                                                }
                                            }
                                            l++
                                        }
                                        this.legend = [o]
                                    }
                                };
                                this.validateNetworkLayout = function() {
                                    if (this.calculateLayout) {
                                        this.initializeNetworkLayout()
                                    } else {
                                        for (var b = 0; b < this.data.nodes.length; b++) {
                                            var c = this.data.nodes[b];
                                            if (c.x == null) {
                                                c.x = -1
                                            }
                                            if (c.y == null) {
                                                c.y = -1
                                            }
                                            if (this.is3DNetwork && c.z == null) {
                                                c.z = -1
                                            }
                                        }
                                    }
                                };
                                this.recalculateLayout = function() {
                                    if (this.calculateLayout) {
                                        this.calculateLayout = this.data.nodes && Object.keys(this.data.nodes[0].layout).length > 1 ? true : false;
                                        this.isLayoutDone = false;
                                        this.isAnimation = true;
                                        this.iteration = 0;
                                        this.randomSeed = 8;
                                        this.initializeNetwork()
                                    }
                                };
                                this.setInitialConfigState = function() {
                                    if (!this.initialNetworkConfigState) {
                                        CanvasXpress.stack[this.target].state[0] = this.getConfigState();
                                        this.initialNetworkConfigState = true
                                    }
                                };
                                this.drawNetworkPlot = function() {
                                    if (this.calculateLayout) {
                                        this.collateNetworks();
                                        this.setNetworkPrivateParams();
                                        this.setNetworkLayout();
                                        this.calculateLayout = false
                                    } else {
                                        this.isLayoutDone = true;
                                        this.renderNetwork();
                                        this.setInitialConfigState()
                                    }
                                    if (this.networkFreezeOnLoad && this.isLayoutDone) {
                                        this.networkFreezeOnLoad = false;
                                        this.networkFreeze = true
                                    }
                                };
                                this.calculateNetworkMetrics = function(c) {
                                    if ((this.isNetworkMetrics || c) && !this.isNetworkMetricsDone) {
                                        var b = this.data.nodes;
                                        this.networkBetweenness(b);
                                        this.networkCloseness(b);
                                        this.networkEccentricity(b);
                                        this.networkDegree(b);
                                        this.exposeNetworkMetrics();
                                        this.isNetsworkMetricsDone;
                                        this.resetMenus();
                                        this.updateNetworkMetaData("nodes");
                                        CanvasXpress.stack[this.target].data = this.data;
                                        delete(this.nodesData)
                                    }
                                };
                                this.drawNetworkProgressBar = function(e, c) {
                                    if (!c) {
                                        switch (this.networkLayoutType) {
                                            case "forceDirected":
                                                c = this.iteration / this.maxIterations;
                                                break;
                                            case "circular":
                                            case "radial":
                                                c = this.iteration / 15;
                                                break
                                        }
                                    }
                                    if (!e) {
                                        e = "Optimizing ..."
                                    }
                                    var b = Math.min(c * 120, 120);
                                    var d = (70 + 60 - (b * 0.5));
                                    if (!this.isLayoutDone) {
                                        this.drawText(e, this.width - 130, this.height - 43, this.nodeFont, "rgba(0,0,0,0.5)", "left", "top");
                                        this.drawShape("rectangle", this.width - d, this.height - 18, b, 15, "rgba(0,0,0,0.5)", "rgba(0,0,0,0.5)", "closed");
                                        this.drawShape("rectangle", this.width - 70, this.height - 18, 120, 15, false, "rgba(0,0,0,0.5)", "open")
                                    }
                                };
                                this.initializeNetwork = function() {
                                    this.validateNetworkLayout();
                                    this.setNetworkHierarchy();
                                    this.setDecorationsRangeUnits();
                                    this.summarizeNetworkNodes();
                                    this.validateNetworkPropertyValues();
                                    this.setLegends();
                                    this.setNetworkDimensions();
                                    if (!this.nodes && this.data.nodes) {
                                        this.setNodes()
                                    }
                                    this.calculateNetworkMetrics();
                                    this.drawNetworkPlot()
                                };
                                if (!a) {
                                    this.initializeNetwork()
                                }
                            };
                            CanvasXpress.prototype.Genome = function() {
                                this.setGenomeSubtracks = function() {
                                    this.subtracks = [];
                                    this.subtracksInfo = [];
                                    this.y = this.margin;
                                    var a = this.marginTop + this.top;
                                    var J = 0;
                                    var F = this.xAxisMin * this.xAxisUnit;
                                    var x = this.xAxisMax * this.xAxisUnit;
                                    for (var L = 0; L < this.data.tracks.length; L++) {
                                        var n, u, N, o, y;
                                        var g = [];
                                        var E = [];
                                        var I = 0;
                                        var A = this.data.tracks[L];
                                        var f = A.data;
                                        var c = A.type ? A.type : this.featureTypeDefault;
                                        var M = A.height ? A.height : this.featureHeightDefault;
                                        var D = A.subtracksMax || this.subtracksMaxDefault;
                                        var O = A.spacer ? A.spacer : 0;
                                        if (!A.hide) {
                                            if (A.name && !A.hideName) {
                                                this.y += this.trackNameFontSize + (this.margin * 2)
                                            }
                                            A.startY = this.marginTop + this.top + this.y;
                                            this.subtracks[L] = [];
                                            if (this.featureStaggered) {
                                                for (var H = 0; H < f.length; H++) {
                                                    var d = f[H];
                                                    var t = this.shortenText(d.label || d.name || d.id, this.maxFeatureStringLen);
                                                    var C = d.hideName || A.hideFeatureNames ? 0 : this.measureText(t, this.featureNameFont) + (this.margin * 3);
                                                    var P = d.data;
                                                    if (!d.hide) {
                                                        d.index = H;
                                                        d.counter = J++;
                                                        if (c == "box") {
                                                            y = d.showDir && this.xAxisUnit > 0.001 ? 10000 : 0;
                                                            n = this.getGenomeDataRange(P);
                                                            u = (n[0] + y) * this.xAxisUnit;
                                                            N = (n[1] + O + y) * this.xAxisUnit;
                                                            N = Math.max(u + C, N)
                                                        } else {
                                                            if (c == "sequence") {
                                                                var B = this.setGenomeGaps(d.gaps, d.sequence.length, d.dir);
                                                                if (d.offsetLeft && !d.offset) {
                                                                    d.offset = (d.offsetLeft - (d.sequence.length + B.total)) + 1
                                                                }
                                                                u = d.offset * this.xAxisUnit;
                                                                N = u + ((d.sequence.length + B.total + O) * this.xAxisUnit);
                                                                N = Math.max(u + C, N)
                                                            } else {
                                                                if (c == "dataframe") {
                                                                    u = F;
                                                                    N = x
                                                                } else {
                                                                    if (c == "marker") {
                                                                        n = this.getGenomeDataRange(P);
                                                                        u = n[0] * this.xAxisUnit;
                                                                        N = n[1] * this.xAxisUnit;
                                                                        N = Math.max(u + C, N)
                                                                    } else {
                                                                        u = (d.offset + O) * this.xAxisUnit;
                                                                        N = A.autowidth && this.isArray(P) ? u + (P[0].length * this.xAxisUnit) : u + A.width ? A.width : this.featureWidthDefault;
                                                                        N = Math.max(u + C, N)
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        o = c == "dataframe" ? true : u >= F && u <= x ? true : N >= F && N <= x ? true : u <= F && N >= x ? true : false;
                                                        g.push([u, N, o, H])
                                                    }
                                                }
                                                if (g.length > 0) {
                                                    g.sort(function(h, e) {
                                                        return h[0] - e[0]
                                                    });
                                                    for (var H = 0; H < g.length; H++) {
                                                        if (g[H][2]) {
                                                            o = false;
                                                            for (var G = 0; G < E.length; G++) {
                                                                N = Math.round(E[G][E[G].length - 1][1]);
                                                                if (Math.round(g[H][0]) >= N) {
                                                                    E[G].push(g[H]);
                                                                    o = true;
                                                                    break
                                                                }
                                                            }
                                                            if (!o) {
                                                                E.push([g[H]])
                                                            }
                                                        }
                                                    }
                                                    for (var H = 0; H < E.length; H++) {
                                                        if (H < D) {
                                                            this.subtracks[L][H] = [];
                                                            I += E[H].length;
                                                            var K = 0;
                                                            var w = 0;
                                                            var p = 0;
                                                            for (var G = 0; G < E[H].length; G++) {
                                                                d = f[E[H][G][3]];
                                                                this.subtracks[L][H].push(E[H][G][3]);
                                                                this.subtracksInfo[d.counter] = {
                                                                    track: L,
                                                                    subtrack: H,
                                                                    index: d.index,
                                                                    name: d.label || d.name || d.id,
                                                                    start: a + this.y
                                                                };
                                                                if (c == "box") {
                                                                    K = Math.max(K, this.getBoxFeatureHeight(d));
                                                                    w = Math.max(w, d.translatesTop || 0);
                                                                    p = Math.max(p, d.translatesBottom || 0)
                                                                } else {
                                                                    if (c == "sequence") {
                                                                        K = Math.max(K, this.getSequenceFeatureHeight(d))
                                                                    }
                                                                }
                                                            }
                                                            if (!this.isNameInSubtrack(A, this.subtracks[L][H]) && c != "dataframe" && c != "marker") {
                                                                this.y += this.featureNameFontSize + this.margin
                                                            }
                                                            if (c != "dataframe" || H == 0) {
                                                                this.y += M + this.margin
                                                            }
                                                            if (c == "box" || c == "sequence") {
                                                                this.y += K
                                                            }
                                                            for (var G = 0; G < E[H].length; G++) {
                                                                d = f[E[H][G][3]];
                                                                this.subtracksInfo[d.counter].end = a + this.y;
                                                                this.subtracksInfo[d.counter].maxHeight = K;
                                                                this.subtracksInfo[d.counter].translateTop = w;
                                                                this.subtracksInfo[d.counter].translateBottom = p
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                for (var H = 0; H < f.length; H++) {
                                                    var d = f[H];
                                                    if (!d.hide) {
                                                        d.index = H;
                                                        d.counter = J++;
                                                        if (H < D) {
                                                            I++;
                                                            this.subtracks[L][H] = [H];
                                                            this.subtracksInfo[d.counter] = {
                                                                track: L,
                                                                subtrack: H,
                                                                index: d.index,
                                                                name: d.label || d.name || d.id,
                                                                start: a + this.y
                                                            };
                                                            if (c != "dataframe" || H == 0) {
                                                                this.y += M + this.margin
                                                            }
                                                            if (c == "box") {
                                                                this.subtracksInfo[d.counter].maxHeight = this.getBoxFeatureHeight(d);
                                                                this.subtracksInfo[d.counter].translateTop = d.translatesTop || 0;
                                                                this.subtracksInfo[d.counter].translateBottom = d.translatesBottom || 0;
                                                                this.y += this.subtracksInfo[d.counter].maxHeight
                                                            } else {
                                                                if (c == "sequence") {
                                                                    this.subtracksInfo[d.counter].maxHeight = this.getSequenceFeatureHeight(d);
                                                                    this.y += this.subtracksInfo[d.counter].maxHeight
                                                                }
                                                            }
                                                            this.subtracksInfo[d.counter].end = a + this.y
                                                        }
                                                    }
                                                }
                                            }
                                            A.endY = this.y;
                                            A.displayedFeatures = I;
                                            A.totalFeatures = f.length;
                                            this.y += (this.margin * 2)
                                        }
                                    }
                                };
                                this.isNameInSubtrack = function(a, e) {
                                    for (var c = 0; c < e.length; c++) {
                                        var d = e[c];
                                        var b = a.data[d];
                                        if (!b.hideName && !a.hideFeatureNames) {
                                            return false
                                        }
                                    }
                                    return true
                                };
                                this.getGenomeRange = function(a) {
                                    var f = [];
                                    var d = [];
                                    for (var e = 0; e < a.length; e++) {
                                        if (a[e].range) {
                                            f.push(a[e].range[0]);
                                            d.push(a[e].range[1])
                                        } else {
                                            var h = [];
                                            var g = a[e].data;
                                            if (this.isArray(g[0])) {
                                                for (var c = 0; c < g.length; c++) {
                                                    for (var b = 0; b < g[c].length; b++) {
                                                        h = h.concat(g[c][b])
                                                    }
                                                }
                                            } else {
                                                for (var c = 0; c < g.length; c++) {
                                                    h = h.concat(g[c])
                                                }
                                            }
                                            a[e].range = this.range(h);
                                            f.push(Number(a[e].range[0]));
                                            d.push(Number(a[e].range[1]))
                                        }
                                    }
                                    return this.range([this.min(f), this.max(d)])
                                };
                                this.getGenomeDataRange = function(d) {
                                    if (d) {
                                        var a = [];
                                        for (var c = 0; c < d.length; c++) {
                                            for (var b = 0; b < d[c].length; b++) {
                                                a.push(Number(d[c][b]))
                                            }
                                        }
                                        a.sort(function(f, e) {
                                            return f - e
                                        });
                                        return [a[0], a[a.length - 1]]
                                    } else {
                                        return [0, 1]
                                    }
                                };
                                this.setGenomeGaps = function(e, a, b) {
                                    var d = 0;
                                    var f = {
                                        total: d
                                    };
                                    if (e && this.isArray(e) && e.length > 0) {
                                        for (var c = 0; c < e.length; c++) {
                                            var h = b == "left" ? a - e[c][0] : e[c][0];
                                            f[h] = e[c][1];
                                            d += e[c][1]
                                        }
                                        f.total = d
                                    }
                                    return f
                                };
                                this.getBoxFeatureHeight = function(b) {
                                    if (this.genomeResolution != "low" && (b.translate || b.sequence)) {
                                        if (b.dir == "left" && !b.sequenceRC) {
                                            b.sequenceRC = this.getReverseComplement(b.sequence)
                                        }
                                        if (b.cds && !b.translate) {
                                            var a = b.cds[0] % 3 || 3;
                                            b.translate = b.dir == "left" ? [a * -1] : [a]
                                        }
                                        if (b.translate && !b.translateRC && this.featureTranslateShow) {
                                            b.translateRC = this.translate(b.translate, b.dir == "left" ? b.sequenceRC : b.sequence)
                                        }
                                        if (b.translate && this.genomeResolution == "high") {
                                            return this.featureTranslateHeight * b.translate.length
                                        }
                                    }
                                    return 0
                                };
                                this.getSequenceFeatureHeight = function(b) {
                                    var c = 0;
                                    if (this.genomeResolution == "high") {
                                        if (b.trace && this.featureTracesShow) {
                                            c += this.featureTraceHeight
                                        }
                                        if (b.translate && this.featureTranslateShow) {
                                            for (var a = 0; a < b.translate.length; a++) {
                                                c += this.featureTranslateHeight
                                            }
                                        }
                                        if (b.quality && this.featureQualityShow) {
                                            c += this.featureQualityHeight
                                        }
                                        if (b.signalToNoise && this.featureSignalToNoiseShow) {
                                            c += this.featureSignalToNoiseHeight
                                        }
                                        if (b.coordinate && this.featureCoordinateShow) {
                                            c += this.featureCoordinateHeight
                                        }
                                    } else {
                                        if (this.genomeResolution == "medium") {
                                            if (b.trace && this.featureTracesShow) {
                                                c += this.featureTraceHeight
                                            }
                                        }
                                    }
                                    return c
                                };
                                this.getReverseComplement = function(d) {
                                    var b = d.split("");
                                    var a = [];
                                    for (var c = 0; c < b.length; c++) {
                                        a.unshift(CanvasXpress.reverseComplement[b[c]] || b[c])
                                    }
                                    return a.join("")
                                };
                                this.translate = function(b, g) {
                                    var a = {
                                        top: [],
                                        bottom: []
                                    };
                                    var n = g.split("");
                                    var k = CanvasXpress.codon;
                                    var f = this.getReverseComplement(g).split("").reverse();
                                    for (var h = 0; h < b.length; h++) {
                                        var m = b[h];
                                        var e = {
                                            seq: [],
                                            off: 0,
                                            rf: b[h]
                                        };
                                        if (m == "-1") {
                                            e.off = f.length % 3;
                                            for (var d = f.length - 1; d >= 0; d -= 3) {
                                                var o = f[d] + f[d - 1] + f[d - 2];
                                                var l = k[o.toUpperCase()];
                                                e.seq.unshift(l ? l[0] : "")
                                            }
                                            a.bottom.push(e)
                                        } else {
                                            if (m == "-2") {
                                                e.off = (f.length - 1) % 3;
                                                for (var d = f.length - 2; d >= 0; d -= 3) {
                                                    var o = f[d] + f[d - 1] + f[d - 2];
                                                    var l = k[o.toUpperCase()];
                                                    e.seq.unshift(l ? l[0] : "")
                                                }
                                                a.bottom.push(e)
                                            } else {
                                                if (m == "-3") {
                                                    e.off = (f.length - 2) % 3;
                                                    for (var d = f.length - 3; d >= 0; d -= 3) {
                                                        var o = f[d] + f[d - 1] + f[d - 2];
                                                        var l = k[o.toUpperCase()];
                                                        e.seq.unshift(l ? l[0] : "")
                                                    }
                                                    a.bottom.push(e)
                                                } else {
                                                    if (m == "1") {
                                                        e.off = 0;
                                                        for (var d = 0; d < n.length; d += 3) {
                                                            var o = n[d] + n[d + 1] + n[d + 2];
                                                            var l = k[o.toUpperCase()];
                                                            e.seq.push(l ? l[0] : "")
                                                        }
                                                        a.top.push(e)
                                                    } else {
                                                        if (m == "2") {
                                                            e.off = 1;
                                                            for (var d = 1; d < n.length; d += 3) {
                                                                var o = n[d] + n[d + 1] + n[d + 2];
                                                                var l = k[o.toUpperCase()];
                                                                e.seq.push(l ? l[0] : "")
                                                            }
                                                            a.top.push(e)
                                                        } else {
                                                            if (m == "3") {
                                                                e.off = 2;
                                                                for (var d = 2; d < n.length; d += 3) {
                                                                    var o = n[d] + n[d + 1] + n[d + 2];
                                                                    var l = k[o.toUpperCase()];
                                                                    e.seq.push(l ? l[0] : "")
                                                                }
                                                                a.top.push(e)
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return a
                                };
                                this.setReverseTrace = function(j) {
                                    if (!j.reversed) {
                                        var d = j.A.length;
                                        var b = j.T.reverse();
                                        var m = j.G.reverse();
                                        var h = j.C.reverse();
                                        var f = j.A.reverse();
                                        var k = [];
                                        for (var e = 0; e < j.peak.length; e++) {
                                            k.unshift(d - j.peak[e])
                                        }
                                        j.A = b;
                                        j.C = m;
                                        j.G = h;
                                        j.T = f;
                                        j.peak = k;
                                        j.reversed = true
                                    }
                                };
                                this.getCoordinateStep = function() {
                                    var a = 1;
                                    if (this.xAxisUnit * 0.2 > this.sequenceFontSize) {
                                        a = 1
                                    } else {
                                        if (this.xAxisUnit * 0.5 > this.sequenceFontSize) {
                                            a = 5
                                        } else {
                                            if (this.xAxisUnit * 1 > this.sequenceFontSize) {
                                                a = 10
                                            } else {
                                                if (this.xAxisUnit * 200 > this.sequenceFontSize) {
                                                    a = 20
                                                } else {
                                                    if (this.xAxisUnit * 500 > this.sequenceFontSize) {
                                                        a = 50
                                                    } else {
                                                        if (this.xAxisUnit * 1000 > this.sequenceFontSize) {
                                                            a = 100
                                                        } else {
                                                            if (this.xAxisUnit * 2500 > this.sequenceFontSize) {
                                                                a = 250
                                                            } else {
                                                                if (this.xAxisUnit * 5000 > this.sequenceFontSize) {
                                                                    a = 500
                                                                } else {
                                                                    if (this.xAxisUnit * 2000 > this.sequenceFontSize) {
                                                                        a = 1000
                                                                    } else {
                                                                        if (this.xAxisUnit * 10000 > this.sequenceFontSize) {
                                                                            a = 5000
                                                                        } else {
                                                                            if (this.xAxisUnit * 20000 > this.sequenceFontSize) {
                                                                                a = 10000
                                                                            } else {
                                                                                if (this.xAxisUnit * 100000 > this.sequenceFontSize) {
                                                                                    a = 50000
                                                                                } else {
                                                                                    if (this.xAxisUnit * 200000 > this.sequenceFontSize) {
                                                                                        a = 100000
                                                                                    } else {
                                                                                        if (this.xAxisUnit * 2000000 > this.sequenceFontSize) {
                                                                                            a = 1000000
                                                                                        } else {
                                                                                            if (this.xAxisUnit * 20000000 > this.sequenceFontSize) {
                                                                                                a = 10000000
                                                                                            } else {
                                                                                                if (this.xAxisUnit * 200000000 > this.sequenceFontSize) {
                                                                                                    a = 100000000
                                                                                                } else {
                                                                                                    if (this.xAxisUnit * 2000000000 > this.sequenceFontSize) {
                                                                                                        a = 1000000000
                                                                                                    } else {
                                                                                                        if (this.xAxisUnit * 20000000000 > this.sequenceFontSize) {
                                                                                                            a = 10000000000
                                                                                                        } else {
                                                                                                            if (this.xAxisUnit * 200000000000 > this.sequenceFontSize) {
                                                                                                                a = 100000000000
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (this.xAxisRange / a > 10) {
                                        a *= (a * 0.1);
                                        while (a * 10 > this.xAxisRange) {
                                            a *= 0.1
                                        }
                                        return a
                                    } else {
                                        if (a * 3 > this.xAxisRange) {
                                            return a * 0.1
                                        } else {
                                            return a
                                        }
                                    }
                                };
                                this.getGenomeObjectColor = function(c, b, a, e) {
                                    if (b[c]) {
                                        return b[c]
                                    } else {
                                        if (a[c]) {
                                            return a[c]
                                        } else {
                                            if (this[c]) {
                                                return this[c]
                                            } else {
                                                if (e) {
                                                    return e
                                                } else {
                                                    return false
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawBoxSequenceName = function(h, b, e, m, j, g, c, n, d) {
                                    var f = this.getGenomeObjectColor("featureNameFontColor", n, d, this.foreground);
                                    var a = n.counter;
                                    var l = this.featureNameFontSize / 2;
                                    var k = n.dir == "right" ? b + " \u2b95" : n.dir == "left" ? "\u2b05 " + b : b;
                                    if (g >= this.xAxisMin && c <= this.xAxisMax) {
                                        e = j + e;
                                        this.toRender({
                                            p: ["drawText", k, e, m + l, this.featureNameFont, f, "left", "middle"],
                                            i: ["track-" + h + ":" + a],
                                            t: "Labels"
                                        })
                                    } else {
                                        if (g <= this.xAxisMin && c >= this.xAxisMin) {
                                            e = j;
                                            this.toRender({
                                                p: ["drawText", k, e, m + l, this.featureNameFont, f, "left", "middle"],
                                                i: ["track-" + h + ":" + a],
                                                t: "Labels"
                                            })
                                        } else {
                                            if ((g <= this.xAxisMax && c >= this.xAxisMax)) {
                                                e = j + e;
                                                this.toRender({
                                                    p: ["drawText", k, e, m + l, this.featureNameFont, f, "left", "middle"],
                                                    i: ["track-" + h + ":" + a],
                                                    t: "Labels"
                                                })
                                            } else {
                                                e = j + e
                                            }
                                        }
                                    }
                                };
                                this.drawGenomeLabels = function() {
                                    if (!this.featureStaggered) {
                                        var w = this.marginLeft;
                                        var c = this.marginTop + this.top + this.margin;
                                        var b = this.featureNameFontSize / 2;
                                        var a = 0;
                                        for (var v = 0; v < this.data.tracks.length; v++) {
                                            var p = this.data.tracks[v];
                                            var d = p.type || this.featureTypeDefault;
                                            var n = p.height || this.featureHeightDefault;
                                            if (!p.hide) {
                                                if (p.name && !p.hideName) {
                                                    c += this.trackNameFontSize + (this.margin * 2)
                                                }
                                                for (var t = 0; t < this.subtracks[v].length; t++) {
                                                    var x = this.subtracks[v][t];
                                                    if (!x) {
                                                        continue
                                                    }
                                                    for (var r = 0; r < x.length; r++) {
                                                        var m = x[r];
                                                        var e = p.data[m];
                                                        var u = e.counter;
                                                        var s = this.getGenomeObjectColor("featureNameFontColor", e, p, this.foreground);
                                                        var g = this.shortenText(e.label || e.name || e.id, this.maxFeatureStringLen);
                                                        var f = e.dir == "right" ? g + " \u2b95" : e.dir == "left" ? "\u2b05 " + g : g;
                                                        if (!e.hideName && !p.hideFeatureNames && d != "dataframe") {
                                                            this.toRender({
                                                                p: ["drawText", f, this.marginLeft, c + (n / 2) - ((this.trackNameFontSize - this.margin) / 2), this.featureNameFont, s, "left", "middle"],
                                                                a: this.getTextArea(f, this.marginLeft, c + (n / 2) - ((this.trackNameFontSize - this.margin) / 2), this.featureNameFont, s, "left", "middle"),
                                                                i: ["track-" + v + ":" + u],
                                                                t: "Labels"
                                                            })
                                                        }
                                                        if (d == "dataframe") {} else {
                                                            if (d == "box" || d == "sequence") {
                                                                if (e.translate && this.genomeResolution == "high") {
                                                                    var h = (this.featureNameFontSize - 2) + "px " + this.fontName;
                                                                    a = -5;
                                                                    if (e.trace && this.featureTracesShow) {
                                                                        a += this.featureTraceHeight
                                                                    }
                                                                    if (e.translate && this.featureTranslateShow) {
                                                                        for (var q = 0; q < e.translate.length; q++) {
                                                                            var o = "+" + e.translate[q];
                                                                            if (o == "+1") {
                                                                                this.toRender({
                                                                                    p: ["drawText", o, this.marginLeft + this.left - 15, c + a + (n / 2), h, s, "left", "middle"],
                                                                                    t: "Data"
                                                                                });
                                                                                a += this.featureTranslateHeight
                                                                            } else {
                                                                                if (o == "+2") {
                                                                                    this.toRender({
                                                                                        p: ["drawText", o, this.marginLeft + this.left - 15, c + a + (n / 2), h, s, "left", "middle"],
                                                                                        t: "Data"
                                                                                    });
                                                                                    a += this.featureTranslateHeight
                                                                                } else {
                                                                                    if (o == "+3") {
                                                                                        this.toRender({
                                                                                            p: ["drawText", o, this.marginLeft + this.left - 15, c + a + (n / 2), h, s, "left", "middle"],
                                                                                            t: "Data"
                                                                                        });
                                                                                        a += this.featureTranslateHeight
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                        a += this.sequenceFontSize + 2;
                                                                        for (var q = 0; q < e.translate.length; q++) {
                                                                            var o = e.translate[q];
                                                                            if (o == "-1") {
                                                                                this.toRender({
                                                                                    p: ["drawText", o, this.marginLeft + this.left - 15, c + a + (n / 2), h, s, "left", "middle"],
                                                                                    t: "Data"
                                                                                });
                                                                                a += this.featureTranslateHeight
                                                                            } else {
                                                                                if (o == "-2") {
                                                                                    this.toRender({
                                                                                        p: ["drawText", o, this.marginLeft + this.left - 15, c + a + (n / 2), h, s, "left", "middle"],
                                                                                        t: "Data"
                                                                                    });
                                                                                    a += this.featureTranslateHeight
                                                                                } else {
                                                                                    if (o == "-3") {
                                                                                        this.toRender({
                                                                                            p: ["drawText", o, this.marginLeft + this.left - 15, c + a + (n / 2), h, s, "left", "middle"],
                                                                                            t: "Data"
                                                                                        });
                                                                                        a += this.featureTranslateHeight
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                if (d == "box") {
                                                                    c += this.getBoxFeatureHeight(e)
                                                                } else {
                                                                    c += this.getSequenceFeatureHeight(e)
                                                                }
                                                            }
                                                        }
                                                        if (d != "dataframe" || t == this.subtracks[v].length - 1) {
                                                            c += n + this.margin
                                                        }
                                                    }
                                                }
                                                c += this.margin * 2
                                            }
                                        }
                                    }
                                };
                                this.plotGenomeData = function() {
                                    var x, w, ac;
                                    var H = this.marginLeft + this.left;
                                    var a = this.marginTop + this.top;
                                    var aa = this.xAxisUnit / 2;
                                    this.toRender({
                                        p: ["setClipArea", this.setClipBoundaries()],
                                        t: "Size"
                                    });
                                    for (var U = 0; U < this.data.tracks.length; U++) {
                                        var z = this.data.tracks[U];
                                        var ab = z.type || this.featureTypeDefault;
                                        var d = z.height || this.featureHeightDefault;
                                        var y = ab.match(/bar|box|dataframe/) && z.fill ? z.fill : false;
                                        var A = ab.match(/bar|box|dataframe/) && z.outline ? z.outline : this.foreground;
                                        var L = false;
                                        x = H;
                                        if (!z.hide) {
                                            if (z.name && !z.hideName) {
                                                var t = z.name;
                                                if (z.displayedFeatures != z.totalFeatures) {
                                                    t += " (Showing " + z.displayedFeatures + " out of " + z.totalFeatures + ")"
                                                }
                                                this.toRender({
                                                    p: ["drawText", t, x, a + (this.trackNameFontSize / 2) + this.margin, this.trackNameFont, z.trackNameFontColor || this.trackNameFontColor, "left", "middle"],
                                                    a: this.getTextArea(t, x, a + (this.trackNameFontSize / 2) + this.margin, this.trackNameFont, z.trackNameFontColor || this.trackNameFontColor, "left", "middle"),
                                                    i: ["track-" + U],
                                                    t: "Labels"
                                                });
                                                a += this.trackNameFontSize + (this.margin * 2)
                                            }
                                            if (z.highlight && this.genomeResolution != "low") {
                                                var V = z.highlight;
                                                for (var S = 0; S < V.length; S++) {
                                                    if (V[S].offset) {
                                                        var Z = V[S].color ? V[S].color : this.colors[U % this.colors.length];
                                                        x = this.marginLeft + this.left + (((V[S].offset - 0.5) - this.xAxisMin) * this.xAxisUnit);
                                                        w = V[S].width ? V[S].width * this.xAxisUnit : this.xAxisUnit;
                                                        ac = (z.endY - z.startY) + d;
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", x + (w / 2), z.startY + (ac / 2), w, ac, Z, Z, "closed"],
                                                            t: "Data"
                                                        })
                                                    }
                                                }
                                            }
                                            for (var S = 0; S < this.subtracks[U].length; S++) {
                                                var r = this.subtracks[U][S];
                                                if (!r) {
                                                    continue
                                                }
                                                if (this.featureStaggered) {
                                                    L = this.isNameInSubtrack(z, r)
                                                }
                                                for (var R = 0; R < r.length; R++) {
                                                    var Y = r[R];
                                                    var J = z.data[Y];
                                                    var X = J.data;
                                                    var t = this.shortenText(J.label || J.name || J.id, this.maxFeatureStringLen);
                                                    var D = this.getGenomeObjectColor("featureNameFontColor", J, z, this.foreground);
                                                    if (ab == "box") {
                                                        if (X.length > 0) {
                                                            this.setGenomeBoxExons(J);
                                                            if (this.featureStaggered && !z.hideFeatureNames && (!J.hideName || !L)) {
                                                                if (!J.hideName) {
                                                                    x = (((J.start - this.xAxisMin) * this.xAxisUnit)) - aa;
                                                                    this.drawBoxSequenceName(U, t, x, a, H, J.start, J.end, J, z)
                                                                }
                                                                a += this.featureNameFontSize + this.margin
                                                            }
                                                            this.drawGenomeBox(a, d, J, z);
                                                            if (this.genomeResolution == "high" && J.translate && this.featureTranslateShow) {
                                                                a += this.featureTranslateHeight * J.translate.length
                                                            }
                                                        }
                                                    } else {
                                                        if (ab == "sequence") {
                                                            var u = this.setGenomeGaps(J.gaps, J.sequence.length, J.dir);
                                                            if (J.offsetLeft && !J.offset) {
                                                                J.offset = (J.offsetLeft - (J.sequence.length + u.total)) + 1
                                                            }
                                                            if (this.featureStaggered && !z.hideFeatureNames && (!J.hideName || !L)) {
                                                                if (!J.hideName) {
                                                                    x = ((J.offset - this.xAxisMin) * this.xAxisUnit) - aa;
                                                                    this.drawBoxSequenceName(U, t, x, a, H, J.offset, J.offset + J.sequence.length + u.total, J, z)
                                                                }
                                                                a += this.featureNameFontSize + this.margin
                                                            }
                                                            if (this.genomeResolution == "high") {
                                                                if (J.trace && this.featureTracesShow) {
                                                                    this.drawGenomeTrace(a, J.counter, this.featureTraceHeight - 1, J.offset, J.trace, u, J.dir);
                                                                    a += this.featureTraceHeight
                                                                }
                                                                this.drawGenomeSequence(a, d, u, J, z);
                                                                a += d;
                                                                if (J.translate && this.featureTranslateShow) {
                                                                    for (var Q = 0; Q < J.translate.length; Q++) {
                                                                        a += this.featureTranslateHeight
                                                                    }
                                                                }
                                                                if (J.quality && this.featureQualityShow) {
                                                                    this.drawGenomeQuality(a, J.counter, this.featureQualityHeight - 1, J.offset, J.quality, u, J.dir, z);
                                                                    a += this.featureQualityHeight
                                                                }
                                                                if (J.signalToNoise && this.featureSignalToNoiseShow) {
                                                                    this.drawGenomeSignalToNoise(a, J.counter, this.featureSignalToNoiseHeight - 1, J.offset, J.signalToNoise, u, J.dir, z);
                                                                    a += this.featureSignalToNoiseHeight
                                                                }
                                                                if (J.coordinate && this.featureCoordinateShow) {
                                                                    this.drawGenomeCoordinate(a + 1, J.counter, this.featureCoordinateHeight - 1, J.offset, J.coordinate, J.sequence.length, u, J.dir, z);
                                                                    a += this.featureCoordinateHeight
                                                                }
                                                                a -= d
                                                            } else {
                                                                if (this.genomeResolution == "medium") {
                                                                    if (J.trace && this.featureTracesShow) {
                                                                        this.drawGenomeTrace(a, J.counter, this.featureTraceHeight - 1, J.offset, J.trace, u, J.dir);
                                                                        a += this.featureTraceHeight
                                                                    }
                                                                    this.drawGenomeSequence(a, d, u, J, z);
                                                                    if (J.coordinate && this.featureCoordinateShow) {
                                                                        this.drawGenomeCoordinate(a + 1, J.counter, this.featureCoordinateHeight - 1, J.offset, J.coordinate, J.sequence.length, u, J.dir, z)
                                                                    }
                                                                } else {
                                                                    this.drawGenomeSequence(a, d, u, J, z);
                                                                    if (J.coordinate && this.featureCoordinateShow) {
                                                                        this.drawGenomeCoordinate(a + 1, J.counter, this.featureCoordinateHeight - 1, J.offset, J.coordinate, J.sequence.length, u, J.dir, z)
                                                                    }
                                                                }
                                                            }
                                                        } else {
                                                            if (ab == "bar") {
                                                                var f;
                                                                if (this.genomeResolution == "high") {
                                                                    f = this.xAxisUnit / X.length
                                                                } else {
                                                                    f = z.autowidth ? this.xAxisUnit : J.width ? J.width : z.width ? z.width : this.featureWidthDefault
                                                                }
                                                                var T = f * X.length;
                                                                x = this.marginLeft + this.left + ((J.offset - this.xAxisMin) * this.xAxisUnit) - ((T / 2) + 1);
                                                                if (this.featureStaggered && !z.hideFeatureNames && (!J.hideName || !L)) {
                                                                    if (!J.hideName) {
                                                                        this.toRender({
                                                                            p: ["drawText", t, x, a + (this.featureNameFontSize / 2), this.featureNameFont, D, "left", "middle"],
                                                                            a: this.getTextArea(t, x, a + (this.featureNameFontSize / 2), this.featureNameFont, D, "left", "middle"),
                                                                            i: ["track-" + U + ":" + J.counter],
                                                                            t: "Labels"
                                                                        })
                                                                    }
                                                                    a += this.featureNameFontSize + this.margin
                                                                }
                                                                w = x;
                                                                var b = z.range[1] < 0 ? a : z.range[0] >= 0 ? a + d : (a + d) - Math.abs(z.range[0] * z.units);
                                                                for (var N = 0; N < X.length; N++) {
                                                                    var e = J.fill || y;
                                                                    var M = J.outline || A;
                                                                    var G = this.isArray(e) && e.length == X.length ? e[N] : this.isArray(e) ? e[0] : this.foreground;
                                                                    var o = this.isArray(M) && M.length == X.length ? M[N] : this.isArray(M) ? M[0] : this.foreground;
                                                                    var V = X[N] * z.units;
                                                                    if (X[N]) {
                                                                        if (V > 0) {
                                                                            this.toRender({
                                                                                p: ["drawShape", "rectangle", w + (f / 2), b - (V / 2), f, V, G, o, "closed"],
                                                                                a: this.getShapeArea("rectangle", w + (f / 2), b - (V / 2), f, V, G, o, "closed"),
                                                                                i: [J.counter],
                                                                                t: "Data"
                                                                            })
                                                                        } else {
                                                                            this.toRender({
                                                                                p: ["drawShape", "rectangle", w + (f / 2), b - (V / 2), f, -V, G, o, "closed"],
                                                                                a: this.getShapeArea("rectangle", w + (f / 2), b - (V / 2), f, -V, G, o, "closed"),
                                                                                i: [J.counter],
                                                                                t: "Data"
                                                                            })
                                                                        }
                                                                    }
                                                                    if (z.autowidth) {
                                                                        w += f
                                                                    } else {
                                                                        w += f + 2
                                                                    }
                                                                }
                                                            } else {
                                                                if (ab == "heatmap") {
                                                                    var f;
                                                                    if (this.genomeResolution == "high") {
                                                                        f = this.xAxisUnit
                                                                    } else {
                                                                        f = z.autowidth ? this.xAxisUnit : J.width ? J.width : z.width ? z.width : this.featureWidthDefault
                                                                    }
                                                                    x = this.marginLeft + this.left + ((J.offset - this.xAxisMin) * this.xAxisUnit) - ((f / 2) + 1);
                                                                    if (this.featureStaggered && !z.hideFeatureNames && (!J.hideName || !L)) {
                                                                        if (!J.hideName) {
                                                                            this.toRender({
                                                                                p: ["drawText", t, x, a + (this.featureNameFontSize / 2), this.featureNameFont, D, "left", "middle"],
                                                                                a: this.getTextArea(t, x, a + (this.featureNameFontSize / 2), this.featureNameFont, D, "left", "middle"),
                                                                                i: ["track-" + U + ":" + J.counter],
                                                                                t: "Labels"
                                                                            })
                                                                        }
                                                                        a += this.featureNameFontSize + this.margin
                                                                    }
                                                                    var V = z.autowidth ? d : d / X.length;
                                                                    ac = a;
                                                                    for (var N = 0; N < X.length; N++) {
                                                                        var C = X[N];
                                                                        var g = this.getColorForValue(z.brew, C);
                                                                        if (isNaN(C)) {
                                                                            this.toRender({
                                                                                p: ["drawShape", "rectangle", x + (f / 2), ac + (V / 2), f, V, this.missingDataColor, this.missingDataColor, "closed"],
                                                                                a: this.getShapeArea("rectangle", x + (f / 2), ac + (V / 2), f, V, this.missingDataColor, this.missingDataColor, "closed"),
                                                                                i: [J.counter],
                                                                                t: "Data"
                                                                            })
                                                                        } else {
                                                                            this.toRender({
                                                                                p: ["drawShape", "rectangle", x + (f / 2), ac + (V / 2), f, V, g, g, "closed"],
                                                                                a: this.getShapeArea("rectangle", x + (f / 2), ac + (V / 2), f, V, g, g, "closed"),
                                                                                i: [J.counter],
                                                                                t: "Data"
                                                                            })
                                                                        }
                                                                        if (z.autowidth) {
                                                                            x += f
                                                                        } else {
                                                                            ac += V
                                                                        }
                                                                    }
                                                                } else {
                                                                    if (ab == "dataframe") {
                                                                        x = this.marginLeft + this.left + ((J.offset - this.xAxisMin) * this.xAxisUnit);
                                                                        if (S == 0) {
                                                                            this.drawGenomeBoxTrack(this.marginLeft + this.left, a, d, z)
                                                                        }
                                                                        if (!z.hideFeatureNames && (!J.hideName || !L)) {
                                                                            if (!J.hideName) {
                                                                                var ac = (this.featureNameFontSize + this.margin) * S;
                                                                                for (var O = 0; O < X.length; O++) {
                                                                                    if (X[O].type) {
                                                                                        var K = X[O].colorBy && z.dataframe[X[O].colorBy] ? z.dataframe[X[O].colorBy] : false;
                                                                                        var n = X[O].colorBy && z.dataframe[X[O].colorBy] && X[O].meta && X[O].meta.color ? X[O].meta.color : false;
                                                                                        if (X[O].type == "line" || (X[O].type == "scatter" && (!K || !n))) {
                                                                                            var o = X[O].fill || "grey";
                                                                                            this.toRender({
                                                                                                p: ["drawText", X[O].yAxis, (this.left + this.margin * 4), a + (this.featureNameFontSize / 2) + ac + this.margin, this.featureNameFont, o, "left", "middle"],
                                                                                                a: this.getTextArea(X[O].yAxis, (this.left + this.margin * 4), a + (this.featureNameFontSize / 2) + ac + this.margin, this.featureNameFont, o, "left", "middle"),
                                                                                                i: ["track-" + U + ":" + J.counter],
                                                                                                t: "Labels"
                                                                                            });
                                                                                            ac += (this.featureNameFontSize + this.margin)
                                                                                        } else {
                                                                                            if (X[O].type == "scatter" && K && n) {
                                                                                                for (var P in X[O].meta.color) {
                                                                                                    var o = X[O].meta.color[P];
                                                                                                    this.toRender({
                                                                                                        p: ["drawText", P, (this.left + this.margin * 4), a + (this.featureNameFontSize / 2) + ac + this.margin, this.featureNameFont, o, "left", "middle"],
                                                                                                        a: this.getTextArea(P, (this.left + this.margin * 4), a + (this.featureNameFontSize / 2) + ac + this.margin, this.featureNameFont, o, "left", "middle"),
                                                                                                        i: ["track-" + U + ":" + J.counter],
                                                                                                        t: "Labels"
                                                                                                    });
                                                                                                    ac += (this.featureNameFontSize + this.margin)
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                        for (var O = 0; O < X.length; O++) {
                                                                            var I = z.dataframe && X[O].xAxis && z.dataframe[X[O].xAxis] ? z.dataframe[X[O].xAxis] : false;
                                                                            var v = z.dataframe && X[O].yAxis && z.dataframe[X[O].yAxis] ? z.dataframe[X[O].yAxis] : false;
                                                                            if (I && v && X[O].type) {
                                                                                var F, B;
                                                                                var K = X[O].colorBy && this.meta.data.tracks[U][X[O].colorBy] ? this.meta.data.tracks[U][X[O].colorBy] : false;
                                                                                if (X[O].type == "line") {
                                                                                    for (var N = 0; N < I.length - 1; N++) {
                                                                                        var o = X[O].fill || "grey";
                                                                                        x = this.marginLeft + this.left + ((I[N] - this.xAxisMin) * this.xAxisUnit);
                                                                                        w = this.marginLeft + this.left + ((I[N + 1] - this.xAxisMin) * this.xAxisUnit);
                                                                                        F = X[O].side == "left" ? (v[N] - z.minAxisY) * z.units : (v[N] - z.minAxisY2) * z.units2;
                                                                                        B = X[O].side == "left" ? (v[N + 1] - z.minAxisY) * z.units : (v[N + 1] - z.minAxisY2) * z.units2;
                                                                                        this.toRender({
                                                                                            p: ["drawLine", "line", x, d + a - F, w, d + a - B, o, false, "butt"],
                                                                                            a: this.getLineArea("line", x, d + a - F, w, d + a - B, o, false, "butt"),
                                                                                            i: ["dataframe-" + U + ":" + O, N],
                                                                                            t: "Data"
                                                                                        })
                                                                                    }
                                                                                } else {
                                                                                    if (X[O].type == "scatter") {
                                                                                        for (var N = 0; N < I.length; N++) {
                                                                                            var o;
                                                                                            if (K) {
                                                                                                if (K.type == "Numeric") {
                                                                                                    o = this.getColorForValue(K.brew, z.dataframe[X[O].colorBy][N])
                                                                                                } else {
                                                                                                    o = K.colors[K.order[z.dataframe[X[O].colorBy][N]]]
                                                                                                }
                                                                                            } else {
                                                                                                o = X[O].fill ? X[O].fill : "grey"
                                                                                            }
                                                                                            var m = this.dataPointSize * this.dataPointSizeScaleFactor;
                                                                                            var E = m > 5 ? this.foreground : o;
                                                                                            x = this.marginLeft + this.left + ((I[N] - this.xAxisMin) * this.xAxisUnit);
                                                                                            F = X[O].side == "left" ? (v[N] - z.minAxisY) * z.units : (v[N] - z.minAxisY2) * z.units;
                                                                                            this.toRender({
                                                                                                p: ["drawShape", "circle", x, d + a - F, m, m, o, E, "closed"],
                                                                                                a: this.getShapeArea("circle", x, d + a - F, m, m, o, E, "closed"),
                                                                                                i: ["dataframe-" + U + ":" + O, N],
                                                                                                t: "Data"
                                                                                            })
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    } else {
                                                                        if (ab == "marker") {
                                                                            for (var O = 0; O < X.length; O++) {
                                                                                y = J.fill && J.fill[O] ? J.fill[O] : this.foreground;
                                                                                for (var W = 0; W < X[O].length; W++) {
                                                                                    x = this.marginLeft + this.left + ((X[O][W] - this.xAxisMin) * this.xAxisUnit);
                                                                                    this.toRender({
                                                                                        p: ["drawLine", "line", x, a, x, a + d, y, false, "butt"],
                                                                                        a: this.getLineArea("line", x, a, x, a + d, y, false, "butt"),
                                                                                        i: [J.counter, W, O],
                                                                                        t: "Data"
                                                                                    })
                                                                                }
                                                                            }
                                                                        } else {
                                                                            if (ab == "triangle") {
                                                                                x = this.marginLeft + this.left + ((J.offset - this.xAxisMin) * this.xAxisUnit);
                                                                                y = J.fill ? J.fill : this.foreground;
                                                                                A = J.outline ? J.outline : this.foreground;
                                                                                if (this.featureStaggered && !z.hideFeatureNames && (!J.hideName || !L)) {
                                                                                    if (!J.hideName) {
                                                                                        this.toRender({
                                                                                            p: ["drawText", t, x, a + (this.featureNameFontSize / 2), this.featureNameFont, D, "left", "middle"],
                                                                                            a: this.getTextArea(t, x, a + (this.featureNameFontSize / 2), this.featureNameFont, D, "left", "middle"),
                                                                                            i: ["track-" + U + ":" + J.counter],
                                                                                            t: "Labels"
                                                                                        })
                                                                                    }
                                                                                    a += this.featureNameFontSize + this.margin
                                                                                }
                                                                                this.toRender({
                                                                                    p: ["drawShape", "triangle", x, a + (d / 2), d, d, y, A, "closed"],
                                                                                    a: this.getShapeArea("triangle", x, a + (d / 2), d, d, y, A, "closed"),
                                                                                    i: [J.counter],
                                                                                    t: "Data"
                                                                                })
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    if (this.featureStaggered) {
                                                        if (R < r.length - 1) {
                                                            if (!L) {
                                                                a -= (this.featureNameFontSize + this.margin)
                                                            }
                                                            if (ab == "box") {
                                                                a -= this.getBoxFeatureHeight(J)
                                                            } else {
                                                                if (ab == "sequence") {
                                                                    a -= this.getSequenceFeatureHeight(J)
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                if (ab != "dataframe" || S == this.subtracks[U].length - 1) {
                                                    a += d + this.margin
                                                }
                                            }
                                            a += this.margin * 2
                                        }
                                    }
                                    this.toRender({
                                        p: ["resetClipArea"],
                                        t: "Size"
                                    })
                                };
                                this.setGenomeBoxExons = function(b) {
                                    var e = b.data;
                                    if (!b.start || !b.end) {
                                        b.start = e[0][0];
                                        b.end = e[e.length - 1][1];
                                        if (b.sequence) {
                                            var g = b.dir == "left" ? b.sequence.length : 1;
                                            for (var a = 0; a < e.length; a++) {
                                                if (e[a].length == 2) {
                                                    var f = e[a][1] - e[a][0];
                                                    if (b.dir == "left") {
                                                        b.data[a].push(g - f, g)
                                                    } else {
                                                        b.data[a].push(g, g + f)
                                                    }
                                                }
                                                g = b.dir == "left" ? g - (f + 1) : g + f + 1
                                            }
                                        }
                                    }
                                };
                                this.drawGenomeBoxTrack = function(e, g, a, b) {
                                    this.toRender({
                                        p: ["drawShape", "rectangle", e + (this.x / 2) + 0.5, g + (a / 2) + 0.5, this.x + 1, a + 1, false, this.plotBoxColor, "open"],
                                        t: "Axis"
                                    });
                                    this.toRender({
                                        p: ["resetClipArea"],
                                        t: "Size"
                                    });
                                    var h = b.values;
                                    for (var d = 0; d < h.length; d++) {
                                        var f = ((h[d] - b.minAxisY) * b.units) - 0.5;
                                        this.toRender({
                                            p: ["drawLine", "line", this.left + this.margin, a + g - f, this.left - this.margin, a + g - f, this.yAxisTickColor],
                                            t: "Axes"
                                        });
                                        this.toRender({
                                            p: ["drawText", h[d].toString(), this.left - (this.margin * 2), a + g - f, this.axisTickFont, this.axisTickColor, "right", "middle"],
                                            t: "Axes"
                                        })
                                    }
                                    if (b.title) {
                                        var c = this.measureText(b.maxValueStr, this.axisTickFont) + (this.margin * 6);
                                        this.toRender({
                                            p: ["drawText", b.title, this.left - c, g + (a / 2), this.axisTitleFont, this.axisTitleColor, "center", "bottom", -Math.PI * 0.5],
                                            t: "Axes"
                                        })
                                    }
                                    if (b.values2) {
                                        var h = b.values2;
                                        for (var d = 0; d < h.length; d++) {
                                            var f = ((h[d] - b.minAxisY2) * b.units2) - 0.5;
                                            this.toRender({
                                                p: ["drawLine", "line", this.left + this.x + this.margin, a + g - f, this.left + this.x + (this.margin * 2), a + g - f, this.yAxisTickColor],
                                                t: "Axes"
                                            });
                                            this.toRender({
                                                p: ["drawText", h[d].toString(), this.left + this.x + (this.margin * 3), a + g - f, this.axisTickFont, this.axisTickColor, "left", "middle"],
                                                t: "Axes"
                                            })
                                        }
                                        if (b.title2) {
                                            var c = this.measureText(b.maxValueStr2, this.axisTickFont) + (this.margin * 6);
                                            this.toRender({
                                                p: ["drawText", b.title2, this.left + this.x + c, g + (a / 2), this.axisTitleFont, this.axisTitleColor, "center", "top", -Math.PI * 0.5],
                                                t: "Axes"
                                            })
                                        }
                                    }
                                    this.toRender({
                                        p: ["setClipArea", this.setClipBoundaries()],
                                        t: "Size"
                                    })
                                };
                                this.drawGenomeBoxLines = function(d, j, h, k) {
                                    var s, r, q, p, l;
                                    var a = h.scaleHeight ? h.scaleHeight : 1;
                                    var c = d + ((j * a) / 2);
                                    var b = h.dir == "right" ? d : d + (j * a);
                                    var e = this.marginLeft + this.left;
                                    var t = e + this.x;
                                    var u = h.data;
                                    var g = this.validateColor(h.fill || h.connect || k.connect) || this.foreground;
                                    var f = this.xAxisUnit / 2;
                                    var o = [];
                                    for (var m = 0; m < u.length; m++) {
                                        s = (((u[m][0] - this.xAxisMin) * this.xAxisUnit) - f);
                                        r = ((((u[m][1] - this.xAxisMin) * this.xAxisUnit) + f) - s);
                                        if (!h.insertion && (k.connect || h.connect) && this.featureSpliceStyle != "rect") {
                                            if (m < u.length - 1) {
                                                q = ((u[m + 1][0] - this.xAxisMin) * this.xAxisUnit);
                                                p = (s + r + q + 1 - f) / 2;
                                                if (Math.floor(q - (r + s)) > 2 && e + s + r < t && e + q > e) {
                                                    if (Math.abs(b - c) < 3) {
                                                        this.toRender({
                                                            p: ["drawLine", "line", e + s + r + 1, c + j - (j * a), e + q, c + j - (j * a), g, false, "butt"],
                                                            a: this.getLineArea("line", e + s + r + 1, c + j - (j * a), e + q, c + j - (j * a), g, false, "butt"),
                                                            i: [h.counter],
                                                            t: "Data"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawLine", "line", e + s + r + 1, c + j - (j * a), e + p, b + j - (j * a), g, false, "butt"],
                                                            a: this.getLineArea("line", e + s + r + 1, c + j - (j * a), e + p, b + j - (j * a), g, false, "butt"),
                                                            i: [h.counter],
                                                            t: "Data"
                                                        });
                                                        this.toRender({
                                                            p: ["drawLine", "line", e + p, b + j - (j * a), e + q - f, c + j - (j * a), g, false, "butt"],
                                                            a: this.getLineArea("line", e + p, b + j - (j * a), e + q - f, c + j - (j * a), g, false, "butt"),
                                                            i: [h.counter],
                                                            t: "Data"
                                                        })
                                                    }
                                                }
                                            }
                                        }
                                        if (h.insertion) {
                                            s = ((((u[m][0] + u[m][1]) / 2) - this.xAxisMin) * this.xAxisUnit);
                                            o.push([e + s, (d + j) - (j * a) + ((j * a) / 2), f / 2, (j * a)])
                                        } else {
                                            o.push([e + s, (d + j) - (j * a), r, (j * a)])
                                        }
                                    }
                                    if (!h.insertion && (k.connect || h.connect) && this.featureSpliceStyle == "rect") {
                                        l = u.length - 1;
                                        s = (((u[0][0] - this.xAxisMin) * this.xAxisUnit));
                                        r = ((((u[l][1] - this.xAxisMin) * this.xAxisUnit)) - s);
                                        this.toRender({
                                            p: ["drawLine", "line", e + s + r, c + j - (j * a), e + s, c + j - (j * a), g, false, "butt"],
                                            a: this.getLineArea("line", e + s + r, c + j - (j * a), e + s, c + j - (j * a), g, false, "butt"),
                                            i: [h.counter],
                                            t: "Data"
                                        })
                                    }
                                    if (h.showDir && this.xAxisUnit > 0.001 && !h.insertion) {
                                        g = this.validateColor(h.showDir) || g;
                                        s = e + (((h.start - this.xAxisMin) * this.xAxisUnit)) - f;
                                        r = e + (((h.end - this.xAxisMin) * this.xAxisUnit)) + f;
                                        q = 10;
                                        p = 5;
                                        if (h.dir == "right") {
                                            if (r < t && r + q > e) {
                                                this.toRender({
                                                    p: ["drawLine", "line", r, c, r + q, c, g, false, "butt"],
                                                    a: this.getLineArea("line", r, c, r + q, c, g, false, "butt"),
                                                    i: [h.counter],
                                                    t: "Data"
                                                });
                                                this.toRender({
                                                    p: ["drawLine", "line", r + p, c - (j / 3), r + q, c, g, false, "butt"],
                                                    a: this.getLineArea("line", r + p, c - (j / 3), r + q, c, g, false, "butt"),
                                                    i: [h.counter],
                                                    t: "Data"
                                                });
                                                this.toRender({
                                                    p: ["drawLine", "line", r + p, c + (j / 3), r + q, c, g, false, "butt"],
                                                    a: this.getLineArea("line", r + p, c + (j / 3), r + q, c, g, false, "butt"),
                                                    i: [h.counter],
                                                    t: "Data"
                                                })
                                            }
                                        } else {
                                            if (s - q < t && s > e) {
                                                this.toRender({
                                                    p: ["drawLine", "line", s, c, s - q, c, g, false, "butt"],
                                                    a: this.getLineArea("line", s, c, s - q, c, g, false, "butt"),
                                                    i: [h.counter],
                                                    t: "Data"
                                                });
                                                this.toRender({
                                                    p: ["drawLine", "line", s - p, c - (j / 3), s - q, c, g, false, "butt"],
                                                    a: this.getLineArea("line", s - p, c - (j / 3), s - q, c, g, false, "butt"),
                                                    i: [h.counter],
                                                    t: "Data"
                                                });
                                                this.toRender({
                                                    p: ["drawLine", "line", s - p, c + (j / 3), s - q, c, g, false, "butt"],
                                                    a: this.getLineArea("line", s - p, c + (j / 3), s - q, c, g, false, "butt"),
                                                    i: [h.counter],
                                                    t: "Data"
                                                })
                                            }
                                        }
                                    }
                                    return o
                                };
                                this.drawGenomeBoxAlleles = function(f, t, e, s, g, b) {
                                    var o = s / g.length;
                                    for (var n = 0; n < g.length; n++) {
                                        var r = g[n].split("");
                                        var k = (e - f) / r.length;
                                        var q = t + (o * n);
                                        for (var m = 0; m < r.length; m++) {
                                            var d = f + (k * m);
                                            if (r[m] == "-") {
                                                r[m] = "Gap"
                                            }
                                            var p = "sequence" + r[m].toUpperCase() + "Color";
                                            this.toRender({
                                                p: ["drawShape", "rectangle", d + (k / 2), q + (o / 2), k, o, this[p], this[p], "closed"],
                                                a: this.getShapeArea("rectangle", d + (k / 2), q + (o / 2), k, o, this[p], this[p], "closed"),
                                                i: [b],
                                                t: "Data"
                                            })
                                        }
                                    }
                                };
                                this.drawGenomeBox = function(d, x, n, z) {
                                    var r = this;
                                    var a = {};
                                    var t = function() {
                                        if (r.genomeResolution != "low" && n.sequence) {
                                            return n.dir == "left" ? n.sequenceRC.split("") : n.sequence.split("")
                                        } else {
                                            return false
                                        }
                                    };
                                    var C = n.fill && this.isArray(n.fill) ? this.validateColor(n.connect || z.fill || z.connect) : this.validateColor(n.fill || n.connect || z.fill || z.connect);
                                    var u = n.height && this.isArray(n.height) ? n.height : false;
                                    var H = n.outline || z.outline || C;
                                    var p = C ? "closed" : "open";
                                    var D = this.xAxisUnit / 2;
                                    var w = this.sequenceFontSize > x ? (x - 3) + "px " + this.fontName : this.sequenceFont;
                                    var s = t();
                                    var g = n.translateRC;
                                    var q = n.data;
                                    var h = this.marginLeft + this.left;
                                    var I = h + this.x;
                                    if (this.genomeResolution == "high" && g) {
                                        d += g.top.length * this.featureTranslateHeight
                                    }
                                    var y = this.drawGenomeBoxLines(d, x, n, z);
                                    for (var E = 0; E < y.length; E++) {
                                        var G = y[E][0];
                                        var F = G + y[E][2];
                                        if (Math.floor(F - G) < 3) {
                                            var B = parseInt(F);
                                            if (a.hasOwnProperty(B)) {
                                                continue
                                            }
                                            a[B] = true;
                                            a[B + 1] = true
                                        }
                                        if (G < I && F > h) {
                                            if (this.genomeResolution != "low" && n.alleles && n.alleles[E] && !n.insertion) {
                                                this.drawGenomeBoxAlleles(G, d, F, x, n.alleles[E], n.counter)
                                            }
                                            if (!g || this.genomeResolution != "high") {
                                                if (n.insertion) {
                                                    var c = n.dir == "left" ? "triangle" : "triangle2";
                                                    this.toRender({
                                                        p: ["drawShape", c, y[E][0], y[E][1], y[E][2], y[E][3], C, H, p],
                                                        a: this.getShapeArea(c, y[E][0], y[E][1], y[E][2], y[E][3], C, H, p),
                                                        i: [n.counter],
                                                        t: "Data"
                                                    })
                                                } else {
                                                    if (this.genomeResolution != "low" && n.sequence && (n.sequenceFill || z.sequenceFill || this.sequenceFill)) {
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", y[E][0] + (y[E][2] / 2), y[E][1] + (y[E][3] / 2), y[E][2], y[E][3], n.sequenceFill || z.sequenceFill || this.sequenceFill, H, p],
                                                            a: this.getShapeArea("rectangle", y[E][0] + (y[E][2] / 2), y[E][1] + (y[E][3] / 2), y[E][2], y[E][3], n.sequenceFill || z.sequenceFill || this.sequenceFill, H, p),
                                                            i: [n.counter],
                                                            t: "Data"
                                                        })
                                                    } else {
                                                        var f = u && u[E] != null && u[E] <= y[E][3] ? u[E] : y[E][3];
                                                        var J = n.fill && this.isArray(n.fill) && this.validateColor(n.fill[E]) ? n.fill[E] : C;
                                                        this.toRender({
                                                            p: ["drawShape", "rectangle", y[E][0] + (y[E][2] / 2), y[E][1] + (y[E][3] / 2), y[E][2], f, J, H, p],
                                                            a: this.getShapeArea("rectangle", y[E][0] + (y[E][2] / 2), y[E][1] + (y[E][3] / 2), y[E][2], f, J, H, p),
                                                            i: [n.counter],
                                                            t: "Data"
                                                        })
                                                    }
                                                }
                                            }
                                            if (this.genomeResolution != "low" && n.sequence && !n.insertion) {
                                                var e = {};
                                                var b = q[E][0];
                                                var o = q[E][1];
                                                var K = n.dir == "left" ? s.length - q[E][3] + 1 : q[E][2];
                                                var k = n.dir == "left" ? s.length - q[E][2] + 1 : q[E][3];
                                                var m = K - 3;
                                                if (o - b != k - K) {
                                                    this.errors.push("Exon length for segment " + E + " in feature " + n.id + "is different to the box dimmension")
                                                }
                                                if (s.length > 0) {
                                                    G += D;
                                                    for (var A = K; A <= k; A++) {
                                                        var v = s[A - 1];
                                                        if (!v) {
                                                            this.errors.push("Nucleotide " + A + " in exon " + (E + 1) + " in feature " + n.id + "not specified")
                                                        }
                                                        if (v) {
                                                            var l = "sequence" + v.toUpperCase() + "Color";
                                                            if (this.genomeResolution == "high") {
                                                                if (g && (!n.cds || (n.cds && A >= n.cds[0] && A <= n.cds[1]))) {
                                                                    this.drawTranslationTop(g, G, d, D, m, H, w, 0, e, n.counter);
                                                                    this.toRender({
                                                                        p: ["drawText", v, G, d + (x / 2), w, this[l], "center", "middle"],
                                                                        a: this.getTextArea(v, G, d + (x / 2), w, this[l], "center", "middle"),
                                                                        i: [n.counter],
                                                                        t: "Data"
                                                                    });
                                                                    this.drawTranslationBottom(g, G, d, D, m, H, w, 0, e, n.counter)
                                                                } else {
                                                                    this.toRender({
                                                                        p: ["drawText", v, G, d + (x / 2), w, this[l], "center", "middle"],
                                                                        a: this.getTextArea(v, G, d + (x / 2), w, this[l], "center", "middle"),
                                                                        i: [n.counter],
                                                                        t: "Data"
                                                                    })
                                                                }
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawShape", "rectangle", G, d + 1 + ((x - 2) / 2), 1, x - 2, this[l], this[l], "closed"],
                                                                    a: this.getShapeArea("rectangle", G, d + 1 + ((x - 2) / 2), 1, x - 2, this[l], this[l], "closed"),
                                                                    i: [n.counter],
                                                                    t: "Data"
                                                                })
                                                            }
                                                        } else {
                                                            if (this.genomeResolution == "high") {
                                                                this.toRender({
                                                                    p: ["drawText", "-", G, d + (x / 2), w, this.missingDataColor, "center", "middle"],
                                                                    a: this.getTextArea("-", G, d + (x / 2), w, this.missingDataColor, "center", "middle"),
                                                                    i: [n.counter],
                                                                    t: "Data"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawShape", "rectangle", G, d + 1 + ((x - 2) / 2), 1, x - 2, this.missingDataColor, this.missingDataColor, "closed"],
                                                                    a: this.getShapeArea("rectangle", G, d + 1 + ((x - 2) / 2), 1, x - 2, this.missingDataColor, this.missingDataColor, "closed"),
                                                                    i: [n.counter],
                                                                    t: "Data"
                                                                })
                                                            }
                                                        }
                                                        m++;
                                                        G += this.xAxisUnit
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawGenomeTrace = function(b, m, q, f, z, t, s) {
                                    if (this.genomeResolution != "low") {
                                        if (s == "left" && !z.reversed) {
                                            this.setReverseTrace(z)
                                        }
                                        var o = [];
                                        var g = ["A", "C", "G", "T"];
                                        var D = this.marginLeft + this.left + (((f - 1) - this.xAxisMin) * this.xAxisUnit);
                                        var u = this.marginLeft + this.left;
                                        var p = this.marginLeft + this.left + this.x;
                                        var a = b + q;
                                        if (z.max == null) {
                                            for (var A = 0; A < g.length; A++) {
                                                o = o.concat(z[g[A]])
                                            }
                                            if (CanvasXpress.system.browser == "Firefox") {
                                                o = this.radixSort(o)
                                            } else {
                                                o.sort(function(j, i) {
                                                    return j - i
                                                })
                                            }
                                            var B = Math.floor(o.length * this.featureTraceTrim / 100);
                                            z.max = o[o.length - (B + 1)]
                                        }
                                        var v = q / z.max;
                                        var e = g.length;
                                        for (var A = 0; A < e; A++) {
                                            var c = 0;
                                            var h = [];
                                            var y = [];
                                            var C = D;
                                            var d = "sequence" + g[A].toUpperCase() + "Color";
                                            var F = z.peak.length;
                                            for (var x = 0; x < F; x++) {
                                                if (C > u - this.xAxisUnit && C < p) {
                                                    var n = this.xAxisUnit / (z.peak[x] - c);
                                                    if (t[x]) {
                                                        var E = Math.floor((z.peak[x] - c) / 2);
                                                        for (var w = c; w < (z.peak[x] - E); w++) {
                                                            h.push(C);
                                                            y.push(a - (Math.min(z.max, z[g[A]][w]) * v));
                                                            C += n
                                                        }
                                                        c += E;
                                                        if (h.length > 1 && y.length > 1) {
                                                            this.toRender({
                                                                p: ["drawShape", "path", h, y, false, false, this[d], this[d], "open"],
                                                                a: this.getShapeArea("path", h, y, false, false, this[d], this[d], "open"),
                                                                i: [m],
                                                                t: "Data"
                                                            })
                                                        }
                                                        h = [];
                                                        y = [];
                                                        for (var w = 0; w < t[x]; w++) {
                                                            C += this.xAxisUnit
                                                        }
                                                    }
                                                    for (var w = c; w <= z.peak[x]; w++) {
                                                        h.push(C);
                                                        y.push(a - (Math.min(z.max, z[g[A]][w]) * v));
                                                        C += n
                                                    }
                                                    C -= n;
                                                    c = z.peak[x]
                                                } else {
                                                    if (t[x]) {
                                                        for (var w = 0; w < t[x]; w++) {
                                                            C += this.xAxisUnit
                                                        }
                                                    }
                                                    c = z.peak[x];
                                                    C += this.xAxisUnit
                                                }
                                            }
                                            if (C > u - this.xAxisUnit && C < p) {
                                                for (var w = c; w < z[g[A]].length; w++) {
                                                    h.push(C);
                                                    y.push(a - (Math.min(z.max, z[g[A]][w]) * v));
                                                    C += n
                                                }
                                            }
                                            if (h.length > 1 && y.length > 1) {
                                                this.toRender({
                                                    p: ["drawShape", "path", h, y, false, false, this[d], this[d], "open"],
                                                    a: this.getShapeArea("path", h, y, false, false, this[d], this[d], "open"),
                                                    i: [m],
                                                    t: "Data"
                                                })
                                            }
                                        }
                                    }
                                };
                                this.drawTranslationTop = function(q, d, l, g, k, o, n, p, e, b) {
                                    if (q.top && q.top.length > 0) {
                                        for (var f = 0; f < q.top.length; f++) {
                                            y1 = l - ((q.top.length - f) * this.featureTranslateHeight);
                                            var j = q.top[f];
                                            if (k - j.off >= 0 && (k - j.off) % 3 == 0) {
                                                var a = j.seq[Math.floor((k - j.off) / 3)];
                                                var m = k % 2 ? this.oddColor : this.evenColor;
                                                if (a == "M") {
                                                    m = this.sequenceStartColor
                                                } else {
                                                    if (a == "*") {
                                                        m = this.sequenceEndColor
                                                    }
                                                }
                                                if (!e[j.rf]) {
                                                    e[j.rf] = d - (this.xAxisUnit * (p + 2.5))
                                                }
                                                x0 = (d - e[j.rf]) + g;
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2), x0, this.featureTranslateHeight - 1, m, o, "closed"],
                                                    a: this.getShapeArea("rectangle", e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2), x0, this.featureTranslateHeight - 1, m, o, "closed"),
                                                    i: [b],
                                                    t: "Data"
                                                });
                                                this.toRender({
                                                    p: ["drawText", a, e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2) + 1, n, this.foreground, "center", "middle"],
                                                    a: this.getTextArea(a, e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2) + 1, n, this.foreground, "center", "middle"),
                                                    i: [b],
                                                    t: "Data"
                                                });
                                                e[j.rf] = d + g
                                            }
                                        }
                                    }
                                };
                                this.drawTranslationBottom = function(q, d, l, g, k, o, n, p, e, b) {
                                    if (q.bottom && q.bottom.length > 0) {
                                        for (var f = 0; f < q.bottom.length; f++) {
                                            y1 = l + ((f + 1) * this.featureTranslateHeight);
                                            var j = q.bottom[f];
                                            if (k - j.off >= 0 && (k - j.off) % 3 == 0) {
                                                var a = j.seq[Math.floor((k + j.off + 1) / 3)];
                                                var m = k % 2 ? this.oddColor : this.evenColor;
                                                if (a == "M") {
                                                    m = this.sequenceStartColor
                                                } else {
                                                    if (a == "*") {
                                                        m = this.sequenceEndColor
                                                    }
                                                }
                                                if (!e[j.rf]) {
                                                    e[j.rf] = d - (this.xAxisUnit * (p + 2.5))
                                                }
                                                x0 = (d - e[j.rf]) + g;
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2), x0, this.featureTranslateHeight - 1, m, o, "closed"],
                                                    a: this.getShapeArea("rectangle", e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2), x0, this.featureTranslateHeight - 1, m, o, "closed"),
                                                    i: [b],
                                                    t: "Data"
                                                });
                                                this.toRender({
                                                    p: ["drawText", a, e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2) + 1, n, this.foreground, "center", "middle"],
                                                    a: this.getTextArea(a, e[j.rf] + (x0 / 2), y1 + (this.featureTranslateHeight / 2) + 1, n, this.foreground, "center", "middle"),
                                                    i: [b],
                                                    t: "Data"
                                                });
                                                e[j.rf] = d + g
                                            }
                                        }
                                    }
                                };
                                this.drawGenomeSequence = function(a, d, m, y, u) {
                                    var f = y.counter;
                                    var t = y.fill ? y.fill : u.fill ? u.fill : this.background;
                                    var v = y.outline || this.foreground;
                                    var k = t ? "closed" : "open";
                                    var e = this.sequenceFontSize > d ? (d - 3) + "px " + this.fontName : this.sequenceFont;
                                    var D = y.offset;
                                    var M = y.sequence;
                                    var P = y.sequenceRC;
                                    var C = y.translate;
                                    var L = y.translateRF;
                                    var O = y.dir;
                                    if (O == "left" && !P) {
                                        P = M;
                                        M = this.getReverseComplement(M)
                                    }
                                    if (C && !L) {
                                        L = C;
                                        C = this.translate(C, M)
                                    }
                                    var g = M.split("");
                                    var q = this.marginLeft + this.left + ((D - this.xAxisMin) * this.xAxisUnit);
                                    var I = this.marginLeft + this.left;
                                    var G = this.marginLeft + this.left + this.x;
                                    var p = (g.length + m.total) * this.xAxisUnit;
                                    var H = 0;
                                    var F = u.subtype.match(/DNA|RNA/) ? 1 : 3;
                                    var E = this.xAxisUnit * 4;
                                    var K = this.xAxisUnit / 2;
                                    var N = -2;
                                    var w = {};
                                    var Q = a;
                                    var B = 0;
                                    var z = 0;
                                    var A = this;
                                    if (this.genomeResolution == "high") {
                                        var o = q + (H * this.xAxisUnit);
                                        if (C) {
                                            a += C.top.length * this.featureTranslateHeight
                                        }
                                        while (g.length > 0) {
                                            if (o > I - E && o < G + E) {
                                                var b = g.shift();
                                                if (b == "[") {
                                                    b = g.shift();
                                                    var x = [];
                                                    while (b != "]") {
                                                        x.push(b);
                                                        b = g.shift()
                                                    }
                                                    this.toRender({
                                                        p: ["drawText", x.join("/"), q + (H * this.xAxisUnit), a + (d / 2), e, this.sequenceMColor, "center", "middle"],
                                                        a: this.getTextArea(x.join("/"), q + (H * this.xAxisUnit), a + (d / 2), e, this.sequenceMColor, "center", "middle"),
                                                        i: [f],
                                                        t: "Data"
                                                    })
                                                } else {
                                                    var j = "sequence" + b.toUpperCase() + "Color";
                                                    if (C) {
                                                        this.drawTranslationTop(C, o, a, K, N, v, e, z, w, f);
                                                        this.toRender({
                                                            p: ["drawText", b, o, a + (d / 2), e, this[j], "center", "middle"],
                                                            a: this.getTextArea(b, o, a + (d / 2), e, this[j], "center", "middle"),
                                                            i: [f],
                                                            t: "Data"
                                                        });
                                                        this.drawTranslationBottom(C, o, a, K, N, v, e, z, w, f)
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawText", b, o, a + (d / 2), e, this[j], "center", "middle"],
                                                            a: this.getTextArea(b, o, a + (d / 2), e, this[j], "center", "middle"),
                                                            i: [f],
                                                            t: "Data"
                                                        })
                                                    }
                                                }
                                                H += F;
                                                o = q + ((H + B) * this.xAxisUnit);
                                                N++;
                                                z = 0;
                                                if (m[parseInt(H / F)]) {
                                                    for (var J = 0; J < m[parseInt(H / F)]; J++) {
                                                        this.toRender({
                                                            p: ["drawText", "-", o, a + (d / 2), e, this.missingDataColor, "center", "middle"],
                                                            a: this.getTextArea("-", o, a + (d / 2), e, this.missingDataColor, "center", "middle"),
                                                            i: [f],
                                                            t: "Data"
                                                        });
                                                        B++;
                                                        z++;
                                                        o = q + ((H + B) * this.xAxisUnit)
                                                    }
                                                }
                                            } else {
                                                g.shift();
                                                H += F;
                                                o = q + ((H + B) * this.xAxisUnit);
                                                N++;
                                                z = 0;
                                                if (m[parseInt(H / F)]) {
                                                    for (var J = 0; J < m[parseInt(H / F)]; J++) {
                                                        B++;
                                                        z++;
                                                        o = q + ((H + B) * this.xAxisUnit)
                                                    }
                                                }
                                            }
                                        }
                                    } else {
                                        q = this.marginLeft + this.left + (((D - 0.5) - this.xAxisMin) * this.xAxisUnit);
                                        this.toRender({
                                            p: ["drawShape", "rectangle", q + (p / 2), a + (d / 2), p, d, t, v, "closed"],
                                            a: this.getShapeArea("rectangle", q + (p / 2), a + (d / 2), p, d, t, v, "closed"),
                                            i: [f],
                                            t: "Data"
                                        });
                                        for (var J in m) {
                                            q = this.marginLeft + this.left + ((((D - 0.5) + parseInt(J) + z) - this.xAxisMin) * this.xAxisUnit);
                                            p = m[J] * this.xAxisUnit;
                                            z += m[J];
                                            this.toRender({
                                                p: ["drawShape", "rectangle", q + (p / 2), a + (d / 2), p, d, this.missingDataColor, v, k],
                                                a: this.getShapeArea("rectangle", q + (p / 2), a + (d / 2), p, d, this.missingDataColor, v, k),
                                                i: [f],
                                                t: "Data"
                                            })
                                        }
                                    }
                                };
                                this.drawGenomeQuality = function(a, f, n, d, c, q, o, p) {
                                    if (this.genomeResolution != "low") {
                                        var h = o == "left" ? this.cloneObject(c).reverse() : c;
                                        var y = this.marginLeft + this.left + (((d - 0.5) - this.xAxisMin) * this.xAxisUnit);
                                        var t = this.marginLeft + this.left;
                                        var m = this.marginLeft + this.left + this.x;
                                        var x = y;
                                        var k = p.subtype.match(/DNA|RNA/) ? 1 : 3;
                                        var g = k * this.xAxisUnit;
                                        var e = (this.featureQualityHeight - 3) + "px " + this.fontName;
                                        for (var v = 0; v < h.length; v++) {
                                            if (x + g > t && x < m) {
                                                if (q[v]) {
                                                    for (var u = 0; u < q[v]; u++) {
                                                        x += g
                                                    }
                                                }
                                                var b = this.getColorForValue(p.brew, h[v]);
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", x + (g / 2), a + (n / 2), g, n, b, b, "closed"],
                                                    a: this.getShapeArea("rectangle", x + (g / 2), a + (n / 2), g, n, b, b, "closed"),
                                                    i: [f],
                                                    t: "Data"
                                                });
                                                if (x > t && this.genomeResolution == "high" && this.featureQualityValues) {
                                                    this.toRender({
                                                        p: ["drawText", h[v], x + (g / 2), a + (n / 2), e, this.foreground, "center", "middle"],
                                                        a: this.getTextArea(h[v], x + (g / 2), a + (n / 2), e, this.foreground, "center", "middle"),
                                                        i: [f],
                                                        t: "Data"
                                                    })
                                                }
                                            }
                                            x += g
                                        }
                                    }
                                };
                                this.drawGenomeSignalToNoise = function(a, f, m, d, u, p, n, o) {
                                    if (this.genomeResolution != "low") {
                                        var c = n == "left" ? this.cloneObject(u).reverse() : u;
                                        var y = this.marginLeft + this.left + (((d - 0.5) - this.xAxisMin) * this.xAxisUnit);
                                        var q = this.marginLeft + this.left;
                                        var k = this.marginLeft + this.left + this.x;
                                        var x = y;
                                        var h = o.subtype.match(/DNA|RNA/) ? 1 : 3;
                                        var g = h * this.xAxisUnit;
                                        var e = (this.featureSignalToNoiseHeight - 3) + "px " + this.fontName;
                                        for (var v = 0; v < c.length; v++) {
                                            if (x + g > q && x < k) {
                                                if (p[v]) {
                                                    for (var t = 0; t < p[v]; t++) {
                                                        x += g
                                                    }
                                                }
                                                var b = this.getColorForValue(o.brew, c[v]);
                                                this.toRender({
                                                    p: ["drawShape", "rectangle", x + (g / 2), a + (m / 2), g, m, b, b, "closed"],
                                                    a: this.getShapeArea("rectangle", x + (g / 2), a + (m / 2), g, m, b, b, "closed"),
                                                    i: [f],
                                                    t: "Data"
                                                });
                                                if (x > q && this.genomeResolution == "high" && this.featureSignalToNoiseValues) {
                                                    this.toRender({
                                                        p: ["drawText", c[v], x + (g / 2), a + (m / 2), e, this.foreground, "center", "middle"],
                                                        a: this.getTextArea(c[v], x + (g / 2), a + (m / 2), e, this.foreground, "center", "middle"),
                                                        i: [f],
                                                        t: "Data"
                                                    })
                                                }
                                            }
                                            x += g
                                        }
                                    }
                                };
                                this.drawGenomeCoordinate = function(a, g, m, e, C, b, x, p, u) {
                                    if (this.genomeResolution != "low") {
                                        var A = this.marginLeft + this.left + ((e - this.xAxisMin) * this.xAxisUnit);
                                        var y = this.marginLeft + this.left;
                                        var k = this.marginLeft + this.left + this.x;
                                        var v = C;
                                        var j = u.subtype.match(/DNA|RNA/) ? 1 : 3;
                                        var h = j * this.xAxisUnit;
                                        var B = this.getCoordinateStep();
                                        var o = b + x.total;
                                        var i = C + o;
                                        var f = (m - 3) + "px " + this.fontName;
                                        if (p == "left") {
                                            var z = A + ((o - 1) * h);
                                            while (C < i - x.total) {
                                                if (x[(o - (C - v)) - 2]) {
                                                    z -= (h * x[(o - (C - v)) - 2])
                                                }
                                                if (z > y && z < k) {
                                                    if (C % B == 0) {
                                                        this.toRender({
                                                            p: ["drawText", C, z, a + (m / 2), f, this.foreground, "center", "middle"],
                                                            t: "Labels"
                                                        })
                                                    }
                                                }
                                                z -= h;
                                                C++
                                            }
                                        } else {
                                            var z = A;
                                            while (C < i - x.total) {
                                                if (x[C - v]) {
                                                    z += (h * x[C - v])
                                                }
                                                if (z > y && z < k) {
                                                    if (C % B == 0) {
                                                        this.toRender({
                                                            p: ["drawText", C, z, a + (m / 2), f, this.foreground, "center", "middle"],
                                                            t: "Labels"
                                                        })
                                                    }
                                                }
                                                z += h;
                                                C++
                                            }
                                        }
                                    }
                                };
                                this.setGenomeWireFrame = function() {
                                    var b = this.marginLeft + this.left;
                                    var a = this.marginLeft + this.left + this.x;
                                    var f = this.getCoordinateStep();
                                    var g = Math.floor(this.xAxisMin);
                                    var e = this.getFontPt(this.featureNameFont) / 2;
                                    if (this.genomeResolution == "low") {
                                        f *= 5
                                    }
                                    while (b <= a) {
                                        b = this.marginLeft + this.left + ((g - this.xAxisMin) * this.xAxisUnit);
                                        if (g % f == 0) {
                                            if (this.xAxisTickStyle == "dotted") {
                                                this.toRender({
                                                    p: ["drawLine", "dottedLine", b, this.marginTop + this.top, b, this.marginTop + this.top + this.y, this.wireColor, false, "butt"],
                                                    t: "Axes"
                                                })
                                            } else {
                                                this.toRender({
                                                    p: ["drawLine", "line", b, this.marginTop + this.top, b, this.marginTop + this.top + this.y, this.wireColor, false, "butt"],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                        g++
                                    }
                                };
                                this.setGenomeTicks = function() {
                                    var e = this.marginLeft + this.left;
                                    var b = this.marginLeft + this.left + this.x;
                                    var f = this.marginLeft + this.left;
                                    var h = this.getCoordinateStep();
                                    var i = Math.floor(this.xAxisMin);
                                    var g = this.getFontPt(this.featureNameFont) / 2;
                                    if (this.genomeResolution == "low") {
                                        h *= 5
                                    }
                                    while (e <= b) {
                                        e = this.marginLeft + this.left + ((i - this.xAxisMin) * this.xAxisUnit);
                                        if (i % h == 0) {
                                            var a = this.measureText(i.toString(), this.featureNameFont);
                                            if (e >= f) {
                                                this.toRender({
                                                    p: ["drawText", i.toString(), e, this.marginTop + this.top + this.y + this.margin + g, this.featureNameFont, this.axisTickColor, "center", "middle"],
                                                    t: "Axes"
                                                });
                                                f = e + (a * 1.5)
                                            }
                                        }
                                        i++
                                    }
                                };
                                this.setGenomeRightDimentions = function() {
                                    var h = 0;
                                    for (var f = 0; f < this.data.tracks.length; f++) {
                                        var b = this.data.tracks[f];
                                        if (b.type == "dataframe") {
                                            for (var e = 0; e < b.data.length; e++) {
                                                var a = b.data[e];
                                                for (var d = 0; d < a.data.length; d++) {
                                                    var l = a.data[d].title ? this.axisTitleFontSize + this.margin : this.margin;
                                                    var g = a.data[d].yAxis;
                                                    var m = a.data[d].side;
                                                    if (g && b.dataframe[g] && m && m == "right") {
                                                        var c = a.data[d].maxValueStrLen + l;
                                                        h = Math.max(h, c)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return h == 0 ? this.margin : h + (this.margin * 4)
                                };
                                this.setGenomeLeftDimentions = function() {
                                    if (this.featureStaggered) {
                                        var l = 0;
                                        for (var f = 0; f < this.data.tracks.length; f++) {
                                            var b = this.data.tracks[f];
                                            if (b.type == "dataframe") {
                                                for (var e = 0; e < b.data.length; e++) {
                                                    var a = b.data[e];
                                                    for (var d = 0; d < a.data.length; d++) {
                                                        var m = a.data[d].title ? this.axisTitleFontSize + this.margin : this.margin;
                                                        var h = a.data[d].yAxis;
                                                        var o = a.data[d].side;
                                                        if (h && b.dataframe[h] && o && o == "left") {
                                                            var c = a.data[d].maxValueStrLen + m;
                                                            l = Math.max(l, c)
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        return l + (this.margin * 6)
                                    } else {
                                        var g = [];
                                        for (var f = 0; f < this.data.tracks.length; f++) {
                                            var b = this.data.tracks[f];
                                            for (var e = 0; e < b.data.length; e++) {
                                                var n = b.data[e];
                                                g.push(n.label || n.name || n.id)
                                            }
                                        }
                                        return this.measureText(this.shortenText(this.getMaxText(g), this.maxFeatureStringLen), this.featureNameFont) + (this.margin * 4)
                                    }
                                };
                                this.setGenomeYDimentions = function() {
                                    this.bottom = this.margin + this.getFontPt(this.featureNameFont);
                                    if (this.adjustAspectRatio || this.height < (this.marginTop + this.top + this.y + this.bottom + this.marginBottom)) {
                                        this.height = this.marginTop + this.top + this.y + this.bottom + this.marginBottom
                                    }
                                    this.resizeCanvas();
                                    this.resizeViewport()
                                };
                                this.setGenomeYUnits = function() {
                                    for (var h = 0; h < this.data.tracks.length; h++) {
                                        var c = this.data.tracks[h];
                                        var o = this.meta.data.tracks[h];
                                        if (c.type == "dataframe") {
                                            for (var f = 0; f < c.data.length; f++) {
                                                var b = c.data[f];
                                                var m = [];
                                                var g = [];
                                                for (var e = 0; e < b.data.length; e++) {
                                                    var n = b.data[e].yAxis;
                                                    if (n && c.dataframe.hasOwnProperty(n) && o.hasOwnProperty(n)) {
                                                        b.data[e].range = o[n].range;
                                                        b.data[e].values = o[n].values;
                                                        b.data[e].valuesStr = o[n].valuesStr;
                                                        b.data[e].maxValueStr = o[n].maxValueStr;
                                                        b.data[e].maxValueStrLen = o[n].maxValueStrLen;
                                                        b.data[e].minAxisY = b.data[e].setMinY != null ? b.data[e].setMinY : Math.min(b.data[e].range[0], b.data[e].values[0]);
                                                        b.data[e].maxAxisY = b.data[e].setMaxY != null ? b.data[e].setMaxY : Math.max(b.data[e].range[1], b.data[e].values[b.data[e].values.length - 1]);
                                                        b.data[e].units = (c.height || this.featureTypeDefault) / ((b.data[e].maxAxisY - b.data[e].minAxisY) * 1.05);
                                                        b.data[e].brew = this.getColorBrew(c.colorSpectrum || this.colorSpectrum, b.data[e].minAxisY, b.data[e].maxAxisY)
                                                    }
                                                    if (b.data[e].side == "left") {
                                                        if (b.data[e].title) {
                                                            c.title = b.data[e].title
                                                        }
                                                        m.push(b.data[e].range[0], b.data[e].range[1])
                                                    } else {
                                                        if (b.data[e].side == "right") {
                                                            if (b.data[e].title) {
                                                                c.title2 = b.data[e].title
                                                            }
                                                            g.push(b.data[e].range[0], b.data[e].range[1])
                                                        }
                                                    }
                                                }
                                                if (m.length) {
                                                    c.range = this.range(m);
                                                    c.values = this[this.axisAlgorithm](c.range[0], c.range[1], 5, this.axisWilkinsonLoose);
                                                    var a = [];
                                                    for (var d = 0; d < c.values.length; d++) {
                                                        a.push(c.values[d].toString())
                                                    }
                                                    c.maxValueStr = this.getMaxText(a);
                                                    c.maxValueStrLen = this.measureText(c.maxValueStr, this.axisTickFont);
                                                    c.minAxisY = Math.min(c.range[0], c.values[0]);
                                                    c.maxAxisY = Math.max(c.range[1], c.values[c.values.length - 1]);
                                                    c.units = (c.height || this.featureTypeDefault) / ((c.maxAxisY - c.minAxisY) * 1.05);
                                                    c.brew = this.getColorBrew(c.colorSpectrum || this.colorSpectrum, c.minAxisY, c.maxAxisY)
                                                }
                                                if (g.length) {
                                                    c.range2 = this.range(g);
                                                    c.values2 = this[this.axisAlgorithm](c.range2[0], c.range2[1], 5, this.axisWilkinsonLoose);
                                                    var a = [];
                                                    for (var d = 0; d < c.values2.length; d++) {
                                                        a.push(c.values2[d].toString())
                                                    }
                                                    c.maxValueStr2 = this.getMaxText(a);
                                                    c.maxValueStrLen2 = this.measureText(c.maxValueStr2, this.axisTickFont);
                                                    c.minAxisY2 = Math.min(c.range2[0], c.values2[0]);
                                                    c.maxAxisY2 = Math.max(c.range2[1], c.values2[c.values2.length - 1]);
                                                    c.units2 = (c.height || this.featureTypeDefault) / ((c.maxAxisY2 - c.minAxisY2) * 1.05);
                                                    c.brew2 = this.getColorBrew(c.colorSpectrum || this.colorSpectrum, c.minAxisY2, c.maxAxisY2)
                                                }
                                            }
                                        } else {
                                            if (c.type.match(/bar|heatmap/)) {
                                                c.range = o.range;
                                                c.values = o.values;
                                                c.valuesStr = o.valuesStr;
                                                c.minAxisY = c.setMinY != null ? c.setMinY : Math.min(c.range[0], c.values[0]);
                                                c.maxAxisY = c.setMaxY != null ? c.setMaxY : Math.max(c.range[1], c.values[c.values.length - 1]);
                                                c.units = (c.height || this.featureTypeDefault) / ((c.maxAxisY - c.minAxisY) * 1.05);
                                                c.brew = this.getColorBrew(c.colorSpectrum || this.colorSpectrum, c.minAxisY, c.maxAxisY)
                                            }
                                        }
                                    }
                                };
                                this.setGenomeAxisUnits = function() {
                                    this.setAxisUnits("xAxis");
                                    this.genomeResolution = this.xAxisUnit > this.sequenceFontSize ? "high" : this.xAxisUnit * 5 > this.sequenceFontSize ? "medium" : "low"
                                };
                                this.setGenomeXDimentions = function() {
                                    this.left = this.setGenomeLeftDimentions();
                                    this.right = this.setGenomeRightDimentions();
                                    if (this.featureStaggered) {
                                        if (this.width) {
                                            this.x = this.width - (this.marginLeft + this.left + this.right + this.marginRight)
                                        } else {
                                            this.width = this.marginLeft + this.left + this.x + this.right + this.marginRight
                                        }
                                    } else {
                                        if (this.width) {
                                            this.x = this.width - (this.marginLeft + this.left + this.right + this.marginRight)
                                        } else {
                                            this.width = this.marginLeft + this.left + this.x + this.right + this.marginRight
                                        }
                                    }
                                };
                                this.setGenomeFontsColors = function() {
                                    this.trackNameFont = this.trackNameFontStyle + " " + this.trackNameFontSize + "px " + this.fontName;
                                    this.featureNameFont = this.featureNameFontStyle + " " + this.featureNameFontSize + "px " + this.fontName;
                                    this.sequenceFont = (this.sequenceFontSize) + "px " + this.fontName;
                                    if (!this.wireColor.match(/,0.1\)$/)) {
                                        this.wireColor = this.wireColor.replace(/\)$/, ",0.1)")
                                    }
                                };
                                this.drawGenome = function() {
                                    this.setGenomeFontsColors();
                                    this.setGenomeYUnits();
                                    this.setGenomeXDimentions();
                                    this.setGenomeAxisUnits();
                                    this.setGenomeSubtracks();
                                    this.setGenomeYDimentions();
                                    this.setGenomeWireFrame();
                                    this.plotGenomeData();
                                    this.drawGenomeLabels();
                                    this.setGenomeTicks()
                                };
                                this.initializeGenome = function() {
                                    this.drawGenome()
                                };
                                this.initializeGenome()
                            };
                            CanvasXpress.prototype.Circular = function() {
                                this.drawCircularElement = function(b) {
                                    if (!this.circularDebuggingCounter) {
                                        this.circularDebuggingCounter = 0
                                    }
                                    if (this.debug) {
                                        var f = this.addColorTransparency(this.colors[this.circularDebuggingCounter % this.colors.length], 0.5, true);
                                        var a = -Math.PI;
                                        var d = a + (2 * Math.PI);
                                        this.toRender({
                                            p: ["drawShape", "circle", this.cx, this.cy, this.currentRadius * 2, this.currentRadius * 2, false, f, "open"],
                                            t: "Debug"
                                        });
                                        this.toRender({
                                            p: ["drawArcText", b, this.cx, this.cy, this.currentRadius, a, d, this.axisTickFont, f, false, false, true],
                                            t: "Debug"
                                        });
                                        this.circularDebuggingCounter++
                                    }
                                };
                                this.setCircularXYDimensions = function() {
                                    if (!this.panningX) {
                                        this.panningX = 0
                                    }
                                    if (!this.panningY) {
                                        this.panningY = 0
                                    }
                                    this.x = this.width - (this.marginLeft + this.left + this.right + this.marginRight);
                                    this.y = this.height - (this.marginTop + this.top + this.bottom + this.marginBottom);
                                    this.r = (Math.min(this.x, this.y) / 2);
                                    this.padX = this.x > this.y ? (this.x - this.y) / 2 : 0;
                                    this.padY = this.x > this.y ? 0 : (this.y - this.x) / 2;
                                    this.cx = this.marginLeft + this.left + this.r + this.padX + this.panningX;
                                    this.cy = this.marginTop + this.top + this.r + this.padY + this.panningY;
                                    this.r *= this.zoom;
                                    this.d = this.r * 2
                                };
                                this.setCircularFonts = function() {
                                    if (this.autoScaleFont) {
                                        var a = Math.min(this.width, this.height) * (1 - this.percentAspectRatioPlotArea);
                                        this.setPropertyFontSize(a / 2, "varLabelFont");
                                        this.setPropertyFontSize(a / 2, "varTitleFont");
                                        this.setPropertyFontSize(a, "smpLabelFont");
                                        this.setPropertyFontSize(a, "smpTitleFont");
                                        this.setPropertyFontSize(a, "overlayFont");
                                        this.setAxisFont("NA", a / 1.33)
                                    }
                                };
                                this.getCircularLevelLabelLength = function() {
                                    if (!this.showIdeogram && this.segregateSamplesBy && this.segregateSamplesBy.length && this.circularType != "sunburst" && this.circularType != "bubble" && this.overlayLevelOrientation == "perpendicular") {
                                        return this.data.x && this.data.x.hasOwnProperty(this.segregateSamplesBy[0]) ? this.meta.data.x[this.segregateSamplesBy[0]].maxLevLen : 0
                                    } else {
                                        return 0
                                    }
                                };
                                this.getCircularSampleLabelLength = function() {
                                    if (this.showSampleNames && this.circularType != "sunburst" && this.circularType != "bubble") {
                                        if (this.smpLabelOrientation == "circular" && this.rAxisIndex < 0) {
                                            return this.getFontPt(this.smpLabelFont) + this.margin
                                        } else {
                                            if (this.meta.data.y.maxSmpChr > this.maxSmpStringLen) {
                                                return this.measureText(this.meta.data.y.maxSmpStr.substring(0, this.maxSmpStringLen), this.smpLabelFont) + this.margin
                                            } else {
                                                return this.measureText(this.meta.data.y.maxSmpStr, this.smpLabelFont) + this.margin
                                            }
                                        }
                                    } else {
                                        return 0
                                    }
                                };
                                this.getCircularVariableLabelLength = function() {
                                    if (this.showVariableNames && this.showIdeogram) {
                                        if (this.meta.data.y.maxVarChr > this.maxVarStringLen) {
                                            return this.measureText(this.meta.data.y.maxVarStr.substring(0, this.maxVarStringLen), this.varLabelFont) + this.margin
                                        } else {
                                            return this.measureText(this.meta.data.y.maxVarStr, this.varLabelFont) + this.margin
                                        }
                                    } else {
                                        return 0
                                    }
                                };
                                this.getCircularXAxisTickLength = function() {
                                    return this.measureText(this.xAxisMaxStrLength, this.axisTickFont)
                                };
                                this.getCircularRAxisTickLength = function() {
                                    if (this.rAxisTickFormat) {
                                        return this.measureText(this.formatAxisValue(this.rAxisMax, "rAxis"), this.axisTickFont)
                                    } else {
                                        return this.measureText(this.rAxisMaxStrLength, this.axisTickFont)
                                    }
                                };
                                this.getCircularRAxisPercentTickLength = function() {
                                    return this.rAxisPercentShow ? this.measureText("100%", this.axisTickFont) : 0
                                };
                                this.getArcSegmentsCenter = function() {
                                    if (this.circularType != "normal" || !this.xAxisShow || this.circularArc < 270) {
                                        return 0
                                    } else {
                                        if (this.xAxisShow) {
                                            return (this.margin * 1.5) + this.arcLengthToDegrees(this.r * this.circularCenterProportion * 2, this.getCircularXAxisTickLength())
                                        }
                                    }
                                };
                                this.getCircularPercentLength = function() {
                                    var a = 0;
                                    if (!this.showIdeogram && this.rAxisPercentShow && (this.rAxisIndex >= 0 || this.circularType == "chord")) {
                                        a = this.getCircularRAxisPercentTickLength() + (this.margin * 3)
                                    }
                                    return a
                                };
                                this.getCircularScalesLength = function(a) {
                                    var b = 0;
                                    if (this.showIdeogram) {
                                        b += (this.axisTickFontSize + this.margin) + (this.margin * 2 * (a ? 0 : 1))
                                    } else {
                                        if ((this.rAxisShow && this.rAxisIndex >= 0) || this.circularType == "chord") {
                                            if (this.rAxisLabelOrientation != "circular" && this.circularType != "chord") {
                                                b += this.axisTickFontSize + (this.margin * 4)
                                            } else {
                                                b += this.getCircularRAxisTickLength() + (this.margin * 4)
                                            }
                                        }
                                    }
                                    return b
                                };
                                this.getCircularDendrogramLength = function() {
                                    return this.smpDendrogram && this.showSmpDendrogram ? this.dendrogramHeight + this.margin : 0
                                };
                                this.getCircularIdeogramLength = function() {
                                    return this.showIdeogram ? this.overlaysThickness + this.margin : 0
                                };
                                this.getCircularOverlaysLength = function() {
                                    var a = 0;
                                    if (this.segregateSamplesBy.length > 0 && this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble" && !this.showIdeogram) {
                                        a += this.overlaysThickness
                                    }
                                    if (this.showOverlays && this.smpOverlays.length > 0 && this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble" && !this.showIdeogram) {
                                        if (this.rAxisIndex < 0) {
                                            for (var b = 0; b < this.smpOverlays.length; b++) {
                                                var c = this.smpOverlays[b];
                                                if (this.rAxisIndex < 0) {
                                                    if (c != "-") {
                                                        a += this.overlaysThickness
                                                    } else {
                                                        a += this.margin
                                                    }
                                                }
                                            }
                                        } else {
                                            if (this.showOverlays && this.varOverlays.length > 0 && this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble" && this.showIdeogram) {
                                                for (var b = 0; b < this.varOverlays.length; b++) {
                                                    var c = this.varOverlays[b];
                                                    if (this.rAxisIndex < 0) {
                                                        if (c != "-") {
                                                            a += this.overlaysThickness
                                                        } else {
                                                            a += this.margin
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    return a + (a > 0 ? this.margin : 0)
                                };
                                this.getCircularLabelsLength = function() {
                                    var a = 0;
                                    if (this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble") {
                                        if (this.showSampleNames && this.rAxisIndex < 0 && !this.showIdeogram) {
                                            if (this.smpLabelOrientation == "circular") {
                                                a += this.smpLabelFontSize + this.margin
                                            } else {
                                                a += this.getCircularSampleLabelLength()
                                            }
                                        } else {
                                            if (this.showSampleNames && this.rAxisIndex >= 0 && !this.showIdeogram) {
                                                a += this.getCircularSampleLabelLength() + this.circularAnchorLength + this.margin
                                            }
                                        }
                                    } else {
                                        if (this.showIdeogram && this.showVariableNames) {
                                            a += this.getCircularVariableLabelLength() + this.circularAnchorLength + this.margin
                                        }
                                    }
                                    return a
                                };
                                this.getCircularAnchorsLength = function() {
                                    var a = 0;
                                    if ((this.showIdeogram && this.showVariableNames) || (!this.showIdeogram && this.showSampleNames && this.rAxisIndex >= 0)) {
                                        a += this.circularAnchorLength + this.margin
                                    }
                                    return a
                                };
                                this.getNonDataRingLength = function() {
                                    var d = this;
                                    var a = this.cloneObject(this.ringsOrder);
                                    var e = function(f) {
                                        if (d.showIdeogram) {
                                            if (d.data.z && d.data.z.hasOwnProperty(f)) {
                                                if (!d.varOverlays.includes(f)) {
                                                    d.varOverlays.push(f)
                                                }
                                                return true
                                            }
                                        } else {
                                            if (d.data.x && d.data.x.hasOwnProperty(f)) {
                                                if (!d.smpOverlays.includes(f)) {
                                                    d.smpOverlays.push(f)
                                                }
                                                return true
                                            }
                                        }
                                        return false
                                    };
                                    var b = this.getCircularLevelLabelLength();
                                    for (var c = 0; c < a.length; c++) {
                                        switch (a[c]) {
                                            case "-":
                                                b += this.margin;
                                                break;
                                            case "percent":
                                                b += this.getCircularPercentLength();
                                                break;
                                            case "chromosomes":
                                            case "scale":
                                                b += this.getCircularScalesLength(a[c] == "chromosomes");
                                                break;
                                            case "dendrogram":
                                                b += this.getCircularDendrogramLength();
                                                break;
                                            case "ideogram":
                                                b += this.getCircularIdeogramLength();
                                                break;
                                            case "overlays":
                                                b += this.getCircularOverlaysLength();
                                                break;
                                            case "labels":
                                                b += this.getCircularLabelsLength();
                                                break;
                                            case "anchors":
                                            case "anchors2":
                                                b += this.getCircularAnchorsLength();
                                                break;
                                            case "data":
                                                b += 0;
                                                break;
                                            default:
                                                if (e(a[c])) {
                                                    b += this.overlaysThickness + this.margin
                                                }
                                                break
                                        }
                                    }
                                    return b
                                };
                                this.setIdeogram = function() {
                                    if (!CanvasXpress.chromosomes[this.ideogram].hasOwnProperty("max")) {
                                        CanvasXpress.chromosomes[this.ideogram].max = {}
                                    } else {
                                        return
                                    }
                                    var d = CanvasXpress.chromosomes[this.ideogram];
                                    for (var b = 0; b < d.order.length; b++) {
                                        var e = d.data[d.order[b]];
                                        var a = e.length - 1;
                                        d.max[d.order[b]] = d.data[d.order[b]][a][1]
                                    }
                                };
                                this.setCircularSampleData = function() {
                                    this.circularSampleData = !this.showIdeogram ? {} : false;
                                    this.circularSampleIndices = !this.showIdeogram ? [] : false;
                                    if (!this.showIdeogram) {
                                        var n = this;
                                        var b = {};
                                        var q = function(v, h) {
                                            var s = v;
                                            var i = n.round(v, 2);
                                            var x = n.round((i + 0.01) % (Math.PI * 2), 2);
                                            var u = n.round((i + 0.02) % (Math.PI * 2), 2);
                                            var j = 0;
                                            var d = 0;
                                            while (b[i] || b[x] || b[u]) {
                                                v = (v + 0.01) % (Math.PI * 2);
                                                i = n.round((i + 0.01) % (Math.PI * 2), 2);
                                                x = n.round((x + 0.01) % (Math.PI * 2), 2);
                                                u = n.round((u + 0.01) % (Math.PI * 2), 2);
                                                d++;
                                                if (d > 8) {
                                                    return Number.NaN
                                                }
                                            }
                                            b[i] = h;
                                            b[x] = h;
                                            b[u] = h;
                                            return v - s
                                        };
                                        var z = this.data.y.smps;
                                        var t = this.data.y.data;
                                        for (var g = 0; g < this.arcSegmentsSampleIndices.length; g++) {
                                            var o = [];
                                            if (this.rAxisIndex >= 0) {
                                                t = this.data.y.data[this.rAxisIndex];
                                                o = this.cloneObject(this.arcSegmentsSampleIndices[g]).sort(function(f, d) {
                                                    return t[f] - t[d]
                                                })
                                            } else {
                                                o = this.arcSegmentsSampleIndices[g]
                                            }
                                            var y = this.circularDataPosition == "absolute" ? this.rAxisUnit : this.arcSegmentsMax[g] * this.rAxisUnit / o.length;
                                            var k = y / 2;
                                            var p = this.rAxisIndex >= 0 ? this.rAxisUnit / 2 : 0;
                                            for (var e = 0; e < o.length; e++) {
                                                var c = z[o[e]];
                                                this.circularSampleIndices.push(o[e]);
                                                var w = this.rAxisUnit * (this.rAxisIndex >= 0 ? t[o[e]] : e);
                                                var a = (this.arcSegmentsDims[g][0] + w - p) % (Math.PI * 2);
                                                var m = q(a, c);
                                                this.circularSampleData[c] = {
                                                    idx: o[e],
                                                    seg: g,
                                                    raw: a,
                                                    mod: (!isNaN(m) ? a + m : Number.NaN),
                                                    dat: [a, a + y, a + k]
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setCircularVariableData = function() {
                                    this.circularVariableData = this.showIdeogram ? {} : false;
                                    this.circularVariableIndices = this.showIdeogram ? [] : false;
                                    if (this.showIdeogram) {
                                        var k = this;
                                        var e = {};
                                        var M = {};
                                        var d = function(u, b) {
                                            var i = u;
                                            var c = k.round(u, 2);
                                            var v = k.round((c + 0.01) % (Math.PI * 2), 2);
                                            var j = k.round((c + 0.02) % (Math.PI * 2), 2);
                                            var h = 0;
                                            var a = 0;
                                            while (e[c] || e[v] || e[j]) {
                                                u = (u + 0.01) % (Math.PI * 2);
                                                c = k.round((c + 0.01) % (Math.PI * 2), 2);
                                                v = k.round((v + 0.01) % (Math.PI * 2), 2);
                                                j = k.round((j + 0.01) % (Math.PI * 2), 2);
                                                a++;
                                                if (a > 8) {
                                                    return Number.NaN
                                                }
                                            }
                                            e[c] = b;
                                            e[v] = b;
                                            e[j] = b;
                                            return u - i
                                        };
                                        var o = this.data.y;
                                        var n = this.data.z;
                                        var N = n[this.ideogramChromosome];
                                        var t = [];
                                        for (var J = 0; J < N.length; J++) {
                                            t.push(N[J].toString().match(/x/i) ? 23 : N[J].toString().match(/y/i) ? 24 : N[J])
                                        }
                                        var F = n[this.ideogramChromosomePosition];
                                        var A = [];
                                        for (var J = 0; J < this.varIndices.length; J++) {
                                            var C = this.varIndices[J];
                                            A.push(o.vars[C])
                                        }
                                        var A = this.cloneObject(o.vars).sort(function(f, c) {
                                            var l = k.getVariableIndices(f);
                                            var h = k.getVariableIndices(c);
                                            return t[l] - t[h] || F[l] - F[h]
                                        });
                                        for (var J = 0; J < A.length; J++) {
                                            var H = A[J];
                                            var s = this.getVariableIndices(H);
                                            this.circularVariableIndices.push(s);
                                            var G = this.arcSegmentsRangeMap[N[s]];
                                            if (!M.hasOwnProperty(N[s])) {
                                                M[N[s]] = 0
                                            }
                                            M[N[s]]++;
                                            var D = (this.arcSegmentsDims[G][0] + (this.rAxisUnit * F[s])) % (Math.PI * 2);
                                            var L = d(D, H);
                                            this.circularVariableData[H] = {
                                                idx: s,
                                                seg: G,
                                                chr: N[s],
                                                raw: D,
                                                mod: !isNaN(L) ? D + L : Number.NaN
                                            }
                                        }
                                        var g = Math.PI * 2;
                                        for (var s in M) {
                                            var G = this.arcSegmentsRangeMap[s];
                                            var B = this.circularDataPosition == "absolute" ? this.rAxisUnit : this.arcSegmentsMax[G] * this.rAxisUnit / M[s];
                                            var K = B / 2;
                                            var P = this.arcSegmentsDims[G][0];
                                            var E = 0;
                                            for (var J = 0; J < A.length; J++) {
                                                var H = A[J];
                                                var I = this.circularVariableData[H].idx;
                                                var O = this.circularDataPosition == "absolute" ? P + (this.rAxisUnit * F[I]) : P + (B * E);
                                                if (N[I] == s) {
                                                    this.circularVariableData[H].dat = [O, (O + B), (O + K)];
                                                    E++
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setCircularArcSegments = function() {
                                    if (this.circularArc > 360) {
                                        this.circularArc = 360
                                    } else {
                                        if (this.circularArc < 90) {
                                            this.circularArc = 90
                                        }
                                    }
                                    this.rAxisIndex = this.rAxis ? this.getVariableIndices(this.rAxis) : -1;
                                    this.arcSegmentsCenter = this.getArcSegmentsCenter();
                                    var h = this.circularArc < 270 ? 1 : 0;
                                    var w = this.circularType != "normal" || this.circularArc < 270 ? 0 : this.xAxisShow ? ((this.arcSegmentsSeparation + this.arcSegmentsCenter) * Math.PI / 360) : 0;
                                    this.circularStart = (Math.PI * 1.5) + w + this.radians(this.circularRotate);
                                    this.arcSegments = [];
                                    this.arcSegmentsSampleIndices = [];
                                    this.arcSegmentsRange = [];
                                    this.arcSegmentsMin = [];
                                    this.arcSegmentsMax = [];
                                    this.arcSegmentsRangeMap = {};
                                    this.arcSegmentsDims = [];
                                    this.arcSegmentsNumber = 0;
                                    this.rAxisUnit = 1;
                                    this.maxRadiusFactor = 1;
                                    this.maxRadiusFactorInv = 1;
                                    if (this.circularType == "sunburst") {
                                        var u = this.createHierarchy(this.hierarchy);
                                        this.arcSegmentsMin.push(0);
                                        this.arcSegmentsMax.push(u[0].value);
                                        this.rAxisUnit = this.radians((this.circularArc - (this.arcSegmentsSeparation + this.arcSegmentsCenter)) / u[0].value);
                                        this.arcSegmentsRange.push(u[0].value);
                                        this.circularSunburst = u
                                    } else {
                                        if (this.circularType == "chord") {
                                            var v = this.circularStart;
                                            var G = this.circularChord;
                                            this.rAxisUnit = G.unit;
                                            for (var D = 0; D < G.segments.length; D++) {
                                                this.arcSegments.push(G.segments[D].value);
                                                this.arcSegmentsRangeMap[G.segments[D].name] = D;
                                                this.arcSegmentsMin[D] = 0;
                                                this.arcSegmentsMax[D] = G.segments[D].value;
                                                this.arcSegmentsRange.push(G.segments[D].value);
                                                this.arcSegmentsDims.push([(v + G.segments[D].start) % (Math.PI * 2), (v + G.segments[D].end) % (Math.PI * 2)])
                                            }
                                        } else {
                                            if (this.circularType == "bubble") {
                                                this.setCirclePack()
                                            } else {
                                                if (this.showIdeogram) {
                                                    this.setIdeogram();
                                                    var B = CanvasXpress.chromosomes[this.ideogram];
                                                    var q = 0;
                                                    var A = B.order.length;
                                                    for (var D = 0; D < A; D++) {
                                                        var G = B.order[D];
                                                        var F = B.data[G];
                                                        var z = B.max[G];
                                                        this.arcSegments.push(G);
                                                        this.arcSegmentsRangeMap[G] = D;
                                                        this.arcSegmentsMin[D] = 0;
                                                        this.arcSegmentsMax[D] = z;
                                                        this.arcSegmentsRange[D] = z;
                                                        q += z
                                                    }
                                                    this.rAxisUnit = this.radians((this.circularArc - ((this.arcSegmentsSeparation * (A - h)) + this.arcSegmentsCenter)) / q);
                                                    this.arcSegmentsNumber = A;
                                                    var v = this.circularStart;
                                                    for (var D = 0; D < A; D++) {
                                                        var E = this.rAxisUnit * this.arcSegmentsRange[D];
                                                        this.arcSegmentsDims.push([v % (Math.PI * 2), (v + E) % (Math.PI * 2)]);
                                                        v += E + this.radians(this.arcSegmentsSeparation)
                                                    }
                                                    this.circularEnd = (v - this.radians(this.arcSegmentsSeparation)) % (Math.PI * 2)
                                                } else {
                                                    if (this.segregateSamplesBy.length) {
                                                        var b = [];
                                                        var C = [];
                                                        var a = this.getSmpAnnotations(this.segregateSamplesBy[0], this.smpIndices).sort();
                                                        for (var D = 0; D < a.length; D++) {
                                                            this.arcSegments.push(a[D]);
                                                            this.arcSegmentsRangeMap[a[D]] = D;
                                                            var g = this.getSamplesByAnnotationLevel(this.segregateSamplesBy[0], a[D]);
                                                            this.arcSegmentsSampleIndices.push(g);
                                                            b = b.concat(g)
                                                        }
                                                        for (var D = 0; D < b.length; D++) {
                                                            if (this.hiddenSmps[b[D]]) {
                                                                C.push(true)
                                                            } else {
                                                                C.push(false)
                                                            }
                                                        }
                                                        this.smpIndices = b;
                                                        this.hiddenSmps = C;
                                                        if (this.rAxisIndex >= 0) {
                                                            var p = {};
                                                            var j = 0;
                                                            for (var D = 0; D < this.data.y.smps.length; D++) {
                                                                var v = this.getMetadataValue(D, "x", this.segregateSamplesBy[0]);
                                                                if (!p[v]) {
                                                                    p[v] = []
                                                                }
                                                                p[v].push(this.data.y.data[this.rAxisIndex][D])
                                                            }
                                                            for (var v in p) {
                                                                if (this.rAxisZero) {
                                                                    p[v].push(0)
                                                                }
                                                                var D = this.arcSegmentsRangeMap[v];
                                                                var f = this.range(p[v]);
                                                                this.arcSegmentsMin[D] = f[0];
                                                                this.arcSegmentsMax[D] = f[1];
                                                                if (this.rAxisZero) {
                                                                    j += f[1];
                                                                    this.arcSegmentsRange[D] = f[1]
                                                                } else {
                                                                    j += (f[1] - f[0]);
                                                                    this.arcSegmentsRange[D] = f[1] - f[0]
                                                                }
                                                            }
                                                            this.rAxisUnit = this.radians((this.circularArc - ((this.arcSegmentsSeparation * (this.arcSegmentsSampleIndices.length - h)) + this.arcSegmentsCenter)) / j)
                                                        } else {
                                                            this.rAxisUnit = this.radians((this.circularArc - ((this.arcSegmentsSeparation * (this.arcSegmentsSampleIndices.length - h)) + this.arcSegmentsCenter)) / this.data.y.smps.length);
                                                            var v = this.circularStart;
                                                            for (var D = 0; D < this.arcSegmentsSampleIndices.length; D++) {
                                                                this.arcSegmentsMin[D] = 0;
                                                                this.arcSegmentsMax[D] = this.arcSegmentsSampleIndices[D].length;
                                                                this.arcSegmentsRange[D] = this.arcSegmentsSampleIndices[D].length
                                                            }
                                                        }
                                                        var v = this.circularStart;
                                                        for (var k = 0; k < a.length; k++) {
                                                            var x = a[k];
                                                            var D = this.arcSegmentsRangeMap[x];
                                                            var y = this.rAxisIndex >= 0 ? this.arcSegmentsRange[D] : this.arcSegmentsSampleIndices[D].length;
                                                            var E = this.rAxisUnit * y;
                                                            this.arcSegmentsDims.push([v % (Math.PI * 2), (v + E) % (Math.PI * 2)]);
                                                            v += E + this.radians(this.arcSegmentsSeparation)
                                                        }
                                                        this.circularEnd = (v - this.radians(this.arcSegmentsSeparation)) % (Math.PI * 2)
                                                    } else {
                                                        this.arcSegments = false;
                                                        this.arcSegmentsSampleIndices = [this.smpIndices];
                                                        if (this.rAxisIndex >= 0) {
                                                            var f = this.range(this.data.y.data[this.rAxisIndex]);
                                                            this.arcSegmentsMin.push(f[0]);
                                                            this.arcSegmentsMax.push(f[1]);
                                                            if (this.rAxisZero) {
                                                                this.rAxisUnit = this.radians((this.circularArc - (this.arcSegmentsSeparation + this.arcSegmentsCenter)) / f[1]);
                                                                this.arcSegmentsRange.push(f[1])
                                                            } else {
                                                                this.rAxisUnit = this.radians((this.circularArc - (this.arcSegmentsSeparation + this.arcSegmentsCenter)) / (f[1] - f[0]));
                                                                this.arcSegmentsRange.push(f[1] - f[0])
                                                            }
                                                        } else {
                                                            this.rAxisUnit = this.radians((this.circularArc - (this.arcSegmentsSeparation + this.arcSegmentsCenter)) / this.data.y.smps.length);
                                                            var v = this.circularStart;
                                                            for (var D = 0; D < this.arcSegmentsSampleIndices.length; D++) {
                                                                this.arcSegmentsMin[D] = 0;
                                                                this.arcSegmentsMax[D] = this.arcSegmentsSampleIndices[D].length;
                                                                this.arcSegmentsRange[D] = this.arcSegmentsSampleIndices[D].length
                                                            }
                                                        }
                                                        var E = this.rAxisUnit * (this.rAxisIndex >= 0 ? this.arcSegmentsRange[0] : this.smpIndices.length);
                                                        this.arcSegmentsDims.push([this.circularStart % (Math.PI * 2), (this.circularStart + E) % (Math.PI * 2)]);
                                                        this.circularEnd = (this.circularStart + E) % (Math.PI * 2)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    this.arcSegmentsNumber = this.showIdeogram ? CanvasXpress.chromosomes[this.ideogram].order.length : this.circularType == "chord" ? this.circularChord.segments.length : this.arcSegmentsSampleIndices.length;
                                    this.currentRadius = this.r * 1;
                                    if (this.arcSegmentsRadius && this.arcSegmentsRadius.length > 0) {
                                        for (var D = this.arcSegmentsRadius.length; D < this.arcSegmentsNumber; D++) {
                                            this.arcSegmentsRadius.push(1)
                                        }
                                        this.maxRadiusFactor = this.max(this.arcSegmentsRadius)
                                    } else {
                                        for (var D = 0; D < this.arcSegmentsNumber; D++) {
                                            this.arcSegmentsRadius.push(1)
                                        }
                                    }
                                    if (this.maxRadiusFactor != 1) {
                                        for (var D = 0; D < this.arcSegmentsNumber; D++) {
                                            this.arcSegmentsRadius[D] /= this.maxRadiusFactor
                                        }
                                    }
                                    this.maxRadiusFactorInv = 1 / this.maxRadiusFactor;
                                    this.setCircularVariableData();
                                    this.setCircularSampleData()
                                };
                                this.setCircularRings = function() {
                                    this.ringsVarIndices = [];
                                    this.ringsSmpIndices = [];
                                    this.ringLength = [];
                                    this.ringMap = {};
                                    var g = ["percent", "scale", "dendrogram", "ideogram", "overlays", "labels", "anchors", "data"];
                                    if (this.rAxisIndex >= 0) {
                                        this.ringsVarIndices.push([this.rAxisIndex])
                                    }
                                    if (this.circularType == "sunburst" || this.circularType == "bubble") {
                                        var k = this.hierarchyVar ? this.getVariableIndices(this.hierarchyVar) : 0;
                                        this.hierarchyVarIndex = k >= 0 ? k : 0;
                                        this.ringsVarIndices.push(this.hierarchyVarIndex);
                                        this.ringGraphWeight[0] = 1;
                                        this.ringsOrder = g;
                                        this.ringNumber = 1
                                    } else {
                                        if (this.circularType == "chord") {
                                            this.ringsVarIndices.push(this.varIndices);
                                            this.ringGraphWeight[0] = 1;
                                            this.ringsOrder = g;
                                            this.ringNumber = 1
                                        } else {
                                            var c;
                                            var n;
                                            if (this.ringsOrder.length > 0) {
                                                if (this.showIdeogram && this.segregateSamplesBy.length > 0) {
                                                    n = this.meta.data.x[this.segregateSamplesBy[0]].order
                                                } else {
                                                    if (this.segregateVariablesBy.length > 0) {
                                                        n = this.meta.data.z[this.segregateVariablesBy[0]].order
                                                    }
                                                }
                                                if (n) {
                                                    for (var k = 0; k < this.ringsOrder.length; k++) {
                                                        if (n.hasOwnProperty(this.ringsOrder[k])) {
                                                            if (!c) {
                                                                c = {}
                                                            }
                                                            c[this.ringsOrder[k]] = true
                                                        }
                                                    }
                                                }
                                            } else {
                                                this.ringsOrder = g
                                            }
                                            if (this.showIdeogram) {
                                                if (this.segregateSamplesBy.length > 0) {
                                                    var a = {};
                                                    for (var k = 0; k < this.data.x[this.segregateSamplesBy[0]].length; k++) {
                                                        var h = this.getMetadataValue(k, "x", this.segregateSamplesBy[0]);
                                                        if (!a[h]) {
                                                            if (c) {
                                                                if (c.hasOwnProperty(h)) {
                                                                    this.ringMap[h] = this.ringsSmpIndices.length;
                                                                    this.ringsSmpIndices.push(this.getSamplesByAnnotationLevel(this.segregateSamplesBy[0], h))
                                                                }
                                                            } else {
                                                                this.ringMap[h] = this.ringsSmpIndices.length;
                                                                this.ringsSmpIndices.push(this.getSamplesByAnnotationLevel(this.segregateSamplesBy[0], h))
                                                            }
                                                            a[h] = true
                                                        }
                                                    }
                                                } else {
                                                    var b = [];
                                                    for (var k = 0; k < this.smpIndices.length; k++) {
                                                        b.push(this.smpIndices[k])
                                                    }
                                                    this.ringsSmpIndices.push(b)
                                                }
                                            } else {
                                                if (this.segregateVariablesBy.length > 0) {
                                                    var a = {};
                                                    for (var k = 0; k < this.data.z[this.segregateVariablesBy[0]].length; k++) {
                                                        if (this.rAxisIndex >= 0 && k == this.rAxisIndex) {
                                                            continue
                                                        }
                                                        var h = this.getMetadataValue(k, "z", this.segregateVariablesBy[0]);
                                                        if (!a[h]) {
                                                            if (c) {
                                                                if (c.hasOwnProperty(h)) {
                                                                    this.ringMap[h] = this.ringsVarIndices.length;
                                                                    this.ringsVarIndices.push(this.getVariablesByAnnotationLevel(this.segregateVariablesBy[0], h))
                                                                }
                                                            } else {
                                                                this.ringMap[h] = this.ringsVarIndices.length;
                                                                this.ringsVarIndices.push(this.getVariablesByAnnotationLevel(this.segregateVariablesBy[0], h))
                                                            }
                                                            a[h] = true
                                                        }
                                                    }
                                                } else {
                                                    var b = [];
                                                    var f = 0;
                                                    for (var k = 0; k < this.varIndices.length; k++) {
                                                        if (this.rAxisIndex >= 0 && k == this.rAxisIndex) {
                                                            continue
                                                        }
                                                        b.push(this.varIndices[k])
                                                    }
                                                    this.ringsVarIndices.push(b)
                                                }
                                            }
                                            this.ringNumber = this.showIdeogram ? this.ringsSmpIndices.length : this.ringsVarIndices.length;
                                            if (this.ringGraphType.length < this.ringNumber) {
                                                for (var k = this.ringGraphType.length; k < this.ringNumber; k++) {
                                                    this.ringGraphType.push(this.showIdeogram ? "heatmap" : this.circularType == "radar" ? "line" : "dot")
                                                }
                                            }
                                            if (this.ringGraphWeight && this.ringGraphWeight.length > 0) {
                                                while (this.ringGraphWeight.length != this.ringNumber) {
                                                    if (this.ringGraphWeight.length > this.ringNumber) {
                                                        this.ringGraphWeight.pop()
                                                    } else {
                                                        this.ringGraphWeight.push(this.ringGraphWeight[this.ringGraphWeight.length - 1])
                                                    }
                                                }
                                                for (var k = 0; k < this.ringNumber; k++) {
                                                    if (this.rAxisShow && this.rAxisIndex >= 0 && k == this.rAxisIndex) {
                                                        this.ringGraphWeight[k] = 0
                                                    }
                                                }
                                            } else {
                                                this.ringGraphWeight = [];
                                                for (var k = 0; k < this.ringNumber; k++) {
                                                    if (this.rAxisShow && this.rAxisIndex >= 0 && k == this.rAxisIndex) {
                                                        this.ringGraphWeight.push(0)
                                                    } else {
                                                        this.ringGraphWeight.push(1)
                                                    }
                                                }
                                            }
                                            var o = 0;
                                            for (var k = 0; k < this.ringGraphWeight.length; k++) {
                                                if (!this.showIdeogram) {
                                                    if (this.ringsVarIndices[k].length < 1) {
                                                        continue
                                                    }
                                                } else {
                                                    if (this.ringsSmpIndices[k].length < 1) {
                                                        continue
                                                    }
                                                }
                                                o += parseFloat(this.ringGraphWeight[k])
                                            }
                                            if (o == 0) {
                                                o = 1
                                            }
                                            for (var k = 0; k < this.ringGraphWeight.length; k++) {
                                                this.ringGraphWeight[k] /= o
                                            }
                                        }
                                    }
                                    var j = this.getNonDataRingLength();
                                    var m = this.circularCenterProportion * this.r;
                                    var d = this.ringSeparation * (this.ringNumber - (this.rAxisIndex >= 0 ? 2 : 1));
                                    var e = this.r - (j + m + d);
                                    for (var k = 0; k < this.ringNumber; k++) {
                                        if (!this.showIdeogram) {
                                            if (this.ringsVarIndices[k].length < 1) {
                                                this.ringLength.push(0)
                                            } else {
                                                this.ringLength.push(this.ringGraphWeight[k] * e)
                                            }
                                        } else {
                                            if (this.ringsSmpIndices[k].length < 1) {
                                                this.ringLength.push(0)
                                            } else {
                                                this.ringLength.push(this.ringGraphWeight[k] * e)
                                            }
                                        }
                                    }
                                };
                                this.renderCircularPlot = function() {
                                    var c = this;
                                    var a = this.cloneObject(this.ringsOrder);
                                    var d = function(f) {
                                        return c.showIdeogram ? c.varOverlays.includes(f) : c.smpOverlays.includes(f)
                                    };
                                    var e = function(g) {
                                        var f = c.showIdeogram ? c.meta.data.x[c.segregateSamplesBy[0]] : c.meta.data.z[c.segregateVariablesBy[0]];
                                        return f.levels.includes(g) && f.order && f.order.hasOwnProperty(g)
                                    };
                                    this.ringInfo = [];
                                    for (var b = 0; b < a.length; b++) {
                                        switch (a[b]) {
                                            case "-":
                                                this.currentRadius -= this.margin;
                                                break;
                                            case "percent":
                                                this.drawCircularPercentRadialAxis();
                                                break;
                                            case "chromosomes":
                                            case "scale":
                                                this.drawCircularRadialAxis(a[b] == "chromosomes");
                                                break;
                                            case "dendrogram":
                                                this.drawCircularDendrogram();
                                                break;
                                            case "ideogram":
                                                this.drawCircularIdeogram();
                                                break;
                                            case "overlays":
                                                this.drawCircularOverlays();
                                                break;
                                            case "labels":
                                                this.drawCircularVariableLabels();
                                                this.drawCircularSampleLabels();
                                                break;
                                            case "anchors":
                                            case "anchors2":
                                                this.drawCircularAnchors(a[b]);
                                                break;
                                            case "data":
                                                switch (this.circularType) {
                                                    case "sunburst":
                                                        this.drawCircularSunburst();
                                                        break;
                                                    case "chord":
                                                        this.drawCircularChord();
                                                        break;
                                                    case "bubble":
                                                        this.drawCircularBubble();
                                                        break;
                                                    default:
                                                        this.drawCircularData();
                                                        break
                                                }
                                                break;
                                            default:
                                                if (d(a[b])) {
                                                    if (this.showIdeogram) {
                                                        this.drawCircularVariableOverlay(a[b])
                                                    } else {
                                                        this.drawCircularSampleOverlay(a[b])
                                                    }
                                                    this.currentRadius -= this.margin
                                                } else {
                                                    if (e(a[b])) {
                                                        this.drawCircularDataRing(a[b])
                                                    }
                                                }
                                                break
                                        }
                                        this.ringInfo.push(this.currentRadius)
                                    }
                                    this.drawCircularHandles()
                                };
                                this.drawCircularHandles = function() {
                                    if (this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble" && this.circularType != "radar") {
                                        var f = this.arcSegmentsRange.length - 1;
                                        var h = this.arcSegmentsDims[f][1] % (Math.PI * 2);
                                        var j = this.arcSegmentsDims[0][0] % (Math.PI * 2);
                                        var d = this.arcSegmentsRadius[0];
                                        for (var g = 0; g < this.ringInfo.length; g++) {
                                            var c, b;
                                            if (g == 0) {
                                                c = Math.max(0, this.r - (this.ringInfo[g] + this.margin));
                                                b = "Ring:" + g + ":Drag " + this.ringsOrder[g] + " in";
                                                this.toRender({
                                                    p: ["drawShape", "arc2", this.cx, this.cy, c, this.r * d, false, "rgba(0,0,0,0)", "open", false, false, false, false, h, j],
                                                    a: this.getShapeArea("arc2", this.cx, this.cy, c, this.r * d, false, "rgba(0,0,0,0)", "open", false, false, false, false, h, j),
                                                    i: [b],
                                                    t: "Axes"
                                                })
                                            } else {
                                                c = Math.max(0, this.ringInfo[g - 1] - (this.ringInfo[g] + this.margin));
                                                b = "Ring:" + g + ":Drag " + this.ringsOrder[g] + " in/out";
                                                this.toRender({
                                                    p: ["drawShape", "arc2", this.cx, this.cy, c, this.ringInfo[g - 1] * d, false, "rgba(0,0,0,0)", "open", false, false, false, false, h, j],
                                                    a: this.getShapeArea("arc2", this.cx, this.cy, c, this.ringInfo[g - 1] * d, false, "rgba(0,0,0,0)", "open", false, false, false, false, h, j),
                                                    i: [b],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    }
                                };
                                this.drawCircularPercentRadialAxis = function() {
                                    if (!this.showIdeogram && this.rAxisPercentShow && (this.rAxisIndex >= 0 || this.circularType == "chord")) {
                                        this.drawCircularElement("drawCircularPercentRadialAxis");
                                        var v = this.getCircularRAxisPercentTickLength();
                                        var h = "1px " + this.fontName;
                                        this.currentRadius -= (this.circularScalesAlign == "outside" ? (this.margin * 2) : v);
                                        var d = this.currentRadius - ((this.circularScalesAlign == "outside" ? (-this.margin * 3) : 0) + (this.margin * 1));
                                        var c = this.currentRadius - ((this.circularScalesAlign == "outside" ? (-this.margin * 3) : 0) + (this.margin * 2));
                                        for (var w = 0; w < this.arcSegmentsRange.length; w++) {
                                            var n = this.arcSegmentsRadius[w];
                                            var z = this.arcSegmentsDims[w][0];
                                            var e = (this.arcSegmentsDims[w][1] - this.arcSegmentsDims[w][0]) < 0 ? (this.arcSegmentsDims[w][1] - this.arcSegmentsDims[w][0]) + (Math.PI * 2) : this.arcSegmentsDims[w][1] - this.arcSegmentsDims[w][0];
                                            var o = e < 0.003 ? [0.5] : e < 0.03 ? [0, 1] : e < 0.15 ? [0, 0.5, 1] : [0, 0.2, 0.4, 0.6, 0.8, 1];
                                            var f = e < 0.003 ? 1 : e < 0.03 ? 0.2 : e < 0.15 ? 0.1 : 0.02;
                                            var s = e < 0.003 ? 1 : e < 0.03 ? 1 : e < 0.15 ? 5 : 10;
                                            for (var u = 0; u < o.length; u++) {
                                                var g = (z + (e * o[u])) % (Math.PI * 2);
                                                var A = (o[u] * 100) + "%";
                                                var m = ((this.currentRadius * n) * Math.cos(g)) + this.cx;
                                                var l = ((this.currentRadius * n) * Math.sin(g)) + this.cy;
                                                for (var t = 0; t < s; t++) {
                                                    if (o[u] < 1 || t == 0) {
                                                        var q = g + (t * f * e);
                                                        var b = d * n * Math.cos(q) + this.cx;
                                                        var r = d * n * Math.sin(q) + this.cy;
                                                        var a = c * n * Math.cos(q) + this.cx;
                                                        var p = c * n * Math.sin(q) + this.cy;
                                                        this.toRender({
                                                            p: ["drawLine", "lineR", b, r, a, p, this.rAxisTickColor, this.outlineWidth],
                                                            b: [this.cx, this.cy],
                                                            t: "Axes"
                                                        })
                                                    }
                                                }
                                                if (g >= (Math.PI * 1.5) || g <= Math.PI / 2) {
                                                    this.toRender({
                                                        p: ["drawText", A, m, l, this.axisTickFont, this.axisTickColor, this.circularScalesAlign == "outside" ? "right" : "left", "middle", g],
                                                        b: [this.cx, this.cy, h],
                                                        t: "Axes"
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", A, m, l, this.axisTickFont, this.axisTickColor, this.circularScalesAlign == "outside" ? "left" : "right", "middle", g + Math.PI],
                                                        b: [this.cx, this.cy, h],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                        this.currentRadius -= (this.circularScalesAlign == "outside" ? v + this.margin : (this.margin * 3))
                                    }
                                };
                                this.drawCircularRadialAxis = function(R) {
                                    if (this.showIdeogram) {
                                        this.drawCircularElement("drawCircularRadialAxis");
                                        var w = this.circularScalesAlign == "outside";
                                        var z = R ? 0 : 1;
                                        this.currentRadius -= (w ? (this.margin * 2 * z) : this.axisTickFontSize);
                                        var f = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * (w ? 1 : 0)));
                                        var e = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * (w ? 2 : 1)));
                                        for (var K = 0; K < this.arcSegmentsRange.length; K++) {
                                            var P = this.arcSegmentsRadius[K];
                                            var u = this.arcSegmentsDims[K][0];
                                            var N = this.arcSegments[K].toString();
                                            var F = (this.arcSegmentsDims[K][0] + (this.rAxisUnit * this.arcSegmentsRange[K] * 0.5)) % (Math.PI * 2);
                                            var B = w ? 0 : this.axisTickFontSize;
                                            this.toRender({
                                                p: ["drawArcText", N, this.cx, this.cy, (this.currentRadius * P) + B, F - (this.rAxisUnit * this.axisTickFontSize / 7), this.rAxisUnit * this.axisTickFontSize / 3.5, this.axisTickFont, this.rAxisTickColor, false, false, true],
                                                a: this.getArcTextArea(N, this.cx, this.cy, (this.currentRadius * P) + B, F - (this.rAxisUnit * this.axisTickFontSize / 7), this.rAxisUnit * this.axisTickFontSize / 3.5, this.axisTickFont, this.rAxisTickColor, false, false, true),
                                                i: ["ChrLbl" + K],
                                                t: "Axes"
                                            });
                                            if (!R) {
                                                var v = [0, 0.2, 0.4, 0.6, 0.8, 1];
                                                for (var H = 0; H < v.length; H++) {
                                                    var A = (u + ((this.arcSegmentsRange[K] * v[H]) * this.rAxisUnit)) % (Math.PI * 2);
                                                    var d = (f * P * Math.cos(A)) + this.cx;
                                                    var E = (f * P * Math.sin(A)) + this.cy;
                                                    var b = (e * P * Math.cos(A)) + this.cx;
                                                    var D = (e * P * Math.sin(A)) + this.cy;
                                                    this.toRender({
                                                        p: ["drawLine", "lineR", d, E, b, D, this.rAxisTickColor, this.outlineWidth],
                                                        b: [this.cx, this.cy],
                                                        t: "Axes"
                                                    })
                                                }
                                            }
                                        }
                                        if (R) {
                                            this.currentRadius -= (w ? this.axisTickFontSize + this.margin : this.margin)
                                        } else {
                                            this.currentRadius -= (w ? this.axisTickFontSize + this.margin : (this.margin * 3))
                                        }
                                    } else {
                                        if ((this.rAxisShow && this.rAxisIndex >= 0) || this.circularType == "chord") {
                                            this.drawCircularElement("drawCircularRadialAxis");
                                            if (this.rAxisLabelOrientation != "circular" && this.circularType != "chord") {
                                                var Q = this.rAxisUnit;
                                                var w = this.circularScalesAlign == "outside";
                                                this.currentRadius -= (w ? (this.margin * 3) : this.axisTickFontSize);
                                                var f = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * (w ? 2 : 0)));
                                                var O = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * 1));
                                                var e = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * (w ? 0 : 2)));
                                                for (var K = 0; K < this.arcSegmentsRange.length; K++) {
                                                    var t = this.arcSegmentsRadius[K];
                                                    var M = this.arcSegmentsDims[K][0];
                                                    var g = (this.arcSegmentsDims[K][1] - this.arcSegmentsDims[K][0]) < 0 ? (this.arcSegmentsDims[K][1] - this.arcSegmentsDims[K][0]) + (Math.PI * 2) : this.arcSegmentsDims[K][1] - this.arcSegmentsDims[K][0];
                                                    var v = this[this.axisAlgorithm](this.arcSegmentsMin[K], this.arcSegmentsMax[K], this.rAxisTicks, this.axisWilkinsonLoose);
                                                    var h = (v[1] - v[0]) / this.rAxisTicks;
                                                    for (var H = 0; H < v.length; H++) {
                                                        if (v[H] <= this.arcSegmentsMax[K]) {
                                                            var L = this.rAxisTickFormat ? this.measureText(this.formatAxisValue(v[H], "rAxis"), this.axisTickFont) : this.measureText(v[H].toString(), this.axisTickFont);
                                                            var l = (M + (this.rAxisUnit * v[H])) % (Math.PI * 2);
                                                            var S = this.rAxisTickFormat ? this.formatAxisValue(v[H], "rAxis") : v[H];
                                                            var J = w ? 0 : (this.axisTickFontSize / 2) + this.margin;
                                                            if (this.rAxisMajorTicks && (g > 0.15 || H == parseInt(v.length / 2))) {
                                                                var d = (f * t * Math.cos(l)) + this.cx;
                                                                var E = (f * t * Math.sin(l)) + this.cy;
                                                                var b = (e * t * Math.cos(l)) + this.cx;
                                                                var D = (e * t * Math.sin(l)) + this.cy;
                                                                this.toRender({
                                                                    p: ["drawLine", "lineR", d, E, b, D, this.rAxisTickColor, this.outlineWidth],
                                                                    b: [this.cx, this.cy],
                                                                    t: "Axes"
                                                                })
                                                            } else {
                                                                if (this.rAxisMajorTicks && g > 0.003) {
                                                                    var d = (O * t * Math.cos(l)) + this.cx;
                                                                    var E = (O * t * Math.sin(l)) + this.cy;
                                                                    var b = (e * t * Math.cos(l)) + this.cx;
                                                                    var D = (e * t * Math.sin(l)) + this.cy;
                                                                    this.toRender({
                                                                        p: ["drawLine", "lineR", d, E, b, D, this.rAxisTickColor, this.outlineWidth],
                                                                        b: [this.cx, this.cy],
                                                                        t: "Axes"
                                                                    })
                                                                }
                                                            }
                                                            if (this.rAxisMinorTicks && g > 0.03) {
                                                                for (var G = 1; G < this.rAxisTicks; G++) {
                                                                    if (v[H] + (h * G) < this.arcSegmentsMax[K]) {
                                                                        var C = (M + (this.rAxisUnit * (v[H] + (h * G)))) % (Math.PI * 2);
                                                                        var d = (O * t * Math.cos(C)) + this.cx;
                                                                        var E = (O * t * Math.sin(C)) + this.cy;
                                                                        var b = (e * t * Math.cos(C)) + this.cx;
                                                                        var D = (e * t * Math.sin(C)) + this.cy;
                                                                        this.toRender({
                                                                            p: ["drawLine", "lineR", d, E, b, D, this.rAxisTickColor, this.outlineWidth],
                                                                            b: [this.cx, this.cy],
                                                                            t: "Axes"
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                            if (g > 0.15 || H == parseInt(v.length / 2)) {
                                                                this.toRender({
                                                                    p: ["drawArcText", S, this.cx, this.cy, (this.currentRadius * t) + J, l - (Q * L / 7), Q * L / 3.5, this.axisTickFont, this.rAxisTickColor, false, false, true],
                                                                    a: this.getArcTextArea(S, this.cx, this.cy, (this.currentRadius * t) + J, l - (Q * L / 7), Q * L / 3.5, this.axisTickFont, this.rAxisTickColor, false, false, true),
                                                                    i: ["RadialSeg:" + K + ":" + H],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                                this.currentRadius -= (this.circularScalesAlign == "outside" ? this.axisTickFontSize + this.margin : (this.margin * 4))
                                            } else {
                                                var I = this.getCircularRAxisTickLength();
                                                var w = this.circularScalesAlign == "outside";
                                                this.currentRadius -= (w ? (this.margin * 3) : I - this.margin);
                                                var f = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * (w ? 2 : 0)));
                                                var O = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * 1));
                                                var e = this.currentRadius - ((w ? (-this.margin * 3) : this.margin) + (this.margin * (w ? 0 : 2)));
                                                var n = "1px " + this.fontName;
                                                for (var K = 0; K < this.arcSegmentsRange.length; K++) {
                                                    var t = this.arcSegmentsRadius[K];
                                                    var M = this.arcSegmentsDims[K][0] + (Math.PI * 2);
                                                    var v = this[this.axisAlgorithm](this.arcSegmentsMin[K], this.arcSegmentsMax[K], this.rAxisTicks, this.axisWilkinsonLoose);
                                                    var h = (v[1] - v[0]) / this.rAxisTicks;
                                                    for (var H = 0; H < v.length; H++) {
                                                        if (v[H] <= this.arcSegmentsMax[K]) {
                                                            var l = (M + (this.rAxisUnit * v[H])) % (Math.PI * 2);
                                                            var S = this.rAxisTickFormat ? this.formatAxisValue(v[H], "rAxis") : v[H];
                                                            var p = ((this.currentRadius * t) * Math.cos(l)) + this.cx;
                                                            var o = ((this.currentRadius * t) * Math.sin(l)) + this.cy;
                                                            if (this.rAxisMinorTicks) {
                                                                for (var G = 0; G < this.rAxisTicks; G++) {
                                                                    if (v[H] + (h * G) < this.arcSegmentsMax[K]) {
                                                                        var C = (M + (this.rAxisUnit * (v[H] + (h * G)))) % (Math.PI * 2);
                                                                        var d = (O * t * Math.cos(C)) + this.cx;
                                                                        var E = (O * t * Math.sin(C)) + this.cy;
                                                                        var b = (e * t * Math.cos(C)) + this.cx;
                                                                        var D = (e * t * Math.sin(C)) + this.cy;
                                                                        this.toRender({
                                                                            p: ["drawLine", "lineR", d, E, b, D, this.rAxisTickColor, this.outlineWidth],
                                                                            b: [this.cx, this.cy],
                                                                            t: "Axes"
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                            if (this.rAxisMajorTicks) {
                                                                var d = (f * t * Math.cos(l)) + this.cx;
                                                                var E = (f * t * Math.sin(l)) + this.cy;
                                                                var b = (e * t * Math.cos(l)) + this.cx;
                                                                var D = (e * t * Math.sin(l)) + this.cy;
                                                                this.toRender({
                                                                    p: ["drawLine", "lineR", d, E, b, D, this.rAxisTickColor, this.outlineWidth],
                                                                    b: [this.cx, this.cy],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                            if (l >= (Math.PI * 1.5) || l <= Math.PI / 2) {
                                                                this.toRender({
                                                                    p: ["drawText", S, p, o, this.axisTickFont, this.axisTickColor, w ? "right" : "left", "middle", l],
                                                                    b: [this.cx, this.cy, n],
                                                                    t: "Axes"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawText", S, p, o, this.axisTickFont, this.axisTickColor, w ? "left" : "right", "middle", l + Math.PI],
                                                                    b: [this.cx, this.cy, n],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                                this.currentRadius -= (this.circularScalesAlign == "outside" ? I + this.margin : (this.margin * 4))
                                            }
                                        }
                                    }
                                };
                                this.drawCircularDendrogram = function() {
                                    if (this.smpDendrogram && this.showSmpDendrogram) {
                                        this.drawCircularElement("drawCircularDendrogram");
                                        var k = this;
                                        var m = this.smpDendrogram;
                                        var o = this.dendrogramHeight / m.max;
                                        var i = this.rAxisUnit / 2;
                                        var v = this.arcSegmentsDims[0][0];
                                        var g = this.arcSegmentsSampleIndices[0].length - 1;
                                        var r = (this.arcSegmentsDims[0][1] - this.rAxisUnit) - v;
                                        if (r < 0) {
                                            r += (Math.PI * 2)
                                        }
                                        var j = r / g;
                                        var b = this.currentRadius - this.dendrogramHeight;
                                        var a = k.smpDendrogramPosition != "inside";
                                        var c = 0;
                                        var n = function(f) {
                                            if (f.children) {
                                                for (var d = 0; d < f.children.length; d++) {
                                                    n(f.children[d]);
                                                    if (f.children[d].children) {
                                                        f.children[d].color = f.children[d].children[0].color
                                                    }
                                                }
                                            } else {
                                                f.color = k.getDendrogramColor(false, f.name)
                                            }
                                            if (f.mid != null) {
                                                f.r = a ? k.currentRadius - (o * f.depth) : b + (o * f.depth);
                                                f.p = (f.mid * j) + v + i;
                                                f.x = k.cx + (f.r * Math.cos(f.p));
                                                f.y = k.cy + (f.r * Math.sin(f.p))
                                            }
                                        };
                                        var e = function(x, s) {
                                            if (x.children) {
                                                var C = x.x;
                                                var l = x.y;
                                                var y = x.color;
                                                var f = x.children[0].p;
                                                var A = x.children[0].r;
                                                var B = k.cx + (A * Math.cos(x.p));
                                                var h = k.cy + (A * Math.sin(x.p));
                                                var t = k.toRender({
                                                    p: ["drawLine", "lineR", C, l, B, h, y, false, "butt"],
                                                    a: k.getLineArea("lineR", C, l, B, h, y, false, "butt"),
                                                    i: ["smpDendrogram:" + c++ + ":" + x.nodeId],
                                                    t: "smpDendrogram"
                                                });
                                                for (var z = 0; z < x.children.length; z++) {
                                                    var w = x.children[z].x;
                                                    var E = x.children[z].y;
                                                    var D = x.children[z].p;
                                                    var u = x.children[z].r;
                                                    var q = x.children[z].color;
                                                    k.toRender({
                                                        p: ["drawLine", "arc", k.cx, k.cy, u, u, q, false, false, f, D],
                                                        a: k.getLineArea("arc", k.cx, k.cy, u, u, q, false, false, f, D),
                                                        i: ["smpDendrogram:" + c++ + ":" + x.nodeId],
                                                        g: t,
                                                        t: "smpDendrogram"
                                                    });
                                                    f = D;
                                                    e(x.children[z], t)
                                                }
                                                if (x.nodeId != null && x.children.length > 1) {
                                                    var d = x.name ? x.name : "";
                                                    var p = x.depth;
                                                    k.toRender({
                                                        p: ["drawShape", "circle", w, E, k.margin * 2, k.margin * 2, "rgba(0,0,0,0)", "rgba(0,0,0,0)"],
                                                        a: k.getLineArea("circle", w, E, k.margin * 2, k.margin * 2, "rgba(0,0,0,0)", "rgba(0,0,0,0)"),
                                                        i: [x.nodeId + "-" + p + "-smpDendrogram-" + d],
                                                        t: "smpDendrogram"
                                                    })
                                                }
                                            } else {
                                                var C = x.x;
                                                var l = x.y;
                                                var y = x.color;
                                                var A = a ? k.currentRadius - k.dendrogramHeight : b + k.dendrogramHeight;
                                                var B = k.cx + (A * Math.cos(x.p));
                                                var h = k.cy + (A * Math.sin(x.p));
                                                k.toRender({
                                                    p: ["drawLine", "lineR", C, l, B, h, y, false, "butt"],
                                                    a: k.getLineArea("lineR", C, l, B, h, y, false, "butt"),
                                                    i: ["smpDendrogram:" + c++ + ":" + x.nodeId],
                                                    g: s,
                                                    t: "smpDendrogram"
                                                })
                                            }
                                        };
                                        this.toRender({
                                            p: ["disableGradientTransparencyShadow"],
                                            t: "smpDendrogram"
                                        });
                                        n(this.smpDendrogram);
                                        e(this.smpDendrogram);
                                        this.toRender({
                                            p: ["enableGradientTransparencyShadow"],
                                            t: "smpDendrogram"
                                        });
                                        this.currentRadius -= (this.dendrogramHeight + this.margin)
                                    }
                                };
                                this.drawCircularOverlayLabel = function(a) {
                                    if (this.circularArc == 360 && this.xAxisShow) {
                                        var b = (this.overlaysThickness - this.overlayFontSize) / 2;
                                        var c = this.currentRadius * this.arcSegmentsRadius[0];
                                        this.toRender({
                                            p: ["drawArcText", a, this.cx, this.cy, c - b, this.circularEnd, this.circularStart - this.circularEnd, this.overlayFont, this.overlayFontColor, false, false, true],
                                            t: "Labels"
                                        })
                                    }
                                };
                                this.drawCircularIdeogram = function() {
                                    if (this.showIdeogram) {
                                        this.drawCircularElement("drawCircularIdeogram");
                                        var k = CanvasXpress.chromosomes[this.ideogram];
                                        var g = function(b) {
                                            switch (b) {
                                                case "gneg":
                                                    return "rgb(255,255,255)";
                                                case "gpos25":
                                                    return "rgb(181,181,181)";
                                                case "gpos50":
                                                    return "rgb(128,128,128)";
                                                case "gpos75":
                                                    return "rgb(63,63,63)";
                                                case "gpos100":
                                                    return "rgb(0,0,0)";
                                                case "acen":
                                                    return "rgb(255,0,0)";
                                                case "stalk":
                                                    return "rgb(0,0,255)";
                                                case "gvar":
                                                    return "rgb(0,255,0)";
                                                default:
                                                    return "rgb(255,255,0)"
                                            }
                                        };
                                        var v = this.circularStart % (Math.PI * 2);
                                        for (var l = 0; l < this.arcSegmentsRange.length; l++) {
                                            var p = this.arcSegments[l].toString();
                                            var d = this.arcSegmentsRange[this.arcSegmentsRangeMap[p]] * this.rAxisUnit;
                                            var u = [v, v + d];
                                            var a = this.currentRadius * this.arcSegmentsRadius[l];
                                            for (var h = 0; h < k.data[p].length; h++) {
                                                var q = k.data[p][h];
                                                var o = (q[1] - q[0]) * this.rAxisUnit;
                                                var m = g(q[3]);
                                                this.toRender({
                                                    p: ["drawShape", "arc2", this.cx, this.cy, this.overlaysThickness, a, m, m, false, false, this.outlineWidth, false, false, v, v + o],
                                                    t: "smpOverlays"
                                                });
                                                v += o
                                            }
                                            this.toRender({
                                                p: ["drawShape", "arc2", this.cx, this.cy, this.overlaysThickness, a, false, "black", "open", false, this.outlineWidth, false, false, u[0], u[1]],
                                                a: this.getShapeArea("arc2", this.cx, this.cy, this.overlaysThickness, a, false, "black", "open", false, this.outlineWidth, false, false, u[0], u[1]),
                                                i: ["Chr - " + p],
                                                t: "smpOverlays"
                                            });
                                            v += this.radians(this.arcSegmentsSeparation)
                                        }
                                        this.drawCircularOverlayLabel(this.ideogram);
                                        this.currentRadius -= this.overlaysThickness + this.margin
                                    }
                                };
                                this.getCircularOverlayColor = function(b, a) {
                                    if (b.type == "Numeric") {
                                        return this.getColorForValue(b.colorBrew, a)
                                    } else {
                                        return b.colors[b.order[a]]
                                    }
                                };
                                this.getCircularSampleOverlayIndex = function(b) {
                                    for (var a = 0; a < this.smpOverlays.length; a++) {
                                        if (this.smpOverlays[a] == b) {
                                            return a
                                        }
                                    }
                                    return -1
                                };
                                this.getCircularVariableOverlayIndex = function(b) {
                                    for (var a = 0; a < this.varOverlays.length; a++) {
                                        if (this.varOverlays[a] == b) {
                                            return a
                                        }
                                    }
                                    return -1
                                };
                                this.drawCircularSampleSegregation = function() {
                                    if (this.segregateSamplesBy.length > 0 && this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble" && !this.showIdeogram) {
                                        this.drawCircularElement("drawCircularSampleSegregation");
                                        var v = this.getCircularLevelLabelLength();
                                        var A = this.meta.data;
                                        var j = this.circularStart % (Math.PI * 2);
                                        var F = this.segregateSamplesBy[0];
                                        var E = (this.overlaysThickness - this.overlayFontSize) / 2;
                                        var w = this.rAxisIndex >= 0 && this.circularArc == 360 ? 0.033 : 0;
                                        var C = this.getSmpAnnotations(F, this.smpIndices).sort();
                                        for (var D = 0; D < C.length; D++) {
                                            var J = this.arcSegmentsRadius[D];
                                            var u = this.currentRadius * J;
                                            var x = C[D];
                                            var B = this.arcLengthToRadians(u / 2, this.measureText(x, this.overlayFont));
                                            var I = this.getCircularOverlayColor(A.x[F], x);
                                            var y = this.rAxisIndex >= 0 ? this.arcSegmentsRange[this.arcSegmentsRangeMap[x]] : (this.getSamplesByAnnotationLevel(F, x)).length;
                                            var G = this.rAxisUnit * y;
                                            var d = this.isHidden(false, false, "Property:" + F + ":" + C[D] + ":x");
                                            this.toRender({
                                                p: ["drawShape", "arc2", this.cx, this.cy, this.overlaysThickness, u - v, I, I, false, false, this.outlineWidth, false, false, j - w, j + G + w],
                                                a: this.getShapeArea("arc2", this.cx, this.cy, this.overlaysThickness, u - v, I, I, false, false, this.outlineWidth, false, false, j - w, j + G + w),
                                                i: ["SmpOvrSgr-" + 0 + "-" + x],
                                                t: "smpOverlays",
                                                h: d
                                            });
                                            if (this.overlayLevelOrientation == "perpendicular") {
                                                var b = ((j - w) + (G / 2)) % (Math.PI * 2);
                                                var f = ((u + this.margin - v) * Math.cos(b)) + this.cx;
                                                var H = ((u + this.margin - v) * Math.sin(b)) + this.cy;
                                                if (b > (Math.PI * 1.5) || b < Math.PI / 2) {
                                                    this.toRender({
                                                        p: ["drawText", x, f, H, this.overlayFont, this.overlayFontColor, "left", "middle", b],
                                                        a: this.getTextArea(x, f, H, this.overlayFont, this.overlayFontColor, "left", "middle", b),
                                                        i: ["SmpOvrSgrLab-" + 0 + "-" + x],
                                                        t: "smpOverlays",
                                                        h: d
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", x, f, H, this.overlayFont, this.overlayFontColor, "right", "middle", b + Math.PI],
                                                        a: this.getTextArea(x, f, H, this.overlayFont, this.overlayFontColor, "right", "middle", b + Math.PI),
                                                        i: ["SmpOvrSgrLab-" + 0 + "-" + x],
                                                        t: "smpOverlays",
                                                        h: d
                                                    })
                                                }
                                            } else {
                                                if (B < G) {
                                                    this.toRender({
                                                        p: ["drawArcText", x, this.cx, this.cy, u - E, j, G, this.overlayFont, this.overlayFontColor, false, false, true],
                                                        a: this.getArcTextArea(x, this.cx, this.cy, u - E, j, G, this.overlayFont, this.overlayFontColor, false, false, true),
                                                        i: ["SmpOvrSgrLab-" + 0 + "-" + x],
                                                        t: "smpOverlays",
                                                        h: d
                                                    })
                                                }
                                            }
                                            j += G + this.radians(this.arcSegmentsSeparation)
                                        }
                                        this.drawCircularOverlayLabel(F);
                                        this.currentRadius -= (this.overlaysThickness + v);
                                        return true
                                    }
                                };
                                this.drawCircularSampleOverlay = function(d) {
                                    if (this.segregateSamplesBy && this.segregateSamplesBy.length && d == this.segregateSamplesBy[0]) {
                                        this.drawCircularSampleSegregation()
                                    } else {
                                        if (this.showOverlays && this.smpOverlays.length > 0 && this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble" && !this.showIdeogram) {
                                            if (this.rAxisIndex < 0 && ((this.data.x && this.data.x[d]) || d == "-")) {
                                                this.drawCircularElement("drawCircularSampleOverlay");
                                                var f = this.meta.data;
                                                var x = this.circularStart % (Math.PI * 2);
                                                var q = this.rAxisUnit;
                                                var p = (this.overlaysThickness - this.overlayFontSize) / 2;
                                                var n = this.getCircularSampleOverlayIndex(d);
                                                if (d != "-") {
                                                    for (var l = 0; l < this.arcSegmentsSampleIndices.length; l++) {
                                                        var u = this.arcSegmentsRadius[l];
                                                        var b = this.currentRadius * u;
                                                        for (var g = 0; g < this.arcSegmentsSampleIndices[l].length; g++) {
                                                            var w = this.getMetadataValue(this.arcSegmentsSampleIndices[l][g], "x", d);
                                                            var t = this.getCircularOverlayColor(f.x[d], w);
                                                            this.toRender({
                                                                p: ["drawShape", "arc2", this.cx, this.cy, (this.overlaysThickness * u), b, t, t, false, false, this.outlineWidth, false, false, x, x + q],
                                                                a: this.getShapeArea("arc2", this.cx, this.cy, (this.overlaysThickness * u), b, t, t, false, false, this.outlineWidth, false, false, x, x + q),
                                                                i: ["SmpOvr-" + this.arcSegmentsSampleIndices[l][g] + "-" + n],
                                                                t: "smpOverlays",
                                                                h: this.isHidden(false, false, "Property:" + d + ":" + w + ":x")
                                                            });
                                                            x += q
                                                        }
                                                        x += this.radians(this.arcSegmentsSeparation)
                                                    }
                                                    this.drawCircularOverlayLabel(d);
                                                    this.currentRadius -= this.overlaysThickness
                                                } else {
                                                    this.currentRadius -= this.margin
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawCircularVariableOverlay = function(a) {
                                    if (this.showOverlays && this.varOverlays.length > 0 && this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble" && this.showIdeogram) {
                                        if ((this.data.z && this.data.z[a]) || a == "-") {
                                            this.drawCircularElement("drawCircularVariableOverlay");
                                            var g = this.meta.data;
                                            var l = this.currentRadius;
                                            var h = this.getCircularVariableOverlayIndex(a);
                                            if (a != "-") {
                                                for (var e = 0; e < this.circularVariableIndices.length; e++) {
                                                    var n = this.circularVariableIndices[e];
                                                    var f = this.data.y.vars[n];
                                                    var k = this.circularVariableData[f].dat[0];
                                                    var d = this.circularVariableData[f].dat[1];
                                                    var m = this.circularVariableData[f].seg;
                                                    var j = this.arcSegmentsRadius[m];
                                                    var c = this.getMetadataValue(this.circularVariableData[f].idx, "z", a);
                                                    var b = this.getCircularOverlayColor(g.z[a], c);
                                                    this.toRender({
                                                        p: ["drawShape", "arc2", this.cx, this.cy, (this.overlaysThickness * j), (l * j), b, b, false, false, this.outlineWidth, false, false, k, d],
                                                        a: this.getShapeArea("arc2", this.cx, this.cy, (this.overlaysThickness * j), (l * j), b, b, false, false, this.outlineWidth, false, false, k, d),
                                                        i: ["VarOvr-" + this.circularVariableData[f].idx + "-" + h],
                                                        t: "varOverlays"
                                                    })
                                                }
                                                this.drawCircularOverlayLabel(a);
                                                this.currentRadius -= this.overlaysThickness
                                            } else {
                                                this.currentRadius -= this.margin
                                            }
                                        }
                                    }
                                };
                                this.drawCircularOverlays = function() {
                                    var b = this.drawCircularSampleSegregation();
                                    if (this.rAxisIndex < 0) {
                                        for (var a = 0; a < this.smpOverlays.length; a++) {
                                            var c = this.smpOverlays[a];
                                            this.drawCircularSampleOverlay(c);
                                            b = true
                                        }
                                        if (this.showIdeogram) {
                                            for (var a = 0; a < this.varOverlays.length; a++) {
                                                var c = this.varOverlays[a];
                                                this.drawCircularVariableOverlay(c);
                                                b = true
                                            }
                                        }
                                    }
                                    this.currentRadius -= (b ? this.margin : 0)
                                };
                                this.drawCircularSampleLabels = function() {
                                    if (this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble") {
                                        var p = this.guides == "dotted" ? "dottedLineR" : "lineR";
                                        var d = this.circularLabelsAlign == "outside";
                                        var w = "1px " + this.fontName;
                                        if (this.showSampleNames && this.rAxisIndex < 0 && !this.showIdeogram) {
                                            this.drawCircularElement("drawCircularSampleLabels");
                                            var o = this.rAxisUnit;
                                            if (this.smpLabelOrientation == "circular") {
                                                var z = this.circularStart;
                                                for (var m = 0; m < this.arcSegmentsSampleIndices.length; m++) {
                                                    var v = this.arcSegmentsRadius[m];
                                                    var b = this.currentRadius * v;
                                                    for (var h = 0; h < this.arcSegmentsSampleIndices[m].length; h += this.smpLabelInterval) {
                                                        var f = this.data.y.smps[this.arcSegmentsSampleIndices[m][h]];
                                                        var q = this.getSmpColor(f);
                                                        this.toRender({
                                                            p: ["drawArcText", f, this.cx, this.cy, b, z, o, this.smpLabelFont, q, false, false, true],
                                                            a: this.getArcTextArea(f, this.cx, this.cy, b, z, o, this.smpLabelFont, q, false, false, true),
                                                            i: ["Smp-" + this.smpIndices[this.arcSegmentsSampleIndices[m][h]]],
                                                            t: "Labels"
                                                        });
                                                        z += (o * this.smpLabelInterval)
                                                    }
                                                    z += this.radians(this.arcSegmentsSeparation)
                                                }
                                                this.currentRadius -= this.smpLabelFontSize + this.margin
                                            } else {
                                                var z = this.circularStart + (o / 2);
                                                var n = this.getCircularSampleLabelLength();
                                                this.currentRadius -= (d ? 0 : n - this.margin);
                                                for (var m = 0; m < this.arcSegmentsSampleIndices.length; m++) {
                                                    var v = this.currentRadius * this.arcSegmentsRadius[m];
                                                    for (var h = 0; h < this.arcSegmentsSampleIndices[m].length; h += this.smpLabelInterval) {
                                                        var g = this.arcSegmentsSampleIndices[m][h];
                                                        var f = this.data.y.smps[g];
                                                        var q = this.getSmpColor(f);
                                                        var b = z % (Math.PI * 2);
                                                        var u = (v * Math.cos(z)) + this.cx;
                                                        var t = (v * Math.sin(z)) + this.cy;
                                                        if (b > (Math.PI * 1.5) || b < Math.PI / 2) {
                                                            this.toRender({
                                                                p: ["drawText", f, u, t, this.smpLabelFont, q, d ? "right" : "left", "middle", z],
                                                                a: this.getTextArea(f, u, t, this.smpLabelFont, q, d ? "right" : "left", "middle", z),
                                                                i: ["Smp-" + g],
                                                                b: [this.cx, this.cy, w],
                                                                t: "Labels"
                                                            })
                                                        } else {
                                                            this.toRender({
                                                                p: ["drawText", f, u, t, this.smpLabelFont, q, d ? "left" : "right", "middle", z + Math.PI],
                                                                a: this.getTextArea(f, u, t, this.smpLabelFont, q, d ? "left" : "right", "middle", z + Math.PI),
                                                                i: ["Smp-" + g],
                                                                b: [this.cx, this.cy, w],
                                                                t: "Labels"
                                                            })
                                                        }
                                                        if (this.guides || this.circularType == "radar") {
                                                            var u = ((v - this.overlaysThickness) * Math.cos(z)) + this.cx;
                                                            var t = ((v - this.overlaysThickness) * Math.sin(z)) + this.cy;
                                                            this.toRender({
                                                                p: ["drawLine", p, this.cx, this.cy, u, t, this.guidesColor, this.guidesWidth + 0.7, "butt"],
                                                                b: [this.cx, this.cy],
                                                                t: "Labels"
                                                            })
                                                        }
                                                        z += (o * this.smpLabelInterval)
                                                    }
                                                    z += this.radians(this.arcSegmentsSeparation)
                                                }
                                                this.currentRadius -= (d ? n : this.margin)
                                            }
                                        } else {
                                            if (this.showSampleNames && this.rAxisIndex >= 0 && !this.showIdeogram) {
                                                this.drawCircularLabels()
                                            }
                                        }
                                    }
                                };
                                this.drawCircularVariableLabels = function() {
                                    if (this.showIdeogram && this.showVariableNames) {
                                        this.drawCircularLabels(true)
                                    }
                                };
                                this.drawCircularLabels = function(c) {
                                    this.drawCircularElement("drawCircularLabels");
                                    var l = this.circularLabelsAlign == "outside";
                                    var D = c ? this.getCircularVariableLabelLength() : this.getCircularSampleLabelLength();
                                    var p = "1px " + this.fontName;
                                    this.currentRadius -= (l ? this.circularAnchorLength : D - (this.margin * 2)) + this.margin;
                                    var q = c ? this.data.y.vars : this.data.y.smps;
                                    var E = c ? 0 : this.rAxisUnit / 2;
                                    var G = c ? this.circularVariableData : this.circularSampleData;
                                    var F = c ? this.varLabelFont : this.smpLabelFont;
                                    var x = 1 / this.maxRadiusFactor;
                                    for (var B = 0; B < q.length; B++) {
                                        var v = q[B];
                                        if (G[v]) {
                                            var J = G[v].idx;
                                            var n = G[v].raw + E;
                                            var j = G[v].mod + E;
                                            var u = G[v].seg;
                                            var t = this.arcSegmentsRadius[u];
                                            var r = this.currentRadius * t;
                                            var M = l ? this.circularAnchorLength + this.margin : -this.circularAnchorLength;
                                            var C = ((r + M) * Math.cos(n)) + this.cx;
                                            var g = ((r + M) * Math.sin(n)) + this.cy;
                                            var L = l ? this.circularAnchorLength + (this.margin / 2) : (this.margin / 2) - this.circularAnchorLength;
                                            var A = ((r + L) * Math.cos(n)) + this.cx;
                                            var e = ((r + L) * Math.sin(n)) + this.cy;
                                            if (!isNaN(j)) {
                                                var K = l ? this.margin : -this.margin;
                                                var I = l ? (this.margin / 2) : (-this.margin / 2);
                                                var z = ((r + K) * Math.cos(j)) + this.cx;
                                                var b = ((r + K) * Math.sin(j)) + this.cy;
                                                var w = ((r + I) * Math.cos(j)) + this.cx;
                                                var a = ((r + I) * Math.sin(j)) + this.cy;
                                                this.toRender({
                                                    p: ["drawLine", "lineR", C, g, A, e, this.rAxisTickColor, this.outlineWidth],
                                                    b: [this.cx, this.cy],
                                                    t: "Labels"
                                                });
                                                this.toRender({
                                                    p: ["drawLine", "lineR", A, e, z, b, this.rAxisTickColor, this.outlineWidth],
                                                    b: [this.cx, this.cy],
                                                    t: "Labels"
                                                });
                                                this.toRender({
                                                    p: ["drawLine", "lineR", z, b, w, a, this.rAxisTickColor, this.outlineWidth],
                                                    b: [this.cx, this.cy],
                                                    t: "Labels"
                                                });
                                                var o = c ? this.getVarColor(v) : this.getSmpColor(v);
                                                var s = (r * Math.cos(j)) + this.cx;
                                                var H = (r * Math.sin(j)) + this.cy;
                                                var m = this.scaleFont(F, t != 1 ? x : 1);
                                                if (j > (Math.PI * 1.5) || j < Math.PI / 2) {
                                                    this.toRender({
                                                        p: ["drawText", v, s, H, m, o, l ? "right" : "left", "middle", j],
                                                        a: this.getTextArea(v, s, H, m, o, l ? "right" : "left", "middle", j),
                                                        i: [(c ? "Var-" : "Smp-") + J],
                                                        b: [this.cx, this.cy, p],
                                                        t: "Labels"
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawText", v, s, H, m, o, l ? "left" : "right", "middle", j + Math.PI],
                                                        a: this.getTextArea(v, s, H, m, o, l ? "left" : "right", "middle", j + Math.PI),
                                                        i: [(c ? "Var-" : "Smp-") + J],
                                                        b: [this.cx, this.cy, p],
                                                        t: "Labels"
                                                    })
                                                }
                                            } else {
                                                this.toRender({
                                                    p: ["drawLine", "lineR", C, g, A, e, this.rAxisTickColor, this.outlineWidth],
                                                    b: [this.cx, this.cy],
                                                    t: "Labels"
                                                })
                                            }
                                        }
                                    }
                                    this.currentRadius -= (l ? D - this.margin : this.circularAnchorLength) + this.margin
                                };
                                this.drawCircularAnchors = function(z) {
                                    if ((this.showIdeogram && this.showVariableNames) || (!this.showIdeogram && this.showSampleNames && this.rAxisIndex >= 0)) {
                                        this.drawCircularElement("drawCircularAnchors");
                                        var j = this.showIdeogram && this.showVariableNames ? true : false;
                                        var g = j ? this.data.y.vars : this.data.y.smps;
                                        var s = j ? 0 : this.rAxisUnit / 2;
                                        var v = j ? this.circularVariableData : this.circularSampleData;
                                        var m = z == "anchors2" ? this.circularAnchorsAlign == "outside" : this.circularAnchorsAlign == "inside";
                                        for (var r = 0; r < g.length; r++) {
                                            var n = g[r];
                                            if (v[n]) {
                                                var w = v[n].idx;
                                                var f = v[n].raw + s;
                                                var e = z == "anchors2" ? v[n].raw : v[n].mod + s;
                                                var u = this.rAxisIndex >= 0 ? v[n].dat[0] : v[n].dat[2];
                                                var l = v[n].seg;
                                                var k = this.currentRadius * this.arcSegmentsRadius[l];
                                                if (!isNaN(e)) {
                                                    var t = (k * Math.cos(m ? e : u)) + this.cx;
                                                    var c = (k * Math.sin(m ? e : u)) + this.cy;
                                                    var q = ((k - this.circularAnchorLength) * Math.cos(m ? u : e)) + this.cx;
                                                    var b = ((k - this.circularAnchorLength) * Math.sin(m ? u : e)) + this.cy;
                                                    this.toRender({
                                                        p: ["drawLine", "beziery", t, c, q, b, this.circularAnchorColor, this.outlineWidth],
                                                        b: [this.cx, this.cy],
                                                        t: "Anchors"
                                                    })
                                                } else {
                                                    var o = ((k - this.circularAnchorLength) * Math.cos(m ? u : e)) + this.cx;
                                                    var a = ((k - this.circularAnchorLength) * Math.sin(m ? u : e)) + this.cy;
                                                    this.toRender({
                                                        p: ["drawShape", "sphere", o, a, 1, 1, this.circularAnchorColor, this.circularAnchorColor],
                                                        b: [this.cx, this.cy],
                                                        t: "Anchors"
                                                    })
                                                }
                                            }
                                        }
                                        this.currentRadius -= (this.circularAnchorLength + this.margin)
                                    }
                                };
                                this.drawCircularData = function() {
                                    for (var b = 0; b < this.ringNumber; b++) {
                                        if (this.rAxisIndex >= 0 && b == this.rAxisIndex) {
                                            continue
                                        }
                                        if (!this.showIdeogram) {
                                            if (this.ringsVarIndices[b].length < 1) {
                                                continue
                                            }
                                        } else {
                                            if (this.ringsSmpIndices[b].length < 1) {
                                                continue
                                            }
                                        }
                                        if (this.getKeys(this.ringMap).length > 0) {
                                            for (var a in this.ringMap) {
                                                if (this.ringMap[a] == b) {
                                                    this.drawCircularDataRing(a);
                                                    break
                                                }
                                            }
                                        } else {
                                            this.drawCircularDataRing()
                                        }
                                    }
                                };
                                this.drawCircularDataRing = function(d) {
                                    var b = this.varIndices;
                                    var c = this.smpIndices;
                                    var e = d ? this.ringMap[d] : 0;
                                    if (!this.showIdeogram) {
                                        if (this.ringsVarIndices[e].length < 1) {
                                            return
                                        }
                                    } else {
                                        if (this.ringsSmpIndices[e].length < 1) {
                                            return
                                        }
                                    }
                                    var a = this.ringLength[e];
                                    var f = this.ringGraphType[e];
                                    if (!this.showIdeogram) {
                                        this.setVariablesVisible(this.ringsVarIndices[e])
                                    } else {
                                        this.setSamplesVisible(this.ringsSmpIndices[e])
                                    }
                                    if (this.circularType != "chord") {
                                        this.setAxes(false, true, f == "stacked")
                                    }
                                    if (f == "heatmap") {
                                        this.circularHeatmap = true
                                    }
                                    this.xAxisUnit = a / this.xAxisRange;
                                    this.drawCircularDataAxis(a, f == "heatmap", e);
                                    this.drawCircularOtherData(a, f);
                                    this.drawCircularDataAxisBox();
                                    this.currentRadius -= (a + this.ringSeparation);
                                    if (!this.showIdeogram) {
                                        this.setVariablesVisible(b)
                                    } else {
                                        this.setSamplesVisible(c)
                                    }
                                    this.varIndices = b;
                                    this.smpIndices = c
                                };
                                this.getCircularXAxisValues = function() {
                                    var b = [];
                                    for (var a = 0; a < this.xAxisValues.length; a++) {
                                        var c = parseFloat(this.xAxisValues[a]);
                                        if (c >= this.xAxisMin && c <= this.xAxisMax) {
                                            b.push(c)
                                        }
                                    }
                                    return b
                                };
                                this.drawCircularDataAxis = function(H, F, b) {
                                    if (this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble") {
                                        var I = Math.min(this.width, this.height) * (1 - this.percentAspectRatioPlotArea);
                                        var D = this.circularArc == 360 ? this.arcSegmentsNumber - 1 : this.circularType == "radar" || this.circularType == "sunburst" ? 0 : 1;
                                        var G = this.arcSegmentsDims[0][0] % (Math.PI * 2);
                                        var B = this.arcSegmentsDims[D][1] % (Math.PI * 2);
                                        var J = this.currentRadius;
                                        var C = this.arcSegmentsRadius[0];
                                        var A = this.axisTickFontSize / 2;
                                        if (F && this.rAxisIndex < 0) {
                                            var n = this.showIdeogram ? this.smpIndices : this.varIndices;
                                            var t = H / n.length;
                                            var K = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");
                                            for (var E = 0; E < n.length; E++) {
                                                var u = this.colors[n[E] % this.colors.length];
                                                var o = G - B;
                                                while (o < 0) {
                                                    o += Math.PI * 2
                                                }
                                                J -= t;
                                                this.toRender({
                                                    p: ["drawArcText", K[E], this.cx, this.cy, (J * C) + (t / 2) + A, B, o, this.axisTickFont, u, false, false, true],
                                                    a: this.getArcTextArea(K[E], this.cx, this.cy, (J * C) + (t / 2) + A, B, o, this.axisTickFont, u, false, false, true),
                                                    i: ["AxisVal:" + b + ":" + E],
                                                    t: "Axes"
                                                })
                                            }
                                        } else {
                                            if (this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble") {
                                                this.setAxisFont("NA", I / 2);
                                                var v = this.rAxisIndex >= 0 && this.circularArc == 360 ? 0.033 : 0;
                                                var s = this.getCircularXAxisValues();
                                                for (var E = 0; E < s.length; E++) {
                                                    var g = J - ((this.xAxisMax - s[E]) * this.xAxisUnit);
                                                    for (var D = 0; D < this.arcSegmentsNumber; D++) {
                                                        var K = this.arcSegmentsRadius[D];
                                                        if (D == 0) {
                                                            if (this.circularArc == 360 || this.circularType == "normal") {
                                                                var H = G - B;
                                                                while (H < 0) {
                                                                    H += Math.PI * 2
                                                                }
                                                                this.toRender({
                                                                    p: ["drawArcText", s[E], this.cx, this.cy, (g * C) + A, B, H, this.axisTickFont, this.axisTickColor, false, false, true],
                                                                    a: this.getArcTextArea(s[E], this.cx, this.cy, (g * C) + A, B, H, this.axisTickFont, this.axisTickColor, false, false, true),
                                                                    i: ["AxisVal:" + b + ":" + E],
                                                                    t: "Axes"
                                                                })
                                                            } else {
                                                                var H = this.arcSegmentsDims[0][1] - this.arcSegmentsDims[0][0];
                                                                while (H < 0) {
                                                                    H += Math.PI * 2
                                                                }
                                                                this.toRender({
                                                                    p: ["drawArcText", s[E], this.cx, this.cy, (g * C) + A, G, H, this.axisTickFont, this.axisTickColor, false, false, true],
                                                                    a: this.getArcTextArea(s[E], this.cx, this.cy, (g * C) + A, G, H, this.axisTickFont, this.axisTickColor, false, false, true),
                                                                    i: ["AxisVal:" + b + ":" + E],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                        if (E != 0 && E != s.length - 1) {
                                                            if (this.circularArc == 360 && this.circularType != "normal") {
                                                                this.toRender({
                                                                    p: ["drawShape", "circle", this.cx, this.cy, g * K * 2, g * K * 2, false, this.xAxisTickColor, "open", false, this.outlineWidth],
                                                                    t: "Axes"
                                                                })
                                                            } else {
                                                                this.toRender({
                                                                    p: ["drawLine", "arc", this.cx, this.cy, g * K, g * K, this.xAxisTickColor, this.outlineWidth, false, this.arcSegmentsDims[D][0] - v, this.arcSegmentsDims[D][1] + v],
                                                                    t: "Axes"
                                                                })
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            this.setAxisFont("NA", I / 1.33)
                                        }
                                    }
                                };
                                this.drawCircularDataAxisBox = function() {
                                    if (this.circularType != "sunburst" && this.circularType != "chord" && this.circularType != "bubble") {
                                        if (this.circularType == "radar" && this.circularArc == 360) {
                                            var i = this.currentRadius * 2;
                                            this.toRender({
                                                p: ["drawShape", "circle", this.cx, this.cy, i, i, false, this.foreground, "open", false, this.oulineWidth],
                                                t: "Axes"
                                            })
                                        } else {
                                            var k = this.currentRadius;
                                            var b = this.rAxisIndex >= 0 && this.circularArc == 360 ? 0.033 : 0;
                                            var o = this.getCircularXAxisValues();
                                            var n = k - ((this.xAxisMax - o[0]) * this.xAxisUnit);
                                            var m = k - ((this.xAxisMax - o[o.length - 1]) * this.xAxisUnit);
                                            var f = m - n;
                                            for (var g = 0; g < this.arcSegmentsNumber; g++) {
                                                var q = this.arcSegmentsDims[g][0] - b;
                                                var h = this.arcSegmentsDims[g][1] + b;
                                                var l = this.arcSegmentsRadius[g];
                                                this.toRender({
                                                    p: ["drawShape", "arc2", this.cx, this.cy, f * l, k * l, false, this.foreground, "open", false, this.oulineWidth, false, false, q, h],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    }
                                };
                                this.drawCircularSunburst = function() {
                                    this.drawCircularElement("drawCircularSunburst");
                                    var e = this;
                                    var a = this.ringLength[0];
                                    var c = function(q, r) {
                                        if (q.children) {
                                            var m = 0.002;
                                            for (var o = 0; o < q.children.length; o++) {
                                                var g = q.children[o];
                                                var h = g.depth * d;
                                                var s = g.value * e.rAxisUnit;
                                                var v, i, n, k, l, p, u, t;
                                                if ((e.hierarchy.length == 0 || g.depth < e.hierarchy.length) && g.name) {
                                                    if (m >= 0.002) {
                                                        n = e.measureText(g.name, e.smpLabelFont) + (e.margin * 2);
                                                        k = s * ((e.currentRadius - a) + h + f);
                                                        v = e.getFillColor(g.color);
                                                        ol = e.getOutlineColor(v);
                                                        p = e.isHidden(false, g.idx[0]);
                                                        i = e.toRender({
                                                            p: ["drawShape", "arc2", e.cx, e.cy, d, (e.currentRadius - a) + h + d, v, ol, false, false, false, false, false, r, r + s],
                                                            a: e.getShapeArea("arc2", e.cx, e.cy, d, (e.currentRadius - a) + h + d, v, ol, false, false, false, false, false, r, r + s),
                                                            i: ["Sunburst:" + g.tooltip, g.idx],
                                                            t: "Data",
                                                            h: p
                                                        });
                                                        if (k > n) {
                                                            if (d > e.smpLabelFontSize) {
                                                                e.toRender({
                                                                    p: ["drawArcText", g.name, e.cx, e.cy, (e.currentRadius - a) + h + f, r, s, e.smpLabelFont, e.smpLabelFontColor, false, false, true],
                                                                    a: e.getArcTextArea(g.name, e.cx, e.cy, (e.currentRadius - a) + h + f, r, s, e.smpLabelFont, e.smpLabelFontColor, false, false, true),
                                                                    i: ["SunburstLabel:" + g.tooltip, g.idx],
                                                                    g: i,
                                                                    t: "Labels",
                                                                    h: p
                                                                })
                                                            }
                                                        } else {
                                                            if (d > n) {
                                                                if (k > e.smpLabelFontSize) {
                                                                    l = (r + (s / 2)) % (Math.PI * 2);
                                                                    u = (((e.currentRadius - a) + h + f - (n / 2)) * Math.cos(l)) + e.cx;
                                                                    t = (((e.currentRadius - a) + h + f - (n / 2)) * Math.sin(l)) + e.cy;
                                                                    if (l > (Math.PI * 1.5) || l < Math.PI / 2) {
                                                                        e.toRender({
                                                                            p: ["drawText", g.name, u, t, e.smpLabelFont, e.smpLabelFontColor, "center", "middle", l],
                                                                            a: e.getTextArea(g.name, u, t, e.smpLabelFont, e.smpLabelFontColor, "center", "middle", l),
                                                                            i: ["SunburstLabel:" + g.tooltip, g.idx],
                                                                            g: i,
                                                                            b: [e.cx, e.cy],
                                                                            t: "Labels",
                                                                            h: p
                                                                        })
                                                                    } else {
                                                                        e.toRender({
                                                                            p: ["drawText", g.name, u, t, e.smpLabelFont, e.smpLabelFontColor, "center", "middle", l + Math.PI],
                                                                            a: e.getTextArea(g.name, u, t, e.smpLabelFont, e.smpLabelFontColor, "center", "middle", l + Math.PI),
                                                                            i: ["SunburstLabel:" + g.tooltip, g.idx],
                                                                            g: i,
                                                                            b: [e.cx, e.cy],
                                                                            t: "Labels",
                                                                            h: p
                                                                        })
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        m = 0
                                                    }
                                                    if (g.children) {
                                                        c(g, r)
                                                    }
                                                    r += s;
                                                    m += s
                                                }
                                            }
                                        }
                                    };
                                    var b = this.circularStart;
                                    var d = a / Math.max(this.hierarchy.length, 1);
                                    var f = (d + this.smpLabelFontSize) / 2;
                                    c(this.circularSunburst[0], b)
                                };
                                this.drawCircularChord = function() {
                                    this.drawCircularElement("drawCircularChord");
                                    var o = this.circularStart;
                                    var j = this.circularChord;
                                    var k = (this.chordThickness - this.smpLabelFontSize) / 2;
                                    var r = [];
                                    for (var v = 0; v < j.segments.length; v++) {
                                        j.segments[v].ribbons = {};
                                        var b = (o + j.segments[v].start);
                                        var d = (o + j.segments[v].end);
                                        var m = j.segments[v].color;
                                        var n = j.segments[v].name;
                                        var p = this.toRender({
                                            p: ["drawShape", "arc2", this.cx, this.cy, this.chordThickness, this.currentRadius, this.getFillColor(m), this.getOutlineColor(m), false, false, false, false, false, b, d],
                                            a: this.getShapeArea("arc2", this.cx, this.cy, this.chordThickness, this.currentRadius, this.getFillColor(m), this.getOutlineColor(m), false, false, false, false, false, b, d),
                                            i: ["Chord:" + j.segments[v].idx + ":" + j.segments[v].name + " (" + j.segments[v].value + ")", [j.segments[v].idx]],
                                            t: "Data",
                                            h: this.isHidden(j.segments[v].idx)
                                        });
                                        j.segments[v].ribbons[p] = true;
                                        if (this.showSampleNames) {
                                            p = this.toRender({
                                                p: ["drawArcText", n, this.cx, this.cy, this.currentRadius - k, b, d - b, this.smpLabelFont, this.smpLabelFontColor, false, false, true],
                                                a: this.getArcTextArea(n, this.cx, this.cy, this.currentRadius - k, b, d - b, this.smpLabelFont, this.smpLabelFontColor, false, false, true),
                                                i: ["ChordLbl" + v],
                                                g: p,
                                                t: "Labels",
                                                h: this.isHidden(j.segments[v].idx)
                                            });
                                            j.segments[v].ribbons[p] = true
                                        }
                                    }
                                    this.currentRadius -= this.chordThickness;
                                    if (this.chordColor != "target") {
                                        this.chordColor = "source"
                                    }
                                    for (var v = 0; v < j.chords.length; v++) {
                                        var q = (o + j.chords[v].source.start);
                                        var y = (o + j.chords[v].source.end);
                                        var c = (o + j.chords[v].target.start);
                                        var l = (o + j.chords[v].target.end);
                                        var x = this.cx + (this.currentRadius * Math.cos(q));
                                        var h = this.cy + (this.currentRadius * Math.sin(q));
                                        var w = this.cx + (this.currentRadius * Math.cos(l));
                                        var g = this.cy + (this.currentRadius * Math.sin(l));
                                        var u = this.cx + (this.currentRadius * Math.cos(c));
                                        var f = this.cy + (this.currentRadius * Math.sin(c));
                                        var t = this.cx + (this.currentRadius * Math.cos(y));
                                        var e = this.cy + (this.currentRadius * Math.sin(y));
                                        var m = j.chords[v][this.chordColor].color;
                                        var a = ["Connect:" + j.segments[j.chords[v].source.idx].name + " (" + j.segments[j.chords[v].source.idx].value + ") -- " + j.segments[j.chords[v].target.idx].name + " (" + j.segments[j.chords[v].target.idx].value + ")", [j.chords[v].source.idx, j.chords[v].target.idx]];
                                        var p = this.toRender({
                                            p: ["drawShape", "arch", [x, this.cx, w, u, this.cx, t],
                                                [h, this.cy, g, f, this.cy, e],
                                                [q, y, c, l],
                                                [this.currentRadius, this.currentRadius], this.addColorTransparency(m, 0.67, true), this.addColorTransparency(this.foreground, 0.33, true)
                                            ],
                                            a: this.getShapeArea("arch", [x, this.cx, w, u, this.cx, t], [h, this.cy, g, f, this.cy, e], [q, y, c, l], [this.currentRadius, this.currentRadius], this.addColorTransparency(m, 0.67, true), this.addColorTransparency(this.foreground, 0.33, true)),
                                            i: a,
                                            t: "Data",
                                            h: this.isHidden(j.chords[v].source.idx) || this.isHidden(j.chords[v].target.idx)
                                        });
                                        j.segments[j.chords[v].source.idx].ribbons[p] = true;
                                        j.segments[j.chords[v].target.idx].ribbons[p] = true
                                    }
                                };
                                this.drawCircularBubble = function() {
                                    this.drawCircularElement("drawCircularBubble");
                                    var e = this.data.bubble.plot.descendants();
                                    var B = Math.max(this.top, this.right);
                                    var o = this.data.bubble.plot.diameter / 2;
                                    var k = this.marginLeft + this.marginRight + this.left + this.x - this.right;
                                    var h = this.marginTop + this.marginBottom + this.bottom + this.y - this.top;
                                    var A = k > h ? this.marginLeft + this.left + ((this.x - this.y) / 2) : this.marginLeft + this.left;
                                    var v = h > k ? this.marginTop + this.top + ((this.y - this.x)) / 2 : this.marginTop + this.top;
                                    if (this.hierarchy.length > 0) {
                                        for (var j = 0; j < e.length; j++) {
                                            var g = this.meta.data.x;
                                            var t = e[j];
                                            if (t.children) {
                                                var f = this.rotatePoint(t.x, t.y, o, o, this.radians(this.circularRotate));
                                                var u = A + f[0];
                                                var r = v + f[1];
                                                var l = t.r * 2;
                                                var a = t.depth == 0 ? false : ["Bubble" + t.data.id + ":" + t.data.name + " (" + t.value + ")"];
                                                var n = this.colorBy && g && g.hasOwnProperty(this.colorBy) && g[this.colorBy].order.hasOwnProperty(t.data.name) ? g[this.colorBy].colors[g[this.colorBy].order[t.data.name]] : t.parent && t.parent.color ? t.parent.color : this.bubbleColor;
                                                var w = this.toRender({
                                                    p: ["drawShape", "circle", u, r, l, l, t.depth == this.hierarchy.length ? n : this.addColorTransparency(n, 0.33, true), this.foreground],
                                                    a: this.getShapeArea("circle", u, r, l, l, t.depth == this.hierarchy.length ? n : this.addColorTransparency(n, 0.33, true), this.foreground),
                                                    i: a,
                                                    b: [this.cx, this.cy, 0, 0],
                                                    t: "Data"
                                                });
                                                if (a) {
                                                    a[0] += ":Label"
                                                }
                                                if (this.measureText(t.data.name, this.smpLabelFont) < l) {
                                                    if (t.depth == this.hierarchy.length) {
                                                        this.toRender({
                                                            p: ["drawText", t.data.name, u, r, this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                                            a: this.getTextArea(t.data.name, u, r, this.smpLabelFont, this.smpLabelFontColor, "center", "middle"),
                                                            i: a,
                                                            g: w,
                                                            b: [this.cx, this.cy, 0, 0],
                                                            t: "Labels"
                                                        })
                                                    } else {
                                                        this.toRender({
                                                            p: ["drawText", t.data.name, u, r - (t.r + (this.smpLabelFontSize * 0)), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                                            a: this.getTextArea(t.data.name, u, r - (t.r + (this.smpLabelFontSize * 0)), this.smpLabelFont, this.smpLabelFontColor, "center", "middle"),
                                                            i: a,
                                                            g: w,
                                                            b: [this.cx, this.cy, 0, 0],
                                                            t: "Labels"
                                                        })
                                                    }
                                                }
                                                t.color = n
                                            }
                                        }
                                    } else {
                                        for (var j = 0; j < e.length; j++) {
                                            var t = e[j];
                                            if (!t.children) {
                                                var f = this.rotatePoint(t.x, t.y, o, o, this.radians(this.circularRotate));
                                                var u = A + f[0];
                                                var r = v + f[1];
                                                var l = t.r * 2;
                                                var a = ["Bubble" + t.data.id + ":" + t.data.name + " (" + t.value + ")"];
                                                var n = this.colorBy ? this.getPropertyValue(this.hierarchyVar, t.data.idx, "colorBy") : this.colors[j % this.colors.length];
                                                var w = this.toRender({
                                                    p: ["drawShape", "circle", u, r, l, l, this.getFillColor(n), this.getOutlineColor(n)],
                                                    a: this.getShapeArea("circle", u, r, l, l, this.getFillColor(n), this.getOutlineColor(n)),
                                                    i: a,
                                                    b: [this.cx, this.cy, 0, 0],
                                                    t: "Data"
                                                });
                                                a[0] += ":Label";
                                                if (this.measureText(t.data.name, this.smpLabelFont) < l) {
                                                    this.toRender({
                                                        p: ["drawText", t.data.name, u, r, this.smpLabelFont, this.smpLabelFontColor, "center", "middle"],
                                                        a: this.getTextArea(t.data.name, u, r, this.smpLabelFont, this.smpLabelFontColor, "center", "middle"),
                                                        i: a,
                                                        g: w,
                                                        b: [this.cx, this.cy, 0, 0],
                                                        t: "Labels"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawCircularOtherData = function(t, W, h) {
                                    this.drawCircularElement("drawCircularOtherData");
                                    var J = this;
                                    var e = function() {
                                        var j = f.length;
                                        var a = J.margin;
                                        return j >= 200 ? a / 1.4 : j >= 100 ? a / 1 : j >= 50 ? a * 1 : j >= 25 ? a * 1.5 : a * 2
                                    };
                                    var K = function(k, a) {
                                        return J.showIdeogram ? J.getDataAtPos(k, a) : J.getDataAtPos(a, k)
                                    };
                                    var B = function(k, a) {
                                        return J.showIdeogram ? [k, a] : [a, k]
                                    };
                                    var p = this.currentRadius;
                                    var o = this.showIdeogram ? this.circularVariableData : this.circularSampleData;
                                    var n = this.showIdeogram ? this.circularVariableIndices : this.circularSampleIndices;
                                    var f = this.showIdeogram ? this.data.y.vars : this.data.y.smps;
                                    var d = this.showIdeogram ? this.data.y.smps : this.data.y.vars;
                                    var S = this.showIdeogram ? this.smpIndices : this.varIndices;
                                    var P = this.showIdeogram ? this.varIndices : this.smpIndices;
                                    var H = this.getObjectArray(P);
                                    switch (W) {
                                        case "bar":
                                            var w = this.xAxisMin < 0 ? Math.abs(this.xAxisMin) * this.xAxisUnit : 0;
                                            for (var V = 0; V < n.length; V++) {
                                                var F = n[V];
                                                if (H.hasOwnProperty(F)) {
                                                    var R = f[F];
                                                    var E = o[R].dat[0];
                                                    var r = (o[R].dat[1] - o[R].dat[0]) / S.length;
                                                    var X = o[R].seg;
                                                    var c = this.arcSegmentsRadius[X];
                                                    for (var U = 0; U < S.length; U++) {
                                                        var q = S[U];
                                                        var z = (K(F, q) - this.xAxisMin) * this.xAxisUnit * c;
                                                        var O = this.colors[(q - (this.rAxisIndex >= 0 ? 1 : 0)) % this.colors.length];
                                                        var m = this.addColorTransparency(O, 0.67, true);
                                                        var g = ((this.currentRadius + w + 1) * c) - ((t * c) - z);
                                                        var s = E + r;
                                                        if (z < 0) {
                                                            this.toRender({
                                                                p: ["drawShape", "arc2", this.cx, this.cy, -z, g - z, m, O, false, false, false, false, false, E, s],
                                                                a: this.getShapeArea("arc2", this.cx, this.cy, -z, g - z, m, O, false, false, false, false, false, E, s),
                                                                i: B(F, q),
                                                                t: "Data",
                                                                h: this.isHidden(q, F)
                                                            })
                                                        } else {
                                                            this.toRender({
                                                                p: ["drawShape", "arc2", this.cx, this.cy, z, g, m, O, false, false, false, false, false, E, s],
                                                                a: this.getShapeArea("arc2", this.cx, this.cy, z, g, m, O, false, false, false, false, false, E, s),
                                                                i: B(F, q),
                                                                t: "Data",
                                                                h: this.isHidden(q, F)
                                                            })
                                                        }
                                                        E += r
                                                    }
                                                }
                                            }
                                            break;
                                        case "dot":
                                            var b = e();
                                            for (var V = 0; V < n.length; V++) {
                                                var F = n[V];
                                                if (H.hasOwnProperty(F)) {
                                                    var R = f[F];
                                                    var A = this.rAxisIndex >= 0 ? o[R].dat[0] : o[R].dat[2];
                                                    var X = o[R].seg;
                                                    var c = this.arcSegmentsRadius[X];
                                                    for (var U = 0; U < S.length; U++) {
                                                        var q = S[U];
                                                        var z = (this.xAxisMax - K(F, q)) * (this.xAxisUnit * c);
                                                        var O = this.colors[(q - (this.rAxisIndex >= 0 ? 1 : 0)) % this.colors.length];
                                                        var m = this.addColorTransparency(O, 0.67, true);
                                                        var M = this.cx + ((p * c) - z) * Math.cos(A);
                                                        var L = this.cy + ((p * c) - z) * Math.sin(A);
                                                        this.toRender({
                                                            p: ["drawShape", "circle", M, L, b, b, m, O],
                                                            a: this.getShapeArea("circle", M, L, b, b, m, O),
                                                            i: B(F, q),
                                                            b: [this.cx, this.cy],
                                                            t: "Data",
                                                            h: this.isHidden(q, F)
                                                        })
                                                    }
                                                }
                                            }
                                            break;
                                        case "heatmap":
                                            var g = t / S.length;
                                            for (var V = 0; V < n.length; V++) {
                                                var F = n[V];
                                                if (H.hasOwnProperty(F)) {
                                                    var R = f[F];
                                                    var E = o[R].dat[0];
                                                    var s = o[R].dat[1];
                                                    var X = o[R].seg;
                                                    var c = this.arcSegmentsRadius[X];
                                                    var l = 0;
                                                    for (var U = 0; U < S.length; U++) {
                                                        var q = S[U];
                                                        var z = K(F, q);
                                                        var m = !isNaN(z) ? this.getColorForValue(false, z) : this.missingDataColor;
                                                        var O = this.addColorTransparency(m, 0.67, true);
                                                        this.toRender({
                                                            p: ["drawShape", "arc2", this.cx, this.cy, (g * c), ((p * c) - l), m, O, false, false, false, false, false, E, s],
                                                            a: this.getShapeArea("arc2", this.cx, this.cy, (g * c), ((p * c) - l), m, O, false, false, false, false, false, E, s),
                                                            i: B(F, q),
                                                            t: "Data",
                                                            h: this.isHidden(q, F)
                                                        });
                                                        l += (g * c)
                                                    }
                                                }
                                            }
                                            break;
                                        case "stacked":
                                            for (var V = 0; V < n.length; V++) {
                                                var F = n[V];
                                                if (H.hasOwnProperty(F)) {
                                                    var R = f[F];
                                                    var E = o[R].dat[0];
                                                    var s = o[R].dat[1];
                                                    var X = o[R].seg;
                                                    var c = this.arcSegmentsRadius[X];
                                                    var l = 0;
                                                    for (var U = 0; U < S.length; U++) {
                                                        var q = S[U];
                                                        var z = K(F, q);
                                                        var O = this.colors[(q - (this.rAxisIndex >= 0 ? 1 : 0)) % this.colors.length];
                                                        var m = this.addColorTransparency(O, 0.67, true);
                                                        var g = z * this.xAxisUnit * c;
                                                        this.toRender({
                                                            p: ["drawShape", "arc2", this.cx, this.cy, g, ((p - t) * c) + (g + l) + 1, m, O, false, false, false, false, false, E, s],
                                                            a: this.getShapeArea("arc2", this.cx, this.cy, g, ((p - t) * c) + (g + l) + 1, m, O, false, false, false, false, false, E, s),
                                                            i: B(F, q),
                                                            t: "Data",
                                                            h: this.isHidden(q, F)
                                                        });
                                                        l += g
                                                    }
                                                }
                                            }
                                            break;
                                        case "area":
                                        case "line":
                                            var Q = [];
                                            var v = (p - t) + 2;
                                            var b = e();
                                            for (var U = 0; U < S.length; U++) {
                                                Q[U] = {
                                                    x: [],
                                                    y: [],
                                                    c: this.foreground,
                                                    a: [],
                                                    s: [],
                                                    m: [],
                                                    w: [],
                                                    l: []
                                                };
                                                var q = S[U];
                                                var m = this.colors[(q - (this.rAxisIndex >= 0 ? 1 : 0)) % this.colors.length];
                                                for (var V = 0; V < n.length; V++) {
                                                    var F = n[V];
                                                    if (H.hasOwnProperty(F)) {
                                                        var R = f[F];
                                                        var A = this.rAxisIndex >= 0 ? o[R].dat[0] : o[R].dat[2];
                                                        var X = o[R].seg;
                                                        var c = this.arcSegmentsRadius[X];
                                                        var z = (this.xAxisMax - K(F, q)) * (this.xAxisUnit * c);
                                                        Q[U].x.push(this.cx + ((p * c) - z) * Math.cos(A));
                                                        Q[U].y.push(this.cy + ((p * c) - z) * Math.sin(A));
                                                        Q[U].c = m;
                                                        Q[U].a.push(B(F, q));
                                                        Q[U].s.push(o[R].seg);
                                                        Q[U].m.push(A);
                                                        Q[U].w.push(c);
                                                        Q[U].l.push(d[P[q]]);
                                                        if (W == "line") {
                                                            var N = Q[U].l.length - 1;
                                                            this.toRender({
                                                                p: ["drawShape", "circle", Q[U].x[N], Q[U].y[N], b, b, m, m],
                                                                a: this.getShapeArea("circle", Q[U].x[N], Q[U].y[N], b, b, m, m),
                                                                i: B(F, q),
                                                                b: [this.cx, this.cy],
                                                                t: "Data",
                                                                h: this.isHidden(q, F)
                                                            })
                                                        }
                                                    }
                                                }
                                            }
                                            if (W == "line") {
                                                for (var U = 0; U < S.length; U++) {
                                                    var I = null;
                                                    var Y = Q[U];
                                                    var u = Y.s[0];
                                                    for (var T = 1; T < Q[U].x.length; T++) {
                                                        if (Y.s[T] == u) {
                                                            var G = this.toRender({
                                                                p: ["drawLine", "line", Y.x[T - 1], Y.y[T - 1], Y.x[T], Y.y[T], Y.c],
                                                                a: this.getLineArea("line", Y.x[T - 1], Y.y[T - 1], Y.x[T], Y.y[T], Y.c),
                                                                i: ["Line:" + Y.l[T] + ":" + S[U]],
                                                                g: I,
                                                                b: [this.cx, this.cy, this.cx, this.cy],
                                                                t: "Data",
                                                                h: this.isHidden(S[U], Y.l[T])
                                                            });
                                                            if (T == Q[U].x.length - 1 && this.circularArc == 360 && !this.segregateSamplesBy.length) {
                                                                this.toRender({
                                                                    p: ["drawLine", "line", Y.x[T], Y.y[T], Y.x[0], Y.y[0], Y.c],
                                                                    a: this.getLineArea("line", Y.x[T], Y.y[T], Y.x[0], Y.y[0], Y.c),
                                                                    i: ["Line:" + Y.l[0] + ":" + S[U]],
                                                                    g: I,
                                                                    b: [this.cx, this.cy, this.cx, this.cy],
                                                                    t: "Data",
                                                                    h: this.isHidden(S[U], Y.l[0])
                                                                })
                                                            }
                                                        } else {
                                                            I = null
                                                        }
                                                        u = Y.s[T];
                                                        if (!I) {
                                                            I = G
                                                        }
                                                    }
                                                }
                                            } else {
                                                if (W == "area") {
                                                    for (var U = 0; U < S.length; U++) {
                                                        var Y = Q[U];
                                                        var u = Y.s[0];
                                                        var C = [
                                                            [],
                                                            []
                                                        ];
                                                        var D = [
                                                            [],
                                                            []
                                                        ];
                                                        var M, L;
                                                        for (var T = 0; T < Q[U].x.length; T++) {
                                                            if (Y.s[T] == u) {
                                                                M = this.cx + (v * Y.w[T]) * Math.cos(Y.m[T]);
                                                                L = this.cy + (v * Y.w[T]) * Math.sin(Y.m[T]);
                                                                D[0].unshift(M);
                                                                D[1].unshift(L);
                                                                C[0].push(Y.x[T]);
                                                                C[1].push(Y.y[T])
                                                            } else {
                                                                if (this.circularArc != 360 || this.segregateSamplesBy.length) {
                                                                    while (D[0].length > 0) {
                                                                        C[0].push(D[0].shift());
                                                                        C[1].push(D[1].shift())
                                                                    }
                                                                }
                                                                this.toRender({
                                                                    p: ["drawShape", "path", C[0], C[1], false, false, this.addColorTransparency(Y.c, 0.25, true), Y.c],
                                                                    a: this.getShapeArea("path", C[0], C[1], false, false, this.addColorTransparency(Y.c, 0.25, true), Y.c),
                                                                    i: ["Area:" + Y.l[T] + ":" + S[U]],
                                                                    b: [this.cx, this.cy],
                                                                    t: "Data",
                                                                    h: this.isHidden(S[U], Y.l[T])
                                                                });
                                                                u = Y.s[T];
                                                                M = this.cx + (v * Y.w[T]) * Math.cos(Y.m[T]);
                                                                L = this.cy + (v * Y.w[T]) * Math.sin(Y.m[T]);
                                                                D[0].unshift(M);
                                                                D[1].unshift(L);
                                                                C = [
                                                                    [],
                                                                    []
                                                                ];
                                                                C[0].push(Y.x[T]);
                                                                C[1].push(Y.y[T])
                                                            }
                                                        }
                                                        if (this.circularArc != 360 || this.segregateSamplesBy.length) {
                                                            while (D[0].length > 0) {
                                                                C[0].push(D[0].shift());
                                                                C[1].push(D[1].shift())
                                                            }
                                                        }
                                                        this.toRender({
                                                            p: ["drawShape", "path", C[0], C[1], false, false, this.addColorTransparency(Y.c, 0.25, true), Y.c],
                                                            a: this.getShapeArea("path", C[0], C[1], false, false, this.addColorTransparency(Y.c, 0.25, true), Y.c),
                                                            i: ["Area:" + Y.l[T - 1] + ":" + S[U]],
                                                            b: [this.cx, this.cy],
                                                            t: "Data",
                                                            h: this.isHidden(S[U], Y.l[T - 1])
                                                        })
                                                    }
                                                }
                                            }
                                            break
                                    }
                                };
                                this.getCircularCoordinates = function(t) {
                                    var l = this;
                                    var s = this.rAxisUnit;
                                    var i = this.currentRadius;
                                    var n = function(e) {
                                        var w = l.arcSegmentsRangeMap[e[1]];
                                        var z = l.arcSegmentsRangeMap[e[3]];
                                        if (w != null && z != null) {
                                            var c = l.rAxisZero && l.arcSegmentsMin[w] < 0 ? l.arcSegmentsMin[w] : 0;
                                            var C = l.rAxisZero && l.arcSegmentsMin[z] < 0 ? l.arcSegmentsMin[z] : 0;
                                            if (e[2] >= l.arcSegmentsMin[w] && e[2] <= l.arcSegmentsMax[w] && e[4] >= l.arcSegmentsMin[z] && e[4] <= l.arcSegmentsMax[z]) {
                                                var y, B, x, A;
                                                y = l.arcSegmentsDims[w][0] + ((e[2] + c - l.arcSegmentsMin[w]) * l.rAxisUnit);
                                                B = l.arcSegmentsDims[z][0] + ((e[4] + C - l.arcSegmentsMin[z]) * l.rAxisUnit);
                                                if (e[5] != null || e[6] != null) {
                                                    x = l.arcSegmentsDims[w][0] + ((Math.min(e[2] + (e[5] || 0), l.arcSegmentsMax[w]) + c - l.arcSegmentsMin[w]) * l.rAxisUnit);
                                                    A = l.arcSegmentsDims[z][0] + ((Math.min(e[4] + (e[6] || 0), l.arcSegmentsMax[z]) + C - l.arcSegmentsMin[z]) * l.rAxisUnit);
                                                    return [y, B, x, A]
                                                }
                                                return [y, B]
                                            }
                                        }
                                        return false
                                    };
                                    if (this.rAxisIndex < 0 && !this.showIdeogram) {
                                        var k = this.circularSampleData[t[t.length == 2 ? 0 : 1]];
                                        var m = this.circularSampleData[t[t.length == 2 ? 1 : 2]];
                                        var a = k && k.dat ? k.dat[0] : false;
                                        var h = m && m.dat ? m.dat[0] : false;
                                        if (a && h) {
                                            var v = this.arcSegmentsRadius[k.seg];
                                            var u = this.arcSegmentsRadius[m.seg];
                                            var r = this.cx + (i * Math.cos(a));
                                            var g = this.cy + (i * Math.sin(a));
                                            var q = this.cx + (i * Math.cos(h + s));
                                            var f = this.cy + (i * Math.sin(h + s));
                                            var p = this.cx + (i * Math.cos(h));
                                            var d = this.cy + (i * Math.sin(h));
                                            var o = this.cx + (i * Math.cos(a + s));
                                            var b = this.cy + (i * Math.sin(a + s));
                                            return [r, g, q, f, p, d, o, b, a, a + s, h, h + s, v, u]
                                        }
                                    } else {
                                        if ((this.segregateSamplesBy.length > 0 && this.data.x[this.segregateSamplesBy[0]]) || this.showIdeogram) {
                                            var j = n(t);
                                            if (j) {
                                                var r, g, q, f, p, d, o, b, v, u;
                                                if (j.length > 2) {
                                                    if (this.showIdeogram) {
                                                        v = this.arcSegmentsRadius[this.arcSegmentsRangeMap[t[1]]];
                                                        u = this.arcSegmentsRadius[this.arcSegmentsRangeMap[t[3]]]
                                                    } else {
                                                        v = 1;
                                                        u = 1
                                                    }
                                                    r = this.cx + (i * v * Math.cos(j[0]));
                                                    g = this.cy + (i * v * Math.sin(j[0]));
                                                    q = this.cx + (i * u * Math.cos(j[3]));
                                                    f = this.cy + (i * u * Math.sin(j[3]));
                                                    p = this.cx + (i * u * Math.cos(j[1]));
                                                    d = this.cy + (i * u * Math.sin(j[1]));
                                                    o = this.cx + (i * v * Math.cos(j[2]));
                                                    b = this.cy + (i * v * Math.sin(j[2]));
                                                    return [r, g, q, f, p, d, o, b, j[0], j[2], j[1], j[3], u, v]
                                                } else {
                                                    r = this.cx + (i * Math.cos(j[0]));
                                                    g = this.cy + (i * Math.sin(j[0]));
                                                    q = this.cx + (i * Math.cos(j[1]));
                                                    f = this.cy + (i * Math.sin(j[1]));
                                                    return [r, g, q, f]
                                                }
                                            } else {
                                                alert("Oooops! Something went wrong in the connection between " + t[1] + " and" + t[3] + "!")
                                            }
                                        }
                                    }
                                    return false
                                };
                                this.drawCircularConnections = function() {
                                    this.currentRadius += this.margin;
                                    this.drawCircularElement("drawCircularConnections");
                                    if (this.showCircularConnections && this.connections) {
                                        var k = function(b) {
                                            if (b.length > 3) {
                                                return b[1] + "[" + b[2] + "] " + b[5] + " - " + b[3] + "[" + b[4] + "] " + b[6]
                                            } else {
                                                if (b.length == 2) {
                                                    return b[0] + " - " + b[1]
                                                } else {
                                                    return b[1] + " - " + b[2]
                                                }
                                            }
                                        };
                                        var j = this.rAxisUnit;
                                        for (var g = 0; g < this.connections.length; g++) {
                                            var m = this.getCircularCoordinates(this.connections[g]);
                                            var d = k(this.connections[g]);
                                            var h = this.addColorTransparency((this.connections[g].length == 2 ? this.colors[g % this.colors.length] : this.connections[g][0]), this.circularConnectionsTransparency, true);
                                            var a = this.addColorTransparency(this.foreground, 0.33, true);
                                            if (m.length > 4) {
                                                this.toRender({
                                                    p: ["drawShape", "arch", [m[0], this.cx, m[2], m[4], this.cx, m[6]],
                                                        [m[1], this.cy, m[3], m[5], this.cy, m[7]],
                                                        [m[8], m[9], m[10], m[11]],
                                                        [this.currentRadius * m[12], this.currentRadius * m[13]], h, a, "solid"
                                                    ],
                                                    a: this.getShapeArea("arch", [m[0], this.cx, m[2], m[4], this.cx, m[6]], [m[1], this.cy, m[3], m[5], this.cy, m[7]], [m[8], m[9], m[10], m[11]], [this.currentRadius * m[12], this.currentRadius * m[13]], h, a, "solid"),
                                                    i: ["Connect:" + d],
                                                    t: "Connections"
                                                })
                                            } else {
                                                this.toRender({
                                                    p: ["drawLine", "arch", [m[0], this.cx, m[2]],
                                                        [m[1], this.cy, m[3]], false, false, h, a
                                                    ],
                                                    a: this.getLineArea("arch", [m[0], this.cx, m[2]], [m[1], this.cy, m[3]], false, false, h, a),
                                                    i: ["Connect:" + d],
                                                    t: "Connections"
                                                })
                                            }
                                        }
                                    }
                                };
                                this.drawNetworkColorIndicator = function() {
                                    if (this.circularHeatmap) {
                                        this.drawColorIndicator(this.margin * 4, this.top, this.meta.def.colorBrew, "Color Indicator", true)
                                    }
                                };
                                this.checkCircularSegregationOverlays = function() {
                                    this.validateSegregation();
                                    this.validateOverlays();
                                    if (this.segregateSamplesBy.length > 0 && this.smpOverlays.includes(this.segregateSamplesBy[0])) {
                                        var b = [];
                                        for (var a = 0; a < this.smpOverlays.length; a++) {
                                            if (this.smpOverlays[a] != this.segregateSamplesBy[0]) {
                                                b.push(this.smpOverlays[a])
                                            }
                                        }
                                        this.smpOverlays = b
                                    }
                                    this.segregateSamplesByTemp = this.cloneObject(this.segregateSamplesBy);
                                    if (this.circularType == "sunburst" || this.circularType == "chord" || this.circularType == "bubble") {
                                        this.segregateSamplesBy = []
                                    }
                                };
                                this.checkCircularClustering = function() {
                                    if (!this.rAxis) {
                                        if (this.samplesClustered) {
                                            this.clusterSamples(false, true)
                                        }
                                        if (this.samplesKmeaned) {
                                            this.kmeansSamples(false, true)
                                        }
                                        if (this.segregateSamplesBy.length > 0 && this.meta.tree && this.meta.tree.samples && this.showSmpDendrogram) {
                                            if (this.segregateSamplesBy[0] && !this.smpOverlays.includes(this.segregateSamplesBy[0])) {
                                                this.smpOverlays.unshift(this.segregateSamplesBy[0]);
                                                this.tmpSegregateSamplesBy = this.segregateSamplesBy;
                                                this.tmpShowSmpOverlaysLegend = this.showSmpOverlaysLegend
                                            }
                                            this.segregateSamplesBy = [];
                                            this.showSmpOverlaysLegend = true
                                        } else {
                                            if (this.tmpSegregateSamplesBy && !this.showSmpDendrogram) {
                                                this.segregateSamplesBy = this.tmpSegregateSamplesBy
                                            }
                                        }
                                    }
                                };
                                this.setCircularTempParameters = function() {
                                    this.arcSegmentsSeparationTemp = this.arcSegmentsSeparation;
                                    this.circularCenterProportionTemp = this.circularCenterProportion;
                                    this.circularArcTemp = this.circularArc;
                                    this.outlineWidthTemp = this.outlineWidth;
                                    this.lineThicknessTemp = this.lineThickness;
                                    this.outlineWidth = 0.5;
                                    this.lineThickness = 0.5;
                                    if (this.circularType != "normal") {
                                        if (this.circularType == "radar" || this.circularType == "bubble") {
                                            this.circularCenterProportion = 0;
                                            this.arcSegmentsSeparation = 0;
                                            if (this.circularType == "bubble") {
                                                this.circularArc = 360
                                            }
                                        } else {
                                            if (this.circularType == "chord") {
                                                this.arcSegmentsSeparation = 3;
                                                this.circularCenterProportion = 0
                                            } else {
                                                if (this.circularType == "sunburst") {
                                                    this.arcSegmentsSeparation = 0
                                                }
                                            }
                                        }
                                    }
                                };
                                this.resetCircularTempParameters = function() {
                                    this.arcSegmentsSeparation = this.arcSegmentsSeparationTemp;
                                    this.circularCenterProportion = this.circularCenterProportionTemp;
                                    this.circularArc = this.circularArcTemp;
                                    this.segregateSamplesBy = this.segregateSamplesByTemp;
                                    this.outlineWidth = this.outlineWidthTemp;
                                    this.lineThickness = this.lineThicknessTemp;
                                    this.outlineWidth = this.outlineWidthTemp;
                                    this.lineThickness = this.lineThicknessTemp
                                };
                                this.setCircularAttributes = function() {
                                    this.checkCircularClustering();
                                    this.checkCircularSegregationOverlays();
                                    this.setCircularTempParameters();
                                    this.setCircularXYDimensions();
                                    this.setCircularFonts();
                                    this.setDendrograms();
                                    this.validatePropertyValues()
                                };
                                this.drawCircularPlot = function() {
                                    this.setCircularArcSegments();
                                    this.setCircularRings();
                                    this.setLegends();
                                    this.renderCircularPlot();
                                    this.drawCircularConnections();
                                    this.drawLegend();
                                    this.drawNetworkColorIndicator();
                                    this.drawTitle()
                                };
                                this.resetCircularAttributes = function() {
                                    this.resetCircularTempParameters()
                                };
                                this.initializeCircular = function() {
                                    this.setCircularAttributes();
                                    this.drawCircularPlot();
                                    this.resetCircularAttributes()
                                };
                                this.initializeCircular()
                            };
                            CanvasXpress.prototype.Map = function() {
                                this.topojsonFeature = function(g, f) {
                                    var a = function(h) {
                                        return h
                                    };
                                    var d = function(j) {
                                        if (j == null) {
                                            return a
                                        }
                                        var l, n, m = j.scale[0],
                                            k = j.scale[1],
                                            i = j.translate[0],
                                            h = j.translate[1];
                                        return function(p, r) {
                                            if (!r) {
                                                l = n = 0
                                            }
                                            var q = 2,
                                                s = p.length,
                                                o = new Array(s);
                                            o[0] = (l += p[0]) * m + i;
                                            o[1] = (n += p[1]) * k + h;
                                            while (q < s) {
                                                o[q] = p[q], ++q
                                            }
                                            return o
                                        }
                                    };
                                    var c = function(o, m) {
                                        var l, h = o.length,
                                            k = h - m;
                                        while (k < --h) {
                                            l = o[k], o[k++] = o[h], o[h] = l
                                        }
                                    };

                                    function e(m, k) {
                                        var l = k.id,
                                            j = k.bbox,
                                            h = k.properties == null ? {} : k.properties,
                                            i = b(m, k);
                                        return l == null && j == null ? {
                                            type: "Feature",
                                            properties: h,
                                            geometry: i
                                        } : j == null ? {
                                            type: "Feature",
                                            id: l,
                                            properties: h,
                                            geometry: i
                                        } : {
                                            type: "Feature",
                                            id: l,
                                            bbox: j,
                                            properties: h,
                                            geometry: i
                                        }
                                    }

                                    function b(q, j) {
                                        var l = d(q.transform),
                                            h = q.arcs;

                                        function i(t, u) {
                                            if (u.length) {
                                                u.pop()
                                            }
                                            for (var o = h[t < 0 ? ~t : t], s = 0, v = o.length; s < v; ++s) {
                                                u.push(l(o[s], s))
                                            }
                                            if (t < 0) {
                                                c(u, v)
                                            }
                                        }

                                        function p(o) {
                                            return l(o)
                                        }

                                        function r(t) {
                                            var s = [];
                                            for (var o = 0, u = t.length; o < u; ++o) {
                                                i(t[o], s)
                                            }
                                            if (s.length < 2) {
                                                s.push(s[0])
                                            }
                                            return s
                                        }

                                        function k(s) {
                                            var o = r(s);
                                            while (o.length < 4) {
                                                o.push(o[0])
                                            }
                                            return o
                                        }

                                        function n(o) {
                                            return o.map(k)
                                        }

                                        function m(u) {
                                            var s = u.type,
                                                t;
                                            switch (s) {
                                                case "GeometryCollection":
                                                    return {
                                                        type: s, geometries: u.geometries.map(m)
                                                    };
                                                case "Point":
                                                    t = p(u.coordinates);
                                                    break;
                                                case "MultiPoint":
                                                    t = u.coordinates.map(p);
                                                    break;
                                                case "LineString":
                                                    t = r(u.arcs);
                                                    break;
                                                case "MultiLineString":
                                                    t = u.arcs.map(r);
                                                    break;
                                                case "Polygon":
                                                    t = n(u.arcs);
                                                    break;
                                                case "MultiPolygon":
                                                    t = u.arcs.map(n);
                                                    break;
                                                default:
                                                    return null
                                            }
                                            return {
                                                type: s,
                                                coordinates: t
                                            }
                                        }
                                        return m(j)
                                    }
                                    return f.type === "GeometryCollection" ? {
                                        type: "FeatureCollection",
                                        features: f.geometries.map(function(h) {
                                            return e(g, h)
                                        })
                                    } : e(g, f)
                                };
                                this.graticule = function() {
                                    var r, t, u, v, d, e, f, h, m = 10,
                                        l = m,
                                        i = 90,
                                        g = 360,
                                        k, j, c, b, q = 2.5,
                                        w = 0.000001;

                                    function p(C, z, A) {
                                        C = +C, z = +z, A = (B = arguments.length) < 2 ? (z = C, C = 0, 1) : B < 3 ? 1 : +A;
                                        var y = -1,
                                            B = Math.max(0, Math.ceil((z - C) / A)) | 0,
                                            x = new Array(B);
                                        while (++y < B) {
                                            x[y] = C + y * A
                                        }
                                        return x
                                    }

                                    function o(A, z, x) {
                                        var B = p(A, z - w, x).concat(z);
                                        return function(y) {
                                            return B.map(function(C) {
                                                return [y, C]
                                            })
                                        }
                                    }

                                    function n(B, A, z) {
                                        var y = p(B, A - w, z).concat(A);
                                        return function(x) {
                                            return y.map(function(C) {
                                                return [C, x]
                                            })
                                        }
                                    }

                                    function s() {
                                        return {
                                            type: "MultiLineString",
                                            coordinates: a()
                                        }
                                    }

                                    function a() {
                                        return p(Math.ceil(v / i) * i, u, i).map(c).concat(p(Math.ceil(h / g) * g, f, g).map(b)).concat(p(Math.ceil(t / m) * m, r, m).filter(function(y) {
                                            return Math.abs(y % i) > w
                                        }).map(k)).concat(p(Math.ceil(e / l) * l, d, l).filter(function(x) {
                                            return Math.abs(x % g) > w
                                        }).map(j))
                                    }
                                    s.lines = function() {
                                        return a().map(function(x) {
                                            return {
                                                type: "LineString",
                                                coordinates: x
                                            }
                                        })
                                    };
                                    s.outline = function() {
                                        return {
                                            type: "Polygon",
                                            coordinates: [c(v).concat(b(f).slice(1), c(u).reverse().slice(1), b(h).reverse().slice(1))]
                                        }
                                    };
                                    s.extent = function(x) {
                                        if (!arguments.length) {
                                            return s.extentMinor()
                                        }
                                        return s.extentMajor(x).extentMinor(x)
                                    };
                                    s.extentMajor = function(x) {
                                        if (!arguments.length) {
                                            return [
                                                [v, h],
                                                [u, f]
                                            ]
                                        }
                                        v = +x[0][0], u = +x[1][0];
                                        h = +x[0][1], f = +x[1][1];
                                        if (v > u) {
                                            x = v, v = u, u = x
                                        }
                                        if (h > f) {
                                            x = h, h = f, f = x
                                        }
                                        return s.precision(q)
                                    };
                                    s.extentMinor = function(x) {
                                        if (!arguments.length) {
                                            return [
                                                [t, e],
                                                [r, d]
                                            ]
                                        }
                                        t = +x[0][0], r = +x[1][0];
                                        e = +x[0][1], d = +x[1][1];
                                        if (t > r) {
                                            x = t, t = r, r = x
                                        }
                                        if (e > d) {
                                            x = e, e = d, d = x
                                        }
                                        return s.precision(q)
                                    };
                                    s.step = function(x) {
                                        if (!arguments.length) {
                                            return s.stepMinor()
                                        }
                                        return s.stepMajor(x).stepMinor(x)
                                    };
                                    s.stepMajor = function(x) {
                                        if (!arguments.length) {
                                            return [i, g]
                                        }
                                        i = +x[0], g = +x[1];
                                        return s
                                    };
                                    s.stepMinor = function(x) {
                                        if (!arguments.length) {
                                            return [m, l]
                                        }
                                        m = +x[0], l = +x[1];
                                        return s
                                    };
                                    s.precision = function(x) {
                                        if (!arguments.length) {
                                            return q
                                        }
                                        q = +x;
                                        k = o(e, d, 10);
                                        j = n(t, r, q);
                                        c = o(h, f, 10);
                                        b = n(v, u, q);
                                        return s
                                    };
                                    s.extentMajor([
                                        [-180, -90 + w],
                                        [180, 90 - w]
                                    ]).extentMinor([
                                        [-180, -80 - w],
                                        [180, 80 + w]
                                    ]);
                                    return s()
                                };
                                this.configureMapFeatures = function() {
                                    if (this.mapConfigFeatures) {
                                        var z = this.meta.map.geojson;
                                        var o = z.features;
                                        for (var v = 0; v < o.length; v++) {
                                            var n = o[v];
                                            if (this.mapConfigFeatures.hasOwnProperty(v) && this.mapConfigFeatures[v].translate && this.mapConfigFeatures[v].scale) {
                                                if (n.geometry) {
                                                    var p = n.geometry.coordinates;
                                                    var A = n.geometry.type;
                                                    var a = this.mapConfigFeatures[v].translate;
                                                    var B = this.mapConfigFeatures[v].scale;
                                                    var d = this.mapConfigFeatures[v].min;
                                                    var b = this.mapConfigFeatures[v].max;
                                                    switch (A) {
                                                        case "Polygon":
                                                            for (var h = 0; h < p[0].length - 1; h++) {
                                                                if (!isNaN(p[0][h][0]) && !isNaN(p[0][h][1])) {
                                                                    var q = p[0][h][0] + a[0] > 90 ? ((p[0][h][0] + a[0]) - 180) * B[0] : p[0][h][0] + a[0] < -90 ? ((p[0][h][0] + a[0]) + 180) * B[0] : (p[0][h][0] + a[0]) * B[0];
                                                                    var u = p[0][h][1] + a[1] > 180 ? ((p[0][h][1] + a[1]) - 360) * B[1] : p[0][h][1] + a[1] < -180 ? ((p[0][h][1] + a[1]) + 360) * B[1] : (p[0][h][1] + a[1]) * B[1];
                                                                    p[0][h][0] = q;
                                                                    p[0][h][1] = u
                                                                }
                                                            }
                                                            break;
                                                        case "MultiPolygon":
                                                            for (var h = 0; h < p.length; h++) {
                                                                for (var g = 0; g < p[h].length; g++) {
                                                                    for (var e = 0; e < p[h][g].length - 1; e++) {
                                                                        if (!isNaN(p[h][g][e][0]) && !isNaN(p[h][g][e][1])) {
                                                                            var q = (p[h][g][e][0] + a[0]) * B[0];
                                                                            var u = p[h][g][e][1] + a[1] > 180 ? NaN : (p[h][g][e][1] + a[1]) * B[1];
                                                                            p[h][g][e][0] = q;
                                                                            p[h][g][e][1] = u
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            break
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setMapLayerCoordinates = function() {
                                    var x = this.meta.map.geojson;
                                    var n = x.features;
                                    var C = Number.MAX_VALUE;
                                    var z = Number.MAX_VALUE;
                                    var A = -Number.MAX_VALUE;
                                    var y = -Number.MAX_VALUE;
                                    var g = this.layoutComb ? this.layoutWidth : this.width;
                                    var q = this.layoutComb ? this.layoutHeight : this.height;
                                    for (var h = 0; h < n.length; h++) {
                                        var v = n[h];
                                        if (v.hidden) {
                                            continue
                                        }
                                        if (v.geometry) {
                                            var B = v.geometry.coordinates;
                                            var l = v.geometry.type;
                                            var o = v.coordinates = [];
                                            switch (l) {
                                                case "Polygon":
                                                    o[0] = [];
                                                    o[0][0] = [];
                                                    if (this.mapProjection != "orthographic") {
                                                        for (var u = 0; u < B[0].length - 1; u++) {
                                                            if (!isNaN(B[0][u][0]) && !isNaN(B[0][u][1])) {
                                                                o[0][0].push([B[0][u][1], B[0][u][0]]);
                                                                C = Math.min(C, B[0][u][0]);
                                                                z = Math.min(z, B[0][u][1]);
                                                                A = Math.max(A, B[0][u][0]);
                                                                y = Math.max(y, B[0][u][1])
                                                            }
                                                        }
                                                    }
                                                    break;
                                                case "MultiPolygon":
                                                    if (this.mapProjection != "orthographic") {
                                                        for (var u = 0; u < B.length; u++) {
                                                            o[u] = [];
                                                            for (var s = 0; s < B[u].length; s++) {
                                                                o[u][s] = [];
                                                                for (var r = 0; r < B[u][s].length - 1; r++) {
                                                                    if (!isNaN(B[u][s][r][0]) && !isNaN(B[u][s][r][1])) {
                                                                        o[u][s].push([B[u][s][r][1], B[u][s][r][0]]);
                                                                        C = Math.min(C, B[u][s][r][0]);
                                                                        z = Math.min(z, B[u][s][r][1]);
                                                                        A = Math.max(A, B[u][s][r][0]);
                                                                        y = Math.max(y, B[u][s][r][1])
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    break
                                            }
                                        }
                                    }
                                    if (this.mapProjection == "orthographic") {
                                        C = -180;
                                        z = -90;
                                        A = 180;
                                        y = 90
                                    }
                                    var D = this.mapCoordinateToPoint([y, C], true);
                                    var E = this.mapCoordinateToPoint([z, A], true);
                                    var a = Math.min(g / (E[0] - D[0]), q / (E[1] - D[1])) * 512;
                                    var b = Number.parseFloat(Math.log(a / 256) / Math.LN2).toFixed(1) - 0.2;
                                    var e = this.mapCoordinateToPoint([y, A], true);
                                    var m = this.mapCoordinateToPoint([z, C], true);
                                    var d = this.mapPointToCoordinate([(e[0] + m[0]) / 2, (e[1] + m[1]) / 2]);
                                    this.meta.map.geojson.geometry = {
                                        minX: C,
                                        minY: z,
                                        maxX: A,
                                        maxY: y
                                    };
                                    this.meta.map.geojson.global = {
                                        minX: C,
                                        minY: z,
                                        maxX: A,
                                        maxY: y,
                                        center: d,
                                        scale: a,
                                        zoom: b
                                    }
                                };
                                this.setMapZoomCenter = function(a) {
                                    if (this.graphType == "Map" && this.meta.map) {
                                        var e = this.meta.map.geojson;
                                        var i = e.geometry;
                                        var o = this.layoutComb ? this.layoutWidth : this.width;
                                        var f = this.layoutComb ? this.layoutHeight : this.height;
                                        if (!i.zoom || !i.center || a) {
                                            e.zoom = 1;
                                            e.center = [0, 0];
                                            e.translate = [0, 0];
                                            i.zoom = 1;
                                            i.center = [0, 0];
                                            var q = [i.maxY, i.minX];
                                            var p = [i.minY, i.maxX];
                                            var m = [i.maxY, i.maxX];
                                            var b = [i.minY, i.minX];
                                            var k = this.mapCoordinateToPoint(q, true);
                                            var l = this.mapCoordinateToPoint(p, true);
                                            var c = Math.min(o / (l[0] - k[0]), f / (l[1] - k[1])) * 512;
                                            i.zoom = Number.parseFloat(Math.log(c / 256) / Math.LN2).toFixed(1) - 0.2;
                                            var d = this.mapCoordinateToPoint(m, true);
                                            var n = this.mapCoordinateToPoint(b, true);
                                            i.center = this.mapPointToCoordinate([(d[0] + n[0]) / 2, (d[1] + n[1]) / 2], true)
                                        }
                                        if (!i.initial || a) {
                                            i.initial = {
                                                zoom: this.cloneObject(i.zoom),
                                                center: this.cloneObject(i.center),
                                                canvas: this.cloneObject([o, f])
                                            }
                                        }
                                    }
                                };
                                this.setMapTranslate = function() {
                                    if (this.graphType == "Map" && this.meta.map && this.mapProjection == "orthographic") {
                                        var a = this.meta.map.geojson.translate[0];
                                        var e = this.meta.map.geojson.translate[1];
                                        this.meta.map.geojson.translate = [0, 0];
                                        var b = this.layoutComb ? this.layoutWidth : this.width;
                                        var c = this.layoutComb ? this.layoutHeight : this.height;
                                        var d = this.mapCoordinateToPoint([0, 0], true);
                                        if (isNaN(d[0]) && isNaN(d[1])) {
                                            this.meta.map.geojson.translate = [a, e]
                                        } else {
                                            this.meta.map.geojson.translate = [Math.round(d[0] - (b / 2)), Math.round(d[1] - (c / 2))]
                                        }
                                    }
                                };
                                this.setMapLayerBounds = function() {
                                    var b = this.meta.map.geojson;
                                    var a = this.layoutComb ? this.layoutWidth : this.width;
                                    var c = this.layoutComb ? this.layoutHeight : this.height;
                                    b.zoom = this.mapConfig && this.mapConfig.zoom && !b.isZoomed ? this.mapConfig.zoom : b.geometry.zoom * this.zoom;
                                    var g = this.mapConfig && this.mapConfig.center && !b.isZoomed ? this.mapConfig.center : [b.geometry.center[1], b.geometry.center[0]];
                                    if (this.mapProjection == "orthographic" && (this.panningX || this.panningY) && this.geoProjection) {
                                        g = this.geoProjection.rotate();
                                        g[0] += this.panningX * this.rotationSensitivity / a / 4;
                                        g[1] -= this.panningY * this.rotationSensitivity / c / 4;
                                        this.panningX = 0;
                                        this.panningY = 0;
                                        this.geoProjection.rotate(g)
                                    }
                                    var f = this.mapCoordinateToPoint(g);
                                    var e = this.mapProjection == "orthographic" ? [Math.round(f[0] + b.center[0] - (a / 2)), Math.round(f[1] + b.center[1] - (c / 2))] : [Math.round(f[0] + b.center[0] - ((a / 2) + this.panningX)), Math.round(f[1] + b.center[1] - ((c / 2) + this.panningY))];
                                    b.center = e;
                                    var d = a * 0.1;
                                    var i = c * 0.1;
                                    b.bounds = {
                                        min: [Math.round(-d), Math.round(-i)],
                                        max: [Math.round(a + d), Math.round(c + i)]
                                    };
                                    this.setMapTranslate()
                                };
                                this.isMapSizeChanged = function() {
                                    if (this.graphType == "Map" && this.meta.map) {
                                        var a = this.layoutComb ? this.layoutWidth : this.width;
                                        var b = this.layoutComb ? this.layoutHeight : this.height;
                                        var d = this.meta.map.geojson.geometry;
                                        if (d.initial) {
                                            var e = d.initial.canvas;
                                            return a != e[0] || b != e[1]
                                        } else {
                                            return true
                                        }
                                    }
                                };
                                this.mapCoordinateToPoint = function(h, j) {
                                    var k = h[1] * this.mapRadian;
                                    var i = h[0] * this.mapRadian;
                                    var r = 256 * Math.pow(2, this.meta.map.geojson.zoom || 1);
                                    var n = this.meta.map.geojson.translate || [0, 0];
                                    var a = this.meta.map.geojson.center || [0, 0];
                                    if (this.mapProjection == "albers") {
                                        var e = this.mapMeanPhi * (k - this.mapCentralMeridianRad);
                                        var d = Math.sqrt(this.mapC - 2 * this.mapMeanPhi * Math.sin(i)) / this.mapMeanPhi;
                                        k = d * Math.sin(e);
                                        i = this.mapP0 - d * Math.cos(e)
                                    } else {
                                        if (this.mapProjection == "orthographic") {
                                            if (this.geoPath) {
                                                var d = this.geoPath({
                                                    type: "Point",
                                                    coordinates: [h[1], h[0]]
                                                });
                                                if (d.length) {
                                                    return [d[0][0][0], d[0][0][1]]
                                                } else {
                                                    return [NaN, NaN]
                                                }
                                            }
                                            if (!j && Math.cos(i) * Math.cos(k) <= 0) {
                                                return [NaN, NaN]
                                            }
                                            k = Math.cos(i) * Math.sin(k);
                                            i = Math.sin(i)
                                        } else {
                                            var f = 85 * this.mapRadian;
                                            var g = Math.max(Math.min(f, i), -f);
                                            var o = Math.sin(g);
                                            i = Math.log((1 + o) / (1 - o)) / 2
                                        }
                                    }
                                    k = r * (this.mapUnits * k + 0.5);
                                    i = r * (-this.mapUnits * i + 0.5);
                                    return this.mapProjection == "orthographic" ? [k - n[0], i - n[1]] : [k - a[0], i - a[1]]
                                };
                                this.mapPointToCoordinate = function(a) {
                                    var j = a[0];
                                    var i = a[1];
                                    var k = 256 * Math.pow(2, this.meta.map.geojson.zoom || 1);
                                    var e = function(c) {
                                        return c > 1 ? Math.PI / 2 : c < -1 ? -Math.PI / 2 : Math.asin(c)
                                    };
                                    j = (j / k - 0.5) / this.mapUnits;
                                    i = (i / k - 0.5) / -this.mapUnits;
                                    if (this.mapProjection == "albers") {
                                        var b = Math.atan(j / (this.mapP0 - i));
                                        var a = Math.sqrt(j * i + Math.pow(this.mapP0 - i, 2));
                                        j = (this.mapCentralMeridianRad + b / this.mapMeanPhi) * this.mapDegrees;
                                        i = (Math.asin((this.mapC - a * a * this.mapMeanPhi * this.mapMeanPhi) / (2 * this.mapMeanPhi))) * this.mapDegrees
                                    } else {
                                        if (this.mapProjection == "orthographic") {
                                            var h = Math.sqrt((j * j) + (i * i));
                                            var g = e(h);
                                            var f = Math.sin(g);
                                            var d = Math.cos(g);
                                            j = Math.atan2(j * f, h * d) * this.mapDegrees;
                                            i = e(h && i * f / h) * this.mapDegrees
                                        } else {
                                            j = j * this.mapDegrees;
                                            i = (2 * Math.atan(Math.exp(i)) - (Math.PI / 2)) * this.mapDegrees
                                        }
                                    }
                                    return [j, i]
                                };
                                this.canvasPointToCoordinate = function(k, i) {
                                    var l = this.layoutComb ? this.layoutParams[0].width : this.width;
                                    var b = this.layoutComb ? this.layoutParams[0].height : this.height;
                                    var a = this.meta.map.geojson;
                                    var d = this.mapConfig && this.mapConfig.center && !a.isZoomed ? this.mapConfig.center : a.geometry.center;
                                    var f = a.zoom;
                                    var m = Math.pow(2, f);
                                    k = ((l / 2) + ((k - (l / 2)) * (1 - 1 / m)));
                                    i = ((b / 2) + ((i - (b / 2)) * (1 - 1 / m)));
                                    var e = this.mapProjection == "orthographic" ? this.mapPointToCoordinate([k + a.translate[0], i + a.translate[1]]) : this.mapPointToCoordinate([k + a.center[0], i + a.center[1]]);
                                    return this.mapProjection == "orthographic" ? [Number(e[1] + Number(d[1])), Number(e[0] + Number(d[0]))] : e
                                };
                                this.setMapLayerPoints = function(o, n) {
                                    var s = this.meta.map.geojson;
                                    var h = s.features;
                                    for (var g = 0; g < h.length; g++) {
                                        if (h[g].hidden) {
                                            continue
                                        }
                                        var m = h[g].coordinates;
                                        if (m) {
                                            var b = h[g].parts = [];
                                            for (var f = 0; f < m.length; f++) {
                                                b[f] = [];
                                                for (var e = 0; e < m[f].length; e++) {
                                                    b[f][e] = [];
                                                    for (var d = 0; d < m[f][e].length; d++) {
                                                        var r = m[f][e][d];
                                                        var a = this.mapProjection == "orthographic" ? this.mapCoordinateToPoint(this.mapRotate(r)) : this.mapCoordinateToPoint(r);
                                                        b[f][e].push([Math.round(a[0]), Math.round(a[1])])
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.mapMidPoint = function(e, i, d, h) {
                                    var g = this.radians(h - i);
                                    e = this.radians(e);
                                    d = this.radians(d);
                                    i = this.radians(i);
                                    var b = Math.cos(d) * Math.cos(g);
                                    var a = Math.cos(d) * Math.sin(g);
                                    var c = Math.atan2(Math.sin(e) + Math.sin(d), Math.sqrt((Math.cos(e) + b) * (Math.cos(e) + b) + a * a));
                                    var f = i + Math.atan2(a, Math.cos(e) + b);
                                    return [this.degrees(c), this.degrees(f)]
                                };
                                this.mapRotate = function(j, a) {
                                    var e = j[0] * this.mapRadian;
                                    var h = j[1] * this.mapRadian;
                                    var c = Math.cos(e);
                                    var f = Math.cos(h) * c;
                                    var b = Math.sin(h) * c;
                                    var k = Math.sin(e);
                                    var i, g, d;
                                    if (a) {
                                        i = this.mapCosLat * this.mapCosLng * f + this.mapSinLng * b + this.mapSinLat * this.mapCosLng * k;
                                        g = -this.mapCosLat * this.mapSinLng * f + this.mapCosLng * b - this.mapSinLat * this.mapSinLng * k;
                                        d = -this.mapSinLat * f + this.mapCosLat * k
                                    } else {
                                        i = this.mapCosLat * this.mapCosLng * f + this.mapCosLat * this.mapSinLng * b + this.mapSinLat * k;
                                        g = -this.mapSinLng * f + this.mapCosLng * b;
                                        d = -this.mapSinLat * this.mapCosLng * f - this.mapSinLat * this.mapSinLng * b + this.mapCosLat * k
                                    }
                                    return [Math.asin(d) * this.mapDegrees, Math.atan2(g, i) * this.mapDegrees]
                                };
                                this.clipMapPoints = function() {
                                    var g = function(e, b) {
                                        var a = 0;
                                        if (e[0] < b.min[0]) {
                                            a |= 1
                                        } else {
                                            if (e[0] > b.max[0]) {
                                                a |= 2
                                            }
                                        }
                                        if (e[1] < b.min[1]) {
                                            a |= 4
                                        } else {
                                            if (e[1] > b.max[1]) {
                                                a |= 8
                                            }
                                        }
                                        e[2] = a
                                    };
                                    var A = function(B, l, i, e) {
                                        var D = l[0] - B[0];
                                        var C = l[1] - B[1];
                                        var j = e.min;
                                        var m = e.max;
                                        var q, k;
                                        if (i & 8) {
                                            q = B[0] + D * (m[1] - B[1]) / C;
                                            k = m[1]
                                        } else {
                                            if (i & 4) {
                                                q = B[0] + D * (j[1] - B[1]) / C;
                                                k = j[1]
                                            } else {
                                                if (i & 2) {
                                                    q = m[0];
                                                    k = B[1] + C * (m[0] - B[0]) / D
                                                } else {
                                                    if (i & 1) {
                                                        q = j[0];
                                                        k = B[1] + C * (j[0] - B[0]) / D
                                                    }
                                                }
                                            }
                                        }
                                        return [q, k, true]
                                    };
                                    var w = this.meta.map.geojson;
                                    var o = w.features;
                                    var f = this.cloneObject(w.bounds);
                                    f.min[0] -= 3;
                                    f.min[1] -= 3;
                                    f.max[0] += 3;
                                    f.max[1] += 3;
                                    for (var u = 0; u < o.length; u++) {
                                        if (o[u].hidden) {
                                            continue
                                        }
                                        var n = o[u].parts;
                                        if (n) {
                                            var c = [1, 4, 2, 8];
                                            for (var t = 0; t < n.length; t++) {
                                                for (var s = 0; s < n[t].length; s++) {
                                                    for (var r = 0; r < n[t][s].length; r++) {
                                                        g(n[t][s][r], f)
                                                    }
                                                }
                                            }
                                            for (var t = 0; t < n.length; t++) {
                                                for (var s = 0; s < n[t].length; s++) {
                                                    for (var x = 0; x < c.length; x++) {
                                                        var d = [];
                                                        var v = n[t][s].length;
                                                        var p = v - 1;
                                                        for (var r = 0; r < v; r++) {
                                                            var z = n[t][s][r];
                                                            var y = n[t][s][p];
                                                            if (!(z[2] & c[x])) {
                                                                if (y[2] & c[x]) {
                                                                    var h = A(y, z, c[x], f);
                                                                    g(h, f);
                                                                    d.push(h)
                                                                }
                                                                d.push(z)
                                                            } else {
                                                                if (!(y[2] & c[x])) {
                                                                    var h = A(y, z, c[x], f);
                                                                    g(h, f);
                                                                    d.push(h)
                                                                }
                                                            }
                                                            p = r
                                                        }
                                                        n[t][s] = d
                                                    }
                                                }
                                            }
                                        }
                                    }
                                };
                                this.simplifyMapPoints = function() {
                                    var h = function(p, k) {
                                        var j = k[0] - p[0];
                                        var i = k[1] - p[1];
                                        return j * j + i * i
                                    };
                                    var b = function(q, k) {
                                        var s = [q[0]];
                                        var j = q.length;
                                        var r = 0;
                                        for (var p = 1; p < j; p++) {
                                            if (h(q[p], q[r]) > k) {
                                                s.push(q[p]);
                                                r = p
                                            }
                                        }
                                        if (r < j - 1) {
                                            s.push(q[j - 1])
                                        }
                                        return s
                                    };
                                    var c = function(j, s, r) {
                                        var q = s[0];
                                        var k = s[1];
                                        var w = r[0] - q;
                                        var v = r[1] - k;
                                        var i = w * w + v * v;
                                        var u;
                                        if (i > 0) {
                                            u = ((j[0] - q) * w + (j[1] - k) * v) / i;
                                            if (u > 1) {
                                                q = r[0];
                                                k = r[1]
                                            } else {
                                                if (u > 0) {
                                                    q += w * u;
                                                    k += v * u
                                                }
                                            }
                                        }
                                        w = j[0] - q;
                                        v = j[1] - k;
                                        return w * w + v * v
                                    };
                                    var a = function(v, k, j, s, u) {
                                        var q = 0;
                                        var t;
                                        var r;
                                        for (var p = s + 1; p <= u - 1; p++) {
                                            r = c(v[p], v[s], v[u]);
                                            if (r > q) {
                                                t = p;
                                                q = r
                                            }
                                        }
                                        if (q > j) {
                                            k[t] = 1;
                                            a(v, k, j, s, t);
                                            a(v, k, j, t, u)
                                        }
                                    };
                                    var l = function(r, k) {
                                        var j = r.length;
                                        var q = typeof Uint8Array !== undefined + "" ? Uint8Array : Array;
                                        var t = new q(j);
                                        t[0] = t[j - 1] = 1;
                                        a(r, t, k, 0, j - 1);
                                        var s = [];
                                        for (var p = 0; p < j; p++) {
                                            if (t[p]) {
                                                s.push(r[p])
                                            }
                                        }
                                        return s
                                    };
                                    var o = function(k, i) {
                                        if (!i || !k.length) {
                                            return k.slice()
                                        }
                                        var j = i * i;
                                        k = b(k, j);
                                        k = l(k, j);
                                        return k
                                    };
                                    var n = this.meta.map.geojson;
                                    var m = n.features;
                                    for (var g = 0; g < m.length; g++) {
                                        if (m[g].hidden) {
                                            continue
                                        }
                                        var f = m[g].parts;
                                        if (f) {
                                            for (var e = 0; e < f.length; e++) {
                                                for (var d = 0; d < f[e].length; d++) {
                                                    f[e][d] = o(f[e][d], 1)
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawMapGraticule = function() {
                                    if (this.mapGraticuleShow) {
                                        var h = this.graticule();
                                        var l = this.mapProjection == "orthographic" ? this.geoPath(this.geoGraticule) : h.coordinates;
                                        var a = 0;
                                        var d = this.mapGraticuleType == "dashed" ? "dashedSpline" : "spline";
                                        for (var f = 0; f < l.length; f++) {
                                            var b = [];
                                            var m = [];
                                            for (var e = 0; e < l[f].length; e++) {
                                                var o = l[f][e];
                                                var p = this.mapProjection == "orthographic" ? o : this.mapCoordinateToPoint([o[1], o[0]]);
                                                if (isNaN(p[0]) || isNaN(p[1])) {
                                                    if (b.length) {
                                                        this.toRender({
                                                            p: ["drawLine", d, b, m, false, false, "black", "0.1"],
                                                            a: this.getLineArea(d, b, m, false, false, "black", "0.1"),
                                                            i: ["Graticule:" + a++],
                                                            t: "Axes"
                                                        });
                                                        b = [];
                                                        m = []
                                                    }
                                                } else {
                                                    b.push(p[0]);
                                                    m.push(p[1])
                                                }
                                            }
                                            if (b.length) {
                                                this.toRender({
                                                    p: ["drawLine", d, b, m, false, false, "black", "0.1"],
                                                    a: this.getLineArea(d, b, m, false, false, "black", "0.1"),
                                                    i: ["Graticule:" + a++],
                                                    t: "Axes"
                                                })
                                            }
                                        }
                                    }
                                };
                                this.drawMapLayer = function(E) {
                                    var q = null;
                                    var s = E.properties.varId ? this.commonElementsInArrays(E.properties.varId, this.varIndices) : [];
                                    var d = this.getSampleIndices(this.colorBy);
                                    var r = this.colorBy && d >= 0 ? d : this.colorBy && s.length ? s[0] : -1;
                                    var l = this.sizeBy ? this.getSampleIndices(this.sizeBy) : -1;
                                    var D = this.sizeBy && l >= 0 && s.length ? this.data.y.data[s[0]][l] : 0;
                                    var e = this.colorBy && s.length && d >= 0 ? this.getPropertyValue(s[0], r, "colorBy") : this.colorBy && s.length ? this.getPropertyValue(r, null, "colorBy") : this.colorBy && E.id != null && this.isNumeric(E.id) ? this.getPropertyValue(E.id, null, "colorBy") : this.mapColor;
                                    var z = this.sizeBy && s.length && l >= 0 ? this.getPropertyValue(s[0], l, "sizeBy") : 0;
                                    var g = this.mapProjection == "orthographic" ? this.geoPath({
                                        type: "FeatureCollection",
                                        features: [E]
                                    }) : E.parts;
                                    var n = this.decorations && this.decorations.pie;
                                    if (g && !E.hidden) {
                                        var p, m;
                                        var C = this.isUSAMap ? CanvasXpress.usa[E.properties.key] : this.isWorldMap ? CanvasXpress.countries[E.properties.key] : false;
                                        if (C && D) {
                                            var A = C.length;
                                            var w = this.mapCoordinateToPoint([C[A - 2], C[A - 1]]);
                                            if (this.isUSAMap && this.mapProjection == "albers") {
                                                if (E.properties.key == "AK") {
                                                    w = this.mapCoordinateToPoint([27.5, -112])
                                                } else {
                                                    if (E.properties.key == "HI") {
                                                        w = this.mapCoordinateToPoint([26.5, -104])
                                                    }
                                                }
                                            }
                                            p = w[0];
                                            m = w[1]
                                        }
                                        var F = ["MapKey:" + E.properties.key, [Math.max(0, d)]];
                                        var a = !this.isDOE || (this.isDOE && this.data.l.doe.includes(s[0])) ? this.getFillColor(e, F) : "rgba(0,0,0,0)";
                                        var y = this.mapOutlineColor == "useBackground" ? this.background : this.getOutlineColor(this.mapOutlineColor, F);
                                        var b = !this.colorBy ? false : this.data.z && this.data.z.hasOwnProperty(this.colorBy) && this.hiddenLegends["Property:" + this.colorBy + ":" + this.data.z[this.colorBy][r] + ":z"] ? true : false;
                                        if (this.mapProjection == "orthographic") {
                                            for (var x = 0; x < g.length; x++) {
                                                var h = [];
                                                var v = [];
                                                for (var u = 0; u < g[x].length; u++) {
                                                    var f = g[x][u];
                                                    if (!isNaN(f[0]) || !isNaN(f[1])) {
                                                        h.push(f[0]);
                                                        v.push(f[1])
                                                    } else {
                                                        if (h.length && v.length) {
                                                            var o = this.toRender({
                                                                p: ["drawShape", "polygon", h, v, false, false, a, y],
                                                                a: this.getShapeArea("polygon", h, v, false, false, a, y),
                                                                i: F,
                                                                g: q,
                                                                t: "Data",
                                                                h: b
                                                            });
                                                            if (q == null) {
                                                                q = o
                                                            }
                                                            h = [];
                                                            v = []
                                                        }
                                                    }
                                                }
                                                if (h.length && v.length) {
                                                    var o = this.toRender({
                                                        p: ["drawShape", "polygon", h, v, false, false, a, y],
                                                        a: this.getShapeArea("polygon", h, v, false, false, a, y),
                                                        i: F,
                                                        g: q,
                                                        t: "Data",
                                                        h: b
                                                    });
                                                    if (q == null) {
                                                        q = o
                                                    }
                                                }
                                            }
                                        } else {
                                            for (var x = 0; x < g.length; x++) {
                                                for (var u = 0; u < g[x].length; u++) {
                                                    var h = [];
                                                    var v = [];
                                                    for (var t = 0; t < g[x][u].length; t++) {
                                                        var f = g[x][u][t];
                                                        if (!isNaN(f[0]) || !isNaN(f[1])) {
                                                            h.push(f[0]);
                                                            v.push(f[1])
                                                        } else {
                                                            if (h.length && v.length) {
                                                                var o = this.toRender({
                                                                    p: ["drawShape", "polygon", h, v, false, false, a, y],
                                                                    a: this.getShapeArea("polygon", h, v, false, false, a, y),
                                                                    i: F,
                                                                    g: q,
                                                                    t: "Data",
                                                                    h: b
                                                                });
                                                                if (q == null) {
                                                                    q = o
                                                                }
                                                                h = [];
                                                                v = []
                                                            }
                                                        }
                                                    }
                                                    if (h.length && v.length) {
                                                        var o = this.toRender({
                                                            p: ["drawShape", "polygon", h, v, false, false, a, y],
                                                            a: this.getShapeArea("polygon", h, v, false, false, a, y),
                                                            i: F,
                                                            g: q,
                                                            t: "Data",
                                                            h: b
                                                        });
                                                        if (q == null) {
                                                            q = o
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        if (this.sizeBy && p && m && D && !n) {
                                            this.toRender({
                                                p: ["drawShape", "circle", p, m, z * 1.2, z * 1.2, "rgba(255,0,0,0.6)", this.mapOutlineColor],
                                                t: "Data"
                                            })
                                        }
                                    }
                                    if (this.motionBy) {
                                        var B = this.left + this.x;
                                        var c = this.top + this.y + (this.margin * 2);
                                        this.toRender({
                                            p: ["drawText", this.motionObject.current, B, c, this.motionCurrentFont, this.motionCurrentColor, "right", "bottom"],
                                            t: "Data"
                                        })
                                    }
                                };
                                this.drawMapPieDecoration = function(m) {
                                    var a = m.properties.varId ? this.commonElementsInArrays(m.properties.varId, this.varIndices) : [];
                                    var l = this.sizeBy ? this.getSampleIndices(this.sizeBy) : -1;
                                    var d = this.sizeBy && a.length && l >= 0 ? this.getPropertyValue(a[0], l, "sizeBy") : 0;
                                    if (m.parts) {
                                        var f = this.isUSAMap ? CanvasXpress.usa[m.properties.key] : this.isWorldMap ? CanvasXpress.countries[m.properties.key] : false;
                                        if (f && !m.hidden && this.decorations && this.decorations.pie && this.decorations.pie[0] && a[0]) {
                                            var n = f.length;
                                            var g = this.mapCoordinateToPoint([f[n - 2], f[n - 1]]);
                                            var c = false;
                                            if (this.isUSAMap && this.mapProjection == "albers") {
                                                if (m.properties.key == "AK") {
                                                    g = this.mapCoordinateToPoint([27.5, -112])
                                                } else {
                                                    if (m.properties.key == "HI") {
                                                        g = this.mapCoordinateToPoint([26.5, -104])
                                                    }
                                                }
                                            }
                                            if (this.isUSAMap && this.decorations && this.decorations.pie) {
                                                switch (m.properties.key) {
                                                    case "CT":
                                                        c = this.mapCoordinateToPoint([f[n - 2] - 1.8, f[n - 1] + 1.4]);
                                                        break;
                                                    case "DE":
                                                        c = this.mapCoordinateToPoint([f[n - 2] - 3.5, f[n - 1] + 2.4]);
                                                        break;
                                                    case "DC":
                                                        c = this.mapCoordinateToPoint([f[n - 2] - 5.8, f[n - 1] + 2.5]);
                                                        break;
                                                    case "MD":
                                                        c = this.mapCoordinateToPoint([f[n - 2], f[n - 1] + 0.6]);
                                                        break;
                                                    case "NJ":
                                                        c = this.mapCoordinateToPoint([f[n - 2] - 2.2, f[n - 1] + 1.3]);
                                                        break;
                                                    case "RI":
                                                        c = this.mapCoordinateToPoint([f[n - 2] - 0.7, f[n - 1] + 2.8]);
                                                        break;
                                                    case "VT":
                                                        c = this.mapCoordinateToPoint([f[n - 2] + 2, f[n - 1]]);
                                                        break;
                                                    case "MA":
                                                        c = this.mapCoordinateToPoint([f[n - 2] + 0.8, f[n - 1] + 3.5]);
                                                        break
                                                }
                                            }
                                        }
                                        if (this.decorations && this.decorations.pie && this.decorations.pie[0] && a[0] && g) {
                                            var k = [];
                                            var o = [a[0]];
                                            for (var j = 0; j < this.decorations.pie[0].idxs.length; j++) {
                                                k.push(this.data.y.data[a[0]][this.decorations.pie[0].idxs[j]]);
                                                o.push(this.decorations.pie[0].idxs[j])
                                            }
                                            var e = this.decorations.pie[0].colors || false;
                                            var b = this.sizeBy ? d : ((this.decorations.pie[0].size || 3) * this.meta.map.geojson.zoom) + (this.meta.map.geojson.zoom > 4 ? 5 : 0);
                                            var h = this.setPieData(k, false, e);
                                            if (c) {
                                                this.toRender({
                                                    p: ["drawLine", "solid", c[0], c[1], g[0], g[1]],
                                                    t: "Decorations"
                                                });
                                                this.drawPie(h, c[0], c[1], b, [o])
                                            } else {
                                                this.drawPie(h, g[0], g[1], b, [o])
                                            }
                                        }
                                    }
                                };
                                this.drawMapConnections = function() {
                                    if (this.decorations && this.decorations.connections) {
                                        var g = this;
                                        var j = function(t, y, s, x) {
                                            var w = g.radians(x - y);
                                            t = g.radians(t);
                                            s = g.radians(s);
                                            y = g.radians(y);
                                            var i = Math.cos(s) * Math.cos(w);
                                            var c = Math.cos(s) * Math.sin(w);
                                            var m = Math.atan2(Math.sin(t) + Math.sin(s), Math.sqrt((Math.cos(t) + i) * (Math.cos(t) + i) + c * c));
                                            var v = y + Math.atan2(c, Math.cos(t) + i);
                                            return [g.degrees(m), g.degrees(v)]
                                        };
                                        for (var f = 0; f < this.decorations.connections.length; f++) {
                                            var h = this.decorations.connections[f];
                                            if (h.source && h.source.length == 2 && h.target && h.target.length == 2) {
                                                var u = this.mapCoordinateToPoint(h.source);
                                                var l = u[0];
                                                var k = u[1];
                                                var q = this.mapCoordinateToPoint(h.target);
                                                var e = q[0];
                                                var d = q[1];
                                                var r = "markerCon" + f;
                                                var a = h.color || "red";
                                                if (h.type.match(/spline/)) {
                                                    var o = j(h.source[0], h.source[1], h.target[0], h.target[1]);
                                                    var b = this.mapCoordinateToPoint(o);
                                                    var p = b[0];
                                                    var n = b[1];
                                                    this.toRender({
                                                        p: ["drawLine", h.type, [l, p, e],
                                                            [k, n, d], false, false, a
                                                        ],
                                                        a: this.getLineArea(h.type, [l, p, e], [k, n, d], false, false, a),
                                                        i: ["Connection:" + r],
                                                        t: "Decorations"
                                                    })
                                                } else {
                                                    this.toRender({
                                                        p: ["drawLine", h.type, l, k, e, d, a],
                                                        a: this.getLineArea(h.type, l, k, e, d, a),
                                                        i: ["Connection:" + r],
                                                        t: "Decorations"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawMapMarkers = function() {
                                    if (this.decorations && this.decorations.marker) {
                                        for (var f = 0; f < this.decorations.marker.length; f++) {
                                            var e = this.decorations.marker[f];
                                            var g = this.meta.map.geojson.zoom ? this.meta.map.geojson.zoom : 1;
                                            if ((e.lat && e.lng) || (e.Lat && e.Lng) || (e.latitude && e.longitude) || (e.Latitude && e.Longitude) || (e.coords && e.coords.length == 2)) {
                                                var h = e.lat || e.Lat || e.latitude || e.Latitude || e.coords[0];
                                                var j = e.lng || e.Lng || e.longitude || e.Longitude || e.coords[1];
                                                var d = this.mapCoordinateToPoint([h, j]);
                                                var p = d[0];
                                                var l = d[1];
                                                var b = (e.size || this.margin) * g;
                                                var o = "markerPos" + f;
                                                var n = this.toRender({
                                                    p: ["drawShape", e.shape || "drop", p, l, b, b, e.color || "red", this.mapOutlineColor],
                                                    a: this.getShapeArea(e.shape || "drop", p, l, b, b, e.color || "red", this.mapOutlineColor),
                                                    i: ["Marker:" + o + ":[ " + h + ", " + j + " ]"],
                                                    t: "Decorations"
                                                });
                                                if (e.label || e.text) {
                                                    this.toRender({
                                                        p: ["drawText", e.label || e.text, p, l, this.font, this.fontColor, "center", "middle"],
                                                        a: this.getTextArea(e.label, p, l, this.font, this.fontColor, "center", "middle"),
                                                        i: ["Marker:" + o + "-text:[ " + h + ", " + j + " ]"],
                                                        g: n,
                                                        t: "Decorations"
                                                    })
                                                }
                                            }
                                        }
                                    } else {
                                        if (this.markerBy && this.data.x.hasOwnProperty(this.markerBy)) {
                                            var k = this.data.x;
                                            var g = this.meta.map.geojson.zoom ? this.meta.map.geojson.zoom : 1;
                                            for (var f = 0; f < k[this.markerBy].length; f++) {
                                                var h = k.lat ? k.lat[f] : k.Lat ? k.Lat[f] : k.latitude ? k.latitude[f] : k.Latitude ? k.Latitude[f] : false;
                                                var j = k.lng ? k.lng[f] : k.Lng ? k.Lng[f] : k.longitude ? k.longitude[f] : k.Longitude ? k.Longitude[f] : false;
                                                if (h != null && j != null) {
                                                    var d = this.mapCoordinateToPoint([h, j]);
                                                    var p = d[0];
                                                    var l = d[1];
                                                    var b = k.size ? k.size[f] * g : this.margin * g;
                                                    var q = k.shape ? k.shape[f] : "drop";
                                                    var c = this.getPropertyValue(0, f, "markerBy");
                                                    var o = "markerBy" + f;
                                                    if (this.motionBy) {
                                                        var a = k[this.motionBy][f];
                                                        if (a != this.motionObject.current) {
                                                            continue
                                                        }
                                                    }
                                                    this.toRender({
                                                        p: ["drawShape", q, p, l, b, b, c, this.mapOutlineColor],
                                                        a: this.getShapeArea("drawShape", q, p, l, b, b, c, this.mapOutlineColor),
                                                        i: ["Marker:" + o + ": [" + h + ", " + j + " ]"],
                                                        t: "Decorations"
                                                    })
                                                }
                                            }
                                        }
                                    }
                                };
                                this.drawMapBorder = function() {
                                    if (this.mapProjection == "orthographic") {
                                        var a = this.layoutComb ? this.layoutWidth : this.width;
                                        var c = this.layoutComb ? this.layoutHeight : this.height;
                                        var b = c * 0.86 * this.zoom;
                                        this.toRender({
                                            p: ["drawShape", "circle", a / 2, c / 2, b, b, false, this.mapOutlineColor, "open"],
                                            t: "Axes"
                                        });
                                        this.meta.map.geojson.center = [0, 0]
                                    }
                                };
                                this.setMapDimensions = function() {
                                    if (this.layoutComb) {
                                        this.x = this.layoutWidth - (this.marginLeft + this.left + this.right + this.marginRight);
                                        this.y = this.layoutHeight - (this.marginTop + this.top + this.bottom + this.marginBottom)
                                    } else {
                                        this.x = this.width - (this.marginLeft + this.left + this.right + this.marginRight);
                                        this.y = this.height - (this.marginTop + this.top + this.bottom + this.marginBottom + (this.motionBy ? 40 : 0));
                                        if (this.motionBy && !this.reproducing) {
                                            this.addMotionDiv()
                                        }
                                    }
                                };
                                this.setMapColors = function() {
                                    if (this.colorBy && !this.colorBy.match(/variable|sample/i) && this.meta.data.z && this.meta.data.z[this.colorBy] && this.meta.data.z[this.colorBy].colors && this.colors.length < this.meta.data.z[this.colorBy].colors.length) {
                                        this.colors = this.meta.data.z[this.colorBy].colors
                                    }
                                };
                                this.addMapData = function() {
                                    var b = [];
                                    var C = {};
                                    var h = {};
                                    var g = this.meta.map.geojson ? this.meta.map.geojson.features : false;
                                    var k = this;
                                    var f = 0;
                                    var m = 0;
                                    var d = function(j, o) {
                                        var E = j.id ? j.id : o;
                                        var p = j.properties ? j.properties : {};
                                        var i = p.name || p.NAME || p.Name;
                                        if (A.hasOwnProperty(i) && C[i]) {
                                            f++;
                                            return i
                                        } else {
                                            if (c.hasOwnProperty(i) && C[i]) {
                                                m++;
                                                return i
                                            } else {
                                                if (A.hasOwnProperty(E) && C[E]) {
                                                    f++;
                                                    return E
                                                } else {
                                                    if (c.hasOwnProperty(E) && C[E]) {
                                                        m++;
                                                        return E
                                                    } else {
                                                        return E
                                                    }
                                                }
                                            }
                                        }
                                    };
                                    var z = function() {
                                        var i = {};
                                        for (var j in CanvasXpress.countries) {
                                            i[j] = j;
                                            i[CanvasXpress.countries[j][0]] = j;
                                            i[CanvasXpress.countries[j][3]] = j
                                        }
                                        return i
                                    };
                                    var s = function() {
                                        var j = {};
                                        for (var i in CanvasXpress.usa) {
                                            j[i] = i;
                                            j[CanvasXpress.usa[i][0]] = i
                                        }
                                        return j
                                    };
                                    var a = function(o, j) {
                                        for (var F in o) {
                                            if (F == "varId" || F == "key") {
                                                continue
                                            }
                                            if (j != null) {
                                                if (!k.data.z.hasOwnProperty(F)) {
                                                    k.data.z[F] = []
                                                }
                                                k.data.z[F][j] = o[F]
                                            } else {
                                                if (!k.data.z.hasOwnProperty(F)) {
                                                    k.data.z[F] = []
                                                }
                                                for (var E = 0; E < o.varId.length; E++) {
                                                    k.data.z[F][o.varId[E]] = o[F]
                                                }
                                            }
                                        }
                                    };
                                    var c = z();
                                    var A = s();
                                    if (g) {
                                        for (var y = 0; y < g.length; y++) {
                                            var v = g[y];
                                            var t = v.id ? v.id : v.properties && v.properties.id ? v.properties.id : v.properties && v.properties.key ? v.properties.key : "Id" + (y + 1);
                                            if (!v.id) {
                                                v.id = t
                                            }
                                            b.push([t, v.properties]);
                                            h[t] = y
                                        }
                                    }
                                    if (this.isExample) {
                                        var D = {
                                            y: {
                                                vars: [],
                                                smps: ["Order"],
                                                data: []
                                            },
                                            z: {
                                                id: []
                                            }
                                        };
                                        this.$(this.target).style.display = "block";
                                        for (var y = 0; y < b.length; y++) {
                                            C[b[y][0]] = [y]
                                        }
                                        for (var y = 0; y < b.length; y++) {
                                            var u = b[y];
                                            D.y.data.push([y]);
                                            D.y.vars.push(u[1].name || u[0]);
                                            D.z.id.push(u[0] || null)
                                        }
                                        this.updateData(D, false, true)
                                    } else {
                                        var e = false;
                                        var w = 0;
                                        if (this.data.z) {
                                            for (var y in this.data.z) {
                                                if (y.match(/country|Country|state|State/)) {
                                                    e = y;
                                                    break
                                                }
                                            }
                                        } else {
                                            this.data.z = {}
                                        }
                                        this.data.z.id = [];
                                        this.data.z.name = [];
                                        if (!e) {
                                            for (var y = 0; y < this.data.y.vars.length; y++) {
                                                var n = this.data.y.vars[y];
                                                if (h.hasOwnProperty(n)) {
                                                    w++
                                                }
                                            }
                                        }
                                        for (var y = 0; y < this.data.y.vars.length; y++) {
                                            var n = this.data.y.vars[y];
                                            var q = null;
                                            if (c.hasOwnProperty(n) || A.hasOwnProperty(n)) {
                                                q = A[n] || c[n]
                                            } else {
                                                if (e) {
                                                    q = this.data.z[e][y]
                                                } else {
                                                    if (w) {
                                                        q = n
                                                    }
                                                }
                                            }
                                            this.data.z.id.push(q);
                                            if (q != null) {
                                                if (!C.hasOwnProperty(q)) {
                                                    C[q] = []
                                                }
                                                C[q].push(y)
                                            }
                                        }
                                        for (var y = 0; y < b.length; y++) {
                                            var u = b[y];
                                            var q = u[1].hasOwnProperty("name") && (c.hasOwnProperty(u[1].name) || A.hasOwnProperty(u[1].name)) ? (A[u[1].name] || c[u[1].name]) : u[1].hasOwnProperty("NAME") && (c.hasOwnProperty(u[1].NAME) || A.hasOwnProperty(u[1].NAME)) ? (A[u[1].NAME] || c[u[1].NAME]) : (c.hasOwnProperty(u[0]) || A.hasOwnProperty(u[0])) ? (A[u[0]] || c[u[0]]) : null;
                                            if (q != null && C.hasOwnProperty(q)) {
                                                for (var x = 0; x < C[q].length; x++) {
                                                    var B = C[q][x];
                                                    if (u[1].hasOwnProperty("name") && (c.hasOwnProperty(u[1].name) || A.hasOwnProperty(u[1].name))) {
                                                        this.data.z.name[B] = A.hasOwnProperty(u[1].name) ? CanvasXpress.usa[q][0] : CanvasXpress.countries[q][0]
                                                    } else {
                                                        if (u[1].hasOwnProperty("NAME") && (c.hasOwnProperty(u[1].NAME) || A.hasOwnProperty(u[1].NAME))) {
                                                            this.data.z.name[B] = A.hasOwnProperty(u[1].NAME) ? CanvasXpress.usa[q][0] : CanvasXpress.countries[q][0]
                                                        } else {
                                                            this.data.z.name[B] = null
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        this.updateData(this.cloneObject(this.data), false, true)
                                    }
                                    if (g) {
                                        for (var y = 0; y < g.length; y++) {
                                            var r = g[y].properties;
                                            var q = d(g[y], this.data.y.vars[y]);
                                            r.varId = q != null ? C[q] : [null];
                                            r.key = q || g[y].id;
                                            if (r.varId) {
                                                a(r)
                                            } else {
                                                a(r, g[y].id || y)
                                            }
                                        }
                                        if (m > 100) {
                                            this.isWorldMap = true
                                        } else {
                                            if (f > 40) {
                                                this.isUSAMap = true
                                            }
                                        }
                                    }
                                    this.updateData(this.cloneObject(this.data), false, true);
                                    this.validatePropertyValues();
                                    this.mapVarIds = C
                                };
                                this.setMapSmps = function() {
                                    this.mapSmpIndices = [];
                                    if (this.mapSmps.length == 0) {
                                        this.mapSmps.push(this.data.y.smps[0])
                                    }
                                    for (var c = 0; c < this.mapSmps.length; c++) {
                                        var a = this.getSampleIndices(this.mapSmps[c]);
                                        if (a > -1) {
                                            this.mapSmpIndices.push(a)
                                        }
                                    }
                                    if (this.decorations && this.decorations.pie) {
                                        var b = this.decorations.pie[0];
                                        if (b.smps) {
                                            b.idxs = [];
                                            for (var c = 0; c < b.smps.length; c++) {
                                                var a = this.getSampleIndices(b.smps[c]);
                                                if (a > -1) {
                                                    b.idxs.push(a)
                                                }
                                            }
                                        }
                                    }
                                };
                                this.setMapParameters = function() {
                                    this.mapPI = Math.PI;
                                    this.mapPI2 = Math.PI * 2;
                                    this.mapPIhlf = Math.PI / 2;
                                    this.mapRadian = Math.PI / 180;
                                    this.mapDegrees = 180 / Math.PI;
                                    this.mapUnits = 0.5 / Math.PI;
                                    this.mapLatitudeOriginRad = this.mapLatitudeOrigin * this.mapRadian;
                                    this.mapCentralMeridianRad = this.mapCentralMeridian * this.mapRadian;
                                    this.mapStandardParallel1Rad = this.mapStandardParallel1 * this.mapRadian;
                                    this.mapStandardParallel2Rad = this.mapStandardParallel2 * this.mapRadian;
                                    this.mapSinPhi1 = Math.sin(this.mapStandardParallel1Rad);
                                    this.mapCosPhi1 = Math.cos(this.mapStandardParallel1Rad);
                                    this.mapMeanPhi = (Math.sin(this.mapStandardParallel1Rad) + Math.sin(this.mapStandardParallel2Rad)) / 2;
                                    this.mapC = (this.mapCosPhi1 * this.mapCosPhi1) + (2 * this.mapMeanPhi * this.mapSinPhi1);
                                    this.mapP0 = Math.sqrt(this.mapC - (2 * this.mapMeanPhi * Math.sin(this.mapLatitudeOriginRad))) / this.mapMeanPhi;
                                    this.mapRotationLat = this.mapConfig && this.mapConfig.center ? this.mapConfig.center[1] % 360 * this.mapRadian : 0;
                                    this.mapRotationLng = this.mapConfig && this.mapConfig.center ? (-this.mapConfig.center[0] + 90) % 360 * this.mapRadian : 0;
                                    this.mapCosLat = Math.cos(this.mapRotationLat);
                                    this.mapSinLat = Math.sin(this.mapRotationLat);
                                    this.mapCosLng = Math.sin(this.mapRotationLng);
                                    this.mapSinLng = Math.cos(this.mapRotationLng)
                                };
                                this.setMapAttributes = function(a) {
                                    if (this.meta.map) {
                                        this.setMapParameters();
                                        if (!a) {
                                            this.setMapLayerCoordinates();
                                            this.setMapZoomCenter()
                                        } else {
                                            if (this.isMapSizeChanged()) {
                                                this.setMapZoomCenter(true)
                                            }
                                        }
                                        this.setMapLayerBounds();
                                        this.setMapLayerPoints();
                                        this.clipMapPoints();
                                        this.simplifyMapPoints()
                                    }
                                };
                                this.drawMapData = function() {
                                    if (this.meta.map) {
                                        this.legendInside = true;
                                        if (this.meta.map.geojson) {
                                            if (!this.layoutValid) {
                                                this.toRender({
                                                    p: ["setClipArea"],
                                                    t: "Data"
                                                })
                                            }
                                            this.drawMapGraticule();
                                            for (var a = 0; a < this.meta.map.geojson.features.length; a++) {
                                                this.drawMapLayer(this.meta.map.geojson.features[a])
                                            }
                                            if (this.decorations && this.decorations.pie && this.decorations.pie[0] && !this.layoutValid) {
                                                for (var a = 0; a < this.meta.map.geojson.features.length; a++) {
                                                    this.drawMapPieDecoration(this.meta.map.geojson.features[a])
                                                }
                                            }
                                            if (!this.layoutValid) {
                                                this.toRender({
                                                    p: ["resetClipArea"],
                                                    t: "Data"
                                                })
                                            }
                                            this.drawMapBorder();
                                            this.drawLegend();
                                            this.drawMapConnections();
                                            this.drawMapMarkers();
                                            this.drawTitle()
                                        }
                                    }
                                };
                                this.drawMap = function() {
                                    this.hideUnhideMapFeatures(this.hiddenMapFeatures, true);
                                    this.hideUnhideMapFeatures(this.visibleMapFeatures, false, this.visibleMapFeatures.length);
                                    this.setMapAttributes(this.layoutValid ? false : this.mapInitialized);
                                    if (!this.mapInitialized) {
                                        this.addMapData();
                                        this.setMapSmps();
                                        this.mapInitialized = true
                                    }
                                    this.setLegends();
                                    this.setMapDimensions();
                                    this.initializeOrthographic();
                                    this.setMapColors();
                                    this.drawMapData()
                                };
                                this.initializeMap = function() {
                                    if (!this.meta.hasOwnProperty("map")) {
                                        this.meta.map = {}
                                    }
                                    if (!this.meta.map.hasOwnProperty("geojson")) {
                                        if (window[this.mapId] && window[this.mapId].hasOwnProperty("objects")) {
                                            var a = window[this.mapId];
                                            var c = Object.keys(a.objects);
                                            var b = c[c.length - 1];
                                            var d = a.objects[b];
                                            this.meta.map.geojson = this.topojsonFeature(a, d)
                                        } else {
                                            if (window[this.mapId]) {
                                                this.meta.map.geojson = window[this.mapId]
                                            } else {
                                                if (this.meta.config.user.topoJSON) {
                                                    window[this.mapId] = this.meta.config.user.topoJSON;
                                                    this.meta.map.geojson = window[this.mapId]
                                                }
                                            }
                                        }
                                        this.configureMapFeatures();
                                        this.setAllMapFeaturesVisible()
                                    }
                                    this.Orthographic();
                                    if (this.layoutValid) {
                                        this.drawLayoutCompartments(this.drawMap)
                                    } else {
                                        this.drawMap()
                                    }
                                };
                                this.initializeMap()
                            };
                            CanvasXpress.prototype.Orthographic = function() {
                                this.d3Geo = function() {
                                    var at = 0.000001,
                                        ay = at * at,
                                        J = Math.PI,
                                        bl = 2 * J,
                                        aX = J / 2,
                                        Q = J / 180,
                                        al = 180 / J;
                                    var aa = this;
                                    var af = Math.abs;

                                    function az(bm) {
                                        return bm > 0 ? 1 : bm < 0 ? -1 : 0
                                    }

                                    function k(bn, bm, bo) {
                                        return (bm[0] - bn[0]) * (bo[1] - bn[1]) - (bm[1] - bn[1]) * (bo[0] - bn[0])
                                    }

                                    function bi(bm) {
                                        return bm > 1 ? 0 : bm < -1 ? J : Math.acos(bm)
                                    }

                                    function ap(bm) {
                                        return bm > 1 ? aX : bm < -1 ? -aX : Math.asin(bm)
                                    }

                                    function T(bm) {
                                        return (bm = Math.sin(bm / 2)) * bm
                                    }

                                    function bg() {}

                                    function ah(bm) {
                                        return bm
                                    }
                                    var M = {};

                                    function aD() {}
                                    aD.prototype = {
                                        s: 0,
                                        t: 0,
                                        add: function(bm) {
                                            aR(bm, this.t, aJ);
                                            aR(aJ.s, this.s, this);
                                            if (this.s) {
                                                this.t += aJ.t
                                            } else {
                                                this.s = aJ.t
                                            }
                                        },
                                        reset: function() {
                                            this.s = this.t = 0
                                        },
                                        valueOf: function() {
                                            return this.s
                                        }
                                    };
                                    var aJ = new aD();

                                    function aR(bp, bo, br) {
                                        var bn = br.s = bp + bo,
                                            bm = bn - bp,
                                            bq = bn - bm;
                                        br.t = bp - bq + (bo - bm)
                                    }

                                    function I(bq) {
                                        var bs = bq.length,
                                            bn, bp = -1,
                                            bo = 0,
                                            bm, br;
                                        while (++bp < bs) {
                                            bo += bq[bp].length
                                        }
                                        bm = new Array(bo);
                                        while (--bs >= 0) {
                                            br = bq[bs];
                                            bn = br.length;
                                            while (--bn >= 0) {
                                                bm[--bo] = br[bn]
                                            }
                                        }
                                        return bm
                                    }

                                    function S(br, bo, bp) {
                                        br = +br, bo = +bo, bp = (bq = arguments.length) < 2 ? (bo = br, br = 0, 1) : bq < 3 ? 1 : +bp;
                                        var bn = -1,
                                            bq = Math.max(0, Math.ceil((bo - br) / bp)) | 0,
                                            bm = new Array(bq);
                                        while (++bn < bq) {
                                            bm[bn] = br + bn * bp
                                        }
                                        return bm
                                    }

                                    function aI(bo, bn) {
                                        var bm = 1,
                                            bq = arguments.length,
                                            bp;
                                        while (++bm < bq) {
                                            bo[bp = arguments[bm]] = O(bo, bn, bn[bp])
                                        }
                                        return bo
                                    }

                                    function O(bn, bm, bo) {
                                        return function() {
                                            var bp = bo.apply(bm, arguments);
                                            return bp === bm ? bn : bp
                                        }
                                    }
                                    M.stream = function(bm, bn) {
                                        if (bm && ax.hasOwnProperty(bm.type)) {
                                            ax[bm.type](bm, bn)
                                        } else {
                                            ao(bm, bn)
                                        }
                                    };

                                    function ao(bn, bm) {
                                        if (bn && a5.hasOwnProperty(bn.type)) {
                                            a5[bn.type](bn, bm)
                                        }
                                    }
                                    var ax = {
                                        Feature: function(bm, bn) {
                                            ao(bm.geometry, bn)
                                        },
                                        FeatureCollection: function(bm, bp) {
                                            var bo = bm.features,
                                                bn = -1,
                                                bq = bo.length;
                                            while (++bn < bq) {
                                                ao(bo[bn].geometry, bp)
                                            }
                                        }
                                    };
                                    var a5 = {
                                        Sphere: function(bm, bn) {
                                            bn.sphere()
                                        },
                                        Point: function(bm, bn) {
                                            bm = bm.coordinates;
                                            bn.point(bm[0], bm[1], bm[2])
                                        },
                                        MultiPoint: function(bm, bo) {
                                            var bp = bm.coordinates,
                                                bn = -1,
                                                bq = bp.length;
                                            while (++bn < bq) {
                                                bm = bp[bn], bo.point(bm[0], bm[1], bm[2])
                                            }
                                        },
                                        LineString: function(bm, bn) {
                                            A(bm.coordinates, bn, 0)
                                        },
                                        MultiLineString: function(bm, bo) {
                                            var bp = bm.coordinates,
                                                bn = -1,
                                                bq = bp.length;
                                            while (++bn < bq) {
                                                A(bp[bn], bo, 0)
                                            }
                                        },
                                        Polygon: function(bm, bn) {
                                            ae(bm.coordinates, bn)
                                        },
                                        MultiPolygon: function(bm, bo) {
                                            var bp = bm.coordinates,
                                                bn = -1,
                                                bq = bp.length;
                                            while (++bn < bq) {
                                                ae(bp[bn], bo)
                                            }
                                        },
                                        GeometryCollection: function(bm, bp) {
                                            var bo = bm.geometries,
                                                bn = -1,
                                                bq = bo.length;
                                            while (++bn < bq) {
                                                ao(bo[bn], bp)
                                            }
                                        }
                                    };

                                    function A(bp, bo, bm) {
                                        var bn = -1,
                                            br = bp.length - bm,
                                            bq;
                                        bo.lineStart();
                                        while (++bn < br) {
                                            bq = bp[bn], bo.point(bq[0], bq[1], bq[2])
                                        }
                                        bo.lineEnd()
                                    }

                                    function ae(bo, bn) {
                                        var bm = -1,
                                            bp = bo.length;
                                        bn.polygonStart();
                                        while (++bm < bp) {
                                            A(bo[bm], bn, 1)
                                        }
                                        bn.polygonEnd()
                                    }
                                    M.area = function(bm) {
                                        P = 0;
                                        M.stream(bm, aq);
                                        return P
                                    };
                                    var P, aF = new aD();
                                    var aq = {
                                        sphere: function() {
                                            P += 4 * J
                                        },
                                        point: bg,
                                        lineStart: bg,
                                        lineEnd: bg,
                                        polygonStart: function() {
                                            aF.reset();
                                            aq.lineStart = i
                                        },
                                        polygonEnd: function() {
                                            var bm = 2 * aF;
                                            P += bm < 0 ? 4 * J + bm : bm;
                                            aq.lineStart = aq.lineEnd = aq.point = bg
                                        }
                                    };

                                    function i() {
                                        var bq, br, bo, bn, bm;
                                        aq.point = function(bs, bt) {
                                            aq.point = bp;
                                            bo = (bq = bs) * Q, bn = Math.cos(bt = (br = bt) * Q / 2 + J / 4), bm = Math.sin(bt)
                                        };

                                        function bp(bx, by) {
                                            bx *= Q;
                                            by = by * Q / 2 + J / 4;
                                            var bz = bx - bo,
                                                bt = bz >= 0 ? 1 : -1,
                                                bw = bt * bz,
                                                bu = Math.cos(by),
                                                bs = Math.sin(by),
                                                bv = bm * bs,
                                                bB = bn * bu + bv * Math.cos(bw),
                                                bA = bv * bt * Math.sin(bw);
                                            aF.add(Math.atan2(bA, bB));
                                            bo = bx, bn = bu, bm = bs
                                        }
                                        aq.lineEnd = function() {
                                            bp(bq, br)
                                        }
                                    }

                                    function s(bm) {
                                        var bn = bm[0],
                                            bo = bm[1],
                                            bp = Math.cos(bo);
                                        return [bp * Math.cos(bn), bp * Math.sin(bn), Math.sin(bo)]
                                    }

                                    function aM(bn, bm) {
                                        return bn[0] * bm[0] + bn[1] * bm[1] + bn[2] * bm[2]
                                    }

                                    function j(bn, bm) {
                                        return [bn[1] * bm[2] - bn[2] * bm[1], bn[2] * bm[0] - bn[0] * bm[2], bn[0] * bm[1] - bn[1] * bm[0]]
                                    }

                                    function aK(bn, bm) {
                                        bn[0] += bm[0];
                                        bn[1] += bm[1];
                                        bn[2] += bm[2]
                                    }

                                    function N(bm, bn) {
                                        return [bm[0] * bn, bm[1] * bn, bm[2] * bn]
                                    }

                                    function aH(bn) {
                                        var bm = Math.sqrt(bn[0] * bn[0] + bn[1] * bn[1] + bn[2] * bn[2]);
                                        bn[0] /= bm;
                                        bn[1] /= bm;
                                        bn[2] /= bm
                                    }

                                    function aG(bm) {
                                        return [Math.atan2(bm[1], bm[0]), ap(bm[2])]
                                    }

                                    function ar(bn, bm) {
                                        return af(bn[0] - bm[0]) < at && af(bn[1] - bm[1]) < at
                                    }
                                    M.bounds = function() {
                                        var bp, bE, bn, bD, bq, bv, bH, br, bu, bs, bw;
                                        var bm = {
                                            point: bz,
                                            lineStart: bx,
                                            lineEnd: bB,
                                            polygonStart: function() {
                                                bm.point = bA;
                                                bm.lineStart = bt;
                                                bm.lineEnd = by;
                                                bu = 0;
                                                aq.polygonStart()
                                            },
                                            polygonEnd: function() {
                                                aq.polygonEnd();
                                                bm.point = bz;
                                                bm.lineStart = bx;
                                                bm.lineEnd = bB;
                                                if (aF < 0) {
                                                    bp = -(bn = 180), bE = -(bD = 90)
                                                } else {
                                                    if (bu > at) {
                                                        bD = 90
                                                    } else {
                                                        if (bu < -at) {
                                                            bE = -90
                                                        }
                                                    }
                                                }
                                                bw[0] = bp, bw[1] = bn
                                            }
                                        };

                                        function bz(bI, bJ) {
                                            bs.push(bw = [bp = bI, bn = bI]);
                                            if (bJ < bE) {
                                                bE = bJ
                                            }
                                            if (bJ > bD) {
                                                bD = bJ
                                            }
                                        }

                                        function bo(bM, bP) {
                                            var bI = s([bM * Q, bP * Q]);
                                            if (br) {
                                                var bO = j(br, bI),
                                                    bQ = [bO[1], -bO[0], 0],
                                                    bL = j(bQ, bO);
                                                aH(bL);
                                                bL = aG(bL);
                                                var bR = bM - bq,
                                                    bS = bR > 0 ? 1 : -1,
                                                    bN = bL[0] * al * bS,
                                                    bK = af(bR) > 180;
                                                if (bK ^ (bS * bq < bN && bN < bS * bM)) {
                                                    var bJ = bL[1] * al;
                                                    if (bJ > bD) {
                                                        bD = bJ
                                                    }
                                                } else {
                                                    if (bN = (bN + 360) % 360 - 180, bK ^ (bS * bq < bN && bN < bS * bM)) {
                                                        var bJ = -bL[1] * al;
                                                        if (bJ < bE) {
                                                            bE = bJ
                                                        }
                                                    } else {
                                                        if (bP < bE) {
                                                            bE = bP
                                                        }
                                                        if (bP > bD) {
                                                            bD = bP
                                                        }
                                                    }
                                                }
                                                if (bK) {
                                                    if (bM < bq) {
                                                        if (bC(bp, bM) > bC(bp, bn)) {
                                                            bn = bM
                                                        }
                                                    } else {
                                                        if (bC(bM, bn) > bC(bp, bn)) {
                                                            bp = bM
                                                        }
                                                    }
                                                } else {
                                                    if (bn >= bp) {
                                                        if (bM < bp) {
                                                            bp = bM
                                                        }
                                                        if (bM > bn) {
                                                            bn = bM
                                                        }
                                                    } else {
                                                        if (bM > bq) {
                                                            if (bC(bp, bM) > bC(bp, bn)) {
                                                                bn = bM
                                                            }
                                                        } else {
                                                            if (bC(bM, bn) > bC(bp, bn)) {
                                                                bp = bM
                                                            }
                                                        }
                                                    }
                                                }
                                            } else {
                                                bz(bM, bP)
                                            }
                                            br = bI, bq = bM
                                        }

                                        function bx() {
                                            bm.point = bo
                                        }

                                        function bB() {
                                            bw[0] = bp, bw[1] = bn;
                                            bm.point = bz;
                                            br = null
                                        }

                                        function bA(bI, bJ) {
                                            if (br) {
                                                var bK = bI - bq;
                                                bu += af(bK) > 180 ? bK + (bK > 0 ? 360 : -360) : bK
                                            } else {
                                                bv = bI, bH = bJ
                                            }
                                            aq.point(bI, bJ);
                                            bo(bI, bJ)
                                        }

                                        function bt() {
                                            aq.lineStart()
                                        }

                                        function by() {
                                            bA(bv, bH);
                                            aq.lineEnd();
                                            if (af(bu) > at) {
                                                bp = -(bn = 180)
                                            }
                                            bw[0] = bp, bw[1] = bn;
                                            br = null
                                        }

                                        function bC(bJ, bI) {
                                            return (bI -= bJ) < 0 ? bI + 360 : bI
                                        }

                                        function bG(bJ, bI) {
                                            return bJ[0] - bI[0]
                                        }

                                        function bF(bI, bJ) {
                                            return bJ[0] <= bJ[1] ? bJ[0] <= bI && bI <= bJ[1] : bI < bJ[0] || bJ[1] < bI
                                        }
                                        return function(bM) {
                                            bD = bn = -(bp = bE = Infinity);
                                            bs = [];
                                            M.stream(bM, bm);
                                            var bP = bs.length;
                                            if (bP) {
                                                bs.sort(bG);
                                                for (var bL = 1, bK = bs[0], bJ, bI = [bK]; bL < bP; ++bL) {
                                                    bJ = bs[bL];
                                                    if (bF(bJ[0], bK) || bF(bJ[1], bK)) {
                                                        if (bC(bK[0], bJ[1]) > bC(bK[0], bK[1])) {
                                                            bK[1] = bJ[1]
                                                        }
                                                        if (bC(bJ[0], bK[1]) > bC(bK[0], bK[1])) {
                                                            bK[0] = bJ[0]
                                                        }
                                                    } else {
                                                        bI.push(bK = bJ)
                                                    }
                                                }
                                                var bO = -Infinity,
                                                    bN;
                                                for (var bP = bI.length - 1, bL = 0, bK = bI[bP], bJ; bL <= bP; bK = bJ, ++bL) {
                                                    bJ = bI[bL];
                                                    if ((bN = bC(bK[1], bJ[0])) > bO) {
                                                        bO = bN, bp = bJ[0], bn = bK[1]
                                                    }
                                                }
                                            }
                                            bs = bw = null;
                                            return bp === Infinity || bE === Infinity ? [
                                                [NaN, NaN],
                                                [NaN, NaN]
                                            ] : [
                                                [bp, bE],
                                                [bn, bD]
                                            ]
                                        }
                                    }();
                                    M.centroid = function(bo) {
                                        Z = Y = G = n = a9 = E = m = a8 = C = l = a6 = 0;
                                        M.stream(bo, ak);
                                        var bn = C,
                                            bq = l,
                                            bp = a6,
                                            bm = bn * bn + bq * bq + bp * bp;
                                        if (bm < ay) {
                                            bn = E, bq = m, bp = a8;
                                            if (Y < at) {
                                                bn = G, bq = n, bp = a9
                                            }
                                            bm = bn * bn + bq * bq + bp * bp;
                                            if (bm < ay) {
                                                return [NaN, NaN]
                                            }
                                        }
                                        return [Math.atan2(bq, bn) * al, ap(bp / Math.sqrt(bm)) * al]
                                    };
                                    var Z, Y, G, n, a9, E, m, a8, C, l, a6;
                                    var ak = {
                                        sphere: bg,
                                        point: X,
                                        lineStart: bc,
                                        lineEnd: bb,
                                        polygonStart: function() {
                                            ak.lineStart = h
                                        },
                                        polygonEnd: function() {
                                            ak.lineStart = bc
                                        }
                                    };

                                    function X(bm, bn) {
                                        bm *= Q;
                                        var bo = Math.cos(bn *= Q);
                                        a0(bo * Math.cos(bm), bo * Math.sin(bm), Math.sin(bn))
                                    }

                                    function a0(bm, bo, bn) {
                                        ++Z;
                                        G += (bm - G) / Z;
                                        n += (bo - n) / Z;
                                        a9 += (bn - a9) / Z
                                    }

                                    function bc() {
                                        var bm, bn, bp;
                                        ak.point = function(bq, br) {
                                            bq *= Q;
                                            var bs = Math.cos(br *= Q);
                                            bm = bs * Math.cos(bq);
                                            bn = bs * Math.sin(bq);
                                            bp = Math.sin(br);
                                            ak.point = bo;
                                            a0(bm, bn, bp)
                                        };

                                        function bo(bs, bt) {
                                            bs *= Q;
                                            var bw = Math.cos(bt *= Q),
                                                bq = bw * Math.cos(bs),
                                                bv = bw * Math.sin(bs),
                                                bu = Math.sin(bt),
                                                br = Math.atan2(Math.sqrt((br = bn * bu - bp * bv) * br + (br = bp * bq - bm * bu) * br + (br = bm * bv - bn * bq) * br), bm * bq + bn * bv + bp * bu);
                                            Y += br;
                                            E += br * (bm + (bm = bq));
                                            m += br * (bn + (bn = bv));
                                            a8 += br * (bp + (bp = bu));
                                            a0(bm, bn, bp)
                                        }
                                    }

                                    function bb() {
                                        ak.point = X
                                    }

                                    function h() {
                                        var bq, br, bm, bn, bp;
                                        ak.point = function(bs, bt) {
                                            bq = bs, br = bt;
                                            ak.point = bo;
                                            bs *= Q;
                                            var bu = Math.cos(bt *= Q);
                                            bm = bu * Math.cos(bs);
                                            bn = bu * Math.sin(bs);
                                            bp = Math.sin(bt);
                                            a0(bm, bn, bp)
                                        };
                                        ak.lineEnd = function() {
                                            bo(bq, br);
                                            ak.lineEnd = bb;
                                            ak.point = X
                                        };

                                        function bo(bx, by) {
                                            bx *= Q;
                                            var bv = Math.cos(by *= Q),
                                                bB = bv * Math.cos(bx),
                                                bA = bv * Math.sin(bx),
                                                bz = Math.sin(by),
                                                bw = bn * bz - bp * bA,
                                                bu = bp * bB - bm * bz,
                                                bt = bm * bA - bn * bB,
                                                bs = Math.sqrt(bw * bw + bu * bu + bt * bt),
                                                bE = bm * bB + bn * bA + bp * bz,
                                                bD = bs && -bi(bE) / bs,
                                                bC = Math.atan2(bs, bE);
                                            C += bD * bw;
                                            l += bD * bu;
                                            a6 += bD * bt;
                                            Y += bC;
                                            E += bC * (bm + (bm = bB));
                                            m += bC * (bn + (bn = bA));
                                            a8 += bC * (bp + (bp = bz));
                                            a0(bm, bn, bp)
                                        }
                                    }

                                    function bf(bn, bm) {
                                        function bo(bp, bq) {
                                            return bp = bn(bp, bq), bm(bp[0], bp[1])
                                        }
                                        if (bn.invert && bm.invert) {
                                            bo.invert = function(bp, bq) {
                                                return bp = bm.invert(bp, bq), bp && bn.invert(bp[0], bp[1])
                                            }
                                        }
                                        return bo
                                    }

                                    function o() {
                                        return true
                                    }

                                    function aB(bs, bn, bw, bu, bp) {
                                        var bv = [],
                                            bq = [];
                                        bs.forEach(function(bE) {
                                            if ((bH = bE.length - 1) <= 0) {
                                                return
                                            }
                                            var bH, bG = bE[0],
                                                bF = bE[bH];
                                            if (ar(bG, bF)) {
                                                bp.lineStart();
                                                for (var bD = 0; bD < bH; ++bD) {
                                                    bp.point((bG = bE[bD])[0], bG[1])
                                                }
                                                bp.lineEnd();
                                                return
                                            }
                                            var bC = new au(bG, bE, null, true),
                                                bB = new au(bG, null, bC, false);
                                            bC.o = bB;
                                            bv.push(bC);
                                            bq.push(bB);
                                            bC = new au(bF, bE, null, false);
                                            bB = new au(bF, null, bC, true);
                                            bC.o = bB;
                                            bv.push(bC);
                                            bq.push(bB)
                                        });
                                        bq.sort(bn);
                                        a7(bv);
                                        a7(bq);
                                        if (!bv.length) {
                                            return
                                        }
                                        for (var br = 0, by = bw, bo = bq.length; br < bo; ++br) {
                                            bq[br].e = by = !by
                                        }
                                        var bm = bv[0],
                                            bz, bx;
                                        while (1) {
                                            var bt = bm,
                                                bA = true;
                                            while (bt.v) {
                                                if ((bt = bt.n) === bm) {
                                                    return
                                                }
                                            }
                                            bz = bt.z;
                                            bp.lineStart();
                                            do {
                                                bt.v = bt.o.v = true;
                                                if (bt.e) {
                                                    if (bA) {
                                                        for (var br = 0, bo = bz.length; br < bo; ++br) {
                                                            bp.point((bx = bz[br])[0], bx[1])
                                                        }
                                                    } else {
                                                        bu(bt.x, bt.n.x, 1, bp)
                                                    }
                                                    bt = bt.n
                                                } else {
                                                    if (bA) {
                                                        bz = bt.p.z;
                                                        for (var br = bz.length - 1; br >= 0; --br) {
                                                            bp.point((bx = bz[br])[0], bx[1])
                                                        }
                                                    } else {
                                                        bu(bt.x, bt.p.x, -1, bp)
                                                    }
                                                    bt = bt.p
                                                }
                                                bt = bt.o;
                                                bz = bt.z;
                                                bA = !bA
                                            } while (!bt.v);
                                            bp.lineEnd()
                                        }
                                    }

                                    function a7(bq) {
                                        if (!(bp = bq.length)) {
                                            return
                                        }
                                        var bp, bo = 0,
                                            bn = bq[0],
                                            bm;
                                        while (++bo < bp) {
                                            bn.n = bm = bq[bo];
                                            bm.p = bn;
                                            bn = bm
                                        }
                                        bn.n = bm = bq[0];
                                        bm.p = bn
                                    }

                                    function au(bn, bo, bm, bp) {
                                        this.x = bn;
                                        this.z = bo;
                                        this.o = bm;
                                        this.e = bp;
                                        this.v = false;
                                        this.n = this.p = null
                                    }

                                    function a(bm, bp, bn, bo) {
                                        return function(bF, bu) {
                                            var by = bp(bu),
                                                bt = bF.invert(bo[0], bo[1]);
                                            var bH = {
                                                point: bC,
                                                lineStart: bA,
                                                lineEnd: bG,
                                                polygonStart: function() {
                                                    bH.point = br;
                                                    bH.lineStart = bv;
                                                    bH.lineEnd = bB;
                                                    bD = [];
                                                    bz = []
                                                },
                                                polygonEnd: function() {
                                                    bH.point = bC;
                                                    bH.lineStart = bA;
                                                    bH.lineEnd = bG;
                                                    bD = I(bD);
                                                    var bI = q(bt, bz);
                                                    if (bD.length) {
                                                        if (!bs) {
                                                            bu.polygonStart(), bs = true
                                                        }
                                                        aB(bD, aU, bI, bn, bu)
                                                    } else {
                                                        if (bI) {
                                                            if (!bs) {
                                                                bu.polygonStart(), bs = true
                                                            }
                                                            bu.lineStart();
                                                            bn(null, null, 1, bu);
                                                            bu.lineEnd()
                                                        }
                                                    }
                                                    if (bs) {
                                                        bu.polygonEnd(), bs = false
                                                    }
                                                    bD = bz = null
                                                },
                                                sphere: function() {
                                                    bu.polygonStart();
                                                    bu.lineStart();
                                                    bn(null, null, 1, bu);
                                                    bu.lineEnd();
                                                    bu.polygonEnd()
                                                }
                                            };

                                            function bC(bJ, bK) {
                                                var bI = bF(bJ, bK);
                                                if (bm(bJ = bI[0], bK = bI[1])) {
                                                    bu.point(bJ, bK)
                                                }
                                            }

                                            function bw(bJ, bK) {
                                                var bI = bF(bJ, bK);
                                                by.point(bI[0], bI[1])
                                            }

                                            function bA() {
                                                bH.point = bw;
                                                by.lineStart()
                                            }

                                            function bG() {
                                                bH.point = bC;
                                                by.lineEnd()
                                            }
                                            var bD;
                                            var bE = ac(),
                                                bq = bp(bE),
                                                bs = false,
                                                bz, bx;

                                            function br(bJ, bK) {
                                                bx.push([bJ, bK]);
                                                var bI = bF(bJ, bK);
                                                bq.point(bI[0], bI[1])
                                            }

                                            function bv() {
                                                bq.lineStart();
                                                bx = []
                                            }

                                            function bB() {
                                                br(bx[0][0], bx[0][1]);
                                                bq.lineEnd();
                                                var bK = bq.clean(),
                                                    bM = bE.buffer(),
                                                    bL, bN = bM.length;
                                                bx.pop();
                                                bz.push(bx);
                                                bx = null;
                                                if (!bN) {
                                                    return
                                                }
                                                if (bK & 1) {
                                                    bL = bM[0];
                                                    var bN = bL.length - 1,
                                                        bJ = -1,
                                                        bI;
                                                    if (bN > 0) {
                                                        if (!bs) {
                                                            bu.polygonStart(), bs = true
                                                        }
                                                        bu.lineStart();
                                                        while (++bJ < bN) {
                                                            bu.point((bI = bL[bJ])[0], bI[1])
                                                        }
                                                        bu.lineEnd()
                                                    }
                                                    return
                                                }
                                                if (bN > 1 && bK & 2) {
                                                    bM.push(bM.pop().concat(bM.shift()))
                                                }
                                                bD.push(bM.filter(ai))
                                            }
                                            return bH
                                        }
                                    }

                                    function ai(bm) {
                                        return bm.length > 1
                                    }

                                    function ac() {
                                        var bn = [],
                                            bm;
                                        return {
                                            lineStart: function() {
                                                bn.push(bm = [])
                                            },
                                            point: function(bo, bp) {
                                                bm.push([bo, bp])
                                            },
                                            lineEnd: bg,
                                            buffer: function() {
                                                var bo = bn;
                                                bn = [];
                                                bm = null;
                                                return bo
                                            },
                                            rejoin: function() {
                                                if (bn.length > 1) {
                                                    bn.push(bn.pop().concat(bn.shift()))
                                                }
                                            }
                                        }
                                    }

                                    function aU(bn, bm) {
                                        return ((bn = bn.x)[0] < 0 ? bn[1] - aX - at : aX - bn[1]) - ((bm = bm.x)[0] < 0 ? bm[1] - aX - at : aX - bm[1])
                                    }
                                    var c = a(o, bj, aw, [-J, -J / 2]);

                                    function bj(bp) {
                                        var bo = NaN,
                                            bm = NaN,
                                            bq = NaN,
                                            bn;
                                        return {
                                            lineStart: function() {
                                                bp.lineStart();
                                                bn = 1
                                            },
                                            point: function(bs, br) {
                                                var bt = bs > 0 ? J : -J,
                                                    bu = af(bs - bo);
                                                if (af(bu - J) < at) {
                                                    bp.point(bo, bm = (bm + br) / 2 > 0 ? aX : -aX);
                                                    bp.point(bq, bm);
                                                    bp.lineEnd();
                                                    bp.lineStart();
                                                    bp.point(bt, bm);
                                                    bp.point(bs, bm);
                                                    bn = 0
                                                } else {
                                                    if (bq !== bt && bu >= J) {
                                                        if (af(bo - bq) < at) {
                                                            bo -= bq * at
                                                        }
                                                        if (af(bs - bt) < at) {
                                                            bs -= bt * at
                                                        }
                                                        bm = B(bo, bm, bs, br);
                                                        bp.point(bq, bm);
                                                        bp.lineEnd();
                                                        bp.lineStart();
                                                        bp.point(bt, bm);
                                                        bn = 0
                                                    }
                                                }
                                                bp.point(bo = bs, bm = br);
                                                bq = bt
                                            },
                                            lineEnd: function() {
                                                bp.lineEnd();
                                                bo = bm = NaN
                                            },
                                            clean: function() {
                                                return 2 - bn
                                            }
                                        }
                                    }

                                    function B(bs, bn, bq, bm) {
                                        var br, bp, bo = Math.sin(bs - bq);
                                        return af(bo) > at ? Math.atan((Math.sin(bn) * (bp = Math.cos(bm)) * Math.sin(bq) - Math.sin(bm) * (br = Math.cos(bn)) * Math.sin(bs)) / (br * bp * bo)) : (bn + bm) / 2
                                    }

                                    function aw(br, bq, bp, bo) {
                                        var bn;
                                        if (br == null) {
                                            bn = bp * aX;
                                            bo.point(-J, bn);
                                            bo.point(0, bn);
                                            bo.point(J, bn);
                                            bo.point(J, 0);
                                            bo.point(J, -bn);
                                            bo.point(0, -bn);
                                            bo.point(-J, -bn);
                                            bo.point(-J, 0);
                                            bo.point(-J, bn)
                                        } else {
                                            if (af(br[0] - bq[0]) > at) {
                                                var bm = br[0] < bq[0] ? J : -J;
                                                bn = bp * bm / 2;
                                                bo.point(-bm, bn);
                                                bo.point(0, bn);
                                                bo.point(bm, bn)
                                            } else {
                                                bo.point(bq[0], bq[1])
                                            }
                                        }
                                    }

                                    function q(bD, bx) {
                                        var bK = bD[0],
                                            bN = bD[1],
                                            bm = [Math.sin(bK), -Math.cos(bK), 0],
                                            bw = 0,
                                            bI = 0;
                                        aF.reset();
                                        for (var bH = 0, bB = bx.length; bH < bB; ++bH) {
                                            var br = bx[bH],
                                                bC = br.length;
                                            if (!bC) {
                                                continue
                                            }
                                            var bq = br[0],
                                                bn = bq[0],
                                                bM = bq[1] / 2 + J / 4,
                                                bG = Math.sin(bM),
                                                bA = Math.cos(bM),
                                                bF = 1;
                                            while (true) {
                                                if (bF === bC) {
                                                    bF = 0
                                                }
                                                bD = br[bF];
                                                var by = bD[0],
                                                    bp = bD[1] / 2 + J / 4,
                                                    bu = Math.sin(bp),
                                                    bJ = Math.cos(bp),
                                                    bz = by - bn,
                                                    bv = bz >= 0 ? 1 : -1,
                                                    bO = bv * bz,
                                                    bo = bO > J,
                                                    bE = bG * bu;
                                                aF.add(Math.atan2(bE * bv * Math.sin(bO), bA * bJ + bE * Math.cos(bO)));
                                                bw += bo ? bz + bv * bl : bz;
                                                if (bo ^ bn >= bK ^ by >= bK) {
                                                    var bs = j(s(bq), s(bD));
                                                    aH(bs);
                                                    var bt = j(bm, bs);
                                                    aH(bt);
                                                    var bL = (bo ^ bz >= 0 ? -1 : 1) * ap(bt[2]);
                                                    if (bN > bL || bN === bL && (bs[0] || bs[1])) {
                                                        bI += bo ^ bz >= 0 ? 1 : -1
                                                    }
                                                }
                                                if (!bF++) {
                                                    break
                                                }
                                                bn = by, bG = bu, bA = bJ, bq = bD
                                            }
                                        }
                                        return (bw < -at || bw < at && aF < -at) ^ bI & 1
                                    }

                                    function ag(bq) {
                                        var br = Math.cos(bq),
                                            bp = br > 0,
                                            bs = af(br) > at,
                                            bt = z(bq, 6 * Q);
                                        return a(bo, bu, bt, bp ? [0, -bq] : [-J, bq - J]);

                                        function bo(bv, bw) {
                                            return Math.cos(bv) * Math.cos(bw) > br
                                        }

                                        function bu(bA) {
                                            var bz, by, bv, bx, bw;
                                            return {
                                                lineStart: function() {
                                                    bx = bv = false;
                                                    bw = 1
                                                },
                                                point: function(bC, bG) {
                                                    var bF = [bC, bG],
                                                        bE, bB = bo(bC, bG),
                                                        bH = bp ? bB ? 0 : bm(bC, bG) : bB ? bm(bC + (bC < 0 ? J : -J), bG) : 0;
                                                    if (!bz && (bx = bv = bB)) {
                                                        bA.lineStart()
                                                    }
                                                    if (bB !== bv) {
                                                        bE = bn(bz, bF);
                                                        if (ar(bz, bE) || ar(bF, bE)) {
                                                            bF[0] += at;
                                                            bF[1] += at;
                                                            bB = bo(bF[0], bF[1])
                                                        }
                                                    }
                                                    if (bB !== bv) {
                                                        bw = 0;
                                                        if (bB) {
                                                            bA.lineStart();
                                                            bE = bn(bF, bz);
                                                            bA.point(bE[0], bE[1])
                                                        } else {
                                                            bE = bn(bz, bF);
                                                            bA.point(bE[0], bE[1]);
                                                            bA.lineEnd()
                                                        }
                                                        bz = bE
                                                    } else {
                                                        if (bs && bz && bp ^ bB) {
                                                            var bD;
                                                            if (!(bH & by) && (bD = bn(bF, bz, true))) {
                                                                bw = 0;
                                                                if (bp) {
                                                                    bA.lineStart();
                                                                    bA.point(bD[0][0], bD[0][1]);
                                                                    bA.point(bD[1][0], bD[1][1]);
                                                                    bA.lineEnd()
                                                                } else {
                                                                    bA.point(bD[1][0], bD[1][1]);
                                                                    bA.lineEnd();
                                                                    bA.lineStart();
                                                                    bA.point(bD[0][0], bD[0][1])
                                                                }
                                                            }
                                                        }
                                                    }
                                                    if (bB && (!bz || !ar(bz, bF))) {
                                                        bA.point(bF[0], bF[1])
                                                    }
                                                    bz = bF, bv = bB, by = bH
                                                },
                                                lineEnd: function() {
                                                    if (bv) {
                                                        bA.lineEnd()
                                                    }
                                                    bz = null
                                                },
                                                clean: function() {
                                                    return bw | (bx && bv) << 1
                                                }
                                            }
                                        }

                                        function bn(bW, bU, bz) {
                                            var by = s(bW),
                                                bw = s(bU);
                                            var bD = [1, 0, 0],
                                                bB = j(by, bw),
                                                bG = aM(bB, bB),
                                                bS = bB[0],
                                                bM = bG - bS * bS;
                                            if (!bM) {
                                                return !bz && bW
                                            }
                                            var bP = br * bG / bM,
                                                bO = -br * bS / bM,
                                                bX = j(bD, bB),
                                                bN = N(bD, bP),
                                                bL = N(bB, bO);
                                            aK(bN, bL);
                                            var bI = bX,
                                                bH = aM(bN, bI),
                                                bA = aM(bI, bI),
                                                bF = bH * bH - bA * (aM(bN, bN) - 1);
                                            if (bF < 0) {
                                                return
                                            }
                                            var bJ = Math.sqrt(bF),
                                                bK = N(bI, (-bH - bJ) / bA);
                                            aK(bK, bN);
                                            bK = aG(bK);
                                            if (!bz) {
                                                return bK
                                            }
                                            var bx = bW[0],
                                                bv = bU[0],
                                                bV = bW[1],
                                                bT = bU[1],
                                                bC;
                                            if (bv < bx) {
                                                bC = bx, bx = bv, bv = bC
                                            }
                                            var bQ = bv - bx,
                                                bY = af(bQ - J) < at,
                                                bR = bY || bQ < at;
                                            if (!bY && bT < bV) {
                                                bC = bV, bV = bT, bT = bC
                                            }
                                            if (bR ? bY ? bV + bT > 0 ^ bK[1] < (af(bK[0] - bx) < at ? bV : bT) : bV <= bK[1] && bK[1] <= bT : bQ > J ^ (bx <= bK[0] && bK[0] <= bv)) {
                                                var bE = N(bI, (-bH + bJ) / bA);
                                                aK(bE, bN);
                                                return [bK, aG(bE)]
                                            }
                                        }

                                        function bm(bv, by) {
                                            var bx = bp ? bq : J - bq,
                                                bw = 0;
                                            if (bv < -bx) {
                                                bw |= 1
                                            } else {
                                                if (bv > bx) {
                                                    bw |= 2
                                                }
                                            }
                                            if (by < -bx) {
                                                bw |= 4
                                            } else {
                                                if (by > bx) {
                                                    bw |= 8
                                                }
                                            }
                                            return bw
                                        }
                                    }

                                    function aW(bn, bp, bm, bo) {
                                        return function(bD) {
                                            var bz = bD.a,
                                                bw = bD.b,
                                                br = bz.x,
                                                bC = bz.y,
                                                bv = bw.x,
                                                bu = bw.y,
                                                bt = 0,
                                                bs = 1,
                                                bB = bv - br,
                                                bA = bu - bC,
                                                bq;
                                            bq = bn - br;
                                            if (!bB && bq > 0) {
                                                return
                                            }
                                            bq /= bB;
                                            if (bB < 0) {
                                                if (bq < bt) {
                                                    return
                                                }
                                                if (bq < bs) {
                                                    bs = bq
                                                }
                                            } else {
                                                if (bB > 0) {
                                                    if (bq > bs) {
                                                        return
                                                    }
                                                    if (bq > bt) {
                                                        bt = bq
                                                    }
                                                }
                                            }
                                            bq = bm - br;
                                            if (!bB && bq < 0) {
                                                return
                                            }
                                            bq /= bB;
                                            if (bB < 0) {
                                                if (bq > bs) {
                                                    return
                                                }
                                                if (bq > bt) {
                                                    bt = bq
                                                }
                                            } else {
                                                if (bB > 0) {
                                                    if (bq < bt) {
                                                        return
                                                    }
                                                    if (bq < bs) {
                                                        bs = bq
                                                    }
                                                }
                                            }
                                            bq = bp - bC;
                                            if (!bA && bq > 0) {
                                                return
                                            }
                                            bq /= bA;
                                            if (bA < 0) {
                                                if (bq < bt) {
                                                    return
                                                }
                                                if (bq < bs) {
                                                    bs = bq
                                                }
                                            } else {
                                                if (bA > 0) {
                                                    if (bq > bs) {
                                                        return
                                                    }
                                                    if (bq > bt) {
                                                        bt = bq
                                                    }
                                                }
                                            }
                                            bq = bo - bC;
                                            if (!bA && bq < 0) {
                                                return
                                            }
                                            bq /= bA;
                                            if (bA < 0) {
                                                if (bq > bs) {
                                                    return
                                                }
                                                if (bq > bt) {
                                                    bt = bq
                                                }
                                            } else {
                                                if (bA > 0) {
                                                    if (bq < bt) {
                                                        return
                                                    }
                                                    if (bq < bs) {
                                                        bs = bq
                                                    }
                                                }
                                            }
                                            if (bt > 0) {
                                                bD.a = {
                                                    x: br + bt * bB,
                                                    y: bC + bt * bA
                                                }
                                            }
                                            if (bs < 1) {
                                                bD.b = {
                                                    x: br + bs * bB,
                                                    y: bC + bs * bA
                                                }
                                            }
                                            return bD
                                        }
                                    }
                                    var r = 1000000000;
                                    M.clipExtent = function() {
                                        var bo, br, bn, bp, bs, bq, bm = {
                                            stream: function(bt) {
                                                if (bs) {
                                                    bs.valid = false
                                                }
                                                bs = bq(bt);
                                                bs.valid = true;
                                                return bs
                                            },
                                            extent: function(bt) {
                                                if (!arguments.length) {
                                                    return [
                                                        [bo, br],
                                                        [bn, bp]
                                                    ]
                                                }
                                                bq = av(bo = +bt[0][0], br = +bt[0][1], bn = +bt[1][0], bp = +bt[1][1]);
                                                if (bs) {
                                                    bs.valid = false, bs = null
                                                }
                                                return bm
                                            }
                                        };
                                        return bm.extent([
                                            [0, 0],
                                            [960, 500]
                                        ])
                                    };

                                    function av(bn, bq, bm, bo) {
                                        return function(by) {
                                            var bu = by,
                                                bD = ac(),
                                                bv = aW(bn, bq, bm, bo),
                                                bL, bE, bB;
                                            var bP = {
                                                point: bK,
                                                lineStart: bH,
                                                lineEnd: bN,
                                                polygonStart: function() {
                                                    by = bD;
                                                    bL = [];
                                                    bE = [];
                                                    bM = true
                                                },
                                                polygonEnd: function() {
                                                    by = bu;
                                                    bL = I(bL);
                                                    var bR = bG([bn, bo]),
                                                        bQ = bM && bR,
                                                        bS = bL.length;
                                                    if (bQ || bS) {
                                                        by.polygonStart();
                                                        if (bQ) {
                                                            by.lineStart();
                                                            bC(null, null, 1, by);
                                                            by.lineEnd()
                                                        }
                                                        if (bS) {
                                                            aB(bL, br, bR, bC, by)
                                                        }
                                                        by.polygonEnd()
                                                    }
                                                    bL = bE = bB = null
                                                }
                                            };

                                            function bG(bQ) {
                                                var bY = 0,
                                                    bR = bE.length,
                                                    bW = bQ[1];
                                                for (var bU = 0; bU < bR; ++bU) {
                                                    for (var bT = 1, bZ = bE[bU], bS = bZ.length, bX = bZ[0], bV; bT < bS; ++bT) {
                                                        bV = bZ[bT];
                                                        if (bX[1] <= bW) {
                                                            if (bV[1] > bW && k(bX, bV, bQ) > 0) {
                                                                ++bY
                                                            }
                                                        } else {
                                                            if (bV[1] <= bW && k(bX, bV, bQ) < 0) {
                                                                --bY
                                                            }
                                                        }
                                                        bX = bV
                                                    }
                                                }
                                                return bY !== 0
                                            }

                                            function bC(bV, bU, bT, bS) {
                                                var bR = 0,
                                                    bQ = 0;
                                                if (bV == null || (bR = bp(bV, bT)) !== (bQ = bp(bU, bT)) || bs(bV, bU) < 0 ^ bT > 0) {
                                                    do {
                                                        bS.point(bR === 0 || bR === 3 ? bn : bm, bR > 1 ? bo : bq)
                                                    } while ((bR = (bR + bT + 4) % 4) !== bQ)
                                                } else {
                                                    bS.point(bU[0], bU[1])
                                                }
                                            }

                                            function bF(bQ, bR) {
                                                return bn <= bQ && bQ <= bm && bq <= bR && bR <= bo
                                            }

                                            function bK(bQ, bR) {
                                                if (bF(bQ, bR)) {
                                                    by.point(bQ, bR)
                                                }
                                            }
                                            var bJ, bz, bI, bO, bx, bw, bA, bM;

                                            function bH() {
                                                bP.point = bt;
                                                if (bE) {
                                                    bE.push(bB = [])
                                                }
                                                bA = true;
                                                bw = false;
                                                bO = bx = NaN
                                            }

                                            function bN() {
                                                if (bL) {
                                                    bt(bJ, bz);
                                                    if (bI && bw) {
                                                        bD.rejoin()
                                                    }
                                                    bL.push(bD.buffer())
                                                }
                                                bP.point = bK;
                                                if (bw) {
                                                    by.lineEnd()
                                                }
                                            }

                                            function bt(bQ, bT) {
                                                bQ = Math.max(-r, Math.min(r, bQ));
                                                bT = Math.max(-r, Math.min(r, bT));
                                                var bS = bF(bQ, bT);
                                                if (bE) {
                                                    bB.push([bQ, bT])
                                                }
                                                if (bA) {
                                                    bJ = bQ, bz = bT, bI = bS;
                                                    bA = false;
                                                    if (bS) {
                                                        by.lineStart();
                                                        by.point(bQ, bT)
                                                    }
                                                } else {
                                                    if (bS && bw) {
                                                        by.point(bQ, bT)
                                                    } else {
                                                        var bR = {
                                                            a: {
                                                                x: bO,
                                                                y: bx
                                                            },
                                                            b: {
                                                                x: bQ,
                                                                y: bT
                                                            }
                                                        };
                                                        if (bv(bR)) {
                                                            if (!bw) {
                                                                by.lineStart();
                                                                by.point(bR.a.x, bR.a.y)
                                                            }
                                                            by.point(bR.b.x, bR.b.y);
                                                            if (!bS) {
                                                                by.lineEnd()
                                                            }
                                                            bM = false
                                                        } else {
                                                            if (bS) {
                                                                by.lineStart();
                                                                by.point(bQ, bT);
                                                                bM = false
                                                            }
                                                        }
                                                    }
                                                }
                                                bO = bQ, bx = bT, bw = bS
                                            }
                                            return bP
                                        };

                                        function bp(bu, bt) {
                                            return af(bu[0] - bn) < at ? bt > 0 ? 0 : 3 : af(bu[0] - bm) < at ? bt > 0 ? 2 : 1 : af(bu[1] - bq) < at ? bt > 0 ? 1 : 0 : bt > 0 ? 3 : 2
                                        }

                                        function br(bu, bt) {
                                            return bs(bu.x, bt.x)
                                        }

                                        function bs(bw, bu) {
                                            var bv = bp(bw, 1),
                                                bt = bp(bu, 1);
                                            return bv !== bt ? bv - bt : bv === 0 ? bu[1] - bw[1] : bv === 1 ? bw[0] - bu[0] : bv === 2 ? bw[1] - bu[1] : bu[0] - bw[0]
                                        }
                                    }

                                    function a3(bp) {
                                        var bo = 0,
                                            bn = J / 3,
                                            bm = e(bp),
                                            bq = bm(bo, bn);
                                        bq.parallels = function(br) {
                                            if (!arguments.length) {
                                                return [bo / J * 180, bn / J * 180]
                                            }
                                            return bm(bo = br[0] * J / 180, bn = br[1] * J / 180)
                                        };
                                        return bq
                                    }

                                    function L(bo, bm) {
                                        var bp = Math.sin(bo),
                                            bs = (bp + Math.sin(bm)) / 2,
                                            br = 1 + bp * (2 * bs - bp),
                                            bq = Math.sqrt(br) / bs;

                                        function bn(bt, bv) {
                                            var bu = Math.sqrt(br - 2 * bs * Math.sin(bv)) / bs;
                                            return [bu * Math.sin(bt *= bs), bq - bu * Math.cos(bt)]
                                        }
                                        bn.invert = function(bu, bv) {
                                            var bt = bq - bv;
                                            return [Math.atan2(bu, bt) / bs, ap((br - (bu * bu + bt * bt) * bs * bs) / (2 * bs))]
                                        };
                                        return bn
                                    }(M.conicEqualArea = function() {
                                        return a3(L)
                                    }).raw = L;
                                    M.albers = function() {
                                        return M.conicEqualArea().rotate([96, 0]).center([-0.6, 38.7]).parallels([29.5, 45.5]).scale(1070)
                                    };
                                    M.albersUsa = function() {
                                        var bn = M.albers();
                                        var br = M.conicEqualArea().rotate([154, 0]).center([-2, 58.5]).parallels([55, 65]);
                                        var bo = M.conicEqualArea().rotate([157, 0]).center([-3, 19.9]).parallels([8, 18]);
                                        var bt, bm = {
                                                point: function(bv, bw) {
                                                    bt = [bv, bw]
                                                }
                                            },
                                            bq, bs, bp;

                                        function bu(bw) {
                                            var bv = bw[0],
                                                bx = bw[1];
                                            bt = null;
                                            (bq(bv, bx), bt) || (bs(bv, bx), bt) || bp(bv, bx);
                                            return bt
                                        }
                                        bu.invert = function(by) {
                                            var bw = bn.scale(),
                                                bx = bn.translate(),
                                                bv = (by[0] - bx[0]) / bw,
                                                bz = (by[1] - bx[1]) / bw;
                                            return (bz >= 0.12 && bz < 0.234 && bv >= -0.425 && bv < -0.214 ? br : bz >= 0.166 && bz < 0.234 && bv >= -0.214 && bv < -0.115 ? bo : bn).invert(by)
                                        };
                                        bu.stream = function(bx) {
                                            var bw = bn.stream(bx),
                                                by = br.stream(bx),
                                                bv = bo.stream(bx);
                                            return {
                                                point: function(bz, bA) {
                                                    bw.point(bz, bA);
                                                    by.point(bz, bA);
                                                    bv.point(bz, bA)
                                                },
                                                sphere: function() {
                                                    bw.sphere();
                                                    by.sphere();
                                                    bv.sphere()
                                                },
                                                lineStart: function() {
                                                    bw.lineStart();
                                                    by.lineStart();
                                                    bv.lineStart()
                                                },
                                                lineEnd: function() {
                                                    bw.lineEnd();
                                                    by.lineEnd();
                                                    bv.lineEnd()
                                                },
                                                polygonStart: function() {
                                                    bw.polygonStart();
                                                    by.polygonStart();
                                                    bv.polygonStart()
                                                },
                                                polygonEnd: function() {
                                                    bw.polygonEnd();
                                                    by.polygonEnd();
                                                    bv.polygonEnd()
                                                }
                                            }
                                        };
                                        bu.precision = function(bv) {
                                            if (!arguments.length) {
                                                return bn.precision()
                                            }
                                            bn.precision(bv);
                                            br.precision(bv);
                                            bo.precision(bv);
                                            return bu
                                        };
                                        bu.scale = function(bv) {
                                            if (!arguments.length) {
                                                return bn.scale()
                                            }
                                            bn.scale(bv);
                                            br.scale(bv * 0.35);
                                            bo.scale(bv);
                                            return bu.translate(bn.translate())
                                        };
                                        bu.translate = function(bx) {
                                            if (!arguments.length) {
                                                return bn.translate()
                                            }
                                            var bw = bn.scale(),
                                                bv = +bx[0],
                                                by = +bx[1];
                                            bq = bn.translate(bx).clipExtent([
                                                [bv - 0.455 * bw, by - 0.238 * bw],
                                                [bv + 0.455 * bw, by + 0.238 * bw]
                                            ]).stream(bm).point;
                                            bs = br.translate([bv - 0.307 * bw, by + 0.201 * bw]).clipExtent([
                                                [bv - 0.425 * bw + at, by + 0.12 * bw + at],
                                                [bv - 0.214 * bw - at, by + 0.234 * bw - at]
                                            ]).stream(bm).point;
                                            bp = bo.translate([bv - 0.205 * bw, by + 0.212 * bw]).clipExtent([
                                                [bv - 0.214 * bw + at, by + 0.166 * bw + at],
                                                [bv - 0.115 * bw - at, by + 0.234 * bw - at]
                                            ]).stream(bm).point;
                                            return bu
                                        };
                                        return bu.scale(1070)
                                    };
                                    var aZ, aL, aQ = {
                                        point: bg,
                                        lineStart: bg,
                                        lineEnd: bg,
                                        polygonStart: function() {
                                            aL = 0;
                                            aQ.lineStart = p
                                        },
                                        polygonEnd: function() {
                                            aQ.lineStart = aQ.lineEnd = aQ.point = bg;
                                            aZ += af(aL / 2)
                                        }
                                    };

                                    function p() {
                                        var bp, bm, bn, bo;
                                        aQ.point = function(br, bs) {
                                            aQ.point = bq;
                                            bp = bn = br, bm = bo = bs
                                        };

                                        function bq(br, bs) {
                                            aL += bo * br - bn * bs;
                                            bn = br, bo = bs
                                        }
                                        aQ.lineEnd = function() {
                                            bq(bp, bm)
                                        }
                                    }
                                    var W, y, V, x;
                                    var an = {
                                        point: u,
                                        lineStart: bg,
                                        lineEnd: bg,
                                        polygonStart: bg,
                                        polygonEnd: bg
                                    };

                                    function u(bm, bn) {
                                        if (bm < W) {
                                            W = bm
                                        }
                                        if (bm > V) {
                                            V = bm
                                        }
                                        if (bn < y) {
                                            y = bn
                                        }
                                        if (bn > x) {
                                            x = bn
                                        }
                                    }

                                    function g() {
                                        var bo = aE(4.5),
                                            bn = [];
                                        var bt = {
                                            point: bm,
                                            lineStart: function() {
                                                bt.point = bs
                                            },
                                            lineEnd: br,
                                            polygonStart: function() {
                                                bt.lineEnd = bp
                                            },
                                            polygonEnd: function() {
                                                bt.lineEnd = br;
                                                bt.point = bm
                                            },
                                            pointRadius: function(bu) {
                                                bo = aE(bu);
                                                return bt
                                            },
                                            result: function() {
                                                if (bn.length) {
                                                    var bu = bn.join("");
                                                    bn = [];
                                                    return bu
                                                }
                                            }
                                        };

                                        function bm(bu, bv) {
                                            bn.push("M", bu, ",", bv, bo)
                                        }

                                        function bs(bu, bv) {
                                            bn.push("M", bu, ",", bv);
                                            bt.point = bq
                                        }

                                        function bq(bu, bv) {
                                            bn.push("L", bu, ",", bv)
                                        }

                                        function br() {
                                            bt.point = bm
                                        }

                                        function bp() {
                                            bn.push("Z")
                                        }
                                        return bt
                                    }

                                    function aE(bm) {
                                        return "m0," + bm + "a" + bm + "," + bm + " 0 1,1 0," + -2 * bm + "a" + bm + "," + bm + " 0 1,1 0," + 2 * bm + "z"
                                    }
                                    var aT = {
                                        point: ad,
                                        lineStart: aP,
                                        lineEnd: f,
                                        polygonStart: function() {
                                            aT.lineStart = aY
                                        },
                                        polygonEnd: function() {
                                            aT.point = ad;
                                            aT.lineStart = aP;
                                            aT.lineEnd = f
                                        }
                                    };

                                    function ad(bm, bn) {
                                        G += bm;
                                        n += bn;
                                        ++a9
                                    }

                                    function aP() {
                                        var bm, bn;
                                        aT.point = function(bp, bq) {
                                            aT.point = bo;
                                            ad(bm = bp, bn = bq)
                                        };

                                        function bo(bp, bt) {
                                            var br = bp - bm,
                                                bq = bt - bn,
                                                bs = Math.sqrt(br * br + bq * bq);
                                            E += bs * (bm + bp) / 2;
                                            m += bs * (bn + bt) / 2;
                                            a8 += bs;
                                            ad(bm = bp, bn = bt)
                                        }
                                    }

                                    function f() {
                                        aT.point = ad
                                    }

                                    function aY() {
                                        var bp, bm, bn, bo;
                                        aT.point = function(br, bs) {
                                            aT.point = bq;
                                            ad(bp = bn = br, bm = bo = bs)
                                        };

                                        function bq(br, bv) {
                                            var bt = br - bn,
                                                bs = bv - bo,
                                                bu = Math.sqrt(bt * bt + bs * bs);
                                            E += bu * (bn + br) / 2;
                                            m += bu * (bo + bv) / 2;
                                            a8 += bu;
                                            bu = bo * br - bn * bv;
                                            C += bu * (bn + br);
                                            l += bu * (bo + bv);
                                            a6 += bu * 3;
                                            ad(bn = br, bo = bv)
                                        }
                                        aT.lineEnd = function() {
                                            bq(bp, bm)
                                        }
                                    }
                                    M.render = [];

                                    function aO(bn) {
                                        var bq = 4.5;
                                        var bt = {
                                            point: bm,
                                            lineStart: function() {
                                                bt.point = bs
                                            },
                                            lineEnd: br,
                                            polygonStart: function() {
                                                bt.lineEnd = bo
                                            },
                                            polygonEnd: function() {
                                                bt.lineEnd = br;
                                                bt.point = bm
                                            },
                                            pointRadius: function(bu) {
                                                bq = bu;
                                                return bt
                                            },
                                            result: bg
                                        };

                                        function bm(bu, bv) {
                                            M.render.push([
                                                [bu, bv]
                                            ])
                                        }

                                        function bs(bu, bv) {
                                            M.render.push([]);
                                            M.render[M.render.length - 1].push([bu, bv]);
                                            bt.point = bp
                                        }

                                        function bp(bu, bv) {
                                            M.render[M.render.length - 1].push([bu, bv])
                                        }

                                        function br() {
                                            bt.point = bm
                                        }

                                        function bo() {}
                                        return bt
                                    }

                                    function w(bs) {
                                        var bp = 0.5,
                                            br = Math.cos(30 * Q),
                                            bt = 16;

                                        function bo(bu) {
                                            return (bt ? bq : bm)(bu)
                                        }

                                        function bm(bu) {
                                            return be(bu, function(bv, bw) {
                                                bv = bs(bv, bw);
                                                bu.point(bv[0], bv[1])
                                            })
                                        }

                                        function bq(bA) {
                                            var bD, bO, bK, bB, bN, bE, bw, bv, bM, bx, bP, bC, bG;
                                            var by = {
                                                point: bJ,
                                                lineStart: bF,
                                                lineEnd: bL,
                                                polygonStart: function() {
                                                    bA.polygonStart();
                                                    by.lineStart = bz
                                                },
                                                polygonEnd: function() {
                                                    bA.polygonEnd();
                                                    by.lineStart = bF
                                                }
                                            };

                                            function bJ(bQ, bR) {
                                                bQ = bs(bQ, bR);
                                                bA.point(bQ[0], bQ[1])
                                            }

                                            function bF() {
                                                bM = NaN;
                                                by.point = bu;
                                                bA.lineStart()
                                            }

                                            function bu(bQ, bR) {
                                                var bT = s([bQ, bR]),
                                                    bS = bs(bQ, bR);
                                                bn(bM, bx, bv, bP, bC, bG, bM = bS[0], bx = bS[1], bv = bQ, bP = bT[0], bC = bT[1], bG = bT[2], bt, bA);
                                                bA.point(bM, bx)
                                            }

                                            function bL() {
                                                by.point = bJ;
                                                bA.lineEnd()
                                            }

                                            function bz() {
                                                bF();
                                                by.point = bI;
                                                by.lineEnd = bH
                                            }

                                            function bI(bQ, bR) {
                                                bu(bD = bQ, bO = bR), bK = bM, bB = bx, bN = bP, bE = bC, bw = bG;
                                                by.point = bu
                                            }

                                            function bH() {
                                                bn(bM, bx, bv, bP, bC, bG, bK, bB, bD, bN, bE, bw, bt, bA);
                                                by.lineEnd = bL;
                                                bL()
                                            }
                                            return by
                                        }

                                        function bn(bO, bA, bw, bW, bD, bL, bN, bz, bv, bU, bC, bJ, bT, bB) {
                                            var bH = bN - bO,
                                                bG = bz - bA,
                                                bV = bH * bH + bG * bG;
                                            if (bV > 4 * bp && bT--) {
                                                var bS = bW + bU,
                                                    bR = bD + bC,
                                                    bQ = bL + bJ,
                                                    bK = Math.sqrt(bS * bS + bR * bR + bQ * bQ),
                                                    bP = Math.asin(bQ /= bK),
                                                    bu = af(af(bQ) - 1) < at || af(bw - bv) < at ? (bw + bv) / 2 : Math.atan2(bR, bS),
                                                    bI = bs(bu, bP),
                                                    bM = bI[0],
                                                    by = bI[1],
                                                    bx = bM - bO,
                                                    bF = by - bA,
                                                    bE = bG * bx - bH * bF;
                                                if (bE * bE / bV > bp || af((bH * bx + bG * bF) / bV - 0.5) > 0.3 || bW * bU + bD * bC + bL * bJ < br) {
                                                    bn(bO, bA, bw, bW, bD, bL, bM, by, bu, bS /= bK, bR /= bK, bQ, bT, bB);
                                                    bB.point(bM, by);
                                                    bn(bM, by, bu, bS, bR, bQ, bN, bz, bv, bU, bC, bJ, bT, bB)
                                                }
                                            }
                                        }
                                        bo.precision = function(bu) {
                                            if (!arguments.length) {
                                                return Math.sqrt(bp)
                                            }
                                            bt = (bp = bu * bu) > 0 && 16;
                                            return bo
                                        };
                                        return bo
                                    }
                                    M.path = function() {
                                        var bs = 4.5,
                                            bn, bp, bq, bm, bo;

                                        function bt(bu) {
                                            M.render = [];
                                            if (bu) {
                                                if (typeof bs === "function") {
                                                    bm.pointRadius(+bs.apply(this, arguments))
                                                }
                                                if (!bo || !bo.valid) {
                                                    bo = bq(bm)
                                                }
                                                M.stream(bu, bo)
                                            }
                                            return M.render;
                                            return bm.result()
                                        }
                                        bt.area = function(bu) {
                                            aZ = 0;
                                            M.stream(bu, bq(aQ));
                                            return aZ
                                        };
                                        bt.centroid = function(bu) {
                                            G = n = a9 = E = m = a8 = C = l = a6 = 0;
                                            M.stream(bu, bq(aT));
                                            return a6 ? [C / a6, l / a6] : a8 ? [E / a8, m / a8] : a9 ? [G / a9, n / a9] : [NaN, NaN]
                                        };
                                        bt.bounds = function(bu) {
                                            V = x = -(W = y = Infinity);
                                            M.stream(bu, bq(an));
                                            return [
                                                [W, y],
                                                [V, x]
                                            ]
                                        };
                                        bt.projection = function(bu) {
                                            if (!arguments.length) {
                                                return bn
                                            }
                                            bq = (bn = bu) ? bu.stream || U(bu) : ah;
                                            return br()
                                        };
                                        bt.context = function(bu) {
                                            if (!arguments.length) {
                                                return bp
                                            }
                                            bm = (bp = bu) == null ? new g() : new aO(bu);
                                            if (typeof bs !== "function") {
                                                bm.pointRadius(bs)
                                            }
                                            return br()
                                        };
                                        bt.pointRadius = function(bu) {
                                            if (!arguments.length) {
                                                return bs
                                            }
                                            bs = typeof bu === "function" ? bu : (bm.pointRadius(+bu), +bu);
                                            return bt
                                        };

                                        function br() {
                                            bo = null;
                                            return bt
                                        }
                                        return bt.projection(M.albersUsa()).context(null)
                                    };

                                    function U(bn) {
                                        var bm = w(function(bo, bp) {
                                            return bn([bo * al, bp * al])
                                        });
                                        return function(bo) {
                                            return bh(bm(bo))
                                        }
                                    }
                                    M.transform = function(bm) {
                                        return {
                                            stream: function(bp) {
                                                var bo = new K(bp);
                                                for (var bn in bm) {
                                                    bo[bn] = bm[bn]
                                                }
                                                return bo
                                            }
                                        }
                                    };

                                    function K(bm) {
                                        this.stream = bm
                                    }
                                    K.prototype = {
                                        point: function(bm, bn) {
                                            this.stream.point(bm, bn)
                                        },
                                        sphere: function() {
                                            this.stream.sphere()
                                        },
                                        lineStart: function() {
                                            this.stream.lineStart()
                                        },
                                        lineEnd: function() {
                                            this.stream.lineEnd()
                                        },
                                        polygonStart: function() {
                                            this.stream.polygonStart()
                                        },
                                        polygonEnd: function() {
                                            this.stream.polygonEnd()
                                        }
                                    };

                                    function be(bn, bm) {
                                        return {
                                            point: bm,
                                            sphere: function() {
                                                bn.sphere()
                                            },
                                            lineStart: function() {
                                                bn.lineStart()
                                            },
                                            lineEnd: function() {
                                                bn.lineEnd()
                                            },
                                            polygonStart: function() {
                                                bn.polygonStart()
                                            },
                                            polygonEnd: function() {
                                                bn.polygonEnd()
                                            }
                                        }
                                    }
                                    M.projection = aV;
                                    M.projectionMutator = e;

                                    function aV(bm) {
                                        return e(function() {
                                            return bm
                                        })()
                                    }

                                    function e(bA) {
                                        var bq, bF, bu, bC = w(function(bK, bL) {
                                                bK = bq(bK, bL);
                                                return [bK[0] * bD + bt, br - bK[1] * bD]
                                            }),
                                            bD = 150,
                                            by = 480,
                                            bx = 250,
                                            bB = 0,
                                            bo = 0,
                                            bE = 0,
                                            bv = 0,
                                            bp = 0,
                                            bt, br, bJ = c,
                                            bG = ah,
                                            bm = null,
                                            bn = null,
                                            bs;

                                        function bI(bK) {
                                            bK = bu(bK[0] * Q, bK[1] * Q);
                                            return [bK[0] * bD + bt, br - bK[1] * bD]
                                        }

                                        function bz(bK) {
                                            bK = bu.invert((bK[0] - bt) / bD, (br - bK[1]) / bD);
                                            return bK && [bK[0] * al, bK[1] * al]
                                        }
                                        bI.stream = function(bK) {
                                            if (bs) {
                                                bs.valid = false
                                            }
                                            bs = bh(bJ(bF, bC(bG(bK))));
                                            bs.valid = true;
                                            return bs
                                        };
                                        bI.clipAngle = function(bK) {
                                            if (!arguments.length) {
                                                return bm
                                            }
                                            bJ = bK == null ? (bm = bK, c) : ag((bm = +bK) * Q);
                                            return bw()
                                        };
                                        bI.clipExtent = function(bK) {
                                            if (!arguments.length) {
                                                return bn
                                            }
                                            bn = bK;
                                            bG = bK ? av(bK[0][0], bK[0][1], bK[1][0], bK[1][1]) : ah;
                                            return bw()
                                        };
                                        bI.scale = function(bK) {
                                            if (!arguments.length) {
                                                return bD
                                            }
                                            bD = +bK;
                                            return bH()
                                        };
                                        bI.translate = function(bK) {
                                            if (!arguments.length) {
                                                return [by, bx]
                                            }
                                            by = +bK[0];
                                            bx = +bK[1];
                                            return bH()
                                        };
                                        bI.center = function(bK) {
                                            if (!arguments.length) {
                                                return [bB * al, bo * al]
                                            }
                                            bB = bK[0] % 360 * Q;
                                            bo = bK[1] % 360 * Q;
                                            return bH()
                                        };
                                        bI.rotate = function(bK) {
                                            if (!arguments.length) {
                                                return [bE * al, bv * al, bp * al]
                                            }
                                            bE = bK[0] % 360 * Q;
                                            bv = bK[1] % 360 * Q;
                                            bp = bK.length > 2 ? bK[2] % 360 * Q : 0;
                                            return bH()
                                        };
                                        aI(bI, bC, "precision");

                                        function bH() {
                                            bu = bf(bF = aj(bE, bv, bp), bq);
                                            var bK = bq(bB, bo);
                                            bt = by - bK[0] * bD;
                                            br = bx + bK[1] * bD;
                                            return bw()
                                        }

                                        function bw() {
                                            if (bs) {
                                                bs.valid = false, bs = null
                                            }
                                            return bI
                                        }
                                        return function() {
                                            bq = bA.apply(this, arguments);
                                            bI.invert = bq.invert && bz;
                                            return bH()
                                        }
                                    }

                                    function bh(bm) {
                                        return be(bm, function(bn, bo) {
                                            bm.point(bn * Q, bo * Q)
                                        })
                                    }

                                    function bk(bm, bn) {
                                        return [bm, bn]
                                    }(M.equirectangular = function() {
                                        return aV(bk)
                                    }).raw = bk.invert = bk;
                                    M.rotation = function(bn) {
                                        bn = aj(bn[0] % 360 * Q, bn[1] * Q, bn.length > 2 ? bn[2] * Q : 0);

                                        function bm(bo) {
                                            bo = bn(bo[0] * Q, bo[1] * Q);
                                            return bo[0] *= al, bo[1] *= al, bo
                                        }
                                        bm.invert = function(bo) {
                                            bo = bn.invert(bo[0] * Q, bo[1] * Q);
                                            return bo[0] *= al, bo[1] *= al, bo
                                        };
                                        return bm
                                    };

                                    function d(bm, bn) {
                                        return [bm > J ? bm - bl : bm < -J ? bm + bl : bm, bn]
                                    }
                                    d.invert = bk;

                                    function aj(bm, bn, bo) {
                                        return bm ? bn || bo ? bf(aN(bm), aA(bn, bo)) : aN(bm) : bn || bo ? aA(bn, bo) : d
                                    }

                                    function aC(bm) {
                                        return function(bn, bo) {
                                            return bn += bm, [bn > J ? bn - bl : bn < -J ? bn + bl : bn, bo]
                                        }
                                    }

                                    function aN(bm) {
                                        var bn = aC(bm);
                                        bn.invert = aC(-bm);
                                        return bn
                                    }

                                    function aA(bn, br) {
                                        var bm = Math.cos(bn),
                                            bs = Math.sin(bn),
                                            bp = Math.cos(br),
                                            bq = Math.sin(br);

                                        function bo(bv, bw) {
                                            var bz = Math.cos(bw),
                                                bt = Math.cos(bv) * bz,
                                                by = Math.sin(bv) * bz,
                                                bx = Math.sin(bw),
                                                bu = bx * bm + bt * bs;
                                            return [Math.atan2(by * bp - bu * bq, bt * bm - bx * bs), ap(bu * bp + by * bq)]
                                        }
                                        bo.invert = function(bv, bw) {
                                            var bz = Math.cos(bw),
                                                bt = Math.cos(bv) * bz,
                                                by = Math.sin(bv) * bz,
                                                bx = Math.sin(bw),
                                                bu = bx * bp - by * bq;
                                            return [Math.atan2(by * bp + bx * bq, bt * bm + bu * bs), ap(bu * bm - bt * bs)]
                                        };
                                        return bo
                                    }
                                    M.circle = function() {
                                        var bn = [0, 0],
                                            bq, bm = 6,
                                            bo;

                                        function bp() {
                                            var br = typeof bn === "function" ? bn.apply(this, arguments) : bn,
                                                bt = aj(-br[0] * Q, -br[1] * Q, 0).invert,
                                                bs = [];
                                            bo(null, null, 1, {
                                                point: function(bu, bv) {
                                                    bs.push(bu = bt(bu, bv));
                                                    bu[0] *= al, bu[1] *= al
                                                }
                                            });
                                            return {
                                                type: "Polygon",
                                                coordinates: [bs]
                                            }
                                        }
                                        bp.origin = function(br) {
                                            if (!arguments.length) {
                                                return bn
                                            }
                                            bn = br;
                                            return bp
                                        };
                                        bp.angle = function(br) {
                                            if (!arguments.length) {
                                                return bq
                                            }
                                            bo = z((bq = +br) * Q, bm * Q);
                                            return bp
                                        };
                                        bp.precision = function(br) {
                                            if (!arguments.length) {
                                                return bm
                                            }
                                            bo = z(bq * Q, (bm = +br) * Q);
                                            return bp
                                        };
                                        return bp.angle(90)
                                    };

                                    function z(bm, bn) {
                                        var bp = Math.cos(bm),
                                            bo = Math.sin(bm);
                                        return function(bw, bv, bu, bt) {
                                            var bs = bu * bn;
                                            if (bw != null) {
                                                bw = a4(bp, bw);
                                                bv = a4(bp, bv);
                                                if (bu > 0 ? bw < bv : bw > bv) {
                                                    bw += bu * bl
                                                }
                                            } else {
                                                bw = bm + bu * bl;
                                                bv = bm - 0.5 * bs
                                            }
                                            for (var bq, br = bw; bu > 0 ? br > bv : br < bv; br -= bs) {
                                                bt.point((bq = aG([bp, -bo * Math.cos(br), -bo * Math.sin(br)]))[0], bq[1])
                                            }
                                        }
                                    }

                                    function a4(bo, bm) {
                                        var bn = s(bm);
                                        bn[0] -= bo;
                                        aH(bn);
                                        var bp = bi(-bn[1]);
                                        return ((-bn[2] < 0 ? -bp : bp) + 2 * Math.PI - at) % (2 * Math.PI)
                                    }
                                    M.distance = function(bw, bt) {
                                        var bn = (bt[0] - bw[0]) * Q,
                                            bv = bw[1] * Q,
                                            bs = bt[1] * Q,
                                            bm = Math.sin(bn),
                                            bu = Math.cos(bn),
                                            br = Math.sin(bv),
                                            bp = Math.cos(bv),
                                            bq = Math.sin(bs),
                                            bo = Math.cos(bs),
                                            bx;
                                        return Math.atan2(Math.sqrt((bx = bo * bm) * bx + (bx = bp * bq - br * bo * bu) * bx), br * bq + bp * bo * bu)
                                    };
                                    M.graticule = function() {
                                        var bC, bE, bF, bG, bp, bq, br, bt, by = 10,
                                            bx = by,
                                            bu = 90,
                                            bs = 360,
                                            bw, bv, bo, bn, bB = 2.5;

                                        function bA(bJ, bI, bH) {
                                            var bK = S(bJ, bI - at, bH).concat(bI);
                                            return function(bL) {
                                                return bK.map(function(bM) {
                                                    return [bL, bM]
                                                })
                                            }
                                        }

                                        function bz(bK, bJ, bI) {
                                            var bH = S(bK, bJ - at, bI).concat(bJ);
                                            return function(bL) {
                                                return bH.map(function(bM) {
                                                    return [bM, bL]
                                                })
                                            }
                                        }

                                        function bD() {
                                            return {
                                                type: "MultiLineString",
                                                coordinates: bm()
                                            }
                                        }

                                        function bm() {
                                            return S(Math.ceil(bG / bu) * bu, bF, bu).map(bo).concat(S(Math.ceil(bt / bs) * bs, br, bs).map(bn)).concat(S(Math.ceil(bE / by) * by, bC, by).filter(function(bH) {
                                                return af(bH % bu) > at
                                            }).map(bw)).concat(S(Math.ceil(bq / bx) * bx, bp, bx).filter(function(bH) {
                                                return af(bH % bs) > at
                                            }).map(bv))
                                        }
                                        bD.lines = function() {
                                            return bm().map(function(bH) {
                                                return {
                                                    type: "LineString",
                                                    coordinates: bH
                                                }
                                            })
                                        };
                                        bD.outline = function() {
                                            return {
                                                type: "Polygon",
                                                coordinates: [bo(bG).concat(bn(br).slice(1), bo(bF).reverse().slice(1), bn(bt).reverse().slice(1))]
                                            }
                                        };
                                        bD.extent = function(bH) {
                                            if (!arguments.length) {
                                                return bD.minorExtent()
                                            }
                                            return bD.majorExtent(bH).minorExtent(bH)
                                        };
                                        bD.majorExtent = function(bH) {
                                            if (!arguments.length) {
                                                return [
                                                    [bG, bt],
                                                    [bF, br]
                                                ]
                                            }
                                            bG = +bH[0][0], bF = +bH[1][0];
                                            bt = +bH[0][1], br = +bH[1][1];
                                            if (bG > bF) {
                                                bH = bG, bG = bF, bF = bH
                                            }
                                            if (bt > br) {
                                                bH = bt, bt = br, br = bH
                                            }
                                            return bD.precision(bB)
                                        };
                                        bD.minorExtent = function(bH) {
                                            if (!arguments.length) {
                                                return [
                                                    [bE, bq],
                                                    [bC, bp]
                                                ]
                                            }
                                            bE = +bH[0][0], bC = +bH[1][0];
                                            bq = +bH[0][1], bp = +bH[1][1];
                                            if (bE > bC) {
                                                bH = bE, bE = bC, bC = bH
                                            }
                                            if (bq > bp) {
                                                bH = bq, bq = bp, bp = bH
                                            }
                                            return bD.precision(bB)
                                        };
                                        bD.step = function(bH) {
                                            if (!arguments.length) {
                                                return bD.minorStep()
                                            }
                                            return bD.majorStep(bH).minorStep(bH)
                                        };
                                        bD.majorStep = function(bH) {
                                            if (!arguments.length) {
                                                return [bu, bs]
                                            }
                                            bu = +bH[0], bs = +bH[1];
                                            return bD
                                        };
                                        bD.minorStep = function(bH) {
                                            if (!arguments.length) {
                                                return [by, bx]
                                            }
                                            by = +bH[0], bx = +bH[1];
                                            return bD
                                        };
                                        bD.precision = function(bH) {
                                            if (!arguments.length) {
                                                return bB
                                            }
                                            bB = +bH;
                                            bw = bA(bq, bp, 90);
                                            bv = bz(bE, bC, bB);
                                            bo = bA(bt, br, 90);
                                            bn = bz(bG, bF, bB);
                                            return bD
                                        };
                                        return bD.majorExtent([
                                            [-180, -90 + at],
                                            [180, 90 - at]
                                        ]).minorExtent([
                                            [-180, -80 - at],
                                            [180, 80 + at]
                                        ])
                                    };
                                    M.greatArc = function() {
                                        function bo(bt) {
                                            return bt.source
                                        }

                                        function bp(bt) {
                                            return bt.target
                                        }
                                        var bq = bo,
                                            bn, br = bp,
                                            bs;

                                        function bm() {
                                            return {
                                                type: "LineString",
                                                coordinates: [bn || bq.apply(this, arguments), bs || br.apply(this, arguments)]
                                            }
                                        }
                                        bm.distance = function() {
                                            return M.distance(bn || bq.apply(this, arguments), bs || br.apply(this, arguments))
                                        };
                                        bm.source = function(bt) {
                                            if (!arguments.length) {
                                                return bq
                                            }
                                            bq = bt, bn = typeof bt === "function" ? null : bt;
                                            return bm
                                        };
                                        bm.target = function(bt) {
                                            if (!arguments.length) {
                                                return br
                                            }
                                            br = bt, bs = typeof bt === "function" ? null : bt;
                                            return bm
                                        };
                                        bm.precision = function() {
                                            return arguments.length ? bm : 0
                                        };
                                        return bm
                                    };
                                    M.interpolate = function(bn, bo) {
                                        function bm(bs, bD, br, bB) {
                                            var bv = Math.cos(bD),
                                                bC = Math.sin(bD),
                                                bt = Math.cos(bB),
                                                bA = Math.sin(bB),
                                                bx = bv * Math.cos(bs),
                                                bq = bv * Math.sin(bs),
                                                bw = bt * Math.cos(br),
                                                bp = bt * Math.sin(br),
                                                bz = 2 * Math.asin(Math.sqrt(T(bB - bD) + bv * bt * T(br - bs))),
                                                bu = 1 / Math.sin(bz);
                                            var by = bz ? function(bG) {
                                                var bJ = Math.sin(bG *= bz) * bu,
                                                    bF = Math.sin(bz - bG) * bu,
                                                    bE = bF * bx + bJ * bw,
                                                    bI = bF * bq + bJ * bp,
                                                    bH = bF * bC + bJ * bA;
                                                return [Math.atan2(bI, bE) * al, Math.atan2(bH, Math.sqrt(bE * bE + bI * bI)) * al]
                                            } : function() {
                                                return [bs * al, bD * al]
                                            };
                                            by.distance = bz;
                                            return by
                                        }
                                        return bm(bn[0] * Q, bn[1] * Q, bo[0] * Q, bo[1] * Q)
                                    };
                                    M.length = function(bm) {
                                        F = 0;
                                        M.stream(bm, aS);
                                        return F
                                    };
                                    var F;
                                    var aS = {
                                        sphere: bg,
                                        point: bg,
                                        lineStart: ab,
                                        lineEnd: bg,
                                        polygonStart: bg,
                                        polygonEnd: bg
                                    };

                                    function ab() {
                                        var bo, bm, bn;
                                        aS.point = function(bq, br) {
                                            bo = bq * Q, bm = Math.sin(br *= Q), bn = Math.cos(br);
                                            aS.point = bp
                                        };
                                        aS.lineEnd = function() {
                                            aS.point = aS.lineEnd = bg
                                        };

                                        function bp(bq, bt) {
                                            var bs = Math.sin(bt *= Q),
                                                bv = Math.cos(bt),
                                                br = af((bq *= Q) - bo),
                                                bu = Math.cos(br);
                                            F += Math.atan2(Math.sqrt((br = bv * Math.sin(br)) * br + (br = bn * bs - bm * bv * bu) * br), bm * bs + bn * bv * bu);
                                            bo = bq, bm = bs, bn = bv
                                        }
                                    }

                                    function am(bo, bn) {
                                        function bm(bq, br) {
                                            var bs = Math.cos(bq),
                                                bt = Math.cos(br),
                                                bp = bo(bs * bt);
                                            return [bp * bt * Math.sin(bq), bp * Math.sin(br)]
                                        }
                                        bm.invert = function(bp, bu) {
                                            var bq = Math.sqrt(bp * bp + bu * bu),
                                                bt = bn(bq),
                                                br = Math.sin(bt),
                                                bs = Math.cos(bt);
                                            return [Math.atan2(bp * br, bq * bs), Math.asin(bq && bu * br / bq)]
                                        };
                                        return bm
                                    }
                                    var bd = am(function(bm) {
                                        return Math.sqrt(2 / (1 + bm))
                                    }, function(bm) {
                                        return 2 * Math.asin(bm / 2)
                                    });
                                    (M.azimuthalEqualArea = function() {
                                        return aV(bd)
                                    }).raw = bd;
                                    var b = am(function(bm) {
                                        var bn = Math.acos(bm);
                                        return bn && bn / Math.sin(bn)
                                    }, ah);
                                    (M.azimuthalEquidistant = function() {
                                        return aV(b)
                                    }).raw = b;

                                    function ba(bo, bm) {
                                        var br = Math.cos(bo),
                                            bp = function(bt) {
                                                return Math.tan(J / 4 + bt / 2)
                                            },
                                            bs = bo === bm ? Math.sin(bo) : Math.log(br / Math.cos(bm)) / Math.log(bp(bm) / bp(bo)),
                                            bq = br * Math.pow(bp(bo), bs) / bs;
                                        if (!bs) {
                                            return R
                                        }

                                        function bn(bt, bv) {
                                            if (bq > 0) {
                                                if (bv < -aX + at) {
                                                    bv = -aX + at
                                                }
                                            } else {
                                                if (bv > aX - at) {
                                                    bv = aX - at
                                                }
                                            }
                                            var bu = bq / Math.pow(bp(bv), bs);
                                            return [bu * Math.sin(bs * bt), bq - bu * Math.cos(bs * bt)]
                                        }
                                        bn.invert = function(bu, bw) {
                                            var bt = bq - bw,
                                                bv = az(bs) * Math.sqrt(bu * bu + bt * bt);
                                            return [Math.atan2(bu, bt) / bs, 2 * Math.atan(Math.pow(bq / bv, 1 / bs)) - aX]
                                        };
                                        return bn
                                    }(M.conicConformal = function() {
                                        return a3(ba)
                                    }).raw = ba;

                                    function H(bo, bm) {
                                        var bq = Math.cos(bo),
                                            br = bo === bm ? Math.sin(bo) : (bq - Math.cos(bm)) / (bm - bo),
                                            bp = bq / br + bo;
                                        if (af(br) < at) {
                                            return bk
                                        }

                                        function bn(bs, bu) {
                                            var bt = bp - bu;
                                            return [bt * Math.sin(br * bs), bp - bt * Math.cos(br * bs)]
                                        }
                                        bn.invert = function(bt, bu) {
                                            var bs = bp - bu;
                                            return [Math.atan2(bt, bs) / br, bp - az(br) * Math.sqrt(bt * bt + bs * bs)]
                                        };
                                        return bn
                                    }(M.conicEquidistant = function() {
                                        return a3(H)
                                    }).raw = H;
                                    var t = am(function(bm) {
                                        return 1 / bm
                                    }, Math.atan);
                                    (M.gnomonic = function() {
                                        return aV(t)
                                    }).raw = t;

                                    function R(bm, bn) {
                                        return [bm, Math.log(Math.tan(J / 4 + bn / 2))]
                                    }
                                    R.invert = function(bm, bn) {
                                        return [bm, 2 * Math.atan(Math.exp(bn)) - aX]
                                    };

                                    function a2(br) {
                                        var bm = aV(br),
                                            bq = bm.scale,
                                            bp = bm.translate,
                                            bn = bm.clipExtent,
                                            bo;
                                        bm.scale = function() {
                                            var bs = bq.apply(bm, arguments);
                                            return bs === bm ? bo ? bm.clipExtent(null) : bm : bs
                                        };
                                        bm.translate = function() {
                                            var bs = bp.apply(bm, arguments);
                                            return bs === bm ? bo ? bm.clipExtent(null) : bm : bs
                                        };
                                        bm.clipExtent = function(bu) {
                                            var bt = bn.apply(bm, arguments);
                                            if (bt === bm) {
                                                if (bo = bu == null) {
                                                    var bs = J * bq(),
                                                        bv = bp();
                                                    bn([
                                                        [bv[0] - bs, bv[1] - bs],
                                                        [bv[0] + bs, bv[1] + bs]
                                                    ])
                                                }
                                            } else {
                                                if (bo) {
                                                    bt = null
                                                }
                                            }
                                            return bt
                                        };
                                        return bm.clipExtent(null)
                                    }(M.mercator = function() {
                                        return a2(R)
                                    }).raw = R;
                                    var a1 = am(function() {
                                        return 1
                                    }, Math.asin);
                                    (M.orthographic = function() {
                                        return aV(a1)
                                    }).raw = a1;
                                    var D = am(function(bm) {
                                        return 1 / (1 + bm)
                                    }, function(bm) {
                                        return 2 * Math.atan(bm)
                                    });
                                    (M.stereographic = function() {
                                        return aV(D)
                                    }).raw = D;

                                    function v(bm, bn) {
                                        return [Math.log(Math.tan(J / 4 + bn / 2)), -bm]
                                    }
                                    v.invert = function(bm, bn) {
                                        return [-bn, 2 * Math.atan(Math.exp(bm)) - aX]
                                    };
                                    (M.transverseMercator = function() {
                                        var bn = a2(v),
                                            bm = bn.center,
                                            bo = bn.rotate;
                                        bn.center = function(bp) {
                                            return bp ? bm([-bp[1], bp[0]]) : (bp = bm(), [bp[1], -bp[0]])
                                        };
                                        bn.rotate = function(bp) {
                                            return bp ? bo([bp[0], bp[1], bp.length > 2 ? bp[2] + 90 : 90]) : (bp = bo(), [bp[0], bp[1], bp[2] - 90])
                                        };
                                        return bo([0, 0, 90])
                                    }).raw = v;
                                    return M
                                };
                                this.geoProjectInvert = function(a) {
                                    return this.geoProjection.invert(a)
                                };
                                this.geoProject = function(a) {
                                    return this.geoPath(a)
                                };
                                this.initializeOrthographic = function() {
                                    this.mapObject = this.d3Geo();
                                    var f = this.meta.map.geojson.global;
                                    var h = this.marginLeft + this.offsetX + this.left + (this.x / 2);
                                    var g = this.marginTop + this.offsetY + this.top + (this.y / 2);
                                    var d = this.layoutComb ? this.layoutWidth : this.width;
                                    var b = this.layoutComb ? this.layoutHeight : this.height;
                                    var e = this.eventMapZoom ? this.eventMap.zom : this.mapConfig && this.mapConfig.zoom ? this.mapConfig.zoom : this.mapProjection == "orthographic" ? this.zoom : f.zoom;
                                    var a = this.mapProjection == "orthographic" && this.geoProjection ? this.geoProjection.rotate() : this.eventMapCenter ? this.eventMapCenter : this.mapConfig && this.mapConfig.center ? [-this.mapConfig.center[0], -this.mapConfig.center[1]] : [f.center[0], f.center[1]];
                                    var c = this.meta.canvas.ctx.canvas.getContext("2d");
                                    this.geoGraticule = this.mapObject.graticule()();
                                    this.geoCanvasScale = this.mapProjection == "mercator" ? [this.y * e / (2 * Math.PI)] : this.mapProjection == "orthographic" ? b / 2 * 0.86 : Math.min(this.x, this.y) / 2;
                                    this.geoCanvasCenter = this.mapProjection == "orthographic" ? [d / 2, b / 2] : [h, g];
                                    switch (this.mapProjection) {
                                        case "mercator":
                                            this.geoProjection = this.mapObject.mercator().center(a).scale(this.geoCanvasScale).translate(this.geoCanvasCenter);
                                            break;
                                        case "albers":
                                            this.geoProjection = this.mapObject.albers().center(a).scale(this.geoCanvasScale * e).translate(this.geoCanvasCenter).clipAngle(90).precision(0.5);
                                            break;
                                        case "orthographic":
                                            this.geoProjection = this.mapObject.orthographic().scale(this.geoCanvasScale * e).translate(this.geoCanvasCenter).clipAngle(90).precision(0.5).rotate(a);
                                            break
                                    }
                                    this.geoPath = this.mapObject.path().projection(this.geoProjection).context(c)
                                }
                            };
                            CanvasXpress.images = {
                                "01": "https://www.canvasxpress.org/assets/images/core/01.png",
                                "02": "https://www.canvasxpress.org/assets/images/core/02.png",
                                "03": "https://www.canvasxpress.org/assets/images/core/03.png",
                                "04": "https://www.canvasxpress.org/assets/images/core/04.png",
                                "05": "https://www.canvasxpress.org/assets/images/core/05.png",
                                "06": "https://www.canvasxpress.org/assets/images/core/06.png",
                                "07": "https://www.canvasxpress.org/assets/images/core/07.png",
                                "08": "https://www.canvasxpress.org/assets/images/core/08.png",
                                "10": "https://www.canvasxpress.org/assets/images/core/10.png",
                                "11": "https://www.canvasxpress.org/assets/images/core/11.png",
                                "15": "https://www.canvasxpress.org/assets/images/core/15.png",
                                "23": "https://www.canvasxpress.org/assets/images/core/23.png",
                                "29": "https://www.canvasxpress.org/assets/images/core/29.png",
                                "30": "https://www.canvasxpress.org/assets/images/core/30.png",
                                "31": "https://www.canvasxpress.org/assets/images/core/31.png",
                                "32": "https://www.canvasxpress.org/assets/images/core/32.png",
                                "36": "https://www.canvasxpress.org/assets/images/core/36.png",
                                "46": "https://www.canvasxpress.org/assets/images/core/46.png",
                                "47": "https://www.canvasxpress.org/assets/images/core/47.png",
                                "48": "https://www.canvasxpress.org/assets/images/core/48.png",
                                "49": "https://www.canvasxpress.org/assets/images/core/49.png",
                                "50": "https://www.canvasxpress.org/assets/images/core/50.png",
                                "54": "https://www.canvasxpress.org/assets/images/core/54.png",
                                "56": "https://www.canvasxpress.org/assets/images/core/56.png",
                                "58": "https://www.canvasxpress.org/assets/images/core/58.png",
                                "59": "https://www.canvasxpress.org/assets/images/core/59.png",
                                "60": "https://www.canvasxpress.org/assets/images/core/60.png",
                                "61": "https://www.canvasxpress.org/assets/images/core/61.png",
                                "62": "https://www.canvasxpress.org/assets/images/core/62.png",
                                "63": "https://www.canvasxpress.org/assets/images/core/63.png",
                                "67": "https://www.canvasxpress.org/assets/images/core/67.png",
                                "68": "https://www.canvasxpress.org/assets/images/core/68.png",
                                "69": "https://www.canvasxpress.org/assets/images/core/69.png",
                                "71": "https://www.canvasxpress.org/assets/images/core/71.png",
                                "99": "https://www.canvasxpress.org/assets/images/core/99.png",
                                canvasXpress: "data:image/png;base64,R0lGODlhAQABAID/AMDAwAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==",
                                cytoplasm: "https://www.canvasxpress.org/assets/images/core/cytoplasm.png",
                                epr: "https://www.canvasxpress.org/assets/images/core/epr.png",
                                extracellular: "https://www.canvasxpress.org/assets/images/core/extracellular.png",
                                lisosome: "https://www.canvasxpress.org/assets/images/core/lisosome.png",
                                lysosome: "https://www.canvasxpress.org/assets/images/core/lysosome.png",
                                microsome: "https://www.canvasxpress.org/assets/images/core/microsome.png",
                                mitochondria: "https://www.canvasxpress.org/assets/images/core/mitochondria.png",
                                mitochondria2: "https://www.canvasxpress.org/assets/images/core/mitochondria2.png",
                                nucleous: "https://www.canvasxpress.org/assets/images/core/nucleous.png",
                                nucleus: "https://www.canvasxpress.org/assets/images/core/nucleus.png",
                                peroxisome: "https://www.canvasxpress.org/assets/images/core/peroxisome.png"
                            };
                            CanvasXpress.icons = {
                                classes: {
                                    cxtn10: "{font: 10px sans-serif;}",
                                    cxblue: "{stroke:blue;stroke-width:5px;}",
                                    clt17: "{fill:#FEDFB2;}",
                                    cl55: "{fill:#C72037;}",
                                    cxti100: "{font: italic 100px Georgia;}",
                                    cl20: "{fill:#F2F2F2;}",
                                    cl24: "{fill:#A8D6FF;}",
                                    cl35: "{fill:#FDEE01;}",
                                    clt15: "{fill:#F91642;}",
                                    cl1: "{fill:#F7BA15;}",
                                    cxblack: "{stroke:black;fill:black;stroke-width:0.5px;}",
                                    cl18: "{fill:#FFF;}",
                                    cl4: "{fill:#EB3323;}",
                                    cl32: "{fill:#0080FF;}",
                                    cl27: "{fill:#164F86;}",
                                    cxtn40: "{font: 40px sans-serif;}",
                                    cxbc: "{stroke:#555;fill:#c6c6c6;}",
                                    cxts60: "{font: italic 60px Brush Script MT;}",
                                    cl56: "{fill:#E8762D;}",
                                    cxtn160: "{font: 160px sans-serif;}",
                                    cl8: "{fill:#3D5CA9;}",
                                    cxab: "{stroke:blue;fill:#555;}",
                                    cl36: "{fill:#FFAB00;}",
                                    cxb: "{stroke-miterlimit:10;stroke-width:3px;fill:none;stroke:#555;}",
                                    clt18: "{fill:#FECB7F;}",
                                    cl0: "{fill:#F6EA38;}",
                                    cxbw: "{stroke-miterlimit:10;stroke-width:3px;stroke:#555;fill:white}",
                                    cl21: "{fill:#FFFFFF;}",
                                    cl52: "{fill:#5B879B;}",
                                    cxtn90: "{font: 90px sans-serif;}",
                                    cxtn30: "{font: 30px sans-serif;}",
                                    clt10: "{fill:#AA47BC;}",
                                    clt8: "{fill:#CE93D7;}",
                                    cxwhite: " {stroke:white;stroke-width:2px;}",
                                    clt5: "{fill:#29B6F5;}",
                                    cl16: "{fill:#FE00FE;}",
                                    cl19: "{fill:#00608F;}",
                                    cxaa: "{stroke:blue;fill:blue;}",
                                    cl12: "{fill:#FE0000;}",
                                    cl3: "{fill:#EF5522;}",
                                    clt6: "{fill:#B12F83;}",
                                    cxtn60: "{font: 60px sans-serif;}",
                                    cl15: "{fill:#00FEFE;}",
                                    cxtn180: "{font: 180px sans-serif;}",
                                    clt9: "{fill:#BA68C8;}",
                                    cxtn20: "{font: 20px sans-serif;}",
                                    clr: "{fill:#2369BE;}",
                                    cl23: "{fill:#000643;}",
                                    cl58: "{fill:#FFFFFF;}",
                                    cxti85: "{font: italic 85px Georgia;}",
                                    clt2: "{fill:#B3E5FC;}",
                                    cxnc: "{stroke:none;fill:none;}",
                                    cl5: "{fill:#AC1E47;}",
                                    clt0: "{fill:#FFFFFF;}",
                                    cxtn120: "{font: 120px sans-serif;}",
                                    clt12: "{fill:#FEC8C4;}",
                                    clt4: "{fill:#4FC2F6;}",
                                    cl6: "{fill:#7B3691;}",
                                    cl17: "{fill:#FEFE00;}",
                                    clt16: "{fill:#FE9D0C;}",
                                    cl11: "{fill:#CCDC38;}",
                                    cxtxr: "{fill:none;stroke:red;stroke-width:3px;}",
                                    cl41: "{fill:#F6EA38;}",
                                    cl14: "{fill:#00FE00;}",
                                    cl10: "{fill:#64AD45;}",
                                    cl9: "{fill:#0691CC;}",
                                    cl40: "{fill:#F7BA15;}",
                                    cl53: "{fill:#EB9129;}",
                                    cxts70: "{font: italic 70px Brush Script MT;}",
                                    cxts100: "{font: italic 100px Brush Script MT;}",
                                    clt7: "{fill:#E0BDE7;}",
                                    cxtxb: "{fill:none;stroke:black;stroke-width:3px;}",
                                    cl7: "{fill:#462D8F;}",
                                    cl28: "{fill:#002452;}",
                                    cl33: "{fill:#7FFE1A;}",
                                    clt1: "{fill:#269BCF;}",
                                    cxrr: "{stroke:red;fill:red;}",
                                    cl2: "{fill:#F7981C;}",
                                    cl13: "{fill:#0000FE;}",
                                    cxts200: "{font: italic 200px Brush Script MT;}",
                                    clt14: "{fill:#FE5252;}",
                                    cl25: "{fill:#51A7F9;}",
                                    cl54: "{fill:#1F457E;}",
                                    cl50: "{fill:#7199A6;}",
                                    clt19: "{fill:#FEB64C;}",
                                    cl34: "{fill:#0DDA83;}",
                                    clt13: "{fill:#FE897F;}",
                                    cl30: "{fill:#000040;}",
                                    cxtb100: "{font: bold 100px sans-serif;}",
                                    cxtn80: "{font: 80px sans-serif;}",
                                    cxtn140: "{font: 140px sans-serif;}",
                                    cl57: "{fill:#EC1E24;}",
                                    cl31: "{fill:#0000CB;}",
                                    clt3: "{fill:#80D3FA;}",
                                    cxtn70: "{font: 70px sans-serif;}",
                                    cxtn100: "{font: 100px sans-serif;}",
                                    clt11: "{fill:#E11640;}",
                                    cl26: "{fill:#0365C0;}",
                                    cxc: "{stroke-miterlimit:10;stroke-width:3px;fill:none;stroke:#c6c6c6;}",
                                    cxts150: "{font: italic 150px Brush Script MT;}",
                                    cxac: "{stroke:blue;fill:#c6c6c6;}",
                                    cxtxa: "{fill:none;stroke:blue;stroke-width:3px;}",
                                    cxww: "{stroke:white;fill:white;}",
                                    cxbb: "{stroke:#555;fill:#555;}",
                                    cl37: "{fill:#E24520;}",
                                    cl22: "{fill:#424242;}",
                                    cxcc: "{stroke:#c6c6c6;fill:#c6c6c6;}",
                                    cl51: "{fill:#5C6692;}",
                                    clt20: "{fill:#FEA725;}",
                                    cxaw: "{stroke-miterlimit:10;stroke-width:3px;stroke:blue;fill:white;}",
                                    cxtn50: "{font: 50px sans-serif;}",
                                    cxa: " {stroke-miterlimit:10;stroke-width:3px;fill:none;stroke:blue;}"
                                },
                                gradients: {
                                    b_grhr: '<linearGradient id="hr-grad"><stop offset="5%" stop-color="white" /><stop offset="95%" stop-color="black" /></linearGradient>',
                                    tx_shadow: '<linearGradient id="ts-grad" gradientUnits="userSpaceOnUse" x1="67.7304" y1="44.903" x2="45.4561" y2="20.9231" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#ADADAD"/><stop  offset="1" style="stop-color:#6B6B6B"/></linearGradient>',
                                    b_bwindowgradient: '<linearGradient id="w-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    b_bgradient: '<linearGradient id="b-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    b_grc: '<radialGradient id="rad-grad"><stop offset="5%" stop-color="white" /><stop offset="95%" stop-color="black" /></radialGradient>',
                                    i_hist: '<linearGradient id="l-grad"><stop offset="5%"  stop-color="white" /><stop offset="95%" stop-color="black" /></linearGradient>',
                                    b_gstype: '<linearGradient id="gt-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient><radialGradient id="gt-gradr"><stop offset="5%" stop-color="white" /><stop offset="95%" stop-color="black" /></radialGradient>',
                                    c_wallstreetjournal: '<linearGradient id="WS-gradient" gradientTransform="rotate(90)"><stop offset="0" stop-color="#ece4d9" /><stop offset="1" stop-color="#c1b398" /></linearGradient>',
                                    c_canvasxpress: '<linearGradient id="cx-grad1" gradientUnits="userSpaceOnUse" x1="31.3462" y1="420.1643" x2="31.3462" y2="450.9281" gradientTransform="matrix(1 0 0 1 0 -398)"><stop  offset="0" style="stop-color:#FFD385"/><stop  offset="1" style="stop-color:#FFAE54"/></linearGradient><linearGradient id="cx-grad2" gradientUnits="userSpaceOnUse" x1="36.3" y1="428.6523" x2="36.3" y2="452.6173" gradientTransform="matrix(1 0 0 1 0 -398)"><stop  offset="0" style="stop-color:#FE6969"/><stop  offset="1" style="stop-color:#ED0C0C"/></linearGradient><linearGradient id="cx-grad3" gradientUnits="userSpaceOnUse" x1="49.85" y1="433.0864" x2="49.85" y2="452.6595" gradientTransform="matrix(1 0 0 1 0 -398)"><stop  offset="0" style="stop-color:#00B1DD"/><stop  offset="1" style="stop-color:#0081BD"/></linearGradient>',
                                    b_bbodygradient: '<linearGradient id="b-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    b_grvb: '<linearGradient id="vb-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="white" /><stop offset="95%" stop-color="black" /></linearGradient>',
                                    b_gsori: '<linearGradient id="go-gradv" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient><linearGradient id="go-gradh"><stop offset="5%"  stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    b_grvt: '<linearGradient id="vt-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    i_h: '<linearGradient id="l-grad"><stop offset="5%"  stop-color="white" /><stop offset="95%" stop-color="black" /></linearGradient><linearGradient id="r-grad"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    at_shd: '<linearGradient id="s-grad" gradientUnits="userSpaceOnUse" x1="50" y1="16.5161" x2="50" y2="46.4412" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#ADADAD"/><stop  offset="1" style="stop-color:#6B6B6B"/></linearGradient>',
                                    b_gsswitch: '<linearGradient id="gs-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    b_grhl: '<linearGradient id="hl-grad"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>',
                                    c_excel: '<linearGradient id="excel-grad1" gradientUnits="userSpaceOnUse" x1="10.4295" y1="93.4497" x2="91.2468" y2="8.6135" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#DEF1DF"/><stop  offset="1" style="stop-color:#DBEBC3"/></linearGradient><linearGradient id="excel-grad2" gradientUnits="userSpaceOnUse" x1="32.8982" y1="23.8811" x2="83.8607" y2="82.2735" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#06A817"/><stop  offset="1" style="stop-color:#003700"/></linearGradient><linearGradient id="excel-grad3" gradientUnits="userSpaceOnUse" x1="4.0159" y1="98.7549" x2="102.7326" y2="-1.6166" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#06A817"/><stop  offset="1" style="stop-color:#003700"/></linearGradient><linearGradient id="excel-grad4" gradientUnits="userSpaceOnUse" x1="19.1737" y1="87.3007" x2="78.6131" y2="23.2007" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#06A817"/><stop  offset="1" style="stop-color:#003700"/></linearGradient><linearGradient id="excel-grad5" gradientUnits="userSpaceOnUse" x1="19.1737" y1="87.3007" x2="78.6131" y2="23.2007" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#06A817"/><stop  offset="1" style="stop-color:#003700"/></linearGradient><linearGradient id="exel-grad6" gradientUnits="userSpaceOnUse" x1="47.2828" y1="36.174" x2="78.5223" y2="49.075" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#06A817"/><stop  offset="1" style="stop-color:#003700"/></linearGradient>',
                                    c_rc: '<linearGradient id="rc-grad" gradientUnits="userSpaceOnUse" x1="0" y1="53.205" x2="100" y2="53.205" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#BDBFC2"/><stop  offset="1" style="stop-color:#828287"/></linearGradient>',
                                    c_rrc: '<linearGradient id="rr-grad" gradientUnits="userSpaceOnUse" x1="0" y1="53.205" x2="100" y2="53.205" gradientTransform="matrix(1 0 0 -1 0 102)"><stop  offset="0" style="stop-color:#BDBFC2"/><stop  offset="1" style="stop-color:#828287"/></linearGradient>',
                                    b_btype: '<linearGradient id="bl-grad" gradientTransform="rotate(90)"><stop offset="5%" stop-color="black" /><stop offset="95%" stop-color="white" /></linearGradient>'
                                },
                                use: {
                                    wp_scale: ["wp_scale"],
                                    bx_median: ["bx_median"],
                                    dtt_transpose: ["dtt_transpose"],
                                    a_moveback: ["a_moveback"],
                                    wp_datawrangling: ["wp_datawrangling"],
                                    p_ghsampletitle: ["p_gh", "p_ghsampletitle"],
                                    p_g2axisy: ["p_g2", "p_g2axisy"],
                                    p_g1citation: ["p_g1", "p_g1citation"],
                                    ar_bm: ["ar_bm"],
                                    ch_czzz: ["dummy"],
                                    gd_g1marker: ["p_cg1axesvertical", "p_cg1datavertical", "p_dgmarker"],
                                    rt_c2: ["rt_c2"],
                                    ch_calt: ["ch_calt"],
                                    wp_dom: ["wp_dom"],
                                    sw_down: ["sw_down"],
                                    sp_thicker: ["sp_thicker"],
                                    ch_cctrl: ["ch_cctrl"],
                                    c_excel: ["c_excel"],
                                    bx_medianw: ["bx_medianw"],
                                    gc_ghspace: ["p_cghdata1", "p_cghdata2", "p_cghaxes", "h_hspace"],
                                    dp_binc: ["dp_binc"],
                                    ch_oz: ["ch_oz"],
                                    p_g3axisz: ["p_g3", "p_g3axisz"],
                                    ar_dcbls: ["ar_dcbls"],
                                    ln_zzz: ["dummy"],
                                    gc_goverticalhorizontal: ["p_cg1dataverticalhorizontal"],
                                    rt_c: ["rt_c"],
                                    g_donnut: ["g_donnut"],
                                    ch_olog2: ["ch_olog2"],
                                    g_pie: ["g_pie"],
                                    ar_diagm: ["ar_tlm", "ar_trm", "ar_brm", "ar_blm"],
                                    gc_govertical: ["p_cg1axesvertical", "p_cg1datavertical"],
                                    ch_ox: ["ch_ox"],
                                    dps_expand: ["dps_expand"],
                                    dt_histremove: ["p_cg2axes", "p_cg2datahist", "v_cancelsmall"],
                                    gd_g1line: ["p_cg1axesvertical", "p_cg1datavertical", "p_dgline"],
                                    g_barline: ["g_barline"],
                                    b_bzzz: ["dummy"],
                                    z_zoom: ["z_zoom"],
                                    gr_stylesolid: ["gr_stylesolid"],
                                    dtp_count: ["dt_count"],
                                    a_order: ["a_order"],
                                    b_bwindowgradient: ["b_body", "b_windowgradient", "b_pail"],
                                    sv_diskjson: ["sv_diskjson"],
                                    gr_g2z: ["gr_g2z"],
                                    p_g1zzz: ["dummy"],
                                    gd_g2line: ["p_cg2axes", "p_cg2data", "p_dgline"],
                                    ar_ls: ["ar_ls"],
                                    op_redo: ["op_redo"],
                                    g_density: ["g_density"],
                                    gc_gohorizontal: ["p_cg1axeshorizontal", "p_cg1datahorizontal"],
                                    sr_aad: ["sr_aad"],
                                    gr_g2xy: ["gr_g2xy"],
                                    wp_data: ["wp_data"],
                                    p_ghsubtitle: ["p_gh", "p_ghsubtitle"],
                                    sw_zzz: ["dummy"],
                                    gc_gerrors: ["p_cg1axesvertical", "p_cg1dataverticalshort", "p_cg1errors"],
                                    dt_den: ["p_cg2axes", "p_cg2fitden"],
                                    at_sze: ["at_sze"],
                                    ar_hs: ["ar_hs"],
                                    g_tree: ["g_tree"],
                                    v_first: ["v_first"],
                                    dps_toinside: ["dps_toinside"],
                                    wp_softwaredesign: ["wp_softwaredesign"],
                                    p_g1: ["p_g1"],
                                    ar_cross: ["ar_cross"],
                                    dtt_zzz: ["dummy"],
                                    tb_app: ["tb_app"],
                                    b_btype: ["b_type"],
                                    g_facet: ["g_facet"],
                                    ch_la: ["ch_la"],
                                    g_lollipop: ["g_lollipop"],
                                    g_layout: ["g_layout"],
                                    gd_g2marker: ["p_cg2axes", "p_cg2data", "p_dgmarker"],
                                    b_grhl: ["b_grhl"],
                                    ar_tlm: ["ar_tlm"],
                                    m_zlasso: ["m_zlasso"],
                                    ch_lm: ["ch_lm"],
                                    cd_upload: ["cd_upload"],
                                    dt_histstag: ["p_cg2axes", "p_cg2datahist", "p_cg2datahiststag"],
                                    b_gstype: ["b_gstype", "ar_dctrs2", "ar_dcbls2"],
                                    c_rr: ["c_rr"],
                                    c_jsfiddle: ["c_jsfiddle"],
                                    wp_examples: ["wp_examples"],
                                    c_zzz: ["dummy"],
                                    bx_data: ["bx_data"],
                                    p_g1axistitle2: ["p_g1", "p_g1axistitle2"],
                                    dt_denremove: ["p_cg2axes", "p_cg2fitden", "v_cancelsmall"],
                                    ch_ozzz: ["dummy"],
                                    b_grvb: ["b_grvb"],
                                    sl_zzz: ["dummy"],
                                    dp_binned: ["dp_binned"],
                                    wp_threebars: ["wp_threebars"],
                                    p_g3axes: ["p_g3", "p_g3axes"],
                                    ar_vs: ["ar_vs"],
                                    ps_toloc: ["ps_toloc"],
                                    ch_li: ["ch_li"],
                                    ch_cdelete: ["ch_cdelete"],
                                    p_g2axisx: ["p_g2", "p_g2axisx"],
                                    ch_szzz: ["dummy"],
                                    g_parallelcoordinates: ["g_parallelcoordinates"],
                                    gc_gzzz: ["dummy"],
                                    ch_of: ["ch_of"],
                                    wp_events: ["wp_events"],
                                    bx_mean: ["bx_mean"],
                                    p_g1axestitles: ["p_g1", "p_g1axestitles"],
                                    bx_violint: ["bx_violint"],
                                    dp_jittered: ["dp_jittered"],
                                    z_out: ["z_out"],
                                    ch_oitalic: ["ch_oitalic"],
                                    gc_ggh: ["p_cghdata1", "p_cghdata2", "p_cghaxes"],
                                    a_alignright: ["a_alignright"],
                                    g_tagcloud: ["g_tagcloud"],
                                    ch_lv: ["ch_lv"],
                                    wp_interactiveplots: ["wp_interactiveplots"],
                                    ar_tr: ["ar_tr"],
                                    tb_table: ["tb_table"],
                                    sp_thickness2: ["sp_thickness2"],
                                    sl_checkboxoff: ["sl_checkboxoff"],
                                    p_g3title: ["p_g3", "p_g3title"],
                                    ch_omean: ["ch_omean"],
                                    cd_select: ["cd_select"],
                                    ch_oe: ["ch_oe"],
                                    wp_user: ["wp_user"],
                                    sl_eremove: ["e_open", "v_cancelsmall"],
                                    p_ghtitlesubtitle: ["p_gh", "p_ghtitlesubtitle"],
                                    ar_rs: ["ar_rs"],
                                    b_grhr: ["b_grhr"],
                                    dt_denfit: ["p_cg2axes", "p_cg2fitden", "p_cg2dataden"],
                                    g_chord: ["g_chord"],
                                    ar_brs: ["ar_brs"],
                                    ar_dctrs: ["ar_dctrs"],
                                    bx_connect: ["bx_connect"],
                                    v_next: ["v_next"],
                                    sr_zad: ["sr_zad"],
                                    ch_sampersand: ["ch_sampersand"],
                                    ch_creturn: ["ch_creturn"],
                                    p_g3axistitlez: ["p_g3", "p_g3axistitlez"],
                                    sp_heightness: ["sp_heightness"],
                                    ly_zzz: ["dummy"],
                                    wp_instances: ["wp_instances"],
                                    p_g2axestitles: ["p_g2", "p_g2axestitles"],
                                    g_gantt: ["g_gantt"],
                                    cl_verticalk: ["cl_verticalbg", "cl_vertical"],
                                    wp_installation: ["wp_installation"],
                                    op_zzz: ["dummy"],
                                    sv_pictures: ["sv_pictures"],
                                    ch_lr: ["ch_lr"],
                                    rt_zzz: ["dummy"],
                                    fp_funnelremove: ["fp_funnel", "v_cancelsmall"],
                                    tx_tonumeric: ["tx_tonumeric"],
                                    bx_zzz: ["dummy"],
                                    sr_azi: ["sr_azi"],
                                    m_right: ["m_body", "m_right"],
                                    ps_topright: ["ps_topright"],
                                    a_alignbottom: ["a_alignbottom"],
                                    ps_top: ["ps_top"],
                                    ch_lb: ["ch_lb"],
                                    bx_wishkersn: ["bx_wishkersn"],
                                    p_ghsamplelabels: ["p_gh", "p_ghsamplelabels"],
                                    a_moveforward: ["a_moveforward"],
                                    dtt_pivotremove: ["dtt_pivot", "v_cancelsmall"],
                                    at_col2: ["at_col2"],
                                    dps_inout: ["dps_inout"],
                                    gr_style: ["gr_style"],
                                    i_zzz: ["dummy"],
                                    ch_oinfo: ["ch_oinfo"],
                                    tx_format: ["tx_format"],
                                    g_map: ["g_map"],
                                    g_kaplanmeier: ["g_kaplanmeier"],
                                    ch_lu: ["ch_lu"],
                                    ch_lw: ["ch_lw"],
                                    ch_lt: ["ch_lt"],
                                    p_g3axistitlex: ["p_g3", "p_g3axistitlex"],
                                    dtp_max: ["dt_max"],
                                    v_cancel: ["v_cancel"],
                                    dps_collapse: ["dps_collapse"],
                                    c_paultol: ["c_paultol"],
                                    mr_all: ["mr_all"],
                                    wp_code: ["wp_code"],
                                    sl_eclose: ["e_close"],
                                    ps_bottom: ["ps_bottom"],
                                    dp_binr: ["dp_binr"],
                                    cd_lines: ["cd_doc", "cd_lines"],
                                    ch_oparens: ["ch_oparens"],
                                    v_cancelsmall: ["v_cancelsmall"],
                                    ar_tm: ["ar_tm"],
                                    rt_ac: ["rt_ac"],
                                    fp_pencil: ["fp_pencil"],
                                    p_ghtitle: ["p_gh", "p_ghtitle"],
                                    o_ghvars: ["o_ghvars"],
                                    mr_left: ["mr_all", "mr_left"],
                                    at_zzz: ["dummy"],
                                    gr_g2y: ["gr_g2y"],
                                    ar_h: ["ar_h"],
                                    op_undo: ["op_undo"],
                                    g_histogram: ["g_histogram"],
                                    bx_type: ["bx_type"],
                                    ps_toloc2: ["ps_toloc2"],
                                    dps_zzz: ["dummy"],
                                    b_bbodywindow: ["b_body2", "b_window", "b_pail"],
                                    gc_ghvariable: ["p_cghdata1", "p_cghdata2", "p_cghaxes", "h_hvariable"],
                                    ar_l: ["ar_l"],
                                    dt_corremove: ["p_cg2axes", "p_cg2fitcor", "p_cg2datacor", "v_cancelsmall"],
                                    g_zzz: ["dummy"],
                                    c_wallstreetjournal: ["c_wallstreetjournal"],
                                    c_ggplot: ["c_ggplot"],
                                    a_movebackward: ["a_movebackward"],
                                    a_movefront: ["a_movefront"],
                                    a_group: ["a_group"],
                                    dt_denfitfilled: ["p_cg2axes", "p_cg2fitden2", "p_cg2dataden"],
                                    ch_ofx: ["ch_ofx"],
                                    ch_oe10: ["ch_oe10"],
                                    at_shd: ["at_shd"],
                                    p_g3titlesubtitle: ["p_g3", "p_g3titlesubtitle"],
                                    sr_19: ["sr_19"],
                                    ar_br: ["ar_br"],
                                    gr_styledashed: ["gr_styledashed"],
                                    b_bgradient: ["b_bodygradient", "b_pail"],
                                    at_shp: ["at_shp"],
                                    g_dotline: ["g_dotline"],
                                    sv_diskremove: ["sv_disk", "v_cancelsmall"],
                                    p_g2zzz: ["dummy"],
                                    ps_right: ["ps_right"],
                                    a_zzz: ["dummy"],
                                    ch_lc: ["ch_lc"],
                                    a_alignleft: ["a_alignleft"],
                                    g_genome: ["g_genome"],
                                    at_trn: ["at_trn"],
                                    dt_cor: ["p_cg2axes", "p_cg2fitcor", "p_cg2datacor"],
                                    p_g1axis1: ["p_g1", "p_g1axis1"],
                                    ar_v: ["ar_v"],
                                    ch_coption: ["ch_coption"],
                                    at_col: ["at_col"],
                                    wp_configuration: ["wp_configuration"],
                                    n_edges: ["n_edges"],
                                    b_bwindowsolid: ["b_body", "b_windowbg", "b_pail"],
                                    cl_horizontalk: ["cl_horizontalbg", "cl_horizontal"],
                                    g_oncoprint: ["g_oncoprint"],
                                    p_g3axistitley: ["p_g3", "p_g3axistitley"],
                                    sr_zzz: ["dummy"],
                                    p_g2: ["p_g2"],
                                    ch_oy: ["ch_oy"],
                                    dt_qqremove: ["p_cg2axes", "p_cg2fitqq", "v_cancelsmall"],
                                    ar_trs: ["ar_trs"],
                                    ga_axisx: ["ga_axisx"],
                                    bx_violin: ["bx_violin"],
                                    v_minus: ["v_minus"],
                                    wp_marker: ["wp_marker"],
                                    c_solarized: ["c_solarized"],
                                    ps_zzz: ["dummy"],
                                    ch_splus: ["ch_splus"],
                                    gc_ghcell: ["p_cghdata1", "p_cghdata2", "p_cghaxes", "h_hcell"],
                                    p_g2citation: ["p_g2", "p_g2citation"],
                                    ch_oquantile: ["ch_oquantile"],
                                    cd_folder: ["cd_folder"],
                                    dt_zzz: ["dummy"],
                                    p_ghvariabletitle: ["p_gh", "p_ghvariabletitle"],
                                    v_play: ["v_play"],
                                    ly_splom: ["ly_splom"],
                                    ar_blm: ["ar_blm"],
                                    lg_h: ["lg_h", "lg_l"],
                                    gr_major: ["gr_major"],
                                    ar_r: ["ar_r"],
                                    dt_km: ["p_cg2axes", "p_cg2fitkm"],
                                    g_scatterbubble2d: ["g_scatterbubble2d"],
                                    gr_styledotted: ["gr_styledotted"],
                                    dtp_exact: ["dt_exact"],
                                    bx_violinu: ["bx_violinu"],
                                    ch_cshift: ["ch_cshift"],
                                    op_more: ["op_more"],
                                    c_angular: ["c_angular"],
                                    tx_shadow: ["tx_shadow"],
                                    ch_cctrl2: ["ch_cctrl2"],
                                    sp_zzz: ["dummy"],
                                    ps_toloc3: ["ps_toloc3"],
                                    sl_check: ["sl_check"],
                                    o_ghvarsp: ["o_ghvars", "ch_ocodemed"],
                                    ch_cesc2: ["ch_cesc2"],
                                    cl_vertical: ["cl_vertical"],
                                    wp_zzz: ["dummy"],
                                    m_zzz: ["dummy"],
                                    sl_lightbulboff: ["sl_lightbulboff"],
                                    dps_tooutside: ["dps_tooutside"],
                                    ar_perpm: ["ar_lm", "ar_tm", "ar_rm", "ar_bm"],
                                    at_colshpsze: ["at_colshpsze"],
                                    p_g3subtitle: ["p_g3", "p_g3subtitle"],
                                    lg_legend: ["lg_legend"],
                                    b_gsswitch: ["b_gsswitch", "ar_dctrs2", "ar_dcbls2"],
                                    ch_cshift2: ["ch_cshift2"],
                                    m_body: ["m_body"],
                                    at_palette: ["at_palette"],
                                    ar_perp: ["ar_l", "ar_t", "ar_r", "ar_b"],
                                    gc_gg2: ["p_cg2axes", "p_cg2data"],
                                    g_stackedpercentline: ["g_stackedpercentline"],
                                    g_sunburst: ["g_sunburst"],
                                    o_gzzz: ["dummy"],
                                    g_stackedpercent: ["g_stackedpercent"],
                                    ch_ocodesmall: ["ch_ocodesmall"],
                                    wp_initialization: ["wp_initialization"],
                                    ch_olog: ["ch_olog"],
                                    m_double: ["m_body", "m_left", "m_double"],
                                    ps_center: ["ps_center"],
                                    g_arealine: ["g_arealine"],
                                    ar_tls: ["ar_tls"],
                                    g_scatter2d: ["g_scatter2d"],
                                    v_zzz: ["dummy"],
                                    c_tableau: ["c_tableau"],
                                    mr_right: ["mr_all", "mr_right"],
                                    v_backward: ["v_backward"],
                                    at_pat: ["at_pat"],
                                    bx_violinbp: ["bx_violinbp"],
                                    cl_zzz: ["dummy"],
                                    fp_pinremove: ["fp_pin", "v_cancelsmall"],
                                    wp_documentation: ["wp_documentation"],
                                    p_g3: ["p_g3"],
                                    dp_binl: ["dp_binl"],
                                    p_g2axistitley: ["p_g2", "p_g2axistitley"],
                                    g_fish: ["g_fish"],
                                    bx_violinc: ["bx_violin", "v_cancelsmall"],
                                    ch_lf: ["ch_lf"],
                                    ar_bl: ["ar_bl"],
                                    tm_time: ["tm_time"],
                                    at_ellipse: ["at_ellipse"],
                                    ly_segregate: ["ly_segregate"],
                                    ar_zzz: ["dummy"],
                                    dt_corconf: ["p_cg2fitcorconf", "p_cg2axes", "p_cg2fitcor", "p_cg2datacor"],
                                    ch_le: ["ch_le"],
                                    ch_lq: ["ch_lq"],
                                    g_waterfall: ["g_waterfall"],
                                    ch_oe2: ["ch_oe2"],
                                    p_g1axistitle1: ["p_g1", "p_g1axistitle1"],
                                    m_wheel: ["m_body", "m_wheel"],
                                    b_grc: ["b_grc"],
                                    v_stop: ["v_stop"],
                                    c_rrcode: ["c_rrcode"],
                                    wp_arguments: ["wp_arguments"],
                                    tm_history: ["tm_history"],
                                    ly_layout: ["ly_layout"],
                                    mr_zzz: ["dummy"],
                                    ch_ologsmall: ["ch_ologsmall"],
                                    dtp_range: ["dt_range"],
                                    gr_minor: ["gr_minor"],
                                    ch_lg: ["ch_lg"],
                                    p_g3citation: ["p_g3", "p_g3citation"],
                                    c_rc: ["c_rc"],
                                    gr_g2x: ["gr_g2x"],
                                    ch_spercent: ["ch_spercent"],
                                    dps_square: ["dps_square"],
                                    p_g2subtitle: ["p_g2", "p_g2subtitle"],
                                    sl_checkboxon: ["sl_checkboxon"],
                                    sp_spacing: ["sp_spacing"],
                                    b_gzzz: ["dummy"],
                                    ch_ocode: ["ch_ocode"],
                                    ch_lp: ["ch_lp"],
                                    wp_oveview: ["wp_oveview"],
                                    bx_wishkersd: ["bx_wishkersd"],
                                    ch_sminus: ["ch_sminus"],
                                    ch_lzzz: ["dummy"],
                                    ar_brm: ["ar_brm"],
                                    ps_topleft: ["ps_topleft"],
                                    g_area: ["g_area"],
                                    p_g1title: ["p_g1", "p_g1title"],
                                    cr_normal: ["cr_normal"],
                                    g_treemap: ["g_treemap"],
                                    g_dotplot: ["g_dotplot"],
                                    p_g1axis2: ["p_g1", "p_g1axis2"],
                                    g_ridgeline: ["g_ridgeline"],
                                    g_line: ["g_line"],
                                    g_scatter3d: ["g_scatter3d"],
                                    ar_diags: ["ar_tls", "ar_trs", "ar_brs", "ar_bls"],
                                    ch_oaa: ["ch_oaa"],
                                    ch_oa: ["ch_oa"],
                                    sv_disk: ["sv_disk"],
                                    o_g1p: ["o_g1", "ch_ocodemed"],
                                    sl_radioon: ["sl_radioon"],
                                    ga_zzz: ["dummy"],
                                    p_g3axestitles: ["p_g3", "p_g3axestitles"],
                                    p_g2axistitlex: ["p_g2", "p_g2axistitlex"],
                                    tx_zzz: ["dummy"],
                                    g_contour: ["g_contour"],
                                    o_g1: ["o_g1"],
                                    ln_stylesolid: ["ln_stylesolid"],
                                    mr_bottom: ["mr_all", "mr_bottom"],
                                    dps_resize: ["dps_resize"],
                                    wp_userinterface: ["wp_userinterface"],
                                    tx_tostring: ["tx_tostring"],
                                    lg_zzz: ["dummy"],
                                    ch_ofloor: ["ch_ofloor"],
                                    g_violin: ["g_violin"],
                                    mr_top: ["mr_all", "mr_top"],
                                    ch_ll: ["ch_ll"],
                                    ar_ts: ["ar_ts"],
                                    g_heatmap: ["g_heatmap"],
                                    bx_notched: ["bx_notched"],
                                    bx_wishkerss: ["bx_wishkerss"],
                                    sr_az: ["sr_az"],
                                    gr_zzz: ["dummy"],
                                    g_boxplot: ["g_boxplot"],
                                    ga_axisxyz: ["ga_axisxyz"],
                                    dp_bin: ["dp_bin"],
                                    sl_lightbulbon: ["sl_lightbulbon"],
                                    cd_linesindent: ["cd_doc", "cd_linesindent"],
                                    fp_funnel: ["fp_funnel"],
                                    ch_oceil: ["ch_oceil"],
                                    dt_kmconf: ["p_cg2fitkmconf", "p_cg2axes", "p_cg2fitkm"],
                                    ch_lz: ["ch_lz"],
                                    tm_zzz: ["dummy"],
                                    ar_b: ["ar_b"],
                                    a_distributever: ["a_distributever"],
                                    dtp_zzz: ["dummy"],
                                    sl_eopen: ["e_open"],
                                    ps_left: ["ps_left"],
                                    v_previous: ["v_previous"],
                                    ch_lx: ["ch_lx"],
                                    fp_pin: ["fp_pin"],
                                    g_stackedline: ["g_stackedline"],
                                    b_bwindow: ["b_body", "b_window", "b_pail"],
                                    p_g2titlesubtitle: ["p_g2", "p_g2titlesubtitle"],
                                    ch_sat: ["ch_sat"],
                                    ch_olog10: ["ch_olog10"],
                                    g_tcga: ["g_map"],
                                    p_g1samplelabels: ["p_g1", "p_g1samplelabels"],
                                    cr_cumulative: ["cr_cumulative"],
                                    dp_zzz: ["dummy"],
                                    p_g1axes: ["p_g1", "p_g1axes"],
                                    dtt_pivot: ["dtt_pivot"],
                                    ga_axisxy: ["ga_axisxy"],
                                    g_bar: ["g_bar"],
                                    g_correlation: ["g_correlation"],
                                    sl_radiooff: ["sl_radiooff"],
                                    gc_gg3: ["p_cg3axes", "p_cg3data"],
                                    z_in: ["z_in"],
                                    sp_farther: ["sp_farther"],
                                    g_stacked: ["g_stacked"],
                                    dt_kmremove: ["p_cg2axes", "p_cg2fitkm", "v_cancelsmall"],
                                    o_ghsmps: ["o_ghsmps"],
                                    ar_rm: ["ar_rm"],
                                    ch_ln: ["ch_ln"],
                                    sv_zzz: ["dummy"],
                                    p_g3axisx: ["p_g3", "p_g3axisx"],
                                    c_economist: ["c_economist"],
                                    at_sch: ["at_sch"],
                                    wp_list: ["wp_list"],
                                    dps_height: ["dps_height"],
                                    ch_ssum: ["ch_ssum"],
                                    p_g1titlesubtitle: ["p_g1", "p_g1titlesubtitle"],
                                    dt_hist: ["p_cg2axes", "p_cg2datahist"],
                                    g_circular: ["g_circular"],
                                    ch_ocodemed: ["ch_ocodemed"],
                                    cd_doc: ["cd_doc"],
                                    ar_trm: ["ar_trm"],
                                    p_g2axes: ["p_g2", "p_g2axes"],
                                    g_sankey: ["g_sankey"],
                                    ly_doe: ["ly_doe"],
                                    fp_zzz: ["dummy"],
                                    g_dashboard: ["g_dashboard"],
                                    dps_width: ["dps_width"],
                                    cr_zzz: ["dummy"],
                                    b_bbodygradient: ["b_bodygradient", "b_windowbg2", "b_pail"],
                                    ln_styledotted: ["ln_styledotted"],
                                    cl_horizontal: ["cl_horizontal"],
                                    p_g2title: ["p_g2", "p_g2title"],
                                    wp_license: ["wp_license"],
                                    v_last: ["v_last"],
                                    c_python: ["c_python"],
                                    sv_video: ["sv_video"],
                                    cd_params: ["cd_doc", "cd_params"],
                                    ar_bls: ["ar_bls"],
                                    c_canvasxpress: ["c_canvasxpress"],
                                    g_bubble: ["g_bubble"],
                                    ar_perps: ["ar_ls", "ar_ts", "ar_rs", "ar_bs"],
                                    g_radar: ["g_radar"],
                                    c_r: ["c_r"],
                                    v_plus: ["v_plus"],
                                    b_gsori: ["b_gsori", "ar_dctrs2", "ar_dcbls2"],
                                    tb_stripped: ["tb_stripped"],
                                    sv_image: ["sv_image"],
                                    dummy: ["dummy"],
                                    b_grvt: ["b_grvt"],
                                    dt_denfithist: ["p_cg2axes", "p_cg2fitden", "p_cg2datadenhist"],
                                    ch_ly: ["ch_ly"],
                                    c_rrc: ["c_rrc"],
                                    bx_wishkers: ["bx_wishkers"],
                                    c_codepen: ["c_codepen"],
                                    ch_lk: ["ch_lk"],
                                    gd_gzzz: ["dummy"],
                                    c_nodejs: ["c_nodejs"],
                                    tb_zzz: ["dummy"],
                                    ln_styledashed: ["ln_styledashed"],
                                    bx_meanc: ["bx_meanc"],
                                    ch_ccommand: ["ch_ccommand"],
                                    tx_stringnumeric: ["tx_stringnumeric"],
                                    dt_cdf: ["p_cg2axes", "p_cg2fitcdf"],
                                    ar_minmax: ["ar_minmax"],
                                    sp_thinner: ["sp_thinner"],
                                    b_bbody: ["b_body", "b_pail"],
                                    ch_capple: ["ch_capple"],
                                    ps_bottomright: ["ps_bottomright"],
                                    cr_bezier: ["cr_bezier"],
                                    op_config: ["op_config"],
                                    dt_qq: ["p_cg2axes", "p_cg2fitqq"],
                                    ch_lj: ["ch_lj"],
                                    wp_audittrail: ["wp_audittrail"],
                                    ar_tl: ["ar_tl"],
                                    ch_ls: ["ch_ls"],
                                    ch_olin: ["ch_olin"],
                                    ar_t: ["ar_t"],
                                    gr_g1: ["gr_g1"],
                                    p_ghzzz: ["dummy"],
                                    sp_thickness: ["sp_thickness"],
                                    op_refresh: ["op_refresh"],
                                    dt_cdfremove: ["p_cg2axes", "p_cg2fitcdf", "v_cancelsmall"],
                                    sw_up: ["sw_up"],
                                    cd_json: ["cd_json"],
                                    bx_medianc: ["bx_medianc"],
                                    g_venn: ["g_venn"],
                                    lg_g2: ["lg_g2", "lg_l"],
                                    i_h: ["i_left", "i_right", "i_labels"],
                                    p_g3axisy: ["p_g3", "p_g3axisy"],
                                    gc_ghsample: ["p_cghdata1", "p_cghdata2", "p_cghaxes", "h_hsample"],
                                    ar_lm: ["ar_lm"],
                                    a_aligntop: ["a_aligntop"],
                                    c_opensource: ["c_opensource"],
                                    rt_ac2: ["rt_ac2"],
                                    sr_aai: ["sr_aai"],
                                    p_g1subtitle: ["p_g1", "p_g1subtitle"],
                                    gc_gg1: ["p_cg1axesvertical", "p_cg1datavertical"],
                                    wp_broadcast: ["wp_broadcast"],
                                    o_ghsmpsp: ["o_ghsmps", "ch_ocodemed"],
                                    m_left: ["m_body", "m_left"],
                                    ch_lh: ["ch_lh"],
                                    c_rcode: ["c_rcode"],
                                    cd_zzz: ["dummy"],
                                    p_gh: ["p_gh"],
                                    ch_lo: ["ch_lo"],
                                    c_php: ["c_php"],
                                    ch_snumber: ["ch_snumber"],
                                    p_ghcitation: ["p_gh", "p_ghcitation"],
                                    g_remotegraphs: ["g_remotegraphs"],
                                    v_pause: ["v_pause"],
                                    a_distributehor: ["a_distributehor"],
                                    ln_style: ["ln_style"],
                                    ly_doeremove: ["ly_doe", "v_cancelsmall"],
                                    ch_olinsmall: ["ch_olinsmall"],
                                    ps_bottomleft: ["ps_bottomleft"],
                                    sv_svg: ["sv_svg"],
                                    g_network: ["g_network"],
                                    p_g1sampletitle: ["p_g1", "p_g1sampletitle"],
                                    op_cancel: ["op_cancel"],
                                    sw_updown: ["sw_up", "sw_down"],
                                    ch_cesc: ["ch_cesc"],
                                    ar_diag: ["ar_tl", "ar_tr", "ar_br", "ar_bl"],
                                    bx_meanb: ["bx_meanb"],
                                    g_splom: ["g_splom"],
                                    ch_ld: ["ch_ld"],
                                    g_nonlinearfit: ["g_nonlinearfit"],
                                    p_ghvariablelabels: ["p_gh", "p_ghvariablelabels"],
                                    i_hist: ["i_hist"],
                                    ar_bs: ["ar_bs"],
                                    n_zzz: ["dummy"],
                                    wp_constructor: ["wp_constructor"],
                                    v_forward: ["v_forward"],
                                    wp_fileformat: ["wp_fileformat"],
                                    at_motion: ["at_motion"],
                                    lg_g1: ["lg_g1", "lg_l"],
                                    sp_closer: ["sp_closer"],
                                    c_stata: ["c_stata"],
                                    g_meter: ["g_meter"],
                                    n_nodes: ["n_nodes"],
                                    dtp_min: ["dt_min"]
                                },
                                symbols: {
                                    ch_lf: '<text class="cxtb100" x="15" y="85">F</text>',
                                    ar_bl: '<path class="cxtxb" d="M2,78 L2,98 L22,98 M2,98 L98,2" />',
                                    g_fish: '<g class="cxa"><path d="M 78 50 C 78 50 61.1 74.1 40.4 74.1 C 19.6 74.1 2.7 50 2.7 50 C 2.7 50 19.6 25.9 40.4 25.9 C 61.1 25.9 78 50 78 50 Z"/><line x1="97.4" y1="28.2" x2="77.9" y2="50"/><line x1="97.4" y1="71.9" x2="77.9" y2="50"/></g><g class="cxb"><line x1="23.5" y1="43.2" x2="23.5" y2="47.1"/></g>',
                                    b_windowbg2: '<polyline class="cxaw" points="65,45 65,30 48,30 48,15 15,15 15,83 68,83 45,65 65,45" />',
                                    p_g2axistitley: '<g class="cxblue"><rect x="0" y="25" width="3" height="25"/></g>',
                                    dp_binl: '<g class="cxb"><circle cx="50" cy="3" r="2.5" /><circle cx="50" cy="18" r="2.5" /><circle cx="50" cy="33" r="2.5" /><circle cx="43" cy="33" r="2.5" /><circle cx="50" cy="50" r="2.5" /><circle cx="43" cy="50" r="2.5" /><circle cx="36" cy="50" r="2.5" /><circle cx="50" cy="65" r="2.5" /><circle cx="43" cy="65" r="2.5" /><circle cx="50" cy="80" r="2.5" /><circle cx="50" cy="97" r="2.5" /></g>',
                                    p_g3: '<g class="cxc"><rect x="45" y="0" width="30" height="2"/><rect x="50" y="10" width="20" height="2"/><rect x="35" y="30" width="4" height="4"/><rect x="85" y="40" width="4" height="4"/><rect x="40" y="85" width="30" height="2"/><rect x="0" y="25" width="3" height="25"/><line x1="55" y1="55" x2="65" y2="47"/><line x1="25" y1="65" x2="95" y2="65" /><line x1="25" y1="65" x2="25" y2="75" /><line x1="45" y1="65" x2="45" y2="75" /><line x1="65" y1="65" x2="65" y2="75" /><line x1="85" y1="65" x2="85" y2="75" /><line x1="25" y1="15" x2="25" y2="75" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /><line x1="25" y1="65" x2="75" y2="25" /><line x1="45" y1="50" x2="45" y2="60" /><line x1="65" y1="33" x2="65" y2="43" /><rect x="75" y="95" width="20" height="2"/></g>',
                                    wp_documentation: '<g class="cxa"><path d="M 50 21.9 C 34.8 14.9 17.4 14.9 2.3 21.9 L 2.3 83.3 C 17.6 77.2 34.7 77.2 50 83.3 C 65.3 77.2 82.4 77.2 97.8 83.3 L 97.8 21.9 C 82.6 14.9 65.2 14.9 50 21.9 Z" /></g><g class="cxb"><line x1="50" y1="21.9" x2="50" y2="83.1" /></g>',
                                    ch_oe2: '<text class="cxts150" x="10" y="70">e</text><text class="cxtn40" x="55" y="85">2</text>',
                                    g_waterfall: '<g class="cxb"><rect x="44.7" y="22.6" width="12.7" height="19.6"/><rect x="19.4" y="5.9" width="12.7" height="36.4"/><rect x="32.1" y="13.3" width="12.7" height="28.9"/><rect x="57.4" y="42.2" width="12.7" height="19.6"/><rect x="82.8" y="42.2" width="12.7" height="36.4"/><rect x="70.1" y="42.2" width="12.7" height="28.9"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g>',
                                    ch_lq: '<text class="cxtb100" x="8" y="85">Q</text>',
                                    ch_le: '<text class="cxtb100" x="15" y="85">E</text>',
                                    b_body2: '<g class="cxb"><polyline points="78,42 78,30 48,30 48,2 2,2 2,98 78,98 78,85"/><line x1="79" y1="29" x2="48" y2="1" /></g>',
                                    ly_segregate: '<g class="cxa"><rect x="2" y="2" width="43" height="43" /><rect x="53" y="2" width="43" height="43" /><rect x="2" y="53" width="43" height="43" /><rect x="53" y="53" width="43" height="43" /></g><g class="cxbb"><rect x="9" y="20" width="10" height="21" /><rect x="28" y="10" width="10" height="31" /><rect x="60" y="15" width="10" height="26" /><rect x="79" y="31" width="10" height="10" /><rect x="9" y="81" width="10" height="11" /><rect x="28" y="63" width="10" height="29" /><rect x="60" y="73" width="10" height="19" /><rect x="79" y="79" width="10" height="13" /></g>',
                                    tm_time: '<g class="cxa"><circle cx="50" cy="50" r="48" /></g><g class="cxb"><line x1="50" y1="10" x2="50" y2="50" /><line x1="40" y1="83" x2="50" y2="50" /><circle cx="50" cy="50" r="4" /></g>',
                                    at_ellipse: '<g class="cxa"><path d="M31,2 Q 48,3 56,19 59,35 56,53 48,69 31,71 13,69 6,53 2,36 6,19 13,3 31,2" /><path d="M41,37 Q 56,27 74,36 90,44 97,68 98,86 88,94 74,98 60,94 44,86 36,70 31,52 41,37" /></g><g class="cxb"><circle cx="20" cy="18" r="2" /><circle cx="12" cy="27" r="2" /><circle cx="15" cy="40" r="2" /><circle cx="45" cy="52" r="2" /><circle cx="25" cy="52" r="2" /><circle cx="45" cy="23" r="2" /><circle cx="36" cy="15" r="2" /><circle cx="31" cy="26" r="2" /><circle cx="30" cy="42" r="2" /></g><g class="cxb"><circle cx="60" cy="63" r="2" /><circle cx="52" cy="70" r="2" /><circle cx="75" cy="85" r="2" /><circle cx="85" cy="82" r="2" /><circle cx="65" cy="82" r="2" /><circle cx="80" cy="73" r="2" /><circle cx="70" cy="43" r="2" /><circle cx="75" cy="56" r="2" /><circle cx="85" cy="62" r="2" /></g>',
                                    ch_ocodesmall: '<text class="cxtn50" x="30" y="-40" transform="rotate(90)">&#8963;</text><text class="cxtn50" x="-70" y="60" transform="rotate(-90)">&#8963;</text>',
                                    g_stackedpercent: '<g class="cxcc"><rect x="76.7" y="45.4" width="14.9" height="22.1"/><rect x="49.7" y="21.1" width="14.9" height="39.7"/><rect x="23.2" y="31.3" width="14.9" height="37.3"/></g><g class="cxbb"><rect x="22.4" y="68.6" width="14.9" height="17.4"/><rect x="49.7" y="60.8" width="14.9" height="25.2"/><rect x="76.7" y="67.5" width="14.9" height="18.5"/></g><g class="cxb"><rect x="22.4" y="2" width="15.6" height="84"/><rect x="49.4" y="2" width="15.6" height="84"/><rect x="76.4" y="2" width="15.6" height="84"/><line x1="50" y1="21.1" x2="64.9" y2="21.1"/><line x1="50" y1="60.8" x2="64.9" y2="60.8"/><line x1="76.7" y1="45.4" x2="91.6" y2="45.4"/><line x1="76.7" y1="67.5" x2="91.6" y2="67.5"/><line x1="22.4" y1="31.3" x2="37.9" y2="31.3"/><line x1="22.4" y1="68.6" x2="37.9" y2="68.6"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g>',
                                    g_sunburst: '<g class="cxa"><circle cx="50.1" cy="50.1" r="35.7"/><path d="M 27.5 50.1 L 2.4 50.1 C 2.4 23.8 23.8 2.4 50.1 2.4 L 50.1 41.1"/><path d="M 72.7 50.1 L 97.7 50.1 C 97.7 76.4 76.4 97.7 50.1 97.7 L 50.1 72.7"/><circle cx="50.1" cy="50.1" r="22.6"/><circle cx="50.1" cy="50.1" r="9"/></g><g class="cxac"><path d="M 50.1 14.3 L 50.1 2.4 C 23.8 2.4 2.4 23.8 2.4 50.1 L 14.3 50.1 C 14.3 30.3 30.3 14.3 50.1 14.3 Z"/><path d="M 50.1 85.8 L 50.1 97.7 C 76.4 97.7 97.7 76.4 97.7 50.1 L 85.8 50.1 C 85.8 69.8 69.8 85.8 50.1 85.8 Z"/></g><g class="cxb"><line x1="43.2" y1="55.9" x2="22.7" y2="73.1"/><line x1="27.4" y1="21.5" x2="36.7" y2="30.9"/><line x1="68.2" y1="63.4" x2="89.1" y2="77.2"/><line x1="68.2" y1="80.8" x2="74.1" y2="91.2"/><line x1="7.5" y1="28.7" x2="29.9" y2="39.7"/><line x1="29.9" y1="8.8" x2="34.2" y2="17.9"/></g>',
                                    g_stackedpercentline: '<g class="cxcc"><rect x="76.7" y="34.8" width="14.9" height="32.7"/><rect x="49.7" y="59.1" width="14.9" height="18.2"/><rect x="23.2" y="31.3" width="14.9" height="37.3"/></g><g class="cxbb"><rect x="22.4" y="68.6" width="14.9" height="17.4"/><rect x="49.7" y="76.7" width="14.9" height="9.3"/><rect x="76.7" y="67.5" width="14.9" height="18.5"/></g><g class="cxb"><rect x="22.4" y="2" width="15.6" height="84"/><rect x="49.4" y="2" width="15.6" height="84"/><rect x="76.4" y="2" width="15.6" height="84"/><line x1="50" y1="59.1" x2="64.9" y2="59.1"/><line x1="50" y1="76.7" x2="64.9" y2="76.7"/><line x1="76.7" y1="34.8" x2="91.6" y2="34.8"/><line x1="76.7" y1="67.5" x2="91.6" y2="67.5"/><line x1="22.4" y1="31.3" x2="37.9" y2="31.3"/><line x1="22.4" y1="68.6" x2="37.9" y2="68.6"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/><polyline points="23.1 15.6 57.7 51.1 89.9 15.6"/></g>',
                                    at_palette: '<path class="cxb" d="M2,50 C 2,25 25,2 50,2 C 73,2 98,25 98,50 C 98,57 97,63 90,63 C 90,53 81,53 78,60 C 92,79 73,98 50,98 C 25,98 2,75 2,50" /><g class="cxa"><circle cx="20" cy="45" r="8" /><circle cx="35" cy="25" r="8" /><circle cx="63" cy="23" r="8" /><circle cx="80" cy="40" r="8" /><path d="M50,75 C 65,75 65,88 50,88 C 35,88 35,75 50,75" /></g>',
                                    at_pat: '<g class="cxb"><rect x="2" y="2" width="25" height="96" /><rect x="33" y="2" width="25" height="96" /><rect x="66" y="2" width="25" height="96" /></g><g class="cxa"><line x1="35" y1="10" x2="57" y2="30" /><line x1="35" y1="30" x2="57" y2="50" /><line x1="35" y1="50" x2="57" y2="70" /><line x1="35" y1="70" x2="57" y2="90" /><line x1="68" y1="22" x2="90" y2="22" /><line x1="68" y1="42" x2="90" y2="42" /><line x1="68" y1="62" x2="90" y2="62" /><line x1="68" y1="82" x2="90" y2="82" /></g>',
                                    bx_violinbp: '<g class="cxb"><path  d="M64,1 Q 66,11 68,25 72,38 86,47 96,56 89,70 82,82 80,99 L 20,99 Q 18,82 11,70 4,56 14,47 28,38 32,25 34,11 36,1 Z" /></g><g class="cxa"><rect x="40" y="35" width="20" height="30" /><line x1="40" y1="50" x2="60" y2="50" /><line x1="40" y1="2" x2="60" y2="2" /><line x1="50" y1="2" x2="50" y2="35" /><line x1="40" y1="98" x2="60" y2="98" /><line x1="50" y1="98" x2="50" y2="65" /></g>',
                                    v_backward: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn60" x="3" y="73">&#9664;</text><text class="cxtn60" x="25" y="73">&#9664;</text>',
                                    mr_right: '<g class="cxa"><line x1="77" y1="2" x2="77" y2="98" /></g>',
                                    c_tableau: '<rect x="47.5" class="cl50" width="5" height="20.3"/><rect x="39.8" y="7.6" class="cl50" width="20.3" height="5"/><rect x="47.5" y="79.7" class="cl51" width="5" height="20.3"/><rect x="39.8" y="87.3" class="cl51" width="20.3" height="5"/><rect x="79.7" y="47.5" class="cl51" width="20.3" height="5"/><rect x="87.3" y="39.8" class="cl51" width="5" height="20.3"/><rect y="47.5" class="cl50" width="20.3" height="5"/><rect x="7.6" y="39.8" class="cl50" width="5" height="20.3"/><rect x="74.2" y="9.7" class="cl52" width="5" height="31.2"/><rect x="61.2" y="22.8" class="cl52" width="31.2" height="5"/><rect x="20.7" y="9.7" class="cl53" width="5" height="31.2"/><rect x="7.7" y="22.8" class="cl53" width="31.2" height="5"/><rect x="74.2" y="59.1" class="cl54" width="5" height="31.2"/><rect x="61.2" y="72.2" class="cl54" width="31.2" height="5"/><rect x="20.7" y="59.1" class="cl55" width="5" height="31.2"/><rect x="7.7" y="72.2" class="cl55" width="31.2" height="5"/><rect x="47.5" y="32.6" class="cl56" width="5" height="34.7"/><rect x="32.6" y="47.5" class="cl56" width="34.7" height="5"/>',
                                    ar_tls: '<path class="cxtxb" d="M34,42 L34,34 L42,34 M34,34 L66,66" />',
                                    g_arealine: '<polygon class="cxbc" points="11.9 86.3 40 57.1 55 67.9 76.8 37 92.6 67.8 99.9 58.8 99.9 86 11.9 86.3" /><g class="cxb"><polyline points="11.9 86.3 40 57.1 55 67.9 76.8 37 92.6 67.8 99.9 58.8" /><polyline points="11.9 61.7 40 30 53 43.4 79.9 3.7 99.9 39.2" /></g><g class="cxa"><line x1="11.9" y1="0.1" x2="11.9" y2="100" /><line x1="99.9" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.2" x2="11.9" y2="39.2" x1="0"/><line y1="15.7" x2="11.9" y2="15.7" x1="0"/></g>',
                                    g_scatter2d: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/><line x1="32.5" y1="100" x2="32.5" y2="86"/><line x1="56" y1="100" x2="56" y2="86"/><line x1="79.4" y1="100" x2="79.4" y2="86"/></g><g class="cxb"><line x1="28.9" y1="15.6" x2="32.5" y2="15.6"/><line x1="80.3" y1="19.5" x2="84" y2="19.5"/><line x1="54.1" y1="26.6" x2="57.8" y2="26.6"/><line x1="90" y1="36.8" x2="93.7" y2="36.8"/><line x1="80.3" y1="47.2" x2="84" y2="47.2"/><line x1="67.7" y1="47.2" x2="71.4" y2="47.2"/><line x1="61.2" y1="59.8" x2="64.8" y2="59.8"/><line x1="74.5" y1="68.3" x2="78.2" y2="68.3"/><line x1="42.7" y1="73.6" x2="46.3" y2="73.6"/><line x1="34.2" y1="59.8" x2="37.9" y2="59.8"/><line x1="48.2" y1="47.2" x2="51.8" y2="47.2"/><line x1="23.6" y1="39.1" x2="27.3" y2="39.1"/></g>',
                                    ps_center: '<g class="cxa"><rect x="40" y="40" width="20" height="20" rx="2" /></g>',
                                    m_double: '<text class="cxtn30 cxaa" x="2" y="25">2</text>',
                                    ch_olog: '<text class="cxts100" x="1" y="70">log</text>',
                                    p_cg2datacor: '<g class="cxb"><rect x="20" y="68" width="2" height="2" /><rect x="25" y="80" width="2" height="2" /><rect x="30" y="61" width="2" height="2" /><rect x="35" y="71" width="2" height="2" /><rect x="40" y="49" width="2" height="2" /><rect x="45" y="60" width="2" height="2" /><rect x="50" y="37" width="2" height="2" /><rect x="55" y="51" width="2" height="2" /><rect x="60" y="30" width="2" height="2" /><rect x="65" y="44" width="2" height="2" /><rect x="70" y="19" width="2" height="2" /><rect x="75" y="30" width="2" height="2" /><rect x="80" y="6" width="2" height="2" /><rect x="85" y="21" width="2" height="2" /><rect x="90" y="2" width="2" height="2" /><rect x="95" y="15" width="2" height="2" /></g>',
                                    wp_initialization: '<g class="cxa"><path d="M 15.5 33.2 C 28.4 6.7 65.2 4.1 81.7 28.5 C 86 34.8 88.3 42.3 88.3 50"/><polyline points="98.5 39.8 88.4 50 78.1 39.8"/></g><g class="cxb"><path d="M 84.4 66.8 C 71.5 93.3 34.7 95.9 18.2 71.4 C 14 65.1 11.7 57.6 11.7 50"/><polyline points="1.5 60.1 11.7 50 21.8 60.1"/></g>',
                                    p_g2subtitle: '<g class="cxblue"><rect x="50" y="10" width="20" height="2"/></g>',
                                    dps_square: '<g class="cxa"><rect x="2" y="2" width="96" height="96" /></g>',
                                    ch_spercent: '<text class="cxtb100" x="5" y="85">%</text>',
                                    ps_topleft: '<path class="cxtxb" d="M34,42 L34,34 L42,34 M34,34 L66,66" /><g class="cxa"><rect x="2" y="2" width="20" height="20" rx="2" /></g>',
                                    ar_brm: '<path class="cxtxb" d="M83,71 L83,83 L71,83 M17,17 L83,83" />',
                                    ch_sminus: '<text class="cxtb100" x="35" y="80">-</text>',
                                    ch_lp: '<text class="cxtb100" x="15" y="85">P</text>',
                                    wp_oveview: '<g class="cxa"><path d="M 80.9 42.6 L 80.9 21.6 L 61.6 2.3 L 11.5 2.3 L 11.5 90.4 L 31.6 90.4"/><polyline points="61.8 2.2 61.8 21.3 81 21.3"/></g><g class="cxb"><circle cx="59" cy="68.3" r="22.1"/><line x1="74.5" y1="84" x2="88.5" y2="97.8"/></g>',
                                    bx_wishkersd: '<g class="cxb"><rect x="35" y="30" width="30" height="40" /><line x1="35" y1="51" x2="65" y2="51" /></g><g class="cxa"><line x1="35" y1="2" x2="65" y2="2" /><line x1="50" y1="2" x2="50" y2="30" /><line x1="35" y1="98" x2="65" y2="98" /><line x1="50" y1="98" x2="50" y2="70" /></g>',
                                    ch_ocode: '<text class="cxtn100" x="10" y="-20" transform="rotate(90)">&#8963;</text><text class="cxtn100" x="-90" y="80" transform="rotate(-90)">&#8963;</text>',
                                    sl_checkboxon: '<rect class="cxaa" x="15" y="15" width="70" height="70" rx="5" /><text class="cxtn50 cxww" x="32" y="68">&#10003;</text>',
                                    sp_spacing: '<path class="cxtxa" d="M86,2 L98,14 L86,26 M14,2 L2,14 L14,26 M98,14 2,14" /><g class="cxb"><rect x="2" y="36" width="18" height="62" /><rect x="27" y="36" width="18" height="62" /><rect x="52" y="36" width="18" height="62" /><rect x="77" y="36" width="18" height="62" /></g>',
                                    b_grc: '<g class="cxa"><rect fill="url(\'#rad-grad\')" x="0" y="0" width="100" height="100" /></g>',
                                    m_wheel: '<g class="cxaa"><path d="M50,25 Q 55,25 55,30 L55,40 Q 55,45 50,45 Q 45,45 45,40 L45,30 Q 45,25 50,25" /></g>',
                                    p_g1axistitle1: '<g class="cxblue"><rect x="0" y="25" width="3" height="25"/></g>',
                                    gr_g2x: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="100" y2="98" /></g><g class="cxa"><line x1="20" y1="0" x2="20" y2="97" /> <line x1="40" y1="0" x2="40" y2="97" /> <line x1="60" y1="0" x2="60" y2="97" /> <line x1="80" y1="0" x2="80" y2="97" /></g>',
                                    c_rc: '<path fill="url(\'#rc-grad\')" d="M50,12.7c-27.6,0-50,16.1-50,36.1s22.4,36.1,50,36.1s50-16.1,50-36.1S77.6,12.7,50,12.7z M56.3,73.2c-20.5,0-37.2-11-37.2-24.3s16.7-24.3,37.2-24.3s37.2,10.9,37.2,24.3S76.9,73.2,56.3,73.2z"/><path class="clr" d="M76.8,66.5c6.9-1.7,11.5-9.9,10.1-18.5c-1.2-7.3-6.5-12.8-12.6-12.7H41.1v51.9h14.7V66.8h6.4L73,87.3h14.8L76.8,66.5z M68.2,57.2H55.3V45h12.9c3,0,5.4,2.4,5.4,5.4c0,0,0,0.1,0,0.1c0.5,3-1.5,5.9-4.5,6.6C68.8,57.2,68.5,57.2,68.2,57.2z"/>',
                                    p_g3citation: '<g class="cxblue"><rect x="75" y="95" width="20" height="2"/></g>',
                                    ch_lg: '<text class="cxtb100" x="15" y="85">G</text>',
                                    gr_minor: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxb"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /><line x1="4" y1="14" x2="98" y2="14" /> <line x1="4" y1="26" x2="98" y2="26" /> <line x1="4" y1="38" x2="98" y2="38" /> <line x1="4" y1="50" x2="98" y2="50" /> <line x1="4" y1="62" x2="98" y2="62" /> <line x1="4" y1="74" x2="98" y2="74" /> <line x1="4" y1="86" x2="98" y2="86" /></g>',
                                    ch_ologsmall: '<text class="cxts60" x="15" y="70">log</text>',
                                    ly_layout: '<g class="cxa"><rect x="2" y="2" width="26" height="26" /><rect x="36" y="2" width="26" height="26" /><rect x="69" y="2" width="26" height="26" /><rect x="2" y="36" width="26" height="26" /><rect x="36" y="36" width="26" height="26" /><rect x="69" y="36" width="26" height="26" /><rect x="2" y="69" width="26" height="26" /><rect x="36" y="69" width="26" height="26" /><rect x="69" y="69" width="26" height="26" /></g><g class="cxb"><rect x="9" y="8" width="2" height="16" /><rect x="19" y="10" width="2" height="14" /><rect x="43" y="14" width="2" height="10" /><rect x="53" y="18" width="2" height="6" /><rect x="76" y="16" width="2" height="8" /><rect x="86" y="9" width="2" height="15" /><rect x="9" y="42" width="2" height="16" /><rect x="19" y="50" width="2" height="8" /><rect x="43" y="52" width="2" height="6" /><rect x="53" y="48" width="2" height="10" /><rect x="76" y="43" width="2" height="15" /><rect x="86" y="49" width="2" height="9" /><rect x="9" y="83" width="2" height="8" /><rect x="19" y="76" width="2" height="15" /><rect x="43" y="79" width="2" height="12" /><rect x="53" y="84" width="2" height="7" /><rect x="76" y="81" width="2" height="10" /><rect x="86" y="85" width="2" height="6" /></g>',
                                    tm_history: '<g class="cxa"><path d=" M 12 50 A 38 38 0 1 1 31 83" /><line x1="2" y1="40" x2="12" y2="50" /><line x1="22" y1="40" x2="12" y2="50" /></g><g class="cxb"><line x1="50" y1="20" x2="50" y2="50" /><line x1="42" y1="73" x2="50" y2="50" /><circle cx="50" cy="50" r="4" /></g>',
                                    b_bodygradient: '<g class="cxa"><polyline fill="url(\'#b-grad\')" points="78,42 78,30 48,30 48,2 2,2 2,98 78,98 78,85"/><line x1="79" y1="29" x2="48" y2="1" /></g>',
                                    wp_arguments: '<g class="cxb"><line x1="29.2" y1="71.9" x2="37.8" y2="71.9"/><line x1="45.6" y1="71.9" x2="54.3" y2="71.9"/><line x1="62.1" y1="71.9" x2="70.7" y2="71.9"/></g><g class="cxa"><path d="M 21.3 15.9 L 21.3 15.9 C 14.1 15.9 8.6 22.6 10.1 29.7 C 11 33.3 11.3 36.9 11 40.6 C 9.9 45.2 6.4 48.7 1.9 49.9"/><path d="M 78.6 15.9 L 78.6 15.9 C 85.9 15.9 91.3 22.6 89.8 29.7 C 89 33.3 88.8 37 89.1 40.6 C 90.2 45.2 93.7 48.7 98.2 49.9"/></g><g class="cxa"><path d="M 21.3 84 L 21.3 84 C 14.1 84 8.6 77.3 10.1 70.2 C 11 66.6 11.3 62.9 11 59.3 C 9.8 54.7 6.4 51.2 1.9 49.9 L 4.8 48.7"/><path d="M 78.6 84 L 78.6 84 C 85.9 84 91.3 77.3 89.8 70.2 C 89 66.6 88.8 62.9 89.1 59.3 C 90.2 54.7 93.7 51.2 98.2 49.9 L 95.3 48.7"/></g>',
                                    c_rrcode: '<g class="cxb"><path d="M 50 15.2 C 23.4 15.2 1.8 30.7 1.8 50 C 1.8 69.2 23.4 84.8 50 84.8 C 76.6 84.8 98.1 69.2 98.1 50 C 98.1 30.7 76.6 15.2 50 15.2 Z M 56 73.5 C 36.3 73.5 20.2 62.9 20.2 50.1 C 20.2 37.3 36.3 26.7 56 26.7 C 75.8 26.7 91.9 37.2 91.9 50.1 C 91.9 63 75.9 73.5 56 73.5 Z"/></g><g class="cxaw"><path d="M 80.6 73.4 C 85.8 72.1 89.2 65.9 88.1 59.5 C 87.2 54 83.2 50 78.6 50 L 53.8 50 L 53.8 89 L 64.8 89 L 64.8 73.7 L 69.6 73.7 L 77.8 89 L 88.8 89 L 80.6 73.4 Z M 74 66.4 L 64.3 66.4 L 64.3 57.3 L 74 57.3 C 76.2 57.3 78 59.1 78 61.3 C 78 61.4 78 61.4 78 61.5 C 78.4 63.8 76.9 66 74.6 66.5 C 74.5 66.5 74.3 66.5 74 66.4 Z"/><path d="M 38.7 34.4 C 43.9 33.1 47.3 26.9 46.2 20.5 C 45.3 15 41.3 11 36.7 11 L 11.9 11 L 11.9 50 L 22.9 50 L 22.9 34.7 L 27.7 34.7 L 35.9 50 L 46.9 50 L 38.7 34.4 Z M 32.1 27.4 L 22.4 27.4 L 22.4 18.3 L 32.1 18.3 C 34.3 18.3 36.1 20.1 36.1 22.3 C 36.1 22.4 36.1 22.4 36.1 22.5 C 36.5 24.8 35 27 32.7 27.5 C 32.6 27.5 32.4 27.5 32.1 27.4 Z"/></g><g class="cxaa"><text class="cxtn50" x="2" y="-60" transform="rotate(90)">&#8963;</text><text class="cxtn50" x="-42" y="90" transform="rotate(-90)">&#8963;</text></g>',
                                    v_stop: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn70" x="14" y="77">&#9726;</text>',
                                    tx_tostring: '<text class="cxtn60" x="65" y="70">#</text><g class="cxaa"><text class="cxtn60" x="20" y="30">&#10554;</text><text class="cxtn60" x="0" y="65">a</text></g>',
                                    wp_userinterface: '<g class="cxb"><line x1="3.4" y1="16.2" x2="58.1" y2="16.2"/><line x1="9.4" y1="9.6" x2="13.5" y2="9.6"/><line x1="18.1" y1="9.6" x2="22.2" y2="9.6"/><polyline points="11.4 42.2 27 31.1 36.5 39.5 48.8 27.7"/><line x1="41.8" y1="57" x2="96.6" y2="57"/><line x1="48" y1="50.4" x2="52" y2="50.4"/><line x1="56.6" y1="50.4" x2="60.8" y2="50.4"/><line x1="57.6" y1="84.1" x2="57.6" y2="78.4"/><line x1="69.2" y1="84.1" x2="69.2" y2="73.6"/><line x1="80.9" y1="84.1" x2="80.9" y2="69.4"/></g><g class="cxa"><polyline points="41.8 57 3.4 57 3.4 2.3 58.1 2.3 58.1 43"/><rect x="41.9" y="43" width="54.8" height="54.8"/></g>',
                                    dps_resize: '<g class="cxa"><rect x="2" y="2" width="96" height="96" /></g><path class="cxtxb" d="M17,71 L17,83 L29,83 M71,17 L83,17 L83,29 M17,83 L83,17" />',
                                    mr_bottom: '<g class="cxa"><line x1="2" y1="77" x2="98" y2="77" /></g>',
                                    ln_stylesolid: '<g class="cxa"><line x1="4" y1="50" x2="98" y2="50" /></g>',
                                    o_g1: '<g class="cxc"><line x1="2" y1="40" x2="98" y2="40" /><line x1="2" y1="24" x2="8" y2="24" /><line x1="2" y1="12" x2="8" y2="12" /><line x1="10" y1="2" x2="10" y2="40" /><line x1="90" y1="24" x2="98" y2="24" /><line x1="90" y1="12" x2="98" y2="12" /><line x1="90" y1="2" x2="90" y2="40" /><rect x="20" y="55" width="20" height="2" /><rect x="60" y="55" width="20" height="2" /></g><g class="cxcc"><rect x="25" y="35" width="15" height="10" /><rect x="60" y="10" width="15" height="30" /></g><g class="cxa"><rect x="15" y="68" width="70" height="28" /><line x1="15" y1="82" x2="85" y2="82" /><line x1="50" y1="68" x2="50" y2="96" /><rect x="95" y="75" width="2" height="2" /><rect x="95" y="89" width="2" height="2" /></g>',
                                    g_contour: '<g class="cxa"><path d="M 56.1 92.7 L 21.1 92.7 C 17.4 92.8 14.3 89.8 14.3 86 L 14.3 82.1 C 14.3 80.4 13.1 79.1 11.4 79.1 L 11.4 79.1 C 9.8 79.1 8.4 77.7 8.4 76.2 L 8.4 29.7 L 14.3 29.7 L 14.3 22.2 L 20.3 22.2 L 20.3 18.4 L 25 18.4 L 25 13.3 L 29.9 13.3 L 29.9 8.7 L 33.6 8.7 L 33.6 5.8 L 37.8 5.8 L 37.8 2.8 L 50 2.8 L 50 6.6 L 62.5 6.6 L 62.5 10.9 L 69.1 10.9 L 69.1 15.7 L 74 15.7 L 74 20 L 77.5 20 L 77.5 27 L 82.5 27 L 82.5 34.9 L 86.2 34.9 L 86.2 50.9 L 90.8 50.9 L 90.8 69.8 L 86.5 69.8 L 86.5 80.1 L 82.5 80.1 L 82.5 90.6 C 82.5 91.8 81.5 92.7 80.2 92.7 L 80.2 92.7 C 78.9 92.7 77.9 93.8 77.9 95 L 77.9 95 C 77.9 96.3 76.9 97.3 75.6 97.3 L 60.8 97.3 C 59.6 97.3 58.6 96.3 58.6 95 L 58.6 95 C 58.6 93.7 57.5 92.6 56.1 92.7 Z"/><polygon points="38.4 42.7 38.4 38.9 49.9 38.9 49.9 43.2 53.7 43.2 53.7 71.1 38.4 71.1 38.4 63.2 34 63.2 34 42.7 38.4 42.7"/></g><g class="cxb"><polygon points="63 78.5 69.8 78.5 69.8 70.7 78.5 70.7 78.5 59.1 74 59.1 74 50.6 69.5 50.6 69.5 39.4 66.7 39.4 66.7 31.7 62.5 31.7 62.5 27.5 54.2 27.5 54.2 22.9 33.9 22.9 33.9 27.4 30.1 27.3 30.1 29.8 26.2 29.8 26.2 34.7 22.8 34.7 22.8 75.1 25.4 75.1 25.4 79.2 29.5 79.2 29.5 83.1 63 83.1 63 78.5"/><polyline points="77.9 2.9 85.9 2.9 85.9 11.4 90 11.4 90 15 93.9 15 93.9 22.9 98.2 22.9 98.2 31.2"/><polyline points="21.9 2.9 14 2.9 14 7.2 10.1 7.2 10.1 15.4 1.8 15.4"/></g>',
                                    p_g2axistitlex: '<g class="cxblue"><rect x="40" y="85" width="30" height="2"/></g>',
                                    sr_az: '<path class="cxtxb" d="M2,80 L17,98 L32,80 M17,98 L17,2" /><path class="cxtxb" d="M27,20 L42,2 L57,20 M42,98 L42,2" /><g class="cxaa"><text class="cxtn60" x="60" y="45">A</text><text class="cxtn60" x="60" y="95">Z</text></g>',
                                    bx_wishkerss: '<g class="cxb"><rect x="35" y="30" width="30" height="40" /><line x1="35" y1="51" x2="65" y2="51" /></g><g class="cxa"><line x1="50" y1="2" x2="50" y2="30" /><line x1="50" y1="98" x2="50" y2="70" /></g>',
                                    bx_notched: '<g class="cxa"><polyline points="40,50 30,40 30,20 70,20 70,40 60,50 70,60 70,80 30,80 30,60 40,50" /><line x1="40" y1="50" x2="60" y2="50" /></g><g class="cxb"><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g>',
                                    ar_ts: '<path class="cxtxb" d="M42,38 L50,30 L58,38 M50,70 L50,30" />',
                                    g_heatmap: '<g class="cxcc"><rect x="64.5" y="50" width="28.8" height="20.3"/><rect x="64.5" y="69.5" width="28.8" height="20.3"/><rect x="35.6" y="30.2" width="28.8" height="20.3"/><rect x="6.7" y="10.9" width="28.8" height="20.3"/><rect x="6.8" y="69.5" width="28.8" height="20.3"/></g><g class="cxbb"><rect x="64.4" y="10.3" width="28.8" height="20.3"/><rect x="35.6" y="49.9" width="28.8" height="20.3"/><rect x="6.7" y="30.2" width="28.8" height="20.3"/></g><g class="cxa"><line x1="100" y1="50" y2="50" x2="0"/><line x1="93.3" x2="93.3" y2="96.2" y1="3.8"/><line x1="64.4" x2="64.4" y2="96.2" y1="3.8"/><line x1="6.7" x2="6.7" y2="96.2" y1="3.8"/><line x1="35.6" x2="35.6" y2="96.2" y1="3.8"/><line x1="100" y1="69.8" y2="69.8" x2="0"/><line x1="100" y1="89.4" y2="89.4" x2="0"/><line x1="100" y1="10.9" y2="10.9" x2="0"/><line x1="100" y1="30.6" y2="30.6" x2="0"/></g>',
                                    ch_ll: '<text class="cxtb100" x="15" y="85">L</text>',
                                    mr_top: '<g class="cxa"><line x1="2" y1="25" x2="98" y2="25" /></g>',
                                    ch_ofloor: '<text class="cxtn50" x="0" y="70">floor</text>',
                                    g_violin: '<g class="cxcc"><path d="M 73.1 51.6 C 67.5 46.1 54.8 40.4 61.2 34.5 C 68.7 27.4 59.6 21 54.4 14.7 C 51.8 11.4 50.3 7.5 50 3.4 C 50 2 50 2 50 3.4 L 50 3.4 C 49.8 7.5 48.2 11.4 45.6 14.7 C 40.5 21 31.3 27.4 38.9 34.5 C 45.1 40.4 32.5 46.1 26.9 51.6 C 22.5 55.9 24.2 60.7 30.7 61.7 C 56.4 65.6 32.4 67.9 32.5 74.5 C 32.7 80.6 40.2 76.2 42.7 84.5 C 43.4 87.1 44.8 89.5 46.9 91.4 C 48.6 92.8 49.8 95 50 97.3 C 50 97.3 50 97.8 50 97.6 C 50 97.5 50 97.3 50 97.3 C 50.3 95 51.3 92.8 53.2 91.4 C 55.2 89.5 56.7 87.1 57.4 84.5 C 59.9 76.2 67.3 80.6 67.5 74.5 C 67.7 67.9 43.7 65.5 69.3 61.7 C 75.9 60.7 77.5 55.9 73.1 51.6 Z"/></g><g class="cxa"><path d="M 73.1 51.6 C 67.5 46.1 54.8 40.4 61.2 34.5 C 68.7 27.4 59.6 21 54.4 14.7 C 51.8 11.4 50.3 7.5 50 3.4 C 50 2 50 2 50 3.4 L 50 3.4 C 49.8 7.5 48.2 11.4 45.6 14.7 C 40.5 21 31.3 27.4 38.9 34.5 C 45.1 40.4 32.5 46.1 26.9 51.6 C 22.5 55.9 24.2 60.7 30.7 61.7 C 56.4 65.6 32.4 67.9 32.5 74.5 C 32.7 80.6 40.2 76.2 42.7 84.5 C 43.4 87.1 44.8 89.5 46.9 91.4 C 48.6 92.8 49.8 95 50 97.3 C 50 97.3 50 97.8 50 97.6 C 50 97.5 50 97.3 50 97.3 C 50.3 95 51.3 92.8 53.2 91.4 C 55.2 89.5 56.7 87.1 57.4 84.5 C 59.9 76.2 67.3 80.6 67.5 74.5 C 67.7 67.9 43.7 65.5 69.3 61.7 C 75.9 60.7 77.5 55.9 73.1 51.6 Z"/></g>',
                                    g_scatter3d: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/><line x1="32.5" y1="100" x2="32.5" y2="86"/><line x1="56" y1="100" x2="56" y2="86"/><line x1="79.4" y1="100" x2="79.4" y2="86"/><line x1="11.9" y1="86" x2="74.5" y2="26.6"/></g><g class="cxb"><line x1="28.9" y1="15.6" x2="32.5" y2="15.6"/><line x1="50" y1="15.6" x2="53.7" y2="15.6"/><line x1="78.3" y1="46.7" x2="81.9" y2="46.7"/><line x1="61.2" y1="59.8" x2="64.8" y2="59.8"/><line x1="74.5" y1="68.3" x2="78.2" y2="68.3"/><line x1="48" y1="71.8" x2="51.4" y2="71.8"/><line x1="39" y1="29.4" x2="42.7" y2="29.4"/><polyline points="72.1 4.9 81.5 4.9 81.5 19.5 72.1 19.5"/><line x1="74.5" y1="11.8" x2="81.5" y2="11.8"/><polyline points="92.5 4.9 85.8 4.9 85.8 19.5 92.5 19.5"/><line x1="94" y1="5.9" x2="94" y2="18.5"/></g>',
                                    g_line: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g><g class="cxb"><polyline points="24.3 73.9 54 42.6 62.7 50.7 90.2 19.4"/></g>',
                                    g_ridgeline: '<g class="cxcc"><path d="M 11.5 35.4 C 11.5 35.4 27.1 2.1 30.9 2.1 C 43.1 2.1 53.7 32.3 59.5 35.4"/><path d="M 22.6 66.7 C 22.6 66.7 35.9 32 40.4 26.5 C 45.1 20.4 53.9 42 68.9 65.8"/><path d="M 42.3 98 C 42.3 98 53.1 62.5 59.2 55.9 C 67 47.3 82.5 85.5 86.4 91.6 C 87.2 93.8 88.3 95.8 88.9 98"/></g><g class="cxb"><path d="M 11.5 35.4 C 11.5 35.4 27.1 2.1 30.9 2.1 C 43.1 2.1 53.7 32.3 59.5 35.4"/><path d="M 22.6 66.7 C 22.6 66.7 35.9 32 40.4 26.5 C 45.1 20.7 53.9 42.3 68.9 65.8"/><path d="M 42.3 98 C 42.3 98 52.8 62.5 58.9 55.9 C 66.7 47.3 82.2 85.5 86.4 91.6 C 87.2 93.8 88.3 95.8 88.9 98"/></g><g class="cxa"><line y1="35.4" x2="94" y2="35.4" x1="6"/><line y1="66.7" x2="94" y2="66.7" x1="6"/><line y1="97.9" x2="94" y2="97.9" x1="6"/></g>',
                                    p_g1axis2: '<g class="cxblue"><line x1="75" y1="15" x2="75" y2="65" /><line x1="75" y1="25" x2="85" y2="25" /><line x1="75" y1="45" x2="85" y2="45" /><line x1="75" y1="65" x2="85" y2="65" /></g>',
                                    g_dotplot: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g><g class="cxb"><circle cx="57.1" cy="67.9" r="6.6"/><circle cx="82.7" cy="42.6" r="6.6"/><circle cx="38.9" cy="25.9" r="6.6"/></g>',
                                    g_treemap: '<g class="cxbb"><rect x="48" y="83.3" width="33.1" height="14.4"/><rect x="59.5" y="23" width="38.1" height="38.9"/><rect x="25.4" y="35.9" width="22.6" height="45.5"/><rect x="2.3" y="2.2" width="45.7" height="45.7"/></g><g class="cxcc"><rect x="80.4" y="72.6" width="16.6" height="25.1"/><rect x="25.1" y="79" width="22.9" height="18.6"/><rect x="48" y="61.9" width="31.8" height="21.3"/><rect x="48" y="2.2" width="49.1" height="20.8"/></g><g class="cxa"><rect x="2.3" y="2.2" width="95.5" height="95.5"/><rect x="2.3" y="2.2" width="45.7" height="45.7"/><line x1="97" y1="23" x2="48" y2="23"/><line x1="48" y1="47.9" x2="48" y2="97.6"/><rect x="2.3" y="47.9" width="22.9" height="49.7"/><line x1="25.1" y1="79" x2="48" y2="79"/><rect x="48" y="61.9" width="31.8" height="21.3"/><rect x="79.8" y="61.9" width="17.9" height="35.7"/><line x1="79.8" y1="72.6" x2="97.6" y2="72.6"/><line x1="59.5" y1="23" x2="59.5" y2="61.9"/></g>',
                                    b_body: '<g class="cxa"><polyline points="78,42 78,30 48,30 48,2 2,2 2,98 78,98 78,85"/><line x1="79" y1="29" x2="48" y2="1" /></g>',
                                    cr_normal: '<g class="cxa"><path d="M1,99 C45,67 33,0 50,3 66,0 67,90 99,99" /></g>',
                                    p_g1title: '<g class="cxblue"><rect x="45" y="0" width="20" height="2"/></g>',
                                    g_area: '<polygon class="cxbc" points="11.9 86.7 53 44.1 63.3 53.7 100 12.1 100 86.3 11.9 86.7" /><g class="cxb"><polyline points="14.5 84.1 53 44.1 63.3 53.7 100 12.1" /><polyline points="11.9 47.3 40.1 18.3 53.1 31.7 78 3.5 93.7 19.6" /></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g>',
                                    p_g3axestitles: '<g class="cxblue"><rect x="40" y="85" width="30" height="2"/><rect x="0" y="25" width="3" height="25"/><line x1="55" y1="55" x2="65" y2="47"/></g>',
                                    sl_radioon: '<circle class="cxaa" cx="50" cy="50" r="35" /><circle class="cxww" cx="50" cy="50" r="10" />',
                                    ch_oa: '<text class="cxtb100" x="25" y="75">a</text>',
                                    sv_disk: '<g class="cxa"><polyline points="98,25 98,98 2,98 2,2 75,2 98,25" /></g><g class="cxb"><rect x="27" y="58" width="50" height="40" /><rect x="32" y="2" width="40" height="30" /><rect x="55" y="12" width="5" height="10" /></g>',
                                    p_cg2fitden2: '<g class="cxac"><path d="M15,90 C50,67 38,0 55,3 71,0 72,90 95,90" /></g>',
                                    ch_oaa: '<text class="cxtn100" x="0" y="85">A</text><text class="cxtn60" x="65" y="85">a</text>',
                                    cr_cumulative: '<g class="cxa"><path d="M1,99 C75,75 25,25 99,1" /></g>',
                                    p_g1samplelabels: '<g class="cxblue"><rect x="38" y="75" width="5" height="2"/><rect x="56" y="75" width="5" height="2"/></g>',
                                    ch_sat: '<text class="cxtb100" x="1" y="85">@</text>',
                                    ch_olog10: '<text class="cxts70" x="1" y="60">log</text><text class="cxtn40" x="55" y="85">10</text>',
                                    p_g2titlesubtitle: '<g class="cxblue"><rect x="45" y="0" width="30" height="2"/><rect x="50" y="10" width="20" height="2"/></g>',
                                    g_stackedline: '<g class="cxcc"><rect x="76.7" y="51.4" width="15.1" height="34.7"/><rect x="50" y="64.3" width="15.1" height="21.8"/><rect x="23.2" y="71" width="15.1" height="15.1"/></g><g class="cxb"><rect x="23.2" y="56" width="15.1" height="30.1"/><rect x="50" y="42.5" width="15.1" height="43.6"/><rect x="76.7" y="30.4" width="15.1" height="55.6"/><line x1="23.2" y1="71" x2="38.4" y2="71"/><line x1="49.7" y1="64.3" x2="65.1" y2="64.3"/><line x1="76.7" y1="51.4" x2="91.9" y2="51.4"/></g><g class="cxa"><line x1="11.9" y1="0.5" x2="11.9" y2="100"/><line x1="99.4" y1="86.1" y2="86.1" x2="0"/><line y1="62.7" x2="11.9" y2="62.7" x1="0"/><line y1="39.4" x2="11.9" y2="39.4" x1="0"/><line y1="16.1" x2="11.9" y2="16.1" x1="0"/><polyline points="23.2 42.5 49.7 19.6 59.5 28.6 89.1 0.5"/></g>',
                                    h_hvariable: '<g class="cxa"><rect x="42" y="4" width="26" height="18"/><rect x="42" y="26" width="26" height="18"/><rect x="42" y="48" width="26" height="18"/><rect x="42" y="70" width="26" height="18"/></g>',
                                    dtt_pivot: '<g class="cxaa"><text class="cxtn60" x="-30" y="-85" transform="rotate(135)">&#10554;</text><text class="cxtn60" x="-30" y="-85" transform="rotate(135) scale(-1,1)">&#10554;</text></g><g class="cxb"><rect x="2" y="2" width="18" height="18" /><rect x="30" y="2" width="68" height="18" /><rect x="2" y="30" width="18" height="68" /></g>',
                                    p_g1axes: '<g class="cxblue"><line x1="25" y1="15" x2="25" y2="65" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /><line x1="75" y1="15" x2="75" y2="65" /><line x1="75" y1="25" x2="85" y2="25" /><line x1="75" y1="45" x2="85" y2="45" /><line x1="75" y1="65" x2="85" y2="65" /></g>',
                                    ch_lz: '<text class="cxtb100" x="15" y="85">Z</text>',
                                    ch_oceil: '<text class="cxtn60" x="5" y="70">ceil</text>',
                                    fp_funnel: '<g class="cxb"><polyline points="2,2 98,2 98,10 60,50 40,50 2,10 2,2" /></g><g class="cxa"><polyline points="60,50 60,98 40,83 40,50 60,50" /></g>',
                                    cd_linesindent: '<g class="cxa"><line x1="10" y1="10" x2="40" y2="10" /><line x1="15" y1="18" x2="40" y2="18" /><line x1="15" y1="26" x2="40" y2="26" /><line x1="10" y1="34" x2="50" y2="34" /><line x1="15" y1="42" x2="40" y2="42" /><line x1="15" y1="50" x2="40" y2="50" /><line x1="10" y1="58" x2="50" y2="58" /><line x1="15" y1="66" x2="40" y2="66" /><line x1="15" y1="74" x2="40" y2="74" /><line x1="10" y1="82" x2="50" y2="82" /><line x1="15" y1="90" x2="40" y2="90" /></g>',
                                    sl_lightbulbon: '<g class="cxa"><path d="M75.4,50.1C75.4,36,64,24.7,50,24.7S24.6,36.1,24.6,50.1c0,7.4,3.2,14.3,8.7,19.2c3.3,2.9,5.3,7.1,5.3,11.5h22.7c0-4.5,2-8.8,5.5-11.7C72.2,64.3,75.4,57.3,75.4,50.1z"/><path d="M38.7,80.8h22.9l0,0v8.6c0,4.5-3.7,8.2-8.2,8.2l0,0h-6.5c-4.5,0-8.2-3.7-8.2-8.2l0,0L38.7,80.8L38.7,80.8z"/></g><g class="cxb"><line x1="50" y1="0" x2="50" y2="14.4"/><line x1="99.3" y1="49.3" x2="84.9" y2="49.3"/><line x1="0.7" y1="49.3" x2="15.1" y2="49.3"/><line x1="84.9" y1="14.4" x2="74.6" y2="24.6"/><line x1="15.1" y1="84.2" x2="25.4" y2="73.9"/><line x1="84.9" y1="84.2" x2="74.6" y2="73.9"/><line x1="15.1" y1="14.4" x2="25.4" y2="24.6"/></g>',
                                    dp_bin: '<g class="cxb"><circle cx="19" cy="3" r="2.5" /><circle cx="19" cy="18" r="2.5" /><circle cx="19" cy="33" r="2.5" /><circle cx="12" cy="33" r="2.5" /><circle cx="19" cy="50" r="2.5" /><circle cx="12" cy="50" r="2.5" /><circle cx="5" cy="50" r="2.5" /><circle cx="19" cy="65" r="2.5" /><circle cx="12" cy="65" r="2.5" /><circle cx="19" cy="80" r="2.5" /><circle cx="19" cy="97" r="2.5" /><circle cx="50" cy="3" r="2.5" /><circle cx="46.5" cy="18" r="2.5" /><circle cx="53.5" cy="18" r="2.5" /><circle cx="43" cy="33" r="2.5" /><circle cx="50" cy="33" r="2.5" /><circle cx="57" cy="33" r="2.5" /><circle cx="39.5" cy="50" r="2.5" /><circle cx="46.5" cy="50" r="2.5" /><circle cx="53.5" cy="50" r="2.5" /><circle cx="60.5" cy="50" r="2.5" /><circle cx="43" cy="65" r="2.5" /><circle cx="50" cy="65" r="2.5" /><circle cx="57" cy="65" r="2.5" /><circle cx="46.5" cy="80" r="2.5" /><circle cx="53.5" cy="80" r="2.5" /><circle cx="50" cy="97" r="2.5" /><circle cx="81" cy="3" r="2.5" /><circle cx="81" cy="18" r="2.5" /><circle cx="81" cy="33" r="2.5" /><circle cx="88" cy="33" r="2.5" /><circle cx="81" cy="50" r="2.5" /><circle cx="88" cy="50" r="2.5" /><circle cx="95" cy="50" r="2.5" /><circle cx="81" cy="65" r="2.5" /><circle cx="88" cy="65" r="2.5" /><circle cx="81" cy="80" r="2.5" /><circle cx="81" cy="97" r="2.5" /><circle cx="81" cy="3" r="2.5" /></g>',
                                    ga_axisxyz: '<g class="cxb"><line x1="15" y1="2" x2="15" y2="98" /><line x1="15" y1="2" x2="0" y2="17" /><line x1="15" y1="2" x2="30" y2="17" /><line x1="2" y1="85" x2="98" y2="85" /><line x1="83" y1="70" x2="98" y2="85" /><line x1="83" y1="100" x2="98" y2="85" /><line x1="2" y1="98" x2="70" y2="30" /><line x1="55" y1="30" x2="70" y2="30" /><line x1="70" y1="45" x2="70" y2="30" /></g><text class="cxtn30 cxaa" x="30" y="25">X</text><text class="cxtn30 cxaa" x="65" y="70">Y</text><text class="cxtn30 cxaa" x="75" y="25">Z</text>',
                                    h_hspace: '<g class="cxwhite"><line x1="10" y1="24" x2="98" y2="24" /><line x1="10" y1="46" x2="98" y2="46" /><line x1="10" y1="68" x2="98" y2="68" /><line x1="40" y1="2" x2="40" y2="90" /><line x1="70" y1="2" x2="70" y2="90" /></g>',
                                    g_boxplot: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g><g class="cxb"><rect x="83.1" y="27.1" width="13.3" height="25.1"/><line x1="83.1" y1="39.6" x2="96.4" y2="39.6"/><line x1="90" y1="27.1" x2="90" y2="19.3"/><line x1="84.8" y1="20" x2="95.2" y2="20"/><line x1="90" y1="52.2" x2="90" y2="59.9"/><line x1="84.8" y1="59.2" x2="95.2" y2="59.2"/><line x1="89.8" y1="67.5" x2="89.8" y2="68.7"/><rect x="23.1" y="18.8" width="13.3" height="25.1"/><line x1="23.1" y1="31.3" x2="36.5" y2="31.3"/><line x1="30" y1="18.8" x2="30" y2="11"/><line x1="24.8" y1="11.7" x2="35.3" y2="11.7"/><line x1="30" y1="43.9" x2="30" y2="51.7"/><line x1="24.8" y1="51" x2="35.3" y2="51"/><line x1="29.8" y1="59.2" x2="29.8" y2="60.5"/><rect x="53.1" y="44.2" width="13.3" height="25.1"/><line x1="53.1" y1="56.7" x2="66.4" y2="56.7"/><line x1="60" y1="69.2" x2="60" y2="77"/><line x1="54.7" y1="76.3" x2="65.3" y2="76.3"/><line x1="60" y1="44.2" x2="60" y2="36.4"/><line x1="54.7" y1="37.1" x2="65.3" y2="37.1"/><line x1="59.8" y1="25.9" x2="59.8" y2="24.7"/></g>',
                                    fp_pin: '<g class="cxb"><line x1="32.9" y1="68" x2="2.6" y2="98.2"/><path d="M80.3,41.4L58.1,63.5c-2.2,2.1-8.8-1-14.8-7s-9.1-12.6-7-14.8l21.9-22.1"/></g><g class="cxa"><path d="M63.6,58c6.8,11.4,7.7,22.7,3.9,26.5c-5,5-20.6-2.4-34.7-16.5S11.3,38.5,16.3,33.3c3.7-3.7,14.4-2.2,25.4,3.9"/><ellipse transform="matrix(0.7071 -0.7071 0.7071 0.7071 9.1516 62.3116)" cx="79.8" cy="20.1" rx="8.4" ry="23.5"/><path d="M96.5,36.6l-5.9,5.9c-3.2,3.3-13.3-1.5-22.5-10.7S54.1,12.6,57.4,9.4l5.9-5.9"/></g>',
                                    ch_lx: '<text class="cxtb100" x="15" y="85">X</text>',
                                    v_previous: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn100" x="-90" y="100" transform="rotate(-90)">⌃</text>',
                                    ps_left: '<path class="cxtxb" d="M38,42 L30,50 L38,58 M70,50 L30,50" /><g class="cxa"><rect x="2" y="40" width="20" height="20" rx="2" /></g>',
                                    a_distributever: '<g class="cxb"><rect x="10" y="25" width="36" height="50" rx="5" /><rect x="54" y="5" width="36" height="90" rx="5" /></g><g class="cxa"><line x1="1" y1="50" x2="99" y2="50" /></g>',
                                    p_cg2data: '<g class="cxb"><rect x="18" y="56" width="2" height="2"/><rect x="26" y="32" width="2" height="2"/><rect x="34" y="44" width="2" height="2"/><rect x="42" y="10" width="2" height="2"/><rect x="43" y="30" width="2" height="2"/><rect x="50" y="80" width="2" height="2"/><rect x="58" y="60" width="2" height="2"/><rect x="64" y="24" width="2" height="2"/><rect x="70" y="70" width="2" height="2"/><rect x="74" y="48" width="2" height="2"/><rect x="82" y="18" width="2" height="2"/><rect x="90" y="72" width="2" height="2"/><rect x="55" y="45" width="2" height="2"/><rect x="40" y="60" width="2" height="2"/><rect x="25" y="75" width="2" height="2"/></g>',
                                    ar_b: '<path class="cxtxb" d="M35,80 L50,98 L65,80 M50,98 L50,2" />',
                                    ar_trm: '<path class="cxtxb" d="M71,17 L83,17 L83,29 M17,83 L83,17" />',
                                    cd_doc: '<g class="cxb"><polyline points="78,42 78,30 48,30 48,2 2,2 2,98 78,98 78,85"/><line x1="79" y1="29" x2="48" y2="1" /></g><g class="cxaa"><text class="cxtn50" x="42" y="-60" transform="rotate(90)">&#8963;</text><text class="cxtn50" x="-82" y="90" transform="rotate(-90)">&#8963;</text></g>',
                                    ch_ocodemed: '<text class="cxtn80" x="20" y="-30" transform="rotate(90)">&#8963;</text><text class="cxtn80" x="-82" y="70" transform="rotate(-90)">&#8963;</text>',
                                    g_circular: '<g class="cxa"><circle cx="50" cy="50" r="37.9"/><line x1="23" y1="76.6" x2="16.9" y2="84.6"/><circle cx="50" cy="50" r="47.9"/><circle cx="50" cy="50" r="18.6"/></g><g class="cxa"><line x1="50" y1="2.2" x2="50" y2="12.1"/></g><g class="cxb"><line x1="50" y1="20.2" x2="50" y2="24"/><line x1="50" y1="79.8" x2="50" y2="76"/><line x1="79.8" y1="50" x2="76" y2="50"/><line x1="20.2" y1="50" x2="24" y2="50"/><line x1="71.1" y1="28.9" x2="68.4" y2="31.6"/><line x1="28.9" y1="71.1" x2="31.6" y2="68.4"/><line x1="71.1" y1="71.1" x2="68.4" y2="68.4"/><line x1="28.9" y1="28.9" x2="31.6" y2="31.6"/><line x1="61.3" y1="22.4" x2="59.8" y2="25.9"/><line x1="38.7" y1="77.6" x2="40.2" y2="74.1"/><line x1="77.6" y1="61.3" x2="74.1" y2="59.8"/><line x1="22.4" y1="38.7" x2="25.9" y2="40.2"/><line x1="77.5" y1="38.5" x2="74" y2="39.9"/><line x1="22.5" y1="61.6" x2="26" y2="60.1"/><line x1="61.6" y1="77.5" x2="60.1" y2="74"/><line x1="38.5" y1="22.5" x2="39.9" y2="26"/><path d="M 87.9 50 C 87.9 59.7 84.1 69.1 77.4 76.1 L 83.7 83.8 C 109.8 57.8 97.9 13.4 62.4 3.8 C 58.3 2.7 54.2 2.2 50 2.2 L 50 12.1 C 71 12.1 87.9 29.1 87.9 50 Z"/></g>',
                                    e_close: '<g class="cxb"><path d="M98,50 Q50,100 2,50" /><line x1="2" y1="75" x2="10" y2="65" /><line x1="25" y1="88" x2="30" y2="77" /><line x1="50" y1="92" x2="50" y2="80" /><line x1="75" y1="88" x2="70" y2="77" /><line x1="98" y1="75" x2="88" y2="65" /></g>',
                                    p_g1titlesubtitle: '<g class="cxblue"><rect x="45" y="0" width="20" height="2"/><rect x="50" y="10" width="10" height="2"/></g>',
                                    ch_ssum: '<text class="cxtb100" x="15" y="80">&#8721;</text>',
                                    p_cg1datahorizontal: '<g class="cxcc"><rect x="14" y="10" width="30" height="16"/><rect x="14" y="38" width="80" height="16"/><rect x="14" y="66" width="60" height="16"/></g>',
                                    dps_height: '<g class="cxa"><rect x="2" y="2" width="96" height="96" /></g><path class="cxtxb" d="M38,29 L50,17 L62,29 M38,71 L50,83 L62,71 M50,83 L50,17" />',
                                    wp_list: '<g class="cxa"><line x1="22.4" y1="15" x2="100" y2="15.2" /><line x1="22.4" y1="84.5" x2="100" y2="84.6" /></g><g class="cxaa"><rect width="9.9" height="9.5" y="10.5" /><rect y="80" width="9.9" height="9.5" /></g><g class="cxb"><line x1="22.4" y1="49.8" x2="100" y2="50" /></g><g class="cxbb"><rect y="45.2" width="9.9" height="9.5" /></g>',
                                    p_g3axisx: '<g class="cxblue"><line x1="25" y1="65" x2="95" y2="65" /><line x1="25" y1="65" x2="25" y2="75" /><line x1="45" y1="65" x2="45" y2="75" /><line x1="65" y1="65" x2="65" y2="75" /><line x1="85" y1="65" x2="85" y2="75" /></g>',
                                    c_economist: '<path class="cl57" d="M3.5,50.1c0-13,0-25.9,0-38.9C3.8,4.8,9.3-0.3,15.8,0c0.1,0,0.3,0,0.4,0h68.1c6-0.2,11.2,4.2,12,10.1c0.5,26,0,52,0.2,78c0.2,6.3-4.7,11.5-10.9,11.8H14C8.3,99.6,3.8,95,3.5,89.3V50.1z M61.2,59.4l0.2-0.2c-1.3-0.4-1-1.4-1.1-2.3c-0.1-0.9-0.1-1.9,0-2.8c0-1.5,2.2-2.9,2.7-0.9c0.5,1.9,0.9,4.3-0.6,6.2h3.7c-1.6-1.1-0.7-4.1-0.8-5.9c0.1-0.7,0.7-1.3,1.5-1.2s1.3,0.7,1.2,1.5c0,0.9,0,1.8,0,2.6c0,0.9,0.4,2.3-0.9,3h4.1l0.2-0.2c-2-0.3-1.4-1.8-1.5-2.9c0.3-4.2-0.9-7-5.2-3.9c-0.9-2.1-3.2-1.1-4.7-0.4v-0.9l-3,0.4v0.3c1.6,0,1.4,1.3,1.4,2.3v3.3c0,0.9,0,1.8-1.2,1.9c0,0,0,0,0,0.3L61.2,59.4z M8.3,59.1c0.2,0.3,0.3,0.3,0.3,0.3H16c0.7,0,0.8-2.3,0.5-2.8c-0.2,0.2-0.4,0.3-0.5,0.4c-0.5,1.3-1.9,1.9-3.2,1.4c-0.1,0-0.1,0-0.2-0.1c-0.9-0.9-0.2-3.2-0.4-4.6c1.1,0,2.7-0.5,2.9,1.1c0,0,0.2,0.2,0.3,0.3c0.4-1.2,0.4-2.5,0-3.6c-0.8,1.5-1.6,1.6-3.4,1.4v-4.3c1.2,0,2.8-0.5,3,1.3c1,0.9,0.6-1.6,0.7-2.1H8.3c0.2,0.2,0.3,0.4,0.3,0.4c1.2,0,1.3,0.8,1.3,1.8c0,2.4,0,4.7,0,7.1C10,58.6,9.7,58.9,8.3,59.1z M45.9,59.4l0.2-0.2c-1.8-0.2-1.4-1.5-1.4-2.5c0.3-3.9-0.7-7.4-5-4.4v-1.1l-3,0.4c0,0.2,0.2,0.3,0.2,0.3c1,0,1.1,0.8,1.1,1.6c0,1.3,0,2.6,0,3.9c0,0.8,0,1.6-1.1,1.7c0,0.1,0,0.2,0,0.3h4.3c-1.7-0.9-0.9-3.4-1-5.9c0.2-0.8,0.9-1.3,1.7-1.1c0.7,0.1,1.1,0.7,1.1,1.4c0.1,0.8,0.1,1.6,0,2.4c0,1.1,0.5,2.4-0.9,3.1H45.9z M55.4,45.1c-1.5-0.5-1-1.7-1.1-2.6c0.3-3.4-0.6-6.3-4.5-3.9v-4.1L47,34.7L46.8,35c1.6,0,1.3,1.2,1.3,2.1c0,2,0,4,0,6c0,0.8,0,1.6-1,1.8v0.2h3.7c-0.4-0.4-0.9-0.6-0.9-0.9c-0.1-1.5-0.1-3,0-4.5c0-1.3,2.1-1.2,2.4,0c0,1.8,0.8,3.8-0.6,5.5L55.4,45.1z M51.3,59.7c5.4,0.2,5.3-8.6,0-8.5C46,51.2,45.9,59.9,51.3,59.7z M30.5,59.7c5.4,0.2,5.3-8.7,0-8.5S25.3,59.9,30.5,59.7z M43.3,35.4c1.1,0.2,2.5-0.4,2.8,1.3c0.1,0.1,0.2,0.2,0.3,0.2c0.5-0.3,0-1,0.2-1.5c0.2-0.5-0.2-0.9-0.9-0.9H38c0,0.9-0.3,1.7,0.2,2.4c0.3-0.4,0.6-1.2,1-1.3c0.7-0.1,1.4-0.2,2.1-0.2c0,2.6,0,5.1,0,7.5c0,0.9,0,1.7-1.2,1.8c0,0,0,0,0,0.3h4.6c-0.4-0.8-1.2,0-1.2-1.4L43.3,35.4z M58.1,41.1h4c0.3-0.1,0.5-0.2,0.6-0.5c0-1.3-0.8-2.5-2.1-2.8c-2-0.4-3.9,0.9-4.3,2.9c-0.1,0.7-0.1,1.3,0.1,2c0.4,1.8,2.3,2.9,4.1,2.5c0.9-0.2,1.7-0.8,2.1-1.6c-2.9,1.6-4.1,0.9-4.4-2.4H58.1z M84.1,52.4c-0.4-1.2-1.5-1.2-2.6-1.2c-1.3,0-2.5,1-2.5,2.4c0,0.9,0.5,1.8,1.3,2.2c0.7,0.8,2.4,1.2,2.1,2.6c-0.2,1.3-2.1,0.9-2.3-0.3c0-0.5-0.4-0.7-0.9-0.5c-0.5,0.2,0,1.7,0.3,1.8c0.8,0.2,1.7,0.3,2.6,0.3c1.3-0.2,2.2-1.4,2-2.8c-0.1-0.6-0.4-1.2-1-1.6c-0.7-0.4-1.3-0.9-1.9-1.4c-0.7-0.8-0.8-1.7,0.5-2c1.3-0.3,1.1,1,1.9,1.4L84.1,52.4z M88.7,52.6c1.9-0.2,1.9-0.2,1.8-1.1h-1.9v-2.1c-0.8,0-0.8,0-0.9,0.5c-0.5,1.7-1.2,1.2-2,2.1c0.3,0.3,0.5,0.5,1,0.5c0,1.7,0,3.4,0,5c0,1.6,3.4,3.1,4.1,1.1c-1.9,0-2.2,0-2.2-1.3c-0.1-1.3,0.2-3.2,0.2-4.8L88.7,52.6z M24.6,53.5c0-0.7,0.3-1.6-0.4-2c-2.5-0.7-5,0-5.5,2.8c-0.2,1-0.1,2.1,0.2,3.1c0.5,1.7,2.2,2.7,3.8,2.2c0.9-0.2,1.6-0.9,2-1.7h-0.2c-1.2,1.1-3.1,1.3-3.6-0.5c-0.5-1.8-0.9-5.2,1.5-5.5c0.8,0,1.1,0.5,1.2,1.2s0.5,0.6,1.1,0.3L24.6,53.5z M72.9,59.4h4.5c0-0.2,0-0.3-0.2-0.4c-0.9,0-1-0.7-1-1.4c0-2.2,0-4.3,0-6.5l-3.4,0.4c2.2,1.1,1.2,3,1.4,5.4c0,1,0,2-1.2,2.3L72.9,59.4z M76.2,48.5c0-1.5-2.4-1.5-2.3,0c0.2,0.6,0.9,0.9,1.5,0.7c0.3-0.1,0.6-0.4,0.7-0.7L76.2,48.5z"/><path class="cl58" d="M61.3,59.4h-4.1c0-0.2,0-0.3,0-0.3c1.2,0,1.2-1,1.2-1.9V54c0-1,0.2-2.1-1.4-2.3v-0.3l3-0.4V52c1.5-0.7,3.8-1.7,4.7,0.4c4.2-3.1,5.5-0.3,5.2,3.9c0,1.1-0.6,2.6,1.5,2.9L71,59.3h-3.8c1.3-0.7,0.8-2,0.9-3c0.1-1,0-1.8,0-2.6c0.1-0.7-0.5-1.4-1.2-1.5c-0.7-0.1-1.4,0.5-1.5,1.2c0,1.9-0.8,4.8,0.8,5.9h-3.8c1.5-2,0.8-4.1,0.6-6.2c-0.2-2.1-2.6-0.5-2.7,0.9c-0.1,0.9-0.1,1.9,0,2.8c0,0.9-0.2,1.9,1.1,2.3L61.3,59.4z"/><path class="cl58" d="M8.3,59.1c1.3-0.3,1.7-0.5,1.7-1.9c0-2.2,0-4.6,0-7.1c0-1,0-1.8-1.3-1.8c0,0,0,0-0.3-0.4H16c0,0.6,0.3,3-0.7,2.1c-0.2-1.8-1.9-1.2-3-1.3v4.3c1.6,0,2.4,0,3.4-1.4c0.4,1.2,0.4,2.5,0,3.6c0,0-0.3-0.2-0.3-0.3c-0.2-1.6-1.8-0.9-2.9-1.1c0.2,1.4-0.5,3.6,0.4,4.6c1.3,0.6,2.7,0,3.3-1.2c0-0.1,0-0.1,0.1-0.2c0-0.2,0.3-0.3,0.5-0.4c0.4,0.5,0.2,2.7-0.5,2.8H8.6C8.6,59.5,8.6,59.4,8.3,59.1z"/><path class="cl58" d="M45.9,59.4h-4c1.4-0.8,0.8-2.1,0.9-3.1c0.1-0.8,0.1-1.6,0-2.4c0-0.8-0.7-1.4-1.5-1.4c-0.7,0-1.3,0.5-1.4,1.1c0,2.4-0.7,5,1,5.9h-4.3c0-0.1,0-0.2,0-0.3c1.1,0,1.1-0.9,1.1-1.7c0-1.3,0-2.6,0-3.9c0-0.8,0-1.5-1.1-1.6c0,0,0,0-0.2-0.3l3-0.4v1.1c4.4-3,5.4,0.4,5,4.4c0,1-0.4,2.3,1.4,2.5L45.9,59.4z"/><path class="cl58" d="M55.4,45.1h-3.6c1.5-1.7,0.7-3.6,0.6-5.5c-0.3-1.2-2.3-1.3-2.4,0c-0.1,1.5-0.1,3,0,4.5c0,0.3,0.5,0.5,0.9,0.9h-3.8v-0.2c1-0.2,1-0.9,1-1.8c0-2,0-4,0-6c0-0.9,0.3-2-1.3-2.1l0.2-0.2l2.9-0.4v4.2c3.9-2.4,4.8,0.5,4.5,3.9C54.4,43.4,54.1,44.6,55.4,45.1z"/><path class="cl58" d="M51.3,59.7c-5.4,0.3-5.2-8.9,0-8.5S56.7,59.8,51.3,59.7z M53,57.6c0.9-1.9-0.6-8.1-3.4-5c-0.7,1.9-0.5,4,0.4,5.7c0.3,0.8,1.1,1.2,1.9,1C52.7,59.1,53.1,58.4,53,57.6z"/><path class="cl58" d="M30.5,59.7c-5.4,0.2-5.3-8.8,0-8.5S36,59.8,30.5,59.7z M28.8,54c-0.4,1.9,0.8,7.3,3.4,4.4c0.8-1.9,0.6-4-0.5-5.7C30.5,51.2,28.9,52.3,28.8,54z"/><path class="cl58" d="M43.4,35.4v8.2c0,1.2,0.9,0.6,1.2,1.4h-4.6v-0.3c1.2,0,1.2-0.9,1.2-1.8c0-2.4,0-4.9,0-7.5c-0.7,0-1.4,0.1-2.1,0.2c-0.4,0-0.7,0.9-1,1.3c-0.6-0.7-0.2-1.5-0.2-2.4h7.9c0.7,0,0.9,0.2,0.9,0.9c-0.1,0.6,0.2,1.2-0.2,1.5c-0.1,0-0.3-0.1-0.3-0.2C45.9,35,44.6,35.6,43.4,35.4z"/><path class="cl58" d="M58.2,41.1c0.2,3.4,1.5,4,4.5,2.4c-0.9,1.6-3,2.2-4.6,1.3c-0.8-0.5-1.4-1.2-1.6-2.1c-0.7-1.9,0.3-4,2.2-4.7c0.6-0.2,1.3-0.3,2-0.1c1.3,0.3,2.2,1.5,2.1,2.8c-0.1,0.3-0.3,0.4-0.6,0.5H58.2z M61.1,40.2c0-2.8-2.9-2.6-2.8,0.2L61.1,40.2z"/><path class="cl58" d="M84.2,52.4l-0.6,0.8c-0.8-0.3-0.9-1.6-1.9-1.4s-1.1,1.2-0.5,2c0.6,0.5,1.2,1,1.9,1.4c1.1,0.8,1.3,2.3,0.5,3.4c-0.4,0.5-1,0.9-1.6,1c-0.9,0-1.7-0.1-2.6-0.3c-0.4,0-0.6-1.6-0.3-1.8s0.8,0,0.9,0.5c0.2,1.2,1.9,1.1,2.3,0.3c0.2-1.7-2.9-2.3-3.4-4.2C78.5,51.1,83.3,50.1,84.2,52.4z"/><path class="cl58" d="M88.8,52.6c0,1.7,0,3.4,0,4.8s0.4,1.4,2.2,1.3c0,0.2,0,0.4-0.2,0.5c-4.8,2.4-4-3.8-4-6.7c-0.5,0-0.7-0.2-1-0.5c0.7-0.9,1.5-0.4,2-2.1c0.2-0.6,0.2-0.6,0.9-0.5v2.1h1.9C90.7,52.3,90.7,52.3,88.8,52.6z"/><path class="cl58" d="M24.8,53.5c-0.6,0.3-0.8,0-0.9-0.4c-0.1-0.4-0.4-1.2-1.2-1.2c-2.4,0.2-2,3.8-1.5,5.5s2.4,1.7,3.6,0.5H25c-0.7,1.6-2.6,2.3-4.1,1.6c-0.8-0.4-1.5-1.1-1.7-2c-0.3-1-0.4-2.1-0.2-3.1c0.5-2.9,3-3.5,5.5-2.8C25.1,51.8,24.7,52.8,24.8,53.5z"/><path class="cl58" d="M72.9,59.4v-0.2c1.3-0.2,1.2-1.3,1.2-2.3c-0.2-2.4,0.8-4.2-1.4-5.4l3.4-0.4c0,2.2,0,4.3,0,6.5c0,0.7,0,1.3,1,1.4c0.2,0,0.2,0,0.2,0.4H72.9z"/><path class="cl58" d="M76.1,48.5c-0.1,0.6-0.7,1-1.3,0.9c-0.5-0.1-0.9-0.5-0.9-0.9C73.8,47,76.2,47,76.1,48.5z"/><path class="cl57" d="M52.7,53.4c0.6,1.5,0.6,3.2,0,4.7c-2.5,3.4-4.3-3.1-3-5.5C50.8,51.1,52.4,51.9,52.7,53.4z"/><path class="cl57" d="M28.9,56.4c-0.3-1.5-0.4-3.8,1.2-4.5c2.7,0,3,4.5,2,6.3C30.5,60.2,29,58.2,28.9,56.4z"/><path class="cl57" d="M61.1,40.2l-2.8,0.2C58.1,37.6,60.9,37.4,61.1,40.2z"/>',
                                    at_sch: '<circle class="clt0" cx="11" cy="89" r="4.3"/><path class="clt1" d="M100,78v22l0,0H11c-6.1,0-11-5-11-11v0C0,83,5,78,11,78H100L100,78z"/><rect x="80.8" y="78" class="clt2" width="19.2" height="22"/><rect x="61.6" y="78" class="clt3" width="19.2" height="22"/><rect x="42.5" y="78" class="clt4" width="19.2" height="22"/><rect x="23.3" y="78" class="clt5" width="19.2" height="22"/><path class="clt6" d="M83.3,35.9l10.8,19.2l0,0L16.4,98.6c-5.3,3-12,1.1-15-4.2l0,0c-3-5.3-1.1-12,4.2-15L83.3,35.9L83.3,35.9z"/><rect x="70.7" y="39.2" transform="matrix(0.8725 -0.4887 0.4887 0.8725 -14.2707 45.6597)" class="clt7" width="19.2" height="22"/><rect x="54" y="48.5" transform="matrix(0.8725 -0.4887 0.4887 0.8725 -20.9912 38.6718)" class="clt8" width="19.2" height="22"/><rect x="37.3" y="57.9" transform="matrix(0.8725 -0.4887 0.4887 0.8725 -27.6765 31.7204)" class="clt9" width="19.2" height="22"/><rect x="20.6" y="67.3" transform="matrix(0.8725 -0.4887 0.4887 0.8725 -34.3969 24.7323)" class="clt10" width="19.2" height="22"/><path class="clt11" d="M47.7,7l18.8,11.4l0,0l-46,76.2c-3.1,5.2-9.9,6.9-15.1,3.7l0,0c-5.2-3.1-6.9-9.9-3.7-15.1L47.7,7L47.7,7z"/><rect x="42.5" y="9.9" transform="matrix(0.5171 -0.8559 0.8559 0.5171 7.2816 54.7253)" class="clt12" width="19.2" height="22"/><rect x="32.6" y="26.3" transform="matrix(0.5171 -0.8559 0.8559 0.5171 -11.5756 54.1644)" class="clt13" width="19.2" height="22"/><rect x="22.7" y="42.7" transform="matrix(0.5171 -0.8559 0.8559 0.5171 -30.334 53.6064)" class="clt14" width="19.2" height="22"/><rect x="12.8" y="59.1" transform="matrix(0.5171 -0.8559 0.8559 0.5171 -49.1912 53.0452)" class="clt15" width="19.2" height="22"/><circle class="clt0" cx="11" cy="89" r="4.3"/><path class="clt16" d="M0,0h22l0,0v89c0,6.1-5,11-11,11h0C5,100,0,95,0,89L0,0L0,0z"/><circle class="clt0" cx="11" cy="89" r="4.3"/><rect x="0" class="clt17" width="22" height="19.2"/><rect x="0" y="19.2" class="clt18" width="22" height="19.2"/><rect x="0" y="38.3" class="clt19" width="22" height="19.2"/><rect x="0" y="57.5" class="clt20" width="22" height="19.2"/>',
                                    cl_horizontal: '<g class="cxa"><line y1="6" x1="75" y2="6" x2="90" /><line y1="14" x1="75" y2="14" x2="90" /><line y1="6" x1="75" y2="14" x2="75" /><line y1="22" x1="65" y2="22" x2="90" /><line y1="30" x1="65" y2="30" x2="90" /><line y1="22" x1="65" y2="30" x2="65" /><line y1="10" x1="75" y2="10" x2="50" /><line y1="26" x1="65" y2="26" x2="50" /><line y1="10" x1="50" y2="26" x2="50" /><line y1="38" x1="50" y2="38" x2="90" /><line y1="46" x1="65" y2="46" x2="90" /><line y1="54" x1="65" y2="54" x2="90" /><line y1="46" x1="65" y2="54" x2="65" /><line y1="50" x1="65" y2="50" x2="50" /><line y1="38" x1="50" y2="50" x2="50" /><line y1="62" x1="65" y2="62" x2="90" /><line y1="70" x1="65" y2="70" x2="90" /><line y1="62" x1="65" y2="70" x2="65" /><line y1="44" x1="40" y2="44" x2="50" /><line y1="66" x1="40" y2="66" x2="65" /><line y1="44" x1="40" y2="66" x2="40" /><line y1="78" x1="55" y2="78" x2="90" /><line y1="86" x1="75" y2="86" x2="90" /><line y1="94" x1="75" y2="94" x2="90" /><line y1="86" x1="75" y2="94" x2="75" /><line y1="90" x1="55" y2="90" x2="75" /><line y1="78" x1="55" y2="90" x2="55" /><line y1="84" x1="25" y2="84" x2="55" /><line y1="55" x1="25" y2="55" x2="40" /><line y1="55" x1="25" y2="84" x2="25" /><line y1="18" x1="10" y2="18" x2="50" /><line y1="70" x1="10" y2="70" x2="25" /><line y1="18" x1="10" y2="70" x2="10" /><line y1="44" x1="10" y2="44" x2="0" /></g><g class="cxb"><rect y="5" x="96" width="2" height="2" /><rect y="13" x="96" width="2" height="2" /><rect y="21" x="96" width="2" height="2" /><rect y="29" x="96" width="2" height="2" /><rect y="37" x="96" width="2" height="2" /><rect y="45" x="96" width="2" height="2" /><rect y="53" x="96" width="2" height="2" /><rect y="61" x="96" width="2" height="2" /><rect y="69" x="96" width="2" height="2" /><rect y="78" x="96" width="2" height="2" /><rect y="86" x="96" width="2" height="2" /><rect y="94" x="96" width="2" height="2" /></g>',
                                    p_cg2fitcdf: '<g class="cxa"><path d="M15,90 C80,75 30,25 95,10" /></g>',
                                    ln_styledotted: '<g class="cxa"><line x1="4" y1="50" x2="98" y2="50" stroke-dasharray="5" /></g>',
                                    dps_width: '<g class="cxa"><rect x="2" y="2" width="96" height="96" /></g><path class="cxtxb" d="M71,38 L83,50 L71,62 M29,38 L17,50 L29,62 M83,50 L17,50" />',
                                    g_dashboard: '<g class="cxb"><path d="M 40.2 73.9 C 40.2 66.3 48.3 61.6 54.8 65.4 C 57.9 67.1 59.7 70.4 59.7 73.9"/><line x1="50" y1="33.3" x2="50" y2="41.5"/><line x1="72.3" y1="40" x2="67.8" y2="46.8"/><line x1="86.6" y1="56.5" x2="79.2" y2="59.9"/><line x1="27.6" y1="40" x2="32.1" y2="46.8"/><line x1="13.3" y1="56.5" x2="20.7" y2="59.9"/><line x1="47.1" y1="64.1" x2="41.2" y2="43.4"/></g><g class="cxa"><path d="M 50 26.2 C 23.6 26.2 2.3 47.5 2.3 73.9 L 97.7 73.9 C 97.7 47.5 76.3 26.2 50 26.2 Z"/></g>',
                                    ly_doe: '<g class="cxa"><rect x="2" y="2" width="43" height="43" /><rect x="53" y="2" width="43" height="43" /><rect x="2" y="53" width="43" height="43" /><circle cx="75" cy="75" r="20" /></g><g class="cxb"><rect x="9" y="20" width="10" height="24" /><rect x="28" y="10" width="10" height="34" /><polyline points="60,40 70,20 80,30 90,10" /><circle cx="15" cy="82" r="2" /><circle cx="26" cy="75" r="2" /><circle cx="36" cy="65" r="2" /><line x1="75" y1="75" x2="75" y2="55" /><line x1="75" y1="75" x2="95" y2="75" /><line x1="75" y1="75" x2="61" y2="86" /></g>',
                                    g_sankey: '<g class="cxcc"><path d="M 88.1 57.9 L 88.1 57.9 C 76.8 57.9 66.1 52.9 58.7 44.3 L 42.4 25.1 C 35 16.5 24.3 11.6 13 11.6 L 12 11.6 L 12 42.1 L 13 42.1 C 24.3 42.2 35.1 47.1 42.4 55.8 L 58.7 74.9 C 66.1 83.6 76.8 88.5 88.1 88.5 L 88.1 88.5 L 88.1 57.9"/></g><g class="cxb"><rect x="2" y="11.5" width="10" height="30.6"/><rect x="88.1" y="57.9" width="10" height="30.6"/><path d="M 12 11.6 L 12 11.6 C 23.4 11.6 34.1 16.5 41.4 25.1 L 57.8 44.3 C 65.1 52.9 75.9 57.9 87.2 57.9 L 88.1 57.9"/><path d="M 12 42.1 L 12 42.1 C 23.4 42.2 34.1 47.1 41.4 55.8 L 57.8 74.9 C 65.1 83.6 75.9 88.5 87.2 88.5 L 88.1 88.5"/></g><g class="cxa"><rect x="2" y="57.9" width="10" height="30.6"/><rect x="88.1" y="11.5" width="10" height="30.6"/><path d="M 12 57.9 L 12 57.9 C 23.4 57.9 34.1 52.9 41.4 44.3 L 57.8 25.1 C 65.1 16.5 75.9 11.6 87.2 11.6 L 88.1 11.6 L 88.1 42.1 L 87.2 42.1 C 75.8 42.2 65.1 47.1 57.8 55.8 L 41.4 74.9 C 34.1 83.6 23.4 88.5 12 88.5 L 12 88.5 L 12 57.9"/></g>',
                                    p_g2axes: '<g class="cxblue"><line x1="25" y1="65" x2="95" y2="65" /><line x1="25" y1="65" x2="25" y2="75" /><line x1="45" y1="65" x2="45" y2="75" /><line x1="65" y1="65" x2="65" y2="75" /><line x1="85" y1="65" x2="85" y2="75" /><line x1="25" y1="15" x2="25" y2="75" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /></g>',
                                    sp_farther: '<path class="cxtxa" d="M90,2 L98,10 L90,18 M98,10 L58,10" /><path class="cxtxa" d="M10,2 L2,10 L10,18 M42,10 L2,10" /><g class="cxb"><rect x="9" y="36" width="18" height="62" /><rect x="42" y="36" width="18" height="62" /><rect x="77" y="36" width="18" height="62" /></g>',
                                    g_stacked: '<g class="cxcc"><rect x="76.7" y="47.3" width="14.9" height="25.8"/><rect x="49.7" y="39.1" width="14.9" height="25.8"/><rect x="23.2" y="61.7" width="14.9" height="14.9"/></g><g class="cxbb"><rect x="22.4" y="73.1" width="14.9" height="12.9"/><rect x="49.7" y="64.9" width="14.9" height="21.1"/><rect x="76.7" y="73.1" width="14.9" height="12.9"/></g><g class="cxb"><rect x="22.4" y="50" width="15.6" height="36"/><rect x="49.4" y="15.6" width="15.6" height="70.4"/><rect x="76.4" y="27.4" width="15.6" height="58.5"/><line x1="50" y1="39.1" x2="64.9" y2="39.1"/><line x1="50" y1="64.9" x2="64.9" y2="64.9"/><line x1="76.7" y1="47.3" x2="91.6" y2="47.3"/><line x1="76.7" y1="73.1" x2="91.6" y2="73.1"/><line x1="22.4" y1="62.6" x2="37.9" y2="62.6"/><line x1="22.4" y1="73.1" x2="37.9" y2="73.1"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g>',
                                    z_in: '<g class="cxaa"><text class="cxtn60" x="15" y="50">+</text></g><g class="cxb"><circle cx="35" cy="35" r="33" /><line x1="60" y1="60" x2="99" y2="99" /></g>',
                                    p_cghdata2: '<g class="cxbb"><rect x="72" y="4" width="26" height="18"/><rect x="12" y="26" width="26" height="18"/><rect x="42" y="48" width="26" height="18"/></g>',
                                    sl_radiooff: '<circle class="cxb" cx="50" cy="50" r="35" />',
                                    g_correlation: '<g class="cxb"><line x1="76.6" y1="22.6" x2="36.7" y2="63.9"/><line x1="23.4" y1="22.6" x2="63.3" y2="63.9"/><line x1="50" y1="22.6" x2="76.2" y2="51"/><line x1="50" y1="22.6" x2="23.8" y2="51"/><line x1="76.6" y1="22.6" x2="90.8" y2="36.8"/><line x1="23.4" y1="22.6" x2="9.9" y2="36.8"/></g><g class="cxa"><polygon points="50 22.6 1.9 22.6 1.9 28.8 50 77.4 98.1 28.8 98.1 22.6 50 22.6"/></g>',
                                    g_bar: '<g class="cxb"> <rect x="23.4" y="55.7" width="15.2" height="30.3" /><rect x="50.3" y="15.6" width="15.2" height="70.4" /><rect x="77.2" y="30.1" width="15.2" height="56" /></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g>',
                                    ga_axisxy: '<g class="cxb"><line x1="15" y1="2" x2="15" y2="98" /><line x1="15" y1="2" x2="0" y2="17" /><line x1="15" y1="2" x2="30" y2="17" /><line x1="2" y1="85" x2="98" y2="85" /><line x1="83" y1="70" x2="98" y2="85" /><line x1="83" y1="100" x2="98" y2="85" /></g><text class="cxtn30 cxaa" x="30" y="25">X</text><text class="cxtn30 cxaa" x="65" y="70">Y</text>',
                                    ch_ln: '<text class="cxtb100" x="15" y="85">N</text>',
                                    ar_rm: '<path class="cxtxb" d="M71,38 L83,50 L71,62 M83,50 L17,50" />',
                                    o_ghsmps: '<g class="cxc"><rect y="15" x="58" height="70" width="40" /><line y1="15" x1="78" y2="85" x2="78" /><line y1="50" x1="98" y2="50" x2="58" /><rect y="95" x="94" width="2" height="4" /><rect y="95" x="74" width="2" height="4" /><rect y="20" x="45" width="2" height="20" /><rect y="60" x="45" width="2" height="20" /></g><g class="cxa"><rect y="15" x="4" width="28" height="70" /><line y1="15" x1="18" y2="85" x2="18" /><line y1="50" x1="32" y2="50" x2="4" /><rect y="2" x="25" width="2" height="2" /><rect y="2" x="11" width="2" height="2" /></g>',
                                    tx_stringnumeric: '<text class="cxtn60" x="0" y="65">a</text><text class="cxtn60" x="65" y="70">#</text><g class="cxaa"><text class="cxtn60" x="20" y="30">&#10554;</text><text class="cxtn60" x="20" y="100">&#10555;</text></g>',
                                    i_left: '<rect fill="url(\'#r-grad\')" x="2" y="25" width="48" height="50"/>',
                                    bx_meanc: '<g class="cxb"><rect x="30" y="20" width="40" height="60" /><line x1="30" y1="50" x2="70" y2="50" /><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g><g class="cxa"><rect x="40" y="40" width="20" height="20" /></g>',
                                    ch_ccommand: '<text class="cxtb100" x="5" y="85">&#8984;</text>',
                                    ln_styledashed: '<g class="cxa"><line x1="4" y1="50" x2="98" y2="50" stroke-dasharray="15 5" /></g>',
                                    c_nodejs: '<g class="cxb"><line x1="10.3" y1="24.2" x2="50.6" y2="98" /><line x1="24" y1="49.2" x2="9.3" y2="75.1" /><line x1="89.9" y1="75.7" x2="49.3" y2="1.9" /><line x1="76.1" y1="49.9" x2="90.9" y2="24.2" /></g><path class="cxa" d="M 7.7 28.6 L 7.7 71.4 C 7.8 73.3 8.8 75 10.4 75.9 L 47.6 97.4 C 49.1 98.3 51.1 98.3 52.7 97.4 L 89.9 75.9 C 91.5 75 92.4 73.3 92.4 71.4 L 92.4 28.6 C 92.4 26.8 91.5 25.1 89.9 24.2 L 52.6 2.6 C 51 1.7 49 1.7 47.4 2.6 L 10.3 24.2 C 8.7 25.1 7.8 26.8 7.7 28.6 Z" />',
                                    ch_lk: '<text class="cxtb100" x="15" y="85">K</text>',
                                    p_cghdata1: '<g class="cxcc"><rect x="12" y="4" width="26" height="18"/><rect x="12" y="70" width="26" height="18"/><rect x="42" y="26" width="26" height="18"/><rect x="72" y="48" width="26" height="18"/><rect x="72" y="70" width="26" height="18"/></g>',
                                    c_codepen: '<g class="cxb"><polyline points="96.1 26 80.6 50 96.1 73.8" /><line x1="50" y1="2" x2="50" y2="35.8" /><line x1="80.6" y1="50" x2="64.2" y2="50" /><polyline points="3.9 26 19.4 50 3.9 73.8" /><line x1="19.4" y1="50" x2="35.9" y2="50" /><line x1="50" y1="98" x2="50" y2="64.1" /></g><g class="cxa"><polygon points="96.1 73.8 96.1 26 50 2 3.9 26 3.9 73.8 50 98 96.1 73.8" /><rect x="35.9" y="35.8" width="28.3" height="28.3" /></g>',
                                    bx_wishkers: '<g class="cxb"><rect x="2" y="30" width="20" height="40" /><line x1="2" y1="51" x2="22" y2="51" /><rect x="78" y="30" width="20" height="40" /><line x1="78" y1="51" x2="98" y2="51" /></g><g class="cxa"><line x1="2" y1="2" x2="22" y2="2" /><line x1="12" y1="2" x2="12" y2="30" /><line x1="12" y1="70" x2="12" y2="98" /><line x1="2" y1="98" x2="22" y2="98" /></g><path class="cxtxa" d="M56,44 L64,52 L56,60 M40,44 L32,52 L40,60 M64,52 L32,52" />',
                                    ch_ls: '<text class="cxtb100" x="15" y="85">S</text>',
                                    h_hcell: '<g class="cxa"><rect x="42" y="26" width="26" height="18"/></g>',
                                    ar_tl: '<path class="cxtxb" d="M2,22 L2,2 L22,2 M2,2 L98,98" />',
                                    wp_audittrail: '<g class="cxa"><circle cx="59.6" cy="57.7" r="27.9"/><line x1="79.3" y1="77.5" x2="98.1" y2="96.2"/></g><g class="cxa"><polyline points="33.2 66.4 1.9 66.4 1.9 3.9 68.3 3.9 68.3 31.3"/></g><g class="cxb"><line x1="12.1" y1="15.5" x2="12.1" y2="23.9"/><line x1="23.6" y1="15.5" x2="23.6" y2="23.9"/><line x1="35.1" y1="15.5" x2="35.1" y2="23.9"/><line x1="46.7" y1="15.5" x2="46.7" y2="23.9"/><line x1="58.1" y1="15.5" x2="58.1" y2="23.9"/><line x1="12.1" y1="30.9" x2="12.1" y2="39.4"/><line x1="23.6" y1="30.9" x2="23.6" y2="39.4"/><line x1="12.1" y1="46.4" x2="12.1" y2="54.9"/><line x1="23.6" y1="46.4" x2="23.6" y2="54.9"/></g>',
                                    ch_lj: '<text class="cxtb100" x="20" y="85">J</text>',
                                    op_config: '<g class="cxa"><circle cx="70.8" cy="37.6" r="8.9"/><path d="M97.5,41.8v-8.6L90,31.9c-0.4-1.3-0.9-2.5-1.5-3.7l4.3-6.2l-6.1-6.1l-6.1,4.3c-1.3-0.7-2.6-1.3-4-1.7l-1.3-7.2h-8.6l-1.2,7c-1.5,0.4-3,0.9-4.4,1.7l-5.7-4L49.5,22l3.9,5.6c-0.8,1.4-1.4,3-1.9,4.5l-6.7,1.1v8.6l6.7,1.2c0.4,1.6,1.1,3.1,1.9,4.5l-3.9,5.6l6.1,6.1l5.7-4c1.4,0.7,2.8,1.3,4.4,1.7l1.2,7h8.6l1.3-7.2c1.4-0.4,2.7-1,4-1.7l6.1,4.3l6.1-6.1l-4.3-6.1c0.6-1.2,1.2-2.5,1.5-3.8L97.5,41.8z"/></g><g class="cxb"><circle cx="24.6" cy="66.4" r="7.5"/><path d="M47.4,70v-7.3L41,61.6c-0.3-1.1-0.7-2.2-1.3-3.2l3.7-5.3l-5.2-5.2L33,51.5c-1.1-0.6-2.2-1.1-3.4-1.5l-1.1-6.2h-7.3l-1,6c-1.3,0.3-2.5,0.8-3.7,1.4l-4.8-3.4l-5.2,5.2l3.4,4.8c-0.7,1.2-1.3,2.5-1.6,3.8l-5.7,1V70l5.7,1c0.4,1.3,0.9,2.6,1.6,3.8l-3.4,4.8l5.3,5.2l4.7-3.4c1.2,0.6,2.4,1.1,3.7,1.4l1,5.9h7.3l1.1-6.1c1.2-0.3,2.3-0.8,3.4-1.5l5.2,3.6l5.2-5.2l-3.7-5.3c0.6-1,1-2.1,1.3-3.2L47.4,70z"/></g>',
                                    ps_bottomright: '<path class="cxtxb" d="M66,58 L66,66 L56,66 M34,34 L66,66" /><g class="cxa"><rect x="78" y="78" width="20" height="20" rx="2" /></g>',
                                    cr_bezier: '<g class="cxa"><path d="M1,99 C25,25 75,75 99,1" /></g>',
                                    ch_capple: '<text class="cxtb100" x="10" y="85">&#63743;</text>',
                                    ar_minmax: '<path class="cxtxb" d="M2,22 L2,2 L22,2 M28,45 L45,45 L48,28 M2,2 L45,45" /><path class="cxtxb" d="M25,55 L45,55 L45,75 M2,78 L2,98 L22,98 M2,98 L45,55" /><path class="cxtxb" d="M78,98 L98,98 L98,78 M55,75 L55,55 L75,55 M98,98 L55,55" /><path class="cxtxb" d="M55,25 L55,45 L75,45 M78,2 L98,2 L98,22 M98,2 L55,45" />',
                                    sp_thinner: '<path class="cxtxa" d="M30,42 L22,50 L30,58 M62,50 L22,50" /><g class="cxa"><rect x="2" y="2" width="10" height="96" /></g><g class="cxb"><rect x="72" y="2" width="26" height="96" /></g>',
                                    c_r: '<g class="cxb"><path d="M 40.1 72.2 C 19.2 69.5 3.5 58.7 3.5 45.5 C 3.5 30.5 24.3 18.3 50.1 18.3 C 75.7 18.3 96.5 30.5 96.5 45.5 C 96.5 53.4 90.9 60.4 81.9 65.4" /><path d="M 68.7 70.6 C 64.8 71.6 60.7 72.3 56.7 72.6" /><path d="M 40.1 63.1 C 29.5 59.9 22.4 54 22.4 47.2 C 22.4 37.2 37.8 29.1 56.8 29.1 C 62.7 29.1 68.6 29.9 74.2 31.6 C 77.3 32.7 80.2 34 83 35.5" /></g><path class="cxa" d="M 80.2 62.8 C 91 60.6 95.6 47.6 88.3 39.2 C 85.6 36.1 81.5 34.3 77.4 34.3 L 40.1 34.3 L 40.1 81.7 L 56.7 81.7 L 56.7 63.1 L 63.8 63.1 L 75.9 81.7 L 92.5 81.7 Z M 70.4 54.3 L 55.9 54.3 L 55.9 43.2 L 70.4 43.2 C 74.6 42.8 77.7 47.2 75.9 51.1 C 74.9 53.2 72.8 54.5 70.4 54.3 Z" />',
                                    c_canvasxpress: '<path fill="url(\'#cx-grad1\')" d="M 1.7 54.9 C 1.7 54.9 9.7 23.4 23.2 20.4 C 36.8 17.4 37.2 45.4 58.6 45.2 C 79.8 45 1.7 54.9 1.7 54.9 Z" /><path fill="url(\'#cx-grad2\')" d="M 71.8 54.9 C 71.8 54.9 59.4 26.9 50.8 27.6 C 42.2 28.4 41.8 36.3 24.2 45.1 C 6.6 53.9 1.7 54.9 1.7 54.9 L 71.8 54.9 Z" /><path fill="url(\'#cx-grad3\')" d="M 1.7 54.9 L 98 54.9 C 98 54.9 89.7 31.9 74.2 32.7 C 58.9 33.4 65.4 45.9 1.7 54.9 Z" /><g class="cxblack"><path d="M 12 71.9 C 11.5 74.2 9.4 75.7 7.2 75.5 C 3.5 75.4 1.7 72.9 1.7 69.5 C 1.4 66.6 3.6 63.9 6.6 63.7 C 6.8 63.7 7 63.7 7.1 63.7 C 9.4 63.4 11.5 65 11.8 67.3 L 9.8 67.3 C 9.5 66.1 8.4 65.2 7.1 65.3 C 4.8 65.3 3.9 67.3 3.9 69.4 C 3.9 71.7 4.7 73.6 7.2 73.6 C 8.5 73.7 9.6 72.8 9.8 71.6 L 12 71.9 Z" /><path d="M 19.6 73.2 C 19.6 73.9 19.7 74.7 19.8 75.3 L 17.7 75.3 C 17.6 75 17.6 74.7 17.6 74.4 C 17.1 75.2 16.1 75.6 15.1 75.5 C 13.7 75.7 12.3 74.7 12.1 73.2 C 12.1 73.1 12.1 73 12.1 72.9 C 12.1 70.9 13.8 70 16.2 70 L 17.5 70 L 17.5 69.4 C 17.5 68.8 17.3 68.1 16 68.1 C 14.6 68.1 14.6 68.6 14.4 69.3 L 12.4 69.3 C 12.5 67.8 13.4 66.6 16.1 66.6 C 18.4 66.6 19.7 67.4 19.7 69.4 L 19.6 73.2 Z M 17.5 71.3 L 16.4 71.3 C 14.8 71.3 14.2 71.8 14.2 72.7 C 14.2 73.4 14.6 74 15.4 74.1 C 15.5 74.1 15.5 74.1 15.6 74.1 C 17.3 74.1 17.6 72.9 17.6 71.6 L 17.5 71.3 L 17.5 71.3 Z" /><path d="M 20.7 68.9 C 20.7 68.1 20.7 67.3 20.7 66.6 L 22.8 66.6 C 22.8 67 22.8 67.4 22.8 67.9 C 23.2 66.9 24.3 66.4 25.4 66.5 C 27.1 66.5 28.3 67.6 28.3 69.8 L 28.3 75.2 L 26.2 75.2 L 26.2 70 C 26.2 69 25.8 68.2 24.7 68.2 C 23.5 68.2 22.8 69 22.8 70.6 L 22.8 75.3 L 20.7 75.3 L 20.7 68.9 Z" /><path d="M 30.7 66.7 C 31.6 69.9 32.4 72.4 32.6 73.5 L 32.6 73.5 C 32.9 72.2 33.8 69.6 34.6 66.7 L 36.7 66.7 L 33.5 75.3 L 31.3 75.3 L 28.4 66.7 L 30.7 66.7 Z" /><path d="M 44.2 73.2 C 44.2 73.9 44.2 74.7 44.3 75.3 L 42.3 75.3 C 42.2 75 42.2 74.7 42.2 74.4 C 41.6 75.2 40.6 75.6 39.6 75.5 C 38.2 75.7 36.8 74.7 36.7 73.2 C 36.7 73.1 36.7 73 36.7 72.8 C 36.7 70.8 38.2 69.9 40.7 69.9 L 42.1 69.9 L 42.1 69.4 C 42.1 68.7 41.8 68 40.5 68 C 39.3 68 39.1 68.6 39 69.2 L 36.9 69.2 C 37 67.7 38 66.5 40.6 66.5 C 43.2 66.5 44.2 67.3 44.2 69.4 L 44.2 73.2 Z M 42.2 71.3 L 41 71.3 C 39.5 71.3 38.8 71.8 38.8 72.7 C 38.8 73.4 39.3 74 40 74.1 C 40.1 74.1 40.1 74.1 40.2 74.1 C 42 74.1 42.3 72.9 42.3 71.6 L 42.2 71.3 Z" /><path d="M 46.8 72.8 C 47 73.6 47.8 74.2 48.6 74.1 C 49.7 74.1 50.1 73.7 50.1 73.1 C 50.1 72.5 49.7 72.2 48.3 71.9 C 45.5 71.2 45.1 70.3 45.1 69.2 C 45.1 68 45.9 66.6 48.5 66.6 C 51 66.6 52 67.9 52.1 69.2 L 50 69.2 C 50 68.8 49.6 68.1 48.3 68.1 C 47.1 68.1 47.1 68.6 47.1 69 C 47.1 69.4 47.4 69.7 48.8 70 C 51.7 70.7 52.1 71.7 52.1 72.9 C 52.1 74.2 50.9 75.6 48.4 75.6 C 45.9 75.6 44.8 74.4 44.6 72.8 L 46.8 72.8 Z" /><path d="M 59.2 76 L 56.4 71.8 L 56.4 71.8 L 50.8 79.8 L 48.3 79.8 L 55.1 70.2 L 51.2 64.5 L 53.8 64.5 L 56.5 68.5 L 56.5 68.5 L 60.4 62.8 L 62.8 62.8 L 57.7 69.9 L 61.7 75.9 L 59.2 76 Z" /><path d="M 63.9 74.6 L 63.9 78.7 L 61.8 78.7 L 61.8 68.9 C 61.8 68.2 61.8 67.4 61.8 66.7 L 63.8 66.7 C 63.8 67.1 63.8 67.5 63.8 67.9 C 64.4 66.9 65.3 66.5 66.4 66.6 C 68.4 66.6 70 68.2 70 70.8 C 70 73.9 68.2 75.5 66.1 75.5 C 65.1 75.6 64.4 75.2 63.9 74.6 Z M 67.9 71 C 67.9 69.4 67.2 68.3 65.9 68.3 C 64.7 68.3 63.9 69.3 63.9 71.1 C 63.9 72.9 64.4 74 65.9 74 C 67.5 74 67.9 72.8 67.9 71 L 67.9 71 Z" /><path d="M 70.3 69.2 C 70.3 68.2 70.3 67.4 70.3 66.8 L 72.2 66.8 C 72.2 67.4 72.2 67.9 72.2 68.5 C 72.7 67.3 73.8 66.6 75.1 66.6 L 75.1 68.6 C 73.4 68.6 72.2 69.2 72.2 71.5 L 72.2 75.3 L 70.3 75.3 L 70.3 69.2 Z" /><path d="M 77 71.5 C 77 72.8 77.7 73.9 79 73.9 C 79.8 74 80.5 73.5 80.8 72.8 L 82.8 72.8 C 82.3 74.6 80.7 75.7 78.9 75.5 C 76.6 75.5 74.9 73.8 74.9 71.6 C 74.9 71.4 74.9 71.3 74.9 71.1 C 74.9 68.4 76.2 66.6 79 66.6 C 81.1 66.5 82.9 68 82.9 70.1 C 82.9 70.3 82.9 70.6 82.9 70.8 C 82.9 71 82.9 71.3 82.9 71.5 L 77 71.5 L 77 71.5 Z M 80.7 70.1 C 80.7 69 80.2 68 78.9 68 C 77.5 68 77 68.9 76.8 70.1 L 80.7 70.1 Z" /><path d="M 85.2 72.8 C 85.4 73.6 86.2 74.2 87.1 74.1 C 88.1 74.1 88.5 73.7 88.5 73.1 C 88.5 72.5 88.1 72.2 86.7 71.9 C 84 71.2 83.4 70.3 83.4 69.2 C 83.4 68 84.4 66.6 86.9 66.6 C 89.4 66.6 90.3 67.9 90.4 69.2 L 88.4 69.2 C 88.3 68.8 88 68.1 86.8 68.1 C 85.5 68.1 85.5 68.6 85.5 69 C 85.5 69.4 85.8 69.7 87.4 70 C 90.2 70.7 90.6 71.7 90.6 72.9 C 90.6 74.2 89.5 75.6 87 75.6 C 84.5 75.6 83.3 74.4 83.1 72.8 L 85.2 72.8 Z" /><path d="M 93 72.8 C 93.1 73.6 93.9 74.2 94.8 74.1 C 95.9 74.1 96.2 73.7 96.2 73.1 C 96.2 72.5 95.9 72.2 94.5 71.9 C 91.7 71.2 91.2 70.3 91.2 69.2 C 91.2 68 92.1 66.6 94.7 66.6 C 97.3 66.6 98.2 67.9 98.3 69.2 L 96.2 69.2 C 96.2 68.8 95.9 68.1 94.6 68.1 C 93.3 68.1 93.3 68.6 93.3 69 C 93.3 69.4 93.6 69.7 95.1 70 C 98 70.7 98.4 71.7 98.4 72.9 C 98.4 74.2 97.2 75.6 94.7 75.6 C 92.2 75.6 91 74.4 90.8 72.8 L 93 72.8 Z" /></g>',
                                    g_radar: '<g class="cxcc"><polygon points="50 24.6 20.4 44.5 31.4 81.2 71.2 83.5 90.7 41.3 50 24.6"/></g><g class="cxb"><polyline points="50 4.5 50 53.1 97.8 39.2"/><polyline points="79.5 95.5 50 53.1 20.4 95.5"/><line x1="2.2" y1="39.2" x2="50" y2="53.1"/></g><g class="cxa"><polygon points="50 4.5 2.2 39.2 20.4 95.5 79.5 95.5 97.8 39.2 50 4.5"/></g>',
                                    g_bubble: '<g class="cxa"><circle cx="50" cy="50" r="47.4"/><circle cx="63.6" cy="65.7" r="10.7"/><circle cx="36.4" cy="36" r="11.3"/><circle cx="35.6" cy="82.2" r="5.8"/><circle cx="82" cy="41.6" r="4.6"/></g><g class="cxb"><circle cx="37.2" cy="35.3" r="20"/><circle cx="63.6" cy="65.7" r="20"/><circle cx="67.8" cy="25.7" r="10.7"/><circle cx="21" cy="61.9" r="10.7"/></g>',
                                    ar_bls: '<path class="cxtxb" d="M34,58 L34,66 L42,66 M34,66 L66,34" />',
                                    cd_params: '<g class="cxaa"><text class="cxtn40" x="10" y="20">...</text><text class="cxtn40" x="10" y="40">...,</text><text class="cxtn40" x="10" y="80">{ }</text></g>',
                                    sv_video: '<g class="cxa"><rect x="2" y="20" width="70" height="60" rx="4" /></g><g class="cxb"><polyline points="70,40 98,30 98,70 70,60" /></g>',
                                    v_last: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn60" x="25" y="73">&#9654;</text><rect x="55" y="25" width="18" height="50" />',
                                    c_python: '<g class="cxb"><path d="M 72.7 72.2 L 72.7 86.2 C 72.7 92.8 67.4 98 60.8 98 L 35.9 98 C 29.5 98 24.2 92.8 24.2 86.2 L 24.2 61.4 C 24.2 55 29.5 49.8 35.9 49.8 L 64 49.8 C 70.5 49.8 75.8 44.5 75.8 38 L 75.8 23.8 L 80.4 23.8 C 90.1 23.9 98 31.7 98.1 41.4 L 98.1 54.3 C 98.1 64.1 90.1 72.1 80.2 72 Z" /><line x1="72.8" y1="72.3" x2="50.2" y2="72.3" /></g><circle class="cxbb" cx="60" cy="85.8" r="4.3" /><g class="cxa"><path d="M 27.4 27.7 L 27.4 13.7 C 27.4 7.2 32.8 1.9 39.1 1.9 L 64.1 1.9 C 70.6 1.9 76 7.2 76 13.7 L 76 38.3 C 76 44.8 70.6 50.1 64.1 50.1 L 35.7 50.1 C 29.5 50.1 24.3 55.2 24.3 61.4 L 24.3 76.2 L 19.6 76.2 C 9.9 76.2 1.9 68.3 1.8 58.5 L 1.8 45.5 C 1.8 35.6 9.9 27.7 19.6 27.7 Z" /><line x1="27.4" y1="27.7" x2="50" y2="27.7" /></g><circle class="cxaa" cx="39.9" cy="14.3" r="4.3" />',
                                    wp_license: '<g class="cxa"><polygon points="90.1 56.9 97.7 49.1 89.6 40.9 93.7 30.9 83.2 26.4 83.2 15.6 71.6 15.6 67.3 5.5 56.9 9.8 49.1 2.3 40.9 10.5 30.9 6.2 26.4 16.8 15.6 16.8 15.6 28.4 5.5 32.6 9.8 43.1 2.3 50.7 10.5 58.9 6.2 69.1 16.8 73.5 16.8 84.3 28.4 84.3 32.6 94.5 43.1 90.1 50.7 97.7 58.9 89.6 69.1 93.7 73.5 83.2 84.3 83.2 84.3 71.6 94.5 67.3 90.1 56.9" /></g>',
                                    p_g2title: '<g class="cxblue"><rect x="45" y="0" width="30" height="2"/></g>',
                                    ch_ly: '<text class="cxtb100" x="15" y="85">Y</text>',
                                    c_rrc: '<path fill="url(\'#rr-grad\')" d="M 50 16 C 22.4 16 0 32.1 0 52.1 C 0 72.1 22.4 88.2 50 88.2 C 77.6 88.2 100 72.1 100 52.1 C 100 32.1 77.6 16 50 16 Z M 56.3 76.5 C 35.8 76.5 19.1 65.5 19.1 52.2 C 19.1 38.9 35.8 27.9 56.3 27.9 C 76.8 27.9 93.5 38.8 93.5 52.2 C 93.5 65.6 76.9 76.5 56.3 76.5 Z"/><path class="clr" d="M 80.6 73.4 C 85.8 72.1 89.2 65.9 88.1 59.5 C 87.2 54 83.2 50 78.6 50 L 53.8 50 L 53.8 89 L 64.8 89 L 64.8 73.7 L 69.6 73.7 L 77.8 89 L 88.8 89 L 80.6 73.4 Z M 74 66.4 L 64.3 66.4 L 64.3 57.3 L 74 57.3 C 76.2 57.3 78 59.1 78 61.3 C 78 61.4 78 61.4 78 61.5 C 78.4 63.8 76.9 66 74.6 66.5 C 74.5 66.5 74.3 66.5 74 66.4 Z"/><path class="clr" d="M 38.7 34.4 C 43.9 33.1 47.3 26.9 46.2 20.5 C 45.3 15 41.3 11 36.7 11 L 11.9 11 L 11.9 50 L 22.9 50 L 22.9 34.7 L 27.7 34.7 L 35.9 50 L 46.9 50 L 38.7 34.4 Z M 32.1 27.4 L 22.4 27.4 L 22.4 18.3 L 32.1 18.3 C 34.3 18.3 36.1 20.1 36.1 22.3 C 36.1 22.4 36.1 22.4 36.1 22.5 C 36.5 24.8 35 27 32.7 27.5 C 32.6 27.5 32.4 27.5 32.1 27.4 Z"/>',
                                    cl_verticalbg: '<g class="cxcc"><rect x="0" y="0" width="33" height="100" /><rect x="67" y="0" width="33" height="100" /></g>',
                                    b_grvt: '<g class="cxa"><rect fill="url(\'#vt-grad\')" x="0" y="0" width="100" height="100" /></g>',
                                    h_hsample: '<g class="cxa"><rect x="12" y="26" width="26" height="18"/><rect x="42" y="26" width="26" height="18"/><rect x="72" y="26" width="26" height="18"/></g>',
                                    dummy: "",
                                    sv_image: '<g class="cxa"><path d="M60,7 L70,17 L90,17 Q 98,17 98,26 L98,74 Q 98,84 90,84 L10,84 Q 2,84 2,74 L2,24 Q 2,17 10,17 L30,17 L40,7 Z" /></g><g class="cxb"><circle cx="50" cy="50" r="15" /><circle cx="50" cy="50" r="25" /><line x1="10" y1="8" x2="25" y2="8" /><line x1="10" y1="27" x2="25" y2="27" /></g>',
                                    tb_stripped: '<g class="cxcc"><rect x="2" y="26" width="96" height="24" /><rect x="2" y="74" width="96" height="24" /></g><g class="cxb"><line x1="2" y1="26" x2="98" y2="26" /><line x1="2" y1="50" x2="98" y2="50" /><line x1="2" y1="74" x2="98" y2="74" /><line x1="34" y1="26" x2="34" y2="98" /><line x1="66" y1="26" x2="66" y2="98" /></g><g class="cxa"><rect x="2" y="2" width="96" height="96" /><rect x="12" y="12" width="3" height="3" /><rect x="24" y="12" width="3" height="3" /><rect x="36" y="12" width="3" height="3" /></g>',
                                    b_gsori: '<g class="cxa"><rect fill="url(\'#go-gradv\')" x="1" y="1" width="42" height="42"/><rect fill="url(\'#go-gradh\')" x="57" y="57" width="42" height="42"/></g>',
                                    v_plus: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtb100" x="20" y="77">+</text>',
                                    p_g1subtitle: '<g class="cxblue"><rect x="50" y="10" width="10" height="2"/></g>',
                                    sr_aai: '<path class="cxtxa" d="M80,2 L98,17 L80,33 M98,17 L2,17" /><text class="cxtn60" x="0" y="90">a</text><text class="cxtn100" x="35" y="90">a</text>',
                                    rt_ac2: '<g class="cxb"><path d=" M 18 18 A 45 45 45 0 1 95 50" /><line x1="18" y1="0" x2="18" y2="18" /><line x1="36" y1="18" x2="16" y2="18" /><path d=" M 82 82 A 45 45 225 0 1 5 50" /><line x1="64" y1="82" x2="84" y2="82" /><line x1="82" y1="100" x2="82" y2="82" /></g>',
                                    c_opensource: '<path class="cxa" d="M 50.1 4.4 C 13.7 4.1 -9.3 43.4 8.7 75 C 14.1 84.4 22.4 91.7 32.6 95.6 L 44.4 67.1 C 32.6 62.7 29.9 47.1 39.6 39 C 49.3 31 64.1 36.5 66.2 48.9 C 67.6 56.6 63.2 64.3 55.7 67.1 L 64.2 87.2 L 65.5 90.5 L 67.7 95.6 C 101.4 82.1 108.2 37.2 79.6 14.5 C 71.2 7.9 60.8 4.3 50.1 4.4 Z" />',
                                    a_aligntop: '<g class="cxb"><rect x="2" y="15" width="38" height="45" rx="5" /><rect x="52" y="15" width="38" height="75" rx="5" /></g><g class="cxa"><line x1="1" y1="3" x2="99" y2="3" /></g>',
                                    ar_lm: '<path class="cxtxb" d="M29,38 L17,50 L29,62 M83,50 L17,50" />',
                                    ch_lo: '<text class="cxtb100" x="10" y="85">O</text>',
                                    p_gh: '<g class="cxc"><rect x="50" y="0" width="30" height="2"/><rect x="55" y="10" width="20" height="2"/><rect x="30" y="20" width="68" height="45"/><line x1="30" y1="44" x2="98" y2="44" /><line x1="64" y1="20" x2="64" y2="65" /><rect x="0" y="25" width="3" height="30"/><rect x="15" y="25" width="3" height="10"/><rect x="15" y="45" width="3" height="10"/><rect x="40" y="75" width="15" height="2"/><rect x="74" y="75" width="15" height="2"/><rect x="50" y="85" width="30" height="2"/><rect x="75" y="95" width="20" height="2"/></g>',
                                    c_rcode: '<g class="cxb"><path d="M 40.1 72.2 C 19.2 69.5 3.5 58.7 3.5 45.5 C 3.5 30.5 24.3 18.3 50.1 18.3 C 75.7 18.3 96.5 30.5 96.5 45.5 C 96.5 53.4 90.9 60.4 81.9 65.4" /><path d="M 68.7 70.6 C 64.8 71.6 60.7 72.3 56.7 72.6" /><path d="M 40.1 63.1 C 29.5 59.9 22.4 54 22.4 47.2 C 22.4 37.2 37.8 29.1 56.8 29.1 C 62.7 29.1 68.6 29.9 74.2 31.6 C 77.3 32.7 80.2 34 83 35.5" /></g><path class="cxa" d="M 80.2 62.8 C 91 60.6 95.6 47.6 88.3 39.2 C 85.6 36.1 81.5 34.3 77.4 34.3 L 40.1 34.3 L 40.1 81.7 L 56.7 81.7 L 56.7 63.1 L 63.8 63.1 L 75.9 81.7 L 92.5 81.7 Z M 70.4 54.3 L 55.9 54.3 L 55.9 43.2 L 70.4 43.2 C 74.6 42.8 77.7 47.2 75.9 51.1 C 74.9 53.2 72.8 54.5 70.4 54.3 Z" /><g class="cxaa"><text class="cxtn50" x="2" y="-5" transform="rotate(90)">&#8963;</text><text class="cxtn50" x="-42" y="35" transform="rotate(-90)">&#8963;</text></g>',
                                    m_left: '<g class="cxaa"><path d="M50,10 Q 25,10 25,25 L25,35 45,35 45,30 Q 45,25 50,25 Z" /></g>',
                                    ch_lh: '<text class="cxtb100" x="15" y="85">H</text>',
                                    wp_broadcast: '<g class="cxb"><path d="M 67.8 9.8 C 75.6 17.6 75.6 30.3 67.8 38.1"/><path d="M 81 0.3 C 94 13.4 94 34.6 81 47.6"/><path d="M 32.2 9.8 C 24.4 17.6 24.4 30.3 32.2 38.1"/><path d="M 19 0.3 C 6 13.4 6 34.6 19 47.6"/></g><g class="cxa"><polyline points="75.2 99.8 50.1 26.8 25 99.8"/><line x1="69" y1="82.8" x2="31.2" y2="82.8"/></g><g class="cxb"><circle cx="50" cy="24" r="8.6"/></g>',
                                    op_refresh: '<g class="cxa"><path d="M79.7,27.5C66.1,8.4,39.6,3.8,20.4,17.4C9.8,25,3.1,37,2.5,50.1c5.7-18.9,25.7-29.5,44.5-23.8c7.1,2.2,13.4,6.5,17.9,12.4L50,50.1l35.4,3.6l6-35L79.7,27.5z"/></g><g class="cxb"><path d="M20.9,73.3C34.9,92.1,61.6,96,80.4,82c10.5-7.8,16.8-20,17.1-33.1c-5.3,19-25,30.1-44,24.8c-7.1-2-13.5-6.1-18.1-11.9L50,50.1l-35.4-2.8L9.5,82.5L20.9,73.3z"/></g>',
                                    dt_max: '<g class="cxaa"><rect x="88" y="6" width="10" height="87" /></g><g class="cxb"><line x1="2" y1="98" x2="100" y2="98" /><line x1="2" y1="2" x2="2" y2="98" /></g><g class="cxcc"><rect x="8" y="86" width="10" height="7" /><rect x="28" y="66" width="10" height="27" /><rect x="48" y="46" width="10" height="47" /><rect x="68" y="26" width="10" height="67" /></g>',
                                    sp_thickness: '<path class="cxtxa" d="M50,42 L58,50 L50,58 M36,42 L26,50 L36,58 M58,50 L26,50" /><g class="cxb"><rect x="2" y="2" width="10" height="96" /><rect x="72" y="2" width="26" height="96" /></g>',
                                    gr_g1: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxa"><line x1="4" y1="18" x2="98" y2="18" /><line x1="4" y1="38" x2="98" y2="38" /><line x1="4" y1="58" x2="98" y2="58" /><line x1="4" y1="78" x2="98" y2="78" /></g><g class="cxcc"><rect x="20" y="48" width="20" height="47" /><rect x="60" y="10" width="20" height="85" /></g>',
                                    ar_t: '<path class="cxtxb" d="M35,20 L50,2 L65,20 M50,98 L50,2" />',
                                    ch_olin: '<text class="cxts100" x="5" y="70">lin</text>',
                                    p_g3axisy: '<g class="cxblue"><line x1="25" y1="15" x2="25" y2="75" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /></g>',
                                    p_cg2datadenhist: '<g class="cxb"><line x1="55" y1="6" x2="55" y2="88" /><line x1="47" y1="21" x2="47" y2="88" /><line x1="39" y1="58" x2="39" y2="88" /><line x1="31" y1="76" x2="31" y2="88" /><line x1="63" y1="21" x2="63" y2="88" /><line x1="71" y1="58" x2="71" y2="88" /><line x1="78" y1="76" x2="78" y2="88" /></g>',
                                    lg_g2: '<g class="cxc"><line x1="10" y1="10" x2="10" y2="98" /><line x1="2" y1="90" x2="98" y2="90" /><line x1="2" y1="70" x2="10" y2="70" /><line x1="2" y1="50" x2="10" y2="50" /><line x1="2" y1="30" x2="10" y2="30" /><line x1="30" y1="90" x2="30" y2="98" /><line x1="50" y1="90" x2="50" y2="98" /><line x1="70" y1="90" x2="70" y2="98" /><line x1="90" y1="90" x2="90" y2="98" /></g><g class="cxcc"><rect x="26" y="20" width="2" height="2"/><rect x="36" y="40" width="2" height="2"/><rect x="46" y="70" width="2" height="2"/><rect x="56" y="80" width="2" height="2"/><rect x="66" y="60" width="2" height="2"/><rect x="27" y="80" width="2" height="2"/><rect x="20" y="60" width="2" height="2"/><rect x="76" y="75" width="2" height="2"/></g>',
                                    g_venn: '<g class="cxbb"><path d="M 39.4 64.1 C 28.2 59.7 20.9 48.9 20.8 36.9 C 20.8 36.6 20.8 36.2 20.8 35.9 C -0.1 44 -4.4 71.7 13.1 85.8 C 23.9 94.5 39.3 94.4 49.9 85.6 C 43.5 80.2 39.7 72.4 39.4 64.1 Z"/><path d="M 50 7.8 C 27.6 7.9 13.7 32.3 25 51.6 C 28.3 57.2 33.4 61.6 39.4 64 C 39.4 63.7 39.4 63.3 39.4 63 C 39.4 54.3 43.3 46 50.1 40.5 C 56.8 46 60.7 54.3 60.7 63 C 60.7 63.3 60.7 63.7 60.7 64 C 81.6 55.7 85.6 28 68 14 C 62.9 10 56.6 7.8 50.1 7.8 Z"/></g><g class="cxcc"><path d="M 50 66.1 C 46.4 66.1 42.8 65.4 39.4 64.1 C 39.7 72.4 43.6 80.3 50 85.6 C 56.5 80.3 60.3 72.4 60.6 64.1 C 57.2 65.4 53.6 66.1 50 66.1 Z"/><path d="M 79.1 35.9 C 75.7 34.6 72.2 33.9 68.5 33.9 C 61.8 33.9 55.2 36.2 50 40.5 C 56.7 46.1 60.6 54.3 60.6 63.1 C 60.6 63.4 60.6 63.7 60.6 64.1 C 71.8 59.7 79.2 48.9 79.2 36.9 C 79.2 36.6 79.1 36.2 79.1 35.9 Z"/><path d="M 20.9 35.9 C 24.3 34.6 27.9 33.9 31.5 33.9 C 38.2 33.9 44.8 36.2 50 40.5 C 43.3 46.1 39.4 54.3 39.4 63.1 C 39.4 63.4 39.4 63.7 39.4 64.1 C 28.2 59.7 20.8 48.9 20.8 36.9 C 20.8 36.6 20.9 36.2 20.9 35.9 Z"/></g><g class="cxa"><circle cx="50" cy="36.9" r="29.2"/><circle cx="68.5" cy="63.1" r="29.2"/><circle cx="31.5" cy="63.1" r="29.2"/></g>',
                                    bx_medianc: '<g class="cxb"><rect x="30" y="20" width="40" height="60" /><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g><g class="cxbb"><rect x="40" y="40" width="20" height="20" /></g>',
                                    sw_up: '<g class="cxa"><path d="M0,85 C90,90 10,10 100,15" /><line x1="83" y1="5" x2="98" y2="15" /><line x1="83" y1="25" x2="98" y2="15" /></g>',
                                    cd_json: '<g class="cxb"><polyline points="89,40 89,30 59,30 59,2 13,2 13,40" /><polyline points="13,90 13,98 89,98 89,90" /><line x1="90" y1="29" x2="59" y2="1" /><rect x="2" y="40" width="96" height="50" /></g><g class="cxaa"><text class="cxtn30" x="10" y="-30" transform="rotate(90)">&#8963;</text><text class="cxtn30" x="-34" y="44" transform="rotate(-90)">&#8963;</text><text class="cxtn30" x="10" y="75">JSON</text></g>',
                                    v_forward: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn60" x="17" y="73">&#9654;</text><text class="cxtn60" x="40" y="73">&#9654;</text>',
                                    wp_constructor: '<g class="cxa"><polyline points="19.7 21.7 4.2 30.8 4.2 70.9 50 97.7 95.8 70.9 95.8 30.8 80.6 21.8"/><polyline points="4.2 30.9 50 57.5 95.8 30.9"/><line x1="50" y1="57.5" x2="50" y2="97.7"/></g><g class="cxb"><ellipse cx="50" cy="9.1" rx="12" ry="6.8"/><line x1="38.1" y1="15" x2="38.1" y2="10.1"/><path d="M 57.6 22.6 C 55.2 23.6 52.7 24.1 50 24.1 C 47.3 24.1 44.5 23.5 42.1 22.3"/><line x1="62.1" y1="10.1" x2="62.1" y2="15"/><ellipse cx="30" cy="20" rx="12" ry="6.8"/><path d="M 37.6 33.4 C 35.2 34.5 32.7 35 30 34.9 C 23.4 34.9 18 31.9 18 28.2 L 18 20.8"/><ellipse cx="68.7" cy="20" rx="12" ry="6.8"/><path d="M 80.6 20.8 L 80.6 28.2 C 80.6 31.9 75.2 34.9 68.7 34.9 C 65.8 35 63.1 34.4 60.6 33.2"/><ellipse cx="48.6" cy="30.8" rx="12" ry="6.8"/><path d="M 60.6 31.6 L 60.6 39 C 60.6 42.7 55.2 45.8 48.6 45.8 C 42 45.8 36.6 42.5 36.6 39 L 36.6 31.6"/></g>',
                                    p_cg1dataverticalshort: '<g class="cxcc"><rect x="20" y="67" width="16" height="20"/><rect x="48" y="27" width="16" height="60"/><rect x="76" y="47" width="16" height="40"/></g>',
                                    ar_bs: '<path class="cxtxb" d="M42,62 L50,70 L58,62 M50,70 L50,30" />',
                                    i_hist: '<rect fill="url(\'#l-grad\')" x="0" y="0" width="100" height="100"/><g class="cxa"><rect x="2" y="2" width="96" height="96"/><polyline points="2,98 20,88 40,60 60,25 80,70 98,2" /></g>',
                                    p_ghvariablelabels: '<g class="cxblue"><rect x="40" y="75" width="15" height="2"/><rect x="74" y="75" width="15" height="2"/></g>',
                                    i_labels: '<g class="cxc"><rect x="2" y="25" width="96" height="50"/><rect x="40" y="10" width="20" height="2"/><rect x="2" y="90" width="10" height="2"/><rect x="45" y="90" width="10" height="2"/><rect x="88" y="90" width="10" height="2"/></g>',
                                    g_nonlinearfit: '<g class="cxb"><path d="M 11.9 73.2 L 23.4 73.2 C 36.2 73.2 47.9 65.8 53.5 54.3 L 58.8 43.4 C 64.4 31.8 76.1 24.5 89 24.5 L 100 24.5"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.5" x2="11.9" y2="62.5" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/><line x1="32.5" y1="100" x2="32.5" y2="86"/><line x1="57.7" y1="100" x2="57.7" y2="86"/><line x1="82.8" y1="100" x2="82.8" y2="86"/></g><g class="cxaa"><circle cx="30.5" cy="61.5" r="4.6"/><circle cx="73.2" cy="16.9" r="4.6"/><circle cx="92.4" cy="33.3" r="4.6"/><circle cx="60.6" cy="63.5" r="4.6"/><circle cx="51.4" cy="34.5" r="4.6"/></g>',
                                    ch_ld: '<text class="cxtb100" x="15" y="85">D</text>',
                                    n_nodes: '<g class="cxc"><line x1="18.9" y1="15.4" x2="41.7" y2="31.3"/><line x1="21.6" y1="75.8" x2="43.5" y2="53.1"/><line x1="56.7" y1="76.6" x2="55.9" y2="57.1"/><line x1="84.3" y1="60.8" x2="69.5" y2="50.2"/><line x1="78" y1="13.9" x2="66.4" y2="28.2"/></g><g class="cxac"><circle cx="55.3" cy="40.9" r="16.9"/><circle cx="82.3" cy="8.6" r="6.8"/><circle cx="89.9" cy="64.7" r="6.8"/><circle cx="16.9" cy="80.6" r="6.8"/><circle cx="12.2" cy="10.7" r="8.9"/><circle cx="57.1" cy="87.5" r="10.8"/></g>',
                                    g_meter: '<g class="cxa"><path d="M 23.6 30.4 C 36.7 13.6 62 13.2 75.7 29.5 L 87.3 21.9 C 67.9 -3 30.2 -2.3 11.7 23.2 Z"/><path d="M 91.7 28.4 L 80 36.1 C 87.1 50.3 83.3 67.5 70.8 77.3 L 70.8 93.6 C 95.1 81.8 104.6 52.1 91.7 28.4 Z"/><line x1="44.3" y1="33.5" x2="44.3" y2="40.6"/><line x1="54.7" y1="33.5" x2="54.7" y2="40.6"/><polyline points="40.3 80.2 44.6 80.2 44.6 96.3"/><rect x="51.6" y="80.2" width="8.2" height="14.1"/></g><g class="cxb"><path d="M 28.2 76.5 C 16.8 66.8 13.3 50.7 19.5 37.1 L 7.6 29.9 C -4.1 53 5.1 81.3 28.2 93.2 Z"/><circle cx="49.5" cy="65.4" r="7.3"/><line x1="54" y1="59.7" x2="70.9" y2="37.8"/></g>',
                                    c_stata: '<path class="cl19" d="M22.7,38.5l-1.9,5.1H7c-1.1,0.1-1.8,1.1-1.7,2.1c0.1,0.9,0.8,1.6,1.7,1.7h8.6c3.9,0,7,3.2,7,7c0,3.9-3.2,7-7,7H0l1.9-5.1h13.7c1.1-0.1,1.8-1.1,1.7-2.1c-0.1-0.9-0.8-1.6-1.7-1.7H7c-3.9,0-7-3.2-7-7s3.2-7,7-7H22.7z"/><polygon class="cl19" points="62.6,38.5 60.6,43.6 67.1,43.6 67.1,61.5 72.2,61.5 72.2,43.6 77.3,43.6 79.3,38.5 "/><path class="cl19" d="M92.9,52.6h-9.9c-1.1,0-1.9,0.9-1.9,1.9c0,1.1,0.9,1.9,1.9,1.9h11.8v-3.8H92.9z M88.2,47.4h6.6v-2.1c0-1-0.9-1.8-1.9-1.8h-15l1.9-5h13.1c3.9,0,7.1,3.2,7.1,7.1c0,0,0,0,0,0v15.9H83.1c-3.9-0.2-6.9-3.5-6.7-7.4c0.2-3.6,3.1-6.5,6.7-6.7L88.2,47.4z"/><path class="cl19" d="M53.6,52.6h-9.9c-1.1,0-1.9,0.9-1.9,1.9c0,1.1,0.9,1.9,1.9,1.9h11.8v-3.8H53.6z M51.1,47.4h4.5v-2.1c0-1-0.9-1.8-1.9-1.8h-15l1.9-5h13.1c3.9,0,7,3.2,7,7.1l0,0v15.9H43.8c-3.9,0.2-7.2-2.8-7.4-6.7s2.8-7.2,6.7-7.4c0.3,0,0.5,0,0.8,0L51.1,47.4z"/><polygon class="cl19" points="23.3,38.5 21.4,43.6 27.8,43.6 27.8,61.5 32.9,61.5 32.9,43.6 38,43.6 40,38.5 "/>',
                                    b_pail: '<path class="cxbw" d="M95,70l-15,15a6,6,0,0,1-9,0L45,65l25-25,25,25A6,6,0,0,1,95,70Z"/><g class="cxb"><path d="M70,40h6a9,9,0,0,1,9,9h0a9,9,0,0,1-9,9H65"/><circle cx="40" cy="72" r="2"/></g>',
                                    lg_g1: '<g class="cxc"><line x1="10" y1="10" x2="10" y2="98" /><line x1="2" y1="90" x2="90" y2="90" /><line x1="2" y1="70" x2="10" y2="70" /><line x1="2" y1="50" x2="10" y2="50" /><line x1="2" y1="30" x2="10" y2="30" /><line x1="25" y1="98" x2="35" y2="98" /><line x1="45" y1="98" x2="55" y2="98" /><line x1="65" y1="98" x2="75" y2="98" /></g><g class="cxcc"><rect x="26" y="20" width="9" height="68"/><rect x="46" y="53" width="9" height="35"/><rect x="66" y="73" width="9" height="15"/></g>',
                                    sp_closer: '<path class="cxtxa" d="M66,2 L58,10 L66,18 M98,10 L58,10" /><path class="cxtxa" d="M34,2 L42,10 L34,18 M42,10 L2,10" /><g class="cxb"><rect x="9" y="36" width="18" height="62" /><rect x="42" y="36" width="18" height="62" /><rect x="77" y="36" width="18" height="62" /></g>',
                                    at_motion: '<g class="cxb"><rect x="22" y="35" width="20" height="30" /><rect x="2" y="35" width="10" height="30" /></g><g class="cxa"><polyline points="98,50 68,85 68,65 53,65 53,35, 68,35 68,15 98,50" /></g>',
                                    p_cg3axes: '<g class="cxb"><line x1="10" y1="2" x2="10" y2="98" /><line x1="2" y1="10" x2="10" y2="10" /><line x1="2" y1="30" x2="10" y2="30" /><line x1="2" y1="50" x2="10" y2="50" /><line x1="2" y1="70" x2="10" y2="70" /><line x1="2" y1="90" x2="98" y2="90" /><line x1="10" y1="90" x2="10" y2="98" /><line x1="30" y1="90" x2="30" y2="98" /><line x1="50" y1="90" x2="50" y2="98" /><line x1="70" y1="90" x2="70" y2="98" /><line x1="90" y1="90" x2="90" y2="98" /><line x1="10" y1="90" x2="70" y2="30" /><line x1="55" y1="45" x2="65" y2="45" /><line x1="40" y1="60" x2="50" y2="60" /><line x1="25" y1="75" x2="35" y2="75" /></g>',
                                    wp_fileformat: '<g class="cxa"><path d="M 15 52.7 L 15 2.2 L 69.4 2.2 L 90.3 23.1 L 90.3 97.8 L 15 97.8 L 15 81.6"/><polyline points="69.4 2.2 69.4 22.8 90.4 22.8"/></g><g class="cxb"><rect x="9.6" y="52.7" width="51.3" height="29"/></g>',
                                    op_cancel: '<g class="cxa"><circle cx="50" cy="50" r="48"/></g><g class="cxb"><line x1="25" y1="25" x2="75" y2="75" /><line x1="75" y1="25" x2="25" y2="75" /></g>',
                                    p_g1sampletitle: '<g class="cxblue"><rect x="35" y="85" width="30" height="2"/></g>',
                                    g_network: '<g class="cxa"><line x1="18.9" y1="15.4" x2="41.7" y2="31.3"/><line x1="21.6" y1="75.8" x2="43.5" y2="53.1"/><line x1="56.7" y1="76.6" x2="55.9" y2="57.1"/><line x1="84.3" y1="60.8" x2="69.5" y2="50.2"/><line x1="78" y1="13.9" x2="66.4" y2="28.2"/><circle cx="55.3" cy="40.9" r="16.9"/></g><g class="cxb"><circle cx="82.3" cy="8.6" r="6.8"/><circle cx="89.9" cy="64.7" r="6.8"/><circle cx="16.9" cy="80.6" r="6.8"/><circle cx="12.2" cy="10.7" r="8.9"/><circle cx="57.1" cy="87.5" r="10.8"/></g>',
                                    sv_svg: '<g class="cxa"><path d="M60,7 L70,17 L90,17 Q 98,17 98,26 L98,74 Q 98,84 90,84 L10,84 Q 2,84 2,74 L2,24 Q 2,17 10,17 L30,17 L40,7 Z" /></g><g class="cxb"><circle cx="50" cy="50" r="15" /><circle cx="50" cy="50" r="25" /><line x1="10" y1="8" x2="25" y2="8" /><line x1="10" y1="27" x2="25" y2="27" /></g><g class="cxaw"><rect x="12" y="55" width="76" height="40" rx="4" /></g><g class="cxaa"><text class="cxtn30" x="18" y="85">SVG</text></g>',
                                    p_cg1axesvertical: '<g class="cxb"><line x1="10" y1="2" x2="10" y2="98" /><line x1="2" y1="10" x2="10" y2="10" /><line x1="2" y1="30" x2="10" y2="30" /><line x1="2" y1="50" x2="10" y2="50" /><line x1="2" y1="70" x2="10" y2="70" /><line x1="2" y1="90" x2="98" y2="90" /><rect x="23" y="98" width="10" height="2"/><rect x="51" y="98" width="10" height="2"/><rect x="79" y="98" width="10" height="2"/></g>',
                                    ch_olinsmall: '<text class="cxts60" x="25" y="70">lin</text>',
                                    ps_bottomleft: '<path class="cxtxb" d="M34,58 L34,66 L42,66 M34,66 L66,34" /><g class="cxa"><rect x="2" y="78" width="20" height="20" rx="2" /></g>',
                                    ln_style: '<g class="cxa"><line x1="4" y1="23" x2="98" y2="23" /><line x1="4" y1="48" x2="98" y2="48" stroke-dasharray="5" /><line x1="4" y1="73" x2="98" y2="73" stroke-dasharray="15 5"/></g>',
                                    a_distributehor: '<g class="cxb"><rect x="25" y="10" width="50" height="36" rx="5" /><rect x="5" y="54" width="90" height="36" rx="5" /></g><g class="cxa"><line x1="50" y1="1" x2="50" y2="99" /></g>',
                                    v_pause: '<circle class="cxb" cx="50" cy="50" r="48" /><rect x="24" y="25" width="18" height="50" /><rect x="58" y="25" width="18" height="50" />',
                                    g_remotegraphs: '<g class="cxa"><circle cx="50" cy="50" r="16.8"/></g><g class="cxb"><path d="M 83.8 16.2 C 102.4 34.9 102.4 65.1 83.8 83.8"/><path d="M 73.1 26.9 C 85.9 39.6 85.9 60.3 73.1 73.1"/><path d="M 73.1 26.9 C 85.9 39.6 85.9 60.3 73.1 73.1"/><path d="M 16.2 16.2 C -2.4 34.9 -2.4 65.1 16.2 83.8"/><path d="M 26.9 26.9 C 14.1 39.6 14.1 60.3 26.9 73.1"/><path d="M 26.9 26.9 C 14.1 39.6 14.1 60.3 26.9 73.1"/></g>',
                                    cl_horizontalbg: '<g class="cxcc"><rect x="0" y="0" width="100" height="33" /><rect x="0" y="67" width="100" height="33" /></g>',
                                    p_ghcitation: '<g class="cxblue"><rect x="75" y="95" width="20" height="2"/></g>',
                                    ch_snumber: '<text class="cxtb100" x="15" y="85">#</text>',
                                    c_php: '<ellipse class="cxa" cx="50" cy="50" rx="47.9" ry="25" /><g class="cxb"><line x1="47.3" y1="31.8" x2="42.5" y2="56.1" /><path d="M 56.3 56.1 L 58.2 46.5 C 58.8 44.1 56.8 41.7 54.2 41.7 L 44.8 41.7" /><path d="M 19 63.4 L 23.5 40.9 L 30.4 40.9 C 34.8 40.9 37.9 44.9 36.8 49.1 L 36.8 49.1 C 36.2 52 33.5 54.1 30.4 54.1 L 20.8 54.1" /><path d="M 62.9 63.4 L 67.6 40.9 L 74.5 40.9 C 78.7 40.9 81.9 44.9 80.8 49.1 L 80.8 49.1 C 80.1 52 77.4 54.1 74.4 54.1 L 64.8 54.1" /></g>',
                                    g_splom: '<g class="cxcc"><rect x="2.3" y="2.9" width="18.4" height="18.4"/><rect x="79.3" y="78.7" width="18.4" height="18.4"/><rect x="53.7" y="53.4" width="18.4" height="18.4"/><rect x="28" y="28.2" width="18.4" height="18.4"/></g><g class="cxa"><rect x="2.3" y="2.9" width="18.4" height="18.4"/><rect x="2.3" y="28.2" width="18.4" height="18.4"/><rect x="2.3" y="53.4" width="18.4" height="18.4"/><rect x="2.3" y="78.7" width="18.4" height="18.4"/><rect x="79.3" y="2.9" width="18.4" height="18.4"/><rect x="79.3" y="28.2" width="18.4" height="18.4"/><rect x="79.3" y="53.4" width="18.4" height="18.4"/><rect x="79.3" y="78.7" width="18.4" height="18.4"/><rect x="53.7" y="2.9" width="18.4" height="18.4"/><rect x="53.7" y="28.2" width="18.4" height="18.4"/><rect x="53.7" y="53.4" width="18.4" height="18.4"/><rect x="53.7" y="78.7" width="18.4" height="18.4"/><rect x="28" y="2.9" width="18.4" height="18.4"/><rect x="28" y="28.2" width="18.4" height="18.4"/><rect x="28" y="53.4" width="18.4" height="18.4"/><rect x="28" y="78.7" width="18.4" height="18.4"/></g><g class="cxb"><rect x="2.3" y="2.9" width="18.4" height="18.4"/><rect x="79.3" y="78.7" width="18.4" height="18.4"/><rect x="53.7" y="53.4" width="18.4" height="18.4"/><rect x="28" y="28.2" width="18.4" height="18.4"/></g>',
                                    bx_meanb: '<g class="cxc"><rect x="30" y="20" width="40" height="60" /><line x1="30" y1="50" x2="70" y2="50" /><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g><g class="cxbb"><rect x="40" y="40" width="20" height="20" /></g>',
                                    ch_cesc: '<text class="cxtb100" x="5" y="85">&#9099;</text>',
                                    g_pie: '<g class="cxcc"><path d="M 49.5 50 L 49.5 3.2 C 26.2 3.4 3.1 19 2.5 50 C 2.4 60.7 5.8 71 12.3 79.5 Z"/></g><g class="cxbb"><path d="M 96 62 L 49.5 50 L 12.3 79.5 C 34.4 107.5 86.6 101.6 96 62 Z"/></g><g class="cxb"><polyline points="49.5 3.2 49.5 50 12.3 79.5"/><line x1="96" y1="62.3" x2="49.5" y2="50"/></g><g class="cxa"><path d="M 97.6 50 C 96.5 112.5 3.5 112.5 2.5 50 C 3.5 -12.5 96.5 -12.5 97.6 50 Z"/></g>',
                                    ch_olog2: '<text class="cxts70" x="5" y="60">log</text><text class="cxtn40" x="65" y="85">2</text>',
                                    rt_c: '<g class="cxb"><path d=" M 95 50 A 45 45 0 1 1 82 18" /><line x1="82" y1="0" x2="82" y2="18" /><line x1="64" y1="18" x2="84" y2="18" /></g>',
                                    g_donnut: '<g class="cxbc"><path d="M 50 2.5 C 36.8 2.4 24.2 8 15.2 17.7 L 32.5 34.3 C 41.3 24.5 56.4 23.8 66 32.8 L 81.5 14.4 C 72.8 6.7 61.6 2.5 50 2.5 Z"/><path d="M 50 97.6 C 57.2 97.6 64.2 95.9 70.6 92.8 L 60.2 71.2 C 44.6 78.8 26.4 67.4 26.4 50 L 2.5 50 C 2.5 76.3 23.8 97.6 50 97.6 Z"/></g><g class="cxb"><line x1="26.4" y1="50" x2="2.5" y2="50"/><line x1="14.9" y1="17.9" x2="32.6" y2="34.3"/><line x1="66" y1="32.6" x2="82.1" y2="14.9"/><line x1="59.8" y1="71.4" x2="70.1" y2="93.2"/></g><g class="cxa"><path d="M 50 2.5 C 13.4 2.5 -9.5 42.1 8.8 73.8 C 27.1 105.5 72.9 105.5 91.2 73.8 C 95.4 66.6 97.6 58.4 97.6 50 C 97.6 23.8 76.3 2.5 50 2.5 Z M 50 73.6 C 31.9 73.6 20.5 54 29.6 38.2 C 38.7 22.5 61.4 22.5 70.4 38.2 C 72.5 41.8 73.6 45.9 73.6 50 C 73.6 63.1 63 73.6 50 73.6 Z"/></g>',
                                    ar_dcbls: '<text class="cxtn60" x="44" y="51" transform="rotate(45)">&#10555;</text><text class="cxtn60" x="-96" y="51" transform="rotate(45) scale(-1,1)">&#10555;</text>',
                                    p_g3axisz: '<g class="cxblue"><line x1="25" y1="65" x2="75" y2="25" /><line x1="45" y1="50" x2="45" y2="60" /><line x1="65" y1="33" x2="65" y2="43" /></g>',
                                    ch_oz: '<text class="cxti100" x="25" y="70">z</text>',
                                    dp_binc: '<g class="cxb"><circle cx="50" cy="3" r="2.5" /><circle cx="46.5" cy="18" r="2.5" /><circle cx="53.5" cy="18" r="2.5" /><circle cx="43" cy="33" r="2.5" /><circle cx="50" cy="33" r="2.5" /><circle cx="57" cy="33" r="2.5" /><circle cx="39.5" cy="50" r="2.5" /><circle cx="46.5" cy="50" r="2.5" /><circle cx="53.5" cy="50" r="2.5" /><circle cx="60.5" cy="50" r="2.5" /><circle cx="43" cy="65" r="2.5" /><circle cx="50" cy="65" r="2.5" /><circle cx="57" cy="65" r="2.5" /><circle cx="46.5" cy="80" r="2.5" /><circle cx="53.5" cy="80" r="2.5" /><circle cx="50" cy="97" r="2.5" /></g>',
                                    z_zoom: '<g class="cxa"><circle cx="35" cy="35" r="33" /><line x1="60" y1="60" x2="99" y2="99" /></g>',
                                    g_barline: '<g class="cxb"> <rect x="23.2" y="56" width="15.1" height="30.1" /><rect x="50" y="42.5" width="15.1" height="43.6"/><rect x="76.7" y="30.4" width="15.1" height="55.6" /></g><g class="cxa"><line x1="11.9" y1="0.5" x2="11.9" y2="100" /><line x1="99.4" y1="86.1" y2="86.1" x2="0"/><line y1="62.7" x2="11.9" y2="62.7" x1="0"/><line y1="39.4" x2="11.9" y2="39.4" x1="0"/><line y1="16.1" x2="11.9" y2="16.1" x1="0"/><polyline points="23.2 42.5 49.7 19.6 59.5 28.6 89.1 0.5"/></g>',
                                    dps_expand: '<g class="cxa"><rect x="9.5" y="9.5" width="80" height="80" rx="4" /></g><text class="cxtb100" x="3" y="95" transform="scale(1,-1) translate(0,-100)">&#8963;</text>',
                                    ch_ox: '<text class="cxti100" x="25" y="70">x</text>',
                                    dt_count: '<g class="cxb"><line x1="12" x2="12" y1="5" y2="45"/><line x1="37" x2="37" y1="5" y2="45"/><line x1="62" x2="62" y1="5" y2="45"/><line x1="87" x2="87" y1="5" y2="45"/><line x1="12" x2="12" y1="57" y2="95"/><line x1="37" x2="37" y1="57" y2="95"/><line x1="62" x2="62" y1="57" y2="95"/></g><g class="cxa"><line x1="2" x2="98" y1="40" y2="10"/></g>',
                                    p_g1citation: '<g class="cxblue"><rect x="75" y="95" width="20" height="2"/></g>',
                                    p_g2axisy: '<g class="cxblue"><line x1="25" y1="15" x2="25" y2="75" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /></g>',
                                    p_ghsampletitle: '<g class="cxblue"><rect x="0" y="25" width="3" height="30"/></g>',
                                    wp_datawrangling: '<g class="cxa"><ellipse cx="40.4" cy="19.2" rx="38.3" ry="12.3"/><path d="M 40.4 47.7 C 19.3 47.7 2.2 42.2 2.2 35.4 L 2.2 19.2"/><line x1="78.8" y1="19.2" x2="78.8" y2="35.4"/><path d="M 40.4 63.8 C 19.3 63.8 2.2 58.3 2.2 51.5 L 2.2 35.3"/><path d="M 40.4 79.6 C 19.3 79.6 2.2 74.1 2.2 67.4 L 2.2 51.2"/></g><g class="cxb"><path d="M 97.8 73.8 L 97.8 62.2 L 90.6 62.2 C 90.3 61.3 89.9 60.4 89.5 59.6 L 94.6 54.4 L 86.5 46.3 L 81.4 51.4 C 80.6 51 79.7 50.6 78.8 50.3 L 78.8 43 L 67.1 43 L 67.1 50.3 C 66.2 50.6 65.3 51 64.5 51.4 L 59.3 46.3 L 51.1 54.4 L 56.3 59.6 C 55.8 60.4 55.5 61.3 55.2 62.2 L 47.9 62.2 L 47.9 73.8 L 55.2 73.8 C 55.5 74.7 55.8 75.6 56.3 76.4 L 51.1 81.6 L 59.3 89.7 L 64.5 84.6 C 65.3 85.1 66.2 85.4 67.1 85.7 L 67.1 93 L 78.7 93 L 78.7 85.7 C 79.6 85.4 80.5 85.1 81.3 84.6 L 86.5 89.7 L 94.7 81.6 L 89.5 76.4 C 89.9 75.5 90.3 74.7 90.6 73.8 Z"/><circle cx="72.9" cy="68" r="7.4"/></g>',
                                    bx_median: '<g class="cxb"><rect x="30" y="20" width="40" height="60" /><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g><g class="cxa"><line x1="30" y1="50" x2="70" y2="50" /></g>',
                                    dtt_transpose: '<g class="cxaa"><text class="cxtn60" x="42" y="-22" transform="rotate(45)">&#10554;</text><text class="cxtn60" x="-100" y="-22" transform="rotate(45) scale(-1,1)">&#10554;</text></g><g class="cxb"><rect x="2" y="2" width="30" height="60" /><line x1="2" y1="12" x2="32" y2="12" /><rect x="38" y="68" width="60" height="30" /><line x1="38" y1="78" x2="98" y2="78" /></g>',
                                    a_moveback: '<g class="cxb"><rect x="2" y="2" width="30" height="30" /><rect x="68" y="68" width="30" height="30" /></g><g class="cxa"><polyline points="32,17 82,17 82,67" /><polyline points="17,32 17,82 67,82" /></g>',
                                    wp_scale: '<g class="cxa"><path d="M50.2,77.2c-8,0-14.5,6.5-14.5,14.5c0,0,0,0,0,0h29C64.7,83.7,58.2,77.2,50.2,77.2C50.2,77.2,50.2,77.2,50.2,77.2z"/><circle cx="50.2" cy="34.1" r="7.4"/><line x1="50.2" y1="26.8" x2="50.2" y2="8.3"/><line x1="50.2" y1="77.2" x2="50.2" y2="41.4"/><line x1="17" y1="16.9" x2="83.3" y2="16.9"/></g><g class="cxb"><path d="M2.6,49.1c-0.4,8,5.8,14.7,13.8,15.1c8,0.4,14.7-5.8,15.1-13.8c0-0.4,0-0.9,0-1.3H2.6z"/><polyline points="2.6,49.1 17,16.9 31.4,49.1"/><path d="M68.7,49.1c-0.4,8,5.8,14.7,13.8,15.1c8,0.4,14.7-5.8,15.1-13.8c0-0.4,0-0.9,0-1.3H68.7z"/><polyline points="68.7,49.1 83.1,16.9 97.5,49.1"/></g>',
                                    c_excel: '<rect fill="url(\'#excel-grad1\')" x="3" y="3" width="93.2" height="93.2" /><polygon fill="url(\'#excel-grad2\')" points="84.6,24.5 61.1,24.5 17.9,71.3 41.5,71.3 59.8,71.3 50.6,61.4 "/><path fill="url(\'#excel-grad3\')" d="M93.2,6.8v86.5H6.8V6.8H93.2 M100,0H0v100h100V0z"/><polygon fill="url(\'#excel-grad4\')" points="90.2,78.7 66.6,78.7 16.6,24.5 40.2,24.5"/><polygon fill="url(\'#excel-grad5\')" points="90.2,78.7 66.6,78.7 16.6,24.5 40.2,24.5"/><polygon fill="url(\'#exel-grad6\')" points="75.1,62.4 84.6,50.7 64.3,50.7"/>',
                                    bx_medianw: '<g class="cxb"><rect x="30" y="20" width="40" height="60" /><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g><g class="cxaa"><rect x="31" y="45" width="38" height="10" /></g>',
                                    ch_cctrl: '<text class="cxtb100" x="5" y="85">&#8963;</text>',
                                    sp_thicker: '<path class="cxtxa" d="M56,42 L62,50 L56,58 M62,50 L22,50" /><g class="cxa"><rect x="72" y="2" width="26" height="96" /></g><g class="cxb"><rect x="2" y="2" width="10" height="96" /></g>',
                                    sw_down: '<g class="cxb"><path d="M0,15 C90,10 10,90 100,85" /><line x1="83" y1="75" x2="98" y2="85" /><line x1="83" y1="95" x2="98" y2="85" /></g>',
                                    wp_dom: '<g class="cxb"><polyline points="50.1 44.8 50.1 62 66.6 62"/><polyline points="18 21.6 18 38.8 34.4 38.8"/><line x1="50.1" y1="62" x2="50.1" y2="78.5"/></g><g class="cxa"><rect x="66.6" y="54.3" width="31.1" height="15.6"/><rect x="2.3" y="5.9" width="31.1" height="15.6"/><rect x="34.4" y="31" width="31.1" height="15.6"/><rect x="34.4" y="78.5" width="31.1" height="15.6"/></g>',
                                    ch_calt: '<text class="cxtn60" x="5" y="70">Alt</text>',
                                    rt_c2: '<g class="cxb"><path d=" M 5 50 A 45 45 180 0 1 82 18" /><line x1="82" y1="0" x2="82" y2="18" /><line x1="64" y1="18" x2="84" y2="18" /><path d=" M 95 50 A 45 45 180 0 1 18 82" /><line x1="33" y1="82" x2="16" y2="82" /><line x1="18" y1="100" x2="18" y2="82" /></g>',
                                    ar_bm: '<path class="cxtxb" d="M38,71 L50,83 L62,71 M50,83 L50,17" />',
                                    v_first: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn60" x="25" y="73">&#9664;</text><rect x="25" y="25" width="18" height="50" />',
                                    g_tree: '<g class="cxb"><path d="M 40.5 25.6 L 35.6 25.6 C 31.2 25.5 27.1 27.8 24.8 31.6 L 12.4 51.4 L 23.2 68.5 C 25.5 72.2 29.5 74.4 33.8 74.4 L 40.5 74.4"/><path d="M 50.3 25.6 L 57.7 25.6 C 59.5 25.6 61.2 24.6 62.3 23.1 L 62.3 23.1 C 66.1 17.4 72.5 14 79.4 13.9 L 88.2 13.9"/><path d="M 50.3 25.6 L 57.7 25.6 C 59.5 25.6 61.2 26.5 62.3 28 L 62.3 28 C 66.1 33.7 72.5 37.1 79.4 37.2 L 88.2 37.2"/><path d="M 50.3 74.5 L 57.7 74.5 C 59.5 74.5 61.2 73.5 62.3 72 L 62.3 72 C 66.1 66.3 72.5 62.9 79.4 62.9 L 88.2 62.9"/><path d="M 50.3 74.5 L 57.7 74.5 C 59.5 74.5 61.2 75.4 62.3 76.9 L 62.3 76.9 C 66.1 82.6 72.5 86 79.4 86.1 L 88.2 86.1"/></g><g class="cxa"><circle cx="6.8" cy="51.4" r="4.9"/><circle cx="45.4" cy="25.6" r="4.9"/><circle cx="45.4" cy="74.5" r="4.9"/><circle cx="93.2" cy="13.9" r="4.9"/><circle cx="93.2" cy="37.3" r="4.9"/><circle cx="93.2" cy="62.7" r="4.9"/><circle cx="93.2" cy="86.2" r="4.9"/></g>',
                                    ar_hs: '<path class="cxtxb" d="M58,42 L66,50 L58,58 M42,42 L34,50 L42,58 M66,50 L34,50" />',
                                    at_sze: '<g class="cxb"><path d=" M 4 35 A 48 48 0 1 1 77 90" /><circle cx="53" cy="83" r="15" /></g><g class="cxa"><path d=" M 34 95 A 30 30 0 1 1 62 63" /></g>',
                                    p_ghsubtitle: '<g class="cxblue"><rect x="55" y="10" width="20" height="2"/></g>',
                                    wp_data: '<g class="cxa"><path d="M 97.4 60.7 L 97.4 82.3 C 97.4 90.7 76.1 97.5 50 97.5 C 23.8 97.5 2.6 90.7 2.6 82.3 L 2.6 60.7"/><path d="M 97.4 17.7 L 97.4 39.4 C 97.4 47.8 76.1 54.5 50 54.5 C 23.8 54.5 2.6 47.8 2.6 39.4 L 2.6 17.7"/><line x1="52.6" y1="43.3" x2="47.3" y2="43.3"/><line x1="64.9" y1="43.3" x2="59.5" y2="43.3"/><line x1="40" y1="43.3" x2="34.6" y2="43.3"/><line x1="64.9" y1="66.1" x2="59.5" y2="66.1"/><line x1="40" y1="66.1" x2="34.6" y2="66.1"/><line x1="64.9" y1="87.2" x2="59.5" y2="87.2"/><line x1="40" y1="87.2" x2="34.6" y2="87.2"/><line x1="52.6" y1="66.1" x2="47.3" y2="66.1"/><line x1="52.6" y1="87.2" x2="47.3" y2="87.2"/></g><g class="cxb"><path d="M 97.4 39.9 L 97.4 61.6 C 97.4 70 76.1 76.7 50 76.7 C 23.8 76.7 2.6 70 2.6 61.6 L 2.6 39.9"/><ellipse cx="50" cy="17.7" rx="47.4" ry="15.2"/></g>',
                                    b_grhl: '<g class="cxa"><rect fill="url(\'#hl-grad\')" x="0" y="0" width="100" height="100" /></g>',
                                    g_layout: '<g class="cxa"><rect x="2.1" y="2.6" width="25.3" height="25.3"/><rect x="2.1" y="37.4" width="25.3" height="25.3"/><rect x="2.1" y="72.1" width="25.3" height="25.3"/><rect x="72.6" y="2.6" width="25.3" height="25.3"/><rect x="72.6" y="37.4" width="25.3" height="25.3"/><rect x="72.6" y="72.1" width="25.3" height="25.3"/><rect x="37.4" y="2.6" width="25.3" height="25.3"/><rect x="37.4" y="37.4" width="25.3" height="25.3"/><rect x="37.4" y="72.1" width="25.3" height="25.3"/></g><g class="cxb"><line x1="90" y1="14.3" x2="90" y2="10"/><line x1="46.3" y1="13.3" x2="46.3" y2="9.1"/><line x1="9.9" y1="13.3" x2="9.9" y2="9.1"/><line x1="14.8" y1="47.6" x2="14.8" y2="43.3"/><line x1="9.9" y1="81.5" x2="9.9" y2="77.3"/><line x1="18" y1="18.5" x2="18" y2="14.3"/><line x1="19.5" y1="52.5" x2="19.5" y2="56.7"/><line x1="19.5" y1="82.6" x2="19.5" y2="86.9"/><line x1="45" y1="82.6" x2="45" y2="86.9"/><line x1="55.3" y1="82.6" x2="55.3" y2="86.9"/><line x1="53.4" y1="21.1" x2="53.4" y2="16.9"/><line x1="53.4" y1="47.6" x2="53.4" y2="43.3"/><line x1="47.9" y1="56.7" x2="47.9" y2="52.5"/><line x1="81.6" y1="47.6" x2="81.6" y2="43.3"/><line x1="81.6" y1="86.9" x2="81.6" y2="82.6"/><line x1="90.6" y1="57.7" x2="90.6" y2="53.5"/><line x1="90.6" y1="81.5" x2="90.6" y2="77.3"/><line x1="81.6" y1="21.1" x2="81.6" y2="16.9"/></g>',
                                    g_lollipop: '<g class="cxb"><circle cx="30.2" cy="60.1" r="7.4"/><line x1="30.2" y1="67.4" x2="30.2" y2="86"/><circle cx="65.9" cy="46.5" r="7.4"/><line x1="65.9" y1="53.8" x2="65.9" y2="86"/><circle cx="83.7" cy="34.1" r="7.4"/><line x1="83.7" y1="41.5" x2="83.7" y2="86"/><circle cx="48.1" cy="26.8" r="7.4"/><line x1="48.1" y1="34.1" x2="48.1" y2="86"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g>',
                                    ch_la: '<text class="cxtb100" x="15" y="85">A</text>',
                                    tb_app: '<g class="cxa"><rect x="14" y="13" width="6" height="6" /><rect x="30" y="13" width="6" height="6" /><rect x="46" y="13" width="6" height="6" /></g><g class="cxb"><line x1="2" y1="30" x2="96" y2="30" /><rect x="2" y="2" width="96" height="96" rx="5" /></g>',
                                    g_facet: '<g class="cxb"><line x1="10.2" y1="28" x2="10.2" y2="14.3"/><line x1="19.5" y1="28" x2="19.5" y2="9.1"/><line x1="10.2" y1="62.6" x2="10.2" y2="53.1"/><line x1="19.5" y1="62.6" x2="19.5" y2="48.9"/><line x1="10.2" y1="97.2" x2="10.2" y2="79.7"/><line x1="19.5" y1="97.2" x2="19.5" y2="79.7"/><line x1="89.7" y1="28" x2="89.7" y2="14.3"/><line x1="80.4" y1="28" x2="80.4" y2="9.1"/><line x1="89.7" y1="62.6" x2="89.7" y2="53.1"/><line x1="80.4" y1="62.6" x2="80.4" y2="48.9"/><line x1="89.7" y1="97.2" x2="89.7" y2="84.5"/><line x1="80.4" y1="97.2" x2="80.4" y2="90.3"/><line x1="45.3" y1="28" x2="45.3" y2="18.5"/><line x1="54.6" y1="28" x2="54.6" y2="9.1"/><line x1="45.3" y1="62.6" x2="45.3" y2="45.1"/><line x1="54.6" y1="62.6" x2="54.6" y2="55.7"/><line x1="45.3" y1="97.2" x2="45.3" y2="79.7"/><line x1="54.6" y1="97.2" x2="54.6" y2="84"/></g><g class="cxa"><rect x="2.3" y="2.8" width="25.2" height="25.2"/><rect x="2.3" y="37.3" width="25.2" height="25.2"/><rect x="2.3" y="71.9" width="25.2" height="25.2"/><rect x="72.5" y="2.8" width="25.2" height="25.2"/><rect x="72.5" y="37.3" width="25.2" height="25.2"/><rect x="72.5" y="71.9" width="25.2" height="25.2"/><rect x="37.4" y="2.8" width="25.2" height="25.2"/><rect x="37.4" y="37.3" width="25.2" height="25.2"/><rect x="37.4" y="71.9" width="25.2" height="25.2"/></g>',
                                    ar_cross: '<path class="cxb" d="M98,50 L2,50 M50,98 L50,2" />',
                                    p_g1: '<g class="cxc"><rect x="45" y="0" width="20" height="2"/><rect x="50" y="10" width="10" height="2"/><rect x="38" y="40" width="5" height="20"/><rect x="56" y="20" width="5" height="40"/><line x1="25" y1="65" x2="85" y2="65" /><rect x="0" y="25" width="3" height="25"/><line x1="25" y1="15" x2="25" y2="65" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /><rect x="97" y="25" width="3" height="25"/><line x1="75" y1="15" x2="75" y2="65" /><line x1="75" y1="25" x2="85" y2="25" /><line x1="75" y1="45" x2="85" y2="45" /><line x1="75" y1="65" x2="85" y2="65" /><rect x="38" y="75" width="5" height="2"/><rect x="56" y="75" width="5" height="2"/><rect x="35" y="85" width="30" height="2"/><rect x="75" y="95" width="20" height="2"/></g>',
                                    wp_softwaredesign: '<g class="cxa"><path d="M 46.8 78.1 L 5 78.1 C 3.4 78.1 2.1 76.8 2.1 75.2 L 2.1 12.8 C 2.1 11.2 3.4 9.9 5 9.9 L 95 9.9 C 96.6 9.9 97.9 11.2 97.9 12.8 L 97.9 45.4"/><polyline points="55.1 90.1 39.4 90.1 39.4 78.1"/><line x1="21.8" y1="90.1" x2="55.1" y2="90.1"/></g><g class="cxb"><polyline points="26.9 44 16 33.1 26.9 22.2"/><polyline points="45.6 44 56.5 33.1 45.6 22.2"/><line x1="39.1" y1="22.2" x2="33.5" y2="44"/><path d="M 97.8 72.6 L 97.8 62 L 91.2 62 C 91 61.2 90.7 60.5 90.3 59.7 L 95 55 L 87.4 47.6 L 82.8 52.2 C 82 51.8 81.2 51.5 80.4 51.2 L 80.4 44.7 L 70 44.7 L 70 51.2 C 69.1 51.5 68.3 51.8 67.6 52.2 L 62.9 47.6 L 55.4 55 L 60 59.7 C 59.6 60.4 59.3 61.2 59 62 L 52.5 62 L 52.5 72.6 L 59.1 72.6 C 59.3 73.4 59.7 74.2 60 75 L 55.4 79.6 L 62.8 87 L 67.4 82.4 C 68.2 82.8 69 83.1 69.8 83.4 L 69.8 90 L 80.4 90 L 80.4 83.4 C 81.2 83.1 82 82.8 82.7 82.4 L 87.4 87 L 94.8 79.6 L 90.3 74.8 C 90.8 74.1 91.1 73.3 91.4 72.4 Z"/><circle cx="75.1" cy="67.3" r="6.7"/></g>',
                                    dps_toinside: '<g class="cxa"><polyline points="65,30 65,2 2,2 2,98 65,98 65,70" /></g><path class="cxtxb" d="M29,38 L17,50 L29,62 M83,50 L17,50" />',
                                    p_cg2dataden: '<g class="cxb"><rect x="20" y="80" width="2" height="2" /><rect x="37" y="65" width="2" height="2" /><rect x="32" y="50" width="2" height="2" /><rect x="45" y="35" width="2" height="2" /><rect x="39" y="20" width="2" height="2" /><rect x="52" y="7" width="2" height="2" /><rect x="87" y="78" width="2" height="2" /><rect x="73" y="63" width="2" height="2" /><rect x="80" y="48" width="2" height="2" /><rect x="73" y="33" width="2" height="2" /><rect x="68" y="18" width="2" height="2" /><rect x="63" y="3" width="2" height="2" /></g>',
                                    p_dgline: '<g class="cxa"><line x1="10" y1="50" x2="98" y2="50" /><line x1="10" y1="51" x2="98" y2="51" /></g>',
                                    gr_g2z: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxa"><line x1="4" y1="97" x2="70" y2="30" /> <line x1="30" y1="97" x2="96" y2="30" /> <line x1="56" y1="97" x2="122" y2="30" /> <line x1="82" y1="97" x2="148" y2="30" /></g>',
                                    sv_diskjson: '<g class="cxa"><polyline points="98,25 98,98 2,98 2,2 75,2 98,25" /></g><g class="cxb"><rect x="27" y="58" width="50" height="40" /><rect x="32" y="2" width="40" height="30" /><rect x="55" y="12" width="5" height="10" /></g><g class="cxaw"><rect x="2" y="40" width="96" height="50" /></g><g class="cxaa"><text class="cxtn30" x="10" y="75">JSON</text></g>',
                                    a_order: '<g class="cxb"><polyline points="25,52 2,52 2,2 52,2 52,25" /><polyline points="48,77 27,77 27,27 77,27 77,48" /></g><g class="cxa"><rect x="48" y="48" width="50" height="50" /></g>',
                                    gr_stylesolid: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxa"><line x1="4" y1="23" x2="98" y2="23" /> <line x1="4" y1="48" x2="98" y2="48" /> <line x1="4" y1="73" x2="98" y2="73" /></g>',
                                    gr_g2xy: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="100" y2="98" /></g><g class="cxa"><line x1="20" y1="0" x2="20" y2="97" /> <line x1="40" y1="0" x2="40" y2="97" /> <line x1="60" y1="0" x2="60" y2="97" /> <line x1="80" y1="0" x2="80" y2="97" /><line x1="4" y1="18" x2="98" y2="18" /> <line x1="4" y1="38" x2="98" y2="38" /> <line x1="4" y1="58" x2="98" y2="58" /> <line x1="4" y1="78" x2="98" y2="78" /></g>',
                                    sr_aad: '<path class="cxtxa" d="M80,2 L98,17 L80,33 M98,17 L2,17" /><text class="cxtn100" x="0" y="90">a</text><text class="cxtn60" x="60" y="90">a</text>',
                                    g_density: '<g class="cxb"><path d="M 11.9 86 C 11.9 86 23.5 79.2 29.4 56.8 C 35.3 34.4 38.9 2.4 47.3 3.9 C 55.8 5.3 59.3 58.7 63.9 58.7 C 69 58.7 67.8 37.7 76.8 39.5 C 85.7 41.3 96.7 86 96.7 86"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g>',
                                    op_redo: '<g class="cxa"><path d="M94.5,31.5l-39.8-29V16h-1.1C27.4,15.6,5.8,36.6,5.5,62.8c0,0,0,0.1,0,0.1c0,13.2,5.7,25.7,15.5,34.5c-3.4-5.4-5.3-11.6-5.3-18C16,60,31.9,44.5,51.4,44.8c0,0,0,0,0,0c1.1,0,2.3,0,3.4,0.2v15.6L94.5,31.5z"/></g>',
                                    ar_ls: '<path class="cxtxb" d="M38,42 L30,50 L38,58 M70,50 L30,50" />',
                                    ch_cdelete: '<text class="cxtn80" x="0" y="80">&#9003;</text>',
                                    ch_li: '<text class="cxtb100" x="35" y="85">I</text>',
                                    p_cg2fitkm: '<g class="cxa"><polyline points="10,20 35,20 35,30 55,30 55,50 75,50 75,75 95,75 95,90" /></g>',
                                    ps_toloc: '<g class="cxb"><rect x="2" y="2" width="25" height="25" /><rect x="34" y="2" width="25" height="25" /><rect x="67" y="2" width="25" height="25" /><rect x="2" y="34" width="25" height="25" /><rect x="67" y="34" width="25" height="25" /><rect x="2" y="67" width="25" height="25" /><rect x="34" y="67" width="25" height="25" /><rect x="67" y="67" width="25" height="25" /></g><g class="cxaa"><rect x="34" y="34" width="25" height="25" /></g>',
                                    b_type: '<g class="cxcc"><polyline points="83,65 65,65 65,88 88,88 88,68" /></g><g class="cxa"><polyline points="45,15 30,15 30,2 2,2 2,45 45,45 45,15" /><line x1="30" y1="2" x2="45" y2="15" /><polyline points="98,15 83,15 83,2 55,2 55,45 98,45 98,15" /><polyline points="83,12 65,12 65,35 88,35 88,15" /><line x1="83" y1="2" x2="98" y2="15" /><polyline fill="url(\'#bl-grad\')" points="45,68 30,68 30,55 2,55 2,98 45,98 45,68" /><line x1="30" y1="55" x2="45" y2="68" /><polyline points="83,65 65,65 65,88 88,88 88,68" /><polyline points="98,68 83,68 83,55 55,55 55,98 98,98 98,68" /><line x1="83" y1="55" x2="98" y2="68" /></g>',
                                    p_cg2axes: '<g class="cxb"><line x1="10" y1="2" x2="10" y2="98" /><line x1="2" y1="10" x2="10" y2="10" /><line x1="2" y1="30" x2="10" y2="30" /><line x1="2" y1="50" x2="10" y2="50" /><line x1="2" y1="70" x2="10" y2="70" /><line x1="2" y1="90" x2="98" y2="90" /><line x1="10" y1="90" x2="10" y2="98" /><line x1="30" y1="90" x2="30" y2="98" /><line x1="50" y1="90" x2="50" y2="98" /><line x1="70" y1="90" x2="70" y2="98" /><line x1="90" y1="90" x2="90" y2="98" /></g>',
                                    ar_vs: '<path class="cxtxb" d="M42,58 L50,66 L58,58 M42,42 L50,34 L58,42 M50,66 L50,34" />',
                                    p_g3axes: '<g class="cxblue"><line x1="25" y1="65" x2="95" y2="65" /><line x1="25" y1="65" x2="25" y2="75" /><line x1="45" y1="65" x2="45" y2="75" /><line x1="65" y1="65" x2="65" y2="75" /><line x1="85" y1="65" x2="85" y2="75" /><line x1="25" y1="15" x2="25" y2="75" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /><line x1="25" y1="65" x2="75" y2="25" /><line x1="45" y1="50" x2="45" y2="60" /><line x1="65" y1="33" x2="65" y2="43" /></g>',
                                    p_cg1errors: '<g class="cxa"><line x1="20" y1="42" x2="36" y2="42" /><line x1="28" y1="42" x2="28" y2="67" /><line x1="48" y1="2" x2="64" y2="2" /><line x1="56" y1="2" x2="56" y2="27" /><line x1="76" y1="22" x2="92" y2="22" /><line x1="84" y1="22" x2="84" y2="47" /></g>',
                                    p_cg2fitden: '<g class="cxa"><path d="M15,90 C50,67 38,0 55,3 71,0 72,90 95,90" /></g>',
                                    g_parallelcoordinates: '<g class="cxa"><line x1="54.3" y1="52.8" x2="88" y2="23.6"/><line x1="12.4" y1="33.9" x2="45.7" y2="53.8"/><line x1="54.4" y1="78.7" x2="88" y2="51.7"/><line x1="13.1" y1="68.7" x2="44.8" y2="80.2"/><line x1="10.1" y1="86.5" x2="47.2" y2="24.6"/><line x1="53.4" y1="24.3" x2="89" y2="72.1"/></g><g class="cxb"><line x1="7.6" y1="73.2" x2="7.6" y2="85.1"/><line x1="7.6" y1="36.6" x2="7.6" y2="61.4"/><line x1="7.6" x2="7.6" y2="25.5" y1="3.8"/><line x1="92.5" y1="82.2" x2="92.5" y2="96.2"/><line x1="92.5" y1="53.8" x2="92.5" y2="71"/><line x1="92.5" y1="25.5" x2="92.5" y2="42.6"/><line x1="92.5" x2="92.5" y2="14.3" y1="3.8"/><line x1="50.1" y1="87.7" x2="50.1" y2="96.2"/><line x1="50.1" y1="62" x2="50.1" y2="76.6"/><line x1="50.1" y1="25.5" x2="50.1" y2="50.9"/><line x1="50.1" x2="50.1" y2="14.3" y1="3.8"/><circle cx="92.4" cy="19.9" r="5.6"/><circle cx="50.1" cy="19.9" r="5.6"/><circle cx="7.6" cy="31" r="5.6"/><circle cx="7.6" cy="67.6" r="5.6"/><circle cx="7.6" cy="90.6" r="5.6"/><circle cx="92.4" cy="48.2" r="5.6"/><circle cx="50.1" cy="56.5" r="5.6"/><circle cx="50.1" cy="82.1" r="5.6"/><circle cx="92.4" cy="76.6" r="5.6"/></g>',
                                    p_g2axisx: '<g class="cxblue"><line x1="25" y1="65" x2="95" y2="65" /><line x1="25" y1="65" x2="25" y2="75" /><line x1="45" y1="65" x2="45" y2="75" /><line x1="65" y1="65" x2="65" y2="75" /><line x1="85" y1="65" x2="85" y2="75" /></g>',
                                    p_cg2fitkmconf: '<g class="cxcc"><polyline points="10,2 40,2 40,10 65,10 65,30 85,30 85,52 98,52 98,87 66,87 66,68 54,68 54,58 42,58 42,42 30,42 30,36 10,36" /></g>',
                                    c_jsfiddle: '<path class="cxa" d="M 86.2 45.6 C 86.2 45.5 86.2 45.3 86.2 45.2 C 86.2 24.9 64.2 12.1 46.6 22.3 C 43 24.4 39.9 27.3 37.6 30.9 C 27.5 28.5 17.4 34.9 15.2 45.1 C 1.6 49.3 -2.3 66.7 8.2 76.4 C 11.6 79.6 16.1 81.3 20.8 81.3 L 79.3 81.3 C 93.5 81.3 102.4 65.8 95.3 53.5 C 93.2 49.9 90 47.2 86.2 45.6 Z" /><g class="cxb"><path d="M 47.6 61.4 C 45 64 41.5 66.7 38.6 66.7 C 30.7 67.1 25.4 58.9 29 51.9 C 30.8 48.3 34.6 46.2 38.6 46.4 C 44.2 46.4 51.9 56.6 51.9 56.6" /><path d="M 51.9 56.6 C 51.9 56.6 59.7 66.7 65.3 66.7 C 73.2 66.3 77.6 57.6 73.4 51 C 71.6 48.3 68.6 46.5 65.3 46.4 C 63.2 46.6 61.2 47.5 59.6 49 C 58.4 49.9 57.2 50.9 56.2 51.9" /></g>',
                                    c_rr: '<g class="cxb"><path d="M 50 15.2 C 23.4 15.2 1.8 30.7 1.8 50 C 1.8 69.2 23.4 84.8 50 84.8 C 76.6 84.8 98.1 69.2 98.1 50 C 98.1 30.7 76.6 15.2 50 15.2 Z M 56 73.5 C 36.3 73.5 20.2 62.9 20.2 50.1 C 20.2 37.3 36.3 26.7 56 26.7 C 75.8 26.7 91.9 37.2 91.9 50.1 C 91.9 63 75.9 73.5 56 73.5 Z"/></g><g class="cxaw"><path d="M 80.6 73.4 C 85.8 72.1 89.2 65.9 88.1 59.5 C 87.2 54 83.2 50 78.6 50 L 53.8 50 L 53.8 89 L 64.8 89 L 64.8 73.7 L 69.6 73.7 L 77.8 89 L 88.8 89 L 80.6 73.4 Z M 74 66.4 L 64.3 66.4 L 64.3 57.3 L 74 57.3 C 76.2 57.3 78 59.1 78 61.3 C 78 61.4 78 61.4 78 61.5 C 78.4 63.8 76.9 66 74.6 66.5 C 74.5 66.5 74.3 66.5 74 66.4 Z"/><path d="M 38.7 34.4 C 43.9 33.1 47.3 26.9 46.2 20.5 C 45.3 15 41.3 11 36.7 11 L 11.9 11 L 11.9 50 L 22.9 50 L 22.9 34.7 L 27.7 34.7 L 35.9 50 L 46.9 50 L 38.7 34.4 Z M 32.1 27.4 L 22.4 27.4 L 22.4 18.3 L 32.1 18.3 C 34.3 18.3 36.1 20.1 36.1 22.3 C 36.1 22.4 36.1 22.4 36.1 22.5 C 36.5 24.8 35 27 32.7 27.5 C 32.6 27.5 32.4 27.5 32.1 27.4 Z"/></g>',
                                    b_gstype: '<g class="cxa"><rect fill="url(\'#gt-grad\')" x="1" y="1" width="42" height="42"/><rect fill="url(\'#gt-gradr\')" x="57" y="57" width="42" height="42"/></g>',
                                    cd_upload: '<path class="cxtxa" d="M35,60 L50,75 L65,60 M50,75 L50,25" /><g class="cxa"><line x1="30" y1="82" x2="70" y2="82" /></g><g class="cxb"><polyline points="89,30 59,30 59,2 13,2 13,98 89,98 89,30" /><line x1="90" y1="29" x2="59" y2="1" /></g>',
                                    ch_lm: '<text class="cxtb100" x="8" y="85">M</text>',
                                    m_zlasso: '<g class="cxa"><path d="M12.4,60c-4.7-2.8-8-7.3-9.4-12.6C-0.6,31.8,17.6,14.3,43.5,8.3S93.4,10.2,97,25.8c3.6,15.6-14.6,33.1-40.5,39.2c-1.1,0.3-2.3,0.5-3.4,0.7"/><path d="M29.5,93.8c0,0,14.4-21.7,0-33.7S5.1,69.9,19.2,73.8c7.6,2.1,46.6-2.9,30.7-19c-6.8-7-20.4,5.3-20.4,5.3"/></g>',
                                    ar_tlm: '<path class="cxtxb" d="M17,29 L17,17 L29,17 M17,17 L83,83" />',
                                    wp_threebars: '<g class="cxaa"><rect x="2" y="15" width="96" height="8" /><rect x="2" y="48" width="96" height="8" /><rect x="2" y="81" width="96" height="8" /></g>',
                                    dp_binned: '<g class="cxb"><circle cx="3" cy="3" r="2.5" /><circle cx="3" cy="18" r="2.5" /><circle cx="3" cy="33" r="2.5" /><circle cx="3" cy="50" r="2.5" /><circle cx="3" cy="65" r="2.5" /><circle cx="3" cy="80" r="2.5" /><circle cx="3" cy="97" r="2.5" /><circle cx="86.5" cy="3" r="2.5" /><circle cx="83" cy="18" r="2.5" /><circle cx="90" cy="18" r="2.5" /><circle cx="79.5" cy="33" r="2.5" /><circle cx="86.5" cy="33" r="2.5" /><circle cx="93.5" cy="33" r="2.5" /><circle cx="76" cy="50" r="2.5" /><circle cx="83" cy="50" r="2.5" /><circle cx="90" cy="50" r="2.5" /><circle cx="97" cy="50" r="2.5" /><circle cx="79.5" cy="65" r="2.5" /><circle cx="86.5" cy="65" r="2.5" /><circle cx="93.5" cy="65" r="2.5" /><circle cx="83" cy="80" r="2.5" /><circle cx="90" cy="80" r="2.5" /><circle cx="86.5" cy="97" r="2.5" /></g><path class="cxtxa" d="M50,44 L58,52 L50,60 M34,44 L26,52 L34,60 M58,52 L26,52" />',
                                    b_grvb: '<g class="cxa"><rect fill="url(\'#vb-grad\')" x="0" y="0" width="100" height="100" /></g>',
                                    bx_data: '<g class="cxb"><rect x="30" y="20" width="40" height="60" /><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g><g class="cxa"><rect x="38" y="50" width="3" height="3" /><rect x="40" y="28" width="3" height="3" /><rect x="38" y="68" width="3" height="3" /><rect x="50" y="40" width="3" height="3" /><rect x="55" y="55" width="3" height="3" /><rect x="60" y="30" width="3" height="3" /><rect x="60" y="65" width="3" height="3" /></g>',
                                    p_g1axistitle2: '<g class="cxblue"><rect x="97" y="25" width="3" height="25"/></g>',
                                    wp_examples: '<g class="cxb"><polyline points="48.8 29.2 21.7 2.1 2.1 21.7 29.6 49.3" /><polyline points="48.1 67.9 78.1 97.9 97.9 78.1 67.9 48.1" /><line x1="82.2" y1="61.7" x2="71" y2="73" /><line x1="34.1" y1="16.3" x2="22.9" y2="27.6" /></g><g class="cxa"><path d="M 7.4 71.5 L 5.2 92.2 L 25.9 90 L 92.6 23.5 C 96.2 20.1 96.4 14.4 93 10.8 L 86.6 4.5 C 83 1.2 77.3 1.4 73.9 5 Z" /><line x1="63.8" y1="15.1" x2="82.2" y2="33.6" /></g>',
                                    ar_brs: '<path class="cxtxb" d="M66,58 L66,66 L56,66 M34,34 L66,66" />',
                                    e_open: '<g class="cxa"><circle cx="50" cy="50" r="15" /></g><g class="cxb"><path d="M2,50 Q 50,0 98,50 50,100 2,50" /><line x1="2" y1="25" x2="10" y2="35" /><line x1="25" y1="12" x2="30" y2="23" /><line x1="50" y1="8" x2="50" y2="20" /><line x1="75" y1="12" x2="70" y2="23" /><line x1="98" y1="25" x2="88" y2="35" /></g><g class="cxcc"><circle cx="50" cy="50" r="2" /></g>',
                                    g_chord: '<g class="cxb"><path d="M 84.5 65.8 C 84.5 65.8 46.1 50 83.6 32.4"/><path d="M 84.5 65.8 C 84.5 65.8 47.4 48.6 42.2 87.2"/><path d="M 15.5 65.8 C 15.5 65.8 59.1 50.7 61.5 13.8"/><path d="M 12.1 50 C 12.1 50 59.8 66.4 87.4 43"/><path d="M 15 35.2 C 15 35.2 56.8 39 25.2 79"/><path d="M 72.8 80.4 C 72.8 80.4 15.8 48.8 75.9 22.3"/></g><g class="cxa"><path d="M 2.2 50 C 2.3 86.8 42.1 109.8 74 91.3 C 75.6 90.4 77.1 89.4 78.6 88.3 L 72.7 80.4 C 49.3 97.9 15.7 83.4 12.3 54.4 C 12.2 53 12.1 51.5 12.1 50 L 2.2 50 Z"/><path d="M 15 35.2 C 25.3 11 56.6 4.3 75.9 22.3 L 82.6 15.1 C 58.3 -7.6 18.9 0.9 6 31.4 L 15 35.2 Z"/><path d="M 87.4 79.8 C 99.3 64.9 101.2 44.2 92.1 27.4 L 83.7 32.4 C 90.7 45.8 89.1 62.2 79.5 74 L 87.4 79.8 Z"/></g>',
                                    b_windowbg: '<polyline class="cxac" points="65,45 65,30 48,30 48,15 15,15 15,83 68,83 45,65 65,45" />',
                                    b_grhr: '<g class="cxa"><rect fill="url(\'#hr-grad\')" x="0" y="0" width="100" height="100" /></g>',
                                    ar_rs: '<path class="cxtxb" d="M62,42 L70,50 L62,58 M70,50 L30,50" />',
                                    p_ghtitlesubtitle: '<g class="cxblue"><rect x="50" y="0" width="30" height="2"/><rect x="55" y="10" width="20" height="2"/></g>',
                                    sr_zad: '<path class="cxtxa" d="M12,80 L27,98 L42,80 M27,98 L27,2" /><text class="cxtn60" x="50" y="45">Z</text><text class="cxtn60" x="50" y="95">A</text>',
                                    v_next: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn100" x="10" y="0" transform="rotate(90)">⌃</text>',
                                    bx_connect: '<g class="cxb"><rect x="2" y="2" width="24" height="24" /><rect x="2" y="36" width="24" height="24" /><rect x="2" y="70" width="24" height="24" /><rect x="74" y="2" width="24" height="24" /><rect x="74" y="36" width="24" height="24" /><rect x="74" y="70" width="24" height="24" /></g><g class="cxa"><line x1="14" y1="14" x2="86" y2="14" /><line x1="14" y1="48" x2="86" y2="48" /><line x1="14" y1="82" x2="86" y2="82" /></g>',
                                    ar_dctrs: '<text class="cxtn60" x="42" y="-22" transform="rotate(45)">&#10554;</text><text class="cxtn60" x="-100" y="-22" transform="rotate(45) scale(-1,1)">&#10554;</text>',
                                    ch_oitalic: '<text class="cxti100" x="30" y="85">I</text>',
                                    z_out: '<g class="cxaa"><text class="cxtn80" x="20" y="58">-</text></g><g class="cxb"><circle cx="35" cy="35" r="33" /><line x1="60" y1="60" x2="99" y2="99" /></g>',
                                    bx_violint: '<g class="cxac"><path d="M66,18 Q76,28 63,36 50,40 66,49 84,55 84,67 82,81 65,86 L35,86 Q18,81 16,67 16,55 39,50 50,40 37,36 24,28 34,18 Z" /></g>',
                                    dp_jittered: '<g class="cxb"><circle cx="3" cy="3" r="2.5" /><circle cx="3" cy="18" r="2.5" /><circle cx="3" cy="33" r="2.5" /><circle cx="3" cy="50" r="2.5" /><circle cx="3" cy="65" r="2.5" /><circle cx="3" cy="80" r="2.5" /><circle cx="3" cy="97" r="2.5" /><circle cx="89" cy="3" r="2.5" /><circle cx="77" cy="18" r="2.5" /><circle cx="97" cy="33" r="2.5" /><circle cx="87" cy="50" r="2.5" /><circle cx="82" cy="65" r="2.5" /><circle cx="95" cy="80" r="2.5" /><circle cx="93" cy="97" r="2.5" /></g><path class="cxtxa" d="M50,44 L58,52 L50,60 M34,44 L26,52 L34,60 M58,52 L26,52" />',
                                    p_g1axestitles: '<g class="cxblue"><rect x="0" y="25" width="3" height="25"/><rect x="97" y="25" width="3" height="25"/></g>',
                                    bx_mean: '<g class="cxb"><rect x="30" y="20" width="40" height="60" /><line x1="30" y1="50" x2="70" y2="50" /><line x1="30" y1="2" x2="70" y2="2" /><line x1="50" y1="2" x2="50" y2="20" /><line x1="30" y1="98" x2="70" y2="98" /><line x1="50" y1="98" x2="50" y2="80" /></g><g class="cxaa"><rect x="40" y="40" width="20" height="20" /></g>',
                                    wp_events: '<polygon class="cxa" points="79.6 23.2 2.6 2.6 23.2 79.6 39.3 56.9 79.6 97.4 97.4 79.6 56.9 39.3 79.6 23.2" style=""></polygon>',
                                    ch_of: '<text class="cxti100" x="35" y="75">f</text>',
                                    dt_exact: '<g class="cxaa"><rect x="8" y="86" width="10" height="7" /><rect x="88" y="6" width="10" height="87" /></g><g class="cxb"><line x1="2" y1="98" x2="100" y2="98" /><line x1="2" y1="2" x2="2" y2="98" /></g><g class="cxcc"><rect x="28" y="66" width="10" height="27" /><rect x="48" y="46" width="10" height="47" /><rect x="68" y="26" width="10" height="67" /></g>',
                                    wp_user: '<g class="cxa"><circle cx="49.9" cy="26" r="23.6" /><path d="M 49.9 49.6 L 49.9 49.6 C 71.7 49.6 89.3 67.2 89.3 88.9 L 89.3 97.7 C 89.3 97.7 89.3 97.7 89.3 97.7 L 10.7 97.7 C 10.7 97.7 10.7 97.7 10.7 97.7 L 10.7 88.9 C 10.6 67.2 28.2 49.6 49.9 49.6 Z" /></g>',
                                    ch_oe: '<text class="cxts200" x="10" y="85">e</text>',
                                    cd_select: '<g class="cxa"><rect y="2" x="2" width="96" height="96" stroke-dasharray="10" /></g><g class="cxb"><polyline points="68,47 68,40 48,40 48,17 22,17 22,83 68,83 68,70" /><line x1="68" y1="40" x2="48" y2="17" /></g><g class="cxaa"><text class="cxtn30" x="47" y="-60" transform="rotate(90)">&#8963;</text><text class="cxtn30" x="-71" y="74" transform="rotate(-90)">&#8963;</text></g>',
                                    p_cg2fitcor: '<g class="cxa"><line x1="10" y1="90" x2="99" y2="1" /></g>',
                                    dt_min: '<g class="cxaa"><rect x="8" y="86" width="7" height="10" /></g><g class="cxb"><line x1="2" y1="98" x2="100" y2="98" /><line x1="2" y1="2" x2="2" y2="98" /></g><g class="cxcc"><rect x="28" y="66" width="10" height="27" /><rect x="48" y="46" width="10" height="47" /><rect x="68" y="26" width="10" height="67" /><rect x="88" y="6" width="10" height="87" /></g>',
                                    ch_omean: '<rect x="20" y="2" width="68" height="6" /><text class="cxtn100" x="20" y="90">X</text>',
                                    sp_thickness2: '<g class="cxa"><rect x="27" y="2" width="24" height="96" /></g><g class="cxb"><rect x="2" y="2" width="14" height="96" /><rect x="61" y="2" width="34" height="96" /></g>',
                                    sl_checkboxoff: '<rect class="cxb" x="15" y="15" width="70" height="70" rx="5" />',
                                    p_g3title: '<g class="cxblue"><rect x="45" y="0" width="30" height="2"/></g>',
                                    tb_table: '<g class="cxa"><rect x="2" y="2" width="96" height="96" /><rect x="12" y="12" width="3" height="3" /><rect x="24" y="12" width="3" height="3" /><rect x="36" y="12" width="3" height="3" /></g><g class="cxb"><line x1="2" y1="26" x2="98" y2="26" /><line x1="2" y1="50" x2="98" y2="50" /><line x1="2" y1="74" x2="98" y2="74" /><line x1="34" y1="26" x2="34" y2="98" /><line x1="66" y1="26" x2="66" y2="98" /></g>',
                                    b_window: '<polyline class="cxa" points="65,45 65,30 48,30 48,15 15,15 15,83 68,83 45,65 65,45" />',
                                    ar_tr: '<path class="cxtxb" d="M78,2 L98,2 L98,22 M2,98 L98,2" />',
                                    wp_interactiveplots: '<g class="cxa"><path d="M 68.8 24.9 C 66 26.7 65.1 30.4 66.8 33.3 C 64.4 29.3 58.5 29.5 56.4 33.6 C 55.3 35.5 55.4 37.8 56.6 39.7 C 54.1 35.7 48.3 35.9 46.1 40 C 45.1 42 45.1 44.3 46.3 46.1 L 36.2 29.8 C 33.8 25.8 27.9 26 25.7 30.1 C 24.7 32.1 24.8 34.4 25.9 36.2 L 37.2 54.4 L 38.8 57 C 38.2 57.2 37.6 57.4 37.1 57.7 C 34.4 59.5 33.6 63.1 35.3 65.9 L 39.3 72.3 C 39.3 72.3 47.4 85.2 47.8 85.6 C 61.4 102.4 88.2 98.2 95.9 77.9 C 99 69.9 98.2 60.9 93.8 53.5 L 88.9 45.5 L 87.2 42.8 L 77 26.9 C 75.3 24.1 71.6 23.2 68.8 24.9 Z"/><line x1="38.8" y1="57" x2="49.6" y2="74.3"/><line x1="46.3" y1="46" x2="54.4" y2="59.1"/><line x1="56.6" y1="39.6" x2="64.7" y2="52.7"/><line x1="66.8" y1="33.3" x2="75" y2="46.4"/></g><g class="cxb"><path d="M 25.2 50 C 21.5 48.6 18.4 46.1 16.3 42.7 C 8.7 31.2 16.4 15.8 30.2 14.9 C 37 14.5 43.4 18 46.8 23.8"/><path d="M 24.1 61.5 C 2.3 55.8 -5.2 28.8 10.6 12.8 C 23.9 -0.7 46.2 1.8 56.2 17.9"/></g>',
                                    ch_lv: '<text class="cxtb100" x="15" y="85">V</text>',
                                    g_tagcloud: '<g class="cxa"><line x1="10.7" y1="2.1" x2="66.7" y2="2.1"/><line x1="10.7" y1="6.2" x2="66.7" y2="6.2"/><line x1="65" y1="17.9" x2="89" y2="17.9"/><line x1="40.5" y1="27.3" x2="77" y2="27.3"/><line y1="65.4" x2="54.5" y2="65.4" x1="4"/><line x1="45.7" y1="89" x2="79.8" y2="89"/><line x1="63.5" y1="97.9" x2="92.1" y2="97.9"/><line x1="25.5" y1="27.3" x2="19.2" y2="27.3"/><line x1="54.9" y1="38.9" x2="63.5" y2="38.9"/><line x1="58" y1="77.4" x2="66.7" y2="77.4"/><line x1="34.4" y1="51.1" x2="68.9" y2="51.1"/><line x1="34.4" y1="53.2" x2="68.9" y2="53.2"/></g><g class="cxb"><line y1="17.9" x2="52.2" y2="17.9" x1="4"/><line x1="68.9" y1="41.9" x2="93" y2="41.9"/><line x1="9.8" y1="38.9" x2="46.3" y2="38.9"/><line x1="9.8" y1="41.9" x2="46.3" y2="41.9"/><line x1="72" y1="80.4" x2="96" y2="80.4"/><line x1="13" y1="77.4" x2="49.5" y2="77.4"/><line x1="13" y1="80.4" x2="49.5" y2="80.4"/><line x1="86.3" y1="30.6" x2="93" y2="30.6"/><line x1="76.4" y1="5.2" x2="83" y2="5.2"/><line x1="13.5" y1="53.9" x2="22.5" y2="53.9"/><line x1="83.3" y1="56.2" x2="92.4" y2="56.2"/><line x1="61.9" y1="65.4" x2="79.8" y2="65.4"/></g>',
                                    a_alignright: '<g class="cxb"><rect x="40" y="2" width="45" height="38" rx="5" /><rect x="10" y="52" width="75" height="38" rx="5" /></g><g class="cxa"><line x1="97" y1="1" x2="97" y2="99" /></g>',
                                    gr_style: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxa"><line x1="4" y1="23" x2="98" y2="23" /> <line x1="4" y1="48" x2="98" y2="48" stroke-dasharray="5" /> <line x1="4" y1="73" x2="98" y2="73" stroke-dasharray="15 5"/></g>',
                                    dps_inout: '<g class="cxa"><polyline points="65,30 65,2 2,2 2,98 65,98 65,70" /></g><path class="cxtxb" d="M71,38 L83,50 L71,62 M29,38 L17,50 L29,62 M83,50 L17,50" />',
                                    at_col2: '<path class="cl0" d="M74.6,6.5L50,50V0C58.6,0,67.1,2.2,74.6,6.5z"/><path class="cl1" d="M93.5,25.4L50,50L74.6,6.5C82.5,11,89,17.5,93.5,25.4z"/><path class="cl2" d="M100,50H50l43.5-24.6C97.8,32.9,100,41.4,100,50z"/><path class="cl3" d="M100,50c0,8.6-2.2,17.1-6.5,24.6L50,50H100z"/><path class="cl4" d="M93.5,74.6C89,82.5,82.5,89,74.6,93.5L50,50L93.5,74.6z"/><path class="cl5" d="M74.6,93.5c-7.5,4.2-16,6.5-24.6,6.5V50L74.6,93.5z"/><path class="cl6" d="M50,50v50c-8.6,0-17.1-2.2-24.6-6.5L50,50z"/><path class="cl7" d="M50,50L25.4,93.5C17.5,89,11,82.5,6.5,74.6L50,50z"/><path class="cl8" d="M50,50L6.5,74.6C2.2,67.1,0,58.6,0,50H50z"/><path class="cl9" d="M50,50H0c0-8.6,2.2-17.1,6.5-24.6L50,50z"/><path class="cl10" d="M50,50L6.5,25.4C11,17.5,17.5,11,25.4,6.5L50,50z"/><path class="cl11" d="M50,0v50L25.4,6.5C32.9,2.2,41.4,0,50,0z"/>',
                                    a_moveforward: '<g class="cxb"><polyline points="22,42 2,42 2,2 42,2 42,22" /></g><g class="cxa"><rect x="22" y="22" width="76" height="76" /></g>',
                                    p_ghsamplelabels: '<g class="cxblue"><rect x="15" y="25" width="3" height="10"/><rect x="15" y="45" width="3" height="10"/></g>',
                                    bx_wishkersn: '<g class="cxb"><rect x="35" y="30" width="30" height="40" /><line x1="35" y1="51" x2="65" y2="51" /></g>',
                                    b_windowgradient: '<g class="cxa"><polyline fill="url(\'#w-grad\')" points="65,45 65,30 48,30 48,15 15,15 15,83 68,83 45,65 65,45" /></g>',
                                    ch_lb: '<text class="cxtb100" x="15" y="85">B</text>',
                                    ps_top: '<path class="cxtxb" d="M42,38 L50,30 L58,38 M50,70 L50,30" /><g class="cxa"><rect x="40" y="2" width="20" height="20" rx="2" /></g>',
                                    cd_lines: '<g class="cxa"><line x1="10" y1="10" x2="40" y2="10" /><line x1="10" y1="18" x2="40" y2="18" /><line x1="10" y1="26" x2="40" y2="26" /><line x1="10" y1="34" x2="70" y2="34" /><line x1="10" y1="42" x2="60" y2="42" /><line x1="10" y1="50" x2="50" y2="50" /><line x1="10" y1="58" x2="50" y2="58" /><line x1="10" y1="66" x2="50" y2="66" /><line x1="10" y1="74" x2="50" y2="74" /><line x1="10" y1="82" x2="60" y2="82" /><line x1="10" y1="90" x2="70" y2="90" /></g>',
                                    dp_binr: '<g class="cxb"><circle cx="50" cy="3" r="2.5" /><circle cx="50" cy="18" r="2.5" /><circle cx="50" cy="33" r="2.5" /><circle cx="57" cy="33" r="2.5" /><circle cx="50" cy="50" r="2.5" /><circle cx="57" cy="50" r="2.5" /><circle cx="64" cy="50" r="2.5" /><circle cx="50" cy="65" r="2.5" /><circle cx="57" cy="65" r="2.5" /><circle cx="50" cy="80" r="2.5" /><circle cx="50" cy="97" r="2.5" /></g>',
                                    wp_code: '<g class="cxa"><polyline points="29.9 77.9 2.1 50 29.9 22.1" /><polyline points="70 77.9 97.9 50 70 22.1" /></g><g class="cxb"><line x1="60.2" y1="12.5" x2="39.6" y2="87.5" /></g>',
                                    ps_bottom: '<path class="cxtxb" d="M42,62 L50,70 L58,62 M50,70 L50,30" /><g class="cxa"><rect x="40" y="78" width="20" height="20" rx="2" /></g>',
                                    mr_all: '<g class="cxc"><line x1="2" y1="25" x2="98" y2="25" /><line x1="77" y1="2" x2="77" y2="98" /><line x1="2" y1="77" x2="98" y2="77" /><line x1="25" y1="2" x2="25" y2="98" /></g>',
                                    v_cancel: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtb100" x="22" y="77">x</text>',
                                    c_paultol: '<rect y="16.2" class="cl30" width="12.5" height="67.7"/><rect x="12.5" y="16.2" class="cl31" width="12.5" height="67.7"/><rect x="25" y="16.2" class="cl32" width="12.5" height="67.7"/><rect x="50" y="16.2" class="cl33" width="12.5" height="67.7"/><rect x="37.5" y="16.2" class="cl34" width="12.5" height="67.7"/><rect x="62.5" y="16.2" class="cl35" width="12.5" height="67.7"/><rect x="75" y="16.2" class="cl36" width="12.5" height="67.7"/><rect x="87.5" y="16.2" class="cl37" width="12.5" height="67.7"/>',
                                    dps_collapse: '<g class="cxa"><rect x="9.5" y="9.5" width="80" height="80" rx="4" /></g><text class="cxtb100" x="3" y="95">&#8963;</text>',
                                    p_g3axistitlex: '<g class="cxblue"><rect x="40" y="85" width="30" height="2"/></g>',
                                    ch_lt: '<text class="cxtb100" x="15" y="85">T</text>',
                                    ch_lw: '<text class="cxtb100" x="2" y="85">W</text>',
                                    g_map: '<g class="cxa"><ellipse cx="50" cy="50" rx="26.6" ry="47.8"/><path d="M 87.9 20.9 C 79.2 25.3 65.4 28.2 50 28.2 C 34.5 28.2 20.8 25.3 12 20.9"/><path d="M 87.9 79 C 79.2 74.6 65.4 71.7 50 71.7 C 34.5 71.7 20.8 74.6 12 79"/><line x1="97.8" y1="50" x2="2.1" y2="50"/><line x1="50" y1="2.1" x2="50" y2="97.8"/></g><g class="cxb"><circle cx="50" cy="50" r="47.8"/></g>',
                                    ch_lu: '<text class="cxtb100" x="15" y="85">U</text>',
                                    g_kaplanmeier: '<g class="cxb"><polyline points="11.9 28.5 25.6 28.5 25.6 44.8 39.6 44.8 39.6 56.7 50 56.7 50 68.8 76.7 68.8 76.7 75.4 100 75.4"/><polyline points="11.9 7 37.5 7 37.5 15.6 50 15.6 50 39.1 70.8 39.1 70.8 56 90.7 56 90.7 62.6 100 62.6"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/><line x1="35.2" y1="100" x2="35.2" y2="86"/><line x1="58.5" y1="100" x2="58.5" y2="85.5"/><line x1="81.9" y1="100" x2="81.9" y2="85.5"/></g>',
                                    tx_format: '<g class="cxb"><circle cx="60" cy="49.7" r="12.3"/><path d="M59.1,77.5c2,0.1,4-0.1,6-0.5l6,8.4l10.8-5.2L79,70c1.4-1.3,2.6-2.7,3.7-4.3l10.5,1.7l3.9-11.3L87.8,51c0.1-1.9,0-3.8-0.4-5.7l8.5-6.2l-5.2-10.8l-9.9,2.9c-1.3-1.5-2.8-2.9-4.4-4.1l1.6-10.1l-11.3-3.9l-4.8,8.6c-2.2-0.2-4.3-0.1-6.5,0.2l-5.7-7.8l-10.8,5.2"/></g><g class="cxaa"><path d="M47,67.5H20.2l-3.4,7.4c-0.9,2-1.4,4.1-1.5,6.3c-0.1,1.9,0.9,3.8,2.6,4.7c2.4,0.9,4.9,1.3,7.5,1.3v2.1H0v-2.1c2.6-0.3,4.9-1.5,6.7-3.4c2.8-3.5,5.1-7.5,6.7-11.7l27.1-60.8h1.1L69,73.9c1.5,4.1,3.7,7.9,6.5,11.2c1.5,1.2,3.4,1.9,5.4,2v2.1H43.9v-2.1h1.5c2.2,0.2,4.3-0.2,6.2-1.2c0.8-0.6,1.3-1.6,1.2-2.6c0-0.7-0.1-1.4-0.3-2.1c0-0.3-0.6-1.7-1.7-4.2L47,67.5zM45.1,63.4L33.6,37.1L22,63.4L45.1,63.4z"/></g>',
                                    ch_oinfo: '<text class="cxts150 cxaa" x="20" y="85">i</text>',
                                    wp_installation: '<g class="cxa"><path d="M 65.2 51.9 C 82.4 58.5 100.3 43.9 97.4 25.7 C 97.1 23.8 96.5 21.8 95.8 20 L 83.3 32.5 L 73.5 29.8 L 70.8 19.9 L 83.2 7.5 C 66.2 0.3 47.8 14.1 50 32.4 C 50.3 35.1 51.1 37.7 52.3 40.1"/><polyline points="35 57.1 10.1 82 22.6 94.5 41.3 75.7"/></g><g class="cxb"><rect x="62.8" y="52" width="17.8" height="39.3" transform="matrix(0.707107, -0.707107, 0.707107, 0.707107, -30.578448, 74.020113)"/><line x1="43.9" y1="73.2" x2="70" y2="47.1"/><polygon points="28.5 15.7 12.1 5.5 2.3 15.3 12.5 31.7 19.4 30.6 53.1 64.2 61 56.3 27.4 22.6 28.5 15.7"/></g>',
                                    g_gantt: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g><g class="cxb"><rect x="24" y="10.6" width="29.6" height="10.5"/><rect x="66" y="64.1" width="29.6" height="10.5"/><rect x="43.2" y="28.5" width="20.9" height="10.5"/><rect x="56.4" y="46.3" width="16.3" height="10.5"/></g>',
                                    p_g2axestitles: '<g class="cxblue"><rect x="40" y="85" width="30" height="2"/><rect x="0" y="25" width="3" height="25"/></g>',
                                    wp_instances: '<g class="cxb"><polyline points="17.2 31.7 17.2 16.6 82.7 16.6 82.7 82.1 67.7 82.1"/><polyline points="32.3 17.7 32.3 2.7 97.8 2.7 97.8 68.3 82.7 68.3"/></g><g class="cxa"><rect x="2.2" y="31.7" width="65.5" height="65.5"/></g>',
                                    sp_heightness: '<path class="cxtxa" d="M58,42 L66,50 L58,58 M42,42 L34,50 L42,58 M66,50 L34,50" /><g class="cxb"><rect x="2" y="40" width="26" height="56" /><rect x="72" y="2" width="26" height="96" /></g>',
                                    p_g3axistitlez: '<g class="cxblue"><line x1="55" y1="55" x2="65" y2="47"/></g>',
                                    ar_dctrs2: '<text class="cxtn60 cxaa" x="42" y="-22" transform="rotate(45)">&#10554;</text><text class="cxtn60 cxaa" x="-100" y="-22" transform="rotate(45) scale(-1,1)">&#10554;</text>',
                                    ch_creturn: '<text class="cxtn80" x="5" y="90">&#8629;</text>',
                                    ch_sampersand: '<text class="cxtb100" x="15" y="85">&#38;</text>',
                                    a_alignbottom: '<g class="cxb"><rect x="2" y="40" width="38" height="45" rx="5" /><rect x="52" y="10" width="38" height="75" rx="5" /></g><g class="cxa"><line x1="1" y1="97" x2="99" y2="97" /></g>',
                                    ps_topright: '<path class="cxtxb" d="M58,34 L66,34 L66,42 M34,66 L66,34" /><g class="cxa"><rect x="78" y="2" width="20" height="20" rx="2" /></g>',
                                    m_right: '<g class="cxaa"><path d="M50,10 Q 75,10 75,25 L75,35 55,35 55,30 Q 55,25 50,25 Z" /></g>',
                                    tx_tonumeric: '<text class="cxtn60" x="0" y="65">a</text><g class="cxaa"><text class="cxtn60" x="65" y="70">#</text><text class="cxtn60" x="20" y="100">&#10555;</text></g>',
                                    sr_azi: '<path class="cxtxa" d="M12,80 L27,98 L42,80 M27,98 L27,2" /><text class="cxtn60" x="50" y="45">A</text><text class="cxtn60" x="50" y="95">Z</text>',
                                    ch_lr: '<text class="cxtb100" x="15" y="85">R</text>',
                                    sv_pictures: '<g class="cxa"><path d="M59,14 Q 81,30 79,57 Q 79,89 98,98" /><circle cx="35" cy="18" r="6" /><circle cx="52" cy="32" r="6" /><circle cx="19" cy="32" r="6" /><circle cx="26" cy="50" r="6" /><circle cx="46" cy="50" r="6" /></g><g class="cxb"><circle cx="35" cy="35" r="32" /><circle cx="35" cy="35" r="1" /></g>',
                                    xar_dctrs2: '<path class="cxtxa" d="M 50 10 A 40 40 0 0 1 90 50 M58,3 L50,10 L58,18 M97,42 L90,50 L82,42" />',
                                    a_movebackward: '<g class="cxb"><rect x="2" y="2" width="40" height="40" /></g><g class="cxa"><polyline points="42,22 98,22 98,98 22,98 22,42" /></g>',
                                    c_ggplot: '<polygon class="cl20" points="8.5,26 8.5,74 50,98 91.6,74 91.6,26 50,2"/><rect x="12.7" y="23.8" class="cl21" width="75.7" height="0.8"/><rect x="9.6" y="41.9" class="cl21" width="82" height="0.8"/><rect x="9.6" y="60" class="cl21" width="82" height="0.8"/><rect x="20.2" y="79" class="cl21" width="60.6" height="0.8"/><rect x="31.2" y="13" class="cl21" width="0.8" height="74.8"/><rect x="12.8" y="23" class="cl21" width="0.8" height="54.8"/><rect x="67.7" y="13" class="cl21" width="0.8" height="74.8"/><rect x="86.1" y="23" class="cl21" width="0.8" height="54.8"/><rect x="49.5" y="2.3" class="cl21" width="0.8" height="96.1"/><polygon class="cl22" points="12.7,52 11,49.3 45.7,26.8 55,41.5 85.7,22.4 87.4,25.2 54,45.8 44.7,31.2 \t\t"/><path class="cl23" d="M82.8,20.3c-2.1,1.5-2.6,4.4-1.1,6.5s4.4,2.6,6.5,1.1c0.9-0.7,1.6-1.7,1.9-2.8C88.2,24,85,21.8,82.8,20.3z"/><circle class="cl24" cx="11.8" cy="51.4" r="4.7"/><circle class="cl25" cx="27.6" cy="39.6" r="4.7"/><circle class="cl26" cx="44.9" cy="29.2" r="4.7"/><circle class="cl27" cx="54.8" cy="43.6" r="4.7"/><circle class="cl28" cx="70.9" cy="33.2" r="4.7"/><path class="cl22" d="M50,3.7l40.1,23.2v46.4L50,96.3L9.9,73.2V26.8L50,3.7 M50,0L6.7,25v50L50,100l43.3-25V25L50,0z"/><path class="cl22" d="M29.9,60.5c0,0.7,0,1.5,0,2.6v5.5c0.2,1.6-0.2,3.1-1.2,4.4c-0.9,0.8-2,1.2-3.2,1.1c-1,0-2-0.4-2.9-1l0.4-1.3c0.7,0.5,1.6,0.8,2.5,0.8c1.6,0,2.7-0.9,2.7-3.2v-1.1l0,0c-0.5,1-1.6,1.6-2.7,1.6c-2.1,0-3.6-2-3.6-4.7c0-3.2,1.9-5.1,3.8-5.1c1.2,0,2.2,0.6,2.7,1.7l0,0v-1.5L29.9,60.5z M28.3,64.3c0-0.3,0-0.5,0-0.8c-0.2-1-1.1-1.8-2.2-1.8c-1.5,0-2.5,1.4-2.5,3.6s0.9,3.4,2.5,3.4c1-0.1,1.9-0.8,2.1-1.8c0-0.3,0-0.6,0-0.9L28.3,64.3z"/><path class="cl22" d="M39.7,60.5c0,0.7,0,1.5,0,2.6v5.5c0.2,1.5-0.2,3-1.1,4.2c-0.9,0.8-2,1.2-3.2,1.1c-1,0-2-0.3-2.9-0.8l0.4-1.3c0.7,0.5,1.6,0.8,2.5,0.8c1.6,0,2.8-0.9,2.8-3.2v-1.1l0,0c-0.6,1-1.6,1.6-2.8,1.7c-2.1,0-3.6-2-3.6-4.7c0-3.2,1.9-5.1,3.8-5.1c1.1,0,2.2,0.6,2.6,1.7l0,0v-1.5L39.7,60.5z M38.1,64.3c0-0.3,0-0.5,0-0.8c-0.2-1-1.1-1.8-2.2-1.8c-1.5,0-2.5,1.4-2.5,3.6s0.8,3.4,2.5,3.4c1-0.1,1.9-0.8,2-1.8c0-0.3,0-0.6,0-0.9L38.1,64.3z"/><path class="cl22" d="M42.1,63.5c0-1.2,0-2.2,0-3.2h1.4v1.7l0,0c0.5-1.2,1.7-1.9,3-1.9c2.1,0,3.6,2,3.6,4.9c0,3.4-1.8,5.2-3.9,5.2c-1.1,0-2.1-0.5-2.6-1.5l0,0v5.2h-1.5L42.1,63.5z M43.6,66c0,0.2,0,0.5,0,0.7c0.2,1.1,1.2,2,2.3,2c1.6,0,2.6-1.5,2.6-3.7s-0.9-3.6-2.5-3.6c-1.2,0.1-2.1,1-2.3,2.2c0,0.2,0,0.5,0,0.7L43.6,66z"/><path class="cl22" d="M52.1,55.9h1.5V70h-1.5V55.9z"/><path class="cl22" d="M64,65c0,3.5-2.2,5.1-4.2,5.1s-4.1-1.9-4.1-4.9c0-3,1.8-5.1,4.2-5.1S64,62.1,64,65z M57.3,65c0,2.1,1.1,3.7,2.6,3.7s2.6-1.6,2.6-3.7c0-1.6-0.7-3.7-2.5-3.7S57.2,63.3,57.3,65L57.3,65z"/><path class="cl22" d="M67.8,57.6v2.9H70v1.3h-2.2v5c0,1.2,0.3,1.8,1.1,1.8c0.3,0,0.6,0,0.9,0V70c-0.4,0.2-0.9,0.2-1.4,0.2c-0.6,0-1.2-0.2-1.7-0.7c-0.5-0.8-0.7-1.7-0.5-2.6v-5.2h-1.3v-1.2h1.3v-2.3L67.8,57.6z"/><path class="cl22" d="M71.2,70V69l1.2-1.3c2.9-3.2,4.2-4.8,4.2-6.7c0-1.3-0.5-2.5-2.3-2.5c-0.9,0-1.8,0.4-2.4,1.1l-0.5-1.2c0.9-0.8,2-1.3,3.2-1.3c1.9-0.1,3.5,1.4,3.6,3.3c0,0.1,0,0.2,0,0.2c0,2.4-1.5,4.3-3.9,6.9l-0.9,0.9l0,0h5.2V70H71.2z"/>',
                                    c_wallstreetjournal: '<rect width="100" height="100" fill="url(\'#WS-gradient\')"/><path d="M 30.1 39.9 C 30.1 40.3 30 40.6 29.9 41 C 28 48.9 26.1 56.9 24.1 64.8 L 23.2 68.6 C 23.2 68.8 23.2 69 22.8 69 C 22.3 69 22.4 68.8 22.3 68.6 L 18.2 51.7 C 16.8 46.1 15.5 40.5 14.1 34.8 L 13.9 34 C 13.7 33.1 12.8 32.3 11.9 32.3 L 10.1 32.1 L 10.1 30.9 L 21.4 30.9 C 21.9 30.9 21.9 30.9 21.9 31.5 L 21.9 32.1 L 20.6 32.3 C 19.5 32.6 19.1 33.2 19.2 34.3 C 19.4 35.6 19.7 36.9 20 38.1 L 23.9 54 C 23.9 54.7 24.2 55.3 24.4 56 C 24.4 56.2 24.4 56.3 24.4 56.4 L 24.4 56.4 C 24.4 56.1 24.4 55.8 24.7 55.5 C 26.2 49.2 27.8 43 29.4 36.9 C 29.5 36.7 29.5 36.5 29.4 36.3 C 29.2 35.5 28.9 34.7 28.7 34 C 28.3 33 27.4 32.3 26.4 32.2 L 25.7 32.2 L 25.7 31 L 36.9 31 C 37.3 31 37.4 31 37.4 31.4 C 37.4 31.6 37.4 31.9 37.4 32.1 L 35.7 32.4 L 35.4 32.4 C 34 32.7 33.6 33.3 33.9 34.7 C 34.2 36.1 34.7 38.4 35.2 40.2 L 38.9 55.8 C 38.9 56.3 39.2 56.8 39.3 57.3 L 39.3 57.3 C 39.4 57.2 39.4 57 39.5 56.8 L 41.6 47.6 C 42.6 43.5 43.5 39.3 44.5 35.2 C 44.5 34.8 44.5 34.3 44.5 33.9 C 44.6 33.4 44.3 32.9 43.9 32.6 C 43.1 32.4 42.3 32.3 41.5 32.2 L 41.2 32.2 C 41.1 31.9 41.1 31.5 41.2 31.2 C 41.2 31.2 41.4 31 41.5 31 L 49.5 31 C 49.9 31 50 31 50 31.4 C 49.9 31.7 49.9 31.9 50 32.2 L 49.4 32.2 C 47.9 32.3 46.6 33.4 46.3 35 C 45.8 37.3 45.2 39.6 44.6 41.9 C 43.5 46.7 42.3 51.4 41.2 56.1 C 40.2 60.3 39.2 64.4 38.3 68.5 C 38.3 68.7 38.3 69 37.8 69 C 37.4 69 37.4 69 37.4 68.6 L 35.1 59.5 C 33.8 54 32.4 48.6 31.1 43.2 C 30.9 42.3 30.7 41.3 30.4 40.4 L 30.4 40 Z" /><path d="M 50.3 56.6 C 51.1 56.6 51.1 56.6 51.5 57.1 C 52.7 59.8 54.3 62.4 56.2 64.6 C 57.2 65.9 58.6 67 60.1 67.7 C 61.2 68.3 62.6 68.3 63.7 67.7 C 64.6 67.2 65.3 66.3 65.5 65.3 C 66.5 62.5 66 59.5 64.1 57.2 C 62.8 55.5 61.3 54.1 59.6 52.8 C 57.6 51.4 55.8 49.8 54 48 C 51.9 45.8 50.7 42.9 50.6 39.9 C 50.6 37.4 51.5 35 53.1 33.1 C 55.4 30.6 59 30 61.9 31.7 C 62.6 32.1 63.2 32.5 63.8 32.9 L 64.4 33.4 C 64.9 33.7 65.5 33.7 65.9 33.4 C 66.3 32.9 66.7 32.4 67 31.8 C 67.3 31.4 67.3 31.3 67.9 31.5 L 67.9 41.8 C 67.9 42 67.9 42.3 67.7 42.3 C 67.4 42.3 67 42.3 66.9 42 C 66.1 39.5 64.8 37.1 63.2 35 C 62.5 34 61.5 33.2 60.4 32.6 C 57.8 31.2 54.6 32.9 54.3 35.8 C 53.8 38.2 54.4 40.7 56 42.5 C 57.2 44 58.6 45.3 60.1 46.5 C 62.3 48.2 64.3 50 66.3 51.9 C 68 53.6 69.1 55.8 69.4 58.2 C 70 61.3 69.3 64.4 67.5 67 C 65.7 69.4 62.6 70.3 59.8 69.3 C 58.3 68.7 56.9 68 55.7 67 C 55.6 66.8 55.4 66.7 55.2 66.6 C 54.4 66 54 66 53.2 66.6 C 52.6 67.2 52.1 67.9 51.6 68.6 C 51.4 68.9 50.9 69.1 50.7 68.9 C 50.6 68.8 50.6 68.7 50.7 68.6 L 50.7 56.6 Z" /><path d="M 77.2 32.1 L 77.2 31 L 89.9 31 C 90 31.3 90 31.6 89.9 31.9 C 89.8 32 89.7 32 89.6 31.9 C 89 31.9 88.3 31.9 87.7 31.9 C 86.9 32 86.3 32.5 86.3 33.3 C 86.3 33.6 86.3 34 86.3 34.3 L 86.3 60.1 C 86.4 62.1 85.8 64 84.6 65.7 C 83.2 67.7 80.9 69 78.4 69 C 76.1 69.2 73.9 68.1 72.8 66.1 C 71.5 64.1 71.5 61.5 72.8 59.4 C 73.4 58.4 74.5 57.8 75.6 57.8 C 76.6 57.7 77.6 58.4 77.9 59.3 C 78.4 60.3 78.3 61.5 77.5 62.3 C 77 62.8 76.4 63.2 75.8 63.6 C 74.6 64.4 74.4 65.3 75.1 66.7 C 75.6 67.5 76.4 67.9 77.2 67.9 C 77.7 68 78.2 68 78.7 67.9 C 79.6 67.7 80.4 67 80.7 66.1 C 80.9 65.2 81.1 64.2 81.2 63.3 C 81.2 61.8 81.2 60.4 81.2 58.9 L 81.2 34.9 C 81.2 34.4 81.2 33.9 81.2 33.4 C 81.1 32.9 80.6 32.4 80.1 32.3 C 79.4 32.2 78.8 32.2 78.1 32.1 Z" />',
                                    p_cg2fitqq: '<g class="cxb"><line x1="10" y1="70" x2="98" y2="32" /></g><g class="cxa"><path d="M15,90 C30,25 80,75 95,10"/></g>',
                                    p_cg2datahist: '<g class="cxcc"><rect x="17" y="54" width="7" height="34" /><rect x="31" y="34" width="7" height="54" /><rect x="45" y="14" width="7" height="74" /><rect x="59" y="20" width="7" height="68" /><rect x="73" y="39" width="7" height="49" /><rect x="87" y="56" width="7" height="32" /></g>',
                                    xar_dcbls2: '<path class="cxtxa" d="M 50 90 A 40 40 0 0 1 10 50 M42,82 L50,90 L42,97 M3,58 L10,50 L18,58" />',
                                    ar_l: '<path class="cxtxb" d="M20,35 L2,50 L20,65 M98,50 L2,50" />',
                                    p_cghaxes: '<g class="cxb"><rect x="10" y="2" width="88" height="88"/><line x1="10" y1="24" x2="98" y2="24" /><line x1="10" y1="46" x2="98" y2="46" /><line x1="10" y1="68" x2="98" y2="68" /><rect x="0" y="10" width="2" height="6"/><rect x="0" y="32" width="2" height="6"/><rect x="0" y="54" width="2" height="6"/><rect x="0" y="76" width="2" height="6"/><line x1="40" y1="2" x2="40" y2="90" /><line x1="70" y1="2" x2="70" y2="90" /><rect x="20" y="98" width="10" height="2"/><rect x="50" y="98" width="10" height="2"/><rect x="80" y="98" width="10" height="2"/></g>',
                                    sr_19: '<path class="cxtxb" d="M2,80 L17,98 L32,80 M17,98 L17,2" /><path class="cxtxb" d="M27,20 L42,2 L57,20 M42,98 L42,2" /><g class="cxaa"><text class="cxtn60" x="60" y="45">1</text><text class="cxtn60" x="60" y="95">9</text></g>',
                                    p_g3titlesubtitle: '<g class="cxblue"><rect x="45" y="0" width="30" height="2"/><rect x="50" y="10" width="20" height="2"/></g>',
                                    xar_dcbls: '<path class="cxtxb" d="M 50 90 A 40 40 0 0 1 10 50 M42,82 L50,90 L42,97 M3,58 L10,50 L18,58" />',
                                    at_shd: '<polygon fill="url(#s-grad)" points="94.5,64.1 66.7,50 50,58.5 33.3,50 5.5,64.1 50,86.7"/><polygon class="cxa" points="94.5,35.9 50,13.3 5.5,35.9 50,58.5 "/>',
                                    ch_oe10: '<text class="cxts150" x="10" y="70">e</text><text class="cxtn40" x="50" y="85">10</text>',
                                    ch_ofx: '<text class="cxti100" x="16" y="75">fx</text>',
                                    a_group: '<g class="cxb"><polyline points="42,57 27,57 27,27 57,27 57,42" /><rect x="42" y="42" width="30" height="30" /></g><g class="cxa"><line x1="18" y1="10" x2="82" y2="10" stroke-dashoffset="-3" stroke-dasharray="8"/><line x1="18" y1="90" x2="82" y2="90" stroke-dashoffset="-3" stroke-dasharray="8"/><line x1="10" y1="18" x2="10" y2="82" stroke-dashoffset="-3" stroke-dasharray="8"/><line x1="90" y1="18" x2="90" y2="82" stroke-dashoffset="-3" stroke-dasharray="8"/><rect x="2" y="2" width="16" height="15" /><rect x="2" y="82" width="16" height="15" /><rect x="82" y="2" width="16" height="15" /><rect x="82" y="82" width="16" height="15" /></g>',
                                    a_movefront: '<g class="cxb"><polyline points="20,32 2,32 2,2 32,2 32,20" /><polyline points="85,68 98,68 98,98 68,98 68,85" /></g><g class="cxa"><rect x="20" y="20" width="65" height="65" /></g>',
                                    xar_dctrs: '<path class="cxtxb" d="M 50 10 A 40 40 0 0 1 90 50 M58,3 L50,10 L58,18 M97,42 L90,50 L82,42" />',
                                    gr_g2y: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="100" y2="98" /></g><g class="cxa"><line x1="4" y1="18" x2="98" y2="18" /> <line x1="4" y1="38" x2="98" y2="38" /> <line x1="4" y1="58" x2="98" y2="58" /> <line x1="4" y1="78" x2="98" y2="78" /></g>',
                                    mr_left: '<g class="cxa"><line x1="25" y1="2" x2="25" y2="98" /></g>',
                                    o_ghvars: '<g class="cxc"><rect x="15" y="2" width="70" height="40" /><line x1="15" y1="22" x2="85" y2="22" /><line x1="50" y1="2" x2="50" y2="42" /><rect x="2" y="6" width="4" height="2" /><rect x="2" y="26" width="4" height="2" /><rect x="20" y="55" width="20" height="2" /><rect x="60" y="55" width="20" height="2" /></g><g class="cxa"><rect x="15" y="68" width="70" height="28" /><line x1="15" y1="82" x2="85" y2="82" /><line x1="50" y1="68" x2="50" y2="96" /><rect x="95" y="75" width="2" height="2" /><rect x="95" y="89" width="2" height="2" /></g>',
                                    p_ghtitle: '<g class="cxblue"><rect x="50" y="0" width="30" height="2"/></g>',
                                    p_cg2datahiststag: '<g class="cxbb"><rect x="17" y="70" width="7" height="18" /><rect x="31" y="56" width="7" height="32" /><rect x="45" y="38" width="7" height="50" /><rect x="59" y="34" width="7" height="54" /><rect x="73" y="62" width="7" height="26" /><rect x="87" y="74" width="7" height="14" /></g>',
                                    fp_pencil: '<g class="cxb"><path d="M72,10 L90,27 M68,14 L86,31 M2,80 L20,98 M11,89 L77,22" /></g><g class="cxa"><path d="M74,8 Q 80,2 86,4 L96,14 Q 98,20 92,25 L20,98 L2,98 L2,80 L74,8" /></g>',
                                    rt_ac: '<g class="cxb"><path d=" M 18 18 A 45 45 225 1 1 5 50" /><line x1="18" y1="0" x2="18" y2="18" /><line x1="36" y1="18" x2="16" y2="18" /></g>',
                                    ar_tm: '<path class="cxtxb" d="M38,29 L50,17 L62,29 M50,83 L50,17" />',
                                    ch_oparens: '<text class="cxtn100" x="0" y="75">{ }</text>',
                                    v_cancelsmall: '<circle class="cxa" cx="50" cy="50" r="35" /><text class="cxtn60 cxrr" x="35" y="66">x</text>',
                                    p_cg1axeshorizontal: '<g class="cxb"><line x1="10" y1="2" x2="10" y2="98" /><rect x="0" y="67" width="2" height="10"/><rect x="0" y="39" width="2" height="10"/><rect x="0" y="11" width="2" height="10"/><line x1="2" y1="90" x2="98" y2="90" /><line x1="30" y1="90" x2="30" y2="98" /><line x1="50" y1="90" x2="50" y2="98" /><line x1="70" y1="90" x2="70" y2="98" /><line x1="90" y1="90" x2="90" y2="98" /></g>',
                                    ps_toloc2: '<path class="cxtxb" d="M35,80 L50,98 L65,80 M35,20 L50,2 L65,20 M50,98 L50,2" /><path class="cxtxb" d="M80,35 L98,50 L80,65 M20,35 L2,50 L20,65 M98,50 L2,50" /><g class="cxaa"><rect x="36" y="36" width="25" height="25" /></g>',
                                    bx_type: '<g class="cxb"><rect x="2" y="30" width="20" height="40" /><line x1="2" y1="51" x2="22" y2="51" /><line x1="2" y1="2" x2="22" y2="2" /><line x1="12" y1="2" x2="12" y2="30" /><line x1="12" y1="70" x2="12" y2="98" /><line x1="2" y1="98" x2="22" y2="98" /><path d="M80,7 Q 80,2 85,2 90,2 90,7 L90,40 Q 97,41 98,50 97,59 90,60 L90,93 Q 90,98 85,98 80,98 80,93 L80,60 Q 73,59 72,50 73,41 80,40 Z" /></g><path class="cxtxa" d="M56,44 L64,52 L56,60 M40,44 L32,52 L40,60 M64,52 L32,52" />',
                                    g_histogram: '<g class="cxb"><rect x="21.2" y="44.8" width="11.8" height="41.2"/><rect x="33" y="27.4" width="11.8" height="58.6"/><rect x="44.9" y="12.7" width="11.8" height="73.3"/><rect x="56.7" y="26" width="11.8" height="60"/><rect x="68.5" y="49.3" width="11.8" height="36.7"/><rect x="80.3" y="65.4" width="11.8" height="20.6"/></g><g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/><line x1="35.4" y1="100" x2="35.4" y2="86"/><line x1="58.9" y1="100" x2="58.9" y2="86"/><line x1="82.5" y1="100" x2="82.5" y2="86"/></g>',
                                    op_undo: '<g class="cxa"><path d="M5.5,31.5l39.8-29V16h1.1c26.2-0.4,47.8,20.6,48.1,46.8c0,0,0,0.1,0,0.1c0,13.2-5.7,25.7-15.5,34.5c3.4-5.4,5.3-11.6,5.3-18C84.1,60,68.1,44.5,48.7,44.8c0,0,0,0,0,0c-1.1,0-2.2,0-3.4,0.2v15.6L5.5,31.5z"/></g>',
                                    ar_h: '<path class="cxtxb" d="M80,35 L98,50 L80,65 M20,35 L2,50 L20,65 M98,50 L2,50" />',
                                    p_cg1dataverticalhorizontal: '<g class="cxa"><line x1="2" y1="2" x2="2" y2="45" /><line x1="2" y1="45" x2="45" y2="45" /><line x1="53" y1="53" x2="53" y2="96" /><line x1="53" y1="96" x2="96" y2="95" /></g><g class="cxcc"><rect x="9" y="20" width="10" height="24" /><rect x="28" y="10" width="10" height="34" /><rect x="55" y="59" width="24" height="10" /><rect x="55" y="78" width="34" height="10" /></g><g class="cxaa"><text class="cxtn60" x="42" y="-22" transform="rotate(45)">&#10554;</text><text class="cxtn60" x="-100" y="-22" transform="rotate(45) scale(-1,1)">&#10554;</text><text class="cxtn60" x="44" y="51" transform="rotate(45)">&#10555;</text><text class="cxtn60" x="-96" y="51" transform="rotate(45) scale(-1,1)">&#10555;</text></g>',
                                    g_oncoprint: '<g class="cxbb"><rect x="14.4" y="4.2" width="16.4" height="20.4"/><rect x="47.8" y="4.2" width="16.4" height="20.4"/><rect x="80.9" y="31.3" width="16.4" height="6.6"/><rect x="80.9" y="51.6" width="16.4" height="6.6"/><rect x="14.5" y="51.6" width="16.4" height="6.6"/><rect x="64.4" y="51.6" width="16.4" height="6.6"/></g><g class="cxcc"><rect x="64.1" y="11" width="16.4" height="6.6"/><rect x="47.8" y="71.9" width="16.4" height="6.6"/><rect x="30.7" y="31.3" width="16.4" height="6.6"/><rect x="80.9" y="71.9" width="16.4" height="6.6"/></g><g class="cxa"><rect x="14.4" y="4.2" width="16.6" height="20.3"/><rect x="31" y="4.2" width="16.6" height="20.3"/><rect x="64.3" y="4.2" width="16.6" height="20.3"/><rect x="80.9" y="4.2" width="16.6" height="20.3"/><rect x="47.6" y="4.2" width="16.6" height="20.3"/><rect x="14.4" y="24.5" width="16.6" height="20.3"/><rect x="31" y="24.5" width="16.6" height="20.3"/><rect x="64.3" y="24.5" width="16.6" height="20.3"/><rect x="80.9" y="24.5" width="16.6" height="20.3"/><rect x="47.6" y="24.5" width="16.6" height="20.3"/><rect x="14.4" y="44.8" width="16.6" height="20.3"/><rect x="31" y="44.8" width="16.6" height="20.3"/><rect x="64.3" y="44.8" width="16.6" height="20.3"/><rect x="80.9" y="44.8" width="16.6" height="20.3"/><rect x="47.6" y="44.8" width="16.6" height="20.3"/><rect x="14.4" y="65.1" width="16.6" height="20.3"/><rect x="31" y="65.1" width="16.6" height="20.3"/><rect x="64.3" y="65.1" width="16.6" height="20.3"/><rect x="80.9" y="65.1" width="16.6" height="20.3"/><rect x="47.6" y="65.1" width="16.6" height="20.3"/></g><g class="cxa"><line x1="2.5" y1="10" x2="2.5" y2="18"/><line x1="2.5" y1="30.6" x2="2.5" y2="38.6"/><line x1="2.5" y1="51" x2="2.5" y2="58.9"/><line x1="2.5" y1="71.3" x2="2.5" y2="79.2"/><line x1="18.6" y1="95.8" x2="26.6" y2="95.8"/><line x1="35.3" y1="95.8" x2="43.3" y2="95.8"/><line x1="51.9" y1="95.8" x2="59.9" y2="95.8"/><line x1="68.5" y1="95.8" x2="76.5" y2="95.8"/><line x1="85.3" y1="95.8" x2="93.2" y2="95.8"/></g>',
                                    n_edges: '<g class="cxa"><line x1="18.9" y1="15.4" x2="41.7" y2="31.3"/><line x1="21.6" y1="75.8" x2="43.5" y2="53.1"/><line x1="56.7" y1="76.6" x2="55.9" y2="57.1"/><line x1="84.3" y1="60.8" x2="69.5" y2="50.2"/><line x1="78" y1="13.9" x2="66.4" y2="28.2"/></g><g class="cxc"><circle cx="55.3" cy="40.9" r="16.9"/><circle cx="82.3" cy="8.6" r="6.8"/><circle cx="89.9" cy="64.7" r="6.8"/><circle cx="16.9" cy="80.6" r="6.8"/><circle cx="12.2" cy="10.7" r="8.9"/><circle cx="57.1" cy="87.5" r="10.8"/></g>',
                                    wp_configuration: '<g class="cxa"><path d="M 97.2 61 L 97.2 39 L 83.5 39 C 83 37.3 82.3 35.7 81.4 34.1 L 91.2 24.4 L 75.6 8.8 L 65.9 18.5 C 64.3 17.7 62.7 17 61 16.4 L 61 2.8 L 39 2.8 L 39 16.4 C 37.3 17 35.7 17.7 34.1 18.5 L 24.4 8.8 L 8.8 24.4 L 18.5 34.1 C 17.7 35.7 17 37.3 16.4 39 L 2.8 39 L 2.8 61 L 16.4 61 C 17 62.7 17.7 64.3 18.5 65.9 L 8.8 75.6 L 24.4 91.2 L 34.1 81.5 C 35.7 82.3 37.3 83 39 83.5 L 39 97.3 L 61 97.3 L 61 83.5 C 62.7 82.9 64.3 82.3 65.9 81.4 L 75.6 91.2 L 91.2 75.6 L 81.5 65.9 C 82.3 64.3 83 62.7 83.5 61 Z"/></g><g class="cxb"><circle cx="50" cy="50" r="18.5"/></g>',
                                    v_minus: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtb100" x="32" y="80">-</text>',
                                    p_cg1datavertical: '<g class="cxcc"><rect x="20" y="57" width="16" height="30"/><rect x="48" y="7" width="16" height="80"/><rect x="76" y="27" width="16" height="60"/></g>',
                                    bx_violin: '<g class="cxac"><path  d="M64,1 Q 66,11 68,25 72,38 86,47 96,56 89,70 82,82 80,99 L 20,99 Q 18,82 11,70 4,56 14,47 28,38 32,25 34,11 36,1 Z" /></g>',
                                    ga_axisx: '<g class="cxb"><line x1="2" y1="50" x2="98" y2="50" /><line x1="2" y1="50" x2="17" y2="35" /><line x1="2" y1="50" x2="17" y2="65" /><line x1="98" y1="50" x2="83" y2="35" /><line x1="98" y1="50" x2="83" y2="65" /></g><text class="cxtn40 cxaa" x="38" y="38">X</text>',
                                    ar_trs: '<path class="cxtxb" d="M58,34 L66,34 L66,42 M34,66 L66,34" />',
                                    ch_oy: '<text class="cxti100" x="25" y="70">y</text>',
                                    p_g2: '<g class="cxc"><rect x="45" y="0" width="30" height="2"/><rect x="50" y="10" width="20" height="2"/><rect x="35" y="30" width="4" height="4"/><rect x="85" y="40" width="4" height="4"/><rect x="45" y="50" width="4" height="4"/><rect x="40" y="85" width="30" height="2"/><rect x="0" y="25" width="3" height="25"/><line x1="25" y1="65" x2="95" y2="65" /><line x1="25" y1="65" x2="25" y2="75" /><line x1="45" y1="65" x2="45" y2="75" /><line x1="65" y1="65" x2="65" y2="75" /><line x1="85" y1="65" x2="85" y2="75" /><line x1="25" y1="15" x2="25" y2="75" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /><rect x="75" y="95" width="20" height="2"/></g>',
                                    p_g3axistitley: '<g class="cxblue"><rect x="0" y="25" width="3" height="25"/></g>',
                                    ps_right: '<path class="cxtxb" d="M62,42 L70,50 L62,58 M70,50 L30,50" /><g class="cxa"><rect x="78" y="40" width="20" height="20" rx="2" /></g>',
                                    g_dotline: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/></g><g class="cxb"><polyline points="24.8 65.2 53.4 35.9 62.7 46.1 89.3 19.9"/></g><g class="cxb"><circle cx="52" cy="67.9" r="6.6"/><circle cx="82.7" cy="55.7" r="6.6"/><circle cx="35.6" cy="23.4" r="6.6"/></g>',
                                    p_cg3data: '<g class="cxb"><rect x="18" y="56" width="2" height="2"/><rect x="26" y="32" width="2" height="2"/><rect x="34" y="44" width="2" height="2"/><rect x="42" y="10" width="2" height="2"/><rect x="43" y="30" width="2" height="2"/><rect x="50" y="80" width="2" height="2"/><rect x="58" y="60" width="2" height="2"/><rect x="64" y="24" width="2" height="2"/><rect x="70" y="70" width="2" height="2"/><rect x="74" y="48" width="2" height="2"/><rect x="82" y="18" width="2" height="2"/><rect x="90" y="72" width="2" height="2"/></g>',
                                    dt_range: '<g class="cxaa"><rect x="8" y="46" width="10" height="9" /><rect x="88" y="6" width="10" height="49" /></g><g class="cxb"><line x1="2" y1="60" x2="100" y2="60" /><line x1="2" y1="2" x2="2" y2="60" /></g><g class="cxcc"><rect x="28" y="36" width="10" height="19" /><rect x="48" y="26" width="10" height="29" /><rect x="68" y="16" width="10" height="39" /></g><path class="cxtxa" d="M71,74 L83,86 L71,98 M29,74 L17,86 L29,98 M83,86 L17,86" />',
                                    at_shp: '<g class="cxa"><polyline points="48,40 65,20 98,75 65,75" /></g><g class="cxb"><circle cx="30" cy="70" r="27" /><polyline points="2,48 2,2 50,2 50,25" /></g>',
                                    gr_styledashed: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxa"><line x1="4" y1="23" x2="98" y2="23" stroke-dasharray="15 5" /> <line x1="4" y1="48" x2="98" y2="48" stroke-dasharray="15 5" /> <line x1="4" y1="73" x2="98" y2="73" stroke-dasharray="15 5" /></g>',
                                    ar_br: '<path class="cxtxb" d="M98,78 L98,98 L78,98 M2,2 L98,98" />',
                                    ch_coption: '<text class="cxtb100" x="0" y="85">&#8997;</text>',
                                    at_col: '<circle class="cl12" cx="50" cy="34.8" r="30.3"/><circle class="cl13" cx="69.7" cy="65.2" r="30.3"/><circle class="cl14" cx="30.3" cy="65.2" r="30.3"/><ellipse class="cl15" cx="50" cy="65.2" rx="10.7" ry="23.1"/><path class="cl16" d="M39.4,63.3c15.7,5.9,33.1-2.1,39-17.8c1-2.8,1.7-5.7,1.9-8.7c-3.4-1.3-6.9-1.9-10.5-1.9C53.7,34.8,40.4,47.2,39.4,63.3z"/><path class="cl17" d="M60.6,63.3C44.9,69,27.5,61,21.7,45.3c-1-2.7-1.6-5.6-1.8-8.5c3.4-1.3,7-1.9,10.6-1.9C46.4,34.9,59.6,47.3,60.6,63.3z"/><path class="cl18" d="M50,65.2c3.6,0,7.2-0.7,10.6-1.9c0,0,0,0,0-0.2c-0.1-0.9-0.2-1.7-0.3-2.6c0-0.1,0-0.3,0-0.4c0-0.8-0.3-1.7-0.5-2.5v-0.3c-0.9-3.2-2.3-6.2-4.2-9c-0.3-0.4-0.5-0.8-0.8-1.1c-0.3-0.3-0.6-0.7-0.9-1.1c-0.3-0.4-0.7-0.9-1.1-1.3L52,43.8c-0.5-0.5-0.9-0.9-1.4-1.4L50,42.3c-6.2,5.3-10,12.9-10.5,21.1C42.8,64.6,46.4,65.2,50,65.2z"/>',
                                    ar_v: '<path class="cxtxb" d="M35,80 L50,98 L65,80 M35,20 L50,2 L65,20 M50,98 L50,2" />',
                                    p_g1axis1: '<g class="cxblue"><line x1="25" y1="15" x2="25" y2="65" /><line x1="15" y1="25" x2="25" y2="25" /><line x1="15" y1="45" x2="25" y2="45" /><line x1="15" y1="65" x2="25" y2="65" /></g>',
                                    at_trn: '<g class="cxcc"><rect x="2.5" y="2.7" width="13.6" height="13.6"/><rect x="16.1" y="16.2" width="13.6" height="13.6"/><rect x="43.2" y="16.2" width="13.6" height="13.6"/><rect x="56.8" y="2.7" width="13.6" height="13.6"/><rect x="70.3" y="16.2" width="13.6" height="13.6"/><rect x="83.9" y="2.7" width="13.6" height="13.6"/><rect x="29.7" y="2.7" width="13.6" height="13.6"/><rect x="2.5" y="29.8" width="13.6" height="13.6"/><rect x="16.1" y="43.4" width="13.6" height="13.6"/><rect x="43.2" y="43.4" width="13.6" height="13.6"/><rect x="56.8" y="29.8" width="13.6" height="13.6"/><rect x="70.3" y="43.4" width="13.6" height="13.6"/><rect x="83.9" y="29.8" width="13.6" height="13.6"/><rect x="29.7" y="29.8" width="13.6" height="13.6"/><rect x="2.5" y="56.9" width="13.6" height="13.6"/><rect x="16.1" y="70.5" width="13.6" height="13.6"/><rect x="43.2" y="70.5" width="13.6" height="13.6"/><rect x="56.8" y="56.9" width="13.6" height="13.6"/><rect x="70.3" y="70.5" width="13.6" height="13.6"/><rect x="83.9" y="56.9" width="13.6" height="13.6"/><rect x="29.7" y="56.9" width="13.6" height="13.6"/><rect x="2.5" y="84" width="13.6" height="13.6"/><rect x="56.8" y="84" width="13.6" height="13.6"/><rect x="83.9" y="84" width="13.6" height="13.6"/><rect x="29.7" y="84" width="13.6" height="13.6"/></g><g class="cxa"><rect x="2" y="2" width="96" height="96"/></g>',
                                    g_genome: '<g class="cxb"><line x1="62.7" y1="7.9" x2="92.7" y2="37.9"/><line x1="52.5" y1="25.1" x2="75.5" y2="48.1"/><line x1="7.9" y1="62.7" x2="37.9" y2="92.7"/><line x1="25.1" y1="52.5" x2="48.1" y2="75.5"/></g><g class="cxa"><path d="M 100 31.3 L 94.5 36.8 C 82.9 48.4 66.3 53.4 50.3 50.2 L 50.3 50.2 C 47.1 34.2 52.2 17.6 63.7 6 L 69.2 0.6"/><path d="M 31.3 100 L 36.8 94.5 C 48.4 82.9 53.4 66.3 50.2 50.3 L 50.2 50.3 C 34.2 47.1 17.6 52.2 6 63.7 L 0.6 69.2"/><path d="M 31.3 100 L 36.8 94.5 C 48.4 82.9 53.4 66.3 50.2 50.3 L 50.2 50.3 C 34.2 47.1 17.6 52.2 6 63.7 L 0.6 69.2"/></g>',
                                    a_alignleft: '<g class="cxb"><rect x="15" y="2" width="45" height="38" rx="5" /><rect x="15" y="52" width="75" height="38" rx="5" /></g><g class="cxa"><line x1="3" y1="1" x2="3" y2="99" /></g>',
                                    ch_lc: '<text class="cxtb100" x="15" y="85">C</text>',
                                    p_dgmarker: '<g class="cxaa"><rect x="42" y="24" width="24" height="5"/><line x1="56" y1="25" x2="56" y2="65" /><line x1="57" y1="25" x2="57" y2="65" /></g>',
                                    cl_vertical: '<g class="cxa"><line x1="6" y1="75" x2="6" y2="90" /><line x1="14" y1="75" x2="14" y2="90" /><line x1="6" y1="75" x2="14" y2="75" /><line x1="22" y1="65" x2="22" y2="90" /><line x1="30" y1="65" x2="30" y2="90" /><line x1="22" y1="65" x2="30" y2="65" /><line x1="10" y1="75" x2="10" y2="50" /><line x1="26" y1="65" x2="26" y2="50" /><line x1="10" y1="50" x2="26" y2="50" /><line x1="38" y1="50" x2="38" y2="90" /><line x1="46" y1="65" x2="46" y2="90" /><line x1="54" y1="65" x2="54" y2="90" /><line x1="46" y1="65" x2="54" y2="65" /><line x1="50" y1="65" x2="50" y2="50" /><line x1="38" y1="50" x2="50" y2="50" /><line x1="62" y1="65" x2="62" y2="90" /><line x1="70" y1="65" x2="70" y2="90" /><line x1="62" y1="65" x2="70" y2="65" /><line x1="44" y1="40" x2="44" y2="50" /><line x1="66" y1="40" x2="66" y2="65" /><line x1="44" y1="40" x2="66" y2="40" /><line x1="78" y1="55" x2="78" y2="90" /><line x1="86" y1="75" x2="86" y2="90" /><line x1="94" y1="75" x2="94" y2="90" /><line x1="86" y1="75" x2="94" y2="75" /><line x1="90" y1="55" x2="90" y2="75" /><line x1="78" y1="55" x2="90" y2="55" /><line x1="84" y1="25" x2="84" y2="55" /><line x1="55" y1="25" x2="55" y2="40" /><line x1="55" y1="25" x2="84" y2="25" /><line x1="18" y1="10" x2="18" y2="50" /><line x1="70" y1="10" x2="70" y2="25" /><line x1="18" y1="10" x2="70" y2="10" /><line x1="44" y1="10" x2="44" y2="0" /></g><g class="cxb"><rect x="5" y="96" width="2" height="2" /><rect x="13" y="96" width="2" height="2" /><rect x="21" y="96" width="2" height="2" /><rect x="29" y="96" width="2" height="2" /><rect x="37" y="96" width="2" height="2" /><rect x="45" y="96" width="2" height="2" /><rect x="53" y="96" width="2" height="2" /><rect x="61" y="96" width="2" height="2" /><rect x="69" y="96" width="2" height="2" /><rect x="78" y="96" width="2" height="2" /><rect x="86" y="96" width="2" height="2" /><rect x="94" y="96" width="2" height="2" /></g>',
                                    ps_toloc3: '<path class="cxtxb" d="M2,78 L2,98 L22,98 M78,2 L98,2 L98,22 M2,98 L98,2" /><path class="cxtxb" d="M98,78 L98,98 L78,98 M2,22 L2,2 L22,2 M2,2 L98,98" /><g class="cxaa"><rect x="36" y="36" width="25" height="25" /></g>',
                                    sl_check: '<text class="cxtn120" x="10" y="90">&#10003;</text>',
                                    ch_cesc2: '<text class="cxtn60" x="-2" y="70">Esc</text>',
                                    ch_cctrl2: '<text class="cxtn60" x="5" y="70">Ctrl</text>',
                                    tx_shadow: '<path fill="url(#ts-grad)" d="M100,52.3l-11.7,9.8h-1.6c1.3-1.4,2.2-3,2.7-4.9c0-1-0.6-1.8-1.8-2.3c-1.7-0.4-3.5-0.6-5.2-0.5H78L44.8,82.3c-1.4,0.9-2.6,2.1-3.6,3.3c-0.2,0.4-0.1,0.8,0.5,1.2c1.1,0.4,2.2,0.6,3.3,0.5h2l-1.2,1H14.9l1.2-1h2c1.6,0,3.2-0.2,4.8-0.5c1.2-0.3,2.3-0.7,3.3-1.3c1.6-1,3.1-2.1,4.5-3.3l33.2-27.9h-4.3c-3.6,0-7.1,0.5-10.5,1.5c-4.3,1.5-8.4,3.6-12.1,6.2h-1.7L47,52.2L100,52.3z"/><g class="cxaa"><path d="M69.1,11.5v20.8h-2c-0.8-3.7-2.1-7.2-4-10.4c-1.6-2.2-3.7-3.9-6.2-5c-2.4-0.8-5-1.2-7.6-1h-5.6v59.4c-0.2,2.5,0.1,5,0.6,7.4c0.6,1.1,1.5,2,2.5,2.6c1.6,0.8,3.4,1.2,5.2,1.1h2.5v2.1H14.5v-2.1h2.6c1.8,0,3.6-0.4,5.2-1.2c1.1-0.6,1.9-1.6,2.3-2.7c0.6-2.3,0.8-4.8,0.6-7.2V16h-5.6c-4.1-0.4-8.1,0.8-11.3,3.3c-3.5,3.5-5.7,8.1-6.3,13.1H0V11.5H69.1z"/></g>',
                                    p_cg2fitcorconf: '<g class="cxcc"><path d="M10,90 L10,60 Q 50,50 70,0 L100,0 L100,30 Q 50,50 40,90 Z" /></g>',
                                    c_angular: '<polygon class="cxa" points="50 2 5 18.3 12.1 77.1 50 98.1 88 77.1 95 18.3 50 2"/><g class="cxb"><polyline points="73.5 72.2 50 20.3 26.5 72.2"/><line x1="34" y1="55.9" x2="65.9" y2="55.9"/></g>',
                                    op_more: '<g class="cxa"><circle cx="50" cy="50" r="48"/></g><g class="cxb"><line x1="15" y1="50" x2="85" y2="50" /><line x1="50" y1="15" x2="50" y2="85" /></g>',
                                    lg_l: '<g class="cxa"><rect x="48" y="2" width="50" height="40"/><rect x="58" y="12" width="2" height="2"/><rect x="58" y="22" width="2" height="2"/><rect x="58" y="32" width="2" height="2"/><line x1="68" y1="12" x2="88" y2="12" /><line x1="68" y1="22" x2="88" y2="22" /><line x1="68" y1="32" x2="88" y2="32" /></g>',
                                    ch_cshift: '<text class="cxtb100" x="-10" y="85">&#8679;</text>',
                                    bx_violinu: '<g class="cxac"><path d="M50,0 Q54,12 66,18 76,28 63,36 50,40 66,49 84,55 84,67 82,81 65,86 54,90 50,100 46,90 35,86 18,81 16,67 16,55 39,50 50,40 37,36 24,28 34,18 46,12 50,0" /></g>',
                                    m_body: '<g class="cxb"><path d="M35,2 Q 45,2 50,10 Q 75,10 75,25 L75,70 Q 75,98 50,98 Q 25,98 25,70 L25,25 Q 25,10 50,10" /><path d="M50,25 Q 55,25 55,30 L55,40 Q 55,45 50,45 Q 45,45 45,40 L45,30 Q 45,25 50,25" /><path d="M50,10 Q 75,10 75,25 L75,35 55,35 55,30 Q 55,25 50,25 Z" /><path d="M50,10 Q 25,10 25,25 L25,35 45,35 45,30 Q 45,25 50,25 Z" /></g>',
                                    ch_cshift2: '<text class="cxtn50" x="0" y="70">Shift</text>',
                                    lg_legend: '<g class="cxa"><rect x="2" y="2" width="96" height="96"/><rect x="18" y="20" width="2" height="2"/><rect x="18" y="50" width="2" height="2"/><rect x="18" y="80" width="2" height="2"/></g><g class="cxaa"><text class="cxtn20" x="30" y="28">Good</text><text class="cxtn20" x="30" y="58">Better</text><text class="cxtn20" x="30" y="88">Best!</text></g>',
                                    b_gsswitch: '<g class="cxa"><rect x="1" y="1" width="42" height="42"/><rect fill="url(\'#gs-grad\')" x="57" y="57" width="42" height="42"/></g>',
                                    p_g3subtitle: '<g class="cxblue"><rect x="50" y="10" width="20" height="2"/></g>',
                                    at_colshpsze: '<g class="cxac"><rect x="2" y="2" width="46" height="46" /><polyline points="37,85 67,36 97,85 37,85" /><circle cx="31" cy="60" r="25" /></g><g class="cxab"><circle cx="18" cy="82" r="15" /><rect x="42" y="10" width="22" height="22" /><polyline points="71,53 84,33 97,53 71,53" /></g>',
                                    dps_tooutside: '<g class="cxa"><polyline points="65,30 65,2 2,2 2,98 65,98 65,70" /></g><path class="cxtxb" d="M71,38 L83,50 L71,62 M83,50 L17,50" />',
                                    sl_lightbulboff: '<g class="cxb"><path d="M75.4,50.1C75.4,36,64,24.7,50,24.7S24.6,36.1,24.6,50.1c0,7.4,3.2,14.3,8.7,19.2c3.3,2.9,5.3,7.1,5.3,11.5h22.7c0-4.5,2-8.8,5.5-11.7C72.2,64.3,75.4,57.3,75.4,50.1z"/><path d="M38.7,80.8h22.9l0,0v8.6c0,4.5-3.7,8.2-8.2,8.2l0,0h-6.5c-4.5,0-8.2-3.7-8.2-8.2l0,0L38.7,80.8L38.7,80.8z"/></g>',
                                    ch_oquantile: '<text class="cxti100" x="15" y="75">Q</text>',
                                    cd_folder: '<g class="cxb"><path d="M83.1,36.3V22.9c0-1.3-1-2.3-2.3-2.3l0,0H28.8v-5.1c0-1.6-1.3-2.8-2.8-2.8H5.4c-1.6,0-2.8,1.3-2.8,2.8l0,0V85c0,1.3,1,2.3,2.3,2.3c0,0,0,0,0,0"/></g><g class="cxa"><path d="M79.5,87.2H4.9c-1.3,0-2.3-1-2.3-2.3c0-0.3,0-0.5,0.1-0.8l15.6-46.3c0.3-0.9,1.2-1.6,2.2-1.6h74.6c1.3,0,2.3,1,2.3,2.3c0,0.2,0,0.5-0.1,0.7L81.7,85.7C81.4,86.7,80.5,87.3,79.5,87.2z"/></g>',
                                    p_g2citation: '<g class="cxblue"><rect x="75" y="95" width="20" height="2"/></g>',
                                    ch_splus: '<text class="cxtb100" x="20" y="75">+</text>',
                                    i_right: '<rect fill="url(\'#l-grad\')" x="50" y="25" width="48" height="50"/>',
                                    c_solarized: '<circle class="cl40" cx="50" cy="50" r="24.6"/><path class="cl41" d="M74.6,50c0-13.6-11-24.6-24.6-24.6l0,0v49.2C63.5,74.6,74.5,63.6,74.6,50C74.6,50,74.6,50,74.6,50z"/><polygon class="cl40" points="50,0 45.9,20.5 54.1,20.5 "/><polygon class="cl40" points="50,100 45.9,79.5 54.1,79.5\t"/><polygon class="cl41" points="100,50 79.5,45.9 79.5,54.1\t"/><polygon class="cl41" points="0,50 20.5,45.9 20.5,54.1 "/><polygon class="cl40" points="93.5,25.4 73.6,31.9 77.7,39.1 "/><polygon class="cl40" points="6.5,74.6 22.3,60.9 26.4,68.1 "/><polygon class="cl41" points="74.6,93.5 68.1,73.6 60.9,77.7 "/><polygon class="cl41" points="25.4,6.5 39.1,22.3 31.9,26.4 "/><polygon class="cl41" points="75.3,6.9 61.4,22.5 68.5,26.7 "/><polygon class="cl41" points="24.7,93.1 31.5,73.3 38.6,77.5 "/><polygon class="cl40" points="93.1,75.3 77.5,61.4 73.3,68.5 "/><polygon class="cl0" points="6.9,24.7 26.7,31.5 22.5,38.6 "/>',
                                    wp_marker: '<g class="cxa"><path d="M90.7,42.2C90.7,64.7,50,96.8,50,96.8S9.3,64.7,9.3,42.2C9.9,19.8,28.6,2,51,2.6c21.6,0.6,39,18,39.6,39.6H90.7z"/></g><g class="cxb"><circle cx="49.9" cy="34.5" r="12.7"/></g>',
                                    gr_styledotted: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxa"><line x1="4" y1="23" x2="98" y2="23" stroke-dasharray="5" /> <line x1="4" y1="48" x2="98" y2="48" stroke-dasharray="5" /> <line x1="4" y1="73" x2="98" y2="73" stroke-dasharray="5" /></g>',
                                    g_scatterbubble2d: '<g class="cxa"><line x1="11.9" x2="11.9" y2="100" y1="0"/><line x1="100" y1="86" y2="86" x2="0"/><line y1="62.6" x2="11.9" y2="62.6" x1="0"/><line y1="39.1" x2="11.9" y2="39.1" x1="0"/><line y1="15.6" x2="11.9" y2="15.6" x1="0"/><line x1="32.5" y1="100" x2="32.5" y2="86"/><line x1="56" y1="100" x2="56" y2="86"/><line x1="79.4" y1="100" x2="79.4" y2="86"/></g><g class="cxb"><circle cx="68.1" cy="42.8" r="17.8"/><circle cx="29.8" cy="45.7" r="6.9"/><circle cx="43.6" cy="68.3" r="7"/><circle cx="88.4" cy="14.5" r="6.7"/><circle cx="34.7" cy="17.3" r="7.8"/></g>',
                                    ar_r: '<path class="cxtxb" d="M80,35 L98,50 L80,65 M98,50 L2,50" />',
                                    gr_major: '<g class="cxc"><line x1="2" y1="2" x2="2" y2="100" /><line x1="2" y1="98" x2="98" y2="98" /></g><g class="cxa"><line cx1="4" y1="18" x2="98" y2="18" /> <line x1="4" y1="38" x2="98" y2="38" /> <line x1="4" y1="58" x2="98" y2="58" /> <line x1="4" y1="78" x2="98" y2="78" /></g>',
                                    lg_h: '<g class="cxc"><rect x="10" y="50" width="81" height="40"/><line x1="10" y1="70" x2="90" y2="70" /><line x1="37" y1="50" x2="37" y2="90" /><line x1="64" y1="50" x2="64" y2="90" /><line x1="2" y1="55" x2="2" y2="65" /><line x1="2" y1="75" x2="2" y2="85" /><line x1="13" y1="98" x2="34" y2="98" /><line x1="40" y1="98" x2="61" y2="98" /><line x1="67" y1="98" x2="88" y2="98" /></g>',
                                    v_play: '<circle class="cxb" cx="50" cy="50" r="48" /><text class="cxtn70" x="25" y="77">&#9654;</text>',
                                    ly_splom: '<g class="cxa"><rect x="25" y="2" width="15" height="15" /><rect x="2" y="25" width="15" height="15" /><rect x="57" y="2" width="15" height="15" /><rect x="80" y="2" width="15" height="15" /><rect x="57" y="25" width="15" height="15" /><rect x="2" y="80" width="15" height="15" /><rect x="80" y="57" width="15" height="15" /></g><g class="cxac"><rect x="2" y="2" width="15" height="15" /><rect x="25" y="25" width="15" height="15" /><rect x="2" y="57" width="15" height="15" /><rect x="25" y="80" width="15" height="15" /><rect x="57" y="57" width="15" height="15" /><rect x="80" y="80" width="15" height="15" /></g>',
                                    p_ghvariabletitle: '<g class="cxblue"><rect x="50" y="85" width="30" height="2"/></g>',
                                    ar_blm: '<path class="cxtxb" d="M17,71 L17,83 L29,83 M17,83 L83,17" />',
                                    ar_dcbls2: '<text class="cxtn60 cxaa" x="44" y="51" transform="rotate(45)">&#10555;</text><text class="cxtn60 cxaa" x="-96" y="51" transform="rotate(45) scale(-1,1)">&#10555;</text>'
                                }
                            };
                            CanvasXpress.doc = {
                                P: {
                                    fontScaleFontFactor: {
                                        M: "Text",
                                        T: "float",
                                        D: "1",
                                        H: ['{[*],"title":"Graph Title","subtitle":"Graph Subtitle"}'],
                                        C: "Scaling factor used to increase or decrease the font size in the canvas.<br>"
                                    },
                                    fontName: {
                                        H: ["{[*]}"],
                                        D: "Arial",
                                        T: "option",
                                        O: ["Courier", "Arial", "Verdana", "sans-serif", "Indie Flower", "Ubuntu", "Architects Daughter", "Roboto"],
                                        C: "Font name. It will be set depending on the browser.<br>",
                                        M: "Text"
                                    },
                                    smpLabelRotate: {
                                        D: "0",
                                        M: "Samples",
                                        T: "integer",
                                        C: "Rotation for sample labels in degrees. It could be positive or negative.<br>",
                                        H: ['{[0,-45,90],"graphType":"Bar"}']
                                    },
                                    axisTitleColor: {
                                        D: "rgb(0,0,0)",
                                        M: "Axis",
                                        T: "color",
                                        C: "Color for the axis title in one, two and three dimensional plots<br>",
                                        H: ['{[*],"xAxisTitle":"Axis Title"}']
                                    },
                                    showPieGrid: {
                                        M: "Pie Charts",
                                        T: "boolean",
                                        D: "true",
                                        H: ['{[*],"data":"Random:5:6","xAxis":["S1","S2","S3","S4","S5","S6"],"layout":"2X3"}'],
                                        C: "A flag to show the labels for the grid when plotting multiple pies<br>"
                                    },
                                    transpose: {
                                        M: "Functions",
                                        T: "void",
                                        C: "Transpose the data. It takes no parameters<br>",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "StackedLine", "StackedPercentLine"]
                                    },
                                    zoomStep: {
                                        H: ['{[*],"graphType":"Heatmap"}'],
                                        C: "Percentage step for zooming networks and genome panel.<br>",
                                        D: "0.2",
                                        T: "float",
                                        M: "Zooming, Panning and Resizing"
                                    },
                                    yRotate: {
                                        H: ['{[0,45],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        C: "Starting number of degrees to rotate graph arround the Y axis<br>",
                                        T: "float",
                                        M: "3D Attributes",
                                        D: "0"
                                    },
                                    metaData: {
                                        C: "Meta data for files read from a url<br>",
                                        D: "{}",
                                        M: "General",
                                        T: "object"
                                    },
                                    networkSpeed: {
                                        C: "Network Speed<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        M: "Network Algorithm Parameters",
                                        T: "float",
                                        D: "0.1"
                                    },
                                    layout: {
                                        M: "Combination Plots",
                                        T: "string",
                                        Z: "true",
                                        D: "1X1",
                                        C: "Topology of the canvas. Number of rows and columns.<br>"
                                    },
                                    randomMissingDataPercentage: {
                                        C: "Default percentage of missing values when creating random data. A value between 0 and 1.<br>",
                                        D: "0",
                                        T: "float",
                                        M: "Random"
                                    },
                                    circularDataPosition: {
                                        H: ['{[*],"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"]}'],
                                        D: "distributed",
                                        T: "option",
                                        O: ["absolute", "distributed"],
                                        C: "Position to align the data in 2D radial graphs and ideograms<br>",
                                        M: "Circular Graphs"
                                    },
                                    fontsExternal: {
                                        D: "[]",
                                        T: "array",
                                        M: "Text",
                                        H: ['{"data":"Random:8:4:2:1","title":"External Fonts","graphType":"Scatter2D","fontsExternal":[{"url": "https://www.canvasxpress.org/assets/fonts/NewWaltDisneyFontRegular-BPen.ttf", "name": "New Waltograph"}]}'],
                                        C: "External Fonts.<br>"
                                    },
                                    motionEffectIn: {
                                        T: "string",
                                        M: "Effect",
                                        D: "swashIn",
                                        H: ["{[*]}"],
                                        C: "motionEffectIn<br>"
                                    },
                                    configuratorExamplesSize: {
                                        C: "Size in pixels for the examples in the configurator.<br>",
                                        Z: "true",
                                        D: "500",
                                        M: "Events",
                                        T: "integer"
                                    },
                                    shadowOffsetX: {
                                        C: "Length in pixels for the shadow offset in the X axis.<br>",
                                        M: "Shadows",
                                        S: ["showShadow"],
                                        H: ['{[*],"showShadow":true}'],
                                        T: "integer",
                                        D: "1"
                                    },
                                    colorDataTable: {
                                        S: ["colorDataTableTransparency"],
                                        T: "boolean",
                                        M: "Data Table",
                                        D: "true",
                                        C: "Flag to color the data table<br>"
                                    },
                                    subtitleAlign: {
                                        H: ['{[*],"title":"Graph Title","subtitle":"Graph Subtitle"}'],
                                        D: "center",
                                        T: "option",
                                        O: ["left", "center", "right"],
                                        C: "Subtitle alignment<br>",
                                        M: "Titles and Subtitles"
                                    },
                                    boxplotMedianWidth: {
                                        D: "1",
                                        T: "integer",
                                        M: "Boxplot Graphs",
                                        C: "Width for the line of the median of data in boxplots<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}']
                                    },
                                    xAxisTitle: {
                                        C: "Title for the X axis<br>",
                                        H: ['{"xAxisTitle":"X-axis title"}'],
                                        M: "X-Axis",
                                        T: "string",
                                        D: "false"
                                    },
                                    randomDataDistribution: {
                                        T: "option",
                                        M: "Random",
                                        D: "biased",
                                        C: "Distribution for the random data<br>",
                                        O: ["range", "normal", "uniform", "symmetrical", "biased"]
                                    },
                                    layoutWidth: {
                                        C: "Width of the current segment of the canvas when there are multiple graphs.<br>",
                                        D: "0",
                                        Z: "true",
                                        M: "Combination Plots",
                                        T: "float"
                                    },
                                    featureConfigurableProperties: {
                                        M: "Genome Browser",
                                        T: "array",
                                        D: ["id", "name", "label", "hideName", "fill", "outline", "dir", "showDir", "connect", "offset", "data", "subtype", "quality", "signalToNoise", "coordinate", "sequence", "trace", "gaps", "translate", "hide", "counter"],
                                        H: ["{[*]}"],
                                        C: "Feature configurable properties<br> @features {id:[string];Feature id;[],fill:[color];Color for the feature;[]}"
                                    },
                                    randomNetworkAll: {
                                        C: "Use all types of colors, shapes and edges in random network, otherwise only one color, one shape and straight black lines for the edges.<br>",
                                        M: "Random",
                                        T: "boolean",
                                        D: "true",
                                        U: ["Network"]
                                    },
                                    hierarchyVar: {
                                        D: "false",
                                        M: "Hierarchy",
                                        T: "string",
                                        C: "Variable name to use in the sankey, sunburst and bubble graphs. This is used when the data set has more than a single variable. Otherwise the first variable will be selected.<br>",
                                        H: ['{"data":"RandomCircular:4:8","graphType":"Circular","circularType":"sunburst","hierarchyVar":"V1"}', '{"data":"RandomCircular:4:8","graphType":"Circular","circularType":"sunburst","hierarchyVar":"V3"}']
                                    },
                                    networkGravity: {
                                        D: "0.75",
                                        M: "Network Algorithm Parameters",
                                        T: "float",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        C: "Network Gravity<br>"
                                    },
                                    marginRight: {
                                        T: "integer",
                                        M: "Margins",
                                        D: "5",
                                        C: "Specifies the length in pixels for the right margin in the canvas.<br>",
                                        H: ['{[5,100],"data":"Random:1:3"}']
                                    },
                                    resizable: {
                                        C: "Flag to disable resizing the canvas by dragging the mouse over the edges<br>",
                                        H: ["{[*]}"],
                                        M: "Events",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    ratioReference: {
                                        C: "Default index of sample used in ratio transformation. Almost 'private' parameters used within the different CanvasXpress UIs.<br>",
                                        D: "0",
                                        T: "integer",
                                        M: "Data"
                                    },
                                    parallelCoordinates: {
                                        T: "array",
                                        M: "Line Graphs",
                                        D: "[]",
                                        Z: "true",
                                        C: "Array used to store and handle a parallel coordinates plot<br>"
                                    },
                                    swimHigh: {
                                        O: ["false"],
                                        H: ['{[*],"data":"Swimmer","graphType":"Bar","barType":"swimmer"}'],
                                        D: "false",
                                        T: "option",
                                        X: "getVariablesAsArray",
                                        C: "Variable to use in Swimmer plot. Defaults to the first variable in the data set. See https://blogs.sas.com/content/graphicallyspeaking/2014/06/22/swimmer-plot/<br>",
                                        M: "Bar Graphs"
                                    },
                                    tagCloudTextGridSize: {
                                        H: ["{[*]}"],
                                        C: "Size for the grid in text tag cloud visualizations<br>",
                                        D: "8",
                                        M: "Tag Cloud",
                                        T: "integer"
                                    },
                                    loessBandwidth: {
                                        T: "float",
                                        M: "Loess",
                                        D: "0.8",
                                        C: "Loess bandwidth. Thickness for the confidence of the loess curve. A vaulue between 0 and 1.<br>",
                                        H: ['{[0.5,0.9],"data":"Random:200:2","graphType":"Scatter2D","showLoessFit":true,"showConfidenceIntervals":true}']
                                    },
                                    spiderBy: {
                                        O: ["false"],
                                        H: ['{[false,"Annt1"],"data":"Random:30:3:2:2","graphType":"Scatter3D"}'],
                                        T: "option",
                                        D: "false",
                                        C: "Utility to create spider plots in Scatter2D plots<br> @funtion getZData",
                                        M: "Data Point Attributes"
                                    },
                                    showConfiguratorExamplesOnSelect: {
                                        C: "Flag to display examples as the configurator property changes<br>",
                                        H: ["{[*]}"],
                                        D: "false",
                                        M: "Events",
                                        T: "boolean"
                                    },
                                    sequenceZColor: {
                                        D: "rgb(0,0,0)",
                                        M: "Genome Browser",
                                        T: "color",
                                        C: "Color for the glutamines in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    maxFeatureStringLen: {
                                        T: "integer",
                                        M: "Genome Browser",
                                        D: "30",
                                        C: "Maximum length in characters a feature label can have so anything above is truncated.<br>",
                                        H: ["{[*]}"]
                                    },
                                    printType: {
                                        O: ["download", "window"],
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "download",
                                        C: "Type of printing when the camera icon in the UI is pressed. Download is to download the image while window is to save the image in a new browser window.<br>",
                                        M: "General"
                                    },
                                    maxVarStringLen: {
                                        M: "Variables",
                                        C: "Maximum length in characters a variable label or description can have so anything above is truncated.<br>",
                                        U: ["Heatmap"],
                                        T: "integer",
                                        D: "25",
                                        H: ['{[1,30],"data":"Random:8:4"}']
                                    },
                                    showLoessFit: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Loess",
                                        H: ['{[*],"data":"Random:200:2","graphType":"Scatter2D"}'],
                                        C: "Flag to show the loess fit in Scatter2D plots<br>"
                                    },
                                    randomData: {
                                        C: "Flag to indicate random data for debug and demonstration purposes<br>",
                                        M: "Random",
                                        T: "boolean",
                                        Z: "true",
                                        D: "false"
                                    },
                                    printMagnification: {
                                        C: "Print Magnification to produce High Definition images. Courtesy of Baohong Zhang.<br>",
                                        H: ["{[*]}"],
                                        M: "General",
                                        T: "integer",
                                        D: "1"
                                    },
                                    heatmapIndicatorPosition: {
                                        M: "Heatmap Graphs",
                                        C: "Position for the heatmap indicator<br>",
                                        O: ["topLeft", "top", "topRight", "right"],
                                        D: "right",
                                        T: "option",
                                        H: ["{[*]}"]
                                    },
                                    resizableX: {
                                        H: ["{[*]}"],
                                        C: "Flag to disable resizing the width of the canvas by dragging the mouse over the edges<br>",
                                        T: "boolean",
                                        M: "Events",
                                        D: "true"
                                    },
                                    labelNodePosition: {
                                        O: ["auto", "center", "top", "right", "bottom", "left"],
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        T: "option",
                                        D: "auto",
                                        C: "Default position for the node label<br>",
                                        M: "Network Graphs"
                                    },
                                    playable: {
                                        T: "boolean",
                                        M: "Events",
                                        D: "false",
                                        H: ["{[*]}"],
                                        C: "Flag to make the plot playable if there are after rendering functions<br>"
                                    },
                                    subNetworks: {
                                        D: "false",
                                        Z: "true",
                                        M: "Network Graphs",
                                        T: "array",
                                        C: "Array to keep independent networks<br>"
                                    },
                                    disableDataFilters: {
                                        C: "Flag to disable showing data filters<br>",
                                        H: ["{[*]}"],
                                        M: "Events",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    selectionColor: {
                                        T: "color",
                                        M: "Data Selection: Parameters used to select data in all visualizations",
                                        D: "rgb(255,0,0)",
                                        C: "The color used for selected data points when selection mode is to be highlight.<br> @see{selectionMode}",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    trackConfigurableProperties: {
                                        C: "Track configurable properties<br> @tracks {name:[string];Track name;[]}",
                                        H: ["{[*]}"],
                                        D: ["name", "hideName", "hideFeatureNames", "type", "height", "fill", "outline", "data", "hide", "connect", "subtracksMax", "highlight"],
                                        M: "Genome Browser",
                                        T: "array"
                                    },
                                    varLabelFont: {
                                        D: "12px Verdana",
                                        Z: "true",
                                        M: "Fonts",
                                        T: "font",
                                        C: "Font for the variable labels in one dimensional plots<br>"
                                    },
                                    smpOverlaysLegendColumns: {
                                        H: ['{[1,2,3],"data":"Random:10:10:0:3","showSmpOverlaysLegend":true,"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        C: "Number of columns for the sample overlay legends<br>",
                                        M: "Overlays",
                                        T: "integer",
                                        D: "1"
                                    },
                                    xAxisMaxStrLength: {
                                        C: "Longest string of all the values in the ticks in the X axis<br>",
                                        Z: "true",
                                        D: "null",
                                        M: "X-Axis",
                                        T: "string"
                                    },
                                    meterNeedleColor: {
                                        D: "rgb(0,0,0)",
                                        M: "Meter Graphs",
                                        T: "color",
                                        H: ['{[*],"graphType":"Meter"}'],
                                        C: "Meter Needle Color.<br>"
                                    },
                                    violinBorderColor: {
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        M: "Boxplot Graphs",
                                        H: ['{[*],"data":"Random:2:12:0:2","showViolinBoxplot":true,"showBoxplotIfViolin":true,"groupingFactors":["Factor1"]}'],
                                        C: "Color for the violin borders<br>"
                                    },
                                    yAxisHistogramHeight: {
                                        M: "Y-Axis",
                                        C: "Number of pixels for the histogram in the Y axis<br>",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        D: "80",
                                        T: "integer",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D","yAxisHistogramShow":true}']
                                    },
                                    fishParents: {
                                        C: "Fish Parents.<br>",
                                        M: "Fish Graphs",
                                        S: ["fishTimepoints", "fishColors"],
                                        H: ['{[*],"graphType":"Fish"}'],
                                        D: "[]",
                                        T: "array"
                                    },
                                    shapeKey: {
                                        C: "Object to assign custom shapes to sample annotations and variable annotations included in the data object. The key of the object is the name of an annotation in the data.x object or the name of an annotation in the data.z object. A default shape will be assigned to a data point whose value was not included the object.<br>",
                                        H: ['{"graphType":"Dotplot","shapeBy":"Factor1","shapeKey":{"Factor1":{"Lev:1":"star","Lev:2":"diamond"}}}'],
                                        M: "Data Point Attributes",
                                        T: "object",
                                        D: "false"
                                    },
                                    desegregateVariables: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"],
                                        S: ["segregateVariables"],
                                        C: "Desegregate variables previously segregated based on a variable category (data.z object)<br>",
                                        T: "void",
                                        M: "Functions"
                                    },
                                    useRoundRectangles: {
                                        T: "boolean",
                                        M: "Shapes",
                                        D: "false",
                                        C: "Use round rectangles in bar graphs, stacked graphs and boxplots<br>",
                                        H: ['{[*],"data":"Random:1:6"}']
                                    },
                                    pieSegmentPrecision: {
                                        H: ["{[*]}"],
                                        C: "Number of decimals for values in the Pie charts<br>",
                                        T: "integer",
                                        M: "Pie Charts",
                                        D: "0"
                                    },
                                    remoteIds: {
                                        C: "Array of the remoteIds passed after a service call<br>",
                                        D: "[]",
                                        Z: "true",
                                        T: "array",
                                        M: "Remote Procedures"
                                    },
                                    outlineByData: {
                                        T: "string",
                                        D: "false",
                                        H: ['{"data":"RandomMultidimensional:5:10:1:1","graphType":"Heatmap","outlineByData":"data2","outlineBy":"DataOutline"}'],
                                        S: ["outlineBy"],
                                        U: ["Heatmap"],
                                        M: "Data Point Attributes",
                                        C: "String that identify the object containing a two dimensional array with values used to color the outline data points when drawing a multidimensional Heatmap. It must be located within the data.y object (for example: data.y.data4)<br>"
                                    },
                                    colorHSV: {
                                        Z: "true",
                                        D: [" 0", " 0", " 1 "],
                                        T: "array",
                                        M: "Colors",
                                        C: "Color HSV. Hue, Saturation and Value used in the configurator<br>"
                                    },
                                    legendColor: {
                                        M: "Legends",
                                        T: "color",
                                        D: "rgb(0,0,0)",
                                        C: "Color for the legends<br>",
                                        H: ["{[*]}"]
                                    },
                                    grpIndicesStart: {
                                        Z: "true",
                                        D: "-1",
                                        M: "Heatmap Graphs",
                                        T: "integer",
                                        C: "Number that indicates starting point for grouped samples in heatmaps when the canvas is zoom in.<br>"
                                    },
                                    motionBy: {
                                        D: "false",
                                        T: "option",
                                        H: ['{"data":"Random:30:3:2:2","graphType":"Scatter2D","motionBy":"Annt1"}', '{"data":"Random:30:3:2:2","graphType":"Scatter2D","motionBy":false}'],
                                        O: ["false", "variable"],
                                        M: "Data Point Attributes",
                                        C: "Utility to create dynamic filtering of data in Scatter plots<br>",
                                        X: "getZData"
                                    },
                                    imageTimeOut: {
                                        T: "integer",
                                        D: "1000",
                                        H: ["{[*]}"],
                                        S: ["imageMaxTries", "imageTries"],
                                        M: "Images",
                                        C: "Time in milliseconds to wait to load images<br>"
                                    },
                                    showDecorationsLegend: {
                                        C: "Flag to show or not the decoration legends<br>",
                                        H: ['{"data":"Random:16:2","showDecorationsLegends":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}', '{"data":"Random:16:2","showDecorationsLegends":false,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        T: "boolean",
                                        M: "Decorations",
                                        D: "true"
                                    },
                                    baseline: {
                                        C: "Default vertical alignment for drawing text.<br>",
                                        M: "Text",
                                        O: ["top", "middle", "bottom"],
                                        H: ['{[*],"title":"Graph Title"}'],
                                        T: "option",
                                        D: "middle"
                                    },
                                    sortDir: {
                                        O: ["ascending", "descending"],
                                        C: "Default direction for data sorting. Almost 'private' parameters used within the different CanvasXpress UIs.<br>",
                                        D: "ascending",
                                        M: "Data sorting",
                                        T: "option"
                                    },
                                    heatmapIndicatorHeight: {
                                        D: "25",
                                        T: "integer",
                                        M: "Heatmap Graphs",
                                        C: "Length in pixels for the heatmap indicator<br>",
                                        H: ['{[*],"graphType":"Heatmap"}']
                                    },
                                    chordColor: {
                                        H: ['{[*],"data":"RandomChord","graphType":"Circular","circularType":"chord"}'],
                                        T: "option",
                                        D: "source",
                                        O: ["source", "target"],
                                        C: "Color the ribbon according to either the source or the target of the connection<br>",
                                        M: "Circular Graphs"
                                    },
                                    showHistogramDensity: {
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        T: "boolean",
                                        D: "false",
                                        S: ["createHistogram", "densityKernel"],
                                        C: "Flag to show the density kernel in histograms<br>",
                                        M: "Histograms"
                                    },
                                    boxplotWhiskersType: {
                                        M: "Boxplot Graphs",
                                        C: "Boxplot whiskers type<br>",
                                        T: "option",
                                        D: "double",
                                        H: ['{[*],"data":"Random:2:12:0:1:1:100:0:false:normal:50:10","groupingFactors":["Factor1"]}'],
                                        O: ["single", "double", "none"]
                                    },
                                    infoTimeIn: {
                                        C: "Time in milliseconds to start showing info after a mouse over<br>",
                                        H: ["{[*]}"],
                                        M: "Events",
                                        T: "integer",
                                        D: "50"
                                    },
                                    sequenceNColor: {
                                        C: "Color for the degenerate A/C/G/T and asparagines in the genome browser<br>",
                                        H: ["{[*]}"],
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,0,0)"
                                    },
                                    featureHeightDefault: {
                                        T: "integer",
                                        M: "Genome Browser",
                                        D: "14",
                                        C: "Default size in pixels of the feature height<br>"
                                    },
                                    legendColumns: {
                                        T: "integer",
                                        M: "Legends",
                                        D: "1",
                                        H: ["{[*]}"],
                                        C: "Number of columns for the variable legends in one dimensional plots<br>"
                                    },
                                    oncoprintCNA: {
                                        T: "boolean",
                                        M: "Oncoprint Graphs",
                                        D: "false",
                                        C: "String to identify the data object to use to draw the copy number alterations; that is the amplifications (which will be colored red) and deletions (which will be colored blue). It MUST be a file with only two categorical levels.<br>",
                                        H: ['{"data":"RandomMultidimensional:5:10","oncoprintCNA":"data2"}']
                                    },
                                    showFilledHistogramDensity: {
                                        S: ["createHistogram", "densityKernel"],
                                        C: "Flag to show a filled histogram density<br>",
                                        M: "Histograms",
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        D: "false",
                                        T: "boolean"
                                    },
                                    xAxisTransformTicks: {
                                        C: "Flag to transform the values of the ticks in the X axis<br>",
                                        M: "X-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        H: ['{[*],"xAxisTransform":"log10","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "true"
                                    },
                                    tensionSegments: {
                                        D: "16",
                                        T: "integer",
                                        M: "Line Graphs",
                                        H: ['{[*],"data":"RandomCircular:4:8"}'],
                                        C: "Number of segments to smooth a quadratic curve<br>"
                                    },
                                    remoteUpdating: {
                                        C: "Flag to indicate that updating data is in progress<br>",
                                        D: "false",
                                        Z: "true",
                                        M: "Remote Procedures",
                                        T: "boolean"
                                    },
                                    contourStartLevel: {
                                        D: "false",
                                        T: "integer",
                                        H: ['{[5,10],"data":"Random:20:20","functions":["createContour"]}'],
                                        S: ["createContour"],
                                        M: "Contours",
                                        C: "Start level for contours. It is automatically calculated if not defined.<br>"
                                    },
                                    zAxisShow: {
                                        M: "Z-Axis",
                                        T: "boolean",
                                        D: "true",
                                        C: "Flag to show on not the values of the ticks in the Z axis<br>",
                                        H: ['{[*],"data":"Random:10:3","graphType":"Scatter3D"}']
                                    },
                                    edgesProperties: {
                                        D: "[]",
                                        T: "array",
                                        M: "Data Table/Filter",
                                        C: "Two dimensional array with object properties not at the root level for the edges in the Network graph to include in the Data table and the data filter<br>"
                                    },
                                    randomSeed: {
                                        C: "Specifies the random seed number to create pseudo random numbers<br>",
                                        D: "8",
                                        M: "Random",
                                        T: "integer"
                                    },
                                    widthFactor: {
                                        S: ["sampleSpaceFactor", "variableSpaceFactor"],
                                        M: "Aspect Ratio, Space and width",
                                        C: "Factor to adjust the width of the bars in the one dimensional and the three dimensional plots. The greater the number, the wider the bars.<br>",
                                        D: "1",
                                        T: "integer",
                                        H: ['{[1,2],"data":"Random:2:4","graphType":"Bar"}', '{[1,2],"data":"Random:8:4","graphType":"Scatter3D","scatterType":"bar"}']
                                    },
                                    tagCloudTextEllipticity: {
                                        D: "0.65",
                                        M: "Tag Cloud",
                                        T: "float",
                                        H: ["{[*]}"],
                                        C: "Ellipticity for the for text in tag cloud visualizations<br>"
                                    },
                                    resizeHeightOnLayout: {
                                        M: "Events",
                                        T: "boolean",
                                        D: "true",
                                        C: "Flag to enable resizing the height of the canvas after changing the layout<br>",
                                        H: ["{[*]}"]
                                    },
                                    oncoprintNoAlterations: {
                                        C: "Switch to show variables and samples without any alterations.<br>",
                                        H: ["{[*]}"],
                                        D: "true",
                                        M: "Oncoprint Graphs",
                                        T: "boolean"
                                    },
                                    clusterAxis: {
                                        M: "Clustering",
                                        Z: "true",
                                        C: "Axis to use when clustering data.<br>",
                                        T: "option",
                                        D: "samples",
                                        O: ["samples", "variables"]
                                    },
                                    xAxisTitleDynamic: {
                                        D: "false",
                                        T: "boolean",
                                        M: "X-Axis",
                                        C: "Set the title for the X axis dynamically as it changes<br>",
                                        H: ["{[*]}"]
                                    },
                                    ringGraphType: {
                                        C: "Array containing the graph type for each ring in the circular plot.<br>",
                                        M: "Circular Graphs",
                                        S: ["ringOrder"],
                                        H: ['{"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"ringGraphType":["bar","heatmap","dot"]}'],
                                        T: "array",
                                        D: "[]"
                                    },
                                    treeNodeId: {
                                        T: "integer",
                                        M: "Trees",
                                        Z: "true",
                                        D: "0",
                                        C: "Id for the nodes in the tree<br>"
                                    },
                                    editable: {
                                        C: "Editable in JS Fiddle.<br>",
                                        H: ["{[*]}"],
                                        D: "true",
                                        T: "boolean",
                                        M: "General"
                                    },
                                    legendInside: {
                                        S: ["legendPosition", "legendPositionAuto"],
                                        M: "Legends",
                                        C: "Position the legend inside the graphs<br>",
                                        T: "boolean",
                                        D: "false",
                                        H: ["{[*]}"]
                                    },
                                    totalRows: {
                                        C: "Total rows in the data table<br>",
                                        Z: "true",
                                        D: "null",
                                        M: "Data Table",
                                        T: "integer"
                                    },
                                    yAxisBottomMajorTick: {
                                        C: "A flag to show the bottom Major tick line in the Y axis in Scatter2D plots<br>",
                                        M: "Y-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "true"
                                    },
                                    yAxis2Title: {
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"],
                                        C: "Title for the Y axis in Scatter plots and in Correlation graphs.<br>",
                                        M: "Y-Axis",
                                        H: ['{"data":"Random:10:2","yAxisTitle":"Y-axis title"}', '{"data":"Random:8:4","yAxisTitle":"Y-axis title","graphType":"Correlation"}'],
                                        T: "string",
                                        D: "false"
                                    },
                                    yAxisRugHeight: {
                                        C: "Number of pixels for the rug in the Y axis<br>",
                                        M: "Y-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D","yAxisRugShow":true}'],
                                        D: "15",
                                        T: "integer"
                                    },
                                    loessDegree: {
                                        M: "Loess",
                                        C: "Loess degree. 0 : Constant, 1 : Linear, 2 : Quadratic.<br>",
                                        D: "2",
                                        T: "option",
                                        H: ['{[*],"data":"Random:200:2","graphType":"Scatter2D","showLoessFit":true,"showConfidenceIntervals":true}'],
                                        O: ["0", "1", "2"]
                                    },
                                    boxplotNotched: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Boxplot Graphs",
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}'],
                                        C: "Flag to notch boxplots.<br>"
                                    },
                                    titleScaleFontFactor: {
                                        D: "1",
                                        T: "float",
                                        M: "Titles and Subtitles",
                                        C: "Scaling factor used to increase or decrease the title font size in the canvas.<br>",
                                        H: ['{[*],"title":"Graph Title"}']
                                    },
                                    weight: {
                                        M: "Combination Plots",
                                        T: "float",
                                        Z: "true",
                                        D: "1",
                                        C: "Fraction of the canvas to be used (a value between 0 and 1). Used when multiple graphs are displayed in one canvas. Could be an number or an array of numbers.<br>"
                                    },
                                    sequenceSColor: {
                                        D: "rgb(255,165,0)",
                                        M: "Genome Browser",
                                        T: "color",
                                        C: "Color for the degenerate G/C and serines in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    ganttDependencyColor: {
                                        X: "getXData",
                                        C: "Variable annotation for the color of the dependency line. Defaults to rgb(0,0,0)<br>",
                                        M: "Gantt Charts",
                                        O: ["false"],
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}'],
                                        T: "color",
                                        D: "false"
                                    },
                                    zAxisMinorValues: {
                                        C: "Values for the minor ticks in the Z axis<br>",
                                        M: "Z-Axis",
                                        T: "array",
                                        D: "[]",
                                        Z: "true"
                                    },
                                    varHighlightColor: {
                                        M: "Variables",
                                        C: "The color for the highlighted variables.<br>",
                                        U: ["Heatmap"],
                                        D: "rgb(255,0,0)",
                                        T: "color",
                                        H: ['{[*],"highlightVar":["V1","V3"]}']
                                    },
                                    dataTableFontFamily: {
                                        M: "Data Table",
                                        T: "string",
                                        D: "unset",
                                        C: "Data table font family<br>"
                                    },
                                    chordThickness: {
                                        C: "Relative length in pixels of the chord thickness in the circular graphs. Only applicable to the chord subtype.<br>",
                                        H: ['{[*],"data":"RandomChord","graphType":"Circular","circularType":"chord"}'],
                                        D: "28",
                                        M: "Circular Graphs",
                                        T: "integer"
                                    },
                                    fishCloneLabels: {
                                        H: ['{[*],"graphType":"Fish"}'],
                                        C: "Fish Clone Labels (array with names for the clones). Must have the same dimension as the fishParents<br>",
                                        D: "[]",
                                        M: "Fish Graphs",
                                        T: "array"
                                    },
                                    moveParentsWithChildren: {
                                        C: "Flag to make parents move when a child is moved<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        D: "false",
                                        M: "Network Graphs",
                                        T: "boolean"
                                    },
                                    rAxisValuesRaw: {
                                        Z: "true",
                                        D: "[]",
                                        T: "array",
                                        M: "R-Axis",
                                        C: "Raw values for the ticks in the R axis<br>"
                                    },
                                    confidenceIntervalColor: {
                                        D: "rgb(50,50,50)",
                                        M: "Error Bars and Confidence Intervals",
                                        T: "color",
                                        H: ["{[*]}"],
                                        C: "Color for the confidence intervals<br>"
                                    },
                                    showMousePositionOnDrag: {
                                        T: "boolean",
                                        M: "Events",
                                        D: "true",
                                        C: "Show mouse position when dragging in relation to the zero coordinate (top-right) of the canvas.<br>",
                                        H: ["{[*]}"]
                                    },
                                    smpDendrogramNewick: {
                                        M: "Dendrograms",
                                        T: "string",
                                        D: "false",
                                        C: "Dendrogram in Newick format for the samples<br>"
                                    },
                                    disableCanvas: {
                                        H: ["{[*]}"],
                                        C: "Flag to disable all canvas events<br>",
                                        M: "Events",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    remoteAutoPlayDelay: {
                                        C: "Time in milliseconds to wait between iterations while automatically going over remote data sets<br>",
                                        D: "3000",
                                        T: "integer",
                                        M: "Remote Procedures"
                                    },
                                    smpTitleFontStyle: {
                                        O: ["", "bold", "italic", "bold italic"],
                                        H: ['{[*],"smpTitle":"Sample Title"}'],
                                        D: "",
                                        T: "option",
                                        C: "Font style for the samples.<br>",
                                        M: "Samples"
                                    },
                                    networkSpringCoeff: {
                                        C: "Hook's law coefficient. 1 - solid spring.<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        D: "0.0008",
                                        M: "Network Algorithm Parameters",
                                        T: "float"
                                    },
                                    xAxisLeftRightTickColor: {
                                        C: "Color for the left and right tick lines in the Y axis<br>",
                                        M: "X-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        D: "rgb(204,204,204)",
                                        T: "color"
                                    },
                                    clusterVariables: {
                                        C: "Cluster variables based on data and generate a dendrogram on the variable axis. It takes no parameters<br>",
                                        M: "Functions",
                                        T: "void",
                                        U: ["Heatmap"],
                                        S: ["distance", "linkage", "imputeMethod"]
                                    },
                                    xAxisRugPosition: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        M: "X-Axis",
                                        C: "Position for the rug in the X axis<br>",
                                        O: ["top", "bottom", "both"],
                                        T: "option",
                                        D: "bottom",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D","xAxisRugShow":true}']
                                    },
                                    motionCurrentScaleFontFactor: {
                                        D: "1",
                                        T: "float",
                                        M: "Motion Charts",
                                        C: "Scaling factor used to increase or decrease font size in motion charts.<br>",
                                        H: ['{"data":"Random:30:3:2:2","graphType":"Scatter2D","motionBy":"Annt1"}']
                                    },
                                    resizableY: {
                                        C: "Flag to disable resizing the height of canvas by dragging the mouse over the edges<br>",
                                        H: ["{[*]}"],
                                        T: "boolean",
                                        M: "Events",
                                        D: "true"
                                    },
                                    heatmapCellBoxColor: {
                                        T: "color",
                                        M: "Heatmap Graphs",
                                        D: "rgb(102,102,102)",
                                        C: "Color for the heatmap boxes around the cells<br>",
                                        H: ['{[*],"graphType":"Heatmap"}']
                                    },
                                    yAxisValuesRaw: {
                                        C: "Raw values for the ticks in the Y axis<br>",
                                        M: "Y-Axis",
                                        T: "array",
                                        Z: "true",
                                        D: "[]"
                                    },
                                    panningGlobalX: {
                                        D: "0",
                                        Z: "true",
                                        M: "Zooming, Panning and Resizing",
                                        T: "float",
                                        C: "Cumulative number of unit to pan the network in the X dimension<br>"
                                    },
                                    zAxisTickStyle: {
                                        D: "solid",
                                        T: "option",
                                        H: ['{[*],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        O: ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        M: "Z-Axis",
                                        C: "Style for the tick lines in the Z axis<br>"
                                    },
                                    titleColor: {
                                        H: ['{[*],"title":"Graph Title"}'],
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        S: ["title", "titleHeight"],
                                        C: "Color for the title<br>",
                                        M: "Titles and Subtitles"
                                    },
                                    startPieSectors: {
                                        C: "Starting degrees for pie sectors. 0 is equivalent to 3:00 oclock<br>",
                                        H: ['{[0,90,180,270],"data":"Random:5:6"}'],
                                        T: "float",
                                        M: "Pie Charts",
                                        D: "270"
                                    },
                                    setMaxX: {
                                        C: "Maximum value to set the data in the X axis<br>",
                                        H: ['{[20,50,null],"graphType":"Bar"}', '{[20,50,null],"graphType":"Scatter2D"}'],
                                        D: "null",
                                        M: "X-Axis",
                                        T: "float"
                                    },
                                    layoutComb: {
                                        T: "boolean",
                                        M: "Combination Plots",
                                        Z: "true",
                                        D: "false",
                                        C: "Flag that identify that multiple graphs will be displayed in the canvas. This is the case when ata is segregated, splom, multiple pies or DOE visualizations.<br>"
                                    },
                                    missingDataColor: {
                                        C: "Color for the missing data<br>",
                                        H: ['{[*],"data":"Random:10:10:0:0:1:100:0.15","graphType":"Heatmap"}'],
                                        D: "rgb(245,245,245)",
                                        T: "color",
                                        M: "Missing Data"
                                    },
                                    zAxisTickColor: {
                                        H: ['{[*],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        C: "Color for the tick lines in the Z axis<br>",
                                        M: "Z-Axis",
                                        T: "color",
                                        D: "rgb(204,204,204)"
                                    },
                                    pseudoRandom: {
                                        C: "Flag to indicate to use pseudo random rather than random<br>",
                                        D: "true",
                                        M: "Random",
                                        T: "boolean"
                                    },
                                    axisCoordinate: {
                                        C: "Flag to coordinate xAxis and xAxis2 in *-Line combination plots<br>",
                                        H: ['{[*],"graphType":"BarLine","xAxis":["V1","V2"],"xAxis2":["V3","V4"]}'],
                                        D: "false",
                                        M: "Axis",
                                        T: "boolean"
                                    },
                                    samplesClustered: {
                                        C: "Configuration property to cluster samples<br>",
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap"}'],
                                        D: "false",
                                        M: "Clustering",
                                        T: "boolean"
                                    },
                                    vennCompartments: {
                                        Z: "true",
                                        D: ["A", "B", "AB", "C", "AC", "BC", "ABC", "D", "AD", "BD", "CD", "ABD", "ACD", "BCD", "ABCD"],
                                        M: "Venn Diagrams",
                                        T: "array",
                                        C: "Name for the compartments in the the Venn diagrams<br>"
                                    },
                                    featureSignalToNoiseShow: {
                                        T: "boolean",
                                        M: "Genome Browser",
                                        D: "true",
                                        C: "Flag use to show quality<br>",
                                        H: ["{[*]}"]
                                    },
                                    disableEvents: {
                                        C: "Flag to disable all events.<br>",
                                        H: ["{[*]}"],
                                        D: "false",
                                        T: "boolean",
                                        M: "Events"
                                    },
                                    networkDragCoeff: {
                                        C: "Drag force coefficient. Used to slow down system, thus should be less than 1. The closer it is to 0 the less tight system will be.<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        T: "float",
                                        M: "Network Algorithm Parameters",
                                        D: "0.09"
                                    },
                                    heatmapCellBoxHighlightWidth: {
                                        D: "1",
                                        M: "Heatmap Graphs",
                                        T: "float",
                                        C: "Width for the highlighting heatmap boxes around the cells<br>",
                                        H: ['{[*],"graphType":"Heatmap","highlightVar":["V1","V2"],"highlightSmp":["S1","S2"]}']
                                    },
                                    fitLineColor: {
                                        C: "Color for the fit line<br>",
                                        H: ['{[*],"data":"Random:200:2","graphType":"Scatter2D","showLoessFit":true}'],
                                        M: "Error Bars and Confidence Intervals",
                                        T: "color",
                                        D: "rgb(255,215,0)"
                                    },
                                    featureNameFontColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the text of the features in the genome browser<br>",
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,0,0)"
                                    },
                                    swimHighCap: {
                                        O: ["false"],
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"data":"Swimmer","graphType":"Bar","barType":"swimmer"}'],
                                        X: "getXData",
                                        M: "Bar Graphs",
                                        C: "Name of sample annotation to use in Swimmer Plot. Defaults to 'High Cap'. See https://blogs.sas.com/content/graphicallyspeaking/2014/06/22/swimmer-plot/<br>"
                                    },
                                    titleColorBackground: {
                                        S: ["title", "titleHeight"],
                                        M: "Titles and Subtitles",
                                        C: "Color for the background of the title<br>",
                                        D: "false",
                                        T: "color",
                                        H: ['{[*],"title":"Graph Title"}']
                                    },
                                    sizeKey: {
                                        M: "Data Point Attributes",
                                        T: "object",
                                        D: "false",
                                        C: "Object to assign custom sizes to sample annotations and variable annotations included in the data object. The key of the object is the name of an annotation in the data.x object or the name of an annotation in the data.z object. A default size will be assigned to a data point whose value was not included the object.<br>",
                                        H: ['{"graphType":"Dotplot","sizeBy":"Factor1","sizeKey":{"Factor1":{"Lev:1":5,"Lev:2":10}}}']
                                    },
                                    yAxisTitle: {
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"],
                                        M: "Y-Axis",
                                        C: "Title for the Y axis in Scatter plots and in Correlation graphs.<br>",
                                        D: "false",
                                        T: "string",
                                        H: ['{"data":"Random:10:2","yAxisTitle":"Y-axis title"}']
                                    },
                                    patterns: {
                                        C: "Patterns used in visualizations to fill objects. This array must contain one or more pattern names and in concert with the color array can be used to specify the pattern colors for all filled objects in the visualizations.. The order will dictate the utilization in the visualization.<br>",
                                        M: "General Attributes",
                                        O: ["solid", "hatchForward", "hatchReverse", "stripeHorizontal", "stripeVertical", "polkaDot", "crossHatch", "crossStripe", "squares", "circles", "plus", "minus", "bars", "squiglesVertical", "squiglesHorizontal", "brickForward", "brickReverse", "art", "pcx", "hatchForward3", "hatchReverse3"],
                                        H: ['{"data":"Random:21:1:0:0:1:100:0:false:uniform","graphType":"Bar","graphOrientation":"vertical","setMaxX":1,"setMinX":0,"smpLabelRotate":90,"patternBy":"variable","showLegend":false,"colorScheme":"White"}'],
                                        D: ["solid", "hatchForward", "hatchReverse", "stripeHorizontal", "stripeVertical", "polkaDot", "crossHatch", "crossStripe", "squares", "circles", "plus", "minus", "bars", "squiglesVertical", "squiglesHorizontal", "brickForward", "brickReverse", "art", "pcx", "hatchForward3", "hatchReverse3"],
                                        T: "array"
                                    },
                                    featureWidthDefault: {
                                        M: "Genome Browser",
                                        T: "integer",
                                        D: "3",
                                        C: "Default size in pixels of the feature width<br>"
                                    },
                                    randomMethod: {
                                        M: "Random",
                                        T: "option",
                                        D: "numericalRecipes",
                                        C: "Random method",
                                        O: ["jenkins", "numericalRecipes"]
                                    },
                                    remoteEffectOut: {
                                        C: "remoteEffectOut<br>",
                                        H: ["{[*]}"],
                                        M: "Effect",
                                        T: "string",
                                        D: "holeOut"
                                    },
                                    xAxis2: {
                                        X: "getVariablesAsArray",
                                        M: "X-Axis2",
                                        C: "Name of the variables in one dimensional graphs<br>",
                                        T: "array",
                                        D: "[]",
                                        H: ['{"data":"Random:4:8","xAxis2":["V1"],"xAxis":["V2"],"graphType":"BarLine"}']
                                    },
                                    shapeByShape: {
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "false",
                                        O: ["false", "sphere", "square", "triangle", "star", "rhombus", "octagon", "oval", "plus", "minus", "mdavid"],
                                        C: "String that identify the shape to use in regular and multidimensional heatmaps. shapeByData will take precedence over this property.<br>",
                                        M: "Data Point Attributes",
                                        U: ["Heatmap"]
                                    },
                                    randomNetworkLayout: {
                                        O: ["forceDirected", "circular", "radial", "duo", "trio", "pentagon", "hexagon", "octagon", "star", "small", "medium", "large", "huge", "lesmiserables", "karate"],
                                        D: "forceLayout",
                                        T: "option",
                                        U: ["Network"],
                                        M: "Random",
                                        C: "Random network layout<br>"
                                    },
                                    patternNodeBy: {
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","patternNodeBy":"type"}'],
                                        C: "Name of the attribute to pattern the nodes.<br>",
                                        D: "false",
                                        T: "string",
                                        M: "Network Node and Edge Attributes"
                                    },
                                    colorSpectrumNumber: {
                                        M: "Colors",
                                        T: "integer",
                                        D: "100",
                                        H: ['{[100,6],"graphType":"Heatmap"}'],
                                        C: "Number of colors to use in the color spectrum<br>"
                                    },
                                    highlightGreyOut: {
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        M: "General",
                                        C: "Flag to add grey out when highlighting with mouse over<br>",
                                        S: ["highlightGreyOutTransparency"]
                                    },
                                    motionCurrentFontSize: {
                                        D: "60",
                                        T: "integer",
                                        H: ['{"data":"Random:30:3:2:2","graphType":"Scatter2D","motionBy":"Annt1"}'],
                                        M: "Motion Charts",
                                        C: "Font size for the motion charts.<br>",
                                        S: ["autoScaleFont", "motionCurrentScaleFontFactor"]
                                    },
                                    xRotate: {
                                        D: "45",
                                        T: "float",
                                        M: "3D Attributes",
                                        C: "Starting number of degrees to rotate graph arround the X axis<br>",
                                        H: ['{[0,45],"data":"Random:8:4","graphType":"Scatter3D"}']
                                    },
                                    isMultidimensionalData: {
                                        C: "Flag to indicate if there is more than a single data set.<br>",
                                        M: "Heatmap Graphs",
                                        T: "boolean",
                                        Z: "true",
                                        D: "false"
                                    },
                                    varLabelFontColor: {
                                        H: ["{[*]}"],
                                        T: "color",
                                        D: "rgb(0,0,0)",
                                        U: ["Heatmap"],
                                        C: "Font color for the variable labels in one dimensional plots<br>",
                                        M: "Variables"
                                    },
                                    translateY: {
                                        C: "Amount to translate for the Y axis.<br>",
                                        Z: "true",
                                        D: "0",
                                        M: "Combination Plots",
                                        T: "float"
                                    },
                                    remoteData: {
                                        T: "array",
                                        M: "Remote Procedures",
                                        Z: "true",
                                        D: "[]",
                                        C: "Array for the remote data pased after a service call<br>"
                                    },
                                    sortCaseSensitive: {
                                        D: "false",
                                        M: "Data sorting",
                                        T: "boolean",
                                        C: "Whether to use case sensitive in ascii sorting. Almost 'private' parameters used within the different CanvasXpress UIs.<br>"
                                    },
                                    foreground: {
                                        C: "Specifies the foreground color for text or lines not covered in a more specific configuration property.<br>",
                                        M: "Foreground and Background",
                                        S: ["objectBorderColor"],
                                        H: ['{[*],"data":"Random:1:3:0:0","graphType":"Dotplot"}'],
                                        D: "rgb(0,0,0)",
                                        T: "color"
                                    },
                                    variableSpaceFactor: {
                                        H: ['{[2,6],"data":"Random:2:4","graphType":"Bar"}'],
                                        T: "integer",
                                        D: "2",
                                        C: "Factor to adjust the spacing between the data points between the variables in the one dimensional plots. The greater the number, the greater the gap.<br>",
                                        M: "Aspect Ratio, Space and width",
                                        S: ["sampleSpaceFactor", "widthFactor"]
                                    },
                                    sequenceMColor: {
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(0,103,0)",
                                        C: "Color for the degenerate A/G and methionines in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    ratioLevelReference: {
                                        D: "",
                                        T: "option",
                                        M: "Data",
                                        C: "Name of the level used in ratio transformation. Almost 'private' parameters used within the different CanvasXpress UIs.<br>"
                                    },
                                    showContourLevel: {
                                        C: "Flag to show the levels in contours<br>",
                                        H: ['{"data":"Random:20:20","functions":["createContour"]}'],
                                        D: "false",
                                        T: "boolean",
                                        M: "Contours"
                                    },
                                    infoStartTime: {
                                        Z: "true",
                                        D: "new Date().getTime()",
                                        T: "time",
                                        M: "Events",
                                        C: "Time in milliseconds to keep track of time<br>"
                                    },
                                    filterVarBy: {
                                        X: "getZData",
                                        U: ["AGraphs"],
                                        M: "Data Filters",
                                        C: "Filter variables by their annotation included in the 'data.z' object used in one dimensional plots. Used in the CanvasXpress UIs.<br>",
                                        T: "filter",
                                        D: "{'cases':[],'comp':[],'op':[],'type':[],'value':[]}"
                                    },
                                    adjustBezier: {
                                        C: "Flag to automatically select the bezier line type. the bezier can start from the top or bottom (vertical), or from the side (horizontal). This will be based on the location of the two points joined by the line.<br>",
                                        M: "Lines",
                                        U: ["Network"],
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}'],
                                        T: "boolean",
                                        D: "false"
                                    },
                                    decorationsColors: {
                                        U: ["Network"],
                                        M: "Decorations",
                                        C: "Array of colors used for selection in network decorations not to be confused by its singular form 'decorationsColor' above<br>",
                                        T: "array",
                                        D: "[]",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","decorationsPosition":"right","showDecorations":true,"decorationsColors":["rgb(51,125,255)","rgb(125,255,51)","rgb(255,125,51)"],"decorations":["D1","D2","D3"]}']
                                    },
                                    featureStaggered: {
                                        D: "false",
                                        M: "Genome Browser",
                                        T: "boolean",
                                        C: "Flag use to stagger the features in the genome panel<br>",
                                        H: ["{[*]}"]
                                    },
                                    smpOverlays: {
                                        C: "Sample annotations included in the 'data.x' object used in one dimensional plots<br>",
                                        M: "Overlays",
                                        X: "getXData",
                                        H: ['{"data":"Random:10:10:0:3","smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        T: "array",
                                        D: "[]"
                                    },
                                    filterNodeBy: {
                                        U: ["Network"],
                                        X: "getNodeData",
                                        M: "Data Filters",
                                        C: "Filter nodes by their properties used in network graphs. Used in the CanvasXpress UIs.<br>",
                                        D: "{'cases':[],'comp':[],'op':[],'type':[],'value':[]}",
                                        T: "filter"
                                    },
                                    xAxisHistogramHeight: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        M: "X-Axis",
                                        C: "Number of pixels for the histogram in the X axis<br>",
                                        D: "80",
                                        T: "integer",
                                        H: ['{[*],"graphType":"Scatter2D","xAxisHistogramShow":true}']
                                    },
                                    filterSkipNullValues: {
                                        C: "Flag to indicate to bypass filtering when a value is null.<br>",
                                        D: "false",
                                        T: "boolean",
                                        M: "Data Filters"
                                    },
                                    varOverlayProperties: {
                                        D: "{}",
                                        M: "Overlays",
                                        T: "object",
                                        C: "Object to assign properties to the variable overlays. The key should be an annotation in the 'data.z' object and the value should be either type which could be either one of the one dimensional graph types or increasing, or decreasing for continuous annotations<br>"
                                    },
                                    remoteServiceType: {
                                        O: ["webService", "file"],
                                        D: "webService",
                                        T: "string",
                                        S: ["remoteService", "remoteParams"],
                                        M: "Remote Procedures",
                                        C: "Type of web service to obtain data remotely<br>"
                                    },
                                    transparency: {
                                        H: ["{[*]}"],
                                        C: "Percentage of transparency applied to all elements in the visualizations<br>",
                                        D: "null",
                                        T: "float",
                                        M: "General"
                                    },
                                    resizerBackgroundColor: {
                                        D: "rgba(204,204,204,0.7)",
                                        M: "Zooming, Panning and Resizing",
                                        T: "color",
                                        H: ["{[*]}"],
                                        C: "Color for the div that shows up when resizing the canvas<br>"
                                    },
                                    adjustAspectRatio: {
                                        C: "Flag to automatically adjust the size of the bars or points in the one dimensional plots to fit in the provided canvas width and height. If the flag is set to 'false' the width and height of the canvas will be sized according to the number of bars or points in the data set.<br>",
                                        M: "Aspect Ratio, Space and width",
                                        S: ["variableSpaceFactor", "sampleSpaceFactor", "widthFactor", "adjustAspectRatioHeatmapIndicator"],
                                        H: ['{[*],"graphOrientation":"vertical"}'],
                                        T: "boolean",
                                        D: "true"
                                    },
                                    zoom: {
                                        H: ['{[*],"graphType":"Heatmap"}'],
                                        C: "Zoom factor for the networks. A number greater than zero<br>",
                                        D: "1",
                                        M: "Zooming, Panning and Resizing",
                                        T: "float"
                                    },
                                    connectByWidth: {
                                        D: "2",
                                        M: "Data Point Attributes",
                                        T: "integer",
                                        C: "Width for the line of the connectBy line<br>",
                                        H: ['{[2,6],"graphType":"Scatter3D","connectBy":"Annt1"}']
                                    },
                                    showNetworkCommunities: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:karate","calculateNetworkCommunities":true}'],
                                        C: "Flag to show or hide network communities<br>",
                                        M: "Network Communities",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    errorBarsColor: {
                                        C: "Color for the error bars in dotplots and barplots.<br>",
                                        H: ['{[*],"setMinX":0,"groupingFactors":["Factor1"]}'],
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        M: "Error Bars and Confidence Intervals"
                                    },
                                    mapStandardParallel2: {
                                        C: "Map Standard Parallel 2 in degrees. (Applicable to Albers projection only). Default adjusts to USA maps.<br>",
                                        H: ["{[*]}"],
                                        T: "float",
                                        M: "Maps",
                                        D: "45.5"
                                    },
                                    chromosomeLengths: {
                                        D: "[]",
                                        T: "array",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        S: ["scatterType"],
                                        M: "Scatter Plots",
                                        C: "Manhattan Chromosomes length is a sorted array by chromosome with the length in base pairs for each chromosome. It is required when scatterType is manhattan.<br>"
                                    },
                                    smpLabelScaleFontFactor: {
                                        C: "Scaling factor used to increase or decrease sample label font size in the canvas.<br>",
                                        H: ["{[*]}"],
                                        D: "1",
                                        T: "float",
                                        M: "Samples"
                                    },
                                    loessSteps: {
                                        D: "30",
                                        M: "Loess",
                                        T: "integer",
                                        H: ['{[20,30],"data":"Random:200:2","graphType":"Scatter2D","showLoessFit":true,"loessDegree":1,"showConfidenceIntervals":true}'],
                                        C: "Loess steps. Number of steps to smooth the line.<br>"
                                    },
                                    motionWidth: {
                                        C: "Size in pixels for the motion widget when used to reproduce user customizations.<br>",
                                        H: ["{[*]}"],
                                        D: "250",
                                        T: "integer",
                                        M: "Motion Charts"
                                    },
                                    rAxisLabelOrientation: {
                                        O: ["perpendicular", "circular"],
                                        H: ['{[*],"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        D: "perpendicular",
                                        T: "option",
                                        C: "Orientation to show the ticks values in circular plots.<br>",
                                        M: "R-Axis"
                                    },
                                    rAxisMaxStrLength: {
                                        D: "null",
                                        Z: "true",
                                        T: "string",
                                        M: "R-Axis",
                                        C: "Longest string of all the values in the ticks in the R axis<br>"
                                    },
                                    mapProjection: {
                                        M: "Maps",
                                        C: "Map projection<br>",
                                        D: "mercator",
                                        T: "option",
                                        H: ["{[*]}"],
                                        O: ["mercator", "albers", "orthographic"]
                                    },
                                    adjustAspectRatioXTries: {
                                        C: "Counter set when trying to automatically adjust the horizontal size of the canvas when adjustAspectRatio is true<br>",
                                        D: "0",
                                        Z: "true",
                                        T: "integer",
                                        M: "Aspect Ratio, Space and width"
                                    },
                                    timeValueIndices: {
                                        T: "array",
                                        M: "Time Series",
                                        D: "[]",
                                        Z: "true",
                                        C: "Array containing the indices of the values when the the graph is a time series<br>"
                                    },
                                    shapeByContinuous: {
                                        D: "false",
                                        M: "Data Point Attributes",
                                        T: "boolean",
                                        C: "Flag to use pie shapes with continuous data as opposed to by binning the data and show regular shapes<br>",
                                        H: ['{[*],"data":"Random:8:4:3:3","graphType":"Scatter2D","shapeBy":"Factor3"}']
                                    },
                                    disableShowShortcuts: {
                                        C: "Flag to disable showing shortcuts.<br>",
                                        H: ["{[*]}"],
                                        T: "boolean",
                                        M: "Events",
                                        D: "false"
                                    },
                                    transitionFunction: {
                                        O: ["linear", "easeInQuad", "easeOutQuad", "easeInOutQuad", "easeInCubic", "easeOutCubic", "easeInOutCubic", "easeInQuart", "easeOutQuart", "easeInOutQuart", "easeInQuint", "easeOutQuint", "easeInOutQuint"],
                                        T: "option",
                                        D: "easeInOutQuad",
                                        H: ['{[*],"graphType":"Bar","showTransition":true,"groupingFactors":["Factor1"]}'],
                                        M: "Animations and Visualization Transitions",
                                        C: "Easing function for the transition<br>"
                                    },
                                    createHistogram: {
                                        C: "Create a histogram in 2D-Scatter plots in the 'x' axis or the 'y' axis<br> @advanced",
                                        M: "Functions",
                                        T: "option",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        O: ["x", "y"]
                                    },
                                    patternByData: {
                                        H: ['{"data":"RandomMultidimensional:5:10:1:1","patternByData":"data3","patternBy":"DataPattern"}'],
                                        D: "false",
                                        T: "string",
                                        U: ["Heatmap"],
                                        S: ["patternBy"],
                                        C: "String that identify the object containing a two dimensional array with values used to pattern the data points when drawing a multidimensional Heatmap. It must be located within the data.y object (for example: data.y.data4)<br>",
                                        M: "Data Point Attributes"
                                    },
                                    yAxisMaxStrLength: {
                                        C: "Longest string of all the values in the ticks in the Y axis<br>",
                                        M: "Y-Axis",
                                        T: "string",
                                        Z: "true",
                                        D: "null"
                                    },
                                    xAxis2MaxStrLength: {
                                        C: "Longest string of all the values in the ticks in the 2nd X axis<br>",
                                        M: "X-Axis2",
                                        T: "string",
                                        Z: "true",
                                        D: "null"
                                    },
                                    layoutBoxLabelColors: {
                                        C: 'Layout box label background colors.<br> @ex {["gold","silver"],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"];',
                                        D: "[]",
                                        M: "Combination Plots",
                                        T: "array"
                                    },
                                    circularCenterProportion: {
                                        H: ['{[0.3,0.5],"data":"RandomCircular:4:20:2:3","graphType":"Circular","segregateSamplesBy":["Factor1"]}'],
                                        C: "Proportion of the center of the circular graph to use as void; that is the fraction of the radius in the middle of the graph.<br>",
                                        M: "Circular Graphs",
                                        T: "float",
                                        D: "0.3"
                                    },
                                    calculateLayout: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        C: "Flag to force or not to calculate the network layout.<br>",
                                        M: "Network Graphs",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    smpTitle: {
                                        T: "string",
                                        M: "Samples",
                                        D: "false",
                                        C: "Title for the sample axis in one dimensional plots<br>",
                                        H: ['{"smpTitle":"Sample Title"}']
                                    },
                                    rotationStep: {
                                        M: "3D Attributes",
                                        T: "integer",
                                        D: "2",
                                        C: "Number of degrees used when the plot is automatically rotated<br>",
                                        H: ['{[*],"data":"Random:8:4","graphType":"Scatter3D"}']
                                    },
                                    is3DPlot: {
                                        C: "Flag to create or not a 3D plot<br>",
                                        H: ['{[*],"graphType":"Bar"}'],
                                        T: "boolean",
                                        M: "Plot area",
                                        D: "false"
                                    },
                                    yAxisTitleDynamic: {
                                        C: "Set the title for the Y axis dynamically as it changes<br>",
                                        H: ["{[*]}"],
                                        D: "false",
                                        T: "boolean",
                                        M: "Y-Axis"
                                    },
                                    setMaxZ: {
                                        H: ['{[23,null],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        C: "Maximum value to set the data in the Z axis<br>",
                                        D: "null",
                                        M: "Z-Axis",
                                        T: "float"
                                    },
                                    legendPosition: {
                                        H: ['{["right","bottom"],"legendInside":false}', '{[*],"legendInside":true}'],
                                        T: "option",
                                        D: "right",
                                        O: ["topRight", "right", "bottomRight", "bottom", "bottomLeft", "left", "topLeft", "top"],
                                        C: "Position for the legend in the graphs. If legendInside is true the all the options apply but if legendInside is false only right and bottom are valid options<br>",
                                        M: "Legends",
                                        S: ["legendInside", "legendPositionAuto"]
                                    },
                                    setMinX2: {
                                        U: ["AreaLine", "BarLine", "StackedLine", "StackedPercentLine"],
                                        M: "X-Axis2",
                                        C: "Minimum value to set the data in the 2nd axis<br>",
                                        D: "null",
                                        T: "float",
                                        H: ['{[10,20,null],"data":"Random:4:8","graphType":"BarLine","xAxis2":["V1","V2"],"xAxis":["V3","V4"]}']
                                    },
                                    smpTitleFontSize: {
                                        H: ['{[*],"smpTitle":"SampleTitle","autoScaleFont":false}'],
                                        C: "Size for the sample title in one dimensional plots<br>",
                                        T: "integer",
                                        M: "Samples",
                                        D: "12"
                                    },
                                    showVersion: {
                                        M: "Debug",
                                        T: "boolean",
                                        D: "true",
                                        C: "Flag to show version when mouse over top-left corner of the canvas.<br>"
                                    },
                                    skipConfigurableProperties: {
                                        D: "true",
                                        M: "Data Table/Filter",
                                        T: "boolean",
                                        C: "Flag to indicate to exclude configurable parameters in the data table and the data filters in Networks and Genome Browser<br>"
                                    },
                                    overlayFontStyle: {
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        D: "",
                                        T: "option",
                                        O: ["", "bold", "italic", "bold italic"],
                                        C: "Font style for the overlays.<br>",
                                        M: "Overlays"
                                    },
                                    decorationFontStyle: {
                                        M: "Decorations",
                                        C: "Font style for the decorations.<br>",
                                        O: ["", "bold", "italic", "bold italic"],
                                        T: "option",
                                        D: "",
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}']
                                    },
                                    fontStyle: {
                                        C: "Font style.<br>",
                                        M: "Text",
                                        O: ["", "bold", "italic", "bold italic"],
                                        H: ['{[*],"title":"Graph Title"}'],
                                        D: "",
                                        T: "option"
                                    },
                                    qqDistribution: {
                                        C: "Type of the QQ plot<br>",
                                        M: "QQ Plots",
                                        H: ['{[*],"data":"Random:200:2","graphType":"Scatter2D"}'],
                                        D: "normal",
                                        T: "option",
                                        O: ["normal", "uniform"]
                                    },
                                    mapLatideOrigin: {
                                        D: "23.0",
                                        M: "Maps",
                                        T: "float",
                                        C: "Map Latitude Of Origin in degrees. (Applicable to Albers projection only). Default adjusts to USA maps.<br>",
                                        H: ["{[*]}"]
                                    },
                                    bandwidthCut: {
                                        S: ["createHistogram", "showHistogramDensity"],
                                        M: "Density Plots",
                                        C: "Bandwidth cut<br>",
                                        T: "integer",
                                        D: "3",
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50,"showHistogramDensity":true}']
                                    },
                                    sankeyTarget: {
                                        X: "getXData",
                                        C: "Name of a sample annotation to use as target in the sankey diagrams<br>",
                                        M: "Sankey Diagrams",
                                        O: ["false"],
                                        H: ['{"data":"RandomSankey","graphType":"Sankey","sankeyTarget":"Target"}', '{"data":"RandomSankey","graphType":"Sankey","sankeyTarget":"Target2"}'],
                                        D: "false",
                                        T: "option"
                                    },
                                    configuratorEffectIn: {
                                        C: "configuratorEffectIn<br>",
                                        H: ["{[*]}"],
                                        T: "string",
                                        M: "Effect",
                                        D: "swashIn"
                                    },
                                    xAxis2Title: {
                                        M: "X-Axis2",
                                        T: "string",
                                        D: "false",
                                        C: "Title for the 2nd X axis<br>",
                                        H: ['{"data":"Random:4:8","graphType":"BarLine","xAxis2":["V1","V2"],"xAxis":["V3","V4"],"xAxis2Title":"2nd X-axis title"}']
                                    },
                                    xAxisRugHeight: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        M: "X-Axis",
                                        C: "Number of pixels for the rug in the X axis<br>",
                                        D: "15",
                                        T: "integer",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D","xAxisRugShow":true}']
                                    },
                                    overlaysThickness: {
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        T: "integer",
                                        D: "18",
                                        C: "Relative length in pixels for the thickness of the colored boxes to classify samples and or variables in one dimensional plots. This value is adjusted acording to the graph dimensions if the adjustAspectRatio parameter is set to 'true'.<br>",
                                        M: "Overlays",
                                        S: ["adjustAspectRatio"]
                                    },
                                    featureCoordinateShow: {
                                        H: ["{[*]}"],
                                        C: "Flag use to show coordinates<br>",
                                        T: "boolean",
                                        M: "Genome Browser",
                                        D: "true"
                                    },
                                    refresehDataTableOnDraw: {
                                        C: "Flag to indicate to refresh data after drawing the plot<br>",
                                        D: "false",
                                        M: "Data Table",
                                        T: "boolean"
                                    },
                                    xAxisS2Show: {
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"],
                                        M: "X-Axis",
                                        C: "Flag to show or not the values of the ticks in the X axis at the top in Scatter plots<br>",
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"graphType":"Scatter2D"}']
                                    },
                                    sizeNodeBy: {
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","sizeNodeBy":"n","graphType":"Network"}'],
                                        C: "Name of the attribute to size the nodes.<br>",
                                        D: "false",
                                        T: "string",
                                        M: "Network Node and Edge Attributes"
                                    },
                                    randomNetworkReduce: {
                                        U: ["Network"],
                                        T: "boolean",
                                        M: "Random",
                                        D: "true",
                                        C: "Flag to create or not a single random network for debug and demonstration purposes<br>"
                                    },
                                    translateX: {
                                        C: "Amount to translate for the X axis.<br>",
                                        T: "float",
                                        M: "Combination Plots",
                                        D: "0",
                                        Z: "true"
                                    },
                                    transitionStep: {
                                        H: ['{[*],"graphType":"Bar","showTransition":true,"groupingFactors":["Factor1"]}'],
                                        C: "Steps for transition<br>",
                                        M: "Animations and Visualization Transitions",
                                        T: "integer",
                                        D: "20"
                                    },
                                    showCircularConnections: {
                                        H: ['{[*],"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"connections":[["red","S1","S4"],["blue","S2","S5"],["green","S3","S6"]]}'],
                                        C: "Flag to show connections in circular graphs<br>",
                                        M: "Circular Graphs",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    appendNetworkData: {
                                        C: "Array containing additional data files to append to networks. Useful for loading KEGG and Wikipatways to decorate the nodes and the edges.<br>",
                                        D: "[]",
                                        T: "array",
                                        M: "Data"
                                    },
                                    xAxis2MinorValues: {
                                        U: ["AreaLine", "BarLine", "StackedLine", "StackedPercentLine"],
                                        Z: "true",
                                        M: "X-Axis2",
                                        C: "Values for the minor ticks in the 2nd X axis<br>",
                                        D: "[]",
                                        T: "array"
                                    },
                                    nodeScaleFontFactor: {
                                        D: "1",
                                        M: "Network Graphs",
                                        T: "float",
                                        C: "Scaling factor used to increse or decrease network text font size in the canvas.<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    randomDataSigma: {
                                        C: "Sigma value when creating random data<br>",
                                        M: "Random",
                                        T: "integer",
                                        D: "1"
                                    },
                                    trackFillColor: {
                                        H: ["{[*]}"],
                                        C: "Default color for the fill of the tracks in the genome browser<br>",
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(255,255,255)"
                                    },
                                    codeType: {
                                        O: ["pretty", "compact", "tab", "params"],
                                        D: "params",
                                        T: "option",
                                        M: "Debug",
                                        C: "Output type for the JSON code<br>"
                                    },
                                    layoutCollapse: {
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        C: "Flag to make layout graphs without any space in between<br>",
                                        D: "false",
                                        M: "Combination Plots",
                                        T: "boolean"
                                    },
                                    violinTransparency: {
                                        H: ['{[*],"data":"Random:2:12:0:2","showViolinBoxplot":true,"showBoxplotIfViolin":true,"groupingFactors":["Factor1"]}'],
                                        C: "Fraction to adjust color transparency for the violins.<br>",
                                        D: "0.5",
                                        M: "Boxplot Graphs",
                                        T: "float"
                                    },
                                    colorEdgeBy: {
                                        D: "false",
                                        M: "Network Node and Edge Attributes",
                                        T: "string",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","colorEdgeBy":"kind"}'],
                                        C: "Name of the attribute to color the edges.<br>"
                                    },
                                    fitLineStyle: {
                                        M: "Error Bars and Confidence Intervals",
                                        C: "Color for the fit line<br>",
                                        O: ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        T: "option",
                                        D: "solid",
                                        H: ['{[*],"data":"Random:200:2","graphType":"Scatter2D","showLoessFit":true}']
                                    },
                                    heatmapSeparatorThickness: {
                                        D: "3",
                                        T: "float",
                                        M: "Heatmap Graphs",
                                        H: ['{[2.5,5],"graphType":"Heatmap","heatmapVarSeparateBy":"Annt1","variablesClustered":true,"varOverlays":["Annt1"],"heatmapSmpSeparateBy":"Factor1","samplesClustered":true,"smpOverlays":["Factor1"]}'],
                                        C: "Thickness of the separation of samples and variables in the heatmap.<br>"
                                    },
                                    errorBarsThickness: {
                                        T: "float",
                                        M: "Error Bars and Confidence Intervals",
                                        D: "3",
                                        H: ['{[*],"setMinX":0,"groupingFactors":["Factor1"]}'],
                                        C: "Thickness for the error bars in dotplots.<br>"
                                    },
                                    meterStart: {
                                        C: "Start value for the meter in degrees.<br>",
                                        H: ['{[*],"graphType":"Meter"}'],
                                        D: "270",
                                        M: "Meter Graphs",
                                        T: "float"
                                    },
                                    histogramMedianLineStyle: {
                                        D: "dashed",
                                        T: "option",
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        O: ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        M: "Histograms",
                                        C: "Line type for the histogram median<br>",
                                        S: ["createHistogram", "densityKernel"]
                                    },
                                    yAxisTransformTicks: {
                                        C: "Flag to transform the values of the ticks in the Y axis<br>",
                                        H: ['{[*],"data":"Random:10:2","yAxisTransform":"log10","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        M: "Y-Axis",
                                        D: "true"
                                    },
                                    showOverlays: {
                                        C: "Flag to indicate to show or not the overlays in one dimensional plots<br>",
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        T: "boolean",
                                        M: "Overlays",
                                        D: "true"
                                    },
                                    hideInfoDiv: {
                                        C: "Hide additional information<br> @advanced",
                                        M: "Functions",
                                        T: "void"
                                    },
                                    remoteParamOverride: {
                                        D: "true",
                                        M: "Remote Procedures",
                                        T: "boolean",
                                        C: "Flag to override parameters to maintain the state of the graphs when using remote services<br>"
                                    },
                                    segregateVariables: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"],
                                        X: "getZData",
                                        S: ["segregateVariables"],
                                        C: "Segregate variables based on a variable category (data.z object)<br>",
                                        M: "Functions",
                                        T: "option"
                                    },
                                    backgroundWindow: {
                                        T: "color",
                                        D: "rgb(244,244,244)",
                                        H: ['{[*],"backgroundType":"window"}'],
                                        S: ["backgroundType"],
                                        M: "Foreground and Background",
                                        C: "Specifies the background color for the canvas when the background type is of a type 'window'.<br>"
                                    },
                                    xAxisRightMajorTick: {
                                        T: "boolean",
                                        D: "true",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        M: "X-Axis",
                                        C: "A flag to show the right Major tick line in the X axis in Scatter2D plots<br>",
                                        U: ["Scatter2D", "ScatterBubble2D"]
                                    },
                                    layoutLabelColor: {
                                        C: "Color for the label text in layout graphs<br>",
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        M: "Combination Plots"
                                    },
                                    showCodeDiv: {
                                        C: "Show the code for the plot<br> @advanced",
                                        T: "void",
                                        M: "Functions"
                                    },
                                    rowHeight: {
                                        M: "Data Table",
                                        T: "integer",
                                        D: "18",
                                        C: "Mumber of pixels for the height of cells in the data table<br>"
                                    },
                                    overlayFontColor: {
                                        C: "Color for the overlays in one dimensional plots<br>",
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        D: "rgb(0,0,0)",
                                        M: "Overlays",
                                        T: "color"
                                    },
                                    disablePlusMinusKeys: {
                                        H: ["{[*]}"],
                                        C: "Flag to disable plus / minus key binding events.<br>",
                                        T: "boolean",
                                        M: "Events",
                                        D: "true"
                                    },
                                    dotLength: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}'],
                                        C: "Size in pixels of the length between dots in the doted lines.<br>",
                                        D: "1",
                                        T: "integer",
                                        M: "Lines"
                                    },
                                    loessAccuracy: {
                                        C: "Loess accuracy<br>",
                                        D: "1e-12",
                                        Z: "true",
                                        T: "float",
                                        M: "Loess"
                                    },
                                    disableWindow: {
                                        C: "Flag to disable resizing the canvas when the window is resized. <br>",
                                        H: ["{[*]}"],
                                        T: "boolean",
                                        M: "Events",
                                        D: "false"
                                    },
                                    featureQualityShow: {
                                        H: ["{[*]}"],
                                        C: "Flag use to show quality<br>",
                                        D: "true",
                                        T: "boolean",
                                        M: "Genome Browser"
                                    },
                                    maxCols: {
                                        D: "6",
                                        M: "Data Table",
                                        T: "integer",
                                        C: "Maximum number of columns to display in the data table<br>"
                                    },
                                    kmeansSmpClusters: {
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap","samplesKmeaned":true}'],
                                        D: "3",
                                        T: "integer",
                                        S: ["maxIterations", "kmeansVarClusters", "kmeansSamples", "kmeansVariables"],
                                        C: "Number of clusters when clustering sample data with kmeans.<br>",
                                        M: "Clustering"
                                    },
                                    fishShape: {
                                        O: ["spline", "polygon"],
                                        H: ['{[*],"graphType":"Fish"}'],
                                        D: "polygon",
                                        T: "option",
                                        C: "Fish Shape<br>",
                                        M: "Fish Graphs"
                                    },
                                    graphType: {
                                        C: "Specifies the type of graph.<br>",
                                        M: "General",
                                        O: ["Bar", "Line", "Area", "AreaLine", "BarLine", "Boxplot", "Dotplot", "DotLine", "Fish", "Gantt", "Meter", "Heatmap", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation", "Pie", "Venn", "Network", "Genome", "Circular"],
                                        H: ['{[*],"graphOrientation":"vertical"}'],
                                        D: "Bar",
                                        T: "option"
                                    },
                                    randomDataSamples: {
                                        M: "Random",
                                        T: "integer",
                                        D: "36",
                                        C: "Default number of samples when creating random data<br>"
                                    },
                                    arrowPointSize: {
                                        D: "9",
                                        M: "Lines",
                                        T: "integer",
                                        C: "Size in pixels of the arrow head in arrow lines.<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}']
                                    },
                                    pieType: {
                                        O: ["separated", "solid"],
                                        T: "option",
                                        D: "separated",
                                        H: ["{[*]}"],
                                        M: "Pie Charts",
                                        C: "Position for the pices of the pie<br>"
                                    },
                                    colorDataTableTransparency: {
                                        S: ["colorDataTable"],
                                        C: "Transparency for the background of the data table cells if colored<br>",
                                        T: "float",
                                        M: "Data Table",
                                        D: "0.5"
                                    },
                                    maxTextSize: {
                                        C: "Maximum size for any text in the canvas.<br>",
                                        H: ['{[*],"title":"Graph Title"}'],
                                        T: "integer",
                                        M: "Text",
                                        D: "40"
                                    },
                                    decorations: {
                                        S: ["showDecorations"],
                                        M: "Decorations",
                                        C: "Name of the node properties to include in the network decorations in the 'data.nodes' object<br>",
                                        D: "false",
                                        T: "object",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","showDecorations":true,"decorationsType":"pie","decorations":["D1","D2","D3"]}', '{"data":"RandomNonLinearFit","showDecorations":true,"graphType":"Scatter2D","xAxisTransform":"log10","xAxisTransformTicks":false,"setMaxY":350,"setMinY":100,"yAxisExact":true,"decorations": {"nlfit":[{"label":"Custom Fit","type":"cst","param":["164","313","0.031","-1.5","1.2e-06","1.9"]},{"label":"Regular Fit","type":"reg","param":["164","313","0.031","1.5","1.2e-06","1.9"]}]}}', '{"data":"Random:1:8","showDecorations":true,"graphType":"Bar","decorations":{"line":[{"value":20,"label":"Background","color":"rgb(255,125,51)","type":"dashedLine","graphOrientation":"vertical"}]}}', '{"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}', '{"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addRegressionLine"]}', '{"data":"Random:8:4","showDecorations":true,"showLegend":false,"graphType":"Scatter2D","decorations":{"area":[{"x":20,"y":20,"label":"Area","width":8,"height":8,"color":"rgb(255,125,51,0.5)","ouline":"rgb(255,125,51,0.5)","pattern":"closed","type":"oval"}]}}', '{"data":"RandomKaplanMeier","showDecorations":true,"graphType":"Scatter2D","showLegend":false,"functions":["addKaplanMeierCurve:Time:Censored-1:Data 1 Population:rgb(0,0,255)","addKaplanMeierCurve:Time:Censored-2:Data 2 Population:rgb(255,0,0)"]}']
                                    },
                                    sequencePColor: {
                                        D: "rgb(255,165,0)",
                                        M: "Genome Browser",
                                        T: "color",
                                        H: ["{[*]}"],
                                        C: "Color for the prolines in the genome browser<br>"
                                    },
                                    groupingFactors: {
                                        D: "[]",
                                        M: "Data",
                                        T: "array",
                                        C: "An array that holds the group names used for grouping the data. It must be a category in the 'data.x' object<br>",
                                        H: ['{"data":"Random:4:8:2:2","setMinX":0,"groupingFactors":["Factor1"]}', '{"data":"Random:4:8:2:2","setMinX":0,"groupingFactors":["Factor1","Factor2"]}']
                                    },
                                    axisTitleFont: {
                                        C: "Font for the axis titles in one, two and three dimensional plots<br>",
                                        D: "12px Verdana",
                                        Z: "true",
                                        T: "font",
                                        M: "Fonts"
                                    },
                                    xAxisValuesRaw: {
                                        D: "[]",
                                        Z: "true",
                                        M: "X-Axis",
                                        T: "array",
                                        C: "Raw values for the ticks in the X axis<br>"
                                    },
                                    shapeByData: {
                                        H: ['{"data":"RandomMultidimensional:5:10:1:1","shapeByData":"data4","shapeBy":"DataShape"}'],
                                        D: "false",
                                        T: "string",
                                        C: "String that identify the object containing a two dimensional array with values used to shape data points when drawing a multidimensional Heatmap. It must be located within the data.y object (for example: data.y.data2)<br>",
                                        M: "Data Point Attributes",
                                        U: ["Heatmap"],
                                        S: ["shapeBy"]
                                    },
                                    fixedAspectRatio: {
                                        C: "Keep fixed aspect ratio expressed as y / x. A zero value is used to ignore otherwise the x and y axes are set accordingly.<br>",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        D: "0",
                                        M: "Aspect Ratio, Space and width",
                                        T: "float"
                                    },
                                    swimStart: {
                                        X: "getVariablesAsArray",
                                        C: "Variable to use in Swimmer Plot. Defaults to the second variable in the data set. See https://blogs.sas.com/content/graphicallyspeaking/2014/06/22/swimmer-plot/<br>",
                                        M: "Bar Graphs",
                                        O: ["false"],
                                        H: ['{[*],"data":"Swimmer","graphType":"Bar","barType":"swimmer"}'],
                                        T: "option",
                                        D: "false"
                                    },
                                    debug: {
                                        C: "Flag to turn on alerts.<br>",
                                        D: "false",
                                        M: "Debug",
                                        T: "boolean"
                                    },
                                    effect: {
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "none",
                                        O: ["none", "magic", "puffIn", "openDownLeft", "openDownLeftOut", "perspectiveDown", "rotateDown", "twisterInDown", "puffOut", "openDownRight", "openDownRightOut", "perspectiveUp", "rotateUp", "twisterInUp", "vanishIn", "openUpLeft", "openUpLeftOut", "perspectiveLeft", "rotateLeft", "swap", "vanishOut", "openUpRight", "openUpRightOut", "perspectiveRight", "rotateRight", "openDownLeftReturn", "perspectiveDownReturn", "openDownRightReturn", "perspectiveUpReturn", "openUpLeftReturn", "perspectiveLeftReturn", "openUpRightReturn", "perspectiveRightReturn", "slideDown", "swashOut", "tinRightOut", "bombRightOut", "boingInUp", "spaceOutUp", "slideUp", "swashIn", "tinLeftOut", "bombLeftOut", "boingOutDown", "spaceOutRight", "slideLeft", "foolishIn", "tinUpOut", "spaceOutDown", "slideRight", "holeOut", "tinDownOut", "spaceOutLeft", "slideDownReturn", "tinRightIn", "spaceInUp", "slideUpReturn", "tinLeftIn", "spaceInRight", "slideLeftReturn", "tinUpIn", "spaceInDown", "slideRightReturn", "tinDownIn", "spaceInLeft"],
                                        C: "Effect used to show widgets Magic - Ver 1.3.0 - https://minimamente.com<br>",
                                        M: "Effect"
                                    },
                                    yAxisRugPosition: {
                                        C: "Position for the rug in the Y axis<br>",
                                        M: "Y-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D","yAxisRugShow":true}'],
                                        T: "option",
                                        D: "left",
                                        O: ["left", "right", "both"]
                                    },
                                    hideUnhideSmps: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        X: "getSamplesAsArray",
                                        C: "Hide or unhide samples. It works like a switch<br>",
                                        T: "array",
                                        M: "Functions"
                                    },
                                    boxplotConnect: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Boxplot Graphs",
                                        C: "Flag to show data in boxplots connected<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}']
                                    },
                                    sequenceUColor: {
                                        C: "Color for the uracils in the genome browser<br>",
                                        H: ["{[*]}"],
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(255,0,0)"
                                    },
                                    motionCurrentColor: {
                                        H: ['{"data":"Random:30:3:2:2","graphType":"Scatter2D","motionBy":"Annt1"}'],
                                        C: "Color for the axis title in motion charts<br>",
                                        D: "rgba(0,0,0,0.3)",
                                        T: "color",
                                        M: "Motion Charts"
                                    },
                                    smpTitleScaleFontFactor: {
                                        M: "Samples",
                                        T: "float",
                                        D: "1",
                                        C: "Scaling factor used to increse or decrease sample title font size in the canvas<br>",
                                        H: ['{[*],"smpTitle":"Sample Title"}']
                                    },
                                    sequenceHColor: {
                                        C: "Color for the degenerate A/C/T and histidines in the genome browser<br>",
                                        H: ["{[*]}"],
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(255,0,0)"
                                    },
                                    circularType: {
                                        M: "Circular Graphs",
                                        C: "Property to set the subtype of circular graph. If set to sunburst or bubble then smpOverlays can be used to build a hierarchy for the graph.<br>",
                                        O: ["normal", "radar", "sunburst", "chord", "bubble"],
                                        D: "normal",
                                        T: "option",
                                        H: ['{[*],"graphType":"Circular"}']
                                    },
                                    filterFeatureBy: {
                                        U: ["Genome"],
                                        X: "getFeatureData",
                                        C: "Filter features by their properties used in genome browser. Used in the CanvasXpress UIs.<br>",
                                        M: "Data Filters",
                                        D: "{'cases':[],'comp':[],'op':[],'type':[],'value':[]}",
                                        T: "filter"
                                    },
                                    densityKernel: {
                                        M: "Density Plots",
                                        C: "Histogram density kernels<br>",
                                        S: ["createHistogram", "showHistogramDensity"],
                                        D: "gaussian",
                                        T: "option",
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50,"showHistogramDensity":true}'],
                                        O: ["epanechnikov", "uniform", "triangular", "quartic", "triweight", "gaussian", "cosine"]
                                    },
                                    shadowBlur: {
                                        S: ["showShadow"],
                                        C: "Amount in blur for the shadow.<br>",
                                        M: "Shadows",
                                        H: ['{[*],"showShadow":true}'],
                                        D: "2",
                                        T: "integer"
                                    },
                                    alignConfiguratorExamples: {
                                        H: ["{[*]}"],
                                        C: "Flag to align examples to the configurator<br>",
                                        D: "false",
                                        M: "Events",
                                        T: "boolean"
                                    },
                                    skipRender: {
                                        D: "false",
                                        Z: "true",
                                        T: "boolean",
                                        M: "General",
                                        C: "Flag to skip initial rendering<br>"
                                    },
                                    yAxisFloorValue: {
                                        T: "float",
                                        M: "Y-Axis",
                                        D: "null",
                                        C: "Value to floor the data in the Y axis.<br>",
                                        H: ['{[null,50],"data":"Random:10:2","graphType":"Scatter2D"}']
                                    },
                                    smpLabelInterval: {
                                        C: "Interval for the sample labels in one dimensional and circular plots<br>",
                                        H: ["{[*]}"],
                                        D: "1",
                                        M: "Samples",
                                        T: "integer"
                                    },
                                    showScatterDensity: {
                                        D: "false",
                                        M: "Density Plots",
                                        T: "boolean",
                                        H: ['{[*],"data":"Random:20000:2","dataPointSize":2,"scatterOutlineThreshold":1}'],
                                        C: "Flag to show the density kernel in histograms<br>"
                                    },
                                    genomeTicks: {
                                        H: ["{[*]}"],
                                        C: "Number of ticks in the genome browser<br>",
                                        M: "Genome Browser",
                                        T: "integer",
                                        D: "50"
                                    },
                                    yAxisMinorTicks: {
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "true",
                                        C: "A flag to show minor tick lines in the Y axis<br>",
                                        M: "Y-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"]
                                    },
                                    legendScaleFontFactor: {
                                        T: "float",
                                        M: "Legends",
                                        D: "1",
                                        C: "Scaling factor used to increase or decrease legend font size in the canvas.<br>",
                                        H: ["{[*]}"]
                                    },
                                    showDataTable: {
                                        C: "Flag to indicate to show the data table<br>",
                                        M: "Data Table",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    selectedDataPoints: {
                                        T: "array",
                                        M: "Data Selection: Parameters used to select data in all visualizations",
                                        D: "[]",
                                        C: "Variable / Sample names of data points (in the data object) to initially select.<br>",
                                        H: ['{"data":"Random:20:20","selectedDataPoints":["V1", "V2"]}']
                                    },
                                    rAxisMinorTicks: {
                                        M: "R-Axis",
                                        T: "boolean",
                                        D: "true",
                                        H: ['{[*],"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        C: "A flag to show minor tick lines in the R axis<br>"
                                    },
                                    zoomGlobal: {
                                        C: "Cumulative zoom factor for the networks.<br>",
                                        D: "1",
                                        Z: "true",
                                        M: "Zooming, Panning and Resizing",
                                        T: "float"
                                    },
                                    dataexplorerEffectIn: {
                                        T: "string",
                                        M: "Effect",
                                        D: "holeOut",
                                        H: ["{[*]}"],
                                        C: "dataexplorerEffectIn<br>"
                                    },
                                    featureFillColor: {
                                        D: "rgb(255,255,255)",
                                        M: "Genome Browser",
                                        T: "color",
                                        C: "Default color for the fill of the feature in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    arcSegmentsSeparation: {
                                        D: "8",
                                        T: "integer",
                                        M: "Circular Graphs",
                                        C: "Number of degrees to separate the arc segments in the circular plots. The arc segments can be set with the segregateSampleBy property.<br>",
                                        H: ['{[8,20],"data":"RandomCircular:4:8:2:3","graphType":"Circular","segregateSamplesBy":["Factor2"]}']
                                    },
                                    imageMaxTries: {
                                        M: "Images",
                                        C: "Maximum times to try to load images. Used to calculate the timeout which will be imageTimeOut / imageTries which will be 100ms by default.<br>",
                                        S: ["imageTimeOut", "imageTries"],
                                        T: "integer",
                                        D: "10",
                                        H: ["{[*]}"]
                                    },
                                    zAxisCeilValue: {
                                        C: "Value to ceil the data in the Z axis.<br>",
                                        H: ['{[null,50],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        T: "float",
                                        M: "Z-Axis",
                                        D: "null"
                                    },
                                    varTitleFontColor: {
                                        M: "Variables",
                                        C: "Font color for the variable titles in one dimensional plots<br>",
                                        U: ["Heatmap"],
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        H: ['{[*],"varTitle":"Variable Title"}']
                                    },
                                    blockContrast: {
                                        H: ['{[*],"graphType":"Bar"}'],
                                        T: "boolean",
                                        D: "false",
                                        S: ["evenColor", "oddColor"],
                                        C: "A flag to creates a shade between the samples so there are two backgrounds, one for the odd samples and one for the even samples.<br>",
                                        M: "Plot area"
                                    },
                                    createVersion: {
                                        C: "CanvasXpress Version used to create plot. This is parsed from the PNG or JSON data loaded<br>",
                                        D: "false",
                                        Z: "true",
                                        M: "General",
                                        T: "float"
                                    },
                                    nodeHighlightColor: {
                                        D: "rgb(255,0,0)",
                                        M: "Network Graphs",
                                        T: "color",
                                        C: "The color for the highlighted nodes.<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large","highlightNode":["ND1","ND2"]}']
                                    },
                                    decorationsProperties: {
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","decorationsPosition":"right","showDecorations":true,"decorations":["D1","D2","D3"],"decorationsProperties":{"exp1":{"color":"rgb(51,125,255)","shape":"square"},"exp2":{"color":"rgb(125,255,51)","shape":"square"},"exp2":{"color":"rgb(255,125,51)","shape":"square"}}}'],
                                        T: "object",
                                        D: "{}",
                                        C: "Object to assign properties like color for the network decorations<br>",
                                        M: "Decorations",
                                        U: ["Network"]
                                    },
                                    summaryType: {
                                        O: ["false", "iqr", "median", "mean", "cor", "min", "max", "count", "sum"],
                                        T: "option",
                                        D: "false",
                                        H: ['{[*],"data":"Random:4:8:2:2","setMinX":0,"groupingFactors":["Factor1"]}'],
                                        M: "Data",
                                        C: "Summary type for the data when grouping<br>"
                                    },
                                    titleFont: {
                                        C: "Font for the title<br>",
                                        D: "16px Verdana",
                                        Z: "true",
                                        M: "Fonts",
                                        T: "font"
                                    },
                                    loadRDatasets: {
                                        M: "R",
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to load R datasets from Github<br>"
                                    },
                                    heatmapCellBox: {
                                        D: "true",
                                        M: "Heatmap Graphs",
                                        T: "boolean",
                                        H: ['{[*],"graphType":"Heatmap"}'],
                                        C: "Flag to print a box around the heatmap cells<br>"
                                    },
                                    zAxisCurrent: {
                                        C: "Index (zero-based) of the sample that is currently displayed in the Z axis when there are multiple series in an ScatterBubble2D plot. Use ctrl + arrow keys to cycle through data series.<br>",
                                        M: "Z-Axis",
                                        U: ["ScatterBubble2D"],
                                        H: ['{[0,1],"data":"Random:10:6","xAxis":["S1","S2"],"yAxis":["S3","S4"],"zAxis":["S5","S6"],"graphType":"ScatterBubble2D"}'],
                                        D: "0",
                                        T: "integer"
                                    },
                                    selectionMetadata: {
                                        M: "Data Selection: Parameters used to select data in all visualizations",
                                        C: "Matadata (or factor) to use to display selected data points instead of the variable name. This metadata has to be in the 'data.z' object. This property is only valid when the selectionMode is 'name' and the visualization is a Scatter plot.<br> @see{selectionMode}",
                                        X: "getZData",
                                        D: "false",
                                        T: "option",
                                        H: ['{"selectionMode":"name","selectionMetadata":false}', '{"selectionMode":"name","selectionMetadata":"Annt1"}'],
                                        O: ["false"]
                                    },
                                    featureSignalToNoiseHeight: {
                                        H: ["{[*]}"],
                                        C: "Default size in pixels of the quality height<br>",
                                        D: "14",
                                        T: "integer",
                                        M: "Genome Browser"
                                    },
                                    transparencyHidden: {
                                        D: "0.1",
                                        M: "General",
                                        T: "float",
                                        H: ["{[*]}"],
                                        C: "Percentage of transparency applied to elements that are hidden<br>"
                                    },
                                    ringGraphWeight: {
                                        S: ["ringOrder"],
                                        C: "Array containing the proportion of the dimensions for each data ring in the circular plot. It must be a value between 0.1 and 1. If not specified then all ring will be weighted the same.<br>",
                                        M: "Circular Graphs",
                                        H: ['{"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"ringGraphWeight":[0.4,0.2,0.2,0.2]}'],
                                        T: "array",
                                        D: "[]"
                                    },
                                    zoomScale: {
                                        H: ["{[*]}"],
                                        C: "Flag to scale nodes and edges in networks with zoom and data points in 3D scatter plots<br>",
                                        D: "true",
                                        T: "boolean",
                                        M: "Zooming, Panning and Resizing"
                                    },
                                    histogramStat: {
                                        T: "option",
                                        D: "density",
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50,"showHistogramDensity":true}'],
                                        O: ["density", "count"],
                                        M: "Histograms",
                                        C: "Histogram density type<br>",
                                        S: ["createHistogram", "showHistogramDensity"]
                                    },
                                    binned: {
                                        S: ["showBoxplotOriginalData", "boxplotDataPointTransparency"],
                                        U: ["Dotplot", "DotLine", "Boxplot"],
                                        M: "Plot area",
                                        C: "Flag to bin the data points in dotplots and boxplots.<br>",
                                        D: "false",
                                        T: "boolean",
                                        H: ['{[*],"graphType":"Dotplot","groupingFactors":["Factor1"]}', '{[*],"graphType":"Boxplot","showBoxplotOriginalData":true,"groupingFactors":["Factor1"]}']
                                    },
                                    qqPoints: {
                                        D: "100",
                                        M: "QQ Plots",
                                        T: "integer",
                                        H: ['{[*],"data":"Random:200:2","graphType":"Scatter2D"}'],
                                        C: "Number of point to use in the QQ plot<br>"
                                    },
                                    layoutCurrent: {
                                        C: "Integer to identify the current graph being displayed in the canvas.<br>",
                                        M: "Combination Plots",
                                        T: "integer",
                                        D: "0",
                                        Z: "true"
                                    },
                                    decorationsHeight: {
                                        M: "Decorations",
                                        C: "Length in pixels of the height for the decorations in the networks<br>",
                                        U: ["Network"],
                                        D: "40",
                                        T: "integer",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","decorationsPosition":"left","showDecorations":true,"decorations":["D1","D2","D3"]}']
                                    },
                                    canvasBoxColor: {
                                        S: ["canvasBox"],
                                        C: "Color for the box around the canvas<br>",
                                        M: "General",
                                        H: ['{[*],"canvasBox":true}'],
                                        D: "rgb(204,204,204)",
                                        T: "color"
                                    },
                                    layoutBoxShow: {
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        C: "Flag to draw the layout boxes.<br>",
                                        D: "true",
                                        T: "boolean",
                                        M: "Combination Plots"
                                    },
                                    correlationAnchorLegendAlignWidth: {
                                        D: "40",
                                        M: "Correlation Graphs",
                                        T: "integer",
                                        C: "Length in pixels of the height of the correlation anchor legend<br>",
                                        H: ['{[*],"data":"Random:4:8","correlationAnchorLegend":true}']
                                    },
                                    mapConfigFeatures: {
                                        C: "Map config for features use to translate and scale<br>",
                                        M: "Maps",
                                        T: "object",
                                        D: "false"
                                    },
                                    gradientType: {
                                        C: "Specifies the gradient pattern.<br>",
                                        M: "Gradients",
                                        S: ["gradient"],
                                        H: ['{[*],"data":"Random:1:3:0:0","gradient":true}'],
                                        T: "option",
                                        D: "radial",
                                        O: ["linear", "radial"]
                                    },
                                    perspectiveFactor: {
                                        D: "2.2",
                                        T: "float",
                                        M: "3D Attributes",
                                        H: ['{[*],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        C: "Factor to use to make the 3D perspective. The higher the number the more perspective. Perspective of zero is no perspective at all.<br>"
                                    },
                                    legendPositionAuto: {
                                        T: "boolean",
                                        D: "false",
                                        H: ["{[*]}"],
                                        S: ["legendPosition", "legendInside"],
                                        M: "Legends",
                                        C: "Automatically select best position for the legend outside the graphs; either left or bottom.<br>"
                                    },
                                    axisMinMaxTickThickness: {
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        T: "float",
                                        D: "1",
                                        C: "Thickness of the min and max axis ticks in two dimensional plots.<br>",
                                        M: "Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"]
                                    },
                                    showRegressionFullRange: {
                                        M: "Error Bars and Confidence Intervals",
                                        C: "Flag to show or not the full range in regression plots<br>",
                                        S: ["decorations"],
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addRegressionLine"]}']
                                    },
                                    boxplotOutliersRatio: {
                                        H: ['{[*],"data":"Random:2:12:0:1:1:100:0:false:normal:50:10","groupingFactors":["Factor1"]}'],
                                        C: "Ratio for the size of the outliers with respect to boxplot<br>",
                                        D: "8",
                                        T: "integer",
                                        M: "Boxplot Graphs"
                                    },
                                    sizeByShowLegend: {
                                        T: "boolean",
                                        M: "Data Point Attributes",
                                        D: "true",
                                        H: ['{[*],"graphType":"Dotplot","sizeBy":"Factor1"}'],
                                        C: "Flag to show the sizeBy legend<br>"
                                    },
                                    showConfidenceIntervals: {
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addRegressionLine"]}'],
                                        D: "true",
                                        T: "boolean",
                                        S: ["decorations"],
                                        C: "Flag to show or not the confidence intervals in the regression and Kaplan-Meier plots <br>",
                                        M: "Error Bars and Confidence Intervals"
                                    },
                                    correlationAnchorLegend: {
                                        C: "Flag to show a region above the correlation plot that anchror a sample/variable to a position<br>",
                                        H: ['{[*],"data":"Random:4:8"}'],
                                        D: "false",
                                        T: "boolean",
                                        M: "Correlation Graphs"
                                    },
                                    nodesProperties: {
                                        D: "[]",
                                        T: "array",
                                        M: "Data Table/Filter",
                                        C: "Two dimensional array with object properties not at the root level for the nodes in the Network graph to include in the Data table and the data filter<br>"
                                    },
                                    zAxisExact: {
                                        C: "Flag to force exact values for the data in the Z axis<br>",
                                        H: ['{[*],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        M: "Z-Axis",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    loessIteration: {
                                        D: "2",
                                        Z: "true",
                                        M: "Loess",
                                        T: "integer",
                                        C: "Loess iterations<br>"
                                    },
                                    heatmapIndicatorWidth: {
                                        T: "integer",
                                        M: "Heatmap Graphs",
                                        D: "250",
                                        C: "Length in pixels for the heatmap indicator line width used for increase the size of the indicator<br>",
                                        H: ['{[*],"graphType":"Heatmap"}']
                                    },
                                    legendFontStyle: {
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "",
                                        O: ["", "bold", "italic", "bold italic"],
                                        C: "Font style for the legend.<br>",
                                        M: "Legends"
                                    },
                                    isR: {
                                        C: "Flag to indicate is running from the R library. For developers only.<br>",
                                        H: ["{[*]}"],
                                        M: "General",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    highlightSmp: {
                                        X: "getSamplesAsArray",
                                        M: "Samples",
                                        C: "Name of samples in the 'data.y' object to highlight.<br>",
                                        D: "[]",
                                        T: "array",
                                        H: ['{"highlightSmp":["S1","S3"]}']
                                    },
                                    xAxisLeftMajorTick: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        C: "A flag to show the left Major tick line in the X axis in Scatter2D plots<br>",
                                        M: "X-Axis",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        D: "true",
                                        T: "boolean"
                                    },
                                    sequenceFontStyle: {
                                        M: "Genome Browser",
                                        C: "Font style for the sequences.<br>",
                                        O: ["", "bold", "italic", "bold italic"],
                                        D: "",
                                        T: "option",
                                        H: ["{[*]}"]
                                    },
                                    overlayLevelOrientation: {
                                        C: "Orientation to show the segregation levels<br>",
                                        M: "Circular Graphs",
                                        H: ['{[*],"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        D: "circular",
                                        T: "option",
                                        O: ["perpendicular", "circular"]
                                    },
                                    rAxisTickFormat: {
                                        H: ['{"data":"RandomCircular2:4:8:2:3","rAxisTickFormat":"%.4f cxs","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}', '{"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        C: "Format for the tick values in the R axis. It could be a string with the sprintf format or an array where the first parameter is the sprintf format and the second parameter is a modification applied to the value before is passed to the sprintf function.<br>",
                                        D: "false",
                                        T: "string",
                                        M: "R-Axis"
                                    },
                                    smpTitleLabelPosition: {
                                        C: "Position for sample labels<br>",
                                        M: "Heatmap Graphs",
                                        H: ['{[*],"graphType":"Heatmap","smpOverlays":["Factor1"]}'],
                                        D: "left",
                                        T: "option",
                                        O: ["left", "right"]
                                    },
                                    xAxis2TickFormat: {
                                        H: ['{"data":"Random:4:8","graphType":"BarLine","xAxis2":["V1","V2"],"xAxis":["V3","V4"],"xAxis2TickFormat":"%.2f cxs","graphOrientation":"vertical"}'],
                                        C: "Format for the tick values in the second X axis. It could be a string with the sprintf format or an array where the first parameter is the sprintf format and the second parameter is a modification applied to the value before is passed to the sprintf function.<br>",
                                        M: "X-Axis2",
                                        T: "string",
                                        D: "false"
                                    },
                                    toolbarEffectIn: {
                                        C: "toolbarEffectIn<br>",
                                        H: ["{[*]}"],
                                        M: "Effect",
                                        T: "string",
                                        D: "holeIn"
                                    },
                                    tagCloudTextRotateRatio: {
                                        C: "Ratio for rotation of text in cloud visualizations<br>",
                                        H: ["{[*]}"],
                                        D: "0.1",
                                        M: "Tag Cloud",
                                        T: "float"
                                    },
                                    arcSegmentsRadius: {
                                        S: ["arcSegmentsRadius"],
                                        C: "Array containing the proportion of the radius for each arc segment in the circular plot. If not specified then all radius will be the same. The plot will be scaled based of the largest value in the array<br>",
                                        M: "Circular Graphs",
                                        H: ['{"data":"RandomCircular:4:8:2:3","graphType":"Circular","segregateSamplesBy":["Factor2"],"arcSegmentsRadius":[0.8,0.9,1]}'],
                                        D: "[]",
                                        T: "array"
                                    },
                                    boxplotHingeFunction: {
                                        C: "Function to calculate the boxplor hinges. See https://chemicalstatistician.wordpress.com/2013/08/12/exploratory-data-analysis-the-5-number-summary-two-different-methods-in-r-2/<br>",
                                        M: "Boxplot Graphs",
                                        O: ["summary", "fivenum"],
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}'],
                                        T: "option",
                                        D: "summary"
                                    },
                                    yAxisTickFormat: {
                                        D: "false",
                                        M: "Y-Axis",
                                        T: "string",
                                        H: ['{"data":"Random:10:2","graphType":"Scatter2D","yAxisTickFormat":"%.2f cxs"}'],
                                        C: "Format for the tick values in the Y axis. It could be a string with the sprintf format or an array where the first parameter is the sprintf format and the second parameter is a modification applied to the value before is passed to the sprintf function.<br>"
                                    },
                                    toolbarEffectOut: {
                                        D: "holeOut",
                                        M: "Effect",
                                        T: "string",
                                        H: ["{[*]}"],
                                        C: "toolbarEffectOut<br>"
                                    },
                                    barnesHutNodesCacheCurrent: {
                                        C: "Barnes Hut idex for node cache for performance and avoid Javascript GC<br>",
                                        T: "integer",
                                        M: "Network Algorithm Parameters",
                                        Z: "true",
                                        D: "0"
                                    },
                                    ringSeparation: {
                                        H: ['{[*],"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"ringGraphType":["bar","heatmap","dot"]}'],
                                        C: "Number of pixels to separate the rings in the circular plots.<br>",
                                        T: "integer",
                                        M: "Circular Graphs",
                                        D: "5"
                                    },
                                    xAxisAbsMin: {
                                        C: "Minimum non-filtered value for the data plotted in the X axis<br>",
                                        T: "float",
                                        M: "X-Axis",
                                        Z: "true",
                                        D: "null"
                                    },
                                    treemapBy: {
                                        X: "getXData",
                                        M: "Data Point Attributes",
                                        C: "Array of sample annotations to treemap the variables. The array may also include 'sample' to use as last level.<br>",
                                        D: "[]",
                                        T: "array",
                                        H: ['{"data":"Random:4:8:2:2","graphType":"Stacked","treemapBy":["Factor1","Factor2"]}', '{"data":"Random:4:8:2:2","graphType":"Stacked","treemapBy":["Factor2"],"groupingFactors":["Factor1"]}']
                                    },
                                    rAxis: {
                                        M: "Circular Graphs",
                                        T: "string",
                                        D: "false",
                                        C: "Radial axis for circular plots. It must be the name of a variable. Only applicable to 2 Dimensional circular plots.<br>",
                                        H: ['{"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"rAxis":false}', '{"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}']
                                    },
                                    guidesColor: {
                                        D: "rgb(204,204,204)",
                                        M: "Plot area",
                                        T: "color",
                                        H: ['{[*],"graphType":"Bar","guides":true}'],
                                        C: "The color for the thin line that appears in the middle of the variables and / or samples in one dimensional graphs and multidimensional heatmaps just for aesthetics.<br>"
                                    },
                                    asSampleFactors: {
                                        C: "Array containing variable names. Numeric variable data (in rows) to be treated as a sample factor (move from 'y' to 'x' object). This parameter accomplishes the same as the function switchVarToAnnotation at load time. It can be used in conjunction with the parameter stringSampleFactors to be treated as a string. TO DO: write example.<br>",
                                        H: ['{"data":"Random:4:8:2:2","asSampleFactors":["Var1"]}'],
                                        D: "[]",
                                        M: "Data",
                                        T: "array"
                                    },
                                    disableCode: {
                                        D: "false",
                                        M: "Events",
                                        T: "boolean",
                                        H: ["{[*]}"],
                                        C: "Flag to disable showing the code<br>"
                                    },
                                    subtracksMaxDefault: {
                                        C: "Maximum number of subtracks to show in a track<br>",
                                        D: "8",
                                        M: "Genome Browser",
                                        T: "integer"
                                    },
                                    barPathTransparency: {
                                        C: "Transparency for the bar graph path<br>",
                                        H: ['{[*],"data":"Random:1:8","graphType":"Bar"}'],
                                        D: "0.1",
                                        M: "Bar Graphs",
                                        T: "boolean"
                                    },
                                    yAxis: {
                                        X: "getSamplesAsArray",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        C: "Name of the samples groups or variables to be displayed in the Y axis<br>",
                                        M: "Y-Axis",
                                        H: ['{"data":"Random:10:2","xAxis":["S1","S2","S3"],"yAxis":["S4","S5","S6"],"graphType":"Scatter2D"}'],
                                        T: "array",
                                        D: "[]"
                                    },
                                    circularAnchorsAlign: {
                                        M: "Circular Graphs",
                                        C: "Position to align the anchors in circular plot<br>",
                                        O: ["inside", "outside"],
                                        T: "option",
                                        D: "inside",
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularAnchorsAlign":"inside"}', '{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularLabelsAlign":"inside","circularAnchorsAlign":"outside","ringsOrder":["chromosomes","Annt1","Lev:1","anchors","labels","ideogram"],"circularCenterProportion":0.6}']
                                    },
                                    infoTimeOut: {
                                        H: ["{[*]}"],
                                        C: "Time in milliseconds to wait between updates for the mouse over info to show up<br>",
                                        T: "integer",
                                        M: "Events",
                                        D: "3000"
                                    },
                                    sizeBy: {
                                        C: "Name of a variable annotation or a sample name or the string 'variable' to size the variables. When sizeByData is specified sizeBy is used for the title in the legend.<br>",
                                        M: "Data Point Attributes",
                                        X: "getXZData",
                                        S: ["sizeByData"],
                                        H: ['{"data":"Random:8:4:1:1","graphType":"Scatter3D","sizeBy":"Annt1"}', '{"data":"Random:8:4:1:1","graphType":"Scatter3D","sizeBy":"Sample4"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","sizeBy":"Factor1"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","sizeBy":"Annt1"}'],
                                        D: "false",
                                        T: "option",
                                        O: ["false", "variable"]
                                    },
                                    linkage: {
                                        O: ["single", "complete", "average"],
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap","samplesClustered":true,"variablesClustered":true}'],
                                        D: "complete",
                                        T: "option",
                                        S: ["distance", "imputeMethod", "clusterSamples", "clusterVariables"],
                                        C: "Linkage type to use when clustering data.<br>",
                                        M: "Clustering"
                                    },
                                    axisTickFont: {
                                        D: "12px Verdana",
                                        Z: "true",
                                        T: "font",
                                        M: "Fonts",
                                        C: "Font for the axis ticks in one, two and three dimensional plots<br>"
                                    },
                                    yAxisTransform: {
                                        O: ["false", "log2", "log10", "exp2", "exp10", "percentile"],
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "option",
                                        D: "false",
                                        C: "Transformation for the values in the Y axis.<br>",
                                        M: "Y-Axis"
                                    },
                                    sequenceRColor: {
                                        D: "rgb(255,0,0)",
                                        M: "Genome Browser",
                                        T: "color",
                                        H: ["{[*]}"],
                                        C: "Color for the degenerate A/G and arginines in the genome browser<br>"
                                    },
                                    areaType: {
                                        C: "Flag to produce normal, stacked, center or percent area graphs<br>",
                                        M: "Area Graphs",
                                        O: ["normal", "stacked", "percent"],
                                        H: ['{[*],"data":"Random:4:8:0:0","transparency":0.5,"lineType":"spline"}'],
                                        D: "normal",
                                        T: "option"
                                    },
                                    colorVarDendrogramBy: {
                                        D: "false",
                                        T: "option",
                                        H: ['{"data":"Random:4:8:1:1","colorVarDendrogramBy":"Annt1","graphType":"Heatmap","variablesClustered":true}'],
                                        O: ["false"],
                                        M: "Dendrograms",
                                        C: "Name of a variable annotation to color the variable dendrogram.<br>",
                                        X: "getZData"
                                    },
                                    mapConfig: {
                                        T: "object",
                                        M: "Maps",
                                        D: "false",
                                        C: "Map config<br>"
                                    },
                                    jitterColumns: {
                                        H: ['{[3,7],"graphType":"Dotplot","jitter":true,"groupingFactors":["Factor1"]}', '{[3,7],"graphType":"Boxplot","jitter":true,"showBoxplotOriginalData":true,"groupingFactors":["Factor1"]}'],
                                        C: "A number to indicate the ammount of discrete columns in the jitter function. The minimum number is three. It will be addjusted to be an odd number for aesthetic reasons.<br>",
                                        M: "Plot area",
                                        T: "integer",
                                        D: "7"
                                    },
                                    smpLabelFontSize: {
                                        S: ["autoScaleFont", "smpLabelScaleFontFactor"],
                                        C: "Size for the sample labels in one dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the sample label scaling factor<br>",
                                        M: "Samples",
                                        H: ['{[*],"autoScaleFont":false}'],
                                        D: "12",
                                        T: "integer"
                                    },
                                    layoutTopology: {
                                        C: "Topology of the canvas. Number of columns and rows separated by X. For example: 2X1, 1X3, etc.<br>",
                                        H: ['{["4X6","6X4"],"data":"Random:16:16:4:6","segregateSamplesBy":["Factor6"],"segregateVariablesBy":["Annt4"]}'],
                                        D: "false",
                                        T: "string",
                                        M: "Combination Plots"
                                    },
                                    xAxisValues: {
                                        Z: "true",
                                        D: "[]",
                                        T: "array",
                                        M: "X-Axis",
                                        C: "Values for the ticks in the X axis<br>"
                                    },
                                    filterMode: {
                                        T: "option",
                                        D: "remove",
                                        O: ["remove", "hide", "color"],
                                        M: "Data Filters",
                                        C: "Mode for the filter. Can be 'remove' to remove the data from the plot, 'hide' to hide the data similarily to legend filters (may be useful to adjustor transparencyHidden) or 'color' to color the data point with a set color (may be useful to adjust missingDataColor).<br>",
                                        S: ["transparencyHidden", "missingDataColor"]
                                    },
                                    circularConnectionsTransparency: {
                                        H: ['{[0.2,0.5],"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"connections":[["red","S1","S4"],["blue","S2","S5"],["green","S3","S6"]]}'],
                                        C: "Percentage of transparency applied to the connections in the circular graphs<br>",
                                        M: "Circular Graphs",
                                        T: "float",
                                        D: "0.5"
                                    },
                                    tension: {
                                        H: ['{[*],"data":"Random:4:6","graphType":"Line","lineType":"spline"}'],
                                        C: "Curvature for the splines and hulls<br>",
                                        M: "Line Graphs",
                                        T: "float",
                                        D: "0.3"
                                    },
                                    legendBox: {
                                        M: "Legends",
                                        C: "Flag to create a box around the legend<br>",
                                        S: ["legendBoxColor", "legendBackgroundColor"],
                                        T: "boolean",
                                        D: "false",
                                        H: ["{[*]}"]
                                    },
                                    boxplotMeanColor: {
                                        M: "Boxplot Graphs",
                                        T: "color",
                                        D: "rgb(255,215,0)",
                                        C: "Color for the mean of data in boxplots<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","boxplotMean":true,"groupingFactors":["Factor1"]}']
                                    },
                                    coordinateLineColor: {
                                        C: "Flag to used same color in BarLine plots. If set to true the color of the bars and the lines will be coordinated<br>",
                                        H: ['{[*],"graphType":"BarLine","xAxis":["V1","V2"],"xAxis2":["V3","V4"]}'],
                                        D: "false",
                                        T: "boolean",
                                        M: "Line Graphs"
                                    },
                                    axisTitleFontSize: {
                                        H: ['{[*],"autoScaleFont":false,"xAxisTitle":"Axis Title"}'],
                                        D: "12",
                                        T: "integer",
                                        C: "Font size for the axis titles in one, two and three dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the axis title scaling factor<br>",
                                        M: "Axis",
                                        S: ["autoScaleFont", "axisTitleScaleFontFactor"]
                                    },
                                    capType: {
                                        C: "Default type of cap for lines.<br>",
                                        M: "Lines",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}'],
                                        D: "butt",
                                        T: "option",
                                        O: ["butt", "round", "square"]
                                    },
                                    randomDataMin: {
                                        C: "Minimun value when creating random data<br>",
                                        T: "integer",
                                        M: "Random",
                                        D: "1"
                                    },
                                    correlationLabelInterval: {
                                        C: "Interval for the sample or variable labels in the correlation plot<br>",
                                        H: ['{[*],"data":"Random:4:8"}'],
                                        D: "1",
                                        T: "integer",
                                        M: "Correlation Graphs"
                                    },
                                    filterDataBy: {
                                        C: "Filter data by their value in the 'data' object used in oncoprints. Used in the CanvasXpress UIs.<br>",
                                        D: "{'cases':[],'comp':[],'op':[],'type':[],'value':[]}",
                                        T: "filter",
                                        M: "Data Filters",
                                        U: ["Heatmap"]
                                    },
                                    heatmapIndicatorHistogram: {
                                        C: "Flag to show histogram in the heatmap indicator<br>",
                                        H: ["{[*]}"],
                                        D: "false",
                                        M: "Heatmap Graphs",
                                        T: "boolean"
                                    },
                                    qqSamples: {
                                        T: "integer",
                                        M: "QQ Plots",
                                        D: "10000",
                                        H: ['{[*],"data":"Random:200:2","graphType":"Scatter2D"}'],
                                        C: "Number of samples to use in building the QQ plot<br>"
                                    },
                                    xAxisFloorValue: {
                                        C: "Value to floor the data in the X axis.<br>",
                                        H: ['{[null,60],"graphType":"Dotplot"}', '{[null,60],"graphType":"Scatter2D"}'],
                                        D: "null",
                                        T: "float",
                                        M: "X-Axis"
                                    },
                                    zoomVariablesDisable: {
                                        S: ["zoomSamplesDisable"],
                                        C: "Flag to disable zooming of variables with mouse wheel in Heatmaps<br>",
                                        M: "Zooming, Panning and Resizing",
                                        H: ['{[*],"graphType":"Heatmap"}'],
                                        D: "false",
                                        T: "boolean"
                                    },
                                    useRawLines: {
                                        C: "Use raw lines rather than 'potentially' crisp lines. Use only with circular graphs and networks.<br>",
                                        M: "General",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    drawArea: {
                                        C: "Display event areas<br>",
                                        T: "void",
                                        M: "Functions"
                                    },
                                    scaleX: {
                                        Z: "true",
                                        D: "1",
                                        T: "float",
                                        M: "Combination Plots",
                                        C: "Scale factor for the X axis<br>"
                                    },
                                    xAxisMinorTicks: {
                                        D: "true",
                                        T: "boolean",
                                        M: "X-Axis",
                                        C: "A flag to show minor tick lines in the X axis<br>",
                                        H: ["{[*]}"]
                                    },
                                    boxplotMeanColorBorder: {
                                        D: "rgb(255,0,0)",
                                        T: "color",
                                        M: "Boxplot Graphs",
                                        H: ['{[*],"data":"Random:2:12:0:2","boxplotMean":true,"groupingFactors":["Factor1"]}'],
                                        C: "Color for the border of the mean of data in boxplots<br>"
                                    },
                                    ignoreEventlessOrder: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        C: "Flag to render all nodes at one time rather that rendering first the eventless nodes and then the non-eventless nodes<br>",
                                        D: "false",
                                        T: "boolean",
                                        M: "Network Graphs"
                                    },
                                    includeDOE: {
                                        M: "DOE",
                                        T: "array",
                                        D: "[]",
                                        C: "Array containing the factors to include when exploring the DOE. If left empty all the factors will be included<br>"
                                    },
                                    topoJSON: {
                                        C: "TopoJSON map string<br>",
                                        H: ['{[*],"graphType":"Map"}'],
                                        M: "Maps",
                                        T: "string",
                                        D: "false"
                                    },
                                    histogramBinWidth: {
                                        C: "Width in actual units for the histogram bin.<br>",
                                        H: ['{[10, 50],"data":"Random:200:1","functions":["createHistogram"]}'],
                                        M: "Histograms",
                                        T: "float",
                                        D: "false"
                                    },
                                    decorationsType: {
                                        U: ["Network"],
                                        M: "Decorations",
                                        C: "Type for the decorations in the networks. The types stacked and stackedpercent must be two dimensional. Heatmap could be one or two dimensional<br>",
                                        O: ["pie", "bar", "heatmap", "stacked", "stackedpercent"],
                                        T: "option",
                                        D: "bar",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","showDecorations":true,"decorationsType":"pie","decorations":["D1","D2","D3"]}', '{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","showDecorations":true,"decorationsType":"bar","decorations":["D1","D2","D3"]}', '{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","showDecorations":true,"decorationsType":"heatmap","decorations":["D4","D5"]}', '{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","showDecorations":true,"decorationsType":"stacked","decorations":["D4","D5"]}', '{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","showDecorations":true,"decorationsType":"stackedpercent","decorations":["D4","D5"]}']
                                    },
                                    roundedPolygonRadius: {
                                        C: "Radius for rounded polygons<br>",
                                        D: "5",
                                        M: "Shapes",
                                        T: "integer"
                                    },
                                    sizeByContinuous: {
                                        T: "boolean",
                                        M: "Data Point Attributes",
                                        D: "false",
                                        C: "Flag to show the size data continuously as opposed to by binning the sizes<br>",
                                        H: ['{[*],"data":"Random:8:4:3:3","graphType":"Scatter2D","sizeBy":"Factor3"}']
                                    },
                                    disableMenu: {
                                        C: "Flag to disable showing the menu on right clicks<br>",
                                        H: ["{[*]}"],
                                        D: "false",
                                        M: "Events",
                                        T: "boolean"
                                    },
                                    printThumbnail: {
                                        D: "false",
                                        T: "boolean",
                                        M: "General",
                                        C: "Print thumbnail.<br>",
                                        H: ["{[*]}"]
                                    },
                                    citationFont: {
                                        C: "Font for the reference citation<br>",
                                        T: "font",
                                        M: "Fonts",
                                        D: "7px Verdana",
                                        Z: "true"
                                    },
                                    barLollipopFactor: {
                                        C: "Ratio for the lollipop in bar graphs. The higher the value the bigger the lollipop.<br>",
                                        H: ['{[*],"data":"Random:1:8","graphType":"Bar","widthFactor":0.1,"barType":"lollipop"}'],
                                        T: "integer",
                                        M: "Bar Graphs",
                                        D: "1.5"
                                    },
                                    z3DRatio: {
                                        U: ["Scatter3D", "Bar"],
                                        C: "Value between 0 - 1 for adjusting the 3D of the Z Axis<br>",
                                        M: "3D Attributes",
                                        H: ['{[0.5,1],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        D: "1",
                                        T: "float"
                                    },
                                    layoutConfig: {
                                        D: "[]",
                                        M: "Combination Plots",
                                        T: "array",
                                        C: "Array of object to assign visualization configurations to each layout.<br>"
                                    },
                                    smpLabelOrientation: {
                                        C: "Orientation to show the sample names<br>",
                                        M: "Circular Graphs",
                                        H: ['{[*],"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        T: "option",
                                        D: "perpendicular",
                                        O: ["perpendicular", "circular"]
                                    },
                                    edgeThickness: {
                                        C: "Default thickness for the edges in the networks<br>",
                                        Z: "true",
                                        D: "1",
                                        T: "integer",
                                        M: "Network Graphs"
                                    },
                                    tagCloudGridPoints: {
                                        C: "Array to keep state of the used space in the tag cloud visualization<br>",
                                        Z: "true",
                                        D: "[]",
                                        T: "array",
                                        M: "Tag Cloud"
                                    },
                                    histogramData: {
                                        T: "string",
                                        M: "Data",
                                        D: "false",
                                        C: "Flag or sample annotation to create histogram. If 'true' is specified then the histogram will be done with all data<br>",
                                        H: ['{[*],"data":"Random:200:1","histogramBins":50}']
                                    },
                                    cacheBase64: {
                                        M: "General",
                                        T: "boolean",
                                        D: "false",
                                        H: ["{[*]}"],
                                        C: "Cache image in meta data as Base64.<br>"
                                    },
                                    networkSpringLength: {
                                        T: "integer",
                                        M: "Network Algorithm Parameters",
                                        D: "35",
                                        C: "Ideal length for links (springs in physical model).<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    kmeansVariables: {
                                        M: "Functions",
                                        T: "void",
                                        C: "Cluster variables using kmeans<br>",
                                        S: ["kmeansVarClusters", "maxIterations"],
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "StackedLine", "StackedPercentLine"]
                                    },
                                    ideogramChromosomePosition: {
                                        C: "Factor name included in the 'data.z' object used to map to the chromosome position.<br>",
                                        M: "Circular Graphs",
                                        X: "getZData",
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"]}'],
                                        D: "pos",
                                        T: "string"
                                    },
                                    varTitleFont: {
                                        C: "Font for the variable titles in one dimensional plots<br>",
                                        M: "Fonts",
                                        T: "font",
                                        Z: "true",
                                        D: "12px Verdana"
                                    },
                                    dataPointSize: {
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        C: "Approximate size for the data points in scatter plots, dotplots and boxplots. The size will be adjusted according to the dimensions of the graph.<br>",
                                        D: "20",
                                        M: "Aspect Ratio, Space and width",
                                        T: "integer"
                                    },
                                    smpLabelImageRound: {
                                        C: "Use round images as sample labels<br>",
                                        D: "false",
                                        M: "Samples",
                                        T: "boolean"
                                    },
                                    asVariableFactors: {
                                        H: ['{"data":"Random:4:8:2:2","asSampleFactors":["Smp1"]}'],
                                        C: "Array containing sample names. Numeric sample data (in columns) to be treated as a variable factor (move from 'y' to 'z' object). This parameter accomplishes the same as the function switchSmpToAnnotation at load time. It can be used in conjunction with the parameter stringVariableFactors to be treated as a string. TO DO: write example.<br>",
                                        D: "[]",
                                        T: "array",
                                        M: "Data"
                                    },
                                    smpLabelImage: {
                                        M: "Samples",
                                        T: "boolean",
                                        D: "false",
                                        C: "Use images as sample labels when possible<br>"
                                    },
                                    connectByShowLegend: {
                                        M: "Data Point Attributes",
                                        T: "boolean",
                                        D: "true",
                                        H: ['{[*],"graphType":"Dotplot","connectBy":"Factor1"}'],
                                        C: "Flag to show the connectBy legend<br>"
                                    },
                                    axisTickThickness: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        M: "Axis",
                                        C: "Thickness of the axis ticks.<br>",
                                        T: "float",
                                        D: "1",
                                        H: ['{[*],"graphType":"Scatter2D"}']
                                    },
                                    fishAxisLabels: {
                                        C: "Fish Axis Labels (array with names for the lines across the X Axis). Must have the same dimension as the fishAxis<br>",
                                        M: "Fish Graphs",
                                        S: ["fishAxis"],
                                        H: ['{[*],"graphType":"Fish"}'],
                                        T: "array",
                                        D: "[]"
                                    },
                                    densityPixels: {
                                        C: "Number of pixels to stack on the density plots.<br>",
                                        H: ['{[*],"data":"Random:20000:2","showScatterDensity":true,"dataPointSize":2,"scatterOutlineThreshold":1}'],
                                        M: "Density Plots",
                                        T: "integer",
                                        D: "1000"
                                    },
                                    smpIndicesStart: {
                                        D: "-1",
                                        Z: "true",
                                        M: "Heatmap Graphs",
                                        T: "integer",
                                        C: "Number that indicates starting point for samples in heatmaps when the canvas is zoom in.<br>"
                                    },
                                    timeValues: {
                                        T: "array",
                                        M: "Time Series",
                                        D: "[]",
                                        Z: "true",
                                        C: "Array containing the tick values when the the graph is a time series<br>"
                                    },
                                    remoteParams: {
                                        D: "{}",
                                        T: "object",
                                        M: "Remote Procedures",
                                        C: "Object to hold additional parameters used to obtain data remotely. The target property will be always added to the method as well as the direction [next|prev].<br>",
                                        S: ["remoteService", "remoteServiceType", "remoteDirection"]
                                    },
                                    saveFilename: {
                                        D: "false",
                                        T: "string",
                                        M: "General",
                                        C: "Filename to use when downloading the canvas as an image or as json. If not specified. the filename will be based on the target id of the canvas. 'cX-' + canvas.targetId + extension.<br>"
                                    },
                                    connectBy: {
                                        X: "getZData",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        C: "Name of a variable annotation to connect the variables.<br>",
                                        M: "Data Point Attributes",
                                        O: ["false"],
                                        H: ['{"data":"Random:8:4:1:1","graphType":"Scatter3D","connectBy":"Annt1"}', '{"data":"Random:8:4:1:1","graphType":"Scatter3D","connectBy":false}'],
                                        T: "option",
                                        D: "false"
                                    },
                                    sequenceFill: {
                                        C: "Color for the background when showing sequnces in the box or sequence object in the Genome. The default is to use the background of the object. If specied a valid color then all the background of sequences will be uniform<br>",
                                        H: ["{[*]}"],
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "false"
                                    },
                                    treeLinkColor: {
                                        C: "The default color for the tree lines (links)<br>",
                                        H: ["{[*]}"],
                                        T: "color",
                                        M: "Trees",
                                        D: "rgb(150,150,150)"
                                    },
                                    fonts: {
                                        M: "Text",
                                        T: "array",
                                        D: "[]",
                                        H: ['{"data":"Random:8:4:2:1","title":"Google Fonts","graphType":"Scatter2D","fonts":["Indie Flower", "Ubuntu", "Architects Daughter", "Roboto"],"fontName":"Indie Flower"}'],
                                        C: "Goggle Fonts.<br>"
                                    },
                                    sequenceIColor: {
                                        C: "Color for the isoleucines in the genome browser<br>",
                                        H: ["{[*]}"],
                                        D: "rgb(0,103,0)",
                                        T: "color",
                                        M: "Genome Browser"
                                    },
                                    remoteTransitionEffect: {
                                        O: ["none", "slide", "fade"],
                                        C: "Effect for the remote transitions.<br>",
                                        D: "slide",
                                        M: "Remote Procedures",
                                        T: "option"
                                    },
                                    title: {
                                        M: "Titles and Subtitles",
                                        C: "Title of the graph.<br>",
                                        S: ["titleHeight", "titleColor"],
                                        T: "string",
                                        D: "false",
                                        H: ['{"title":"Graph Title"}']
                                    },
                                    networkRoot: {
                                        C: "Node Id of the network root.<br>",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"radial","networkRoot":"ND1","showAnimation":true}', '{"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"radial","networkRoot":"ND6","showAnimation":true}'],
                                        T: "string",
                                        M: "Network Graphs",
                                        D: "false"
                                    },
                                    showLevelOverlays: {
                                        C: "Flag to indicate to show or not the level overlays in one dimensional plots<br>",
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        D: "true",
                                        M: "Overlays",
                                        T: "boolean"
                                    },
                                    yAxisTopBottomTickColor: {
                                        T: "color",
                                        D: "rgb(204,204,204)",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        M: "Y-Axis",
                                        C: "Color for the top and bottom tick lines in the Y axis<br>",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"]
                                    },
                                    setMin: {
                                        C: "Minimum value to set the data<br>",
                                        D: "null",
                                        Z: "true",
                                        M: "Axis",
                                        T: "float"
                                    },
                                    showHeatmapOncoprint: {
                                        T: "boolean",
                                        D: "false",
                                        H: ["{[*]}"],
                                        S: ["showHeatmapOncoprint", "showHeatmapOncoprint"],
                                        M: "Oncoprint Graphs",
                                        C: "Flag to show heatmap along with the oncoprint.<br>"
                                    },
                                    zAxisTicks: {
                                        C: "Number of ticks in the Z axis<br>",
                                        M: "Z-Axis",
                                        T: "integer",
                                        D: "10",
                                        Z: "true"
                                    },
                                    showHistogramMedian: {
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        D: "false",
                                        T: "boolean",
                                        S: ["createHistogram", "densityKernel"],
                                        C: "Flag to show histogram median<br>",
                                        M: "Histograms"
                                    },
                                    ganttDependencyThickness: {
                                        O: ["false"],
                                        D: "false",
                                        T: "float",
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}'],
                                        X: "getXData",
                                        M: "Gantt Charts",
                                        C: "Variable annotation for the thickness of the dependency line. Defaults to 1.<br>"
                                    },
                                    evenColor: {
                                        M: "Colors",
                                        C: "The color for the even numbers in samples when the property block contrast is set in one dimensional plots or the color for odd number residues in translations in genome plots.<br>",
                                        S: ["blockContrast", "oddColor"],
                                        D: "rgb(245,245,245)",
                                        T: "color",
                                        H: ['{[*],"data":"Random:1:6","blockContrast":true}']
                                    },
                                    show3DGrid: {
                                        U: ["Scatter3D"],
                                        C: "Flag to show the X,Y,Z grid in 3D plots<br>",
                                        M: "3D Attributes",
                                        H: ['{[*],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        D: "true",
                                        T: "boolean"
                                    },
                                    isCreateHistogram: {
                                        C: "Object to store histogram data<br>",
                                        M: "Histograms",
                                        T: "object",
                                        D: "false",
                                        Z: "true"
                                    },
                                    variablesClustered: {
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap"}'],
                                        C: "Configuration property to cluster variables<br>",
                                        M: "Clustering",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    subtitleFont: {
                                        C: "Font for the subtitle<br>",
                                        Z: "true",
                                        D: "14px Verdana",
                                        T: "font",
                                        M: "Fonts"
                                    },
                                    transitionStaggering: {
                                        H: ['{[*],"graphType":"Bar","showTransition":true,"groupingFactors":["Factor1"]}'],
                                        C: "Steps for transitionioning data objects<br>",
                                        M: "Animations and Visualization Transitions",
                                        T: "integer",
                                        D: "10"
                                    },
                                    createRandomData: {
                                        C: "Create a random data set<br>",
                                        T: "void",
                                        M: "Functions"
                                    },
                                    barnesHutNodesCache: {
                                        C: "Barnes Hut node cache for performance and avoid Javascript GC<br>",
                                        T: "array",
                                        M: "Network Algorithm Parameters",
                                        D: "[]",
                                        Z: "true"
                                    },
                                    layoutType: {
                                        M: "Combination Plots",
                                        C: "Type of layout to place the position for the labels in the trellis plot. Identify the axis that will be used to place the first segregating factor. 'rows' will use the first segregating factor in the rows and the second in the columns. 'cols' will use the first segregating factor in the columns and the second in the rows. 'wrap' will wrap the segregating factors putting the sample factors in the columns.<br>",
                                        O: ["wrap", "rows", "cols"],
                                        D: "wrap",
                                        T: "option",
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}']
                                    },
                                    backgroundImage: {
                                        M: "Foreground and Background",
                                        C: "Specifies the url for the background image when the background type is of the type 'image' or 'windowImage'.<br>",
                                        S: ["backgroundType"],
                                        T: "url",
                                        D: "false",
                                        H: ['{"backgroundType":"image","backgroundImage":"https://www.canvasxpress.org/assets/images/nanotube.jpg"}', '{"backgroundType":"windowImage","backgroundImage":"https://www.canvasxpress.org/assets/images/nanotube.jpg"}']
                                    },
                                    trackNameFontStyle: {
                                        C: "Font style for the track name.<br>",
                                        M: "Genome Browser",
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "",
                                        O: ["", "bold", "italic", "bold italic"]
                                    },
                                    meterEnd: {
                                        M: "Meter Graphs",
                                        T: "float",
                                        D: "90",
                                        C: "End value for the meter in degrees.<br>",
                                        H: ['{[*],"graphType":"Meter"}']
                                    },
                                    shadowColor: {
                                        C: "Color for the shadow.<br>",
                                        M: "Shadows",
                                        S: ["showShadow"],
                                        H: ['{[*],"showShadow":true}'],
                                        T: "color",
                                        D: "rgba(0,0,0,0.5)"
                                    },
                                    layoutLabelShow: {
                                        C: "Flag to draw the layout label.<br>",
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        T: "boolean",
                                        M: "Combination Plots",
                                        D: "true"
                                    },
                                    featuresProperties: {
                                        C: "Two dimensional array with object properties not at the root level for the features in the Genome graph to include in the Data table and the data filter<br>",
                                        M: "Data Table/Filter",
                                        T: "array",
                                        D: "[]"
                                    },
                                    remoteAutoSize: {
                                        C: "Flag to adjust remote graph to current canvas size<br>",
                                        M: "Remote Procedures",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    zAxisAbsMax: {
                                        C: "Maximum non-filtered value for the data plotted in the Z axis<br>",
                                        M: "Z-Axis",
                                        T: "float",
                                        D: "null",
                                        Z: "true"
                                    },
                                    treemapBorderWidth: {
                                        C: "Width for the treemap border<br>",
                                        H: ["{[*]}"],
                                        M: "Treemap Graphs",
                                        T: "integer",
                                        D: "3"
                                    },
                                    stringSampleFactors: {
                                        H: ['{"data":"Random:4:8:2:2","stringSampleFactors":["Factor1"]}'],
                                        C: "Array containing sample factors. The numeric sample factors will be treated as strings. This parameter accomplishes the same as the function switchNumericToString for samples at load time. It can be used in conjunction with the parameter asSampleFactors. TO DO: write example.<br>",
                                        D: "[]",
                                        M: "Data",
                                        T: "array"
                                    },
                                    dotplotOutlineThreshold: {
                                        H: ['{[10,3],"data":"Random:20:4:2:1","graphType":"Dotplot","dotplotOutlineThreshold":10}'],
                                        C: "Maximum number of data points before skipping plotting their outline but only the fill color<br>",
                                        D: "500",
                                        T: "integer",
                                        M: "Plot area"
                                    },
                                    xAxisTickFormat: {
                                        H: ['{"xAxisTickFormat":"%.2f cxs","graphOrientation":"vertical"}'],
                                        C: "Format for the tick values in the X axis. It could be a string with the sprintf format or an array where the first parameter is the sprintf format and the second parameter is a modification applied to the value before is passed to the sprintf function.<br>",
                                        D: "false",
                                        M: "X-Axis",
                                        T: "string"
                                    },
                                    setMinY: {
                                        D: "null",
                                        M: "Y-Axis",
                                        T: "float",
                                        H: ['{[10,15,null],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        C: "Minimum value to set the data in the Y axis<br>"
                                    },
                                    meterThickness: {
                                        D: "50",
                                        M: "Meter Graphs",
                                        T: "integer",
                                        C: "Thickness in pixels for the vertical, horizontal and state meters<br>",
                                        H: ['{[*],"graphType":"Meter"}']
                                    },
                                    meterIndex: {
                                        H: ['{[*],"graphType":"Meter"}'],
                                        C: "Variable or Sample index to use creating a meter and there is multiple variables or samples<br>",
                                        T: "integer",
                                        M: "Meter Graphs",
                                        D: "0"
                                    },
                                    boxplotTransparency: {
                                        D: "0.5",
                                        T: "float",
                                        M: "Boxplot Graphs",
                                        C: "Fraction to adjust color transparency for the boxplot id individual data points are shown.<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}']
                                    },
                                    objectBorderColor: {
                                        D: "rgb(0,0,0)",
                                        M: "Plot area",
                                        T: "color",
                                        C: "The color for the border of all objects in one dimensional graphs. It turns into the non-transparent fill color if set to false.<br>",
                                        H: ['{[*],"graphType":"Bar"}']
                                    },
                                    networkTimeStep: {
                                        D: "20",
                                        T: "integer",
                                        M: "Network Algorithm Parameters",
                                        C: "Default time step (dt) for forces integration.<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    createContour: {
                                        S: ["contourXBinSize", "contourYBinSize", "contourZBinSize", "contourType"],
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        T: "void",
                                        M: "Functions",
                                        C: "Create contour<br>"
                                    },
                                    colorSpectrumTarget: {
                                        D: "10",
                                        M: "Colors",
                                        T: "integer",
                                        C: "Approximate number of colors to use to build the color spectrum<br>",
                                        H: ['{[100,6],"graphType":"Heatmap"}']
                                    },
                                    sequenceLColor: {
                                        C: "Color for the leucines in the genome browser<br>",
                                        H: ["{[*]}"],
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,103,0)"
                                    },
                                    tags: {
                                        D: "[]",
                                        T: "array",
                                        M: "General",
                                        C: "Tags<br>"
                                    },
                                    imageTries: {
                                        C: "Image try counter.<br>",
                                        M: "Images",
                                        Z: "true",
                                        S: ["imageTimeOut", "imageMaxTries"],
                                        T: "integer",
                                        D: "0"
                                    },
                                    boxplotDataPointTransparency: {
                                        M: "Boxplot Graphs",
                                        C: "Fraction to adjust color transparency for the data points when displaying original data in boxplots.<br>",
                                        S: ["showBoxplotOriginalData", "jitterColumns", "jitter"],
                                        T: "float",
                                        D: "0.5",
                                        H: ['{[0.2,0.5,0.8],"data":"Random:2:12:0:2","jitter":true,"showBoxplotOriginalData":true,"groupingFactors":["Factor1"]}']
                                    },
                                    attractiveForceFunction: {
                                        C: "Type of function to apply when calculating attractive force in forceDirected network layouts. Fruchterman-Reingold uses square while Eades uses log.<br>",
                                        M: "Network Algorithm Parameters",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        D: "square",
                                        T: "option",
                                        O: ["square", "cubic", "log", "pow", "sqrt"]
                                    },
                                    smpLabelFontStyle: {
                                        C: "Font style for the sample label.<br>",
                                        M: "Samples",
                                        O: ["", "bold", "italic", "bold italic"],
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: ""
                                    },
                                    disableToolbar: {
                                        D: "false",
                                        M: "Events",
                                        T: "boolean",
                                        C: "Flag to disable showing the toolbar<br>",
                                        H: ["{[*]}"]
                                    },
                                    dataPointSizeScaleFactor: {
                                        C: "Factor used to adjust the size of the dataPointSize.<br>",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        D: "1",
                                        T: "float",
                                        M: "Aspect Ratio, Space and width"
                                    },
                                    featureSignalToNoiseValues: {
                                        C: "Flag use to show values for the quality<br>",
                                        H: ["{[*]}"],
                                        M: "Genome Browser",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    is3DNetwork: {
                                        D: "false",
                                        M: "Network Graphs",
                                        T: "boolean",
                                        C: "Flag to create or not a 3D network<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    selectionMode: {
                                        C: "Mode use to highlight selected data points in visualizations.<br> @see{selectionColor,selectionMetadata}",
                                        M: "Data Selection: Parameters used to select data in all visualizations",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        T: "option",
                                        D: "highlight",
                                        O: ["highlight", "ghost", "name", "filter"]
                                    },
                                    transformData: {
                                        S: ["transformAxis"],
                                        M: "Data",
                                        C: "Default transformation type for ALL the data. Data can also be transformed by axis (x,y,z) to give more flexibility. false, save, reset and undo are NOT real transformations. They are only used in the canvasXpress UIs to save the transformed data.<br>",
                                        O: ["false", "log2", "log10", "exp2", "exp10", "percentile", "zscore", "ratio2", "ratio10", "save", "reset", "undo"],
                                        T: "option",
                                        D: "false",
                                        H: ['{[*],"data":"Random:4:8:2:2"}']
                                    },
                                    offsetY: {
                                        C: "Additional amount to move for the Y axis.<br>",
                                        T: "float",
                                        M: "Combination Plots",
                                        Z: "true",
                                        D: "0"
                                    },
                                    xAxisTransform: {
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        O: ["false", "log2", "log10", "exp2", "exp10", "percentile"],
                                        M: "X-Axis",
                                        C: "Tranformation for the values in the X axis.<br>",
                                        U: ["Scatter2D", "ScatterBubble2D"]
                                    },
                                    motionCurrentFontStyle: {
                                        C: "Font style for the motion charts.<br>",
                                        M: "Motion Charts",
                                        O: ["", "bold", "italic", "bold italic"],
                                        H: ['{"data":"Random:30:3:2:2","graphType":"Scatter2D","motionBy":"Annt1"}'],
                                        D: "",
                                        T: "option"
                                    },
                                    pieSegmentSeparation: {
                                        T: "integer",
                                        M: "Pie Charts",
                                        D: "1",
                                        H: ["{[*]}"],
                                        C: "Length in pixels for the separation of the pieces of the pie charts<br>"
                                    },
                                    rAxisValues: {
                                        C: "Values for the ticks in the R axis<br>",
                                        T: "array",
                                        M: "R-Axis",
                                        D: "[]"
                                    },
                                    meterColors: {
                                        H: ['{[*],"graphType":"Meter"}'],
                                        D: ["rgb(0,255,0)", "rgb(255,255,0)", "rgb(255,0,0)"],
                                        T: "array",
                                        S: ["meterSegments"],
                                        C: "Meter Colors.<br>",
                                        M: "Meter Graphs"
                                    },
                                    networkCommunities: {
                                        C: "Number of network communities<br>",
                                        D: "null",
                                        Z: "true",
                                        T: "integer",
                                        M: "Network Communities"
                                    },
                                    calculateNetworkCommunities: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:karate","showNetworkCommunities":true}'],
                                        C: "Flag to calculate the network communities using the jLouvain algorithm. If this flag is false the property community and communityColor for each node will need to be provided, otherwise all nodes will belong to a single community.<br>",
                                        D: "true",
                                        T: "boolean",
                                        M: "Network Communities"
                                    },
                                    networkShowDataTable: {
                                        D: "nodes",
                                        M: "Data Table",
                                        T: "option",
                                        C: "Show nodes or edges on data table<br>",
                                        O: ["nodes", "edges"]
                                    },
                                    manhattanColors: {
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        C: "Colors for the manhattan plots",
                                        M: "Scatter Plots",
                                        T: "array",
                                        D: ["rgb(128,128,128)", "rgb(135,206,235)"]
                                    },
                                    startCol: {
                                        C: "Starting column in the data table<br>",
                                        M: "Data Table",
                                        T: "integer",
                                        Z: "true",
                                        D: "0"
                                    },
                                    varDendrogramPosition: {
                                        M: "Dendrograms",
                                        C: "Position for the variable dendrogram in the plot. It could be top, bottom, right or left depending on the orientation of the graph.<br>",
                                        D: "top",
                                        T: "option",
                                        H: ['{[*],"data":"Random:4:8:1:1","graphType":"Heatmap","variablesClustered":true}'],
                                        O: ["top", "bottom"]
                                    },
                                    sequenceCColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the cytosines and cysteins in the genome browser<br>",
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,0,255)"
                                    },
                                    scatterPlotMatrixType: {
                                        C: "Type for the matrix of 2D sccaterplots. Draw either in both panels, upper only or lower only. Show any combination of correlation, histogram, density and variability (boxplots). Also specify whether to use all versus all or only the first data set.<br>",
                                        M: "Scatter Plot Matrix",
                                        S: ["scatterPlotMatrix"],
                                        H: ['{[*],"data":"Random:8:8","graphType":"Scatter2D","scatterPlotMatrix":true}'],
                                        D: "both",
                                        T: "option",
                                        O: ["both", "upper", "lower", "correlation", "correlationHistogram", "corelationDensity", "all", "first"]
                                    },
                                    tagCloudTextWeightFactor: {
                                        C: "Factor weight for text in tag cloud visualizations<br>",
                                        H: ["{[*]}"],
                                        D: "1",
                                        T: "integer",
                                        M: "Tag Cloud"
                                    },
                                    vennLegendColors: {
                                        T: "boolean",
                                        M: "Venn Diagrams",
                                        D: "false",
                                        C: "Flag to use the venn colors to use for the legends instead of the letters<br>",
                                        H: ['{[*],"data":"RandomVenn"}']
                                    },
                                    randomDataSampleAnnotations: {
                                        C: "Default number of sample annotations when creating random data<br>",
                                        M: "Random",
                                        T: "integer",
                                        D: "2"
                                    },
                                    yAxisValues: {
                                        C: "Values for the ticks in the Y axis<br>",
                                        Z: "true",
                                        D: "[]",
                                        T: "array",
                                        M: "Y-Axis"
                                    },
                                    ridgelineScale: {
                                        T: "float",
                                        M: "Ridgeline Plots",
                                        D: "1.5",
                                        C: "Scale for ridgeline<br>",
                                        H: ['{[*],"data":"Random:20000:2","dataPointSize":2,"scatterOutlineThreshold":1}']
                                    },
                                    connectKey: {
                                        T: "object",
                                        M: "Data Point Attributes",
                                        D: "false",
                                        H: ['{"graphType":"Dotplot","connectBy":"Factor1","connectKey":{"Factor1":{"Lev:1":"red","Lev:2":"gold"}}}'],
                                        C: "Object to assign custom colors to lines when samples are connected by a sample annotations included in the data object. The key of the object is the name of an annotation in the data.x object. A default connect will be assigned to a data point whose value was not included the object.<br>"
                                    },
                                    scatterType: {
                                        S: ["images", "isHistogram", "histogramBarWidth", "chromosomeLengths"],
                                        C: "Type of scatter plot<br>",
                                        M: "Scatter Plots",
                                        O: ["false", "line", "bar", "dot", "image", "lineImage", "lineStep", "boxplot", "visium", "manhattan"],
                                        H: ['{[*],"graphType":"Scatter2D","scatterType":"image","images":["area", "bar", "boxplot", "heatmap", "line", "pie"]}'],
                                        T: "option",
                                        D: "false"
                                    },
                                    dendrogramHeight: {
                                        H: ['{[*],"data":"Random:4:8:1:1","graphType":"Heatmap","samplesClustered":true,"variablesClustered":true}'],
                                        C: "Size in pixels for the dendrogram.<br>",
                                        T: "integer",
                                        M: "Dendrograms",
                                        D: "80"
                                    },
                                    mapStandardParallel1: {
                                        H: ["{[*]}"],
                                        C: "Map Standard Parallel 1 in degrees. (Applicable to Albers projection only). Default adjusts to USA maps.<br>",
                                        M: "Maps",
                                        T: "float",
                                        D: "29.5"
                                    },
                                    axisAlgorithm: {
                                        T: "option",
                                        D: "wilkinson",
                                        H: ['{[*],"data":"Random:2:4","graphType":"Bar"}'],
                                        O: ["heckbert", "wilkinson", "wilkinsonExtended", "rPretty"],
                                        M: "Axis",
                                        C: "Algorithm used to position tick labels on axes. See An Extension of Wilkinson’s Algorithm for Positioning Tick Labels on Axes. Justin Talbot, Sharon Lin, Pat Hanrahan.<br>",
                                        S: ["axisWilkinsonLoose"]
                                    },
                                    yAxisAbsMin: {
                                        C: "Minimum non-filtered value for the data plotted in the Y axis<br>",
                                        D: "null",
                                        Z: "true",
                                        T: "float",
                                        M: "Y-Axis"
                                    },
                                    graphOrientation: {
                                        O: ["horizontal", "vertical"],
                                        D: "horizontal",
                                        T: "option",
                                        H: ["{[*]}"],
                                        U: ["Bar", "Line", "Area", "AreaLine", "BarLine", "Boxplot", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedLine", "StackedPercent", "StackedPercentLine", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey"],
                                        M: "General",
                                        C: "Specifies the orientation of one dimensional graphs.<br>"
                                    },
                                    networkFreeze: {
                                        M: "Network Graphs",
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"forceDirected"}', '{[*],"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"radial"}'],
                                        C: "Flag to prevent autoscaling for the network layout. Useful when images are part of the network.<br>"
                                    },
                                    showNodeNameThreshold: {
                                        H: ['{[5,50],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        C: "Thereshold used to set the limit to hide or display the name of nodes in a network. If the number of nodes exceed this thereshold then the name will not be shown.<br>",
                                        D: "50",
                                        M: "Network Graphs",
                                        T: "integer"
                                    },
                                    sequenceFColor: {
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,0,255)",
                                        H: ["{[*]}"],
                                        C: "Color for the phenylalanines in the genome browser<br>"
                                    },
                                    colorKey: {
                                        D: "false",
                                        M: "Data Point Attributes",
                                        T: "object",
                                        H: ['{"graphType":"Dotplot","colorBy":"Factor1","colorKey":{"Factor1":{"Lev:1":"gold","Lev:2":"silver"}}}'],
                                        C: "Object to assign custom colors to sample annotations and variable annotations included in the data object. The key of the object is the name of an annotation in the data.x object, or the name of an annotation in the data.z object. The value for each key could be either: (1) a scalar with a valid color scheme (see this.meta.def.colorSchemes), or (2) an array with valid colors, or (3) an object to specify custom colors for each of the values of the annotation. A default color will be assigned to a data point whose value was not included the object. CanvasXpress will handle string and numeric annotation approprietly. However, if an object is specified like that one in number (3) the annotation will be treated as categorical even if the annotation is numeric.<br>"
                                    },
                                    periodTicksLabels: {
                                        M: "Genome Browser",
                                        T: "integer",
                                        D: "5",
                                        H: ["{[*]}"],
                                        C: "Number of ticks to skip between values in the genome browser<br>"
                                    },
                                    showHistogramQuantiles: {
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        S: ["createHistogram", "densityKernel"],
                                        M: "Histograms",
                                        C: "Flag to show quantile 0.25 and 0.75 in density plots<br>"
                                    },
                                    sequenceFontSize: {
                                        M: "Genome Browser",
                                        T: "integer",
                                        D: "12",
                                        C: "Size in pixels for the font size of text of the sequence in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    networkRepulsion: {
                                        M: "Network Algorithm Parameters",
                                        T: "float",
                                        D: "-1",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        C: "Coulomb's law coefficient. It's used to repel nodes thus should be negative if you make it positive nodes start attract each other.<br>"
                                    },
                                    xAxis: {
                                        H: ['{"xAxis":["S1","S2","S3"],"yAxis":["S4","S5","S6"],"graphType":"Scatter2D"}'],
                                        T: "array",
                                        D: "[]",
                                        C: "Name of the samples or sample groups to be displayed in the X axis if scatter plot or variables if one dimensional graphs<br>",
                                        M: "X-Axis",
                                        X: "getSamplesVariablesAsArray"
                                    },
                                    rAxisAbsMin: {
                                        C: "Minimum non-filtered value for the data plotted in the R axis<br>",
                                        T: "float",
                                        M: "R-Axis",
                                        D: "null",
                                        Z: "true"
                                    },
                                    remoteEffectIn: {
                                        C: "remoteEffectIn<br>",
                                        H: ["{[*]}"],
                                        T: "string",
                                        M: "Effect",
                                        D: "holeIn"
                                    },
                                    xAxisTickStyle: {
                                        M: "X-Axis",
                                        C: "Style for the tick lines in the X axis<br>",
                                        O: ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        T: "option",
                                        D: "solid",
                                        H: ["{[*]}"]
                                    },
                                    boxplotConnectWidth: {
                                        T: "integer",
                                        M: "Boxplot Graphs",
                                        D: "2",
                                        C: "Width for the line of the connection of boxes in boxplots<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","boxplotConnect":true,"groupingFactors":["Factor1"]}']
                                    },
                                    barPath: {
                                        H: ['{[*],"data":"Random:1:8","graphType":"Bar","barType":"lollipop"}'],
                                        C: "Show the path for the bar graph<br>",
                                        T: "boolean",
                                        M: "Bar Graphs",
                                        D: "false"
                                    },
                                    fullTextMeasureCheck: {
                                        T: "integer",
                                        M: "General",
                                        D: "500",
                                        C: "Full thorough check of variable and sample names when more than the specified number. This is useful for large data sets as canvas has not an efficent maner to measure text.<br>",
                                        H: ["{[*]}"]
                                    },
                                    xAxis2ValuesRaw: {
                                        T: "array",
                                        D: "[]",
                                        C: "Raw values for the ticks in the 2nd X axis<br>",
                                        M: "X-Axis2",
                                        Z: "true",
                                        U: ["AreaLine", "BarLine", "StackedLine", "StackedPercentLine"]
                                    },
                                    manhattanMarkerLogPValue: {
                                        X: "getSamplesAsArray",
                                        M: "Scatter Plots",
                                        C: "Sample name included in the 'data.y.smps' object used to map to the negative log 10 p value.<br>",
                                        O: ["false"],
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"graphType":"Scatter2D"}']
                                    },
                                    coordinateNetworkConvexHullCommunityColor: {
                                        T: "boolean",
                                        M: "Network Communities",
                                        D: "false",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:karate","showNetworkCommunities":true,"calculateNetworkCommunities":true}'],
                                        C: "Flag to coordinate colors of the nodes with convex hull for the network communities<br>"
                                    },
                                    fishSeparateIndependentClones: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Fish Graphs",
                                        H: ['{[*],"graphType":"Fish"}'],
                                        C: "Separate indepenent clones<br>"
                                    },
                                    rAxisPercentShow: {
                                        T: "boolean",
                                        M: "R-Axis",
                                        D: "true",
                                        H: ['{[*],"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        C: "Flag to show on not the percent in each segment in the R axis<br>"
                                    },
                                    hierarchyVarIndex: {
                                        Z: "true",
                                        D: "0",
                                        M: "Hierarchy",
                                        T: "integer",
                                        C: "Variable index to use in the sankey, sunburst and bubble graphs.<br>"
                                    },
                                    fontSize: {
                                        T: "integer",
                                        M: "Text",
                                        D: "12",
                                        C: "Font size for text in complex plot only. See other categories to modify specific font sizes.<br>",
                                        H: ['{[*],"title":"Graph Title"}']
                                    },
                                    errors: {
                                        D: "[]",
                                        Z: "true",
                                        T: "array",
                                        M: "Debug",
                                        C: "Array containing benign errors produced when rendering canvasXpress<br>"
                                    },
                                    decorationsColor: {
                                        C: "Color for the decorations in scatter plots and network graphs<br>",
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        T: "color",
                                        M: "Decorations",
                                        D: "rgb(0,0,0)"
                                    },
                                    xAxisMinorValues: {
                                        C: "Values for the minor ticks in the X axis<br>",
                                        T: "array",
                                        M: "X-Axis",
                                        D: "[]",
                                        Z: "true"
                                    },
                                    legend: {
                                        M: "Legends",
                                        C: "Custom legends : Array of objects [{ size : [], shape : [], shapeColor : [], line : [], lineColor : [], lineStart : [], lineEnd : [], text : [], x : number, y : number, title : string }]<br>",
                                        U: ["Network"],
                                        T: "array",
                                        D: "[]",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","legend":[{"size":[20],"shape":["circle"],"shapeColor":["lightblue"],"text":["Node"]}]}', '{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","legend":[{"title":"Legend","size":[20,20],"shape":["circle",false],"shapeColor":["lightblue",false],"line":[false,"solid"],"lineColor":[false,"black"],"text":["Node","Edge"]}]}', '{"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","legend":[{"title":"Legend1","size":[20],"shape":["circle"],"shapeColor":["lightblue"],"line":["dashed"],"lineColor":["black"],"text":["Node"]},{"title":"Legend2","size":[20],"line":["solid"],"lineColor":["black"],"text":["Edge"]}]}']
                                    },
                                    overlayFont: {
                                        C: "Font for the overlays in one dimensional plots<br>",
                                        Z: "true",
                                        D: "12px Verdana",
                                        M: "Fonts",
                                        T: "font"
                                    },
                                    sequenceEndColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the end codon in the genome browser<br>",
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(255,0,0)"
                                    },
                                    citationColor: {
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        H: ['{[*],"citation":"Graph citation or reference"}'],
                                        S: ["citation"],
                                        M: "Citations or References",
                                        C: "Color for a reference citation of the graph<br>"
                                    },
                                    heatmapCellBoxColorHighlight: {
                                        T: "color",
                                        M: "Heatmap Graphs",
                                        D: "rgb(255,215,0)",
                                        C: "Color for highlighting heatmap cells<br>",
                                        H: ['{[*],"graphType":"Heatmap","highlightVar":["V1","V2"],"highlightSmp":["S1","S2"]}']
                                    },
                                    sequenceYColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the degenerate C/T and tyrosines in the genome browser<br>",
                                        D: "rgb(0,0,255)",
                                        M: "Genome Browser",
                                        T: "color"
                                    },
                                    smpDendrogramPosition: {
                                        C: "Position for the sample dendrogram in the plot. It could be top, bottom, right or left depending on the orientation of the one dimensional graph or inside or outside in circular graphs.<br>",
                                        M: "Dendrograms",
                                        O: ["right", "left"],
                                        H: ['{["right","left"],"data":"Random:4:8:1:1","graphType":"Bar","samplesClustered":true,"graphOrientation":"horizontal"}', '{["top","bottom"],"data":"Random:4:8:1:1","graphType":"Bar","samplesClustered":true,"graphOrientation":"vertical"}', '{["inside","outside"],"data":"RandomCircular:4:20","graphType":"Circular","samplesClustered":true}'],
                                        T: "option",
                                        D: "left"
                                    },
                                    xAxisTickColor: {
                                        D: "rgb(204,204,204)",
                                        T: "color",
                                        M: "X-Axis",
                                        C: "Color for the tick lines in the X axis<br>",
                                        H: ["{[*]}"]
                                    },
                                    showVarDendrogram: {
                                        M: "Dendrograms",
                                        T: "boolean",
                                        D: "true",
                                        H: ['{[*],"data":"Random:4:8:1:1","graphType":"Heatmap","variablesClustered":true}'],
                                        C: "Flag to show or not the variable dendrogram<br>"
                                    },
                                    treeCircular: {
                                        H: ["{[*]}"],
                                        C: "Flag to plot a circular tree layout.<br>",
                                        M: "Trees",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    axisTickScaleFontFactor: {
                                        D: "1",
                                        M: "Axis",
                                        T: "float",
                                        H: ["{[*]}"],
                                        C: "Scaling factor used to increase or decrease tick font size in the canvas in one, two and three dimensional plots<br>"
                                    },
                                    margin: {
                                        D: "5",
                                        T: "integer",
                                        H: ['{[5,20],"data":"Random:1:3"}'],
                                        S: ["adjustAspectRatio"],
                                        M: "Margins",
                                        C: "Relative length in pixels for the distance between various objects in the graphs. This value is adjusted acording to the graph dimensions if the adjustAspectRatio parameter is set to 'true'.<br>"
                                    },
                                    patternKey: {
                                        C: "Object to assign custom patterns to sample annotations and variable annotations included in the data object. The key of the object is the name of an annotation in the data.x object or the name of an annotation in the data.z object. A default pattern will be assigned to a data point whose value was not included the object.<br>",
                                        H: ['{"graphType":"Dotplot","patternBy":"Factor1","patternKey":{"Factor1":{"Lev:1":"stripeVertical","Lev:2":"stripeHorizontal"}}}'],
                                        M: "Data Point Attributes",
                                        T: "object",
                                        D: "false"
                                    },
                                    addRegressionLine: {
                                        C: "Add regression line(s) to a 2D-Scatter plot<br>",
                                        M: "Functions",
                                        T: "void",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    decorationsPosition: {
                                        H: ['{["right","bottom"],"data":"Random:16:2","graphType":"Scatter2D","showDecorations":true,"showLegend":false,"functions":["addNormalDistributionLine"]}', '{["right","bottom","left","top"],"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","showDecorations":true,"decorations":["D1","D2","D3"]}'],
                                        D: "bottom",
                                        T: "option",
                                        O: ["rightTop", "right", "rightBottom", "bottom", "leftBottom", "left", "leftTop", "top"],
                                        C: "Position for the decorations in one dimensional plots, scatter plots and network graphs. If legendInside is true the all the options apply but if legendInside is false only right and bottom are valid options<br>",
                                        M: "Decorations"
                                    },
                                    setMax: {
                                        T: "float",
                                        M: "Axis",
                                        D: "null",
                                        Z: "true",
                                        C: "Maximum value to set the data<br>"
                                    },
                                    verbose: {
                                        C: "Flag to turn on/off verbose<br>",
                                        D: "false",
                                        M: "Debug",
                                        T: "boolean"
                                    },
                                    colorByShowLegend: {
                                        D: "true",
                                        M: "Data Point Attributes",
                                        T: "boolean",
                                        H: ['{[*],"graphType":"Dotplot","colorBy":"Factor1"}'],
                                        C: "Flag to show the colorBy legend<br>"
                                    },
                                    scaleY: {
                                        D: "1",
                                        Z: "true",
                                        M: "Combination Plots",
                                        T: "float",
                                        C: "Scale factor for the Y axis<br>"
                                    },
                                    hideCodeDiv: {
                                        T: "void",
                                        M: "Functions",
                                        C: "Hide the code for the plot<br> @advanced"
                                    },
                                    featureTraceTrim: {
                                        C: "Default triming for nucleotide values in the traces (expressed in percent)<br>",
                                        H: ["{[*]}"],
                                        M: "Genome Browser",
                                        T: "integer",
                                        D: "1"
                                    },
                                    xAxisShow: {
                                        M: "X-Axis",
                                        T: "boolean",
                                        D: "true",
                                        C: "Flag to show on not the values of the ticks in the X axis<br>",
                                        H: ['{[*],"graphType":"Bar"}', '{[*],"graphType":"Scatter2D"}']
                                    },
                                    showInfoDiv: {
                                        C: "Show additional information<br> @advanced",
                                        M: "Functions",
                                        T: "void"
                                    },
                                    colorSpectrumZeroValue: {
                                        C: "A value to be at the center of the color spectrum to produce symmetrical heatmaps<br>",
                                        H: ['{[0,25],"graphType":"Heatmap"}'],
                                        D: "null",
                                        T: "float",
                                        M: "Colors"
                                    },
                                    zAxisTransformTicks: {
                                        C: "Flag to transform the values of the ticks in the Z axis<br>",
                                        H: ['{[*],"data":"Random:10:3","zAxisTransform":"log10","graphType":"Scatter3D"}'],
                                        D: "true",
                                        M: "Z-Axis",
                                        T: "boolean"
                                    },
                                    heatmapSmpSeparateBy: {
                                        X: "getXData",
                                        S: ["smpOverlays"],
                                        C: "Factor (in the x data object) used to separate the samples in the heatmap. The same factor must be included in the sample overlays.<br>",
                                        M: "Heatmap Graphs",
                                        H: ['{"graphType":"Heatmap","heatmapSmpSeparateBy":"Factor1","samplesClustered":true,"smpOverlays":["Factor1"]}'],
                                        D: "false",
                                        T: "string"
                                    },
                                    nodeFont: {
                                        C: "Font for the text in networks<br>",
                                        D: "20px Verdana",
                                        Z: "true",
                                        T: "font",
                                        M: "Fonts"
                                    },
                                    filterSkipNullKeys: {
                                        C: "Flag to indicate to bypass filtering when a key is non existent in the data objects.<br>",
                                        D: "false",
                                        M: "Data Filters",
                                        T: "boolean"
                                    },
                                    updateCodeDiv: {
                                        C: "Update the code to generate the plot<br> @advanced",
                                        T: "void",
                                        M: "Functions"
                                    },
                                    heatmapCellBoxWidth: {
                                        D: "1",
                                        T: "float",
                                        M: "Heatmap Graphs",
                                        C: "Width for the heatmap boxes around the cells<br>",
                                        H: ['{[0.5,2],"graphType":"Heatmap"}']
                                    },
                                    varLabelFontStyle: {
                                        U: ["Heatmap"],
                                        C: "Font style for the variable label.<br>",
                                        M: "Variables",
                                        O: ["", "bold", "italic", "bold italic"],
                                        H: ["{[*]}"],
                                        D: "",
                                        T: "option"
                                    },
                                    ganttCompletionTransparency: {
                                        M: "Gantt Charts",
                                        T: "float",
                                        D: "0.5",
                                        C: "Fraction to adjust color transparency for completion.<br>",
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}']
                                    },
                                    colors: {
                                        C: "Colors.<br>",
                                        M: "Colors",
                                        S: ["colorScheme"],
                                        H: ['{"data":"Random:16:1:0:0:1:100:0:false:uniform","graphType":"Pie"}'],
                                        D: ["#fe296c", "#487eb6", "#a7ce31", "#f8cc03", "#ff8c02", "#699696", "#b77844", "#83acd0", "#c2e076", "#fadc5a", "#ff549f", "#ffaf54", "#9ab8b7", "#d2a683", "#3d699b", "#87ac22", "#cda908", "#d02158", "#d07300", "#567676"],
                                        T: "array"
                                    },
                                    dataTableFontSize: {
                                        M: "Data Table",
                                        T: "integer",
                                        D: "12",
                                        C: "Data table font size<br>"
                                    },
                                    percentAspectRatioPlotArea: {
                                        C: "Specifies the minimum percentage for the plotting area<br>",
                                        H: ['{[0.25,0.5],"graphType":"Bar"}', '{[0.25,0.5],"graphType":"Pie"}'],
                                        M: "Aspect Ratio, Space and width",
                                        T: "float",
                                        D: "0.5"
                                    },
                                    sequenceVColor: {
                                        D: "rgb(0,103,0)",
                                        M: "Genome Browser",
                                        T: "color",
                                        H: ["{[*]}"],
                                        C: "Color for the degenerate A/C/G and valines in the genome browser<br>"
                                    },
                                    featureTranslateHeight: {
                                        C: "Default size in pixels of the translation height<br>",
                                        H: ["{[*]}"],
                                        D: "14",
                                        M: "Genome Browser",
                                        T: "integer"
                                    },
                                    datafilterEffectOut: {
                                        H: ["{[*]}"],
                                        C: "datafilterEffectOut<br>",
                                        M: "Effect",
                                        T: "string",
                                        D: "holeOut"
                                    },
                                    minTextSize: {
                                        D: "4",
                                        M: "Text",
                                        T: "integer",
                                        C: "Minimum size for any text in the canvas.<br>",
                                        H: ['{[*],"title":"Graph Title"}']
                                    },
                                    removeHistogram: {
                                        C: "Remove histogram from a 2D-Scatter plot<br>",
                                        T: "void",
                                        M: "Functions",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    oncoprintRowSummary: {
                                        C: "Flag to show row summary in oncoprints.<br>",
                                        H: ["{[*]}"],
                                        D: "false",
                                        M: "Oncoprint Graphs",
                                        T: "boolean"
                                    },
                                    showHistogramDataPoints: {
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        D: "false",
                                        T: "boolean",
                                        S: ["createHistogram", "densityKernel"],
                                        C: "Flag to show the original data point in histograms<br>",
                                        M: "Histograms"
                                    },
                                    ganttEnd: {
                                        X: "getVariablesAsArray",
                                        M: "Gantt Charts",
                                        C: "Variable to use in Gantt plots as end date. Defaults to the second variable in the data set.<br>",
                                        O: ["false"],
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}']
                                    },
                                    recalculateLayout: {
                                        T: "void",
                                        M: "Functions",
                                        C: "Recalculate the network layout<br>",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    confidenceIntervalType: {
                                        M: "Error Bars and Confidence Intervals",
                                        C: "Confidence intervals type for Kaplan Meier estimates<br>",
                                        O: ["ordinary", "log", "loglog"],
                                        D: "log",
                                        T: "option",
                                        H: ['{[*],"data":"RandomKaplanMeier","showDecorations":true,"graphType":"Scatter2D","showLegend":false,"functions":["addKaplanMeierCurve:Time:Censored-1:Data 1 Population:rgb(0,0,255)","addKaplanMeierCurve:Time:Censored-2:Data 2 Population:rgb(255,0,0)"]}']
                                    },
                                    colorBy: {
                                        O: ["false", "variable"],
                                        H: ['{"data":"Random:8:4:1:1","graphType":"Scatter3D","colorBy":"Annt1"}', '{"data":"Random:8:4:1:1","graphType":"Scatter3D","colorBy":"Sample4"}', '{"data":"Random:4:8:1:1","graphType":"Bar","colorBy":"Factor1"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","colorBy":"Factor1"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","colorBy":"Annt1"}'],
                                        D: "false",
                                        T: "option",
                                        X: "getXZData",
                                        C: "Name of a variable annotation or a sample name or the string 'variable' to color the variables.<br>",
                                        M: "Data Point Attributes"
                                    },
                                    zAxisTitleDynamic: {
                                        T: "boolean",
                                        M: "Z-Axis",
                                        D: "false",
                                        H: ["{[*]}"],
                                        C: "Set the title for the Z axis dynamically as it changes<br>"
                                    },
                                    configuratorWidth: {
                                        M: "Events",
                                        T: "integer",
                                        D: "250",
                                        C: "Size in pixels for the configurator.<br>",
                                        H: ["{[*]}"]
                                    },
                                    adjustAspectRatioYTries: {
                                        Z: "true",
                                        D: "0",
                                        T: "integer",
                                        M: "Aspect Ratio, Space and width",
                                        C: "Counter set when trying to automatically adjust the vertical size of the canvas when adjustAspectRatio is true<br>"
                                    },
                                    gradientOrientation: {
                                        C: "Specifies the orientation of the gradient if the gradient type is of the type 'linear'<br>",
                                        M: "Gradients",
                                        S: ["backgroundType"],
                                        H: ['{[*],"data":"Random:1:3:0:0","gradient":true,"gradientType":"linear"}'],
                                        T: "option",
                                        D: "vertical",
                                        O: ["vertical", "horizontal"]
                                    },
                                    subtitleColor: {
                                        H: ['{[*],"title":"Graph Title","subtitle":"Graph Subtitle"}'],
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        C: "Color for the subtitle<br>",
                                        M: "Titles and Subtitles",
                                        S: ["subtitle", "subtitleHeight"]
                                    },
                                    contourEndLevel: {
                                        S: ["createContour"],
                                        M: "Contours",
                                        C: "End level for contours. It is automatically calculated if not defined.<br>",
                                        T: "integer",
                                        D: "false",
                                        H: ['{[5,10],"data":"Random:20:20","functions":["createContour"]}']
                                    },
                                    disableDocument: {
                                        H: ["{[*]}"],
                                        C: "Flag to disable mousemove and mouseup in the document.<br>",
                                        T: "boolean",
                                        M: "Events",
                                        D: "false"
                                    },
                                    showPrimaryMenus: {
                                        D: "false",
                                        M: "Events",
                                        T: "boolean",
                                        H: ["{[*]}"],
                                        C: "Flag to show primary menus in toolbar<br>"
                                    },
                                    zAxisMaxStrLength: {
                                        C: "Longest string of all the values in the ticks in the Z axis<br>",
                                        T: "string",
                                        M: "Z-Axis",
                                        Z: "true",
                                        D: "null"
                                    },
                                    functions: {
                                        C: "Functions exposed to the api<br>",
                                        D: "[];",
                                        Z: "true",
                                        M: "General",
                                        T: "array"
                                    },
                                    panningY: {
                                        C: "Number of unit to pan the network in the Y dimension<br>",
                                        H: ["{[*]}"],
                                        T: "float",
                                        M: "Zooming, Panning and Resizing",
                                        D: "0"
                                    },
                                    hiddenMapFeatures: {
                                        C: "Hidden Map features<br>",
                                        D: "[]",
                                        T: "array",
                                        M: "Maps"
                                    },
                                    colorNodeBy: {
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","colorNodeBy":"n"}'],
                                        C: "Name of the attribute to color the nodes.<br>",
                                        T: "string",
                                        M: "Network Node and Edge Attributes",
                                        D: "false"
                                    },
                                    colorScheme: {
                                        T: "option",
                                        D: "User",
                                        H: ['{[*],"data":"Random:8:1:0:0:1:100:0:false:uniform","graphType":"Pie"}'],
                                        O: ["YlGn", "YlGnBu", "GnBu", "BuGn", "PuBuGn", "PuBu", "BuPu", "RdPu", "PuRd", "OrRd", "YlOrRd", "YlOrBr", "Purples", "Blues", "Greens", "Oranges", "Reds", "Greys", "PuOr", "BrBG", "PRGn", "PiYG", "RdBu", "RdGy", "RdYlBu", "Spectral", "RdYlGn", "Accent", "Dark2", "Paired", "Pastel1", "Pastel2", "Set1", "Set2", "Set3", "Default", "Basic", "Light", "Favorite", "Pastel", "Balanced", "Rpalette", "RlatticeBackground", "RlatticeShingle", "RlatticeLine", "RlatticePolygon", "Bootstrap", "Economist", "EconomistBG", "Excel", "Excel2", "Excel3", "GGPlot", "Solarized", "SolarizedBase", "PaulTol", "ColorBlind", "Tableau", "TableauGrey", "TableauColorBlind", "TableauTrafficLight", "TableauPurpleGrey", "TableauBlueRed", "TableauGreenOrange", "TableauCyclic", "TableauPairSequential", "TableauTripleDiverging", "WallStreetJournal", "WallStreetJournal2", "WallStreetJournal3", "WallStreetJournalRedGreen", "WallStreetJournalBlackGreen", "WallStreetJournalDemRep", "Stata", "Stata2", "Stata3", "StataMono", "BlackAndWhite", "CanvasXpress", "CanvasXpressT"],
                                        M: "Colors",
                                        C: "Color schemes can be user defined which will take the colors in the color property or one provided in canvasXpress. The order of the colors will be used to sequentially select when a different color is needed in a particular visualization.<br>",
                                        S: ["colors"],
                                        X: "getColorSchemes"
                                    },
                                    histogramBarWidth: {
                                        C: "Length in pixels for half of the bar width in the 2D sccater plot histogram.<br>",
                                        M: "Histograms",
                                        T: "float",
                                        D: "false",
                                        Z: "true"
                                    },
                                    featureTraceHeight: {
                                        D: "40",
                                        M: "Genome Browser",
                                        T: "integer",
                                        C: "Default size in pixels of the trace height<br>",
                                        H: ["{[*]}"]
                                    },
                                    trackDirColor: {
                                        H: ["{[*]}"],
                                        C: "Default color for the strand direction of the tracks in the genome browser<br>",
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(0,0,0)"
                                    },
                                    panningStep: {
                                        C: "Percentage step for panning networks.<br>",
                                        H: ['{[*],"graphType":"Heatmap"}'],
                                        T: "float",
                                        M: "Zooming, Panning and Resizing",
                                        D: "0.2"
                                    },
                                    treeNodeSize: {
                                        T: "integer",
                                        M: "Trees",
                                        D: "5",
                                        Z: "true",
                                        C: "Size for the Tree nodes<br>"
                                    },
                                    nodeFontSize: {
                                        C: "Size in pixels for the font size of text in the networks. This is based  on the nodeSize<br>",
                                        M: "Network Graphs",
                                        T: "integer",
                                        D: "15",
                                        Z: "true"
                                    },
                                    colorSpectrum: {
                                        H: ['{"graphType":"Heatmap","colorSpectrum":["blue","white","red"]}', '{"graphType":"Heatmap","colorSpectrum":["green","black","red"]}'],
                                        T: "array",
                                        D: ["#4575b4", "#91bfdb", "#e0f3f8", "#ffffbf", "#fee090", "#fc8d59", "#d73027"],
                                        S: ["colorSpectrumBreaks"],
                                        C: "An array with valid color names to create a color brew for the default color indicators<br>",
                                        M: "Colors"
                                    },
                                    lineWidthEvent: {
                                        C: "Size in pixels of the width for the events in the lines.<br>",
                                        D: "2",
                                        Z: "true",
                                        T: "integer",
                                        M: "Lines"
                                    },
                                    remoteDataIndex: {
                                        C: "Index of the canvasXpress object requested<br>",
                                        T: "integer",
                                        M: "Remote Procedures",
                                        D: "0",
                                        Z: "true"
                                    },
                                    boxplotWidthRatioIfViolin: {
                                        C: "A number between 0.1 and 1 to adjust the width of the boxplot when violins are shown. It does not affect anything unless violins are shown.<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","showViolinBoxplot":true,"showBoxplotIfViolin":true,"groupingFactors":["Factor1"]}'],
                                        T: "float",
                                        M: "Boxplot Graphs",
                                        D: "0.33"
                                    },
                                    sankeyCoordinateColor: {
                                        C: "Flag to use same color for the nodes and for the lines (links) in the Sankey diagram.<br>",
                                        H: ['{[*],"data":"RandomSankey","graphType":"Sankey"}'],
                                        T: "boolean",
                                        M: "Sankey Diagrams",
                                        D: "false"
                                    },
                                    joinType: {
                                        C: "Default type for joining lines.<br>",
                                        M: "Lines",
                                        O: ["mitter", "bevel", "round"],
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}'],
                                        D: "mitter",
                                        T: "option"
                                    },
                                    oncoprintHeatmapPosition: {
                                        C: "Position for the heatmap in the oncoprint<br>",
                                        M: "Oncoprint Graphs",
                                        S: ["showHeatmapOncoprint"],
                                        H: ["{[*]}"],
                                        D: "bottom",
                                        T: "option",
                                        O: ["right", "bottom", "left", "top"]
                                    },
                                    patternBy: {
                                        O: ["false", "variable"],
                                        T: "option",
                                        D: "false",
                                        H: ['{"data":"Random:8:4:1:1","graphType":"Scatter3D","patternBy":"Annt1"}', '{"data":"Random:8:4:1:1","graphType":"Scatter3D","patternBy":"Sample4"}', '{"data":"Random:4:8:1:1","graphType":"Bar","patternBy":"Factor1"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","patternBy":"Factor1"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","patternBy":"Annt1"}'],
                                        S: ["patternByData"],
                                        X: "getXZData",
                                        M: "Data Point Attributes",
                                        C: "Name of a variable annotation or a sample name or the string 'variable' to pattern the variables. When patternByData is specified patternBy is used for the title in the legend.<br>"
                                    },
                                    varIndicesStart: {
                                        C: "Number that indicates starting point for variables in heatmaps when the canvas is zoom in.<br>",
                                        M: "Heatmap Graphs",
                                        T: "integer",
                                        Z: "true",
                                        D: "-1"
                                    },
                                    treeNodeOutlineColor: {
                                        T: "color",
                                        M: "Trees",
                                        D: "rgb(51,122,183)",
                                        C: "The default color for the tree lines (links)<br>",
                                        H: ["{[*]}"]
                                    },
                                    hideUnhideVars: {
                                        M: "Functions",
                                        T: "array",
                                        C: "Hide or unhide variables. It works like a switch<br>",
                                        X: "getVariablesAsArray",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    align: {
                                        O: ["right", "center", "left"],
                                        H: ['{[*],"title":"Graph Title"}'],
                                        T: "option",
                                        D: "center",
                                        C: "Default horizontal alignment for drawing text.<br>",
                                        M: "Text"
                                    },
                                    rAxisZero: {
                                        T: "boolean",
                                        M: "Circular Graphs",
                                        D: "false",
                                        C: "Flag to force the rAxis property to start from zero otherwise it starts from the minimum value.<br>"
                                    },
                                    violinScale: {
                                        C: "Type for scaling violin plots<br>",
                                        M: "Boxplot Graphs",
                                        O: ["area", "count", "width"],
                                        H: ['{[*],"data":"Random:2:12:0:2","showViolinBoxplot":true,"groupingFactors":["Factor1"]}'],
                                        D: "area",
                                        T: "option"
                                    },
                                    plotBoxColor: {
                                        D: "rgb(204,204,204)",
                                        T: "color",
                                        H: ['{[*],"plotBox":true}'],
                                        M: "General",
                                        C: "Color for the box around the x,y coordinates of the plot<br>",
                                        S: ["plotBox"]
                                    },
                                    segregateVariablesBy: {
                                        D: "[]",
                                        M: "Data",
                                        T: "array",
                                        H: ['{"data":"Random:4:8:2:2","segregateVariablesBy":["Annt1"]}'],
                                        C: "An array that holds the annotation(s) used to segregate the variables. It must be categories in the 'data.z' object<br>"
                                    },
                                    networkNodesOnTop: {
                                        D: "true",
                                        M: "Network Graphs",
                                        T: "boolean",
                                        H: ['{[*],"data":"RandomNetwork:1:50:10:0:0:forceDirected"}'],
                                        C: "Order to use when drawing the nodes and edges in the networks. Useful for very populated netwrok graphs. When is set to true all the edges will be in the background.<br>"
                                    },
                                    networkFreezeOnLoad: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"forceDirected"}', '{[*],"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"radial"}'],
                                        C: "Flag to prevent autoscaling for the network layout after loading. Useful when images are part of the network.<br>",
                                        M: "Network Graphs",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    dashLength: {
                                        M: "Lines",
                                        T: "integer",
                                        D: "8",
                                        C: "Size in pixels of the length of the dashes and the separation between the dashes in the dashed lines.<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}']
                                    },
                                    mapSmps: {
                                        C: "Samples to use in maps<br>",
                                        T: "array",
                                        M: "Maps",
                                        D: "[]"
                                    },
                                    colorSpectrumBreaks: {
                                        C: "An array with numbers in ascending order for the color spectrum to create discontinuous spectra. It must have the same length of the colorSpectrum array for example [0, 0.3, 1]<br>",
                                        M: "Colors",
                                        S: ["colorSpectrum"],
                                        H: ['{"graphType":"Heatmap","colorSpectrumBreaks":[1,15,30,50,70,85,100]}', '{"graphType":"Heatmap","colorSpectrumBreaks":[1,10,20,30,40,50,75]}'],
                                        D: "[]",
                                        T: "array"
                                    },
                                    featureTypeDefault: {
                                        O: ["box", "bar", "heatmap", "sequence", "triangle", "line"],
                                        C: "Default type for the feature in the genome browser<br>",
                                        T: "option",
                                        M: "Genome Browser",
                                        D: "line"
                                    },
                                    tooltipDivEffectOut: {
                                        H: ["{[*]}"],
                                        C: "tooltipDivEffectOut<br>",
                                        D: "spaceInUp",
                                        T: "string",
                                        M: "Effect"
                                    },
                                    hideHistogram: {
                                        C: "Flag to hide the histogram bars<br>",
                                        M: "Histograms",
                                        S: ["createHistogram", "densityKernel"],
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        T: "boolean",
                                        D: "false"
                                    },
                                    disableDataExplorer: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Events",
                                        H: ["{[*]}"],
                                        C: "Flag to disable the data explorer<br>"
                                    },
                                    sankeyIterations: {
                                        C: "Number of iterations for the Sankey diagram<br>",
                                        Z: "true",
                                        D: "32",
                                        M: "Sankey Diagrams",
                                        T: "integer"
                                    },
                                    setMaxY: {
                                        D: "null",
                                        M: "Y-Axis",
                                        T: "float",
                                        H: ['{[25,50,null],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        C: "Maximum value to set the data in the Y axis<br>"
                                    },
                                    RdatastesURL: {
                                        Z: "true",
                                        D: "https://raw.githubusercontent.com/neuhausi/Rdatasets/master/",
                                        T: "array",
                                        M: "R",
                                        C: "URL for R objects<br>"
                                    },
                                    ideogramChromosome: {
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"]}'],
                                        T: "string",
                                        D: "chr",
                                        X: "getZData",
                                        C: "Factor name included in the 'data.z' object used to map to the chromosome number.<br>",
                                        M: "Circular Graphs"
                                    },
                                    gradientRatio: {
                                        D: "1.3",
                                        T: "float",
                                        H: ['{[*],"data":"Random:1:3:0:0","gradient":true,"gradientType":"linear"}'],
                                        S: ["gradientType"],
                                        M: "Gradients",
                                        C: "Specifies the ratio used to generate linear gradients.<br>"
                                    },
                                    sequenceStartColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the start codon in the genome browser<br>",
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(0,204,0)"
                                    },
                                    showDecorations: {
                                        H: ['{"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        C: "Flag to show or not extra decorations like (regression lines, splines, etc) in scatter plots and (heatmaps, pie charts or stacked bar graphs in) network graphs<br>",
                                        M: "Decorations",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    yAxisTopMajorTick: {
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        D: "true",
                                        T: "boolean",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        C: "A flag to show the top Major tick line in the Y axis in Scatter2D plots<br>",
                                        M: "Y-Axis"
                                    },
                                    smpTitleFont: {
                                        Z: "true",
                                        D: "12px Verdana",
                                        T: "font",
                                        M: "Fonts",
                                        C: "Font for the sample title in one dimensional plots<br>"
                                    },
                                    ganttDependency: {
                                        O: ["false"],
                                        T: "option",
                                        D: "false",
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}'],
                                        X: "getXData",
                                        M: "Gantt Charts",
                                        C: "Variable annotation in the x object to use in Gantt plots as dependency. Must be a valid sample / group name<br>"
                                    },
                                    featureQualityValues: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Genome Browser",
                                        C: "Flag use to show values for the quality<br>",
                                        H: ["{[*]}"]
                                    },
                                    patternByShowLegend: {
                                        C: "Flag to show the patternBy legend<br>",
                                        H: ['{[*],"graphType":"Dotplot","patternBy":"Factor1"}'],
                                        D: "true",
                                        M: "Data Point Attributes",
                                        T: "boolean"
                                    },
                                    resizeWidthOnLayout: {
                                        D: "true",
                                        M: "Events",
                                        T: "boolean",
                                        H: ["{[*]}"],
                                        C: "Flag to enable resizing the width of the canvas after changing the layout<br>"
                                    },
                                    meterBackgroundColor: {
                                        C: "Meter Background Color.<br>",
                                        H: ['{[*],"graphType":"Meter"}'],
                                        D: "rgb(229,229,229)",
                                        T: "color",
                                        M: "Meter Graphs"
                                    },
                                    showBoxplotOriginalData: {
                                        S: ["jitterColumns", "boxplotDataPointTransparency", "jitter"],
                                        C: "Flag to show all the observed data point in boxplots. (Should be called showBoxplotDataPoints)<br>",
                                        M: "Boxplot Graphs",
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}'],
                                        D: "false",
                                        T: "boolean"
                                    },
                                    boxplotMedianColor: {
                                        D: "rgb(0,0,0)",
                                        M: "Boxplot Graphs",
                                        T: "color",
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}'],
                                        C: "Color for the line of the median of data in boxplots.<br>"
                                    },
                                    vennColors: {
                                        T: "array",
                                        D: "[]",
                                        H: ['{"data":"RandomVenn","vennColors":["rgb(51,151,255)","rgb(151,255,51)","rgb(255,51,125)"],"vennGroups":3}'],
                                        M: "Venn Diagrams",
                                        C: "Colors for the Venn bubles. If not specified the colors will be chosen from the colors array. Colors in this array need to be at least the same number of groups in the Venn diagram<br>",
                                        S: ["colors"]
                                    },
                                    adjustAspectRatioMax: {
                                        C: "Specifies the number of times to try to automatically adjust the size of the canvas when adjustAspectRatio is true<br>",
                                        M: "Aspect Ratio, Space and width",
                                        T: "integer",
                                        D: "3",
                                        Z: "true"
                                    },
                                    confidenceLevel: {
                                        H: ['{"data":"Random:16:2","confidenceLevel":0.80,"showDecorations":true,"graphType":"Scatter2D","functions":["addRegressionLine"]}', '{"data":"Random:16:2","confidenceLevel":0.90,"showDecorations":true,"graphType":"Scatter2D","functions":["addRegressionLine"]}', '{"data":"Random:30:2","confidenceLevel":0.80,"graphType":"Scatter2D","ellipseBy":"variable"}', '{"data":"Random:30:2","confidenceLevel":0.90,"graphType":"Scatter2D","ellipseBy":"variable"}'],
                                        C: "Confidence level for regression, ellipse and Kaplan Meier.<br>",
                                        T: "float",
                                        M: "Error Bars and Confidence Intervals",
                                        D: "0.95"
                                    },
                                    stringVariableFactors: {
                                        C: "Array containing variable factors. The numeric variable factors will be treated as strings. This parameter accomplishes the same as the function switchNumericToString for variables at load time. It can be used in conjunction with the parameter asVariableFactors. TO DO: write example.<br>",
                                        H: ['{"data":"Random:4:8:2:2","stringVariableFactors":["Annt1"]}'],
                                        M: "Data",
                                        T: "array",
                                        D: "[]"
                                    },
                                    yAxisMajorTicks: {
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "true",
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        C: "A flag to show Major tick lines in the Y axis<br>",
                                        M: "Y-Axis"
                                    },
                                    featureDirColor: {
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,0,0)",
                                        H: ["{[*]}"],
                                        C: "Default color for the strand direction of the feature in the genome browser<br>"
                                    },
                                    linePatterns: {
                                        O: ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        H: ['{[*],"data":"Random:4:6","graphType":"Line"}'],
                                        D: ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        T: "array",
                                        C: "Line Patterns used in line visualizations.<br>",
                                        M: "General Attributes"
                                    },
                                    shadowOffsetY: {
                                        S: ["showShadow"],
                                        C: "Length in pixels for the shadow offset in the Y axis.<br>",
                                        M: "Shadows",
                                        H: ['{[*],"showShadow":true}'],
                                        D: "1",
                                        T: "integer"
                                    },
                                    hierarchy: {
                                        X: "getXData",
                                        C: "Hierarchy for trees and bubble graphs made up of sample annotations present the data x object.<br>",
                                        M: "Hierarchy",
                                        H: ['{"data":"RandomCircular:4:8:0:2","graphType":"Circular","circularType":"bubble","colorBy":"Factor2","hierarchy":["Factor1","Factor2"]}', '{"data":"RandomCircular:4:8:0:2","graphType":"Tree","colorBy":"Factor2","hierarchy":["Factor1","Factor2"]}'],
                                        D: "[]",
                                        T: "array"
                                    },
                                    tagCloudShape: {
                                        T: "option",
                                        D: "false",
                                        H: ["{[*]}"],
                                        O: ["false", "circle", "cardioid", "diamond", "square", "triangle", "triangle2", "pentagon", "star"],
                                        M: "Tag Cloud",
                                        C: "Shape for the tag cloud<br>"
                                    },
                                    decorationFontSize: {
                                        H: ['{[*],"data":"Random:16:2","autoScaleFont":false,"showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        C: "Font size for the decorations in scatter plots and network graphs<br>",
                                        D: "12",
                                        T: "integer",
                                        M: "Decorations"
                                    },
                                    isHistogram: {
                                        C: "Flag to track conversion of 2D scatter plot into histograms.<br>",
                                        Z: "true",
                                        D: "false",
                                        M: "Histograms",
                                        T: "boolean"
                                    },
                                    titleAlign: {
                                        O: ["left", "center", "right"],
                                        T: "option",
                                        D: "center",
                                        H: ['{[*],"title":"Graph Title"}'],
                                        M: "Titles and Subtitles",
                                        C: "Title alignment<br>"
                                    },
                                    wireColor: {
                                        C: "Color for the ticks in the genome browser<br>",
                                        H: ["{[*]}"],
                                        D: "rgba(204,204,204,0.1)",
                                        M: "Genome Browser",
                                        T: "color"
                                    },
                                    rAxisMajorTicks: {
                                        C: "A flag to show Major tick lines in the R axis<br>",
                                        H: ['{[*],"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        D: "true",
                                        T: "boolean",
                                        M: "R-Axis"
                                    },
                                    maxDOENumber: {
                                        D: "8",
                                        M: "DOE",
                                        T: "integer",
                                        C: "Maximum number of graphs when creating a DOE.<br>",
                                        H: ['{[5,8],"data":"Random:3:24:3:5","groupingFactors":["Factor1"],"functions":["createDOE"]}']
                                    },
                                    createFactory: {
                                        C: "CanvasXpress Factory used to create plot. This is parsed from the PNG or JSON data loaded<br>",
                                        D: "false",
                                        Z: "true",
                                        T: "object",
                                        M: "General"
                                    },
                                    zAxisTitle: {
                                        T: "string",
                                        M: "Z-Axis",
                                        D: "false",
                                        C: "Title for the Z axis<br>",
                                        H: ['{"data":"Random:10:3","graphType":"Scatter3D","zAxisTitle":"Z-axis title"}']
                                    },
                                    showScatterPlotMatrixLabels: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Scatter Plot Matrix",
                                        C: "Flag to show the labels in the scatter plot matrix<br>",
                                        H: ['{[*],"data":"Random:8:8","graphType":"Scatter2D","scatterPlotMatrix":true}']
                                    },
                                    reproduceTime: {
                                        D: "500",
                                        T: "integer",
                                        M: "General",
                                        H: ['{[*],"groupingFactors":["Factor1"],"isReproducibleResearch":true}'],
                                        C: "Time to wait in milliseconds to reproduce user modifications through the UI.<br>"
                                    },
                                    binConfigurations: {
                                        D: "{}",
                                        M: "Bins",
                                        T: "object",
                                        C: "Properties for the binning functions<br>"
                                    },
                                    ratioGroupReference: {
                                        X: "getXData",
                                        M: "Data",
                                        C: "Name of the group used in ratio transformation. Almost 'private' parameters used within the different CanvasXpress UIs.<br>",
                                        O: ["false"],
                                        T: "option",
                                        D: "false"
                                    },
                                    plotByVariable: {
                                        M: "Plot area",
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"graphType":"Bar"}'],
                                        C: "Flag to indicate whether to group the data variable rather than by sample<br>"
                                    },
                                    showSmpOverlaysLegend: {
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1"],"smpOverlays":["Factor1"]}'],
                                        C: "Flag to show or not the legend for the sample overlays in the graphs. If set to false the level information will be displayed in the actual colored boxes of the overlays<br>",
                                        D: "false",
                                        M: "Overlays",
                                        T: "boolean"
                                    },
                                    disableWheel: {
                                        C: "Flag to disable wheel. <br>",
                                        H: ["{[*]}"],
                                        T: "boolean",
                                        M: "Events",
                                        D: "false"
                                    },
                                    kmeansSamples: {
                                        T: "void",
                                        M: "Functions",
                                        C: "Cluster samples using kmeans<br>",
                                        S: ["kmeansSmpClusters", "maxIterations"],
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "StackedLine", "StackedPercentLine"]
                                    },
                                    varLabelFontSize: {
                                        U: ["Heatmap"],
                                        S: ["autoScaleFont", "varLabelScaleFontFactor"],
                                        C: "Size for the variable labels in one dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the variable label scaling factor<br>",
                                        M: "Variables",
                                        H: ['{[*],"autoScaleFont":false}'],
                                        T: "integer",
                                        D: "12"
                                    },
                                    motionEffectOut: {
                                        C: "motionEffectOut<br>",
                                        H: ["{[*]}"],
                                        D: "holeOut",
                                        T: "string",
                                        M: "Effect"
                                    },
                                    dendrogramColor: {
                                        C: "The color for the dendrograms<br>",
                                        H: ['{[*],"data":"Random:4:8:1:1","graphType":"Heatmap","samplesClustered":true,"variablesClustered":true}'],
                                        D: "rgb(0,0,0)",
                                        M: "Dendrograms",
                                        T: "color"
                                    },
                                    rAxisTickColor: {
                                        D: "rgb(0,0,0)",
                                        M: "R-Axis",
                                        T: "color",
                                        C: "Color for the tick lines in the R axis<br>",
                                        H: ['{[*],"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}']
                                    },
                                    meterMax: {
                                        T: "float",
                                        M: "Meter Graphs",
                                        D: "100",
                                        C: "Maximum value in the meter.<br>",
                                        H: ['{[*],"graphType":"Meter"}']
                                    },
                                    showFunctionNamesAfterRender: {
                                        C: "Show function names when after render is set<br>",
                                        D: "false",
                                        M: "General",
                                        T: "boolean"
                                    },
                                    layoutCanvasCompartments: {
                                        C: "Flag to draw lines around each graph in the layout in the canvas. Used only when debugging.<br>",
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        T: "boolean",
                                        M: "Combination Plots",
                                        D: "false"
                                    },
                                    featureNameFont: {
                                        D: "12px Verdana",
                                        Z: "true",
                                        M: "Fonts",
                                        T: "font",
                                        C: "Font for the text of the features in the genome browser<br>"
                                    },
                                    legendFontSize: {
                                        C: "Font size for the legends. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the legend scaling factor<br>",
                                        M: "Legends",
                                        S: ["autoScaleFont", "legendScaleFontFactor"],
                                        H: ['{[*],"autoScaleFont":false}'],
                                        T: "integer",
                                        D: "12"
                                    },
                                    histogramBins: {
                                        C: "Approximate number of bins in a histogram. It may vary considerably to the actual number used in the histogram to ensure a 'pretty' size for the intervals in the histogram. ggplot's default is 30.<br>",
                                        M: "Histograms",
                                        S: ["createHistogram"],
                                        H: ['{[10,50],"data":"Random:200:1","functions":["createHistogram"]}'],
                                        T: "integer",
                                        D: "false"
                                    },
                                    treeVarIndex: {
                                        C: "Variable index to use in the tree diagrams<br>",
                                        M: "Trees",
                                        T: "integer",
                                        D: "0",
                                        Z: "true"
                                    },
                                    maxItemMenuCheckbox: {
                                        M: "Events",
                                        T: "integer",
                                        D: "10",
                                        C: "Maximum number of items in a menu before it becomes a scroll box<br>",
                                        H: ["{[*]}"]
                                    },
                                    yAxisTickColor: {
                                        T: "color",
                                        D: "rgb(204,204,204)",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        M: "Y-Axis",
                                        C: "Color for the tick lines in the Y axis<br>",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"]
                                    },
                                    highlightGreyOutTransparency: {
                                        S: ["highlightGreyOut"],
                                        M: "General",
                                        C: "Fraction of transparency for grey out when highlighting with mouse over<br>",
                                        D: "0.67",
                                        T: "float",
                                        H: ['{[0.67,0.33],"graphType":"Scatter2D","highlightGreyOut":true}']
                                    },
                                    axisTitleFontStyle: {
                                        C: "Font style for the axis titles.<br>",
                                        M: "Axis",
                                        O: ["", "bold", "italic", "bold italic"],
                                        H: ['{[*],"xAxisTitle":"Axis Title"}'],
                                        D: "",
                                        T: "option"
                                    },
                                    useOpenShapes: {
                                        C: "Use open shapes in most visualizations<br>",
                                        H: ['{[*],"data":"Random:1:6"}'],
                                        M: "Shapes",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    rAxisMinorValues: {
                                        C: "Values for the minor ticks in the R axis<br>",
                                        M: "R-Axis",
                                        T: "array",
                                        D: "[]"
                                    },
                                    filterSmpBy: {
                                        M: "Data Filters",
                                        C: "Filter samples by their annotation included in the 'data.x' object used in one dimensional plots. Used in the CanvasXpress UIs.<br>",
                                        U: ["AGraphs"],
                                        X: "getXData",
                                        D: "{'cases':[],'comp':[],'op':[],'type':[],'value':[]}",
                                        T: "filter"
                                    },
                                    decorationsBoxColor: {
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        T: "color",
                                        D: "rgb(204,204,204)",
                                        C: "Color for the box around the decoration legend<br>",
                                        M: "Decorations",
                                        S: ["decorationsBox"]
                                    },
                                    sequenceAColor: {
                                        D: "rgb(0,103,0)",
                                        M: "Genome Browser",
                                        T: "color",
                                        C: "Color for the adenines and alanines in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    zAxisValuesRaw: {
                                        C: "Raw values for the ticks in the Z axis<br>",
                                        D: "[]",
                                        Z: "true",
                                        M: "Z-Axis",
                                        T: "array"
                                    },
                                    yAxisTickStyle: {
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"],
                                        M: "Y-Axis",
                                        C: "Style for the tick lines in the Y axis<br>",
                                        O: ["solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        D: "solid",
                                        T: "option",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}']
                                    },
                                    addNormalDistributionLine: {
                                        C: "Add a normaldistribution line(s) to a 2D-Scatter plot<br>",
                                        M: "Functions",
                                        T: "void",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    backgroundDataTable: {
                                        C: "Color for the data table background<br>",
                                        D: "rgba(255,255,255,0.95)",
                                        T: "color",
                                        M: "Data Table"
                                    },
                                    sequenceGColor: {
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(0,0,0)",
                                        H: ["{[*]}"],
                                        C: "Color for the guanines and glycines in the genome browser<br>"
                                    },
                                    randomDataVariables: {
                                        T: "integer",
                                        M: "Random",
                                        D: "3",
                                        C: "Default number of variables when creating random data<br>"
                                    },
                                    meterAxis: {
                                        T: "option",
                                        D: "variables",
                                        H: ['{[*],"graphType":"Meter"}'],
                                        O: ["samples", "variables"],
                                        M: "Meter Graphs",
                                        C: "Axis to use when creating meter and there is multiple data variable or samples.<br>"
                                    },
                                    yAxisMinorValues: {
                                        D: "[]",
                                        Z: "true",
                                        M: "Y-Axis",
                                        T: "array",
                                        C: "Values for the minor ticks in the Y axis<br>"
                                    },
                                    colorSmpDendrogramBy: {
                                        O: ["false"],
                                        T: "option",
                                        D: "false",
                                        H: ['{"data":"Random:4:8:1:1","colorSmpDendrogramBy":"Factor1","graphType":"Heatmap","samplesClustered":true}'],
                                        X: "getXData",
                                        M: "Dendrograms",
                                        C: "Name of a sample annotation to color the variable dendrogram.<br>"
                                    },
                                    outlineWidth: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}'],
                                        D: "1",
                                        T: "float",
                                        C: "Default width in pixels for lines in networks and other line elements in all visualizations except for the lines in the line plots.<br>",
                                        M: "Lines",
                                        S: ["lineThickness"]
                                    },
                                    lines: {
                                        S: ["arrows"],
                                        C: "Line types in network graphs for the edges (or connections) between network nodes.<br> There are three styles: solid, dashed and dotted and four sub types: straight, bezier, curved (clockwise) and curvedCC (counter clockwise). The line types can be any combination of a style followed by a subtype. By default the type is always a solid straight line so there is no need to specify solid or stright as a style if there is a subtype.<br> Lines can also have elbows which are specified as a 2D-array. In the case a straight solid line each elements in the array will have an x,y coordinate and each segment will be perpendicular to the previous one. For example in this edge object:<br> <i>{ ..., type : 'line', elbows : [ [20, 40], [60, 80] ], ... }</i><br> A special subtype of line called segmented can also have elbows which are not perpendicalar to each other. For example in this edge object:<br> <i>{ ..., type : 'segmented', elbows : [ [20, 40], [60, 80] ], ... }</i><br> In the case of a bezier curved each element of the array will have an x,y coordinate for the control point 1, an x,y coordinate for the control point 2 and an x,y coordinate for the end of the line.<br> <i>{ ..., type : 'bezier', elbows : [ [20, 40, 40, 20, 40, 40], ... ], ... }</i><br> If the property elbow is specified the line will be drawn using the first and last elements of the array rather than the coordinates of the two nodes. A property startX and startY can be used to better adjust the position of the starting line. Similarly, a property endX and endY can be used to better adjust the position of the end line. These properties have a maginitud between -1 to 1 which will be used based on the width and height of the source and target node. For example in the following edge object the line will start in the middle bottom of the source node and will end at the upper left of the target node.<br>  <i>{ ..., type : 'line', startX : 0, startY : 1, endX : -1, endY : -0.5, ... }</i><br>",
                                        M: "Lines",
                                        Z: "true",
                                        O: ["line", "solid", "straight", "bezier", "curved", "curvedCC", "dashedLine", "dashedBezier", "dashedCurved", "dashedCurvedCC", "dottedLine", "dottedBezier", "dottedCurved", "dottedCurvedCC"],
                                        H: ['{"data":"RandomNetwork:1:30:15:1:0:forceDirected","graphType":"Network"}'],
                                        T: "array",
                                        D: ["line", "solid", "straight", "bezier", "curved", "curvedCC", "dashedLine", "dashedBezier", "dashedCurved", "dashedCurvedCC", "dottedLine", "dottedBezier", "dottedCurved", "dottedCurvedCC"]
                                    },
                                    isTransformedData: {
                                        C: "Flag to indicate if the data is transformed.<br>",
                                        Z: "true",
                                        D: "false",
                                        M: "Data",
                                        T: "boolean"
                                    },
                                    featureCoordinateHeight: {
                                        M: "Genome Browser",
                                        T: "integer",
                                        D: "14",
                                        H: ["{[*]}"],
                                        C: "Default size in pixels of the coordinates height<br>"
                                    },
                                    varTitleLabelPosition: {
                                        O: ["bottom", "top"],
                                        T: "option",
                                        D: "bottom",
                                        H: ['{[*],"graphType":"Heatmap","varOverlays":["Annt1"]}'],
                                        M: "Heatmap Graphs",
                                        C: "Position for variable labels<br>"
                                    },
                                    scaleTextConstantMult: {
                                        D: "25",
                                        Z: "true",
                                        T: "integer",
                                        M: "Text",
                                        C: "Constants to autoscale text<br>"
                                    },
                                    sequenceGAPColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the deletions, insertions and gaps in the genome browser<br>",
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(255,0,255)"
                                    },
                                    manhattanMarkerChromosomeNumber: {
                                        M: "Scatter Plots",
                                        C: "Sample name included in the 'data.y.smps'  object used to map to the chromosome number.<br>",
                                        X: "getSamplesAsArray",
                                        T: "string",
                                        D: "false",
                                        H: ['{[*],"graphType":"Scatter2D"}']
                                    },
                                    connections: {
                                        C: "Array to store connections in circular graphs<br>",
                                        H: ['{"data":"RandomCircular:4:8:2:3","segregateVariablesBy":["Ring"],"connections":[["red","S1","S4"],["blue","S2","S5"],["green","S3","S6"]]}'],
                                        D: "[]",
                                        T: "array",
                                        M: "Circular Graphs"
                                    },
                                    lineErrorType: {
                                        M: "Line Graphs",
                                        C: "Line error type in the line graphs. The line type must be spline for the area error type. <br>",
                                        O: ["bar", "area"],
                                        D: "bar",
                                        T: "option",
                                        H: ['{[*],"data":"Random:1:80:0:4","groupingFactors":["Factor4"],"graphType":"Line","lineType":"spline","setMinX":18}']
                                    },
                                    gradient: {
                                        C: "Flag used to apply gradients to all objects in the graphs.<br>",
                                        M: "Gradients",
                                        S: ["gradientType"],
                                        H: ['{[*],"data":"Random:1:3:0:0"}'],
                                        T: "boolean",
                                        D: "false"
                                    },
                                    offline: {
                                        C: "Flag to work offline<br>",
                                        T: "boolean",
                                        M: "Debug",
                                        D: "false"
                                    },
                                    isBoxplotCalc: {
                                        C: "Flag to indicate if the iqr has been calculated when the graph type is Boxplot.<br>",
                                        M: "Data",
                                        T: "boolean",
                                        D: "false",
                                        Z: "true"
                                    },
                                    datafilterEffectIn: {
                                        D: "holeOut",
                                        T: "string",
                                        M: "Effect",
                                        C: "datafilterEffectIn<br>",
                                        H: ["{[*]}"]
                                    },
                                    networkVendor: {
                                        D: "false",
                                        Z: "true",
                                        T: "string",
                                        M: "Network Graphs",
                                        C: "Network vendor<br>"
                                    },
                                    showVariableNames: {
                                        D: "true",
                                        T: "boolean",
                                        H: ["{[*]}"],
                                        U: ["Heatmap"],
                                        M: "Variables",
                                        C: "Flag to show the variable names in one dimensional plots<br>"
                                    },
                                    hullScale: {
                                        M: "Network Communities",
                                        T: "float",
                                        D: "1.25",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:karate","showNetworkCommunities":true,"calculateNetworkCommunities":true}'],
                                        C: "Scaling factor for extension of the hulls in the network communities<br>"
                                    },
                                    marginTop: {
                                        D: "5",
                                        T: "integer",
                                        M: "Margins",
                                        C: "Specifies the length in pixels for the top margin in the canvas.<br>",
                                        H: ['{[5,100],"data":"Random:1:3"}']
                                    },
                                    backgroundType: {
                                        S: ["backgroundImage", "gradientOrientation", "colorScheme"],
                                        M: "Foreground and Background",
                                        C: "Specifies the style for the background of the canvas. The canvas background is composed of a frame with a window where the data is plotted. Either of these elements the may be a solid or gradient color or an image of your choosing. The colorScheme property will be used If gradient is specified.<br>",
                                        O: ["solid", "gradient", "window", "windowGradient", "windowSolidGradient", "image", "windowImage"],
                                        D: "solid",
                                        T: "option",
                                        H: ['{[*],"backgroundImage":"https://www.canvasxpress.org/assets/images/nanotube.jpg"}']
                                    },
                                    ganttCompletion: {
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}'],
                                        T: "option",
                                        D: "false",
                                        O: ["false"],
                                        C: "Variable annotation in the x object to use in Gantt plots as completion percentage. Must be a value between 0 and 1.<br>",
                                        M: "Gantt Charts",
                                        X: "getXData"
                                    },
                                    ganttDependencyEnd: {
                                        C: "Variable annotation for the type of ending for the dependency line. Options are 'arrow', 'square' or 'round'.<br>",
                                        M: "Gantt Charts",
                                        X: "getXData",
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}'],
                                        T: "option",
                                        D: "false",
                                        O: ["false"]
                                    },
                                    blindnessType: {
                                        H: ['{[*],"data":"Random:1:6"}'],
                                        D: "false",
                                        T: "string",
                                        O: ["false", "protanopia", "deuteranopia", "tritanopia", "monochromatic"],
                                        C: "Color Blindness<br>",
                                        M: "Colors"
                                    },
                                    yAxisShow: {
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "true",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"],
                                        C: "Flag to show on not the values of the ticks in the Y axis<br>",
                                        M: "Y-Axis"
                                    },
                                    boxplotType: {
                                        C: "Boxplot type<br>",
                                        M: "Boxplot Graphs",
                                        O: ["boxWhiskers", "range"],
                                        H: ['{[*],"data":"Random:2:12:0:1:1:100:0:false:normal:50:10","groupingFactors":["Factor1"]}'],
                                        T: "option",
                                        D: "boxWhiskers"
                                    },
                                    missingDataValue: {
                                        M: "Missing Data",
                                        T: "string",
                                        D: "NA",
                                        C: "String value use to specify missing data<br>"
                                    },
                                    titleFontSize: {
                                        M: "Titles and Subtitles",
                                        C: "Font size for the title of the graph. The font height will be adjusted automatically to fit in the canvas.<br>",
                                        S: ["title", "titleColor"],
                                        D: "16",
                                        T: "integer",
                                        H: ['{[*],"title":"Graph Title","autoScaleFont":false}']
                                    },
                                    lineType: {
                                        O: ["rect", "solid", "spline", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        D: "rect",
                                        T: "option",
                                        H: ['{[*],"data":"Random:4:6","graphType":"Line"}'],
                                        M: "Line Graphs",
                                        C: "Type of line used to join the points in line graphs<br>"
                                    },
                                    circularScalesAlign: {
                                        M: "Circular Graphs",
                                        C: "Position to align the percent and radial axes in circular plot<br>",
                                        O: ["inside", "outside"],
                                        D: "inside",
                                        T: "option",
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularScalesAlign":"outside","ringsOrder":["ideogram","scale"]}', '{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularScalesAlign":"inside","ringsOrder":["scale","ideogram"]}']
                                    },
                                    dataTableTransposed: {
                                        C: "Flag to transpose the data in the data table<br>",
                                        M: "Data Table",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    rAxisShow: {
                                        M: "R-Axis",
                                        T: "boolean",
                                        D: "true",
                                        H: ['{[*],"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}'],
                                        C: "Flag to show on not the values of the ticks in the R axis<br>"
                                    },
                                    totalCols: {
                                        D: "null",
                                        Z: "true",
                                        M: "Data Table",
                                        T: "integer",
                                        C: "Total columns in the data table<br>"
                                    },
                                    zoomSamplesDisable: {
                                        S: ["zoomVariablesDisable"],
                                        M: "Zooming, Panning and Resizing",
                                        C: "Flag to disable zooming in all plots<br>",
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"graphType":"Heatmap"}', '{[*],"graphType":"Heatmap"}']
                                    },
                                    sankeyNodeWidth: {
                                        C: "Width for the Sankey nodes<br>",
                                        H: ['{[*],"data":"RandomSankey","graphType":"Sankey"}'],
                                        M: "Sankey Diagrams",
                                        T: "integer",
                                        D: "20"
                                    },
                                    kaplanMeierBy: {
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"data":"RandomKaplanMeier","showDecorations":true,"graphType":"Scatter2D","showLegend":false,"functions":["addKaplanMeierCurve:Time:Censored-1:Data 1 Population:rgb(0,0,255)","addKaplanMeierCurve:Time:Censored-2:Data 2 Population:rgb(255,0,0)"]}'],
                                        O: ["false"],
                                        M: "Error Bars and Confidence Intervals",
                                        C: "Name of a sample annotation to create multiple Kaplan Meier plots.<br>",
                                        X: "getXZData"
                                    },
                                    dataexplorerEffectOut: {
                                        D: "holeOut",
                                        M: "Effect",
                                        T: "string",
                                        H: ["{[*]}"],
                                        C: "dataexplorerEffectOut<br>"
                                    },
                                    ratioSampleReference: {
                                        C: "Name of the sample used in ratio transformation. Almost 'private' parameters used within the different CanvasXpress UIs.<br>",
                                        M: "Data",
                                        X: "getSamplesAsArray",
                                        T: "option",
                                        D: "false",
                                        O: ["false"]
                                    },
                                    tooltipDivEffectIn: {
                                        D: "holeOut",
                                        T: "string",
                                        M: "Effect",
                                        C: "tooltipDivEffectIn<br>",
                                        H: ["{[*]}"]
                                    },
                                    trackNameFontSize: {
                                        D: "10",
                                        M: "Genome Browser",
                                        T: "integer",
                                        C: "Size in pixels for the font size of text of the tracks in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    tagCloudMask: {
                                        H: ["{[*]}"],
                                        C: "Add a shadow for the selected shape<br>",
                                        M: "Tag Cloud",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    smpTitleFontColor: {
                                        C: "Font color for the sample title in one dimensional plots<br>",
                                        H: ['{[*],"smpTitle":"Sample Title"}'],
                                        T: "color",
                                        M: "Samples",
                                        D: "rgb(0,0,0)"
                                    },
                                    pieLabelType: {
                                        C: "Pie label type to show the percentage of the slice or the actual number<br>",
                                        M: "Pie Charts",
                                        O: ["percentage", "value"],
                                        H: ["{[*]}"],
                                        D: "percentage",
                                        T: "option"
                                    },
                                    outlineBy: {
                                        M: "Data Point Attributes",
                                        C: "Name of the annotation for the outline when drawing a multidimensional Heatmap<br>",
                                        S: ["outlineByData"],
                                        U: ["Heatmap"],
                                        D: "false",
                                        T: "string",
                                        H: ['{"data":"RandomMultidimensional:5:10:1:1","graphType":"Heatmap","outlineBy":"data2"}']
                                    },
                                    useBarnesHutSimulation: {
                                        C: "Flag to use Barnes–Hut simulation<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        M: "Network Algorithm Parameters",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    subtitleScaleFontFactor: {
                                        C: "Scaling factor used to increase or decrease the subtitle font size in the canvas.<br>",
                                        H: ['{[*],"title":"Graph Title","subtitle":"Graph Subtitle"}'],
                                        D: "1",
                                        T: "float",
                                        M: "Titles and Subtitles"
                                    },
                                    histogramSizeEstimator: {
                                        C: "Histogram size estimator<br>",
                                        M: "Histograms",
                                        S: ["createHistogram", "showHistogramDensity"],
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50,"showHistogramDensity":true}'],
                                        D: "sturges",
                                        T: "option",
                                        O: ["sturges", "freedmanDiaconis", "scott"]
                                    },
                                    circularAnchorColor: {
                                        H: ['{[*],"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"]}'],
                                        C: "Default color for the circular anchor.<br>",
                                        T: "color",
                                        M: "Circular Graphs",
                                        D: "rgb(0,0,255)"
                                    },
                                    adjustAspectRatioHeatmapIndicator: {
                                        M: "Heatmap Graphs",
                                        C: "Flag to adjust aspect ratio of heatmap indicator. It depends on the adjustAspectRatio parameter; that is, the adjustAspectRatio parameter has to set to true for the adjustAspectRatioHeatmapIndicator to take effect.<br>",
                                        S: ["adjustAspectRatio"],
                                        T: "boolean",
                                        D: "true",
                                        H: ["{[*]}"]
                                    },
                                    showIdeogram: {
                                        H: ['{[*],"data":"RandomIdeogram:200:10:4:4"}'],
                                        C: "Show Human Chromosome Ideogram. Force plot to be two dimensional.<br>",
                                        D: "false",
                                        T: "boolean",
                                        M: "Circular Graphs"
                                    },
                                    transformBase: {
                                        O: ["2", "10"],
                                        D: "10",
                                        T: "integer",
                                        C: "Default log or exponential transformation for the data.<br>",
                                        Z: "true",
                                        M: "Data"
                                    },
                                    layoutAdjust: {
                                        C: "Flag to force recalculating the ranges in the axes when multiple graphs are displayed in the canvas.<br>",
                                        M: "Combination Plots",
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        D: "false",
                                        T: "option",
                                        O: ["false", "axis", "global", "true"]
                                    },
                                    nodeSize: {
                                        M: "Network Graphs",
                                        T: "integer",
                                        D: "15",
                                        Z: "true",
                                        C: "Approximate pixels for the size of the nodes in the network. Automatically adjusted depending on the numebr of nodes in the network.<br>"
                                    },
                                    repulsiveForceFunction: {
                                        C: "Type of function to apply when calculating repulsive force in forceDirected network layouts. Fruchterman-Reingold uses square while Eades uses log.<br>",
                                        M: "Network Algorithm Parameters",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        D: "square",
                                        T: "option",
                                        O: ["square", "cubic", "log", "pow", "sqrt"]
                                    },
                                    varLabelInterval: {
                                        U: ["Heatmap"],
                                        C: "Interval for the variable labels in heatmaps<br>",
                                        M: "Variables",
                                        H: ["{[*]}"],
                                        D: "1",
                                        T: "integer"
                                    },
                                    sizeEdgeBy: {
                                        C: "Name of the attribute to size the edges.<br>",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","sizeEdgeBy":"kind"}'],
                                        T: "string",
                                        M: "Network Node and Edge Attributes",
                                        D: "false"
                                    },
                                    xAxisMajorTicks: {
                                        M: "X-Axis",
                                        T: "boolean",
                                        D: "true",
                                        C: "A flag to show Major tick lines in the X axis<br>",
                                        H: ["{[*]}"]
                                    },
                                    oncoprintColSummary: {
                                        M: "Oncoprint Graphs",
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to show column summary in oncoprints.<br>",
                                        H: ["{[*]}"]
                                    },
                                    segregateSamplesBy: {
                                        H: ['{"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}', '{"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1","Factor2"]}'],
                                        C: "An array that holds the annotation(s) used to segregate the samples. It must be categories in the 'data.x' object<br>",
                                        M: "Data",
                                        T: "array",
                                        D: "[]"
                                    },
                                    mapColor: {
                                        D: "rgb(105,210,230)",
                                        M: "Maps",
                                        T: "color",
                                        H: ["{[*]}"],
                                        C: "Color for the maps<br>"
                                    },
                                    datatableEffectOut: {
                                        D: "holeOut",
                                        T: "string",
                                        M: "Effect",
                                        H: ["{[*]}"],
                                        C: "datatableEffectOut<br>"
                                    },
                                    isReproducibleResearch: {
                                        C: "Flag to indicate to track user modifications for Reproducible Research. For developers only.<br>",
                                        H: ['{[*],"groupingFactors":["Factor1"]}'],
                                        D: "true",
                                        M: "General",
                                        T: "boolean"
                                    },
                                    isOncoprint: {
                                        C: "Boolean flag to draw an oncoprint<br>",
                                        M: "Oncoprint Graphs",
                                        T: "boolean",
                                        Z: "true",
                                        D: "false"
                                    },
                                    transposeData: {
                                        M: "Data",
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to transpose data as a parameter. This parameter accomplishes the same as the function transpose at load time.<br>",
                                        H: ['{[*],"data":"Random:4:8:2:2"}']
                                    },
                                    outlineByShowLegend: {
                                        D: "true",
                                        M: "Data Point Attributes",
                                        T: "boolean",
                                        C: "Flag to show the outlineBy legend<br>",
                                        H: ['{[*],"data":"RandomMultidimensional:5:10:1:1","graphType":"Heatmap","outlineBy":"data2","outlineBy":"DataOutline"}']
                                    },
                                    marginBottom: {
                                        C: "Specifies the length in pixels for the bottom margin in the canvas.<br>",
                                        H: ['{[5,100],"data":"Random:1:3"}'],
                                        D: "5",
                                        T: "integer",
                                        M: "Margins"
                                    },
                                    movable: {
                                        C: "Flag to disable moving the canvas by dragging the mouse from the move image in the toolbar<br>",
                                        H: ["{[*]}"],
                                        M: "Events",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    mapId: {
                                        D: "false",
                                        T: "string",
                                        M: "Maps",
                                        C: "Map Id for the map div in the DOM<br>"
                                    },
                                    broadcast: {
                                        D: "true",
                                        T: "boolean",
                                        M: "Events",
                                        H: ["{[*]}"],
                                        C: "Flag to enable broadcasting to other canvasXpress objects in the page<br>"
                                    },
                                    sortData: {
                                        C: "Array of arrays with sorting functions. Each function takes three parameters. The first parameter must be either 'smp' to identify the parameters are related to the samples, 'var' to identify  the parameters are related to the variables, or 'cat' to identify a sample or variable category. The second parameter can be either 'smp' to indicate to sort the sample indices or 'var' to indicate to sort the variable indices. The third parameter is the value for the key referenced by the first parameter. A special case for this parameter could be 'samples' or 'variables' to indicate to sort by the names of the samples or variables respectively. Here are some examples to sort the samples in the data: [ ['cat', 'smp', 'Factor1'] ]   : Sort the samples by the sample category 'Factor1' [ ['var', 'smp', 'Variable1'] ] : Sort the samples by the value of the 'Variable1' [ ['cat', 'smp', 'samples'] ]   : Sort the samples by their name.  Important!!!! This parameter will clean the data and remove any variables not used in the dataset at load time.<br>",
                                        T: "object",
                                        M: "Data sorting",
                                        D: "[]"
                                    },
                                    ungroupSamples: {
                                        C: "Ungroup samples previously grouped according to a sample category (data.x object)<br>",
                                        M: "Functions",
                                        T: "void",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"],
                                        S: ["groupSamples"]
                                    },
                                    histogramDensityFillTransparency: {
                                        C: "Transparency applied to the filled histogram density<br>",
                                        H: ['{[0.2,0.5],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50}'],
                                        D: "0.6",
                                        T: "float",
                                        M: "Histograms"
                                    },
                                    oncoprintMUT: {
                                        H: ['{"data":"RandomMultidimensional:5:10","oncoprintMUT":"data2"}'],
                                        C: "String to identify the data object to use to draw the mutations. For example missense, non-synonymous, truncating, etc. Each level will be colored in a shade of green.<br>",
                                        T: "boolean",
                                        M: "Oncoprint Graphs",
                                        D: "false"
                                    },
                                    varTitleScaleFontFactor: {
                                        C: "Scaling factor used to increse or decrease variable font size in the canvas.<br>",
                                        M: "Variables",
                                        U: ["Heatmap"],
                                        H: ['{[*],"varTitle":"Variable Title"}'],
                                        D: "1",
                                        T: "float"
                                    },
                                    showLegendTitle: {
                                        H: ["{[*]}"],
                                        C: "Flag to show or not the legend title in the graphs<br>",
                                        D: "true",
                                        M: "Legends",
                                        T: "boolean"
                                    },
                                    axisTickColor: {
                                        C: "Color of the axis ticks.<br>",
                                        H: ["{[*]}"],
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        M: "Axis"
                                    },
                                    variablesKmeaned: {
                                        D: "false",
                                        M: "Clustering",
                                        T: "boolean",
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap"}'],
                                        C: "Configuration property to k-mean variables<br>"
                                    },
                                    showNodeNameSizeThreshold: {
                                        T: "integer",
                                        M: "Network Graphs",
                                        D: "20",
                                        C: "Thereshold used to set the limit to hide or display the name of nodes in a network based on the size of the node. If the number of node size exceed this thereshold then the name will be shown.<br>",
                                        H: ['{[5,50],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    decorationsWidth: {
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large","graphType":"Network","decorationsPosition":"top","showDecorations":true,"decorations":["D1","D2","D3"]}'],
                                        T: "integer",
                                        D: "20",
                                        U: ["Network"],
                                        C: "Length in pixels of the width for the decorations in the networks<br>",
                                        M: "Decorations"
                                    },
                                    sampleSpaceFactor: {
                                        H: ['{[*],"data":"Random:2:4","graphType":"Bar"}'],
                                        T: "integer",
                                        D: "1",
                                        C: "Factor to adjust the spacing between the data points between the samples in the one dimensional graphs. The greater the number, the greater the gap.<br>",
                                        M: "Aspect Ratio, Space and width",
                                        S: ["widthFactor", "variableSpaceFactor"]
                                    },
                                    treeLinkWidth: {
                                        H: ["{[*]}"],
                                        C: "Width for the Tree lines<br>",
                                        M: "Trees",
                                        T: "integer",
                                        D: "1"
                                    },
                                    swimStatus: {
                                        O: ["false"],
                                        H: ['{[*],"data":"Swimmer","graphType":"Bar","barType":"swimmer"}'],
                                        D: "false",
                                        T: "option",
                                        X: "getXData",
                                        C: "Name of sample annotation to use in Swimmer Plot. Defaults to 'Status'. See https://blogs.sas.com/content/graphicallyspeaking/2014/06/22/swimmer-plot/<br>",
                                        M: "Bar Graphs"
                                    },
                                    bandwidthRule: {
                                        M: "Density Plots",
                                        C: "Bandwidth rule <br>",
                                        S: ["createHistogram", "showHistogramDensity"],
                                        D: "nrd0",
                                        T: "option",
                                        H: ['{[*],"data":"Random:200:1","functions":["createHistogram"],"histogramBins":50,"showHistogramDensity":true}'],
                                        O: ["nrd0", "nrd", "silverman"]
                                    },
                                    circularAnchorLength: {
                                        M: "Circular Graphs",
                                        T: "integer",
                                        D: "15",
                                        H: ['{[*],"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"]}'],
                                        C: "Length in pixels of the height of the circular anchor<br>"
                                    },
                                    zRotate: {
                                        H: ['{[0,45],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        C: "Starting number of degrees to rotate graph arround the Z axis<br>",
                                        T: "float",
                                        M: "3D Attributes",
                                        D: "0"
                                    },
                                    connectByNoColor: {
                                        C: "Flag to prevent coloring the lines  by the connectBy annotation. Usefull when connectBy is used along with colorBy to avoid confusion of colors<br>",
                                        H: ['{[*],"graphType":"Dotplot","connectBy":"Factor1"}'],
                                        M: "Data Point Attributes",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    regressionType: {
                                        C: "Type of linear least-squares fitting methods for simple data analysis",
                                        M: "Error Bars and Confidence Intervals",
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addRegressionLine"]}'],
                                        D: "linear",
                                        T: "option",
                                        O: ["linear", "exponential", "logarithmic", "power", "polynomial"]
                                    },
                                    citationScaleFontFactor: {
                                        M: "Citations or References",
                                        T: "float",
                                        D: "1",
                                        C: "Scaling factor used to increase or decrease citation font size in the canvas<br>",
                                        H: ['{[*],"citation":"Graph citation or reference"}']
                                    },
                                    kmeansVarClusters: {
                                        M: "Clustering",
                                        C: "Number of clusters when clustering variable data with kmeans.<br>",
                                        S: ["maxIterations", "kmeansSmpClusters", "kmeansSamples", "kmeansVariables"],
                                        D: "3",
                                        T: "integer",
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap","variablesKmeaned":true}']
                                    },
                                    errorBarsType: {
                                        O: ["standardDeviation", "standardErrorMean", "confidenceInterval95"],
                                        T: "option",
                                        D: "confidenceInterval95",
                                        H: ['{[*],"setMinX":0,"groupingFactors":["Factor1"]}'],
                                        M: "Error Bars and Confidence Intervals",
                                        C: "Type of error bars.<br>"
                                    },
                                    maxOverlayStringLen: {
                                        H: ['{[4,50],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        C: "Maximum length in characters for the sample factor (in the 'data.x' object) or variable annotation (in the 'data.z' object) when included as an overlay. Anything above is truncated.<br>",
                                        T: "integer",
                                        M: "Overlays",
                                        D: "30"
                                    },
                                    remoteDirection: {
                                        M: "Remote Procedures",
                                        C: "Direction parameter used to obtain data remotely.<br>",
                                        S: ["remoteService", "remoteServiceType", "remoteParams"],
                                        T: "option",
                                        D: "next",
                                        O: ["next", "prev"]
                                    },
                                    meterMin: {
                                        H: ['{[*],"graphType":"Meter"}'],
                                        C: "Minimum value in the meter.<br>",
                                        D: "0",
                                        T: "float",
                                        M: "Meter Graphs"
                                    },
                                    showTransition: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Animations and Visualization Transitions",
                                        H: ['{[*],"graphType":"Bar","groupingFactors":["Factor1"]}'],
                                        C: "Flag to show or not transitions for the graphs<br>"
                                    },
                                    networkTheta: {
                                        T: "float",
                                        M: "Network Algorithm Parameters",
                                        D: "0.8",
                                        C: "Theta coefficient from Barnes Hut simulation. Ranged between (0, 1). The closer it's to 1 the more nodes algorithm will have to go through. Setting it to one makes Barnes Hut simulation no different from brute-force forces calculation (each node is considered).<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    maxRows: {
                                        D: "10",
                                        M: "Data Table",
                                        T: "integer",
                                        C: "Maximum number of rows to display in the data table<br>"
                                    },
                                    legendBoxColor: {
                                        C: "Color for the box around the legend<br>",
                                        M: "Legends",
                                        S: ["legendBox"],
                                        H: ["{[*]}"],
                                        T: "color",
                                        D: "rgb(204,204,204)"
                                    },
                                    maxSubMenus: {
                                        H: ["{[*]}"],
                                        C: "Maximum number of submenus in the context menus<br>",
                                        T: "integer",
                                        M: "Events",
                                        D: "22"
                                    },
                                    transform: {
                                        O: ["false", "log2", "log10", "exp2", "exp10", "percentile", "zscore", "ratio", "ratio2", "ratio10", "save", "reset", "undo"],
                                        T: "option",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        S: ["transformType", "ratioReference", "zscoreAxis"],
                                        C: "Transform all the data. Warning: the option 'save' overwrites the original data<br>",
                                        M: "Functions"
                                    },
                                    startRow: {
                                        M: "Data Table",
                                        T: "integer",
                                        D: "0",
                                        Z: "true",
                                        C: "Starting row in the data table<br>"
                                    },
                                    zAxisAbsMin: {
                                        C: "Minimum non-filtered value for the data plotted in the Z axis<br>",
                                        Z: "true",
                                        D: "null",
                                        M: "Z-Axis",
                                        T: "float"
                                    },
                                    featureTranslateShow: {
                                        C: "Flag use to show tranlation<br>",
                                        H: ["{[*]}"],
                                        T: "boolean",
                                        M: "Genome Browser",
                                        D: "true"
                                    },
                                    showDataTableOnSelect: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Data Table",
                                        C: "Flag to indicate to show data after selecting data in the plot<br>"
                                    },
                                    highlightNode: {
                                        D: "[]",
                                        T: "array",
                                        M: "Network Graphs",
                                        C: "Name of nodes in the 'data.nodes' object to highlight.<br>",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","highlightNode":["ND1","ND2"]}']
                                    },
                                    subtitleFontSize: {
                                        C: "Font size for the subtitle of the graph. The font height will be adjusted automatically to fit in the canvas.<br>",
                                        M: "Titles and Subtitles",
                                        S: ["subtitle", "subtitleColor"],
                                        H: ['{[*],"title":"Graph Title","subtitle":"Graph Subtitle","autoScaleFont":false}'],
                                        T: "integer",
                                        D: "14"
                                    },
                                    sequenceBColor: {
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(0,0,0)",
                                        H: ["{[*]}"],
                                        C: "Color for the degenerate C/G/T and asparagines in the genome browser<br>"
                                    },
                                    sankeySource: {
                                        C: "Name of a sample annotation to use as source in the sankey diagrams<br>",
                                        M: "Sankey Diagrams",
                                        X: "getXData",
                                        H: ['{"data":"RandomSankey","graphType":"Sankey","sankeySource":"Source"}', '{"data":"RandomSankey","graphType":"Sankey","sankeySource":"Source2"}'],
                                        D: "false",
                                        T: "option",
                                        O: ["false"]
                                    },
                                    scatterPlotMatrix: {
                                        D: "false",
                                        T: "option",
                                        H: ['{"graphType":"Scatter2D","scatterPlotMatrix":true}'],
                                        M: "Scatter Plot Matrix",
                                        C: "Could be a boolean to plot a matrix of 2D sccaterplots or a sample annotation to color and segregate the plots. <br>",
                                        S: ["scatterPlotMatrixType"],
                                        X: "getXData"
                                    },
                                    showPieSampleLabel: {
                                        C: "A flag to show the sample label when plotting multiple pies<br>",
                                        H: ['{[*],"data":"Random:5:6","xAxis":["S1","S2","S3","S4","S5","S6"],"layout":"2X3"}'],
                                        T: "boolean",
                                        M: "Pie Charts",
                                        D: "true"
                                    },
                                    marginLeft: {
                                        D: "5",
                                        T: "integer",
                                        M: "Margins",
                                        H: ['{[5,100],"data":"Random:1:3"}'],
                                        C: "Specifies the length in pixels for the left margin in the canvas.<br>"
                                    },
                                    highlightVar: {
                                        H: ['{"highlightVar":["V1","V3"]}'],
                                        D: "[]",
                                        T: "array",
                                        C: "Name of variables in the 'data.y' object to highlight.<br>",
                                        M: "Variables",
                                        U: ["Heatmap"],
                                        X: "getVariablesAsArray"
                                    },
                                    zAxisValues: {
                                        M: "Z-Axis",
                                        T: "array",
                                        Z: "true",
                                        D: "[]",
                                        C: "Values for the ticks in the Z axis<br>"
                                    },
                                    configuratorEffectOut: {
                                        C: "configuratorEffectOut<br>",
                                        H: ["{[*]}"],
                                        D: "holeOut",
                                        T: "string",
                                        M: "Effect"
                                    },
                                    showPieValues: {
                                        D: "true",
                                        M: "Pie Charts",
                                        T: "boolean",
                                        H: ["{[*]}"],
                                        C: "A flag to show the values for the pie<br>"
                                    },
                                    codeEffectOut: {
                                        C: "codeEffectOut<br>",
                                        H: ["{[*]}"],
                                        T: "string",
                                        M: "Effect",
                                        D: "holeOut"
                                    },
                                    ellipseBy: {
                                        D: "false",
                                        T: "option",
                                        H: ['{[false,"variable","Annt1"],"data":"Random:30:3:2:2","graphType":"Scatter3D"}'],
                                        O: ["false", "variable"],
                                        M: "Data Point Attributes",
                                        C: "Utility to create error ellipses in Scatter plots<br> @funtion getZData"
                                    },
                                    maxDataExplorerEntries: {
                                        C: "Maximum number of samples or variables to display in the data explorer<br>",
                                        M: "Data Explorer",
                                        T: "integer",
                                        D: "10000"
                                    },
                                    dotplotType: {
                                        O: ["normal", "stacked", "movement"],
                                        D: "normal",
                                        T: "option",
                                        H: ['{[*],"graphType":"Dotplot"}'],
                                        M: "Dotplot Graphs",
                                        C: "Flag to produce normal, stacked or movement dotplot graphs. Movement plot are only applicable when data is grouped.<br>"
                                    },
                                    showVarOverlaysLegend: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Overlays",
                                        C: "Flag to show or not the legend for the variable overlays in the graphs. If set to false the level information will be displayed in the actual colored boxes of the overlays<br>",
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1"],"smpOverlays":["Factor1"]}']
                                    },
                                    violinColor: {
                                        T: "color",
                                        M: "Boxplot Graphs",
                                        D: "false",
                                        C: "Color for the violins. If specified all the violins will have the assigned color; otherwise it will be automatically assigned.<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","showViolinBoxplot":true,"showBoxplotIfViolin":true,"groupingFactors":["Factor1"]}']
                                    },
                                    scatterOutlineThreshold: {
                                        C: "Maximum number of data points before skipping plotting their outline but only the fill color<br>",
                                        H: ['{[10,3],"data":"Random:8:4:2:1","graphType":"Scatter3D","scatterOutlineThreshold":10}'],
                                        D: "50000",
                                        T: "integer",
                                        M: "Scatter Plots"
                                    },
                                    yAxis2Show: {
                                        C: "Flag to show or not the values of the ticks in the Y axis at the right in Scatter plots<br>",
                                        M: "Y-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Correlation"],
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "false"
                                    },
                                    reset: {
                                        M: "Functions",
                                        T: "void",
                                        C: "Reset the canvas<br>"
                                    },
                                    disableDataTable: {
                                        M: "Events",
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to disable showing data table<br>",
                                        H: ["{[*]}"]
                                    },
                                    circularLetterSeparationFactor: {
                                        D: "1.5",
                                        M: "Circular Graphs",
                                        T: "float",
                                        C: "Factor to adjust the spacing between letters in the circular graphs. The greater the number the closer the letters in the labels<br>",
                                        H: ['{[1.5,6],"data":"RandomCircular:4:8:2:3","segregateSamplesBy":["Factor2"]}']
                                    },
                                    oncoprintHeatmapSwitch: {
                                        S: ["showHeatmapOncoprint"],
                                        M: "Oncoprint Graphs",
                                        C: "Flag to show heatmap instead of oncoprint.<br>",
                                        T: "boolean",
                                        D: "false",
                                        H: ["{[*]}", "{[*]}"]
                                    },
                                    toolbarType: {
                                        M: "Events",
                                        C: "Toolbar type",
                                        O: ["over", "under", "fixed"],
                                        D: "under",
                                        T: "option",
                                        H: ["{[*]}"]
                                    },
                                    treeInverted: {
                                        C: "Flag to plot the tree inverted.<br>",
                                        H: ["{[*]}"],
                                        D: "false",
                                        T: "boolean",
                                        M: "Trees"
                                    },
                                    distance: {
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap","samplesClustered":true,"variablesClustered":true}'],
                                        D: "euclidian",
                                        T: "option",
                                        O: ["euclidian", "manhattan", "max"],
                                        C: "Distance metric to use when clustering data.<br>",
                                        M: "Clustering",
                                        S: ["linkage", "clusterSamples", "clusterVariables"]
                                    },
                                    xAxisExact: {
                                        U: ["Scatter3D"],
                                        C: "Flag to force exact values for the data in the X axis<br>",
                                        M: "X-Axis",
                                        H: ['{[*],"graphType":"Scatter3D"}'],
                                        T: "boolean",
                                        D: "false"
                                    },
                                    ganttStart: {
                                        O: ["false"],
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"data":"Gantt","graphType":"Gantt"}'],
                                        X: "getVariablesAsArray",
                                        M: "Gantt Charts",
                                        C: "Variable to use in Gantt plots as start date. Defaults to the first variable in the data set.<br>"
                                    },
                                    trackNameFontColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the text of the tracks in the genome browser<br>",
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        M: "Genome Browser"
                                    },
                                    jitter: {
                                        C: "Flag to jitter the data points in dotplots and boxplots<br>",
                                        M: "Plot area",
                                        U: ["Dotplot", "DotLine", "Boxplot"],
                                        S: ["showBoxplotOriginalData", "boxplotDataPointTransparency", "jitterColumns"],
                                        H: ['{[*],"graphType":"Dotplot","groupingFactors":["Factor1"]}', '{[*],"graphType":"Boxplot","showBoxplotOriginalData":true,"groupingFactors":["Factor1"]}'],
                                        T: "boolean",
                                        D: "true"
                                    },
                                    datatableEffectIn: {
                                        C: "datatableEffectIn<br>",
                                        H: ["{[*]}"],
                                        M: "Effect",
                                        T: "string",
                                        D: "holeOut"
                                    },
                                    varTitleFontSize: {
                                        T: "integer",
                                        D: "12",
                                        H: ['{[*],"varTitle":"VariableTitle","autoScaleFont":false}'],
                                        U: ["Heatmap"],
                                        M: "Variables",
                                        C: "Size for the variable title in one dimensional plots<br>"
                                    },
                                    randomDataTime: {
                                        C: "Flag to create or not time series random data for debug and demonstration purposes<br>",
                                        D: "false",
                                        M: "Random",
                                        T: "boolean"
                                    },
                                    yAxisAbsMax: {
                                        D: "null",
                                        Z: "true",
                                        M: "Y-Axis",
                                        T: "float",
                                        C: "Maximum non-filtered value for the data plotted in the Y axis<br>"
                                    },
                                    isGroupedData: {
                                        C: "Flag to indicate if the data is grouped.<br>",
                                        Z: "true",
                                        D: "false",
                                        M: "Data",
                                        T: "boolean"
                                    },
                                    arrows: {
                                        O: ["arrow", "square", "round"],
                                        D: ["arrow", "square", "round"],
                                        T: "array",
                                        H: ['{"data":"RandomNetwork:1:30:15:1:0:forceDirected","graphType":"Network"}'],
                                        S: ["lines"],
                                        Z: "true",
                                        M: "Lines",
                                        C: "Arrows for the edges (or connections) in network graphs.<br> There are three arrow types: arrow, square and round. They can be at the start or at the end of the line. To specify an arrow at the start of the line include a startArrow property in the edge; to specify an arrow at the end of the line include a endArrow property in the edge. For example in this edge object:<br> <i>{ ..., type : 'line', startArrow : 'square', endArrow : 'arrow', ... }</i><br>"
                                    },
                                    font: {
                                        C: "The combination of font name style and size.<br>",
                                        D: "12px Verdana",
                                        Z: "true",
                                        T: "font",
                                        M: "Fonts"
                                    },
                                    rAxisAbsMax: {
                                        T: "float",
                                        M: "R-Axis",
                                        D: "null",
                                        Z: "true",
                                        C: "Maximum non-filtered value for the data plotted in the R axis<br>"
                                    },
                                    overlayScaleFontFactor: {
                                        C: "Scaling factor used to increse or decrease overlays font size in the canvas in one dimensional plots<br>",
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        M: "Overlays",
                                        T: "float",
                                        D: "1"
                                    },
                                    citationFontSize: {
                                        M: "Citations or References",
                                        T: "integer",
                                        D: "7",
                                        C: "Size for the text of the reference citation of the graph<br>",
                                        H: ['{[*],"citation":"Graph citation or reference","autoScaleFont":false}']
                                    },
                                    motionCurrentFont: {
                                        T: "font",
                                        M: "Fonts",
                                        Z: "true",
                                        D: "20px Verdana",
                                        C: "Font for the text in motion charts<br>"
                                    },
                                    showCode: {
                                        M: "Debug",
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to show code for the canvas.<br>"
                                    },
                                    autoScaleFont: {
                                        H: ['{[*],"title":"Graph Title"}'],
                                        T: "boolean",
                                        D: "true",
                                        S: ["smpLabelFontSize", "varLabelFontSize", "legendFontSize", "axisTickFontSize", "axisTitleFontSize"],
                                        C: "Flag to automatically adjust the font size in many visualization. Please be aware that scaling factors can still modify the font size. This flag needs to be false for the text to accept the specified font size.<br>",
                                        M: "Text"
                                    },
                                    swimEnd: {
                                        O: ["false"],
                                        H: ['{[*],"data":"Swimmer","graphType":"Bar","barType":"swimmer"}'],
                                        D: "false",
                                        T: "option",
                                        X: "getVariablesAsArray",
                                        C: "Variable to use in Swimmer Plot. Defaults to the third variable in the data set. See https://blogs.sas.com/content/graphicallyspeaking/2014/06/22/swimmer-plot/<br>",
                                        M: "Bar Graphs"
                                    },
                                    sankeyColor: {
                                        H: ['{[*],"data":"RandomSankey","graphType":"Sankey"}'],
                                        C: "The default color for the sankey lines (links)<br>",
                                        D: "rgba(150,150,150,0.5)",
                                        T: "color",
                                        M: "Sankey Diagrams"
                                    },
                                    panningGlobalY: {
                                        C: "Cumulative number of unit to pan the network in the Y dimension<br>",
                                        T: "float",
                                        M: "Zooming, Panning and Resizing",
                                        Z: "true",
                                        D: "0"
                                    },
                                    varLabelScaleFontFactor: {
                                        U: ["Heatmap"],
                                        M: "Variables",
                                        C: "Scaling factor used to increse or decrease variable font size in the canvas.<br>",
                                        D: "1",
                                        T: "float",
                                        H: ["{[*]}"]
                                    },
                                    lineThickness: {
                                        H: ['{[*],"graphType":"Line"}'],
                                        D: "1",
                                        T: "float",
                                        C: "Default thickness in pixels for the lines in line plots.<br>",
                                        M: "Lines",
                                        S: ["outlineWidth"]
                                    },
                                    heatmapAutoAdjust: {
                                        D: "false",
                                        M: "Heatmap Graphs",
                                        T: "boolean",
                                        H: ['{[*],"graphType":"Heatmap"}'],
                                        C: "Flag to adjust the range of the heatmaps when zooming in/out<br>"
                                    },
                                    xAxisCurrent: {
                                        D: "0",
                                        T: "integer",
                                        H: ['{[0,1],"xAxis":["S1","S2"],"yAxis":["S3","S4","S5"],"graphType":"Scatter2D","xAxisCurrent":0}'],
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        M: "X-Axis",
                                        C: "Index (zero-based) of the sample that is currently displayed in the X axis when there are more series in the Y axis than in the X axis in an Scarrter2D plot or when there are multiple series in an ScatterBubble2D plot. Use ctrl + arrow keys to cycle through data series.<br>"
                                    },
                                    rAxisTicks: {
                                        D: "5",
                                        T: "integer",
                                        M: "R-Axis",
                                        C: "Number of ticks in the R axis<br>",
                                        H: ['{[*],"data":"RandomCircular2:4:8:2:3","rAxis":"Number","segregateVariablesBy":["Ring"],"segregateSamplesBy":["Factor2"]}']
                                    },
                                    ideogram: {
                                        D: "hg38",
                                        T: "option",
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"]}'],
                                        O: ["hg19", "hg38"],
                                        M: "Circular Graphs",
                                        C: 'Ideogram. Additional ideograms can be loaded by appending to the CanvasXpress.chromosomes object. The format of the ideogram is based on the R data for \'USCS.hg19.chr\'<br> CanvasXpress.chromosomes = {<br> &nbsp;&nbsp;hg19 : {<br> &nbsp;&nbsp;&nbsp;&nbsp;order : [ 1, 2, 3, 4, 5, 6, 7, 8, ...],<br> &nbsp;&nbsp;&nbsp;&nbsp;data : {<br> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1 : [ [ 0, 2300000, "p36.33", "gneg" ], ...],<br> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2 : [ [ 0, 4300000, "p25.3", "gneg" ],  ...],<br> &nbsp;&nbsp;&nbsp;&nbsp;}<br> &nbsp;&nbsp;}<br> }'
                                    },
                                    standardDeviationType: {
                                        M: "Error Bars and Confidence Intervals",
                                        C: "Type of Standard Deviation. 'biased' uses n as denominator and 'unbiased' uses (n - 1) as denominator where n is the number of values<br>",
                                        O: ["biased", "unbiased"],
                                        T: "option",
                                        D: "unbiased",
                                        H: ['{[*],"setMinX":0,"groupingFactors":["Factor1"]}']
                                    },
                                    citation: {
                                        M: "Citations or References",
                                        C: "A reference citation of the graph which is placed at the bottom right corner<br>",
                                        S: ["citationColor"],
                                        D: "false",
                                        T: "string",
                                        H: ['{"citation":"Graph citation or reference"}']
                                    },
                                    featureNameFontStyle: {
                                        M: "Genome Browser",
                                        C: "Font style for the feature name.<br>",
                                        D: "",
                                        T: "option",
                                        H: ["{[*]}"],
                                        O: ["", "bold", "italic", "bold italic"]
                                    },
                                    correlationType: {
                                        O: ["diamond", "circle"],
                                        H: ['{[*],"data":"Random:4:8"}'],
                                        T: "option",
                                        D: "diamond",
                                        C: "Shape to use in the correlation graphs<br>",
                                        M: "Correlation Graphs"
                                    },
                                    showSampleNames: {
                                        D: "true",
                                        M: "Samples",
                                        T: "boolean",
                                        H: ["{[*]}"],
                                        C: "Flag to show the sample names in one dimensional plots.<br>"
                                    },
                                    view: {
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "canvas",
                                        O: ["canvas", "table", "layout"],
                                        C: "Specify the starting view of the data<br>",
                                        M: "General"
                                    },
                                    invertGraph: {
                                        D: "false",
                                        M: "General",
                                        T: "boolean",
                                        C: "Flag to invert horizontal one dimensional graphs to plot from right to left<br>",
                                        H: ['{[*],"graphType":"Bar","graphOrientation":"horizontal"}']
                                    },
                                    timeFormat: {
                                        D: "isoDate",
                                        M: "Time Series",
                                        T: "option",
                                        C: "Time Format according to date.format.js Steven Levithan <stevenlevithan.com><br>",
                                        O: ["default", "shortDate", "mediumDate", "longDate", "fullDate", "shortTime", "mediumTime", "longTime", "isoDate", "isoTime", "isoDateTime", "isoUtcDateTime", "year", "month", "day", "hour", "minute", "second"]
                                    },
                                    yAxisTicks: {
                                        C: "Number of ticks in the Y axis<br>",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "integer",
                                        M: "Y-Axis",
                                        D: "5"
                                    },
                                    disableKeys: {
                                        D: "false",
                                        M: "Events",
                                        T: "boolean",
                                        C: "Flag to disable key binding events. This prevent some default browser shortcuts and it is system specific. Please see the Event section bellow.<br>",
                                        H: ["{[*]}"]
                                    },
                                    showAnimation: {
                                        C: "Flag to show or not animation for the graphs<br>",
                                        H: ['{[*],"graphType":"Network"}'],
                                        M: "Animations and Visualization Transitions",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    guidesWidth: {
                                        D: "1",
                                        M: "Plot area",
                                        T: "float",
                                        H: ['{[*],"graphType":"Bar","guides":true}'],
                                        C: "The width for the thin line that appears in the middle of the variables and / or samples in one dimensional graphs and multidimensional heatmaps just for aesthetics.<br>"
                                    },
                                    titleFontStyle: {
                                        M: "Titles and Subtitles",
                                        C: "Font style for the title.<br>",
                                        D: "",
                                        T: "option",
                                        H: ['{[*],"title":"Graph Title"}'],
                                        O: ["", "bold", "italic", "bold italic"]
                                    },
                                    connectByData: {
                                        T: "object",
                                        M: "Data Point Attributes",
                                        D: "{}",
                                        Z: "true",
                                        C: "Internal object with connectBy data<br>"
                                    },
                                    canvasBox: {
                                        S: ["canvasBoxColor"],
                                        C: "Flag to draw a box around the canvas<br>",
                                        M: "General",
                                        H: ["{[*]}"],
                                        D: "false",
                                        T: "boolean"
                                    },
                                    colWidth: {
                                        T: "integer",
                                        M: "Data Table",
                                        D: "100",
                                        C: "Mumber of pixels for the width of cells in the data table<br>"
                                    },
                                    showBoxplotIfViolin: {
                                        H: ['{[*],"data":"Random:2:12:0:2","showViolinBoxplot":true,"groupingFactors":["Factor1"]}'],
                                        C: "Flag to show boxplots when violin plot are show. It does not affect anything unless violins are shown.<br>",
                                        T: "boolean",
                                        M: "Boxplot Graphs",
                                        D: "true"
                                    },
                                    xAxisRugShow: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        C: "Flag to indicate whether to show a rug for the data in the X axis<br>",
                                        M: "X-Axis",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "false"
                                    },
                                    varTitle: {
                                        T: "string",
                                        D: "false",
                                        H: ['{"varTitle":"Variable Title"}'],
                                        U: ["Heatmap"],
                                        M: "Variables",
                                        C: "Title for the sample axis in one dimensional plots<br>"
                                    },
                                    regressionOrder: {
                                        M: "Error Bars and Confidence Intervals",
                                        T: "integer",
                                        D: "2",
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","regressionType":\'polynomial",functions":["addRegressionLine"]}'],
                                        C: "Specifies the number of degrees to solve for in polynomial regressions<br>"
                                    },
                                    sizes: {
                                        T: "array",
                                        D: [8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48],
                                        H: ['{"data":"Random:16:3:16:0","graphType":"Scatter3D","sizeBy":"Annt1"}'],
                                        O: ["8", "10", "12", "14", "16", "18", "20", "22", "24", "26", "28", "30", "32", "34", "36", "38", "40", "42", "44", "46", "48", "50", "52", "54"],
                                        M: "General Attributes",
                                        C: "Array with sizes used invisualizations. The order will dictate the utilization in the visualization.<br>"
                                    },
                                    sequenceFont: {
                                        Z: "true",
                                        D: "12px Verdana",
                                        T: "font",
                                        M: "Fonts",
                                        C: "inititalizeConfig     * Initialize configurations<br> @param void @returns void"
                                    },
                                    vennGroups: {
                                        H: ['{[2,3,4],"data":"RandomVenn"}'],
                                        C: "Number of groups in the Venn diagram<br>",
                                        T: "integer",
                                        M: "Venn Diagrams",
                                        D: "4"
                                    },
                                    lineDecoration: {
                                        M: "Line Graphs",
                                        C: "Lines decorations in the line graphs<br>",
                                        D: "symbol",
                                        T: "option",
                                        H: ['{[*],"graphType":"Line"}'],
                                        O: ["false", "dot", "symbol", "pattern"]
                                    },
                                    samplesKmeaned: {
                                        H: ['{[*],"data":"Random:20:20","graphType":"Heatmap"}'],
                                        C: "Configuration property to k-mean samples<br>",
                                        M: "Clustering",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    scatterAxesEqual: {
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        C: "Keep same range in both axes<br>",
                                        M: "Scatter Plots",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    varOverlays: {
                                        X: "getZData",
                                        C: "Variable annotations included in the 'data.z' object used in one dimensional plots<br>",
                                        M: "Overlays",
                                        H: ['{"data":"Random:10:10:3:0","graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"]}'],
                                        T: "array",
                                        D: "[]"
                                    },
                                    guides: {
                                        H: ['{[*],"graphType":"Bar"}'],
                                        T: "option",
                                        D: "false",
                                        O: ["false", "solid", "dotted", "dashed", "dotdash", "longdash", "twodash"],
                                        C: "This is a thin line that appears in the middle of the variables and / or samples in one dimensional graphs and multidimensional heatmaps just for aesthetics.<br>",
                                        M: "Plot area"
                                    },
                                    smpOverlayProperties: {
                                        M: "Overlays",
                                        T: "object",
                                        D: "{}",
                                        C: "Object to assign properties to the variable overlays. The key should be an annotation in the 'data.z' object and the value may contain 'type' which could be either one of the one dimensional graph types or Increase, or Decrease for continuous annotations; 'color' to assign the color for the Bar, Line, etc.; 'level' which is an object where the key is the level and the value is the corresponding color. 'height' to identify how tall the overlay will be<br>"
                                    },
                                    bubbleColor: {
                                        T: "color",
                                        M: "Circular Graphs",
                                        D: "rgba(204,204,204,0.33)",
                                        C: "Default color for the bubbles. Only applicable to the bubble subtype.<br>",
                                        H: ['{[*],"data":"RandomCircular:4:8:2:3","graphType":"Circular","circularType":"bubble","colorBy":"Factor2","hierarchy":["Factor1","Factor2"]}']
                                    },
                                    filterType: {
                                        O: ["and", "or"],
                                        T: "option",
                                        M: "Data Filters",
                                        D: "and",
                                        C: "Type for the filter. Can be 'and' or 'or'.<br>"
                                    },
                                    sizeByData: {
                                        T: "string",
                                        D: "false",
                                        H: ['{"data":"RandomMultidimensional:5:10:1:1","sizeByData":"data3","sizeBy":"Factor"}'],
                                        M: "Data Point Attributes",
                                        C: "String that identify the object containing a two dimensional array with values used to size data points when drawing a multidimensional Heatmap. It must be located within the data.y object (for example: data.y.data3)<br>",
                                        S: ["sizeBy"],
                                        U: ["Heatmap"]
                                    },
                                    removeContour: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        S: ["contourXBinSize", "contourYBinSize", "contourZBinSize", "contourType"],
                                        C: "Remove contour<br>",
                                        T: "void",
                                        M: "Functions"
                                    },
                                    fishTimepoints: {
                                        C: "Fish Timepoints.<br>",
                                        M: "Fish Graphs",
                                        S: ["fishParents", "fishColors"],
                                        H: ['{[*],"graphType":"Fish"}'],
                                        D: "[]",
                                        T: "array"
                                    },
                                    histogramType: {
                                        M: "Histograms",
                                        C: "Type of histogram when multiple series are present<br>",
                                        S: ["createHistogram"],
                                        T: "option",
                                        D: "dodged",
                                        H: ['{[*],"data":"Random:200:3","functions":["createHistogram"]}'],
                                        O: ["dodged", "staggered", "stacked"]
                                    },
                                    transformAxis: {
                                        C: "Default axis to use to transform the data when either z-score or ratio transformation is used.<br>",
                                        M: "Data",
                                        S: ["transformedData", "transformType"],
                                        H: ['{[*],"data":"Random:4:8:2:2","transformType":"zscore","transformedData":true}'],
                                        D: "samples",
                                        T: "option",
                                        O: ["samples", "variables"]
                                    },
                                    contourLevelStep: {
                                        C: "Step levels for contours. It is automatically calculated if not defined.<br>",
                                        M: "Contours",
                                        S: ["createContour"],
                                        H: ['{[5,10],"data":"Random:20:20","functions":["createContour"]}'],
                                        T: "integer",
                                        D: "false"
                                    },
                                    images: {
                                        C: "Array of urls of images used in scatter plots. Additional shapes will be used if the array does not contain as many images as needed.<br>",
                                        M: "General Attributes",
                                        S: ["scatterType"],
                                        H: ['{"data":"Random:8:4:2:1","scatterType":"image","graphType":"Scatter2D","images":["https://www.canvasxpress.org/assets/images/prot.png","https://www.canvasxpress.org/assets/images/prot1.png","https://www.canvasxpress.org/assets/images/prot2.png","https://www.canvasxpress.org/assets/images/prot3.png","https://www.canvasxpress.org/assets/images/prot4.png"]}'],
                                        T: "array",
                                        D: "[]"
                                    },
                                    pieInnerRadius: {
                                        T: "float",
                                        M: "Pie Charts",
                                        D: "0",
                                        C: "Percentage of the radius in the pies to remove to make a donut. It must be a number between 0 to 1<br>",
                                        H: ['{[0.2,0.35,0.5],"data":"Random:4:8"}']
                                    },
                                    fishAxis: {
                                        T: "array",
                                        D: "[]",
                                        H: ['{[*],"graphType":"Fish"}'],
                                        S: ["fishAxisLabels"],
                                        M: "Fish Graphs",
                                        C: "Fish Axis (array with lines across the X Axis)<br>"
                                    },
                                    showShadow: {
                                        M: "Shadows",
                                        C: "Flag used to add shadows to all graph objects in the canvas. It will be forced to false if the browser is IE.<br>",
                                        S: ["shadowOffsetX", "shadowOffsetY", "shadowBlur", "shadowColor"],
                                        T: "boolean",
                                        D: "false",
                                        H: ["{[*]}"]
                                    },
                                    circularArc: {
                                        M: "Circular Graphs",
                                        T: "integer",
                                        D: "360",
                                        C: "Number of degrees to extend the circular graph.<br>",
                                        H: ['{[360,180,90],"data":"Random:1:10","graphType":"Circular","circularType":"sunburst"}']
                                    },
                                    barLollipopOpen: {
                                        C: "Pattern open for th lollipop<br>",
                                        H: ['{[*],"data":"Random:1:8","graphType":"Bar","barType":"lollipop"}'],
                                        D: "false",
                                        T: "boolean",
                                        M: "Bar Graphs"
                                    },
                                    axisTitleScaleFontFactor: {
                                        D: "1",
                                        T: "float",
                                        M: "Axis",
                                        H: ['{[*],"xAxisTitle":"Axis Title"}'],
                                        C: "Scaling factor used to increase or decrease title font size in the canvas in one, two and three dimensional plots<br>"
                                    },
                                    smpLabelFontColor: {
                                        M: "Samples",
                                        T: "color",
                                        D: "rgb(0,0,0)",
                                        H: ["{[*]}"],
                                        C: "Font color for the sample labels in one dimensional plots<br>"
                                    },
                                    ringsOrder: {
                                        D: "[]",
                                        T: "array",
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularLabelsAlign":"inside","ringsOrder":["chromosomes","labels","ideogram"]}', '{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularLabelsAlign":"outside","ringsOrder":["scale","ideogram","labels"]}'],
                                        S: ["ringOrder"],
                                        M: "Circular Graphs",
                                        C: "Array containing the order of the rings. The array includes the levels of the factor specified as either segregateSamplesBy when show the ideogram or segregateVariablesBy when there is no ideogram. It may also include any of the following terms: 'dendrogram', 'ideogram', 'labels', 'scale', 'percent' and 'data'. If there are sample overlays, the array may also contain any of the factor names include in the this.data.x object. This array supersede any other configurations for example for the sample overlays. CanvasXpress will honored all other configurations if left empty.<br>"
                                    },
                                    layoutAxis: {
                                        C: "Flag to indicated whether to print axes values when multiple graphs are displayed in the canvas. The possible values are: 1: horizontal, 2: vertical, 3: both<br>",
                                        M: "Combination Plots",
                                        Z: "true",
                                        T: "option",
                                        D: "3",
                                        O: ["1", "2", "3"]
                                    },
                                    boxplotColor: {
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}'],
                                        C: "Color for the boxplot if individual data points are shown.<br>",
                                        M: "Boxplot Graphs",
                                        T: "color",
                                        D: "false"
                                    },
                                    pieColors: {
                                        D: "[]",
                                        T: "array",
                                        M: "Pie Charts",
                                        C: "Pie Colors. Defaults to the parameter colors.<br>",
                                        H: ['{"data":"Random:4:8","graphType":"Pie","pieColors":["rgb(0,0,117)","rgb(117,0,36)","rgb(117,88,0)","rgb(53,117,0)","rgb(76,0,117)","rgb(117,53,0)","rgb(117,117,0)","rgb(0,117,117)","rgb(117,0,0)","rgb(117,97,0)","rgb(28,0,117)","rgb(0,117,0)","rgb(117,0,117)","rgb(117,67,0)","rgb(97,117,0)","rgb(0,66,117)","rgb(50,0,117)","rgb(117,33,0)","rgb(117,107,0)","rgb(0,117,67)","rgb(117,0,66)","rgb(117,78,0)","rgb(78,117,0)","rgb(0,36,117)"]}']
                                    },
                                    y3DRatio: {
                                        C: "Value between 0 - 1 for adjusting the 3D of the Y Axis<br>",
                                        M: "3D Attributes",
                                        U: ["Scatter3D", "Bar"],
                                        H: ['{[0.5,1],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        D: "1",
                                        T: "float"
                                    },
                                    maxIterations: {
                                        D: "500",
                                        M: "Clustering",
                                        T: "integer",
                                        C: "Number of maximum iterations when clustering data with kmeans for one dimensional graphs or maximum number of iterations when calculating force direct layout networks.<br>",
                                        S: ["kmeansVarClusters", "kmeansSmpClusters", "kmeansSamples", "kmeansVariables"]
                                    },
                                    correlationAxis: {
                                        M: "Correlation Graphs",
                                        C: "Axis used for the correlation.<br>",
                                        O: ["samples", "variables"],
                                        D: "samples",
                                        T: "option",
                                        H: ['{[*],"data":"Random:4:8"}']
                                    },
                                    setMaxX2: {
                                        U: ["AreaLine", "BarLine", "StackedLine", "StackedPercentLine"],
                                        C: "Maximum value to set the data in the 2nd axis<br>",
                                        M: "X-Axis2",
                                        H: ['{[20,50,null],"data":"Random:4:8","graphType":"BarLine","xAxis2":["V1","V2"],"xAxis":["V3","V4"]}'],
                                        T: "float",
                                        D: "null"
                                    },
                                    decorationScaleFontFactor: {
                                        D: "1",
                                        M: "Decorations",
                                        T: "float",
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        C: "Scaling factor used to increase or decrease decoration font size in the canvas.<br>"
                                    },
                                    setMinZ: {
                                        H: ['{[25,null],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        C: "Minimum value to set the data in the Z axis<br>",
                                        D: "null",
                                        T: "float",
                                        M: "Z-Axis"
                                    },
                                    subtitle: {
                                        S: ["subtitleHeight", "subtitleColor"],
                                        M: "Titles and Subtitles",
                                        C: "Subtitle of the graph.<br>",
                                        D: "false",
                                        T: "string",
                                        H: ['{"title":"Graph Title","subtitle":"Graph Subtitle"}']
                                    },
                                    heatmapCollapse: {
                                        H: ["{[*]}"],
                                        C: "Flag to collapse cells in heatmaps of type circle or hexagon. If true cells are ploted without outline otherwise the outline is the foreground color.<br>",
                                        T: "boolean",
                                        M: "Heatmap Graphs",
                                        D: "false"
                                    },
                                    circularLabelsAlign: {
                                        M: "Circular Graphs",
                                        C: "Position to align the variable and sample names in circular plot<br>",
                                        T: "option",
                                        D: "outside",
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularLabelsAlign":"inside","ringsOrder":["chromosomes","labels","ideogram"]}', '{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularLabelsAlign":"outside","ringsOrder":["scale","ideogram","labels"]}'],
                                        O: ["inside", "outside"]
                                    },
                                    segregateSamples: {
                                        T: "option",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"],
                                        X: "getXData",
                                        S: ["desegregateSamples"],
                                        C: "Segregate samples based on a sample category (data.x object)<br>",
                                        M: "Functions"
                                    },
                                    filterEdgeBy: {
                                        C: "Filter edges by their properties used in network graphs. Used in the CanvasXpress UIs.<br>",
                                        M: "Data Filters",
                                        U: ["Network"],
                                        X: "getEdgeData",
                                        D: "{'cases':[],'comp':[],'op':[],'type':[],'value':[]}",
                                        T: "filter"
                                    },
                                    axisTickFontStyle: {
                                        M: "Axis",
                                        C: "Font style of the axis.<br>",
                                        O: ["", "bold", "italic", "bold italic"],
                                        D: "",
                                        T: "option",
                                        H: ["{[*]}"]
                                    },
                                    xAxisCeilValue: {
                                        C: "Value to ceil the data in the X axis.<br>",
                                        H: ['{[null,60],"graphType":"Dotplot"}', '{[null,60],"graphType":"Scatter2D"}'],
                                        T: "float",
                                        M: "X-Axis",
                                        D: "null"
                                    },
                                    randomNetworkNodes: {
                                        U: ["Network"],
                                        C: "Default number of nodes when creating random networks<br>",
                                        D: "40",
                                        T: "integer",
                                        M: "Random"
                                    },
                                    featureTracesShow: {
                                        H: ["{[*]}"],
                                        C: "Flag use to show traces<br>",
                                        T: "boolean",
                                        M: "Genome Browser",
                                        D: "true"
                                    },
                                    barType: {
                                        H: ['{[*],"data":"Random:1:8","graphType":"Bar","widthFactor":0.1}'],
                                        D: "normal",
                                        T: "option",
                                        O: ["normal", "lollipop", "arrow", "swimmer"],
                                        C: "Flag to produce normal or lollipop bar graphs<br>",
                                        M: "Bar Graphs"
                                    },
                                    barnesHutUpdateQueue: {
                                        M: "Network Algorithm Parameters",
                                        T: "array",
                                        Z: "true",
                                        D: "[]",
                                        C: "Barnes Hut Queue for performance and avoid Javascript GC<br>"
                                    },
                                    markerBy: {
                                        X: "getXData",
                                        C: "Utility to create dynamic markers in Map. It must have a latitude and longitude metadata too.<br>",
                                        M: "Data Point Attributes",
                                        O: ["false", "variable"],
                                        D: "false",
                                        T: "option"
                                    },
                                    showFeatureNameThereshold: {
                                        D: "20",
                                        T: "integer",
                                        M: "Genome Browser",
                                        H: ["{[*]}"],
                                        C: "Threshehold used to set te limit when there are too many features in the genome browser<br>"
                                    },
                                    visiumFixedAspectRatio: {
                                        M: "Scatter Plots",
                                        T: "boolean",
                                        D: "true",
                                        C: "Fix aspect ratio for visium plots.<br>",
                                        H: ['{[*],"graphType":"Scatter2D"}']
                                    },
                                    yAxisHistogramShow: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        C: "Flag to indicate whether to show a histogram for the data in the Y axis<br>",
                                        M: "Y-Axis",
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        D: "false",
                                        T: "boolean"
                                    },
                                    nodeFontColor: {
                                        C: "Color for the network text<br>",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        M: "Network Graphs",
                                        T: "color",
                                        D: "rgb(0,0,0)"
                                    },
                                    clusterSamples: {
                                        T: "void",
                                        M: "Functions",
                                        C: "Cluster samples based on data and generate a dendrogram on the sample axis. It takes no parameters<br>",
                                        S: ["distance", "linkage", "imputeMethod"],
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "StackedLine", "StackedPercentLine"]
                                    },
                                    legendBackgroundColor: {
                                        S: ["legendBox"],
                                        C: "Color for the legend background<br>",
                                        M: "Legends",
                                        H: ["{[*]}"],
                                        T: "color",
                                        D: "rgba(255,255,255,0)"
                                    },
                                    dataTableColumnWidth: {
                                        C: "setInitialFonts     * Set the initial fonts @param void @returns void",
                                        M: "Data Table",
                                        T: "array",
                                        Z: "true",
                                        D: "[]"
                                    },
                                    remoteAutoPlay: {
                                        D: "false",
                                        T: "boolean",
                                        M: "Remote Procedures",
                                        C: "Flag to automatically iterate over remote data sets<br>"
                                    },
                                    featureNameFontSize: {
                                        H: ["{[*]}"],
                                        C: "Size in pixels for the font size of text of the features in the genome browser<br>",
                                        D: "12",
                                        T: "integer",
                                        M: "Genome Browser"
                                    },
                                    sequenceQColor: {
                                        D: "rgb(0,0,0)",
                                        T: "color",
                                        M: "Genome Browser",
                                        H: ["{[*]}"],
                                        C: "Color for the glutamines in the genome browser<br>"
                                    },
                                    mapOutlineColor: {
                                        D: "rgb(204,204,204)",
                                        M: "Maps",
                                        T: "color",
                                        C: "Color for the outline of the maps<br>",
                                        H: ["{[*]}"]
                                    },
                                    plotBox: {
                                        H: ["{[*]}"],
                                        D: "false",
                                        T: "boolean",
                                        S: ["plotBoxColor"],
                                        C: "Flag to draw a box around the x,y coordinates of the plot<br>",
                                        M: "General"
                                    },
                                    boxplotMean: {
                                        M: "Boxplot Graphs",
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to show mean of data in boxplots<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","boxplotMean":true,"groupingFactors":["Factor1"]}']
                                    },
                                    violinTrim: {
                                        T: "boolean",
                                        M: "Boxplot Graphs",
                                        D: "true",
                                        C: "Flag to trim violin plots<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","showViolinBoxplot":true,"groupingFactors":["Factor1"]}']
                                    },
                                    sequenceWColor: {
                                        C: "Color for the degenerate A/T and tryptophans in the genome browser<br>",
                                        H: ["{[*]}"],
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(0,0,255)"
                                    },
                                    networkConvexHulls: {
                                        C: "Array for the Network community convex hull property object<br>",
                                        Z: "true",
                                        D: "[]",
                                        M: "Network Communities",
                                        T: "array"
                                    },
                                    shapeNodeBy: {
                                        C: "Name of the attribute to shape the nods.<br>",
                                        H: ['{"data":"RandomNetwork:1:20:10:0:0:large","shapeNodeBy":"n"}'],
                                        D: "false",
                                        M: "Network Node and Edge Attributes",
                                        T: "string"
                                    },
                                    showHeatmapIndicator: {
                                        M: "Heatmap Graphs",
                                        T: "boolean",
                                        D: "true",
                                        H: ['{[*],"graphType":"Heatmap"}'],
                                        C: "Flag to show the heatmap color indicator<br>"
                                    },
                                    zAxisTransform: {
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        O: ["false", "log2", "log10", "exp2", "exp10", "percentile"],
                                        M: "Z-Axis",
                                        C: "Transformation for the values in the Z axis.<br>"
                                    },
                                    mapGraticuleShow: {
                                        C: "Show Map Graticule<br>",
                                        H: ["{[*]}"],
                                        M: "Maps",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    genomeResolution: {
                                        C: "Number to adjust the splines curvature<br>",
                                        Z: "true",
                                        M: "Genome Browser",
                                        O: ["low", "medium", "high"],
                                        D: "low",
                                        T: "option"
                                    },
                                    oddColor: {
                                        H: ['{[*],"data":"Random:1:6","blockContrast":true}'],
                                        D: "rgb(255,255,255)",
                                        T: "color",
                                        S: ["blockContrast", "evenColor"],
                                        C: "The color for the odd numbers in samples when the property block contrast is set in one dimensional plots or the color for odd number residues in translations in genome plots.<br>",
                                        M: "Colors"
                                    },
                                    xAxis2Values: {
                                        U: ["AreaLine", "BarLine", "StackedLine", "StackedPercentLine"],
                                        C: "Values for the ticks in the 2nd X axis<br>",
                                        Z: "true",
                                        M: "X-Axis2",
                                        D: "[]",
                                        T: "array"
                                    },
                                    ridgeBy: {
                                        M: "Data Point Attributes",
                                        C: "Utility to create ridgelines in Scatter2D plots<br> @funtion getZData",
                                        T: "option",
                                        D: "false",
                                        H: ['{[false,"Annt1"],"data":"Random:30:3:2:2","graphType":"Scatter2D"}'],
                                        O: ["false"]
                                    },
                                    loessSpan: {
                                        D: "0.8",
                                        M: "Loess",
                                        T: "float",
                                        H: ['{[0.5,0.9],"data":"Random:200:2","graphType":"Scatter2D","showLoessFit":true,"showConfidenceIntervals":true}'],
                                        C: "Loess span. Factor to adjust the gaussian shape of the loess curve. A vaulue between 0 and 1.<br>"
                                    },
                                    groupSamples: {
                                        T: "array",
                                        X: "getXData",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"],
                                        S: ["ungroupSamples"],
                                        C: "Group samples based on a sample category (data.x object)<br>",
                                        M: "Functions"
                                    },
                                    citationFontStyle: {
                                        C: "Font style for the citation.<br>",
                                        M: "Citations or References",
                                        O: ["", "bold", "italic", "bold italic"],
                                        H: ['{[*],"citation":"Graph citation or reference"}'],
                                        D: "",
                                        T: "option"
                                    },
                                    zAxis: {
                                        T: "array",
                                        D: "[]",
                                        H: ['{"data":"Random:10:6","xAxis":["S1","S2"],"yAxis":["S3","S4"],"zAxis":["S5","S6"],"graphType":"ScatterBubble2D"}'],
                                        M: "Z-Axis",
                                        C: "Name of the samples groups or variables to be displayed in the Z axis<br>",
                                        X: "getSamplesAsArray"
                                    },
                                    randomDataMax: {
                                        D: "100",
                                        T: "integer",
                                        M: "Random",
                                        C: "Maxmun value when creating random data<br>"
                                    },
                                    smpHighlightColor: {
                                        D: "rgb(255,0,0)",
                                        M: "Samples",
                                        T: "color",
                                        C: "The color for the higlighted samples.<br>",
                                        H: ['{[*],"highlightSmp":["S1","S3"]}']
                                    },
                                    scaleTextConstantAdd: {
                                        D: "2.0",
                                        Z: "true",
                                        T: "float",
                                        M: "Text",
                                        C: "Constants to autoscale text (extra)<br>"
                                    },
                                    mapGraticuleType: {
                                        M: "Maps",
                                        C: "Map Graticule type<br>",
                                        O: ["dashed", "solid"],
                                        T: "option",
                                        D: "solid",
                                        H: ["{[*]}"]
                                    },
                                    varDendrogramNewick: {
                                        C: "Dendrogram in Newick format for the variables<br>",
                                        D: "false",
                                        M: "Dendrograms",
                                        T: "string"
                                    },
                                    varTitleFontStyle: {
                                        M: "Variables",
                                        C: "Font style for the var title.<br>",
                                        U: ["Heatmap"],
                                        T: "option",
                                        D: "",
                                        H: ['{[*],"varTitle":"Variable Title"}'],
                                        O: ["", "bold", "italic", "bold italic"]
                                    },
                                    sequenceXColor: {
                                        M: "Genome Browser",
                                        T: "color",
                                        D: "rgb(0,0,0)",
                                        H: ["{[*]}"],
                                        C: "Color for the any aminoacid code in the genome browser<br>"
                                    },
                                    heatmapType: {
                                        C: "Type of Heatmap used to overlay a layer on top of an image. Special for spatial transcriptomics.<br>",
                                        M: "Heatmap Graphs",
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "normal",
                                        O: ["normal", "circle", "hexagon"]
                                    },
                                    isNetworkMetrics: {
                                        T: "boolean",
                                        M: "Network Graphs",
                                        D: "false",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"radial","networkRoot":"ND1","showAnimation":true}'],
                                        C: "Flag to calculate all network metrics: betweenness, closeness, eccentricity and degree.<br>"
                                    },
                                    overlayFontSize: {
                                        H: ['{[*],"data":"Random:10:10:3:3","autoScaleFont":false,"graphType":"Heatmap","varOverlays":["Annt1","Annt2","Annt3"],"smpOverlays":["Factor1","Factor2","Factor3"]}'],
                                        C: "Font size for the overlays in one dimensional plots<br>",
                                        D: "12",
                                        M: "Overlays",
                                        T: "integer"
                                    },
                                    boxplotCoef: {
                                        H: ['{[*],"data":"Random:2:12:0:1:1:100:0:false:normal:50:10","groupingFactors":["Factor1"]}'],
                                        C: "Number that determines how far the plot ‘whiskers’ extend out from the box.<br>",
                                        D: "1.5",
                                        M: "Boxplot Graphs",
                                        T: "float"
                                    },
                                    zAxisTickFormat: {
                                        D: "false",
                                        M: "Z-Axis",
                                        T: "string",
                                        C: "Format for the tick values in the Z axis. It could be a string with the sprintf format or an array where the first parameter is the sprintf format and the second parameter is a modification applied to the value before is passed to the sprintf function.<br>",
                                        H: ['{"data":"Random:10:3","graphType":"Scatter3D","zAxisTickFormat":"%.2f cxs"}']
                                    },
                                    binAlignment: {
                                        M: "Plot area",
                                        C: "Alignment for the data points when binned<br>",
                                        O: ["left", "center", "right"],
                                        D: "center",
                                        T: "option",
                                        H: ['{[*],"graphType":"Line"}']
                                    },
                                    decorationsBackgroundColor: {
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        D: "rgba(255,255,255,0)",
                                        T: "color",
                                        S: ["decorationsBox"],
                                        C: "Color for the decoration legend background<br>",
                                        M: "Decorations"
                                    },
                                    randomDataVariableAnnotations: {
                                        D: "2",
                                        T: "integer",
                                        M: "Random",
                                        C: "Default number of variable annotations when creating random data<br>"
                                    },
                                    xAxisAbsMax: {
                                        C: "Maximum non-filtered value for the data plotted in the X axis<br>",
                                        T: "float",
                                        M: "X-Axis",
                                        Z: "true",
                                        D: "null"
                                    },
                                    heatmapVarSeparateBy: {
                                        X: "getZData",
                                        C: "Factor (in the z data object) used to separate the variables in the heatmap. The same factor must be included in the variable overlays.<br>",
                                        M: "Heatmap Graphs",
                                        H: ['{"graphType":"Heatmap","heatmapVarSeparateBy":"Annt1","variablesClustered":true,"varOverlays":["Annt1"]}'],
                                        D: "false",
                                        T: "string"
                                    },
                                    loessSurfaceSteps: {
                                        H: ['{[20,30],"data":"Random:200:3","graphType":"Scatter3D","showLoessFit":true,"loessDegree":1,"showConfidenceIntervals":true}'],
                                        C: "Loess steps. Number of steps to smooth the plane in 3D plots.<br>",
                                        D: "30",
                                        T: "integer",
                                        M: "Loess"
                                    },
                                    axisWilkinsonLoose: {
                                        M: "Axis",
                                        C: "Flag to indicate whether to use loose positioning when using the wilkinson algorithm to position the labels on the axis. There will not be a difference most of the times.<br>",
                                        S: ["axisAlgorithm"],
                                        T: "boolean",
                                        D: "false",
                                        H: ['{[*],"data":"Random:2:4","graphType":"Bar","axisAlgorithm":"wilkinson"}']
                                    },
                                    timeValueProperties: {
                                        T: "object",
                                        M: "Time Series",
                                        Z: "true",
                                        D: "{}",
                                        C: "Object with all the time properties needed to plot the data"
                                    },
                                    treemapBorderColor: {
                                        C: "The color for the treemap header and border<br>",
                                        H: ["{[*]}"],
                                        M: "Treemap Graphs",
                                        T: "color",
                                        D: "rgb(204,204,204)"
                                    },
                                    theme: {
                                        O: ["none", "economist", "excel", "tableau", "stata", "igray", "solarized", "paulTol", "ggplot", "wallStreetJournal", "cx"],
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "none",
                                        C: "Themes for the plot. This parameter will overwrite colors, background, axes, etc<br>",
                                        M: "General"
                                    },
                                    axisExtension: {
                                        D: "0.1",
                                        T: "float",
                                        M: "Axis",
                                        C: "Percentage to extend the values of the data to ensure all the data points are plotted inside and not over the edges of the graph<br>",
                                        H: ['{[0.1,0.2],"graphType":"Scatter2D"}']
                                    },
                                    showLegend: {
                                        C: "Flag to show or not the legend in the graphs<br>",
                                        H: ["{[*]}"],
                                        T: "boolean",
                                        M: "Legends",
                                        D: "true"
                                    },
                                    xAxis2Show: {
                                        T: "boolean",
                                        M: "X-Axis2",
                                        D: "true",
                                        H: ["{[*]}"],
                                        C: "Flag to show on not the values of the ticks in the second X axis<br>"
                                    },
                                    visiumFlip: {
                                        D: "false",
                                        M: "Scatter Plots",
                                        T: "boolean",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        C: "Invert the data in visium plots. <br>"
                                    },
                                    rotationSensitivity: {
                                        H: ['{[*],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        D: "450",
                                        T: "integer",
                                        C: "Factor to adjust the sensitivity of the mouse when rotating the graph<br>",
                                        M: "3D Attributes",
                                        U: ["Scatter3D"]
                                    },
                                    sequenceDColor: {
                                        H: ["{[*]}"],
                                        C: "Color for the degenerate A/G/T and aspartic acids in the genome browser<br>",
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,0,0)"
                                    },
                                    xAxis2Ticks: {
                                        C: "Number of ticks in the 2nd X axis. It is the same as xAxisTicks.<br>",
                                        D: "5",
                                        Z: "true",
                                        T: "integer",
                                        M: "X-Axis2"
                                    },
                                    dataTableStyle: {
                                        O: ["false", "stripped"],
                                        C: "Data table style<br>",
                                        M: "Data Table",
                                        T: "option",
                                        D: "false"
                                    },
                                    xAxis2AbsMax: {
                                        C: "Minimum non-filtered value for the data plotted in the 2nd X axis<br>",
                                        T: "float",
                                        M: "X-Axis2",
                                        Z: "true",
                                        D: "null"
                                    },
                                    imputeMethod: {
                                        S: ["distance", "linkage", "clusterSamples", "clusterVariables"],
                                        C: "Imputation method for missing data when clustering<br>",
                                        M: "Clustering",
                                        O: ["mean", "median"],
                                        H: ['{[*],"data":"Random:20:20:::::0.15","graphType":"Heatmap","samplesClustered":true,"variablesClustered":true}'],
                                        D: "mean",
                                        T: "option"
                                    },
                                    circularAnchors2Align: {
                                        M: "Circular Graphs",
                                        C: "Position to align the anchors2 in circular plot<br>",
                                        D: "outside",
                                        T: "option",
                                        H: ['{"data":"RandomIdeogram:200:10:4:4","showIdeogram":true,"arcSegmentsSeparation":1,"segregateSamplesBy":["Factor4"],"circularAnchorsAlign":"outside","circularAnchors2Align":"inside","circularLabelsAlign":"inside","ringsOrder":["chromosomes","Annt1","Lev:1","anchors","labels","ideogram","anchors2","Lev:4"]}'],
                                        O: ["inside", "outside"]
                                    },
                                    panningX: {
                                        M: "Zooming, Panning and Resizing",
                                        T: "float",
                                        D: "0",
                                        C: "Number of unit to pan the network in the X dimension<br>"
                                    },
                                    trackNameFont: {
                                        M: "Fonts",
                                        T: "font",
                                        Z: "true",
                                        D: "12px Verdana",
                                        C: "Font for the text of the tracks in the genome browser<br>"
                                    },
                                    codeEffectIn: {
                                        T: "string",
                                        M: "Effect",
                                        D: "swashIn",
                                        H: ["{[*]}"],
                                        C: "codeEffectIn<br>"
                                    },
                                    randomNetworkNodeEdgesMax: {
                                        U: ["Network"],
                                        C: "Default number of maximum edges when creating random networks<br>",
                                        T: "integer",
                                        M: "Random",
                                        D: "5"
                                    },
                                    sequenceTColor: {
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(255,0,0)",
                                        C: "Color for the thymidines and threonines in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    showSmpDendrogram: {
                                        H: ['{[*],"data":"Random:4:8:1:1","graphType":"Heatmap","samplesClustered":true}'],
                                        C: "Flag to show or not the sample dendrogram<br>",
                                        M: "Dendrograms",
                                        T: "boolean",
                                        D: "true"
                                    },
                                    featureQualityHeight: {
                                        D: "14",
                                        T: "integer",
                                        M: "Genome Browser",
                                        C: "Default size in pixels of the quality height<br>",
                                        H: ["{[*]}"]
                                    },
                                    subtitleFontStyle: {
                                        T: "option",
                                        D: "",
                                        H: ['{[*],"title":"Graph Title","subtitle":"Graph Subtitle"}'],
                                        O: ["", "bold", "italic", "bold italic"],
                                        M: "Titles and Subtitles",
                                        C: "Font style for the title.<br>"
                                    },
                                    networkLayoutType: {
                                        T: "option",
                                        D: "forceDirected",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        O: ["forceDirected", "circular", "radial"],
                                        M: "Network Graphs",
                                        C: "Type of network layout.<br>"
                                    },
                                    yAxisExact: {
                                        H: ['{[*],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        D: "false",
                                        T: "boolean",
                                        C: "Flag to force exact values for the data<br>",
                                        M: "Y-Axis",
                                        U: ["Scatter3D"]
                                    },
                                    layoutRemoveEmpty: {
                                        C: "Flag to remove empty combinations in segregated layouts.<br>",
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        T: "boolean",
                                        M: "Combination Plots",
                                        D: "true"
                                    },
                                    layoutLabelBoxThickness: {
                                        C: "Thickness of the layout label boxes.<br>",
                                        H: ['{[*],"data":"Random:4:8:2:2","segregateSamplesBy":["Factor1"]}'],
                                        T: "float",
                                        M: "Combination Plots",
                                        D: "30"
                                    },
                                    heatmapIndicatorHistogramColor: {
                                        T: "color",
                                        M: "Heatmap Graphs",
                                        D: "rgb(0,255,255)",
                                        C: "Color for the heatmap indicator histogram<br>",
                                        H: ['{[*],"heatmapIndicatorHistogram":true,"heatmapIndicatorHeight":50}']
                                    },
                                    visibleMapFeatures: {
                                        C: "Visible Map features. It Overrides the hidden features<br>",
                                        M: "Maps",
                                        T: "array",
                                        D: "[]"
                                    },
                                    autoexpandDOE: {
                                        H: ['{[*],"data":"Random:3:24:3:5","groupingFactors":["Factor1"],"functions":["createDOE"]}'],
                                        C: "Flag to automatically expand verticaly the extent of the meta data-plots when changing the size of the graphs<br>",
                                        T: "boolean",
                                        M: "DOE",
                                        D: "true"
                                    },
                                    lazyLoad: {
                                        D: "false",
                                        M: "Events",
                                        T: "boolean",
                                        C: "Load canvas only if shown in viewport.<br>",
                                        H: ["{[*]}"]
                                    },
                                    filtersExposed: {
                                        D: "[]",
                                        T: "array",
                                        M: "Data Filters",
                                        C: "Exposed filters after rendering the plot. Each element in the array is an object as follows: {name: [var or smp annotation|vars|smps], position: [topRight|topLeft|bottomRight|bottomLeft], css: {property:value}}<br>"
                                    },
                                    objectColorTransparency: {
                                        C: "The transparency for the color fill of all objects in one dimensional graphs. A value between 0 and 1.<br>",
                                        H: ['{[*],"graphType":"Bar"}'],
                                        M: "Plot area",
                                        T: "float",
                                        D: "1"
                                    },
                                    arrowQuadraticFactor: {
                                        D: "2.3",
                                        M: "Lines",
                                        T: "integer",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:1:0:forceDirected","graphType":"Network"}'],
                                        C: "Factor to use to bend the quadratic lines.<br>"
                                    },
                                    barPathColor: {
                                        D: "false",
                                        M: "Bar Graphs",
                                        T: "color",
                                        C: "Color for the bar graph path. If false, it will default to the color of the graph.<br>",
                                        H: ['{[*],"data":"Random:1:8","graphType":"Bar"}']
                                    },
                                    layoutHeight: {
                                        C: "Height of the current segment of the canvas when there are multiple graphs.<br>",
                                        M: "Combination Plots",
                                        T: "float",
                                        Z: "true",
                                        D: "0"
                                    },
                                    showViolinBoxplot: {
                                        T: "boolean",
                                        M: "Boxplot Graphs",
                                        D: "false",
                                        C: "Flag to show violin plot in boxplots<br>",
                                        H: ['{[*],"data":"Random:2:12:0:2","groupingFactors":["Factor1"]}']
                                    },
                                    connectByColor: {
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        C: "The color for the connectBy lines<br>",
                                        M: "Data Point Attributes",
                                        H: ['{[*],"graphType":"Scatter3D","connectBy":"Annt1"}'],
                                        T: "color",
                                        D: "rgb(204,204,204)"
                                    },
                                    decorationsBox: {
                                        C: "Flag to create a box around the decoration legend<br>",
                                        M: "Decorations",
                                        S: ["decorationsBoxColor", "decorationsBackgroundColor"],
                                        H: ['{[*],"data":"Random:16:2","showDecorations":true,"graphType":"Scatter2D","functions":["addNormalDistributionLine"]}'],
                                        D: "false",
                                        T: "boolean"
                                    },
                                    yAxisCurrent: {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        C: "Index (zero-based) of the sample that is currently displayed in the Y axis when there are more series in the X axis than in the Y axis in an Scarrter2D plot or when there are multiple series in an ScatterBubble2D plot. Use ctrl + arrow keys to cycle through data series.<br>",
                                        M: "Y-Axis",
                                        H: ['{[0,1],"data":"Random:10:2","yAxis":["S1","S2"],"xAxis":["S3","S4","S5"],"graphType":"Scatter2D","yAxisCurrent":0}'],
                                        T: "integer",
                                        D: "0"
                                    },
                                    errorBarsWidth: {
                                        C: "Minimum size of the bar in pixels to determine to show or hide error bar ends in the graphs when available.<br>",
                                        H: ['{[2,50],"setMinX":0,"groupingFactors":["Factor1"]}'],
                                        D: "2",
                                        M: "Error Bars and Confidence Intervals",
                                        T: "integer"
                                    },
                                    sequenceKColor: {
                                        D: "rgb(255,0,0)",
                                        M: "Genome Browser",
                                        T: "color",
                                        C: "Color for the degenerate G/T and lysines in the genome browser<br>",
                                        H: ["{[*]}"]
                                    },
                                    yAxisRugShow: {
                                        H: ['{[*],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to indicate whether to show a rug for the data in the Y axis<br>",
                                        M: "Y-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"]
                                    },
                                    overlaysLegendPosition: {
                                        H: ['{[*],"data":"Random:10:10:3:3","graphType":"Heatmap","showVarOverlaysLegend":true,"showSmpOverlaysLegend":true,"varOverlays":["Annt1"],"smpOverlays":["Factor1"]}'],
                                        D: "topRight",
                                        T: "option",
                                        O: ["topRight", "right", "bottomLeft", "bottom"],
                                        C: "Position for the variable and sample overlays legend in the graphs.<br>",
                                        M: "Overlays"
                                    },
                                    axisTickFontSize: {
                                        H: ['{[*],"autoScaleFont":false}'],
                                        T: "integer",
                                        D: "12",
                                        C: "Font size of the axis ticks in one, two and three dimensional plots. Be aware that auto scaling font must be turned off for this property to take effect. A more convenient way to modify the size is to use the tick scaling factor<br>",
                                        M: "Axis",
                                        S: ["autoScaleFont", "axisTickScaleFontFactor"]
                                    },
                                    smpLabelFont: {
                                        Z: "true",
                                        D: "12px Verdana",
                                        T: "font",
                                        M: "Fonts",
                                        C: "Font for the sample labels in one dimensional plots<br>"
                                    },
                                    desegregateSamples: {
                                        C: "Desegreagate samples previously segregated based on a sample category (data.x object)<br>",
                                        M: "Functions",
                                        T: "void",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"],
                                        S: ["segregateSamples"]
                                    },
                                    mapCentralMeridian: {
                                        C: "Map Latitude Of Origin in degrees. (Applicable to Albers projection only). Default adjusts to USA maps.<br>",
                                        H: ["{[*]}"],
                                        M: "Maps",
                                        T: "float",
                                        D: "-96.0"
                                    },
                                    setMinX: {
                                        H: ['{[20,50,null],"graphType":"Bar"}', '{[20,50,null],"graphType":"Scatter2D"}'],
                                        C: "Minimum value to set the data in the X axis<br>",
                                        D: "null",
                                        M: "X-Axis",
                                        T: "float"
                                    },
                                    showNetworkRadialLayout: {
                                        T: "boolean",
                                        M: "Network Graphs",
                                        D: "false",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large","networkLayoutType":"radial","networkRoot":"ND1","showAnimation":true}'],
                                        C: "Flag to show or not a radial layout wire.<br>"
                                    },
                                    xAxisTicks: {
                                        H: ["{[*]}"],
                                        C: "Number of ticks in the X axis<br>",
                                        D: "5",
                                        M: "X-Axis",
                                        T: "integer"
                                    },
                                    varOverlaysLegendColumns: {
                                        H: ['{[1,2,3],"data":"Random:10:10:3:0","graphType":"Heatmap","showVarOverlaysLegend":true,"varOverlays":["Annt1","Annt2","Annt3"]}'],
                                        C: "Number of columns for the variable overlay legends<br>",
                                        M: "Overlays",
                                        T: "integer",
                                        D: "1"
                                    },
                                    manhattanMarkerPosition: {
                                        M: "Scatter Plots",
                                        C: "Sample name included in the 'data.y.smps' object used to map to the position in base pairs.<br>",
                                        X: "getSamplesAsArray",
                                        D: "false",
                                        T: "option",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        O: ["false"]
                                    },
                                    meterType: {
                                        M: "Meter Graphs",
                                        C: "Type of meter. <br>",
                                        T: "option",
                                        D: "gauge",
                                        H: ['{[*],"graphType":"Meter"}'],
                                        O: ["gauge", "speedometer", "vertical", "horizontal", "state", "digital"]
                                    },
                                    meterSegments: {
                                        C: "Meter Segments.<br>",
                                        M: "Meter Graphs",
                                        S: ["meterColors"],
                                        H: ['{[*],"graphType":"Meter"}'],
                                        D: [25, 75],
                                        T: "array"
                                    },
                                    showDataValues: {
                                        H: ['{[*],"graphType":"Bar"}'],
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to indicate whether to show data values in the one bar graphs.<br>",
                                        M: "Plot area",
                                        U: ["Bar", "Heatmap"]
                                    },
                                    shapes: {
                                        C: "Array with shapes used in visualizations. The order will dictate the utilization in the visualization.<br>",
                                        M: "General Attributes",
                                        H: ['{"data":"Random:8:4:2:1","shapes":["sphere","square","triangle","star"],"shapeBy":"Factor2","graphType":"Dotplot"}', '{"data":"Random:8:4:2:1","shapes":["rhombus","octagon","oval","plus"],"shapeBy":"Factor2","graphType":"Dotplot"}'],
                                        T: "array",
                                        D: ["sphere", "square", "triangle", "star", "rhombus", "octagon", "oval", "plus", "minus", "pacman", "pacman2", "mdavid", "rect2", "pentagon", "rect3", "arc", "rectangle", "image"],
                                        O: ["sphere", "square", "triangle", "star", "rhombus", "octagon", "oval", "plus", "minus", "pacman", "mdavid", "rect2", "pentagon", "rect3", "arc", "rectangle", "image"]
                                    },
                                    yAxisCeilValue: {
                                        C: "Value to ceil the data in the Y axis.<br>",
                                        H: ['{[null,50],"data":"Random:10:2","graphType":"Scatter2D"}'],
                                        D: "null",
                                        M: "Y-Axis",
                                        T: "float"
                                    },
                                    decorationFont: {
                                        C: "Font for the decoration in scatter plots and network graphs<br>",
                                        Z: "true",
                                        D: "12px Verdana",
                                        M: "Fonts",
                                        T: "font"
                                    },
                                    contourType: {
                                        T: "option",
                                        D: "color",
                                        H: ['{[*],"data":"Random:20:20","functions":["createContour"]}'],
                                        O: ["overlay", "color"],
                                        M: "Contours",
                                        C: "Type of contour plot<br>",
                                        S: ["images", "isHistogram", "histogramBarWidth"]
                                    },
                                    invertCensored: {
                                        M: "Error Bars and Confidence Intervals",
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to indicate whether zero values are censored or not in Kaplan-Meier plots <br>",
                                        H: ['{[*],"data":"RandomKaplanMeier","showDecorations":true,"graphType":"Scatter2D","showLegend":false,"functions":["addKaplanMeierCurve:Time:Censored-1:Data 1 Population:rgb(0,0,255)","addKaplanMeierCurve:Time:Censored-2:Data 2 Population:rgb(255,0,0)"]}']
                                    },
                                    circularRotate: {
                                        C: "Number of degrees to rotate the circular graph to adjust the starting point.<br>",
                                        H: ['{[0,90,180],"graphType":"Circular"}'],
                                        D: "0",
                                        M: "Circular Graphs",
                                        T: "integer"
                                    },
                                    sequenceEColor: {
                                        C: "Color for the glutamic acids in the genome browser<br>",
                                        H: ["{[*]}"],
                                        T: "color",
                                        M: "Genome Browser",
                                        D: "rgb(0,0,0)"
                                    },
                                    zAxisFloorValue: {
                                        D: "null",
                                        T: "float",
                                        M: "Z-Axis",
                                        H: ['{[null,50],"data":"Random:10:3","graphType":"Scatter3D"}'],
                                        C: "Value to floor the data in the Z axis.<br>"
                                    },
                                    xAxisHistogramShow: {
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        T: "boolean",
                                        D: "false",
                                        C: "Flag to indicate whether to show a histogram for the data in the X axis<br>",
                                        M: "X-Axis",
                                        U: ["Scatter2D", "ScatterBubble2D"]
                                    },
                                    shapeByShowLegend: {
                                        T: "boolean",
                                        M: "Data Point Attributes",
                                        D: "true",
                                        H: ['{[*],"graphType":"Dotplot","shapeBy":"Factor1"}'],
                                        C: "Flag to show the shapeBy legend<br>"
                                    },
                                    legendFont: {
                                        M: "Fonts",
                                        T: "font",
                                        Z: "true",
                                        D: "12px Verdana",
                                        C: "Font for the legends<br>"
                                    },
                                    print: {
                                        M: "Functions",
                                        T: "void",
                                        C: "initializeApi     * @param void @returns void"
                                    },
                                    offsetX: {
                                        M: "Combination Plots",
                                        T: "float",
                                        D: "0",
                                        Z: "true",
                                        C: "Additional amount to move for the X axis<br>"
                                    },
                                    maxSmpStringLen: {
                                        T: "integer",
                                        M: "Samples",
                                        D: "25",
                                        C: "Maximum length in characters a sample label or description can have so anything above is truncated.<br>",
                                        H: ['{[1,30],"graphType":"Bar"}']
                                    },
                                    stackBy: {
                                        H: ['{"data":"Random:4:8:1:1","graphType":"Bar","stackBy":"Annt1"}'],
                                        T: "option",
                                        D: "false",
                                        O: ["false"],
                                        C: "Name of a sample annotation to stack the samples of each variable in Bar graphs.<br>",
                                        M: "Data Point Attributes",
                                        X: "getXData"
                                    },
                                    featureSpliceStyle: {
                                        O: ["rect", "broken"],
                                        C: "Default style for splicing in boxes<br>",
                                        T: "option",
                                        M: "Genome Browser",
                                        D: "rect"
                                    },
                                    background: {
                                        D: "rgb(255,255,255)",
                                        T: "color",
                                        H: ["{[*]}"],
                                        S: ["backgroundType"],
                                        M: "Foreground and Background",
                                        C: "Specifies the background color for the canvas.<br>"
                                    },
                                    showErrorBars: {
                                        D: "true",
                                        M: "Error Bars and Confidence Intervals",
                                        T: "boolean",
                                        H: ['{[*],"setMinX":0,"groupingFactors":["Factor1"]}'],
                                        C: "Flag to indicate whether to show or not error bars in the graphs.<br>"
                                    },
                                    colorRGB: {
                                        M: "Colors",
                                        T: "array",
                                        D: [" 1", " 1", " 1 "],
                                        Z: "true",
                                        C: "Color RGB. Red, Green, Blue used in the configurator<br>"
                                    },
                                    varLabelRotate: {
                                        M: "Variables",
                                        C: "Rotation for variable labels in degrees It could be positive or negative.<br>",
                                        U: ["Heatmap"],
                                        D: "0",
                                        T: "integer",
                                        H: ['{[0,45,90],"data":"Random:8:4"}']
                                    },
                                    dataFilterWidth: {
                                        M: "Data Filters",
                                        T: "integer",
                                        D: "220",
                                        C: "Size in pixels for the data filters.<br>",
                                        H: ["{[*]}"]
                                    },
                                    pieSegmentLabels: {
                                        C: "Location for the values in the pie charts<br>",
                                        M: "Pie Charts",
                                        O: ["inside", "outside"],
                                        H: ["{[*]}"],
                                        T: "option",
                                        D: "inside"
                                    },
                                    shapeBy: {
                                        O: ["false", "variable"],
                                        D: "false",
                                        T: "option",
                                        H: ['{"data":"Random:8:4:1:1","graphType":"Scatter3D","shapeBy":"Annt1"}', '{"data":"Random:8:4:1:1","graphType":"Scatter3D","shapeBy":"Sample4"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","shapeBy":"Factor1"}', '{"data":"Random:4:8:1:1","graphType":"Dotplot","shapeBy":"Annt1"}'],
                                        S: ["shapeByData"],
                                        X: "getXZData",
                                        M: "Data Point Attributes",
                                        C: "Name of a variable annotation or a sample name or the string 'variable' to shape the variables. When shapeByData is specified shapeBy is used for the title in the legend.<br>"
                                    },
                                    isGraphTime: {
                                        T: "boolean",
                                        M: "Time Series",
                                        D: "false",
                                        C: "Flag to indicate if the data is a time series so there is no need to plot every time interval. It is boolean in one dimensional plots or a string indicating the axis which is timed 'x', 'y' or 'z'<br>",
                                        H: ['{"data":"Random:2:150:0:0:1:100:0:true","isGraphTime":true}']
                                    },
                                    manhattanContrastColor: {
                                        D: "rgba(0,0,0,0.1)",
                                        T: "array",
                                        M: "Scatter Plots",
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        C: "Manhattan contrast color"
                                    },
                                    visiumPanning: {
                                        H: ['{[*],"graphType":"Scatter2D"}'],
                                        C: "No panning on visium plots so dragging will always zoom.<br>",
                                        M: "Scatter Plots",
                                        T: "boolean",
                                        D: "false"
                                    },
                                    disableUndoRedoKeys: {
                                        D: "true",
                                        M: "Events",
                                        T: "boolean",
                                        H: ["{[*]}"],
                                        C: "Flag to disable undo / redo key binding events.<br>"
                                    },
                                    remoteService: {
                                        D: "false",
                                        M: "Remote Procedures",
                                        T: "url",
                                        C: "Url used to obtain data remotely thorugh a web service or directly from a file. If the remote service is a file then it expects a json file with a two dimensional array. Each of the arrays should have a key (which will be used in a drop down menu) and a value to point to a url where to get the data. If the remote service is a web service it expects a canvasXpress object. You may specify additional parameters for the web service but you must specify the type of remote service in remoteServiceType. The default parameters for web services are index (to identify the current record number) and dir (to identify the direction; it could be either next or prev)<br>",
                                        S: ["remoteServiceType", "remoteParams", "remoteDirection"]
                                    },
                                    maxPieSectors: {
                                        H: ['{[2,3],"data":"Random:4:8:"}'],
                                        C: "Max pie sectors. After that number the sectors will be put in a sector named 'other'.<br>",
                                        D: "20",
                                        M: "Pie Charts",
                                        T: "float"
                                    },
                                    draw: {
                                        T: "void",
                                        M: "Functions",
                                        C: "Redraw the canvas<br>"
                                    },
                                    skipClick: {
                                        M: "Events",
                                        T: "boolean",
                                        Z: "true",
                                        D: "false",
                                        C: "Flag to skip click events after a mouse down event in visualizations where there is a drag capabilities<br>"
                                    },
                                    remoteParentId: {
                                        D: "",
                                        Z: "true",
                                        M: "Remote Procedures",
                                        T: "string",
                                        C: "Id for the parent holding the remoteWindow to prevent id collisions<br>"
                                    },
                                    preScaleNetwork: {
                                        T: "boolean",
                                        M: "Network Graphs",
                                        D: "false",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}'],
                                        C: "Flag to prescale or not the network. This is an aesthetic parameter to make the graph look nicer... Sometimes...<br>"
                                    },
                                    nodeFontStyle: {
                                        M: "Network Graphs",
                                        C: "Font style for the node label.<br>",
                                        O: ["", "bold", "italic", "bold italic"],
                                        D: "",
                                        T: "option",
                                        H: ['{[*],"data":"RandomNetwork:1:20:10:0:0:large"}']
                                    },
                                    showTextShadow: {
                                        C: "Flag used to add shadows to all text in the canvas. It will be forced to false if the browser is IE.<br>",
                                        M: "Shadows",
                                        S: ["shadowOffsetX", "shadowOffsetY", "shadowBlur", "shadowColor"],
                                        H: ["{[*]}"],
                                        T: "boolean",
                                        D: "false"
                                    },
                                    x3DRatio: {
                                        H: ['{[0.5,1],"data":"Random:8:4","graphType":"Scatter3D"}'],
                                        D: "1",
                                        T: "float",
                                        C: "Value between 0 - 1 for adjusting the 3D of the X Axis<br>",
                                        M: "3D Attributes",
                                        U: ["Scatter3D", "Bar"]
                                    },
                                    randomDataMean: {
                                        T: "integer",
                                        M: "Random",
                                        D: "0",
                                        C: "Mean value when creating random data<br>"
                                    },
                                    disableConfigurator: {
                                        H: ["{[*]}"],
                                        C: "Flag to disable configurator.<br>",
                                        D: "false",
                                        T: "boolean",
                                        M: "Events"
                                    },
                                    legendOrder: {
                                        D: "false",
                                        M: "Legends",
                                        T: "object",
                                        H: ['{"data":"Random:16:2:1:0","showDecorations":true,"graphType":"Scatter2D","colorBy":"Annt1","legendOrder":false}', '{"data":"Random:16:2:1:0","showDecorations":true,"graphType":"Scatter2D","colorBy":"Annt1","legendOrder":{"Annt1":["Desc:2","Desc:1"]}}'],
                                        C: "Object to specify custom order for the levels in the legends. The key of the object is the name of an annotation in the data.x object, or the name of an annotation in the data.z object. The value for element is an array with the levels for the corresponding factor<br>"
                                    }
                                },
                                M: {
                                    "Motion Charts": {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        P: ["motionCurrentColor", "motionCurrentFontSize", "motionCurrentFontStyle", "motionCurrentScaleFontFactor", "motionWidth"],
                                        D: "General parameters in scatter plots"
                                    },
                                    "Citations or References": {
                                        D: "Properties associated with citations or references of the plot",
                                        P: ["citation", "citationColor", "citationFontSize", "citationFontStyle", "citationScaleFontFactor"],
                                        U: ["AllGraphs"]
                                    },
                                    "Data Selection: Parameters used to select data in all visualizations": {
                                        D: "AllGraphs\n",
                                        P: ["selectedDataPoints", "selectionColor", "selectionMetadata", "selectionMode"]
                                    },
                                    Random: {
                                        D: "Properties used to generate random data sets",
                                        P: ["pseudoRandom", "randomData", "randomDataDistribution", "randomDataMax", "randomDataMean", "randomDataMin", "randomDataSampleAnnotations", "randomDataSamples", "randomDataSigma", "randomDataTime", "randomDataVariableAnnotations", "randomDataVariables", "randomMethod", "randomMissingDataPercentage", "randomNetworkAll", "randomNetworkLayout", "randomNetworkNodeEdgesMax", "randomNetworkNodes", "randomNetworkReduce", "randomSeed"],
                                        U: ["AllGraphs"]
                                    },
                                    "Pie Charts": {
                                        U: ["Pie"],
                                        P: ["maxPieSectors", "pieColors", "pieInnerRadius", "pieLabelType", "pieSegmentLabels", "pieSegmentPrecision", "pieSegmentSeparation", "pieType", "showPieGrid", "showPieSampleLabel", "showPieValues", "startPieSectors"],
                                        D: "General parameters in pie charts"
                                    },
                                    "R-Axis": {
                                        U: ["Circular"],
                                        D: "R axis parameters",
                                        P: ["rAxisAbsMax", "rAxisAbsMin", "rAxisLabelOrientation", "rAxisMajorTicks", "rAxisMaxStrLength", "rAxisMinorTicks", "rAxisMinorValues", "rAxisPercentShow", "rAxisShow", "rAxisTickColor", "rAxisTickFormat", "rAxisTicks", "rAxisValues", "rAxisValuesRaw"]
                                    },
                                    "Foreground and Background": {
                                        U: ["AllGraphs"],
                                        P: ["background", "backgroundImage", "backgroundType", "backgroundWindow", "foreground"],
                                        D: "Foreground and Background properties used in all visualizations"
                                    },
                                    "Heatmap Graphs": {
                                        P: ["adjustAspectRatioHeatmapIndicator", "grpIndicesStart", "heatmapAutoAdjust", "heatmapCellBox", "heatmapCellBoxColor", "heatmapCellBoxColorHighlight", "heatmapCellBoxHighlightWidth", "heatmapCellBoxWidth", "heatmapCollapse", "heatmapIndicatorHeight", "heatmapIndicatorHistogram", "heatmapIndicatorHistogramColor", "heatmapIndicatorPosition", "heatmapIndicatorWidth", "heatmapSeparatorThickness", "heatmapSmpSeparateBy", "heatmapType", "heatmapVarSeparateBy", "isMultidimensionalData", "showHeatmapIndicator", "smpIndicesStart", "smpTitleLabelPosition", "varIndicesStart", "varTitleLabelPosition"],
                                        D: "General parameters for heatmaps",
                                        U: ["Heatmap"]
                                    },
                                    "Fish Graphs": {
                                        U: ["Fish"],
                                        D: "General parameters in fish graphs",
                                        P: ["fishAxis", "fishAxisLabels", "fishCloneLabels", "fishParents", "fishSeparateIndependentClones", "fishShape", "fishTimepoints"]
                                    },
                                    "Area Graphs": {
                                        P: ["areaType"],
                                        D: "General parameters in area graphs",
                                        U: ["Area", "AreaLine"]
                                    },
                                    Shapes: {
                                        U: ["AllGraphs"],
                                        D: "Properties to adjust Shapes",
                                        P: ["roundedPolygonRadius", "useOpenShapes", "useRoundRectangles"]
                                    },
                                    "Dotplot Graphs": {
                                        D: "General parameters in dotplot graphs",
                                        P: ["dotplotType"],
                                        U: ["Dotplot", "DotLine"]
                                    },
                                    "X-Axis2": {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "BarLine", "StackedLine", "StackedPercentLine"],
                                        P: ["setMaxX2", "setMinX2", "xAxis2", "xAxis2AbsMax", "xAxis2MaxStrLength", "xAxis2MinorValues", "xAxis2Show", "xAxis2TickFormat", "xAxis2Ticks", "xAxis2Title", "xAxis2Values", "xAxis2ValuesRaw"],
                                        D: "X2 Axis parameters"
                                    },
                                    "Network Algorithm Parameters": {
                                        U: ["Network"],
                                        P: ["attractiveForceFunction", "barnesHutNodesCache", "barnesHutNodesCacheCurrent", "barnesHutUpdateQueue", "networkDragCoeff", "networkGravity", "networkRepulsion", "networkSpeed", "networkSpringCoeff", "networkSpringLength", "networkTheta", "networkTimeStep", "repulsiveForceFunction", "useBarnesHutSimulation"],
                                        D: "General parameters used in the layout algorithms for networks"
                                    },
                                    "Time Series": {
                                        U: ["OneTwoThreeeDGraphs"],
                                        P: ["isGraphTime", "timeFormat", "timeValueIndices", "timeValueProperties", "timeValues"],
                                        D: "Time series related parameters"
                                    },
                                    "Y-Axis": {
                                        P: ["setMaxY", "setMinY", "yAxis", "yAxis2Show", "yAxis2Title", "yAxisAbsMax", "yAxisAbsMin", "yAxisBottomMajorTick", "yAxisCeilValue", "yAxisCurrent", "yAxisExact", "yAxisFloorValue", "yAxisHistogramHeight", "yAxisHistogramShow", "yAxisMajorTicks", "yAxisMaxStrLength", "yAxisMinorTicks", "yAxisMinorValues", "yAxisRugHeight", "yAxisRugPosition", "yAxisRugShow", "yAxisShow", "yAxisTickColor", "yAxisTickFormat", "yAxisTickStyle", "yAxisTicks", "yAxisTitle", "yAxisTitleDynamic", "yAxisTopBottomTickColor", "yAxisTopMajorTick", "yAxisTransform", "yAxisTransformTicks", "yAxisValues", "yAxisValuesRaw"],
                                        D: "Y axes parameters",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    Gradients: {
                                        D: "Properties used to adjust color gradients in all visualizations",
                                        P: ["gradient", "gradientOrientation", "gradientRatio", "gradientType"],
                                        U: ["AllGraphs"]
                                    },
                                    Events: {
                                        U: ["AllGraphs"],
                                        D: "Event parameters",
                                        P: ["alignConfiguratorExamples", "broadcast", "configuratorExamplesSize", "configuratorWidth", "disableCanvas", "disableCode", "disableConfigurator", "disableDataExplorer", "disableDataFilters", "disableDataTable", "disableDocument", "disableEvents", "disableKeys", "disableMenu", "disablePlusMinusKeys", "disableShowShortcuts", "disableToolbar", "disableUndoRedoKeys", "disableWheel", "disableWindow", "infoStartTime", "infoTimeIn", "infoTimeOut", "lazyLoad", "maxItemMenuCheckbox", "maxSubMenus", "movable", "playable", "resizable", "resizableX", "resizableY", "resizeHeightOnLayout", "resizeWidthOnLayout", "showConfiguratorExamplesOnSelect", "showMousePositionOnDrag", "showPrimaryMenus", "skipClick", "toolbarType"]
                                    },
                                    "Combination Plots": {
                                        U: ["AllGraphs"],
                                        P: ["layout", "layoutAdjust", "layoutAxis", "layoutBoxLabelColors", "layoutBoxShow", "layoutCanvasCompartments", "layoutCollapse", "layoutComb", "layoutConfig", "layoutCurrent", "layoutHeight", "layoutLabelBoxThickness", "layoutLabelColor", "layoutLabelShow", "layoutRemoveEmpty", "layoutTopology", "layoutType", "layoutWidth", "offsetX", "offsetY", "scaleX", "scaleY", "translateX", "translateY", "weight"],
                                        D: "Parameters used in complex plots"
                                    },
                                    Functions: {
                                        D: "Functions exposed in the configurator :",
                                        P: ["addNormalDistributionLine", "addRegressionLine", "clusterSamples", "clusterVariables", "createContour", "createHistogram", "createRandomData", "desegregateSamples", "desegregateVariables", "draw", "drawArea", "groupSamples", "hideCodeDiv", "hideInfoDiv", "hideUnhideSmps", "hideUnhideVars", "kmeansSamples", "kmeansVariables", "print", "recalculateLayout", "removeContour", "removeHistogram", "reset", "segregateSamples", "segregateVariables", "showCodeDiv", "showInfoDiv", "transform", "transpose", "ungroupSamples", "updateCodeDiv"]
                                    },
                                    Dendrograms: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Circular"],
                                        P: ["colorSmpDendrogramBy", "colorVarDendrogramBy", "dendrogramColor", "dendrogramHeight", "showSmpDendrogram", "showVarDendrogram", "smpDendrogramNewick", "smpDendrogramPosition", "varDendrogramNewick", "varDendrogramPosition"],
                                        D: "General parameters in dendrograms"
                                    },
                                    "Gantt Charts": {
                                        U: ["Gantt"],
                                        P: ["ganttCompletion", "ganttCompletionTransparency", "ganttDependency", "ganttDependencyColor", "ganttDependencyEnd", "ganttDependencyThickness", "ganttEnd", "ganttStart"],
                                        D: "General parameters in gantt charts"
                                    },
                                    "Z-Axis": {
                                        P: ["setMaxZ", "setMinZ", "zAxis", "zAxisAbsMax", "zAxisAbsMin", "zAxisCeilValue", "zAxisCurrent", "zAxisExact", "zAxisFloorValue", "zAxisMaxStrLength", "zAxisMinorValues", "zAxisShow", "zAxisTickColor", "zAxisTickFormat", "zAxisTickStyle", "zAxisTicks", "zAxisTitle", "zAxisTitleDynamic", "zAxisTransform", "zAxisTransformTicks", "zAxisValues", "zAxisValuesRaw"],
                                        D: "Z axes parameters",
                                        U: ["ScatterBubble2D", "Scatter3D"]
                                    },
                                    "Network Graphs": {
                                        U: ["Network"],
                                        D: "General parameters used in networks",
                                        P: ["calculateLayout", "edgeThickness", "highlightNode", "ignoreEventlessOrder", "is3DNetwork", "isNetworkMetrics", "labelNodePosition", "moveParentsWithChildren", "networkFreeze", "networkFreezeOnLoad", "networkLayoutType", "networkNodesOnTop", "networkRoot", "networkVendor", "nodeFontColor", "nodeFontSize", "nodeFontStyle", "nodeHighlightColor", "nodeScaleFontFactor", "nodeSize", "preScaleNetwork", "showNetworkRadialLayout", "showNodeNameSizeThreshold", "showNodeNameThreshold", "subNetworks"]
                                    },
                                    "Line Graphs": {
                                        P: ["coordinateLineColor", "lineDecoration", "lineErrorType", "lineType", "parallelCoordinates", "tension", "tensionSegments"],
                                        D: "General parameters in line graphs",
                                        U: ["Area", "Line", "Heatmap", "ParallelCoordinates", "BarLine", "AreaLine", "StackedLine", "StackedPercentLine"]
                                    },
                                    R: {
                                        U: ["AllGraphs"],
                                        D: "Parameters associated with R",
                                        P: ["RdatastesURL", "loadRDatasets"]
                                    },
                                    Lines: {
                                        D: "Properties to adjust Lines",
                                        P: ["adjustBezier", "arrowPointSize", "arrowQuadraticFactor", "arrows", "capType", "dashLength", "dotLength", "joinType", "lineThickness", "lineWidthEvent", "lines", "outlineWidth"],
                                        U: ["AllGraphs"]
                                    },
                                    "Tag Cloud": {
                                        U: ["TagCloud"],
                                        P: ["tagCloudGridPoints", "tagCloudMask", "tagCloudShape", "tagCloudTextEllipticity", "tagCloudTextGridSize", "tagCloudTextRotateRatio", "tagCloudTextWeightFactor"],
                                        D: "General parameters used in tag clouds"
                                    },
                                    "3D Attributes": {
                                        U: ["Scatter3D", "Network", "Bar"],
                                        D: "General parameters in 3d scatter plots and networks",
                                        P: ["perspectiveFactor", "rotationSensitivity", "rotationStep", "show3DGrid", "x3DRatio", "xRotate", "y3DRatio", "yRotate", "z3DRatio", "zRotate"]
                                    },
                                    "Network Communities": {
                                        U: ["Network"],
                                        D: "General parameters used in network communities",
                                        P: ["calculateNetworkCommunities", "coordinateNetworkConvexHullCommunityColor", "hullScale", "networkCommunities", "networkConvexHulls", "showNetworkCommunities"]
                                    },
                                    "Remote Procedures": {
                                        D: "Parameters used when getting data remotely",
                                        P: ["remoteAutoPlay", "remoteAutoPlayDelay", "remoteAutoSize", "remoteData", "remoteDataIndex", "remoteDirection", "remoteIds", "remoteParamOverride", "remoteParams", "remoteParentId", "remoteService", "remoteServiceType", "remoteTransitionEffect", "remoteUpdating"],
                                        U: ["AllGraphs"]
                                    },
                                    "Scatter Plot Matrix": {
                                        U: ["Scatter2D", "ScatterBubble2D"],
                                        D: "Parameters used to create a matrix of 2d scatter plots",
                                        P: ["scatterPlotMatrix", "scatterPlotMatrixType", "showScatterPlotMatrixLabels"]
                                    },
                                    "QQ Plots": {
                                        U: ["AllGraphs"],
                                        P: ["qqDistribution", "qqPoints", "qqSamples"],
                                        D: "Parameters used to create QQ plots in 2d scatter plots"
                                    },
                                    Colors: {
                                        P: ["blindnessType", "colorHSV", "colorRGB", "colorScheme", "colorSpectrum", "colorSpectrumBreaks", "colorSpectrumNumber", "colorSpectrumTarget", "colorSpectrumZeroValue", "colors", "evenColor", "oddColor"],
                                        D: "Properties to adjust Colors",
                                        U: ["AllGraphs"]
                                    },
                                    "Data Point Attributes": {
                                        D: "General attributes for data points in scatter and one dimensional plots",
                                        P: ["colorBy", "colorByShowLegend", "colorKey", "connectBy", "connectByColor", "connectByData", "connectByNoColor", "connectByShowLegend", "connectByWidth", "connectKey", "ellipseBy", "markerBy", "motionBy", "outlineBy", "outlineByData", "outlineByShowLegend", "patternBy", "patternByData", "patternByShowLegend", "patternKey", "ridgeBy", "shapeBy", "shapeByContinuous", "shapeByData", "shapeByShape", "shapeByShowLegend", "shapeKey", "sizeBy", "sizeByContinuous", "sizeByData", "sizeByShowLegend", "sizeKey", "spiderBy", "stackBy", "treemapBy"],
                                        U: ["AGraphs"]
                                    },
                                    "Titles and Subtitles": {
                                        D: "Properties associated with titles and subtitles",
                                        P: ["subtitle", "subtitleAlign", "subtitleColor", "subtitleFontSize", "subtitleFontStyle", "subtitleScaleFontFactor", "title", "titleAlign", "titleColor", "titleColorBackground", "titleFontSize", "titleFontStyle", "titleScaleFontFactor"],
                                        U: ["AllGraphs"]
                                    },
                                    Overlays: {
                                        P: ["maxOverlayStringLen", "overlayFontColor", "overlayFontSize", "overlayFontStyle", "overlayScaleFontFactor", "overlaysLegendPosition", "overlaysThickness", "showLevelOverlays", "showOverlays", "showSmpOverlaysLegend", "showVarOverlaysLegend", "smpOverlayProperties", "smpOverlays", "smpOverlaysLegendColumns", "varOverlayProperties", "varOverlays", "varOverlaysLegendColumns"],
                                        D: "Colored boxes to help in the visualization of samples and variables",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"]
                                    },
                                    "X-Axis": {
                                        P: ["setMaxX", "setMinX", "xAxis", "xAxisAbsMax", "xAxisAbsMin", "xAxisCeilValue", "xAxisCurrent", "xAxisExact", "xAxisFloorValue", "xAxisHistogramHeight", "xAxisHistogramShow", "xAxisLeftMajorTick", "xAxisLeftRightTickColor", "xAxisMajorTicks", "xAxisMaxStrLength", "xAxisMinorTicks", "xAxisMinorValues", "xAxisRightMajorTick", "xAxisRugHeight", "xAxisRugPosition", "xAxisRugShow", "xAxisS2Show", "xAxisShow", "xAxisTickColor", "xAxisTickFormat", "xAxisTickStyle", "xAxisTicks", "xAxisTitle", "xAxisTitleDynamic", "xAxisTransform", "xAxisTransformTicks", "xAxisValues", "xAxisValuesRaw"],
                                        D: "X axis parameters",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "BarLine", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    Debug: {
                                        D: "Debugging parameters",
                                        P: ["codeType", "debug", "errors", "offline", "showCode", "showVersion", "verbose"],
                                        U: ["AllGraphs"]
                                    },
                                    Clustering: {
                                        P: ["clusterAxis", "distance", "imputeMethod", "kmeansSmpClusters", "kmeansVarClusters", "linkage", "maxIterations", "samplesClustered", "samplesKmeaned", "variablesClustered", "variablesKmeaned"],
                                        D: "Parameters used in clustering",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"]
                                    },
                                    "Data Table": {
                                        D: "Parameters associated with the data table",
                                        P: ["backgroundDataTable", "colWidth", "colorDataTable", "colorDataTableTransparency", "dataTableColumnWidth", "dataTableFontFamily", "dataTableFontSize", "dataTableStyle", "dataTableTransposed", "maxCols", "maxRows", "networkShowDataTable", "refresehDataTableOnDraw", "rowHeight", "showDataTable", "showDataTableOnSelect", "startCol", "startRow", "totalCols", "totalRows"],
                                        U: ["AllGraphs"]
                                    },
                                    "Data Table/Filter": {
                                        U: ["Network", "Genome"],
                                        P: ["edgesProperties", "featuresProperties", "nodesProperties", "skipConfigurableProperties"],
                                        D: "Parameters associated with data table and data filter"
                                    },
                                    "Zooming, Panning and Resizing": {
                                        P: ["panningGlobalX", "panningGlobalY", "panningStep", "panningX", "panningY", "resizerBackgroundColor", "zoom", "zoomGlobal", "zoomSamplesDisable", "zoomScale", "zoomStep", "zoomVariablesDisable"],
                                        D: "Parameters associated with zooming, panning and resizing events",
                                        U: ["AllGraphs"]
                                    },
                                    General: {
                                        P: ["cacheBase64", "canvasBox", "canvasBoxColor", "createFactory", "createVersion", "editable", "fullTextMeasureCheck", "functions", "graphOrientation", "graphType", "highlightGreyOut", "highlightGreyOutTransparency", "invertGraph", "isR", "isReproducibleResearch", "metaData", "plotBox", "plotBoxColor", "printMagnification", "printThumbnail", "printType", "reproduceTime", "saveFilename", "showFunctionNamesAfterRender", "skipRender", "tags", "theme", "transparency", "transparencyHidden", "useRawLines", "view"],
                                        D: "General properties used in most visualizations",
                                        U: ["AllGraphs"]
                                    },
                                    Hierarchy: {
                                        U: ["Circular", "Tree", "Bubble"],
                                        P: ["hierarchy", "hierarchyVar", "hierarchyVarIndex"],
                                        D: "General parameters to build hierarchy for circular (sunburst) trees and bubbles graphs"
                                    },
                                    Loess: {
                                        U: ["AllGraphs"],
                                        D: "Parameters used to create smooth lines in 2d scatter plots",
                                        P: ["loessAccuracy", "loessBandwidth", "loessDegree", "loessIteration", "loessSpan", "loessSteps", "loessSurfaceSteps", "showLoessFit"]
                                    },
                                    "Missing Data": {
                                        U: ["OneTwoThreeeDGraphs"],
                                        P: ["missingDataColor", "missingDataValue"],
                                        D: "Missing data related parameters"
                                    },
                                    Decorations: {
                                        P: ["decorationFontSize", "decorationFontStyle", "decorationScaleFontFactor", "decorations", "decorationsBackgroundColor", "decorationsBox", "decorationsBoxColor", "decorationsColor", "decorationsColors", "decorationsHeight", "decorationsPosition", "decorationsProperties", "decorationsType", "decorationsWidth", "showDecorations", "showDecorationsLegend"],
                                        D: "Additional elements added to graphs to increase data understanding",
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D", "Network"]
                                    },
                                    "Error Bars and Confidence Intervals": {
                                        P: ["confidenceIntervalColor", "confidenceIntervalType", "confidenceLevel", "errorBarsColor", "errorBarsThickness", "errorBarsType", "errorBarsWidth", "fitLineColor", "fitLineStyle", "invertCensored", "kaplanMeierBy", "regressionOrder", "regressionType", "showConfidenceIntervals", "showErrorBars", "showRegressionFullRange", "standardDeviationType"],
                                        D: "Error bar and confidence intervals related parameters",
                                        U: ["OneTwoThreeeDGraphs"]
                                    },
                                    Fonts: {
                                        U: ["AllGraphs"],
                                        P: ["axisTickFont", "axisTitleFont", "citationFont", "decorationFont", "featureNameFont", "font", "legendFont", "motionCurrentFont", "nodeFont", "overlayFont", "sequenceFont", "smpLabelFont", "smpTitleFont", "subtitleFont", "titleFont", "trackNameFont", "varLabelFont", "varTitleFont"],
                                        D: "Default fonts"
                                    },
                                    Contours: {
                                        U: ["AllGraphs"],
                                        D: "Parameters used to create contours in one and two dimensional plots",
                                        P: ["contourEndLevel", "contourLevelStep", "contourStartLevel", "contourType", "showContourLevel"]
                                    },
                                    Images: {
                                        U: ["AllGraphs"],
                                        D: "General parameters with images",
                                        P: ["imageMaxTries", "imageTimeOut", "imageTries"]
                                    },
                                    Trees: {
                                        U: ["Tree"],
                                        P: ["treeCircular", "treeInverted", "treeLinkColor", "treeLinkWidth", "treeNodeId", "treeNodeOutlineColor", "treeNodeSize", "treeVarIndex"],
                                        D: "General parameters in trees"
                                    },
                                    Data: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        P: ["appendNetworkData", "asSampleFactors", "asVariableFactors", "groupingFactors", "histogramData", "isBoxplotCalc", "isGroupedData", "isTransformedData", "ratioGroupReference", "ratioLevelReference", "ratioReference", "ratioSampleReference", "segregateSamplesBy", "segregateVariablesBy", "stringSampleFactors", "stringVariableFactors", "summaryType", "transformAxis", "transformBase", "transformData", "transposeData"],
                                        D: "Data related parameters"
                                    },
                                    Maps: {
                                        U: ["Map"],
                                        P: ["hiddenMapFeatures", "mapCentralMeridian", "mapColor", "mapConfig", "mapConfigFeatures", "mapGraticuleShow", "mapGraticuleType", "mapId", "mapLatideOrigin", "mapOutlineColor", "mapProjection", "mapSmps", "mapStandardParallel1", "mapStandardParallel2", "topoJSON", "visibleMapFeatures"],
                                        D: "Map properties used in all visualizations"
                                    },
                                    "Network Node and Edge Attributes": {
                                        D: "General parameters used for nodes and edges in networks",
                                        P: ["colorEdgeBy", "colorNodeBy", "patternNodeBy", "shapeNodeBy", "sizeEdgeBy", "sizeNodeBy"],
                                        U: ["Network"]
                                    },
                                    Axis: {
                                        D: "General axis parameters",
                                        P: ["axisAlgorithm", "axisCoordinate", "axisExtension", "axisMinMaxTickThickness", "axisTickColor", "axisTickFontSize", "axisTickFontStyle", "axisTickScaleFontFactor", "axisTickThickness", "axisTitleColor", "axisTitleFontSize", "axisTitleFontStyle", "axisTitleScaleFontFactor", "axisWilkinsonLoose", "setMax", "setMin"],
                                        U: ["OneTwoThreeeDGraphs"]
                                    },
                                    "Ridgeline Plots": {
                                        U: ["OneTwoThreeeDGraphs"],
                                        D: "Parameters used to create ridgeline plots in 1d and 2d scatter plots",
                                        P: ["ridgelineScale"]
                                    },
                                    "Aspect Ratio, Space and width": {
                                        U: ["AllGraphs"],
                                        D: "Properties used to adjust the aspect ratio, space and width in most visualizations",
                                        P: ["adjustAspectRatio", "adjustAspectRatioMax", "adjustAspectRatioXTries", "adjustAspectRatioYTries", "dataPointSize", "dataPointSizeScaleFactor", "fixedAspectRatio", "percentAspectRatioPlotArea", "sampleSpaceFactor", "variableSpaceFactor", "widthFactor"]
                                    },
                                    "General Attributes": {
                                        U: ["AllGraphs"],
                                        D: "Properties related to Shapes, Sizes, Images and Patterns",
                                        P: ["images", "linePatterns", "patterns", "shapes", "sizes"]
                                    },
                                    DOE: {
                                        D: "Parameters used to create pie and histograms in general data",
                                        P: ["autoexpandDOE", "includeDOE", "maxDOENumber"],
                                        U: ["AllGraphs"]
                                    },
                                    Variables: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        D: "Properties associated with variables",
                                        P: ["highlightVar", "maxVarStringLen", "showVariableNames", "varHighlightColor", "varLabelFontColor", "varLabelFontSize", "varLabelFontStyle", "varLabelInterval", "varLabelRotate", "varLabelScaleFontFactor", "varTitle", "varTitleFontColor", "varTitleFontSize", "varTitleFontStyle", "varTitleScaleFontFactor"]
                                    },
                                    "Boxplot Graphs": {
                                        P: ["boxplotCoef", "boxplotColor", "boxplotConnect", "boxplotConnectWidth", "boxplotDataPointTransparency", "boxplotHingeFunction", "boxplotMean", "boxplotMeanColor", "boxplotMeanColorBorder", "boxplotMedianColor", "boxplotMedianWidth", "boxplotNotched", "boxplotOutliersRatio", "boxplotTransparency", "boxplotType", "boxplotWhiskersType", "boxplotWidthRatioIfViolin", "showBoxplotIfViolin", "showBoxplotOriginalData", "showViolinBoxplot", "violinBorderColor", "violinColor", "violinScale", "violinTransparency", "violinTrim"],
                                        D: "General parameters in Boxplot Graphs",
                                        U: ["Boxplot"]
                                    },
                                    Margins: {
                                        P: ["margin", "marginBottom", "marginLeft", "marginRight", "marginTop"],
                                        D: "Margin properties used in most visualizations",
                                        U: ["AllGraphs"]
                                    },
                                    "Data sorting": {
                                        P: ["sortCaseSensitive", "sortData", "sortDir"],
                                        D: "Data sorting related parameters",
                                        U: ["OneTwoThreeeDGraphs"]
                                    },
                                    "Plot area": {
                                        P: ["binAlignment", "binned", "blockContrast", "dotplotOutlineThreshold", "guides", "guidesColor", "guidesWidth", "is3DPlot", "jitter", "jitterColumns", "objectBorderColor", "objectColorTransparency", "plotByVariable", "showDataValues"],
                                        D: "General parameters for the plotting area in one dimensional plots",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correlation", "Pie", "Barline", "StackedLine", "StackedPercentLine"]
                                    },
                                    "Sankey Diagrams": {
                                        P: ["sankeyColor", "sankeyCoordinateColor", "sankeyIterations", "sankeyNodeWidth", "sankeySource", "sankeyTarget"],
                                        D: "General parameters in sankey diagrams",
                                        U: ["Sankey"]
                                    },
                                    "Treemap Graphs": {
                                        U: ["Treemap"],
                                        D: "General parameters for treemaps",
                                        P: ["treemapBorderColor", "treemapBorderWidth"]
                                    },
                                    Samples: {
                                        P: ["highlightSmp", "maxSmpStringLen", "showSampleNames", "smpHighlightColor", "smpLabelFontColor", "smpLabelFontSize", "smpLabelFontStyle", "smpLabelImage", "smpLabelImageRound", "smpLabelInterval", "smpLabelRotate", "smpLabelScaleFontFactor", "smpTitle", "smpTitleFontColor", "smpTitleFontSize", "smpTitleFontStyle", "smpTitleScaleFontFactor"],
                                        D: "Properties associated with samples",
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D"]
                                    },
                                    "Bar Graphs": {
                                        U: ["Bar", "BarLine"],
                                        P: ["barLollipopFactor", "barLollipopOpen", "barPath", "barPathColor", "barPathTransparency", "barType", "swimEnd", "swimHigh", "swimHighCap", "swimStart", "swimStatus"],
                                        D: "General parameters in bar graphs"
                                    },
                                    "Venn Diagrams": {
                                        P: ["vennColors", "vennCompartments", "vennGroups", "vennLegendColors"],
                                        D: "General parameters in Venn diagrams",
                                        U: ["Venn"]
                                    },
                                    "Scatter Plots": {
                                        U: ["Scatter2D", "ScatterBubble2D", "Scatter3D"],
                                        D: "General parameters in scatter plots",
                                        P: ["chromosomeLengths", "manhattanColors", "manhattanContrastColor", "manhattanMarkerChromosomeNumber", "manhattanMarkerLogPValue", "manhattanMarkerPosition", "scatterAxesEqual", "scatterOutlineThreshold", "scatterType", "visiumFixedAspectRatio", "visiumFlip", "visiumPanning"]
                                    },
                                    Shadows: {
                                        P: ["shadowBlur", "shadowColor", "shadowOffsetX", "shadowOffsetY", "showShadow", "showTextShadow"],
                                        D: "Shadow properties used in most visualizations",
                                        U: ["AllGraphs"]
                                    },
                                    Bins: {
                                        D: "Function to bin samples and variables",
                                        P: ["binConfigurations"],
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine"]
                                    },
                                    "Animations and Visualization Transitions": {
                                        P: ["showAnimation", "showTransition", "transitionFunction", "transitionStaggering", "transitionStep"],
                                        D: "Animation and visualization transition parameters",
                                        U: ["AllGraphs"]
                                    },
                                    "Correlation Graphs": {
                                        U: ["Correlation"],
                                        P: ["correlationAnchorLegend", "correlationAnchorLegendAlignWidth", "correlationAxis", "correlationLabelInterval", "correlationType"],
                                        D: "General parameters for correlation"
                                    },
                                    Histograms: {
                                        P: ["hideHistogram", "histogramBarWidth", "histogramBinWidth", "histogramBins", "histogramDensityFillTransparency", "histogramMedianLineStyle", "histogramSizeEstimator", "histogramStat", "histogramType", "isCreateHistogram", "isHistogram", "showFilledHistogramDensity", "showHistogramDataPoints", "showHistogramDensity", "showHistogramMedian", "showHistogramQuantiles"],
                                        D: "Parameters used to create histograms in 2d scatter plots",
                                        U: ["AllGraphs"]
                                    },
                                    "Oncoprint Graphs": {
                                        U: ["Heatmap"],
                                        D: "General parameters for oncoprints",
                                        P: ["isOncoprint", "oncoprintCNA", "oncoprintColSummary", "oncoprintHeatmapPosition", "oncoprintHeatmapSwitch", "oncoprintMUT", "oncoprintNoAlterations", "oncoprintRowSummary", "showHeatmapOncoprint"]
                                    },
                                    "Genome Browser": {
                                        P: ["featureConfigurableProperties", "featureCoordinateHeight", "featureCoordinateShow", "featureDirColor", "featureFillColor", "featureHeightDefault", "featureNameFontColor", "featureNameFontSize", "featureNameFontStyle", "featureQualityHeight", "featureQualityShow", "featureQualityValues", "featureSignalToNoiseHeight", "featureSignalToNoiseShow", "featureSignalToNoiseValues", "featureSpliceStyle", "featureStaggered", "featureTraceHeight", "featureTraceTrim", "featureTracesShow", "featureTranslateHeight", "featureTranslateShow", "featureTypeDefault", "featureWidthDefault", "genomeResolution", "genomeTicks", "maxFeatureStringLen", "periodTicksLabels", "sequenceAColor", "sequenceBColor", "sequenceCColor", "sequenceDColor", "sequenceEColor", "sequenceEndColor", "sequenceFColor", "sequenceFill", "sequenceFontSize", "sequenceFontStyle", "sequenceGAPColor", "sequenceGColor", "sequenceHColor", "sequenceIColor", "sequenceKColor", "sequenceLColor", "sequenceMColor", "sequenceNColor", "sequencePColor", "sequenceQColor", "sequenceRColor", "sequenceSColor", "sequenceStartColor", "sequenceTColor", "sequenceUColor", "sequenceVColor", "sequenceWColor", "sequenceXColor", "sequenceYColor", "sequenceZColor", "showFeatureNameThereshold", "subtracksMaxDefault", "trackConfigurableProperties", "trackDirColor", "trackFillColor", "trackNameFontColor", "trackNameFontSize", "trackNameFontStyle", "wireColor"],
                                        D: "General parameters used in genome browser",
                                        U: ["Genome"]
                                    },
                                    "Data Filters": {
                                        U: ["AllGraphs"],
                                        P: ["dataFilterWidth", "filterDataBy", "filterEdgeBy", "filterFeatureBy", "filterMode", "filterNodeBy", "filterSkipNullKeys", "filterSkipNullValues", "filterSmpBy", "filterType", "filterVarBy", "filtersExposed"],
                                        D: "Parameters associated with filtering"
                                    },
                                    Text: {
                                        U: ["AllGraphs"],
                                        P: ["align", "autoScaleFont", "baseline", "fontName", "fontScaleFontFactor", "fontSize", "fontStyle", "fonts", "fontsExternal", "maxTextSize", "minTextSize", "scaleTextConstantAdd", "scaleTextConstantMult"],
                                        D: "Properties associated with text attributes"
                                    },
                                    Legends: {
                                        U: ["Bar", "Line", "Area", "AreaLine", "Dotplot", "DotLine", "Heatmap", "Tree", "Treemap", "TagCloud", "ParallelCoordinates", "Sankey", "Stacked", "StackedPercent", "Boxplot", "Correletion", "Pie", "Barline", "StackedLine", "StackedPercentLine", "Scatter2D", "ScatterBubble2D", "Scatter3D", "Network"],
                                        P: ["legend", "legendBackgroundColor", "legendBox", "legendBoxColor", "legendColor", "legendColumns", "legendFontSize", "legendFontStyle", "legendInside", "legendOrder", "legendPosition", "legendPositionAuto", "legendScaleFontFactor", "showLegend", "showLegendTitle"],
                                        D: "Legends for variables and samples"
                                    },
                                    "Data Explorer": {
                                        D: "Parameters associated with data explorer :",
                                        P: ["maxDataExplorerEntries"]
                                    },
                                    Effect: {
                                        U: ["AllGraphs"],
                                        D: "Effects for UI widgets",
                                        P: ["codeEffectIn", "codeEffectOut", "configuratorEffectIn", "configuratorEffectOut", "dataexplorerEffectIn", "dataexplorerEffectOut", "datafilterEffectIn", "datafilterEffectOut", "datatableEffectIn", "datatableEffectOut", "effect", "motionEffectIn", "motionEffectOut", "remoteEffectIn", "remoteEffectOut", "toolbarEffectIn", "toolbarEffectOut", "tooltipDivEffectIn", "tooltipDivEffectOut"]
                                    },
                                    "Density Plots": {
                                        U: ["OneTwoThreeeDGraphs"],
                                        D: "Parameters used to create density plots in 1d and 2d scatter plots",
                                        P: ["bandwidthCut", "bandwidthRule", "densityKernel", "densityPixels", "showScatterDensity"]
                                    },
                                    "Circular Graphs": {
                                        P: ["arcSegmentsRadius", "arcSegmentsSeparation", "bubbleColor", "chordColor", "chordThickness", "circularAnchorColor", "circularAnchorLength", "circularAnchors2Align", "circularAnchorsAlign", "circularArc", "circularCenterProportion", "circularConnectionsTransparency", "circularDataPosition", "circularLabelsAlign", "circularLetterSeparationFactor", "circularRotate", "circularScalesAlign", "circularType", "connections", "ideogram", "ideogramChromosome", "ideogramChromosomePosition", "overlayLevelOrientation", "rAxis", "rAxisZero", "ringGraphType", "ringGraphWeight", "ringSeparation", "ringsOrder", "showCircularConnections", "showIdeogram", "smpLabelOrientation"],
                                        D: "General parameters in circular graphs",
                                        U: ["Circular"]
                                    },
                                    "Meter Graphs": {
                                        U: ["Meter"],
                                        D: "General parameters in meter graphs",
                                        P: ["meterAxis", "meterBackgroundColor", "meterColors", "meterEnd", "meterIndex", "meterMax", "meterMin", "meterNeedleColor", "meterSegments", "meterStart", "meterThickness", "meterType"]
                                    }
                                }
                            };
                            if (typeof exports === 'object' && typeof module !== 'undefined') {
                                exports['init'] = CanvasXpress;
                            }